////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmAK2.cpp {X AJlQ
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/03/2005
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMAK2_CPP__

#include "EnmAK2.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Wat\WK7Event.h"
#include "..\Wat\WK7Stage.h"
#include "..\Wat\WK7Player.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Stage\03\01\K7Stage361M00.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Matsu\mK7Noise.h"
#include "..\Yam\YK7EffectMuzzle.h"
#include "..\Yam\YK7EffectShot.h"
#include "..\Yam\YK7EffectFlash.h"
#include "..\Yam\YK7EffectBlur.h"
#include "..\Yam\YK7EffectDamageBlood.h"
#include "..\Yam\YK7EffectElec.h"
#include "..\Yam\YK7EffectSkill.h"
#include "..\Yam\YK7EffectModelFire.h"
#include "..\Yam\YK7EffectGMark.h"
#include "..\Yam\YK7EffectGravity.h"
#include "..\Yam\YK7EffectExplode.h"
#include "..\Wat\K7GlobalFlag.h"
#include "..\Wat\WK7EventScript.h"

#ifdef YAMADADEBUG
//	#define DEBUG_KILLER1
//	#define DEBUG_EASY
//	#define DEBUG_VITAL
#endif

// ҂ԎZo
#ifdef DEBUG_KILLER1
		#define KILLER1			(true)
		#define EASYFLAG		(false)
#else
	#ifdef DEBUG_EASY
		#define KILLER1			(false)
		#define EASYFLAG		(true)
	#else
		#define KILLER1			(K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1))
		#define EASYFLAG		(K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE))
	#endif
#endif
#define GETWAITTIME(x)	( true == EASYFLAG && KILLER1 == false ? ((x) * AK2_EASYSHOTWAITRATE) : (x) )

// ǂ̒`
#define WALL_XMIN		(-109.515F)
#define WALL_YMIN		(21.983F)
#define WALL_ZMIN		(-1768.342F)

#define WALL_XMAX		(93.378F)
#define WALL_YMAX		(73.383F)
#define WALL_ZMAX		(-1578.342F)


static const Vec AK2_BasePos = {-3.021f, 	21.372f,	-1710.146f} ;	// {|WV
#define AK2_MIN_X		(-82.868F)
#define AK2_MAX_X		(67.584F)
#define AK2_MOV_LEN		(AK2_MAX_X - AK2_MIN_X)		// ړ͈͂̒
#define AK2_SPEED		(1.5F)						// 鑬
#define AK2_SPEED_T		(AK2_SPEED / AK2_MOV_LEN)
#define YUKA_Y			(AK2_BasePos.y)

#define AK2_DAMEFFECTTIME	(60)

// `
static const f32 AK2_Rot[] = { 0.0F,  (-PI / 2.0F), (PI / 2.0F) } ;
static const AK2_MOT AK2_DashShotMot[] = { AK2_MOT_RUN, AK2_MOT_SHOTDASH2, AK2_MOT_SHOTDASH } ;

#define AK2_INITPOS		((5.0F-AK2_MIN_X) / AK2_MOV_LEN)		// ʒu
#define AK2_ROTSPEED	(3.0F)									// ωx
#define AK2_ROTSPEED2	(12.0F)									// ωxQ

#define AK2_FIRSTWAIT		(60)	// ŏ̑҂
#define AK2_NORMALMAXWAIT	(40)	// ʏ펞̍ő҂
#define AK2_NORMALMINWAIT	(10)	// ʏ펞̍ŏ҂

#define AK2_MOVENUM			(4)		// s̐

#define AK2_SHOTRATE			(0.8F)	// U[Vɓm
#define AK2_SHOTMAXWAIT			(30)	// ˌ\̍ő҂
#define AK2_SHOTMINWAIT			(10)	// ˌ\̍ŏ҂
#define AK2_KAMAEMOTIONSPEED	(2.0F)	// \E\̃[Ṽ[VXs[h

#define AK2_RELOAD_NUM		(3)		// [h܂ł̎ˌ

#define MDL361M00SHATTIME		(30)		//Vb^[J肷鎞
#define MDL361M00SHAT_MIN_X		(-82.868F)	//Ĉԍ̃Vb^[̂wW
#define MDL361M00SHAT_MAX_X		(67.584F)	//ĈԉẼVb^[̂wW

#define AK2_KAKURANRATE			(0.5F)		// Ă闦
#define AK2_KAKURAN_WAIT		(60)		// ɑԊu
#define AK2_KAKURAN_TIME1		(10)		// łVb^[̍1
#define AK2_KAKURAN_TIME2		(30)		// łVb^[̍2
#define AK2_KAKURAN2_WAIT		(3)			// łVb^[̊Ԋu

#define AK2_OPENWAIT			(30)		// JĂ҂
#define AK2_STARTWAIT			(60)		// ŏ̑҂

#define AK2_SHOTDIRBIASRAND		(0.05F)		// ]̃̕oCAXl(S_)

#define AK2_DMGAREA				(28.0F)		// _[W󂯂锼a
#define AK2_DMGTIME_SMALL		(10)		// _[W[V̎
#define AK2_DMGTIME_BIG			(60)		// _[W[V̎
#define AK2_DMGRESETWAIT		(60)		// _[W~ςZbg鎞
#define AK2_DMGTAENUM			(2)			// _[Wɑς
#define AK2_DMGTAENUMVSCON		(6)			// R̍Uɑς
#define AK2_DMGSTATFRAME		(20.0F)		// \Ɏ󂯂_[W̃X^[gt[
#define AK2_NORMALDAMAGERATE	(0.6F)		// m[}̃_[W[g

#define AK2_PLAYDMGWAIT			(6)							// vC[_[W󂯂܂ł̑҂
#define AK2_PLAYDMGWAIT2		(30)						// vC[_[WLZɎ󂯂܂ł̑҂
#define AK2_PLAYDMG				(1)							// ꔭ̃vC[󂯂_[Wl
#define AK2_PLAYDMG2			(1)							// ꔭ̃vC[󂯂_[Wl(`Ԏ)
#define AK2_PLAYDMG3			(1)							// ꔭ̃vC[󂯂_[Wl(Ō)
#define AK2_PLAYDMGCOLOR		(GXColor){ 255,0,0,128 }	// vC[_[W󂯂Ƃ̃tbV̐F
#define AK2_PLAYDMGWIDTH		(8.0F)						// vC[_[W󂯂锼a
#define AK2_PLAYDMGCHECKDIV		(8)

#define AK2_SHOTCOLOR			(CMK(255,255,255,255))		// P`Ԏ̃Vbg̐F
#define AK2_SHOTSIZE			(0.157F)					// P`Ԏ̃Vbg̑傫
#define AK2_SHOTSPEED			(10.9F)						// P`Ԏ̃Vbg̑

#define AK2_SHOTWAIT1			(120)						// P`Ԏ̃VbgłԊu
#define AK2_SHOTWAIT2			(70)						// Q`Ԏ̃VbgłԊu
#define AK2_SHOTWAIT3			(50)						// R`Ԏ̃VbgłԊu

#define AK2_MUZZLEWAIT			(3)							// }YtbV̊Ԋu

#define AK2_SHOTCOLOR2			(CMK(8,10,255,255))			// `Ԏ̃Vbg̐F
#define AK2_SHOTSIZE2			(0.600F)					// `Ԏ̃Vbg̑傫
#define AK2_SHOTSPEED2			(25.9F)						// `Ԏ̃Vbg̑

#define AK2_SHOTCOLOR3			(CMK(8,100,255,255))		// Ō̃Vbg̐F
#define AK2_SHOTSIZE3			(1.000F)					// Ō̃Vbg̑傫

#define AK2_IKARIHP				(AK2_VITAL * 0.5F)			// {胂[hɓgo
#define AK2_BLURNAME			"Blur"						// u[P[^̖O

#define AK2_DASHSHOTWAIT		(30)						// _bVVbg̊Jn҂
#define AK2_DASHSHOTDIRBIAS		(0.0F)						// c̃̕oCAXl
#define AK2_DASHSPEED			(1.2F)						// _bVx

#define AK2_SHOTWAIT_EASY		(15)						// Vbg̍Œ҂
#define AK2_SHOTWAIT_NORMAL		(0)							// Vbg̍Œ҂
#define AK2_SHOTWAIT_MIN		(EASYFLAG == true ? AK2_SHOTWAIT_EASY : AK2_SHOTWAIT_NORMAL )	// Vbg̍Œ҂

#define AK2_BLURSHOTWAIT1		(30)						// u[Vbg̊Jn҂ԂP
#define AK2_BLURSHOTWAIT2		(30)						// u[Vbg̊Jn҂ԂQ
#define AK2_BLURSHOTWAIT2VSCON	(15)						// u[Vbg̊Jn҂ԂQ
#define AK2_BLURSHOTTIME		(30)						// u[Vbg̃Vbg
#define AK2_BLURSHOTTIMEVSCON	(30)						// u[Vbg̃Vbg
#define AK2_BLURSHOTENDWAIT		(60)						// u[Vbg̃Vbg҂
#define AK2_BLURSHOTENDWAITVSCON	(15)					// u[Vbg̃Vbg҂
#define AK2_BLURSHOTNUM			(3)							// u[Vbg̈̍U
#define AK2_BLURSPEED			(AK2_SPEED_T * 1.3F)

#define AK2_EASYSPEEDRATE		(0.7F)			// C[W[̃Xs[h̃[g
#define AK2_EASYSHOTWAITRATE	(1.3F)			// C[W[̎ˌJn܂ł̎ԃ[g

#define AK2_MAXSPEED			(2.0F)			// ő呬x{
#define AK2_MINSPEED			(1.0F)			// ŏx{

#define AK2_VSCONSPEED			(1.5F)			// 肪Rꍇ̑x
#define AK2_VSCONDAMAGE			(1.0F)			// 肪Rꍇ̃_[W[g
#define AK2_GRENADE_FIRE_DAMAGE	(1.0F)			// Ol[hẽ_[W[g

#define AK2_IKARINOMALRATE		(0.15F)			// {胂[hʏ̍sm

//#define AK2_VITAL				(3000)			// ̗
#ifdef DEBUG_VITAL
	#define	AK2_VITAL 			(10)
#else
	#define AK2_VITAL			( 3000 * ( KILLER1 == true ? HI_LV_ENEMYHP : ( EASYFLAG == true ? EASY_LV_ENEMYHP : NORMAL_LV_ENEMYHP ) ) )
#endif

#define AK2_DIESHOTWAIT			(30)			// Ō̍U̍\̑Ȏ҂
#define AK2_DIESHOTWAIT2		(EASYFLAG == true ? 30 : 15 )		// Ō̍ȖȎ҂
#define AK2_DIESHOTWAIT3		(90)			// Ō̍ŨVb^[J܂ł̎
#define AK2_DIESHOTTIME			(EASYFLAG == true ? 150 : 300)		// Ō̈񃊃[h܂ł̎
#define AK2_DIESHOTTAENUM		(6)				// Ō̃Vbgɑςl
//#define AK2_DIESHOTTAENUM		(3)				// Ō̃Vbgɑς
//#define AK2_DIESHOTTAENUMVSCON	(6)				// Ō̃Vbgɑς(Ro[W)
#define AK2_DIESHOTDAMAGE		(2)				// Ō̃VbgɃRȊÕLōUƂɗ^_[W
#define AK2_DIESHOTCONDAMAGE	(1)				// Ō̃VbgɃRōUƂɗ^_[W
#define AK2_DIEWAIT				(30)			// |ꂽ̑҂
#define AK2_DIEAHOT_ROTWAIT		(120)			// lɌԊu

#define AK2_ONAJIMAXNUM			(2)				// sAđIԍő

static const s16 AK2_ShotTime[] =
{
	-1,		// ChVbg
	60,		// _W
} ;

static const s32 AK2_ShotMotion[] =
{
	AK2_MOT_SHOTNOW,	// ChVbg		
	AK2_MOT_SHOTNOW2,	// _W
} ;

enum WK7NpcBossHngControlState{
	NPC_AK2_STATE_INIT = NPC_STATE_MAX,	// l
	NPC_AK2_STATE_WAIT,					// Ȓ҂
	NPC_AK2_STATE_MOVE,					// ړ
	NPC_AK2_STATE_SHOT,					// Vbg
	NPC_AK2_STATE_RELOAD,				// [h
	NPC_AK2_STATE_SHATENDWAIT,			// Vb^[~܂҂
	NPC_AK2_STATE_SHATKAKURAN,			// Vb^[
	NPC_AK2_STATE_DASHSHOT,				// ȂVbg
	NPC_AK2_STATE_BLURSHOT,				// u[Vbg
	NPC_AK2_STATE_STARTWAIT,			// ŏ̑҂
	NPC_AK2_STATE_DMAGE,				// _[W
	NPC_AK2_STATE_DIE,					// S
};


//int K7EnmAK2::mAK2BattleStart = 0;			// AJl{XJtO

void K7EnmAK2::Dummy( void )
{
}


K7EnmAK2::K7EnmAK2(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
 K7EnmBoss(enemyid, suffix, pAnchor, prio, K7AK2, MotionIDTableAK2)
{
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 0;								// goiQƂĂȂ̂łӁj
	mData.mWeakID		= NPCWEAKOBJID_HEAD;				// _
	mData.mVLossID		= -1;								// ʐѕA
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// XP[
	
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	
	WK7RenderObj::SetVfxFlag( false );						// {X͂ɂ傤ɂ؂
	mInitProcess		= 0;
	mpGun				= (WK7Model *) NULL;
	
	mBulletNow			= AK2_GUN_BULLET_MAX;
	mShotNum			= 0;
	
	K7EnmAK2::mAK2BattleStart = 0;
	
	mBattleCount		= WK7_SEC_TO_FRAME(30);
	mBatteleExit		= 0;
	mBattleProcess		= 0;
	
	mMoveProcess		= CALL_INIT;								// svZX̎w
	
	mStartPos.x			= 0.f;
	mStartPos.y			= 0.f;
	mStartPos.z			= 0.f;
	
	mEndPos.x			= 0.f;
	mEndPos.y			= 0.f;
	mEndPos.z			= 0.f;
	
	mRunPointPtr		= 0;
	
//	mMotID				= AK2_MOT_WAIT;
//	mState.Init( KIB_KRR_COMMON_ATK0 );

	mVisible 			= false ;
	mVisible3			= false ;
	mAK2BattleStart 	= false ;
	mod = con 			= 0 ;
	alphainitflag		= false ;
	
	PlayMotionID		= -1 ;
	
	TurnFlag			= false ;
	Pos					= AK2_INITPOS ;
	TargetPos 			= AK2_INITPOS ;
	IndexPos			= 2 ;
	VecPos				= AK2_BasePos ;
	TargetDir			= AK2_DIR_FRONT ;
	
	InitEndFlag			= false ;
	
	muz					= NULL ;
	muzid				= 0 ;
	
	blur				= NULL ;
	blurid				= 0 ;

	shot 				= NULL ;
	IkariMode			= false ;

	dmgmotionflag		= false ;
	dmgmotioncon		= 0.0F ;
	dmgmotionspeed		= 1.0F ;

	motioncon			= 0.0F ;

	DamageCon			= 0 ;
	DamageTime			= 0 ;
	
	pdamagetime			= 0 ;
	pdamagetime2		= 0 ;
	pdamagecon			= 0 ;

	shotflag			= false ;	
	movespeed			= AK2_SPEED_T ;
	
	Vital				= (short)AK2_VITAL ;
	DieFlag				= false ;
	nodamegeaction		= false ;
	
	GlobalModeState		= 0 ;
	
	efdam				= NULL ;
	efdamCounter		= 0 ;
	InitFlag			= false ;
}

K7EnmAK2::~K7EnmAK2()
{
	 WK7RenderObj::SetVfxFlag( true );
	 Release() ;
}

void K7EnmAK2::Release(void)
{
	if( InitFlag == false ) return ;

	gpSound->mReleaseSsm( "seBossAkn.ssm" );
	DetachGun();
	ReleaseModel    ();
	ReleaseMotionAll();
	DeleteMuzzle() ;
	alphaend() ;
	if( shot != NULL ) DeleteEffect( shot ) ;
	shot = NULL ;
	if( blur != NULL && CheckEffectValidState( blur, blurid ) == TRUE ) DeleteEffect( blur ) ;
	blur = NULL ;
	mBatteleExit = true ;
	
	if( efdam != NULL ) DeleteEffect( efdam ) ;
	efdam = NULL ;
	
	mState = NPC_STATE_LOSS ;
	
	InitFlag = false ;
}
void K7EnmAK2::DetachGun(void)
{
	if ( mpGun ){
		DetachGunModel((s8)GUN_R);
		mpGun = (WK7Model *)0;
	}
	ReleaseGunArchive(GUN_R);
}


bool K7EnmAK2::ControlProcess(void)
{
	Vec myPos;
//	f32 dam;
//	int weakhit;

	if ( mBatteleExit == true )		return true;
	if ( mpNpcChara==NULL )			return true;
	
	if( GetEffectValidState( shot ) == TRUE )
	{
		SetEffectMoveFlag( shot, (s8)( GetNpcPause() == true && ( mState != NPC_AK2_STATE_DIE || ( mod != 8 && mod != 9 && mod != 701 && mod != 700 ) ) ? FALSE : TRUE ) ) ;
	}
	
	if ( GlobalModeState == 1000 && true == GetNpcPause() ) 	return true;											// |[YȎ
	if ( true == IsLoading() ) 		return true;											// ǂݍݒ
	
	if ( mState == NPC_STATE_INIT )	goto NPC_CTRL_INIT_JUMP;
	if ( mAK2BattleStart == false )	return true ;
	
	mpNpcChara->GetPosition(myPos);
	
	ShatFrameProcess() ;
	RotProc() ;
	alphaproc() ;
	RefreshPos() ;
	MotionProc() ;
	PlayDamageProc() ;
	ShotProc() ;

	// vC[̕Œ
	WK7PLAYERCONTROL->SetKamaeDir( PI );

	// _[WZbg
	if( DieFlag == false )
	{
		if( DamageCon != 0 )
		{
			DamageTime ++ ;
			if( DamageTime >= AK2_DMGRESETWAIT )
			{
				DamageCon = 0 ;
				DamageTime = 0 ;
			}
		}
	}

	// _[W炢`FbN
	if ((true == DamageTest())
	&&	(mState != NPC_STATE_DMG)								// AȂ
	){
		// _[WHǂ𒲂ׂ
		{
			Vec apos, dpos ;
			f32 len ;
			
			GetRootJointPos( &apos ) ;
			dpos = mDamage.mDamPos ;

			len = VECDistance( &apos, &dpos ) ;
			if( len >= AK2_DMGAREA ) goto DAMAGE_END ;
		}
		
		// _[WGtFNg𔭐
		{	
			if( efdam != NULL ) DeleteEffect( efdam ) ;
			efdam = NULL ;
			efdamCounter = 0 ;
			
			switch( mDamage.mDamType )
			{
			case DAMTYPE_GRENADE_FIRE :		// Ol[hij
			case DAMTYPE_BOMBER :			// Ԑڃ_[W
			case DAMTYPE_GRENADE_FINAL :
				CreateSmokeExplodeEffect( mDamage.mDamPos, 3.f, 0 ) ;
				efdam = CreateModelFireEffectEasy( GetModel()->GetObj("Root_joint"), MFIRE_HS, (Vec){0.0F,0.0F,0.0F} ) ;
				break ;
				
			case DAMTYPE_GRENADE_THUND :	// Ol[hidj
				CreateMskSparkBom( mDamage.mDamPos ) ;
				PlayEffectSE( SFX_BT_HIT_DENGEKI ) ;
				efdam = CreateElecHSEffect( EL_HS_DMG1, 
											GetModel()->GetObj("Root_joint"),  
											10.0F , 10.0F ) ;
				break ;
				
			case DAMTYPE_GRENADE_GRAVI :	// Ol[hid́j
				CreateGravityEffect( mDamage.mDamPos ) ;
				PlayEffectSE( SFX_BT_HIT_SHUSOKU ) ;
				efdam =	CreateGMarkEffect( GetModel()->GetObj("Root_joint"),
									VParam[ED_GMARK][11] * 10,		// ő吔

									VParam[ED_GMARK][0] * 0.01F, VParam[ED_GMARK][1] * 0.01F, 	// őTCYŏTCY
									VParam[ED_GMARK][2] * 0.01F, VParam[ED_GMARK][3] * 0.01F, 	// őXs[hŏXs[h
									VParam[ED_GMARK][4] * 0.001F,	VParam[ED_GMARK][5] * 0.001F,	// őkxŏkx

									VParam[ED_GMARK][6] * 0.01F,	// ʐϕӂ̍쐬m

									CMK(VParam[ED_GMARK][7],VParam[ED_GMARK][8],VParam[ED_GMARK][9],VParam[ED_GMARK][10])						// F
									) ;
				break ;

			default :
				CreateDamageBloodEffect( DMGBLD_AK2_NORMAL, mDamage.mDamPos ) ;
				break ;
			}
		}
		
		// _[W␳
		{
			// e̎ 200_[W
			if( mDamage.mDamType == DAMTYPE_DANSPATK ) mDamage.mDamPoint = 200 ;

			// t@COl[he̓_[W[gႢ
			if( mDamage.mDamType == DAMTYPE_GRENADE_FIRE ) mDamage.mDamPoint *= AK2_GRENADE_FIRE_DAMAGE ;
			
			// Ȑꍇ̓_[W[gႢ
			if( WK7PLAYERCONTROL->GetMainID() == K7CON ) mDamage.mDamPoint = (s16)( mDamage.mDamPoint * AK2_VSCONDAMAGE ) ;
			
			// ՓxƂ̃_[Wl̕␳
	//		if( false == EASYFLAG ) mDamage.mDamPoint = (short)( mDamage.mDamPoint * AK2_NORMALDAMAGERATE ) ;
	
			// _[WO 1 ɂ
			if( mDamage.mDamPoint == 0 ) mDamage.mDamPoint = 1 ;
		}

#ifdef YAMADADEBUG
		OSReport( "Vital:%04d  Damage:%03d\n", Vital, mDamage.mDamPoint ) ;
#endif
	
		// _[WJE^i߂
		if( mState != NPC_AK2_STATE_DIE )
		{
			DamageCon ++ ;
		}
		else
		{
			DamageCon += WK7PLAYERCONTROL->GetMainID() == K7CON ? AK2_DIESHOTCONDAMAGE : AK2_DIESHOTDAMAGE ;
		}

		// _[WĐ		
		PlayEffectSE( SFX_BOSS_AKN_DAMAGE ) ;
		
		// u[폜
		deleteblur() ;
		
		// xʏɖ߂
		MoveSpeed() ;

		// _[W[Vo
		if( DieFlag == false )
		{
			PlayEffectSE( GetRandINum( 2 ) == 0 ? SFX_BOSS_AKN_DAMAGE2 : SFX_BOSS_AKN_DAMAGE1 ) ;

			if(	( mState == NPC_AK2_STATE_DASHSHOT && mod >= 7 ) ||
				( WK7PLAYERCONTROL->GetMainID() != K7CON && ( DamageCon >= AK2_DMGTAENUM || shotflag == true ) ) ||
				( WK7PLAYERCONTROL->GetMainID() == K7CON && DamageCon >= AK2_DMGTAENUMVSCON  ) )
			{
				if( GlobalModeState == 0 ) GlobalModeState = 100 ;		// ܂Vb^[܂ĂȂ߂

				// 񐔘AōU邩Vbg̏ꍇ̓_[WԂɈڍs
				PlayDamageMotion( AK2_DMGTIME_BIG ) ;
				Damage() ;
				ShotEnd() ;
			}
			else
			{
//				PlayEffectSE( SFX_BOSS_AKN_DAMAGE1 ) ;

				PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
			}

			// ̗͏
			Vital -= mDamage.mDamPoint ;
			
			// ̗͂OɂȂ玀S[h
			if( Vital < 0 )
//			if( 1 )
			{
				ShotEnd() ;
				Die() ;
			}
			else
			// ̗͂ȉɂȂꍇ͓{胂[hֈڍs
			if( Vital < ( EASYFLAG == true ? AK2_IKARIHP / 2 : AK2_IKARIHP ) && IkariMode == false )
			{
				Ikari() ;
			}
		}
		else
		{
			PlayEffectSE( SFX_BOSS_AKN_DAMAGE1 ) ;
				
			if( nodamegeaction == false )
				PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
		}

		// }YtbV
		if( muz != NULL && CheckEffectValidState( muz, muzid ) == TRUE ) DeleteEffect( muz ) ;
		muz = NULL ;
		
/*		// HP DEC
		if (((mDamage.mNearHitID) == mData.mWeakID)
		&&	(-1 != mDamage.mNearHitID)
		&&	(mDamage.mDamWeakHitOk)
		){														// Hi[Vj
			dam = (f32 )(mDamage.mDamPoint);
			dam = dam * 1.5f;
			weakhit = 1;
		}else{
			dam = (f32 )(mDamage.mDamPoint);
			weakhit = 0;
		}
		
		// _[W~bg`FbN
		if ( dam > 30.f ){
			dam = 30.f;
		}
		mData.mHp -= (s16 )dam;
		
		
		if  ( mData.mHp <= 0 ){
			DieMotSet();
		}else{
			if ( weakhit ){
				AK2_Dmg();
				mState = NPC_STATE_DMG;
			}
		}
		
		// rd
//		gpSound->mPlaySE(damageSeTbl[rand()%SFX_BT_HS_AK2UGI_MAX]);
		
		// GtFNgiqbg}[Nj
		{
			WK7Model		*pModel;
			WK7JObj			*pJOBj;
			if ( (pModel = mpNpcChara->GetModel()) != NULL ){
				pJOBj = pModel->GetObj(K7CHRBONE_WAIST);
			}
			
			BloodEfcCall(&mDamage, myPos, pJOBj);
		}
		
		mDamage.mDamHitRequest = 0;
		
//		Cmd_ResetSet();
*/	}
	DAMAGE_END :
	
	if( efdam != NULL )
	{
		efdamCounter ++ ;
		if( efdamCounter >= AK2_DAMEFFECTTIME )
		{
			DelReqEffect( efdam ) ;
			efdam = NULL ;
			efdamCounter = 0 ;
		}
	}
	
	switch( mState ){
	case NPC_AK2_STATE_DMAGE :		// _[W
		switch( mod )
		{
		case 0 :	// SẴVb^[
			ShatAllClose() ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 1 :	// Vb^[҂
			if( CheckShatAllEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 2 :	// Kɑ
			Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
			break ;
		}
		break ;
	
	case NPC_STATE_INIT:
NPC_CTRL_INIT_JUMP:
		switch (mInitProcess){
		case 0:
			if ( true == StateInit() ){						// ̒mStateςꂿႤ̂
				mState = NPC_STATE_INIT;
				mInitProcess++;
			}
			break;
		case 1:
			// ẽ[hĩ^C~OŃR[)
			if ( -1 == LoadGunArchive((s8)GUN_R) ) break;
			
															// AJlpSEf[^̓ǂݍ
			bool hr = gpSound->mReadSsm( "seBossAkn.ssm", eBankBoss );
			
			// VbgGtFNg̍쐬
			shot = CreateShotEffect( AK2_SHOTCOLOR,
										AK2_SHOTSIZE,
										true,
										60,
										0.1F,
										100,
										CMK( 247,189,119,200),
										SFX_BOSS_AKN_TYOUDAN ) ;
			if( shot == NULL ) break ;
			SetShotEffectWall( shot, WALL_XMIN, WALL_XMAX,
										WALL_YMIN, WALL_YMAX,
										WALL_ZMIN, WALL_ZMAX ) ;
											 
			// _ݒij
			WeakPointEffectSet( K7CHRBONE_SKULL );
			
			mInitProcess++;
			break;
		case 2:
			if ( true == CheckGunArchiveLoad((s8)GUN_R) ) break;
			// nCf̏eɃA^b`
			mpGun = AttachGunModel(	(s8)GUN_R,
										NULL,												// NULL I[gŃA^b`
										mpNpcChara->GetModel(),
										GUN_HAND_R											// E肩肩
			);
			alphainit() ;
			
			mInitProcess++;
			break;
		case 3:
//			if( false == MotSet_Wait(false) ) break;

			// Ԃҋ@Ԃ
//			Wait() ;

			mInitProcess++;
			mState = NPC_STATE_WAIT;
			InitEndFlag = true ;
			InitFlag = true ;
			
			// f
//			SetVisible2( false ) ;
			SetVisible2( true ) ;
			RefreshPos() ;
			
			break;
		}
		break;

	case NPC_AK2_STATE_WAIT :		// ҋ@
		MoveProc() ;
		switch( mod )
		{
		case 0 :		// 莞ԑ҂
			con ++ ;
			if( con > WaitTime ){
				mod ++ ;	con = 0 ;
			}
			break ;
			
		case 1 :		// tFCgɂ邩ǂ߂
			con = 0 ;
			
			if( IkariMode == true && GetRandFNum( 1.0F ) > AK2_IKARINOMALRATE )
			{
				// {胂[hU
				switch( GetRandINum( 2, &IkariAtRand, AK2_ONAJIMAXNUM ) )
				{
				case 0 :	DashShot() ;	break ;		// _bVVbg
				case 1 :	BlurShot() ;	break ;		// u[Vbg
				}
			}
			else
			{
				// ʏU
				
				switch( GetRandINum( 2, &WaitRand, AK2_ONAJIMAXNUM ) )
				{
				case 0 :
					mod = 2 ;
#ifdef YAMADADEBUG
					OSReport( "mod=0\n" ) ;
#endif
					break ;		// ʂɊJ
						
				case 1 :
					mod = 4 ;
#ifdef YAMADADEBUG
					OSReport( "mod=1\n" ) ;
#endif
					break ;		// Jɏo
						
				case 2 :
					mod = 8 ;
#ifdef YAMADADEBUG
					OSReport( "mod=2\n" ) ;
#endif
					break ;		// J
				}
			}
			break ;
			
		case 2 :	// ʂɊJ
			{
				s32 i ;
			
				// AJl̓ꏊJ
				ShatOpen( IndexPos ) ;
			
				// KɊJ
				for( i = 0 ; i < STG361_SHATNUM ; i ++ )
					if( GetRandFNum( 1.0F ) < 0.5F ) ShatOpen( i ) ;
					
				mod ++ ;	con = 0 ;
			}
			break ;
			
		case 3 :	// J҂
			if( CheckShatAllEnd() == false ) break ;
			mod = 14 ;	con = 0 ;
			break ;
			
			


		case 4 :	// Jɏo
			{
				s32 i ;
			
				// AJl̂ꏊׂ̗J
				if( GetRandINum( 2 ) == 1 )
				{
					OpenPos = IndexPos - 1 ;
					if( OpenPos == -1 ) OpenPos = IndexPos + 1 ; 
				}
				else
				{
					OpenPos = IndexPos + 1 ;
					if( OpenPos == STG361_SHATNUM ) OpenPos = IndexPos - 1 ;
				}
				ShatOpen( OpenPos ) ;
				
				// ȊO̕KɊJ
				for( i = 0 ; i < STG361_SHATNUM ; i ++ )
					if( GetRandFNum( 1.0F ) < 0.5F && i != OpenPos && i != IndexPos )
					{
						ShatOpen( i ) ;
						break ;
					}
						
				mod ++ ;
				con = 0 ;
			}
			break ;
			
		case 5 :	// J҂
			if( CheckShatAllEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 6 :	// Jɏo
			if( OpenPos != IndexPos ) PlayEffectSE( SFX_BOSS_AKN_DUSHSFX ) ;
			Move( GetTPos( IndexPos = OpenPos ), false ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 7 :	// ړI҂
			if( GetMoveEnd() == false ) break ;
			mod = 14 ;	con = 0 ;
			break ;
			
			
			
			
		case 8 :	// J
			{
				int j ;
			
				// AJlȂꏊKɊJ
				j = 0 ;
				for( s32 i = 0 ; j < 2 && i < STG361_SHATNUM ; i ++ )
					if( GetRandFNum( 1.0F ) < 0.5F && i != IndexPos )
					{
						ShatOpen( i ) ;
						j ++ ;
					}
				
				mod ++ ;	con = 0 ;
			}
			break ;
			
		case 9 :	// J҂
			if( CheckShatAllEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 10 :	// ԑ҂
			con ++ ;
			if( con >= AK2_OPENWAIT ){
				con = 0 ; mod ++ ;
			}
			break ;
			
		case 11 :	// 
			ShatAllClose() ;
			con = 0 ; mod ++ ;
			break ;
			
		case 12 :	// ҂
			if( CheckShatAllEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;

		case 13 :	// ̊mł
			// ̊mł		
			if( GetRandFNum( 1.0F ) < AK2_KAKURANRATE )
			{
				Kakuran() ;
			}
			else
			{
				// KȏꏊɈړ
				Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
			}
			break ;
			
			
			


		case 14 :	// ҂
			WaitTime = (s32)( GetRandI2Num( AK2_NORMALMAXWAIT, AK2_NORMALMINWAIT ) * GetWaitRate() ) ; 
			
			// ʂ
			Wait( -1, false ) ;
			
			mod = 101 ;		con = 0 ;
			break ;
			
		case 101 :	// ҂
			con ++ ;
			if( con >= WaitTime ){
				mod ++ ;	con = 0 ;
			}
			break ;
			
		case 102 :	// U[Vɓ邩ǂ
			// ̊mōU[Vɓ
			if( GetRandFNum( 1.0F ) < AK2_SHOTRATE )
			{
				Shot() ;	// U
			}
			else
			{
				mod = 100 ;	con = 0 ;
			}
			break ;



			
		case 100 :		// ҂( Vbg̍s )
			con ++ ;
			if( con > 15 ){
				mod = 15 ;	con = 0 ;
			}
			break ;
			
		case 15 :	// S邩ĂƂɉB
			con = 0 ;
			if( GetRandFNum( 1.0F ) < 0.5F )
			{
				// Sĕ
				ShatAllClose() ;
				
				mod = 18 ;
			}
			else
			{
				mod ++ ;
			}
			break ;
			
		case 16 :	// ĂȂꏊɈړ
			{
				s32 i, num, ind[STG361_SHATNUM] ;
	
				// Sĕ	
				ShatAllClose() ;
			
				con = 0 ;
				num = 0 ;
				for( i = 0 ; i < STG361_SHATNUM ; i ++ )
					if( shat[i].closeflag == true )
					{
						ind[num] = i ;
						num ++ ;
					}
					
				// ȂS߂
				if( num == 0 )
				{
					mod = 18 ;
				}
				else
				{
					s32 i ;
					
					i = ind[GetRandINum( num )] ;
					if( i != IndexPos ) PlayEffectSE( SFX_BOSS_AKN_DUSHSFX ) ;
					Move( GetTPos( IndexPos = i ), false ) ;
					mod ++ ;
				}
			}
			break ;
			
		case 17 :	// ړI҂
			if( GetMoveEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
			
			
			
		case 18 :	// S߂̂҂
			mod ++ ;	con = 0 ;
			break ;
			
		case 19 :	// ߂܂̂҂
			if( CheckShatAllEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 20 :	// KɈړ
			// ̊mł		
			if( GetRandFNum( 1.0F ) < AK2_KAKURANRATE )
			{
				Kakuran() ;
			}
			else
			{
				// KȏꏊɈړ
				Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
			}
			break ;
//			Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
//			break ;
		}
		break ;

/*
			con ++ ;
			if( con >= WaitTime )
			{
				// ̊mōU[Vɓ
				if( GetRandFNum( 1.0F ) < AK2_SHOTRATE )
				{
					// U
					Shot() ;
				}
				else
				{
					// 
					Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
					
	//				ShatAllClose() ;
	//				ShatOpen( IndexPos ) ;
				}
			}
*/
	case NPC_AK2_STATE_DASHSHOT :	// ȂVbg
		MoveProc() ;
		switch( mod )
		{
		case 0 :	// Vb^[SĊJ
			ShatAllOpen() ;
			mod ++ ;	con = 0 ;
			break ;

		case 1 :	// [܂ňړ
			{
				s32 i ;
				
				i = ( ( GetRandINum( 2 ) == 1 ? 0 : 3 ) ) ;
				if( i != IndexPos ) PlayEffectSE( SFX_BOSS_AKN_DUSHSFX ) ;
				Move( GetTPos( IndexPos = i ), false ) ;
				mod ++ ;	con = 0 ;
			}
			break ;
			
		case 2 :	// ړI҂
			if( GetMoveEnd() == false ) break ;
			Wait( -1, false ) ;		// ʂ
			mod ++ ;	con = 0 ;
			break ;
			
		case 3 :	// \
			PlayMotion( AK2_MOT_SHOTPOSE, false, true, AK2_KAMAEMOTIONSPEED ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 4 :	// \I҂
			if( GetMotionEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 5 :	// \[v
			PlayMotion( AK2_MOT_SHOTFREE, true, true, 1.0F ) ;
			mod ++ ;	con = 0 ;
			break ;

		case 6 :	// \҂
			con ++ ;
			if( con < GETWAITTIME(AK2_DASHSHOTWAIT) ) break ;

			con = 0 ;	mod ++ ;
			break ;
			
		case 7 :	// ˌ_bVJn
			Move( GetTPos( IndexPos = ( IndexPos == 3 ? 0 : 3 ) ), false, true ) ;
			ShotStart( AK2_DASHSHOTDIRBIAS ) ;	// ˌJn
			PlayEffectSE( SFX_BOSS_AKN_DUSHSFX ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 8 :	// I܂Ŏˌ
			if( GetMoveEnd() == false ) break ;
			
			// ǂɒ甽]
			if( con == 0 )
			{
				con ++ ;
				Move( GetTPos( IndexPos = ( IndexPos == 3 ? 0 : 3 ) ), false, true ) ;
				PlayEffectSE( SFX_BOSS_AKN_DUSHSFX ) ;
			}
			else
			{
				// Qڂ̏ꍇ͎
				ShotEnd() ;		// ˌI
				mod ++ ;	con = 0 ;
			}
			break ;
		
		case 9 :	// ]ăVb^[̒֏
			Move( GetTPos( IndexPos = ( IndexPos == 3 ? 0 : 3 ) ), false, true ) ;
			PlayEffectSE( SFX_BOSS_AKN_DUSHSFX ) ;
			ShatAllClose() ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 10 :	// Sɕ܂KȈʒuɈړ
			if( CheckShatAllEnd() == false ) break ;
			Move( GetTPos( IndexPos = GetRandINum( 4 ) ) ) ;
			break ;
		}
		break ;


		
	case NPC_AK2_STATE_BLURSHOT :	// u[Vbg
		MoveProc() ;
		switch( mod )
		{
		case 0 :		// KȂƂ󂯂
			{
/*				s32 i, j, k ;
				
				j = k = 0 ;
				for( i = 0 ; i < AK2_MOVENUM ; i ++ )
				{
					if( GetRandINum( 2 ) == 0 || k == 2 )
					{
						ShatOpen( i ) ;
						
						j ++ ;
						if( j == 2 ) break ;
						k = 0 ;
					}
					else
					{
						k ++ ;
					}
				}
*/
				// Kȏꏊ󂯂
				BlurOpen = GetRandINum( AK2_MOVENUM ) ;
				ShatOpen( BlurOpen ) ;
				
				// AJlĂ镔Ɉړ
				switch( BlurOpen )
				{
				case 0 : BlurClose = BlurOpen + 1 ; break ;
				case 1 : 
					switch( GetRandINum( 3 ) )
					{
						case 0 : BlurClose = 0 ; break ;
						case 1 : BlurClose = 2 ; break ;
						case 2 : BlurClose = 3 ; break ;
					}
					break ;
				case 2 :
					switch( GetRandINum( 3 ) )
					{
						case 0 : BlurClose = 0 ; break ;
						case 1 : BlurClose = 1 ; break ;
						case 2 : BlurClose = 3 ; break ;
					}
					break ;
				case 3 : BlurClose = BlurOpen - 1 ; break ;
				}
				Move( GetTPos( IndexPos = BlurClose ), false, false, true, true ) ;
				
				mod ++ ;	con = 0 ;
			}
			break ;

		case 1 :	// J܂ő҂
//			if( CheckShatAllEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 2 :	// AJlo
			Move( GetTPos( IndexPos = BlurOpen ), false ) ;
			PlayEffectSE( SFX_BOSS_AKN_DUSHSFX ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 3 :	// ړI҂
			if( GetMoveEnd() == false ) break ;
			PlayMotion( AK2_MOT_WAIT, true, true, 1.0F ) ;
			RotPlayer() ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 4 :	// ҂
			con ++ ;
			if( con < GETWAITTIME(AK2_BLURSHOTWAIT1 * GetWaitRate()) ) break ;
			mod ++ ;	con = 0 ;
			break ;

		case 5 :	// vC[̕
			RotPlayer() ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 6 :	// \
			PlayMotion( AK2_MOT_SHOTPOSE, false, true, AK2_KAMAEMOTIONSPEED ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 7 :	// \I҂
			if( GetMotionEnd() == false ) break ;
			PlayMotion( AK2_MOT_SHOTFREE, true, true, 1.0F ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 8 :	// ҂
			{
				s32 time ;
				
				time = ( WK7PLAYERCONTROL->GetMainID() == K7CON && BlurNum > 0 ) ? AK2_BLURSHOTWAIT2VSCON : AK2_BLURSHOTWAIT2 ;
				con ++ ;
				if( con < GETWAITTIME(time * GetWaitRate()) + AK2_SHOTWAIT_MIN ) break ;
				mod ++ ;	con = 0 ;
			}
			break ;

		case 9 :	// ˌ
			ShotStart() ;
			PlayMotion( AK2_MOT_SHOTNOW2, true, true, 1.0F ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 10 :	// ˌI҂
			con ++ ;
			if( con < ( WK7PLAYERCONTROL->GetMainID() == K7CON ? AK2_BLURSHOTTIMEVSCON : AK2_BLURSHOTTIME ) ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 11 :	// ˌI
			ShotEnd() ;
//			PlayMotion( AK2_MOT_SHOTPOSE, true, true, 1.0F ) ;
			PlayMotion( AK2_MOT_SHOTFREE, true, true, 1.0F ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 12 :	// ҂
			con ++ ;
			if( con < GETWAITTIME( ( WK7PLAYERCONTROL->GetMainID() == K7CON ? AK2_BLURSHOTENDWAITVSCON : AK2_BLURSHOTENDWAIT ) * GetWaitRate()) ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 13 :	// Vb^[̉A֏
			BlurNum ++ ;		// Ủ񐔂𑝂₷
			BlurClose = IndexPos ;
			switch( BlurOpen )
			{
			case 0 :
				IndexPos = 1 ;
				BlurOpen = GetRandINum( 2 ) + 2 ;
				break ;

			case 1 :
				IndexPos = BlurClose == 0 ? 2 : 0 ;
				BlurOpen = 3 ;
				break ;
				
			case 2 :
				IndexPos = BlurClose == 1 ? 3 : 1 ;
				BlurOpen = 0 ;
				break ;

			case 3 :
				IndexPos = 2 ;
				BlurOpen = GetRandINum( 2 ) ;
				break ;
			}
			MoveSpeed( AK2_BLURSPEED ) ;	// ړxύX
			Move( GetTPos( IndexPos ), false, false, false, false ) ;
			PlayEffectSE( SFX_BOSS_AKN_WARP ) ;
			ShatClose( BlurClose ) ;		// JĂƂ낪
			if( BlurNum != AK2_BLURSHOTNUM ) 
				ShatOpen( BlurOpen ) ;			// ̈ʒuJ
				
			mod ++ ;	con = 0 ;
			break ;
			
		case 14 :	// ړI҂
			createblur() ;
			if( GetMoveEnd() == false ) break ;
			deleteblur() ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 15 :	// 邩ǂ̔f
			if( BlurNum == AK2_BLURSHOTNUM )
			{
				MoveSpeed() ;	// ʏɖ߂
				
				// KɈړ
				Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
				break ;
			}
			mod ++ ;	con = 0 ;
			break ;
			
		case 16 :	// ̏ꏊɏo邽߂̈ʒuɈړ
			switch( BlurOpen )
			{
			case 0 : BlurClose = BlurOpen + 1 ; break ;
			case 1 : 
				switch( GetRandINum( 3 ) )
				{
					case 0 : BlurClose = 0 ; break ;
					case 1 : BlurClose = 2 ; break ;
					case 2 : BlurClose = 3 ; break ;
				}
				break ;
			case 2 :
				switch( GetRandINum( 3 ) )
				{
					case 0 : BlurClose = 0 ; break ;
					case 1 : BlurClose = 1 ; break ;
					case 2 : BlurClose = 3 ; break ;
				}
				break ;
			case 3 : BlurClose = BlurOpen - 1 ; break ;
			}
			Move( GetTPos( IndexPos = BlurClose ), false, false, false, true ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 17 :	// JĂʒuɈړJn
			Move( GetTPos( IndexPos = BlurOpen ), false, false, false, false ) ;
			PlayEffectSE( SFX_BOSS_AKN_WARP ) ;
			RotPlayer() ;		// vC[̕
			mod ++ ;	con = 0 ;
			break ;
			
		case 18 :	// ړI҂
			createblur() ;
			RotPlayer() ;		// vC[̕
			if( GetMoveEnd() == false ) break ;
			deleteblur() ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 19 :	// \ԂɈڍs
			RotPlayer() ;		// vC[̕
			mod = 8 ;		con = 0 ;
			break ;
		}
		break ;

	case NPC_AK2_STATE_MOVE :		// ړ
		MoveProc() ;	// ړ̃t[vZX
		MoveProc() ;	// ړ̃t[vZX
		if( GetMoveEnd() == true )
		{
			Wait() ;		// ҋ@Ԃ
		}
		break ;
	
	case NPC_AK2_STATE_SHOT :		// e
		switch( mod )
		{
		case 0 :	// \I҂
			if( GetMotionEnd() == true ){
				mod ++ ;
				con = 0 ;
			}
			break ;
			
		case 1 :	// \ҋ@
			{
				PlayMotion( AK2_MOT_SHOTFREE, true, true ) ;
				
				// ҋ@Ԃ̎Zo
				ShotWaitTime = (s32)( GetRandI2Num( AK2_SHOTMAXWAIT, AK2_SHOTMINWAIT ) * GetWaitRate() + AK2_SHOTWAIT_MIN ) ;
				
				con = 0 ;		mod ++ ;
			}
			break ;

		case 2 :	// ҋ@I҂
			con ++ ;
			if( con >= GETWAITTIME(ShotWaitTime) ){
				mod ++ ;
				con = 0 ;
			}
			break ;
			
		case 3 :	// ˌJn
			ShotType = (AK2_SHOTTYPE)GetRandINum( (s32)AK2_SHOT_TYPENUM, &NormalAtRand, AK2_ONAJIMAXNUM ) ;
			PlayMotion( (u32)AK2_ShotMotion[ShotType], AK2_ShotTime[ShotType] == -1 ? false : true, true ) ;

			mod ++ ;	con = 0 ;
			break ;
			
		case 4 :	// ˌI҂
			ShotStart() ;	// ˌJn
			con ++ ;
			if( ( AK2_ShotTime[ShotType] == -1 && GetMotionEnd() == true ) ||
				( AK2_ShotTime[ShotType] != -1 && AK2_ShotTime[ShotType] <= con ) ){
				mod ++ ;	con = 0 ;
				ShotEnd() ;		// ˌI
			}
			break ;

		case 5 :	// [h
			mShotNum ++ ;
			con = 0 ;
			if( mShotNum >= AK2_RELOAD_NUM ) mod ++ ;
			else mod = 8 ;
			break ;
			
		case 6 :	// [h
			mShotNum = 0 ;
			PlayMotion( AK2_MOT_RELOAD, false, true ) ;
			PlayEffectSE( SFX_BOSS_AKN_RELOAD ) ;
			mod ++ ;
			con = 0 ;
			break ;
		
		case 7 :	// [hI҂
			if( GetMotionEnd() == true ){
				mod ++ ;
				con = 0 ;
			}
			break ;

		case 8 :	// \߂
			PlayMotion( AK2_MOT_SHOTRETURN, false, true, AK2_KAMAEMOTIONSPEED ) ;
			mod ++ ;
			con = 0 ;
			break ;
			
		case 9 :	// \߂I҂
			if( GetMotionEnd() == true ){
				mod ++ ;
				con = 0 ;
			}
			break ;
			
		case 10 :	// 
//			Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
			mState = (WK7NpcControlState)NPC_AK2_STATE_WAIT ;
			mod = 100 ;		con = 0 ;
			break ;
		}
		break ;
		
	case NPC_AK2_STATE_DIE :			// S
		switch( mod )
		{
		case 0 :	// SẴVb^[
			ShatAllClose() ;
			mod = 600 ;	con = 0 ;
			break ;
			
		case 600 :	// ҂
			if( CheckShatAllEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 601 :	// AJlړ
			Move( 0.5F, false, false, false, true ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 602 :	// SẴVb^[J
			con ++ ;
			if( con < AK2_DIESHOTWAIT3 ) break ;
			ShatAllOpen() ;
			RotPlayer() ;
			PlayMotion( AK2_MOT_WAIT ) ;	// ҂[V
			mod = 1 ;	con = 0 ;
			break ;

		case 1 :	// J҂
			RotPlayer() ;					// vC[̕
			if( CheckShatAllEnd() == false ) break ;
			alphavalidflag( false ) ;		// 
			ShatAllClose() ;				// ĂёSẴVb^[
			mod ++ ;	con = 0 ;
			break ;

		case 2 :	// ҂
			alphaend() ;

			RotPlayer() ;					// vC[̕
			con ++ ;
			if( con < AK2_DIESHOTWAIT ) break ;
			mod ++ ;	con = 0 ;	con3 = 0 ;
			break ;

		case 3 :	// \
			RotPlayer() ;
			PlayMotion( AK2_MOT_SHOTPOSE, false, true, 1.0F ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 4 :	// \I҂
			RotPlayer() ;					// vC[̕
			if( GetMotionEnd() == false ) break ;
			PlayMotion( AK2_MOT_RELOAD, false, true, 1.0F ) ;	// [h
			PlayEffectSE( SFX_BOSS_AKN_RELOAD ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 5 :	// ˌ҂
			if( con3 == 1 )
			{
				if( DamageCon2 != DamageCon )
				{
//					if( DamageCon < ( WK7PLAYERCONTROL->GetMainID() == K7CON ? AK2_DIESHOTTAENUMVSCON : AK2_DIESHOTTAENUM ) ) PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
					if( DamageCon < AK2_DIESHOTTAENUM ) PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
					DamageCon2 = DamageCon ;
					if( WK7PLAYERCONTROL->GetMainID() == K7MSK || DamageCon >= AK2_DIESHOTTAENUM ) goto DIE_LABEL1 ;
//					if( WK7PLAYERCONTROL->GetMainID() == K7MSK ||
//						( DamageCon >= ( WK7PLAYERCONTROL->GetMainID() == K7CON ?
//							AK2_DIESHOTTAENUMVSCON : AK2_DIESHOTTAENUM ) ) ) goto DIE_LABEL1 ;
				}
			}
			RotPlayer() ;					// vC[̕
			if( GetMotionEnd() == false ) break ;	// [hI҂
			PlayMotion( AK2_MOT_SHOTFREE, false, true, 1.0F ) ;	// ˌҋ@
			mod = 500 ;	con = 0 ;
			break ;

		case 500 :	// ҂
			if( con3 == 1 )
			{
				if( DamageCon2 != DamageCon )
				{
//					if( DamageCon < ( WK7PLAYERCONTROL->GetMainID() == K7CON ? AK2_DIESHOTTAENUMVSCON : AK2_DIESHOTTAENUM ) ) PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
					if( DamageCon < AK2_DIESHOTTAENUM ) PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
					DamageCon2 = DamageCon ;
					if( WK7PLAYERCONTROL->GetMainID() == K7MSK || DamageCon >= AK2_DIESHOTTAENUM ) goto DIE_LABEL1 ;
//					if( WK7PLAYERCONTROL->GetMainID() == K7MSK ||
//						( DamageCon >= ( WK7PLAYERCONTROL->GetMainID() == K7CON ?
//							AK2_DIESHOTTAENUMVSCON : AK2_DIESHOTTAENUM ) ) ) goto DIE_LABEL1 ;
				}
			}
			
			con ++ ;
			if( con < AK2_DIESHOTWAIT2 ) break ;
			mod = 6 ;	con = 0 ;
			break ;

		case 6 :	// VbgJn
			if( con3 == 1 )
			{
				if( DamageCon2 != DamageCon )
				{
//					if( DamageCon < ( WK7PLAYERCONTROL->GetMainID() == K7CON ? AK2_DIESHOTTAENUMVSCON : AK2_DIESHOTTAENUM ) ) PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
					if( DamageCon < AK2_DIESHOTTAENUM ) PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
					DamageCon2 = DamageCon ;
					if( WK7PLAYERCONTROL->GetMainID() == K7MSK || DamageCon >= AK2_DIESHOTTAENUM ) goto DIE_LABEL1 ;
//					if( WK7PLAYERCONTROL->GetMainID() == K7MSK ||
//						( DamageCon >= ( WK7PLAYERCONTROL->GetMainID() == K7CON ?
//							AK2_DIESHOTTAENUMVSCON : AK2_DIESHOTTAENUM ) ) ) goto DIE_LABEL1 ;
				}
			}
			
			RotPlayer(true) ;					// vC[̕
			PlayMotion( AK2_MOT_SHOTNOW2, false, true, 1.0F ) ;	// ˌ
			ShotStart(0.0F) ;
			nodamegeaction = true ;
			if( con3 == 0 )
			{
				DamageCon = 0 ;			// _[WJE^Zbg
				DamageCon2 = 0 ;
			}
			mod ++ ;	con = 0 ;		con2 = 0 ;		con3 = 0 ;
			break ;

		case 7 :	// 񐔍U󂯂玀S
			// 莞Ԃ烊[h
			con3 ++ ;
			if( con3 > AK2_DIESHOTTIME )
			{
				ShotEnd() ;
				PlayMotion( AK2_MOT_RELOAD, false, true, 1.0F ) ;	// [h
				PlayEffectSE( SFX_BOSS_AKN_RELOAD ) ;
				mod = 5 ;	con = 0 ;	con2 = 0 ;	con3 = 1 ;
				break ;
			}
			con2 ++ ;
			if( con2 > AK2_DIEAHOT_ROTWAIT )
			{
				con2 = 0 ;
				RotPlayer(true) ;
			}
			if( DamageCon2 != DamageCon )
			{
//				RotPlayer(true) ;
				if( dmgmotionflag == false ) con2 = 0 ;
//				if( DamageCon < ( WK7PLAYERCONTROL->GetMainID() == K7CON ? AK2_DIESHOTTAENUMVSCON : AK2_DIESHOTTAENUM ) ) PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
				if( DamageCon < AK2_DIESHOTTAENUM ) PlayDamageMotion( AK2_DMGTIME_SMALL ) ;
				
				// ł񂾂̂}XNꌂŎS
				if( WK7PLAYERCONTROL->GetMainID() == K7MSK )
					goto DIE_LABEL1 ;
				
				DamageCon2 = DamageCon ;
			}
//			if( DamageCon < ( WK7PLAYERCONTROL->GetMainID() == K7CON ? AK2_DIESHOTTAENUMVSCON : AK2_DIESHOTTAENUM ) ) break ;
			if( DamageCon < AK2_DIESHOTTAENUM ) break ;
DIE_LABEL1 :
			gpSound->mStopSE( SFX_BOSS_AKN_RELOAD ) ;
			mod = 700 ;	con = 0 ;
			break ;
			
		case 700 :	// _[W[VI҂
			ShotEnd() ;
//			if( dmgmotionflag == true ) break ;
			dmgmotionflag = false ;
			GlobalModeState = 1 ;		// Ԑ
			mod ++ ;	con = 0 ;
			break ;
			
		case 701 :	// J҂
//			if( GlobalModeState == 1 ) break ;
			if( con == 0 )
			{
				PlayEffectSE( SFX_BOSS_AKN_DIE ) ;
			}
			mod = 8 ;	con = 0 ;
			break ;

		case 8 :	// |郂[V
			PlayMotion( AK2_MOT_DIE, false, false, 1.0F ) ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 9 :	// |҂
			con ++ ;
			if( con == 35 )
				PlayEffectSE( SFX_BOSS_AKN_DOWN ) ;
			if( GetMotionEnd() == false ) break ;
			if( GlobalModeState != 2 ) break ;			// Ԑ
			mod ++ ;	con = 0 ;
			break ;

		case 10 :	// ҂
			con ++ ;
			if( con < AK2_DIEWAIT ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 11 :	// 퓬I
			GlobalModeState = 3 ;		// Ԑ
			mBatteleExit = true ;
			Release() ;
			break ;
		}
		break ;
		
	case NPC_AK2_STATE_STARTWAIT :		// ŏ̑҂
		switch( mod )
		{
		case 0 :	// 莞ԑ҂
			con ++ ;
			if( con >= AK2_STARTWAIT ){
				mod ++ ;	con = 0 ;
			}
			break ;
			
		case 1 :	// n߂
			ShatAllClose() ;
			GlobalModeState = 100 ;		// Ԑ
			mod ++ ;	con = 0 ;
			break ;
			
		case 2 :	// ҂
			if( CheckShatAllEnd() == false ) break ;
			mod ++ ;	con = 0 ;
			break ;
			
		case 3 :	// ړJn
			Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
			break ;
		}
		break ;
		
	case NPC_AK2_STATE_SHATENDWAIT :	// Vb^[SĎ~܂҂
		{
			// ~܂҂
			if( CheckShatAllEnd() == false ) break ;

			// ̊mł		
			if( GetRandFNum( 1.0F ) < AK2_KAKURANRATE )
			{
				Kakuran() ;
			}
			else
			{
				// KȏꏊɈړ
				Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
			}
		}
		break ;

	case NPC_AK2_STATE_SHATKAKURAN :		// 
		{
			// ړ
			if( MoveProc() == true )
			{
				if( GetMoveEnd() == true )
				{
					Wait( -1, false ) ;
				}
			
				KakuranCon -- ;
				if( KakuranCon < 0 )
				{
					s32 i ;
				
					i = GetRandINum(AK2_MOVENUM) ;
					if( i != IndexPos ) PlayEffectSE( SFX_BOSS_AKN_DUSHSFX ) ;
					Move( GetTPos( IndexPos = i ), false ) ;
					
					KakuranCon = (s32)( GetRandI2Num( AK2_KAKURAN_WAIT, AK2_KAKURAN_WAIT / 2 ) * GetWaitRate() ) ;
				}
			}

			switch( mod )
			{
			case 0 :	// _ɂ
				con = 0 ;
				switch( GetRandINum( 2, &KakuranRand, AK2_ONAJIMAXNUM ) )
				{
				case 0 : mod = 1 ; break ;		// SĂɊJĕ
				case 1 : mod = 9 ; break ;		// Â
				}
				break ;
				
			case 1 :	// SĂɊJĕ
				ShatAllOpen() ;
				mod ++ ;	con = 0 ;
				break ;
			
			case 2 :	// J҂
				con ++ ;
				if( con >= AK2_KAKURAN_TIME1 ){
					mod ++ ;	con = 0 ;
				}
				break ;
				
			case 3 :	// S
				ShatAllClose() ;
				mod ++ ;	con = 0 ;
				break ;
				
			case 4 :	// ҂
				if( CheckShatAllEnd() == false ) break ;
				mod ++ ;	con = 0 ;
				break ;
				
			case 5 :	// ܂J
				ShatAllOpen() ;
				mod ++ ;	con = 0 ;
				break ;
				
			case 6 :	// ԑ҂
				con ++ ;
				if( con >= AK2_KAKURAN_TIME2 ){
					mod ++ ;	con = 0 ;
				}
				break ;

			case 7 :	// S		
				ShatAllClose() ;
				mod ++ ;	con = 0 ;
				break ;
				
			case 8 :	// ҂
				if( CheckShatAllEnd() == false ) break ;
				mod = 12 ;	con = 0 ;
				break ;
				
				
				
				
			case 9 :	// ǂ炩J߂
				KakuranType = GetRandINum( 2 ) ;
//				KakuranType = 1 ;
				mod = 200 ;		con = 0 ;
				break ;
				
			case 200 :	// Â
				if( con % AK2_KAKURAN2_WAIT == 0 )
				{
					if( KakuranType == 0 )
					{
						ShatOpen( con / AK2_KAKURAN2_WAIT ) ;
					}
					else
					{
						ShatOpen( ( STG361_SHATNUM - 1 ) - con / AK2_KAKURAN2_WAIT ) ;
					}
					if( con / AK2_KAKURAN2_WAIT == STG361_SHATNUM - 1 )
					{
						mod = 10 ;
						con = 0 ;
						break ;
					}
				}
				con ++ ;
				break ;
				
			case 10 :	// Â
				if( con % AK2_KAKURAN2_WAIT == 0 )
				{
					s32 ind ;

					if( KakuranType == 0 )
					{
						ind = con / AK2_KAKURAN2_WAIT ;
					}
					else
					{
						ind = ( STG361_SHATNUM - 1 ) - con / AK2_KAKURAN2_WAIT ;
					}
				
					if( shat[ind].endflag == true )
					{
						ShatClose( ind ) ;
						con ++ ;
						if( con / AK2_KAKURAN2_WAIT == STG361_SHATNUM - 1 )
						{
							mod ++ ;
							con = 0 ;
						}
					}
				}
				else
				{
					con ++ ;
				}
				break ;
				
			case 11 :	// ҂
				if( CheckShatAllEnd() == true ){
					mod ++ ;	con = 0 ;
				}
				break ;


				
			case 12 :	// KȏꏊɈړ
				Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ) ) ;
				break ;
			}
		}
		break ;
		

	case NPC_STATE_WAIT:
		MoveProc() ;
		break ;
		
		if ( 1 == K7EnmAK2::mAK2BattleStart ){
			if ( CALL_MOVE == mMoveProcess ){
				if ( mBattleCount ){
					mBattleCount--;
				}else{
					
					Cmd_RunSet(AK2_MovePoint[mRunPointPtr]);
					if ( mRunPointPtr < (RUNPOINT_MAX-1) ){
						mRunPointPtr++;
					}else{
						mRunPointPtr = 0;
					}
					
					break;
				}
			}
		}
		
		// Ȑ
		if ( true == MotStatus_Wait() ) break;
		
		break;
		
	case NPC_STATE_RUN:
		AK2_Run();
		break;
	case NPC_STATE_SHOTPOSE:											// \Jn
		MotStatus_ShotPose(AK2_MOT_SHOTFREE);
		break;
	case NPC_STATE_SHOTFREE:											// ˌ\[v
		// \炷Aˌ[VĐ
		if ( CALL_WAIT == mMoveProcess ){
			// Ȑ
			Cmd_ResetSet();
			break;
		}else{
			if ( AK2_MOT_SHOTNOW != mMotID ){
				// ˌ[V
				SetRotCalc(1.f);
				MotPlayInit(NPC_POSMODE_DATA);
				if ( false == PlayCommonMotionAK2(AK2_MOT_SHOTNOW, false, true, 0.f) ){
					break;
				}
				mSecondShotTiming = 0;
				mBulletNow-=1;
				mState = NPC_STATE_SHOTNOW;
				PcDamageSet();
			}
		}
		break;
	case NPC_STATE_SHOTNOW:												// ˌ
		mSecondShotTiming++;
		if ( SECOND_SHOT_FRAME == mSecondShotTiming ){
			// lɃ_[W^
			mBulletNow-=1;
			PcDamageSet();
		}
		
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			
			// \[vĐ
			MotPlayInit(NPC_POSMODE_DATA);
			if ( false == PlayCommonMotionAK2(AK2_MOT_SHOTFREE, true, false, 0.f) ){
				return false;
			}
			mState = NPC_STATE_SHOTFREE;
		}
		break;
	case NPC_STATE_DMG:
		// _[W
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			
			// \Ȃ
			MotSet_ShotPose(1.f, AK2_MOT_SHOTPOSE);
			
		}
		break;
	case NPC_STATE_EVENT:
		break;
	case NPC_STATE_DIE:
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			ReleaseWeakPoint();
			mState = NPC_STATE_LOSS;
		}
		break;
	case NPC_STATE_LOSS:
		break;
	}
	return false;
}


/*
	
	S[VZbg
	
*/
void K7EnmAK2::DieMotSet(void)
{
	// AJlSSE
//	gpSound->mPlaySE(SFX_BOSS_AK2_DIE);
	
	MotPlayInit(NPC_POSMODE_DATA);
	if ( false == PlayCommonMotionAK2(AK2_MOT_DIE, false, true, 0.f) ){
		
	}
	
	mState = NPC_STATE_DIE;
}




/*
	
	
	߁FʒuZbg
	
	
*/
void K7EnmAK2::Cmd_ResetSet(void)
{
	MotStatus_Wait();
	SetPosition(mStartPos);
	mState = NPC_STATE_WAIT;
}


/*
	
	
	߁F
	
	
*/
bool K7EnmAK2::Cmd_RunSet(Vec goPos)
{
	Vec myPos;

	if ( mpNpcChara != NULL ){
		mpNpcChara->GetPosition(myPos);
		mState		= NPC_STATE_RUN;
		mStartPos	= myPos;
		mEndPos		= goPos;
		return true;
	}
	return false;
}


/*
	
	
	胂[VZbg
	
	NPC_STATE_RUN
	
*/
bool K7EnmAK2::AK2_Run(void)
{
	Vec	enePos;
	Vec	dir;
	f32 distRest;

	mpNpcChara->GetPosition(enePos);							// ݒn̎擾
	
	// ړIl̕I
	dir.x = mEndPos.x - enePos.x;
	dir.z = mEndPos.z - enePos.z;
	mGoDir = atan2f((f32 )dir.x, (f32 )dir.z);
	
	SetTargetRotY(mGoDir);
	SetRotCalc(4.f);
	
	// rdĐ
	if(	mpNpcChara!=NULL ){
		WK7Model *pModel = mpNpcChara->GetModel();
		if ((2 == pModel->GetCurrentMotionFrame())
		||	(22 == pModel->GetCurrentMotionFrame())
		){
//			gpSound->mPlaySE3D( FOOT_SE_DEFINE, enePos, 0 );		// rdĐ
		}
	}
	
	// 胂[V̍Đ
	if ( mMotID != AK2_MOT_RUN ){
		MotPlayInit(NPC_POSMODE_PROG);
		if( false == PlayCommonMotionAK2(AK2_MOT_RUN, true, true, 2.f) ){
			return false;
		}
	}
	
	// ړ
	enePos.x += (RUN_SPEED * 1.f) * sinf(mRotY);
	enePos.z += (RUN_SPEED * 1.f) * cosf(mRotY);
	
	SetPosition(enePos);
	
	// ړIn܂ŒǂH
#define TOUTYAKU_OK_DIST	(RUN_SPEED*3)
	distRest = GHM_VEC_GET_DIST(&mEndPos, &enePos);
	
	if ( distRest <= TOUTYAKU_OK_DIST ){
		MotSet_Wait(true);
		mState = NPC_STATE_WAIT;
		return true;
	}
	return false;
}

/*
	
	ꃂ[VZbg
	
*/
void K7EnmAK2::AK2_Dmg(void)
{
	MotPlayInit(NPC_POSMODE_DATA);
	if ( false == PlayCommonMotionAK2(AK2_MOT_DAM, false, true, 0.f) ){
		
	}
}


/*
	
	
	lɃ_[Wݒ肷B
	
	
*/
void K7EnmAK2::PcDamageSet(void)
{
	Vec myPos;
	
	mpNpcChara->GetPosition(myPos);
	SetMuzzleCartridgeSound3DFlag() ;
	CreateMuzzleEffect( GUN_R, myPos.y );
	
	mShotNum++;
	
	if (((3+rand()%4) <= mShotNum)
	&&	(true == PcHitTest())
	){
		mShotNum = 0;
//		WK7PLAYERCONTROL->SetPcDamage(myPos, 2, 1);				// |WVA_[WlA[h
		WK7PLAYERCONTROL->SetPcDamage(myPos, AK2_GUN_DAMAGE, 2);				// |WVA_[WlA[h
	}
}

/*
	
	
	obɃ_[W^ĂǂH
	
	
*/
bool K7EnmAK2::PcHitTest(void)
{
	if ((200 == mBattleProcess)
	||	(0 == mBattleProcess)
	||	(20 == mBattleProcess)
	||	(21 == mBattleProcess)
	){
		return false;
	}
	return true;
}


/*
	
	
	oWbN
	
	
*/
void K7EnmAK2::RunLogicSet(u32 time)
{
	mMoveProcess = CALL_MOVE;									// AJlړJn
	mBattleCount = time;
}


bool K7EnmAK2::FrameProcess(void)
{
	MotionProcess();
	
	if( mpNpcChara!=NULL ){
		
		if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
#if FUJITA //030702
			//_B
			{
				Vec eye;
				WK7CAM->GetPosition( eye );
				
				//_JOBJAJɂ炷ʁB
				//f32 dist = 5.f;
				f32 dist = -5.f;
				
				//_̏B
				PlayWeakPoint( eye, dist );
			}
#endif
			// XLjORg[
//			ScanContorol();
			
			// B鏈Rg[
//			HideContorol();
			
			// [VXs[hRg[
			MotionSpeedControl();
			
			// ŏ̈ʒuZbg̎
			if( !mFirstPosSet ){
				WK7Model *pModel;
				
				mFirstPosSet = 1;
				mpNpcChara->SetPosition(mPosition);
				mpNpcChara->SetRotY(mTargetRotY);
				
				// X^[gʒu̕ۑ
				mStartPos = mPosition;
				
				SetVisible(true);
				
				if( (pModel = mpNpcChara->GetModel())!=NULL ){
					mpNpcChara->SetRenderFlag(true);
					pModel->Disp();
				}
				
				// _[iqbg̃sbN̂߂ɂKvsj
				switch( mpNpcChara->GetRenderID() ){
				case	WK7RENDEROBJ_INVALID_RENDERID:
//				case	WK7RENDEROBJ_RENDERID_MAX:
				case	WK7RENDEROBJ_RENDERID_DEFAULT:
					mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
					mpNpcChara->EnableVfxEffect();
					break;
				default:
					break;
				}
			}
		}
	
//		VisibleTest();
	}
	return true;
}

/*
	
	
	AJl{XĎ֐
	
	
*/
void K7EnmAK2::StageProc(WK7Stage *pCurrentStage)
{
	static WK7JObj *pJObj;
	static int exitMode;
	K7Stage361M00 *pStage = (K7Stage361M00 *)pCurrentStage;
	
	switch (mBattleProcess){
	case 0:							// ҋ@
		if ( 1 == K7EnmAK2::mAK2BattleStart ){
			mBattleProcess = 100;
			WK7PLAYERCONTROL->SetOperateEnable(true);
			RunLogicSet(0);
			
			gpSound->mPlayStreamNo(HPS_BOSS_AKN);						//@퓬ȊJnI
			
		}
		break;
	case 100:															// og
		if ( PC_STATE_LOSS == WK7PLAYERCONTROL->PcDieTest()/*GetPcState()*/ ){			// lŏI
				mBattleProcess=1000;
				exitMode = -1;
		}else{
			if (mState == NPC_STATE_LOSS ){								// f|[ŏI
				mBattleProcess=1000;
				exitMode = 1;
			}
		}
		break;
#if	1
	case 1000:
		gpSound->mStopStream();											// 퓬ȏI
		mBattleProcess=1001;
		break;
	case 1001:
		Release();
		mBattleProcess++;
		mBatteleExit = exitMode;
		break;
#else
	case 1000:
		gpSound->mStopStream();											// 퓬ȏI
		//mCY
//		gpNoise->mSandRequest(eSandLongNoise);													// LȂꍇ
		gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);			// Lꍇ
		mBattleProcess=1001;
		break;
	case 1001:
		if ( gpNoise->mGetSandFrameProc()==eSandExec ){
			Release();
			mBattleProcess++;
			mBatteleExit = exitMode;
		}
		break;
#endif
	default:
		break;
	}
}

/*
	
	
	AJl{XIH
	
	<return>
	-1			{XIilSj
	1			{XIiAJlSj
	0			{X풆
	
*/
int K7EnmAK2::AK2BossEnd(void)
{
	return mBatteleExit;
}

bool K7EnmAK2::AK2BossStart(void)
{
	mAK2BattleStart = true ;
	
	// f̕\
	SetVisible2( true ) ;
	
	// ҋ@Ԃ
	mState = (WK7NpcControlState)NPC_AK2_STATE_STARTWAIT ;
	con = mod = 0 ;
	PlayMotion( AK2_MOT_WAIT, true, true ) ;
	
	return true ;
}


WK7Model *K7EnmAK2::GetModel(void)
{
	WK7Chara		*pCharaTmp;
	
	pCharaTmp = pCurrentChara();
	
	if( pCharaTmp==NULL ) return NULL ;
	return pCharaTmp->GetModel() ;
}

// S_𓾂
void K7EnmAK2::GetRootJointPos( Vec *pos )
{
	GetModel()->GetObj( "Root_joint" )->GetWorldPosition( pos ) ;
}

// u[GtFNg쐬
void K7EnmAK2::createblur( void )
{
	u32 cr1, cr2 ;

	if( blur != NULL ) return ;		// ɍĂ牽Ȃ
	if( validalpha == true && alpha < 0.01F ) return ;	// O牽Ȃ

	// 쐬
	cr1 = CMK( 159, 109, 243, 255 ) ;
	cr2 = CMK( 191, 227, 225, 255 ) ;
	blur = CreateBlurEffect( 	pCurrentChara()->GetModel()->GetObj( AK2_BLURNAME "1" ),
								pCurrentChara()->GetModel()->GetObj( AK2_BLURNAME "2" ),
								*((GXColor *)&cr1), *((GXColor *)&cr2) ) ;
	blurid = GetEffectID( blur ) ;
}

// u[GtFNg폜
void K7EnmAK2::deleteblur( void )
{
	if( CheckEffectValidState( blur, blurid ) == FALSE ) return ;

	// 폜
	DelReqEffect( blur ) ;
	blur = NULL ;
}

// ̗LtOZbg
void K7EnmAK2::alphavalidflag( bool flag )
{
	validalpha = flag ;
}

// ̏
void K7EnmAK2::alphainit(void)
{
	if( alphainitflag == true ) return ;

	// IuWFNg̍쐬
	gunalpha = bodyalpha = NULL ;
	if( ( bodyalpha = new C_SetAlpha( GetModel()->GetObj(0)->GetJObj(), 1.0F ) ) == NULL ) goto ERR ;
	if( ( gunalpha = new C_SetAlpha( mpGun->GetObj(0)->GetJObj(), 1.0F ) ) == NULL ) goto ERR ;
	
	alpha 		= 1.0F ;
	alphaspeed 	= 0.1F ;
	hideflag 	= false ;
	
	validalpha	= true ;
	alphainitflag = true ;

	return ;
		
ERR :
	if( bodyalpha != NULL ) delete bodyalpha ;
	if( gunalpha != NULL ) delete gunalpha ;
	
	bodyalpha = gunalpha = NULL ;
	
	return ;
}

// ̌n
void K7EnmAK2::alphaend(void)
{
	if( alphainitflag == false ) return ;

	if( bodyalpha != NULL )
	{
		bodyalpha->SetVal( 1.0F ) ;
		delete bodyalpha ;
		
		if( mpNpcChara != NULL )
		{
			if( mpNpcChara->GetModel() != NULL )
			{
				mpNpcChara->GetModel()->Hide( false ) ;
				mpNpcChara->GetModel()->Disp( true ) ;
//				if( mpNpcChara->mpModel->mpTopObj != NULL )
//				{
//					mpNpcChara->mpModel->mpTopObj->mpJObj->flag &= ~
//				}
			}
		}
	}
	if( gunalpha != NULL )
	{
		gunalpha->SetVal( 1.0F ) ;
		delete gunalpha ;
	}

	bodyalpha = gunalpha = NULL ;

	alphainitflag = false ;
	
	return ;
}

// l̕ύX
void K7EnmAK2::setalpha(bool disp, f32 speed)
{
	hideflag = !disp ;
	
	alphaspeed = speed ;
}

// ̃t[vZX
void K7EnmAK2::alphaproc(void)
{
	if( alphainitflag == false ) return ;
	
	// ʏ
	{
		f32 targetalpha ;
		
		targetalpha = 1.0F - GetShatCloseRate( Pos ) ;
		
		if( targetalpha != alpha )
		{
			if( targetalpha > alpha )
			{
				alpha += alphaspeed ;
				if( alpha > targetalpha ) alpha = targetalpha ;
			}
			else
			{
				alpha -= alphaspeed ;
				if( alpha < targetalpha ) alpha = targetalpha ;
			}
		}

		if( validalpha )
		{
			bodyalpha->SetVal( alpha ) ;
			gunalpha->SetVal( alpha ) ;
		}
		else
		{
			bodyalpha->SetVal( 1.0F ) ;
			gunalpha->SetVal( 1.0F ) ;
		}

		return ;
	}

	if( hideflag == true )
	{
		if( alpha != 0.0F )
		{
			alpha -= alphaspeed ;
			if( alpha < 0.0F ) alpha = 0.0F ;
			
			if( validalpha )
			{
				bodyalpha->SetVal( alpha ) ;
				gunalpha->SetVal( alpha ) ;
			}
			else
			{
				bodyalpha->SetVal( 1.0F ) ;
				gunalpha->SetVal( 1.0F ) ;
			}
		}
	}
	else
	{
		if( alpha != 1.0F )
		{
			alpha += alphaspeed ;
			if( alpha > 1.0F ) alpha = 1.0F ;
			
			if( validalpha )
			{
				bodyalpha->SetVal( alpha ) ;
				gunalpha->SetVal( alpha ) ;
			}
			else
			{
				bodyalpha->SetVal( 1.0F ) ;
				gunalpha->SetVal( 1.0F ) ;
			}
		}
	}

	if( alpha == 0.0F && validalpha == true )
	{
		Vec p = {0.0F,0.0F,0.0F} ;
		mpNpcChara->SetPosition( p ) ;
		deleteblur() ;
	}
}

// vC[̃_[W̃R[obN
s8 K7EnmAK2::PlayDamageCallBack( SHOTOBJECT *obj, void *data )
{
	K7EnmAK2 *AK2 = ( K7EnmAK2 * )data ;
	Vec pos, spos ;
	s32 i ;
	
	// vC[̈ʒu𓾂
	WK7PLAYERCONTROL->GetCharaModel()->GetObj( "Root_joint" )->GetWorldPosition( &pos ) ;
	
	// Ă邩ׂ
	for( i = 0 ; i < AK2_PLAYDMGCHECKDIV ; i ++ )
	{
		spos.x = obj->pos.x - obj->speed2.x * i / AK2_PLAYDMGCHECKDIV ;
		spos.y = obj->pos.y - obj->speed2.y * i / AK2_PLAYDMGCHECKDIV ;
		spos.z = obj->pos.z - obj->speed2.z * i / AK2_PLAYDMGCHECKDIV ;
	
		// Ă烋[v𔲂
		if( VECDistance( &pos, &spos ) <= AK2_PLAYDMGWIDTH ) break ;
	}
	if( i == AK2_PLAYDMGCHECKDIV ) return 0 ;
	
	// Ă_[Wǉ
	AK2->PlayDamageInc() ;
	
	// I
	return 0 ;
}

// vC[̃_[W`FbN
void K7EnmAK2::PlayDamageCheck( void )
{
	// SĂ̒eۂ񋓁EvC[ɓĂ邩ׂ
	EnumShotEffect( shot, PlayDamageCallBack, this ) ;
}

// vC[Ƀ_[Wǉ
void K7EnmAK2::PlayDamageInc( void )
{
	// ^CJE^Zbg
	pdamagetime = 0 ;
	if( pdamagecon == 0 ) pdamagetime2 = 0 ;
	
	// _[W񐔂ǉ
	pdamagecon ++ ;
	
	// ʂtbV
	CreateFlashEffect( 
						TRUE,						// QcWn
						(Vec){0.0F,0.0F,0.0F},		// W
						1.0F,						// TCY
						AK2_PLAYDMGCOLOR,			// F
							
						0,							// 肫܂ł̎
						0,							// Ă܂ł̎
						FALSE 						// Z
						) ;
}

// vC[Ƀ_[W^鏈̃t[vZX
void K7EnmAK2::PlayDamageProc( void )
{
	if( PlayMotionID == AK2_MOT_DIE ) return ;

	PlayDamageCheck() ;
	if( pdamagecon == 0 ) return ;
	
	pdamagetime ++ ;
	pdamagetime2 ++ ;
	if( pdamagetime < AK2_PLAYDMGWAIT && pdamagetime2 < AK2_PLAYDMGWAIT2 ) return ;

	// vC[Ƀ_[W^
	{
		Vec pos ;
		s16 dam, hp  ;
		
		mpNpcChara->GetPosition(pos) ;
		dam = (s16)( ( false/*WK7PLAYERCONTROL->GetMainID() == K7CON*/ ? 0.7F : 1.0F ) * ( DieFlag ? AK2_PLAYDMG3 : ( IkariMode ? AK2_PLAYDMG2 : AK2_PLAYDMG ) ) * pdamagecon ) ;
		hp = WK7PLAYERCONTROL->GetHp() ;
#ifdef YAMADADEBUG
		OSReport( "PcDamage:%d  hp:%d\n", dam, hp ) ;
#endif
		if( dam == 0 ) dam = 1 ;
		WK7PLAYERCONTROL->SetPcDamage( pos, dam, 1 ) ;
	}
	
	// JE^̃Zbg
	pdamagecon = 0 ;
	pdamagetime = 0 ;
	pdamagetime2 = 0 ;
}



// S
void K7EnmAK2::Die( void )
{
	mState = (WK7NpcControlState)NPC_AK2_STATE_DIE ;
	DieFlag = true ;
	
	mod = con = 0 ;
//	ChangeShotInfo( shot, AK2_SHOTCOLOR3, AK2_SHOTSIZE3 ) ;
}

// WXV
void K7EnmAK2::RefreshPos( void )
{
	if( alpha == 0.0F && validalpha == true )
	{
		Vec p = {0.0F,0.0F,0.0F} ;
		mpNpcChara->SetPosition( p ) ;
		deleteblur() ;
	}
	else
	{
		Vec p ;
		
		p = AK2_BasePos ;
		p.x = AK2_MIN_X + AK2_MOV_LEN * Pos ;
		mpNpcChara->SetPosition( p ) ;
		
		VecPos = p ;
	}
}

// [VĐ
void K7EnmAK2::PlayMotion( u32 id, bool loop, bool hokan, f32 speed )
{
	if( PlayMotionID == id ) return ;
	
	PlayMotionID = (s32)id ;
	motioncon	= 0.0F ;
//	motiontime	= GetMotionTotalTime( id ) ;
	motionspeed	= speed ;
	motionloop	= loop ;

	// ĐJn
	if( dmgmotionflag == false )
	{
		PlayCommonMotionAK2( id, loop, hokan, 0.0F, speed ) ;
	}
}

// _[W[VĐ
void K7EnmAK2::PlayDamageMotion( s32 time, f32 speed )
{
	// [V̎ԂۑĂ
	if( dmgmotionflag == false )
		motiontime = GetMotionFrame() ;
	
	// _[W[V̊Jn
	PlayCommonMotionAK2( AK2_MOT_DAM, true, true, AK2_DMGSTATFRAME, speed ) ;
	
	dmgmotionflag = true ;
	dmgmotiontime = time ;
	dmgmotioncon = 0.0F ;
	dmgmotiontimecon = 0 ;
	dmgmotionspeed = speed ;
}

// [Ṽt[vZX
void K7EnmAK2::MotionProc( void )
{
	// _[W[Vł͂Ȃꍇ̓[VJE^i߂
	if( dmgmotionflag == false )
	{
//		motiontime += 1.0F ;
		return ;
	}

	// _[W[ṼCNg
	dmgmotiontimecon ++ ;
	if( dmgmotiontimecon >= dmgmotiontime )
	{
		dmgmotionflag = false ;
		PlayCommonMotionAK2( (u32)PlayMotionID, motionloop, true, motiontime * 2.0F, motionspeed ) ;
	}
	else
	{
		// _[W[V̐
		dmgmotioncon += dmgmotionspeed ;
	}
}

// [V̑Ԃ𓾂
f32 K7EnmAK2::GetMotionTotalTime( u32 id )
{
	return mpNpcMotion[id]->GetMotion()->GetModelMotion()->GetTotalMotionFrame() ;
}

// [V̍ĐԂ𓾂
f32 K7EnmAK2::GetMotionFrame( void )
{
	return pCurrentChara()->GetModel()/*->GetObj( "Spine_joint1" )*/->GetCurrentMotionFrame(false) ;
}


// [V̏IԂ𓾂
bool K7EnmAK2::GetMotionEnd( void )
{
	return GetCommonMotionState() == WK7MODEL_NOANIM && dmgmotionflag == false ;
}


// 
void K7EnmAK2::Kakuran( void )
{
	con = 0 ;
	mod = 0 ;
	KakuranCon = GetRandI2Num( AK2_KAKURAN_WAIT, AK2_KAKURAN_WAIT / 2 ) ;
	
	// KȏꏊɈړ
	Move( GetTPos( IndexPos = GetRandINum(AK2_MOVENUM) ), false ) ;

	PlayEffectSE( SFX_BOSS_AKN_DUSHSFX ) ;

	mState = (WK7NpcControlState)NPC_AK2_STATE_SHATKAKURAN ;
}

// {胂[h
void K7EnmAK2::Ikari( void )
{
	IkariMode = true ;
//	ChangeShotInfo( shot, AK2_SHOTCOLOR2, AK2_SHOTSIZE2 ) ;
}

// _bVVbg
void K7EnmAK2::DashShot( void )
{
	mState = (WK7NpcControlState)NPC_AK2_STATE_DASHSHOT ;

	con = mod = 0 ;	
}

// u[Vbg
void K7EnmAK2::BlurShot( void )
{
	mState = (WK7NpcControlState)NPC_AK2_STATE_BLURSHOT ;

	BlurNum = 0 ;
	con = mod = 0 ;	
}

// _[W
void K7EnmAK2::Damage( void )
{
	mState = (WK7NpcControlState)NPC_AK2_STATE_DMAGE ;
	
	DamageCon = 0 ;
	DamageTime = 0 ;
	
	con = mod = 0 ;
}


// ҂
void K7EnmAK2::ShatEndWait( void )
{
	mState = (WK7NpcControlState)NPC_AK2_STATE_SHATENDWAIT ;
	
	mod = con = 0 ;
}

// e
void K7EnmAK2::Shot( void )
{
	mState = (WK7NpcControlState)NPC_AK2_STATE_SHOT ;

	// \[V̍Đ
	PlayMotion( AK2_MOT_SHOTPOSE, false, true, AK2_KAMAEMOTIONSPEED ) ;

	// vC[̕
	RotPlayer() ;

	con = mod = 0 ;
}

// VbgX^[g
void K7EnmAK2::ShotStart( f32 bias )
{
	if( shotflag == true ) return ;
	MuzzleWaitCon = 0 ;
	muzzlecon = 0 ;
	shotflag = true ;
	shotbias = bias ;
	CreateMuzzle() ;
}

// VbgGh
void K7EnmAK2::ShotEnd( void )
{
	shotflag = false ;
	DeleteMuzzle() ;
}

// Vbg̃t[vZX
void K7EnmAK2::ShotProc( void )
{
	s32 wait ;

	if( shotflag == false ) return ;

	// }YtbVo
	muzzlecon ++ ;
	if( muzzlecon >= AK2_MUZZLEWAIT )
	{
		muz = CreateMuzzleEffect( GUN_R, YUKA_Y ) ;			
		if( muz != NULL ) muzid = GetEffectID( muz ) ;
		muzzlecon = 0 ;
	}
	
	// VbgԊu̎Zo
	wait = DieFlag == true ? AK2_SHOTWAIT3 : ( IkariMode == true ? AK2_SHOTWAIT2 : AK2_SHOTWAIT1 ) ;

	// Vbg鏈
	MuzzleWaitCon += 100 ;
	while( MuzzleWaitCon >= wait )
	{
		MuzzleWaitCon -= wait ;
		CreateMuzzle() ;
		MuzzleWaitCon = 0 ;
	}
}

// ړx̕ύX
void K7EnmAK2::MoveSpeed( f32 speed )
{
	movespeed = speed < 0.0F ? AK2_SPEED_T : speed ;
}



// w̍WɈړ
void K7EnmAK2::Move( f32 pos, bool mchange, bool kamae, bool motion, bool teleport )
{
	f32 f1, f2 ;
	
	// uňړꍇ͈uňړ
	if( teleport == true )
	{
		Pos = TargetPos = pos ;		// WZbg
		RefreshPos() ;				// ʒuZbg
		
		return ;
	}

	// Ɏw̍WڕWWłꍇ͉Ȃ
	if( pos == TargetPos ) return ;

	TargetPos 	= pos ;			// sW̕ۑ
	kamaeflag 	= kamae ;		// \Ă邩ǂ̃tOۑ
	motionflag 	= motion ;		// [VtOۑ

	// ^[[V̍Đ
	f1 = TargetPos - Pos ;
	f2 = pos - Pos ;
	if( TargetDir != AK2_DIR_FRONT &&
		( ( f1 > 0.0F && f2 < 0.0F ) || ( f1 < 0.0F && f2 > 0.0F ) ) &&
		motion == true )
	{
		TurnFlag = true ;
		PlayMotion( AK2_MOT_TURN, false, true ) ;
	}
	else
	{
		// łȂꍇ͑n߂
		TurnFlag = false ;
		
		// \Aǂŏ𕪊
		if( motion == true )
		{
			if( kamae == false )
			{
				// \Ȃ̏ꍇ͂̂܂ܑ
				PlayMotion( AK2_MOT_RUN, true, true ) ;
			}
			else
			{
				PlayMotion( AK2_DashShotMot[ GetAngle( f1 ) ], true, true ) ;
			}
			
			// ̕ύX
			Rot( f1 ) ;
		}
	}

	// Ԃ𑖂ɂ
	if( mchange == true )
	{
		mState = (WK7NpcControlState)NPC_AK2_STATE_MOVE ;
		con = mod = 0 ;
	}
}

// ړ̃t[vZX
bool K7EnmAK2::MoveProc( void )
{
	if( Pos == TargetPos ) return true ;
	if( dmgmotionflag == true ) return false ;

	if( TurnFlag == true )
	{
		// ^[I҂
		if( GetMotionEnd() == true )
		{
			// ̕ύX
			Rot( TargetPos - Pos, false ) ;
			TurnFlag = false ;
			
			// 胂[V̍Đ
			// \Aǂŏ𕪊
			if( kamaeflag == false )
			{
				// \Ȃ̏ꍇ͂̂܂ܑ
				PlayMotion( AK2_MOT_RUN, true, true ) ;
			}
			else
			{
				PlayMotion( AK2_DashShotMot[ GetAngle( TargetPos - Pos ) ], true, true ) ;
			}
		}
		
		return false ;
	}
	
	// ړ
	{
		f32 rate, rate2 ;
		
		rate2 = WK7PLAYERCONTROL->GetMainID() == K7CON ? AK2_VSCONSPEED : 1.0F ;
		rate = ( AK2_MAXSPEED * rate2 * ( 1.0F - GetWaitRate() ) ) + ( AK2_MINSPEED * rate2 * GetWaitRate() ) ;
		if( mState != (WK7NpcControlState)NPC_AK2_STATE_MOVE )
		{
			if ( true == EASYFLAG ) rate *= AK2_EASYSPEEDRATE ;
		}
	
		if( TargetPos > Pos )
		{
			Pos += movespeed * rate ;
			if( Pos >= TargetPos ) Pos = TargetPos ;
		}
		else
		{
			Pos -= movespeed * rate ;
			if( Pos <= TargetPos ) Pos = TargetPos ;
		}
	}
	
	// ʒuZbg
	RefreshPos() ;
	
	if( Pos != TargetPos ) return false ;
	
	return true ;
}

// ҋ@ԂɈڍs
void K7EnmAK2::Wait( s32 Wait, bool mchange )
{
	// ɑҋ@Ԃ̏ꍇ͉Ȃ
	if( mchange == true )
	{
		if( mState == NPC_AK2_STATE_WAIT ) return ;
	}

	// 𐳖ʂ
	Rot( 0.0F ) ;
	
	// ҋ@[V̍Đ
	PlayMotion( AK2_MOT_WAIT ) ;

	if( mchange == true )
	{
		// Ԃҋ@Ԃɂ
		mState = (WK7NpcControlState)NPC_AK2_STATE_WAIT ;
		con = mod = 0 ;
		
		// ҂ԂZbg
		if( Wait == -1 )
		{
			WaitTime = GetRandI2Num( AK2_NORMALMAXWAIT, AK2_NORMALMINWAIT ) ;
		}
		else
		{
			WaitTime = Wait ;
		}
		WaitTime = (s32)( WaitTime * GetWaitRate() ) ;
	}
}

// fl񋓌^l𓾂( 0.0F:  Plus:w}CiX֌  Minus:wvX֌ )
K7EnmAK2::AK2_ANG K7EnmAK2::GetAngle( f32 angle )
{
	return angle == 0.0F ? AK2_DIR_FRONT : ( angle > 0.0F ? AK2_DIR_PLUS : AK2_DIR_MINUS ) ;
}

// ړ̑҂Ԃ𓾂
f32 K7EnmAK2::GetWaitRate( void )
{
	return (f32)Vital / AK2_VITAL ;
}

// w̕Ɍ( 0.0F:  Plus:w}CiX֌  Minus:wvX֌ )
void K7EnmAK2::Rot( f32 angle, bool hokan )
{
	TargetDir = GetAngle( angle ) ;
	if( hokan == false )
	{
		mpNpcChara->SetRotY( AK2_Rot[TargetDir]  ) ;
		AK2_Rot[TargetDir] ;
	}
	else
	{
		SetTargetRotY( AK2_Rot[TargetDir]  ) ;
	}
}

// vC[̕
void K7EnmAK2::RotPlayer( bool hokan )
{
	Vec ppos, apos ;
	f32 rot ;
	
	hokan = hokan ;

	// W𓾂
	WK7PLAYERCONTROL->GetPosition( &ppos ) ;
	mpNpcChara->GetPosition(apos);

	// ]
	rot = atan2f( ppos.x - apos.x, ppos.z - apos.z ) ;
	if( hokan )
	{
		SetTargetRotY( rot ) ;
	}
	else
	{
		SetRotY( rot ) ;
	}
}

// t[vZX
void K7EnmAK2::RotProc( void )
{
	SetRotCalc( DieFlag == true ? AK2_ROTSPEED2 : AK2_ROTSPEED ) ;
}

// \
void K7EnmAK2::SetVisible2( bool flag )
{
	mVisible = flag ;
	if( mVisible == true && mVisible3 == true )
	{
		GetModel()->Disp( false ) ;
		if( mpGun != NULL ) mpGun->Disp( false ) ;
	}
	else
	{
		GetModel()->Hide( false ) ;
		if( mpGun != NULL ) mpGun->Hide( false ) ;
	}
}


// Vb^[̃t[vZX
void K7EnmAK2::ShatFrameProcess( void )
{
	s32 i ;
	bool openf, closef ;
	STG361SHAT *st ;
	
	openf = closef = false ;
	
	st = shat ;
	for( i = 0 ; i < STG361_SHATNUM ; i ++, st ++ )
	{
		if( st->endflag == true ) continue ;
		
		// 
		if( st->closeflag == true )
		{
			st->closerate += 1.0F / MDL361M00SHATTIME ;
			if( st->closerate >= 1.0F )
			{
				st->closerate = 1.0F ;
				st->endflag = true ;
				
				if( closef == false )
				{
					PlayEffectSE( SFX_BOSS_AKN_SHUTTERCLOSE ) ;
					closef = true ;
				}
				if( CheckShatAllEnd() == true ) gpSound->mStopSE( SFX_BOSS_AKN_SHUTTER ) ;
			}
		}
		else
		{
			st->closerate -= 1.0F / MDL361M00SHATTIME ;
			if( st->closerate <= 0.0F )
			{
				st->closerate = 0.0F ;
				st->endflag = true ;

				if( openf == false )
				{
					PlayEffectSE( SFX_BOSS_AKN_SHUTTEROPEN ) ;
					openf = true ;
				}
				if( CheckShatAllEnd() == true ) gpSound->mStopSE( SFX_BOSS_AKN_SHUTTER ) ;
			}
		}
		
		// [Vɔf
		{
			f32 total ;
			
			total = st->JObj->GetTotalMotionFrame() ;
			st->JObj->SetMotionLoop( false ) ;
			st->JObj->PlayMotion( total * st->closerate ) ;
			st->JObj->StopMotion( true, true ) ;
		}
	}
}

// Vb^[SĎ~܂Ă邩𓾂( true:SĎ~܂Ă  false:~܂ĂȂ )
bool K7EnmAK2::CheckShatAllEnd( void )
{
	s32 i ;
	
	for( i = 0 ; i < STG361_SHATNUM ; i ++ )
		if( shat[i].endflag == false ) return false ;
		
	return true ;
}


// ݂̈ʒuԋ߂Vb^[̃CfbNX𓾂	
s32 K7EnmAK2::GetShatIndex( f32 posX )
{
	posX *= STG361_SHATNUM - 1 ;
	if( posX >= 0.0F && posX < 0.5F ) return 0 ;
	if( posX >= 0.5F && posX < 1.5F ) return 1 ;
	if( posX >= 1.5F && posX < 2.5F ) return 2 ;
	return 3 ;
}

// Vb^[̕𓾂
f32 K7EnmAK2::GetShatCloseRate( f32 posX )
{
	f32 rate ;
	STG361SHAT *st1, *st2 ;

	posX *= STG361_SHATNUM - 1 ;

	if( posX >= 0.0F && posX < 1.0F )
	{
		rate = posX ;
		st1 = &shat[0] ;
		st2 = &shat[1] ;
	}
	else
	if( posX >= 1.0F && posX < 2.0F )
	{
		rate = posX - 1.0F ;
		st1 = &shat[1] ;
		st2 = &shat[2] ;
	}
	else
	if( posX >= 2.0F && posX < 3.0F )
	{
		rate = posX - 2.0F ;
		st1 = &shat[2] ;
		st2 = &shat[3] ;
	}
	else return shat[3].closerate ;
	
	return ( 1.0F - rate ) * st1->closerate + rate * st2->closerate ;
}


// Vb^[܂Ă邩擾
bool K7EnmAK2::GetShatCloseState( s32 ShatIndex )
{
	STG361SHAT *st = &shat[ShatIndex] ;
	return st->endflag == true && st->closeflag == true ;
}

// Vb^[J
void K7EnmAK2::ShatOpen( s32 ShatIndex )
{
	STG361SHAT *st = &shat[ShatIndex] ;
	
	if( st->closeflag == false ) return ;
	
	if( CheckShatAllEnd() == true )
	{
		PlayEffectSE( SFX_BOSS_AKN_SHUTTER ) ;
	}

	st->closeflag = false ;
	st->endflag = false ;
}


// Vb^[
void K7EnmAK2::ShatClose( s32 ShatIndex )
{
	STG361SHAT *st = &shat[ShatIndex] ;
	
	if( st->closeflag == true ) return ;

	if( CheckShatAllEnd() == true )
	{
		PlayEffectSE( SFX_BOSS_AKN_SHUTTER ) ;
	}
	
	st->closeflag = true ;
	st->endflag = false ;
}


// SẴVb^[J
void K7EnmAK2::ShatAllOpen( void )
{
	s32 i ;
	for( i = 0 ; i < STG361_SHATNUM ; i ++ ) ShatOpen( i ) ;
}


// SẴVb^[
void K7EnmAK2::ShatAllClose( void )
{
	s32 i ;
	for( i = 0 ; i < STG361_SHATNUM ; i ++ ) ShatClose( i ) ;
}

// }Yo
void K7EnmAK2::CreateMuzzle( void )
{
//	s32 i, num ;

	// Vbg̔
//	num = DieFlag == true ? 3 : ( IkariMode == true ? 2 : 1 ) ;
//	for( i = 0 ; i < num ; i ++ )
	{
		HSD_JObj *jobj ;
		Vec dir, pos ;
	
		jobj = mpGun->GetObj( "MuzFlash00_S1" )->GetJObj() ;
		GetJObjZVec( jobj, &dir ) ;
		dir.y += shotbias ;
		
		dir.x += GetRandF2Num( AK2_SHOTDIRBIASRAND, -AK2_SHOTDIRBIASRAND ) ;
		dir.y += GetRandF2Num( AK2_SHOTDIRBIASRAND, -AK2_SHOTDIRBIASRAND ) ;
		dir.z += GetRandF2Num( AK2_SHOTDIRBIASRAND, -AK2_SHOTDIRBIASRAND ) ;
		
		VECNormalize( &dir, &dir ) ;
		GetJObjPos( jobj, &pos ) ;

		AddShotEffect( shot, pos, dir, /*IkariMode == true ? AK2_SHOTSPEED2 :*/ AK2_SHOTSPEED ) ;
		PlayEffectSE( DieFlag == true ? SFX_BOSS_AKN_SHOTLV3 : ( IkariMode == true ? SFX_BOSS_AKN_SHOTLV2 : SFX_BOSS_AKN_SHOTLV1 ) ) ;//,
//						VecPos, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap ) ;
	}
}

// }Y폜
void K7EnmAK2::DeleteMuzzle( void )
{
	if( CheckEffectValidState( muz, muzid ) == TRUE )
	{
		DeleteEffect( muz ) ;
		muz = NULL ;
		muzid = 0 ;
	}
}

/*
	
	
	AJlp[VĐ[`
	
	
	
*/
bool K7EnmAK2::PlayCommonMotionAK2(u32 id, bool loop, bool hokan, f32 sframe, f32 speed)
{
	if ((id == AK2_MOT_RUN)
	||	(id == AK2_MOT_SHOTDASH)
	||	(id == AK2_MOT_SHOTDASH2)
	||	(id == AK2_MOT_DIE)
	){
		if ( mpNpcChara != NULL ){							// ̂̕vZ𖳌ɂ
			mpNpcChara->SetClothEnable(false);
		}
	}else{
		if ( mpNpcChara != NULL ){							// ̂̕vZLɂ
			mpNpcChara->SetClothEnable(true);
		}
	}
	
	return PlayCommonMotion(id, loop, hokan, sframe, speed);
}

