////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// Enmang.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMBOSS_CPP__

#include "EnmBoss.h"
#include "..\Wat\WK7EventScript.h"
#include "..\Wat\K7GlobalFlag.h"

s32 K7EnmBoss::common_state = 0;

s32 K7EnmBoss::AddMotion( s16 *tbl_ )
{
  s32 ofst_ = last_mot_no;

  for (int i_=last_mot_no,j_=0; i_<WK7MOTION_NPCCMN_NUM; ++i_){

	if ( -1 == tbl_[j_] ) break;

	if ( NULL == CreateMotion( (K7MOTID(chr_id,tbl_[j_])), i_) ){
	}else{
	  ++j_;
	}
  }
  return ofst_;
}

#if 1
void K7EnmBoss::CreatePackMotion(s16 *pTabelePtr, u32 motCodeId)
{
	for ( int i=0; i<WK7MOTION_NPCCMN_NUM; i++){
		mpNpcMotion[i] = (WK7NpcMotion *)0;
	}
	if( pTabelePtr == 0 ) return;


#pragma unused(motCodeId)
	u32 err;
	int	i;

	for (i=0; i<WK7MOTION_NPCCMN_NUM; i++){
		err = 0;
		if ( -1 == pTabelePtr[i] ){		// EndCode
			break;
		}
		if ( 0 == pTabelePtr[i] ){		// Continue			̃[V
			continue;
		}
		if ( 0 != pTabelePtr[i] ){
			if ( NULL == CreateMotion( (K7MOTID(chr_id,pTabelePtr[i])), i) ){
				err++;
			}
		}else{
			err++;
		}
		
		if ( err ){
			// [V݂Ȃꍇ
			mpNpcMotion[i] = (WK7NpcMotion *)0;
		}
	}
	last_mot_no = i;
	for ( ; i<WK7MOTION_NPCCMN_NUM; i++){
		mpNpcMotion[i] = (WK7NpcMotion *)0;
	}
}
#endif
K7EnmBoss::K7EnmBoss(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio, u32 _chr_id, s16 *_mot_tbl) 
  : WK7Enemy(enemyid,pAnchor,prio)
{
  chr_id = _chr_id;
  mot_tbl = _mot_tbl;
  last_mot_no = 0;
  common_state = 0;

  // fǂݍ
  CreateModel (K7CHRID(chr_id,suffix));
	
  // [Vǂݍ
  CreatePackMotion(mot_tbl, 0);
	
}
void K7EnmBoss::CopyPCPackMotion( u32 chr_id_ )
{
  ReleaseMotionAll();


  for ( int i=0; i<WK7MOTION_NPCCMN_NUM; i++){
	mpNpcMotion[i] = (WK7NpcMotion *)0;
  }
  
  u32 mainid = chr_id_;
  u32 err;
  s16 motid;
  
  //PCNPC̕A[Ve[u傫̂łł悢B
  for (int i=0; i<WK7MOTION_PCCMN_MAX; i++){
	err = 0;
	if( (motid=WK7PlayerControl::GetMotionID(mainid,(u32)i)) > 0 ){
	  if ( NULL == CreateMotion( K7MOTID(mainid,motid), i) ){
		err++;
	  }
	}else{
	  err++;
	}
  }
  last_mot_no = WK7MOTION_PCCMN_MAX;
}


K7EnmBoss::~K7EnmBoss()
{
}

WK7HitObjJObj *K7EnmBoss::CreateHitObj( char *name )
{
  WK7JObj *jobj = 0;
  WK7HitObjJObj	*hit_obj = 0;

  if( !mpNpcChara ) return 0;
  if( !(jobj = mpNpcChara->GetJObj(name)) ) return 0;
  u32	renderid = WK7RenderObj::GetUniqueRenderID(false,WK7RENDEROBJ_RENDERID_DEFAULT);
  //u32	renderid = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
  if( renderid==0xffffffff ) return 0;
  hit_obj = new WK7HitObjJObj();
  if( !hit_obj ) return 0;

  hit_obj->SetJObj(jobj);
  hit_obj->SetEnable(true);
  hit_obj->SetRenderID(renderid);
  jobj->SetDstAlpha(WK7RenderObj::ConvRenderIDToAlpha(renderid),false,false);
  return hit_obj;
}


/*
	
	_̃GtFNg\
	
*/
void K7EnmBoss::WeakPointEffectSet(char *pObjName)
{
	if( NULL != mpTargetParentJObj ){
		ReleaseWeakPoint();
	}
	
	if ( false == K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) ){
		
		WK7Model *pModel = mpNpcChara->GetModel();
		WK7JObj  *pBone;
		
		pBone  = pModel->GetObj(pObjName);
		CreateWeakPoint( pBone->GetJObj() );
	}
}



