////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmDE2.h
//
// Creator       : Kawa
// Creation Date : 10/06/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMDE2_H__
#define	__ENMDE2_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\Yam\YK7EffectHeader.h"
#include "..\Wat\WK7Model.h"
#include "..\Wat\WK7Stage.h"

class K7EnmDE2 : public K7EnmBoss{
protected:
	void		Dummy( void );
	u32			mInitProcess;				// ǂݍ݃Xe[^Xp
	WK7Model 	*mpGun[2];					// ef
	s16			mSecondShotTiming;			// Qڂ̃^C~O
	s16			mBulletNow;					// e
	
	u32			mBattleCount;				// og̎
	u32			mBattleProcess;				// og̊Ǘ
	int 		mBatteleExit;				// og̏I}
	
	u32			mMoveProcess;				// sp^[tO
	
	Vec			mStartPos;					// X^[gʒu̕ۑ
	f32			mSetRunDist;				// 点鋗
	u8			mFinalAtk;					// ŏIUtO
	
	void		PcDamageSet(int side);
	
	void		Cmd_ResetSet(void);
	void		Cmd_RunSet(f32 dist);
	bool		PcHitTest(void);
	
	bool		DE2_Run(void);
	bool 		DE2_ShotFree(void);
	bool 		DE2_Avoid(int side);
	bool 		DE2Status_Avoid(void);
	bool		DE2_ShotWait(void);
	bool 		DE2_ShotReload(void);
	bool 		DE2_Status_Reload(void);
	
	bool		DE2Status_ShotPose(void);
	
	void		DieMotSet(void);

	void		LogicSet(u32 process, u32 time=0);
	
	void		Release(void);
	void		DetachGun(void);
	
	f32 		RotRevision(void);
	int 		AvoidSideGet(void);
	int			AvoidSideTest(void);
	
public:
	K7EnmDE2(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	~K7EnmDE2();
	
	static	int	mDE2BattleStart;
	
	bool	FrameProcess(void);
	bool	ControlProcess(void);
	

	void	StageProc(WK7Stage *pCurrentStage);
	int		DE2BossEnd(void);
	bool 	DE2HitTest(Vec *pPos);
	void 	FinalAtkCall(void);
};


#ifdef	__ENMDE2_CPP__

//#define DE2_HP				(150)			// f|[go
#define DE2_GUN_BULLET_MAX			(6)					// e
#define DE2_GUN_DAMAGE_NORMAL		(30)				// ẽ_[W
#define DE2_GUN_DAMAGE_EASY			(10)				// ẽ_[W

#define GUN_R				GUN_COUGARF_R
#define GUN_L				GUN_COUGARF_L

#define RUN_SPEED			(1.2f)

#define DOOR_OPEN_FRAME		(WK7_SEC_TO_FRAME(5))

#define LOGIC_INIT			(0)
#define LOGIC_MOVE			(1)
#define LOGIC_WAIT			(2)

enum DE2_MOT{
	DE2_MOT_WAIT = 0,		// R
	DE2_MOT_RUN,			// 
	DE2_MOT_SHOTPOSE,		// ˌ\
	DE2_MOT_SHOTFREE,		// \[v
	DE2_MOT_SHOTNOW,		// ˌ
	DE2_MOT_SHOTWAIT,		// \߂
	DE2_MOT_DAM,			// _[W
	DE2_MOT_DIE,			// S
	DE2_MOT_NOTICE,			// Ct
	DE2_MOT_L_ROLL,			// ]
	DE2_MOT_R_ROLL,			// E]
	DE2_MOT_RELOAD,			// [h
	DE2_MOT_MAX
};

s16 MotionIDTableDE2[] = {
	20,	
	90,
	100,
	101,
	102,
	103,
	150,
	310,
	600,
	710,
	700,
	110,
	-1
};

#else


#endif




#endif	//__ENMDE2_H__

