////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmHNG.h
//
// Creator       : Kawa
// Creation Date : 05/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMHNG_H__
#define	__ENMHNG_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\Yam\YK7EffectHeader.h"
#include "..\Yam\YK7EffectRope.h"
#include "..\Wat\WK7Model.h"
#include "..\Wat\WK7Stage.h"

// wuX}Copf[^
typedef struct tagHNGSMOKE
{
	bool runflag ;
	s32 con, mod ;
	WK7Npc *hs ;
	EFFECT *smoke, *smoke2 ;
	u32 smokeid, smokeid2 ;
} HNGSMOKE ;

class K7EnmHNG : public K7EnmBoss{
protected:
	void		Dummy( void );
	u32			mInitProcess;				// ǂݍ݃Xe[^Xp
	WK7Model 	*mpGun;						// ef
	s16			mBulletNow;					// e
	s16			mShotNum;					// VbgJEgp
	
	EFFECT		*Rope ;						// [vGtFNg
	u32			RopeID ;					// [vGtFNĝhc
	
	EFFECT		*Muzzle ;					// }YtbṼGtFNg̃|C^
	s32			MuzzleID ;					// }YtbṼGtFNĝhc
	
	s32 		con, con2, mod ;			// ėpJE^

	s32			popupHSnum ;				// ogr̐
	HNGSMOKE	popupHS[7] ;				// gr|bvAbv̏pf[^
	
	s16 		mShotWait ;					// ܂ł̑҂
	s16			mShotCounter ;				// ẴJE^
	bool		mShotFlag ;					// VbgԂɓĂ邩̃tO
	bool		mShotFireFlag ;				// VbgstO
	bool		mShotActionFlag ;			// Vbĝsǂ̃tO
	
	bool		mZubonFlag ;				// Y{EĂ邩tO
	bool		mZubonNugeFlag ;			// Y{EsĂ邩AtO
	bool		mZubonKisimiSoundFlag ;		// Y{Ea݃TEh炵tO
	
	s32			mYurePower ;				// hp[( 0:hĂȂ  1:hꏬ  2:hꒆ  3:h )
	u32			BodyMotionID ;				// ̂ɓKĂ郂[V̂hc
	
	u32			mBattleCount;				// og̎
	u32			mBattleProcess;				// og̊Ǘ
	int 		mBatteleExit;				// og̏I}
	bool		mBattleStart ;				// ogJn}
	
	bool		mGunOtosiFlag ;				// e𗎂ƂAtO
	bool		mBarrierFlag ;				// oAtO
	bool		mNewGunFlag ;				// VetO
	
	s32			KisimiSoundID ;				// aމhc
	
	void		Release(void);
	void		DetachGun(void);

	inline	void popHSRun( s32 id ){ popupHS[id].runflag = true ; }
	void		popHSInit( s32 id ) ;
	void		popHSFrame( s32 id ) ;
	void		popHSEnd( s32 id ) ;
	bool		CheckpopUpRunFlag( void ) ;		// true:ǂꂩo  false:ĂȂ )
	
	WK7JObj		*GetCoreJObj( void ) ;		//  core JObj 擾
	WK7JObj		*GetYureJObj( void ) ;		//  Root JObj 擾
	bool		PlayHNGYureMotion( u32 YurePower, s32 HitPos = -1, bool loop = true ) ;	// hꃂ[VĐ
	bool		PlayHNGBodyMotion( u32 id, bool loop, bool hokan, f32 sframe = 0.0F, f32 speed = 1.0F ) ;	// [gȉ̕ɂ̂ݎw̃[V𗬂
	void		ShotInit( void ) ;			// e
	void		ShotReset( void ) ;			// eԂȂƂɂ
	void		ShotFrame( void ) ;			// e̃t[vZX
	
	void		KisimiSoundFrame( void ) ;	// aމ̃t[vZX
	s8			GetYureDir( void ) ;		// ݂̗hꃂ[V̕𓾂( -1:  1:E )
	s8			GetHitPos( void ) ;			// ꂽ𓾂( -1:g  1:Eg  0:S )
	void		PlaySE( u32 id ) ;			// Đ
	void		VisibleReflesh( void ) ;	// \ԂXV

public:
	K7EnmHNG(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	~K7EnmHNG();
	
	static	int	mHNGBattleStart;
	
	inline 	void SetNewGunFlag( void ){ mNewGunFlag = true ; }
			void BattleStart( void ) ;
	inline 	bool GetGunOtosiState( void ){ return mGunOtosiFlag ; }
	inline 	void SetBarrierFlag( bool flag ){ mBarrierFlag = flag ; }
	inline 	bool GetBarrierFlag( void ){ return mBarrierFlag ; }
	
	bool	FrameProcess(void);
	bool	ControlProcess(void);

	void	StageProc(WK7Stage *pCurrentStage);
	int		HNGBossEnd(void);
};


#ifdef	__ENMHNG_CPP__

//#define HNG_HP				(150)			// f|[go
#define HNG_GUN_BULLET_MAX	(12*2)			// e
#define HNG_GUN_DAMAGE		(10)			// e

#define GUN_R				GUN_SWM29MB_R

#define RUN_SPEED			(1.2f)

#define DOOR_OPEN_FRAME		(WK7_SEC_TO_FRAME(5))

enum HNG_MOT{
	HNG_MOT_WAIT = 0,		// R
	HNG_MOT_SHOTNOW,		// ˌ
	HNG_MOT_DAM,			// _[W
	HNG_MOT_YURE_S,			// h()
	HNG_MOT_YURE_M,			// h()
	HNG_MOT_YURE_L,			// h()
	HNG_MOT_YURE_STOP,		// h(Xgbv)
	HNG_MOT_NUGE,			// Y{E
	HNG_MOT_MAX
};

s16 MotionIDTableHNG[] = {
	20,	
	100,
	150,
	200,
	210,
	220,
	310,
	900,
	-1
};



#else


#endif




#endif	//__ENMHNG_H__

