////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmJ.cpp			gr
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//

/*               K7ENM_SU                  */


////////////////////////////////////////////////////////////////////////////////

#define	__ENMK_CPP__

#include "EnmK.h"
#include "..\Yam\YK7EffectHSDead.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Kaw\KK7Util.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Yam\YK7EffectFlashBom.h"
#include "..\Wat\WK7EventScript.h"
#include "..\Wat\K7GlobalFlag.h"

#define MDLCODE_ID				(18)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(18)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeKMotionIdTable[WK7MOTION_NPCCMN_NUM+1] = {
	20,						// R
	0,						// 
	0,						// 
	0,						// ^[E
	0,						// ^[
	0,						// ^[
	0,						// UĂѓiNu쓮j
	0,						// 85cmɍU
	0,						// 150cmɍU
	0,						// _[WO
	0,						// _[W
	0,						// _[WO
	0,						// _[W
	0,						// _[WEO
	0,						// _[WE
	0,						// _[WO
	0,						// _[W
	0,						// _[WEgO
	0,						// _[WEg
	0,						// _[WgO
	0,						// _[Wg
	0,						// _[WӂƂу_EOiSj
	0,						// _[Wу_EiSj
	0,						// _[WE _E
	0,						// _[W _E
	0,						// _ER
	0,						// _E_[W
	0,						// _EȂ
	0,						// _EȂ瑖
	0,						// _E玀S
	0,						// _E85cmɍU
	0,						// _E150cmɍU
	0,						// [U[ōU
	0,						// [U[gro
	0,						// [U[grB
	0,						// ꎩR̂̂QiXs[hpj
	0,						// Xs[hX}CsJn
	0,						// Xs[hX}C
	0,						// ݍUi_j
	0,						// ݍUiRj
	0,						// ݍUiJGfj
	0,						// ݍUiR[ej
	0,						// ݍUi}XNj
	0,						// ݍUiPrj
	0,						// iAiU[X}CpjV䒣tҋ@
	0,						// iAiU[X}CpjVA
	0,						// iAiU[X}CpjVA
	0,						// iAiU[X}CpjVA
	0,						// iAiU[X}CpjVA󒆗R
	0,						// iAiU[X}CpjVA󒆗`nA͂
	0,						// _[WE]
	0,						// _[W]
	0,						// p[cAj[Vp
	0,						// ]rpNオO
	0,						// ]rpNオ
	-1
};

s16 npcTypeKHakiMotionIdTable[] = {
	30,						// f
	0,						// f
	0,						// R
	0,						// ]
	-1
};

char *pNameSuWeakObj[] = {
	"E18_hit0",
	"E18_hit1",
	"E18_hit2",
	"E18_hit3",
	"E18_hit4",
	"E18_hit5",
	"E18_hit6",
};

#define HARD_CORENAME0	"E18_hit3"
#define HARD_CORENAME1	"E18_hit5"

#define E18_HITOBJ_START	(6)					// UԂ肩͂߂΁AXe[WƏdȂȂƎv

K7EnmK::K7EnmK(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	u32 setSuffix = suffix;
	int i;

	// fǂݍ
	mEasySu = 0;
	if ( true == K7SCR_GET_GLOBAL_FLAG( K7GLFL_EASY_MODE) ){
		mEasySu = 1;
		setSuffix+=10;
	}
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  setSuffix));
	
	// [Vǂݍ݁isuffixɂāAǂݍރ[VςiꏊႤjj
	CreatePackMotion(npcTypeKMotionIdTable,		MOTCODE_ID);
	CreatePackMotion(npcTypeKHakiMotionIdTable, MOTCODE_ID,	WK7MOTION_NPCCMN_STD_NUM);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;								// _ij
	mData.mVLossID		= -1;								// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= -1;
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 1;
	mData.mTypeEggOya	= 1;
	mData.mNoMove		= true;								// ړȂ
	
	mCoreType = E18_CORE_SIMPLE;
	for(i=0; i<E18_CORE_MAX; i++){
		coreDead[i] = 0;
	}
	mCoreNum = 0;

}

/*
	
	
	p_[hc̊蓖
	
	
*/
void K7EnmK::PartsRenderIDSet(void)
{
	mCoreType = E18_CORE_PLURAL;
}

#if 0
// P
void K7EnmK::PartsRenderIDSet_Simple(char *pWeakName)
{
	u32 renderidex;
	WK7Model *pModel = pCurrentChara()->GetModel();
	
	renderidex = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	pCurrentChara()->SetRenderIDEx(renderidex);
	
	// ʂJOBJƂĂ
	if ( pModel != NULL ){
		WK7JObj *pJOBJ;
		pJOBJ   = pModel->GetObj(pWeakName);					// IuWF񂷂̂ǂ
		if ( pJOBJ != NULL ){
//			pCurrentChara()->SetRenderIDEx(pJOBJ,false,true);		// ݂ɂȂł̂OKȏꍇ
			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂ȏꍇ
		}
	}
}
#endif

// 
/*
	
	
	Xe[W̌Ăяo悤
	
	
*/
void K7EnmK::HitObjMake(WK7Stage *pCurrentStage, int CoreNum)
{
	WK7Model *pModel;
	WK7JObj  *pJObj;
	int i;

	for (i=0; i<CoreNum; i++){
		if ( (pModel = pCurrentChara()->GetModel()) != NULL ){
			pJObj = pModel->GetObj(pNameSuWeakObj[i]);
			if ( pJObj != NULL ) {
				pCurrentStage->SetHitObj(pJObj, (u32 )(i+E18_HITOBJ_START));
			}
		}
	}
	mCoreNum = (s16 )CoreNum;
}
u32 K7EnmK::GetHitObjID(void)
{
	return E18_HITOBJ_START;
}


/*
	
	
	pʌ
	
	
	
*/
bool K7EnmK::CoreHit(int inID, WK7HitObjInfoType hitType, Vec hitPos)
{
	WK7Model *pModel;
	WK7JObj  *pJObj;
	Vec myPos;
	int id = inID - E18_HITOBJ_START;

	pCurrentChara()->GetPosition(myPos);
	if ( (pModel = pCurrentChara()->GetModel()) != NULL ){
		pJObj = pModel->GetObj(pNameSuWeakObj[id]);
		if ( pJObj != NULL ) {
			// qbgnjI i[Voj
			if ( false == SuDmgProc(id, WK7PLAYERCONTROL->GetGunDamage(hitType), pJObj, hitType, hitPos) ){
				return false;
			}
			return true;
		}
	}
	return false;
}

//WK7PcShotMode K7EnmK::GetShotType(WK7HitObjInfoType hitType)
//{
//	WK7PcShotMode setEnum = SHOTMODE_NORMALSHOT;
//
//	switch (hitType){
//	default:
//	case WK7HITOBJINFO_TYPE_NORMALSHOT:		// ʏ̂
//		setEnum = SHOTMODE_NORMALSHOT;
//		break;
//	case WK7HITOBJINFO_TYPE_DANCHARGE:		// _\
//		setEnum = SHOTMODE_DANSPATK;
//		break;
//	case WK7HITOBJINFO_TYPE_KVNCHARGE:		// Pr^E`
//		setEnum = SHOTMODE_KVNTAMEUCHI;
//		break;
//	case WK7HITOBJINFO_TYPE_CYOMAGNUM:		// R[e}Oi
//		setEnum = SHOTMODE_CYOMAGNUM;
//		break;
//	case WK7HITOBJINFO_TYPE_GALPOWER:		// KVAp[Abv̒e
//		setEnum = SHOTMODE_GALPOWER;
//		break;
//	case WK7HITOBJINFO_TYPE_DANPOWER:		// _ep[Abv̒e
//		setEnum = SHOTMODE_DANPOWER;
//		break;
//	case WK7HITOBJINFO_TYPE_GRENADE_FIRE:	// }XNOl[h
//		setEnum = SHOTMODE_GRENADE_FIRE;
//		break;
//	case WK7HITOBJINFO_TYPE_GRENADE_THUND:	// }XNd
//		setEnum = SHOTMODE_GRENADE_THUND;
//		break;
//	case WK7HITOBJINFO_TYPE_GRENADE_GRAVI:	// }XNk
//		setEnum = SHOTMODE_GRENADE_GRAVI;
//		break;
//	case WK7HITOBJINFO_TYPE_KVNCHARGEALL:	// PrOʃVbg
//		setEnum = SHOTMODE_KVNCHARGEALL;
//		break;
//	case WK7HITOBJINFO_TYPE_MSKCHARGEALL:	// }XNSʃVbg
//		setEnum = SHOTMODE_MSKCHARGEALL;
//		break;
//	}
//	
//	return setEnum;
//}



/*
	
	
	p _[WvZX
	_[W[VZbg
	
	RRɂ̓RAɂĔłĂ
	
	<return>
	false			s
	true			
	
*/
bool K7EnmK::SuDmgProc(int id, s16 damPoint, WK7JObj *pJObj, WK7HitObjInfoType hitType, Vec hitPos)
{
	s16	bloodefc;
	s16 setFireFrame = -1;
//	Vec corePos;
	bool easyCore = true;
	WK7JObj *pJObjTmp;
	WK7Model *pModel;

	bloodefc = 1;
	mBurn = mThund = mGravi = 0;
	Vec pcRot;
	f32 pcRotY;
	
	// qbgȂU
	if ((hitType == WK7HITOBJINFO_TYPE_GRENADE_FIRE)
	||	(hitType == WK7HITOBJINFO_TYPE_GRENADE_THUND)
	||	(hitType == WK7HITOBJINFO_TYPE_GRENADE_GRAVI)
	||	(hitType == WK7HITOBJINFO_TYPE_MSKCHARGEALL)
	){
		// Ol[hn͓Ȃ
		return false;
	}
	
	
	// XLꂽH
	if ((DAMTYPE_GALPOWER != (mDamage.mDamType))
	&&	(false == ScanHitTest())
	){
		// XL
		return false;
	}
	
	// goOHi}XÑt@CiT[JXŊO莀񂾁j
	if ( mData.mHp == 0 ) return false;
	
	// _[Wʒuo
//	pJObj->GetWorldPosition(&corePos);
	
	// C[W[[h̏ꍇ̔f
	if ( mEasySu ){
		if ( (pModel = pCurrentChara()->GetModel()) != NULL ){
			if ( (pJObjTmp=pModel->GetObj(HARD_CORENAME0)) != NULL ) {
				if ( pJObjTmp == pJObj ) easyCore = false;
			}
			if ( (pJObjTmp=pModel->GetObj(HARD_CORENAME1)) != NULL ) {
				if ( pJObjTmp == pJObj ) easyCore = false;
			}
		}
	}else{
		easyCore = false;
	}
	
	if ((WK7HITOBJINFO_TYPE_DANCHARGE == hitType)			// _Aê
	||	(WK7HITOBJINFO_TYPE_GALPOWER  == hitType)			// KVp[
	||	(easyCore == true)									// C[W[[h̃RA
	){
		// qbgOK
		// _[W̃|Cg₷
		if ( easyCore == true ){
			damPoint *= 10;
			if ( damPoint > 10000 )	damPoint = 10000;
			if ( damPoint < 0 )		damPoint = 10000;
		}
		mData.mHp -= damPoint;
	}else{
		// qbg|Cg炷iWXg
		damPoint /= 10;
		if (damPoint <= 0) damPoint = 1;
		mData.mHp -= damPoint;
	}
	
	if ( (mData.mHp) <= 0 ){
		// 
		mData.mHp = 0;
	}
	
	// RGtFNgJn
#if 0
//		setFireFrame = WK7_SEC_TO_FRAME(2);
//		switch (hitType){
//		case WK7HITOBJINFO_TYPE_GRENADE_FIRE:
//		case WK7HITOBJINFO_TYPE_MSKCHARGEALL:
//			mBurn = 1;
//			DmgFireEffectStart(setFireFrame, pJObj);
//			break;
//		case WK7HITOBJINFO_TYPE_GRENADE_THUND:
//			mThund = 1;
//			DmgThundEffectStart(setFireFrame, pJObj);
//			break;
//		case WK7HITOBJINFO_TYPE_GRENADE_GRAVI:
//			mGravi = 1;
//			DmgGraviEffectStart(setFireFrame, pJObj);
//			break;
//		}
#endif
	
	// _[W̃Xs[hύX
	DmgSpeedSet(1.f);
	
	// _[Wo
	WK7PLAYERCONTROL->GetRotY(&pcRotY);
	pcRot.x = 0.f;
	pcRot.y = pcRotY;
	pcRot.z = 0.f;
	
	//
	// RAj
	// ꌂ
	// NeBJ
	//
	if ( 0 == (mData.mHp) ){
		
		ComboMessagePlay(1);
		
		{
			GXColor color;
			
			color.r = (u8)0xf0;
			color.g = (u8)0xf0;
			color.b = (u8)0xff;
			color.a = (u8)250;
			SetHSDeadEffectColor( color, color );			// ɍ쐬wuX}CSGtFNg̐Fݒ肷
			
			// grSGtFNg
			{
															// Ƃ̂rd
				Vec enePos;
				int seNo;
				
				pCurrentChara()->GetPosition(enePos);
				seNo = gpSound->mPlaySE3D( waraiDeathSeTbl[rand()%SFX_BT_HS_DEATH_MAX], enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );
				SePitchChange(seNo);
			}
			
			KK7BattleEffectDead(	GetYukaY(),				// RAgU
									pcRot,
									pJObj,
									0,
									mEfcBoodMode,
									mEfcBoodPoint,
									BLOODTEX_BLOOD,
									20
			);
		}
		
		bloodefc = 0;
		
		// ʗh炷
		pBattleMain->BattleCamera.CameraShakeCountSet(1);	// Jh炷
		
		// ʖȂ
		coreDead[id] = 1;
		
		// Aʂǂ̃eXg
		DieTest(&hitPos);
		
		return true;
	}
	
	if ( bloodefc ){
		BloodEfcCall(hitPos, pcRot, hitPos, damPoint, pJObj);
	}
	
	return false;
}


/*
	
	
	\
	
	
*/
void K7EnmK::VisibleTestDisp(void)
{
	WK7Model *pModel;
	WK7JObj  *pJObj;
	s16 i;
	if( (pModel = pCurrentChara()->GetModel())!=NULL ){
		pModel->Disp();
		// ł镔ʂ͏
		for (i=0; i<mCoreNum; i++){
			if ( 1 == coreDead[i] ){
				pJObj = pModel->GetObj(pNameSuWeakObj[i]);
				if ( pJObj != NULL ) {
					pJObj->Hide(false, false);
				}
			}
		}
	}
}

/*
	
	
	ASłǂeXg
	
	
*/
bool K7EnmK::DieTest(Vec *pCorePos)
{
	int i, ok;

	for (i=0, ok=0; i<mCoreNum; i++){
		if ( 1 == coreDead[i] ){
			ok++;
		}
	}
	
	if ( ok == mCoreNum ){
		
#define SU_CORE_HOSEI_ZDIST		(-5.f)
		Vec newCorePos = *pCorePos;
		f32 myRotY = GetRotY();
		
		// ̏o|WViɈ߂j
		newCorePos.x += SU_CORE_HOSEI_ZDIST * sinf(myRotY);
		newCorePos.z += SU_CORE_HOSEI_ZDIST * cosf(myRotY);
		
		//@ S
		
		// ^C~O
		mDamage.mDamDieCount = 120;
		
		// tbVjGtFNgo
		CreateFlashBomEffect( newCorePos, (s32 )mDamage.mDamDieCount );
		gpSound->mPlaySE3D( SFX_BT_HS_SUFLASH, newCorePos, 1, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );
		
		SetNoPause();									// ̉õ͎|[Y֎~ɂ
		SetEnemyDieInfo(NPC_DIE_DIE);
		mState = NPC_STATE_DIE;
		return true;
	}else{
		// HP߂
		mData.mHp = mData.mHpBk;
	}
	return false;
}

/*
	
	
	S
	
	<return>
	true	VK[VZbgꂽ
	false	[V̂܂
	
*/
bool K7EnmK::MotStatus_Die(void)
{
	bool dieEnd = false;

	if ( mDamage.mDamDieCount > 0 ){
		// ĂJE^[ƂĎg
		mDamage.mDamDieCount--;
		if ( 0 >= mDamage.mDamDieCount ){
			
			// ASIIIIIIIII
			
			// Rg[[h炷
			KK7PadRumble(0, 60);
			
			//HS HS̑j
			gpSound->mPlaySE( SFX_BT_HSNEST_BREAK, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackBattleOverlap, eSEGroupBattle00Env );
			SetVisible(false);
			
			dieEnd = true;
		}
	}
	
	if ( true == dieEnd ){
		MotSet_Loss();
		ResetNoPause();									// |[Y֎~
//		SetEnemyDieInfo(NPC_DIE_DIE);					// 񂾏Zbg (̓ZbgĂ̂OK C
		return true;
	}
	
	return false;
}

/*
	
	
	̓ȃ_[Wȕ
	
	<return>
	true			
	false			ʏ폈OK
	
*/
bool K7EnmK::GetNoDamage(void)
{
	if ( mDamage.mDamType == DAMTYPE_GRENADE_FINAL ){
		// t@CiT[JXʏ_[Wŋ炤
		return false;
	}
	return true;
}



