////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// Enmang.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMKIB_CPP__

#include "EnmKIB.h"

s16 MotionIDTableKIB[] = {
	20,							// R
	100,							// U
	150,							// lN^CɂB
	310,						// lN^CSB
	600,						// lN^CiAj
	0,						// ^[
	0,							// UĂѓiNu쓮j
	0,						// 85cmɍU
	0,						// 150cmɍU
	0,						// _[WO
	0,						// _[W
	0,						// _[WO
	0,						// _[W
	0,						// _[WEO
	0,						// _[WE
	0,						// _[WO
	0,						// _[W
	0,						// _[WEgO
	0,						// _[WEg
	0,						// _[WgO
	0,						// _[Wg
	0,						// _[WӂƂу_EOiSj
	0,						// _[Wу_EiSj
	0,						// _[WE _E
	0,						// _[W _E
	0,						// _ER
	0,						// _E_[W
	0,						// _EȂ
	0,						// _EȂ瑖
	0,						// _E85cmɍU
	0,						// _E150cmɍU
	-1
};

K7EnmKIB *K7EnmKIB::instance = 0;

bool K7EnmKIB::IsMyRenderID( u32 id , Vec *)
{
  if( !brain_hit_obj ) return false;
  if( brain_hit_obj->GetRenderID() == id ) return true;
  if( !debri_hit_obj ) return false;
  if( debri_hit_obj->GetRenderID() == id ) return true;

  return false;
}
K7EnmKIB *K7EnmKIB::GetInstance( void )
{
  return instance;
}
void K7EnmKIB::Dummy( void )
{
}
static GHMGCTASK_HANDLER( HitTask );
static GHMGCTASK_HANDLER( HitTask )
{
  bool *flg = (bool*)task_get_param(0);
  *flg = true;
  task_exit();
}

K7EnmKIB::K7EnmKIB(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7KIB, MotionIDTableKIB )
{
  // Gʂ̃f[^̃Zbg
//  mData.mHp			= KIB_HP;								// go
  mData.mWeakID		= NPCWEAKOBJID_HEAD;				// _
  mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  head_jobj = 0;
  instance = this;
  atk_counter = 320;
  brain_hit_obj = debri_hit_obj = 0;
  brain_hit = debri_hit = false;
}
K7EnmKIB::~K7EnmKIB()
{
  GHM_SAFE_DELETE( brain_hit_obj );
  GHM_SAFE_DELETE( debri_hit_obj );
}
s32 K7EnmKIB::AtkWait( void )
{
  atk_counter -= HSD_Rand()%4;
  if( atk_counter < 0 ) atk_counter = 0;
  return atk_counter;
}
bool K7EnmKIB::IsHit( void )
{
  u32 frm = (u32)(mpRootBone->GetCurrentMotionFrame());
  if( frm > (33*2) && frm < (90*2) ){
	return brain_hit;
  }else{
	return false;
  }
}

bool K7EnmKIB::ControlProcess(void)
{
	if( mState==NPC_STATE_INIT ){ return WK7Npc::ControlProcess(); }
	if( GetNpcPause()==true ){ return true; }
	return false;
}
bool K7EnmKIB::FrameProcess(void)
{
  //if( mState==NPC_STATE_INIT ){ return WK7Npc::ControlProcess(); }
  //if( GetNpcPause()==true ){ return true; }
	
	MotionProcess();
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  // [VXs[hRg[
	  //MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){
		mFirstPosSet = 1;
		mpNpcChara->SetPosition(mPosition);
		WK7Model *pModel;
		if( (pModel = mpNpcChara->GetModel())!=NULL ){
		  mpNpcChara->SetRenderFlag(true);
		  pModel->Disp();
		}
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  //mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  //mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}
		debri_jobj = mpNpcChara->GetJObj("Bullet")->GetJObj();
		head_jobj = mpNpcChara->GetJObj("Neck_joint")->GetJObj();
		brain_hit_obj = CreateHitObj( "KIB_Brain" );
		brain_hit_obj->SetTaskHandler(HitTask);
		brain_hit_obj->SetTaskParam(0,(u32)&brain_hit);
		debri_hit_obj = CreateHitObj( "Bullet" );
		debri_hit_obj->SetTaskHandler(HitTask);
		debri_hit_obj->SetTaskParam(0,(u32)&debri_hit);
	  }
	}
  }
	
  return true;
}
