////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// Enmang.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMKRR_CPP__

#include "..\Matsu\mK7Sound.h"
#include "EnmKRR.h"
#include "EnmKIB.h"
#include "..\Wat\K7GlobalFlag.h"
#include "..\Wat\WK7EventScript.h"

s16 MotionIDTableKRR[] = {
	20,							// R
	100,						// U
	151,						// lN^C(QjɂB
	311,						// lN^C(QjSB
	310,						// lN^CiAj
	320,						// KIB̂ƓɍĐB
	600,						// Q
	321,						// lN^Cqbg
	322,						// lN^CT̃[vB
	323,						// lN^CIB
	0,						// _[W
	0,						// _[WO
	0,						// _[W
	0,						// _[WEO
	0,						// _[WE
	0,						// _[WO
	0,						// _[W
	0,						// _[WEgO
	0,						// _[WEg
	0,						// _[WgO
	0,						// _[Wg
	0,						// _[WӂƂу_EOiSj
	0,						// _[Wу_EiSj
	0,						// _[WE _E
	0,						// _[W _E
	0,						// _ER
	0,						// _E_[W
	0,						// _EȂ
	0,						// _EȂ瑖
	0,						// _E85cmɍU
	0,						// _E150cmɍU
	-1
};

KRR_KIB_PARAM gGameParams[MAX_GAME_LEVEL] ={
  //҂,	炵,		e,	ȇA	ȅCl
  {560,		0.6f,		1,1,	0.17f,0.2f,	0.008f},	//level1
  {560,		0.7f,		2,1,	0.25f,0.2f,	0.01f},		//level2
  {256,		0.5f,		4,1,	0.3f, 0.3f,	0.02f},		//level3
  {256,		0.7f,		5,1,	0.35f,0.3f,	0.03f}		//level4
};

KRR_KIB_PARAM gGameParamsEasy[MAX_GAME_LEVEL] ={
  //҂,	炵,		e,	ȇA	ȅCl
  {600,		0.6f,		1,1,	0.17f,0.2f,	0.008f},	//level1
  {600,		0.7f,		2,1,	0.25f,0.2f,	0.01f},		//level2
  {400,		0.5f,		3,1,	0.3f, 0.3f,	0.015f},	//level3
  {400,		0.7f,		3,1,	0.35f,0.3f,	0.02f}		//level4
};

void K7EnmKRR::Dummy( void )
{
}

K7EnmKRR *K7EnmKRR::instance = 0;
C_Vec K7EnmKRR::last_hit_pos;
bool K7EnmKRR::IsMyRenderID( u32 id, Vec *p )
{
  if( p ) last_hit_pos.Set( p->x, p->y, p->z );
  if( tie_hit_obj && tie_hit_obj->GetRenderID() == id ) return true;
  if( brain_hit_obj && brain_hit_obj->GetRenderID() == id ) return true;
  if( debri_hit_obj && debri_hit_obj->GetRenderID() == id ) return true;

  return false;
}
K7EnmKRR::K7EnmKRR(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7KRR, MotionIDTableKRR )
{
  // Gʂ̃f[^̃Zbg
//  mData.mHp = KRR_HP; // go
  mData.mWeakID		= NPCWEAKOBJID_HEAD;				// _
  mData.mVLossID	= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  mot_id = KIB_KRR_MOT_NEUTRAL;
  WK7RenderObj::SetVfxFlag( false );
  head_jobj = 0;
  tie_counter = 0;
  common_state.Init( KIB_KRR_COMMON_ATK0 );
  tie_hit_obj = brain_hit_obj = debri_hit_obj = 0;
  tie_hit = brain_hit = debri_hit = false;
  instance = this;
  head_jobj = debri_jobj = 0;
  for( int i=0; i<MAX_DEBRI; i++ ) debri[i] = 0;
  for( int i=0; i<MAX_GEN; i++ ) gen[i] = 0;
  //KIBlN^CɋCÂ܂ł̎ԁB
  //ꂪƁAKIBł̂͑B
//  tie_wait = 120;
  //lN^Cւ̂ȂYɌ邽߂ɁA[Ṽ[vJEg(180)Pʂő₷ƂɂB
  tie_wait = 120;
  game_level = 0;
	if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
  		param = &gGameParamsEasy[game_level];
  	}else{
  		param = &gGameParams[game_level];
	}
  atk_counter = 320;
  weap_counter = param->atk_wait;
}

K7EnmKRR::~K7EnmKRR()
{
  //WK7RenderObj::GetVFX()->SetTargetAlpha( -1 );
  //WK7RenderObj::VFXSetIntensity( 0.1f );		  
  WK7RenderObj::SetVfxFlag( true );
  instance = 0;
  for( int i=0; i<MAX_DEBRI; i++ ) {
	if( debri[i] ) delete debri[i];
  }
  for( int i=0; i<MAX_GEN; i++ ) {
	if( gen[i] ) delete gen[i];
  }
  GHM_SAFE_DELETE( tie_hit_obj );
  GHM_SAFE_DELETE( brain_hit_obj );
  GHM_SAFE_DELETE( debri_hit_obj );
}
bool K7EnmKRR::IsHit( void )
{
  u32 frm = (u32)(mpRootBone->GetCurrentMotionFrame());
  if( frm > (33*2) && frm < (90*2) ){
	return brain_hit;
  }else{
	return false;
  }
}

static GHMGCTASK_HANDLER( HitTask );
static GHMGCTASK_HANDLER( HitTask )
{
  bool *flg = (bool*)task_get_param(0);
  *flg = true;
  task_exit();
}

bool K7EnmKRR::IsHitTie( void )
{
  return tie_hit;
}

s32 K7EnmKRR::AtkWait( void )
{
  atk_counter -= (HSD_Rand()%4);
  if( atk_counter < 0 ) atk_counter = 0;
  return atk_counter;
}
s32 K7EnmKRR::WeapWait( void )
{
  weap_counter -= (HSD_Rand()%4);
  if( weap_counter < 0 ) weap_counter = 0;
  return weap_counter;
}
s32 K7EnmKRR::GetDebriNum( void )
{
  s32 num = 0;
  for( int i=0; i<MAX_DEBRI; i++ )	if( debri[i]!=0 ) num++;
  return num;
}
bool K7EnmKRR::ControlProcess(void)
{
#define MOTION_END( X ) ((X)->GetCommonMotionState() == WK7MODEL_NOANIM)
#define MOTION_REWIND( X ) ((X)->GetCommonMotionState() == AOBJ_ANIM_REWINDED)
#define IS_MOTION( X, Y ) ((X)->mot_id == Y)
#define PLAY( X, Y ) (X)->PlayCommonMotion( (X)->mot_id = Y, false, false )
#define PLAY_INTRP( X, Y ) (X)->PlayCommonMotion( (X)->mot_id = Y, false, true )
#define PLAY_LOOP( X, Y ) (X)->PlayCommonMotion( (X)->mot_id = Y, true, false )
#define PLAY_LOOP_INTRP( X, Y ) (X)->PlayCommonMotion( (X)->mot_id = Y, true, true )
#define PERCENT( X ) ((HSD_Rand()%101) > (100-X) )
  //낤܂ŉȂB
  K7EnmKRR *krr = this;
  K7EnmKIB *kib = K7EnmKIB::GetInstance();
  if( !kib ) return false;
	if( mState==NPC_STATE_INIT ){ return WK7Npc::ControlProcess(); }
	if( GetNpcPause()==true ){ return true; }

  if ( krr->mpNpcChara==NULL ) return true;
  if ( kib->mpNpcChara==NULL ) return true;
  if ( krr->mState == NPC_STATE_INIT ){ krr->StateInit();}
  if ( kib->mState == NPC_STATE_INIT ){ kib->StateInit();}
  //ʃXe[^X̌ɕKvKIB,KRR̃f[^擾B
  class KIBKRR{
  public:
	KIBKRR( void ){ hit = false; hp = 0; frm = -1; }
	bool hit;
	s16 hp;
	s16 frm;
  };
  KIBKRR kib_state,krr_state;
  //qbg
  krr_state.hit = (krr->tie_hit || krr->brain_hit ) ? true : false;
  kib_state.hit = kib->brain_hit;
  //HP
  krr_state.hp = krr->mData.mHp;
  kib_state.hp = kib->mData.mHp;
  //t[
  if ( krr->mpRootBone && kib->mpRootBone ){
	krr_state.frm = (s16)(krr->mpRootBone->GetCurrentMotionFrame());
	kib_state.frm = (s16)(kib->mpRootBone->GetCurrentMotionFrame());
  }
  
  //|CgςɕύX
#if 1
	if ( mDamage.mDamHitRequest ){
		mDamage.mDamHitRequest = 0;
	}
#else
  kib->mDamage.mDamPoint = 10;
  krr->mDamage.mDamPoint = 10;
#endif

  //Q[̃p[^B
	if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
  		param = &gGameParamsEasy[game_level];
  	}else{
  		param = &gGameParams[game_level];
	}

  //ʃXe[^XB
  do{
	switch( (s32)common_state ){
	case KIB_KRR_COMMON_ATK0:
	  {//KIB,KRRƂɌ݂ōUB
		switch( common_state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY_LOOP( kib, KIB_KRR_MOT_NEUTRAL );
		  PLAY_LOOP( krr, KIB_KRR_MOT_NEUTRAL );
		}break;
		case PHASE_PROC:{
		  if( tie_counter ){
			tie_counter++;
			if( IS_MOTION( krr, KIB_KRR_MOT_TIE_LOOP ) &&
				IS_MOTION( kib, KIB_KRR_MOT_NEUTRAL ) && tie_counter > tie_wait ){
			  //jhaCÂ𒲐߂ƓՓxRg[łB
			  common_state = KIB_KRR_COMMON_TIE;
			}
		  }else if( IS_MOTION( krr, KIB_KRR_MOT_NEUTRAL ) && krr_state.hit && IsHitTie() ){
			tie_counter = 1;
			PLAY( krr, KIB_KRR_MOT_TIE_HIT );
		  }
		  //KRR
		  bool atk_flg = GetDebriNum() ? false : true;
		  if( GetDebriNum()>3 ){
		  }else{
			if( IS_MOTION( krr, KIB_KRR_MOT_NEUTRAL ) && !tie_counter ){
			  if( !(krr->AtkWait()) ) PLAY( krr, KIB_KRR_MOT_ATK );
			  if( atk_flg && krr_state.frm >= 2 ) krr->atk_counter = 0;
			}else if( IS_MOTION( krr, KIB_KRR_MOT_ATK )){
			  if( MOTION_END( krr ) ){
				PLAY_LOOP( krr, KIB_KRR_MOT_NEUTRAL );
				krr->atk_counter = param->atk_wait;
			  }else if( krr_state.frm == (80) ) krr->GenDebri(param->krr_num,0);
			}else if( IS_MOTION( krr, KIB_KRR_MOT_TIE_HIT ) && MOTION_END( krr ) ){
			  PLAY_LOOP_INTRP( krr, KIB_KRR_MOT_TIE_LOOP );
			}
			//KIB
			if( IS_MOTION( kib, KIB_KRR_MOT_NEUTRAL ) ){
			  if( !(kib->AtkWait()) ) PLAY( kib, KIB_KRR_MOT_ATK );
			  if( atk_flg && kib_state.frm >= 2 ) kib->atk_counter = 0;
			}else if( IS_MOTION( kib, KIB_KRR_MOT_ATK )){
			  if( MOTION_END( kib ) ){
				PLAY_LOOP( kib, KIB_KRR_MOT_NEUTRAL );
				kib->atk_counter = param->atk_wait;
			  }else if( kib_state.frm == (70) ) krr->GenDebri(param->kib_num,1);
			}
		  }
		}break;
		case PHASE_DTOR:break;
		}
	  }break;
	case KIB_KRR_COMMON_TIE:
	  {//KIB,KRRƂɌ݂ŃlN^CB
		switch( common_state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY_INTRP( kib, KIB_KRR_MOT_TIE );
		  PLAY_INTRP( krr, KIB_KRR_MOT_TIE_END );
		  tie_counter = 0;
		  if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
			C_Debri::SetWaitFlg( true );
		  }
		}break;
		case PHASE_PROC:{
		  if( kib_state.frm >= (120) && kib_state.frm < (180)) 
			kib->mpNpcChara->GetModel()->SetMotionRate(param->mot_rate);
		  else
			kib->mpNpcChara->GetModel()->SetMotionRate(1.0f);
		  if( kib_state.hit && kib->IsHit() ){
			if( kib_state.hp <= 0 ) 
			  common_state = KIB_KRR_COMMON_KIB_DIE;
			else
			  common_state = KIB_KRR_COMMON_KIB_HIT;
		  }else if( MOTION_END( kib ) ){
			common_state = KIB_KRR_COMMON_ATK0;
		  }
		}break;
		case PHASE_DTOR:{
		  kib->mpNpcChara->GetModel()->SetMotionRate(1.f);
		  if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
			C_Debri::SetWaitFlg( false );
		  }
		}break;
		}
	  }break;
	case KIB_KRR_COMMON_KIB_HIT:
	  {//KIB,KRRƂɌ݂ŃlN^CKIBB
		switch( common_state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( kib, KIB_KRR_MOT_HIT );
		  kib->mData.mHp -= kib->mDamage.mDamPoint;
		  gpSound->mPlaySE( SFX_BOSS_KIBKRR_DAMAGE );
		  gpSound->mPlaySE( SFX_BOSS_KIBKRR_KIB_DAMAGE );
		}break;
		case PHASE_PROC:{
		  if( MOTION_END( kib ) ) {
			common_state = KIB_KRR_COMMON_ATK0;
		  }
		}break;
		case PHASE_DTOR:{
		  if( game_level == 0 ) game_level++;
		}break;
		}
	  }break;
	case KIB_KRR_COMMON_KIB_DIE:
	  {//KIBSB
		switch( common_state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( krr, KIB_KRR_MOT_TIE_DRAG );
		  PLAY( kib, KIB_KRR_MOT_DIE );
		  gpSound->mPlaySE( SFX_BOSS_KIBKRR_KIB_DIE );
		}break;
		case PHASE_PROC:{
		  if( MOTION_END( kib ) && MOTION_END( krr ) ) {
			common_state = KIB_KRR_COMMON_ATK1;
		  }
		}break;
		case PHASE_DTOR:{
		  if( game_level==1 ) game_level++;
		}break;
		}
	  }break;
	case KIB_KRR_COMMON_ATK1:
	  {//KRRlōUB
		switch( common_state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY_LOOP( krr, KIB_KRR_MOT_NEUTRAL );
		}break;
		case PHASE_PROC:{
#if 0
		  if( tie_hit_obj ) { 
			tie_hit_obj->GetJObj()->SetDstAlpha(0,false,false);
		  }
#endif
		  if( !(krr->WeapWait()) && IS_MOTION(krr,KIB_KRR_MOT_NEUTRAL)){
			common_state = KIB_KRR_COMMON_WEAP;
		  }else{
			//KRR
			if( GetDebriNum() > 1){
			}else{
			  if( IS_MOTION( krr, KIB_KRR_MOT_NEUTRAL )){
				if( !(krr->AtkWait()) )  PLAY( krr, KIB_KRR_MOT_ATK );
				if( !GetDebriNum() && krr_state.frm >= 2 ) krr->atk_counter = 0;
			  }else if( IS_MOTION( krr, KIB_KRR_MOT_ATK )){
				if( krr_state.frm == (80) ) krr->GenDebri(param->krr_num,0);
				else if( MOTION_END( krr ) ){
				  PLAY_LOOP( krr, KIB_KRR_MOT_NEUTRAL );
				  krr->atk_counter = param->atk_wait;
				}
			  }
			}
		  }
		}break;
		case PHASE_DTOR:break;
		}
	  }break;
	case KIB_KRR_COMMON_WEAP:
	  {//KRR̒QB
		switch( common_state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( krr, KIB_KRR_MOT_WEAP );
		  weap_counter = param->atk_wait;
		  if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
			C_Debri::SetWaitFlg( true );
		  }
		} break;
		case PHASE_PROC:{
		  if( krr_state.frm >= (120) && krr_state.frm < (180)) 
			krr->mpNpcChara->GetModel()->SetMotionRate(param->mot_rate);
		  else
			krr->mpNpcChara->GetModel()->SetMotionRate(1.0f);
		  if( krr_state.hit && krr->IsHit() ){
			if( krr_state.hp <= 0 ) 
			  common_state = KIB_KRR_COMMON_DEAD;
			else
			  common_state = KIB_KRR_COMMON_KRR_HIT;
		  }else if( MOTION_END( krr ) ){
			common_state = KIB_KRR_COMMON_ATK1;
		  }
		}break;
		case PHASE_DTOR:{
		  krr->mpNpcChara->GetModel()->SetMotionRate(1.0f);
		  if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
			C_Debri::SetWaitFlg( false );
		  }
		}break;
		}
	  }break;
	case KIB_KRR_COMMON_KRR_HIT:
	  {//KRR̒QɂB
		switch( common_state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( krr, KIB_KRR_MOT_HIT );
		  krr->mData.mHp -= krr->mDamage.mDamPoint;
		  gpSound->mPlaySE( SFX_BOSS_KIBKRR_DAMAGE );
		  gpSound->mPlaySE( SFX_BOSS_KIBKRR_KRR_DAMAGE );
		}break;
		case PHASE_PROC:{
		  if( MOTION_END( krr ) ){
			common_state = KIB_KRR_COMMON_ATK1;
		  }
		}break;
		case PHASE_DTOR:{
		  if( game_level == 2 ) game_level++;
		}break;
		}
	  }break;
	case KIB_KRR_COMMON_DEAD:
	  {//lƂSŏIB
		switch( common_state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( krr, KIB_KRR_MOT_DIE );
		  gpSound->mPlaySE( SFX_BOSS_KIBKRR_KRR_DIE );
		  //eNAB
		  for( int i=0; i<MAX_DEBRI; i++ ){
			if( debri[i] ) {delete debri[i]; debri[i] = 0; }
		  }
		}break;
		case PHASE_PROC:{
		  if( MOTION_END( krr ) ){
#if 0
			common_state = KIB_KRR_COMMON_ATK0;
#else
			common_state = KIB_KRR_COMMON_TERMINATE;
#endif
		  }
		}break;
		case PHASE_DTOR:{
		  krr->mData.mHp = KRR_HP;
		  kib->mData.mHp = KIB_HP;
		  game_level = 0;
		}break;
		}
	  }break;
	case KIB_KRR_COMMON_TERMINATE:
	  {
		//IB
	  }break;
	default:
	  break;
	}
  }while( !common_state.Proc() );

  //qbgB
  if( krr->debri_hit || kib->debri_hit ){
	for( int i=0; i<MAX_DEBRI; i++ ){
	  if( debri[i] && debri[i]->IsHit( last_hit_pos ) ){
		delete debri[i]; debri[i] = 0;
		GenParticle( 12, last_hit_pos );
		gpSound->mPlaySE(SFX_BOSS_KIBKRR_BLD_BREAK);
	  }
	}
  }

  krr->tie_hit = false;
  krr->brain_hit = false;
  krr->debri_hit = false;
  kib->brain_hit = false;
  kib->debri_hit = false;
  if( krr->tie_hit_obj ) krr->tie_hit_obj->SetEnable( true );
  if( krr->brain_hit_obj ) krr->brain_hit_obj->SetEnable( true );
  if( krr->debri_hit_obj ) krr->debri_hit_obj->SetEnable( true );
  if( kib->brain_hit_obj ) kib->brain_hit_obj->SetEnable( true );
  if( kib->debri_hit_obj ) kib->debri_hit_obj->SetEnable( true );

  return false;
}
void K7EnmKRR::AdditionalPostRenderProcess( void )
{
  for( int i=0; i<MAX_DEBRI; i++ )
	if( debri[i] ) debri[i]->Disp();
}
C_Generator *K7EnmKRR::GenParticle( s32 no, C_Vec &p )
{
  for( int j=0; j<MAX_GEN; j++ ){
	if( !gen[j] ){
	  gen[j] = new C_Generator( p, no );
	  gen[j]->Fire();
	  return gen[j];
	}else if( !gen[j]->IsAlive() ){
	  delete gen[j];
	  gen[j] = new C_Generator( p, no );
	  gen[j]->Fire();
	  return gen[j];
	}
  }
  return 0;
}
C_Generator *K7EnmKRR::GenParticle( s32 no, HSD_JObj *j )
{
  for( int i=0; i<MAX_GEN; i++ ){
	if( !gen[i] ){
	  gen[i] = new C_Generator( j, no );
	  gen[i]->Fire();
	  return gen[i];
	}else if( !gen[i]->IsAlive() ){
	  delete gen[i];
	  gen[i] = new C_Generator( j, no );
	  gen[i]->Fire();
	  return gen[i];
	}
  }
  return 0;
}
C_Generator *K7EnmKRR::GenParticle( s32 no, C_Vec &p, C_Vec &r )
{
  for( int i=0; i<MAX_GEN; i++ ){
	if( !gen[i] ){
	  gen[i] = new C_Generator( p, no );
	  gen[i]->SetRot( r );
	  gen[i]->Fire();
	  return gen[i];
	}else if( !gen[i]->IsAlive() ){
	  delete gen[i];
	  gen[i] = new C_Generator( p, no );
	  gen[i]->SetRot( r );
	  gen[i]->Fire();
	  return gen[i];
	}
  }
  return 0;
}
void K7EnmKRR::GenDebri( s32 num, s32 which )
{
  if( !WK7PLAYERCONTROL->GetWaistObjPtr() ) return ;

  if( num < 0 ) num = MAX_DEBRI;

  C_Vec tgt;
  WK7PLAYERCONTROL->GetWaistObjPtr()->GetWorldPosition(tgt);

  //ǂɂ߂荞ނB
  f32 lim = 50.f;
  if( tgt.x > lim ) tgt.x = lim;
  else if( tgt.x < -lim ) tgt.x = -lim;

  f32 min_debri_speed = param->min_debri_speed;
  f32 var_debri_speed = param->var_debri_speed;

  if( !which ){
	for( int i=0; i<MAX_DEBRI && num; i++ ){
	  C_Vec up(((HSD_Rand()%100) / 100.f-0.5f)*5.5f, 2.5f, 0.4f);
	  up.Nrm();
	  if( !debri[i] ){
		debri[i] = new C_Debri( head_jobj, up, tgt, debri_jobj, 
								min_debri_speed + var_debri_speed*(HSD_Rand()%100)/100.f , param->debri_force, 2.f );
		debri[i]->AddParticle( 5 );
		GenParticle( 1, head_jobj );
		num--;
		gpSound->mPlaySE(SFX_BOSS_KIBKRR_BLD_THROW);
		gpSound->mPlaySE(SFX_BOSS_KIBKRR_KRR_ATC);
	  }
	}
  }else{
	K7EnmKIB *kib = K7EnmKIB::GetInstance();
	for( int i=0; i<MAX_DEBRI && num; i++ ){
	  C_Vec up(((HSD_Rand()%100) / 100.f-0.5f)*5.5f, 2.5f, 0.4f);
	  up.Nrm();
	  if( !debri[i] ){
		debri[i] = new C_Debri( kib->head_jobj, up, tgt, kib->debri_jobj, 
								min_debri_speed + var_debri_speed*(HSD_Rand()%100)/100.f , param->debri_force, 2.f );
		debri[i]->AddParticle( 5 );
		GenParticle( 1, kib->head_jobj );
		num--;
		gpSound->mPlaySE(SFX_BOSS_KIBKRR_BLD_THROW);
		gpSound->mPlaySE(SFX_BOSS_KIBKRR_KIB_ATC);
	  }
	}
  }
}
bool K7EnmKRR::FrameProcess(void)
{
  //if( mState==NPC_STATE_INIT ){ return WK7Npc::ControlProcess(); }
	
	MotionProcess();
	
  if( !WK7PLAYERCONTROL->GetWaistObjPtr() ) return true;

  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  // [VXs[hRg[
	  //MotionSpeedControl();
			
	  //fu
	  mpNpcChara->mpAdditionalPostRender = 0;
	  C_Vec tgt;
	  WK7PLAYERCONTROL->GetWaistObjPtr()->GetWorldPosition(tgt);
	  for( int i=0; i<MAX_DEBRI; i++ ) {
		if ( debri[i] ){									// jЂ̕\
			mpNpcChara->mpAdditionalPostRender = this;
		}
		
		if( GetNpcPause()==false && debri[i] ){				// jЂ̎̃vZX
		  {
			//ǂɂ߂荞ނB
			C_Vec t_ = tgt;
			f32 lim = 50.f;
			if( tgt.x > lim ) t_.x = lim;
			else if( tgt.x < -lim ) t_.x = -lim;
			debri[i]->Proc( t_ );
		  }
		  if( debri[i]->IsHit( tgt, 18.f ) ){
			//BPCɂZbg
			if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
				WK7PLAYERCONTROL->SetPcDamage(tgt, KRR_GUN_DAMAGE_EASY,   1);
			}else{
				WK7PLAYERCONTROL->SetPcDamage(tgt, KRR_GUN_DAMAGE_NORMAL, 1);
			}
			GenParticle( 12, debri[i]->GetPos() );
			delete debri[i];
			debri[i] = 0;
			gpSound->mPlaySE(SFX_BOSS_KIBKRR_BLD_PHIT);
		  }else if( debri[i]->GetState() == C_Debri::FAIL || debri[i]->GetState() == C_Debri::HIT ){
			//OĎ񂾁B
			GenParticle( 12, debri[i]->GetPos() );
			delete debri[i];
			debri[i] = 0;
		  }
		}
	  }

	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){
		mFirstPosSet = 1;
		mpNpcChara->SetPosition(mPosition);
		WK7Model *pModel;
		if( (pModel = mpNpcChara->GetModel())!=NULL ){
		  mpNpcChara->SetRenderFlag(true);
		  pModel->Disp();
		}
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  //mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  //mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}
		head_jobj = mpNpcChara->GetJObj("Skull_joint3")->GetJObj();
		debri_jobj = mpNpcChara->GetJObj("Bullet")->GetJObj();
		tie_hit_obj = CreateHitObj( "Krr_Tie" );
		tie_hit_obj->SetTaskHandler(HitTask);
		tie_hit_obj->SetTaskParam(0,(u32)&tie_hit);
		brain_hit_obj = CreateHitObj( "Krr_Brain" );
		brain_hit_obj->SetTaskHandler(HitTask);
		brain_hit_obj->SetTaskParam(0,(u32)&brain_hit);
		debri_hit_obj = CreateHitObj( "Bullet" );
		debri_hit_obj->SetTaskHandler(HitTask);
		debri_hit_obj->SetTaskParam(0,(u32)&debri_hit);
		//WK7RenderObj::GetVFX()->SetTargetAlpha( (s32)debri_hit_obj->GetRenderID() );
		//WK7RenderObj::VFXSetIntensity( 1.f );		  
	  }
	}
  }
	
  return true;
}







