////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmA.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMKRR_H__
#define	__ENMKRR_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\fujita\c_state.h"
#include "..\fujita\c_debri.h"
#include "..\fujita\c_particle.h"

#define MAX_DEBRI 8
#define MAX_GEN 512
#define MAX_GAME_LEVEL 4
#define KRR_HP 10
#define KIB_HP 10

#define KRR_GUN_DAMAGE_EASY		(10)
#define KRR_GUN_DAMAGE_NORMAL	(20)

enum KIB_KRR_MOT{
  KIB_KRR_MOT_NEUTRAL = 0,
  KIB_KRR_MOT_ATK,
  KIB_KRR_MOT_HIT,
  KIB_KRR_MOT_DIE,
  KIB_KRR_MOT_TIE,
  KIB_KRR_MOT_TIE_DRAG,
  KIB_KRR_MOT_WEAP,
  KIB_KRR_MOT_TIE_HIT,
  KIB_KRR_MOT_TIE_LOOP,
  KIB_KRR_MOT_TIE_END,
  KIB_KRR_MOT_MAX,
  KIB_KRR_COMMON_ATK0,//KIB,KRRƂɌ݂ōUB
  KIB_KRR_COMMON_TIE,	//KIB,KRRƂɌ݂ŃlN^CB
  KIB_KRR_COMMON_KIB_HIT,//KIB,KRRƂɌ݂ŃlN^CKIBB
  KIB_KRR_COMMON_KIB_DIE,//KIB,KRRƂɌ݂ŃlN^CKIBSB
  KIB_KRR_COMMON_ATK1,//KIBSB
  KIB_KRR_COMMON_WEAP,	//KRR̒QB
  KIB_KRR_COMMON_KRR_HIT,//KRR̒QɂB
  KIB_KRR_COMMON_DEAD,
  KIB_KRR_COMMON_TERMINATE
};
typedef struct{
  s16 atk_wait;
  f32 mot_rate;
  s16 krr_num,kib_num;
  f32 min_debri_speed,var_debri_speed,debri_force;
}KRR_KIB_PARAM;
  
class K7EnmKRR : public K7EnmBoss{
private:
  static K7EnmKRR *instance;
  static C_Vec last_hit_pos;
protected:
  void Dummy( void );
  u32 mot_id;
  C_State common_state;
  HSD_JObj *head_jobj;
  HSD_JObj *debri_jobj;
  WK7HitObjJObj *tie_hit_obj,*brain_hit_obj,*debri_hit_obj;
  C_Debri *debri[MAX_DEBRI];
  C_Generator *gen[MAX_GEN];
  s32 atk_counter;
  s32 tie_counter,tie_wait;
  s32 weap_counter,game_level;
  KRR_KIB_PARAM *param;

  s32 AtkWait(void);
  s32 WeapWait( void );
  bool IsHit( void );
  bool IsHitTie( void );
  bool tie_hit,brain_hit,debri_hit;
  s32 GetDebriNum( void );
  void GenDebri( s32 num = -1, s32 which = 0 );
  C_Generator *GenParticle( s32 num, C_Vec &p );
  C_Generator *GenParticle( s32 num, HSD_JObj *j );
  C_Generator *GenParticle( s32 no, C_Vec &p, C_Vec &r );
public:
  K7EnmKRR(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
  ~K7EnmKRR();
  virtual bool IsMyRenderID( u32 id, Vec *pos = 0 );
  bool FrameProcess(void);
  bool ControlProcess(void);
  void AdditionalPostRenderProcess( void );
  static bool IsGameOver( void ){ 
	if( instance ) return ((s32)(instance->common_state) == KIB_KRR_COMMON_TERMINATE);
	else return false;
  }
};

#endif	//__ENMKRR_H__

