////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmMYS.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMMYS_CPP__

#include "EnmMYS.h"
#include "..\Wat\WK7Model.h"
#include "..\Wat\EnmList.h"

#define MDLCODE_ID				(28)		// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(2)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeMYSMotionIdTable[] = {
	20,							// R
	960,						// 
	0,							// 
	120,						// ^[E
	130,						// ^[
	140,						// ^[
	0,							// UĂѓiNu쓮j
	420,						// 85cmɍU
	410,						// 150cmɍU
	150,						// _[WO
	160,						// _[W
	170,						// _[WO
	180,						// _[W
	190,						// _[WEO
	290,						// _[WE
	200,						// _[WO
	300,						// _[W
	210,						// _[WEgO
	220,						// _[WEg
	230,						// _[WgO
	240,						// _[Wg
	260,						// _[WӂƂу_EOiSj
	250,						// _[Wу_EiSj
	310,						// _[WE _E
	320,						// _[W _E
	330,						// _ER
	340,						// _E_[W
	350,						// _EȂ
	360,						// _EȂ瑖
	400,						// _E玀S
	440,						// _E85cmɍU
	430,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	500,						// ݍUi_j
	650,						// ݍUiRj
	450,						// ݍUiJGfj
	460,						// ݍUiR[ej
	470,						// ݍUi}XNj
	490,						// ݍUiPrj
	0,							// iAiU[X}CpjV䒣tҋ@
	0,							// iAiU[X}CpjVA
	970,						// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA
	0,							// iAiU[X}CpjVA󒆗R
	0,							// iAiU[X}CpjVA󒆗`nA͂
	0,							// _[WE]
	0,							// _[W]
	1200,						// p[cAj[Vp
	0,							// 
	0,							// f
	0,							// f
	-1
};

static int eneFootSeTbl[] = {
	SFX_BT_MITHRILHS_WALKA,
	SFX_BT_MITHRILHS_WALKB,
	SFX_BT_MITHRILHS_WALKC,
	SFX_BT_MITHRILHS_WALKD,
	SFX_BT_MITHRILHS_WALKE
};

#define VYOROI_RATE				(0.5f)						// Z͑Ŝ̉₤̂H
#define EXTRA_PARTS_NAME		"Weak"

K7EnmMYS::K7EnmMYS(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	switch (suffix){
	case 0:					// m[}
		npcTypeMYSMotionIdTable[WK7MOTION_NPCCMN_RUN] = 90;
		break;
	case 1:					// jO
	case 3:					// jOiLn
		npcTypeMYSMotionIdTable[WK7MOTION_NPCCMN_RUN] = 930;
		break;
	default:				// 
		npcTypeMYSMotionIdTable[WK7MOTION_NPCCMN_RUN] = 711;
		break;
	}
	
	CreatePackMotion(npcTypeMYSMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	// _͘r̂
	switch (rand()&1){
	case 0:
		mData.mWeakID	= NPCWEAKOBJID_LARM;
		break;
	default:
		mData.mWeakID	= NPCWEAKOBJID_RARM;
	}
	
	mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;					// 
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 1;
	mYoroiBroken = 0;
}

/*
	
	
	mobZbgi^Cvj
	
	
	
*/
void K7EnmMYS::EneTypeReset(void)
{
	mYoroiBroken = 0;
	YoroiDisp();
	YoroiPartsHide();
	mAiEscape 	= 0;
	mAiWallBomb = 0;						// ǂɓB甚j^Cv
}


/*
	
	
	p_[hc̊蓖
	
	
*/
void K7EnmMYS::PartsRenderIDSet(void)
{
	u32 renderidex;
	WK7Model *pModel = pCurrentChara()->GetModel();
	
	renderidex = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	pCurrentChara()->SetRenderIDEx(renderidex);
	
	// ʂJOBJƂĂ
	if ( pModel != NULL ){
		WK7JObj *pJOBJ;
		pJOBJ   = pModel->GetObj(EXTRA_PARTS_NAME);					// IuWF񂷂̂ǂ
		if ( pJOBJ != NULL ){
			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂OKȏꍇ
//			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂ȏꍇ
		}
	}
}




void K7EnmMYS::VisibleTestDisp(void)
{
	s16 i;
	WK7Model *pModel;
	
	if( (pModel = pCurrentChara()->GetModel())!=NULL ){
		pModel->Disp();
		// ł镔ʂ͂܂
		for (i=0; i<NPCWEAKOBJID_MAX; i++){
			if ( 0 < VLossTest(i) ){
				if ( mWeakObj[i].mpSkin != NULL ) mWeakObj[i].mpSkin->Hide(false);
				if ( mWeakObj[i].mpBone != NULL ) mWeakObj[i].mpBone->Hide(false);
			}
		}
		// ZԂꂽ
		if ( 1 == mYoroiBroken ){
			YoroiHide();
		}else{
			YoroiDisp();
		}
		
		// ZтȊO̎́Ap[c͏
		if ( mMotID != WK7MOTION_NPCCMN_EXT_PARTS ){
			YoroiPartsHide();
		}
	}
}

void K7EnmMYS::VisibleTestHide(void)
{
	WK7Model *pModel;
	if( (pModel = pCurrentChara()->GetModel())!=NULL ){
		pModel->Hide();
	}
}

void K7EnmMYS::YoroiHide(void)
{
	WK7Model *pModel = pCurrentChara()->GetModel();
	WK7JObj *pJOBJ;
	if ( NULL != pModel ){
		pJOBJ = pModel->GetObj(EXTRA_PARTS_NAME);
		if ( pJOBJ != NULL ){
			pJOBJ->Hide(false, false);
		}
	}
}

void K7EnmMYS::YoroiDisp(void)
{
	WK7Model *pModel = pCurrentChara()->GetModel();
	WK7JObj *pJOBJ;
	if ( NULL != pModel ){
		pJOBJ = pModel->GetObj(EXTRA_PARTS_NAME);
		if ( pJOBJ != NULL ){
			pJOBJ->Disp(false, false);
		}
	}
}

void K7EnmMYS::YoroiPartsHide(void)
{
	WK7Model *pModel = pCurrentChara()->GetModel();
	WK7JObj *pJOBJ;
	if ( NULL != pModel ){
		pJOBJ = pModel->GetObj("P05");
		if ( pJOBJ != NULL ){
			pJOBJ->Hide(true, true);
		}
	}
}


/*
	
	
	_[W[VI
	Z邩ǂ
	
	
*/
bool K7EnmMYS::DamageMotionSelect(s16 frontFlag, u32 *pInSetMotID)
{
	f32 vYoroiDam	= (f32 )mWeakObj[NPCWEAKOBJID_WAIST].mWeakDam;
	f32 hpMax		= (f32 )(mData.mHpBk);
	Vec myPos;
	
	
	if ((0 == mYoroiBroken)
	&&  (vYoroiDam / hpMax >= VYOROI_RATE )
	&&	(1 == frontFlag)												// ʂ̂
	&&	(false == DamageGrenadeTest())
	&&	(DAMTYPE_BOMBER			!= (mDamage.mDamType))
	&&	(DAMTYPE_GRENADE_FINAL	!= (mDamage.mDamType))
//	&&	(DAMTYPE_KVNFRONTSHOT	!= (mDamage.mDamType))
	){																	// ʃ_[WŜXX𒴂
		if ( K7CHR_SUFFIX(mModelID) == 2 ){
			mAiEscape	= 1;
			mAiWallBomb = 1;											// ǂɓB甚j^Cv
		}
		
		// 胂[hfn
		if ( K7CHR_SUFFIX(mModelID) != 0 ){
			mAi.mRunPlz	= 1;
		}
		
		// p낢ꃂ[V
		YoroiHide();
		mYoroiBroken = 1;
		
		*pInSetMotID = WK7MOTION_NPCCMN_EXT_PARTS;
		
		DmgSpeedSet(1.f);
		
		// Zrd
		if ( NULL != pCurrentChara() ){
			pCurrentChara()->GetPosition(myPos);
			gpSound->mPlaySE3D(SFX_BT_MSHS_ARMOR , myPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
		}
		
	}else{
		return false;
	}
	return true;
}


/*
	
	
	go炷
	
	<return>
	false			ꃂ[V
	true			ꃂ[VA
	
*/
bool K7EnmMYS::HpDec(s16 inFrontFlag, s16 *pRegiDmgPoint)
{
	s16 damPoint;
	bool ret = true;

	// sJnOK
	mFirstMove = 1;
	
	// 񂤂_[Wl
	damPoint = mDamage.mDamPoint;
	
	// WXg`FbN
	damPoint = DamageRegistTest(damPoint, inFrontFlag);						// WXgeXgi{IɃWXg͂Ȃ
	
	if ( 0 < damPoint ){
		
		if ((0 == mYoroiBroken)												// Z𒅂ĂƂ
		&&	(1 == mDamage.mDamExHitOk)										// ZɃqbg
		&&	(DAMTYPE_GRENADE_FINAL != mDamage.mDamType)						// n̂͒ڑ̂Ƀ_[Wqbg
		&&	(DAMTYPE_BOMBER != mDamage.mDamType)
		&&	(false == DamageGrenadeTest())
		){
			// ZɃqbg
			// _[W͊Zŋz
			mWeakObj[NPCWEAKOBJID_WAIST].mWeakDam += damPoint;				// ̕Z_[WƂĎg
			damPoint = 0;
			
			{
				f32 vYoroiDam	= (f32 )mWeakObj[NPCWEAKOBJID_WAIST].mWeakDam;
				f32 hpMax		= (f32 )(mData.mHpBk);
				if ((0 == mYoroiBroken)
				&&  (vYoroiDam / hpMax >= VYOROI_RATE )
				&&	(1 == inFrontFlag)										// ʂ̂
				){															// ʃ_[WŜXX𒴂
					ret = true;
				}else{
					ret = false;											// _[W[VoȂꍇ͂
				}
			}
		}else{
			// ʂɃ_[W~ς
			if ( -1 != mDamage.mNearHitID ){
				if ( mWeakObj[mDamage.mNearHitID].mWeakDam >= 0 ){			// -1 ̎͂łɌς
					mWeakObj[mDamage.mNearHitID].mWeakDam += damPoint;
				}
			}
			if ( mDamage.mDamWeakHitOk ){
				// ʈꌂ莞̓_[WʃAbv
				damPoint = (s16 )( damPoint * VLOSS_DAM_RATE );
			}
			
			// Ŝgo炷
			mData.mHp -= damPoint;
			if ( (mData.mHp) <= 0 ){
				// 
				mData.mHp = 0;
			}
			ret = true;
		}
	}
	
	*pRegiDmgPoint = damPoint;
	
	return ret;
}

void K7EnmMYS::FootSeWalk(Vec myPos)
{
	// rdĐ
	// [vrd{[`FW
	if(	(pCurrentChara()!=NULL)
	&&	(mData.mFootSe != 0)
	){
		if ((2  == GetCurrentMotionFrame())
		||	(30 == GetCurrentMotionFrame())
		){
			gpSound->mPlaySE3D( (int )eneFootSeTbl[rand()%5], myPos, 0 );		// rdĐ
			if( 2  == GetCurrentMotionFrame() ){
				FootPaintTestSet(NPCWEAKOBJID_RFOOT);
			}else{
				FootPaintTestSet(NPCWEAKOBJID_LFOOT);
			}
		}
	}
}
void K7EnmMYS::FootSeRun(Vec myPos)
{
	int footSe = (int )eneFootSeTbl[rand()%5];

	// [vrd{[`FW
	if(	(pCurrentChara()!=NULL)
	&&	(mData.mFootSe != 0)
	){
		WK7Model *pModel = pCurrentChara()->GetModel();
		if ( 1 == mYoroiBroken ){
			switch ( K7CHR_SUFFIX(mModelID) ){
			case 0:
				if ((10  == GetCurrentMotionFrame())
				||	(30 == GetCurrentMotionFrame())
				){
					gpSound->mPlaySE3D( footSe, myPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
				}
				if( 10  == GetCurrentMotionFrame() ){
					FootPaintTestSet(NPCWEAKOBJID_RFOOT);
				}else{
					FootPaintTestSet(NPCWEAKOBJID_LFOOT);
				}
				break;
			case 1:
			case 3:
				if ((16  == GetCurrentMotionFrame())
				||	(32 == GetCurrentMotionFrame())
				){
					gpSound->mPlaySE3D( footSe, myPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
				}
				if( 16  == GetCurrentMotionFrame() ){
					FootPaintTestSet(NPCWEAKOBJID_RFOOT);
				}else{
					FootPaintTestSet(NPCWEAKOBJID_LFOOT);
				}
				break;
			case 2:
				if ((26  == GetCurrentMotionFrame())
				||	(12 == GetCurrentMotionFrame())
				){
					gpSound->mPlaySE3D( footSe, myPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
				}
				if( 26  == GetCurrentMotionFrame() ){
					FootPaintTestSet(NPCWEAKOBJID_RFOOT);
				}else{
					FootPaintTestSet(NPCWEAKOBJID_LFOOT);
				}
				break;
			}
		}else{
				if ((30  == GetCurrentMotionFrame())
				||	(10 == GetCurrentMotionFrame())
				){
					gpSound->mPlaySE3D( footSe, myPos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
				}
				if( 30  == GetCurrentMotionFrame() ){
					FootPaintTestSet(NPCWEAKOBJID_RFOOT);
				}else{
					FootPaintTestSet(NPCWEAKOBJID_LFOOT);
				}
		}
	}
}
	


/*
	
	
	Gȃ^C~O
	
	<return>
	true			G
	false			GȂ
	
*/
bool K7EnmMYS::GetNoDamage(void)
{
	// 낢j󒆂͖G
	if (mMotID == WK7MOTION_NPCCMN_EXT_PARTS){
		return true;
	}
	return false;
}







