////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmR.cpp [U[gr
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMR_CPP__

#include "EnmR.h"
#include "..\Yam\YK7EffectBlood.h"
#include "..\Kaw\KK7Effect.h"

#define MDLCODE_ID				(25)		// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(25)		// dmHQwww ́H̔ԍi[Vj

s16 npcTypeRMotionIdTable[] = {
	20,							// R
	0,							// 
	0,							// 
	0,							// ^[E
	0,							// ^[
	140,						// ^[
	0,							// UĂѓiNu쓮j
	0,							// 85cmɍU
	0,							// 150cmɍU
	0,							// _[WO
	0,							// _[W
	160,						// _[WO
	0,							// _[W
	0,							// _[WEO
	0,							// _[WE
	0,							// _[WO
	0,							// _[W
	0,							// _[WEgO
	0,							// _[WEg
	0,							// _[WgO
	0,							// _[Wg
	0,							// _[WӂƂу_EOiSj
	0,							// _[Wу_EiSj
	0,							// _[WE _E
	0,							// _[W _E
	0,							// _ER
	0,							// _E_[W
	0,							// _EȂ
	0,							// _EȂ瑖
	0,							// _E玀S
	0,							// _E85cmɍU
	0,							// _E150cmɍU
	100,						// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	0,						// ݍUi_j
	0,						// ݍUiRj
	0,						// ݍUiJGfj
	0,						// ݍUiR[ej
	0,						// ݍUi}XNj
	0,						// ݍUiPrj
	0,							// f
	0,							// f
	-1
};


K7EnmR::K7EnmR(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeRMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= NPCWEAKOBJID_HEAD;
	mData.mVLossID		= -1;								// ʌ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;					// ăZbgŒ
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mNoMove		= true;								// ړȂ
	mData.mCounterKurai	= 66-(10*2);
}

/*
	
	
	U[V
	
	
	<return>
	true	VK[VZbgꂽ
	false	[V̂܂
	
*/
bool K7EnmR::MotStatus_Atk(void)
{
	Vec myPos;

	SetTargetRotY(mOperationDir);
	
	// [U[ȔꍇApU菈
	switch (mLaserProcess){
	case 0:
		SetRotCalc(4.f);											// 肬܂Ńz[~O
		if ( 4 <= GetCurrentMotionFrame() ){
			HSEffect_LaserTame();
			mLaserProcess++;
		}
		break;
	case 1:
		SetRotCalc(4.f);											// 肬܂Ńz[~O
		if ( 66 > GetCurrentMotionFrame() ){
			HSEffect_LaserTamePosUpDate();
		}else{
			mLaserProcess++;
		}
		break;
	case 2:
		SetRotCalc(1.f);											// 肬܂Ńz[~O
		HSEffect_LaserTameTerm();
		
		// [U[ˁI
		if ( false == HSEffect_LaserShot() ){
			// ˂Ȃꍇ́AJE^[VOioȂ
			mCounterSignal = 1;
		}
		mLaserProcess++;
		break;
	case 3:
		HSEffect_LaserShotPosUpDate();
		mLaserProcess++;
		break;
	case 4:
		HSEffect_LaserShotPosUpDate();
		mLaserProcess++;
		break;
	case 5:															// [U[qbg
		HSEffect_LaserShotPosUpDate();
		GetPosition(myPos);
		if ( pCurrentChara() != NULL ) {
			if ( true == pCurrentChara()->IsValidEffect(mpLaserBombEfc) ) {
				// lɂqbgtO𗧂Ă
				WK7PLAYERCONTROL->SetPcDamage(myPos, (s16 )mData.mAtkPower2);
			}
		}
		mLaserProcess++;
		break;
	case 6:															// [U[
		if ( 96 <= GetCurrentMotionFrame() ){
			DelLaserBomb();
			mLaserProcess++;
		}else{
			HSEffect_LaserShotPosUpDate();
		}
		break;
	default:
		break;
	}
	
	// ݍU\m点
	if ((6 >= mLaserProcess)
	&&	(!(mOperationPathResult != PATHSEARESULT_NOWALL))
	){
		KerenmiSignalCall();
	}
	
	// Iijj
	if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
		
		Vec		dummyDir;
		
		dummyDir.x = 0.f;
		dummyDir.y = 0.f;
		dummyDir.z = 0.f;
		
		// ݒn̎擾
		SetVisible(false);
		
		// grSGtFNgiSj
		mpNpcRevivalEfc = KK7BattleEffectDead(	GetYukaY(),
												dummyDir,
												mWeakObj[NPCWEAKOBJID_WAIST].mpBone,
												1,
												mEfcBoodMode,
												mEfcBoodPoint,
												BLOODTEX_BLOOD,
												20
		);
		
		{
																	// Ƃ̂rd
			Vec enePos;
			int seNo;
			
			pCurrentChara()->GetPosition(enePos);
			seNo = gpSound->mPlaySE3D( waraiDeathSeTbl[rand()%SFX_BT_HS_DEATH_MAX], enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );
			SePitchChange(seNo);
		}
		
		// [U[X}C̏ꍇ́AɂȂ邯ǁuv
		DelLaserBomb();
		MotSet_Loss();
		SetEnemyDieInfo(NPC_DIE_JIBAKU);
//		NpcRePopTest();
		mWaitCount = 8;
	}
	
	return false;
}

bool K7EnmR::DamageMotionSelect(s16 frontFlag, u32 *pInSetMotID)
{
#pragma unused(frontFlag)
	*pInSetMotID = WK7MOTION_NPCCMN_DMG_BODY_F;
	return true;
}




