////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmA.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMUR2_H__
#define	__ENMUR2_H__

#include "..\Wat\WK7Enemy.h"
#include "..\Wat\WK7Path.h"
#include "EnmBoss.h"
#include "..\Fujita\c_bloodline.h"
#include "..\Fujita\c_state.h"
#include "..\Fujita\c_trigon.h"
#include "..\..\..\Yam\YK7Effect.h"
enum UR2_MOT{
  UR2_MOT_NEUTRAL = 0,
  UR2_MOT_WALK,
  UR2_MOT_EXPLODE,
  UR2_MOT_TURN90,
  UR2_MOT_TURN180,
  UR2_MOT_HIT,
  UR2_MOT_DIE
};
enum UR2_STATE{
  UR2_STATE_READY = 0,
  UR2_STATE_READY2,
  UR2_STATE_OPENING0,
  UR2_STATE_OPENING1,
  UR2_STATE_OPENING2,
  UR2_STATE_ENDING0,
  UR2_STATE_ENDING1,
  UR2_STATE_ENDING2,
  UR2_STATE_ENDING3,
  UR2_STATE_WAIT,
  UR2_STATE_EXPLODE,
  UR2_STATE_EXPLORE,
  UR2_STATE_TURN,
  UR2_STATE_ATACK,
  UR2_STATE_HIT,
  UR2_STATE_DIE
};
#define AFRO_DIST (f32)(7.f)
#define AFRO_DIST_MAX (f32)(30.f)
#define AFRO_SPEED (f32)(2.f)
#define WARP_POINT_NUM 2
#define UR2_ATK_DIST (f32)( 10.f )
#define UR2_AWARE_DIST (f32)( 20.f )
#define UR2_HIT_MAX 2
#define UR2_SPEED 0.2f
#define UR2_TYPE1_NUM 8
#define UR2_TYPE2_NUM 30
#define UR2_MAX_BLOOD_STAIN (30*3)
#define UR2_BLOOD_STAIN_LIFE (30*30)

class C_BloodStain{
  friend class C_BloodStainSet;
 public:
  C_BloodStain( void );
  ~C_BloodStain();
  void Proc( s32 t_, f32 sr_ );
  void Disp( void );
 private:
  s32 life;
  s32 start_counter;
  HSD_JObj *jobj;
  C_Vec pos;
};
class C_BloodStainSet{
 public:
  C_BloodStainSet( void ){
	counter = UR2_BLOOD_STAIN_LIFE / 2;
	time = 1;
	counter_max = 60;
	scl_rate = 0.7f;
  }
  //~C_BloodStainSet();
  void Proc( void );
  void Disp( void );
  bool Add( C_Vec &pos );
  inline void SetCounter( s32 c_ ){ counter_max = c_; }
  inline void SetTime( s32 t_ ){ time = t_; }
  void SetPE( void );
  void SetScaleRate( f32 sr_ ) { scl_rate = sr_; }
 private:
  s32 counter; 
  s32 time,counter_max;
  f32 scl_rate;
  C_BloodStain bs[ UR2_MAX_BLOOD_STAIN ];
};
class C_LastHitData{
 public:
  C_LastHitData( void ){
	trigon = 0;
  }
  C_Trigon *trigon;
  C_Vec pos;
};
class C_LastDst{
 public:
  C_LastDst( void ){
	flg = false;
	pos.Set(0.f);
  }
  C_Vec pos;
  bool flg;
};
class C_Path{
 public:
  enum {
	NONE = 0,
	DIRECT,
	DIVERT
  };
  C_Path( void ){
	flg = NONE;
  }
  s32 flg;
  C_Vec pos,nrm;
  f32 dist;
};
class C_CamReq{
 public:
  C_Vec pos;
  C_Vec tgt;
  f32 fov;
  bool flg;
};

class C_PathObj : public WK7PathControlObj{
 public:
  C_PathObj( void );
  ~C_PathObj();
  virtual CallbackResult BranchPointArriveCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranchPoint *pBranchPoint);
  void FrameProcess( void );
  Vec GetPos( void );
  f32 GetRotY( void );
  void Move( f32 dist_ );
  void SetTarget( WK7PathInfo *t_ );
  WK7PathInfo *GetCurrent( void );
  f32 GetDist( void );
  C_Vec GetDir( void );
 protected:
  WK7PathControl path_control;
  WK7PathBranchList	*branch_list;
  WK7PathInfo		*target_path;
};

class K7EnmUR2 : public K7EnmBoss{
protected:
  void Dummy( void );
  void SetAfroPos( void );
  void GetWarpPoint( Vec &pos, f32 &rot, s32 no = -1 );
  void GetPath( C_Path &path, C_Vec &start, C_Vec &end );
  bool CanSee( C_Vec &tgt_pos );
  bool IsDie( void );
  void StopAfro( void );
  void StartAfro( void );
  void SetHitStatus( void );
  bool IsHitAfro( void );
  virtual ~K7EnmUR2();
  static K7EnmUR2 *instance;
  static C_Vec last_hit_pos;
  HSD_JObj *afro_jobj,*bullet_jobj;
  C_Vec afro_pos;
  C_Vec chr_dir;
  C_Vec save_cam_pos;
  C_Vec save_cam_tgt;
  C_LastDst last_dst;
  C_BloodLines *bloodline;
  f32 save_intensity;
  f32 afro_dist,afro_dist_max;
  f32 speed;
  u32 hit_counter;
  C_State state;
  s32 mot_id;
  s16 atk_dmg;
  s16 dbr_dmg;
  C_LastHitData body_last_hit;
  C_LastHitData afro_last_hit;
  bool explode_flg;
  C_Path afro2dst;
  C_Path body2dst;
  WK7HitObjJObj *afro_hit_obj,*debri_hit_obj;
  WK7JObj *car_front_jobj;
  bool afro_hit,debri_hit;
  s32 hit_status;
  bool game_over;
  C_CamReq cam_req;
  C_ParticleSystem ptcl;
  C_BloodStainSet bloodstain;
  s32 ready_counter;
  s32 opening_counter;
  s32 no_hit_counter;
  f32 path_speed;
  f32 cam_dist;
  f32 cam_height;
  s32 counter;
  C_PathObj ur2_path,afro_path,cam_path;
  WK7PathInfo path_info;
  EFFECT*	mpEffect;
public:
  static bool IsGameOver( void );
  static bool IsMyRenderID( u32 id, Vec *p );
  static bool IsCamReq( C_Vec &pos, C_Vec &tgt, f32 &fov );
  K7EnmUR2(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
  void AdditionalPostRenderProcess( void );
  void AdditionalPreRenderProcess( void );
  bool FrameProcess(void);
  bool ControlProcess(void);
  static s32 GetState(void) { if( instance ) return (s32)instance->state; else return 0;}
};

#endif	//__ENMANG_H__

