
/*

 	KK7BattleCamera.cpp

 	Creator       : Kawakami Satoshi (GHM)
 	Creation Date : 02/16/2003

*/

#define	__KK7BATTLECAMERA_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "KK7BattleCamera.h"
#include "..\lib\ghmGcDefine.h"
#include "..\Fujita\C_Font.h"
#include "..\Wat\WK7Cam.h"
#include "..\Kaw\KK7Util.h"
#include "..\Wat\WK7Player.h"


// J̃fBCftHgl
#define BATTLE_CAM_DELAY_DEF		(12.f * (WK7_FRAME_RATE / 60.f))

/*
	
	RXgN^
	
*/
KK7BattleCamera::KK7BattleCamera()
{
	// Init
//	OSReport( "KK7BattleCamera@called constractor\n" );
	
}

/*
	
	fXgN^
	
*/
KK7BattleCamera::~KK7BattleCamera()
{
	// Init
//	OSReport( "KK7BattleCamera@called destractor\n" );
	
	
}

/*
	
	J̃fBČvZ
	
*/
void KK7BattleCamera::Init(void)
{
	shakeCount				= 0;
	shakeCountMax			= 1;
	rot[NOW].x				= 0.f;
	rot[TARGET].x			= 0.f;
	rot[NOW].y				= 0.f;
	rot[TARGET].y			= 0.f;
	pos[NOW].x				= 0.f;
	pos[TARGET].x			= 0.f;
	pos[NOW].y				= 0.f;
	pos[TARGET].y			= 0.f;
	pos[NOW].z				= 0.f;
	pos[TARGET].z			= 0.f;
}

/*
	
	J̃fBČvZ
	
	delay 0.0 ~ 1.0
	
*/
void KK7BattleCamera::CameraDelayCalc(f32 delay)
{
	f32 tmp;

	// ]
	{
		tmp = rot[TARGET].y - rot[NOW].y;
		if ( tmp ){
			// +-܂Ƃ̏
			if( tmp > PI ){
				do{
					tmp -= TWO_PI;
				}while( tmp > PI );
			}else if( tmp < -PI ){
				do{
					tmp += TWO_PI;
				}while( tmp < -PI );
			}
			rot[NOW].y += tmp * delay;
			GHM_LIMIT_RANGE(rot[NOW].y, PI, -PI);
		}
		tmp = rot[TARGET].x - rot[NOW].x;
		if ( tmp ){
			rot[NOW].x += tmp * delay;
		}
	}
	
	// ړ
	{
		tmp = pos[TARGET].x - pos[NOW].x;
		if ( tmp ){
			pos[NOW].x += tmp * delay;
		}
		tmp = pos[TARGET].y - pos[NOW].y;
		if ( tmp ){
			pos[NOW].y += tmp * delay;
		}
		tmp = pos[TARGET].z - pos[NOW].z;
		if ( tmp ){
			pos[NOW].z += tmp * delay;
		}
	}
	
}

/*
	
	J̐ݒi_A]j
	
*/
//	static f32 shakeRotTable[SHAKE_COUNTMAX] = {
//		0.f,
//		+0.001f,
//		+0.003f,
//		0.f,
//		+0.006f,
//		0.f,
//		+0.008f,
//		0.f,
//		+0.020f,
//		0.f,
//	};
//	static f32 shakeTargetYTable[SHAKE_COUNTMAX] = {
//		0.f,
//		0.f,
//		+0.4f,
//		0.f,
//		+1.f,
//		0.f,
//		+1.f,
//		0.2f,
//		+3.5f,
//		0.f,
//	};

static f32 *pShakeRotTable = NULL;
static f32 shakeRotTable[SHAKE_COUNTMAX] = {
	0.f,
	+0.002f,
	-0.005f,
	0.f,
	+0.008f,
	0.f,
	-0.010f,
	0.f,
	+0.025f,
	0.f,
};
static f32 *pShakeTargetYTable = NULL;
static f32 shakeTargetYTable[SHAKE_COUNTMAX] = {
	+0.f,
	0.f,
	+0.4f,
	0.f,
	+1.f,
	0.f,
	+1.f,
	0.2f,
	+2.f,
	0.f,
};

#define SHAKE_COUNTMAX2	(12)
static f32 shakeRotTableBig[SHAKE_COUNTMAX2] = {
	0.f,
	+0.002f,
	+0.020f,
	0.f,
	+0.030f,
	0.f,
	+0.050f,
	0.f,
	-0.070f,
	0.f,
	+0.050f,
	0.f,
};
static f32 shakeTargetYTableBig[SHAKE_COUNTMAX2] = {
	+0.f,
	0.f,
	+0.4f,
	0.f,
	+2.f,
	0.f,
	+3.f,
	0.2f,
	+4.5f,
	0.f,
	+7.5f,
	0.f,
};


/*
	
	
	݂̃LN^̈ʒuAJPOSƊpxo
	
	<in>
	ArmSide		A[̉̒
	ArmFront	A[̏c̒
	ArmHigh		A[̍
	NowPos		݂̊Pos
	NowPos		݂̊Rot
	
*/
void KK7BattleCamera::LookSetRotCalc(f32 ArmSide, f32 ArmFront, f32 ArmHigh, Vec NowPos, Vec NowRot, Vec *pGetPos, Vec *pGetRot, bool mode)
{
	f32 tmprot, setRotX, setPosY;
	Vec ArmPos, CalcPos;

	// W NowPos
	
	// A[vZ
	tmprot = NowRot.y + PI/2.f;
	GHM_LIMIT_RANGE(tmprot, PI, -PI);
	
	ArmPos.x = NowPos.x + ArmSide * sinf(tmprot);
	ArmPos.z = NowPos.z + ArmSide * cosf(tmprot);

	tmprot = NowRot.y + PI;
	GHM_LIMIT_RANGE(tmprot, PI, -PI);
	
	// ̃t[̌ݒnvZ
	CalcPos.x = ArmPos.x + ArmFront * sinf(tmprot);
	CalcPos.z = ArmPos.z + ArmFront * cosf(tmprot);
	CalcPos.y = NowPos.y + ArmHigh;
	
	setRotX = NowRot.x;
	setPosY = CalcPos.y;
	
	// f[^ƂăZbg
#if 0
//	if ( NULL == pGetRot ){
//		rot[TARGET].x = setRotX;
//		rot[TARGET].y = NowRot.y;
//		rot[TARGET].z = 0.f;
//		// 
//		if ( true == mode ) rot[NOW] = rot[TARGET];
//	}else{
//		pGetRot->x = setRotX;
//		pGetRot->y = NowRot.y;
//		pGetRot->z = 0.f;
//	}
#else
	if ( NULL != pGetRot ){
		pGetRot->x = setRotX;
		pGetRot->y = NowRot.y;
		pGetRot->z = 0.f;
	}
#endif
	
	if ( NULL == pGetPos ){
		CalcPos.y     = setPosY;
		pos[TARGET]   = CalcPos;
		// 
		if ( true == mode ) pos[NOW] = pos[TARGET];
	}else{
		pGetPos->x = CalcPos.x;
		pGetPos->y = CalcPos.y;
		pGetPos->z = CalcPos.z;
	}
}

/*
	
	
	Jhp[^擾
	
	
*/
bool KK7BattleCamera::ShakeParamGet(f32 *pGetRotX, f32 *pGetPosY, f32 shakeRate)
{
	// JVFCN
	if ( shakeCount ){
		*pGetRotX = pShakeRotTable[shakeCount%shakeCountMax]		* shakeRate;
		*pGetPosY = pShakeTargetYTable[shakeCount%shakeCountMax]	* shakeRate;
		shakeCount--;
		return true;
	}
	return false;
}

/*	
	
	
	JꎞԂZbg
	
	
*/
void KK7BattleCamera::CameraShakeCountSet(s16 count)
{
	switch (count){
	case 0:						// Ol[hp
		pShakeRotTable		= shakeRotTableBig;
		pShakeTargetYTable	= shakeTargetYTableBig;
		shakeCountMax		= (s16 )SHAKE_COUNTMAX2;
		shakeCount			= (s16 )(shakeCountMax - 1);
		break;
	default:
		pShakeRotTable		= shakeRotTable;
		pShakeTargetYTable	= shakeTargetYTable;
		shakeCountMax		= (s16 )SHAKE_COUNTMAX;
		shakeCount			= (s16 )(shakeCountMax - 1);
		break;
	}
}


