/*

 	KK7BattleCtrl.h

 Creator       : Kawakami Satoshi (GHM)
 Creation Date : 02/16/2003

*/

#ifndef	__KK7BATTLECTRL_H__
#define	__KK7BATTLECTRL_H__


#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTask.h"
#include "..\Lib\ghmGcTex.h"
#include "..\wat\K7ID.h"
#include "WK7Chara.h"
#include "WK7Obj.h"
#include "WK7Npc.h"


// ubh|Cg̃[h
enum BpType{
	BP_SERUM = 0,		// 
	BP_THICK,			// Z 
	BP_THIN,			//  XyVA^bNŎgp
	BP_MAX
};

#define KK7BATTLECTRL_DAMAGEPOINT_BIT_PC		(0x01)
#define KK7BATTLECTRL_DAMAGEPOINT_BIT_ENEMY		(0x02)
#define KK7BATTLECTRL_DAMAGEPOINT_BIT_EXTRA		(0x04)
#define KK7BATTLECTRL_DAMAGEPOINT_BIT_OBJ		(0x08)
#define KK7BATTLECTRL_DAMAGEPOINT_BIT_ALL		(KK7BATTLECTRL_DAMAGEPOINT_BIT_PC|KK7BATTLECTRL_DAMAGEPOINT_BIT_ENEMY|KK7BATTLECTRL_DAMAGEPOINT_BIT_EXTRA|KK7BATTLECTRL_DAMAGEPOINT_BIT_OBJ)

// }XÑxAbvn
enum MskLevel{
	KK7BATTLECTRL_MSKLV_NORMAL = 0,
	KK7BATTLECTRL_MSKLV_TEXAS,
	KK7BATTLECTRL_MSKLV_FINAL,
	KK7BATTLECTRL_MSKLV_TEKKAMEN
};

// _̃xAbvn
enum DanLevel{
	KK7BATTLECTRL_DANLV_NORMAL = 0,
	KK7BATTLECTRL_DANLV_UP,
};

// KṼxAbvn
enum GalLevel{
	KK7BATTLECTRL_GALLV_NORMAL = 0,
	KK7BATTLECTRL_GALLV_UP,
};

// _[W
class KK7BattleCtrl_DamagePos : public ghmGcListObj{
protected:
	u32				mId;

	KK7BattleCtrl_DamagePos();
public:
	KK7BattleCtrl_DamagePos(ghmGcListObj *pAnchor, u32 id);
	virtual ~KK7BattleCtrl_DamagePos();
	
	inline KK7BattleCtrl_DamagePos* GetPrev(void){ return (KK7BattleCtrl_DamagePos *)ghmGcListObj::GetPrev(); }
	inline KK7BattleCtrl_DamagePos* GetNext(void){ return (KK7BattleCtrl_DamagePos *)ghmGcListObj::GetNext(); }
	inline u32 GetID(void){ return mId; }
	
//	inline WK7CharaMotion* GetMotion(void){ return mpMotion; }
//	bool IsLoading(void);
	
	Vec				mDamPos;					// _[W|WV
	f32				mDamDist;					// _[WL͈
	f32				mDamFrame;					// _[W̑ݎ
	u32				mDamListBit;				// _[W󂯂镨
	u32				mDamPoint;					// _[W_[W̒l
	WK7NpcDamType	mDamType;					// _[W̃^Cv
};


typedef struct{
	Vec				damagePos;
}BattleCtrl_DamagePoint;


struct KK7DeadPlayerSaveData{
	u32							mID;
	u32							mStageID;
	Vec							mPosition;
	Vec							mDir;
};

// ̐ݒup
class KK7DeadPlayer : public WK7Obj{
protected:
	u32							mID;						// hc
	u32							mMainID;					// Chc
	u32							mSuffix;					// TtBbNX
	u32							mStageID;					// ݒuXe[Whc
	
	WK7Chara					*mpPcDead;					// ʏL
	
	Vec							mDir;
	Vec							mPosition;
	f32							mRotY;
	
	u32							mReleaseRequest;			// JNGXg
	
	int							mTaskID;
	
public:
	
	void	SetID(u32 id, u32 stageid);
	inline	u32 GetID(void){ return mID; }
	inline	u32 GetMainID(void){ return mMainID; }
	inline	u32 GetStageID(void){ return mStageID; }
	inline	u32 GetReleaseRequest(void){ return mReleaseRequest; }
	inline	void ReleaseRequest(void){ mReleaseRequest = 1; }
	inline	void SetTaskID(int taskid){ mTaskID=taskid; }
	inline	int GetTaskID(void){ return mTaskID; }
	
	inline	WK7Chara *GetpWK7Chara(void){ return mpPcDead; }
	void	Init(void);
	bool	CreateModel(u32 SetID);
	bool	ReleaseModel(void);
	bool	IsLoading(void);
	void	SetVisible(bool flag);
	bool	GetPosition(Vec *pos);
	Vec 	*pGetPosition(void){ return &mPosition; }
	inline	bool GetPosition(Vec &position){ position=mPosition; return true; }
	bool	SetPosition(Vec pos);
	bool	SetPosition(void);
	bool	GetRotY(f32 *roty);
	bool	SetRotY(f32 roty);
	bool	SetRotY(void);
	bool	SetDir(const Vec &dir){ mDir=dir; return true; }
	bool	GetDir(Vec &dir){ dir=mDir; return true; }
															// KV[̉Cxg`FbN
	bool	GalDeadRecoverTest(void);
	
	bool	StoreSaveData(KK7DeadPlayerSaveData *pSaveData);
	bool	RestoreSaveData(KK7DeadPlayerSaveData *pSaveData);
	
};


// obLǗp
class KK7PCInfo{
protected:
	u32							mDieInfoBit;				// 񂾂łȂ̃tO
	u32							mCollectInfoBit;			// H
	u32							mReCallInfoBit;				// ĂыNǂH
	u32							mSelOKInfoBit;				// LI\ǂH
	
	int							mBpGauge[BP_MAX];			// aoQ[W
	
public:
	KK7PCInfo();
	~KK7PCInfo();
	void ScenarioReset(void);
	bool GetDieInfo(u32 mainID);
	void SetDieInfo(u32 mainID, int info);
	bool GetCollectInfo(u32 mainID);
	void SetCollectInfo(u32 mainID, int info);
	bool GetReCallInfo(u32 mainID);
	void SetReCallInfo(u32 mainID, int info);
	bool GetSelOKInfo(u32 mainID);
	void SetSelOKInfo(u32 mainID, int info);
	int GetBpGauge(int type);
	void SetBpGauge(int type, int Point);
	int IncBpGauge(int type, int IncPoint);
	
	void GetPcInfo(u32 *pInDie, u32 *pInCollect, u32 *pInReCall, u32 *pInSelOK);
	void SetPcInfo(u32 inDie, u32 inCollect, u32 inReCall, u32 inSelOK);

};


class KK7BattleCtrl{
protected:
	ghmGcListObj				mDamagePosAnchor;			// _-W AJ[
	u32							mDamagePosIdCounter;		// _-W JE^[Up
	u32							mTotalEnemyHunt;			// G̑j
	u32							mTotalReCallNum;			// erʓ̈N
	u32							mCreateSerumVolume;			// 쐬Av̗
	u32							mTvEnemyCount;				// G̑jierp
	u8							mGalPowerUp;				// KVAp[Abv
	u8							mDanPowerUp;				// _p[Abv
	u8							mMskPowerUp;				// }XNp[Abv
	u32							mComboCount;				// R{JEg
	
															// _[WRg[At[
	bool						DamagePosCtrlFrameProcess(void);
	void						AllReleaseDamagePos(void);
public:
	KK7BattleCtrl();
	~KK7BattleCtrl();

	KK7DeadPlayer				mDeadPlayer[K7PCMAX];		// ̗pf
	KK7PCInfo					mPcInfo;					// ob̏Ǘp
	
	void						InitStage(void);
	void						InitNewGame(void);
	void						InitScenario(void);
	void						InitScenarioFlow(void);
	void						ReleaseScenario(void);
	
	void 						FrameProcess(void);

	KK7PCInfo					*pGetPcInfo(void){ return &mPcInfo; }
	
								// _[W쐬
	u32 						CreateDamagePos(Vec pos, f32 dist, f32 frame, u32 bit, u32 point, WK7NpcDamType type=DAMTYPE_NORMAL);
								// _[W
	KK7BattleCtrl_DamagePos* 	FindDamagePos(u32 id);	
								// _[WJ
	bool						ReleaseDamagePos(KK7BattleCtrl_DamagePos *pDamage);
	bool						ReleaseDamagePos(u32 id);
								// _[Wf[^̃gbvAhX擾
	KK7BattleCtrl_DamagePos* 	GetTopDamagePos(void){ return (KK7BattleCtrl_DamagePos *)mDamagePosAnchor.GetNext(); }
	
								// ̊Ǘ^XN̊Jn
	bool						StartDeadTask(u32 set_mID, u32 set_mStageID);
	bool						StopDeadTask(u32 set_mID);
	bool						EndDeadTask(u32 mainID);
	void						EndDeadTaskAll(void);
	bool						RestoreDeadTask(void);
	bool						ReleaseDeadTask(void);
	
								// _[WRg[AɎl荞ł邩`FbN
	bool						DamagePosCtrlMainCharaInTest(Vec Pos);
	
								// ob̎SԂeXg
	bool						PcDieTest(u32 mainID);
								// ob̎SԂݒ肷
	void						PcDieSet(u32 mainID, int info);
	
								// ob̉ԂeXg
	bool						PcCollectTest(u32 mainID);
								// ob̉Ԃݒ肷
	void						PcCollectSet(u32 mainID, int info);
	
								// ob̌ĂыNԂeXg
	bool						PcReCallTest(u32 mainID);
								// ob̌ĂыNԂݒ肷
	void						PcReCallSet(u32 mainID, int info);
	
								// ob̃LI\ԂeXg
	bool						PcSelOKTest(u32 mainID);
								// ob̃LI\Ԃݒ肷
	void						PcSelOKSet(u32 mainID, int info);
	
								// aoQ[W֘A
	int							GetBpGauge(int type);
	void						SetBpGauge(int type, int Point);
	int							IncBpGauge(int type, int IncPoint);
	
								// ob̎Sԏ
	void						DeadPlayerInit(void);
	
								// ViĨL[Lݒ
	void						InitDefaultReCallChara(void);
	
								// Gjn
	u32							GetTotalEnemyHunt(void);
	u32							IncTotalEnemyHunt(int num);
	void						SetTotalEnemyHunt(u32 num);
	
								// ĂыN񐔊֌W
	u32							GetTotalReCallNum(void);
	u32							IncTotalReCallNum(int num);
	void						SetTotalReCallNum(u32 num);
	
								// Av֌W
	u32							GetCreateSerumVolume(void);
	u32							IncCreateSerumVolume(int num);
	void						SetCreateSerumVolume(u32 num);
	
								// G̑jierp
	u32							GetTvEnemyCount(void);
	u32							IncTvEnemyCount(int num);
	void						SetTvEnemyCount(u32 num);
	
								// eLp[Abvn
	void						GalPowerUp(u8 Lv=KK7BATTLECTRL_GALLV_UP);
	void						DanPowerUp(u8 Lv=KK7BATTLECTRL_DANLV_UP);
	void						MskPowerUp(u8 Lv);
	u8							GetGalPowerUp(void);
	u8							GetDanPowerUp(void);
	u8							GetMskPowerUp(void);
	
								// R{n
	u32							GetComboCount(void);
	u32							IncComboCount(int num);
	void						SetComboCount(u32 num);
	void						ClearComboCount(void);
	
								// AũViItEƂMAXl̎擾
	u32 						GetSerumVolumeMax(K7ScenarioFlow inScenarioFlow);
	
};

#ifdef __KK7BATTLECTRL_CPP__

KK7BattleCtrl BattleCtrl;
GHMGCTASK_HANDLER(KK7BattleCtrlDeadTask);
GHMGCTASK_HANDLER(KK7BattleCtrlDeadTaskTerm);

#else
extern KK7BattleCtrl BattleCtrl;

#endif


#endif



