/*

 	KK7Prim.cpp

 	Creator       : Kawakami Satoshi (GHM)
 	Creation Date : 02/16/2003

*/

#define	__KK7PRIM_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "..Lib\ghmGcDefine.h"
#include "..\Wat\K7App.h"
#include "..\Fujita\C_Font.h"
#include "KK7Prim.h"


/*
	
	RXgN^
	
*/
KK7Prim::KK7Prim()
{
	OSReport( "KK7Prim@called constractor\n" );
}

/*
	
	fXgN^
	
*/
KK7Prim::~KK7Prim()
{
	OSReport( "KK7Prim@called destractor\n" );
}



/*
	
	
	v~eBȕ
	
	
*/
void KK7Prim::Init(KK7PrimController *pKK7PrimController, KK7Texture* inTex)
{
	//eNX`\̂ւ̃|C^ۑ
	if ( inTex != (KK7Texture *)NULL ){
		mpTex		= inTex;
	}else{
		mpTex		= (KK7Texture *)NULL;
	}
	
	//v~eBuɐݒ
	mKind			= GX_TRIANGLESTRIP;
	
	//
	priority		= INIT_PRIORITY;
	w				= 0;
	h				= 0;
	u0				= 0;
	v0				= 0;
	u1				= 0;
	v1				= 0;
	u2				= 0;
	v2				= 0;
	u3				= 0;
	v3				= 0;
	x0				= 0;
	y0				= 0;
	x1				= 0;
	y1				= 0;
	x2				= 0;
	y2				= 0;
	x3				= 0;
	y3				= 0;
	rgba			= 0xffffffff;
	flag			= 0x0;
	scale			= 1;
	
	
	//Xg̍\z(VꂽXvCg͏ɃXg̐擪ɂ悤Xg쐬)
	pPrev			= NULL;
	pNext			= pKK7PrimController->GetPrimTop();
	if( pNext != NULL ){
		pNext->pPrev= this;			//̎̑O=
	}
									//Xg̐擪=
	pKK7PrimController->SetPrimTop(this);
}

/*
	
	
	v~eBu̔j
	
	
*/
void KK7Prim::Term(KK7PrimController *pKK7PrimController)
{
	//Xgč\z
	if( pPrev == NULL ){
									//OȂꍇ̓Xg̃gbv=̎
		pKK7PrimController->SetPrimTop(pNext);
	}else{
		pPrev->pNext	= pNext;	//Oꍇ͎̑O̎=̎
	}
	if( pNext != NULL ){
		pNext->pPrev	= pPrev;	//Xg̍ŌłȂΎ̎̑O=̑O
	}
}



/*
	
	
	QcpJ̐ݒ
	
	
*/
void KK7Prim::SetCamera2D(void)
{
	Mtx			view;
	Mtx44		proj;
	
#if 0
	Vec			vPos;
	Vec			vUp;
	Vec			vAt;
	
	vUp .x =    0.0f;
	vUp .y = -  1.0f;
	vUp .z =    0.0f;
	vPos.x =    0.0f;
	vPos.y =    0.0f;
	vPos.z = -300.0f;		// K
	vAt .x =  vPos.x;
	vAt .y =  vPos.y;
	vAt .z =    0.0f;
	
	// [Jr[ϊ}gNXݒ
	MTXLookAt       (view,&vPos,&vUp,&vAt);
	MTXOrtho        (proj,0,-K7APP_SCREEN_HEIGHT,0,K7APP_SCREEN_WIDTH,100,1000);
#else
	MTXIdentity     (view);
	view[2][3] = -300.f;
	MTXOrtho        (proj,0,K7APP_SCREEN_HEIGHT,0,K7APP_SCREEN_WIDTH,100,1000);
#endif
	
	GXLoadPosMtxImm (view,GX_PNMTX0);
	GXLoadNrmMtxImm (view,GX_PNMTX0);
	GXSetCurrentMtx (GX_PNMTX0);
	GXSetProjection (proj,GX_ORTHOGRAPHIC);
	
	GXSetScissor    (0,0,K7APP_SCREEN_WIDTH,K7APP_SCREEN_HEIGHT);
	GXSetViewport   (0.0f,0.0f,K7APP_SCREEN_WIDTH,K7APP_SCREEN_HEIGHT,0.0f,1.0f);
}


/*
	
	
	2Dptevݒ
	
	
*/
void KK7Prim::Set2DTev(void)
{
	//ArGgJ[ƃ}eAJ[ݒ
//	static	GXColor		ambcol = { 0x40,0x00,0x00,0xff, };
//	static	GXColor		matcol = { 0x00,0x00,0x40,0xff, };
	
	//J
	SetCamera2D();
	
////	GXSetZMode      (GX_FALSE,GX_ALWAYS,GX_FALSE);
////	GXSetZMode      (GX_TRUE,GX_GREATER,GX_TRUE);
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );
////	GXSetZMode      (GX_TRUE,GX_LESS,GX_TRUE);
////	GXSetZMode      (GX_TRUE,GX_ALWAYS,GX_TRUE);
	GXSetColorUpdate( GX_TRUE );
	GXSetAlphaUpdate( GX_TRUE );
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
//	GXSetBlendMode( GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_SRCCLR, GX_LO_CLEAR );
	
	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 1 );
	//eNX`W̕@w聨łGX_TEXCOORD0̍W@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	
	//TEVXe[Wւ̏o͂łJ[`l̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumChans( 1 );
	//GX_COLOR0A0̃CgRg[̐ݒ
	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );
//	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_REG, GX_SRC_REG, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );	//2̖߂Őݒ肷ArGgJ[ƃ}eAJ[gꍇ͂Ăяo
	//ArGgJ[𔽉f
//	GXSetChanAmbColor( GX_COLOR0A0, ambcol );
	//}eAJ[𔽉f
//	GXSetChanMatColor( GX_COLOR0A0, matcol );

	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
//	GXSetTevOp( GX_TEVSTAGE0, GX_REPLACE );
	GXSetTevOp( GX_TEVSTAGE0, GX_MODULATE );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
//	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR_NULL );
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo
	
	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
//	GXSetVtxDesc( GX_VA_NRM,  GX_NONE );	//@̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
	GXSetVtxDesc( GX_VA_TEX0, GX_DIRECT );	//eNX`0̎ނݒ
	
	//ꂼ̗̑vf(?)Ǝނݒ
//	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XY,   GX_S16  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ,  GX_S16  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST,   GX_F32,   0 );	//eNX`0̗vfƎނw
}


/*
	
	
	`揈
	
	
*/
//-----------------------------------------------------------------------------
//XvCg_O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void KK7Prim::RenderPrim(KK7PrimController *pKK7PrimController)
{
	KK7Prim		*pPrim		= pKK7PrimController->GetPrimTop();
	KK7Texture	*pOldTex	= NULL;
	f32			xRate, yRate, s0, t0, s1, t1, s2, t2, s3, t3;

	//tevݒ
	Set2DTev();
	
	//Xg̍ŏXvCg`悷
	while( pPrim ){
		
		//XvCg̊gk
//		mK7SpriteScaleProc( pPrim );
		
		//XvCgړ
//		mK7SpriteMoveProc( pPrim );
		
		//XvCgtF[h
//		mK7SpriteFadeProc( pPrim );
		
		//\tOĂ邩mF
		if( pPrim->flag & 0x01 ){
			
			//eNX`[h
			if(	pOldTex != pPrim->mpTex ){
				GXLoadTexObj( &pPrim->mpTex->obj, GX_TEXMAP0 );
				pOldTex = pPrim->mpTex;
			}
			
			//x1`x3,y1`y3߂
			pPrim->x1 = pPrim->x3 = (s16)(pPrim->x0 + pPrim->w);
			pPrim->x2 = pPrim->x0;
			pPrim->y1 = pPrim->y0;
			pPrim->y2 = pPrim->y3 = (s16)(pPrim->y0 + pPrim->h);
			//u1`u3,v1`v3߂
//			pPrim->u1 = pPrim->u3 = (s16)(pPrim->u0 + pPrim->orgW);
			pPrim->u1 = pPrim->u3 = (s16)(pPrim->u0 + pPrim->w);
			pPrim->u2 = pPrim->u0;
			pPrim->v1 = pPrim->v0;
//			pPrim->v2 = pPrim->v3 = (s16)(pPrim->v0 + pPrim->orgH);
			pPrim->v2 = pPrim->v3 = (s16)(pPrim->v0 + pPrim->h);
			
			//uvl߂邽߂̌vZ
			xRate	= 1.0f / (f32)pPrim->mpTex->mpHeadTex->mWidth;
			yRate	= 1.0f / (f32)pPrim->mpTex->mpHeadTex->mHeight;
			s0		= xRate * (f32)pPrim->u0;
			t0		= yRate * (f32)pPrim->v0;
			s1		= xRate * (f32)pPrim->u1;
			t1		= yRate * (f32)pPrim->v1;
			s2		= xRate * (f32)pPrim->u2;
			t2		= yRate * (f32)pPrim->v2;
			s3		= xRate * (f32)pPrim->u3;
			t3		= yRate * (f32)pPrim->v3;
			
			//gCAOXgbvGX_VTXFMT0g4_̕`
			GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, 4 );
				// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
				GXPosition3s16( pPrim->x0, pPrim->y0, pPrim->priority );
				GXColor1u32   ( pPrim->rgba );
				GXTexCoord2f32( s0, t0 );
				
				GXPosition3s16( pPrim->x1, pPrim->y1, pPrim->priority );
				GXColor1u32   ( pPrim->rgba );
				GXTexCoord2f32( s1, t1 );
				
				GXPosition3s16( pPrim->x2, pPrim->y2, pPrim->priority );
				GXColor1u32   ( pPrim->rgba );
				GXTexCoord2f32( s2, t2 );
				
				GXPosition3s16( pPrim->x3, pPrim->y3, pPrim->priority );
				GXColor1u32   ( pPrim->rgba );
				GXTexCoord2f32( s3, t3 );
			GXEnd();
		}
		
		//̃XvCgփ|C^ړ
		pPrim = pPrim->pNext;
	}
}

// -------------------------------------------------------------------------------------------------


/*
	
	RXgN^
	
*/
KK7PrimController::KK7PrimController()
{
	OSReport( "KK7PrimController@called constractor\n" );
	
	pPrimTop = (KK7Prim *)NULL;
}



/*
	
	fXgN^
	
*/
KK7PrimController::~KK7PrimController()
{
	OSReport( "KK7PrimController@called destractor\n" );
	
	GHM_SAFE_DELETE(pPrimTop);
}

/*
	
	`揈
	
*/

bool KK7PrimController::RenderProcess(void)
{
	if(NULL != pPrimTop){
		pPrimTop->RenderPrim(this);
	}
	return true;
}
