/*

 	KK7Sound.h

 Creator       : Kawakami Satoshi (GHM)
 Creation Date : 02/16/2003

*/

#ifndef	__KK7SOUND_H__
#define	__KK7SOUND_H__

typedef struct {
	int 	inSEno;
	int 	retSEno;
	u8		volMax;
	u8		inMode;
	Vec		pos;
	u32		stageid;
	int		taskEnd;
	u32		evNo;
	s32		charaID;
}LOOPSE;

typedef struct {
	int 	inSEno;
	int 	retSEno;
	u8		volMax;
	u8		volMin;
	Vec		pos;
	u32		stageid;
	int		taskEnd;
	u32		evNo;
	f32		maxDist;
	f32		minDist;
	u32		fadeTime;
}LOOPSE2;

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTask.h"
#include "..\Lib\ghmGcTex.h"
#include "..\Matsu\MK7Sound.h"

#ifdef __KK7SOUND_CPP__
u8 seVolCalc(Vec tPos, u8 volMax, u8 *pGetVol, u8 *pGetPan, int type);
u8 seVolCalc2(Vec tPos, u8 volMax, u8 volMin,u8 *pGetVol,u8 *pGetPan,f32 maxDist,f32 minDist);
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTask);
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTermTask);
LOOPSE *KK7SoundLoopSePlayVolumeChange(Vec Pos, u32 stageid, int inSEno, u8 volMax, u8 inMode, int taskEnd, u32 evNo, s32 charaID);
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTask2);
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTermTask2);
LOOPSE2 *KK7SoundLoopSePlayVolumeChange2(Vec Pos,u32 stageid,int inSEno,u8 volMax,u8 volMin,f32 maxDist,f32 minDist,int taskEnd,u32 evNo,u32 fadeTime);

#else
extern u8 seVolCalc(Vec tPos, u8 volMax, u8 *pGetVol, u8 *pGetPan, int type);
extern u8 seVolCalc2(Vec tPos, u8 volMax, u8 volMin,u8 *pGetVol,u8 *pGetPan,f32 maxDist,f32 minDist);
extern LOOPSE *KK7SoundLoopSePlayVolumeChange(Vec Pos, u32 stageid, int inSEno, u8 volMax=SOUND_EVENT_SE_VOLUME, u8 inMode=0, int taskEnd=0, u32 evNo=0, s32 charaID=-1);
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTask);
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTermTask);
extern	LOOPSE2 *KK7SoundLoopSePlayVolumeChange2(Vec Pos,u32 stageid,int inSEno,u8 volMax=SOUND_EVENT_SE_VOLUME,u8 volMin=SOUND_EVENT_SE_VOLUME/8,f32 maxDist=200.0f,f32 minDist=8.0f,int taskEnd=0,u32 evNo=0,u32 fadeTime=2400);
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTask2);
GHMGCTASK_HANDLER(KK7SoundLoopSePlayVolumeChangeTermTask2);

#endif


#endif



