////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Kawakami Test Task
//
// KK7TestTask.cpp
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 11/28/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__KK7TESTTASK_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "WK7MenuTask.h"
#include "..\Fujita\C_Font.h"

#include "KK7TestTask.h"
#include "KK7DebugMenuTask.h"
#include "KK7BattleMainTask.h"

static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 2.000000f },		// wobj position
//	{ 0.000000f, 5.000000f, 2.000000f },		// wobj position
};

static	float	dir_light_shininess = 50.0f;
static	HSD_LightDesc dir0_light = {
	NULL,
	NULL,
//	&dir2_light,								// link
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{ 128, 128, 128, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};

static HSD_LightDesc amb_light = {
	NULL,
	&dir0_light,
//	&dir_light,									// link
	LOBJ_DIFFUSE,								// flags
	LOBJ_AMBIENT,								// attnflags
	{ 0xff, 0xff, 0xff, 0xff },					// color
	NULL,										// position
	NULL,										// interest
	NULL,
};
static HSD_SceneLightSet amb_lightset = {
	&amb_light,
	NULL,
};



/*
	
	
	RXgN^
	
	
*/
KK7TestTask::KK7TestTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	OSReport( "KK7TestTask called constractor\n" );
	
	// fobOj[̋N
//	debugMenu.KK7DebugMenuStart(&mTaskController);
	
	// og^XNp̏i{ȂXe[W؂ւɃR[
//	mBattelMain.InitScene();
}


/*
	
	
	fXgN^
	
	
*/
KK7TestTask::~KK7TestTask()
{
	OSReport( "KK7TestTask called destractor\n" );
	
	// og^XNp̏Ii{ȂXe[W؂ւɃR[
//	mBattelMain.ExitScene();
}

/*
	
	
	
	
	
*/
bool KK7TestTask::InitializeCallBack(void)
{
	OSReport("Kawakami Killer7 Test Task Init : DefaultHeap = 0x%08x , TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),sizeof(*this));
	
	mpLObj       = new C_LObj(new (&amb_lightset) C_LightSet);
	
/*
	mArchiveController.Initialize();
*/
	
	// Xe[W쐬
	if( (mpStageArchive = WK7Archive::Create())!=NULL ){
		mpStageArchive->LoadArchiveB("savoye.dat");
//		mpPathArchive->LoadArchiveB("savoye_path.dat");
//		mpStage = mpStageArchive->GetPath();
		mpStageModel = mpStageArchive->CreateModel();
	}
	
	// LN^[쐬
	AllCharaCreate();
	
	// Jݒ --------------------------------------------------------------
	// J̃^[Qbgf[h
	mCamera.LoadArchive("crystal.dat");
	mCamera.SetRenderFlag(true);
	
	mCamera.SetMode(WK7Cam::WK7CAM_DEBUG);
	
	return true;
}

/*
	
	
	I
	
	
*/
bool KK7TestTask::TerminateCallBack(void)
{
	ghmGcApp		*pApp = GetApplication();
	
//	mArchiveController.Terminate();
	
	delete this;
	
	new WK7MenuTask(pApp);
	return true;
}


/*
	
	
	t[
	
	
*/
bool KK7TestTask::FrameProcess(void)
{
	s16 i;

											// J
	mCamera.FrameProcess();
	
	mCamera.SetCurrent();
											// A[JCuf[^
	WK7Archive::FrameProcessAll();
	
	// ^XNRg[
	mTaskController.FrameProcess();
	
	for(i=0; i<TEST_STAGE_CHARA_MAX; i++){
		if( mpCharaModel[i] != NULL ){		// Lf̏
			mpCharaModel[i]->FrameProcess();
		}
	}
	
	
	if( mpStageModel != NULL ){				// Xe[Wf̏
		mpStageModel->FrameProcess();
	}
	
	if( HSD_PadGetTrigger(0) & PAD_BUTTON_X ){
		if( DeleteTerminate()==true ){
			return true;
		}
	}
	
	EnemyAI();
	
	if( HSD_PadGetTrigger(0) & PAD_BUTTON_B ){
		
		/*
			
			og^XNN
			
		*/
		
		// f̑Oo^
//		for (i=0; i<TEST_STAGE_CHARA_MAX; i++){
//			mBattelMain.Entry(mpCharaModel[i], (s16 )(i? 1: 0));
//		}
		
		// JNX̃|C^ogɈn
//		mBattelMain.CameraClassSet(&mCamera);
		
		// og^XN̋N
//		if ( false == mBattelMain.BattleMainTaskStart(&mCamera, &mTaskController, &mTaskController) ){
//			mBattelMain.BattleMainTaskExit();
//		}
	}
	
	return true;
}

/*
	
	
	_[it[̂Ɓj
	
	
*/
bool KK7TestTask::RenderProcess(void)
{
	s16 i;

	// sysdolphinԖ
	HSD_StateInvalidate(HSD_STATE_ALL);
	
	// JgJݒ
	if( mCamera.SetCurrent()==true ){
		
		C_LObj::DispStart();
		// Cgo^
		if( mpLObj != NULL ){
			HSD_LObj	*pLObj = mpLObj->GetLObj();
			HSD_LObjSetCurrentAll(pLObj);
		}
		
		C_LObj::DispEnd();
		
		for(i=0; i<TEST_STAGE_CHARA_MAX; i++){
			if( mpCharaModel[i] != NULL ){		// Lf̏
				mpCharaModel[i]->RenderProcess();
			}
		}
		
		if( mpStageModel != NULL ){				// Xe[Wf̕`
			mpStageModel->RenderProcess();
		}
		
		// J̃_[
		mCamera.RenderProcess();
		
		// JgJł̕`I
		mCamera.EndCurrent();
		
	}
	
	return true;
}

/*
	
	
	eXg^XNpALN^[ǂݍ
	
	
*/
bool KK7TestTask::AllCharaCreate(void)
{
	s16 i;

	for (i=0; i<TEST_STAGE_CHARA_MAX; i++){
		// L̓ǂݍ݁쐬
		if( (mpCharaArchive[i] = WK7Archive::Create())!=NULL ){
			mpCharaArchive[i]->LoadArchiveB("enemy.dat");
			mpCharaModel[i] = mpCharaArchive[i]->CreateModel();
			mpCharaModel[i]->Disp(true);
		}
	}
	
	return true;
}



/*
	
	
	GAI
	
	
*/
bool KK7TestTask::EnemyAI(void)
{
	s16 i, radom;

	radom = 0;
	
	// _UtOON
	if( HSD_PadGetTrigger(0) & PAD_BUTTON_Y ){
		radom = 1;
	}
	
	
	for (i=0; i<TEST_STAGE_CHARA_MAX; i++){
		if( mpCharaModel[i] != NULL ){		// Lf̏
			Vec camPos, enePos, dir, eneDir;
			f32 camDir, setDir;
			
			if ( radom ){
				Vec rpos;
				rpos.x = (float )(HSD_Randf() * 100.f);
				rpos.z = (float )(HSD_Randf() * 100.f);
				mpCharaModel[i]->SetPosition(rpos.x, 0.f, rpos.z);
			}
			
			mpCharaModel[i]->GetPosition(&enePos);			// ݒn̎擾
			mpCharaModel[i]->GetRotation(&eneDir);			// ̎擾
			
			// J̕Ɍ
			mCamera.GetPosition(camPos);
			dir.x = camPos.x - enePos.x;
			dir.z = camPos.z - enePos.z;
			camDir = atan2f((f32 )dir.x, (f32 )dir.z);
			setDir = camDir - eneDir.y / 64.f;
			GHM_LIMIT_RANGE(setDir, PI, -PI);
			mpCharaModel[i]->SetRotation(eneDir.x, setDir, eneDir.z);
			
			
			// Ăɕ
			if ( HSD_Randf() < 0.2f ){
				Vec nextPos;
				nextPos.x = enePos.x + 0.5f * sinf(eneDir.y);
				nextPos.z = enePos.z + 0.5f * cosf(eneDir.y);
				mpCharaModel[i]->SetPosition(nextPos.x, 0.f, nextPos.z);
			}
			
		}
	}
	
	return true;
}

