/*

 	KK7Util.cpp

 	Creator       : Kawakami Satoshi (GHM)
 	Creation Date : 02/16/2003

*/

#define	__KK7UTIL_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "KK7Util.h"
#include "..\Fujita\C_Font.h"
#include "..\Wat\WK7MainTask.h"
#include "..\Wat\WK7Cam.h"
#include "..\Kaw\KK7Sound.h"
#include "..\Wat\WK7GameInfo.h"
#include "..\Wat\WK7EventScript.h"
#include "..\Wat\K7GlobalFlag.h"


/*
	
	t@C[hiubN֐j
	
*/
bool KK7Util::FileReadB( char* inFileName, void** inBuff )
{
	//t@CI[v
	if( mFile.Open(inFileName) == false ){
		return false;
	}
	
	//t@Cǂݍ
	if( (*inBuff = mFile.ReadB()) == NULL )
		return false;
	
	//t@CN[Y
	mFile.Close();
	
	//t@Cǂݍݐ
	return true;
}

/*
	
	
	eNX`ǂݍ݊֐
	
	
*/
void KK7Util::InitTexture( KK7Texture* inTex )
{
	//
	GXInitTexObj( &inTex->obj,
				  (void*)((u32)inTex->mpHeadTex + inTex->mpHeadTex->mImagePtr),
				  inTex->mpHeadTex->mWidth,
				  inTex->mpHeadTex->mHeight,
				  inTex->mpHeadTex->mFormat,	// GX_TF_I4,
				  GX_CLAMP,
				  GX_CLAMP,
				  GX_FALSE );
}


/*
	
	
	eNX`J
	
	
*/
void KK7Util::FreeTexture( KK7Texture* inTex )
{
	GHMGCMEM_SAFE_FREE( inTex->mpHeadTex );
}


/*
	
	RXgN^
	
*/
KK7Util::KK7Util()
{
	OSReport( "KK7Util@called constractor\n" );
}

/*
	
	fXgN^
	
*/
KK7Util::~KK7Util()
{
	OSReport( "KK7Util@called destractor\n" );
}



/*
	
	
	pbhU
	
	<in>
	padNo			pbhNO
	frame			U鎞
	
*/
void KK7PadRumble(int padNo, int frame)
{
	if ( K7SCR_GET_GLOBAL_FLAG( K7GLFL_OPT_VIB ) ){
		GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->Start(KK7PadRumbleTask, (u32)padNo, (u32)frame);
	}
}
GHMGCTASK_HANDLER(KK7PadRumbleTask)
{
	u8   pad		= (u8 )task_get_param(0);
	int  frame		= (int )task_get_param(1);

	HSD_PadRumbleOn(pad); 
	
	for (; frame>0; frame--){
		retsys();
	}
	
	HSD_PadRumbleOffH(pad); 
}


/*
	
	
	VecMove
	
	
*/
bool KK7VecMove(Vec *set, Vec *now, f32 div)
{
	f32 tmp;

	// ړ
	tmp = set->x - now->x;
	if ( tmp ){
		now->x += tmp / div;
	}
	tmp = set->y - now->y;
	if ( tmp ){
		now->y += tmp / div;
	}
	tmp = set->z - now->z;
	if ( tmp ){
		now->z += tmp / div;
	}
	
	return true;
}

/*
	
	
	Jh炷
	
	<in>
	padNo			pbhNO
	frame			U鎞
	
*/
void KK7ShakeCamera(f32 *pTable, int cnt)
{
	GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->Start(KK7ShakeCam, (u32)pTable, (u32)cnt);
}


#define SHAKE_COUNTMAX (10)
static f32 shakeTargetYTable[SHAKE_COUNTMAX] = {
	+0.f,
	0.f,
	+0.4f,
	0.f,
	+1.f,
	0.f,
	+1.f,
	0.2f,
	+2.f,
	0.f,
};

GHMGCTASK_HANDLER(KK7ShakeCam)
{
	f32 *pTable		= (f32 *)task_get_param(0);
	int	cnt			= (int )task_get_param(1);
	Vec cpos, ctgt;

	WK7CAM->GetPosition      (cpos);
	WK7CAM->GetTargetPosition(ctgt);
	
	if ( cnt == 0 ){
		cnt = SHAKE_COUNTMAX;
	}
	// h
	while(cnt--){
		Vec setpos = cpos;
		Vec settgt = ctgt;
		f32 shakePoint;
		
		if ( NULL == pTable ){
			shakePoint = shakeTargetYTable[cnt];
		}else{
			shakePoint = pTable[cnt];
		}
		setpos.x  = cpos.x;
		setpos.y  = cpos.y + shakePoint;
		setpos.z  = cpos.z;
		
		settgt.x  = ctgt.x;
		settgt.y  = ctgt.y + shakePoint;
		settgt.z  = ctgt.z;
		
		WK7CAM->SetPosition      (setpos);
		WK7CAM->SetTargetPosition(settgt);
		retsys();
	}
}

