////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube Application
//
// ghmGcApp.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/08/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__GHMGCAPP_H__
#define	__GHMGCAPP_H__

#include "ghmGcMem.h"
#include "ghmGcFile.h"
#include "ghmGcAppTask.h"
#include "ghmGcPerf.h"
#include "ghmGcTask.h"

class ghmGcApp{
private:
	// ĂׂȂ悤ɂ
	void* operator new[](u32 blocksize);
	void operator delete[](void *pblock);
protected:
	bool					mTerminate;						// ItO
	ghmGcAppTask			mTaskAnchor;					// ^XNXg
	int						mIDCounter;						// hcpJE^[
	ghmGcPerf				mPerfMeter;						// ptH[}X[^[
	static volatile bool	mRetraceFlag;
	static volatile u32		mRetraceCount;
	static volatile u32		mRetraceCountDiff;
	static volatile u32		mRetraceFrameCount;
	static volatile u32		mRetraceFrame;
	static volatile u32		mRefreshCount;
	static int				mResetProc;
	static bool				mResetEnable;
	static int				mResetParam;
	static u32				mResetCode;
	static BOOL				mResetForceMenu;
public:
	
	ghmGcApp();
	virtual ~ghmGcApp();
	
	inline static bool SetResetEnable(bool flag){ mResetEnable=flag; return true; }
	inline static bool GetResetEnable(void){ return mResetEnable; }
	static bool SetResetParam(int param);
	inline static int GetResetParam(void){ return mResetParam; }
	inline static bool SetResetCode(u32 code){ mResetCode=code; return true; }
	inline static u32 GetResetCode(void){ return mResetCode; }
	inline bool SetResetForceMenu(BOOL flag){ mResetForceMenu=flag; return true; }
	inline static BOOL GetResetForceMenu(void){ return mResetForceMenu; }
	
	// 
	virtual bool Initialize(void);
	virtual bool SetRetraceCallBack(void);
	
	// I
	virtual bool Terminate(void){ mTerminate = true; return true; }
	
	// s
	virtual bool Run(void);
	
	// _O
	virtual bool PreRenderProcess(void);
	virtual bool RenderProcess(void);
	virtual bool PostRenderProcess(void);
	
	// t[
	virtual bool PreFrameProcess(void);
	virtual bool FrameProcess(void);
	virtual bool PostFrameProcess(void);
	
	// VBlank
	virtual bool SynchronizeVBlank(void);
	virtual bool ResetProcess(void);
	
	// RetraceCallBack
	static void PreRetraceCallBack(u32 retraceCount);
	static void PostRetraceCallBack(u32 retraceCount);
	
	inline ghmGcAppTask* GetTaskAnchor(void){ return &mTaskAnchor; }
	
	int GenerateUniqueID(void);
	
	ghmGcAppTask* GetTask(int id);
	
	inline void SetVisiblePerfMeter(bool flag){ mPerfMeter.SetVisible(flag); }
	inline bool GetVisiblePerfMeter(void){ return mPerfMeter.GetVisible(); }
	inline void SetEnablePerfMeter(bool flag){ mPerfMeter.SetEnable(flag); }
	inline bool GetEnablePerfMeter(void){ return mPerfMeter.GetEnable(); }
	
	volatile static void SetRetraceFrame(u32 frame){ mRetraceFrame=frame; }
	volatile static u32 GetRetraceFrame(void){ return mRetraceFrame; }
	volatile static u32 GetRetraceFrameCount(void){ return mRetraceFrameCount; }
	volatile static u32 GetRetraceCount(void){ return mRetraceCount; }
	volatile static bool GetRetraceFlag(void){ return mRetraceFlag; }
	volatile static u32 GetRefreshCount(void){ return mRefreshCount; }
};

#endif	//__GHMGCAPP_H__

