////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube Performance Meter
//
// ghmGcPerf.h
//
// Creator       : Fujita Yoshikazu
// Modified      : Watanabe Kazuhisa (GHM)
// Creation Date : 11/20/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__GHMGCPERF_CPP__

#include <dolphin.h>
#include <dolphin\base\PPCArch.h>

#include "ghmGcPerf.h"

#include "..\Fujita\C_Font.h"

#define	GHMGCPERF_METRIC_MAX			(17 * 3)
//#define	GHMGCPERF_METRIC_MAX			(17 * 2 * 3)

bool ghmGcSprite::SetRenderMode(void)
{
	
	// _OXe[gݒ
//	GXSetZMode       (GX_FALSE,GX_ALWAYS,GX_FALSE);
//	GXSetZMode       (GX_TRUE,GX_LESS,GX_TRUE);
	GXSetZMode       (GX_TRUE,GX_LEQUAL,GX_TRUE);
//	GXSetZMode       (GX_FALSE,GX_LEQUAL,GX_TRUE);
	GXSetColorUpdate (GX_TRUE);
	GXSetAlphaUpdate (GX_TRUE);
	GXSetBlendMode   (GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	
	// ǂ̑_tH[}bgɂ邩w肵ACfbNXQƂA_CNgQƂw
	GXClearVtxDesc   ();
	GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
	GXSetVtxDesc     (GX_VA_NRM ,GX_NONE  );
	GXSetVtxDesc     (GX_VA_CLR0,GX_DIRECT);
	GXSetVtxDesc     (GX_VA_TEX0,GX_NONE  );
	
	GXSetNumTexGens  (0);
	GXSetNumTevStages(1);
	
	// X^CYJ[̂܂܏o
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR0A0);
	GXSetTevOp       (GX_TEVSTAGE0,GX_PASSCLR);
	
	// _J[gp
	GXSetNumChans(1);
	GXSetChanCtrl(GX_COLOR0A0,GX_FALSE,GX_SRC_VTX,GX_SRC_VTX,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
//	GXSetChanCtrl(GX_COLOR0A0,GX_FALSE,GX_SRC_VTX,GX_SRC_VTX,GX_LIGHT0,GX_DF_NONE,GX_AF_NONE);
	
	static	GXColor		ambcol = { 0x40,0x00,0x00,0xff, };
	static	GXColor		matcol = { 0x00,0x00,0x40,0xff, };
	
	GXSetChanAmbColor(GX_COLOR0A0,ambcol);
	GXSetChanMatColor(GX_COLOR0A0,matcol);
	
	// JOȂ
	GXSetCullMode    (GX_CULL_NONE);
	
	// ꂼ̗̑vfƎނw
	GXSetVtxAttrFmt(GX_VTXFMT1,GX_VA_POS ,GX_POS_XYZ ,GX_S16  ,0);
	GXSetVtxAttrFmt(GX_VTXFMT1,GX_VA_CLR0,GX_CLR_RGBA,GX_RGBA8,0);
	
	return true;
}

#define	SCREEN_WIDTH		(640)
#define	SCREEN_HEIGHT		(480)
bool ghmGcSprite::RenderStart(void)
{
	
	Mtx			view;
	Mtx44		proj;
	
	Vec			vPos;
	Vec			vUp;
	Vec			vAt;
	
	vUp .x =    0.0f;
	vUp .y = -  1.0f;
	vUp .z =    0.0f;
	vPos.x =    0.0f;
	vPos.y =    0.0f;
	vPos.z =    0.0f;
	vAt .x =  vPos.x;
	vAt .y =  vPos.y;
	vAt .z =  100.0f;
	
	// [Jr[ϊ}gNXݒ
	MTXLookAt       (view,&vPos,&vUp,&vAt);
	MTXOrtho        (proj,0,-SCREEN_HEIGHT,0,SCREEN_WIDTH,0,1000);
	
	GXLoadPosMtxImm (view,GX_PNMTX0);
	GXLoadNrmMtxImm (view,GX_PNMTX0);
	GXSetCurrentMtx (GX_PNMTX0);
	GXSetProjection (proj,GX_ORTHOGRAPHIC);
	
	GXSetScissor    (0,0,SCREEN_WIDTH,SCREEN_HEIGHT);
	GXSetViewport   (0.0f,0.0f,SCREEN_WIDTH,SCREEN_HEIGHT,0.0f,1.0f);
	
	SetRenderMode();
	
	return true;
}

bool ghmGcSprite::RenderEnd(void)
{
	return true;
}

bool ghmGcSpriteF::Render(void)
{
	short		r,b;
	
	r = (short)(mLeft + mWidth );
	b = (short)(mTop  + mHeight);
	
	if( mLeft < 0 && r < 0 ){
		return true;
	}
	
	if( mLeft > GHM_SCREEN_WIDTH && r > GHM_SCREEN_WIDTH ){
		return true;
	}
	
	if( mTop < 0 && b < 0 ){
		return true;
	}
	
	if( mTop > GHM_SCREEN_HEIGHT && b > GHM_SCREEN_HEIGHT ){
		return true;
	}
	
	// v~eBu̎ނw
	GXBegin(GX_QUADS,GX_VTXFMT1,4);
		
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		GXPosition3s16(mLeft          , mTop           , mLayer);
		GXColor1u32   (mColor32);
		
		GXPosition3s16(r              , mTop           , mLayer);
		GXColor1u32   (mColor32);
		
		GXPosition3s16(r              , b              , mLayer);
		GXColor1u32   (mColor32);
		
		GXPosition3s16(mLeft          , b              , mLayer);
		GXColor1u32   (mColor32);
		
	GXEnd();
	
	return true;
}

volatile ghmGcPerfMetricInfo	ghmGcPerf::mMetricInfo[2];
volatile int					ghmGcPerf::mMetricIndex;
OSAlarm							ghmGcPerf::mAlarm;
OSTime							ghmGcPerf::mAlarmStartTime;
//OSStopwatch						ghmGcPerf::mSwProc;
//OSStopwatch						ghmGcPerf::mSwRender;
float							ghmGcPerf::mSamplingTime;
u32								ghmGcPerf::mProcEventCycleMax = 0;
u32								ghmGcPerf::mRenderEventCycleMax = 0;

ghmGcPerf::AllocFunc			*ghmGcPerf::mpAllocFunc = NULL;
ghmGcPerf::FreeFunc				*ghmGcPerf::mpFreeFunc  = NULL;

ghmGcPerfMetric					mPrevMetric;

#define	METRIC_DIFF(a,b)		( a < b )? a : a - b;

void alarmHandler(OSAlarm */*pAlarm*/,OSContext */*pContext*/);
void alarmHandler(OSAlarm */*pAlarm*/,OSContext */*pContext*/)
{
//	ghmGcPerfMetric					*pMetric = (ghmGcPerfMetric *)ghmGcPerf::Alloc(sizeof(ghmGcPerfMetric));
	ghmGcPerfMetric					*pMetric;
	volatile ghmGcPerfMetricInfo	*pInfo   = ghmGcPerf::GetCurrentMetricInfo();
//	OSTime							now;
	
	if( pInfo->mMetricCnt >= GHMGCPERF_METRIC_MAX ){
		return;
	}
	
#if 1
	pMetric = pInfo->mpMetricTop + pInfo->mMetricCnt;
#else
	if( pInfo->mpMetricLast==NULL ){
		pInfo->mpMetricTop          = pMetric;
	}else{
		pInfo->mpMetricLast->mpNext = pMetric;
	}
	pInfo->mpMetricLast = pMetric;
	pMetric->mpNext = NULL;
#endif
	pInfo->mMetricCnt++;
	
//	now = OSDiffTick(OSGetTime(),ghmGcPerf::GetAlarmStartTime());
//	pMetric->mTime = (s32)OSTicksToMilliseconds(now);
	
	GXReadMemMetric(&pMetric->mCpReq,
	                &pMetric->mTcReq,
	                &pMetric->mCpuRdReq,
	                &pMetric->mCpuWrReq,
	                &pMetric->mDspReq,
	                &pMetric->mIoReq,
	                &pMetric->mViReq,
	                &pMetric->mPeReq,
	                &pMetric->mRfReq,
	                &pMetric->mFiReq);
	GXReadPixMetric(&pMetric->mTopPixelsIn,
	                &pMetric->mTopPixelsOut,
	                &pMetric->mBotPixelsIn,
	                &pMetric->mBotPixelsOut,
	                &pMetric->mClrPixelsIn,
	                &pMetric->mCopyClks);
	GXReadGPMetric(&pMetric->mGp0Cnt,&pMetric->mGp1Cnt);
	
	pMetric->mDiffCpReq          = METRIC_DIFF(pMetric->mCpReq   ,mPrevMetric.mCpReq   );
	pMetric->mDiffTcReq          = METRIC_DIFF(pMetric->mTcReq   ,mPrevMetric.mTcReq   );
	pMetric->mDiffCpuRdReq       = METRIC_DIFF(pMetric->mCpuRdReq,mPrevMetric.mCpuRdReq);
	pMetric->mDiffCpuWrReq       = METRIC_DIFF(pMetric->mCpuWrReq,mPrevMetric.mCpuWrReq);
	pMetric->mDiffDspReq         = METRIC_DIFF(pMetric->mDspReq  ,mPrevMetric.mDspReq  );
	pMetric->mDiffIoReq          = METRIC_DIFF(pMetric->mIoReq   ,mPrevMetric.mIoReq   );
	pMetric->mDiffViReq          = METRIC_DIFF(pMetric->mViReq   ,mPrevMetric.mViReq   );
	pMetric->mDiffPeReq          = METRIC_DIFF(pMetric->mPeReq   ,mPrevMetric.mPeReq   );
	pMetric->mDiffRfReq          = METRIC_DIFF(pMetric->mRfReq   ,mPrevMetric.mRfReq   );
	pMetric->mDiffFiReq          = METRIC_DIFF(pMetric->mFiReq   ,mPrevMetric.mFiReq   );
	
	pMetric->mDiffTopPixelsIn    = METRIC_DIFF(pMetric->mTopPixelsIn ,mPrevMetric.mTopPixelsIn );
	pMetric->mDiffTopPixelsOut   = METRIC_DIFF(pMetric->mTopPixelsOut,mPrevMetric.mTopPixelsOut);
	pMetric->mDiffBotPixelsIn    = METRIC_DIFF(pMetric->mBotPixelsIn ,mPrevMetric.mBotPixelsIn );
	pMetric->mDiffBotPixelsOut   = METRIC_DIFF(pMetric->mBotPixelsOut,mPrevMetric.mBotPixelsOut);
	pMetric->mDiffClrPixelsIn    = METRIC_DIFF(pMetric->mClrPixelsIn ,mPrevMetric.mClrPixelsIn );
	pMetric->mDiffCopyClks       = METRIC_DIFF(pMetric->mCopyClks    ,mPrevMetric.mCopyClks    );
	
	pMetric->mDiffGp0Cnt         = METRIC_DIFF(pMetric->mGp0Cnt      ,mPrevMetric.mGp0Cnt      );
	pMetric->mDiffGp1Cnt         = METRIC_DIFF(pMetric->mGp1Cnt      ,mPrevMetric.mGp1Cnt      );
	
	pMetric->mPmcInstruction     = PPCMfpmc1();
	pMetric->mPmcLoadStore       = PPCMfpmc2();
	pMetric->mPmcLlMissCycle     = PPCMfpmc3();
	pMetric->mPmcCycle           = PPCMfpmc4();
	
	pMetric->mDiffPmcInstruction = METRIC_DIFF(pMetric->mPmcInstruction,mPrevMetric.mPmcInstruction);
	pMetric->mDiffPmcLoadStore   = METRIC_DIFF(pMetric->mPmcLoadStore  ,mPrevMetric.mPmcLoadStore  );
	pMetric->mDiffPmcLlMissCycle = METRIC_DIFF(pMetric->mPmcLlMissCycle,mPrevMetric.mPmcLlMissCycle);
	pMetric->mDiffPmcCycle       = METRIC_DIFF(pMetric->mPmcCycle      ,mPrevMetric.mPmcCycle      );
	
	mPrevMetric                  = *pMetric;
	
}

ghmGcPerfMetric					metric[2];
bool ghmGcPerf::Start(void)
{
	// start measurement frame
	if( mSetAlarm ){
		PPCMtmmcr1(0);
		PPCMtmmcr0(0);
		OSCancelAlarm(&mAlarm);
		mSetAlarm = 0;
	}
	if( !mEnable || mpAllocFunc==NULL || mpFreeFunc==NULL ){
		return false;
	}
	
	mStart    = 1;
	mSetAlarm = 1;
	
	// vԊu
	OSTime		period = (OSTime)OSMillisecondsToTicks(mSamplingTime);
	
	// obt@؂ւ
	volatile ghmGcPerfMetricInfo		*pMetricInfo;
	pMetricInfo   = mMetricInfo + mMetricIndex;
	pMetricInfo->mTotalTime = PPCMfpmc4();
	mMetricIndex ^= 1;
	pMetricInfo   = mMetricInfo + mMetricIndex;
	pMetricInfo->mMetricCnt   = 0;
	
	// vJE^NA
	GXClearMemMetric  ();
	GXClearGPMetric   ();
	GXClearPixMetric  ();
	
	// vJnԎ擾
	mAlarmStartTime = OSGetTime();
	
	OSSetPeriodicAlarm(&mAlarm,
	                   mAlarmStartTime,
	                   period,
	                   alarmHandler);
	
//	OSResetStopwatch(&mSwProc  );
//	OSResetStopwatch(&mSwRender);
	
	PPCMtpmc1(0);
	PPCMtpmc2(0);
	PPCMtpmc3(0);
	PPCMtpmc4(0);
	PPCMtmmcr0(MMCR0_PMC1_INSTRUCTION  |MMCR0_PMC2_LOAD_STORE);
	PPCMtmmcr1(MMCR1_PMC3_L1_MISS_CYCLE|MMCR1_PMC4_CYCLE     );
	
	return true;
}

bool ghmGcPerf::End(void)
{
	
	if( !mStart ){
		return false;
	}
	
	switch( mFlag & (GHMGCPERF_RENDER|GHMGCPERF_PROC) ){
	case	GHMGCPERF_RENDER:
		EndRender();
		break;
	case	GHMGCPERF_PROC:
		EndProc();
		break;
	case	GHMGCPERF_RENDER|GHMGCPERF_PROC:
		EndProc();
		EndRender();
		break;
	default:
		break;
	}
	
	mStart = 0;
	return true;
}

bool ghmGcPerf::StartProc(void)
{
	switch( mFlag & (GHMGCPERF_PROC|GHMGCPERF_START) ){
	case	GHMGCPERF_START:
		break;
	default:
		return false;
	}
	volatile ghmGcPerfMetricInfo	*pMetricInfo = mMetricInfo + mMetricIndex;
//	OSStartStopwatch(&mSwProc);
	pMetricInfo->mProcEvent.mStartCycle = PPCMfpmc4();
	mProc = 1;
	return true;
}

bool ghmGcPerf::EndProc(void)
{
	switch( mFlag & (GHMGCPERF_PROC|GHMGCPERF_START) ){
	case	GHMGCPERF_START|GHMGCPERF_PROC:
		break;
	default:
		return false;
	}
	volatile ghmGcPerfMetricInfo	*pMetricInfo = mMetricInfo + mMetricIndex;
//	OSStopStopwatch(&mSwProc);
	pMetricInfo->mProcEvent.mEndCycle = PPCMfpmc4();
	pMetricInfo->mProcEvent.mCycle    = pMetricInfo->mProcEvent.mEndCycle - pMetricInfo->mProcEvent.mStartCycle;
	if( mProcEventCycleMax < pMetricInfo->mProcEvent.mCycle ){
		mProcEventCycleMax = pMetricInfo->mProcEvent.mCycle;
	}
//	pMetricInfo->mProcTime = (u32)OSCheckStopwatch(&mSwProc);
	mProc = 0;
	
	return true;
}

bool ghmGcPerf::StartRender(void)
{
	switch( mFlag & (GHMGCPERF_RENDER|GHMGCPERF_START) ){
	case	GHMGCPERF_START:
		break;
	default:
		return false;
	}
	volatile ghmGcPerfMetricInfo	*pMetricInfo = mMetricInfo + mMetricIndex;
//	OSStartStopwatch(&mSwRender);
	pMetricInfo->mRenderEvent.mStartCycle = PPCMfpmc4();
	mRender = 1;
	
	return true;
}

bool ghmGcPerf::EndRender(void)
{
	
	switch( mFlag & (GHMGCPERF_RENDER|GHMGCPERF_START) ){
	case	GHMGCPERF_START|GHMGCPERF_RENDER:
		break;
	default:
		return false;
	}
	volatile ghmGcPerfMetricInfo	*pMetricInfo = mMetricInfo + mMetricIndex;
//	OSStopStopwatch(&mSwRender);
	pMetricInfo->mRenderEvent.mEndCycle = PPCMfpmc4();
	pMetricInfo->mRenderEvent.mCycle    = pMetricInfo->mRenderEvent.mEndCycle - pMetricInfo->mRenderEvent.mStartCycle;
	if( mRenderEventCycleMax < pMetricInfo->mRenderEvent.mCycle ){
		mRenderEventCycleMax = pMetricInfo->mRenderEvent.mCycle;
	}
//	pMetricInfo->mRenderTime = (u32)OSCheckStopwatch(&mSwRender);
	mRender = 0;
	
	// ptH[}X[^[\
	Draw();
	
	return true;
}

#define	SCREEN_WIDTH		(640)
#define	SCREEN_HEIGHT		(480)

#define	WIDTH_MARGIN		(16)
#define	BAR_WIDTH_MAX		((float)(SCREEN_WIDTH - WIDTH_MARGIN * 2))

#define	CPUBAR_HEIGHT		(2)
#define	CPUBAR_POS			(SCREEN_HEIGHT - CPUBAR_HEIGHT * 2 - 32)

#define	XFBAR_HEIGHT_MAX	(32)
#define	XFBAR_POS			(CPUBAR_POS - XFBAR_HEIGHT_MAX - 2)

#define	PFBAR_HEIGHT_MAX	(32)
#define	PFBAR_POS			(XFBAR_POS - PFBAR_HEIGHT_MAX - 2)

#define	WIDTH_SCALE(cycle)	((cycle) * BAR_WIDTH_MAX / pInfo->mTotalTime)

#define	CLOCK_PER_FRAME		(OS_CORE_CLOCK/60)
#define	CLOCK_MARGIN		(10000)
#define	BUSCLOCK_PER_SAMPLE	((OS_BUS_CLOCK/1000) * mSamplingTime)

#define	PIXEL_PER_SAMPLE	((648*1000*(1000/1000)) * mSamplingTime)		// 648M pixel/sec

bool ghmGcPerf::Draw(void)
{
	
	if( !mVisible ){
		return false;
	}
	
	ghmGcSpriteF					sprite;
	volatile ghmGcPerfMetricInfo	*pInfo = &mMetricInfo[mMetricIndex^1];
	ghmGcPerfMetric					*pMetric;
	int								frame,frames;
	
	ghmGcSprite::RenderStart();
	
	sprite.mTop    = CPUBAR_POS;
	sprite.mHeight = CPUBAR_HEIGHT;
	sprite.mLayer  = 0;
	
	sprite.mLeft   = (short)(WIDTH_MARGIN + WIDTH_SCALE(pInfo->mProcEvent  .mStartCycle));
	sprite.mWidth  = (short)(               WIDTH_SCALE(pInfo->mProcEvent  .mCycle     ));
	sprite.mColor32 = 0x00ff00ff;
	sprite.Render();
	
	sprite.mLeft   = (short)(WIDTH_MARGIN + WIDTH_SCALE(pInfo->mRenderEvent.mStartCycle));
	sprite.mWidth  = (short)(               WIDTH_SCALE(pInfo->mRenderEvent.mCycle     ));
	sprite.mColor32 = 0xff0000ff;
	sprite.Render();
	
	frames         = (int)((pInfo->mTotalTime + CLOCK_MARGIN)/ CLOCK_PER_FRAME);
	sprite.mTop   += CPUBAR_HEIGHT;
	sprite.mLeft   = (short)(WIDTH_MARGIN);
	sprite.mWidth  = (short)(BAR_WIDTH_MAX / frames);
	for(frame=0 ; frame<frames ; frame++){
		if( frame & 1 ){
			sprite.mColor32 = 0x0000ff80;
		}else{
			sprite.mColor32 = 0xffffff80;
		}
		sprite.Render();
		sprite.mLeft   += sprite.mWidth;
	}
	
	ghmGcSpriteF	sprite_pf;
	int				cnt = pInfo->mMetricCnt;
	
	sprite_pf.mLayer   = 0;
	
	sprite   .mTop     = (short)(XFBAR_POS + XFBAR_HEIGHT_MAX);
	sprite   .mColor32 = 0xffffff40;
	sprite_pf.mTop     = (short)(PFBAR_POS + PFBAR_HEIGHT_MAX);
	sprite_pf.mColor32 = 0xffffff40;
	sprite   .mLeft    = 
	sprite_pf.mLeft    = (short)WIDTH_MARGIN;
	sprite   .mWidth   = 
	sprite_pf.mWidth   = -2;
	sprite   .mHeight =  -XFBAR_HEIGHT_MAX;
	sprite_pf.mHeight =  -PFBAR_HEIGHT_MAX;
	sprite   .Render();
	sprite_pf.Render();
	
	pMetric = pInfo->mpMetricTop;
	
	sprite   .mTop     = (short)(XFBAR_POS + XFBAR_HEIGHT_MAX);
	sprite   .mColor32 = 0x00ff0040;
	sprite_pf.mTop     = (short)(PFBAR_POS + PFBAR_HEIGHT_MAX);
	sprite_pf.mColor32 = 0xff000040;
	
	while( cnt>0 ){
		
		sprite   .mHeight = (short)(-((float)XFBAR_HEIGHT_MAX * (pMetric->mDiffGp0Cnt     ) / BUSCLOCK_PER_SAMPLE));
		sprite_pf.mHeight = (short)(-((float)PFBAR_HEIGHT_MAX * (pMetric->mDiffClrPixelsIn) / PIXEL_PER_SAMPLE   ));
		
		
		sprite   .mWidth  = 
		sprite_pf.mWidth  = (short)WIDTH_SCALE(pMetric->mDiffPmcCycle);
		
		sprite   .Render();
		sprite_pf.Render();
		
		sprite   .mLeft += sprite   .mWidth;
		sprite_pf.mLeft += sprite_pf.mWidth;
		
		pMetric++;
		cnt--;
		
	}
	
	ghmGcSprite::RenderEnd();
	
#if 0
	{
		C_Paper		paper(0,0);
//		OSTime		proctime,rendertime;
		volatile ghmGcPerfMetricInfo	*pInfo = &mMetricInfo[mMetricIndex^1];
		
		PRINTF("\n\n\n\n\n\n\n\n\n");
		
//		proctime   = OSCheckStopwatch(&mSwProc  );
//		rendertime = OSCheckStopwatch(&mSwRender);
		
//		PRINTF("  Proc   : %d,%d,%d,%d\n",(u32)mSwProc  .total,(u32)mSwProc  .min,(u32)mSwProc  .max,(u32)mSwProc  .last);
//		PRINTF("  Render : %d,%d,%d,%d\n",(u32)mSwRender.total,(u32)mSwRender.min,(u32)mSwRender.max,(u32)mSwRender.last);
//		
//		PRINTF("  Proc   : %d,%d,%d\n",mSwProc  .hits,(u32)proctime  ,mSwProc  .running);
//		PRINTF("  Render : %d,%d,%d\n",mSwRender.hits,(u32)rendertime,mSwRender.running);
		
		PRINTF("  Proc   : %d,%d,%d\n",pInfo->mProcEvent  .mCycle,pInfo->mProcEvent  .mStartCycle,pInfo->mProcEvent  .mEndCycle);
		PRINTF("  Render : %d,%d,%d\n",pInfo->mRenderEvent.mCycle,pInfo->mRenderEvent.mStartCycle,pInfo->mRenderEvent.mEndCycle);
		PRINTF("  Total  : %d\n",pInfo->mTotalTime);
		
		PRINTF("  PPCM   : I:%d L/S:%d\n"
		       "           M:%d C:%d\n",PPCMfpmc1(),PPCMfpmc2(),PPCMfpmc3(),PPCMfpmc4());
		
		PRINTF("  Clock  : %d,%d,%d\n",OS_CORE_CLOCK,OS_BUS_CLOCK,OS_TIMER_CLOCK);
		PRINTF("  Cyc/F  : %d\n",OS_CORE_CLOCK/60);
		
	}
#endif
	
	return true;
}

bool ghmGcPerf::ResetMetric(void)
{
	mProcEventCycleMax   = 0;
	mRenderEventCycleMax = 0;
	return true;
}

ghmGcPerf::ghmGcPerf()
{
}

ghmGcPerf::~ghmGcPerf()
{
}

void ghmGcPerf::SetEnable(bool flag)
{
	mEnable = (flag==true)? 1:0;
	ResetMetric();
}

void ghmGcPerf::SetVisible(bool flag)
{
	mVisible = (flag==true)? 1:0;
	ResetMetric();
}

bool ghmGcPerf::Initialize(void)
{
//	GXSetGPMetric   (GX_PERF0_XF_BOT_CLKS ,GX_PERF1_TEXELS);
	GXSetGPMetric   (GX_PERF0_XF_XFRM_CLKS,GX_PERF1_TEXELS);
//	GXSetGPMetric   (GX_PERF0_TRIANGLES_SCISSORED,GX_PERF1_TEXELS);
	GXClearMemMetric();
	GXClearGPMetric ();
	GXClearPixMetric();
	OSCreateAlarm   (&mAlarm);
	
	memset((void *)mMetricInfo,0,sizeof(mMetricInfo));
	mMetricIndex   = 0;
	memset((void *)&mPrevMetric,0,sizeof(mPrevMetric));
	
	ghmGcPerfMetric		*pMetric;
	int					i;
	
	for(i=0 ; i<2 ; i++){
		ghmGcMemSetAllocName("PerfMtr");
		pMetric = (ghmGcPerfMetric *)ghmGcPerf::Alloc(sizeof(ghmGcPerfMetric) * GHMGCPERF_METRIC_MAX);
		memset((void *)pMetric,0,sizeof(ghmGcPerfMetric) * GHMGCPERF_METRIC_MAX);
		mMetricInfo[i].mpMetricTop = pMetric;
	}
	
	mFlag       = 0;
	
	mSamplingTime = 1.0f;
	
//	OSInitStopwatch (&mSwProc  ,"ghmGcPerfProc"  );
//	OSInitStopwatch (&mSwRender,"ghmGcPerfRender");
	
	return true;
}

void* ghmGcPerf::Alloc(u32 size)
{
	if( mpAllocFunc==NULL ){
		return NULL;
	}
	return mpAllocFunc(size);
}

bool ghmGcPerf::Free(void *ptr)
{
	if( mpFreeFunc==NULL ){
		return false;
	}
	mpFreeFunc(ptr);
	return true;
}

