////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7CharaDisp
//
// mK7CharaDisp.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 02/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7CHARADISP_CPP__

//---- include ----
#include "..\Wat\WK7Define.h"
#include "mK7CharaDisp.h"

//---- define ----
#define	CHARA_DISP_LINE_NO				(0)				//f[^̒̂̃vOŎgps
#define	CHARA_DISP_SPACE_WIDTH			(12)			//Sp̃Xy[X
#define	CHARA_DISP_COLOR_NAME			(0xffffff00)	//O\F
#define	CHARA_DISP_COLOR_NAME_SHADOW	(0x00000000)	//O\FEe
#define	CHARA_DISP_COLOR_ALPHA			(0xff)			//O\FEl
#define	CHARA_DISP_DEFAULT_FADE_TICK	(480*3)			//W̕\Ɣ\ɂtF[h

//---- O[oϐ ----
MK7CharaDispMng*	gpCharaDispMng = NULL;
MK7CharaDisp*		gpCharaDispTop = NULL;




//==============================
//====== X̕f[^ ======
//==============================
//-----------------------------------------------------------------------------
//RXgN^
//-----------------------------------------------------------------------------
MK7CharaDisp::MK7CharaDisp()
{
	//eNX`NA
	mClearSprt();
	//Xg̍\z(VꂽXvCg͏ɃXg̐擪ɂ悤Xg쐬)
	mPrev = NULL;
	mNext = gpCharaDispTop;
	if( mNext != NULL )
	{
		//̎̑O=
		mNext->mPrev = this;
	}
	//Xg̐擪=
	gpCharaDispTop = this;
}
//-----------------------------------------------------------------------------
//fXgN^
//-----------------------------------------------------------------------------
MK7CharaDisp::~MK7CharaDisp()
{
	//eNX`NA
	mClearSprt();
	//Xgč\z
	if( mPrev == NULL )
	{
		//OȂꍇ̓Xg̃gbv=̎
		gpCharaDispTop = mNext;
	}else
	{
		//Oꍇ͎̑O̎=̎
		mPrev->mNext = mNext;
	}
	if( mNext != NULL )
	{
		//Xg̍ŌłȂΎ̎̑O=̑O
		mNext->mPrev = mPrev;
	}
}
//-----------------------------------------------------------------------------
//eNX`f[^̃NA
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7CharaDisp::mClearSprt( void )
{
	int	i, j;
	
	//XvCgݒ
	for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		//
		mSprt[i].chara.mSetDispFlag( false );
		mSprt[i].chara.mRelateTex( NULL );
		//
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprt[i].shadow[j].mSetDispFlag( false );
			mSprt[i].shadow[j].mRelateTex( NULL );
		}
	}
}
//-----------------------------------------------------------------------------
//\NGXg
// in --> s16 inNo    \ԍ
//        s16 inX     \XW
//        s16 inY     \YW
//        s32 inTick  \(ȗmRelease֐Ă΂܂ŕ\܂)
// out -> bool false  \NGXgs
//             true   \NGXg
//-----------------------------------------------------------------------------
bool
MK7CharaDisp::mRequest( s16 inNo, s16 inX, s16 inY, s32 inTick )
{
	int				i, j;
	s16				dat, charIndex, width;
	s32				fadeTick[JIMAKU_SPRT_MAX];
	stOneSentence*	sentence;
	stFontParam*	fontparam;
	stTexture*		tex;
	
	//}l[W[ƃf[^Ȃ΃NGXgł܂
	if( (gpCharaDispMng == NULL) || (gpCharaDispMng->mGetDataExist() == false) )
	{
		return( false );
	}
	
	//͂̓Ăf[^ւ̃|C^擾
	sentence  = gpCharaDispMng->mGetSentenceDat();
	//tHgp[^̃|C^擾
	fontparam = gpCharaDispMng->mGetFontParamPtr();
	//eNX`̃|C^擾
	tex       = gpCharaDispMng->mGetTexPtr();
	
	//XvCg
	mClearSprt();
	
	//\ԕۑ
	mDispTick = inTick;
	
	//XvCgXvCg̊eݒ
	for( i = charIndex = width = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		dat = sentence[inNo].jimaku[CHARA_DISP_LINE_NO].chardat[charIndex];
		//sm
		if( dat == (s16)JIMAKU_RETURN )
		{
			break;
		}else
		//SpXy[Xm
		if( (dat == (s16)JIMAKU_SPACE_H) || (dat == (s16)JIMAKU_SPACE_Z) )
		{
			width += CHARA_DISP_SPACE_WIDTH;
			i--;	//XvCgID͐i߂Ȃ
		}else
		{
			//tF[hɂ鎞ԎZo
			fadeTick[i] = HSD_Randi(CHARA_DISP_DEFAULT_FADE_TICK) + 1;
			//--  --
			mSprt[i].chara.mRelateTex( tex );
			mSprt[i].chara.mSetU0( (s16)fontparam[dat].u );
			mSprt[i].chara.mSetV0( (s16)fontparam[dat].v );
#ifdef	_DEBUG
			if( GETCAPTUREMODE() ){
				mSprt[i].chara.mSetWH(0,0);
			}else{
#endif
			mSprt[i].chara.mSetWH( (s16)fontparam[dat].w, (s16)fontparam[dat].h );
#ifdef	_DEBUG
			}
#endif
			mSprt[i].chara.mSetX0( (s16)(inX + width) );
			mSprt[i].chara.mSetY0( inY );
			mSprt[i].chara.mSetRGBA( CHARA_DISP_COLOR_NAME );
			mSprt[i].chara.mSetFade( CHARA_DISP_COLOR_ALPHA, fadeTick[i] );
			mSprt[i].chara.mSetDispFlag( true );
			//--  --
			for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
			{
				mSprt[i].shadow[j].mRelateTex( tex );
				mSprt[i].shadow[j].mSetU0( (s16)fontparam[dat].u );
				mSprt[i].shadow[j].mSetV0( (s16)fontparam[dat].v );
#ifdef	_DEBUG
				if( GETCAPTUREMODE() ){
					mSprt[i].shadow[j].mSetWH(0,0);
				}else{
#endif
				mSprt[i].shadow[j].mSetWH( (s16)fontparam[dat].w, (s16)fontparam[dat].h );
#ifdef	_DEBUG
				}
#endif
				switch( j )
				{
					case	0:
						mSprt[i].shadow[j].mSetX0( (s16)(inX + width -1) );
						mSprt[i].shadow[j].mSetY0( (s16)(inY - 1) );
						break;
					case	1:
						mSprt[i].shadow[j].mSetX0( (s16)(inX + width + 1) );
						mSprt[i].shadow[j].mSetY0( (s16)(inY - 1) );
						break;
					case	2:
						mSprt[i].shadow[j].mSetX0( (s16)(inX + width - 1) );
						mSprt[i].shadow[j].mSetY0( (s16)(inY + 1) );
						break;
					case	3:
						mSprt[i].shadow[j].mSetX0( (s16)(inX + width + 1) );
						mSprt[i].shadow[j].mSetY0( (s16)(inY + 1) );
						break;
				}
				mSprt[i].shadow[j].mSetRGBA( CHARA_DISP_COLOR_NAME_SHADOW );
				mSprt[i].shadow[j].mSetFade( CHARA_DISP_COLOR_ALPHA, fadeTick[i] );
				mSprt[i].shadow[j].mSetDispFlag( true );
			}
			//vZ
			width += mSprt[i].chara.mGetW();
		}
		//f[^ւindexi߂
		charIndex++;
	}
	
	for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		if( mSprt[i].chara.mGetDispFlag() == true )
		{
			//--  --
			mSprt[i].chara.mSetScale( eScaleW, 0.0f, 1 );
			mSprt[i].chara.mScaleProc();
			mSprt[i].chara.mSetScale( eScaleH, 2.0f, 1 );
			mSprt[i].chara.mScaleProc();
			mSprt[i].chara.mSetScale( eScaleWH, 1.0f, fadeTick[i] );
			//--  --
			for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
			{
				mSprt[i].shadow[j].mSetScale( eScaleW, 0.0f, 1 );
				mSprt[i].shadow[j].mScaleProc();
				mSprt[i].shadow[j].mSetScale( eScaleH, 2.0f, 1 );
				mSprt[i].shadow[j].mScaleProc();
				mSprt[i].shadow[j].mSetScale( eScaleWH, 1.0f, fadeTick[i] );
			}
		}
	}
	
	//[XtO
	mReleaseFlag = false;
	//sԂɕύX
	mFrameProc = eCharaDispExec;
	
	return( true );
}
//-----------------------------------------------------------------------------
//\NGXg
// in --> none
// out -> bool false  \NGXgs
//             true   \NGXg
//-----------------------------------------------------------------------------
bool
MK7CharaDisp::mRelease( void )
{
	int	i, j;
	s32	fadeTick;
	
	//eNX`ݒ肳ĂȂ΃f[^͂Ȃ
	if( mSprt[0].chara.mGetTex() == NULL )
	{
		return( false );
	}
	
	//XvCg\ɂĂ
	for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		//tF[hɂ鎞ԎZo
		fadeTick = HSD_Randi(CHARA_DISP_DEFAULT_FADE_TICK) + 1;
		//
		mSprt[i].chara.mSetFade( 0, fadeTick );
		mSprt[i].chara.mSetScale( eScaleW, 0.0f, fadeTick );
		mSprt[i].chara.mSetScale( eScaleH, 2.0f, fadeTick );
		//
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprt[i].shadow[j].mSetScale( eScaleW, 0.0f, fadeTick );
			mSprt[i].shadow[j].mSetScale( eScaleH, 2.0f, fadeTick );
			mSprt[i].shadow[j].mSetFade( 0, fadeTick );
		}
	}
	
	//[XtOON
	mReleaseFlag = true;
	
	return( true );
}
//-----------------------------------------------------------------------------
//\~
// in --> none
// out -> bool false  ~s
//             true   ~
//-----------------------------------------------------------------------------
bool
MK7CharaDisp::mDispStop( void )
{
	int	i, j;
	
	//eNX`ݒ肳ĂȂ΃f[^͂Ȃ
	if( mSprt[0].chara.mGetTex() == NULL )
	{
		return( false );
	}
	
	//XvCg\ɂĂ
	for( i = 0; i < JIMAKU_SPRT_MAX; i++ )
	{
		//
		mSprt[i].chara.mSetDispFlag( false );
		//
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprt[i].shadow[j].mSetDispFlag( false );
		}
	}
	
	//eNX`NA
	mClearSprt();
	//[XtO
	mReleaseFlag = false;
	//sҋ@Ԃɂ
	mFrameProc = eCharaDispStandby;
	
	return( true );
}
//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7CharaDisp::mFrameProcess( void )
{
	switch( mFrameProc )
	{
		case	eCharaDispExec:
			//[XtOĂ󋵂Ď
			if( mReleaseFlag == true )
			{
				if( mSprt[0].chara.mGetFadeEnd() == true )
				{
					mDispTick = 0;
					mClearSprt();
					mFrameProc = eCharaDispStandby;
				}
			}else
			{
				//iv\`FbN
				if( mDispTick != CHARA_DISP_TICK_PERMANENCE )
				{
					//\Ԃ0ɂȂ܂ŌvZ
					if( mDispTick != 0 )
					{
						mDispTick -= WK7_TICK_PER_FRAME;
						if( mDispTick <= CHARA_DISP_DEFAULT_FADE_TICK )
						{
							mRelease();
						}
					}
				}
			}
			break;
		
		default:
			break;
	}
}




//==========================
//====== }l[W[ ======
//==========================
//-----------------------------------------------------------------------------
//RXgN^
//-----------------------------------------------------------------------------
MK7CharaDispMng::MK7CharaDispMng()
{
	//
	mDat         = NULL;
	mSentenceDat = NULL;
	mFontParam   = NULL;
	mTex.tex     = NULL;
}
//-----------------------------------------------------------------------------
//fXgN^
//-----------------------------------------------------------------------------
MK7CharaDispMng::~MK7CharaDispMng()
{
}
//-----------------------------------------------------------------------------
//static
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7CharaDispMng::Init( void )
{
	if( gpCharaDispMng == NULL ){
		ghmGcMemSetAllocName("MChrDisp");
		gpCharaDispMng = new MK7CharaDispMng;
	}
	gpCharaDispMng->mInit();
}
//-----------------------------------------------------------------------------
//staticI
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7CharaDispMng::Term( void )
{
	gpCharaDispMng->mTerm();
	GHM_SAFE_DELETE( gpCharaDispMng );
}
//-----------------------------------------------------------------------------
//
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7CharaDispMng::mInit( void )
{
}
//-----------------------------------------------------------------------------
//I
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7CharaDispMng::mTerm( void )
{
	mDispStop();
}
//-----------------------------------------------------------------------------
//f[^̂AhXݒ肷
// in --> void* inDat  f[^̂AhX
// out -> none
//-----------------------------------------------------------------------------
void
MK7CharaDispMng::mDataSet( void* inDat )
{
	//NULLw肳ꂽf[^͂Ȃ̂Ŗ߂
	if( inDat == NULL )
	{
		mDat         = NULL;
		mSentenceDat = NULL;
		mFontParam   = NULL;
		mTex.tex     = NULL;
		return;
	}
	
	//f[^AhXݒ
	mDat = (stSentence*)inDat;
	//̓f[^ւ̃AhXݒ
	mSentenceDat = (stOneSentence*)((char*)mDat + mDat->offset);
	//uvwhf[^ւ̃AhXݒ
	mFontParam = (stFontParam*)((char*)mDat + mDat->charOffset);
	//eNX`AhẌn
	mTex.tex = (GhmGcTexHeader*)((char*)mDat + mDat->texOffset);
	//eNX`̏
	mK7InitTexture( &mTex );
}
//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7CharaDispMng::mFrameProcess( void )
{
	MK7CharaDisp*	charaDisp = gpCharaDispTop;
	
	while( charaDisp )
	{
		charaDisp->mFrameProcess();
		charaDisp = charaDisp->mNext;
	}
}
//-----------------------------------------------------------------------------
//\~ăX^oCԂɂ܂
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7CharaDispMng::mDispStop( void )
{
	MK7CharaDisp*	charaDisp = gpCharaDispTop;
	
	while( charaDisp )
	{
		charaDisp->mDispStop();
		charaDisp = charaDisp->mNext;
	}
}




