////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki mK7CharaDisp
//
// mK7CharaDisp.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 02/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7CHARADISP_H__
#define	__MK7CHARADISP_H__

//---- include ----
#include "mK7Jimaku.h"




//---- define ----
#define	CHARA_DISP_TICK_PERMANENCE	(-1)	//mRelease֐Ă΂܂ŕ\




//---- enum ----
typedef	enum{
	eCharaDispExec,
	eCharaDispStandby,
	eCharaDispProcMax,
}enCharaDispProc;




//---- struct ----
typedef	struct{
	mK7Sprite	chara;						//XvCg
	mK7Sprite	shadow[JIMAKU_SHADOW_MAX];	//XvCg
}stChara;




//---- class ----
//==============================
//====== X̕f[^ ======
//==============================
class MK7CharaDisp{
protected:
private:
public:
	//---- ֐ ----
	MK7CharaDisp();
	~MK7CharaDisp();
	
	//XvCgf[^̃NA
	void	mClearSprt( void );
	
	//\NGXg
	bool	mRequest( s16 inNo, s16 inX, s16 inY, s32 inTick = CHARA_DISP_TICK_PERMANENCE );
	//\NGXg
	bool	mRelease( void );
	//\~
	bool	mDispStop( void );
	
	//t[
	void	mFrameProcess( void );
	//Ԏ擾
	enCharaDispProc	mGetFrameProcess( void ){return(mFrameProc);}
	
	//---- ϐ ----
	enCharaDispProc		mFrameProc;				//t[
	stChara				mSprt[JIMAKU_SPRT_MAX];	//XvCg
	s32					mDispTick;				//\
	s32					mFadeWidth;				//tF[hɂ鎞
	bool				mReleaseFlag;			//ĂtO
	
	MK7CharaDisp*		mPrev;					//Oւ̃|C^
	MK7CharaDisp*		mNext;					//ւ̃|C^
};



//===========================
//====== }l[W[ =======
//===========================
class MK7CharaDispMng{
protected:
public:
	//---- ֐ ----
	MK7CharaDispMng();
	~MK7CharaDispMng();
	
	//
	static	void	Init( void );
	//I
	static	void	Term( void );
	
	//
	void	mInit( void );
	//I
	void	mTerm( void );
	
	//f[^̂AhXݒ肷
	void	mDataSet( void* inDat );
	//f[^̂AhXԂ
	void*	mDataGet( void ){ return((void*)mDat); }
	
	//t[
	void	mFrameProcess( void );
	//\~ăX^oCԂɂ܂
	void	mDispStop( void );
	
	//f[^ݒ肳Ă邩擾
	bool			mGetDataExist( void ){return((mDat==NULL)?false:true);}
	//͂̓Ăf[^ւ̃|C^擾
	stOneSentence*	mGetSentenceDat( void ){return(mSentenceDat);}
	//tHgp[^̃|C^擾
	stFontParam*	mGetFontParamPtr( void ){return(mFontParam);}
	//eNX`̃|C^擾
	stTexture*		mGetTexPtr( void ){return(&mTex);}
	
private:
	//---- ֐ ----
	
	//---- ϐ ----
	stSentence*			mDat;			//t@Cǂݍ񂾃f[^
	stOneSentence*		mSentenceDat;	//͂̓Ăf[^ւ̃|C^
	stFontParam*		mFontParam;		//uvwhl̓Ăe[uւ̃|C^
	stTexture			mTex;			//eNX`
};

//extern
extern	MK7CharaDispMng*	gpCharaDispMng;




#endif	//__MK7CHARADISP_H__


