////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Common
//
// mK7Common.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 11/22/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7COMMON_CPP__

//---- include ----
#include "mK7Common.h"
#include "..\wat\WK7Define.h"

//---- define ----

//---- O[oϐ ----




//-----------------------------------------------------------------------------
//t@CFRXgN^
//-----------------------------------------------------------------------------
mK7File::mK7File( void )
{
	mFileStatus = eFileReadOpen;
}
//-----------------------------------------------------------------------------
//t@CFfXgN^
//-----------------------------------------------------------------------------
mK7File::~mK7File( void )
{
	//t@CN[Y
	mFile.Close();
}
//-----------------------------------------------------------------------------
//t@CFǂݍ݁ubN()
// in --> char*      inFileName          t@C
//        void**     inBuf               f[^ǂݍݐAhX
// out -> enFileRead eFileReadOpenError  I[vG[
//                   eFileReadReadError  [hG[
//                   eFileReadSucsess    t@Cǂݍݐ
//-----------------------------------------------------------------------------
enFileRead
mK7File::mK7FileReadB( char* inFileName, void** inBuff )
{
	//t@CI[v
	if( mFile.Open(inFileName) == false )
		return( eFileReadOpenError );
	
	//t@Cǂݍ
	if( (*inBuff = mFile.ReadB()) == NULL )
		return( eFileReadReadError );
	
	//t@CN[Y
	mFile.Close();
	
	//t@Cǂݍݐ
	TRACE( "File read : %s\n", inFileName );
	return( eFileReadSucsess );
}
//-----------------------------------------------------------------------------
//t@CFǂݍ݁mubN(񓯊)
// in --> char*      inFileName           t@C
//        void**     inBuf                f[^ǂݍݐAhX
// out -> enFileRead eFileReadOpenError   I[vG[
//                   eFileReadReadError   [hG[
//                   eFileReadCloseError  N[YG[
//                   eFileReadWorking     t@Cǂݍݍƒ
//                   eFileReadSucsess     t@Cǂݍݐ
//-----------------------------------------------------------------------------
enFileRead
mK7File::mK7FileRead( char* inFileName, void** inBuff )
{
	enFileRead	ret = eFileReadWorking;
	
	switch( mFileStatus )
	{
		//t@CI[v
		case eFileReadOpen:
			if( mFile.Open(inFileName) == false )
				ret = eFileReadOpenError;
			else
				mFileStatus = eFileReadRead;
			break;
		
		//t@Cǂݍ
		case eFileReadRead:
			if( (*inBuff = mFile.Read()) == NULL )
				ret = eFileReadReadError;	//mۂłȂ
			else
				mFileStatus = eFileReadWait;
			break;
		
		//t@CǂݍݏI҂
		case eFileReadWait:
			//ǂݍݏI҂
			if( mFile.GetState() == ghmGcFile::READFINISH )
				mFileStatus = eFileReadClose;
			break;
		
		//t@CN[Y
		case eFileReadClose:
			mFile.Close();
			mFileStatus = eFileReadOpen;
			ret = eFileReadSucsess;
#ifdef	DEBUG_MATSUZAKI
			TRACE( "File read end. ---> %s\n", inFileName );
#endif
			break;
		
		default:
			ASSERT( 0 );
			break;
	}
	
	return( ret );
}




//-----------------------------------------------------------------------------
//eNX`̏
// in --> stTexture* inTex  eNX`̃f[^̓\
// out -> none
//-----------------------------------------------------------------------------
void
mK7InitTexture( stTexture* inTex )
{
	//
	GXInitTexObj( &inTex->obj,
				  (void*)((u32)inTex->tex + inTex->tex->mImagePtr),
				  inTex->tex->mWidth,
				  inTex->tex->mHeight,
				  inTex->tex->mFormat,	// GX_TF_I4,
				  GX_CLAMP,
				  GX_CLAMP,
				  GX_FALSE );
				  
	GXInitTexObjLOD( &inTex->obj,
				//	 GX_NEAR,	//GX_LINEAR
				//	 GX_NEAR,	//GX_LINEAR
					 GX_LINEAR,
					 GX_LINEAR,
					 0.0f,
					 0.0f,
					 0.0f,
					 GX_FALSE,
					 GX_FALSE,
					 GX_ANISO_1 );
}
//-----------------------------------------------------------------------------
//oCjAeNX`̏
// in --> stTexture* inTex  eNX`̃f[^̓\
// out -> none
//-----------------------------------------------------------------------------
void
mK7InitBilinearTexture( stTexture* inTex )
{
	//
	GXInitTexObj( &inTex->obj,
				  (void*)((u32)inTex->tex + inTex->tex->mImagePtr),
				  inTex->tex->mWidth,
				  inTex->tex->mHeight,
				  inTex->tex->mFormat,	// GX_TF_I4,
				  GX_CLAMP,
				  GX_CLAMP,
				  GX_FALSE );
				  
	GXInitTexObjLOD( &inTex->obj,
					 GX_LINEAR,
					 GX_LINEAR,
					 0.0f,
					 0.0f,
					 0.0f,
					 GX_FALSE,
					 GX_FALSE,
					 GX_ANISO_1 );
}




//-----------------------------------------------------------------------------
//Βl̎擾s16
// in --> s16
// out -> s16
//-----------------------------------------------------------------------------
s16
mK7GetAbsS16( s16 inNum )
{
	if( inNum < 0 )
	return( (s16)(-(inNum)) );
	return( inNum );
}



































//****************************
//****************************
//******** eXg֐ ********
//****************************
//****************************
#define ASPECT   ((float)K7APP_SCREEN_WIDTH/(float)K7APP_SCREEN_HEIGHT)
typedef	struct{
	Vec		pos;
	Vec		v0;
	Vec		v1;
	Vec		v2;
	u32		rgba;
}stTriangle;
stTriangle	gTri;
u32			gZDeg = 0;
//-----------------------------------------------------------------------------
//3D`̃J
// in --> Mtx v  view}gbNX
// out -> 
//-----------------------------------------------------------------------------
static	void
zkSetCamera3D( Mtx inViewMtx )
{
	Mtx44	pMtx;	//vWFNVmtx
	Point3d	camLoc	= {  0.0f,  0.0f,  0.0f };
	Vec		up		= {  0.0f,  1.0f,  0.0f };
	Point3d	objLoc	= {  0.0f,  0.0f, -1.0f };

	//                    fovy   aspect  near    far
	MTXPerspective( pMtx, 33.3f, ASPECT, 128.0f, 32768.0f );
	GXSetProjection( pMtx, GX_PERSPECTIVE );
	
	MTXLookAt( inViewMtx, &camLoc, &up, &objLoc );
}
//-----------------------------------------------------------------------------
//3D_O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Render3D( void )
{
	Mtx	mMtx;	//model matrix
	Mtx	rMtx;	//rotate matrix
	Mtx	vMtx;	//view matrix
	Vec	rot;	//]
	
	rot.x = 1.0f;
	rot.y = 1.0f;
	rot.z = 1.0f;
	
	//\W
	gTri.pos.x	=     0.0f;
	gTri.pos.y	=     0.0f;
	gTri.pos.z	= -1500.0f;
	//_1
	gTri.v0.x	=     0.0f;
	gTri.v0.y	=     0.0f;
	gTri.v0.z	=     0.0f;
	//_2
	gTri.v1.x	=   128.0f;
	gTri.v1.y	=     0.0f;
	gTri.v1.z	=     0.0f;
	//_3
	gTri.v2.x	=     0.0f;
	gTri.v2.y	=  -128.0f;
	gTri.v2.z	=     0.0f;
	//rgba
	gTri.rgba	= 0xffffffff;
	
	//VUO͈̔͐ݒ(!?)
//	GXSetScissor( 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );
	//r[|[g̐ݒ
	GXSetViewport( 0.0f, 0.0f, (f32)K7APP_SCREEN_WIDTH, (f32)K7APP_SCREEN_HEIGHT, 0.0f, 1.0f );
	//JO(\Ȃ)ʂw肷:|S̕`ʂw肷
	GXSetCullMode( GX_CULL_BACK );
	
	//ArGgJ[ƃ}eAJ[ݒ
//	static	GXColor		ambcol = { 0x40, 0x00, 0x00, 0xff };
//	static	GXColor		matcol = { 0x00, 0x00, 0x40, 0xff };
	
	//]}gbNX
	MTXRotAxisDeg( rMtx, &rot, gZDeg );
//	MTXRotDeg( rMtx, 'z', gZDeg );
	//sړ}gbNX
	MTXTrans( mMtx, gTri.pos.x, gTri.pos.y, gTri.pos.z );
	
	MTXConcat( mMtx, rMtx, mMtx );
	
	//view}gbNXJ
	zkSetCamera3D( vMtx );
	
	//f}gbNXƃr[}gbNX烏[h}gbNX𐶐
	MTXConcat( vMtx, mMtx, vMtx );
	GXLoadPosMtxImm( vMtx, GX_PNMTX0 );
	GXSetCurrentMtx( GX_PNMTX0 );
	
	//
	gZDeg++;
	
	
	//Zobt@r[hݒ
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );
	//EFBփ_Oۂ̃J[obt@XV[h
	GXSetColorUpdate( GX_TRUE );
	//EFBփ_Oۂ̃At@obt@XV[h
	GXSetAlphaUpdate( GX_TRUE );
	//EFBƂ̃uh@߂
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
//	GXSetBlendMode( GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_SRCCLR, GX_LO_CLEAR );
	
	//TEVXe[Wŗp\ɂeNX`W̐ݒ
	GXSetNumTexGens( 0 );
	
	//TEVXe[Wւ̏o͂łJ[`l̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumChans( 1 );
	//GX_COLOR0A0̃CgRg[̐ݒ
	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
//	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_REG, GX_SRC_REG, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );	//2̖߂Őݒ肷ArGgJ[ƃ}eAJ[gꍇ͂Ăяo
	//ArGgJ[𔽉f
//	GXSetChanAmbColor( GX_COLOR0A0, ambcol );
	//}eAJ[𔽉f
//	GXSetChanMatColor( GX_COLOR0A0, matcol );

	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
	GXSetTevOp( GX_TEVSTAGE0, GX_PASSCLR );
	
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
//	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR_NULL );
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0 );	//J[`lgꍇ͂Ăяo
	
	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
//	GXSetVtxDesc( GX_VA_NRM,  GX_NONE );	//@̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
	
	//ꂼ̗̑vf(?)Ǝނݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ,  GX_F32  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
	
	//gCAOGX_VTXFMT0g3_̕`
	GXBegin( GX_TRIANGLES, GX_VTXFMT0, 3 );
		//_LqqƑtH[}bg킹A̒_GPɑv~eBu`
		GXPosition3f32( gTri.v0.x, gTri.v0.y, gTri.v0.z );
		GXColor1u32   ( gTri.rgba );
		
		GXPosition3f32( gTri.v1.x, gTri.v1.y, gTri.v1.z );
		GXColor1u32   ( gTri.rgba );
		
		GXPosition3f32( gTri.v2.x, gTri.v2.y, gTri.v2.z );
		GXColor1u32   ( gTri.rgba );
	GXEnd();
}













#if	0
	u32		texsize = GXGetTexBufferSize(640,				// 
	                                     480,				// 
	                                     DRAWTEXFMT,		// tH[}bg
	                                     GX_FALSE,			// ~bv}bv
	                                     0);				// ~bv}bv
	texsize += 
	if( texsize > 0 ){
		mpDrawTexture = ghmGcMemAlloc((int)texsize);
		if( mpDrawTexture != NULL ){
			GXInitTexObj(&mDrawTexObj,
			             mpDrawTexture,
			             640,480,
			             DRAWTEXFMT,
			             GX_CLAMP,			// wrap_s
			             GX_CLAMP,			// wrap_t
			             GX_FALSE);			// mipmap
		}
	}
	
	
#define	TEXW			(640)
#define	TEXH			(480)
	GXSetTexCopySrc   (0,0,640,480);
	GXSetTexCopyDst   (TEXW,TEXH,GX_TF_I4,GX_FALSE);
	GXCopyTex         (mpDrawTexture,GX_FALSE);
	GXPixModeSync     ();
	GXInvalidateTexAll();
	
	GXInitTexObj(&mDrawTexObj,
	             mpDrawTexture,
	             TEXW,TEXH,
	             GX_TF_I4,
	             GX_CLAMP,			// wrap_s
	             GX_CLAMP,			// wrap_t
	             GX_FALSE);			// mipmap
	
	GXLoadTexObj      (&mDrawTexObj,GX_TEXMAP0);
	
	GXSetZMode        (GX_FALSE,GX_ALWAYS,GX_FALSE);
	GXSetColorUpdate  (GX_TRUE);
	GXSetAlphaUpdate  (GX_FALSE);
	GXSetBlendMode    (GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	
	GXClearVtxDesc    ();
	GXSetVtxDesc      (GX_VA_POS ,GX_DIRECT);
	GXSetVtxDesc      (GX_VA_NRM ,GX_NONE  );
	GXSetVtxDesc      (GX_VA_CLR0,GX_DIRECT);
	GXSetVtxDesc      (GX_VA_TEX0,GX_DIRECT);
	
	GXSetNumTexGens   (1);
	GXSetTexCoordGen  (GX_TEXCOORD0,GX_TG_MTX2x4,GX_TG_TEX0,GX_IDENTITY);
	
	GXSetNumTevStages (1);
	GXSetTevColorIn   (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_RASC,GX_CC_TEXC,GX_CC_ZERO);
	GXSetTevColorOp   (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn   (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
	GXSetTevAlphaOp   (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	
//	GXSetTevOp        (GX_TEVSTAGE0,GX_MODULATE);
	GXSetTevOrder     (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR0A0);
	
	GXSetNumChans     (1);
	GXSetChanCtrl     (GX_COLOR0A0,GX_FALSE,GX_SRC_VTX,GX_SRC_VTX,GX_LIGHT0,GX_DF_NONE,GX_AF_NONE);
	
	static	GXColor		ambcol = { 0x40,0x00,0x00,0xff, };
	static	GXColor		matcol = { 0x00,0x00,0x40,0xff, };
	
	GXSetChanAmbColor(GX_COLOR0A0,ambcol);
	GXSetChanMatColor(GX_COLOR0A0,matcol);
	
	GXSetCullMode    (GX_CULL_NONE);
	
	// ꂼ̗̑vfƎނw
	GXSetVtxAttrFmt(GX_VTXFMT0,GX_VA_POS ,GX_POS_XY  ,GX_S16  ,0);
	GXSetVtxAttrFmt(GX_VTXFMT0,GX_VA_CLR0,GX_CLR_RGBA,GX_RGBA8,0);
	GXSetVtxAttrFmt(GX_VTXFMT0,GX_VA_TEX0,GX_TEX_ST  ,GX_F32  ,0);
	
	// v~eBu̎ނw
	GXBegin(GX_QUADS,GX_VTXFMT0,4);
		
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		
		GXPosition2s16(  0,  0);
		GXColor1u32   (TONE_COLOR);
		GXTexCoord2f32(0.0f,0.0f);
		
		GXPosition2s16(640,  0);
		GXColor1u32   (TONE_COLOR);
		GXTexCoord2f32(1.0f,0.0f);
		
		GXPosition2s16(640,480);
		GXColor1u32   (TONE_COLOR);
		GXTexCoord2f32(1.0f,1.0f);
		
		GXPosition2s16(  0,480);
		GXColor1u32   (TONE_COLOR);
		GXTexCoord2f32(0.0f,1.0f);
		
	GXEnd();
	
#endif








