////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7EngTelop
//
// mK7EngTelop.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 02/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7ENGTELOP_CPP__

//---- include ----
#include "..\wat\WK7Define.h"
#include "..\wat\WK7Cam.h"
#include "..\wat\WK7Event.h"
#include "..\wat\WK7EventScript.h"
#include "..\wat\WK7GameInfo.h"
#include "..\wat\K7GlobalFlag.h"
#include "mK7EngTelop.h"

//---- define ----
#define	ENGTELOP_SPACE_W			(6)				//Xy[X
#define	ENGTELOP_DISP_Y				(20)			//\YW 36
#define	ENGTELOP_COLOR				(0xffffffff)	//F
#define	ENGTELOP_COLOR_EDGE			(0x000000ff)	//EF
#define	ENGTELOP_TICK_DEFAULT_DISP	(4800)			//̕W\
#define	ENGTELOP_TICK_IN			(800)			//ɂ鎞
#define	ENGTELOP_TICK_OUT			(800)			//ޏɂ鎞
#define	ENGTELOP_RATE				(100)			//̃g~Oɑ΂閾邳̊
#define	ENGTELOP_RATE_EGDE			(30)			//̃g~Oɑ΂Â̊




//---- O[oϐ ----
MK7EngTelop*	gpEngTelop = NULL;




//-----------------------------------------------------------------------------
//RXgN^
//-----------------------------------------------------------------------------
MK7EngTelop::MK7EngTelop()
{
	mFrameProc = eEngTelopStandby;
}
//-----------------------------------------------------------------------------
//fXgN^
//-----------------------------------------------------------------------------
MK7EngTelop::~MK7EngTelop()
{
}
//-----------------------------------------------------------------------------
//static
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7EngTelop::Init( void )
{
	if( gpEngTelop == NULL ){
		ghmGcMemSetAllocName("MEngTlp");
		gpEngTelop = new MK7EngTelop;
	}
	gpEngTelop->mInit();
}
//-----------------------------------------------------------------------------
//staticI
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7EngTelop::Term( void )
{
	gpEngTelop->mTerm();
	GHM_SAFE_DELETE( gpEngTelop );
}
//-----------------------------------------------------------------------------
//
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7EngTelop::mInit( void )
{
	int	i, j;
	
	//
	mFrameProc     = eEngTelopStandby;
	mTex.tex       = NULL;
	mDat           = NULL;
	mSentenceDat   = NULL;
	mFParam        = NULL;
	mSentenceIndex = 0;
	mTotalTick     = 0;
	mPauseFlag     = true;
	
	//XvCg̏ݒ
	for( i =0; i < ENG_JIMAKU_CHAR_MAX; i++ )
	{
		mSprt[i].chara.mRelateTex( &mTex );
		mSprt[i].chara.mSetPriority( SPRT_PRI_JMK );
		mSprt[i].chara.mSetDispFlag( false );
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprt[i].edge[j].mRelateTex( &mTex );
			mSprt[i].edge[j].mSetPriority( SPRT_PRI_JMK_SHADOW );
			mSprt[i].edge[j].mSetDispFlag( false );
		}
	}
}
//-----------------------------------------------------------------------------
//I
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7EngTelop::mTerm( void )
{
	//\~
	mDispStop();
}




//-----------------------------------------------------------------------------
//\̂߂̖t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7EngTelop::mFrameProcess( void )
{
	s32	i, j;
	s16	dat, charIndex;
	
	switch( mFrameProc )
	{
		//f[^ݒ
		case	eEngTelopDataSet:
			//
			charIndex        = 0;
			mWidth           = 0;
			mLastDispSprtNum = 0;
			//XvCgXvCg̊eݒ
			for( i = 0; i < ENG_JIMAKU_CHAR_MAX; i++ )
			{
				dat = mSentenceDat[mSentenceIndex].chardat[charIndex];
				//sm
				if( dat == (s16)JIMAKU_RETURN )
				{
					break;
				}else
				//pXy[Xm
				if( (dat == (s16)JIMAKU_SPACE_H) || (dat == (s16)JIMAKU_SPACE_Z) )
				{
					mWidth += ENGTELOP_SPACE_W;
					i--;	//XvCgID͐i߂Ȃ
				}else
				{
					mSprt[i].chara.mSetDispFlag( false );
					mSprt[i].chara.mSetU0( (s16)mFParam[dat].u );
					mSprt[i].chara.mSetV0( (s16)mFParam[dat].v );
					mSprt[i].chara.mSetWH( (s16)mFParam[dat].w, (s16)mFParam[dat].h );
					mSprt[i].chara.mSetX0( mWidth );
					mSprt[i].chara.mSetY0( (s16)ENGTELOP_DISP_Y );
					mSprt[i].chara.mSetRGBA( ENGTELOP_COLOR );
				//	mSprt[i].chara.mSetRGBA( 0x80808080 );
					for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
					{
						mSprt[i].edge[j].mSetDispFlag( false );
						mSprt[i].edge[j].mSetU0( (s16)mFParam[dat].u );
						mSprt[i].edge[j].mSetV0( (s16)mFParam[dat].v );
						mSprt[i].edge[j].mSetWH( (s16)mFParam[dat].w, (s16)mFParam[dat].h );
						mSprt[i].edge[j].mSetX0( mWidth );
						mSprt[i].edge[j].mSetY0( (s16)ENGTELOP_DISP_Y );
				//		mSprt[i].edge[j].mSetRGBA( ENGTELOP_COLOR_EDGE );
						mSprt[i].edge[j].mSetRGBA( 0x00000040 );
					}
					mWidth += mSprt[i].chara.mGetW();
					mLastDispSprtNum++;
				}
				//f[^ւindexi߂
				charIndex++;
			}
			//\Jn܂ł̃EGCg擾
			mStartWaitTime = mSentenceDat[mSentenceIndex].wait;
			//\Ԑݒ
			mDisptime = mSentenceDat[mSentenceIndex].disptime - ENGTELOP_TICK_IN - ENGTELOP_TICK_OUT;
			//\Ԃ0菬ꍇ
			if( mDisptime <= 0 )
			{
				mDisptime = ENGTELOP_TICK_DEFAULT_DISP - ENGTELOP_TICK_IN - ENGTELOP_TICK_OUT;
			}
			
			//\JnÕEGCg
			mFrameProc = eEngTelopStartWait;
			break;
		
		//\܂ł̃EGCg
		case	eEngTelopStartWait:
			if( (mTotalTick >= mStartWaitTime) && (mPauseFlag == false) )
			{
				mCentering( mWidth );		//Z^O:Z^OƓɕ\tOONɂ邽߂Őݒ
				mSetIn();					//Cf[^ݒ
				mFrameProc = eEngTelopIn;	//C
			}
			break;
		
		//C
		case	eEngTelopIn:
			if( mIn() == true )
			{
				mFrameProc = eEngTelopWait;
			}
			break;
		
		//EGCgI҂
		case	eEngTelopWait:
			if( mTotalTick >= (mDisptime + mStartWaitTime) )
			{
				mSetOut();
				mFrameProc = eEngTelopOut;
			}
			break;
		
		//AEg
		case	eEngTelopOut:
			if( mOut() == true )
			{
				//ɑǂׂ
				if( mDispEndCheck() == true )
				{
					//f[^IX^oC
					mFrameProc = eEngTelopStandby;
				}else
				{
					//f[^\
					mFrameProc = eEngTelopDataSet;
				}
			}
			break;
		
		//---- ҋ@ ----
		case	eEngTelopStandby:
			break;
		
		//---- ftHg ----
		default:
			break;
	}
	
	//\ԂĎticǩvZ
	if( (mFrameProc == eEngTelopStartWait)	//\܂ł̃EGCg
	 || (mFrameProc == eEngTelopIn)			//C
	 || (mFrameProc == eEngTelopWait)		//\Eԑ҂
	 || (mFrameProc == eEngTelopOut) )		//AEg
	{
		if( mPauseFlag == false )
		{
			mTotalTick += WK7_TICK_PER_FRAME;
		}
	}
}




//-----------------------------------------------------------------------------
//f[^̂AhXݒ肷
// in --> void* inDat  f[^̂AhX
// out -> false f[^ݒ莸si\Ă\j
//        true  f[^ݒ萬
//-----------------------------------------------------------------------------
bool
MK7EngTelop::mDataSet( void* inDat )
{
	//IvVŉpꎚ\łΔ
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_OPT_ENGTELOP) == false )
	{
		return( true );
	}
	
	//NULLw肳ꂽf[^͂Ȃ̂Ŗ߂
	if( inDat == NULL )
	{
		mDat = NULL;
		return( true );
	}
	
	//t[ҋ@łȂΖ߂
	if( mFrameProc != eEngTelopStandby )
	{
		return( false );
	}
	
	//f[^AhXݒ
	mDat = (stEngSentence*)inDat;
	//̓f[^ւ̃AhXݒ
	mSentenceDat = (stEngJimaku*)((char*)mDat + mDat->offset);
	//uvwhf[^ւ̃AhXݒ
	mFParam = (stFontParam*)((char*)mDat + mDat->charOffset);
	//eNX`AhẌn
	mTex.tex = (GhmGcTexHeader*)((char*)mDat + mDat->texOffset);
	//eNX`̏
	mK7InitTexture( &mTex );
	
	//
	mTotalTick     = 0;		//\ԂĎtick
	mSentenceIndex = 0;		//\͔ԍ
	mPauseFlag     = true;	//\̓|[YԂɂĂ
	
	//t[f[^ݒɕύX
	mFrameProc = eEngTelopDataSet;
	
	//I
	return( true );
}
//-----------------------------------------------------------------------------
//\~ăX^oCԂɂ܂
// in --> none
// out -> bool true   vO~߂ăX^oCԂɂȂ
//             false  vO~߂邱ƂłȂ
//-----------------------------------------------------------------------------
bool
MK7EngTelop::mDispStop( void )
{
	int	i, j;
	
	//XvCg\tONA
	for( i =0; i < ENG_JIMAKU_CHAR_MAX; i++ )
	{
		mSprt[i].chara.mSetDispFlag( false );
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprt[i].edge[j].mSetDispFlag( false );
		}
	}
	
	//̃t[\ɕύX
	mFrameProc = eEngTelopStandby;
	
	return( true );
}




//-----------------------------------------------------------------------------
//\JE^[̈ꎞ~
// in --> u32  inTick  |[YƂɎw肵tick
// out -> bool false   NGXg󂯕tԂłȂ
//             true    NGXg
//-----------------------------------------------------------------------------
bool
MK7EngTelop::mSetPause( void )
{
	//f[^Ȃ΃|[YKvȂ
	if( mDat == NULL )
	{
		return( false );
	}

	mPauseFlag = true;
//	if( (mFrameProc == eEngTelopStartWait)	//\܂ł̃EGCg
//	 || (mFrameProc == eEngTelopStandby) )	//ҋ@
//	{
//		mPauseFlag = true;
//	}else
//	{
//		return( false );
//	}
	
	return( true );
}
//-----------------------------------------------------------------------------
//\JE^[̈ꎞ~
// in --> u32  inTick  |[YƂɎw肵tick
// out -> bool false   ݃|[YĂ܂
//             true    |[Y܂
//-----------------------------------------------------------------------------
bool
MK7EngTelop::mReleasePause( u32 inTick )
{
	//f[^Ȃ΃|[YKvȂ
	if( mDat == NULL )
	{
		return( false );
	}
	
	if( mPauseFlag == true )
	{
		if( inTick != 0 )
		{
			mTotalTick = inTick;
		}
		mPauseFlag = false;
	}else
	{
		return( false );
	}
	
	return( true );
}




//-----------------------------------------------------------------------------
//Z^O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7EngTelop::mCentering( s16 inW )
{
	int	i, j;
	
	//̃Z^O
	for( i = 0; i < mLastDispSprtNum; i++ )
	{
		mSprt[i].chara.mSetDispFlag( true );
		mSprt[i].chara.mSetX0( (s16)(mSprt[i].chara.mGetX0() + (s16)((K7APP_SCREEN_WIDTH - inW) / 2)) );
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
		//	mSprt[i].edge[j].mSetDispFlag( true );
			mSprt[i].edge[j].mSetX0( (s16)(mSprt[i].edge[j].mGetX0() + (s16)((K7APP_SCREEN_WIDTH - inW) / 2)) );
			switch( j )
			{
				case	0:
					mSprt[i].edge[j].mSetXY0( (s16)(mSprt[i].edge[j].mGetX0() - 1), (s16)(mSprt[i].edge[j].mGetY0() - 1) );
					break;
				case	1:
					mSprt[i].edge[j].mSetXY0( (s16)(mSprt[i].edge[j].mGetX0() + 1), (s16)(mSprt[i].edge[j].mGetY0() - 1) );
					break;
				case	2:
					mSprt[i].edge[j].mSetXY0( (s16)(mSprt[i].edge[j].mGetX0() - 1), (s16)(mSprt[i].edge[j].mGetY0() + 1) );
					break;
				case	3:
					mSprt[i].edge[j].mSetXY0( (s16)(mSprt[i].edge[j].mGetX0() + 1), (s16)(mSprt[i].edge[j].mGetY0() + 1) );
					break;
			}
		}
	}
}
//-----------------------------------------------------------------------------
//ݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7EngTelop::mSetIn( void )
{
	int	i, j;
	s16	orgX, orgY;
	s32	r0, g0, b0;
	s32	r1, g1, b1;
	u32	rgba = WK7CAM->GetCinemaScopeColor();
	
	r0 = r1 = (s32)((rgba >> 24) & 0xff);
	g0 = g1 = (s32)((rgba >> 16) & 0xff);
	b0 = b1 = (s32)((rgba >> 8)  & 0xff);
	
	r0 = r0 + ((255 - r0) / 5);
	g0 = g0 + ((255 - g0) / 5);
	b0 = b0 + ((255 - b0) / 5);
	if( r0 > 0xff )r0 = 0xff;
	if( g0 > 0xff )g0 = 0xff;
	if( b0 > 0xff )b0 = 0xff;
	
	r1 = r1 - (r1 / 6);
	g1 = g1 - (g1 / 6);
	b1 = b1 - (b1 / 6);
	if( r1 < 0 )r1 = 0;
	if( g1 < 0 )g1 = 0;
	if( b1 < 0 )b1 = 0;
	
	//ʉE[ɂ炵Ĉړݒ
	for( i = 0; i < mLastDispSprtNum; i++ )
	{
		orgX = (s16)mSprt[i].chara.mGetX0();
		mSprt[i].chara.mSetX0( (s16)(orgX + K7APP_SCREEN_WIDTH) );
		mSprt[i].chara.mSetMove( orgX, ENGTELOP_DISP_Y, ENGTELOP_TICK_IN );
	//	mSprt[i].chara.mSetRGBA( (u32)((r0 << 24) | (g0 << 16) | (b0 << 8) | 0xff) );
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			orgX = (s16)mSprt[i].edge[j].mGetX0();
			orgY = (s16)mSprt[i].edge[j].mGetY0();
			mSprt[i].edge[j].mSetX0( (s16)(orgX + K7APP_SCREEN_WIDTH) );
			mSprt[i].edge[j].mSetMove( orgX, orgY, ENGTELOP_TICK_IN );
	//		mSprt[i].edge[j].mSetRGBA( (u32)((r1 << 24) | (g1 << 16) | (b1 << 8) | 0xff) );
		}
	}
}
//-----------------------------------------------------------------------------
//I
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7EngTelop::mIn( void )
{
	if( mLastDispSprtNum == 0 )
		return( true );
	
	if( mSprt[0].chara.mGetMoveEnd() == true )
		return( true );
	
	return( false );
}
//-----------------------------------------------------------------------------
//ޏݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7EngTelop::mSetOut( void )
{
	int	i, j;
	
	//ʍ[Ɉړݒ
	for( i = 0; i < mLastDispSprtNum; i++ )
	{
		mSprt[i].chara.mSetMove( ((s16)mSprt[i].chara.mGetX0() - K7APP_SCREEN_WIDTH), ENGTELOP_DISP_Y, ENGTELOP_TICK_OUT );
		for( j = 0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprt[i].edge[j].mSetMove( ((s16)mSprt[i].edge[j].mGetX0() - K7APP_SCREEN_WIDTH), ENGTELOP_DISP_Y, ENGTELOP_TICK_OUT );
		}
	}
}
//-----------------------------------------------------------------------------
//ޏI
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7EngTelop::mOut( void )
{
	if( mLastDispSprtNum == 0 )
		return( true );
	
	if( mSprt[0].chara.mGetMoveEnd() == true )
		return( true );
	
	return( false );
}
//-----------------------------------------------------------------------------
//f[^ImF
// in --> none
// out -> bool false  f[^͑
//             true   f[^I
//-----------------------------------------------------------------------------
bool
MK7EngTelop::mDispEndCheck( void )
{
	int	i, j;
	
	//XvCg\tONA
	for( i =0; i < ENG_JIMAKU_CHAR_MAX; i++ )
	{
		mSprt[i].chara.mSetDispFlag( false );
		for( j =0; j < JIMAKU_SHADOW_MAX; j++ )
		{
			mSprt[i].edge[j].mSetDispFlag( false );
		}
	}
	
	//I`FbN
	if( (mSentenceIndex + 1) < mDat->num )
	{
		//\indexZ
		mSentenceIndex++;
	}else
	{
		//f[^I
		return( true );
	}
	
	//f[^͑܂
	return( false );
}
