////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki mK7EngTelop
//
// mK7EngTelop.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 02/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7ENGTELOP_H__
#define	__MK7ENGTELOP_H__

//---- include ----
#include ".\mK7Jimaku.h"




//---- define ----
#define	ENG_JIMAKU_CHAR_MAX		(128)




//---- enum ----
//t[vZX̏
typedef	enum{
	eEngTelopDataSet,		//f[^ݒ
	eEngTelopStartWait,		//\܂ł̃EGCg
	eEngTelopIn,			//C
	eEngTelopWait,			//\Eԑ҂
	eEngTelopOut,			//AEg
	eEngTelopStandby,		//ҋ@
	eEngTelopFrameProcMax,
}enEngTelopFrameProc;




//---- struct ----
typedef	struct{
	mK7Sprite	chara;						//
	mK7Sprite	edge[JIMAKU_SHADOW_MAX];	//XvCg
}stEngChara;

//1̕̕\ɕKvȃp[^
typedef	struct{
	s32			wait;							//\Jn܂ł̃EGCg
	s32			disptime;						//\
	s16			chardat[ENG_JIMAKU_CHAR_MAX];	//̓f[^(IDe[u)
}stEngJimaku;
//̓f[^
typedef	struct{
	s16		num;				//͂̐
	s16		charNum;			//̎ނ̐
	u32		offset;				//͂̃f[^ꏊ܂ł̃ItZbg
	u32		charOffset;			//uvwhĂf[^܂ł̃ItZbg
	u32		texOffset;			//eNX`f[^܂ł̃ItZbg
	u32		sMotionOffset;		//VFCv[Vf[^f[^܂ł̃ItZbg
	u32		sMotionSizeTbl[];	//eVFCv[VTCYe[u
}stEngSentence;



//---- class ----
class MK7EngTelop{
protected:
public:
	//---- ֐ ----
	MK7EngTelop();
	~MK7EngTelop();
	
	//
	static
	void	Init( void );
	void	mInit( void );
	
	//\̂߂̖t[
	void	mFrameProcess( void );
	
	//I
	static
	void	Term( void );
	void	mTerm( void );
	
	//Ԏ擾
	enEngTelopFrameProc	mGetStatus( void ){return(mFrameProc);}
	
	//f[^̂AhXݒ肷
	bool	mDataSet( void* inDat );
	//\~ăX^oCԂɂ܂
	bool	mDispStop( void );
	
	//\JE^[̈ꎞ~
	bool	mSetPause( void );
	//\JE^[̈ꎞ~
	bool	mReleasePause( u32 inTick=0 );
	//|[YԂ̎擾
	bool	mGetPauseFlag( void ){return(mPauseFlag);}
	
private:
	//---- ֐ ----
	//Z^O
	void	mCentering( s16 inW );
	
	//ݒ
	void	mSetIn( void );
	//I
	bool	mIn( void );
	//ޏݒ
	void	mSetOut( void );
	//ޏI
	bool	mOut( void );
	
	//f[^ImF
	bool	mDispEndCheck( void );
	
	//---- ϐ ----
	enEngTelopFrameProc	mFrameProc;				//t[
	
	stTexture			mTex;					//eNX`
	stEngChara			mSprt[ENG_JIMAKU_CHAR_MAX];	//
	
	s32					mLastDispSprtNum;		//Ōɕ\镶̃XvCgindex
	s16					mWidth;					//͂̕
	
//	stSentence*			mDat;					//t@Cǂݍ񂾃f[^
//	stOneSentence*		mSentenceDat;			//͂̓Ăf[^ւ̃|C^
	stEngSentence*		mDat;					//t@Cǂݍ񂾃f[^
	stEngJimaku*		mSentenceDat;			//͂̓Ăf[^ւ̃|C^
	stFontParam*		mFParam;				//uvwhl̓Ăe[uւ̃|C^
	
	s16					mSentenceIndex;			//͂ւindex
	s16					mLineIndex;				//sւindex
	
	s32					mStartWaitTime;			//\܂ł̎
	s32					mDisptime;				//\Ă鎞
	u32					mTotalTick;				//\ԂĎtick
	bool				mPauseFlag;				//̒~p|[YtO
};

//extern
extern	MK7EngTelop*	gpEngTelop;



#endif	//__MK7ENGTELOP_H__


