////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Movie
//
// mK7Movie.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 08/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7MOVIE_CPP__

//---- include ----
#include "mK7Movie.h"
#include "mK7Common.h"
#include "mK7Sprite.h"
#include "..\Wat\WK7SceneBlur.h"
#include "..\Wat\WK7Cam.h"
#include "mK7Jimaku.h"
#include "mK7EngTelop.h"
#include "mK7Sound.h"

//---- define ----
#define	MOVIE_USE_TEX			//[r[ĐɃeNX`dl
#define	MOVIE_DISP_X			(0)
//#define	MOVIE_DISP_Y			(64)
//#define	MOVIE_DISP_Y			(44)
#define	MOVIE_DISP_Y			(32)
#define	MV_WIDTH				(640)
#define	MV_HEIGHT				(352)
#define ExCacheLineSize			(64)
#define	OSRoundUpExCacheLine(x)	(((u32)(x)+ExCacheLineSize-1) & ~(ExCacheLineSize-1))

//---- enum ----
enum{
	eMovieJimaku,
	eMovieEngTelop,
};

//---- ϐ錾 ----
#ifdef	MOVIE_USE_TEX
static	void*			mvPictureBuffer      = NULL;
static	void*			mvPictureBufferAlloc = NULL;
#endif
static	GXTexObj		mvTexObj;
volatile static	hHVQM4PlayerEx	mvPlayerHandle       = NULL;

//---- ֐錾 ----
void	mvDraw( void );
void*	mvRenderThreadFunc( void* );
void	mvDvdStatusWatch( hHVQM4PlayerEx inPlayerHandle, void* inPtr, s32 inStatus );
void	mvAsendNullInit( hHVQM4PlayerEx inHp );
void	mvAsendDmanext( void );
void	mvAsendDmastop( void );
void	mvAsend1stFunc( hHVQM4PlayerEx inHp, void * );

//---- O[oϐ ----
MK7Movie*	gpMovie = NULL;

#ifndef	MOVIE_USE_TEX
extern "C" {
	void*				HSD_GetFrameBuffer( void );
	GXRenderModeObj*	HSD_GetRmode( void );
}
#endif




//---- ֐ ----
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Movie::MK7Movie()
{
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Movie::~MK7Movie()
{
}
//-----------------------------------------------------------------------------
//static
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Movie::Init( void )
{
	if( gpMovie == NULL ){
		ghmGcMemSetAllocName("MMovie");
		gpMovie = new MK7Movie;
	}
	gpMovie->mInit();
}
//-----------------------------------------------------------------------------
//static㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Movie::Term( void )
{
	gpMovie->mTerm();
	GHM_SAFE_DELETE( gpMovie );
}




//-----------------------------------------------------------------------------
//
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Movie::mInit( void )
{
	//
	mPlayerHandle = NULL;
	mProc         = eMvProcStandby;
	mMvRenderFlag = false;
	mPauseFlag    = false;
	mDVDError     = false;
	mFrame        = MOVIE_NOT_PLAY;
}
//-----------------------------------------------------------------------------
//㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Movie::mTerm( void )
{
}




//-----------------------------------------------------------------------------
//ĐNGXg
// in --> none
// out -> false Đs
//        true  Đ
//-----------------------------------------------------------------------------
bool
MK7Movie::mRequest( char* inFileName )
{
	if( mProc != eMvProcStandby )
	{
		return( false );
	}
	
	gpSound->mStopStream();
	gpSound->mStopSEAll();
	strcpy( mFileName, inFileName );
	mProc  = eMvProcRequest;
	
	return( true );
}
//-----------------------------------------------------------------------------
//Đ~
// in --> none
// out -> false ~s
//        true  ~
//-----------------------------------------------------------------------------
bool
MK7Movie::mStop( void )
{
	if( mProc == eMvProcRequest || mProc == eMvProcDrawing )
	{
		//t[0ȏŃLZ\
		if( mGetFrame() < 1 )
		{
			return( false );
		}
		HVQM4PlayerExSetCancel();
		return( true );
	}
	
	return( false );
}
//-----------------------------------------------------------------------------
//ꎞ~
// in --> none
// out -> false ꎞ~s
//        true  ꎞ~
//-----------------------------------------------------------------------------
bool
MK7Movie::mSetPause( void )
{
	if( (mvPlayerHandle != NULL) && (mPauseFlag == false) )
	{
		HVQM4PlayerExControlStep( mvPlayerHandle );
		mPauseFlag = true;
		return( true );
	}
	return( false );
}
//-----------------------------------------------------------------------------
//ꎞ~
// in --> none
// out -> false ꎞ~s
//        true  ꎞ~
//-----------------------------------------------------------------------------
bool
MK7Movie::mReleasePause( void )
{
	if( (mvPlayerHandle != NULL) && (mPauseFlag == true) )
	{
		HVQM4PlayerExControlNormal( mvPlayerHandle );
		mPauseFlag = false;
		return( true );
	}
	return( false );
}




//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Movie::mFrameProcess( void )
{
	enFileRead ret;
	
	switch( mProc )
	{
		//ĐNGXg(f[^ǂݍ)
		case	eMvProcRequest:
			//g`t@CǂݍłI܂ő҂
			if( gpSound->mGetProcess() != eSndStandby )
			{
				return;
			}
			ret = mFile.mK7FileRead( mGetResourceFileName(), &((void*)mBuff) );
			if( (ret == eFileReadSucsess) || (ret == eFileReadOpenError) )
			{
				mReslink = NULL;
				if( ret == eFileReadSucsess )
				{
					mReslink = new ((ghmGcResLink *)mBuff)ghmGcResLink;
					ASSERT( mReslink );
					//\[Xf[^ݒ
					gpJimaku->mDataSet( (void*)mReslink->GetResource(eMovieJimaku) );
					gpEngTelop->mDataSet( (void*)mReslink->GetResource(eMovieEngTelop) );
				}
				TRACE( "HVQM4 PLAY : %s\n", mFileName );
				//ĐNGXg
				mRequestProc();
				//`
				mProc = eMvProcDrawing;
				//tF[hJn
				k7app.FadeStart(0xff,0);
				//KVAƃnTsN̂Ƃ̂ݔtF[hŊJn
				if( strcmp("/Movie/04060902.h4m",mFileName) == 0 )
				{
					k7app.SetFadeColor(0xffffffff);
				}else
				{
					k7app.SetFadeColor(0x000000ff);
				}
			//	k7app.FadeStart(0x00,3360);
				//VlXRON
			//	WK7CAM->SetCinemaScopeColor( 0x600000ff );
			//	WK7CAM->SetCinemaScopeColor( 0x5a0a0aff );
				WK7CAM->SetCinemaScopeColor( WK7CAM_DEFAULT_CINEMASCOPE_COLOR );
				WK7CAM->SetCinemaScopeMode( true );
			}else
			{
				break;
			}
		
		//`撆
		case	eMvProcDrawing:
			if( mvPlayerHandle==NULL ){
				// ܂
				break;
			}
			if( HVQM4PlayerExCheckExecute(mvPlayerHandle) != 0 )
			{
				//Đꂽ玚Jn
				if( mGetFrame() == 2 )
				{
					k7app.FadeStart(0x00,3040);
					gpJimaku->mReleasePause( 2 );
					gpEngTelop->mReleasePause( 2 );
				}
				mMvRenderFlag = true;
			}else
			{
				//~
				mStopProc();
				//f[^NA
				gpJimaku->mDispStop();
				gpEngTelop->mDispStop();
				gpJimaku->mDataSet( NULL );
				gpEngTelop->mDataSet( NULL );
				//f[^
				GHM_SAFE_DELETE( mReslink );
				//VlXROff
				WK7CAM->SetCinemaScopeMode( false );
				k7app.FadeStart(0x00,0);
				//X^oC
				mProc = eMvProcStandby;
			}
			break;
		
		//ҋ@
		case	eMvProcStandby:
			break;
		
		default:
			break;
	}
}
//-----------------------------------------------------------------------------
//\[Xt@C̎擾
// in --> none
// out -> none
//-----------------------------------------------------------------------------
char*
MK7Movie::mGetResourceFileName( void )
{
	u32		len;
	char	temp[MOVIE_FILE_LENGTH];
	
	strcpy( temp, mFileName );
	len = strlen( temp );
	temp[len-3] = '\0';
	strcat( temp, "mrs" );
	if( temp[0] == '/' )
	{
		sprintf( mResFileName, "Message%s", temp );
	}else
	{
		sprintf( mResFileName, "Message/%s", temp );
	}
	
	return( mResFileName );
}
//-----------------------------------------------------------------------------
//_O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Movie::mRender( void )
{
#ifdef	MOVIE_USE_TEX
	if( mMvRenderFlag == true )
	{
		mvDraw();
	}
#endif
}
//-----------------------------------------------------------------------------
//`Xbh
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Movie::mInitThread( void )
{
    BOOL	ret;
	
    //Xbh
    ret = OSCreateThread( &mRenderThread,
						  &mvRenderThreadFunc,
						  NULL,
    					  mRenderThreadStack + sizeof( mRenderThreadStack ),
    					  sizeof( mRenderThreadStack ),
    					  20,	//8,XbhD揇ʁFC16Ⴍ
    					  OS_THREAD_ATTR_DETACH );
    //XbhscIɂǂ悤AAA
    if( ret == false )
    {
		OSHalt("HVQM4 render thread error !!\n");
    }
	//Xbhs\Ԃɂ
    OSResumeThread( &mRenderThread );
    
	TRACE("HVQM4 render thread start\n");
}
//-----------------------------------------------------------------------------
//`XbhI
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Movie::mTermThread( void )
{
	//`Xbh~
	OSCancelThread( &mRenderThread );
	//~`FbN
	if( OSIsThreadTerminated( &mRenderThread ) == false )
	{
		OSHalt("HVQM4 render thread stop error !!\n");
	}else
	{
		TRACE("HVQM4 render thread stop\n");
	}
}
//-----------------------------------------------------------------------------
//HVQM4ĐNGXg
// in --> none
// out -> false NGXgs
//        true  NGXg
//-----------------------------------------------------------------------------
bool
MK7Movie::mRequestProc( void )
{
	
	mFrame = -1;
	
	//Xbh𗧂Ă
	mInitThread();
	
#if 0
	u32	buffSize, err;
	
#ifdef	MOVIE_USE_TEX
	//m
	GHMGCMEM_SAFE_FREE( mvPictureBufferAlloc );
	buffSize = OSRoundUpExCacheLine( MV_WIDTH * MV_HEIGHT * 4 );
	mvPictureBufferAlloc = ghmGcMemAlloc( int(buffSize + ExCacheLineSize) );
	ASSERT( mvPictureBufferAlloc );
	mvPictureBuffer = (u8*)OSRoundUpExCacheLine( mvPictureBufferAlloc );
//	memset( mvPictureBuffer, 0x80, buffSize );
	memset( mvPictureBuffer, 0, buffSize );
	DCFlushRangeNoSync( mvPictureBuffer, buffSize );
#endif
	
	//ĐJn
	mvPlayerHandle = HVQM4PlayerExCreate(
		mFileName,			//Đt@C
		15,					//obt@̐VideofR[hobt@ bnum t[mہAudiofR[hobt@ bnum * 2 t[m
		24,					//vC[Thread̃vCIeC
		8192,				//vC[Thread̃X^bNTCY
		-1,					//C^[[X摜\̓[h
		&mvDvdStatusWatch,	//DVD̃Xe[^XĎ֐
		NULL,				//L֐̈
		&err				//G[R[h̎󂯎M
	);
	//G[`FbN
	if( mvPlayerHandle == NULL )
	{
		OSHalt("HVQM4 cleate error !!\n");
	}
	
	//s[g[hݒ
	HVQM4PlayerExSetRepeatMode( mvPlayerHandle, FALSE );
	
	//I[fBI
	mvAsendNullInit( mvPlayerHandle );
	
	mPlayerHandle = mvPlayerHandle;
    
	HVQM4PlayerEx1stFrameFunc( mvPlayerHandle, mvAsend1stFunc, NULL );
	HVQM4PlayerExStart( mvPlayerHandle );
	
#endif
	mOldBlurVisible = SceneBlur.GetVisible();
	SceneBlur.SetVisible( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//HVQM4Đ~
// in --> none
// out -> false ~s
//        true  ~
//-----------------------------------------------------------------------------
bool
MK7Movie::mStopProc( void )
{
	u32	err;
	
	//
	mMvRenderFlag = false;
	
	//I[fBII
	mvAsendDmastop();
	
	mPlayerHandle = NULL;
	
	//\񐔕\
//	if ( HVQM4PlayerExDebug_DispEmptyCount(mvPlayerHandle) > 0 )
//	{
		TRACE("HVQM4 empty count = %d\n",HVQM4PlayerExDebug_DispEmptyCount(mvPlayerHandle));
//	}
	
	//ĐI̕鏈
	if( HVQM4PlayerExClose(mvPlayerHandle,&err) == FALSE )
	{
		OSHalt("HVQM4 close error !!\n");
	}
	
	//I
	mvPlayerHandle = NULL;
#ifdef	MOVIE_USE_TEX
	//
	GHMGCMEM_SAFE_FREE( mvPictureBufferAlloc );
#endif
	
	//XbhI
	mTermThread();
	
	//[r[t[
	TRACE( "Movie total frame: %d\n ", mFrame );
	mFrame = MOVIE_NOT_PLAY;
	
	SceneBlur.SetVisible( mOldBlurVisible );
	
	return( true );
}




//-----------------------------------------------------------------------------
//`֐
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mvDraw( void )
{
//	return;
#ifdef	MOVIE_USE_TEX
	//eNX`ݒ
	//
	GXInitTexObj( &mvTexObj,
				  mvPictureBuffer,
				  MV_WIDTH,
				  MV_HEIGHT,
				  GX_TF_RGBA8,
				  GX_CLAMP,
				  GX_CLAMP,
				  GX_FALSE );
	
	GXInitTexObjLOD( &mvTexObj,
					 GX_NEAR,	//GX_LINEAR
					 GX_NEAR,	//GX_LINEAR
					 0.0f,
					 0.0f,
					 0.0f,
					 GX_FALSE,
					 GX_FALSE,
					 GX_ANISO_1 );
	
	//XV~
	GXSetAlphaUpdate( false );
	//J
	mK7Sprite::mSetCamera2D();
	//eNX`ƃCgƒ_̊ݒ
	mK7Sprite::mSetCommonEnv();
	
	//---- tevݒ ----
	//uh[hݒ
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 1 );
	//eNX`W̕@w聨łGX_TEXCOORD0̍W@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
//	GXSetTevOp( GX_TEVSTAGE0, GX_MODULATE );
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_RASC, GX_CC_TEXC, GX_CC_ZERO );
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_RASA, GX_CA_TEXA, GX_CA_ZERO );
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo
	
	//---- _ݒ ----
	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
	GXSetVtxDesc( GX_VA_TEX0, GX_DIRECT );	//eNX`0̎ނݒ
	//ꂼ̗̑vf(?)Ǝނݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XY,   GX_S16  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST,   GX_F32,   0 );	//eNX`0̗vfƎނw
	
	//eNX`[h
	GXLoadTexObj( &mvTexObj, GX_TEXMAP0 );
	//`
	GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, 4 );
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		GXPosition2s16( MOVIE_DISP_X, MOVIE_DISP_Y );
		GXColor1u32   ( 0xffffffff );
		GXTexCoord2f32( 0, 0 );
		
		GXPosition2s16( MOVIE_DISP_X + MV_WIDTH, MOVIE_DISP_Y );
		GXColor1u32   ( 0xffffffff );
		GXTexCoord2f32( 1.0f, 0 );
		
		GXPosition2s16( MOVIE_DISP_X, MOVIE_DISP_Y + MV_HEIGHT );
		GXColor1u32   ( 0xffffffff );
		GXTexCoord2f32( 0, 1.0f );
		
		GXPosition2s16( MOVIE_DISP_X + MV_WIDTH, MOVIE_DISP_Y + MV_HEIGHT );
		GXColor1u32   ( 0xffffffff );
		GXTexCoord2f32( 1.0f, 1.0f );
	GXEnd();
#endif
}
//-----------------------------------------------------------------------------
//`֐
//-----------------------------------------------------------------------------
#define FBWIDTH  640
#define FB0_OFFS_32 ((FBWIDTH/2)*0)
#define FB1_OFFS_32 ((FBWIDTH/2)*1)
#define FB2_OFFS_32 ((FBWIDTH/2)*2)
#define FB3_OFFS_32 ((FBWIDTH/2)*3)
#define FB4_OFFS_32 ((FBWIDTH/2)*4)
static void
vdisp_copy_frame( u8* imgbuf, u8* yuvimg, u32 width, u32 height )
{
    u32 *xfb;
    u32 *fb,*fbe;
    u8  *yP1,*yP2,*uP,*vP;
    u32 d0,d1,d2,d3;
    int h_loop;

    /* Draw image on XFB */
    yP2 = yuvimg;
    uP = yP2 + width * height;
    vP = uP + (width / 2) * (height / 2);

    xfb = (u32 *)(imgbuf);
    h_loop = (int)(height/2);
    for (  ; h_loop > 0 ; h_loop-- ) {
        yP2 = (yP1 = yP2) + width;
        fb = xfb;
        fbe = fb + (width/2);
        while( fb < fbe ) {
            d0=(u32)((yP1[0]<<24)|(uP[0]<<16)|(yP1[1]<<8)|(vP[0]<<0));
            d1=(u32)((yP1[2]<<24)|(uP[1]<<16)|(yP1[3]<<8)|(vP[1]<<0));
            d2=(u32)((yP1[4]<<24)|(uP[2]<<16)|(yP1[5]<<8)|(vP[2]<<0));
            d3=(u32)((yP1[6]<<24)|(uP[3]<<16)|(yP1[7]<<8)|(vP[3]<<0));
            fb[FB0_OFFS_32+0]=d0;
            fb[FB0_OFFS_32+1]=d1;
            fb[FB0_OFFS_32+2]=d2;
            fb[FB0_OFFS_32+3]=d3;
            d0=(u32)((yP2[0]<<24)|(uP[0]<<16)|(yP2[1]<<8)|(vP[0]<<0));
            d1=(u32)((yP2[2]<<24)|(uP[1]<<16)|(yP2[3]<<8)|(vP[1]<<0));
            d2=(u32)((yP2[4]<<24)|(uP[2]<<16)|(yP2[5]<<8)|(vP[2]<<0));
            d3=(u32)((yP2[6]<<24)|(uP[3]<<16)|(yP2[7]<<8)|(vP[3]<<0));
            fb[FB1_OFFS_32+0]=d0;
            fb[FB1_OFFS_32+1]=d1;
            fb[FB1_OFFS_32+2]=d2;
            fb[FB1_OFFS_32+3]=d3;
            fb += (4);
            uP += 4 ;
            vP += 4 ;
            yP1 += (2*4) ;
            yP2 += (2*4) ;
        }
        DCFlushRangeNoSync( xfb+FB0_OFFS_32,(u32)(width*2));
        DCFlushRangeNoSync( xfb+FB1_OFFS_32,(u32)(width*2));
        xfb += FB2_OFFS_32 ;
    }
}
//-----------------------------------------------------------------------------
//HVQM4`Xbh֐
// in --> none
// out -> none
//-----------------------------------------------------------------------------
#if	0
void _OSReport(const char* msg, ...)
{
    va_list marker;

    va_start(marker, msg);
    vprintf(msg, marker);
    va_end(marker);
}
#endif
void*
mvRenderThreadFunc( void* )
{
	u32	buffSize, err;
#ifdef	MOVIE_USE_TEX
	//m
	GHMGCMEM_SAFE_FREE( mvPictureBufferAlloc );
	buffSize = OSRoundUpExCacheLine( MV_WIDTH * MV_HEIGHT * 4 );
	mvPictureBufferAlloc = ghmGcMemAlloc( int(buffSize + ExCacheLineSize) );
	ASSERT( mvPictureBufferAlloc );
	mvPictureBuffer = (u8*)OSRoundUpExCacheLine( mvPictureBufferAlloc );
//	memset( mvPictureBuffer, 0x80, buffSize );
	memset( mvPictureBuffer, 0, buffSize );
	DCFlushRangeNoSync( mvPictureBuffer, buffSize );
#endif
	
	//ĐJn
	mvPlayerHandle = HVQM4PlayerExCreate(
		gpMovie->GetFileName(),			//Đt@C
//		mFileName,			//Đt@C
		15,					//obt@̐VideofR[hobt@ bnum t[mہAudiofR[hobt@ bnum * 2 t[m
		24,					//vC[Thread̃vCIeC
		8192,				//vC[Thread̃X^bNTCY
		-1,					//C^[[X摜\̓[h
		&mvDvdStatusWatch,	//DVD̃Xe[^XĎ֐
		NULL,				//L֐̈
		&err				//G[R[h̎󂯎M
	);
	//G[`FbN
	if( mvPlayerHandle == NULL )
	{
		OSHalt("HVQM4 cleate error !!\n");
	}
	
	//s[g[hݒ
	HVQM4PlayerExSetRepeatMode( mvPlayerHandle, FALSE );
	
	//I[fBI
	mvAsendNullInit( mvPlayerHandle );
	
//	mPlayerHandle = mvPlayerHandle;
	gpMovie->mSetPlayerHandle(mvPlayerHandle);
    
	HVQM4PlayerEx1stFrameFunc( mvPlayerHandle, mvAsend1stFunc, NULL );
	HVQM4PlayerExStart( mvPlayerHandle );
	
#ifdef	MOVIE_USE_TEX
	//eNX`g
	hHVQM4PlayerEx	playerHandle;
    hHVQM4BufvData	buff;
    u8*				hvqimg;
    u32				width;
    u32				height;
	
	while( 1 )
	{
		playerHandle = gpMovie->mGetPlayerHandle();
		if( playerHandle != NULL )
		{
			if( HVQM4PlayerExViRetrace(playerHandle) )
			{
				buff = HVQM4PlayerExBufvGetDisp( playerHandle );
				if( buff != NULL )
				{
					hvqimg = (u8*)HVQM4PlayerExBufvGetBuff( buff );
					width  = HVQM4PlayerExGetWidth( playerHandle );
					height = HVQM4PlayerExGetHeight( playerHandle );
					//fR[h߃EGCg(VOobt@̋w)
					{
					#if	0
						static	u32 MOVIE_FORCE_WAIT = 0;
						if( HSD_PadGetRepeat(0) == PAD_BUTTON_UP ){
							MOVIE_FORCE_WAIT += 100;
						}else
						if( (HSD_PadGetRepeat(0) == PAD_BUTTON_DOWN) && (MOVIE_FORCE_WAIT >= 100) ){
							MOVIE_FORCE_WAIT -= 100;
						}else
						if( HSD_PadGetTrigger(0) == PAD_BUTTON_A ){
							_OSReport("%d\n",MOVIE_FORCE_WAIT);
						}
					#else
						#define MOVIE_FORCE_WAIT	(300)
					#endif
						OSTick tick = OSGetTick();
						while( (tick + OSMicrosecondsToTicks(MOVIE_FORCE_WAIT)) > OSGetTick() ){}
						//OS_TIMER_CLOCK / WK7_FRAME_RATE;	//30t[ŐiރNbN
					}
					ConvertTexRgba8( hvqimg, (u8*)mvPictureBuffer, width, height );
					HVQM4PlayerExBufvSetBusyFlag( buff, FALSE );
					gpMovie->mAddFrame();
				}
			}
		}
		VIWaitForRetrace();
	}
    return( NULL );
#else
	//xfbɒړ]
	hHVQM4PlayerEx		playerHandle;
    hHVQM4BufvData		buff;
    u8*					xfb;
    u8*					hvqimg;
    u32					height;
    u32					width;
    u32					fboffs;
	GXRenderModeObj*	rMode = HSD_GetRmode();
    
    while( 1 )
    {
		playerHandle = gpMovie->mGetPlayerHandle();
		if( playerHandle != NULL )
		{
			if( HVQM4PlayerExViRetrace(playerHandle) )
			{
				buff = HVQM4PlayerExBufvGetDisp( playerHandle );
                if( buff != NULL )
                {
				//	xfb    = (u8*)HSD_GetFrameBuffer();
					hvqimg = (u8*)HVQM4PlayerExBufvGetBuff( buff );
					width  = HVQM4PlayerExGetWidth( playerHandle );
					height = HVQM4PlayerExGetHeight( playerHandle );
				//	if( FrameBufferClearFlag[FrameBufferPage] )
				//	{
				//		u32 *v,*e;
				//		v=(u32 *)xfb;
				//		e=(u32 *)(xfb+FrameBufferSize);
				//		while( v < e )
				//		{
				//		    *v=0x00800080;
				//		    v++;
				//		}
				//		DCFlushRangeNoSync( xfb,FrameBufferSize);
				//		FrameBufferClearFlag[FrameBufferPage]=FALSE;
				//	}
					/* Calculate offset for xfb to come to the center of screen */
					fboffs = ((((rMode->xfbHeight-height)/2)*FBWIDTH)*2)+(((FBWIDTH-width)/2)*2);
				//	vdisp_copy_frame( xfb+fboffs, hvqimg, width, height );
					HVQM4PlayerExBufvSetBusyFlag( buff, FALSE );
				//	VISetNextFrameBuffer(xfb);
				//	VIFlush();
				//	FrameBufferPage++;
				//	if ( FrameBufferPage == FRAME_BUFF_NUMS )
				//	{
				//		FrameBufferPage=0;
				//	}
				}
			}
		}
		VIWaitForRetrace();
	}
	return( NULL );
#endif
}
//-----------------------------------------------------------------------------
//    func:      DVD Status ωɌĂяo callback֐B
//               NULL w肷ƁAcallback ֐͖łB
//               func() ďóAHVQM4PlayerExCreate() Ŏw肵 parm 
//               DVD Status Ƃēn܂B
//                  func( <hHVQM4PlayerEx>, <param>, <DVD Status> );
//               ۂɃQ[ɑgݍޏꍇ́A̋@\gpāACOVEROPEN,
//               RETRY ERROR, FATAL ERROR, NO DISK, WRONG DISK ɑΉ鏈
//               sKv܂B
//
//		case	DVD_STATE_FATAL_ERROR:
//		case	DVD_STATE_WAITING:
//		case	DVD_STATE_COVER_CLOSED:		//internal state. never returns.
//		case	DVD_STATE_MOTOR_STOPPED:
//		case	DVD_STATE_PAUSING:
//		case	DVD_STATE_IGNORED:
//		case	DVD_STATE_CANCELED:
//		case	DVD_STATE_RETRY:
//
//HVQM4 DVDXe[^XĎ֐
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mvDvdStatusWatch( hHVQM4PlayerEx inPlayerHandle, void* inPtr, s32 inStatus )
{
	inPlayerHandle;
	inPtr;
	return;
	
	switch( inStatus )
	{
		//fBXNȂ
		case	DVD_STATE_NO_DISK:
			gpMovie->mSetPause();
			gpMovie->mSetDVDError( true );
			break;
		
		//Jo[JĂ
		case	DVD_STATE_COVER_OPEN:
			gpMovie->mSetPause();
			gpMovie->mSetDVDError( true );
			break;
		
		//ႤfBXNĂ
		case	DVD_STATE_WRONG_DISK:
			gpMovie->mSetPause();
			gpMovie->mSetDVDError( true );
			break;
		
		//ҋ@ǂݍݒ
		case	DVD_STATE_END:
		case	DVD_STATE_BUSY:
			if( gpMovie->mGetDVDError() == true )
			{
				gpMovie->mReleasePause();
				gpMovie->mSetDVDError( false );
			}
			break;
		
		default:
			break;
	}
}




//ϐ錾
static	AIDCallback		mvOldAIDCallback     = NULL;
static	hHVQM4BufaData  asend_last           = NULL;
static	u8*				_asend_null_ptr      = NULL;
static	u8*				asend_null_ptr       = NULL;
static	u32				asend_null_siz       = 0;
//-----------------------------------------------------------------------------
//HVQM4I[fBI
// in -->
// out ->
//-----------------------------------------------------------------------------
void
mvAsendNullInit( hHVQM4PlayerEx inHp )
{
	u32 wsize;
	u32 n;

	GHMGCMEM_SAFE_FREE( _asend_null_ptr );

	wsize  = HVQM4PlayerExGetAudioSamples( inHp );
	wsize *= HVQM4PlayerExGetMicroSecPerFrame( inHp );
	wsize /= 1000000;
	wsize *= 4;
	wsize  = OSRoundUp32B( wsize );
	asend_null_siz  = wsize;

	//OSReport("asend_null_siz=%d\n",asend_null_siz);

	_asend_null_ptr = (u8*)ghmGcMemAlloc( (int)(wsize + 32) );
	
	if( _asend_null_ptr == NULL )
	{
	    OSHalt("asend_null alloc error !\n");
	}

	asend_null_ptr = (u8*)OSRoundUp32B( _asend_null_ptr );

	for( n = 0; n < wsize; n++ )
	{
	    asend_null_ptr[n] = 0;
	}

	DCFlushRange( asend_null_ptr, asend_null_siz );
}
//-----------------------------------------------------------------------------
//HVQM4 Transfer soundless data if data dose not exist
// in -->
// out ->
//-----------------------------------------------------------------------------
void
mvAsendDmanext( void )
{
	hHVQM4BufaData	buff;

	buff = HVQM4PlayerExBufaGetSend( gpMovie->mGetPlayerHandle() );

	if( asend_last != NULL )
	{
		HVQM4PlayerExBufaSetFree( gpMovie->mGetPlayerHandle(), asend_last );
	}
	
	asend_last = buff;
	
	if( (asend_last != NULL) && HVQM4PlayerExControlCheckNormal( gpMovie->mGetPlayerHandle() ) )
	{
		DCFlushRange( HVQM4PlayerExBufaGetBuff(asend_last), HVQM4PlayerExBufaGetSize(asend_last) );
		AIInitDMA( (u32)HVQM4PlayerExBufaGetBuff(asend_last), HVQM4PlayerExBufaGetSize(asend_last) );
	}else
	{
		AIInitDMA( (u32)asend_null_ptr, asend_null_siz );
	}
}
//-----------------------------------------------------------------------------
//HVQM4I[fBII
// in -->
// out ->
//-----------------------------------------------------------------------------
void
mvAsendDmastop( void )
{
    BOOL	old;
	
//	AIStopDMA();
	
	old = OSDisableInterrupts();
	if( mvOldAIDCallback )
	{
		AIRegisterDMACallback( mvOldAIDCallback );
	}else
	{
		AIRegisterDMACallback( NULL );
	}
	OSRestoreInterrupts( old );
	
	GHMGCMEM_SAFE_FREE( _asend_null_ptr );
}
//-----------------------------------------------------------------------------
//
// in -->
// out ->
//-----------------------------------------------------------------------------
void
mvAsend1stFunc( hHVQM4PlayerEx inHp, void * )
{
    BOOL	old;
	u32		sample;
	
	sample = HVQM4PlayerExGetAudioSamples( inHp );
	//OSReport("asend_1st_func() %d\n",sample);

	if( sample == 48043 || sample == 48042 )
	{
		AISetDSPSampleRate( AI_SAMPLERATE_48KHZ );
	}else
	if( sample == 32028 )
	{
		AISetDSPSampleRate( AI_SAMPLERATE_32KHZ );
	}else
	if( sample == 0 )
	{
		OSReport("no sound data !\n");
		return;
	}else
	{
		OSReport("audio samples/sec error ! %d\n",sample);
		OSHalt("stop\n");
	}
	
	asend_last = NULL;
	
	old = OSDisableInterrupts();
	mvOldAIDCallback = AIRegisterDMACallback( mvAsendDmanext );
	OSRestoreInterrupts( old );
	
	mvAsendDmanext();
//	AIStartDMA();
}


