////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Movie
//
// mK7Movie.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 08/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7MOVIE_H__
#define	__MK7MOVIE_H__


#define	MOVIE_FILE_LENGTH	(128)

//---- include ----
#include ".\hvqm4\HVQM4PlayerEx.h"
#include ".\hvqm4\convrgb.h"
#include "mk7common.h"

//---- define ----
#define	MOVIE_NOT_PLAY	(-2)

//---- enum ----
typedef	enum{
	eMvProcRequest,		//ĐNGXg(f[^ǂݍ)
	eMvProcDrawing,		//`撆
	eMvProcStandby,		//ҋ@
	eMvProcMax,
}enMvProc;
	

//---- struct ----

//---- class ----
//u[NX

class MK7Movie{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7Movie();
	//fXgN^
	~MK7Movie();
	
	//
	static
	void			Init( void );
	//㏈
	static
	void			Term( void );
	
	//
	void			mInit( void );
	//㏈
	void			mTerm( void );
	
	//t[
	void			mFrameProcess( void );
	//\[Xt@C̎擾
	char*			mGetResourceFileName( void );
	//_O
	void			mRender( void );
	//ĐNGXg
	bool			mRequest( char* inFileName );
	//Đ~
	bool			mStop( void );
	//ꎞ~
	bool			mSetPause( void );
	//ꎞ~
	bool			mReleasePause( void );
	//vC[nhݒ
    bool mSetPlayerHandle(hHVQM4PlayerEx hndl){ mPlayerHandle=hndl; return true; }
	//vC[nh擾
	hHVQM4PlayerEx	mGetPlayerHandle( void ){return(mPlayerHandle);}
	//HVQM4Xe[^X擾
	enMvProc		mGetStatus( void ){return( mProc );}
	//fR[hXbh
	void			mInitThread( void );
	//fR[hXbh~
	void			mTermThread( void );
	//HVQM4ĐNGXg
	bool			mRequestProc( void );
	//HVQM4Đ~
	bool			mStopProc( void );
	//DVDǂݍ݃G[ݒ
	void			mSetDVDError( bool inFlag ){mDVDError=inFlag;}
	//DVDǂݍ݃G[擾
	bool			mGetDVDError( void ){return(mDVDError);}
	//|[YtO̎擾
	bool			mGetPauseFlag( void ){return(mPauseFlag);}
	//t[Z
	void			mAddFrame( void ){mFrame++;}
	//t[擾
	s32				mGetFrame( void ){return(mFrame);}
	//t@C擾
	char* GetFileName(void){ return mFileName; }
private:
	//---- ֐ ----
	//---- ϐ ----
	OSThread			mRenderThread;				//`Xbh
	u8					mRenderThreadStack[4096];	//`X^bN
    hHVQM4PlayerEx		mPlayerHandle;
	enMvProc			mProc;							//t[
	char				mFileName[MOVIE_FILE_LENGTH];	//Đt@C
	bool				mMvRenderFlag;					//[r[_OtO
	bool				mPauseFlag;						//ꎞ~tO
	bool				mDVDError;						//DVDǂݍ݃G[tO
	s32					mFrame;							//\t[
	bool				mOldBlurVisible;				//i{Pݒ
	
	mK7File				mFile;
	void*				mBuff;								//f[^ǂݍ݃obt@
	ghmGcResLink*		mReslink;							//\[X
	char				mResFileName[MOVIE_FILE_LENGTH];	//\[Xt@C
};



//extern
extern	MK7Movie*		gpMovie;



#endif	//__MK7MOVIE_H__




