////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Noise
//
// mK7Noise.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/01/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7NOISE_CPP__

//---- include ----
#include "..\wat\WK7Define.h"
#include "..\wat\WK7MainTask.h"
#include "..\wat\WK7Player.h"
#include "..\wat\WK7GameInfo.h"
#include "..\Sato\SK7Special.h"
#include "MK7Jimaku.h"
#include "mK7Noise.h"
#include "mK7Sound.h"

//---- define ----
#define	NOISE_TEX_FILE		"Texture/noise.bin"
#define	NOISE_MIDDLE_ALPHA	(64)	//ʂɎcmCỸl
#define	NOISE_SCALEUP_RATE	(4)		//mCYg傳銄

#define	SAND_NOISEBLUE_TEX_FILE		"Texture/noiseblue.bin"
#define	SAND_NOISERED_TEX_FILE		"Texture/noisered.bin"
#define	SAND_NOISE_FONT_ALPH_FILE	"Texture/noisefont.jmb"
#define	SAND_NOISE_FONT_KATA_FILE	"Texture/noisefontkana.jmb"
#define	SAND_SCROLL_SPEED			(1)		//̃x[XXN[鑬x
#define	SAND_SCROLL_SPEED_MAX		(128)	//̃x[XXN[ő呬x
#define	SAND_SCROLL_SHORT_TICK		(400)	//畜A鎞ԁEV[g
#define	SAND_SCROLL_LONG_TICK		(2400)	//畜A鎞ԁEO
#define	SAND_SCROLL_TO_MAP_TICK		(14400)	//畜A鎞ԁE}bv֌q
#define	SAND_NOISE_TEX_W			(160)	//eNX`̕
#define	SAND_NOISE_TEX_H			(120)	//eNX`̍
#define	SAND_NOISE_RATE_MIN			(7)		//g傳ŏ
//#define	SAND_NOISE_RATE_MAX			(12)	//g傳ő劄
#define	SAND_NOISE_RATE_MAX			(18)	//g傳ő劄
#define	SAND_NOISE_RATE_MAX_TO_MAP	(64)	//g傳ő劄
//#define	SAND_NOISE_RATE_MAX_TO_MAP	(100)	//g傳ő劄
#define	SAND_NOISE_HEIGHT			(64)	//ꂽƂ̍ŏIIȍ
#define	SAND_NOISE_WAIT_TO_MAP		(4800)	//}bvʂ֌ÕEGCg

#define	SAND_STRING_IN_TICK			(4800)	//ꎞ
#define	SAND_STRING_DISP_TICK		(2400)	//\
#define	SAND_STRING_OUT_TICK		(2400)	//ޏꎞ

#define	SAND_STRING_UA_Y			(24)	//iAt@xbg\yW
#define	SAND_STRING_DK_Y			(K7APP_SCREEN_HEIGHT-SAND_STRING_UA_Y)	//iJ^Ji\yW


//---- O[oϐ ----
MK7Noise*	gpNoise = NULL;




//---- ֐ ----
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Noise::MK7Noise()
{
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Noise::~MK7Noise()
{
}




//-----------------------------------------------------------------------------
//staic
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::Init( void )
{
	if( gpNoise == NULL ){
		ghmGcMemSetAllocName("MNoise");
		gpNoise = new MK7Noise;
	}
	gpNoise->mInit();
}
//-----------------------------------------------------------------------------
//static㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::Term( void )
{
	gpNoise->mTerm();
	GHM_SAFE_DELETE( gpNoise );
}
//-----------------------------------------------------------------------------
//
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::mInit( void )
{
	int	i;
	
	mFrameProc = eNoiseFileRead;
	
	//eNX`|C^
	mTexNoise.tex     = NULL;
	mTexBlueNoise.tex = NULL;
	mTexRedNoise.tex  = NULL;
	
	//ݒ
	mSandFrameProc     = eSandInit;
	mTexHeader.mFormat = GX_TF_RGBA8;
	mTexHeader.mWidth  = WK7_SCREEN_WIDTH;
	mTexHeader.mHeight = WK7_SCREEN_HEIGHT;
	mTexBase.tex       = &mTexHeader;
	mBaseY             = 0;
	mBaseYSpeed        = 0;
	for( i = 0; i < NOISE_SAND_BASE_NUM; i++ )
	{
		mSprtBase[i].mSetPriority( SPRT_PRI_SANDBASE );
		mSprtBase[i].mRelateTex( &mTexBase );
		mSprtBase[i].mSetSpriteNoTexAlphaPrim();
		mSprtBase[i].mSetUV0( 0, 0 );
		mSprtBase[i].mSetXY0( 0, 0 );
		mSprtBase[i].mSetWH( WK7_SCREEN_WIDTH, WK7_SCREEN_HEIGHT );
		mSprtBase[i].mSetRGBA( 0xffffffff );
		mSprtBase[i].mSetDispFlag( false );
	}
	
	//
	for( i = 0; i < NOISE_SAND_STR_MAX; i++ )
	{
		mFont[i].str  = NULL;
		mFont[i].sprt = NULL;
	}
	mTexFontAlph.dat = NULL;
	mTexFontKata.dat = NULL;
	mUpDownFontDisp  = false;
	mMono            = false;
	mMonoRGBA        = 0xffffffff;
}
//-----------------------------------------------------------------------------
//㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::mTerm( void )
{
	int	i, j;
	
	//SE~
	gpSound->mStopSE( SFX_SYS_SAND_NOISE );
	gpSound->mStopSE( SFX_BT_KAMAE_NOISE );
	
	//XvCgݒ
	for( j = 0; j < NOISE_HEIGHT_NUM; j++ )
		for( i = 0; i < NOISE_WIDTH_NUM; i++ )
			mSprtN[i][j].mSetDispFlag( false );
	mSprtNoise.mSetDispFlag( false );
	mSprtNoiseBottom.mSetDispFlag( false );
	for( i = 0; i < NOISE_SAND_BASE_NUM; i++ )
	{
		mSprtBase[i].mSetDispFlag( false );
	}
	
	mInitNoiseFont();
	
	//eNX`
	GHMGCMEM_SAFE_FREE( mTexNoise.tex );
	GHMGCMEM_SAFE_FREE( mTexBlueNoise.tex );
	GHMGCMEM_SAFE_FREE( mTexRedNoise.tex );
	
	GHMGCMEM_SAFE_FREE( mTexFontAlph.dat );
	GHMGCMEM_SAFE_FREE( mTexFontKata.dat );
}
//-----------------------------------------------------------------------------
//NGXg
// in --> u32  inTick         mCY\鎞(P:tick 1b=4800)
//        u32  inInTick       tF[hCɂ鎞(P:tick 1b=4800)
//        u32  inOutTick      tF[hAEgɂ鎞(P:tick 1b=4800)
//        bool inAutoRelease  Iɉ邩tO
// out -> bool false  NGXgs(=eNX`f[^ǂݍݒ)
//             true   NGXg
//-----------------------------------------------------------------------------
bool
MK7Noise::mRequest( s32 inTick, s32 inInTick, s32 inOutTick, bool inAutoRelease )
{
	int	i, j;
	
	if( mFrameProc == eNoiseFileRead )
		return( false );
	
	mNowTick     = inTick;
	mFadeInTick  = inInTick;
	mFadeOutTick = inOutTick;
	mAutoRelease = inAutoRelease;
	
	//XvCgݒ
	for( j = 0; j < NOISE_HEIGHT_NUM; j++ )
	{
		for( i = 0; i < NOISE_WIDTH_NUM; i++ )
		{
			mSprtN[i][j].mSetDispFlag( true );
			mSprtN[i][j].mSetRGBA( 0x80808000 );
			mSprtN[i][j].mSetFade( 0x80, mFadeInTick );
		}
	}
	
	if( mAutoRelease == false )
	{
		//SEĐ
		gpSound->mPlaySE( SFX_BT_ZOOM_IN,			//SEԍ
						  SOUND_SYSTEM_SE_VOLUME,	//
						  SOUND_PAN_CENTER,			//p
						  eSETrackBattleOverlap,	//gbN
						  eSEGroupBattle00 );		//O[v
	}
	
	//s
	mFrameProc = eNoiseFadeIn;
	
	return( true );
}
//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::mFrameProcess( void )
{
	enFileRead	fileStatus;
	int			i, j, rand;
	
	if( (mFrameProc == eNoiseExec)
	 || (mFrameProc == eNoiseFadeOut)
	 || (mFrameProc == eNoiseFadeIn)
	 || (mFrameProc == eNoiseFadeStopping)
	 || (mFrameProc == eNoiseFadeFinish)
	)
	{
		rand = HSD_Randi(100);
		for( j = 0; j < NOISE_HEIGHT_NUM; j++ )
		{
			for( i = 0; i < NOISE_WIDTH_NUM; i++ )
			{
				if( rand < 90 )
				{
					mSprtN[i][j].mSetUV0( (s16)(HSD_Randi(NOISE_WIDTH)), (s16)(HSD_Randi(NOISE_HEIGHT)) );
				}else
				{
					mSprtN[i][j].mSetUV0(                               (s16)(HSD_Randi(NOISE_WIDTH)),                               (s16)(HSD_Randi(NOISE_HEIGHT)) );
					mSprtN[i][j].mSetUV1( (s16)(mSprtN[i][j].mGetU0()+NOISE_WIDTH/NOISE_SCALEUP_RATE),                                        mSprtN[i][j].mGetV0() );
					mSprtN[i][j].mSetUV2(                                       mSprtN[i][j].mGetU0(), (s16)(mSprtN[i][j].mGetV0()+NOISE_HEIGHT/NOISE_SCALEUP_RATE) );
					mSprtN[i][j].mSetUV3( (s16)(mSprtN[i][j].mGetU0()+NOISE_WIDTH/NOISE_SCALEUP_RATE), (s16)(mSprtN[i][j].mGetV0()+NOISE_HEIGHT/NOISE_SCALEUP_RATE) );
				}
			}
		}
	}
	
	switch( mFrameProc )
	{
		//
		case	eNoiseInit:
			break;
		
		//eNX`t@Cǂݍ
		case	eNoiseFileRead:
			//mCYpeNX`ǂݍ
			fileStatus = mFile.mK7FileRead( NOISE_TEX_FILE, &((void*)mTexNoise.tex) );
			if( fileStatus == eFileReadSucsess )
			{
				//eNX`̏
				mK7InitTexture( &mTexNoise );
				//mCYݒ
				for( j = 0; j < NOISE_HEIGHT_NUM; j++ )
				for( i = 0; i < NOISE_WIDTH_NUM; i++ )
				{
					mSprtN[i][j].mRelateTex( &mTexNoise );
					mSprtN[i][j].mSetPriority( SPRT_PRI_NOISE );
					mSprtN[i][j].mSetWH( NOISE_WIDTH, NOISE_HEIGHT );
					mSprtN[i][j].mSetUV0( 0, 0 );
					mSprtN[i][j].mSetXY0( (s16)(NOISE_WIDTH * i), (s16)(NOISE_HEIGHT * j) );
					mSprtN[i][j].mSetDispFlag( false );
				}
				mFrameProc = eNoiseStandby;
			}
			break;
		
		//tF[hC
		case	eNoiseFadeIn:
			if( mSprtN[0][0].mGetFadeEnd() == true )
			{
				gpSound->mPlaySE( SFX_BT_KAMAE_NOISE,		//SEԍ
								  SOUND_SYSTEM_SE_VOLUME,	//
								  SOUND_PAN_CENTER,			//p
								  eSETrackBattle00,			//gbN
								  eSEGroupBattle00 );		//O[v
				mFrameProc = eNoiseExec;
			}
			break;
		
		//s
		case	eNoiseExec:
			if( mNowTick > 0 )
			{//Ԃo߂ĎRɂڂ₯~߂
				mNowTick -= WK7_TICK_PER_FRAME;
				if( mNowTick <= 0 )
				{
					for( j = 0; j < NOISE_HEIGHT_NUM; j++ )
						for( i = 0; i < NOISE_WIDTH_NUM; i++ )
							mSprtN[i][j].mSetFade( NOISE_MIDDLE_ALPHA, mFadeOutTick );
					mNowTick   = 0;
					mFrameProc = eNoiseFadeOut;
				}
			}
			break;
		
		//tF[hAEg
		case	eNoiseFadeOut:
			if( mSprtN[0][0].mGetFadeEnd() == true )
			{
				if( mAutoRelease == true )
				{
					mRelease();
				}else
				{
					mFrameProc = eNoiseFadeStopping;
				}
			}
			break;
		
		//tF[hAEg~
		case	eNoiseFadeStopping:
			break;
		
		//tF[hI
		case	eNoiseFadeFinish:
			if( mSprtN[0][0].mGetFadeEnd() == true )
			{
				for( j = 0; j < NOISE_HEIGHT_NUM; j++ )
					for( i = 0; i < NOISE_WIDTH_NUM; i++ )
						mSprtN[i][j].mSetDispFlag( false );
				mFrameProc = eNoiseStandby;
			}
			break;
		
		//ҋ@
		case	eNoiseStandby:
			break;
		
		default:
			break;
	}
	
	//mCỸt[
	mSandFrameProcess();
	//㉺̊Ď
	mWatchUpDownStr();
}
//-----------------------------------------------------------------------------
//`揈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::mRender( void )
{
	//mCỸ_[
	mSandRender();
}
//-----------------------------------------------------------------------------
//mCYI
// in --> none
// out -> bool false  mCYIԂɂ܂
//             true   mCYI܂
//-----------------------------------------------------------------------------
bool
MK7Noise::mRelease( void )
{
	int	i, j;
	//łIł悤ɏC
	//if( mFrameProc != eNoiseFadeStopping )
	//	return( false );
	
	for( j = 0; j < NOISE_HEIGHT_NUM; j++ )
		for( i = 0; i < NOISE_WIDTH_NUM; i++ )
			mSprtN[i][j].mSetFade( 0, mFadeOutTick );
	mFrameProc = eNoiseFadeFinish;
	gpSound->mStopSE( SFX_BT_KAMAE_NOISE );
	return( true );
}




//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
//-----------------------------------------------------------------------------
//mN[hݒ
// in --> bool inFlag false  J[ݒ
//                    true   mNݒ
//        u32  inRGBA        eNX`_J[
// out -> bool false   ܂ł̐ݒ̓J[ł
//             true    ܂ł̐ݒ̓mNł
//-----------------------------------------------------------------------------
bool
MK7Noise::mSandSetMono( bool inFlag, u32 inRGBA )
{
	bool old  = mMono;
	mMono     = inFlag;
	mMonoRGBA = inRGBA;
	return( old );
}
//-----------------------------------------------------------------------------
//NGXg
// in --> enSnadNoiseType inNoiseType   mCY̎
//        enNoiseColor    inNoiseColor  mCỸJ[
//        int             inSENo        SEԍ
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Noise::mSandRequest( enSnadNoiseType inNoiseType, enNoiseColor inNoiseColor, int inSENo )
{
	int	i;
	
	GXTexObj*	pTexObj;
	
	//ԂX^oCȊOƃNGXg󂯕tȂ
	if( mSandFrameProc != eSandStandby )
		return( false );
	
	//g~OtOQ
	mNoiseTrimming = false;
	//
	mInitNoiseFont();
	
	//F̃eNX`I
	switch( inNoiseColor )
	{
		case	eNoiseColorBlue:
			mSprtNoise.mRelateTex( &mTexBlueNoise );
			mSprtNoiseBottom.mRelateTex( &mTexBlueNoise );
			break;
		case	eNoiseColorRed:
			mSprtNoise.mRelateTex( &mTexRedNoise );
			mSprtNoiseBottom.mRelateTex( &mTexRedNoise );
			break;
		default:
			mSprtNoise.mRelateTex( &mTexBlueNoise );
			mSprtNoiseBottom.mRelateTex( &mTexBlueNoise );
			break;
	}
	
	//J[[h
	if( mMono == true )
	{
		//eNX`擾
		pTexObj = screenImageMonoColor.GetTexObj();
		mSprtBase[0].mSetRGBA( mMonoRGBA );
		mSprtBase[1].mSetRGBA( mMonoRGBA );
	}else
	{
		//eNX`擾
		pTexObj = screenImageFullColor.GetTexObj();
		mSprtBase[0].mSetRGBA( 0xffffffff );
		mSprtBase[1].mSetRGBA( 0xffffffff );
	}
	memcpy( &mTexBase.obj, pTexObj, sizeof(GXTexObj) );
	screenImageMonoColor.ScreenCopy(false);
	screenImageFullColor.ScreenCopy(false);
	//XN[C[WRs[֎~
	screenImageMonoColor.SetCopyEnable( false );
	screenImageFullColor.SetCopyEnable( false );
	
	//XN[WƃXs[h
	mBaseY         = 0;
	mBaseYSpeed    = 0;
	mSandNoiseType = inNoiseType;
	if( mSandNoiseType == eSandShortNoise )
	{
		mBaseNowTick   = SAND_SCROLL_SHORT_TICK;
		mBaseFadeTick  = SAND_SCROLL_SHORT_TICK;
	}else
	{
		mBaseNowTick   = SAND_SCROLL_LONG_TICK;
		mBaseFadeTick  = SAND_SCROLL_LONG_TICK;
	}
	
	//XvCgݒ
	mSprtNoise.mSetWH( K7APP_SCREEN_WIDTH, K7APP_SCREEN_HEIGHT );
	mSprtNoise.mSetDispFlag( true );
	mSprtNoise.mSetRGBA( 0xffffff00 );
	mSprtNoise.mSetFade( 0xff, mBaseFadeTick );
	mSprtNoiseBottom.mSetDispFlag( false );
	mSprtNoiseBottom.mSetRGBA( 0xffffffff );
	
	//ʃRs[̃XvCg\
	if( mSandNoiseType == eSandLongNoise )
	for( i = 0; i < NOISE_SAND_BASE_NUM; i++ )
	{
	//	mSprtBase[0].mSetRGBA( 0xffff00ff );	//Ղ悤ɃeXg
	//	mSprtBase[1].mSetRGBA( 0xff0000ff );	//Ղ悤ɃeXg
		mSprtBase[i].mSetSpriteNoTexAlphaPrim();
		mSprtBase[i].mSetDispFlag( true );
	}
	
	//{IɃ[vł͂Ȃݒɂ
	mNotNoiseSE = true;
	
	//SEĐ
	if( inSENo != NOISE_SE_NONE )
	{
		//ʏ퉹
		if( inSENo == NOISE_SE_NORMAL )
		{
		//	mNotNoiseSE = false;
			gpSound->mPlaySE( SFX_SYS_SAND_NOISE );
		}else
		//}bvԈړftHg
		if( inSENo == NOISE_SE_MAP_DEFAULT )
		{
			int idTbl[] = {
				SFX_SCE0_MAP_CHANGE_DOOR_MID_OPEN,			// ZeBbN
				SFX_SCE1_MAP_CHANGE_KOUSIDO_OPEN,			// tNV}
				SFX_SCE1_MAP_CHANGE_KAKU_DOOR_OPEN,			// pr
				SFX_SCE2_MAP_CHANGE_DINER_OPEN,				// eLTX
				SFX_SCE3_MAP_CHANGE_DOOR_IRON_LIGHT_OPEN,	// VniCVUJhj
				SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_OPEN,	// J[eBX@
				SFX_SCE4_MAP_CHANGE_WDOOR_WOOD_OPEN,		// h~jJ
				SFX_SYS_SAND_NOISE,							// j[[N
				SFX_SCE5_MAP_CHANGE_DOOR_COMMON_OPEN,		// ze
				SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_OPEN,		// wZ
				SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_OPEN,	// R͓
				SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,			// KVA@
				SFX_SYS_MAP_CHANGE_DOOR_HAC_OPEN,			// n[}
			};
			gpSound->mPlaySE( idTbl[GameInfo.GetAreaID()] );
		}else
		{
			gpSound->mPlaySE( inSENo );
		}
	}
	
	//eNX`XP[ݒ
	mSandScaleRate = SAND_NOISE_RATE_MAX;
	
	//tF[hC
	mSandFrameProc = eSandFadeIn;
	
	return( true );
}
//-----------------------------------------------------------------------------
//
// in --> char* inStr0         iɕ\镶
//        char* inStr1         iɕ\镶
//        char* inStr2         iɕ\镶
//        char* inStr3         iɕ\镶
//        int   inSENo         SEԍ
//        bool  inLongRelease  }bvʂɌqp(Ԃĉ&g嗦up)
// out -> false  ʂԂɂȂĂȂ̂ŉs
//        true   
//-----------------------------------------------------------------------------
bool
MK7Noise::mSandRelease( char* inStr0, char* inStr1, char* inStr2, char* inStr3, int inSENo, bool inLongRelease )
{
	GXTexObj*	pTexObj;
	
	//s̓NGXgłȂ
	if( (mSandFrameProc != eSandFadeIn)
	 && (mSandFrameProc != eSandExec ) )
		return( false );
	
	//ۑ
	if( inStr0 != NULL )
	{
		//g~OtO𗧂Ă
		mNoiseTrimming = true;
		//NGXg
		mUpDownStrRequest( inStr0, inStr1, inStr2, inStr3, SAND_STRING_IN_TICK );
		//mCY͕\Ă̂ŏ㉺tHĝݕ\tOfalse
		mUpDownFontDisp = false;
	}
	
	//ݏĂʂLv`
	screenImageMonoColor.SetCopyEnable( true );
	screenImageFullColor.SetCopyEnable( true );
	//J[[h
	if( mMono == true )
	{
		//eNX`擾
		pTexObj = screenImageMonoColor.GetTexObj();
		mSprtBase[0].mSetRGBA( mMonoRGBA );
		mSprtBase[1].mSetRGBA( mMonoRGBA );
	}else
	{
		//eNX`擾
		pTexObj = screenImageFullColor.GetTexObj();
		mSprtBase[0].mSetRGBA( 0xffffffff );
		mSprtBase[1].mSetRGBA( 0xffffffff );
	}
	memcpy( &mTexBase.obj, pTexObj, sizeof(GXTexObj) );
	
	//ʂ̈ʒuɖ߂邽߂̏lݒ
	mBaseY         = SAND_SCROLL_SPEED_MAX - 61;
	mBaseYSpeed    = (f32)SAND_SCROLL_SPEED_MAX;
	mSandMaxRate   = SAND_NOISE_RATE_MAX;	//̍őg
	
	//mCY鎞Ԃݒ
	if( mSandNoiseType == eSandShortNoise )
	{
		mBaseNowTick   = SAND_SCROLL_SHORT_TICK;
		mBaseFadeTick  = SAND_SCROLL_SHORT_TICK;
	}else
	{
		//g~OȂ̃mCYɂ鎞
		if( mNoiseTrimming == false )
		{
			//ʏ̉
			if( inLongRelease == false )
			{
				mBaseNowTick   = SAND_SCROLL_LONG_TICK;
				mBaseFadeTick  = SAND_SCROLL_LONG_TICK;
			}else
			{
				//X}bv֌qƂ̉
				mBaseNowTick   = SAND_SCROLL_TO_MAP_TICK;
				mBaseFadeTick  = SAND_SCROLL_TO_MAP_TICK;
				mSandMaxRate   = SAND_NOISE_RATE_MAX_TO_MAP;
			}
		}else
		{
			//g~ÕmCYɂ鎞
			mBaseNowTick   = SAND_STRING_IN_TICK;
			mBaseFadeTick  = SAND_STRING_IN_TICK;
		}
	}
	
	//g~OȂ̂ł΃tF[hAEg
	if( mNoiseTrimming == false )
	{
		mSprtNoise.mSetFade( 0x00, mBaseFadeTick );
	}else
	{
		//̃mCY\
		mSprtNoiseBottom.mSetDispFlag( true );
		mNoiseHeight = (f32)(K7APP_SCREEN_HEIGHT / 2);
	}
	
	//SEĐ
	if( (inSENo != NOISE_SE_NONE) && (inSENo != NOISE_SE_NORMAL) )
	{
		//}bvԈړftHg
		if( inSENo == NOISE_SE_MAP_DEFAULT )
		{
			int idTbl[] = {
				SFX_SCE0_MAP_CHANGE_DOOR_MID_CLOSE,			// ZeBbN
				SFX_SCE1_MAP_CHANGE_KOUSIDO_CLOSE,			// tNV}
				SFX_SCE1_MAP_CHANGE_KAKU_DOOR_CLOSE,		// pr
				SFX_SCE2_MAP_CHANGE_DINER_CLOSE,			// eLTX
				SFX_SCE3_MAP_CHANGE_DOOR_IRON_LIGHT_CLOSE,	// VniCVUJhj
				SFX_SCE3_MAP_CHANGE_CUR_DOOR_GLASS_CLOSE,	// J[eBX@
				SFX_SCE4_MAP_CHANGE_WDOOR_WOOD_CLOSE,		// h~jJ
				SFX_SYS_SAND_NOISE,							// j[[N
				SFX_SCE5_MAP_CHANGE_DOOR_COMMON_CLOSE,		// ze
				SFX_SCE5_MAP_CHANGE_SCL_DOOR_IRON_CLOSE,	// wZ
				SFX_SCE6_MAP_CHANGE_SLIDE_DOOR_WOOD_CLOSE,	// R͓
				SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE,			// KVA@
				SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE,			// n[}
			};
			gpSound->mPlaySE( idTbl[GameInfo.GetAreaID()] );
		}else
		{
			gpSound->mPlaySE( inSENo );
		}
	}
	
	//tF[hAEg
	mSandFrameProc = eSandFadeOut;
	
	return( true );
}
//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::mSandFrameProcess( void )
{
	enFileRead	fileStatus;
	int			i;
	s16			uw, uh, uh2;
	
	if( mSprtNoise.mGetDispFlag() == true )
	{
		if( mNoiseTrimming == false )
		{
			uw = (s16)((f32)SAND_NOISE_TEX_W / mSandScaleRate);
			uh = (s16)((f32)SAND_NOISE_TEX_H / mSandScaleRate);
			
			mSprtNoise.mSetUV0( (s16)(HSD_Randi(SAND_NOISE_TEX_W - uw - 2) + 1),
								(s16)(HSD_Randi(SAND_NOISE_TEX_H - uh - 2) + 1) );
			
			mSprtNoise.mSetUV1( (s16)(mSprtNoise.mGetU0() + uw),
								(s16)(mSprtNoise.mGetV0()) );
			
			mSprtNoise.mSetUV2( (s16)(mSprtNoise.mGetU0()),
								(s16)(mSprtNoise.mGetV0() + uh) );
			
			mSprtNoise.mSetUV3( (s16)(mSprtNoise.mGetU0() + uw),
								(s16)(mSprtNoise.mGetV0() + uh) );
		}else
		{
			uw  = (s16)((f32)SAND_NOISE_TEX_W / mSandScaleRate);
			uh2 = (s16)((f32)SAND_NOISE_TEX_H / mSandScaleRate);
			uh  = (s16)((f32)uh2 * (mNoiseHeight / (f32)K7APP_SCREEN_HEIGHT));
			
			//㑤̃mCY
			mSprtNoise.mSetWH( K7APP_SCREEN_WIDTH, (s16)mNoiseHeight );
			
			mSprtNoise.mSetUV0( (s16)(HSD_Randi(SAND_NOISE_TEX_W - uw - 2) + 1),
								(s16)(HSD_Randi(SAND_NOISE_TEX_H - uh2 - 2) + 1) );
			
			mSprtNoise.mSetUV1( (s16)(mSprtNoise.mGetU0() + uw),
								(s16)(mSprtNoise.mGetV0()) );
			
			mSprtNoise.mSetUV2( (s16)(mSprtNoise.mGetU0()),
								(s16)(mSprtNoise.mGetV0() + uh) );
			
			mSprtNoise.mSetUV3( (s16)(mSprtNoise.mGetU0() + uw),
								(s16)(mSprtNoise.mGetV0() + uh) );
			
			//̃mCY
			mSprtNoiseBottom.mSetXY0( 0, (s16)(K7APP_SCREEN_HEIGHT - (s16)mNoiseHeight) );
			mSprtNoiseBottom.mSetWH( K7APP_SCREEN_WIDTH, (s16)mNoiseHeight );
			
			mSprtNoiseBottom.mSetUV0( (s16)(mSprtNoise.mGetU0()),
									  (s16)(uh2 / 2 + uh + 1) );
			
			mSprtNoiseBottom.mSetUV1( (s16)(mSprtNoiseBottom.mGetU0() + uw),
									  (s16)(mSprtNoiseBottom.mGetV0()) );
			
			mSprtNoiseBottom.mSetUV2( (s16)(mSprtNoiseBottom.mGetU0()),
									  (s16)(mSprtNoiseBottom.mGetV0() + uh) );
			
			mSprtNoiseBottom.mSetUV3( (s16)(mSprtNoiseBottom.mGetU0() + uw),
									  (s16)(mSprtNoiseBottom.mGetV0() + uh) );
			
			//mCY̍vZ
			if( mNoiseHeight <= (f32)SAND_NOISE_HEIGHT )
			{
				mNoiseHeight = (f32)SAND_NOISE_HEIGHT;
			}else
			{
				mNoiseHeight -= (f32)(((K7APP_SCREEN_HEIGHT / 2) - SAND_NOISE_HEIGHT) / (f32)WK7_TICK_TO_FRAME((f32)mBaseFadeTick));
			}
		}
	}
	
	switch( mSandFrameProc )
	{
		//
		case	eSandInit:
			mSandFrameProc = eSandFileReadBlue;
			break;
		
		//mCYpeNX`ǂݍ
		case	eSandFileReadBlue:
			if( mFrameProc != eNoiseFileRead )
			{
				fileStatus = mFile.mK7FileRead( SAND_NOISEBLUE_TEX_FILE, &((void*)mTexBlueNoise.tex) );
				if( fileStatus == eFileReadSucsess )
				{
					//eNX`̏
					mK7InitBilinearTexture( &mTexBlueNoise );
					//mCYݒ
					mSprtNoise.mRelateTex( &mTexBlueNoise );
					mSprtNoise.mSetPriority( SPRT_PRI_NOISE );
					mSprtNoise.mSetWH( K7APP_SCREEN_WIDTH, K7APP_SCREEN_HEIGHT );
					mSprtNoise.mSetUV0( 0, 0 );
					mSprtNoise.mSetXY0( 0, 0 );
					mSprtNoise.mSetDispFlag( false );
					mSprtNoiseBottom.mRelateTex( &mTexBlueNoise );
					mSprtNoiseBottom.mSetPriority( SPRT_PRI_NOISE );
					mSprtNoiseBottom.mSetWH( K7APP_SCREEN_WIDTH, K7APP_SCREEN_HEIGHT );
					mSprtNoiseBottom.mSetUV0( 0, 0 );
					mSprtNoiseBottom.mSetXY0( 0, 0 );
					mSprtNoiseBottom.mSetDispFlag( false );
					mSandFrameProc = eSandFileReadRed;
				}
			}
			break;
		
		//ԃmCYpeNX`ǂݍ
		case	eSandFileReadRed:
			if( mFrameProc != eNoiseFileRead )
			{
				fileStatus = mFile.mK7FileRead( SAND_NOISERED_TEX_FILE, &((void*)mTexRedNoise.tex) );
				if( fileStatus == eFileReadSucsess )
				{
					//eNX`̏
					mK7InitBilinearTexture( &mTexRedNoise );
					mSandFrameProc = eSandFileReadAlph;
				}
			}
			break;
		
		//At@xbgEeNX`t@Cǂݍ
		case	eSandFileReadAlph:
			if( mFrameProc != eNoiseFileRead )
			{
				if( mFile.mK7FileRead(SAND_NOISE_FONT_ALPH_FILE,&((void*)mTexFontAlph.dat)) == eFileReadSucsess )
				{
					//uvwhf[^ւ̃AhXݒ
					mTexFontAlph.fontParam = (stFontParam*)((char*)mTexFontAlph.dat + mTexFontAlph.dat->charOffset);
					//eNX`AhẌn
					mTexFontAlph.fontTex.tex = (GhmGcTexHeader*)((char*)mTexFontAlph.dat + mTexFontAlph.dat->texOffset);
					//eNX`̏
					mK7InitTexture( &mTexFontAlph.fontTex );
					mSandFrameProc = eSandFileReadKata;
				}
			}
			break;
		
		//J^JiEeNX`t@Cǂݍ
		case	eSandFileReadKata:
			if( mFrameProc != eNoiseFileRead )
			{
				if( mFile.mK7FileRead(SAND_NOISE_FONT_KATA_FILE,&((void*)mTexFontKata.dat)) == eFileReadSucsess )
				{
					//uvwhf[^ւ̃AhXݒ
					mTexFontKata.fontParam = (stFontParam*)((char*)mTexFontKata.dat + mTexFontKata.dat->charOffset);
					//eNX`AhẌn
					mTexFontKata.fontTex.tex = (GhmGcTexHeader*)((char*)mTexFontKata.dat + mTexFontKata.dat->texOffset);
					//eNX`̏
					mK7InitTexture( &mTexFontKata.fontTex );
					mSandFrameProc = eSandStandby;
				}
			}
			break;
		
		//tF[hC
		case	eSandFadeIn:
			if( mBaseNowTick >= 0 )
			{
				mSandScaleRate -= (f32)(SAND_NOISE_RATE_MAX - SAND_NOISE_RATE_MIN) / (f32)WK7_TICK_TO_FRAME((f32)mBaseFadeTick);
				
				mBaseNowTick -= WK7_TICK_PER_FRAME;
				mBaseYSpeed  += (f32)SAND_SCROLL_SPEED_MAX / (f32)WK7_TICK_TO_FRAME((f32)mBaseFadeTick);
				if( mBaseYSpeed >= (f32)SAND_SCROLL_SPEED_MAX )
				{
					mBaseYSpeed = (f32)SAND_SCROLL_SPEED_MAX;
				}
			}else
			{
				SK7SpOption		*pSpOption;
				if( (pSpOption=GameInfo.GetSpOption())!=NULL ){
					pSpOption->SetEyeExpan(EYE_EXSTATE_SMALL);
				}
				mBaseNowTick   = 0;
				mSandFrameProc = eSandExec;
			}
			mBaseY = (s16)((mBaseY + (s16)mBaseYSpeed) % WK7_SCREEN_HEIGHT);
			mSandSetY();
			break;
		
		//s
		case	eSandExec:
			mBaseY = (s16)((mBaseY + (s16)mBaseYSpeed) % WK7_SCREEN_HEIGHT);
			mSandSetY();
#if	0
			if( mSandScaleRate < SAND_NOISE_RATE_MAX )
			{
				mSandScaleRate += (f32)(SAND_NOISE_RATE_MAX - SAND_NOISE_RATE_MIN) / (f32)WK7_TICK_TO_FRAME((f32)(4800*3));
			}else
			{
				mSandScaleRate = SAND_NOISE_RATE_MAX;
			}
#endif
			break;
		
		//tF[hAEg
		case	eSandFadeOut:
			//XN[Rs[̃eNX`̃XN[vZ
			if( mBaseNowTick >= 0 )
			{
			//	mSandScaleRate += (f32)(SAND_NOISE_RATE_MAX - SAND_NOISE_RATE_MIN) / (f32)WK7_TICK_TO_FRAME((f32)mBaseFadeTick);
			//	mSandScaleRate += (f32)(mSandMaxRate - SAND_NOISE_RATE_MIN) / (f32)WK7_TICK_TO_FRAME((f32)mBaseFadeTick);
#if	0
				if( mSandScaleRate < mSandMaxRate )
				{
					mSandScaleRate += (f32)(mSandMaxRate - SAND_NOISE_RATE_MIN) / (f32)WK7_TICK_TO_FRAME((f32)mBaseFadeTick);
				}else
				{
					mSandScaleRate = mSandMaxRate;
				}
#else
				mSandScaleRate += (f32)(mSandMaxRate - SAND_NOISE_RATE_MIN) / (f32)WK7_TICK_TO_FRAME((f32)mBaseFadeTick);
#endif
				
				mBaseNowTick -= WK7_TICK_PER_FRAME;
				mBaseYSpeed  -= (f32)SAND_SCROLL_SPEED_MAX / (f32)WK7_TICK_TO_FRAME((f32)mBaseFadeTick);
				if( mBaseYSpeed <= 0.0f )
				{
					mBaseYSpeed = 0.0f;
				}
				mWaitToMap = SAND_NOISE_WAIT_TO_MAP;
			}else
			{
				if( mNoiseTrimming == false )
				{
					//}bv֌qtF[hAEg̏ꍇ͏IEGCg
					if( mSandMaxRate == SAND_NOISE_RATE_MAX_TO_MAP )
					{
						if( mWaitToMap >= 0 )
						{
							mWaitToMap -= WK7_TICK_PER_FRAME;
							break;
						}
					}
					mSandFrameProc = eSandFadeFinish;
					mBaseNowTick   = 0;
				}else
				{
					//mCỸtF[hAEgݒ
					mSprtNoise.mSetFade( 0, SAND_STRING_DISP_TICK+SAND_STRING_OUT_TICK );
					mSprtNoiseBottom.mSetFade( 0, SAND_STRING_DISP_TICK+SAND_STRING_OUT_TICK );
					//XN[Lv`͔\ɂ
					for( i = 0; i < NOISE_SAND_BASE_NUM; i++ )
					{
						mSprtBase[i].mSetDispFlag( false );
					}
					mBaseNowTick   = SAND_STRING_DISP_TICK;
					mBaseFadeTick  = SAND_STRING_DISP_TICK;
					mSandFrameProc = eSandFontDisp;
				}
			}
			mBaseY = (s16)((mBaseY + (s16)mBaseYSpeed) % WK7_SCREEN_HEIGHT);
			mSandSetY();
			break;
		
		//\
		case	eSandFontDisp:
			if( mBaseNowTick >= 0 )
			{
				mBaseNowTick -= WK7_TICK_PER_FRAME;
			}else
			{
				//ړ̐ݒ
				mUpDownStrRelease( SAND_STRING_OUT_TICK );
				//ԂȂǐݒ
				mBaseNowTick   = SAND_STRING_OUT_TICK;
				mBaseFadeTick  = SAND_STRING_OUT_TICK;
				mSandFrameProc = eSandFontOut;
			}
			break;
		
		//񁕃mCY
		case	eSandFontOut:
			if( mBaseNowTick >= 0 )
			{
				mBaseNowTick -= WK7_TICK_PER_FRAME;
			}else
			{
				mSandFrameProc = eSandFadeFinish;
			}
			break;
		
		//tF[hAEgI
		case	eSandFadeFinish:
			//\
			if( mNoiseTrimming == true )
			{
				mInitNoiseFont();
			}
			//XN[Lv`摜
			for( i = 0; i < NOISE_SAND_BASE_NUM; i++ )
			{
				mSprtBase[i].mSetDispFlag( false );
			}
			mSprtNoise.mSetDispFlag( false );
			mSprtNoiseBottom.mSetDispFlag( false );
		//	//SE~
		//	if( mNotNoiseSE == false )
		//	{
		//		gpSound->mStopSE( SFX_SYS_SAND_NOISE );
		//	}
			mSandFrameProc   = eSnadScreenImageFree;
			break;
		
		//XN[C[W̃
		case	eSnadScreenImageFree:
			SK7SpOption		*pSpOption;
			if( (pSpOption=GameInfo.GetSpOption())!=NULL ){
				pSpOption->SetEyeExpan(EYE_EXSTATE_BIG);
			}
			mSandFrameProc = eSandStandby;
			break;
		
		//ҋ@
		case	eSandStandby:
			break;
		
		default:
			break;
	}
}
//-----------------------------------------------------------------------------
//`揈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::mSandRender( void )
{
	if( mScreenCopyFlag==true ){
		screenImageFullColor.ScreenCopy();
	}
}
//-----------------------------------------------------------------------------
//YWݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::mSandSetY( void )
{
	if( mSandNoiseType == eSandShortNoise )
		return;
//TRACE("%d\n",mBaseY);

	mSprtBase[0].mSetUV0( 0, mBaseY );
	mSprtBase[0].mSetWH( WK7_SCREEN_WIDTH, (s16)(WK7_SCREEN_HEIGHT - mBaseY) );
	
	mSprtBase[1].mSetXY0( 0, (s16)(WK7_SCREEN_HEIGHT - mBaseY) );
	mSprtBase[1].mSetWH( WK7_SCREEN_WIDTH, (s16)(WK7_SCREEN_HEIGHT - mSprtBase[0].mGetH()) );
}




//-----------------------------------------------------------------------------
//㉺ɕ\镶̃NGXgi͔̕p̉ppJ^Jij
// in --> char* inStr0  ȉɕ\镶
//        char* inStr1  ỉɕ\镶
//        char* inStr2  ȉɕ\镶
//        char* inStr3  ỉɕ\镶
//        s16   inTick  \̂ɂ鎞
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Noise::mUpDownStrRequest( char* inStr0, char* inStr1, char* inStr2, char* inStr3, s16 inTick )
{
	int	i, j, k, index;
	u8	r, g, b;
	s16	dispX;
	
	//iRGB
	u8	rgbUlight[3] = { 240, 237, 115 };
	u8	rgbUdark[3]  = { 105,  92,   0 };
	//iRGB
	u8	rgbDlight[3] = { 255,  58,  94 };
	u8	rgbDdark[3]  = { 122,  28,  61 };
	
	//Ȍ͏
	mInitNoiseFont();
	
	//\擾
	mFont[0].length = strlen( inStr0 );
	mFont[1].length = strlen( inStr1 );
	mFont[2].length = strlen( inStr2 );
	mFont[3].length = strlen( inStr3 );
	
	//22̕񐶐
	for( i = 0; i < NOISE_SAND_STR_MAX; i++ )
	{
		//͂̉
		mFont[i].width = 0;
		//ΐݒ肷
		if( mFont[i].length != 0 )
		{
			//񃁃m
			mFont[i].str = (char*)K7AppSmallMemAlloc( (int)((sizeof(char) * mFont[i].length) + 1) );
//			ASSERT( mFont[i].str );
			if( mFont[i].str == NULL )
			{
				for( k = 0; k < NOISE_SAND_STR_MAX; k++ )
				{
					GHMGCMEM_SAFE_FREE( mFont[k].str );
					GHM_SAFE_DELETE_ARRAY( mFont[k].sprt );
				}
				return( false );
			}
			//͕ۑ
			if( i == 0 )strcpy( mFont[i].str, inStr0 );
			if( i == 1 )strcpy( mFont[i].str, inStr1 );
			if( i == 2 )strcpy( mFont[i].str, inStr2 );
			if( i == 3 )strcpy( mFont[i].str, inStr3 );
			//XvCg̃m
			ghmGcMemSetAllocName("MSprite");
			mFont[i].sprt = new mK7Sprite[mFont[i].length];
			if( mFont[i].sprt == NULL )
			{
				for( k = 0; k < NOISE_SAND_STR_MAX; k++ )
				{
					GHMGCMEM_SAFE_FREE( mFont[k].str );
					GHM_SAFE_DELETE_ARRAY( mFont[k].sprt );
				}
				return( false );
			}
//			ASSERT( mFont[i].sprt );
			//XvCg̐ݒ
			for( j = 0; j < mFont[i].length; j++ )
			{
				if( (u8)(mFont[i].str[j]) < (u8)(0x7F) )
				{
					//At@xbg
					//index = mFont[i].str[j] - 0x21;
					//At@xbgeNX`l܂Ă邽ߏC
					if( (u8)(mFont[i].str[j]) >= (u8)('a') )
					{
						index = mFont[i].str[j] - 0x21 - 0x06;
					}else
					{
						index = mFont[i].str[j] - 0x21;
					}
					mFont[i].sprt[j].mRelateTex( &mTexFontAlph.fontTex );
					mFont[i].sprt[j].mSetWH( (s16)mTexFontAlph.fontParam[index].w, (s16)mTexFontAlph.fontParam[index].h );
					mFont[i].sprt[j].mSetUV0( (s16)mTexFontAlph.fontParam[index].u, (s16)mTexFontAlph.fontParam[index].v );
					mFont[i].sprt[j].mSetXY0( mFont[i].width, 0 );
					mFont[i].width += mFont[i].sprt[j].mGetW();
					//RGBݒ
					//if( (i == 0) || (i == 1) )
					if( 0 )
					{
						r = (u8)(rgbUlight[0] - (((rgbUlight[0] - rgbUdark[0]) / mFont[i].length) * j));
						g = (u8)(rgbUlight[1] - (((rgbUlight[1] - rgbUdark[1]) / mFont[i].length) * j));
						b = (u8)(rgbUlight[2] - (((rgbUlight[2] - rgbUdark[2]) / mFont[i].length) * j));
					}else
					{
						r = (u8)(rgbDlight[0] - (((rgbDlight[0] - rgbDdark[0]) / mFont[i].length) * j));
						g = (u8)(rgbDlight[1] - (((rgbDlight[1] - rgbDdark[1]) / mFont[i].length) * j));
						b = (u8)(rgbDlight[2] - (((rgbDlight[2] - rgbDdark[2]) / mFont[i].length) * j));
					}
					mFont[i].sprt[j].mSetRGBA( (u32)((r<<24) | (g<<16) | (b<<8) | (255)) );
				}else
				{
					//J^Ji
				#if	1
				//	index = (u8)(mFont[i].str[j]) - (u8)(0xB0);	//pJi
					index = (u8)(mFont[i].str[j]) - (u8)(0xA6);	//SpJi
					mFont[i].sprt[j].mRelateTex( &mTexFontKata.fontTex );
					mFont[i].sprt[j].mSetWH( (s16)mTexFontKata.fontParam[index].w, (s16)mTexFontKata.fontParam[index].h );
					mFont[i].sprt[j].mSetUV0( (s16)mTexFontKata.fontParam[index].u, (s16)mTexFontKata.fontParam[index].v );
				#else
					index = (u8)(mFont[i].str[j]) - (u8)(0xA6);
					index += 93;//SeNX`őΉ
					mFont[i].sprt[j].mRelateTex( &mTexFontAlph.fontTex );
					if( (mFont[i].str[j] == '') || (mFont[i].str[j] == '') )
					{
						mFont[i].sprt[j].mSetWH( (s16)(mTexFontAlph.fontParam[index].w/3), (s16)mTexFontAlph.fontParam[index].h );
					}else
					{
						mFont[i].sprt[j].mSetWH( (s16)mTexFontAlph.fontParam[index].w, (s16)mTexFontAlph.fontParam[index].h );
					}
					mFont[i].sprt[j].mSetUV0( (s16)mTexFontAlph.fontParam[index].u, (s16)mTexFontAlph.fontParam[index].v );
				#endif
					mFont[i].sprt[j].mSetXY0( mFont[i].width, 0 );
					mFont[i].width += mFont[i].sprt[j].mGetW();
					//RGBݒ
					//if( (i == 0) || (i == 1) )
					if( 0 )
					{
						r = (u8)(rgbUlight[0] - (((rgbUlight[0] - rgbUdark[0]) / mFont[i].length) * j));
						g = (u8)(rgbUlight[1] - (((rgbUlight[1] - rgbUdark[1]) / mFont[i].length) * j));
						b = (u8)(rgbUlight[2] - (((rgbUlight[2] - rgbUdark[2]) / mFont[i].length) * j));
					}else
					{
						r = (u8)(rgbDlight[0] - (((rgbDlight[0] - rgbDdark[0]) / mFont[i].length) * j));
						g = (u8)(rgbDlight[1] - (((rgbDlight[1] - rgbDdark[1]) / mFont[i].length) * j));
						b = (u8)(rgbDlight[2] - (((rgbDlight[2] - rgbDdark[2]) / mFont[i].length) * j));
					}
					mFont[i].sprt[j].mSetRGBA( (u32)((r<<24) | (g<<16) | (b<<8) | (255)) );
				}
				mFont[i].sprt[j].mSetPriority( SPRT_PRI_NOISE_FONT );
				mFont[i].sprt[j].mSetDispFlag( true );
			}
			//\Wƈړ̂̐ݒ
			for( j = 0; j < mFont[i].length; j++ )
			{
				switch( i )
				{
					//iAt@xbg
					case	0:
						dispX = (s16)(mFont[i].sprt[j].mGetX0());
						mFont[i].sprt[j].mSetXY0( (s16)(K7APP_SCREEN_WIDTH), SAND_STRING_UA_Y );
						mFont[i].sprt[j].mSetMove( (s16)(dispX+64), SAND_STRING_UA_Y, inTick );
					//EɊ\̓RgAEg
					//	dispX = (s16)(K7APP_SCREEN_WIDTH+mFont[i].sprt[j].mGetX0());
					//	mFont[i].sprt[j].mSetXY0( (s16)(K7APP_SCREEN_WIDTH), SAND_STRING_UA_Y );
					//	mFont[i].sprt[j].mSetMove( (s16)(dispX-mFont[i].width-64), SAND_STRING_UA_Y, inTick );
						break;
					//iJ^Ji
					case	1:
						dispX = (s16)(mFont[i].sprt[j].mGetX0());
						mFont[i].sprt[j].mSetXY0( (s16)(K7APP_SCREEN_WIDTH), (s16)(SAND_STRING_UA_Y+mFont[0].sprt[0].mGetH()) );
						mFont[i].sprt[j].mSetMove( (s16)(dispX+64), (s16)(SAND_STRING_UA_Y+mFont[0].sprt[0].mGetH()), inTick );
					//EɊ\̓RgAEg
					//	dispX = (s16)(K7APP_SCREEN_WIDTH+mFont[i].sprt[j].mGetX0());
					//	mFont[i].sprt[j].mSetXY0( (s16)(K7APP_SCREEN_WIDTH), (s16)(SAND_STRING_UA_Y+mFont[0].sprt[0].mGetH()) );
					//	mFont[i].sprt[j].mSetMove( (s16)(dispX-mFont[i].width-64), (s16)(SAND_STRING_UA_Y+mFont[0].sprt[0].mGetH()), inTick );
						break;
					//iAt@xbg
					case	2:
						dispX = (s16)(-mFont[i].width+mFont[i].sprt[j].mGetX0());
						mFont[i].sprt[j].mSetXY0( (s16)(-mFont[i].width),        (s16)(SAND_STRING_DK_Y-mFont[0].sprt[0].mGetH()-mFont[1].sprt[0].mGetH()) );
						mFont[i].sprt[j].mSetMove( (s16)(K7APP_SCREEN_WIDTH+dispX-64), (s16)(SAND_STRING_DK_Y-mFont[0].sprt[0].mGetH()-mFont[1].sprt[0].mGetH()), inTick );
						break;
					//iJ^Ji
					case	3:
						dispX = (s16)(-mFont[i].width+mFont[i].sprt[j].mGetX0());
						mFont[i].sprt[j].mSetXY0( (s16)(-mFont[i].width),        (s16)(SAND_STRING_DK_Y-mFont[i].sprt[j].mGetH()) );
						mFont[i].sprt[j].mSetMove( (s16)(K7APP_SCREEN_WIDTH+dispX-64), (s16)(SAND_STRING_DK_Y-mFont[i].sprt[j].mGetH()), inTick );
						break;
				}
			}
		}
	}
	
	//mCY͕\Ă炸㉺tHĝݕ\tOON
	mUpDownFontDisp = true;
	
	return( true );
}
//-----------------------------------------------------------------------------
//㉺ɕ\镶̃[X
// in --> s16 inTick  \̂ɂ鎞
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Noise::mUpDownStrRelease( s16 inTick )
{
	int	i, j;
	
	//ړ̐ݒ
	for( i = 0; i < NOISE_SAND_STR_MAX; i++ )
	{
		if( mFont[i].sprt != NULL )
		{
			for( j = 0; j < mFont[i].length; j++ )
			{
				//tF[hAEgݒ
				mFont[i].sprt[j].mSetFade( 0, inTick );
				//ړݒ
				switch( i )
				{
					//iAt@xbg
					case	0:
						mFont[i].sprt[j].mSetMove( (s16)(-mFont[i].sprt[j].mGetW()), mFont[i].sprt[j].mGetY0(), inTick );
						break;
					//iJ^Ji
					case	1:
						mFont[i].sprt[j].mSetMove( (s16)(-mFont[i].sprt[j].mGetW()), mFont[i].sprt[j].mGetY0(), inTick );
						break;
					//iAt@xbg
					case	2:
						mFont[i].sprt[j].mSetMove( (s16)(K7APP_SCREEN_WIDTH), mFont[i].sprt[j].mGetY0(), inTick );
						break;
					//iJ^Ji
					case	3:
						mFont[i].sprt[j].mSetMove( (s16)(K7APP_SCREEN_WIDTH), mFont[i].sprt[j].mGetY0(), inTick );
						break;
				}
			}
		}
	}
	
	return( true );
}
//-----------------------------------------------------------------------------
//㉺ɕ\镶̊Ď
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::mWatchUpDownStr( void )
{
	if( mUpDownFontDisp == true )
	{
		if( mFont[0].sprt == NULL )
		{
			mUpDownFontDisp = false;
		}else
		{
			if( (mFont[0].sprt[0].mGetA() == 0) && (mFont[0].sprt[0].mGetMoveEnd() == true) )
			{
				mInitNoiseFont();
				mUpDownFontDisp = false;
			}
		}
	}
}

//-----------------------------------------------------------------------------
//
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Noise::mInitNoiseFont()
{
	int	i;
	
	for( i = 0; i < NOISE_SAND_STR_MAX; i++ )
	{
		mFont[i].length = 0;
		GHMGCMEM_SAFE_FREE( mFont[i].str );
		GHM_SAFE_DELETE_ARRAY( mFont[i].sprt );
		mFont[i].width = 0;
	}
}
