////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Sound
//
// mK7Sound.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/14/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7SOUND_CPP__

//---- include ----
#include <string.h>
#include <types.h>
#include <config.h>
//killer7֌W
#include "..\wat\WK7Define.h"
#include "..\wat\K7ID.h"
//O֌W
#include "mK7Sound.h"

#include "..\Kaw\KK7Sound.h"

//---- define ----
#define	SOUND_HPS_DIR			"sound/music/"	//hpst@ĈfBNg
#define	SOUND_SSM_DIR			"sound/se/"		//g`t@ĈfBNg
#define	SOUND_EVENT_SSM_DIR		"Event/"		//Cxgpg`t@ĈfBNg
//#define	SOUND_ARAM_SIZE			(0)				//A-RAM̃TCY(0ŃftHg8MByte)
#define	SOUND_ARAM_SIZE			(15*1024*1024)	//A-RAM̃TCY(ő16MByteEXg[p1MB̗]T邱)
#define	SOUND_VOICE_NUM			(128)			//z{CX(0ŃftHg128)
#define	SOUND_TRACK_NUM			(256)			//gbN(0ŃftHg256)
#define	SOUND_PRG_STREAM_NUM	(eTrackMax-1)	//vOXg[
#define	SOUND_BANK0_SIZE		(3*1024*1024)	//bank0̃TCY	VXe
#define	SOUND_BANK1_SIZE		(3*1024*1024)	//bank1̃TCY 퓬GtFNg
#define	SOUND_BANK2_SIZE		(4*1024*1024)	//bank2̃TCY ViI풓
#define	SOUND_BANK3_SIZE		(1*1024*1024)	//bank3̃TCY vC[
#define	SOUND_BANK4_SIZE		(2*1024*1024)	//bank4̃TCY ėp
#define	SOUND_SSM_NOT_USE		(-2)			//ssmf[^ǂݍ܂ĂȂtO
#define	SOUND_READ_FILES_AT_SAME_TIME	(6)		//ɓǂݍ߂g`t@C
#define	SOUND_INIT_MUSIC_TRACK	(65535)			//yXg[ĐĂȂ
#define	SOUND_INIT_FADE_VOL		(STREAM_PAUSE-1)//tF[hĎpʂ̏l
#define	SOUND_INIT_MUTE_VOLUME	(-1)			//~[gĂȂ
#define	SOUND_STREAM_MUTE_SPEED	(600)			//Xg[~[gx(1/200bP)
//#define	SOUND_STREAM_MUTE_SPEED	(100)			//Xg[~[gx(1/200bP)

#define	SOUND_SCENARIO_MAX		(6)				//TEh\[XŎgViIő吔

//---- O[oϐ ----
MK7Sound*	gpSound = NULL;

//---- ϐ ----
u32			MK7Sound::mAramBlock[SOUND_ARAM_NUM];
u8*			MK7Sound::mPlayList = NULL;
ghmGcMem*	MK7Sound::mHeap     = NULL;
static	mK7File	gpSndFile;			//semt@Cǂݍݗp
static	u8*		gpPlaylist = NULL;	//playlist

//SẼt@C̕я̏ꂽf[^include
#include "se\seFileOrder.h"
#include "se\hpsList.h"




//---- ֐ ----
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Sound::MK7Sound()
{
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Sound::~MK7Sound()
{
}




//-----------------------------------------------------------------------------
//static semt@Cǂݍ
// in --> u8*  inPlayList  semt@Cǂݍރ|C^
// out -> bool false       ǂݍ݊҂
//             true        ǂݍ݊
//-----------------------------------------------------------------------------
bool
MK7Sound::ReadSem( void )
{
	if( gpSndFile.mK7FileRead("/sound/se/se.sem", &((void*)gpPlaylist)) == eFileReadSucsess )
	{
		return( true );
	}
	return( false );
}
//-----------------------------------------------------------------------------
//static
// in --> ghmGcMem& inHeap       mۂׂq[v
//        u8        inVolume     ݒ肵
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Sound::Init( ghmGcMem& inHeap, u8 inVolume )
{
	bool	ret;
	
	if( gpSound == NULL ){
		ghmGcMemSetAllocName("MSound");
		gpSound = new MK7Sound;
	}
	if( gpSound == NULL )
		return( false );
	
	ret = gpSound->mInit( inHeap, gpPlaylist, inVolume );
	
#ifdef	_DEBUG
	//TEhfobOtO
	gpSound->mSetSoundDebug( true );
#endif
	return( ret );
}
//-----------------------------------------------------------------------------
//static㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Sound::Term( void )
{
	gpSound->mTerm();
	GHM_SAFE_DELETE( gpSound );
	
	return( true );
}
//-----------------------------------------------------------------------------
//m
// in --> int inSize  mۂ̃TCY
// out -> none
//-----------------------------------------------------------------------------
void*
MK7Sound::mAlloc( int inSize )
{
	return( mHeap->Alloc( inSize ) );
}
//-----------------------------------------------------------------------------
//
// in --> ̃|C^
// out -> none
//-----------------------------------------------------------------------------
void
MK7Sound::mFree( void* inPtr )
{
	if( inPtr != NULL )
		mHeap->Free( inPtr );
	inPtr = NULL;
}




//-----------------------------------------------------------------------------
//
// in --> ghmGcMem& inHeap       mۂׂq[v
//        u8*       inPlayList   semt@Cǂݍ܂ꂽ|C^
//        u8        inVolume     ݒ肵
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Sound::mInit( ghmGcMem& inHeap, u8* inPlayList, u8 inVolume )
{
	int	i, j, ret;
	
	mHeap     = &inHeap;
	mPlayList = inPlayList;
	
	AIInit( NULL );
	ARInit( mAramBlock, SOUND_ARAM_NUM );
	ARQInit();
	
	//ssmf[^
	for( i = 0; i < SOUND_SSM_NUM; i++ )
	{
		mSsmDat[i].entryNum = SOUND_SSM_NOT_USE;
		mSsmDat[i].bankNo   = SOUND_SSM_NOT_USE;
		strcpy( mSsmDat[i].fileName, "" );
	}
	
	//̊蓖Ăщ̊֐o^
	HSD_AudioSetMallocFreeProc( MK7Sound::mAlloc, MK7Sound::mFree ); 
	
	//TEh[h̎擾
	mSoundMode = HSD_AudioGetSoundMode(); 
	
	//fVxł̃{[̍ŏlݒ
	HSD_AudioSetDBMin( 0 ); 
	
	//}X^[{[̐ݒ
	if( mSetMasterVol(inVolume) == false )
		return( false );
	if( mSetMasterVolumeSE(inVolume,10) == false )
		return( false );
	
	//pe[uݒ
	HSD_AudioSetPantable( HSD_SYNTHPANTABLE_CLASSIC );
	
	//}`Xg[~Ogpꍇ̃TEhVXȅB 
	ret = HSD_AudioInitMultiPStream( SOUND_ARAM_SIZE,			//A-RAM̃TCY
	                                 SOUND_VOICE_NUM,			//ő剼z{CXw
	                                 SOUND_TRACK_NUM,			//őgbN
	                                 SOUND_PRG_STREAM_NUM,		//vOXg[
	                                 1 );
	if( ret == FALSE )
		return( false );
	
	//semt@C̐ݒ
	ret = HSD_AudioSFXSetPlayList( mPlayList );
	if( ret == FALSE )
		return( false );
	
	//oN̊蓖
	mBank[eBank0] = HSD_AudioSFXNewBank( SOUND_BANK0_SIZE );
	mBank[eBank1] = HSD_AudioSFXNewBank( SOUND_BANK1_SIZE );
	mBank[eBank2] = HSD_AudioSFXNewBank( SOUND_BANK2_SIZE );
	mBank[eBank3] = HSD_AudioSFXNewBank( SOUND_BANK3_SIZE );
	mBank[eBank4] = HSD_AudioSFXNewBank( SOUND_BANK4_SIZE );
	if( (mBank[eBank0] == -1)
	 || (mBank[eBank1] == -1)	//
	 || (mBank[eBank2] == -1)
	 || (mBank[eBank3] == -1)
	 || (mBank[eBank4] == -1) )
	{
		ASSERT( 0 );
		return( false );
	}
	
	//egbNŎgp\ȃ{CXw
	HSD_AudioSFXSetMaxTrackVoice( eSETrackSystemOverlap, SOUND_VOICE_NUM-1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackSystem00, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackSystem01, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackSystem02, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackSystem03, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackSystem04, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackSystem05, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackSystem06, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackSystem07, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackEventOverlap, SOUND_VOICE_NUM-1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackEvent00, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackEvent01, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackEvent02, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackEvent03, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackEvent04, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackEvent05, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackEvent06, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackEvent07, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackBattleOverlap, SOUND_VOICE_NUM-1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackBattle00, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackBattle01, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackBattle02, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackBattle03, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackBattle04, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackBattle05, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackBattle06, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackBattle07, 1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackScene01,  1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackScene02,  1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackScene03,  1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackScene04,  1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackScene05,  1 );
	HSD_AudioSFXSetMaxTrackVoice( eSETrackScene06,  1 );
	
	//ǂݍݒt@C
	mReadingFiles = 0;
	
	//t[̎w
	mProcess = eSndStandby;
	
	//Cxgg`t@Cǂݍݏ
	mReadEventSeProc = eSndReadReqWaiting;
	//ǂݍ݃NGXĝssmt@Cۑꏊ
	strcpy( mFileName, "" );
	//ݓǂݍ܂ĂSẼt@CԂ
	mOrder = 0;
	
	//ݍĐĂgbN
	mNowPlayMusicCh = SOUND_INIT_MUSIC_TRACK;
	
	//tF[h̏
	for( i = 0; i < eTrackMax; i++ )
	{
		mFadeMng[i].time   = 0.000f;
		mFadeMng[i].volume = SOUND_INIT_FADE_VOL;
	}
	
	//ftHgGtFNgݒ擾
	HSD_AudioSFXGetDefaultAuxParam( eDspReverbHi, &mDspReverbHI[eAch] );
	HSD_AudioSFXGetDefaultAuxParam( eDspReverbStd, &mDspReverbStd[eAch] );
	HSD_AudioSFXGetDefaultAuxParam( eDspChorus, &mDspChorus[eAch] );
	HSD_AudioSFXGetDefaultAuxParam( eDspDelay, &mDspDelay[eAch] );
	HSD_AudioSFXGetDefaultAuxParam( eDspReverbHi, &mDspReverbHI[eBch] );
	HSD_AudioSFXGetDefaultAuxParam( eDspReverbStd, &mDspReverbStd[eBch] );
	HSD_AudioSFXGetDefaultAuxParam( eDspChorus, &mDspChorus[eBch] );
	HSD_AudioSFXGetDefaultAuxParam( eDspDelay, &mDspDelay[eBch] );
	//DPS
	for( i = 0; i < eChMax; i++ )
	{
		for( j = 0; j < eSEGroupMax; j++ )
		{
			mDspRate[i][j] = SOUND_DEFAULT_DSP_INIT_RATE;
		}
	}
	//DSPݒ
	mDspBuff[eAch] = NULL;
	mDspKind[eAch] = eDspKindMax;
	mSetDspCtrl( eCtrlSTXT, eAch );
	mSetDspKind( eDspNoEffect, eAch );
	
	mDspBuff[eBch] = NULL;
	mDspKind[eBch] = eDspKindMax;
	mSetDspCtrl( eCtrlAPI, eBch );
	mSetDspKindRateAll( eDspReverbHi, SOUND_DEFAULT_DSP_INIT_RATE );
	
	//ݓǂݍłLN^SẼLN^ԍ
	mCharNo = K7PCMAX;
	
	//ݍĐĂXg[ԍ
	mStreamNo      = -1;
	mOldStreamNo   = -1;				//Xg[̓ĐƂ̑ŐȔԍ
	mOldStreamVol  = VOLUME_MUSIC;		//Xg[̓ĐƂ̑ŐȂ̉
	
	mMuteStreamVol = SOUND_INIT_MUTE_VOLUME;
	
	//|[YtO
	mPauseFlag = false;
	//Xg[~[g
	mDontMuteStream = false;
	
	//I
	return( true );
}
//-----------------------------------------------------------------------------
//㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Sound::mTerm( void )
{
	//SẴTEh~
	mStopAllSound();
	
	//oN
	HSD_AudioSFXDeleteBank();
	
	//
	mFree( mDspBuff[eAch] );
	mFree( mDspBuff[eBch] );
	
	//semt@C̉
	HSD_AudioFree( mPlayList );
	
	return( true );
}
//-----------------------------------------------------------------------------
//SẴTEh~
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Sound::mStopAllSound( void )
{
	//ʉSĎ~߂
	mStopSEAll();
	
	//ׂẴvOXg[~O̒~
	HSD_AudioPStreamStop();
	
	//DVDXg[~O̒~
	HSD_AudioDVDStreamStop();
 	
	return( true );
}




//-----------------------------------------------------------------------------
//DSPݒ
// in --> enDspKind   ݒ肷DSP̎
//        enDspCh     DSPݒ肷`l
// out -> bool false  ݒ莸s
//             true   ݒ萬
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetDspCtrl( enDspCtrl inCtrl, enDspCh inCh )
{
	int	ret;
	
	//`lDSPݒ
	ret = HSD_AudioSFXSetupAuxChannel( inCh, inCtrl );
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//DPSݒ
// in --> enDspKind   ݒ肷DSP̎
//        enDspCh     DSPݒ肷`l
// out -> bool false  ݒ莸s
//             true   ݒ萬
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetDspKind( enDspKind inKind, enDspCh inCh )
{
	int	buffSize, ret;
	
	//gĂ
	mFree( mDspBuff[inCh] );
	
	//ނɂăobt@TCY擾
	switch( inKind )
	{
		//GtFNgȂ
		case	eDspNoEffect:
			buffSize = HSD_AudioSFXGetAuxHeapSize( inKind, NULL );
			break;
		//o[ui
		case	eDspReverbHi:
			buffSize = HSD_AudioSFXGetAuxHeapSize( inKind, &mDspReverbHI[inCh] );
			break;
		//o[uʏ
		case	eDspReverbStd:
			buffSize = HSD_AudioSFXGetAuxHeapSize( inKind, &mDspReverbStd[inCh] );
			break;
		//R[X
		case	eDspChorus:
			buffSize = HSD_AudioSFXGetAuxHeapSize( inKind, &mDspChorus[inCh] );
			break;
		//fBC
		case	eDspDelay:
			buffSize = HSD_AudioSFXGetAuxHeapSize( inKind, &mDspDelay[inCh] );
			break;
		//default
		default:
			buffSize = HSD_AudioSFXGetAuxHeapSize( inKind, NULL );
			break;
	}
	//m
	buffSize += 32 - (buffSize % 32);	//32byteACg
	mDspBuff[inCh] = mAlloc( buffSize );
	//G[`FbN
	if( mDspBuff[inCh] == NULL )
		return( false );
	
	//ݒ
	switch( inKind )
	{
		//GtFNgȂ
		case	eDspNoEffect:
			ret = HSD_AudioSFXSetupAux( inCh, inKind, NULL, mDspBuff[inCh], buffSize );
			break;
		//o[ui
		case	eDspReverbHi:
			ret = HSD_AudioSFXSetupAux( inCh, inKind, &mDspReverbHI[inCh], mDspBuff[inCh], buffSize );
			break;
		//o[uʏ
		case	eDspReverbStd:
			ret = HSD_AudioSFXSetupAux( inCh, inKind, &mDspReverbStd[inCh], mDspBuff[inCh], buffSize );
			break;
		//R[X
		case	eDspChorus:
			ret = HSD_AudioSFXSetupAux( inCh, inKind, &mDspChorus[inCh], mDspBuff[inCh], buffSize );
			break;
		//fBC
		case	eDspDelay:
			ret = HSD_AudioSFXSetupAux( inCh, inKind, &mDspDelay[inCh], mDspBuff[inCh], buffSize );
			break;
		//default
		default:
			ret = HSD_AudioSFXSetupAux( inCh, inKind, NULL, mDspBuff[inCh], buffSize );
			break;
	}
	//G[`FbN
	if( ret == FALSE )
	{
		mFree( mDspBuff[inCh] );
		return( false );
	}
	
	//DSPޕۑ
	mDspKind[inCh] = inKind;
	
	return( true );
}
//-----------------------------------------------------------------------------
//O[vԍw肵ďo̓`l̃GtFNg~bNXlݒ
// in --> int     inGroup  ~bNXO[v
//        u8      inMix    0ݒ肷ƃhCiGtFNgj100%
//                         255ݒ肷ƃEGbgiGtFNgj100%
//        enDspCh inCh     ~bNX`l
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetDspRate( int inGroup, u8 inMix, enDspCh inCh )
{
	int	ret;
	
	ret = HSD_AudioSFXSetMixGroup( inGroup, inCh, inMix );
	
	if( ret == FALSE )
		return( false );
	
	mDspRate[inCh][inGroup] = inMix;
	
	return( true );
}
//-----------------------------------------------------------------------------
//SĂ̊eO[vɏo̓`l̃GtFNg~bNXlݒ
// in --> u8      inMix    0ݒ肷ƃhCiGtFNgj100%
//                         255ݒ肷ƃEGbgiGtFNgj100%
//        enDspCh inCh     ~bNX`l
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetDspRateAll( u8 inMix, enDspCh inCh )
{
	//GtFNg~bNXݒ
	mSetDspRate( eSEGroupSystem00Env, inMix, inCh );
//	mSetDspRate( eSEGroupSystem01Env, inMix, inCh );
//	mSetDspRate( eSEGroupSystem02Env, inMix, inCh );
//	mSetDspRate( eSEGroupSystem03Env, inMix, inCh );
//	mSetDspRate( eSEGroupEvent00Env, inMix, inCh );
//	mSetDspRate( eSEGroupEvent01Env, inMix, inCh );
//	mSetDspRate( eSEGroupEvent02Env, inMix, inCh );
//	mSetDspRate( eSEGroupEvent03Env, inMix, inCh );
	mSetDspRate( eSEGroupBattle00Env, inMix, inCh );
//	mSetDspRate( eSEGroupBattle01Env, inMix, inCh );
//	mSetDspRate( eSEGroupBattle02Env, inMix, inCh );
//	mSetDspRate( eSEGroupBattle03Env, inMix, inCh );
	
	return( true );
}
//-----------------------------------------------------------------------------
//o̓`l̃GtFNg~bNXݒ
// in --> enDspKind inKind   ݒ肵DSP̎
//        int       inGroup  ݒ肵O[v
//        u8        inMix    DSP̂銄(0-255:255100%)
//        enDspCh   inCh     ~bNX`l
// out -> bool false  ݒ莸s
//             true   ݒ萬
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetDspKindRate( enDspKind inKind, int inGroup, u8 inMix, enDspCh inCh )
{
	bool	ret;
	
	ret= mSetDspKind( inKind, inCh );
	if( ret == false )
		return( false );
	
	ret = mSetDspRate( inGroup, inMix, inCh );
	if( ret == false )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//SẴO[vɑ΂DSPݒ肷
// in --> enDspKind inKind  ݒ肵DSP̎
//        u8        inMix   DSP̂銄(0-255:255100%)
//        enDspCh   inCh    ~bNX`l
// out -> bool false  ݒ莸s
//             true   ݒ萬
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetDspKindRateAll( enDspKind inKind, u8 inMix, enDspCh inCh )
{
	bool	ret;
	
	//ݐݒ肳ĂނƈႦΐݒ
	if( mGetDspKind( inCh ) != inKind )
	{
		ret = mSetDspKind( inKind, inCh );
		if( ret == false )
		{
			return( false );
		}
	}
	
	//GtFNg~bNXݒ
	mSetDspRate( eSEGroupSystem00Env, inMix, inCh );
//	mSetDspRate( eSEGroupSystem01Env, inMix, inCh );
//	mSetDspRate( eSEGroupSystem02Env, inMix, inCh );
//	mSetDspRate( eSEGroupSystem03Env, inMix, inCh );
//	mSetDspRate( eSEGroupEvent00Env, inMix, inCh );
//	mSetDspRate( eSEGroupEvent01Env, inMix, inCh );
//	mSetDspRate( eSEGroupEvent02Env, inMix, inCh );
//	mSetDspRate( eSEGroupEvent03Env, inMix, inCh );
	mSetDspRate( eSEGroupBattle00Env, inMix, inCh );
//	mSetDspRate( eSEGroupBattle01Env, inMix, inCh );
//	mSetDspRate( eSEGroupBattle02Env, inMix, inCh );
//	mSetDspRate( eSEGroupBattle03Env, inMix, inCh );
	
	return( true );
}




//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Sound::mFrameProcess( void )
{
	switch( mProcess )
	{
		//g`t@Cǂݍݒ
		case	eSndReadingSsm:
			if( HSD_AudioSFXLoadCheck() == FALSE )
			{
				mReadingFiles = 0;
				mProcess      = eSndStandby;
			}
			break;
		
		//ҋ@
		case	eSndStandby:
			break;
		
		//ftHg
		default:
			break;
	}
	
	//mReadEventSsmProc();
	mFadeVolumeWatch();
}




//-----------------------------------------------------------------------------
//}X^[ʐݒ
// in --> u8 inVolume  ݒ肵
// out -> bool false  ʐݒ莸s
//             true   ʐݒ萬
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetMasterVol( u8 inVolume )
{
	int	ret;
	
	//ʐݒ
	ret = HSD_AudioSetOutputGain( inVolume / 255.f );
	if( ret == FALSE )
		return( false );
	
	//ʕۑ
	mMasterVol = inVolume;
	
	return( true );
}
//-----------------------------------------------------------------------------
//}X^[ʎ擾
// in --> none
// out -> u8 inVolume  }X^[
//-----------------------------------------------------------------------------
u8
MK7Sound::mGetMasterVol( void )
{
	return( mMasterVol );
}
//-----------------------------------------------------------------------------
//TEh[h̐ݒ
// in --> int HSD_SYNTH_SOUND_MODE_MONO ...... m
//            HSD_SYNTH_SOUND_MODE_STEREO .... XeI
//            HSD_SYNTH_SOUND_MODE_SURROUND .. TEh
//            HSD_SYNTH_SOUND_MODE_DPL2 ...... hr[vWbNQ
//            HSD_SYNTH_SOUND_MODE_HAL_DPL2 .. hr[vWbNQ(\tgEFAGR[fBO)
// out -> bool false  ݒ莸s
//             true   ݒ萬
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetSoundMode( int inSoundMode )
{
	int	ret;
	
	//TEh[hݒ
	ret = HSD_AudioSetSoundMode( inSoundMode ); 
	if( ret == FALSE )
		return( false );
	
	//TEh[hۑ
	mSoundMode = inSoundMode;
	
	return( true );
}
//-----------------------------------------------------------------------------
//TEh[h̎擾
// in --> none
// out -> int HSD_SYNTH_SOUND_MODE_MONO ...... m
//            HSD_SYNTH_SOUND_MODE_STEREO .... XeI
//            HSD_SYNTH_SOUND_MODE_SURROUND .. TEh
//            HSD_SYNTH_SOUND_MODE_DPL2 ...... hr[vWbNQ
//            HSD_SYNTH_SOUND_MODE_HAL_DPL2 .. hr[vWbNQ(\tgEFAGR[fBO)
//-----------------------------------------------------------------------------
int
MK7Sound::mGetSoundMode( void )
{
	mSoundMode = HSD_AudioGetSoundMode();
	return( mSoundMode );
}




//-----------------------------------------------------------------------------
//g`t@C̓ǂݍ
// in --> char* inFileName  ǂݍ݂t@C
//        int   inBankNo    ǂݍݐ̃oNԍ
// out -> 
//-----------------------------------------------------------------------------
bool
MK7Sound::mReadSsm( char* inFileName, int inBankNo )
{
	int		i;
	char	temp[SOUND_FILENAME_LENGTH];
	
	//t@CNULLłΔ
	if( inFileName == NULL )
		return( true );
	
	//6̃t@Cǂݍłꍇ͓ǂݍ݂łȂ
	if( mReadingFiles >= SOUND_READ_FILES_AT_SAME_TIME )
		return( false );
	
	//󂢂Ăssmf[^i[ꏊ
	for( i = 0; i < SOUND_SSM_NUM; i++ )
		if( mSsmDat[i].entryNum == SOUND_SSM_NOT_USE )
			break;
	//G[`FbN
	if( i == SOUND_SSM_NUM )
		return( false );
	
	//CxgȊOssmt@C̃t@CƃfBNgݒ
	strcpy( temp, SOUND_SSM_DIR );
	strcat( temp, inFileName );
	
	//t@C̑݊mF
	if( DVDConvertPathToEntrynum(temp) == - 1 )
	{
		TRACE("not exsit! --> %s\n",temp);
		return( false );
	}
	
	//g`t@Cǂݍ݊Jn
	mSsmDat[i].entryNum = HSD_AudioSFXLoad( temp, mBank[inBankNo], NULL, NULL );
	////ssmt@CǂݍݏI҂
	//HSD_AudioSFXLoadSync();
	//G[`FbN
	if( mSsmDat[i].entryNum == -1 )
	{
		TRACE( "Read error file --> [%d] %s\n", inBankNo, temp );
		 mSsmDat[i].entryNum = SOUND_SSM_NOT_USE;
		return( false );
	}else
	{
		TRACE( "Reading ssm file --> [%d] %s\n", inBankNo, temp );
	}
	
	//gpoNԍۑ
	mSsmDat[i].bankNo = inBankNo;
	
	//t@Cۑ
	strcpy( mSsmDat[i].fileName, inFileName );
	
	//t[vZXf[^ǂݍݒɂ
	mProcess = eSndReadingSsm;
	
	//ǂݍݒt@C𑝂₷
	mReadingFiles += 1;
	
	//I
	return( true );
}
//-----------------------------------------------------------------------------
//g`t@C̉
// in --> char* inFileName  g`t@C̃t@C
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mReleaseSsm( char* inFileName )
{
	int		i, ret;
	if( inFileName == NULL )
	{
		i = -1;
	}else
	{
		//Yf[^
		for( i = SOUND_SSM_NUM-1 ; i >= 0 ; i-- )
		{
			if( strcmp(mSsmDat[i].fileName,inFileName) == 0 )
			{
				break;
			}
		}
	}
	//G[`FbN
	if( i < 0 )
	{
		TRACE( "not read --> %s\n", inFileName);
		return( false );
	}
	
	//ssmt@C
	ret = HSD_AudioSFXGroupDataRemove( mSsmDat[i].entryNum );
	//G[`FbN
	if( ret == FALSE )
	{
		TRACE( "Release ssm error --> %s\n", inFileName);
		return( false );
	}
	
	//oNftO
	ret = HSD_AudioSFXBankDeflag( mSsmDat[i].bankNo ); 
	if( ret == FALSE )
	{
		return( false );
	}
	//ftOI҂(ŒȂ΂Ȃ)
	HSD_AudioSFXBankDeflagSync();
	
	TRACE( "Release ssm file --> %s\n", mSsmDat[i].fileName );
	
	//ϐ
	mSsmDat[i].entryNum = SOUND_SSM_NOT_USE;
	mSsmDat[i].bankNo   = SOUND_SSM_NOT_USE;
	strcpy( mSsmDat[i].fileName, "" );
	
	//ǂݍ݃NGXĝssmt@Cۑꏊ
	strcpy( mFileName, "" );
	
	//I
	return( true );
}
//-----------------------------------------------------------------------------
//se̍Đ
// in --> int inId      Đʉԍ
//        u8  inVolume  Đ(default:SOUND_SYSTEM_SE_VOLUME)
//        u8  inPan     ̖ʒu(default:SOUND_PAN_CENTER)
//        int inTrack   (default:0)
//        int inGroup   (default:0)
// out -> int -1      ʉĐs
//            -1ȊO  zVOICEԍ
//-----------------------------------------------------------------------------
int
MK7Sound::mPlaySE( int inId, u8 inVolume, u8 inPan, int inTrack, int inGroup )
{
	////g`f[^ǂݍݒ͍ĐłȂ
	//if( mProcess != eSndStandby )
	//	return( false );
	
	return( HSD_AudioSFXStart(inId,inVolume,inPan,inTrack,inGroup) );
}
//-----------------------------------------------------------------------------
//se̍Đsb`wt
// in --> int inId      Đʉԍ
//        s16 inPitch   -10800`2400  100yɂ锼
//        u8  inVolume  Đ(default:SOUND_SYSTEM_SE_VOLUME)
//        u8  inPan     ̖ʒu(default:SOUND_PAN_CENTER)
//        int inTrack   (default:0)
//        int inGroup   (default:0)
// out -> int -1      ʉĐs
//            -1ȊO  zVOICEԍ
//-----------------------------------------------------------------------------
int
MK7Sound::mPlaySEP( int inId, s16 inPitch, u8 inVolume, u8 inPan, int inTrack, int inGroup )
{
	int	ret;
	
	ret = (int)mPlaySE(inId, inVolume, inPan, inTrack, inGroup);
	if( ret == -1 )
		return( ret );
	
	if( HSD_AudioSFXSetPitch(ret,inPitch) == FALSE )
		return( -1 );
	
	return( ret );
}
//-----------------------------------------------------------------------------
//se̍Đ 3D
// in --> int inId      Đʉԍ
//        Vec tPos      ^[Qbg̍W
//        u8  inMode    Rc[h(default:0)
//        u8  inVolume  Đ(default:SOUND_SYSTEM_SE_VOLUME)
//        int inTrack   (default:0)
//        int inGroup   (default:0)
// out -> int -1      ʉĐs
//            -1ȊO  zVOICEԍ
//-----------------------------------------------------------------------------
int
MK7Sound::mPlaySE3D( int inId, Vec tPos, int inMode, int inVolume, int inTrack, int inGroup )
{
	u8 getVolume, getPan;
	
	seVolCalc(tPos, (u8 )inVolume, &getVolume, &getPan, (u8 )inMode);
	return( mPlaySE(inId,getVolume,getPan,inTrack,inGroup) );
}
//-----------------------------------------------------------------------------
//se̍Đ 3DŃsb`wt
// in --> int inId      Đʉԍ
//        Vec tPos      ^[Qbg̍W
//        s16 inPitch   -10800`2400  100yɂ锼
//        u8  inMode    Rc[h(default:0)
//        u8  inVolume  Đ(default:SOUND_SYSTEM_SE_VOLUME)
//        int inTrack   (default:0)
//        int inGroup   (default:0)
// out -> int -1      ʉĐs
//            -1ȊO  zVOICEԍ
//-----------------------------------------------------------------------------
int
MK7Sound::mPlaySE3DP( int inId, Vec tPos, s16 inPitch, int inMode, int inVolume, int inTrack, int inGroup )
{
	int ret;
	u8 getVolume, getPan;
	
	seVolCalc(tPos, (u8 )inVolume, &getVolume, &getPan, (u8 )inMode);
	ret = mPlaySE(inId, getVolume, getPan, inTrack, inGroup );
	if( ret == -1 )
		return( -1 );
	
	ret = HSD_AudioSFXSetPitch( ret, inPitch );
	if( ret == FALSE )
		return( -1 );
	
	return( ret );
}
//-----------------------------------------------------------------------------
//se̍Đ~
// in --> int inId  ~SE̔ԍ
// out -> bool false  ʉ~
//             true   ʉ~s
//-----------------------------------------------------------------------------
bool
MK7Sound::mStopSE( int inId )
{
	int	ret;
	
	ret = HSD_AudioSFXKeyOffFid( inId );
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//zԍse̍Đ~
// in --> int inId  ~SẺzԍ
// out -> bool false  ʉ~
//             true   ʉ~s
//-----------------------------------------------------------------------------
bool
MK7Sound::mStopSENo( int inId )
{
	int	ret;
	
	ret = HSD_AudioSFXKeyOff( inId );
	if( ret == FALSE )
		return( false );
	
	return( true );
}

//-----------------------------------------------------------------------------
//SĂSE~
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Sound::mStopSEAll( void )
{
	//ĂʉSĎ~߂
	if( HSD_AudioSFXGetNbActiveVVoices() != 0 )
	{
		HSD_AudioSFXKeyOffAll();
	}
	
	return( true );
}

//-----------------------------------------------------------------------------
//se̍Đ`FbN
// in --> int inId  mFSE̔ԍ
// out -> bool false  ĂȂ
//             true   Ă
//-----------------------------------------------------------------------------
bool
MK7Sound::mCheckSE( int inId )
{
	int	ret;
	
	ret = HSD_AudioSFXCheckFid( inId );
	if( (ret == -1) || (ret == 0) )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//zԍse̍Đ`FbN
// in --> int inId  mFSE̔ԍ
// out -> bool false  ĂȂ
//             true   Ă
//-----------------------------------------------------------------------------
bool
MK7Sound::mCheckSENo( int inId )
{
	int	ret;
	
	ret = HSD_AudioSFXCheck( inId );
	if( (ret == -1) || (ret == 0) )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//seŜ̉ʐݒtF[ht
// in --> u8  inVolume    ݒ肵
//        u16 inFadeTime  ʕύXɂ鎞 0`65535 1=1/200b
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetMasterVolumeSE( u8 inVolume, u16 inFadeTime )
{
	int	ret;
	
	ret = HSD_AudioSFXSetMasterVolume( inVolume, inFadeTime );
	if( ret == FALSE )
		return( false );
	
	mMasterVolSE = inVolume;
	
	return( true );
}
//-----------------------------------------------------------------------------
//ʉԍw肵ă{[ƃ{[tF[hݒ
// in --> int inSEno      ݒ肵ʉԍ
//        u8  inVolume    ݒ肵
//        u16 inFadeTime  ʕύXɂ鎞 0`65535 1=1/200b
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetVolumeSE( int inSEno, u8 inVolume, u16 inFadeTime )
{
	int	ret;
	
	ret = HSD_AudioSFXSetVolumeFid( inSEno, inVolume, inFadeTime );
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//ʉԍzԍŎw肵ă{[ƃ{[tF[hݒ
// in --> int inSEno      ݒ肵zʉԍ
//        u8  inVolume    ݒ肵
//        u16 inFadeTime  ʕύXɂ鎞 0`65535 1=1/200b
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetVolumeSENo( int inSEno, u8 inVolume, u16 inFadeTime )
{
	int	ret;
	
	ret = HSD_AudioSFXSetVolume( inSEno, inVolume, inFadeTime );
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//O[vw肵ă{[ƃ{[tF[hݒ
// in --> int inGroup     ݒ肵ʉO[v
//        u8  inVolume    ݒ肵
//        u16 inFadeTime  ʕύXɂ鎞 0`65535 1=1/200b
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetVolumeSEGroup( int inGroup, u8 inVolume, u16 inFadeTime )
{
	int	ret;
	
	ret = HSD_AudioSFXSetVolumeGroup( inVolume, inFadeTime, inGroup );
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//ʉԍw肵dbdbtF[hݒ
// in --> int inSEno      ݒ肵ʉԍ
//        u8  inVolume    ݒ肵 -904`0 (0=̉ 1=0.1dB)
//        u16 inFadeTime  ʕύXɂ鎞 0`65535 1=1/200b
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetDBSE( int inSEno, int inVolume, u16 inFadeTime )
{
	if( HSD_AudioSFXSetVolumeDBFid(inSEno,inVolume,inFadeTime) == false )
	{
		return( false );
	}
	return( true );
}
//-----------------------------------------------------------------------------
//zԍw肵dbdbtF[hݒ
// in --> int inSEno      ݒ肵zʉԍ
//        u8  inVolume    ݒ肵 -904`0 (0=̉ 1=0.1dB)
//        u16 inFadeTime  ʕύXɂ鎞 0`65535 1=1/200b
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetDBSENo( int inSEno, int inVolume, u16 inFadeTime )
{
	if( HSD_AudioSFXSetVolumeDB(inSEno,inVolume,inFadeTime) == FALSE )
	{
		return( false );
	}
	return( true );
}
//-----------------------------------------------------------------------------
//O[vw肵dbdbtF[hݒ
// in --> int inGroup     ݒ肵ʉO[v
//        u8  inVolume    ݒ肵
//        u16 inFadeTime  ʕύXɂ鎞 0`65535 1=1/200b
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
//bool
//MK7Sound::mSetDBSEGroup( int inGroup, int inVolume, u16 inFadeTime )/
//{
//	return( true );
//}
//-----------------------------------------------------------------------------
//ʉԍw肵ăpݒ
// in --> int inSEno      ݒ肵ʉԍ
//        u8  inPan       p̒l 0`254 0ō[ 254ŉE[
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetPanSE( int inSEno, u8 inPan )
{
	int	ret;
	
	ret = HSD_AudioSFXSetPanFid( inSEno, inPan );
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//zԍw肵ăpݒ
// in --> int inSEno      ݒ肵ʉԍ
//        u8  inPan       p̒l 0`254 0ō[ 254ŉE[
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetPanSENo( int inSEno, u8 inPan )
{
	int	ret;
	
	ret = HSD_AudioSFXSetPan( inSEno, inPan );
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//O[vw肵ăpݒ
// in --> int inGroup     ݒ肵ʉԍ
//        u8  inPan       p̒l 0`254 0ō[ 254ŉE[
// out -> bool false  s
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetPanGroup( int inGroup, u8 inPan )
{
	int	ret;
	
	ret = HSD_AudioSFXSetPanGroup( inGroup, inPan );
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//ʉԍŃsb`ݒ
// in --> int inId     Đʉԍ
//        s16 inPitch  -10800`2400  100yɂ锼 ʏ펞0
// out -> bool false   ݒ萬
//             true    ݒ莸s
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetPitchSE( int inId, s16 inPitch )
{
	int ret;
	
	ret = HSD_AudioSFXSetPitchFid( inId, inPitch );
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//zԍŃsb`ݒ
// in --> int inId     Đʉԍ
//        s16 inPitch  -10800`2400  100yɂ锼 ʏ펞0
// out -> bool false   ݒ萬
//             true    ݒ莸s
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetPitchSENo( int inId, s16 inPitch )
{
	int ret;
	
	ret = HSD_AudioSFXSetPitch( inId, inPitch );
	if( ret == FALSE )
		return( false );
	
	return( true );
}







//-----------------------------------------------------------------------------
//stream̍Đ(t@Cw)
// in --> int  inFileName  t@C
//        u8   inVolume    (default:SOUND_MASTER_VOLUME)
//        int  inGroup     O[v(default:AXDRIVER_MAX_GROUP)
//        bool inFadeOut   ȂĂꍇtF[hAEg邩(default:true)
//                         falsȅꍇ͌̋Ȃ͍Đ܂܂ɂȂ܂
// out -> bool false  Đs
//             true   Đ
//-----------------------------------------------------------------------------
bool
MK7Sound::mPlayStream( char* inFileName, u8 inVolume, int inGroup, bool inFadeOut )
{
	int	ret;
	
#ifdef	_DEBUG
	if( mDebugSound )
		return( true );
#endif
	
	if( inGroup != AXDRIVER_MAX_GROUP )
	{
		TRACE( "Stream group is no good!!\n" );
	}
	
	//t@C̑݊mF
	if( DVDConvertPathToEntrynum(inFileName) == - 1 )
	{
		TRACE("not exsit! --> %s\n",inFileName);
		return( false );
	}
	
	//Őȏۑ
	mOldStreamNo  = mStreamNo;
	mOldStreamVol = mGetVolumeStream();
	
	//ygbN̏ꍇ͋󂢂Ăق̃gbNōĐ
	//ĐĂȂch0g
	if( mNowPlayMusicCh == SOUND_INIT_MUSIC_TRACK )
	{
		mNowPlayMusicCh = eTrackMusic0;
	}else
	//ch0gĂꍇch0tF[hAEgch1gčĐ
	if( mNowPlayMusicCh == eTrackMusic0 )
	{
		if( inFadeOut == true )
		{
			HSD_AudioPStreamSetVolumeCh( 0, MUSIC_FADEOUT_TIME, eTrackMusic0 );
			mFadeMng[eTrackMusic0].time   = MUSIC_FADEOUT_TIME / 200;
			mFadeMng[eTrackMusic0].volume = 0;
		}
		mNowPlayMusicCh = eTrackMusic1;
	}else
	//ch1gĂꍇch1tF[hAEgch0gčĐ
	if( mNowPlayMusicCh == eTrackMusic1 )
	{
		if( inFadeOut == true )
		{
			HSD_AudioPStreamSetVolumeCh( 0, MUSIC_FADEOUT_TIME, eTrackMusic1 );
			mFadeMng[eTrackMusic1].time   = MUSIC_FADEOUT_TIME / 200;
			mFadeMng[eTrackMusic1].volume = 0;
		}
		mNowPlayMusicCh = eTrackMusic0;
	}
	//{[ۑ
	mStreamVol[mNowPlayMusicCh]      = inVolume;
	mFadeMng[mNowPlayMusicCh].time   = 0.000f;
	mFadeMng[mNowPlayMusicCh].volume = SOUND_INIT_FADE_VOL;
	ret = HSD_AudioPStreamStartCh( inFileName, inVolume, AXDRIVER_MAX_GROUP, mNowPlayMusicCh );
	
	if( ret == 0 )
	{
		TRACE( "HPS file can't play : %s\n", inFileName );
		return( false );
	}
	//TRACE( "play ch:%d %s\n", mNowPlayMusicCh, inFileName );
	
	//ĐĂXg[ԍ(mPlayStreamNôƂۑ)
	mStreamNo = -1;
	
	return( true );
}
//-----------------------------------------------------------------------------
//stream̍Đ(ԍw)
// in --> int  inStreamNo  Xg[ԍ(gHpsListQ)
//        u8   inVolume    (default:SOUND_MASTER_VOLUME)
//        int  inGroup     O[v(default:AXDRIVER_MAX_GROUP)
//        bool inFadeOut   ȂĂꍇtF[hAEg邩(default:true)
//                         falsȅꍇ͌̋Ȃ͍Đ܂܂ɂȂ܂
// out -> bool false  Đs
//             true   Đ
//-----------------------------------------------------------------------------
bool
MK7Sound::mPlayStreamNo( int inStreamNo, u8 inVolume, int inGroup, bool inFadeOut )
{
	int		ret;
	char	fileName[256];
	
#ifdef	_DEBUG
	if( mDebugSound )
		return( true );
#endif
	
	if( inGroup != AXDRIVER_MAX_GROUP )
	{
		TRACE( "Stream group is no good!!\n" );
	}
	
	//͂ꂽȔԍ`FbN
	if( (inStreamNo >= HPS_NUM_MAX) || (inStreamNo < 0))
	{
		return( false );
	}
	
	//t@C쐬
	strcpy( fileName, SOUND_HPS_DIR );
	strcat( fileName, gHpsList[inStreamNo] );
	
	//t@C̑݊mF
	if( DVDConvertPathToEntrynum(fileName) == - 1 )
	{
		TRACE("not exsit! --> %s\n",fileName);
		return( false );
	}
	
	//Őȏۑ
	mOldStreamNo  = mStreamNo;
	mOldStreamVol = mGetVolumeStream();
	
	//ĐĂȂch0g
	if( mNowPlayMusicCh == SOUND_INIT_MUSIC_TRACK )
	{
		mNowPlayMusicCh = eTrackMusic0;
	}else
	//ch0gĂꍇch0tF[hAEgch1gčĐ
	if( mNowPlayMusicCh == eTrackMusic0 )
	{
		if( inFadeOut == true )
		{
			HSD_AudioPStreamSetVolumeCh( 0, MUSIC_FADEOUT_TIME, eTrackMusic0 );
			mFadeMng[eTrackMusic0].time   = MUSIC_FADEOUT_TIME / 200;
			mFadeMng[eTrackMusic0].volume = 0;
		}
		mNowPlayMusicCh = eTrackMusic1;
	}else
	//ch1gĂꍇch1tF[hAEgch0gčĐ
	if( mNowPlayMusicCh == eTrackMusic1 )
	{
		if( inFadeOut == true )
		{
			HSD_AudioPStreamSetVolumeCh( 0, MUSIC_FADEOUT_TIME, eTrackMusic1 );
			mFadeMng[eTrackMusic1].time   = MUSIC_FADEOUT_TIME / 200;
			mFadeMng[eTrackMusic1].volume = 0;
		}
		mNowPlayMusicCh = eTrackMusic0;
	}
	//{[ۑ
	mStreamVol[mNowPlayMusicCh]      = inVolume;
	mFadeMng[mNowPlayMusicCh].time   = 0.000f;
	mFadeMng[mNowPlayMusicCh].volume = SOUND_INIT_FADE_VOL;
	ret = HSD_AudioPStreamStartCh( fileName, inVolume, AXDRIVER_MAX_GROUP, mNowPlayMusicCh );
	//TRACE( "play ch:%d %s\n", mNowPlayMusicCh, fileName );
	
	if( ret == 0 )
		return( false );
	
	//ĐĂXg[ԍۑ
	mStreamNo = (s16)inStreamNo;
	
	return( true );
}
//-----------------------------------------------------------------------------
//stream̍Đ~
// in --> none
// out -> bool false  
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mStopStream( void )
{
	if( (mNowPlayMusicCh == eTrackMusic0) || (mNowPlayMusicCh == eTrackMusic1) ){}else
	{
		return( false );
	}
	
	HSD_AudioPStreamStopCh( mNowPlayMusicCh );
	
	//ĐĂXg[ԍ
	mStreamNo = -1;
	
	return( true );
}
//-----------------------------------------------------------------------------
//stream̍Đ`FbN
// in --> none
// out -> bool false  ĐĂ܂
//             true   Đł
//-----------------------------------------------------------------------------
bool
MK7Sound::mCheckStream( void )
{
	int	ret;
	
	if( (mNowPlayMusicCh == eTrackMusic0) || (mNowPlayMusicCh == eTrackMusic1) ){}else
	{
		return( false );
	}
	
	ret = HSD_AudioPStreamCheckCh( mNowPlayMusicCh );
	
	if( ret == FALSE )
		return( false );
	
	return( true );
}
//-----------------------------------------------------------------------------
//stream̉ʐݒ
// in --> u8  inVolume    ݒ肵 0`255
//        int inCH        ݒ肵`l -1ōĐ`l
// out -> bool false  ʐݒ莸s
//             true   ʐݒ萬
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetVolumeStream( u8 inVolume, int inCH )
{
	int	ret;
	
	if( inCH == -1 )
	{
		ret = HSD_AudioPStreamSetVolumeCh( inVolume, 1, mNowPlayMusicCh );
	}else
	{
		ret = HSD_AudioPStreamSetVolumeCh( inVolume, 1, inCH );
	}
	
	if( ret == FALSE )
		return( false );
	
	//{[ۑ
	mStreamVol[mNowPlayMusicCh] = inVolume;
	
	return( true );
}
//-----------------------------------------------------------------------------
//stream̉ʐݒ
// in --> u8  inVolume    ݒ肵 0`255
//        u16 inFadeTime  ʕύXɂ鎞 0`65535 1b=1/200b
// out -> bool false  ʐݒ莸s
//             true   ʐݒ萬
//-----------------------------------------------------------------------------
bool
MK7Sound::mFadeVolumeStream( u8 inVolume, u16 inFadeTime )
{
	int	ret;
	
	if( (mNowPlayMusicCh == eTrackMusic0) || (mNowPlayMusicCh == eTrackMusic1) ){}else
	{
		return( false );
	}
	
	if( HSD_AudioPStreamCheckCh(mNowPlayMusicCh) == TRUE )
	{
		ret = HSD_AudioPStreamSetVolumeCh( inVolume, inFadeTime, mNowPlayMusicCh );
	}else
	{
		return( FALSE );
	}
	
	if( ret == FALSE )
		return( false );
	
	if( inVolume == 0 )
	{
		mFadeMng[mNowPlayMusicCh].time   = inFadeTime / 200;
		mFadeMng[mNowPlayMusicCh].volume = inVolume;
		mStreamNo                        = -1;
	}
	
	//{[ۑ
	mStreamVol[mNowPlayMusicCh] = inVolume;
	
	return( true );
}
//-----------------------------------------------------------------------------
//stream̃{[擾
// in --> none
// out -> u8        
//-----------------------------------------------------------------------------
u8
MK7Sound::mGetVolumeStream( void )
{
	if( (mNowPlayMusicCh == eTrackMusic0) || (mNowPlayMusicCh == eTrackMusic1) ){}else
	{
		return( 0 );
	}
	
	if( HSD_AudioPStreamCheckCh(mNowPlayMusicCh) == TRUE )
	{
		return( mStreamVol[mNowPlayMusicCh] );
	}
	
	return( 0 );
}
//-----------------------------------------------------------------------------
//tF[h̊Ď
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Sound::mFadeVolumeWatch( void )
{
	int	i;
	for( i = eTrackMusic0; i < eTrackMax; i++ )
	{
		if( mFadeMng[i].volume == 0 )
		{
			if( mFadeMng[i].time > 0.0f )
			{
				mFadeMng[i].time -= (f32)WK7_INV_FRAME_RATE;
			}else
			{
				mFadeMng[i].time   = 0.000f;
				mFadeMng[i].volume = SOUND_INIT_FADE_VOL;
				HSD_AudioPStreamStopCh( i );
			}
		}else
		if( mFadeMng[i].volume == STREAM_PAUSE )
		{
			if( mFadeMng[i].time > 0.0f )
			{
				mFadeMng[i].time -= (f32)WK7_INV_FRAME_RATE;
			}else
			{
				mFadeMng[i].time   = 0.000f;
				mFadeMng[i].volume = SOUND_INIT_FADE_VOL;
				HSD_AudioPStreamPauseCh( i );
			}
		}
	}
}
//-----------------------------------------------------------------------------
//Xg[Đ`FbN
// in --> none
// out -> bool false  ĐĂ܂
//             true   Đł
//-----------------------------------------------------------------------------
bool
MK7Sound::mStreamCheckPlay( void )
{
#ifdef	_DEBUG
	if( mDebugSound )
		return( true );
	else
		return( mCheckStream() );
#else
	return( mCheckStream() );
#endif
}
//-----------------------------------------------------------------------------
//Xg[~`FbN
// in --> none
// out -> bool false  ~Ă܂
//             true   ~ł
//-----------------------------------------------------------------------------
bool
MK7Sound::mStreamCheckStop( void )
{
#ifdef	_DEBUG
	if( mDebugSound )
		return( true );
	else
		return( !mCheckStream() );
#else
	return( !mCheckStream() );
#endif
}
//-----------------------------------------------------------------------------
//Xg[̓Đ
// in --> int inFileName  t@C
//        u8  inVolume    (default:SOUND_MASTER_VOLUME)
//        int inGroup     (default:AXDRIVER_MAX_GROUP)
// out -> bool false  ł܂ł
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mPrepareStream( char* inFileName, u8 inVolume, int inGroup )
{
	int	ret;
	
	//Đ
	if( mPlayStream(inFileName,inVolume,inGroup,false) == false )
	{
		return( false );
	}
	//|[Y
	ret = HSD_AudioPStreamPauseCh( mNowPlayMusicCh );
	//TRACE( "prepare & pause ch : %d %s\n", mNowPlayMusicCh, inFileName );
	
	if( ret == FALSE )
	{
		return( false );
	}
	
	return( true );
}
//-----------------------------------------------------------------------------
//Xg[̓Điԍwj
// in --> int inStreamNo  Xg[ԍ(gHpsListQ)
//        u8  inVolume    (default:SOUND_MASTER_VOLUME)
//        int inGroup     (default:AXDRIVER_MAX_GROUP)
// out -> bool false  ł܂ł
//             true   
//-----------------------------------------------------------------------------
bool
MK7Sound::mPrepareStreamNo( int inStreamNo, u8 inVolume, int inGroup )
{
	int	ret;
	
	//Đ
	if( mPlayStreamNo(inStreamNo,inVolume,inGroup,false) == false )
	{
		return( false );
	}
	//|[Y
	ret = HSD_AudioPStreamPauseCh( mNowPlayMusicCh );
	
	if( ret == FALSE )
	{
		return( false );
	}
	
	return( true );
}
//-----------------------------------------------------------------------------
//Xg[̓Đ
// in --> s16  inFadeVol  0-255őOɖĂXg[̉ʂݒ
//                        0w肷0ɂȂƂɃXg[~܂
// out -> bool false      Đs
//             true       Đ
//-----------------------------------------------------------------------------
bool
MK7Sound::mJustPlayStream( s16 inFadeVol )
{
	int	ret;
	
	//ch0gčĐĂꍇch1̓tF[hAEg
	if( mNowPlayMusicCh == eTrackMusic0 )
	{
		if( inFadeVol == STREAM_PAUSE )
		{
			HSD_AudioPStreamSetVolumeCh( 0, MUSIC_FADEOUT_TIME, eTrackMusic1 );
			mFadeMng[eTrackMusic1].time   = (f32)((f32)MUSIC_FADEOUT_TIME / (f32)200);
			mFadeMng[eTrackMusic1].volume = STREAM_PAUSE;
		}else
		{
			HSD_AudioPStreamSetVolumeCh( (u8)inFadeVol, MUSIC_FADEOUT_TIME, eTrackMusic1 );
			mFadeMng[eTrackMusic1].time   = (f32)((f32)MUSIC_FADEOUT_TIME / (f32)200);
			mFadeMng[eTrackMusic1].volume = inFadeVol;
		}
	}else
	//ch1gčĐĂꍇch0̓tF[hAEg
	if( mNowPlayMusicCh == eTrackMusic1 )
	{
		if( inFadeVol == STREAM_PAUSE )
		{
			HSD_AudioPStreamSetVolumeCh( 0, MUSIC_FADEOUT_TIME, eTrackMusic0 );
			mFadeMng[eTrackMusic0].time   = (f32)((f32)MUSIC_FADEOUT_TIME / (f32)200);
			mFadeMng[eTrackMusic0].volume = STREAM_PAUSE;
		}else
		{
			HSD_AudioPStreamSetVolumeCh( (u8)inFadeVol, MUSIC_FADEOUT_TIME, eTrackMusic0 );
			mFadeMng[eTrackMusic0].time   = (f32)((f32)MUSIC_FADEOUT_TIME / (f32)200);
			mFadeMng[eTrackMusic0].volume = inFadeVol;
		}
	}
	
	//|[YĂXg[̃|[Y
	ret = HSD_AudioPStreamResumeCh( mNowPlayMusicCh );
	//TRACE( "just play ch : %d\n", mNowPlayMusicCh );
	
	if( ret == FALSE )
	{
		return( false );
	}
	
	return( true );
}
//-----------------------------------------------------------------------------
//Xg[̓ĐƂɑŐȂ~Ȃꍇ̕A֐
// in --> none
// out -> bool false  Đs
//             true   Đ
//-----------------------------------------------------------------------------
bool
MK7Sound::mResumeStream( void )
{
	int	ret;
	
	//ch0gčĐĂꍇch1𕜋A
	if( mNowPlayMusicCh == eTrackMusic0 )
	{
		//A`lĐĂȂΔ
		if( HSD_AudioPStreamCheckCh(eTrackMusic1) == false )
		{
			return( false );
		}
		if( mFadeMng[eTrackMusic1].volume != SOUND_INIT_FADE_VOL )
		{
			mFadeMng[eTrackMusic1].time   = 0.000f;
			mFadeMng[eTrackMusic1].volume = SOUND_INIT_FADE_VOL;
		}else
		{
			ret = HSD_AudioPStreamResumeCh( eTrackMusic1 );
			if( ret == FALSE )
			{
				return( false );
			}
		}
		HSD_AudioPStreamSetVolumeCh( mOldStreamVol, MUSIC_FADEOUT_TIME, eTrackMusic1 );
		mNowPlayMusicCh = eTrackMusic1;
	}else
	//ch1gčĐĂꍇch0𕜋A
	if( mNowPlayMusicCh == eTrackMusic1 )
	{
		//A`lĐĂȂΔ
		if( HSD_AudioPStreamCheckCh(eTrackMusic0) == false )
		{
			return( false );
		}
		if( mFadeMng[eTrackMusic0].volume != SOUND_INIT_FADE_VOL )
		{
			mFadeMng[eTrackMusic0].time   = 0.000f;
			mFadeMng[eTrackMusic0].volume = SOUND_INIT_FADE_VOL;
		}else
		{
			ret = HSD_AudioPStreamResumeCh( eTrackMusic0 );
			if( ret == FALSE )
			{
				return( false );
			}
		}
		HSD_AudioPStreamSetVolumeCh( mOldStreamVol, MUSIC_FADEOUT_TIME, eTrackMusic0 );
		mNowPlayMusicCh = eTrackMusic0;
	}

	//Xg[ԍۑ
	mStreamNo = (s16)mOldStreamNo;
	
	return( true );
}
//-----------------------------------------------------------------------------
//Xg[̈ꎞ~
// in --> none
// out -> bool
//-----------------------------------------------------------------------------
bool
MK7Sound::mSetPauseStream( void )
{
	int	ret;
	
	if( (mNowPlayMusicCh == eTrackMusic0) || (mNowPlayMusicCh == eTrackMusic1) ){}else
	{
		return( false );
	}
	if( mPauseFlag == true )
	{
		return( false );
	}
	
	ret = HSD_AudioPStreamPauseCh( mNowPlayMusicCh );
	
	if( ret == FALSE )
	{
		return( false );
	}
	
	mPauseFlag = true;
	return( true );
}
//-----------------------------------------------------------------------------
//Xg[̈ꎞ~
// in --> none
// out -> bool
//-----------------------------------------------------------------------------
bool
MK7Sound::mReleasePauseStream( void )
{
	int	ret = FALSE;
	
	if( (mNowPlayMusicCh == eTrackMusic0) || (mNowPlayMusicCh == eTrackMusic1) ){}else
	{
		return( false );
	}
	
	if( mPauseFlag == true )
	{
		ret = HSD_AudioPStreamResumeCh( mNowPlayMusicCh );
	}
	
	if( ret == FALSE )
	{
		return( false );
	}
	
	mPauseFlag = false;
	return( true );
}
//-----------------------------------------------------------------------------
//Xg[̍Đ(ɃXe[Wp)
// in --> int       inStreamNo  ĐXg[ԍ
//                              HPS_STOP_STREAMŃXg[~
//                              HPS_FADEOUT_STREAMŃXg[tF[hAEg
//                              HPS_SAME_STREAMŌݍĐĂXg[Đ
//        u8        inVolume    (default:VOLUME_MUSIC)
//        bool      inFadeOut   ĂXg[tF[hAEg邩(default:true)
// out -> bool      false       Đs
//                  true        Đ
//-----------------------------------------------------------------------------
bool
MK7Sound::mPlayStreamEx( int inStreamNo, u8 inVolume, bool inFadeOut )
{
	int	ret;
	
	if( inStreamNo == HPS_STOP_STREAM )
	{
		mStopStream();
	}else
	if( inStreamNo == HPS_FADEOUT_STREAM )
	{
		mFadeVolumeStream( 0, MUSIC_FADEOUT_TIME );
	}else
	if( inStreamNo == HPS_SAME_STREAM )
	{
		if( mGetVolumeStream() != inVolume )
		{
			mSetVolumeStream( inVolume );
		}
	}else
	{
		if( inStreamNo != mStreamNo )
		{
			ret = mPlayStreamNo( inStreamNo, inVolume, AXDRIVER_MAX_GROUP, inFadeOut );
			if( ret == FALSE )
			{
				return( false );
			}
		}else
		if( mGetVolumeStream() != inVolume )
		{
			mSetVolumeStream( inVolume );
		}
	}
	
	return( true );
}
//-----------------------------------------------------------------------------
//Xg[̍Đ(ɃXe[Wp)
// in --> int       inStreamNo  ĐXg[ԍ
//                              HPS_STOP_STREAMŃXg[~
//                              HPS_FADEOUT_STREAMŃXg[tF[hAEg
//                              HPS_SAME_STREAMŌݍĐĂXg[Đ
//        s16       inMix       DSP̂銄(default:DSP_SAME_RATE)
//                              0ݒ肷ƃhCiGtFNgj100%
//                              255ݒ肷ƃEGbgiGtFNgj100%
//                              DSP_SAME_RATEŌ݂̐ݒg
//        u8        inVolume    (default:VOLUME_MUSIC)
//        enDspKind inKind      DPS̎(default:eDspKindMax)
//                              eDspKindMaxŌ݂̐ݒg
//        bool      inFadeOut   ĂXg[tF[hAEg邩(default:true)
// out -> bool      false       Đs
//                  true        Đ
//-----------------------------------------------------------------------------
//bool
//MK7Sound::mPlayStreamEx( int inStreamNo, s16 inMix, u8 inVolume, enDspKind inKind, bool inFadeOut )
//{
//	return( true );
//}

//-----------------------------------------------------------------------------
//Xg[̃~[g
//-----------------------------------------------------------------------------
bool
MK7Sound::mRequestMuteStream( void )
{
	if( mDontMuteStream == true )
	{
		return( false );
	}
	
	if( (mNowPlayMusicCh == eTrackMusic0) || (mNowPlayMusicCh == eTrackMusic1) ){}else
	{
		return( false );
	}
	
	mMuteStreamVol = mGetVolumeStream();
	if( mMuteStreamVol == 0 )
	{
		mMuteStreamVol = SOUND_INIT_MUTE_VOLUME;
		return( false );
	}
	
	HSD_AudioPStreamSetVolumeCh( 0, SOUND_STREAM_MUTE_SPEED, mNowPlayMusicCh );
	mFadeMng[mNowPlayMusicCh].time   = SOUND_STREAM_MUTE_SPEED / 200;
	mFadeMng[mNowPlayMusicCh].volume = STREAM_PAUSE;
	
	return( true );
}
//-----------------------------------------------------------------------------
//Xg[̃~[g
//-----------------------------------------------------------------------------
bool
MK7Sound::mReleaseMuteStream( void )
{
	if( mDontMuteStream == true )
	{
		mDontMuteStream = false;
		return( false );
	}
	
	if( (mNowPlayMusicCh == eTrackMusic0) || (mNowPlayMusicCh == eTrackMusic1) ){}else
	{
		return( false );
	}
	
	//muteĂȂΔ
	if( mMuteStreamVol == SOUND_INIT_MUTE_VOLUME )
	{
		return( false );
	}
	
	if( mFadeMng[mNowPlayMusicCh].volume != SOUND_INIT_FADE_VOL )
	{
		mFadeMng[mNowPlayMusicCh].time   = 0.000f;
		mFadeMng[mNowPlayMusicCh].volume = SOUND_INIT_FADE_VOL;
	}else
	{
		HSD_AudioPStreamResumeCh( mNowPlayMusicCh );
	}
	
	HSD_AudioPStreamSetVolumeCh( (u8)mMuteStreamVol, SOUND_STREAM_MUTE_SPEED, mNowPlayMusicCh );
	
	mMuteStreamVol = SOUND_INIT_MUTE_VOLUME;
	
	return( true );
}

//-----------------------------------------------------------------------------
//PCpg`t@Cǂݍ
// in --> char* inFileName  ǂݍ݂SEg`t@C
// out -> false ǂݍ݃NGXgs
//        true  ǂݍݐ
//-----------------------------------------------------------------------------
bool
MK7Sound::mReadPcSsmReq( u32 inCharId )
{
	bool	ret;
	char	pcSeFileName[K7PCMAX][16] = {	{ "sePcDan.ssm" },
											{ "sePcGal.ssm" },
											{ "sePcCat.ssm" },
											{ "sePcHac.ssm" },
											{ "sePcHas.ssm" },
											{ "sePcHay.ssm" },
											{ "sePcCyo.ssm" },
											{ "sePcKed.ssm" },
											{ "sePcKvn.ssm" },
											{ "sePcMsk.ssm" },	};
	
	//`FbN
	if( inCharId >= K7PCMAX )
	{
		return( false );
	}
	//g`t@C[X
	if( mCharNo != K7PCMAX )
	{
		ret = mReleaseSsm( pcSeFileName[mCharNo] );
		if( ret == false )
		{
			return( false );
		}
	}
	//g`t@Cǂݍݏ
	ret = mReadSsm( pcSeFileName[inCharId], eBankPlayer );
	if( ret == false )
	{
		TRACE( "char se file [No:%d] read request error! -> %s\n", inCharId, pcSeFileName[mCharNo] );
		return( false );
	}
	//LN^IDۑ
	mCharNo = inCharId;
	
	return( true );
}
//-----------------------------------------------------------------------------
//PCpg`t@C
// in --> char* inFileName  ǂݍ݂SEg`t@C
// out -> false s
//        true  
//-----------------------------------------------------------------------------
bool
MK7Sound::mReleasePcSsm( void )
{
	bool	ret;
	char	pcSeFileName[K7PCMAX][16] = {	{ "sePcDan.ssm" },
											{ "sePcGal.ssm" },
											{ "sePcCat.ssm" },
											{ "sePcHac.ssm" },
											{ "sePcHas.ssm" },
											{ "sePcHay.ssm" },
											{ "sePcCyo.ssm" },
											{ "sePcKed.ssm" },
											{ "sePcKvn.ssm" },
											{ "sePcMsk.ssm" },	};
	
	//g`t@C[X
	if( mCharNo != K7PCMAX )
	{
		ret = mReleaseSsm( pcSeFileName[mCharNo] );
		if( ret == false )
		{
			TRACE( "char se file [No:%d] release error! -> %s\n", mCharNo, pcSeFileName[mCharNo] );
			return( false );
		}
	}
	
	//LID
	mCharNo = K7PCMAX;
	
	return( true );
}




#ifdef _DEBUG 		// Yam

//************************************
//******** fobOp֐ **********
//************************************
bool
MK7Sound::mSetSoundDebug( bool inFlag )
{
	bool ret = mDebugSound;
	mDebugSound=inFlag;
	return( ret );
}

#endif


