////////////////////////////////////////////////////////////////////////////////
//
// Killer7  Sound Task
//
// mK7SoundTask.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 02/12/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7SOUNDTASK_CPP__

//---- include ----
#include "..\wat\WK7MenuTask.h"
#include "..\fujita\c_font.h"
#include "mK7SoundTask.h"

//---- define ----
#define	FILE_DISP_NUM		(12)	//1ʂɕ\t@C
#define	MAX_VOLUME			(256)	//ő{[

#define	SND_EVENT_SE_FILES	(53)	//SEg`t@C(g`t@C邽тɏȂ΂Ȃ)
#define	SND_FILEID_LENGTH	(24)	//SEg`t@C(g`t@C邽тɏȂ΂Ȃ)

//---- enum ----

//---- struct ----

//---- O[oϐ ----
u32*	timingTbl = NULL;
u32		timer;

//---- extern ----
extern	char gEventSeFile[SND_EVENT_SE_FILES][SND_FILEID_LENGTH];




//-----------------------------------------------------------------------------
//midiV[PXĐeXg
//-----------------------------------------------------------------------------
static	void
playSeq( void )
{
	u32	channel, channelOffset;
	u32	step, stepMax;
	u32	timing;
	
	channelOffset = 1;
	for( channel = 0; channel < *timingTbl; channel++ )
	{
		stepMax = *(timingTbl + (1 * channel) + channelOffset);
		for( step = 0; step < stepMax; step++ )
		{
			//炷
			timing = *(timingTbl + (1 * (channel + 1)) + step + channelOffset);
			if( (timing/10) == timer )
			{
			//	SND.PlaySFX( (s32)((1 * (channel + 1)) + step + channelOffset) );
			}
		}
		channelOffset = channelOffset + stepMax;
	}
	timer++;
}




//---- public ----
//-----------------------------------------------------------------------------
//RXgN^
//-----------------------------------------------------------------------------
MK7SoundTask::MK7SoundTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
}




//-----------------------------------------------------------------------------
//fXgN^
//-----------------------------------------------------------------------------
MK7SoundTask::~MK7SoundTask()
{
}




//-----------------------------------------------------------------------------
//R[obN
//-----------------------------------------------------------------------------
bool MK7SoundTask::InitializeCallBack(void)
{
	mK7File	file;
	
	OSReport("MK7TestTask Init : DefaultHeap = 0x%08x , TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),sizeof(*this));
	
	timer = 0;
//	//TEhg`t@Cǂݍ	
//	SND.ReadSFX( "/sound/a.ssm", 0 );
//	//TEh^C~Ot@Cǂݍ
//	file.mK7FileReadB( "/sound/a.tmg", &(void*)timingTbl );
	
	//ϐƃfBNg擾
	mMenuMode			= eMainMenuMode;
	mMainCurPos			= 0;
	mFileSelectCurPos	= 0;
	mSelectSe			= 0;
	mSeMax				= 255;
	strcpy( mDirName, SOUND_TOP_DIR );
	strcpy( mSsmFileName, "" );
	strcpy( mHpsFileName, "" );
	strcpy( mVoiFileName, "" );
	mHpsVol             = 255;
	mVoiceVol           = 255;
	
	//t@CIJ[\ʒu
	mFileSelectCurPos = 0;
	//\郊Xg̃gbv
	mDispListTop = 0;
	
	//TEheXgɓODSPf[^ۑ
	mOldDspKind = gpSound->mGetDspKind();
	mOldDspRate = gpSound->mGetDspRate( eSEGroupSystem00Env );
	mDspKind    = mOldDspKind;
	mDspRate    = mOldDspRate;
	mPitchSe    = 0;
	
#ifdef _DEBUG		// Yam
	//TEhfobOoffɂ
	mOldDebugSound = gpSound->mSetSoundDebug( false );
#endif
	
	return true;
}




//-----------------------------------------------------------------------------
//IR[obN
//-----------------------------------------------------------------------------
bool MK7SoundTask::TerminateCallBack(void)
{
	//TEheXgɓODSPf[^ɖ߂
	gpSound->mSetDspKind( mOldDspKind );
	gpSound->mSetDspRate( eSEGroupSystem00Env, mOldDspRate );
	HSD_AudioSFXSetPitchGroup( eSEGroupSystem00Env, 0 );
	
	//퓬̔g`t@Cǂݍ݂ȂĂ
	HSD_AudioSFXBankClear( 2 );
//	HSD_AudioSFXLoad( "sound/se/seBattle.ssm", eBankBattle, NULL, NULL );
//	HSD_AudioSFXLoadSync();
	
	ghmGcApp *pApp = GetApplication();
	
	//TEh^C~Ot@C
	GHMGCMEM_SAFE_FREE( timingTbl );
	
	//hpsĐ~
	stopHps();
	
#ifdef _DEBUG			// Yam
	//TEhfobO[hɖ߂
	gpSound->mSetSoundDebug( mOldDebugSound );
#endif
	
	delete this;
	
	ghmGcMemSetAllocName("MenuTask");
	new WK7MenuTask(pApp);
	return true;
}




//-----------------------------------------------------------------------------
//t[
//-----------------------------------------------------------------------------
bool MK7SoundTask::FrameProcess(void)
{
	//X{^ꂽI
	if( HSD_PadGetTrigger(0) & PAD_BUTTON_START )
		if( DeleteTerminate()==true )
			return true;
	
	//炷
	//playSeq();
	
	//pbh͏
	padProc();
	//ʂɕ\
	printStrings();
	
	//TEh
	if( gpSound != NULL )
	gpSound->mFrameProcess();
	
	return true;
}




//-----------------------------------------------------------------------------
//_O
//-----------------------------------------------------------------------------
bool MK7SoundTask::RenderProcess(void)
{
	// sysdolphinԖ
	HSD_StateInvalidate(HSD_STATE_ALL);
	
	return true;
}




//---- private ----
//-----------------------------------------------------------------------------
//fBNg̎擾
//-----------------------------------------------------------------------------
bool
MK7SoundTask::getDirInfo( char* inDirName )
{
	BOOL		result;
	DVDDir		dir;
	
	//fBNgI[v&G[`FbN
	result = DVDOpenDir( inDirName, &dir );
	if( !result )
		return( false );
	
	//fBNg擾
	for( mFileTotalEntryNum = 0; mFileTotalEntryNum < SOUND_FILE_MAX; mFileTotalEntryNum++ )
	{
		result = DVDReadDir( &dir, &mDirent[mFileTotalEntryNum] );
		if( !result )
			break;
	}
	
	if( mFileTotalEntryNum > FILE_DISP_NUM )
		mDispNum = FILE_DISP_NUM;
	else
		mDispNum = mFileTotalEntryNum;
	
	//fBNgN[Y
	DVDCloseDir( &dir );
	
	return( true );
}




//-----------------------------------------------------------------------------
//pbh͏
//-----------------------------------------------------------------------------
void
MK7SoundTask::padProc( void )
{
	int 	i, lastDir;
	char	temp[SOUND_STRING_MAX];
	
	//ǂɂĂLR{^͂ꂼ̋Ȃ̍Đ~
	if( HSD_PadGetTrigger(0) & PAD_TRIGGER_L )	stopHps();
	
	//j[Ƃɏ
	switch( mMenuMode )
	{
		//Cj[[h
		case	eMainMenuMode:
			//㉺L[
			if( HSD_PadGetTrigger(0) & PAD_BUTTON_UP )
				mMainCurPos = (mMainCurPos + (eMenuMax - 1)) % eMenuMax;
			else
			if( HSD_PadGetTrigger(0) & PAD_BUTTON_DOWN )
				mMainCurPos = (mMainCurPos + 1) % eMenuMax;
			//J[\|WVʂ̏
			switch( mMainCurPos )
			{
				//ssmt@CI
				case	eSelectSsm:
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
					{
						mMenuMode = eSelectSsmMode;
						moveDirSearch();
					}
					break;
				
				//play se I
				case	ePlaySe:
					//EL[
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_LEFT )
						mSelectSe = (mSelectSe + (mSeMax - 1)) % mSeMax;
					else
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_RIGHT )
						mSelectSe = (mSelectSe + 1) % mSeMax;
					else
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
						//HSD_AudioSFXStart( ((mOrder << 16) + mSelectSe), 255, 127, 0, 0 );
						gpSound->mPlaySE( ((mOrder << 16) + mSelectSe), 255, 127, eSETrackSystemOverlap, eSEGroupSystem00Env );
					break;
				
				//stop se I
				case	eStopSe:
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
						HSD_AudioSFXKeyOffAll();
					break;
				
				//DSP set I
				case	eDspSet:
					//EL[
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_LEFT )
					{
						mDspKind = (enDspKind)((mDspKind + (eDspKindMax - 1)) % eDspKindMax);
						gpSound->mSetDspKind( mDspKind );
					}
					else
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_RIGHT )
					{
						mDspKind = (enDspKind)((mDspKind + 1) % eDspKindMax);
						gpSound->mSetDspKind( mDspKind );
					}else
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
						gpSound->mPlaySE( ((mOrder << 16) + mSelectSe), 255, 127, eSETrackSystemOverlap, eSEGroupSystem00Env );
					break;
				
				//DSP rate set I
				case	eDspRateSet:
					//EL[
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_LEFT )
					{
						mDspRate = (u8)((mDspRate + (256 - 1)) % 256);
						gpSound->mSetDspRate( eSEGroupSystem00Env, mDspRate );
					}
					else
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_RIGHT )
					{
						mDspRate = (u8)((mDspRate + 1) % 256);
						gpSound->mSetDspRate( eSEGroupSystem00Env, mDspRate );
					}
					break;
				
				//Pitch SE I
				case	ePitchSe:
					//EL[
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_LEFT )
					{
						mPitchSe -= 10;
						if( mPitchSe < -10800 )mPitchSe = 2400;
						HSD_AudioSFXSetPitchGroup( eSEGroupSystem00Env, mPitchSe );
					}
					else
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_RIGHT )
					{
						mPitchSe += 10;
						if( mPitchSe > 2400 )mPitchSe = -10800;
						HSD_AudioSFXSetPitchGroup( eSEGroupSystem00Env, mPitchSe );
					}else
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
					{
						gpSound->mPlaySE( ((mOrder << 16) + mSelectSe), 255, 127, eSETrackSystemOverlap, eSEGroupSystem00Env );
					}
					break;
				
				//hpst@CI
				case	eSelectHps:
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
					{
						mMenuMode = eSelectHpsMode;
						moveDirSearch();
					}else
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_LEFT )
					{
						mHpsVol = (u8)((mHpsVol + 1) % MAX_VOLUME);
						gpSound->mSetVolumeStream( mHpsVol, eTrackMusic0 );
						gpSound->mSetVolumeStream( mHpsVol, eTrackMusic1 );
					}else
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_RIGHT )
					{
						mHpsVol = (u8)((mHpsVol + (MAX_VOLUME - 1)) % MAX_VOLUME);
						gpSound->mSetVolumeStream( mHpsVol, eTrackMusic0 );
						gpSound->mSetVolumeStream( mHpsVol, eTrackMusic1 );
					}
					break;
				
				//play hps I
				case	ePlayHps:
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
						playHps();
					break;
				
				//stop hps I
				case	eStopHps:
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
						stopHps();
					break;
				
				//voicet@CI
				case	eSelectVoice:
					if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
					{
						mMenuMode = eSelectVoiMode;
						moveDirSearch();
					}else
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_LEFT )
					{
						mVoiceVol = (u8)((mVoiceVol + 1) % MAX_VOLUME);
						gpSound->mSetVolumeStream( mHpsVol );
					}else
					if( HSD_PadGetRepeat(0) & PAD_BUTTON_RIGHT )
					{
						mVoiceVol = (u8)((mVoiceVol + (MAX_VOLUME - 1)) % MAX_VOLUME);
						gpSound->mSetVolumeStream( mHpsVol );
					}
					break;
				
				//play voice I
				case	ePlayVoice:
					break;
				
				//stop voice I
				case	eStopVoice:
					break;
				
				default:
					break;
			}
			break;
		
		//
		case	eSelectSsmMode:
		case	eSelectHpsMode:
		case	eSelectVoiMode:
			//㉺L[
			if( HSD_PadGetRepeat(0) & PAD_BUTTON_UP )
			{
				mFileSelectCurPos -= 1;
				if( mFileSelectCurPos == -1 )
				{
					mDispListTop -= 1;
					if( mDispListTop < 0 )
					{
						mDispListTop      = mFileTotalEntryNum - mDispNum;
						mFileSelectCurPos = mDispNum - 1;
					}else
						mFileSelectCurPos = 0;
				}
				//mFileSelectCurPos = (mFileSelectCurPos + (mFileEntryNum - 1)) % mFileEntryNum;
			}else
			if( HSD_PadGetRepeat(0) & PAD_BUTTON_DOWN )
			{
				mFileSelectCurPos += 1;
				if( mFileSelectCurPos == mDispNum )
				{
					mDispListTop += 1;
					if( mDispListTop == (mFileTotalEntryNum - mDispNum + 1) )
					{
						mDispListTop      = 0;
						mFileSelectCurPos = 0;
					}else
						mFileSelectCurPos = mDispNum - 1;
				}
				//mFileSelectCurPos = (mFileSelectCurPos + 1) % mFileEntryNum;
			}
			//A{^
			if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
			{
				//J[\ʒũt@CfBNgǂׂ
				if( strncmp(mFileList[mDispListTop+mFileSelectCurPos],"<DIR>",5) == 0 )
				{
					if( strcmp(mFileList[mDispListTop+mFileSelectCurPos],"<DIR> ..") == 0 )
					{	//̊KwֈړŌ̃fBNg
						for( i = lastDir = 0; i < SOUND_STRING_MAX; i++ )
						{
							if( mDirName[i] == '\0' )
								break;
							if( mDirName[i] == '/' )
							{
								lastDir = i;
							}
						}
						mDirName[lastDir] = '\0';
						mFileSelectCurPos = 0;
						mDispListTop      = 0;
						moveDirSearch();
					}else
					{	//wfBNgֈړ
						strcpy( temp, &mFileList[mDispListTop+mFileSelectCurPos][6] );
						strcat( mDirName, "/" );
						strcat( mDirName, temp );
						mFileSelectCurPos = 0;
						mDispListTop      = 0;
						moveDirSearch();
					}
				}else
				if( (mMenuMode == eSelectSsmMode) && (checkFile(mFileList[mDispListTop+mFileSelectCurPos],eSsm) == true) )
				{
					strcpy( mSsmFileName, mDirName );
					strcat( mSsmFileName, "/" );
					strcat( mSsmFileName, mFileList[mDispListTop+mFileSelectCurPos] );
					HSD_AudioSFXBankClear( 2 );
					HSD_AudioSFXLoad( mSsmFileName, 2, NULL, NULL );
					HSD_AudioSFXLoadSync();
					for( mOrder = 0; mOrder < SND_EVENT_SE_FILES; mOrder++ )
					{
						if( strcmp(gEventSeFile[mOrder],mFileList[mDispListTop+mFileSelectCurPos]) == 0 )
							break;
					}
					mMenuMode = eMainMenuMode;
				}else
				if( (mMenuMode == eSelectHpsMode) && (checkFile(mFileList[mDispListTop+mFileSelectCurPos],eHps) == true) )
				{	//hpst@CȂ̂ōĐ
					strcpy( mHpsFileName, mDirName );
					strcat( mHpsFileName, "/" );
					strcat( mHpsFileName, mFileList[mDispListTop+mFileSelectCurPos] );
					playHps();
					//mMenuMode = eMainMenuMode;
				}else
				if( (mMenuMode == eSelectVoiMode) && (checkFile(mFileList[mDispListTop+mFileSelectCurPos],eHps) == true) )
				{	//hpst@CȂ̂ōĐ
					strcpy( mHpsFileName, mDirName );
					strcat( mHpsFileName, "/" );
					strcat( mHpsFileName, mFileList[mDispListTop+mFileSelectCurPos] );
				}
			}
			//LZ
			if( HSD_PadGetTrigger(0) & PAD_BUTTON_B )
			{
				mMenuMode = eMainMenuMode;
			}
			break;
		
		default:
			break;
	}
}



//-----------------------------------------------------------------------------
//t@C`FbN
//-----------------------------------------------------------------------------
bool
MK7SoundTask::checkFile( char* inFileName, int inKind )
{
	int	i;
	//gq`FbN
	for( i = 0; i < SOUND_STRING_MAX; i++ )
	{
		//̍ŌłΔ
		if( inFileName[i] == '\0' )
			break;
		//ׂgq̓[hŕ
		if( inKind == eSsm )
		{
			//g`t@Cǂ`FbN
			if( strncmp( &inFileName[i], ".ssm", 4 ) == 0 )
				return( true );
		}else
		{
			//XgOt@Cǂ`FbN
			if( strncmp( &inFileName[i], ".hps", 4 ) == 0 )
				return( true );
		}
	}
	return( false );
}




//-----------------------------------------------------------------------------
//\
//-----------------------------------------------------------------------------
void
MK7SoundTask::printStrings( void )
{
	s32	i;
	char	dspTbl[eDspKindMax][24] = {
		{ "no effect" },
		{ "reverb hi quality" },
		{ "reverb standard" },
		{ "chorus" },
		{ "delay" }, };
	
	//PRINTFp̎
	C_Paper	paper(0,0);
	PRINTF( "\n" );
//	PRINTF( "  Killer7 SOUND TEST\n" );
	PRINTF( "\n" );
	
	//j[Ƃɏ
	switch( mMenuMode )
	{
		//Cj[
		case	eMainMenuMode:
			//se֌W
			if( mSsmFileName[0] == '\0' )
			PRINTF( "    SSM file is no selected\n" );
			else
			PRINTF( "    SSM \"%s\"\n", mSsmFileName );
			if( mMainCurPos == eSelectSsm )
				PRINTF( "   > Select SSM\n" );
			else
				PRINTF( "     Select SSM\n" );
			if( mMainCurPos == ePlaySe )
				PRINTF( "   > Play SE     No:%3d\n", mSelectSe );
			else
				PRINTF( "     Play SE     No:%3d\n", mSelectSe );
			if( mMainCurPos == eStopSe )
				PRINTF( "   > Stop SE\n" );
			else
				PRINTF( "     Stop SE\n" );
			if( mMainCurPos == eDspSet )
				PRINTF( "   > DSP set        %s\n", dspTbl[mDspKind] );
			else
				PRINTF( "     DSP set        %s\n", dspTbl[mDspKind] );
			if( mMainCurPos == eDspRateSet )
				PRINTF( "   > DSP rate set   %3d\n", mDspRate );
			else
				PRINTF( "     DSP rate set   %3d\n", mDspRate );
			if( mMainCurPos == ePitchSe )
				PRINTF( "   > Pitch set      %6d\n\n", mPitchSe );
			else
				PRINTF( "     Pitch set      %6d\n\n", mPitchSe );
			//Xg[֌W
			if( mHpsFileName[0] == '\0' )
			PRINTF( "    HPS file no select\n" );
			else
			PRINTF( "    HPS \"%s\"\n", mHpsFileName );
			if( mMainCurPos == eSelectHps )
				PRINTF( "   > Select HPS   vol=%d\n", mHpsVol );
			else
				PRINTF( "     Select HPS   vol=%d\n", mHpsVol );
			if( mMainCurPos == ePlayHps )
				PRINTF( "   > Play HPS\n" );
			else
				PRINTF( "     Play HPS\n" );
			if( mMainCurPos == eStopHps )
				PRINTF( "   > Stop HPS\n\n" );
			else
				PRINTF( "     Stop HPS\n\n" );
			//{CX֌W
			if( mVoiFileName[0] == '\0' )
			PRINTF( "    VOICE file no select\n" );
			else
			PRINTF( "    VOICE \"%s\"\n", mVoiFileName );
			if( mMainCurPos == eSelectVoice )
				PRINTF( "   > Select HPS   vol=%d\n", mVoiceVol );
			else
				PRINTF( "     Select HPS   vol=%d\n", mVoiceVol );
			if( mMainCurPos == ePlayVoice )
				PRINTF( "   > Play HPS\n" );
			else
				PRINTF( "     Play HPS\n" );
			if( mMainCurPos == eStopVoice )
				PRINTF( "   > Stop HPS\n" );
			else
				PRINTF( "     Stop HPS\n" );
			break;
		
		//ssmt@Chpst@CI
		case	eSelectSsmMode:
		case	eSelectHpsMode:
		case	eSelectVoiMode:
			PRINTF( "    DIR \"%s\"\n", mDirName );
			for( i = mDispListTop; i < mDispListTop + mDispNum; i++ )
			{
				if( mFileSelectCurPos == (i - mDispListTop) )
					PRINTF( "   > %s\n", mFileList[i] );
				else
					PRINTF( "     %s\n", mFileList[i] );
			}
			break;
		
		default:
			break;
	}
}



	
//-----------------------------------------------------------------------------
//hpst@CĐ~߂
//-----------------------------------------------------------------------------
void
MK7SoundTask::stopHps( void )
{
	bool ret;
	if( gpSound->mCheckStream() == true )
		ret = gpSound->mStopStream();
}




//-----------------------------------------------------------------------------
//hpst@CĐ
//-----------------------------------------------------------------------------
void
MK7SoundTask::playHps( void )
{
	if( checkFile(mHpsFileName,eHps) )
	{
		//stopHps();
		gpSound->mPlayStream( mHpsFileName, mHpsVol, SOUND_DEFAULT_GROUP );
	}
}




//-----------------------------------------------------------------------------
//fBNgړ
//-----------------------------------------------------------------------------
void
MK7SoundTask::moveDirSearch( void )
{
	getDirInfo( mDirName );
	makeFileList();
}




//-----------------------------------------------------------------------------
//t@CXg쐬
//-----------------------------------------------------------------------------
void
MK7SoundTask::makeFileList( void )
{
	u32  i, index;
	char temp[SOUND_STRING_MAX];
	
	//t@CXg
	for( i = 0; i < SOUND_FILE_MAX; i++ )
		strcpy( mFileList[i], "" );
	
	//[gfBNgׂ
	if( strcmp(mDirName,SOUND_TOP_DIR) )
	{	//[gfBNgłȂ̂ŏfBNgɈړ镨擪ɔzu
		strcpy( mFileList[0], "<DIR> .." );
		index = 1;
		mDispNum += 1;
	}else
		index = 0;
	
	//t@CXg쐬
	for( i = 0; i < mFileTotalEntryNum; i++ )
	{
		if( mDirent[i].isDir )
		{	//fBNg
			sprintf( temp, "<DIR> %s", mDirent[i].name );
			strcpy( mFileList[index], temp );
			index++;
		}else
		{	//t@C
			strcpy( mFileList[index], mDirent[i].name );
			index++;
		}
	}
	
	//Xg쐬ɃGg[ЂƂ₷
	if( strcmp(mDirName,SOUND_TOP_DIR) )
		mFileTotalEntryNum += 1;
}




