////////////////////////////////////////////////////////////////////////////////
//
// Killer7 mK7Sprite
//
// mK7Sprite.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/17/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7SPRITE_CPP__

//---- include ----
#include "..\wat\WK7Define.h"
#include "..\wat\WK7Obj.h"
#include "..\wat\WK7GameInfo.h"
#include "..\wat\WK7Cam.h"
#include "mK7Sprite.h"




//---- define ----
#define	MK7SPRITE_DIM_ALPHA_MAX		(255)	//̍ől





//---- O[oϐ ----
//mK7Sprite*		mK7Sprite::mSprtTop    = NULL;
stTexture*		mK7Sprite::mOldTex     = NULL;
vtxFunc*		mK7Sprite::mOldVtxFunc = NULL;
tevFunc*		mK7Sprite::mOldTevFunc = NULL;
ghmGcListObj	mK7Sprite::mAnchor;
bool			gTrimming = false;




//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
mK7Sprite::mK7Sprite( int inPriority ) : ghmGcListObj( &mAnchor, inPriority )
{
	//
	mTex      = NULL;
	mKind     = GX_TRIANGLESTRIP;	//v~eBuɐݒ
	//mPriority = PRIORITY_LOW_SPRT;
	mW        = 0;
	mH        = 0;
	mU0       = 0;
	mV0       = 0;
	mU1       = 0;
	mV1       = 0;
	mU2       = 0;
	mV2       = 0;
	mU3       = 0;
	mV3       = 0;
	mX0       = 0;
	mY0       = 0;
	mX1       = 0;
	mY1       = 0;
	mX2       = 0;
	mY2       = 0;
	mX3       = 0;
	mY3       = 0;
	mRgba0    = 0xffffffff;
	mRgba1    = 0xffffffff;
	mRgba2    = 0xffffffff;
	mRgba3    = 0xffffffff;
	mFlag     = false;
	
	mScaleW.start    = 1.0f;
	mScaleW.last     = 1.0f;
	mScaleW.now      = 1.0f;
	mScaleW.tick     = 0;
	mScaleW.nowTick  = 0;
	mScaleH.start    = 1.0f;
	mScaleH.last     = 1.0f;
	mScaleH.now      = 1.0f;
	mScaleH.tick     = 0;
	mScaleH.nowTick  = 0;
	
	mMove.orgX       = 0;
	mMove.orgY       = 0;
	mMove.toX        = 0;
	mMove.toY        = 0;
	mMove.nowX       = 0.0f;
	mMove.nowY       = 0.0f;
	mMove.tick       = 0;
	mMove.nowTick    = 0;
	
	mMoveXY0.orgX    = 0;
	mMoveXY0.orgY    = 0;
	mMoveXY0.toX     = 0;
	mMoveXY0.toY     = 0;
	mMoveXY0.nowX    = 0.0f;
	mMoveXY0.nowY    = 0.0f;
	mMoveXY0.tick    = 0;
	mMoveXY0.nowTick = 0;
	
	mMove4Vtx.orgX1  = 0.0f;
	mMove4Vtx.orgY1  = 0.0f;
	mMove4Vtx.orgX2  = 0.0f;
	mMove4Vtx.orgY2  = 0.0f;
	mMove4Vtx.orgX3  = 0.0f;
	mMove4Vtx.orgY3  = 0.0f;
	mMove4Vtx.flag   = false;
	
	mFade.orgA       = 0;
	mFade.toA        = 0;
	mFade.nowA       = 0.0f;
	mFade.tick       = 0;
	mFade.nowTick    = 0;
	
	mVib.vibrateW    = 0;
	mVib.orgY        = 0;
	mVib.index       = 0;
	mVib.tick        = 0;
	mVib.nowTick     = 0;
	mVib.waitTick    = 0;
	
	//Ԃ̓XvCgɐݒ肷
	mSetSpritePrim();
	
	//Xg̍\z(VꂽXvCg͏ɃXg̐擪ɂ悤Xg쐬)
	//mPrev = NULL;
	//mNext = mK7Sprite::mSprtTop;
	//if( mNext != NULL )
	//	mNext->mPrev = this;	//̎̑O=
	//mK7Sprite::mSprtTop = this;	//Xg̐擪=
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
mK7Sprite::~mK7Sprite( void )
{
	//Xgč\z
	//if( mPrev == NULL )
	//	mK7Sprite::mSprtTop = mNext;	//OȂꍇ̓Xg̃gbv=̎
	//else
	//	mPrev->mNext = mNext;	//Oꍇ͎̑O̎=̎
	
	//if( mNext != NULL )
	//	mNext->mPrev = mPrev;	//Xg̍ŌłȂΎ̎̑O=̑O
}
//-----------------------------------------------------------------------------
//XvCgɃeNX`֘At
// in --> stTexture* inTex   eNX`̃f[^̓\
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mRelateTex( stTexture* inTex )
{
	//eNX`\̂ւ̃|C^ۑ
	mTex = inTex;
}
//-----------------------------------------------------------------------------
//vtxݒ
// in --> enVtxKind inVtxKind  ݒ肵vtx̎
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetVtx( enVtxKind inVtxKind )
{
	switch( inVtxKind )
	{
		case	eVtxNonTex:
			mVtxFunc = mSetNoTexVtx;
			break;
		
		case	eVtxTex:
			mVtxFunc = mSetTexVtx;
			break;
		
		default:
			mVtxFunc = mSetTexVtx;
			break;
	}
}
//-----------------------------------------------------------------------------
//tevݒ
// in --> enTevKind inTevKind  ݒ肵tev̎
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetTev( enTevKind inTevKind )
{
	switch( inTevKind )
	{
		case	eTevFlat:
			mTevFunc = mSetFlatTev;
			break;
		
		case	eTevSprite:
			mTevFunc = mSetSpriteTev;
			break;
		
		case	eTevSpriteNoTexAlpha:
			mTevFunc = mSetSpriteTevNoTexAlpha;
			break;
		
		case	eTevAddAlpha:
			mTevFunc = mSetSpriteTevAddAlpha;
			break;
		
		case	eTevScanHS:
			mTevFunc = mSetScanHSTev;
			break;
		
		default:
			mTevFunc = mSetSpriteTev;
			break;
	}
}
//-----------------------------------------------------------------------------
//_Oݒ
// in --> enRenderKind inRenderKind  _O
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetRenderFunc( enRenderKind inRenderKind )
{
	switch( inRenderKind )
	{
		//2_w̃C
		case	eRenderLine:
			mRenderFunc = mRenderLine;
			break;
		
		//Op`eNX`t|S
		case	eRenderTriangle:
			mRenderFunc = mRenderTriangleTex;
			break;
		
		//tbglp`|S
		case	eRenderBox:
			mRenderFunc = mRenderBox;
			break;
		
		//tbgό`lp`|S
		case	eRenderTransformBox:
			mMove4Vtx.flag = true;
			mRenderFunc    = mRenderTransformBox;
			break;
		
		//eNX`̎lp`XvCg
		case	eRenderSprite:
			mRenderFunc = mRenderSprite;
			break;
		
		default:
			break;
	}
}

//-----------------------------------------------------------------------------
//Cv~eBuɐݒ肷
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetLinePrim( void )
{
	mSetPrimKind( GX_LINES );
	mSetVtx( eVtxNonTex );
	mSetTev( eTevFlat );
	mSetRenderFunc( eRenderLine );
}
//-----------------------------------------------------------------------------
//Op`eNX`̃v~eBuɐݒ肷
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetTriangleTexPrim( void )
{
	mSetPrimKind( GX_TRIANGLES );
	mSetVtx( eVtxTex );
	mSetTev( eTevSprite );
	mSetRenderFunc( eRenderTriangle );
}
//-----------------------------------------------------------------------------
//lp`v~eBuɐݒ肷
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetBoxPrim( void )
{
	mSetPrimKind( GX_TRIANGLESTRIP );
	mSetVtx( eVtxNonTex );
	mSetTev( eTevFlat );
	mSetRenderFunc( eRenderBox );
}
//-----------------------------------------------------------------------------
//ό`lp`v~eBuɐݒ肷
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetTransformBoxPrim( void )
{
	mSetPrimKind( GX_TRIANGLESTRIP );
	mSetVtx( eVtxNonTex );
	mSetTev( eTevFlat );
	mSetRenderFunc( eRenderTransformBox );
}
//-----------------------------------------------------------------------------
//eNX`̎lp`v~eBuɐݒ肷
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetSpritePrim( void )
{
	mSetPrimKind( GX_TRIANGLESTRIP );
	mSetVtx( eVtxTex );
	mSetTev( eTevSprite );
	mSetRenderFunc( eRenderSprite );
}
//-----------------------------------------------------------------------------
//eNX`ŃeNX`̃gȂlp`v~eBuɐݒ肷
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetSpriteNoTexAlphaPrim( void )
{
	mSetPrimKind( GX_TRIANGLESTRIP );
	mSetVtx( eVtxTex );
	mSetTev( eTevSpriteNoTexAlpha );
	mSetRenderFunc( eRenderSprite );
}
//-----------------------------------------------------------------------------
//eNX`̎lp`Zv~eBuɐݒ肷
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetSpriteAddAlphaPrim( void )
{
	mSetPrimKind( GX_TRIANGLESTRIP );
	mSetVtx( eVtxTex );
	mSetTev( eTevAddAlpha );
	mSetRenderFunc( eRenderSprite );
}
//-----------------------------------------------------------------------------
//HSXLp̃v~eBuɐݒ肷
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetSpriteScanHSPrim( void )
{
	mSetPrimKind( GX_TRIANGLESTRIP );
	mSetVtx( eVtxTex );
	mSetTev( eTevScanHS );
	mSetRenderFunc( eRenderSprite );
}

//-----------------------------------------------------------------------------
//XvCg̕ݒ
// in --> s16 inW  
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetW( s16 inW )
{
	mW          = inW;
	mOrgW       = inW;
	mScaleW.now = 1.0f;
	mU1         = (s16)(mU0 + mW);
	mU2         = mU0;
	mU3         = (s16)(mU0 + mW);
}
//-----------------------------------------------------------------------------
//XvCg̍ݒ
// in --> s16 inH  
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetH( s16 inH )
{
	mH          = inH;
	mOrgH       = inH;
	mScaleH.now = 1.0f;
	mV1         = mV0;
	mV2         = (s16)(mV0 + mH);
	mV3         = (s16)(mV0 + mH);
}
//-----------------------------------------------------------------------------
//XvCg̕ݒ
// in --> s16 inW  
//        s16 inH  
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetWH( s16 inW, s16 inH )
{
	mSetW( inW );
	mSetH( inH );
}
//-----------------------------------------------------------------------------
//XvCg̕\XYWݒ
// in --> f32 inX  \XW
//        f32 inY  \YW
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetXY0( f32 inX, f32 inY )
{
	mSetX0( inX );
	mSetY0( inY );
}
//-----------------------------------------------------------------------------
//Alݒ
// in --> u8 inA  ݒ肷郿l
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetA( u8 inA )
{
	mRgba0 = (mRgba0 & 0xffffff00) | inA;
	mRgba1 = (mRgba1 & 0xffffff00) | inA;
	mRgba2 = (mRgba2 & 0xffffff00) | inA;
	mRgba3 = (mRgba3 & 0xffffff00) | inA;
}




//-----------------------------------------------------------------------------
//XvCggkw
// in --> enScaleDir inScaleDir  gk
//        f32        inScale     gk
//        s32        inTick      gkɂ鎞(1b=4800)
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetScale( enScaleDir inScaleDir, f32 inScale, s32 inTick )
{
	mSetScaleWithWait( inScaleDir, inScale, inTick, 0 );
}
//-----------------------------------------------------------------------------
//XvCggkwEGCgt
// in --> enScaleDir inScaleDir  gk
//        f32        inScale     gk
//        s32        inTick      gkɂ鎞(1b=4800)
//        s32        inWaitTick  gk͂߂܂ł̃EGCg(1b=4800)
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetScaleWithWait( enScaleDir inScaleDir, f32 inScale, s32 inTick, s32 inWaitTick )
{
	switch( inScaleDir )
	{
		case	eScaleW:
			mScaleW.start    = mScaleW.now;
			mScaleW.last     = inScale;
			mScaleW.now      = mScaleW.now;
			mScaleW.tick     = inTick;
			mScaleW.nowTick  = inTick;
			mScaleW.waitTick = inWaitTick;
			break;
		case	eScaleH:
			mScaleH.start    = mScaleH.now;
			mScaleH.last     = inScale;
			mScaleH.now      = mScaleH.now;
			mScaleH.tick     = inTick;
			mScaleH.nowTick  = inTick;
			mScaleH.waitTick = inWaitTick;
			break;
		case	eScaleWH:
			mScaleW.start    = mScaleW.now;
			mScaleW.last     = inScale;
			mScaleW.now      = mScaleW.now;
			mScaleW.tick     = inTick;
			mScaleW.nowTick  = inTick;
			mScaleW.waitTick = inWaitTick;
			mScaleH.start    = mScaleH.now;
			mScaleH.last     = inScale;
			mScaleH.now      = mScaleH.now;
			mScaleH.tick     = inTick;
			mScaleH.nowTick  = inTick;
			mScaleH.waitTick = inWaitTick;
			break;
		default:
			break;
	}
}
//-----------------------------------------------------------------------------
//gkImF
// in --> none
// out -> bool false  gk
//             true   gkI
//-----------------------------------------------------------------------------
bool
mK7Sprite::mGetScaleEnd( void )
{
	if( (mScaleW.nowTick == 0) && (mScaleH.nowTick == 0) )
		return( true );
	else
		return( false );
}
//-----------------------------------------------------------------------------
//XvCggk
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mScaleProc( void )
{
	stScale *w, *h;
	w = &mScaleW;
	h = &mScaleH;
	
	//gk
	if( w->waitTick == 0 )
	{
		if( w->nowTick != 0 )
		{
			w->now     += (w->last - w->start) / WK7_TICK_TO_FRAME((f32)w->tick);
//			if( w->now < 0.0001f )
//				w->now = 0.0000f;
			mW   = (s16)(mOrgW * w->now);
			w->nowTick -= WK7_TICK_PER_FRAME;
			if( w->nowTick <= 0 )
			{
				mW  = (s16)(mOrgW * w->last);
				w->nowTick = 0;
				w->now     = w->last;
			}
			mX0  = (s16)(mOrgX0 - ((mW - mOrgW) / 2));
		}
	}else
	{
		w->waitTick -= WK7_TICK_PER_FRAME;
		if( w->waitTick <= 0 )
		{
			w->waitTick = 0;
		}
	}
	
	//gk
	if( h->waitTick == 0 )
	{
		if( h->nowTick != 0 )
		{
			h->now     += (h->last - h->start) / WK7_TICK_TO_FRAME((f32)h->tick);
//			if( h->now < 0.0001f )
//				h->now = 0.0000f;
			mH   = (s16)(mOrgH * h->now);
			h->nowTick -= WK7_TICK_PER_FRAME;
			if( h->nowTick <= 0 )
			{
				mH  = (s16)(mOrgH * h->last);
				h->nowTick = 0;
				h->now     = h->last;
			}
			mY0 = (s16)(mOrgY0 - ((mH - mOrgH) / 2));
		}
	}else
	{
		h->waitTick -= WK7_TICK_PER_FRAME;
		if( h->waitTick <= 0 )
		{
			h->waitTick = 0;
		}
	}
}
//-----------------------------------------------------------------------------
//XvCgړw
// in --> s16 inX     ړXW
//        s16 inY     ړYW
//        s32 inTick  ړɂ鎞(1b=4800)
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetMove( f32 inX, f32 inY, s32 inTick )
{
	mMove.orgX    = mX0;
	mMove.orgY    = mY0;
	mMove.toX     = inX;
	mMove.toY     = inY;
	mMove.nowX    = mX0;
	mMove.nowY    = mY0;
	mMove.tick    = inTick;
	mMove.nowTick = inTick;
}
//-----------------------------------------------------------------------------
//ړImF
// in --> none
// out -> bool false  ړ
//             true   ړI
//-----------------------------------------------------------------------------
bool
mK7Sprite::mGetMoveEnd( void )
{
	if( mMove.nowTick == 0 )
		return( true );
	else
		return( false );
}
//-----------------------------------------------------------------------------
//XvCgړ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mMoveProc( void )
{
	if( mMove.nowTick != 0 )
	{
		mMove.nowX    += ((f32)mMove.toX - (f32)mMove.orgX) / (f32)WK7_TICK_TO_FRAME((f32)mMove.tick);
		mMove.nowY    += ((f32)mMove.toY - (f32)mMove.orgY) / (f32)WK7_TICK_TO_FRAME((f32)mMove.tick);
		mMove.nowTick -= WK7_TICK_PER_FRAME;
		if( mMove.nowTick <= 0 )
		{
			mMove.nowX    = (f32)mMove.toX;
			mMove.nowY    = (f32)mMove.toY;
			mMove.nowTick = 0;
		}
		mOrgX0 = mX0 = mMove.nowX;
		mOrgY0 = mY0 = mMove.nowY;
		
		//4_Ɨp
		if( mMove4Vtx.flag == true )
		{
			mX1 = mX0 + (mMove4Vtx.orgX1 - mMove.orgX);
			mX2 = mX0 + (mMove4Vtx.orgX2 - mMove.orgX);
			mX3 = mX0 + (mMove4Vtx.orgX3 - mMove.orgX);
			mY1 = mY0 + (mMove4Vtx.orgY1 - mMove.orgY);
			mY2 = mY0 + (mMove4Vtx.orgY2 - mMove.orgY);
			mY3 = mY0 + (mMove4Vtx.orgY3 - mMove.orgY);
		}
	}
}
//-----------------------------------------------------------------------------
//XY0̐Lkݒ
// in --> f32 inX     ړXW
//        f32 inY     ړYW
//        s32 inTick  ړɂ鎞(1b=4800)
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetElastic( f32 inX, f32 inY, s32 inTick )
{
	mMoveXY0.orgX    = mX1;
	mMoveXY0.orgY    = mY1;
	mMoveXY0.toX     = inX;
	mMoveXY0.toY     = inY;
	mMoveXY0.nowX    = (f32)mX1;
	mMoveXY0.nowY    = (f32)mY1;
	mMoveXY0.tick    = inTick;
	mMoveXY0.nowTick = inTick;
}
//-----------------------------------------------------------------------------
//XY0̐LkImF
// in --> none
// out -> bool false  ړ
//             true   ړI
//-----------------------------------------------------------------------------
bool
mK7Sprite::mGetElasticEnd( void )
{
	if( mMoveXY0.nowTick == 0 )
		return( true );
	else
		return( false );
}
//-----------------------------------------------------------------------------
///XY0̐Lk
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mElasticProc( void )
{
	if( mMoveXY0.nowTick != 0 )
	{
		mMoveXY0.nowX    += ((f32)mMoveXY0.toX - (f32)mMoveXY0.orgX) / (f32)WK7_TICK_TO_FRAME((f32)mMoveXY0.tick);
		mMoveXY0.nowY    += ((f32)mMoveXY0.toY - (f32)mMoveXY0.orgY) / (f32)WK7_TICK_TO_FRAME((f32)mMoveXY0.tick);
		mMoveXY0.nowTick -= WK7_TICK_PER_FRAME;
		if( mMoveXY0.nowTick <= 0 )
		{
			mMoveXY0.nowX    = (f32)mMoveXY0.toX;
			mMoveXY0.nowY    = (f32)mMoveXY0.toY;
			mMoveXY0.nowTick = 0;
		}
		mX1 = (s16)mMoveXY0.nowX;
		mY1 = (s16)mMoveXY0.nowY;
	}
}
//-----------------------------------------------------------------------------
//XvCgtF[hw
// in --> s8  inA     ڕWƂȂPx
//        s32 inTick  tF[hɂ鎞(1b=4800)
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetFade( u8 inA, s32 inTick )
{
	mSetFadeWithWait( inA, inTick, 0 );
//	mFade.orgA    = (u8)(mRgba & 0x000000ff);
//	mFade.toA     = inA;
//	mFade.nowA    = (f32)(mRgba & 0x000000ff);
//	mFade.tick    = inTick;
//	mFade.nowTick = inTick;
}
//-----------------------------------------------------------------------------
//XvCgtF[hwEGCg
// in --> s8  inA     ڕWƂȂPx
//        s32 inTick  tF[hɂ鎞(1b=4800)
//        s32 inWaitTick  tF[hJn܂ő҂(1b=4800)
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetFadeWithWait( u8 inA, s32 inTick, s32 inWaitTick )
{
	if( inTick==0 ){
		mFade.orgA     = inA;
		mFade.toA      = inA;
		mFade.nowA     = inA;
		mFade.tick     = 1;
		mFade.nowTick  = 0;
		mFade.waitTick = 0;
		mRgba0 = (mRgba0 & 0xffffff00) | (u8)(mFade.nowA);
		mRgba1 = (mRgba1 & 0xffffff00) | (u8)(mFade.nowA);
		mRgba2 = (mRgba2 & 0xffffff00) | (u8)(mFade.nowA);
		mRgba3 = (mRgba3 & 0xffffff00) | (u8)(mFade.nowA);
		return;
	}
	mFade.orgA     = (u8)(mRgba0 & 0x000000ff);
	mFade.toA      = inA;
	mFade.nowA     = (f32)(mRgba0 & 0x000000ff);
	mFade.tick     = inTick;
	mFade.nowTick  = inTick;
	mFade.waitTick = inWaitTick;
}
//-----------------------------------------------------------------------------
//tF[hImF
// in --> none
// out -> bool false  tF[h
//             true   tF[hI
//-----------------------------------------------------------------------------
bool
mK7Sprite::mGetFadeEnd( void )
{
	if( mFade.nowTick == 0 )
		return( true );
	else
		return( false );
}
//-----------------------------------------------------------------------------
//XvCgtF[h
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mFadeProc( void )
{
	if( mFade.waitTick == 0 )
	{
		if( mFade.nowTick != 0 )
		{
			mFade.nowA    += ((f32)mFade.toA - (f32)mFade.orgA) / (f32)WK7_TICK_TO_FRAME((f32)mFade.tick);
			mFade.nowTick -= WK7_TICK_PER_FRAME;
			if( mFade.nowTick <= 0 )
			{
				mFade.nowA    = (f32)mFade.toA;
				mFade.nowTick = 0;
			}
			mRgba0 = (mRgba0 & 0xffffff00) | (u8)(mFade.nowA);
			mRgba1 = (mRgba1 & 0xffffff00) | (u8)(mFade.nowA);
			mRgba2 = (mRgba2 & 0xffffff00) | (u8)(mFade.nowA);
			mRgba3 = (mRgba3 & 0xffffff00) | (u8)(mFade.nowA);
		//	mRgba1 = mRgba0;
		//	mRgba2 = mRgba0;
		//	mRgba3 = mRgba0;
		}
	}else
	{
		mFade.waitTick -= WK7_TICK_PER_FRAME;
		if( mFade.waitTick <= 0 )
		{
			mFade.waitTick = 0;
		}
	}
}
//-----------------------------------------------------------------------------
//CUw
// in --> U
//        U
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetVibrate( s16 inVibrateW, s32 inTick )
{
	if( mKind != GX_LINES )
		return;
	
	mVib.vibrateW = inVibrateW;
	mVib.orgY     = mGetY0();
	mVib.index    = (u8)HSD_Randi(4);
	mVib.tick     = inTick;
	mVib.nowTick  = inTick;
	mVib.waitTick = inTick / 4;
}
//-----------------------------------------------------------------------------
//CU
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mVibrateProc( void )
{
	u8 loopTbl[4] = { 0, 1, 2, 1 };
	
	if( mKind != GX_LINES )
		return;
	
	if( mVib.nowTick != 0 )
	{
		mVib.nowTick -= WK7_TICK_PER_FRAME;
		if( mVib.nowTick <= 0 )
		{
			mSetY0( mVib.orgY );
			mSetY1( mVib.orgY );
			mSetFade( 0xff, 1 );
			mVib.nowTick  = 0;
			mVib.waitTick = 0;
		}else
		{
			switch( loopTbl[mVib.index] )
			{
				case	0:
					mSetY0( (s16)(mVib.orgY + mVib.vibrateW) );
					mSetY1( (s16)(mVib.orgY - mVib.vibrateW) );
					mSetFade( 0x80, 1 );
					break;
				case	1:
					mSetY0( mVib.orgY );
					mSetY1( mVib.orgY );
					mSetFade( 0xff, 1 );
					break;
				case	2:
					mSetY0( (s16)(mVib.orgY - mVib.vibrateW) );
					mSetY1( (s16)(mVib.orgY + mVib.vibrateW) );
					mSetFade( 0x80, 1 );
					break;
				default:
					break;
			}
			if( mVib.waitTick <= 0 )
			{
				mVib.index = (u8)((mVib.index + 1) % 4);
				mVib.waitTick = mVib.tick / 4;
			}else
			{
				mVib.waitTick -= WK7_TICK_PER_FRAME;
			}
		}
	}
}
//-----------------------------------------------------------------------------
//C_O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mRenderLine( void )
{
	GXSetLineWidth( (u8)mW, GX_TO_ZERO );
	GXBegin( mKind, GX_VTXFMT0, 2 );
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		GXPosition2f32( mX0, mY0 );
		GXColor1u32   ( mRgba0 );
		
		GXPosition2f32( mX1, mY1 );
		GXColor1u32   ( mRgba1 );
	GXEnd();
}
//-----------------------------------------------------------------------------
//Op`eNX`t_O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mRenderTriangleTex( void )
{
	f32 xRate, yRate, s0, t0, s1, t1, s2, t2;
	
	//eNX`[h
	if(	mK7Sprite::mOldTex != mTex ){
		GXLoadTexObj( &mTex->obj, GX_TEXMAP0 );
		mK7Sprite::mOldTex = mTex;
	}
	
	//uvl߂邽߂̌vZ
	xRate	= 1.0f / (f32)mTex->tex->mWidth;
	yRate	= 1.0f / (f32)mTex->tex->mHeight;
	s0		= xRate * (f32)mU0;
	t0		= yRate * (f32)mV0;
	s1		= xRate * (f32)mU1;
	t1		= yRate * (f32)mV1;
	s2		= xRate * (f32)mU2;
	t2		= yRate * (f32)mV2;
	
	GXBegin( mKind, GX_VTXFMT0, 3 );
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		GXPosition2f32( mX0, mY0 );
		GXColor1u32   ( mRgba0 );
		GXTexCoord2f32( s0, t0 );
		
		GXPosition2f32( mX1, mY1 );
		GXColor1u32   ( mRgba1 );
		GXTexCoord2f32( s1, t1 );
		
		GXPosition2f32( mX2, mY2 );
		GXColor1u32   ( mRgba2 );
		GXTexCoord2f32( s2, t2 );
	GXEnd();
}
//-----------------------------------------------------------------------------
//_O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mRenderBox( void )
{
	//x1`x3,y1`y3߂
	mX1 = mX3 = mX0 + (f32)mW;
	mX2 = mX0;
	mY1 = mY0;
	mY2 = mY3 = mY0 + (f32)mH;
	
	GXBegin( mKind, GX_VTXFMT0, 4 );
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		GXPosition2f32( mX0, mY0 );
		GXColor1u32   ( mRgba0 );
		
		GXPosition2f32( mX1, mY1 );
		GXColor1u32   ( mRgba1 );
		
		GXPosition2f32( mX2, mY2 );
		GXColor1u32   ( mRgba2 );
		
		GXPosition2f32( mX3, mY3 );
		GXColor1u32   ( mRgba3 );
	GXEnd();
}
//-----------------------------------------------------------------------------
//ό`_O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mRenderTransformBox( void )
{
	GXBegin( mKind, GX_VTXFMT0, 4 );
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		GXPosition2f32( mX0, mY0 );
		GXColor1u32   ( mRgba0 );
		
		GXPosition2f32( mX1, mY1 );
		GXColor1u32   ( mRgba1 );
		
		GXPosition2f32( mX2, mY2 );
		GXColor1u32   ( mRgba2 );
		
		GXPosition2f32( mX3, mY3 );
		GXColor1u32   ( mRgba3 );
	GXEnd();
}
//-----------------------------------------------------------------------------
//XvCg_O
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mRenderSprite( void )
{
	f32 xRate, yRate, s0, t0, s1, t1, s2, t2, s3, t3;
	
	//eNX`[h
	if(	mK7Sprite::mOldTex != mTex ){
		GXLoadTexObj( &mTex->obj, GX_TEXMAP0 );
		mK7Sprite::mOldTex = mTex;
	}
	
	//x1`x3,y1`y3߂
	mX1 = mX3 = mX0 + (f32)mW;
	mX2 = mX0;
	mY1 = mY0;
	mY2 = mY3 = mY0 + (f32)mH;
	//u1`u3,v1`v3߂
//	mU1 = mU3 = (s16)(mU0 + mOrgW);
//	mU2 = mU0;
//	mV1 = mV0;
//	mV2 = mV3 = (s16)(mV0 + mOrgH);
	
	//uvl߂邽߂̌vZ
	xRate	= 1.0f / (f32)mTex->tex->mWidth;
	yRate	= 1.0f / (f32)mTex->tex->mHeight;
	s0		= xRate * (f32)mU0;
	t0		= yRate * (f32)mV0;
	s1		= xRate * (f32)mU1;
	t1		= yRate * (f32)mV1;
	s2		= xRate * (f32)mU2;
	t2		= yRate * (f32)mV2;
	s3		= xRate * (f32)mU3;
	t3		= yRate * (f32)mV3;
	
	GXBegin( mKind, GX_VTXFMT0, 4 );
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		GXPosition2f32( mX0, mY0 );
		GXColor1u32   ( mRgba0 );
		GXTexCoord2f32( s0, t0 );
		
		GXPosition2f32( mX1, mY1 );
		GXColor1u32   ( mRgba1 );
		GXTexCoord2f32( s1, t1 );
		
		GXPosition2f32( mX2, mY2 );
		GXColor1u32   ( mRgba2 );
		GXTexCoord2f32( s2, t2 );
		
		GXPosition2f32( mX3, mY3 );
		GXColor1u32   ( mRgba3 );
		GXTexCoord2f32( s3, t3 );
	GXEnd();
}
//-----------------------------------------------------------------------------
//_OĂяo֐
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mCallRenderProc( void )
{
	(this->*mRenderFunc)();
}
//-----------------------------------------------------------------------------
//XvCg`
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mRender( void )
{
//	mK7Sprite*  sprt = mK7Sprite::mSprtTop;
	mK7Sprite*  sprt = (mK7Sprite*)mAnchor.GetNext();
	HSD_RectU16 sc_rect;

	//J
	mSetCamera2D();
	//eNX`ƃCgƒ_̊ݒ
	mSetCommonEnv();
	
	//Xg̍ŏXvCg`悷
	while( sprt ){
		//\tOmF
		if( sprt->mGetDispFlag() )
		{
			//tevݒ
			if( sprt->mCheckSameTev() == false )
				sprt->mTevFunc();
			//vtxݒ
			if( sprt->mCheckSameVtx() == false )
				sprt->mVtxFunc();
			//XvCg̊gk
			if( ghmGcFile::IsDiskStandby()==true ){
				sprt->mScaleProc();
				//XvCgړ
				sprt->mMoveProc();
				//XY0̐Lk
				sprt->mElasticProc();
				//XvCgtF[h
				sprt->mFadeProc();
				//CU
				sprt->mVibrateProc();
			}
			//LɃXLVUO
			if( (GameInfo.GetMode() == WK7GameInfo::PLAY)
			 && ((sprt->mGetPriority() == SPRT_PRI_DIM) || (sprt->mGetPriority() == SPRT_PRI_DIM_MONO) || (sprt->mGetPriority() == SPRT_PRI_DIM_HS)) )
			{
				if( gTrimming == false )
				{
					WK7CAM->GetScissor( sc_rect );
					GXSetScissor(sc_rect.xmin,sc_rect.ymin,(u32)(sc_rect.xmax-sc_rect.xmin),(u32)(sc_rect.ymax-sc_rect.ymin));
					gTrimming = true;
				}
			}else
			{
				if( gTrimming == true )
				{
					GXSetScissor( 0, 0, K7APP_SCREEN_WIDTH, K7APP_SCREEN_HEIGHT );
					gTrimming = false;
				}
			}
			//XvCg_O
			sprt->mCallRenderProc();
		}
		//̃XvCgփ|C^ړ
//		sprt = sprt->mNext;
		sprt = sprt->mGetNext();
	}
	
//	GXSetAlphaCompare(GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0);
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);
	GXSetZCompLoc( GX_TRUE );
	GXSetTevOp( GX_TEVSTAGE0, GX_MODULATE );
	
	//e|C^NA
	mK7Sprite::mOldTex = NULL;
	mK7Sprite::mOldVtxFunc = NULL;
	mK7Sprite::mOldTevFunc = NULL;
}




//-----------------------------------------------------------------------------
//vtxOvtxƓǂׂ
// in --> none
// out -> bool false  OƈႤvtxł
//             true   OƓvtxł
//-----------------------------------------------------------------------------
bool
mK7Sprite::mCheckSameVtx( void )
{
	if( mK7Sprite::mOldVtxFunc == mVtxFunc )
		return( true );
	
	mK7Sprite::mOldVtxFunc = mVtxFunc;
	return( false );
}
//-----------------------------------------------------------------------------
//tevOtevƓǂׂ
// in --> none
// out -> bool false  OƈႤtevł
//             true   OƓtevł
//-----------------------------------------------------------------------------
bool
mK7Sprite::mCheckSameTev( void )
{
	if( mK7Sprite::mOldTevFunc == mTevFunc )
		return( true );
	
	mK7Sprite::mOldTevFunc = mTevFunc;
	return( false );
}
//-----------------------------------------------------------------------------
//2DpJ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetCamera2D( void )
{
	Mtx			view;
	Mtx44		proj;
	
#if 0
	Vec			vPos;
	Vec			vUp;
	Vec			vAt;
	
	vUp .x =    0.0f;
	vUp .y = -  1.0f;
	vUp .z =    0.0f;
	vPos.x =    0.0f;
	vPos.y =    0.0f;
	vPos.z = -300.0f;		// K
	vAt .x =  vPos.x;
	vAt .y =  vPos.y;
	vAt .z =    0.0f;
	
	// [Jr[ϊ}gNXݒ
	MTXLookAt       (view,&vPos,&vUp,&vAt);
	MTXOrtho        (proj,0,-K7APP_SCREEN_HEIGHT,0,K7APP_SCREEN_WIDTH,100,1000);
#else
	MTXIdentity     (view);
	view[2][3] = -300.f;
	MTXOrtho        (proj,0,K7APP_SCREEN_HEIGHT,0,K7APP_SCREEN_WIDTH,100,1000);
#endif
	
	GXLoadPosMtxImm (view,GX_PNMTX0);
	GXLoadNrmMtxImm (view,GX_PNMTX0);
	GXSetCurrentMtx (GX_PNMTX0);
	GXSetProjection (proj,GX_ORTHOGRAPHIC);
	
	GXSetScissor    (0,0,K7APP_SCREEN_WIDTH,K7APP_SCREEN_HEIGHT);
	GXSetViewport   (0.0f,0.0f,K7APP_SCREEN_WIDTH,K7APP_SCREEN_HEIGHT,0.0f,1.0f);
}




//-----------------------------------------------------------------------------
//eNX`ƃCgƒ_̊ݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetCommonEnv( void )
{
#if	0	//A`eXg
//	GXSetCopyFilter( GX_FALSE, NULL, GX_FALSE, NULL );
//	GXSetPixelFmt( GX_PF_RGB565_Z16, GX_ZC_LINEAR );
	GXSetDither( GX_TRUE );
#endif
	
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);
	GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );
	GXSetZCompLoc( GX_TRUE );
	GXSetColorUpdate( GX_TRUE );
	GXSetDither( GX_TRUE );
	
//	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
//	GXSetNumTexGens( 1 );
//	//eNX`W̕@w聨łGX_TEXCOORD0̍W@w
//	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	
	//TEVXe[Wւ̏o͂łJ[`l̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumChans( 1 );
	//GX_COLOR0A0̃CgRg[̐ݒ
//	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );
	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
}




//-----------------------------------------------------------------------------
//tbg|Sptevݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetFlatTev( void )
{
	//rݒ
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);
	GXSetZCompLoc( GX_TRUE );
//	GXSetAlphaCompare(GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0);
	
	//uh[hݒ
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 0 );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
	GXSetTevOp( GX_TEVSTAGE0, GX_PASSCLR );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo
}
//-----------------------------------------------------------------------------
//spriteptevݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetSpriteTev( void )
{
	//rݒ
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);
	GXSetZCompLoc( GX_TRUE );
//	GXSetAlphaCompare(GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0);
	
	//uh[hݒ
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 1 );
	//eNX`W̕@w聨łGX_TEXCOORD0̍W@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
//	GXSetTevOp( GX_TEVSTAGE0, GX_MODULATE );
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_RASC, GX_CC_TEXC, GX_CC_ZERO );
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_RASA, GX_CA_TEXA, GX_CA_ZERO );
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo
}
//-----------------------------------------------------------------------------
//spriteptevݒEeNX`͎̃gȂ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetSpriteTevNoTexAlpha( void )
{
	//rݒ
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);
	GXSetZCompLoc( GX_TRUE );
//	GXSetAlphaCompare(GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0);
	
	//uh[hݒ
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 1 );
	//eNX`W̕@w聨łGX_TEXCOORD0̍W@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
//	GXSetTevOp( GX_TEVSTAGE0, GX_MODULATE );
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_RASC, GX_CC_TEXC, GX_CC_ZERO );
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA );
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo
}
//-----------------------------------------------------------------------------
//Zptevݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetSpriteTevAddAlpha( void )
{
	//rݒ
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);
	GXSetZCompLoc( GX_TRUE );
//	GXSetAlphaCompare(GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0);
	
	//uh[hݒ
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_ONE, GX_LO_CLEAR );
	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 1 );
	//eNX`W̕@w聨łGX_TEXCOORD0̍W@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
//	GXSetTevOp( GX_TEVSTAGE0, GX_MODULATE );
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_RASC, GX_CC_TEXC, GX_CC_ZERO );
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_RASA, GX_CA_TEXA, GX_CA_ZERO );
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo
}
//-----------------------------------------------------------------------------
//spriteptevݒ:HSXLpT[OtBp
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetScanHSTev( void )
{
	//rݒ
	GXSetAlphaCompare( GX_GEQUAL, WK7RenderObj::ConvRenderIDToAlpha(WK7RENDEROBJ_RENDERID_HALF), GX_AOP_AND, GX_LESS, MK7SPRITE_DIM_ALPHA_MAX );
	GXSetZCompLoc( GX_FALSE );
	
	//uh[hݒ
	GXSetBlendMode( GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 1 );
	//eNX`W̕@w聨łGX_TEXCOORD0̍W@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
//	GXSetTevOp( GX_TEVSTAGE0, GX_MODULATE );
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_RASC, GX_CC_TEXC, GX_CC_ZERO );
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_TEXA );	//HS̃eNX`g
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo
}




//-----------------------------------------------------------------------------
//xyz.rgba8pvtx
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetNoTexVtx( void )
{
	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
	//ꂼ̗̑vf(?)Ǝނݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XY,   GX_F32  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
}
//-----------------------------------------------------------------------------
//xyz.rgba8.texpvtx
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
mK7Sprite::mSetTexVtx( void )
{
	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
	GXSetVtxDesc( GX_VA_TEX0, GX_DIRECT );	//eNX`0̎ނݒ
	//ꂼ̗̑vf(?)Ǝނݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XY,   GX_F32  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST,   GX_F32,   0 );	//eNX`0̗vfƎނw
}




