////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Typo
//
// mK7Typo.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/16/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7TYPO_H__
#define	__MK7TYPO_H__

//---- include ----
#include "..\wat\WK7Define.h"
#include "mK7Common.h"
#include "mK7Jimaku.h"
#include "mK7Sprite.h"




//---- define ----
#define	TF_N		(1<<0)	//ACREk
#define	TF_NNE		(1<<1)	//ACREkk
#define	TF_NE		(1<<2)	//ACREk
#define	TF_ENE		(1<<3)	//ACREk
#define	TF_E		(1<<4)	//ACRE
#define	TF_ESE		(1<<5)	//ACRE쓌
#define	TF_SE		(1<<6)	//ACRE쓌
#define	TF_SSE		(1<<7)	//ACRE쓌
#define	TF_S		(1<<8)	//ACRE
#define	TF_SSW		(1<<9)	//ACRE쐼
#define	TF_SW		(1<<10)	//ACRE쐼
#define	TF_WSW		(1<<11)	//ACRE쐼
#define	TF_W		(1<<12)	//ACRE
#define	TF_WNW		(1<<13)	//ACREk
#define	TF_NW		(1<<14)	//ACREk
#define	TF_NNW		(1<<15)	//ACREkk
#define	TF_DOOR		(1<<16)	//ACRE
#define	TF_KEY		(1<<17)	//ACRE
#define	TF_MAP		(1<<18)	//ACREn}
#define	TF_MEMO		(1<<19)	//ACRE
#define	TF_VREC		(1<<20)	//ACRE
#define	TF_GRFF		(1<<21)	//ACRE graffiti
#define	TF_EVENT	(1<<22)	//ACRECxg
#define	TF_TV		(1<<23)	//ACREer
#define	TF_MAX		(1<<31)	//ACREŌ

//---- enum ----
//t[vZX̏
typedef	enum{
	eTypoFontRead,			//tHgǂݍ
	eTypoIconRead,			//ACRǂݍ
	eTypoFontStandby,		//X^oC
	eTypoFrameProcMax,
}enTypoFrameProc;
//^C|̑̕傫
typedef	enum{
	eTypoSizeSmall,
	eTypoSizeBig,
	eTypoSizeMax,
}enTypoSize;
//^C|̌Ə̎(w鑤)
typedef	enum{
	eTypoDisp00,			//:tF[hCAEg@傫:k>k
	eTypoDispMax,
}enTypoDispType;
//^C|̌Ə̎(ۂ̎)
typedef	enum{
	//SĂ̎ނɃtF[hCAEg͕t܂
	eTypoFadeInOut,				//tF[hCAEg
	eTypoFadeInOutWithWait,		//tF[hCAEgEEGCgt
	eTypoReduce,				//k>k
	eTypoDispFormatMax,
}enTypoDispFormat;
//IĂȂ
typedef	enum{
	eTypoSelect,
	eTypoUnselect,
	eTypoSelectMax,
}enTypoSelect;


//---- struct ----

//---- class ----
//^C|NX
class MK7Typo{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7Typo();
	
	//fXgN^
	~MK7Typo();
	
	//^C|ACRւindex擾
	s16			mGetIconIndex( u32* inFlag, int* inDirNum );
	//^C|ACRNGCg
	bool		mCreateIcon( u32 inFlag, enTypoDispFormat inFormat );
	//^C|NGCg:傫wt
	bool		mCreateStr( char* inString, enTypoDispFormat inFormat );
	//bool		mCreateStr( char* inString, enTypoSize inSize, enTypoDispFormat inFormat );
	//XvCǧƏ̏ݒ
	void		mSprtInit( void );
	
	//^C|
	void		mErase( void );
	
	//\Wݒ
	void		mSetXY0( s16 inX, s16 inY );
	//^C|̒S\Wݒ
	void		mSetXYCenter( s16 inX, s16 inY );
	
	//RGBAl̐ݒ
	void		mSetRGBA( u32 inRgba );
	//RGBAl̎擾
	u32			mGetRGBA( void );
	//RGBl̐ݒ
	void		mSetRGB( u32 inRgb );
	
	//tF[h̐ݒ
	void		mSetFade( u8 inA, s32 inTick );
	//tF[h̏I̊mF
	bool		mGetFadeEnd( void );
	
	//ړ̐ݒ
	void		mSetMove( s16 inX, s16 inY, s32 inTick );
	//ړI̊mF
	bool		mGetMoveEnd( void );
	
	//^C|̃NGCgNGXgǂ`FbN
	bool		mExistCheck( void );
	
	//^C|\
	void		mDisp( void );
	//^C|\
	void		mUnDisp( enTypoSelect inSelect );
	
	//\tOݒ
	void		mSetDispFlag( bool inFlag );
	
	//̃^C|ւ̃AhX擾
	MK7Typo*	mGetNextTypo(void){return(mNext);}
	
	//^C|̕擾
	s16			mGetWidth(void){return(mWidth);}
	//^C|̍擾
	s16			mGetHeight( void );

	//^C|t[
	void		mFrameProcess( void );
	
	//W擾
	s16			mGetX( void );
	s16			mGetY( void );
	
	//---- ϐ ----
	MK7Typo*			mPrev;			//Õ^C|ւ̃|C^
	MK7Typo*			mNext;			//̃^C|ւ̃|C^
	
private:
	//---- ֐ ----
	
	//---- ϐ ----
	mK7Sprite*			mSprt;			//XvCgւ̃|C^
	mK7Sprite*			mSprtS;			//eXvCgւ̃|C^
	stMove*				mMove;			//^C|ړp
	size_t				mLength;		//
	char*				mString;		//^C|̕
	u32					mIcon;			//ACR
	s16					mWidth;			//^C|̕
	enTypoDispFormat	mDispFormat;	//Ə
	enTypoSelect		mSelect;		//IꂽȂ
	
	stFontParam*		mFontParam;		//tHg̕p[^
};

//^C|NX
class MK7Typos{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7Typos();
	
	//fXgN^
	~MK7Typos();
	
	//^C|NGCg
	bool	mCreate( char* inStringS, char* inStringB, enTypoDispType inDispType, u32 inIcon=(u32)TF_MAX );
	
	//^C|
	void	mErase( void );
	
	//\Wݒ
	void	mSetXY0( s16 inX, s16 inY );
	//^C|̒S\Wݒ
	void	mSetXYCenter( s16 inX, s16 inY );
	
	//RGBAl̐ݒ
	void	mSetRGBA( u32 inRgba );
	//RGBAl̎擾
	u32		mGetRGBA( void );
	//RGBl̐ݒ
	void	mSetRGB( u32 inRgb );
	
	//tF[h̐ݒ
	void	mSetFade( u8 inA, s32 inTick );
	//tF[h̏I̊mF
	bool	mGetFadeEnd( void );
	
	//^C|̃NGCgNGXgǂ`FbN
	bool	mExistCheck( void );
	
	//^C|\
	void	mDisp( void );
	//^C|\EWwt
	void	mDispXY( s16 inX, s16 inY );
	//^C|\ESWwt
	void	mDispXYCenter( s16 inX, s16 inY );
	//^C|\
	void	mUnDisp( enTypoSelect inSelect );
	
	//\tOݒ
	void	mSetDispFlag( bool inFlag );
	
	//C\
	void	mLineDisp( void );
	//C\
	void	mLineUnDisp( enTypoSelect inSelect );
	
	//^C|̕擾
	s16		mGetWidth( void );
	//^C|̍擾
	s16		mGetHeight( void );
	
	//^C|Lƕ̕\t]
	void	mSetReverse( bool inReverse, s32 inTick = 0 );
	
private:
	//---- ֐ ----
	
	//---- ϐ ----
	enTypoDispType	mDispType;	//Ə
	
	MK7Typo			mTypoS;		//^C|
	s16				mOffsetXS;
	s16				mOffsetYS;
	
	MK7Typo			mTypoB;		//傫^C|
	s16				mOffsetXB;
	s16				mOffsetYB;
	
	mK7Sprite		mLine;		//d؂郉C
};

//^C|}l[WNX
class MK7TypoMng{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7TypoMng();
	
	//fXgN^
	~MK7TypoMng();
	
	//
	static	void	Init( void );
	//㏈
	static	void	Term( void );
	
	//
	void			mInit( void );
	//㏈
	void			mTerm( void );
	
	//eNX`f[^ǂݍ܂Ă邩擾
	bool			mGetTexExist( void );
	//t[
	void			mFrameProcess( void );
	//SẴ^C|̕\~܂
	bool			mDispAllStop( void );
	//Ԏ擾
	enTypoFrameProc	mGetStatus( void );
	//^C|p̃eNX`̃|C^擾
	stTexture*		mGetTexStrPtr( void );
	//ACRp̃eNX`̃|C^擾
	stTexture*		mGetTexIconPtr( void );
	//tHgp[^̃|C^擾
	stFontParam*	mGetFontParamPtr( void );

private:
	//---- ֐ ----
	//t@CNX
	mK7File			mFile;
	
	//---- ϐ ----
	enTypoFrameProc	mFrameProc;	//t[
	stSentence*		mDat;		//t@Cǂݍ񂾃f[^
	stTexture		mTexStr;	//^C|eNX`
	stTexture		mTexIcon;	//^C|ACReNX`
};

//extern
extern	MK7TypoMng*	gpTypoMng;

#endif	//__MK7TYPO_H__




