////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Breaker
//
// SK7PanelBreaker.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELBREAKER_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelBreaker.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

const VEC2 tblSwitchPos[]=
{
	248.0f,	163.0f,
	333.0f,	163.0f,
};

Vec tblCursolPos[]=
{
	280.0f,	286.0f, 0.0f,
	365.0f,	286.0f, 0.0f,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelBreaker::SK7PanelBreaker( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	switch( Now ){
	case	BREAKER_NONE:
		SetCursolPosition( &tblCursolPos[0] );
		SetCursolDir( CURSOL_DIR_RIGHT );
		break;
	case	BREAKER_ORANGE:
		SetCursolPosition( &tblCursolPos[1] );
		break;
	case	BREAKER_GREEN:
		SetCursolPosition( &tblCursolPos[0] );
		break;
	}
	m_sNowAnswer	= Now;
	m_chState		= (s8)Now;
	m_cSelect 		= 0;
	m_iTime 		= 0;
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	XCb`
	m_spSwitchO.SetXY0( tblSwitchPos[0].x, tblSwitchPos[0].y );
	m_spSwitchG.SetXY0( tblSwitchPos[1].x, tblSwitchPos[1].y );	
		
	//	_`FbN
	switch( Now ){
	case BREAKER_NONE:
		m_spSwitchO.SetVisible(false);
		m_spSwitchG.SetVisible(false);
		break;
		
	case BREAKER_GREEN:
		m_spSwitchO.SetVisible(false);
		m_spSwitchG.SetVisible(true);
		break;
		
	case BREAKER_ORANGE:
		m_spSwitchO.SetVisible(true);
		m_spSwitchG.SetVisible(false);
		break;
	
	case BREAKER_ALL:
		m_spSwitchO.SetVisible(true);
		m_spSwitchG.SetVisible(true);
		break;
	}
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelBreaker::~SK7PanelBreaker()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spSwitchO.Delete();
	m_spSwitchG.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelBreaker::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			//	u[J[ׂĂĂƂ͕`悵Ȃ
			if( m_sNowAnswer != BREAKER_ALL )	SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;

		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			m_sNowAnswer = NOT_PLAY;
			m_Proc = PROC_CANCEL;
			break;
		}
		
		switch( m_chState ){
		case BREAKER_NONE:
			if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
				switch( m_cSelect ){
				case 0:
					gpSound->mPlaySE( SFX_SCE3_PNL_BREAKER_SOUSA );
					m_spSwitchO.SetVisible(true);
					break;
				case 1:
					gpSound->mPlaySE( SFX_SCE3_PNL_BREAKER_SOUSA );
					m_spSwitchG.SetVisible(true);
					break;
				}
				m_Proc = PROC_CHECK;
				break;
			}
			if( CheckKeyT( SK7_KEY_LEFT ) ){
				if( --m_cSelect < 0 ){
					m_cSelect = 0;
					break;
				}
				gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
				SetCursolPosition( &tblCursolPos[m_cSelect]);
				SetCursolDir( CURSOL_DIR_LEFT, 1 );
				break;
			}
			if( CheckKeyT( SK7_KEY_RIGHT ) )
			{
				if( ++m_cSelect > 1 ){
					m_cSelect = 1;
					break;
				}
				gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
				SetCursolPosition( &tblCursolPos[m_cSelect]);
				SetCursolDir( CURSOL_DIR_RIGHT );
				break;
			}
			break;

		case BREAKER_GREEN:
			if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
				m_cSelect = 0;
				gpSound->mPlaySE( SFX_SCE3_PNL_BREAKER_SOUSA );
				m_spSwitchO.SetVisible(true);
				m_Proc = PROC_CHECK;
			}
			break;
		case BREAKER_ORANGE:
			if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
				m_cSelect = 1;
				gpSound->mPlaySE( SFX_SCE3_PNL_BREAKER_SOUSA );
				m_spSwitchG.SetVisible(true);
				m_Proc = PROC_CHECK;
			}
			break;
		case BREAKER_ALL:
			if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
				gpSound->mPlaySE(SFX_SYS_CANCEL);
				m_sNowAnswer = NOT_PLAY;
				m_Proc = PROC_CANCEL;
			}
			break;
		}
		break;
		
	//	ŏI`FbN	---------------------------------------
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:		//߂
			if( m_cSelect == 0 ){
				if( m_spSwitchO.CheckFlag( RENDER_FLAG ) ){
					m_spSwitchO.SetVisible(false);
				}
			}else{
				if( m_spSwitchG.CheckFlag( RENDER_FLAG ) ){
					m_spSwitchG.SetVisible(false);
				}
			}
			m_Proc = PROC_SELECT_MAIN;
			break;
		
		case	PANEL_CHECK_SET:
			gpSound->mPlaySE( SFX_SCE3_PNL_BREAKER_BOON );
			switch( m_sNowAnswer ){
			case	BREAKER_NONE:
				if( m_spSwitchG.CheckFlag( RENDER_FLAG ) ){
					m_sNowAnswer = BREAKER_GREEN_ON;
				}else{
					m_sNowAnswer = BREAKER_ORANGE_ON;
				}
				break;
			case	BREAKER_GREEN:	
				m_sNowAnswer = BREAKER_ORANGE_ON;
				break;
			case	BREAKER_ORANGE:	
				m_sNowAnswer = BREAKER_GREEN_ON;
				break;	
			}
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case	PROC_TIME:
		if( ++m_iTime > 30 ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
			
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	//	J[\̌	=========================================
	if( m_sNowAnswer == BREAKER_NONE ){
		switch(m_cSelect){
		case 0: 	SetCursolDir( CURSOL_DIR_RIGHT,0 );	break;
		case 1: 	SetCursolDir( CURSOL_DIR_LEFT,0 );	break;
		}
	}
		
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelBreaker::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spSwitchG.Render();
	m_spSwitchO.Render();
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelBreaker::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelBreaker::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelBreaker::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h 
//========================================================================
bool	SK7PanelBreaker::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL030401TEX_BG )){
			m_TexProc = LOAD_ON_O;
		}
		break;
				
	case 	LOAD_ON_O:
		if( m_spSwitchO.LoadTexture( PNL030401TEX_ON_O )){
			m_TexProc = LOAD_ON_G;
		}
		break;
	case 	LOAD_ON_G:	//	wi
		if( m_spSwitchG.LoadTexture( PNL030401TEX_ON_G )){
			return true;
		}
		break;
	}
	return false;
}