////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cards
//
// SK7PanelCards.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELCARDS_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelCards.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"

//	W
const VEC2 tblCardsPos[]={
	0,168,
	64,160,
	320,160,
	384,176,
	128,-16,
	0,-16,
};

//	J[\W
Vec tblCardsCursolPos[]={
	70,257,0,
	201,197,0,
	440,197,0,
	569,257,0,
	483,335,0,
	154,335,0,
};

//	oJ(f[^j
const int tblBaccaAns[]={
	0,		//9
	1,		//10
	3,		//Q
	
};

//	|[J[
#define		POKER_NOT		(0)
#define		POKER_ANS_NUM	(5)
#define		BLACK_ANS_NUM	(3)
#define		BACCA_ANS_NUM		(3)

//	ubNWbN	
const int tblBlackAns[]={
	2,		//11
	4,		//K
	5,		//A
};



//========================================================================
//					RXgN^
//========================================================================
SK7PanelCards::SK7PanelCards( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	SetCursolPosition(&tblCardsCursolPos[2]);
	SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN );	
	
	m_sNowAnswer	= CARDS_LOSE;
	
	//vZX	----------------------------------------------
	m_Proc 			= PROC_LOAD;
	m_TexProc 		= LOAD_BG;
	m_cCardSelect 	= (s8)Now;
	m_cSelect		= 2;
	m_iTime			= 0;
	m_bCheckAns		= false;
	
	//	AT[	--------------------------------------------------
	memset( &m_bAnswer, false, sizeof(bool)*CARDS_NUM);

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);

	//	gv	--------------------------------------------------
	for( int i = 0; i < CARDS_NUM; i++ ){
		m_spCards[i].SetXY0		( tblCardsPos[i].x, tblCardsPos[i].y );
	}
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelCards::~SK7PanelCards()
{
	//eNX`	-----------------------------
	m_spBG.Delete();

	for( int i = 0; i < CARDS_NUM; i++ ){
		m_spCards[i].Delete();
	}
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelCards::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_UP ) )
		{
			if( !( m_cSelect == 0 || m_cSelect == 3 ) ) break;
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			if( m_cSelect == 0 )	m_cSelect++;
			if( m_cSelect == 3 )	m_cSelect--;
			SetCursolPosition( &tblCardsCursolPos[m_cSelect] );
			SetCursolDir( CURSOL_DIR_UP,1 );
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) )
		{
			if( !( m_cSelect == 0 || m_cSelect == 3 ) ) break;
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			if( m_cSelect == 0 )		m_cSelect = 5;
			else if( m_cSelect == 3 )	m_cSelect++;
			SetCursolPosition( &tblCardsCursolPos[m_cSelect] );
			SetCursolDir( CURSOL_DIR_DOWN );
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) )
		{
			if( m_cSelect == 0 || m_cSelect == 3 ) break;			
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			if( m_cSelect == 1 || m_cSelect == 2 )	m_cSelect--;
			else if( m_cSelect == 4 )				m_cSelect++;
			else if( m_cSelect == 5 )				m_cSelect = 0;
			SetCursolPosition( &tblCardsCursolPos[m_cSelect] );
			SetCursolDir( CURSOL_DIR_LEFT,1 );
			break;
		}
		if( CheckKeyT( SK7_KEY_RIGHT ) )
		{
			if( m_cSelect == 0 || m_cSelect == 3 ) break;			
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			if( m_cSelect == 5 || m_cSelect == 4 )				m_cSelect--;
			else if( m_cSelect == 2 || m_cSelect == 1 )			m_cSelect++;
			SetCursolPosition( &tblCardsCursolPos[m_cSelect] );
			SetCursolDir( CURSOL_DIR_RIGHT,1 );
			break;
		}		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A )
		{
			gpSound->mPlaySE(SFX_SCE1_PNL_CARDMEKURU);
			if( m_bAnswer[m_cSelect] ){
				m_bAnswer[m_cSelect] = false;
				m_spCards[m_cSelect].SetVisible(false);
				break;
			}
			m_spCards[m_cSelect].SetVisible(true);
			m_bAnswer[m_cSelect] = true;

			int i;
			int num=0;
			int	AnsNum=0;
			bool Clear=true;

			//	ЂԂ
			for( i = 0; i < CARDS_NUM; i++ )
			{
				if( m_bAnswer[i] ){
					num++;
				}
			}
			
			switch( m_cCardSelect )
			{
			case CARDS_BC:	
				if( num >= 3 ){	
					for( i = 0; i < CARDS_NUM; i++ )
					{
						if( tblBaccaAns[AnsNum] == i ){
							if( m_bAnswer[i] ){
								Clear = false;
								break;
							}
							if(++AnsNum >= 3 ){
								break;
							}
						}
					}
					if( Clear )	m_bCheckAns = true;
					else		m_bCheckAns = false;
					m_Proc = PROC_ANS_CHECK;
					break;
				}
				break;
				
			case CARDS_PK:
				if( num >= 1 ){
					if( m_bAnswer[POKER_NOT] )	m_bCheckAns = true;
					else						m_bCheckAns = false;
					m_Proc = PROC_ANS_CHECK;
					break;
				}
				break;
				
			case CARDS_BJ:
				if( num >= 3 ){	
					for( i = 0; i < CARDS_NUM; i++ )
					{
						if( tblBlackAns[AnsNum] == i ){
							if( m_bAnswer[i] ){
								Clear = false;
								break;
							}
							if(++AnsNum >= 3 ){
								break;
							}

						}
					}
					if( Clear )	m_bCheckAns = true;
					else		m_bCheckAns = false;
					m_Proc = PROC_ANS_CHECK;
					break;
				}
				break;
			}
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			SetCursolDisp(false);
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
#if 0
	case	PROC_MOVE_CARDS:
		m_spCards[m_cSelect].SetSTTwo( 	m_spCards[m_cSelect].GetS0(),		m_spCards[m_cSelect].GetT0(),
										m_spCards[m_cSelect].GetS1()+0.1f,	m_spCards[m_cSelect].GetT2() );
		if( m_spCards[m_cSelect].GetS1() <= 0.2f )	m_spCards[m_cSelect].SetVisible(false);
		break;
#endif
	//	킹	-----------------------------------------------------------------
	case	PROC_ANS_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			{		
			//	m_cSelect = 0;
				memset( &m_bAnswer, false, sizeof(bool)*CARDS_NUM );
				for( int i = 0; i < CARDS_NUM; i++ )	m_spCards[i].SetVisible(false);
//				SetCursolPosition( &tblCardsCursolPos[0] );
				gpSound->mPlaySE(SFX_SCE0_PANEL_KEY_GET);
				m_Proc = PROC_SELECT_MAIN;	
			}
			break;
		
		case	PANEL_CHECK_SET:				//	
			if( !m_bCheckAns ){
				gpSound->mPlaySE(SFX_SYS_PNL_MISS);
				SetCursolDisp(false);
				m_Proc = PROC_CANCEL;
			}else{
//				gpSound->mPlaySE(SFX_SYS_TRUE);
				SetCursolDisp(false);
				m_sNowAnswer = CARDS_WIN;
				m_Proc = PROC_TIME;		
			}
			break;
		}
		break;
		
	case 	PROC_TIME:
		if( DrawMessage(0) )
		{
			SetCursolDisp(false);
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	if( m_Proc == PROC_SELECT_MAIN ){
		switch(m_cSelect){
		case 0:
		case 3:
			SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_DOWN, 0 );	
			break;	
		default:
			SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT,0 );	
			break;
		}
	}
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelCards::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	for( int i = 0; i < CARDS_NUM; i++ )
	{
		m_spCards[i].Render();
	}
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelCards::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelCards::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelCards::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelCards::LoadTexData()
{	
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL011402TEX_BG ) )
		{
			m_TexProc = LOAD_CARDS0;
		}
		break;
		
	case	LOAD_CARDS0:
		if( m_spCards[0].LoadTexture( PNL011402TEX_0 ) ){
			m_TexProc = LOAD_CARDS1;
		}
		break;
		
	case	LOAD_CARDS1:
		if( m_spCards[1].LoadTexture( PNL011402TEX_1 ) ){
			m_TexProc = LOAD_CARDS2;
		}
		break;

	case	LOAD_CARDS2:
		if( m_spCards[2].LoadTexture( PNL011402TEX_2 ) ){
			m_TexProc = LOAD_CARDS3;
		}
		break;

	case	LOAD_CARDS3:
		if( m_spCards[3].LoadTexture( PNL011402TEX_3 ) ){
			m_TexProc = LOAD_CARDS4;
		}
		break;

	case	LOAD_CARDS4:
		if( m_spCards[4].LoadTexture( PNL011402TEX_4 ) ){
			m_TexProc = LOAD_CARDS5;
		}
		break;

	case	LOAD_CARDS5:
		if( m_spCards[5].LoadTexture( PNL011402TEX_5 ) ){
			return true;
		}
		break;
	}

#if 0
	case LOAD_CARDS:
		if( m_spCards[0].LoadTexture( PNL011402TEX_CARDS, CARDS_ALL_NUM, 1 ) )
		{
			m_spCards[0].SetXY0		( tblCardsPos[0].x, tblCardsPos[0].y );
			m_spCards[0].SetTexNo	( 0 );
			m_spCards[0].SetFlag	( true, RENDER_FLAG|BLOCK_FLAG );

			for( int i = 1; i < CARDS_NUM; i++ )
			{
				m_spCards[i].SetXY0		( tblCardsPos[i].x, tblCardsPos[i].y );
				m_spCards[i].SetTexture	( m_spCards[0].GetTexture(), CARDS_ALL_NUM, 1 );
				m_spCards[i].SetTexNo	( (u8)i );
				m_spCards[i].SetFlag	( true, RENDER_FLAG|BLOCK_FLAG );
			}
			return true;
		}
	 	break;
	}
#endif
	return false;
}
