////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cards
//
// SK7PanelCards.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELCARDS_H__
#define	__SK7PANELCARDS_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	߂l
#define	CARDS_WIN				(0)		//	NA
#define	CARDS_LOSE				(-1)	//	s


//	eNX`[pX
#define	PNL011402TEX_BG				"Texture/011402/card04_BG.BIN"
#define	PNL011402TEX_0				"Texture/011402/card04_BS00.BIN"
#define	PNL011402TEX_1				"Texture/011402/card04_BS01.BIN"
#define	PNL011402TEX_2				"Texture/011402/card04_BS02.BIN"
#define	PNL011402TEX_3				"Texture/011402/card04_BS03.BIN"
#define	PNL011402TEX_4				"Texture/011402/card04_BS04.BIN"
#define	PNL011402TEX_5				"Texture/011402/card04_BS05.BIN"



#define	CARDS_NUM				(6)
#define	CARDS_SIZE_X			(100)
#define	CARDS_SIZE_Y			(150)
#define	HALF_CARDS_X			(CARDS_SIZE_X*0.5f)
#define	HALF_CARDS_Y			(CARDS_SIZE_Y*0.5f)


//	gv̎
enum
{
	CARDS_BC=0,		//	oJ
	CARDS_PK,		//	|[J[
	CARDS_BJ,		//	ubNWbN
};


enum{
	CARDS_9, 
	CARDS_10,
	CARDS_J,
	CARDS_Q,
	CARDS_K,
	CARDS_A,
	CARDS_REV,
};


//---- class ----
class SK7PanelCards : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_TIME,
		PROC_MOVE_CARDS,
		PROC_ANS_CHECK,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_CARDS0,
		LOAD_CARDS1,
		LOAD_CARDS2,
		LOAD_CARDS3,
		LOAD_CARDS4,
		LOAD_CARDS5,
	}eLoadTexProc;
	
protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spCards[CARDS_NUM];
	
	s8						m_cCardSelect;
	s8						m_cSelect;
	
	int						m_iTime;

	bool					m_bCheckAns;
	bool					m_bAnswer[CARDS_NUM];
	

public:
	SK7PanelCards( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelCards();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELCARDS_H__
