////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel ChinChiro
//
// SK7PanelChinChiro.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELCHINCHIRO_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "../wat/WK7Archive.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7Light.h"
#include "SK7PanelChinChiro.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"


#define		MODEL_DICE		"Texture/011305/dice.dat"//dice_test.dat"//dice2.dat"
#define		MOTION_DICE		"Texture/011305/DIS_0000.dat"

//	Cgݒ 	
static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ -2.000000f, 3.000000f, 5.000000f },		// wobj position
};
static	float	dir_light_shininess = 40.0f;
static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// CgN
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// CgtO
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{0xff,0xff,0xff,0xff},						// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};

#define	SK7CHIN_LIGHT_TYPE		(0xbfffffff)
#define	SK7CHIN_LIGHT_ID		(3)



//========================================================================
//					RXgN^
//========================================================================
SK7PanelChinChiro::SK7PanelChinChiro( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	SetCursolPosition(&(Vec){332,200,0});

	//	Cg쐬	-----------------------------------
	WK7Light::Create(&dir_light,SK7CHIN_LIGHT_TYPE,SK7CHIN_LIGHT_ID);
		
	m_sNowAnswer	= CHINCHIRO_LOSE;
	m_bClear	= false;
	m_iTime		= 0;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	ܑuj󂵂ǂ
	if( Now == CHIN_NORMAL_PLAY ){
		m_bBreakCheck = false;
	}else{
		m_bBreakCheck = true;
	}
	
	//	냂f̍쐬	-------------------------------------------------
	m_pModel = NULL;

	if( NULL != (m_pArchive 	= WK7Archive::Create() ))
	{
		m_pArchive->LoadArchive		( MODEL_DICE 	);
	}
	
	//	냂[V̍쐬	---------------------------------------------
	m_pMotion = NULL;

	if( NULL != (m_pMotionArc 	= WK7Archive::Create()))
	{
		m_pMotionArc->LoadArchive( MOTION_DICE );
	}
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelChinChiro::~SK7PanelChinChiro()
{
	//	ff[^J
	GHM_SAFE_DELETE( m_pModel	);
	GHM_SAFE_DELETE( m_pMotion	);
	
	//eNX`	-----------------------------
	m_spBG.Delete();
	
	WK7Light::Release(SK7CHIN_LIGHT_TYPE,SK7CHIN_LIGHT_ID);
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelChinChiro::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SET_CAMERA;
		}
		break;
		
	case 	PROC_SET_CAMERA:
		//	J̃|WV	-------------------------------------------------
//		WK7CAM->SetPosition			(0.8f,  	6.0f,		-0.025f		);
//		WK7CAM->SetRotation			(-0.14f,-1.047466f,		-0.42f		);
		WK7CAM->SetTargetPosition	(-0.085f,	0.126f,		0.177f		);
		WK7CAM->SetPosition			(-0.085f,  	4.318f,		4.318f		);
		WK7CAM->SetRotation			(0.0f,		0.0f,		0.0f		);
		WK7CAM->SetFov				( 54.43f );
		m_pModel->SetPosition		( 0.0f, 0.0f, 0.0f );
		m_pModel->SetRotation		( 0.0f, 0.0f, 0.0f );
		m_pModel->Hide();
		m_Proc = PROC_PLAY_MOTION;
		break;
		
	case PROC_PLAY_MOTION:
		if( ++m_iTime > WAIT_TIME )
		{
			m_iTime = 0;
			m_bClear = CheckDiceMove();
			m_pModel->Disp();
			m_pModel->PlayMotion(0.0F, true, 20 );
			m_pModel->SetMotionLoop(false);
			m_pModel->GetObj("dice3")->GetObj("dice")->Hide();			
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
//					m_bClear = CheckDiceMove();

#if 1
		if( ++m_iTime == 10 ){
			gpSound->mPlaySE(SFX_SCE1_PNL_DICE);
		}

		if( m_pModel->GetMotionState() == WK7MODEL_NOANIM )
		{
			SetCursolDisp( true );
			m_iTime = 0;
			if( m_bClear ){
				m_Proc = PROC_CLEAR;
				break;
			}else{
				switch( CheckAnswer() )
				{
				case	PANEL_CHECK_RETURN:				//߂
					
					RunPanelCursorOkCancelSelect( m_pEffectCursol );		
					SetCursolDisp( false );
					m_Proc = PROC_CANCEL;
					break;
		
				case	PANEL_CHECK_SET:				//gC
					m_pEffectCursol     = CreatePanelCursorEffect( 332,200 );
					m_EffectID = GetEffectID( m_pEffectCursol );
					RunPanelCursorOkCancelSelect( m_pEffectCursol );		
					SetCursolSize( 64, 64 );
					gpSound->mPlaySE(SFX_SCE0_PANEL_KEY_GET);
					gpSound->mPlaySE( SFX_SYS_PNL_OK );
					m_pModel->SetPosition		( 0.0f, 0.0f, 0.0f );
					m_pModel->SetRotation		( 0.0f, 0.0f, 0.0f );
//					m_pModel->Hide();
					m_iTime = WAIT_TIME-2;
					m_Proc = PROC_PLAY_MOTION;
					break;
				}
			}
		}
#endif
		break;
		
	case 	PROC_CLEAR:
		if( m_pModel->GetMotionState() == WK7MODEL_NOANIM )
		{
			SetCursolDisp( false );
//			gpSound->mPlaySE(SFX_SYS_TRUE);
//			m_pEffect = CreateMessage2Effect( m_cJmbHandle, 66, TRUE );
			m_Proc = PROC_CLEAR2;
		}
		break;
	
	case 	PROC_CLEAR2:
		if( DrawMessage( 0 ) )
		{
			SetCursolDisp( false );
			m_sNowAnswer = CHINCHIRO_WIN;
			m_Proc = PROC_CANCEL;
		}

		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	//	듮	----------------------------------------------------
	if( m_pModel != NULL ){
		m_pModel->FrameProcess();
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelChinChiro::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	// JgJݒ
	if(WK7CAM->SetCurrent()==true )
	{
		WK7Light::DispStart();
		WK7Light::DispAll();
		WK7Light::DispEnd();
		
		if( m_pModel	!= NULL ){
			m_pModel->RenderProcess();
		}
		WK7CAM->RenderProcess();

		// JgJł̕`I
		WK7CAM->EndCurrent();
	}	
			
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelChinChiro::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelChinChiro::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelChinChiro::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool		SK7PanelChinChiro::CheckDiceMove()
{
	const char* tblDiceName[]={ "dice1", "dice2", "dice3" };
	const char* strDice = "dice";
	
	int No = 0;
	int SaveNo[DICE_NUM]={0,0};

#if 0
	static Vec vDiceRot={0.0f,0.0f,0.0f};
	static int DiceNo = 0;
	
	if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP ){
		vDiceRot.x += MTXDegToRad(90);
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN ){
		vDiceRot.x -= MTXDegToRad(90);
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_RIGHT ){
		if( ++DiceNo >= 2){	DiceNo = 2; }
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_LEFT ){
		if( --DiceNo <= 0 ){ DiceNo = 0; }
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_UP ){
		vDiceRot.y += MTXDegToRad(90);
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_DOWN ){
		vDiceRot.y -= MTXDegToRad(90);
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_RIGHT ){
		vDiceRot.z += MTXDegToRad(90);
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_LEFT ){
		vDiceRot.z += MTXDegToRad(90);
	}
	GHM_LIMIT_RANGE(vDiceRot.x, PI, -PI);
	GHM_LIMIT_RANGE(vDiceRot.y, PI, -PI);
	GHM_LIMIT_RANGE(vDiceRot.z, PI, -PI);
	
	m_pModel->GetObj(tblDiceName[DiceNo])->GetObj(strDice)->SetRotation( vDiceRot.x, vDiceRot.y, vDiceRot.z );
//	m_pModel->GetObj(tblDiceName[1])->GetObj(strDice)->SetRotation( 0.0f, 1.0f, 0.0f );	
//	m_pModel->GetObj(tblDiceName[2])->GetObj(strDice)->SetRotation( 0.0f, 0.0f, 0.0f );
#endif
	for( int i = 0; i < DICE_NUM; i++ )
	{
//		No = rand() % 6;
		No = rand()*(5+1)/RAND_MAX%(5+1);
		SaveNo[i]=No;
		
		if( !m_bBreakCheck )
		{
			if( SaveNo[0] == 0 && SaveNo[1] == 0 ){
//				No = rand() % 5 + 1;
				No = rand()*(4+1)/RAND_MAX%(4+1)+1;
				SaveNo[1]=No;
			}
		}
		else
		{
			if( SaveNo[0] == 0 )//&& SaveNo[1] < 4 )
			{
				SaveNo[1] = 0;
				No = 0;
			}
		}
		switch( No )
		{
		case 0:
			if( i == 0 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( 1.57f, 0.0f, -1.57f );	
				break;
			}
			if( i == 1 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( -1.57f, 0.0f, -1.57f );	
				break;
			}
			break;//
		case 1:
			if( i == 0 ){				
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( 0.0f, -PI, 0.0f ); 		
				break;
			}
			if( i == 1 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( 0.0f, 0.0f, 0.0f ); 	
				break;
			}
			break;//
		case 2:
			if( i == 0 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( 0.0f, 1.57f, -1.57f ); 
				break;
			}
			if( i == 1 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( -1.57f, -1.57f, PI ); 	
				break;
			}
			break;//
		case 3:
			if( i == 0 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( 0.0f, -1.57f, -1.57f ); 
				break;
			}
			if( i == 1 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( -1.57f, 1.57f, 1.57f ); 
				break;
			}
			break;//
		case 4:
			if( i == 0 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( 0.0f, 0.0f, -1.57f );
				break;
			}
			if( i == 1 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( 0.0f, PI, 1.57f );  
				break;
			}
			break;
		case 5:
			if( i == 0 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( 1.57f, -PI, 0.0f );
				break;
			}
			if( i == 1 ){
				m_pModel->GetObj(tblDiceName[i])->GetObj(strDice)->SetRotation( -1.57f, PI, 0.0f);//1.57f );
				break;
			}
			break;//
		}
	}
	if( SaveNo[0] == 0 && SaveNo[1] == 0 ){
		return true;
	}
	else{
		return false;
	}
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelChinChiro::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL011305TEX_BG ) )
		{
			m_TexProc = LOAD_MODEL0;
		}
		break;
		
	case LOAD_MODEL0:
		if( m_pArchive->GetState() != WK7Archive::WK7ARCHIVE_LOADED )	break;

		//	ff[^̍쐬
		if( (m_pModel = m_pArchive->CreateModel()) != NULL )
		{
			m_TexProc = LOAD_MOTION0;
		}
		break;

	case LOAD_MOTION0:
		if( m_pMotionArc->GetState() != WK7Archive::WK7ARCHIVE_LOADED )	break;

		if( (m_pMotion = m_pMotionArc->CreateModelMotion()) != NULL )
		{
			if( m_pMotion->GetAnimJoint( m_pModel->GetObj(0)->GetName(), &m_pAnim ) == false ){
				m_pAnim = NULL ;
			}else{
				m_pModel->AttachMotion( m_pMotion );
				return true;
			}
		}
		break;
	}
	return false;
}