////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel ChinChiro
//
// SK7PanelChinChiro.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELCHINCHIRO_H__
#define	__SK7PANELCHINCHIRO_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"
#include "../wat/WK7Model.h"


//	
#define	CHIN_NORMAL_PLAY			(-1)
#define	CHIN_BREAK_PLAY				(0)

//	߂l
#define	CHINCHIRO_WIN				(1)	//	NA
#define	CHINCHIRO_LOSE				(0)	//	s
#define	CHINCHIRO_CANCEL			(-1)

#define	DICE_NUM					(2)

#define	WAIT_TIME					(10)

//	eNX`[pX
#define	PNL011305TEX_BG				"Texture/011305/tin4_BG.BIN"


//---- class ----
class SK7PanelChinChiro : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SET_CAMERA,
		PROC_PLAY_MOTION,
		PROC_SELECT_MAIN,
		PROC_CLEAR,
		PROC_CLEAR2,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		
		LOAD_BG,
		LOAD_MODEL0,
		LOAD_MODEL1,
		LOAD_MODEL2,
		LOAD_MOTION0,
		LOAD_MOTION1,
		LOAD_MOTION2,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	WK7Model*				m_pModel;							
	WK7Archive*				m_pArchive;							
	WK7Archive*				m_pMotionArc;		//	A[JCuNX
	WK7ModelMotion* 		m_pMotion;
	HSD_AnimJoint*			m_pAnim;

	int						m_iTime;
	bool					m_bBreakCheck;
	bool					m_bClear;

public:
	SK7PanelChinChiro( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelChinChiro();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	bool	CheckDiceMove();
};

#endif	//__SK7PANELCHINCHIRO_H__
