////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cook
//
// SK7PanelCook.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELCOOK_H__
#define	__SK7PANELCOOK_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	߂l
#define		UTUWA_NO_ONE		(0)		//	O
#define		UTUWA_NO_TWO		(1)		//	P
#define		UTUWA_NO_THREE		(2)		//	Q
#define		UTUWA_NO_FOUR		(3)		//	R	
#define		UTUWA_NO_FIVE		(4)		//	S	II
#define		UTUWA_NO_SIX		(5)		//	T


//	eNX`[pX
#define		PNL000107TEX_BG		"Texture/010701/utsuwa_BG.BIN"
#define		PNL000107TEX_U1		"Texture/010701/u1.BIN"
#define		PNL000107TEX_U2		"Texture/010701/u2.BIN"
#define		PNL000107TEX_U3		"Texture/010701/u3.BIN"
#define		PNL000107TEX_U4		"Texture/010701/u4.BIN"
#define		PNL000107TEX_U5		"Texture/010701/u5.BIN"
#define		PNL000107TEX_U6		"Texture/010701/u6.BIN"


#define		UTUWA_NUM			(6)

#define		UTUWA_SIGHT_X		(146)
#define		UTUWA_SIGHT_Y		(79)

#define		RENDER_TIME			(40)

//---- class ----
class SK7PanelCook : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_NOTRENDER,
		PROC_TIME,
		PROC_MESSAGE,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_CURSOL = 0,
		LOAD_BG,
		LOAD_U1,
		LOAD_U2,
		LOAD_U3,
		LOAD_U4,
		LOAD_U5,
		LOAD_U6,
	}eLoadTexProc;

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spUtuwa[UTUWA_NUM];

	u8						m_ucSelectNo;
	Vec						m_vSightPos;
	u32						m_lRenderTime;

public:
	SK7PanelCook( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelCook();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
};

#endif	//__SK7PANELCOOK_H__
