////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cook
//
// SK7PanelCook2.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELCOOK2_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelCook2.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../Yam/YK7EffectMessage2.h"
#include "../matsu/mK7Sound.h"



//========================================================================
//					RXgN^
//========================================================================
SK7PanelCook2::SK7PanelCook2( s32 Now ) : SK7PanelBase( Now )
{
	m_lMoveTime = 0;
	m_lTime = 0;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;
	
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	̃XvCg
	m_spOwan.SetXY0(350,157);
	
	//	GtFNg
	m_spEffect.SetXYTwo(EFFECT_X,EFFECT_Y,EFFECT_X+EFFECT_SIZE,EFFECT_Y+EFFECT_SIZE);
	m_spEffect.SetFlag( true, VTX4_FLAG );
	
	m_spEffect2.SetXYTwo(EFFECT_X,EFFECT_Y,EFFECT_X+EFFECT_SIZE,EFFECT_Y+EFFECT_SIZE);
	m_spEffect2.SetFlag( true, VTX4_FLAG );
	
	if( Now == ANSWER_OWAN )
	{
		m_bAnswer = true;
		m_spOwan.SetVisible(true);
		m_spEffect.SetVisible(true);
		m_spEffect2.SetVisible(true);
		m_bFirst = false;
	}
	else
	{
		if( Now == -1 )		m_bFirst = true;
		else				m_bFirst = false;
		m_bAnswer = false;
		m_spOwan.SetVisible(false);
		m_spEffect.SetVisible(false);
		m_spEffect2.SetVisible(false);
	}
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelCook2::~SK7PanelCook2()
{
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spOwan.Delete();
	m_spEffect.Delete();
	m_spEffect2.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelCook2::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_FIRST_TIME;
		}
		break;
		
	case	PROC_FIRST_TIME:
		if( ++m_lTime > 30 )
		{
			m_lTime = 0;
			if( m_bAnswer )	
			{
				m_Proc = PROC_SELECT_MAIN;
			}
			else
			{
				if( m_bFirst )
				{
					m_Proc = PROC_FIRST_NAME;
				}
				else
				{	
					gpSound->mPlaySE(SFX_SYS_PNL_MISS);
					m_Proc = PROC_MISS_NAME;
				}
			}
		}
		break;
		
	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( MoveEffect() )
		{
//			gpSound->mPlaySE(SFX_SYS_TRUE);
			m_Proc = PROC_MESSAGE;
		}
		break;
	
	//	t@[Xgl[	--------------------------------------
	case	PROC_FIRST_NAME:
		if( DrawMessage(3) )
		{
			m_Proc = PROC_CANCEL;
		}
		break;

	//	~X	-------------------------------------------------
	case	PROC_MISS_NAME:
		if( DrawMessage(2) )
		{
			m_Proc = PROC_CANCEL;			
		}
		break;
		
	case PROC_TIME:
		if( ++m_lTime > 80 )
		{
			m_lTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
		
	case PROC_MESSAGE:
		if( DrawMessage(0) ){
			m_Proc = PROC_MESSAGE2;
		}
		break;
		
	case PROC_MESSAGE2:
		if( DrawMessage(1) ){
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelCook2::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spEffect2.Render();
	m_spEffect.Render();
	m_spOwan.Render();
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelCook2::mGetFileReadEnd(void)
{
	if( m_Proc >= PROC_SELECT_MAIN )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelCook2::mGetSelectEnd(void)
{
	if((m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelCook2::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return m_bAnswer;
		
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// GtFNg̈ړ
//========================================================================
bool	SK7PanelCook2::MoveEffect()
{
	f32 X = m_spEffect2.GetX0();
	f32 Y = m_spEffect2.GetY0();
	f32 X2 = m_spEffect2.GetX1();
	f32 Y2 = m_spEffect2.GetY2();
	
	if( m_lMoveTime < MOVE_TIME )
	{
		X	-=	MOVE_SPEED;
		Y	-=	MOVE_SPEED;
		X2	+=	MOVE_SPEED;
		Y2	+=	MOVE_SPEED;
	}
	else
	if( m_lMoveTime < MOVE_TIME*2 )
	{
		X	+=	MOVE_SPEED;
		Y	+=	MOVE_SPEED;
		X2	-=	MOVE_SPEED;
		Y2	-=	MOVE_SPEED;
	}
	
	m_lMoveTime++;
	
	if( m_lMoveTime > 3 )	m_spEffect2.SetColor( 0xFFFFFFC8 );
	m_spEffect2.SetXYTwo( X, Y, X2, Y2 );
	
	if( m_lMoveTime == MOVE_TIME*2 )
	{
		m_lMoveTime = 0;
		return true;
	}
	return false;
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelCook2::LoadTexData()
{
	switch( m_TexProc ) 
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL010700TEX_BG ) )
		{
			m_TexProc = LOAD_EFFECT;
		}
		break;
	case 	LOAD_EFFECT:
		if( m_spEffect.LoadTexture( PNL010700TEX_EFFECT ) )
		{
			m_TexProc = LOAD_EFFECT2;
		}
		break;
	case 	LOAD_EFFECT2:
		if( m_spEffect2.LoadTexture( PNL010700TEX_EFFECT2 ))
		{
			m_TexProc = LOAD_OWAN;
		}
		break;
	case 	LOAD_OWAN:	//	wi
		if( m_spOwan.LoadTexture( PNL010700TEX_OWAN ) )
		{
			return true;
		}
		break;
	}
	return false;
}

