////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Darts
//
// SK7PanelDarts.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELDARTS_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelDarts.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"



//========================================================================
//					RXgN^
//========================================================================
SK7PanelDarts::SK7PanelDarts( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	SetCursolPosition( &(Vec){420,358,0} );

	m_sNowAnswer = ( Now >= CLEAR_POINT ) ? (s8)DARTS_CLEAR : (s8)DARTS_MISS;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);	
	
	//	mnW	---------------------------------------------------
	const VEC2 tblNoPos[]={
		392,343,
		410,343,
		429,343,
	};

	int num[NO_NUM];
	num[0] = (Now/100);
	num[1] = (Now/10)%10;
	num[2] = (Now%10);
	for( int i = 0; i < NO_NUM; i++ )
	{
		m_spNo[i].SetXY0( tblNoPos[i].x, tblNoPos[i].y );
		m_spNo[i].SetFlag( true, BLOCK_FLAG|RENDER_FLAG );
		m_spNo[i].SetTexNo( (u8)num[i] );
	}
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelDarts::~SK7PanelDarts()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spNo[0].Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelDarts::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			SetCursolDisp( false );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B|HSD_PAD_Y|HSD_PAD_X) ){
			m_Proc = PROC_CANCEL;
		}
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelDarts::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	for( int i = 0; i < NO_NUM; i++ ){
		m_spNo[i].Render();
	}
			
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelDarts::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelDarts::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelDarts::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelDarts::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL000401TEX_BG ) )
		{
			m_TexProc = LOAD_NO;
		}
		break;
	
	case LOAD_NO:
		if( m_spNo[0].LoadTexture( PNL000401TEX_NO, 10, 1 ) )
		{
			m_spNo[1].SetTexture( m_spNo[0].GetTexture(), 10, 1 );
			m_spNo[2].SetTexture( m_spNo[0].GetTexture(), 10, 1 ); 
			return true;;
		}
	 	break;
	 
	}
	return false;
}