////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelDoncho.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELDONCHO_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelDoncho.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

//	eNX`[pX
#define	PNL055300TEX_BG				"Texture/055300/EVENT_055300_base.BIN"
#define	PNL055300TEX_SWITCH			"Texture/055300/EVENT_055300_lump.BIN"

//========================================================================
//					RXgN^
//========================================================================
SK7PanelDoncho::SK7PanelDoncho( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= DONCHO_CANCEL;
		
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);

	m_iTime = 0;
	
	m_spLamp.SetXY0		( 284, 124 );
	m_spLamp.SetTexNo	( 0 );
	m_spLamp.SetFlag	( true, BLOCK_FLAG );

	m_spSwitch.SetXY0	( 284, 270 );
	m_spSwitch.SetTexNo	( 1 );	
	m_spSwitch.SetFlag	( true, BLOCK_FLAG );
	
	SetCursolPosition( &(Vec){320.0f, 305.0f, 0.0f} );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelDoncho::~SK7PanelDoncho()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	
	m_spSwitch.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelDoncho::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			m_Proc = PROC_CHECK;
			break;
		}
#if 0
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_Proc = PROC_CANCEL;
			break;
		}		
#endif
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			SetCursolDisp( false );
			gpSound->mPlaySE(SFX_SYS_PNL_OK);
			gpSound->mPlaySE(SFX_SYS_PNL_SWITCHDENSHI);
			m_sNowAnswer = DONCHO_ON;
			m_spLamp.SetVisible(true);
			m_spSwitch.SetVisible(true);
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case PROC_TIME:
		if( ++m_iTime > 20 ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
#if 0		
	//	bZ[W	
	case	PROC_MESSAGE:
		if( DrawMessage(m_chSelect) ){
			m_Proc = PROC_CANCEL;
		}
		break;
	//	|X^[
	case	PROC_END:
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
			m_Proc = PROC_CANCEL;
		}
		break;
#endif
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelDoncho::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
		
	m_spLamp.Render();
	m_spSwitch.Render();
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelDoncho::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelDoncho::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelDoncho::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelDoncho::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL055300TEX_BG ) ){
			m_TexProc = LOAD_SWITCH;
		}
		break;
	case 	LOAD_SWITCH:	//	XCb`
		if( m_spSwitch.LoadTexture( PNL055300TEX_SWITCH, 2, 1 ) ){
			m_spLamp.SetTexture( m_spSwitch.GetTexture(), 2, 1 );
			return true;
		}
		break;
	}
	return false;
}