////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelEnd.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELEND_CPP__
//#define	__DEBUG_END__

#include "SK7PanelEnd.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/K7GlobalFlag.h"
#include "../wat/WK7EventScript.h"
#include "../wat/WK7GameInfo.h"
#include "../yam/YK7EffectNoise.h"
#include "../wat/WK7Cam.h"


#define	END_PACK_DATA			"/Texture/panel/060000.pak"
#define	FONT_COLOR(A)			(0xff000000+A)
#define	FONT_SIZE				(200.0f)
#define	FONT_FIRST_SIZE			(60.0f)
#define	FONT_FRAME				(120)
#define	PLUS_FRAME				(30)					//888777666555444
#define	FONT_MAX_FRAME			(FONT_FRAME+PLUS_FRAME)
#define	ANGLE_MAX				(1080.0f)
#define	ANGLE_SPEED				(ANGLE_MAX/FONT_FRAME)
#define	EX_SPEED				((FONT_SIZE-FONT_FIRST_SIZE)/FONT_MAX_FRAME)
#define	KASAN_START_TIME		(5)
#define	KASAN_MAX_TIME			(1)//10)
#define	KASAN_END_TIME			(25)
#define	KASAN_ADD_SPEED			(0.2f)
#define	FADE_SPEED				(WK7_SEC_TO_TICK(2))
#define	DRAW_TIME				(90)
#define	WAIT_TIME				(30)

const int	tblWaitTime[]={180,160,180,160,90,90,150};
const VEC2 tblBGPos[]={
	0,0,
	0,0,
	0,0,
	0,0,
	83,159,
	83,159,
	64,176,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelEnd::SK7PanelEnd( s32 Now ) : SK7PanelBase( Now, -1, false  )
{
	if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 ) ){
		m_chTexNo		= TEX_060000_SUDA2;
	}else{
		m_chTexNo		= TEX_060000_SUDA;
	}
	m_bFade			= false;
	m_pEffect		= NULL;
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_iTime			= 0;
	m_chLoad		= LOAD_PACK_DATA;
	SetCursolDisp( false );
	k7app.SetFadeColor(0x00000000);
	k7app.FadeStart(0x00,0);
	K7SCR_RESET_GLOBAL_FLAG( K7GLFL_SCENARIO_CLEAR );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelEnd::~SK7PanelEnd()
{
	DeleteEffect( m_pEffect );
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelEnd::FrameProcess(void)
{
	switch( m_Proc ){
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			m_spBG.SetTexSprite( tblBGPos[m_chTexNo].x, tblBGPos[m_chTexNo].y, &m_pTexture[m_chTexNo] );
			m_spBlack.SetVisible( true );
			m_spBG.SetVisible( true );
			m_Proc = PROC_DRAW;
		}
		break;
		
	case 	PROC_DRAW:
		if( !m_bCtrl )	return 0;

		if( k7app.IsFade() ) break;
		if( ++m_iTime > tblWaitTime[m_chTexNo] ){
			m_iTime = 0;
			if( (m_chTexNo >= TEX_060000_THE && K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false) ||
				(m_chTexNo >= TEX_060000_THE2 && K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==true ) )
			{
				if( m_chTexNo == TEX_060000_CAPCOM )	k7app.FadeStart(0xff,FADE_SPEED*3);
				else									k7app.FadeStart(0xff,FADE_SPEED);
				m_Proc = PROC_FADE;
				break;
			}
			m_pEffect = CreateNoiseEffect();
			SetEffectCamera( WK7CAM->GetCObj() );
			AddNoiseLine( m_pEffect, (u8)VParam[ED_CHARCHANGE][3], VParam[ED_CHARCHANGE][4], VParam[ED_CHARCHANGE][5], VParam[ED_CHARCHANGE][6], -1 ) ;
			gpSound->mPlaySE( SFX_SYS_SCENARIO_TITLE_NOIZ );
			m_chTexNo++;
			m_spBG.SetTexSprite( tblBGPos[m_chTexNo].x, tblBGPos[m_chTexNo].y, &m_pTexture[m_chTexNo] );
			m_Proc = PROC_NOISE;
		}
		break;

	case PROC_NOISE:
		if( GetNoiseLineNum( m_pEffect ) == 0 ){
			DeleteEffect( m_pEffect );
			m_Proc = PROC_DRAW;
		}
		break;
		
	case	PROC_FADE:
		if( k7app.IsFade() ) break;
		if( m_chTexNo == TEX_060000_CAPCOM ){
			m_Proc = PROC_CANCEL;
			break;
		}
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && m_chTexNo == TEX_060000_THE ){
			m_chTexNo += 3;
		}else{
			m_chTexNo++;
		}
//		if( m_chTexNo == TEX_060000_SASAGU ) 	m_spMei.SetVisible( true );
//		else									m_spMei.SetVisible( false );
		m_spBG.SetTexSprite( tblBGPos[m_chTexNo].x, tblBGPos[m_chTexNo].y, &m_pTexture[m_chTexNo] );
		k7app.FadeStart(0,FADE_SPEED);
		m_Proc = PROC_DRAW;
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelEnd::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	m_spBlack.Render();
	m_spBG.Render();
//	m_spMei.Render();
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelEnd::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD ){
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelEnd::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) ){
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelEnd::mGetResult(void)
{
	if( mGetSelectEnd() == false ){
		return( PANEL_WORKING );
	}

	switch( m_Proc ){
	case	PROC_CANCEL:
		return (s32)m_sNowAnswer;
		break;
		
	default:
		break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelEnd::LoadTexData()
{
	switch( m_chLoad ){
	case LOAD_PACK_DATA:
		if( LoadPackData( END_PACK_DATA, TEX_060000_MAX )){
			
			m_spBlack.SetSprite		( 0, 0, 640, 480, 0x000000ff );
			m_spBlack.SetVisible	( false );
			
//			m_spMei.SetTexSprite	( 342,315, &m_pTexture[TEX_060000_MEI] );
//			m_spMei.SetVisible		( false );
			m_chLoad = LOAD_EFFECT;
		}
		break;
	case LOAD_EFFECT:
		if( EffectSetupCheck() == TRUE ){
			return true;
		}
		break;
	}
	return false;
}

