////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Gum
//
// SK7PanelGum.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELGUM_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelGum.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"

#define		DIAL_SIZE_X			(128)
#define		DIAL_SIZE_Y			(64)
#define		HALF_SIZE_X			(64)
#define		HALF_SIZE_Y			(32)
#define		DIAL_POS_X			(256)
#define		DIAL_POS_Y			(285)
#define		DIAL_CENTER_X		(256+64)
#define		DIAL_CENTER_Y		(285+32)
#define		MOVE_SPEED			(8)//(4)
#define		GUM_SIZE			(32)
#define		GUM_POS_X			(312)
#define		GUM_POS_Y			(320)
#define		GUM_MOVE_TIME		(10)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelGum::SK7PanelGum( s32 Now, s32 Now2 ) : SK7PanelBase( Now, Now2 )
{
	//	TCg	----------------------------------------------
	SetCursolPosition( &(Vec){319,317,0});

	m_sNowAnswer 	= GUM_NORMAL_ANS;
	m_cCheck 		= (s8)Now;
	m_cGumNo 		= (u8)Now2;
	m_iMoveTime	 	= 0;
	m_fAngle 		= 0;
	m_fSpeed		= 0;
	m_fSize			= 10;
	m_GumProc		= 0;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	_CA
	m_spDial.SetXYTwo( DIAL_POS_X, DIAL_POS_Y, DIAL_POS_X+DIAL_SIZE_X, DIAL_POS_Y+DIAL_SIZE_Y );
	m_spDial.SetFlag( true, RENDER_FLAG|VTX4_FLAG );
	
	//	K
	m_spGum.SetXYTwo( GUM_POS_X, GUM_POS_Y, GUM_POS_X + m_fSize, GUM_POS_Y + m_fSize );
	m_spGum.SetFlag( true, RENDER_FLAG|BLOCK_FLAG|VTX4_FLAG );
	if( Now == GUM_GOLD_ANS ){
		m_spGum.SetTexNo((u8)5);
	}else{
		int no = rand()%5;
		if( no == 0 )	no = 1;
		m_spGum.SetTexNo( (u8)no );
	}
	
	//	o
	m_spBack.SetXY0( 287.0f, 367.0f );
	m_spBack.SetFlag( true, RENDER_FLAG );
	
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelGum::~SK7PanelGum()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spGum.Delete();
	m_spDial.Delete();
	m_spBack.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelGum::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A )
		{
			gpSound->mPlaySE(SFX_SCE3_PNL_GUM_HINERU);
			m_fSpeed = (50.0f/GUM_MOVE_TIME);
			m_Proc = PROC_MOVE_DIAL;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			m_sNowAnswer = GUM_CANCEL;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		
		break;
		
	//	_CA
	case	PROC_MOVE_DIAL:
		if( MoveDial() ){
			m_Proc = PROC_MOVE_GUM;
		}
		break;
		
	case	PROC_MOVE_GUM:
		if( MoveGum() ){
#if 0
			if( m_cCheck == GUM_GOLD_ANS ){ 
				m_pEffect = CreateMessage2Effect( m_cJmbHandle, 89, TRUE );
			}else{
				m_pEffect = CreateMessage2Effect( m_cJmbHandle, 88, TRUE );
			}
#endif
			m_Proc = PROC_TIME;
		}
		break;
		
	//	܂
	case	PROC_TIME:
		if( m_cCheck == GUM_GOLD_ANS ){
			if( DrawMessage(1) ){
				SetCursolDisp( false );
				m_sNowAnswer = (s32)m_cCheck;
				m_Proc = PROC_CANCEL;
			}
		}else{
			if( DrawMessage(0) ){
				SetCursolDisp( false );
				m_sNowAnswer = (s32)m_cCheck;
				m_Proc = PROC_CANCEL;
			}
		}
#if 0
		if( !GetEffectValidState( m_pEffect )){
		}
#endif
		break;
			
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelGum::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBack.Render();
	m_spGum.Render();	
	m_spBG.Render();					//	wi
	m_spDial.Render();
	
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelGum::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelGum::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelGum::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}

	
//========================================================================
// _CÄړ
//========================================================================
bool	SK7PanelGum::MoveDial()
{
	m_fAngle -= MOVE_SPEED+4*((180-(180+m_fAngle))/180.0f);
		
	Mtx m;
	MTXRotDeg( m, 'z', m_fAngle );

	Vec v={-HALF_SIZE_X,-HALF_SIZE_Y,0};
	MTXMultVec( m, &v, &v );
	m_spDial.SetXY0( DIAL_CENTER_X+v.x , DIAL_CENTER_Y+v.y );

	v.x = HALF_SIZE_X; v.y = -HALF_SIZE_Y;
	MTXMultVec( m, &v, &v );
	m_spDial.SetXY1( DIAL_CENTER_X+v.x , DIAL_CENTER_Y+v.y );

	v.x = -HALF_SIZE_X; v.y = HALF_SIZE_Y;
	MTXMultVec( m, &v, &v );
	m_spDial.SetXY2( DIAL_CENTER_X+v.x, DIAL_CENTER_Y+v.y );

	v.x = HALF_SIZE_X; v.y = HALF_SIZE_Y;
	MTXMultVec( m, &v, &v );
	m_spDial.SetXY3( DIAL_CENTER_X+v.x, DIAL_CENTER_Y+v.y );
	
	if( m_fAngle < -180 )	return true;
	return false;
}

//========================================================================
// K̈ړ
//========================================================================
bool	SK7PanelGum::MoveGum()
{
	m_spGum.SetXYTwo( GUM_POS_X, m_spGum.GetY0() + m_fSpeed, GUM_POS_X + m_fSize, m_spGum.GetY0() + m_fSize + m_fSpeed ); 
	switch( m_GumProc ){
	case 0:
		if( ++m_iMoveTime > GUM_MOVE_TIME ){
			m_iMoveTime = 0;
			m_fSpeed = 20/GUM_MOVE_TIME;
			m_GumProc = 1;
		}
		break;
	case 1:
		m_fSize += 20/GUM_MOVE_TIME;
		m_iMoveTime++;
		
		if( m_iMoveTime == 4 ){
			gpSound->mPlaySE(SFX_SCE3_PNL_GUM_DERU);
		}
		if( m_iMoveTime > GUM_MOVE_TIME ){
			return true;
		}
		break;
	}
	return false;
}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelGum::LoadTexData()
{
	switch( m_TexProc )
	{
	
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( tblGumTexture[m_cGumNo])){
			m_TexProc = LOAD_DIAL;
		}
		break;
	case	LOAD_DIAL:
		if( m_spDial.LoadTexture( PNL030201TEX_DIAL )){
			m_TexProc = LOAD_EXIT;
		}
		break;
	case	LOAD_EXIT:
		if( m_spBack.LoadTexture( PNL030201TEX_EXIT )){
			m_TexProc = LOAD_GUM;
		}	
		break;
		
	case	LOAD_GUM:
		if( m_spGum.LoadTexture( PNL030201TEX_GUM, 8, 1 )){
			return true;
		}
		break;
	}
	return false;
}