////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Gum
//
// SK7PanelGum.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELGUM_H__
#define	__SK7PANELGUM_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	ƕԂlłB̂܂܂܂B
#define	GUM_GOLD_ANS				(1)		//	NA
#define	GUM_NORMAL_ANS				(0)	//	~X
#define	GUM_CANCEL					(-1)


//	eNX`[pX
#define	PNL030201TEX_DIAL			"Texture/030201/Dial.BIN"
#define	PNL030201TEX_GUM			"Texture/030201/Ball.BIN"
#define	PNL030201TEX_EXIT			"Texture/030201/EXIT.BIN"


//	K̎
enum{
	GUM_PHOENIX,
	GUM_COWGIRL,
	GUM_BIKE,
	GUM_GUN,
	GUM_MISSILE,
};

//	KBG
static char* tblGumTexture[]=
{
	"Texture/030201/E_030201.BIN",	
	"Texture/030201/E_030202.BIN",
	"Texture/030201/E_030203.BIN",
	"Texture/030201/E_030204.BIN",
	"Texture/030201/E_030205.BIN",
};


//---- class ----
class SK7PanelGum : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_MOVE_DIAL,
		PROC_MOVE_GUM,
		PROC_CANCEL,
		PROC_TIME,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{		
		LOAD_BG,
		LOAD_DIAL,
		LOAD_EXIT,
		LOAD_GUM,
	}eLoadTexProc;

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spGum;
	SK7Sprite				m_spDial;
	SK7Sprite				m_spBack;
	
	f32						m_fAngle;
	s8						m_cCheck;
	u8						m_cGumNo;
	int						m_iMoveTime;
	f32						m_fSpeed;
	f32						m_fSize;
	u8						m_GumProc;
	
public:
	SK7PanelGum( s32 Now=PANEL_INIT_ARRANGE, s32 Now2=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelGum();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	bool	MoveDial();
	bool	MoveGum();
	
};

#endif	//__SK7PANELGUM_H__
