////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Nine
//
// SK7PanelHotelElevator.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELHOTELELEVATOR_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelHotelElevator.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


#define	HOTELELE_PACK_DATA	"/Texture/panel/050103.pak"
#define	ELE_BUTTON_SIZE		(38)

const VEC2 tblElePos[]={
	234.1875f,360.25f,	
	323.5f,315.1875f,
	234.125f,272.5f,
	323.5625f,226,
	234.5f,183.4375f,
	323.25f,137.0625f,
	234.375f,94.5f,		
	323.375f,47.4375f,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelHotelElevator::SK7PanelHotelElevator( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= Now;
	m_chSelect	= (s8)Now;
	m_iTime		 = 0;

	SetCursolPosition( &(Vec){tblElePos[Now].x+ELE_BUTTON_SIZE,tblElePos[Now].y+ELE_BUTTON_SIZE,0} );
	SetCursolDir( CURSOL_DIR_RIGHT );
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelHotelElevator::~SK7PanelHotelElevator()
{ 
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelHotelElevator::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
#if 0
		DEBUG_GET_2D_POS( m_spSwitch );
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			m_chSelect++;
			m_spSwitch.SetTexture( &m_pTexture[ELEVATOR_HOTEL1F+m_chSelect] );
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			m_chSelect--;
			m_spSwitch.SetTexture( &m_pTexture[ELEVATOR_HOTEL1F+m_chSelect] );
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_X ){
			if( m_spSwitch.CheckFlag( RENDER_FLAG ) ){
				m_spSwitch.SetVisible( false );
			}else{
				m_spSwitch.SetVisible( true );
			}
		}
#else
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( m_sNowAnswer ==  m_chSelect )	return true;
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			m_sNowAnswer = ELEHOTLE_CANCEL;
			gpSound->mPlaySE(SFX_SYS_PNL_CANCEL);
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( ++m_chSelect > 6 ){
				m_chSelect = 6;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &(Vec){tblElePos[m_chSelect].x+ELE_BUTTON_SIZE,tblElePos[m_chSelect].y+ELE_BUTTON_SIZE,0} );
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			if( --m_chSelect < 0 ){
				m_chSelect = 0;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &(Vec){tblElePos[m_chSelect].x+ELE_BUTTON_SIZE,tblElePos[m_chSelect].y+ELE_BUTTON_SIZE,0} );
			break;
		}
#endif
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			SetCursolDisp( false );
			gpSound->mPlaySE(SFX_SYS_PNL_SWITCHANALOG);
			gpSound->mPlaySE(SFX_SYS_PNL_OK);
			m_spSwitch.SetTexSprite	( tblElePos[m_chSelect].x, tblElePos[m_chSelect].y, &m_pTexture[ELEVATOR_HOTEL1F+m_chSelect] );
			m_sNowAnswer = m_chSelect;
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case PROC_TIME:
		if( ++m_iTime > 20 ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
/*
	if( m_chSelect == 0 )							SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN );
	else if( m_chSelect == ROULETTE_ANSWER_NUM-1) 	SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_UP );
	else											SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_UP|CURSOL_DIR_DOWN );
*/	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelHotelElevator::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spSwitch.Render();
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelHotelElevator::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelHotelElevator::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelHotelElevator::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelHotelElevator::LoadTexData()
{
	if( LoadPackData( HOTELELE_PACK_DATA, ELEVATOR_HOTELMAX )){
		m_spBG.SetTexSprite	( 0, 0, &m_pTexture[ELEVATOR_HOTELBG] );
		m_spBG.SetVisible	( true );
		
		m_spSwitch.SetTexSprite	( tblElePos[m_chSelect].x, tblElePos[m_chSelect].y, &m_pTexture[ELEVATOR_HOTEL1F+m_chSelect] );
		m_spSwitch.SetVisible	( true );
		return true;
	}
	return false;
}