////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Ino
//
// SK7PanelIno.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELINO_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelIno.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


char* tblBgTexName[]=
{
	"Texture/011602/Ino_BG.BIN",
	"Texture/011602/Shika_BG.BIN",
	"Texture/011602/Chou_BG.BIN",
};

char* tblSelectTexName[]=
{
	"Texture/011602/Ino_er1.BIN","Texture/011602/Ino_er2.BIN","Texture/011602/Ino_ok.BIN",
	"Texture/011602/Shika_er1.BIN","Texture/011602/Shika_er2.BIN","Texture/011602/Shika_ok.BIN",
	"Texture/011602/Chou_er1.BIN","Texture/011602/Chou_er2.BIN","Texture/011602/Chou_ok.BIN",
};

#define		BUTTON_RIGHT	"Texture/011602/ISC_button3.BIN"
#define		BUTTON_CENTER	"Texture/011602/ISC_button2.BIN"
#define		BUTTON_LEFT		"Texture/011602/ISC_button1.BIN"

#define		SELECT_X		(190)//(250)
#define		SELECT_Y		(160)//(227)
#define		INOBUTTON_X0	(192)//(256)
#define		INOBUTTON_X1	(288)//(296)
#define		INOBUTTON_X2	(384)//(340)
#define		INOBUTTON_Y		(368)//(354)

Vec		tblInoCardPos[]={
	224, 400, 	0, 
	320, 400,	0,
	416, 400,	0,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelIno::SK7PanelIno( s32 Now ) : SK7PanelBase( Now )
{	
	SetCursolPosition( &tblInoCardPos[0] );
	SetCursolDir(CURSOL_DIR_RIGHT,0);
	
	int answer = (rand()%3);
	if( answer == 0 ){
		m_ucNo[0]=2,m_ucNo[1]=0,m_ucNo[2]=1;
	}else if( answer == 1 ){
		m_ucNo[0]=1,m_ucNo[1]=2,m_ucNo[2]=0;
	}else{
		m_ucNo[0]=0,m_ucNo[1]=1,m_ucNo[2]=2;
	}
		
	
	m_sNowAnswer	= INO_MISS;
	m_ucGameNo		= (u8)Now;
	m_chSelect		= 0;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);		
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelIno::~SK7PanelIno()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	for( int i = 0; i < INO_SELECT_NUM; i++ ){
		m_spSelect[i].Delete();
	    m_spButton[i].Delete();
	}
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelIno::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_RIGHT ) ){
			if( ++m_chSelect >= INO_SELECT_NUM ){
				m_chSelect = 0;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &tblInoCardPos[m_chSelect] );
			SetCursolDir(CURSOL_DIR_RIGHT, 1);
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) ){
			if( --m_chSelect < 0 ){
				m_chSelect = INO_SELECT_NUM-1;
			}			
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &tblInoCardPos[m_chSelect] );
			SetCursolDir(CURSOL_DIR_LEFT,1 );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE(SFX_SYS_DECIDE);
			m_spSelect[m_chSelect].SetVisible(true);
			m_spButton[m_chSelect].SetVisible(true);
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			SetCursolDisp( false );
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
		
	case	PROC_CHECK:
		switch( CheckAnswer() ){
		case	PANEL_CHECK_RETURN:		//߂
			m_spSelect[m_chSelect].SetVisible(false);
			m_spButton[m_chSelect].SetVisible(false);
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			SetCursolDisp( false );
			gpSound->mPlaySE(SFX_SYS_PNL_OK);
			if( 2 == m_ucNo[m_chSelect] ){
				m_sNowAnswer = INO_OK;
				m_Proc = PROC_CANCEL;
			}else{
				m_Proc = PROC_CANCEL;
			}
			break;
		}
		break;

	case	PROC_MESSAGE:
		if( DrawMessage(0) ){
			m_sNowAnswer = INO_OK;
			m_Proc = PROC_CANCEL;
		}
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	if( m_chSelect == 0 )		SetCursolDir(CURSOL_DIR_RIGHT,0);
	else if( m_chSelect == 2)	SetCursolDir(CURSOL_DIR_LEFT,0);
	else						SetCursolDir(CURSOL_DIR_LEFT|CURSOL_DIR_RIGHT,0);
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelIno::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	for( int i = 0; i < INO_SELECT_NUM; i++ ){
		m_spSelect[i].Render();
		m_spButton[i].Render();
	}
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelIno::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelIno::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelIno::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelIno::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( tblBgTexName[m_ucGameNo] ) ){
			m_TexProc = LOAD_SELECT0;
		}
		break;
	case	LOAD_SELECT0:	//	ZNg
		if( m_spSelect[0].LoadTexture( tblSelectTexName[m_ucGameNo*3+m_ucNo[0]] )){
			m_spSelect[0].SetXY0	( SELECT_X, SELECT_Y );
			m_spSelect[0].SetFlag	( false, RENDER_FLAG );
			m_TexProc = LOAD_SELECT1;
		}
		break;
	case	LOAD_SELECT1:	//	ZNg
		if( m_spSelect[1].LoadTexture( tblSelectTexName[m_ucGameNo*3+m_ucNo[1]] )){
			m_spSelect[1].SetXY0	( SELECT_X, SELECT_Y );
			m_spSelect[1].SetFlag	( false, RENDER_FLAG );
			m_TexProc = LOAD_SELECT2;
		}
		break;
	case	LOAD_SELECT2:	//	ZNg
		if( m_spSelect[2].LoadTexture( tblSelectTexName[m_ucGameNo*3+m_ucNo[2]] )){
			m_spSelect[2].SetXY0	( SELECT_X, SELECT_Y );
			m_spSelect[2].SetFlag	( false, RENDER_FLAG );
			m_TexProc = LOAD_BUTTON_LEFT;
		}
		break;
	case	LOAD_BUTTON_LEFT:	//	{^
		if( m_spButton[0].LoadTexture( BUTTON_LEFT )){
			m_spButton[0].SetXY0	( INOBUTTON_X0, INOBUTTON_Y );
			m_spButton[0].SetFlag	( false, RENDER_FLAG );
			m_TexProc = LOAD_BUTTON_CENTER;
		}
		break;
	case	LOAD_BUTTON_CENTER:	//	{^
		if( m_spButton[1].LoadTexture( BUTTON_CENTER )){
			m_spButton[1].SetXY0	( INOBUTTON_X1, INOBUTTON_Y );
			m_spButton[1].SetFlag	( false, RENDER_FLAG );
			m_TexProc = LOAD_BUTTON_RIGHT;
		}
		break;
	case	LOAD_BUTTON_RIGHT:	//	{^
		if( m_spButton[2].LoadTexture( BUTTON_RIGHT )){
			m_spButton[2].SetXY0	( INOBUTTON_X2, INOBUTTON_Y );
			m_spButton[2].SetFlag	( false, RENDER_FLAG );
			return true;
		}
		break;
	}
	return false;
}
