////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel InputCode 
//
// SK7PanelInputCode.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/26/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELINPUTCODE_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelInputCode.h"
#include "../Yam/YK7EffectSight.h" 
#include "../Yam/YK7EffectMessage2.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"

#define	 CODE_KEY_TIME		(4)

const VEC2	tblMojiPos[]=
{
	303.0f,  91.0f,	//	  A, 
	339.0f,  96.0f, //    B, 
	373.0f,  108.0f,//    C, 
	402.0f,  128.0f,//    D, 
	425.0f,  155.0f,//    E, 
	441.0f,  185.0f,//    F, 
	450.0f,  221.0f,//    G, 
	450.0f,  256.0f,//    H, 
	441.0f,  291.0f,//    I, 
	424.0f,  322.0f,//    J, 
	402.0f,  348.0f,//    K, 
	373.0f,  367.0f,//    L, 
	339.0f,  380.0f,//    M, 
	304.0f,  385.0f,//    N, 
	269.0f,  381.0f,//    O, 
	236.0f,  370.0f,//    P, 
	206.0f,  348.0f,//    Q, 
	184.0f,  322.0f,//    R, 
	167.0f,  290.0f,//    S, 
	158.0f,  256.0f,//    T, 
	158.0f,  220.0f,//    U, 
	166.0f,  186.0f,//    V, 
	183.0f,  155.0f,//    W, 
	207.0f,  129.0f,//    X, 
	235.0f,  108.0f,//    Y, 
	269.0f,  96.0f, //    Z, 
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelInputCode::SK7PanelInputCode( s32 Now ) : SK7PanelBase( Now )
{
	SetCursolPosition( &(Vec){320-16,260,0});
//	SetCursolSize( 33, 33 );
	
	m_lTime			= 0;
	m_chSelect		= 0;
	m_chAnswerNo	= 0;
	m_iRenderTime	= 0;
	memset(&m_chAnswer, 0, sizeof(u8)*2);
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;
	
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	
	m_spAnswer[0].SetXY0( ANSWER_X0, ANSWER_Y );
	m_spAnswer[0].SetFlag(true, BLOCK_FLAG|RENDER_FLAG);
	m_spAnswer[0].SetTexNo(0);
	m_spAnswer[1].SetXY0( ANSWER_X1, ANSWER_Y );
	m_spAnswer[1].SetFlag(true, BLOCK_FLAG|RENDER_FLAG);
	m_spAnswer[1].SetTexNo(0);
	
	//	_CA	--------------------------------------------------
	m_spDial.SetXY0( tblMojiPos[0].x, tblMojiPos[0].y );
	m_spDial.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
	m_spDial.SetTexNo(0);

	//	ˌ
	m_spLgt.SetXY0( LGT_X, LGT_Y );
	m_spLgt.SetFlag( true, RENDER_FLAG );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelInputCode::~SK7PanelInputCode()
{
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spDial.Delete();				//	_CA
	m_spAnswer[0].Delete();
	m_spLgt.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelInputCode::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		//	_ŗp
		m_iRenderTime++;
		if( (m_iRenderTime%20) >= 10 ){
			m_spAnswer[m_chAnswerNo].SetVisible(false);
		}else{
			m_spAnswer[m_chAnswerNo].SetVisible(true);
		}

		//	j	------------------------------------------
		m_iKeyTime++;
		
		//	XeBbNړ	--------------------------------------
		if( CheckKeyR( SK7_KEY_LEFT ) && m_iKeyTime > CODE_KEY_TIME )
		{
			if( --m_chSelect < 0 )
			{
				m_chSelect = ALPHABET_NUM-1;
			}
			m_spDial.SetXY0( tblMojiPos[m_chSelect].x, tblMojiPos[m_chSelect].y );
			m_spDial.SetTexNo( (u8)m_chSelect );
			m_spAnswer[m_chAnswerNo].SetTexNo( (u8)m_chSelect);
			
			m_iKeyTime = 0;
			gpSound->mPlaySE(SFX_SCE0_PANEL_DIAL_ROLL);
			break;
		}
		if( CheckKeyR( SK7_KEY_RIGHT ) && m_iKeyTime > CODE_KEY_TIME  )
		{
			if( ++m_chSelect > ALPHABET_NUM-1 )
			{
				m_chSelect = 0;
			}
			m_spDial.SetXY0( tblMojiPos[m_chSelect].x, tblMojiPos[m_chSelect].y );
			m_spDial.SetTexNo((u8)m_chSelect );
			m_spAnswer[m_chAnswerNo].SetTexNo( (u8)m_chSelect);
			
			m_iKeyTime = 0;
			gpSound->mPlaySE(SFX_SCE0_PANEL_DIAL_ROLL);
			break;
		}
		//		-----------------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
		{
			gpSound->mPlaySE(SFX_SCE0_PANEL_INPUT);
			m_spAnswer[m_chAnswerNo].SetVisible(true);
			if( m_chAnswerNo == 0 ){
				m_spAnswer[m_chAnswerNo+1].SetTexNo( (u8)m_chSelect );
			}
			m_chAnswer[m_chAnswerNo] = (u8)m_chSelect;
			m_iKeyTime = 0;
			if( ++m_chAnswerNo > 1 )
			{
				m_Proc = PROC_ANSWER_CHECK;
				break;			
			}
			SetCursolPosition( &(Vec){320+16,260,0});
			break;
		}
		//	LZ	-----------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B )
		{
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			switch( m_chAnswerNo )
			{
			case 0:
				SetCursolDisp( false );
				m_sNowAnswer = CODE_ANSWER_CANCEL;
				m_Proc = PROC_CURSOL_END;
				break;
			case 1:
				m_chAnswerNo = 0;
				m_spAnswer[1].SetVisible( true );
				m_spAnswer[m_chAnswerNo].SetTexNo( (u8)m_chSelect);
				SetCursolPosition( &(Vec){320-16,260,0});
				break;
			}
			m_iKeyTime = 0;
			break;
		}
		break;
	
	//	킹
	case PROC_ANSWER_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:		//߂
			m_iRenderTime = 0;	
			m_chAnswerNo = 1;
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			gpSound->mPlaySE(SFX_SCE0_PANEL_ENTER);
			if( m_chAnswer[0] == ANSWER_LEFT && m_chAnswer[1] == ANSWER_RIGHT )
			{
				SetCursolDisp( false );
				gpSound->mPlaySE(SFX_SYS_TRUE);
				m_Proc = PROC_TIME;
				break;
			}
			else	//	͂
			{
				SetCursolDisp( false );
				gpSound->mPlaySE(SFX_SYS_PNL_MISS);
				m_Proc = PROC_ANSWER_BAT;
				break;
			}
			break;
		}

		break;
		
	//	`掞ԑ҂
	case 	PROC_TIME:
		if( DrawMessage(1) )
		{
			m_sNowAnswer = CODE_ANSWER_HIT;
			m_Proc = PROC_CURSOL_END;
		}		
		break;
	
	//	OꂿB
	case	PROC_ANSWER_BAT:
		if(DrawMessage(0))
		{
			m_sNowAnswer = CODE_ANSWER_MISS;
			m_Proc = PROC_CURSOL_END;
		}
		break;
				
	case 	PROC_CURSOL_END:
		if( GetPanelCursolEnd() == true ){
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelInputCode::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	GXSetBlendMode( GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	
	m_spBG.Render();				//	wi
	
	m_spDial.Render();				//	_CA

	int i;
	
	for( i = 0; i < ANSWER_NUM; i++ )
	{
		m_spAnswer[i].Render();
	}	
	m_spLgt.Render();
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelInputCode::mGetFileReadEnd(void)
{
	if( m_Proc >= PROC_SELECT_MAIN )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelInputCode::mGetSelectEnd(void)
{
	if( m_Proc == PROC_CANCEL )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelInputCode::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return m_sNowAnswer;
				
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelInputCode::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	if( m_spBG.LoadTexture( PNL000304TEX_BG ) )		m_TexProc=LOAD_FONT;	break;
	case 	LOAD_FONT:	
		if( m_spAnswer[0].LoadTexture( PNL000304TEX_FONT, 13, 2) )
		{
			m_TexProc = LOAD_LGT;
			m_spAnswer[1].SetTexture( m_spAnswer[0].GetTexture(), 13, 2 );
		}
		break;
	case	LOAD_LGT:	if( m_spLgt.LoadTexture( PNL000304TEX_LGT ) ) 	m_TexProc = LOAD_DIAL;	break;
	case 	LOAD_DIAL:	if( m_spDial.LoadTexture( PNL000304TEX_DIAL, 8, 4 ) ) return true;
	}
	return false;
}






