////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel InputCode
//
// SK7PanelInputCode.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/26/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELINPUTCODE_H__
#define	__SK7PANELINPUTCODE_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


#define		ALPHABET_NUM		(26)		//	At@xbg̐
#define		ANSWER_NUM			(2)			//	̐

#define		ANSWER_X0			(291)
#define		ANSWER_X1			(320)
#define		ANSWER_Y			(244)

#define		DIAL_X				(128)
#define		DIAL_Y				(62)
#define		DIAL_SIZE			(384)
#define		DIAL_KEY_TIME		(8)
#define		LGT_X				(281)
#define		LGT_Y				(227)

#define		ANSWER_LEFT			(13)
#define		ANSWER_RIGHT		(14)

//	Ԃl
#define		CODE_ANSWER_HIT		(1)
#define		CODE_ANSWER_MISS	(0)
#define		CODE_ANSWER_CANCEL	(-1)


//	eNX`[pX 
#define	PNL000304TEX_BG		"Texture/000304/dial4_BG.BIN"
#define PNL000304TEX_FONT	"Texture/000304/dial2_alphabet.BIN"
#define	PNL000304TEX_LGT	"Texture/000304/dial2_ISZKlgt.BIN"
#define	PNL000304TEX_DIAL	"Texture/000304/dial4_Ramp.BIN"




//---- class ----
class SK7PanelInputCode : public SK7PanelBase
{
	//	t[vZX
	typedef enum 
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_DIAL_CHECK,
		PROC_DIAL_MOVE,
		PROC_ANSWER_HIT,
		PROC_ANSWER_BAT,
		PROC_ANSWER_CHECK,
		PROC_CANCEL,
		PROC_ANSWER_BAT_TIME,
		PROC_CURSOL_END,
		PROC_TIME,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	enum
	{
		LOAD_BG=0,
		LOAD_FONT,
		LOAD_LGT,
		LOAD_DIAL,
	};
	

protected:
	eInputCodeProc			m_Proc;
	u8						m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spAnswer[ANSWER_NUM]; //	̐		
	SK7Sprite				m_spDial;				//	_CA
	SK7Sprite				m_spLgt;
	
	SK7File					m_File[ALPHABET_NUM];

	u32						m_lTime;
	int						m_iKeyTime;
	int						m_iRenderTime;
	s8						m_chSelect;
	u8						m_chAnswer[2];
	u8						m_chAnswerNo;
		
public:
	SK7PanelInputCode( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelInputCode();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
};

#endif	//__SK7PANELINPUTCODE_H__
