////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel InputCode6 
//
// SK7PanelInputCode6.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/26/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELINPUTCODE6_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelInputCode6.h"
#include "../Yam/YK7EffectSight.h" 
#include "../Yam/YK7EffectMessage2.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"

#define	 CODE_KEY_TIME		(4)

const VEC2	tblMojiPos[]=
{
	303.0f,  91.0f,	//	  A, 
	339.0f,  96.0f, //    B, 
	373.0f,  108.0f,//    C, 
	402.0f,  128.0f,//    D, 
	425.0f,  155.0f,//    E, 
	441.0f,  185.0f,//    F, 
	450.0f,  221.0f,//    G, 
	450.0f,  256.0f,//    H, 
	441.0f,  291.0f,//    I, 
	424.0f,  322.0f,//    J, 
	402.0f,  348.0f,//    K, 
	373.0f,  367.0f,//    L, 
	339.0f,  380.0f,//    M, 
	304.0f,  385.0f,//    N, 
	269.0f,  381.0f,//    O, 
	236.0f,  370.0f,//    P, 
	206.0f,  348.0f,//    Q, 
	184.0f,  322.0f,//    R, 
	167.0f,  290.0f,//    S, 
	158.0f,  256.0f,//    T, 
	158.0f,  220.0f,//    U, 
	166.0f,  186.0f,//    V, 
	183.0f,  155.0f,//    W, 
	207.0f,  129.0f,//    X, 
	235.0f,  108.0f,//    Y, 
	269.0f,  96.0f, //    Z, 
};

const f32  tblAnsPosX[]={
	247,
	268,
	292,
	315,
	337,
	360,
};

const u8	tblAnswerNo[]={
//	Hustle
	7,20,18,19,11,4,
};

#define		ANSWER_Y			(244)
#define		DIAL_X				(128)
#define		DIAL_Y				(62)
#define		DIAL_SIZE			(384)
#define		DIAL_KEY_TIME		(8)
#define		LGT_X				(244)
#define		LGT_Y				(228)

//	eNX`[pX 
#define	PNL020109TEX_BG		"Texture/020109/dial4_bg.BIN"
#define PNL020109TEX_FONT	"Texture/020109/dial4_alphabet.BIN"
#define	PNL020109TEX_LGT	"Texture/020109/dial4_window.BIN"
#define	PNL020109TEX_DIAL	"Texture/020109/dial4_lamp.BIN"



//========================================================================
//					RXgN^
//========================================================================
SK7PanelInputCode6::SK7PanelInputCode6( s32 Now ) : SK7PanelBase( Now )
{
	SetCursolPosition( &(Vec){tblAnsPosX[0]+16,260,0});
	
	m_lTime			= 0;
	m_chSelect		= 0;
	m_chAnswerNo	= 0;
	m_iRenderTime	= 0;
	m_iKeyTime		= 0;
	memset(&m_chAnswer, 0, sizeof(u8)*INPUT_ANSWER_NUM);
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;
	
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//		------------------------------------------------------
	for( int i = 0; i < INPUT_ANSWER_NUM; i++ ){
		m_spAnswer[i].SetXY0( tblAnsPosX[i], ANSWER_Y );
		m_spAnswer[i].SetFlag(true, BLOCK_FLAG|RENDER_FLAG);
		m_spAnswer[i].SetTexNo(0);
	}
	
	//	_CA	--------------------------------------------------
	m_spDial.SetXY0( tblMojiPos[0].x, tblMojiPos[0].y );
	m_spDial.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
	m_spDial.SetTexNo(0);

	//	ˌ
	m_spLgt.SetXY0( LGT_X, LGT_Y );
	m_spLgt.SetFlag( true, RENDER_FLAG );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelInputCode6::~SK7PanelInputCode6()
{
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spDial.Delete();				//	_CA
	m_spAnswer[0].Delete();
	m_spLgt.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelInputCode6::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		//	_ŗp
		m_iRenderTime++;
		if( (m_iRenderTime%20) >= 10 ){
			m_spAnswer[m_chAnswerNo].SetVisible(false);
		}else{
			m_spAnswer[m_chAnswerNo].SetVisible(true);
		}

		//	j	------------------------------------------
		m_iKeyTime++;
		
		//	XeBbNړ	--------------------------------------
		if( CheckKeyR( SK7_KEY_LEFT ) && m_iKeyTime > CODE_KEY_TIME )
		{
			if( --m_chSelect < 0 ){
				m_chSelect = ALPHABET_NUM-1;
			}
			m_spDial.SetXY0( tblMojiPos[m_chSelect].x, tblMojiPos[m_chSelect].y );
			m_spDial.SetTexNo( (u8)m_chSelect );
			m_spAnswer[m_chAnswerNo].SetTexNo( (u8)m_chSelect);
			
			m_iKeyTime = 0;
			gpSound->mPlaySE(SFX_SCE2_PANEL_DIAL_ROLL );
			break;
		}
		if( CheckKeyR( SK7_KEY_RIGHT ) && m_iKeyTime > CODE_KEY_TIME  )
		{
			if( ++m_chSelect > ALPHABET_NUM-1 ){
				m_chSelect = 0;
			}
			m_spDial.SetXY0( tblMojiPos[m_chSelect].x, tblMojiPos[m_chSelect].y );
			m_spDial.SetTexNo((u8)m_chSelect );
			m_spAnswer[m_chAnswerNo].SetTexNo( (u8)m_chSelect);
			
			m_iKeyTime = 0;
			gpSound->mPlaySE(SFX_SCE2_PANEL_DIAL_ROLL );
			break;
		}
		//		-----------------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
		{
			gpSound->mPlaySE(SFX_SCE2_PANEL_INPUT);
			m_spAnswer[m_chAnswerNo].SetVisible(true);
			if( m_chAnswerNo != INPUT_ANSWER_NUM-1 ){
				m_spAnswer[m_chAnswerNo+1].SetTexNo( (u8)m_chSelect );
			}
			m_chAnswer[m_chAnswerNo] = (u8)m_chSelect;
			m_iKeyTime = 0;
			if( ++m_chAnswerNo > INPUT_ANSWER_NUM-1 ){
				m_Proc = PROC_ANSWER_CHECK;
				break;			
			}
			SetCursolPosition( &(Vec){tblAnsPosX[m_chAnswerNo]+16,260,0});
			break;
		}
		//	LZ	-----------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B )
		{
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			if( m_chAnswerNo ==  0 ){
				SetCursolDisp( false );
				m_sNowAnswer = CODE_ANSWER_CANCEL;
				m_Proc = PROC_CANCEL;
			}else{
				m_spAnswer[m_chAnswerNo].SetVisible( true );
				m_chAnswerNo--;
				m_spAnswer[m_chAnswerNo].SetVisible( true );
				m_spAnswer[m_chAnswerNo].SetTexNo( (u8)m_chSelect );
				SetCursolPosition( &(Vec){tblAnsPosX[m_chAnswerNo]+16,260,0});
				break;
			}
			m_iKeyTime = 0;
			break;
		}
		break;
	
	//	킹
	case PROC_ANSWER_CHECK:
		switch( CheckAnswer() ){
		case	PANEL_CHECK_RETURN:		//߂
			m_iRenderTime = 0;	
			m_chAnswerNo = INPUT_ANSWER_NUM-1;
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			gpSound->mPlaySE(SFX_SCE2_PANEL_ENTER);
			bool flag = true;
			for( int i = 0; i < INPUT_ANSWER_NUM; i++ ){
				if( m_chAnswer[i] != tblAnswerNo[i] ){
					flag = false;
					break;
				}
			}
			if( flag ){
//				gpSound->mPlaySE(SFX_SYS_TRUE);
				SetCursolDisp( false );
				m_Proc = PROC_TIME;
				break;
			}
			else	//	͂
			{
				SetCursolDisp( false );
				gpSound->mPlaySE(SFX_SYS_PNL_MISS);
				m_Proc = PROC_ANSWER_BAT;
				break;
			}
			break;
		}
		break;
		
	//	`掞ԑ҂
	case 	PROC_TIME:
		if( DrawMessage(1) )
		{
			m_sNowAnswer = CODE_ANSWER_HIT;
			m_Proc = PROC_CANCEL;
		}		
		break;
	
	//	OꂿB
	case	PROC_ANSWER_BAT:
		if(DrawMessage(0))
		{
			m_sNowAnswer = CODE_ANSWER_MISS;
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelInputCode6::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	GXSetBlendMode( GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	
	m_spBG.Render();				//	wi
	
	m_spDial.Render();				//	_CA

	int i;
	
	for( i = 0; i < INPUT_ANSWER_NUM; i++ ){
		m_spAnswer[i].Render();
	}	
//	m_spLgt.Render();
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelInputCode6::mGetFileReadEnd(void)
{
	if( m_Proc >= PROC_SELECT_MAIN )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelInputCode6::mGetSelectEnd(void)
{
	if( m_Proc == PROC_CANCEL && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelInputCode6::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return( m_sNowAnswer );		
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelInputCode6::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	if( m_spBG.LoadTexture( PNL020109TEX_BG ) )		m_TexProc=LOAD_FONT;	break;
	case 	LOAD_FONT:	
		if( m_spAnswer[0].LoadTexture( PNL020109TEX_FONT, 13, 2) ){
			for( int i = 0; i < INPUT_ANSWER_NUM; i++ ){
				m_spAnswer[i].SetTexture( m_spAnswer[0].GetTexture(), 13, 2 );
			}
			m_TexProc = LOAD_LGT;
		}
		break;
	case	LOAD_LGT:	if( m_spLgt.LoadTexture( PNL020109TEX_LGT ) ) 	m_TexProc = LOAD_DIAL;	break;
	case 	LOAD_DIAL:	if( m_spDial.LoadTexture( PNL020109TEX_DIAL, 8, 4 ) ) return true;
	}
	return false;
}






