////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Keiba
//
// SK7PanelKeiba.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELKEIBA_CPP__
//#define __DEBUGKEIBA__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelKeiba.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"

//			
const u8 tblAnswerNo[]=
{
	0,3,2,6,5,1,4,
};
const VEC2	tblHorsePos[]={
	390.0f, 30.0f,
	390.0f, 60.0f,
	390.0f, 120.0f,
	390.0f, 150.0f,
	390.0f, 210.0f,
	390.0f, 270.0f,
	390.0f, 330.0f,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelKeiba::SK7PanelKeiba( s32 Now ) : SK7PanelBase( Now )
{	
	int i;
	for( i = 0; i < HORSE_NUM; i++ ){
		//	n̍W
		m_spHorse[i].SetXY0( tblHorsePos[i].x, tblHorsePos[i].y );
		m_spHorse[i].SetFlag( true, RENDER_FLAG );
		//	ԍ̓
		m_ucAnswerNo[i] = (u8)i;
	}
	
	for( i = 0; i < HORSE_NUM+1; i++ )
	{
		//	ԍ
		m_spNumber[i].SetXY0( HORSE_NUMBER_X + i * HORSE_NO_GAP_X, HORSE_NUMBER_Y );
		m_spNumber[i].SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
		m_spNumber[i].SetTexNo( (u8)i );
	}
	
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);

	//	tO	----------------------------------------------
	m_spWinLose.SetXY0( WINLOSE_X, WINLOSE_Y );
	m_spWinLose.SetFlag( false, RENDER_FLAG );
	m_spWinLose.SetFlag( true, BLOCK_FLAG );

	//	TCg	----------------------------------------------
	SetCursolPosition(&(Vec){240,290,0} );

	Vec vSightPos;
	vSightPos.x = HORSE_NUMBER_X + CURSOL_NO_GAP_X;
	vSightPos.y = HORSE_NUMBER_Y + CURSOL_NO_GAP_Y;
	vSightPos.z = 0;
	SetCursolPosition(&vSightPos);
	SetCursolDir(CURSOL_DIR_RIGHT);
			
	m_sNowAnswer		= KEIBA_LOSE;
	m_cSelectNo		= 0;
	m_iTime			= 0;
	m_ucSelectSaveNo= 0;
	m_iLightTime	= 0;
	m_fHorseAngle	= 0;
	m_iHorseTime	= 0;
	m_iGoalNo		= 0;
	m_iCheckTime	= 0;
	m_ucGoalNum		= 0;
	m_bEndFlag		= false;
	m_bSelectFlag	= false;
	m_bAnswerCheck	= false;
	m_bWinCheck		= false;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelKeiba::~SK7PanelKeiba()
{
	//eNX`	-----------------------------
	m_spBG.Delete();
	
	for( int i = 0; i < HORSE_NUM+1; i++ )
	{
		if( i < HORSE_NUM ){
			m_spHorse[i].Delete();
		}
		m_spNumber[i].Delete();
	}
	m_spWinLose.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelKeiba::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
#ifdef __DEBUGKEIBA__
			m_bAnswerCheck = true;
			m_Proc = PROC_START;
#else
			m_Proc = PROC_SELECT_MAIN;
#endif
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;

		//		_ŗp	@
		m_iTime++;
		if( m_bSelectFlag ){		
			if( (m_iTime%20) < 10 ){						
				m_spNumber[m_cSelectNo].SetVisible(false);
			}else{
				m_spNumber[m_cSelectNo].SetVisible(true);
			}
			if( (m_iTime%20) == 11 ) gpSound->mPlaySE(SFX_SCE1_PNL_KEIBA_TENMETSU);
		}
		
		for( int i = 0; i < HORSE_NUM; i++ ){
			if( m_cSelectNo != i || !m_bSelectFlag ){
				m_spNumber[i].SetVisible( true );
			}
		}

		if( CheckKeyT( SK7_KEY_RIGHT ) ){
			if( m_bSelectFlag ){
				if( ++m_cSelectNo > HORSE_NUM-1 ){
					m_cSelectNo = 0;
				}
			}else{
				if( ++m_cSelectNo > HORSE_NUM ){
					m_cSelectNo = 0;
				}
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			Vec vSightPos;
			vSightPos.x = HORSE_NUMBER_X + m_cSelectNo * HORSE_NO_GAP_X + CURSOL_NO_GAP_X;
			vSightPos.y = HORSE_NUMBER_Y + CURSOL_NO_GAP_Y;
			vSightPos.z = 0;
			
			SetCursolPosition(&vSightPos);
			SetCursolDir(CURSOL_DIR_RIGHT,1);
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) ){
			if( m_bSelectFlag ){
				if( --m_cSelectNo < 0 ){
					m_cSelectNo = HORSE_NUM-1;
				}
			}else{
				if( --m_cSelectNo < 0 ){
					m_cSelectNo = HORSE_NUM;
				}
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			Vec vSightPos;
			vSightPos.x = HORSE_NUMBER_X + m_cSelectNo * HORSE_NO_GAP_X + CURSOL_NO_GAP_X;
			vSightPos.y = HORSE_NUMBER_Y + CURSOL_NO_GAP_Y;
			vSightPos.z = 0;
			
			SetCursolPosition(&vSightPos);
			SetCursolDir(CURSOL_DIR_LEFT, 1);
			break;
		}
		//	I
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE(SFX_SCE1_PNL_KEIBA_CHANGE);
			if( m_bSelectFlag ){
				u8 No = m_ucAnswerNo[m_ucSelectSaveNo];
				m_ucAnswerNo[m_ucSelectSaveNo]	= m_ucAnswerNo[m_cSelectNo];
				m_ucAnswerNo[m_cSelectNo]	 	= No;
				m_spNumber[m_ucSelectSaveNo].SetTexNo( m_ucAnswerNo[m_ucSelectSaveNo] );
				m_spNumber[m_cSelectNo].SetTexNo( m_ucAnswerNo[m_cSelectNo] );
				for( int j = 0; j < HORSE_NUM; j++ )	m_spNumber[j].SetColor( 0xffffffff );
			}else{
				//	X^[gI
				if( m_cSelectNo == HORSE_NUM ){	
					m_bAnswerCheck = false;
					for( int a = 0, b = 0; a < HORSE_NUM; a++ ){
						if( m_ucAnswerNo[a] == tblAnswerNo[a] )
						{
							if( ++b == HORSE_NUM ){
								m_bAnswerCheck = true;
							}
						}
					}
					m_sNowAnswer = (m_bAnswerCheck == true) ? (s8)KEIBA_WIN : (s8)KEIBA_LOSE;
					m_Proc = PROC_START_CHECK;
					break;
				}else{
					m_ucSelectSaveNo = (u8)m_cSelectNo;
					m_spNumber[m_cSelectNo].SetColor( 0x00ff00ff );
				}
			}
			m_bSelectFlag = ( m_bSelectFlag == true ) ? false : true;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			if( m_bSelectFlag ){
				for( int j = 0; j < HORSE_NUM; j++ )	m_spNumber[j].SetColor( 0xffffffff );
				m_bSelectFlag = false;
			}else{
				m_sNowAnswer = KEIBA_CANCEL;
				SetCursolDisp(  false );
				m_Proc = PROC_CANCEL;
				break;
			}
			break;
		}
		break;
#if 0
		if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
			for( int a = 0, b = 0; a < HORSE_NUM; a++ ){
				if( m_ucAnswerNo[a] == tblAnswerNo[a] )
				{
					if( ++b == HORSE_NUM ){
						m_bAnswerCheck = true;
					}
				}
			}
			m_sNowAnswer = (m_bAnswerCheck == true) ? (s8)KEIBA_WIN : (s8)KEIBA_LOSE;
			m_Proc = PROC_START_CHECK;
		}
		break;
#endif
	
	//		X^[g`FbN@
	case 	PROC_START_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			for( int i = 0; i < HORSE_NUM+1; i++ )	m_spNumber[i].SetVisible(false);
			gpSound->mPlaySE(SFX_SCE1_PNL_KEIBA_FANFARE);
			m_Proc = PROC_FANFARE_STOP;
			break;
		}
		break;
		
	case 	PROC_FANFARE_STOP:
		if( !gpSound->mCheckSE( SFX_SCE1_PNL_KEIBA_FANFARE ))
		{
			gpSound->mPlaySE(SFX_SCE1_PNL_KEIBA_GATEOPEN);
			m_Proc = PROC_GATE_OPEN;
		}
		break;
		
	case	PROC_GATE_OPEN:
		if( !gpSound->mCheckSE( SFX_SCE1_PNL_KEIBA_GATEOPEN ))
		{
			gpSound->mPlaySE(SFX_SCE1_PNL_KEIBA_RUN);
			m_Proc = PROC_START;
		}
		break;
		
	//		X^[g	
	case	PROC_START:
		if( MoveHorse() ){
			m_spWinLose.SetVisible(true);
			gpSound->mStopSE(SFX_SCE1_PNL_KEIBA_RUN);
			if( m_sNowAnswer == KEIBA_LOSE ){
				if( !m_bWinCheck ){
					gpSound->mPlaySE(SFX_SCE1_PNL_KEIBA_LOOSER);
					m_bWinCheck = true;
					m_spWinLose.SetTexNo( 0 );
					m_Proc = PROC_LIGHT;
				}
			}else{
				if( !m_bWinCheck ){
					gpSound->mPlaySE(SFX_SCE1_PNL_KEIBA_WINNER);
					m_bWinCheck = true;
					m_spWinLose.SetTexNo( 1 );
					m_Proc = PROC_LIGHT;
				}
			}
		}
		break;
		
	case	PROC_LIGHT:
		if( ++m_iLightTime > LIGHT_TIME ){
			m_iLightTime = 0;
			for( int i = 0; i < HORSE_NUM+1; i++ )	m_spNumber[i].SetVisible(false);
#ifdef __DEBUGKEIBA__
			for( int i = 0; i < HORSE_NUM; i++ ){
				//	n̍W
				m_spHorse[i].SetXY0( tblHorsePos[i].x, tblHorsePos[i].y );
				m_spHorse[i].SetFlag( true, RENDER_FLAG );
				//	ԍ̓
				m_ucAnswerNo[i] = (u8)i;
			}
			m_cSelectNo		= 0;
			m_iTime			= 0;
			m_ucSelectSaveNo= 0;
			m_iLightTime	= 0;
			m_fHorseAngle	= 0;
			m_iHorseTime	= 0;
			m_iGoalNo		= 0;
			m_iCheckTime	= 0;
			m_ucGoalNum		= 0;
			m_bEndFlag		= false;
			m_bSelectFlag	= false;
			m_bAnswerCheck	= true;
			m_bWinCheck		= false;
			m_Proc = PROC_START;
#else
			m_Proc = PROC_MESSAGE;
#endif
			break;
		}
		break;
		
	case	PROC_MESSAGE:
		if( m_sNowAnswer == KEIBA_WIN ){
			if( DrawMessage(0) ){
				m_Proc = PROC_CANCEL;
			}
		}else{
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	if( m_cSelectNo == HORSE_NUM )	SetCursolDir(CURSOL_DIR_LEFT , 0);
	else if( m_cSelectNo == 0 )	SetCursolDir(CURSOL_DIR_RIGHT, 0);
	else if( m_bSelectFlag && m_cSelectNo == HORSE_NUM-1)	SetCursolDir(CURSOL_DIR_LEFT, 0);
	else	SetCursolDir(CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT, 0);

	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelKeiba::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	int i;
	
	m_spWinLose.Render();

	for( i = 0; i < HORSE_NUM; i++ )
	{
		//	n̕`
		m_spHorse[i].Render();
	}
	for( i = 0; i < HORSE_NUM+1; i++  )
	{
		//	io[
		m_spNumber[i].Render();
	}	
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelKeiba::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelKeiba::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelKeiba::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// n̐ړ
//========================================================================
bool		SK7PanelKeiba::MoveHorse()
{
	const f32 tblGoalPos[]=
	{
		-145.4f,-149.6f,-154.5f,-164.7f,-178.2f,-190.0f,-204.0f,
	};
	const f32 tblGoalPos2[]=
	{
		31.75f,31.375f,27.0625f,20.0625f,9.0625f,-3.6875f,-12.25f,
	};
		
	int i=0;
	f32 	MoveX=0;
	int 	HorseNum=0;
	int 	HorseNo = (rand()%HORSE_NUM);
	int 	HorseMoveX = (rand()%HORSE_MOVE_X);
	bool	bGoalCheck=false;
	static int NN=0;
/*
	if( HSD_PadGetTrigger(0) & HSD_PAD_A )	NN++;
	if( HSD_PadGetTrigger(0) & HSD_PAD_B )  NN--;
	DEBUG_GET_2D_POS( m_spHorse[NN] );
*/
	if( m_bAnswerCheck ){
		//	ɃS[Aɍs邽߂̍s	--------------------------------
		m_iCheckTime++;
		if( m_iCheckTime > CHECK_TIME ){
			m_iCheckTime = 0;
			m_spHorse[tblAnswerNo[m_ucGoalNum]].SetXY0(  (m_spHorse[tblAnswerNo[m_ucGoalNum]].GetX0() + HORSE_EX_X ), m_spHorse[tblAnswerNo[m_ucGoalNum]].GetY0() );
		}
		//	n̈ړ	---------------------------------------------------------------------
		if( ++m_iHorseTime >= HORSE_MOVE_TIME ){			//	ԃ`FbN
			if( (m_spHorse[HorseNo].GetX0() - HorseMoveX) <= tblGoalPos2[HorseNo] ){	//	S[邩`FbN
				if( tblAnswerNo[m_iGoalNo] == HorseNo ){
					m_iGoalNo++;	//	S[𑝂₷
					bGoalCheck = true;
				}
				if( !bGoalCheck ){		//	S[ႢȂ
					HorseNo = tblAnswerNo[m_iGoalNo];
				}
				m_spHorse[HorseNo].SetXY0( (m_spHorse[HorseNo].GetX0() - HorseMoveX), m_spHorse[HorseNo].GetY0() );
			}else{
				m_spHorse[HorseNo].SetXY0( (m_spHorse[HorseNo].GetX0() - HorseMoveX), m_spHorse[HorseNo].GetY0() );
			}
			m_iHorseTime = 0;
		}
		//	ʂ̔\	--------------------------------------------------------
		//	S[n̓XN[	--------------------------------------------
		u8 HNum=0;
		for( i = 0; i < HORSE_NUM; i++ ){
			if( tblGoalPos2[tblAnswerNo[i]] >= m_spHorse[tblAnswerNo[i]].GetX0() ){
				m_spNumber[i].SetVisible(true);
				HNum++;
				if( m_spHorse[tblAnswerNo[i]].GetX0() > -300.0f ){
					m_spHorse[tblAnswerNo[i]].SetXY0( m_spHorse[tblAnswerNo[i]].GetX0()+HORSE_EX_X, m_spHorse[tblAnswerNo[i]].GetY0() );
				}
				if( m_spHorse[tblAnswerNo[HORSE_NUM-1]].GetX0() <= -300.0f ){
					return true;
				}
			}
		}
		if( m_ucGoalNum < HNum ){
			gpSound->mPlaySE(SFX_SCE1_PNL_KEIBA_TENMETSU);
		}
		m_ucGoalNum = HNum;
	}else{
		if( !m_bEndFlag ){
			if( ++m_iHorseTime >= HORSE_MOVE_TIME ){
				while(1){
					//	nʒuɂĂꍇ
					if( m_spHorse[HorseNo].GetX0() <= tblGoalPos[HorseNo]+HORSE_LOSE_X ){
						if( ++HorseNo > HORSE_NUM-1 ){	//	n̔ԍЂƂJグāAől`FbN
							HorseNo = 0;
						}
					}else{	//	n܂ĂȂƂ
						MoveX = m_spHorse[HorseNo].GetX0()-(rand()%HORSE_MOVE_X);	//	܈ړ
						if( MoveX <= tblGoalPos[HorseNo]+HORSE_LOSE_X ){	//	ʒus߂ĂȂ`FbN
							MoveX = tblGoalPos[HorseNo]+HORSE_LOSE_X;		//	␳
						}
						break;
					}
				}
				if( !m_bEndFlag ){
					m_iHorseTime = 0;
					//	Zbg
					m_spHorse[HorseNo].SetXY0( MoveX, m_spHorse[HorseNo].GetY0() );
				}
				for( i = 0; i < HORSE_NUM; i++ ){
					if( m_spHorse[i].GetX0() <= tblGoalPos[i]+HORSE_LOSE_X ){
						HorseNum++;
					}
				}
				if( HorseNum > HORSE_NUM-1 ){
					m_bEndFlag = true;
					m_iHorseTime = 0;
				}
			}
		}else{
			for( i = 0; i < HORSE_NUM; i++ ){
				m_spHorse[i].SetXY0( m_spHorse[i].GetX0() + (390.0f-tblGoalPos[i]-HORSE_LOSE_X) / HORSE_SAME_SPEED, m_spHorse[i].GetY0() );
			}
			if( ++m_iHorseTime > HORSE_SAME_SPEED ){
				m_iHorseTime = 0;
				return true;
			}
		}
	}
	return false;
}



//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelKeiba::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL011502TEX_BG ) )
		{
			m_TexProc = LOAD_FONT;
		}
		break;
	
	case LOAD_FONT:
		if( m_spWinLose.LoadTexture( PNL011502TEX_FONT, 1, 8 ) )
		{
			m_TexProc = LOAD_NUMBER;
		}
	 	break;
	 
	case LOAD_NUMBER:
		if( m_spNumber[0].LoadTexture( PNL011502TEX_NUMBER, HORSE_NUM+1, 1 ) )
		{
			for( int i = 1; i < HORSE_NUM+1; i++ )
			{
				m_spNumber[i].SetTexture( m_spNumber[0].GetTexture(), HORSE_NUM+1, 1 );
				m_spNumber[i].SetTexNo( (u8)i ) ;
			}
			m_TexProc = LOAD_HORSE0;
		}
		break;
		
	case LOAD_HORSE0:
		if( m_spHorse[0].LoadTexture( PNL011502TEX_HORSE0 ) )
		{
			m_TexProc = LOAD_HORSE1;
		}
		break;

	case LOAD_HORSE1:
		if( m_spHorse[1].LoadTexture( PNL011502TEX_HORSE1 ) )
		{
			m_TexProc = LOAD_HORSE2;
		}
		break;
		
	case LOAD_HORSE2:
		if( m_spHorse[2].LoadTexture( PNL011502TEX_HORSE2 ) )
		{
			m_TexProc = LOAD_HORSE3;
		}
		break;

	case LOAD_HORSE3:
		if( m_spHorse[3].LoadTexture( PNL011502TEX_HORSE3 ) )
		{
			m_TexProc = LOAD_HORSE4;
		}
		break;
		
	case LOAD_HORSE4:
		if( m_spHorse[4].LoadTexture( PNL011502TEX_HORSE4 ) )
		{
			m_TexProc = LOAD_HORSE5;
		}
		break;
		
	case LOAD_HORSE5:
		if( m_spHorse[5].LoadTexture( PNL011502TEX_HORSE5 ) )
		{
			m_TexProc = LOAD_HORSE6;
		}
		break;
		
	case LOAD_HORSE6:
		if( m_spHorse[6].LoadTexture( PNL011502TEX_HORSE6 ) )
		{
			return true;
		}
		break;

	}
	return false;
}