////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Keiba
//
// SK7PanelKeiba.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELKEIBA_H__
#define	__SK7PANELKEIBA_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l
#define	KEIBA_WIN				(1)
#define	KEIBA_LOSE				(0)
#define	KEIBA_CANCEL			(-1)



#define		HORSE_NUM			(7)
#define		HORSE_NUMBER_X		(104)
#define		HORSE_NUMBER_Y		(383)
#define		HORSE_NO_GAP_X		(60)
#define		CURSOL_NO_GAP_X		(30)
#define		CURSOL_NO_GAP_Y		(30)
#define		WINLOSE_X			(216)
#define		WINLOSE_Y			(31)
#define		HORSE_FRAME			(5)
#define		HORSE_SAME_SPEED	(20)
#define		LIGHT_TIME			(80)
#define		HORSE_LOSE_X		(210)
#define		HORSE_MOVE_TIME		(4)
#define		HORSE_MOVE_X		(30)
#define		CHECK_TIME			(10)
#define		HORSE_EX_X			(-10)



//	eNX`[pX
#define	PNL011502TEX_BG				"Texture/011502/horse2_BG.BIN"
#define	PNL011502TEX_FONT			"Texture/011502/horse2_lc.BIN"
#define	PNL011502TEX_NUMBER			"Texture/011502/horse2_nmbr.BIN"
#define	PNL011502TEX_HORSE0			"Texture/011502/horse2_1st.BIN"
#define	PNL011502TEX_HORSE1			"Texture/011502/horse2_2nd.BIN"
#define	PNL011502TEX_HORSE2			"Texture/011502/horse2_3rd.BIN"
#define	PNL011502TEX_HORSE3			"Texture/011502/horse2_4th.BIN"
#define	PNL011502TEX_HORSE4			"Texture/011502/horse2_5th.BIN"
#define	PNL011502TEX_HORSE5			"Texture/011502/horse2_6th.BIN"
#define	PNL011502TEX_HORSE6			"Texture/011502/horse2_7th.BIN"


//---- class ----
class SK7PanelKeiba : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_START_CHECK,
		PROC_START,
		PROC_FANFARE_STOP,
		PROC_GATE_OPEN,
		PROC_LIGHT,
		PROC_MESSAGE,
		PROC_CANCEL,
	}eFrameProc;

	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_FONT,
		LOAD_NUMBER,
		LOAD_HORSE0,
		LOAD_HORSE1,
		LOAD_HORSE2,
		LOAD_HORSE3,
		LOAD_HORSE4,
		LOAD_HORSE5,
		LOAD_HORSE6,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spHorse[HORSE_NUM];	//	n
	SK7Sprite				m_spNumber[HORSE_NUM+1];	//	
	SK7Sprite				m_spWinLose;			//	
	
	s8						m_cSelectNo;
	u8						m_ucSelectSaveNo;
	u8						m_ucAnswerNo[HORSE_NUM];
	u8						m_ucGoalNum;
	f32						m_fHorseAngle;
	int						m_iTime;
	int						m_iLightTime;
	int						m_iHorseTime;
	int						m_iCheckTime;
	int						m_iGoalNo;
	bool					m_bSelectFlag;
	bool					m_bAnswerCheck;
	bool					m_bWinCheck;
	bool					m_bEndFlag;

public:
	SK7PanelKeiba( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelKeiba();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	//	n̈ړ
	bool	MoveHorse();
	
};

#endif	//__SK7PANELKEIBA_H__
