////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelKeyBoard.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELKEYBOARD_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelKeyBoard.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"
#include "..\Scn\K7Scn05.h"


#define	PANEL_COLOR			(0x68ff67ff)
#define	ANSWER_X			(122)
#define	ANSWER_Y			(175)
#define ANSWER_WORD_X		(ANSWER_X+10)
#define	ANSWER_WORD_Y		(ANSWER_Y+10)
#define	QBOX_X				(126)
#define	QBOX_Y				(79)
#define	QBOX_GAP_X			(16)
#define	KEYTIME				(5)
#define	KEY_H_NUM			(4)
#define	ENTER_X				(519)
#define	ENTER_Y				(370)
#define	ESC_X				(112)
#define	ESC_Y				(298)
#define	SELECT_SIZE			(32)
#define	KEY_GAP_X			(35)
#define	ANSWER_GAP_X		(43)
#define	ENTER_NO			(127)
#define	ESC_NO				(126)
#define	Q_NO				(10)
#define	QFONT_X			(190)
#define	QFONT_Y			(98)
#define	QFONT_EX		(0.55f)
#define	ADD_ALPHA			(15)

#define	KEYBOARD_PACK_DATA	"/Texture/panel/055500.pak"

const VEC2 tblKeyPos[]={ {128,282}, {150,317}, {163,352}, {175,387} };
const u8 tblSideNo[]={ 0, 11, 21, 30 };

typedef struct{
	s8		No[KEYBOARD_ANSWER_NUM];
}ANSWER_DATA;


const ANSWER_DATA tblAnswerWord[]={
	{20,21,14,28,14,13,18,35,13,14},//PARKREINER
	{1,9,9,3,7,4,-1,-1,-1,-1},//200485//{9,9,3,7,9,0,4,7,-1,-1},//00480158
	{35,13,33,21,23,21,-1,-1,-1,-1},//{21,29,21,34,21,36,21,-1,-1,-1},//Alabama
	{0,8,3,1,0,0,1,1,-1,-1},//19421122
	{19,-1,-1,-1,-1,-1,-1,-1,-1,-1},//o
	{36,18,32,26,21,13,29,-1,-1,-1},//Michael{36,19,14,25,21,35,-1,-1,-1,-1},//Morgan
	{28,21,15,26,21,14,18,35,13,-1},//Katharine
	{0,8,4,1,0,0,1,1,-1,-1},//19521122
	{35,19,23,21,15,21,-1,-1,-1,-1},//NODATA
	{13,29,34,19,12,-1,-1,-1,-1,-1},//ELBOW
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelKeyBoard::SK7PanelKeyBoard( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= KEYBOARD_CANCEL;
		
	//vZX	----------------------------------------------
	m_iTime 	= 0;
	m_iKeyTime 	= 0;
	m_chQNo 	= (s8)K7EVENT_SCN_VAR(K7SCN05,EVVA_ANSWER);
	m_chSelect 	= 0;
	m_chAnswerNo = 0;
	m_chSaveNoR = 0;
	m_chSaveNoL	= 0;
	m_chPlusAlpha = (s8)(-ADD_ALPHA);
	m_Alpha		= 0xff;
	m_bAnswer	= true;
	for( int i = 0; i < KEYBOARD_ANSWER_NUM; i++ )	m_chAnswerData[i] = -1;
	
	m_spFade.SetSprite( 0, 0 , 640, 480, PANEL_COLOR );
	m_spFade.SetAlpha( 0 );
	m_spFade.SetVisible( true );

	m_Proc 		= PROC_LOAD;
	SetCursolPosition( &(Vec){ 128+SELECT_SIZE*0.5f, 282+SELECT_SIZE*0.5f, 0.0f} );	
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelKeyBoard::~SK7PanelKeyBoard()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spQNo.Delete();
	m_spSelect.Delete();
	m_spEnter.Delete();
	m_spASelect.Delete();	
	m_pYFont->Release();
	GHM_SAFE_DELETE( m_pYFont );
}




//========================================================================
// t[
//========================================================================
s16			SK7PanelKeyBoard::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_FIRST;
		}
		break;
	
	//	ŏ̍s	----------------------------------------------
	case 	PROC_FIRST:
		if( !m_bCtrl )	break;
	
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
			gpSound->mPlaySE( SFX_SCE5_SCL_PNL_PC_TYPING );	
			m_spQNo.SetVisible	( true );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		m_iKeyTime++;
		
		if( CheckKeyN( SK7_KEY_RIGHT ) & m_iKeyTime > KEYTIME ){
			m_iKeyTime = 0;
			if( m_chSelect == ENTER_NO ){
				m_chSelect = m_chSaveNoR;
			}else{
				//	G^[ւ	---------------------------
				const s8 tblNextEnterNo[]={10,20,29,38};
				const s8 tblEnterRightNo[]={ESC_NO,11,21,30};
				for( int i = 0; i < KEY_H_NUM; i++ ){
					if( tblNextEnterNo[i] == m_chSelect ){
						SetCursolPosition( &(Vec){ENTER_X, ENTER_Y, 0.0f} );
						m_chSaveNoL = m_chSelect;
						m_chSaveNoR = tblEnterRightNo[i];
						m_chSelect = ENTER_NO;
						gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );	
						return true;
					}
				}
				if( m_chSelect == ESC_NO ){
					m_chSelect = 0;
				}else{
					m_chSelect++;
				}
			}
			if( m_chSelect == ESC_NO ){
				gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );	
				SetCursolPosition( &(Vec){ESC_X, ESC_Y, 0.0f} );				
			}else{
				SetCursolPos();
			}
			return true;
		}
		if( CheckKeyN( SK7_KEY_LEFT ) & m_iKeyTime > KEYTIME ){
			m_iKeyTime = 0;
			if( m_chSelect == ESC_NO ){
				m_chSelect 	= ENTER_NO;
				m_chSaveNoL = 10;
				m_chSaveNoR = ESC_NO;
				gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );	
				SetCursolPosition( &(Vec){ENTER_X, ENTER_Y, 0.0f} );
				return true;
			}
			if( m_chSelect == ENTER_NO ){ 
				m_chSelect = m_chSaveNoL;
			}else{
				m_chSelect--;
				if( m_chSelect < 0 ){
					gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );	
					SetCursolPosition( &(Vec){ESC_X, ESC_Y, 0.0f} );
					m_chSelect = ESC_NO;
					return true;
				}
				const s8 tblNextRightNo[]={10,20,29};
				const s8 tblEnterLeftNo[]={20,29,38};
				for( int i = 0; i < 3; i++ ){
					if( tblNextRightNo[i] == m_chSelect ){
						SetCursolPosition( &(Vec){ENTER_X, ENTER_Y, 0.0f} );
						gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );	
						m_chSaveNoL = tblEnterLeftNo[i];
						m_chSaveNoR = (s8)(m_chSelect+1);						
						m_chSelect = ENTER_NO;
						return true;
					}
				}
			}
			SetCursolPos();
			return true;
		}
		if( CheckKeyN( SK7_KEY_UP ) & m_iKeyTime > KEYTIME ){
			m_iKeyTime = 0;
			if( m_chSelect == ENTER_NO || m_chSelect == ESC_NO )	break; 
			m_chSelect -= GetUpDownNo(true);
			SetCursolPos();
			return true;
		}
		if( CheckKeyN( SK7_KEY_DOWN ) & m_iKeyTime > KEYTIME ){
			m_iKeyTime = 0;
			if( m_chSelect == ENTER_NO || m_chSelect == ESC_NO )	break; 
			m_chSelect += GetUpDownNo(false);
			SetCursolPos();
			return true;
		}
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SCE5_SCL_PNL_PC_TYPING );	
			//	L[`FbN	:::::::::::::::::::::::::::::::::::
			switch( m_chSelect ){
			case ENTER_NO:
				//	AT[`FbN	----------------------------------
				if( m_bAnswer ){
					for( int i = 0; i < KEYBOARD_ANSWER_NUM; i++ ){
						if( m_chAnswerData[i] != tblAnswerWord[m_chQNo].No[i] ){
//							m_bAnswer = false;
//							m_Proc = PROC_CHECK;
							gpSound->mPlaySE( SFX_SYS_PNL_MISS );
							m_chAnswerNo = 0;
//							m_Alpha		= 0xff;
							m_bAnswer	= true;
							for(int j = 0; j < KEYBOARD_ANSWER_NUM; j++ )	m_chAnswerData[j] = -1;
							m_spASelect.SetXY0( ANSWER_X+m_chAnswerNo*ANSWER_GAP_X, ANSWER_Y );
							m_spQBox.SetXY0		( QBOX_X+m_chQNo*QBOX_GAP_X, QBOX_Y );
							m_spQNo.SetTexNo	( (u16)m_chQNo );
							return true;
						}
					}
				}
				for( int i = 0; i < KEYBOARD_ANSWER_NUM; i++ )	m_chAnswerData[i] = -1;
				m_chQNo++;

				if( m_chQNo == Q_NO ){	//	S񓚂
					m_Proc = PROC_CHECK;
				}else{
					gpSound->mPlaySE( SFX_SYS_PNL_OK );	
					m_chAnswerNo = 0;
					m_spASelect.SetXY0( ANSWER_X+m_chAnswerNo*ANSWER_GAP_X, ANSWER_Y );
					m_spQBox.SetXY0		( QBOX_X+m_chQNo*QBOX_GAP_X, QBOX_Y );
					m_spQNo.SetTexNo	( (u16)m_chQNo );
				}
				break;
			
			case ESC_NO:
				SetCursolDisp( false );
				K7EVENT_SCN_VAR(K7SCN05,EVVA_ANSWER) = (u8)m_chQNo;
				m_sNowAnswer = KEYBOARD_CANCEL;
				m_Proc = PROC_CANCEL;
				break;
			
			default:
				m_chAnswerData[m_chAnswerNo] = m_chSelect;	//	
				if( ++m_chAnswerNo > KEYBOARD_ANSWER_NUM-1 ){
					m_chAnswerNo = KEYBOARD_ANSWER_NUM-1;
				}
				m_spASelect.SetXY0( ANSWER_X+m_chAnswerNo*ANSWER_GAP_X, ANSWER_Y );
				break;
			}
			break;
		}
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			if( m_chAnswerNo > 0 ){
				if( m_chAnswerNo == 9 ){
					if( m_chAnswerData[m_chAnswerNo] == -1 ){
						m_chAnswerData[8] = -1;
					}else{
						m_chAnswerData[9] = -1;
					}
				}else{
					m_chAnswerData[m_chAnswerNo-1] = -1;
				}
			}
			m_chAnswerData[m_chAnswerNo] = -1;
			if( m_chAnswerNo == 9 ){
				if( m_chAnswerData[8] != -1 ){
					m_chAnswerNo = 9;
				}else{
					m_chAnswerNo = 8;
				}
			}else{
				if( --m_chAnswerNo < 0 ){
					m_chAnswerNo = 0;
				}
			}
			m_spASelect.SetXY0	( ANSWER_X+m_chAnswerNo*ANSWER_GAP_X, ANSWER_Y );			
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
			SetCursolPosition( &(Vec){ENTER_X, ENTER_Y, 0.0f} );
			m_chSaveNoL = 20;
			m_chSaveNoR	= 11;
			m_chSelect = ENTER_NO;
			m_iKeyTime = 0;
			break;
		}
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		if( ++m_iTime > 20 ){
			m_iTime = 0;
			if( !m_bAnswer ){
				m_sNowAnswer = KEYBOARD_CANCEL;
				m_Proc = PROC_CANCEL;
			}else{
				m_sNowAnswer = KEYBOARD_CLEAR;
				SetCursolDisp( false );
				m_Proc = PROC_FADE;
			}
		}
		break;
		
	case 	PROC_FADE:
		if( m_spFade.AddAlpha(50) ){
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelKeyBoard::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spQNo.Render();
	m_spSelect.Render();
	m_spQBox.Render();
	m_spASelect.Render();
	m_spEnter.Render();
	SetKeyAnswer();
	RenderQ();
	m_spFade.Render();
	return true;
}


//========================================================================
// J[\̂ۂ
//========================================================================
void	SK7PanelKeyBoard::SetCursolPos()
{
	VEC2 vPos;
	u8 KeyNo;
	
	if( m_chSelect < tblSideNo[1] )			KeyNo = 0;
	else if( m_chSelect < tblSideNo[2] )	KeyNo = 1;
	else if( m_chSelect < tblSideNo[3] )	KeyNo = 2;
	else									KeyNo = 3;
	
	gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );	
	vPos = tblKeyPos[ KeyNo ];
	SetCursolPosition( &(Vec){ vPos.x + (m_chSelect-tblSideNo[KeyNo])*KEY_GAP_X +SELECT_SIZE*0.5f, vPos.y+SELECT_SIZE*0.5f, 0.0f} );	
}


//========================================================================
// ㉺̈ړ
//========================================================================
u8		SK7PanelKeyBoard::GetUpDownNo( bool upflag )
{
	u8 KeyNo;
	
	if( m_chSelect < tblSideNo[1] )			KeyNo = 0;
	else if( m_chSelect < tblSideNo[2] )	KeyNo = 1;
	else if( m_chSelect < tblSideNo[3] )	KeyNo = 2;
	else									KeyNo = 3;
	
	const u8 tblDownNo[]={ 11,10,9, 0 };
	const u8 tblUpNo[]={ 0, 11, 10, 9,};
	
	//	[
	if( !upflag ){
		if( m_chSelect == 10 || m_chSelect == 20 )	KeyNo++;
	}else{
		if( m_chSelect == 20 ){
			KeyNo++;
		}
	}
	if( upflag ) return tblUpNo[KeyNo];
	else		 return tblDownNo[KeyNo];
}


//========================================================================
// 	蕶
//========================================================================
void			SK7PanelKeyBoard::RenderQ(void)
{
	m_pYFont->DrawSetup();
	m_pYFont->SetColor2( 0x000000ff );
	m_pYFont->SetExRate( QFONT_EX );
	if( m_Proc == PROC_FIRST ){
		m_pYFont->DrawStrPack( QFONT_X, QFONT_Y, 0 );
		m_pYFont->DrawStrPack( QFONT_X, QFONT_Y, 0 );
	}else{
//		m_pYFont->SetExRate		( 0.80f );
		if( m_chQNo >= 9 )	 m_chQNo = 9;
		f32 size = m_pYFont->DrawStrPack	( QFONT_X, QFONT_Y, m_chQNo+1 );
		
		SK7Sprite sprite;
		sprite.SetSprite	( QFONT_X+size+8.0f, QFONT_Y, 24, 24, 0x000000ff );
		sprite.SetVisible	( true );
		sprite.Render		();

		//	_Ł`
		m_Alpha+=m_chPlusAlpha;
		if( m_Alpha >= 255 ){
			m_Alpha = 255;
			m_chPlusAlpha = (s8)-ADD_ALPHA;
		}
		if( m_Alpha <= 0 ){
			m_Alpha = 0;			
			m_chPlusAlpha = ADD_ALPHA;
		}
		GXColor color={0x68, 0xff,0x67, m_Alpha};
		m_pYFont->DrawSetup();
		m_pYFont->SetColor	( &color );	
		m_pYFont->DrawFSStr	( QFONT_X+size+15.0f, QFONT_Y, false, true, "?" );
	}
}


//========================================================================
// 	L[
//========================================================================
void			SK7PanelKeyBoard::SetKeyAnswer(void)
{
	char* word;
	for( int i = 0; i < KEYBOARD_ANSWER_NUM; i++ ){
		switch( m_chAnswerData[i] ){
		case -1:	word = " ";	break;
		case 0:		word = "1";	break;
		case 1:		word = "2"; break;
		case 2:		word = "3"; break;
		case 3:		word = "4"; break;
		case 4:		word = "5"; break;
		case 5:		word = "6"; break;
		case 6:		word = "7"; break;
		case 7:		word = "8"; break;
		case 8:		word = "9"; break;
		case 9:		word = "0"; break;
		case 10:	word = "-"; break;
		case 11:	word = "Q"; break;
		case 12:	word = "W"; break;
		case 13:	word = "E"; break;
		case 14:	word = "R"; break;
		case 15:	word = "T"; break;
		case 16:	word = "Y"; break;
		case 17:	word = "U"; break;
		case 18:	word = "I"; break;
		case 19:	word = "O"; break;
		case 20:	word = "P"; break;
		case 21:	word = "A"; break;
		case 22:	word = "S"; break;
		case 23:	word = "D"; break;
		case 24:	word = "F"; break;
		case 25:	word = "G"; break;
		case 26:	word = "H"; break;
		case 27:	word = "J"; break;
		case 28:	word = "K"; break;
		case 29:	word = "L"; break;
		case 30:	word = "Z"; break;
		case 31:	word = "X"; break;
		case 32:	word = "C"; break;
		case 33:	word = "V"; break;
		case 34:	word = "B"; break;
		case 35:	word = "N"; break;
		case 36:	word = "M"; break;
		case 37:	word = ","; break;
		case 38:	word = "."; break;
		}
		m_pYFont->DrawSetup();
		m_pYFont->SetExRate( 1.0f );
		m_pYFont->SetColor2( PANEL_COLOR );
		m_pYFont->DrawFSStr( ANSWER_WORD_X+i*ANSWER_GAP_X, ANSWER_WORD_Y, false, true, word );
	}
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelKeyBoard::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelKeyBoard::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelKeyBoard::mGetResult(void)
{
	if( mGetSelectEnd() == false ){
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelKeyBoard::LoadTexData()
{
	if( LoadPackData( KEYBOARD_PACK_DATA, TEX_055500_MAX, PANEL_FONT_YAMADA )){
		m_spBG.SetTexSprite	( 0, 0, &m_pTexture[TEX_055500_BASE] );
		m_spBG.SetVisible	( true );

		m_spQNo.SetTexSprite( 125, 98, &m_pTexture[TEX_055500_QNUMBER], 5, 2, (u8)K7EVENT_SCN_VAR(K7SCN05,EVVA_ANSWER) );
		m_spQNo.SetVisible	( false );
		
		m_spQBox.SetSprite	( QBOX_X+m_chQNo*QBOX_GAP_X, QBOX_Y, 5, 5, PANEL_COLOR );
		m_spQBox.SetVisible	( true );
		
		m_spASelect.SetTexSprite( ANSWER_X, ANSWER_Y, &m_pTexture[TEX_055500_A_WAKU] );
		m_spASelect.SetColor	( PANEL_COLOR );
		m_spASelect.SetVisible	( true );
		
		m_spEnter.SetTexSprite	( 481, 282, &m_pTexture[TEX_055500_ENTER] );
		m_spEnter.SetColor		( PANEL_COLOR );
		m_spEnter.SetVisible	( false );
		
		m_spSelect.SetTexSprite	( 481, 282, &m_pTexture[TEX_055500_KEYDOWN] );
		m_spSelect.SetVisible	( false );

		return true;
	}
	return false;
}