////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Poster
//
// SK7PanelLaundry.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELLAUNDRY_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelLaundry.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7Event.h"
#include "../Yam/YK7EffectMessage2.h"


//========================================================================
//					RXgN^
//========================================================================
SK7PanelLaundry::SK7PanelLaundry( s32 Now ) : SK7PanelBase( Now, -1, false )
{
	//vZX	----------------------------------------------
	m_Proc 			= PROC_LOAD;
	m_TexProc 		= LOAD_BG;
	m_iMessageNo	= (int)Now;
	m_ulEffectID	= 0;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);		
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelLaundry::~SK7PanelLaundry()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelLaundry::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_CHECK_MESSAGE;
		}
		break;

	//	I`FbNH
	case	PROC_CHECK_MESSAGE:
//		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
//			m_Proc = PROC_CANCEL;
//			break;
//		}
		if( m_iMessageNo == 0 ){
			if( DrawMessage( 0 ) ){
				m_Proc = PROC_CANCEL;
				break;
			}
		}else{
			if( CheckMessage( 1 ) ){
				m_Proc = PROC_CANCEL;
				break;
			}
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
//					plVXebZ[W
//========================================================================
bool		SK7PanelLaundry::CheckMessage( u16 MesNo )
{
	//	bZ[W`FbN	----------------------------------
	if( m_cCheckJmbHandle == -1 )	return true;
	
	switch( m_MecProc ){
	case eMesLoad:
		m_pEffectMessage = CreateMessage2Effect(m_cCheckJmbHandle, MesNo, TRUE );
		m_ulEffectID = GetEffectID( m_pEffectMessage );
		gpSound->mStopSE(SFX_SCE0_DRY_KEY_LOOP);
		m_MecProc = eMesCheck; 
		break;
	case eMesCheck:
		if( CheckEffectValidState( m_pEffectMessage, m_ulEffectID ) == FALSE ){
			m_MecProc = eMesEnd; 		
		}
		break;
	case eMesEnd:	
		m_MecProc = eMesLoad;
		return true;
	}
	return false;
}


//========================================================================
// _O
//========================================================================
bool		SK7PanelLaundry::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
		
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelLaundry::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelLaundry::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelLaundry::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelLaundry::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( "Texture/Poster/POSTER_000102.BIN" ) )
		{
			return true;
		}
		break;

	}
	return false;
}