////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Locker
//
// SK7PanelLocker.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELLOCKER_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelLocker.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"


//========================================================================
//					RXgN^
//========================================================================
SK7PanelLocker::SK7PanelLocker( s32 Now ) : SK7PanelBase( Now )
{	
	//	TCg	----------------------------------------------
	SetCursolPosition( &(Vec){558,280,0} );
	
	m_sNowAnswer = ( Now == 3 ) ? LOCKER_OK : LOCKER_MISS;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	io[XvCg	-------------------------------------------
	m_spNo.SetXY0( 528.0f, 42.0f );
	m_spNo.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
	m_spNo.SetTexNo((u8)Now);
	
	//	L[XvCg	----------------------------------------------	
	m_spKey.SetXY0( 427.0f, 212.0f );
	m_spKey.SetVisible(true);
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelLocker::~SK7PanelLocker()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spNo.Delete();
	m_spKey.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelLocker::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		switch( CheckAnswer(4) )
		{
		case	PANEL_CHECK_RETURN:				//Ȃ
			m_sNowAnswer = LOCKER_CANCEL;
			m_Proc = PROC_CANCEL;
			break;

		case	PANEL_CHECK_SET:				//
			if( m_sNowAnswer == LOCKER_OK ){
				m_spKey.SetVisible(false);
			}
			m_Proc = PROC_TIME;
			break;
		}
		break;
#if 0
			if( m_sNowAnswer == LOCKER_OK ){
				m_spKey.SetVisible(false);
				m_pEffect = CreateMessage2Effect( m_cJmbHandle, PNLMES_CLEAR, TRUE );
			}else{
				m_pEffect = CreateMessage2Effect( m_cJmbHandle, PNLMES_MISS, TRUE );
			}
			SetCursolDisp( false );
			m_Proc = PROC_TIME;
			break;
		}
		break;
#endif
	//	Ԃ܂傤@	---------------------------------		
	case 	PROC_TIME:
		if( DrawMessage(0) ){
			m_Proc = PROC_MESSAGE;
		}
#if 0
		if( !GetEffectValidState( m_pEffect )){
			m_Proc = PROC_MESSAGE;
		}
#endif
		break;
	
	case PROC_MESSAGE:
		if( m_sNowAnswer == LOCKER_OK ){
			if( DrawMessage(2) ){
				m_Proc = PROC_MESSAGE2;
			}
		}else{
			if( DrawMessage(1) ){
				m_Proc = PROC_CANCEL;
			}
		}
		break;
	
	case	PROC_MESSAGE2:
		if( DrawMessage(3) ){
			m_Proc = PROC_CANCEL;
		}
		break;
			

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelLocker::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spKey.Render();
	m_spNo.Render();
			
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelLocker::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelLocker::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelLocker::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelLocker::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL011201TEX_BG ) )
		{
			m_TexProc = LOAD_KEY;
		}
		break;
	case	LOAD_KEY:
		if( m_spKey.LoadTexture( PNL011201TEX_KEY ))
		{
			m_TexProc = LOAD_NO;
		}
		break;
	case	LOAD_NO:
		if( m_spNo.LoadTexture( PNL011201TEX_NO,1,8 ))
		{
			return true;
		}
		break;
	}
	return false;
}