////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel ManageKey
// 
// SK7PanelManageKey.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELMANAGEKEY_H__
#define	__SK7PANELMANAGEKEY_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l	--------------------------------------------------------------
#define		ROOM_NO_101				(16) 	//	101
#define		ROOM_NO_102				(17)	//	102
#define		ROOM_NO_103				(18)	//	103
#define		ROOM_NO_201				(4)		//	201
#define		ROOM_NO_202				(5)		//	202
#define		ROOM_NO_203				(6)		//	203
#define		ROOM_NO_204				(7)		//	204
#define		ROOM_NO_205				(8)		//	205
#define		ROOM_NO_206				(9)		//	206
#define		ROOM_NO_207				(10)	//	207
#define		ROOM_NO_208				(11)	//	208
#define		ROOM_NO_209				(12)	//	209
#define		ROOM_NO_210				(13)	//	210
#define		ROOM_NO_301				(0)		//	301
#define		ROOM_NO_302				(1)		//	302
#define		ROOM_NO_303				(2)		//	303
#define		ROOM_NO_304				(3)		//	304
#define		ROOM_CANCEL				(-1)	//	LZ




//		---------------------------------------------------------------
#define		KEYHOLE_X0				(128)
#define		KEYHOLE_Y0				(258)
#define		KEYHOLE_X1				(300)
#define		KEYHOLE_Y1				(100)
#define		KEYHOLE_GAPX			(92)
#define		KEYHOLE_GAPY			(79)
#define		KEYHOLE_MAXW			(4)
#define		KEYHOLE_MAXH			(5)
#define		KEYHOLE_NUM				(20)

#define		KEY_GAPX				(20.0f)
#define		KEY_GAPY				(15.0f)
#define		KEY_NUM					(5)

#define		PLUG_GAP_X				(-33.0f)
#define		PLUG_GAP_Y				(-60.0f)

#define		AFTERKEY_X				(-19.0f)
#define		AFTERKEY_Y				(-12.0f)

#define		LAMP_X0					(83)
#define		LAMP_Y0					(207)

#define		LAMP_X					(-47.0f)
#define		LAMP_Y					(-52.0f)
#define		LAMP_NUM				(18)

#define		DRAW_KEYTIME			(30)
	
//	eNX`[pX	---------------------------------------------------
#define	PNL000104TEX_BG				"Texture/000104/patch03_01.BIN"
#define	PNL000104TEX_KEY			"Texture/000104/patch03_plug.BIN"
//#define	PNL000104TEX_KEY_AFTER		"Texture/000104/Open_Key.BIN"
#define	PNL000104TEX_LAMP			"Texture/000104/light2.BIN"


//---- class ----
class SK7PanelManageKey : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_KEYSET,
		PROC_TIME,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		
		LOAD_BG,
		LOAD_KEY,
		LOAD_LAMP,
	}eLoadTexProc;
	

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spKey;				//	
	SK7Sprite				m_spLamp;				//	v
	SK7Sprite				m_spLampMain;

	u8						m_ucSelectNo;			//	ZNgԍ
	Vec						m_vSightPos;			//	|WV
	bool					m_bKeyFlag;				//	Ă邩ǂH
	u32						m_lDrawTime;			//	`掞
	int						m_iCancelTime;
	u8						m_ucSaveAns;

public:
	SK7PanelManageKey( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelManageKey();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
};

#endif	//__SK7PANELMANAGEKEY_H__
