////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelMatsu.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELMATSU_CPP__
//#define	__DEBUGMATSU__

#include "SK7PanelMatsu.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

#define	MATSU_FADEIN_TIME			(10)
#define	ALIVE_MAX_ALPHA1			(180)
#define	ALIVE_MAX_ALPHA2			(180)
#define	DEATH_ALPHA_TIME			(30*4)
#define NOT_SELECT_COLOR			(0xf0f0f0ff)
#define	FONT_SELECT_COLOR_ALIVE		(0x0f0fdcff)
#define FONT_SELECT_COLOR_DEATH		(0xdc0f0fff)
#define	SHADOW_FONT_ALPHA1			(0x7f)
#define	SHADOW_FONT_ALPHA2			(0xbf)
#define	FONT_MOVE_SIZE				(10)
#define	FONT_MOVE_FRAME				(15)
#define	FONT_EX_TIME				(10)
#define	MUZZLE_TIME					(4)
#define	MUZZLE_MOVE_TIME			(4)
#define	GUNSHOT_ALPHA				(127)
#define	MUZZLE_WAIT_TIME			(30)
#define	MUZZLE_ALPHA_TIME			(30*2)
#define	FONT_SHADOW_X				(4)
#define	FONT_SHADOW_Y				(4)
#define	LETTER_Y					(34)


#define	MATSU_PACK_DATA			"/Texture/panel/057500.pak"

const VEC2 tblDFontPos[]={
	188,97,
	228,151,
};
const VEC2 tblAFontPos[]={
	371,97,
	407,151,
	437,184,
};

const f32 	tblAFontEx[]={
	1.0f, 0.75f, 0.6f,
};
const f32 	tblDFontEx[]={
	1.0f, 0.75f,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelMatsu::SK7PanelMatsu( s32 Now ) : SK7PanelBase( Now, -1, false  )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= 0;
	m_chSelect		= 0;
	m_iTime 		= 0;
	m_iMuzzleTime	= 0;
	m_bAlive		= false;
	m_bAliveBgFlag	= false;
		
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;

	m_spFlash.SetSprite( 0, 0, 640, 480, 0xff000000 );
	m_spFlash.SetVisible( false );
	m_spBack.SetSprite( 0, 0, 640, 480, 0x000000ff );
	m_spBack.SetVisible( false );
	m_spLast.SetXY0( 0, LETTER_Y );
	m_spLast.SetVisible( false );
	SetCursolDisp( false );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelMatsu::~SK7PanelMatsu()
{ 
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelMatsu::FrameProcess(void)
{	
	//	tHggkړ
	if( m_Proc > PROC_LOAD && m_Proc < PROC_CHECK )	MoveFontEx();		

	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			m_Proc = PROC_FADEIN;
		}
		break;
		
	//	tF[hC	=================================================
	case 	PROC_FADEIN:
#ifdef __DEBUGMATSU__
		static int time=0;
		if( ++time > 30 ){
			time = 31;
		}else{
			break;
		}
#endif
		if( MoveFadeIn() ){
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;

		//	tbV
		m_spBG.SetColor( 0xffffffff );
		
		//	܂傤	-----------------------------------------
		if( CheckKeyN( SK7_KEY_RIGHT ) ){
			if( m_sNowAnswer == MATSU_KILL ){
				gpSound->mPlaySE( SFX_SCE6_MATSU_IKASU );
				m_sNowAnswer = MATSU_NIGASU;
				MoveFontDirection( FRAME_FONT_NONE );
				break;
			}
			MoveFontDirection( FRAME_FONT_ALIVE );
			MoveAlive();
			if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
				m_spFlash.SetVisible( true );
				m_spFlash.SetColor	( 0xf0f0f000 );
				m_sNowAnswer = MATSU_NIGASU;
				gpSound->mPlaySE( SFX_SCE6_MATSU_DECIDE );
				m_Proc = PROC_CHECK;
			}
			break;
		}
		if( CheckKeyN( SK7_KEY_LEFT ) ){
			if( m_sNowAnswer == MATSU_NIGASU ){
				gpSound->mPlaySE( SFX_SCE6_MATSU_YARU );
				m_sNowAnswer = MATSU_KILL;
				MoveFontDirection( FRAME_FONT_NONE );				
				break;
			}
			MoveFontDirection( FRAME_FONT_DEATH );
			MoveDeath();
			m_spBG.SetColor( FONT_SELECT_COLOR_DEATH );
			if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
				m_spFlash.SetVisible( true );
				m_spFlash.SetColor	( 0xf0f0f000 );
				m_sNowAnswer = MATSU_KILL;
				gpSound->mPlaySE( SFX_SCE6_MATSU_DECIDE );
				m_Proc = PROC_CHECK;
			}
			break;
		}
		MoveFontDirection( FRAME_FONT_NONE );
		
#ifdef __DEBUGMATSU__
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			m_Proc = PROC_CANCEL;
			break;
		}
#endif
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		if( m_spFlash.AddAlpha( 5 ) ){
			m_spLast.SetVisible( true );
			if( m_sNowAnswer == MATSU_KILL ){
				m_spLast.SetTexture( &m_pTexture[TEX_057500_DEATH] );
			}else{
				m_spLast.SetTexture( &m_pTexture[TEX_057500_ALIVE] );
			}
			m_Proc = PROC_TIME;
		}
		break;
			
	case	PROC_TIME:
		if( m_spFlash.DownAlpha( 10 ) ){
			m_Proc = PROC_CANCEL;
		}
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelMatsu::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	int i;
	m_spBG.Render();					//	wi
	m_spAliveBG.Render();
	
	m_spAlive[0].Render();
	m_spAlive[1].Render();
	
	m_spGunShot.Render();
	m_spFace.Render();
	for( i = 0; i < MUZZLE_MAX_NUM; i++ ){
		m_Muzzle[i].spMuzzle.Render();
	}
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	for( i = 0; i < ALIVE_FONT_NUM; i++ ){
		m_MFAliveS[i].spFont.Render();
	}
	for( i = 0; i < ALIVE_FONT_NUM; i++ ){
		m_MFAlive[i].spFont.Render();	
	}
	m_MFDeathS[0].spFont.Render();
	for( i = 0; i < DEATH_FONT_NUM; i++ ){
		m_MFDeathS[i].spFont.Render();
	}
	for( i = 0; i < DEATH_FONT_NUM; i++ ){	
		m_MFDeath[i].spFont.Render();
	}
		
	m_spBack.Render();
	m_spLast.Render();
	m_spFlash.Render();
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelMatsu::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelMatsu::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelMatsu::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelMatsu::LoadTexData()
{
	int i;
	if( LoadPackData( MATSU_PACK_DATA, TEX_057500_MAX )){
		m_spAliveBG.SetTexSprite( 0, LETTER_Y, &m_pTexture[TEX_057500_ALIVEBG] );
		m_spAliveBG.SetAlpha( 0 );
		m_spAliveBG.SetVisible( true );
		//	wi
		m_spBG.SetTexSprite	( 0, LETTER_Y, &m_pTexture[TEX_057500_MAT_BACK_GROUND] );
		m_spBG.SetAlpha		( 0 );
		m_spBG.SetVisible	( true );
		
		//	Ă摜
		m_spAlive[0].SetTexSprite	( 452, 76, &m_pTexture[TEX_057500_ALIVE01] );
		m_spAlive[0].SetAlpha		( ALIVE_MAX_ALPHA1 );
		m_spAlive[0].SetVisible		( false );
		m_spAlive[1].SetTexSprite	( 20, 74, &m_pTexture[TEX_057500_ALIVE02] );
		m_spAlive[1].SetAlpha		( 0 );
		m_spAlive[1].SetVisible		( false );
		
		//	S摜
		m_spGunShot.SetTexSprite	( 0, 0, &m_pTexture[TEX_057500_GUN_SHOT] );
		m_spGunShot.SetVisible		( false );
		m_spGunShot.SetAlpha		( GUNSHOT_ALPHA );
		m_spFace.SetTexSprite		( 0, 0, &m_pTexture[TEX_057500_GUN_SHOT2] );
		m_spFace.SetVisible			( false );
		m_spFace.SetFlag			( true, CENTER_FLAG );
		m_spFace.SetEX				( 0.5f );

		//	}Y
		for( i = 0; i < MUZZLE_MAX_NUM; i++ ){
			m_Muzzle[i].spMuzzle.SetTexSprite	( 0, 0, &m_pTexture[TEX_057500_MUZZLE01+i] );
			m_Muzzle[i].spMuzzle.SetFlag		( true, CENTER_FLAG );
			m_Muzzle[i].spMuzzle.SetVisible	( false );
			m_Muzzle[i].spMuzzle.SetBlendNo	( SPR_BLEND_ONE );
			m_Muzzle[i].AddTime = 0;
			m_Muzzle[i].SaveEx	= 0;
		}
		SetDeathData();
		
		// tHg
		for( i = 0; i < ALIVE_FONT_NUM; i++ ){
			m_MFAlive[i].spFont.SetTexSprite	( tblAFontPos[i].x, tblAFontPos[i].y, &m_pTexture[TEX_057500_SEI+i] );
			m_MFAlive[i].spFont.SetFlag			( true, RENDER_FLAG|CENTER_FLAG );
			m_MFAlive[i].spFont.SetEX			( tblAFontEx[i] );
			m_MFAlive[i].spFont.SetColor		( NOT_SELECT_COLOR );
			m_MFAlive[i].spFont.SetAlpha		( 0 );
			m_MFAliveS[i].spFont.SetTexSprite	( tblAFontPos[i].x+FONT_SHADOW_X, tblAFontPos[i].y+FONT_SHADOW_Y, &m_pTexture[TEX_057500_SEI+i] );
			m_MFAliveS[i].spFont.SetFlag		( true, CENTER_FLAG );
			m_MFAliveS[i].spFont.SetVisible		( false );
			m_MFAliveS[i].spFont.SetEX			( tblAFontEx[i] );
			m_MFAliveS[i].spFont.SetColor		( 0x00000000 );
			m_MFAlive[i].fExSpeed 	= 0;
			m_MFAlive[i].iExTime 	= m_MFAlive[i].iExAddTime = m_MFAlive[i].iMoveTime = 0;
			m_MFAliveS[i].fExSpeed 	= 0;
			m_MFAliveS[i].iExTime 	= m_MFAliveS[i].iExAddTime = m_MFAliveS[i].iMoveTime = 0;
			SetMoveDirection( &m_MFAlive[i] );
			SetMoveDirection( &m_MFAliveS[i] );
			SetFontEx( &m_MFAlive[i], i );
			SetFontEx( &m_MFAliveS[i], i );
		}
		for( i = 0; i < DEATH_FONT_NUM; i++ ){
			m_MFDeath[i].spFont.SetTexSprite	( tblDFontPos[i].x, tblDFontPos[i].y, &m_pTexture[TEX_057500_SATSU+i] );
			m_MFDeath[i].spFont.SetFlag			( true, RENDER_FLAG|CENTER_FLAG );
			m_MFDeath[i].spFont.SetEX			( tblDFontEx[i] );
			m_MFDeath[i].spFont.SetColor		( NOT_SELECT_COLOR );
			m_MFDeath[i].spFont.SetAlpha		( 0 );
			m_MFDeathS[i].spFont.SetTexSprite	( tblDFontPos[i].x+FONT_SHADOW_X, tblDFontPos[i].y+FONT_SHADOW_Y, &m_pTexture[TEX_057500_SATSU+i] );
			m_MFDeathS[i].spFont.SetFlag		( true, CENTER_FLAG );
			m_MFDeathS[i].spFont.SetVisible		( false );
			m_MFDeathS[i].spFont.SetEX			( tblDFontEx[i] );
			m_MFDeathS[i].spFont.SetColor		( 0x00000000 );
			m_MFDeath[i].fExSpeed 	= 0;
			m_MFDeath[i].iExTime 	= m_MFDeath[i].iExAddTime = m_MFDeath[i].iMoveTime = 0;
			m_MFDeathS[i].fExSpeed 	= 0;
			m_MFDeathS[i].iExTime 	= m_MFDeathS[i].iExAddTime = m_MFDeathS[i].iMoveTime = 0;	
			SetMoveDirection( &m_MFDeath[i] );
			SetMoveDirection( &m_MFDeathS[i] );
			SetFontEx( &m_MFDeath[i], i );
			SetFontEx( &m_MFDeathS[i],i );
		}
		return true;
	}
	return false;
}

//========================================================================
// ZbgSf[^
//========================================================================
void		SK7PanelMatsu::SetDeathData()
{
	//	Xg\
	int GunX = rand()*(160+1)/RAND_MAX%(160+1);
	int GunY = rand()*(115+1)/RAND_MAX%(115+1)+45;
	m_spGunShot.SetXY0		( GunX, GunY );
	m_spGunShot.SetVisible	( false );
	m_spGunShot.SetAlpha	( ALIVE_MAX_ALPHA1 );

	//	tFCX\	
	int FaceX = rand()*(260+1)/RAND_MAX%(260+1)+320+64;
	int FaceY = rand()*(240+1)/RAND_MAX%(240+1)+200;
	m_spFace.SetXY0		( FaceX, FaceY );
	m_spFace.SetAlpha	( 30 );
	m_spFace.SetEX		( 0.5f );
	m_spFace.SetVisible	( false );

	//	}Y
	int MuzX, MuzY, Ex;
	for( int i = 0; i < MUZZLE_MAX_NUM; i++ ){
		MuzX 	= rand()*(320+1)/RAND_MAX%(320+1);
		MuzY 	= rand()*(160+1)/RAND_MAX%(160+1)+290;
		Ex 		= rand()*(4+1)/RAND_MAX%(4+1)+6;
		m_Muzzle[i].SaveEx 	= Ex*0.1f;
		m_Muzzle[i].AddTime 	= 0;
		m_Muzzle[i].spMuzzle.SetXY0	( MuzX, MuzY );
		m_Muzzle[i].spMuzzle.SetAlpha	( 0xff );
		m_Muzzle[i].spMuzzle.SetEX		( Ex*0.1f );
		m_Muzzle[i].spMuzzle.SetVisible( false );
	}
	m_iMuzzleTime = 0;
}

//========================================================================
// tF[h
//========================================================================
bool		SK7PanelMatsu::MoveFadeIn()
{
	int i;
	bool retcode = m_spBG.AddAlpha( MATSU_FADEIN_TIME );
	for( i = 0; i < ALIVE_FONT_NUM; i++ ){
		m_MFAlive[i].spFont.AddAlpha	( MATSU_FADEIN_TIME );
		m_MFAliveS[i].spFont.AddAlpha	( MATSU_FADEIN_TIME );
	}
	for( i = 0; i < DEATH_FONT_NUM; i++ ){
		m_MFDeath[i].spFont.AddAlpha	( MATSU_FADEIN_TIME );
		m_MFDeathS[i].spFont.AddAlpha	( MATSU_FADEIN_TIME );
	}
	return retcode;
}

//========================================================================
// gkZbg
//========================================================================
void		SK7PanelMatsu::SetFontEx( MOVE_FONT* pF, int no )
{
	f32 Ex;
	const int tblSize[]={8, 6, 5};
	Ex = ( rand()*(4+1)/RAND_MAX%(4+1)+tblSize[no])*0.1f;
	pF->iExTime 	= rand()*(FONT_EX_TIME+1)/RAND_MAX%(FONT_EX_TIME+1)+2;
	pF->fExSpeed 	= (Ex - pF->spFont.GetExX())/(f32)pF->iExTime;
	pF->iExAddTime 	= 0;
}
		
//========================================================================
// gkړ
//========================================================================
void		SK7PanelMatsu::MoveFontEx()
{
	int i;
	for( i = 0; i < ALIVE_FONT_NUM; i++ ){
		m_MFAlive[i].spFont.SetEX( m_MFAlive[i].spFont.GetExX()+m_MFAlive[i].fExSpeed );
		if(  ++m_MFAlive[i].iExAddTime >= m_MFAlive[i].iExTime ){
			SetFontEx( &m_MFAlive[i], i );
		}
#if 1
		m_MFAliveS[i].spFont.SetEX( m_MFAliveS[i].spFont.GetExX()+m_MFAliveS[i].fExSpeed );
		if(  ++m_MFAliveS[i].iExAddTime >= m_MFAliveS[i].iExTime ){
			SetFontEx( &m_MFAliveS[i], i );
		}
#endif
	}	
	for( i = 0; i < DEATH_FONT_NUM; i++ ){
		m_MFDeath[i].spFont.SetEX( m_MFDeath[i].spFont.GetExX()+m_MFDeath[i].fExSpeed );
		if(  ++m_MFDeath[i].iExAddTime >= m_MFDeath[i].iExTime ){
			SetFontEx( &m_MFDeath[i], i );
		}
#if 1
		m_MFDeathS[i].spFont.SetEX( m_MFDeathS[i].spFont.GetExX()+m_MFDeathS[i].fExSpeed );
		if(  ++m_MFDeathS[i].iExAddTime >= m_MFDeathS[i].iExTime ){
			SetFontEx( &m_MFDeathS[i], i );
		}
#endif
	}
}


//========================================================================
// ړZbg
//========================================================================
void		SK7PanelMatsu::SetMoveDirection( MOVE_FONT* pF )
{
	f32 SpeedAngle=0.0f;
	SpeedAngle = MTXDegToRad(rand()%360);
	pF->vMove.x = ( FONT_MOVE_SIZE * cosf(SpeedAngle))/FONT_MOVE_FRAME;
	pF->vMove.y = ( FONT_MOVE_SIZE * sinf(SpeedAngle))/FONT_MOVE_FRAME;
	pF->iMoveTime = 0;
}


//========================================================================
// ړ
//========================================================================
void		SK7PanelMatsu::MoveFontDirection( u8 flag )
{
	int i;
	switch( flag ){
	case FRAME_FONT_ALIVE:
		for( i = 0; i < ALIVE_FONT_NUM; i++ ){
			m_MFAlive[i].spFont.SetColor	( 0xffffffff );
			m_MFAliveS[i].spFont.SetColor	( 0x0000007f );
			m_MFAlive[i].spFont.SetVisible( true );
			m_MFAliveS[i].spFont.SetVisible( true );
		
			m_MFAlive[i].spFont.SetIncXY	( m_MFAlive[i].vMove.x, 	m_MFAlive[i].vMove.y );
			if( ++m_MFAlive[i].iMoveTime >= FONT_MOVE_FRAME ){
				SetMoveDirection( &m_MFAlive[i] );
			}else{
				if( m_MFAlive[i].spFont.GetX0() > tblAFontPos[i].x+FONT_MOVE_SIZE ){
					m_MFAlive[i].spFont.SetX0( tblAFontPos[i].x+FONT_MOVE_SIZE );
					m_MFAlive[i].vMove.x = -m_MFAlive[i].vMove.x;
				}
				else if( m_MFAlive[i].spFont.GetX0() < tblAFontPos[i].x-FONT_MOVE_SIZE ){
					m_MFAlive[i].spFont.SetX0( tblAFontPos[i].x-FONT_MOVE_SIZE );
					m_MFAlive[i].vMove.x = -m_MFAlive[i].vMove.x;
				}
				if( m_MFAlive[i].spFont.GetY0() > tblAFontPos[i].y+FONT_MOVE_SIZE ){
					m_MFAlive[i].spFont.SetY0( tblAFontPos[i].y+FONT_MOVE_SIZE );
					m_MFAlive[i].vMove.y = -m_MFAlive[i].vMove.y;
				}
				else if( m_MFAlive[i].spFont.GetY0() < tblAFontPos[i].y-FONT_MOVE_SIZE ){
					m_MFAlive[i].spFont.SetY0( tblAFontPos[i].y-FONT_MOVE_SIZE );
					m_MFAlive[i].vMove.y = -m_MFAlive[i].vMove.y;
				}
			}
			m_MFAliveS[i].spFont.SetIncXY	( m_MFAliveS[i].vMove.x, 	m_MFAliveS[i].vMove.y );
			if( ++m_MFAliveS[i].iMoveTime >= FONT_MOVE_FRAME ){
				SetMoveDirection( &m_MFAliveS[i] );
			}else{
				if( m_MFAliveS[i].spFont.GetX0() > tblAFontPos[i].x+FONT_MOVE_SIZE ){
					m_MFAliveS[i].spFont.SetX0( tblAFontPos[i].x+FONT_MOVE_SIZE );					
					m_MFAliveS[i].vMove.x = -m_MFAliveS[i].vMove.x;
				}
				else if( m_MFAliveS[i].spFont.GetX0() < tblAFontPos[i].x-FONT_MOVE_SIZE ){
					m_MFAliveS[i].spFont.SetX0( tblAFontPos[i].x-FONT_MOVE_SIZE );					
					m_MFAliveS[i].vMove.x = -m_MFAliveS[i].vMove.x;
				}
				if( m_MFAliveS[i].spFont.GetY0() > tblAFontPos[i].y+FONT_MOVE_SIZE ){
					m_MFAliveS[i].spFont.SetY0( tblAFontPos[i].y+FONT_MOVE_SIZE );					
					m_MFAliveS[i].vMove.y = -m_MFAliveS[i].vMove.y;
				}
				else if( m_MFAliveS[i].spFont.GetY0() < tblAFontPos[i].y-FONT_MOVE_SIZE){
					m_MFAliveS[i].spFont.SetY0( tblAFontPos[i].y-FONT_MOVE_SIZE );					
					m_MFAliveS[i].vMove.y = -m_MFAliveS[i].vMove.y;
				}
			}
		}
		for( i = 0; i < DEATH_FONT_NUM; i++ ){
			m_MFDeath[i].spFont.SetVisible( false );
			m_MFDeathS[i].spFont.SetVisible( false );
		}
		break;

	case FRAME_FONT_DEATH:
		for( i = 0; i < DEATH_FONT_NUM; i++ ){
			m_MFDeath[i].spFont.SetColor	( 0x000000ff );
			m_MFDeathS[i].spFont.SetColor	( 0x0000007f );
			m_MFDeath[i].spFont.SetVisible( true );
			m_MFDeathS[i].spFont.SetVisible( true );

			m_MFDeath[i].spFont.SetIncXY	( m_MFDeath[i].vMove.x, 	m_MFDeath[i].vMove.y );
			if( ++m_MFDeath[i].iMoveTime >= FONT_MOVE_FRAME ){
				SetMoveDirection( &m_MFDeath[i] );
			}else{
				if( m_MFDeath[i].spFont.GetX0() > tblDFontPos[i].x+FONT_MOVE_SIZE ){
					m_MFDeath[i].spFont.SetX0( tblDFontPos[i].x+FONT_MOVE_SIZE );
					m_MFDeath[i].vMove.x = -m_MFDeath[i].vMove.x;
				}
				else if( m_MFDeath[i].spFont.GetX0() < tblDFontPos[i].x-FONT_MOVE_SIZE ){
					m_MFDeath[i].spFont.SetX0( tblDFontPos[i].x-FONT_MOVE_SIZE );
					m_MFDeath[i].vMove.x = -m_MFDeath[i].vMove.x;
				}
				if( m_MFDeath[i].spFont.GetY0() > tblDFontPos[i].y+FONT_MOVE_SIZE ){
					m_MFDeath[i].spFont.SetY0( tblDFontPos[i].y+FONT_MOVE_SIZE );
					m_MFDeath[i].vMove.y = -m_MFDeath[i].vMove.y;
				}
				else if( m_MFDeath[i].spFont.GetY0() < tblDFontPos[i].y-FONT_MOVE_SIZE){
					m_MFDeath[i].spFont.SetY0( tblDFontPos[i].y-FONT_MOVE_SIZE );
					m_MFDeath[i].vMove.y = -m_MFDeath[i].vMove.y;
				}
			}
			m_MFDeathS[i].spFont.SetIncXY	( m_MFDeathS[i].vMove.x, 	m_MFDeathS[i].vMove.y );
			if( ++m_MFDeath[i].iMoveTime >= FONT_MOVE_FRAME ){
				SetMoveDirection( &m_MFDeathS[i] );
			}else{
				if( m_MFDeathS[i].spFont.GetX0() > tblDFontPos[i].x+FONT_MOVE_SIZE ){
					m_MFDeathS[i].spFont.SetX0( tblDFontPos[i].x+FONT_MOVE_SIZE );
					m_MFDeathS[i].vMove.x = -m_MFDeathS[i].vMove.x;				
				}
				else if( m_MFDeathS[i].spFont.GetX0() < tblDFontPos[i].x-FONT_MOVE_SIZE ){
					m_MFDeathS[i].spFont.SetX0( tblDFontPos[i].x-FONT_MOVE_SIZE );
					m_MFDeathS[i].vMove.x = -m_MFDeathS[i].vMove.x;				
				}
				if( m_MFDeathS[i].spFont.GetY0() > tblDFontPos[i].y+FONT_MOVE_SIZE ){
					m_MFDeathS[i].spFont.SetY0( tblDFontPos[i].y+FONT_MOVE_SIZE );
					m_MFDeathS[i].vMove.y = -m_MFDeathS[i].vMove.y;				
				}
				else if( m_MFDeathS[i].spFont.GetY0() < tblDFontPos[i].y-FONT_MOVE_SIZE ){
					m_MFDeathS[i].spFont.SetY0( tblDFontPos[i].y-FONT_MOVE_SIZE );
					m_MFDeathS[i].vMove.y = -m_MFDeathS[i].vMove.y;				
				}
			}
		}
		for( i = 0; i < ALIVE_FONT_NUM; i++ ){
			m_MFAlive[i].spFont.SetVisible( false );
			m_MFAliveS[i].spFont.SetVisible( false );
		}
		break;
		
	case FRAME_FONT_NONE:
		for( i = 0; i < ALIVE_FONT_NUM; i++ ){
			m_MFAlive[i].spFont.SetXY0		( tblAFontPos[i].x, tblAFontPos[i].y );
			m_MFAlive[i].spFont.SetVisible	( true );
			m_MFAlive[i].spFont.SetColor	( NOT_SELECT_COLOR );
			m_MFAliveS[i].spFont.SetXY0		( tblAFontPos[i].x+FONT_SHADOW_X, tblAFontPos[i].y+FONT_SHADOW_Y);
			m_MFAliveS[i].spFont.SetVisible	( true );
			m_MFAliveS[i].spFont.SetColor	( 0x000000bf );
			if( m_MFAlive[i].iMoveTime > 0 )	SetMoveDirection( &m_MFAlive[i] );
			if( m_MFAliveS[i].iMoveTime > 0 ) 	SetMoveDirection( &m_MFAliveS[i] );
		}
		for( i = 0; i < DEATH_FONT_NUM; i++ ){
			m_MFDeath[i].spFont.SetXY0		( tblDFontPos[i].x, tblDFontPos[i].y );
			m_MFDeath[i].spFont.SetVisible	( true );
			m_MFDeath[i].spFont.SetColor	( NOT_SELECT_COLOR );
			m_MFDeathS[i].spFont.SetXY0		( tblDFontPos[i].x+FONT_SHADOW_X, tblDFontPos[i].y+FONT_SHADOW_Y );
			m_MFDeathS[i].spFont.SetVisible	( true );
			m_MFDeathS[i].spFont.SetColor	( 0x000000bf );
			if( m_MFDeath[i].iMoveTime > 0 )	SetMoveDirection( &m_MFDeath[i] );
			if( m_MFDeathS[i].iMoveTime > 0 )	SetMoveDirection( &m_MFDeathS[i] );
		}
		m_spAliveBG.SetAlpha( 0 );
		m_spAliveBG.SetAlphaStart( 0 );
		m_spAlive[0].SetAlphaStart( ALIVE_MAX_ALPHA1 );
		m_spAlive[1].SetAlphaStart( 0 );
		m_spAlive[0].SetAlpha( ALIVE_MAX_ALPHA1 );
		m_spAlive[1].SetAlpha( 0 );
		m_spAlive[0].SetVisible( false );
		m_spAlive[1].SetVisible( false );
		m_bAlive 		= false;
		m_bAliveBgFlag	= false;
		m_iFadeTime = 0;
		if( m_iMuzzleTime > 0 )	SetDeathData();
		break;
	}
}

//========================================================================
// 
//========================================================================
void		SK7PanelMatsu::MoveAlive()
{
	m_spAlive[0].SetVisible( true );
	m_spAlive[1].SetVisible( true );
	if( !m_bAliveBgFlag )	m_spAliveBG.FrameAlphaMove( 60, 255 );
	if( m_bAlive ){
		m_spAlive[0].FrameAlphaMove( 60, ALIVE_MAX_ALPHA1 );
		m_spAlive[1].FrameAlphaMove( 60, 0 );
	}else{
		m_spAlive[0].FrameAlphaMove( 60, 0 );
		m_spAlive[1].FrameAlphaMove( 60, ALIVE_MAX_ALPHA1 );
	}
	if( ++m_iFadeTime >= 60 ){
		m_bAliveBgFlag = true;
		m_bAlive = m_bAlive ? false : true;
		if( m_bAlive ){
			m_spAlive[0].SetAlphaStart( 0 );
			m_spAlive[1].SetAlphaStart( ALIVE_MAX_ALPHA1 );
		}else{
			m_spAlive[0].SetAlphaStart( ALIVE_MAX_ALPHA1 );
			m_spAlive[1].SetAlphaStart( 0 );
		}
		gpSound->mPlaySE( SFX_SCE6_MATSU_IKASUHOYOUJ );
		m_iFadeTime = 0;
	}
	//	E
	for( int i = 0; i < MUZZLE_MAX_NUM; i++ ){
		m_Muzzle[i].spMuzzle.SetVisible( false );
	}
	m_spGunShot.SetVisible	( false );
	m_spFace.SetVisible		( false );
}

//========================================================================
// E
//========================================================================
void		SK7PanelMatsu::MoveDeath()
{
	int i;
	//}Ÿړ	---------------------------------------------------
	for( i = 0; i < MUZZLE_MAX_NUM; i++ ){
		if( !m_Muzzle[i].spMuzzle.CheckFlag( RENDER_FLAG ) ) continue;
		if( (m_Muzzle[i].AddTime%2) == 0 )	m_Muzzle[i].spMuzzle.SetEX( m_Muzzle[i].SaveEx+0.3f-0.04f*m_Muzzle[i].AddTime );
		else								m_Muzzle[i].spMuzzle.SetEX( m_Muzzle[i].SaveEx-0.3f+0.04f*m_Muzzle[i].AddTime );
		if( ++m_Muzzle[i].AddTime >= MUZZLE_MOVE_TIME ){
			m_Muzzle[i].AddTime = MUZZLE_MOVE_TIME;
		}
	}
	if( (++m_iMuzzleTime % MUZZLE_TIME) == 1 && m_iMuzzleTime < MUZZLE_WAIT_TIME+MUZZLE_TIME*4 ){
		for( i = 0; i < MUZZLE_MAX_NUM; i++ ){
			if( m_Muzzle[i].spMuzzle.CheckFlag( RENDER_FLAG ) ) continue;
			gpSound->mPlaySE( SFX_SCE6_MATSU_YARUDANKON );
			m_Muzzle[i].spMuzzle.SetVisible( true );
			return;
		}
		//	}YI
		m_spGunShot.SetVisible( true );
		m_spFace.SetVisible	( true );
		gpSound->mPlaySE( SFX_SCE6_MATSU_YARUZOOM );
	}
	//	Sڂ`n܂
	if( m_spGunShot.CheckFlag( RENDER_FLAG ) ){
		m_spFace.SetEX				( m_spFace.GetExX()+(1.1f/DEATH_ALPHA_TIME) );		//	g	
		if( m_iMuzzleTime < MUZZLE_TIME*4+60 ){	//	ŏ̂Qb
			m_spFace.AddAlpha			( 60, 180 );
		}else{
			m_spFace.DownAlpha			( 60 );
		}
	}
	//	}Y^C
	if( m_iMuzzleTime >= MUZZLE_WAIT_TIME+MUZZLE_TIME*4 ){
		for( i = 0; i < MUZZLE_MAX_NUM; i++ ){
			m_Muzzle[i].spMuzzle.DownAlpha( MUZZLE_ALPHA_TIME );
		}
		m_spGunShot.DownAlpha( DEATH_ALPHA_TIME );
		if( m_iMuzzleTime >= MUZZLE_WAIT_TIME+MUZZLE_TIME*4+DEATH_ALPHA_TIME ){
			SetDeathData();
		}
	}
	//	
	m_spAlive[0].SetVisible( false );
	m_spAlive[1].SetVisible( false );	
	m_spAliveBG.SetAlpha( 0 );
;
}


