////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Roulette
//
// SK7PanelNine.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELNINE_H__
#define	__SK7PANELNINE_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l
#define	NINE_CANCEL					(-1)	//	rI
#define	NINE_PLAY					(0)
#define	NINE_CLEAR					(1)		//	NA


//	eNX`[pX
#define	PNL035003TEX_BG				"Texture/035003/9puzzle00.BIN"
#define	PNL035003TEX_LEVER			"Texture/035003/9puzzle01.BIN"
#define	PNL035003TEX_CAR			"Texture/035003/9puzzle02.BIN"

#define	CAR_NUM						(9)
#define	SELECT_NUM					(4)

const u32 	tblCarColor[]={
	0x990000ff,//c81006ff,//200,16,6CbhiFj
	0x298733ff,//41,135,51,[
	0xa0b0b0ff,//173,185,186SDVo[
	0xfd0b0bff,//253,11,11,TD
	0xff7f00ff,//255,128,0UDIW~
	0x0000e3ff,//0,	0,	227VD
	0xf2ec00ff,// 242,236,0,//WDCG[
	0xf6f6f6ff,// 246,246,246,	//XD
	0xffffffff,//255,255,255,	//PD~iŌ̐Aio[Xj
};

typedef struct{
	SK7Sprite		Sprite;
	u8				No;
}CAR_STATE;

//---- class ----
class SK7PanelNine : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_MOVE_LEVER,
		PROC_MOVE_LEVER2,
		PROC_MOVE_CAR,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_CHECK,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_LEVER,
		LOAD_CAR,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;

	CAR_STATE				m_Car[CAR_NUM-1];
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spLever;
	SK7Sprite				m_spSelect[SELECT_NUM];
	s8						m_chSelect;
	s8						m_chBlackNo;
	s8						m_chMoveNo;
	u8						m_ucCarNo[CAR_NUM];
	int						m_iMoveTime;
	int						m_iMoveTime2;
	int						m_iTime;
	bool					m_bReturnFlag;
	bool					m_bMoveFlag;
	bool					m_bAlphaFlag; 
	
public:
	SK7PanelNine( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelNine();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	bool	MoveLever();
	bool	MoveCar();
	bool	CheckPazzle();
	void	GetCarPos( int No, VEC2 *pPos );
	void	SetSelectPos();
	void	SetNoSelect(){	for( int i = 0; i < SELECT_NUM; i++ )	m_spSelect[i].SetVisible(false); }
	void	SetCarAlpha(){	for( int i = 0; i < SELECT_NUM; i++ )	m_spSelect[i].SetAlpha(0xff); }
};

#endif	//__SK7PANELNINE_H__
