////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Popcorn
//
// SK7PanelPopcorn.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELPOPCORN_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "..\Scn\K7Scn03.h"

#include "SK7PanelPopcorn.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

#define		STOP_TIME			(30)

const VEC2 tblBallPos[]=
{
	287,	102,
	393,	185,
	355,	311,
	220,	310,
	180,	185,
};

Vec tblGoldGumPos[]=
{
	320,132,0,
	426,217,0,
	390,343,0,
	252,343,0,
	212,217,0,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelPopcorn::SK7PanelPopcorn( s32 Now ) : SK7PanelBase( Now )
{
	//	K̐
	m_cGumNum 		= (s8)(Now - K7EVENT_SCN_VAR(K7SCN03,EVVA_SETGUM));
	m_sNowAnswer 	= POPCORN_MISS;
	m_cSelect		= (s8)(K7EVENT_SCN_VAR(K7SCN03,EVVA_SETGUM));
	m_iTime			= 0;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	for( int i = 0; i < GUM_MAX_NUM; i++ ){
		m_spGum[i].SetXY0( tblBallPos[i].x, tblBallPos[i].y );
		if( i < K7EVENT_SCN_VAR(K7SCN03,EVVA_SETGUM) ){
			m_spGum[i].SetFlag( true, RENDER_FLAG );
		}else{
			m_spGum[i].SetFlag( false, RENDER_FLAG );
		}
	}
	//	TCg	----------------------------------------------
	SetCursolPosition( &tblGoldGumPos[m_cSelect] );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelPopcorn::~SK7PanelPopcorn()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();	
	for( int i = 0; i < GUM_MAX_NUM; i++ ){
		m_spGum[i].Delete();
	}
}


//========================================================================
// t[
//========================================================================]
s16			SK7PanelPopcorn::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_MESSAGE;
		}
		break;
		
	case	PROC_MESSAGE:
		if( DrawMessage(0) ){
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A )
		{
			//	KĂȂ
			if( m_cGumNum <= 0 )	break;
			//	KZbgĂ
			if( m_spGum[m_cSelect].CheckFlag( RENDER_FLAG ) )	break;

			gpSound->mPlaySE( SFX_SYS_DECIDE );			
			m_spGum[m_cSelect].SetVisible(true);	//	K\
			K7EVENT_SCN_VAR(K7SCN03,EVVA_SETGUM)++;	//	ݒuK
			m_cGumNum--;							//	K
			if( K7EVENT_SCN_VAR(K7SCN03,EVVA_SETGUM) == 5 ){
				SetCursolDisp( false );
				m_sNowAnswer 	= POPCORN_CLEAR;
				m_Proc = PROC_TIME;
				break;
			}
			m_cSelect++;
			m_Proc = PROC_MESSAGE2;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			gpSound->mPlaySE( SFX_SYS_CANCEL );			
			m_sNowAnswer = POPCORN_CANCEL;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
#if 0
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_RIGHT )
		{
			switch( m_cSelect ){
			case 0:		m_cSelect ++;	break;
			case 2:
			case 3:
			case 4:
				m_cSelect --;
				break;
			}
			SetCursolPosition( &tblGoldGumPos[m_cSelect] );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_LEFT )
		{
			switch( m_cSelect ){
			case 0:		m_cSelect = 4;	break;
			case 1:		
			case 2:		
			case 3:
				m_cSelect++;		
				break;
			}
			SetCursolPosition( &tblGoldGumPos[m_cSelect] );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP )
		{
			switch( m_cSelect ){
			case 1:
			case 2:
				m_cSelect --;
				break;
			case 3:		m_cSelect ++;	break;
			case 4:		m_cSelect = 0;	break;
			}
			SetCursolPosition( &tblGoldGumPos[m_cSelect] );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
		{
			switch( m_cSelect ){
			case 0:
			case 1:
				m_cSelect++;
				break;
			case 4:		m_cSelect--;	break;
			}
			SetCursolPosition( &tblGoldGumPos[m_cSelect] );
			break;
		}
#endif
		break;
		
	case	PROC_MESSAGE2:
		if( DrawMessage(1) ){
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &tblGoldGumPos[m_cSelect] );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	case	PROC_TIME:
		if( ++m_iTime > STOP_TIME ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
			
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelPopcorn::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	for( int i = 0; i < GUM_MAX_NUM; i++ ){
		m_spGum[i].Render();
	}
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelPopcorn::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelPopcorn::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelPopcorn::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelPopcorn::LoadTexData()
{
	switch( m_TexProc )
	{
	
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL030206TEX_BG )){
			m_TexProc = LOAD_GUM1;
		}
		break;
	case	LOAD_GUM1:
		if( m_spGum[0].LoadTexture( PNL030206TEX_GUM1 )){
			m_TexProc = LOAD_GUM2;
		}
		break;
	case	LOAD_GUM2:
		if( m_spGum[1].LoadTexture( PNL030206TEX_GUM2 )){
			m_TexProc = LOAD_GUM3;
		}
		break;
	case	LOAD_GUM3:
		if( m_spGum[2].LoadTexture( PNL030206TEX_GUM3 )){
			m_TexProc = LOAD_GUM4;
		}
		break;
	case	LOAD_GUM4:
		if( m_spGum[3].LoadTexture( PNL030206TEX_GUM4 )){
			m_TexProc = LOAD_GUM5;
		}
		break;
	case	LOAD_GUM5:
		if( m_spGum[4].LoadTexture( PNL030206TEX_GUM5 )){
			return true;
		}
		break;
	}
	return false;
}
