////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Popcorn
//
// SK7PanelPopcorn.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELPOPCORN_H__
#define	__SK7PANELPOPCORN_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	Ԃ
#define	POPCORN_CLEAR			(1)		//	NA
#define	POPCORN_MISS			(0)	//	~X
#define	POPCORN_CANCEL			(-1)

// ̓KCxg̃NAĂB

//	eNX`[pX
#define	PNL030206TEX_BG			"Texture/030206/EVENT_030206.BIN"
#define	PNL030206TEX_GUM1		"Texture/030206/GoldGum_01.BIN"
#define	PNL030206TEX_GUM2		"Texture/030206/GoldGum_02.BIN"
#define	PNL030206TEX_GUM3		"Texture/030206/GoldGum_03.BIN"
#define	PNL030206TEX_GUM4		"Texture/030206/GoldGum_04.BIN"
#define	PNL030206TEX_GUM5		"Texture/030206/GoldGum_05.BIN"

#define	GUM_MAX_NUM					(5)

//---- class ----
class SK7PanelPopcorn : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_TIME,
		PROC_MESSAGE,
		PROC_MESSAGE2,
		PROC_CANCEL,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_GUM1,
		LOAD_GUM2,
		LOAD_GUM3,
		LOAD_GUM4,
		LOAD_GUM5,
	}eLoadTexProc;

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spGum[GUM_MAX_NUM];
	
	f32						m_fAngle;
	s8						m_cGumNum;
	s8						m_cSelect;
	int						m_iTime;

public:
	SK7PanelPopcorn( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelPopcorn();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELPOPCORN_H__
