////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Poster
//
// SK7PanelPoster.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELPOSTER_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelPoster.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7Event.h"
#include "../Yam/YK7EffectMessage2.h"


MESSAGE_PARAM tblMessageNum[]=
{
	//ID						
//	0x020201,			1,		0,
	0x020203,			3,		0,	
	0x020208,			1,		0,	
	0x020303,			1,		0,
	0x020304,			1,		0,
	0x020305,			1,		0,
	0x020306,			1,		0,
	0x020307,			1,		0,
	0x020308,			1,		0,
	0x020309,			1,		0,
	0x030101,			1,		0,
	0x030103,			1,		0,
	0x030104,			1,		0,
	0x030105,			1,		0,
	0x030106,			1,		0,
	0x055703,			3,		0,
	0x055103,	        1,      0,
	0x055102,           1,      0,
	0x055101,           1,      0,
	0x055100,           1,      0,
	NULL,				NULL,	NULL,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelPoster::SK7PanelPoster( s32 PosterID, s32 Now ) : SK7PanelBase( Now, -1, false )
{
	//vZX	----------------------------------------------
	m_Proc 			= PROC_LOAD;
	m_TexProc 		= LOAD_BG;
	m_pEffect		= NULL;
	memset( &m_Message, 0, sizeof(MESSAGE_PARAM) );
	
	//	|X^[ԍ
//	m_iPosterNo = PosterID;
	char str[255];
	u32 No = ((u32)PosterID>>28);
	u32 ENo = (u32)PosterID - (No<<28);

	//	|X^[Cxg
	if( No == 0 ){
		sprintf( str, "Texture/Poster/POSTER_%06x.BIN", ENo );
	}else{	//	Cxg
		sprintf( str, "Rakugaki/RAKUM_%06x.BIN", ENo  );		
	}
	if( No != 0 ){
		ENo += K7EV_TYPE_RAKU;
	}

	//	bZ[W	===================================
	int i = 0;
	while(1){
		if( tblMessageNum[i].MessageID == NULL )	break;
		if( ENo == tblMessageNum[i].MessageID && Now == tblMessageNum[i].MesNo ){
			m_Message = tblMessageNum[i];
			break;
		}
		i++;
	}
		
	m_pFileName = str;
	
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);		
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelPoster::~SK7PanelPoster()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelPoster::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			if( m_Message.MessageID != 0 ){ 
				m_Proc = PROC_CHECK_MESSAGE;
			}else{
				m_Proc = PROC_SELECT_MAIN;
			}
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		//	bZ[WȂꍇ	================================
		if( m_Message.MessageID == NULL ){
			if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
				m_Proc = PROC_CANCEL;
				break;
			}
		}
		break;
		
	//	I`FbNH
	case	PROC_CHECK_MESSAGE:
//		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
//			m_Proc = PROC_STOP_MESSAGE;
//			break;
//		}
		if( DrawMessage( m_Message.MesNo ) ){
			if( --m_Message.MesNum <= 0 ){
				m_Proc = PROC_CANCEL;
				break;
			}
			m_Message.MesNo++;
		}
		break;
		
	case	PROC_STOP_MESSAGE:
		m_Proc = PROC_CANCEL;
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelPoster::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
		
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelPoster::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelPoster::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelPoster::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelPoster::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( m_pFileName ) )
		{
			return true;
		}
		break;

	}
	return false;
}
