////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cho
//
// SK7PanelRobot.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELROBOT_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelRobot.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"

#define		NO_SIZE_X			(41) 
#define		NO_SIZE_Y			(55)
#define		NO_SIZE_GAP_Y		(4)
#define		NO_MOVE_FRAME		(5)

//	eNX`[pX
#define	PNL055501TEX_BG				"Texture/055501/EVENT_055501_base.BIN"
#define PNL055501TEX_NO				"Texture/055501/EVENT_055501_number.BIN"
#define	PNL055501TEX_SELECT			"Texture/055501/EVENT_055501_button.BIN"


#define		BUTTON_X		(145)
#define		BUTTON_UP_Y		(250)
#define		BUTTON_DOWN_Y	(365)
#define		BUTTON_GAP_X	(108)


#define		NO_X			(138)
#define		NO_GAP_X		(108)
#define		NO_Y			(294)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelRobot::SK7PanelRobot( s32 Now ) : SK7PanelBase( Now )
{	
	//	TCg	----------------------------------------------	
	SetCursolPosition(&(Vec){NO_X+NO_SIZE_X*0.5f,NO_Y+NO_SIZE_Y*0.5f,0});
	SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	
	m_bKeyState = false;
	m_cSelect	= 0;
	m_iMoveTime	= 0;
	
	//	ԈĂ
	m_sNowAnswer	= ROBOT_MISS;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	io[XvCg	------------------------------------------
	for( int i = 0; i < ROBOT_NO_NUM; i++ ){
		m_spNo[i].SetXY0( NO_X+i*NO_GAP_X, NO_Y );
		m_spNo[i].SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
		m_spNo[i].SetTexNo( (u8)0 );
	}
	//	܂͂ɂ炷
	m_spNoPlus1.SetXY0( NO_X, NO_Y + NO_SIZE_Y + NO_SIZE_GAP_Y );
	m_spNoPlus1.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
	m_spNoPlus1.SetTexNo( (u8)1);
	
	//	
	m_spNoPlus2.SetXY0( NO_X, NO_Y - NO_SIZE_Y - NO_SIZE_GAP_Y );
	m_spNoPlus2.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
	m_spNoPlus2.SetTexNo( (u8)9 );
	
	m_spSelect.SetXY0( BUTTON_X, BUTTON_UP_Y );
	m_spSelect.SetTexNo( 0 );
	m_spSelect.SetFlag( true, BLOCK_FLAG );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelRobot::~SK7PanelRobot()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();	
	m_spNo[0].Delete();
	m_spSelect.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelRobot::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		m_spSelect.SetVisible	( false );
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE(SFX_SCE3_PNL_ENT_KETTEI);
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			m_sNowAnswer = ROBOT_CANCEL;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		if( CheckKeyT( SK7_KEY_UP ) ){
			gpSound->mPlaySE(SFX_SYS_PNL_UPDOWN);
			m_spSelect.SetVisible	( true );
			m_spSelect.SetXY0		( BUTTON_X+m_cSelect*BUTTON_GAP_X, BUTTON_UP_Y );
			m_spSelect.SetTexNo		(0);
			SetCursolDir( CURSOL_DIR_DOWN );
			m_Proc = PROC_MOVE_NO;
			m_bKeyState = true;
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			gpSound->mPlaySE(SFX_SYS_PNL_UPDOWN);
			m_spSelect.SetVisible	( true );
			m_spSelect.SetXY0		( BUTTON_X+m_cSelect*BUTTON_GAP_X, BUTTON_DOWN_Y );
			m_spSelect.SetTexNo		(1);
			SetCursolDir( CURSOL_DIR_UP );
			m_Proc = PROC_MOVE_NO;
			m_bKeyState = false;
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) )
		{
			if( --m_cSelect < 0 ){
				m_cSelect = 0;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			m_spSelect.SetX0		( BUTTON_X+m_cSelect*BUTTON_GAP_X );
			s8 no = (s8)m_spNo[m_cSelect].GetTexNo();
			s8 no1 = (s8)(no+1), no2 = (s8)(no-1);
			if( no1 > 9 )  	(s8)no1 = 0;
			if( no2 < 0 )	(s8)no2 = 9;
			m_spNoPlus1.SetXY0	( NO_X+m_cSelect*NO_GAP_X, NO_Y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo( (u8)no1 );
			m_spNoPlus2.SetXY0	( NO_X+m_cSelect*NO_GAP_X, NO_Y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo( (u8)no2 );
			SetCursolPosition(&(Vec){NO_X+(m_cSelect*NO_GAP_X)+NO_SIZE_X*0.5f,NO_Y+NO_SIZE_Y*0.5f,0});
			SetCursolDir( CURSOL_DIR_LEFT );
			break;
		}
		if( CheckKeyT( SK7_KEY_RIGHT ) )
		{
			if( ++m_cSelect >= ROBOT_NO_NUM ){
				m_cSelect = ROBOT_NO_NUM-1;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			m_spSelect.SetX0		( BUTTON_X+m_cSelect*BUTTON_GAP_X );
			s8 no = (s8)m_spNo[m_cSelect].GetTexNo();
			s8 no1 = (s8)(no+1), no2 = (s8)(no-1);
			if( no1 > 9 )  	(s8)no1 = 0;
			if( no2 < 0 )	(s8)no2 = 9;
			m_spNoPlus1.SetXY0	( NO_X+m_cSelect*NO_GAP_X, NO_Y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo( (u8)no1 );
			m_spNoPlus2.SetXY0	( NO_X+m_cSelect*NO_GAP_X, NO_Y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo( (u8)no2 );
			SetCursolPosition(&(Vec){NO_X+(m_cSelect*NO_GAP_X)+NO_SIZE_X*0.5f,NO_Y+NO_SIZE_Y*0.5f,0});
			SetCursolDir( CURSOL_DIR_RIGHT );
			break;
		}
		break;

	//	io[ړ
	case 	PROC_MOVE_NO:
		if( MoveNo( m_bKeyState, m_cSelect ) )
		{
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	//	`FbNp	----------------------------------------------
	case 	PROC_CHECK:		
		switch( CheckAnswer() )
		{		
		case	PANEL_CHECK_RETURN:				//߂
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			m_Proc = PROC_SELECT_MAIN;	
			break;
		
		case	PANEL_CHECK_SET:				//
			SetCursolDisp( false );
			if( m_spNo[0].GetTexNo() == 3 && m_spNo[1].GetTexNo() == 5 &&
				m_spNo[2].GetTexNo() == 7 && m_spNo[3].GetTexNo() == 6 )
			{
				m_sNowAnswer	= ROBOT_CLEAR;
				m_Proc = PROC_CANCEL;
			}
			else
			{
				gpSound->mPlaySE(SFX_SYS_PNL_MISS);
				m_Proc = PROC_CANCEL;//TIME;
			}
			break;
		}
		break;
#if 0		
	case	PROC_TIME:
		if( DrawMessage(1) ){
			m_Proc = PROC_CANCEL;
		}
		break;
#endif

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	if( m_cSelect == 0 )					SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	else if( m_cSelect == ROBOT_NO_NUM-1 )	SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	else									SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelRobot::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}


	m_spBG.Render();					//	wi
#if 0
	static u32 size = 68;
	if( HSD_PadGetTrigger(0) & HSD_PAD_UP )	size++;
	if( HSD_PadGetTrigger(0) & HSD_PAD_DOWN )	size--;
#endif	
	GXSetScissor( 133, 287, (u32)400, (u32)68 );
	m_spNoPlus1.Render();
	GXSetScissor( 133, 287, (u32)400, (u32)68 );
	m_spNoPlus2.Render();
	GXSetScissor( 133, 287, (u32)400, (u32)68 );
	for( int i = 0; i < ROBOT_NO_NUM; i++ ){
		m_spNo[i].Render();
	}
	
	GXSetScissor( 0, 0, (u32)640, (u32)480 );
	m_spSelect.Render();
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelRobot::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelRobot::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelRobot::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelRobot::MoveNo(bool state, s8 select)
{
	f32 vSpeedY	= (NO_SIZE_Y+NO_SIZE_GAP_Y)/NO_MOVE_FRAME;
	
	//	Ƃ	
	if( state )		vSpeedY = -vSpeedY;
	
	m_spNo[select].SetXY0	( m_spNo[select].GetX0(), 	m_spNo[select].GetY0()	+ vSpeedY	);
	m_spNoPlus1.SetXY0		( m_spNoPlus1.GetX0(), 		m_spNoPlus1.GetY0() 	+ vSpeedY	);
	m_spNoPlus2.SetXY0		( m_spNoPlus2.GetX0(), 		m_spNoPlus2.GetY0() 	+ vSpeedY	);

	//	ԉZ
	if( ++m_iMoveTime >= NO_MOVE_FRAME ){
		s8 no0 = (s8)m_spNo[select].GetTexNo();
		s8 no1 = (s8)m_spNoPlus1.GetTexNo();
		s8 no2 = (s8)m_spNoPlus2.GetTexNo();
		
		//	ւ
		if( state ){
			if( ++no0 	>= 10 )	no0 = 0;
			if( ++no1 	>= 10 )	no1	= 0;
			if( ++no2	>= 10 )	no2 = 0;

			m_spNo[select].SetXY0	( NO_X+NO_GAP_X*select, NO_Y ); 
			m_spNo[select].SetTexNo	( (u8)no0 );
			m_spNoPlus1.SetXY0		( NO_X+NO_GAP_X*select, NO_Y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo	( (u8)no1 );
			m_spNoPlus2.SetXY0		( NO_X+NO_GAP_X*select, NO_Y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo	( (u8)no2 );
		}else{
			if( --no0 	< 0 )	no0 = 9;
			if( --no1 	< 0 )	no1	= 9;
			if( --no2	< 0 )	no2 = 9;

			m_spNo[select].SetXY0	( NO_X+NO_GAP_X*select, NO_Y ); 
			m_spNo[select].SetTexNo	( (u8)no0 );
			m_spNoPlus1.SetXY0		( NO_X+NO_GAP_X*select, NO_Y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo	( (u8)no1 );
			m_spNoPlus2.SetXY0		( NO_X+NO_GAP_X*select, NO_Y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo	( (u8)no2 );
		}
		m_iMoveTime = 0;
		return true;
	}
	
	return false;
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelRobot::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL055501TEX_BG ) ){
			m_TexProc = LOAD_NO;
		}
		break;

	case 	LOAD_NO:	//	
		if( m_spNo[0].LoadTexture( PNL055501TEX_NO, 5, 2 ) )
		{
			for( int i = 1; i < ROBOT_NO_NUM; i++ ){
				m_spNo[i].SetTexture( m_spNo[0].GetTexture(), 5, 2 );
			}
			m_spNoPlus1.SetTexture( m_spNo[0].GetTexture(), 5, 2 );
			m_spNoPlus2.SetTexture( m_spNo[0].GetTexture(), 5, 2 );
			m_TexProc = LOAD_SELECT;
		}
		break;
		
	case 	LOAD_SELECT:
		if( m_spSelect.LoadTexture( PNL055501TEX_SELECT, 2, 1 ) ){
			return true;
		}
		break;
	}
	return false;
}