////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cho
//
// SK7PanelRobot.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELROBOT_H__
#define	__SK7PANELROBOT_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



//	߂l
#define	ROBOT_MISS					(0)
#define	ROBOT_CLEAR					(1)
#define	ROBOT_CANCEL				(-1)

#define	ROBOT_NO_NUM				(4)


//---- class ----
class SK7PanelRobot : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_MESSAGE,
		PROC_SELECT_MAIN,
		PROC_CHECK,
		PROC_MOVE_NO,
		PROC_TIME,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_NO,
		LOAD_SELECT,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spNo[ROBOT_NO_NUM];					//	wi
	SK7Sprite				m_spNoPlus1;
	SK7Sprite				m_spNoPlus2;
	SK7Sprite				m_spSelect;
	
	int						m_iMoveTime;
	s8						m_cSelect;
	bool					m_bKeyState;

public:
	SK7PanelRobot( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelRobot();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	//	ړvZ
	bool	MoveNo(bool state, s8 select);
	
};

#endif	//__SK7PANELROBOT_H__
