////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelSafe.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PanelSafe_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelSafe.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

//	eNX`[pX
#define	PNL055702TEX_BG				"Texture/055702/EVENT_055702_base.BIN"
#define	PNL055702TEX_NOBU			"Texture/055702/EVENT_055702_lever.BIN"
#define	PNL055702TEX_NOBU2			"Texture/055702/EVENT_055702_lever2.BIN"
#define	PNL055702TEX_DIAL			"Texture/055702/EVENT_055702_dial2.BIN"

#define		DIAL_CENTER_X			(416)
#define		DIAL_CENTER_Y			(225)
#define		DIAL_SIZE_X				(144)
#define		DIAL_SIZE_Y				(144)

#define		NOBU_X					(168)
#define		NOBU_Y					(193)
#define		NOBU2_X					(167)
#define		NOBU2_Y					(191)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelSafe::SK7PanelSafe( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= SAFE_CANCEL	;
	m_iTime = 0;
	m_chNum = 0;
	m_fAngle = 0;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	m_spDial.SetXY0		( 416, 225 );
	m_spDial.SetFlag	( true, RENDER_FLAG|VTX4_FLAG );
	SET_SPRITE_ROT		( &m_spDial, 0, DIAL_CENTER_X, DIAL_CENTER_Y, DIAL_SIZE_X, DIAL_SIZE_Y );
	
	m_spNobu.SetXY0		( NOBU_X, NOBU_Y );
	m_spNobu.SetFlag	( true, RENDER_FLAG );
	
	m_spNobu2.SetXY0	( NOBU2_X, NOBU2_Y );
	m_spNobu2.SetFlag	( false, RENDER_FLAG );
	
	SetCursolPosition( &(Vec){416.0f, 223.0f, 0.0f} );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelSafe::~SK7PanelSafe()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spNobu.Delete();
	m_spNobu2.Delete();
	m_spDial.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelSafe::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		m_iTime++;
		gpSound->mStopSE( SFX_SCE5_SCL_VAULT_DIAL );
		
		if( CheckKeyN( SK7_KEY_RIGHT ) && m_iTime > 2 ){
			m_fAngle += 12;
			m_iTime = 0;
			gpSound->mPlaySE( SFX_SCE5_SCL_VAULT_DIAL );
			SET_SPRITE_ROT		( &m_spDial, m_fAngle, DIAL_CENTER_X, DIAL_CENTER_Y, DIAL_SIZE_X, DIAL_SIZE_Y );
		}
		if( CheckKeyN( SK7_KEY_LEFT ) && m_iTime > 2 ){
			m_fAngle -= 12;
			m_iTime = 0;
			gpSound->mPlaySE( SFX_SCE5_SCL_VAULT_DIAL );
			SET_SPRITE_ROT		( &m_spDial, m_fAngle, DIAL_CENTER_X, DIAL_CENTER_Y, DIAL_SIZE_X, DIAL_SIZE_Y );

		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			SetCursolDisp( false );
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_Proc = PROC_CANCEL;
			break;
		}
		if( m_fAngle >= 180 ){
			m_fAngle = 180;
			gpSound->mStopSE( SFX_SCE5_SCL_VAULT_DIAL );
			SET_SPRITE_ROT		( &m_spDial, m_fAngle, DIAL_CENTER_X, DIAL_CENTER_Y, DIAL_SIZE_X, DIAL_SIZE_Y );
			if( m_chNum == 0 ){
				gpSound->mPlaySE( SFX_SYS_TRUE );
				m_chNum++;
			}
		}
		if( m_fAngle <= -180 ){
			m_fAngle = -180;
			gpSound->mStopSE( SFX_SCE5_SCL_VAULT_DIAL );
			SET_SPRITE_ROT		( &m_spDial, m_fAngle, DIAL_CENTER_X, DIAL_CENTER_Y, DIAL_SIZE_X, DIAL_SIZE_Y );
			if( m_chNum == 1 ){
				gpSound->mPlaySE( SFX_SYS_TRUE );
				m_Proc = PROC_CHECK;
				break;
			}
		}
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		gpSound->mStopSE( SFX_SCE5_SCL_VAULT_DIAL );
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_chNum = 0;
			m_Proc = PROC_TIME;
			break;
		case	PANEL_CHECK_SET:
			m_iTime = 0;
			SetCursolDisp( false );
			m_sNowAnswer = SAFE_ON;
			m_spNobu.SetVisible( false );
			m_spNobu2.SetVisible( true );
			gpSound->mPlaySE( SFX_SCE5_SCL_VAULT_LEVER );
			gpSound->mPlaySE( SFX_SYS_PNL_OK );
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case PROC_TIME:
		if( ++m_iTime > 20 ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
#if 0		
	//	bZ[W	
	case	PROC_MESSAGE:
		if( DrawMessage(m_chSelect) ){
			m_Proc = PROC_CANCEL;
		}
		break;
	//	|X^[
	case	PROC_END:
		if( (0) & (HSD_PAD_A|HSD_PAD_B) ){
			m_Proc = PROC_CANCEL;
		}
		break;
#endif
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelSafe::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spNobu.Render();
	m_spNobu2.Render();
	m_spDial.Render();
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelSafe::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelSafe::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelSafe::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelSafe::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL055702TEX_BG ) ){
			m_TexProc = LOAD_NOBU;
		}
		break;
	case 	LOAD_NOBU:	//	
		if( m_spNobu.LoadTexture( PNL055702TEX_NOBU ) ){
			m_TexProc = LOAD_NOBU2;
		}
		break;
	
	case 	LOAD_NOBU2:	//	
		if( m_spNobu2.LoadTexture( PNL055702TEX_NOBU2 ) ){
			m_TexProc = LOAD_DIAL;
		}
		break;
		
	case 	LOAD_DIAL:
		if( m_spDial.LoadTexture( PNL055702TEX_DIAL ) ){
			return true;
		}
		break;
	}
	return false;
}