////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelToilet2.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELTOILET2_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelToilet2.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

//	eNX`[pX
#define	PNL055600TEX_BG				"Texture/055600/EVENT_055600_toile.BIN"
#define	PNL055600TEX_SWITCH			"Texture/055600/EVENT_055600_himo.BIN"

#define	HIMO_SIZE_Y			(64)
#define	HIMO_MOVE_TIME		(20)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelToilet2::SK7PanelToilet2( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= TOILET2_CANCEL;
		
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);

	m_iTime = 0;
	
	m_spSwitch.SetXY0		( 207, -HIMO_SIZE_Y );
	m_spSwitch.SetVisible	( true );
	
	SetCursolPosition( &(Vec){210.0f, 100.0f, 0.0f} );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelToilet2::~SK7PanelToilet2()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	
	m_spSwitch.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelToilet2::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			SetCursolDisp( false );
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_Proc = PROC_CANCEL;
			break;
		}		
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			gpSound->mPlaySE( SFX_SCE5_SCL_PNL_TOILET_PULL );
			m_sNowAnswer = TOILET2_ON;
			m_spSwitch.SetVisible(true);
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case PROC_TIME:
		if( m_iTime < 20 ){
			m_spSwitch.SetIncY( HIMO_SIZE_Y/HIMO_MOVE_TIME );
		}
		m_iTime++;
		
		if( m_iTime == 15 ){
			gpSound->mPlaySE( SFX_SCE5_SCL_PNL_TOILET_WATER );
		}

		if( !gpSound->mCheckSE(SFX_SCE5_SCL_PNL_TOILET_WATER) && m_iTime > 15 ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
#if 0		
	//	bZ[W	
	case	PROC_MESSAGE:
		if( DrawMessage(m_chSelect) ){
			m_Proc = PROC_CANCEL;
		}
		break;
	//	|X^[
	case	PROC_END:
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
			m_Proc = PROC_CANCEL;
		}
		break;
#endif
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelToilet2::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
		
	m_spSwitch.Render();
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelToilet2::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelToilet2::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelToilet2::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelToilet2::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL055600TEX_BG ) ){
			m_TexProc = LOAD_SWITCH;
		}
		break;
	case 	LOAD_SWITCH:	//	XCb`
		if( m_spSwitch.LoadTexture( PNL055600TEX_SWITCH ) ){
			return true;
		}
		break;
	}
	return false;
}