////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelTutorial.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELTUTORIAL_CPP__
	
#include "SK7PanelTutorial.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7EventScript.h"
#include "../wat/K7GlobalFlag.h"
#include "../fujita/c_font.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7Event.h"
#include "../wat/WK7EventItem.h"


#define		TUTORIAL_PACK_DATA			"/Texture/tutorial.pak"
#define		CHANGE_PLUSY			(15)
#define		MAX_LOG_NUM				(MAX_FONT_NUM)
#define		TUTORIAL_WIN_X			(160)
#define		TUTORIAL_WIN_SIZEX		(360)
#define		TUTORIAL_WIN_Y			(CHANGE_PLUSY)
#define		TUTORIAL_WIN_SIZEY		(480)
#define		TUTORIAL_FONT_X			(68)
#define		TUTORIAL_FONT_Y			(68+CHANGE_PLUSY)
#define		TUTORIAL_FONT_GAPY		((413.0f-68.0f)/MAX_FONT_NUM)
#define		TUTORIAL_SEL_Y			(215+CHANGE_PLUSY)
#define		TUTORIAL_SEL_SIZEY		(50)
#define		LINE_X					(30)//(4)//(55)
#define		KATEGORI_GAPX			(100)//(105)//(107)
#define		SENTAKU_ALPHA			(0xff)//A5)
#define		BOX_Y					(34+CHANGE_PLUSY)
#define		BOX_SIZE_X				(96)//(102)
#define		BOX_SIZE_Y				(10)
#define		BOX_ALPHA				(0xff)//41)
#define		BOX_SHADOW_ALPHA		(0xa0)
#define		SHADOW_Y				(BOX_Y+BOX_SIZE_Y)
#define		SHADOW_SIZEX			(220)//(160)
#define		SHADOW_SIZEY			(400)
#define		SHADOW_COLOR			(0x0000008f)
#define		SHADOW_ALPHA			(0x8f)
#define		YAJI_X					(62)
#define		YAJI_Y					(22+CHANGE_PLUSY)//(15+CHANGE_PLUSY)
#define		YAJI_SIZE_X				(16)
#define		YAJI_X2					(72)//14.0f)//(YAJI_X+BOX_SIZE_X-YAJI_SIZE_X+7.0f)
#define		YAJI_SIZE_Y				(432)
#define		PANEL_Y					(20+CHANGE_PLUSY)//(13+CHANGE_PLUSY)
#define		TITLE_X					(30)//(4)//(51)
#define		TITLE_Y					(24+CHANGE_PLUSY)//(17+CHANGE_PLUSY)
#define		TITLE_FIRST_X			(-130)//(-BOX_SIZE_X-2)
#define		FIRST_MOVE_FRAME		(2)
#define		FIRST_WAIT_TIME			(20)
#define		YAJI_MOVE_NUM			(5)
#define		YAJI_ALPHA				(0xff)//A5)
#define		FONT_MOVE_TIME			(1)
#define		CURSOL_MOVE_TIME		(3)
#define		CURSOLGAP_Y				(-6.0f)
#define		FONT_SIZE				(20)
#define		MONKEY_GAP_LX			(-32)
#define		MONKEY_COLOR_NOREAD		(0xffffffeb)//(0xe60000ff)
#define		MONKEY_COLOR_READ		(0xffffffeb)//(0x0a64f0ff)
#define		EYE_GAPY				(5.0f)
#define		FONT_READ_ALPHA			(0x77)
#define		FONT_READ_COLOR			(0xffffff77)
#define		LINE_X2					(YAJI_X2-TUTORIAL_WIN_X+YAJI_SIZE_X)
#define		SET_SPRITE_ALPHA( SP, COLOR, ALPHA )  (SP)->SetColor( COLOR+ALPHA );
#define		KATEGORI_PLUSX(X,NO)				(X+KATEGORI_GAPX*NO)
#define		DRAP_SHADOW_SIZE		(2)
#define		PANEL_GAP_X				(128-BOX_SIZE_X)


const u32 tblKategoriColor[]={
	0xf0142800,
	0xf05a1400,
	0xe8981e00,
	0x4650b400,
	0x285a9c00,
	0x1e78a600,
};

typedef struct{
	f32 fEx;
	f32	fAngle;
}YAJIRUSHI;

const YAJIRUSHI tblYajirushi[]={
	0.05f,	5,
	0.28f,	357,
	0.52f,	2,
	0.76f,	358,
	1.0f,	0,
};

//	t[ԍƑIԍŃ`FbN
const u8 tblDrawNoBattle[]= {0,0,0,0,0,1,0,0,1,1,2};
const u8 tblDrawNoBattle2[]={0,0,99,0,0,1,0,0,1,1,2};
const u8 tblDrawNoBlood[]={0,0,0,1,0,0,0,1,1,2};

const u8 tblTutorialFlowNum[]={
	10,	6, 6,  0, 4,  0,			//ZeBbN
	10,	9, 9,  0, 7,  0,			//tNV}
	10,	10, 10, 0,11, 0,			//JNr
	10,	10, 10, 0,12, 2,			//eLTX
	10,	10, 10, 0,12, 5,			//Vn
	10,	10, 10, 0,12, 7,			//J[eBX@
	10,	10, 10, 0,12, 9,			//h~jJ
	10,	10, 10, 0,12, 9,			//h~jJ2
	11,	10, 10, 0,12, 9,			//HTL1
	11,	10, 10, 0,12, 9,			//wZ
	11,	10, 10, 0,12, 9,			//HTL2
	11,	10, 10, 0,12, 9,			//
};

const u8 tblTutorialFlowNum2[]={
	10,	7,  6,  0, 4, 0,			//ZeBbN
	10,	10, 9,  0, 7, 0,			//tNV}
	10,	11, 10, 0,11, 0,			//JNr
	10,	11, 10, 0,12, 2,			//eLTX
	10,	11, 10, 0,12, 5,			//Vn
	10,	11, 10, 0,12, 7,			//J[eBX@
	10,	11, 10, 0,12, 9,			//h~jJ
	10,	11, 10, 0,12, 9,			//h~jJ2
	11,	11, 10, 0,12, 9,			//HTL1
	11,	11, 10, 0,12, 9,			//wZ
	11,	11, 10, 0,12, 9,			//HTL2
	11,	11, 10, 0,12, 9,			//
};

//Xe[Whct[ԍ
const u8 tblStageFlowNo[]={ K7SCNF_CEL, K7SCNF_KAK, K7SCNF_TXS, K7SCNF_CUR, K7SCNF_DM2, K7SCNF_HT2, K7SCNF_GNK };

//========================================================================
//					RXgN^
//========================================================================
SK7PanelTutorial::SK7PanelTutorial( s32 Now ) : SK7PanelBase( Now, Now, false, true )
{
//	int i;
	//	TCg	----------------------------------------------
	m_sNowAnswer	= -1;
	m_chKategori	= eKihon;
	m_eFirst		= eFTitle;
		
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	
	m_iTime 		= 0;
	m_chSelect 		= 0;
	m_chMoveNo		= 0;
	m_chFontLine	= 1;
	m_chSelect 		= 0;
	m_iYajiTime		= 0;
	m_iCursolTime	= 0;
	m_chLogNum		= 0;
	m_lAnswer		= TUTORIAL_STANDBY;
	m_chFontDrawNo 	= (GameInfo.GetScenarioID() >= GameInfo.GetClearScenarioID()) ? (s8)GameInfo.GetScenarioFlow() : (s8)tblStageFlowNo[GameInfo.GetClearScenarioID()];
	m_chKategoriMax = KATEGORI_NUM-1;
	if( tblTutorialFlowNum[m_chFontDrawNo*KATEGORI_NUM+eHm2] > 0 ){
		m_chKategoriMax = KATEGORI_NUM;
	}	
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelTutorial::~SK7PanelTutorial()
{ 
	WK7CAM->SetCinemaScopeModeFlag(true);
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelTutorial::FrameProcess(void)
{
	//	JeSChE	-------------------------------------
	if( m_Proc == PROC_SELECT_MAIN ){
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	return true;
		MoveSelect();
		MoveKategori();
	}
	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			m_Proc = PROC_TIME;
		}
		break;

	//	Ǝԕ␳
	case 	PROC_TIME:
		if( ++m_iTime > FIRST_WAIT_TIME ){
			m_iTime = 0;
			m_Proc = PROC_FIRST;
		}
		break;

	//	ԍŏ	---------------------------------------------
	case 	PROC_FIRST:
		if( MoveFirst() ){
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyR( SK7_KEY_UP ) ){
			if((m_chKategori == eLog && m_chLogNum<=1))	break;
			if( !m_spCursol.CheckFlag( RENDER_FLAG ) )	break;
			if( m_iYajiTime < YAJI_MOVE_NUM )	break;
			m_chSelect--;
			if( m_chSelect < 0 ){
				if( m_chKategori == eLog ){
					m_chSelect = (s8)(m_chLogNum-1);
				}else{
					if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
						m_chSelect = (s8)(tblTutorialFlowNum2[m_chFontDrawNo*KATEGORI_NUM+m_chKategori]-1);
					}else{
						m_chSelect = (s8)(tblTutorialFlowNum[m_chFontDrawNo*KATEGORI_NUM+m_chKategori]-1);
					}
				}
			}
			SetSelect();
			break;
		}
		if( CheckKeyR( SK7_KEY_DOWN ) ){
			if((m_chKategori == eLog && m_chLogNum<=1))	break;
			if( !m_spCursol.CheckFlag( RENDER_FLAG ) )	break;
			if( m_iYajiTime < YAJI_MOVE_NUM )	break;
			m_chSelect++;
			if( m_chKategori == eLog ){
				if( m_chSelect > m_chLogNum-1 ){
					m_chSelect = 0;
				}
			}else{
				if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
					if( m_chSelect > tblTutorialFlowNum2[m_chFontDrawNo*KATEGORI_NUM+m_chKategori]-1 ){
						m_chSelect = 0;
					}
				}else{
					if( m_chSelect > tblTutorialFlowNum[m_chFontDrawNo*KATEGORI_NUM+m_chKategori]-1 ){
						m_chSelect = 0;
					}
				}
			}
			SetSelect();
			break;
		}
		if( CheckKeyR( SK7_KEY_RIGHT ) ){
			if( ++m_chKategori >= m_chKategoriMax ){
				m_chKategori = 0;
			}
			SetMoveKategori();
			break;
		}
		if( CheckKeyR( SK7_KEY_LEFT ) ){
			if( --m_chKategori < 0 ){
				m_chKategori = (s8)(m_chKategoriMax-1);
			}
			SetMoveKategori();
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			const s32* TutorialNo = NULL;
			if(m_chKategori == eLog ){
				if( m_chLogNum==0 )	break;
				TutorialNo = tblLogNoAll[GameInfo.GetScenarioFlow()];
				int Select=0, No=0;
				for( int i = 0; i < MAX_FONT_NUM; i++ ){
					if( K7SCR_EVHASITEM(K7EVITEM_ZANID( (u32)TutorialNo[i] ))==true ){ 	
						if( m_chSelect == No ){
							Select = i;
							break;
						}
						No++;
					}
				}
				m_lAnswer = TutorialNo[Select];
//				K7SCR_SET_GLOBAL_FLAG( K7GLFL_TUTORIAL_LOG_0+Select );
			}else{
				TutorialNo = tblTutorialAllNo[m_chKategori];
				m_lAnswer = TutorialNo[m_chSelect];
				u8 allno=0;
				for( int i = 0; i < m_chKategori; i++ ){
					if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
						allno += tblTutorialFlowNum2[K7SCNF_HT2*KATEGORI_NUM+i];
					}else{
						allno += tblTutorialFlowNum[K7SCNF_HT2*KATEGORI_NUM+i];
					}
				}
				if( m_chKategori == eBattle || m_chKategori == eBlood ){
					int FontNum=0;
					//	ogPcGL
					const u8* TblNo=NULL;
					if( m_chKategori == eBattle ){
						if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
							TblNo = tblDrawNoBattle;
						}else{
							TblNo = tblDrawNoBattle2;
						}
					}else{
						TblNo = tblDrawNoBlood;				
					}
		
					int CheckNo=0;
					while(1){
						//	``FbN
						if( TblNo[CheckNo] <= m_chFontDrawNo ){
							if( FontNum == m_chSelect ){
								m_lAnswer = TutorialNo[CheckNo];
								K7SCR_SET_GLOBAL_FLAG( K7GLFL_TUTORIAL_00+allno+CheckNo );
								break;
							}
							FontNum++;
						}
						CheckNo++;
					}
				}else{
					K7SCR_SET_GLOBAL_FLAG( K7GLFL_TUTORIAL_00+allno+(int)m_chSelect );
				}
			}
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_lAnswer = TUTORIAL_CANCEL;
			m_Proc = PROC_CANCEL;
			break;
		}
		m_lAnswer = TUTORIAL_STANDBY;
		break;
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelTutorial::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	WK7CAM->SetCinemaScopeModeFlag(true);
	WK7CAM->RenderCinemaScopeFrame(true);
	WK7CAM->SetCinemaScopeModeFlag(false);
	int i;
//	for( i = 0; i < LINE_NUM; i++ ){
//		m_pspLine[i].Render();
//	}
	m_spShadow.Render();

	if( m_chKategori < eLog ){	
		m_spYaji.SetSTTwo( 0.0f, 0.0f, 1.0f, 1.0f );
		m_spYaji2.SetSTTwo( 0.0f, 0.0f, 1.0f, 1.0f );
	}else{
		m_spYaji.SetSTTwo( 1.0f, 0.0f, 0.0f, 1.0f );
		m_spYaji2.SetSTTwo( 1.0f, 0.0f, 0.0f, 1.0f );
	}
	m_spYaji2.Render();
	m_spYaji.Render();
	
	if( m_chKategori < eLog ){
		m_spCursol.SetSTTwo( 0.0f, 0.0f, 1.0f, 1.0f );
	}else{
		m_spCursol.SetSTTwo( 1.0f, 0.0f, 0.0f, 1.0f );
	}
	if( !(m_chKategori == eLog && m_chLogNum==0)) m_spCursol.Render();

	for( i = 0; i < KATEGORI_NUM-1; i++ ){
		m_spBox2[i].Render();
	}
	for( i = 0; i < KATEGORI_NUM-1; i++ ){
		m_spBox[i].Render();
	}
	m_spKategori2.Render();
	m_spKategori.Render();
	for( i = 0; i < KATEGORI_NUM; i++ ){
		m_spTitle[i].Render();
	}
	m_spTitle2.Render();

	for( i = 0; i < MAX_FONT_NUM; i++ ){
		m_Font[i].RenderLine();
		m_spEyeShadow[i].Render();
		m_spEye[i].Render();
	}

	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelTutorial::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelTutorial::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelTutorial::mGetResult(void)
{
	return m_lAnswer;
}


//========================================================================
// ŏ̃ChE
//========================================================================
bool	SK7PanelTutorial::MoveFirst()
{
	s16 Alpha, Alpha2;
	switch( m_eFirst ){
	case eFTitle:
		if( m_iTime < FIRST_MOVE_FRAME ){
			f32 KMoveX = (LINE_X-TITLE_FIRST_X)/FIRST_MOVE_FRAME;
			m_spKategori.SetIncX	( KMoveX );
			m_spKategori2.SetIncX	( KMoveX );
			m_spTitle[0].SetIncX	( KMoveX );
			if( m_iTime == FIRST_MOVE_FRAME-1 ){
				m_spTitle[m_chMoveNo+1].SetXY0	( TITLE_X, TITLE_Y );
				m_spBox[m_chMoveNo].SetXY0		( TITLE_X, PANEL_Y );
				m_spBox2[m_chMoveNo].SetXY0		( TITLE_X+DRAP_SHADOW_SIZE, PANEL_Y+DRAP_SHADOW_SIZE );
			}
		}
		else if( m_iTime < FIRST_MOVE_FRAME*(m_chMoveNo+2) ){
			Alpha = (s16)(m_spBox[m_chMoveNo].GetAlpha() + BOX_ALPHA/FIRST_MOVE_FRAME);
			Alpha2 = (s16)(m_spBox2[m_chMoveNo].GetAlpha() + BOX_SHADOW_ALPHA/FIRST_MOVE_FRAME);
			if( Alpha > 0xff ) 	Alpha  = 0xff;
			if( Alpha2 > 0xa0 ) Alpha2 = 0xa0;			
			m_spBox[m_chMoveNo].SetAlpha	( (u8)Alpha );
			m_spBox2[m_chMoveNo].SetAlpha	( (u8)Alpha2 );
			if( m_chMoveNo < eLog-1){
				m_spBox[m_chMoveNo].SetIncX		( KATEGORI_GAPX/FIRST_MOVE_FRAME );
				m_spBox2[m_chMoveNo].SetIncX	( KATEGORI_GAPX/FIRST_MOVE_FRAME );
				m_spTitle[m_chMoveNo+1].SetIncX	( KATEGORI_GAPX/FIRST_MOVE_FRAME );
			}else{
				m_spBox[m_chMoveNo].SetIncX		( (KATEGORI_GAPX-PANEL_GAP_X)/FIRST_MOVE_FRAME );
				m_spBox2[m_chMoveNo].SetIncX	( (KATEGORI_GAPX-PANEL_GAP_X)/FIRST_MOVE_FRAME );
				m_spTitle[m_chMoveNo+1].SetIncX	( (KATEGORI_GAPX+15)/FIRST_MOVE_FRAME );
			}
			if( m_iTime == FIRST_MOVE_FRAME*(m_chMoveNo+2)-1 ){
				m_chMoveNo++;
				if( m_chMoveNo == KATEGORI_NUM-1 ){
					m_chMoveNo = 0;
					m_iTime = 0;
					SetYajirushi();
					m_eFirst = eFYajirushi;
					break;
				}
				m_spBox[m_chMoveNo].SetXY0		( TITLE_X+m_chMoveNo*KATEGORI_GAPX, PANEL_Y );			
				m_spBox2[m_chMoveNo].SetXY0		( TITLE_X+m_chMoveNo*KATEGORI_GAPX+DRAP_SHADOW_SIZE, PANEL_Y+DRAP_SHADOW_SIZE );			
				m_spTitle[m_chMoveNo+1].SetXY0	( TITLE_X+m_chMoveNo*KATEGORI_GAPX, TITLE_Y );
			}
		}
		m_iTime++;
		break;
	case eFYajirushi:
		return MoveKategori();
	}
	return false;
}

//========================================================================
// ZNgChE
//========================================================================
void	SK7PanelTutorial::MoveSelect()
{
	if( m_iCursolTime < CURSOL_MOVE_TIME ){
		//	J[\ړ	------------------------------------------
		f32 PlusX = FONT_SIZE;
		if( m_Font[m_chSelect].GetFontNum() < 3 ){
			PlusX += FONT_SIZE;
		}
		if( m_chKategori < eLog ){
			m_spCursol.SetIncXRight( (m_Font[m_chSelect].GetFontLengthX(true)+PlusX)/CURSOL_MOVE_TIME );
		}else{
			m_spCursol.SetIncXRight( (-m_Font[m_chSelect].GetFontLengthX(true)-PlusX)/CURSOL_MOVE_TIME );
		}
	}else{
		m_iCursolTime = CURSOL_MOVE_TIME;
	}
	m_iCursolTime++;
}

//========================================================================
// JeSChE
//========================================================================
bool	SK7PanelTutorial::MoveKategori()
{
	//	tHgZNg
	if( m_iYajiTime == 0 ){
		if( m_bLookFlag[0] )	m_Font[0].SetColor		( FONT_READ_COLOR );
		else					m_Font[0].SetColor		( 0xffffffff );
		m_spEye[0].SetAlpha	( 0xff );
		m_spEyeShadow[0].SetAlpha	( 0xff );
		if( m_chFontDrawNo < 3 && m_chKategori == eHm2 ){
			m_spCursol.SetVisible( false );
		}else{
			m_spCursol.SetVisible( true );
		}
	}
	
	//	ChE	--------------------------------------------------
	if( m_iYajiTime < YAJI_MOVE_NUM ){
		if( m_chKategori < eLog ){
			SET_SPRITE_ROT( &m_spYaji, tblYajirushi[m_iYajiTime].fAngle, KATEGORI_PLUSX(YAJI_X,m_chKategori)+YAJI_SIZE_X*0.5f, YAJI_Y+tblYajirushi[m_iYajiTime].fEx*YAJI_SIZE_Y*0.5f, YAJI_SIZE_X, YAJI_SIZE_Y );
			SET_SPRITE_ROT( &m_spYaji2, tblYajirushi[m_iYajiTime].fAngle, KATEGORI_PLUSX(YAJI_X+DRAP_SHADOW_SIZE,m_chKategori)+YAJI_SIZE_X*0.5f, YAJI_Y+DRAP_SHADOW_SIZE+tblYajirushi[m_iYajiTime].fEx*YAJI_SIZE_Y*0.5f, YAJI_SIZE_X, YAJI_SIZE_Y );
		}else{
			SET_SPRITE_ROT( &m_spYaji, tblYajirushi[m_iYajiTime].fAngle, KATEGORI_PLUSX(YAJI_X2,m_chKategori)+YAJI_SIZE_X*0.5f, YAJI_Y+tblYajirushi[m_iYajiTime].fEx*YAJI_SIZE_Y*0.5f, YAJI_SIZE_X, YAJI_SIZE_Y );
			SET_SPRITE_ROT( &m_spYaji2, tblYajirushi[m_iYajiTime].fAngle, KATEGORI_PLUSX(YAJI_X2+DRAP_SHADOW_SIZE,m_chKategori)+YAJI_SIZE_X*0.5f, YAJI_Y+DRAP_SHADOW_SIZE+tblYajirushi[m_iYajiTime].fEx*YAJI_SIZE_Y*0.5f, YAJI_SIZE_X, YAJI_SIZE_Y );
		}
		m_spShadow.SetAlpha( (u8)(m_spShadow.GetAlpha()+SHADOW_ALPHA/YAJI_MOVE_NUM) );
	}else{
		m_iYajiTime = YAJI_MOVE_NUM;
	}
	m_iYajiTime++;

	s16 SetAlpha;
	int LineNo;
	if( m_chKategori == eLog ){
		LineNo = m_chLogNum;
	}else{
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
			LineNo = tblTutorialFlowNum2[m_chFontDrawNo*KATEGORI_NUM+m_chKategori];
		}else{
			LineNo = tblTutorialFlowNum[m_chFontDrawNo*KATEGORI_NUM+m_chKategori];
		}
	}
	//	JeS	----------------------------------------------------
	if( LineNo > m_chFontLine ){
		
		SetAlpha = (m_bLookFlag[m_chFontLine]) ? (s16)FONT_READ_ALPHA : (s16)0xff;
		
		s16 Alpha = (s16)(m_Font[m_chFontLine].GetAlpha() + SetAlpha/FONT_MOVE_TIME);
		if( Alpha > SetAlpha ) Alpha = SetAlpha;
		m_Font[m_chFontLine].SetY( 	m_Font[m_chFontLine].GetPos()->y+TUTORIAL_FONT_GAPY/FONT_MOVE_TIME );
		m_Font[m_chFontLine].SetAlpha( (u8)Alpha );

		s16 MonkeyAlpha = (s16)(m_spEye[m_chFontLine].GetAlpha() + 0xff/FONT_MOVE_TIME);
		if( MonkeyAlpha > 0xff ) MonkeyAlpha = 0xff;
		m_spEye[m_chFontLine].SetY0			( m_Font[m_chFontLine].GetPos()->y-m_Font[m_chFontLine].GetFontLengthY(0)*0.5f+EYE_GAPY );
		m_spEye[m_chFontLine].SetAlpha		( (u8)MonkeyAlpha );
		m_spEyeShadow[m_chFontLine].SetY0	( m_spEye[m_chFontLine].GetY0()+DRAP_SHADOW_SIZE	 );
		m_spEyeShadow[m_chFontLine].SetAlpha( (u8)MonkeyAlpha );
		
		if( ++m_iTime >= FONT_MOVE_TIME ){
			m_iTime = 0;
			m_chFontLine++;
			if( m_chFontLine < MAX_FONT_NUM ){
				m_Font[m_chFontLine].SetY( 	m_Font[m_chFontLine-1].GetPos()->y );
				m_spEye[m_chFontLine].SetY0( m_Font[m_chFontLine-1].GetPos()->y-m_Font[m_chFontLine-1].GetFontLengthY(0)*0.5f+EYE_GAPY );
				m_spEyeShadow[m_chFontLine].SetY0( m_spEye[m_chFontLine].GetY0()+DRAP_SHADOW_SIZE );
			}
		}
	}else{
		if( m_iYajiTime >= YAJI_MOVE_NUM )	return true;
	}
	return false;
}
//========================================================================
// JeSChEZbg
//========================================================================
void	SK7PanelTutorial::SetMoveKategori()
{
	m_iYajiTime 	= 0;
	m_chFontLine	= 1;
	m_iTime 		= 0;
	m_chSelect		= 0;
	m_iCursolTime 	= 0;
	SetYajirushi();
	if( m_chKategori == eLog ){
		SetFontLog();
		SetMonkeyLog();
	}else{
		SetFont();
		SetMonkey();
	}
	SetCursol();
	if( m_chKategori < eLog ){		
		m_spShadow.SetSprite	( KATEGORI_PLUSX(YAJI_X,m_chKategori), SHADOW_Y, SHADOW_SIZEX, SHADOW_SIZEY, SHADOW_COLOR );
	}else{
		m_spShadow.SetSprite	( KATEGORI_PLUSX(YAJI_X+YAJI_SIZE_X,m_chKategori), SHADOW_Y, -SHADOW_SIZEX, SHADOW_SIZEY, SHADOW_COLOR );
	}
	m_spShadow.SetAlpha		( 0 );
//	m_spTitle2.SetTexSprite	( KATEGORI_PLUSX(TITLE_X-2,m_chKategori), TITLE_Y-2, &m_pTexture[TEX_TUTORIAL_MOJI_01+m_chKategori] );
	m_spTitle2.SetTexSprite	( m_spTitle[m_chKategori].GetX0()-2, TITLE_Y-2, &m_pTexture[TEX_TUTORIAL_MOJI_01+m_chKategori] );
	gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
}

//========================================================================
//	̃Zbg
//========================================================================
void		SK7PanelTutorial::SetYajirushi()
{
	if( m_chKategori < eLog ){
		SET_SPRITE_ROT( &m_spYaji, tblYajirushi[0].fAngle, KATEGORI_PLUSX(YAJI_X,m_chKategori)+YAJI_SIZE_X*0.5f, YAJI_Y+tblYajirushi[0].fEx*YAJI_SIZE_Y*0.5f, YAJI_SIZE_X, YAJI_SIZE_Y );
		SET_SPRITE_ROT( &m_spYaji2, tblYajirushi[0].fAngle, KATEGORI_PLUSX(YAJI_X+DRAP_SHADOW_SIZE,m_chKategori)+YAJI_SIZE_X*0.5f, YAJI_Y+DRAP_SHADOW_SIZE+tblYajirushi[0].fEx*YAJI_SIZE_Y*0.5f, YAJI_SIZE_X, YAJI_SIZE_Y );
	}else{
		SET_SPRITE_ROT( &m_spYaji, tblYajirushi[0].fAngle, KATEGORI_PLUSX(YAJI_X2,m_chKategori)+YAJI_SIZE_X*0.5f, YAJI_Y+tblYajirushi[0].fEx*YAJI_SIZE_Y*0.5f, YAJI_SIZE_X, YAJI_SIZE_Y );
		SET_SPRITE_ROT( &m_spYaji2, tblYajirushi[0].fAngle, KATEGORI_PLUSX(YAJI_X2+DRAP_SHADOW_SIZE,m_chKategori)+YAJI_SIZE_X*0.5f, YAJI_Y+DRAP_SHADOW_SIZE+tblYajirushi[0].fEx*YAJI_SIZE_Y*0.5f, YAJI_SIZE_X, YAJI_SIZE_Y );
	}
	m_spYaji.SetColor		( tblKategoriColor[m_chKategori]+YAJI_ALPHA );
	m_spYaji.SetVisible		( true );
	m_spYaji2.SetColor		( 0x000000a0 );
	m_spYaji2.SetVisible	( true );
}

//========================================================================
//	font̃Zbg
//========================================================================
void		SK7PanelTutorial::SetFont()
{
	u8 FontNo=0;
	u8 allno=0;
	for(int i = 0; i < m_chKategori; i++ ){
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
			allno += tblTutorialFlowNum2[K7SCNF_HT2*KATEGORI_NUM+i];
		}else{
			allno += tblTutorialFlowNum[K7SCNF_HT2*KATEGORI_NUM+i];
		}
	}
	s8 Kategori = m_chKategori;
	if( m_chKategori > eBlood ){
		Kategori--;
	}
	int TutorialNum=0;
	for(int i = 0; i < MAX_FONT_NUM; i++ ){
		m_Font[i].SetData	( m_pSentence );
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
			TutorialNum = tblTutorialFlowNum2[m_chFontDrawNo*KATEGORI_NUM+m_chKategori];
		}else{
			TutorialNum = tblTutorialFlowNum[m_chFontDrawNo*KATEGORI_NUM+m_chKategori];
		}
		if( i < TutorialNum ){
			//	fonẗʒuւ
			switch( m_chKategori ){
			case eBattle:
				while(1){
					if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
						if( tblDrawNoBattle[i+FontNo] <= m_chFontDrawNo ) break;
					}else{
						if( tblDrawNoBattle2[i+FontNo] <= m_chFontDrawNo ) break;
					}
					FontNo++;
				}
				break;
			case eBlood:
				while(1){
					if( tblDrawNoBlood[i+FontNo] <= m_chFontDrawNo ) break;
					FontNo++;
				}
				break;
			}
			//	tHgԍ̌tÕZbg
			m_bLookFlag[i] = (K7SCR_GET_GLOBAL_FLAG( K7GLFL_TUTORIAL_00+allno+i+FontNo)==true) ? true : false;
			m_Font[i].SetBlockLine	( (u8)Kategori, (u8)(i+FontNo) );
			
			if( m_chKategori < eLog ){
				m_Font[i].SetPos		( KATEGORI_PLUSX(TUTORIAL_FONT_X,m_chKategori), TUTORIAL_FONT_Y );
			}else{
				m_Font[i].SetPos		( KATEGORI_PLUSX(YAJI_X2,m_chKategori)-m_Font[i].GetFontLengthX(true), TUTORIAL_FONT_Y );
			}
			if( i == 0 )	m_Font[i].SetAlpha	( 0 );
			else			m_Font[i].SetAlpha	( 0 );
			m_Font[i].SetFlag	( true, FONT_EFC_RENDER );
		}else{
			m_Font[i].SetFlag	( false, FONT_EFC_RENDER );
		}
	}
}

//========================================================================
//	font̃Zbg
//========================================================================
void		SK7PanelTutorial::SetFontLog()
{
	int BlockNo=GameInfo.GetScenarioFlow() ;
	switch( GameInfo.GetScenarioFlow() ){
	case K7SCNF_HT2:
	case K7SCNF_GNK:
		BlockNo = 0;
		break;
	}
	int	LookLogNum=0,i;
	const s32* pLogData = &tblLogNoAll[GameInfo.GetScenarioFlow()][0];
	
	for( i = 0; i < MAX_LOG_NUM; i++ ){
		m_Font[i].SetData	( m_pSentence2 );
		//	O邩ǂ
		if( pLogData[i] == NULL )	break;
		//	̃OĂ邩ǂ?
		if( K7SCR_EVHASITEM(K7EVITEM_ZANID( (u32)pLogData[i] ))==false ) 	continue;
		//	tHgԍ̌tÕZbg
//		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_TUTORIAL_LOG_0+i )==true ){
			m_bLookFlag[LookLogNum] = true;
//		}else{
//			m_bLookFlag[LookLogNum] = false;
//		}
		//	CZbg
		m_Font[LookLogNum].SetBlockLine	( (u8)BlockNo, (u8)(i) );
		m_Font[LookLogNum].SetPos		( KATEGORI_PLUSX(YAJI_X2,eLog)-m_Font[LookLogNum].GetFontLengthX(true), TUTORIAL_FONT_Y );
		m_Font[LookLogNum].SetAlpha		( 0 );
		m_Font[LookLogNum].SetFlag		( true, FONT_EFC_RENDER );
		LookLogNum++;	//	O
	}
	m_chLogNum = (s8)LookLogNum;
	//	gȂ͕̂\Ȃ
	for( i = LookLogNum; i < MAX_FONT_NUM; i++ ){
		m_Font[i].SetFlag	( false, FONT_EFC_RENDER );		
	}
}

//========================================================================
//	JeS{bNXZbg
//========================================================================
void		SK7PanelTutorial::SetKategoriBox( bool Alpha )
{
	int boxno=0;
	for(int i = 0; i < m_chKategoriMax; i++ ){
		if( i != m_chKategori ){
			if( Alpha ){
				m_spBox[boxno].SetTexSprite	( KATEGORI_PLUSX(TITLE_X,m_chKategori), PANEL_Y, &m_pTexture[TEX_TUTORIAL_PANEL] );
				m_spBox2[boxno].SetTexSprite( KATEGORI_PLUSX(TITLE_X+DRAP_SHADOW_SIZE,m_chKategori), PANEL_Y+DRAP_SHADOW_SIZE, &m_pTexture[TEX_TUTORIAL_PANEL] );
			}else{
				m_spBox[boxno].SetTexSprite	( KATEGORI_PLUSX(TITLE_FIRST_X,m_chKategori), PANEL_Y, &m_pTexture[TEX_TUTORIAL_PANEL] );
				m_spBox2[boxno].SetTexSprite( KATEGORI_PLUSX(TITLE_FIRST_X+DRAP_SHADOW_SIZE,m_chKategori), PANEL_Y+DRAP_SHADOW_SIZE, &m_pTexture[TEX_TUTORIAL_PANEL] );
			}
			if( i < eLog ){
				m_spBox[boxno].SetSTTwo( 0.0f, 0.0f, 1.0f, 1.0f );
				m_spBox2[boxno].SetSTTwo( 0.0f, 0.0f, 1.0f, 1.0f );
			}else{
				m_spBox[boxno].SetSTTwo( 1.0f, 0.0f, 0.0f, 1.0f );
				m_spBox2[boxno].SetSTTwo( 1.0f, 0.0f, 0.0f, 1.0f );
			}
			m_spBox[boxno].SetColor		( tblKategoriColor[boxno+1]+0xff );
			m_spBox2[boxno].SetColor	( tblKategoriColor[boxno+1]+0xff );
			m_spBox[boxno].SetVisible	( true );
			m_spBox2[boxno].SetVisible	( true );
			boxno++;
		}else{
			if( Alpha ){
				m_spKategori.SetTexSprite	( KATEGORI_PLUSX(TITLE_X,m_chKategori), PANEL_Y, &m_pTexture[TEX_TUTORIAL_PANEL] );
				m_spKategori2.SetTexSprite	( KATEGORI_PLUSX(TITLE_X+DRAP_SHADOW_SIZE,m_chKategori), PANEL_Y+DRAP_SHADOW_SIZE, &m_pTexture[TEX_TUTORIAL_PANEL] );
			}else{
				m_spKategori.SetTexSprite	( KATEGORI_PLUSX(TITLE_FIRST_X,m_chKategori), PANEL_Y, &m_pTexture[TEX_TUTORIAL_PANEL] );
				m_spKategori2.SetTexSprite	( KATEGORI_PLUSX(TITLE_FIRST_X+DRAP_SHADOW_SIZE,m_chKategori), PANEL_Y+DRAP_SHADOW_SIZE, &m_pTexture[TEX_TUTORIAL_PANEL] );
			}
			if( i < eLog ){
				m_spKategori.SetSTTwo( 0.0f, 0.0f, 1.0f, 1.0f );
				m_spKategori2.SetSTTwo( 0.0f, 0.0f, 1.0f, 1.0f );
			}else{
				m_spKategori.SetSTTwo( 1.0f, 0.0f, 0.0f, 1.0f );
				m_spKategori2.SetSTTwo( 1.0f, 0.0f, 0.0f, 1.0f );
			}
			m_spKategori.SetColor		( tblKategoriColor[m_chKategori]+0xff );
			m_spKategori.SetVisible		( true );
			m_spKategori2.SetColor		( 0x000000a0 );
			m_spKategori2.SetVisible	( true );
		}
	}
}

//========================================================================
// ZNgZbg
//========================================================================
void	SK7PanelTutorial::SetSelect()
{
	SetCursol();
	gpSound->mPlaySE( SFX_SYS_CURSOR );
}

//========================================================================
// J[\Zbg
//========================================================================
void	SK7PanelTutorial::SetCursol()
{
	f32 Y = m_Font[m_chSelect].GetPos()->y+m_Font[m_chSelect].GetFontLengthY(0)+CURSOLGAP_Y;
	if( m_chKategori < eLog ){
		m_spCursol.SetXYTwo	( m_Font[m_chSelect].GetPos()->x, Y, m_Font[m_chSelect].GetPos()->x, Y+m_spCursol.GetTexSizeY() );
	}else{
		m_spCursol.SetXYTwo	( m_Font[m_chSelect].GetPos()->x+m_Font[m_chSelect].GetFontLengthX(), Y, m_Font[m_chSelect].GetPos()->x+m_Font[m_chSelect].GetFontLengthX(), Y+m_spCursol.GetTexSizeY() );
	}
	SET_SPRITE_ALPHA		( &m_spCursol, tblKategoriColor[m_chKategori],  SENTAKU_ALPHA );
	m_iCursolTime = 0;
}

//========================================================================
// L[Zbg
//========================================================================
void	SK7PanelTutorial::SetMonkey()
{	
	//	L[	--------------------------------------------------
	int i;
	u8 allno=0;
	u8 texno;
	int FontNo=0;
	for( i = 0; i < m_chKategori; i++ ){
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
			allno += tblTutorialFlowNum2[K7SCNF_HT2*KATEGORI_NUM+i];
		}else{
			allno += tblTutorialFlowNum[K7SCNF_HT2*KATEGORI_NUM+i];
		}
	}
	int TutorialNum=0;
	for( i = 0; i < MAX_FONT_NUM; i++ ){
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
			TutorialNum = tblTutorialFlowNum2[m_chFontDrawNo*KATEGORI_NUM+m_chKategori];
		}else{
			TutorialNum = tblTutorialFlowNum[m_chFontDrawNo*KATEGORI_NUM+m_chKategori];
		}
		if( i < TutorialNum ){
			//	fonẗʒuւ
			switch( m_chKategori ){
			case eBattle:
				while(1){
					if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==false && K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==false ){
						if( tblDrawNoBattle[i+FontNo] <= m_chFontDrawNo ) break;
					}else{
						if( tblDrawNoBattle2[i+FontNo] <= m_chFontDrawNo ) break;
					}
					FontNo++;
				}
				break;
			case eBlood:
				while(1){
					if( tblDrawNoBlood[i+FontNo] <= m_chFontDrawNo ) break;
					FontNo++;
				}
				break;
			}
			if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_TUTORIAL_00+allno+i+FontNo )==true ){
				texno = TEX_TUTORIAL_MONKEY_A;
			}else{
				texno=TEX_TUTORIAL_MONKEY_B;
			}
			if( m_chKategori < eLog ){
				m_spEye[i].SetTexSprite			( m_Font[i].GetPos()->x+MONKEY_GAP_LX, TUTORIAL_FONT_Y-m_Font[0].GetFontLengthY(0)*0.5f+EYE_GAPY, &m_pTexture[texno] );
				m_spEyeShadow[i].SetTexSprite	( m_spEye[i].GetX0()+DRAP_SHADOW_SIZE, m_spEye[i].GetY0()+DRAP_SHADOW_SIZE, &m_pTexture[texno] );
			}else{
				m_spEye[i].SetTexSprite			( m_Font[i].GetPos()->x+m_Font[i].GetFontLengthX(), TUTORIAL_FONT_Y-m_Font[0].GetFontLengthY(0)*0.5f+EYE_GAPY, &m_pTexture[texno] );
				m_spEyeShadow[i].SetTexSprite	( m_spEye[i].GetX0()+DRAP_SHADOW_SIZE, m_spEye[i].GetY0()+DRAP_SHADOW_SIZE, &m_pTexture[texno] );
			}
			m_spEye[i].SetVisible( true );
			m_spEyeShadow[i].SetVisible( true );
			m_spEye[i].SetColor( tblKategoriColor[m_chKategori] );
		}else{
			m_spEye[i].SetVisible( false );
			m_spEyeShadow[i].SetVisible( false );
		}
		m_spEyeShadow[i].SetColor( 0 );
	}
}

//========================================================================
// L[Zbg
//========================================================================
void	SK7PanelTutorial::SetMonkeyLog()
{
	int i;
	if((m_chKategori == eLog && m_chLogNum==0)){
		for( i = 0; i < MAX_FONT_NUM; i++ ){
			m_spEye[i].SetVisible( false );
			m_spEyeShadow[i].SetVisible( false );
		}
		return;
	}
	u8 texno;
	u8 No=0;
	const s32* pLogData = &tblLogNoAll[GameInfo.GetScenarioFlow()][0];
	for( i = 0; i < MAX_FONT_NUM; i++ ){
		if( pLogData[i] == NULL )	break;
		if( K7SCR_EVHASITEM(K7EVITEM_ZANID( (u32)pLogData[i] ) )!=true )	continue;
		if( No < m_chLogNum ){
//			if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_TUTORIAL_LOG_0+i )==true ){
				texno = TEX_TUTORIAL_MONKEY_A;
//			}else{
//				texno = TEX_TUTORIAL_MONKEY_B;
//			}
			if( m_chKategori < eLog ){
				m_spEye[No].SetTexSprite		( m_Font[No].GetPos()->x+MONKEY_GAP_LX, TUTORIAL_FONT_Y-m_Font[0].GetFontLengthY(0)*0.5f+EYE_GAPY, &m_pTexture[texno] );
				m_spEyeShadow[No].SetTexSprite	( m_spEye[No].GetX0()+DRAP_SHADOW_SIZE, m_spEye[No].GetY0()+DRAP_SHADOW_SIZE, &m_pTexture[texno] );
			}else{
				m_spEye[No].SetTexSprite		( m_Font[No].GetPos()->x+m_Font[No].GetFontLengthX(), TUTORIAL_FONT_Y-m_Font[0].GetFontLengthY(0)*0.5f+EYE_GAPY, &m_pTexture[texno] );
				m_spEyeShadow[No].SetTexSprite	( m_spEye[No].GetX0()+DRAP_SHADOW_SIZE, m_spEye[No].GetY0()+DRAP_SHADOW_SIZE, &m_pTexture[texno] );
			}
			m_spEye[No].SetVisible( true );
			m_spEyeShadow[No].SetVisible( true );
			m_spEye[No].SetColor( tblKategoriColor[m_chKategori] );
			m_spEyeShadow[No].SetColor( 0 );
			No++;
		}else{
			break;
		}
	}
	for( i = m_chLogNum; i < MAX_FONT_NUM; i++ ){
		m_spEye[i].SetVisible( false );
		m_spEyeShadow[i].SetVisible( false );
		m_spEyeShadow[i].SetColor( 0 );
	}
}

//========================================================================
// L[Zbg
//========================================================================
void	SK7PanelTutorial::SetReturnMenu()
{	
	m_Font[m_chSelect].SetColor( FONT_READ_COLOR );
	m_spEye[m_chSelect].SetTexture		( &m_pTexture[TEX_TUTORIAL_MONKEY_A] );
	m_spEyeShadow[m_chSelect].SetTexture( &m_pTexture[TEX_TUTORIAL_MONKEY_A] );
	m_lAnswer = TUTORIAL_STANDBY;
	m_Proc = PROC_SELECT_MAIN; 

}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelTutorial::LoadTexData()
{
	if( LoadPackData( TUTORIAL_PACK_DATA, TEX_TUTORIAL_MAX, PANEL_FONT_MATSU, 2 )){
		m_spYaji.SetTexSprite	( KATEGORI_PLUSX(YAJI_X,m_chKategori), YAJI_Y, &m_pTexture[TEX_TUTORIAL_YAJIRUSHI] );
		m_spYaji.SetVisible		( false );
		m_spYaji.SetColor		( tblKategoriColor[m_chKategori]+YAJI_ALPHA );
		m_spYaji2.SetTexSprite	( KATEGORI_PLUSX(YAJI_X+DRAP_SHADOW_SIZE,m_chKategori), YAJI_Y+DRAP_SHADOW_SIZE, &m_pTexture[TEX_TUTORIAL_YAJIRUSHI] );
		m_spYaji2.SetVisible	( false );
		m_spYaji2.SetColor		( 0x000000a0 );

		SetFont();

		m_spCursol.SetTexture	( &m_pTexture[TEX_TUTORIAL_SENTAKU] );
		m_spCursol.SetVisible	( false );
		m_spCursol.SetFlag		( true, VTX4_FLAG );
		SetCursol();
		SET_SPRITE_ALPHA		( &m_spCursol, tblKategoriColor[0],  SENTAKU_ALPHA );

		SetKategoriBox(false);
		SetMonkey();
		
		for( int i = 0; i < m_chKategoriMax; i++ ){
			m_spTitle[i].SetTexSprite	( TITLE_FIRST_X, TITLE_Y, &m_pTexture[TEX_TUTORIAL_MOJI_01+i] );
			m_spTitle[i].SetColor		( 0x000000ff );
			m_spTitle[i].SetVisible		( true );
		}

		m_spTitle2.SetTexSprite	( KATEGORI_PLUSX(TITLE_X-2,m_chKategori), TITLE_Y-2, &m_pTexture[TEX_TUTORIAL_MOJI_01+m_chKategori] );
		m_spTitle2.SetVisible	( true );
		m_spTitle2.SetColor		( 0xffffffff );
		
		m_spShadow.SetSprite	( KATEGORI_PLUSX(YAJI_X,m_chKategori), SHADOW_Y, SHADOW_SIZEX, SHADOW_SIZEY, SHADOW_COLOR );
		m_spShadow.SetVisible	( true );
		m_spShadow.SetAlpha		( 0 );
		return true;
	}
	return false;
}

