////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Nine
//
// SK7PanelValve.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELVALVE_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelValve.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


#define		HALF_SIZE_X		(256.0f)
#define		HALF_SIZE_Y		(256.0f)
#define		DIAL_CENTER_X	(320.0f)
#define		DIAL_CENTER_Y	(240.0f)
#define		MOVE_SPEED		(5)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelValve::SK7PanelValve( s32 Now ) : SK7PanelBase( Now, -1, false )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= Now;
	m_chSelect		= (s8)Now;
	m_fAngle		= 0;

	SetCursolPosition( &(Vec){0,0,0} );
	SetCursolDir( CURSOL_DIR_RIGHT );

	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);

	m_spValve.SetXYTwo( 64.0f, -16.0f, 576.0f, 496.0f );
	m_spValve.SetFlag( true, RENDER_FLAG|VTX4_FLAG );

	m_spCenter.SetXY0( 192, 112 );
	m_spCenter.SetFlag( true, RENDER_FLAG );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelValve::~SK7PanelValve()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spValve.Delete();
	m_spCenter.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelValve::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			SetCursolDisp( true );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		//	ouړ
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			m_sNowAnswer	= VALVE_ON;
			m_Proc = PROC_MOVE_VALVE;
			break;
		}
		//	LZ
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
	
	//	oüړ	=====================================================
	case	PROC_MOVE_VALVE:
		if( MoveValve(m_chSelect) ){
			m_sNowAnswer = (m_chSelect==VALVE_OFF) ? VALVE_ON : VALVE_OFF;
			m_Proc = PROC_MESSAGE;
		}
		break;
		
	//	bZ[W\	=============================================
	case	PROC_MESSAGE:
		if( DrawMessage(m_chSelect) ){
			m_Proc = PROC_CANCEL;
		}
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
/*	
	if( m_chSelect == 0 )							SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN );
	else if( m_chSelect == ROULETTE_ANSWER_NUM-1) 	SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_UP );
	else											SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_UP|CURSOL_DIR_DOWN );
*/	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelValve::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spValve.Render();
	m_spCenter.Render();
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelValve::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelValve::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelValve::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// oüړ
//========================================================================
bool	SK7PanelValve::MoveValve( s8 flag )
{
	if( flag == VALVE_OFF )	m_fAngle -= MOVE_SPEED;
	else					m_fAngle += MOVE_SPEED;
	
	Mtx m;
	MTXRotDeg( m, 'z', m_fAngle );

	Vec v={-HALF_SIZE_X,-HALF_SIZE_Y,0};
	MTXMultVec( m, &v, &v );
	m_spValve.SetXY0( DIAL_CENTER_X+v.x , DIAL_CENTER_Y+v.y );

	v.x = HALF_SIZE_X; v.y = -HALF_SIZE_Y;
	MTXMultVec( m, &v, &v );
	m_spValve.SetXY1( DIAL_CENTER_X+v.x , DIAL_CENTER_Y+v.y );

	v.x = -HALF_SIZE_X; v.y = HALF_SIZE_Y;
	MTXMultVec( m, &v, &v );
	m_spValve.SetXY2( DIAL_CENTER_X+v.x, DIAL_CENTER_Y+v.y );

	v.x = HALF_SIZE_X; v.y = HALF_SIZE_Y;
	MTXMultVec( m, &v, &v );
	m_spValve.SetXY3( DIAL_CENTER_X+v.x, DIAL_CENTER_Y+v.y );
	
	if( m_fAngle <= -360 && flag == VALVE_OFF )	return true;
	else if( m_fAngle >= 360 && flag == VALVE_ON )	return true;
	return false;
}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelValve::LoadTexData()
{
		switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL035015TEX_BG ) ){
			m_TexProc = LOAD_CENTER;
		}
		break;
	case 	LOAD_CENTER:	//	^
		if( m_spCenter.LoadTexture( PNL035015TEX_CENTER ) ){
			m_TexProc = LOAD_COCK;
		}
		break;
	case 	LOAD_COCK:	//	Z
		if( m_spValve.LoadTexture( PNL035015TEX_COCK ) ){
			return true;
		}
		break;
	}
	return false;
}
