////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelVending.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELVENDING_CPP__


#include "SK7PanelVending.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


#define	VENDING_PACK_DATA			"/Texture/panel/011302.pak"

#define	VEND_ANS_NUM		(3)
#define	VEND_CURSOL_X		(405)
const f32 tblCursolY[]={ 87, 155, 220, 300, 367, 433 };


//========================================================================
//					RXgN^
//========================================================================
SK7PanelVending::SK7PanelVending( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= VENDING_MISS;
	m_chSelect		= 0;
	m_chAnsNum		= 0;
		
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);

	m_iTime = 0;
		
	SetCursolPosition( &(Vec){VEND_CURSOL_X, tblCursolY[0], 0.0f} );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelVending::~SK7PanelVending()
{ 
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelVending::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( --m_chSelect < 0 ){
				m_chSelect = VENDING_NUM-1;
			}
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			SetCursolPosition( &(Vec){VEND_CURSOL_X, tblCursolY[m_chSelect], 0.0f} );
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			if( ++m_chSelect > VENDING_NUM-1 ){
				m_chSelect = 0;
			}
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			SetCursolPosition( &(Vec){VEND_CURSOL_X, tblCursolY[m_chSelect], 0.0f} );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( m_spLamp[m_chSelect].CheckFlag( RENDER_FLAG ) ){
				m_chAnsNum--;
				m_spLamp[m_chSelect].SetVisible		( false );
				m_spSwitch[m_chSelect].SetVisible	( false );				
				gpSound->mPlaySE( SFX_SYS_CANCEL );
				if( m_chAnsNum == VEND_ANS_NUM ){
					m_Proc = PROC_CHECK;
				}
			}else{
				m_chAnsNum++;
				m_spLamp[m_chSelect].SetVisible		( true );
				m_spSwitch[m_chSelect].SetVisible	( true );
				gpSound->mPlaySE( SFX_SYS_DECIDE );
				if( m_chAnsNum == VEND_ANS_NUM ){
					m_Proc = PROC_CHECK;
				}
			}
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			SetCursolDisp( false );
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_sNowAnswer = VENDING_CANCEL;
			m_Proc = PROC_CANCEL;
			break;
		}		
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		int i;
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			for( i = 0; i < VENDING_NUM; i++ ){
				m_spSwitch[i].SetVisible(false);
				m_spLamp[i].SetVisible	(false);
			}
			m_chAnsNum = 0;
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			const u8 tblVendAns[]={1,2,5};
			SetCursolDisp( false );
			for( i = 0; i < VEND_ANS_NUM; i++ ){
				if( !m_spLamp[tblVendAns[i]].CheckFlag( RENDER_FLAG ) ){
					gpSound->mPlaySE( SFX_SYS_PNL_MISS );
					m_sNowAnswer = VENDING_MISS;
					m_Proc = PROC_TIME;
					return true;
				}
			}
			gpSound->mPlaySE( SFX_SYS_PNL_OK );
			m_sNowAnswer = VENDING_OK;
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case PROC_TIME:
		if( ++m_iTime > 20 ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelVending::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	int i;
	for( i = 0; i < VENDING_NUM; i++ ){
		m_spSwitch[i].Render();
	}
	for( i = 0; i < VENDING_NUM; i++ ){
		m_spLamp[i].Render();
	}
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelVending::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelVending::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true)
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelVending::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelVending::LoadTexData()
{
	if( LoadPackData( VENDING_PACK_DATA, TEX_011302_MAX )){
		m_spBG.SetTexSprite	( 0, 0, &m_pTexture[TEX_011302_BASE] );
		m_spBG.SetVisible	( true );
		
		int i;
		const VEC2 tblLapmPos[]={
			28,52,
			137,52,
			246,52,
			27,272,
			136,272,
			245,272,
		};
		for( i = 0; i < VENDING_NUM; i++ ){
			m_spLamp[i].SetTexSprite( tblLapmPos[i].x, tblLapmPos[i].y, &m_pTexture[TEX_011302_PIC], 3, 2, (u16)i );
			m_spLamp[i].SetVisible( false );
		}
		
		const f32 tblSwitchPosY[]={ 57, 124, 191, 273, 338, 404, };
		for( i = 0; i < VENDING_NUM; i++ ){
			m_spSwitch[i].SetTexSprite( 383, tblSwitchPosY[i], &m_pTexture[TEX_011302_LAMP], 3, 2, (u16)i );
			m_spSwitch[i].SetVisible( false );
		}
		return true;
	}
	return false;
}
