////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cho
//
// SK7PanelVisitor.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELVISITOR_CPP?_

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelVisitor.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"

#define		NO_SIZE_X			(32) 
#define		NO_SIZE_Y			(64)
#define		NO_SIZE_GAP_Y		(4)
#define		NO_MOVE_FRAME		(5)

const VEC2 tblNoPos[]=
{
	60.0f, 242.0f,
	116.0f,242.0f,
	172.0f,242.0f,
	228.0f,242.0f,
	284.0f,242.0f,
	340.0f,242.0f,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelVisitor::SK7PanelVisitor( s32 Now ) : SK7PanelBase( Now )
{	
	//	TCg	----------------------------------------------	
	SetCursolPosition(&(Vec){tblNoPos[0].x+NO_SIZE_X/2.0f,tblNoPos[0].y+NO_SIZE_Y/2.0f,0});
	SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	
	m_bKeyState = false;
	m_cSelect	= 0;
	m_iMoveTime	= 0;
	
	//	ԈĂ
	m_sNowAnswer	= VISITOR_MISS;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	io[XvCg	------------------------------------------
	for( int i = 0; i < NO_MAX_NUM; i++ ){
		m_spNo[i].SetXY0( tblNoPos[i].x, tblNoPos[i].y );
		m_spNo[i].SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
		m_spNo[i].SetTexNo( (u8)0 );
	}
	//	܂͂ɂ炷
	m_spNoPlus1.SetXY0( tblNoPos[0].x, tblNoPos[0].y + NO_SIZE_Y + NO_SIZE_GAP_Y );
	m_spNoPlus1.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
	m_spNoPlus1.SetTexNo( (u8)1);
	
	//	
	m_spNoPlus2.SetXY0( tblNoPos[0].x, tblNoPos[0].y - NO_SIZE_Y - NO_SIZE_GAP_Y );
	m_spNoPlus2.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
	m_spNoPlus2.SetTexNo( (u8)9 );

}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelVisitor::~SK7PanelVisitor()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();	
	m_spNo[0].Delete();

}


//========================================================================
// t[
//========================================================================
s16			SK7PanelVisitor::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_MESSAGE;
		}
		break;
		
	case	PROC_MESSAGE:
		if( DrawMessage(0) ){
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A )
		{
			gpSound->mPlaySE(SFX_SCE3_PNL_ENT_KETTEI);
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			m_sNowAnswer = VISITOR_CANCEL;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) )
		{
			gpSound->mPlaySE(SFX_SCE3_PNL_ENT_ERABU);
			SetCursolDir( CURSOL_DIR_DOWN );
			m_Proc = PROC_MOVE_NO;
			m_bKeyState = true;
			break;
		}
		if( CheckKeyT( SK7_KEY_UP ) )
		{
			gpSound->mPlaySE(SFX_SCE3_PNL_ENT_ERABU);
			SetCursolDir( CURSOL_DIR_UP );
			m_Proc = PROC_MOVE_NO;
			m_bKeyState = false;
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) )
		{
			if( --m_cSelect < 0 ){
				m_cSelect = 0;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			s8 no = (s8)m_spNo[m_cSelect].GetTexNo();
			s8 no1 = (s8)(no+1), no2 = (s8)(no-1);
			if( no1 > 9 )  	(s8)no1 = 0;
			if( no2 < 0 )	(s8)no2 = 9;
			m_spNoPlus1.SetXY0( tblNoPos[m_cSelect].x, tblNoPos[m_cSelect].y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo( (u8)no1 );
			m_spNoPlus2.SetXY0( tblNoPos[m_cSelect].x, tblNoPos[m_cSelect].y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo( (u8)no2 );
			SetCursolPosition(&(Vec){tblNoPos[m_cSelect].x+NO_SIZE_X/2.0f,tblNoPos[m_cSelect].y+NO_SIZE_Y/2.0f,0});
			SetCursolDir( CURSOL_DIR_LEFT );
			break;
		}
		if( CheckKeyT( SK7_KEY_RIGHT ) )
		{
			if( ++m_cSelect >= NO_MAX_NUM ){
				m_cSelect = NO_MAX_NUM-1;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			s8 no = (s8)m_spNo[m_cSelect].GetTexNo();
			s8 no1 = (s8)(no+1), no2 = (s8)(no-1);
			if( no1 > 9 )  	(s8)no1 = 0;
			if( no2 < 0 )	(s8)no2 = 9;
			m_spNoPlus1.SetXY0( tblNoPos[m_cSelect].x, tblNoPos[m_cSelect].y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo( (u8)no1 );
			m_spNoPlus2.SetXY0( tblNoPos[m_cSelect].x, tblNoPos[m_cSelect].y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo( (u8)no2 );
			SetCursolPosition(&(Vec){tblNoPos[m_cSelect].x+NO_SIZE_X/2.0f,tblNoPos[m_cSelect].y+NO_SIZE_Y/2.0f,0});
			SetCursolDir( CURSOL_DIR_RIGHT );
			break;
		}
		break;

	//	io[ړ
	case 	PROC_MOVE_NO:
		if( MoveNo( m_bKeyState, m_cSelect ) )
		{
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	//	`FbNp	----------------------------------------------
	case 	PROC_CHECK:		
		switch( CheckAnswer() )
		{		
		case	PANEL_CHECK_RETURN:				//߂
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			m_Proc = PROC_SELECT_MAIN;	
			break;
		
		case	PANEL_CHECK_SET:				//
			if( m_spNo[0].GetTexNo() == 0 && m_spNo[1].GetTexNo() == 0 && m_spNo[2].GetTexNo() == 5 && 
				m_spNo[3].GetTexNo() == 6 && m_spNo[4].GetTexNo() == 4 && m_spNo[5].GetTexNo() == 8 )
			{
				m_sNowAnswer	= VISITOR_CLEAR;
				m_Proc = PROC_CANCEL;
//				m_pEffect = CreateMessage2Effect( m_cJmbHandle, PNLMES_CLEAR, TRUE );
			}
			else
			{
				m_Proc = PROC_TIME;
//				m_pEffect = CreateMessage2Effect( m_cJmbHandle, 1, TRUE );
			}
			break;
		}
		break;
		
	case	PROC_TIME:
		if( DrawMessage(1) )
		{
			m_Proc = PROC_CANCEL;
		}
#if 0
		if( !GetEffectValidState( m_pEffect ))
		{
			m_Proc = PROC_CANCEL;
		}
#endif
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	if( m_cSelect == 0 )					SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	else if( m_cSelect == NO_MAX_NUM-1 )	SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	else									SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelVisitor::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}

	m_spNoPlus1.Render();
	m_spNoPlus2.Render();

	for( int i = 0; i < NO_MAX_NUM; i++ ){
		m_spNo[i].Render();
	}

	m_spBG.Render();					//	wi
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelVisitor::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelVisitor::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelVisitor::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelVisitor::MoveNo(bool state, s8 select)
{
	f32 vSpeedY	= (NO_SIZE_Y+NO_SIZE_GAP_Y)/NO_MOVE_FRAME;
	
	//	Ƃ	
	if( state )		vSpeedY = -vSpeedY;
	
	m_spNo[select].SetXY0	( m_spNo[select].GetX0(), 	m_spNo[select].GetY0()	+ vSpeedY	);
	m_spNoPlus1.SetXY0		( m_spNoPlus1.GetX0(), 		m_spNoPlus1.GetY0() 	+ vSpeedY	);
	m_spNoPlus2.SetXY0		( m_spNoPlus2.GetX0(), 		m_spNoPlus2.GetY0() 	+ vSpeedY	);

	//	ԉZ
	if( ++m_iMoveTime >= NO_MOVE_FRAME ){
		s8 no0 = (s8)m_spNo[select].GetTexNo();
		s8 no1 = (s8)m_spNoPlus1.GetTexNo();
		s8 no2 = (s8)m_spNoPlus2.GetTexNo();
		
		//	ւ
		if( state ){
			if( ++no0 	>= 10 )	no0 = 0;
			if( ++no1 	>= 10 )	no1	= 0;
			if( ++no2	>= 10 )	no2 = 0;

			m_spNo[select].SetXY0	( tblNoPos[select].x, tblNoPos[select].y ); 
			m_spNo[select].SetTexNo	( (u8)no0 );
			m_spNoPlus1.SetXY0		( tblNoPos[select].x, tblNoPos[select].y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo	( (u8)no1 );
			m_spNoPlus2.SetXY0		( tblNoPos[select].x, tblNoPos[select].y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo	( (u8)no2 );
		}else{
			if( --no0 	< 0 )	no0 = 9;
			if( --no1 	< 0 )	no1	= 9;
			if( --no2	< 0 )	no2 = 9;

			m_spNo[select].SetXY0	( tblNoPos[select].x, tblNoPos[select].y ); 
			m_spNo[select].SetTexNo	( (u8)no0 );
			m_spNoPlus1.SetXY0		( tblNoPos[select].x, tblNoPos[select].y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo	( (u8)no1 );
			m_spNoPlus2.SetXY0		( tblNoPos[select].x, tblNoPos[select].y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo	( (u8)no2 );
		}
		m_iMoveTime = 0;
		return true;
	}
	
	return false;
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelVisitor::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL030101TEX_BG ) )
		{
			m_TexProc = LOAD_NO;
		}
		break;

	case 	LOAD_NO:	//	
		if( m_spNo[0].LoadTexture( PNL030101TEX_NO, 8, 2 ) )
		{
			for( int i = 1; i < NO_MAX_NUM; i++ ){
				m_spNo[i].SetTexture( m_spNo[0].GetTexture(), 8, 2 );
			}
			m_spNoPlus1.SetTexture( m_spNo[0].GetTexture(), 8, 2 );
			m_spNoPlus2.SetTexture( m_spNo[0].GetTexture(), 8, 2 );
			return true;
		}
		break;
	}
	return false;
}