////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Kouro
//
// mK7PanelKouro.cpp
// F
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7PANELKOURO_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "mK7PanelKouro.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"




//---- define ----
#define	PANELKOURO_FADE_TICK	(2400)	//tH[hɂ鎞
#define	PANELKOURO_X_TABLE		(36)	//XWe[uMAX
//ʃt@C
#define	PANEL010401TEX_SMOKE	"Texture/010401/smoke.bin"
//010401t@C
#define	PANEL010401TEX_KOURO	"Texture/010401/kouro.bin"
#define	PANEL010401TEX_OKOU0	"Texture/010401/1.bin"
#define	PANEL010401TEX_OKOU1	"Texture/010401/2.bin"
#define	PANEL010401TEX_OKOU2	"Texture/010401/3t.bin"
//010402t@C
#define	PANEL010402TEX_KOURO	"Texture/010402/heya2.bin"
#define	PANEL010402TEX_OKOU0	"Texture/010402/4.bin"
#define	PANEL010402TEX_OKOU1	"Texture/010402/5.bin"
#define	PANEL010402TEX_OKOU2	"Texture/010402/6t.bin"
//010403t@C
#define	PANEL010403TEX_KOURO	"Texture/010403/heya3.bin"
#define	PANEL010403TEX_OKOU0	"Texture/010403/7.bin"
#define	PANEL010403TEX_OKOU1	"Texture/010403/8t.bin"
#define	PANEL010403TEX_OKOU2	"Texture/010403/9.bin"




//========================================================================
//					RXgN^
//========================================================================
mK7PanelKouro::mK7PanelKouro( s32 Now ) : SK7PanelBase( Now )
{
	//	JZbg	---------------------------------------------
	Vec vPos={320,240,0};
	SetCursolPosition(&vPos);
	
	//ϐ
	mKeyTime        = 0;
	mLastCheck      = false;
	mInitSelectFlag = mSelectFlag;
	
	//F̎ނۑ
	mKouroNo = Now;
	
	//vZX
	mProc = ePanelKouroReadTexSmoke;
}


//========================================================================
//					fXgN^
//========================================================================
mK7PanelKouro::~mK7PanelKouro()
{
	//\
	mSpSmoke.SetFlag( false, RENDER_FLAG );
	mSpKouro.SetFlag( false, RENDER_FLAG );
	mSpOkou0.SetFlag( false, RENDER_FLAG );
	mSpOkou1.SetFlag( false, RENDER_FLAG );
	mSpOkou2.SetFlag( false, RENDER_FLAG );
	//eNX`
	mSpSmoke.Delete();
	mSpKouro.Delete();
	mSpOkou0.Delete();
	mSpOkou1.Delete();
	mSpOkou2.Delete();
	//XvCg
	GHM_SAFE_DELETE_ARRAY( mSmkSprt );
}


//========================================================================
// ̃tF[hݒ
// in --> s32 inType    0:tF[hC
//                      1:tF[hAEg
//        s32 inSelect  0-2:Iԍ
//========================================================================
void
mK7PanelKouro::mSetSmokeFade( s32 inType, s32 inSelect )
{
	u32	i;
	u32	smokeColor[3][3] = { { 0xd6eddd00, 0x7378b700, 0xf5644d00 },
							 { 0xffbe8900, 0x63af7500, 0xffe96700 },
							 { 0xa3dbe800, 0xdcf0b400, 0xd79fb700 } };
	
	for( i = 0; i < mSmokeHeight; i++ )
	{
		if( inType == 0 )
		{
			//tF[hC
			mXIndex = 0;
			mSmkSprt[i].mSetRGBA( smokeColor[mKouroNo][inSelect] );
			mSmkSprt[i].mSetFade( 0x70, PANELKOURO_FADE_TICK );
			mSmkSprt[i].mSetDispFlag( true );
		}else
		{
			//tF[hAEg
			mSmkSprt[i].mSetFade( 0, PANELKOURO_FADE_TICK*2 );
		}
	}
}

//========================================================================
// XWݒ
//========================================================================
void
mK7PanelKouro::mSetSmokeX0( void )
{
	u32	i;
	f32	tbl[PANELKOURO_X_TABLE] = {
	 0.000f,  0.173f,  0.342f,  0.500f,  0.642f,  0.766f,  0.866f,  0.939f,  0.984f,
	 1.000f,  0.984f,  0.939f,  0.866f,  0.766f,  0.642f,  0.500f,  0.342f,  0.173f,
	 0.000f, -0.173f, -0.342f, -0.500f, -0.642f, -0.766f, -0.866f, -0.939f, -0.984f,
	-1.000f, -0.984f, -0.939f, -0.866f, -0.766f, -0.642f, -0.500f, -0.342f, -0.173f };
	
	for( i = 0; i < mSmokeHeight; i++ )
	{
		mSmkSprt[i].mSetX0( (s16)(mSmkSprt[i].mGetX0() + (s16)(tbl[mXIndex] * 1.5f)) );
		mXIndex = (mXIndex + 1) % PANELKOURO_X_TABLE;
	}
}

//========================================================================
// t[
//========================================================================
s16
mK7PanelKouro::FrameProcess(void)
{
	u32			i;
	TEX_DATA*	texDat;
	char		fileName[64];
	
	switch( mProc )
	{
		//eNX`ǂݍ
		case	ePanelKouroReadTexSmoke:
			if( mSpSmoke.LoadTexture(PANEL010401TEX_SMOKE) == true )
			{
				texDat       = mSpSmoke.GetTexture();
				mSmokeHeight = texDat->Header->mHeight;
				mSmkSprt     = new mK7Sprite[mSmokeHeight];
				for( i = 0; i < mSmokeHeight; i++ )
				{
					mSmkSprt[i].mRelateTex( (stTexture*)mSpSmoke.GetTexture() );
					mSmkSprt[i].mSetWH( (s16)texDat->Header->mWidth, 1 );
					mSmkSprt[i].mSetUV0( 0, (s16)i );
					if( mKouroNo == 0 )
					mSmkSprt[i].mSetXY0( 128, (s16)(i - 128) );
					else
					mSmkSprt[i].mSetXY0( 64, (s16)(i - 128) );
					mSmkSprt[i].mSetDispFlag( false );
					mSmkSprt[i].mSetPriority( SPRT_PRI_NORMAL );
				}
				mProc = ePanelKouroReadTexKouro;
			}
			break;
		
		//eNX`ǂݍ
		case	ePanelKouroReadTexKouro:
			if( mKouroNo == 0 )strcpy( fileName, PANEL010401TEX_KOURO );
			if( mKouroNo == 1 )strcpy( fileName, PANEL010402TEX_KOURO );
			if( mKouroNo == 2 )strcpy( fileName, PANEL010403TEX_KOURO );
			if( mSpKouro.LoadTexture(fileName) == true )
			{
				mSpKouro.SetXY0(   0,   0 );
				mSpKouro.SetXY1( 640,   0 );
				mSpKouro.SetXY2(   0, 480 );
				mSpKouro.SetXY3( 640, 480 );
				mSpKouro.SetColor( 255, 255, 255, 255 );
				mSpKouro.SetFlag( true, RENDER_FLAG|COLOR_FLAG|VTX4_FLAG );
				mProc = ePanelKouroReadTexOkou0;
			}
			break;
		
		//eNX`ǂݍ
		case	ePanelKouroReadTexOkou0:
			if( mKouroNo == 0 )strcpy( fileName, PANEL010401TEX_OKOU0 );
			if( mKouroNo == 1 )strcpy( fileName, PANEL010402TEX_OKOU0 );
			if( mKouroNo == 2 )strcpy( fileName, PANEL010403TEX_OKOU0 );
			if( mSpOkou0.LoadTexture(fileName) == true )
			{
				texDat = mSpOkou0.GetTexture();
				if( mKouroNo == 0 )mSpOkou0.SetXY0( 235, 333 );
				if( mKouroNo == 1 )mSpOkou0.SetXY0( 112, 383 );
				if( mKouroNo == 2 )mSpOkou0.SetXY0(  89, 400 );
				mSpOkou0.SetXY1( mSpOkou0.GetX0() + texDat->Header->mWidth, mSpOkou0.GetY0() + 0 );
				mSpOkou0.SetXY2( mSpOkou0.GetX0(),                          mSpOkou0.GetY0() + texDat->Header->mHeight );
				mSpOkou0.SetXY3( mSpOkou0.GetX0() + texDat->Header->mWidth, mSpOkou0.GetY0() + texDat->Header->mHeight );
				mSpOkou0.SetColor( 255, 255, 255, 255 );
				mSpOkou0.SetFlag( true, RENDER_FLAG|COLOR_FLAG|VTX4_FLAG );
				mProc = ePanelKouroReadTexOkou1;
			}
			break;
		
		//eNX`ǂݍ
		case	ePanelKouroReadTexOkou1:
			SetCursolDisp(true);
			if( mKouroNo == 0 )strcpy( fileName, PANEL010401TEX_OKOU1 );
			if( mKouroNo == 1 )strcpy( fileName, PANEL010402TEX_OKOU1 );
			if( mKouroNo == 2 )strcpy( fileName, PANEL010403TEX_OKOU1 );
			if( mSpOkou1.LoadTexture(fileName) == true )
			{
				texDat = mSpOkou1.GetTexture();
				if( mKouroNo == 0 )mSpOkou1.SetXY0( 373, 261 );
				if( mKouroNo == 1 )mSpOkou1.SetXY0( 314, 371 );
				if( mKouroNo == 2 )mSpOkou1.SetXY0( 252, 342 );
				mSpOkou1.SetXY1( mSpOkou1.GetX0() + texDat->Header->mWidth, mSpOkou1.GetY0() + 0 );
				mSpOkou1.SetXY2( mSpOkou1.GetX0(),                          mSpOkou1.GetY0() + texDat->Header->mHeight );
				mSpOkou1.SetXY3( mSpOkou1.GetX0() + texDat->Header->mWidth, mSpOkou1.GetY0() + texDat->Header->mHeight );
				mSpOkou1.SetColor( 255, 255, 255, 255 );
				mSpOkou1.SetFlag( true, RENDER_FLAG|COLOR_FLAG|VTX4_FLAG );
				Vec vPos={mSpOkou1.GetX0() + (texDat->Header->mWidth / 2),mSpOkou1.GetY0() + (texDat->Header->mHeight / 2),0};
				SetCursolPosition(&vPos);
				SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT );

				mProc = ePanelKouroReadTexOkou2;
			}
			break;
		
		//eNX`ǂݍ
		case	ePanelKouroReadTexOkou2:
			if( mKouroNo == 0 )strcpy( fileName, PANEL010401TEX_OKOU2 );
			if( mKouroNo == 1 )strcpy( fileName, PANEL010402TEX_OKOU2 );
			if( mKouroNo == 2 )strcpy( fileName, PANEL010403TEX_OKOU2 );
			if( mSpOkou2.LoadTexture(fileName) == true )
			{
				texDat = mSpOkou2.GetTexture();
				if( mKouroNo == 0 )mSpOkou2.SetXY0( 391, 348 );
				if( mKouroNo == 1 )mSpOkou2.SetXY0( 336, 270 );
				if( mKouroNo == 2 )mSpOkou2.SetXY0( 411, 361 );
				mSpOkou2.SetXY1( mSpOkou2.GetX0() + texDat->Header->mWidth, mSpOkou2.GetY0() + 0 );
				mSpOkou2.SetXY2( mSpOkou2.GetX0(),                          mSpOkou2.GetY0() + texDat->Header->mHeight );
				mSpOkou2.SetXY3( mSpOkou2.GetX0() + texDat->Header->mWidth, mSpOkou2.GetY0() + texDat->Header->mHeight );
				mSpOkou2.SetColor( 255, 255, 255, 255 );
				mSpOkou2.SetFlag( true, RENDER_FLAG|COLOR_FLAG|VTX4_FLAG );
				mProc = ePanelKouroSelectOkou1;
				gpSound->mPlaySE( SFX_SYS_PNL_START );
			}
			break;
		
		//0I
		case	ePanelKouroSelectOkou0:
			if( m_bCtrl == true )
			{
				SetCursolDir( CURSOL_DIR_RIGHT, 0 );
				if( CheckKeyT( SK7_KEY_RIGHT ) )
				{
					SetCursolDir( CURSOL_DIR_RIGHT, 1 );
					texDat = mSpOkou1.GetTexture();
					Vec vPos={mSpOkou1.GetX0() + (texDat->Header->mWidth / 2),mSpOkou1.GetY0() + (texDat->Header->mHeight / 2),0};
					SetCursolPosition(&vPos);				
					mKeyTime = 0;
					gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
					mProc = ePanelKouroSelectOkou1;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = 0;
					mProc = ePanelKouroLastCheck;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(false);
					mProc = ePanelKouroCancel;
				}
			}
			break;
		
		//1I
		case	ePanelKouroSelectOkou1:
			if( m_bCtrl == true )
			{
				SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_RIGHT, 0 );
				if( CheckKeyT( SK7_KEY_LEFT ) )
				{
					SetCursolDir( CURSOL_DIR_LEFT, 1 );
					gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
					texDat = mSpOkou0.GetTexture();
					Vec vPos={mSpOkou0.GetX0() + (texDat->Header->mWidth / 2),mSpOkou0.GetY0() + (texDat->Header->mHeight / 2),0};
					SetCursolPosition(&vPos);				
					mKeyTime = 0;
					mProc = ePanelKouroSelectOkou0;
				}else
				if( CheckKeyT( SK7_KEY_RIGHT ) )
				{
					SetCursolDir( CURSOL_DIR_RIGHT, 1 );
					gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
					texDat = mSpOkou2.GetTexture();
					Vec vPos={mSpOkou2.GetX0() + (texDat->Header->mWidth / 2),mSpOkou2.GetY0() + (texDat->Header->mHeight / 2),0};
					SetCursolPosition(&vPos);				
					mKeyTime = 0;
					mProc = ePanelKouroSelectOkou2;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = 1;
					mProc = ePanelKouroLastCheck;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(false);
					mProc = ePanelKouroCancel;
				}
			}
			break;
		
		//2I
		case	ePanelKouroSelectOkou2:
			if( m_bCtrl == true )
			{
				SetCursolDir( CURSOL_DIR_LEFT, 0 );
				if( CheckKeyT( SK7_KEY_LEFT ) )
				{
					SetCursolDir( CURSOL_DIR_LEFT,1);
					gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
					texDat = mSpOkou1.GetTexture();
					Vec vPos={mSpOkou1.GetX0() + (texDat->Header->mWidth / 2),mSpOkou1.GetY0() + (texDat->Header->mHeight / 2),0};
					SetCursolPosition(&vPos);				
//					SetSightEffectPoint( mEfSight, &(Vec){mSpOkou1.GetX0() + (texDat->Header->mWidth / 2),mSpOkou1.GetY0() + (texDat->Header->mHeight / 2),0}, TRUE/*Yamada*/ );
//					SetSightSize( mEfSight, texDat->Header->mWidth, texDat->Header->mHeight );
					mKeyTime = 0;
					mProc = ePanelKouroSelectOkou1;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
//					SetSightEffectRenderFlag( mEfSight, false );
					mSelectFlag = 2;
					mProc = ePanelKouroLastCheck;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(false);
//					SetSightEffectRenderFlag( mEfSight, false );
					mProc = ePanelKouroCancel;
				}
			}
			break;
		
		//Ō̊mFs
		case	ePanelKouroLastCheck:
			switch( CheckAnswer() )
			{
				case	PANEL_CHECK_RETURN:
					SetCursolDisp(true);
//					SetSightEffectRenderFlag( mEfSight, true );
					switch( mSelectFlag  )
					{
						case	0:
							mProc = ePanelKouroSelectOkou0;
							break;
						case	1:
							mProc = ePanelKouroSelectOkou1;
							break;
						case	2:
							mProc = ePanelKouroSelectOkou2;
							break;
					}
					break;
				case	PANEL_CHECK_SET:
					switch( mSelectFlag  )
					{
						case	0:
							mSpOkou0.SetFlag( false, RENDER_FLAG );
							break;
						case	1:
							mSpOkou1.SetFlag( false, RENDER_FLAG );
							break;
						case	2:
							mSpOkou2.SetFlag( false, RENDER_FLAG );
							break;
					}
					mSetSmokeFade( 0, mSelectFlag );
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mProc = ePanelKouroSmokeFadeIn;
					break;
			}
			break;
		
		//tF[hC
		case	ePanelKouroSmokeFadeIn:
			mSetSmokeX0();
			if( mSmkSprt[0].mGetFadeEnd() == true )
			{
				mSetSmokeFade( 1, 0 );
				mProc = ePanelKouroSmokeFadeOut;
			}
			break;
		
		//tF[hAEg
		case	ePanelKouroSmokeFadeOut:
			mSetSmokeX0();
			if( mSmkSprt[0].mGetFadeEnd() == true )
			{
				for( i = 0; i < mSmokeHeight; i++ )
				{
					mSmkSprt[i].mSetDispFlag( false );
				}
				mProc = ePanelKouroSmokeMessage;
			}
			break;
		
	case	ePanelKouroSmokeMessage:
		switch( mSelectFlag ){
		case 0:
			switch( mKouroNo ){
			case 0:	if( DrawMessage(2) )	mProc = ePanelKouroDecide;	break;
			case 1:	if( DrawMessage(1) )	mProc = ePanelKouroDecide;	break;
			case 2:	if( DrawMessage(0) )	mProc = ePanelKouroDecide;	break;
			}
			break;
		case 1:
			switch( mKouroNo ){
			case 0:	if( DrawMessage(0) )	mProc = ePanelKouroDecide;	break;
			case 1:	if( DrawMessage(4) )	mProc = ePanelKouroDecide;	break;
			case 2:	if( DrawMessage(3) )	mProc = ePanelKouroDecide;	break;
			}
			break;
		case 2:
			switch( mKouroNo ){
			case 0:	if( DrawMessage(1) )	mProc = ePanelKouroDecide;	break;
			case 1:	if( DrawMessage(3) )	mProc = ePanelKouroDecide;	break;
			case 2:	if( DrawMessage(1) )	mProc = ePanelKouroDecide;	break;
			}
			break;
		}
		break;
		
		//II
		case	ePanelKouroDecide:
		case	ePanelKouroCancel:
			break;
		
		default:
			break;
	}
		
	return( 0 );
}

//========================================================================
// _O
//========================================================================
bool
mK7PanelKouro::RenderProcess(void)
{
	if( m_bRender == false ){
		return( true );
	}
	
	//mSpSmoke.Render();
	mSpKouro.Render();
	mSpOkou0.Render();
	mSpOkou1.Render();
	mSpOkou2.Render();
	
	return( true );
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool
mK7PanelKouro::mGetFileReadEnd(void)
{
	if( (mProc == ePanelKouroReadTexSmoke)
	 || (mProc == ePanelKouroReadTexKouro)
	 || (mProc == ePanelKouroReadTexOkou0)
	 || (mProc == ePanelKouroReadTexOkou1)
	 || (mProc == ePanelKouroReadTexOkou2))
	{
		return( false );
	}
	
	return( true );
}

//========================================================================
// 싖ݒ֐
//========================================================================
void
mK7PanelKouro::mSetCtrlFlag( bool inBool )
{
	m_bCtrl = inBool;
}

//========================================================================
// _Oݒ֐
//========================================================================
void
mK7PanelKouro::mSetRender( bool inBool )
{
	m_bRender = inBool;
//	SetSightEffectRenderFlag( mEfSight, inBool );
}

//========================================================================
// II擾֐
//========================================================================
bool
mK7PanelKouro::mGetSelectEnd(void)
{
	if( (mProc == ePanelKouroDecide) || (mProc == ePanelKouroCancel) )
	{
		return( true );
	}
	
	return( false );
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32
mK7PanelKouro::mGetResult(void)
{
	//ԍe[u
	s32	ans[3] = { 2, 1, 1 };
	
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( mProc )
	{
		case	ePanelKouroCancel:
			return( PANEL_OPERATE_CANCEL );
		
		case	ePanelKouroDecide:
			if( mSelectFlag == ans[mKouroNo] )
				return( true );
			else
				return( false );
		
		default:
			break;
	}
	
	return( PANEL_OPERATE_CANCEL );
}














