////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 00
//
// mK7PanelSwitch00.cpp
// @̃̕Cg̃XCb`
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/25/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7PANELSWITCH00_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "mK7PanelSwitch00.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"




//---- define ----
#define	PANEL000101TEX_OFF	"Texture/000101/02switch_off.bin"
#define	PANEL000101TEX_ON	"Texture/000101/02switch.bin"




//========================================================================
//					RXgN^
//========================================================================
mK7PanelSwitch00::mK7PanelSwitch00( s32 Now ) : SK7PanelBase( Now )
{
	//	JZbg	---------------------------------------------
	SetEffectCamera( WK7CAM->GetCObj() );
	if( (Now == 0) || (Now == PANEL_INIT_ARRANGE) )
	{
		//XCb`off̏Ԃɂ
		mSelectFlag = false;
		Vec vPos={320,272,0};
		SetCursolPosition(&vPos);
		SetCursolDir( CURSOL_DIR_UP );
//		mEfSight    = CreateSightEffect( (Vec){320,272,0}, 0, 0, SIGHT_TYPE_CURSOR );
	}else
	{
		//XCb`on̏Ԃɂ
		mSelectFlag = true;
		Vec vPos={320,208,0};
		SetCursolPosition(&vPos);
		SetCursolDir( CURSOL_DIR_DOWN );
//		mEfSight    = CreateSightEffect( (Vec){320,208,0}, 0, 0, SIGHT_TYPE_CURSOR );
	}
//	SetSightSize( mEfSight, 74, 34 );
//	SetSightEffectRenderFlag( mEfSight, false );
	
	//ϐ
	mKeyTime        = 0;
	mLastCheck      = false;
	mInitSelectFlag = mSelectFlag;
	
	//vZX
	mProc = ePanelSwitch00ReadTexOff;
}


//========================================================================
//					fXgN^
//========================================================================
mK7PanelSwitch00::~mK7PanelSwitch00()
{
	//\
	mSpOff.SetFlag( false, RENDER_FLAG );
	mSpOn.SetFlag( false, RENDER_FLAG );
	//eNX`
	mSpOff.Delete();
	mSpOn.Delete();
	
//	DelReqSightEffec( mEfSight );
}


//========================================================================
// t[
//========================================================================
s16
mK7PanelSwitch00::FrameProcess(void)
{
	Vec switchPosTbl[] = { 320.0f, 208.0f, 0.0f,
						   320.0f, 272.0f, 0.0f, };
	
	switch( mProc )
	{
		//offeNX`ǂݍ
		case	ePanelSwitch00ReadTexOff:
			if( mSpOff.LoadTexture(PANEL000101TEX_OFF) == true )
			{
				mSpOff.SetXY0(   0,   0 );
				mSpOff.SetXY1( 640,   0 );
				mSpOff.SetXY2(   0, 480 );
				mSpOff.SetXY3( 640, 480 );
				mSpOff.SetColor( 255, 255, 255, 255 );
				mSpOff.SetFlag( true, COLOR_FLAG|VTX4_FLAG );
				if( mSelectFlag == false )
					mSpOff.SetFlag( true, RENDER_FLAG );
				else
					mSpOff.SetFlag( false, RENDER_FLAG );
				mProc = ePanelSwitch00ReadTexOn;
			}
			break;
		
		//oneNX`ǂݍ
		case	ePanelSwitch00ReadTexOn:
			if( mSpOn.LoadTexture(PANEL000101TEX_ON) == true )
			{
				mSpOn.SetXY0(   0,   0 );
				mSpOn.SetXY1( 640,   0 );
				mSpOn.SetXY2(   0, 480 );
				mSpOn.SetXY3( 640, 480 );
				mSpOn.SetColor( 255, 255, 255, 255 );
				mSpOn.SetFlag( true, COLOR_FLAG|VTX4_FLAG );
				if( mSelectFlag == false )
				{
					mSpOn.SetFlag( false, RENDER_FLAG );
					mProc = ePanelSwitch00DispOff;
				}else
				{
					mSpOn.SetFlag( true, RENDER_FLAG );
					mProc = ePanelSwitch00DispOn;
				}
			}
			break;
		
		//off\
		case	ePanelSwitch00DispOff:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP)
				{
					SetCursolDir( CURSOL_DIR_DOWN );
					gpSound->mPlaySE( SFX_SYS_CURSOR );
//					gpSound->mPlaySE( SFX_SCE0_SWITCH );
					SetCursolPosition( &switchPosTbl[0] );
					mKeyTime = 0;
					mProc = ePanelSwitch00DispOn;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = false;
					mProc       = ePanelSwitch00Decide;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					SetCursolDisp(false);
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch00Cancel;
				}
			}
			break;
		
		//on\
		case	ePanelSwitch00DispOn:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
				{
					SetCursolDir( CURSOL_DIR_UP );
					gpSound->mPlaySE( SFX_SYS_CURSOR );
//					gpSound->mPlaySE( SFX_SCE0_SWITCH );
					SetCursolPosition( &switchPosTbl[1] );
					mKeyTime = 0;
					mProc = ePanelSwitch00DispOff;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = true;
					mProc       = ePanelSwitch00Decide;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(false);
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch00Cancel;
				}
			}
			break;
		
		//II
		case	ePanelSwitch00Decide:
		case	ePanelSwitch00Cancel:
			//Ō̊mFs
			if( mLastCheck == false )
			{
				switch( CheckAnswer() )
				{
				case	PANEL_CHECK_RETURN:
					SetCursolDisp(true);
					if( mSelectFlag == false )
					{
						mProc = ePanelSwitch00DispOff;
					}else
					{
						mProc = ePanelSwitch00DispOn;
					}
					break;
				case	PANEL_CHECK_SET:
					SetCursolDisp(false);
					m_sLastWait = PANEL_LAST_WAIT;
					if( mSelectFlag == false )
					{
						mSpOff.SetFlag( true, RENDER_FLAG );
						mSpOn.SetFlag( false, RENDER_FLAG );
					}else
					{
						mSpOff.SetFlag( false, RENDER_FLAG );
						mSpOn.SetFlag( true, RENDER_FLAG );
					}
					//莞̂SEĐ
					if( mProc == ePanelSwitch00Decide )
					{
						gpSound->mPlaySE( SFX_SCE0_SWITCH );
					}
					mLastCheck = true;
					mProc = ePanelSwitch00Message;
					break;
				}
			
			}else{
				m_sLastWait = 0;
			}
			break;
/*			{
				if( m_sLastWait > 0 )
				{
					//ŏXCb`̕\؂ւ
					if( m_sLastWait == PANEL_LAST_WAIT )
					{
					}
					m_sLastWait -= WK7_TICK_PER_FRAME;
				}else
				{
					m_sLastWait = 0;
				}
			}
			break;
*/
		case ePanelSwitch00Message:
			if( mSelectFlag == true ){
				if( DrawMessage( 23 ) ){
					m_sLastWait = 0;
					mProc = ePanelSwitch00MessageEnd;
				}
			}else{
				if( DrawMessage( 24 ) ){
					m_sLastWait = 0;
					mProc = ePanelSwitch00MessageEnd;
				}
			}
			break;
		case ePanelSwitch00MessageEnd:
		default:
			break;
	}	
	return( 0 );
}

//========================================================================
// _O
//========================================================================
bool
mK7PanelSwitch00::RenderProcess(void)
{
	if( m_bRender == false ){
		return( true );
	}
	
	mSpOff.Render();
	mSpOn.Render();
	
	
	return( true );
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool
mK7PanelSwitch00::mGetFileReadEnd(void)
{
	if( (mProc == ePanelSwitch00ReadTexOff) || (mProc == ePanelSwitch00ReadTexOn) )
	{
		return( false );
	}
	
	return( true );
}

//========================================================================
// 싖ݒ֐
//========================================================================
void
mK7PanelSwitch00::mSetCtrlFlag( bool inBool )
{
	m_bCtrl = inBool;
}

//========================================================================
// _Oݒ֐
//========================================================================
void
mK7PanelSwitch00::mSetRender( bool inBool )
{
	m_bRender = inBool;
	SetCursolDisp(inBool);
}

//========================================================================
// II擾֐
//========================================================================
bool
mK7PanelSwitch00::mGetSelectEnd(void)
{
	if( m_sLastWait == 0 )
	{
		return( true );
	}
	
	return( false );
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32
mK7PanelSwitch00::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( mProc )
	{
		case	ePanelSwitch00Cancel:
			return( PANEL_OPERATE_CANCEL );
		
		case	ePanelSwitch00Message:
		case	ePanelSwitch00MessageEnd:
			return( mSelectFlag );
		
		default:
			break;
	}
	
	return( PANEL_OPERATE_CANCEL );
}














