////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 01
//
// mK7PanelSwitch01.cpp
// @̃XCb`
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/26/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7PANELSWITCH01_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "mK7PanelSwitch01.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"




//---- define ----
#define	PANEL000102TEX_ON	"Texture/000102/dryer02_on.bin"
#define	PANEL000102TEX_OFF	"Texture/000102/dryer02_off.bin"
#define	PANEL000102_WIDTH	(640)//(240)	//\鉡




//========================================================================
//					RXgN^
//========================================================================
mK7PanelSwitch01::mK7PanelSwitch01( s32 Now ) : SK7PanelBase( Now )
{
	//	JZbg	---------------------------------------------
	SetEffectCamera( WK7CAM->GetCObj() );
	if( (Now == 0) || (Now == PANEL_INIT_ARRANGE) )
	{
		SetCursolDir( CURSOL_DIR_LEFT );
		//XCb`off̏Ԃɂ
		mSelectFlag = false;
	}else
	{
		SetCursolDir( CURSOL_DIR_RIGHT );
		//XCb`on̏Ԃɂ
		mSelectFlag = true;
	}
	SetCursolPosition( &(Vec){320,240,0} );
	SetCursolDisp(false);

	//ϐ
	mKeyTime        = 0;
	mLastCheck      = false;
	mInitSelectFlag = mSelectFlag;
	
	//vZX
	mProc = ePanelSwitch01ReadTexOn;
}


//========================================================================
//					fXgN^
//========================================================================
mK7PanelSwitch01::~mK7PanelSwitch01()
{
	//\
	mSpOff.SetFlag( false, RENDER_FLAG );
	mSpOn.SetFlag( false, RENDER_FLAG );
	//eNX`
	mSpOff.Delete();
	mSpOn.Delete();
	
//	DelReqSightEffec( mEfSight );
}


//========================================================================
// t[
//========================================================================
s16
mK7PanelSwitch01::FrameProcess(void)
{
	TEX_DATA*	texDat;
	Vec switchPosTbl[] = { 573.0f, 61.0f, 0.0f,
						   506.0f, 61.0f, 0.0f, };
	
	switch( mProc )
	{
		//oneNX`ǂݍ
		case	ePanelSwitch01ReadTexOn:
			if( mSpOn.LoadTexture(PANEL000102TEX_ON) == true )
			{
				if( 0 )
				{
					mSpOn.SetXY0(   0,   0 );
					mSpOn.SetXY1( 640,   0 );
					mSpOn.SetXY2(   0, 480 );
					mSpOn.SetXY3( 640, 480 );
				}else
				{
					mSpOn.SetXY0( 640-PANEL000102_WIDTH,   0 );
					mSpOn.SetXY1( 640,   0 );
					mSpOn.SetXY2( 640-PANEL000102_WIDTH, 480 );
					mSpOn.SetXY3( 640, 480 );
					mSpOn.SetST0( (f32)((f32)(640-PANEL000102_WIDTH)/640.0f), 0.0f );
					mSpOn.SetST2( (f32)((f32)(640-PANEL000102_WIDTH)/640.0f), 1.0f );
				}
				mSpOn.SetColor( 255, 255, 255, 255 );
				mSpOn.SetFlag( true, RENDER_FLAG|COLOR_FLAG|VTX4_FLAG );
				mProc = ePanelSwitch01ReadTexOff;
			}
			break;
		
		//offeNX`ǂݍ
		case	ePanelSwitch01ReadTexOff:
			if( mSpOff.LoadTexture(PANEL000102TEX_OFF) == true )
			{
				texDat = mSpOff.GetTexture();
				mSpOff.SetXY0( 492,  95 );
				mSpOff.SetXY1( mSpOff.GetX0() + texDat->Header->mWidth,                           mSpOff.GetY0() );
				mSpOff.SetXY2(                          mSpOff.GetX0(), mSpOff.GetY0() + texDat->Header->mHeight );
				mSpOff.SetXY3( mSpOff.GetX0() + texDat->Header->mWidth, mSpOff.GetY0() + texDat->Header->mHeight );
				mSpOff.SetColor( 255, 255, 255, 255 );
				mSpOff.SetFlag( true, COLOR_FLAG|VTX4_FLAG );
				if( mSelectFlag == false )
				{
					SetCursolPosition( &switchPosTbl[0] );
					mSpOff.SetFlag( true, RENDER_FLAG );
					mProc = ePanelSwitch01DispOff;
				}else
				{
					SetCursolPosition( &switchPosTbl[1] );
					mSpOff.SetFlag( false, RENDER_FLAG );
					mProc = ePanelSwitch01DispOn;
				}
			}
			break;
		
		//off\
		case	ePanelSwitch01DispOff:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_LEFT )
				{
					gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
					SetCursolPosition( &switchPosTbl[1] );
					mKeyTime = 0;
					mSelectFlag = true;
					SetCursolDir( CURSOL_DIR_RIGHT );
					mProc = ePanelSwitch01DispOn;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mProc       = ePanelSwitch01Decide;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(  false );
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch01Cancel;
				}
			}
			break;
		
		//on\
		case	ePanelSwitch01DispOn:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_RIGHT )
				{
					gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
					SetCursolPosition( &switchPosTbl[0] );
					mKeyTime = 0;
					mSelectFlag = false;
					SetCursolDir( CURSOL_DIR_LEFT );
					mProc = ePanelSwitch01DispOff;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mProc       = ePanelSwitch01Decide;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(  false );
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch01Cancel;
				}
			}
			break;
		
		//II
		case	ePanelSwitch01Decide:
		case	ePanelSwitch01Cancel:
			//Ō̊mFs
			if( mLastCheck == false )
			{
				switch( CheckAnswer() )
				{
					case	PANEL_CHECK_RETURN:
						SetCursolDisp(  true );
						if( mSelectFlag == false )
						{
							mProc = ePanelSwitch01DispOff;
						}else
						{
							mProc = ePanelSwitch01DispOn;
						}
						break;
					case	PANEL_CHECK_SET:
						SetCursolDisp( false );
						mLastCheck = true;
						if( mSelectFlag == false )
						{
							mSpOff.SetFlag( true, RENDER_FLAG );
							gpSound->mPlaySE( SFX_SCE0_DRY_SWITCH );
							gpSound->mPlaySE( SFX_SYS_PNL_OK );
						}else
						{
							mSpOff.SetFlag( false, RENDER_FLAG );
							//莞̂SEĐ
							if( mProc == ePanelSwitch01Decide )
							{
								gpSound->mPlaySE( SFX_SCE0_DRY_SWITCH );
								gpSound->mPlaySE( SFX_SYS_PNL_OK );
							}
						}
						m_sLastWait = PANEL_LAST_WAIT;
						if( mInitSelectFlag == mSelectFlag ){
							m_sLastWait = 0;
							mProc = ePanelSwitch01MessageEnd;
							break;
						}
						mLastCheck = true;
//						mProc = ePanelSwitch01Message;
						break;
				}
			}else{
				if( m_sLastWait > 0 )
				{
					//ŏXCb`̕\؂ւ
					if( m_sLastWait == PANEL_LAST_WAIT )
					{
					}
					m_sLastWait -= WK7_TICK_PER_FRAME;
				}else
				{
					m_sLastWait = 0;
					mProc = ePanelSwitch01MessageEnd;
				}
			}
			break;
		case	ePanelSwitch01Message:
			if( mSelectFlag == false ){
//				if( DrawMessage(1) ){
					m_sLastWait = 0;
					mProc = ePanelSwitch01MessageEnd;
//				}
			}else{
//				if( DrawMessage(0) ){
					m_sLastWait = 0;
					mProc = ePanelSwitch01MessageEnd;
//				}
			}
			break;
			
		default:
			break;
	}
	
	return( 0 );
}

//========================================================================
// _O
//========================================================================
bool
mK7PanelSwitch01::RenderProcess(void)
{
	if( m_bRender == false ){
		return( true );
	}
	
	mSpOn.Render();
	mSpOff.Render();
	
	return( true );
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool
mK7PanelSwitch01::mGetFileReadEnd(void)
{
	if( (mProc == ePanelSwitch01ReadTexOff) || (mProc == ePanelSwitch01ReadTexOn) )
	{
		return( false );
	}
	
	return( true );
}

//========================================================================
// 싖ݒ֐
//========================================================================
void
mK7PanelSwitch01::mSetCtrlFlag( bool inBool )
{
	m_bCtrl = inBool;
}

//========================================================================
// _Oݒ֐
//========================================================================
void
mK7PanelSwitch01::mSetRender( bool inBool )
{
	m_bRender = inBool;
	SetCursolDisp(  inBool );
}

//========================================================================
// II擾֐
//========================================================================
bool
mK7PanelSwitch01::mGetSelectEnd(void)
{
	if( m_sLastWait == 0 )
	{
		return( true );
	}
	
	return( false );
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32
mK7PanelSwitch01::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( mProc )
	{
		case	ePanelSwitch01Cancel:
			return( PANEL_OPERATE_CANCEL );
		
		case	ePanelSwitch01Decide:
		case	ePanelSwitch01Message:
		case	ePanelSwitch01MessageEnd:
			return( mSelectFlag );
		
		default:
			break;
	}
	
	return( PANEL_OPERATE_CANCEL );
}














