////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 02
//
// mK7PanelSwitch02.cpp
// ZeBbN2FʘH̏ƖXCb`
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7PANELSWITCH02_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "mK7PanelSwitch02.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"




//---- define ----
#define	PANEL000201TEX_OFF	"Texture/000201/02switch_off.bin"
#define	PANEL000201TEX_ON	"Texture/000201/02switch.bin"




//========================================================================
//					RXgN^
//========================================================================
mK7PanelSwitch02::mK7PanelSwitch02( s32 Now ) : SK7PanelBase( Now )
{
	m_sNowAnswer = Now;
	if( (Now == 0) || (Now == PANEL_INIT_ARRANGE) )
	{
		//XCb`off̏Ԃɂ
		mSelectFlag = false;
		SetCursolPosition( &(Vec){320,272,0} );
		SetCursolDir( CURSOL_DIR_UP );
//		mEfSight    = CreateSightEffect( (Vec){320,272,0}, 0, 0, SIGHT_TYPE_CURSOR );
	}else
	{
		//XCb`on̏Ԃɂ
		mSelectFlag = true;
		SetCursolDir( CURSOL_DIR_DOWN );
		SetCursolPosition( &(Vec){320,208,0} );
//		mEfSight    = CreateSightEffect( (Vec){320,208,0}, 0, 0, SIGHT_TYPE_CURSOR );
	}
//	SetSightSize( mEfSight, 74, 34 );
//	SetCursolDisp( false );
	
	//ϐ
	mKeyTime        = 0;
	mLastCheck      = false;
	mInitSelectFlag = mSelectFlag;
	
	//vZX
	mProc = 	ePanelSwitch02ReadTexOff;
}


//========================================================================
//					fXgN^
//========================================================================
mK7PanelSwitch02::~mK7PanelSwitch02()
{
	//\
	mSpOff.SetFlag( false, RENDER_FLAG );
	mSpOn.SetFlag( false, RENDER_FLAG );
	//eNX`
	mSpOff.Delete();
	mSpOn.Delete();
	
//	DelReqSightEffec( mEfSight );
}


//========================================================================
// t[
//========================================================================
s16
mK7PanelSwitch02::FrameProcess(void)
{
	Vec switchPosTbl[] = { 320.0f, 208.0f, 0.0f,
						   320.0f, 272.0f, 0.0f, };
	
	switch( mProc )
	{

		//offeNX`ǂݍ
		case	ePanelSwitch02ReadTexOff:
			if( mSpOff.LoadTexture(PANEL000201TEX_OFF) == true )
			{
				mSpOff.SetXY0(   0,   0 );
				mSpOff.SetXY1( 640,   0 );
				mSpOff.SetXY2(   0, 480 );
				mSpOff.SetXY3( 640, 480 );
				mSpOff.SetColor( 255, 255, 255, 255 );
				mSpOff.SetFlag( true, COLOR_FLAG|VTX4_FLAG );
				if( mSelectFlag == false )
					mSpOff.SetFlag( true, RENDER_FLAG );
				else
					mSpOff.SetFlag( false, RENDER_FLAG );
				mProc = ePanelSwitch02ReadTexOn;
			}
			break;
		
		//oneNX`ǂݍ
		case	ePanelSwitch02ReadTexOn:
			if( mSpOn.LoadTexture(PANEL000201TEX_ON) == true )
			{
				mSpOn.SetXY0(   0,   0 );
				mSpOn.SetXY1( 640,   0 );
				mSpOn.SetXY2(   0, 480 );
				mSpOn.SetXY3( 640, 480 );
				mSpOn.SetColor( 255, 255, 255, 255 );
				mSpOn.SetFlag( true, COLOR_FLAG|VTX4_FLAG );
				if( mSelectFlag == false )
				{
					mSpOn.SetFlag( false, RENDER_FLAG );
					mProc = ePanelSwitch02DispOff;
				}else
				{
					mSpOn.SetFlag( true, RENDER_FLAG );
					mProc = ePanelSwitch02DispOn;
				}
			}
			break;
		
		//off\
		case	ePanelSwitch02DispOff:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP )
				{
					gpSound->mPlaySE( SFX_SCE0_SWITCH );
					gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
					SetCursolPosition( &switchPosTbl[0] );
					mKeyTime = 0;
					SetCursolDir( CURSOL_DIR_DOWN );
					mProc = ePanelSwitch02DispOn;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = false;
					mProc       = ePanelSwitch02Decide;
				}
#if 0
				else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp( false );
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch02Cancel;
				}
#endif
			}
			break;
		
		//on\
		case	ePanelSwitch02DispOn:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
				{
					gpSound->mPlaySE( SFX_SCE0_SWITCH );
					gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
					SetCursolPosition( &switchPosTbl[1] );
					mKeyTime = 0;
					SetCursolDir( CURSOL_DIR_UP );
					mProc = ePanelSwitch02DispOff;
				}
#if 0			
				else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = true;
					mProc       = ePanelSwitch02Decide;
				}
#endif
#if 0
				else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp( false );
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch02Cancel;
				}
#endif
			}
			break;
		
		//II
		case	ePanelSwitch02Decide:
		case	ePanelSwitch02Cancel:
			if( mLastCheck == false )
			{
				switch( CheckAnswer() )
				{
					case	PANEL_CHECK_RETURN:
						SetCursolDisp( true );
						if( mSelectFlag == false )
						{
							mProc = ePanelSwitch02DispOff;
						}else
						{
							mProc = ePanelSwitch02DispOn;
						}
						break;
					case	PANEL_CHECK_SET:
						SetCursolDisp( false );
						m_sLastWait = PANEL_LAST_WAIT;
						if( mSelectFlag == false )
						{
							mSpOff.SetFlag( true, RENDER_FLAG );
							mSpOn.SetFlag( false, RENDER_FLAG );
						}else
						{
							mSpOff.SetFlag( false, RENDER_FLAG );
							mSpOn.SetFlag( true, RENDER_FLAG );
						}
						//莞̂SEĐ
						if( mProc == ePanelSwitch02Decide )
						{
							gpSound->mPlaySE( SFX_SYS_PNL_SWITCHDENSHI );
						}
						mLastCheck = true;
						mProc = ePanelSwitch02Message;
						break;
				}
			}else{
				m_sLastWait = 0;
			}
			break;
		case	ePanelSwitch02Message:
			if( mSelectFlag ){
				if( DrawMessage(28) ){
					m_sLastWait = 0;
					mProc = ePanelSwitch02MessageEnd;
				}	
			}else{
				if( DrawMessage(29) ){
					m_sLastWait = 0;
					mProc = ePanelSwitch02MessageEnd;
				}
			}
			break;
		default:
			break;
	}
		
	return( 0 );
}

//========================================================================
// _O
//========================================================================
bool
mK7PanelSwitch02::RenderProcess(void)
{
	if( m_bRender == false ){
		return( true );
	}
	
	mSpOff.Render();
	mSpOn.Render();
		
	return( true );
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool
mK7PanelSwitch02::mGetFileReadEnd(void)
{
	if( (mProc == ePanelSwitch02ReadTexOff) || (mProc == ePanelSwitch02ReadTexOn) )
	{
		return( false );
	}
	
	return( true );
}

//========================================================================
// 싖ݒ֐
//========================================================================
void
mK7PanelSwitch02::mSetCtrlFlag( bool inBool )
{
	m_bCtrl = inBool;
}

//========================================================================
// _Oݒ֐
//========================================================================
void
mK7PanelSwitch02::mSetRender( bool inBool )
{
	m_bRender = inBool;
	SetCursolDisp( inBool );
}

//========================================================================
// II擾֐
//========================================================================
bool
mK7PanelSwitch02::mGetSelectEnd(void)
{
	if( m_sLastWait == 0 && GetPanelCursolEnd() == true )
	{
		return( true );
	}
	
	return( false );
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32
mK7PanelSwitch02::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( mProc )
	{
		case	ePanelSwitch02Cancel:
			return( PANEL_OPERATE_CANCEL );
		
		case	ePanelSwitch02Message:
		case	ePanelSwitch02MessageEnd:
			return( mSelectFlag );
		
		default:
			break;
	}
	
	return( PANEL_OPERATE_CANCEL );
}














