////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 04
//
// mK7PanelSwitch04.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7PANELSWITCH04_H__
#define	__MK7PANELSWITCH04_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"

//---- enum ----
typedef	enum{
	ePanelSwitch04ReadTex00,
	ePanelSwitch04ReadTex01,
	ePanelSwitch04ReadTex02,
	ePanelSwitch04ReadTex03,
	ePanelSwitch04ReadTex04,
	ePanelSwitch04Standby,
	ePanelSwitch04DispEasy,
	ePanelSwitch04DispNormal,
	ePanelSwitch04DispHard,
	ePanelSwitch04Decide,
	ePanelSwitch04Cancel,
	ePanelSwitch04Message,
	ePanelSwitch04StatsuMax,
}ePanelSwitch04Proc;


#define		RETURN_CANCEL			(-1)
#define		RETURN_EASY				(0)
#define		RETURN_NORMAL			(1)
#define		RETURN_HARD				(2)

//---- class ----
class mK7PanelSwitch04 : public SK7PanelBase
{
protected:
	ePanelSwitch04Proc	mProc;
	
	SK7Sprite			mSpBg;			//bg
	SK7Sprite			mSpEasy;		//easy
	SK7Sprite			mSpNormal;		//normal
	SK7Sprite			mSpHard;		//hard
	SK7Sprite			mSpPlug;		//plug
	
	bool				mInsert;		//vO}tO
	s32					mSelectFlag;	//IʃtO
	bool				mLastCheck;		//Ō̊mFtO
	s32					mInitSelectFlag;//ItO
	
//	EFFECT*				mEfSight;		//TCgGtFNg
	u32					mKeyTime;		//key
	u8					mNotSelectNo;
	
public:
	mK7PanelSwitch04( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~mK7PanelSwitch04();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );
	
	// 싖ݒ֐
	virtual void mSetCtrlFlag( bool inBool );

	// _Oݒ֐
	virtual void mSetRender( bool inBool );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );

	// vOSTlݒ
	void	mSetPlugXYST(void);
};

#endif	//__MK7PANELSWITCH04_H__
