////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEfCharaPresent : LGtFNgiLЉpj
//
// K7PlayEfCharaPresent.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7PLAYEFCHARAPRESENT_CPP__

#include "..\Wat\WK7Event.h"
#include ".\K7PlayEfCharaPresent.h"

#include ".\CharaPresent.h"
#include "..\Wat\K7GlobalFlag.h"

K7PlayEfCharaPresentInstance::K7PlayEfCharaPresentInstance(WK7PlayEffect *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj,u32 startTick,u32 maxTick) : WK7PlayEffectInstance(pContainer,pAnchor,pJObj)
{
	mEnd       = false;
	mTick      = 0;
	mMaxTick   = maxTick;
	mStartTick = startTick;
	if( mStartTick==0xffffffff ){
		mMaxTick = 0xffffffff;
	}else if( mMaxTick < WK7_TICK_PER_FRAME ){
		mMaxTick = WK7_TICK_PER_FRAME;
	}
}

K7PlayEfCharaPresentInstance::~K7PlayEfCharaPresentInstance()
{
}

bool K7PlayEfCharaPresentInstance::Restart(void)
{
	HideCharaName();
	RestartProcess();
	WK7CHARAPRESENT->DeleteMaskWindowAll();
	WK7CHARAPRESENT->SetEnable(false);
	return true;
}

#ifdef	_DEBUG
static	int	editid = 0;
#endif
bool K7PlayEfCharaPresentInstance::FrameProcess(bool stopReq)
{
#pragma	unused(stopReq)
	if( mEnd==true ){
		return true;
	}
#ifdef	_DEBUG
#if 0
	if( mMaxTick==0xffffffff ){
		if( HSD_PadGetTrigger(1) & HSD_PAD_A ){
			Restart();
			mEnd = true;
			return true;
		}
	}
	bool	edit = false;
	if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
		WK7Play		*pPlay = GetPlay();
		if( pPlay!=NULL ){
			OSReport("(%08x),%10d,%6d,%5d,%5d,%4d,%4d,%4d,%4d)\n",
			         pPlay->GetPlayNo() & K7EV_ID_MASK,
			         mStartTick,
			         0,
			         (s16)mNameX,
			         (s16)mNameY,
			         (s16)mWindowX,
			         (s16)mWindowY,
			         (s16)mWindowW,
			         (s16)mWindowH);
		}
		edit = true;
	}
	if( HSD_PadGetTrigger(1) & HSD_PAD_Z ){
		editid++;
		if( editid >= 2 ){
			editid = 0;
		}
	}
static	f32		movespeed = 8.0f;
	f32			lx,ly,rx,ry;
	lx = HSD_PadGetNormalStickX   (1);
	ly = HSD_PadGetNormalStickY   (1);
	rx = HSD_PadGetNormalSubStickX(1);
	ry = HSD_PadGetNormalSubStickY(1);
	if( lx!=0.0f || ly!=0.0f || rx!=0.0f || ry!=0.0f ){
		edit = true;
		switch( editid ){
		case	0:
			mWindowX += movespeed * lx;
			mWindowY -= movespeed * ly;
			mWindowW += movespeed * rx;
			mWindowH -= movespeed * ry;
			if( mWindowW < 0 ){
				mWindowW = 0;
			}
			if( mWindowH < 0 ){
				mWindowH = 0;
			}
			break;
		case	1:
			mNameX += movespeed * lx;
			mNameY -= movespeed * ly;
			break;
		}
	}
	if( edit==true ){
		mMaxTick = 0xffffffff;
	}
	if( mMaxTick==0xffffffff ){
		if( mpMaskWindow != NULL ){
			mpMaskWindow->SetRect(mWindowX,mWindowY,mWindowW,mWindowH);
		}
		return true;
	}
#endif
#endif
	if( mTick >= mMaxTick - WK7_TICK_PER_FRAME ){
		Restart();
		mEnd = true;
		return true;
	}
	mTick += WK7_TICK_PER_FRAME;
	return true;
}

bool K7PlayEfCharaPresentInstance::RenderProcess(void)
{
	if( mEnd==true ){
		return true;
	}
#ifdef	_DEBUG
	if( mMaxTick!=0xffffffff ){
		return true;
	}
	Mtx				view;
	Mtx44			proj;
static	GXColor		drawColor[2] = { { 0xff,0x00,0x00,0xff } , { 0xff,0xff,0xff,0xff } };
	
	HSD_RectU16		sc_rect;
	WK7CAM->GetScissor(sc_rect);
	
	WK7Cam::Set2DMatrix(view,proj);
	
	// [Jr[ϊ}gNXݒ
	GXLoadPosMtxImm  (view,GX_PNMTX0);
	GXLoadNrmMtxImm  (view,GX_PNMTX0);
	GXSetCurrentMtx  (GX_PNMTX0);
	GXSetProjection  (proj,GX_ORTHOGRAPHIC);
	GXSetScissor     (0,0,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT);
	GXSetViewport    (0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);
	
	GXSetDither      (GX_FALSE);
	GXSetDstAlpha    (0,0);
	GXSetAlphaCompare(GX_ALWAYS,0,GX_AOP_AND,GX_ALWAYS,0);
	
	GXSetNumChans    (1);
	GXSetChanCtrl    (GX_COLOR0A0,GX_FALSE,GX_SRC_REG,GX_SRC_REG,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
	
	// uhȂ
	GXSetBlendMode   (GX_BM_NONE,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetCullMode    (GX_CULL_NONE);
	
	GXSetZMode       (GX_FALSE,GX_ALWAYS,GX_FALSE);
	GXSetZCompLoc    (GX_TRUE );
	GXSetColorUpdate (GX_TRUE );
	GXSetAlphaUpdate (GX_FALSE);
	
	GXClearVtxDesc   ();
	GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
	GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
	
	GXSetNumTexGens  (0);
	
	GXSetNumTevStages(1);
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR0A0);
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_RASC);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	
static	f32		clearz = 0.5f;
static	f32		namew = 200.0f,nameh = 48.0f;
	int			id;
	
	switch( editid ){
	case	0:
		id = 1;
		break;
	default:
		id = 0;
		break;
	}
	GXSetChanMatColor(GX_COLOR0A0,drawColor[id]);
	GXBegin(GX_LINESTRIP,GX_VTXFMT0,5);
	
		GXPosition3f32(mNameX      ,mNameY      ,clearz);
		GXPosition3f32(mNameX+namew,mNameY      ,clearz);
		GXPosition3f32(mNameX+namew,mNameY+nameh,clearz);
		GXPosition3f32(mNameX      ,mNameY+nameh,clearz);
		GXPosition3f32(mNameX      ,mNameY      ,clearz);
		
	GXEnd();
	
	switch( editid ){
	case	0:
		id = 0;
		break;
	default:
		id = 1;
		break;
	}
	GXSetChanMatColor(GX_COLOR0A0,drawColor[id]);
	GXBegin(GX_LINESTRIP,GX_VTXFMT0,5);
	
		GXPosition3f32(mWindowX         ,mWindowY         ,clearz);
		GXPosition3f32(mWindowX+mWindowW,mWindowY         ,clearz);
		GXPosition3f32(mWindowX+mWindowW,mWindowY+mWindowH,clearz);
		GXPosition3f32(mWindowX         ,mWindowY+mWindowH,clearz);
		GXPosition3f32(mWindowX         ,mWindowY         ,clearz);
		
	GXEnd();
	
#endif
	return true;
}

K7PlayEfCharaPresent::K7PlayEfCharaPresent(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj) : WK7PlayEffect(pPlay,pAnchor,pJObj)
{
	mPrevPlayCount = -1;
}

K7PlayEfCharaPresentInstance* K7PlayEfCharaPresent::FindInstance(u32 startTick)
{
	K7PlayEfCharaPresentInstance	*pInstance;
	for(pInstance=(K7PlayEfCharaPresentInstance *)mInstanceAnchor.GetNext() ; pInstance!=NULL ; pInstance=pInstance->GetNext()){
		if( pInstance->GetStartTick()==0xffffffff ){
			continue;
		}
		if( pInstance->GetStartTick()==startTick ){
			return pInstance;
		}
	}
	return NULL;
}

K7PlayEfCharaPresentInstance* K7PlayEfCharaPresent::CreateInstance(K7PlayEfCharaPresentInfo *pInfo,u32 startTick)
{
	K7PlayEfCharaPresentInstance	*pInstance;
	if( (pInstance=FindInstance(pInfo->mTick))!=NULL ){
		return pInstance;
	}
	WK7CharaPresentMaskWindow	*pMaskWindow;
	if( (pMaskWindow = WK7CHARAPRESENT->AddMaskWindow((f32)pInfo->mWindowX,(f32)pInfo->mWindowY,(f32)pInfo->mWindowW,(f32)pInfo->mWindowH))!=NULL ){
		WK7CHARAPRESENT->SetEnable(true);
		WK7CHARAPRESENT->ReserveDelete(0xffffffff);
	}
	if( pInfo->mNameNo >= 0 ){
		DispCharaName((s16)pInfo->mNameNo,pInfo->mNameX,pInfo->mNameY);
	}
	u32		maxTick;
	if( startTick==0xffffffff ){
		startTick = pInfo->mTick;
	//	maxTick   = WK7_SEC_TO_TICK(1);
		maxTick   = K7SCR_CP_WAITTIME;
	}else{
		maxTick   = 0xffffffff;
	}
	StopProcess();
	pInstance = new K7PlayEfCharaPresentInstance(this,&mInstanceAnchor,NULL,startTick,maxTick);
#ifdef	_DEBUG
	if( pInstance!=NULL ){
		pInstance->SetMaskWindow(pMaskWindow);
		pInstance->SetNamePos   (pInfo->mNameX,pInfo->mNameY);
		pInstance->SetWindowRect(pInfo->mWindowX,pInfo->mWindowY,pInfo->mWindowW,pInfo->mWindowH);
	}
#endif
	return pInstance;
}

WK7PlayEffectInstance* K7PlayEfCharaPresent::CreateInstance(WK7JObj *pJObj)
{
#pragma	unused(pJObj)
	if( mpContainer==NULL || mpContainer->GetPlayCountFlag()==false ){
		return NULL;
	}
	s32								playCount = mpContainer->GetPlayCount();
	u32								playNo    = mpContainer->GetPlayNo();
	u32								tick;
	K7PlayEfCharaPresentInfo		*pInfo;
	K7PlayEfCharaPresentInstance	*pInstance;
	playNo = K7EVENTPLAYID(playNo);
	tick   = (u32)WK7_FRAME_TO_TICK(playCount);
	for(pInfo=charaPresentInfo ; pInfo->mPlayNo!=0xffffffff ; pInfo++){
		if( playNo!=pInfo->mPlayNo ){
			continue;
		}
		if( tick < pInfo->mTick ){
			continue;
		}
		if( (pInstance=FindInstance(pInfo->mTick))!=NULL ){
			continue;
		}
		return CreateInstance(pInfo);
	}
	return NULL;
}

bool K7PlayEfCharaPresent::FrameProcess(void)
{
	if( mpContainer==NULL ){
		return false;
	}
	s32		playCount = mpContainer->GetPlayCount();
#ifdef	_DEBUG
	if( HSD_PadGetTrigger(1) & HSD_PAD_X ){
		if( mpContainer->GetPlayCountFlag()==true ){
			K7PlayEfCharaPresentInfo	info;
			info.mPlayNo  = mpContainer->GetPlayNo();
			info.mTick    = 0xffffffff;
			info.mNameNo  = 0;
			info.mNameX   = 240;
			info.mNameY   = 320;
			info.mWindowX = 240;
			info.mWindowY = 160;
			info.mWindowW = 160;
			info.mWindowH = 160;
			CreateInstance(&info,(u32)WK7_FRAME_TO_TICK(playCount));
		}
	}
#endif
	if( mPrevPlayCount != playCount ){
		CreateInstance((WK7JObj *)NULL);
	}
	mPrevPlayCount = playCount;
	
	WK7PlayEffectInstance	*pInstance,*pNext;
	for(pInstance=(WK7PlayEffectInstance *)mInstanceAnchor.GetNext() ; pInstance!=NULL ; pInstance=pNext){
		pNext = pInstance->GetNext();
		if( pInstance->FrameProcess(false)==false ){
			delete pInstance;
		}
	}
	return true;
}

