////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEfCharaPresent
//
// K7PlayEfCharaPresent.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7PLAYEFCHARAPRESENT_H__
#define	__K7PLAYEFCHARAPRESENT_H__

#include "..\Wat\WK7Play.h"
#include "..\Wat\WK7Anim.h"
#include "..\Wat\WK7CharaPresent.h"

struct K7PlayEfCharaPresentInfo{
	u32							mPlayNo;
	u32							mTick;
	s32							mNameNo;
	s16							mNameX,mNameY;
	s16							mWindowX,mWindowY,mWindowW,mWindowH;
};

#define	K7PLAYEFCHARAPRESENT_DECL_START()						K7PlayEfCharaPresentInfo	charaPresentInfo[] = {
#define	K7PLAYEFCHARAPRESENT_DECL(pno,tick,nno,nx,ny,wx,wy,ww,wh)	{ (pno),(tick),(nno),(nx),(ny),(wx),(wy),(ww),(wh) },
#define	K7PLAYEFCHARAPRESENT_DECL_END()								{ 0xffffffff,0xffffffff,0xffffffff,0,0,0,0,0,0 }, \
																};

class K7PlayEfCharaPresentInstance : public WK7PlayEffectInstance{
protected:
	u32								mTick;
	u32								mMaxTick;
	u32								mStartTick;
	bool							mEnd;
#ifdef	_DEBUG
	WK7CharaPresentMaskWindow		*mpMaskWindow;
	f32								mNameX,mNameY;
	f32								mWindowX,mWindowY,mWindowW,mWindowH;
#endif
	bool Restart(void);
public:
	K7PlayEfCharaPresentInstance(WK7PlayEffect *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj,u32 startTick,u32 maxTick);
	virtual ~K7PlayEfCharaPresentInstance();
	
	inline K7PlayEfCharaPresentInstance* GetNext(void){ return (K7PlayEfCharaPresentInstance *)WK7PlayEffectInstance::GetNext(); }
	inline K7PlayEfCharaPresentInstance* GetPrev(void){ return (K7PlayEfCharaPresentInstance *)WK7PlayEffectInstance::GetPrev(); }
	
	inline u32 GetStartTick(void){ return mStartTick; }
	
#ifdef	_DEBUG
	void SetMaskWindow(WK7CharaPresentMaskWindow *pMaskWindow){ mpMaskWindow=pMaskWindow; }
	void SetNamePos(s16 x,s16 y){ mNameX=(f32)x; mNameY=(f32)y; }
	void SetWindowRect(s16 x,s16 y,s16 w,s16 h){ mWindowX=(f32)x; mWindowY=(f32)y; mWindowW=(f32)w; mWindowH=(f32)h; }
#endif
	
	virtual bool FrameProcess(bool stopReq);
	virtual bool RenderProcess(void);
};

class K7PlayEfCharaPresent : public WK7PlayEffect{
protected:
	s32								mPrevPlayCount;
	K7PlayEfCharaPresentInstance* FindInstance(u32 startTick);
	K7PlayEfCharaPresentInstance* CreateInstance(K7PlayEfCharaPresentInfo *pInfo,u32 startTick=0xffffffff);
public:
	K7PlayEfCharaPresent(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj);
	
	virtual WK7PlayEffectInstance* CreateInstance(WK7JObj *pJObj);
	virtual bool FrameProcess(void);
};

#endif	//__K7PLAYEFCHARAPRESENT_H__

