////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEfHSScan : LGtFNgigrXLĎ̉j
//
// K7PlayEfHSScan.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7PLAYEFHSSCAN_CPP__

#include ".\K7PlayEfHSScan.h"
#include "..\Matsu\MK7Dim.h"

K7PlayEfHSScanInstance::K7PlayEfHSScanInstance(WK7PlayEffect *pContainerBase,ghmGcListObj *pAnchor,WK7JObj *pJObj,WK7JObj *pHSJObj) : WK7PlayEffectInstance(pContainerBase,pAnchor,pJObj)
{
	K7PlayEfHSScan		*pContainer = (K7PlayEfHSScan *)pContainerBase;
	if( (mpJObj=pHSJObj)!=NULL ){
		mpJObj->CreateAlphaControl(0.0f,false);
		mpJObj->SetAlpha(1.0f,4800);
	}
	gpDim->mRequest(K7PLAYEFFECT_HSSCAN_TICK);
}

K7PlayEfHSScanInstance::~K7PlayEfHSScanInstance()
{
}

bool K7PlayEfHSScanInstance::FrameProcess(bool stopReq)
{
	if( stopReq==true || mpJObj==NULL ){
		return false;
	}
	if( mpJObj->IsAnimatingAlpha()==false ){
		return false;
	}
	return true;
}

bool K7PlayEfHSScanInstance::RenderProcess(void)
{
	return WK7PlayEffectInstance::RenderProcess();
}

K7PlayEfHSScan::K7PlayEfHSScan(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj,const char *pObjName) : WK7PlayEffect(pPlay,pAnchor,pJObj)
{
	WK7PlayEffectInfo	*pEffectInfo = GetEffectInfo();
	WK7Model			*pModel;
	mppJObj  = NULL;
	mJObjNum = 0;
	if( pEffectInfo==NULL || (pModel = pEffectInfo->mpModel)==NULL ){
		return;
	}
	if( (mppJObj = new WK7JObj*[1])==NULL ){
		return;
	}
	mJObjNum   = 1;
	mppJObj[0] = NULL;
	if( (mppJObj[0] = pModel->GetObj(pObjName))!=NULL ){
		mppJObj[0]->Disp(false,true);
	}
}

K7PlayEfHSScan::K7PlayEfHSScan(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj,const char **ppObjName) : WK7PlayEffect(pPlay,pAnchor,pJObj)
{
	WK7PlayEffectInfo	*pEffectInfo = GetEffectInfo();
	WK7Model			*pModel;
	mppJObj  = NULL;
	mJObjNum = 0;
	if( pEffectInfo==NULL || (pModel = pEffectInfo->mpModel)==NULL ){
		return;
	}
	for( ; ppObjName[mJObjNum]!=NULL ; mJObjNum++){}
	if( (mppJObj = new WK7JObj*[mJObjNum])==NULL ){
		mJObjNum = 0;
		return;
	}
	int		i;
	for(i=0 ; ppObjName[i]!=NULL ; i++){
		if( (mppJObj[i] = pModel->GetObj(ppObjName[i]))!=NULL ){
			mppJObj[i]->Disp(false,true);
		}
	}
}

K7PlayEfHSScan::~K7PlayEfHSScan()
{
	GHM_SAFE_DELETE(mppJObj);
}

WK7PlayEffectInstance* K7PlayEfHSScan::CreateInstance(WK7JObj *pJObj)
{
	int						i;
	WK7PlayEffectInstance	*pInstance = NULL;
	for(i=0 ; i<mJObjNum ; i++){
		if( mppJObj[i]==NULL ){
			continue;
		}
		pInstance = new K7PlayEfHSScanInstance(this,&mInstanceAnchor,pJObj,mppJObj[i]);
		
	}
	return pInstance;
}

WK7JObj* K7PlayEfHSScan::GetJObj(int index)
{
	if( index < 0 || index >= mJObjNum ){
		return NULL;
	}
	return mppJObj[index];
}

