////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEffect  : LGtFNg
//
// WK7PlayEffect.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7PLAYEFFECT_CPP__

#include ".\K7PlayEffect.h"
#include "..\Yam\YK7EffectCharGeki.h"

#include ".\K7PlayEf0008.h"
#include ".\K7PlayEf0010.h"
#include ".\K7PlayEf0055.h"
#include ".\K7PlayEfHSScan.h"
#include ".\K7PlayEfMonotone.h"
#include ".\K7PlayEfCharaPresent.h"

static	const char*	K7PlayEf0151ObjNameList[] = { "HS_N_Root_01","HS_N_Root_02","HS_N_Root_03",NULL };

K7PLAYEFFECT_DECL_START()
	K7PLAYEFFECT_DECL      (   8,K7PlayEf0008)
	K7PLAYEFFECT_DECL      (  10,K7PlayEf0010)
	K7PLAYEFFECT_DECL      (  55,K7PlayEf0055)
	K7PLAYEFFECT_DECL_PARAM(  61,K7PlayEfHSScan,"E02_Root")
	K7PLAYEFFECT_DECL_PARAM( 151,K7PlayEfHSScan,K7PlayEf0151ObjNameList)
	K7PLAYEFFECT_DECL_PARAM( 152,K7PlayEfHSScan,"E02_N01_Root")
//	K7PLAYEFFECT_DECL_PARAM( 167,K7PlayEfMonotone,0xffc00000)
	K7PLAYEFFECT_DECL_PARAM( 167,K7PlayEfMonotone,0xffffff00)
	K7PLAYEFFECT_DECL_PARAM( 168,K7PlayEfMonotone,0xffffff00)
	K7PLAYEFFECT_DECL_PARAM( 169,K7PlayEfMonotone,0xffffff00)
	K7PLAYEFFECT_DECL_PARAM( 170,K7PlayEfMonotone,0xffffff00)
	K7PLAYEFFECT_DECL_PARAM( 171,K7PlayEfMonotone,0xffffff00)
	K7PLAYEFFECT_DECL_PARAM( 172,K7PlayEfMonotone,0xffffff00)
	
	// K7PLAYEFFECT_DECL_INVALID ... Ƃɔԍw
//	K7PLAYEFFECT_DECL_INVALID(  45)
//	K7PLAYEFFECT_DECL_INVALID(  46)
//	K7PLAYEFFECT_DECL_INVALID(  47)
//	K7PLAYEFFECT_DECL_INVALID(  48)
//	K7PLAYEFFECT_DECL_INVALID(  59)
K7PLAYEFFECT_DECL_END()

K7PlayEffectInstanceDef::K7PlayEffectInstanceDef(WK7PlayEffect *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj,int prio) : WK7PlayEffectInstance(pContainer,pAnchor,pJObj)
{
	WK7RenderObjEffectInfo	info;
	u32		id = WK7PlayEffect::GetEffectID(pJObj);
	info.Create();
	if( (mpEffect = ::CreateCharGekiEffect((s16)id,prio))!=NULL ){
		mEffectID = GetEffectID(mpEffect);
		info.Parent(mpEffect);
		WK7Play	*pPlay = GetPlay();
		if( pPlay!=NULL && pPlay->GetState()!=WK7Play::PLAY ){
			::SetEffectDrawFlagAll(mpEffect,false);
		}
	}else{
		mEffectID = 0xffffffff;
	}
}

K7PlayEffectInstanceDef::~K7PlayEffectInstanceDef()
{
	FreeEffect();
}

bool K7PlayEffectInstanceDef::FreeEffect(void)
{
	if( mEffectID!=0xffffffff && mpEffect!=NULL && ::CheckEffectValidState(mpEffect,mEffectID)==TRUE ){
		::DeleteEffect(mpEffect);
		mpEffect  = NULL;
		mEffectID = 0xffffffff;
	}
	return true;
}

bool K7PlayEffectInstanceDef::FrameProcess(bool stopReq)
{
	if( mEffectID!=0xffffffff && mpEffect!=NULL ){
		if( ::CheckEffectValidState(mpEffect,mEffectID)==FALSE ){
			mEffectID = 0xffffffff;
			mpEffect  = NULL;
			return false;
		}
		WK7Play	*pPlay = GetPlay();
		if( pPlay!=NULL && pPlay->GetState()==WK7Play::PLAY ){
			::SetEffectDrawFlagAll(mpEffect,true);
		}
	}else{
		return false;
	}
	if( stopReq==true ){
		// ~
		::DelReqEffect(mpEffect);
		return true;
	}
	return true;
}

K7PlayEffectDef::K7PlayEffectDef(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj) : WK7PlayEffect(pPlay,pAnchor,pJObj)
{
	::SetupCharGekiEffect((s16)mID);
}

K7PlayEffectDef::~K7PlayEffectDef()
{
	FreeEffectAll();
	if( mID != 0xffffffff ){
		::EndCharGekiEffect((s16)mID);
	}
}

bool K7PlayEffectDef::CheckSetup(void)
{
	if( mID==0xffffffff ){
		return true;
	}
	if( ::CheckCharGekiEffectSetup((s16)mID)==FALSE ){
		return false;
	}
	return true;
}

WK7PlayEffectInstance* K7PlayEffectDef::CreateInstance(WK7JObj *pJObj)
{
	int		prio = -1;
	switch( mID ){
	case	200:
	case	201:
		prio = 128;
		break;
	default:
		break;
	}
	return new K7PlayEffectInstanceDef(this,&mInstanceAnchor,pJObj,prio);
}

