////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7ChangeDisk.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/18/2003
//	
////////////////////////////////////////////////////////////////////////////////

#define	__SK7CHANGEDISK_CPP__

#include "..\Lib\ghmGcFile.h"
#include "../wat/WK7MainTask.h"
#include "../wat/WK7Cam.h"
#include "SK7ChangeDisk.h"
#include "..\Matsu\mK7Sound.h"
#include "../wat/WK7Archive.h"
#include "../yam/YK7EffectNoise.h"
#include "../yam/YK7CharChange.h"
#include "SK7SaveBase.h"
#include "SK7SaveLoadMessage.h"

#define		DISK_CHANGE_Y(NO)		(160+40*NO)
#define		FADE_SPEED				(WK7_SEC_TO_TICK(0.9f))

//========================================================================
//					RXgN^
//========================================================================
SK7ChangeDisk::SK7ChangeDisk(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	HSD_VISetClearClr((GXColor){0,0,0,0xff});	
}


//========================================================================
//					fXgN^
//========================================================================
SK7ChangeDisk::~SK7ChangeDisk()
{
}


//========================================================================
//					
//========================================================================
bool 	SK7ChangeDisk::InitializeCallBack(void)
{
	m_eProc 		= eLoad;
	m_eLoad 		= eKana;
	m_bRender 		= false;
	m_bMotorFlag	= false;
	m_pNoiseEffect = NULL;
	m_iDiskID = (ghmGcFile::GetCurrentDiskID()==0) ? 1 : 0;

	ghmGcMemSetAllocName("ChangeDisk");
	m_pYFont = new YK7StrImage;
	m_pYFont->Load( "/Texture/Disk_GC.BIN" );

	ghmGcMemSetAllocName("ChangeDisk");
	m_pYKana = new YK7StrImage;
	m_pYKana->Load( Y_KANA_TEX );
	
	m_spBack.SetSprite( 0, 0, 640, 480, 0x000000ff );
	m_spBack.SetVisible( true );
	
	k7app.SetFadeColor(0xff0000ff);

	m_pTaskControl = NULL;
	ghmGcMemSetAllocName("ChagneDisk");
	m_pTaskControl = new ghmGcTaskController;
	m_pTaskControl->Initialize();
	EffectInit( m_pTaskControl, 200 );
	screenImageFullColor.SetFormat(GX_TF_RGBA8);
	screenImageFullColor.AllocBuffer();
	
	return true;
}


//========================================================================
//					I
//========================================================================
bool 	SK7ChangeDisk::TerminateCallBack(void)
{
	DeleteEffect( m_pNoiseEffect );
	EffectEnd();
	GHM_SAFE_DELETE(m_pTaskControl);
	screenImageFullColor.FreeBuffer();

	m_spTV.Delete();
	m_pYKana->Release();
	m_pYFont->Release();	
	GHM_SAFE_DELETE( m_pYKana );
	GHM_SAFE_DELETE( m_pYFont );
	
	ghmGcApp *pApp = GetApplication();
	delete this;
	k7app.SetFadeColor(0xff000000);
	k7app.FadeStart(0xff,0);
	new WK7MainTask(pApp);

	return true;
} 


//========================================================================
//					t[
//========================================================================
bool 	SK7ChangeDisk::FrameProcess(void)
{
	return true;
}

//========================================================================
//					t[
//========================================================================
bool 	SK7ChangeDisk::_FrameProcess(void)
{
	s32 state = ghmGcFile::GetDriveState();
	if( m_eProc == eSet ){
		switch( state ){
		case DVD_STATE_MOTOR_STOPPED:
//			m_bMotorFlag = true;
//			break;
		case DVD_STATE_COVER_OPEN:
			break;
		default:
//			m_bRender = false;
			break;
		}
	}

	switch( m_eProc ){
	case eLoad:
		if( Load() ){
			ghmGcFile::ChangeDisk( m_iDiskID );
			m_bRender = true; 
			k7app.FadeStart(0x00,FADE_SPEED);			//	CtF[h
			m_eProc = eFade;
		}
		break;
		
	case eFade:
		if( !k7app.IsFade() ){
			m_eProc = eSet;//eCheck;
		}
		break;
//	case eCheck:
//		if( !ghmGcFile::ChangeDisk( m_iDiskID ) ) return true;
//		if( state == DVD_STATE_MOTOR_STOPPED ){
//			m_eProc = eSet;
//		}
//		break;
	case eSet:
		if( !ghmGcFile::ChangeDisk( m_iDiskID ) ) return true;
		if( state == DVD_STATE_END && ghmGcFile::GetCurrentDiskID() == ghmGcFile::GetReserveDiskID() ){
			m_bRender = false; 
			m_eProc = eEnd;
		}
		break;
	case eEnd:
		if( DeleteTerminate()==true ){
			return false;
		}
		break;
	}
	SetEffectCamera(WK7CAM->GetCObj());
	WK7Archive::FrameProcessAll();
	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7ChangeDisk::RenderProcess(void)
{
	if( _FrameProcess() == false )	return true;
	
	if( !m_bRender ) 	return true;
		
	m_spBack.Render();

	switch( ghmGcFile::GetDriveState() ){
	case DVD_STATE_MOTOR_STOPPED:
		m_pYFont->DrawSetup();
		m_pYFont->SetColor2(SLOT_FONT_COLOR);
		
		m_pYFont->SetKanaY	( 4 );
		if( m_iDiskID == 1 ){
			m_pYFont->DrawFSStr	( TV_CENTER_X, DISK_CHANGE_Y(0), true, true, "killer@7@@́@@ł@@2@@");
		}else{
			m_pYFont->DrawFSStr( TV_CENTER_X, DISK_CHANGE_Y(0), true, true, "killer@7@@́@@ł@@1@@");
		}
		m_pYFont->DrawFSStr( TV_CENTER_X, DISK_CHANGE_Y(1), true, true, "ĂB");
		break;
		
	case DVD_STATE_BUSY:
		m_pYFont->DrawSetup();
		m_pYFont->SetColor2(SLOT_FONT_COLOR);
		
		m_pYFont->SetKanaY	( 4 );
		m_pYFont->DrawFSStr( TV_CENTER_X, DISK_CHANGE_Y(0), true, true, "ł@@@Ă܂B");
		break;
	}
	
	DrawSousaLine();
	if( m_pNoiseEffect ){
		MoveEffect(m_pNoiseEffect);
		DrawEffect(m_pNoiseEffect);
	}
	_DrawTVScreen();

	m_spTV.Render();
	m_pTaskControl->FrameProcess();

	return true;
}


//========================================================================
//					[h
//========================================================================
bool	SK7ChangeDisk::Load()
{
	switch( m_eLoad ){
	case eKana:
		if( m_pYKana->LoadCheck() ){
			m_eLoad = eFont;
		}
		break;
	case eFont:
		if( m_pYFont->LoadCheck() ){
			m_pYFont->SetKanaFont( m_pYKana );
			m_eLoad = eLoadEffect;
		}
		break;
	case eLoadEffect:
		if( EffectSetupCheck() == TRUE ){
			m_pNoiseEffect = CreateNoiseEffect();
			SetEffectIndeManageFlag( m_pNoiseEffect, true );
			SetEffectCamera( WK7CAM->GetCObj() );
			m_eLoad = eTV;
		}
		break;
	case eTV:
		if( m_spTV.LoadTexture( TV_TEX ) ){
			m_spTV.SetTexSprite	( 0, 0, m_spTV.GetTexture() );
			m_spTV.SetVisible	( true );
			return true; 
		}
		break;
	}	
	return false;
}

