 ////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Common
//
// SK7Common.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7COMMON_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "../Lib/ghmGcDefine.h"
#include "SK7Common.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Jimaku.h"
#include "SK7MapData.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7Stage.h"


#define		KEY_POWER		(0.3f) 

//========================================================================
//					vg^Cv
//========================================================================
void	InitTexture( TEX_DATA *pData, bool filt );
void	Get3Dto2D( Vec *pPos, Vec *Ans );
bool 	CheckPointLine(Vec *a,Vec *b,Vec *c);
bool	CheckPointTriangle(Vec *a,Vec *b,Vec *c, Vec *p);
void 	MakeModelMtx ( Vec xAxis, Vec yAxis, Vec zAxis, Mtx m );

void	Set2DCamera();
void	SetGraphMode();
void	SetTevStage();
void	SetTevStageI4();
void	SetVertex();

bool	CheckKeyT( u8 KeyNo ); 
bool	CheckKeyR( u8 KeyNo ); 
bool	CheckKeyN( u8 KeyNo );

void		DrawSousaLine();
s8		CheckStageNo();
u8		GetPlayerNo( u32 MainID );
u32		GetPlayerNo( u8 MainID );

class Vector3;

//========================================================================
//					eNX`
//========================================================================
void	InitTexture( TEX_DATA *pData, bool filt )
{
	// eNX`쐬
	GXInitTexObj(	&pData->Obj, 
					GHMGCTEX_GETIMAGE(pData->Header),
					pData->Header->mWidth, 
					pData->Header->mHeight, 
					pData->Header->mFormat,
					GX_CLAMP, 
					GX_CLAMP, 
					GX_FALSE );

	if( !filt ){
		GXInitTexObjLOD(	&pData->Obj, 
							GX_NEAR, //GX_LINEAR, 
							GX_NEAR,//GX_LINEAR, 
							pData->Header->mMinLOD,
							pData->Header->mMaxLOD, 
							0.0F,
							GX_FALSE, 
							GX_FALSE, 
							GX_ANISO_1 );
	}else{
		GXInitTexObjLOD(	&pData->Obj, 
							GX_LIN_MIP_LIN, 
							GX_LINEAR, 
							pData->Header->mMinLOD,
							pData->Header->mMaxLOD, 
							0.0F,
							GX_FALSE, 
							GX_FALSE, 
							GX_ANISO_4 );
	}
}

//========================================================================
//					Cƃ|Cg`FbN
//========================================================================
bool 	CheckPointLine(Vec *a,Vec *b,Vec *c)
{
	Vec v1,v2;

	v1.x = b->x - a->x;
	v1.y = b->y - a->y;
	v2.x = c->x - a->x;
	v2.y = c->y - a->y;
	if (v1.x*v2.y - v1.y*v2.x > 0)	return true;
	else if (v1.x*v2.y - v1.y*v2.x < 0)	return false;
	else	return true;
}


//========================================================================
//					Op`ƃ|Cg`FbN
//========================================================================
bool	CheckPointTriangle(Vec *a,Vec *b,Vec *c, Vec *p)
{
	if( !CheckPointLine(a,b,p) ) return false;
	if( !CheckPointLine(b,c,p) ) return false;
	if( !CheckPointLine(c,a,p) ) return false;
	return true;
}


//========================================================================
//					Rc|Qc
//========================================================================
void		Get3Dto2D( Vec *pPos, Vec *Ans )
{	
	Mtx mtxView;
	Mtx44 mtxProj;
	f32 fov, aspect ;
	f32 Projection[GX_PROJECTION_SZ];
	f32 Viewport  [GX_VIEWPORT_SZ  ];
	HSD_CObj	*pCObj;
	
	//	J`FbN
	if( (pCObj = HSD_CObjGetCurrent())==NULL ){
		return;
	}
	// r[}gbNX̎擾
	HSD_CObjGetViewingMtx(pCObj,mtxView);

	// ˉes쐬
	HSD_CObjGetPerspective( pCObj, &fov, &aspect ) ;
	MTXPerspective( mtxProj, fov, aspect, HSD_CObjGetNear(pCObj), HSD_CObjGetFar(pCObj) ) ;

	//	r[|[g擾
	GXGetViewportv( Viewport );

	Projection[0] = (f32)GX_PERSPECTIVE;
	Projection[1] = mtxProj[0][0];
	Projection[2] = mtxProj[0][2];
	Projection[3] = mtxProj[1][1];
	Projection[4] = mtxProj[1][2];
	Projection[5] = mtxProj[2][2];
	Projection[6] = mtxProj[2][3];
	
	//	XN[W
	GXProject(pPos->x,pPos->y,pPos->z, mtxView, Projection, Viewport, &Ans->x, &Ans->y, &Ans->z );
}


//========================================================================
//					2c|3c
//========================================================================
void		Get2Dto3D( Vec& v, f32 fZ )
{
	HSD_CObj			*pCObj = WK7CAM->GetCObj();
	
	if( pCObj==NULL )	return;
	
	f32				n      = HSD_CObjGetNear  (pCObj);
	f32				f      = HSD_CObjGetFar   (pCObj);
	f32				fovy_2 = HSD_CObjGetFov   (pCObj) * (PI / (2.0f * 180.0f));
	f32				aspect = HSD_CObjGetAspect(pCObj);
	f32				tan_fovy_2 = tanf(fovy_2);

	v.z   = fZ;
	v.x   = v.z * tan_fovy_2 * aspect * (v.x - (WK7_SCREEN_WIDTH *0.5f)) / (WK7_SCREEN_WIDTH *0.5f);
	v.y   = v.z * tan_fovy_2          * (v.y - (WK7_SCREEN_HEIGHT*0.5f)) / (WK7_SCREEN_HEIGHT*0.5f);
}


//========================================================================
//					f}gbNXvZ
//========================================================================
void MakeModelMtx ( Vec xAxis, Vec yAxis, Vec zAxis, Mtx m )
{
    VECNormalize(&xAxis,&xAxis);		//	̐K
    VECNormalize(&yAxis,&yAxis);		//	̐K
    VECNormalize(&zAxis, &zAxis);		//	̐K

    m[0][0] = xAxis.x;			// x.x y.x z.x 0 	
    m[1][0] = xAxis.y;			// x.y y.y z.y 0
    m[2][0] = xAxis.z;			// x.z y.z z.z 0

    m[0][1] = yAxis.x;
    m[1][1] = yAxis.y;
    m[2][1] = yAxis.z;

    m[0][2] = zAxis.x;
    m[1][2] = zAxis.y;
    m[2][2] = zAxis.z;

    m[0][3] = 0.0F;
    m[1][3] = 0.0F;
    m[2][3] = 0.0F;
}

//========================================================================
//					Jݒ	
//========================================================================
void		Set2DCamera()
{
	Mtx			view;
	Mtx44		proj;

	//	
	MTXIdentity     (view);
	view[2][3] = -300.f;

	//	vWFNV쐬
	MTXOrtho        (proj,0,K7APP_SCREEN_HEIGHT,0,K7APP_SCREEN_WIDTH,100,1000);
	//	fԂ̒_Wr[Ԃɕϊ
	GXLoadPosMtxImm (view,GX_PNMTX0);
	//	fԂ̖@Ar[Ԃɕϊ
	GXLoadNrmMtxImm (view,GX_PNMTX0);
	//	Jgs̐ݒ
	GXSetCurrentMtx (GX_PNMTX0);
	//	vWFNVZbgiˉej
	GXSetProjection (proj,GX_ORTHOGRAPHIC);
	
	//	VU[Ng
//	GXSetScissor    (0,0,K7APP_SCREEN_WIDTH,K7APP_SCREEN_HEIGHT);
	//	r[|[gNg
	GXSetViewport   (0.0f,0.0f,K7APP_SCREEN_WIDTH,K7APP_SCREEN_HEIGHT,0.0f,1.0f);
}

//========================================================================
//					yobt@̐ݒ
//========================================================================
void		SetGraphMode()
{
	//	Zobt@r[h̐ݒ
	GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );	
	//	JO
	GXSetCullMode( GX_CULL_NONE ) ;
	//TEVXe[Wւ̏o͂łJ[`l̐ݒ
	GXSetNumChans( 1 );
	//GX_COLOR0A0̃CgRg[̐ݒ
	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
//	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );
	//dither
	GXSetDither      (GX_TRUE);
	
	//	At@ J[		-----------------------------------------------------------------
	GXSetAlphaUpdate(GX_TRUE);
	GXSetDstAlpha(GX_TRUE,255);	
	
	//[Update
	GXSetColorUpdate(GX_TRUE);
	
	//	r
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);

//	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
}

//========================================================================
//					TEV
//========================================================================
void		SetTevStage()
{
	//TEVXe[Wŗp\ɂeNX`W̐ݒ
	GXSetNumTexGens( 1 );
	//eNX`W̕@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	
	//TEVXe[WŔJ[
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_RASC, GX_CC_TEXC, GX_CC_ZERO );
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_RASA, GX_CA_TEXA, GX_CA_ZERO );
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );

	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
}

//========================================================================
//					TEV	(Zpj
//========================================================================
void		SetTevStageI4()
{
	//TEVXe[Wŗp\ɂeNX`W̐ݒ
	GXSetNumTexGens( 1 );
	//eNX`W̕@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	
	//TEVXe[WŔJ[
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC );
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_RASA, GX_CA_TEXA, GX_CA_ZERO );
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );

	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder	( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
}

//========================================================================
//					TEVݒ
//========================================================================
void		SetTevStageNoTex()
{
	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 0 );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
	GXSetTevOp( GX_TEVSTAGE0, GX_PASSCLR );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo
}


//========================================================================
//					_ݒ
//========================================================================
void		SetVertex()
{
	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
	GXSetVtxDesc( GX_VA_TEX0, GX_DIRECT );	//eNX`0̎ނݒq
	//ꂼ̗̑vf(?)Ǝނݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ,  GX_F32  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST,   GX_F32,   0 );	//eNX`0̗vfƎނw
}

//========================================================================
//					_ݒ
//========================================================================
void		SetVertexNoTex()
{
	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
	//ꂼ̗̑vf(?)Ǝނݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ,  GX_F32  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
}


//========================================================================
//					L[Zbg
//========================================================================
bool	CheckKeyT( u8 KeyNo )
{
	s32 Key = 0;
	if( KeyNo & SK7_KEY_UP )	Key |= (HSD_PAD_UP|HSD_PAD_STICK_UP);
	if( KeyNo & SK7_KEY_DOWN )	Key |= (HSD_PAD_DOWN|HSD_PAD_STICK_DOWN);	
	if( KeyNo & SK7_KEY_RIGHT)	Key |= (HSD_PAD_RIGHT|HSD_PAD_STICK_RIGHT);	
	if( KeyNo & SK7_KEY_LEFT )	Key |= (HSD_PAD_LEFT|HSD_PAD_STICK_LEFT);	
	if( HSD_PadGetTrigger(0) & Key )	return true;
	return false;
}

//========================================================================
//					L[Zbgs[g
//========================================================================
bool	CheckKeyR( u8 KeyNo )
{
	s32 Key = 0;
	if( KeyNo & SK7_KEY_UP )	Key |= (HSD_PAD_UP|HSD_PAD_STICK_UP);
	if( KeyNo & SK7_KEY_DOWN )	Key |= (HSD_PAD_DOWN|HSD_PAD_STICK_DOWN);	
	if( KeyNo & SK7_KEY_RIGHT)	Key |= (HSD_PAD_RIGHT|HSD_PAD_STICK_RIGHT);	
	if( KeyNo & SK7_KEY_LEFT )	Key |= (HSD_PAD_LEFT|HSD_PAD_STICK_LEFT);	
	if( HSD_PadGetRepeat(0) & Key )	return true;
	return false;
}

//========================================================================
//					L[Zbgs[g^񒆂
//========================================================================
bool	CheckKeyN( u8 KeyNo )
{
	f32 PowerX = 0, PowerY = 0;
	bool up=false, down=false, right=false,left=false;
	
	PowerX = HSD_PadGetNormalStickX(0);
	PowerY = HSD_PadGetNormalStickY(0);
	if( HSD_PadGetButton(0) & HSD_PAD_UP ) 		up=true;
	if( HSD_PadGetButton(0) & HSD_PAD_DOWN ) 	down=true;
	if( HSD_PadGetButton(0) & HSD_PAD_RIGHT ) 	right=true;
	if( HSD_PadGetButton(0) & HSD_PAD_LEFT ) 	left=true;
	
	if( up && right && (KeyNo & SK7_KEY_RIGHT_UP) ) 		return true;
	if( up && left 	&& (KeyNo & SK7_KEY_LEFT_UP) ) 			return true;
	if( down && right && (KeyNo & SK7_KEY_RIGHT_DOWN) ) 	return true;
	if( down && left 	&& (KeyNo & SK7_KEY_LEFT_DOWN) ) 	return true;


	if( KeyNo & SK7_KEY_UP ){
		if( PowerY >= 0.5f ){
			return true;
		}
	}
	if( KeyNo & SK7_KEY_DOWN ){
		if( PowerY <= -0.5f ){
			return true;
		}
	}
	if( KeyNo & SK7_KEY_RIGHT ){
		if( PowerX >= 0.5f ){
			return true;
		}
	}
	if( KeyNo & SK7_KEY_LEFT ){
		if( PowerX <= -0.5f ){
			return true;
		}
	}
	if( PowerX >= KEY_POWER ){
		if( PowerY < KEY_POWER && PowerY > -KEY_POWER  ){
//			if( KeyNo & SK7_KEY_RIGHT )	 return true;
		}else 
		if( PowerY >= KEY_POWER ){
			if( KeyNo & SK7_KEY_RIGHT_UP )	return true;
		}else
		if( PowerY <= -KEY_POWER ){
			if( KeyNo & SK7_KEY_RIGHT_DOWN )	return true;
		}
	}else
	if( PowerX <= -KEY_POWER ){
		if( PowerY < KEY_POWER && PowerY > -KEY_POWER  ){
//			if( KeyNo & SK7_KEY_LEFT )	 return true;
		}else 
		if( PowerY >= KEY_POWER ){
			if( KeyNo & SK7_KEY_LEFT_UP )	return true;
		}else
		if( PowerY <= -KEY_POWER ){
			if( KeyNo & SK7_KEY_LEFT_DOWN )	return true;
		}
	}else
	if( PowerY >= KEY_POWER ){
//		if( KeyNo & SK7_KEY_UP )	return true;
	}else
	if( PowerY <= -KEY_POWER ){		
//		if( KeyNo & SK7_KEY_DOWN )	return true;
	}
	return false;
}

//========================================================================
//						// `
//========================================================================
void		DrawSousaLine()
{
	u8 a ;
	u16 i, Num, y ;
		
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
	GXSetLineWidth( (u8)( 6 * VParam[ED_CHARCHANGE][1] ), GX_TO_ONE ) ;

	// ̕`
	a = (u8)VParam[ED_CHARCHANGE][0] ;
	Num = (u16)( 480 / ( VParam[ED_CHARCHANGE][1] * 2 ) ) ;
	GBGN( GX_LINES, Num * 2 ) ;
	{
		y = 0 ;
		for( i = 0 ; i < Num ; i ++, y += VParam[ED_CHARCHANGE][1] * 2 )
			DrawLineNB( 0, y, SCW, y, a ) ;
	}
	GXEnd();		
}
	
#if 0
//========================================================================
//					Xe[Wԍ}bv`FbN
//========================================================================
s8				CheckStageNo()
{
	STAGE_NO* pStageNo;
	u32 GetID0 = WK7Stage::GetReleasedStageID();
	u32	GetID1 = WK7Stage::GetCurrentStageID();
	u32 GetID = 0;
	if( GetID0 == 0xffffffff )	GetID = GetID1;
	if( GetID1 == 0xffffffff )  GetID = GetID0;
	u32 StageID	= (GetID>>K7STGMAINID_SHIFT);

	for( int i = 0; i < STAGE_NO_NUM; i++ )
	{
		pStageNo = tblStageNoDataAll[i];
		if( pStageNo == NULL ){
			return -1;
		}
		
		while(1)
		{
			if( pStageNo->LeftNo == NULL ) break;
			if( pStageNo->LeftNo == StageID ){
				return (s8)i;
			}
			pStageNo++;
		}
	}
	return -1;
}
#endif

//========================================================================
//					vC[̃io[擾
//========================================================================
u8		GetPlayerNo( u32 MainID )
{
	switch( MainID ){
	case K7DAN:		return 1;
	case K7GAL:		return 0;
	case K7CON:		return 5;
	case K7HAC:		return 7;
	case K7CYO:		return 4;
	case K7KED:		return 2;
	case K7KVN:		return 3;
	case K7MSK:		return 6;
	}
	return 0xff;
}

//========================================================================
//					vC[̃io[擾
//========================================================================
u32		GetPlayerID( u8 MainID )
{
	switch( MainID ){
	case 0:		return K7DAN;
	case 1:		return K7KED;
	case 2:		return K7KVN;
	case 3:		return K7CYO;
	case 4:		return K7CON;
	case 5:		return K7MSK;
	case 6:		return K7GAL;
	case 7:		return K7HAC;
	default:
		return 255;
	}
}

#if 0
//========================================================================
//					͂Ȃт̈ړ
//========================================================================
void		MoveHanabi()
{
	f32		X,Y;
	f32		PX,PY;
	
	for( int i = 0; i < HANABI_NUM*HANABI_WA_NUM; i++ )
	{		
		X = m_spHanabi[i].GetX0();
		Y = m_spHanabi[i].GetY0();
		
		if( (i%2)==0 )
		{
			PX = HANABI_R * cosf( (2.0f*PI)/HANABI_NUM*i);
			PY = HANABI_R * sinf( (2.0f*PI)/HANABI_NUM*i);
		}
		else
		{
			PX = HANABI_R/2.0f * cosf( (2.0f*PI)/HANABI_NUM*i);
			PY = HANABI_R/2.0f * sinf( (2.0f*PI)/HANABI_NUM*i);
		}
		X += (PX * cosf(0.0f) + PY * sinf(0.0f))/HANABI_RAD_SPEED;
		Y += (PX * sinf(0.0f) - PY * cosf(0.0f))/HANABI_RAD_SPEED;
		
		m_spHanabi[i].SetXY0( X, Y );
	}
}
#endif




//
//						t@CNX
//
	
//========================================================================
//					RXgN^
//========================================================================
SK7File::SK7File()
{
	m_sFileEvent 	= FILE_OPEN;
}

//========================================================================
//					fXgN^
//========================================================================
SK7File::~SK7File()
{
	m_File.Close();
}

//========================================================================
//					eNX`[h
//========================================================================
bool		SK7File::OpenTexFile( char* FileName, TEX_DATA *pTex )
{
	s32 	Size;
	
	switch( m_sFileEvent )
	{
		case FILE_OPEN://	t@CI[v
			if( m_File.Open(FileName) == false )	return false;
			m_sFileEvent = FILE_READ;
			break;
		
		case FILE_READ://	t@C[h
			Size = (s32)OSRoundUp32B( m_File.GetLength(true) );
			ghmGcMemSetAllocName("SK7Texture");
			if( (pTex->Header = ( GhmGcTexHeader * )ghmGcMemAlloc( Size )) == NULL )
				return false;
			m_File.Read( pTex->Header, 0, Size );
			m_sFileEvent = FILE_WAIT;
			break;
		
		case FILE_WAIT://	t@CǂݍݏI҂
			if( m_File.GetState() == ghmGcFile::READFINISH )
			{
				m_File.Close();
				m_sFileEvent = FILE_OPEN;
				return true;
			}
			break;
	}
	return false;
}

//========================================================================
//					eNX`[h
//========================================================================
bool		SK7File::OpenTexFileB( char* FileName, TEX_DATA *pTex )
{
	s32 	Size;
	
	if( m_File.Open(FileName) == false )	return false;
	
	Size = (s32)OSRoundUp32B( m_File.GetLength(true) );
	ghmGcMemSetAllocName("SK7TextureB");
	if( (pTex->Header = ( GhmGcTexHeader * )ghmGcMemAlloc( Size )) == NULL )	return false;
	m_File.ReadB( pTex->Header, 0, Size );
	m_File.Close();
	return true;
}

//========================================================================
//					t@C[h
//========================================================================
bool		SK7File::OpenDataFile( char* FileName, void** Data )
{
	switch( m_sFileEvent )
	{
	case FILE_OPEN://	t@CI[v
		ghmGcMemSetAllocName("SK7OPENDATA");
		if( m_File.Open(FileName) == false )	return false;
		ghmGcMemSetAllocName("SK7OPENDATA");
		if( (*Data = m_File.Read()) != NULL )
		{
			if( m_File.GetState() == ghmGcFile::READFINISH )
			{
				m_File.Close();
				return true;
			}
			m_sFileEvent = FILE_WAIT;
		}
		break;

	case FILE_WAIT://	t@CǂݍݏI҂
		if( m_File.GetState() == ghmGcFile::READFINISH )
		{
			m_sFileEvent = FILE_OPEN;
			m_File.Close();
			return true;
		}
		break;
	}
	return false;
}


//========================================================================
//					oCi
//========================================================================
void*		SK7File::OpenFile( char* FileName )
{
	void*	Buff;
	u32 	Size;
	
	if( m_File.Open(FileName) == false )	return NULL;
	
//	Size = (s32)OSRoundUp32B( m_File.GetLength(true) );
	Size = m_File.GetLength(false) ;
	ghmGcMemSetAllocName("SK7BINARI");
	if(( Buff = (void*)ghmGcMemAlloc( (int)Size )) == NULL )		return NULL;
	
	m_File.ReadB( Buff, 0, (s32)Size );
	
	return Buff;
}





unsigned short SwapEndian_W( unsigned short w);

inline float	Swap4( void*data );
inline s32		SwapS32( void*data ); 

unsigned short SwapEndian_W( unsigned short w )
{
    return (unsigned short)( w << 8 | w >> 8 );
}

//	Xbv
inline float	Swap4( void*data )
{
	u8 a[4],b[4];
	for( int i = 0; i < 4; i++ )
	{
		a[i] = *(u8*)data; (u8*)data+=1;
	}
	b[0] = a[3];
	b[1] = a[2];
	b[2] = a[1];
	b[3] = a[0];
	
	return *(float*)b;
}

	//	Xbv
inline s32	SwapS32( void*data )
{
	u8 a[4],b[4];
	for( int i = 0; i < 4; i++ )
	{
		a[i] = *(u8*)data; (u8*)data+=1;
	}
	b[0] = a[3];
	b[1] = a[2];
	b[2] = a[1];
	b[3] = a[0];
	
	return *(s32*)b;
}

	//	Xbv
inline u16	Swap2( void*data )
{
	u8 a[2],b[2];
	for( int i = 0; i < 2; i++ )
	{
		a[i] = *(u8*)data; (u8*)data+=1;
	}
	b[0] = a[1];
	b[1] = a[0];	
	return *(u16*)b;
}

//========================================================================
//					
//========================================================================
int			SK7File::ReadKanjiFile( Vec** OutData, void* Buff )
{
	int Num;
	unsigned short a;
	
	//	W
	a = *(u16*)Buff;
	Num = SwapEndian_W(a);
	(u8*)Buff+=4;

	//	Wf[^쐬
	ghmGcMemSetAllocName("SK7KANJI");
	OutData[0] = new Vec[Num];

	// W擾
	for( int i = 0; i < Num; i++ )
	{
		OutData[0][i].x = Swap4(Buff); 
		(u8*)Buff+=4;
		OutData[0][i].y = Swap4(Buff); 
		(u8*)Buff+=4;
		OutData[0][i].z = Swap4(Buff);	
		(u8*)Buff+=4;
	}
	return Num;
}

//========================================================================
//					oCi
//========================================================================
int			SK7File::ReadKanjiFile( VEC2U16** OutData, void* Buff )
{
	s32 Num;
	//	W
	Num = SwapS32(Buff);
	(u8*)Buff+=sizeof(s32);

	//	Wf[^쐬
	ghmGcMemSetAllocName("SK7KANJI");
	OutData[0] = new VEC2U16[Num];

	// W擾
	for( int i = 0; i < Num; i++ )
	{
		OutData[0][i].x = Swap2(Buff); 
		(u8*)Buff+=2;
		OutData[0][i].y = Swap2(Buff); 
		(u8*)Buff+=2;
	}
	return Num;
}
	
//========================================================================
//					oCi
//========================================================================
int			SK7File::ReadStarFile( VEC2** OutData, void* Buff )
{
	int Num;
	unsigned short a;
	
	//	W
	a = *(u16*)Buff;
	Num = SwapEndian_W(a);
	(u8*)Buff+=4;

	//	Wf[^쐬 
	OutData[0] = new VEC2[Num];

	// W擾
	for( int i = 0; i < Num; i++ )
	{
		OutData[0][i].x = Swap4(Buff); 
		(u8*)Buff+=4;
		OutData[0][i].y = Swap4(Buff); 
		(u8*)Buff+=4;
	}
	return Num;
}


Vector3::Vector3(float inX, float inY, float inZ) 
{
  x = inX;
  y = inY;
  z = inZ;
}

Vector3::Vector3(const Vector3 &v) 
{
  x = v.x;
  y = v.y;
  z = v.z;
}
	
Vector3 &Vector3::operator = (const Vector3 &v) 
{
  x = v.x;
  y = v.y;
  z = v.z;

  return *this;
}


Vector3 &Vector3::operator += (const Vector3 &v) 
{
  x += v.x;
  y += v.y;
  z += v.z;

  return *this;
}

Vector3 &Vector3::operator -= (const Vector3 &v) 
{
  x -= v.x;
  y -= v.y;
  z -= v.z;

  return *this;
}

Vector3 &Vector3::operator *= (float f) 
{
  x *= f;
  y *= f;
  z *= f;

  return *this;
}

Vector3 &Vector3::operator /= (float f) 
{
  x /= f;
  y /= f;
  z /= f;

  return *this;
}

bool operator == (const Vector3 &a, const Vector3 &b) 
{
  return ((a.x == b.x) && (a.y == b.y) && (a.z == b.z));
}

bool operator != (const Vector3 &a, const Vector3 &b) 
{
  return ((a.x != b.x) || (a.y != b.y) || (a.z != b.z));
}

Vector3 operator + (const Vector3 &a, const Vector3 &b) 
{
  Vector3 ret(a);

  ret += b;

  return ret;
}

Vector3 operator - (const Vector3 &a, const Vector3 &b) 
{
  Vector3 ret(a);

  ret -= b;

  return ret;
}

Vector3 operator * (const Vector3 &v, float f) 
{
  return Vector3(f * v.x, f * v.y, f * v.z);
}

Vector3 operator * (float f, const Vector3 &v) 
{
  return Vector3(f * v.x, f * v.y, f * v.z);
}

Vector3 operator / (const Vector3 &v, float f) 
{
  return Vector3(v.x / f, v.y / f, v.z / f);
}

Vector3 operator - (const Vector3 &a) 
{
  return Vector3(-a.x, -a.y, -a.z);
}

float Vector3::length() const 
{
  return (float) sqrt(x*x + y*y + z*z);
}

float Vector3::lengthSqr() const 
{
  return (x*x + y*y + z*z);
}

bool Vector3::isZero() const 
{
  return ((x == 0.0F) && (y == 0.0F) && (z == 0.0F));
}

Vector3 &Vector3::normalize() 
{
  float m = length();

  if (m > 0.0F) 
    m = 1.0F / m;
  else 
    m = 0.0F;
  x *= m;
  y *= m;
  z *= m;

  return *this;
}
