////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SK7Death
//
// SK7Death.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7DEATH_CPP__
//#define	__MOVEFONT__

#define		DEATH_DEBUG

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "../wat/K7App.h"
#include "../wat/WK7MainTask.h"
#include "SK7Death.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7Light.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7GameInfo.h"
#include "SK7Special.h"
#include "../yam/YK7Effect.h"


#define		DEATH_TIME			(60)
#define		DEATH_FOV_FIRST		(42.18468f)
#define		DEATH_FOV_SPEED		(0.5f)
#define		DEATH_FOV_MAX		(20.0f)
#define		DEATH_CAMERA_TIME	(120)
#define		RETRY_ALPHA_TIME	(15)
#define		RETRY_TIME			(60)
#define		BLOOD_MOVE_FRAME	(5)
#define		DEATH_RED_FADE_TIME	(60)
#define		TITLE_FONT_X		(176)
#define		TITLE_GEKI_X		(220)
#define		TITLE_FONT_X2		(265)
#define		BLACK_GAP_X			(10.0f)
#define		BLACK_GAP_Y			(15.0f)
#define		BLACK_GAP_X2		(0)
#define		BLACK_GAP_Y2		(15.0f)
#define		FONT_PLUS_ALPHA		(20.0f)
#define		FONT_MINS_ALPHA		(20.0f)
#define		TITLE_BETWEEN_X		(8)
#define		FONT_EX_SELECT		(0)
#define		FONT_EX_RIGHT		(-18)
#define		FONT_EX_LEFT		(-8)
#define		FONT_SELECT_GAPY	(-5)
#define		FONT_EX_TIME		(10)
#define		FONT_HANE_SPEED		(10)
#define		FONT_HANE_SPEED2	(4)

#define		FONT_MOVE_FRAME		(8)
#define		FONT_MOVE_FRAME2	(12)
#define		FONT_MOVE_SIZE		(5.0f)
#define		FONT_MOVE_SIZE2		(5.0f)

#define		DEATH_ROT_TIME		(4)
#define		DEATH_ROT_ANGLE		(360)
#define		DEATH_MAX_SIZE		(800)

#define		ENDMES_LEFT_NUM		(4)			//	̑O̕

#define		END_MES_DATA		"/Texture/gameover/end.jmb"
#define		BLOOD_ZETHU			"/Texture/gameover/zetumei.BIN"
#define		BLOOD_SHI			"/Texture/gameover/Death.BIN"
#define		END_BG_DATA			"/Texture/gameover/background_black.BIN"//background_ded.BIN"//background_black.BIN


//		AbvJ|WV		
PLAYER_CAMERA	tblPlayerCamPos[]=
{
	5.045532f,4.980789f,-9.731770f,0.5824435f,-3.098422f,-17.22983f,//	_
	5.045532f,4.980789f,-9.731770f,0.5824435f,-3.098422f,-17.22983f,//	_
	-7.147f,4.695f,-4.647f,-11.052f,-5.719f,-8.857f,                //	R
	-7.147f,4.695f,-4.647f,-11.052f,-5.719f,-8.857f,                //	R
	1.722056F,12.64586F,3.701090F,-3.470262F,17.85698F,-5.642241F,  //	
	1.722056F,12.64586F,3.701090F,-3.470262F,17.85698F,-5.642241F,  //	
	1.154339f,15.73893f,3.742325f,-3.375676f,20.34942f,-6.239463f,  //	}XN
	1.154339f,15.73893f,3.742325f,-3.375676f,20.34942f,-6.239463f,  //	}XN
	0.7900563f,13.33229f,2.436955f,-1.863107f,21.62040f,-2.265662f, //	Pr
	0.7900563f,13.33229f,2.436955f,-1.863107f,21.62040f,-2.265662f, //	Pr
	1.661574f,14.37021f,2.922647f,-2.158386f,22.85920f,-0.4227448f, //	KVA
	1.661574f,14.37021f,2.922647f,-2.158386f,22.85920f,-0.4227448f, //	KVA
	1.176546f,13.52728f,3.305147f,-1.061477f,19.92108f,-3.902992f,  //	R[e
	1.176546f,13.52728f,3.305147f,-1.061477f,19.92108f,-3.902992f,  //	R[e
	1.154339f,15.73893f,3.742325f,-3.375676f,20.34942f,-6.239463f,  //	}XNtexs
	1.154339f,15.73893f,3.742325f,-3.375676f,20.34942f,-6.239463f,  //	}XNfinal
	1.154339f,15.73893f,3.742325f,-3.375676f,20.34942f,-6.239463f,  //	}XNmask
	1.625f,15.318f,3.682f,-3.2f,19.059f,-6.523f,//	n[
};

const f32 tblTitleY[]={ 142.0f, 142.0f, 218.0f, 218.0f, 294.0f, 294.0f };

//	Cgݒ 	

#define	DIRLIGHT_COLOR		{ 0xff, 0xff, 0xff, 0xff }					// color


static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 2.000000f },		// wobj position
};

static	float	dir_light_shininess = 50.0f;

static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// CgN
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// CgtO
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};

#define	DEATH_LIGHT_TYPE		(0xdddddddd)
#define DEATH_LIGHT_ID			(4)	

#if 0
//	Õnl
const VEC2 tblMaeHane[]={
	{13.0f,5.0f},	{16.0f,4.0f},	{-4.0f,-20.0f},
	{34.0f,7.0f},	{37.0f,7.0f},	{41.0f,-39.0f},
	{5.0f,12.0f},	{6.0f,14.0f},	{-21.0f,32.0f},
	{36.0f,29.0f},	{33.0f,30.0f},	{35.0f,63.0f},
	{0.0f,0.0f},	{0.0f,0.0f},	{0.0f,0.0f},
};
#endif

//	̃nl
const VEC2 tblGekiHane[]={
	{5.0f,8.0f},	{6.0f,10.0f},	{-20.0f,10.0f},
	{3.0f,31.0f},	{5.0f,32.0f},	{-10.0f,50.0f},
	{17.0f,33.0f},	{19.0f,33.0f},	{26.0f,55.0f},
	{33.0f,2.0f},	{35.0f,2.0f},	{39.0f,-26.0f},
	{32.0f,36.0f},	{34.0f,35.0f},	{43.0f,71.0f},
};

//	Ă̂͂
const VEC2 tblSaiHane[]={
	{8.0f,4.0f},	{9.0f,4.0f},	{-1.0f,-15.0f},
	{19.0f,5.0f},	{22.0f,6.0f},	{34.0f,-24.0f},
	{8.0f,34.0f},	{10.0f,34.0f},	{25.0f,56.0f},
	{27.0f,36.0f},	{28.0f,34.0f},	{-25.0f,9.0f},
	{31.0f,11.0f},	{33.0f,12.0f},	{50.0f,30.0f},
};

const VEC2 tblSyuHane[]={
	{5.0f,11.0f},	{7.0f,10.0f},	{-19.0f,-11.0f},
	{3.0f,31.0f},	{4.0f,32.0f},	{-17.0f,65.0f},
	{15.0f,32.0f},	{16.0f,31.0f},	{27.0f,52.0f},
	{32.0f,6.0f},	{34.0f,7.0f},	{52.0f,-32.0f},
	{33.0f,21.0f},	{36.0f,21.0f},	{42.0f,43.0f},
};

//	nl̃e[u	--------------------------------------------
const VEC2* tblHaneAll[]={
//	tblMaeHane,
	tblSaiHane,
	tblSyuHane,
};


//========================================================================
//					RXgN^
//========================================================================
SK7Death::SK7Death( u32	CharaNo, bool GameOverFlag )
{
	if( PLAYER_GAL_FRONT == CharaNo || PLAYER_GAL_BACK == CharaNo ){
		//	KV[񂶂猌J	===============================
		GameInfo.GetSpOption()->SetBloodGauge( BP_THICK, 0 );
		GameInfo.GetSpOption()->SetBloodGauge( BP_THIN, 0 );
		GameInfo.GetSpOption()->SetBloodGauge( BP_SERUM, 0 );
		m_bEndFlag = true;
	}else{
		m_bEndFlag = false;
	}
	
	if( (CharaNo % 2) == 0 )	CharaNo++;

	if( CharaNo == 6 || CharaNo == 7 ){
		//	}XNLvUpΉ	---------------------------------------------
		switch( BattleCtrl.GetMskPowerUp() ){
		case KK7BATTLECTRL_MSKLV_TEXAS:		CharaNo = PLAYER_MSK_TEXAS; 	break;
		case KK7BATTLECTRL_MSKLV_FINAL:		CharaNo = PLAYER_MSK_FINAL;		break;
		case KK7BATTLECTRL_MSKLV_TEKKAMEN:	CharaNo = PLAYER_MSK_KAMEN;		break;
		}
	}

	m_bRender 		= false;					// `tO
	m_bCtrl 		= false;					// 싖tO
	m_bBloodDrawFlag= false;
	m_bSoundFlag	= false;
	m_bRetryFlag	= GameOverFlag;
	m_pModel		= NULL;
	m_pMotion		= NULL;
	m_pFaceMotion	= NULL;
	m_pArchive		= NULL;	
	m_pMotionArc 	= NULL;
	m_pFaceArc		= NULL;
	m_iTime			= 0;
	m_iCameraTime	= 0;
	m_iSelect		= 0;
	m_iExTime		= 0;
	m_fAngle		= 0;
	m_fSize			= 0;
	m_fFov			= DEATH_FOV_FIRST;
	m_iCharaNo		= (int)CharaNo;
	
	m_bGameOverFlag = false;
	m_Proc			= PROC_LOAD;
	m_LoadProc		= LOAD_MODEL;
	
	memset( m_iMoveTime, 	0, sizeof( int )*DEATH_SELECT_NO_MAX 	);
	memset( m_sAlpha, 		0, sizeof( s16 )*DEATH_SELECT_NO_MAX 	);
	memset( m_iSetTime, 	0, sizeof( int )*DEATH_SELECT_NO_MAX 	);
	memset( m_fFontEx, 		0, sizeof( f32 )*DEATH_EX_NUM 			);
	memset( m_fOneFontEx,	0, sizeof( f32 )*SELECT_FONT_NUM_MAX	);
		
	//	Cg쐬	===========================================
	WK7Light::Create(&dir_light,DEATH_LIGHT_TYPE,DEATH_LIGHT_ID);
	
	//	ff[^[h	===========================================
	if( (m_pArchive = WK7Archive::Create()) != NULL  ){
		m_pArchive->LoadArchive( tblPlayerName[CharaNo]  );
	}	
	//	[Vf[^[h	===========================================
	if( tblPlayerMotionName[CharaNo] != NULL ){
		if( (m_pMotionArc = WK7Archive::Create()) != NULL ){
			m_pMotionArc->LoadArchive( tblPlayerMotionName[CharaNo] );
		}
	}
	//	tFCV[V[h	===================================
	if( tblFaceMotionName[CharaNo] != NULL ){
		if( (m_pFaceArc = WK7Archive::Create() ) != NULL ){
			m_pFaceArc->LoadArchive( tblFaceMotionName[CharaNo] );
		}
	}

	//	J̃|WV	===========================================
	WK7CAM->SetMode				(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetDesc				(NULL);
	WK7CAM->SetWobbleEnable		(false);
	WK7CAM->SetPosition			(tblPlayerCamPos[CharaNo].CamPos);
	WK7CAM->SetTargetPosition	(tblPlayerCamPos[CharaNo].TargetPos);
	
	//	p[eBNW
	for( int i = 0; i < DEATH_BLOOD_NUM; i++ )
	{
		m_vBloodPos[i].x = 420.0f-rand()%130+50;
		m_vBloodPos[i].y = 290.0f-rand()%100+50;
		m_vBloodPos[i].z = 0;
	}
	
	//	̕	===============================================
	if( !m_bEndFlag ){
		m_spDeath.SetXY0( 54.9375f, -14.0625f );
	}else{
		m_spDeath.SetXY0( 44.5f, -27.0f );
	}
	m_spDeath.SetVisible(false);
	m_spDeath.SetColor( 0xa0a0a0ff );
	m_spDeath.SetFlag( true, Z_FLAG );
	if( !m_bEndFlag ) SET_SPRITE_ROT( &m_spDeath, m_fAngle, 320, 240, m_fSize, m_fSize );
	
	//	ԃtF[h	===============================================
	m_spFade.SetXYTwo( -10,-10,650,490 );
	m_spFade.SetFlag( true, Z_FLAG|RENDER_FLAG|NOTEX_FLAG);
	m_spFade.SetColor( 0xa0000000 );
	
	//	wi	===============================================
	m_spWhite.SetXYTwo( -10, -10, 650, 490 );
	m_spWhite.SetFlag( true, Z_FLAG|NOTEX_FLAG );
	m_spWhite.SetVisible(false);
	m_spWhite.SetColor( 0xffffffff );
	
	//	L悤	======================================
	m_spCharaWhite.SetXYTwo( -10, -10, 650, 490 );
	m_spCharaWhite.SetFlag( true, Z_FLAG|NOTEX_FLAG|RENDER_FLAG );
	m_spCharaWhite.SetVisible(true);
	m_spCharaWhite.SetColor( 0xffffff00 );

	//	XN[	=======================================
	m_spScreen.SetXYTwo( 0, 0, 640, 480 );
	m_spScreen.SetFlag( true, Z_FLAG|RENDER_FLAG|VTX4_FLAG|SCREEN_FLAG );
	m_spScreen.SetColor( 0xffffffff );
	PanelScreenEffectStop();
	
	m_spLastFade.SetXYTwo( -10, -10, 650, 490 );
	m_spLastFade.SetFlag( true, Z_FLAG|NOTEX_FLAG );
	m_spLastFade.SetVisible(true);
	m_spLastFade.SetColor( 0x00000000 );
	
	//	nl̏	
	InitHane();	
}


//========================================================================
//					fXgN^
//========================================================================
SK7Death:: ~SK7Death()
{
	m_Font[0].Delete();
	
	for( int i = 0; i < DEATH_SELECT_NUM; i++ ){
		m_Font[i].Release();
		m_FontB[i].Release();
	}
	// Cg
	WK7Light::Release(DEATH_LIGHT_TYPE,DEATH_LIGHT_ID);
	
	GHM_SAFE_DELETE( m_pModel );
	GHM_SAFE_DELETE( m_pMotion );
	GHM_SAFE_DELETE( m_pFaceMotion );
	
	GHMGCMEM_SAFE_FREE( m_BloodTex.Header );
	m_spDeath.Delete();
	m_spBg.Delete();
	
	PanelScreenEffectStopRelease();
	
}



//========================================================================
//					t[
//========================================================================
bool  		SK7Death::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	[h	
	case 	PROC_LOAD:
		if( LoadData() )
		{
			// }X^[{[߂
			gpSound->mSetMasterVol( SOUND_MASTER_VOLUME );
			gpSound->mStopStream();
			gpSound->mStopSEAll();
			if( m_bEndFlag )	gpSound->mPlayStreamNo( HPS_DEAD_GAMEOVER );
			else				gpSound->mPlayStreamNo( HPS_DEAD );
			m_Proc = PROC_MAIN;
		}
		break;
		
	//	ŏwait	
	case 	PROC_MAIN:
		if( ++m_iTime > 10 ){
			m_iTime = 0;
			m_Proc = PROC_MOVE_BLOOD;
		}
		break;

	//	J	
	case	PROC_MOVE_BLOOD:
#ifdef	DEATH_DEBUG
		if( m_iTime == 0 ){
			if( tblFaceObjName[m_iCharaNo] != NULL ){
				WK7JObj	*pJObj = m_pModel->GetObj(tblFaceObjName[m_iCharaNo]);
				if( pJObj!=NULL ){
					pJObj->PlayShapeMotion(0.0F,false,true);
					pJObj->SetMotionLoop(false);
				}
			}
			gpSound->mPlaySE(SFX_SYS_GAMEOVER_DIE);
			if( !m_bEndFlag )	gpSound->mFadeVolumeStream( 0, 800 );
		}
		if( ++m_iTime >= tblMouthTime[m_iCharaNo] ){
//			m_bBloodDrawFlag = true;
			m_iTime = 0;
			m_spWhite.SetVisible(true);
			m_Proc = PROC_BLOOD_MAIN;
		}
#endif
		break;

	//	̈ړ	
	case	PROC_BLOOD_MAIN:
		m_spCharaWhite.AddAlpha(BLOOD_MOVE_FRAME);
		for( int i = 0; i < DEATH_BLOOD_NUM; i++ ){
			m_vBloodPos[i].x -= rand()%10;//250;
			m_vBloodPos[i].y -= rand()%50;//150;
		}
		if( ++m_iTime >= BLOOD_MOVE_FRAME ){
			m_iTime = 0;
			m_bBloodDrawFlag = false;
			m_spDeath.SetVisible(true);
			if( m_bEndFlag ){
				m_Proc = PROC_FADECHECK;
			}else{
				m_Proc = PROC_MOVE_DEATH;//
			}
		}
		break;
		
	//	̉̕]g	
	case 	PROC_MOVE_DEATH:	
		m_fAngle += DEATH_ROT_ANGLE/DEATH_ROT_TIME; 
		m_fSize += DEATH_MAX_SIZE/DEATH_ROT_TIME;
		SET_SPRITE_ROT( &m_spDeath, m_fAngle, 320, 240, m_fSize, m_fSize );		
		if( ++m_iTime >= DEATH_ROT_TIME ){
			m_iTime = 0;
			m_Proc = PROC_FADECHECK;
		}
		break;
		
	//	wait	
	case PROC_FADECHECK:
		if( ++m_iTime > 80 ){
			m_iTime = 0;
			if( m_bEndFlag ){
				m_Proc = PROC_SELECTBG_FADE;
			}else{
				m_Proc = PROC_TIME;
			}
		}
		break;

	//	ԂtF[h	
	case	PROC_TIME:
		if( m_spFade.AddAlpha( DEATH_RED_FADE_TIME ) ){
			if( m_bRetryFlag ){
				m_Proc = PROC_FADE_MAIN;
			}else{
				m_Proc = PROC_RETRY;
			}
		}
		break;
		
	//	^CgwitF[h	
	case 	PROC_SELECTBG_FADE:
		if( m_spBg.AddAlpha( DEATH_RED_FADE_TIME ) ){
			for( int i = 0; i < DEATH_SELECT_NUM; i++ ){
				m_Font[i].SetFlag	( true, FONT_EFC_RENDER );
				m_FontB[i].SetFlag	( true, FONT_EFC_RENDER );
				m_Font[i].SetAlpha	( 0 );
			}
			//	O	-----------------------------------------
			m_Font[0].SetAlpha		( 0xff );
			m_Font[1].SetAlpha		( 0xff );
			m_Font[4].SetAlpha		( 0xff );
			m_sAlpha[0] = 0xff;
			SetSelectFont();
			SetSelectEx();
			SetSelectHane();
			m_Proc = PROC_END_SELECT;
		}
		break;
		
	//	gCp	
	case	PROC_RETRY:
		if( ++m_iTime > RETRY_TIME ){
			m_iTime = 0;
			m_Proc = PROC_FADE_MAIN;
		}
		break;
		
	//	Ō̃tF[h	
	case	PROC_FADE_MAIN:
		if( m_spLastFade.AddAlpha(30) ){
			if( GameInfo.GetSpOption() != NULL ){
				GameInfo.GetSpOption()->InitOptionWindow();
			}
			m_Proc = PROC_END;
		}
		break;
		
	//	ČI	
	case PROC_END_SELECT:
		//	IAt@	----------------------------------------
		m_sAlpha[m_iSelect] += FONT_PLUS_ALPHA;
		if( m_sAlpha[m_iSelect] > 255 )		m_sAlpha[m_iSelect] = 255;
		//	IĂȂAt@	----------------------------------------
		for( int i = 0; i < DEATH_SELECT_NO_MAX; i++ ){
			if( i != m_iSelect ){
				m_sAlpha[i] -= FONT_MINS_ALPHA;
				if( m_sAlpha[i] < 0 )		m_sAlpha[i] = 0;
			}
		}
		//	At@Zbg		----------------------------------------
		for( int i = 0; i < DEATH_SELECT_NUM; i++ ){
			if( i < 4 ){
				m_Font[i].SetAlpha( (u8)m_sAlpha[i/2] );
			}else{
				m_Font[i].SetAlpha( (u8)m_sAlpha[i-4] );
			}
		}
		//	g	-----------------------------------------------
		MoveSelectEx();
#ifdef __MOVEFONT__
		//	ړ	-------------------------------------------------
		MoveSelectFont();
#endif	
		//	nl̈ړݒ	
		SetHaneState();
		//	͂˂̐ݒu		
		SetSelectHane();
		
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			if( ++m_iSelect > 1 ){
				m_iSelect = 1;
				break;
			}
			SetSelectFont();
			SetSelectEx();
			InitHane();
			gpSound->mPlaySE(SFX_SYS_CONTINUE_SELECT);
		}
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( --m_iSelect < 0 ){
				m_iSelect = 0;
				break;
			}
			SetSelectFont();
			SetSelectEx();
			InitHane();
			gpSound->mPlaySE(SFX_SYS_CONTINUE_SELECT);
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( m_iSelect == 0 ) 	gpSound->mPlaySE(SFX_SYS_CONTINUE_SAIGEKI);
			else					gpSound->mPlaySE(SFX_SYS_CONTINUE_SYUGEKI);
			for( int i = 0; i < DEATH_SELECT_NUM; i++ ){
				m_Font[i].SetFlag		( false, FONT_EFC_MOVE );
				m_FontB[i].SetFlag		( false, FONT_EFC_MOVE );
			}
			m_Proc = PROC_FADE_MAIN;
		}
		break;
		
	case 	PROC_END:
		return true;
	}
	//	fvZX	============================
	if( m_pModel != NULL )	m_pModel->FrameProcess();
	return false;
}

//========================================================================
//					_O
//========================================================================
bool  		SK7Death::RenderProcess(void)
{
	if( !m_bRender )	return true;

	m_spWhite.Render();

	//	[hύXifwi̐OɁj
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );

	// JgJݒ
	if(WK7CAM->SetCurrent()==true )
	{
		WK7Light::DispStart();
		WK7Light::DispAll();
		WK7Light::DispEnd();

		if( m_pModel != NULL )	m_pModel->RenderProcess();
		WK7CAM->RenderProcess();

		// JgJł̕`I
		WK7CAM->EndCurrent();
	}
	//	
	DrawBlood();
	//	L悤
	m_spCharaWhite.Render();
	//	XN[Rs[
	screenImageMonoColor.ScreenCopy();
	m_spScreen.SetTexture( 	screenImageMonoColor.GetTexObj() );	
	m_spScreen.Render();
	//	̕
	m_spDeath.Render();
	//	Iwi
	m_spBg.Render();
	//	ԃtF[h
	m_spFade.Render();
	//	tHg͂
	for( int i = 0; i < HANE_NUM; i++ ){
		m_FHane[i].spHane.Render();
		m_BHane[i].spHane.Render();
	}
	//	tHg	
	for( int i = 0; i < DEATH_SELECT_NUM; i++ ){
		m_FontB[i].RenderLine();
		m_Font[i].RenderLine();
	}

	m_spLastFade.Render();
	return true;
}


//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================	 
bool  		SK7Death::GetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}


//========================================================================
//					II擾֐
//========================================================================	 
bool  		SK7Death::GetMenuEnd(void)
{
	if( m_Proc == PROC_END )
	{
		return true;
	}
	return false;
}


//========================================================================
//					II擾֐
//========================================================================	 
bool  		SK7Death::LoadData()
{				
	switch( m_LoadProc )
	{
	case LOAD_MODEL:
		if( m_pArchive->GetState() == WK7Archive::WK7ARCHIVE_LOADED )
		{
			if( (m_pModel = m_pArchive->CreateModel()) != NULL )
			{
				m_pModel->SetPosition( 0.0f, 0.0f, 0.0f );
				m_pModel->SetRotation( 0.0f, 0.0f, 0.0f );
				m_pModel->Disp();
				for( int i = 0; i < NOT_DREW_NUM; i++ ){
					if( tblVisibleName[m_iCharaNo].NotDraw[i] != NULL ){
						m_pModel->GetObj( tblVisibleName[m_iCharaNo].NotDraw[i] )->Hide();
					}
				}
				m_LoadProc = LOAD_MOTION;
			}
		}
		break;
	case LOAD_MOTION:
		if( m_pMotionArc == NULL ){
			m_LoadProc = LOAD_FACE;
			break;
		}
		if( m_pMotionArc->GetState() == WK7Archive::WK7ARCHIVE_LOADED )
		{
			if( (m_pMotion = m_pMotionArc->CreateModelMotion()) != NULL )
			{
				m_pModel->AttachMotion(m_pMotion);
				m_pModel->PlayMotionAll(-1.0F);
				m_pModel->SetMotionLoop(false);
				m_LoadProc = LOAD_FACE;
			}
		}
		break;
		
	case LOAD_FACE:
		if( m_pFaceArc == NULL ){
			m_LoadProc = LOAD_BLOOD_PAT;
			break;
		}
		if( m_pFaceArc->GetState() == WK7Archive::WK7ARCHIVE_LOADED )
		{
			if( (m_pFaceMotion = m_pFaceArc->CreateModelMotion()) != NULL )
			{
				if( m_iCharaNo == PLAYER_DAN_BACK || m_iCharaNo == PLAYER_CAT_BACK ){
					WK7JObj	*pJObj = m_pModel->GetObj(tblFaceObjName[m_iCharaNo]);
					pJObj->AttachShapeMotion(m_pFaceMotion);
				}else{
					m_pModel->AttachShapeMotion(m_pFaceMotion);
				}
				m_LoadProc = LOAD_BLOOD_PAT;
			}
		}
		break;
		
	case LOAD_BLOOD_PAT:
		if( m_File.OpenTexFile( BLOOD_PAT_TEX, &m_BloodTex ) )
		{
			InitTexture( &m_BloodTex );
			m_LoadProc = LOAD_END_DATA;
		}
		break;
				
	case LOAD_END_DATA:
		if( m_Font[0].LoadFont( END_MES_DATA ) ){
			int j=0;
			for( int i = 0; i < DEATH_SELECT_NUM; i++ ){
				if( i < ENDMES_LEFT_NUM ){
					if( (i%2) == 0 ){
						m_Font[i].SetFontLine	( TITLE_FONT_X, tblTitleY[i], 0xdcdcdcff, 0, (u8)i, m_Font[0].GetData() );
						m_FontB[i].SetFontLine	( TITLE_FONT_X+BLACK_GAP_X, tblTitleY[i]+BLACK_GAP_Y, 0x000000ff, 0, (u8)i, m_Font[0].GetData() );
					}else{
						m_Font[i].SetFontLine	( TITLE_GEKI_X, tblTitleY[i], 0xdcdcdcff, 0, (u8)i, m_Font[0].GetData() );
						m_FontB[i].SetFontLine	( TITLE_GEKI_X+BLACK_GAP_X, tblTitleY[i]+BLACK_GAP_Y, 0x000000ff, 0, (u8)i, m_Font[0].GetData() );
					}
				}else{
					m_Font[i].SetFontLine	( TITLE_FONT_X2, tblTitleY[j]+5.0f, 0xdcdcdcff, 0, (u8)i, m_Font[0].GetData() );
					m_FontB[i].SetFontLine	( TITLE_FONT_X2+BLACK_GAP_X2, tblTitleY[j]+BLACK_GAP_Y2, 0x000000ff, 0, (u8)i, m_Font[0].GetData() );
					j+=2;
				}
				m_Font[i].SetAlpha		( 0 );
				m_Font[i].SetFlag		( false, FONT_EFC_RENDER );
				m_Font[i].SetFlag		( true, FONT_EFC_MOVE|FONT_EFC_BIG2 );
				m_FontB[i].SetFlag		( true, FONT_EFC_MOVE|FONT_EFC_BIG2 );
				m_FontB[i].SetAlpha		( 200 );
				if( i < 2 ){
					m_Font[i].SetMoveSize	(FONT_MOVE_SIZE);
					m_Font[i].SetMoveFrame	(FONT_MOVE_FRAME);
					m_FontB[i].SetMoveSize	(FONT_MOVE_SIZE);
					m_FontB[i].SetMoveFrame	(FONT_MOVE_FRAME);
				}else if( i < ENDMES_LEFT_NUM ){
					m_Font[i].SetMoveSize	(FONT_MOVE_SIZE2);
					m_Font[i].SetMoveFrame	(FONT_MOVE_FRAME2);
					m_FontB[i].SetMoveSize	(FONT_MOVE_SIZE2);
					m_FontB[i].SetMoveFrame	(FONT_MOVE_FRAME2);
				}else{
					m_Font[i].SetMoveSize	(FONT_MOVE_SIZE2);
					m_Font[i].SetMoveFrame	(FONT_MOVE_FRAME2);
					m_FontB[i].SetMoveSize	(FONT_MOVE_SIZE2);
					m_FontB[i].SetMoveFrame	(FONT_MOVE_FRAME2);
				}
			}
			m_LoadProc = LOAD_END_BG;
		}
		break;
		
	case LOAD_END_BG:
		if( m_spBg.LoadTexture( END_BG_DATA ) ){
			m_spBg.SetXY0		( 0, 0 );
			m_spBg.SetAlpha		( 0 );
			m_spBg.SetVisible	( true );
			m_LoadProc = LOAD_BLOOD_DEATH;
		}
		break;
		
	case LOAD_BLOOD_DEATH:
		if( !m_bEndFlag ){
			if( m_spDeath.LoadTexture( BLOOD_SHI )){
				return true;
			}
		}else{
			if( m_spDeath.LoadTexture( BLOOD_ZETHU )){
				return true;
			}
		}
		break;
	}
	return false;
}


//========================================================================
//					p[eBN`
//========================================================================
void		SK7Death::DrawBlood()
{
	if( m_bBloodDrawFlag == false )	return;
	Set2DCamera();
	SetGraphMode();
	SetTevStage();
	SetVertex();
	
	//	|CgXvCgeNX`ݒ
	GXEnableTexOffsets(GX_TEXCOORD0, GX_FALSE, GX_TRUE);
	
	//	TCYݒ
	GXSetPointSize(200,GX_TO_HALF);
	GXLoadTexObj( &m_BloodTex.Obj, GX_TEXMAP0 );
	
	int i;
	//	X^[g
	GXBegin( GX_POINTS, GX_VTXFMT0, (u16)DEATH_BLOOD_NUM );
	
	for( i = 0; i < DEATH_BLOOD_NUM; i++ )
	{
		GXPosition3f32( m_vBloodPos[i].x,  m_vBloodPos[i].y, m_vBloodPos[i].z );
		GXColor1u32   ( 0xffffff6f );
		switch( (i%4) ){
		case 0:		GXTexCoord2f32( 0.0f, 0.0f );	break;
		case 1:		GXTexCoord2f32( 0.5f, 0.0f );	break;
		case 2:		GXTexCoord2f32( 0.0f, 0.5f );	break;
		case 3:		GXTexCoord2f32( 0.5f, 0.5f );	break;
		}	
	}
	GXEnd();
}

//========================================================================
//					Jړ
//========================================================================
bool		SK7Death::MoveCamera()
{
#if 0
	Vec vCSpeed;
	vCSpeed.x = (tblLastCamPos[m_iCharaNo].CamPos.x - tblFirstCamPos[m_iCharaNo].CamPos.x)/DEATH_CAMERA_TIME;
	vCSpeed.y = (tblLastCamPos[m_iCharaNo].CamPos.y - tblFirstCamPos[m_iCharaNo].CamPos.y)/DEATH_CAMERA_TIME;
	vCSpeed.z = (tblLastCamPos[m_iCharaNo].CamPos.z - tblFirstCamPos[m_iCharaNo].CamPos.z)/DEATH_CAMERA_TIME;

	Vec vTSpeed;
	vTSpeed.x = (tblLastCamPos[m_iCharaNo].TargetPos.x - tblFirstCamPos[m_iCharaNo].TargetPos.x)/DEATH_CAMERA_TIME;
	vTSpeed.y = (tblLastCamPos[m_iCharaNo].TargetPos.y - tblFirstCamPos[m_iCharaNo].TargetPos.y)/DEATH_CAMERA_TIME;
	vTSpeed.z = (tblLastCamPos[m_iCharaNo].TargetPos.z - tblFirstCamPos[m_iCharaNo].TargetPos.z)/DEATH_CAMERA_TIME;

	Vec vCamPos, vTarPos;
	WK7CAM->GetPosition			(vCamPos);
	WK7CAM->GetTargetPosition	(vTarPos);

	VECAdd( &vCamPos, &vCSpeed, &vCamPos );
	VECAdd( &vTarPos, &vTSpeed, &vTarPos );
	WK7CAM->SetPosition			( vCamPos );
	WK7CAM->SetTargetPosition	( vTarPos );

	if( ++m_iCameraTime > DEATH_CAMERA_TIME ){
		m_iCameraTime = 0;
		return true;
	}
#endif
	return false;
}

//========================================================================
//					Jړ
//========================================================================
bool		SK7Death::MoveFov()
{
	m_fFov -= DEATH_FOV_SPEED;
	
	if( m_fFov < DEATH_FOV_MAX ){
		return true;
	}
	WK7CAM->SetFov( m_fFov );
	return false;
}

//========================================================================
//					Jړ
//========================================================================
void		SK7Death::PlayFaceMotion()
{
	if( m_pModel == NULL ) return;
	
	WK7JObj	*pJObj = m_pModel->GetObj(tblFaceObjName[m_iCharaNo]);
	if( pJObj!=NULL ){
		pJObj->PlayShapeMotion(0.0F,false,true);
		pJObj->SetMotionLoop(false);
	}
}


//========================================================================
//					tHg̃TCYύX
//========================================================================
void		SK7Death::SetSelectFont()
{
	for( int i = 0; i < DEATH_SELECT_NUM; i++ ){
		if( i < ENDMES_LEFT_NUM ){
			if( m_iSelect*2 == i || m_iSelect*2+1 == i ) {
#ifdef __MOVEFONT__
				m_Font[i].SetPos	( m_Font[i].GetPos()->x-12.0f+BLACK_GAP_X, 	tblTitleY[i]+FONT_SELECT_GAPY+BLACK_GAP_Y );
#else
				m_Font[i].SetPos	( m_Font[i].GetPos()->x-12.0f, 	tblTitleY[i]+FONT_SELECT_GAPY );
#endif
				m_FontB[i].SetPos	( m_FontB[i].GetPos()->x-12.0f+BLACK_GAP_X, tblTitleY[i]+BLACK_GAP_Y+FONT_SELECT_GAPY );
				m_Font[i].SetEx		( FONT_EX_SELECT, FONT_EX_SELECT );
				m_FontB[i].SetEx	( FONT_EX_SELECT, FONT_EX_SELECT );
			}else{
				if( (i%2) == 0 ){
					m_Font[i].SetPos	( TITLE_FONT_X, 			tblTitleY[i] );
					m_FontB[i].SetPos	( TITLE_FONT_X+BLACK_GAP_X, tblTitleY[i]+BLACK_GAP_Y );
				}else{
					m_Font[i].SetPos	( TITLE_GEKI_X, 			tblTitleY[i] );
					m_FontB[i].SetPos	( TITLE_GEKI_X+BLACK_GAP_X, tblTitleY[i]+BLACK_GAP_Y );
				}
				m_Font[i].SetEx		( FONT_EX_LEFT, FONT_EX_LEFT );
				m_FontB[i].SetEx	( FONT_EX_LEFT, FONT_EX_LEFT );
			}
		}else{
			m_Font[i].SetEx	( FONT_EX_RIGHT, FONT_EX_RIGHT );
			m_FontB[i].SetEx( FONT_EX_RIGHT, FONT_EX_RIGHT );
		}
	}
#ifdef __MOVEFONT__
	//	ړԂ̃Zbg	---------------------------------------------------------------
	for( int i = 0; i < 3; i++ ){
		m_iSetTime[i] = (int)(255/FONT_PLUS_ALPHA+1) - ( m_iSetTime[i] - m_iMoveTime[i] );
		m_iMoveTime[i] = 0;
	}
#endif
}

//========================================================================
//					tHg̃TCYύX
//========================================================================
void		SK7Death::MoveSelectFont()
{
	int MoveTime = (int)(255/FONT_PLUS_ALPHA+1);

	for( int i = 0; i < DEATH_SELECT_NO_MAX; i++ ){
		if( m_iMoveTime[i] >= MoveTime ) continue;
		
		if( m_iSelect == i ){
			m_Font[i].SetPos( m_Font[i].GetPos()->x - (BLACK_GAP_X/MoveTime), m_Font[i].GetPos()->y - (BLACK_GAP_Y/MoveTime) );
		}else{
			m_Font[i].SetPos( m_Font[i].GetPos()->x + (BLACK_GAP_X/MoveTime), m_Font[i].GetPos()->y + (BLACK_GAP_Y/MoveTime) );
		}
		
		if( ++m_iMoveTime[i] >= MoveTime ){
			m_iMoveTime[i] = MoveTime;
		}
	}
}

//========================================================================
//					tHg̃TCYύX
//========================================================================
void		SK7Death::SetSelectEx()
{
	const f32 SELECT_MAX_EX = 6.0f;
	f32 Ex=0.0f;
	int i;
	
	for( i = 0; i < 6; i++ ){
		//	`FbN	
		if( (rand()%2) == 0 )	Ex = m_Font[i].GetEx()->x + rand()*(5+1)/RAND_MAX%(5+1);
		else					Ex = m_Font[i].GetEx()->x - rand()*(5+1)/RAND_MAX%(5+1);
		
		if( m_iSelect*2 == i || (m_iSelect*2+1) == i ){
			if( Ex > SELECT_MAX_EX )	Ex = SELECT_MAX_EX;
			if( Ex < 0 )				Ex = 0;
		}else{
			if( Ex > FONT_EX_LEFT+SELECT_MAX_EX )	Ex = FONT_EX_LEFT+SELECT_MAX_EX;
			if( Ex < FONT_EX_LEFT )					Ex = FONT_EX_LEFT;
		}
		m_fFontEx[i] = (Ex-m_Font[i].GetEx()->x)/FONT_EX_TIME;
		if( i == m_iSelect*2 || i == (m_iSelect*2+1) ){
			m_Font[i].SetMoveSize	(FONT_MOVE_SIZE);
			m_Font[i].SetMoveFrame	(FONT_MOVE_FRAME);
			m_FontB[i].SetMoveSize	(FONT_MOVE_SIZE);
			m_FontB[i].SetMoveFrame	(FONT_MOVE_FRAME);
		}else{
			m_Font[i].SetMoveSize	(FONT_MOVE_SIZE2);
			m_Font[i].SetMoveFrame	(FONT_MOVE_FRAME2);
			m_FontB[i].SetMoveSize	(FONT_MOVE_SIZE2);
			m_FontB[i].SetMoveFrame	(FONT_MOVE_FRAME2);
		}
	}
	
	//	̕TCYZbg	---------------------------------------
	for( i = 0; i < SELECT_FONT_NUM_MAX; i++ ){
		if( (rand()%2) == 0 )	m_fOneFontEx[i] = rand()*(5+1)/RAND_MAX%(5+1); 
		else					m_fOneFontEx[i] = -rand()*(5+1)/RAND_MAX%(5+1);
	}
	
	int num=0;
	for( i = DEATH_EX_NUM; i < DEATH_SELECT_NUM; i++ ){
		f32* pFontEx = m_Font[i].GetOneEx();
		for( int j = 0; j < m_Font[i].GetFontNum(); j++ ){
			if( (pFontEx[j] + m_fOneFontEx[num]) > SELECT_MAX_EX ){
				m_fOneFontEx[num] = -SELECT_MAX_EX*0.5f;
			}else if( (pFontEx[j] + m_fOneFontEx[num]) < -SELECT_MAX_EX ){
				m_fOneFontEx[num] = SELECT_MAX_EX*0.5f;
			}
			num++;
		}
	}
	m_iExTime = 0;
}

//========================================================================
//					tHg̃TCYύX
//========================================================================
void		SK7Death::MoveSelectEx()
{
	int i;
	for( i = 0; i < 4; i++ ){
		m_Font[i].SetEx( m_Font[i].GetEx()->x + m_fFontEx[i], m_Font[i].GetEx()->y + m_fFontEx[i] );
	}
	int num=0;
	for( i = DEATH_EX_NUM; i < DEATH_SELECT_NUM; i++ ){
		f32* pFontEx = m_Font[i].GetOneEx();
		for( int j = 0; j < m_Font[i].GetFontNum(); j++ ){
			pFontEx[j] += m_fOneFontEx[num]/FONT_EX_TIME;
			num++;
		}
	}
	if( ++m_iExTime >= FONT_EX_TIME ){
		SetSelectEx();
	}
}


//========================================================================
//					nl̃Zbg
//========================================================================
void		SK7Death::SetSelectHane()
{
	//	tg	:::::::::::::::::::::::::::::::::::::::::::::::::
	f32 XX = m_Font[m_iSelect*2].GetOnePos(0)->x + m_Font[m_iSelect*2].GetPos()->x + m_Font[m_iSelect*2].GetEx()->x*0.5f;
	f32 YY = m_Font[m_iSelect*2].GetOnePos(0)->y + m_Font[m_iSelect*2].GetPos()->y + m_Font[m_iSelect*2].GetEx()->y*0.5f;

	VEC2 v;
	//	e[u擾	:::::::::::::::::::::::::::::::::::::::::::::
	const VEC2* pTable = 	tblHaneAll[m_iSelect];
	
	for( int i = 0; i < HANE_NUM; i++ ){
		if( m_FHane[i].bMoveFlag ){
			if( ++m_FHane[i].iHaneTime >= FONT_HANE_SPEED*2 ){	//	߂̏I
				m_FHane[i].bMoveFlag = false;					//	ړI					
				m_FHane[i].spHane.SetVisible( false );
			}else{
				v.x = (pTable[i*3+2].x-pTable[i*3+1].x)/FONT_HANE_SPEED;
				v.y = (pTable[i*3+2].y-pTable[i*3+1].y)/FONT_HANE_SPEED;
				if( m_FHane[i].iHaneTime > FONT_HANE_SPEED ){
					v.x = -v.x;
					v.y = -v.y;
				}
			}
			m_FHane[i].spHane.SetTriangle( 	XX+pTable[i*3].x, 		YY+pTable[i*3].y, 
											XX+pTable[i*3+1].x, 	YY+pTable[i*3+1].y, 
											m_FHane[i].spHane.GetX2()+v.x, m_FHane[i].spHane.GetY2()+v.y,
											0xffffffff );
		}else{
			m_FHane[i].spHane.SetVisible( false );
		}
	}

	//	obN	:::::::::::::::::::::::::::::::::::::::::::::::::
	XX = m_Font[m_iSelect*2+1].GetOnePos(0)->x + m_Font[m_iSelect*2+1].GetPos()->x + m_Font[m_iSelect*2+1].GetEx()->x*0.5f;
	YY = m_Font[m_iSelect*2+1].GetOnePos(0)->y + m_Font[m_iSelect*2+1].GetPos()->y + m_Font[m_iSelect*2+1].GetEx()->y*0.5f;

	for( int i = 0; i < HANE_NUM; i++ ){
		if( m_BHane[i].bMoveFlag ){
			if( ++m_BHane[i].iHaneTime >= FONT_HANE_SPEED*2 ){	//	߂̏I
				m_BHane[i].bMoveFlag = false;					//	ړI					
				m_BHane[i].spHane.SetVisible( false );
			}else{
				v.x = (tblGekiHane[i*3+2].x-tblGekiHane[i*3+1].x)/FONT_HANE_SPEED;
				v.y = (tblGekiHane[i*3+2].y-tblGekiHane[i*3+1].y)/FONT_HANE_SPEED;
				if( m_BHane[i].iHaneTime > FONT_HANE_SPEED ){
					v.x = -v.x;
					v.y = -v.y;
				}
			}
			m_BHane[i].spHane.SetTriangle( 	XX+tblGekiHane[i*3].x, 		YY+tblGekiHane[i*3].y, 
											XX+tblGekiHane[i*3+1].x, 	YY+tblGekiHane[i*3+1].y, 
											m_BHane[i].spHane.GetX2()+v.x, m_BHane[i].spHane.GetY2()+v.y,
											0xffffffff );
		}else{
			m_BHane[i].spHane.SetVisible( false );
		}
	}
}

//========================================================================
//					nl̏
//========================================================================
void		SK7Death::SetHaneState()
{
	//	tg	:::::::::::::::::::::::::::::::::::::::::::::::::
	f32 XX = m_Font[m_iSelect*2].GetOnePos(0)->x + m_Font[m_iSelect*2].GetPos()->x + m_Font[m_iSelect*2].GetEx()->x*0.5f;
	f32 YY = m_Font[m_iSelect*2].GetOnePos(0)->y + m_Font[m_iSelect*2].GetPos()->y + m_Font[m_iSelect*2].GetEx()->y*0.5f;

	//	e[u擾	:::::::::::::::::::::::::::::::::::::::::::::
	const VEC2* pTable = 	tblHaneAll[m_iSelect];
	//	nl̏	----------------------------------------
	for( int i = 0; i < HANE_NUM; i++ ){
		if( !m_FHane[i].bMoveFlag ){
			if( ++m_FHane[i].iMoveTime > m_FHane[i].iSetTime ){
				m_FHane[i].iMoveTime 	= 0;
				m_FHane[i].iHaneTime	= 0;
				m_FHane[i].iSetTime 	= rand()%10;
				m_FHane[i].bMoveFlag 	= true;
				m_FHane[i].spHane.SetVisible	( true );
				m_FHane[i].spHane.SetTriangle	( 	XX+pTable[i*3].x, 		YY+pTable[i*3].y, 
													XX+pTable[i*3+1].x, 	YY+pTable[i*3+1].y, 
													XX+pTable[i*3+1].x,		YY+pTable[i*3+1].y,
													0xffffffff );
			}
		}
	}

	//	obN	:::::::::::::::::::::::::::::::::::::::::::::::::
	XX = m_Font[m_iSelect*2+1].GetOnePos(0)->x + m_Font[m_iSelect*2+1].GetPos()->x + m_Font[m_iSelect*2+1].GetEx()->x*0.5f;
	YY = m_Font[m_iSelect*2+1].GetOnePos(0)->y + m_Font[m_iSelect*2+1].GetPos()->y + m_Font[m_iSelect*2+1].GetEx()->y*0.5f;

	//	nl̏	----------------------------------------
	for( int i = 0; i < HANE_NUM; i++ ){
		if( !m_BHane[i].bMoveFlag ){
			if( ++m_BHane[i].iMoveTime > m_BHane[i].iSetTime ){
				m_BHane[i].iMoveTime 	= 0;
				m_BHane[i].iHaneTime	= 0;
				m_BHane[i].iSetTime 	= rand()%10;
				m_BHane[i].bMoveFlag 	= true;
				m_BHane[i].spHane.SetVisible( true );
				m_BHane[i].spHane.SetTriangle( 	XX+tblGekiHane[i*3].x, 		YY+tblGekiHane[i*3].y, 
												XX+tblGekiHane[i*3+1].x, 	YY+tblGekiHane[i*3+1].y, 
												XX+tblGekiHane[i*3+1].x,	YY+tblGekiHane[i*3+1].y,
												0xffffffff );
			}
		}
	}
}

//========================================================================
//					nl̏
//========================================================================
void		SK7Death::InitHane()
{
	f32 XX = m_Font[m_iSelect*2].GetOnePos(0)->x + m_Font[m_iSelect*2].GetPos()->x + m_Font[m_iSelect*2].GetEx()->x*0.5f;
	f32 YY = m_Font[m_iSelect*2].GetOnePos(0)->y + m_Font[m_iSelect*2].GetPos()->y + m_Font[m_iSelect*2].GetEx()->y*0.5f;
	//	e[u擾	:::::::::::::::::::::::::::::::::::::::::::::
	const VEC2* pTable = 	tblHaneAll[m_iSelect];

	for( int i = 0; i < HANE_NUM; i++ ){
		m_FHane[i].spHane.SetVisible( false );
		m_FHane[i].iMoveTime = 0;
		m_FHane[i].iHaneTime = 0;
		m_FHane[i].iSetTime  = rand()%10;
		m_FHane[i].bMoveFlag = false;
		m_FHane[i].spHane.SetTriangle( 	XX+pTable[i*3].x, 		YY+pTable[i*3].y, 
										XX+pTable[i*3+1].x, 	YY+pTable[i*3+1].y, 
										XX+pTable[i*3+1].x,		YY+pTable[i*3+1].y,
										0xffffffff );
	}
	//	obN	:::::::::::::::::::::::::::::::::::::::::::::::::
	XX = m_Font[m_iSelect*2+1].GetOnePos(0)->x + m_Font[m_iSelect*2+1].GetPos()->x + m_Font[m_iSelect*2+1].GetEx()->x*0.5f;
	YY = m_Font[m_iSelect*2+1].GetOnePos(0)->y + m_Font[m_iSelect*2+1].GetPos()->y + m_Font[m_iSelect*2+1].GetEx()->y*0.5f;
	
	for( int i = 0; i < HANE_NUM; i++ ){
		m_BHane[i].spHane.SetVisible( false );
		m_BHane[i].iMoveTime = 0;
		m_BHane[i].iHaneTime = 0;
		m_BHane[i].iSetTime  = rand()%10;
		m_BHane[i].bMoveFlag = false;
		m_BHane[i].spHane.SetTriangle( 	XX+tblGekiHane[i*3].x, 		YY+tblGekiHane[i*3].y, 
										XX+tblGekiHane[i*3+1].x, 	YY+tblGekiHane[i*3+1].y, 
										XX+tblGekiHane[i*3+1].x,	YY+tblGekiHane[i*3+1].y,
										0xffffffff );
	}
	
}

