////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7EndSaveTask.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/18/2003
//	
////////////////////////////////////////////////////////////////////////////////

#define	__SK7ENDSAVETASK_CPP__

#include "..\Lib\ghmGcFile.h"
#include "../wat/WK7MainTask.h"
#include "SK7EndSaveTask.h"
#include "..\Matsu\mK7Sound.h"
//#include "SK7SaveLoad.h"
#include "SK7SaveLoadMessage.h"
#include "SK7ScenarioTask.h"
#include "SK7LogoTask.h"

SK7SaveData* 	g_pSaveData=NULL;

#define		FADE_SPEED				(WK7_SEC_TO_TICK(0.9f))

//========================================================================
//					RXgN^
//========================================================================
SK7EndSaveTask::SK7EndSaveTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	m_eProc 	= eLoad;
	m_eLoad 	= eSaveLoad;
	m_pSaveLoad = NULL;

	m_pTaskControl = new ghmGcTaskController;
	m_pTaskControl->Initialize();
	EffectInit( m_pTaskControl, 200 );
	screenImageFullColor.SetFormat(GX_TF_RGBA8);
	screenImageFullColor.AllocBuffer();
}


//========================================================================
//					fXgN^
//========================================================================
SK7EndSaveTask::~SK7EndSaveTask()
{
}


//========================================================================
//					
//========================================================================
bool 	SK7EndSaveTask::InitializeCallBack(void)
{
	m_pSaveLoad = SK7SaveBase::Create( eBaseSaveEnd );//new SK7SaveLoad( SAVE_STATE_ENDSAVE );
	
	SK7SaveData* pSave = m_pSaveLoad->GetSaveData();
	memcpy( pSave, g_pSaveData, sizeof( SK7SaveData ) );
		
	k7app.SetFadeColor(0x000000ff);	
	return true;
}


//========================================================================
//					I
//========================================================================
bool 	SK7EndSaveTask::TerminateCallBack(void)
{	
	GHM_SAFE_DELETE( g_pSaveData );
	GHM_SAFE_DELETE( m_pSaveLoad );
	EffectEnd();
	GHM_SAFE_DELETE(m_pTaskControl);
	screenImageFullColor.FreeBuffer();

 	ghmGcApp *pApp = GetApplication();
	delete this;
	k7app.SetFadeColor(0x00000000);
	k7app.FadeStart(0xff,0);
	
	if( GameInfo.GetScenarioID() == 6 ){
		new SK7LogoTask(pApp);
	}else{
		new SK7ScenarioTask(pApp);
	}

	return true;
} 


//========================================================================
//					t[
//========================================================================
bool 	SK7EndSaveTask::FrameProcess(void)
{ 
	switch( m_eProc ){
	case eLoad:
		if( Load() ){
			m_bRender = true; 
			m_pSaveLoad->SetRender(true);
			k7app.FadeStart(0x00,FADE_SPEED);			//	CtF[h
			m_eProc = eFade;
		}
		break;
	case eFade:
		if( !k7app.IsFade() ){
			m_pSaveLoad->SetCtrlFlag(true);
			m_eProc = eMain;
		}
		break;
	case eMain:
		if( m_pSaveLoad->GetMenuEnd() ){
			k7app.FadeStart(0xff,FADE_SPEED);			//	CtF[h
			m_eProc = eEnd;
		}
		break;
	case eEnd:
		if( !k7app.IsFade() ){
			if( DeleteTerminate()==true ){
				return true;
			}
		}
		break;
	}
	m_pSaveLoad->FrameProcess();
	SetEffectCamera(WK7CAM->GetCObj());
	WK7Archive::FrameProcessAll();
	return true;
}



//========================================================================
//					_O
//========================================================================
bool 	SK7EndSaveTask::RenderProcess(void)
{
	if( m_pSaveLoad )	m_pSaveLoad->RenderProcess();
	m_pTaskControl->FrameProcess();
	return true;
}


//========================================================================
//					[h
//========================================================================
bool	SK7EndSaveTask::Load()
{
	switch( m_eLoad ){
	case eSaveLoad:
		if( m_pSaveLoad->GetFileReadEnd() ){
			m_eLoad = eEffect;
		}
		break;
		
	case eEffect:
		if( EffectSetupCheck() == TRUE ){
			return true;
		}
		break;
	}
	return false;
}

