////////////////////////////////////////////////////////////////////////////////
//
// Killer7 FirstCheck
//
// SK7FirstCheck.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/12/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7FIRSTCHECK_CPP__

#include <limits.h>
#include "SK7FirstCheck.h"
#include "../matsu/mK7Sound.h"
#include "../wat/K7GlobalFlag.h"

#define		CARD_CHECK_TIME			(50)
#define		CARD_CHECK_TIME2		(10)
#define		MESSAGE_DRAW_TIME		(30)

//extern
bool	g_bFirstGameCheck = false;

//========================================================================
//					RXgN^
//========================================================================
SK7FirstCheck::SK7FirstCheck( s8 State )
{
	m_chState 		= State;
	m_bSlotInFlag	= false;
	m_iTime			= 0;
	m_iMessageTime	= 0;
	m_bSlotAOkFlag	= false;
	m_bCheckBFlag	= false;
	SetMessage( CERROR_CHECK_CHECK );
	m_eProc			= eProcFirst;
}

//========================================================================
//					fXgN^
//========================================================================
SK7FirstCheck::~SK7FirstCheck()
{
	g_bFirstGameCheck = true;
}

//========================================================================
//					t[vZX
//========================================================================
bool 	SK7FirstCheck::FrameProcess(void)
{
	if( !m_bCtrl )	return false;
	
	if( m_eProc == eProcEnd )	return true;

	//	ŏ̎
	if( m_eProc == eProcFirst ){
		if( ++m_iTime > CARD_CHECK_TIME2 ){
			m_iTime = 0;
			m_eProc = eProcSetMound;
		}
		return true;
	}
	
	//----------------	J[h}`FbN	----------------------//
	switch( CheckCardInsert() ){
	case MEMORYCARD_RETCODE_TRUE:
		if( !GetSectorSize(m_chSlotNo) ){
			SetMessage( CERROR_CHECK_BREAK );
			m_eProc = eProcMessage;
			break;
		}
		if( GetMesNo() != CERROR_CHECK_NOSLOT && !m_bSlotInFlag ) m_eProc = eProcSetMound;
		break;
		
	case MEMORYCARD_RETCODE_FALSE:
	case MEMORYCARD_RETCODE_NOTCARD:
		m_eProc = eProcMessage;
		break;
	case MEMORYCARD_RETCODE_BUSY:	
		return true;
	}
		
	//----------------	C	----------------------//
	switch( m_eProc ){
	case eProcSetMound:		
		SetMessage	( CERROR_CHECK_CHECK );
		CreateCard();
		SetCardMount( m_chSlotNo );
		m_bSlotInFlag = true;
		m_eProc = eProcCheckMount;
		return true;
	case eProcMessage:		FrameMessageKey();		return true;
	case eProcCheckMount:	CheckMount();			return true;
	case eProcFileCheck:	CheckFileCheck();		return true;
	case eProcHopperCheck:	CheckHopperFlag();		return true;
	case eProcEreaCheck:	
		if( m_chState == CHECK_STATE_FIRST ){
			CheckFileErea();
		}else{
			CheckFileErea2();
		}
		return true;
	case eProcInit:			CheckInitCard();		return true;
	case eProcEnd:			return true;
	}
	return true;
}

//========================================================================
//					_[vZX
//========================================================================
bool 	SK7FirstCheck::RenderProcess(void)
{
	if( !m_bRender )	return false;
	
	//----------------	Xbg`J[h`FbN	------------------------//
	if( m_bSlotAOkFlag && m_chSlotNo == CARD_SLOT_B && m_eProc == eProcMessage ){
		InitCheck();
	}
	RenderFontFirst( (s8)m_chSlotNo, m_chSelect, m_chState );		//	tHg`
	return true;
}

//========================================================================
//					I`FbN
//========================================================================
bool 	SK7FirstCheck::GetMenuEnd(void)
{ 
	if( m_eProc == eProcEnd ){
		return true;
	}
	return false;
}		
	
//========================================================================
//					bZ[WΉ
//========================================================================
bool 	SK7FirstCheck::FrameMessageKey(void)
{
	u8 MesNo = GetMesNo();

	//IbZ[W
	if( MesNo == CERROR_CHECK_INIT_OK && ++m_iMessageTime > MESSAGE_DRAW_TIME ){
		InitCheck();
		return true;
	}
	if( CheckKeyT( SK7_KEY_UP ) ){
		if( --m_chSelect < 0 )	m_chSelect = 0;
		return false;
	}
	if( CheckKeyT( SK7_KEY_DOWN ) ){
		s8 Num = (s8)(GetSelectNum()-1);
		if( ++m_chSelect > Num ){
			m_chSelect = Num;
		}
		return false;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		switch( m_chSelect ){
		case 0:					//	̂܂܎n߂
			switch( MesNo ){
			case CERROR_CHECK_INIT:			
			case CERROR_CHECK_BREAK:		
			case CERROR_CHECK_SIZE:
			case CERROR_CHECK_NOSLOT:		
			case CERROR_CHECK_NOTCARD:
			case CERROR_CHECK_INIT_MISS:
				SetCardUnMount ( m_chSlotNo );	
				DeleteCard();
				m_eProc = eProcEnd;
				return true;
			case CERROR_CHECK_INIT_OK:
				InitCheck();
				return true;
			case CERROR_CHECK_INIT_CHECK:
				SetCardFormat( m_chSlotNo );
				SetMessage( CERROR_INIT_CHECK );
				m_eProc = eProcInit;
				return true;
			}
			break;

		case 1:					//	J[h`FW
			switch( MesNo ){
			case CERROR_CHECK_INIT:
			case CERROR_CHECK_BREAK:		
			case CERROR_CHECK_SIZE:
			case CERROR_CHECK_NOSLOT:		
			case CERROR_CHECK_NOTCARD:
			case CERROR_CHECK_INIT_MISS:
			case CERROR_CHECK_NO_INIT:
				InitCheck();
				return true;
			case CERROR_CHECK_INIT_OK:
				InitCheck();
				return true;
			case CERROR_CHECK_INIT_CHECK:
				InitCheck();
//				SetMessage	( CERROR_CHECK_INIT, m_chSelect );				
//				m_chSelect = 0;
				return true;
			}
			break;
			
		case 2:
			switch( MesNo ){
			case CERROR_CHECK_INIT:
				SetMessage	( CERROR_CHECK_INIT_CHECK, 1 );				
				return true;
				
			case CERROR_CHECK_SIZE:
				SetCardUnMount ( m_chSlotNo );	
				DeleteCard();
				OSResetSystem( OS_RESET_HOTRESET, 0, TRUE);	
				m_eProc = eProcEnd;
				return true;
			case CARD_SELECT_BREAK:
				return true;
			}
			break;				
		}
		return true;
	}
	return false;
}

//========================================================================
//					J[h}`FbN
//========================================================================
s8 		SK7FirstCheck::CheckCardInsert(void)
{
	s32 retcodeA = GetCardInsert( CARD_SLOT_A );
	s32 retcodeB = GetCardInsert( CARD_SLOT_B );

	//	`XbĝnjmF
	if( m_bSlotAOkFlag && retcodeA != CARD_RESULT_READY ){
		m_bSlotAOkFlag = false;
	}
	//	aXbgʂꂽII
	if( m_bCheckBFlag && retcodeB == CARD_RESULT_NOCARD && !m_bSlotAOkFlag ){
		m_bCheckBFlag = false;
	}
	//	J[hꂽ	
	if( m_bSlotInFlag ){
		if( (m_chSlotNo == CARD_SLOT_A && retcodeA == CARD_RESULT_NOCARD ) ||
			(m_chSlotNo == CARD_SLOT_B && retcodeB == CARD_RESULT_NOCARD ) )
		{
			m_bSlotInFlag = false;
			m_chSelect = 0;
		}
	}
	
	if( !m_bCheckBFlag ){
		switch( retcodeA ){
		case CARD_RESULT_READY:
			m_chSlotNo = CARD_SLOT_A;
			return MEMORYCARD_RETCODE_TRUE;
			
		case CARD_RESULT_NOCARD:
			if( GetMesNo() == CERROR_CHECK_NOSLOT ){
				return MEMORYCARD_RETCODE_NOTCARD;
			}
			if( m_chSlotNo == CARD_SLOT_A ){
				InitCheck();
			}
			m_bCheckBFlag 	= true;
			m_chSlotNo = CARD_SLOT_B;
			switch( retcodeB ){
			case CARD_RESULT_READY:
				SetMessage		( CERROR_CHECK_NOSLOT );
				return MEMORYCARD_RETCODE_TRUE;
			case CARD_RESULT_BUSY:
				return MEMORYCARD_RETCODE_BUSY;
			case CARD_RESULT_NOCARD:
				SetMessage( CERROR_CHECK_NOSLOT, m_chSelect );
				return MEMORYCARD_RETCODE_FALSE;
			case CARD_RESULT_WRONGDEVICE:
				if( GetMesNo() == CERROR_CHECK_NOSLOT )	return MEMORYCARD_RETCODE_FALSE;
				SetMessage( CERROR_CHECK_NOTCARD, m_chSelect );
				return MEMORYCARD_RETCODE_NOTCARD;					
			default:
				SetMessage( CERROR_CHECK_BREAK, m_chSelect );
				return MEMORYCARD_RETCODE_FALSE;
			}
			break;
			
		case CARD_RESULT_BUSY:
			return MEMORYCARD_RETCODE_BUSY;
			
		default:
			m_chSlotNo = CARD_SLOT_A;
			if( retcodeA == CARD_RESULT_WRONGDEVICE ){
				if( GetMesNo() == CERROR_CHECK_NOSLOT )	return MEMORYCARD_RETCODE_FALSE;
				SetMessage( CERROR_CHECK_NOTCARD, m_chSelect );
				return MEMORYCARD_RETCODE_NOTCARD;
			}else{
				SetMessage( CERROR_CHECK_BREAK, m_chSelect );
			}
			return MEMORYCARD_RETCODE_FALSE;
		}	
	}else{
		m_bCheckBFlag 	= true;
		m_chSlotNo 		= CARD_SLOT_B;
		if( retcodeA == CARD_RESULT_BUSY )	return MEMORYCARD_RETCODE_BUSY;
		if( !(retcodeB == CARD_RESULT_READY || retcodeB == CARD_RESULT_BUSY) ){
			if( m_bSlotAOkFlag ){
				m_eProc = eProcEnd;
				SetCardUnMount( m_chSlotNo );	
				DeleteCard();
				return MEMORYCARD_RETCODE_BUSY;
			}
		}
		switch( retcodeB ){
		case CARD_RESULT_READY:
			return MEMORYCARD_RETCODE_TRUE;
		case CARD_RESULT_BUSY:
			return MEMORYCARD_RETCODE_BUSY;
		case CARD_RESULT_NOCARD:
			SetMessage( CERROR_CHECK_NOSLOT, m_chSelect );
			return MEMORYCARD_RETCODE_FALSE;
		case CARD_RESULT_WRONGDEVICE:
			if( GetMesNo() == CERROR_CHECK_NOSLOT )	return MEMORYCARD_RETCODE_FALSE;
			SetMessage( CERROR_CHECK_NOTCARD, m_chSelect );
			return MEMORYCARD_RETCODE_NOTCARD;
		default:
			SetMessage( CERROR_CHECK_BREAK, m_chSelect );
			return MEMORYCARD_RETCODE_FALSE;
		}
		SetCardUnMount( m_chSlotNo );	
		DeleteCard();
		m_chSlotNo 		= CARD_SLOT_A;
		m_bCheckBFlag 	= false;
		m_eProc 		= eProcSetMound;
		return MEMORYCARD_RETCODE_BUSY;
	}
	return MEMORYCARD_RETCODE_BUSY;
}

//========================================================================
//				}Egʃ`FbN
//========================================================================
void		SK7FirstCheck::CheckMount()
{
	switch( CARDGetResultCode( m_chSlotNo ) ){
	case CARD_RESULT_BUSY:	return;
	case CARD_RESULT_BROKEN:
	case CARD_RESULT_READY:
		SetCardCheck( m_chSlotNo );
		m_eProc = eProcFileCheck;
		return;
	case CARD_RESULT_ENCODING:		SetMessage( CERROR_CHECK_INIT );	break;
	case CARD_RESULT_WRONGDEVICE:	SetMessage( CERROR_CHECK_NOTCARD );	break;
	case CARD_RESULT_NOCARD:		InitCheck(); return;
	case CARD_RESULT_FATAL_ERROR:	
	case CARD_RESULT_IOERROR:		SetMessage( CERROR_CHECK_BREAK );	break;
	}
	if( m_chSlotNo == CARD_SLOT_B && m_bSlotAOkFlag ){
		SetMessage( CERROR_MES_NONE );
		m_eProc = eProcEnd;
	}else{
		m_eProc = eProcMessage;
	}
}

//========================================================================
//				t@CCʃ`FbN
//========================================================================
void		SK7FirstCheck::CheckFileCheck()
{
	switch( CARDGetResultCode(m_chSlotNo) ){
	case CARD_RESULT_BUSY:			return;
	case CARD_RESULT_READY:			
		if( m_chState == CHECK_STATE_FIRST ){
			m_eProc = eProcHopperCheck;
		}else{
			m_eProc = eProcEreaCheck;
		}
		return;
	case CARD_RESULT_NOCARD:		InitCheck(); return;
	case CARD_RESULT_BROKEN:		
	case CARD_RESULT_ENCODING:		SetMessage( CERROR_CHECK_INIT );	break;
	case CARD_RESULT_FATAL_ERROR:
	case CARD_RESULT_IOERROR:		SetMessage( CERROR_CHECK_BREAK );	break;
	}
	if( m_chSlotNo == CARD_SLOT_B && m_bSlotAOkFlag ){
		SetMessage( CERROR_MES_NONE );
		m_eProc = eProcEnd;
	}else{
		m_eProc = eProcMessage;
	}
}

//========================================================================
//				t@CGA`FbN
//========================================================================
void		SK7FirstCheck::CheckFileErea2()
{
	//	f[^邩ǂ
	if( CheckKillerData() ){
		m_eProc = eProcEnd;
		SetCardUnMount	( m_chSlotNo );
		DeleteCard();
		return;
	}
	//̈`FbN
	if( GetCardErea( m_chSlotNo, SAVEDATA_SIZE ) ){
		SetCardUnMount	( m_chSlotNo );
		DeleteCard();
		m_eProc = eProcEnd;
		return;
	}else{
		SetCardUnMount	( m_chSlotNo );
		DeleteCard();
		SetMessage( CERROR_CHECK_SIZE );
		m_eProc = eProcMessage;
	}
}

//========================================================================
//				t@CGA`FbN
//========================================================================
void		SK7FirstCheck::CheckHopperFlag()
{
	switch( CheckHopper7() ){
	case DATA_IS_BUSY:	return;
	case DATA_IS_TRUE:
		m_chReadNo		= 0;
		CheckKillerData();
		GHM_SAFE_DELETE_ARRAY( m_pSavedData );
		m_eProc 		= eProcEreaCheck;
		return;
	}
}

//========================================================================
//				t@CGA`FbN
//========================================================================
void		SK7FirstCheck::CheckFileErea()
{	
	//	f[^`FbN	
	switch( CheckKiller8() ){
	case DATA_IS_NONE: break;
	case DATA_IS_BUSY: return;
	case DATA_IS_TRUE:
		m_chSavedFlag 	= 0;
		m_chReadNo		= 0;
		if( m_chSlotNo == CARD_SLOT_A ){
			m_bSlotAOkFlag = true;
		}
		GHM_SAFE_DELETE_ARRAY( m_pSavedData );
		SetCardUnMount		 ( m_chSlotNo );	
		DeleteCard();
		if( m_chSlotNo == CARD_SLOT_B ){
			m_eProc = eProcEnd;
		}else{
			m_bCheckBFlag	= true;
			m_chSlotNo		= CARD_SLOT_B;
			m_eProc 		= eProcSetMound;
		}
		return;
	}

	//̈`FbN
	if( GetCardErea( m_chSlotNo, SAVEDATA_SIZE ) ){
		SetCardUnMount	( m_chSlotNo );
		DeleteCard();
		if( m_chSlotNo == CARD_SLOT_A ){
			m_bSlotAOkFlag 	= true;
			m_chSlotNo 		= CARD_SLOT_B;
			m_bCheckBFlag	= true;
			m_eProc = eProcSetMound;
		}else{
			m_eProc = eProcEnd;
		}
	}else{
		SetCardUnMount		 ( m_chSlotNo );
		DeleteCard();
		if( m_bSlotAOkFlag ){
			m_eProc = eProcEnd;
		}else{
			SetMessage( CERROR_CHECK_SIZE );
			m_eProc = eProcMessage;
		}
	}
}

//========================================================================
//				L[tO`FbN
//========================================================================
bool			SK7FirstCheck::CheckKillerData()
{
	int i,j;
	char FileName[32];
	CARDStat cardstat;
	bool flag = false;

	for( i = 0; i < SAVE_DATA_NUM; i++ ){
		InitCardInfo();
		sprintf( FileName, "%s_%d", SAVE_FILE_NAME8, i );
		for( j = 0; j < 127; j++ ){
			memset( &cardstat, 0, sizeof( CARDStat ) );
			CARDGetStatus( m_chSlotNo, j, &cardstat );
			//	ʕ҃`FbN	---------------------------------
			if( strcmp( cardstat.fileName, FileName )==0 ){
				if( m_chState == CHECK_STATE_FIRST ){
					K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR );
				}
				return true;
			}
#if 0
			if( strcmp( cardstat.fileName, FileName2 )==0 ){
				if( m_chState == CHECK_STATE_FIRST ){
					K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR );
					K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR_K8 );
				}
				return true;
			}
#endif
		}
	}
	return false;
}

//========================================================================
//				CheckHopper7
//========================================================================
s8				SK7FirstCheck::CheckHopper7()
{
	char FileName[32];
	CARDStat cardstat;

	switch( m_chEnumNo ){
	case 0:
		for( int i = m_chReadNo; i < SAVE_DATA_NUM; i++ ){
			InitCardInfo();
			sprintf( FileName, "%s_%d", SAVE_FILE_NAME8, i );
			for( int j = 0; j < 127; j++ ){
				memset( &cardstat, 0, sizeof( CARDStat ) );
				CARDGetStatus( m_chSlotNo, j, &cardstat );
#if 0
				//	zbp[7`FbN	--------------------------------
				if( strcmp( cardstat.fileName, FileName2 )==0 ){	//	zbp[V̏㏑f[^
					K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR_K8 );
					m_chReadNo = (s8)i;
					m_chEnumNo = 0;
					return DATA_IS_TRUE;
				}
#endif
				//	L[8`FbN	---------------------------------
				if( strcmp( cardstat.fileName, FileName )==0 ){	//	L[8̏㏑f[^
					if( SetCardOpen( m_chSlotNo, FileName ) == CARD_RESULT_READY ){
						K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR );
						GHM_SAFE_DELETE_ARRAY( m_pSavedData );
						ghmGcMemSetAllocName("SAVELOADRE");
						m_pSavedData = new byte[CARD_READ_SIZE]; 
						m_chReadNo = (s8)i;
						SetCardRead( m_pSavedData, CARD_READ_SIZE, CARD_READ_SIZE*16 );
						m_chEnumNo = 1;
						return DATA_IS_BUSY;
					}
				}
			}
		}
		GHM_SAFE_DELETE_ARRAY( m_pSavedData );
		return DATA_IS_TRUE;

	case 1:
		switch( CARDGetResultCode(m_chSlotNo) ){
		case CARD_RESULT_READY:
			char FileFlagWord[32];
			memset( FileFlagWord, '\0', 32 );
			memcpy( FileFlagWord, ((byte*)m_pSavedData+70), DATACHECK_WORD_NUM );
			if( strcmp( FileFlagWord, KILLERH_COMMENT )==0  ){
				K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR_K8 );
				SetCardClose();
				m_chEnumNo=0;
				return DATA_IS_TRUE;
			}
			m_chReadNo++;
			m_chEnumNo=0;
			break;
		case CARD_RESULT_BUSY:		return DATA_IS_BUSY;
		default:
			GHM_SAFE_DELETE_ARRAY( m_pSavedData );
			SetCardClose();
			m_chReadNo++;
			m_chEnumNo=0;
			break;
		}
		break;
	}
	return DATA_IS_BUSY;
}

//========================================================================
//				Killer8Check
//========================================================================
s8			SK7FirstCheck::CheckKiller8()
{
	char FileName[32];
	CARDStat cardstat;

	switch( m_chEnumNo ){
	case 0:
		for( int i = m_chReadNo; i < SAVE_DATA_NUM; i++ ){
			InitCardInfo();
			sprintf( FileName, "%s_%d", SAVE_FILE_NAME, i );
			for( int j = 0; j < 127; j++ ){
				memset( &cardstat, 0, sizeof( CARDStat ) );
				CARDGetStatus( m_chSlotNo, j, &cardstat );
				//	L[V`FbN	---------------------------------
				if( strcmp( cardstat.fileName, FileName )==0 ){	//	L[V̏㏑f[^
					if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR )==true && m_chSavedFlag != 0 ){
						return DATA_IS_TRUE;			
					}else if( SetCardOpen( m_chSlotNo, FileName ) == CARD_RESULT_READY ){
						ghmGcMemSetAllocName("SAVELOADRE");
						GHM_SAFE_DELETE_ARRAY( m_pSavedData );
						m_pSavedData = new byte[CARD_READ_SIZE]; 
						m_chReadNo = (s8)i;
						SetCardRead( m_pSavedData, CARD_READ_SIZE, CARD_READ_SIZE*16 );
						m_chSavedFlag |= (1<<j);						//	tOĂ
						m_chEnumNo = 1;
						return DATA_IS_BUSY;
					}
				}
			}
		}
		//	L[V݂̂̃`FbN	----------------------------------------
//		SetCardClose();
		if( m_chSavedFlag == 0 ){
			GHM_SAFE_DELETE_ARRAY( m_pSavedData );
			return DATA_IS_NONE;						//	tOĂ
		}else{
			return DATA_IS_TRUE;
		}
		return DATA_IS_BUSY;
		
	case 1:
		switch( CARDGetResultCode(m_chSlotNo) ){
		case CARD_RESULT_READY:
			char FileFlagWord[32];
			memset( FileFlagWord, '\0', 32 );
			memcpy( FileFlagWord, ((byte*)m_pSavedData+70), DATACHECK_WORD_NUM );
			//	zbp[V`FbN
			if( strcmp( FileFlagWord, KILLERH_COMMENT )==0  ){
				K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR_K8 );
				K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR );
				SetCardClose();
				m_chEnumNo=0;
				return DATA_IS_TRUE;
			}
			//	L[W`FbN
			if( strcmp( FileFlagWord, KILLER8_COMMENT )==0  ){
				K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR );
				SetCardClose();
				m_chEnumNo=0;
				return DATA_IS_TRUE;
			}
			m_chReadNo++;
			m_chEnumNo=0;
			break;
		case CARD_RESULT_BUSY:		return DATA_IS_BUSY;
		default:
			GHM_SAFE_DELETE_ARRAY( m_pSavedData );
			SetCardClose();
			m_chReadNo++;
			m_chEnumNo=0;
			break;
		}
		break;
	}
	return DATA_IS_BUSY;
}	


//========================================================================
//					
//========================================================================
void 		SK7FirstCheck::CheckInitCard(void)
{
	switch( CARDGetResultCode(m_chSlotNo) ){
	case CARD_RESULT_BUSY:			return;
	case CARD_RESULT_READY:			
		SetMessage( CERROR_CHECK_INIT_OK );
		m_chSelect = 0; 
		m_eProc = eProcMessage;
		return;
	case CARD_RESULT_NOCARD:		InitCheck();	return;//SetMessage( CERROR_CHECK_NOSLOT );		break;
	case CARD_RESULT_FATAL_ERROR:
	case CARD_RESULT_IOERROR:		SetMessage( CERROR_CHECK_INIT_MISS );	break;
	}
	SetCardUnMount( m_chSlotNo );
	DeleteCard();
	m_eProc = eProcMessage;
}

//========================================================================
//					`FbN
//========================================================================
void 		SK7FirstCheck::InitCheck(void)
{
	SetMessage		( CERROR_CHECK_CHECK );
	SetCardUnMount	( m_chSlotNo );	
	DeleteCard();
	m_chSlotNo 		= CARD_SLOT_A;
	m_bCheckBFlag 	= false;
	m_chSelect		= 0;
	m_chReadNo		= 0;
	m_iMessageTime 	= 0;
	m_bSlotInFlag	= false;
	m_bSlotAOkFlag	= false;
	m_eProc 		= eProcSetMound;
}

//========================================================================
//					I𐔎擾
//========================================================================
s8			SK7FirstCheck::GetSelectNum()
{
	int num=0;
	switch( GetMesNo() ){
	case CERROR_CHECK_INIT:			return 3;
	case CERROR_CHECK_SIZE:
		if( m_chState == CHECK_STATE_FIRST && !g_bFirstGameCheck ) 	return 3;
		else														return 2;
	case CERROR_CHECK_INIT_CHECK:
	case CERROR_CHECK_INIT_MISS:
	case CERROR_CHECK_BREAK:		
	case CERROR_CHECK_NOSLOT:		
	case CERROR_CHECK_NOTCARD:		return 2;
	}
	return 2;
}

