////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Font
//
// SK7Font.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7FONT_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "SK7Font.h"


//========================================================================
//					RXgN^
//========================================================================	 
SK7Font::SK7Font()
{
	m_FontData.m_Data			= NULL;
	m_FontData.m_SentenceDat	= NULL;
	m_FontData.m_FParam			= NULL;
	m_FontData.m_Tex.Header		= NULL;
	m_pfEx						= NULL;
	m_Color						= 0xffffffff;
	m_usFontNum					= 0;
	m_iMoveTime					= 0;
	m_ucLineNo					= 0;
	m_fSpaceSize				= 0.0f;
	m_lEffectFlag				= 0;
	m_fMoveSize					= SK7FONT_MOVE_R;
	m_iMoveFrame				= SK7FONT_MOVE_FRAME;
	m_lEffectFlag				|= FONT_EFC_RENDER;
	memset( &m_vStartPos, 	0, 	sizeof( VEC2 ));
	memset( &m_vExpan, 		0,	sizeof( VEC2 ));
	memset( &m_vOne, 		0,	sizeof( VEC2 ));
	memset( &m_vBetween, 	0,	sizeof( VEC2 ));
	memset( &m_vEffectMove, 0, 	sizeof( VEC2 )*SK7FONT_MAX_NUM);
	memset( &m_vBasePos,	0,	sizeof( VEC2 )*SK7FONT_MAX_NUM);
	memset( &m_vFontPos,	0,	sizeof( VEC2 )*SK7FONT_MAX_NUM);
}

//========================================================================
//					fXgN^
//========================================================================	 
SK7Font::~SK7Font()
{
	GHM_SAFE_DELETE_ARRAY( m_pfEx );
}

//========================================================================
//					fXgN^
//========================================================================	 
void		SK7Font::Release()
{
	GHM_SAFE_DELETE_ARRAY( m_pfEx );
}

//========================================================================
//					II擾֐
//========================================================================	 
bool  		SK7Font::LoadFont( char* FileName, u8 LineNo, u8 BlockNo )
{
	//	CZbg
	m_ucLineNo = LineNo;
	
	//	ubNZbg
	m_ucBlockNo = BlockNo;
	
	//	f[^ݒ
	if( m_File.OpenDataFile( FileName, &((void*)m_FontData.m_Data)))
	{
		//̓f[^ւ̃AhXݒ
		m_FontData.m_SentenceDat = (stOneSentence*)((char*)m_FontData.m_Data + m_FontData.m_Data->offset);
		//uvwhf[^ւ̃AhXݒ
		m_FontData.m_FParam = (stFontParam*)((char*)m_FontData.m_Data + m_FontData.m_Data->charOffset);
		//eNX`AhẌn
		m_FontData.m_Tex.Header = (GhmGcTexHeader*)((char*)m_FontData.m_Data + m_FontData.m_Data->texOffset);
		//eNX`̏
		InitTexture( &m_FontData.m_Tex );
		//tHgf[^쐬
		SetFontVector();
		return true;
	}
	return false;
}

//========================================================================
//					II擾֐
//========================================================================	 
void			SK7Font::SetData ( stSentence* pData, u8 LineNo, u8 BlockNo )
{
	m_ucLineNo = LineNo; 
	m_ucBlockNo = BlockNo; 

	m_FontData.m_Data = pData;
	
	//̓f[^ւ̃AhXݒ
	m_FontData.m_SentenceDat = (stOneSentence*)((char*)m_FontData.m_Data + m_FontData.m_Data->offset);
	//uvwhf[^ւ̃AhXݒ
	m_FontData.m_FParam = (stFontParam*)((char*)m_FontData.m_Data + m_FontData.m_Data->charOffset);
	//eNX`AhẌn
	m_FontData.m_Tex.Header = (GhmGcTexHeader*)((char*)m_FontData.m_Data + m_FontData.m_Data->texOffset);
	//eNX`̏
	InitTexture( &m_FontData.m_Tex );
	//tHgf[^쐬
	SetFontVector();
}

//========================================================================
//					s`
//========================================================================	 
void  		SK7Font::SetFontLine( f32 x, f32 y, u32 Color, u8 BlockNo, u8 LineNo, stJimakuParam* pJimaku )
{
	m_vStartPos.x = x, m_vStartPos.y = y;
	m_Color = Color;
	m_FontData = *pJimaku; 
	m_ucLineNo = LineNo; 
	m_ucBlockNo = BlockNo; 
	SetFlag( false, FONT_EFC_RENDER );
	SetFontVector();
}

//========================================================================
//					s`
//========================================================================	 
void  		SK7Font::SetFontLine( f32 x, f32 y, u32 Color, u8 BlockNo, u8 LineNo, stSentence* pJimaku )
{
	m_vStartPos.x = x, m_vStartPos.y = y;
	m_Color = Color;
	SetFlag( false, FONT_EFC_RENDER );
	SetData( pJimaku, LineNo, BlockNo );
	SetFontVector();
}


//========================================================================
//					s`
//========================================================================	 
void  		SK7Font::RenderLine()
{
	int	SpaceNum 	= 0;
	u16	FontNum		= 0;
	int	string		= 0;

	//	``FbN	***************************************************
	if( !(m_lEffectFlag & FONT_EFC_RENDER) )	return;
	
	//	ړGtFNg	***********************************************
	if( (m_lEffectFlag & FONT_EFC_MOVE) ){
		if( ++m_iMoveTime > m_iMoveFrame ){
			SetEffectMove();
			m_iMoveTime = 0;
		}
	}
	
	//	\̃|C^擾	***********************************************
	stJimaku* pFont = &m_FontData.m_SentenceDat[m_ucBlockNo].jimaku[m_ucLineNo];
		
	//	ݒ	***********************************************
	Set2DCamera();
	SetGraphMode();
	SetTevStage();
	SetVertex();

	GXSetAlphaUpdate( GX_FALSE );

	//	eNX`[Zbg	***********************************************
	GXLoadTexObj( &m_FontData.m_Tex.Obj, GX_TEXMAP0 );

	f32 PosX=0.0f;
	f32 X1, X0, Y1, Y0, S1, S0, T1, T0;

	//	v~eBu쐬	***********************************************
	GXBegin( GX_QUADS, GX_VTXFMT0, (u16)(4 * m_usFontNum) );
	
	for( int i = 0; (u16)pFont->chardat[i] != JIMAKU_NO_FONT; i++ )
	{
		//	tHg`FbN	***********************************************
		if( (u16)pFont->chardat[i] == JIMAKU_SPACE_Z ||
			(u16)pFont->chardat[i] == JIMAKU_RETURN  ||
			(u16)pFont->chardat[i] == JIMAKU_SPACE_H )
		{
			SpaceNum++;
			continue;
		}
		if( (s16)(pFont->chardat[i] & (s16)JIMAKU_FLAG_SATSU) ){
			pFont->chardat[i] =  (s16)(pFont->chardat[i] & ~(s16)JIMAKU_FLAG_SATSU);
		}
		if( (s16)(pFont->chardat[i] & (s16)JIMAKU_FLAG_SHI) ){
			pFont->chardat[i] =  (s16)(pFont->chardat[i] & ~(s16)JIMAKU_FLAG_SHI);
		}

		//	tHg␳	***********************************************
		if( !(m_lEffectFlag & FONT_EFC_ONEMOVE) ){
			if( (m_lEffectFlag & FONT_EFC_BIG2) ){
				//	E[ɂ	-------------------------------------------------------
				if( m_vFontPos[i-SpaceNum].x >= m_vBasePos[i-SpaceNum].x + SK7FONT_MOVE_RANGE){
					m_vFontPos[i-SpaceNum].x = m_vBasePos[i-SpaceNum].x + SK7FONT_MOVE_RANGE;
					m_vEffectMove[i-SpaceNum].x = -m_vEffectMove[i-SpaceNum].x;
				}
				//	nWɂ	--------------------------------------------------------
				if( m_vFontPos[i-SpaceNum].x <= m_vBasePos[i-SpaceNum].x - SK7FONT_MOVE_RANGE){
					m_vFontPos[i-SpaceNum].x = m_vBasePos[i-SpaceNum].x - SK7FONT_MOVE_RANGE;
					m_vEffectMove[i-SpaceNum].x = -m_vEffectMove[i-SpaceNum].x;
				}
				//	nWɂ	----------------------------------------------------
				if( m_vFontPos[i-SpaceNum].y >= m_vBasePos[i-SpaceNum].y + SK7FONT_MOVE_RANGE){
					m_vFontPos[i-SpaceNum].y = m_vBasePos[i-SpaceNum].y + SK7FONT_MOVE_RANGE;
					m_vEffectMove[i-SpaceNum].y = -m_vEffectMove[i-SpaceNum].y;
				}
				//	nWɂ	----------------------------------------------------
				if( m_vFontPos[i-SpaceNum].y <= m_vBasePos[i-SpaceNum].y - SK7FONT_MOVE_RANGE){
					m_vFontPos[i-SpaceNum].y = m_vBasePos[i-SpaceNum].y - SK7FONT_MOVE_RANGE;
					m_vEffectMove[i-SpaceNum].y = -m_vEffectMove[i-SpaceNum].y;
				}
			}else{
				if( m_vFontPos[i-SpaceNum].x >= m_vBasePos[i-SpaceNum].x + SK7FONT_MOVE_RANGE + m_vExpan.x*0.5f)	m_vFontPos[i-SpaceNum].x = m_vBasePos[i-SpaceNum].x + SK7FONT_MOVE_RANGE + m_vExpan.x*0.5f;
				if( m_vFontPos[i-SpaceNum].x <= m_vBasePos[i-SpaceNum].x - SK7FONT_MOVE_RANGE - m_vExpan.x*0.5f)	m_vFontPos[i-SpaceNum].x = m_vBasePos[i-SpaceNum].x - SK7FONT_MOVE_RANGE - m_vExpan.x*0.5f;
				if( m_vFontPos[i-SpaceNum].y >= m_vBasePos[i-SpaceNum].y + SK7FONT_MOVE_RANGE + m_vExpan.y*0.5f)	m_vFontPos[i-SpaceNum].y = m_vBasePos[i-SpaceNum].y + SK7FONT_MOVE_RANGE + m_vExpan.y*0.5f;
				if( m_vFontPos[i-SpaceNum].y <= m_vBasePos[i-SpaceNum].y - SK7FONT_MOVE_RANGE - m_vExpan.y*0.5f)	m_vFontPos[i-SpaceNum].y = m_vBasePos[i-SpaceNum].y - SK7FONT_MOVE_RANGE - m_vExpan.y*0.5f;
			}
		}

		//	ړXs[h	***********************************************
		if( (m_lEffectFlag & FONT_EFC_MOVE) ){
			m_vFontPos[i-SpaceNum].x += m_vEffectMove[i-SpaceNum].x;
			m_vFontPos[i-SpaceNum].y += m_vEffectMove[i-SpaceNum].y;
		}

		//	WZbg	***********************************************
		if( (m_lEffectFlag & FONT_EFC_BIG) ){
			X0 = m_vFontPos[i-SpaceNum].x + m_vStartPos.x - m_vExpan.x+m_vExpan.x*0.5f;		X1 = X0 + m_FontData.m_FParam[pFont->chardat[i]].w + m_vExpan.x+m_vExpan.x*0.5f;
			Y0 = m_vFontPos[i-SpaceNum].y + m_vStartPos.y - m_vExpan.y+m_vExpan.y*0.5f;		Y1 = Y0 + m_FontData.m_FParam[pFont->chardat[i]].h + m_vExpan.y+m_vExpan.y*0.5f;
		}else if( (m_lEffectFlag & FONT_EFC_BIG2) ){	//	gʃo[W
			X0 = m_vFontPos[i-SpaceNum].x + m_vStartPos.x + m_vExpan.x*(i-SpaceNum) - m_pfEx[i-SpaceNum]*0.5f;
			X1 = X0 + m_FontData.m_FParam[pFont->chardat[i]].w + m_vExpan.x + m_pfEx[i-SpaceNum]*0.5f;
			Y0 = m_vFontPos[i-SpaceNum].y + m_vStartPos.y - m_pfEx[i-SpaceNum]*0.5f;
			Y1 = Y0 + m_FontData.m_FParam[pFont->chardat[i]].h + m_vExpan.y + m_pfEx[i-SpaceNum]*0.5f;
		}else{
			X0 = m_vFontPos[i-SpaceNum].x + m_vStartPos.x;		X1 = X0 + m_FontData.m_FParam[pFont->chardat[i]].w;
			Y0 = m_vFontPos[i-SpaceNum].y + m_vStartPos.y;		Y1 = Y0 + m_FontData.m_FParam[pFont->chardat[i]].h;
		}
		//	ꕶWύX	***********************************************
		if( (m_lEffectFlag & FONT_EFC_ONE ) ){
			if( m_usChageNo == pFont->chardat[i] ){
				X0 += m_vOne.x;		X1 += m_vOne.x;
				Y0 += m_vOne.y;		Y1 += m_vOne.y;	
			}
		}
		if( i > 0 ){
			X0 += m_vBetween.x*i;
			X1 += m_vBetween.x*i;
		}

		
		S0 = (f32)m_FontData.m_FParam[pFont->chardat[i]].u / (f32)m_FontData.m_Tex.Header->mWidth;
		S1 = ((f32)m_FontData.m_FParam[pFont->chardat[i]].u+(f32)m_FontData.m_FParam[pFont->chardat[i]].w) / (f32)m_FontData.m_Tex.Header->mWidth;
		T0 = (f32)m_FontData.m_FParam[pFont->chardat[i]].v / (f32)m_FontData.m_Tex.Header->mHeight;
		T1 = ((f32)m_FontData.m_FParam[pFont->chardat[i]].v+(f32)m_FontData.m_FParam[pFont->chardat[i]].h) / (f32)m_FontData.m_Tex.Header->mHeight;
		
		GXPosition3f32	( X0, Y0, 0 );		GXColor1u32		( m_Color 	);		GXTexCoord2f32	( S0, T0 	);
		GXPosition3f32	( X1, Y0, 0 );		GXColor1u32		( m_Color 	);		GXTexCoord2f32	( S1, T0 	);
		GXPosition3f32	( X1, Y1, 0 );		GXColor1u32		( m_Color 	);		GXTexCoord2f32	( S1, T1 	);
		GXPosition3f32	( X0, Y1, 0 );		GXColor1u32		( m_Color 	);		GXTexCoord2f32	( S0, T1 	);
	}
	GXEnd();
}

//========================================================================
//					s̒
//========================================================================	 
f32  		SK7Font::GetFontLengthX( bool space )
{
	u16	FontNum	= 0;
	f32 PosX=0.0f;
	int i=0;

	//	\̃|C^擾	***********************************************
	stJimaku* pFont = &m_FontData.m_SentenceDat[m_ucBlockNo].jimaku[m_ucLineNo];

	//	}	***********************************************
	for( i = 0; (u16)pFont->chardat[i] != JIMAKU_NO_FONT; i++ ){
		if( (u16)pFont->chardat[i] == JIMAKU_RETURN 	||
			(u16)pFont->chardat[i] == JIMAKU_SPACE_H  )
		{
			continue;
		}else if( (u16)pFont->chardat[i] == JIMAKU_SPACE_Z ){
			if( space ){
				if( (m_lEffectFlag & FONT_EFC_SPACE) ){
					PosX += m_fSpaceSize;
				}else{
					if( (m_lEffectFlag & FONT_EFC_BIG2) ){
						PosX += m_FontData.m_FParam[pFont->chardat[0]].w + m_vExpan.x;
					}else{
						PosX += m_FontData.m_FParam[pFont->chardat[0]].w;
					}
				}
			}
		}else{
			if( (m_lEffectFlag & FONT_EFC_BIG2) ){
				PosX += m_FontData.m_FParam[pFont->chardat[i]].w + m_vExpan.x;
			}else{
				PosX += m_FontData.m_FParam[pFont->chardat[i]].w;
			}
		}
		if( i > 0 ){
			PosX += m_vBetween.x;
		}
	}	
	return PosX;
}

//========================================================================
//					ꕶϊ
//========================================================================	 
void  		SK7Font::SetChangeFont( u16 FontNo, VEC2* pSize )
{
	m_lEffectFlag |= FONT_EFC_ONE;
	m_usChageNo = FontNo;
	m_vOne = *pSize;
}


//========================================================================
//					̈ړGtFNgZbg
//========================================================================
void		SK7Font::SetEffectMove()
{
	f32 SpeedAngle=0.0f;
	for( int i = 0; i < SK7FONT_MAX_NUM; i++ )
	{
		SpeedAngle = MTXDegToRad(rand()%360);
		m_vEffectMove[i].x = (m_fMoveSize*cosf(SpeedAngle))/m_iMoveFrame;
		m_vEffectMove[i].y = (m_fMoveSize*sinf(SpeedAngle))/m_iMoveFrame;
	}
}

//========================================================================
//					̈ړGtFNgZbg
//========================================================================
bool		SK7Font::SetFontVector()
{
	int	SpaceNum 	= 0;
	int	string		= 0;

	//	\̃|C^擾	***********************************************
	stJimaku* pFont = &m_FontData.m_SentenceDat[m_ucBlockNo].jimaku[m_ucLineNo];

	if( pFont->chardat[0] == -1 )	return false;
	
	//	}	***********************************************
	for( string = 0; (u16)pFont->chardat[string] != JIMAKU_NO_FONT; string++ ){
		if( (u16)pFont->chardat[string] == JIMAKU_RETURN 	||
			(u16)pFont->chardat[string] == JIMAKU_SPACE_H  ||
			(u16)pFont->chardat[string] == JIMAKU_SPACE_Z ){
			SpaceNum++;
		}
	}
	//	B(Xy[X)	***********************************************
	m_usFontNum = (u16)(string - SpaceNum);	
	f32 PosX=0.0f;
	SpaceNum = 0;
	
	for( int i = 0; i < string; i++ ){
		if( (u16)pFont->chardat[i] == JIMAKU_SPACE_Z ||
			(u16)pFont->chardat[i] == JIMAKU_RETURN  ||
			(u16)pFont->chardat[i] == JIMAKU_SPACE_H )
		{
			SpaceNum++;
			continue;
		}
		if( (s16)(pFont->chardat[i] & (s16)JIMAKU_FLAG_SATSU) ){
			pFont->chardat[i] =  (s16)(pFont->chardat[i] & ~(s16)JIMAKU_FLAG_SATSU);
		}
		if( (s16)(pFont->chardat[i] & (s16)JIMAKU_FLAG_SHI) ){
			pFont->chardat[i] =  (s16)(pFont->chardat[i] & ~(s16)JIMAKU_FLAG_SHI);
		}
		//	tHgSp̈ړ	***********************************************
		if( i > 0 ){
			if( (u16)pFont->chardat[i-1] == JIMAKU_SPACE_Z ){
				if( (m_lEffectFlag & FONT_EFC_SPACE) ){
					PosX += m_fSpaceSize+m_FontData.m_FParam[pFont->chardat[i-2]].w;
				}else{
					PosX += m_FontData.m_FParam[pFont->chardat[0]].w+m_FontData.m_FParam[pFont->chardat[i-2]].w;
				}
			}else{
				PosX += m_FontData.m_FParam[pFont->chardat[i-1]].w;
			}
		}
		//	WZbg	***********************************************
		m_vBasePos[i-SpaceNum].x = m_vFontPos[i-SpaceNum].x = PosX;
		m_vBasePos[i-SpaceNum].y = m_vFontPos[i-SpaceNum].y = 0;
	}
	//	g嗦̒P̍쐬	----------------------------------------------
	GHM_SAFE_DELETE_ARRAY( m_pfEx );
	ghmGcMemSetAllocName("SK7Font");
	m_pfEx = new f32[string];
	memset( m_pfEx, 0, sizeof( f32 )*string );
	return true;
}


//========================================================================
//					̈ړGtFNgZbg
//========================================================================
u8				SK7Font::GetSpaceNum()
{
	u8 SpaceNum=0;

	//	\̃|C^擾	***********************************************
	stJimaku* pFont = &m_FontData.m_SentenceDat[m_ucBlockNo].jimaku[m_ucLineNo];

	//	}	***********************************************
	for( int i = 0; (u16)pFont->chardat[i] != JIMAKU_NO_FONT; i++ ){
		if( (u16)pFont->chardat[i] == JIMAKU_SPACE_Z ){
			SpaceNum++;
		}
	}
	return SpaceNum;
}


//========================================================================
//					At@[
//========================================================================
void		SK7Font::SetAlpha(u8 Alpha)
{
	u8 cR = (u8)(m_Color>>24);
	u8 cG = (u8)((m_Color<<8)>>24);
	u8 cB = (u8)((m_Color<<16)>>24);
	
	m_Color = (u32)((cR<<24)+(cG<<16)+(cB<<8)+(Alpha)); 
}


//========================================================================
//					ubN
//========================================================================
u8			SK7Font::GetDataBlockNum()
{
	return (u8)(m_FontData.m_Data->num-1);
}

//========================================================================
//					C
//========================================================================
u8			SK7Font::GetDataLineNum()
{
	for( int i = 0; i < m_FontData.m_Data->num; i++ ){
		for( int j = 0; j < JIMAKU_LINE_MAX; j++ ){
			stJimaku* pFont = &m_FontData.m_SentenceDat[i].jimaku[j];	
			if( pFont->chardat[0] == -1 ){
				return (u8)(j+1);
			}	
		}
	}
	return 0;
}

