////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuPola
//
// SK7IMenuColor.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7IMENUCOLOR_CPP__
//#define	__CHIPDEBUG__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

//#include "../wat/WK7GameInfo.h"
#include "SK7IMenuColor.h"
#include "../matsu/mK7Sound.h"
#include "../scn/K7Scn04.h"

#define		COLOR_PACK_DATA			"/sub/Color.pak"
#define		ARROW_X					(343)
#define		ARROW_Y					(90)
#define		ANSWER_X				(245)
#define		ANSWER_SIZE_X			(29)
#define		ANSWER_SIZE_Y			(31)
#define		KASAN_GAP_X				(-3)
#define		KASAN_GAP_Y				(-3)
#define		RIGHT_CHIP_NUM_X		(2)
#define		RIGHT_CHIP_NUM_Y		(6)
#define		LEFT_CHIP_NUM_X			(3)
#define		LEFT_CHIP_NUM_Y			(7)
#define		SELECT_GAP_X			(-14)
#define		SELECT_GAP_Y			(-16)
#define		FONT_BIG_SIZE			(1.3f)
#define		FONT_SMALL_SIZE			(0.8f)
#define		GB_GAP_X				(-30)

#define		DRAW_YFONT_VAR( DATA, X, Y, COLOR, EX, FONT, VAR )\
	{\
		(DATA)->DrawSetup();\
		(DATA)->SetColor2( COLOR );\
		(DATA)->SetExRate( EX );\
		(DATA)->DrawFSStr( X, Y, false, true, FONT, VAR );\
	}


//	񓚃|WV	---------------------------------------------
const int tblAnswerY[]={ 111,158,205,252,299,346,393 };



//	[̃|WV	------------------------------------------
const VEC2	tblLeftChipPos[]={
	299,110,	353,110,	407,110,		//200,0,0,
	299,157,	353,157,	407,157,		//0,0,166,
	299,204,	353,204,	407,204,		//80,20,90,
	299,251,	353,251,					//100, 60&30
	299,298,	353,298,					//240,100,160,
	299,345,				407,345,	    //90,5,20,	
	299,392,								//230,
};

//	ZbgĂȂƂ
const u8 tblLeftNotSetNo[]={1,2,3,5,7,10,11,13,15};//{1,2,3,6,8,11,12,14,16};

//	[̍ŏĂ	------------------------------------------
const VEC2	tblLeftSetPos[]={
	299,110,		/*353,110,		407,110,*/
	/*299,157,*/	353,157,		/*407,157,*/
	299,204,		/*353,204,*/	407,204,
	299,251,		/*353,251,*/	
	/*299,298,*/	353,298,	
	/*299,345,*/					407,345,   
	299,392,
};



//========================================================================
//					RXgN^
//========================================================================
SK7IMenuColor::SK7IMenuColor() : SK7IMenuBase()
{
	for( int i = 0; i < TEX_COLOR_MAX; i++ ){
		m_ptData[i] 		= NULL;
	}
	m_pYFontData	= NULL;
	m_pResLink	 	= NULL;
	m_pPackData		= NULL;
	m_pFile			= NULL;
	ghmGcMemSetAllocName("SK7COLORFILE");
	m_pFile			= new SK7File;
	m_chSelect 		= 0;
	m_chChipSelect	= 0;
	m_chOldPoint	= 0;
	m_bLRFlag		= false;
	m_bCatchFlag	= false;
	m_bPointFlag	= false;
	
	m_pNoFont 		= NULL;
	ghmGcMemSetAllocName("SK7COLORYFONT");
	m_pNoFont 		= new YK7StrImage;

#ifdef __CHIPDEBUG__
#endif
	
	m_Proc = PROC_LOAD;	
}


//========================================================================
//					fXgN^
//========================================================================
SK7IMenuColor::~SK7IMenuColor()
{
	GHM_SAFE_DELETE( m_pNoFont );
	for( int i = 0; i < TEX_COLOR_MAX; i++ ){
		GHM_SAFE_DELETE	( m_ptData[i] );
	}
	GHM_SAFE_DELETE	( m_pResLink );
}


//========================================================================
//					
//========================================================================
void	SK7IMenuColor::Initialize()
{
	int i;
	
	m_pNoFont->LoadMem( m_pYFontData );
	
	m_spBG.SetTexSprite	( 0, 0, m_ptData[TEX_BACKGROUND] );
	m_spBG.SetVisible	( true );
		
	for( i = 0; i < COLOR_ANSWER_NUM; i++ ){
		m_spAnswer[i].SetSprite( ANSWER_X, 	tblAnswerY[i], ANSWER_SIZE_X, ANSWER_SIZE_Y, 0x000000ff );
		m_spAnswer[i].SetVisible( true );
	}
	
	//[h	-------------------------------------------------------------------------------
	for( i = 0; i < COLOR_SELECT_NUM; i++ ){
		if( CheckHasColorChip( (u8)i ) ){
			m_spChip[i].SetXY0		( tblChipState[i].vPos.x, tblChipState[i].vPos.y );
			m_spChip[i].SetTexture	( m_ptData[tblChipState[i].TexNo] );
			m_spChip[i].SetVisible( true );
		}
	}
	
	//	ŏĂ	-------------------------------------------------------------
	for( i = 0; i < COLOR_NOW_NUM; i++ ){
		m_spChip[COLOR_SELECT_NUM+i].SetXY0( tblLeftSetPos[i].x, tblLeftSetPos[i].y );
		m_spChip[COLOR_SELECT_NUM+i].SetTexture	( m_ptData[tblChipSetState[i].TexNo] );
		m_spChip[COLOR_SELECT_NUM+i].SetEX( 1.0f );
		m_spChip[COLOR_SELECT_NUM+i].SetVisible	( true );
	}
	CheckColor();
}


//========================================================================
//					t[
//========================================================================
bool  	SK7IMenuColor::FrameProcess(void)
{
	switch( m_Proc )
	{
	case PROC_LOAD:
		if( LoadData() ){
			Initialize();
			m_Proc = PROC_MAIN;
		}
		break;
		
	case PROC_MAIN:
		if( !m_bCtrl )	break;	
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
			m_Proc = PROC_END;
		}
		break;
		
	case PROC_END:
		break;
		
	}
	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7IMenuColor::RenderProcess(void)
{
	if( !m_bRender )	return true;
	
	int i;
	
	m_spBG.Render();
	for( i = 0; i < COLOR_ANSWER_NUM; i++ ){
		m_spAnswer[i].Render();
	}
	
	//	łɂ
	for( i = 0; i < COLOR_SELECT_NUM+COLOR_NOW_NUM; i++ ){
		m_spChip[i].Render();
	}
	
	if( m_pNoFont == NULL )	return true;
	//		J[io[		
	for( i = 0; i < COLOR_CHIP_NUM; i++ ){
		
		if( m_spChip[i].CheckFlag( RENDER_FLAG ) ){
			f32	Ex=1.0f;
			m_pNoFont->SetExRate( Ex );

			int ColorNo0,ColorNo1,TexNo;
			u32 FontColor;
			if( i < COLOR_SELECT_NUM ){
				ColorNo0 = tblChipState[i].Color0;
				ColorNo1 = tblChipState[i].Color1;
				TexNo	 = tblChipState[i].TexNo;
				FontColor = 0xffffffff;
			}else{
				ColorNo0 = tblChipSetState[i-COLOR_SELECT_NUM].No0;
				ColorNo1 = tblChipSetState[i-COLOR_SELECT_NUM].No1;
				TexNo	 = tblChipSetState[i-COLOR_SELECT_NUM].TexNo;
				FontColor = 0x262626ff;
			}
			f32	Width 	= m_spChip[i].GetX0()+(m_spChip[i].GetTexSizeX()*m_spChip[i].GetExX()) 				- m_pNoFont->DrawFSStr( 0, 0, false, false, "%d", ColorNo0 );
			f32 Height 	= m_spChip[i].GetY0()+(m_spChip[i].GetTexSizeY()*m_spChip[i].GetExY()) 				- (18*m_spChip[i].GetExY());
			f32	Width1 	= m_spChip[i].GetX0()+(m_spChip[i].GetTexSizeX()*m_spChip[i].GetExX()) 				- m_pNoFont->DrawFSStr( 0, 0, false, false, "%d", ColorNo1 );
			f32	Width2 	= m_spChip[i].GetX0()+(m_spChip[i].GetTexSizeX()*m_spChip[i].GetExX()/2.0f) 		- m_pNoFont->DrawFSStr( 0, 0, false, false, "%d", ColorNo0 );
			f32	Width3 	= m_spChip[i].GetX0()+(m_spChip[i].GetTexSizeX()*m_spChip[i].GetExX()/3.0f) 		- m_pNoFont->DrawFSStr( 0, 0, false, false, "%d", ColorNo0 );
			f32	Width4 	= m_spChip[i].GetX0()+(m_spChip[i].GetTexSizeX()*m_spChip[i].GetExX()/3.0f*2.0f) 	- m_pNoFont->DrawFSStr( 0, 0, false, false, "%d", ColorNo0 );

			if( TexNo == CHIP_COLOR_RG || TexNo == CHIP_COLOR_GB ){
				DRAW_YFONT_VAR( m_pNoFont, Width1+2,Height+2, 	0x000000ff, Ex, "%d", ColorNo1 );
				DRAW_YFONT_VAR( m_pNoFont, Width1, 	Height, 	FontColor,	Ex,	"%d", ColorNo1 );
				DRAW_YFONT_VAR( m_pNoFont, Width2+2,Height+2, 	0x000000ff, Ex, "%d", ColorNo0 );
				DRAW_YFONT_VAR( m_pNoFont, Width2, 	Height, 	FontColor,	Ex,	"%d", ColorNo0 );
			}else if( TexNo == CHIP_COLOR_RGB ){
				DRAW_YFONT_VAR( m_pNoFont, Width+2, Height+2, 	0x000000ff, Ex, "%d", ColorNo0 );
				DRAW_YFONT_VAR( m_pNoFont, Width, 	Height, 	FontColor,	Ex,	"%d", ColorNo0 );
				DRAW_YFONT_VAR( m_pNoFont, Width4+2,Height+2, 	0x000000ff, Ex, "%d", ColorNo0 );
				DRAW_YFONT_VAR( m_pNoFont, Width4, 	Height, 	FontColor,	Ex,	"%d", ColorNo0 );
				DRAW_YFONT_VAR( m_pNoFont, Width3+2,Height+2, 	0x000000ff, Ex, "%d", ColorNo0 );
				DRAW_YFONT_VAR( m_pNoFont, Width3, 	Height, 	FontColor,	Ex,	"%d", ColorNo0 );
			}else{
				DRAW_YFONT_VAR( m_pNoFont, Width+2, Height+2, 	0x000000ff, Ex, "%d", ColorNo0 );
				DRAW_YFONT_VAR( m_pNoFont, Width, 	Height, 	FontColor,	Ex,	"%d", ColorNo0 );
			}
		}
	}
	return true;
}		

//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================
bool 	SK7IMenuColor::GetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD ){
		return true;
	}
	return false;
}

//========================================================================
//					j[I֐
//========================================================================
bool 	SK7IMenuColor::GetMenuEnd(void)
{
	if( m_Proc == PROC_END ){
		return true;
	}
	return false;
}

//========================================================================
//					f[^[h
//========================================================================
bool	SK7IMenuColor::LoadData(void)
{
	int i = 0;

	if( m_pFile->OpenDataFile( COLOR_PACK_DATA, &m_pPackData ) ){
		ghmGcMemSetAllocName("SK7COLORPACK");
		if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
			return false;
		}
		if( (m_pYFontData = (void*)m_pResLink->GetResource(TEX_FONT_DATA))==NULL ){
			return false;
		}
		for( i = 0; i < TEX_COLOR_MAX; i++ ){
			ghmGcMemSetAllocName("SK7COLORTEX");
			m_ptData[i] = new TEX_DATA;
			if( (m_ptData[i]->Header = (GhmGcTexHeader*)m_pResLink->GetResource(i+YAM_DATA_MAX))==NULL ){
				return false;
			}
			InitTexture( m_ptData[i] );
		}
		GHM_SAFE_DELETE( m_pFile );
		return true;
	}
	return false;
}


//========================================================================
//					J[`bv`FbN
//========================================================================
int		SK7IMenuColor::CheckHasColorChip( u8 No )
{
#ifdef __CHIPDEBUG__
	int tblans[]={ 1,0,0,0,0,0,1,1,1,1,0,0,0,1,1,0, };
	return tblans[No];
#else
	switch( No ){
	case 0:			return K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_COLORCHIP_01);
	case 1:			return K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_COLORCHIP_02);
	case 2:			return K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_COLORCHIP_03);
	case 3:			return K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_COLORCHIP_04);
	case 4:			return K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_COLORCHIP_05);
	case 5:			return K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_COLORCHIP_06);
	case 6:			return K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_COLORCHIP_07);
	case 7:			return K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_COLORCHIP_08);
	case 8:			return K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_COLORCHIP_09);
	}
	return false;
#endif
}


//========================================================================
//					쐬F`FbN	
//========================================================================
void		SK7IMenuColor::CheckColor()
{
	u8 Rparam,Gparam, Bparam;
	Rparam = Gparam = Bparam = 0;
	Rparam = tblChipSetState[0].No0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+6 ) )	Gparam = tblChipState[6].Color0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+2 ) )	Bparam = tblChipState[2].Color0;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[0] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[1] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[2] = Bparam;
	m_spAnswer[0].SetColor( Rparam, Gparam, Bparam, 255 );
	
	Rparam = Gparam = Bparam = 0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+1 ) )	Rparam = tblChipState[1].Color0;
	Gparam = tblChipSetState[1].No0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+5 ) )	Bparam = tblChipState[5].Color0;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[3] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[4] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[5] = Bparam;
	m_spAnswer[1].SetColor( Rparam, Gparam, Bparam, 255 );

	Rparam = Gparam = Bparam = 0;
	Rparam = tblChipSetState[2].No0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+4 ) )	Gparam = tblChipState[4].Color0;
	Bparam = tblChipSetState[3].No0;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[6] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[7] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[8] = Bparam;
	m_spAnswer[2].SetColor( Rparam, Gparam, Bparam, 255 );

	Rparam = Gparam = Bparam = 0;
	Rparam = tblChipSetState[4].No0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01 ) ){
		Gparam = tblChipState[0].Color0;
		Bparam = tblChipState[0].Color1;
	}
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[9] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[10] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[11] = Bparam;
	m_spAnswer[3].SetColor( Rparam, Gparam, Bparam, 255 );

	Rparam = Gparam = Bparam = 0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+3 ) )	Rparam = tblChipState[3].Color0;
	Gparam = tblChipSetState[5].No0;
	Bparam = tblChipSetState[5].No1;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[12] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[13] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[14] = Bparam;
	m_spAnswer[4].SetColor( Rparam, Gparam, Bparam, 255 );

	Rparam = Gparam = Bparam = 0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+8 ) ){
		Rparam = tblChipState[8].Color0;
		Gparam = tblChipState[8].Color1;
	}
	Bparam = tblChipSetState[6].No0;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[15] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[16] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[17] = Bparam;
	m_spAnswer[5].SetColor( Rparam, Gparam, Bparam, 255 );

	Rparam = Gparam = Bparam = 0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+7 ) ){
		Rparam = tblChipState[7].Color0;
		Gparam = tblChipState[7].Color0;
		Bparam = tblChipState[7].Color0;
	}
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[18] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[19] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[20] = Bparam;
	m_spAnswer[6].SetColor( Rparam, Gparam, Bparam, 255 );
}
