////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuVoice
//
// SK7IMenuVoice.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7IMENUVOICE_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "../matsu/mk7Sound.h"
#include "SK7IMenuVoice.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7Event.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7Light.h"
#include "../scn/K7Scn05.h"
#include "..\fujita\c_font.h"
 
#define __DEBUG_VOICE__		(0)		//	HCX`FbNp

#define		STAGE_POS_X		(39.1f)//(10.1f)
#define		STAGE_POS_Y		(-16.7f)//(-14.2f)
#define		STAGE_POS_Z		(28.06f)//(31.1f)
#define		STAGE_ROT_Y		(-1.7f)//(1.436817f)
#define		POSTIT_NUM_X	(5)
#define		VOICE_PACK_DATA		"/item/voice/voice.pak"




//	Cgݒ 	
#define	DIRLIGHT_COLOR		{ 0xff, 0xff, 0xff, 0xff }					// color

static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 2.000000f },		// wobj position
};
static	float	dir_light_shininess = 50.0f;

static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// CgN
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// CgtO
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};


#define	SK7VOICE_LIGHT_TYPE		(0xcfffffff)
#define	SK7VOICE_LIGHT_ID		(2)


//========================================================================
//					RXgN^
//========================================================================
SK7IMenuVoice::SK7IMenuVoice( u8 no ) : SK7IMenuBase()
{
#pragma unused( no )
	m_pLight			= NULL;
	//	Cg쐬	-----------------------------------
	m_pLight = WK7Light::Create(&dir_light,SK7VOICE_LIGHT_TYPE,SK7VOICE_LIGHT_ID);
	
	m_pArchive			= NULL;			//	A[JCuNX
	m_pModel			= NULL;			//	fNX
	m_pMotionArc		= NULL;
	m_pMotion			= NULL;
				
	//	e[v̐`FbN	-------------------------------------------------------
	CheckVoiceNum();
	
	m_lAnimeTime 	= 0;
	m_lAnimeCount	= 0;
	m_lStopTime		= 0;
	m_iVoiceNo		= 0;
	m_iString		= 0;
	m_fCenterX		= 0.0f;
	m_sFontNum		= 0;
	m_fMoveX		= 640.0f;
	m_ucSelect 		= 0;
	m_iStreamTime	= 0;

	m_Proc 			= PROC_LOAD;
	m_MoveProc 		= MOVE_WAIT;//MOVE_START;
	
	m_Data			= NULL;
	m_SentenceDat	= NULL;
	m_FParam		= NULL;				
	m_Tex.Header	= NULL;
	m_RubiTex.Header= NULL;
	
	m_bVoiceRenderFlag = false;
	
	m_pFile = new SK7File;
	
	m_spTapeBg.SetSprite( 61,42, 421,82, 0xa09b647f );
	m_spTapeBg.SetVisible( true );
}


//========================================================================
//					fXgN^
//========================================================================
SK7IMenuVoice::~SK7IMenuVoice()
{
	GHMGCMEM_SAFE_FREE(m_Data);
	
	// Cg
	if( m_pLight != NULL )	WK7Light::Release(SK7VOICE_LIGHT_TYPE,SK7VOICE_LIGHT_ID);
	
	GHM_SAFE_DELETE( m_pModel );
	GHM_SAFE_DELETE( m_pMotion );
	GHM_SAFE_DELETE( m_pFile );
	for( int i = 0; i < VOICE_TEX_MAX; i++ ){
		GHM_SAFE_DELETE	( m_pTexture[i] );
	}
	GHM_SAFE_DELETE	( m_pResLink );

}

//========================================================================
//					t[
//========================================================================
bool  	SK7IMenuVoice::FrameProcess(void)
{
	switch( m_Proc )
	{
	case PROC_LOAD:
		if( LoadData() ){
			m_Proc = PROC_CAMERA_SET;
		}
		break;
		
	case PROC_CAMERA_SET:
		WK7CAM->SetDesc(NULL);
		WK7CAM->SetPosition(0.0f,0.0f,50.0f);
		WK7CAM->SetTargetPosition(0.0f,0.0f,0.0f);
		WK7CAM->SetMode				( WK7Cam::WK7CAM_FREE_TARGET );
		m_Proc = PROC_MAIN;
		break;

		
	case PROC_MOVE_DOWN:				
		for( int i = 0; i < POSTIT_NUM; i++ )	m_spPostit[i].SetVisible(true);
		m_spSelect.SetVisible	(true);
		m_Proc = PROC_MAIN;
		break;
		
	case PROC_MOVE_UP:
		m_spSwitch[0].SetTexNo( (u8)SPLAY_ON );
		m_spSwitch[0].SetVisible(true);
		m_spSwitch[1].SetTexNo( (u8)SSTOP_OFF );
		m_spSwitch[1].SetVisible(true);
		m_Proc = PROC_CHANGE;
		break;
		
	case PROC_MAIN:
		if( !m_bCtrl ){
			break;
		}
		//		Eo[	
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_RIGHT )
		{
			//	E[ȂB
			if( (m_ucSelect%(POSTIT_NUM/2)) == 4 )		break;			
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			m_ucSelect++;
			SetSelectCursol();
			break;
		}
		//		o[	
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_LEFT )
		{
			//	[ȂB
			if( (m_ucSelect%(POSTIT_NUM/2)) == 0 )		break;
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			m_ucSelect--;
			SetSelectCursol();
			break;
		}
		//		ヌo[	
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP )
		{
			if( m_ucSelect < POSTIT_NUM/2 )	break;
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			m_ucSelect -= POSTIT_NUM/2;
			SetSelectCursol();
			break;
		}
		//		o[	
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
		{
			if( m_ucSelect >= POSTIT_NUM/2 )	break;
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			m_ucSelect += POSTIT_NUM/2;
			SetSelectCursol();
			break;
		}
		//		Abotan	
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A ){
//			if( m_sVoiceNum <= 0 )			break;
			if( !m_bHasFlag[m_ucSelect] ){
				gpSound->mPlaySE(SFX_SYS_SUBSCREEN_BOO);
				break;
			}
			gpSound->mPlaySE(SFX_SCE5_SCL_TAPEREC_ON);
//			m_spSwitch[0].SetVisible(true);
//			m_spSwitch[1].SetVisible(true);
			m_bVoiceRenderFlag = true;
			gpSound->mPrepareStreamNo( (HPS_FBI_TAPE01+m_ucSelect) );
			for( int i = 0; i < POSTIT_NUM; i++ )	m_spPostit[i].SetVisible(false);
			m_spSelect.SetVisible(false);			
			m_spTapeBg.SetVisible(false);
			m_spSwitch[0].SetTexNo(SPLAY_ON);
			m_spSwitch[1].SetTexNo(SSTOP_OFF);
			m_spAnime.SetVisible(true);
			m_Proc = PROC_CHANGE;//PROC_SWITCH_CHECK;
			break;
		}
		//		Bbottan		
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B ){
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			m_lStopTime = 0;
			m_Proc = PROC_END;
			break;
		}
		break;
#if 0
	case PROC_SWITCH_CHECK:
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
//			gpSound->mPlaySE(SFX_SYS_VOICEREC_ON);
			m_spSwitch[0].SetTexNo( (u8)SPLAY_ON );
			m_spSwitch[0].SetVisible(true);
			m_spSwitch[1].SetTexNo( (u8)SSTOP_OFF );
			m_spSwitch[1].SetVisible(true);
			gpSound->mPrepareStreamNo( (HPS_FBI_TAPE01+m_ucSelect) );
			m_Proc = PROC_MOVE_UP;//PROC_CHANGE
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			for( int i = 0; i < POSTIT_NUM; i++ )	m_spPostit[i].SetVisible(true);
			m_spSelect.SetVisible(true);
			m_spSelect.SetColor( 0, 0xff, 0, 0x64 );
			m_Proc = PROC_MAIN;
			break;
		}
		break;
#endif
		
	case PROC_CHANGE:
		MoveAnime();	//	Aj[V 
		u32	VoiceID = 0;
		char FileName[255];
		m_iStreamTime++;
		sprintf( FileName, "item/voice/voice%02d.jmb", m_ucSelect+1 );	
		if( m_iStreamTime > 30 && SetFontProcess( FileName )){
			gpSound->mJustPlayStream( STREAM_PAUSE );
			m_spTapeBg.SetVisible(false);
			CheckJimakuData(0);
			m_lStopTime = 0;
			m_iStreamTime = 0;
			m_Proc = PROC_PLAY;
			break;
		}
		break;
		
	case PROC_PLAY:
		MoveAnime();	//	Aj[V 
		MoveFontVoice();
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B || (m_SentenceDat[0].jimaku[m_iVoiceNo].chardat[0] == -1) || m_iVoiceNo >= JIMAKU_LINE_MAX ){ //|| m_iVoiceNo >= m_Data->num ){
			gpSound->mPlaySE(SFX_SCE5_SCL_TAPEREC_OFF);
			m_MoveProc 		= MOVE_WAIT;
			m_fMoveX   		= 640.0f;
			m_iVoiceNo 		= 0;
			m_iStreamTime 	= 0;
			m_lStopTime		= 0;
			m_bVoiceRenderFlag = false;
			gpSound->mStopStream();
			gpSound->mResumeStream();
			m_spSwitch[0].SetTexNo(SPLAY_OFF);
			m_spSwitch[1].SetTexNo(SSTOP_ON);
			GHMGCMEM_SAFE_FREE(m_Data);
			m_Tex.Header = NULL;

			for( int i = 0; i < POSTIT_NUM; i++ )	m_spPostit[i].SetVisible(true);
			m_spSelect.SetVisible	(true);						
			m_spTapeBg.SetVisible	(true);
			m_Proc = PROC_MAIN;//PROC_MOVE_DOWN;
			break;
		}
		break;
		
	case PROC_END: 
		break;
	}
	if( m_pModel != NULL )	m_pModel->FrameProcess();

	return true;
}

//========================================================================
//					_O
//========================================================================
bool 	SK7IMenuVoice::RenderProcess(void)
{
	if( !m_bRender )	return true;

	int i;	
	//	[hύXifwi̐OɁj
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );
	
	// JgJݒ
	if(WK7CAM->SetCurrent()==true )
	{
		WK7Light::DispStart();
//		WK7Light::DispAll();
		m_pLight->Disp();
		WK7Light::DispEnd();
		
		if( m_pModel 		!= NULL )	m_pModel->RenderProcess();
		WK7CAM->RenderProcess();
		WK7CAM->EndCurrent();
	}

	
	m_spBG.Render();
	m_spTapeBg.Render();

	for( i = 0; i < 2; i++ ){
		m_spSwitch[i].Render();
	}
	for( i = 0; i < POSTIT_NUM; i++ ){
		m_spPostit[i].Render();
	}
	m_spSelect.Render();
	m_spAnime.Render();
	
	if( m_Proc == PROC_PLAY ){
		RenderVoice();
	}
	return true;
}

//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================
bool 	SK7IMenuVoice::GetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD ){
		return true;
	}
	return false;
}

//========================================================================
//					j[I֐
//========================================================================
bool 	SK7IMenuVoice::GetMenuEnd(void)
{
	if( m_Proc == PROC_END ){
		return true;
	}
	return false;
}

//========================================================================
//					f[^[h
//========================================================================
bool	SK7IMenuVoice::LoadData(void)
{
	int i;
	if( m_pFile->OpenDataFile( VOICE_PACK_DATA, &m_pPackData ) ){
		ghmGcMemSetAllocName("SKVOICE");
		if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
			return false;
		}
		//	f쐬	
		if( NULL != (m_pArchive = WK7Archive::Create())){
			m_pArchive->LoadArchive( (void*)m_pResLink->GetResource(VOICE_DATA_STAGE) );
			if( (m_pModel = m_pArchive->CreateModel()) != NULL ){
				m_pModel->SetPosition( STAGE_POS_X,	STAGE_POS_Y, STAGE_POS_Z );
				m_pModel->SetRotation( 0.0f, 	STAGE_ROT_Y, 	0.0f );
				m_pModel->Disp();
			}
		}
		//	[V쐬	
		if( NULL != (m_pMotionArc = WK7Archive::Create())){
			m_pMotionArc->LoadArchive	( (void*)m_pResLink->GetResource(VOICE_DATA_MOTION) );
			if( (m_pMotion = m_pMotionArc->CreateModelMotion()) != NULL ){
				m_pModel->AttachMotionAll( m_pMotion );
				m_pModel->PlayMotionAll(0.0f);
			}			
		}
		//	eNX`[Zbg
		for( i = 0; i < VOICE_TEX_MAX; i++ ){
			ghmGcMemSetAllocName("SKVOICE");
			m_pTexture[i] = new TEX_DATA;
			if( (m_pTexture[i]->Header = (GhmGcTexHeader*)m_pResLink->GetResource(i+VOICE_DATA_SWITCH))==NULL ){
				return false;
			}
			InitTexture( m_pTexture[i] );
		}
		m_spSwitch[0].SetTexSprite	( SWITCH_PLAY_X, SWITCH_Y, m_pTexture[VOICE_TEX_SWITCH], 1, 4, SPLAY_OFF );
		m_spSwitch[0].SetVisible	( true );
		m_spSwitch[1].SetTexSprite	( SWITCH_STOP_X, SWITCH_Y, m_pTexture[VOICE_TEX_SWITCH], 1, 4, SSTOP_ON );
		m_spSwitch[1].SetVisible	( true );
		
		//	|XgCbg	-----------------------------------------------------------
		for( i = 0; i < POSTIT_NUM; i++ ){
			m_spPostit[i].SetTexSprite	( POSTIT_LEFT_X+( POSTIT_GAP_X*( i%POSTIT_NUM_X )), POSTIT_UP_Y+(POSTIT_GAP_Y*(u8)(i/ (POSTIT_NUM/2))), m_pTexture[VOICE_TEX_TAPE01+i] );
			m_spPostit[i].SetVisible	( true );
			if( !m_bHasFlag[i] ){
				m_spPostit[i].SetColor( 0x303030ff );
			}
		}		
		
		m_spSelect.SetTexSprite( POSTIT_LEFT_X, POSTIT_UP_Y, m_pTexture[VOICE_TEX_WAKU] );
		m_spSelect.SetFlag( true, RENDER_FLAG );

		m_spAnime.SetTexSprite( ANIME_X, ANIME_Y, m_pTexture[VOICE_TEX_ANIME], 13, 3, 0 );
		m_spAnime.SetFlag( true, RENDER_FLAG );
		m_spAnime.SetAlpha( 0x7e );
	
		m_spBG.SetTexSprite	( VOICE_BG_X, VOICE_BG_Y, m_pTexture[VOICE_TEX_RECO4_BG] );
		m_spBG.SetVisible	( true );
		m_spBG.SetAlpha(0x7e);
		
		GHM_SAFE_DELETE( m_pFile );
		
		m_RubiTex.Header = gpJimaku->mGetRubiTexPtr();
		InitTexture( &m_RubiTex );

		return true;
	}
	return false;
}
	


//========================================================================
//					̈ړ
//========================================================================
bool	SK7IMenuVoice::MoveFontVoice()
{
//	m_lStopTime++;
	m_iStreamTime++;
	switch( m_MoveProc )
	{
	case MOVE_START:
		m_fMoveX -= VOICE_SPEED;
		if( m_fMoveX <= m_fCenterX )
		{
			m_fMoveX = m_fCenterX;
			m_MoveProc = MOVE_STOP;
		}
		break;
		
	case MOVE_STOP:
		if( ++m_lStopTime > (m_pVoice->disptime/4800*30)-10 )//VOICE_STOP_TIME )
		{
			m_lStopTime = 0;
			m_MoveProc = MOVE_RESTART;
		}
		break;
		
	case MOVE_RESTART:
		m_fMoveX -= VOICE_SPEED;
		if( m_fMoveX <= (-640.0f) ){
			m_MoveProc = MOVE_WAIT;
			m_fMoveX = 640.0f;
			m_iVoiceNo++;
			CheckJimakuData(m_iVoiceNo);
			return true;
		}
		break;
	
	case MOVE_WAIT:
		if( m_iStreamTime > m_pVoice->wait/4800*30 ){
			m_MoveProc = MOVE_START;
		}
		break;
	}
/*	
	{
		C_Paper	paper(280,24);
		PRINTF( "%d, %d \n", m_iStreamTime, (u32)(m_pVoice->wait/4800*30) );
	}
*/	return false;
}

//========================================================================
//					HCXtHgcheck
//========================================================================
void		SK7IMenuVoice::CheckJimakuData( int JimakuNo )
{
//	if( m_iVoiceNo >= m_Data->num )	return;
	if( m_SentenceDat[0].jimaku[JimakuNo].chardat[0] == -1 || JimakuNo >= JIMAKU_LINE_MAX )	return;
	
	//	\̃|C^擾	--------------------------
	m_pVoice = &m_SentenceDat[0].jimaku[JimakuNo];
	int SpaceNum 	= 0;
	f32 WSize = 0;
	//	}
	for( m_iString = 0; (u16)m_pVoice->chardat[m_iString] != JIMAKU_NO_FONT; m_iString++ ){
		if( (u16)m_pVoice->chardat[m_iString] == JIMAKU_RETURN 	||
			(u16)m_pVoice->chardat[m_iString] == JIMAKU_SPACE_H ||
			(u16)m_pVoice->chardat[m_iString] == JIMAKU_SPACE_Z )
		{
			SpaceNum++;
		}else{
			if( (s16)(m_pVoice->chardat[m_iString] & (s16)JIMAKU_FLAG_SATSU) ){
				m_pVoice->chardat[m_iString] =  (s16)(m_pVoice->chardat[m_iString] & ~(s16)JIMAKU_FLAG_SATSU);
			}
			if( (s16)(m_pVoice->chardat[m_iString] & (s16)JIMAKU_FLAG_SHI) ){
				m_pVoice->chardat[m_iString] =  (s16)(m_pVoice->chardat[m_iString] & ~(s16)JIMAKU_FLAG_SHI);
			}
			WSize += m_FParam[m_pVoice->chardat[m_iString]].w;
		}
	}
	//	B(Xy[X)
	m_sFontNum =(u16)(m_iString - SpaceNum);
	//	^
	m_fCenterX = (640.0f - WSize)/2.0f;
	//	s̃r̐𐔂	--------------------------------------------
	m_cRubiNum = 0;
	int r, num = 0;
	memset( &m_cWordNum, 0, sizeof(u8)*10 );
	while(1){
		if( m_pVoice->rubidat[num].fromNum == -1 || m_pVoice->rubidat[num].toNum == -1 ){
			break;
		}
		r = 0;
		while( (u16)m_pVoice->rubidat[num].charID[r] != JIMAKU_NO_FONT ){
			r++;
		}
		m_cRubiNum += r;
		m_cWordNum[num] = (u8)r;
		num++;
	}
}

//========================================================================
//					wtHg̃|WVQbg
//========================================================================
f32			SK7IMenuVoice::GetFontPosition( stJimaku* pVoice, int No )
{
	f32 PosX = 0;
	for( int s = 0; (u16)pVoice->chardat[s] != JIMAKU_NO_FONT; s++ )
	{
		if( s >= No )	break;
		
		if( (u16)pVoice->chardat[s] == JIMAKU_SPACE_Z ){
			PosX += 20.0f;
		}else{
			PosX += m_FParam[pVoice->chardat[s]].w;
		}
	}
	return PosX;
}

//========================================================================
//					̍W擾
//========================================================================
f32			SK7IMenuVoice::GetKanjiSize( stJimaku* pVoice, int No, int Num )
{
	f32 size = 0;
	
	for( int i = 0; i < Num; i++ ){
		size += m_FParam[pVoice->chardat[No+i]].w;
	}
	return size;
}

//========================================================================
//					HCXtHg`
//========================================================================
void		SK7IMenuVoice::RenderVoice()
{
	if( !m_bVoiceRenderFlag )	return;
		
//	ݒ	--------------------------------------------
	Set2DCamera();
	SetGraphMode();
	SetTevStage();
	SetVertex();

//	eNX`[Zbg	---------------------------------------------------------------------
	GXLoadTexObj( &m_Tex.Obj, GX_TEXMAP0 );
	
	u32	Color = 0xffffffff, SColor = 0x000000ff;
	f32 PosX=0.0f;
	f32 X1, X0, Y1, Y0, S1, S0, T1, T0;
	int n=0;
	const int PlusX[]={0,0,1,-1};
	const int PlusY[]={1,-1,0,0};
//	v~eBu쐬	----------------------------------------------------------------------
	GXBegin( GX_QUADS, GX_VTXFMT0, (u16)(4 * m_sFontNum * 5) );
	
	for( int i = 0; i < m_iString; i++ ){
		if( (u16)m_pVoice->chardat[i] == JIMAKU_SPACE_Z ||
			(u16)m_pVoice->chardat[i] == JIMAKU_RETURN  ||
			(u16)m_pVoice->chardat[i] == JIMAKU_SPACE_H )
		{
			continue;
		}
		if( i > 0 ){
			if( (u16)m_pVoice->chardat[i-1] == JIMAKU_SPACE_Z )
			{
				PosX += 20.0f;
			}
			else
			{
				PosX += m_FParam[m_pVoice->chardat[i-1]].w;
			}
		}

		X0 = PosX + m_fMoveX;
		X1 = PosX + m_FParam[m_pVoice->chardat[i]].w + m_fMoveX;
		Y0 = FONT_VOICE_Y;
		Y1 = FONT_VOICE_Y + m_FParam[m_pVoice->chardat[i]].h;
		S0 = (f32)m_FParam[m_pVoice->chardat[i]].u / (f32)m_Tex.Header->mWidth;
		S1 = ((f32)m_FParam[m_pVoice->chardat[i]].u+(f32)m_FParam[m_pVoice->chardat[i]].w) / (f32)m_Tex.Header->mWidth;
		T0 = (f32)m_FParam[m_pVoice->chardat[i]].v / (f32)m_Tex.Header->mHeight;
		T1 = ((f32)m_FParam[m_pVoice->chardat[i]].v+(f32)m_FParam[m_pVoice->chardat[i]].h) / (f32)m_Tex.Header->mHeight;

		for( n = 0; n < 4; n++ ){
			GXPosition3f32( X0+PlusX[n],	Y0+PlusY[n], 0 );
			GXColor1u32( SColor );
			GXTexCoord2f32( S0, T0 );
			
			GXPosition3f32( X1+PlusX[n],	Y0+PlusY[n], 0 );
			GXColor1u32( SColor );
			GXTexCoord2f32( S1, T0 );
			
			GXPosition3f32( X1+PlusX[n],	Y1+PlusY[n], 0 );
			GXColor1u32( SColor );
			GXTexCoord2f32( S1, T1 );

			GXPosition3f32( X0+PlusX[n], Y1+PlusY[n], 0 );
			GXColor1u32( SColor );
			GXTexCoord2f32( S0, T1 );
		}

		GXPosition3f32( X0,	Y0, 0 );
		GXColor1u32( Color );
		GXTexCoord2f32( S0, T0 );
		
		GXPosition3f32( X1,	Y0, 0 );
		GXColor1u32( Color );
		GXTexCoord2f32( S1, T0 );
		
		GXPosition3f32( X1,	Y1, 0 );
		GXColor1u32( Color );
		GXTexCoord2f32( S1, T1 );

		GXPosition3f32( X0, Y1, 0 );
		GXColor1u32( Color );
		GXTexCoord2f32( S0, T1 );
	
	}
	GXEnd();
	
	
//	rtHg	---------------------------------------------------------------------------
	//	ݒ	--------------------------------------------	
	Set2DCamera();
	SetGraphMode();
	SetTevStage();
	SetVertex();
			
	GXLoadTexObj( &m_RubiTex.Obj, GX_TEXMAP0 );		//	reNX`
			
	//	v~eBu쐬	----------------------------------------------------------------------
	GXBegin( GX_QUADS, GX_VTXFMT0, (u16)(4 * m_cRubiNum) );
			
	f32 U0, U1, V0, V1;
	f32 KanjiSize = 0.0f;
			
	int num = 0;
	while(1)
	{
		//	rf[^`FbN
		if( m_pVoice->rubidat[num].fromNum == -1 || m_pVoice->rubidat[num].toNum == -1 ){
			break;
		}
		
		for( int c = 0; m_pVoice->rubidat[num].charID[c] >= 0; c++ )
		{
			KanjiSize = GetKanjiSize( m_pVoice, (int)m_pVoice->rubidat[num].fromNum, (int)m_pVoice->rubidat[num].toNum );
			f32 HalfX = ( KanjiSize - ( m_cWordNum[num] * VOICE_RUBI_SIZE_W )) / 2.0f;
			X0 = HalfX + ( c * VOICE_RUBI_SIZE_W ) + GetFontPosition( m_pVoice, (int)m_pVoice->rubidat[num].fromNum ) + m_fMoveX;
			X1 = X0 + VOICE_RUBI_SIZE_W;
			Y0 = FONT_VOICE_Y + VOICE_RUBI_GAP_Y;
			Y1 = Y0 + VOICE_RUBI_SIZE_H;
			U0 = (f32) (m_pVoice->rubidat[num].charID[c] % JIMAKU_RUBI_W_NUM) * JIMAKU_RUBI_W / (f32)m_RubiTex.Header->mWidth; 
			U1 = (( (f32)( m_pVoice->rubidat[num].charID[c] % JIMAKU_RUBI_W_NUM )+1) * JIMAKU_RUBI_W) / (f32)m_RubiTex.Header->mWidth;
			V0 = (( m_pVoice->rubidat[num].charID[c] / JIMAKU_RUBI_W_NUM ) * JIMAKU_RUBI_H ) / (f32)m_RubiTex.Header->mHeight;
			V1 = ((((m_pVoice->rubidat[num].charID[c]+JIMAKU_RUBI_W_NUM) / JIMAKU_RUBI_W_NUM) ) * JIMAKU_RUBI_H ) / (f32)m_RubiTex.Header->mHeight;

			GXPosition3f32( X0,	Y0, 0 );
			GXColor1u32( Color );
			GXTexCoord2f32( U0, V0 );

			GXPosition3f32( X1,	Y0, 0 );
			GXColor1u32( Color );
			GXTexCoord2f32( U1, V0 );
			
			GXPosition3f32( X1,	Y1, 0 );
			GXColor1u32( Color );
			GXTexCoord2f32( U1, V1 );

			GXPosition3f32( X0, Y1, 0 );
			GXColor1u32( Color );
			GXTexCoord2f32( U0, V1 );
		}
		num++;
	}
	GXEnd();
}


//========================================================================
//					Aj[V
//========================================================================
void	SK7IMenuVoice::MoveAnime()
{
	if( ++m_lAnimeTime > ANIME_TIME ){
		m_lAnimeTime = 0;
		if( ++m_lAnimeCount > ANIME_NUM-1 ){
			m_lAnimeCount = 0;
		}
		m_spAnime.SetTexNo((u16)m_lAnimeCount);
	}
}

//========================================================================
//					HCX`FbN
//========================================================================
void		SK7IMenuVoice::CheckVoiceNum()
{
	memset( &m_bHasFlag, false, sizeof(bool)*POSTIT_NUM);

	m_bHasFlag[0] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE00);
	m_bHasFlag[1] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE01);
	m_bHasFlag[2] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE02);
	m_bHasFlag[3] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE03);
	m_bHasFlag[4] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE04);
	m_bHasFlag[5] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE05);
	m_bHasFlag[6] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE06);
	m_bHasFlag[7] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE07);
	m_bHasFlag[8] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE08);
	m_bHasFlag[9] = (bool)K7SCR_GET_SCENARIO_FLAG(VRTAPE09);
#if 0
	memset( &m_bHasFlag, false, sizeof(bool)*POSTIT_NUM);
		
	m_bHasFlag[0] = 
	//	HCX̐
	for(int i = 0; i < POSTIT_NUM; i++ ){
		if( VoiceData[i] == NULL ) continue;
			m_bHasFlag[i] = true;
			m_sVoiceNum++;		
		}
	}
	
#if __DEBUG_VOICE__
	m_bHasFlag[0] = true;
	m_sVoiceNum = 1;
#endif
#endif
}

//========================================================================
//					[h
//========================================================================
bool		SK7IMenuVoice::SetFontProcess( char* FileName )
{
	if( m_Tex.Header != NULL )	return true;
	
	//	f[^ݒ
	if( m_File.OpenDataFile( FileName, &((void*)m_Data)))
	{
		//̓f[^ւ̃AhXݒ
		m_SentenceDat = (stOneSentence*)((char*)m_Data + m_Data->offset);
		//uvwhf[^ւ̃AhXݒ
		m_FParam = (stFontParam*)((char*)m_Data + m_Data->charOffset);
		//eNX`AhẌn
		m_Tex.Header = (GhmGcTexHeader*)((char*)m_Data + m_Data->texOffset);
		//eNX`̏
		InitTexture( &m_Tex );		
		return true;
	}
	return false;
}

//========================================================================
//					ZNgJ[\
//========================================================================
void		SK7IMenuVoice::SetSelectCursol()
{
	f32 X = POSTIT_LEFT_X+( POSTIT_GAP_X*( m_ucSelect%POSTIT_NUM_X ));
	f32 Y = POSTIT_UP_Y+(POSTIT_GAP_Y*(u8)(m_ucSelect/ (POSTIT_NUM/2)));
	m_spSelect.SetXY0( X, Y );//Two( X, Y,  X + SELECT_X, Y + SELECT_Y );						
}
