////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuVoice
//
// SK7IMenuVoice.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7IMENUVOICE_H__
#define	__SK7IMENUVOICE_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"

#include "../matsu/mK7Jimaku.h"
#include "SK7IMenuBase.h"
#include "SK7Sprite.h"
#include "../Yam/YK7Effect.h"
#include "../wat/WK7Archive.h"


#define		VOICE_BG_X				(155)//(100)//(157)
#define		VOICE_BG_Y				(161)//(140.0f)//(162.5f)
#define		ANIME_NUM				(39)
#define		SWITCH_NUM				(4)
#define		POSTIT_NUM				(10)
#define		SWITCH_PLAY_X			(180.0f)//157+78)
#define		SWITCH_Y				(274.4f)//(47+162.5f)//(132)
#define		SWITCH_STOP_X			(SWITCH_PLAY_X+81.0f)//(159)
#define		SIGHT_SWITCH_PLAY_X		(VOICE_BG_X+58.0f)
#define		SIGHT_SWITCH_Y			(VOICE_BG_Y+126.0f)

#define		POSTIT_LEFT_X			(69)
#define 	POSTIT_UP_Y				(50)//187)
#define		POSTIT_GAP_X			(85)
#define		POSTIT_GAP_Y			(35)
#define		POSTIT_SIZE_X			(80)
#define		POSTIT_SIZE_Y			(27)

#define		SELECT_X				(80)
#define		SELECT_Y				(27)

#define		ANIME_X					(460.25f)//359)
#define		ANIME_Y					(405.5f)//(177)//(263)
#define		ANIME_TIME				(1)

#define		VOICE_SPEED				(75.0f)
#define		VOICE_STOP_TIME			(120)

#define		FONT_VOICE_Y			(390)
#define		VOICE_RUBI_GAP_Y		(-20)

#define		VOICE_RUBI_SIZE_W		(15)
#define		VOICE_RUBI_SIZE_H		(16)

#define		BG_SPEED_DOWN			(0.1f)//25f)
#define		BG_SPEED_UP				(0.1f)//025f)
#define		BG_DOWN_MAX				(-0.24f)
#define		BG_UP_MAX				(0.18f)

enum{
	VOICE_DATA_STAGE=0,
	VOICE_DATA_MOTION,
	
	VOICE_DATA_SWITCH,
	VOICE_DATA_RECO4_BG,
	VOICE_DATA_ANIME,
	VOICE_DATA_WAKU,
	
	VOICE_DATA_TAPE01,
	VOICE_DATA_TAPE02,
	VOICE_DATA_TAPE03,
	VOICE_DATA_TAPE04,
	VOICE_DATA_TAPE05,
	VOICE_DATA_TAPE06,
	VOICE_DATA_TAPE07,
	VOICE_DATA_TAPE08,
	VOICE_DATA_TAPE09,
	VOICE_DATA_TAPE10,
	VOICE_DATA_TAPE11,
	VOICE_DATA_TAPE12,
	
	VOICE_DATA_MAX,
};

enum{
	VOICE_TEX_SWITCH=0,
	VOICE_TEX_RECO4_BG,
	VOICE_TEX_ANIME,
	VOICE_TEX_WAKU,
	
	VOICE_TEX_TAPE01,
	VOICE_TEX_TAPE02,
	VOICE_TEX_TAPE03,
	VOICE_TEX_TAPE04,
	VOICE_TEX_TAPE05,
	VOICE_TEX_TAPE06,
	VOICE_TEX_TAPE07,
	VOICE_TEX_TAPE08,
	VOICE_TEX_TAPE09,
	VOICE_TEX_TAPE10,
	VOICE_TEX_TAPE11,
	VOICE_TEX_TAPE12,
	
	VOICE_TEX_MAX,
};

//	ACe{CXR[_[
class SK7IMenuVoice : public SK7IMenuBase
{ 
protected:
		
	typedef enum{
		PROC_LOAD=0,
		PROC_CAMERA_SET,
		PROC_MOVE_DOWN,
		PROC_MOVE_UP,
		PROC_MAIN,
		PROC_PLAY,
		PROC_SWITCH_CHECK,
		PROC_CHANGE,
		PROC_END,
	}eMainProc;
	
	typedef enum{
		MOVE_START=0,
		MOVE_STOP,
		MOVE_RESTART,
		MOVE_WAIT,
		MOVE_END,
	}eMoveProc;
	
	enum
	{
		SPLAY_OFF=0,
		SPLAY_ON,
		SSTOP_OFF,
		SSTOP_ON,
	};
	
	SK7Sprite			m_spBG;
	SK7Sprite			m_spSwitch[2];
	SK7Sprite			m_spPostit[POSTIT_NUM];
	SK7Sprite			m_spSelect;
	SK7Sprite			m_spAnime;
	SK7Sprite			m_spTapeBg;
	SK7File				m_File;

	WK7Archive*			m_pArchive;	//	Xe[WNX
	WK7Model*			m_pModel;		//	Xe[WfNX
	WK7Archive*			m_pMotionArc;	
	WK7ModelMotion* 	m_pMotion;
	WK7Light*			m_pLight;
	
	eMainProc			m_Proc;
	eMoveProc			m_MoveProc;
	
	stSentence*			m_Data;
	stOneSentence*		m_SentenceDat;
	stFontParam*		m_FParam;				//uvwhl̓Ăe[uւ̃|C^
	stJimaku*			m_pVoice;
	TEX_DATA			m_Tex;
	TEX_DATA			m_RubiTex;
	
	u8				m_ucSelect;
	u16				m_sFontNum;
	u16				m_sVoiceNum;
	int				m_iString;
	int				m_iVoiceNo;
	int				m_iStreamTime;
	u32				m_lAnimeTime;
	u32				m_lAnimeCount;
	u32				m_lStopTime;
	bool			m_bVoiceRenderFlag;
	bool			m_bHasFlag[POSTIT_NUM];
	bool			m_bMoveFlag;
	f32				m_fCenterX;
	f32				m_fMoveX;
	u16				m_sSenarioNo;
	u16				m_cWordNum[10];
	u16				m_cRubiNum;
	

	//	pbNf[^
	SK7File*		m_pFile;
	ghmGcResLink*	m_pResLink;			//	N\[X
	void*			m_pPackData;		//	f[^
	TEX_DATA*		m_pTexture[VOICE_TEX_MAX];

public:
	SK7IMenuVoice( u8 no );
	virtual ~SK7IMenuVoice();
	
	// t[
	virtual bool  FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	// t@CǂݍݏI擾֐
	virtual bool GetFileReadEnd(void);
	
	// II擾֐
	virtual bool GetMenuEnd(void);
	
	bool	LoadData();
	
	void	MoveAnime();
	
	bool	MoveFontVoice();
	
	void	RenderVoice();
	
	bool	SetFontProcess( char* FileName );
	
	void	CheckJimakuData( int JimakuNo );
	
	void	CheckVoiceNum();
	
	void	SetSelectCursol();
	
	f32		GetFontPosition( stJimaku* pJimaku, int No );
	f32		GetKanjiSize( stJimaku* pJimaku, int No, int Num );

};

#endif	//__SK7IMENUVOICE_H__

