////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Load Task
//
// SK7LoadTask.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7LOADTASK_CPP__
//#define	

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "../Lib/ghmGcTask.h"
#include "SK7Common.h"
#include "SK7LoadTask.h"
#include "SK7LoadProcess.h"
#include "..\Wat\K7App.h"
#include "..\Wat\WK7MenuTask.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7Light.h"
#include "../Yam/YK7EffectHSDead.h"
#include "../fujita/C_Particle.h"
#include "../matsu/mk7Sound.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7MainTask.h"
#include "../wat/WK7Sight.h"
#include "../Yam/YK7Break.h"
#include "../matsu/mK7TitleTask.h"
#include "SK7ChangeDisk.h"
#include "SK7ScenarioTask.h"
#include "../wat/K7GlobalFlag.h"
#include "../yam/YK7CharChange.h"
#include "../yam/YK7EffectNoise.h"



#define		MOVE_CHARA_SPEEDX	(3.0f)
#define		SCE1_CHARA_NO		(7)
#define		FADE_SPEED			(WK7_SEC_TO_TICK(0.7f))
#define		FADE_SPEED2			(WK7_SEC_TO_TICK(0.9f))

const u8 tblSceCharaNum[]={ 1,2,1,1,1,1,1 };



//	Cgݒ 	

static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 2.000000f },		// wobj position
};
static	float	dir_light_shininess = 50.0f;


static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// CgN
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// CgtO
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{ 255, 255, 255, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};
#define		LOAD_LIGHT_ID			(0xbeffffff)

//========================================================================
//					RXgN^
//========================================================================
SK7LoadTask::SK7LoadTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	m_sFrameProc 			= FRAME_INIT;
	m_sTexNumber 			= 0;
	m_bBloodFlag			= false;
	m_bLoadFlag 			= false;
	m_sScenarioNo 			= 0;
	m_bChangeSightFlag 		= false;
	m_bLoadRedFlag			= false;
	m_bReturnFlag			= false;
	m_iBloodDrawTime		= 0;
	m_ucLoadProc			= 0;
	m_vLineCenter.x = m_vLineCenter.y = 0;

	m_ppArchive 			=NULL;	
	m_ppMotionArc 	        =NULL;
	m_ppModel 		        =NULL;
	m_ppMotion 			    =NULL;
	m_pSaveLoad				=NULL;
	m_pTexture				= NULL;
	m_pResLink	 			= NULL;
	m_pPackData				= NULL;
		
	m_Sight.InitSight();
	m_iCharaMoveTime	= 0;
	
	k7app.FadeStart(0xff,0);
}	

//========================================================================
//					fXgN^
//========================================================================
SK7LoadTask::~SK7LoadTask()
{
}

//========================================================================
//					R[obN
//========================================================================
bool 		SK7LoadTask::InitializeCallBack(void)
{
	HSD_VISetClearClr((GXColor){0x00,0x00,0x00,0x00});	

#if	0
	ghmGcApp	*pApp = GetApplication();
	
	OSDebugReport("SK7TestTask Init : DefaultHeap = 0x%08x , TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),sizeof(*this));
	
	pApp->SetEnablePerfMeter (true);
	pApp->SetVisiblePerfMeter(true);
	ghmGcMem::SetRender(true);
#endif
	
	//	Cg쐬	-----------------------------------
	WK7Light::Create(&dir_light,LOAD_LIGHT_ID,LOAD_LIGHT_ID);
	
	//	J̃|WV
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetDesc(NULL);
	WK7CAM->SetPosition(0.0f,0.0f,50.0f);
	WK7CAM->SetTargetPosition(0.0f,0.0f,0.0f);
	
	//	RcGtFNg	---------------------------------
	ghmGcMemSetAllocName("YAMADATASK");
	m_pTaskControl = new ghmGcTaskController;
	m_pTaskControl->Initialize();
	EffectInit( m_pTaskControl, 200 );
	screenImageFullColor.SetFormat(GX_TF_RGBA8);
	screenImageFullColor.AllocBuffer();
		
	//	TCg̏
	m_Sight.InitSight();
	
	//	TEhf[^Ăяo
//	gpSound->mReadSsm("seTv.ssm",eBankPlayer);
	gpSound->mReadSsm("seSSelect.ssm",eBankScenario);

	return true;
}

//========================================================================
//					IR[obN
//========================================================================
bool 	SK7LoadTask::TerminateCallBack(void)
{
	//	f[V
	GHM_SAFE_DELETE_ARRAY( m_ppArchive );
	GHM_SAFE_DELETE_ARRAY( m_ppMotionArc );

	for( int i = 0; i < tblSceCharaNum[m_sScenarioNo]; i++ ){
		if( m_ppModel != NULL )	GHM_SAFE_DELETE( m_ppModel[i] );
		if( m_ppMotion != NULL ) GHM_SAFE_DELETE( m_ppMotion[i] );	
	}
	
	GHM_SAFE_DELETE			(m_pResLink);
	GHM_SAFE_DELETE_ARRAY	(m_pTexture);

	
	GHM_SAFE_DELETE_ARRAY( m_ppModel );
	GHM_SAFE_DELETE_ARRAY( m_ppMotion );	
	
	//	ij̍폜	------------------------
	m_Blood.Delete();

	//	RcGtFNgI
	//	TEhf[^J
//	gpSound->mReleaseSsm("seTv.ssm");
//	gpSound->mReleaseSsm("seSSelect.ssm");
//	gpSound->mReadSsm("seSSelect.ssm",eBankScenario);

	GHM_SAFE_DELETE( m_pSaveLoad );
	EffectEnd();
	GHM_SAFE_DELETE(m_pTaskControl);
	screenImageFullColor.FreeBuffer();

	// Cg	---------------------------------
	WK7Light::Release(LOAD_LIGHT_ID,LOAD_LIGHT_ID);		

	bool flag = m_bReturnFlag;
	s16 scenario = m_sScenarioNo;
	GameInfo.SetContinue(m_bLoadRedFlag);

	if( !K7SCR_GET_GLOBAL_FLAG( K7GLFL_SCENARIO_CLEAR ) ){
		if( !flag ){
			if( !m_bLoadRedFlag ){
				switch( m_sScenarioNo )
				{
				case 0:	GameInfo.SetScenarioID(K7SCN07);	break;
				case 1:	GameInfo.SetScenarioID(K7SCN01);	break;
				case 2: GameInfo.SetScenarioID(K7SCN02);	break;
				case 3:	GameInfo.SetScenarioID(K7SCN03);	break;
				case 4: GameInfo.SetScenarioID(K7SCN04);	break;
				case 5: GameInfo.SetScenarioID(K7SCN05);	break;
				case 6: GameInfo.SetScenarioID(K7SCN06);	break;
				}
			}
		}
	}

	ghmGcApp *pApp = GetApplication();
	delete this;

	gpSound->mReleaseSsm("seSSelect.ssm");
	if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_SCENARIO_CLEAR ) ){
		if( gTitleGoContinue==true ){
			gTitleGoContinue = false;
		}
		new SK7ScenarioTask(pApp);
	}else{
		if( flag ){
			new MK7TitleTask(pApp);
		}else{
			if( gTitleGoContinue==true ){
				gTitleGoContinue = false;
			}
			//	fBXN`FbN	---------------------------------------
			if( (scenario > 3 && ghmGcFile::GetCurrentDiskID() == 0) ||
				(scenario < 4 && ghmGcFile::GetCurrentDiskID() == 1) )
			{
				new SK7ChangeDisk(pApp);
			}else{
				new WK7MainTask(pApp);
			}
		}
	}	
	return true;
}


//========================================================================
//					t[
//========================================================================
bool 	SK7LoadTask::FrameProcess(void)
{
	//	TCg̈ړ
	if( m_sFrameProc == FRAME_MODEL_VIEW )	MoveSight();
	
	//	
	switch( m_sFrameProc )
	{
	//
	//	
	case FRAME_INIT:		
		//	tF[hƃ[h`FbN
		if( LoadData() ){
			m_sTexNumber = 0;
			k7app.SetFadeColor(0x000000ff);
			k7app.FadeStart(0x00,FADE_SPEED);			//	CtF[h
			m_pSaveLoad->SetRender(true);
			m_sFrameProc = FRAME_FADE;
		}
		break;
		
	//
	//	tF[h
	case FRAME_FADE:
		if( !k7app.IsFade() ){
			m_pSaveLoad->SetCtrlFlag(true);
			m_sFrameProc = FRAME_TV_LOAD;
		}
		break;
		
	//
	//	su[h
	case FRAME_TV_LOAD:
		if( m_pSaveLoad->GetMenuEnd() ){						//	[ǏI`FbN
			if( m_pSaveLoad->GetState()==eProcLoadEnd ){		//	[h`FbN
				m_sScenarioNo 	= (s16)((SK7LoadProcess*)m_pSaveLoad)->GetScenarioNo();
				int ReControl 	= K7SCR_GET_GLOBAL_FLAG( K7GLFL_OPT_RECONTROL );
				int Vibe 		= K7SCR_GET_GLOBAL_FLAG( K7GLFL_OPT_VIB );
				GameInfo.RestoreSaveData( m_pSaveLoad->GetSaveData() );
				if( ReControl == true ){
					K7SCR_SET_GLOBAL_FLAG( K7GLFL_OPT_RECONTROL );
				}else{
					K7SCR_RESET_GLOBAL_FLAG( K7GLFL_OPT_RECONTROL );
				}				
				if( Vibe == true ){
					K7SCR_SET_GLOBAL_FLAG( K7GLFL_OPT_VIB );
				}else{
					K7SCR_RESET_GLOBAL_FLAG( K7GLFL_OPT_VIB );
				}
				k7app.FadeStart(0xff,FADE_SPEED);			//	CtF[h
				if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_SCENARIO_CLEAR ) ){
					m_sFrameProc = FRAME_END;
				}else{
					m_sFrameProc = FRAME_LOAD_END;
				}
			}else{
//				HSD_VISetClearClr((GXColor){0x00,0x00,0x00,0xff});	
				m_bReturnFlag = true;
				k7app.FadeStart( 0xff, FADE_SPEED2 );
				m_sFrameProc = FRAME_RETURN_END;
			}
		}
		break;
		
	//
	//	[h܂Ƃf[^[h
	case FRAME_LOAD_END:
		m_bLoadFlag = LoadData2();
		if( !k7app.IsFade() ){
			if( m_bLoadFlag ){
				HSD_VISetClearClr((GXColor){0xff,0xff,0xff,0xff});	
				k7app.FadeStart(0x00,FADE_SPEED);			//	CtF[h
				gpSound->mPlaySE(SFX_SYS_SIGHT_LOOP);
				m_Sight.InitSightLine();
				m_Sight.InitSight();
				m_Sight.SetSightPos( 0, 0 );
				m_Sight.SetSight2DPos( 320, 240 );
				m_Sight.SetLineVertex();
				m_sFrameProc = FRAME_MODEL_VIEW;
			}
		}
		break;

	//
	//	f`
	case FRAME_MODEL_VIEW:
		if( k7app.IsFade() ) 	break;

#if 0
 		//	LZ	--------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B ){
			gpSound->mStopSE(SFX_SYS_SIGHT_LOOP);
			m_pSaveLoad->InitLoad();				//	[hւ̏
			DeleteData2();							//	f[^
			m_sFrameProc = FRAME_TV_LOAD;			//TVʂ
			break;
		}
#endif
		//	蔻	-------------------------- 
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A ){
			//	f ̃Zbg
			SetBlood(m_sScenarioNo);
			//	ł܂II
			if(m_bBloodFlag)
			{
				gpSound->mStopSE(SFX_SYS_SIGHT_LOOP);
				gpSound->mPlaySE(SFX_BT_WEAK_DEATH);
				gpSound->mPlaySE( SFX_SYS_RIFLE );

				m_bLoadRedFlag = true;
				m_ppModel[0]->Hide();
				if( m_sScenarioNo == 1 )	m_ppModel[1]->Hide();
				m_sFrameProc = FRAME_BLOOD_TIME;
			}
		}
		break;

	//
	//	̕`掞
	case FRAME_BLOOD_TIME:
		MoveCharactor();
		if( ++m_iBloodDrawTime > BLOOD_DRAW_TIME )
		{
			gpSound->mPlaySE(SFX_BT_WEAK_DEATH_BOMB);
			m_iBloodDrawTime = 0;
			m_sFrameProc = FRAME_BLOOD_MOVE;
		}
		break;
		
	//
	//	̈ړ
	case FRAME_BLOOD_MOVE:
		//	̈ړ
		if( m_bLoadRedFlag ){
			if( m_Blood.MoveRedBlood( m_sScenarioNo ) ){	
				k7app.SetFadeColor(0xff000000);
				k7app.FadeStart(0xff,FADE_SPEED);	
				m_sFrameProc = FRAME_END;
			}
		}else{
			if( m_Blood.MoveBlood(m_sScenarioNo) ){
				k7app.SetFadeColor(0xff000000);
				k7app.FadeStart(0xff,FADE_SPEED);	
				m_sFrameProc = FRAME_END;
			}
		}
		break;

	//
	//	^Cgɖ߂
	case FRAME_RETURN_END:
		if( !k7app.IsFade() ){
			if( DeleteTerminate()==true ){
				return true;
			}		
		}
		break;
	
	//
	//	I
	case FRAME_END:
#if !__BLOOD_DEBUG__
		if( !k7app.IsFade() ){
			gpSound->mStopSE(SFX_SYS_SCENARIO_TITLE);			
			if( DeleteTerminate()==true ){
				return true;
			}
		}
#endif
		break;
		
	}
	
	//	Z[u[h̃t[vZX
	if( m_pSaveLoad != NULL && m_sFrameProc < FRAME_LOAD_END){
		m_pSaveLoad->FrameProcess();
	}
	//	y
	gpSound->mFrameProcess(); 	

	// J
	WK7CAM->FrameProcess();
	SetEffectCamera(WK7CAM->GetCObj());
	PARTICLE.Proc(WK7CAM->GetCObj());
	PARTICLE.Proc(WK7CAM->GetCObj());
	
	// Aj[Vs
	for( int i = 0; i < tblSceCharaNum[m_sScenarioNo]; i++ ){
		if( m_ppModel != NULL && m_sFrameProc == FRAME_MODEL_VIEW ){
			m_ppModel[i]->FrameProcess();
		}
	}
	WK7Archive::FrameProcessAll();

	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7LoadTask::RenderProcess(void)
{
	if( (m_sFrameProc <= FRAME_LOAD_END && m_sFrameProc != FRAME_INIT ) || ( m_sFrameProc == FRAME_RETURN_END ) ||
		(m_sFrameProc == FRAME_END && K7SCR_GET_GLOBAL_FLAG( K7GLFL_SCENARIO_CLEAR )) )
	{
		if( m_pSaveLoad != NULL ){
			m_pSaveLoad->RenderProcess();
		}
	}else{
		//	I肵
		if( m_bLoadFlag ){
			//	[hύXifwi̐OɁj
			GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );

			// JgJݒ
			if(WK7CAM->SetCurrent()==true ){
				WK7Light::DispStart();
				WK7Light::DispAll();
				WK7Light::DispEnd();
				for( int i = 0; i < tblSceCharaNum[m_sScenarioNo]; i++ ){
					if( m_ppModel != NULL )		m_ppModel[i]->RenderProcess();
				}				
				WK7CAM->RenderProcess();
				// JgJł̕`I
				WK7CAM->EndCurrent();	
			}
			WK7Sight::DrawSyncToken();

			//	C`
			RenderSight();
			
			//	̕`
			if( m_sFrameProc >= FRAME_BLOOD_TIME ){
				//	̕`	-------------------------------
				if( m_bBloodFlag )	m_Blood.DrawBlood();
			
				//	Rc	--------------------------------
				PARTICLE.Disp();
			}
		}
	}
	m_pTaskControl->FrameProcess();
	return true;
}



//
//							SCENARIOp
//

//========================================================================
//					TVdata
//========================================================================
void		SK7LoadTask::DeleteData2()
{
	m_Blood.Delete();

	//	f[V
	GHM_SAFE_DELETE_ARRAY( m_ppModel 	);	
	GHM_SAFE_DELETE_ARRAY( m_ppMotion 	);	
}

//========================================================================
//					[hf[^
//========================================================================
bool		SK7LoadTask::LoadData()
{
	int i;
	switch( m_sTexNumber ){
	case 0:
		if( m_File.OpenDataFile( SCENARIO_PACK_DATA, &m_pPackData ) ){
			m_pTexture = new TEX_DATA[SCENARIO_TEX_NUM];
			if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
				return false;
			}
			for( i = 0; i < SCENARIO_MAX_NUM; i++ ){
				m_Blood.ReadKanjiData2( i, (void*)m_pResLink->GetResource(i) );
			}
			for( i = 0; i < SCENARIO_TEX_NUM; i++ ){
				if( (m_pTexture[i].Header = (GhmGcTexHeader*)m_pResLink->GetResource(i+SCENARIO_MAX_NUM))==NULL ){
					return false;
				}
				InitTexture( &m_pTexture[i] );
			}
			m_Blood.LoadTexture2( &m_pTexture[SCE_TEX_BLOODS] );
			ghmGcMemSetAllocName("SaveLoad");
			m_pSaveLoad = SK7SaveBase::Create(eBaseLoad);
			m_sTexNumber++;
		}
		break;

	case 1:
		if( m_pSaveLoad->GetFileReadEnd() ){
			m_sTexNumber++;
		}
		break;
		
	case 2: 
		if( EffectSetupCheck() == TRUE ){
			USE_PARTICLE;
			m_sTexNumber++;
			return true;
		}
		break;
	default:
		return true;
	}
	return false;
}


//========================================================================
//					[hĨ[h
//========================================================================
bool 	SK7LoadTask::LoadData2(void)
{
	bool flag = false;
	if( m_sScenarioNo == 1 )	flag = true;

	switch( m_sTexNumber ){
	case LOAD_ARCHIVE:
		ghmGcMemSetAllocName("SK7LOADARC");
		m_ppArchive 	= new WK7Archive* [tblSceCharaNum[m_sScenarioNo]];
		ghmGcMemSetAllocName("SK7LOADMOA");
		m_ppMotionArc 	= new WK7Archive* [tblSceCharaNum[m_sScenarioNo]];
		ghmGcMemSetAllocName("SK7LOADMO");
		m_ppModel 		= new WK7Model* [tblSceCharaNum[m_sScenarioNo]];
		ghmGcMemSetAllocName("SK7LOADTION");
		m_ppMotion 		= new WK7ModelMotion* [tblSceCharaNum[m_sScenarioNo]];

		//	f	-----------------------------------------
		if( NULL != (m_ppArchive[0] = WK7Archive::Create())){
			m_ppArchive[0]->LoadArchive( tblModelData[m_sScenarioNo].Red );
		}
		//	[V쐬	----------------------------------
		if( tblMotionData[m_sScenarioNo]  != NULL ){
			if( NULL != (m_ppMotionArc[0] = WK7Archive::Create())){
				m_ppMotionArc[0]->LoadArchive	( tblMotionData[m_sScenarioNo] );
			}
		}
		if( flag ){
			if( NULL != (m_ppArchive[1] = WK7Archive::Create())){
				m_ppArchive[1]->LoadArchive( tblModelData[SCE1_CHARA_NO].Red );
			}
			if( tblMotionData[m_sScenarioNo]  != NULL ){
				if( NULL != (m_ppMotionArc[1] = WK7Archive::Create())){
					m_ppMotionArc[1]->LoadArchive	( tblMotionData[SCE1_CHARA_NO] );
				}
			}
		}
		m_sTexNumber = LOAD_MODEL0;
		break;
		
	case LOAD_MODEL0:
		if( m_ppArchive[0]->GetState() == WK7Archive::WK7ARCHIVE_LOADED ){
			if( (m_ppModel[0] = m_ppArchive[0]->CreateModel()) != NULL ){
				m_ppModel[0]->SetPosition( &tblModelPos[m_sScenarioNo] );
				m_ppModel[0]->SetRotation( &tblModelRot[m_sScenarioNo] );
				m_ppModel[0]->Disp();
				if( flag )		m_sTexNumber = LOAD_MODEL1;
				else			m_sTexNumber = LOAD_MOTION0;
			}
		}
		break;
		
	case LOAD_MODEL1:
		if( m_ppArchive[1]->GetState() == WK7Archive::WK7ARCHIVE_LOADED ){
			if( (m_ppModel[1] = m_ppArchive[1]->CreateModel()) != NULL ){
				m_ppModel[1]->SetPosition( &tblModelPos[SCE1_CHARA_NO] );
				m_ppModel[1]->SetRotation( &tblModelRot[SCE1_CHARA_NO] );
				m_ppModel[1]->Disp();			
				m_sTexNumber = LOAD_MOTION0;
			}
		}
		break;
		
	case LOAD_MOTION0:
		if( (tblMotionData[m_sScenarioNo]  != NULL) ){
			if( m_ppMotionArc[0]->GetState() == WK7Archive::WK7ARCHIVE_LOADED ){
				if( (m_ppMotion[0] = m_ppMotionArc[0]->CreateModelMotion()) != NULL ){
					m_ppModel[0]->AttachMotion( m_ppMotion[0] );
					m_ppModel[0]->PlayMotion(0.0f);				
				}else{
					break;
				}
			}else{
				break;
			}
		}		
		if( flag )	m_sTexNumber = LOAD_MOTION1;
		else		m_sTexNumber = LOAD_MAX;
		break;
		
	case LOAD_MOTION1:
		if( (tblMotionData[SCE1_CHARA_NO]  != NULL) ){
			if( m_ppMotionArc[1]->GetState() == WK7Archive::WK7ARCHIVE_LOADED ){
				if( (m_ppMotion[1] = m_ppMotionArc[1]->CreateModelMotion()) != NULL ){
					m_ppModel[1]->AttachMotion( m_ppMotion[1] );
					m_ppModel[1]->PlayMotion(0.0f);				
				}else{
					break;
				}
			}else{
				break;
			}
		}
		m_sTexNumber = LOAD_MAX;
		return true;
		
	case LOAD_MAX:
		return true;
	}
	return false;
}



//========================================================================
//					LN^[̈ړ
//========================================================================
bool		SK7LoadTask::MoveCharactor()
{
	Vec vCharaPos;

	//	Ԃ𔄂ꍇ	==============================================
	if( m_bLoadRedFlag ){
		m_ppModel[0]->GetPosition( vCharaPos );
		m_ppModel[0]->SetPosition( vCharaPos.x-MOVE_CHARA_SPEEDX,vCharaPos.y, vCharaPos.z );
		if( m_sScenarioNo == 1 ){
			m_ppModel[1]->GetPosition( vCharaPos );
			m_ppModel[1]->SetPosition( vCharaPos.x-MOVE_CHARA_SPEEDX,vCharaPos.y, vCharaPos.z );
		}
	}else{
		m_ppModel[1]->GetPosition( vCharaPos );
		m_ppModel[1]->SetPosition( vCharaPos.x+MOVE_CHARA_SPEEDX,vCharaPos.y, vCharaPos.z );
		if( m_sScenarioNo == 1 ){
			m_ppModel[3]->GetPosition( vCharaPos );
			m_ppModel[3]->SetPosition( vCharaPos.x+MOVE_CHARA_SPEEDX,vCharaPos.y, vCharaPos.z );
		}
	}
	return true;
}


//========================================================================
//					
//========================================================================
void		SK7LoadTask::SetBlood(int sNo)
{
	const u16 tblBloodNum[]={30,30,30,30,10,10};
	u32 ZBuff;
	u32 Color;
	if( !(m_Sight.GetSight2DPos()->x < 640.0f && m_Sight.GetSight2DPos()->x > 0.0f &&
			m_Sight.GetSight2DPos()->y < 480.0f && m_Sight.GetSight2DPos()->y > 0.0f ))
		return;

	WK7Sight::DrawSyncToken();		
	WK7Sight::WaitSyncToken();

	GXPeekARGB((u16)m_Sight.GetSight2DPos()->x, (u16)m_Sight.GetSight2DPos()->y, &Color);
	GXPeekZ((u16)m_Sight.GetSight2DPos()->x, (u16)m_Sight.GetSight2DPos()->y, &ZBuff);

/*
	//	obNobt@ȂƂ
	if( ZBuff !=  0xfffffff){	
		//	W擾̂߂ɕ`
		m_bBloodFlag = true;
		//	Ԃ̂ǂ
		if( ZBuff > tblZBuffData[m_sScenarioNo] ){
			m_bLoadRedFlag = false;
			if( sNo == 1 )	m_Blood.CreateBloodObject( m_ppModel[1], m_ppModel[3] , 	tblBloodNum[sNo], 1.0f );
			else			m_Blood.CreateBloodObject( m_ppModel[1], NULL, 			tblBloodNum[sNo], 1.0f );
		}else{
			m_bLoadRedFlag = true;
			if( sNo == 1 )	m_Blood.CreateBloodObject( m_ppModel[0], m_ppModel[2] , 	tblBloodNum[sNo], 1.0f );
			else			m_Blood.CreateBloodObject( m_ppModel[0], NULL, 			tblBloodNum[sNo], 1.0f );
		}
		m_Blood.SetBloodParam( m_bLoadRedFlag );
	}
*/
	ZBuff &= 0x00ffffff;
	if( !(ZBuff <= 0x00ffffff && ZBuff >= 0x00FEE5D2) ){
		//	W擾̂߂ɕ`
		m_bBloodFlag = true;
		m_bLoadRedFlag = true;
		if( sNo == 1 )	m_Blood.CreateBloodObject( m_ppModel[0], m_ppModel[1] , 	tblBloodNum[sNo], 1.0f );
		else			m_Blood.CreateBloodObject( m_ppModel[0], NULL, 			tblBloodNum[sNo], 1.0f );		
	}
	m_Blood.SetBloodParam( m_bLoadRedFlag );	
}


//========================================================================
//					TCg̈ړ
//========================================================================
void		SK7LoadTask::MoveSight()
{
	bool MoveFlag = true;
	float MoveX = 0.0f, MoveY = 0.0f;
	
	MoveX = HSD_PadGetNormalStickX(0)*0.2f;
	MoveY = HSD_PadGetNormalStickY(0)*0.2f;
	m_Sight.SetSightIncPos( MoveX, MoveY );
	m_Sight.SetSight2D();
	if( MoveX == 0 && MoveY == 0 ){
		m_Sight.MoveStopSight();
		m_Sight.MoveSightLine(false);
	}else{
		m_Sight.MoveSightLine(true);
	}
	SetSightSize();
}

//========================================================================
//					TCgTCY`FbN
//========================================================================
void		SK7LoadTask::SetSightSize()
{
	u32 ZBuff;

//	WK7Sight::DrawSyncToken();
	WK7Sight::WaitSyncToken();
	
//	GXPeekARGB((u16)m_Sight.vPos2D.x, (u16)m_Sight.vPos2D.y, &ZBuff);
	GXPeekZ((u16)m_Sight.GetSight2DPos()->x, (u16)m_Sight.GetSight2DPos()->y, &ZBuff);

	//	TCY
	ZBuff &= 0x00ffffff;
	if( ZBuff <= 0x00ffffff && ZBuff >= 0x00FEE5D2)	m_Sight.SetSightSize(SIGHT_SIZE/2);
	else											m_Sight.SetSightSize(SIGHT_SIZE);
}


//========================================================================
//					TCg̕`
//========================================================================
void		SK7LoadTask::RenderSight()
{
	//	JZbg
	m_Sight.SetSightCamera();	
	m_Sight.SetAlphaSight();
	
	switch( m_sFrameProc )
	{		
	//	^Cg
	case FRAME_MODEL_VIEW:
	
		m_Sight.RenderSight3D(&m_pTexture[SCE_TEX_SIGHT]);
		m_Sight.RenderSight2D();
		break;
	}
}






