////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7LogoTask.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/18/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7LOGOTASK_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include <DVDBanner.h>
#include "../Lib/ghmGcTask.h"
#include "SK7Common.h"
#include "SK7LogoTask.h"
#include "..\Wat\K7App.h"
#include "..\Wat\WK7MenuTask.h"
#include "..\Wat\K7GlobalFlag.h"
#include "../matsu/mk7Sound.h"
#include "../wat/WK7MainTask.h"
#include "../matsu/MK7TitleTask.h"
#include "SK7FirstCheck.h"


#define		LOGO_PACK_DATA	"/scenario/logo/logo.pak"
#define		LOGO_TIME			(50)
#define		RED_TIME			(30)
#define		RED_TIME2			(20)
#define		RED_CAPCOM_TIME		(40)
#define		RED_GHM_TIME		(60)
#define		GULO_TIME			(80)
#define		GULO_FADE_START		(WK7_SEC_TO_TICK(1.4f))
#define		GULO_FADE_SPEED		(WK7_SEC_TO_TICK(0.9f))
#define		LOGO_FADE_SPEED		(WK7_SEC_TO_TICK(0.5f))
#define		LOGO_GHM_SPEED		(WK7_SEC_TO_TICK(0.8f))
#define		CARD_TIME			(20)
#define		JYU_SE_TIME			(20)

//========================================================================
//					R[obN
//========================================================================
bool SK7LogoTask::InitializeCallBack(void)
{	
	//	---------	eXgp̏	------------	//
	HSD_VISetClearClr((GXColor){0,0,0,0xff});
	
	m_Proc 		= eLoadProc;
	m_Load		= eLoadTex;
	m_pSaveCheck= NULL;
	m_iTime		= 0;
		
	m_spRed.SetSprite( 0, 0, 640, 480, 0xff000000 );
	m_spRed.SetVisible( true );
	
	m_pTaskControl = NULL;
	
//	k7app.FadeStart( 0xff, 0 );
	k7app.FadeStart( 0x00, 0 );
	
	//	TEhf[^Ăяo
	gpSound->mReadSsm("seLogo.ssm",eBankScenario);
	
	return true;
}


//========================================================================
//					IR[obN
//========================================================================
bool 	SK7LogoTask::TerminateCallBack(void)
{	
	//	TEhf[^J
	gpSound->mReleaseSsm("seLogo.ssm");

	GHM_SAFE_DELETE(m_pTaskControl);

	GHM_SAFE_DELETE( m_pSaveCheck );
	GHM_SAFE_DELETE_ARRAY	( m_pTexture );		
	GHM_SAFE_DELETE(m_pResLink);
	
	ghmGcApp *pApp = GetApplication();

	delete this;	
	new MK7TitleTask(pApp);
	
	return true;
} 


//========================================================================
//					t[
//========================================================================
bool 	SK7LogoTask::FrameProcess(void)
{
	switch( m_Proc ){
//		[h		
	case	eLoadProc:
		if( LoadTexture() ){
			if( !g_bFirstGameCheck ){
				//	Z[u[hptOZbg
				m_pSaveCheck->SetCtrlFlag(true);
				m_pSaveCheck->SetRender(true);
				m_Proc = eCheckCard;
			}else{	
				m_spGulo.SetVisible( true );
				k7app.FadeStart( 0xff, 0 );
				m_Proc = eCardFade;
			}
		}
		break;

//		J[h`FbN		
	case eCheckCard:
		m_pSaveCheck->FrameProcess();
		if( !m_pSaveCheck->GetMenuEnd() )	break;	//	[hIĂȂ
		m_spGulo.SetVisible( true );
		k7app.FadeStart( 0xff, 0 );
		m_Proc = eCardFade;
		break;
		
//		J[h`FbNtF[h		
	case 	eCardFade:
		if( !k7app.IsFade() ){
			if( ++m_iTime > CARD_TIME ){
				k7app.FadeStart( 0x00, GULO_FADE_SPEED );
				m_iTime = 0;
				m_Proc = eGuloProc;
			}
		}
		break;
		
//		ŏ̃tF[h		
	case 	eGuloProc:
		if( !k7app.IsFade() ){
			if( ++m_iTime > GULO_TIME ){ 
				k7app.FadeStart( 0xff, GULO_FADE_SPEED );
				m_iTime = 0;
				m_Proc = eGuloFadeEnd;
			}
		}
		break;
		
//		OeXNtF[h		
	case 	eGuloFadeEnd:
		if( !k7app.IsFade() ){
#ifndef K7APP_MASTER_NINTENDO
			if( HSD_PadGetNormalAnalogL(0) >= 0.3f  ){
				K7SCR_SET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR);
			}
			if( HSD_PadGetNormalAnalogR(0) >= 0.3f  ){
				K7SCR_SET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR);
				K7SCR_SET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR_K8);
			}
#endif
			k7app.FadeStart( 0x00, GULO_FADE_SPEED );
			m_spGulo.SetVisible( false );
			m_spRed.SetColor( 0xffffffff );
			m_spCapLogo.SetFlag( true, RENDER_FLAG );
			m_Proc = eCapcomFadeStart;
		}
		break;

//		JvRtF[h		
	case	eCapcomFadeStart:
		if( !k7app.IsFade() ){
			if( m_iTime == 0 )		gpSound->mPlaySE(SFX_LOGO_CAPCOM);	//	C
			if( ++m_iTime == RED_TIME ){
				gpSound->mPlaySE(SFX_LOGO_RIFLE);	//	e
				m_iTime = 0;
				m_spRed.SetColor( 0xff0000ff );
				m_Proc = eCapcomRedProc;
			}
		}
		break;

//		JvR\		
	case	eCapcomRedProc:
		if( ++m_iTime > RED_CAPCOM_TIME ){
			m_iTime = 0;
			k7app.FadeStart( 0xff, LOGO_FADE_SPEED );
			m_Proc = eCapcomProc;
		}
		break;
		
//		JvRI		
	case	eCapcomProc:
		if( !k7app.IsFade() ){
			m_spCapLogo.SetVisible(false);
			m_spGhmLogo.SetVisible(true);
			m_spRed.SetColor( 0xffffffff );
			k7app.FadeStart( 0x00, LOGO_FADE_SPEED );			
			m_Proc = eGhmFadeStart;
		}
		break;
	
		
//		GHMԃtF[h҂		
	case	eGhmFadeStart:
		if( !k7app.IsFade() ){
			if( m_iTime == 0 )		gpSound->mPlaySE(SFX_LOGO_GHM);	//	C
			if( ++m_iTime == RED_TIME2 ){
				gpSound->mPlaySE(SFX_LOGO_RIFLE);	//	e
				m_spGhmLogo.SetVisible(false);		
				m_iTime = 0;
				m_spRed.SetColor( 0xff0000ff );
				m_Proc = eGhmRedProc;
			}
		}
		break;

//		GHMԂȂ		
	case	eGhmRedProc:
		m_spGhmLogo2.SetVisible(true);
		if( ++m_iTime > RED_GHM_TIME ){
			m_iTime = 0;
			k7app.FadeStart( 0xff, LOGO_GHM_SPEED );							
			m_Proc = eGhmProc;
		}
		break;

//		GHMI		
	case	eGhmProc:
		if( !k7app.IsFade() ){
			gpSound->mStopSE(SFX_LOGO_RIFLE);
			m_Proc = eLogoEnd;
		}
		break;

//		S̏I		
	case	eLogoEnd:
		if( DeleteTerminate()==true ){
			return true;
		}
		break;
	}

//		I		
	if( m_Proc >= eCardFade ){
		if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
			k7app.FadeStart( 0xff, 0 );
			DeleteTerminate();
		}	
	}
	gpSound->mFrameProcess(); 

	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7LogoTask::RenderProcess(void)
{
	if( m_Proc == eLoadProc ) return true;
	m_spRed.Render();
	m_spGulo.Render();
	m_spCapLogo.Render();
	m_spGhmLogo.Render();
	m_spGhmLogo2.Render();
	if( m_Proc == eCheckCard ){
		if( m_pSaveCheck != NULL )	m_pSaveCheck->RenderProcess();
	}
	return true;
}

//========================================================================
//					RXgN^
//========================================================================
SK7LogoTask::SK7LogoTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
}

//========================================================================
//					fXgN^
//========================================================================
SK7LogoTask::~SK7LogoTask()
{
}

//========================================================================
//					[h
//========================================================================
bool		SK7LogoTask::LoadTexture()
{
	int i;
	
	switch( m_Load ){
	case eLoadTex:
		if( m_File.OpenDataFile( LOGO_PACK_DATA, &m_pPackData ) ){

			ghmGcMemSetAllocName("LOGO");
			m_pTexture = new TEX_DATA[TEX_LOGO_MAX];
				
			if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
				return false;
			}
			//	eNX`[pbN		---------------------------------------
			for( i = 0; i < TEX_LOGO_MAX; i++ ){
				if( (m_pTexture[i].Header = (GhmGcTexHeader*)m_pResLink->GetResource(i))==NULL ){
					return false;
				}
				InitTexture( &m_pTexture[i] );
			}
			m_spGhmLogo.SetTexSprite( 192, -16, &m_pTexture[TEX_GHMLOGO] );
			m_spGhmLogo.SetVisible( false );
			
			m_spGhmLogo2.SetTexSprite( 192, -16, &m_pTexture[TEX_GHMLOGO1] );
			m_spGhmLogo2.SetVisible( false );

			m_spCapLogo.SetTexSprite( 64, 176, &m_pTexture[TEX_CAPCOM_LOGO_A3] ); 
			m_spCapLogo.SetColor	( 0x000000ff );
			m_spCapLogo.SetVisible( false );
			
			m_spGulo.SetTexSprite	( 0, 0, &m_pTexture[TEX_GULOTGA] );
			m_spGulo.SetVisible		( false );
			
			m_pSaveCheck = SK7SaveBase::Create( eBaseFirstCheck );
			m_Load = eLoadSaveData;
		}
		break;

	case eLoadSaveData:
		if( m_pSaveCheck->LoadData(LOAD_FONT) ){
			return true;
		}
		break;
	}
	return false;
}

