////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Logo Task
//
// SK7LogoTask.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7LOGOTASK_H__
#define	__SK7LOGOTASK_H__

#include "SK7Sprite.h"
#include "SK7SaveBase.h"
//#include "SK7SaveLoad.h"


enum{
	TEX_GULOTGA,
	TEX_GHMLOGO1,
	TEX_GHMLOGO,
	TEX_CAPCOM_LOGO_A3,
	TEX_LOGO_MAX,
};


//	S^XNNX
class SK7LogoTask : public ghmGcAppTask
{
	typedef enum{
		eLoadProc = 0,
		eCheckCard,
		eCardFade,
		eGuloFadeStart,
		eGuloProc,
		eGuloFadeEnd,
		eCapcomFadeStart,
		eCapcomFadeRed,
		eCapcomRedProc,
		eCapcomProc,
		eGhmFadeStart,
		eGhmFadeRed,
		eGhmRedProc,
		eGhmProc,
		eLogoEnd,
	}eLogoProc;
	
	typedef enum{
		eLoadTex=0,
		eLoadSaveData,
	}eDataProc;
			
protected:
	SK7Sprite			m_spCapLogo;
	SK7Sprite			m_spGhmLogo;
	SK7Sprite			m_spGhmLogo2;
	SK7Sprite			m_spRed;
	SK7Sprite			m_spGulo;
	SK7Sprite			m_spWhite;
	eLogoProc			m_Proc;
	eDataProc			m_Load;
	int					m_iTime;

	//	pbNt@C	-----------------------------------
	SK7File						m_File;
	ghmGcResLink*				m_pResLink;			//	N\[X
	void*						m_pPackData;		//	f[^
	TEX_DATA*					m_pTexture;			//	eNX`[f[^

//	SK7SaveLoad*				m_pSaveLoad;
	SK7SaveBase*				m_pSaveCheck;
	ghmGcTaskController *m_pTaskControl;	//	^XNRg[[
	
public:
	SK7LogoTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~SK7LogoTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	bool		LoadTexture();
};

#endif	//__SK7LOGOTASK_H__



