////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SK7MemoryCard
//
// SK7MemoryCard.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 07/08/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7MEMORYCARD_CPP__

#include "SK7MemoryCard.h"


//========================================================================
//					RXgN^
//========================================================================
SK7MemoryCard::SK7MemoryCard()
{
	CARDInit();
	m_sSectorSize[0]=m_sSectorSize[1]=0;
	m_pWorkErea = NULL;
	m_pCardInfo = NULL;
}

//========================================================================
//					fXgN^
//========================================================================
SK7MemoryCard::~SK7MemoryCard()
{
	DeleteCard();
}

//-----------------------------------------------------------------------------
//	֐	:	CreateCardData
//	Tv	:	J[hf[^쐬
//		:	
//	߂l	:	
//-----------------------------------------------------------------------------
void			SK7MemoryCard::CreateCard()
{
	DeleteCard();
	ghmGcMemSetAllocName("SAVEWORK");
	m_pWorkErea = new u8[CARD_WORKAREA_SIZE];
	ghmGcMemSetAllocName("SAVEINFO");
	m_pCardInfo = new CARDFileInfo;
}

//-----------------------------------------------------------------------------
//	֐	:	DeleteCard
//	Tv	:	J[hf[^폜
//		:	
//	߂l	:	
//-----------------------------------------------------------------------------
void			SK7MemoryCard::DeleteCard()
{
	GHM_SAFE_DELETE_ARRAY	( m_pWorkErea ); 
	GHM_SAFE_DELETE			( m_pCardInfo );	
}

//-----------------------------------------------------------------------------
//	֐	:	CreateCardInfo
//	Tv	:	J[hf[^쐬
//		:	
//	߂l	:	
//-----------------------------------------------------------------------------
void			SK7MemoryCard::CreateCardInfo()
{
	GHM_SAFE_DELETE			( m_pCardInfo );	
	ghmGcMemSetAllocName("SAVEINFO");
	m_pCardInfo = new CARDFileInfo;	
	memset( m_pCardInfo, 0, sizeof(CARDFileInfo) );
}

//-----------------------------------------------------------------------------
//	֐	:	GetCardInsert
//	Tv	:	J[h}`FbN
//		:	J[hXbg`ȁ
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::GetCardInsert( s32 SlotNo )
{	
	if( SlotNo > 1 )	return -1;
	return CARDProbeEx( SlotNo, NULL, &m_sSectorSize[SlotNo] );	//	XbgA 
}

//-----------------------------------------------------------------------------
//	֐	:	GetSectorSize
//	Tv	:	ZN^[8KB`FbN
//		:	Xbgm TCY
//	߂l	:	ZN^TCY`FbN true = T|[g false = m[T|[g
//-----------------------------------------------------------------------------
bool		SK7MemoryCard::GetSectorSize( s32 SlotNo )
{
	if( SlotNo > 1 )	return false;
	return ( (m_sSectorSize[SlotNo]/1024) != 8 ) ? false : true;
}

//-----------------------------------------------------------------------------
//	֐	:	SetCardMount
//	Tv	:	}Eg`FbN
//		:	XbgAJ[hR[obNA}EgIR[obN
//	߂l	:	
//-----------------------------------------------------------------------------
s32 		SK7MemoryCard::SetCardMount( s32 SlotNo )
{
	if( SlotNo > 1 )	return -1;
	return CARDMountAsync	( SlotNo, m_pWorkErea, NULL, NULL );	//	}Eg
}

//-----------------------------------------------------------------------------
//	֐	:	SetCardUnMount
//	Tv	:	A}Eg
//		:	Xbg
//	߂l	:	
//-----------------------------------------------------------------------------
s32		SK7MemoryCard::SetCardUnMount( s32 SlotNo )
{
	if( SlotNo > 1 )	return -1;
	return CARDUnmount( SlotNo );
}

//-----------------------------------------------------------------------------
//	֐	:	SetCardCheck
//	Tv	:	C\J[h`FbN
//		:	Xbg
//	߂l	:	
//-----------------------------------------------------------------------------
s32 		SK7MemoryCard::SetCardCheck( s32 SlotNo )
{
	if( SlotNo > 1 )	return -1;
	return CARDCheckAsync( SlotNo, NULL );	
}

//-----------------------------------------------------------------------------
//	֐	:	SetCardCheck
//	Tv	:	J[hI[v
//		:	Xbg, t@C
//	߂l	:	I[v
//-----------------------------------------------------------------------------
s32 			SK7MemoryCard::SetCardOpen( s32 SlotNo, char* FileName )
{
	if( SlotNo > 1 )	return -1;
	return CARDOpen	( SlotNo, FileName, m_pCardInfo );
}

//-----------------------------------------------------------------------------
//	֐	:	SetCardClose
//	Tv	:	J[hN[Y
//		:	
//	߂l	:	
//-----------------------------------------------------------------------------
s32  		SK7MemoryCard::SetCardClose()
{
	return CARDClose	( m_pCardInfo );
}

//-----------------------------------------------------------------------------
//	֐	:	SetCardRead
//	Tv	:	J[h[h
//		:	obt@ATCYAItZbg
//	߂l	:	
//-----------------------------------------------------------------------------
s32 		SK7MemoryCard::SetCardRead( void* Buff, s32 ReadSize,  s32 Offset )
{
	return CARDReadAsync( m_pCardInfo, Buff, ReadSize, Offset, NULL );
}

//-----------------------------------------------------------------------------
//	֐	:	SetCardReadB
//	Tv	:	J[h[hubN
//		:	obt@ATCYAItZbg
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::SetCardReadB( void* Buff, s32 ReadSize,  s32 Offset )
{
	return CARDRead( m_pCardInfo, Buff, ReadSize, Offset );
}

//-----------------------------------------------------------------------------
//	֐	:	SetCardFormat
//	Tv	:	J[h
//		:	Xbg
//	߂l	:	
//-----------------------------------------------------------------------------
s32		SK7MemoryCard::SetCardFormat( s32 SlotNo )
{
	if( SlotNo > 1 )	return -1;
	return CARDFormatAsync( SlotNo, NULL );
}
//-----------------------------------------------------------------------------
//	֐	:	SetCardFormat
//	Tv	:	J[h
//		:	Xbg
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::SetCardFormatB( s32 SlotNo )
{
	if( SlotNo > 1 )	return -1;
	return CARDFormat( SlotNo );
}

//-----------------------------------------------------------------------------
//	֐	:	SetCreateCard
//	Tv	:	t@C쐬
//		:	Xbg, t@Cl[
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::SetCreateCard( s32 SlotNo, char* FileName, u32 Size )
{
	if( SlotNo > 1 )	return -1;
	return CARDCreateAsync( SlotNo, FileName, Size, m_pCardInfo, NULL );
}

//-----------------------------------------------------------------------------
//	֐	:	SetCreateCard
//	Tv	:	t@C쐬
//		:	Xbg, t@Cl[
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::SetCreateCardB( s32 SlotNo, char* FileName, u32 Size )
{
	if( SlotNo > 1 )	return -1;
	return CARDCreate( SlotNo, FileName, Size, m_pCardInfo );
}

//-----------------------------------------------------------------------------
//	֐	:	SetCreateCard
//	Tv	:	t@C쐬
//		:	Xbg, t@Cl[
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::SetWriteCard( const void* Data, s32 Size, s32 Offset )
{
	return CARDWriteAsync	( m_pCardInfo, 	Data, 	Size,	Offset, NULL );	//	
}

//-----------------------------------------------------------------------------
//	֐	:	SetDeleteCard
//	Tv	:	t@C폜
//		:	Xbg, t@Cl[
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::SetDeleteCard( s32 SlotNo, char* FileName )
{
	if( SlotNo > 1 )	return -1;
	return CARDDeleteAsync( SlotNo, FileName, NULL );
}
//-----------------------------------------------------------------------------
//	֐	:	SetDeleteCardB
//	Tv	:	t@C폜
//		:	Xbg, t@Cl[
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::SetDeleteCardB( s32 SlotNo, char* FileName )
{
	if( SlotNo > 1 )	return -1;
	return CARDDelete( SlotNo, FileName );
}

//-----------------------------------------------------------------------------
//	֐	:	SetRenameCard
//	Tv	:	t@C̕ύX
//		:	Xbg, t@Cl[
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::SetRenameCard( s32 SlotNo, const char* OldName, const char* NewName )
{ 
	if( SlotNo > 1 )	return -1;
	return CARDRenameAsync( SlotNo, OldName, NewName, NULL );
}


//-----------------------------------------------------------------------------
//	֐	:	SetRenameCardB
//	Tv	:	t@C̕ύX
//		:	Xbg, t@Cl[
//	߂l	:	
//-----------------------------------------------------------------------------
s32		SK7MemoryCard::SetRenameCardB( s32 SlotNo, const char* OldName, const char* NewName )
{ 
	if( SlotNo > 1 )	return -1;
	return CARDRename( SlotNo, OldName, NewName );
}

//-----------------------------------------------------------------------------
//	֐	:	GetCheckErea
//	Tv	:	GA`FbN
//		:	Xbg
//	߂l	:	true = OK false = NO
//-----------------------------------------------------------------------------
bool 		SK7MemoryCard::GetCardErea( s32 SlotNo, int DataSize )
{
	if( SlotNo > 1 )	return false;
	s32 byte=0, filedir=0, nobyte=0;
	CARDFreeBlocks( SlotNo, &byte, &filedir );			//	TCYAt@C`FbN
	nobyte = (byte - DataSize);
	if( nobyte >= 0 && filedir > 0 )	return true;
	else								return false;
}

//-----------------------------------------------------------------------------
//	֐	:	GetCardStatus
//	Tv	:	XeC^X擾
//		:	Xbg
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::GetCardStatus( s32 SlotNo, CARDStat* CardState )
{
	if( SlotNo > 1 )	return -1;
	return CARDGetStatus( SlotNo, m_pCardInfo->fileNo, CardState);	//	XeC^XAhX̎擾	
}

//-----------------------------------------------------------------------------
//	֐	:	SetCardData
//	Tv	:	J[hZbg
//		:	Xbg
//	߂l	:	
//-----------------------------------------------------------------------------
s32			SK7MemoryCard::SetCardData( s32 SlotNo )
{
	if( SlotNo > 1 )	return -1;
	CARDStat CardState;
	CARDGetStatus( SlotNo, m_pCardInfo->fileNo, &CardState);	//	XeC^XAhX̎擾

	// Rg̃ItZbg
	CARDSetCommentAddress(&CardState,0);
	
	// oi[ƃACR̃ItZbg
	CARDSetIconAddress(&CardState, CARD_COMMENT_SIZE);

	// oi[tH[}bg
	CARDSetBannerFormat(&CardState, CARD_STAT_BANNER_RGB5A3);

	// ACRtH[}bg
	CARDSetIconFormat(&CardState, 0, CARD_STAT_ICON_RGB5A3);
	
	//	ACRAj[V
	CARDSetIconSpeed(&CardState, 0, CARD_STAT_SPEED_SLOW);
	CARDSetIconSpeed(&CardState, 1, CARD_STAT_SPEED_END);

	//	Xe[^XZbg
	return CARDSetStatusAsync( SlotNo, m_pCardInfo->fileNo, &CardState, NULL );	
}

