////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuBase
//
// SK7Moon.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7MOON_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "../wat/K7App.h"
#include "SK7Moon.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7GameInfo.h"



//========================================================================
//					RXgN^
//========================================================================
SK7Moon::SK7Moon( u8 StageNo )
{
	m_bRender 		= true;					// `tO
	m_bCtrl 		= false;				// 싖tO
	m_bMoveFlag 	= false;
	m_bChangeFlag 	= false;
	m_bSEFlag		= false;
	m_bMoonSeFlag	= false;

	m_ucStageNo 	= StageNo;
	m_iTime			= 0;
	m_iMoveTime		= 0;
	m_iChangeTime	= 0;
	m_iRenderTime	= 0;
	m_Proc			= PROC_LOAD;

	m_spMoon.SetXY0(0,0);
	m_spMoon.SetTexNo(0);
	m_spMoon.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
	
	HSD_VISetClearClr((GXColor){0,0,0,0xff});	
//	k7app.SetFadeColor( 0xff0000ff );
	memset(&m_vSpeed,0,sizeof(Vec));
	//	TEhf[^Ăяo
//	gpSound->mReadSsm("seSSelect.ssm",eBankScenario);
}


//========================================================================
//					fXgN^
//========================================================================
SK7Moon:: ~SK7Moon()
{
	//	TEhf[^J
//	gpSound->mReleaseSsm("seSSelect.ssm");
	GameInfo.SetNewGame( false );
	m_spMoon.Delete();
}



//========================================================================
//					t[
//========================================================================
bool  		SK7Moon::FrameProcess(void)
{
	switch( m_Proc )
	{
	case PROC_LOAD:
		if( LoadData( m_ucStageNo ))
		{
			k7app.FadeStart( 0, 9600 );
			m_Proc = PROC_DOWN_ALPHA;
		}
		break;
		
	case PROC_DOWN_ALPHA:
		if( !k7app.IsFade() )
		{
		//	gpSound->mSetDspRate( eSEGroupSystem00Env, 255 );
			gpSound->mPlaySE( SFX_SYS_MOON_LOW );
			
			m_Proc = PROC_MOVE_MOON;
		}
		break;
		
	case PROC_MOVE_MOON:
		if( m_bSEFlag && !m_bMoonSeFlag ){
			gpSound->mSetVolumeSE( SFX_SYS_MOON_LOW,  0, 300 );//1000 );
			m_bMoonSeFlag = true;
		}
		if( ++m_iTime <= FRAME_PROC_TIME )
		{
			MoveMoon();
			ChangeMoon();
		}
		else
		{
			m_iTime = 0;
			m_Proc = PROC_END;
		}
		break;
				
	case PROC_END:
		return true;
		break;
	}
	return false;
}


//========================================================================
//					_O
//========================================================================
bool  		SK7Moon::RenderProcess(void)
{
	if( !m_bRender )	return true;
	
	if( m_Proc > PROC_LOAD )	m_spMoon.Render();

	return true;
}


//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================	 
bool  		SK7Moon::GetFileReadEnd(void)
{
	if( m_Proc >= PROC_DOWN_ALPHA )
	{
		return true;
	}
	return false;
}


//========================================================================
//					II擾֐
//========================================================================	 
bool  		SK7Moon::GetMenuEnd(void)
{
	if( m_Proc == PROC_END )
	{
		return true;
	}
	return false;
}

//========================================================================
//					̓
//========================================================================	 
void  		SK7Moon::MoveMoon(void)
{
	//	삵ĂȂƂ
	if( !m_bMoveFlag )
	{
		f32 StopAngle = MTXDegToRad(rand()%360);
		m_vSpeed.x = (MOON_R * cosf(StopAngle)) / MOON_MOVE_FRAME;
		m_vSpeed.y = (MOON_R * cosf(StopAngle)) / MOON_MOVE_FRAME;
		m_bMoveFlag = true;
	}
	else//	쒆
	{
		if( ++m_iMoveTime <= MOON_MOVE_FRAME )
		{
			Vec vMoonPos = *m_spMoon.GetPos0();
			vMoonPos.x += m_vSpeed.x;
			vMoonPos.y += m_vSpeed.y;
			m_spMoon.SetPos0( vMoonPos );
		}else{
			m_iMoveTime = 0;
			m_bMoveFlag = false;
		}
	}
}


//========================================================================
//					̃f[^̕ύX
//========================================================================	 
void  		SK7Moon::ChangeMoon(void)
{
	//	`FWԐݒ
	if( !m_bChangeFlag )
	{
		m_iChangeTime = 40;
		m_bChangeFlag = true;
	}
	else
	{
		if( ++m_iRenderTime == m_iChangeTime )
		{
			gpSound->mStopSE( SFX_SYS_MOON_LOW );
			gpSound->mPlaySE( SFX_SYS_MOON_HIGH, 3 );
			m_spMoon.SetTexNo(1);	
		}
		else
		if( m_iRenderTime > m_iChangeTime+2 )
		{
			gpSound->mStopSE( SFX_SYS_MOON_HIGH );
			gpSound->mPlaySE( SFX_SYS_MOON_LOW  );
			if( !m_bSEFlag && m_iTime >= 90 ){
				m_bSEFlag = true;
			}
			m_spMoon.SetTexNo(0);
			m_iRenderTime = 0;
			m_bChangeFlag = false;
		}
	}
}
		


//========================================================================
//					II擾֐
//========================================================================	 
bool  		SK7Moon::LoadData(u8 No)
{
	switch( No )
	{
	case 0:	if( m_spMoon.LoadTexture( BLUE_MOON_DATA,	1,2 ) )		return true;
	case 1: if( m_spMoon.LoadTexture( RED_MOON_DATA,	1,2 ) )		return true;
	case 2:	if( m_spMoon.LoadTexture( CHAOS_MOON_DATA,	1,2 ) )		return true;
	case 3: if( m_spMoon.LoadTexture( GURITTA_MOON_DATA,1,2 ) )		return true;
	case 4:	if( m_spMoon.LoadTexture( ANIME_MOON_DATA,	1,2 ) )		return true;
	case 5: if( m_spMoon.LoadTexture( DARK_MOON_DATA,	1,2 ) )		return true;
	case 6: if( m_spMoon.LoadTexture( END_MOON_DATA,	1,2 ) )		return true;
	}
	return false; 
}
