////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Moon
//
// SK7Moon.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/14/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7MOON_H__
#define	__SK7MOON_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "SK7Sprite.h"

#define		BLUE_MOON_DATA			"/scenario/moon/bmoon0.BIN"
#define		RED_MOON_DATA			"/scenario/moon/rmoon0.BIN"
#define		CHAOS_MOON_DATA			"/scenario/moon/cmoon0.BIN"//JIXu_jv
#define		GURITTA_MOON_DATA		"/scenario/moon/ymoon0.BIN"//Ob^[u琁v
#define		ANIME_MOON_DATA			"/scenario/moon/amoon0.BIN"//AjCebhugv
#define		DARK_MOON_DATA			"/scenario/moon/dmoon0.BIN"//_[NuΊv
#define		END_MOON_DATA			"/scenario/moon/e_moon.BIN"

#define		DOWN_SPEED				(5)
#define		ADD_SPEED				(2)
#define		MOON_MOVE_FRAME			(3)
#define		MOON_R					(1.0f)
#define		FRAME_PROC_TIME			(150)

//	NX
class SK7Moon
{
	typedef enum{
		PROC_LOAD=0,
		PROC_DOWN_ALPHA,
		PROC_MOVE_MOON,
		PROC_ADD_ALPHA,
		PROC_END,
	}eProc;

protected:
	bool						m_bRender;				// `tO
	bool						m_bCtrl;				// 싖tO
	bool						m_bMoveFlag;
	bool						m_bChangeFlag;
	bool						m_bSEFlag;
	bool						m_bMoonSeFlag;
	
	u8							m_ucStageNo;
	int							m_iTime;
	int							m_iMoveTime;
	int							m_iChangeTime;
	int							m_iRenderTime;
//	int							m_i
	eProc						m_Proc;
	
	Vec							m_vSpeed;							
	
	SK7Sprite					m_spMoon;
	SK7Sprite					m_spFade;

public:
	SK7Moon( u8 StageNo );
	~SK7Moon();

	// t[
	bool  FrameProcess(void);
	
	// _O
	bool  RenderProcess(void);
	
	// t@CǂݍݏI擾֐
	bool  GetFileReadEnd(void);

	// II擾֐
	bool  GetMenuEnd(void);

	// 싖ݒ֐
	void  SetCtrlFlag(bool flag){ m_bCtrl=flag; }

	// _O
	void  SetRender(bool flag){ m_bRender=flag; }
	
	//	[h
	bool	LoadData(u8 No);
	
	
	//	̓
	void	MoveMoon(void);
	void	ChangeMoon(void);
};

#endif	//__SK7MOON_H__
