////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7NextTask.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/18/2003
//	
////////////////////////////////////////////////////////////////////////////////

#define	__SK7NEXTTASK_CPP__
//#define	__DEBUG_TASK__

#include "../wat/WK7MainTask.h"
#include "SK7NextTask.h"
#include "..\Matsu\mK7Sound.h"
#include "SK7EndSaveTask.h"
#include "../wat/K7GlobalFlag.h"
#include "../wat/WK7EventScript.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7Archive.h"
#include "../yam/YK7EffectNoise.h"
#include "SK7LogoTask.h"

#define		FADE_SPEED				(WK7_SEC_TO_TICK(1.4f))
#define		NEXT_PACK_DATA			"/scenario/next.pak"
#define		MES_X					(124)
#define		MES_Y					(203)
#define		DRAW_TIME				(150)

const u8	tblRollTime[]={ 30, 20, 25, 35, 15, 22 };

const VEC2 tblNoPos[]={
	369.0f,201.0f,
	388.0f,198.0f,
	410.0f,198.0f,
	430.0f,198.0f,
	451.0f,196.0f,
};

const VEC2 tblScnPos[]={
	436,395,
	434,395,
	428,393,
	437,398,
	432,396,
	225,173,
};

//========================================================================
//					RXgN^
//========================================================================
SK7NextTask::SK7NextTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	m_eProc 	= eLoad;
	m_eLoad		= eLTexture;
	m_eHSProc	= eHSFirst;
	m_pFile		= NULL;
	m_iTime		= 0;
	m_ucBigNo	= 4;
	memset( m_iCountTime, 0, sizeof( int )*COUNT_NUM );
	memset( m_bCountFlag, false, sizeof( bool )*COUNT_NUM );
	memset( m_bMoveFlag, false, sizeof( bool )*COUNT_NUM );
	memset( m_chHsNum, 0, sizeof( u8 )*COUNT_NUM );
}


//========================================================================
//					fXgN^
//========================================================================
SK7NextTask::~SK7NextTask()
{
}


//========================================================================
//					
//========================================================================
bool 	SK7NextTask::InitializeCallBack(void)
{	
	ghmGcMemSetAllocName("SK7NEXT");
	m_pFile = new SK7File;
	if( !K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) ){
		k7app.SetFadeColor(0x000000ff);
	}else{
		k7app.FadeStart(0x00,0);
	}
	ghmGcMemSetAllocName("SK7NEXT");
	m_pTaskControl = new ghmGcTaskController;
	m_pTaskControl->Initialize();
	EffectInit( m_pTaskControl, 200 );
	screenImageFullColor.SetFormat(GX_TF_RGBA8);
	screenImageFullColor.AllocBuffer();

	m_spBlack.SetSprite( 0,0,640,480,0x000000ff );
	m_spBlack.SetVisible( true );

	return true;
}


//========================================================================
//					I
//========================================================================
bool 	SK7NextTask::TerminateCallBack(void)
{
//	gpSound->mReleaseSsm("seSTitle.ssm");
	GHM_SAFE_DELETE( m_pFile );			
	for( int i = 0; i < TEX_NEXT_MAX; i++ )	GHM_SAFE_DELETE	( m_pTexture[i] );
	GHM_SAFE_DELETE	( m_pResLink );
	//	RcGtFNgI
	EffectEnd();
	GHM_SAFE_DELETE(m_pTaskControl);
	
	screenImageFullColor.FreeBuffer();

 	ghmGcApp *pApp = GetApplication();
	delete this;
	k7app.SetFadeColor(0x00000000);
	k7app.FadeStart(0xff,0);
	if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) != true ){
		new SK7EndSaveTask(pApp);
	}else{
		K7SCR_RESET_GLOBAL_FLAG( K7GLFL_HOPPER7 );
		new SK7LogoTask(pApp);
	}

	return true;
} 


//========================================================================
//					t[
//========================================================================
bool 	SK7NextTask::FrameProcess(void)
{ 
	switch( m_eProc ){
	//	[h
	case eLoad:
		if( Load() ){
			m_bRender = true; 
			if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) != true ){
				k7app.FadeStart(0x00,FADE_SPEED);			//	CtF[h
				m_eNext = eHSMain;
				m_eProc = eFade;
			}else{
				AddNoiseLine( m_pEffect, (u8)VParam[ED_CHARCHANGE][3], VParam[ED_CHARCHANGE][4], VParam[ED_CHARCHANGE][5], VParam[ED_CHARCHANGE][6], -1 ) ;
				gpSound->mPlaySE( SFX_SYS_SCENARIO_TITLE_NOIZ );
				m_eNext = eMesMain;
				m_eProc = eNoise;
//				m_eProc = eHopperFade;
			}
		}
		break;
		
	case eHopperFade:
		AddNoiseLine( m_pEffect, (u8)VParam[ED_CHARCHANGE][3], VParam[ED_CHARCHANGE][4], VParam[ED_CHARCHANGE][5], VParam[ED_CHARCHANGE][6], -1 ) ;
		gpSound->mPlaySE( SFX_SYS_SCENARIO_TITLE_NOIZ );
		switch( m_eNext ){
		case eHSMain:
			for( int i = 0; i < COUNT_NUM; i++ ){
				m_spBG.SetTexSprite	( MES_X, MES_Y, m_pTexture[TEX_NEXT_HS_MSG2] );
				m_spCount[i].SetVisible( true );
				if( i >= m_ucBigNo )		m_spCountPlus[i].SetVisible ( true );
				else						m_spCountPlus[i].SetVisible ( false );
			}
			break;
		}
		m_eProc = eNoise;
		break;
		
	//	tF[h
	case eFade:
		if( !k7app.IsFade() ){
			if( m_eNext != eHSMain ){
				AddNoiseLine( m_pEffect, (u8)VParam[ED_CHARCHANGE][3], VParam[ED_CHARCHANGE][4], VParam[ED_CHARCHANGE][5], VParam[ED_CHARCHANGE][6], -1 ) ;
				gpSound->mPlaySE( SFX_SYS_SCENARIO_TITLE_NOIZ );
			}
			switch( m_eNext ){
			case eMesMain:
				for( int i = 0; i < COUNT_NUM; i++ ){
					m_spCount[i].SetVisible		( false );
					m_spCountPlus[i].SetVisible	( false );
				}
				m_spBG.SetTexSprite( 83, 159, m_pTexture[TEX_NEXT_MSG00+GameInfo.GetScenarioID()] );
				break;
			case eNextMain:
				if( GameInfo.GetScenarioID() == 5 )	m_spBG.SetVisible	( false );			
				m_spBG.SetTexSprite( 0, 0, m_pTexture[TEX_NEXT_ZOKU] );	
				m_spScn.SetVisible( true );
				break;
			}
			k7app.FadeStart(0x00,0);
			if( m_eNext == eHSMain )	m_eProc = eHSMain;
			else						m_eProc = eNoise;
		}
		break;
		
	
	//	mCY
	case eNoise:
		if( GetNoiseLineNum( m_pEffect ) == 0 ){
			m_eProc = m_eNext;
		}
		break;
	
	//	gr	
	case eHSMain:
		if( FrameProcessHS() ){
			if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) != true ){
				k7app.FadeStart(0xff,FADE_SPEED);
				m_eNext = eMesMain;
				m_eProc = eFade;
			}else{
				DeleteEffect( m_pEffect );
				k7app.FadeStart(0xff,FADE_SPEED*2);
				m_eProc = eEnd;				
			}
		}
		break;

	//	bZ[W
	case eMesMain:
		if( FrameProcessDraw() ){
			if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) != true ){
				k7app.FadeStart(0xff,FADE_SPEED);
				m_eNext = eNextMain;
				m_eProc = eFade;
			}else{
				m_eNext = eHSMain;
				m_eProc = eHopperFade;
			}
		}
		break;
		
	//	
	case eNextMain:
		if( FrameProcessDraw() ){
			DeleteEffect( m_pEffect );
			k7app.FadeStart(0xff,FADE_SPEED*2);
			m_eProc = eEnd;	
		}
		break;
		
	//	I
	case eEnd:
		if( !k7app.IsFade() ){
			if( DeleteTerminate()==true ){
				return true;
			}
		}
		break;
	}
	SetEffectCamera(WK7CAM->GetCObj());
	WK7Archive::FrameProcessAll();
	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7NextTask::RenderProcess(void)
{
	if( m_eProc <= eLoad )	return true;
	
	int i;
	m_spBlack.Render();
	m_spBG.Render();
	for( i = 0; i < COUNT_NUM; i++ ){
		m_spCount[i].Render();
		m_spCountPlus[i].Render();
	}
	m_spScn.Render();
	m_pTaskControl->FrameProcess();
	return true;
}


//========================================================================
//					[h
//========================================================================
bool	SK7NextTask::Load()
{
	int i;
	
	switch( m_eLoad ){
	case eLTexture:
		if( m_pFile->OpenDataFile( NEXT_PACK_DATA, &m_pPackData ) ){
			ghmGcMemSetAllocName("SK7NEXT");
			if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
				return false;
			}
			for( i = 0; i < TEX_NEXT_MAX; i++ ){
				ghmGcMemSetAllocName("SK7NEXT");
				m_pTexture[i] = new TEX_DATA;
				if( (m_pTexture[i]->Header = (GhmGcTexHeader*)m_pResLink->GetResource(i))==NULL ){
					return false;
				}
				InitTexture( m_pTexture[i] );
			}
			//	G̐
#ifdef __DEBUG_TASK__
			u32 num = 1040;
#else
			u32 num = BattleCtrl.GetTotalEnemyHunt();
			if( num > 99999 ) num = 99999;
#endif
			m_chHsNum[0]	= (s8)(num/10000);
			m_chHsNum[1]	= (s8)((num%10000)/1000);
			m_chHsNum[2] 	= (s8)((num%1000)/100);
			m_chHsNum[3]	= (s8)((num%100)/10);
			m_chHsNum[4]	= (s8)(num%10);
			//	ԑ傫
			for( i = 0; i < COUNT_NUM; i++ ){
				if( m_chHsNum[i] == 0 )	continue;
				m_ucBigNo = (u8)i;
				break;
			}
			
			for( i = 0; i < COUNT_NUM; i++ ){
				m_spCount[i].SetTexture		( m_pTexture[TEX_NEXT_H10000-i], 1, 10, 0 );
				m_spCount[i].SetXYTwo		( tblNoPos[i].x, tblNoPos[i].y, tblNoPos[i].x+m_spCount[i].GetTexSizeX(), tblNoPos[i].y+m_spCount[i].GetTexSizeY(true) );
				m_spCount[i].SetFlag		( true, VTX4_FLAG );
				m_spCount[i].SetAlpha		( 230 );
				m_spCountPlus[i].SetTexture	( m_pTexture[TEX_NEXT_H10000-i], 1, 10, 1 );
				m_spCountPlus[i].SetXYTwo	( tblNoPos[i].x, tblNoPos[i].y, tblNoPos[i].x+m_spCount[i].GetTexSizeX(), tblNoPos[i].y );
				m_spCountPlus[i].SetSTTwo	( 0.0f, 1.0f, 1.0f, 1.0f );
				m_spCountPlus[i].SetFlag	( true, VTX4_FLAG );
				m_spCountPlus[i].SetAlpha	( 230 );
				if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) != true ){
					m_spCount[i].SetVisible( true );
					if( i >= m_ucBigNo )		m_spCountPlus[i].SetVisible ( true );
					else						m_spCountPlus[i].SetVisible ( false );
				}else{
					m_spCount[i].SetVisible( false );					
					m_spCountPlus[i].SetVisible ( false );
				}
			}
			if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) != true ){
				m_spBG.SetTexSprite	( MES_X, MES_Y, m_pTexture[TEX_NEXT_HS_MSG] );
			}else{
				m_spBG.SetTexSprite( 83, 159, m_pTexture[TEX_NEXT_MSG06] );
			}
			m_spBG.SetVisible	( true );

#ifdef __DEBUG_TASK__
			int ScnNo = 0;//GameInfo.GetScenarioID();
#else
			int ScnNo = GameInfo.GetScenarioID();	
#endif
			m_spScn.SetTexSprite( tblScnPos[ScnNo].x, tblScnPos[ScnNo].y, m_pTexture[TEX_NEXT_RAKUJITU+ScnNo] );
			m_spScn.SetVisible	( false );
			
			GHM_SAFE_DELETE( m_pFile );
			m_eLoad = eLEffect;
		}
		break;
			
	case eLEffect:
		if( EffectSetupCheck() == TRUE ){
			m_pEffect = CreateNoiseEffect();
			SetEffectCamera( WK7CAM->GetCObj() );
			return true;
		}
		break;
	}
	return false;
}


//========================================================================
//					wuX}C̈ړ
//========================================================================
bool	SK7NextTask::FrameProcessHS()
{
	int num=0;
	int i;
	switch( m_eHSProc ){
	case eHSFirst:
		
		//	Ԑݒ	----------------------------------
		if( !m_bCountFlag[m_ucBigNo] ){
			m_iTime++;
			if( ++m_iTime > 20 ){
				m_iTime = 0;
				int move = (rand()%COUNT_NUM);
				if( !m_bCountFlag[move] && (m_ucBigNo) != move ){
					gpSound->mPlaySE( SFX_SYS_HS_COUNT );
					m_bCountFlag[move] = true;
				}else{
					int countnum=0;
					for( i = 0; i < COUNT_NUM; i++ ){
						if( m_bCountFlag[i] ){
							if( ++countnum >= COUNT_NUM-1 ){
								m_bCountFlag[m_ucBigNo] = true;
								gpSound->mPlaySE( SFX_SYS_HS_COUNT );
								break;
							}
							continue;
						}
						if( i == (m_ucBigNo) )	continue;
						gpSound->mPlaySE( SFX_SYS_HS_COUNT );
						m_bCountFlag[i] = true;
						break;
					}	
				}
			}
		}
		//	]	-------------------------------------------
		for( i = 0; i < COUNT_NUM; i++ ){
			if( !m_bCountFlag[i] )	continue;
			if( (m_ucBigNo != i && m_ucBigNo < i) || (i==COUNT_NUM-1 && m_ucBigNo==3) ){
				if( m_chHsNum[i] == 0 ){
					if( ++num >= COUNT_NUM ){
						gpSound->mPlaySE( SFX_SYS_HS_TOTAL );
						m_iCountTime[i] = 0;
						m_iTime = 0;
						m_eHSProc = eHSMove;
						continue;
					}
					continue;
				}
			}
			if( ++m_iCountTime[i] <= tblRollTime[i] ){
				if( m_ucBigNo == COUNT_NUM-1 && 0 == m_chHsNum[COUNT_NUM-1] && i == COUNT_NUM-1 ) continue;
				if( !m_bMoveFlag[i] )	SetRollNo( &m_spCount[i], &m_spCountPlus[i],  tblRollTime[i] );
				else					SetRollNo( &m_spCountPlus[i], &m_spCount[i],  tblRollTime[i] );
				//	1]IƂ
				if( m_iCountTime[i] == tblRollTime[i] ){
					m_chHsNum[i]--;
					if( m_chHsNum[i] > 0 ){
						m_iCountTime[i] = 0;
						if( !m_bMoveFlag[i] ){
							m_spCount[i].SetTexNo	( (u16)(m_spCountPlus[i].GetTexNo()+1) );
							m_spCount[i].SetXYTwo	( tblNoPos[i].x, tblNoPos[i].y, tblNoPos[i].x+m_spCount[i].GetTexSizeX(), tblNoPos[i].y );
							m_spCount[i].SetSTTwo	( 0.0f, 1.0f, 1.0f, 1.0f );
						}else{
							m_spCountPlus[i].SetTexNo	( (u16)(m_spCount[i].GetTexNo()+1) );
							m_spCountPlus[i].SetXYTwo	( tblNoPos[i].x, tblNoPos[i].y, tblNoPos[i].x+m_spCountPlus[i].GetTexSizeX(), tblNoPos[i].y );
							m_spCountPlus[i].SetSTTwo	( 0.0f, 1.0f, 1.0f, 1.0f );
						}
						if( !m_bMoveFlag[i] ){
							m_bMoveFlag[i] = true;
							gpSound->mPlaySE( SFX_SYS_HS_COUNT );
						}else{
							m_bMoveFlag[i] = false;
						}
					}
				}
			}else{
				if( ++num >= COUNT_NUM ){
					gpSound->mPlaySE( SFX_SYS_HS_TOTAL );
					m_iCountTime[i] = 0;
					m_iTime = 0;
					m_eHSProc = eHSMove;
				}
			}
		}
		break;
	case eHSMove:		
		if( ++m_iTime > DRAW_TIME ){
			m_iTime = 0;
			return true;
		}
		break;
	}
	return false;
}

//========================================================================
//					
//========================================================================
bool	SK7NextTask::FrameProcessDraw()
{
	if( ++m_iTime > DRAW_TIME ){
		m_iTime = 0;
		return true;
	}
	return false;
}

//========================================================================
//					[]
//========================================================================
void	SK7NextTask::SetRollNo( SK7Sprite* pDown, SK7Sprite* pUp, int Time )
{
	if( pDown != NULL ){
		f32 T0 = (pDown->GetY2()-pDown->GetY0())/pDown->GetTexSizeY(true);
		pDown->SetY0	( pDown->GetY0()+(f32)(pDown->GetTexSizeY(true)/Time) );
		pDown->SetY1	( pDown->GetY1()+(f32)(pDown->GetTexSizeY(true)/Time) );
		pDown->SetSTTwo	( 0.0f, 0.0f, 1.0f, T0 );
	}
	if( pUp != NULL ){
		f32 T1 = (pUp->GetY2()-pUp->GetY0())/pUp->GetTexSizeY(true);
		pUp->SetY2		( pUp->GetY2()+(f32)(pUp->GetTexSizeY(true)/Time) );
		pUp->SetY3		( pUp->GetY3()+(f32)(pUp->GetTexSizeY(true)/Time) );
		pUp->SetSTTwo	( 0.0f, T1, 1.0f, 1.0f );
	}
}

