////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Logo Task
//
// SK7NextTask.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7NEXTTASK_H__
#define	__SK7NEXTTASK_H__

#include "SK7Common.h"
#include "SK7Sprite.h"
#include "../yam/YK7Effect.h"

//	eNX`[f[^
enum{
	TEX_NEXT_MSG00=0,
	TEX_NEXT_MSG01,
	TEX_NEXT_MSG02,
	TEX_NEXT_MSG03,
	TEX_NEXT_MSG04,
	TEX_NEXT_MSG05,
	TEX_NEXT_MSG06,

	TEX_NEXT_RAKUJITU,
	TEX_NEXT_KUMOOTOKO,
	TEX_NEXT_KAIKOU,
	TEX_NEXT_BUNSHIN,
	TEX_NEXT_EGAO,
	TEX_NEXT_SYUMAKU,
	TEX_NEXT_ZOKU,
	
	TEX_NEXT_HS_MSG,
	TEX_NEXT_HS_MSG2,
	TEX_NEXT_H00001,
	TEX_NEXT_H00010,
	TEX_NEXT_H00100,
	TEX_NEXT_H01000,
	TEX_NEXT_H10000,
	TEX_NEXT_MAX,
};

#define		COUNT_NUM			(5)

//	փNX
class SK7NextTask : public ghmGcAppTask
{	
	typedef enum{
		eLoad=0,
		eFade,
		eHopperFade,
		eNoise,
		eHSMain,
		eMesMain,
		eNextMain,
		eEnd,
	}eProc;
	
	typedef enum{
		eLTexture=0,
		eLEffect,
	}eData;
	
	typedef enum{
		eHSFirst=0,
		eHSMove,
	}eHSProc;
	
protected:
	SK7Sprite			m_spBlack;
	SK7Sprite			m_spBG;
	SK7Sprite			m_spScn;
	SK7Sprite			m_spCount[COUNT_NUM];
	SK7Sprite			m_spCountPlus[COUNT_NUM];
	eProc				m_eProc;
	eProc				m_eNext;
	eData				m_eLoad;
	eHSProc				m_eHSProc;
	bool				m_bRender;
	bool				m_bCountFlag[COUNT_NUM];
	bool				m_bMoveFlag[COUNT_NUM];
	int					m_iTime;
	int					m_iCountTime[COUNT_NUM];
	s8					m_chHsNum[COUNT_NUM];
	u8					m_ucBigNo;
	EFFECT*				m_pEffect;

	//	pbNf[^	=========================================
	SK7File*			m_pFile;
	ghmGcResLink*		m_pResLink;	//	N\[X
	TEX_DATA*			m_pTexture[TEX_NEXT_MAX];	//	
	void*				m_pPackData;	//	f[^

	ghmGcTaskController *m_pTaskControl;	//	^XNRg[[

//	֐	------------------------------------------------------	
	bool				FrameProcessHS();		//	grvZX
	bool				FrameProcessDraw();
	void				SetRollNo( SK7Sprite*, SK7Sprite*, int );

public:
	SK7NextTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~SK7NextTask();

	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);

	bool Load();
};

#endif	//__SK7NEXTTASK_H__



