////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Pack
//
// SK7Pack.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PACK_CPP__

#include "SK7Common.h"
#include "SK7Pack.h"
#include "WK7GameInfo.h"
#include "SK7SpOption.h"
#include "SK7Special.h"	
#include "../Yam/YK7EffectCharge.h"


//	et@C	::::::::::::::::::::::::::::::::::::::::::::::
#define		SPECIAL_DATA		"/sub/Special.pak"

//	O[oϐ	======================================================
SK7SpecialData*	g_pSpData=NULL;
SK7StageData*	g_pStageData=NULL;

/***************	SK7SpecialData	***********************/

//========================================================================
//					RXgN^
//========================================================================
SK7SpecialData::SK7SpecialData()
{
	m_eProc = PROC_LOAD_TEXTURE;
}

//========================================================================
//					fXgN^
//========================================================================
SK7SpecialData::~SK7SpecialData()
{
}

//========================================================================
//					
//========================================================================
void	SK7SpecialData::Initialize()
{	
	for( int i = 0; i < TEX_MAX-TEXTURE_NOT_NUM; i++ ){
		m_ptTexData[i] = NULL;
	}
	m_pYFontData[0] = NULL;
	m_pYFontData[1] = NULL;
	m_pResLink	 	= NULL;
	m_pPackData		= NULL;
	m_pFile			= NULL;
	ghmGcMemSetAllocName("SFILE");
	m_pFile			= new SK7File;
	m_eProc 		= PROC_LOAD_TEXTURE;
}


//========================================================================
//					ǂݍݏI`FbN
//========================================================================
bool	SK7SpecialData::GetFileReadEnd()
{
	if( m_eProc == PROC_END ){
		return true;	//	ǂݍݏI
	}
	return false;
}

//========================================================================
//					ԃ`FbN
//========================================================================
u8	SK7SpecialData::GetState()
{
	return m_eProc;
}

//========================================================================
//					t[
//========================================================================
void	SK7SpecialData::FrameProcess()
{
	int i = 0;
	switch( m_eProc ){
	case PROC_LOAD_TEXTURE:
		if( m_pFile->OpenDataFile( SPECIAL_DATA, &m_pPackData ) ){			
			if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
				break;
			}
			if( (m_pYFontData[0] = (void*)m_pResLink->GetResource(TEX_YAMADA_FONT))==NULL ){
				break;
			}
			if( (m_pYFontData[1] = (void*)m_pResLink->GetResource(TEX_BLOOD_FONT))==NULL ){
				break;
			}			
			for( i = 0; i < TEX_MAX-TEXTURE_NOT_NUM; i++ ){
				ghmGcMemSetAllocName("STEXDATA");
				m_ptTexData[i] = new TEX_DATA;
				if( (m_ptTexData[i]->Header = (GhmGcTexHeader*)m_pResLink->GetResource(i+TEXTURE_NOT_NUM))==NULL ){
					break;
				}
				InitTexture( m_ptTexData[i] );
			}
			//	TuʍXV
			if( GameInfo.GetSpOption() != NULL ){
				GameInfo.GetSpOption()->SetControl(true);
				GameInfo.GetSpOption()->SetRender(true);
			}
			if( GameInfo.GetSpecial() != NULL ){
				GameInfo.GetSpecial()->SetCtrlFlag(true);
				GameInfo.GetSpecial()->SetRender(true);
			}
			SetupChargeEffect();
			GHM_SAFE_DELETE( m_pFile );			
			m_eProc = PROC_EFFECT;
		}
		break;
		
	case PROC_EFFECT:
		if( CheckSetupChargeEffect() == TRUE ){
			m_eProc = PROC_END;
		}
		break;
		
	case PROC_END:
		break;
	}
}


//========================================================================
//					J
//========================================================================
void	SK7SpecialData::Terminate()
{
	ReleaseChargeEffect();
	for( int i = 0; i < TEX_MAX-TEXTURE_NOT_NUM; i++ ){
		GHM_SAFE_DELETE( m_ptTexData[i] );
	}
	GHM_SAFE_DELETE	( m_pResLink );
	GHM_SAFE_DELETE( m_pFile );
	//	TuʍXVXgbv
	if( GameInfo.GetSpOption() != NULL ){
		GameInfo.GetSpOption()->SetControl(false);
		GameInfo.GetSpOption()->SetRender(false);
	}
	if( GameInfo.GetSpecial() != NULL ){ 
		GameInfo.GetSpecial()->SetCtrlFlag(false);
		GameInfo.GetSpecial()->SetRender(false);
	}
}


/***************	SK7StageData	***********************/

//	IvVpbN	
static char* tblOptionPack[]={
	 "/sub/OptionCel.pak",//K7SCNF_CEL
	 "/sub/OptionFuk.pak",//K7SCNF_FUK
	 "/sub/OptionKak.pak",//K7SCNF_KAK
	 "/sub/OptionTx1.pak",//K7SCNF_TX1
	 "/sub/OptionIsz.pak",//K7SCNF_ISZ
	 "/sub/OptionCur.pak",//K7SCNF_CUR
	 "/sub/OptionDm1.pak",//K7SCNF_DM1
	 "/sub/OptionDm1.pak",//K7SCNF_DM2
	 "/sub/OptionHt1.pak",//K7SCNF_HT1
	 "/sub/OptionScl.pak",//K7SCNF_SCL
	 "/sub/OptionHt1.pak",//K7SCNF_HT2
	 "/sub/OptionGnk.pak",//K7SCNF_GNK
};                        
                          
//========================================================================
//					RXgN^
//========================================================================
SK7StageData::SK7StageData()
{
	m_eProc = PROC_LOAD_TEXTURE;
}

//========================================================================
//					fXgN^
//========================================================================
SK7StageData::~SK7StageData()
{
}

//========================================================================
//					
//========================================================================
void	SK7StageData::Initialize()
{	
	for( int i = 0; i < STAGE_TEX_MAX; i++ )	m_ptTexData[i] = NULL;
	m_pResLink	 	= NULL;
	m_pPackData		= NULL;
	m_pFile			= NULL;
	ghmGcMemSetAllocName("SFILE");
	m_pFile			= new SK7File;
	m_iFlow			= 0;
	m_eProc = PROC_LOAD_TEXTURE;
}


//========================================================================
//					ǂݍݏI`FbN
//========================================================================
bool	SK7StageData::GetFileReadEnd()
{
	if( m_eProc == PROC_END ){
		return true;	//	ǂݍݏI
	}
	return false;
}

//========================================================================
//					ǂݍݏI`FbN
//========================================================================
u8	SK7StageData::GetState()
{
	return m_eProc;
}


//========================================================================
//					t[
//========================================================================
void	SK7StageData::FrameProcess()
{
	int i = 0;
	int StageTexNum = 2;
	
	switch( m_eProc ){
	case PROC_LOAD_TEXTURE:
		
		if( GameInfo.GetScenarioID() < 0 || GameInfo.GetScenarioID() > 12 ){
			m_eProc = PROC_END;
			break;
		}
	 	m_iFlow = GameInfo.GetScenarioFlow();
		//	ACe	^----------------------------------------
		switch( GameInfo.GetScenarioFlow() ){
		case K7SCNF_TXS:  	StageTexNum = 4;	break;
		case K7SCNF_DM1:    
		case K7SCNF_DM2:   
		case K7SCNF_SCL:	StageTexNum = 3;	break;
		}
		if( m_pFile->OpenDataFile( tblOptionPack[m_iFlow], &m_pPackData ) ){
			if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
				break;
			}
			for( int i = 0; i < StageTexNum; i++ ){
				ghmGcMemSetAllocName("STEXDATA");
				m_ptTexData[i] = new TEX_DATA;
				if( (m_ptTexData[i]->Header = (GhmGcTexHeader*)m_pResLink->GetResource(i))==NULL ){
					break;
				}
				InitTexture( m_ptTexData[i] );
			}
			GHM_SAFE_DELETE( m_pFile );			
			m_eProc = PROC_END;
		}
		break;

	case PROC_END:
		break;
	}
}


//========================================================================
//					J
//========================================================================
void	SK7StageData::Terminate()
{
	GHM_SAFE_DELETE( m_pFile );			
	for( int i = 0; i < STAGE_TEX_MAX; i++ )	GHM_SAFE_DELETE	( m_ptTexData[i] );
	GHM_SAFE_DELETE	( m_pResLink );	
}
