////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SaveBase
//
// SK7SaveBase.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SAVEBASE_H__
#define	__SK7SAVEBASE_H__

#include "SK7Common.h"
#include "SK7MemoryCard.h"
#include "SK7SaveLoadMessage.h"
#include "DVDBanner.h"
#include "SK7SaveData.h"
#include "../Yam/YK7Effect.h"

#define		ICON_TEX_1				"/item/icon8.BIN"
#define		ICON_TEX_7				"/item/icon7.BIN"
#define		ICON_TEX_H				"/item/hopper.BIN"
#define		SAVE_FILE_NAME			"Killer7"
#define		SAVE_FILE_NAME8			"Killer8"
//#define		SAVE_FILE_NAMEH			"Hopper7"
#define		SAVE_DAMMY_NAME			"Killer7_Dammy"
#define		KILLER7_COMMENT			"killer7"
#define		KILLER8_COMMENT			"killer8"
#define		KILLERH_COMMENT			"Hopper7"
#define		KILLERH_DATANAME		"zbp[7"
#define		KILLERH_FILENAME		"قρ[7"
#define		BREAK_DATA_NAME			"Error reading saved data"
#define		TV_TEX					"/Yam/CharChange/tvtv005_bg.BIN"

#define		SAVE_CURSOL_X			(100)
#define		SAVE_CURSOL_Y			(75)
#define		SAVE_NO_X				(123)
#define		SAVE_DATA_X				(167)
#define		SAVE_DATA_Y				(122)//(80)
#define		SAVE_DATA_GAPY			(35)
#define		SAVE_NAME_TIME			(20)
#define		SAVE_NAME_RIGHT_X		(600)
#define		SAVE_FILE_BOX_X			(320)
#define		SAVE_FILE_BOX_Y			(30)
#define		SAVE_BOX_SIZEY			(32)
#define		SAVE_BOX_PLUSX			(45)
#define		COMMENT_MEM_SCN			(17)
#define		COMMENT_MEM_POINT		(19)
#define		CHAN_MOVE_TIME			(30)
#define		CHECK_WAIT_TIME			(50)
#define		KILLER8_BYTE			(8264)
#define		ICON_OFFSET				(64)


//	t@C	-----------------------------------------------------------
static char* tblSaveScenarioName[]={
	"Ă",
	"炭",
	"Ƃ",
	"",
	"Ԃ񂵂",
	"",
	"",
	
	"eV",
	"NWc",
	"NIgR",
	"JCRE",
	"uV",
	"GKI",
	"VV",
};

//	Z[uNX̎
enum{
	eBaseFirstCheck=0,
	eBaseKiller8Check,
	eBaseSave,
	eBaseLoad,
	eBaseSaveEnd,
};
//	[J[h`FbNAT[
enum{
	MEMORYCARD_RETCODE_BUSY=0,
	MEMORYCARD_RETCODE_TRUE,
	MEMORYCARD_RETCODE_FALSE,
	MEMORYCARD_RETCODE_NOCARD,
	MEMORYCARD_RETCODE_NOTCARD,
};
//	Xbgm
enum{
	CARD_SLOT_A=0,
	CARD_SLOT_B,
	CARD_SLOT_EXIT,
};

enum{
	LOAD_FONT=0,
	LOAD_TV,
	LOAD_BANNER,
	LOAD_ICON,
};

//	G[bZ[W̃^Cv
enum{
	MESERROR_NONE=0,
	MESERROR_DELETE,
};

typedef struct{
	char	name[32];
}SAVENAME;

typedef enum{
	eProcFirst=0,
	eProcSecond,
	eProcLoad,
	eProcCursolDraw,
	eProcAnsCheck,
	eProcInsert,
	eProcSetMound,
	eProcMessage,
	eProcCheckMount,
	eProcFileCheck,
	eProcHopperCheck,
	eProcEreaCheck,
	eProcSavedCheck,
	eProcInit,
	eProcResult,
	eProcSlotSelect,
	eProcDammyDelete,
	eProcSavedDraw,
	eProcSaveSelect,
	eProcSaveCheck,
	eProcDelete,
	eProcRename,
	eProcWrite,
	eProcWriteCheck,
	eProcWriteMes,
	eProcReadCheck,
	eProcReadFlag,
	eProcRead,
	eProcReadEndCheck,
	eProcWriteEnd,
	eProcLoadEnd,
	eProcEnd,
}eSaveProc;

extern bool		SK7ResetProcessCallBack( u32 param );	//R[obN


//	j[x[XNX
class SK7SaveBase : public SK7MemoryCard, public SK7SaveLoadMessage
{	
protected:
	bool						m_bRender;				// `tO
	bool						m_bCtrl;				// 싖tO
	bool						m_bKiller8Flag[SAVE_DATA_NUM];	//	L[WǂB
	bool						m_bLoadFontFlag;
	bool						m_bChanFlag;
	s8							m_chSlotInFlag;			// XbgCtO
	s8							m_chSavedFlag;			// Z[utO
	s8							m_chHopperFlag;
	s8							m_chSaveSelectNo;
	s8							m_chSelect;
	s8							m_chSlotNo;
	s8							m_eLoad;
	s8							m_chEnumNo;
	s8							m_chReadNo;
	int							m_iChanTime;
	SK7File*					m_pFile;
	void*						m_pIconData;				//	ACRf[^
	void*						m_pSavedData;
	SK7Sprite					m_spTV;
	SK7Sprite					m_spBoxLine;
	DVDBanner*					m_pBanner;					//	oi[f[^
	u32							m_lSlotColor[2];
	SAVENAME					m_SaveName[SAVE_DATA_NUM];
	SK7SaveData					m_SaveData;					//	Z[uf[^
	SK7SaveData*				m_pSaveData;
	EFFECT*						m_pEffect;
	eSaveProc					m_eProc;
public:
	SK7SaveBase();
	virtual ~SK7SaveBase();
	
	static SK7SaveBase* Create(u8 id);							//	쐬
	
	virtual bool FrameProcess	( void ){ return true; }				// t[
	virtual bool RenderProcess	( void ){ return true; }			// _O
	virtual bool GetMenuEnd		( void ){ return true; }				// II擾֐
	virtual void SetCtrlFlag	( bool flag ){ m_bCtrl=flag; }		// 싖ݒ֐
	virtual void SetRender		( bool flag ){ m_bRender=flag; }		// _O

	eSaveProc	GetState		(){ return m_eProc; }				//	Ԏ擾
	
	bool  	GetFileReadEnd		( void );	// t@CǂݍݏI擾֐
	bool 	LoadData			( s8 DataNo );										//	[h
	void	InitBase			( void );			//	tO
	bool	CheckCardExist		( void );			// Z[u`FbN	
	void	SetMessage			( u8 MesNo, s8 Select=0 );	// bZ[WZbg
	void	SetMessageCheck		( u8 MesNo, s8 Select );
	void	SetMessageUp		( u8 MesNo, s8 Select );
	void	RenderSaveComment	( void );
	void	CheckCardSavedData	( s32 SlotNo );
	bool	ResultCheck			( s32 State, s8 Select=MESERROR_NONE );
	s8 		CheckCardInsert		( void );
	void	CheckSlotSelect		( void );
	void	CheckCardSavedData	( void );
	void	CheckMount			( void );
	void	CheckFileCheck		( void );
	void	CheckFileErea		( bool LoadFlag );
	void	DeleteDammyFile		( void );
	s8 		FrameMessageKey		( void );
	void	CheckSavePoint		( s8 State );
	void	CheckSavePlay		( s8 State );
	u32		GetCRC				( SK7SaveData* Data );
	bool	CheckCRC			( SK7SaveData* pSave );
	
	SK7SaveData*	GetSaveData(){ return &m_SaveData; }
};

#endif	//__SK7SAVEBASE_H__
