////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SaveLoad
//
// SK7SaveLoad.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/12/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SAVELOAD_H__
#define	__SK7SAVELOAD_H__

#include "SK7Sprite.h"
#include "SK7Font.h"
#include "DVDBanner.h"
#include "SK7SaveData.h"
#include "SK7SaveLoadMessage.h"
#include "../Yam/YK7String.h"

#define		KILLER7_COMMENT		"Killer7"
#define		TV_TEX					"/Yam/CharChange/tvtv005_bg.BIN"

//	t@C	-----------------------------------------------------------
static char* SaveScenarioName[]={
	"Ă",
	"炭",
	"Ƃ",
	"",
	"Ԃ񂵂",
	"",
	"",
	
	"eV",
	"NWc",
	"NIgR",
	"JCRE",
	"uV",
	"GKI",
	"VV",
};


#define		CARD_FONT_X				(50)
#define		CARD_FONT_Y				(200)


//	Xbg`FbN	====================================================================
#define		SK7CARD_SLOTA_NOSUPPORT		(0x10000006)	//	T|[gĂȂ
#define		SK7CARD_SLOTB_NOSUPPORT		(0x10000007)	//	T|[gĂȂ
#define		SK7CARD_OK					(1)	//	OK
#define		SK7CARD_ERROR				(0)	//	
#define		SK7CARD_BUSY				(2)	//	܂Ă
#define		SK7CARD_MOUNT_ERROR			(3)	//	}EgG[
#define		SK7CARD_MOUNT_OK			(4)	//	}EgOK

//	NAtO`FbNp
#define		FCARD_CHECK_A			(1<<0)
#define		FCARD_CHECK_B			(1<<1)
#define		FCARD_CHECKEND_A		(1<<2)
#define		FCARD_CHECKEND_B		(1<<3)


//	bZ[Wp	=====================================================================
typedef struct{
	s8 No;
	s8 proc;
	s8 slotno;
	bool bErrorDraw;
}NEXT_MESSAGE;

typedef struct{
	char	name[32];
}SAVE_NAME;


//********************************************	Z[u[hNX	********************************************
class SK7SaveLoad : protected SK7SaveLoadMessage
{
	enum{
		PROC_LOAD=0,
		PROC_CARD_MESSAGE,
		PROC_CHECK_END_SAVE,
		PROC_SLOT_CHECK,
		PROC_CARD_CHECK,
		PROC_FIRST_CARD_CHECK,
		PROC_MOUNT_CHECK,
		PROC_SELECT_CHECK,
		PROC_BREAK_CHECK,
		PROC_DELETE_CHECK,
		PROC_SIZE_CHECK,
		PROC_INIT_CHECK,
		PROC_FIRST_SELECT,
		PROC_END_MESSAGE,
		PROC_DATA_LOAD_CHECK,
		PROC_LOAD_DATA,
		PROC_LOAD_CHECK,
		PROC_DATA_DRAW,
		PROC_SAVE_SELECT,
		PROC_SAVE_PLAY_CHECK,
		PROC_WRITE,
		PROC_WRITE_CHECK,
		PROC_WRITE_END,
		PROC_READ_END,
		PROC_CHECK_END,
		PROC_NOT_MESSAGE,
		PROC_WAIT,
		PROC_END,
	};
	
	typedef enum{
		LOAD_FONT=0,
		LOAD_TV,
		LOAD_BANNER,
		LOAD_ICON,
	}eLoad;

protected:
	bool						m_bRender;					// `tO
	bool						m_bCtrl;					// 싖tO
	bool						m_bSlotInFlag;				//	XbgC
	bool						m_bSelectFlag;				//	ZNg
	bool						m_bWriteFlag;				//	݃`FbN
	bool						m_bLoadFontFlag;			//	[hf[^\邩B
	bool						m_bSaveOkFlag;				//	VKZ[uł邩ǂ
	bool						m_bChanFlag;

	DVDBanner*					m_pBanner;					//	oi[f[^
	CARDFileInfo*				m_pCardInfo;				//	J[hCtHf[^
	u8*							m_pWorkErea;				//	[NGA
	void*						m_pIconData;				//	ACRf[^
	SK7SaveData					m_SaveData;					//	Z[uf[^
	SK7SaveData*				m_pSaveData;
	int							m_iSaveDataSize;
	int							m_iSaveDataBlock;
	SK7Sprite					m_spTV;						//	TV
	SK7Sprite					m_spBoxLine;
	
	EFFECT*						m_pEffect;

	SK7File*					m_pFile;					//	t@C

	s8							m_Proc;	
	eLoad						m_Load;						//	[h
	s8							m_chNextProc;				//	̏ꏊ
	s8							m_chSelect;					//	ZNg
	s8							m_chSavedFlag;				//	Z[utO
	s8							m_chSaveSelectNo;			//	Z[uI
	s8							m_chSetSlotNo;				//	}EgXbgԍ
	u8							m_chCheckFlag;				//	ŏ̃`FbNԍ
	u8							m_ucSelectNo;				//	ZNg@ԍ
	u8							m_ucState;					//	Z[u[h
	u8							m_ucCardFileNo;				//	ZN^[m
	u8							m_ucMoveNameFlag;			//	ړZ[üړtO
	u8							m_ucSelectMes;				//	ÎƂ̃bZ[Wԍ
	s32							m_lReqbyte;					//	Kvȃt@C
	f32							m_fSaveNameX;				//	Z[ûwW
	u32							m_lSlotAColor;
	u32							m_lSlotBColor;	
	int							m_iSaveNameTime;			//	Z[üړ
	int							m_iChanTime;				//	`lg\
	int							m_iCheckTime;				//	`FbN̎̃^C
	NEXT_MESSAGE				m_NextMes;					//	2sƂ̃bZ[Wf[^
	SAVE_NAME					m_SaveName[SAVE_DATA_NUM];
	char*						m_pSavedName;				//	Z[uIO
	
	s32							m_ScenarioNo;				//	[hViIԍ

	//	֐	-----------------------------------------------------------------------------------
	bool		CheckCardIn( s32* SlotStateA, s32* SlotStateB );//	J[h}`FbN
	int			MessageResultCode( s32 SlotNo );				//	UgR[hbZ[W
	bool 		CardAnswerSelect();						//	L[`FbN
	void		SetCardData(void);								//	J[hɋLqf[^
	void		CheckCardRender( s32 AState, s32 BState );		//	J[hZbg``FbN
	bool		CheckCardExist();								//	f[^
	u32			GetCRC( SK7SaveData* Data );					//	bqb擾
	bool		CheckCRC( SK7SaveData* pSave );					//	bqb`FbN
	void 		CreateSaveData();								//	Z[uf[^̍쐬
	void		RenderSaveComment();
	void		EndWriteEvent();								//	ݏI
	void		EndNotEvent();									//	sI

	void		WriteSaveData();								//	VK
	void		LoadSaveData();									//	ǂݍ

	void		CheckCardSlotIn	( s8 SlotNo, s32 State );		//	J[h`FbN̑Ή
	void		CheckCardMount	( s8 SlotNo );					//	}Eg`FbNΉ
	void		CheckCardBreak	( s8 SlotNo );					//	uCN`FbNΉ
	void		CheckCardErea	( s8 SlotNo );					//	J[ḧ̗Ή
	void		CheckSlotInNow	( s32 State );					//	XbgɃJ[hĂ邩`FbN
	void		CheckCardSelect	(void);							//	ZNgp
	void		CheckCardInit	( s8 SlotNo );					//	
	void		CheckSlotSelect	( s32 AState, s32 BState );		//	XbgZNgΉ
	void		CheckMessageOne	(void);							//	bZ[WP
	void		CheckSelectMessage(void);						//	`FbNp
	void		CheckCardLoad(void);							//	[hf[^`FbN
	void		CheckCardSavedData(void);						//	Z[uf[^̒go
	void		CheckSavePlay(void);							//	Z[u邩`FbN
	void		CheckSavePoint(void);							//	ǂɂ[Ԃ邩H
	void		CheckWriteEnd(void);							//	ݏI`FbN
	void		CheckLoadEnd(void);								//	ǂݍݏI`FbN
	void		CheckCardDelete(void);							//	폜`FbN	
	void		CheckEndSave();									//	Z[u`FbN
	void		CheckFirstCard( s32 AState, s32 BState );		//	ŏ̃J[h`FbN
	void		CheckClearCard();								//	NAtO̎擾

public:
	SK7SaveLoad( s8 State=SAVE_STATE_CHECK );
	~SK7SaveLoad();

	//	[h
	bool  LoadData();
	
	// t[
	bool  FrameProcess(void);
	
	//	t[
	bool  FirstFrameProcess(void);
	bool  SaveFrameProcess(void);
	bool  LoadFrameProcess(void);
	
	// _O
	bool  RenderProcess(void);
	
	// t@CǂݍݏI擾֐
	bool  GetFileReadEnd(void);

	// II擾֐
	bool  GetMenuEnd(void);
	
	//	݁ǂݍݏI
	bool  GetProcessEnd(void);

	// 싖ݒ֐
	void  SetCtrlFlag(bool flag){ m_bCtrl=flag; }

	// _O
	void  SetRender(bool flag){ m_bRender=flag; }	
	
	//	[hʏ	
	void	InitLoad();
	
	//	[hf[^̃ViI擾
	s32				GetLoadSenarioNo(){ return m_ScenarioNo; }
	SK7SaveData*	GetSaveData(){ return &m_SaveData; }
};

#endif	//__SK7SAVELOAD_H__
