////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scenario Task
//
// SK7ScenarioTask.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/3/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SCENARIOTASK_H__
#define	__SK7SCENARIOTASK_H__

#include "SK7Sight.h"
#include "../wat/WK7Model.h"
#include "../wat/WK7Archive.h"
#include "SK7Sprite.h"
#include "../Yam/YK7Break.h"
#include "SK7ScenarioData.h"
#include "SK7Blood.h"
#include "SK7SaveBase.h"


#define		MAX_MODEL_NUM			(8)
#define		RETITLE_YES_NUM			(3)
#define		RETITLE_NO_NUM			(2)

//	t[ԍ
enum
{
	FRAME_INIT = 0,
	FRAME_CARD_CHECK,
	FRAME_OPEN_FADE,
	FRAME_SCENARIO_OPEN,
	FARME_SHISHI_OPEN,
	FRAME_FIRST_SIGHT_MOVE,
	FRAME_MAIN,	//	I
	FRAME_CANCEL_MOVE,
	FRAME_HIT_MOVE_SCENARIO,
	FRAME_CHARA_ENTRANCE,
	FRAME_CANCEL_MOVE_SCENARIO,
	FRAME_MODEL_VIEW,
	FRAME_BLOOD_TIME,
	FRAME_BLOOD_MOVE,	//	̓
	FRAME_CHARA_MOVE,
	FRAME_END,
};



//	^Cgo[
typedef struct{
	SK7Sprite	spBar;
	SK7Sprite	spTarget;
	SK7Sprite	spNo;
	SK7Sprite	spWaku[2];
	SK7Sprite	spDay;
	SK7Sprite*	pspName;
}TITLE_BAR;

//	xdrmnZNg
typedef struct{
	VEC2		vSpeed;
	VEC2		vPos;
	SK7Sprite	spBody;
}RETITLE_YESNO;

//	
class SK7ScenarioTask : public ghmGcAppTask
{
	enum{
		LOAD_KANJI_DATA=0,
		LOAD_BLOOD_TEX,
		LOAD_SCENA_TEX,
		LOAD_SIGHT_TEX,
		LOAD_WASHI_TEX,
		LOAD_EFFECT_SET,
	};

protected:
	u16					m_sFrameProc;		//	t[

	SK7Sprite			m_spFade;					//	tF[hp
	SK7Sprite			m_spRedBox;
	SK7Sprite			m_spBack;
	SK7Sprite			m_spReturnTitle;
	SK7Sprite			m_spBar;
	SK7Sprite			m_spSave[2];
	RETITLE_YESNO		m_Yes[RETITLE_YES_NUM];
	RETITLE_YESNO		m_No[RETITLE_NO_NUM];
	RETITLE_YESNO		m_YesS[RETITLE_YES_NUM];
	RETITLE_YESNO		m_NoS[RETITLE_NO_NUM];

	SK7SaveBase*		m_pSaveCheck;
	
	TITLE_BAR			m_Sce[SCENARIO_MAX_NUM];	//	ViIo[
	
	u16					m_sTexNumber;		//	Ǎ݃t[
	
	WK7Archive*			m_pArchive[MAX_MODEL_NUM];			//	A[JCuNX
	WK7Archive*			m_pMotionArc[MAX_MODEL_NUM];
	WK7Model*			m_pModel[MAX_MODEL_NUM];			//	fNX
	WK7ModelMotion* 	m_pMotion[MAX_MODEL_NUM];
	SK7Blood			m_Blood;			//	ij
	SK7Sight			m_Sight;

	bool				m_bBloodFlag;		//	H
	bool				m_bChangeSightFlag;	//	TCg̕ύXtO
	bool				m_bReturnFlag;
	bool				m_bMoveNextFlag;
	bool				m_bSEFlag;
	bool				m_bScenarioFlag[SCENARIO_MAX_NUM];	
	

	SK7File				m_File;				//	t@C
	ghmGcResLink*		m_pResLink;			//	N\[X
	void*				m_pPackData;		//	f[^
	TEX_DATA*			m_pTexture;			//	eNX`[f[^
	
	s16					m_sOldSenarioNo;	//	ЂƂÕViIԍ
	s16					m_sScenarioNo;		//	ViIԍ
	
	
	int					m_iScenarioTime;	//	ViIړ
	int					m_iScenarioNum;		//	ViI̐
	int					m_iBloodDrawTime;	//	̕`掞
	int					m_iShishiTime;
	int					m_iBackTime;
	int					m_iMoveAddTime;				//	ړԁ{{ 
	int					m_iMoveSetTime;				//	ړ
	int					m_iCharaMoveTime;
	int					m_iSETime;
	
	VEC2				m_vYesNoSpeed[3];

	GXColor				m_UpColor;
	GXColor				m_DownColor;
		
	ghmGcTaskController *m_pTaskControl;	//	^XNRg[[

	
	void	SetScenarioBar( TITLE_BAR* pSce, bool next, int No );
	void	SetReturnVisible( bool flag );
	void	SetEffectMove( VEC2 *pVec );
	void	MoveYesNo( RETITLE_YESNO* pData, const VEC2 *pSide );

public:
	SK7ScenarioTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~SK7ScenarioTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
			
	//	f[^̃[h	
	bool	LoadData();
		
	//	Move֐
	bool	MoveScenario();		//	ViIړ
	bool	MoveHitScenario( bool State);
	bool	MoveCharactor();
	bool	MoveShishi();				//	qViI
	void	MoveBackColor();
	void	MoveScenarioBar();
	bool	MoveSightFirst();
	//	SET֐
	void	SetCheckMoveScenario();
	void	SetBlood(int sNo);			//	̃Zbg
	void	SetCharactorPos();
	void	SetMoveCharactorPos();
	void	SetSightSize();
	void	SetBackColor( u8 SetRU, u8 SetGU, u8 SetBU, u8 SetRD, u8 SetGD, u8 SetBD, u8 Frame = LINE_AFTER_FRAME );
	
	//	`֐
	void	RenderSight();					//	TCg̕`惁C
			
	//	f|SQbg
	void	GetModelData();
	void	CheckSightPos();
};

#endif	//__SK7SCENARIOTASK_H__



