////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SK7SpOption
//
// SK7SpOption.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/24/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SPOPTION_H__
#define	__SK7SPOPTION_H__
#define	__OPTION_DEBUG__

#include "../kaw/KK7BattleCtrl.h"
#include "../Yam/YK7String.h"
#include "../wat/Blood.h"
#include "SK7SpecialData.h"

#define		BALLET_MAX			(10)
#define		OPTION_WINDOW_X		(-100.0f)
#define		OPTION_WINDOW_LX	(-15.0f)
#define		OPTION_WINDOW_COLOR	(0x000000ff)
#define		FONT_SP_NUM_W		(34)			//	tHg
#define		FONT_SP_NUM_H		(2)
#define		OUTLET_NUM			(7)
#define		PIPE_NUM			(4)
#define		METER_NUM			(9)//10)
#define		EYE_MAX_NUM			(5)
#define		BLOOD_BP_POINT		(20)
#define		CODE_FONT_LINE			(5)
#define		CONPAS_FONT_NUM		(3)

//	Q[W	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#define		PACK_GAUGE_X		(176.0f)
#define		PACK_GAUGE_UPY		(138.0f)
#define		PACK_GAUGE_DOWNY	(256.0f)

#define		MACHINE_TUBE_NUM	(5)
#define		MACHINE_KASAN_NUM	(7)

//	ڂ̍W	:::::::::::::::::::::::::::::::::::::::::::::::::::::
#define		EYE_SIZE				(54)
#define		EYE_HALF_SIZE			(EYE_SIZE*0.5f)
#define		EYE_X					(24.0f+EYE_HALF_SIZE+1.0f)
#define		EYE_Y					(40.0f+EYE_HALF_SIZE)
#define		EYE_RIGHT_X				(560.0f+EYE_HALF_SIZE)
#define		EYE_BALL_SIZE			(16)

//	̎擾̃TCY	:::::::::::::::::::::::::::::::::::::::::::::::::::::
enum SK7BloodSize{
	BLOOD_SIZE_BIG = 0,
	BLOOD_SIZE_SML,
};

enum SK7BloodJoint{
	BLOOD_JOIN_ALL   = 0,
	BLOOD_JOIN_HEAD,
	BLOOD_JOIN_OTHER,
};

//	擾ACe	*****************************************
enum{
	ITEM_BALLET=0,
};

//	ڋʂ̊gk
enum{
	EYE_EXSTATE_NORMAL=0,
	EYE_EXSTATE_BIG,
	EYE_EXSTATE_SMALL,
};


//	}Vp
typedef struct{
	SK7Sprite	BodyA;
	SK7Sprite	BodyB;
	SK7Sprite	BodyC[2];
	SK7Sprite	Tube[MACHINE_TUBE_NUM];
	SK7Sprite	BloodThick;				//	Z
	SK7Sprite	BloodThin;				//	
	int			AddTime;				//	Z
	int			SetTime;				//	ړ
	int			KasanSize;				//	ZTCY
	int			ThickTime;				//	Z̎
	int			ThinTime;				//	C̎
	bool		bThickMoveFlag;			//	CړtO
	bool		bThinMoveFlag;			//	CړtO
	bool		bThickEndFlag;			//	Co؂tO
	bool		bThinEndFlag;			//	Co؂tO
	VEC2		vPos;
}MACHINE;

//	Z	-------------------------------------------------
typedef struct{
	int Time;
	bool Size;
	SK7Sprite	sprite;
}BLOOD_KASAN;


//	Ǘp
typedef struct{
	SK7Sprite	Waku;
	SK7Sprite	Kan;
	SK7Sprite	In;
	SK7Sprite	Blood;
}SHIKENKAN;


//	ڋ
typedef struct{
	bool		Flag;
	bool		NotDrawFlag;
	int			Time;
	int			StartNo;
	int			EndNo;
	int			ExTime;
	s8			State;
}EYE_STATE;

//	R[hg
typedef struct{
	SK7Sprite	WakuTop;
	SK7Sprite	WakuLeft;
	SK7Sprite	WakuUnder;
	SK7Sprite	Kazari;
	f32			MoveX;
	f32			CodeX;
	bool		bStartFlag;			//	R[hX^[gtO
	u8 			FontNo;
	u8			FontLine;
	int 		FontTime;
	int			CommentNo;
}CODE_STATE;

//	RpX\
typedef struct{
	SK7Sprite	spCircle[2];
	SK7Sprite	spKasan;
	SK7Sprite	spEnemyKasan;
	SK7Sprite	spN[CONPAS_FONT_NUM];
	SK7Sprite	spS[CONPAS_FONT_NUM];
	SK7Sprite	spW[CONPAS_FONT_NUM];
	SK7Sprite	spE[CONPAS_FONT_NUM];
	f32			fAngle;
	f32			fEnemyAngle;
	bool		bEnemyRender;
	bool		bReverseState;
}CONPAS;


//	t[
typedef enum{
	SPOPTION_BALLET_MOVE=0,		//	ړ
	SPOPTION_BALLET_CLOSE,		//	߂
	SPOPTION_STANBY,			//	BĂ܂Ă܂
	SPOPTION_CHARGE_MOVE,		//	`[Wp
	SPOPTION_DEMO_CLOSE,		//	fpN[Y
	SPOPTION_EXIT,
}eProc;

//	tt[̗	********************************************
typedef enum{
	BLOOD_PROC_CHECK=0,
	BLOOD_PROC_MOVE,
	BLOOD_PROC_MOVE_LINE,
	BLOOD_PROC_INSERT,
}eBloodProc;


//	eہ̃IvVʃNX
class SK7SpOption
{		
protected:
	eProc				m_eProc;					//	C
	eBloodProc			m_eBloodProc;				//	tC
	
	bool				m_bRenderFlag;				//	`tO
	bool				m_bControlFlag;				//	Rg[tO
	bool				m_bMoveFlag;				//	ړtO 
	bool				m_bMoveBloodFlag;			//	̈ړtO
	bool				m_bSEFlag;
	bool				m_bRedFlag;					//	ڂ̋ʐԂȂ
	bool				m_bWinMoveFlag;				//	EBhEړtO
	bool				m_bAllBloodMoveFlag;		//	ttO
	bool				m_bBossFlag;				//	{XtO
	bool				m_bCodeFlag;				//	R[h
	bool				m_bNoudoDrawFlag;			//	m[h̕\tO

	SK7Sprite			m_spWindow;					//	IvVEBhE
	SK7Sprite			m_spWindowUp;				//	EBhEThCb`
	SK7Sprite			m_spUnder;					//	̍
	SK7Sprite			m_spEye;					//	ڂ̃_[W\
	SK7Sprite			m_spEye2;					//	ڋ
	SK7Sprite			m_spNoudo;					//	m[h
	SK7Sprite			m_spNoudoBack;				//	m[hobN
	SORE				m_Sore;						//	ǂł͂Ȃ
	YK7StrImage* 		m_pYFont;					//	RctHg
	YK7StrImage* 		m_pBFont;					//	RctHg

	MACHINE				m_Macine;					//	t}V
	SHIKENKAN			m_Shiken;					//	
	CODE_STATE			m_Code;						//	R[hp
	EYE_STATE			m_Eye;
	BLOOD_KASAN			m_Kasan[MACHINE_KASAN_NUM];	//	Z
	CONPAS				m_Conpas;					//	RpX
	EFFECT*				m_pEfCharge;				//	`[WGtFNg
	f32					m_fEyeMoveX;				//	ڋʂ̈ړ
	f32					m_fBloodY;					//	ԂƂx
	f32					m_fNoudoX;					//	m[ĥw
	f32					m_fUnderX;					//	̂w
	f32					m_fMoveY;					//	ChEY
	f32					m_fShikenX;					//	ǖ{X
	f32					m_fMeterX;					//	Z̗ʃ[^w
	
	int					m_iMoveAddTime;				//	ړԁ{{ 
	int					m_iMoveSetTime;				//	ړ
	int					m_iBloodTime;				//	̗鎞
	int					m_iBloodNextTime;			//	ȂƂ̏ꍇ̎
	s8					m_chMoveFont[CODE_FONT_LINE];//	tHg
//	s8					m_chBulletNum;				//	e
	s8					m_chEyeEx;					//	gk
	u8					m_ucMaxThinBlood;			//	ǌt̍ő
	u16					m_usThickBlood;				//	hߏI̔Z
	u16					m_usThinBlood;				//	hߏI̔
	u16					m_usSerumBlood;				//	hߏǏ
	u16					m_usBloodPoint;				//	wuX}C擾_
	u32					m_ulEffectID;				//	GtFNgJ[\

	//	֐	====================================================
	bool	MoveLeftWindow( bool );					//	EBhEړ
	void	RenderMoveCode();
	void	RenderNoudoFont();
	void	CreateMacine(void);						//	}V쐬
	bool	MoveBloodThick(void);
	bool	MoveBloodThin(void);					//	̈ړ
	void	SetStoreNo();							//	߂̔ԍ
	void	InitKasan();							//	Z
	void	SetMacineLeftPos(bool);
	void 	_BloodFrameProcess(void);
	void	MoveSore();
public:	
	SK7SpOption();
	~SK7SpOption();
	
	bool 	FrameProcess(void);						// t[
	bool 	RenderProcess(void);					// _O
	
	void	SetControl(bool State){ m_bControlFlag = State; }
	void	SetRender(bool State){ m_bRenderFlag = State; }
	
	//	et[	----------------------------------------------------
	bool	BloodFrameProcess(void);				//	tt[
	bool	WindowFrameProcess(void);				//	EBhEt[

	//	tn߂̃`FbN	----------------------------------------------------
	void	CheckThinMoveStart();					//	n߂̃`FbN	
	void	CheckThickMoveStart();					//	Z̗n߃`FbN
	
	//	̃EBhE	----------------------------------------------------
	void	SetState( eProc proc, bool set=true );		//	vZXZbg
	void	InitTimer(void)				{ m_iMoveAddTime = m_iMoveSetTime = 0; m_bMoveFlag = false; }	//	e^C}[
	void	InitOptionWindow(void);						//	EBhEʒu
	
	//	`Zbg	-------------------------------------------
	void	SetRenderOption	(bool State);			//	IvVS
	void	SetRenderEye	(bool State);			//	ڋ
	
	//	ACe֘A	----------------------------------------
	void	CreateItem		(u8 State);				//	ACe쐬
	void	DeleteItem		(u8 State);				//	ACe폜

	//	_[W֘A	----------------------------------------
	u8		SetEyeTexture( f32 Hp );			//	ڂ̃eNX`[ύX	
	
	//	ړpwW	-------------------------------------------
	void	SetOptionX();
	void	MoveOptionX( bool state );
	
	void	SetMacinePos( f32, f32 );				//	}V̍WZbg
	void	SetMacineRender( bool );				//	}V̕`Zbg

	//	t̕`	
	void	SetKasanRender(bool State);
	void	SetBeakerRender( bool State );
	
	bool	CreateBloodPoint( u8 No );							//	t쐬
	
	f32 	GetBloodY(){ return m_fBloodY; }
	
	//	eې̎擾	--------------------------------------
	s8		GetBalletNum();//{ return m_chBulletNum; }
//	void	SetBalletNum( s8 num ){ m_chBulletNum = num; }

	//	ڋʂ̎擾
	u8		GetEyeNo( f32 Hp );
		
	//	RctHgiqMmnj
	YK7StrImage*	GetYamadaFont(){ return m_pBFont; }

	void	SetCodeFlag		( bool flag ){ m_bCodeFlag = flag; }
	void	SetNoudoRender	( bool flag ){ m_bNoudoDrawFlag = flag; }
	
	//		RpX		
	void	SetRenderConpas		( bool State );										//	RpX`
	void	SetReverseMode		( bool State ){ m_Conpas.bReverseState = State; } 	//	t][hǂB true=]  false=]ĂȂ	
	void	SetConpasRot		( f32 rot ){ m_Conpas.fAngle = rot; }				//	pxZbg
	f32		GetConpasRot		( void ){ return m_Conpas.fAngle; }					//	pxZbg擾
	void	SetEnemyConpasRot	( f32 rot ){ m_Conpas.fEnemyAngle = rot; } 			//	GpxZbg
	void	SetEnemyConpasRender( bool flag ){ m_Conpas.bEnemyRender = flag; } 	//	G`Zbg
	bool	GetEnemyConpasRender(){ return m_Conpas.bEnemyRender; } 	//	G`Qbg
	

	//		֘A		
	u16		GetBloodGauge(int type);				//	擾
	void	SetBloodGauge(int type, u16 Point);		//	Zbg
	u16		IncBloodGauge(int type, s16 IncPoint);	//	̒lCNg

	void 	SetGetBloodPoint( SK7BloodSize inSize, SK7BloodJoint inJoin);			//	wuX}CS̎擾_SET
	void	SetMaxThinBlood( u8 blood ){ m_ucMaxThinBlood = blood; }				//	tő吔
	void 	GetMachineBloodPoint( Vec* pV );										//	̈ړꏊ
	f32		GetBloodPointMoveX(){ return m_Macine.BodyA.GetX0(); }
	bool 	GetBloodPointEnd();														//	t擾̃qJ̏I`FbN
	void	GetBloodSetFlag( bool flag ){ m_bAllBloodMoveFlag = flag; }
	

	//			
	void	GetEyeCenterPos( Vec* pV ){ pV->x = m_spEye2.GetX0()+EYE_BALL_SIZE*0.5f, pV->y = m_spEye2.GetY0()+EYE_BALL_SIZE*0.5f; }
	void	SetEyeAnime2(void);
	void	SetEyeAniem( f32 StartHp, f32 EndHp );
	void	MoveEyeAnime();	
	void	SetEyeExpan(s8 state);					//	ڂ̊gkZbg state=EYE_EXSTATE_SMALL=k size=EYE_EXSTATE_BIG=g

	//		{XXe[WZbg	
	void	SetBossFlag ( bool state )	{ 	m_bBossFlag = state; }		//	{X̂ƂtrueŁBȊOfalse
	bool	GetBossFlag ()				{ 	return m_bBossFlag; }		
	
	//		ǃZbg	
	EFFECT*		SetEffectCharge();
	EFFECT*		GetChargeEffect(){ return m_pEfCharge; }
	void		SetChargeTube();
	void		DeleteTubeEffect();
	
	//		ǂł͂Ȃ	
	void	SetRenderSore( bool flag ){ m_Sore.spFont.SetVisible( flag ); m_Sore.spPlate.SetVisible( flag ); }


#ifdef __OPTION_DEBUG__
	void	DEBUG_SPRITE_POS();
#endif
	
};

#endif	//__SK7SPOPTION_H__



