////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7TestTask.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/18/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7TESTTASK_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "../Lib/ghmGcTask.h"
#include "SK7Common.h"
#include "SK7TestTask.h"
#include "../Wat/K7App.h"
#include "../Wat/WK7MenuTask.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7Light.h"
#include "../matsu/mk7Sound.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7MainTask.h"
#include "../Yam/YK7EffectHSDead.h"
#include "../fujita/C_Particle.h"
#include "../Yam/YK7Break.h"
#include "../fujita/c_font.h"
#include "SK7Death.h"
#include "SK7PanelBase.h"
#include "../panel/mK7PanelSwitch00.h"
#include "SK7PanelInputCode.h"
#include "SK7Special.h"
#include "SK7Pack.h"

#define		CHARA_NAME_JMB		"/Texture/CharaName.jmb"


//========================================================================
//					R[obN
//========================================================================
bool SK7TestTask::InitializeCallBack(void)
{	
#if 1
	ghmGcApp	*pApp = GetApplication();
	
	OSDebugReport("SK7TestTask Init : DefaultHeap = 0x%08x , TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),sizeof(*this));
	
	pApp->SetEnablePerfMeter (true);
	pApp->SetVisiblePerfMeter(true);
	ghmGcMem::SetRender(true);
#endif
	m_pDeath 	= 	NULL;
	m_pUlmeyda	=	NULL;
	m_pPola		= 	NULL;
//	m_pSaveLoad = 	NULL;
	m_pSpecial	= 	NULL;
	m_pSpOption = 	NULL;
	m_pNext		= 	NULL;
	m_pMap		= 	NULL;
	
	g_pSpData = new SK7SpecialData;
	g_pSpData->Initialize();
	
	
	//	---------	eXgp̏	------------	//
	HSD_VISetClearClr((GXColor){0x00,0x00,0x00,0x00});
	screenImageMonoColor.SetFormat(GX_TF_I4);
	screenImageMonoColor.AllocBuffer();
	
	return true;
}


//========================================================================
//					IR[obN
//========================================================================
bool 	SK7TestTask::TerminateCallBack(void)
{
	HSD_VISetClearClr((GXColor){0x00,0x00,0x40,0x00});

	ghmGcApp *pApp = GetApplication();
	delete this;
	new WK7MenuTask(pApp);

	return true;
}


//========================================================================
//					t[
//========================================================================
bool 	SK7TestTask::FrameProcess(void)
{
	//	fobNJ	=======================================================
	if( (HSD_PadGetButton(0) & HSD_PAD_Y) && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
		if( WK7CAM->IsDebugMode()==true ){
			WK7CAM->ExitDebugMode();
		}else{
			WK7CAM->EnterDebugMode();
		}
	}
	//	eXgI	===========================================================
	if( HSD_PadGetTrigger(0) & PAD_BUTTON_X ){
		DeleteProcess();// if( DeleteTerminate()==true)
		return true;
	}
	switch( m_MainProcess ){
	case MAINPROC_LOAD:
		if( LoadData() ){
			m_MainProcess = MAINPROC_MOVE;
		}
		break;
	
	case MAINPROC_MOVE:
		//	et[vZX	==================================================
		switch( m_chProcNo ){
		case MAIN_PROC:			MainFrameProcess();	break;
		case DEATH_PROC:		DeathProcess();		break;
		case ULMYDA_PROC:		UlmydaProcess();	break;
		case POLA_PROC:			PolaProcess();		break;
		case SAVE_PROC:			SaveLoadProcess();	break;
		case CHARA_PROC:		CharaChangeProcess();	break;
		case NEXT_PROC:			NextProcess();		break;
		case MAP_PROC:			MapProcess();	break;
#if 0
		case STAFF2_PROC:
			if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
				ghmGcApp *pApp = GetApplication();
				delete this;
				new SK7StaffRoll2(pApp);
			}
			break;
#endif
//		case TEX_PROC:			TexProcess();		break;
		}
		break;
	}

	WK7Archive::FrameProcessAll();
	WK7RenderObj::FrameProcessAll();
 	WK7CAM->FrameProcess();

	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7TestTask::RenderProcess(void)
{
	if( m_MainProcess == MAINPROC_LOAD ) 	return true;
	
	switch( m_chProcNo ){
	case	MAIN_PROC:						MainRenderProcess();		break;
	case	DEATH_PROC:
		if( m_pDeath == NULL )	break;
		if(m_pDeath->GetFileReadEnd())		m_pDeath->RenderProcess();
		break;
		
	case	ULMYDA_PROC:
		if( m_pUlmeyda == NULL )	break;
		if( m_pUlmeyda->GetFileReadEnd())	m_pUlmeyda->RenderProcess();
		break;

	case	POLA_PROC:
		if( m_pPola == NULL )	break;
		if( m_pPola->GetFileReadEnd() )		m_pPola->RenderProcess();
		break;
		
	case	SAVE_PROC:
//		if( m_pSaveLoad == NULL )	break;
//		if( m_pSaveLoad->GetFileReadEnd() )	m_pSaveLoad->RenderProcess();
		break;
		
	case	CHARA_PROC:
		if( m_pSpecial == NULL ) break;
		m_pSpecial->RenderProcess();
		m_pSpOption->RenderProcess();
		break;
		
	case	NEXT_PROC:
		if( m_pNext == NULL ) break;
		m_pNext->RenderProcess();
		break;
		
	case 	MAP_PROC:
		if( m_pMap == NULL )	break;
		m_pMap->RenderProcess();
		break;
	}
	
	WK7RenderObj::RenderProcessAll();
	return true;
}

//========================================================================
//					RXgN^
//========================================================================
SK7TestTask::SK7TestTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	m_chProcNoSelect= 0;
	m_chProcNo 		= 0;
	m_chSelectNo 	= 3;
	m_MainProcess = MAINPROC_LOAD;
	m_Load = LOAD_CHARA_NAME;
}

//========================================================================
//					fXgN^
//========================================================================
SK7TestTask::~SK7TestTask()
{
}

//========================================================================
//					I
//========================================================================
void	SK7TestTask::DeleteProcess()
{
	m_chProcNo 		= 0;
	m_chSelectNo 	= 0;

	//	Death̊J
	GHM_SAFE_DELETE(m_pDeath);
	GHM_SAFE_DELETE(m_pUlmeyda);
	GHM_SAFE_DELETE(m_pPola);
//	GHM_SAFE_DELETE(m_pSaveLoad);
	GHM_SAFE_DELETE(m_pSpecial);
	GHM_SAFE_DELETE(m_pSpOption);
	GHM_SAFE_DELETE(m_pNext);	
//	GHM_SAFE_DELETE(g_pSpData);
	
	screenImageFullColor.FreeBuffer();
	screenImageMonoColor.FreeBuffer();

}

//========================================================================
//					S̃t[vZX
//========================================================================
void	SK7TestTask::DeathProcess()
{
//	if( HSD_PadGetTrigger(0) & HSD_PAD_A )		m_pDeath->PlayFaceMotion();
	if( HSD_PadGetTrigger(0) & HSD_PAD_UP )		m_chSelectNo++;
	if( HSD_PadGetTrigger(0) & HSD_PAD_DOWN )	m_chSelectNo--;
	if( HSD_PadGetTrigger(0) & HSD_PAD_Z){
		GHM_SAFE_DELETE(m_pDeath);
		screenImageMonoColor.SetFormat(GX_TF_I8);
		screenImageMonoColor.AllocBuffer();
		m_pDeath = new SK7Death((u32)m_chSelectNo,true);
	}
	if( m_pDeath != NULL ){
		if(m_pDeath->GetFileReadEnd()){
			m_pDeath->SetCtrlFlag(true);
			m_pDeath->SetRender(true);
		}
		m_pDeath->FrameProcess();
	}
}

//========================================================================
//					}bvt[vZX
//========================================================================
void	SK7TestTask::MapProcess()
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
		GHM_SAFE_DELETE(m_pMap);
		m_pMap = SK7IMenuBase::Create( eMenuMap );
	}
	if(m_pMap != NULL){
		if(m_pMap->GetFileReadEnd()){
			m_pMap->SetCtrlFlag(true);
			m_pMap->SetRender(true);
		}
		m_pMap->FrameProcess();
	}
}

//========================================================================
//					EC_t[vZX
//========================================================================
void	SK7TestTask::UlmydaProcess()
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
		GHM_SAFE_DELETE(m_pUlmeyda);
		m_pUlmeyda = SK7IMenuBase::Create( eMenuUlmeyda );
	}
	
	if(m_pUlmeyda != NULL){
		if(m_pUlmeyda->GetFileReadEnd()){
			m_pUlmeyda->SetCtrlFlag(true);
			m_pUlmeyda->SetRender(true);
		}
		m_pUlmeyda->FrameProcess();
	}
}

//========================================================================
//					lNXgt[vZX
//========================================================================
void	SK7TestTask::NextProcess()
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
//		GHM_SAFE_DELETE(m_pNext);
		ghmGcApp *pApp = GetApplication();
		delete this;
		new SK7NextTask(pApp);
	}	
}

//========================================================================
//					t[vZX
//========================================================================
void	SK7TestTask::PolaProcess()
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
		GHM_SAFE_DELETE(m_pPola);
		m_pPola = new SK7IMenuPola(m_chSelectNo);
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_UP ){
		if( ++m_chSelectNo > 5 )	m_chSelectNo = 5;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_DOWN ){
		if( --m_chSelectNo < 0 )	m_chSelectNo = 0;
	}
	
	if(m_pPola == NULL)	return;
	if(m_pPola->GetFileReadEnd()){
		m_pPola->SetCtrlFlag(true);
		m_pPola->SetRender(true);
	}
	m_pPola->FrameProcess();
}

//========================================================================
//					Z[u[hp
//========================================================================
void	SK7TestTask::SaveLoadProcess()
{
//	if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
//		GHM_SAFE_DELETE(m_pSaveLoad);
//		m_pSaveLoad = new SK7SaveLoad(1);
//	}
//	if(m_pSaveLoad == NULL)	return;
//	if(m_pSaveLoad->GetFileReadEnd()){
//		m_pSaveLoad->SetCtrlFlag(true);
//		m_pSaveLoad->SetRender(true);
//	}
//	m_pSaveLoad->SaveFrameProcess();
//	m_pSaveLoad->LoadFrameProcess();
//	m_pSaveLoad->FirstFrameProcess();

}

//========================================================================
//					L`FWp
//========================================================================
void	SK7TestTask::CharaChangeProcess()
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
		GHM_SAFE_DELETE(m_pSpecial);
		GHM_SAFE_DELETE(m_pSpOption);
		//	wiJ[Zbg
		HSD_VISetClearClr((GXColor){0x00,0x00,0x00,0xff});	
		m_pSpOption = new SK7SpOption;
	}
	if(m_pSpecial != NULL){
		m_pSpecial->SetCtrlFlag(true);
		m_pSpecial->SetRender(true);
		m_pSpecial->FrameProcess();
	}
	
	if( m_pSpOption ){
		m_pSpOption->FrameProcess();
	}
}

//========================================================================
//					t[vZX
//========================================================================
void	SK7TestTask::MainRenderProcess()
{
	C_Paper paper( 200, 150, 2, true, 300, 300 );
	PRINTF("%d", (int)(m_chProcNoSelect) );
}

//========================================================================
//					t[vZX
//========================================================================
void	SK7TestTask::MainFrameProcess()
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_UP )		m_chProcNoSelect++;
	if( HSD_PadGetTrigger(0) & HSD_PAD_DOWN )	m_chProcNoSelect--;
	if( HSD_PadGetTrigger(0) & HSD_PAD_A )		m_chProcNo = m_chProcNoSelect;
} 
//========================================================================
//					[h
//========================================================================
bool	SK7TestTask::LoadData()
{
	switch( m_Load ){
	case LOAD_CHARA_NAME:
		g_pSpData->FrameProcess();
		if( g_pSpData->GetFileReadEnd() ){
			return true;
		}
	}
	return false;
}
