////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SCNALL
//
// K7SCNALL.cpp
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 02/08/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7SCNALL_CPP__
#pragma	warn_unusedarg			off

#include "..\Fujita\C_Font.h"

////////////////////////////////////////////////////////////////////////////////
// CxgfXNv^`
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_BODY_PART
#include ".\K7SCNALL.h"

#include "..\Matsu\MK7Noise.h"
#include "..\Wat\WK7Enemy.h"
#include "..\Wat\WK7MainTask.h"

////////////////////////////////////////////////////////////////////////////////
// nh`
////////////////////////////////////////////////////////////////////////////////

K7EV_HANDLER(K7SCNALL_Init)
{
	K7SCR_RETSYS();
}

K7EV_HANDLER(K7SCNALL_Term)
{
	K7SCR_RETSYS();
}

class WK7NextStage : public WK7SmallMemObj{
protected:
	char				*mpBranchPointName;
public:
	WK7NextStage		*mpNext;
	WK7NextStage		*mpPrev;
	u32					mStageID;
	WK7NextStage(WK7NextStage *pPrev);
	~WK7NextStage();
	bool SetBranchPointName(const char *pName);
	const char* GetBranchPointName(void){ return mpBranchPointName; }
};

WK7NextStage::WK7NextStage(WK7NextStage *pPrev)
{
	mpNext = NULL;
	if( (mpPrev = pPrev)!=NULL ){
		mpPrev->mpNext = this;
	}
	mStageID = 0xffffffff;
	mpBranchPointName = NULL;
}

WK7NextStage::~WK7NextStage()
{
	GHM_SAFE_DELETE_ARRAY(mpBranchPointName);
	if( mpPrev!=NULL ){
		mpPrev->mpNext = NULL;
		delete mpPrev;
	}else if( mpNext!=NULL ){
		mpNext->mpPrev = NULL;
		delete mpNext;
	}
}

bool WK7NextStage::SetBranchPointName(const char *pName)
{
	if( pName==NULL ){
		return false;
	}
	u32		len;
	len = strlen(pName) + 1;
	GHM_SAFE_DELETE_ARRAY(mpBranchPointName);
	mpBranchPointName = new char[len];
	if( mpBranchPointName==NULL ){
		return false;
	}
	strcpy(mpBranchPointName,pName);
	return true;
}

static void StgBpArriveDefMoveTerm(WK7Stage *pNextStg=NULL,WK7StageDoorInfo *pDoorInfo=NULL,const char *pPathName=NULL);
static void StgBpArriveDefMoveTerm(WK7Stage *pNextStg,WK7StageDoorInfo *pDoorInfo,const char *pPathName)
{
	WK7Stage::DeleteStage(pNextStg);
	
	if( WK7Stage::GetManualBranch()==false ){
		
		WK7StagePlaceInfo		*pPlaceInfo;
		pPlaceInfo = WK7Stage::GetPlaceInfo(WK7Stage::GetCurrentStageID(),pPathName);
		WK7Stage::SetCameraStartPosition(pPlaceInfo);
		WK7Stage::SandRelease(pPlaceInfo,pDoorInfo);
#ifdef	_DEBUG
		WK7Stage	*pStage = WK7Stage::GetCurrentStage();
		if( pStage!=NULL ){
			pStage->SetPlaceInfoWaring(pPlaceInfo,pPathName);
		}
#endif
		
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		
		if( WK7Stage::GetMoveModeCancel()==false ){
			GameInfo.SetMode(WK7GameInfo::MOVE);
		}
		WK7Stage::SetMoveModeCancel(false);
		
	}
	
	while( WK7Stage::SetChanging(false)==false ){
		GHMGCTASK_RETSYS();
	}
	
	WK7Stage::SetManualBranch(false);
}

K7EV_HANDLER(K7SCNALL_StgBpArriveDefMove)
{
	WK7Stage			*pCurrentStg = WK7Stage::GetCurrentStage();
	u32					currStgID     = pCurrentStg->GetID();
	WK7PathBranchPoint	*pBranchPoint = (WK7PathBranchPoint *)K7EV_GETEVENTPARAM(0);
	const char			*pBranchPointName;
	if( pBranchPoint==NULL || (pBranchPointName=pBranchPoint->GetName())==NULL ){
		return;
	}
	char				bpName[128];
	char				nextStgMainIDStr[8];
	char				nextStgSuffixStr[8];
	int					i;
	const char			*psrc;
	char				*pdst;
	WK7NextStage		*pNextStageTop,*pNextStage;
	int					nextStgNum;
	
	if( (psrc = GetPartialStr(bpName,sizeof(bpName),pBranchPointName,'_'))==NULL ){
		return;
	}
	psrc++;
	
	pNextStageTop = NULL;
	pNextStage    = NULL;
	nextStgNum    = 0;
	while( 1 ){
		memset(nextStgMainIDStr,0,sizeof(nextStgMainIDStr));
		memset(nextStgSuffixStr,0,sizeof(nextStgSuffixStr));
		pdst = nextStgMainIDStr;
		for(i=0 ; i<3 ; i++){
			*pdst++ = *psrc++;
		}
		switch( *psrc ){
		case	'm':
		case	'M':
			psrc++;
			break;
		case	'_':
			psrc++;
			switch( *psrc ){
			case	'm':
			case	'M':
				psrc++;
				break;
			default:
				GHM_SAFE_DELETE(pNextStageTop);
				return;
			}
			break;
		default:
			GHM_SAFE_DELETE(pNextStageTop);
			return;
		}
		pdst = nextStgSuffixStr;
		for(i=0 ; i<2 ; i++){
			*pdst++ = *psrc++;
		}
		u32					nextStgMainID,nextStgSuffix;
		nextStgMainID = (u32)atoi(nextStgMainIDStr);
		nextStgSuffix = (u32)atoi(nextStgSuffixStr);
		pNextStage = new WK7NextStage(pNextStage);
		pNextStage->mStageID = K7STGID(nextStgMainID,nextStgSuffix);
		nextStgNum++;
		if( pNextStageTop==NULL ){
			pNextStageTop = pNextStage;
		}
		switch( *psrc ){
		case	'_':
			psrc++;
			continue;
		case	'\0':
			break;
		default:{
			char	cbpName[128];
			psrc = GetPartialStr(cbpName,sizeof(cbpName),psrc,'_');
			pNextStage->SetBranchPointName(cbpName);
			if( psrc==NULL ){
				break;
			}
			psrc++;
			}continue;
		}
		break;
	}
	
	WK7Stage			*pNextStg;
	u32					nextStgID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	while( WK7Stage::SetChanging(true)==false ){
		GHMGCTASK_RETSYS();
	}
	
	if( nextStgNum!=1 ){
		// Xe[WI
		int		selectid = 0;
		GHMGCTASK_RETSYS();
		while( 1 ){
			C_Paper		paper(0,0,0.75f);
			char		str[256];
			
			PRINTF("\n\n%64s\n","Select Stage");
			
			pNextStage = pNextStageTop;
			
			for(i=0 ; i<nextStgNum ; i++,pNextStage=pNextStage->mpNext){
				sprintf(str,"%52s Stage%03dM%02d\n",(i==selectid)? ">" : " ",
				                                    K7STG_MAINID(pNextStage->mStageID),
				                                    K7STG_SUFFIX(pNextStage->mStageID));
				PRINTF(str);
			}
			
			if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
				selectid--;
			}
			if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
				selectid++;
			}
			if( selectid < 0 ){
				selectid = nextStgNum-1;
			}else if( selectid >= nextStgNum ){
				selectid = 0;
			}
			if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
				pNextStage = pNextStageTop;
				for(i=0 ; i<selectid ; i++){
					pNextStage = pNextStage->mpNext;
				}
				break;
			}
			if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
				WK7RenderObj::SetVisibleAll(true);
				GHM_SAFE_DELETE(pNextStageTop);
				StgBpArriveDefMoveTerm();
				return;
			}
			
			K7SCR_RETSYS();
		}
	}else{
		pNextStage = pNextStageTop;
	}
	
	WK7StageDoorInfo			*pDoorInfo;
	
	nextStgID = pNextStage->mStageID;
	if( pNextStage->GetBranchPointName()!=NULL ){
		strcpy(bpName,pNextStage->GetBranchPointName());
	}
	
	pDoorInfo = WK7Stage::GetDoorInfo(currStgID,
	                                  pBranchPointName,
	                                  nextStgID,
	                                  bpName);
	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,pDoorInfo!=NULL? (int)pDoorInfo->mOpenSeID : NOISE_SE_MAP_DEFAULT);
//	k7app.FadeStart(0xff,4800);
//	k7app.SetFadeColor(0);
	
	GHM_SAFE_DELETE(pNextStageTop);
	
	if( (pNextStg = WK7RenderObj::CreateStage(nextStgID))==NULL ){
		StgBpArriveDefMoveTerm();
		return;
	}
	while( pNextStg->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	WK7Path		*pNextStgPath = pNextStg->GetPath();
	if( pNextStgPath==NULL ){
		StgBpArriveDefMoveTerm(pNextStg);
		return;
	}
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
//	while( k7app.IsFade()==true ){
//		K7SCR_RETSYS();
//	}
	for(pBranchPoint = pNextStgPath->GetBranchPointTop() ; pBranchPoint!=NULL ; pBranchPoint=pBranchPoint->GetNext()){
		if( (pBranchPointName = pBranchPoint->GetName())==NULL ){
			continue;
		}
		for(pdst=bpName,psrc=pBranchPointName; *pdst!='\0' ; psrc++,pdst++){
			if( *pdst!=*psrc ){
				break;
			}
		}
		if( *pdst!='\0' || (*psrc!='_' && *psrc!='\0') ){
			continue;
		}
		break;
	}
	if( pBranchPoint==NULL ){
		StgBpArriveDefMoveTerm(pNextStg);
		return;
	}
	K7SCR_STG_SET_CURRENT           (nextStgID);
	K7SCR_STG_SET_CURRENT_PATH_POINT(pBranchPoint->GetName());
	K7SCR_STG_VISIBLE               (nextStgID,true);
	K7SCR_STG_RELEASE               (currStgID);
	StgBpArriveDefMoveTerm(NULL,pDoorInfo,pBranchPoint->GetName());
}

static void StgBpArriveDefMoveTerm2(WK7Stage *pNextStg=NULL,WK7StageBpEvent *pBpEvent=NULL,WK7StageDoorInfo *pDoorInfo=NULL,const char *pPathName=NULL);
static void StgBpArriveDefMoveTerm2(WK7Stage *pNextStg,WK7StageBpEvent *pBpEvent,WK7StageDoorInfo *pDoorInfo,const char *pPathName)
{
	WK7Stage::DeleteStage(pNextStg);
	
	GameInfo.InitOptionWindow();
	
	if( WK7Stage::GetManualBranch()==false ){
		
		WK7StagePlaceInfo		*pPlaceInfo;
		
		pPlaceInfo = WK7Stage::GetPlaceInfo(WK7Stage::GetCurrentStageID(),pPathName);
		WK7Stage::SetCameraStartPosition(pPlaceInfo);
		WK7Stage::SandRelease(pPlaceInfo,pDoorInfo);
#ifdef	_DEBUG
		WK7Stage	*pStage = WK7Stage::GetCurrentStage();
		if( pStage!=NULL ){
			pStage->SetPlaceInfoWaring(pPlaceInfo,pPathName);
		}
#endif
		
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		
		if( WK7Stage::GetMoveModeCancel()==false ){
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		WK7Stage::SetMoveModeCancel(false);
	}
	
	GHM_SAFE_DELETE(pBpEvent);
	
	while( WK7Stage::SetChanging(false)==false ){
		GHMGCTASK_RETSYS();
	}
	
	WK7Stage::SetManualBranch(false);
}

#include "..\Stage\K7Stage121M00.h"
K7EV_HANDLER(K7SCNALL_StgBpArriveDefMove2)
{
	WK7PathBranchPointObjJObj	*pSelectObj   = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0);
	WK7Stage					*pCurrentStg  = WK7Stage::GetCurrentStage();
	u32							currStgID     = pCurrentStg->GetID();
	WK7PathBranchPoint			*pBranchPoint = pSelectObj->GetBranchPoint();
	const char					*pBranchPointName;
	if( pBranchPoint==NULL || (pBranchPointName=pBranchPoint->GetName())==NULL ){
		pSelectObj->SetEnable(true);
		return;
	}
	
	WK7StageBpEvent		*pBpEvent = new WK7StageBpEvent(pBranchPointName);
	if( pBpEvent==NULL ){
		pSelectObj->SetEnable(true);
		return;
	}
	
	WK7StageBpEventBranch	*pBranch  = pBpEvent->GetBranch();
	WK7JObj					*pJObj    = pSelectObj->GetJObj();
	const char				*pSelectObjName;
	if( pBranch==NULL || pJObj==NULL || (pSelectObjName=pJObj->GetName())==NULL ){
		GHM_SAFE_DELETE(pBpEvent);
		pSelectObj->SetEnable(true);
		return;
	}
	
	WK7StageBpEventBranchNextStage	*pStage = pBranch->GetStageTop();
	while( pStage!=NULL ){
		if( pStage->GetSelectObjName()!=NULL ){
			if( strcmp(pStage->GetSelectObjName(),pSelectObjName)==0 ){
				break;
			}
		}
		pStage = pStage->GetNext();
	}
	
	if( pStage==NULL ){
		GHM_SAFE_DELETE(pBpEvent);
		pSelectObj->SetEnable(true);
		return;
	}
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
//	WK7PLAYERCONTROL->VitalVisible(true);
	
	while( WK7Stage::SetChanging(true)==false ){
		GHMGCTASK_RETSYS();
	}
	
	u32			nextStgID = pStage->GetStageID();
	WK7Stage	*pNextStg;
	bool		sameStg;
	WK7StageDoorInfo			*pDoorInfo;
	
	WK7Stage::SetCurrentStageBpName(pStage->GetBpName());
	WK7Stage::SetPrevStageID      (currStgID       );
//	WK7Stage::SetPrevStageBpName  (pBranchPointName);
	WK7Stage::SetPrevStageBpName  (pBpEvent->GetShortBpName());
	WK7Stage::SetPrevStagePathName(NULL);
	WK7Stage::SetCurrentStageParam(pStage->GetParam());
	
	pDoorInfo = WK7Stage::GetDoorInfo(currStgID,
	                                  pBpEvent->GetBpName(),
	                                  nextStgID,
	                                  pStage->GetBpName());
	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,pDoorInfo!=NULL? (int)pDoorInfo->mOpenSeID : NOISE_SE_MAP_DEFAULT);
//	while( gpNoise->mGetSandFrameProc()!=eSandFadeIn ){
//		K7SCR_RETSYS();
//	}
	if( nextStgID!=currStgID ){
		K7SCR_RETSYS();
		pCurrentStg->SetRenderFlag(false);
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		K7SCR_STG_RELEASE    (currStgID);
		WK7PLAYERCONTROL->ReleaseArchive();
		pSelectObj = NULL;
		sameStg = false;
	}else{
		sameStg = true;
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
	
	if( sameStg==false ){
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
			GHMGCTASK_RETSYS();
		}
		
		K7SCR_CHANGE_SCENARIO_DATA();
		
		if( (pNextStg = WK7RenderObj::CreateStage(nextStgID))==NULL ){
			StgBpArriveDefMoveTerm2(NULL,pBpEvent,pDoorInfo);
			if( pSelectObj!=NULL ){
				pSelectObj->SetEnable(true);
			}
			return;
		}
		while( pNextStg->GetState()!=WK7RenderObj::LOADED ){
			K7SCR_RETSYS();
		}
		WK7PLAYERCONTROL->RestoreArchive();
		while( true == WK7PLAYERCONTROL->IsLoading() ){
			GHMGCTASK_RETSYS();
		}
	}else{
		pNextStg = pCurrentStg;
	}
	
	WK7PathNurbs				*pNextPath         = pNextStg->SearchPath(pStage->GetBpName());
	WK7PathBranchPoint			*pNextBranchPoint = NULL;
	if( pNextPath==NULL && (pNextBranchPoint=pNextStg->SearchBranchPoint(pStage->GetBpName()))==NULL ){
		WK7Path		*pPath = pNextStg->GetPath();
		if( pPath==NULL || (pNextBranchPoint = pPath->GetBranchPointTop())==NULL ){
			if( sameStg==true ){
				pNextStg = NULL;
			}
			StgBpArriveDefMoveTerm2(pNextStg,pBpEvent,pDoorInfo);
			if( pSelectObj!=NULL ){
				pSelectObj->SetEnable(true);
			}
			return;
		}
	}
	
	if( sameStg==false ){
		K7SCR_STG_SET_CURRENT(nextStgID);
		K7SCR_STG_VISIBLE    (nextStgID,true);
	}else{
		pNextStg->InitializeSelectFlag();
	}
	if( pNextPath!=NULL ){
		u32		dir;
		f32		param;
		if( pNextPath->GetStartBranchPoint()==NULL ){
			dir   = 0;
			param = pNextPath->GetEndParam();
//			param = pNextPath->GetStartParam();
		}else{
			dir = 1;
			param = pNextPath->GetStartParam();
//			param = pNextPath->GetEndParam();
		}
		WK7Stage::SetCurrentPath(pNextPath,param,dir,WK7PATHINFO_INITDIR_TGTDIR);
		WK7PLAYERPATHCONTROL->SetBranchPointFix(true);
		WK7PLAYERPATHCONTROL->SetPathSelectMode();
	}else{
		WK7PLAYERPATHCONTROL->SetBranchPointFix(false);
		K7SCR_STG_SET_CURRENT_PATH_POINT(pNextBranchPoint->GetName());
	}
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	K7SCR_TIMEWAIT(600);
	
	if( pSelectObj!=NULL ){
		pSelectObj->SetEnable(true);
	}
	StgBpArriveDefMoveTerm2(NULL,pBpEvent,pDoorInfo,pStage->GetBpName());
}

K7EV_HANDLER(K7SCNALL_StgBpArriveDefPlay)
{
	WK7PathBranchPoint	*pBranchPoint = (WK7PathBranchPoint *)K7EV_GETEVENTPARAM(0);
	const char			*pBranchPointName;
	if( pBranchPoint==NULL || (pBranchPointName=pBranchPoint->GetName())==NULL ){
		return;
	}
	const char			*psrc,*pdst;
	int					i,scnid;
	psrc = pBranchPointName;
	pdst = WK7STAGE_STGBPARRIVE_DEFPLAY_PREFIX;
	while( *pdst!='\0' ){
		if( *psrc++!=*pdst++){
			return;
		}
	}
	if( *psrc!='_' ){
		return;
	}
	psrc++;
	scnid = 0;
	for(i=0 ; i<2 ; i++){
		if( *psrc < '0' || *psrc > '9' ){
			return;
		}
		scnid *= 10;
		scnid += (*psrc - '0');
	}
	char		filename[256];
	WK7Play		*pPlay;
	
	sprintf(filename,"/Event/%02d/%s.rsl",scnid,psrc);
	if( (pPlay=WK7Play::Create(filename))==NULL ){
		return;
	}
	
	WK7CAM->StoreState();
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	k7app.FadeStart(0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	WK7Play::SetExceptPlayRenderObj(false);
//	pCurrentStg->SetRenderFlag(false);
	
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart(0,4800);
	k7app.SetFadeColor(0);
	
	// LJn
	pPlay->Start();
	// LI҂
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart(0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	GHM_SAFE_DELETE(pPlay);
	
//	pCurrentStg->SetRenderFlag(true);
	WK7Play::SetExceptPlayRenderObj(true);
	
	K7EV_PATHCONTROL->CameraRenew();
	WK7CAM->RestoreState();
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	
}

////////////////////////////////////////////////////////////////////////////////
// nhe[u
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_TBL_PART
#include ".\K7SCNALL.h"

