////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage776M00
//
// K7Stage776M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE776M00_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage776M00.h"
#include "..\..\..\Wat\WK7Event.h"

//[V
#define	MOT776M00_OPEN		(0)				//Gx[^̔J
#define	MOT776M00_CLOSE		(1)				//Gx[^̔
//f
#define	MDL776M00_ELEV_DOOR	"elevator_door"	//Gx[^hA




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage776M00::K7Stage776M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage776M00_Camera );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage776M00::~K7Stage776M00()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool K7Stage776M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT776M00_OPEN );
	CreateOwnStageMotion( MOT776M00_CLOSE );
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool K7Stage776M00::SetCurrentCallBack( void )
{
	//776M01痈ꍇ̓Gx[^Cxg
	if( GetPrevStageID() == K7STGID(776,1) )
	{
		ElevGetOff( ELEV_CAMERA_POS,		//JW
					ELEV_PLAYER_POS,		//vC[W
					MDL776M00_ELEV_DOOR,	//Gx[^f
					MOT776M00_OPEN,			//Gx[^[Vԍ
					1,						//ړ
					SFX_SYS_ELEV_DOOR,		//hAJSE
					SFX_SYS_ELEV_MOVE,		//Gx[^ړSE
					SFX_SYS_ELEV_ARRIVE,	//Gx[^SE
					false );				//ɔ[VZbg邩H
		return( false );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
// hACxg
//------------------------------------------------------------------------------
bool K7Stage776M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//Gx[^ɏ
		case	K7EVENTDOOR( 007605 ):
			gpSound->mStopSE( SFX_SYS_ELEV_DOOR );
			ElevGetOn( ELEV_CAMERA_POS, ELEV_PLAYER_POS, MDL776M00_ELEV_DOOR, MOT776M00_CLOSE, 1 );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage776M00::BpLeaveCallBack( WK7BpInfo &info )
{
	WK7JObj*		pJObj;
	WK7ModelMotion*	pMotion;
	f32	motFrame, totalMotFrame;
	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )
	{
		return( true );
	}
	
	//Gx[^̋ŊJCxg
	switch( evno )
	{
		case	K7EVENTNO( 007601 ):
			//Gx[^JF߂Â
			if( pathNo == 0 )
			{
				if( (pJObj=GetJObj(MDL776M00_ELEV_DOOR)) != NULL )
				{
					motFrame = pJObj->GetCurrentMotionFrame( false, true );
					if( motFrame < 0.0f )
					{
						if( (pJObj=PlayMotion(MDL776M00_ELEV_DOOR,MOT776M00_OPEN)) != NULL )
						{
							gpSound->mPlaySE( SFX_SYS_ELEV_DOOR );
							pJObj->SetMotionLoop( false ,false, true );
						}
					}else
					{
						//鑤̑[V擾ĊJ[V̊Jnt[vZ
						if( (pMotion=GetOwnModelMotion(MOT776M00_CLOSE)) != NULL )
						{
							totalMotFrame = pMotion->GetTotalMotionFrame();
							motFrame = totalMotFrame - motFrame;
						}else
						{
							motFrame = 0.000f;
						}
						if( (pJObj=PlayMotion(MDL776M00_ELEV_DOOR,MOT776M00_OPEN,NULL,motFrame)) != NULL )
						{
							if( motFrame == 0.0f )
							{
								gpSound->mPlaySE( SFX_SYS_ELEV_DOOR );
							}
							pJObj->SetMotionLoop( false ,false, true );
						}
					}
				}
			}else
			//Gx[^F̂
			if( pathNo == 1 )
			{
				if( (pJObj=GetJObj(MDL776M00_ELEV_DOOR)) != NULL )
				{
					motFrame = pJObj->GetCurrentMotionFrame( false, true );
					if( motFrame < 0.0f )
					{
						if( (pJObj=PlayMotion(MDL776M00_ELEV_DOOR,MOT776M00_CLOSE)) != NULL )
						{
							gpSound->mPlaySE( SFX_SYS_ELEV_DOOR );
							pJObj->SetMotionLoop( false ,false, true );
						}
					}else
					{
						//J̑[V擾ĊJ[V̊Jnt[vZ
						if( (pMotion=GetOwnModelMotion(MOT776M00_OPEN)) != NULL )
						{
							totalMotFrame = pMotion->GetTotalMotionFrame();
							motFrame = totalMotFrame - motFrame;
						}else
						{
							motFrame = 0.000f;
						}
						if( (pJObj=PlayMotion(MDL776M00_ELEV_DOOR,MOT776M00_CLOSE,NULL,motFrame)) != NULL )
						{
							if( motFrame == 0.0f )
							{
								gpSound->mPlaySE( SFX_SYS_ELEV_DOOR );
							}
							pJObj->SetMotionLoop( false ,false, true );
						}
					}
				}
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

