////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage101M01
//
// K7Stage101M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/04/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE101M01_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage101M01.h"
#include "..\..\info\K7StageSoundInfo.h"
#include "..\Yam\YK7EffectRain.h"
#include "..\Wat\WK7Zan.h"

#define	K7STAGE101M01_RINGNAME		"Ring01"

K7Stage101M01::K7Stage101M01(ghmGcListObj *pAnchor,int prio) : K7Stage101M00(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage101M01_Camera);
}

K7Stage101M01::~K7Stage101M01()
{
}

bool K7Stage101M01::InitializeCallBack(void)
{
//	Vec		point = { 0.0f , 120.0f , -350.0f };
//	mpRainEffect = CreateEffectRain(point,0.0f,1000.0f);
	WK7JObj		*pJObj = GetJObj("RainCollision2");
	if( pJObj!=NULL ){
		::SetRainCollision2JObj(pJObj);
		pJObj->Hide(false,true);
	}
	mpRainEffect = CreateEffectRain(120.0f,0.0f);
	CreateOwnStageMotion(   0);
	CreateOwnStageMotion(   1);
	return true;
}

bool K7Stage101M01::CondChangeCallBack(void)
{
	WK7JObj		*pJObj = GetJObj("Dark");
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_2F_LIGHTUP)==TRUE ){
		K7SCR_JOBJ_HIDE(pJObj);
	}else{
		K7SCR_JOBJ_DISP(pJObj);
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_RING_WATER)==TRUE ){
//	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_RING_WATER)==TRUE ){
		K7SCR_EVNO_SETENABLE(K7EVENTNO(010409),false);
		HideJObj(K7STAGE101M01_RINGNAME,false,true);
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(010409),true );
		DispJObj(K7STAGE101M01_RINGNAME,false,true);
	}
	return true;
}

bool K7Stage101M01::PathChangeCallBack(WK7PathChangeInfo &info)
{
#pragma	unused(info)
	return true;
}

bool K7Stage101M01::EventCallBack(WK7EventInfo &info)
{
	WK7ZanEventInfo		zanEventInfo;
	switch( info.mEventNo ){
	case	K7EVENTNO(010409):
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( false );
		
		//cvOƉb
		zanEventInfo.Initialize();
		zanEventInfo.mEventNo = K7EVENTZAN(010007);
		zanEventInfo.mpStage  = this;
		GameInfo.SetZanMesID( 0 );
		GameInfo.SetZanExecWait       (true);
		GameInfo.SetZanTermWait       (true);
		GameInfo.SetZanNoiseCancel    (true);
		GameInfo.SetZanCharaLoadCancel(true);
		CallZanEventCallBackTask( zanEventInfo );
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_EXECWAIT ){
			K7SCR_RETSYS();
		}
		
		gpSound->mPlaySE(SFX_SCE1_FUKU_TOBUKURO);
		PlayMotion(0,0.0f);
		SetMotionLoop(false);
		while( GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		
		GameInfo.SetZanExecWait(false);
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT ){
			K7SCR_RETSYS();
		}
		GameInfo.SetZanTermWait         (false);
		GameInfo.SetZanManual           (true);
		GameInfo.SetZanCinemaScopeCancel(true);
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY ){
			K7SCR_RETSYS();
		}
		gpSound->mStopStream();
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( false );
		
		K7SCR_STG_ITEMGET(K7STAGE101M01_MES_RING_WATER);
		K7SCR_STG_ITEMGET_NOTDISPLAYED_B(K7STAGE101M01_MES_RING_WATER);
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		K7SCR_SET_GLOBAL_FLAG(K7GLFL_RING_WATER);
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_RING_WATER);
		K7SCR_EVCONDCHANGE();
		K7SCR_STG_ITEMGET_VALID_B(K7STAGE101M01_MES_RING_WATER);
		
		K7SCR_EVSETITEM( K7EVENTZAN(010007), false );
		
		zanEventInfo.Initialize();
		zanEventInfo.mEventNo = K7EVENTZAN(010007);
		zanEventInfo.mpStage  = this;
		GameInfo.SetZanMesID( 1 );
		GameInfo.SetZanExecWait       (true);
		GameInfo.SetZanTermWait       (true);
		GameInfo.SetZanNoiseCancel    (true);
		GameInfo.SetZanCharaLoadCancel(true);
		CallZanEventCallBackTask( zanEventInfo );
		
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_EXECWAIT ){
			K7SCR_RETSYS();
		}
		GameInfo.SetZanExecWait( false );
		
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT ){
			K7SCR_RETSYS();
		}
		
		gpSound->mFadeVolumeStream(0,200);
//		gpSound->mStopStream();
		
		gpSound->mSetMasterVolumeSE(SOUND_MASTER_VOLUME,1);
		K7SCR_RETSYS();
		gpSound->mPlaySE(SFX_SCE1_FUKU_TOBUKURO);
		PlayMotion(1,0.0f);
		SetMotionLoop(false);
		while( GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		gpSound->mStopStream();
		gpSound->mSetVolumeStream(WK7ZAN_VOLUME_MUSIC);
		
		GameInfo.SetZanTermWait         (false);
		GameInfo.SetZanNoiseCancel      (false);
		GameInfo.SetZanCinemaScopeCancel(false);
		GameInfo.SetZanManual           (false);
		GameInfo.SetZanTermNoiseWait    (true );
		
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERM_NOISEWAIT ){
			K7SCR_RETSYS();
		}
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		GameInfo.SetZanTermNoiseWait    (false);
		
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY ){
			K7SCR_RETSYS();
		}
		
		gpSound->mPlayStreamNo( HPS_KRAKUJITU_C );
		K7SCR_PC_SETVISIBLE( true );
		K7SCR_EVCONDCHANGE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage101M01::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(015001):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_2F_LIGHTUP)==FALSE ){
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE(false);
			
			FixCam(DOOR_015001);
			K7SCR_STGC_MESSAGE_B(K7STAGE101M01_MES_INVISIBLE);
			
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		
			return false;
		}
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_ENFL_FUKSU);
		gpSound->mSetDspRateAll(K7SOUND_REVERB_SML);
		gpSound->mPlayStreamEx(HPS_KRAKUJITU_C,VOLUME_MUSIC,true);
		break;
	case	K7EVENTDOOR(015002):
		K7SCR_RESET_SCENARIO_FLAG(K7SCN01_ENFL_FUKSU);
		gpSound->mSetDspRateAll(K7SOUND_REVERB_SML);
		gpSound->mPlayStreamEx(HPS_RAKUJITU_G,VOLUME_MUSIC,true);
		break;
	default:
		break;
	}
	return true;
}

