////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage107M00
//
// K7Stage107M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE107M00_CPP__

#include ".\K7Stage107M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"
#include "..\..\..\Yam\YK7EffectScreen.h"
#include "..\..\..\Yam\YK7EffectSmoke.h"
#include "..\..\..\Yam\YK7EffectImpact.h"

#define	K7STAGE107M00_EVENT_015300_CLOSE_PATHNAME		"curve"
#define	K7STAGE107M00_MSK_MOTID							K7MOTID(K7MSK,510)

const u16 _SmokParam[20] = 
{	101,		3,		2,		274,		50,
	20,		60,		50,		90,		70,

	191,	175,	150,		255,		5,
	30,		30,		10,		79,		0 } ;

K7Stage107M00::K7Stage107M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpFireEffect = NULL;
	mpMskMotion  = NULL;
	SetOneShotCamLocTbl(K7Stage107M00_Camera);
	Smoke = NULL ;
	Impact = NULL ;
	Screen = NULL ;
}

K7Stage107M00::~K7Stage107M00()
{
	if( CheckEffectValidState( Impact, ImpactID ) == TRUE ) DeleteEffect( Impact ) ;
	if( CheckEffectValidState( Screen, ScreenID ) == TRUE ) DeleteEffect( Screen ) ;
	if( CheckEffectValidState( Smoke, SmokeID ) == TRUE ) DeleteEffect( Smoke ) ;
}

bool K7Stage107M00::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE107M00_MSK_MOTID);
	return true;
}

bool K7Stage107M00::InitializeCallBack(void)
{
	WK7JObj		*pObj = GetJObj("burn");
	for(pObj=pObj->GetChild() ; pObj!=NULL ; pObj=pObj->GetNext()){
		WK7RenderObjEffect	*pFireEffect;
		pObj->Hide(false,true);
		pFireEffect = CreateEffectModelFire(pObj,MFIRE_FUK_107);
		if( strcmp(pObj->GetName(),"burn_015300")==0 ){
			mpFireEffect = pFireEffect;
		}
	}
	mpMskMotion = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE107M00_MSK_MOTID);
	return true;
}

bool K7Stage107M00::SetCurrentCallBack(void)
{
	KK7SoundLoopSePlayVolumeChange((Vec){ -20.934f, 0.0f, - 43.386f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_AMB_FIRE,SOUND_EVENT_SE_VOLUME,0,0,K7SCN01_PLAY_01050102);
	KK7SoundLoopSePlayVolumeChange((Vec){  27.168f, 0.0f, - 41.799f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_A  ,SOUND_EVENT_SE_VOLUME,0,0,K7SCN01_PLAY_01050102);
	KK7SoundLoopSePlayVolumeChange((Vec){  66.386f, 0.0f,    0.271f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_B  ,SOUND_EVENT_SE_VOLUME,0,0,K7SCN01_PLAY_01050102);
	KK7SoundLoopSePlayVolumeChange((Vec){  60.931f, 0.0f, -122.991f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_C  ,SOUND_EVENT_SE_VOLUME,0,0,K7SCN01_PLAY_01050102);
	KK7SoundLoopSePlayVolumeChange((Vec){ -18.604f, 0.0f, -160.261f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_A  ,SOUND_EVENT_SE_VOLUME,0,0,K7SCN01_PLAY_01050102);
	KK7SoundLoopSePlayVolumeChange((Vec){  20.584f, 0.0f, -153.821f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_B  ,SOUND_EVENT_SE_VOLUME,0,0,K7SCN01_PLAY_01050102);
	KK7SoundLoopSePlayVolumeChange((Vec){ -19.635f, 0.0f, -193.006f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_C  ,SOUND_EVENT_SE_VOLUME,0,0,K7SCN01_PLAY_01050102);
	if( WK7Play::HasPlayed(K7EVENTPLAY(01050102))==false ){
		KK7SoundLoopSePlayVolumeChange((Vec){  -2.196f, 0.0f, -426.016f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_AMB_FIRE,SOUND_EVENT_SE_VOLUME,0,0,K7SCN01_PLAY_01050102);
	}
	return true;
}

bool K7Stage107M00::CondChangeCallBack(void)
{
	WK7JObj		*pJObj = GetJObj("event_015300_cmn");
	if( WK7Play::HasPlayed(K7EVENTPLAY(01050102))==true ){
		K7SCR_STG_SET_PATHENABLE(K7STAGE107M00_EVENT_015300_CLOSE_PATHNAME,true);
		K7SCR_EVNO_SETENABLE(K7EVENTNO(015301),false);
		K7SCR_JOBJ_HIDE(pJObj);
		ReleaseEffect(mpFireEffect);
		mpFireEffect = NULL;
		PlayMotion(0,-1.0f);
		SetMotionLoop(false);
	}else{
		K7SCR_STG_SET_PATHENABLE(K7STAGE107M00_EVENT_015300_CLOSE_PATHNAME,false);
		K7SCR_EVNO_SETENABLE(K7EVENTNO(015301),true );
		K7SCR_JOBJ_DISP(pJObj);
		PlayMotion(0,0.0f);
		SetMotionLoop(false);
		StopMotion();
	}
//	if( K7SCR_EVHASITEM(K7EVITEM_KEY(010003))==true ){
//		K7SCR_EVNO_SETENABLE(K7EVENTNO(010700),false);
//	}else{
//		K7SCR_EVNO_SETENABLE(K7EVENTNO(010700),true);
//	}
	return true;
}

bool K7Stage107M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(015301):
		if( WK7PLAYERCONTROL->GetMainID()!=K7MSK ){
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE(false);
			
			FixCam(EVENT_015301);
			
			K7SCR_STG_MESSAGE_B(K7STAGE107M00_MES_EXIST_OBSTACLE);
			
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			return false;
		}
		
		u32		no = K7EVENTPLAY(01050102);
		if( WK7Play::HasPlayed(no)==false ){
			
			WK7Model	*pPcModel = WK7PLAYERCONTROL->GetCharaModel();
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			K7SCR_NOISE_REQUEST();
			K7SCR_NOISE_REQUEST_WAIT();
			
			WK7PLAYERCONTROL->SetEnable(false);
			WK7PLAYERCONTROL->SetClothEnable(false);
			
			if( pPcModel!=NULL ){
				pPcModel->SetPosition  (-0.8f,0.0f,-293.0f);
				pPcModel->SetRotY      (-HALF_PI);
				pPcModel->AttachMotion (mpMskMotion);
				pPcModel->PlayMotion   ();
				pPcModel->SetMotionLoop(false);
				pPcModel->StopMotion   ();
			}
			
//			WK7CAM->SetCinemaScopeMode(true);
			FixCam(EVENT_015301_2);
			
			K7SCR_NOISE_RELEASE();
			
			PlayMotion(0,0.0f);
			SetMotionLoop(false);
			
			gpSound->mPlaySE(SFX_SCE1_FUKU_PILLERBOMB);
			if( pPcModel!=NULL && mpMskMotion!=NULL ){
				pPcModel->ReplayMotion();
				
				Screen = CreateScreenEffect() ;
				if( Screen != NULL )
				{
					SetScreenEffectExRate( Screen, 1.02F ) ;
					SetScreenEffectAddFlag( Screen, FALSE ) ;
					SetScreenEffectAlpha( Screen, 0.45F ) ;
					SetScreenEffectDrawFlag( Screen, TRUE ) ;
					ScreenID = GetEffectID( Screen ) ;
				}
				while( pPcModel->GetMotionState()!=WK7MODEL_NOANIM ){
					if ( 230 == pPcModel->GetCurrentMotionFrame() ){				// }XNӂ΂萺Đ
						gpSound->mPlaySE( SFX_PC_MSK_POWVOICE_A,
										  SOUND_SYSTEM_SE_VOLUME,					// 
										  SOUND_PAN_CENTER,							// p
										  eSETrackBattleOverlap, 					// gbN
										  eSEGroupBattle00Env );					// O[v
					}
					K7SCR_RETSYS();
					
					if ( 290 == pPcModel->GetCurrentMotionFrame() ){
						// o
						{
							GXColor Color ;
							Vec Point = { 7.413F, 0.319F, -296.893F } ;
							
							Color.r = (u8)_SmokParam[10] ;
							Color.g = (u8)_SmokParam[11] ;
							Color.b = (u8)_SmokParam[12] ;
							Smoke = CreateSmokeEffect( 1, Point, _SmokParam[0] * 0.1F,
												_SmokParam[1] * 0.01F, _SmokParam[2] * 0.01F,
												0.0F, _SmokParam[3],
												(Vec){0.0F,0.0F,0.0F}, 0.0F,
												PI * _SmokParam[4] * 0.1F / 180.0F, PI * _SmokParam[5] * 0.1F / 180.0F, 
												_SmokParam[6] * 0.1F, _SmokParam[7] * 0.1F,
												_SmokParam[6] * 0.1F, _SmokParam[7] * 0.1F,
												_SmokParam[8], _SmokParam[9], _SmokParam[17] * 1.0F,
												Color, Color, Color, (u8)_SmokParam[13],
												PI * _SmokParam[18] / 180.0F, 0.0F, FALSE, (u8)_SmokParam[14], 
												_SmokParam[15] * 0.01F, FALSE, 0,
												Color, Color, Color,
												_SmokParam[16] * 0.01F ) ;
							if( Smoke != NULL ) SmokeID = GetEffectID( Smoke ) ;
						}
						
						// ʂh炷
						Impact = CreateImpactEffect( 60, 40, (Vec){0.0F, 0.0F, 0.0F}, 17, 0, TRUE ) ;
						if( Impact != NULL ) ImpactID = GetEffectID( Impact ) ;
					}
					if ( 390 == pPcModel->GetCurrentMotionFrame() ){
						pPcModel->StopMotion();
						break;
					}
				}
			}
			
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
			
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,SFX_SCE1_MAP_CHANGE_KIDAI_OPEN)==false ){
				K7SCR_RETSYS();
			}
			WK7PLAYERCONTROL->SetClothEnable(true);
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_PLAY_01050102);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7PLAYERCONTROL->SetEnable(true);
			
			while( WK7Stage::ReleaseStageArchive()==false ){
				K7SCR_RETSYS();
			}
			
			while( WK7Stage::IsReleasedStageArchive()==false ){
				K7SCR_RETSYS();
			}
			
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7Play		*pPlay;
			while( (pPlay=WK7Play::Create(no))==NULL ){
				K7SCR_RETSYS();
			}
			pPlay->Prepare();
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			WK7Play::StorePlayTB();
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			pPlay->Start();
			K7SCR_RETSYS();
			while( gpNoise->mSandRelease(NULL,NULL,NULL,NULL,SFX_SYS_SAND_NOISE)==false ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,SFX_SYS_SAND_NOISE)==false ){
				K7SCR_RETSYS();
			}
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			GHM_SAFE_DELETE(pPlay);
			WK7Play::RestorePlayTB();
			
			WK7Play::SetPlayed(no,true);
			
			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_PLAY_01050102);
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_KITCHEN);
			
			while( WK7Stage::RestoreStageArchive()==false ){
				K7SCR_RETSYS();
			}
			
			// mCYI҂
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			while( WK7Stage::IsRestoredStageArchive()==false ){
				K7SCR_RETSYS();
			}
			
			WK7CAM->RestoreState();
			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			
			WK7PLAYERCONTROL->SetOperateEnable(false);
			
			gpSound->mPlaySE(SFX_SCE1_FUKU_TUURO_KUZUERU);
			
			K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("event_015301","BackRoom2_curve1",0.0f,K7SCR_CAM_PATHDIR_REV);
			
			while( gpNoise->mSandRelease(NULL,NULL,NULL,NULL,SFX_SCE1_MAP_CHANGE_KIDAI_CLOSE)==false ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
		}
		return false;
	default:
		break;
	}
	return true;
}


bool K7Stage107M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(010014):
		if( WK7PLAYERCONTROL->GetMainID()!=K7MSK ){
			// }XN\͂gĂȂ
			FixCamMes(DOOR_010014,K7STAGE107M00_MES_CANT_ADVANCE_BY_FLAME);
			return false;
		}
		break;
	default:
		break;
	}
	return true;
}

