////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage113M00
//
// K7Stage113M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE113M00_CPP__

#include ".\K7Stage113M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"

K7Stage113::K7Stage113(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage113M00_Camera);
}

K7Stage113::~K7Stage113()
{
}

bool K7Stage113::MotionPlay(int evflag,u32 mesid,int id,int camid)
{
	char		str[32];
	int			motid;
	f32			frame;
	sprintf(str,K7SCN01_STG113_FUSUMA_MOTION "%1d",id);
	evflag += id-1;
	WK7JObj		*pJObj = GetJObj(str);
	if( K7SCR_GET_SCENARIO_FLAG(evflag)!=TRUE ){
		motid = 1;
	}else{
		motid = 0;
	}
	if( camid >= 0 ){
		motid ^= 1;
		frame = 0.0f;
	}else{
		frame = -1.0f;
	}
	if( (pJObj=PlayMotion(str,motid,K7SCN01_STG113_FUSUMA_MOTION,frame))==NULL ){
		return false;
	}
	pJObj->SetMotionLoop(false,false,true);
	if( camid < 0 ){
		return true;
	}
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE(false);
	
	FixCam((u32)camid);
	
	gpSound->mPlaySE(SFX_SCE1_FUSUMA_SLOW);
	while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
		K7SCR_RETSYS();
	}
	
	K7SCR_REVERSE_SCENARIO_FLAG(evflag);
	if( mesid != 0xffffffff ){
		if( K7SCR_GET_SCENARIO_FLAG(evflag)==TRUE ){
			K7SCR_STGC_MESSAGE_B(mesid + 1);
		}else{
			K7SCR_STGC_MESSAGE_B(mesid    );
		}
	}
	
#if 0
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100_1)==FALSE &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100_2)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100_3)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010101_1)==FALSE &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010101_2)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010101_3)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102_1)==FALSE &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102_2)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010102_3)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103_1)==FALSE &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103_2)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010103_3)==TRUE  &&
	    K7SCR_EVHASITEM(K7EVENTTAMA(010000))==FALSE ){
		
//		gpSound->mPlaySE(SFX_SYS_TRUE);
//		
//		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
		
		K7SCR_SYS_ITEMGET(K7SCR_SYSMES_GETTAMA);
		K7SCR_SYS_ITEMGET_NOTDISPLAYED_B(K7SCR_SYSMES_GETTAMA);
		K7SCR_EVSETITEM(K7EVITEM_TAMA(010000),true);
		K7SCR_PC_SETVISIBLE(true);
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		K7SCR_SYS_ITEMGET_VALID_B(K7SCR_SYSMES_GETTAMA);
		
	}
#endif
	
	K7SCR_PC_SETVISIBLE(true);
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	K7SCR_EVCONDCHANGE();
	return true;
}

K7Stage113M00::K7Stage113M00(ghmGcListObj *pAnchor,int prio) : K7Stage113(pAnchor,prio)
{
}

K7Stage113M00::~K7Stage113M00()
{
}

bool K7Stage113M00::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	CreateOwnStageMotion(   1);
	return true;
}

bool K7Stage113M00::SetCurrentCallBack(void)
{
	return true;
}

bool K7Stage113M00::CondChangeCallBack(void)
{
	int			i;
	for(i=1 ; i<=3 ; i++){
		MotionPlay(K7SCN01_EVFL_010100_1,0xffffffff,i);
	}
	return true;
}

bool K7Stage113M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(010105):
		MotionPlay(K7SCN01_EVFL_010100_1,K7STAGE113M00_MES_CLOSE_FUSUMA_EVENT_010105,1,EVENT_010105);
		break;
	case	K7EVENTNO(010107):
		MotionPlay(K7SCN01_EVFL_010100_1,K7STAGE113M00_MES_CLOSE_FUSUMA_EVENT_010107,2,EVENT_010107);
		break;
	case	K7EVENTNO(010106):
		MotionPlay(K7SCN01_EVFL_010100_1,K7STAGE113M00_MES_CLOSE_FUSUMA_EVENT_010106,3,EVENT_010106);
		break;
	default:
		break;
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100_1)==FALSE &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100_2)==TRUE  &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010100_3)==TRUE  ){
	    K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010100);
	}else{
	    K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010100);
	}
	return true;
}

