////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage114M00
//
// K7Stage114M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE114M00_H__
#define	__K7STAGE114M00_H__

#include "..\K7Stage.h"

#define	K7SCN01_STG114_TYPESTACK_NUM		(5)
//#define	K7SCN01_STG114_TYPESTACK_NUM		(20)
//#define	K7SCN01_STG114_TYPESTACK_NUM		(256)
class K7Stage114M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	int				mType;
	int				mTypeStackID;
	int				mTypeStack[K7SCN01_STG114_TYPESTACK_NUM];
	int				mOpenCloseID[2];
	
	int				mJunctionDir;
	
	
	
	bool			mFinish;
	int				mAnswerCount;
	u32				mRightEventNo;
	u32				mPicture;
	u32				mFront;
	WK7JObj			*mpGate[2];
	
	bool InitMember(void);
	bool Initialize(int dir=-1);
	bool SetPathEnable(u32 eventNo,u32 pathNo,bool flag,int enableex=-1);
	bool SetPathEnable(u32 eventNo,bool flag,int enableex=-1);
	bool OpenFusuma(u32 eventNo,u32 pathNo);
	bool ChangeFusuma(u32 eventNo,u32 pathNo);
	bool CloseFusuma(u32 eventNo,u32 pathNo);
	bool GetNextPath(u32 dir,const char *pPathName,char *pNextPathName);
	int GetPrevType(void);
	int GetNextType(void);
	int GetCurrentType(void);
	bool Reverse(void);
	bool Forward(int type);
	bool SetAroundPathEnable(int fromdir,int todir);
	
	K7Stage114M00();
	K7Stage114M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage114M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool BpArriveCallBack  (WK7BpInfo        &);
};

#ifdef	__K7STAGE114M00_CPP__

enum K7STAGE114M00_ONESHOTCAM{
	DOOR_010012,
	DOOR_010013,
	EVENT_010002,
};

K7StageEventOneShotCamera	K7Stage114M00_Camera[] = {
//	{{43.236f, 13.548f, -314.762f},{16.405f, 11.578f, -300.424f}},		// ̖I񂾂Ƃ̉o
//	{{-35.809f, 13.548f, -314.008f},{-10.213f, 10.675f, -297.702f}},	// ̖I񂾂Ƃ̉o
	{{59.149f, 13.936f, -367.599f},{3.119f, 9.586f, -342.621f}},		// ̖I񂾂Ƃ̉o
	{{-59.278f, 13.936f, -366.154f},{-4.905f, 11.553f, -337.519f}},		// ̖I񂾂Ƃ̉o
	{{-6.588f, 18.818f, -422.703f},{5.413f, 17.317f, -362.648f}},		// GI񂾂Ƃ̉o
};

enum{
	K7STAGE114M00_MES_GET_HATOMEMO = 0			,		// uȁvɓꂽ
	K7STAGE114M00_MES_TIGER_LOOK_RIGHT			,		// Ղ͉EĂ
	K7STAGE114M00_MES_TIGER_LOOK_LEFT			,		// Ղ͍Ă
	K7STAGE114M00_MES_WOLF_LOOK_RIGHT			,		// T͉EĂ
	K7STAGE114M00_MES_WOLF_LOOK_LEFT			,		// T͍Ă
	K7STAGE114M00_MES_TIGER_LOOK_FRONT			,		// Ղ͐ʂĂ
	K7STAGE114M00_MES_WOLF_LOOK_FRONT			,		// T͐ʂĂ
	K7STAGE114M00_MES_OPEN_FUSUMA_011104		,		// ӂ܂JEVENT_011104
	K7STAGE114M00_MES_OPEN_FUSUMA_011105		,		// ӂ܂JEVENT_011105
	K7STAGE114M00_MES_OPEN_FUSUMA_011106		,		// ӂ܂JEVENT_011106
	K7STAGE114M00_MES_OPEN_FUSUMA_011107		,		// ӂ܂JEVENT_011107
	K7STAGE114M00_MES_PASS_FRONT_GATE			,		// Oʉ߂
	K7STAGE114M00_MES_PASS_BACK_GATE			,		// ʉ߂
};

#endif

#endif	//__K7STAGE114M00_H__

