////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage116M00
//
// K7Stage116M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE116M00_CPP__

#include ".\K7Stage116M00.h"
#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Wat\WK7Item.h"

#define	K7STAGE116M00_KIS_CHRID		K7CHRID(K7KIS,  0)
#define	K7STAGE116M00_KIS_MOTID		K7MOTID(K7KIS,200)

K7Stage116M00::K7Stage116M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpKisModel  = NULL;
	mpKisMotion = NULL;
	SetOneShotCamLocTbl(K7Stage116M00_Camera);
}

K7Stage116M00::~K7Stage116M00()
{
}

bool K7Stage116M00::CreateCallBack(void)
{
	CreateOwnChara(K7STAGE116M00_KIS_CHRID);
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE116M00_KIS_MOTID);
	return true;
}

bool K7Stage116M00::InitializeCallBack(void)
{
//	WK7Stage::ClearChangeChara();
//	WK7Stage::SetChangeChara(K7HAC,true);
	mpKis       = GetOwnChara(K7STAGE116M00_KIS_CHRID);
	mpKisModel  = GetOwnModel(K7OBJTYPE_CHR,K7STAGE116M00_KIS_CHRID);
	mpKisMotion = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE116M00_KIS_MOTID);
	return true;
}

bool K7Stage116M00::TerminateCallBack(void)
{
//	WK7Stage::ClearChangeChara();
	return true;
}

bool K7Stage116M00::SetCurrentCallBack(void)
{
	if( WK7RenderObj::IsValid(mpKis)==true && mpKisModel!=NULL && mpKisMotion!=NULL ){
		mpKis->SetPosition  (15.793f,0.0f,-298.025f);
		mpKis->SetRotY      (-PI * 0.25f);
		mpKisModel->AttachMotion(mpKisMotion);
		mpKisModel->PlayMotion();
		mpKisModel->SetMotionLoop(true);
	}
//	WK7Stage::SetCurrentPath("set1","Acurve1",0.0f,K7SCR_CAM_PATHDIR);
	return true;
}

bool K7Stage116M00::CondChangeCallBack(void)
{
	if( WK7RenderObj::IsValid(mpKis)==true ){
		if( WK7Play::HasPlayed(K7EVENTPLAY(01050206))==true ){
			mpKis->SetRenderFlag(false);
		}else{
			mpKis->SetRenderFlag(true);
		}
	}
	return true;
}

bool K7Stage116M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	u32						playno;
	WK7StagePlaceInfo		*pPlaceInfo;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(010011):
		if( WK7PLAYERCONTROL->GetMainID()!=K7HAC ){
			break;
		}
		playno = K7EVENTPLAY(01050206);
		
		if( WK7Play::HasPlayed(playno)==true ){
			return true;
		}
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();

		K7SCR_NOISE_REQUEST();
		WK7Play::SetTermCaptureRenderOn(true);
		K7SCR_STAGE_RELEASE();
		K7SCR_CHARAGEKI_PREPARE( playno );
		K7SCR_NOISE_RELEASE();
		K7SCR_CHARAGEKI_END_WAIT( playno );
		WK7Play* pPlay = WK7Play::Find( playno );
		pPlay->SetVisibleAll( false );
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		GHM_SAFE_DELETE( pPlay );
		WK7Play::SetPlayed( playno, true );
		K7SCR_BLACK_FADEOUT();
		
		WK7Play::SetInitCaptureRenderOff(true);
		WK7Play::SetTermCaptureRenderOn (false);
		playno = K7EVENTPLAY(01050203);
		while( (pPlay=WK7Play::Create(playno)) == NULL ){ K7SCR_RETSYS(); }
		pPlay->Prepare();
		while( pPlay->GetState() != WK7Play::PREPARED ){ K7SCR_RETSYS(); }
		pPlay->Start();
		K7SCR_RETSYS();
		K7SCR_BLACK_FADEIN();
		K7SCR_CHARAGEKI_END_WAIT( playno );
		WK7Play::SetInitCaptureRenderOff(false);
		
		//mCY
		K7SCR_NOISE_REQUEST();
		K7SCR_CHARAGEKI_TERM( playno );
		K7SCR_STAGE_RESTORE();
	    WK7Chara::SetRenderChara(true);
	    WK7Stage::SetRenderStage(true);
	    WK7Item::SetRenderItem(true);
		WK7CAMPATHFOLLOWINFO->SetStageStartMode(false);
		WK7CAM->SetBranchPointMode(false);
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		K7SCR_NOISE_RELEASE();
		
#if	0
		gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
		K7SCR_RETSYS();
		
	    WK7Chara::SetRenderChara(false);
	    WK7Stage::SetRenderStage(false);
	    WK7Item::SetRenderItem(false);
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
		
		while( WK7Stage::ReleaseStageArchive()==false ){
			K7SCR_RETSYS();
		}
		
		while( WK7Stage::IsReleasedStageArchive()==false ){
			K7SCR_RETSYS();
		}
		
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		
		WK7Play::StorePlayTB();
		
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		
		WK7Play::PlayTB(playno);
		WK7Play::PlayTB(K7EVENTPLAY(01050203));
		
		gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
		
		while( WK7Stage::RestoreStageArchive()==false ){
			K7SCR_RETSYS();
		}
		
		while( WK7Stage::IsRestoredStageArchive()==false ){
			K7SCR_RETSYS();
		}
		
		while( SandRelease()==false ){
			K7SCR_RETSYS();
		}
		
		WK7CAMPATHFOLLOWINFO->SetStageStartMode(false);
		WK7CAM->SetBranchPointMode(false);
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		WK7Play::RestorePlayTB();
		
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
#endif
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		return false;
	case	K7EVENTDOOR(015004):
		SetManualBranch(true);
		DoorEventTask(info);
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		pPlaceInfo = GetPlaceInfo(info.mNextBpName);
		SetCameraStartPosition(pPlaceInfo);
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		while( SandRelease(pPlaceInfo)==false ){
			K7SCR_RETSYS();
		}
		if( WK7PLAYERCONTROL->GetMainID()!=K7HAC && WK7Play::HasPlayed(K7EVENTPLAY(01050206))==false ){
				
			FixCam( CHANGE_CHARA1 );
			K7SCR_TIMEWAIT( 4800 * 2 );
			WatchCameraB( K7Stage116M00_Camera[CHANGE_CHARA1_1].tgt,
						  K7Stage116M00_Camera[CHANGE_CHARA1_1].pos,
						  K7CHRID(K7HAC,0), 1 );
			
		}else{
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				GHMGCTASK_RETSYS();
			}
		}
		SetManualBranch(false);
		K7SCR_STG_SET_JUNCTION_PASS_EVNO(K7EVENTNO(015005));
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
		return false;
	case	K7EVENTDOOR(015005):
		SetManualBranch(true);
		DoorEventTask(info);
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		pPlaceInfo = GetPlaceInfo(info.mNextBpName);
		SetCameraStartPosition(pPlaceInfo);
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		while( SandRelease(pPlaceInfo)==false ){
			K7SCR_RETSYS();
		}
		if( WK7PLAYERCONTROL->GetMainID()==K7HAC ){
			
			u32	pcid = GetAlivePcID(K7MSK);
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			FixCam( CHANGE_CHARA0 );
			K7SCR_TIMEWAIT( 4800 * 2 );
			WatchCameraB( K7Stage116M00_Camera[CHANGE_CHARA0_1].tgt,
						  K7Stage116M00_Camera[CHANGE_CHARA0_1].pos,
						  K7CHRID(pcid,0), 1 );
			
		}else{
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				GHMGCTASK_RETSYS();
			}
		}
		SetManualBranch(false);
		K7SCR_STG_SET_JUNCTION_PASS_EVNO(K7EVENTNO(015004));
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
		return false;
	default:
		break;
	}
	return true;
}

