////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage117M00 
//
// K7Stage117M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE117M00_CPP__

#include "..\..\Scn\K7Scn01.h"
#include ".\K7Stage117M00.h"
#include "..\..\Wat\WK7EffectBreakObj.h"
#include "..\Yam\YK7EffectRain.h"

#define	K7STAGE117M00_KED_RIDDLE_BREAKOBJNAME	"event_015100_ked"
#define	K7STAGE117M00_KED_RIDDLE_PATHNAME		"event_015100_0"
#define	K7STAGE117M00_KED_CLOSE_PATHNAME		"pass_ked"
#define	K7STAGE117M00_NEST_CLOSE_PATHNAME		"Pass_Nest"

K7Stage117M00::K7Stage117M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	pNpcSu = NULL;
	mpRainEffect = NULL;
	SetOneShotCamLocTbl(K7Stage117M00_Camera);
}

K7Stage117M00::~K7Stage117M00()
{
	ReleaseEffect(mpRainEffect);
}

bool K7Stage117M00::InitializeCallBack(void)
{
	SetZanEnable(K7EVENTTAMA(010000),false);
	mpRainEffect = CreateEffectRain(100.0f,-5.0f);
	return true;
}

bool K7Stage117M00::CondChangeCallBack(void)
{
//	K7SCR_EVNO_SETENABLE(K7EVENTZAN(010013),false);
	K7SCR_EVNO_SETENABLE(K7EVENTNO(015102),false);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_SP_117M00_KED)==TRUE ){
		K7SCR_STG_SET_PATHENABLE       (K7STAGE117M00_KED_CLOSE_PATHNAME ,true);
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE117M00_KED_RIDDLE_PATHNAME,true);
		SetVisibleJObj(K7STAGE117M00_KED_RIDDLE_BREAKOBJNAME,false,false,true);
	}else{
		K7SCR_STG_SET_PATHENABLE       (K7STAGE117M00_KED_CLOSE_PATHNAME ,false);
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE117M00_KED_RIDDLE_PATHNAME,false);
		SetVisibleJObj(K7STAGE117M00_KED_RIDDLE_BREAKOBJNAME,true ,false,true);
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_HS_NEST_117M00)==TRUE ){
		K7SCR_STG_SET_PATHENABLE       (K7STAGE117M00_NEST_CLOSE_PATHNAME,true );
	}else{
		K7SCR_STG_SET_PATHENABLE       (K7STAGE117M00_NEST_CLOSE_PATHNAME,false);
	}
	return true;
}

bool K7Stage117M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(015100):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_SP_117M00_KED)==TRUE ){
			return true;
		}
		break;
	case	K7EVENTNO(015101):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_SP_117M00_CYO)==TRUE ){
			return true;
		}
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

bool K7Stage117M00::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
//	WK7JObj		*pJObj;
	WK7PlayerSpInfoKed	*pKedInfo = WK7PLAYERCONTROL->GetSpInfoKed();
	switch( info.mAbilityID ){
	case	PC_SPA_BLOODY_SHOWER:
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_SP_117M00_KED)==TRUE ){
			WK7PLAYERCONTROL->SetSpAbilityCancel(true);
			return false;
		}
//		K7SCR_SET_SCENARIO_FLAG(K7SCN01_HS_NEST_117M00);		// ܂͂Ƃ肠
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_SP_117M00_KED);
		WK7PLAYERCONTROL->SetSpInfoType(0);
		pKedInfo->mpTargetJObj = GetJObj(K7STAGE117M00_KED_RIDDLE_BREAKOBJNAME);
		pKedInfo->mKedPos .x = -445.014f;
		pKedInfo->mKedPos .y = -5.0f;
		pKedInfo->mKedPos .z = -637.778f;
		pKedInfo->mKedRotY   = -1.0f;
		pKedInfo->mZanPos .x = -441.261f;
		pKedInfo->mZanPos .y = -5.0f;
		pKedInfo->mZanPos .z = -624.029f;
		pKedInfo->mZanRotY   = -1.0f;
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_MOTSTART     ){
			K7SCR_RETSYS();
		}
		FixCam(SECTRET_0);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_ZANAPPEAR    ){
			K7SCR_RETSYS();
		}
		FixCam(SECTRET_1);
		WK7CAM->StartLinearInterpolateOnLinearPath(mpOneShotCamera[SECTRET_2].pos,
		                                           mpOneShotCamera[SECTRET_2].tgt,
		                                           90.0f);
//		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_ZANDISAPPEAR ){
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_BAAN ){
			K7SCR_RETSYS();
		}
		FixCam(SECTRET_3);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_BREAKOBJ ){
			K7SCR_RETSYS();
		}
		FixCam(SECTRET_4);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_IDLE ){
			K7SCR_RETSYS();
		}
//		while( WK7PLAYERCONTROL->SpAtkEffectEndTest(mID,K7KED)==false ){
//			K7SCR_RETSYS();
//		}
//		if( (pJObj=GetJObj("event_015100_ked"))!=NULL ){
//			WK7EffectBreakObj	*pEffectBreakObj;
//			WK7EffectBreakObj::SetLimitSurfaceSize(15.0f);
//			if( (pEffectBreakObj = pJObj->CreateEffectBreakObj(false,true,5))!=NULL ){
//				pJObj->Hide(false,true);
//				pEffectBreakObj->SetVisible(true);
//				pEffectBreakObj->Start();
//				gpSound->mPlaySE(SFX_SCE0_BREAK_BARRIER);
//				while( WK7EffectBreakObj::IsValid(pEffectBreakObj)==true ){
//					K7SCR_RETSYS();
//				}
//			}
//		}
//		
//		K7SCR_SET_SCENARIO_FLAG(K7SCN01_SP_117M00_KED);
//		K7SCR_EVCONDCHANGE();
		return false;
//	case	PC_SPA_BOOST_JUMP:
////		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_SP_117M00_CYO)!=TRUE ){
//			WK7PlayerSpInfoCyo	*pCyoInfo = WK7PLAYERCONTROL->GetSpInfoCyo();
//			K7SCR_SET_SCENARIO_FLAG(K7SCN01_SP_117M00_CYO);
////			K7SCR_STG_SET_CURRENT_PATH_POINT("branchJ");
////			K7SCR_EVCONDCHANGE();
//			pCyoInfo->mpToBpName      = "branchJ";
//			pCyoInfo->mFromPos.x      = -46.111f;
//			pCyoInfo->mFromPos.y      =  0.0f;
//			pCyoInfo->mFromPos.z      = -648.557f;
//			pCyoInfo->mFromRotY       =  1.783f;
//			pCyoInfo->mToPos  .x      = -20.396f;
//			pCyoInfo->mToPos  .y      =  35.0f;
//			pCyoInfo->mToPos  .z      = -666.636f;
//			pCyoInfo->mToRotY         =  1.614f;
//			pCyoInfo->mStageMessage   = true;
//			pCyoInfo->mStageMessageID = K7STAGE117M00_MES_JUMP;
//			FixCam(JUMP_0);
//			while( WK7PLAYERCONTROL->GetSpProc() < SPCYO_JUMPWAIT ){
//				K7SCR_RETSYS();
//			}
//			FixCam(JUMP_1);
//			while( WK7PLAYERCONTROL->GetSpProc()!=SPCYO_IDLE ){
//				K7SCR_RETSYS();
//			}
////		}
////		WK7PLAYERCONTROL->SetSpAbilityCancel(true);
//		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage117M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	if( info.mpNpc==NULL ){
		return true;
	}
	switch( info.mpNpc->GetEneNo() ){
	case	ENENO_1_117M00_1:
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_HS_NEST_117M00);
		K7SCR_EVCONDCHANGE();
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage117M00::EventCallBack(WK7EventInfo &info)
{
#pragma	unused(info)
#if 0
	WK7ZanEventInfo		zanEventInfo;
	switch( info.mEventNo ){
	case	K7EVENTNO(015102):
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE( false );
		
		zanEventInfo.Initialize();
		zanEventInfo.mEventNo = K7EVENTZAN(010013);
		zanEventInfo.mpStage  = this;
		CallZanEventCallBackTask(zanEventInfo);
		while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY ){
			K7SCR_RETSYS();
		}
		
		if( K7SCR_EVHASITEM(K7EVENTZAN(010013))!=TRUE ){
			
			GameInfo.SetZanMesID( 0 );
			GameInfo.SetZanTermWait( true );
			zanEventInfo.Initialize();
			zanEventInfo.mEventNo = K7EVENTZAN(010013);
			zanEventInfo.mpStage  = this;
			CallZanEventCallBackTask(zanEventInfo);
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT ){
				K7SCR_RETSYS();
			}
			GameInfo.SetZanTermWait( false );
			GameInfo.SetZanManual( true );
			
			K7SCR_SYS_ITEMGET_IS(K7SCR_SYSMES_GETTAMA,15,SFX_SYS_GET_BULLET);
			K7SCR_SYS_ITEMGET_NOTDISPLAYED_B(K7SCR_SYSMES_GETTAMA);
			K7SCR_EVSETITEM(K7EVITEM_TAMA(010000),true);
			K7SCR_EVCONDCHANGE();
			K7SCR_SYS_ITEMGET_VALID_B(K7SCR_SYSMES_GETTAMA);
			
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY ){
				K7SCR_RETSYS();
			}
			
			zanEventInfo.Initialize();
			zanEventInfo.mEventNo = K7EVENTZAN(010013);
			zanEventInfo.mpStage  = this;
			GameInfo.SetZanMesID( 1 );
			CallZanEventCallBackTask(zanEventInfo);
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY ){
				K7SCR_RETSYS();
			}
			
		}else{
			zanEventInfo.Initialize();
			zanEventInfo.mEventNo = K7EVENTZAN(010013);
			zanEventInfo.mpStage  = this;
			GameInfo.SetZanMesID(2);
			CallZanEventCallBackTask(zanEventInfo);
		}
		
		K7SCR_PC_SETVISIBLE( true );
		K7SCR_EVCONDCHANGE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	default:
		break;
	}
#endif
	return true;
}

bool K7Stage117M00::ZanEventCallBack(WK7ZanEventInfo &info)
{
#pragma	unused(info)
#if 0
	switch( info.mEventNo ){
	case	K7EVENTZAN(010013):
		if( K7SCR_EVHASITEM(K7EVENTZAN(010013))!=TRUE ){
			
			K7SCR_ENTER_PLAYMODE ();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE  (false);
			
			SetZanEventInfo(K7EVENTZAN(010013));
			GameInfo.SetZanMesID   (0);
			GameInfo.SetZanTermWait(true);
			GameInfo.SetMode       (WK7GameInfo::ZAN);
			
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT ){
				K7SCR_RETSYS();
			}
			
			K7SCR_SYS_ITEMGET_IS(K7SCR_SYSMES_GETTAMA,15,SFX_SYS_GET_BULLET);
			K7SCR_SYS_ITEMGET_NOTDISPLAYED_B(K7SCR_SYSMES_GETTAMA);
			K7SCR_EVSETITEM(K7EVITEM_TAMA(010000),true);
			K7SCR_EVCONDCHANGE();
			K7SCR_SYS_ITEMGET_VALID_B(K7SCR_SYSMES_GETTAMA);
			
			GameInfo.SetZanTermWait   (false);
			GameInfo.SetZanNoiseCancel(true);
			GameInfo.SetZanCinemaScopeCancel(true);
			
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY ){
				K7SCR_RETSYS();
			}
			
			SetZanEventInfo(K7EVENTZAN(010013));
			GameInfo.SetZanMesID      (1);
			GameInfo.SetZanTermWait   (true);
			GameInfo.SetZanNoiseCancel(true);
			GameInfo.SetMode          (WK7GameInfo::ZAN);
			
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT ){
				K7SCR_RETSYS();
			}
			
			GameInfo.SetZanTermWait   (false);
			GameInfo.SetZanNoiseCancel(false);
			GameInfo.SetZanCinemaScopeCancel( false );
			
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY ){
				K7SCR_RETSYS();
			}
			
			K7SCR_EVSETITEM(K7EVENTZAN(010013),true);
			K7SCR_PC_SETVISIBLE (true);
			K7SCR_EXIT_PLAYMODE ();
			K7SCR_EXIT_DEMOPAUSE();
			
#if 0
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			K7SCR_PC_SETVISIBLE( false );
//			
			GameInfo.SetZanMesID( 0 );
//			GameInfo.SetZanNoiseCancel      ( true  );
//			GameInfo.SetZanManual           ( true  );
//			GameInfo.SetZanCinemaScopeCancel( false );
			ZanEventTask(info);
			
			while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
				K7SCR_RETSYS();
			}
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			
			WK7EventEffect		*pEffect = K7SCR_SYS_ITEMGET_IS(K7SCR_SYSMES_GETTAMA,15,SFX_SYS_GET_BULLET);
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
			K7SCR_EVSETITEM(K7EVITEM_TAMA(010000),true);
			K7SCR_EVCONDCHANGE();
			while( WK7EVENTCONTROLLER->IsValidEffect(pEffect)==true ){
				K7SCR_RETSYS();
			}
			
//			GameInfo.SetZanNoiseCancel      ( true  );
//			GameInfo.SetZanManual           ( true  );
//			GameInfo.SetZanCinemaScopeCancel( false );
//			GameInfo.SetZanMesID( 1 );
//			ZanEventTask(info);
			
			K7SCR_PC_SETVISIBLE( true );
			K7SCR_EVCONDCHANGE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
#endif
			return false;
		}else{
			GameInfo.SetZanMesID(2);
		}
		break;
	default:
		break;
	}
#endif
	return true;
}

// ̐ݒ
#define CORE_NUM	(1)
bool K7Stage117M00::SetCurrentCallBack(void)
{
	pNpcSu = (K7EnmK *)WK7Npc::Find(ENENO_1_117M00_1);
	
	if ( pNpcSu != NULL ) {
		while( pNpcSu->SetUpTest()==false ){
			K7SCR_RETSYS();
		}
		pNpcSu->HitObjMake(WK7Stage::GetCurrentStage(), CORE_NUM);
	}
	return true;
}
bool K7Stage117M00::HitObjCallBack(WK7HitObjInfo &info)
{
	if ( pNpcSu != NULL ) {
		if( (info.mEventNo >= pNpcSu->GetHitObjID()) && (info.mEventNo < (pNpcSu->GetHitObjID()+CORE_NUM) ) ){
			if ( false == pNpcSu->CoreHit((int )info.mEventNo, info.mTypeID, info.mHitPos) ) {
				// RAj󂵂ĂȂ
				// qbgIuWF𕜊
				info.SetHitObjEnable(true);
//				info.mpHitObj->SetEnable(true);
			}
			return false;
		}
	}
	return true;
}



