////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage180M00
//
// K7Stage180M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/06/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE180M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage180M00.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

K7Stage180M00::K7Stage180M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
//	SetOneShotCamLocTbl( K7Stage180M00_Camera );
}

K7Stage180M00::~K7Stage180M00()
{
}

bool K7Stage180M00::CreateCallBack(void)
{
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage180M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

//bool K7Stage180M00::SetCurrentCallBack(void)
//{
//	return true;
//}

bool K7Stage180M00::CondChangeCallBack(void)
{
	SetVisibleTamaJObj(K7EVENTTAMA(010002),!K7SCR_EVHASITEM(K7EVENTTAMA(010002)));
	RenewTamaEffect(K7EVENTTAMA(010002));
	return false;
}

bool K7Stage180M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(015402):
		if( K7SCR_EVHASITEM(K7EVITEM_TAMA(010002))==TRUE ){
			return true;
		}
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

bool K7Stage180M00::PrePathChangeCallBack(WK7PrePathChangeInfo &info)
{
	WK7PathNurbs	*pNextPath = info.GetNextPath();
	const char		*pNextPathName;
	u32				mesid;
	
	if( pNextPath==NULL || (pNextPathName=pNextPath->GetName())==NULL ){
		return true;
	}
	if( strcmp(pNextPathName,"event_015402_0")==0 ){
		K7SCR_RESET_SCENARIO_FLAG(K7SCN01_TOILET_M);
		K7SCR_RESET_SCENARIO_FLAG(K7SCN01_TOILET_F);
		return true;
	}
	if( strcmp(pNextPathName,"MalePath")==0 ){
		if( WK7PLAYERCONTROL->GetMainID()!=K7KED ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_TOILET_M);
			return true;
		}
		mesid = K7STAGE180M00_MES_MAIL_TOILET;
	}else if( strcmp(pNextPathName,"FemalePath")==0 ){
		if( WK7PLAYERCONTROL->GetMainID()==K7KED ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_TOILET_F);
			return true;
		}
		mesid = K7STAGE180M00_MES_FEMAIL_TOILET;
	}else{
		return true;
	}
	
	PathChangeCancel();
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	K7SCR_STG_MESSAGE_B(mesid);
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return false;
}

bool K7Stage180M00::PreCharaChangeCallBack(WK7CharaChangeInfo &info)
{
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_TOILET_M)==TRUE ){
		if( K7CHR_MAINID(info.mCurrCharaID)==K7KED ){
			GameInfo.SetCharaChangeCancel(true);
			
			K7SCR_ENTER_DEMOPAUSE();
			while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
				K7SCR_RETSYS();
			}
			
			K7SCR_STG_MESSAGE_B(K7STAGE180M00_MES_THIS_IS_MAIL_TOILET);
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			return false;
		}
	}else if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_TOILET_F)==TRUE ){
		if( K7CHR_MAINID(info.mCurrCharaID)!=K7KED ){
			GameInfo.SetCharaChangeCancel(true);
			
			K7SCR_ENTER_DEMOPAUSE();
			while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
				K7SCR_RETSYS();
			}
			
			K7SCR_STG_MESSAGE_B(K7STAGE180M00_MES_THIS_IS_FEMAIL_TOILET);
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			return false;
		}
	}
	return true;
}

bool K7Stage180M00::TamaEventCallBack(WK7TamaEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTTAMA(010002):
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_TOILET);
		break;
	default:
		break;
	}
	return true;
}

