////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage131M00 prPKL
//
// K7Stage131M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/31/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE131M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage131M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Matsu\MK7Sound.h"
#include "..\..\..\Enm\EnmDE2.h"
#include "..\..\..\Panel\SK7PanelCards.h"
#include "..\Panel\SK7PanelChinChiro.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Kaw\KK7Sound.h"

static K7EnmDE2		*pNpcDe2;

// [V
#define MOES31M00_POSTER			(0)  //|X^[

// [V
#define MOT131M00_DESKOPEN			(3)  //oJ
#define MOT131M00_PANELOPEN			(4)  //plJ
#define MOT131M00_IKASAMA			(5)  //ܑu_

// f
#define MDL131M00_DESK				"Drawer"
#define MDL131M00_IKASAMA			"Lamp01"
#define MDL131M00_PANEL				"PanelCover"
#define MDL131M00_KEYOPEN			"cyo_padlock_off"
#define MDL131M00_KEYLOCK			"cyo_padlock_on"
#define MDL131M00_TAMA				"tama_011301"

// bZ[W
#define MES131M00_01				(1)  //Ɏ{Ă

K7Stage131M00::K7Stage131M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mDeskOpen = false;
	mIkasamaSadou = false;
	SetOneShotCamLocTbl(K7Stage131M00_Camera);
}

K7Stage131M00::~K7Stage131M00()
{
}


/*
	
	NGCg
	
*/
bool K7Stage131M00::CreateCallBack(void)
{
	// [Vǂݍ
	CreateOwnStageMotion(MOT131M00_DESKOPEN);
	CreateOwnStageMotion(MOT131M00_PANELOPEN);
	CreateOwnStageMotion(MOT131M00_IKASAMA);
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

/*
	
	
	
	
*/
bool K7Stage131M00::InitializeCallBack(void)
{
	HereComeANewHSInit( PR_HS_POIZ, ENENO_1_131M00_5 );
	K7SCR_EVCONDCHANGE();
	return true;
}

bool K7Stage131M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

/*
	
	Jg
	
*/
bool K7Stage131M00::SetCurrentCallBack(void)
{
	// ܑûrd
	KK7SoundLoopSePlayVolumeChange(	(Vec ){159.096f, 3.759f, 54.372f},
									K7SCR_STG_GET_CURRENTID(),
									SFX_SCE1_KAKU_IKASAMACHINE_DOUSA,
									SOUND_EVENT_SE_VOLUME,
									6,
									0,
									K7SCN01_EVFL_011310
	);
	
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_POIZ,
									ENENO_1_131M00_5,							// GID
									NULL,
									CAM131M00_HS_PRESEN_START,
									CAM131M00_HS_PRESEN_END,
									0,
									195,  228, -36,  66, 804, 137 )				// OЉp
	){
		SetManualBranch(false);
		return( true );
	}
	
	return true;
}

bool K7Stage131M00::CondChangeCallBack(void)
{
	WK7JObj *pJObj;

	DeskOpen(0);
	IkasamaSetUp();
	
	// bNL[
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011310)==true ){
		if( (pJObj=GetJObj(MDL131M00_KEYOPEN)) != NULL ) K7SCR_JOBJ_DISP(pJObj);
		if( (pJObj=GetJObj(MDL131M00_KEYLOCK)) != NULL ) K7SCR_JOBJ_HIDE(pJObj);
	}else{
		if( (pJObj=GetJObj(MDL131M00_KEYOPEN)) != NULL ) K7SCR_JOBJ_HIDE(pJObj);
		if( (pJObj=GetJObj(MDL131M00_KEYLOCK)) != NULL ) K7SCR_JOBJ_DISP(pJObj);
	}
	
	// ``plN`FbN
	ReleaseTamaEffect();
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011305)==TRUE ){			// I
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011305), false);					// ̃Cxg֎~
		if ( K7SCR_EVHASITEM(K7EVITEM_TAMA(011301)) == false ){			// eO
			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011301),  true);			// eCxgL
			CreateTamaEffect(K7EVITEM_TAMA(011301));
		}else{
			if( (pJObj=GetJObj(MDL131M00_TAMA)) != NULL ){
				pJObj->Hide(false,true);								// e
			}
			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011301), false);			// eCxg
		}
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011305), true);
		K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011301),  false);
	}
	
	// R[esbLO
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011310)==TRUE ){			// I
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011310), false);					// ̃Cxg֎~
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011310), true);					// ̃Cxg֎~
	}
	
	// ܑu_
	if(	(K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011305)==TRUE)			// CxgI
	||	(K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011310)==TRUE)			// sbLOI
	){
		IkasamaDisp(false);
	}else{
		IkasamaDisp(true);
	}

	return true;
}

/*
	
	Cxg
	
*/
bool K7Stage131M00::EventCallBack(WK7EventInfo &info)
{
	WK7JObj *pJObj;

	switch( info.mEventNo ){
	case	K7EVENTNO(011310):												// R[esbLO
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011310)==false ){
			bool ret;
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
//			K7SCR_PC_SETVISIBLE(false);
			
			FixCam(ONESHOTCAM_011310);
			
			if( WK7PLAYERCONTROL->HasSpAbility(PC_SPA_PICKING_TOOL)==true ){
				ret   = true;
				
				// R[esbLOf[^쐬
				Vec camTgt = {284.487f, 10.912f, 35.820f};
				Vec camPos = {299.401f, 7.832f, 50.077f};
				Vec pcPos  = {281.296f, 0.f, 37.661f};
				f32 pcRotY = 0.f;
				WK7PLAYERCONTROL->WK7PlayerCyoPicking(	PICKING_131M00,
														&camTgt,
														&camPos,
														&pcPos,
														pcRotY,
														SFX_PC_CYO_PICKING,	true);
				
			}else{
				ret   = false;
			}
			
			if ( true == ret ){
				// uJ
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				
				K7SCR_PC_SETVISIBLE(false);
				
				if( (pJObj=GetJObj(MDL131M00_KEYOPEN)) != NULL ) K7SCR_JOBJ_DISP(pJObj);
				if( (pJObj=GetJObj(MDL131M00_KEYLOCK)) != NULL ) K7SCR_JOBJ_HIDE(pJObj);
				
				FixCam(ONESHOTCAM_011310_OPEN);
				K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
//				info.mCinemaScopeClear = true;
//				K7SCR_SYS_MESSAGE_B(mesid);
				
				// uJ
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				PanelOpen();
			}else{
				FixCamMesWithRiddle( ONESHOTCAM_011310_OPEN, MES131M00_01 );
//				K7SCR_SYS_MESSAGE_B();
			}
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			if ( ret ){
				// ̂܂܃pl	
				K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(011310), 1);				//0:ftHgXCb`I
				K7SCR_PANEL_START();
				K7SCR_PANEL_TERMWAIT();
				if( K7SCR_PANEL_GETRESULT() == 0 ){								// Itɂ
					K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011310);
					K7SCR_EVNO_SETENABLE(K7EVENTNO(011310), false);				// ̃Cxg֎~
					ret = true;
				}else{
					ret = false;
				}
				WK7CAM->SetCinemaScopeMode(false);
				K7SCR_RETSYS();
				if ( ret ){
					FixCam(ONESHOTCAM_IKASAMA);
				}
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				if ( ret ){
					K7SCR_ENTER_PLAYMODE();
					K7SCR_ENTER_DEMOPAUSE();
					
//					FixCam(ONESHOTCAM_IKASAMA);
					
					K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
					
					K7SCR_EVCONDCHANGE();
					gpSound->mPlaySE(SFX_SCE1_KAKU_IKASAMACHINE_STOP);			// prFCJT}@B ~
					
					
					K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
					
					K7SCR_EXIT_PLAYMODE();
					K7SCR_EXIT_DEMOPAUSE();
				}
				K7SCR_PC_SETVISIBLE(true);
			}
			
			K7SCR_EVCONDCHANGE();
			
			// L|[Y
			return ret;
		}
		break;
	case	K7EVENTNO(011305):
		s32  result, inparam;
		bool panelOK = false;
		
		// EVENT_011305 ``pl
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011310)==TRUE ){				// jς݁isbLOς݂plڍς݁j
			inparam = CHIN_BREAK_PLAY;
		}else{
			inparam = CHIN_NORMAL_PLAY;
		}
		K7SCR_PANEL_SETPANELID(ePanel011305, inparam);
		
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		
		if( (result = K7SCR_PANEL_GETRESULT()) == CHINCHIRO_WIN ){				// I
			panelOK = true;
		}
		
		K7SCR_RETSYS();
		if ( panelOK == true ){
			FixCam(ONESHOTCAM_011305);
		}
		K7SCR_PANEL_EXIT();
		K7SCR_PANEL_EXITWAIT();
		
		if ( panelOK == true ){
			
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011305), false);						// ̃Cxg֎~
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011305);
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE(false);											// l
			
			// Jς
//			FixCam(ONESHOTCAM_011305);
			
			gpSound->mPlaySE(SFX_SYS_EV_CLEAR);									// 
			DeskOpen(1);
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
			gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOM);								// Y[op SE
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
			
			// L|[Y
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		
		K7SCR_EVCONDCHANGE();
		break;
	// |X^[
	case	K7EVENTNO(011309):
		// L|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);												// l
		
		// Jς
		FixCam(ONESHOTCAM_011309);
		
		K7SCR_STGC_MESSAGE_B(MOES31M00_POSTER);
		
		// L|[Y
		K7SCR_PC_RETURNVISIBLE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		return false;
		
		break;
	}
	
	return false;
}


bool K7Stage131M00::DeskOpen(int se)
{
	WK7JObj		*pJObj;
	
	// 񂿂I
	if ( false == K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011305) ) return false;
	
	if ( mDeskOpen == false ){
		mDeskOpen = true;
	}else{
		return false;
	}
	
	if( (pJObj=PlayMotion(MDL131M00_DESK, MOT131M00_DESKOPEN))!=NULL ){
		pJObj->SetMotionLoop(false);
		if ( se ) gpSound->mPlaySE(SFX_SCE1_KAKU_HIKIDASHI_OPEN);		// J 
		while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		return true;
	}
	return false;
}


bool K7Stage131M00::IkasamaSetUp(int se)
{
#pragma unused(se)
	WK7JObj		*pJObj;
	
	// ܑudOFF
	if ( false == K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011310) ) return false;
	
	if ( mIkasamaSadou == false ){
		mIkasamaSadou = true;
	}else{
		return false;
	}
	
	if( (pJObj=PlayMotion(MDL131M00_IKASAMA, MOT131M00_IKASAMA))!=NULL ){
		pJObj->SetMotionLoop(true);
		return true;
	}
	return false;
}
bool K7Stage131M00::IkasamaDisp(bool flag)
{
	WK7JObj		*pJObj;
	if( (pJObj=GetJObj(MDL131M00_IKASAMA)) != NULL ){
		if ( true == flag ){
			pJObj->Disp(false,true);
		}else{
			pJObj->Hide(false,true);
		}
		return true;
	}
	return false;
}
bool K7Stage131M00::PanelOpen(void)
{
	WK7JObj		*pJObj;
	
	if( (pJObj=PlayMotion(MDL131M00_PANEL, MOT131M00_PANELOPEN))!=NULL ){
		
		pJObj->SetMotionLoop(false);
		
		gpSound->mPlaySE(SFX_SCE1_KAKU_HUTA_OPEN);					// prFGx[^ؑփXCb`̃t^J
		
		while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		return true;
	}
	return false;
}
