////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage132M00 prQKL
//
// K7Stage132M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE132M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Wat\WK7Event.h"
#include ".\K7Stage132M00.h"
#include "..\..\..\Matsu\MK7Sound.h"
#include "..\..\..\Panel\SK7PanelCards.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

// bZ
#define MES132M00_POSTER	(0)				// |X^[\Ă

// [V
#define MOT132M00_DESKOPEN	(3)				// Jiej

// f
#define MDL132M00_DESK		"Drawer"		// o
#define MDL132M00_TAMA		"tama_011401"


K7Stage132M00::K7Stage132M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mDeskOpen = false;
	SetOneShotCamLocTbl(K7Stage132M00_Camera);
}

K7Stage132M00::~K7Stage132M00()
{
}

/*
	
	NGCg
	
*/
bool K7Stage132M00::CreateCallBack(void)
{
	CreateOwnStageMotion(MOT132M00_DESKOPEN);
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage132M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

/*
	
	Jg
	
*/
bool K7Stage132M00::SetCurrentCallBack(void)
{
	return true;
}


/*
	
	
	
*/
bool K7Stage132M00::InitializeCallBack(void)
{
	K7SCR_EVCONDCHANGE();
	return true;
}

bool K7Stage132M00::CondChangeCallBack(void)
{
	WK7JObj *pJObj;
	DeskOpen(0);
	
	ReleaseTamaEffect();
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011403) == true ){
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011403), false);
		if ( K7SCR_EVHASITEM(K7EVITEM_TAMA(011401)) == false ){				// eO
			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011401),  true);
			CreateTamaEffect(K7EVITEM_TAMA(011401));
		}else{
			if( (pJObj=GetJObj(MDL132M00_TAMA)) != NULL ){
				pJObj->Hide(false,true);									// e
			}
			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011401), false);
		}
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011403), true);
		K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011401),  false);
	}
	
	return true;
}


/*
	
	Cxg
	
*/
bool K7Stage132M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(011403):											// |[J[pl
		s32  result;
		bool panelOK = false;
		
		// EVENT_011403 |[J[pl
//		K7SCR_PANEL_SETPANELID(ePanel011403, CARDS_PK);
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel011403);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		if( (result = K7SCR_PANEL_GETRESULT()) == CARDS_WIN ){					// I
			panelOK = true;
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011403);
			
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011403), false);				// ̃Cxg֎~
		}
		K7SCR_RETSYS();
		if ( panelOK == true ){
			FixCam(ONESHOTCAM_011406_RESULT);
		}
		K7SCR_PANEL_EXIT();
		
		if ( panelOK == true ){
			K7SCR_PANEL_EXITWAIT();
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE(false);									// l
			
//			FixCam(ONESHOTCAM_011406_RESULT);
			
			gpSound->mPlaySE(SFX_SYS_EV_CLEAR);									// 
			DeskOpen(1);
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
			gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOM);						// Y[op SE
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
			
			// L|[Y
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		
		K7SCR_EVCONDCHANGE();
		break;
	// |X^[
	case	K7EVENTNO(011406):												// |X^[pl
		// L|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);											// l
		
		// Jς
		FixCam(ONESHOTCAM_011406);
		
		K7SCR_STGC_MESSAGE_B(MES132M00_POSTER);								// J[hJWm̃|X^[\Ă
		
		// L|[Y
		K7SCR_PC_RETURNVISIBLE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		return false;
		
		break;
	}
	
	return false;
}


bool K7Stage132M00::DeskOpen(int se)
{
	WK7JObj		*pJObj;
	
	if ( false == K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011403) ) return false;
	
	if ( mDeskOpen == false ){
		mDeskOpen = true;
	}else{
		return false;
	}
	
	if( (pJObj=PlayMotion(MDL132M00_DESK, MOT132M00_DESKOPEN))!=NULL ){
		pJObj->SetMotionLoop(false);
		if ( se ) gpSound->mPlaySE(SFX_SCE1_KAKU_HIKIDASHI_OPEN);			// J
		
		while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		return true;
	}
	return false;
}


