////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage147M00 
//
// K7Stage147M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE147M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage147M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7Npc.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Panel\SK7PanelLocker.h"
#include "..\..\..\Matsu\MK7Sound.h"
#include "..\..\..\Yam\YK7EffectSeenSound.h"

// bZ[W
#define MES147M00_00					(0)		 //u̎wցv߂

// [V
#define MOT147M00_PANELOPEN				(0) 	 //plJ
#define MOT147M00_HAKOOPEN				(1) 	 //_{[J
#define MOT147M00_HAKOCLOSE				(2) 	 //_{[


// f
#define MDL147M00_NAZO					"Thing"	//̑`
#define MDL147M00_PANEL					"PanelCover"
#define MDL147M00_HAKO					"SusieCover"
#define MDL147M00_CATWINDPOINT			"Sound"
#define MDL147M00_RING					"Ring"

// J
#define CAM147M00_ATELIER_RIDDLE		"event_011203_0"


K7Stage147M00::K7Stage147M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mPanelOpen = false;
	mpWindEffect = NULL;
	SetOneShotCamLocTbl(K7Stage147M00_Camera);
}

K7Stage147M00::~K7Stage147M00()
{
}

/*
	
	
	
*/
bool K7Stage147M00::InitializeCallBack(void)
{
	return true;
}


/*
	
	NGCg
	
*/
bool K7Stage147M00::CreateCallBack(void)
{
	CreateOwnStageMotion(MOT147M00_PANELOPEN);
	CreateOwnStageMotion(MOT147M00_HAKOOPEN);
	CreateOwnStageMotion(MOT147M00_HAKOCLOSE);
	return true;
}


/*
	
	Jg
	
*/
bool K7Stage147M00::SetCurrentCallBack(void)
{
	K7SCR_EVCONDCHANGE();
	if(	K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011203) == false ){			// X[W[u̎wցv
		KK7SoundLoopSePlayVolumeChange((Vec){57.637f, 15.345f, 34.170f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_KAKU_CARDBOARDBOX_YURE, SOUND_EVENT_SE_VOLUME, 0, 0, K7SCN01_EVFL_011203);
	}
	return true;
}


/*
	
	󋵕ω
	
*/
bool K7Stage147M00::CondChangeCallBack(void)
{
	WK7JObj*		pJObj;
	EFFECT*			pWindEffect=NULL;
	Vec				Point;
	
	// pl̃Aj
	PanelOpen();
	
	// RȂǂ̃̕}[N
	if(	K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011203) == false ){		// X[W[u̎wցv
		// J
		K7SCR_STG_SET_DISABLEPATHCAMERA( CAM147M00_ATELIER_RIDDLE, false );
		if( WK7PLAYERCONTROL->GetMainID() == K7CAT )
		{
			// ̎w֎擾WNV\
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011203), true);
			pJObj=GetJObj(MDL147M00_CATWINDPOINT);
			if ( pJObj != NULL ){
				pJObj->GetPosition(Point);
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (IsValidEffect(mpWindEffect) == false)
				&& ((pWindEffect = KazeEffectCreate(Point)) != NULL) )
				{
					mpWindEffect = CreateEffect( pWindEffect ,&info);
				}
			}
		}else{
#if 1
			// ̎w֎擾WNV\
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011203), true);
#else
			// ̎w֎擾WNV
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011203), false);
#endif
			if( mpWindEffect != NULL ){
				DelReqEffect( mpWindEffect );
				mpWindEffect = NULL;
			}
		}
	}else{
		if( mpWindEffect != NULL ){
			DelReqEffect( mpWindEffect );
			mpWindEffect = NULL;
		}
		// J
		K7SCR_STG_SET_DISABLEPATHCAMERA( CAM147M00_ATELIER_RIDDLE, true );
		
		// ̎w֎擾WNV
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011203), false );
	}
	
	return true;
}


/*
	
	Cxg
	
*/
bool K7Stage147M00::EventCallBack(WK7EventInfo &info)
{
	s32  result, inParam;
	WK7JObj *pJObj;
	WK7ZanEventInfo zanEventInfo;
//	int panelOK;

	switch (info.mEventNo){
	case	K7EVENTNO(011203):												// X[W[u̎wցv
		if (K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011203)==FALSE){			// X[W[u̎wցv

			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011203);
			K7SCR_EVCONDCHANGE();											// GtFNg
			
			// Jς
			WK7CAM->SetCinemaScopeMode(true);								// VlXRON
			FixCam(ONESHOTCAM_011202_OPEN);
			K7SCR_PC_SETVISIBLE(false);										// l
			
			if( (pJObj=PlayMotion(MDL147M00_HAKO, MOT147M00_HAKOOPEN))!=NULL ){
				pJObj->SetMotionLoop(false);
				
				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);					// 
				
				while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
					K7SCR_RETSYS();
				}
			}
			
			// JX[W[Abv
			WK7CAM->StartLinearInterpolateOnLinearPath(mpOneShotCamera[ONESHOTCAM_011202_SUSI].pos,
			                                           mpOneShotCamera[ONESHOTCAM_011202_SUSI].tgt,
			                                           60.0f);
			// WaitiL⊮̎Ԃ邱Ɓj
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
			
			//cvOƉb
			zanEventInfo.Initialize();
			zanEventInfo.mEventNo = K7EVENTZAN( 011203 );
			zanEventInfo.mpStage  = this;
			GameInfo.SetZanMesID( 0 );
			GameInfo.SetZanTermWait( true );
			GameInfo.SetZanNoiseCancel( true );
			GameInfo.SetZanCharaLoadCancel( true );
			CallZanEventCallBackTask( zanEventInfo );
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
			{
				K7SCR_RETSYS();				// X[W[b
			}
			GameInfo.SetZanTermWait( false );
			GameInfo.SetZanManual( true );
			GameInfo.SetZanNoiseCancel( true );
			GameInfo.SetZanCinemaScopeCancel( true );
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
			{
				K7SCR_RETSYS();
			}
			gpSound->mStopStream();
			// ̎w֎擾
			K7SCR_SET_GLOBAL_FLAG( K7GLFL_RING_WIND );
			K7SCR_EVSETITEM( K7EVENTZAN(011203), false );
			//inGame~icvO𔲂Ɖ邽߁j
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			//wւ̃f\
			if( (pJObj=GetJObj(MDL147M00_RING)) != NULL )
			{
				K7SCR_JOBJ_HIDE(pJObj);
			}
			//ACe擾ʂ\
			K7SCR_STG_ITEMGET_B( MES147M00_00 );
			//tO𗎂Ƃ
//			K7SCR_EVSETITEM( K7EVENTZAN(110500), false );
			
			//cvOƉbi㔼j
			zanEventInfo.Initialize();
			zanEventInfo.mEventNo = K7EVENTZAN( 011203 );
			zanEventInfo.mpStage  = this;
			GameInfo.SetZanMesID( 1 );
			GameInfo.SetZanTermWait( true );
			GameInfo.SetZanNoiseCancel( true );
			GameInfo.SetZanCharaLoadCancel( true );
			CallZanEventCallBackTask( zanEventInfo );
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT )
			{
				K7SCR_RETSYS();				// X[W[b
			}
			
			GameInfo.SetZanTermWait( false );
			GameInfo.SetZanManual( false );
			GameInfo.SetZanNoiseCancel( true );
			GameInfo.SetZanCinemaScopeCancel( true );
			
			// Jς
			FixCam(ONESHOTCAM_011202_OPEN);
			while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY )
			{
				K7SCR_RETSYS();
			}
			
			//inGame~icvO𔲂Ɖ邽߁j
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			
			// _{[߂
			if( (pJObj=PlayMotion(MDL147M00_HAKO, MOT147M00_HAKOCLOSE))!=NULL ){
				pJObj->SetMotionLoop(false);
				
//				if ( se ) gpSound->mPlaySE(SFX_SCE1_FUKU_ROCKDESTROY);					// J
				
				while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
					K7SCR_RETSYS();
				}
			}
			
			K7SCR_PC_SETVISIBLE(true);													// l\
			
			K7SCR_RETSYS();
			
			WK7CAM->SetCinemaScopeMode( false );										// VlXROFF
			WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
			WK7CAM->FrameProcess();
			WK7CAM->SetCurrent();
			
			gpSound->mPlayStreamNo( HPS_KRAKUJITU_C );
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			K7SCR_EVCONDCHANGE();
		}
		break;
	case	K7EVENTNO(011202):														// Gx[^[Ɍ킹XCb`
		// 
		if ( true == K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011601) ) {				// `ς݁H
			if ( false == K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011202_NAZO) ) {		// `nO
				
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				FixCam(ONESHOTCAM_011202_PANELOPEN);
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
				
				gpSound->mPlaySE(SFX_SYS_AKASICITEM_SET);							// svcȑ`͂߂
				
				// IuWF\
				if( (pJObj=GetJObj(MDL147M00_NAZO)) != NULL )
				{
					pJObj->Disp( false, true );
				}
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011202_NAZO);
				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
				
				PanelOpen(1);
				
				//svcȑ`̃tOƂiTuʂ
				K7SCR_EVSETITEM( K7EVITEM_KEY(011601), false );
				
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}
		}else{
			// `O
			FixCamWithRiddle( ONESHOTCAM_011202_PANELOPEN );
			return true;
		}
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011202) == false ){
			inParam = 1;
		}else{
			inParam = 0;
		}
#if 1
		K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(011202), inParam );
#else
//		K7SCR_PANEL_SETPANELID(ePanel011202, inParam);
#endif
		
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		
		result = K7SCR_PANEL_GETRESULT();
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		
		if ( result != -1 ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_ENFL_POP1);					// G|bvp̃tOĂ
			// I
			if ( 0 == result ){
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011202);			// tOĂ
			}else{
				K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_011202);			// tO낷
			}
		}
		
		K7SCR_EVCONDCHANGE();
		
		return true;
	default:
		return false;
	}
	return false;
}

bool K7Stage147M00::PanelOpen(int se)
{
	WK7JObj		*pJObj;
	f32			StartFrame = 0.f;
	
	// IuWF͂߂ĂȂ
	if ( false == K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011202_NAZO) ){
		// IuWF
		if( (pJObj=GetJObj(MDL147M00_NAZO)) != NULL )
		{
			pJObj->Hide( false, true );
		}
		return false;
	}
	
	if ( mPanelOpen == false ){
		mPanelOpen = true;
	}else{
		StartFrame = -1.f;				// ŏIt[ōĐ
	}
	
	if( (pJObj=PlayMotion(MDL147M00_PANEL, MOT147M00_PANELOPEN, NULL, StartFrame))!=NULL ){
		
		pJObj->SetMotionLoop(false);
		
		if ( se ) gpSound->mPlaySE(SFX_SCE1_KAKU_IKASAMACHINE_OPEN);					// J
		
		while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		return true;
	}
	return false;
}


//------------------------------------------------------------------------------
//L`FW
//------------------------------------------------------------------------------
bool K7Stage147M00::CharaChangeCallBack( WK7CharaChangeInfo &info )
{
#pragma	unused(info)
	K7SCR_EVCONDCHANGE();
	return( true );
}

/*
	
	
	GtFNg\
	
	
*/
EFFECT *K7Stage147M00::KazeEffectCreate(Vec Point)
{
	GXColor c1, c2 ;
	EFFECT *pEfc;
	
	c1.r = (u8)VParam[ED_SEENSOUND][1] ;
	c1.g = (u8)VParam[ED_SEENSOUND][2] ;
	c1.b = (u8)VParam[ED_SEENSOUND][3] ;
	c1.a = (u8)VParam[ED_SEENSOUND][4] ;

	c2.r = (u8)VParam[ED_SEENSOUND][5] ;
	c2.g = (u8)VParam[ED_SEENSOUND][6] ;
	c2.b = (u8)VParam[ED_SEENSOUND][7] ;
	c2.a = (u8)VParam[ED_SEENSOUND][8] ;
	
	pEfc = CreateSeenSoundEffect( (Vec)Point,							// W
							VParam[ED_SEENSOUND][13],					// 쐬҂
							VParam[ED_SEENSOUND][11],					// \
							(f32)VParam[ED_SEENSOUND][12] * 0.01F,		// 鑬x
							(f32)VParam[ED_SEENSOUND][9] * 0.01F,		// 
							c1, c2,	// F
							(f32)VParam[ED_SEENSOUND][10] * 0.01F );	// L鑬x
	
	
	return pEfc;
}


bool K7Stage147M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32	eventNo  = GetBpEventNo( info );
	int	pathNo   = GetBpPathNo( info );
	
	if( pathNo!=0 ){
		return true;
	}
	
	switch( eventNo ){
		//
		case K7EVENTNO(011203):
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011203) == false ){		// X[W[u̎wցv
				gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
			}
			break;
		//ftHg
		default:
			return( true );
	}
	return( true );
}

