////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage20M00
//
// K7Stage210M00.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/16/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE210M00_CPP__

#include ".\K7Stage210M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Sato\SK7PanelBase.h"

#define		STAGE_NUM_NO		(5)
const int tblEnemyFlag[]={
	K7SCN02_ENFL_POP_R208,
	K7SCN02_ENFL_POP_R209,
	K7SCN02_ENFL_POP_R217,
	K7SCN02_ENFL_POP_R218,
	K7SCN02_ENFL_POP_R219,
};

//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage210M00::K7Stage210M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	memset( &WorkNextBpName,  0, WK7DOOREVENT_BPNAME_MAX );
	memset( &WorkEnemyBpName, 0, WK7DOOREVENT_BPNAME_MAX );

	if( GetPrevStageBpName()!=NULL ){
		memcpy( &WorkNextBpName, GetPrevStageBpName(), WK7DOOREVENT_BPNAME_MAX );
	}
	if( GetPrevStageBpName()!=NULL ){
		memcpy( &WorkEnemyBpName, GetPrevStageBpName(), WK7DOOREVENT_BPNAME_MAX );
	}
	for( int i = 0; i < STAGE_NUM_NO; i++ ){
		if( strcmp( WorkEnemyBpName, tblPathName[i] ) == 0 ){
			K7SCR_SET_SCENARIO_FLAG( tblEnemyFlag[i] );
			break;
		}
	}
}

//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage210M00::~K7Stage210M00()
{
	for( int i = 0; i < STAGE_NUM_NO; i++ ){
		K7SCR_RESET_SCENARIO_FLAG( tblEnemyFlag[i] );
	}
}


//`````````````````````````````````````````````````
//			Jg
//`````````````````````````````````````````````````
bool K7Stage210M00::SetCurrentCallBack(void)
{
	int i;
	//	ĂȂƂ
	if( !K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_021001) ){
		for( i = 0; i < STAGE_NUM_NO; i++ ){
			if( strcmp( WorkNextBpName, tblPathName[i] ) == 0 ){
				SetMultiID( (s16)i );
				SetStageMapFlag( 0, true, i );
				GameInfo.SetMenuMapSubNo( (s8)i );
				break;
			}
		}
		K7SCR_SET_SCENARIO_FLAG(K7SCN02_EVFL_021001);
	}
	// WNVʉ߂Ԃɂ
	K7SCR_STG_SET_JUNCTION_PASS(K7STGID(208,0),"branchE");
	return true;
}


//`````````````````````````````````````````````````
//			ԕύXitOɂԕύX邽߂ɗpj
//`````````````````````````````````````````````````
bool K7Stage210M00::DoorEventCallBack (WK7DoorEventInfo &info)
{	
	switch( info.mEventNo ){
	case	K7EVENTDOOR( 021001 ):
		WK7DoorEventInfo *pInfo = &info;
		if( strlen(WorkNextBpName)!=0 ){
			memcpy( &pInfo->mNextBpName, WorkNextBpName, WK7DOOREVENT_BPNAME_MAX );
		}
		K7SCR_REVERSE_SCENARIO_FLAG(K7SCN02_EVFL_021001);
		return true;
	}
	return false;
}

//`````````````````````````````````````````````````
//			G񂾂Ƃ̃EC_RC擾Cxg
//`````````````````````````````````````````````````
bool K7Stage210M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	WK7Npc *pNpc = info.mpNpc;
	
#if 1
	//	EC_r
	switch( pNpc->GetEneNo() ){
	case ENENO_2_210M00_208_1:	// 208inYjiEC_j
	case ENENO_2_210M00_208_2:	// 208inYjiEC_j
	case ENENO_2_210M00_217_1:	// 217inYjiEC_j
	case ENENO_2_210M00_219_1:	// 219inYjiEC_j
	case ENENO_2_210M00_219_2:	// 219inYjiEC_j
	case ENENO_2_210M00_219_3:	// 219inYjiEC_j
	case ENENO_2_210M00_219_4:	// 219inYjiEC_j
	case ENENO_2_210M00_219_5:	// 219inYjiEC_j
	case ENENO_2_210M00_219_6:	// 219inYjiEC_j
	case ENENO_2_210M00_219_7:	// 219inYjiEC_j
	case ENENO_2_210M00_219_8:	// 219inYjiEC_j
		K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL)++;		//_Qbg
//		gpSound->mPlaySE( SFX_SCE2_ULMAYDA_MEDAL_GET );
		if( K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) > K7SCN02_ULMEDAL_MAX ){
			K7EVENT_SCN_VAR(K7SCN02, EVVA_ULMEDAL) = K7SCN02_ULMEDAL_MAX;
		}
		break;
	}
#endif
	return true;
}