////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage307M00 [vL
//
// K7Stage307M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE307M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage307M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Effect.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectDraft.h"

//f
#define	MDL307M00WALL		"door_030506_curve06"		//
#define	MDL307M00WIND		"pPlane2"

//bZ[W
#define	MES307M00_00		(0)							//ǂꂽ
#define MES307M00_01		(1)
#define MES307M00_02		(2)
// J
#define	CAM307_RIDDLE_PATHNAME		"event_030501_0"	// JpXO

static Vec windPos = {-2145.609f, 13.195f, -2037.846f};

K7Stage307M00::K7Stage307M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage307M00_Camera );
	mpWindEffect = NULL;
}

K7Stage307M00::~K7Stage307M00()
{
}

const char* K7Stage307M00::GetPairPath(const char *pPathName)
{
	if( pPathName==NULL ){
		return NULL;
	}
	int		i,j;
	for(i=1 ; i>=0 ; i--){
		for(j=1 ; j>=0 ; j--){
			if( strcmp(pLoopTable[i][j],pPathName)==0 ){
				return pLoopTable[i][j ^ 1];
			}
		}
	}
	return NULL;
}


/*
	
	
	
*/
bool K7Stage307M00::InitializeCallBack(void)
{
	K7SCR_EVCONDCHANGE();
	
	return true;
}


/*
	
	
	Jg
	
	
*/
bool K7Stage307M00::SetCurrentCallBack(void)
{
//	CatWindSePlay(windPos, K7SCN03_EVFL_030501, SFX_SCE3_SUKIMAKAZE);
	K7SCR_EVCONDCHANGE();
	return true;
}


/*
	
	
	qbgIuWF
	
	
*/
bool K7Stage307M00::HitObjCallBack(WK7HitObjInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(030506):							// ւ̕
		if ( K7MSK == WK7PLAYERCONTROL->GetMainID() ){
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030501);	// ItOĂ
			
			//ogIB
			KK7BattleMainTask::BattleMainTaskExit(2);
			// L|[Y
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE(false);
			
			// 
			KK7DoorSmokeEffect( (Vec){-2145.f, 0.f, -2033.f} );
			
			info.mpJObj->Hide(false,true);					// g
			BrokenObj("door_030506_curve06");
			
			gpSound->mPlaySE(SFX_SCE0_WALL_BREAK);
			SetMskWallCam( EV_030501 );
			
			{
				WK7PathNurbs	*pPath = WK7HitObjJObj::GetPath(info.mpJObj);
				if( pPath!=NULL ){
					pPath->SetEnable  (true);									// pXJ
					pPath->SetEnableEx(true);
				}
			}
			
			// L|[Y
			K7SCR_PC_SETVISIBLE(true);
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_EVCONDCHANGE();
			
//		}else{
////			info.mpHitObj->SetEnable(true);					// qbgėLɂ
//			info.SetHitObjEnable(true);
		}
		return true;
		break;
	}
	return true;
}



bool K7Stage307M00::BpLeaveCallBack(WK7BpInfo &info)
{
	WK7PathNurbs			*pCurrPathNurbs;
	WK7PathNurbs			*pNextPathNurbs;
	u32						eventNo = GetBpEventNo(info);

	switch( eventNo ){
	case	K7EVENTNO(030501):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030501)==FALSE ){			// jO
			gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
			return true;
		}
	}

	if( (pCurrPathNurbs=info.GetCurrentPath())==NULL || (pNextPathNurbs=info.GetNextPath())==NULL ){
		return true;
	}
	if( strcmp(pCurrPathNurbs->GetName(),pLoopTable[0][0])!=0 ||
	    strcmp(pNextPathNurbs->GetName(),pLoopTable[1][0])!=0 ){
		return true;
	}
	
	WK7PathInfo				*pPathInfo      = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
	pCurrPathNurbs = pPathInfo->GetPath();
	pNextPathNurbs = GetPathNurbs(pLoopTable[0][1]);
	f32						param           = pPathInfo->GetParam();
	u32						pathdir         = pPathInfo->GetDir();
	Vec						pos[2],dir;
	Vec						campos,camtgt;
	WK7CamPathFollowInfo	*pPathFollowInfo = WK7CAM->GetPathFollowInfo();
	WK7PathControl			*pCamPathControl = WK7CAM->GetPathControl();
	WK7PathInfo				*pCamPathInfo;
	
	if( pCurrPathNurbs ==NULL ||
	    pNextPathNurbs ==NULL ||
	    pPathFollowInfo==NULL ||
	    pCamPathControl==NULL ||
	    (pCamPathInfo=pCamPathControl->GetCurrentPathInfo())==NULL ){
		return true;
	}
	
	pCurrPathNurbs->GetPoint(pos[0],param);
	pNextPathNurbs->GetPoint(pos[1],param);
	VECSubtract(&pos[1],&pos[0],&dir);
	
	WK7Stage::SetCurrentPath(pNextPathNurbs,param,pathdir);
	
	if( (pCurrPathNurbs = pCamPathInfo->GetPath())==NULL ){
		return true;
	}
	
	const char		*pNextPathName = GetPairPath(pCurrPathNurbs->GetName());
	
	if( (pNextPathNurbs = GetPathNurbs(pNextPathName))==NULL ){
		return true;
	}
	
	param   = pCamPathInfo->GetParam();
	pathdir = pCamPathInfo->GetDir();
	
	pPathFollowInfo->SetCurrentPath(pNextPathNurbs,param,pathdir);
	pPathFollowInfo->SetCamPosReset(false);
	
	pPathFollowInfo->GetPosition      (campos);
	pPathFollowInfo->GetTargetPosition(camtgt);
	
	campos.x += dir.x;
	campos.y += dir.y;
	campos.z += dir.z;
	camtgt.x += dir.x;
	camtgt.y += dir.y;
	camtgt.z += dir.z;
	
	pPathFollowInfo->SetPosition      (campos);
	pPathFollowInfo->SetTargetPosition(camtgt);
	
	return false;
}


/*
	
	
	L`FW
	
	
*/
bool K7Stage307M00::CharaChangeCallBack(WK7CharaChangeInfo &info)
{
#pragma	unused(info)
//	CatWindSePlay(windPos, K7SCN03_EVFL_030501, SFX_SCE3_SUKIMAKAZE);
	K7SCR_EVCONDCHANGE();
	return true;
}



/*
	
	
	󋵕ω
	
	
*/
bool K7Stage307M00::CondChangeCallBack(void)
{
	EFFECT		*pWindEffect;
	WK7JObj		*pWindJObj;
	bool		wind;
	
	// ǃIuWF
	pWindJObj = GetJObj(MDL307M00WALL);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030501)==TRUE ){			// jς
		K7SCR_JOBJ_HIDE(pWindJObj);
		K7SCR_STG_SET_DISABLEPATHCAMERA(CAM307_RIDDLE_PATHNAME,true);
		WK7PathNurbs	*pPath = WK7HitObjJObj::GetPath(pWindJObj);
		if( pPath!=NULL ){
			pPath->SetEnable(true);										// pX
			pPath->SetEnableEx(true);
		}
	}else{
	// pX
		K7SCR_JOBJ_DISP(pWindJObj);
		K7SCR_STG_SET_DISABLEPATHCAMERA(CAM307_RIDDLE_PATHNAME,false);
		WK7PathNurbs	*pPath = WK7HitObjJObj::GetPath(pWindJObj);
		if( pPath!=NULL ){
			pPath->SetEnable(false);									// pX
			pPath->SetEnableEx(false);
		}
	}
	
	// GtFNg
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030501)==TRUE ){			// jς
		wind = false;
	}else{
		if( WK7PLAYERCONTROL->GetMainID()==K7CAT ){
			wind = true;
		}else{
			wind = false;
		}
	}
	pWindJObj = GetJObj(MDL307M00WIND);
	if( pWindJObj!=NULL ){
		if( wind==true && GetCurrentStageID()==mID ){
			if( IsValidEffect(mpWindEffect)==false ){
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (pWindEffect = ::CreateDraft2Effect(pWindJObj,(s32)VParam[ED_DRAFT][2]))!=NULL ){
					mpWindEffect = CreateEffect(pWindEffect,&info);
					CatWindSePlay(windPos, K7SCN03_EVFL_030501, SFX_SCE3_SUKIMAKAZE);
				}
			}
		}else{
			if( mpWindEffect!=NULL ){
				DelReqEffect(mpWindEffect);
				mpWindEffect = NULL;
			}
		}
	}
	
	return true;
}

bool K7Stage307M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo )
	{
		//{[h
		case	K7EVENTNO( 030516 ):
			// L|[Y
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			FixCamMes2( CAM307M_030516, MES307M00_01 );
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		//{[h
		case	K7EVENTNO( 030517 ):
			// L|[Y
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			FixCamMes2( CAM307M_030517, MES307M00_02 );
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			break;
		//ftHg
		default:
			break;
	}
	
	return( true );
}

