////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage310M00  Z~bNX}CXe[W
//
// K7Stage310M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 05/27/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE310M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage310M00.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7BattleCtrl.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

#define	K7STAGE310M00_LARGE_ANGEL_CHRID		K7CHRID(K7FER,   0)
#define	K7STAGE310M00_LARGE_ANGEL_MOTID		K7MOTID(K7FER,  20)

// bZ[W
#define MES310_CERA		(0)			//  Z~bN}CЉp

K7Stage310M00::K7Stage310M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpLargeAngel       = NULL;
	mpLargeAngelModel  = NULL;
	mpLargeAngelMotion = NULL;
	mpSetAlpha         = NULL;
	SetOneShotCamLocTbl(K7Stage310M00_Camera);
}

K7Stage310M00::~K7Stage310M00()
{
	GHM_SAFE_DELETE(mpSetAlpha);
}

bool K7Stage310M00::CreateCallBack(void)
{
	CreateOwnChara(K7STAGE310M00_LARGE_ANGEL_CHRID);
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE310M00_LARGE_ANGEL_MOTID);
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage310M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage310M00::InitializeCallBack(void)
{
	WK7JObj		*pJObj = GetJObj("omote");
	static	HSD_PEDesc	pedesc = {
		//J[AAt@AŒAt@݁AZobt@SăGiuB
		ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE|ENABLE_DITHER|BEFORE_TEX,
		// GXSetAlphaCompare(),ref0,ref1
		0,0,
		// GXSetDstAlpha(),dst_alpha
		WK7RENDEROBJ_RENDERID_DEFAULT_ALPHA,
		// GXSetBlendMode(),type,src_factor,dst_factor,logic_op
		GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR,
		//GXSetZMode(),func
		GX_LEQUAL,
		//GXAlphaCompare,comp0,op,comp1
		GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
	};
	if( pJObj!=NULL ){
		pJObj->SetPE(&pedesc,false,true);
		pJObj->SetNoZUpdate(false,false,true);
	}
	mpLargeAngel       = GetOwnChara(K7STAGE310M00_LARGE_ANGEL_CHRID);
	mpLargeAngelModel  = GetOwnModel(K7OBJTYPE_CHR,K7STAGE310M00_LARGE_ANGEL_CHRID);
	mpLargeAngelMotion = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE310M00_LARGE_ANGEL_MOTID);
	mAlpha.SetValue(0.0f);
	if( mpLargeAngel!=NULL ){
		mpLargeAngel->CreatePrivateLight();
		mpLargeAngel->SetStageLight(false);
		mpLargeAngel->SetRenderFlag(false);
		mpLargeAngel->SetPosition  (-2919.000f,0.0f,-2160.904f);
		mpLargeAngel->SetRotY      (0.0f);
		if( mpLargeAngelModel!=NULL && mpLargeAngelMotion!=NULL ){
			mpLargeAngelModel->AttachMotion(mpLargeAngelMotion);
			mpLargeAngelModel->PlayMotion();
			mpLargeAngelModel->SetMotionLoop(true);
		}
		if( (mpSetAlpha = new C_SetAlpha(mpLargeAngel,mAlpha.GetValue(),true))!=NULL ){
			mpSetAlpha->SetVal(mAlpha.GetValue(),true);
		}
	}
	return true;
}

bool K7Stage310M00::CondChangeCallBack(void)
{
	bool	after_angel,appear_angel;
	bool	angel_event;
	
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_APPEAR_ANGEL)==FALSE ){
		SetZanEnable(K7EVENTTAMA(030501),false);
		after_angel  = false;
		appear_angel = false;
		angel_event  = false;
		mAlpha.SetValue(0.0f);
		if( mpLargeAngel!=NULL ){
			mpLargeAngel->SetRenderFlag(false);
		}
	}else if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_AFTER_ANGEL)==FALSE ){
		SetZanEnable(K7EVENTTAMA(030501),true);
		after_angel  = false;
		appear_angel = true;
		angel_event  = true;
		mAlpha.SetValue(1.0f);
		if( mpLargeAngel!=NULL ){
			mpLargeAngel->SetRenderFlag(true);
		}
	}else{
		after_angel  = true;
		appear_angel = true;
		angel_event  = false;
		mAlpha.SetValue(0.0f);
		if( mpLargeAngel!=NULL ){
			mpLargeAngel->SetRenderFlag(false);
		}
	}
	K7SCR_STG_SET_PATHENABLE("after_angel"    ,after_angel );
	K7SCR_STG_SET_PATHENABLE("after_ceramic"  ,appear_angel);
	K7SCR_EVNO_SETENABLE    (K7EVENTNO(030530),angel_event );
	SetVisibleJObj("obj",K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_APPEAR_ANGEL)==FALSE,false,true);
	if( mpLargeAngel!=NULL ){
		WK7JObj		*pGun = mpLargeAngel->GetJObj("Cltpspx");
		if( pGun!=NULL ){
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_GETDANGUN)==FALSE ){
				pGun->Disp(false,true);
			}else{
				pGun->Hide(false,true);
			}
		}
		WK7JObj		*pTama = mpLargeAngel->GetJObj("tama_007101");
		if( pTama!=NULL ){
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_APPEAR_ANGEL)==TRUE && K7SCR_EVHASITEM(K7EVITEM_TAMA(030501))==false ){
				pTama->Disp(false,true);
				CreateTamaEffect(pTama);
			}else{
				pTama->Hide(false,true);
				ReleaseTamaEffect();
			}
		}
	}
	return true;
}

#ifndef	K7APP_MASTER
static	bool	eventstart = false;
#endif
bool K7Stage310M00::SetCurrentCallBack(void)
{
	WK7Npc *pEnemy = WK7Npc::Find( ENENO_3_310M00_1 );
	
//	SetCurrentCallBackDefaultProc();
	if( WK7Npc::GetEnemyDieTest(ENENO_3_310M00_1)==true ){
		// Z~bNX}C͎ł
		//ȍĐ
		gpSound->mPlayStreamNo( HPS_ISZK_M );
		
		return true;
	}
	
	// ȍĐ
	gpSound->mPlayStreamNo( HPS_SPEED_HS );
	
	while( WK7Stage::IsChanging() != false ){
		K7SCR_RETSYS();
	}
	
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_CURUCURU_CERA) == false ){
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_CURUCURU_CERA);
		
		// Ln叉߂
		
		KihanDemoFirst(pEnemy, CAM310M00HSINIT, CAM310M00HSTERM, MES310_CERA, 291,  239, -86,  97, 854, 134,
		1	);
		
	}else{
		
		// LnQڈȍ~
		
		KihanDemo(ENENO_3_310M00_1, CAM310M00HSTERM);
		
	}
	
	// {XsJn
	while( pEnemy->KihanBoss_AiRun() == false ){
		K7SCR_RETSYS();
	}
	
	K7SCR_PC_SETVISIBLE(true);
	SetCameraStartPosition(WK7Stage::GetCurrentStageBpName());
	//JPCtH[ɖ߂
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	
	K7SCR_RETSYS();
	K7SCR_CHARAPRESENT_DEBUGEND();
	K7SCR_TIMEWAIT(K7SCR_CP_RELEASETIME);
	
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
#ifndef	K7APP_MASTER
		if( HSD_PadGetTrigger(1) & HSD_PAD_A ){
			if( eventstart==true ){
				WK7DieNpcInfo	info;
				info.Initialize();
				CallDieNpcCallBackTask(info);
			}
		}
#endif

		mAlpha.FrameProcess();
		if( mpSetAlpha != NULL ){
			mpSetAlpha->SetVal(mAlpha.GetValue(),true);
		}
		K7SCR_RETSYS();
	}
	return false;
}

/*
	
	
	
	
*/
bool K7Stage310M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(030530):
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		FixCam(LARGE_ANGEL1);
		
		WK7PLAYERCONTROL->ReleaseArchive();
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
		
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
			K7SCR_RETSYS();
		}
		
		K7SCR_STG_ITEMGET(K7STAGE310M00_MES_GETGUN);
		K7SCR_STG_ITEMGET_NOTDISPLAYED_B(K7STAGE310M00_MES_GETGUN);
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_GETDANGUN);
		K7SCR_EVCONDCHANGE();
		K7SCR_STG_ITEMGET_VALID_B(K7STAGE310M00_MES_GETGUN);
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
		
		K7SCR_SYS_ITEMGET_S(K7SCR_SYSMES_GETTAMA, SFX_SYS_GET_BULLET);
		K7SCR_SYS_ITEMGET_NOTDISPLAYED_B(K7SCR_SYSMES_GETTAMA);
		K7SCR_EVSETITEM(K7EVITEM_TAMA(030501),true);	// e
		K7SCR_EVCONDCHANGE();
		K7SCR_SYS_ITEMGET_VALID_B(K7SCR_SYSMES_GETTAMA);
		
		// _p[AbvtOĂ
		BattleCtrl.DanPowerUp(KK7BATTLECTRL_DANLV_UP);
		
		WK7PLAYERCONTROL->RestoreArchive();
		
		// Vg
		mAlpha.Play(0.0f,WK7_SEC_TO_TICK(3));
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
		
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
			K7SCR_RETSYS();
		}
		
		K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_AFTER_ANGEL);
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EVCONDCHANGE();
		break;
	default:
		break;
	}
	return true;
}

/*
	
	
	Z~bNX}C񂾎̏
	
	eeo
	
	
*/
bool K7Stage310M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
#ifndef	K7APP_MASTER
	if( eventstart==true ){
		goto checkskip;
	}
#endif
	if( info.mpNpc==NULL ){
		return true;
	}
	
	// Ȏ~߂
	gpSound->mStopStream();
	
	if ( info.mpNpc->GetDieMode() != NPC_DIE_INSTANT ){
		
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(030507), true);
		K7SCR_STG_SET_PATHENABLE("door_030507", true);
		
		// ̏ꍇ͂
		return true;
	}
	
	switch( info.mpNpc->GetEneNo() ){
	case	ENENO_3_310M00_1:
		break;
	default:
		return true;
	}
#ifndef	K7APP_MASTER
checkskip:
#endif
	
	KK7BattleMainTask::BattleMainTaskExit(2);
	
	// Vgo
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE(false);										// l
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
	
	gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
	
	if( mpLargeAngel!=NULL ){
		mpLargeAngel->SetRenderFlag(true);
	}
	
	WK7JObj		*pJObj = GetJObj("obj");
	if( pJObj==NULL ){
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EVCONDCHANGE();
		return true;
	}
	
	mAlpha.SetValue(0.0f);
	pJObj->Disp(false,true);
	pJObj->CreateAlphaControl(1.0f,false);
	
	FixCam(LARGE_ANGEL0);
	
	K7SCR_PC_SETVISIBLE(false);
static	f32		sec = 1.5f;
	// JY[Jn
	pJObj->SetAlpha(0.0f,WK7_SEC_TO_TICK(3.0f));
	
	// Y[opSE Y[Jn
	gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOMSTART);
	
	while( pJObj->IsAnimatingAlpha()==true ){
		K7SCR_RETSYS();
	}
	mAlpha.Play(1.0f,WK7_SEC_TO_TICK(sec));
	while( mAlpha.IsAnimating()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_APPEAR_ANGEL);
	K7SCR_EVCONDCHANGE();
	SetZanEnable(K7EVENTTAMA(030501),false);
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
	CamMoveToLinearPath(LARGE_ANGEL1,sec);
//	K7SCR_TIMEWAIT((int)WK7_SEC_TO_TICK(sec));
	
	// Z~bN|ȕύX
	gpSound->mPlayStreamNo( HPS_ISZK_M );
	
	// EFCg
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	K7SCR_TIMEWAIT(2400);
	
	// Y[op SE Y[
	gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOM);
	
	// EFCg
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
	
	pJObj->ReleaseAlphaControl();
	K7SCR_PC_SETVISIBLE(true);
	
	SetZanEnable(K7EVENTTAMA(030501),true);
	
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EVCONDCHANGE();
	return false;
}

