////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage324M00
//
// K7Stage324M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE324M00_H__
#define	__K7STAGE324M00_H__

#include "..\K7Stage.h"

#define K7STAGE324M00_LOT_LGT_MAX		(4)

class K7Stage324M00 : public WK7Stage{
	friend class WK7Stage;
public:
protected:
	K7Stage324M00();
	K7Stage324M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	void BoardMotionTest(void);
	
	bool panelStageReturn;
	bool StartStageEffect(void);
	EFFECT *pRotLgt[K7STAGE324M00_LOT_LGT_MAX];
	
	bool MainBreakerOpen(int inSE=0);
	
	bool FuusenRakkaB(void);
	bool FuusenWait(void);
	bool FuusenGetB(void);
	bool FuusenGetWait(void);
	void KanbanDemo(void);
	void TokeiMove(f32 sframe);
	
public:
	virtual ~K7Stage324M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool EpLeaveCallBack   (WK7EpLeaveInfo   &){ return true; }		// Cxg|Cgo
//	virtual bool EpArriveCallBack  (WK7EpArriveInfo  &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
	bool HitObjCallBack(WK7HitObjInfo &info);
};


#ifdef __K7STAGE324M00_CPP__

enum K7STAGE324M00_ONESHOTCAM{
	ONESHOTCAM_030409,
	DR_030405,
	DR_030401,
	DR_030402,
	DR_030403,
	DR_030404,
	DR_LCAM,
	DR_RCAM,
	DR_KANBANMISS,
	ONESHOTCAM_FUUSENRAKKA,
	ONESHOTCAM_FUUSENGET,
	ONESHOTCAM_FUUSEN_TAMADISP,
	ONESHOTCAM_030411,
	ONESHOTCAM_30303,
	EV_KYOUDAI_UP,
	EV_ZOUKEIBUTU_UP,
	EV_OVERLAP,
	EV_FUUSENRAKKASHOT,
	CAM324M00_HS_PRESEN_START,
	CAM324M00_HS_PRESEN_END,
};


K7StageEventOneShotCamera K7Stage324M00_Camera[] = {
	{{-539.983f, 12.487f, -812.748f},{-540.908f, 11.195f, -843.670f}},			// Cu[J[Jp
	{{-4.989f, 28.339f, -1566.869f},{18.625f, 13.189f, -1529.007f}},			// ~Xe[nEX̔
	{{-407.438f, 14.861f, -1211.093f},{-406.753f, 18.023f, -1157.103f}},		//  i01j
	{{-177.356f, 14.861f, -1213.120f},{-176.671f, 18.023f, -1159.130f}},		//  i02j
	{{171.100f, 14.861f, -1205.984f},{171.785f, 18.023f, -1151.994f}},			//  i03j
	{{403.521f, 14.861f, -1208.647f},{404.206f, 18.023f, -1154.657f}},			//  i04j
	{{309.875f, 52.729f, -1187.067f},{341.452f, 51.160f, -1217.880f}},			// L
	{{-334.963f, 54.511f, -1133.234f},{-370.262f, 54.459f, -1159.748f}},		// R
	{{309.875f, 52.729f, -1187.067f},{341.452f, 51.160f, -1217.880f}},			// ŔSƂ̃fJ
	{{-177.143f, 49.585f, -1154.336f},{-226.342f, 35.826f, -1182.430f}},		// DĂJ
	{{-256.772f, 16.695f, -1169.309f},{-265.769f, 12.381f, -1169.950f}},		// D擾̃J
	{{-201.929f, -0.469f, -1156.868f},{-198.105f, 8.733f, -1157.696f}},			// eAbv
	{{-165.269f, 56.384f, -1163.172f},{-218.299f, 34.500f, -1181.553f}},		// DAт𑣂J
	{{516.010f, 5.043f, -1103.933f},{497.119f, 7.801f, -1111.339f}},			//䋾
	{{519.500f, 6.571f, -1106.132f},{499.512f, 5.210f, -1110.367f}},			//Abv
	{{520.049f, -6.184f, -1104.926f},{507.622f, 11.076f, -1101.430f}},			//`Abv
	{{516.217f, 7.084f, -1107.296f},{497.278f, 13.897f, -1099.583f}},			//I[o[bv
	{{-194.715f, 4.166f, -1157.837f},{-185.306f, 3.615f, -1161.180f}},			//DuԂ̃J
	{{-539.537f, 6.066f, -1084.139f},{-539.260f, 6.432f, -1104.867f}},			//Љ
	{{-541.446f, 9.648f, -854.493f},{-541.170f, 10.014f, -875.221f}},			//ЉAbv
};

// 邭郉Cg̐ݒuꏊ
Vec rotLgtPos[K7STAGE324M00_LOT_LGT_MAX] = {
	{-220.436f, 145.255f, -1000.f},
	{-92.482f,  145.255f, -1000.f},
	{92.036f,   145.255f, -1000.f},
	{213.795f,  145.255f, -1000.f}
};

enum BOARD{
	board_I1 = 0,
	board_S2,
	board_Z3,
	board_K4,
	board_S5,
	board_T6,
	board_R7,
	board_I8,
	board_N9,
	board_G10,
	board_Q11,
	board_U12,
	board_A13,
	board_R14,
	board_T15,
	board_E16,
	board_T17,
	BOARD_MAX
};

static int board_on[BOARD_MAX];

static char *pBoardNameTable[BOARD_MAX] = {
	"I_neon_1",
	"S_neon_2",
	"Z_neon_3",
	"K_neon_4",
	"S_neon_5",
	"T_neon_6",
	"R_neon_7",
	"I_neon_8",
	"N_neon_9",
	"G_neon_10",
	"Q_neon_11",
	"U_neon_12",
	"A_neon_13",
	"R_neon_14",
	"T_neon_15",
	"E_neon_16",
	"T_neon_17",
};

#endif

#endif	//__K7STAGE324M00_H__

