////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage363M00 J[eBX̉Ɓ@v[
//
// K7Stage363M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 01/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE363M00_CPP__

#include ".\WK7Archive.h"
#include ".\K7Stage363M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7GameInfo.h"
#include "..\..\..\fujita\c_vfx.h"
#include "..\..\..\Scn\K7Scn03.h"
#include "..\..\..\Enm\EnmCUR.h"
#include "..\..\..\sato\SK7ScenarioEnd.h"
#include "..\..\..\Wat\WK7Item.h"

#include "..\..\..\Kaw\KK7BattleMainTask.h"

//SEDefine
#define SE_HATO_WAIT1()		gpSound->mPlaySE( SFX_BOSS_CUR_PIGEON_WAITA );
#define SE_HATO_WAIT2()		gpSound->mPlaySE( SFX_BOSS_CUR_PIGEON_WAITB );
#define SE_HATO_FAKE()		gpSound->mPlaySE( SFX_BOSS_CUR_PIGEON_FAKE );
#define SE_HATO_TAKEOFF()	gpSound->mPlaySE( SFX_BOSS_CUR_PIGEON_GO );
#define SE_HATO_LANDING()	gpSound->mPlaySE( SFX_BOSS_CUR_PIGEON_COME );
#define SE_HATO_STAR()		gpSound->mPlaySE( SFX_BOSS_CUR_STARSYMBOL );

enum {
  MOT_STILL = (2),				// ҋ@
  MOT_SIGN = (4),				// ԍ}
  MOT_LANDING = (100),			// n
  MOT_TAKEOFF =	(200)			// ї
};

enum {
  STATE_OPENING,
  STATE_STILL,
  STATE_SIGN,
  STATE_TAKEOFF,
  STATE_VANISH,
  STATE_LANDING,
  STATE_CHEAT,				// tFCg
};
enum {
  CHEAT_FRM = 10,
};
K7Stage363M00::K7Stage363M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
	terminate_called = false;
	mot_id = -1;
}
bool K7Stage363M00::LoadAfterInit(void)
{
  //mpFile.Open( "Texture/Common/star.bin" );
  for( int i=0; i<7; ++i ){
	char *name[] = {
	  "Texture/star01.bin",
	  "Texture/star02.bin",
	  "Texture/star03.bin",
	  "Texture/star04.bin",
	  "Texture/star05.bin",
	  "Texture/star06.bin",
	  "Texture/star07.bin"
	};
	mpFile[i].Open( name[i] );
	if( (mpTextureData[i] = (u8*)mpFile[i].Read()) == 0 ) mpFile[i].Close();
  }
  return WK7Stage::LoadAfterInit();
}
bool K7Stage363M00::IsLoadingAfterInit(void)
{
  for( int i=0; i<7; ++i ){
	if( mpFile[i].GetState() != ghmGcFile::READFINISH ) return true;
  }
  return WK7Stage::IsLoadingAfterInit();
}
bool K7Stage363M00::IsMotionEnd( void )
{
  WK7JObj			*pJObj;

  if( (pJObj=mpHato->GetJObj())!=NULL ){
	if( pJObj->GetMotionState()==AOBJ_NO_ANIM ) return true;
	else return false;
  }
  return true;
}

bool K7Stage363M00::SetMotion( s32 id_, bool loop_, bool intrp_  )
{
  WK7JObj			*pJObj;
  WK7ModelMotion	*pModelMotion; 

  if( (pJObj=mpHato->GetJObj())!=NULL && (pModelMotion=mpHato->GetOwnModelMotion((u32)id_))!=NULL ){
	pJObj->StopMotion  ();
	pJObj->DetachMotion();
	pJObj->AttachMotion(pModelMotion);
	pJObj->PlayMotion  ( 0.f, intrp_, 15.f );
	pJObj->SetMotionLoop(loop_);
	mot_id = (s32)id_;
	return true;
  }
  return false;
}
bool K7Stage363M00::IsMotion( s32 id_ )
{
  return (mot_id == id_);
}
void K7Stage363M00::Penalty( void )
{
  if( K7EnmCUR::GetInstance() ) CUR.SetPenalty(); 
  //state = STATE_VANISH;
}
void K7Stage363M00::PigeonSet( void )
{
  if( K7EnmCUR::GetInstance() ){
	Vec p_;
	CUR.GetRShoulder()->GetWorldPosition( p_ ); 
	p_.y += 0.4f;
	mpHato->GetJObj()->SetPosition( p_ );
	mpHato->GetJObj()->SetRotY( 60.f * (f32)M_PI / 180.f );
  }
}
bool K7Stage363M00::PigeonSetVisible(bool flag)
{
	if( mpHato==NULL ){
		return false;
	}
	mpHato->SetVisible(flag);
	mpHato->SetVisibleJObj("Carrier",false,false,true);
	return true;
}
void K7Stage363M00::CamSetChr2Enm( void )
{
  //Vec ppos={-328.814f,-68.384f,-405.993f}, epos={-318.957f,-67.786f,-407.572f};
  Vec ppos={-325.555f,-69.006f,-404.024f}, epos={-319.581f,-69.099f,-404.196f};
  WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
  WK7CAM->SetPosition      (epos);
  WK7CAM->SetTargetPosition(ppos);
  WK7CAM->SetFov(9.815f);
}
void K7Stage363M00::CamSetEnm2Chr( void )
{
  Vec epos={-359.491f, -90.410f, -412.408f}, ppos={-343.103f, -74.779f, -404.533f};
  //Vec ppos={-410.f,-67.9f,-414.f}, epos={-420.f,-68.f,-417.f};
  WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
  WK7CAM->SetPosition      (epos);
  WK7CAM->SetTargetPosition(ppos);
  WK7CAM->SetFov(19.f);
}
void K7Stage363M00::CamSetEnm( void )
{
  Vec epos={-359.746f, -76.380f, -409.684f}, ppos={-396.354f, -65.647f, -397.734f};
  //Vec ppos={-350.f,-63.f,-428.f}, epos={-338.f,-61.f,-438.f};
  WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
  WK7CAM->SetPosition      (epos);
  WK7CAM->SetTargetPosition(ppos);
  WK7CAM->SetFov(19.f);
}
void K7Stage363M00::AutoPlayIn( void )
{
	K7SCR_ENTER_PLAYMODE();
//	GameInfo.SetSpecialEnable(false);
	KK7BattleMainTask::BattleMainTaskExit(2);
	//WK7CAM->SetCinemaScopeMode(true);
	WK7PLAYERCONTROL->SetOperateEnable(false);
}
void K7Stage363M00::AutoPlayOut( void )
{
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
//	GameInfo.SetSpecialEnable(true);
	//WK7CAM->SetCinemaScopeMode(false);
	WK7PLAYERCONTROL->SetOperateEnable(true);
	GameInfo.SetRenderOption(false);
}

bool K7Stage363M00::SetCurrentCallBack( void )
{
	// 蓮Xe[Wnm
	SetManualBranch(true);
	GameInfo.SetSpecialEnable(false);						// TuʃI[vs
	GameInfo.SetRenderOptionDisable(false);
	GameInfo.SetRenderOption(false);
	GameInfo.SetRenderOptionDisable(true);
	
  {//B
#if 0
	if( WK7Chara::CreateStaticArchive(K7CHRID(K7HAT,0))==false ){
	  return false;
	}
#endif
	if( (mpArchive = WK7Archive::Find(K7OBJTYPE_CHR,K7CHRID(K7HAT,0)))==NULL ){
	  return false;
	}
	if( (mpHato = WK7RenderObj::CreateChara(K7CHRID(K7HAT,0)))==NULL ){
	  return false;
	}
	mpHato->CreateOwnCharaMotion(MOT_STILL);
	mpHato->CreateOwnCharaMotion(MOT_LANDING);
	mpHato->CreateOwnCharaMotion(MOT_TAKEOFF);
	mpHato->CreateOwnCharaMotion(MOT_SIGN);
	
	PigeonSetVisible(true);
  }
  {//Xe[^XB
	state.Init( STATE_STILL );
	pc_hit = npc_hit = 0;
	penalty_hit = true;
  }
  {//eNX`B
    #define	DAN_STAR_POS_Y	(400-32)	//(423)
    #define	CUR_STAR_POS_Y	(80)		//(14)
	s16 pos0[7][2] = {
	  {32,423}, {67,423}, {102,423}, {137,423}, {172,423}, {207,423}, {242,423}
	};
	s16 pos1[7][2] = {
	  {577,14}, {542,14}, {507,14}, {472,14}, {437,14}, {402,14}, {367,14}
	};
	for( int j=0; j<7; ++j ){
	  tex_obj[0][j].tex = (GhmGcTexHeader*)mpTextureData[j];
	  mK7InitTexture( &tex_obj[0][j] );
	  sprite[0][j].mRelateTex( &tex_obj[0][j] );
	  sprite[0][j].mSetSpritePrim();
	  sprite[0][j].mSetWH( 32, 32 );
	  sprite[0][j].mSetUV0( 0, 0 );
	//sprite[0][j].mSetXY0( pos0[j][0], pos0[j][1] );
	  sprite[0][j].mSetXY0( pos0[j][0], DAN_STAR_POS_Y );
	  sprite[0][j].mSetDispFlag( false );
	//sprite[0][j].mSetRGBA( 0xffffffff );
	  sprite[0][j].mSetRGBA( 0xED1C24ff );
	}
	for( int j=0; j<7; ++j ){
	  tex_obj[1][j].tex = (GhmGcTexHeader*)mpTextureData[6-j];
	  mK7InitTexture( &tex_obj[1][j] );
	  sprite[1][j].mRelateTex( &tex_obj[1][j] );
	  sprite[1][j].mSetSpritePrim();
	  sprite[1][j].mSetWH( 32, 32 );
	  sprite[1][j].mSetUV0( 0, 0 );
	//sprite[1][j].mSetXY0( pos1[j][0], pos1[j][1] );
	  sprite[1][j].mSetXY0( pos1[j][0], CUR_STAR_POS_Y );
	  sprite[1][j].mSetDispFlag( false );
	  sprite[1][j].mSetRGBA( 0x000000ff );
	}
  }

	{//^X^[g todo
	//WK7PLAYERCONTROL->SetBullet(0);
		while( WK7PLAYERCONTROL->GetState() != PC_STATE_WAIT ) K7SCR_RETSYS();
		
		// J[eBXǂݍ݊֘AĂH
		while( K7EnmCUR::mCURBattleStart == 0 ) K7SCR_RETSYS();
	}
	
	// ȍĐ
	gpSound->mPlayStreamNo( HPS_HAGESHI );
	
	CamSetChr2Enm();
	SandRelease();																// mCYJiXe[Wj
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		CamSetChr2Enm();
		K7SCR_RETSYS();
	}
	// 蓮Xe[Wnm
	SetManualBranch(false);
	
  {
	PigeonSetVisible(false);
	int c_ = 60;
	while( --c_ ){
		AutoPlayIn();
		if ( true == SetMotion( MOT_LANDING ) ){
//			SE_HATO_LANDING();
		}
		//WK7CAM->SetCinemaScopeMode(false);
		PigeonSet();
		CamSetChr2Enm();
		K7SCR_RETSYS();
	}
	
	SE_HATO_LANDING();
	PigeonSetVisible(true);
	while( !IsMotionEnd()   ){
		PigeonSet();
		CamSetChr2Enm();
		K7SCR_RETSYS();
	}
	AutoPlayOut();
  }
	
  int next_count;
  while( true ){
	if( terminate_called ) return true;

	WK7Npc *npc_ = WK7Npc::Find(ENENO_CUR);
	if(npc_ && npc_->GetNpcPause() ){
	  if( mpHato ){
		WK7JObj	*pJObj = mpHato->GetJObj() ;
		if( pJObj )	  pJObj->StopMotionAll();
	  }
	  while( (npc_ = WK7Npc::Find(ENENO_CUR)) && npc_->GetNpcPause() ){
		K7SCR_RETSYS();
	  }
	  if( terminate_called ) return true;
	  if( mpHato ){
		WK7JObj	*pJObj = mpHato->GetJObj() ;
		if( pJObj )	  pJObj->ReplayMotionAll();
	  }
	}
	  
	PigeonSet();
	bool battle_;
	if( K7EnmCUR::GetInstance() && CUR.GetState() == CUR_STATE_DAMAGE ){
	  //NPC_[WB
	  AutoPlayIn();
	  while(  K7EnmCUR::GetInstance() && CUR.GetState() == CUR_STATE_DAMAGE ){
		CamSetEnm();
		K7SCR_RETSYS();
	  }
	  AutoPlayOut();
	}else if( K7EnmCUR::GetInstance() && CUR.GetState() == CUR_STATE_DEAD ){
	  //NPCSB
	  AutoPlayIn();
	  while(  K7EnmCUR::GetInstance() && CUR.GetState() == CUR_STATE_DEAD ){
		CamSetEnm();
		K7SCR_RETSYS();
	  }
//	  AutoPlayOut();
	  //[r[ցB
	  break;
	}else if( WK7PLAYERCONTROL->GetState() == PC_STATE_DMG ){
	  //PC_[WB
	  AutoPlayIn();
	  int c_ = 90;
	  while(  --c_ || WK7PLAYERCONTROL->GetState() == PC_STATE_DMG  ){
		PigeonSet();
		if( (s32)state == STATE_STILL || (s32)state == STATE_CHEAT ){
		  //yieB̎̓Ĵ܂܁BtFCgƂB
		  CamSetChr2Enm();
		}else{
		  CamSetEnm2Chr();
		}
		state = STATE_VANISH;
		K7SCR_RETSYS();
		if ( false == WK7RenderObj::IsValid(this) ){
		  // Ă܂ǂHiob
		  WK7PLAYERCONTROL->BattlePadRegulationSet();
		  return true;
		}
	  }
	  AutoPlayOut();
	}

	{//[hƂoȂB
//		GameInfo.SetSpecialEnable(false);						// TuʃI[vs
		WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_ONLY);
		WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_MANUALRELOAD);
		WK7PLAYERCONTROL->BattlePadRegulationSet(	BPADREG_NO_WAIT );
	}
	//iB
	if( (battle_ = WK7PLAYERCONTROL->PcBattleTaskTest()) ){
	}else{
	  //ogȊO̓JB
	  CamSetChr2Enm();
	}

	do {
	  switch( (s32)state ){
	  case STATE_STILL:
		{
		  switch( state.GetPhase() ){
		  case PHASE_CTOR:{
			SetMotion( MOT_STILL, true );
			PigeonSetVisible(true);
			next_count = 40 + HSD_Rand()%100;
		  }break;
		  case PHASE_PROC:{
#if 1
			if( K7EnmCUR::GetInstance() && 
				CUR.GetState() == CUR_STATE_STILL &&
				(state.GetPhaseCounter() >= next_count)){
			  if( CUR.GetNPCHit() && ((HSD_Rand()%100) > 20) && cheat_count < 3 ) 
				state = STATE_CHEAT;
			  else					
				state = STATE_SIGN;
			}else if( battle_ && K7EnmCUR::GetInstance() ){
			  Penalty();
			}
#endif
		  }break;
		  case PHASE_DTOR:{
		  }break;
		  }
		}break;
	  case STATE_CHEAT:							// tFCg
		{
		  switch( state.GetPhase() ){
		  case PHASE_CTOR:{
			SetMotion( MOT_TAKEOFF );
			SE_HATO_FAKE();
		  }break;
		  case PHASE_PROC:{
			if( IsMotionEnd() ) {state = STATE_STILL; cheat_count+=(HSD_Rand()%2+1);}
			else if( battle_ && K7EnmCUR::GetInstance() ){state = STATE_STILL; Penalty();}
			else if( state.GetPhaseCounter() == CHEAT_FRM ) SetMotion( MOT_STILL );
		  }break;
		  case PHASE_DTOR:{
		  }break;
		  }
		}break;
	  case STATE_SIGN:
		{
		  switch( state.GetPhase() ){
		  case PHASE_CTOR:{
			SetMotion( MOT_SIGN );
			if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
			  if ( rand()&1 ){
				SE_HATO_WAIT1();
			  }else{
				SE_HATO_WAIT2();
			  }
			}
		  }break;
		  case PHASE_PROC:{
			if( IsMotionEnd() ){
			  state = STATE_TAKEOFF;
			}else if( battle_ ){
			  state = STATE_STILL;
			  Penalty();
			}
		  }break;
		  case PHASE_DTOR:{
		  }break;
		  }
		}break;
	  case STATE_TAKEOFF:						// ї
		{
		  switch( state.GetPhase() ){
		  case PHASE_CTOR:{
			SetMotion( MOT_TAKEOFF );
			SE_HATO_TAKEOFF();
		  }break;
		  case PHASE_PROC:{
			if( K7EnmCUR::GetInstance() && state.GetPhaseCounter() == CHEAT_FRM ) CUR.SetStart();
			else if( K7EnmCUR::GetInstance() && state.GetPhaseCounter() < CHEAT_FRM && battle_ ){
			  state = STATE_STILL;
			  Penalty();
			}else if( IsMotionEnd() ){ 
			  state = STATE_VANISH; 
			  penalty_hit = false; 
			}
		  }break;
		  case PHASE_DTOR:{
		  }break;
		  }
		}break;
	  case STATE_VANISH:
		{
		  switch( state.GetPhase() ){
		  case PHASE_CTOR:{
			PigeonSetVisible(false);
		  }break;
		  case PHASE_PROC:{
			if( K7EnmCUR::GetInstance() && CUR.GetState()==CUR_STATE_STILL )	state = STATE_LANDING;
		  }break;
		  case PHASE_DTOR:{
		  }break;
		  }
		}break;
	  case STATE_LANDING:
		{
		  switch( state.GetPhase() ){
		  case PHASE_CTOR:{
			if( K7EnmCUR::GetInstance() ){
			  for( int i=0; i< CUR.GetNPCHit(); ++i ) sprite[0][i].mSetDispFlag( true );
			  for( int i=0; i< CUR.GetPCHit(); ++i ) sprite[1][i].mSetDispFlag( true );
			  CUR.SetOwnPause( true );
			}
			//k7app.FadeStart(0x00,0);
			//k7app.SetFadeColor(0x2f1f00ff);
			//k7app.FadeStart(0x8f,WK7_DEFAULT_FADE_TICK);
			WK7PLAYERCONTROL->SetOperateEnable(false);
			WK7PLAYERCONTROL->SetPause();
//			GameInfo.SetSpecialEnable(false);
			WK7RenderObj::GetVFX()->SetType( C_VFX::VFX_SOBEL );
			if( penalty_hit )	PigeonSetVisible(true);
			else				PigeonSetVisible(false);
		  }break;
		  case PHASE_PROC:{
			int chg_frm_ = 100;
			int counter_ = state.GetPhaseCounter();
			if( counter_ >= chg_frm_ ){
			  if( counter_ == chg_frm_ ){
				if( !penalty_hit ){
				  PigeonSetVisible(true);
					if ( true == SetMotion( MOT_LANDING ) ){
						SE_HATO_LANDING();
					}
				}
				for( int i=0; i< 7; ++i ) sprite[0][i].mSetDispFlag( false );
				for( int i=0; i< 7; ++i ) sprite[1][i].mSetDispFlag( false );
				WK7PLAYERCONTROL->ResetPause();
				if( K7EnmCUR::GetInstance() ) CUR.SetOwnPause( false );
				WK7RenderObj::GetVFX()->SetType( C_VFX::VFX_MIRAGE );
			  }else if( IsMotionEnd() ) state = STATE_STILL;
			}else{
			  if( counter_ < 15 ) WK7RenderObj::GetVFX()->SetAlpha( counter_*16 );
			  if( counter_ > (chg_frm_-15) ) WK7RenderObj::GetVFX()->SetAlpha( (chg_frm_ - counter_)*16 );
			  if( penalty_hit )	SetMotion( MOT_STILL );
			  else {
				if ( true == SetMotion( MOT_LANDING ) ){
//					SE_HATO_LANDING();
				}
  			  }
			  //_ł_ցB
			  if( K7EnmCUR::GetInstance() ){
				if( counter_ <= 70 ){
				  if( (counter_%15) == 7 ) SE_HATO_STAR();
				  if( npc_hit != CUR.GetNPCHit() ) sprite[0][CUR.GetNPCHit()-1].mSetDispFlag( (bool)(counter_%15 > 7) );
				  if( pc_hit != CUR.GetPCHit() ) sprite[1][CUR.GetPCHit()-1].mSetDispFlag( (bool)(counter_%15 > 7) );
				}else{
				  for( int i=0; i< CUR.GetNPCHit(); ++i ) sprite[0][i].mSetDispFlag( true );
				  for( int i=0; i< CUR.GetPCHit(); ++i ) sprite[1][i].mSetDispFlag( true );
				}
			  }
			}
		  }break;
		  case PHASE_DTOR:{
			for( int i=0; i< 7; ++i ) sprite[0][i].mSetDispFlag( false );
			for( int i=0; i< 7; ++i ) sprite[1][i].mSetDispFlag( false );
			WK7PLAYERCONTROL->SetOperateEnable(true);
//			GameInfo.SetSpecialEnable(true);
			if( K7EnmCUR::GetInstance() ){
			  pc_hit = CUR.GetPCHit();
			  npc_hit = CUR.GetNPCHit();
			}
			cheat_count = 0;
			penalty_hit = true;
		  }break;
		  }
		}break;
	  default:
		goto _exit;
		break;
	  }
	}while( !state.Proc() );
_exit:
	K7SCR_RETSYS();
	if ( false == WK7RenderObj::IsValid(this) ){
	  // Ă܂ǂHiob
	  WK7PLAYERCONTROL->BattlePadRegulationSet();
	  return true;
	}
  }
  
//  K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
  
  //inGame~
  gpSound->mFadeVolumeStream(0,30);
  gpSound->mStopStream();
  WK7PLAYERCONTROL->BattlePadRegulationClear();
  WK7PLAYERCONTROL->SetOperateEnable(false);
  KK7BattleMainTask::BattleMainTaskExit(2);
  WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
  AutoPlayOut();
  K7SCR_PC_SETVISIBLE(false);
  
  //J[eBX|̃L
  if( WK7Play::HasPlayed(K7EVENTPLAY(03050109)) == false ){
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_NOISE_REQUEST();
	SetRenderFlag(false);
	K7SCR_RETSYS();	  
	K7SCR_RETSYS();	
	WK7Stage::DeleteStage(this);
	K7EnmCUR	*pCur = K7EnmCUR::GetInstance();
	if( pCur!=NULL ){
	  pCur->SetVisible(false);
	  K7SCR_RETSYS();	  
	  K7SCR_RETSYS();	
	  GHM_SAFE_DELETE(pCur);
	}
	K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(03050109) );
	K7SCR_NOISE_RELEASE();
	K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(03050109) );
	{
		u32			cgno  = K7EVENTPLAY(03050109);
		WK7Play*	pPlay = WK7Play::Find(cgno);
		pPlay->SetVisibleAll( false );
		WK7Play::PlayReleaseAll();
		WK7Play::RestorePlayTB(false);
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (10000.0f,10000.0f,10000.0f);
		WK7CAM->SetTargetPosition(10000.0f,10010.0f,10000.0f + 10.0f);
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		WK7Play::SetPlayed( cgno,true );
		WK7Chara::SetRenderChara(false);
		WK7Stage::SetRenderStage(false);
		WK7Item::SetRenderItem  (false);
	}
//	K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(03050109) );
  }
  
  SK7ScenarioEnd*		m_pSceEnd;
  m_pSceEnd = new SK7ScenarioEnd;
  m_pSceEnd->LoadData();
  gpSound->mPlaySE( SFX_SCE3_END_03 );
  K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(5.033f));
  m_pSceEnd->FrameProcess();
  m_pSceEnd->Release();
  GHM_SAFE_DELETE( m_pSceEnd );
  //K7SCR_RETSYS();

  GameInfo.SetMode     (WK7GameInfo::TERM           );
  GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);

  return true;
}
K7Stage363M00::~K7Stage363M00()
{
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
	TerminateCallBack();
}

bool
K7Stage363M00::TerminateCallBack( void )
{
  terminate_called = true;
	GHM_SAFE_DELETE(mpHato   );
	//̕œǂł炵B
	//GHM_SAFE_DELETE(mpArchive);
	for( int i=0; i<7; ++i ) GHM_SAFE_DELETE(mpTextureData[i]   );
	gpSound->mReleaseSsm( "seBossCurLHS.ssm");
	gpSound->mFadeVolumeStream(0,30);
	gpSound->mStopStream();
//	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	{//nɖ߂B
		GameInfo.SetSpecialEnable(true);						// TuʃI[v
		GameInfo.SetRenderOptionDisable(false);
		WK7PLAYERCONTROL->BattlePadRegulationClear();			// lM[VNA
	}
	return( true );
}

bool
K7Stage363M00::CreateCallBack( void )
{
  //{X̔g`t@C̓ǂݍ
  gpSound->mReadSsm( "seBossCurLHS.ssm", eBankBoss );
  while( gpSound->mGetProcess() != eSndStandby )
	{
	  K7SCR_RETSYS();
	}
	
	CreateOwnChara(K7CHRID(K7HAT,0));
	return true;
}









