////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage412M00 yh~jJz̊X
//
// K7Stage412M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 05/09/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE412M00_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage412M00.h"
#include "..\..\..\Kaw\KK7Sound.h"

#define	K7STAGE412M00_VOLUME_MUSIC			(VOLUME_MUSIC)

K7Stage412M00::K7Stage412M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mSeenSoundPos = -1;
	mpSeenSound   = NULL;
	mVol          = 0;
	mRight        = false;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 0;
//	SetOneShotCamLocTbl( K7Stage412M00_Camera );
	mpEffectLensFlare = NULL;
}

K7Stage412M00::~K7Stage412M00()
{
	ReleaseEffectLensFlare();
}

bool K7Stage412M00::CreateCallBack(void)
{
	// YtA
	SetupEffectLensFlare();
	return true;
}

bool K7Stage412M00::InitializeCallBack(void)
{
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	return true;
}

int K7Stage412M00::GetNextGate(int curGate)
{
	switch( curGate ){
	case	4:
		return 0;
	case	0:
		if( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)>=1 ){
//		if( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)>=3 ){
			return 4;
		}
		break;
	default:
		break;
	}
	return (curGate + 1) % 4;
}

bool K7Stage412M00::GetEventNo(WK7PathInfo *pPathInfo,u32 &evno,int &pathno)
{
	WK7PathNurbs	*pPath;
	const char		*pPathName;
	if( pPathInfo==NULL || (pPath = pPathInfo->GetPath())==NULL || (pPathName = pPath->GetName())==NULL ){
		return false;
	}
	if( strstr(pPathName,"event_")==NULL ){
		return false;
	}
	pPathName += strlen("event_");
	int				i;
	evno = 0;
	for(i=0 ; i<6 ; i++,pPathName++){
		if( *pPathName < '0' || *pPathName > '9' ){
			return false;
		}
		evno <<= 4;
		evno  += (u32)(*pPathName - '0');
	}
	if( *pPathName=='_' ){
		pathno = 0;
		for(pPathName++ ; *pPathName!='\0' ; pPathName++){
			if( *pPathName < '0' || *pPathName > '9' ){
				return false;
			}
			pathno *= 10;
			pathno += (int)(*pPathName - '0');
		}
	}else{
		pathno = -1;
	}
	return true;
}

bool K7Stage412M00::MainStreetProc(u32 evno,int pathno)
{
	switch( evno ){
	case	K7EVENTNO(040501):
		if( pathno==0 ){
			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 0;
			K7SCR_RESET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN);
			return true;
		}
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN)==TRUE ){
			return true;
		}
		break;
	default:
		K7SCR_RESET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN);
		K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 0;
		return true;
	}
	SetNextPath(0,"event_04050%d_%d",pathno,false);
	K7SCR_EVCONDCHANGE();
	return false;
}

static bool _MAKEMTX(Vec &pos,Vec &dir,Mtx &mtx);
static bool _MAKEMTX(Vec &pos,Vec &dir,Mtx &mtx)
{
	Vec			u = { 0.0f , 1.0f , 0.0f };
	Vec			f,s;
	
	VECNormalize   (&dir,&f);
	VECCrossProduct(&u,&f,&s);
	VECNormalize   (&s,&s);
	VECCrossProduct(&f,&s,&u);
	VECNormalize   (&u,&u);
	
	mtx[0][0] = s.x;
	mtx[1][0] = s.y;
	mtx[2][0] = s.z;
	mtx[0][1] = u.x;
	mtx[1][1] = u.y;
	mtx[2][1] = u.z;
	mtx[0][2] = f.x;
	mtx[1][2] = f.y;
	mtx[2][2] = f.z;
	mtx[0][3] = pos.x;
	mtx[1][3] = pos.y;
	mtx[2][3] = pos.z;
	
	return true;
}

bool K7Stage412M00::SideGateProc(u32 evno,int pathno)
{
	int		nextGate  = GetNextGate((int)(evno & 0xf));
	bool	right = false;
	switch( evno ){
	case	K7EVENTNO(040510):
		switch( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) ){
//		case	3:
		case	1:
			right = true;
//			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)++;
//			K7SCR_SET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN);
			break;
		default:
//			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 0;
			break;
		}
		break;
	case	K7EVENTNO(040511):
//		switch( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) ){
//		case	1:
//		case	2:
//			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)++;
//			break;
//		default:
//			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 0;
//			break;
//		}
		break;
	case	K7EVENTNO(040512):
		switch( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) ){
		case	0:
//			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)++;
			right = true;
			break;
		default:
//			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 0;
			break;
		}
//		K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 0;
		break;
	case	K7EVENTNO(040513):
//		switch( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) ){
//		case	0:
//			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)++;
//			break;
//		default:
//			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 0;
//			break;
//		}
		break;
	default:
		break;
	}
	if( right==true ){
		K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)++;
	}else{
		K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 0;
	}
	mRight = false;
	SetNextPath(nextGate,"event_04051%d_%d",pathno,true);
	K7SCR_EVCONDCHANGE();
	return false;
}

bool K7Stage412M00::CondChangeCallBack(void)
{
	if( WK7PLAYERCONTROL->GetMainID()==K7CAT && K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN_CLEAR)==FALSE ){
		if( mSeenSoundPos != K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) ){
			mSeenSoundPos  = K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP);
			if( mpSeenSound!=NULL ){
				ReleaseEffect(mpSeenSound);
				mpSeenSound = NULL;
			}
			int		posid;
			static	Vec		seenSoundPos[] = {
				{115.727f, 10.991f, 316.962f},
				{125.028f, 10.991f, 177.944f},
				{-133.175f, 10.991f, 101.003f},
//				{-168.436f, 10.991f, 43.988f},
				{-115.206f, 10.991f, 11.578f},
			};
			static	u32		seenSoundCol[] = {
				0x40200000,
				0xff8000ff,
			};
			if( (posid = GetRightPosID()) >= 0 ){
				mpSeenSound = CreateEffectSeenSound(seenSoundPos[posid],seenSoundCol[0],seenSoundCol[1]);
			}
		}
	}else{
		if( mpSeenSound!=NULL ){
			ReleaseEffect(mpSeenSound);
			mpSeenSound = NULL;
		}
		mSeenSoundPos = -1;
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN      )==FALSE &&
	    K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN_CLEAR)==FALSE ){
		SetPathEnable(K7EVENTNO(040520),0,true);
		SetPathEnable(K7EVENTNO(040521),0,true);
		SetPathEnable(K7EVENTNO(040522),0,true);
		SetPathEnable(K7EVENTNO(040523),0,true);
		SetPathEnable(K7EVENTNO(040524),0,true);
	}else{
		SetPathEnable(K7EVENTNO(040520),0,false);
		SetPathEnable(K7EVENTNO(040521),0,false);
		SetPathEnable(K7EVENTNO(040522),0,false);
		SetPathEnable(K7EVENTNO(040523),0,false);
		SetPathEnable(K7EVENTNO(040524),0,false);
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN_CLEAR)==TRUE ){
			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) = 4;
		}
	}
	return true;
}

bool K7Stage412M00::SetPathEnable(u32 evno,int pathno,bool flag)
{
	char		pathname[64];
	sprintf(pathname,"event_%06x_%d",evno & K7EV_ID_MASK,pathno);
	return WK7Stage::SetPathEnableOnly(pathname,flag);
}

bool K7Stage412M00::SetNextPath(int next,const char *ppathname,int pathno,bool rev)
{
	if( next < 0 ){
		return true;
	}
	
	WK7PathInfo		*pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
	WK7Path			*pStagePath = GetPath();
	
	if( pPathInfo==NULL || pStagePath==NULL ){
		return true;
	}
	
	K7SCR_RETSYS();
	
	f32						param,camparam;
	u32						pathdir,campathdir;
	WK7PathNurbs			*pPath,*pCamPath;
	f32						sp,ep;
	WK7PathControl			*pCamPathControl = WK7CAM->GetPathControl();
	WK7PathInfo				*pCamPathInfo;
	char					pathname[64];
	WK7CamPathFollowInfo	*pPathFollowInfo = WK7CAM->GetPathFollowInfo();
	Vec						oldplpos,curplpos;
	Vec						oldpldir,curpldir;
	Vec						campos,camtgt;
	
	if( pCamPathControl!=NULL && (pCamPathInfo=pCamPathControl->GetCurrentPathInfo())!=NULL ){
		u32						camevno;
		int						campathno;
		
		if( GetEventNo(pCamPathInfo,camevno,campathno)==true ){
			camparam     = pCamPathInfo->GetParam();
			campathdir   = pCamPathInfo->GetDir();
			if( rev==true ){
				campathno  ^= 1;
				campathdir ^= 1;
			}
			sprintf(pathname,ppathname,next,campathno);
			pCamPath     = pStagePath->GetPath(pathname);
			if( rev==true && pCamPath!=NULL ){
				sp       = pCamPath->GetStartParam();
				ep       = pCamPath->GetEndParam  ();
				camparam = (ep - sp) - camparam;
			}
		}
		if( pPathFollowInfo!=NULL ){
			pPathFollowInfo->ResetOldDir();
		}
	}
	
	param   = pPathInfo->GetParam();
	pathdir = pPathInfo->GetDir();
	if( rev==true ){
		pathno  ^= 1;
		pathdir ^= 1;
	}
	pPathInfo->GetPosition     (&oldplpos);
	pPathInfo->GetDeltaPosition(&oldpldir);
	sprintf(pathname,ppathname,next,pathno);
	pPath = pStagePath->GetPath(pathname);
	
	if( pPath!=NULL ){
		if( rev==true ){
			sp    = pPath->GetStartParam();
			ep    = pPath->GetEndParam  ();
			param = (ep - sp) - param;
		}
		WK7Stage::SetCurrentPath(pPath,param,pathdir);
		pPathInfo->GetPosition     (&curplpos);
		pPathInfo->GetDeltaPosition(&curpldir);
	}else{
		curplpos.x = 
		curplpos.y = 
		curplpos.z = 0.0f;
		curpldir.x = 
		curpldir.y = 0.0f;
		curpldir.z = 1.0f;
	}
	
	if( pPathFollowInfo!=NULL && pCamPath!=NULL ){
		
		Mtx		mtx,invmtx;
		
		pPathFollowInfo->GetPosition      (campos);
		pPathFollowInfo->GetTargetPosition(camtgt);
		
		_MAKEMTX(oldplpos,oldpldir,mtx);
		MTXInverse(mtx,invmtx);
		MTXMultVec(invmtx,&campos,&campos);
		MTXMultVec(invmtx,&camtgt,&camtgt);
		
		pPathFollowInfo->SetCurrentPath(pCamPath,camparam,campathdir);
		pPathFollowInfo->SetCamPosReset(false);
		
		_MAKEMTX(curplpos,curpldir,mtx);
		MTXMultVec(mtx,&campos,&campos);
		MTXMultVec(mtx,&camtgt,&camtgt);
		
		pPathFollowInfo->SetPosition      (campos);
		pPathFollowInfo->SetTargetPosition(camtgt);
		if( rev==true ){
			pPathFollowInfo->ReversePosLR();
		}
		pPathFollowInfo->SetPos(WK7CamPathFollowInfo::RENEW_IM);
//		pPathFollowInfo->SetPos(WK7CamPathFollowInfo::RENEW_SLOW);
		
		WK7PLAYERCONTROL->RestorePathPosition();
		
	}
	
	return false;
}

bool K7Stage412M00::PathTurnCallBack(WK7PathTurnInfo &info)
{
#pragma	unused(info)
	SetVol(mRight);
	return true;
}

bool K7Stage412M00::BpArriveCallBack(WK7BpInfo &info)
{
	u32	evno = GetBpEventNo(info);
	if( evno==0xffffffff ){
		return true;
	}
	switch( evno ){
	case	K7EVENTNO(040520):
	case	K7EVENTNO(040521):
	case	K7EVENTNO(040522):
	case	K7EVENTNO(040523):
	case	K7EVENTNO(040524):
		if( evno==GetRightEventNo() ){
			SetVol(true);
		}
		break;
	}
	return true;
}

bool K7Stage412M00::BpLeaveCallBack(WK7BpInfo &info)
{
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN_CLEAR)==TRUE ){
		return true;
	}
	u32	evno = GetBpEventNo(info);
	if( evno==0xffffffff ){
		return true;
	}
	int	pathno = GetBpPathNo(info);
	switch( evno ){
	case	K7EVENTNO(040520):
	case	K7EVENTNO(040521):
	case	K7EVENTNO(040522):
	case	K7EVENTNO(040523):
	case	K7EVENTNO(040524):
		if( pathno < 0 ){
			mRight = false;
		}else{
			mRight = true;
		}
		SetVol(mRight);
		if( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)==2 ){
//		if( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)==4 ){
			K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP)++;
			K7SCR_SET_SCENARIO_FLAG(K7SCN04_EVFL_ILLUSION_TOWN);
			K7SCR_EVCONDCHANGE();
		}
		break;
	default:
		break;
	}
	if( pathno < 0 ){
		return true;
	}
	switch( evno ){
	case	K7EVENTNO(040500):
	case	K7EVENTNO(040501): return MainStreetProc(evno,pathno);
	case	K7EVENTNO(040510):
	case	K7EVENTNO(040511):
	case	K7EVENTNO(040512):
	case	K7EVENTNO(040513):
	case	K7EVENTNO(040514): return SideGateProc(evno,pathno);
	default:
		break;
	}
	return true;
}

bool K7Stage412M00::SetVol(bool right)
{
	u32		rate;
	switch( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) ){
	case	0: rate=0; break;
	case	1: rate=1; break;
	case	2:
	case	3: rate=2; break;
	default:   rate=0; break;
	}
	if( right==true ){
		rate++;
	}
	if( rate > 2 ){
		rate = 2;
	}
	mVol = K7STAGE412M00_SE_VOLBASE * SOUND_EVENT_SE_VOLUME * rate / 2; 
	return true;
}

#if 0
bool K7Stage412M00::SetVolPan(void)
{
	u32		maxvol,minvol;
	switch( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) ){
	case	0: maxvol = SOUND_EVENT_SE_VOLUME *  33 / 100; minvol = SOUND_EVENT_SE_VOLUME *   0 / 100; break;
	case	1: maxvol = SOUND_EVENT_SE_VOLUME *  67 / 100; minvol = SOUND_EVENT_SE_VOLUME *  33 / 100; break;
	default:   maxvol = SOUND_EVENT_SE_VOLUME * 100 / 100; minvol = SOUND_EVENT_SE_VOLUME *  67 / 100; break;
//	case	0: maxvol = SOUND_EVENT_SE_VOLUME *  20 / 100; minvol = SOUND_EVENT_SE_VOLUME *   0 / 100; break;
//	case	1: maxvol = SOUND_EVENT_SE_VOLUME *  40 / 100; minvol = SOUND_EVENT_SE_VOLUME *  20 / 100; break;
//	case	2: maxvol = SOUND_EVENT_SE_VOLUME *  60 / 100; minvol = SOUND_EVENT_SE_VOLUME *  40 / 100; break;
//	case	3: maxvol = SOUND_EVENT_SE_VOLUME *  80 / 100; minvol = SOUND_EVENT_SE_VOLUME *  60 / 100; break;
//	default:   maxvol = SOUND_EVENT_SE_VOLUME * 100 / 100; minvol = SOUND_EVENT_SE_VOLUME *  80 / 100; break;
	}
//	K7Stage412M00_Singer::SetVolRange(maxvol,minvol); 
	return true;
}
#endif

u32 K7Stage412M00::GetRightEventNo(void)
{
	int		posid;
	if( (posid=GetRightPosID()) < 0 ){
		return 0xffffffff;
	}
	return (u32)(K7EVENTNO(040520) + posid);
}

int K7Stage412M00::GetRightPosID(void)
{
	switch( K7EVENT_SCN_VAR(K7SCN04,EVVA_ILLUSION_LOOP) ){
	case	0: return 2;
	case	1: return 0;
//	case	0: return 3;
//	case	1: return 1;
//	case	2: return 1;
//	case	3: return 0;
	default:
		break;
	}
	return -1;
}

#if 0
bool K7Stage412M00::GetRightPos(Vec &pos)
{
static	Vec	rightPos[] = {
	{-17.289f, 12.986f, 336.317f },
	{183.670f, 12.986f, 57.296f  },
	{-197.643f, 12.986f, 210.675f},		//	{-282.210f, 12.986f, 119.659f},
	{-12.715f, 12.986f, -64.465f },
	{-28.758f, 13.500f, -456.136f},
};
	int		posid;
	if( (posid=GetRightPosID()) < 0 ){
		pos = rightPos[4];
	}else{
		pos = rightPos[GetRightPosID()];
	}
	return true;
}
#endif

#define	K7STAGE412M00_SE_FADESPEED		(u32)(4 * K7STAGE412M00_SE_VOLBASE * 30 / WK7_FRAME_RATE)
//static	f32		se_spd  = 1.0f;
//static	Vec		se_dpos = { 0.0f,0.0f,-597.0f };
bool K7Stage412M00::SetCurrentCallBack(void)
{
//	K7Stage412M00_Singer	*pSinger[2] = {NULL,NULL};
//	Vec		pos[2];
//	int		i;
	u32		cvol = 0;
	int		seid;
	SetCurrentCallBackDefaultProc();
//	for(i=0 ; i<2 ; i++){
//		if( (pSinger[i] = new K7Stage412M00_Singer(WK7EVENTCONTROLLER->GetFrameProcessTaskController()))!=NULL ){
//			pSinger[i]->Start();
//		}
//	}
	seid = gpSound->mPlaySE(SFX_SCE4_SINGER,(u8)cvol,SOUND_PAN_CENTER);
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
//		SetVolPan();
//		GetRightPos(pos[0]);
//		VECAdd(&pos[0],&se_dpos,&pos[1]);
//		for(i=0 ; i<2 ; i++){
//			if( pSinger[i]==NULL ){
//				continue;
//			}
//			pSinger[i]->SetPos(pos[i]);
//		}
		if( cvol < mVol ){
			if( cvol < mVol - K7STAGE412M00_SE_FADESPEED ){
				cvol += K7STAGE412M00_SE_FADESPEED;
			}else{
				cvol  = mVol;
			}
		}else if( cvol > mVol ){
			if( cvol > mVol + K7STAGE412M00_SE_FADESPEED ){
				cvol -= K7STAGE412M00_SE_FADESPEED;
			}else{
				cvol  = mVol;
			}
		}
		if( seid >= 0 ){
			gpSound->mSetVolumeSENo(seid,(u8)(cvol / K7STAGE412M00_SE_VOLBASE),1);
		}
		K7SCR_RETSYS();
	}
	if( seid >= 0 ){
		for( ; cvol > K7STAGE412M00_SE_FADESPEED ; cvol-=K7STAGE412M00_SE_FADESPEED){
			gpSound->mSetVolumeSENo(seid,(u8)(cvol / K7STAGE412M00_SE_VOLBASE),1);
			K7SCR_RETSYS();
		}
	}
	if( seid >= 0 ){
		gpSound->mStopSENo(seid);
	}
//	// pSinger̃̓^XNŎ폜
//	for(i=0 ; i<2 ; i++){
//		pSinger[i]->Stop();
//	}
	return false;
}

bool K7Stage412M00::CharaChangeCallBack(WK7CharaChangeInfo &info)
{
#pragma	unused(info)
	K7SCR_EVCONDCHANGE();
	return true;
}

#if 0
u32		K7Stage412M00_Singer::mMaxVol = 0;
u32		K7Stage412M00_Singer::mMinVol = 0;
K7Stage412M00_Singer::K7Stage412M00_Singer(ghmGcTaskController *pTaskController)
{
	mSeID   = -1;
	mPan    = SOUND_PAN_CENTER * K7STAGE412M00_SE_PANBASE;
	mVol    = 0;
	mProc   = 0;
	mTaskID = -1;
	GHM_VEC_SET_XYZ(&mPos,0.0f,0.0f,0.0f);
	if( (mpTaskController=pTaskController)!=NULL ){
		mTaskID = pTaskController->Start(SingerTask,SingerTaskTerm,(u32)this,0UL);
	}
}

K7Stage412M00_Singer::~K7Stage412M00_Singer()
{
//	if( mpTaskController!=NULL && mTaskID >= 0 ){
//		mpTaskController->Stop(mTaskID);
//	}
	if( mSeID >= 0 ){
		gpSound->mStopSENo(mSeID);
		mSeID  = -1;
	}
}

bool K7Stage412M00_Singer::Start(void)
{
	if( mProc!=0 ){
		return false;
	}
	mProc = 1;
	return true;
}

bool K7Stage412M00_Singer::Stop(void)
{
	mProc = 32;
	return true;
}

bool K7Stage412M00_Singer::SetPos(const Vec &pos)
{
	mPos = pos;
	return true;
}

#define	K7STAGE412M00_SE_FADESPEED		(u32)(2 * K7STAGE412M00_SE_VOLBASE * 30 / WK7_FRAME_RATE)
#define	K7STAGE412M00_SE_PANSPEED		(u32)(2 * K7STAGE412M00_SE_PANBASE * 30 / WK7_FRAME_RATE)
bool K7Stage412M00_Singer::FrameProcess(void)
{
	switch( mProc ){
	case	0:
		break;
	case	1:
		if( (mSeID = gpSound->mPlaySE(SFX_SCE4_SINGER,0,SOUND_PAN_CENTER)) >= 0 ){
			mProc = 16;
			mVol  = 0;
			mPan  = 0;
		}
		break;
	case	16:{
//		u8		vol8,pan8;
//		u32		vol,pan;
//		seVolCalc2(mPos,
//		           (u8)(mMaxVol / K7STAGE412M00_SE_VOLBASE),
//		           (u8)(mMinVol / K7STAGE412M00_SE_VOLBASE),
//		           &vol8,
//		           &pan8,
//		           400.0f,
//		           200.0f);
//		vol = (u32)vol8 * K7STAGE412M00_SE_VOLBASE;
//		pan = (u32)pan8 * K7STAGE412M00_SE_PANBASE;
		u32		vol = mMaxVol / K7STAGE412M00_SE_VOLBASE;
		if( mVol + K7STAGE412M00_SE_FADESPEED < vol ){
			mVol += K7STAGE412M00_SE_FADESPEED;
		}else if( mVol > vol + K7STAGE412M00_SE_FADESPEED ){
			mVol -= K7STAGE412M00_SE_FADESPEED;
		}else{
			mVol  = vol;
		}
//		if( mPan + K7STAGE412M00_SE_PANSPEED < pan ){
//			mPan += K7STAGE412M00_SE_PANSPEED;
//		}else if( mPan > pan + K7STAGE412M00_SE_PANSPEED ){
//			mPan -= K7STAGE412M00_SE_PANSPEED;
//		}else{
//			mPan  = pan;
//		}
		}break;
	case	32:
		if( mVol >= K7STAGE412M00_SE_FADESPEED ){
			mVol -= K7STAGE412M00_SE_FADESPEED;
			break;
		}
		mProc++;
	case	33:
		if( mSeID >= 0 ){
			gpSound->mStopSENo(mSeID);
			mSeID  = -1;
		}
	default:
		return false;
	}
	if( mSeID >= 0 ){
		gpSound->mSetVolumeSENo(mSeID,(u8)(mVol / K7STAGE412M00_SE_VOLBASE ),1);
//		gpSound->mSetPanSENo   (mSeID,(u8)(mPan / K7STAGE412M00_SE_PANSPEED));
	}
	u8		bgmvol = (u8)(K7STAGE412M00_VOLUME_MUSIC * (SOUND_EVENT_SE_VOLUME - (mVol / K7STAGE412M00_SE_VOLBASE)) / SOUND_EVENT_SE_VOLUME);
	gpSound->mFadeVolumeStream(bgmvol,1);
	return true;
}

void K7Stage412M00_Singer::SingerTask(ghmGcTask *)
{
	K7Stage412M00_Singer		*pSinger = (K7Stage412M00_Singer *)GHMGCTASK_GETPARAM(0);
	while( pSinger->FrameProcess()==true ){
		K7SCR_RETSYS();
	}
}

void K7Stage412M00_Singer::SingerTaskTerm(ghmGcTask *)
{
	K7Stage412M00_Singer		*pSinger = (K7Stage412M00_Singer *)GHMGCTASK_GETPARAM(0);
	GHM_SAFE_DELETE(pSinger);
}
#endif

