////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage430M00 yj[[Nzu[hEFC
//
// K7Stage430M00.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE430M00_H__
#define	__K7STAGE430M00_H__

#include "..\K7Stage.h"
#include "..\..\..\sato\SK7ScenarioEnd.h"

#include "..\..\..\fujita\c_state.h"

#include "..\..\..\Matsu\MK7Jimaku.h"
#include "..\..\..\Wat\WK7Sprite.h"

class K7Stage430M00_PanelTile{
protected:
	stTexture					*mpTex;
	int							mTexNum;
	int							mTexID;
	int							mProc;
	int							mInitWait;
	mK7Sprite					mSprite;
public:
	K7Stage430M00_PanelTile();
	~K7Stage430M00_PanelTile();
	
	bool Init();
	bool Release();
	
	bool SetInitWait(int wait);
	bool StartAnim(void);
	bool StopAnim(void);
	bool FrameProcess(void);
	bool SetTexture(void **ppTex);
	bool SetTexture(void *pTex);
	bool SetTexture(int index,void *pTex);
	bool SetXY(s16 x,s16 y);
	bool SetRGBA(u32 rgb0,u32 rgb1);
	bool GetRGBA(u32 *rgb0,u32 *rgb1);
	bool SetFade(u8 a,s32 tick);
	bool SetDispFlag(bool flag);
	bool SetAddMode(bool flag);
	bool SetScale(enScaleDir dir,f32 scale,s32 tick);
	u32 GetA(void);
	short GetW(void);
};

class K7Stage430M00_PanelTileGrad{
protected:
	K7Stage430M00_PanelTile		mTileGrad;
	K7Stage430M00_PanelTile		mTileEdge;
public:
	K7Stage430M00_PanelTileGrad();
	~K7Stage430M00_PanelTileGrad();
	
	bool Init();
	bool Release();
	
	bool FrameProcess(void);
	bool SetTexture(void *pTex0,void *pTex1);
	bool SetXY(s16 x,s16 y);
	bool SetRGBA(u32 rgb0,u32 rgb1);
	bool GetRGBA(u32 *rgb0,u32 *rgb1);
	bool SetFade(u8 a,s32 tick);
	bool SetDispFlag(bool flag);
	bool SetAddMode(bool flag);
	bool SetScale(enScaleDir dir,f32 scale,s32 tick);
	u32 GetA(void);
};

class K7Stage430M00_PanelFont{
protected:
	stTexture					mTex;
	mK7Sprite					*mpSprite;
	int							mSpriteNum;
	stJimaku					*mpSentence;
	stFontParam					*mpFontParam;
	
	bool RelateTex(void);
public:
	K7Stage430M00_PanelFont();
	~K7Stage430M00_PanelFont();
	
	bool Init();
	bool Release();
	
	bool FrameProcess(void);
	bool SetSentence(stJimaku *pSentence,stFontParam *pFontParam);
	bool SetTexture(void *pTex);
	bool SetXY(s16 x,s16 y);
	bool SetCXY(s16 cx,s16 y);
	f32 GetX(void);
	f32 GetY(void);
	u32 GetW(void);
	u32 GetH(void);
	bool SetRGBA(u32 rgb0,u32 rgb1);
	bool GetRGBA(u32 *rgb0,u32 *rgb1);
	bool SetFade(u8 a,s32 tick);
	bool SetDispFlag(bool flag);
	bool SetAddMode(bool flag);
	bool SetScale(enScaleDir dir,f32 scale,s32 tick);
};

#define	K7STAGE430M00_PANEL_STARTTILE_NUM		(6)
class K7Stage430M00_Panel{
public:
	enum{
		IDLE = 0,
		LOADING,
		LOADED,
	};
protected:
	stSentence						*mpFontData;
	stFontParam						*mpFontParam;
	ghmGcFile						*mpFile;
	int								mState;
	int								mProc;
	int								mMode;
	int								mWaitFlag;
	void							*mpLoadData;
	ghmGcResLink					*mpResource;
	int								mCounter;
	WK7AnimLinearF					mScale;
	int								mScaleIndex;
	WK7AnimLinear					mGameTileRGB[2][3];
	
	int								mMatchID;
	K7Stage430M00_PanelTile			mInadumaTile[3];
	K7Stage430M00_PanelTileGrad		mGameTile;
	K7Stage430M00_PanelTileGrad		mStartTile[K7STAGE430M00_PANEL_STARTTILE_NUM];
	K7Stage430M00_PanelTileGrad		mVsTile;
	K7Stage430M00_PanelTileGrad		mWinTile;
	K7Stage430M00_PanelTileGrad		mLoseTile;
	K7Stage430M00_PanelTileGrad		mKiller7Tile;
	K7Stage430M00_PanelTileGrad		mHandsomeManTile;
	K7Stage430M00_PanelFont			*mpKiller7Name;
	int								mKiller7NameNum;
	K7Stage430M00_PanelFont			*mpHandsomeManName;
	int								mHandsomeManNameNum;
	K7Stage430M00_PanelFont			mWinNum[2];
	K7Stage430M00_PanelFont			mWinStr[2];
	
	bool AllHide(void);
	bool Initialize(void);
	bool SetMatchTexture(int match);
	bool SetWinSentence(int side,int num);
	bool SetOpeningDispName(int tick,bool disp);
	bool SetEndDispName(void);
public:
	K7Stage430M00_Panel();
	~K7Stage430M00_Panel();
	
	bool Init();
	bool Release();
	
	bool Load(void);
	bool IsLoading(void);
	bool FrameProcess(void);
	
	bool OpeningStart(int match);
	bool WaitingOpening(void);
	bool OpeningRestart(void);
	bool EndingStart(int match);
	bool IsOver(void);
	bool Win(void);
};


class K7Stage430M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage430M00();
	K7Stage430M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
//	SK7ScenarioEnd				mScnEnd;
	K7Stage430M00_Panel			mPanel;
	C_State						state;
	u16							mBackupBloodGauge;
	s8							mEnemyGunDataID[2];
	bool						mStageInit;
	bool						mFrameCountTrigger;
	int							mFrameCount;
	
	enum {
		ROUND_MAX = 8,
		PROLOGUE = 0,
		
		//n[}ƐԁB
		ENCOUNTER_HAY2RED,
		FIGHTING_HAY2RED,
		ENDING_HAY2RED,
		
		//RƔB
		ENCOUNTER_CAT2WHITE,
		FIGHTING_CAT2WHITE,
		ENDING_CAT2WHITE,
		
		//R[eƋB
		ENCOUNTER_COY2GOLD,
		FIGHTING_COY2GOLD,
		ENDING_COY2GOLD,
		
		//JGfƒB
		ENCOUNTER_KED2BROWN,
		FIGHTING_KED2BROWN,
		ENDING_KED2BROWN,
		
		//PBƃfbhB
		ENCOUNTER_KVN2DEAD,
		FIGHTING_KVN2DEAD,
		ENDING_KVN2DEAD,
		
		//_ƐB
		ENCOUNTER_DAN2BLUE,
		FIGHTING_DAN2BLUE,
		ENDING_DAN2BLUE,
		
		//}XNƎB
		ENCOUNTER_MSK2PURPLE,
		FIGHTING_MSK2PURPLE,
		FIGHTING_FINALMSK2PURPLE,
		ENDING_MSK2PURPLE,
		
		//KVAƃsNB
		ENCOUNTER_GAL2PINK,
		FIGHTING_GAL2PINK,
		ENDING_GAL2PINK,
	};
	
	void CreateHandsomeMan(u32 charaid);
	void ReleaseHandsomeMan(void);
	
	void ChangeMskToFinal(void);
	void ChangeChr(u32 charaid);
	void EndMatch(u32 charaid);
	virtual bool LoadAfterInit3(void);
	virtual bool IsLoadingAfterInit3(void);
public:
	virtual ~K7Stage430M00();
	
	virtual bool RenderProcess(void);
	virtual bool FrameProcess(void);
	virtual bool CreateCallBack    (void);					//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
	virtual bool InitializeCallBack(void);					//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
//	virtual bool CondChangeCallBack(void);					//ԕύXitOɂԕύX邽߂ɗpj
//	virtual bool TerminateCallBack (void);					//Iȉj
	virtual bool SetCurrentCallBack(void);					//JgXe[Wɐݒ莞
//	virtual bool EventCallBack     (WK7EventInfo     &);	//Cxg
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);	//hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &);	//L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &);	//}bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &);	//Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &);	//_o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &);	//_
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);	//mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &);	//qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &);	//XyVA^bNgp
//	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);	//XyVAreBgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &);	//erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &);	//erCxgiZ[u|Cgj

};

#ifdef __K7STAGE430M00_CPP__


enum K7STAGE430M00_ONESHOTCAM{
	OPENING_CAM,
};

K7StageEventOneShotCamera K7Stage430M00_Camera[] = {
//	{{74.816f, 10.032f, 1728.820f},{97.456f, 4.616f, 1729.710f}},
	{{63.482f, 14.727f, 461.355f},{81.302f, 10.272f, 446.305f}},
};

#endif

#endif	//__K7STAGE430M00_H__

