////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage511M00
//
// K7Stage511M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE511M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage511M00.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

K7Stage511M00::K7Stage511M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelElev(pAnchor,prio)
{
	mElevDoorEventNo = K7EVENTDOOR(051101);
	mElevCamID       = ELEVCAM;
	mElevPlayerPosID = ELEVPLAYER;
	SetOneShotCamLocTbl(K7Stage511M00_Camera);
}

K7Stage511M00::~K7Stage511M00()
{
}

bool K7Stage511M00::CreateCallBack(void)
{
	bool	result;
	CreateMotion();
	result = K7StageHotelBase::CreateCallBack();
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return result;
}

bool K7Stage511M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage511M00::InitializeCallBack(void)
{
	SetManualBranch(true);
	InitElevEvent();
	return true;
}

bool K7Stage511M00::SetCurrentCallBack(void)
{
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		SetZanEventEnable(K7EVENTZAN(051121),false);
	}
	
	if( mStageInit==true ){
		SetManualBranch(false);
		return true;
	}
	
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	switch( GetPrevStageID() ){
	case	K7STGID(510,0):
	case	K7STGID(512,0):
	case	K7STGID(513,0):
	case	K7STGID(514,0):
	case	K7STGID(515,0):
	case	K7STGID(516,0):
	case	K7STGID(517,0):
		StartElevEvent();
		return true;
	case	K7STGID(511,0):
		break;
	case	K7STGID(120,0):
	default:
		K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("Front","curve3",0.717f,WK7PATHINFO_INITDIR_TGTDIR_REV);
//		K7SCR_STG_SET_CURRENT_PATH_TOBP("Front","curve2");
		break;
	}
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	
	WK7StagePlaceInfo		*pPlaceInfo;
	pPlaceInfo = GetPlaceInfo(mID,"Front");
	SetCameraStartPosition(pPlaceInfo);
	SandRelease(pPlaceInfo);																// mCYJiXe[Wj
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	mStageInit = true;
	SetManualBranch(false);
	
	K7SCR_EVCONDCHANGE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}

bool K7Stage511M00::CondChangeCallBack(void)
{
	if( mStageInit==false ){
		return true;
	}
	InitPath();
	bool	tamaevflag;
	bool	evKevin;
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		OpenElevDoor(true);
		evKevin = false;
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051101)==FALSE ){
			SimpleModelDisp("event_051101_ked");
			tamaevflag  = false;
		}else if( K7SCR_EVHASITEM(K7EVITEM_TAMA(051101))==FALSE ){
			SimpleModelHide("event_051101_ked");
			tamaevflag  = true;
		}else{
			SimpleModelHide("event_051101_ked");
			tamaevflag  = false;
		}
	}else{
		tamaevflag  = false;
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090102))==true ){
			K7SCR_SET_SCENARIO_FLAG( K7SCN05_CGFL_051100 );
			OpenElevDoor(true);
			evKevin = false;
		}else{
			CloseElevDoor(true);
			evKevin = true;
		}
	}
	K7SCR_EVNO_SETENABLE(K7EVENTNO  (050102),evKevin);
	K7SCR_EVNO_SETENABLE(K7EVENTTAMA(051101),tamaevflag);
	SetVisibleJObj("tama_051101",!K7SCR_EVHASITEM(K7EVITEM_TAMA(051101)),false,true);
	SetVisibleJObj("Bloodstain",GameInfo.GetScenarioFlow()==K7SCNF_HT2,false,true);
	RenewTamaEffect(K7EVENTTAMA(051101));
	return true;
}


bool K7Stage511M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(051101):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051101)==TRUE ){
			return true;
		}
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

bool K7Stage511M00::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
	switch( info.mAbilityID ){
	case	PC_SPA_BLOODY_SHOWER:
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051101)==TRUE ){
			WK7PLAYERCONTROL->SetSpAbilityCancel(true);
			return false;
		}else{
			WK7PlayerSpInfoKed	*pKedInfo = WK7PLAYERCONTROL->GetSpInfoKed();
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051101);
			WK7PLAYERCONTROL->SetSpInfoType(0);
			pKedInfo->mpTargetJObj = GetJObj("event_051101_ked");
			pKedInfo->mKedPos .x =   99.863f;
			pKedInfo->mKedPos .y =    0.0f;
			pKedInfo->mKedPos .z = - 93.755f;
			pKedInfo->mKedRotY   = HALF_PI;
			pKedInfo->mZanPos .x =  103.644f;
			pKedInfo->mZanPos .y =    0.0f;
			pKedInfo->mZanPos .z = -103.474f;
			pKedInfo->mZanRotY   =    0.0f;
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_MOTSTART     ){
				K7SCR_RETSYS();
			}
			FixCam(EVENT_051101_1);
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_ZANAPPEAR    ){
				K7SCR_RETSYS();
			}
			FixCam(EVENT_051101_2);
			WK7CAM->StartLinearInterpolateOnLinearPath(mpOneShotCamera[EVENT_051101_3].pos,
			                                           mpOneShotCamera[EVENT_051101_3].tgt,
			                                           90.0f);
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_BREAKOBJ ){
//			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_ZANDISAPPEAR ){
				K7SCR_RETSYS();
			}
			FixCam(EVENT_051101_4);
			while( WK7PLAYERCONTROL->SpAtkEffectEndTest(mID,K7KED)==false ){
				K7SCR_RETSYS();
			}
		}
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage511M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(050102):
		WK7PlayEventInfo	playEventInfo;
		playEventInfo.Initialize();
		playEventInfo.mEventNo = K7EVENTPLAY(05090102);
		PlayEventTask(playEventInfo);
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage511M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(051101):
		if( ElevEvent(info,1) < 0 ){
			return false;
		}
		break;
	default:
		break;
	}
	return true;
}

