////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage512M00
//
// K7Stage512M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE512M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage512M00.h"

// ̐ݒ
#define CORE_NUM	(5)


K7Stage512M00::K7Stage512M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelElev(pAnchor,prio)
{
	mElevDoorEventNo = K7EVENTDOOR(051201);
	mElevCamID       = ELEVCAM;
	mElevPlayerPosID = ELEVPLAYER;
	SetOneShotCamLocTbl(K7Stage512M00_Camera);
}

K7Stage512M00::~K7Stage512M00()
{
}

bool K7Stage512M00::CreateCallBack(void)
{
	CreateMotion();
	return K7StageHotelBase::CreateCallBack();
}

bool K7Stage512M00::InitializeCallBack(void)
{
	InitElevEvent();
	K7SCR_STG_SET_JUNCTION_PASS(K7STGID(513,0),"door_051302");
	return true;
}

bool K7Stage512M00::SetCurrentCallBack(void)
{
	pNpcSu = (K7EnmK *)WK7Npc::Find(ENENO_5_512M00_1);
	
	if ( pNpcSu != NULL ) {
		while( pNpcSu->SetUpTest()==false ){
			K7SCR_RETSYS();
		}
		pNpcSu->HitObjMake(WK7Stage::GetCurrentStage(), CORE_NUM);
	}
	
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_VOLUME);
	}else{
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051201)==TRUE ){
			gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_VOLUME);
		}else{
			gpSound->mPlayStreamEx(HPS_FREEMOVE_A,K7SCR05_HOTEL_VOLUME);
		}
	}
	StartElevEvent();
	return false;
}

bool K7Stage512M00::CondChangeCallBack(void)
{
	if( mStageInit==false ){
		return true;
	}
	InitPath();
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051202),false);
	bool	nestpath;
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		OpenElevDoor(true);
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051201)==FALSE ){
			nestpath = false;
		}else{
			nestpath = true;
		}
	}else{
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090202))==true ){
			OpenElevDoor(true);
		}else{
			CloseElevDoor(true);
		}
		SetZanEventEnable(K7EVENTZAN(051122),false);
		nestpath = true;
	}
	K7SCR_STG_SET_PATHENABLE("Pass_Nest",nestpath);
	return true;
}

bool K7Stage512M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(051201):
//	case	K7EVENTDOOR(051202):
		if( ElevEvent(info,2) < 0 ){
			return false;
		}
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage512M00::DieNpcCallBack(WK7DieNpcInfo &info)
{
	if( info.mpNpc==NULL ){
		return true;
	}
	switch( info.mpNpc->GetEneNo() ){
	case	ENENO_5_512M00_1:
		K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051201);
		K7SCR_EVCONDCHANGE();
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_VOLUME);
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage512M00::HitObjCallBack(WK7HitObjInfo &info)
{
	if ( pNpcSu != NULL ) {
		if( (info.mEventNo >= pNpcSu->GetHitObjID()) && (info.mEventNo < (pNpcSu->GetHitObjID()+CORE_NUM) ) ){
			if ( false == pNpcSu->CoreHit((int )info.mEventNo, info.mTypeID, info.mHitPos) ) {
				// RAj󂵂ĂȂ
				// qbgIuWF𕜊
//				info.mpHitObj->SetEnable(true);
				info.SetHitObjEnable(true);
			}
			return false;
		}
	}
	return true;
}




