////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage515M00
//
// K7Stage515M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE515M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage515M00.h"

K7Stage515M00::K7Stage515M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelElev(pAnchor,prio)
{
	mElevDoorEventNo = K7EVENTDOOR(051501);
	mElevCamID       = ELEVCAM;
	mElevPlayerPosID = ELEVPLAYER;
	SetOneShotCamLocTbl(K7Stage515M00_Camera);
}

K7Stage515M00::~K7Stage515M00()
{
}

bool K7Stage515M00::CreateCallBack(void)
{
	CreateMotion();
	return K7StageHotelBase::CreateCallBack();
}

bool K7Stage515M00::InitializeCallBack(void)
{
	InitElevEvent();
	K7SCR_STG_SET_JUNCTION_PASS(K7STGID(516,0),"door_051602");
	return true;
}

bool K7Stage515M00::SetCurrentCallBack(void)
{
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_VOLUME);
	}else{
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_VOLUME);
	}
	StartElevEvent();
	return false;
}

bool K7Stage515M00::CondChangeCallBack(void)
{
	if( mStageInit==false ){
		return true;
	}
	InitPath();
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051502),false);
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		OpenElevDoor(true);
	}else{
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090502))==true ){
			OpenElevDoor(true);
		}else{
			CloseElevDoor(true);
		}
	}
	K7SCR_STG_SET_PATHENABLE("curve8" ,false);
	K7SCR_STG_SET_PATHENABLE("curve9" ,false);
	K7SCR_STG_SET_PATHENABLE("curve10",false);
	return true;
}

bool K7Stage515M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(051501):
//	case	K7EVENTDOOR(051502):
		if( ElevEvent(info,5) < 0 ){
			return false;
		}
		break;
	default:
		break;
	}
	return true;
}


