////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage518M00
//
// K7Stage518M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/22/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE518M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage518M00.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Wat\WK7SceneBlur.h"
#include "..\..\..\Yam\YK7MapSelect.h"
#include "..\..\..\sato\SK7ScenarioEnd.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Kaw\KK7Effect.h"

#define	K7STAGE518_CHR_GLY			K7CHRID(K7GLY,0)
#define	K7STAGE518_MOT_GLY(id)		K7MOTID(K7GLY,(id))

K7Stage518M00::K7Stage518M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelElev(pAnchor,prio)
{
//	mStageInit = false;
	mElevDoorEventNo = K7EVENTDOOR(051801);
	mElevCamID       = ELEVCAM;
	mElevPlayerPosID = ELEVPLAYER;
	mpSetAlpha       = NULL;
	SetOneShotCamLocTbl(K7Stage518M00_Camera);
}

K7Stage518M00::~K7Stage518M00()
{
	GHM_SAFE_DELETE(mpSetAlpha);
}

bool K7Stage518M00::CreateCallBack(void)
{
	mpGly = CreateOwnChara(K7STAGE518_CHR_GLY);
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE518_MOT_GLY( 20));
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE518_MOT_GLY(150));
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE518_MOT_GLY(160));
	CreateMotion();
	return K7StageHotelBase::CreateCallBack();
}

bool K7Stage518M00::InitializeCallBack(void)
{
	InitElevEvent();
//	SetManualBranch(true);
	mpGly      = GetOwnChara(K7STAGE518_CHR_GLY);
	mpGlyModel = GetOwnModel(K7OBJTYPE_CHR,K7STAGE518_CHR_GLY);
	mpGlyMotion[K7STAGE518M00_GLY_MOTION_STANDBY ] = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE518_MOT_GLY( 20));
	mpGlyMotion[K7STAGE518M00_GLY_MOTION_DAMAGE_S] = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE518_MOT_GLY(150));
	mpGlyMotion[K7STAGE518M00_GLY_MOTION_DAMAGE_L] = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE518_MOT_GLY(160));
	
	if( mpGly!=NULL && mpGlyModel!=NULL ){
		WK7JObj		*pJObj;
//		mpGly->SetPosition(79.720f, 0.0f, -249.664f);
//		mpGly->SetPosition(16.234f, 0.0f, -252.612f);
		mpGly->SetPosition(-27.170f, 60.0f, -255.615f);
		mpGly->SetRotY    (-HALF_PI);
//		mpGly->SetRenderFlag(true);
		mpGly->CreatePrivateLight();
		mpGly->SetStageLight(false);
		mpGlyModel->AttachMotion(mpGlyMotion[K7STAGE518M00_GLY_MOTION_STANDBY ]);
		mpGlyModel->PlayMotion();
		mpGlyModel->SetMotionLoop(true);
		if( (pJObj=mpGly->GetJObj("Root"))!=NULL ){
			SetHitObj(pJObj,0);
		}
		if( (pJObj=mpGly->GetJObj("HIT_Obj00"))!=NULL ){
			if( (mpSetAlpha = new C_SetAlpha(pJObj->GetJObj(),0.0f,false))!=NULL ){
				mpSetAlpha->SetVal(0.0f,true);
			}
			SetHitObj(pJObj,1);
		}
//		if( (pJObj=mpGly->GetJObj("Chakra_Eye"))!=NULL ){
//			SetHitObj(pJObj,1);
//		}
	}
	
	return true;
}

bool K7Stage518M00::CondChangeCallBack(void)
{
	if( WK7Play::HasPlayed(K7EVENTPLAY(05090803))==true ){
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051802),false);
		if( mpGly!=NULL ){ mpGly->SetRenderFlag(true ); }
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051802),true );
		if( mpGly!=NULL ){ mpGly->SetRenderFlag(false); }
	}
	// Gx[^ɂ͏Ȃ
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051801),false);
	CloseElevDoor(true);
	return true;
}

bool K7Stage518M00::SetCurrentCallBack(void)
{
	SetCurrentCallBackDefaultProc();
	StartElevEvent();
	if( mStageInit==true && WK7PLAYERCONTROL->GetMainID()!=K7GAL ){
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		FixCam( GALCHANGE0 );
		
		K7SCR_TIMEWAIT( 4800 * 2 );
		
		WatchCameraB( K7Stage518M00_Camera[GALCHANGE1].tgt,
					  K7Stage518M00_Camera[GALCHANGE1].pos,
					  K7CHRID(K7GAL,0), 1 );
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
//	if( mStageInit==false ){
//		mStageInit = true;
//		while( WK7Stage::IsChanging()==true ){
//			K7SCR_RETSYS();
//		}
//		K7SCR_ENTER_PLAYMODE_B();
//		K7SCR_ENTER_DEMOPAUSE();
//		K7SCR_PC_SETVISIBLE(false);
//		
//		FixCam(START_GLY0);
//		
//		SandRelease();
//		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//			GHMGCTASK_RETSYS();
//		}
//		
//		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
//		
//		CamMoveToLinearPath(START_GLY1,0.25f);
//		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
//		
//		K7SCR_PC_SETVISIBLE(true);
//		K7SCR_EVCONDCHANGE();
//		K7SCR_EXIT_DEMOPAUSE();
//		K7SCR_EXIT_PLAYMODE();
//	}
//	SetManualBranch(false);
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
		if( mpGlyModel->GetMotionState()==WK7MODEL_NOANIM ){
			mpGlyModel->AttachMotion(mpGlyMotion[K7STAGE518M00_GLY_MOTION_STANDBY ]);
			mpGlyModel->PlayMotion(0.0f,true,4.0f);
			mpGlyModel->SetMotionLoop(true);
		}
		K7SCR_RETSYS();
	}
	return false;
}

bool K7Stage518M00::HitObjCallBack(WK7HitObjInfo &info)
{
	info.SetHitObjEnable(true);
//	if( info.mpHitObj!=NULL ){
//		info.mpHitObj->SetEnable(true);
//	}
	switch( info.mEventNo ){
	case	0:
		// ̂Ƀqbg
//		K7AppDebugPrint("Hit Body !!");
		mpGlyModel->AttachMotion(mpGlyMotion[K7STAGE518M00_GLY_MOTION_DAMAGE_S]);
		mpGlyModel->PlayMotion(0.0f,true,4.0f);
		mpGlyModel->SetMotionLoop(false);
		return false;
	case	1:{
		// `NɃqbg
//		K7AppDebugPrint("Hit Chakra !!");
		
		KK7BattleMainTask::BattleMainTaskExit(1);
		
		// ̃GtFNgo
		KK7BattleEffectCharaTypeBloodStart( info.mHitPos, K7DAN );
		
		mpGlyModel->AttachMotion(mpGlyMotion[K7STAGE518M00_GLY_MOTION_DAMAGE_L]);
		mpGlyModel->PlayMotion(0.0f,true,4.0f);
		mpGlyModel->SetMotionLoop(false);
//		K7SCR_RETSYS();
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		while( mpGlyModel->GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		
		WK7Play		*pPlay;
		u32			playno;
		
		gpSound->mFadeVolumeStream(0,100);
//		gpSound->mStopStream();
		
		WK7Play::SetSkipCancel(true);
		playno = K7EVENTPLAY(05500101);
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			K7SCR_RETSYS();
		}
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.5f));
		
		WK7Chara::SetRenderChara(false);
		WK7Stage::SetRenderStage(false);
		WK7Item::SetRenderItem  (false);
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		
		WK7Play::StorePlayTB();
		WK7PLAYERCONTROL->SetOperateEnable(false);
		WK7PLAYERCONTROL->Reset();
		WK7PLAYERCONTROL->ReleaseAll();
//		WK7PLAYERCONTROL->ReleaseArchive();
		WK7Stage::DeleteStage(this);
//		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
//			K7SCR_RETSYS();
//		}
		
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		
//		SK7ScenarioEnd	scnEnd;
		
		K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(059000),0);
		SceneBlur.SetVisible(false);
		GameInfo.SetPanelNoiseCancel(true);
		GameInfo.SetPanelReleaseCancel(true);
//		GameInfo.SetPanelCtrlOffWait(true);
		GameInfo.SetPanelInitHideWait(true);
		K7SCR_PANEL_START();
		K7SCR_RETSYS();
		K7SCR_PANEL_INITWAIT();
//		scnEnd.LoadDataB();
		
		WK7Play::SetDontStopStream(true);
		while( (pPlay=WK7Play::Create(playno))==NULL ){
			K7SCR_RETSYS();
		}
		pPlay->Prepare();
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
		
		while( pPlay->GetState()!=WK7Play::PREPARED ){
			K7SCR_RETSYS();
		}
		pPlay->Start();
		K7SCR_RETSYS();
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		
//		WK7Play::SetTermCaptureRenderOn(true);
		while( pPlay->GetState()!=WK7Play::PLAYED ){
			K7SCR_RETSYS();
		}
//		pPlay->SetVisibleAll(false);
		WK7Play::PlayReleaseAll();
		WK7Play::SetPlayed(playno,true);
		K7SCR_RETSYS();
		WK7Play::RestorePlayTB();
		WK7CAM->SetCinemaScopeMode(false);
		
//		scnEnd.FrameProcess();
		k7app.FadeStart(0,0);
//		K7SCR_RETSYS();
//		scnEnd.Release();
		
		GameInfo.SetPanelInitHideWait(false);
//		GameInfo.SetPanelCtrlOffWait(false);
		GameInfo.SetPanelTermHideWait(true);
		K7SCR_PANEL_TERMWAIT();
		GameInfo.SetPanelTermHideWait(false);
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_PANEL_EXITWAIT();
//		WK7Play::SetInitCaptureRenderOff(true);
//		WK7Play::SetTermCaptureRenderOn(false);
//		playno = K7EVENTPLAY(05090902);
//		while( (pPlay=WK7Play::Create(playno))==NULL ){
//			K7SCR_RETSYS();
//		}
//		pPlay->Prepare();
//		while( pPlay->GetState()!=WK7Play::PREPARED ){
//			K7SCR_RETSYS();
//		}
////		scnEnd.LoadData();
//		pPlay->Start();
//		while( pPlay->GetState()!=WK7Play::PLAYED ){
//			K7SCR_RETSYS();
//		}
//		WK7Play::SetInitCaptureRenderOff(false);
//		
//		pPlay->SetVisibleAll(false);
//		WK7Play::PlayReleaseAll();
//		K7SCR_RETSYS();
//		K7SCR_RETSYS();
//		WK7Play::RestorePlayTB();
		
//		K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(059000),0);
//		K7SCR_PANEL_START();
//		K7SCR_PANEL_TERMWAIT();
//		K7SCR_RETSYS();
//		K7SCR_PANEL_EXIT();
//		K7SCR_PANEL_EXITWAIT();
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
		
//		WK7Chara::SetRenderChara(true);
//		WK7Stage::SetRenderStage(true);
//		WK7Item::SetRenderItem  (true);
		WK7Play::SetSkipCancel    (false);
		WK7Play::SetDontStopStream(false);
		
		GameInfo.SetMode     (WK7GameInfo::TERM           );
		GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
		
#if 0
		// }bvړ
		gpSound->mStopStream();
		K7SCR_NOISE_RELEASE_TO_MAP();
		GameInfo.MapSelectInit(MAP_HOTEL,MAP_GAL_HOME);
		while( GameInfo.CheckMapSelectEnd()==false ){
			K7SCR_RETSYS();
		}
		GameInfo.MapSelectEnd();
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			K7SCR_RETSYS();
		}
		K7SCR_STG_CREATE_B   (WK7STAGE_GALSTAGEID);
		WK7PLAYERCONTROL->RestoreArchive();
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
		K7SCR_STG_SET_CURRENT(WK7STAGE_GALSTAGEID);
#endif
		
		}return false;
	default:
		break;
	}
	return true;
}

bool K7Stage518M00::BpArriveCallBack(WK7BpInfo &info)
{
#if 1
#pragma	unused(info)
	return true;
#else
	if( info.IsBranchPointName("set2")==false ){
		return true;
	}
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	WK7Play		*pPlay;
	u32			playno = K7EVENTPLAY(05090902);
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
		K7SCR_RETSYS();
	}
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	WK7Play::StorePlayTB();
	WK7PLAYERCONTROL->ReleaseArchive();
	WK7Stage::DeleteStage(this);
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
		K7SCR_RETSYS();
	}
	
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	GameInfo.SetScenarioFlow(K7SCNF_GNK);
	K7SCR_CHANGE_SCENARIO_DATA();
	
	SK7ScenarioEnd	scnEnd;
	
	while( (pPlay=WK7Play::Create(playno))==NULL ){
		K7SCR_RETSYS();
	}
	pPlay->Prepare();
	
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
	
	while( pPlay->GetState()!=WK7Play::PREPARED ){
		K7SCR_RETSYS();
	}
	scnEnd.LoadData();
	pPlay->Start();
	K7SCR_RETSYS();
	while( gpNoise->mSandRelease()==false ){
		K7SCR_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	
	while( pPlay->GetState()!=WK7Play::PLAYED ){
		K7SCR_RETSYS();
	}
	
	pPlay->SetVisibleAll(false);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	GHM_SAFE_DELETE(pPlay);
	WK7Play::RestorePlayTB();
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	scnEnd.FrameProcess();
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
		K7SCR_RETSYS();
	}
	k7app.FadeStart(0,0);
	K7SCR_RETSYS();
	scnEnd.Release();
	
	WK7Play::SetPlayed(playno,true);
	
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
	
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	
	// }bvړ
	gpSound->mStopStream();
	K7SCR_NOISE_RELEASE_TO_MAP();
	GameInfo.MapSelectInit(MAP_HOTEL,MAP_GAL_HOME);
	while( GameInfo.CheckMapSelectEnd()==false ){
		K7SCR_RETSYS();
	}
	GameInfo.MapSelectEnd();
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_CREATE_B   (WK7STAGE_GALSTAGEID);
	WK7PLAYERCONTROL->RestoreArchive();
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT(WK7STAGE_GALSTAGEID);
	
	return false;
#endif
}

bool K7Stage518M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(051802):
		if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			u32		playno = K7EVENTPLAY(05090803);
			WK7Play	*pPlay;
			
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,SFX_SCE5_MAP_CHANGE_DOOR_IRON_OPEN);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			while( (pPlay=WK7Play::Create(playno))==NULL ){
				K7SCR_RETSYS();
			}
			pPlay->Prepare();
			
			WK7Play::StorePlayTB();
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			pPlay->Start();
			K7SCR_RETSYS();
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
				K7SCR_RETSYS();
			}
			pPlay->SetVisibleAll(false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			GHM_SAFE_DELETE(pPlay);
			WK7Play::RestorePlayTB();
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7Play::SetPlayed(playno,true);
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
static		const char		*pBpName = "door_051802";
			WK7StagePlaceInfo*	pPlaceInfo;
			
			K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR(pBpName,"curve1",0.0f,WK7PATHINFO_INITDIR_TGTDIR);
			
			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			pPlaceInfo = GetPlaceInfo(pBpName);
			SetCameraStartPosition(pPlaceInfo);
			while( SandRelease(pPlaceInfo,SFX_SCE5_MAP_CHANGE_DOOR_IRON_CLOSE)==false ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			K7SCR_EVCONDCHANGE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
//			WK7PlayEventInfo	playEventInfo;
//			playEventInfo.Initialize();
//			playEventInfo.mEventNo = K7EVENTPLAY(05090803);
//			PlayEventTask(playEventInfo);
		}
		return false;
	case	K7EVENTDOOR(051803):
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090803))==true && K7SCR_GET_SCENARIO_FLAG(K7SCN05_GLY)==FALSE ){
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_GLY);
			
			WK7Stage::SetMoveModeCancel(true);
			DoorEventTask(info);
			
			gpSound->mPlayStreamEx(HPS_HOTEL_D);
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE(false);
			
			FixCam(START_GLY0);
			
			SandRelease();
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				GHMGCTASK_RETSYS();
			}
			
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
			
			// Y[opSE Y[Jn
			gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOMSTART);
			
//static	f32	sec = 0.25f;
//			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(sec));
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.25f));
			
			CamMoveToLinearPath(START_GLY1,0.25f);
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.25f));
			
			// Y[op SE Y[
			gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOM);
			
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
			
			K7SCR_PC_SETVISIBLE(true);
			K7SCR_EVCONDCHANGE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_EXIT_PLAYMODE();
			
			return false;
		}else{
			gpSound->mPlayStreamEx(HPS_HOTEL_D);
		}
		break;
	case	K7EVENTDOOR(051804):
		gpSound->mFadeVolumeStream(0,100);
		break;
	default:
		break;
	}
	return true;
}

