////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage523M00
//
// K7Stage523M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE523M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage523M00.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Kaw\KK7Sound.h"

K7Stage523M00::K7Stage523M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelBase(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage523M00_Camera);
	mpSpark = NULL;
	mpTamaEffect = NULL;
}

K7Stage523M00::~K7Stage523M00()
{
}

bool K7Stage523M00::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	CreateOwnStageMotion(   1);
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return K7StageHotelBase::CreateCallBack();
}

bool K7Stage523M00::TerminateCallBack(void)
{
	if( mpSpark != NULL )
	{
		DeleteEffect( mpSpark );
		mpSpark = NULL;
	}
	gpSound->mStopSE(SFX_SCE5_HTL_SPARKA);
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return( true );
}

bool K7Stage523M00::InitializeCallBack(void)
{
	WK7JObj		*pJObj;
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT1 ){
		return true;
	}
	if( (pJObj=GetJObj("Uncut"))!=NULL ){
		SetHitObj(pJObj,1);
	}
	return true;
}

bool K7Stage523M00::SetCurrentCallBack(void)
{
	u32		tick = 0;
	
	gpSound->mSetDspRateAll(20);
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_ROOM_VOLUME);
	}else{
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_ROOM_VOLUME);
	}
	
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	Vec		pos;
	s8		subno;
	
	WK7PLAYERPATHCONTROL->GetCurrentPosition(&pos);
	if( pos.z < -250.0f ){
		subno = 0;
	}else{
		subno = 1;
	}
	SetStageMapFlag(subno,true);
	GameInfo.SetMenuMapSubNo(subno);
	// JgR[obNftHg
//	SetCurrentCallBackDefaultProc();
	
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
		
		if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 && K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051301)==FALSE ){
			if( GetMotionState()==WK7MODEL_NOANIM ){
				
				if( tick >= WK7_TICK_PER_FRAME ){
					gpSound->mStopSE(SFX_SCE5_HTL_SPARKA);
					tick -= WK7_TICK_PER_FRAME;
				}else{
					
					DetachMotion();
					PlayMotion(HSD_Rand() & 1,0.0f);
					SetMotionLoop(false);
					
					static	Vec		sparkPos = {-209.274f, 3.337f, -21.808f};
					KK7SoundLoopSePlayVolumeChange(sparkPos,mID,SFX_SCE5_HTL_SPARKA);
					
					if( mpModel!=NULL ){
						tick = (u32)mpModel->GetTotalMotionFrame() * (WK7_TICK_PER_SEC / 60);
					}else{
						tick = 0;
					}
	//				tick += WK7_SEC_TO_TICK(3.0f);
	//				tick += WK7_SEC_TO_TICK(HSD_Randf() * 3.0f);
					tick += WK7_SEC_TO_TICK(0.5f);
					tick += WK7_SEC_TO_TICK(HSD_Randf() * 1.5f);
					
				}
				
			}
		}else{
			gpSound->mStopSE(SFX_SCE5_HTL_SPARKA);
			DetachMotion();
		}
		
		K7SCR_RETSYS();
	}
	
	gpSound->mStopSE(SFX_SCE5_HTL_SPARKA);
	
	return true;
}

bool K7Stage523M00::CondChangeCallBack(void)
{
	bool		tamaevflag,evMask,elec,spark;
	InitPath();
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		evMask = false;
		if( K7SCR_EVHASITEM(K7EVITEM_TAMA(051301))==TRUE ){
			tamaevflag = false;
		}else{
			tamaevflag = true;
		}
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051301)==TRUE ){
			elec = false;
			spark = false;
		}else{
			elec = true;
			spark = true;
		}
		PlayMotion(0,0.0f);
		PlayMotion(1,0.0f);
		SetMotionLoop(false);
	}else{
		elec = true;
		spark = false;
		tamaevflag = false;
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090302))==true ){
			K7SCR_SET_SCENARIO_FLAG( K7SCN05_CGFL_052300 );
			evMask = false;
		}else{
			evMask = true;
		}
		SetZanEventEnable(K7EVENTZAN(051123),false);
	}
	K7SCR_EVNO_SETENABLE(K7EVENTNO  (050301),evMask);
	K7SCR_EVNO_SETENABLE(K7EVENTTAMA(051301),tamaevflag);
	RenewTamaEffect(K7EVENTTAMA(051301));
	SetVisibleTamaJObj(K7EVENTTAMA(051301),!K7SCR_EVHASITEM(K7EVITEM_TAMA(051301)));
	SetVisibleJObj("Cut"  ,!elec,false,true);
	SetVisibleJObj("Uncut", elec,false,true);
	SetVisibleJObj("SPARK01",spark,false,true);
	SetVisibleJObj("SPARK02",spark,false,true);
	SetVisibleJObj("SPARK03",spark,false,true);
	SetVisibleJObj("SPARK06",spark,false,true);
	SetVisibleJObj("SPARK07",spark,false,true);
	SetVisibleJObj("Bloodstain",GameInfo.GetScenarioFlow()==K7SCNF_HT2,false,true);
	if( (GameInfo.GetScenarioFlow() == K7SCNF_HT1)
	 && (K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051301) == false) )
	{
		if( mpSpark == NULL )
		{
			mpSpark = CreateEasyAnimEffect2( ANIMID_SMALLLIGHT,
											 (Vec){ -200.367f, 17.108f, -34.839f },
											 (Vec){ 1.0f, 1.0f, 1.0f },
											 true, -1 );
		}
	}else
	{
		if( mpSpark != NULL )
		{
			DeleteEffect( mpSpark );
			mpSpark = NULL;
		}
	}
	return true;
}

bool K7Stage523M00::HitObjCallBack(WK7HitObjInfo &info)
{
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT1 ){
		return false;
	}
	K7SCR_HITOBJ_SETENABLE(&info,true);
	switch( info.mEventNo ){
	case	1:
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051301)==true ){
			return false;
		}
		K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051301);
		K7SCR_EVCONDCHANGE();
		
		// R[hؒf
		
		KK7BattleMainTask::BattleMainTaskExit(1);
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		FixCam(EVENT_051301);
		K7SCR_STG_MESSAGE_B(K7STAGE523M00_MES_CUT_CODE);
		
		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage523M00::TamaEventCallBack(WK7TamaEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTTAMA(051301):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051301)==FALSE ){
			// dC΂΂
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE(false);
			
			FixCam(TAMA_051301);
			
			K7SCR_STG_MESSAGE_B(K7STAGE523M00_MES_ELECTRIC_SHOCK);
			
			K7SCR_PC_SETVISIBLE(true);
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			return false;
		}
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage523M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(051301):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051301)==TRUE ){
			return true;
		}
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

bool K7Stage523M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(050301):
		WK7PlayEventInfo	playEventInfo;
		playEventInfo.Initialize();
		playEventInfo.mEventNo = K7EVENTPLAY(05090302);
		PlayEventTask(playEventInfo);
		return false;
	default:
		break;
	}
	return true;
}

