////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage525M00
//
// K7Stage525M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE525M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage525M00.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Sato\SK7SpecialData.h"

K7Stage525M00::K7Stage525M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelBase(pAnchor,prio)
{
	mpCandleFireEffect[0] = 
	mpCandleFireEffect[1] = NULL;
	mpSetAlpha[0]         = NULL;
	mpSetAlpha[1]         = NULL;
	SetOneShotCamLocTbl(K7Stage525M00_Camera);
}

K7Stage525M00::~K7Stage525M00()
{
	GHM_SAFE_DELETE(mpSetAlpha[0]);
	GHM_SAFE_DELETE(mpSetAlpha[1]);
}

bool K7Stage525M00::CreateCallBack(void)
{
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage525M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage525M00::InitializeCallBack(void)
{
	HideJObj("burn",false,true);
	return true;
}

bool K7Stage525M00::SetCurrentCallBack(void)
{
//	SetCurrentCallBackDefaultProc();
	gpSound->mSetDspRateAll(20);
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_ROOM_VOLUME);
	}else{
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_ROOM_VOLUME);
	}
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	Vec		pos;
	s8		subno;
	WK7PLAYERPATHCONTROL->GetCurrentPosition(&pos);
	if( pos.z < -300.0f ){
		subno = 0;
	}else{
		subno = 1;
	}
	SetStageMapFlag(subno,true);
	GameInfo.SetMenuMapSubNo(subno);
	
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
		mAlpha.FrameProcess();
		if( mpSetAlpha[0]!=NULL ){
			mpSetAlpha[0]->SetVal(     mAlpha.GetValue(),false);
		}
		if( mpSetAlpha[1]!=NULL ){
			mpSetAlpha[1]->SetVal(1.0f-mAlpha.GetValue(),false);
		}
		K7SCR_RETSYS();
	}
	return false;
}

bool K7Stage525M00::CondChangeCallBack(void)
{
	bool		tamaevflag,evCyo,evRing;
	InitPath();
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		evCyo = false;
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051501)==FALSE ){
			evRing     = true;
			tamaevflag = false;
		}else{
			evRing     = false;
			if( K7SCR_EVHASITEM(K7EVITEM_TAMA(051501))==TRUE ){
				tamaevflag = false;
			}else{
				tamaevflag = true;
			}
		}
		SetZanEventEnable(K7EVENTZAN(052101),false);
	}else{
		tamaevflag = false;
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090502))==true ){
			evCyo = false;
			K7SCR_SET_SCENARIO_FLAG( K7SCN05_CGFL_052500 );
		}else{
			evCyo = true;
		}
		SetZanEventEnable(K7EVENTZAN(051131),false);
	}
	K7SCR_EVNO_SETENABLE(K7EVENTNO  (050501),evCyo);
	K7SCR_EVNO_SETENABLE(K7EVENTNO  (051501),evRing);
	K7SCR_EVNO_SETENABLE(K7EVENTTAMA(051501),tamaevflag);
	RenewTamaEffect(K7EVENTTAMA(051501));
	SetVisibleTamaJObj(K7EVENTTAMA(051501),!K7SCR_EVHASITEM(K7EVITEM_TAMA(051501)));
	
	bool	bright,dark;
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051501)==TRUE ){
		StartCandleFire();
		bright = true;
		dark   = false;
	}else{
		StopCandleFire();
		bright = false;
		dark   = true;
	}
	SetVisibleJObj("Bright",bright,false,true);
	SetVisibleJObj("Dark"  ,dark  ,false,true);
	SetVisibleJObj("Bloodstain",GameInfo.GetScenarioFlow()==K7SCNF_HT2,false,true);
	
	return true;
}

bool K7Stage525M00::EventCallBack(WK7EventInfo &info)
{
//	WK7RenderObjEffect		*pFireEffect;
//	Vec						posFire;
	Vec						posTarget = { -119.987f,12.827f,-598.327f };
	switch( info.mEventNo ){
	case	K7EVENTNO(051501):
		if( K7SCR_EVEQUIPRING(RING_FIRE)==false ){
			FixCamWithRiddle(EVENT_051501_0);
			return false;
		}
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051501);
		
		FixCam(EVENT_051501_0);
		K7SCR_STG_MESSAGE_B(K7STAGE525M00_MES_USE_FIRE_RING);
		
//		WK7CAM->GetPosition(posFire);
//		posFire.y -= 2.0f;
//		
//		if( (pFireEffect=CreateEffectModelFire((const char*)NULL,MFIRE_CANDLE,&posFire,1.0f))!=NULL ){
////			gpSound->mPlaySE( SFX_SCE3_CUR_TANK_FIRE );
//			if( pFireEffect->GetEffect()!=NULL ){
//				VECSubtract(&posTarget,&posFire,&posTarget);
//				SetWindModelFireEffect(pFireEffect->GetEffect(),posTarget,0.05f);
//			}
//			
//			K7SCR_TIMEWAIT( 4800 * 2 );
//			
//			StartCandleFire();
//			
//			K7SCR_TIMEWAIT( 4800 * 1 );
//			
//			ReleaseEffect(pFireEffect);
//			pFireEffect = NULL;
//		}
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.5f));
		StartCandleFire();
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
		
		FixCam(EVENT_051501_1);
		K7SCR_PC_SETVISIBLE(true);
		
		WK7JObj		*pBrightJObj,*pDarkJObj;
		
		pBrightJObj = GetJObj("Bright");
		pDarkJObj   = GetJObj("Dark");
		K7SCR_JOBJ_DISP(pBrightJObj);
		K7SCR_JOBJ_DISP(pDarkJObj  );
		
		mAlpha.SetValue(0.0f);
		if( (mpSetAlpha[0] = new C_SetAlpha(pBrightJObj->GetJObj(),mAlpha.GetValue(),false))!=NULL ){
			mpSetAlpha[0]->SetVal(mAlpha.GetValue(),false);
		}
		if( (mpSetAlpha[1] = new C_SetAlpha(pDarkJObj->GetJObj(),mAlpha.GetValue(),false))!=NULL ){
			mpSetAlpha[1]->SetVal(1.0f - mAlpha.GetValue(),false);
		}
		mAlpha.Play(1.0f,WK7_SEC_TO_TICK(2.0f));
		
		while( mAlpha.IsAnimating()==true ){
			K7SCR_RETSYS();
		}
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.5f));
		GHM_SAFE_DELETE(mpSetAlpha[0]);
		GHM_SAFE_DELETE(mpSetAlpha[1]);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EVCONDCHANGE();
		break;
	case	K7EVENTNO(050501):
		WK7PlayEventInfo	playEventInfo;
		playEventInfo.Initialize();
		playEventInfo.mEventNo = K7EVENTPLAY(05090502);
		PlayEventTask(playEventInfo);
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage525M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(051501):
		if( GameInfo.GetScenarioFlow()!=K7SCNF_HT1 ){
			return true;
		}
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051501)==TRUE ){
			return true;
		}
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

bool K7Stage525M00::StartCandleFire(void)
{
static	Vec		candlePos[2] = {
	{ -120.037f , 13.160f , -596.522f },
	{ -121.367f , 13.160f , -599.460f },
};
	int		i;
	for(i=0 ; i<2 ; i++){
		if( mpCandleFireEffect[i]!=NULL && IsValidEffect(mpCandleFireEffect[i])==true ){
			continue;
		}
		mpCandleFireEffect[i] = CreateEffectModelFire((const char*)NULL,MFIRE_CANDLE,candlePos + i,0.25f);
	}
	gpSound->mPlaySE(SFX_SCE5_HTL_ROUSOKU_TUKU);
	return true;
}

bool K7Stage525M00::StopCandleFire(void)
{
	int		i;
	for(i=0 ; i<2 ; i++){
		if( mpCandleFireEffect[i]==NULL ){
			continue;
		}
		DelReqEffect(mpCandleFireEffect[i]);
		mpCandleFireEffect[i] = NULL;
	}
	return true;
}

