////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage
//
// K7Stage.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE_CPP__

#include "K7Stage.h"
#include "K7Scn01.h"
#include "K7Scn03.h"
#include "K7Scn07.h"
#include "..\Wat\WK7Event.h"
#include "..\Panel\SK7PanelElevator.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Matsu\mK7Noise.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Kaw\KK7Sound.h"
#include "..\Wat\WK7Player.h"
#include "..\Wat\Blood.h"
#include "..\Wat\WK7MainTask.h"
#include "..\Wat\WK7CharaPresent.h"
#include "..\Yam\YK7EffectHSDead.h"
#include "..\Yam\YK7EffectCamera.h"
#include "..\Yam\YK7EffectExplode.h"
#include "..\Yam\YK7MapSelect.h"
#include "..\Yam\YK7EffectEasyAnim.h"
#include "..\Yam\YK7EffectModelFire.h"
#include "..\Matsu\mK7Proc.h"
#include "..\Wat\WK7MainMenu.h"
#include "..\Wat\EnmList.h"

// Xe[WXg
K7STG_LIST_START()
#include "info\K7StageInfo.h"
K7STG_LIST_END()

K7StageWork		*WK7Stage::mpStgWork  = NULL;
int				WK7Stage::mStgWorkNum = 0;
int				WK7Stage::mStgIDNum   = 0;

#define	__K7STAGECREATE_INCLUDE__
#include	".\info\K7StageCreate.h"
WK7Stage* WK7Stage::CreateStage(u32 id,int prio)
{
	WK7Stage	*pStage;
	
	if( mpCreateStageFunc!=NULL ){
		if( (pStage = mpCreateStageFunc(id,prio))!=NULL ){
			return pStage;
		}
	}
	
	K7STG_CREATE_DECL_START()
#include	".\info\K7StageCreate.h"
	default: pStage = new WK7Stage(&mAnchor,prio); break;
	K7STG_CREATE_DECL_END()
	
	return pStage;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Xe[W̃Xg
WK7STGPLINF_START()
#include "info\K7StagePlaceInfo.h"
WK7STGPLINF_END()
// Xe[W̃Xg
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Xe[WړXg
WK7STGDRINF_START()
//	WK7STGDRINF_DEF  (mid,pfx,se)
//	WK7STGDRINF      (mid,pfx,tomid,topfx,se)
//	WK7STGDRINF_BP   (mid,pfx,bp,tomid,topfx,se)
//	WK7STGDRINF_BP2BP(mid,pfx,bp,tomid,topfx,tobp,se)
#include "info\K7StageDoorInfo.h"
WK7STGDRINF_END()
// Xe[WړXg
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Xe[WԃXg
WK7STGHANAINF_START()
//	WK7STGHANAINF(scn,mid,pfx,hanaid,chrid)
#include "info\K7StageHanaInfo.h"
WK7STGHANAINF_END()
// Xe[WԃXg
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Xe[WcvOXg
//	WK7STGZANINF    (mid,pfx,zanid,type)
//	WK7STGZANINF_CAM(mid,pfx,zanid,type,px,py,pz,tx,ty,tz)
WK7STGZANINF_START()
#include "info\K7StageZanInfo.h"
WK7STGZANINF_END()
// Xe[WcvOXg
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Xe[WeۃXg
//	WK7STGTAMAINF(tamaid,px,py,pz,tx,ty,tz)
WK7STGTAMAINF_START()
#include "info\K7StageTamaInfo.h"
WK7STGTAMAINF_END()
// Xe[WcvOXg
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Xe[WTEhXg
WK7STGSOUNDINF_START()
#include "info\K7StageSoundInfo.h"
WK7STGSOUNDINF_END()
// Xe[WTEhXg
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Xe[W\͔Xg
WK7STGSPCOND_START()
#include "info\K7StageSpCond.h"
WK7STGSPCOND_END()
// Xe[WTEhXg
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Xe[W_JXg
WK7STGBPCAMINF_START()
#include "info\K7StageBpCamInfo.h"
WK7STGBPCAMINF_END()
// Xe[W_JXg
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*
	
	iCxgjIuWFNgj
	
*/
bool WK7Stage::BrokenObj(WK7JObj *pJObj)
{
	if( pJObj==NULL || pJObj->GetChild()==NULL ){
		return false;
	}
	pJObj->Disp(false,true);
	CreateEffectBreak(pJObj->GetChild());
	return true;
}
bool WK7Stage::BrokenObj(const char *pobjname)
{
	if( pobjname==NULL ){
		return false;
	}
	BrokenObj(GetJObj(pobjname));
	return true;
}


/*
	
	iCxgjIuWFNgԔj
	
*/
bool WK7Stage::BrokenFlowerObj(WK7JObj *pJObj, u32 charaid)
{
	Vec vecp = {0.f, 0.f, 0.f};
	Vec Pos;
	
	if( pJObj==NULL ){
		return false;
	}
	if( WK7PLAYERCONTROL->GetMainID() != charaid ){
		pJObj->GetPosition(Pos);
		// GtFNg Ԏg
		KK7FlowerPodBrokenSmokeEffect(Pos);
		pJObj->Hide(false,true);
	}else{
		// ԂɂȂGtFNg
		CreateHSDeadEffect(	pJObj,
							vecp,
							VParam[ED_HSD1][0] / 10.0F,	// Power ԑ
							/*myPos.y,*/ 0.f,
							(u16)( VParam[ED_HSD2][21] * VParam[ED_FLOWER][10+((u8 )WK7PLAYERCONTROL->GetBloodTexNum()-1)] * 0.01F ),		// BloodNum ̐  (1/21/2004 Yamada)
							(u8)VParam[ED_HSD1][2],
							3,
							NULL,
							3000,
							NULL,
							false,
							false,
							80,
							0.01F,
							(u8 )WK7PLAYERCONTROL->GetBloodTexNum()
		);
		
		// GtFNg Ԏg
		pJObj->Hide(false,true);
		
		// XyVQ[W^ɂ
//		WK7PLAYERCONTROL->SpGaugeInc((s16)BLOOD_THIN_GAUGE_MAX);
		
	}
	
	return true;
}
bool WK7Stage::BrokenFlowerObj(const char *pobjname, u32 charaid)
{
	bool ret;

	if( pobjname==NULL ){
		return false;
	}
	ret = BrokenFlowerObj(GetJObj(pobjname), charaid);
	return ret;
}


/*
	
	iCxgjĎJ̏
	
	<in>
	cTPos	JA^[Qbg
	cCPos	JA|WV
	mID		̌コID 0xffffffff  サȂ
	mode
	setEndPathFollow  L`FWɃXe[WړpXɖ߂
	
*/
bool WK7Stage::WatchCameraB(Vec cTPos, Vec cCPos, u32 mID, int mode, bool setEndPathFollow)
{
	EFFECT		*pNoize;
	Vec cpos = cCPos;
	Vec ctgt = cTPos;
	u32 charaid = mID;

	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	// Jς
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (cpos);
	WK7CAM->SetTargetPosition(ctgt);
	
	// ĎJGtFNgJn
	pNoize = CreateCameraEffect();									// ĎJ̃GtFNg쐬
	
	// Wait
	if ( !mode ){
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
	}else{
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	}
	
	{
		// Lǂݑւ
		Vec SavePos;
		f32 rotY;
		
		WK7PLAYERCONTROL->GetPosition(&SavePos);
		WK7PLAYERCONTROL->GetRotY(&rotY);
		
		SetCameraNoiseFlag( pNoize, 1 );							// ĎJmCY
		
		GHMGCTASK_RETSYS();
		GHMGCTASK_RETSYS();
		
		if ( 0xFFFFFFFF != charaid  ){
			
			WK7PLAYERCONTROL->Reset();
			WK7PLAYERCONTROL->ReleaseAll();
			
			GHMGCTASK_RETSYS();
			WK7PLAYERCONTROL->CreateModel(charaid);
			WK7PLAYERCONTROL->CreatePackMotion(charaid);
			GHMGCTASK_RETSYS();
			while( true == WK7PLAYERCONTROL->IsLoading() ){
				GHMGCTASK_RETSYS();
			}
			
			WK7PLAYERCONTROL->SetOperateEnable(false);				// vC[|[Y
			
			WK7PLAYERCONTROL->SetVisible(true);
			WK7PLAYERCONTROL->SetPosition(&SavePos);
			WK7PLAYERCONTROL->SetRotY(rotY);
			WK7PLAYERCONTROL->ChangeCallback();
			
		}
		
		GHMGCTASK_RETSYS();
		GHMGCTASK_RETSYS();
		
		SetCameraNoiseFlag( pNoize, 0 );							// ĎJmCY
		
	}
	
	// Wait
	if ( !mode ){
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
	}else{
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	}
	
	if( setEndPathFollow == true ){
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		K7SCR_RETSYS();
	}
	
	// ĎJGtFNgI
	::DelReqEffect(pNoize);
//	DeleteEffect(pNoize);
	// L|[Y
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}



/*
	
	iCxgju`|CgWv
	
	<in>
	name	Wvu`|Cg̖O
	stageid	wXe[WID ̏ꍇ̓JgXe[W
	
*/
bool WK7Stage::BranchJumpB(char *name, u32 stageid)
{
	WK7Stage	*pStage=NULL;
	WK7PathBranchPoint	*pNextBranchBpoint;
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	// JꎞŒ
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	
	gpNoise->mSandRequest(eSandLongNoise);					// mCY
	
	while( pStage == NULL ) {
		if ( stageid == 0xfffffff ){
			pStage = WK7Stage::GetCurrentStage();
		}else{
			pStage = WK7RenderObj::GetStage((stageid));
		}
	}
	
	pNextBranchBpoint = pStage->SearchBranchPoint(name);
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){		// mCY҂
		GHMGCTASK_RETSYS();
	}
	
	if( pNextBranchBpoint!=NULL ){
		K7SCR_STG_SET_CURRENT_PATH_POINT(pNextBranchBpoint->GetName());
	}
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	// Wait
//	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
	gpNoise->mSandRelease();								// mCYJ
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}


/*
	
	
	iCxgjGx[^[f
	
	<in>
	cTPos	JA^[Qbg
	cCPos	JA|WV
	move	-1.f: +1.f:
	nextStgid	̃Xe[WID 0xffffffff ̓Xe[W`FWȂ
	
*/
#define SHAKE_COUNTMAX (10)
static f32 shakeTargetYTable[SHAKE_COUNTMAX] = {
	+0.f,
	0.f,
	+0.4f,
	0.f,
	+1.f,
	0.f,
	+1.f,
	0.2f,
	+2.f,
	0.f,
};
bool WK7Stage::ElevatorDemoB(Vec cTPos, Vec cCPos, f32 move, u32 /*nextStgid*/)
{
#define CAM_MOVE_Y		(3.f)

	int cnt, frame;
	Vec cpos = cCPos;
	Vec ctgt = cTPos;
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	// Jς
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (cpos);
	WK7CAM->SetTargetPosition(ctgt);
	
	// Wait
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
	// ړ
	frame = WK7_SEC_TO_FRAME(2);
	cnt = frame;
	while(cnt--){
		cpos.y += (CAM_MOVE_Y/(f32 )frame) * move;
		ctgt.y += (CAM_MOVE_Y/(f32 )frame) * move;
		
		WK7CAM->SetPosition      (cpos);
		WK7CAM->SetTargetPosition(ctgt);
		GHMGCTASK_RETSYS();
	}
	
	// h
#if 0
	cnt = SHAKE_COUNTMAX;
	while(cnt--){
		Vec setpos = cpos;
		Vec settgt = ctgt;
		
		f32 shakePoint = shakeTargetYTable[cnt];
		setpos.x  = cpos.x;
		setpos.y  = cpos.y + shakePoint;
		setpos.z  = cpos.z;
		
		settgt.x  = ctgt.x;
		settgt.y  = ctgt.y + shakePoint;
		settgt.z  = ctgt.z;
		
		WK7CAM->SetPosition      (setpos);
		WK7CAM->SetTargetPosition(settgt);
		GHMGCTASK_RETSYS();
	}
#else
	// Wait
	gpSound->mPlaySE(SFX_SCE1_ELV_BELL);						// Gx[^[̃x̉
#endif
	
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}



////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

// ViIʓ

/*
	
	
	iViIPjf|[p OCxg
	
	
*/
bool WK7Stage::Scn1DE2EventB(void)
{
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	// Wait
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
	// JꎞIɊĎJ̕Ɍ
	{
		Vec pos, tgt;
		
		tgt.x = -7.766f;
		tgt.y = 20.482f;
		tgt.z = -109.938f;
		pos.x = -14.118f;
		pos.y = 15.131f;
		pos.z = -99.461f;
		
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (pos);
		WK7CAM->SetTargetPosition(tgt);
	}
	
	// Wait
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
	// ĎJf
	{
		Vec cTPos, cCPos;
		
		cTPos.x = -15.646f;
		cTPos.y = 16.818f;
		cTPos.z = -102.573f;
		cCPos.x = -7.490f;
		cCPos.y = 25.407f;
		cCPos.z = -108.775f;
		WatchCameraB(cTPos, cCPos, K7CHRID(K7MSK,00));
	}
	
	// Jړf
	{
		Vec cTPos, cCPos;
		
		cTPos.x = -18.f;
		cTPos.y = 10.983f;
		cTPos.z = -95.067f;
		cCPos.x = -33.678f;
		cCPos.y = 10.983f;
		cCPos.z = -94.763f;
		ElevatorDemoB(cTPos, cCPos, -1.f);
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
//		// J[VĐ
//		{
//			WK7JObj		*pJObj;
//			if( (pJObj=PlayMotion(ROOM131M00_ELEVATORDOOR_NAME, 0))!=NULL ){
//				pJObj->SetMotionLoop(false);
//				gpSound->mPlaySE(SFX_SCE1_ELV_OPEN);						// Gx[^[hAJieKʁj
//				
//				k7app.SetFadeColor(0);
//				k7app.FadeStart(0xff,WK7_SEC_TO_TICK(2));
//				
//				while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){			// ĐI܂ő҂
//					K7SCR_RETSYS();
//				}
//			}
//		}
	}
	
//	while( k7app.IsFade()==true ){
//		retsys();
//	}
	
	
	{
		u32 nextStgID				= K7STGID(131, 0);
		u32 nextBranchPointEventNo	= K7EVENTNO(011301);
		u32 currStgID				= WK7Stage::GetCurrentStageID();
		WK7Stage					*pNextStg;
		WK7PathBranchPoint			*pNextBranchBpoint;
		u32	playno                  = K7EVENTPLAY(01070210);
		
		gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
		K7SCR_STG_RELEASE    (currStgID);
		
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		
		// LĐIIII
		WK7Play::PlayInit   (false,false);
		WK7Play::Prepare    (playno);
		WK7Play::PrepareWait(playno,false);
		WK7Play::StartB     (playno,false);
		
//		K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010401_CHARAGEKI);
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			K7SCR_RETSYS();
		}
		
		WK7Play::PlayReleaseAll();
		
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		
		// ̃Xe[Wǂݍ
		while( (pNextStg = WK7RenderObj::CreateStage(nextStgID))==NULL ){
			K7SCR_RETSYS();
		}
		while( pNextStg->GetState()!=WK7RenderObj::LOADED ){
			K7SCR_RETSYS();
		}
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
		
		K7SCR_RETSYS();
		WK7Play::RestorePlayTB();
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		
		// ̃u`|Cgݒ
		pNextBranchBpoint = pNextStg->GetBranchPoint_EventNo( nextBranchPointEventNo );
		K7SCR_STG_VISIBLE    (nextStgID,true);
		if( pNextBranchBpoint!=NULL ){
			K7SCR_STG_SET_CURRENT_PATH_POINT(pNextBranchBpoint->GetName());
		}
		K7SCR_RETSYS();
		K7SCR_STG_SET_CURRENT(nextStgID);
		
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
	
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
		
	}
	
	// Ó]̂܂ܔ
	return true;
}


/*
	
	
	Gx[^[pl
	
	̊֐gpꍇ́Ã[VXe[W̕œǂݍŒuĂB
	
	<in>
	stageid	݂ID 
	
*/
bool WK7Stage::Scn1SK7PanelElevatorPanelB(u32 stageid)
{
	s32  resultFloor, nowFloor;
	f32  demo;
	bool panelOK = false;
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	// K̊o
	switch (stageid){
	case K7STGID(131, 0):			// 1F
		nowFloor = ELEVATOR_1F;
		break;
	case K7STGID(132, 0):
		nowFloor = ELEVATOR_2F;
		break;
	case K7STGID(133, 0):
		nowFloor = ELEVATOR_3F;
		break;
	case K7STGID(134, 0):
		nowFloor = ELEVATOR_4F;
		break;
	case K7STGID(135, 0):
		nowFloor = ELEVATOR_5F;
		break;
	}
	
	// Gx[^[̃pl
	K7SCR_PANEL_SETPANELID(ePanel011301, nowFloor);		// ɍK𑗂
	K7SCR_PANEL_START();
	K7SCR_PANEL_TERMWAIT();
	
	demo = 0.f;
	resultFloor = K7SCR_PANEL_GETRESULT();
	if ( nowFloor == resultFloor ){							// LZꍇ
			demo = 0.f;
			resultFloor = -1;
	}else{
		switch (resultFloor){
		case ELEVATOR_OPEN:									// Kɖ߂
			demo = 0.f;
			resultFloor = nowFloor;							// ʂ̊Kɓ͂̊K
			break;
		case ELEVATOR_1F:
		case ELEVATOR_2F:
		case ELEVATOR_3F:
		case ELEVATOR_4F:
		case ELEVATOR_5F:
			if ( nowFloor == resultFloor ){					// K
				demo = 0.f;
				resultFloor = nowFloor;						// ʂ̊Kɓ͂̊K
			}
			if ( nowFloor < resultFloor ){					// ̊K
				demo = -1.f;
			}
			if ( nowFloor > resultFloor ){					// ̊K
				demo = +1.f;
			}
			break;
		}
	}
	
	K7SCR_RETSYS();
	K7SCR_PANEL_EXIT();
	K7SCR_PANEL_EXITWAIT();
	
	if ( 0.f != demo ){
		// Jړf
		Vec cTPos, cCPos;
		
		cTPos.x = -18.f;
		cTPos.y = 10.983f;
		cTPos.z = -95.067f;
		cCPos.x = -33.678f;
		cCPos.y = 10.983f;
		cCPos.z = -94.763f;
		ElevatorDemoB(cTPos, cCPos, demo);
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		// J[VĐ
		{
			WK7JObj		*pJObj;
			if( (pJObj=PlayMotion(ROOM131M00_ELEVATORDOOR_NAME, 0))!=NULL ){
				pJObj->SetMotionLoop(false);
				gpSound->mPlaySE(SFX_SCE1_ELV_OPEN);						// Gx[^[hAJieKʁj
				while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){			// ĐI܂ő҂
					K7SCR_RETSYS();
				}
			}
		}
	}
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	if ( resultFloor >= 0 ){
		// Xe[Wœǂݑւ
		u32			nextStgID, nextBranchPointEventNo;
		u32			currStgID = WK7Stage::GetCurrentStageID();
		WK7Stage	*pNextStg;
		
		switch (resultFloor){
		case ELEVATOR_1F:
			nextStgID = K7STGID(131, 0);
			nextBranchPointEventNo = K7EVENTNO(011301);
			break;
		case ELEVATOR_2F:
			nextStgID = K7STGID(132, 0);
			nextBranchPointEventNo = K7EVENTNO(011401);
			break;
		case ELEVATOR_3F:
			nextStgID = K7STGID(133, 0);
			nextBranchPointEventNo = K7EVENTNO(011504);
			break;
		case ELEVATOR_4F:
			nextStgID = K7STGID(134, 0);
			nextBranchPointEventNo = K7EVENTNO(011601);
			break;
		case ELEVATOR_5F:
			nextStgID = K7STGID(135, 0);
			nextBranchPointEventNo = K7EVENTNO(011701);
			break;
		case ELEVATOR_OPEN:
			
			break;
		}
		
		if ( 0.f == demo ){
			// Wait
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
		}
		
		gpNoise->mSandRequest(eSandLongNoise);
		
		if ( resultFloor != nowFloor ){
			// ̃Xe[Wǂݍ
			while( (pNextStg = WK7RenderObj::CreateStage(nextStgID))==NULL ){
				GHMGCTASK_RETSYS();
			}
			while( pNextStg->GetState()!=WK7RenderObj::LOADED ){
				GHMGCTASK_RETSYS();
			}
		}else{
			// ݂̃Xe[Wɂǂ̂ŃJgXe[Wo
			while( (pNextStg = WK7Stage::GetCurrentStage())==NULL ){
				GHMGCTASK_RETSYS();
			}
		}
		
		WK7PathBranchPoint			*pNextBranchBpoint = pNextStg->GetBranchPoint_EventNo( nextBranchPointEventNo );
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		
		if ( resultFloor != nowFloor ){
			K7SCR_STG_SET_CURRENT(nextStgID);
			K7SCR_STG_VISIBLE    (nextStgID,true);
			K7SCR_STG_RELEASE    (currStgID);
		}
		
		if( pNextBranchBpoint!=NULL ){
			K7SCR_STG_SET_CURRENT_PATH_POINT(pNextBranchBpoint->GetName());
		}
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
		
		gpNoise->mSandRelease();
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
	}
	
	K7SCR_EVCONDCHANGE();
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}


/*
	
	iViIPpjGx[^[ł̃u`|CgWv
	
	<in>
	name	Wvu`|Cg̖O
	
*/
bool WK7Stage::Scn1BranchJumpB(char *name)
{
	WK7Stage	*pStage=NULL;
	WK7PathBranchPoint	*pNextBranchBpoint;
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	// JꎞŒ
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	
	gpNoise->mSandRequest(eSandLongNoise);					// mCY
	
	pStage = WK7Stage::GetCurrentStage();
	pNextBranchBpoint = pStage->SearchBranchPoint(name);
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){		// mCY҂
		GHMGCTASK_RETSYS();
	}
	
	if( pNextBranchBpoint!=NULL ){
		K7SCR_STG_SET_CURRENT_PATH_POINT(pNextBranchBpoint->GetName());
	}
	
	// uŕ܂郂[VĐ
	{
		WK7JObj		*pJObj;
		
		// L|[Y
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		if( (pJObj=PlayMotion(ROOM131M00_ELEVATORDOOR_NAME, 2))!=NULL ){
			
			pJObj->SetMotionLoop(false);
			
			gpSound->mPlaySE(SFX_SCE1_ELV_CLOSE);						// Gx[^[hA܂
			
			while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){			// ĐI܂ő҂
				K7SCR_RETSYS();
			}
		}
	}
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	// Wait
//	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
	// Q[CtH[h
	WK7PLAYERCONTROL->SetOperateEnable(true);
	
	gpNoise->mSandRelease();								// mCYJ
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}

//ePanelID GetPanelID(K7StageEventNoPanelNoTable *pTable,u32 eventNo)
//{
//	if( pTable==NULL ){
//		return ePanelIDMax;
//	}
//	while( pTable->mEventNo!=K7STG_EVENTNOPANELNOTABLE_TERMEVENTNO ){
//		if( pTable->mEventNo==eventNo ){
//			return pTable->mPanelID;
//		}
//		pTable++;
//	}
//	return ePanelIDMax;
//}

int WK7Stage::GetStageInfoIndex(u32 stgid,bool scn)
{
	WK7StageInfo	*pStageList;
	int				i;
	for(i=0,pStageList=stageList ; pStageList->mID!=0xffffffff ; pStageList++,i++){
		if( pStageList->mID==stgid ){
			if( scn==true && pStageList->mScenarioID >= 0 && pStageList->mScenarioID!=GameInfo.GetScenarioID() ){
				continue;
			}
			return i;
		}
	}
	return -1;
}

WK7StageInfo* WK7Stage::GetStageInfo(u32 stgid,bool scn)
{
	WK7StageInfo	*pStageList;
	for(pStageList=stageList ; pStageList->mID!=0xffffffff ; pStageList++){
		if( pStageList->mID==stgid ){
			if( scn==true && pStageList->mScenarioID >= 0 && pStageList->mScenarioID!=GameInfo.GetScenarioID() ){
				continue;
			}
			return pStageList;
		}
	}
	return NULL;
}

#ifdef	_DEBUG
bool WK7Stage::CheckFlag(int scn)
{
	WK7StageInfo		*pStageList;
	WK7StageInfo		*pHarmanRootStageList = NULL;
	int					harmanRoomFlagNum = 0;
	int					passPathFlagNum   = 0;
	int					selectObjFlagNum  = 0;
	int					mapFlagNum        = 0;
	for(pStageList=stageList ; pStageList->mID!=0xffffffff ; pStageList++){
		if( pStageList->mScenarioID >= 0 && pStageList->mScenarioID!=scn ){
			continue;
		}
		int		multi = pStageList->mMultiNum;
		if( multi <= 0 ){
			multi  = 1;
		}
		harmanRoomFlagNum += multi * pStageList->mHarmanRoomNum;
		passPathFlagNum   += multi * pStageList->mSelectPathNum;
		selectObjFlagNum  += multi * pStageList->mSelectObjNum;
		mapFlagNum        += multi * pStageList->mMapNum;
		if( pStageList->mID==WK7STAGE_TVSTAGEID ){
			pHarmanRootStageList = pStageList;
		}
	}
	if( pHarmanRootStageList!=NULL ){
		selectObjFlagNum += harmanRoomFlagNum * pHarmanRootStageList->mSelectObjNum;
		passPathFlagNum  += harmanRoomFlagNum * pHarmanRootStageList->mSelectPathNum;
	}
	OSReport("Scenario %d : H%d,O%d,P%d,M%d\n",scn,harmanRoomFlagNum,selectObjFlagNum,passPathFlagNum,mapFlagNum);
	if( harmanRoomFlagNum > WK7STAGE_HARMANROOM_FLAG_NUM ){
		OSReport("Scenario %d : HarmanRoomFlag Over - %d(%d)\n",scn,harmanRoomFlagNum,WK7STAGE_HARMANROOM_FLAG_NUM);
	}
	if( selectObjFlagNum > WK7STAGE_SELECTOBJ_FLAG_NUM ){
		OSReport("Scenario %d : SelectObjFlag  Over - %d(%d)\n",scn,selectObjFlagNum,WK7STAGE_SELECTOBJ_FLAG_NUM);
	}
	if( passPathFlagNum > WK7STAGE_PASSPATH_FLAG_NUM ){
		OSReport("Scenario %d : SelectPathFlag Over - %d(%d)\n",scn,passPathFlagNum,WK7STAGE_PASSPATH_FLAG_NUM);
	}
	if( mapFlagNum > WK7STAGE_MAP_FLAG_NUM ){
		OSReport("Scenario %d : MapFlag        Over - %d(%d)\n",scn,mapFlagNum,WK7STAGE_MAP_FLAG_NUM);
	}
	return true;
}
#endif

bool WK7Stage::ClearFlag(void)
{
	ClearSelectObjFlag ();
	ClearPassPathFlag  ();
	ClearHarmanTvFlag  ();
	ClearHarmanRoomFlag();
	ClearMapFlag       ();
	return true;
}

bool WK7Stage::InitWork(void)
{
	WK7StageInfo		*pStageList;
	bool				harmansRoom = false;
	GHM_SAFE_DELETE_ARRAY(mpStgWork);
	for(mStgIDNum=0,pStageList=stageList ; pStageList->mID!=0xffffffff ; pStageList++){
		if( pStageList->mID==WK7STAGE_TVSTAGEID ){
			harmansRoom = true;
		}
		mStgIDNum++;
	}
	mStgWorkNum = mStgIDNum;
	if( harmansRoom==true ){
		mStgWorkNum = 2 * mStgWorkNum - 1;
	}
	if( mStgWorkNum ){
		if( (mpStgWork = (K7StageWork *)K7AppSmallMemAlloc((int)(mStgWorkNum * sizeof(K7StageWork))))==NULL ){
			mStgWorkNum = 0;
		}else{
			memset(mpStgWork,0,(mStgWorkNum * sizeof(K7StageWork)));
		}
	}
	
#ifdef	_DEBUG
	// [N`FbN
	CheckFlag(K7SCN07);
	CheckFlag(K7SCN01);
	CheckFlag(K7SCN02);
	CheckFlag(K7SCN03);
	CheckFlag(K7SCN04);
	CheckFlag(K7SCN05);
	CheckFlag(K7SCN06);
#endif
	
	// [NNA
	ClearFlag();
	
	return true;
}

int WK7Stage::GetWorkID(u32 stgid)
{
	WK7StageInfo	*pStageList;
	int				i;
	for(i=0,pStageList=stageList ; pStageList->mID!=0xffffffff ; pStageList++,i++){
		if( pStageList->mID==stgid ){
			return i;
		}
	}
	return -1;
}

int WK7Stage::GetWorkID(void)
{
	return GetWorkID(mID);
}

int WK7Stage::GetWorkNum(void)
{
	return mStgWorkNum;
}

int WK7Stage::GetIDNum(void)
{
	return mStgIDNum;
}

K7StageWork* WK7Stage::GetWorkTop(void)
{
	return mpStgWork;
}

K7StageWork* WK7Stage::GetWork(u32 stgid)
{
	int		id;
	if( stgid==0xffffffff || mpStgWork==NULL ){
		return NULL;
	}
	id = GetWorkID(stgid);
	if( id < 0 || id > K7STG_LIST_NUM ){
		return NULL;
	}
	return mpStgWork + id;
}

K7StageWork* WK7Stage::GetWork(void)
{
	return GetWork(mID);
}

int WK7Stage::GetStageHarmanRoomFlagID(u32 stgid)
{
	WK7StageInfo	*pStageList;
	int				count;
	for(pStageList=stageList,count=0 ; pStageList->mID!=0xffffffff ; pStageList++){
		if( pStageList->mScenarioID>=0 && pStageList->mScenarioID!=GameInfo.GetScenarioID() ){
			continue;
		}
		if( pStageList->mID==stgid ){
			return count;
		}
		int		num = pStageList->mHarmanRoomNum;
		if( pStageList->mMultiNum > 0 ){ num *= pStageList->mMultiNum; }
		count += num;
	}
	return -1;
}

bool WK7Stage::SetHarmanRoomFlag(u32 stgid,int index,bool flag,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int		num = pStageInfo->mHarmanRoomNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	index += multi * pStageInfo->mHarmanRoomNum;
	if( index < 0 || index >= num ){
		return false;
	}
	return SetHarmanRoomFlag(index + GetStageHarmanRoomFlagID(stgid),flag);
}

bool WK7Stage::GetHarmanRoomFlag(u32 stgid,int index,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int		num = pStageInfo->mHarmanRoomNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	index += multi * pStageInfo->mHarmanRoomNum;
	if( index < 0 || index >= num ){
		return false;
	}
	return GetHarmanRoomFlag(index + GetStageHarmanRoomFlagID(stgid));
}

bool WK7Stage::SetHarmanRoomFlag(int index,bool flag)
{
	if( index >= WK7STAGE_HARMANROOM_FLAG_NUM ){
		return false;
	}
	int		uid,lid;
	uid = (index & 0x7fffffe0) >> 5;
	lid =  index & 0x0000001f;
	if( flag==true ){
		mHarmanRoomFlag[uid] |=  (1<<lid);
	}else{
		mHarmanRoomFlag[uid] |= ~(1<<lid);
	}
	return true;
}

bool WK7Stage::GetHarmanRoomFlag(int index)
{
	if( index >= WK7STAGE_HARMANROOM_FLAG_NUM ){
		return false;
	}
	int		uid,lid;
	uid = (index & 0x7fffffe0) >> 5;
	lid =  index & 0x0000001f;
	if( mHarmanRoomFlag[uid] & (1<<lid) ){
		return true;
	}
	return false;
}

bool WK7Stage::ClearHarmanRoomFlag(void)
{
	memset(mHarmanRoomFlag,0,sizeof(mHarmanRoomFlag));
	return true;
}

bool WK7Stage::SetStageHarmanRoomFlag(int index,bool flag,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int		num = mHarmanRoomNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	if( multi < 0 ){
		index += mHarmanRoomNum * mMultiID;
	}else{
		index += mHarmanRoomNum * multi;
	}
	if( mHarmanRoomID < 0 || index < 0 || index >= num ){
		return false;
	}
	return SetHarmanRoomFlag(index + mHarmanRoomID,flag);
}

bool WK7Stage::GetStageHarmanRoomFlag(int index,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int		num = mHarmanRoomNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	if( multi < 0 ){
		index += mHarmanRoomNum * mMultiID;
	}else{
		index += mHarmanRoomNum * multi;
	}
	if( mHarmanRoomID < 0 || index < 0 || index >= num ){
		return false;
	}
	return GetHarmanRoomFlag(index + mHarmanRoomID);
}

int WK7Stage::GetStageHarmanTvFlagID(u32 stgid)
{
	return GetStageHarmanRoomFlagID(stgid);
}

bool WK7Stage::SetHarmanTvFlag(u32 stgid,int index,bool flag,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int		num = pStageInfo->mHarmanRoomNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	index += multi * pStageInfo->mHarmanRoomNum;
	if( index < 0 || index >= num ){
		return false;
	}
	return SetHarmanTvFlag(index + GetStageHarmanTvFlagID(stgid),flag);
}

bool WK7Stage::GetHarmanTvFlag(u32 stgid,int index,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int		num = pStageInfo->mHarmanRoomNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	index += multi * pStageInfo->mHarmanRoomNum;
	if( index < 0 || index >= num ){
		return false;
	}
	return GetHarmanTvFlag(index + GetStageHarmanTvFlagID(stgid));
}

bool WK7Stage::SetHarmanTvFlag(int index,bool flag)
{
	if( index >= WK7STAGE_HARMANTV_FLAG_NUM ){
		return false;
	}
	int		uid,lid;
	uid = (index & 0x7fffffe0) >> 5;
	lid =  index & 0x0000001f;
	if( flag==true ){
		mHarmanTvFlag[uid] |=  (1<<lid);
	}else{
		mHarmanTvFlag[uid] |= ~(1<<lid);
	}
	return true;
}

bool WK7Stage::GetHarmanTvFlag(int index)
{
	if( index >= WK7STAGE_HARMANTV_FLAG_NUM ){
		return false;
	}
	int		uid,lid;
	uid = (index & 0x7fffffe0) >> 5;
	lid =  index & 0x0000001f;
	if( mHarmanTvFlag[uid] & (1<<lid) ){
		return true;
	}
	return false;
}

bool WK7Stage::ClearHarmanTvFlag(void)
{
	memset(mHarmanTvFlag,0,sizeof(mHarmanTvFlag));
	return true;
}

bool WK7Stage::SetStageHarmanTvFlag(int index,bool flag,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int		num = mHarmanRoomNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	if( multi < 0 ){
		index += mHarmanRoomNum * mMultiID;
	}else{
		index += mHarmanRoomNum * multi;
	}
	if( mHarmanRoomID < 0 || index < 0 || index >= num ){
		return false;
	}
	return SetHarmanTvFlag(index + mHarmanRoomID,flag);
}

bool WK7Stage::GetStageHarmanTvFlag(int index,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int		num = mHarmanRoomNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	if( multi < 0 ){
		index += mHarmanRoomNum * mMultiID;
	}else{
		index += mHarmanRoomNum * multi;
	}
	if( mHarmanRoomID < 0 || index < 0 || index >= num ){
		return false;
	}
	return GetHarmanTvFlag(index + mHarmanRoomID);
}

bool WK7Stage::SetMapFlag(int id,bool flag)
{
	if( id < 0 || id >= WK7STAGE_MAP_FLAG_NUM ){
		return false;
	}
	int	uid = (id & 0x7fffffff) >> 5;
	int	lid = id & 0x1f;
	if( flag==true ){
		mMapFlag[uid] |=  (1<<lid);
	}else{
		mMapFlag[uid] &= ~(1<<lid);
	}
	return true;
}

bool WK7Stage::GetMapFlag(int id)
{
	if( id < 0 || id >= WK7STAGE_MAP_FLAG_NUM ){
		return false;
	}
	int	uid = (id & 0x7fffffff) >> 5;
	int	lid = id & 0x1f;
	if( mMapFlag[uid] & (1<<lid) ){
		return true;
	}
	return false;
}

bool WK7Stage::ClearMapFlag(void)
{
	memset(mMapFlag,0,sizeof(mMapFlag));
	return true;
}

int WK7Stage::GetStageMapFlagID(u32 stgid)
{
	WK7StageInfo	*pStageList;
	int				id = 0;
	for(pStageList=stageList ; pStageList->mID!=0xffffffff ; pStageList++){
		if( pStageList->mScenarioID>=0 && pStageList->mScenarioID!=GameInfo.GetScenarioID() ){
			continue;
		}
		if( pStageList->mID==stgid ){
			return id;
		}
		int		num = pStageList->mMapNum;
		if( pStageList->mMultiNum > 0 ){ num *= pStageList->mMultiNum; }
		id += num;
	}
	return -1;
}

bool WK7Stage::SetStageMapFlag(u32 stgid,int id,bool flag,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int	num = pStageInfo->mMapNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	id += pStageInfo->mMapNum * multi;
	if( id < 0 || id >= num ){
		return false;
	}
	return SetMapFlag(id + GetStageMapFlagID(stgid),flag);
}

bool WK7Stage::GetStageMapFlag(u32 stgid,int id,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int	num = pStageInfo->mMapNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	id += pStageInfo->mMapNum * multi;
	if( pStageInfo==NULL || id < 0 || id >= num ){
		return false;
	}
	return GetMapFlag(id + GetStageMapFlagID(stgid));
}

bool WK7Stage::SetStageMapFlag(int id,bool flag,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int	num = mMapNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	if( multi < 0 ){
		id += mMapNum * mMultiID;
	}else{
		id += mMapNum * multi;
	}
	if( mMapID < 0 || id < 0 || id >= num ){
		return false;
	}
	return SetMapFlag(id + mMapID,flag);
}

bool WK7Stage::GetStageMapFlag(int id,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int	num = mMapNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	if( multi < 0 ){
		id += mMapNum * mMultiID;
	}else{
		id += mMapNum * multi;
	}
	if( mMapID < 0 || id < 0 || id >= num ){
		return false;
	}
	return GetMapFlag(id + mMapID);
}

bool WK7Stage::SetPassPathFlag(int id,bool flag)
{
	if( id < 0 || id >= WK7STAGE_PASSPATH_FLAG_NUM ){
		return false;
	}
	int	uid = (id & 0x7fffffff) >> 5;
	int	lid = id & 0x1f;
	if( flag==true ){
		mPassPathFlag[uid] |=  (1<<lid);
	}else{
		mPassPathFlag[uid] &= ~(1<<lid);
	}
	return true;
}

bool WK7Stage::GetPassPathFlag(int id)
{
	if( id < 0 || id >= WK7STAGE_PASSPATH_FLAG_NUM ){
		return false;
	}
	int	uid = (id & 0x7fffffff) >> 5;
	int	lid = id & 0x1f;
	if( mPassPathFlag[uid] & (1<<lid) ){
		return true;
	}
	return false;
}

bool WK7Stage::ClearPassPathFlag(void)
{
	memset(mPassPathFlag,0,sizeof(mPassPathFlag));
	return true;
}

int WK7Stage::GetStagePassPathFlagID(u32 stgid)
{
	WK7StageInfo	*pStageList;
	int				id = 0;
	for(pStageList=stageList ; pStageList->mID!=0xffffffff ; pStageList++){
		if( pStageList->mScenarioID >= 0 && pStageList->mScenarioID!=GameInfo.GetScenarioID() ){
			continue;
		}
		if( pStageList->mID==stgid ){
			return id;
		}
		int		num = pStageList->mSelectPathNum;
		if( pStageList->mMultiNum > 0 ){ num *= pStageList->mMultiNum; }
		id += num;
	}
	return -1;
}

bool WK7Stage::SetStagePassPathFlag(u32 stgid,int id,int dir,bool flag,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int		num = pStageInfo->mSelectPathNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	id += (dir & 3);
	id += pStageInfo->mSelectPathNum * multi;
	if( id < 0 || id >= num ){
		return false;
	}
	return SetPassPathFlag(id + GetStagePassPathFlagID(stgid),flag);
}

bool WK7Stage::GetStagePassPathFlag(u32 stgid,int id,int dir,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int		num = pStageInfo->mSelectPathNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	id += (dir & 3);
	id += pStageInfo->mSelectPathNum * multi;
	if( id < 0 || id >= num ){
		return false;
	}
	return GetPassPathFlag(id + GetStagePassPathFlagID(stgid));
}

bool WK7Stage::SetStagePassPathFlag(int id,int dir,bool flag,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int		num = mSelectPathNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	id += (dir & 3);
	if( multi < 0 ){
		id += mSelectPathNum * mMultiID;
	}else{
		id += mSelectPathNum * multi;
	}
	if( mSelectPathID < 0 || id < 0 || id >= num ){
		return false;
	}
	return SetPassPathFlag(id + mSelectPathID,flag);
	
}

bool WK7Stage::GetStagePassPathFlag(int id,int dir,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int		num = mSelectPathNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	id += (dir & 3);
	if( multi < 0 ){
		id += mSelectPathNum * mMultiID;
	}else{
		id += mSelectPathNum * multi;
	}
	if( mSelectPathID < 0 || id < 0 || id >= num ){
		return false;
	}
	return GetPassPathFlag(id + mSelectPathID);
}

bool WK7Stage::SetSelectObjFlag(int id,bool flag)
{
	if( id < 0 || id >= WK7STAGE_SELECTOBJ_FLAG_NUM ){
		return false;
	}
	int	uid = (id & 0x7fffffff) >> 5;
	int	lid = id & 0x1f;
	if( flag==true ){
		mSelectObjFlag[uid] |=  (1<<lid);
	}else{
		mSelectObjFlag[uid] &= ~(1<<lid);
	}
	return true;
}

bool WK7Stage::GetSelectObjFlag(int id)
{
	if( id < 0 || id >= WK7STAGE_SELECTOBJ_FLAG_NUM ){
		return false;
	}
	int	uid = (id & 0x7fffffff) >> 5;
	int	lid = id & 0x1f;
	if( mSelectObjFlag[uid] & (1<<lid) ){
		return true;
	}
	return false;
}

bool WK7Stage::ClearSelectObjFlag(void)
{
	memset(mSelectObjFlag,0,sizeof(mSelectObjFlag));
	return true;
}

int WK7Stage::GetStageSelectObjFlagID(u32 stgid)
{
	WK7StageInfo	*pStageList;
	int				id = 0;
	for(pStageList=stageList ; pStageList->mID!=0xffffffff ; pStageList++){
		if( pStageList->mScenarioID >= 0 && pStageList->mScenarioID==GameInfo.GetScenarioID() ){
			continue;
		}
		if( pStageList->mID==stgid ){
			return id;
		}
		int		num = pStageList->mSelectObjNum;
		if( pStageList->mMultiNum > 0 ){ num *= pStageList->mMultiNum; }
		id += num;
	}
	return -1;
}

bool WK7Stage::SetStageSelectObjFlag(u32 stgid,int id,int dir,bool flag,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int		num = pStageInfo->mSelectObjNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	id += (dir & 1);
	id += pStageInfo->mSelectObjNum * multi;
	if( id < 0 || id >= num ){
		return false;
	}
	return SetSelectObjFlag(id + GetStageSelectObjFlagID(stgid),flag);
}

bool WK7Stage::GetStageSelectObjFlag(u32 stgid,int id,int dir,int multi)
{
	WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
	if( pStageInfo==NULL ){
		return false;
	}
	int		num = pStageInfo->mSelectObjNum;
	if( pStageInfo->mMultiNum > 0 ){ num *= pStageInfo->mMultiNum; }
	id += (dir & 1);
	id += pStageInfo->mSelectObjNum * multi;
	if( id < 0 || id >= num ){
		return false;
	}
	return GetSelectObjFlag(id + GetStageSelectObjFlagID(stgid));
}

bool WK7Stage::SetStageSelectObjFlag(int id,int dir,bool flag,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int		num = mSelectObjNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	id += (dir & 1);
	if( multi < 0 ){
		id += mSelectObjNum * mMultiID;
	}else{
		id += mSelectObjNum * multi;
	}
	if( id < 0 || id >= num ){
		return false;
	}
	return SetSelectObjFlag(id + mSelectObjID,flag);
	
}

bool WK7Stage::GetStageSelectObjFlag(int id,int dir,int multi)
{
	if( mpStageInfo==NULL ){
		return false;
	}
	int		num = mSelectObjNum;
	if( mMultiNum > 0 ){ num *= mMultiNum; }
	id += (dir & 1);
	if( multi < 0 ){
		id += mSelectObjNum * mMultiID;
	}else{
		id += mSelectObjNum * multi;
	}
	if( id < 0 || id >= num ){
		return false;
	}
	return GetSelectObjFlag(id + mSelectObjID);
}

/*
	
	
	ZeBbN̊ĎJ̏
	
	
*/
void WK7Stage::Scn7KansiCameraCharaChangeInit(void)
{
	// 蓮Xe[Wnm
	SetManualBranch(true);
	
	// ԕ\
//	if ( WK7PLAYERCONTROL->GetmpSpAtGauge() != NULL ){
//		KK7EffectSpAtkGaugeVisible( WK7PLAYERCONTROL->GetmpSpAtGauge(), false );
//	}
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
}
/*
	
	
	ZeBbN̊ĎJ̏
	
	
*/
void WK7Stage::Scn7KansiCameraCharaChangeB(Vec *pTgt1, Vec *pPos1, Vec *pTgt2, Vec *pPos2, u32 charaid)
{
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	// Jς
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (*pPos1);
	WK7CAM->SetTargetPosition(*pTgt1);
	
	gpNoise->mSandRelease();																// mCYJiXe[Wj
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	// Wait
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
	
	// ĎJ̏
	WatchCameraB(*pTgt2, *pPos2, charaid, 1);
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7StagePlaceInfo		*pPlaceInfo;
	pPlaceInfo = GetPlaceInfo(mID,WK7PLAYERPATHCONTROL->GetCurrentPathName());
#ifdef	_DEBUG
	SetPlaceInfoWaring(pPlaceInfo,WK7PLAYERPATHCONTROL->GetCurrentPathName());
#endif
	SetCameraStartPosition(pPlaceInfo);
	SandRelease();																// mCYJiXe[Wj
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	// L|[Y
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	SetManualBranch(false);
}


/*
	
	
	hAG[̃Cxg
	
	J
	l
	
	<in>
	pTgt, pPos
	
*/
void WK7Stage::DoorError(Vec *pTgt, Vec *pPos, u32 mesNo)
{
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	// Jς
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (*pPos);
	WK7CAM->SetTargetPosition(*pTgt);
	K7SCR_PC_SETVISIBLE(false);								// l
	
	K7SCR_STGC_MESSAGE_B(mesNo);							// bZ[W
	
	// L|[Y
	K7SCR_PC_RETURNVISIBLE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
}


#define BOMB_TIME		(8.f)				// R鎞
void WK7Stage::BombObj(WK7JObj *pJObj, f32 BombDist, Vec *pPos)
{
	Vec Pos;
	
	if ( NULL == pPos ){
		pJObj->GetPosition(Pos);
	}else{
		Pos.x = pPos->x;
		Pos.y = pPos->y;
		Pos.z = pPos->z;
	}
	
	// {xŃGtFNgZbg
	CreateSmokeExplodeEffect( Pos, 5.f,  2) ;
#if 0
	BrokenObj(pJObj);
#else
	pJObj->Hide(false,true);
#endif
	BattleCtrl.CreateDamagePos(Pos, BombDist, BOMB_TIME, (KK7BATTLECTRL_DAMAGEPOINT_BIT_ENEMY|KK7BATTLECTRL_DAMAGEPOINT_BIT_PC), POW_BOMBER, DAMTYPE_BOMBER);
}

bool WK7Stage::FixCam( u32 inID)
{
	if( mpOneShotCamera == NULL ){
		return false;
	}
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (mpOneShotCamera[inID].pos);
	WK7CAM->SetTargetPosition(mpOneShotCamera[inID].tgt);
	return true;
}

bool WK7Stage::CamMoveToLinearPath(u32 inID,f32 sec)
{
	if( mpOneShotCamera == NULL ){
		return false;
	}
	f32		frame;
	frame = sec * 60.0f;
	WK7CAM->StartLinearInterpolateOnLinearPath(mpOneShotCamera[inID].pos,
	                                           mpOneShotCamera[inID].tgt,
	                                           frame);
	return true;
}

bool WK7Stage::CamMoveToLinearPathDelay(u32 inID,f32 delayRate)
{
	if( mpOneShotCamera == NULL ){
		return false;
	}
	WK7CAM->StartDelayInterpolateOnLinearPath(mpOneShotCamera[inID].pos,
	                                          mpOneShotCamera[inID].tgt,
	                                          delayRate);
	return true;
}

bool WK7Stage::CamMoveToCirclePath(u32 inID,f32 sec)
{
	if( mpOneShotCamera == NULL ){
		return false;
	}
	f32		frame;
	frame = sec * 60.0f;
	WK7CAM->StartLinearInterpolateOnCirclePath(mpOneShotCamera[inID].pos,
	                                           mpOneShotCamera[inID].tgt,
	                                           frame);
	return true;
}

//------------------------------------------------------------------------------
//iCxgj䂩ŒJset
//------------------------------------------------------------------------------
bool WK7Stage::FixCamWithRiddle( u32 inID )
{
	if( mpOneShotCamera == NULL )
	{
		return( false );
	}
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( false );
	
	WK7CAM->SetMode( WK7Cam::WK7CAM_FREE_TARGET );
	WK7CAM->SetPosition( mpOneShotCamera[inID].pos );
	WK7CAM->SetTargetPosition( mpOneShotCamera[inID].tgt );
	
	//SEĐ
	gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
	//3b~
	K7SCR_TIMEWAIT( 4800 * 3 );
	
	// L|[Y
	K7SCR_PC_RETURNVISIBLE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return( true );
}

//------------------------------------------------------------------------------
//iCxgj䂩ŒJsetbZ[Wt
//------------------------------------------------------------------------------
bool WK7Stage::FixCamMesWithRiddle( u32 inID, u32 inMesNo )
{
	if( mpOneShotCamera == NULL )
	{
		return( false );
	}
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( false );
	
	WK7CAM->SetMode( WK7Cam::WK7CAM_FREE_TARGET );
	WK7CAM->SetPosition( mpOneShotCamera[inID].pos );
	WK7CAM->SetTargetPosition( mpOneShotCamera[inID].tgt );
	
	//SEĐ
	gpSound->mPlaySE( SFX_SYS_APPEAR_RIDDLE );
	//bZ[W\
	K7SCR_STGC_MESSAGE_B( inMesNo );
	
	// L|[Y
	K7SCR_PC_RETURNVISIBLE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return( true );
}

//------------------------------------------------------------------------------
//iCxgjŒJtbZ[W\
//------------------------------------------------------------------------------
bool WK7Stage::FixCamMes( u32 inID, u32 inMesNo ,int preMesSE,int postMesSE)
{
	// G[`FbN
	if( mpOneShotCamera == NULL )
		return false;
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( false );
	
	// Jς
	FixCam(inID);
	
	if( preMesSE >= 0 ){
		gpSound->mPlaySE(preMesSE);
	}
	K7SCR_STGC_MESSAGE_B(inMesNo);
	if( postMesSE >= 0 ){
		gpSound->mPlaySE(postMesSE);
	}
	
	// L|[Y
	K7SCR_PC_SETVISIBLE( true );
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}

bool WK7Stage::DoorClear( u32 inID, u32 inMesNo)
{
	return FixCamMes(inID,inMesNo,SFX_SYS_KEY_USE,SFX_SYS_TRUE);
}

bool WK7Stage::DoorError( u32 inID, u32 inMesNo)
{
	return FixCamMes(inID,inMesNo);
}

bool WK7Stage::FixCamMes2( u32 inID, u32 inMesNo ,int preMesSE,int postMesSE)
{
	// G[`FbN
	if( mpOneShotCamera == NULL )
		return false;
	
	// Jς
	FixCam(inID);
	
	if( preMesSE >= 0 ){
		gpSound->mPlaySE(preMesSE);
	}
	K7SCR_STGC_MESSAGE_B(inMesNo);
	if( postMesSE >= 0 ){
		gpSound->mPlaySE(postMesSE);
	}
	
	return true;
}

bool WK7Stage::DoorClear2( u32 inID, u32 inMesNo)
{
	return FixCamMes2(inID,inMesNo,SFX_SYS_KEY_USE,SFX_SYS_TRUE);
}

bool WK7Stage::DoorError2( u32 inID, u32 inMesNo)
{
	return FixCamMes2(inID,inMesNo);
}

//------------------------------------------------------------------------------
//iCxgjŒJtVXebZ[W\
//------------------------------------------------------------------------------
bool WK7Stage::FixCamSysMes( u32 inID, u32 inMesNo ,int preMesSE,int postMesSE)
{
	// G[`FbN
	if( mpOneShotCamera == NULL )
		return false;
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( false );
	
	// Jς
	FixCam(inID);
	
	if( preMesSE >= 0 ){
		gpSound->mPlaySE(preMesSE);
	}
	K7SCR_SYS_MESSAGE_B(inMesNo);
	if( postMesSE >= 0 ){
		gpSound->mPlaySE(postMesSE);
	}
	
	// L|[Y
	K7SCR_PC_SETVISIBLE( true );
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}

//------------------------------------------------------------------------------
//ȈՔŁEf\
//------------------------------------------------------------------------------
bool WK7Stage::SimpleModelDisp( char* inModelName )
{
	WK7JObj *pJObj;
	
	if( (pJObj=GetJObj(inModelName)) != NULL )
	{
		pJObj->Disp( false, true );
	}else
	{
		return( false );
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//ȈՔŁEf\
//------------------------------------------------------------------------------
bool WK7Stage::SimpleModelHide( char* inModelName )
{
	WK7JObj *pJObj;
	
	if( (pJObj=GetJObj(inModelName)) != NULL )
	{
		pJObj->Hide( false, true );
	}else
	{
		return( false );
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//ȈՃ[VĐ(mubN^)
// in --> 
// out -> bool false  Đ
//             true   Đs
//------------------------------------------------------------------------------
bool WK7Stage::SimplePlayMotion( char* inModelName, int inMotNo, char* inMotionName )
{
	WK7JObj *pJObj;
	
	if( (pJObj=PlayMotion(inModelName,inMotNo,inMotionName)) != NULL )
	{
		pJObj->SetMotionLoop( false ,false, true );
	}else
	{
		return( false );
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//ȈՃ[VĐ(ubN^)
// in --> 
// out -> bool false  Đ
//             true   Đs
//------------------------------------------------------------------------------
bool WK7Stage::SimplePlayMotionB( char* inModelName, int inMotNo, char* inMotionName )
{
	WK7JObj *pJObj;
	
	if( (pJObj=PlayMotion(inModelName,inMotNo,inMotionName)) != NULL )
	{
		pJObj->SetMotionLoop( false ,false, true );
		while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
	}else
	{
		return( false );
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//[V̍ŏ̃t[Œ~
// in --> 
// out -> 
//------------------------------------------------------------------------------
bool WK7Stage::SimpleSetStartMotion( char* inModelName, int inMotNo, char* inMotionName )
{
	WK7JObj *pJObj;
	
	if( (pJObj=PlayMotion(inModelName,inMotNo,inMotionName)) != NULL )
	{
		pJObj->StopMotion();
	}else
	{
		return( false );
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//[V̍Ō̃t[Œ~
// in --> 
// out -> 
//------------------------------------------------------------------------------
bool WK7Stage::SimpleSetLastMotion( char* inModelName, int inMotNo, char* inMotionName )
{
	WK7JObj *pJObj;
	
	if( (pJObj=PlayMotion(inModelName,inMotNo,inMotionName,-1.0f)) != NULL )
	{
		pJObj->SetMotionLoop( false ,false, true );
	}else
	{
		return( false );
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//ȈՔŁEpl\(|X^[Ȃǂ̂\镨)
// in --> 
// out -> 
//------------------------------------------------------------------------------
bool WK7Stage::SimpleCallPanel( u32 inNo )
{
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( false );
	//plĂяo
	K7SCR_PANEL_SETPANELEVNO( inNo, 0 );
	K7SCR_PANEL_START();
	K7SCR_PANEL_TERMWAIT();
	K7SCR_RETSYS();
	K7SCR_PANEL_EXIT();
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	K7SCR_PANEL_EXITWAIT();
	//inGameĊJ
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE( true );
	
	return( true );
}
//------------------------------------------------------------------------------
//}bvĂяo
// in -->
// out ->
//------------------------------------------------------------------------------
void WK7Stage::SimpleMapMove( s32 inFrom, s32 inTo, u32 inHideStageId )
{
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	K7SCR_NOISE_REQUEST();
	//Xe[W\
	if( inHideStageId != K7STGID_INVALID )
	{
		K7SCR_STG_VISIBLE( inHideStageId, false );
		K7SCR_PC_VISIBLE( false );
	}
	K7SCR_NOISE_RELEASE_TO_MAP();
	
	//}bvړ
	GameInfo.MapSelectInit( inFrom, inTo );
	//}bvړʕ`
	while( GameInfo.CheckMapSelectEnd() == false )
	{
//		MapSelectFrameProcess();
//		MapSelectRenderProcess();
		K7SCR_RETSYS();
	}
	GameInfo.MapSelectEnd();
	
	//Xe[W\
	if( inHideStageId != K7STGID_INVALID )
	{
		K7SCR_STG_VISIBLE( inHideStageId, true );
		K7SCR_PC_VISIBLE( true );
	}
}
//------------------------------------------------------------------------------
//ACe擾ʌĂяoif\tj
//------------------------------------------------------------------------------
void WK7Stage::SimpleItemGetMes( u32 inMesID, char* inModel, bool inRetFollowCam )
{
	K7SCR_STG_ITEMGET( inMesID );
	K7SCR_STG_ITEMGET_NOTDISPLAYED_B( inMesID );
	if( inModel != NULL )
	{
		SimpleModelHide( inModel );
	}
	if( inRetFollowCam == true )
	{
		K7SCR_PC_SETVISIBLE( true );
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	}
	K7SCR_STG_ITEMGET_VALID_B( inMesID );
}
//------------------------------------------------------------------------------
//R[esbLOANV
// in --> char* inPosLocName  R[e̗ʒũP[^[
// out -> false  sł
//        true   s
//------------------------------------------------------------------------------
bool WK7Stage::SimpleCyoPicking( char* inPosLocName, u32 inCamID, int inPickID )
{
	WK7JObj*	pJObj;
	Vec			pos;
	f32			rotY;
	
	// G[`FbN
	if( mpOneShotCamera == NULL )
	{
		return( false );
	}
	//R[e\W擾	
	if( (pJObj=GetJObj(inPosLocName)) == NULL )
	{
		return( false );
	}
	pJObj->GetWorldPosition( pos );
	rotY = pJObj->GetRotY();
	
	WK7PLAYERCONTROL->WK7PlayerCyoPicking( (WK7CyoPickingMode )inPickID,
										   &mpOneShotCamera[inCamID].tgt,
										   &mpOneShotCamera[inCamID].pos,
										   &pos,
										   rotY,
										   SFX_PC_CYO_PICKING,
										   true );
	
	return( true );
}
//------------------------------------------------------------------------------
//V^HS̏Љ
//
// in --> int   inCheckFlag   Љ`FbNtO(ViItO)
//        u32   inEneNo       ЉGԍ
//        char* inPathName    Xe[Ŵ閼O(branch or path)
//        int   inStartCamID  JJnʒu
//        int   inEndCamID    JIʒu
//        s16   inNameID      Oԍ
//        s16   inNameX       O\XW
//        s16   inNameY       O\YW
//        s16   inWinX        邢EChEXW
//        s16   inWinY        邢EChEYW
//        s16   inWinW        邢EChE
//        s16   inWinH        邢EChE
//
// out -> bool  false         HS͏Љς
//              true          HSЉ
//
// yӁz̊֐ return  true ꍇ
//         Ăяo SetCurrentCallBack falseŔ鎖I
//
//------------------------------------------------------------------------------
bool WK7Stage::HereComeANewHSInit( int inCheckFlag, u32 inEneNo )
{
	if( K7SCR_GET_SCENARIO_FLAG(inCheckFlag) == false )
	{
		if( WK7Npc::GetEnemyDieTest(inEneNo)==false ){
			// ЉpX}C͐Ă	}jAu`ݒ
			SetManualBranch( true );
			return true;
		}
	}
	return false;
}

bool WK7Stage::HereComeANewHS( int inCheckFlag, u32 inEneNo, char* inPathName,
							   int inStartCamID, int inEndCamID,
							   s16 inNameID, s16 inNameX, s16 inNameY,
							   s16 inWinX, s16 inWinY, s16 inWinW, s16 inWinH )
{
	WK7Npc*				pEnemy     = WK7Npc::Find( inEneNo );
	
	if( K7SCR_GET_SCENARIO_FLAG(inCheckFlag) == false )
	{
		WK7StagePlaceInfo*	pPlaceInfo = NULL;
		
		if ( pEnemy == NULL ){
			SetManualBranch( false );
			return false;						// Error
		}
//		ASSERT( pEnemy );
		
		if ( inPathName == NULL ){
			pPlaceInfo = GetPlaceInfo( WK7Stage::GetCurrentStageBpName() );
		}else
		{
			pPlaceInfo = GetPlaceInfo( inPathName );
		}
		ASSERT( pPlaceInfo );
		
//		SetManualBranch( true );
		
		SetCurrentCallBackDefaultProc();
		
		while( WK7Stage::IsChanging() == true )
		{
			K7SCR_RETSYS();
		}
		while( pEnemy->GetNpcState() == NPC_STATE_INIT )
		{
			K7SCR_RETSYS();
		}
		
//		pEnemy->MotSet_Pop(true);				// |bvw
		pEnemy->SetNoPause();					// |[Y֎~
		
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		if ( pPlaceInfo != NULL ){
			SetCameraStartPosition( pPlaceInfo );
			while( SandRelease(pPlaceInfo) == false )
			{
				K7SCR_RETSYS();
			}
		}
		
		SetCurrentCallBackDefaultProc();		// ȍĐ
		
		//HSЉ
		K7SCR_SET_SCENARIO_FLAG( inCheckFlag );
		KihanDemoFirst( pEnemy,			//GLN^
						inStartCamID,	//JnJ
						inEndCamID,		//IJ
						inNameID, inNameX,   inNameY,   inWinX,      inWinY,      inWinW,       inWinH,  1 );
		//				OID    O\X  O\Y  EChEX  EChEY  EChE  EChE
		
#ifdef	_DEBUG
		while( mainMenu.IsDispCamPos()==true ){
			K7SCR_RETSYS();
		}
#endif
		
		K7SCR_PC_SETVISIBLE( true );
		SetCameraStartPosition( pPlaceInfo );
		
		WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
		K7SCR_RETSYS();
		
		pEnemy->ResetNoPause();			// |[Y֎~
		pEnemy->SyoukaiClear();			// Љp̃NA
		K7SCR_CHARAPRESENT_DEBUGEND();
		K7SCR_TIMEWAIT(K7SCR_CP_RELEASETIME);
		
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		SetManualBranch( false );
		
		return( true );
	}else{
		if ( NULL != pEnemy ) {
			pEnemy->SyoukaiClear();			// Љp̃NA
		}
	}
	
	return false;
}
//------------------------------------------------------------------------------
//}XNǔj󎞂̃J
// in -->  u32 inID  Jԍ
// out -> none
//------------------------------------------------------------------------------
bool WK7Stage::SetMskWallCam( u32 inID )
{
	// G[`FbN
	if( mpOneShotCamera == NULL )
	{
		return( false );
	}
	FixCam( inID );
	K7SCR_TIMEWAIT( K7SCR_MSK_WALL_BEFORE_TICK );
	gpSound->mPlaySE( SFX_SYS_TRUE );
	K7SCR_TIMEWAIT( K7SCR_MSK_WALL_AFTER_TICK );
	return( true );
}
//------------------------------------------------------------------------------
//wPCĂ邩擾iPCMainID́j
//TV̕яŐĂPCID擾iȗj
// in --> u32 inPcID  Ă邩ׂPCMainID
//                    ȗK7PCMAXŁATV̕яŐĂPCID擾
// out -> u32 ĂPCID
//------------------------------------------------------------------------------
u32
WK7Stage::GetAlivePcID( u32 inPcID )
{
	bool	die = false;
	u32		pcID;
	
#if	1	//kĔŃoO17Ή
	if( (inPcID != K7PCMAX) && (BattleCtrl.PcDieTest(inPcID) == false) && (BattleCtrl.PcReCallTest(inPcID) == true) )
	{
		pcID = inPcID;
	}else
	{
		if( (BattleCtrl.PcDieTest(K7DAN) == false) && (BattleCtrl.PcReCallTest(K7DAN) == true) )
		{
			pcID = K7DAN;
		}else
		if( (BattleCtrl.PcDieTest(K7KED) == false) && (BattleCtrl.PcReCallTest(K7KED) == true) )
		{
			pcID = K7KED;
		}else
		if( (BattleCtrl.PcDieTest(K7KVN) == false) && (BattleCtrl.PcReCallTest(K7KVN) == true) )
		{
			pcID = K7KVN;
		}else
		if( (BattleCtrl.PcDieTest(K7CYO) == false) && (BattleCtrl.PcReCallTest(K7CYO) == true) )
		{
			pcID = K7CYO;
		}else
		if( (BattleCtrl.PcDieTest(K7CAT) == false) && (BattleCtrl.PcReCallTest(K7CAT) == true) )
		{
			pcID = K7CAT;
		}else
		if( (BattleCtrl.PcDieTest(K7MSK) == false) && (BattleCtrl.PcReCallTest(K7MSK) == true) )
		{
			pcID = K7MSK;
		}else
		if( (BattleCtrl.PcDieTest(K7HAY) == false) && (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true) )
		{
			pcID = K7HAY;
		}else
		{
			pcID = K7GAL;
		}
	}
#else
	if( (inPcID != K7PCMAX) && (BattleCtrl.PcDieTest(inPcID) == false) )
	{
		pcID = inPcID;
	}else
	{
		if( BattleCtrl.PcDieTest( K7DAN ) == false )
		{
			pcID = K7DAN;
		}else
		if( BattleCtrl.PcDieTest( K7KED ) == false )
		{
			pcID = K7KED;
		}else
		if( BattleCtrl.PcDieTest( K7KVN ) == false )
		{
			pcID = K7KVN;
		}else
		if( BattleCtrl.PcDieTest( K7CYO ) == false )
		{
			pcID = K7CYO;
		}else
		if( BattleCtrl.PcDieTest( K7CAT ) == false )
		{
			pcID = K7CAT;
		}else
		if( BattleCtrl.PcDieTest( K7MSK ) == false )
		{
			pcID = K7MSK;
		}else
		if( (BattleCtrl.PcDieTest(K7HAY) == false) && (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true) )
		{
			pcID = K7HAY;
		}else
		{
			pcID = K7GAL;
		}
	}
#endif
	
	return( pcID );
}
//------------------------------------------------------------------------------
//ViI^Cg\
//------------------------------------------------------------------------------
void WK7Stage::ScenarioTitleDisp( STAGE_TITLE inNo )
{
	GameInfo.StageTitleInit( inNo );
	while( GameInfo.CheckStageTitleSetup() == false )
	{
		K7SCR_RETSYS();
	}
	while( GameInfo.CheckStageTitleEndState() == false )
	{
//		StageTitleFrameProcess();
//		StageTitleRenderProcess();
		K7SCR_RETSYS();
	}
	GameInfo.StageTitleEnd();
}
//------------------------------------------------------------------------------
//E\Nɉ΂_
//------------------------------------------------------------------------------
void
WK7Stage::EffectFireStart( WK7JObj* inJObj, WK7RenderObjEffect* inFire, int inCamID, WK7JObj* inJObjDisp, WK7JObj* inJObjHide )
{
	Vec					posRing;
//	Vec					posFire;
//	WK7RenderObjEffect*	fire;
	
	posRing.x = mpOneShotCamera[inCamID].pos.x;
	posRing.y = mpOneShotCamera[inCamID].pos.y - 3.0f;
	posRing.z = mpOneShotCamera[inCamID].pos.z;
	
//	//̔ѐW擾
//	if( inJObj != NULL )
//	{
//		inJObj->GetWorldPosition( posFire );
//	}else
//	{
//		return;
//	}
//	
//	//wւ̉GtFNg\
//	if( ((fire=CreateEffectModelFire((const char*)NULL,2,&posRing,0.5f)) != NULL) && (fire->GetEffect() != NULL) )
//	{
//		SetWindModelFireEffect( fire->GetEffect(),
//								(Vec){posFire.x-posRing.x,posFire.y-posRing.y,posFire.z-posRing.z},
//								0.05f );
//	}
//	K7SCR_TIMEWAIT( 4800 * 3 );
//	if( fire != NULL )
//	{
//		DelReqEffect( fire );
//	}
	
	//\
	gpSound->mPlaySE( SFX_SYS_TRUE );
	EffectFireDisp( inJObj, inFire );
	
	//e
	AlphaObjChange( inJObjDisp, inJObjHide, 4800 );
	K7SCR_TIMEWAIT( 4800 );
}
//------------------------------------------------------------------------------
//E\N̉΂\
//------------------------------------------------------------------------------
void
WK7Stage::EffectFireDisp( WK7JObj* inJObj, WK7RenderObjEffect* inFire )
{
	Vec      loc;
	//̍W擾
	if( inJObj != NULL )
	{
		inJObj->GetWorldPosition( loc );
	}else
	{
		return;
	}
	//̃GtFNgNGCg
	if( (inFire == NULL)
	 && ((inFire=CreateEffectModelFire((const char*)NULL,MFIRE_CANDLE,&loc,0.25f)) != NULL)
	 && (inFire->GetEffect() != NULL) )
	{
		SetWindModelFireEffect( inFire->GetEffect(), (Vec){-0.2f,0.0f,-1.0f}, 0.0f );
	}
}
//------------------------------------------------------------------------------
//E\N̉΂\
//------------------------------------------------------------------------------
void
WK7Stage::EffectFireStop( WK7RenderObjEffect* inFire )
{
	if( inFire != NULL )
	{
		DelReqEffect( inFire );
		inFire = NULL;
	}
}
//------------------------------------------------------------------------------
//iCxgjGx[^ł̈ړE
// in --> u32   inCamID     JWID (W&_)
//        u32   inPPosID    vC[WID (W&)
//        char* inDoorName  ̃f̖O
//        u32   inMotNo     ̃[Vԍ
//        u8    inUpDown    肩肩 0: 1:
//        int   inSeDoor    Gx[^hAJSE(ȗ)
//        int   inSeMove    Gx[^ړSE(ȗ)
// out -> bool false  Gx[^Cxgݒ莸s
//                    Gx[^CxgsI
//------------------------------------------------------------------------------
bool WK7Stage::ElevGetOn( u32 inCamID, u32 inPPosID, char* inDoorName, u32 inMotNo, u8 inUpDown, int inSeDoor, int inSeMove )
{
	return ElevGetOnMotType(inCamID,inPPosID,inDoorName,0xffffffff,inMotNo,inUpDown,inSeDoor,inSeMove);
}

bool WK7Stage::ElevGetOnMotType( u32 inCamID, u32 inPPosID, char* inDoorName, u32 inMotType, u32 inMotNo, u8 inUpDown, int inSeDoor, int inSeMove )
{
	WK7JObj*					pJObj;
	f32							tempX, tempZ;
	K7StageEventOneShotCamera	toPos;
	WK7ModelMotion				*pMotion;
	
	//G[`FbN
	if( mpOneShotCamera == NULL || mpModel==NULL )
		return false;
	
	//ǂJɂȂ܂ő҂ǐ̎wJLɂ邽߁j
	while( WK7Stage::IsChanging() != false )
	{
		K7SCR_RETSYS();
	}
	
	if( inMotType==0xffffffff ){
		pMotion = GetOwnModelMotion(inMotNo);
	}else{
		pMotion = GetOwnModelMotion(inMotType,inMotNo);
	}
	
	//L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	//Gx[^̔JԂɂ
//	if( (pJObj = PlayMotion((const char*)inDoorName,(int)inMotNo)) != NULL )
	if( (pJObj = mpModel->AttachMotion(pMotion,(const char *)inDoorName,NULL,false,true))!=NULL )
	{
		pJObj->PlayMotion(0.0f,false,0.0f,false,true);
		pJObj->StopMotion();
	}
	
	//LN^̍Wݒ
	WK7PLAYERPATHCONTROL->SetEnable(false);
	WK7PLAYERCONTROL->SetPosition( &mpOneShotCamera[inPPosID].pos );
	tempX = mpOneShotCamera[inPPosID].tgt.x - mpOneShotCamera[inPPosID].pos.x;
	tempZ = mpOneShotCamera[inPPosID].tgt.z - mpOneShotCamera[inPPosID].pos.z;
	WK7PLAYERCONTROL->SetRotY( atan2(tempX,tempZ) );
	
	//LN^̕\ONɂ
	//K7SCR_PC_SETVISIBLE( true );
	
	//Jς
	FixCam( inCamID );
	
	//SEhAJ
	if( inSeDoor >= 0 ){
		gpSound->mPlaySE( inSeDoor );
	}
	
	//Gx[^̔̕Aj
//	if( (pJObj = PlayMotion((const char*)inDoorName,(int)inMotNo)) != NULL )
	if( pJObj!=NULL )
	{
		pJObj->ReplayMotion(false,true);
		pJObj->SetMotionLoop( false );
		while( pJObj->GetMotionState() != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
	}
	
	//SEړ
	if( inSeMove >= 0 ){
		gpSound->mPlaySE( inSeMove );
	}
	
	//Jړ
	toPos.tgt.x = mpOneShotCamera[inCamID].tgt.x;
	toPos.tgt.z = mpOneShotCamera[inCamID].tgt.z;
	toPos.pos.x = mpOneShotCamera[inCamID].pos.x;
	toPos.pos.z = mpOneShotCamera[inCamID].pos.z;
	if( inUpDown == 0 )
	{
		//
		toPos.tgt.y = mpOneShotCamera[inCamID].tgt.y + 2.0f;
		toPos.pos.y = mpOneShotCamera[inCamID].pos.y + 2.0f;
	}else
	{
		//
		toPos.tgt.y = mpOneShotCamera[inCamID].tgt.y - 2.0f;
		toPos.pos.y = mpOneShotCamera[inCamID].pos.y - 2.0f;
	}
	WK7CAM->StartLinearInterpolateOnLinearPath( toPos.pos, toPos.tgt, 60.0f );
	K7SCR_TIMEWAIT( 4800 );
	WK7PLAYERPATHCONTROL->SetEnable(true);
	
	//L|[Y
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}
//------------------------------------------------------------------------------
//iCxgjGx[^ł̈ړE~
// in --> u32   inCamID         JWID (W&_)
//        u32   inPPosID        vC[WID (W&)
//        char* inDoorName      ̃f̖O
//        u32   inMotNo         ̃[Vԍ
//        u8    inUpDown        肩肩 0: 1:
//        int   inSeDoor        Gx[^hAJSE(ȗ)
//        int   inSeMove        Gx[^ړ:[vSE~邽(ȗ)
//        int   inSeArrive      Gx[^(ȗ)
//        bool  inDoorLastRest  ɔ[VZbg邩H
// out -> bool false  Gx[^Cxgݒ莸s
//                    Gx[^CxgsI
//------------------------------------------------------------------------------
bool WK7Stage::ElevGetOff( u32 inCamID, u32 inPPosID, char* inDoorName, u32 inMotNo, u8 inUpDown, int inSeDoor, int inSeMove, int inSeArrive, bool inDoorLastRest )
{
	return ElevGetOffMotType(inCamID,inPPosID,inDoorName,0xffffffff,inMotNo,inUpDown,inSeDoor,inSeMove,inSeArrive,inDoorLastRest);
}

bool WK7Stage::ElevGetOffMotType( u32 inCamID, u32 inPPosID, char* inDoorName, u32 inMotType, u32 inMotNo, u8 inUpDown, int inSeDoor, int inSeMove, int inSeArrive, bool inDoorLastRest )
{
	WK7JObj*					pJObj;
	f32							rotY, tempX, tempZ;
	Vec							pos;
	K7StageEventOneShotCamera	initPos;
	
	//G[`FbN
	if( mpOneShotCamera == NULL || mpModel==NULL )
		return false;
	
	//Gx[^̂߃mCYȂ
	SetManualBranch( true );
	
	//ǂJɂȂ܂ő҂ǐ̎wJLɂ邽߁j
	while( WK7Stage::IsChanging() != false )
	{
		K7SCR_RETSYS();
	}
	
	//L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	//LN^̍Wۑ
	WK7PLAYERCONTROL->GetRotY( &rotY );
	WK7PLAYERCONTROL->GetPosition( &pos );
	//LN^̍Wݒ
	WK7PLAYERPATHCONTROL->SetEnable(false);
	WK7PLAYERCONTROL->SetPosition( &mpOneShotCamera[inPPosID].pos );
	tempX = mpOneShotCamera[inPPosID].tgt.x - mpOneShotCamera[inPPosID].pos.x;
	tempZ = mpOneShotCamera[inPPosID].tgt.z - mpOneShotCamera[inPPosID].pos.z;
	WK7PLAYERCONTROL->SetRotY( atan2(tempX,tempZ) );
	
	//LN^̕\ONɂ
	K7SCR_PC_SETVISIBLE( true );
	
	//Jς
	initPos.tgt.x = mpOneShotCamera[inCamID].tgt.x;
	initPos.tgt.z = mpOneShotCamera[inCamID].tgt.z;
	initPos.pos.x = mpOneShotCamera[inCamID].pos.x;
	initPos.pos.z = mpOneShotCamera[inCamID].pos.z;
	if( inUpDown == 0 )
	{
		//
		initPos.tgt.y = mpOneShotCamera[inCamID].tgt.y + 2.0f;
		initPos.pos.y = mpOneShotCamera[inCamID].pos.y + 2.0f;
	}else
	{
		//
		initPos.tgt.y = mpOneShotCamera[inCamID].tgt.y - 2.0f;
		initPos.pos.y = mpOneShotCamera[inCamID].pos.y - 2.0f;
	}
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (initPos.pos);
	WK7CAM->SetTargetPosition(initPos.tgt);
	
	//
	SandRelease( GetID() );
	K7SCR_RETSYS();
	while( gpNoise->mGetSandFrameProc() != eSandStandby )
	{
		K7SCR_RETSYS();
	}
	
	//Jړ@WK7CAM_LINIP_LINPATH
	WK7CAM->StartLinearInterpolateOnLinearPath( mpOneShotCamera[inCamID].pos, mpOneShotCamera[inCamID].tgt, 60.0f );
	K7SCR_TIMEWAIT( 4800 );
	
	//SE֌W
	if( inSeMove>=0 && gpSound->mCheckSE(inSeMove) == true ){
		gpSound->mStopSE( inSeMove );	//ړ
	}
	if( inSeArrive >= 0 ){
		gpSound->mPlaySE( inSeArrive );	//
	}
	if( inSeDoor >= 0 ){
		gpSound->mPlaySE( inSeDoor );	//hAJ
	}
	
	WK7ModelMotion				*pMotion;
	
	//G[`FbN
	if( mpOneShotCamera == NULL || mpModel==NULL )
		return false;
	
	if( inMotType==0xffffffff ){
		pMotion = GetOwnModelMotion(inMotNo);
	}else{
		pMotion = GetOwnModelMotion(inMotType,inMotNo);
	}
	
	//Gx[^̔̊JAj
	if( (pJObj = mpModel->AttachMotion(pMotion,(const char *)inDoorName,NULL,false,true))!=NULL )
//	if( (pJObj = PlayMotion((const char*)inDoorName,(int)inMotNo)) != NULL )
	{
		pJObj->PlayMotion(0.0f,false,0.0f,false,true);
		pJObj->SetMotionLoop( false );
		while( pJObj->GetMotionState() != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
		//AjO
		pJObj->DetachMotion( false, true );
		//܂ĂԂɂ
		if( inDoorLastRest == true )
		{
			pJObj->ResetMotion( false, true );
		}
	}
	
	//LN^̍W߂
	WK7PLAYERCONTROL->SetRotY( rotY );
	WK7PLAYERCONTROL->SetPosition( &pos );
	
	//Xe[WԈړ̎wJɐݒ肷
	const char	*pCurrentPathName = WK7PathNurbs::GetShortName(WK7PLAYERPATHCONTROL->GetCurrentPathName());
	WK7StagePlaceInfo		*pPlaceInfo = GetPlaceInfo(GetID(),pCurrentPathName);
	SetCameraStartPosition(pPlaceInfo);
#ifdef	_DEBUG
	SetPlaceInfoWaring(pPlaceInfo,pCurrentPathName);
#endif
	
	WK7PLAYERPATHCONTROL->SetEnable(true);
	
	//Gx[^̂߃mCYȂ
	SetManualBranch( false );
	
	//L|[Y
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}
//------------------------------------------------------------------------------
//LĐ(Xe[WJ܂)
// in --> u32  inNo          Lԍ
//        bool inChkAlready  false:ɍĐ
//                           true :ɍĐĂĐȂ
//        bool inPreNoise    LJñmCY\
//        bool inPostNoise   LĨmCY\
// out -> bool false         ĐȂ
//             true          Đ
//------------------------------------------------------------------------------
bool WK7Stage::PlayCharaGeki( u32 inNo, bool inChkAlready, bool inPreNoise, bool inPostNoise )
{
	if( (inChkAlready == false)
	 || ((WK7Play::HasPlayed(inNo) == false) && (inChkAlready == true)) )
	{
		//JñmCY\
		if( inPreNoise == true )
		{
			gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
			while( gpNoise->mGetSandFrameProc() != eSandExec )		K7SCR_RETSYS();
			//Xe[W
			while( WK7Stage::ReleaseStageArchive() == false )		GHMGCTASK_RETSYS();
			while( WK7Stage::IsReleasedStageArchive() == false )	GHMGCTASK_RETSYS();
			WK7Play::StorePlayTB();
			while( gpNoise->mSandRelease() == false )				K7SCR_RETSYS();
			while( gpNoise->mGetSandFrameProc() != eSandStandby )	K7SCR_RETSYS();
		}else
		{
			//Xe[W
			while( WK7Stage::ReleaseStageArchive() == false )		GHMGCTASK_RETSYS();
			while( WK7Stage::IsReleasedStageArchive() == false )	GHMGCTASK_RETSYS();
			WK7Play::StorePlayTB();
		}
		//LĐ
		WK7Play::PlayTB( inNo );
		//ĨmCY\
		if( inPostNoise == true )
		{
			gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
			while( gpNoise->mGetSandFrameProc() != eSandExec )		K7SCR_RETSYS();
			WK7Play::RestorePlayTB();
			//Xe[W
			while( WK7Stage::RestoreStageArchive() == false )		GHMGCTASK_RETSYS();
			while( WK7Stage::IsRestoredStageArchive() == false )	GHMGCTASK_RETSYS();
			while( gpNoise->mSandRelease() == false )				K7SCR_RETSYS();
			while( gpNoise->mGetSandFrameProc() != eSandStandby )	K7SCR_RETSYS();
		}else
		{
			WK7Play::RestorePlayTB();
			//Xe[W
			while( WK7Stage::RestoreStageArchive() == false )		GHMGCTASK_RETSYS();
			while( WK7Stage::IsRestoredStageArchive() == false )	GHMGCTASK_RETSYS();
		}
	}else
	{
		return( false );
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//VbgL
// in -> u32  inCamID     JID
//       int  inWaitTick  LĐz
//       bool inCharDisp  PC\邩Ȃ
//       int  inSE        seԍ(-1ōĐȂ)
//------------------------------------------------------------------------------
bool
WK7Stage::PlayOneShotCharaGeki( u32 inCamID, int inWaitTick, bool inCharDisp, int inSE )
{
	//Jf[^`FbN
	if( mpOneShotCamera == NULL )
	{
		return( false );
	}
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	if( inCharDisp == false )K7SCR_PC_SETVISIBLE( false );
	//mCY
	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
	while( gpNoise->mGetSandFrameProc()!=eSandExec )K7SCR_RETSYS();
	FixCam( inCamID );
	WK7CAM->SetCinemaScopeMode( true );
	while( gpNoise->mSandRelease()==false )K7SCR_RETSYS();
	while( gpNoise->mGetSandFrameProc()!=eSandStandby )K7SCR_RETSYS();
	//ʉ
	if( inSE != -1 )gpSound->mPlaySE( inSE );
	//EGCg
	K7SCR_TIMEWAIT( inWaitTick );
	//mCY
	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, NOISE_SE_NORMAL );
	while( gpNoise->mGetSandFrameProc()!=eSandExec )K7SCR_RETSYS();
	WK7CAM->SetCinemaScopeMode( false );
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	while( SandRelease()==false )K7SCR_RETSYS();
	while( gpNoise->mGetSandFrameProc()!=eSandStandby )K7SCR_RETSYS();
	// L|[Y
	if( inCharDisp == false )K7SCR_PC_SETVISIBLE( true );
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return( true );
}



//------------------------------------------------------------------------------
// IuWF̔\ؑ
// in -> WK7JObj* pJObjDisp  o
//       WK7JObj* pJObjHide  鑤
//       u32  inTick         I[o[bvv(0Ɛ؂ւ邾)
//       int  inSE           seԍ(-1ōĐȂ)
//       bool inObjNext      Zobjւ̉e
//       bool inZUpdate      Zobt@XV
//------------------------------------------------------------------------------
bool
WK7Stage::AlphaObjChange( WK7JObj* pJObjDisp, WK7JObj* pJObjHide, u32 inTick, int inSE, bool inObjNext, bool inZUpdate )
{
	WK7AnimLinearF					Alpha;
	C_SetAlpha						*pSetAlpha[2];

	pSetAlpha[0] = NULL;
	pSetAlpha[1] = NULL;
	
	if ( inSE != -1 ) gpSound->mPlaySE(inSE);
	
	if ( inTick > 0 ){
		
		Alpha.SetValue(0.0f);
		Alpha.Play    (1.0f, inTick);
		
		if (pJObjDisp != NULL) pSetAlpha[0] = new C_SetAlpha(pJObjDisp->GetJObj(),       Alpha.GetValue(), inObjNext);
		if (pJObjHide != NULL) pSetAlpha[1] = new C_SetAlpha(pJObjHide->GetJObj(),1.0f - Alpha.GetValue(), inObjNext);
		
		if( pSetAlpha[0]!=NULL ){ pSetAlpha[0]->SetVal(       Alpha.GetValue(), inZUpdate); }
		if( pSetAlpha[1]!=NULL ){ pSetAlpha[1]->SetVal(1.0f - Alpha.GetValue(), inZUpdate); }
		
		if ( pJObjDisp != NULL) K7SCR_JOBJ_DISP(pJObjDisp);
		if ( pJObjHide != NULL) K7SCR_JOBJ_DISP(pJObjHide);
		
		K7SCR_TIMEWAIT(10);
		
		if( pSetAlpha[0]!=NULL || pSetAlpha[1]!=NULL ){
				
			while( Alpha.IsAnimating()==true ){
				
				K7SCR_RETSYS();
				
				Alpha.FrameProcess();
				
				if ( pSetAlpha[0]!=NULL ) pSetAlpha[0]->SetVal(       Alpha.GetValue(), inZUpdate);
				if ( pSetAlpha[1]!=NULL ) pSetAlpha[1]->SetVal(1.0f - Alpha.GetValue(), inZUpdate);
			}
			
		}
		
		GHM_SAFE_DELETE(pSetAlpha[0]);
		GHM_SAFE_DELETE(pSetAlpha[1]);
		
	}
	
	if ( pJObjDisp != NULL) K7SCR_JOBJ_DISP(pJObjDisp);
	if ( pJObjHide != NULL) K7SCR_JOBJ_HIDE(pJObjHide);
	
	return( true );
}

//------------------------------------------------------------------------------
// ߋnGtFNg
// in -> u32 rgb     F
//------------------------------------------------------------------------------
void
WK7Stage::PastInit( u32 rgb )
{
	//ߋ
	mTexHeader.mFormat = GX_TF_RGBA8;
	mTexHeader.mWidth  = WK7_SCREEN_WIDTH;
	mTexHeader.mHeight = WK7_SCREEN_HEIGHT;
	mMonoTex.tex       = &mTexHeader;
	mSprt.mSetPriority( SPRT_PRI_SANDBASE );
	mSprt.mRelateTex( &mMonoTex );
	mSprt.mSetUV0( 0, 0 );
	mSprt.mSetXY0( 0, 0 );
	mSprt.mSetWH( WK7_SCREEN_WIDTH, WK7_SCREEN_HEIGHT );
	mSprt.mSetRGBA( rgb );
	mSprt.mSetSpriteNoTexAlphaPrim();
	mSprt.mSetDispFlag( false );
}

//------------------------------------------------------------------------------
// ߋɍs
// in -> u32  rgb         F
//       char *pInName@@[VĐIuWF̖OiNULL̏ꍇ͖j
//       int inMotNum     [Vԍ
//       int inNoNoize    Ō̃mCY
//------------------------------------------------------------------------------
void
WK7Stage::GoThePast(u32 rgb, char *pInName, int inMotNum, bool inNoNoize)
{
	GXTexObj*	pTexObj;
	WK7JObj* pJObj;
	
	//mCYJn
	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, SFX_SYS_DIMENSION_SAKANOBORU );
	while( gpNoise->mGetSandFrameProc() != eSandExec )		K7SCR_RETSYS();
	
	//mʊJn
	pTexObj = screenImageMonoColor.GetTexObj();
	memcpy( &mMonoTex.obj, pTexObj, sizeof(GXTexObj) );
	mSprt.mSetDispFlag( true );
	
	//mCYmNݒ
	gpNoise->mSandSetMono( true, rgb );
	
	// [VĐA
	if (pInName != NULL){
		if( (pJObj=PlayMotion(pInName, inMotNum)) != NULL ){
			pJObj->StopMotion( false );
		}
	}
	
	//mCY𐰂炷
	if ( inNoNoize == false ){
		while( gpNoise->mSandRelease() == false )				K7SCR_RETSYS();
		while( gpNoise->mGetSandFrameProc() != eSandStandby )	K7SCR_RETSYS();
	}
}

//------------------------------------------------------------------------------
//݂ɖ߂
// in -> char *pInName@@[VĐIuWF̖OiNULL̏ꍇ͖j
//       int inMotNum     [Vԍ
//------------------------------------------------------------------------------
void
WK7Stage::BackTheCurrent(char *pInName, int inMotNum, bool inNoNoize)
{
	WK7JObj* pJObj;
	
	//mCYNGXg
	gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, SFX_SYS_DIMENSION_MODORU );
	while( gpNoise->mGetSandFrameProc() != eSandExec ){K7SCR_RETSYS();}
	
	/* Ó] */
	
	//mʏI
	mSprt.mSetDispFlag( false );
	
	//mCYJ[ݒ
	gpNoise->mSandSetMono( false );
	
	// [VĐA
	if (pInName != NULL){
		if( (pJObj=PlayMotion(pInName, inMotNum)) != NULL ){
			pJObj->StopMotion( false );
		}
	}
	
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	
	//mCY[X
	if ( inNoNoize == false ){
		while( gpNoise->mSandRelease() == false ){K7SCR_RETSYS();}
		while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
	}
}

//------------------------------------------------------------------------------
//ߋ̕\\It
// in --> none
// out -> none
//------------------------------------------------------------------------------
void
WK7Stage::UndispPastFilter( void )
{
	//mʔ\
	mSprt.mSetDispFlag( false );
	//mCYJ[ݒ
	gpNoise->mSandSetMono( false );
	//J߂
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
}

//------------------------------------------------------------------------------
//Lbgp̕SE([vjĐ
// in -> Pos		̔ʒu
//       evFlah		CxgtOiĂAȂȂj
//       seID		SEID
//		Xe[Wς珟ɒ~
//		Lς珟ɒ~
//------------------------------------------------------------------------------
bool WK7Stage::CatWindSePlay(Vec Pos, u32 evFlah, int seID)
{
	if ( K7CAT == WK7PLAYERCONTROL->GetMainID() ){
		KK7SoundLoopSePlayVolumeChange(	Pos,
										K7SCR_STG_GET_CURRENTID(),
										seID,
										SOUND_MASTER_VOLUME,
										0,
										0,
										evFlah,
										K7CAT
		);
		return true;
	}
	return false;
}

//------------------------------------------------------------------------------
//er̃mCY
//------------------------------------------------------------------------------
bool WK7Stage::TvNoise(void)
{
	WK7JObj			*pObj;
	HSD_JObj		*pJObj;
	HSD_DObj		*pDObj;
	HSD_MObj		*pMObj;
	HSD_TObj		*pTObj;
	
	if( (pObj=GetJObj("Display_ON"))==NULL ){
		return false;
	}
	if( (pJObj=pObj->GetJObj())==NULL ){
		return false;
	}
	if( (pDObj=HSD_JObjGetDObj(pJObj))==NULL ){
		return false;
	}
	if( (pMObj=HSD_DObjGetMObj(pDObj))==NULL ){
		return false;
	}
	if( (pTObj=HSD_MObjGetTObj(pMObj))==NULL ){
		return false;
	}
	
	pTObj->wrap_s = GX_REPEAT;
	pTObj->wrap_t = GX_REPEAT;
	
	pTObj->translate.x = HSD_Randf();
	pTObj->translate.y = HSD_Randf();
	
	pTObj->flag |= TEX_MTX_DIRTY;
	
	TvNoiseCallback();
	
	return true;
}

bool WK7Stage::KihanDemoFirst(WK7Npc *pNpc,
                              int init_camid,
                              int term_camid,
                              s16 name_id,
                              s16 name_x,s16 name_y,
                              s16 win_x,s16 win_y,s16 win_w,s16 win_h, s16 manual)
{
	
	//Jݒ
	if( init_camid >= 0 ){
		FixCam((u32)init_camid);
	}
	K7SCR_PC_SETVISIBLE(false);
	
	K7SCR_TIMEWAIT( WK7_SEC_TO_TICK(0.5f) );
	
	SandRelease();		//mCYJiXe[Wj
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	
	//Jړ
	if( term_camid >= 0 ){
		// Y[opSE Y[Jn
		gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOMSTART);
		CamMoveToLinearPath((u32)term_camid,1.0f);
	}
	
#if 1
	
	K7SCR_TIMEWAIT( WK7_SEC_TO_TICK(1) );
	
	// Y[op SE Y[
	gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOM);
	
	// XL̉o
	
	// XLu[Jn
	gpDim->mRequest((s32)WK7_FRAME_TO_TICK(SCAN_RELOAD_TIME));	// XLu[ BATTLE_DIM_FADEIN_TICK
	
	// gbLOmCY
	gpTNoise->mRequest((s32)WK7_FRAME_TO_TICK(SCAN_RELOAD_TIME));
	
	pNpc->SetScanFlag();
#endif
	
	//ЉJn
#ifndef	USE_ISDOLVIEWER
	K7SCR_CHARAPRESENT_DEBUGSTART();
#endif
	
#if 0
	K7SCR_RESERVENAME(K7SCR_CP_STARTTICK, name_id,name_x, name_y, win_x, win_y, win_w, win_h, K7SCR_CP_WAITTIME);
	K7SCR_TIMEWAIT( (K7SCR_CP_WAITTIME + K7SCR_CP_STARTTICK) );						// LƓ
#else
	K7SCR_RESERVENAME(0, name_id,name_x, name_y, win_x, win_y, win_w, win_h, K7SCR_CP_WAITTIME);
	K7SCR_TIMEWAIT( ((K7SCR_CP_WAITTIME + 0) - K7SCR_CP_RELEASETIME) );								// LƓ
#endif
	
//	K7SCR_TIMEWAIT( 2400 );
	if ( !manual ){
		//ЉI
#ifndef	USE_ISDOLVIEWER
		K7SCR_CHARAPRESENT_DEBUGEND();
#endif
	}
	
	return true;
}

bool WK7Stage::KihanDemo(u32 eneno,int camid)
{
	WK7Npc	*pNpc = WK7Npc::Find(eneno);
	
	if( pNpc==NULL ){
		SandRelease();		//mCYJiXe[Wj
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		return false;
	}
	
	pNpc->SetVisible(false);
	
	WK7RenderObjEffect		*pBloodEffect;
	WK7Chara				*pChara = pNpc->pCurrentChara();
	WK7JObj					*pJObj  = pChara->GetJObj();
	Vec						pos,dir;
	f32						roty;
	WK7AnimLinearF			alpha;
	
	C_SetAlpha		*pSetAlpha;
	
	if( camid >= 0 ){
		FixCam((u32)camid);
	}
	
	K7SCR_PC_SETVISIBLE(false);
	
	alpha.SetValue(0.0f);
	
	if( (pSetAlpha = new C_SetAlpha(pJObj->GetJObj(),alpha.GetValue(),false))!=NULL ){
		pSetAlpha->SetVal(alpha.GetValue(),false);
	}
	
	pChara->GetPosition(pos);
	pChara->GetRotY(&roty);
	dir.y = 0.0f;
	dir.x = sinf(roty);
	dir.z = cosf(roty);
	
	pJObj->Disp();
	
	EFFECT		*pYamEfc;
	
	WK7RenderObjEffectInfo	info;
	info.Create();
	SandRelease();		//mCYJiXe[Wj
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	
	pNpc->SetVisible(true);											// \ibV|Š̐vZpj
	K7SCR_RETSYS();													// ΕKv
	
	pNpc->SetPause(1);
	
	pBloodEffect = pChara->CreateEffect((pYamEfc=CreateHSDeadEffect(pJObj,
										dir,
										VParam[ED_HSD1][0] / 10.0F,	// Power ԑ
										pos.y,
										VParam[ED_HSD1][1],			// BloodNum ̐
										(u8)VParam[ED_HSD1][2],		// Wait
										0,							// Mode
										NULL,						// BInfo
										3000,						// BInfoMaxNum
										NULL,						// BInfoNumBuffer		
										false,						// BloodEffectDeleteFlag
										false,						// ConveFlag
										60 * WK7_FRAME_RATE / 30,	// ConveWaitTime
										0.01F,						// ConvePower
										BLOODTEX_BLOOD,
										TRUE,
										TRUE
	)),&info);
	// NPCfĂĂGtFNg\lɐݒ
	pBloodEffect->SetForcedDrawFlag(1);
	pBloodEffect->SetDrawFlag(true);
	
	alpha.Play(1.0f,WK7_SEC_TO_TICK(1.0f));
	
	while( alpha.IsAnimating()==true ){
		alpha.FrameProcess();
		if( pSetAlpha!=NULL ){
			pSetAlpha->SetVal(alpha.GetValue(),false);
		}
		K7SCR_RETSYS();
	}
	
	GHM_SAFE_DELETE(pSetAlpha);
	
	while( pChara->IsValidEffect(pBloodEffect)==true ){
		K7SCR_RETSYS();
	}
	
#if 1
	K7SCR_TIMEWAIT( WK7_SEC_TO_TICK(1) );
	
	// XL̉o
	// XLu[Jn
	gpDim->mRequest((s32)WK7_FRAME_TO_TICK(SCAN_RELOAD_TIME));	// XLu[ BATTLE_DIM_FADEIN_TICK
	// gbLOmCY
	gpTNoise->mRequest((s32)WK7_FRAME_TO_TICK(SCAN_RELOAD_TIME));
	
	pNpc->SetScanFlag();
#endif
	
	K7SCR_TIMEWAIT( WK7_SEC_TO_TICK(3) );
	
	return true;
}

bool WK7Stage::RenewTamaEffect(u32 eventNo)
{
	if( K7SCR_EVHASITEM(eventNo)==TRUE ){
		return ReleaseTamaEffect();
	}
	return CreateTamaEffect(eventNo);
}

WK7RenderObjEffect* WK7Stage::CreateTamaEffect(u32 eventNo)
{
	return CreateTamaEffect(GetTamaJObj(eventNo));
}

WK7RenderObjEffect* WK7Stage::CreateTamaEffect(const char *pName)
{
	return CreateTamaEffect(GetJObj(pName));
}

WK7RenderObjEffect* WK7Stage::CreateTamaEffect(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return NULL;
	}
	
	Vec		pos;
	
	if( IsValidEffect(mpTamaEffect)==true ){
		return mpTamaEffect;
	}
	
	WK7JObj		*pLocator;
	
	if( (pLocator=pJObj->GetObj("tama_fx",false,true))==NULL ){
		pos.x = 0.5f;
		pos.y = 1.2f;
		pos.z = 0.5f;
		mpTamaEffect = CreateEffectTama(pJObj,pos);
	}else{
		pos.x = 0.0f;
		pos.y = 0.0f;
		pos.z = 0.0f;
		mpTamaEffect = CreateEffectTama(pLocator,pos);
	}
	
	return mpTamaEffect;
}

bool WK7Stage::ReleaseTamaEffect(void)
{
	if( mpTamaEffect != NULL ){
		ReleaseEffect(mpTamaEffect);
		mpTamaEffect = NULL;
	}
	return true;
}

