////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage120M00  KVẢ
//
// K7Stage120M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE120M00_CPP__

#include ".\K7Stage120M00.h"
#include ".\K7Stage121M00.h"
#include "..\Scn\K7Scn01.h"
#include "..\Scn\K7Scn03.h"
#include "..\Scn\K7Scn04.h"
#include "..\Scn\K7Scn05.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Kaw\KK7Sound.h"
#include "..\Wat\WK7Item.h"
#include "..\Yam\YK7MapSelect.h"
#include "..\Yam\YK7StageTitle.h"
#include "..\Wat\WK7Item.h"

#define	K7STAGE120M00_SCREAM_FADEVOL_SHIFT		(12)
#define	K7STAGE120M00_SCREAM_FADEVOL_BASE		(1<<K7STAGE120M00_SCREAM_FADEVOL_SHIFT)
#define	K7STAGE120M00_SCREAM_SE_FADESPEED		((K7STAGE120M00_SCREAM_FADEVOL_BASE / 32) * 30 / WK7_FRAME_RATE)
#define	K7STAGE120M00_SCREAM_SE_START			(SFX_SYS_GAL_HOUSE_VOICE_00)
#define	K7STAGE120M00_SCREAM_SE_NUM				(SFX_SYS_GAL_HOUSE_VOICE_20 - K7STAGE120M00_SCREAM_SE_START + 1)
#define	K7STAGE120M00_SCREAM6_SE_START			(SFX_SYS_GAL_HOUSE_VOICE_15)
#define	K7STAGE120M00_SCREAM6_SE_NUM			(SFX_SYS_GAL_HOUSE_VOICE_20 - K7STAGE120M00_SCREAM6_SE_START + 1)

//n[}LJnpmCYĂяo
#define	K7SCR_NOISE_REQUEST_2HAR_ROOM()			while( gpNoise->mSandRequest( eSandLongNoise, eNoiseColorBlue, SFX_SYS_MAP_CHANGE_HACROOM_DEFIN )==false ){K7SCR_RETSYS();}
//n[}LJnpmCY
#define	K7SCR_NOISE_RELEASE_2HAR_ROOM()			while( gpNoise->mGetSandFrameProc() != eSandExec ){K7SCR_RETSYS();} \
												while( gpNoise->mSandRelease(NULL,NULL,NULL,NULL,SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT) == false ){K7SCR_RETSYS();} \
												while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();} \
												K7Stage121M00::mLookIlltreat = true;

static bool gScreamStop120M00 = false;

//******************************************************************************
//yĂяo匳z
//******************************************************************************
//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage120M00::K7Stage120M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mStageInit    = false;
	mScreamSE     = true;
	gScreamStop120M00 = false;
}
//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage120M00::~K7Stage120M00()
{
	GameInfo.SetItemEnable(true);
	GameInfo.SetSpecialEnable(true);
	GameInfo.SetMenuMapEnable(true);
	WK7PLAYERCONTROL->ClearWalkOnly();
	WK7PLAYERCONTROL->BattlePadRegulationClear();
	gScreamStop120M00 = false;
}
//------------------------------------------------------------------------------
//ߖRg[
//------------------------------------------------------------------------------
K7Stage120M00_Scream::K7Stage120M00_Scream(ghmGcTaskController *pTaskController)
{
	mSeID    = -1;
	mPan     = SOUND_PAN_CENTER;
	mVol     = 0;
	mProc    = 0;
	mFadeVol = K7STAGE120M00_SCREAM_FADEVOL_BASE;
	mTaskID  = -1;
	mWait    = 0;
	if( (mpTaskController=pTaskController)!=NULL ){
		mTaskID = pTaskController->Start(ScreamTask,ScreamTaskTerm,(u32)this,0UL);
	}
}

K7Stage120M00_Scream::~K7Stage120M00_Scream()
{
	if( mSeID >= 0 ){
		gpSound->mStopSENo(mSeID);
		mSeID  = -1;
	}
}
	
bool K7Stage120M00_Scream::Start(void)
{
	if( mProc < 0 ){
		return false;
	}
	mProc = 1;
	return true;
}

bool K7Stage120M00_Scream::Stop(void)
{
	if( mProc < 0 ){
		return false;
	}
	mProc = 2;
	return true;
}
	
bool K7Stage120M00_Scream::Delete(void)
{
	mProc = -1;
	return true;
}

bool K7Stage120M00_Scream::CalcVolPan(void)
{
static	Vec	pos = { 108.308f,11.532f,27.536f };
	u8		vol,pan;
	
	seVolCalc(pos,SOUND_EVENT_SE_VOLUME,&vol,&pan,1);
	mVol = (u32)vol;
	mPan = (u32)pan;
	
	return true;
}

bool K7Stage120M00_Scream::FrameProcess(void)
{
	if( gScreamStop120M00==true ){
		return false;
	}
	if( mSeID >= 0 ){
		if( gpSound->mCheckSENo(mSeID)==false ){
			mSeID = -1;
		}
	}
	switch( mProc ){
	case	0:
		break;
	case	1:
		if( mFadeVol <= K7STAGE120M00_SCREAM_FADEVOL_BASE - K7STAGE120M00_SCREAM_SE_FADESPEED ){
			mFadeVol += K7STAGE120M00_SCREAM_SE_FADESPEED;
		}else{
			mFadeVol  = K7STAGE120M00_SCREAM_FADEVOL_BASE;
		}
		break;
	case	2:
	default:
		if( mFadeVol >= K7STAGE120M00_SCREAM_SE_FADESPEED ){
			mFadeVol -= K7STAGE120M00_SCREAM_SE_FADESPEED;
		}else{
			mFadeVol  = 0;
		}
		break;
	}
	switch( mProc ){
	case	1:
	case	2:
		CalcVolPan();
		break;
	case	0:
		break;
	default:
		if( mFadeVol==0 ){
			return false;
		}
		break;
	}
	
	if( mSeID < 0 ){
		if( mWait > 0 ){
			mWait -= WK7_TICK_PER_FRAME;
		}else{
			int		seid;
			if( GameInfo.GetScenarioID()==K7SCN06 ){
				seid = K7STAGE120M00_SCREAM6_SE_START + HSD_Randi(K7STAGE120M00_SCREAM6_SE_NUM);
			}else{
				seid = K7STAGE120M00_SCREAM_SE_START  + HSD_Randi(K7STAGE120M00_SCREAM_SE_NUM );
			}
			mSeID = gpSound->mPlaySE(seid);
			mWait  = (int)(WK7_SEC_TO_TICK(0.5f) + HSD_Randi(WK7_SEC_TO_TICK(2.5f)));
		}
	}
	
	if( mSeID >= 0 ){
		// {[ύXit[wj
		gpSound->mSetVolumeSENo(mSeID,(u8)(mVol * mFadeVol >> K7STAGE120M00_SCREAM_FADEVOL_SHIFT),1);
		
		// pύXit[wj
		gpSound->mSetPanSENo   (mSeID,(u8)mPan);
	}
	
	return true;
}
	
void K7Stage120M00_Scream::ScreamTask(ghmGcTask *)
{
	K7Stage120M00_Scream		*pScream = (K7Stage120M00_Scream *)GHMGCTASK_GETPARAM(0);
	while( pScream->FrameProcess()==true ){
		K7SCR_RETSYS();
	}
}

void K7Stage120M00_Scream::ScreamTaskTerm(ghmGcTask *)
{
	K7Stage120M00_Scream		*pScream = (K7Stage120M00_Scream *)GHMGCTASK_GETPARAM(0);
	GHM_SAFE_DELETE(pScream);
}

bool K7Stage120M00::PlayScream(void)
{
	mScreamSE = true;
	return true;
}
bool K7Stage120M00::StopScream(void)
{
	mScreamSE = false;
	return true;
}
bool K7Stage120M00::ScreamControl(void)
{
	ghmGcMemSetAllocName("120Scr");
	K7Stage120M00_Scream	*pScream = new K7Stage120M00_Scream(WK7EVENTCONTROLLER->GetFrameProcessTaskController());
	PlayScream();
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
		if( gScreamStop120M00==true ){
			return true;
		}
		if( mScreamSE==true ){
			pScream->Start();
		}else{
			pScream->Stop();
		}
		K7SCR_RETSYS();
	}
	if( gScreamStop120M00==true ){
		return true;
	}
	pScream->Delete();
	return true;
}
//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool K7Stage120M00::SetCurrentCallBack(void)
{
	SetCurrentCallBackDefaultProc();
	
	WK7PLAYERCONTROL->SetWalkOnly();
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_NO);
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_MANUALRELOAD);
	GameInfo.SetSpecialEnable(false);
	GameInfo.SetMenuMapEnable(false);
	if( mStageInit==true ){
		ScreamControl();
		return true;
	}
	//	Xe[WOQ̂Ƃsuo
	if( GameInfo.GetScenarioID() == K7SCN02 ){
		mpModel->GetObj("PortableTV")->Disp(false,true);
	}
	
	Vec	savePos;
	f32	rotY;
	u32	pcID;
	
	GameInfo.SetItemEnable(false);
	
	mStageInit = true;
	
	//OAĂKVAɕϐg
	switch( GetPrevStageID() )
	{
		//n[}
		case	K7STGID(121,1):
			K7SCR_STG_SET_JUNCTION_PASS(K7STGID(121, 0),"door_990001");
		case	K7STGID(121,0):
		// n
		case	K7STGID(122,0):
			break;
		default:
			if( gpNoise->mGetSandFrameProc()!=eSandExec ){
				break;
			}
		//KVAɕϐg
			SetManualBranch( true );
			while( WK7Stage::IsChanging() == true ){K7SCR_RETSYS();}
			if( WK7PLAYERCONTROL->GetMainID() != K7GAL )
			{
				// Lǂݑւ
				WK7PLAYERCONTROL->GetPosition(&savePos);
				WK7PLAYERCONTROL->GetRotY(&rotY);
				
				pcID = K7CHRID(K7GAL,0);
				if( pcID != 0xffffffff )
				{
					WK7PLAYERCONTROL->Reset();
					WK7PLAYERCONTROL->ReleaseAll();
					GHMGCTASK_RETSYS();
					
					WK7PLAYERCONTROL->CreateModel(pcID);
					WK7PLAYERCONTROL->CreatePackMotion(pcID);
					GHMGCTASK_RETSYS();
					
					while( true == WK7PLAYERCONTROL->IsLoading() )
					{
						GHMGCTASK_RETSYS();
					}
					// vC[|[Y
					WK7PLAYERCONTROL->SetOperateEnable(false);
					
					WK7PLAYERCONTROL->SetVisible(true);
					WK7PLAYERCONTROL->SetPosition(&savePos);
					WK7PLAYERCONTROL->SetRotY(rotY);
					WK7PLAYERCONTROL->ChangeCallback();
				}
				
				WK7PLAYERCONTROL->SetWalkOnly();
				
			}
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			WK7PLAYERCONTROL->SetVisible(true);
			K7SCR_STG_VISIBLE(K7STGID(120,0), true);
			switch( GameInfo.GetScenarioFlow() ){
			case	K7SCNF_KAK:	// pr
			case	K7SCNF_CUR:	// J[eBX@
			case	K7SCNF_DM2:	// h~jJ
			case	K7SCNF_SCL:	// wZ
			case	K7SCNF_HT2:	// zeQ
				// ViI`ȊO
				SetCurrentPath("door_990000",NULL);
//				SetCurrentPath(	GetPathNurbsAll("curve3"),
//								0.170f,
//								0,									// 0:forward 1:back
//								WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV0
				SetCameraStartPosition(GetPlaceInfo("door_990000"));
				WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
				break;
			case	K7SCNF_CEL:	// ZeBbN
			case	K7SCNF_FUK:	// tNV}
			case	K7SCNF_TXS:	// eLTXO
			case	K7SCNF_ISZ:	// VniCVUJhj
			case	K7SCNF_DM1:	// h~jJO
			case	K7SCNF_HT1:	// zeP
			case	K7SCNF_GNK:	// R͓
			default:
				// ViI`
				SetCurrentPath(	GetPathNurbsAll("curve3"),
								0.170f,
								0,									// 0:forward 1:back
								WK7PATHINFO_INITDIR_TGTDIR_REV );
				WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
				Vec		initpos;
				WK7PLAYERPATHCONTROL->GetCurrentPosition(&initpos);
				WK7CAMPATHFOLLOWINFO->SetStageStartMode              (true);
				WK7CAMPATHFOLLOWINFO->SetStageStartCamPosition       ((Vec){-11.308f, 3.781f, -5.028f});
				WK7CAMPATHFOLLOWINFO->SetStageStartCamTargetPosition ((Vec){-6.197f, 10.950f, 14.527f});
				WK7CAMPATHFOLLOWINFO->SetStageStartTargetInitPosition(initpos);
				break;
			}
			K7SCR_EVCONDCHANGE();
			SandRelease();		//mCYJiXe[Wj
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){GHMGCTASK_RETSYS();}
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			SetManualBranch( false );
			break;
	}
	
	ScreamControl();
	return true;
}
//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool K7Stage120M00::CondChangeCallBack(void)
{
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_NO);
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_MANUALRELOAD);
	bool	lock;
	if( GameInfo.GetScenarioID()==K7SCN06 ){
		lock = false;
	}else{
		lock = true;
	}
	SetVisibleJObj("Door_Locked"  ,lock       ,false,true);
	SetVisibleJObj("Door_UnLocked",lock==false,false,true);
	switch( GameInfo.GetScenarioID() ){
	case	K7SCN01: return CondChangeCallBack01(); 
	case	K7SCN02: return CondChangeCallBack02(); 
	case	K7SCN03: return CondChangeCallBack03(); 
	case	K7SCN04: return CondChangeCallBack04(); 
	case	K7SCN05: return CondChangeCallBack05(); 
	case	K7SCN06: return CondChangeCallBack06(); 
	default:
		break;
	}
	return true;
}
//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool K7Stage120M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	bool ret = true;

	switch( GameInfo.GetScenarioID() ){
	case	K7SCN01: ret = DoorEventCallBack01(info); break;
	case	K7SCN02: ret = DoorEventCallBack02(info); break;
	case	K7SCN03: ret = DoorEventCallBack03(info); break;
	case	K7SCN04: ret = DoorEventCallBack04(info); break;
	case	K7SCN05: ret = DoorEventCallBack05(info); break;
	case	K7SCN06: ret = DoorEventCallBack06(info); break;
	default:
		break;
	}
	
	BattleCtrl.InitDefaultReCallChara();
	BattleCtrl.ReleaseDeadTask();
	BattleCtrl.DeadPlayerInit();
	WK7PLAYERCONTROL->ChangeStartChkPoint();
	// KVnEXoāACQ[ Xe[Wɖ߂ƂɑOLI\ɂĂiȂƁj
//	ClearCharChangeMask();
	return ret;
}




//******************************************************************************
//yz
//******************************************************************************
//------------------------------------------------------------------------------
//ԕύXEViIPyz
//------------------------------------------------------------------------------
bool K7Stage120M00::CondChangeCallBack01(void)
{
	switch( GameInfo.GetScenarioFlow() ){
	case	K7SCNF_FUK:
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990003),false);
		if( WK7Play::HasPlayed(K7EVENTPLAY(01020203))==false ){
	//	if( WK7Play::HasPlayed(K7EVENTPLAY(01020201))==false ){
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990000),false);
		}else{
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990000),true);
		}
		break;
	default:
	case	K7SCNF_KAK:
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990003),false);
		break;
	}
	return true;
}

//------------------------------------------------------------------------------
//hACxgEViIPyz
//------------------------------------------------------------------------------
bool K7Stage120M00::DoorEventCallBack01FUK(WK7DoorEventInfo &info)
{
	s32		mapid;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(990000):
		K7SCR_RESET_SCENARIO_FLAG(K7SCN01_HIDE_SMA);
		
		StopScream();
		
//		ClearChangeChara();
//		SetChangeChara(K7DAN,true );
//		SetChangeChara(K7GAL,true );
//		SetChangeChara(K7CON,true );
//		SetChangeChara(K7HAC,true );
//		SetChangeChara(K7HAS,true );
//		SetChangeChara(K7HAY,true );
//		SetChangeChara(K7CYO,true );
//		SetChangeChara(K7KED,true );
//		SetChangeChara(K7KVN,true );
//		SetChangeChara(K7MSK,true );
//#if 1
//		BattleCtrl.InitDefaultReCallChara();
//#else
//		BattleCtrl.PcReCallSet (K7HAC, 0);
//		BattleCtrl.PcReCallSet (K7CYO, 1);
//		BattleCtrl.PcReCallSet (K7KED, 1);
//		BattleCtrl.PcReCallSet (K7MSK, 1);
//#endif
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_NOISE_REQUEST();
		K7SCR_STG_VISIBLE( K7STGID(120,0), false );
		K7SCR_PC_VISIBLE( false );
		
		mapid = MAP_GAL_HOME;
		
		if( WK7Play::HasPlayed(K7EVENTPLAY(01030101))==false ){
			gpSound->mStopStream();
			
#if	0
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_GAL_HOME,MAP_OKUTAGON);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			// y^S
			u32		charaid = WK7PLAYERCONTROL->GetID();
			WK7Play::StorePlayTB();
			WK7PLAYERCONTROL->SetOperateEnable(false);
			WK7PLAYERCONTROL->Reset();
			WK7PLAYERCONTROL->ReleaseAll();
			WK7Stage::DeleteStage(this);
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			WK7Play::PlayTB(K7EVENTPLAY(01030101));
			
			// ViI^Cg
			
			WK7Play::RestorePlayTB(false);
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			gpSound->mStopStream();
#else
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_GAL_HOME,MAP_OKUTAGON);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
			u32		charaid = WK7PLAYERCONTROL->GetID();
			K7SCR_NOISE_REQUEST();
			WK7PLAYERCONTROL->SetOperateEnable(false);
			WK7PLAYERCONTROL->Reset();
			WK7PLAYERCONTROL->ReleaseAll();
			WK7Stage::DeleteStage(this);
			K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(01030101) );
			K7SCR_NOISE_RELEASE();
			
			K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(01030101) );
			
			K7SCR_NOISE_REQUEST();
			K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(01030101) );
#endif
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_OKUTAGON,MAP_VIADU);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
			StopScream();
#if	0
			WK7Play::StorePlayTB();
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			
			WK7Play::PlayTB(K7EVENTPLAY(01040101));
			
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
			
			WK7PLAYERCONTROL->CreateModel(charaid);
			WK7PLAYERCONTROL->CreatePackMotion(charaid);
			WK7PLAYERCONTROL->SetOperateEnable(false);
			WK7PLAYERCONTROL->SetVisible(true);
			WK7PLAYERPATHCONTROL->CameraRenew();
			while( WK7PLAYERCONTROL->IsLoading()==true ){
				K7SCR_RETSYS();
			}
			WK7PLAYERCONTROL->ChangeCallback();
			WK7Play::RestorePlayTB(false);
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
#else
			K7SCR_NOISE_REQUEST();
			K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(01040101) );
			K7SCR_NOISE_RELEASE();
			
			K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(01040101) );
			
			K7SCR_NOISE_REQUEST();
			K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(01040101) );
			WK7PLAYERCONTROL->CreateModel(charaid);
			WK7PLAYERCONTROL->CreatePackMotion(charaid);
			WK7PLAYERCONTROL->SetOperateEnable(false);
			WK7PLAYERCONTROL->SetVisible(true);
			WK7PLAYERPATHCONTROL->CameraRenew();
			while( WK7PLAYERCONTROL->IsLoading()==true ){
				K7SCR_RETSYS();
			}
			WK7PLAYERCONTROL->ChangeCallback();
#endif
			
			mapid = MAP_VIADU;
		}

#if	0
		gpSound->mStopStream();
#endif
		K7SCR_NOISE_RELEASE_TO_MAP();
		GameInfo.MapSelectInit(mapid,MAP_FUKUSHIMA);
		while( GameInfo.CheckMapSelectEnd()==false ){
			K7SCR_RETSYS();
		}
		GameInfo.MapSelectEnd();
		
		K7SCR_SCENARIO_TITLE_DISP(ST_FUKUSHIMA);
		
		K7SCR_PC_SETVISIBLE( true );
		
		info.mNextStageID = K7STGID(190, 0);
		strncpy(info.mNextBpName,"start",WK7DOOREVENT_BPNAME_MAX-1);
		
		return true;
	case	K7EVENTDOOR(990001):
		if( WK7Play::HasPlayed(K7EVENTPLAY(01020201))==false ){
			StopScream();
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_NOISE_REQUEST_2HAR_ROOM();
			K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(01020201) );
			K7SCR_NOISE_RELEASE_2HAR_ROOM();
			K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(01020201) );
			K7SCR_NOISE_REQUEST();
			K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(01020201) );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage120M00::DoorEventCallBack01KAK(WK7DoorEventInfo &info)
{
	WK7Play		*pPlay;
	u32			playno;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(990000):
		K7SCR_ENTER_PLAYMODE();
		gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
		StopScream();
		
		WK7Chara::SetRenderChara(false);
		WK7Stage::SetRenderStage(false);
		WK7Item::SetRenderItem  (false);
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		
		WK7Stage::DeleteStage(this);
		WK7PLAYERCONTROL->ReleaseArchive();
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
			K7SCR_RETSYS();
		}
		
		playno = K7EVENTPLAY(01060101);
		if( WK7Play::HasPlayed(playno)==false ){
			
			WK7EVENTCONTROLLER->ReleaseTempData2();
			while( WK7EVENTCONTROLLER->IsReleasedTempData2()==false ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			gpSound->mStopStream();
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_GAL_HOME,MAP_TEARROOM);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
//			while( !(HSD_PadGetTrigger(1) & HSD_PAD_A) ){
//				if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
//					K7AppDumpMemory();
//				}
//				K7SCR_RETSYS();
//			}
			
			// i
			
			K7SCR_ENTER_PLAYMODE();
			
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			while( (pPlay=WK7Play::Create(playno))==NULL ){
				K7SCR_RETSYS();
			}
			pPlay->Prepare();
			
			WK7Play::StorePlayTB();
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			pPlay->Start();
			K7SCR_RETSYS();
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
				K7SCR_RETSYS();
			}
			pPlay->SetVisibleAll(false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			GHM_SAFE_DELETE(pPlay);
			WK7Play::RestorePlayTB();
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7Play::SetPlayed(playno,true);
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			// iprփ}bvړ
			
			gpSound->mStopStream();
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_TEARROOM,MAP_SQUARE_BUIL);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
//			while( !(HSD_PadGetTrigger(1) & HSD_PAD_A) ){
//				if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
//					K7AppDumpMemory();
//				}
//				K7SCR_RETSYS();
//			}
			
			K7SCR_ENTER_PLAYMODE();
			
			K7SCR_SCENARIO_TITLE_DISP(ST_KAKUBUILL);
			
			// ALoƃNnVAJႷ}cP
			
			K7SCR_ENTER_PLAYMODE();
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			playno = K7EVENTPLAY(01090101);
			while( (pPlay=WK7Play::Create(playno))==NULL ){
				K7SCR_RETSYS();
			}
			pPlay->Prepare();
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			WK7Play::StorePlayTB();
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			pPlay->Start();
			K7SCR_RETSYS();
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
				K7SCR_RETSYS();
			}
			pPlay->SetVisibleAll(false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			GHM_SAFE_DELETE(pPlay);
			WK7Play::RestorePlayTB();
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7Play::SetPlayed(playno,true);
			
			while( WK7EVENTCONTROLLER->LoadData()==false ){
				K7SCR_RETSYS();
			}
			while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
		}else{
		
			gpSound->mStopStream();
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_GAL_HOME,MAP_SQUARE_BUIL);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
		}
		
		WK7Chara::SetRenderChara(true);
		WK7Stage::SetRenderStage(true);
		WK7Item::SetRenderItem  (true);
		
		info.mNextStageID = K7STGID(137, 0);
		strncpy(info.mNextBpName,"set9",WK7DOOREVENT_BPNAME_MAX-1);
		
		return true;
	default:
		break;
	}
	return true;
}

bool K7Stage120M00::DoorEventCallBack01(WK7DoorEventInfo &info)
{
	switch( GameInfo.GetScenarioFlow() ){
	//pr
	case	K7SCNF_KAK:
		return DoorEventCallBack01KAK(info);
	default:
		return DoorEventCallBack01FUK(info);
	}
	return true;
}


//******************************************************************************
//y_jz
//******************************************************************************
//------------------------------------------------------------------------------
//ԕύXEViIQy_jz
//------------------------------------------------------------------------------
bool K7Stage120M00::CondChangeCallBack02(void)
{
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990003),false);
	if( WK7Play::HasPlayed(K7EVENTPLAY(02020203))==false ){
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990000),false);
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990000),true);
	}
	return true;
}
//------------------------------------------------------------------------------
//hACxgEViIQy_jz
//------------------------------------------------------------------------------
bool K7Stage120M00::DoorEventCallBack02(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	//	KVAł	-----------------------------------
	case	K7EVENTDOOR(990000):
		StopScream();
		SimpleMapMove( MAP_GAL_HOME, MAP_VIADU, K7STGID(120,0) );

//		ClearChangeChara();
//		SetChangeChara(K7DAN,true );
//		SetChangeChara(K7GAL,true );
//		SetChangeChara(K7CON,true );
//		SetChangeChara(K7HAC,true );
//		SetChangeChara(K7HAS,true );
//		SetChangeChara(K7HAY,true );
//		SetChangeChara(K7CYO,true );
//		SetChangeChara(K7KED,true );
//		SetChangeChara(K7KVN,true );
//		SetChangeChara(K7MSK,true );
//#if 1
//		BattleCtrl.InitDefaultReCallChara();
//#else
//		BattleCtrl.PcReCallSet (K7HAC, 0);
//		BattleCtrl.PcReCallSet (K7CYO, 1);
//		BattleCtrl.PcReCallSet (K7KED, 1);
//		BattleCtrl.PcReCallSet (K7MSK, 1);
//#endif

		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_NOISE_REQUEST();
		if( WK7Play::HasPlayed(K7EVENTPLAY(02030101))==false )
		{
			u32		charaid = WK7PLAYERCONTROL->GetID();
			K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(02030101) );
			WK7PLAYERCONTROL->SetOperateEnable(false);
			WK7PLAYERCONTROL->Reset();
			WK7PLAYERCONTROL->ReleaseAll();
			WK7Stage::DeleteStage(this);
			K7SCR_NOISE_RELEASE();
			
			K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(02030101) );
			
			K7SCR_NOISE_REQUEST();
//			K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(02030101) );
		WK7Play*	pPlay = WK7Play::Find(K7EVENTPLAY(02030101));
		pPlay->SetVisibleAll( false );
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		GHM_SAFE_DELETE( pPlay );
		WK7Play::RestorePlayTB(false);
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		WK7Play::SetPlayed( K7EVENTPLAY(02030101),true );
//		WK7Chara::SetRenderChara(true);
//		WK7Stage::SetRenderStage(true);
//		WK7Item::SetRenderItem  (true);
			K7SCR_NOISE_RELEASE_TO_MAP();
			
			//}bvړ
			GameInfo.MapSelectInit( MAP_VIADU, MAP_INTER_CITY );
			//}bvړʕ`
			while( GameInfo.CheckMapSelectEnd() == false )
			{
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
			K7SCR_SCENARIO_TITLE_DISP( ST_TEXAS );
			K7SCR_MOVIE_PLAY_NO_NOISE(K7MOV_TRACTOR);
			
			K7SCR_PC_CREATE(charaid);					// fǂݍ
			K7SCR_PC_MOTIONCREATE(charaid);				// [Vǂݍ
			WK7PLAYERCONTROL->SetOperateEnable(false);
			WK7PLAYERCONTROL->SetVisible(true);
			WK7PLAYERPATHCONTROL->CameraRenew();
			K7SCR_PC_CREATEWAIT();						// ǂݍݑ҂
			WK7PLAYERCONTROL->ChangeCallback();
		}
		// X^[g`FbN|Cg̐ݒ
		info.mNextStageID = K7STGID(200, 0);
		strncpy(info.mNextBpName,"texas_start",WK7DOOREVENT_BPNAME_MAX-1);
		return true;

	case	K7EVENTDOOR(990001):
		if( WK7Play::HasPlayed(K7EVENTPLAY(02020201))==false ){
			StopScream();
			//inGame~
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_NOISE_REQUEST_2HAR_ROOM();
			K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(02020201) );
			K7SCR_NOISE_RELEASE_2HAR_ROOM();
			K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(02020201) );
			K7SCR_NOISE_REQUEST();
			K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(02020201) );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		break;
	}
	return true;
}



	
//******************************************************************************
//y琁z
//******************************************************************************
//------------------------------------------------------------------------------
//ԕύXEViIRy琁z
//------------------------------------------------------------------------------
bool K7Stage120M00::CondChangeCallBack03(void)
{
	switch( GameInfo.GetScenarioFlow() )
	{
		//Vn
		case	K7SCNF_ISZ:
			//n[}s҂̃LĂȂΊOɂ͏oȂ
			if( WK7Play::HasPlayed(K7EVENTPLAY(03020203)) == false )
			{
				K7SCR_EVNO_SETENABLE( K7EVENTDOOR(990000), false );
			}else
			{
				K7SCR_EVNO_SETENABLE( K7EVENTDOOR(990000), true );
			}
			break;
		//J[eBX@
		case	K7SCNF_CUR:
			break;
		//ftHg
		default:
			break;
	}
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990003),false);
	
	return( true );
}
//------------------------------------------------------------------------------
//hACxgEViIRy琁z
//------------------------------------------------------------------------------
bool K7Stage120M00::DoorEventCallBack03(WK7DoorEventInfo &info)
{
	switch( GameInfo.GetScenarioFlow() )
	{
		//Vn
		case	K7SCNF_ISZ:
			switch( info.mEventNo )
			{
				//o
				case	K7EVENTDOOR( 990000 ):
					StopScream();
					Setup03ISZ();
//					ClearChangeChara();
//					SetChangeChara(K7DAN,true );
//					SetChangeChara(K7GAL,true );
//					SetChangeChara(K7CON,true );
//					SetChangeChara(K7HAC,true );
//					SetChangeChara(K7HAS,true );
//					SetChangeChara(K7HAY,true );
//					SetChangeChara(K7CYO,true );
//					SetChangeChara(K7KED,true );
//					SetChangeChara(K7KVN,true );
//					SetChangeChara(K7MSK,true );
//#if 1
//					BattleCtrl.InitDefaultReCallChara();
//#else
//					BattleCtrl.PcReCallSet (K7HAC, 0);
//					BattleCtrl.PcReCallSet (K7CAT, 1);
//					BattleCtrl.PcReCallSet (K7DAN, 1);
//					BattleCtrl.PcReCallSet (K7CYO, 1);
//					BattleCtrl.PcReCallSet (K7KVN, 1);
//#endif
					info.mNextStageID = K7STGID( 300, 0 );
					strcpy( info.mNextBpName, "branchA" );
					break;
				//n[}
				case	K7EVENTDOOR( 990001 ):
					if( WK7Play::HasPlayed(K7EVENTPLAY(03020201)) == false )
					{
						StopScream();
						//inGame~
						K7SCR_ENTER_PLAYMODE_B();
						K7SCR_ENTER_DEMOPAUSE();
						K7SCR_NOISE_REQUEST_2HAR_ROOM();
						K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(03020201) );
						K7SCR_NOISE_RELEASE_2HAR_ROOM();
						K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(03020201) );
						K7SCR_NOISE_REQUEST();
						K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(03020201) );
						//inGameĊJ
						K7SCR_EXIT_PLAYMODE();
						K7SCR_EXIT_DEMOPAUSE();
					}
					break;
				//ftHg
				default:
					break;
			}
			break;
		
		//J[eBX@
		case	K7SCNF_CUR:
			switch( info.mEventNo )
			{
				//o
				case	K7EVENTDOOR( 990000 ):
					StopScream();
					Setup03CUR();
					info.mNextStageID = K7STGID( 350, 0 );
					strcpy( info.mNextBpName, "set3" );
					break;
				//ftHg
				default:
					break;
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//VnX^[g&X^[g
//------------------------------------------------------------------------------
void
K7Stage120M00::Setup03ISZ( void )
{
	if( K7SCR_GET_SCENARIO_FLAG(EV03DISP_TITLE_ISZ) == false )
	{
		//}bvړ KVẢƁRXe
		SimpleMapMove( MAP_GAL_HOME, MAP_VIADU, K7STGID(120,0) );
		//LĐ
		K7SCR_NOISE_REQUEST();
		K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(03030101) );
		K7SCR_NOISE_RELEASE();
		K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(03030101) );
		K7SCR_NOISE_REQUEST();
		K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(03030101) );
		//}bvړ RXeVn
		K7SCR_STG_VISIBLE( K7STGID(120,0), false );
		K7SCR_PC_VISIBLE( false );
		//SimpleMapMove( MAP_VIADU, MAP_ISZKLAND, K7STGID(120,0) );
		K7SCR_NOISE_RELEASE_TO_MAP();
		//}bvړ
		GameInfo.MapSelectInit( MAP_VIADU, MAP_ISZKLAND );
		//}bvړʕ`
		while( GameInfo.CheckMapSelectEnd() == false )
		{
			K7SCR_RETSYS();
		}
		GameInfo.MapSelectEnd();
		
		//ViI^Cg\
		K7SCR_SCENARIO_TITLE_DISP( ST_ISHIZAKALAND );
		K7SCR_SET_SCENARIO_FLAG( EV03DISP_TITLE_ISZ );
		
		K7SCR_PC_VISIBLE( true );
	}else
	{
		//}bvړ KVẢƁVn
		SimpleMapMove( MAP_GAL_HOME, MAP_ISZKLAND, K7STGID(120,0) );
	}
}
//------------------------------------------------------------------------------
//J[eBX@X^[g&X^[g
//------------------------------------------------------------------------------
void
K7Stage120M00::Setup03CUR( void )
{
	if( K7SCR_GET_SCENARIO_FLAG(EV03DISP_TITLE_CUR) == false )
	{
		//Xe[W\
		K7SCR_STG_VISIBLE( K7STGID(120,0), false );
		K7SCR_PC_VISIBLE( false );
		
		//}bvړ
		SimpleMapMove( MAP_GAL_HOME, MAP_SPORTCLUB, K7STGID_INVALID );
		
		//yhƃJ[eBXÊQ
		K7SCR_NOISE_REQUEST();
		K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(03060102) );
		K7SCR_NOISE_RELEASE();
		K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(03060102) );
		K7SCR_NOISE_REQUEST();
		K7SCR_CHARAGEKI_TERM	( K7EVENTPLAY(03060102) );
		K7SCR_STG_VISIBLE( K7STGID(120,0), false );
		K7SCR_PC_VISIBLE( false );
		K7SCR_NOISE_RELEASE_TO_MAP();
		
		//}bvړ
		GameInfo.MapSelectInit( MAP_SPORTCLUB, MAP_CATHISU_HOUSE );
		//}bvړʕ`
		while( GameInfo.CheckMapSelectEnd() == false )
		{
			K7SCR_RETSYS();
		}
		GameInfo.MapSelectEnd();
		
		//KVAƃ~YL
		K7SCR_NOISE_REQUEST();
		K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(03050101) );
		K7SCR_NOISE_RELEASE();
		K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(03050101) );
		K7SCR_CHARAGEKI_TERM	( K7EVENTPLAY(03050101) );
		K7SCR_STG_VISIBLE( K7STGID(120,0), false );
		K7SCR_PC_VISIBLE( false );
		
		//ViI^Cg\
		K7SCR_SCENARIO_TITLE_DISP( ST_CATHISU_HOUSE );
		K7SCR_SET_SCENARIO_FLAG( EV03DISP_TITLE_CUR );
		K7SCR_PC_VISIBLE( true );
	}else
	{
		//}bvړ KVẢƁVn
		SimpleMapMove( MAP_GAL_HOME, MAP_CATHISU_HOUSE, K7STGID(120,0) );
	}
}



	
//******************************************************************************
//ygz
//******************************************************************************
//------------------------------------------------------------------------------
//ԕύXEViISygz
//------------------------------------------------------------------------------
bool K7Stage120M00::CondChangeCallBack04(void)
{
	switch( GameInfo.GetScenarioFlow() )
	{
		//h~jJO
		case	K7SCNF_DM1:
			//n[}̃LĂȂΊOɂ͏oȂ
			if( K7SCR_GET_SCENARIO_FLAG(MV040001) == false )
			{
				K7SCR_EVNO_SETENABLE( K7EVENTDOOR(990000), false );
			}else
			{
				K7SCR_EVNO_SETENABLE( K7EVENTDOOR(990000), true );
			}
			break;
		//h~jJ
		case	K7SCNF_DM2:
			break;
		//ftHg
		default:
			break;
	}
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990003),false);
	
	return( true );
}
//------------------------------------------------------------------------------
//hACxgEViISygz
//------------------------------------------------------------------------------
bool K7Stage120M00::DoorEventCallBack04(WK7DoorEventInfo &info)
{
	switch( GameInfo.GetScenarioFlow() )
	{
		//h~jJO
		case	K7SCNF_DM1:
			switch( info.mEventNo )
			{
				//o
				case	K7EVENTDOOR( 990000 ):
					gScreamStop120M00 = true;
					Setup04DM1();
					info.mNextStageID = K7STGID( 410, 0 );
					strcpy( info.mNextBpName, "dominica_start" );
					break;
				//n[}
				case	K7EVENTDOOR( 990001 ):
					if( K7SCR_GET_SCENARIO_FLAG(MV040000) == false )
					{
						gScreamStop120M00 = true;
						//inGame~
						K7SCR_ENTER_PLAYMODE_B();
						K7SCR_ENTER_DEMOPAUSE();
						K7SCR_NOISE_REQUEST_2HAR_ROOM();
						K7SCR_STG_VISIBLE( mID, false );
						K7SCR_STAGE_RELEASE();
						K7SCR_TIMEWAIT( 4800*2 );
						K7SCR_NOISE_RELEASE_2HAR_ROOM();
						//[r[Đ
						K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_04010201 );	//n[}s
						K7SCR_NOISE_REQUEST();
						K7SCR_SET_SCENARIO_FLAG( MV040000 );
						K7SCR_STAGE_RESTORE();
						//inGameĊJ
						K7SCR_EXIT_PLAYMODE();
						K7SCR_EXIT_DEMOPAUSE();
					}
					break;
				//ftHg
				default:
					break;
			}
			break;
		//h~jJ
		case	K7SCNF_DM2:
			switch( info.mEventNo )
			{
				//o
				case	K7EVENTDOOR( 990000 ):
					gScreamStop120M00 = true;
					Setup04DM2();
					info.mNextStageID = K7STGID( 430, 0 );
					strcpy( info.mNextBpName, "branchA" );
					break;
				//ftHg
				default:
					break;
			}
			break;
		//ftHg
		default:
			break;
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//h~jJO҃X^[g&X^[g
//------------------------------------------------------------------------------
void
K7Stage120M00::Setup04DM1( void )
{
	if( K7SCR_GET_SCENARIO_FLAG(EV04DISP_TITLE_DM1) == false )
	{
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		//mCY
		K7SCR_NOISE_REQUEST();
		//Xe[W\
		K7SCR_STG_VISIBLE( K7STGID(120,0), false );
		K7SCR_STAGE_RELEASE();
		K7SCR_PC_VISIBLE( false );
		//mCY
		K7SCR_NOISE_RELEASE_TO_MAP();
		//}bvړ
		GameInfo.MapSelectInit(MAP_GAL_HOME, MAP_VIADU );
		while( GameInfo.CheckMapSelectEnd()==false ){
			K7SCR_RETSYS();
		}
		GameInfo.MapSelectEnd();
		
		//[r[ĐERXe
		K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_04040101 );
		
		//mCY
		K7SCR_NOISE_REQUEST();
		//mCY
		K7SCR_NOISE_RELEASE_TO_MAP();
		//}bvړ
		GameInfo.MapSelectInit(MAP_VIADU, MAP_CORRIDOR );
		while( GameInfo.CheckMapSelectEnd()==false ){
			K7SCR_RETSYS();
		}
		GameInfo.MapSelectEnd();
		
		//ViI^Cg\
		K7SCR_SCENARIO_TITLE_DISP( ST_DOMINICA );
		K7SCR_SET_SCENARIO_FLAG( EV04DISP_TITLE_DM1 );
		
		K7SCR_STAGE_RESTORE();
		K7SCR_PC_SETVISIBLE( true );
	}else
	{
		//}bvړ KVẢƁh~jJ
		SimpleMapMove( MAP_GAL_HOME, MAP_CORRIDOR, K7STGID(120,0) );
	}
}
//------------------------------------------------------------------------------
//h~jJ҃X^[g&X^[g
//------------------------------------------------------------------------------
void
K7Stage120M00::Setup04DM2( void )
{
	if( K7SCR_GET_SCENARIO_FLAG(EV04DISP_TITLE_DM2) == false )
	{
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		//mCY
		K7SCR_NOISE_REQUEST();
		//Xe[W\
		K7SCR_STG_VISIBLE( K7STGID(120,0), false );
		K7SCR_PC_VISIBLE( false );
		K7SCR_NOISE_RELEASE_TO_MAP();
		//}bvړ
		GameInfo.MapSelectInit(MAP_GAL_HOME, MAP_BROARDWAY );
		while( GameInfo.CheckMapSelectEnd()==false ){
			K7SCR_RETSYS();
		}
		GameInfo.MapSelectEnd();
		
		//ViI^Cg\
		K7SCR_SCENARIO_TITLE_DISP( ST_NY );
		K7SCR_SET_SCENARIO_FLAG( EV04DISP_TITLE_DM2 );
		
		K7SCR_NOISE_REQUEST();
		K7SCR_STG_VISIBLE( mID, false );
		K7SCR_STAGE_RELEASE();
		K7SCR_NOISE_RELEASE();
		//[r[ĐEL[VvsnT}
		K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_04060101 );
		K7SCR_STAGE_RESTORE();
		
		K7SCR_PC_SETVISIBLE( true );
	}else
	{
		//}bvړ KVẢƁj[[N
		SimpleMapMove( MAP_GAL_HOME, MAP_BROARDWAY, K7STGID(120,0) );
	}
}



	
//******************************************************************************
//yΊz
//******************************************************************************
//------------------------------------------------------------------------------
//ԕύXEViITyΊz
//------------------------------------------------------------------------------
bool K7Stage120M00::CondChangeCallBack05(void)
{
	switch( GameInfo.GetScenarioFlow() )
	{
		//ze2
		case	K7SCNF_HT2:
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990003),false);
			break;
		//ze1
		case	K7SCNF_HT1:
			K7SCR_STG_SET_PATHENABLE("door_990002",true);
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990003),false);
			if( WK7Play::HasPlayed(K7EVENTPLAY(05020201))==false ){
				K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990000),false);
				K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990001),true );
				K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
			}else if( WK7Play::HasPlayed(K7EVENTPLAY(05020302))==false ){
				K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990000),false);
				K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990001),false);
				K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),true );
			}else{
				K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990000),true );
				K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990001),false);
				K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
			}
			break;
		
		//wZ
		case	K7SCNF_SCL:
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990003),false);
			break;
		
		//ftHg
		default:
			break;
	}
	
	return true;
}
//------------------------------------------------------------------------------
//hACxgEViITyΊz
//------------------------------------------------------------------------------
bool K7Stage120M00::DoorEventCallBack05(WK7DoorEventInfo &info)
{
	WK7Play		*pPlay;
	u32			playno;
	
	switch( GameInfo.GetScenarioFlow() ){
	//ze2
	case	K7SCNF_HT2:
		switch( info.mEventNo ){
		case	K7EVENTDOOR(990000):
			
			K7SCR_ENTER_PLAYMODE();
			
			StopScream();
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			WK7Chara::SetRenderChara(false);
			WK7Stage::SetRenderStage(false);
			WK7Item::SetRenderItem  (false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7Stage::DeleteStage(this);
			WK7PLAYERCONTROL->ReleaseArchive();
			while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
				K7SCR_RETSYS();
			}
			
			gpSound->mStopStream();
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_GAL_HOME,MAP_HOTEL);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
			K7SCR_SCENARIO_TITLE_DISP(ST_HOTEL2);
			
			playno = K7EVENTPLAY(05090101);
			if( WK7Play::HasPlayed(playno)==false ){
				
				gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				
				WK7Chara::SetRenderChara(false);
				WK7Stage::SetRenderStage(false);
				WK7Item::SetRenderItem  (false);
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				
				WK7Play::StorePlayTB();
				
				while( (pPlay=WK7Play::Create(playno))==NULL ){
					K7SCR_RETSYS();
				}
				pPlay->Prepare();
				
				WK7Play::StorePlayTB();
				while( pPlay->GetState()!=WK7Play::PREPARED ){
					K7SCR_RETSYS();
				}
				pPlay->Start();
				K7SCR_RETSYS();
				while( gpNoise->mSandRelease()==false ){
					K7SCR_RETSYS();
				}
				
				while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
					K7SCR_RETSYS();
				}
				
				while( pPlay->GetState()!=WK7Play::PLAYED ){
					K7SCR_RETSYS();
				}
				while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
					K7SCR_RETSYS();
				}
				pPlay->SetVisibleAll(false);
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				GHM_SAFE_DELETE(pPlay);
				WK7Play::RestorePlayTB();
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				
				WK7Play::SetPlayed(playno,true);
				
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				
			}
			
			WK7Chara::SetRenderChara(true);
			WK7Stage::SetRenderStage(true);
			WK7Item::SetRenderItem  (true);
			
			WK7Stage::SetCurrentStageParam(1);
			info.mNextStageID = K7STGID(511, 0);
			strncpy(info.mNextBpName,"Front",WK7DOOREVENT_BPNAME_MAX-1);
			return true;
		default:
			break;
		}
		break;
	//ze1
	case	K7SCNF_HT1:
		switch( info.mEventNo ){
		case	K7EVENTDOOR(990000):
		
			K7SCR_ENTER_PLAYMODE_B();
			
			StopScream();
			K7SCR_NOISE_REQUEST();
			
			WK7Chara::SetRenderChara(false);
			WK7Stage::SetRenderStage(false);
			WK7Item::SetRenderItem  (false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7Stage::DeleteStage(this);
			WK7PLAYERCONTROL->ReleaseArchive();
			while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
				K7SCR_RETSYS();
			}
			
			gpSound->mStopStream();
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_GAL_HOME,MAP_VIADU);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
			playno = K7EVENTPLAY(05030101);
			if( WK7Play::HasPlayed(playno)==false ){
				
				gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				
				WK7Chara::SetRenderChara(false);
				WK7Stage::SetRenderStage(false);
				WK7Item::SetRenderItem  (false);
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				
				WK7Play::StorePlayTB();
				
				while( (pPlay=WK7Play::Create(playno))==NULL ){
					K7SCR_RETSYS();
				}
				pPlay->Prepare();
				
				WK7Play::StorePlayTB();
				while( pPlay->GetState()!=WK7Play::PREPARED ){
					K7SCR_RETSYS();
				}
				pPlay->Start();
				K7SCR_RETSYS();
				while( gpNoise->mSandRelease()==false ){
					K7SCR_RETSYS();
				}
				
				while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
					K7SCR_RETSYS();
				}
				
				while( pPlay->GetState()!=WK7Play::PLAYED ){
					K7SCR_RETSYS();
				}
				while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
					K7SCR_RETSYS();
				}
				pPlay->SetVisibleAll(false);
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				GHM_SAFE_DELETE(pPlay);
				WK7Play::RestorePlayTB();
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				
				WK7Play::SetPlayed(playno,true);
				
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				
				WK7Chara::SetRenderChara(true);
				WK7Stage::SetRenderStage(true);
				WK7Item::SetRenderItem  (true);
				
			}
			
			gpSound->mStopStream();
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_VIADU,MAP_HOTEL);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
			K7SCR_SCENARIO_TITLE_DISP(ST_HOTEL1);
			
			playno = K7EVENTPLAY(05040101);
			if( WK7Play::HasPlayed(playno)==false ){
				
				gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				
				while( (pPlay=WK7Play::Create(playno))==NULL ){
					K7SCR_RETSYS();
				}
				pPlay->Prepare();
				
				WK7Play::StorePlayTB();
				while( pPlay->GetState()!=WK7Play::PREPARED ){
					K7SCR_RETSYS();
				}
				pPlay->Start();
				K7SCR_RETSYS();
				while( gpNoise->mSandRelease()==false ){
					K7SCR_RETSYS();
				}
				
				while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
					K7SCR_RETSYS();
				}
				
				while( pPlay->GetState()!=WK7Play::PLAYED ){
					K7SCR_RETSYS();
				}
				
//				pPlay->SetVisibleAll(false);
//				K7SCR_RETSYS();
//				K7SCR_RETSYS();
//				GHM_SAFE_DELETE(pPlay);
//				WK7Play::RestorePlayTB();
//				K7SCR_RETSYS();
//				K7SCR_RETSYS();
				
//				K7SCR_SCENARIO_TITLE_DISP(ST_HOTEL1);
				
				while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
					K7SCR_RETSYS();
				}
				pPlay->SetVisibleAll(false);
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				GHM_SAFE_DELETE(pPlay);
				WK7Play::RestorePlayTB();
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				
				WK7Play::SetPlayed(playno,true);
				
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				
				WK7Chara::SetRenderChara(true);
				WK7Stage::SetRenderStage(true);
				WK7Item::SetRenderItem  (true);
				
			}
			info.mNextStageID = K7STGID(511, 0);
			strncpy(info.mNextBpName,"Front",WK7DOOREVENT_BPNAME_MAX-1);
			WK7Stage::SetCurrentStageParam(1);
			K7SCR_PC_VISIBLE( true );
			return true;
		case	K7EVENTDOOR(990001):
			StopScream();
			playno = K7EVENTPLAY(05020201);
			if( WK7Play::HasPlayed(playno)==false ){
				K7SCR_ENTER_PLAYMODE();
				
				K7SCR_NOISE_REQUEST_2HAR_ROOM();
				while( (pPlay=WK7Play::Create(playno))==NULL ){
					K7SCR_RETSYS();
				}
				pPlay->Prepare();
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				WK7Play::StorePlayTB();
				while( pPlay->GetState()!=WK7Play::PREPARED ){
					K7SCR_RETSYS();
				}
				pPlay->Start();
				K7SCR_RETSYS();
				while( gpNoise->mSandRelease()==false ){
					K7SCR_RETSYS();
				}
				while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
					K7SCR_RETSYS();
				}
				while( pPlay->GetState()!=WK7Play::PLAYED ){
					K7SCR_RETSYS();
				}
				while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT)==false ){
					K7SCR_RETSYS();
				}
				pPlay->SetVisibleAll(false);
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				GHM_SAFE_DELETE(pPlay);
				WK7Play::RestorePlayTB();
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				
				WK7Play::SetPlayed(playno,true);
				K7SCR_EVCONDCHANGE();
				
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				
				WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
				
				while( gpNoise->mSandRelease()==false ){
					K7SCR_RETSYS();
				}
				while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
					K7SCR_RETSYS();
				}
				
				K7SCR_EXIT_PLAYMODE();
			}
			return false;
		case	K7EVENTDOOR(990002):
			StopScream();
			playno = K7EVENTPLAY(05020302);
			if( WK7Play::HasPlayed(playno)==false ){
				K7SCR_ENTER_PLAYMODE();
				
				gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
				while( WK7Stage::ReleaseStageArchive()==false ){
					GHMGCTASK_RETSYS();
				}
				while( WK7Stage::IsReleasedStageArchive()==false ){
					GHMGCTASK_RETSYS();
				}
				while( (pPlay=WK7Play::Create(playno))==NULL ){
					K7SCR_RETSYS();
				}
				pPlay->Prepare();
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				WK7Play::StorePlayTB();
				while( pPlay->GetState()!=WK7Play::PREPARED ){
					K7SCR_RETSYS();
				}
				pPlay->Start();
				K7SCR_RETSYS();
				while( gpNoise->mSandRelease()==false ){
					K7SCR_RETSYS();
				}
				while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
					K7SCR_RETSYS();
				}
				while( pPlay->GetState()!=WK7Play::PLAYED ){
					K7SCR_RETSYS();
				}
				while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
					K7SCR_RETSYS();
				}
				pPlay->SetVisibleAll(false);
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				GHM_SAFE_DELETE(pPlay);
				WK7Play::RestorePlayTB();
				K7SCR_RETSYS();
				K7SCR_RETSYS();
				
				while( WK7Stage::RestoreStageArchive()==false ){
					GHMGCTASK_RETSYS();
				}
				while( WK7Stage::IsRestoredStageArchive()==false ){
					GHMGCTASK_RETSYS();
				}
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				
				WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
				
				WK7Play::SetPlayed(playno,true);
				K7SCR_EVCONDCHANGE();
				while( gpNoise->mSandRelease()==false ){
					K7SCR_RETSYS();
				}
				while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
					K7SCR_RETSYS();
				}
				
				K7SCR_EXIT_PLAYMODE();
			}
			return false;
		default:
			break;
		}
		break;
	
	//wZ
	case	K7SCNF_SCL:
		switch( info.mEventNo )
		{
			//Ƃ̊O
			case	K7EVENTDOOR(990000):
				StopScream();
				Setup05SCL();
				info.mNextStageID = K7STGID( 552, 0 );
				strcpy( info.mNextBpName, "School_start" );
				break;
			//ftHg
			default:
				break;
		}
		break;
	//R͓
	case	K7SCNF_GNK:
		switch( info.mEventNo )
		{
		//Ƃ̊O
		case	K7EVENTDOOR(990000):
			
			K7SCR_ENTER_PLAYMODE();
			
			StopScream();
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			gpSound->mStopStream();
			K7SCR_NOISE_RELEASE_TO_MAP();
			GameInfo.MapSelectInit(MAP_GAL_HOME,MAP_WARSHIP_ISLAND);
			while( GameInfo.CheckMapSelectEnd()==false ){
				K7SCR_RETSYS();
			}
			GameInfo.MapSelectEnd();
			
			info.mNextStageID = K7STGID(570,0);
			break;
		}
		break;
	//ftHg
	default:
		break;
	
	}
	
	return true;
}
//------------------------------------------------------------------------------
//wZX^[g&X^[g
//------------------------------------------------------------------------------
void
K7Stage120M00::Setup05SCL( void )
{
	//---- RXe ----
	//}bvړ
	SimpleMapMove( MAP_GAL_HOME, MAP_VIADU, K7STGID(120,0) );
	
	//---- LĐ ----
	//mCY
	K7SCR_NOISE_REQUEST();
	//L
	K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(05070101) );
	//mCY
	K7SCR_NOISE_RELEASE();
	//LI҂
	K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(05070101) );
	//mCY
	K7SCR_NOISE_REQUEST();
	//LI
	K7SCR_CHARAGEKI_TERM( K7EVENTPLAY(05070101) );
	K7SCR_STG_VISIBLE( K7STGID(120,0), false );
	K7SCR_PC_VISIBLE( false );
	
	//---- wZ ----
	//}bvړ
	K7SCR_NOISE_RELEASE_TO_MAP();
	GameInfo.MapSelectInit(MAP_VIADU, MAP_SCHOOL );
	while( GameInfo.CheckMapSelectEnd()==false ){
		K7SCR_RETSYS();
	}
	GameInfo.MapSelectEnd();
	
	//ViI^Cg\
	K7SCR_SCENARIO_TITLE_DISP( ST_SCHOOL );
	K7SCR_PC_VISIBLE( true );
}
//******************************************************************************
//yHz
//******************************************************************************
//------------------------------------------------------------------------------
//ԕύXEViIUyHz
//------------------------------------------------------------------------------
bool K7Stage120M00::CondChangeCallBack06(void)
{
	switch( GameInfo.GetScenarioFlow() )
	{
		//R͓
		case	K7SCNF_GNK:
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990000),false);
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990001),true );
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990002),false);
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(990003),true );
		//ftHg
		default:
			break;
	}
	
	return true;
}
//------------------------------------------------------------------------------
//hACxgEViIUyHz
//------------------------------------------------------------------------------
bool K7Stage120M00::DoorEventCallBack06(WK7DoorEventInfo &info)
{
	
	switch( GameInfo.GetScenarioFlow() ){
	case	K7SCNF_GNK:
		switch( info.mEventNo ){
		case	K7EVENTDOOR(990001):
			info.mNextStageID = K7STGID(121,1);
			break;
		default:
			break;
		}
		break;
	//ftHg
	default:
		break;
	
	}
	
	return true;
}
