////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage120M00
//
// K7Stage120M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE120M00_H__
#define	__K7STAGE120M00_H__

#include ".\K7Stage.h"

class K7Stage120M00_Scream{
	int					mSeID;
	u32					mPan;
	u32					mVol;
	u32					mFadeVol;
	int					mProc;
	int					mTaskID;
	int					mWait;
	ghmGcTaskController	*mpTaskController;
	
	bool CalcVolPan(void);
public:
	K7Stage120M00_Scream(ghmGcTaskController *pTaskController);
	~K7Stage120M00_Scream();
	
	bool Start(void);
	bool Stop(void);
	bool Delete(void);
	
	bool FrameProcess(void);
	
	static void ScreamTask(ghmGcTask *);
	static void ScreamTaskTerm(ghmGcTask *);
};

class K7Stage120M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	bool		mStageInit;
	bool		mScreamSE;
	K7Stage120M00();
	K7Stage120M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	bool PlayScream(void);
	bool StopScream(void);
	bool ScreamControl(void);
	
	bool CondChangeCallBack01(void);
	bool CondChangeCallBack02(void);
	bool CondChangeCallBack03(void);
	bool CondChangeCallBack04(void);
	bool CondChangeCallBack05(void);
	bool CondChangeCallBack06(void);
	bool DoorEventCallBack01FUK(WK7DoorEventInfo &info);
	bool DoorEventCallBack01KAK(WK7DoorEventInfo &info);
	bool DoorEventCallBack01(WK7DoorEventInfo &info);
	bool DoorEventCallBack02(WK7DoorEventInfo &info);
	bool DoorEventCallBack03(WK7DoorEventInfo &info);
	bool DoorEventCallBack04(WK7DoorEventInfo &info);
	bool DoorEventCallBack05(WK7DoorEventInfo &info);
	bool DoorEventCallBack06(WK7DoorEventInfo &info);
	void Setup03ISZ( void );
	void Setup03CUR( void );
	void Setup04DM1( void );
	void Setup04DM2( void );
	void Setup05SCL( void );
public:
	virtual ~K7Stage120M00();
	
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
	virtual bool CondChangeCallBack(void);
	virtual bool SetCurrentCallBack(void);
};

#endif	//__K7STAGE120M00_H__

