////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage121M00
//
// K7Stage121M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE121M00_H__
#define	__K7STAGE121M00_H__

#include ".\K7Stage.h"

struct K7Stage121M00_ZanEvent{
	u32					mPrevStageID;
	u32					mParam;
	u32					mZanEventNo;
};

#define	K7STAGE121M00_ZANLOCATORNAME_SIZE		(64)

#define	K7STAGE121M00_SMA_MOTION_NUM			(2)
#define	K7STAGE121M00_SMA_MOTION_STANDBY		(0)
#define	K7STAGE121M00_SMA_MOTION_REMOCON		(1)
class K7Stage121M00 : public WK7Stage{
	friend class WK7Stage;
	friend class WK7GameInfo;
protected:
	WK7Chara				*mpSma;
	WK7Model				*mpSmaModel;
	WK7ModelMotion			*mpSmaMotion[K7STAGE121M00_SMA_MOTION_NUM];
	u32						mSmaCharaID;
	u32						mSmaMotID;
	u32						mSmaMotIDRemoCon;
	bool					mSaveRoom;
	WK7Chara				*mpHac;
	WK7Model				*mpHacModel;
	WK7ModelMotion			*mpHacMotion;
	u32						mHacMotID;
	u32						mReturnStageID;
	char					mReturnBpName[WK7DOOREVENT_BPNAME_MAX];
	u32						mParam;
	K7Stage121M00_ZanEvent	*mpZanEvent;
	u32						mZanEventNo;
	char					mZanLocatorName[K7STAGE121M00_ZANLOCATORNAME_SIZE];
	u32						mPcDieFlag;
	u32						mPcCollectFlag;
	u32						mPcReCallFlag;
	u32						mPcSelOKFlag;
	bool					mStageInit;
	WK7AnimLinear			mNoiseVolMax;
	WK7AnimLinear			mNoiseVolMin;
	bool					mEnterPass;
	
	bool MuteNoiseSE(u32 tick=0);
	bool RestoreNoiseSE(u32 tick=0);
	
	bool StoreTvFlag(void);
	bool RestoreTvFlag(void);
	virtual bool TvNoiseCallback(void);
	
	bool SmaSetPosition(f32 x,f32 y,f32 z);
	bool SmaSetPosition(const Vec &pos);
	bool SmaSetRotY(f32 roty);
	bool SmaPlayMotion(int index,bool loop=true);
	bool SmaSetVisible(bool flag);
	
	K7Stage121M00();
	K7Stage121M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	bool SelectHarman(WK7TvEventInfo &info,u32 playno,int flag=-1);
	bool SelectHarmanMovie(WK7TvEventInfo &info,u32 movieid);
	bool TvEventCallBackScn01(WK7TvEventInfo &info);
	bool TvEventCallBackScn02(WK7TvEventInfo &info);
	bool TvEventCallBackScn03(WK7TvEventInfo &info);
	bool TvEventCallBackScn04(WK7TvEventInfo &info);
	
	bool ChangeZanEventNo(u32 eventNo);
	bool SetOrigPathCamera(const char *pPathName);
	
	virtual bool LoadAfterInit3(void);
public:
	virtual ~K7Stage121M00();
	
	u32 GetPrevStageID(void){ return mPrevStageID; }
	const char* GetPrevStagePathName(void){ return mpPrevStagePathName; }
	const char* GetPrevStageBpName(void){ return mpPrevStageBpName; }
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool TvEventCallBack   (WK7TvEventInfo   &);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool DoorEventCallBack (WK7DoorEventInfo  &);
	virtual bool ZanEventCallBack  (WK7ZanEventInfo   &);
	virtual bool EventCallBack     (WK7EventInfo      &);
	virtual bool PathChangeCallBack(WK7PathChangeInfo &);
	
	inline u32 GetReturnStageID(void){ return mReturnStageID; }
	inline const char* GetReturnBpName(void){ return mReturnBpName; }
	inline u32 GetParam(void){ return mParam; }
	inline bool GetSaveRoom(void){ return mSaveRoom; }
	
	virtual K7StageWork* GetWork(void);
	static	bool	mLookIlltreat;	//n[}s҃LĐēĂtO
};

#ifdef	__K7STAGE121M00_CPP__

enum K7STAGE121M00_ONESHOTCAM{
	EVENT_992100,
	EVENT_992100_1,
};

K7StageEventOneShotCamera	K7Stage121M00_Camera[] = {
	{{-15.971f, 12.974f, -23.544f},{-8.180f, 8.162f, -5.172f}},
	{{-28.631f, 9.458f, -6.375f},{-8.180f, 8.162f, -5.172f}},
};

#endif

#endif	//__K7STAGE121M00_H__

