////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Application
//
// K7App.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/08/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7APP_H__
#define	__K7APP_H__

//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcApp.h"
//#include "..\Lib\ghmGcMem.h"
//#include "..\Lib\ghmGcTask.h"
//#include "..\Lib\ghmGcUsb.h"
#include "..\K7App.ini"
#include ".\WK7Effect.h"
#include "..\sato\SK7ErrorCheck.h"
//#include ".\WK7Define.h"

#define	K7APP_HEAPCHECK
#ifndef	_DEBUG
#undef	K7APP_HEAPCHECK
#endif

#if	defined(USE_ISDOLVIEWER) && !defined(USE_USB)
#define	USE_USB
#endif

#define	K7APP_SCREEN_WIDTH				GHM_SCREEN_WIDTH
#define	K7APP_SCREEN_HEIGHT				GHM_SCREEN_HEIGHT

#define	K7APP_PAD_QUEUE_SIZE			(5)

#ifndef	K7APP_DEFAULT_CLEARCOLOR
#ifdef	K7APP_MASTER
#define	K7APP_DEFAULT_CLEARCOLOR		{0x00,0x00,0x00,0x00}
#else
#define	K7APP_DEFAULT_CLEARCOLOR		{0x00,0x00,0x40,0x00}
#endif
#endif

#define	CAPTURE_RGB		(0)
#define	CAPTURE_A		(1)
#define	CAPTURE_RGBA	(2)
#define	CAPTURE_Z		(3)

typedef	bool K7AppResetProcessCallback(u32 param);

#define	K7APP_TICKLOGNUM	(32)
class K7App : public ghmGcApp{
protected:
	// VXe֘A
	HSD_PadRawQueue				mPadQueue[K7APP_PAD_QUEUE_SIZE];		// pbhCupL[
	ghmGcMem					mSmallMem;								// ̈惁mۗp
	ghmGcMem					mSysdolMem;								// sysdolphinp
	ghmGcMem					mAudioMem;								// Audiop(fujita.0120)
	OSThread					*mpMainThread;
//	bool						mThreadSuspended;
	OSSemaphore					mSema;
	volatile int				mSemaCnt;
	
#ifdef _DEBUG
	ghmGcTaskController			mDebugPrintTaskController;				// fobOptHgvg^XN
	s64							mStartTick;
	s32							mTickLog[K7APP_TICKLOGNUM];
#endif
	WK7Fade						mFade;									// ʃtF[h
	SK7ErrorCheck				mErrorMes;
	
	K7AppResetProcessCallback	*mpResetProcessCallback;
	u32							mResetProcessCallbackParam;
	
#ifdef	K7APP_HEAPCHECK
	int							mSmallMemDebugPrintTaskID;
	int							mAudioMemDebugPrintTaskID;
	int							mDefaultMemDebugPrintTaskID;
	bool CheckHeap(ghmGcMem &heap,int &taskid,const char *pheapname);
#endif
	
	static void DebugPrintTask(ghmGcTask *pTask);
	static void DebugPrintTaskTerm(ghmGcTask *pTask);
	
#if	defined(_DEBUG) && defined(USE_USB)
	bool _ScreenCapture(void);
#endif
public:
	K7App();
	virtual ~K7App();
	
	// Zbg{^ꂽƂɁAݒ肵R[obN֐falseԂԁA
	// ZbgɍsȂȂ܂B
	void SetResetProcessCallback(K7AppResetProcessCallback *pResetProcessCallback,u32 param){
		mpResetProcessCallback     = pResetProcessCallback;
		mResetProcessCallbackParam = param;
	}
	inline K7AppResetProcessCallback* GetResetProcessCallback(void){ return mpResetProcessCallback; }
	inline u32 GetResetProcessCallbackParam(void){ return mResetProcessCallbackParam; }
	
	static void K7AppPreRetraceCallBack(u32 retraceCount);
	static void K7AppPostRetraceCallBack(u32 retraceCount);
	OSThread* GetMainThread(void){ return mpMainThread; }
//	bool IsSuspendedMainThread(void){ return mThreadSuspended; }
	bool SuspendMainThread(bool flag);
	
#if	defined(_DEBUG) && defined(USE_USB)
	bool ScreenCapture(int mode=CAPTURE_RGBA,const char *pfname=NULL);
#endif
	
#ifdef	K7APP_HEAPCHECK
	bool CheckHeap(void);
#endif
	
#ifdef	_DEBUG
	void* SmallAlloc(int size,const char *pident,u32 line);
#else
	void* SmallAlloc(int size);
#endif
	bool SmallFree(void *pMem);
	long SmallGetFreeSize(void);
	
	inline void FadeStart(u32 alpha,u32 time){ mFade.Start(alpha,time); }
	inline void FadeStartSec(u32 alpha,f32 sec){ mFade.Start(alpha,WK7_SEC_TO_TICK(sec)); }
	inline void FadeStart(u32 alpha,u32 color,u32 time){ mFade.Start(alpha,color,time); }
	inline void SetFadeColor(u32 color){ mFade.SetColor(color); }
	inline u32 GetFadeColor(void){ return mFade.GetColor(); }
	inline WK7Fade::State GetFadeState(void){ return mFade.GetState(); }
	inline bool IsFade(void){ return GetFadeState()==WK7Fade::FADE? true : false; }
	inline bool IsFading(void){ return GetFadeState()==WK7Fade::FADE? true : false; }
	
	// 
	virtual bool Initialize(void);
	virtual bool SetRetraceCallBack(void);
	
	// I
	virtual bool Terminate(void);
	
	// s
	virtual bool Run(void);
	
	// _O
//	virtual bool PreRenderProcess(void);
	virtual bool RenderProcess(void);
//	virtual bool PostRenderProcess(void);
	
	// t[
	virtual bool PreFrameProcess(void);
	virtual bool FrameProcess(void);
	virtual bool PostFrameProcess(void);
	
	// VBlank
	virtual bool SynchronizeVBlank(void);
	
	virtual bool ResetProcess(void);
#ifdef	_DEBUG
	// fobO\p
	int DebugPrint(const char *pstr,f32 sec);
	int DumpMemory(int type=0);
	bool OSDumpMemory(int type=0);
	bool DebugPrintDelete(void);
	
	bool MeasureTick(int id,bool clear=false);
	void DumpTickLog(int num=-1);
	void ClearTickLog(void);
#endif

};

#ifdef	_DEBUG
#define	K7AppSmallMemAlloc(size)			k7app.SmallAlloc((size),__FILE__,__LINE__)
#define	K7AppSmallMemAllocName(size,pident)	k7app.SmallAlloc((size),(pident),__LINE__)
#define	K7AppMeasureTick(id)				k7app.MeasureTick(id)
#define	K7AppDumpTickLog()					k7app.DumpTickLog()
#define	K7AppClearTickLog()					k7app.ClearTickLog()
#else
#define	K7AppSmallMemAlloc(size)			k7app.SmallAlloc((size))
#define	K7AppSmallMemAllocName(size,ident)	k7app.SmallAlloc((size))
#define	K7AppMeasureTick(id)				
#define	K7AppDumpTickLog()					
#define	K7AppClearTickLog()					
#endif
#define	K7AppSmallMemFree(...)				k7app.SmallFree( __VA_ARGS__ )
#define	K7AppSmallMemGetFreeSize()			k7app.SmallGetFreeSize()

#if	defined(USE_USB) && defined(_DEBUG)
extern	void SetCaptureMode(bool flag);
extern	bool GetCaptureMode(void);
extern	void SetPlayCaptureMode(bool flag);
extern	bool GetPlayCaptureMode(void);
extern	void SetPS2Mode(bool flag);
extern	bool GetPS2Mode(void);
#define	SETCAPTUREMODE(flag)				SetCaptureMode(flag)
#define	GETCAPTUREMODE()					GetCaptureMode()
#define	SETPLAYCAPTUREMODE(flag)			SetPlayCaptureMode(flag)
#define	GETPLAYCAPTUREMODE()				GetPlayCaptureMode()
#define	SETPS2MODE(flag)					SetPS2Mode(flag)
#define	GETPS2MODE()						GetPS2Mode()
#else
#define	SETCAPTUREMODE(flag)				
#define	GETCAPTUREMODE()					0
#define	SETPLAYCAPTUREMODE(flag)			
#define	GETPLAYCAPTUREMODE()				0
#define	SETPS2MODE(flag)					
#define	GETPS2MODE()						0
#endif

#if	defined(_DEBUG) && !defined(K7APP_MASTER) 
//#if	0
#define	K7AppDebugPrintSec(pstr,sec)		k7app.DebugPrint((pstr),(sec))
#define	K7AppDebugPrint(pstr)				K7AppDebugPrintSec((pstr),4.0f)
#define	K7AppDebugPrintDelete()				k7app.DebugPrintDelete()
#define	K7AppHeapCheck()					k7app.HeapCheck()
#define	K7AppDumpMemory()					k7app.DumpMemory()
#define	K7AppDumpMemoryType(type)			k7app.DumpMemory((type))
#define	K7AppOSDumpMemory()					k7app.OSDumpMemory()
#define	K7AppOSDumpMemoryType(type)			k7app.OSDumpMemory((type))
#else
#define	K7AppDebugPrintSec(pstr,sec)		
#define	K7AppDebugPrint(pstr)				
#define	K7AppDebugPrintDelete()				
#define	K7AppHeapCheck()					
#define	K7AppDumpMemory()					
#define	K7AppDumpMemoryType(type)			
#define	K7AppOSDumpMemory()					
#define	K7AppOSDumpMemoryType(type)			
#endif

#ifndef	__K7APP_CPP__
extern	K7App		k7app;
extern	ghmGcUsb	usbFile;
#endif

#endif	//__K7APP_H__

