////////////////////////////////////////////////////////////////////////////////
//
// Killer7 AfterImage
//
// WK7AfterImage.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 09/18/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7AFTERIMAGE_H__
#define	__WK7AFTERIMAGE_H__

#include ".\WK7ScreenImage.h"
#include ".\WK7Anim.h"

class WK7AfterImage{
protected:
	bool				mEnable;
	bool				mCapture;
	WK7AnimLinear		mCaptureCounter;
	u32					mCaptureTick;
	bool				mFrameProcess;
	WK7ScreenImage		*mpPrevImage;
	bool				mClearColorUpdate;
	bool				mClearAlphaUpdate;
	bool				mClearZUpdate;
	u32					mClearColor;
	f32					mClearZ;
	u32					mRate;
	WK7AnimLinear		mBackIntensity;
	bool				mEnableAfterImage;
	
	bool Clear(void);
	bool _RenderProcess(void);
	bool _RenderProcess2(void);
	bool RenewImageBuffer(void);
public:
	WK7AfterImage();
	~WK7AfterImage();
	
	bool FrameProcess(void);
	bool PreRenderProcess(void);
	bool RenderProcess(void);
	
	inline bool SetClearColor(u32 color){ mClearColor=color; return true; }
	inline u32 GetClearColor(void){ return mClearColor; }
	inline bool SetClearColorUpdate(bool flag){ mClearColorUpdate=flag; return true; }
	inline bool GetClearColorUpdate(void){ return mClearColorUpdate; }
	inline bool SetClearAlphaUpdate(bool flag){ mClearAlphaUpdate=flag; return true; }
	inline bool GetClearAlphaUpdate(void){ return mClearAlphaUpdate; }
	inline bool SetClearZUpdate(bool flag){ mClearZUpdate=flag; return true; }
	inline bool GetClearZUpdate(void){ return mClearZUpdate; }
	inline bool SetClearZ(f32 z){ mClearZ=z; return true; }
	inline f32 GetClearZ(void){ return mClearZ; }
	
	bool SetEnable(bool flag);
	inline bool GetEnable(void){ return mEnable; }
	inline bool SetEnableAfterImage(bool flag){ mEnableAfterImage=flag; return true; }
	inline bool GetEnableAfterImage(void){ return mEnableAfterImage; }
	
	bool SetRate(u32 rate);
	inline u32 GetRate(void){ return mRate; }
	
	bool SetBackIntensity(u32 inten,u32 tick=0);
	inline u32 GetBackIntensity(void){ return mBackIntensity.GetValue(); }
};

extern	WK7AfterImage		afterImage;

#endif	//__WK7AFTERIMAGE_H__

