////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Anim
//
// WK7Anim.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/18/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7ANIM_CPP__

//#include <dolphin.h>
#include ".\WK7Anim.h"
#include ".\WK7Define.h"

//  -----------------------------------------------------------------------

WK7AnimLinear::WK7AnimLinear(u32 value)
{
	mCurValue = value;
	mDstValue = value;
	mCount    = 0;
	mTime     = 0;
	mDelta    = 0;
}

WK7AnimLinear::~WK7AnimLinear()
{
}

bool WK7AnimLinear::IsAnimating(void)
{
	if( mCurValue==mDstValue ){
		return false;
	}
	return true;
}

bool WK7AnimLinear::Play(u32 dst,u32 time)
{
	if( time==0 ){
		mCurValue = 
		mDstValue = dst;
		mTime     = 0;
		return true;
	}
	mDstValue = dst;
	mDelta    = (s32)(WK7_TICK_PER_FRAME * (mDstValue - mCurValue));
	mTime     = time;
	mCount    = 0;
	return true;
}

bool WK7AnimLinear::FrameProcess(void)
{
	if( mDstValue==mCurValue ){
		return true;
	}
	if( mDelta > 0 ){
		mCount += mDelta;
	}else{
		mCount -= mDelta;
	}
	if( mCount > mTime ){
		u32		time = mTime;
		u32		delta;
		if( mDelta > mTime ){
			delta  = mCount / mTime;
			time  *= delta;
		}else{
			delta  = 1;
		}
		if( mDelta > 0 ){
			if( mCurValue < mDstValue - delta ){
				mCurValue += delta;
			}else{
				mCurValue = mDstValue;
			}
		}else{
			if( mCurValue > mDstValue + delta ){
				mCurValue -= delta;
			}else{
				mCurValue = mDstValue;
			}
		}
		mCount -= time;
	}
	return true;
}

//  -----------------------------------------------------------------------

WK7AnimLinearF::WK7AnimLinearF(f32 value)
{
	mCurValue = 
	mDstValue = 
	mSrcValue = value;
	mCount    = 0;
	mTime     = 0;
}

WK7AnimLinearF::~WK7AnimLinearF()
{
}

bool WK7AnimLinearF::IsAnimating(void)
{
	if( mCount==mTime ){
		return false;
	}
	return true;
}

bool WK7AnimLinearF::Play(f32 dst,u32 time)
{
	if( time==0 ){
		mSrcValue = 
		mCurValue = 
		mDstValue = dst;
		mTime     = 0;
		return true;
	}
	mSrcValue = mCurValue;
	mDstValue = dst;
	mTime     = time;
	mCount    = 0;
	return true;
}

bool WK7AnimLinearF::FrameProcess(void)
{
	if( mCount >= mTime ){
		mCount    = mTime;
		mCurValue = mDstValue;
		return true;
	}
	mCurValue = mSrcValue + (mDstValue - mSrcValue) * mCount / mTime;
	mCount += WK7_TICK_PER_FRAME;
	return true;
}

