////////////////////////////////////////////////////////////////////////////////
//
// Killer7 AreaInfo
//
// WK7AreaInfo.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/06/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7AREAINFO_CPP__

#include ".\WK7AreaInfo.h"

bool WK7AreaInfo::Initialize(void)
{
	u16		i;
	if( mppName!=NULL ){
		const char	**ppName;
		mppName = (const char **)((u32)mppName + (u32)this);
		for(i=0,ppName=mppName ; i<mNameCount ; i++,ppName++){
			*ppName = (const char *)((u32)(*ppName) + (u32)mppName);
		}
	}
	if( mpVert!=NULL ){
		mpVert = (Vec *)((u32)mpVert+ (u32)this);
	}
	if( mpMaterial!=NULL ){
		WK7AreaMaterial		*pMaterial;
		mpMaterial = (WK7AreaMaterial *)((u32)mpMaterial + (u32)this);
		for(i=0,pMaterial=mpMaterial ; i<mMaterialCount ; i++,pMaterial++){
			u16		nid = (u16)pMaterial->mpName;
			if( mppName!=NULL && nid < mNameCount ){
				pMaterial->mpName = mppName[nid];
			}else{
				pMaterial->mpName = NULL;
			}
		}
	}
	if( mpFace!=NULL ){
		WK7AreaFace		*pFace;
		int				j;
		mpFace = (WK7AreaFace *)((u32)mpFace + (u32)this);
		for(i=0,pFace=mpFace ; i<mFaceCount ; i++,pFace++){
			u16		mid = (u16)pFace->mpMaterial;
			
			if( mpMaterial!=NULL && mid < mMaterialCount ){
				pFace->mpMaterial = mpMaterial + mid;
			}else{
				pFace->mpMaterial = NULL;
			}
			
			for(j=0 ; j<3 ; j++){
				if( mpVert!=NULL && pFace->mVert[j].mVertIndex < mVertCount ){
					pFace->mVert[j].mpVert = mpVert + pFace->mVert[j].mVertIndex;
				}else{
					pFace->mVert[j].mpVert = NULL;
				}
			}
		}
	}
	return true;
}

