////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Bullet Object
//
// WK7Bullet.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/18/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7BULLET_CPP__

#if 0

//#include <dolphin.h>
#include ".\WK7Bullet.h"
#include ".\WK7MainTask.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Fujita\C_Coll.h"
#include "..\Fujita\C_Font.h"
#include "..\Fujita\C_Particle.h"

#include ".\K7App.h"

void *WK7Bullet::mpArchive = NULL;

//#define	BULLET_RADIUS			(2.0f)
#define	BULLET_RADIUS			(0.2f)

WK7Bullet::WK7Bullet(WK7Obj *pAnchor,int prio) : WK7RenderObj(pAnchor,prio)
{
	memset(&mPosition,0,sizeof(mPosition));
	memset(&mVelocity,0,sizeof(mVelocity));
	mState = 0;
	mCount = 0;
	mpScene = NULL;
	mpJObj  = NULL;
	
	if( mpArchive == NULL ){
		ghmGcFile	file;
		if( file.Open("sphere.dat")==false ){
			return;
		}
		if( (mpArchive = file.ReadB())==NULL ){
			return;
		}
		file.Close();
	}
	
	mpScene = new(mpArchive) C_SceneDesc();
	ghmGcMemSetAllocName("C_JObj");
	mpJObj  = new C_JObj     (mpScene->GetModelSet((u32)0));
	
	mpParticleObj = NULL;
	mpGenerator   = NULL;
	mScale = BULLET_RADIUS;
}

WK7Bullet::~WK7Bullet()
{
	GHM_SAFE_DELETE(mpJObj);
	mpScene = NULL;
//	GHMGCMEM_SAFE_FREE(mpArchive);
	
	GHM_SAFE_DELETE(mpParticleObj);
	GHM_SAFE_DELETE(mpGenerator);
}

bool WK7Bullet::FrameProcess(void)
{
	WK7MainTask		*pTask = GET_WK7MAINTASK();
	WK7Chara		*pChara;
	WK7Stage		*pStage;
	Vec				oldpos;
	
	if( pTask==NULL || mpArchive==NULL || mpJObj==NULL ){
		// ^XNI
		return false;
	}
	
//	rot.x = 
//	rot.y = 
//	rot.z = 0.0f;
	
	switch( mState ){
	case	0:
		oldpos   .x  = mPosition.x;
		oldpos   .y  = mPosition.y;
		oldpos   .z  = mPosition.z;
		mPosition.x += mVelocity.x;
		mPosition.y += mVelocity.y;
		mPosition.z += mVelocity.z;
		
//		pTask->SetParticleTranslate(mPosition);
//		pTask->SetParticleRotate   (rot);
		
		pChara = pTask->GetTopChara();
		while( pChara!=NULL ){
			if( pChara->CheckHit(oldpos,mPosition,BULLET_RADIUS)==true ){
static	int		chrptclid = 6;
				ghmGcMemSetAllocName("C_JObj");
				mpParticleObj = new C_JObj();
				ghmGcMemSetAllocName("C_Gene");
				mpGenerator   = new C_Generator(*mpParticleObj,chrptclid);
				if( mpGenerator!=NULL ){
					Vec		hitpos;
					pChara->GetPosition(hitpos);
					hitpos.y += 10.0f;
					HSD_JObj	*pJObj = mpParticleObj->GetJObj();
					HSD_JObjSetTranslate(pJObj,&hitpos);
					mpGenerator->Fire();
				}
				mState = 8;
				break;
			}
			pChara = pChara->GetNext();
		}
		if( mState ){
			break;
		}
		pStage = pTask->GetTopStage();
		while( pStage!=NULL ){
			C_TrigonArray		*pHitPolygon = pStage->GetHitPolygon();
			if( pHitPolygon!=NULL ){
				C_Vec	colpos0(oldpos   .x,oldpos   .y,oldpos   .z);
				C_Vec	colpos1(mPosition.x,mPosition.y,mPosition.z);
				C_Coll	coll(*pHitPolygon,colpos0,colpos1,BULLET_RADIUS);
				if( coll.Result()==true ){
static	int		stgptclid = 2;
					ghmGcMemSetAllocName("C_JObj");
					mpParticleObj = new C_JObj();
					ghmGcMemSetAllocName("C_Gene");
					mpGenerator   = new C_Generator(*mpParticleObj,stgptclid);
					if( mpGenerator!=NULL && mpParticleObj!=NULL ){
						C_Vec		hitpos = coll.GetPos();
						HSD_JObj	*pJObj = mpParticleObj->GetJObj();
						mpGenerator->Fire();
						HSD_JObjSetTranslate(pJObj,&hitpos);
					}
					mState = 16;
					mCount = 0;
					break;
				}
			}
			pStage = pStage->GetNext();
		}
		if( pStage==NULL ){
			mCount++;
			if( mCount > 5 * 60 ){
				mState++;
			}
		}
		break;
	case	1:
		// R
		return false;
	case	8:
//		mScale += 0.1f;
//		if( mScale < 10.0f ){
//			break;
//		}
		// LɃqbg
		return false;
	case	16:
		// Xe[WɃqbg
		return false;
	}
	
	if( mpJObj==NULL ){
		return true;
	}
	
	HSD_JObj	*pJObj = mpJObj->GetJObj();
	Vec			scale;
	scale.x = mScale;
	scale.y = mScale;
	scale.z = mScale;
	HSD_JObjSetScale    (pJObj,&scale);
	HSD_JObjSetTranslate(pJObj,&mPosition);
	
	mpJObj->Proc();
	
	return true;
}

bool WK7Bullet::RenderProcess(void)
{
	if( mpJObj==NULL || mRenderFlag==false ){
		return true;
	}
	mpJObj->Disp();
	return true;
}

#endif

