////////////////////////////////////////////////////////////////////////////////
//
// Killer7 CharaPresent
//
// WK7CharaPresent.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/22/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7CHARAPRESENT_CPP__

//#include <dolphin.h>
#include ".\WK7CharaPresent.h"
#include ".\WK7Cam.h"
#include ".\WK7MainTask.h"
#include "..\Fujita\C_Font.h"
#include "..\Matsu\MK7EngTelop.h"
#include "..\Matsu\MK7Sound.h"

WK7CharaPresent*		WK7CharaPresent::gpCharaPresent = NULL;

static f32	clearz = 0.5f;

bool WK7CharaPresent::Initialize(void)
{
	if( gpCharaPresent==NULL ){
		ghmGcMemSetAllocName("WK7ChrPr");
		gpCharaPresent = new WK7CharaPresent;
	}
	return true;
}

bool WK7CharaPresent::Terminate(void)
{
	GHM_SAFE_DELETE(gpCharaPresent);
	return true;
}

bool WK7CharaPresent::FrameProcessAll(void)
{
	if( gpCharaPresent==NULL ){
		return true;
	}
	
//	if( HSD_PadGetTrigger(1) & HSD_PAD_RIGHT ){
//static	f32	x = 320.0f - 128.0f * 0.5f,y = 160.0f - 128.0f * 0.5f,w = 128.0f,h= 128.0f;
//		gpCharaPresent->AddMaskWindow(x,y,w,h);
//		gpCharaPresent->SetEnable(true);
//	}
//	if( HSD_PadGetTrigger(1) & HSD_PAD_LEFT ){
//		gpCharaPresent->DeleteMaskWindowAll();
//	}
	
	return gpCharaPresent->FrameProcess();
}

bool WK7CharaPresent::RenderProcessAll(void)
{
	if( gpCharaPresent==NULL ){
		return true;
	}
	return gpCharaPresent->RenderProcess();
}

#ifndef	K7APP_MASTER
static	int	editid = 0;
#endif
WK7CharaPresent::WK7CharaPresent()
{
	mEnable          = false;
	mReserved        = false;
	mReserveTick     = 0;
	mDeleteTick      = 0xffffffff;
	mWholeMotionRate = 1.0f;
#ifndef	K7APP_MASTER
#ifdef	_DEBUG
	mTickCounter     = 0;
	mTickCountEnable = false;
	mNameX           = 240.0f;
	mNameY           = 320.0f;
	mWindowX         = 240.0f;
	mWindowY         = 160.0f;
	mWindowW         = 160.0f;
	mWindowH         = 160.0f;
	mDebugMode       = false;
#endif
#endif
}

WK7CharaPresent::~WK7CharaPresent()
{
}

void WK7CharaPresent::SetEnable(bool flag)
{
	mReserved    = false;
	mEnable      = flag;
	mReserveTick = 0;
	if( flag==true ){
		gpSound->mPlaySE(SFX_SYS_CHARA_INTRODUCTION);
	}
}

void WK7CharaPresent::ReserveEnable(u32 tick)
{
	mReserved    = true;
	mEnable      = false;
	mReserveTick = tick;
	mDeleteTick  = WK7_SEC_TO_TICK(1.0f);
}

void WK7CharaPresent::ReserveEnableSec(f32 sec)
{
	ReserveEnable(WK7_SEC_TO_TICK(sec));
}

void WK7CharaPresent::ReserveDelete(u32 tick)
{
	mDeleteTick = tick;
}

void WK7CharaPresent::ReserveDeleteSec(f32 sec)
{
	ReserveDelete(WK7_SEC_TO_TICK(sec));
}

void WK7CharaPresent::SetReserved(bool flag)
{
	mReserved = flag;
}

#ifndef	K7APP_MASTER
bool WK7CharaPresent::StartTickCounter(void)
{
	mDebugMode       = false;
	mTickCounter     = 0;
	mTickCountEnable = true;
	mWholeMotionRate = WK7Motion::GetWholeMotionRate();
	return true;
}

bool WK7CharaPresent::EndTickCounter(void)
{
	if( ghmGcTaskController::GetCurrentTask()!=NULL ){
		while( mEnable==true ){
			GHMGCTASK_RETSYS();
		}
	}
	mDebugMode       = false;
	mTickCountEnable = false;
	DeleteMaskWindowAll();
	SetEnable(false);
	WK7Motion::SetWholeMotionRate(mWholeMotionRate);
	return true;
}
#endif

bool WK7CharaPresent::FrameProcess(void)
{
#ifndef	K7APP_MASTER
#if 0
	if( mTickCountEnable==true ){
		if( mDebugMode==false ){
			mTickCounter += WK7_TICK_PER_FRAME;
		}
		WK7CharaPresentMaskWindow		*pWindow = (WK7CharaPresentMaskWindow *)mWindowAnchor.GetNext();
		if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
			OSReport("%8d,0,%5d,%5d,%4d,%4d,%4d,%4d\n",
			              mTickCounter,
			         (s16)mNameX,
			         (s16)mNameY,
			         (s16)mWindowX,
			         (s16)mWindowY,
			         (s16)mWindowW,
			         (s16)mWindowH);
		}
		if( HSD_PadGetTrigger(1) & HSD_PAD_Z ){
			editid++;
			if( editid >= 2 ){
				editid = 0;
			}
		}
		if( HSD_PadGetTrigger(1) & HSD_PAD_X ){
			if( pWindow!=NULL || (pWindow = AddMaskWindow(mWindowX,mWindowY,mWindowW,mWindowH))!=NULL ){
				SetEnable(true);
				mDeleteTick = 0xffffffff;
				WK7Motion::SetWholeMotionRate(0.0f);
				gpEngTelop->mSetPause();
				gpJimaku  ->mSetPause();
				pWindow->mPosX   = mWindowX;
				pWindow->mPosY   = mWindowY;
				pWindow->mWidth  = mWindowW;
				pWindow->mHeight = mWindowH;
				mDebugMode  = true;
			}
		}
static	f32		movespeed = 8.0f;
		f32			lx,ly,rx,ry;
		lx = HSD_PadGetNormalStickX   (1);
		ly = HSD_PadGetNormalStickY   (1);
		rx = HSD_PadGetNormalSubStickX(1);
		ry = HSD_PadGetNormalSubStickY(1);
		if( lx!=0.0f || ly!=0.0f || rx!=0.0f || ry!=0.0f ){
			if( pWindow!=NULL && mDeleteTick!=0xffffffff ){
				mDebugMode  = true;
				mDeleteTick = 0xffffffff;
				mWindowX = pWindow->mPosX;
				mWindowY = pWindow->mPosY;
				mWindowW = pWindow->mWidth;
				mWindowH = pWindow->mHeight;
			}
			switch( editid ){
			case	0:
				mWindowX += movespeed * lx;
				mWindowY -= movespeed * ly;
				mWindowW += movespeed * rx;
				mWindowH -= movespeed * ry;
				if( mWindowW < 0 ){
					mWindowW = 0;
				}
				if( mWindowH < 0 ){
					mWindowH = 0;
				}
				break;
			case	1:
				mNameX += movespeed * lx;
				mNameY -= movespeed * ly;
				break;
			}
		}
		if( mDeleteTick==0xffffffff ){
			if( pWindow != NULL ){
				pWindow->SetRect(mWindowX,mWindowY,mWindowW,mWindowH);
			}
		}
		if( HSD_PadGetTrigger(1) & HSD_PAD_A ){
			mDebugMode  = false;
			mDeleteTick  = 0xffffffff;
			DeleteMaskWindowAll();
			SetEnable(false);
			WK7Motion::SetWholeMotionRate(mWholeMotionRate);
			gpEngTelop->mReleasePause();
			gpJimaku  ->mReleasePause();
			return true;
		}
	}
#endif
#endif
	if( mReserved==true ){
		mEnable = false;
		if( mReserveTick >  WK7_TICK_PER_FRAME ){
			mReserveTick -= WK7_TICK_PER_FRAME;
			return true;
		}
		SetEnable(true);
		mWholeMotionRate = WK7Motion::GetWholeMotionRate();
		WK7Motion::SetWholeMotionRate(0.0f);
	}
	if( mEnable==false ){
		return true;
	}
	if( mDeleteTick!=0xffffffff ){
		if( mDeleteTick >  WK7_TICK_PER_FRAME ){
			mDeleteTick -= WK7_TICK_PER_FRAME;
		}else{
			mDeleteTick  = 0xffffffff;
			DeleteMaskWindowAll();
			SetEnable(false);
			WK7Motion::SetWholeMotionRate(mWholeMotionRate);
			return true;
		}
	}
	WK7CharaPresentMaskWindow		*pWindow;
	for(pWindow=(WK7CharaPresentMaskWindow *)mWindowAnchor.GetNext() ; pWindow!=NULL ; pWindow=pWindow->GetNext()){
		pWindow->FrameProcess();
	}
	return true;
}

#ifndef	K7APP_MASTER
bool WK7CharaPresent::RenderProcessEditMode(void)
{
	
	Mtx				view;
	Mtx44			proj;
static	GXColor		drawColor[2] = { { 0xff,0x00,0x00,0xff } , { 0xff,0xff,0xff,0xff } };
	
	HSD_RectU16		sc_rect;
	WK7CAM->GetScissor(sc_rect);
	
	WK7Cam::Set2DMatrix(view,proj);
	
	// [Jr[ϊ}gNXݒ
	GXLoadPosMtxImm  (view,GX_PNMTX0);
	GXLoadNrmMtxImm  (view,GX_PNMTX0);
	GXSetCurrentMtx  (GX_PNMTX0);
	GXSetProjection  (proj,GX_ORTHOGRAPHIC);
	GXSetScissor     (0,0,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT);
	GXSetViewport    (0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);
	
	GXSetDither      (GX_FALSE);
	GXSetDstAlpha    (0,0);
	GXSetAlphaCompare(GX_ALWAYS,0,GX_AOP_AND,GX_ALWAYS,0);
	
	GXSetNumChans    (1);
	GXSetChanCtrl    (GX_COLOR0A0,GX_FALSE,GX_SRC_REG,GX_SRC_REG,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
	
	// uhȂ
	GXSetBlendMode   (GX_BM_NONE,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetCullMode    (GX_CULL_NONE);
	
	GXSetZMode       (GX_FALSE,GX_ALWAYS,GX_FALSE);
	GXSetZCompLoc    (GX_TRUE );
	GXSetColorUpdate (GX_TRUE );
	GXSetAlphaUpdate (GX_FALSE);
	
	GXClearVtxDesc   ();
	GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
	GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
	
	GXSetNumTexGens  (0);
	
	GXSetNumTevStages(1);
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR0A0);
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_RASC);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	
static	f32		clearz = 0.5f;
static	f32		namew = 200.0f,nameh = 48.0f;
	int			id;
	
	switch( editid ){
	case	0:
		id = 1;
		break;
	default:
		id = 0;
		break;
	}
	GXSetChanMatColor(GX_COLOR0A0,drawColor[id]);
	GXBegin(GX_LINESTRIP,GX_VTXFMT0,5);
	
		GXPosition3f32(mNameX      ,mNameY      ,clearz);
		GXPosition3f32(mNameX+namew,mNameY      ,clearz);
		GXPosition3f32(mNameX+namew,mNameY+nameh,clearz);
		GXPosition3f32(mNameX      ,mNameY+nameh,clearz);
		GXPosition3f32(mNameX      ,mNameY      ,clearz);
		
	GXEnd();
	
	switch( editid ){
	case	0:
		id = 0;
		break;
	default:
		id = 1;
		break;
	}
	GXSetChanMatColor(GX_COLOR0A0,drawColor[id]);
	GXBegin(GX_LINESTRIP,GX_VTXFMT0,5);
	
		GXPosition3f32(mWindowX         ,mWindowY         ,clearz);
		GXPosition3f32(mWindowX+mWindowW,mWindowY         ,clearz);
		GXPosition3f32(mWindowX+mWindowW,mWindowY+mWindowH,clearz);
		GXPosition3f32(mWindowX         ,mWindowY+mWindowH,clearz);
		GXPosition3f32(mWindowX         ,mWindowY         ,clearz);
		
	GXEnd();
	
	return true;
}
#endif

bool WK7CharaPresent::RenderProcess(void)
{
	if( mReserved==true ){
		return true;
	}
	if( mEnable==false ){
		return true;
	}
#ifdef	_DEBUG
	if( GETCAPTUREMODE() ){
		return true;
	}
#endif
	
	Mtx				view;
	Mtx44			proj;
static	GXColor		clearColor = { 0xff,0xff,0xff,0xff };
static	GXColor		maskColor  = { 0xff,0xff,0xff,0x00 };
static	GXColor		drawColor  = { 0x40,0x40,0x40,0xff };
	
	HSD_RectU16		sc_rect;
	WK7CAM->GetScissor(sc_rect);
	
	WK7Cam::Set2DMatrix(view,proj);
	
	// [Jr[ϊ}gNXݒ
	GXLoadPosMtxImm  (view,GX_PNMTX0);
	GXLoadNrmMtxImm  (view,GX_PNMTX0);
	GXSetCurrentMtx  (GX_PNMTX0);
	GXSetProjection  (proj,GX_ORTHOGRAPHIC);
//	GXSetScissor     (0,0,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT);
	GXSetScissor     (sc_rect.xmin,sc_rect.ymin,(u32)(sc_rect.xmax-sc_rect.xmin),(u32)(sc_rect.ymax-sc_rect.ymin));
	GXSetViewport    (0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);
	
	GXSetDither      (GX_FALSE);
	GXSetDstAlpha    (0,0);
	GXSetAlphaCompare(GX_ALWAYS,0,GX_AOP_AND,GX_ALWAYS,0);
	
	GXSetNumChans    (1);
	GXSetChanCtrl    (GX_COLOR0A0,GX_FALSE,GX_SRC_REG,GX_SRC_REG,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
	GXSetChanMatColor(GX_COLOR0A0,clearColor);
	
	// uhȂ
	GXSetBlendMode   (GX_BM_NONE,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetCullMode    (GX_CULL_NONE);
	
	GXSetZMode       (GX_FALSE,GX_ALWAYS,GX_FALSE);
	GXSetZCompLoc    (GX_TRUE );
	GXSetColorUpdate (GX_FALSE);
	GXSetAlphaUpdate (GX_TRUE );
	
	GXClearVtxDesc   ();
	GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
	GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
	
	GXSetNumTexGens  (0);
	
	GXSetNumTevStages(1);
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR0A0);
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_RASC);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	
	// lNAi0xffj
	
	GXBegin(GX_QUADS,GX_VTXFMT0,4);
	
		GXPosition3f32(0.0f            ,0.0f             ,clearz);
		GXPosition3f32(WK7_SCREEN_WIDTH,0.0f             ,clearz);
		GXPosition3f32(WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,clearz);
		GXPosition3f32(0.0f            ,WK7_SCREEN_HEIGHT,clearz);
		
	GXEnd();
	
	WK7CharaPresentMaskWindow		*pWindow;
	
	GXSetChanMatColor(GX_COLOR0A0,maskColor);
	for(pWindow=(WK7CharaPresentMaskWindow *)mWindowAnchor.GetNext() ; pWindow!=NULL ; pWindow=pWindow->GetNext()){
		pWindow->RenderProcess();
	}
	
	// }XNꂽƂȊOmg[`
	
	GXSetChanMatColor(GX_COLOR0A0,drawColor);
	
	GXSetBlendMode   (GX_BM_BLEND,GX_BL_DSTALPHA,GX_BL_INVDSTALPHA,GX_LO_CLEAR);
	GXSetColorUpdate (GX_TRUE );
	GXSetAlphaUpdate (GX_FALSE);
	
	GXSetNumTexGens  (1);
	GXSetTexCoordGen (GX_TEXCOORD0,GX_TG_MTX2x4,GX_TG_TEX0,GX_IDENTITY);
	screenImageMonoColor.LoadTexObj(GX_TEXMAP0);
	
	GXSetNumTevStages(1);
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR0A0);
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_RASC,GX_CC_TEXC,GX_CC_ZERO);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	
	GXClearVtxDesc   ();
	GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
	GXSetVtxDesc     (GX_VA_TEX0,GX_DIRECT);
	GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
	GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_TEX0,GX_TEX_ST  ,GX_F32  ,0);
	
	GXBegin(GX_QUADS,GX_VTXFMT0,4);
	
		GXPosition3f32(0.0f            ,0.0f             ,clearz);
		GXTexCoord2f32(0.0f,0.0f);
		GXPosition3f32(WK7_SCREEN_WIDTH,0.0f             ,clearz);
		GXTexCoord2f32(1.0f,0.0f);
		GXPosition3f32(WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,clearz);
		GXTexCoord2f32(1.0f,1.0f);
		GXPosition3f32(0.0f            ,WK7_SCREEN_HEIGHT,clearz);
		GXTexCoord2f32(0.0f,1.0f);
		
	GXEnd();
	
	GXSetChanCtrl    (GX_COLOR0A0,GX_FALSE,GX_SRC_VTX,GX_SRC_VTX,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
	GXSetBlendMode   (GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetScissor     (0,0,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT);
	GXSetViewport    (0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);
	
#ifndef	K7APP_MASTER
#if 0
	if( mTickCountEnable==true ){
		C_Paper		paper(64,448);
		PRINTF("%d(%08x)\n",mTickCounter,mTickCounter);
		
		if( mDeleteTick==0xffffffff ){
			RenderProcessEditMode();
		}
		
	}
#endif
#endif
	
	return true;
}

WK7CharaPresentMaskWindow* WK7CharaPresent::AddMaskWindow(f32 x,f32 y,f32 w,f32 h)
{
	ghmGcMemSetAllocName("WK7CrPrW");
	WK7CharaPresentMaskWindow		*pWindow = new WK7CharaPresentMaskWindow(&mWindowAnchor);
	if( pWindow==NULL ){
		return NULL;
	}
	pWindow->SetRect(x,y,w,h);
	pWindow->SetEnable(true);
	return pWindow;
}

bool WK7CharaPresent::DeleteMaskWindow(WK7CharaPresentMaskWindow *pWindow)
{
	if( pWindow==NULL ){
		return false;
	}
	WK7CharaPresentMaskWindow		*pSearchWindow;
	for(pSearchWindow=(WK7CharaPresentMaskWindow *)mWindowAnchor.GetNext() ; pSearchWindow!=NULL ; pSearchWindow=pSearchWindow->GetNext()){
		if( pSearchWindow==pWindow ){
			delete pWindow;
			return true;
		}
	}
	return false;
}

bool WK7CharaPresent::DeleteMaskWindowAll(void)
{
	WK7CharaPresentMaskWindow		*pWindow;
	WK7CharaPresentMaskWindow		*pNext;
	for(pWindow=(WK7CharaPresentMaskWindow *)mWindowAnchor.GetNext() ; pWindow!=NULL ; pWindow=pNext){
		pNext = pWindow->GetNext();
		delete pWindow;
	}
	return true;
}

WK7CharaPresentMaskWindow::WK7CharaPresentMaskWindow(ghmGcListObj *pAnchor) : ghmGcListObj(pAnchor)
{
	mPosX   = 0.0f;
	mPosY   = 0.0f;
	mWidth  = 0.0f;
	mHeight = 0.0f;
}

WK7CharaPresentMaskWindow::~WK7CharaPresentMaskWindow()
{
}

bool WK7CharaPresentMaskWindow::SetRect(f32 x,f32 y,f32 w,f32 h)
{
	mPosX   = x;
	mPosY   = y;
	mWidth  = w;
	mHeight = h;
	return true;
}

bool WK7CharaPresentMaskWindow::FrameProcess(void)
{
	return true;
}

bool WK7CharaPresentMaskWindow::RenderProcess(void)
{
	if( mEnable==false ){
		return true;
	}
	
	f32		r,b;
	
	r = mPosX + mWidth;
	b = mPosY + mHeight;
	
	GXBegin(GX_QUADS,GX_VTXFMT0,4);
	
		GXPosition3f32(mPosX,mPosY,clearz);
		GXPosition3f32(r    ,mPosY,clearz);
		GXPosition3f32(r    ,b    ,clearz);
		GXPosition3f32(mPosX,b    ,clearz);
		
	GXEnd();
	
	return true;
}

