////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// WK7Enemy.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/15/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7ENEMY_CPP__

//#include <dolphin.h>
#include ".\WK7Enemy.h"
#include ".\WK7Player.h"
#include ".\WK7MainTask.h"
//#include "..\Lib\ghmGcFile.h"
//#include "..\Lib\ghmGcMath.h"

#include "..\Enm\EnmA.h"
#include "..\Enm\EnmB.h"
#include "..\Enm\EnmC.h"
#include "..\Enm\EnmD.h"

WK7Enemy::WK7Enemy(u32 enemyid,ghmGcListObj *pAnchor,int prio) : WK7Npc(enemyid,TYPE_ENEMY,pAnchor,prio)
{
}

WK7Enemy::~WK7Enemy()
{
}

WK7Enemy* WK7Enemy::Find(u32 enemyid,u32 stgid,u32 param)
{
	WK7Npc		*pNpc = (WK7Npc *)mAnchor.GetNext();
	while( pNpc!=NULL ){
		if( pNpc->GetID()==enemyid && pNpc->GetType()==TYPE_ENEMY ){
			if( stgid==0xffffffff || pNpc->GetStageID()==stgid ){
				if( param==0xffffffff || pNpc->GetParam()==param ){
					return (WK7Enemy *)pNpc;
				}
			}
		}
		pNpc = pNpc->GetNext();
	}
	return NULL;
}

bool WK7Enemy::ReleaseStageEnemy(u32 stgid)
{
	WK7Npc			*pNpc = (WK7Enemy *)mAnchor.GetNext();
	WK7Npc			*pNext;
	while( pNpc!=NULL ){
		pNext = pNpc->GetNext();
		if( pNpc->GetStageID()==stgid && pNpc->GetType()==TYPE_ENEMY ){
			delete pNpc;
		}
		pNpc = pNext;
	}
	return true;
}

