
///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Event
//
// WK7Event.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7EVENT_H__
#define	__WK7EVENT_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcTask.h"
//#include ".\WK7Define.h"
//#include ".\K7ID.h"
//#include ".\WK7Play.h"

#include ".\WK7EventScript.h"
#include ".\WK7EventItem.h"
#include ".\WK7HitObj.h"
#include ".\WK7GameInfo.h"

enum K7EventCondition{
	K7EV_COND_NONE,							// ɂȂiCxgR[̓xɃCxgj
	K7EV_COND_NOTRUN,						// ĂȂ甭
	K7EV_COND_UNKNOWN = 0x7fffffff			// TCY
};

struct K7EventHandler{
	u32						mID;				// Cxghc
	K7EventCondition		mCondition;			// 
	ghmGcTaskHandler		*mpHandler;			// Cxgnh
	ghmGcTaskHandler		*mpTermHandler;		// ICxgnh
	inline u32 GetID(void){ return mID; }
	inline K7EventCondition GetCondition(void){ return mCondition; }
};

struct K7EVVarType{
	const char		*mpType;
	const char		*mpID;
	void			*mpVar;
	int				mArrayNum;
};

struct WK7EventIDTable{
	u32						mEventNo;
	u32						mEventID;
};
#define	WK7EVENTIDTBL(evno,evid)	{ evno , evid },
#define	WK7EVENTIDTBL_TERM_EVNO		0xffffffff
#define	WK7EVENTIDTBL_TERM_EVID		0xffffffff
#define	WK7EVENTIDTBL_TERM			{ WK7EVENTIDTBL_TERM_EVNO , WK7EVENTIDTBL_TERM_EVID },

struct K7EventDesc;
//struct K7EventDesc{
//	u32						mID;
//	int						mType;
//	
//	inline u32 GetID(void){ return mID; }
//	inline int GetType(void){ return mType; }
//};

//#include "WK7EventScript.h"

#define	WK7EVENT_NOID			(0xffffffff)

class WK7Event : public ghmGcListObj{
	friend class WK7EventController;
protected:
//	static WK7EventTable		*mpEventTable;
	static WK7EventIDTable		*mpEventIDTable;
#ifdef	_DEBUG
	static bool					mDebugPrintEnable;
#endif
	u32							mID;
	u32							mNo;
	u32							mParam[2];
	int							mTaskID;
	ghmGcTask					*mpTask;
	ghmGcTaskHandler			*mpHandler;
	ghmGcTaskHandler			*mpTermHandler;
	
	void CallHandler(void);
	void CallTermHandler(void);
	static void Handler(ghmGcTask *pTask);
	static void TermHandler(ghmGcTask *pTask);
public:
	WK7Event(u32 id,ghmGcListObj *pAnchor,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~WK7Event();
	
	inline WK7Event* GetPrev(void){ return (WK7Event *)ghmGcListObj::GetPrev(); }
	inline WK7Event* GetNext(void){ return (WK7Event *)ghmGcListObj::GetNext(); }
	inline ghmGcTaskHandler* GetHandler(void){ return mpHandler; }
	inline ghmGcTaskHandler* GetTermHandler(void){ return mpTermHandler; }
	
	inline void SetNo(u32 no){ mNo=no; }
	inline u32 GetNo(void){ return mNo; }
	inline u32 GetID(void){ return mID; }
	inline bool SetParam(int id,u32 param){ if(id<0 || id>=2){ return false; } mParam[id]=param; return true; }
	inline u32 GetParam(int id){ return (id<0 || id>=2)? 0 : mParam[id]; }
	
	static int SetEventEnableAll(u32 eventid,bool flag);
	static int SetEventNoEnableAll(u32 eventno,bool flag);
//	inline static void SetTable(WK7EventTable *pEventTable){ mpEventTable=pEventTable; }
//	inline static WK7EventTable* GetTable(void){ return mpEventTable; }
	inline static void SetIDTable(WK7EventIDTable *pEventIDTable){ mpEventIDTable=pEventIDTable; }
	inline static WK7EventIDTable* GetIDTable(void){ return mpEventIDTable; }
	static WK7EventIDTable* FindIDTable(u32 evno);
	static WK7EventIDTable* FindIDTableFromEventID(u32 evid);
	static bool CallStageCondChange(u32 stgid);
	static bool CallCurrentStageCondChange(void);
	static bool CallStageCondChangeAll(void);
	static bool CallCondChangeAll(void);
#ifdef	_DEBUG
	inline static bool SetDebugPrintEnable(bool flag){ mDebugPrintEnable=flag; return true; }
	inline static bool GetDebugPrintEnable(void){ return mDebugPrintEnable; }
	static bool DebugPrint(const char *pstr);
#endif
};

#define	WK7EVENTCONTROLLER_CALL_SUCCESS				(1)			// 
#define	WK7EVENTCONTROLLER_CALL_DISABLE				(0)			// QdN֎~
#define	WK7EVENTCONTROLLER_CALL_FAILED				(-1)		// sisHj
#define	WK7EVENTCONTROLLER_CALL_NOTFOUND			(-2)		// CxgȂ
#define	WK7EVENTCONTROLLER_CALL_TASKSTART_FAILED	(-3)		// ^XNĂяos

struct K7EventDescData{
	int						mStep;
	int						mCount;
	inline void Initialize(void){ mStep=-1; mCount=0; }
};

#define	K7EV_DEFAULT_PRIO			GHMGCLIST_DEFAULT_PRIO

struct	tagEFFECT;
typedef struct tagEFFECT EFFECT;
class WK7EventEffect : public ghmGcListObj{
public:
	enum WK7EventEffectType{
		NORMAL = 0,
		MESSAGE,
	};
protected:
	EFFECT					*mpEffect;
	u32						mEffectID;
	WK7EventEffectType		mType;
	WK7EventEffect();
public:
	WK7EventEffect(ghmGcListObj *pAnchor,EFFECT *pEffect);
	~WK7EventEffect();
	
	inline WK7EventEffect* GetNext(void){ return (WK7EventEffect*)ghmGcListObj::GetNext(); }
	inline WK7EventEffect* GetPrev(void){ return (WK7EventEffect*)ghmGcListObj::GetPrev(); }
	
	inline EFFECT* GetEffect(void){ return mpEffect; }
	inline WK7EventEffectType GetType(void){ return mType; }
	
	bool IsValid(void);
	bool FrameProcess(void);
};

#define	WK7EVENTEFFECTMESSAGE_KIND_MESSAGE		(0)
#define	WK7EVENTEFFECTMESSAGE_KIND_ITEMGET		(1)
class WK7EventEffectMessage : public WK7EventEffect{
protected:
	u32					mMessageID;
	s32					mIconID;
	s32					mSoundID;
	int					mKind;
public:
	WK7EventEffectMessage(u32 mesid,s32 icoid,s32 sndid,int kind,ghmGcListObj *pAnchor,EFFECT *pEffect) : WK7EventEffect(pAnchor,pEffect){
		mMessageID = mesid;
		mIconID    = icoid;
		mSoundID   = sndid;
		mType      = MESSAGE;
		mKind      = kind;
	}
	virtual ~WK7EventEffectMessage(){}
	
	inline WK7EventEffectMessage* GetNext(void){ return (WK7EventEffectMessage *)ghmGcListObj::GetNext(); }
	inline WK7EventEffectMessage* GetPrev(void){ return (WK7EventEffectMessage *)ghmGcListObj::GetPrev(); }
	
	inline u32 GetMessageID(void){ return mMessageID; }
	inline s32 GetIconID(void){ return mIconID; }
	inline s32 GetSoundID(void){ return mSoundID; }
	inline int GetKind(void){ return mKind; }
};

class ghmGcModule;
class WK7EventController{
public:
	enum WK7EventControllerState{
		WK7EVENTCONTROLLERSTATE_IDLE = 0,
		WK7EVENTCONTROLLERSTATE_INIT,
		WK7EVENTCONTROLLERSTATE_MODULELOAD,
		WK7EVENTCONTROLLERSTATE_MODULELOADWAIT,
		WK7EVENTCONTROLLERSTATE_LOAD,
		WK7EVENTCONTROLLERSTATE_LOADWAIT,
		WK7EVENTCONTROLLERSTATE_SYSMES_LOAD,
		WK7EVENTCONTROLLERSTATE_SYSMES_LOADWAIT,
		WK7EVENTCONTROLLERSTATE_DYNAMICLOAD,
		WK7EVENTCONTROLLERSTATE_DYNAMICLOADWAIT,
		WK7EVENTCONTROLLERSTATE_RUN,
		WK7EVENTCONTROLLERSTATE_MAX  = 0x7fffffff
	};
	enum WK7EventControllerDataState{
		DATASTATE_IDLE = 0,
		DATASTATE_LOADING,
		DATASTATE_LOADED,
		DATASTATE_RELEASE,
		DATASTATE_RELEASED = DATASTATE_IDLE,
	};
	enum WK7EventControllerDataProc{
		DATAPROC_IDLE = 0,
		DATAPROC_MATLOAD,
		DATAPROC_MATLOADED,
		DATAPROC_YAMLOAD,
		DATAPROC_YAMLOADED,
		DATAPROC_SATLOAD,
		DATAPROC_SATLOADED,
		DATAPROC_KAWLOAD,
		DATAPROC_KAWLOADED,
		DATAPROC_WATLOAD,
		DATAPROC_WATLOADED,
		DATAPROC_DYNAMICLOAD,
		DATAPROC_DYNAMICLOADED,
		DATAPROC_LOADED,
		DATAPROC_DYNAMICRELEASE,
		DATAPROC_DYNAMICRELEASED,
		DATAPROC_WATRELEASE,
		DATAPROC_WATRELEASED,
		DATAPROC_KAWRELEASE,
		DATAPROC_KAWRELEASED,
		DATAPROC_SATRELEASE,
		DATAPROC_SATRELEASED,
		DATAPROC_YAMRELEASE,
		DATAPROC_YAMRELEASED,
		DATAPROC_MATRELEASE,
		DATAPROC_MATRELEASED = DATAPROC_IDLE,
	};
protected:
	static WK7EventController		*mpEventControllerInstance;
	ghmGcListObj					mAnchor;
	
	K7EventHandler					*mpGlobalEventHandler;
	int								mGlobalEventHandlerNum;
	K7EventHandler					*mpScenarioEventHandler;
	int								mScenarioEventHandlerNum;
	
	K7EventDesc						**mppGlobalEventDesc;
	int								mGlobalEventDescNum;
	K7EventDesc						**mppScenarioEventDesc;
	int								mScenarioEventDescNum;
	
	ghmGcTaskController				mTaskController;
	WK7EventControllerState			mState;
	
	ghmGcListObj					mEffectAnchor;
	
	int								mMessageHandle;
	
	void							*mpKeepMemory;
	int								mRestMemorySize;
	int								mMatMemorySize;
	int								mYamMemorySize;
	int								mSatMemorySize;
	int								mKawMemorySize;
	int								mWatMemorySize;
	int								mStageMemorySize;
	int								mDynamicMemorySize;
	bool							mMemoryCheck;
	
	ghmGcTaskController				*mpFrameProcessTaskController;
	ghmGcTaskController				*mpRenderProcessTaskController;
	
	ghmGcModule						*mpModule;
	void							*mpModuleWork;
	
	WK7EventControllerDataState		mStaticDataState;
	WK7EventControllerDataProc		mStaticDataProc;
	int								mTempRelease;
	
	static void ContinueTask(ghmGcTask *);
	
	bool InitProcess(void);
	bool ContinueProcess(void);
	
	bool AllocRestMemory(void);
	bool AllocKeepMemory(void);
	bool FreeKeepMemory(void);
	static int GetHandlerTableNum(K7EventHandler *pHandler);
	static int GetDescTableNum(K7EventDesc **ppDesc);
	bool CompareBranchPointEventDesc(K7EventDesc *pDesc,const char *pBpName);
	WK7EventController();
	bool FrameProcessEffect(void);
public:
	virtual ~WK7EventController();
	
	bool SetTaskController(ghmGcTaskController *pfp=NULL,ghmGcTaskController *prp=NULL){
		mpFrameProcessTaskController  = pfp;
		mpRenderProcessTaskController = prp;
		return true;
	}
	inline ghmGcTaskController* GetFrameProcessTaskController(void){ return mpFrameProcessTaskController; }
	inline ghmGcTaskController* GetRenderProcessTaskController(void){ return mpRenderProcessTaskController; }
	
	bool SetScenarioEventHandler(K7EventHandler *pHandler);
	bool SetScenarioEventDesc(K7EventDesc **ppDesc);
	
	bool Initialize(void);
	bool LoadModule(void);
	bool LoadStaticData(void);
	bool IsLoadedStaticData(void);
	bool ReleaseStaticData(void);
	bool FrameProcess(void);
	bool FrameProcessData(void);
	bool Terminate(void);
	
	bool LoadData(void);
	bool IsLoadedData(void);
	bool ReleaseData(void);
	bool IsReleasedData(void);
	bool ReleaseTempData(void);
	bool IsReleasedTempData(void);
	bool ReleaseTempData2(void);
	bool IsReleasedTempData2(void);
	bool ReleaseTempData3(void);
	bool IsReleasedTempData3(void);
	
	bool ReloadDynamicData(void);
	bool LoadDynamicData(void);
	bool IsLoadedDynamicData(void);
	bool ReleaseDynamicData(void);
	
	int Call(u32 id,u32 param0=0,u32 param1=0,int prio=K7EV_DEFAULT_PRIO);
	int Call(K7EventDesc *pDesc,u32 param0=0,u32 param1=0,int prio=K7EV_DEFAULT_PRIO);
	int Call(ghmGcTaskHandler *pHandler,ghmGcTaskHandler *pTermHandler=NULL,u32 param0=0,u32 param1=0,int prio=K7EV_DEFAULT_PRIO);
	int Call2(ghmGcTaskHandler *pHandler,ghmGcTaskHandler *pTermHandler=NULL,u32 param0=0,u32 param1=0,int prio=K7EV_DEFAULT_PRIO);
	int CallIM(u32 id,u32 param0=0,u32 param1=0,int prio=K7EV_DEFAULT_PRIO);
	int CallIM(K7EventDesc *pDesc,u32 param0=0,u32 param1=0,int prio=K7EV_DEFAULT_PRIO);
	int CallIM(ghmGcTaskHandler *pHandler,ghmGcTaskHandler *pTermHandler=NULL,u32 param0=0,u32 param1=0,int prio=K7EV_DEFAULT_PRIO);
	int CallIM2(ghmGcTaskHandler *pHandler,ghmGcTaskHandler *pTermHandler=NULL,u32 param0=0,u32 param1=0,int prio=K7EV_DEFAULT_PRIO);
	
	int CallSpecialAttackEvent(u32 chrid);
	
	K7EventHandler* GetHandler(u32 id);
	WK7Event* GetEvent(u32 id);
	WK7Event* GetEvent(ghmGcTaskHandler *pHandler,ghmGcTaskHandler *pTermHandler,u32 param0,u32 param1);
	
	K7EventDesc* GetEventDesc(int type,K7EventDescData &data);
	K7EventDesc* GetBranchPointEventDesc(const char *pBpName,K7EventDescData &data);
	
	static WK7EventController* GetInstance(void);
	
	inline WK7EventControllerState GetState(void){ return mState; }
	
	bool DeleteEffectAll(void);
	
	WK7EventEffectMessage* CreateMessage(u32 messageID,s32 iconID=-1,s32 soundID=-1);
	WK7EventEffectMessage* CallMessage(u32 messageID,s32  iconID=-1,s32 soundID=-1);
	bool CallMessageB(u32 messageID,s32 iconID=-1,s32 soundID=-1);
	bool CallMessageB2(u32 messageID,s32 iconID=-1,s32 soundID=-1);
	bool IsValidMessage(u32 messageID);
	bool IsDisplayedMessage(u32 messageID);
	
	WK7EventEffectMessage* CreateItemGet(u32 messageID,bool buttonCancel=true,s32 iconID=-1,s32 soundID=-1);
	WK7EventEffectMessage* CallItemGet(u32 messageID,bool buttonCancel=true,s32  iconID=-1,s32 soundID=-1);
	bool CallItemGetB(u32 messageID,bool buttonCancel=true,s32 iconID=-1,s32 soundID=-1);
	bool CallItemGetB2(u32 messageID,bool buttonCancel=true,s32 iconID=-1,s32 soundID=-1);
	bool IsValidItemGet(u32 messageID);
	bool IsDisplayedItemGet(u32 messageID);
	
	bool IsValidEffect(WK7EventEffect *pEffect);
};

#define	WK7EVENTCONTROLLER								WK7EventController::GetInstance()

#define	K7EV_HANDLER(func)								static void func(ghmGcTask *pTask)
#define	K7EVENT_HANDLER(func)							K7EV_HANDLER(func)
#define	K7EV_CALL(func)									func(pTask)
#define	K7EVENT_CALL(func)								K7EV_CALL(func)

#define	K7EV_HANDLER_DECL(id,handler,termhandler)					K7EV_HANDLER_DECL_BASE(id,K7EV_COND_NONE,handler,termhandler)
#define	K7EV_HANDLER_DECL_COND(id,handler,termhandler,cond)			K7EV_HANDLER_DECL_BASE(id,cond,handler,termhandler)
#define	K7EV_SCN_HANDLER_DECL(id,handler,termhandler)				K7EV_HANDLER_DECL_BASE(id,K7EV_COND_NONE,handler,termhandler)
#define	K7EV_SCN_HANDLER_DECL_COND(id,handler,cond,termhandler)		K7EV_HANDLER_DECL_BASE(id,cond,handler,termhandler)

#define	K7EV_SCN_STARTID								(0x80000000)
#define	K7EV_GLOBAL_STARTID								(0)

#define	K7EV_HANDLER_TABLE								EventHandlerTable
#define	K7EV_HANDLER_TABLE_DECL							extern K7EventHandler EventHandlerTable[];
#define	K7EV_DESC_TABLE									EventDescTable
#define	K7EV_DESC_TABLE_DECL							extern K7EventDesc* EventDescTable[];
#define	K7EV_SCN_HANDLER_TABLE(scnid)					scnid##EventHandlerTable
#define	K7EV_SCN_HANDLER_TABLE_DECL(scnid)				extern K7EventHandler scnid##EventHandlerTable[];
#define	K7EV_SCN_DESC_TABLE(scnid)						scnid##EventDescTable
#define	K7EV_SCN_DESC_TABLE_DECL(scnid)					extern K7EventDesc* scnid##EventDescTable[];
#define	K7EV_DESC_NAME(id)								eventDesc_##id

#define	K7EV_SCN_IDTABLE(scnid)							scnid##_EventIDTable
#define	K7EV_SCN_IDTABLE_DECL(scnid)					extern WK7EventIDTable scnid##_EventIDTable[];
#define	K7EV_SCN_ITEMTABLE(scnid)						scnid##_EventItemTable
#define	K7EV_SCN_ITEMTABLE_DECL(scnid)					extern WK7EventItemTable scnid##_EventItemTable[];
#define	K7EV_SCN_HITOBJTABLE(scnid)						scnid##_HitObjTable
#define	K7EV_SCN_HITOBJTABLE_DECL(scnid)				extern WK7HitObjTable scnid##_HitObjTable[];
#ifdef	_DEBUG
#define	K7EV_SCN_FLAGNAME(scnid)						scnid##FlagName
#else
#define	K7EV_SCN_FLAGNAME(scnid)						
#endif
#define	K7EV_SCN_VAR_DECL(scnid)						struct scnid##_EventVar
#define	K7EV_SCN_VAR(scnid)								((scnid##_EventVar *)GameInfo.GetScenarioVar(scnid))

#define	K7EV_SCN_FLAG_MASK								(0x00ffffff)
#define	K7EV_SCN_FLAG_SCN_MASK							(0xff000000)
#define	K7EV_SCN_FLAG_SCN_SHIFT							(24)
#define	K7EV_SCN_FLAG_ID_TO_SCN(id)						((u32)((id) & K7EV_SCN_FLAG_SCN_MASK) >> K7EV_SCN_FLAG_SCN_SHIFT)

#define	K7EV_SCN_VARTYPENAMEBODY(scnid)					scnid##_EventVarType
#define	K7EV_SCN_VARTYPENAME(scnid)						_##scnid##_EventVarType

#define	K7EV_HITOBJTABLE(evno)							K7EV_HITOBJTABLE_BASE(evno,-1,HITOBJTYPE_NOACTION)
#define	K7EV_HITOBJTABLE_HIDE(evno,flag)				K7EV_HITOBJTABLE_BASE(evno,flag,HITOBJTYPE_HIDE)
#define	K7EV_HITOBJTABLE_DISP(evno,flag)				K7EV_HITOBJTABLE_BASE(evno,flag,HITOBJTYPE_DISP)
#define	K7EV_HITOBJTABLE_HIDE_PATHOPEN(evno,flag)		K7EV_HITOBJTABLE_BASE(evno,flag,HITOBJTYPE_HIDE_PATHOPEN)

#define	K7EV_MAINTASK									WK7MainTask::mpMainTask
#define	K7EVENT_MAINTASK								K7EV_MAINTASK
#define	K7EV_CAM										K7EV_MAINTASK->GetCamera()
#define	K7EVENT_CAM										K7EV_CAM
#define	K7EV_LIGHT										K7EV_MAINTASK->GetLight()
#define	K7EVENT_LIGHT									K7EV_LIGHT
#define	K7EV_PATHCONTROL								WK7PLAYERCONTROL->GetPathControl()
#define	K7EVENT_PATHCONTROL								K7EV_PATHCONTROL

#define	K7EV_CHR(id)									WK7RenderObj::GetChara(id)
#define	K7EV_STG(id)									WK7RenderObj::GetStage(id)
#define	K7EV_CUR_STG									WK7Stage::GetCurrentStage()
#define	K7EV_ITEM(id)									WK7RenderObj::GetItem(id)
#define	K7EV_CHR_MODEL(id)								K7EV_CHR(id)!=NULL? K7EV_CHR(id)->GetModel() : NULL
#define	K7EV_STG_MODEL(id)								K7EV_STG(id)!=NULL? K7EV_STG(id)->GetModel() : NULL
#define	K7EV_ITEM_MODEL(id)								K7EV_ITEM(id)!=NULL? K7EV_ITEM(id)->GetModel() : NULL

#define	K7EV_MOTCHR(id)									WK7MotionObj::GetCharaMotion(id)
#define	K7EV_MOTSTG(id)									WK7MotionObj::GetStageMotion(id)
#define	K7EV_MOTITEM(id)								WK7MotionObj::GetItemMotion(id)
#define	K7EV_CHR_MODELMOTION(id)						K7EV_MOTCHR(id)!=NULL? K7EV_MOTCHR(id)->GetModelMotion() : NULL
#define	K7EV_STG_MODELMOTION(id)						K7EV_MOTSTG(id)!=NULL? K7EV_MOTSTG(id)->GetModelMotion() : NULL
#define	K7EV_ITEM_MODELMOTION(id)						K7EV_MOTITEM(id)!=NULL? K7EV_MOTITEM(id)->GetModelMotion() : NULL

#define	K7EV_NOANIM										(AOBJ_NO_ANIM)
#define	K7EVENT_NOANIM									K7EV_NOANIM

#define	K7EV_GETEVENT()									((WK7Event*)GHMGCTASK_GETPARAM(0))
#define	K7EV_GETEVENTPARAM(id)							(K7EV_GETEVENT()->GetParam((id)))

#define	K7EV_TYPE_NO									(0x00000000)
#define	K7EV_TYPE_KEY									(0x10000000)
#define	K7EV_TYPE_MAP									(0x20000000)
#define	K7EV_TYPE_MEMO									(0x30000000)
#define	K7EV_TYPE_VMEMO									(0x40000000)
#define	K7EV_TYPE_HANA									(0x50000000)
#define	K7EV_TYPE_ZAN									(0x60000000)
#define	K7EV_TYPE_TAMA									(0x70000000)
#define	K7EV_TYPE_TV									(0xb0000000)
#define	K7EV_TYPE_LTV									(0xc0000000)
#define	K7EV_TYPE_PLAY									(0xd0000000)
#define	K7EV_TYPE_RAKU									(0xe0000000)
#define	K7EV_TYPE_DOOR									(0xf0000000)
#define	K7EV_TYPE_MASK									(0xf0000000)
#define	K7EV_ID_MASK									(0x0fffffff)
// PUi\Li͂POiǏIȂƂlQiPOi@ŕ\LiUjj
// L݂̂Wi擪̃ViIԍ͂PUiłPɎ܂邱ƂKvj
#define	K7EVENTNO(no)									(K7EV_TYPE_NO   |(K7EV_ID_MASK & 0x##no))
#define	K7EVENTKEY(no)									(K7EV_TYPE_KEY  |(K7EV_ID_MASK & 0x##no))
#define	K7EVENTMAP(no)									(K7EV_TYPE_MAP  |(K7EV_ID_MASK & 0x##no))
#define	K7EVENTMEMO(no)									(K7EV_TYPE_MEMO |(K7EV_ID_MASK & 0x##no))
#define	K7EVENTVMEMO(no)								(K7EV_TYPE_VMEMO|(K7EV_ID_MASK & 0x##no))
#define	K7EVENTHANA(no)									(K7EV_TYPE_HANA |(K7EV_ID_MASK & 0x##no))
#define	K7EVENTZAN(no)									(K7EV_TYPE_ZAN  |(K7EV_ID_MASK & 0x##no))
#define	K7EVENTTAMA(no)									(K7EV_TYPE_TAMA |(K7EV_ID_MASK & 0x##no))
#define	K7EVENTRAKU(no)									(K7EV_TYPE_RAKU |(K7EV_ID_MASK & 0x##no))
#define	K7EVENTDOOR(no)									(K7EV_TYPE_DOOR |(K7EV_ID_MASK & 0x##no))
#define	K7EVENTPLAY(no)									(K7EV_TYPE_PLAY |(K7EV_ID_MASK & 0x##no))

#define	K7EVENTNOID(id)									(K7EV_TYPE_NO   |(K7EV_ID_MASK & (id)))
#define	K7EVENTKEYID(id)								(K7EV_TYPE_KEY  |(K7EV_ID_MASK & (id)))
#define	K7EVENTMAPID(id)								(K7EV_TYPE_MAP  |(K7EV_ID_MASK & (id)))
#define	K7EVENTMEMOID(id)								(K7EV_TYPE_MEMO |(K7EV_ID_MASK & (id)))
#define	K7EVENTVMEMOID(id)								(K7EV_TYPE_VMEMO|(K7EV_ID_MASK & (id)))
#define	K7EVENTHANAID(id)								(K7EV_TYPE_HANA |(K7EV_ID_MASK & (id)))
#define	K7EVENTZANID(id)								(K7EV_TYPE_ZAN  |(K7EV_ID_MASK & (id)))
#define	K7EVENTTAMAID(id)								(K7EV_TYPE_TAMA |(K7EV_ID_MASK & (id)))
#define	K7EVENTRAKUID(id)								(K7EV_TYPE_RAKU |(K7EV_ID_MASK & (id)))
#define	K7EVENTDOORID(id)								(K7EV_TYPE_DOOR |(K7EV_ID_MASK & (id)))
#define	K7EVENTPLAYID(id)								(K7EV_TYPE_PLAY |(K7EV_ID_MASK & (id)))

#define	K7EVENT_SCN_VAR(scnid,id)						K7EV_SCN_VAR(scnid)->id
#define	K7EVENT_GL_VAR(id)								(GameInfo.GetGlobalVar())->id

#define	K7EVENTHANA_CHRID(id)							((u32)((id & 0x0000ff00) >> 8))
#define	K7EVENTHANA_SEQID(id)							((u32)( id & 0x000000ff)      )

//#define	K7EV_SCN_HANAFLAG_NUM							(128)
//#define	K7EV_SCN_HANAFLAG_WORKSIZE						GHM_ROUNDUP(K7EV_SCN_HANAFLAG_NUM,32)

//#define	WK7EVENT_PATHCANCEL
//#include ".\WK7MainTask.h"
//#include ".\WK7HitObj.h"
//#include ".\WK7EventItem.h"
//#undef	WK7EVENT_PATHCANCEL

extern const char* GetTokenPointer(const char *pStr,char token);
extern const char* GetTokenPointer2(const char *pStr,char token);
extern const char* GetPartialStr(char *pDstStr,int maxlen,const char *pStr,char token);
extern const char* GetPartialStr(char* &pDstStr,const char *pStr,char token);
extern const char* GetPartialStr2(char *pDstStr,int maxlen,const char *pStr,char token);
extern const char* GetPartialStr2(char *&pDstStr,const char *pStr,char token);

#endif	//__WK7EVENT_H__

//#ifdef	WK7EVENT_PATHCANCEL

//#undef	WK7EVENT_PATHCANCEL

//#else

#undef	K7EV_HANDLER_DECL_START
#undef	K7EV_HANDLER_DECL_BASE
#undef	K7EV_HANDLER_DECL_END
#undef	K7EV_SCN_HANDLER_DECL_START
#undef	K7EV_SCN_HANDLER_DECL_END

#undef	K7EV_DESC_START
#undef	K7EV_DESC
#undef	K7EV_DESC_END
#undef	K7EV_SCN_DESC_START
#undef	K7EV_SCN_DESC_END

#undef	K7EV_SCN_IDTABLE_START
#undef	K7EV_IDTABLE
#undef	K7EV_SCN_IDTABLE_END

#undef	K7EV_SCN_ITEMTABLE_START
#undef	K7EV_ITEMTABLE
#undef	K7EV_SCN_ITEMTABLE_END

#undef	K7EV_SCN_HITOBJTABLE_START
#undef	K7EV_HITOBJTABLE_BASE
#undef	K7EV_SCN_HITOBJTABLE_END

#undef	K7EV_SCN_FLAG_START
#undef	K7EV_FLAG
#undef	K7EV_SCN_FLAG_END

#undef	K7EV_SCN_VAR_START
#undef	K7EV_VAR
#undef	K7EV_VAR_ARRAY
#undef	K7EV_SCN_VAR_END

#if defined(K7EV_TBL_PART)

	#define	K7EV_HANDLER_DECL_START						K7EventHandler EventHandlerTable [] = {
	#define	K7EV_HANDLER_DECL_BASE(id,...)				{ id , __VA_ARGS__ , },
	#define	K7EV_HANDLER_DECL_END						{ 0xffffffff , K7EV_COND_UNKNOWN , NULL, NULL , }, };
	#define	K7EV_SCN_HANDLER_DECL_START(scnid)			K7EventHandler scnid##EventHandlerTable [] = {
	#define	K7EV_SCN_HANDLER_DECL_END(scnid)			{ 0xffffffff , K7EV_COND_UNKNOWN , NULL, NULL , }, };
	
	#define	K7EV_DESC_START								K7EventDesc* EventDescTable [] = {
	#define	K7EV_DESC(id,type,...)						(K7EventDesc *)&K7EV_DESC_NAME(id),
	#define	K7EV_DESC_END								NULL, };
	#define	K7EV_SCN_DESC_START(scnid)					K7EventDesc* scnid##EventDescTable [] = {
	#define	K7EV_SCN_DESC_END(scnid)					NULL, };
	
	#define	K7EV_SCN_IDTABLE_START(scnid)				WK7EventIDTable scnid##_EventIDTable [] = {
	#define	K7EV_IDTABLE(evno,evid)							WK7EVENTIDTBL(evno,evid)
	#define	K7EV_SCN_IDTABLE_END(scnid)					WK7EVENTIDTBL_TERM };
	
	#define	K7EV_SCN_ITEMTABLE_START(scnid)				WK7EventItemTable scnid##_EventItemTable [] = {
	#define	K7EV_ITEMTABLE(itemno)							WK7EVITEMTBL(itemno)
	#define	K7EV_SCN_ITEMTABLE_END(scnid)					WK7EVITEMTBL_TERM };
	
	#define	K7EV_SCN_HITOBJTABLE_START(scnid)			WK7HitObjTable scnid##_HitObjTable [] = {
	#define	K7EV_HITOBJTABLE_BASE(evno,flag,...)			{ evno , flag , __VA_ARGS__ , },
	#define	K7EV_SCN_HITOBJTABLE_END(scnid)				WK7HITOBJTBL_TERM };
	
#ifdef	_DEBUG
	#define	K7EV_SCN_FLAG_START(scnid)					const char *scnid##FlagName[] = {
	#define	K7EV_FLAG(id)									#id ,
	#define	K7EV_SCN_FLAG_END(scnid)					NULL,};
	
//	#define	K7EV_SCN_VAR_START(scnid)					const char *scnid##VarName[] = {
//	#define	K7EV_VAR(scnid,id,type,inivar)					#id ,
//	#define	K7EV_VAR_ARRAY(scnid,id,num,type,inivar)		#id "!",
//	#define	K7EV_SCN_VAR_END(scnid)						NULL,};
	#define	K7EV_SCN_VAR_START(scnid)					
	#define	K7EV_VAR(scnid,id,type,inivar)				
	#define	K7EV_VAR_ARRAY(scnid,id,num,type,inivar)	
	#define	K7EV_SCN_VAR_END(scnid)						
#else
	#define	K7EV_SCN_FLAG_START(scnid)					
	#define	K7EV_FLAG(id)								
	#define	K7EV_SCN_FLAG_END(scnid)					
	
	#define	K7EV_SCN_VAR_START(scnid)					
	#define	K7EV_VAR(scnid,id,type,inivar)				
	#define	K7EV_VAR_ARRAY(scnid,id,num,type,inivar)	
	#define	K7EV_SCN_VAR_END(scnid)						
#endif
	
	#undef	K7EV_TBL_PART
	
#elif defined(K7EV_BODY_PART)

	#define	K7EV_HANDLER_DECL_START						enum{ EVENTID_START = 0,
	#define	K7EV_HANDLER_DECL_BASE(id,...)					id ,
	#define	K7EV_HANDLER_DECL_END						EVENTID_END };
	#define	K7EV_SCN_HANDLER_DECL_START(scnid)			enum{ scnid##EVENTID_START = K7EV_SCN_STARTID,
	#define	K7EV_SCN_HANDLER_DECL_END(scnid)			scnid##EVENTID_END };

	#define	K7EV_DESC_START							
	#define	K7EV_DESC(id,type,...)						static type K7EV_DESC_NAME(id) = { id , __VA_ARGS__ , };
	#define	K7EV_DESC_END								
	#define	K7EV_SCN_DESC_START(scnid)					
	#define	K7EV_SCN_DESC_END(scnid)					
	
	#define	K7EV_SCN_IDTABLE_START(scnid)				
	#define	K7EV_IDTABLE(evno,evid)						
	#define	K7EV_SCN_IDTABLE_END(scnid)					
	
	#define	K7EV_SCN_ITEMTABLE_START(scnid)				
	#define	K7EV_ITEMTABLE(itemno)						
	#define	K7EV_SCN_ITEMTABLE_END(scnid)				
	
	#define	K7EV_SCN_HITOBJTABLE_START(scnid)			
	#define	K7EV_HITOBJTABLE_BASE(evno,flag,...)		
	#define	K7EV_SCN_HITOBJTABLE_END(scnid)				
	
	#define	K7EV_SCN_FLAG_START(scnid)					enum{	scnid##FLAG_START = ((scnid)<<K7EV_SCN_FLAG_SCN_SHIFT)-1,
	#define	K7EV_FLAG(id)									id , 
	#define	K7EV_SCN_FLAG_END(scnid)					};
	
	#define	K7EV_SCN_VAR_START(scnid)					struct scnid##_EventVar{
	#define	K7EV_VAR(scnid,id,type,inivar)						type		id;
	#define	K7EV_VAR_ARRAY(scnid,id,num,type,inivar)			type		id[num];
	#define	K7EV_SCN_VAR_END(scnid)						};
	
	#define	K7EV_DECL_ENUM
	
	#undef	K7EV_BODY_PART
	
#else
	
#ifdef	K7EV_VAR_INIT
		#define	K7EV_SCN_VAR_START(scnid)				{
		#define	K7EV_VAR(scnid,id,type,inivar)				K7EV_SCN_VAR(scnid)->id = inivar;
		#define	K7EV_VAR_ARRAY(scnid,id,num,type,inivar)	for(int j=0 ; j<num ; j++){ K7EV_SCN_VAR(scnid)->id[j]=inivar; }
		#define	K7EV_SCN_VAR_END(scnid)					}
#elif	defined(K7EV_VAR_DEBUG)
#ifdef	_DEBUG
		#define	K7EV_SCN_VAR_START(scnid)				{ int	i=0;
		#define	K7EV_VAR(scnid,id,type,inivar)				scnid##_EventVarType[i++].mpVar=&(K7EV_SCN_VAR(scnid)->id);
		#define	K7EV_VAR_ARRAY(scnid,id,num,type,inivar)	scnid##_EventVarType[i++].mpVar=  K7EV_SCN_VAR(scnid)->id;
		#define	K7EV_SCN_VAR_END(scnid)					}
#else
		#define	K7EV_SCN_VAR_START(scnid)				
		#define	K7EV_VAR(scnid,id,type,inivar)			
		#define	K7EV_VAR_ARRAY(scnid,id,num,type,inivar)
		#define	K7EV_SCN_VAR_END(scnid)					
#endif
#elif	defined(K7EV_VAR_EDIT)
		#define	K7EV_SCN_VAR_START(scnid)				K7EVVarType scnid##_EventVarType[] = {
		#define	K7EV_VAR(scnid,id,type,inivar)				{ #type , #id ,  NULL , 0   },
		#define	K7EV_VAR_ARRAY(scnid,id,num,type,inivar)	{ #type , #id ,  NULL , num },
		#define	K7EV_SCN_VAR_END(scnid)					    { NULL  ,NULL , NULL }, };
#else
		#define	K7EV_SCN_VAR_START(scnid)				struct scnid##_EventVar{
		#define	K7EV_VAR(scnid,id,type,inivar)				type		id;
		#define	K7EV_VAR_ARRAY(scnid,id,num,type,inivar)	type		id[num];
		#define	K7EV_SCN_VAR_END(scnid)					};
#endif

	#ifndef	K7EV_DECL_ENUM
	
//		#define	K7EV_DECL_ENUM
		
		#define	K7EV_HANDLER_DECL_START					enum{ EVENTID_START = 0,
		#define	K7EV_HANDLER_DECL_BASE(id,...)				id ,
		#define	K7EV_HANDLER_DECL_END					EVENTID_END };
		#define	K7EV_SCN_HANDLER_DECL_START(scnid)		enum{ scnid##EVENTID_START = K7EV_SCN_STARTID,
		#define	K7EV_SCN_HANDLER_DECL_END(scnid)			scnid##EVENTID_END };
		

		#define	K7EV_SCN_FLAG_START(scnid)				enum{	scnid##FLAG_START = ((scnid)<<K7EV_SCN_FLAG_SCN_SHIFT)-1,
		#define	K7EV_FLAG(id)								id , 
		#define	K7EV_SCN_FLAG_END(scnid)				};
		
		#define	K7EV_SCN_ITEMTABLE_START(scnid)			
		#define	K7EV_ITEMTABLE(itemno)					
		#define	K7EV_SCN_ITEMTABLE_END(scnid)			
		
	#else
		
		#define	K7EV_HANDLER_DECL_START					
		#define	K7EV_HANDLER_DECL_BASE(id,...)			
		#define	K7EV_HANDLER_DECL_END					
		#define	K7EV_SCN_HANDLER_DECL_START(scnid)		
		#define	K7EV_SCN_HANDLER_DECL_END(scnid)		
		
		#define	K7EV_SCN_FLAG_START(scnid)				
		#define	K7EV_FLAG(id)							
		#define	K7EV_SCN_FLAG_END(scnid)				
		
		#define	K7EV_SCN_ITEMTABLE_START(scnid)			
		#define	K7EV_ITEMTABLE(itemno)					
		#define	K7EV_SCN_ITEMTABLE_END(scnid)			
		
	#endif
	
	#define	K7EV_DESC_START							
	#define	K7EV_DESC(id,type,...)					
	#define	K7EV_DESC_END							
	#define	K7EV_SCN_DESC_START(scnid)				
	#define	K7EV_SCN_DESC_END(scnid)					
	
	#define	K7EV_SCN_IDTABLE_START(scnid)				
	#define	K7EV_IDTABLE(evno,evid)						
	#define	K7EV_SCN_IDTABLE_END(scnid)					
	
	#define	K7EV_SCN_HITOBJTABLE_START(scnid)			
	#define	K7EV_HITOBJTABLE_BASE(evno,flag,...)		
	#define	K7EV_SCN_HITOBJTABLE_END(scnid)				
	
#endif

//#endif

