////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Fog
//
// WK7Fog.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7FOG_H__
#define	__WK7FOG_H__


class WK7Fog{
protected:
	static WK7Fog	*mpTop;
	static WK7Fog	*mpAllFog;
	WK7Fog			*mpNext;
	HSD_Fog			*mpFog;
	bool			mEnable;
	
public:
	WK7Fog(HSD_FogDesc *pFogDesc);
	~WK7Fog();
	
	HSD_Fog* GetFog(void){ return mpFog; }
	
	static bool IsFogging(void);
	inline static WK7Fog* GetTop(void){ return mpTop; }
	static bool Clear(void);
	static bool Initialize(void);
	static bool Terminate(void);
	static bool SetCurrentAll(void);
	static bool EndCurrentAll(void);
	inline static WK7Fog* GetAllFog(void){ return mpAllFog; }
	
	inline bool SetEnable(bool flag){ mEnable=flag; return true; }
	inline bool GetEnable(void){ return mEnable; }
	
	bool LoadDesc(HSD_FogDesc *pFogDesc);
	
	bool SetCurrent(void);
	bool EndCurrent(void);
	
	bool SetType(GXFogType type);
	bool SetStartZ(f32 z);
	bool SetEndZ(f32 z);
	bool SetColor(GXColor color);
	
	GXFogType GetType(void);
	f32 GetStartZ(void);
	f32 GetEndZ(void);
	GXColor GetColor(void);
};

#define	WK7FOG			WK7Fog::GetAllFog()

#endif	//__WK7FOG_H__

