////////////////////////////////////////////////////////////////////////////////
//
// Killer7 HitObj
//
// WK7HitObj.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 09/26/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7HITOBJ_H__
#define	__WK7HITOBJ_H__

//#include "..\Lib\ghmGcTask.h"
//#include "..\Lib\ghmGcList.h"
//#include ".\WK7Model.h"
//#include ".\WK7Path.h"

class WK7JObj;
class WK7PathNurbs;

enum{
	HITOBJTYPE_NOACTION = 0,
	HITOBJTYPE_HIDE,
	HITOBJTYPE_DISP,
	HITOBJTYPE_HIDE_PATHOPEN,
};
struct WK7HitObjTable{
	u32				mEventNo;
	int				mFlagID;
	int				mType;
};
//#define	WK7HITOBJTBL_HIDE(evno,flag)			{ evno , flag , HITOBJTYPE_HIDE          },
//#define	WK7HITOBJTBL_DISP(evno,flag)			{ evno , flag , HITOBJTYPE_DISP          },
//#define	WK7HITOBJTBL_HIDE_PATHOPEN(evno,flag)	{ evno , flag , HITOBJTYPE_HIDE_PATHOPEN },
#define	WK7HITOBJTBL_TERM_EVENTNO		(0xffffffff)
#define	WK7HITOBJTBL_TERM_FLAGID		(-1)
#define	WK7HITOBJTBL_TERM_TYPE		(-1)
#define	WK7HITOBJTBL_TERM				{ WK7HITOBJTBL_TERM_EVENTNO , WK7HITOBJTBL_TERM_FLAGID , WK7HITOBJTBL_TERM_TYPE },


class WK7HitObj;

class WK7HitObjFindData{
	friend class WK7HitObj;
protected:
	bool				mInitialized;
	WK7HitObj			*mpObj;
public:
	WK7HitObjFindData();
	bool Initialize(void);
};

class WK7Stage;
class WK7HitObjJObj;
class WK7HitObj : public ghmGcListObj{
public:
	enum Type{
		BASE_TYPE = 0,
		JOBJ_TYPE,
	};
protected:
	static ghmGcListObj			mAnchor;
	static WK7HitObj			*mpFindObj;
	static ghmGcTaskController	*mpDefaultTaskController;
	static WK7HitObjTable		*mpTable;
	Type						mType;
	union{
		struct{
			u32					mEnable  :  1;
			u32					mFlagPad : 31;
		};
		u32						mFlag;
	};
	u32							mRenderID;
	u32							mEventID;
	u32							mEventParam[2];
	ghmGcTaskHandler			*mpHandler;
	ghmGcTaskHandler			*mpTermHandler;
	u32							mTaskParam[2];
	ghmGcTaskController			*mpTaskController;
	WK7Stage					*mpStage;
	
	virtual bool TaskStart(void);
	virtual bool CallEvent(void);
public:
	WK7HitObj(int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~WK7HitObj();
	
	inline Type GetType(void){ return mType; }
	
	inline WK7HitObj* GetNext(void){ return (WK7HitObj *)ghmGcListObj::GetNext(); }
	inline WK7HitObj* GetPrev(void){ return (WK7HitObj *)ghmGcListObj::GetPrev(); }
	
	inline void SetEnable(bool flag){ mEnable = (flag==true? 1:0); }
	inline bool GetEnable(void){ return mEnable? true : false; }
	
	inline void SetRenderID(u32 id){ mRenderID = id; }
	inline u32 GetRenderID(void){ return mRenderID; }
	
	inline void SetEventID(u32 id){ mEventID = id; }
	inline u32 GetEventID(void){ return mEventID; }
	bool SetEventParam(int index,u32 param);
	u32 GetEventParam(int index);
	
	inline void SetTaskHandler(ghmGcTaskHandler *pHandler,ghmGcTaskHandler *pTermHandler=NULL,ghmGcTaskController *pTaskController=NULL){
		mpHandler        = pHandler;
		mpTermHandler    = pTermHandler;
		mpTaskController = pTaskController;
	}
	inline ghmGcTaskHandler* GetTaskHandler(void){ return mpHandler; }
	inline ghmGcTaskHandler* GetTaskTermHandler(void){ return mpTermHandler; }
	inline ghmGcTaskController* GetTaskController(void){ return mpTaskController; }
	inline ghmGcTaskController* GetCurrentTaskController(void){
		if( mpTaskController != NULL ){
			return mpTaskController;
		}
		return mpDefaultTaskController;
	}
	bool SetTaskParam(int index,u32 param);
	u32 GetTaskParam(int index);
	
	inline static void SetDefaultTaskController(ghmGcTaskController *pTaskController){ mpDefaultTaskController = pTaskController; }
	inline static ghmGcTaskController* GetDefaultTaskController(void){ return mpDefaultTaskController; }
	static bool InitFind(void);
	static int HitCheck(u32 renderid, WK7HitObjInfoType hittypeid, s16 inSightPx, s16 inSightPy, Vec inHitPos);
	static WK7HitObj* Find(u32 renderid);
	static WK7HitObj* Find(WK7JObj *pJObj);
	static WK7HitObj* FindEvent(u32 eventid);
	static WK7HitObjJObj* FindEventNo(u32 eventno);
	static int Release(u32 renderid);
	static int Release(WK7JObj *pJObj);
	inline static WK7HitObj* GetTopObj(void){ return (WK7HitObj *)mAnchor.GetNext(); }
	inline void SetStage(WK7Stage *pStage){ mpStage=pStage; }
	inline WK7Stage* GetStage(void){ return mpStage; }
	static bool IsValid(WK7HitObj *pObj);
	
	static int SetEventEnable(u32 eventid,bool flag);
	static int SetEventNoEnable(u32 eventno,bool flag);
	static bool SetTable(WK7HitObjTable	*pTable);
	static WK7HitObjTable* GetTable(u32 eventNo);
	inline static WK7HitObjTable* GetTableTop(void){ return mpTable; }
	static bool InitEventEnable(void);
};

class WK7HitObjJObj : public WK7HitObj{
protected:
	WK7JObj					*mpJObj;
	u32						mEventNo;
	virtual bool CallEvent(void);
public:
	WK7HitObjJObj(int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~WK7HitObjJObj();
	
	static WK7PathNurbs* GetPath(WK7JObj *pJObj);
	inline void SetJObj(WK7JObj *pJObj){ mpJObj=pJObj; }
	inline WK7JObj* GetJObj(void){ return mpJObj; }
	inline void SetEventNo(u32 no){ mEventNo = no; }
	inline u32 GetEventNo(void){ return mEventNo; }
	
	WK7PathNurbs* GetClosePath(void);
};

#endif	//__WK7HITOBJ_H__

