////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Light Object
//
// WK7Light.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/19/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7LIGHT_CPP__

#include ".\WK7Light.h"
#include ".\WK7Chara.h"
#include ".\WK7Stage.h"
#include ".\WK7Item.h"
#include ".\WK7Model.h"

#include ".\K7App.h"

static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 2.000000f },		// wobj position
//	{ 0.000000f, 5.000000f, 2.000000f },		// wobj position
};

static	HSD_WObjDesc dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 5.000000f },		// wobj position
//	{ 0.000000f, 5.000000f, 5.000000f },		// wobj position
};

static	HSD_WObjDesc dir_light_pos2_wobjdesc = {
	NULL,
	{ 5.000000f, 0.000000f, -5.000000f },		// wobj position
};

static	HSD_WObjDesc dir_light_pos3_wobjdesc = {
	NULL,
	{ -5.000000f, 0.000000f, -5.000000f },		// wobj position
};

static	float	dir_light_shininess = 50.0f;

//#define	DIRLIGHT_COLOR		{ 192, 192, 192, 0xff }					// color
#define	DIRLIGHT_COLOR		{ 128, 128, 128, 0xff }					// color
//#define	DIRLIGHT_COLOR		{ 255, 255, 255, 0xff }					// color
static	HSD_LightDesc dir3_light = {
	NULL,
	NULL,										// link
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&dir_light_pos3_wobjdesc,					// position
	NULL,
	&dir_light_shininess,
};

static	HSD_LightDesc dir2_light = {
	NULL,
	&dir3_light,								// link
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&dir_light_pos2_wobjdesc,					// position
	NULL,
	&dir_light_shininess,
};

static	HSD_LightDesc dir_light = {
	NULL,
	NULL,
//	&dir2_light,								// link
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&dir_light_pos_wobjdesc,					// position
	NULL,
	&dir_light_shininess,
};

static	HSD_LightDesc dir0_light = {
	NULL,
	NULL,
//	&dir2_light,								// link
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};

static HSD_LightDesc amb_light = {
	NULL,
	&dir0_light,
//	&dir_light,									// link
	LOBJ_DIFFUSE,								// flags
	LOBJ_AMBIENT,								// attnflags
	{ 0xff, 0xff, 0xff, 0xff },					// color
	NULL,										// position
	NULL,										// interest
	NULL,
};

static	HSD_LightDesc shadow_dir_light = {
	NULL,
	NULL,										// link
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};

static HSD_SceneLightSet amb_lightset = {
	&amb_light,
	NULL,
};

static HSD_SceneLightSet dir_lightset = {
	&dir_light,
	NULL,
};

static HSD_SceneLightSet shadow_dir_lightset = {
	&shadow_dir_light,
	NULL,
};

ghmGcListObj		WK7Light::mAnchor;

WK7Light::WK7Light()
{
	InitMember();
}

WK7Light::WK7Light(ghmGcListObj *pAnchor,int prio) : WK7Obj(pAnchor,prio)
{
	InitMember();
}

void WK7Light::InitMember(void)
{
	mpName       = "";
	mMotionState = 0;
	mMotionRate  = 1.0f;
	ghmGcMemSetAllocName("C_LObj");
	mpLObj       = new C_LObj(new (&amb_lightset) C_LightSet);
	mLightID     = 0xffffffff;
	mpRenderObj  = NULL;
	mFlag        = 0;
	mEnable      = 1;
	mpPosition   = NULL;
	mpInterest   = NULL;
	CreateWork();
}

WK7Light::~WK7Light()
{
	GHM_SAFE_DELETE_ARRAY(mpPosition);
	GHM_SAFE_DELETE_ARRAY(mpInterest);
	GHM_SAFE_DELETE(mpLObj);
}

int WK7Light::GetLObjNum(void)
{
	HSD_LObj	*pLObj;
	int			i;
	for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){}
	return i;
}

bool WK7Light::SetPosition(Vec *pPosition,int index)
{
	if( mpLObj==NULL || mpPosition==NULL ){
		return false;
	}
	HSD_LObj	*pLObj;
	int			i;
	for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){
		if( index >= 0 ){
			if( index!=i ){
				continue;
			}
			mpPosition[i] = *pPosition;
			return true;
		}
		mpPosition[i] = *pPosition;
	}
	if( index >= 0 ){
		return false;
	}
	return true;
}

bool WK7Light::SetInterest(Vec *pInterest,int index)
{
	if( mpLObj==NULL || mpInterest==NULL ){
		return false;
	}
	HSD_LObj	*pLObj;
	int			i;
	for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){
		if( index >= 0 ){
			if( index!=i ){
				continue;
			}
			mpInterest[i] = *pInterest;
			return true;
		}
		mpInterest[i] = *pInterest;
	}
	if( index >= 0 ){
		return false;
	}
	return true;
}

bool WK7Light::GetPosition(Vec *pPosition,int index)
{
	if( mpLObj==NULL || mpPosition==NULL || index < 0 ){
		return false;
	}
	HSD_LObj	*pLObj;
	int			i;
	for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){
		if( index!=i ){
			continue;
		}
		*pPosition = mpPosition[i];
		return true;
	}
	return false;
}

bool WK7Light::GetInterest(Vec *pInterest,int index)
{
	if( mpLObj==NULL || mpInterest==NULL || index < 0 ){
		return false;
	}
	HSD_LObj	*pLObj;
	int			i;
	for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){
		if( index!=i ){
			continue;
		}
		*pInterest = mpInterest[i];
		return true;
	}
	return false;
}

void WK7Light::CreateWork(void)
{
	GHM_SAFE_DELETE_ARRAY(mpPosition);
	GHM_SAFE_DELETE_ARRAY(mpInterest);
	if( mpLObj==NULL ){
		return;
	}
	HSD_LObj	*pLObj;
	int			i = 0;
	for(pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next){
		i++;
	}
	if( i<=0 ){
		return;
	}
	ghmGcMemSetAllocName("WKLTPOS");
	if( (mpPosition = new Vec[i])==NULL ){
		return;
	}
	ghmGcMemSetAllocName("WKLTITR");
	if( (mpInterest = new Vec[i])==NULL ){
		GHM_SAFE_DELETE_ARRAY(mpPosition);
		return;
	}
	for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){
		HSD_LObjGetPosition(pLObj,&mpPosition[i]);
		HSD_LObjGetInterest(pLObj,&mpInterest[i]);
	}
}

void WK7Light::SetDesc(HSD_LightDesc *pDesc)
{
	GHM_SAFE_DELETE(mpLObj);
	ghmGcMemSetAllocName("C_LObj");
	mpLObj = new C_LObj(new (&pDesc) C_LightSet);
	mpName = GetDescName(pDesc);
	CreateWork();
}

void WK7Light::SetDesc(C_LightSet *pLightSet)
{
	GHM_SAFE_DELETE(mpLObj);
	ghmGcMemSetAllocName("C_LObj");
	mpLObj = new C_LObj(pLightSet);
	mpName = GetDescName(pLightSet->lightdesc);
	CreateWork();
}

int WK7Light::GetLightType(void)
{
	if( mpLObj==NULL ){
		return -1;
	}
	HSD_LObj	*pLObj = mpLObj->GetLObj();
	if( pLObj==NULL ){
		return -1;
	}
	return (int)HSD_LObjGetType(pLObj);
}

bool WK7Light::FrameProcessAll(void)
{
	WK7Light		*pLight = (WK7Light *)mAnchor.GetNext();
	while( pLight!=NULL ){
		pLight->FrameProcess();
		pLight = pLight->GetNext();
	}
	return true;
}

bool WK7Light::FrameProcess(void)
{
	if( mpLObj==NULL ){
		return true;
	}
	HSD_LObj	*pLObj;
	int			i;
	for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){
		if( mpPosition!=NULL && pLObj->position!=NULL ){
			HSD_LObjSetPosition(pLObj,&mpPosition[i]);
		}
		if( mpInterest!=NULL && pLObj->interest!=NULL ){
			HSD_LObjSetInterest(pLObj,&mpInterest[i]);
		}
	}
	mpLObj->Proc();
	for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){
		if( mpPosition!=NULL ){
			HSD_LObjGetPosition(pLObj,&mpPosition[i]);
		}
		if( mpInterest!=NULL ){
			HSD_LObjGetInterest(pLObj,&mpInterest[i]);
		}
	}
	return true;
}

//bool WK7Light::RenderProcess(void)
//{
//	return true;
//}

bool WK7Light::Disp(u32 mirrorType,Vec *pPos)
{
	if( !mEnable ){
		return true;
	}
	if( mpRenderObj!=NULL ){
		if( mpRenderObj->GetRenderFlag()==false ){
			return true;
		}
		switch( mpRenderObj->GetType() ){
		case	K7OBJTYPE_CHR:
			if( WK7Chara::GetRenderChara()==false ){
				return true;
			}
			break;
		case	K7OBJTYPE_STG:
			if( WK7Stage::GetRenderStage()==false ){
				return true;
			}
			break;
		case	K7OBJTYPE_ITEM:
			if( WK7Item::GetRenderItem()==false ){
				return true;
			}
			break;
		default:
			break;
		}
	}
	// Cgo^
	if( mpLObj != NULL ){
		HSD_LObj	*pLObj;
		int			i;
		f32			ip;
		Vec			vec;
		Vec			dir  = { 0.0f,0.0f,0.0f };
static	Vec			zero = { 0.0f,0.0f,0.0f };
		if( pPos==NULL ){
			pPos = &zero;
		}
		switch( mirrorType ){
		case	WK7MODEL_MIRROR_X: dir.x = 1.0f; break;
		case	WK7MODEL_MIRROR_Y: dir.y = 1.0f; break;
		case	WK7MODEL_MIRROR_Z:
		default:                   dir.z = 1.0f; break;
		}
		switch( mirrorType ){
		case	WK7MODEL_MIRROR_X:
		case	WK7MODEL_MIRROR_Y:
		case	WK7MODEL_MIRROR_Z:
			for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){
				if( pLObj->position!=NULL ){
					if( HSD_LObjGetType(pLObj)==LOBJ_INFINITE ){
						vec = mpPosition[i];
					}else{
						VECSubtract(&mpPosition[i],pPos,&vec);
					}
					ip = -2.0f *  VECDotProduct(&vec,&dir);
					VECScale   (&dir,&vec,ip);
					VECAdd     (&mpPosition[i],&vec,&vec);
					HSD_LObjSetPosition(pLObj,&vec);
				}
				if( pLObj->interest!=NULL ){
					VECSubtract(&mpInterest[i],pPos,&vec);
					ip = -2.0f *  VECDotProduct(&vec,&dir);
					VECScale   (&dir,&vec,ip);
					VECAdd     (&mpInterest[i],&vec,&vec);
					HSD_LObjSetInterest(pLObj,&vec);
				}
				HSD_LObjAddCurrent(pLObj);
			}
			break;
		default:
			for(i=0,pLObj=mpLObj->GetLObj() ; pLObj!=NULL ; pLObj=pLObj->next,i++){
				if( pLObj->position!=NULL ){
					HSD_LObjSetPosition(pLObj,&mpPosition[i]);
				}
				if( pLObj->interest!=NULL ){
					HSD_LObjSetInterest(pLObj,&mpInterest[i]);
				}
				HSD_LObjAddCurrent(pLObj);
			}
			break;
		}
//		mpLObj->Disp(true);
	}
	return true;
}

bool WK7Light::AttachMotion(HSD_LightAnim *pLightAnim)
{
	if( mpLObj==NULL ){
		return false;
	}
	HSD_LObjAddAnim(mpLObj->GetLObj(),pLightAnim);
	return true;
}

bool WK7Light::AttachMotion(WK7LightMotion *pLightMotion,int index)
{
	HSD_LightAnim	*pLightAnim = pLightMotion->GetAnim(index);
	if( pLightAnim==NULL ){
		return false;
	}
	return AttachMotion(pLightAnim);
}

bool WK7Light::AttachMotion(WK7LightMotion *pLightMotion,const char *pname)
{
	HSD_LightAnim	*pLightAnim;
	if( pname==NULL ){
		pLightAnim = pLightMotion->GetAnim(mpName);
	}else{
		pLightAnim = pLightMotion->GetAnim(pname);
	}
	if( pLightAnim==NULL ){
		return false;
	}
	return AttachMotion(pLightAnim);
}

bool WK7Light::DetachMotion(void)
{
	if( mpLObj==NULL ){
		return false;
	}
	mMotionState &= ~WK7LIGHT_MOTION_PLAY;
	HSD_LObjRemoveAnim(mpLObj->GetLObj());
	return true;
}

bool WK7Light::PlayMotion(f32 startframe,bool /*interpolate*/,f32 /*interpolateframe*/)
{
	if( mpLObj==NULL ){
		return false;
	}
	HSD_LObjReqAnim(mpLObj->GetLObj(),startframe);
	mMotionState |= WK7LIGHT_MOTION_PLAY;
	SetMotionRate(1.0f);
	return true;
}

bool WK7Light::ReplayMotion(void)
{
	if( mpLObj==NULL || !(mMotionState & WK7LIGHT_MOTION_PLAY) ){
		return false;
	}
	RenewMotionRate();
	return true;
}

bool WK7Light::StopMotion(void)
{
	if( mpLObj==NULL ){
		return false;
	}
	SetMotionRate(mpLObj->GetLObj(),0.0f);
	return true;
}

bool WK7Light::SetMotionLoop(bool flag)
{
	if( mpLObj==NULL ){
		return false;
	}
	HSD_LObj		*pLObj = mpLObj->GetLObj();
	if( pLObj==NULL ){
		return false;
	}
	if( flag==true ){
		if( pLObj->aobj!=NULL ){
			HSD_AObjSetFlags  (pLObj->aobj,AOBJ_ANIM_LOOP);
		}
		if( pLObj->position!=NULL && pLObj->position->aobj!=NULL ){
			HSD_AObjSetFlags  (pLObj->position->aobj,AOBJ_ANIM_LOOP);
		}
		if( pLObj->interest!=NULL && pLObj->interest->aobj!=NULL ){
			HSD_AObjSetFlags  (pLObj->interest->aobj,AOBJ_ANIM_LOOP);
		}
	}else{
		if( pLObj->aobj!=NULL ){
			HSD_AObjClearFlags(pLObj->aobj,AOBJ_ANIM_LOOP);
		}
		if( pLObj->position!=NULL && pLObj->position->aobj!=NULL ){
			HSD_AObjClearFlags(pLObj->position->aobj,AOBJ_ANIM_LOOP);
		}
		if( pLObj->interest!=NULL && pLObj->interest->aobj!=NULL ){
			HSD_AObjClearFlags(pLObj->interest->aobj,AOBJ_ANIM_LOOP);
		}
	}
	return true;
}

bool WK7Light::GetMotionLoop(void)
{
	return (GetMotionState() & AOBJ_ANIM_LOOP)? true : false;
}

int WK7Light::GetMotionState(void)
{
	if( mpLObj==NULL ){
		return AOBJ_NO_ANIM;
	}
	HSD_LObj		*pLObj = mpLObj->GetLObj();
	if( pLObj==NULL ){
		return AOBJ_NO_ANIM;
	}
	if( pLObj->aobj != NULL ){
		return (int)HSD_AObjGetFlags(pLObj->aobj);
	}
	if( pLObj->position!=NULL && pLObj->position->aobj!=NULL ){
		return (int)HSD_AObjGetFlags(pLObj->position->aobj);
	}
	if( pLObj->interest!=NULL && pLObj->interest->aobj!=NULL ){
		return (int)HSD_AObjGetFlags(pLObj->interest->aobj);
	}
	return AOBJ_NO_ANIM;
}

bool WK7Light::SetMotionRate(HSD_WObj *pWObj,f32 rate)
{
	if( pWObj==NULL ){
		return false;
	}
	WK7Motion::SetMotionRate(pWObj->aobj,rate);
	return true;
}

bool WK7Light::SetMotionRate(HSD_LObj *pLObj,f32 rate)
{
	if( pLObj==NULL ){
		return false;
	}
	WK7Motion::SetMotionRate(pLObj->aobj,rate);
	SetMotionRate(HSD_LObjGetPositionWObj(pLObj),rate);
	SetMotionRate(HSD_LObjGetInterestWObj(pLObj),rate);
	return true;
}

bool WK7Light::SetMotionRate(f32 rate)
{
	mMotionRate = rate;
	RenewMotionRate();
	return true;
}

bool WK7Light::RenewMotionRate(void)
{
	if( mMotionState & WK7LIGHT_MOTION_PLAY ){
		SetMotionRate(mpLObj->GetLObj(),mMotionRate);
	}else{
		SetMotionRate(mpLObj->GetLObj(),0.0f);
	}
	return true;
}

bool WK7Light::RenewMotionRateAll(void)
{
	WK7Light	*pLight = (WK7Light *)mAnchor.GetNext();
	while( pLight!=NULL ){
		pLight->RenewMotionRate();
		pLight = pLight->GetNext();
	}
	return true;
}

u32 WK7Light::GetLightIDBit(void)
{
	if( mLightID >= 32 ){
		return 0;
	}
	return (1UL<<mLightID);
}

WK7LightFindData::WK7LightFindData(void)
{
	mObjectType    = 0xffffffff;
	mObjectID      = 0xffffffff;
	mpCurrentLight = NULL;
	mInitialized   = false;
}

bool WK7LightFindData::Initialize(u32 objtype,u32 objid)
{
	mObjectType    = objtype;
	mObjectID      = objid;
	mpCurrentLight = NULL;
	mInitialized   = true;
	return true;
}

u32 WK7Light::GetUniqueID(void)
{
	u32			uniqueID = 0;
	while( 1 ){
		WK7Light	*pLight = (WK7Light *)mAnchor.GetNext();
		while( pLight!=NULL ){
			if( pLight->GetLightID()==uniqueID ){
				break;
			}
			pLight = pLight->GetNext();
		}
		if( pLight==NULL ){
			break;
		}
		uniqueID++;
	}
	return uniqueID;
}

WK7Light* WK7Light::Create(HSD_LightDesc *pDesc,u32 objtype,u32 objid)
{
	ghmGcMemSetAllocName("WK7Light");
	WK7Light	*pLight = new WK7Light(&mAnchor);
	if( pLight!=NULL ){
		pLight->SetDesc(pDesc);
		pLight->mObjectType = objtype;
		pLight->mObjectID   = objid;
		pLight->mLightID    = GetUniqueID();
	}
	return pLight;
}

WK7Light* WK7Light::Create(C_LightSet *pLightSet,u32 objtype,u32 objid)
{
	ghmGcMemSetAllocName("WK7Light");
	WK7Light	*pLight = new WK7Light(&mAnchor);
	if( pLight!=NULL ){
		pLight->SetDesc(pLightSet);
		pLight->mObjectType = objtype;
		pLight->mObjectID   = objid;
		pLight->mLightID    = GetUniqueID();
	}
	return pLight;
}

bool WK7Light::Release(const char *pName)
{
	WK7Light	*pLight = Find(pName);
	if( pLight==NULL ){
		return false;
	}
	delete pLight;
	return true;
}

int WK7Light::Release(u32 objtype,u32 objid,bool privateLight)
{
	WK7LightFindData		data;
	WK7Light				*pLight;
	int						count = 0;
	data.Initialize(objtype,objid);
	while( (pLight=Find(data))!=NULL ){
		if( privateLight==false ){
			if( pLight->GetPrivate()==true ){
				continue;
			}
		}
		delete pLight;
		count++;
	}
	return count;
}

WK7Light* WK7Light::Find(const char *pName)
{
	WK7Light		*pLight = (WK7Light *)mAnchor.GetNext();
	while( pLight != NULL ){
		if( strcmp(pLight->GetName(),pName)==0 ){
			return pLight;
		}
		pLight = pLight->GetNext();
	}
	return NULL;
}

WK7Light* WK7Light::Find(WK7LightFindData &data)
{
	WK7Light		*pLight;
	if( data.mInitialized==true ){
		pLight = (WK7Light *)mAnchor.GetNext();
		data.mInitialized = false;
	}else{
		pLight = data.mpCurrentLight;
	}
	while( pLight!=NULL ){
		
		if( data.mObjectType==0xffffffff              ||
			data.mObjectType==pLight->GetObjectType() ){
			
			if( data.mObjectID==0xffffffff            ||
				data.mObjectID==pLight->GetObjectID() ){
				data.mpCurrentLight = pLight->GetNext();
				return pLight;
			}
			
		}
		pLight = pLight->GetNext();
	}
	data.mpCurrentLight = NULL;
	return NULL;
}

WK7Light* WK7Light::Find(u32 lid)
{
	WK7Light		*pLight = (WK7Light *)mAnchor.GetNext();
	while( pLight != NULL ){
		if( pLight->GetLightID()==lid ){
			return pLight;
		}
		pLight = pLight->GetNext();
	}
	return NULL;
}

int WK7Light::GetCount(u32 objtype,u32 objid)
{
	WK7Light		*pLight = (WK7Light *)mAnchor.GetNext();
	int				count = 0;
	while( pLight != NULL ){
		if( (objtype==0xffffffff || objtype==pLight->mObjectType) &&
		    (objid  ==0xffffffff || objid  ==pLight->mObjectID  ) ){
			count++;
		}
		pLight = pLight->GetNext();
	}
	return count;
}

bool WK7Light::DispAll(u32 objtype,u32 objid)
{
	WK7Light			*pLight;
	WK7LightFindData	data;
	data.Initialize(objtype,objid);
	while( (pLight=WK7Light::Find(data))!=NULL ){
		pLight->Disp();
	}
	return true;
}

HSD_LObj* WK7Light::GetHSDLObj(void)
{
	if( mpLObj==NULL ){
		return NULL;
	}
	return mpLObj->GetLObj();
}

// LOBJ_AMBIENT  | (S)
// LOBJ_INFINITE | _̓_(s)
// LOBJ_POINT    | _
// LOBJ_SPOT     | t_
u32 WK7Light::GetType(void)
{
	HSD_LObj	*pLObj = mpLObj->GetLObj();
	u32			type = 0;
	while( pLObj!=NULL ){
		type |= 1<<HSD_LObjGetType(pLObj);
		pLObj = pLObj->next;
	}
	return type;
}

int WK7Light::SetEnableAll(bool flag,u32 objtype,u32 id)
{
	WK7Light			*pLight;
	WK7LightFindData	data;
	int					count = 0;
	
	data.Initialize(objtype,id);
	while( (pLight=WK7Light::Find(data))!=NULL ){
		pLight->SetEnable(flag);
		count++;
	}
	return count;
}

