////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Main Menu
//
// WK7MainMenu.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/10/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7MAINMENU_CPP__

//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
#include ".\K7ID.h"
#include ".\K7GlobalFlag.h"
#include ".\WK7MainMenu.h"
#include ".\WK7MainTask.h"
#include ".\WK7GameInfo.h"
#include ".\WK7Stage.h"
#include ".\WK7SelectIF.h"
#include ".\WK7Cam.h"
#include ".\K7App.h"
#include "..\Fujita\C_Font.h"
#include ".\Blood.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include ".\WK7EventScript.h"
#include ".\WK7EventItem.h"
#include ".\WK7Event.h"
#include ".\WK7ViewerTask.h"
#include ".\Kaw\KK7BattleMainTask.h"
#include "..\Sato\SK7Pack.h"
#include "..\Sato\SK7SpOption.h"

#define	WK7MAINMENU_PADTRIGGER		(HSD_PadGetTrigger(0))
#define	WK7MAINMENU_PADBUTTON		(HSD_PadGetButton(0))
#define	WK7MAINMENU_PADREPEAT		(HSD_PadGetRepeat(0))

#ifdef _DEBUG
extern s8 DebugTumorEfcType;
#endif

char *pPcName[] = {
	K7DAN_INITIAL,
	K7GAL_INITIAL,
	K7CON_INITIAL,
	K7HAC_INITIAL,
	K7HAS_INITIAL,
	K7HAY_INITIAL,
	K7CYO_INITIAL,
	K7KED_INITIAL,
	K7KVN_INITIAL,
	K7MSK_INITIAL
};

#define	WK7MAINMENU_TOPMENU_ITEMNUM			(49)
#define	WK7MAINMENU_TOPMENU_DISPMAX			(24)

WK7MainMenu		mainMenu;

WK7MainMenu::WK7MainMenu()
{
//	Initialize();
}

WK7MainMenu::~WK7MainMenu()
{
//	Terminate();
}

bool WK7MainMenu::SetActive(bool flag)
{
	if( flag==true ){
		mMask.Start(0x80,2400);
		mRenderSpOption = GameInfo.GetRenderOption();
	}else{
		mMask.Start(0x00,2400);
		GameInfo.SetRenderOption(mRenderSpOption);
	}
	mActive = flag;
	return true;
}

bool WK7MainMenu::Initialize(void)
{
	int		i;
	mMemMinWidth       = 3;
	mMemDumpType       = 1;
	mCurrentStageID    = 0xffffffff;
	mpDumpStageInfo    = NULL;
	mpDumpStage        = NULL;
	mDumpStageInfoProc = -1;
	mpOldCreateStageFunc = NULL;
	mOldFlow           = -1;
	mChangeFlowProc    = 0;
	mModeInfo          = false;
	mPackManCursor     = 0;
	mPackManBlink      = 0;
	mPackManID         = 0;
	mModeDisp          = 1;
	mModeBlink         = 0;
	mCamDebug          = false;
	mpCurrentJObj      = NULL;
	mActive            = false;
	mLevel             = 0;
	mProc              = 0;
	mEditScenarioID    = GameInfo.GetScenarioID();
	mDispIDMax         = 0;
	mEditIDMax         = 0;
	mEditID            = 0;
	mEditArrayID       = 0;
	mEditCursor        = 0;
	mEditSize          = 0;
	mDispPathInfo      = false;
	mDispMemInfo       = false;
//	mDispMemInfo       = true;
	mDispPerfInfo      = false;
//	mDispPerfInfo      = true;
	mAutoPlay          = true;
	mBattleInfo        = false;
	mEneWalkArea       = false;
	mGalSystemEnable   = false;
	mPcPause           = false;
	mNpcPause          = false;
	mSkillAllUse       = false;
	mDownAtkEdit       = false;
	mStreamPlayEnable  = false;
	mGunDisp           = true;
	mEnemySet          = false;
#ifdef	K7APP_MASTER
	mStageWarning      = false;
#else
	mStageWarning      = true;
#endif
#if	!defined(K7APP_MASTER) && !defined(USE_ISDOLVIEWER) && ((defined(K7APP_GXWARNING) && K7APP_GXWARNING!=0) || !defined(K7APP_GXWARNING))
	//DrawDonẻiv[vT߁AftHgI
	SetGxWarning(true);
#else
	SetGxWarning(false);
#endif
#if	defined(_DEBUG) && !defined(USE_ISDOLVIEWER) && defined(K7APP_STREAM_DEFAULT) && (K7APP_STREAM_DEFAULT==0)
	SetStreamPlayEnable(false);
#else
	SetStreamPlayEnable(true);
#endif
	mpTitle            = NULL;
	mEnableStageChange = false;
	mTermRequest       = false;
	mPanelID           = ePanelIDStart;
	mPanelEventNo      = K7EVENTNO(000000);
	mPanelCursor       = 0;
	mPanelParam        = -1;
	for(i=0 ; i<WK7MAINMENU_LEVEL_MAX ; i++){
		mProcStack[i] = 0;
	}
	SetMode(TOPMENU);
	mpFrameProcessTaskController = NULL;
	ghmGcMem::SetRender(mDispMemInfo);
	k7app.SetVisiblePerfMeter(mDispPerfInfo);
	k7app.SetEnablePerfMeter (true );
	mMask.SetColor(0x00000000);
	mDispShadow        = false;
	mDispAlpha         = false;
	mFollowCamEdit     = false;
	mSkillEdit         = false;
	mRenderSpOption    = false;
	mJunctionColorEdit = false;
	mpMaskWindow       = NULL;
//	mpCharaDisp        = NULL;
	mNameX             = 240.0f;
	mNameY             = 320.0f;
	mWindowX           = 240.0f;
	mWindowY           = 160.0f;
	mWindowW           = 160.0f;
	mWindowH           = 160.0f;
	return true;
}

bool WK7MainMenu::Terminate(void)
{
	WK7CHARAPRESENT->DeleteMaskWindow(mpMaskWindow);
	WK7CHARAPRESENT->SetEnable(false);
	mpMaskWindow = NULL;
//	GHM_SAFE_DELETE(mpCharaDisp);
	mMask.Start(0,0);
	k7app.SetVisiblePerfMeter(false);
	k7app.SetEnablePerfMeter (false);
	ghmGcMem::SetRender      (false);
	return true;
}


bool WK7MainMenu::SetGxWarning(bool flag)
{
#ifdef	_DEBUG
	if( flag==true ){
//		GXSetVerifyLevel(GX_WARN_ALL);
		GXSetVerifyLevel(GX_WARN_SEVERE);
static bool	all = false;
		if( all==true ){
//			GXSetVerifyLevel(GX_WARN_MEDIUM);
			GXSetVerifyLevel(GX_WARN_ALL);
		}
	}else{
		GXSetVerifyLevel(GX_WARN_NONE  );
	}
#else
	GXSetVerifyLevel(GX_WARN_NONE  );
#endif
	mGxWarning = flag;
	return true;
}

bool WK7MainMenu::SetStreamPlayEnable(bool flag)
{
	if( mStreamPlayEnable==true && flag==false ){
		gpSound->mStopStream();
	}
// Yam
#ifdef _DEBUG
	gpSound->mSetSoundDebug(flag==true? false : true);
#endif
	mStreamPlayEnable = flag;
	return true;
}

void WK7MainMenu::AdjustPos(int &menuid,int &cursor,int menunum,int dispnum)
{
	if( menuid < 0 ){
		menuid = 0;
	}else if( menuid >= menunum ){
		menuid = menunum-1;
	}
	if( cursor > menuid ){
		cursor = menuid;
	}
	int		cmax;
	if( dispnum > menunum ){
		cmax = menunum;
	}else{
		cmax = dispnum;
	}
	if( cursor < 0 ){
		cursor = 0;
	}else if( cursor > cmax-1 ){
		cursor = cmax-1;
	}
	if( menunum > dispnum ){
		if( cursor + (menunum - menuid) < cmax ){
			cursor = cmax - (menunum - menuid);
		}
	}
}

bool WK7MainMenu::SetMode(Mode mode)
{
	WK7CHARAPRESENT->DeleteMaskWindow(mpMaskWindow);
	WK7CHARAPRESENT->SetEnable(false);
	mpMaskWindow = NULL;
//	GHM_SAFE_DELETE(mpCharaDisp);
	if( mMode==HIERARCHY && mode!=HIERARCHY ){
		if( mCamDebug==false ){
			WK7CAM->ExitDebugMode();
		}
	}
	switch( mode ){
	case	TOPMENU:
		mpTitle = "Menu Top";
		break;
	case	VAREDIT:
		mpTitle = "Scennario Variable Edit";
		break;
	case	FLAGEDIT:
		mpTitle = "Scenario Flag Edit";
		break;
	case	GVAREDIT:
		mpTitle = "Global Variable Edit";
		break;
	case	GFLAGEDIT:
		mpTitle = "Global Flag Edit";
		break;
	case	ITEMEDIT:
		mpTitle = "Item Edit";
		break;
	case	PLAYEDIT:
		mpTitle = "Play Edit";
		break;
	case	PATHCHANGE:
		mpTitle = "Path Change";
		break;
	case	CHARAPRESENT:
		mpTitle = "Chara Present";
		mpMaskWindow = WK7CHARAPRESENT->AddMaskWindow(mWindowX,mWindowY,mWindowW,mWindowH);
		WK7CHARAPRESENT->SetEnable(true);
		break;
	case	AUTOPARAM:
		mpTitle = "Auto Param Set";
		break;
	case	CHANGEFLOW:
		mpTitle = "Change Flow";
		break;
	case	DUMPSTAGEINFO:
		mpTitle = "Dump StageInfo";
		break;
	case	HIERARCHY:
		if( mMode!=HIERARCHY ){
			mCamDebug = WK7CAM->IsDebugMode();
		}
		WK7CAM->EnterDebugMode();
		mpTitle = "Hierarchy";
		break;
	default:
		mpTitle = NULL;
		return false;
	}
	mMode = mode;
	switch( mMode ){
	case	TOPMENU:
		mEditIDMax = WK7MAINMENU_TOPMENU_ITEMNUM;
		mDispIDMax = WK7MAINMENU_TOPMENU_DISPMAX;
		AdjustPos(mProc,mEditCursor,WK7MAINMENU_TOPMENU_ITEMNUM,WK7MAINMENU_TOPMENU_DISPMAX);
		break;
	case	CHARAPRESENT:
	case	HIERARCHY:
		break;
	default:
		SetEditIDMax();
		AdjustPos(mEditID,mEditCursor,mEditIDMax,mDispIDMax);
//		mEditCursor = 0;
//		mEditID     = 0;
		break;
	}
	return true;
}

bool WK7MainMenu::PushProc(int nextproc)
{
	if( mLevel < 0 || mLevel >= WK7MAINMENU_LEVEL_MAX-1 ){
		return false;
	}
	mProcStack[mLevel] = mProc;
	mLevel++;
	if( nextproc < 0 ){
		mProc = mProcStack[mLevel];
	}else{
		mProc = nextproc;
	}
	return true;
}

bool WK7MainMenu::PopProc(void)
{
	if( mLevel < 1 || mLevel >= WK7MAINMENU_LEVEL_MAX ){
		return false;
	}
	mProc = mProcStack[mLevel];
	mLevel--;
	return true;
}

bool WK7MainMenu::PadOperateProc(int max)
{
	int			d;
	d = (int)(fabs(HSD_PadGetNormalStickY(0) * 4.0f));
	if( WK7MAINMENU_PADREPEAT & HSD_PAD_DOWN ){
		mProc      ++;
		mEditCursor++;
	}else if( WK7MAINMENU_PADREPEAT & HSD_PAD_STICK_DOWN ){
		mProc      += d;
		mEditCursor+= d;
	}
	if( WK7MAINMENU_PADREPEAT & HSD_PAD_UP ){
		mProc      --;
		mEditCursor--;
	}else if( WK7MAINMENU_PADREPEAT & HSD_PAD_STICK_UP   ){
		mProc      -= d;
		mEditCursor-= d;
	}
	if( mProc < 0 ){
		mProc       = max-1;
		mEditCursor = max-1;
	}else if( mProc >= max ){
		mProc       = 0;
		mEditCursor = 0;
	}
	if( mEditCursor < 0 ){
		mEditCursor = 0;
	}else if( mEditCursor > WK7MAINMENU_TOPMENU_DISPMAX-1 ){
		mEditCursor = WK7MAINMENU_TOPMENU_DISPMAX-1;
	}
	return true;
}

bool WK7MainMenu::FrameProcessEdit(bool scn)
{
	if( WK7MAINMENU_PADREPEAT & (HSD_PAD_B|HSD_PAD_START) ){
		SetMode(TOPMENU);
		return true;
	}
	
	int		dispmax;
	int		idmax;
	
	if( scn==false ){
		SetEditIDMax();
//	}else{
//		bool	changeScenario = false;
//		if( WK7MAINMENU_PADREPEAT & HSD_PAD_Z ){
//			switch( mEditScenarioID ){
//			case	K7SCN01: mEditScenarioID = K7SCN02; break;
//			case	K7SCN02: mEditScenarioID = K7SCN03; break;
//			case	K7SCN03: mEditScenarioID = K7SCN04; break;
//			case	K7SCN04: mEditScenarioID = K7SCN05; break;
//			case	K7SCN05: mEditScenarioID = K7SCN07; break;
//			case	K7SCN07: mEditScenarioID = K7SCN01; break;
//			}
//			changeScenario = true;
//		}
//		switch( mEditScenarioID ){
//		case	K7SCN01:
//		case	K7SCN02:
//		case	K7SCN03:
//		case	K7SCN04:
//		case	K7SCN05:
//		case	K7SCN07:
//			break;
//		default:
//			mEditScenarioID = K7SCN07;
//			changeScenario = true;
//			break;
//		}
//		
//		if( changeScenario==true ){
//			SetEditIDMax();
//		}
	}
	
	idmax   = mEditIDMax;
	dispmax = mDispIDMax;
	
	int			d;
	d = (int)(fabs(HSD_PadGetNormalStickY(0) * 4.0f));
	if( WK7MAINMENU_PADREPEAT & HSD_PAD_UP ){
		mEditID    --;
		mEditCursor--;
	}else if( WK7MAINMENU_PADREPEAT & HSD_PAD_STICK_UP ){
		mEditID    -= d;
		mEditCursor-= d;
	}
	if( WK7MAINMENU_PADREPEAT & HSD_PAD_DOWN ){
		mEditID    ++;
		mEditCursor++;
	}else if( WK7MAINMENU_PADREPEAT & HSD_PAD_STICK_DOWN ){
		mEditID    += d;
		mEditCursor+= d;
	}
	
	if( idmax <= 0 ){
		mEditID     = 0;
		mEditCursor = 0;
	}else{
		if( mEditID < 0 ){
			mEditID     = idmax-1;
			mEditCursor = idmax-1;
		}else if( mEditID >= idmax ){
			mEditID     = 0;
			mEditCursor = 0;
		}
		int		max;
		if( idmax < dispmax ){
			max   = idmax;
		}else{
			max   = dispmax;
		}
		if( mEditCursor < 0 ){
			mEditCursor = 0;
		}else if( mEditCursor > max-1 ){
			mEditCursor = max-1;
		}
	}
	
	if( WK7MAINMENU_PADTRIGGER & HSD_PAD_Y ){
		mEditSize--;
	}
	if( WK7MAINMENU_PADTRIGGER & HSD_PAD_X ){
		mEditSize++;
	}
	
	return true;
}

struct MainMenuVarType{
	const char		*mpName;
	int				mType;
};

#define	MAINMENU_VARTYPE_S8			(0)
#define	MAINMENU_VARTYPE_U8			(1)
#define	MAINMENU_VARTYPE_S16		(2)
#define	MAINMENU_VARTYPE_U16		(3)
#define	MAINMENU_VARTYPE_S32		(4)
#define	MAINMENU_VARTYPE_U32		(5)
#define	MAINMENU_VARTYPE_F32		(6)
MainMenuVarType	typeNameTable[] = {
	{ "s8"      , MAINMENU_VARTYPE_S8  },
	{ "u8"      , MAINMENU_VARTYPE_U8  },
	{ "char"    , MAINMENU_VARTYPE_U8  },
	{ "u_char"  , MAINMENU_VARTYPE_U8  },
	{ "s16"     , MAINMENU_VARTYPE_S16 },
	{ "short"   , MAINMENU_VARTYPE_S16 },
	{ "u16"     , MAINMENU_VARTYPE_U16 },
	{ "u_short" , MAINMENU_VARTYPE_U16 },
	{ "s32"     , MAINMENU_VARTYPE_S32 },
	{ "int"     , MAINMENU_VARTYPE_S32 },
	{ "u32"     , MAINMENU_VARTYPE_U32 },
	{ "u_int"   , MAINMENU_VARTYPE_U32 },
	{ "float"   , MAINMENU_VARTYPE_F32 },
	{ "f32"     , MAINMENU_VARTYPE_F32 },
	{ NULL      , -1                   },
};
static MainMenuVarType* GetType(const char *pName)
{
	if( pName==NULL ){
		return NULL;
	}
	MainMenuVarType	*pType;
	for(pType=typeNameTable ; pType->mpName!=NULL ; pType++){
		if( strcmp(pType->mpName,pName)==0 ){
			return pType;
		}
	}
	return NULL;
}

int WK7MainMenu::GetEditSize(int type)
{
	int		value = 1;
	int		i,max;
	switch( type ){
	case	MAINMENU_VARTYPE_S8:
	case	MAINMENU_VARTYPE_U8:
		max = 2;
		break;
	case	MAINMENU_VARTYPE_S16:
	case	MAINMENU_VARTYPE_U16:
		max = 4;
		break;
	case	MAINMENU_VARTYPE_S32:
	case	MAINMENU_VARTYPE_U32:
		max = 8;
		break;
	default:
		return 0;
	}
	if( mEditSize < 0 ){
		max = 0;
	}else if( mEditSize < max ){
		max = mEditSize;
	}
	for(i=0 ; i<max ; i++){
		value *= 10;
	}
	return value;
}

f32 WK7MainMenu::GetEditSize(void)
{
	int			i;
	f32			value = 1.0f;
	if( mEditSize >= 0 ){
		for(i=0 ; i<mEditSize ; i++){
			value *= 10.0f;
		}
	}else{
		for(i=mEditSize ; i<0 ; i++){
			value *= 0.5f;
		}
	}
	return value;
}

#define	DISPMAX			(23)
//#define	DISPMAX			(20)
bool WK7MainMenu::SetEditIDMax(void)
{
	mDispIDMax = DISPMAX;
	switch( mMode ){
	case	VAREDIT:
		mEditIDMax = GetVarNum();
		break;
	case	FLAGEDIT:
		mEditIDMax = GetFlagNum();
		break;
	case	GVAREDIT:
		mEditIDMax = GetGVarNum();
		break;
	case	GFLAGEDIT:
		mEditIDMax = GetGFlagNum();
		break;
	case	ITEMEDIT:
		mEditIDMax = GetItemNum();
		break;
	case	PLAYEDIT:
		mEditIDMax = GetPlayNum();
		break;
	case	PATHCHANGE:
		mEditIDMax = GetPathNum();
		break;
	case	CHARAPRESENT:
	case	HIERARCHY:
		break;
	case	AUTOPARAM:
		mEditIDMax = 3;
		break;
	case	TOPMENU:
	default:
		mEditIDMax = -1;
		break;
	}
	return true;
}

int WK7MainMenu::GetVarNum(void)
{
#ifdef	_DEBUG
	K7EVVarType		*pVarType = GameInfo.GetVarTypeTop(mEditScenarioID);
	int				i;
	
	if( pVarType!=NULL ){
		for(i=0 ; pVarType[i].mpVar!=NULL ; i++){}
	}else{
		i = -1;
	}
	
	return i;
#else
	return -1;
#endif
}

bool WK7MainMenu::FrameProcessVarEdit(void)
{
#ifdef	_DEBUG
	K7EVVarType		*pVarType = GameInfo.GetVarTypeTop(mEditScenarioID);
#else
	K7EVVarType		*pVarType = NULL;
#endif
	return FrameProcessVarEdit(pVarType,true);
}

bool WK7MainMenu::FrameProcessVarEdit(K7EVVarType *pVarType,bool scn)
{
	
	if( FrameProcessEdit(scn)==false ){
		return false;
	}
	
	if( pVarType==NULL ){
		return true;
	}
	
	int		type;
	int		d = 0;
	MainMenuVarType	*pType;
	
	if( pVarType[mEditID].mArrayNum ){
		if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_RIGHT ){
			mEditArrayID++;
		}
		if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_LEFT  ){
			mEditArrayID--;
		}
		if( mEditArrayID < 0 ){
			mEditArrayID = pVarType[mEditID].mArrayNum - 1;
		}else if( mEditArrayID >= pVarType[mEditID].mArrayNum ){
			mEditArrayID = 0;
		}
	}else{
		mEditArrayID = 0;
	}
	
	if( (pType = GetType(pVarType[mEditID].mpType))==NULL ){
		type = -1;
	}else{
		type = pType->mType;
	}
	
	if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_RIGHT|HSD_PAD_RIGHT) ){
		d++;
	}
	if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_LEFT|HSD_PAD_LEFT) ){
		d--;
	}
	
	pVarType += mEditID;
	if( d!=0 && pVarType->mpVar!=NULL ){
		if( type==MAINMENU_VARTYPE_F32 ){
			f32		fvalue = (f32)(GetEditSize() * d);
			f32		*pfvalue = (f32 *)pVarType->mpVar;
			pfvalue[mEditArrayID] += fvalue;
		}else{
			int		ivalue = GetEditSize(type) * d;
			switch( type ){
			case	MAINMENU_VARTYPE_S8:{
				s8		*ps8value = (s8 *)pVarType->mpVar;
				ps8value[mEditArrayID] += ivalue;
				}break;
			case	MAINMENU_VARTYPE_U8:{
				u8		*pu8value = (u8 *)pVarType->mpVar;
				pu8value[mEditArrayID] += ivalue;
				}break;
			case	MAINMENU_VARTYPE_S16:{
				s16		*ps16value = (s16 *)pVarType->mpVar;
				ps16value[mEditArrayID] += ivalue;
				}break;
			case	MAINMENU_VARTYPE_U16:{
				u16		*pu16value = (u16 *)pVarType->mpVar;
				pu16value[mEditArrayID] += ivalue;
				}break;
			case	MAINMENU_VARTYPE_S32:{
				s32		*ps32value = (s32 *)pVarType->mpVar;
				ps32value[mEditArrayID] += ivalue;
				}break;
			case	MAINMENU_VARTYPE_U32:{
				u32		*pu32value = (u32 *)pVarType->mpVar;
				pu32value[mEditArrayID] += ivalue;
				}break;
			}
		}
	}
	K7SCR_EVCONDCHANGE();
	
	return true;
}

bool WK7MainMenu::RenderProcessEditScenario(const char *pOption,bool scn)
{
	int		scnid;
	if( scn==false ){
		if( pOption==NULL ){
			PRINTF(" [GL]\n");
		}else{
			PRINTF(" [GL] : %s\n",pOption);
		}
		return true;
	}
	switch( mEditScenarioID ){
	case	K7SCN01: scnid =  1; break;
	case	K7SCN02: scnid =  2; break;
	case	K7SCN03: scnid =  3; break;
	case	K7SCN04: scnid =  4; break;
	case	K7SCN05: scnid =  5; break;
	case	K7SCN06: scnid =  6; break;
	case	K7SCN07: scnid =  0; break;
	default:         scnid = 99; break;
	}
	if( pOption==NULL ){
		PRINTF(" [%02d]\n",scnid);
	}else{
		PRINTF(" [%02d] : %s\n",scnid,pOption);
	}
	return true;
}

bool WK7MainMenu::RenderProcessVarEdit(void)
{
#ifdef	_DEBUG
	K7EVVarType		*pVarType = GameInfo.GetVarTypeTop(mEditScenarioID);
#else
	K7EVVarType		*pVarType = NULL;
#endif
	return RenderProcessVarEdit(pVarType,true);
}

bool WK7MainMenu::RenderProcessVarEdit(K7EVVarType *pVarType,bool scn)
{
	int				varnum,i,c;
	const char		*pCursor;
	const char		*pVarName;
	MainMenuVarType	*pType;
	int				type;
	void			*pVar;
	char			editSize[256];
	char			arrayPart[16];
	int				arrayNum,arrayID;
	
	if( pVarType!=NULL && (pType = GetType(pVarType[mEditID].mpType))!=NULL ){
		type = pType->mType;
		if( type==MAINMENU_VARTYPE_F32 ){
			f32		fvalue = GetEditSize();
			sprintf(editSize,"%d(%f)",mEditSize,fvalue);
		}else{
			int		ivalue = GetEditSize(type);
			sprintf(editSize,"%d(%d)",mEditSize,ivalue);
		}
	}else{
		strcpy(editSize,"---");
	}
	
	RenderProcessEditScenario(editSize,scn);
	
	if( pVarType==NULL ){
		return true;
	}
	
	for(varnum=0 ; pVarType[varnum].mpVar!=NULL ; varnum++){}
	
	i = mEditID - mEditCursor;
	
	for(c=0 ; c<DISPMAX && i<varnum ; c++,i++){
		
		if( c==mEditCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		
		if( (pVarName=pVarType[i].mpID)==NULL ){
			pVarName = "---";
		}
		
		if( (pType = GetType(pVarType[i].mpType))==NULL ){
			type = -1;
		}else{
			type = pType->mType;
		}
		arrayNum = pVarType[i].mArrayNum;
		if( arrayNum > 0 ){
			if( c==mEditCursor ){
				arrayID = mEditArrayID;
			}else{
				arrayID = 0;
			}
			sprintf(arrayPart,"[%1d/%1d]",arrayID,arrayNum);
		}else{
			arrayID = 0;
			strcpy(arrayPart,"[-/-]");
		}
		
		if( (pVar = pVarType[i].mpVar)!=NULL ){
			
			switch( type ){
			case	MAINMENU_VARTYPE_S8:
				PRINTF("%s %-30s %5s : %d\n",pCursor,pVarName,arrayPart,((s8 *)pVar)[arrayID]);
				break;
			case	MAINMENU_VARTYPE_U8:
				PRINTF("%s %-30s %5s : %x\n",pCursor,pVarName,arrayPart,((u8 *)pVar)[arrayID]);
				break;
			case	MAINMENU_VARTYPE_S16:
				PRINTF("%s %-30s %5s : %d\n",pCursor,pVarName,arrayPart,((s16*)pVar)[arrayID]);
				break;
			case	MAINMENU_VARTYPE_U16:
				PRINTF("%s %-30s %5s : %x\n",pCursor,pVarName,arrayPart,((u16*)pVar)[arrayID]);
				break;
			case	MAINMENU_VARTYPE_S32:
				PRINTF("%s %-30s %5s : %d\n",pCursor,pVarName,arrayPart,((s32*)pVar)[arrayID]);
				break;
			case	MAINMENU_VARTYPE_U32:
				PRINTF("%s %-30s %5s : %x\n",pCursor,pVarName,arrayPart,((u32*)pVar)[arrayID]);
				break;
			case	MAINMENU_VARTYPE_F32:
				PRINTF("%s %-30s %5s : %f\n",pCursor,pVarName,arrayPart,((f32*)pVar)[arrayID]);
				break;
			default:
				PRINTF("%s %-30s       : ---\n",pCursor,pVarName);
				break;
			}
			
		}else{
			PRINTF("%s %-30s       : ---\n",pCursor,pVarName);
		}
		
	}
	
	return true;
}

//#ifdef _DEBUG

int WK7MainMenu::GetGVarNum(void)
{
#ifdef	_DEBUG
	K7EVVarType		*pVarType = GlobalVarType;
	int				i;
	
	if( pVarType!=NULL ){
		for(i=0 ; pVarType[i].mpVar!=NULL ; i++){}
	}else{
		i = -1;
	}
	
	return i;
#else
	return -1;
#endif
}

bool WK7MainMenu::FrameProcessGVarEdit(void)
{
#ifdef	_DEBUG
	K7EVVarType		*pVarType = GlobalVarType;
#else
	K7EVVarType		*pVarType = NULL;
#endif
	return FrameProcessVarEdit(pVarType,false);
}

bool WK7MainMenu::RenderProcessGVarEdit(void)
{
#ifdef	_DEBUG
	K7EVVarType		*pVarType = GlobalVarType;
#else
	K7EVVarType		*pVarType = NULL;
#endif
	return RenderProcessVarEdit(pVarType,false);
}

//#endif

int WK7MainMenu::GetFlagNum(void)
{
#ifdef	_DEBUG
	const char		**ppFlagName = GameInfo.GetFlagName();
	int				i;
	
	if( ppFlagName==NULL ){
		return -1;
	}
	
	for(i=0 ; ppFlagName[i]!=NULL ; i++){}
	
	return i;
#else
	return -1;
#endif
}

bool WK7MainMenu::FrameProcessFlagEdit(void)
{
#ifdef	_DEBUG
	const char		**ppFlagName = GameInfo.GetFlagName();
	
	if( ppFlagName==NULL ){
		return true;
	}
	
	if( FrameProcessEdit()==false ){
		return false;
	}
	
	if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
		if( GameInfo.GetScenarioFlag(mEditID) > 0 ){
			GameInfo.ResetScenarioFlag(mEditID);
		}else{
			GameInfo.SetScenarioFlag(mEditID);
		}
		K7SCR_EVCONDCHANGE();
	}
	
#endif
	return true;
}

bool WK7MainMenu::RenderProcessFlagEdit(void)
{
#ifdef	_DEBUG
	const char		**ppFlagName = GameInfo.GetFlagName();
	int				flagnum,i,c;
	const char		*pCursor;
	const char		*pOnOff;
	
	RenderProcessEditScenario();
	
	if( ppFlagName==NULL ){
		return true;
	}
	
	for(flagnum=0 ; ppFlagName[flagnum]!=NULL ; flagnum++){}
	
	i = mEditID - mEditCursor;
	
	for(c=0 ; c<DISPMAX && i<flagnum ; c++,i++){
		
		if( c==mEditCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		if( GameInfo.GetScenarioFlag(i) > 0 ){
			pOnOff = "O";
		}else{
			pOnOff = "X";
		}
		
		PRINTF("%s %-30s : %s\n",pCursor,ppFlagName[i],pOnOff);
		
	}
	
#endif
	return true;
}

int WK7MainMenu::GetGFlagNum(void)
{
	return K7GLFL_NUM;
}

bool WK7MainMenu::FrameProcessGFlagEdit(void)
{
#ifdef	_DEBUG
	if( FrameProcessEdit()==false ){
		return false;
	}
	
	if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
		if( GameInfo.GetGlobalFlag(mEditID) > 0 ){
			GameInfo.ResetGlobalFlag(mEditID);
		}else{
			GameInfo.SetGlobalFlag(mEditID);
		}
		K7SCR_EVCONDCHANGE();
	}
#endif
	return true;
}

bool WK7MainMenu::RenderProcessGFlagEdit(void)
{
#ifdef	_DEBUG
	const char		**ppFlagName = GlobalFlagName;
	int				i,c;
	char			Cursor;
	char			OnOff;
	
	RenderProcessEditScenario(false);
	
	i = mEditID - mEditCursor;
	
	for(c=0 ; c<DISPMAX && i<K7GLFL_NUM ; c++,i++){
		
		if( c==mEditCursor ){
			Cursor = '>';
		}else{
			Cursor = ' ';
		}
		if( GameInfo.GetGlobalFlag(i) > 0 ){
			OnOff = 'O';
		}else{
			OnOff = 'X';
		}
		
		PRINTF("%c %-30s : %c\n",Cursor,ppFlagName[i],OnOff);
	}
#endif	
	return true;
}

int WK7MainMenu::GetItemNum(void)
{
	WK7EventItemTable	*pItemTable = WK7EventItem::GetTable();
	int					i;
	
	if( pItemTable==NULL ){
		return -1;
	}
	
	for(i=0 ; pItemTable[i].mItemNo!=WK7EVITEMTBL_TERM_ITEMNO ; i++){}
	
	return i;
}

bool WK7MainMenu::FrameProcessItemEdit(void)
{
	
	WK7EventItemTable	*pItemTable = WK7EventItem::GetTable();
	
	if( pItemTable==NULL ){
		return true;
	}
	
	if( FrameProcessEdit()==false ){
		return false;
	}
	
	WK7Stage	*pStage = WK7Stage::GetCurrentStage();
	bool		flag;
	
	if( WK7MAINMENU_PADBUTTON & HSD_PAD_X ){
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			flag = WK7EventItem::IsUsedItem(pItemTable[mEditID].mItemNo);
			flag = (flag==true? false : true);
			WK7EventItem::UseItem(pItemTable[mEditID].mItemNo,flag);
			K7SCR_EVCONDCHANGE();
		}
	}else{
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			flag = WK7EventItem::HasItem(pItemTable[mEditID].mItemNo);
			if( pStage!=NULL ){
				pStage->SetEventNoEnable(pItemTable[mEditID].mItemNo,flag);
			}
			flag = (flag==true? false : true);
			WK7EventItem::SetItem(pItemTable[mEditID].mItemNo,flag);
			K7SCR_EVCONDCHANGE();
		}
	}
	
	return true;
}

bool WK7MainMenu::RenderProcessItemEdit(void)
{
	WK7EventItemTable	*pItemTable = WK7EventItem::GetTable();
	int				itemnum,i,c;
	const char		*pCursor;
	char			hasItem;
	char			usedItem;
	const char		*pType;
	
	RenderProcessEditScenario();
	
	if( pItemTable==NULL ){
		return true;
	}
	
	for(itemnum=0 ; pItemTable[itemnum].mItemNo!=WK7EVITEMTBL_TERM_ITEMNO ; itemnum++){}
	
	i = mEditID - mEditCursor;
	
	for(c=0 ; c<DISPMAX && i<itemnum ; c++,i++){
		
		if( c==mEditCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		if( WK7EventItem::HasItem(pItemTable[i].mItemNo) > 0 ){
			hasItem = 'O';
		}else{
			hasItem = 'X';
		}
		if( WK7EventItem::IsUsedItem(pItemTable[i].mItemNo) > 0 ){
			usedItem = 'O';
		}else{
			usedItem = ' ';
		}
		
		switch( pItemTable[i].mItemNo & K7EVITEM_TYPE_MASK ){
		case	K7EVITEM_TYPE_KEY:  pType="KEY" ; break;
		case	K7EVITEM_TYPE_MAP:  pType="MAP" ; break;
		case	K7EVITEM_TYPE_MEMO: pType="MEMO"; break;
		case	K7EVITEM_TYPE_ZAN:  pType="ZAN";  break;
		case	K7EVITEM_TYPE_TAMA: pType="TAMA"; break;
		default:                    pType="---" ; break;
		}
		
		PRINTF("%s %-4s %06x : %c%c\n",pCursor,pType,pItemTable[i].mItemNo & 0xffffff,hasItem,usedItem);
		
	}
	
	return true;
}

int WK7MainMenu::GetPlayNum(void)
{
	WK7PlayTable		*pPlayTable = WK7Play::GetTableTop();
	int					i;
	
	for(i=0 ; pPlayTable[i].mPlayNo!=WK7PLAYTBL_TERM_NO ; i++){}
	
	return i;
}

bool WK7MainMenu::FrameProcessPlayEdit(void)
{
	
	WK7PlayTable	*pPlayTable = WK7Play::GetTableTop();
	
	if( FrameProcessEdit()==false ){
		return false;
	}
	
	WK7Stage	*pStage = WK7Stage::GetCurrentStage();
	bool		flag;
	
	if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
		flag = WK7Play::HasPlayed(pPlayTable[mEditID].mPlayNo);
		flag = (flag==true? false : true);
		WK7Play::SetPlayed(pPlayTable[mEditID].mPlayNo,flag);
		K7SCR_EVCONDCHANGE();
	}
	
	return true;
}

bool WK7MainMenu::RenderProcessPlayEdit(void)
{
	WK7PlayTable	*pPlayTable = WK7Play::GetTableTop();
	int				num,i,c;
	const char		*pCursor;
	char			hasPlayed;
	
	RenderProcessEditScenario();
	
	num = GetPlayNum();
	
	i = mEditID - mEditCursor;
	
	for(c=0 ; c<DISPMAX && i<num ; c++,i++){
		
		if( c==mEditCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		if( WK7Play::HasPlayed(pPlayTable[i].mPlayNo)==true ){
			hasPlayed = 'O';
		}else{
			hasPlayed = 'X';
		}
		
		PRINTF("%s PLAY_%08x : %c\n",pCursor,pPlayTable[i].mPlayNo & 0xfffffff,hasPlayed);
	}
	
	return true;
}

int WK7MainMenu::GetPathNum(void)
{
	WK7Stage		*pStage = WK7Stage::GetCurrentStage();
	WK7Path			*pPath;
	
	if( pStage==NULL || (pPath=pStage->GetPath())==NULL || pPath->GetPathNum()<=0 ){
		return -1;
	}
	
	return (int)pPath->GetPathNum();
}

bool WK7MainMenu::FrameProcessPathChange(void)
{
	WK7Stage		*pStage = WK7Stage::GetCurrentStage();
	WK7Path			*pPath;
	
	if( pStage==NULL || (pPath=pStage->GetPath())==NULL || pPath->GetPathNum()<=0 ){
		SetMode(TOPMENU);
		return true;
	}
	
	if( FrameProcessEdit()==false ){
		return false;
	}
	
	WK7PathNurbs	*pPathNurbs = pPath->GetPathTop();
	int				i;
	for(i=0 ; i<pPath->GetPathNum() && pPathNurbs!=NULL ; i++,pPathNurbs=pPathNurbs->GetNext()){
		if( i==mEditID ){
			break;
		}
	}
	if( pPathNurbs==NULL ){
		return true;
	}
	
	if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
		f32		param;
		u32		dir;
		if( WK7MAINMENU_PADBUTTON & HSD_PAD_Z ){
			param = pPathNurbs->GetEndParam();
			dir   = 1;
		}else{
			param = pPathNurbs->GetStartParam();
			dir   = 0;
		}
		WK7Stage::SetCurrentPath(pPathNurbs,param,dir,WK7PATHINFO_INITDIR_TGTDIR_REV);
		WK7SELECTIF->Disappear();
		SetActive(false);
		return true;
	}
	
	if( WK7MAINMENU_PADTRIGGER & HSD_PAD_X ){
		pPathNurbs->SetEnable(pPathNurbs->GetEnable()==true? false : true);
		K7SCR_EVCONDCHANGE();
	}
	
	if( WK7MAINMENU_PADTRIGGER & HSD_PAD_Y ){
		pPathNurbs->SetEnableEx(pPathNurbs->GetEnableEx()==true? false : true);
		K7SCR_EVCONDCHANGE();
	}
	
	return true;
}

bool WK7MainMenu::RenderProcessPathChange(void)
{
	WK7Stage		*pStage = WK7Stage::GetCurrentStage();
	WK7Path			*pPath;
	WK7PathNurbs	*pPathNurbs;
	int				i,c,pathCount;
	const char		*pName,*pCursor;
	
	if( pStage==NULL || (pPath=pStage->GetPath())==NULL || (pathCount=(int)pPath->GetPathNum())<=0 ){
		return true;
	}
	
	i = mEditID - mEditCursor;
	for(c=0,pPathNurbs=pPath->GetPathTop() ; c<i && pPathNurbs!=NULL  ; c++,pPathNurbs=pPathNurbs->GetNext()){}
	
	if( pPathNurbs==NULL ){
		return true;
	}
	
	for(c=0 ; c<DISPMAX && i<pathCount && pPathNurbs!=NULL ; c++,i++,pPathNurbs=pPathNurbs->GetNext()){
		
		if( c==mEditCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		if( (pName = pPathNurbs->GetName())==NULL ){
			pName = "---";
		}
		
		PRINTF("%s %c%c %s\n",pCursor,
		                      pPathNurbs->GetEnable  ()==true? 'P':'-',
		                      pPathNurbs->GetEnableEx()==true? 'C':'-',
		                      pName);
		
	}
	
	return true;
}

static	int	editid = 0;
bool WK7MainMenu::FrameProcessCharaPresent(void)
{
	if( (WK7MAINMENU_PADREPEAT & (HSD_PAD_B|HSD_PAD_START)) || mpMaskWindow==NULL ){
		SetMode(TOPMENU);
		return true;
	}
	
	if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
		OSReport("%5d,%5d,%4d,%4d,%4d,%4d\n",
		         (s16)mNameX,
		         (s16)mNameY,
		         (s16)mWindowX,
		         (s16)mWindowY,
		         (s16)mWindowW,
		         (s16)mWindowH);
	}
	if( HSD_PadGetTrigger(1) & HSD_PAD_Z ){
		editid++;
		if( editid >= 2 ){
			editid = 0;
		}
	}
static	f32		movespeed = 8.0f;
	f32			lx,ly,rx,ry;
	lx = HSD_PadGetNormalStickX   (1);
	ly = HSD_PadGetNormalStickY   (1);
	rx = HSD_PadGetNormalSubStickX(1);
	ry = HSD_PadGetNormalSubStickY(1);
	if( lx!=0.0f || ly!=0.0f || rx!=0.0f || ry!=0.0f ){
		switch( editid ){
		case	0:
			mWindowX += movespeed * lx;
			mWindowY -= movespeed * ly;
			mWindowW += movespeed * rx;
			mWindowH -= movespeed * ry;
			if( mWindowW < 0 ){
				mWindowW = 0;
			}
			if( mWindowH < 0 ){
				mWindowH = 0;
			}
			break;
		case	1:
			mNameX += movespeed * lx;
			mNameY -= movespeed * ly;
			break;
		}
		mpMaskWindow->SetRect(mWindowX,mWindowY,mWindowW,mWindowH);
	}
	
	return true;
}

bool WK7MainMenu::RenderProcessCharaPresent(void)
{
	
	Mtx				view;
	Mtx44			proj;
static	GXColor		drawColor[2] = { { 0xff,0x00,0x00,0xff } , { 0xff,0xff,0xff,0xff } };
	
	HSD_RectU16		sc_rect;
	WK7CAM->GetScissor(sc_rect);
	
	WK7Cam::Set2DMatrix(view,proj);
	
	// [Jr[ϊ}gNXݒ
	GXLoadPosMtxImm  (view,GX_PNMTX0);
	GXLoadNrmMtxImm  (view,GX_PNMTX0);
	GXSetCurrentMtx  (GX_PNMTX0);
	GXSetProjection  (proj,GX_ORTHOGRAPHIC);
	GXSetScissor     (0,0,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT);
	GXSetViewport    (0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);
	
	GXSetDither      (GX_FALSE);
	GXSetDstAlpha    (0,0);
	GXSetAlphaCompare(GX_ALWAYS,0,GX_AOP_AND,GX_ALWAYS,0);
	
	GXSetNumChans    (1);
	GXSetChanCtrl    (GX_COLOR0A0,GX_FALSE,GX_SRC_REG,GX_SRC_REG,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
	
	// uhȂ
	GXSetBlendMode   (GX_BM_NONE,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetCullMode    (GX_CULL_NONE);
	
	GXSetZMode       (GX_FALSE,GX_ALWAYS,GX_FALSE);
	GXSetZCompLoc    (GX_TRUE );
	GXSetColorUpdate (GX_TRUE );
	GXSetAlphaUpdate (GX_FALSE);
	
	GXClearVtxDesc   ();
	GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
	GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
	
	GXSetNumTexGens  (0);
	
	GXSetNumTevStages(1);
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR0A0);
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_RASC);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	
static	f32		clearz = 0.5f;
static	f32		namew = 200.0f,nameh = 48.0f;
	int			id;
	
	switch( editid ){
	case	0:
		id = 1;
		break;
	default:
		id = 0;
		break;
	}
	GXSetChanMatColor(GX_COLOR0A0,drawColor[id]);
	GXBegin(GX_LINESTRIP,GX_VTXFMT0,5);
	
		GXPosition3f32(mNameX      ,mNameY      ,clearz);
		GXPosition3f32(mNameX+namew,mNameY      ,clearz);
		GXPosition3f32(mNameX+namew,mNameY+nameh,clearz);
		GXPosition3f32(mNameX      ,mNameY+nameh,clearz);
		GXPosition3f32(mNameX      ,mNameY      ,clearz);
		
	GXEnd();
	
	switch( editid ){
	case	0:
		id = 0;
		break;
	default:
		id = 1;
		break;
	}
	GXSetChanMatColor(GX_COLOR0A0,drawColor[id]);
	GXBegin(GX_LINESTRIP,GX_VTXFMT0,5);
	
		GXPosition3f32(mWindowX         ,mWindowY         ,clearz);
		GXPosition3f32(mWindowX+mWindowW,mWindowY         ,clearz);
		GXPosition3f32(mWindowX+mWindowW,mWindowY+mWindowH,clearz);
		GXPosition3f32(mWindowX         ,mWindowY+mWindowH,clearz);
		GXPosition3f32(mWindowX         ,mWindowY         ,clearz);
		
	GXEnd();
	
	return true;
}

bool WK7MainMenu::FrameProcessTopMenu(void)
{
	
	PadOperateProc(WK7MAINMENU_TOPMENU_ITEMNUM);
	
	switch( mProc ){
	case	0:
		if( mEnableStageChange==false ){
			break;
		}
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			if( WK7Stage::ChangeStage()==false ){
				break;
			}
			SetActive(false);
			return true;
		}
		break;
	case	1:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			if( WK7Stage::GetCurrentStage()!=NULL ){
				SetMode(PATHCHANGE);
				return true;
			}
		}
		break;
	case	2:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->Start(WK7PlayerChangeTaskDebug, (u32)K7CHRID(mChangeCharaID, 0));
			SetActive(false);
			return true;
		}
		if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_LEFT|HSD_PAD_LEFT) ){
			mChangeCharaID--;
			if ( mChangeCharaID < 0 ) mChangeCharaID = 0;
		}
		if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_RIGHT|HSD_PAD_RIGHT) ){
			mChangeCharaID++;
			if ( mChangeCharaID >= K7PCMAX ) mChangeCharaID = (K7PCMAX-1);
		}
		break;
	case	3:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			mChangeFlowProc = 0;
			mOldFlow = GameInfo.GetScenarioFlow();
			SetMode(CHANGEFLOW);
			return true;
		}
		break;
	case	4:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mDispPathInfo = (mDispPathInfo==true? false : true);
		}
		break;
	case	5:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mDispMemInfo  = (mDispMemInfo ==true? false : true);
			ghmGcMem::SetRender(mDispMemInfo);
		}
		break;
	case	6:
		if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_RIGHT|HSD_PAD_RIGHT) ){
			mMemMinWidth++;
		}
		if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_LEFT|HSD_PAD_LEFT) ){
			mMemMinWidth--;
		}
		if( mMemMinWidth < 1 ){
			mMemMinWidth = 1;
		}
#ifdef	_DEBUG
		ghmGcMem::SetMinWidth((u16)mMemMinWidth);
#endif
		break;
	case	7:
		if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_RIGHT|HSD_PAD_RIGHT) ){
			mMemDumpType++;
		}
		if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_LEFT|HSD_PAD_LEFT) ){
			mMemDumpType--;
		}
		if( mMemDumpType > 2 ){
			mMemDumpType = 0;
		}else if( mMemDumpType < 0 ){
			mMemDumpType = 2;
		}
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			K7AppDumpMemoryType(mMemDumpType);
		}
		break;
	case	8:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mDispPerfInfo = (mDispPerfInfo==true? false : true);
			k7app.SetVisiblePerfMeter(mDispPerfInfo);
		}
		break;
	case	9:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mDispCamPos = (mDispCamPos==true? false : true);
		}
		break;
	case	10:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mAutoPlay = (mAutoPlay==true? false : true);
		}
		break;
	case	11:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mBattleInfo = (mBattleInfo==true? false : true);
		}
		break;
	case	12:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mEneWalkArea = (mEneWalkArea==true? false : true);
		}
		break;
	case	13:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mGalSystemEnable = (mGalSystemEnable==true? false : true);
		}
		break;
	case	14:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			SetStreamPlayEnable(IsStreamPlayEnable()==true? false : true);
		}
		break;
	case	15:
		if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_RIGHT|HSD_PAD_RIGHT) ){
			GameInfo.GetSpOption()->GetBloodSetFlag( true );
			WK7PLAYERCONTROL->SpGaugeInc(BLOOD_D_WEAK);
			BattleCtrl.IncBpGauge(BP_SERUM, 	(int )BLOOD_MIN);
//			BattleCtrl.PcReCallSet(K7DAN, 1);
//			BattleCtrl.PcReCallSet(K7GAL, 1);
//			BattleCtrl.PcReCallSet(K7CON, 1);
//			BattleCtrl.PcReCallSet(K7CYO, 1);
//			BattleCtrl.PcReCallSet(K7KED, 1);
//			BattleCtrl.PcReCallSet(K7KVN, 1);
//			BattleCtrl.PcReCallSet(K7MSK, 1);
		}
		if( WK7MAINMENU_PADREPEAT & (HSD_PAD_STICK_LEFT|HSD_PAD_LEFT) ){
			GameInfo.GetSpOption()->GetBloodSetFlag( true );
			WK7PLAYERCONTROL->SpGaugeInc(-BLOOD_D_WEAK);
			BattleCtrl.IncBpGauge(BP_SERUM, 	(int )-BLOOD_MIN);
		}
		break;
	case	16:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mMuteki = (mMuteki==true? false : true);
		}
		break;
	case	17:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mPlayerInfo = (mPlayerInfo==true? false : true);
		}
		break;
	case	18:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mPcPause = (mPcPause==true? false : true);
			if ( true == mPcPause ){
				WK7PLAYERCONTROL->SetPause();
			}else{
				WK7PLAYERCONTROL->ResetPause();
			}
		}
		break;
	case	19:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mNpcPause = (mNpcPause==true? false : true);
			if ( true == mNpcPause ){
				WK7Npc::NpcPauseAll();
			}else{
				WK7Npc::NpcResetPauseAll();
			}
		}
		break;
	case	20:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mDispShadow = (mDispShadow==true? false : true);
		}
		break;
	case	21:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mDispAlpha = (mDispAlpha==true? false : true);
		}
		break;
	case	22:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mFollowCamEdit = (mFollowCamEdit==true? false : true);
		}
		break;
	case	23:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mSkillEdit = (mSkillEdit==true? false : true);
		}
		break;
	case	24:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mSkillAllUse = (mSkillAllUse==true? false : true);
		}
		break;
	case	25:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mJunctionColorEdit = (mJunctionColorEdit==true? false : true);
		}
		break;
	case	26:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mDownAtkEdit = (mDownAtkEdit==true? false : true);
		}
		break;
	case	27:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mModeInfo = (mModeInfo==true? false : true);
		}
		break;
	case	28:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mGunDisp = (mGunDisp==true? false : true);
			WK7PLAYERCONTROL->SetGunVisible(mGunDisp);
		}
		break;
	case	29:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mEnemySet = (mEnemySet==true? false : true);
		}
		break;
	case	30:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			SetGxWarning(GetGxWarning()==true? false : true);
		}
		break;
	case	31:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			mStageWarning = (mStageWarning==true? false : true);
		}
		break;
	case	32:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			if ( BattleCtrl.GetGalPowerUp() ){
				BattleCtrl.GalPowerUp(0);
			}else{
				BattleCtrl.GalPowerUp();
			}
		}
		break;
	case	33:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			if ( BattleCtrl.GetDanPowerUp() ){
				BattleCtrl.DanPowerUp(0);
			}else{
				BattleCtrl.DanPowerUp();
			}
		}
		break;
	case	34:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			u8 Lv = BattleCtrl.GetMskPowerUp();
			Lv++;
			if ( Lv > KK7BATTLECTRL_MSKLV_TEKKAMEN ) Lv = 0;
			BattleCtrl.MskPowerUp(Lv);
		}
		break;
	case	35:
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_STICK_LEFT|HSD_PAD_RIGHT|HSD_PAD_LEFT) ){
			ChangeSpAtkTaskState();
		}
		break;
	case	36:
#ifdef _DEBUG
		{
			if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_RIGHT) ){
				DebugTumorEfcType++;
			}
			if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_LEFT|HSD_PAD_LEFT) ){
				DebugTumorEfcType--;
				if ( DebugTumorEfcType < 0 ) DebugTumorEfcType = 0;
			}
			
			WK7Npc *pNearNpc = pBattleMain->GetNearNpc();
			if ( pNearNpc != NULL ){
				pNearNpc->SetTumorEfcType((s8 )DebugTumorEfcType);
			}
		}
#endif
		break;
	case	37:
		if( (WK7MAINMENU_PADBUTTON & HSD_PAD_A) && (WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_RIGHT)) ){
			SetMode(DUMPSTAGEINFO);
			return true;
		}
		break;
	case	38:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			SetMode(GVAREDIT);
			return true;
		}
		break;
	case	39:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			SetMode(GFLAGEDIT);
			return true;
		}
		break;
	case	40:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			SetMode(VAREDIT);
			return true;
		}
		break;
	case	41:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			SetMode(FLAGEDIT);
			return true;
		}
		break;
	case	42:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			SetMode(ITEMEDIT);
			return true;
		}
		break;
	case	43:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			SetMode(PLAYEDIT);
			return true;
		}
		break;
	case	44:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			SetMode(CHARAPRESENT);
			return true;
		}
		break;
	case	45:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			SetMode(HIERARCHY);
			return true;
		}
		break;
	case	46:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			SetMode(AUTOPARAM);
			return true;
		}
		break;
	case	47:
		if( GameInfo.GetMode()!=WK7GameInfo::PANELMODE ){
			int		panelID = (int)mPanelID;
			int		d;
			if( WK7MAINMENU_PADBUTTON & HSD_PAD_Z ){
				d = 4;
			}else{
				d = 1;
			}
			if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_RIGHT ){
				mPanelCursor++;
			}
			if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_LEFT ){
				mPanelCursor--;
			}
			if( mPanelCursor < 0 ){
				mPanelCursor = 7;
			}else if( mPanelCursor > 7 ){
				mPanelCursor = 0;
			}
			switch( mPanelCursor ){
			case	0:{
				int		type;
				switch( mPanelEventNo & K7EV_TYPE_MASK ){
				case	K7EV_TYPE_RAKU: type = 1; break;
				case	K7EV_TYPE_NO:
				default:                type = 0; break;
				}
				if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_UP ){
					type++;
				}
				if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_DOWN ){
					type--;
				}
				if( type < 0 ){
					type = 1;
				}else if( type > 1 ){
					type = 0;
				}
				switch( type ){
				case	1: type = K7EV_TYPE_RAKU; break;
				case	0: 
				default:   type = K7EV_TYPE_NO;   break;
				}
				mPanelEventNo = (mPanelEventNo & K7EV_ID_MASK)|type;
				}break;
			case	1:
			case	2:
			case	3:
			case	4:
			case	5:
			case	6:{
				u32		sft  = (u32)((6-mPanelCursor) << 2);
				int		no   = (int)(((mPanelEventNo & K7EV_ID_MASK) >> sft) & 0xf);
				u32		type = K7EV_TYPE_MASK & mPanelEventNo;
				u32		rest = (K7EV_ID_MASK & mPanelEventNo) & ~(0xf << sft);
				if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_UP ){
					no++;
				}
				if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_DOWN ){
					no--;
				}
				if( no < 0 ){
					no = 9;
				}else if( no > 9 ){
					no = 0;
				}
				no <<= sft;
				mPanelEventNo = type|no|rest;
				}break;
			case	7:
				if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_UP ){
					mPanelParam += d;
				}
				if( WK7MAINMENU_PADREPEAT & HSD_PAD_SUBSTICK_DOWN ){
					mPanelParam -= d;
				}
				break;
			default:
				break;
			}
			if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
				// plĂяo
				GameInfo.SetRequestPanelEventNo(mPanelEventNo,mPanelParam);
//				GameInfo.SetRequestPanelID(mPanelID,mPanelParam);
				GameInfo.SetMode(WK7GameInfo::PANELMODE);
				GameInfo.SetPanelTermHideWait(false);
				SetActive(false);
				return true;
			}
		}
		break;
	default:
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_A ){
			mTermRequest = true;
			return true;
		}
		break;
	}
	
	if( WK7MAINMENU_PADTRIGGER & HSD_PAD_START ){
		SetActive(false);
		return true;
	}
	
	return true;
}

bool WK7MainMenu::RenderProcessTopMenu(void)
{
	int			i,c;
	const char	*pMenuItemName;
	const char	*pMenuItem;
	char		str[128];
	char		str2[32];
	
	i = mProc - mEditCursor;
	
	for(c=0 ; c<WK7MAINMENU_TOPMENU_DISPMAX && i<WK7MAINMENU_TOPMENU_ITEMNUM ; c++,i++){
		
		switch( i ){
		case	0:
			pMenuItemName = "Change Stage";
			pMenuItem     = (mEnableStageChange==true? "Enable -> Press A Button" : "Disable");
			break;
		case	1:
			pMenuItemName = "Change Path";
			pMenuItem     = (WK7Stage::GetCurrentStage()!=NULL? "Enable -> Press A Button" : "Disable");
			break;
		case	2:
			pMenuItemName = "Change Chara";
			pMenuItem     = ("%s", pPcName[mChangeCharaID]);
			break;
		case	3:
			pMenuItemName = "Scenario Flow";
			pMenuItem     = GetFlowName();
			break;
		case	4:
			pMenuItemName = "Disp Path Info";
			pMenuItem     = (mDispPathInfo==true? "On" : "Off");
			break;
		case	5:
			pMenuItemName = "Disp Mem Info";
			pMenuItem     = (mDispMemInfo ==true? "On" : "Off");
			break;
		case	6:
			pMenuItemName = "Disp Mem MinWidth";
			sprintf(str,"%d",mMemMinWidth);
			pMenuItem     = str;
			break;
		case	7:
			pMenuItemName = "Dump Mem Type";
			sprintf(str,"%d",mMemDumpType);
			pMenuItem     = str;
			break;
		case	8:
			pMenuItemName = "Disp Perf Info";
			pMenuItem     = (mDispPerfInfo==true? "On" : "Off");
			break;
		case	9:
			pMenuItemName = "Disp Cam Pos";
			pMenuItem     = (mDispCamPos==true? "On" : "Off");
			break;
		case	10:
			pMenuItemName = "Auto CharaGeki";
			pMenuItem     = (mAutoPlay==true? "On" : "Off");
			break;
		case	11:
			pMenuItemName = "Battle Info";
			pMenuItem     = (mBattleInfo==true? "On" : "Off");
			break;
		case	12:
			pMenuItemName = "EnemyWalk Area";
			pMenuItem     = (mEneWalkArea==true? "On" : "Off");
			break;
		case	13:
			pMenuItemName = "Gal System Enable";
			pMenuItem     = (mGalSystemEnable==true? "On" : "Off");
			break;
		case	14:
			pMenuItemName = "Stream Play Enable";
			pMenuItem     = (IsStreamPlayEnable()==true? "On" : "Off");
			break;
		case	15:
			pMenuItemName = "Blood Gauge(THIN)";
			pMenuItem     = str;
			sprintf(str,"%d",(int)BattleCtrl.GetBpGauge(BP_THIN) );
			break;
		case	16:
			pMenuItemName = "Muteki";
			pMenuItem     = (IsMuteki()==true? "On" : "Off");
			break;
		case	17:
			pMenuItemName = "Player Info";
			pMenuItem     = (IsPlayerInfo()==true? "On" : "Off");
			break;
		case	18:
			pMenuItemName = "Pc  Pause";
			pMenuItem     = (IsPcPause()==true? "On" : "Off");
			break;
		case	19:
			pMenuItemName = "Npc Pause";
			pMenuItem     = (IsNpcPause()==true? "On" : "Off");
			break;
		case	20:
			pMenuItemName = "Shadow";
			pMenuItem     = (GetDispShadow()==true? "On" : "Off");
			break;
		case	21:
			pMenuItemName = "Alpha";
			pMenuItem     = (GetDispAlpha()==true? "On" : "Off");
			break;
		case	22:
			pMenuItemName = "FollowCamEdit";
			pMenuItem     = (GetFollowCamEdit()==true? "On" : "Off");
			break;
		case	23:
			pMenuItemName = "SkillEdit";
			pMenuItem     = (IsSkillEdit()==true? "On" : "Off");
			break;
		case	24:
			pMenuItemName = "SkillAllUse";
			pMenuItem     = (IsSkillAllUse()==true? "On" : "Off");
			break;
		case	25:
			pMenuItemName = "JunctionColorEdit";
			pMenuItem     = (GetJunctionColorEdit()==true? "On" : "Off");
			break;
		case	26:
			pMenuItemName = "DownAttackEdit";
			pMenuItem     = (IsSDownAtkEdit()==true? "On" : "Off");
			break;
		case	27:
			pMenuItemName = "ModeInfo";
			pMenuItem     = (GetModeInfo()==true? "On" : "Off");
			break;
		case	28:
			pMenuItemName = "GunDisp";
			pMenuItem     = (IsGunDisp()==true? "On" : "Off");
			break;
		case	29:
			pMenuItemName = "EnemySet";
			pMenuItem     = (IsEnemySet()==true? "On" : "Off");
			break;
		case	30:
			pMenuItemName = "GxWarning";
			pMenuItem     = (GetGxWarning()==true? "On" : "Off");
			break;
		case	31:
			pMenuItemName = "StageWarning";
			pMenuItem     = (mStageWarning==true? "On" : "Off");
			break;
		case	32:
			pMenuItemName = "Gal PowerUp";
			pMenuItem     = (BattleCtrl.GetGalPowerUp()==1? "On" : "Off");
			break;
		case	33:
			pMenuItemName = "Dan PowerUp";
			pMenuItem     = (BattleCtrl.GetDanPowerUp()==1? "On" : "Off");
			break;
		case	34:
			pMenuItemName = "Msk PowerUp";
			{
				sprintf(str2,"%d", (int)BattleCtrl.GetMskPowerUp());
				pMenuItem = str2;
			}
			break;
		case	35:
			pMenuItemName = "SpAtkTask";
			switch( WK7PlayerControl::GetStateSpAtkTask() ){
			case	GHMGCTASK_IDLE:          pMenuItem = "IDLE";    break;
			case	GHMGCTASK_RUN:           pMenuItem = "RUN";     break;
			case	GHMGCTASK_READY:         pMenuItem = "READY";   break;
			case	GHMGCTASK_SUSPEND:       pMenuItem = "SUSPEND"; break;
			case	GHMGCTASK_WAIT:          pMenuItem = "WAIT";    break;
			case	GHMGCTASK_INVALID_STATE: 
			default:                         pMenuItem = "INVALID"; break;
			}
			break;
		case	36:
			pMenuItemName = "TumorEffect";
#ifdef _DEBUG
			{
				sprintf(str2,"%d", (int)DebugTumorEfcType);
				pMenuItem = str2;
			}
#else
			pMenuItem = "---";
#endif
			break;
		case	37:
			pMenuItemName = "Dump StagelInfo";
			pMenuItem     = "Press A + Right -> Dump";
			break;
		case	38:
			pMenuItemName = "Global Var Edit";
			pMenuItem     = "Press A -> EditMode";
			break;
		case	39:
			pMenuItemName = "Global Flag Edit";
			pMenuItem     = "Press A -> EditMode";
			break;
		case	40:
			pMenuItemName = "Scenario Var Edit";
			pMenuItem     = "Press A -> EditMode";
			break;
		case	41:
			pMenuItemName = "Scenario Flag Edit";
			pMenuItem     = "Press A -> EditMode";
			break;
		case	42:
			pMenuItemName = "Item Edit";
			pMenuItem     = "Press A -> EditMode";
			break;
		case	43:
			pMenuItemName = "CharaGeki Flag Edit";
			pMenuItem     = "Press A -> EditMode";
			break;
		case	44:
			pMenuItemName = "CharaNameEdit";
			pMenuItem     = "Press A -> EditMode";
			break;
		case	45:
			pMenuItemName = "Hierarchy";
			pMenuItem     = "Press A -> Display";
			break;
		case	46:
			pMenuItemName = "AutoParam";
			pMenuItem     = "Press A -> Display";
			break;
		case	47:{
// Yam
#ifdef _DEBUG
			if( GameInfo.GetMode()==WK7GameInfo::PANELMODE ){
				pMenuItem = "---";
			}else{
				char	type[16];
				char	num [6][4];
				char	param[16];
				int		j;
static			int		count = 0;
				if( --count <= 0 ){
					count  = 30;
				}
				switch( mPanelEventNo & K7EV_TYPE_MASK ){
				case	K7EV_TYPE_NO:    strcpy(type,"EVENT");  break;
				case	K7EV_TYPE_KEY:   strcpy(type,"KEY");    break;
				case	K7EV_TYPE_MAP:   strcpy(type,"MAP");    break;
				case	K7EV_TYPE_MEMO:  strcpy(type,"MEMO");   break;
				case	K7EV_TYPE_VMEMO: strcpy(type,"VOICEM"); break;
				case	K7EV_TYPE_PLAY:  strcpy(type,"PLAY");   break;
				case	K7EV_TYPE_RAKU:  strcpy(type,"RAKUM");  break;
				case	K7EV_TYPE_DOOR:  strcpy(type,"DOOR");   break;
				default:                 strcpy(type,"---");    break;
				}
				u32		no = mPanelEventNo & K7EV_ID_MASK;
				for(j=0 ; j<6 ; j++,no>>=4){
					sprintf(num[j],"%d",no & 0xf);
				}
				sprintf(param,"%d",mPanelParam);
				if( count <= 10 && mEditCursor==c ){
					switch( mPanelCursor ){
					case	0: memset(type,' ',strlen(type)); break;
					case	1:
					case	2:
					case	3:
					case	4:
					case	5:
					case	6: num[6-mPanelCursor][0] = ' '; break;
					default:   memset(param,' ',strlen(param)); break;
					}
				}
				sprintf(str,"%s_%s%s%s%s%s%s (%s)",type,num[5],num[4],num[3],num[2],num[1],num[0],param);
				pMenuItem = str;
			}
//			const SK7PanelDebugMenuTable	*pTable = SK7PanelBase::GetDebugMenuTable(mPanelID);
//			if( GameInfo.GetMode()==WK7GameInfo::PANELMODE ){
//				pMenuItem = "---";
//			}else{
//				if( pTable==NULL ){
//					sprintf(str,"%d (%d)",(int)mPanelID,mPanelParam);
//					pMenuItem = str;
//				}else{
//					sprintf(str,"%s (%d)",pTable->m_pMenuName,mPanelParam);
//					pMenuItem = str;
////					pMenuItem = pTable->m_pMenuName;
//				}
//			}
#endif
			pMenuItemName = "Call Panel";
			}break;
		default:
			pMenuItemName = "GameExit";
			pMenuItem     = "";
			break;
		}
		PRINTF("  %s %-20s : %s\n",(mEditCursor==c? ">" : " "),pMenuItemName,pMenuItem);
	}
	
	return true;
}

bool WK7MainMenu::FrameProcess(void)
{
	mMask.FrameProcess();
	
//#ifdef	_DEBUG
	if( mActive==false ){
		if( WK7Stage::IsChanging()==true ){
			return true;
		}
		if( (WK7MAINMENU_PADTRIGGER & HSD_PAD_START) &&
		    (WK7MAINMENU_PADBUTTON  & HSD_PAD_RIGHT) ){
//		    (WK7MAINMENU_PADBUTTON  & HSD_PAD_X    ) ){
//		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_START ){
			SetActive(true);
			SetMode(TOPMENU);
			mPanelParam = GameInfo.GetPanelResult();
			// ݂̃Lhc擾
			mChangeCharaID = (s32 )WK7PLAYERCONTROL->GetMainID();
			if ( mChangeCharaID < 0 ) mChangeCharaID = 0;
			if ( mChangeCharaID >= K7PCMAX ) mChangeCharaID = (K7PCMAX-1);
		}
		return true;
	}
	
	if( mpFrameProcessTaskController==NULL ){
//	if( GameInfo.GetScenarioID()!=K7SCN99 || mpFrameProcessTaskController==NULL ){
		mEnableStageChange = false;
	}else{
		mEnableStageChange = true;
	}
	switch( mMode ){
	case	TOPMENU:
		FrameProcessTopMenu();
		break;
	case	VAREDIT:
		FrameProcessVarEdit();
		break;
	case	FLAGEDIT:
		FrameProcessFlagEdit();
		break;
	case	GVAREDIT:
		FrameProcessGVarEdit();
		break;
	case	GFLAGEDIT:
		FrameProcessGFlagEdit();
		break;
	case	ITEMEDIT:
		FrameProcessItemEdit();
		break;
	case	PLAYEDIT:
		FrameProcessPlayEdit();
		break;
	case	PATHCHANGE:
		FrameProcessPathChange();
		break;
	case	CHARAPRESENT:
		FrameProcessCharaPresent();
		break;
	case	HIERARCHY:
		FrameProcessHierarchy();
		break;
	case	AUTOPARAM:
		FrameProcessAutoparam();
		break;
	case	CHANGEFLOW:
		FrameProcessChangeFlow();
		break;
	case	DUMPSTAGEINFO:
		FrameProcessDumpStageInfo();
		break;
	default:
		break;
	}
//#endif
	return true;
}

bool WK7MainMenu::RenderAlpha(void)
{
	Mtx				view;
	Mtx44			proj;
	GXTexObj		*pTexObj;
	
	if( (pTexObj = screenImageFullColor.GetTexObj())==NULL ){
		return false;
	}
	
	WK7Cam::Set2DMatrix(view,proj,0.0f,1024.0f);
	
	// [Jr[ϊ}gNXݒ
	GXLoadPosMtxImm (view,GX_PNMTX0);
	GXLoadNrmMtxImm (view,GX_PNMTX0);
	GXSetCurrentMtx (GX_PNMTX0);
	GXSetProjection (proj,GX_ORTHOGRAPHIC);
	
	HSD_RectU16		sc_rect;
	WK7CAM->GetScissor(sc_rect);
	GXSetScissor    (sc_rect.xmin,sc_rect.ymin,(u32)(sc_rect.xmax-sc_rect.xmin),(u32)(sc_rect.ymax-sc_rect.ymin));
	GXSetViewport   (0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);
	
	GXLoadTexObj    (pTexObj,GX_TEXMAP0);
	
	GXSetAlphaCompare (GX_ALWAYS,0xff,GX_AOP_OR,GX_ALWAYS,0xff);
	GXSetNumChans     (1);
	GXSetChanCtrl     (GX_COLOR0A0,GX_FALSE,GX_SRC_VTX,GX_SRC_VTX,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
	GXSetBlendMode    (GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetCullMode     (GX_CULL_NONE);
	GXSetDither       (GX_FALSE);
	GXSetDstAlpha     (GX_FALSE,0);
	
	GXClearVtxDesc   ();
	GXSetVtxDesc     (GX_VA_POS , GX_DIRECT );
	GXSetVtxDesc     (GX_VA_CLR0, GX_DIRECT );
	GXSetVtxDesc     (GX_VA_TEX0, GX_DIRECT );
	
	GXSetVtxAttrFmt  (GX_VTXFMT0 , GX_VA_POS  , GX_POS_XYZ  , GX_F32   , 0);
	GXSetVtxAttrFmt  (GX_VTXFMT0 , GX_VA_CLR0 , GX_CLR_RGBA , GX_RGBA8 , 0);
	GXSetVtxAttrFmt  (GX_VTXFMT0 , GX_VA_TEX0 , GX_TEX_ST   , GX_F32   , 0);
	
	GXSetNumTexGens  (1);
	GXSetTexCoordGen (GX_TEXCOORD0,GX_TG_MTX2x4,GX_TG_TEX0,GX_IDENTITY);
	
	GXSetNumTevStages(1);
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR0A0);
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_RASC,GX_CC_TEXA,GX_CC_ZERO);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	
	GXSetZMode        (GX_FALSE,GX_ALWAYS,GX_FALSE);
	GXSetColorUpdate  (GX_TRUE);
	GXSetAlphaUpdate  (GX_FALSE);
	
	GXBegin(GX_TRIANGLEFAN,GX_VTXFMT0,4);
	
static	u32		color = 0xffffffff;
	GXPosition3f32(0.0f,0.0f,1.0f);
	GXColor1u32   (color);
	GXTexCoord2f32(0.0f,0.0f);
	
	GXPosition3f32(WK7_SCREEN_WIDTH,0.0f,1.0f);
	GXColor1u32   (color);
	GXTexCoord2f32(1.0f,0.0f);
	
	GXPosition3f32(WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,1.0f);
	GXColor1u32   (color);
	GXTexCoord2f32(1.0f,1.0f);
	
	GXPosition3f32(0.0f,WK7_SCREEN_HEIGHT,1.0f);
	GXColor1u32   (color);
	GXTexCoord2f32(0.0f,1.0f);
	
	GXEnd();
	
	return true;
}

#define	PACKMAN_NUM			(50)

bool WK7MainMenu::RenderProcess(void)
{
	if( mDispPerfInfo==true ){
		C_Paper		paper(24,420);
		PRINTF("%d,%d\n",ghmGcPerf::GetRenderEventCycleMax(),ghmGcPerf::GetProcEventCycleMax());
	}
	if( mModeInfo==true ){
		C_Paper		paper(24,436);
		int			i;
		char		str[PACKMAN_NUM + 1];
		const char	*pstr;
		
//		if( mModeDisp ){
			switch( GameInfo.GetMode() ){
			case	WK7GameInfo::INIT:         pstr = "Init"; break;
			case	WK7GameInfo::MOVE:         pstr = "Move"; break;
			case	WK7GameInfo::MOVECAM:      pstr = "MoveCam"; break;
			case	WK7GameInfo::BATTLE:       pstr = "Battle"; break;
			case	WK7GameInfo::PLAY:         pstr = "Play"; break;
			case	WK7GameInfo::ITEMMODE:     pstr = "Item"; break;
			case	WK7GameInfo::PANELMODE:    pstr = "Panel"; break;
			case	WK7GameInfo::HATOMEMOMODE: pstr = "HatoMemo"; break;
			case	WK7GameInfo::MOON:         pstr = "Moon"; break;
			case	WK7GameInfo::MAP:          pstr = "Map"; break;
			case	WK7GameInfo::MENUMAP:      pstr = "MenuMap"; break;
			case	WK7GameInfo::STAGETITLE:   pstr = "StageTitle"; break;
			case	WK7GameInfo::ZAN:          pstr = "Zan"; break;
			case	WK7GameInfo::SPMENU:       pstr = "SpMenu"; break;
			case	WK7GameInfo::DIE:          pstr = "Die"; break;
			case	WK7GameInfo::SAVE:         pstr = "Save"; break;
			case	WK7GameInfo::TERM:         pstr = "Term"; break;
			default:                           pstr = "Unknown"; break;
			}
//		}else{
//			pstr = "";
//		}
		
		for(i=0 ; i<PACKMAN_NUM ; i++){
			if( i<mPackManCursor ){
				str[i] = '.';
//				str[i] = ' ';
			}else if( i==mPackManCursor ){
				if( mPackManID ){
					str[i] = 'C';
				}else{
					str[i] = 'c';
				}
			}else{
				str[i] = 'o';
//				str[i] = '.';
			}
		}
		str[i] = '\0';
		PRINTF("%s : %s\n",str,pstr);
		
		if( mPackManBlink <= 0 ){
			mPackManBlink = 10;
			mPackManID ^= 1;
			if( mPackManID ){
				mPackManCursor++;
				if( mPackManCursor >= PACKMAN_NUM ){
					mPackManCursor  = 0;
				}
			}
		}else{
			mPackManBlink--;
		}
		
		if( mModeBlink <= 0 ){
			mModeBlink = 30;
			mModeDisp ^= 1;
		}else{
			mModeBlink--;
		}
		
	}
	
	if( mDispAlpha==true ){
		RenderAlpha();
	}
	
	mMask.RenderProcess();
	
//#ifdef	_DEBUG
	
	if( mActive==true ){
		C_Paper		paper(0,0,0.75f);
		const char	*pTitle;
		char		stageID[16];
		WK7Stage	*pStage;
		if( mpTitle==NULL ){
			pTitle = "---";
		}else{
			pTitle = mpTitle;
		}
		if( (pStage = WK7Stage::GetCurrentStage())!=NULL ){
			u32		mainid = K7STG_MAINID(pStage->GetID());
			u32		suffix = K7STG_SUFFIX(pStage->GetID());
			sprintf(stageID,"Stage%03dM%02d",mainid,suffix);
		}else{
			strcpy(stageID,"---");
		}
		PRINTF("\n\n  K7 Debug Menu : %s [%s]:%08x,%08x\n\n",pTitle,stageID,K7AppSmallMemGetFreeSize(),ghmGcMemGetFreeSize());
		switch( mMode ){
		case	TOPMENU:
			RenderProcessTopMenu();
			break;
		case	VAREDIT:
			RenderProcessVarEdit();
			break;
		case	FLAGEDIT:
			RenderProcessFlagEdit();
			break;
		case	GVAREDIT:
			RenderProcessGVarEdit();
			break;
		case	GFLAGEDIT:
			RenderProcessGFlagEdit();
			break;
		case	ITEMEDIT:
			RenderProcessItemEdit();
			break;
		case	PLAYEDIT:
			RenderProcessPlayEdit();
			break;
		case	PATHCHANGE:
			RenderProcessPathChange();
			break;
		case	CHARAPRESENT:
			RenderProcessCharaPresent();
			break;
		case	HIERARCHY:
			RenderProcessHierarchy();
			break;
		case	AUTOPARAM:
			RenderProcessAutoparam();
			break;
		case	CHANGEFLOW:
			RenderProcessChangeFlow();
			break;
		case	DUMPSTAGEINFO:
			RenderProcessDumpStageInfo();
			break;
		default:
			break;
		}
	}
	
	if( true==mDispCamPos || true==mFollowCamEdit ){
		CameraInfoDisp();
	}
	
//#endif
	return true;
}

#define	CAMMENU_INTERVAL		(4)
#define	CAMMENU_FONTSIZE		(18)
void WK7MainMenu::CameraInfoDisp(void)
{
	Vec					campos,camtgt;
	int					y;
	
	WK7CAM->GetTargetPosition(camtgt);
	WK7CAM->GetPosition(campos);
	
	y = 24;
	{
		C_Paper				paper(470,y,0.75f);
		PRINTF("Camera Information\n\n");
		y += CAMMENU_FONTSIZE + CAMMENU_INTERVAL;
	}
	
	{
		C_Paper				paper(480,y,0.75f);
		PRINTF(" TX %.3f\n",camtgt.x);
		PRINTF(" TY %.3f\n",camtgt.y);
		PRINTF(" TZ %.3f\n",camtgt.z);
		PRINTF(" EX %.3f\n",campos.x);
		PRINTF(" EY %.3f\n",campos.y);
		PRINTF(" EZ %.3f\n",campos.z);
		y += CAMMENU_FONTSIZE * 6 + CAMMENU_INTERVAL;
	}
	{
		C_Paper				paper(480,y,0.75f);
		PRINTF(" TD %.3f\n",WK7CAM->GetTargetDistance());
		PRINTF(" SP %.3f\n",WK7CAM->GetCameraMoveSpeed());
		PRINTF(" N  %.3f\n",WK7CAM->GetNear());
		PRINTF(" F  %.3f\n",WK7CAM->GetFar());
		PRINTF(" FV %.3f\n",WK7CAM->GetFov());
		
		Vec dir;
		dir.x = camtgt.x - campos.x;
		dir.z = camtgt.z - campos.z;
		dir.y = atan2f((f32 )dir.x, (f32 )dir.z);
		dir.x = atan2f(	camtgt.y - campos.y,
									sqrtf((camtgt.x-campos.x)*(camtgt.x-campos.x)+(camtgt.z-campos.z)*(camtgt.z-campos.z))
									);
		
		PRINTF(" CY %.3f\n",dir.y);
		PRINTF(" CX %.3f\n",dir.x);
		
		y += CAMMENU_FONTSIZE * 6 + CAMMENU_INTERVAL;
	}
	{
		C_Paper				paper(480,y,0.75f);
		Vec pPos;
		f32 roty;
		WK7PLAYERCONTROL->GetPosition(&pPos);
		WK7PLAYERCONTROL->GetRotY(&roty);
		PRINTF(" PX %.3f\n",pPos.x);
		PRINTF(" PY %.3f\n",pPos.y);
		PRINTF(" PZ %.3f\n",pPos.z);
		PRINTF(" RY %.3f\n",roty);
		y += CAMMENU_FONTSIZE * 4 + CAMMENU_INTERVAL;
	}
	
	{
		C_Paper				paper(480,y,0.75f);
		PRINTF(" FD %.3f\n",WK7CAMPATHFOLLOWINFO->GetCurrentApproachLimitDist());
		PRINTF(" PH %.3f\n",WK7CAMPATHFOLLOWINFO->GetCurrentPosH             ());
		PRINTF(" PV %.3f\n",WK7CAMPATHFOLLOWINFO->GetCurrentPosV             ());
		PRINTF(" TF %.3f\n",WK7CAMPATHFOLLOWINFO->GetCurrentTgtF             ());
		PRINTF(" TH %.3f\n",WK7CAMPATHFOLLOWINFO->GetCurrentTgtH             ());
		PRINTF(" TV %.3f\n",WK7CAMPATHFOLLOWINFO->GetCurrentTgtV             ());
		y += CAMMENU_FONTSIZE * 6 + CAMMENU_INTERVAL;
	}
	
	if( WK7CAM->IsDebugMode()==true ){
		if( HSD_PadGetTrigger(1)==HSD_PAD_A ){
			OSReport("%.3ff, %.3ff, %.3ff, %.3ff, %.3ff, %.3ff\n",campos.x,campos.y,campos.z,camtgt.x,camtgt.y,camtgt.z);
		}
		if( HSD_PadGetTrigger(1)==HSD_PAD_B ){
			OSReport("{{%.3ff, %.3ff, %.3ff},{%.3ff, %.3ff, %.3ff}},\n",camtgt.x,camtgt.y,camtgt.z,campos.x,campos.y,campos.z);
		}
	}else if( mFollowCamEdit==true ){
		if( HSD_PadGetTrigger(1)==HSD_PAD_A ){
			OSReport("WK7CAMSET_DECL_CHR(%.3ff, %.3ff, %.3ff, %.3ff, %.3ff, %.3ff)\n",
			         WK7CAMPATHFOLLOWINFO->GetCurrentApproachLimitDist(),
			         WK7CAMPATHFOLLOWINFO->GetCurrentPosH             (),
			         WK7CAMPATHFOLLOWINFO->GetCurrentPosV             (),
			         WK7CAMPATHFOLLOWINFO->GetCurrentTgtF             (),
			         WK7CAMPATHFOLLOWINFO->GetCurrentTgtH             (),
			         WK7CAMPATHFOLLOWINFO->GetCurrentTgtV             ());
		}
	}
}

bool WK7MainMenu::FrameProcessHierarchy(void)
{
	if( WK7MAINMENU_PADREPEAT & (HSD_PAD_B|HSD_PAD_START) ){
		SetMode(TOPMENU);
		return true;
	}
	WK7Stage	*pStage = WK7Stage::GetCurrentStage();
	if( pStage==NULL ){
		SetMode(TOPMENU);
		return false;
	}
	if( !(WK7MAINMENU_PADBUTTON & HSD_PAD_Z) ){
		WK7JObj		*pJObj;
		WK7Model	*pModel;
		WK7Model	*pPathModel;
		pModel     = pStage->GetModel();
		pPathModel = pStage->GetPathModel();
		if( mpCurrentJObj==NULL ){
			WK7Model	*pModel;
			if( (pModel=pStage->GetModel())==NULL ){
				return false;
			}
			if( (mpCurrentJObj = pModel->GetTopObj())==NULL ){
				if( (mpCurrentJObj = pPathModel->GetTopObj())==NULL ){
					SetMode(TOPMENU);
					return false;
				}
			}
		}
		if( WK7MAINMENU_PADBUTTON & HSD_PAD_A ){
			if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
				Vec		pos,tgt,dir;
				WK7CAM->GetPosition      (pos);
				WK7CAM->GetTargetPosition(tgt);
				VECSubtract(&tgt,&pos,&dir);
				mpCurrentJObj->GetWorldPosition(&tgt);
				VECSubtract(&tgt,&dir,&pos);
				WK7CAM->SetPosition      (pos);
				WK7CAM->SetTargetPosition(tgt);
				return true;
			}
			if( WK7MAINMENU_PADTRIGGER & HSD_PAD_UP ){
				mpCurrentJObj->Disp(false,true);
			}
			if( WK7MAINMENU_PADTRIGGER & HSD_PAD_DOWN ){
				mpCurrentJObj->Hide(false,true);
			}
			return false;
		}
		if( WK7MAINMENU_PADTRIGGER & HSD_PAD_Y ){
			if( mpCurrentJObj->IsHidden()==true ){
				mpCurrentJObj->Disp(false,false);
			}else{
				mpCurrentJObj->Hide(false,false);
			}
		}
		if( WK7MAINMENU_PADREPEAT & HSD_PAD_UP ){
			if( mpCurrentJObj->GetPrev()!=NULL ){
				mpCurrentJObj = mpCurrentJObj->GetPrev();
			}else{
				if( mpCurrentJObj->GetParent()==NULL ){
					if( pModel!=NULL && (pJObj = pModel->GetTopObj())!=NULL && pJObj!=mpCurrentJObj ){
						for( ; pJObj->GetNext()!=NULL ; pJObj=pJObj->GetNext()){}
						mpCurrentJObj = pJObj;
					}
				}else{
					for(pJObj=mpCurrentJObj->GetParent() ; pJObj!=NULL ; pJObj=pJObj->GetParent()){
						if( pJObj->GetPrev()!=NULL ){
							mpCurrentJObj = pJObj->GetPrev();
							break;
						}
					}
				}
			}
		}
		if( WK7MAINMENU_PADREPEAT & HSD_PAD_DOWN ){
			if( mpCurrentJObj->GetNext()!=NULL ){
				mpCurrentJObj = mpCurrentJObj->GetNext();
			}else{
				if( mpCurrentJObj->GetParent()==NULL ){
					if( pPathModel!=NULL && (pJObj = pPathModel->GetTopObj())!=NULL ){
						if( mpCurrentJObj!=pJObj ){
							mpCurrentJObj = pJObj;
						}else if( pJObj->GetNext()!=NULL ){
							mpCurrentJObj = pJObj->GetNext();
						}else if( pJObj->GetChild()!=NULL ){
							mpCurrentJObj = pJObj->GetChild();
						}
					}
				}else{
					for(pJObj=mpCurrentJObj->GetChild() ; pJObj!=NULL ; pJObj=pJObj->GetChild()){
						if( pJObj->GetNext()!=NULL ){
							mpCurrentJObj = pJObj->GetNext();
							break;
						}
					}
					if( pJObj==NULL ){
						for(pJObj=mpCurrentJObj->GetParent() ; pJObj!=NULL ; pJObj=pJObj->GetParent()){
							if( pJObj->GetNext()!=NULL ){
								mpCurrentJObj = pJObj->GetNext();
								break;
							}
						}
					}
				}
			}
		}
		if( WK7MAINMENU_PADREPEAT & HSD_PAD_RIGHT ){
			if( mpCurrentJObj->GetChild()!=NULL ){
				mpCurrentJObj = mpCurrentJObj->GetChild();
			}else{
				for(pJObj=mpCurrentJObj->GetNext() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
					if( pJObj->GetChild()!=NULL ){
						mpCurrentJObj = pJObj->GetChild();
						break;
					}
				}
				if( pJObj==NULL ){
					for(pJObj=mpCurrentJObj->GetPrev() ; pJObj!=NULL ; pJObj=pJObj->GetPrev()){
						if( pJObj->GetChild()!=NULL ){
							mpCurrentJObj = pJObj->GetChild();
							break;
						}
					}
				}
			}
		}
		if( WK7MAINMENU_PADREPEAT & HSD_PAD_LEFT ){
			if( mpCurrentJObj->GetParent()!=NULL ){
				mpCurrentJObj = mpCurrentJObj->GetParent();
			}else{
				for(pJObj=mpCurrentJObj->GetPrev() ; pJObj!=NULL ; pJObj=pJObj->GetPrev()){
					if( pJObj->GetParent()!=NULL ){
						mpCurrentJObj = pJObj->GetParent();
						break;
					}
				}
			}
		}
	}
	WK7CAM->FrameProcess();
	return false;
}



#define	HIERARCHY_SIZE		(16)
#define	HIERARCHY_INTERVAL	(4)
//#define	HIERARCHY_SIZE		(24)
//#define	HIERARCHY_INTERVAL	(8)
#define	HIERARCHY_RIGHT_LIMIT	(240)
#define	HIERARCHY_BOTTOM_LIMIT	(320)
//#define	HIERARCHY_RIGHT_LIMIT	(320)
//#define	HIERARCHY_BOTTOM_LIMIT	(440)
bool WK7MainMenu::CalcTopHierarchy(WK7JObj *pJObj,ghmGcSpriteF *psprite)
{
	if( pJObj==NULL ){
		return false;
	}
	if( pJObj==mpCurrentJObj ){
		if( psprite->mTop + psprite->mHeight > HIERARCHY_BOTTOM_LIMIT ){
			psprite->mTop = (short)(HIERARCHY_BOTTOM_LIMIT - psprite->mHeight - psprite->mTop);
		}
		if( psprite->mLeft + psprite->mWidth > HIERARCHY_RIGHT_LIMIT ){
			psprite->mLeft = (short)(HIERARCHY_RIGHT_LIMIT - psprite->mWidth - psprite->mLeft);
		}
		return true;
	}
	if( pJObj->GetChild()!=NULL ){
		psprite->mLeft += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
		if( CalcTopHierarchy(pJObj->GetChild(),psprite)==true ){
			return true;
		}
		psprite->mLeft -= HIERARCHY_SIZE + HIERARCHY_INTERVAL;
	}
	WK7JObj	*pNextJObj;
	if( pJObj->GetPrev()==NULL && (pNextJObj=pJObj->GetNext())!=NULL ){
		for( ; pNextJObj!=NULL ; pNextJObj=pNextJObj->GetNext()){
			psprite->mTop += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
			if( CalcTopHierarchy(pNextJObj,psprite)==true ){
				return true;
			}
		}
	}
	return false;
}

bool WK7MainMenu::RenderProcessHierarchy(WK7JObj *pJObj,ghmGcSpriteF *psprite)
{
	if( pJObj==NULL ){
		return true;
	}
	
	short	ctop;
	
	if( pJObj==mpCurrentJObj ){
		C_Paper		paper(320,32,0.75f);
		
		HSD_JObj	*pHSDJObj = pJObj->GetJObj();
		HSD_DObj	*pHSDDObj;
		char		str[256] = "";
		
		PRINTF("\n\n");
		
		PRINTF("[%s]\n",pJObj->GetName());
		PRINTF("TR %.3f,%.3f,%.3f\n",pHSDJObj->translate.x,pHSDJObj->translate.y,pHSDJObj->translate.z);
		PRINTF("RT %.3f,%.3f,%.3f\n",pHSDJObj->rotate   .x,pHSDJObj->rotate   .y,pHSDJObj->rotate   .z);
		if( pHSDJObj->scale.x!=1.0f ||
		    pHSDJObj->scale.y!=1.0f ||
		    pHSDJObj->scale.z!=1.0f ){
			PRINTF("SC %.3f,%.3f.%.3f\n",pHSDJObj->scale.x,pHSDJObj->scale.y,pHSDJObj->scale.z);
		}
		if( pHSDJObj->aobj!=NULL ){
			strcat(str,"Anim ");
		}
		if( pHSDJObj->flags & JOBJ_HIDDEN ){
			strcat(str,"Hide ");
		}
		if( pHSDJObj->flags & JOBJ_ENVELOPE_MODEL ){
			strcat(str,"Skin ");
		}
		if( pHSDJObj->flags & JOBJ_XLU ){
			strcat(str,"SemiTrans ");
		}
		if( pHSDJObj->flags & JOBJ_TEXEDGE ){
			strcat(str,"AlphaZero ");
		}
		if( strlen(str) > 0 ){
			PRINTF("%s\n",str);
		}
		int			mtcnt = 0;
		pHSDDObj = HSD_JObjGetDObj(pHSDJObj);
		while( pHSDDObj!=NULL ){
			mtcnt++;
			pHSDDObj = pHSDDObj->next;
		}
		PRINTF("MT %d\n",mtcnt);
		pHSDDObj = HSD_JObjGetDObj(pHSDJObj);
		while( pHSDDObj!=NULL ){
			PRINTF("   %s\n",pJObj->GetDObjName(pHSDDObj));
			pHSDDObj = pHSDDObj->next;
		}
		
		psprite->mColor.r = 0xff;
		psprite->mColor.g = 0x00;
		psprite->mColor.b = 0x00;
		psprite->mColor.a = 0xff;
	}else{
		psprite->mColor.r = 0xc0;
		psprite->mColor.g = 0xc0;
		psprite->mColor.b = 0xc0;
		psprite->mColor.a = 0x80;
	}
	
	psprite->Render();
	ctop = psprite->mTop;
	
	if( pJObj->GetChild()!=NULL ){
		ghmGcLineF2		line;
		line.mColor32 = 0xc0c0c080;
		line.mLayer   = 0;
		line.mPos[0].mX = (short)(psprite->mLeft + HIERARCHY_SIZE);
		line.mPos[0].mY = (short)(psprite->mTop  + psprite->mHeight / 2);
		line.mPos[1].mX = (short)(line.mPos[0].mX + HIERARCHY_INTERVAL);
		line.mPos[1].mY = line.mPos[0].mY;
		line.Render();
		psprite->mLeft += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
		RenderProcessHierarchy(pJObj->GetChild(),psprite);
		psprite->mLeft -= HIERARCHY_SIZE + HIERARCHY_INTERVAL;
	}
	
	WK7JObj	*pNextJObj;
	if( pJObj->GetPrev()==NULL && (pNextJObj=pJObj->GetNext())!=NULL ){
		for( ; pNextJObj!=NULL ; pNextJObj=pNextJObj->GetNext()){
			ghmGcLineF2		line;
			psprite->mTop  += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
			line.mColor32 = 0xc0c0c080;
			line.mPos[0].mX = (short)(psprite->mLeft + psprite->mWidth / 2);
			line.mPos[0].mY = (short)(ctop  + HIERARCHY_SIZE);
			line.mPos[1].mX = line.mPos[0].mX;
			line.mPos[1].mY = psprite->mTop;
			line.mLayer   = 0;
			line.Render();
			ctop = psprite->mTop;
			if( RenderProcessHierarchy(pNextJObj,psprite)==false ){
				return false;
			}
		}
	}
	
	return true;
}

bool WK7MainMenu::RenderProcessHierarchy(void)
{
	WK7Stage	*pStage = WK7Stage::GetCurrentStage();
	WK7Model	*pModel;
	WK7Model	*pPathModel;
	if( pStage==NULL || (pModel=pStage->GetModel())==NULL || pModel->GetTopObj()==NULL ){
		return false;
	}
	pPathModel = pStage->GetPathModel();
	
	ghmGcSpriteF	sprite;
	sprite.mLeft   = 32;
	sprite.mTop    = 32;
	sprite.mWidth  = HIERARCHY_SIZE;
	sprite.mHeight = HIERARCHY_SIZE;
	sprite.mLayer  = 0;
	CalcTopHierarchy(pModel->GetTopObj(),&sprite);
	if( pPathModel!=NULL ){
		CalcTopHierarchy(pPathModel->GetTopObj(),&sprite);
	}
	if( sprite.mLeft < 0 ){
		sprite.mLeft += 32;
	}else{
		sprite.mLeft  = 32;
	}
	if( sprite.mTop  < 0 ){
		sprite.mTop  += 32;
	}else{
		sprite.mTop   = 32;
	}
	short	ctop = (short)(sprite.mTop + HIERARCHY_SIZE + HIERARCHY_INTERVAL);
	GXSetLineWidth(12,GX_TO_ZERO);
	ghmGcSprite::RenderStart();
	RenderProcessHierarchy(pModel->GetTopObj(),&sprite);
	if( pPathModel!=NULL ){
		ghmGcLineF2		line;
		if( pModel->GetTopObj()!=NULL ){
			sprite.mTop  += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
		}
		line.mColor32 = 0xc0c0c080;
		line.mPos[0].mX = (short)(sprite.mLeft + sprite.mWidth / 2);
		line.mPos[0].mY = (short)(ctop + HIERARCHY_SIZE);
		line.mPos[1].mX = line.mPos[0].mX;
		line.mPos[1].mY = sprite.mTop;
		line.mLayer   = 0;
		line.Render();
		RenderProcessHierarchy(pPathModel->GetTopObj(),&sprite);
	}
	ghmGcSprite::RenderEnd();
	
	return true;
}


bool WK7MainMenu::FrameProcessAutoparam(void)
{
	if( FrameProcessEdit()==false ){
		return false;
	}
	
#ifdef	_DEBUG
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		// ݒ֐R[
		WK7PLAYERCONTROL->StageParamSet((int )mEditCursor);
		SetMode(TOPMENU);
		return true;
	}
#endif
	
	return true;
}

static char *pTitle[] = {
	"Def Ampoule",
	"Type A Param Set",
	"Randam",
	NULL
};
bool WK7MainMenu::RenderProcessAutoparam(void)
{
#ifdef	_DEBUG
	int				flagnum,i, c;
	const char		*pCursor;
	
	for(flagnum=0 ; pTitle[flagnum]!=NULL ; flagnum++){}
	
	i = mEditID - mEditCursor;
	
	for(c=0 ; c<DISPMAX && i<flagnum ; c++,i++){
		if( c==mEditCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		PRINTF("%s %-30s\n",pCursor,pTitle[i]);
	}
	
#endif
	return true;
}


bool WK7MainMenu::FrameProcessChangeFlow(void)
{
	switch( mChangeFlowProc ){
	case	0:
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( mOldFlow != GameInfo.GetScenarioFlow() ){
				mChangeFlowProc++;
				break;
			}
			SetMode(TOPMENU);
			return true;
		}
		K7ScenarioFlow	flow = GameInfo.GetScenarioFlow();
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_RIGHT|HSD_PAD_RIGHT) ){
			flow = (K7ScenarioFlow)((int)flow + 1);
		}
		if( WK7MAINMENU_PADTRIGGER & (HSD_PAD_STICK_LEFT |HSD_PAD_LEFT ) ){
			flow = (K7ScenarioFlow)((int)flow - 1);
		}
		if( flow < K7SCNF_CEL ){
			flow = K7SCNF_GNK;
		}else if( flow > K7SCNF_GNK ){
			flow = K7SCNF_CEL;
		}
		if( GameInfo.GetScenarioFlow()!=flow ){
			GameInfo.SetScenarioFlow(flow);
		}
		return true;
	case	1:
		if( WK7Stage::ReleaseStageArchive()==false ){
			break;
		}
		mChangeFlowProc++;
		break;
	case	2:
		if( WK7Stage::IsReleasedStageArchive()==false ){
			break;
		}
		WK7EVENTCONTROLLER->ReleaseTempData3();
		mChangeFlowProc++;
		break;
	case	3:
		if( WK7EVENTCONTROLLER->IsReleasedTempData3()==false ){
			break;
		}
		WK7EVENTCONTROLLER->LoadData();
		mChangeFlowProc++;
		break;
	case	4:
		if( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			break;
		}
		mChangeFlowProc++;
		break;
	case	5:
		if( WK7Stage::RestoreStageArchive()==false ){
			break;
		}
		mChangeFlowProc++;
		break;
	case	6:
		if( WK7Stage::IsRestoredStageArchive()==false ){
			break;
		}
		mChangeFlowProc = 0;
		mOldFlow = GameInfo.GetScenarioFlow();
	default:
		SetMode(TOPMENU);
		return true;
	}
	return true;
}

bool WK7MainMenu::RenderProcessChangeFlow(void)
{
	C_Paper		paper(24,64);
	
	PRINTF("Scenario Flow : %s\n",GetFlowName());
	
	return true;
}

bool WK7MainMenu::FrameProcessDumpStageInfo(void)
{
	if( mpDumpStageInfo==NULL ){
		WK7Stage	*pCurrentStage = WK7Stage::GetCurrentStage();
		if( pCurrentStage!=NULL && (mpDumpStageInfo=pCurrentStage->GetStageInfo())!=NULL ){
			mpDumpStageInfo->mPad0 = 0;
			if( mpDumpStageInfo->mHarmanRoomNum != (u8)pCurrentStage->GetHarmanRoomNum() ||
			    mpDumpStageInfo->mSelectObjNum  != (u8)pCurrentStage->GetSelectObjNum () ||
			    mpDumpStageInfo->mSelectPathNum != (u8)pCurrentStage->GetSelectPathNum() ){
				mpDumpStageInfo->mPad0 = 1;
				mpDumpStageInfo->mHarmanRoomNum = (u8)pCurrentStage->GetHarmanRoomNum();
				mpDumpStageInfo->mSelectObjNum  = (u8)pCurrentStage->GetSelectObjNum ();
				mpDumpStageInfo->mSelectPathNum = (u8)pCurrentStage->GetSelectPathNum();
			}
			mCurrentStageID = pCurrentStage->GetID();
		}
		mpDumpStageInfo    = stageList;
		mDumpStageInfoProc = 16;
		mpOldCreateStageFunc = WK7Stage::GetCreateStageFunc();
		WK7Stage::SetCreateStageFunc(NULL);
	}
	if( mpDumpStageInfo->mID==0xffffffff ){
		if( mDumpStageInfoProc < 16 ){
			mDumpStageInfoProc = 32;
		}
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		// LZ
		if( mDumpStageInfoProc < 16 ){
			mDumpStageInfoProc = 32;
		}
	}
	switch( mDumpStageInfoProc ){
	case	16:
		if( WK7Stage::ReleaseStageArchive()==false ){
			break;
		}
		mDumpStageInfoProc++;
		break;
	case	17:
		if( WK7Stage::IsReleasedStageArchive()==false ){
			break;
		}
		mDumpStageInfoProc = 0;
		break;
	case	32:
		for(mpDumpStageInfo=stageList ; mpDumpStageInfo->mID!=0xffffffff ; mpDumpStageInfo++){
			if( mpDumpStageInfo->mPad0 < 0 ){
				OSDebugReport("%03d_M%02d Not Found\n"  ,K7STG_MAINID(mpDumpStageInfo->mID),
				                                         K7STG_SUFFIX(mpDumpStageInfo->mID));
			}else if( mpDumpStageInfo->mPad0 > 0 ){
				OSDebugReport("%03d_M%02d,%2d,%3d,%3d\n",K7STG_MAINID(mpDumpStageInfo->mID),
				                                         K7STG_SUFFIX(mpDumpStageInfo->mID),
				                                         mpDumpStageInfo->mHarmanRoomNum,
				                                         mpDumpStageInfo->mSelectObjNum ,
				                                         mpDumpStageInfo->mSelectPathNum);
			}
		}
		if( WK7Stage::RestoreStageArchive()==false ){
			break;
		}
		mDumpStageInfoProc++;
		break;
	case	33:
		if( WK7Stage::IsRestoredStageArchive()==false ){
			break;
		}
		WK7Stage::SetCreateStageFunc(mpOldCreateStageFunc);
		mDumpStageInfoProc   = -1;
		mpOldCreateStageFunc = NULL;
		mpDumpStage          = NULL;
		mCurrentStageID      = 0xffffffff;
		SetMode(TOPMENU);
		return true;
	case	0:
		if( mCurrentStageID==mpDumpStageInfo->mID ){
			mpDumpStageInfo++;
			break;
		}
		mpDumpStageInfo->mPad0 = 0;
		if( (mpDumpStage=WK7RenderObj::CreateStage(mpDumpStageInfo->mID))==NULL ){
			mpDumpStageInfo->mPad0 = -1;
			mpDumpStageInfo++;
			break;
		}
		mDumpStageInfoProc++;
		break;
	case	1:
		if( mpDumpStage->GetState()!=WK7RenderObj::LOADED ){
			break;
		}
		mDumpStageInfoProc++;
		break;
	case	2:
		{
			char	str[128];
			sprintf(str,"%03d_M%02d,%2d,%3d,%3d",K7STG_MAINID(mpDumpStageInfo->mID),
			                                     K7STG_SUFFIX(mpDumpStageInfo->mID),
			                                     mpDumpStage->GetHarmanRoomNum(),
			                                     mpDumpStage->GetSelectObjNum (),
			                                     mpDumpStage->GetSelectPathNum());
//			OSDebugReport("%s\n",str);
			K7AppDebugPrint(str);
			if( mpDumpStageInfo->mHarmanRoomNum != (u8)mpDumpStage->GetHarmanRoomNum() ||
			    mpDumpStageInfo->mSelectObjNum  != (u8)mpDumpStage->GetSelectObjNum () ||
			    mpDumpStageInfo->mSelectPathNum != (u8)mpDumpStage->GetSelectPathNum() ){
				mpDumpStageInfo->mPad0 = 1;
				mpDumpStageInfo->mHarmanRoomNum = (u8)mpDumpStage->GetHarmanRoomNum();
				mpDumpStageInfo->mSelectObjNum  = (u8)mpDumpStage->GetSelectObjNum ();
				mpDumpStageInfo->mSelectPathNum = (u8)mpDumpStage->GetSelectPathNum();
			}
		}
		WK7Stage::DeleteStage(mpDumpStage);
		mpDumpStage = NULL;
	default:
		mDumpStageInfoProc = 0;
		mpDumpStageInfo++;
		break;
	}
	return true;
}

bool WK7MainMenu::RenderProcessDumpStageInfo(void)
{
	C_Paper		paper(24,64);
	
	if( mpDumpStageInfo!=NULL ){
		PRINTF("Now Stage : Stage%03d_M%02d\n",K7STG_MAINID(mpDumpStageInfo->mID),K7STG_SUFFIX(mpDumpStageInfo->mID));
	}else{
		PRINTF("Now Stage : Stage---_M--\n");
	}
	PRINTF("%d\n",mDumpStageInfoProc);
	
	return true;
}

const char* WK7MainMenu::GetFlowName(void)
{
	const char	*pName;
	switch( GameInfo.GetScenarioFlow() ){
	case	K7SCNF_CEL:	pName = "CEL"; break;		// ZeBbN
	case	K7SCNF_FUK:	pName = "FUK"; break;		// tNV}
	case	K7SCNF_KAK:	pName = "KAK"; break;		// pr
	case	K7SCNF_TXS:	pName = "TXS"; break;		// eLTXO
	case	K7SCNF_ISZ:	pName = "ISZ"; break;		// VniCVUJhj
	case	K7SCNF_CUR:	pName = "CUR"; break;		// J[eBX@
	case	K7SCNF_DM1:	pName = "DM1"; break;		// h~jJO
	case	K7SCNF_DM2:	pName = "DM2"; break;		// h~jJ
	case	K7SCNF_HT1:	pName = "HT1"; break;		// zeP
	case	K7SCNF_SCL:	pName = "SCL"; break;		// wZ
	case	K7SCNF_HT2:	pName = "HT2"; break;		// zeQ
	case	K7SCNF_GNK:	pName = "GNK"; break;		// R͓
	default:            pName = "---"; break;
	}
	return pName;
}

bool WK7MainMenu::ChangeSpAtkTaskState(void)
{
	switch( WK7PlayerControl::GetStateSpAtkTask() ){
	case	GHMGCTASK_READY:   WK7PlayerControl::SuspendSpAtkTask(); break;
	case	GHMGCTASK_SUSPEND: WK7PlayerControl::ResumeSpAtkTask();  break;
	case	GHMGCTASK_INVALID_STATE:
	default:
		return false;
	}
	return true;
}

