////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Main Menu
//
// WK7MainMenu.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/10/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7MAINMENU_H__
#define	__WK7MAINMENU_H__

//#include "..\Lib\ghmGcTask.h"
//#include "..\Lib\ghmGcMem.h"
#include "..\Sato\SK7PanelBase.h"
#include ".\WK7CharaPresent.h"
#include ".\WK7Effect.h"
#include ".\WK7Event.h"
#include ".\WK7Stage.h"

#define	WK7MAINMENU_LEVEL_MAX		(3)
class WK7MainMenu{
public:
	enum Mode{
		TOPMENU = 0,
		VAREDIT,
		FLAGEDIT,
		ITEMEDIT,
		PLAYEDIT,
		PATHCHANGE,
		GVAREDIT,
		GFLAGEDIT,
		CHARAPRESENT,
		HIERARCHY,
		AUTOPARAM,
		CHANGEFLOW,
		DUMPSTAGEINFO,
	};
protected:
	bool						mActive;
	
	bool						mDispPathInfo;
	bool						mDispMemInfo;
	int							mMemMinWidth;
	int							mMemDumpType;
	bool						mDispPerfInfo;
	bool						mDispCamPos;				// J|WV̕\
	s32							mChangeCharaID;				// ύXLhc
	bool						mAutoPlay;
	bool						mBattleInfo;				// oĝ܂܂ȃCtH[V
	bool						mEneWalkArea;				// G̈ړ͈͂̕\
	bool						mGalSystemEnable;			// Q[FKV[VXe
	bool						mStreamPlayEnable;			// Xg[Đ
	bool						mMuteki;					// lG
	bool						mPlayerInfo;				// l
	bool						mPcPause;					// l|[Y
	bool						mNpcPause;					// G|[Y
	bool						mSkillAllUse;				// S̃XLg
	bool						mDownAtkEdit;				// _EŨGfBbg[h
	bool						mGunDisp;					// e̕\\
	bool						mEnemySet;					// GZbg[h
	bool						mGxWarning;
	
	const char					*mpTitle;
	int							mLevel;
	int							mProc;
	int							mProcStack[WK7MAINMENU_LEVEL_MAX];
	Mode						mMode;
	ePanelID					mPanelID;
	int							mPanelParam;
	u32							mPanelEventNo;
	int							mPanelCursor;
	
	int							mEditScenarioID;
	int							mEditID;
	int							mEditIDMax;
	int							mEditArrayID;
	int							mEditCursor;
	int							mEditSize;
	int							mDispIDMax;
	
	bool						mDispShadow;
	bool						mDispAlpha;
	bool						mFollowCamEdit;				// ǔJGfBbg
	bool						mSkillEdit;					// XLGfBbg
	bool						mJunctionColorEdit;
	
	bool						mModeInfo;
	int							mPackManCursor;
	int							mPackManBlink;
	int							mPackManID;
	int							mModeBlink;
	int							mModeDisp;
	
	ghmGcTaskController			*mpFrameProcessTaskController;
	bool						mEnableStageChange;
	bool						mTermRequest;
	
	bool						mRenderSpOption;
	
	WK7CharaPresentMaskWindow	*mpMaskWindow;
//	MK7CharaDisp				*mpCharaDisp;
	f32							mNameX,mNameY;
	f32							mWindowX,mWindowY,mWindowW,mWindowH;
	
	WK7JObj						*mpCurrentJObj;
	bool						mCamDebug;
	
	WK7Fade						mMask;
	int							mChangeFlowProc;
	int							mOldFlow;
	
	int							mDumpStageInfoProc;
	WK7StageInfo				*mpDumpStageInfo;
	WK7StageCreateStageFunc		*mpOldCreateStageFunc;
	WK7Stage					*mpDumpStage;
	u32							mCurrentStageID;
	
	bool						mStageWarning;
	
	bool PushProc(int nextproc=0);
	bool PopProc(void);
	
	bool PadOperateProc(int max);
	bool FrameProcessEdit(bool scn=true);
	
	int GetEditSize(int type);
	f32 GetEditSize(void);
	
	void AdjustPos(int &menuid,int &cursor,int menunum,int dispnum);
	bool SetEditIDMax(void);
	int GetVarNum(void);
	int GetFlagNum(void);
	int GetGVarNum(void);
	int GetGFlagNum(void);
	int GetItemNum(void);
	int GetPlayNum(void);
	int GetPathNum(void);
	
	bool FrameProcessTopMenu(void);
	bool FrameProcessVarEdit(void);
	bool FrameProcessVarEdit(K7EVVarType *pVarType,bool scn);
	bool FrameProcessFlagEdit(void);
	bool FrameProcessGVarEdit(void);
	bool FrameProcessGFlagEdit(void);
	bool FrameProcessItemEdit(void);
	bool FrameProcessPlayEdit(void);
	bool FrameProcessPathChange(void);
	bool FrameProcessCharaPresent(void);
	bool FrameProcessHierarchy(void);
	bool FrameProcessAutoparam(void);
	bool FrameProcessChangeFlow(void);
	bool FrameProcessDumpStageInfo(void);

	bool RenderProcessEditScenario(const char *pOption=NULL,bool scn=true);
	bool RenderProcessTopMenu(void);
	bool RenderProcessVarEdit(void);
	bool RenderProcessVarEdit(K7EVVarType *pVarType,bool scn);
	bool RenderProcessFlagEdit(void);
	bool RenderProcessGVarEdit(void);
	bool RenderProcessGFlagEdit(void);
	bool RenderProcessItemEdit(void);
	bool RenderProcessPlayEdit(void);
	bool RenderProcessPathChange(void);
	bool RenderProcessCharaPresent(void);
	bool CalcTopHierarchy(WK7JObj *pJObj,ghmGcSpriteF *psprite);
	bool RenderProcessHierarchy(WK7JObj *pJObj,ghmGcSpriteF *psprite);
	bool RenderProcessHierarchy(void);
	bool RenderProcessAutoparam(void);
	bool RenderProcessChangeFlow(void);
	bool RenderProcessDumpStageInfo(void);
	
	bool SetMode(Mode mode);
	bool SetActive(bool flag);
	void CameraInfoDisp(void);
	
	bool RenderAlpha(void);
	const char* GetFlowName(void);
public:
	WK7MainMenu();
	virtual ~WK7MainMenu();
	
	bool Initialize(void);
	bool Terminate(void);
	
	bool FrameProcess(void);
	bool RenderProcess(void);
	
	inline bool IsActive                 (void){ return mActive;                 }
	inline bool IsDispPathInfo           (void){ return mDispPathInfo;           }
	inline bool IsDispMemInfo            (void){ return mDispMemInfo;            }
	inline bool IsDispPerfInfo           (void){ return mDispPerfInfo;           }
	inline bool IsDispCamPos             (void){ return mDispCamPos;             }
	inline bool IsAutoPlay               (void){ return mAutoPlay;               }
	inline bool IsBattleInfo             (void){ return mBattleInfo;             }
	inline bool IsEneWalkArea            (void){ return mEneWalkArea;            }
	inline bool IsGalSystemEnable        (void){ return mGalSystemEnable;        }
	inline bool IsTermRequested          (void){ return mTermRequest;            }
	inline bool IsMuteki                 (void){ return mMuteki;                 }
	inline bool IsStreamPlayEnable       (void){ return mStreamPlayEnable;       }
	inline bool IsPlayerInfo             (void){ return mPlayerInfo;             }
	inline bool IsPcPause                (void){ return mPcPause;                }
	inline bool IsNpcPause               (void){ return mNpcPause;               }
	inline bool GetDispShadow            (void){ return mDispShadow;             }
	inline bool GetDispAlpha             (void){ return mDispAlpha;              }
	inline bool GetFollowCamEdit         (void){ return mFollowCamEdit;          }
	inline bool IsSkillEdit              (void){ return mSkillEdit;              }
	inline bool IsSkillAllUse            (void){ return mSkillAllUse;            }
	inline bool IsSDownAtkEdit           (void){ return mDownAtkEdit;            }
	inline bool GetJunctionColorEdit     (void){ return mJunctionColorEdit;      }
	inline bool GetModeInfo              (void){ return mModeInfo;               }
	inline bool IsGunDisp                (void){ return mGunDisp;                }
	inline bool IsEnemySet               (void){ return mEnemySet;               }
	inline bool GetGxWarning             (void){ return mGxWarning;              }
	inline bool GetStageWarning          (void){ return mStageWarning;           }
	
	bool SetGxWarning(bool flag);
	bool SetStreamPlayEnable(bool flag);
	inline bool SetModeInfo(bool flag){ mModeInfo = flag; return true; }
	
	inline bool SetEneWalkArea(bool flag){ mEneWalkArea=flag; return true; }
	bool ChangeSpAtkTaskState(void);
	
	inline void SetFrameProcessTaskController(ghmGcTaskController *p){ mpFrameProcessTaskController=p; }
	inline ghmGcTaskController* GetFrameProcessTaskController(void){ return mpFrameProcessTaskController; }
	
	inline Mode GetMode(void){ return mMode; }
	inline int GetChangeFlowProc(void){ return mChangeFlowProc; }
	inline int GetDumpStageInfoProc(void){ return mDumpStageInfoProc; }
};

extern	WK7MainMenu		mainMenu;

#endif	//__WK7MAINMENU_H__

