////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Main Task
//
// WK7MainTask.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7MAINTASK_H__
#define	__WK7MAINTASK_H__

//#include "..\Lib\ghmGcTask.h"
//#include "..\Lib\ghmGcMem.h"

#include ".\K7App.h"
//#include "..\Lib\ghmGcUsb.h"
//#include ".\WK7Event.h"
//#include ".\WK7Archive.h"
//#include ".\WK7AfterImage.h"
//#include ".\WK7Cam.h"
//#include ".\WK7Light.h"
//#include ".\WK7Chara.h"
//#include ".\WK7Player.h"
//#include ".\WK7Enemy.h"
//#include ".\WK7Stage.h"
//#include ".\WK7Item.h"
//#include ".\WK7Bullet.h"
//#include ".\WK7GameInfo.h"
//#include ".\WK7Path.h"
//#include ".\WK7FilmCut.h"
//#include ".\WK7SelectIF.h"
#include ".\WK7ScreenImage.h"
//#include ".\WK7SceneBlur.h"
//#include "..\Fujita\C_Perf.h"
//#include "..\Fujita\C_LObj.h"
//#include "..\Fujita\C_Particle.h"
//#include "..\Fujita\C_Mirror.h"
//#include "..\Matsu\mK7Proc.h"

class WK7Cam;

extern	WK7ScreenImage				screenImageFullColor;
extern	WK7ScreenImage				screenImageMonoColor;

#define	WK7MAINTASK_LAST_FRAMEPROCESS_TASK_PRIO		(1024)

#define	WK7MAINTASK_PRE_SCREENCAPTURE_TASK_PRIO		(128)
#define	WK7MAINTASK_SCREENCAPTURE_TASK_PRIO			(256)
#define	WK7MAINTASK_POST_SCREENCAPTURE_TASK_PRIO	(384)
#define	WK7MAINTASK_POST_SCREENCAPTURE2_TASK_PRIO	(512)

class WK7MainTask : public ghmGcAppTask{
protected:
	
	static	int					mTaskID;
	
	int							mPreScreenCaptureTaskID;
	int							mScreenCaptureTaskID;
	int							mPostScreenCaptureTaskID;
	int							mPostScreenCapture2TaskID;
	int							mLastFrameProcessTaskID;
	
	// ^XNRg[
	ghmGcTaskController			mFrameProcessTaskController;
	ghmGcTaskController			mRenderProcessTaskController;
	
	// ~[
//	C_Mirror					**mppMirror;
//	int							mMirrorNum;
	
#ifdef	_DEBUG
	int							mCallScenarioID;
	bool						mTermMenu;
#endif
	
public:
//	KK7BattleMainTask			mBattelMain;
//	const char					*mpScenarioSSM;
	
	static WK7MainTask			*mpMainTask;
	static ghmGcTaskController	*pMFrameProcessTaskController;
	static ghmGcTaskController	*pMRenderProcessTaskController;
	
	WK7MainTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~WK7MainTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _OO
	virtual bool PreRenderProcess(void);

	// _O
	virtual bool RenderProcess(void);
	
//	inline WK7Cam* GetCamera(void){ return WK7CAM; }
	WK7Cam* GetCamera(void);
	
	static int GetTaskID(void){ return mTaskID; }
	
	bool SetCurrentStage(u32 id);
	
//	inline void SetCurrentPlayerChara(u32 id){ WK7PLAYERCONTROL->SetID(id); }
//	inline u32 GetCurrentPlayerChara(void){ return WK7PLAYERCONTROL->GetID(); }
	
//	bool AllocMirrorNum(int num);
//	bool FreeMirror(void);
//	bool SetMirror(int index,HSD_JObj *pMirrorObj,HSD_JObj *pSizeObj,HSD_DObj *pMirrorMat,HSD_CObj *pCObj);
//	bool MirrorDispStart(int index);
//	bool MirrorDispEnd(int index);
	
	// t[Xg
	bool LastFrameProcessTask(ghmGcTask *pTask);
	static void _LastFrameProcessTask(ghmGcTask *pTask);
	
	// XN[Lv`[OiɂRcnj
	bool PreScreenCaptureTask(ghmGcTask *pTask);
	static void _PreScreenCaptureTask(ghmGcTask *pTask);
	// XN[Lv`[
	bool ScreenCaptureTask(ghmGcTask *pTask);
	static void _ScreenCaptureTask(ghmGcTask *pTask);
	// XN[Lv`[㏈iɂQcnj
	bool PostScreenCaptureTask(ghmGcTask *pTask);
	static void _PostScreenCaptureTask(ghmGcTask *pTask);
	bool PostScreenCapture2Task(ghmGcTask *pTask);
	static void _PostScreenCapture2Task(ghmGcTask *pTask);
	
};

#define	GET_WK7MAINTASK()							WK7MainTask::mpMainTask
#define	GET_WK7MAINTASK_RENDERPROCESSTASKPTR()		WK7MainTask::pMRenderProcessTaskController
#define	GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()		WK7MainTask::pMFrameProcessTaskController
//#define	GET_WK7MAINTASK()			(WK7MainTask *)k7app.GetTask(WK7MainTask::GetTaskID())

#endif	//__WK7MAINTASK_H__

