////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Object
//
// WK7Obj.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/08/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7OBJ_H__
#define	__WK7OBJ_H__

#include "..\Lib\ghmGcThread.h"
//#include "..\Lib\ghmGcList.h"
//#include ".\K7ID.h"
//#include "..\Fujita\C_EdgeShadow.h"
//#include "..\Fujita\C_Vfx.h"
//#include "..\Fujita\c_k7cloth.h"
//#include "..\Yam\YK7Effect.h"
//#include ".\WK7Define.h"

class C_VFX;
class C_K7Cloth;

#define	WK7OBJ_ANCHOR_PRIO			(GHMGCLIST_ANCHOR_PRIO)
#define	WK7OBJ_DEFAULT_PRIO			(GHMGCLIST_DEFAULT_PRIO)

class WK7SmallMemObj{
public:
	void* operator new(u32 blocksize);
	void operator delete(void *pblock);
};

class WK7DefaultMemObj{
public:
	void* operator new(u32 blocksize);
	void operator delete(void *pblock);
};

//
// Object
//
class WK7Obj : public ghmGcListObj , public WK7SmallMemObj{
public:
	WK7Obj();												// AJ[쐬p
	WK7Obj(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7Obj();
	
	inline WK7Obj* GetPrev(void){ return (WK7Obj *)ghmGcListObj::GetPrev(); }
	inline WK7Obj* GetNext(void){ return (WK7Obj *)ghmGcListObj::GetNext(); }
	
	// 
	virtual bool Initialize(void){ return true; }
	
	// I
	virtual bool Terminate(void){ return true; }
	
	// t[
	virtual bool FrameProcess(void){ return true; }
#if FUJITA
	//{̂̃_O̒OAɂȂɂꍇB
	virtual void AdditionalPreRenderProcess(void);
	WK7Obj		*mpAdditionalPreRender;	
	virtual void AdditionalPostRenderProcess(void);
	WK7Obj		*mpAdditionalPostRender;	
#endif	
};

class WK7Archive;
class WK7Model;
class WK7EventController;
class WK7CameraMotion;
class WK7LightMotion;
class WK7Chara;
class WK7Stage;
class WK7Item;
class WK7Light;
class WK7PlayRenderObj;
class WK7SelectObj;
class WK7RenderObj;

class WK7SelectObj;
class WK7JObj;

class WK7RenderSelectObj : public ghmGcListObj{
	friend class WK7RenderObj;
protected:
	WK7RenderObj			*mpContainer;
	WK7SelectObj			*mpSelectObj;
	WK7RenderSelectObj(ghmGcListObj *pAnchor,WK7RenderObj *pContainer,WK7JObj *pJObj);
	~WK7RenderSelectObj();
public:
	inline WK7RenderSelectObj* GetPrev(void){ return (WK7RenderSelectObj *)ghmGcListObj::GetPrev(); }
	inline WK7RenderSelectObj* GetNext(void){ return (WK7RenderSelectObj *)ghmGcListObj::GetNext(); }
	inline WK7RenderObj* GetContainer(void){ return mpContainer; }
	inline WK7SelectObj* GetSelectObj(void){ return mpSelectObj; }
	
	bool SetSelectObjName(int index,const char *pName);
	bool SetSelectObjName(const char *pName0,const char *pName1);
	const char* GetSelectObjName(int index);
	bool SetSelectObjEnable(bool flag);
	bool GetSelectObjEnable(void);
	bool SetSelectObjPlayEnable(bool flag);
	bool GetSelectObjPlayEnable(void);
	bool SetSelectEventID(u32 eventid);
	u32 GetSelectEventID(void);
	
	int SelectCallback(void);
	static int SelectCallback(WK7SelectObj *pObj);
};

#define	WK7RENDEROBJ_CONV_RENDERID_TO_ALPHA(renderid)		((u8)(renderid << 3))
#define	WK7RENDEROBJ_CONV_ALPHA_TO_RENDERID(alpha)			(alpha >> 3)

#define	WK7RENDEROBJ_RENDERID_MAX				(32)
#define	WK7RENDEROBJ_RENDERID_HALF				(WK7RENDEROBJ_RENDERID_MAX/2)
#define	WK7RENDEROBJ_RENDERID_DEFAULT			(WK7RENDEROBJ_RENDERID_HALF-2)
#define	WK7RENDEROBJ_RENDERID_PLAYER			(WK7RENDEROBJ_RENDERID_HALF-1)
#define	WK7RENDEROBJ_INVALID_RENDERID			(0xffffffff)

#define	WK7RENDEROBJ_RENDERID_DEFAULT_ALPHA		(WK7RENDEROBJ_CONV_RENDERID_TO_ALPHA(WK7RENDEROBJ_RENDERID_DEFAULT))

class WK7MotionObj;
class WK7ModelMotion;
class WK7CharaMotion;
class WK7StageMotion;
class WK7ItemMotion;

class WK7RenderObjMotionObj : public ghmGcListObj{
protected:
	WK7MotionObj				*mpMotionObj;
	u32							mType;
	u32							mID;
	int							mPrio;
public:
	WK7RenderObjMotionObj(ghmGcListObj *pAnchor,u32 type,u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7RenderObjMotionObj();
	
	inline WK7RenderObjMotionObj* GetNext(void){ return (WK7RenderObjMotionObj *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjMotionObj* GetPrev(void){ return (WK7RenderObjMotionObj *)ghmGcListObj::GetPrev(); }
	
	inline WK7MotionObj* GetMotionObj(void){ return mpMotionObj; }
	u32 GetType(void);
	u32 GetID(void);
	WK7ModelMotion* GetModelMotion(void);
	WK7CameraMotion* GetCameraMotion(void);
	WK7LightMotion* GetLightMotion(void);
	bool IsLoaded(void);
	bool Release(void);
	bool Restore(void);
};

class WK7RenderObjRenderObj : public ghmGcListObj{
protected:
	WK7RenderObj				*mpRenderObj;
	u32							mType;
	u32							mID;
	int							mPrio;
public:
	WK7RenderObjRenderObj(ghmGcListObj *pAnchor,u32 type,u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7RenderObjRenderObj();
	
	inline WK7RenderObjRenderObj* GetNext(void){ return (WK7RenderObjRenderObj *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjRenderObj* GetPrev(void){ return (WK7RenderObjRenderObj *)ghmGcListObj::GetPrev(); }
	
	inline WK7RenderObj* GetRenderObj(void){ return mpRenderObj; }
	u32 GetType(void);
	u32 GetID(void);
	WK7Model* GetModel(void);
	bool IsLoaded(void);
	bool Release(void);
	bool Restore(void);
};

struct	tagEFFECT;
typedef struct tagEFFECT EFFECT;

class WK7RenderObjEffectInfo{
protected:
	int			mEffectNum;
	EFFECT		**mppEffect;
public:
	WK7RenderObjEffectInfo(){
		mEffectNum = 0;
		mppEffect  = NULL;
	}
	virtual ~WK7RenderObjEffectInfo(){
		mEffectNum = 0;
		GHMGCMEM_SAFE_FREE(mppEffect);
	}
	bool Initialize(void);
	bool Create(void);
	int Parent(EFFECT *pParent);
	static int UnParent(EFFECT *pParent);
};

class WK7RenderObjEffect : public ghmGcListObj{
public:
	enum WK7RenderObjEffectType{
		NORMAL = 0,
		ANIM,
		BILL,
		MODELFIRE,
		RAIN,
		MESSAGE,
	};
protected:
	WK7RenderObj				*mpContainer;
	EFFECT						*mpEffect;
	u32							mEffectID;
	WK7RenderObjEffectType		mType;
	u32							mDamageID;
	int							mForcedDraw;
	int							mForcedMove;
public:
	WK7RenderObjEffect(ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect);
	virtual ~WK7RenderObjEffect();
	
	inline WK7RenderObjEffect* GetNext(void){ return (WK7RenderObjEffect *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffect* GetPrev(void){ return (WK7RenderObjEffect *)ghmGcListObj::GetPrev(); }
	
	bool IsValid(void);
	inline EFFECT* GetEffect(void){ return mpEffect; }
	inline WK7RenderObjEffectType GetType(void){ return mType; }
	virtual bool FrameProcess(void);
	
	void SetForcedDrawFlag(int flag){ mForcedDraw=flag; }
	void SetForcedMoveFlag(int flag){ mForcedMove=flag; }
	int GetForcedDrawFlag(void){ return mForcedDraw; }
	int GetForcedMoveFlag(void){ return mForcedMove; }
	
	bool SetDrawFlag(bool flag);
	bool SetMoveFlag(bool flag);
	
	bool DelReqEffect(void);
	inline bool SetDamageID(u32 id){ mDamageID=id; return true; }
	inline u32 GetDamageID(void){ return mDamageID; }
};

class WK7RenderObjEffectAnim : public WK7RenderObjEffect{
protected:
	s8					mAnimID;
public:
	WK7RenderObjEffectAnim(s8 animID,ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect) : WK7RenderObjEffect(pAnchor,pContainer,pEffect){
		mAnimID = animID;
		mType   = ANIM;
	}
	virtual ~WK7RenderObjEffectAnim(){}
	
	inline WK7RenderObjEffectAnim* GetNext(void){ return (WK7RenderObjEffectAnim *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectAnim* GetPrev(void){ return (WK7RenderObjEffectAnim *)ghmGcListObj::GetPrev(); }
	
	inline s8 GetAnimID(void){ return mAnimID; }
};

class WK7RenderObjEffectAnim2 : public WK7RenderObjEffectAnim{
protected:
	WK7JObj				*mpJObj;
	Vec					mPosition;
public:
	WK7RenderObjEffectAnim2(WK7JObj *pJObj,const Vec &pos,s8 animID,ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect) : WK7RenderObjEffectAnim(animID,pAnchor,pContainer,pEffect){
		mpJObj    = pJObj;
		mPosition = pos;
	}
	virtual ~WK7RenderObjEffectAnim2(){}
	
	inline WK7RenderObjEffectAnim2* GetNext(void){ return (WK7RenderObjEffectAnim2 *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectAnim2* GetPrev(void){ return (WK7RenderObjEffectAnim2 *)ghmGcListObj::GetPrev(); }
	
	inline void SetJObj(WK7JObj *pJObj){ mpJObj=pJObj; }
	inline WK7JObj* GetJObj(void){ return mpJObj; }
	
	inline void SetPosition(const Vec &pos){ mPosition=pos; }
	inline void GetPosition(Vec &pos){ pos=mPosition; }
	
	virtual bool FrameProcess(void);
};

class WK7RenderObjEffectBill : public WK7RenderObjEffect{
protected:
	s8					mEffectID;
public:
	WK7RenderObjEffectBill(s8 effectID,ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect) : WK7RenderObjEffect(pAnchor,pContainer,pEffect){
		mEffectID = effectID;
		mType     = BILL;
	}
	virtual ~WK7RenderObjEffectBill(){}
	
	inline WK7RenderObjEffectBill* GetNext(void){ return (WK7RenderObjEffectBill *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectBill* GetPrev(void){ return (WK7RenderObjEffectBill *)ghmGcListObj::GetPrev(); }
	
	inline s8 GetEffectID(void){ return mEffectID; }
};

class WK7RenderObjEffectModelFire : public WK7RenderObjEffect{
protected:
	WK7JObj							*mpJObj;
	u8								mFireType;
	s8								mBillEffectID;
public:
	WK7RenderObjEffectModelFire(WK7JObj *pJObj,u8 type,ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect);
	virtual ~WK7RenderObjEffectModelFire();
	
	inline WK7RenderObjEffectModelFire* GetNext(void){ return (WK7RenderObjEffectModelFire *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectModelFire* GetPrev(void){ return (WK7RenderObjEffectModelFire *)ghmGcListObj::GetPrev(); }
	
	inline WK7JObj* GetJObj(void){ return mpJObj; }
	inline u8 GetFireType(void){ return mFireType; }
};

class WK7RenderObjEffectRain : public WK7RenderObjEffect{
protected:
	bool			mCamControl;
	f32				mHeight;
public:
	WK7RenderObjEffectRain(ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect);
	WK7RenderObjEffectRain(f32 height,ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect);
	virtual ~WK7RenderObjEffectRain();
	
	inline WK7RenderObjEffectRain* GetNext(void){ return (WK7RenderObjEffectRain *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectRain* GetPrev(void){ return (WK7RenderObjEffectRain *)ghmGcListObj::GetPrev(); }
	
	virtual bool FrameProcess(void);
};

class WK7RenderObjEffectResource : public ghmGcListObj{
	friend class WK7RenderObj;
public:
	enum WK7RenderObjEffectResourceType{
		ANIM = 0,
		BILL,
		BILLID,
	};
protected:
	WK7RenderObjEffectResourceType			mType;
	int										mRefCount;
	
	bool IncRefCount(void){ mRefCount++; return true; }
	bool DecRefCount(void){ mRefCount--; return true; }
	int GetRefCount(void){ return mRefCount; }
	WK7RenderObjEffectResource(ghmGcListObj *pAnchor) : ghmGcListObj(pAnchor,GHMGCLIST_DEFAULT_PRIO){ mRefCount=0; }
	virtual ~WK7RenderObjEffectResource(){}
public:
	
	inline WK7RenderObjEffectResource* GetNext(void){ return (WK7RenderObjEffectResource *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectResource* GetPrev(void){ return (WK7RenderObjEffectResource *)ghmGcListObj::GetPrev(); }
	
	inline WK7RenderObjEffectResourceType GetType(void){ return mType; }
	
	virtual bool FrameProcess(void);
};

class WK7RenderObjEffectResourceAnim : public WK7RenderObjEffectResource{
	friend class WK7RenderObj;
protected:
	s8										mAnimID;
	WK7RenderObjEffectResourceAnim(ghmGcListObj *pAnchor,s8 animID);
	virtual ~WK7RenderObjEffectResourceAnim();
public:
	
	inline WK7RenderObjEffectResourceAnim* GetNext(void){ return (WK7RenderObjEffectResourceAnim *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectResourceAnim* GetPrev(void){ return (WK7RenderObjEffectResourceAnim *)ghmGcListObj::GetPrev(); }
	
	inline s8 GetAnimID(void){ return mAnimID; }
};

class WK7RenderObjEffectResourceBill : public WK7RenderObjEffectResource{
	friend class WK7RenderObj;
protected:
	s8										mEffectID;
	WK7RenderObjEffectResourceBill(ghmGcListObj *pAnchor,s8 effectID);
	virtual ~WK7RenderObjEffectResourceBill();
public:
	
	inline WK7RenderObjEffectResourceBill* GetNext(void){ return (WK7RenderObjEffectResourceBill *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectResourceBill* GetPrev(void){ return (WK7RenderObjEffectResourceBill *)ghmGcListObj::GetPrev(); }
	
	inline s8 GetEffectID(void){ return mEffectID; }
};

class WK7RenderObjEffectResourceBillID : public WK7RenderObjEffectResource{
	friend class WK7RenderObj;
protected:
	s8										mBillID;
	WK7RenderObjEffectResourceBillID(ghmGcListObj *pAnchor,s8 billID);
	virtual ~WK7RenderObjEffectResourceBillID();
public:
	
	inline WK7RenderObjEffectResourceBillID* GetNext(void){ return (WK7RenderObjEffectResourceBillID *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectResourceBillID* GetPrev(void){ return (WK7RenderObjEffectResourceBillID *)ghmGcListObj::GetPrev(); }
	
	inline s8 GetBillID(void){ return mBillID; }
};

#define	WK7RENDEROBJ_INITTHREAD_STACKSIZE			(32 * 1024)

//
// RenderObject
//
// _OIuWFNg
//
class WK7RenderObj : public WK7Obj{
public:
	enum State{
		IDLE = 0,
		LOADRESERVE,
		LOADING,
		LOADING_AFTERINIT_CALL,
		LOADING_AFTERINIT,
		LOADING_AFTERINIT2_CALL,
		LOADING_AFTERINIT2,
		LOADING_AFTERINIT3_CALL,
		LOADING_AFTERINIT3,
		LOADED,
		RELEASEARCHIVE,
		RELEASEDARCHIVE,
		RESTOREARCHIVE,
	};
	enum RenderKind{
		NORMAL = 0,
		VFXEFFECT,
		BLUR,
	};
protected:
	static ghmGcListObj				mAnchor;
	// 凋COp
	static C_VFX					*mpVfx;
	static bool						mVfxFlag;
	
	static bool						mVisibleAllFlag;
	static bool						mIsReservedFileName;
	static char						mReservedFileName[WK7_FNAME_MAX];
#if FUJITA
	static HSD_Fog					*mpFog;	
#endif
	
	WK7Archive						*mpArchive;
	WK7Model						*mpModel;
	WK7Model						*mpMirrorModel;
	ghmGcListObj					mLightAnchor;
	u32								mType;
	u32								mID;
	State							mState;
	bool							mRenderFlag;
	bool							mRenderObjFlag;
	u32								mRenderID;
	u32								mRenderIDEx;
	
	RenderKind						mRenderKind;
	
//	C_EdgeShadow					*mpEdgeShadow;
//	WK7Light						*mpEdgeShadowLight;
	
	// Cg֘A
	u32								mDispLight;
	bool							mObjLight;
	
	// IIuWFNgpAJ[
	ghmGcListObj					mSelectObjAnchor;
	
	// _OIuWFNgp
	ghmGcListObj					mRenderObjAnchor;
	// [VIuWFNgp
	ghmGcListObj					mMotionObjAnchor;
	// GtFNgp
	ghmGcListObj					mEffectAnchor;
	static ghmGcListObj				mEffectResourceAnchor;
	
#if FUJITA
	C_K7Cloth						*mpCloth;
	Vec								mClothWarpOffset;
#endif
	bool							mClothEnable;
	bool							mLoadWait;
//	bool							mPlayerLight;
	u32								mMirrorType;
	
	bool							mPrivateLight;
	WK7Light						**mppPrivateLight;				// DCg
	Vec								*mpPrivateLightPos;
	int								mPrivateLightNum;
	HSD_SceneLightSet				**mppPrivateLightSet;
	
	bool							mCreateInit;
	ghmGcThread						*mpInitThread;
	
	WK7RenderObj();
	WK7RenderObj(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	inline bool GetCreateInit(void){ return mCreateInit; }
	
	virtual bool InitializeLight(void);
	virtual bool InitializeSelectObj(void);
	virtual bool InitializeShadowVolumeObj(void);
	
	inline void SetArchive(WK7Archive *pArchive){ mpArchive=pArchive; }
	inline void SetModel(WK7Model *pModel){ mpModel=pModel; }
	inline void SetState(State state){ mState=state; }
	inline void SetType(u32 type){ mType=type; }
	inline void SetID(u32 id){ mID=id; }
	virtual bool LoadObj(u32 type,u32 id);
	virtual bool RestoreObj(void);
	
	virtual bool CreateLightCallback(WK7Light *pLight);
	virtual bool ReleaseLightCallback(WK7Light *pLight);
	inline virtual bool _RenderEdgeShadowPaint(void){ return false; }
	inline void SetRenderKind(RenderKind kind){ mRenderKind=kind; }
	bool FrameProcessEffect(void);
	bool DeleteEffectAll(void);
	static bool FrameProcessEffectResource(void);
	
	bool PrivateLightProcess(void);
	virtual bool LoadAfterInit(void);
	virtual bool IsLoadingAfterInit(void);
	virtual bool LoadAfterInit2(void){ return true; }
	virtual bool IsLoadingAfterInit2(void){ return false; }
	virtual bool LoadAfterInit3(void){ return true; }
	virtual bool IsLoadingAfterInit3(void){ return false; }
	virtual bool LoadReserveProcess(void);
	virtual bool LoadingProcess(void);
	virtual bool LoadedProcess(void);
	virtual bool ReleaseArchiveProcess(void);
	virtual bool RestoreArchiveProcess(void);
	
	bool _ReleasePrivateLight(void);
	
	static void* _InitializeThread(void *pParam);
	virtual void* InitializeThread(void);
	
	inline virtual void SetRenderObjFlag(bool flag){ mRenderObjFlag = flag; }
public:
	virtual ~WK7RenderObj();
	
	bool SetCastShadowCollSphereRedius(f32 r);
	f32 GetCastShadowCollSphereRedius(void);
	
	inline bool GetRenderObjFlag(void){ return mRenderObjFlag; }
	
	static u32 ConvCharaID(u32 charaid);
	
	inline WK7RenderObj* GetPrev(void){ return (WK7RenderObj *)ghmGcListObj::GetPrev(); }
	inline WK7RenderObj* GetNext(void){ return (WK7RenderObj *)ghmGcListObj::GetNext(); }
	
	inline bool CreateLight(void){ return InitializeLight(); }
	
	bool SetMirrorType(u32 mirrorType);
	bool CreateMirrorModel(void);
	bool ReleaseMirrorModel(void);
	
	bool SetPrivateLight(HSD_SceneLightSet **ppLightSet);
	bool CreatePrivateLight(void);
	bool ReleasePrivateLight(void);
	inline bool HasPrivateLight(void){ return mPrivateLight; }
	inline int GetPrivateLightNum(void){ return mPrivateLightNum; }
	inline WK7Light* GetPrivateLight(int index){
		if( mppPrivateLight==NULL || index < 0 || index >= mPrivateLightNum ){
			return NULL;
		}
		return mppPrivateLight[index];
	}
	inline bool GetPrivateLightPos(Vec &pos,int index){
		if( mpPrivateLightPos==NULL || index < 0 || index >= mPrivateLightNum ){
			return false;
		}
		pos=mpPrivateLightPos[index];
		return true;
	}
	bool DispPrivateLight(WK7Light *pLight,u32 mirrorType,Vec *pPos);
	virtual bool DispLight(u32 mirrorType=0,Vec *pPos=NULL);
	
	virtual bool _ZSortCallback(u32 mirrorType,Vec *pMirrorPos);
	static void ZSortCallback(void *list);
	
	static u32 GetUniqueRenderID(bool uporder=true,int startid=-1);
	static u8 ConvRenderIDToAlpha(u32 renderid);
	static u32 ConvAlphaToRenderID(u8 alpha);
	
	inline WK7Archive* GetArchive(void){ return mpArchive; }
	static HSD_PEDesc* GetNormalPEDesc(void);
	static C_VFX* GetVFX(void);
	static bool VFXProc(void);
	static bool VFXCopyTex(void);
	static bool VFXDisp(void);
	static bool VFXSetIntensity(f32 i);
	static f32 VFXGetIntensity(void);
	static bool VFXAddIntensity(f32 i);
	inline static void SetVfxFlag(bool flag){ mVfxFlag = flag; }
	inline static bool GetVfxFlag(void){ return mVfxFlag; }
	
	inline void SetLoadWait(bool flag){ mLoadWait=flag; }
	inline bool GetLoadWait(void){ return mLoadWait; }
	
//	inline bool SetPlayerLight(bool flag){ mPlayerLight=flag; return true; }
//	inline bool GetPlayerLight(void){ return mPlayerLight; }
	
	inline C_K7Cloth* GetCloth(void){ return mpCloth; }
	bool SetClothEnable(bool flag,bool tobind=true);
	inline bool GetClothEnable(void){ return mClothEnable; }
	bool HideClothCollision(void);
	void SetClothWarpOffset(const Vec &ofs);
	void AddClothWarpOffset(const Vec &ofs);
	void GetClothWarpOffset(Vec &ofs);
	
	virtual int SetEventEnable(u32 eventid,bool flag);
	virtual int SetEventNoEnable(u32 eventno,bool flag);
	static int SetEventEnableAll(u32 eventid,bool flag);
	static int SetEventNoEnableAll(u32 eventno,bool flag);
	virtual bool CallCondChange(void){ return true; }
	static bool CallCondChangeAll(void);
	
	virtual void SetRenderFlag(bool flag);
	bool GetRenderFlag(bool renderobj=false);
	void SetVisible(bool flag);
	void Disp(void);
	void Hide(void);
	bool SetVisibleJObj(const char *pName,bool flag,bool next=true,bool child=true);
	bool DispJObj(const char *pName,bool next=true,bool child=true);
	bool HideJObj(const char *pName,bool next=true,bool child=true);
	
	bool SetRenderIDEx(WK7JObj *pJObj,bool next=true,bool child=true);
	static bool SetRenderID(WK7JObj *pJObj,u32 alpha,bool next=true,bool child=true);
	bool SetRenderID(u32 renderid);
	bool SetRenderIDEx(u32 renderid=0xffffffff);
	bool AllocRenderID(bool uporder=true,int startid=-1);
	bool FreeRenderID(void);
	bool SetPlayerRenderID(void);
	
	bool ClearEffect(void);
	bool EnableVfxEffect(void);
	
	bool SetAlphaUpdate(bool flag,u32 trsp=0xffffffff);
	
	inline virtual bool GetObjFileName(char */*pFileName*/,u32 /*id*/){ return false; }
	
	virtual bool Initialize(void);
	virtual bool ReleaseArchive(void);
	virtual bool RestoreArchive(void);
	
	virtual bool StateProcess(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	virtual bool RenderEdgeShadow(void);
	static bool FrameProcessEdgeShadow(void);
	static bool RenderEdgeShadowPaint(void);
//	inline C_EdgeShadow* GetEdgeShadow(void){ return mpEdgeShadow; }
	
	bool SetDispLight(WK7Light *pLight,bool flag);
	bool SetDispLight(u32 id,bool flag);
	bool SetDispLightAll(bool flag);
	bool GetDispLight(WK7Light *pLight);
	bool GetDispLight(u32 id);
	static bool CreateLightCallbackAll(WK7Light *pLight);
	static bool ReleaseLightCallbackAll(WK7Light *pLight);
	
	inline u32 GetType(void){ return mType; }
	inline u32 GetID(void){ return mID; }
	virtual u32 GetMainID(void);
	virtual u32 GetSuffix(void);
	inline u32 GetRenderID(void){ return mRenderID; }
	inline u32 GetRenderIDEx(void){ return 	mRenderIDEx; }
	inline RenderKind GetRenderKind(void){ return mRenderKind; }
	inline State GetState(void){ return mState; }
	inline WK7Model* GetModel(void){ return mpModel; }
	virtual WK7JObj* GetJObj(const char *pName=NULL);
	virtual WK7JObj* GetJObjPartialName(const char *pName);
	
	bool SetPosition(f32 x,f32 y,f32 z);
	bool SetPosition(const Vec &pos);
	bool SetRotY(f32 roty);
	bool SetRotation(const Vec &pos);
	
	bool GetPosition(Vec &pos);
	bool GetRotY(f32 *roty);
	bool GetRotation(Vec &pos);
	
	inline static WK7RenderObj* GetTopObj(void){ return (WK7RenderObj *)mAnchor.GetNext(); }
	static bool IsValid(WK7RenderObj *pRenderObj);
	static WK7RenderObj* Find(u32 type,u32 id);
	static WK7RenderObj* FindRenderID(u32 renderid);
//	static WK7RenderObj* GetObj(u32 type,u32 id);
	static WK7RenderObj* CreateRenderObj(u32 type,u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	static WK7PlayRenderObj* CreatePlayRenderObj(u32 type,u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	
	static WK7Chara* CreateChara(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline static WK7Chara* GetChara(u32 id){ return (WK7Chara *)Find(K7OBJTYPE_CHR,id); }
	
	static WK7Stage* CreateStage(u32 id,bool loadwait=false,int prio=WK7OBJ_DEFAULT_PRIO);
	inline static WK7Stage* GetStage(u32 id){ return (WK7Stage *)Find(K7OBJTYPE_STG,id); }
	
	static WK7Item* CreateItem(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline static WK7Item* GetItem(u32 id){ return (WK7Item *)Find(K7OBJTYPE_ITEM,id); }
	
	static bool ReleaseAll(void);
	
	// 
	static bool InitializeAll(void);
	static bool IsInitialized(void);
	// I
	static bool TerminateAll(void);
	// t[
	static bool FrameProcessAll(void);
	// _O
	static bool RenderProcessAll(void);
	static bool InitEdgeShadowAll(void);
	static bool RenderEdgeShadowAll(void);
	
	static bool StateProcessAll(void);
	
	static bool PrivateLightProcessAll(void);
	
	bool SetMotionRate(f32 rate);
	bool RenewMotionRate(void);
	static bool RenewMotionRateAll(void);
	
	bool SetMaterialAmbientColor(GXColor col,u32 tick);
	bool SetMaterialAmbientColorLE(GXColor col,u32 tick);
	bool SetMaterialDiffuseColor(GXColor col,u32 tick);
	bool SetMaterialDiffuseColorLE(GXColor col,u32 tick);
	
	inline static void SetVisibleAll(bool flag){ mVisibleAllFlag=flag; }
	inline static bool GetVisibleAll(void){ return mVisibleAllFlag; }
	
	static bool SetReserveFileName(const char *pfname);
	static const char* GetReserveFileName(void);
	static bool ClearReserveFileName(void);
	inline static bool IsReserveFileName(void){ return mIsReservedFileName; }
	
	// [V
	WK7ModelMotion* GetOwnModelMotion(u32 type,u32 id);
	WK7CameraMotion* GetOwnCameraMotion(u32 type,u32 id);
	WK7LightMotion* GetOwnLightMotion(u32 type,u32 id);
	inline WK7ModelMotion* GetOwnModelMotion(u32 id){ return GetOwnModelMotion(K7MOT_ATTR|mType,K7MOTID(GetMainID(),id)); }
	inline WK7CameraMotion* GetOwnCameraMotion(u32 id){ return GetOwnCameraMotion(K7MOT_ATTR|mType,K7MOTID(GetMainID(),id)); }
	inline WK7LightMotion* GetOwnLightMotion(u32 id){ return GetOwnLightMotion(K7MOT_ATTR|mType,K7MOTID(GetMainID(),id)); }
	WK7MotionObj* FindMotionObj(u32 type,u32 id);
	WK7RenderObjMotionObj* FindRenderObjMotion(u32 type,u32 id);
	WK7MotionObj* CreateOwnMotionObj(u32 type,u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	WK7CharaMotion* CreateOwnCharaMotion(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline WK7CharaMotion* GetOwnCharaMotion(u32 id){ return (WK7CharaMotion *)FindMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(GetMainID(),id)); }
	WK7StageMotion* CreateOwnStageMotion(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline WK7StageMotion* GetOwnStageMotion(u32 id){ return (WK7StageMotion *)FindMotionObj(K7MOT_ATTR|K7OBJTYPE_STG,K7MOTID(GetMainID(),id)); }
	WK7ItemMotion* CreateOwnItemMotion(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline WK7ItemMotion* GetOwnItemMotion(u32 id){ return (WK7ItemMotion *)FindMotionObj(K7MOT_ATTR|K7OBJTYPE_ITEM,K7MOTID(GetMainID(),id)); }
	bool IsOwnMotionObjLoaded(void);
	virtual bool ReleaseOwnMotionObjAll(void);
	
	// f
	WK7Model* GetOwnModel(u32 type,u32 id);
	inline WK7Model* GetOwnModel(u32 id){ return GetOwnModel(mType,id); }
	WK7RenderObj* FindRenderObj(u32 type,u32 id);
	WK7RenderObjRenderObj* FindRenderObjRenderObj(u32 type,u32 id);
	WK7RenderObj* CreateOwnRenderObj(u32 type,u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	WK7Chara* CreateOwnChara(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline WK7Chara* GetOwnChara(u32 id){ return (WK7Chara *)FindRenderObj(K7OBJTYPE_CHR,id); }
	WK7Stage* CreateOwnStage(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline WK7Stage* GetOwnStage(u32 id){ return (WK7Stage *)FindRenderObj(K7OBJTYPE_STG,id); }
	WK7Item* CreateOwnItem(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline WK7Item* GetOwnItem(u32 id){ return (WK7Item *)FindRenderObj(K7OBJTYPE_ITEM,id); }
	bool IsOwnRenderObjLoaded(void);
	virtual bool ReleaseOwnRenderObjAll(void);
	
	int GetMotionState(void);
	bool PlayMotion(int motid,f32 startframe);
	WK7JObj* PlayMotion(const char *pModelName,int motid,const char *pMotionName=NULL,f32 startframe=0.0f);
	WK7JObj* PlayMotion(const char *pModelName,f32 startframe);
	WK7JObj* StopMotion(const char *pModelName);
	WK7JObj* PauseMotion(const char *pModelName);
	WK7JObj* ReplayMotion(const char *pModelName);
	
	bool AttachMotionN(const char *pModelName,int motid,const char *pMotionName=NULL);
	bool PlayMotionN(const char *pModelName,f32 startframe=0.0f,bool interpolate=false,f32 interpolateframe=0.0f);
	bool StopMotionN(const char *pModelName);
	bool PauseMotionN(const char *pModelName);
	bool ReplayMotionN(const char *pModelName);
	bool SetMotionLoopN(const char *pModelName,bool flag);
	
	bool AttachMotion(int motid,bool overwrite=false);
	bool AttachMotionAll(int motid,bool overwrite=false);
	bool DetachMotion(int index=-1);
	bool ResetMotion(int index=-1);
	bool PlayMotion(f32 startframe=0.0f,bool interpolate=false,f32 interpolateframe=0.0f,int index=-1);
	bool PlayMotionAll(f32 startframe=0.0f,bool interpolate=false,f32 interpolateframe=0.0f,int index=-1);
	bool StopMotion(int index=-1);
	bool StopMotionAll(int index=-1);
	inline bool PauseMotion(int index=-1){ return StopMotion(index); }
	inline bool PauseMotionAll(int index=-1){ return StopMotionAll(index); }
	bool ReplayMotion(int index=-1);
	bool ReplayMotionAll(int index=-1);
	bool AttachMatMotion(int motid);
	bool DetachMatMotion(int index=-1);
	bool ResetMatMotion(int index=-1);
	bool PlayMatMotion(f32 startframe,int index=-1);
	bool StopMatMotion(int index=-1);
	inline bool PauseMatMotion(int index=-1){ return StopMatMotion(index); }
	bool ReplayMatMotion(int index=-1);
	bool AttachShapeMotion(int motid,bool overwrite=false);
	bool DetachShapeMotion(int index=-1);
	bool ResetShapeMotion(int index=-1);
	bool PlayShapeMotion(f32 startframe,int index=-1);
	bool StopShapeMotion(int index=-1);
	inline bool PauseShapeMotion(int index=-1){ return StopShapeMotion(index); }
	bool ReplayShapeMotion(int index=-1);
	bool SetMotionLoop(bool flag,int index=-1);
	
	WK7JObj* SetVisible(const char *pModelName,bool flag);
	
	inline WK7RenderObjEffect* GetEffectTop(void){ return (WK7RenderObjEffect *)mEffectAnchor.GetNext(); }
	WK7RenderObjEffect* FindEffect(EFFECT *pEffect);
	static WK7RenderObjEffect* FindEffectAll(EFFECT *pEffect);
	WK7RenderObjEffect* CreateBillBoardEffect(s8 effectID,Vec &point,f32 yukaY, u32 MaxObjectNum=0xffffffff);
	WK7RenderObjEffect* CreateEffectModelFire(WK7JObj *pJObj,u8 type,const Vec *ppoint=NULL,f32 size=0.0f);
	WK7RenderObjEffect* CreateEffectModelFire(const char *pObjName,u8 type,const Vec *ppoint=NULL,f32 size=0.0f);
	WK7RenderObjEffect* CreateEffectEasyAnim(s8 animID,Vec &Point,Vec &Size,u8 AddBlendFlag);
	WK7RenderObjEffect* CreateEffectDropWater(Vec &Point,f32 yukaY);
	WK7RenderObjEffect* CreateEffectBreak(WK7JObj *pJObj);
	WK7RenderObjEffect* CreateEffectRain(f32 height,f32 yukaY,f32 size=600.0f);
	WK7RenderObjEffect* CreateEffectRain(Vec &point,f32 yukaY,f32 size=600.0f);
	WK7RenderObjEffect* CreateEffectSmoke(Vec &point,f32 size=-1.0f);
	WK7RenderObjEffect* CreateEffect(EFFECT *pEffect,WK7RenderObjEffectInfo *pInfo=NULL);
	WK7RenderObjEffect* CreateEffectConfetti(Vec &cpos, s32 num);
	WK7RenderObjEffect* CreateEffectSeenSound(Vec &Point,u32 color1,u32 color2);
	WK7RenderObjEffect* CreateEffectTama(WK7JObj *pJObj,const Vec& pos,f32 size=1.0f);
	
	WK7RenderObjEffectAnim* FindEffectEasyAnim(s8 animID);
	bool ReleaseEffectEasyAnim(s8 animID);
	WK7RenderObjEffectBill* FindEffectBillBoard(s8 effectID);
	bool ReleaseEffectBillBoard(s8 effectID);
	bool ReleaseEffect(WK7RenderObjEffect *pEffect);
	bool DelReqEffect(WK7RenderObjEffect *pEffect);
	bool IsValidEffect(WK7RenderObjEffect *pEffect);
	bool ReleaseEffectAll(void){ return DeleteEffectAll(); }
	
	static WK7RenderObjEffectResourceAnim* CreateEffectAnimResource(s8 animID);
	static WK7RenderObjEffectResourceAnim* FindAnimResource(s8 animID);
	static bool FindAnimResource(WK7RenderObjEffectResource *pSrcResource);
	static bool ReleaseEffectAnimResource(s8 animID);
	static bool ReleaseEffectAnimResource(WK7RenderObjEffectResourceAnim *pResourceAnim);
	
	static WK7RenderObjEffectResourceBill* CreateEffectBillResource(s8 effectID);
	static WK7RenderObjEffectResourceBill* FindBillResource(s8 effectID);
	static bool FindBillResource(WK7RenderObjEffectResource *pSrcResource);
	static bool ReleaseEffectBillResource(s8 effectID);
	static bool ReleaseEffectBillResource(WK7RenderObjEffectResourceBill *pResourceBill);
	
	static WK7RenderObjEffectResourceBillID* CreateEffectBillIDResource(s8 billID);
	static WK7RenderObjEffectResourceBillID* FindBillIDResource(s8 billID);
	static bool FindBillIDResource(WK7RenderObjEffectResource *pSrcResource);
	static bool ReleaseEffectBillIDResource(s8 effectID);
	static bool ReleaseEffectBillIDResource(WK7RenderObjEffectResourceBillID *pResourceBillID);
	
	inline static void SetFog( HSD_Fog *fog ){ mpFog = fog; }
};

//
// [VIuWFNg
//
class WK7MotionObj : public WK7Obj{
public:
	enum State{
		IDLE = 0,
		LOADRESERVE,
		LOADING,
		LOADED,
		RELEASEARCHIVE,
		RELEASEDARCHIVE,
		RESTOREARCHIVE,
	};
protected:
	static ghmGcListObj				mAnchor;
	WK7Archive						*mpArchive;
	WK7ModelMotion					*mpModelMotion;
	WK7CameraMotion					*mpCameraMotion;
	WK7LightMotion					*mpLightMotion;
	u32								mType;
	u32								mID;
	State							mState;
	
	WK7MotionObj();
	WK7MotionObj(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	inline void SetArchive(WK7Archive *pArchive){ mpArchive=pArchive; }
	inline void SetModelMotion(WK7ModelMotion *pModelMotion){ mpModelMotion=pModelMotion; }
	inline void SetCameraMotion(WK7CameraMotion *pCameraMotion){ mpCameraMotion=pCameraMotion; }
	inline void SetLightMotion(WK7LightMotion *pLightMotion){ mpLightMotion=pLightMotion; }
	inline void SetState(State state){ mState=state; }
	inline void SetType(u32 type){ mType=type; }
	inline void SetID(u32 id){ mID=id; }
	bool LoadObj(u32 type,u32 id);
	bool RestoreObj(void);
	
	virtual bool LoadReserveProcess(void);
	virtual bool LoadingProcess(void);
	virtual bool LoadedProcess(void);
	virtual bool ReleaseArchiveProcess(void);
	virtual bool RestoreArchiveProcess(void);
	
#ifdef _DEBUG
	bool CheckModel(void);
#endif
public:
	virtual ~WK7MotionObj();
	
	inline WK7MotionObj* GetPrev(void){ return (WK7MotionObj *)ghmGcListObj::GetPrev(); }
	inline WK7MotionObj* GetNext(void){ return (WK7MotionObj *)ghmGcListObj::GetNext(); }
	
	inline virtual bool GetObjFileName(char */*pFileName*/,u32 /*id*/){ return false; }
	
	// t[
	virtual bool FrameProcess(void);
	virtual bool ReleaseArchive(void);
	virtual bool RestoreArchive(void);
	
	inline u32 GetType(void){ return mType; }
	inline u32 GetID(void){ return mID; }
	virtual u32 GetMainID(void);
	virtual u32 GetSuffix(void);
	inline State GetState(void){ return mState; }
	inline WK7ModelMotion* GetModelMotion(void){ return mpModelMotion; }
	inline WK7CameraMotion* GetCameraMotion(void){ return mpCameraMotion; }
	inline WK7LightMotion* GetLightMotion(void){ return mpLightMotion; }
	
	inline static WK7MotionObj* GetTopObj(void){ return (WK7MotionObj *)mAnchor.GetNext(); }
	static bool IsValid(WK7MotionObj* pMotionObj);
	static WK7MotionObj* Find(u32 type,u32 id);
//	static WK7MotionObj* GetObj(u32 type,u32 id);
	static WK7MotionObj* CreateMotionObj(u32 type,u32 id,int prio);
	
	static WK7CharaMotion* CreateCharaMotion(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline static WK7CharaMotion* GetCharaMotion(u32 id){ return (WK7CharaMotion *)Find(K7MOT_ATTR|K7OBJTYPE_CHR,id); }
	
	static WK7StageMotion* CreateStageMotion(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline static WK7StageMotion* GetStageMotion(u32 id){ return (WK7StageMotion *)Find(K7MOT_ATTR|K7OBJTYPE_STG,id); }
	
	static WK7ItemMotion* CreateItemMotion(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	inline static WK7ItemMotion* GetItemMotion(u32 id){ return (WK7ItemMotion *)Find(K7MOT_ATTR|K7OBJTYPE_ITEM,id); }
	
	static bool ReleaseAll(void);
	
	// t[
	static bool FrameProcessAll(void);
};

#include ".\WK7Model.h"

#endif	//__WK7OBJ_H__

