////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SceneBlur
//
// WK7SceneBlur.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 07/16/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7SCENEBLUR_H__
#define	__WK7SCENEBLUR_H__

//#include <dolphin.h>
//#include "..\Lib\ghmGcList.h"

class WK7SceneBlur;
class WK7SceneBlurScreen : public ghmGcListObj{
	friend class WK7SceneBlur;
protected:
	f32				mOffsetX,
					mOffsetY;
	f32				mZDist;
	u32				mAlpha;
	u32				mColor;
	bool			mVisible;
	bool RenderProcess(WK7SceneBlur *pBlur);
	
	WK7SceneBlurScreen(ghmGcListObj *pAnchor);
	~WK7SceneBlurScreen(){}
public:
	
	inline void SetOffset(f32 ofsx,f32 ofsy){ mOffsetX=ofsx; mOffsetY=ofsy; }
	inline void GetOffset(f32 &ofsx,f32 &ofsy){ ofsx=mOffsetX; ofsy=mOffsetY; }
	inline void SetOffsetX(f32 ofsx){ mOffsetX=ofsx; }
	inline f32 GetOffsetX(void){ return mOffsetX; }
	inline void SetOffsetY(f32 ofsy){ mOffsetY=ofsy; }
	inline f32 GetOffsetY(void){ return mOffsetY; }
	
	inline void SetZDist(f32 dist){ mZDist=dist; }
	inline f32 GetZDist(void){ return mZDist; }
	
	inline void SetAlpha(u32 alpha){ mAlpha=alpha; }
	inline u32 GetAlpha(void){ return mAlpha; }
	
	inline void SetColor(u32 color){ mColor=color; }
	inline u32 GetColor(void){ return mColor; }
	
	inline void SetVisible(bool flag){ mVisible=flag; }
	inline bool GetVisible(void){ return mVisible; }
	
	inline WK7SceneBlurScreen* GetPrev(void){ return (WK7SceneBlurScreen *)ghmGcListObj::GetPrev(); }
	inline WK7SceneBlurScreen* GetNext(void){ return (WK7SceneBlurScreen *)ghmGcListObj::GetNext(); }
	
};

class WK7SceneBlur{
protected:
	ghmGcListObj		mAnchor;
	int					mScreenNum;
	f32					mProjection[GX_PROJECTION_SZ];
	f32					mViewport  [GX_VIEWPORT_SZ  ];
	Mtx					mView2DMatrix;
	Mtx44				mProj2DMatrix;
	Mtx					mViewMatrix;
	
	bool				mVisible;
	
	bool Setup(GXTexObj *pTexObj);
public:
	WK7SceneBlur();
	~WK7SceneBlur();
	
	bool RenderProcess(GXTexObj *pTexObj);
	
	inline void SetVisible(bool flag){ mVisible=flag; }
	inline bool GetVisible(void){ return mVisible; }
	
	f32 TransformCamZDisttoScreenZ(f32 camzdist);
	
	WK7SceneBlurScreen* CreateScreen(f32 ofsx=2.0f,f32 ofsy=2.0f,f32 z=100.0f,u32 alpha=0x40);
	bool ReleaseScreen(WK7SceneBlurScreen* pScreen);
	bool ReleaseScreen(int index);
	bool ReleaseScreenAll(void);
	WK7SceneBlurScreen* GetScreen(int index);
	inline WK7SceneBlurScreen* GetTopScreen(void){ return (WK7SceneBlurScreen *)mAnchor.GetNext(); }
	inline int GetScreenNum(void){ return mScreenNum; }
};

extern	WK7SceneBlur		SceneBlur;

#endif	//__WK7SCENEBLUR_H__

