////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Script
//
// WK7Script.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#define __WK7SCRIPT_CPP__

//#include "..\Lib\GhmGcTask.h"
//#include "..\Lib\GhmGcMem.h"
//#include "..\Lib\GhmGcDefine.h"
#include ".\WK7Script.h"
//#include ".\WK7Define.h"

WK7ScriptValue::WK7ScriptValue()
{
	mpChar    = NULL;
	mCharNum  = 0;
	mpShort   = NULL;
	mShortNum = 0;
	mpInt     = NULL;
	mIntNum   = 0;
	mpLong    = NULL;
	mLongNum  = 0;
	mpFloat   = NULL;
	mFloatNum = 0;
}

WK7ScriptValue::~WK7ScriptValue()
{
	Terminate();
}

bool WK7ScriptValue::Initialize(int charnum,int shortnum,int intnum,int longnum,int floatnum)
{
	if( Terminate()==false ){
		return false;
	}
	if( charnum  > 0 ){
		mCharNum  = charnum;
		ghmGcMemSetAllocName("SCRC");
		mpChar    = (s8  *)K7AppSmallMemAlloc(charnum );
	}
	if( shortnum > 0 ){
		mShortNum = shortnum;
		ghmGcMemSetAllocName("SCRS");
		mpShort   = (s16 *)K7AppSmallMemAlloc(shortnum);
	}
	if( intnum   > 0 ){
		mIntNum   = intnum;
		ghmGcMemSetAllocName("SCRI");
		mpInt     = (s32 *)K7AppSmallMemAlloc(intnum  );
	}
	if( longnum  > 0 ){
		mLongNum  = longnum;
		ghmGcMemSetAllocName("SCRL");
		mpLong    = (s64 *)K7AppSmallMemAlloc(longnum );
	}
	if( floatnum > 0 ){
		mFloatNum = floatnum;
		ghmGcMemSetAllocName("SCRF");
		mpFloat   = (f32 *)K7AppSmallMemAlloc(floatnum);
	}
	return true;
}
bool WK7ScriptValue::Terminate(void)
{
	GHMGCMEM_SAFE_FREE(mpChar );
	GHMGCMEM_SAFE_FREE(mpShort);
	GHMGCMEM_SAFE_FREE(mpInt  );
	GHMGCMEM_SAFE_FREE(mpLong );
	GHMGCMEM_SAFE_FREE(mpFloat);
	mCharNum  = 0;
	mShortNum = 0;
	mIntNum   = 0;
	mLongNum  = 0;
	mFloatNum = 0;
	return true;
}

bool WK7ScriptValue::SetChar(int index,s8 val)
{
	if( index < 0 || index >= mCharNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue SetChar Invalid Index : %d,%d",index,val);
#endif
		return false;
	}
	mpChar[index] = val;
	return true;
}

bool WK7ScriptValue::GetChar(int index,s8 &val)
{
	if( index < 0 || index >= mCharNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetChar Invalid Index : %d",index);
#endif
		return false;
	}
	val = mpChar[index];
	return true;
}

s8 WK7ScriptValue::GetChar(int index)
{
	if( index < 0 || index >= mCharNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetChar Invalid Index : %d",index);
#endif
		return 0;
	}
	return mpChar[index];
}

bool WK7ScriptValue::SetShort(int index,s16 val)
{
	if( index < 0 || index >= mShortNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue SetShort Invalid Index : %d,%d",index,val);
#endif
		return false;
	}
	mpShort[index] = val;
	return true;
}

bool WK7ScriptValue::GetShort(int index,s16 &val)
{
	if( index < 0 || index >= mShortNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetShort Invalid Index : %d",index);
#endif
		return false;
	}
	val = mpShort[index];
	return true;
}

s16 WK7ScriptValue::GetShort(int index)
{
	if( index < 0 || index >= mShortNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetShort Invalid Index : %d",index);
#endif
		return 0;
	}
	return mpShort[index];
}

bool WK7ScriptValue::SetInt(int index,s32 val)
{
	if( index < 0 || index >= mIntNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue SetInt Invalid Index : %d,%d",index,val);
#endif
		return false;
	}
	mpInt[index] = val;
	return true;
}

bool WK7ScriptValue::GetInt(int index,s32 &val)
{
	if( index < 0 || index >= mIntNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetInt Invalid Index : %d",index);
#endif
		return false;
	}
	val = mpInt[index];
	return true;
}

s32 WK7ScriptValue::GetInt(int index)
{
	if( index < 0 || index >= mIntNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetInt Invalid Index : %d",index);
#endif
		return 0;
	}
	return mpInt[index];
}

bool WK7ScriptValue::SetLong(int index,s64 val)
{
	if( index < 0 || index >= mLongNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue SetLong Invalid Index : %d,%d",index,val);
#endif
		return false;
	}
	mpLong[index] = val;
	return true;
}

bool WK7ScriptValue::GetLong(int index,s64 &val)
{
	if( index < 0 || index >= mLongNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetLong Invalid Index : %d",index);
#endif
		return false;
	}
	val = mpLong[index];
	return true;
}

s64 WK7ScriptValue::GetLong(int index)
{
	if( index < 0 || index >= mLongNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetLong Invalid Index : %d",index);
#endif
		return 0;
	}
	return mpLong[index];
}

bool WK7ScriptValue::SetFloat(int index,f32 val)
{
	if( index < 0 || index >= mFloatNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue SetFloat Invalid Index : %d,%d",index,val);
#endif
		return false;
	}
	mpFloat[index] = val;
	return true;
}

bool WK7ScriptValue::GetFloat(int index,f32 &val)
{
	if( index < 0 || index >= mFloatNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetFloat Invalid Index : %d",index);
#endif
		return false;
	}
	val = mpFloat[index];
	return true;
}

f32 WK7ScriptValue::GetFloat(int index)
{
	if( index < 0 || index >= mFloatNum ){
#ifdef	_DEBUG
		OSReport("WK7ScriptValue GetFloat Invalid Index : %d",index);
#endif
		return false;
	}
	return mpFloat[index];
}

ghmGcListObj		WK7Script::mAnchor;
WK7ScriptValue*		WK7Script::mpGlobalValue  = NULL;
u32*				WK7Script::mpGlobalFlag   = NULL;
u32					WK7Script::mGlobalFlagNum = 0;

WK7Script::WK7Script(ObjectType *pObjectType,int lflagnum,int lcharnum,int lshortnum,int lintnum,int llongnum,int lfloatnum) : ghmGcListObj(&mAnchor,GHMGCLIST_DEFAULT_PRIO)
{
	WK7ScriptValue		*pProperty;
	int					i;
	mpObjectType   = pObjectType;
	mpEpTop        = NULL;
	mpEp           = NULL;
	mEpCnt         = 0;
	mObjectTypeNum = 0;
	mFlag          = 0;
	while( pObjectType->mpMethod!=(WK7Script::ObjectCallMethod *)0xffffffff ){
		mObjectTypeNum++;
		pObjectType++;
	}
	ghmGcMemSetAllocName("ScrOP");
	mpObjectProperty = new WK7ScriptValue[mObjectTypeNum];
	pProperty   = mpObjectProperty;
	pObjectType = mpObjectType;
	for(i=0 ; i<mObjectTypeNum ; i++,pProperty++,pObjectType++){
		pProperty->Initialize(pObjectType->mPropCharNum,
		                      pObjectType->mPropShortNum,
		                      pObjectType->mPropIntNum,
		                      pObjectType->mPropLongNum,
		                      pObjectType->mPropFloatNum);
	}
	ghmGcMemSetAllocName("ScrValue");
	mpLocalValue = new WK7ScriptValue;
	if( mpLocalValue!=NULL ){
		mpLocalValue->Initialize(lcharnum,lshortnum,lintnum,llongnum,lfloatnum);
	}
	if( lflagnum > 0 ){
		mpLocalFlag   = AllocFlag(lflagnum);
		mLocalFlagNum = (u32)lflagnum;
	}else{
		mpLocalFlag   = NULL;
		mLocalFlagNum = 0;
	}
}

WK7Script::~WK7Script()
{
	GHM_SAFE_DELETE(mpLocalValue);
	GHM_SAFE_DELETE(mpLocalFlag );
	GHM_SAFE_DELETE_ARRAY(mpObjectProperty);
	mLocalFlagNum = 0;
}

bool WK7Script::Initialize(int gflagnum,int gcharnum,int gshortnum,int gintnum,int glongnum,int gfloatnum)
{
	ghmGcMemSetAllocName("ScrValue");
	if( (mpGlobalValue = new WK7ScriptValue)==NULL ){
		return false;
	}
	mpGlobalValue->Initialize(gcharnum,gshortnum,gintnum,glongnum,gfloatnum);
	if( gflagnum > 0 ){
		mpGlobalFlag   = AllocFlag(gflagnum);
		mGlobalFlagNum = (u32)gflagnum;
	}else{
		mpGlobalFlag   = NULL;
		mGlobalFlagNum = 0;
	}
	return true;
}

bool WK7Script::Terminate(void)
{
	GHM_SAFE_DELETE(mpGlobalValue);
	GHM_SAFE_DELETE(mpGlobalFlag );
	mGlobalFlagNum = 0;
	return ReleaseAll();
}

u32* WK7Script::AllocFlag(int flagnum)
{
	int		size = (int)GHM_ROUNDUP_QUOT(flagnum,32);
	u32		*pMem;
	if( size <= 0 ){
		return NULL;
	}
	ghmGcMemSetAllocName("SCRF");
	pMem = (u32 *)K7AppSmallMemAlloc(size);
	return pMem;
}

int WK7Script::SetFlag(u32 *pFlagTop,u32 flagnum,u32 id,bool flag)
{
	if( pFlagTop==NULL || flagnum<=0 ){
		return -1;
	}
	id &= 0xffff;
	int		arrayid = (int)GHM_ROUNDDOWN_QUOT(id,32);
	if( arrayid < 0 || arrayid >= flagnum ){
		return -1;
	}
	u32		mask;
	id   -= arrayid * 32;
	mask  = 1UL << id;
	if( flag==true ){
		pFlagTop[arrayid] |= mask;
		return 1;
	}
	pFlagTop[arrayid] &= ~mask;
	return 0;
}

int WK7Script::GetFlag(u32 *pFlagTop,u32 flagnum,u32 id)
{
	if( pFlagTop==NULL || flagnum<=0 ){
		return -1;
	}
	id &= 0xffff;
	int		arrayid = (int)GHM_ROUNDDOWN_QUOT(id,32);
	if( arrayid < 0 || arrayid >= flagnum ){
		return -1;
	}
	u32		mask;
	id   -= arrayid * 32;
	mask  = 1UL << id;
	return (pFlagTop[arrayid] & mask)? 1 : 0;
}

bool WK7Script::SetLocalFlag(u32 id,bool flag)
{
	if( (id & SL_SYMTP_LFLAG)==0 ){
		return false;
	}
	if( SetFlag(mpLocalFlag,mLocalFlagNum,id & ~SL_SYMTP_LFLAG,flag) < 0 ){
		return false;
	}
	return true;
}

bool WK7Script::GetLocalFlag(u32 id)
{
	if( (id & SL_SYMTP_LFLAG)==0 ){
		return false;
	}
	if( GetFlag(mpLocalFlag,mLocalFlagNum,id & ~SL_SYMTP_LFLAG) <= 0 ){
		return false;
	}
	return true;
}

bool WK7Script::SetGlobalFlag(u32 id,bool flag)
{
	if( id & SL_SYMTP_LFLAG ){
		return false;
	}
	if( SetFlag(mpGlobalFlag,mGlobalFlagNum,id,flag) < 0 ){
		return false;
	}
	return true;
}

bool WK7Script::GetGlobalFlag(u32 id)
{
	if( id & SL_SYMTP_LFLAG ){
		return false;
	}
	if( GetFlag(mpGlobalFlag,mGlobalFlagNum,id) <= 0 ){
		return false;
	}
	return true;
}

bool WK7Script::SetFlag(u32 id,bool flag)
{
	if( id & SL_SYMTP_LFLAG ){
		return SetLocalFlag(id,flag);
	}
	return SetGlobalFlag(id,flag);
}

bool WK7Script::GetFlag(u32 id)
{
	if( id & SL_SYMTP_LFLAG ){
		return GetLocalFlag(id);
	}
	return GetGlobalFlag(id);
}

bool WK7Script::Reset(void)
{
	mpEp   = mpEpTop;
	mEpCnt = 0;
	mStack.Clear();
	return true;
}

bool WK7Script::LoadData(void *pData)
{
	if( (u32)pData & 0x00000001 ){
		return false;
	}
	if( mEpCnt ){
		return false;
	}
	mpEpTop = (u16 *)pData;
	Reset();
	return true;
}

bool WK7Script::ReleaseAll(void)
{
	WK7Script		*pScript = (WK7Script *)mAnchor.GetNext();
	WK7Script		*pNext;
	while( pScript!=NULL ){
		pNext = pScript->GetNext();
		delete pScript;
		pScript = pNext;
	}
	return true;
}

bool WK7Script::Term(void)
{
//	delete this;
//	GHMGCTASK_EXIT();
	return true;
}

int WK7Script::Parse(void)
{
	if( mpEp==NULL ){
		// ߂
		Term();
		return 0;
	}
	while( mStop ){
		GHMGCTASK_RETSYS();
	}
	switch( *mpEp & SL_SYMTP_MASK ){
	case	SL_SYMTP_EOE:
		// CxgGh
		mpEpTop = NULL;
		mpEp    = NULL;
		mEpCnt  = 0;
		Term();
		return 0;
	case	SL_SYMTP_EOS:
		// X^bNNA
		mStack.Clear();
		// |C^XV
		mpEp++;
		break;
	case	SL_SYMTP_OBJ:
#ifdef _DEBUG
		// PƂł͂肦Ȃ
		OSReport("Script Code Error : Code %x EpCnt %d\n",*mpEp,mEpCnt);
		OSHalt("Script Abort!!");
#endif
		break;
	case	SL_SYMTP_VAL:
		// ϐ
		switch( *mpEp & SL_SYMTP_STYPE_MASK ){
		case	SL_SYMTP_MEMVAL:
			mStack.Push(mpEp,4);
			mpEp   += 4;
			mEpCnt += 4;
			break;
		default:
			mStack.Push(mpEp,2);
			mpEp   += 2;
			mEpCnt += 2;
			break;
		}
		break;
	case	SL_SYMTP_NUM:
		// l
		switch( *mpEp & SL_SYMTP_VTYPE_MASK ){
		case	SL_SYMTP_CHAR:
		case	SL_SYMTP_SHORT:
			mStack.Push(mpEp,2);
			mpEp   += 2;
			mEpCnt += 2;
			break;
		case	SL_SYMTP_INT:
			mStack.Push(mpEp,3);
			mpEp   += 3;
			mEpCnt += 3;
			break;
		case	SL_SYMTP_LONG:
			mStack.Push(mpEp,5);
			mpEp   += 5;
			mEpCnt += 5;
			break;
		case	SL_SYMTP_FLOAT:
			mStack.Push(mpEp,3);
			mpEp   += 3;
			mEpCnt += 3;
			break;
		}
		break;
	case	SL_SYMTP_FUNC:
		// IuWFNg\bh
		ExecuteObjectMethod();
		break;
	case	SL_SYMTP_OPE:
		switch( *mpEp ){
		case	SL_OPECODE_PLUS:   ExecutePlusOpe     (); break;
		case	SL_OPECODE_MINUS:  ExecuteMinusOpe    (); break;
		case	SL_OPECODE_LOGNOT: ExecuteLogNotOpe   (); break;
		case	SL_OPECODE_BITREV: ExecuteBitRevOpe   (); break;
		case	SL_OPECODE_MUL:    ExecuteMulOpe      (); break;
		case	SL_OPECODE_DIV:    ExecuteDivOpe      (); break;
		case	SL_OPECODE_ADD:    ExecuteAddOpe      (); break;
		case	SL_OPECODE_SUB:    ExecuteSubOpe      (); break;
		case	SL_OPECODE_LE:     ExecuteLeOpe       (); break;
		case	SL_OPECODE_LEEQU:  ExecuteLeEquOpe    (); break;
		case	SL_OPECODE_GR:     ExecuteGrOpe       (); break;
		case	SL_OPECODE_GREQU:  ExecuteGrEquOpe    (); break;
		case	SL_OPECODE_EQU:    ExecuteEquOpe      (); break;
		case	SL_OPECODE_NOTEQU: ExecuteNotEquOpe   (); break;
		case	SL_OPECODE_BITAND: ExecuteBitAndOpe   (); break;
		case	SL_OPECODE_BITXOR: ExecuteBitXorOpe   (); break;
		case	SL_OPECODE_BITOR:  ExecuteBitOrOpe    (); break;
		case	SL_OPECODE_LOGAND: ExecuteLogAndOpe   (); break;
		case	SL_OPECODE_LOGOR:  ExecuteLogOrOpe    (); break;
		case	SL_OPECODE_SUBST:  ExecuteSubstOpe    (); break;
		case	SL_OPECODE_GOTO:
		case	SL_OPECODE_BREAK:  ExecuteGotoSentence(); break;
		case	SL_OPECODE_IF:     
		case	SL_OPECODE_WHILE:  ExecuteIfSentence  (); break;
		case	SL_OPECODE_RETURN:
			// CxgI
			mpEpTop   = NULL;
			mpEp      = NULL;
			mEpCnt    = 0;
			Term();
			return 0;
		case	SL_OPECODE_MEM:
		case	SL_OPECODE_ELSE:
		case	SL_OPECODE_COMMA:
		default:
#ifdef _DEBUG
			OSReport("Script Code Error : Code %x EpCnt %d\n",*mpEp,mEpCnt);
			OSHalt("Script Abort!!");
#endif
			break;
		}
		break;
	}
	return 1;
}

void WK7Script::PushExpInt(s32 val)
{
	// l쐬
	if( val <= 0x7f && val >= -0x80 ){
		// char^
		u16		dat[2];
		dat[0] = SL_SYMTP_NUM|SL_SYMTP_CHAR;
		dat[1] = (u16)val;
		// ̒lޔ
		mStack.Push(dat,2);
	}else if( val <= 0x7fff && val >= -0x8000 ){
		// short^
		u16		dat[2];
		dat[0] = SL_SYMTP_NUM|SL_SYMTP_SHORT;
		dat[1] = (u16)val;
		// ̒lޔ
		mStack.Push(dat,2);
	}else{
		// int^
		u16		dat[3];
		u8		*pdat;
		u8		*pval = (u8 *)&val;
		dat[0] = SL_SYMTP_NUM|SL_SYMTP_INT;
		pdat = (u8*)(dat+1);
		pdat[0] = pval[2];
		pdat[1] = pval[3];
		pdat[2] = pval[0];
		pdat[3] = pval[1];
//		dat[1] = ((u16 *)&val)[0];
//		dat[2] = ((u16 *)&val)[1];
		// ̒lޔ
		mStack.Push(dat,3);
	}
}

void WK7Script::PushExpLong(s64 val)
{
	// long^
	u16		dat[5];
	u8		*pdat;
	u8		*pval = (u8 *)&val;
	dat[0] = SL_SYMTP_NUM|SL_SYMTP_LONG;
	pdat = (u8*)(dat+1);
	pdat[0] = pval[6];
	pdat[1] = pval[7];
	pdat[2] = pval[4];
	pdat[3] = pval[5];
	pdat[4] = pval[2];
	pdat[5] = pval[3];
	pdat[6] = pval[0];
	pdat[7] = pval[1];
//	dat[1] = ((u16 *)&val)[0];
//	dat[2] = ((u16 *)&val)[1];
//	dat[3] = ((u16 *)&val)[2];
//	dat[4] = ((u16 *)&val)[3];
	// ̒lޔ
	mStack.Push(dat,5);
}

void WK7Script::PushExpFloat(float val)
{
	// l쐬
	// float^
	u16		dat[3];
	u8		*pdat;
	u8		*pval = (u8 *)&val;
	dat[0] = SL_SYMTP_NUM|SL_SYMTP_FLOAT;
	pdat = (u8*)(dat+1);
	pdat[0] = pval[2];
	pdat[1] = pval[3];
	pdat[2] = pval[0];
	pdat[3] = pval[1];
//	dat[1] = ((u16 *)&val)[0];
//	dat[2] = ((u16 *)&val)[1];
	// ̒lޔ
	mStack.Push(dat,3);
}

void WK7Script::ExecuteObjectMethod(void)
{
	// \bhĂяoi޼ު,ҿID,޼ުIDj
	_ObjectCallMethod((u16)(mpEp[2] & (~SL_SYMTP_MASK)),
	                  (u16) mpEp[1],
	                  (u16) mpEp[3]);
	// |C^XV
	mpEp   += 4;
	mEpCnt += 4;
}

void WK7Script::ExecutePlusOpe(void)
{
	// |C^XV
	mpEp  ++;
	mEpCnt++;
}

#define	WK7ScriptOpe1(ope)		\
	{ \
		WK7ScriptStackData	data; \
		mStack.Pop(&data); \
		switch( data.mType ){ \
		case	SL_SYMTP_INT: \
			PushExpInt(ope data.mValue.mInt); \
			break; \
		case	SL_SYMTP_LONG: \
			PushExpLong(ope data.mValue.mLong); \
			break; \
		case	SL_SYMTP_FLOAT: \
			PushExpFloat(ope data.mValue.mFloat); \
			break; \
		} \
		mpEp  ++; \
		mEpCnt++; \
	}

#define	WK7ScriptOpe1Cast(ope)		\
	{ \
		WK7ScriptStackData	data; \
		mStack.Pop(&data); \
		switch( data.mType ){ \
		case	SL_SYMTP_INT: \
			PushExpInt(ope data.mValue.mInt); \
			break; \
		case	SL_SYMTP_LONG: \
			PushExpLong(ope data.mValue.mLong); \
			break; \
		case	SL_SYMTP_FLOAT: \
			PushExpFloat(ope (s32)data.mValue.mFloat); \
			break; \
		} \
		mpEp  ++; \
		mEpCnt++; \
	}

#define	WK7ScriptOpe2(ope)		\
	{ \
		WK7ScriptStackData	ldata,rdata; \
		mStack.Pop(&ldata); \
		mStack.Pop(&rdata); \
		switch( ldata.mType ){ \
		case	SL_SYMTP_INT: \
			switch( rdata.mType ){ \
			case	SL_SYMTP_INT: \
				PushExpLong (ldata.mValue.mInt   ope rdata.mValue.mInt  ); \
				break; \
			case	SL_SYMTP_LONG: \
				PushExpLong (ldata.mValue.mInt   ope rdata.mValue.mLong ); \
				break; \
			case	SL_SYMTP_FLOAT: \
				PushExpFloat(ldata.mValue.mInt   ope rdata.mValue.mFloat); \
				break; \
			} \
			break; \
		case	SL_SYMTP_LONG: \
			switch( rdata.mType ){ \
			case	SL_SYMTP_INT: \
				PushExpLong (ldata.mValue.mLong  ope rdata.mValue.mInt  ); \
				break; \
			case	SL_SYMTP_LONG: \
				PushExpLong (ldata.mValue.mLong  ope rdata.mValue.mLong ); \
				break; \
			case	SL_SYMTP_FLOAT: \
				PushExpFloat(ldata.mValue.mLong  ope rdata.mValue.mFloat); \
				break; \
			} \
			break; \
		case	SL_SYMTP_FLOAT: \
			switch( rdata.mType ){ \
			case	SL_SYMTP_INT: \
				PushExpFloat(ldata.mValue.mFloat ope rdata.mValue.mInt  ); \
				break; \
			case	SL_SYMTP_LONG: \
				PushExpFloat(ldata.mValue.mFloat ope rdata.mValue.mLong ); \
				break; \
			case	SL_SYMTP_FLOAT: \
				PushExpFloat(ldata.mValue.mFloat ope rdata.mValue.mFloat); \
				break; \
			} \
			break; \
		} \
		mpEp  ++; \
		mEpCnt++; \
	}

#define	WK7ScriptOpe2Cast(ope)		\
	{ \
		WK7ScriptStackData	ldata,rdata; \
		mStack.Pop(&ldata); \
		mStack.Pop(&rdata); \
		switch( ldata.mType ){ \
		case	SL_SYMTP_INT: \
			switch( rdata.mType ){ \
			case	SL_SYMTP_INT: \
				PushExpLong (ldata.mValue.mInt   ope      rdata.mValue.mInt  ); \
				break; \
			case	SL_SYMTP_LONG: \
				PushExpLong (ldata.mValue.mInt   ope      rdata.mValue.mLong ); \
				break; \
			case	SL_SYMTP_FLOAT: \
				PushExpFloat(ldata.mValue.mInt   ope (s32)rdata.mValue.mFloat); \
				break; \
			} \
			break; \
		case	SL_SYMTP_LONG: \
			switch( rdata.mType ){ \
			case	SL_SYMTP_INT: \
				PushExpLong (ldata.mValue.mLong  ope      rdata.mValue.mInt  ); \
				break; \
			case	SL_SYMTP_LONG: \
				PushExpLong (ldata.mValue.mLong  ope      rdata.mValue.mLong ); \
				break; \
			case	SL_SYMTP_FLOAT: \
				PushExpFloat(ldata.mValue.mLong  ope (s32)rdata.mValue.mFloat); \
				break; \
			} \
			break; \
		case	SL_SYMTP_FLOAT: \
			switch( rdata.mType ){ \
			case	SL_SYMTP_INT: \
				PushExpFloat((s32)ldata.mValue.mFloat ope      rdata.mValue.mInt  ); \
				break; \
			case	SL_SYMTP_LONG: \
				PushExpFloat((s32)ldata.mValue.mFloat ope      rdata.mValue.mLong ); \
				break; \
			case	SL_SYMTP_FLOAT: \
				PushExpFloat((s32)ldata.mValue.mFloat ope (s32)rdata.mValue.mFloat); \
				break; \
			} \
			break; \
		} \
		mpEp  ++; \
		mEpCnt++; \
	}

// 
void WK7Script::ExecuteMinusOpe(void)
{
	WK7ScriptOpe1(-);
}

// _ے
void WK7Script::ExecuteLogNotOpe(void)
{
	WK7ScriptOpe1(!);
}

// rbg]
void WK7Script::ExecuteBitRevOpe(void)
{
	WK7ScriptOpe1Cast(~);
}

void WK7Script::ExecuteMulOpe(void)
{
	WK7ScriptOpe2(*);
}

void WK7Script::ExecuteDivOpe(void)
{
	WK7ScriptOpe2(/);
}

void WK7Script::ExecuteAddOpe(void)
{
	WK7ScriptOpe2(+);
}

void WK7Script::ExecuteSubOpe(void)
{
	WK7ScriptOpe2(-);
}

void WK7Script::ExecuteLeOpe(void)
{
	WK7ScriptOpe2(<);
}

void WK7Script::ExecuteLeEquOpe(void)
{
	WK7ScriptOpe2(<=);
}

void WK7Script::ExecuteGrOpe(void)
{
	WK7ScriptOpe2(>);
}

void WK7Script::ExecuteGrEquOpe(void)
{
	WK7ScriptOpe2(>=);
}

void WK7Script::ExecuteEquOpe(void)
{
	WK7ScriptOpe2(==);
}

void WK7Script::ExecuteNotEquOpe(void)
{
	WK7ScriptOpe2(!=);
}

void WK7Script::ExecuteBitAndOpe(void)
{
	WK7ScriptOpe2Cast(&);
}

void WK7Script::ExecuteBitXorOpe(void)
{
	WK7ScriptOpe2Cast(^);
}

void WK7Script::ExecuteBitOrOpe(void)
{
	WK7ScriptOpe2Cast(|);
}

void WK7Script::ExecuteLogAndOpe(void)
{
	WK7ScriptOpe2(&&);
}

void WK7Script::ExecuteLogOrOpe(void)
{
	WK7ScriptOpe2(||);
}

void WK7Script::ExecuteSubstOpe(void)
{
#if 0
	WK7ScriptStackData	ldata,rdata;
	WSaveDataValPtr		ptr;
	// Eӎ擾
	mStack.Pop(&ritem);
	// ӎ擾
	mStack.Pop(&litem);
	// ϐ[Nւ̃|C^擾
	wSaveDataManager.GetValPtr(litem.Data,&ptr);
	// 
	switch( ritem.mType ){
	case	SL_SYMTP_LONG:
		switch( ptr.Type ){
		case	SL_SYMTP_CHAR:
			*((s_char *)ptr.pData) = (s_char)ritem.Value.Long;
			break;
		case	SL_SYMTP_SHORT:
			*((short  *)ptr.pData) = (short )ritem.Value.Long;
			break;
		case	SL_SYMTP_INT:
			*((int    *)ptr.pData) = (int   )ritem.Value.Long;
			break;
		case	SL_SYMTP_LONG:
			*((long   *)ptr.pData) = (long  )ritem.Value.Long;
			break;
		case	SL_SYMTP_FLOAT:
			*((float  *)ptr.pData) = (float )ritem.Value.Long;
			break;
		}
		break;
	case	SL_SYMTP_FLOAT:
		switch( ptr.Type ){
		case	SL_SYMTP_CHAR:
			*((s_char *)ptr.pData) = (s_char)ritem.Value.Float;
			break;
		case	SL_SYMTP_SHORT:
			*((short  *)ptr.pData) = (short )ritem.Value.Float;
			break;
		case	SL_SYMTP_INT:
			*((int    *)ptr.pData) = (int   )ritem.Value.Float;
			break;
		case	SL_SYMTP_LONG:
			*((long   *)ptr.pData) = (long  )ritem.Value.Float;
			break;
		case	SL_SYMTP_FLOAT:
			*((float  *)ptr.pData) = (float )ritem.Value.Float;
			break;
		}
		break;
	}
	// lޔ
	switch( ptr.Type ){
	case	SL_SYMTP_CHAR:
		PushExp     ((long)(*((s_char *)ptr.pData)));
		break;
	case	SL_SYMTP_SHORT:
		PushExp     ((long)(*((short  *)ptr.pData)));
		break;
	case	SL_SYMTP_INT:
		PushExp     ((long)(*((int    *)ptr.pData)));
		break;
	case	SL_SYMTP_LONG:
		PushExp     (       *((long   *)ptr.pData) );
		break;
	case	SL_SYMTP_FLOAT:
		PushExpFloat(       *((float  *)ptr.pData) );
		break;
	}
	// |C^XV
	mpEp  ++;
	mEpCnt++;
#endif
}

void WK7Script::ExecuteIfSentence(void)
{
	WK7ScriptStackData	data;
	bool				tf;
	// l擾
	mStack.Pop(&data);
	mStack.Clear();
	// l]
	switch( data.mType ){
	case	SL_SYMTP_FLOAT:
		if( data.mValue.mFloat ){
			tf = true;
		}else{
			tf = false;
		}
		break;
	case	SL_SYMTP_LONG:
		if( data.mValue.mLong ){
			tf = true;
		}else{
			tf = false;
		}
		break;
	case	SL_SYMTP_INT:
		if( data.mValue.mInt ){
			tf = true;
		}else{
			tf = false;
		}
		break;
	default:
#ifdef _DEBUG
		OSReport("Illegal IfExp Code %x\n",data.mData[0]);
#endif
		return;
	}
	if( tf==true ){
		mpEp   += 4;
		mEpCnt += 4;
	}else{
		mpEp   ++;
		mEpCnt ++;
	}
}

void WK7Script::ExecuteGotoSentence(void)
{
	WK7ScriptStackData	data;
	u32					reladdr;
	// l擾
	mStack.Pop(&data);
	mStack.Clear();
	// l]
	switch( data.mType ){
	case	SL_SYMTP_INT:
		reladdr = (u32)(data.mValue.mInt  - 2);
		break;
	case	SL_SYMTP_LONG:
		reladdr = (u32)(data.mValue.mLong - 2);
		break;
	case	SL_SYMTP_FLOAT:
	default:
#ifdef _DEBUG
		OSReport("Illegal GotoAddr Code %x\n",data.mData[0]);
#endif
		return;
	}
	mpEp   += reladdr;
	mEpCnt += (int)reladdr;
}

bool WK7Script::Pop(WK7ScriptStackData *pdata)
{
	return mStack.Pop(pdata);
}

s32 WK7Script::PopInt(void)
{
	WK7ScriptStackData		data;
	if( mStack.Pop(&data)==true ){
		switch( data.mType ){
		case	SL_SYMTP_FLOAT:
			return (s32)data.mValue.mFloat;
		case	SL_SYMTP_LONG:
			return (s32)data.mValue.mLong;
		case	SL_SYMTP_INT:
			return      data.mValue.mInt;
		default:
			return 0;
		}
	}
	return 0;
}

s64 WK7Script::PopLong(void)
{
	WK7ScriptStackData		data;
	if( mStack.Pop(&data)==true ){
		switch( data.mType ){
		case	SL_SYMTP_FLOAT:
			return (s64)data.mValue.mFloat;
		case	SL_SYMTP_LONG:
			return      data.mValue.mLong;
		case	SL_SYMTP_INT:
			return (s64)data.mValue.mInt;
		default:
			return 0;
		}
	}
	return 0;
}

f32 WK7Script::PopFloat(void)
{
	WK7ScriptStackData		data;
	if( mStack.Pop(&data)==true ){
		switch( data.mType ){
		case	SL_SYMTP_FLOAT:
			return      data.mValue.mFloat;
		case	SL_SYMTP_LONG:
			return (f32)data.mValue.mLong;
		case	SL_SYMTP_INT:
			return (f32)data.mValue.mInt;
		default:
			return 0.0f;
		}
	}
	return 0.0f;
}

bool WK7Script::TimeWaitTick(int tick)
{
	while( tick ){
		while( mStop ){
			GHMGCTASK_RETSYS();
		}
		GHMGCTASK_RETSYS();
		tick -= WK7_TICK_PER_FRAME;
	}
	return true;
}

bool WK7Script::TimeWaitSec(f32 sec)
{
	sec *= WK7_FRAME_RATE;
	while( sec > 0.0f ){
		while( mStop ){
			GHMGCTASK_RETSYS();
		}
		GHMGCTASK_RETSYS();
		sec -= 1.0f;
	}
	return true;
}

bool WK7Script::RetSys(void)
{
	while( mStop ){
		GHMGCTASK_RETSYS();
	}
	GHMGCTASK_RETSYS();
	return true;
}

bool WK7Script::SetParam(int index,u32 param)
{
	if( index < 0 || index >= WK7SCRIPT_PARAM_NUM ){
		return false;
	}
	mParam[index] = param;
	return true;
}

bool WK7Script::GetParam(int index,u32 &param)
{
	if( index < 0 || index >= WK7SCRIPT_PARAM_NUM ){
		return false;
	}
	param = mParam[index];
	return true;
}

u32 WK7Script::GetParam(int index)
{
	if( index < 0 || index >= WK7SCRIPT_PARAM_NUM ){
		return 0;
	}
	return mParam[index];
}

bool WK7Script::_ObjectCallMethod(u_short objType,u_short methodID,u_short objID)
{
	if( objType ){
		if( mpObjectType==NULL || objType-1 > mObjectTypeNum ){
			return false;
		}
		ObjectCallMethod		*pObjectCallMethod = mpObjectType[objType-1].mpMethod;
		if( pObjectCallMethod==NULL ){
			return false;
		}
		return pObjectCallMethod(this,methodID,objID);
	}
	int		iarg[2];
	switch( methodID ){
	case	0:	// RetSys
		PushExpInt(RetSys());
		break;
	case	1:	// TimeWaitTick
		PushExpInt(TimeWaitTick(PopInt()));
		break;
	case	2:	// TimeWait
		PushExpInt(TimeWaitSec(PopFloat()));
		break;
	case	3:	// SetFlag
		iarg[1] = PopInt();
		iarg[0] = PopInt();
		PushExpInt(SetFlag((u32)iarg[0],iarg[1]!=0));
		break;
	case	4:	// GetFlag
		PushExpInt(GetFlag((u32)PopInt()));
		break;
	default:
		return false;
	}
	return true;
}

//-----------------------------------------------------------------------------

WK7ScriptStack::WK7ScriptStack()
{
	mpSpTop = mWork;
	mpSp    = mpSpTop;
	mpSp[0] = 0;
	mSpCnt  = 0;
}

WK7ScriptStack::~WK7ScriptStack()
{
	Clear();
}

bool WK7ScriptStack::Push(u_short *data,u_short size)
{
	int		i;
	if( mSpCnt > WK7SCRIPTSTACK_WORKSIZE - size ){
#ifdef _DEBUG
		OSReport("Script Stack Over\n");
#endif
		return false;
	}
	if( size > WK7SCRIPT_STACK_DATA_SIZE || size <= 0 ){
#ifdef _DEBUG
		OSReport("Script Stack Data Size Error : Size %d\n",size);
#endif
		return false;
	}
	// f[^ۑ
	mpSp++;
	for(i=0 ; i<size ; i++){
		*mpSp++ = *data++;
	}
	// TCYۑ
	*mpSp = size;
	// JE^XV
	mSpCnt += (size + 1);
	return true;
}

s16 WK7ScriptStack::GetShortVal(void *pdata)
{
	u8		*pData = (u8 *)pdata;
	s16		val;
	val = (s16)(((u16)pData[0] << 8)|pData[1]);
	return val;
}

s32 WK7ScriptStack::GetIntVal(void *pdata)
{
	u8		*pData = (u8 *)pdata;
	s32		val;
	val = (s32)(((u32)pData[2] << 24)|((u32)pData[3] << 16)|((u32)pData[0] << 8)|pData[1]);
	return val;
}

s64 WK7ScriptStack::GetLongVal(void *pdata)
{
	u8		*pData = (u8 *)pdata;
	s64		val;
	val = (s64)(((u64)pData[6] << 56)|
	            ((u64)pData[7] << 48)|
	            ((u64)pData[4] << 40)|
	            ((u64)pData[5] << 32)|
	            ((u64)pData[2] << 24)|
	            ((u64)pData[3] << 16)|
	            ((u64)pData[0] <<  8)|
	                  pData[1]       );
	return val;
}

bool WK7ScriptStack::Pop(WK7ScriptStackData* pStackData)
{
	int		i;
	u_short	*data;
	if( mSpCnt==0 ){
#ifdef _DEBUG
		OSReport("Stack Empty\n");
#endif
		return false;
	}
	// TCY擾
	pStackData->mSize = (u_char)*mpSp--;
	// f[^擾
	data = pStackData->mData + pStackData->mSize - 1;
	for(i=0 ; i<pStackData->mSize ; i++){
		*data-- = *mpSp--;
	}
	mSpCnt -= (pStackData->mSize + 1);
	// X^bNl]
	switch( pStackData->mData[0] & SL_SYMTP_MASK ){
	case	SL_SYMTP_NUM:
		switch( pStackData->mData[0] & SL_SYMTP_VTYPE_MASK ){
		case	SL_SYMTP_CHAR:
			pStackData->mValue.mInt   = GetShortVal(pStackData->mData + 1);
			pStackData->mType         = SL_SYMTP_INT;
			break;
		case	SL_SYMTP_SHORT:
			pStackData->mValue.mInt   = GetShortVal(pStackData->mData + 1);
			pStackData->mType         = SL_SYMTP_INT;
			break;
		case	SL_SYMTP_INT:
			pStackData->mValue.mInt   = GetIntVal  (pStackData->mData + 1);
			pStackData->mType         = SL_SYMTP_INT;
			break;
		case	SL_SYMTP_LONG:
			pStackData->mValue.mLong  = GetLongVal (pStackData->mData + 1);
			pStackData->mType         = SL_SYMTP_LONG;
			break;
		case	SL_SYMTP_FLOAT:
			pStackData->mValue.mInt   = GetIntVal  (pStackData->mData + 1);
			pStackData->mType         = SL_SYMTP_FLOAT;
			break;
		default:
#ifdef _DEBUG
			OSReport("Stack Value Illegal NumType : Code %x\n",pStackData->mData[0]);
#endif
			return false;
		}
		break;
#if 0
	case	SL_SYMTP_VAL:{
		WSaveDataValPtr		ptr;
		// ϐ[Nւ̃|C^擾
		wSaveDataManager.GetValPtr(pStackData->mData,&ptr);
		switch( ptr.Type ){
		case	SL_SYMTP_CHAR:
			pStackData->mValue.mShort = *((s8  *)ptr.pData);
			pStackData->mType         = SL_SYMTP_SHORT;
			break;
		case	SL_SYMTP_SHORT:
			pStackData->mValue.mShort = *((s16 *)ptr.pData);
			pStackData->mType         = SL_SYMTP_SHORT;
			break;
		case	SL_SYMTP_INT:
			pStackData->mValue.mInt   = *((s32 *)ptr.pData);
			pStackData->mType         = SL_SYMTP_INT;
			break;
		case	SL_SYMTP_LONG:
			pStackData->mValue.mLong  = *((s64 *)ptr.pData);
			pStackData->mType         = SL_SYMTP_LONG;
			break;
		case	SL_SYMTP_FLOAT:
			pStackData->mValue.mFloat = *((f32 *)ptr.pData);
			pStackData->mType         = SL_SYMTP_FLOAT;
			break;
		default:
#ifdef _DEBUG
			OSReport("Stack Value Illegal ValType : Code %x\n",pStackData->mData[0]);
#endif
			return false;
		}
		}break;
#endif
	default:
#ifdef _DEBUG
		OSReport("Stack Value Type Error : Code %x\n",pStackData->mData[0]);
#endif
		return false;
	}
	return true;
}

void WK7ScriptStack::Clear(void)
{
	mpSpTop = mWork;
	mpSp    = mpSpTop;
	mpSp[0] = 0;
	mSpCnt  = 0;
}

