////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Shadow
//
// WK7Shadow.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/13/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7SHADOW_CPP__

#include ".\WK7Shadow.h"
#include ".\WK7Cam.h"
#include ".\WK7Chara.h"
#include ".\WK7Stage.h"
#include ".\WK7Item.h"

WK7Shadow*	WK7Shadow::gpShadow = NULL;

static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 2.000000f },		// wobj position
};

static	HSD_LightDesc shadow_dir_light = {
	NULL,
	NULL,										// link
	LOBJ_INFINITE|LOBJ_DIFFUSE,					// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{ 128, 128, 128, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	NULL,
};

static HSD_SceneLightSet shadow_dir_lightset = {
	&shadow_dir_light,
	NULL,
};

WK7Shadow::WK7Shadow() : mShadow(512,512)//(WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT)
{
	ghmGcMemSetAllocName("C_LObj");
	mpLObj = new C_LObj(new (&shadow_dir_lightset) C_LightSet);
//	mViewDist = 200.0f;
//	mViewDist = 100.0f;
	mViewDist = WK7SHADOW_VIEWDIST_DEF;
	mViewDistManual = false;
	mCameraFov = 60.0f;
	mCameraPosition.x = 0.0f;
	mCameraPosition.y = 0.0f;
	mCameraPosition.z = 0.0f;
	mCameraDirection.x = 0.0f;
	mCameraDirection.y = 0.0f;
	mCameraDirection.z = 1.0f;
	mLightDirection.x = 0.0f;
	mLightDirection.y = 1.0f;
	mLightDirection.z = 0.5f;
	mpShadowLObj = NULL;
	mRender = false;
	mTargetPosition.x = 0.0f;
	mTargetPosition.y = 0.0f;
	mTargetPosition.z = 0.0f;
	mEnableAdjust = true;
	mMinRadius = 10.0f;
	SetInitMinRadius();
}

WK7Shadow::~WK7Shadow()
{
	GHM_SAFE_DELETE(mpLObj);
}

bool WK7Shadow::Initialize(void)
{
	if( gpShadow==NULL ){
		ghmGcMemSetAllocName("WK7Shadow");
		gpShadow = new WK7Shadow;
	}
	return true;
}

bool WK7Shadow::Terminate(void)
{
	GHM_SAFE_DELETE(gpShadow);
	return true;
}

void WK7Shadow::SetLight(HSD_LObj *pLObj)
{
	mpShadowLObj = pLObj;
	mRender = false;
}

bool WK7Shadow::FrameProcess(void)
{
	HSD_CObj			*pCObj;
	
	WK7CastShadowObj	*pCastObj    = (WK7CastShadowObj *)mCastShadowObjAnchor.GetNext();
	WK7ReceiveShadowObj	*pReceiveObj = (WK7ReceiveShadowObj *)mReceiveShadowObjAnchor.GetNext();
	
	pCObj = HSD_CObjGetCurrent();
//		pCObj = WK7CAM->GetCObj();
	WK7JObj::SetViewVolume(pCObj);
	
	if( pCObj!=NULL &&
//	if( (pCObj = HSD_CObjGetCurrent())!=NULL &&
	    mEnable==true &&
	    pCastObj!=NULL &&
	    pReceiveObj!=NULL &&
	    mpShadowLObj!=NULL ){
		
//		int		targetPosSet = 0;
//		Vec		targetPos    = { 0.0f,0.0f,0.0f };
//		
//		for( ; pCastObj!=NULL ; pCastObj=pCastObj->GetNext()){
//			WK7JObj		*pJObj = pCastObj->GetK7JObj();
//			if( pCastObj->GetVisible()==false ||
//			    pJObj                 ==NULL  ||
//			    pJObj->IsHidden()     ==true  ){
//				continue;
//			}
//			HSD_JObj	*pHSDJObj = pJObj->GetJObj();
//			if( pHSDJObj==NULL ){
//				continue;
//			}
//			if( HSD_JObjGetFlags(pHSDJObj) & JOBJ_HIDDEN ){
//				continue;
//			}
//			Vec		pos;
//			switch( pJObj->GetBoundState() ){
//			case	ghmGcCollObj::CROSSOVER:
//			case	ghmGcCollObj::INSIDE:
//				pJObj->GetWorldPosition(pos);
//				targetPosSet++;
//				VECAdd(&targetPos,&pos,&targetPos);
//				break;
//			default:
//				continue;
//			}
//		}
//		if( targetPosSet > 0 ){
//			VECScale(&targetPos,&mTargetPosition,1.0f / targetPosSet);
//		}
		
		switch( HSD_LObjGetType(mpShadowLObj) ){
		case	LOBJ_INFINITE:
//			HSD_LObjGetPosition(mpShadowLObj,&mLightDirection);
			break;
		case	LOBJ_POINT:{
//			HSD_LObjGetPosition(mpShadowLObj,&mLightDirection);
//			VECSubtract(&mLightDirection,&mTargetPosition,&mLightDirection);
			}break;
		case	LOBJ_SPOT:
		case	LOBJ_AMBIENT:
		default:
			mRender = false;
			return false;
		}
		mRender = true;
		
		pCObj = WK7CAM->GetCObj();
		// CastShadowObjŕKvȂߌvZ
//		HSD_CObjGetEyePosition(pCObj,&mCameraPosition);
//		HSD_CObjGetInterest   (pCObj,&mCameraDirection);
//		VECSubtract(&mCameraDirection,&mCameraPosition,&mCameraDirection);
//		VECNormalize(&mCameraDirection,&mCameraDirection);
		
		MtxPtr		vmtx = WK7CAM->GetViewingMtxPtrCurrent();	//GetViewingMtxPtr();
		Mtx			ivmtx;
		
		MTXTranspose(vmtx,ivmtx);
		mCameraPosition.x = -vmtx[0][3];
		mCameraPosition.y = -vmtx[1][3];
		mCameraPosition.z = -vmtx[2][3];
		MTXMultVecSR(ivmtx,&mCameraPosition,&mCameraPosition);
		mCameraDirection.x = -ivmtx[0][2];
		mCameraDirection.y = -ivmtx[1][2];
		mCameraDirection.z = -ivmtx[2][2];
		
		mCameraFov         = WK7CAM->GetFov();
//#define	SHADOW_VIEWDISTPARAM		(5774.0f)		// 100^2 * tan(30) = 5774.0f
#define	SHADOW_VIEWDISTPARAM		(8313.6f)
		if( mViewDistManual==false ){
			mViewDist = sqrtf(SHADOW_VIEWDISTPARAM / tanf(mCameraFov * 0.5f * PI / 180.0f));
		}
		
		mVisibleDist = 0.0f;
		mVisibleNum  = 0;
		
		mViewVolume.SetCurrent(pCObj);
		
	}
	
	int		castObjCount = 0;
	mTargetPosition.x = 0.0f;
	mTargetPosition.y = 0.0f;
	mTargetPosition.z = 0.0f;
	pCastObj = (WK7CastShadowObj *)mCastShadowObjAnchor.GetNext();
	while( pCastObj!=NULL ){
		if( pCastObj->FrameProcess()==true ){
			castObjCount++;
		}
		pCastObj = pCastObj->GetNext();
	}
	if( castObjCount > 0 ){
		VECScale(&mTargetPosition,&mTargetPosition,1.0f / castObjCount);
	}
	while( pReceiveObj!=NULL ){
		pReceiveObj->FrameProcess();
		pReceiveObj = pReceiveObj->GetNext();
	}
	
	if( mVisibleNum > 0 ){
		mVisibleDist /= mVisibleNum;
	}
	
	WK7JObj::SetViewVolume(NULL);
	
	return true;
}

#define	FLOAT_ERROR			(0.00001f)
bool WK7Shadow::RenderProcess(void)
{
	if( mCastShadowObjAnchor.GetNext()==NULL ||
	    mReceiveShadowObjAnchor.GetNext()==NULL ||
	    mRender==false ||
	    mEnable==false ){
		return true;
	}

	f32					r = mMinRadius;//10.0f;
//	f32					r = 15.0f;
	Vec					tgtpos,ldir;
	WK7CastShadowObj	*pCastObj;
	WK7ReceiveShadowObj	*pReceiveObj;
	
	tgtpos = mTargetPosition;
	
	switch( HSD_LObjGetType(mpShadowLObj) ){
	case	LOBJ_INFINITE:
		HSD_LObjGetPosition(mpShadowLObj,&mLightDirection);
		break;
	case	LOBJ_POINT:{
		HSD_LObjGetPosition(mpShadowLObj,&mLightDirection);
		VECSubtract(&mLightDirection,&mTargetPosition,&mLightDirection);
		if( VECMag(&mLightDirection) < FLOAT_ERROR ){
			mLightDirection.x = 0.0f;
			mLightDirection.y = 1.0f;
			mLightDirection.z = 0.0f;
		}
		}break;
	case	LOBJ_SPOT:
	case	LOBJ_AMBIENT:
	default:
		return false;
	}
	
	if( mEnableAdjust==true ){
		f32		zx,y,ang;
		VECNormalize(&mLightDirection,&mLightDirection);
		ldir.x = mLightDirection.x;
		ldir.y = 0.0f;
		ldir.z = mLightDirection.z;
		zx     = GHM_VEC_GET_LEN(&ldir);
		y      = GHM_FABS(mLightDirection.y);
		ang    = atan2f(zx,ldir.y);
		if( ang > D2R(30.0f) ){
			VECNormalize(&ldir,&ldir);
			VECScale    (&ldir,&ldir,tanf(D2R(30.0f)));
			ldir.y = 1.0f;
			VECNormalize(&ldir,&ldir);
		}else{
			ldir = mLightDirection;
		}
	}else{
		ldir = mLightDirection;
	}
	
#define	DIST_SPACE		(20.0f)
#define	MIN_MAXDIST		(10.0f)
	f32		maxdist = MIN_MAXDIST,dist;
	f32		mindist = 1000.0f;
	
	if( VECMag(&ldir) >= FLOAT_ERROR ){
		
		Vec		nldir;
		
		VECNormalize(&ldir,&nldir);
		
		for(pCastObj=(WK7CastShadowObj *)mCastShadowObjAnchor.GetNext() ; pCastObj!=NULL ; pCastObj=pCastObj->GetNext()){
			if( pCastObj->GetAddJObj()==false ){
				continue;
			}
			dist = pCastObj->CalcTargetDist(tgtpos,nldir);
			if( maxdist < dist + DIST_SPACE ){
				maxdist = dist + DIST_SPACE;
			}
			if( mindist > dist - DIST_SPACE ){
				mindist = dist - DIST_SPACE;
			}
		}
		
//		VECScale(&nldir,&nldir,maxdist);
//		VECAdd  (&tgtpos,&nldir,&tgtpos);
		
	}
	
	mShadow.SetShadowCamDist(maxdist);
	
	maxdist -= mindist;
	if( maxdist < MIN_MAXDIST ){
		maxdist = MIN_MAXDIST;
	}
	
	mShadow.SetShadowCamFar (maxdist);
//	mShadow.SetShadowCamFar (maxdist * 1.5f);
//	mShadow.SetShadowCamNear(mindist * 0.5f);
	mShadow.SetShadowCamNear(0.1f);
	
	HSD_LObjSetPosition(mpLObj->GetLObj(),&ldir);
	mShadow.SetLight (mpLObj);
	mShadow.SetCamera(tgtpos,maxdist);
//	mShadow.SetCamera(tgtpos,1000.0f);
//	mShadow.SetCamera(camdir,1000.0f);
	
	mShadow.InitViewingRect  (r,-r,-r,r);
	
	pCastObj = (WK7CastShadowObj *)mCastShadowObjAnchor.GetNext();
	while( pCastObj!=NULL ){
		pCastObj->AddViewingRect(mShadow);
		pCastObj = pCastObj->GetNext();
	}
//	mShadow.AddViewingRect   (r,-r,-r,r);
	
	mShadow.CheckViewingRect ();
	mShadow.StartRenderShadow();
	
//	{
//	  HSD_CObj	*pCObj = WK7CAM->GetCObj();
//	  WK7CastShadowObj	*pCastObj = (WK7CastShadowObj *)mCastShadowObjAnchor.GetNext();
//	  WK7JObj			*pJObj;
//	  u32 c = 0;
//	  for( ; pCastObj!=NULL ; pCastObj = pCastObj->GetNext()){
//		if( (pJObj=pCastObj->GetK7JObj())==NULL ||
//		    pCastObj->GetShadow()->ObjExist()==false ||
//		    pCastObj->GetK7JObj()->IsHidden()==true  ){
//			continue;
//		}
//		HSD_JObj	*pHSDJObj = pJObj->GetJObj();
//		if( pHSDJObj==NULL ){
//			continue;
//		}
//		if( HSD_JObjGetFlags(pHSDJObj) & JOBJ_HIDDEN ){
//			continue;
//		}
//		WK7JObj::SetViewVolume(pCObj);
//		switch( pJObj->GetBoundState() ){
//		case	ghmGcCollObj::CROSSOVER:
//		case	ghmGcCollObj::INSIDE:
//			WK7JObj::SetViewVolume(NULL);
//			pCastObj->GetK7JObj()->RenderProcess(false,true,HSD_TRSP_OPA,RENDER_SHADOW);
//			c++;
//			break;
//		default:
//			WK7JObj::SetViewVolume(NULL);
//			break;
//		}
//	  }
//	}
//	mShadow.EndRenderShadow  ();
	
	pCastObj = (WK7CastShadowObj *)mCastShadowObjAnchor.GetNext();
	while( pCastObj!=NULL ){
	  //`lƂݒ肵Ă܂z炵B
	  //[jOo܂̂ŁA蓮ŖݒBfujita
	  GXSetColorUpdate( GX_ENABLE );
	  GXSetAlphaUpdate( GX_FALSE );
	  GXSetDstAlpha( GX_FALSE, 0 );
	  GXSetChanCtrl(GX_COLOR0A0,
					GX_DISABLE,		// enable channel
					GX_SRC_REG,		// amb source
					GX_SRC_REG,		// mat source
					GX_LIGHT_NULL,	// light mask
					GX_DF_CLAMP,	// diffuse function
					GX_AF_NONE);
	  GXSetNumChans(1);
	  GXSetChanMatColor( GX_COLOR0A0, (GXColor){ 0,0,0,255} );
	  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
	  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
	  GXSetNumTevStages(1);
	  GXSetNumTexGens(0);
	  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);

		pCastObj->RenderProcess();
		pCastObj = pCastObj->GetNext();
	}
	mShadow.EndRenderShadow  ();
	
	pReceiveObj = (WK7ReceiveShadowObj *)mReceiveShadowObjAnchor.GetNext();
	while( pReceiveObj!=NULL ){
		pReceiveObj->RenderProcess();
		pReceiveObj = pReceiveObj->GetNext();
	}
	return true;
}

bool WK7Shadow::ReleaseJObj(WK7JObj *pJObj)
{
	WK7Shadow		*pShadow = WK7Shadow::GetInstance();
	if( pShadow==NULL ){
		return false;
	}
	pShadow->DeleteCastShadowObj   (pJObj);
	pShadow->DeleteReceiveShadowObj(pJObj);
	return true;
}

WK7CastShadowObj* WK7Shadow::AddCastShadowObj(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return false;
	}
	ghmGcMemSetAllocName("CastShdw");
	WK7CastShadowObj	*pObj = new WK7CastShadowObj(this,pJObj,&mCastShadowObjAnchor);
	return pObj;
}

bool WK7Shadow::DeleteCastShadowObj(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return false;
	}
	WK7CastShadowObj	*pObj = (WK7CastShadowObj *)mCastShadowObjAnchor.GetNext();
	WK7CastShadowObj	*pNext;
	while( pObj != NULL ){
		pNext = pObj->GetNext();
		if( pObj->GetJObj()==pJObj ){
			delete pObj;
		}
		pObj = pNext;
	}
	return true;
}

bool WK7Shadow::DeleteCastShadowObj(WK7RenderObj *pRenderObj)
{
	WK7CastShadowObj	*pCastShadowObj = FindCastShadowObj(pRenderObj);
	if( pCastShadowObj==NULL ){
		return false;
	}
	return DeleteCastShadowObj(pCastShadowObj);
}

bool WK7Shadow::DeleteCastShadowObj(WK7CastShadowObj *pCastShadowObj)
{
	if( pCastShadowObj==NULL ){
		return false;
	}
	WK7CastShadowObj	*pObj = (WK7CastShadowObj *)mCastShadowObjAnchor.GetNext();
	for(pObj=(WK7CastShadowObj *)mCastShadowObjAnchor.GetNext() ; pObj!=NULL ; pObj=pObj->GetNext()){
		if( pObj==pCastShadowObj ){
			delete pObj;
			return true;
		}
	}
	return false;
}

WK7CastShadowObj* WK7Shadow::FindCastShadowObj(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return NULL;
	}
	WK7CastShadowObj	*pObj = (WK7CastShadowObj *)mCastShadowObjAnchor.GetNext();
	while( pObj != NULL ){
		if( pObj->GetJObj()==pJObj ){
			return pObj;
		}
		pObj = pObj->GetNext();
	}
	return NULL;
}

WK7CastShadowObj* WK7Shadow::FindCastShadowObj(WK7RenderObj *pRenderObj)
{
	if( pRenderObj==NULL ){
		return NULL;
	}
	WK7CastShadowObj	*pObj = (WK7CastShadowObj *)mCastShadowObjAnchor.GetNext();
	while( pObj != NULL ){
		if( pObj->GetRenderObj()==pRenderObj ){
			return pObj;
		}
		pObj = pObj->GetNext();
	}
	return NULL;
}

WK7ReceiveShadowObj* WK7Shadow::AddReceiveShadowObj(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return false;
	}
	ghmGcMemSetAllocName("RecvShdw");
	WK7ReceiveShadowObj	*pObj = new WK7ReceiveShadowObj(this,pJObj,&mReceiveShadowObjAnchor);
	return pObj;
}

bool WK7Shadow::DeleteReceiveShadowObj(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return true;
	}
	WK7ReceiveShadowObj	*pObj = (WK7ReceiveShadowObj *)mReceiveShadowObjAnchor.GetNext();
	WK7ReceiveShadowObj	*pNext;
	while( pObj != NULL ){
		pNext = pObj->GetNext();
		if( pObj->GetJObj()==pJObj ){
			delete pObj;
		}
		pObj = pNext;
	}
	return true;
}

WK7ReceiveShadowObj* WK7Shadow::FindReceiveShadowObj(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return NULL;
	}
	WK7ReceiveShadowObj	*pObj = (WK7ReceiveShadowObj *)mReceiveShadowObjAnchor.GetNext();
	while( pObj != NULL ){
		if( pObj->GetJObj()==pJObj ){
			return pObj;
		}
		pObj = pObj->GetNext();
	}
	return NULL;
}

WK7Shadow* WK7Shadow::GetInstance(void)
{
	if( gpShadow==NULL ){
		ghmGcMemSetAllocName("WK7Shadow");
		gpShadow = new WK7Shadow;
	}
	return gpShadow;
}

//------------------------------------------------------------------------------

WK7ShadowObj::WK7ShadowObj(WK7Shadow *pShadow,WK7JObj *pJObj,ghmGcListObj *pAnchor,int prio) : WK7Obj(pAnchor,prio)
{
	mpShadow = pShadow;
	mpJObj   = pJObj;
	mVisible = false;
}

WK7ShadowObj::~WK7ShadowObj()
{
}

C_Shadow* WK7ShadowObj::GetShadow(void)
{
	if( mpShadow==NULL ){
		return NULL;
	}
	return mpShadow->GetShadow();
}

HSD_JObj* WK7ShadowObj::GetHSDJObj(void)
{
	if( mpJObj==NULL ){
		return NULL;
	}
	return mpJObj->GetJObj();
}

bool WK7ShadowObj::SetVisible(bool flag)
{
	mVisible = flag;
	return true;
}

//------------------------------------------------------------------------------

WK7CastShadowObj::WK7CastShadowObj(WK7Shadow *pShadow,WK7JObj *pJObj,ghmGcListObj *pAnchor,int prio) :
WK7ShadowObj(pShadow,pJObj,pAnchor,prio)
{
	mAddJObj        = false;
	mpRenderObj     = NULL;
	mTrspMask       = HSD_TRSP_OPA;
	SetVisible(true);
	SetCollSphereRadius();
}

WK7CastShadowObj::~WK7CastShadowObj()
{
	SetVisible(false);
	DeleteJObj();
}

bool CheckBoundState(WK7JObj *pJObj,bool next,bool child);
bool CheckBoundState(WK7JObj *pJObj,bool next,bool child)
{
	switch( pJObj->GetBoundState() ){
	case	ghmGcCollObj::CROSSOVER:
	case	ghmGcCollObj::INSIDE:
		return true;
	default:
		break;
	}
	if( child==true && pJObj->GetChild()!=NULL ){
		if( CheckBoundState(pJObj->GetChild(),true,true)==true ){
			return true;
		}
	}
	if( next==true && pJObj->GetNext()!=NULL ){
		if( CheckBoundState(pJObj->GetNext(),true,child)==true ){
			return true;
		}
	}
	return false;
}

bool WK7CastShadowObj::SetCollSphereRadius(f32 r)
{
	if( r < 0.0f ){
		mSphere.mRadius = 10.0f;
		return false;
	}
	mSphere.mRadius = r;
	return true;
}

f32 WK7CastShadowObj::GetCollSphereRadius(void)
{
	return mSphere.mRadius;
}

bool WK7CastShadowObj::FrameProcess(void)
{
	if( mVisible             ==false ||
	    mpJObj               ==NULL  ||
	    mpJObj->IsHidden()   ==true  ||
	    mpJObj->GetCastShadowDisable(false,true)==true ||
//	    mpJObj->HasAlpha(false,true)==true  ||
	    mpShadow             ==NULL  ||
	    mpShadow->GetEnable()==false ||
	    mpShadow->GetRender()==false ){
		DeleteJObj();
		return false;
	}
	if( mpRenderObj!=NULL ){
		if( mpRenderObj->GetRenderFlag()==false ){
			DeleteJObj();
			return false;
		}
		switch( mpRenderObj->GetType() ){
		case	K7OBJTYPE_CHR:
			if( WK7Chara::GetRenderChara()==false ){
				DeleteJObj();
				return false;
			}
			break;
		case	K7OBJTYPE_STG:
			if( WK7Stage::GetRenderStage()==false ){
				DeleteJObj();
				return false;
			}
			break;
		case	K7OBJTYPE_ITEM:
			if( WK7Item::GetRenderItem()==false ){
				DeleteJObj();
				return false;
			}
			break;
		default:
			break;
		}
	}
	HSD_JObj	*pHSDJObj = mpJObj->GetJObj();
	if( pHSDJObj==NULL || (HSD_JObjGetFlags(pHSDJObj) & JOBJ_HIDDEN) ){
		DeleteJObj();
		return false;
	}
	ghmGcViewVolume		*pViewVolume = mpShadow->GetViewVolume();
	if( pViewVolume==NULL ){
		DeleteJObj();
		return false;
	}
	const Vec	*pcampos = mpShadow->GetCameraPosition();
	const Vec	*pcamdir = mpShadow->GetCameraDirection();
	f32			dist;
	mpJObj->GetWorldPosition(mSphere.mPosition);
	
	switch( pViewVolume->GetCrossState(mSphere) ){
	case	ghmGcCollObj::CROSSOVER:
	case	ghmGcCollObj::INSIDE:
		if( (dist=GHM_VEC_GET_DIST(pcampos,&mSphere.mPosition)) < mpShadow->GetViewDist() ){
			Vec		dir;
			VECSubtract(&mSphere.mPosition,pcampos,&dir);
			dist = VECDotProduct(&dir,pcamdir);
			mpShadow->AddVisibleDist(dist);
			AddJObj();
			
			Vec		tgtpos;
			VECAdd(&mSphere.mPosition,mpShadow->GetTargetPosition(),&tgtpos);
			mpShadow->SetTargetPosition(tgtpos);
			
		}else{
			DeleteJObj();
			return false;
		}
		break;
	case	ghmGcCollObj::OUTSIDE:
	default:
		if( CheckBoundState(mpJObj,false,true)==false ){
			DeleteJObj();
			return false;
		}
		break;
	}
	
	return true;
}

bool WK7CastShadowObj::RenderProcess(void)
{
	if( mAddJObj==false ){
		return false;
	}
	
	if( mpJObj!=NULL ){
	  	mpJObj->RenderProcess(false,true,mTrspMask,RENDER_SHADOW);
//		mpJObj->RenderProcess(false,true,HSD_TRSP_OPA,RENDER_SHADOW);
	}
	
	return true;
}

bool WK7CastShadowObj::AddJObj(void)
{
	HSD_JObj		*pJObj;
	C_Shadow		*pShadow;
	if( mAddJObj==true ){
		return false;
	}
	if( (pJObj=GetHSDJObj())!=NULL && (pShadow=GetShadow())!=NULL ){
		pShadow->AddObject(pJObj);
	}
	mAddJObj = true;
	return true;
}

bool WK7CastShadowObj::DeleteJObj(void)
{
	HSD_JObj		*pJObj;
	C_Shadow		*pShadow;
	if( mAddJObj==false ){
		return false;
	}
	if( (pJObj=GetHSDJObj())!=NULL && (pShadow=GetShadow())!=NULL ){
		pShadow->DeleteObject(pJObj);
	}
	mAddJObj = false;
	return true;
}

f32 WK7CastShadowObj::CalcTargetDist(Vec &tgtpos,Vec &dir,WK7JObj *pJObj,bool next)
{
	if( mAddJObj==false ){
		return 0.0f;
	}
	
	Vec				pos;
	WK7JObjBound	*pBound;
	MtxPtr			lwmat;
	f32				dist,tdist;
	
//	lwmat = pJObj->GetLocalWorldMatrix();
	lwmat = pJObj->GetMtxPtr();
	
	if( (pBound=pJObj->GetBound())!=NULL ){
		switch( pBound->GetType() ){
		case	WK7JObjBound::SPHERE:{
			WK7JObjBoundSphere	*pBoundSphere = (WK7JObjBoundSphere *)pBound;
			ghmGcCollSphere		*pCollSphere  = pBoundSphere->GetBound();
			dist = pCollSphere->mRadius;
			}break;
		case	WK7JObjBound::BOX:{
			WK7JObjBoundBox		*pBoundBox    = (WK7JObjBoundBox     *)pBound;
			ghmGcCollBox		*pCollBox     = pBoundBox->GetBound();
			MTXMultVecSR(lwmat,&pCollBox->mExtent,&pos);
			dist  = fabs(pos.x);
			tdist = fabs(pos.y);
			if( dist < tdist ){
				dist = tdist;
			}
			tdist = fabs(pos.z);
			if( dist < tdist ){
				dist = tdist;
			}
			}break;
		default:
			dist = 0.0f;
			break;
		}
		pos = *pBound->GetCenter();
	}else{
		dist = 0.0f;
		pos.x=pos.y=pos.z=0.0f;
	}
	
	MTXMultVec   (lwmat,&pos,&pos);
	VECSubtract  (&pos,&tgtpos,&pos);
	dist += VECDotProduct(&pos,&dir);
	
	if( pJObj->GetChild()!=NULL ){
		tdist = CalcTargetDist(tgtpos,dir,pJObj->GetChild(),true);
		if( dist < tdist ){
			dist = tdist;
		}
	}
	
	if( next==true && pJObj->GetNext()!=NULL ){
#if 1
		tdist = CalcTargetDist(tgtpos,dir,pJObj->GetNext(),false);
		if( dist < tdist ){
			dist = tdist;
		}
#else
		// {͂̂AdȂĂ܂̂ŁEEE
		for(pJObj=pJObj->GetNext() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
			tdist = CalcTargetDist(tgtpos,dir,pJObj,false);
			if( dist < tdist ){
				dist = tdist;
			}
		}
#endif
	}
	
	return dist;
}

f32 WK7CastShadowObj::CalcTargetDist(Vec &tgtpos,Vec &tgtdir)
{
	if( mpJObj==NULL ){
		return 0.0f;
	}
	return CalcTargetDist(tgtpos,tgtdir,mpJObj,false);
}

void WK7CastShadowObj::AddViewingRect(HSD_ViewingRect *pvrect,WK7JObj *pJObj,bool next)
{
	Vec				pos;
	WK7JObjBound	*pBound;
	f32				t,b,l,r;
	
	MtxPtr			lwmat;
	
	lwmat = pJObj->GetMtxPtr();
	
//	pJObj->GetWorldPosition(pos);
	
	if( (pBound=pJObj->GetBound())==NULL ){
		t=r=3.0f;
//		t=r=15.0f;
		pos.x=pos.y=pos.z=0.0f;
	}else{
		pos = *pBound->GetCenter();
		switch( pBound->GetType() ){
		case	WK7JObjBound::SPHERE:{
			WK7JObjBoundSphere	*pBoundSphere = (WK7JObjBoundSphere *)pBound;
			ghmGcCollSphere		*pCollSphere  = pBoundSphere->GetBound();
			t=r=pCollSphere->mRadius;
			}break;
		case	WK7JObjBound::BOX:{
			WK7JObjBoundBox		*pBoundBox    = (WK7JObjBoundBox     *)pBound;
			ghmGcCollBox		*pCollBox     = pBoundBox->GetBound();
			r = sqrtf(pCollBox->mExtent.x * pCollBox->mExtent.x
			         +pCollBox->mExtent.y * pCollBox->mExtent.y
			         +pCollBox->mExtent.z * pCollBox->mExtent.z);
//			r = pCollBox->mExtent.x;
//			if( r < pCollBox->mExtent.y ){
//				r = pCollBox->mExtent.y;
//			}
//			if( r < pCollBox->mExtent.z ){
//				r = pCollBox->mExtent.z;
//			}
			t=r;
			}break;
		default:
			t=r=15.0f;
			break;
		}
	}
	b=l=-r;
	
	MTXMultVec(lwmat,&pos,&pos);
	
	HSD_ViewingRectAddRect(pvrect,&pos,t,b,l,r);
	
	if( pJObj->GetChild()!=NULL ){
		AddViewingRect(pvrect,pJObj->GetChild(),true);
	}
#if 0
	if( next==true && pJObj->GetNext()!=NULL ){
		AddViewingRect(pvrect,pJObj->GetNext(),false);
	}
#else
	if( next==true ){
		for(pJObj=pJObj->GetNext() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
			AddViewingRect(pvrect,pJObj,false);
		}
	}
#endif
}

void WK7CastShadowObj::AddViewingRect(C_Shadow &shadow)
{
	if( mpJObj==NULL || mAddJObj==false ){
		return;
	}
	HSD_ViewingRect	*pvrect = shadow.GetViewingRect();
	AddViewingRect(pvrect,mpJObj);
}

//------------------------------------------------------------------------------

WK7ReceiveShadowObj::WK7ReceiveShadowObj(WK7Shadow *pShadow,WK7JObj *pJObj,ghmGcListObj *pAnchor,int prio) :
WK7ShadowObj(pShadow,pJObj,pAnchor,prio)
{
	mSetShadow = false;
	SetVisible(true);
}

WK7ReceiveShadowObj::~WK7ReceiveShadowObj()
{
	SetVisible(false);
	ClearShadow();
}

bool WK7ReceiveShadowObj::SetShadow(void)
{
	HSD_JObj		*pJObj;
	C_Shadow		*pShadow;
	if( mSetShadow==true ){
		return false;
	}
	if( (pJObj=GetHSDJObj())!=NULL && (pShadow=GetShadow())!=NULL ){
		pShadow->SetShadow(pJObj);
	}
	mSetShadow = true;
	return true;
}

bool WK7ReceiveShadowObj::ClearShadow(void)
{
	HSD_JObj		*pJObj;
	C_Shadow		*pShadow;
	if( mSetShadow==false ){
		return false;
	}
	if( (pJObj=GetHSDJObj())!=NULL && (pShadow=GetShadow())!=NULL ){
		pShadow->ClearShadow(pJObj);
	}
	mSetShadow = false;
	return true;
}

bool WK7ReceiveShadowObj::FrameProcess(void)
{
	if( mVisible==false || mpJObj==NULL || mpShadow==NULL || mpShadow->GetEnable()==false ){
		ClearShadow();
		return true;
	}
	if( mpShadow->GetRender()==false ){
		ClearShadow();
		return true;
	}
	SetShadow();
	return true;
}

bool WK7ReceiveShadowObj::RenderProcess(void)
{
	return true;
}

