////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Shadow
//
// WK7Shadow.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/13/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7SHADOW_H__
#define	__WK7SHADOW_H__

//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
//#include "..\Lib\ghmGcColl.h"
#include "..\Fujita\C_Shadow.h"
#include ".\WK7Model.h"
#include ".\WK7Obj.h"

#define	WK7SHADOW_VIEWDIST_DEF			(100.0f)

class WK7Shadow;

class WK7ShadowObj : public WK7Obj{
protected:
	WK7Shadow						*mpShadow;		// e
	WK7JObj							*mpJObj;		// ΏۃIuWFNg
	bool							mVisible;		// \tO
	WK7ShadowObj();
public:
	WK7ShadowObj(WK7Shadow *pShadow,WK7JObj *pJObj,ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7ShadowObj();
	inline WK7ShadowObj* GetPrev(void){ return (WK7ShadowObj *)ghmGcListObj::GetPrev(); }
	inline WK7ShadowObj* GetNext(void){ return (WK7ShadowObj *)ghmGcListObj::GetNext(); }
	
	virtual bool SetVisible(bool flag);
	virtual inline bool GetVisible(void){ return mVisible; }
	
	C_Shadow* GetShadow(void);
	HSD_JObj* GetHSDJObj(void);
#if FUJITA
	inline WK7JObj* GetK7JObj(void){ return mpJObj; }
#endif
};

//
// Cast Shadow Object
//
class WK7CastShadowObj : public WK7ShadowObj{
protected:
	bool							mAddJObj;		// 
	ghmGcCollSphere					mSphere;		// `FbNp
	WK7RenderObj					*mpRenderObj;
	HSD_TrspMask					mTrspMask;
	
	WK7CastShadowObj();
	
	bool AddJObj(void);
	bool DeleteJObj(void);
	f32 CalcTargetDist(Vec &tgtpos,Vec &tgtdir,WK7JObj *pJObj,bool next);
	
	static void AddViewingRect(HSD_ViewingRect *pvrect,WK7JObj *pJObj,bool next=false);
public:
	WK7CastShadowObj(WK7Shadow *pShadow,WK7JObj *pJObj,ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7CastShadowObj();
	
	inline WK7CastShadowObj* GetPrev(void){ return (WK7CastShadowObj *)ghmGcListObj::GetPrev(); }
	inline WK7CastShadowObj* GetNext(void){ return (WK7CastShadowObj *)ghmGcListObj::GetNext(); }
	
	inline void SetRenderObj(WK7RenderObj *pRenderObj){ mpRenderObj=pRenderObj; }
	inline WK7RenderObj* GetRenderObj(void){ return mpRenderObj; }
	bool FrameProcess(void);
	bool RenderProcess(void);
	inline WK7JObj* GetJObj(void){ return mpJObj; }
	inline bool GetAddJObj(void){ return mAddJObj; }
	
	inline void SetTrspMask(HSD_TrspMask trpsMask){ mTrspMask=trpsMask; }
	inline HSD_TrspMask GetTrspMask(void){ return mTrspMask; }
	
	void AddViewingRect(C_Shadow &shadow);
	
	f32 CalcTargetDist(Vec &tgtpos,Vec &tgtdir);
	
	bool SetCollSphereRadius(f32 r=-1.0f);
	f32 GetCollSphereRadius(void);
};

//
// Recieve Shadow Object
//
class WK7ReceiveShadowObj : public WK7ShadowObj{
protected:
	bool							mSetShadow;
	
	WK7ReceiveShadowObj();
	
	bool SetShadow(void);
	bool ClearShadow(void);
public:
	WK7ReceiveShadowObj(WK7Shadow *pShadow,WK7JObj *pJObj,ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7ReceiveShadowObj();
	
	inline WK7ReceiveShadowObj* GetPrev(void){ return (WK7ReceiveShadowObj *)ghmGcListObj::GetPrev(); }
	inline WK7ReceiveShadowObj* GetNext(void){ return (WK7ReceiveShadowObj *)ghmGcListObj::GetNext(); }
	
	bool FrameProcess(void);
	bool RenderProcess(void);
	inline WK7JObj* GetJObj(void){ return mpJObj; }
};

//
// Shadow
//
class WK7Shadow{
protected:
	static WK7Shadow		*gpShadow;
	ghmGcListObj			mCastShadowObjAnchor;
	ghmGcListObj			mReceiveShadowObjAnchor;
	C_Shadow				mShadow;
	C_LObj					*mpLObj;
	f32						mCameraFov;
	Vec						mCameraPosition;
	Vec						mCameraDirection;
	Vec						mLightDirection;
	Vec						mTargetPosition;
	ghmGcViewVolume			mViewVolume;
	f32						mViewDist;
	bool					mViewDistManual;
	f32						mVisibleDist;
	int						mVisibleNum;
	HSD_LObj				*mpShadowLObj;
	bool					mRender;
	bool					mEnable;
	bool					mEnableAdjust;
	f32						mMinRadius;
	
public:
	WK7Shadow();
	virtual ~WK7Shadow();
	
	// 
	static bool Initialize(void);
	// I
	static bool Terminate(void);
	
	// t[
	bool FrameProcess(void);
	// _O
	bool RenderProcess(void);
	
	inline void AddVisibleDist(f32 dist){ mVisibleDist+=dist; mVisibleNum++; }
	
	// e𗎂ƂIuWFNg
	WK7CastShadowObj* AddCastShadowObj(WK7JObj *pJObj);
	bool DeleteCastShadowObj(WK7JObj *pJObj);
	bool DeleteCastShadowObj(WK7RenderObj *pRenderObj);
	bool DeleteCastShadowObj(WK7CastShadowObj *pCastShadowObj);
	WK7CastShadowObj* FindCastShadowObj(WK7JObj *pJObj);
	WK7CastShadowObj* FindCastShadowObj(WK7RenderObj *pRenderObj);
	
	// e󂯂IuWFNg
	WK7ReceiveShadowObj* AddReceiveShadowObj(WK7JObj *pJObj);
	bool DeleteReceiveShadowObj(WK7JObj *pJObj);
	WK7ReceiveShadowObj* FindReceiveShadowObj(WK7JObj *pJObj);
	
	static bool ReleaseJObj(WK7JObj *pJObj);
	
	void SetLight(HSD_LObj *pLObj);
	inline HSD_LObj* GetLight(void){ return mpShadowLObj; }
	
	inline void SetEnable(bool flag){ mEnable = flag; }
	inline bool GetEnable(void){ return mEnable; }
	inline void SetEnableAdjust(bool flag){ mEnableAdjust = flag; }
	inline bool GetEnableAdjust(void){ return mEnableAdjust; }
	
	inline void SetTargetPosition(const Vec &pos){ mTargetPosition=pos; }
	inline const Vec* GetTargetPosition(void){ return &mTargetPosition; }
	
	inline C_Shadow* GetShadow(void){ return &mShadow; }
	inline ghmGcViewVolume* GetViewVolume(void){ return &mViewVolume; }
	inline const Vec* GetCameraPosition(void){ return &mCameraPosition; }
	inline const Vec* GetCameraDirection(void){ return &mCameraDirection; }
	inline void SetViewDist(f32 dist=WK7SHADOW_VIEWDIST_DEF){ mViewDist=dist; }
	inline f32 GetViewDist(void){ return mViewDist; }
	
	inline void SetViewDistManual(bool flag){ mViewDistManual=flag; }
	inline bool GetViewDistManual(void){ return mViewDistManual; }
	
	inline bool GetRender(void){ return mRender; }
	
	static WK7Shadow* GetInstance(void);
	
	inline void SetInitMinRadius(void){ mMinRadius=10.0f; }
	inline f32  SetMinRadius(f32 inR){ f32 old=mMinRadius; mMinRadius=inR; return old; }
	inline f32  GetMinRadius(void){ return mMinRadius; }
};

#define	WK7SHADOW	WK7Shadow::GetInstance()

#endif	//__WK7SHADOW_H__

