////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Player Skill
//
// WK7Skill.cpp
//
// Creator       : Satoshi Kawakami (GHM)
// Creation Date : 03/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7SKILL_CPP__

//#include <dolphin.h>
#include ".\K7ID.h"
#include ".\WK7Skill.h"
#include ".\WK7Player.h"
#include "..\Wat\WK7MainMenu.h"
#include "..\Yam\YK7EffectString.h"
#include "..\Sato\SK7Special.h"

#include "PcSkill.h"

// {
static WK7Skill	SKILL;
WK7Skill*	pWK7Skill = &SKILL;

void WK7Skill::Init(void)
{
	pWK7Skill->InitSkillLv();
}

void WK7Skill::Term( void )
{
	if ( pWK7Skill != NULL ){
		GHM_SAFE_DELETE( pWK7Skill );
	}
}


/*
	
	Jg̃XLe[u|C^̎擾
	
*/
void WK7Skill::InitSkillLv(void)
{
	int i, j;

	// lZbg
	for(j=0; j<K7PCMAX; j++){
		for(i=0; i<SKILL_MAX; i++ ){
			mSkillAll.mSkill[i][j].Lv	= SkillLevelInitTbl[j][i];
			mSkillAll.mSkill[i][j].Exp	= 0;
		}
	}
}


/*
	
	Lhc̃XLx̎擾
	
	<in>
	skillID		XLhc
	mainID		Lhc
				ƃJg̃LhcŎ擾
	
*/
u8 WK7Skill::GetSkillLv(u32 skillID, u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	return mSkillAll.mSkill[skillID][mainID].Lv;
}


/*
	
	Lhc̃XLxő僌x̎擾
	
	<in>
	skillID		XLhc
	mainID		Lhc
				ƃJg̃LhcŎ擾
	
*/
u8 WK7Skill::GetSkillMaxLv(u32 skillID, u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	return SkillLevelMaxTbl[mainID][skillID];
}

/*
	
	Lhc̃XLx̃Zbg
	
	<in>
	skillID		XLhc
	mainID		Lhc
				ƃJg̃LhcŎ擾
	
*/
void WK7Skill::SetSkillLv(u8 setLv, u32 skillID, u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	mSkillAll.mSkill[skillID][mainID].Lv = setLv;
}



/*
	
	Lhc̃XLxon̎擾
	
	<in>
	skillID		XLhc
	mainID		Lhc
				ƃJg̃LhcŎ擾
	
*/
u32 WK7Skill::GetSkillExp(u32 skillID, u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	return mSkillAll.mSkill[skillID][mainID].Exp;
}


/*
	
	Lhc̃XLxon̎擾
	
	<in>
	skillID		XLhc
	mainID		Lhc
				ƃJg̃LhcŎ擾
	
*/
void WK7Skill::SetSkillExp(u32 setExp, u32 skillID, u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	mSkillAll.mSkill[skillID][mainID].Exp = setExp;
}

/*
	
	Lhc̃XLxon̎擾
	
	<in>
	skillID		XLhc
	mainID		Lhc
				ƃJg̃LhcŎ擾
	
*/
u32 WK7Skill::GetSkillTotalExp(u32 skillID, u32 mainID)
{
	s8 NowLv, i;
	u32 TotalExp = 0;
	
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	
	// POx܂ł̃RXgExpv
	NowLv			= (s8 )GetSkillLv(skillID, mainID);
	NowLv--;
	if ( NowLv < 0 ) NowLv = 0;
	for (i=0; i<NowLv; i++){
//		TotalExp += (u32 )(BLOOD_POINT * SkillLevelCostTbl[(u8 )i][skillID]);
		TotalExp += (u32 )GetSkillCost(skillID, (u8 )i, mainID);
	}
	
	// ŌɌݕ̌on𑫂
	TotalExp += GetSkillExp(skillID, mainID);
	
	return TotalExp;
}


/*
	
	
	XLxRXg̎擾
	
	<in>
	skillID		XLhc
	SkillLv		XLx
	
*/
u32 WK7Skill::GetSkillCost(u32 skillID, u8 SkillLv, u32 mainID)
{
	u8 MaxLv, NowLv;
	u32 Cost;
	
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	
	MaxLv		= SkillLevelMaxTbl[mainID][skillID];
	NowLv		= (u8 )GetSkillLv(skillID, mainID);
	// ̎dlɍ킹XLJbg
	if ( SkillLv > 4 ) SkillLv = 4;
	// RXge[u̎擾
	
	if ( MaxLv <= NowLv ){
		// }bNXɒBĂꍇ
		Cost = 0;
	}else{
		switch (mainID){
		default:
		case K7DAN:
			Cost = (u32 )(BLOOD_POINT * SkillLevelCostTblDAN[SkillLv][skillID]);
			break;
		case K7CON:
			Cost = (u32 )(BLOOD_POINT * SkillLevelCostTblCON[SkillLv][skillID]);
			break;
		case K7KED:
			Cost = (u32 )(BLOOD_POINT * SkillLevelCostTblKED[SkillLv][skillID]);
			break;
		case K7CYO:
			Cost = (u32 )(BLOOD_POINT * SkillLevelCostTblCYO[SkillLv][skillID]);
			break;
		case K7KVN:
			Cost = (u32 )(BLOOD_POINT * SkillLevelCostTblKVN[SkillLv][skillID]);
			break;
		case K7MSK:
			Cost = (u32 )(BLOOD_POINT * SkillLevelCostTblMSK[SkillLv][skillID]);
			break;
		}
	}
	return Cost;
}

/*
	
	Lhc̃XLxon̎擾
	
	<in>
	Point		ʁi|j
	skillID		XLhc
	mainID		Lhc
				ƃJg̃LhcŎ擾
				
	<return>
				oniĵ̃XL̃x
	
*/
u8 WK7Skill::IncSkillExp(s32 Point, u32 skillID, u32 mainID)
{
	s32 TmpExp;
	u32 NowSkillCost;
	u8 MaxLv, InitLv;
	s8 NowLv;

	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	TmpExp			= (s32 )GetSkillExp(skillID, mainID);
	NowLv			= (s8 )GetSkillLv(skillID, mainID);
#ifdef _DEBUG
	if ( mainMenu.IsSkillEdit()==true ){
		InitLv		= 0;
		if ( PAD_BUTTON_A & HSD_PadGetButton(0) ){
			MaxLv	= 9;
		}else{
			MaxLv	= 5;
		}
	}else{
		InitLv		= SkillLevelInitTbl[mainID][skillID];
		MaxLv		= SkillLevelMaxTbl[mainID][skillID];
	}
#else
	InitLv			= SkillLevelInitTbl[mainID][skillID];
	MaxLv			= SkillLevelMaxTbl[mainID][skillID];
#endif
	NowSkillCost	= (u32 )GetSkillCost(skillID, (u8 )NowLv, mainID);
	
	// 
	TmpExp += Point;
	
	if ( 0 != TmpExp ) {
		
		// xAbv`FbN
		if ( TmpExp >= (int )NowSkillCost ){
			NowLv++;
			// XLLbv`FbN
			if ( NowLv >= MaxLv ){
				TmpExp = (s32 )NowSkillCost;				// JXg
				NowLv  = (s8 )MaxLv;
			}else{
				TmpExp = 0;							// Oɖ߂
			}
		}else{
		// x_E`FbN
			if ( TmpExp <= 0 ){
				TmpExp = 0;							// Oɖ߂
				NowLv--;
			// XLLbv`FbN
				if ( NowLv <= InitLv ) {			// l܂Ŗ߂
					NowLv = (s8 )InitLv;
				}
			}
		}
		
	}
	
	// i[
	SetSkillLv ((u8 )NowLv,  skillID, mainID);
	SetSkillExp((u32 )TmpExp, skillID, mainID);
	
	return (u8 )NowLv;
}


/*
	
	
	XL̃p[^e[u̎擾
	
	<in>
	u8 Lv			~XLx
	
*/
//	
PCGROWSKILLPARAM *WK7Skill::pGetSkillGrowParamTbl(u8 Lv, u32 mainID)
{
	PCGROWSKILLPARAM *pReturn;

	switch (mainID){
	case K7DAN:
		if ( (mainID == K7DAN) && (KK7BATTLECTRL_DANLV_UP == BattleCtrl.GetDanPowerUp()) ){
			pReturn = &GrowSkillParamTblDAN_PowerUp[Lv];
		}else{
			pReturn = &GrowSkillParamTblDAN[Lv];
		}
		break;
	case K7GAL:
		if ( (mainID == K7GAL) && (KK7BATTLECTRL_GALLV_UP == BattleCtrl.GetGalPowerUp()) ){
			pReturn = &GrowSkillParamTblGAL_PowerUp[Lv];
		}else{
			pReturn = &GrowSkillParamTblGAL[Lv];
		}
		break;
	case K7CON:
		pReturn = &GrowSkillParamTblCON[Lv];
		break;
	case K7HAC:
		pReturn = &GrowSkillParamTblHAC[Lv];
		break;
	case K7HAS:
		// Error
		pReturn = &GrowSkillParamTblDAN[Lv];
		break;
	case K7HAY:
		pReturn = &GrowSkillParamTblHAY[Lv];
		break;
	case K7CYO:
		pReturn = &GrowSkillParamTblCYO[Lv];
		break;
	case K7KED:
		pReturn = &GrowSkillParamTblKED[Lv];
		break;
	case K7KVN:
		pReturn = &GrowSkillParamTblKVN[Lv];
		break;
	case K7MSK:
		pReturn = &GrowSkillParamTblMSK[Lv];
		break;
	}
	return pReturn;
}




/*
	
	LƂ̃p[^l̎擾
	
*/
s16 WK7Skill::GetPc_MaxHp(u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	return HpTbl[mainID];
}

f32 WK7Skill::GetPc_MoveSpeedRate(u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	if ( (K7MSK == mainID) && (KK7BATTLECTRL_MSKLV_NORMAL < BattleCtrl.GetMskPowerUp()) ){
		if (KK7BATTLECTRL_MSKLV_TEXAS == BattleCtrl.GetMskPowerUp()){
			return 1.4f;
		}else{
			return 1.6f;
		}
	}else{
		return MoveSpeedRate[mainID];
	}
}

f32 WK7Skill::GetPc_SightSpeed(u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	return SightSpeed[mainID];
}

f32 WK7Skill::GetPc_PoseSpeed(u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	return PoseSpeed[mainID];
}

f32 WK7Skill::GetPc_ReloadSpeed(u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	return ReloadSpeed[mainID];
}

f32 WK7Skill::GetPc_Zoom(u32 mainID)
{
	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	
	return Zoom[mainID];
}



s16 WK7Skill::GetSkillCurrentLv_GunPower(u32 mainID)
{
	PCGROWSKILLPARAM *pParam;
	u8 NowLv;

	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	
	NowLv = GetSkillLv(SKILL_GUNPOWER, mainID);
	// ͂̎wւ𑕔Ă
	if( K7SCR_EVEQUIPRING(RING_ATTACK) == true ){
		NowLv++;
	}
	if ( NowLv < GRAWSKILL_LEVEL_MAX ){
		// xWȓ
		pParam = pGetSkillGrowParamTbl(NowLv, mainID);
		return pParam->mGunPower;
	}else{
		// ͂̎w֑̃xȔꍇ
		if ( (mainID == K7DAN) && (KK7BATTLECTRL_DANLV_UP == BattleCtrl.GetDanPowerUp()) ){
			return Lv6Power_PowerUp[mainID];
		}else{
			return Lv6Power[mainID];
		}
	}
}

u8 WK7Skill::GetSkillCurrentLv_ShotCancel(u32 mainID)
{
	PCGROWSKILLPARAM *pParam;

	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	pParam = pGetSkillGrowParamTbl(GetSkillLv(SKILL_SHOTCANCEL, mainID), mainID);
	
	return pParam->mShotCancel;
}

f32 WK7Skill::GetSkillCurrentLv_Bure(u32 mainID)
{
	PCGROWSKILLPARAM *pParam;

	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	pParam = pGetSkillGrowParamTbl(GetSkillLv(SKILL_BURE, mainID), mainID);
	
	return pParam->mBure;
}

f32 WK7Skill::GetSkillCurrentLv_CriticalSize(u32 mainID)
{
	PCGROWSKILLPARAM *pParam;

	if ( 0xffffffff == mainID ) {
		mainID = WK7PLAYERCONTROL->GetMainID();
	}
	pParam = pGetSkillGrowParamTbl(GetSkillLv(SKILL_CRITICALSIZE, mainID), mainID);
	
	return pParam->mCriticalSize;
}

/*
	
	
	gpłXLAreBe[ȕ
	
	݂̃xŎgp\ȃe[u쐬
	
	
*/
void WK7Skill::InitUseAbilityTbl(u32 mainID)
{
	u8 abiID, setPtr;

	for (abiID=0, setPtr=0; abiID<SKILLABILITY_MAX; abiID++){
		if ( true == UseAbilityTest(mainID, (u32 )abiID) ){
			mAbilityPast[setPtr] = abiID;
			setPtr++;
		}
	}
	// c𖄂߂
	for (abiID=setPtr; abiID<SKILLABILITY_MAX; abiID++){
		mAbilityPast[abiID] = SKILLABILITY_MAX;
	}
	// New ̏̕
	for (abiID=0; abiID<SKILLABILITY_MAX; abiID++){
		mAbilityNew[abiID] = SKILLABILITY_MAX;
	}
}


/*
	
	
	oAreB̃e[u̎擾
	
	<return>
	SKILLABILITY_MAX ܂Ń[v
	
*/
u8 *WK7Skill::pGetUseNewAbilityTbl(u32 mainID)
{
	u8 abiID, setPtr, i, j, setOk, getAbi;
	u8 AbilityTmp[SKILLABILITY_MAX];

	for (abiID=0, setPtr=0; abiID<SKILLABILITY_MAX; abiID++){
		if ( true == UseAbilityTest(mainID, (u32 )abiID) ){
			AbilityTmp[setPtr] = abiID;
			setPtr++;
		}
	}
	// c𖄂߂
	for (abiID=setPtr; abiID<SKILLABILITY_MAX; abiID++){
		AbilityTmp[abiID] = SKILLABILITY_MAX;
	}
	
	// oe NewɊi[
	for (i=0, setPtr=0; i<SKILLABILITY_MAX; i++){
		getAbi = AbilityTmp[i];
		for (j=0, setOk=0; j<SKILLABILITY_MAX; j++){
			if ( getAbi == mAbilityPast[j] ){
				setOk++;
				break;
			}
			if ( SKILLABILITY_MAX == mAbilityPast[j] ){
				break;
			}
		}
		if ( 0 == setOk ){
			mAbilityNew[setPtr] = getAbi;
			setPtr++;
		}
	}
	// c𖄂߂
	for (i=setPtr; i<SKILLABILITY_MAX; i++){
		mAbilityNew[i] = SKILLABILITY_MAX;
	}
	
	return mAbilityNew;
}


/*
	
	
	XLAreB̎gp\ǂׂ
	
	<in>
	skillID		XLhc
	SkillLv		XLx
	
*/
bool WK7Skill::UseAbilityTest(u32 mainID, u32 SkillAbility)
{
	u8 GunPower		= GetSkillLv(SKILL_GUNPOWER,	mainID);
	u8 ShotCancel	= GetSkillLv(SKILL_SHOTCANCEL,	mainID);
	u8 Bure			= GetSkillLv(SKILL_BURE,		mainID);
	u8 CriticalSize	= GetSkillLv(SKILL_CRITICALSIZE,mainID);
	
#ifdef	_DEBUG
	if( mainMenu.IsSkillAllUse()==true ){
		return true;
	}else{
		return UseAbilityTestParam(mainID, SkillAbility, GunPower, ShotCancel, Bure, CriticalSize);
	}
#else
	return UseAbilityTestParam(mainID, SkillAbility, GunPower, ShotCancel, Bure, CriticalSize);
#endif
}

bool WK7Skill::UseAbilityTestParam(u32 mainID, u32 SkillAbility, u8 GunPower, u8 ShotCancel, u8 Bure, u8 CriticalSize)
{
	switch (SkillAbility){
	case SKILLABILITY_COUNTERATTACK:			// ݍU
		if ( cost_SKILLABILITY_COUNTERATTACK[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_COUNTERATTACK[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_COUNTERATTACK[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_COUNTERATTACK[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_DOWNATTACK:				// iU
		if ( cost_SKILLABILITY_DOWNATTACK[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_DOWNATTACK[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_DOWNATTACK[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_DOWNATTACK[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_CRITICALLOCKON:			// _bNI
		if ( cost_SKILLABILITY_CRITICALLOCKON[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_CRITICALLOCKON[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_CRITICALLOCKON[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_CRITICALLOCKON[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_HEADLOCKON:				// wbhbNI
		if ( cost_SKILLABILITY_HEADLOCKON[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_HEADLOCKON[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_HEADLOCKON[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_HEADLOCKON[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_JOINTLOCKON:				// ʃbNI
		if ( cost_SKILLABILITY_JOINTLOCKON[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_JOINTLOCKON[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_JOINTLOCKON[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_JOINTLOCKON[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_CHARGESHOT:				// ^E`
		if ( cost_SKILLABILITY_CHARGESHOT[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_CHARGESHOT[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_CHARGESHOT[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_CHARGESHOT[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_DEADLYBLOW:				// ꌂʌ
		if ( cost_SKILLABILITY_DEADLYBLOW[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_DEADLYBLOW[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_DEADLYBLOW[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_DEADLYBLOW[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_DOUBLEQUICKSHOT:			// ZJho[XgiP̒ełQAŔˁj
		if ( cost_SKILLABILITY_DOUBLEQUICKSHOT[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_DOUBLEQUICKSHOT[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_DOUBLEQUICKSHOT[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_DOUBLEQUICKSHOT[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_TRIPLEQUICKSHOT:			// gvo[XgiP̒ełRAŔˁj
		if ( cost_SKILLABILITY_TRIPLEQUICKSHOT[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_TRIPLEQUICKSHOT[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_TRIPLEQUICKSHOT[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_TRIPLEQUICKSHOT[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_ENEMYSLOW:				// Ĝ炢[VxȂ
		if ( cost_SKILLABILITY_ENEMYSLOW[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_ENEMYSLOW[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_ENEMYSLOW[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_ENEMYSLOW[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	case SKILLABILITY_ROUNDSHOT:				// EhVbg
		if ( cost_SKILLABILITY_ROUNDSHOT[mainID].mGunPower      > GunPower )		return false;
		if ( cost_SKILLABILITY_ROUNDSHOT[mainID].mShotCancel    > ShotCancel )		return false;
		if ( cost_SKILLABILITY_ROUNDSHOT[mainID].mBure          > Bure )			return false;
		if ( cost_SKILLABILITY_ROUNDSHOT[mainID].mCriticalSize  > CriticalSize )	return false;
		return true;
		break;
	}
	return false;
}


/*
	
	
	AreBgp̃GtFNgʂɏo
	
	
*/
bool WK7Skill::UseAbilityEffectPlay(u32 SkillAbility)
{
	CreateStringEffect( pAbilityName[SkillAbility] );
	return true;
}



/*
	
	
	AreBgp̃GtFNgʂɏo
	
	
*/
PCSKILLALL *WK7Skill::pGetSkillAll(void)
{
	return &mSkillAll;
}



