////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Player Skill
//
// WK7Skill.h
//
// Creator       : Satoshi Kawakami (GHM)
// Creation Date : 03/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7SKILL_H__
#define	__WK7SKILL_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"

#define SKILL_LEVEL_MAX			(6)
#define GRAWSKILL_LEVEL_MAX		(6)


enum WK7SkillEnum{
	SKILL_GUNPOWER,					// eЗ́ilj
	SKILL_SHOTCANCEL,				// eA˗ ilj
	SKILL_BURE,						// Əu
	SKILL_CRITICALSIZE,				// ꌂłTCY
	SKILL_MAX
};


typedef struct _PCSKILL{
	u8			Lv;							// XLx
	u32			Exp;						// olĩxł̃Jgʁj
}PCSKILL;

//	typedef struct _PCSKILLLV{
//		u8			mHpLv;						// qbg|Cg
//		u8			mMoveSpeedRateLv;			// ړx ㏸
//		u8			mPowerRateLv;				// eЗ ㏸
//		u8			mShotCancelLv;				// eA˗
//		u8			mSightSpeedLv;				// TCgXs[hiI[gbNo
//		u8			mPoseSpeedLv;				// \x
//		u8			mReloadSpeedLv;				// [hXs[h
//		u8			mZoomLv;					// Y[
//		u8			mBureLv;					// Əu
//		u8			mCriticalSizeLv;			// ꌂłTCY
//		u32			mAbilityLv;					// \̓x irbgŕ\j
//	}PCSKILLLV;

typedef struct _PCGROWSKILLPARAM{
	s16			mGunPower;					// eЗ
	u8			mShotCancel;				// eA˗   12 Œl LZłt[𒼏
	f32			mBure;						// Əu
	f32			mCriticalSize;				// ꌂłTCY
}PCGROWSKILLPARAM;

typedef struct _ABILITYCOST{
	u8			mGunPower;					// eЗ
	u8			mShotCancel;				// eA˗   12 Œl LZłt[𒼏
	u8			mBure;						// Əu
	u8			mCriticalSize;				// ꌂłTCY
}ABILITYCOST;

enum WK7SkillAbility{
	SKILLABILITY_COUNTERATTACK,				// ݍU
	SKILLABILITY_DOWNATTACK,				// iU
	SKILLABILITY_CRITICALLOCKON,			// _bNI
	SKILLABILITY_HEADLOCKON,				// wbhbNI
	SKILLABILITY_JOINTLOCKON,				// ʃbNIibNIj
	SKILLABILITY_CHARGESHOT,				// ^E`
	SKILLABILITY_DEADLYBLOW,				// ꌂʌ
	SKILLABILITY_DOUBLEQUICKSHOT,			// ZJh^bviP̒ełQAŔˁj
	SKILLABILITY_TRIPLEQUICKSHOT,			// gv^bviP̒ełRAŔˁj
	SKILLABILITY_ENEMYSLOW,					// Ĝ炢[VxȂ
	SKILLABILITY_ROUNDSHOT,					// PrO
	SKILLABILITY_MAX,
};

typedef struct _PCSKILLALL{
	PCSKILL		mSkill[SKILL_MAX][K7PCMAX];				// XLp[^e[u
}PCSKILLALL;

class WK7Skill{
protected:
	
	PCSKILLALL	mSkillAll;								// XLp[^e[u
	
	u8			mAbilityPast[SKILLABILITY_MAX];			// Work
	u8			mAbilityNew[SKILLABILITY_MAX];			// Work
	
public:

	static void Init(void);
	static void Term(void);
	void InitSkillLv(void);
	
	u8  GetSkillLv(u32 skillID, u32 mainID=0xffffffff);
	u8  GetSkillMaxLv(u32 skillID, u32 mainID=0xffffffff);
	u32 GetSkillExp(u32 skillID, u32 mainID=0xffffffff);
	u32 GetSkillTotalExp(u32 skillID, u32 mainID=0xffffffff);
	u32 GetSkillCost(u32 skillID, u8 SkillLv, u32 mainID=0xffffffff);
	void SetSkillLv(u8 setLv, u32 skillID, u32 mainID=0xffffffff);
	void SetSkillExp(u32 setExp, u32 skillID, u32 mainID=0xffffffff);
	u8 IncSkillExp(s32 Point, u32 skillID, u32 mainID=0xffffffff);
	
	PCSKILLALL *pGetSkillAll(void);
	PCGROWSKILLPARAM *pGetSkillGrowParamTbl(u8 Lv, u32 mainID);
	
	
	s16 GetPc_MaxHp(u32 mainID=0xffffffff);
	f32 GetPc_MoveSpeedRate(u32 mainID=0xffffffff);
	f32 GetPc_SightSpeed(u32 mainID=0xffffffff);
	f32 GetPc_PoseSpeed(u32 mainID=0xffffffff);
	f32 GetPc_ReloadSpeed(u32 mainID=0xffffffff);
	f32 GetPc_Zoom(u32 mainID=0xffffffff);
	
	s16 GetSkillCurrentLv_GunPower(u32 mainID=0xffffffff);
	u8  GetSkillCurrentLv_ShotCancel(u32 mainID=0xffffffff);
	f32 GetSkillCurrentLv_Bure(u32 mainID=0xffffffff);
	f32 GetSkillCurrentLv_CriticalSize(u32 mainID=0xffffffff);
	
	void InitUseAbilityTbl(u32 mainID);
	u8   *pGetUseNewAbilityTbl(u32 mainID);
	
	bool UseAbilityTest(u32 mainID, u32 SkillAbility);
	bool UseAbilityTestParam(u32 mainID, u32 SkillAbility, u8 GunPower, u8 ShotCancel, u8 Bure, u8 CriticalSize);
	bool UseAbilityEffectPlay(u32 SkillAbility);
};



#ifdef	__WK7SKILL_CPP__

char *pSkillName[SKILL_MAX] = {
	"GUNPOWER",
	"SHOTCANCEL",
	"BURE",
	"CRITICALSIZE",
};

char *pAbilityName[] = {
	"CounterAttack",		
	"DownAttack",			
	"CriticalLockon",		
	"HeadLockon",			
	"FootLockon",			
	"ChargeShot",			
	"DeadlyBlow",			
	"DoubleTap",			
	"TripleTap",			
	"EnemySlow",			
	"ShineSparkling",			
	"ChargeShot",			
};

#else

extern	WK7Skill*	pWK7Skill;
extern	char *pSkillName[SKILL_MAX];
extern	char *pAbilityName[];


#endif

#endif	//__WK7SKILL_H__



