///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7Effect
//
// YK7Effect.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/13/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECT_H
#define	__YK7EFFECT_H

#define FRAME_30


// include --------------------------------------
#include "../matsu/mk7Sound.h"
#include "./YK7File.h"

// define ---------------------------------------

#define WORKBUFFERSIZE		(36000)

#define GTLOAD( o )			if( _TObj != (o) ){ GXLoadTexObj( (o), GX_TEXMAP0 ) ; _TObj = (o) ; }
#define GTLOAD2( o )		GTLOAD( &(o).Data.Obj )
#define GEND				GXEnd
#define GBGN(TYPE,NUM )		GXBegin( (TYPE), GX_VTXFMT0, (u16)(NUM) )
#define GP2(x,y)			GXPosition2f32( (x), (y) )
#define GP3(x,y,z)			GXPosition3f32( (x), (y), (z) )
#define GPV(v)				GXPosition3f32( (v).x, (v).y, (v).z )
#define GPV2(v)				GXPosition2f32( (v).x, (v).y )
#define GPV3(v1,v2)			GXPosition3f32( (v1).x + (v2).x, (v1).y + (v2).y, (v1).z + (v2).z )
#define GPV4(v1,v2,v2size)	GXPosition3f32( (v1).x + (v2).x * (v2size),  (v1).y + (v2).y * (v2size), (v1).z + (v2).z * (v2size) )
#define GC1(c,a)			GXColor4u8( (u8)(c), (u8)(c), (u8)(c), (u8)(a) )
#define GC4(r, g, b, a)		GXColor4u8( (u8)(r), (u8)(g), (u8)(b), (u8)(a) )
#define GC(x)				GXColor1u32( *((u32 *)&x) )
#define GCX(x)				GXColor1u32( (x) )
#define GC2(x,a)			GXColor4u8( (x).r, (x).g, (x).b, (u8)(a) )
#define GT(s,t)				GXTexCoord2f32( (s), (t) )
#define GT2(s,t)			GXTexCoord2u16( (u16)(s), (u16)(t) )
#define CMK(r,g,b,a)		((u32)((((u8)(r))<<24) | (((u8)(g))<<16) | (((u8)(b))<<8) | ((u8)(a))))
#define CMK2(i,a)			((u32)((((u8)(i))<<24) | (((u8)(i))<<16) | (((u8)(i))<<8) | ((u8)(a))))
#define CMKC(c)				((u32)(*((u32 *)&c)))
#define CMKC2(c,a)			((u32)((CMKC(c) & 0xffffff00) | (u8)(a)))

#define PARAMNUM	30

#ifndef PI
#define PI    3.14159265F
#endif
#ifndef PI_2
#define PI_2  6.28318531F
#endif
#define UVSHFTBIT				15
#define UVSCALE					( 1 << UVSHFTBIT )
#define FEED_TIME				120
#define FEED_WAIT				(20+FEED_TIME)
#define RCINT(x)				( IROTSAFE((s32)( (f32)(x) / PI_2 * PI2DIV )) )
#define PI2DIV					( 1 << 12 )
//#define IROTSAFE(x)				((int)(x) >= 0 ? (x) & ( PI2DIV - 1 ) : ( PI2DIV - (int)( (~((unsigned int)(x)) + 1) & ( PI2DIV - 1 ) ) ))		// ^pxl͈͂͂ݏoĂꍇ̕␳s
#define IROTSAFE(x)				((x) & ( PI2DIV - 1 ))
#define SIN(x)					EffSys.SinTable[IROTSAFE(x)]
#define COS(x)					EffSys.SinTable[IROTSAFE(x)+(PI2DIV>>2)]
//#define COS(x)				EffSys.CosTable[IROTSAFE(x)]
#define SINF(x)					EffSys.SinTable[RCINT(x)]
#define COSF(x)					EffSys.SinTable[RCINT(x)+(PI2DIV>>2)]
//#define COSF(x)				EffSys.CosTable[RCINT(x)]
#define MAX_SP					30.0F
#define SUB_SP					5.0F
#define MIN_SP					10.0F
#define OFFSET(a,b)				((u32)(((a)->Size / 2 + (b)->z) / (a)->OneSize) * (a)->DivNum * (a)->DivNum + \
								(u32)(((a)->Size / 2 + (b)->y) / (a)->OneSize) * (a)->DivNum +	\
								(u32)(((a)->Size / 2 + (b)->x) / (a)->OneSize)) 
#define MAX_EFFECTNUM			100			// GtFNg̍ő吔

#define SCW						WK7_SCREEN_WIDTH
#define SCH						WK7_SCREEN_HEIGHT
#define TEXW(x)					((x).Data.Header->mWidth)
#define TEXH(x)					((x).Data.Header->mHeight)

#define CHKFILELOAD( CFile )	( (CFile) != NULL ? ( (CFile)->FrameProcess(), /*(CFile)->GetReadStatus() == DVD_STATE_END*/(CFile)->GetState() == ghmGcFile::READFINISH ) : TRUE ) 
#define FILELOADBLOCK( CFile )	if( (CFile)->GetState() != ghmGcFile::READFINISH ) while( (CFile)->GetState() != ghmGcFile::READFINISH ){} 
#define CLOSECHK( CFile )		if( (CFile) != NULL ){ while((CFile)->GetState() != ghmGcFile::READFINISH/*(CFile)->GetReadStatus() != DVD_STATE_END*/ ){ (CFile)->FrameProcess() ; } (CFile)->Close() ; while( (CFile)->GetState() != ghmGcFile::CLOSED ){ (CFile)->FrameProcess() ; } delete CFile ; CFile = NULL ; } 
#define CHKDELEFFECT( Effect )	if( (Effect) != NULL ){ DeleteEffect( (Effect) ) ; Effect = NULL ; }
#define CHKMEMFREE( Mem )		if( (Mem) != NULL ){ ghmGcMemFree( (Mem) ) ; Mem = NULL ; }
#define CHKMEMFREE2( Mem )		if( (Mem) != NULL ){ K7AppSmallMemFree( (Mem) ) ; Mem = NULL ; }
#define CHKARCLOAD( CArc )		( (CArc) != NULL ? ( (CArc)->GetState() == WK7Archive::WK7ARCHIVE_LOADED ? TRUE : FALSE ) : TRUE ) 
#define DELCHK( CArc )			if( (CArc) != NULL ){ delete CArc ; CArc = NULL ; } 
#define MEMINIT( x )			memset( &x, 0, sizeof( x ) ) 


// uh[h
enum
{
	EF_BLEND_ADD = 0,
	EF_BLEND_SUB = 3,
	EF_BLEND_ALPHA = 1,
	EF_BLEND_NONE = 2,
} ;

// TEV[h
enum
{
	EF_TEV_NOTEX = 0,
	EF_TEV_USETEX = 1
} ;

// ˉe[h
enum
{
	EF_PROJECT_PERS = 0,
	EF_PROJECT_ORTHO = 1,
} ;

// GtFNg^Cv񋓌^
enum EFFECT_TYPE
{
	EFF_BLOOD = 0 ,						// ь
	EFF_MUZZLE = 1,						// }YtbV
	EFF_BARRETT = 2,					// obg
	EFF_MESH = 3,						// bV
	EFF_VLOSS = 4,						// u
	EFF_EXPLODE = 5,					// 
	EFF_FLASH = 6,						// tbV
	EFF_LINE = 7,						// C
	EFF_KLINE = 8,						// ʐ
	EFF_WHIRL = 9,						// ʂ˂
	EFF_IMPACT = 10,					// ʂ
	EFF_WAVE = 11,						// g
	EFF_SMOKE = 12,						// 
	EFF_HSEXPLODE = 13,					// gr
	EFF_FLASHLINE = 14,					// tbVC
	EFF_DENT = 15,						// ʉ
	EFF_SIGHT = 16,						// Ə
	EFF_HITMARK = 17,					// qbg}[N
	EFF_SEARCH = 18,					// T[``
	EFF_HSDEAD = 19,					// grS
	EFF_CARTRIDGE = 20,					// J[gbW
	EFF_SOUND = 21,						// TEh
	EFF_HELIEXP = 22,					// w
	EFF_VITAL = 23,						// ̗͕\
	EFF_FLYBULLET = 24,					// e
	EFF_MESSAGE = 25,					// bZ[W
	EFF_GORE = 26,						// 
	EFF_FLYBLOOD = 27,					// ь
	EFF_NOISE = 28,						// mCY
	EFF_GAUGE = 29,						// Q[W
	EFF_DAMAGE = 30,					// _[W
	EFF_SPSKILLGAGE = 31,				// XLQ[W
	EFF_BILLBOARD = 32,					// r{[hGtFNg
	EFF_CONVEBLOOD = 33,				// GtFNg
	EFF_SKILLEXE = 34,					// \͔GtFNg
	EFF_FEATHER = 35,					// HGtFNg
	EFF_EASYANIM = 36,					// ȈՃAjGtFNg
	EFF_SHUTTER = 37,					// Vb^[GtFNg
	EFF_SIGHT2 = 38,					// TCgQGtFNg
	EFF_BREAK = 39,						// fGtFNg
	EFF_MODELFIRE = 40,					// fRオ
	EFF_LASER = 41,						// [U[GtFNg
	EFF_DROPWATER = 42,					// H
	EFF_LINEROLL = 43,					// epWGtFNg
	EFF_DMGBLOOD = 44,					// _[W򖗃GtFNg
	EFF_SCANLINE = 45,					// GtFNg
	EFF_CAMERA = 46,					// ĎJGtFNg
	EFF_CHARGEKI = 47,					// LGtFNg
	EFF_BLOOD2 = 48,					// 򖗃GtFNgQ
	EFF_RAIN = 49,						// JGtFNg
	EFF_SNOW = 50,						// GtFNg
	EFF_CURSOR = 51,					// J[\GtFNg
	EFF_MESSAGE2 = 52,					// bZ[WGtFNgQ
	EFF_MISS = 53,						// ~XGtFNg
	EFF_SCREEN = 54,					// ʃGtFNg
	EFF_SKILLEXE2 = 55,					// \͔GtFNgQ
	EFF_PANELCURSOR = 56,				// plpJ[\
	EFF_MOON = 57,						// 
	EFF_TUBA = 58,						// 
	EFF_LOCKON = 59,					// bNI
	EFF_CONFETTI = 60,					// 
	EFF_KUNSMOKE = 61,					// NE
	EFF_DRAFT = 62,						// ԕ
	EFF_NOISEOUT = 63,					// mCYAEg
	EFF_DRAFT2 = 64,					// ԕQ
	EFF_FLOWER = 65,					// 
	EFF_HSLASER = 66,					// gr[U[
	EFF_ROTLIGHT = 67,					// 邭郉Cg
	EFF_LIGHT = 68,						// 
	EFF_POPCORN = 69,					// |bvR[
	EFF_STEAM = 70,						// C
	EFF_FLASH2 = 71,					// tbVGtFNgQ
	EFF_TELEPORT = 72,					// e|[gGtFNg
	EFF_SPOTLIGHT = 73,					// X|bgCg
	EFF_FADE = 74,						// tF[h
	EFF_CLOUD = 75,						// _
	EFF_NAME = 76,						// gr\
	EFF_BLOODPACK = 77,					// pbN
	EFF_STRING = 78,					// 
	EFF_CENTLIGHT = 79,					// W
	EFF_CONVEBLOOD2 = 80,				// Q
	EFF_ITEMGET = 81,					// ACe擾
	EFF_CENTLIGHT2 = 82,				// WQ
	EFF_ENESHOT = 83,					// GlM[Vbg
	EFF_FOOTPAINT = 84,					// 
	EFF_KIRAKIRA = 85,					// LL
	EFF_LASER2 = 86,					// [U[Q
	EFF_STICK = 87,						// hGtFNg
	EFF_BLUR = 88,						// u[GtFNg
	EFF_EYESCAN = 89,					// ԖF؃GtFNg
	EFF_SEENSOUND = 90,					// 鉹GtFNg
	EFF_TIME = 91,						// ^C\GtFNg
	EFF_HITNUM = 92,					// qbg\GtFNg
	EFF_FLASHBOM = 93,					// M
	EFF_POOL = 94,						// v[
	EFF_JET = 95,						// WFbg
	EFF_COUNTDOWN = 96,					// JEg_E
	EFF_PETAL = 97,						// ԕ
	EFF_WIND = 98,						// 
	EFF_WASH = 99,						// ԃ}V
	EFF_CHARGE = 100,					// `[Wo
	EFF_CUT = 101,						// Jbg
	EFF_VAPOR = 102,					// C̓
	EFF_SMOKEOBJ = 103,					// IuWFNg
	EFF_SMOKEOBJ2 = 104,				// IuWFNgQ
	EFF_SHOT = 105,						// VbgGtFNg
	EFF_SMOKE2 = 106,					// QGtFNg
	EFF_ELEC = 107,						// dCGtFNg
	EFF_BULLET = 108,					// eGtFNg
	EFF_CUT2 = 109,						// JbgGtFNg
	EFF_KVNSHOT = 110,					// PrVbg
	EFF_MISSILE = 111,					// ~TCGtFNg
	EFF_ELECHS = 112,					// grd炢GtFNg
	EFF_GRAVITY = 113,					// d̓GtFNg
	EFF_GMARK = 114,					// Weqbg}[NGtFNg
	EFF_LENSFLARE = 115,				// YtAGtFNg
	EFF_MAGNUM = 116,					// }OiGtFNg
	EFF_ROPE = 117,						// [vGtFNg
	EFF_TYPENUM = 118
} ;

// GtFNgGfBbghc
enum
{
	ED_HSEXP1 = 0,
	ED_HSEXP2 = 1,
	ED_MUZ = 2,
	ED_EXP = 3,
	ED_SEARCH = 4,
	ED_HITM = 5,
	ED_VLS = 6,
	ED_HSD1 = 7,
	ED_HSD2 = 8,
	ED_KLINE = 9,
	ED_VITAL = 10,
	ED_FLYBULLET = 11,
	ED_SIGHT = 12,
	ED_SIGHT2 = 13,
	ED_SIGHT3 = 14,
	ED_SIGHT4 = 15,
	ED_SIGHT5 = 16,
	ED_MESSAGE = 17,
	ED_CHARCHANGE = 18,
	ED_CHARCHANGE2 = 19,
	ED_CHARCHANGE3 = 20,
	ED_GORE = 21,
	ED_FLASH = 22,
	ED_FLYBLOOD = 23,
	ED_NOISE = 24,
	ED_GAUGE = 25,
	ED_DENT = 26,
	ED_DAMAGE = 27,
	ED_SIGHT6 = 28,
	ED_GRBOM = 29,
	ED_SMOKEEXP = 30,
	ED_SMOKEEXP2 = 31,
	ED_SAR = 32,
	ED_MFIRE = 33,
	ED_CBLOOD = 34,
	ED_MFIRE2 = 35,
	ED_SKILLEXE = 36,
	ED_FEATHER = 37,
	ED_MAPSELECT = 38,
	ED_SIGHT_GAL = 39,
	ED_SIGHT_CYO = 40,
	ED_SIGHT_HAY = 41,
	ED_EASYANIM = 42,
	ED_SMOKE = 43,
	ED_CANDLEFIRE = 44,
	ED_CURSOR = 45,
	ED_SHUTTER = 46,
	ED_SIG_HAC = 47,
	ED_MFIRE3 = 48,
	ED_BREAK = 49,
	ED_MFIRE4 = 50,
	ED_SPRINKLER = 51,
	ED_LASER = 52,
	ED_DROPWATER = 53,
	ED_SMOKE_H = 54,
	ED_SMOKE_DR = 55,
	ED_FIRESPARK = 56,
	ED_MFIRE5 = 57,
	ED_CHARCOLOR = 58,
	ED_FIRESPARK2 = 59,
	ED_SIGHT_KEV = 60,
	ED_MESSAGE2 = 61,
	ED_LINEROLL = 62,
	ED_MESSAGE3 = 63,
	ED_DMGBLOOD = 64,
	ED_DAMAGE2 = 65,
	ED_FLYBLOOD2 = 66,
	ED_MAPSELECT2 = 67,	
	ED_SCANLINE = 68,
	ED_CAMERA = 69,
	ED_CHARGEKI = 70,
	ED_MESSAGE4 = 71, 
	ED_BLOOD2 = 72,
	ED_MESSAGE5 = 73,
	ED_RAIN = 74,
	ED_SNOW = 75,
	ED_CURSOR2 = 76,
	ED_MES_V2 = 77,
	ED_MES_V2_2 = 78,
	ED_BLDRAIN = 79,
	ED_MISS = 80,
	ED_SCREEN = 81,
	ED_PNCURSOR = 82,
	ED_MOON = 83,
	ED_TUBA = 84,
	ED_PNCURSOR2 = 85,
	ED_LOCKON = 86,
	ED_CONFETTI = 87,
	ED_KUNSMOKE = 88,
	ED_DRAFT = 89,
	ED_NOISEOUT = 90,
	ED_FLOWER = 91,
	ED_HSLASER = 92,
	ED_ROTLIGHT = 93,
	ED_LIGHT = 94,
	ED_POPCORN = 95,
	ED_MFIRE6 = 96,
	ED_STEAM = 97,
	ED_BALLOON = 98,
	ED_FLASH2 = 99,
	ED_TELEPORT = 100,
	ED_SPOTLIGHT = 101,
	ED_FADE = 102,
	ED_CLOUD = 103,
	ED_SPARK = 104,
	ED_NAME = 105,
	ED_BLOODPACK = 106,
	ED_CENTLIGHT = 107,
	ED_CONVEBLOOD2 = 108,
	ED_ITEMGET = 109,
	ED_CENTLIGHT2 = 110,
	ED_ENESHOT = 111,
	ED_FOOTPAINT = 112,
	ED_KIRAKIRA = 113,
	ED_CHARGE = 114,
	ED_CHARGESHOT = 115,
	ED_LINESHOT = 116,
	ED_LASER2 = 117,
	ED_STICK = 118,
	ED_BLUR = 119,
	ED_MFIRE7 = 120,
	ED_EYESCAN = 121,
	ED_SEENSOUND = 122,
	ED_TIME = 123,
	ED_HITNUM = 124,
	ED_CONVEBLOOD3 = 125,
	ED_FLASHBOM = 126,
	ED_POOL = 127,
	ED_JET = 128,
	ED_COUNTDOWN = 129,
	ED_PETAL = 130,
	ED_WIND = 131,
	ED_SMOKE_DR2 = 132,
	ED_IMPACT = 133,
	ED_BLOOD = 134,
	ED_STTITLE = 135,
	ED_WASH = 136,
	ED_CHARGE2 = 137,
	ED_CUT = 138,
	ED_VAPOR = 139,
	ED_SMOKEOBJ = 140,
	ED_SHOT = 141,
	ED_SMOKE2 = 142,
	ED_ELEC = 143,
	ED_BULLET = 144,
	ED_WHIRL = 145,
	ED_CUT2 = 146,
	ED_MISSILE = 147,
	ED_SKILL = 148,
	ED_GRAVITY = 149,
	ED_GMARK = 150,
	EDITEFFNUM = 151,
} ;

// êhc
enum
{
	GUN_BARRETT = 0,		// I[hn[}
	GUN_BRWNGHP_L = 1,		// J[eBX
	GUN_BRWNGHP_R = 2,		// J[eBX
	GUN_COLTGOV = 3,		// On[}
	GUN_COLTPYT = 4,		// _
	GUN_GLOCK26_L = 5,		// Lbg
	GUN_GLOCK26_R = 6,		// Lbg
	GUN_WTHRPPK = 7,		// ~Y
	GUN_M79GLNC_L = 8,		// }XN
	GUN_M79GLNC_R = 9,		// }XN
	GUN_COLTGST = 10,		// 
	GUN_WTHRPP2 = 11,		// KVA
	GUN_ENFIELD_R = 12,		// R[e
	GUN_KIMBRPS_L = 13,		// LXM
	GUN_KIMBRPS_R = 14,		// LXM
	GUN_PYTH6IN_R = 15,		// Ng
	GUN_COUGARF_L = 16,		// f|[
	GUN_COUGARF_R = 17,		// f|[
	GUN_HKKNIFE_L = 18,		// Pr
	GUN_THKNIFE_R = 19,		// Pr
	GUN_MP5ARFL_R = 20,		// 
	GUN_JERICHO_R = 21,		// II^
	GUN_DESERTE_R = 22,		// WFt@[Y
	GUN_SWM36CS_R = 23,		// NnV
	GUN_SW629Hr_R = 24,		// _bh[
	GUN_SWM29MB_R = 25,		// G~[
	GUN_COLTPSP_R = 26,		// _Q
	GUN_PYTHN25_R = 27,		// L[
	GUN_THOMPSON = 28,		// On[}
	GUN_NUM = 29,
} ;


// e̂hc
enum
{
	GUN_HAND_R = 0,			// E
	GUN_HAND_L = 1			// 
} ;

// J[gbŴhc
enum
{
	CART_9MM = 0,
	CART_50BMG = 1,
	CART_NUM = 2,
} ;	

// eNX`̃^Cv
enum
{
	TEX_TYPE_NOLINEAR = 1,		// `ԂȂ
	TEX_TYPE_REPEAT = 2,		// eNX`s[g
} ;
	
// detatype -------------------------------------

// Rf[^
typedef struct tagDIR3
{
	Vec x, y, z ;
} DIR3 ;


// lI΂Ȃ̂߂̍\
typedef struct tagSAFERAND
{
	s32 Num ;
	s32 Con ;
} SAFERAND ;

// eNX`f[^
typedef struct tagTEXTURE
{
	char FileName[64] ;
	GhmGcTexHeader *Header ;
	GXTexObj Obj ;
	u8 Type ;
} TEXTURE ;

// keNX`f[^
typedef struct tagATEXDATA
{
	TEXTURE Data ;
	ghmGcFile *File ;
	void *FileImage ;
	s32 SrcSize, DestSize ;
} ATEXDATA ;

// eNX`f[^t@Ct
typedef struct tagTEXDATA
{
	TEXTURE Data ;
	ghmGcFile *File ;
	bool FileFlag ;
} TEXDATA ;

// xNgf[^
typedef struct Vec4 VEC4 ;

// GtFNgf[^\
typedef struct tagEFFECT
{
	EFFECT_TYPE Type ;					// GtFNg̃^Cv
	struct tagEFFECT *Parent ;			// eGtFNgւ̃|C^
	void *Data ;						// GtFNg̃f[^
	s32 Priority ;						// D揇
	struct tagEFFECT *Next, *Back ;		// ƑÕGtFNgf[^
	ghmGcTask *ManageTask ;				// Ǘ^XN
	u32 ID ;							// hc
	s32 LifeTime ;						// c鎞
	Vec Pos ;							// W
	f32 CamLen ;						// JƂ̋

	u8 DeleteFlag : 1 ;					// 폜]tO
//	u8 DeleteCompFlag ;					// 폜tO
	u8 IndeManageFlag : 1 ;				// ƗǗtO
	u8 DelReqFlag : 1 ;					// 폜NGXgtO
	u8 MoveFlag : 1 ;					// tO
	s8 DrawFlag : 1 ;					// `tO
	u8 InitFlag : 1 ;					// tO
	u8 PosValidFlag : 1 ;				// pos LtO

} EFFECT ;

// ֐|C^
typedef struct tagEFFECTFUNC
{
	s8 (*InitEffect)(void) ;
	s8 (*DelReqEffect)( EFFECT *Effect )  ;
	s8 (*CheckEffect)(void) ;
	s8 (*EndEffect)(void) ;
	s8 (*ReleaseEffect)( EFFECT *Effect ) ;
	s8 (*FrameProcessEffect)( EFFECT *Effect ) ;
	s8 (*RenderProcessEffect)( EFFECT *Effect ) ;
	s8 (*IndeEffect)( EFFECT *Effect, s8 Flag ) ;
} EFFECTFUNC ;

// Xg\
typedef struct tagEFFECTMEMLIST
{
	void *Buffer ;
	struct tagEFFECTMEMLIST *Back ;
} EFFECTMEMLIST ;

// D揇ʃ^XNXg\
typedef struct tagEFFECTTASKLIST
{
	s32 TaskID ;							// ^XN̂hc
	s32 Count ;								// 
	s32 Priority ;							// D揇
	struct tagEFFECTTASKLIST *Next, *Back ;	// O
} EFFECTTASKLIST ;

// GtFNgVXef[^
typedef struct tagEFFECTSYS
{
	HSD_CObj *CameraData ;						// J̏

	u8 RunFlag ;								// ܂ƂߎstO
	
	class WK7ScreenImage *AlphaImage ;			// At@C[W荞ݗp
	f32 SinTable[PI2DIV+PI2DIV/4]/*, CosTable[PI2DIV]*/ ;	// Sine[uCose[u
	EFFECT *FirstEffect ;						// ŏ̃GtFNgf[^ւ̃|C^
	EFFECTTASKLIST *FirstTaskList ;				// ^XNXg̐[
	EFFECTTASKLIST *LastTaskList ;				// ^XNXg̖[
	ghmGcTaskController *TaskCon ;				// ^XNRg[
	s32 FirstPriority ;							// GtFNgVXëԍDx
	
	ghmGcTask *AlphaDrawTask ;					// At@ʏ`^XN
	ghmGcTask *AlphaGetTask ;					// At@ʎ擾^XN
	ghmGcTask *DeleteProcessTask ;				// 폜vZX^XN
	
	u32 ScreenEffectTime ;						// ʂɑ΂GtFNg̎
	u32 NowFrame ;								// ݂̃GtFNg
	
	TEXDATA FlatTex ;				// ʃeNX`f[^
//	ghmGcFile *TexFileFlat ;		// ʃeNX`t@C ghmGcFile
	
	u32 IDCounter ;					// hcJE^[

	s8 SE2DFlag ;					// GtFNǧʉQcŖ炷ǂ̃tO	
	s8 SoundOFFFlag ;				// 炷ǂtO

	EFFECTMEMLIST *ConvWorkBuffer ;	// 𓀏Ɏgpobt@ւ̃|C^
//	s32 ConvWorkBufferSize ;		// Ɨp̈̃TCY

//	s32 KyouseiPriority ;			// Dx
//	bool KyouseiPriorityFlag ;		// DxLtO
	
	bool InitFlag ;					// tO
	s32 InitMod, InitCon ;			// pJE^
	
	YK7ResLink *PackFile ;			// ÓIf[^̃pbNt@C
	
	bool ForcedPriorityValidFlag ;	// IɎw̗Dxɂ邩ǂ̃tO
	s32 ForcedPriority ;			// IɎw̗Dxɂꍇ̒l
} EFFECTSYS ;

// data -----------------------------------------

extern EFFECTSYS EffSys ;
extern u16 VParam[EDITEFFNUM][PARAMNUM] ;
extern u32 CRTFlag ;
extern u32 StopFlag, RunFrame ;
extern s16 EffType ;
extern const char *CartridgeName[CART_NUM] ;
extern u8 WorkBuffer[WORKBUFFERSIZE] ;
extern GXTexObj *_TObj ;

// prototype ------------------------------------

extern s8 EffectInit( ghmGcTaskController *TaskCon, s32 FirstPriority ) ;		// GtFNgvO
extern s8 EffectSetupCheck( void ) ;											// GtFNgɊ֘A풓f[^̓ǂݍ݂Iǂ擾( TRUE:Ă  FALSE:܂ )
extern s8 EffectEnd( void ) ;													// GtFNgvOn

extern s8 SetEffectCamera( HSD_CObj *CameraData ) ;	// GtFNgŎgpJIuWFNg̃|C^Zbg
extern HSD_CObj *GetEffectCamera( void ) ;			// GtFNgŎgpJIuWFNg̃AhX擾
extern s8 SetScreenEffectTime( u32 Time ) ;			// ʃGtFNg鎞ԂZbg


extern EFFECT *AddEffectData( EFFECT_TYPE EffectType, void **Data, s32 Priority, u32 StackSize = 16 ) ;		// GtFNgf[^ǉ
extern s8 DeleteEffect( EFFECT *Effect, s8 FastDeleteFlag = FALSE ) ;					// GtFNg̃f[^폜
extern s8 DeleteEffectAll( void ) ;														// o^ׂẴGtFNg폜
extern s8 DelReqEffectAll( void ) ;														// o^SẴGtFNgɍ폜NGXgs
extern s8 DelReqEffect( EFFECT *Effect ) ;												// GtFNgɍ폜NGXgs
extern s8 MoveEffect( EFFECT *Effect ) ;												// w̃GtFNgnhGtFNgPt[삳
extern s8 MoveEffectAll( void ) ;														// 쐬ׂẴGtFNgPt[s
extern s8 DrawEffect( EFFECT *Effect ) ;												// 쐬GtFNgwWɕ`悷
extern s8 DrawEffectAll( void ) ;														// 쐬ׂẴGtFNg`悷
extern s8 GetEffectValidState( EFFECT *Effect ) ;										// GtFNgf[^Lׂ( TRUE:L  FALSE: )
extern s32 CheckEffectNum( EFFECT_TYPE EffectType ) ;									// w̃^CṽGtFNg邩ׂ
ghmGcTaskController *GetEffectTaskCon( void ) ;											// GtFNgŎgĂ^XNRg[擾
extern s8 SetEffectIndeManageFlag( EFFECT *Effect, s8 Flag )  ;							// ƗǗtOZbg
extern s8 SetEffectLifeTime( EFFECT *Effect, s32 Time ) ;								// GtFNg̐c莞Ԃݒ肷
extern s8 SetEffectDrawFlag( EFFECT *Effect, s8 DrawFlag ) ;							// GtFNgɑ΂ĕ`悷邩ǂ̃tOZbg
extern s8 SetEffectDrawFlagAll( EFFECT *Effect, s8 DrawFlag );							// ̃GtFNgɊ֌WGtFNgSĂ̕`tOZbg
extern s8 SetEffectChildDrawFlag( EFFECT *Effect, s8 DrawFlag ,bool child=true);		// ̃GtFNg̎qGtFNg̕`tOZbg
extern s8 SetEffectMoveFlag( EFFECT *Effect, s8 MoveFlag ) ;							// GtFNgɑ΂ē삷邩ǂ̃tOZbg
extern s8 SetEffectMoveFlagAll( EFFECT *Effect, s8 MoveFlag ) ;							// ̃GtFNgɊ֌WGtFNgSĂ̓tOZbg
extern s8 SetEffectChildMoveFlag( EFFECT *Effect, s8 MoveFlag ,bool child=true) ;		// ̃GtFNg̎qGtFNg̓tOZbg
extern s8 SetEffectPos( EFFECT *Effect, Vec *Pos ) ;									// GtFNg̍Wݒ肷
extern s8 SetEffectAllDrawFlag( bool drawOnFlag ) ;										// SẴGtFNg`悷邩ǂ̃tOݒ肷
extern s8 SetEffectTypeDrawFlag( EFFECT_TYPE type, bool drawflag ) ;					// ̎ނ̃GtFNg`悷邩ǂ̃tOZbg
extern s8 SetEffectTypeMoveFlag( EFFECT_TYPE type, bool moveflag ) ;					// ̎ނ̃GtFNg𓮍삷邩ǂ̃tOZbg

s8 TexLoad( char *FileName, TEXTURE *Tex, ghmGcFile **CFile, u8 Type = 0 ) ;			// eNX`̃[h
s8 TexLoad2( char *FileName, TEXTURE *AlphaTex, TEXTURE *RgbTex,
							 ghmGcFile **CFileAlpha, ghmGcFile **CFileRgb ) ;			// eNX`̃[hQ

extern void MTX44MultVec4( Mtx44 Mat44, VEC4 *SrcV4, VEC4 *DestV4 ) ;					// Mtx44sƃxNg̐ς߂
extern void MTX34MultVec4( Mtx Mat34, VEC4 *SrcV4, VEC4 *DestV4 ) ;						// Mtx34sƃxNg̐ς߂
extern void Vec4SetVec3( VEC4 *Dest, Vec *Src ) ;										// SPsxNgɂRPsxNgZbg
extern void Vec3SetVec4( Vec *Dest, VEC4 *Src ) ;										// RPsxNgɂSPsxNgZbg

extern s8 GetScreenPosition( Vec *Src, Vec *Dest, f32 fov = 0.0F, f32 aspect = 0.0F, s8 NoCamInfo = FALSE ) ;									// [hWXN[W߂
extern f32 GetScreenSize( Vec *Src, f32 Size ) ;										// XN[̂ł̃TCY𓾂
extern s8 GetScreen3DVector( f32 x, f32 y, f32 z, Vec *dest ) ;							// XN[猩w̍Wւ̃xNg擾( z:9.5ӂ肪Ó )

extern void CreatePerspectiveV( Mtx ProjectionMat, f32 *ProjectionMatV ) ;				// GXSetProjectionv ɓnp[^쐬
extern void CreateViewportV( f32 *ViewportV ) ;											// GXSetViewportv ɓnp[^쐬

extern s8 DeleteEffectAll_2( void ) ;													// o^̗͕\ȊÕGtFNg폜
extern f32 GetSanjiFunction( f32 InitSp, f32 InitLength, f32 AllTime, f32 t ) ;			// R֐

extern s8 DeleteOptionIDEffect( u32 EffectTypeID ) ;									// Cӂ̎ނ̃GtFNgׂč폜
extern u32 GetOptionIDEffectNum( u32 EffectTypeID ) ;									// Cӂ̎ނ̃GtFNg݂邩ׂ

extern GXTexObj *GetFlatTex( void ) ;													// ʃeNX`𓾂

extern s8 TexLoadSet( char *FileName, TEXDATA *TexData, u8 Type = 0 ) ;					// eNX`̃[h( type = TEX_TYPE_REPEAT  )
extern s8 TexLoadSetMem( void *Buf, TEXDATA *TexData, u8 Type = 0 ) ;					// ɑ݂eNX`f[^Zbg( type = TEX_TYPE_REPEAT  )
extern s8 TexRelease( TEXDATA *TexData ) ;												// eNX`f[^̌n
extern s8 TexLoadChk( TEXDATA *TexData ) ;												// eNX`f[^̃[h`FbN( TRUE:[h FALSE:[h )
extern s8 TexValidChk( TEXDATA *TexData ) ;												// eNX`f[^̗L𒲂ׂ( TRUE:L  FALSE: )

extern s8 ATexLoadSet( char *FileName, ATEXDATA *TexData, u8 Type = 0 ) ;				// keNX`̃[h
extern s8 ATexRelease( ATEXDATA *TexData ) ;											// keNX`f[^̌n
extern s8 ATexLoadChk( ATEXDATA *TexData ) ;											// keNX`f[^̃[h`FbN( TRUE:[h FALSE:[h )
extern s8 ATexSetup( ATEXDATA *TexData ) ;												// keNX`f[^gԂɂ
extern s8 ATexWorkBufferFree( void ) ;													// keNX`WJp̍Ɨp

extern u32 GetEffectID( EFFECT *Effect ) ;												// GtFNgɊ蓖ĂĂhc擾
extern s8 CheckEffectValidState( EFFECT *Effect, u32 ID ) ;								// ̃GtFNg܂Lǂ𒲂ׂAMo[W( TRUE:Ă  FALSE:ł )

extern s8 CheckCrossVectPlane( Vec *PlaneNormal, Vec *PlanePoint, 
								Vec *Point1, Vec *Point2, Vec *CrossPointBuf ) ;		// ƕʂĂ邩𒲂ׂ
																						// ( 0bit[ off:ĂȂ@on:Ă ]
																						//   1bit[ off:_P͖ʂ̑Oʂɋ on:_Pʂ̌ɋ ]
																						//   2bit[ off:_Q͖ʂ̑Oʂɋ on:_Qʂ̌ɋ ] )
extern s8 SetEffectSoundOffFlag( s8 Flag ) ;											// GtFNg̉炷ǂtO(TRUE:炳Ȃ FALSE:炷)
extern s8 GetEffectSoundOffFlag( void ) ;												// GtFNg̉炷ǂtO擾

extern s8 EffectRenderSetup( s8 ProjectMode = EF_PROJECT_ORTHO,
								s8 BlendMode = EF_BLEND_ALPHA,
								s8 TevMode = EF_TEV_USETEX,
								s8 TexColorIgnoreFlag = FALSE ) ;						// `̏
extern s8 EffectProjectSetup( s8 ProjectMode ) ;										// ˉes̃ZbgAbv
extern s8 EffectBlendModeSetup( s8 BlendMode ) ;										// uh[h̃ZbgAbv
extern s8 EffectTevSetup( s8 TevMode ) ;												// TEṼZbgAbv
extern s8 EffectTexColorIgnoreSetup( bool IgnoreFlag ) ;								// eNX`J[𖳎邩AtOZbg
extern s8 EffectSetForcedPriority( bool ValidFlag, s32 Priority = 0 ) ;					// IɎw̗Dxɂ邩ǂ̃tOƂ̒lZbg

extern s8 EffectGetViewMatrix( MtxPtr MtxBuf ) ;										// GtFNggpĂr[s擾
extern s8 EffectGetInvViewMatrix( MtxPtr MtxBuf ) ;										// GtFNggpĂr[s̓]us擾

extern s8 PanelScreenEffectRestart( void );												// plʐpGtFNgĊJ֐
extern s8 PanelScreenEffectStop( void ) ;												// plʐpGtFNgXgbv֐
extern s8 PanelScreenEffectStopRelease( void ) ;										// plʐpGtFNgXgbv̉֐

extern s8 SubScreenEffectStop( void ) ;													// TuʐpGtFNgXgbv֐
extern s8 SubScreenEffectStopRelease( void ) ;											// TuʐpGtFNgXgbv̉֐

extern s8 GetFileName( const char *FullPath, char *FileNameBuf ) ;						// tpXt@Ĉ݂擾
extern s8 SetEffectSE2DFlag( s8 Flag ) ;												// rdQcŖ炷ǂ肷֐
extern s32 PlayEffectSE( int inId,
	                 u8  inVolume = SOUND_SYSTEM_SE_VOLUME,
	                 u8  inPan    = SOUND_PAN_CENTER,
	                 int inTrack  = 0,
	                 int inGroup  = 0 );	// QcʉĐ
extern s32 PlayEffectSE3D( int inId,
	                   Vec tPos,
	                   int inMode   = 0,
	                   int inVolume = SOUND_SYSTEM_SE_VOLUME,
	                   int inTrack  = eSETrackBattleOverlap,
	                   int inGroup  = eSEGroupBattle00Env );	// RcʉĐ
extern s32 PlayEffectSEP( int inId,
					  s16 inPitch  = 0,
					  u8  inVolume = SOUND_SYSTEM_SE_VOLUME,
					  u8  inPan    = SOUND_PAN_CENTER,
					  int inTrack  = 0,
					  int inGroup  = 0 ); 	// QcʉĐ(sb`t)
extern s32 PlayEffectSE3DP( int inId,
						Vec tPos,
						s16 inPitch  = 0,
						int inMode   = 0,
						int inVolume = SOUND_SYSTEM_SE_VOLUME,
						int inTrack  = eSETrackBattleOverlap,
						int inGroup  = eSEGroupBattle00Env );	// RcʉĐ(sb`t)

extern f32 GetRandF2Num( f32 Max, f32 Min ) ;										// _ Max >= x >= Min ̒l𓾂
extern s32 GetRandI2Num( s32 Max, s32 Min, SAFERAND *Rand = NULL, s32 ComboMaxNum = 2 ) ;	// _ Max > x >= Min ̒l𓾂
extern f32 GetRandFNum( f32 Num ) ;													// _ Num >= x >= 0 ̒l𓾂
extern s32 GetRandINum( s32 Num, SAFERAND *Rand = NULL, s32 ComboMaxNum = 2 ) ;		// _ Num > x >= 0 ̒l𓾂

extern void DrawTex( f32 x, f32 y, TEXDATA *Tex, u32 color = 0xffffffff ) ;							// eNX``悷
extern void DrawTex2( f32 x, f32 y, TEXDATA *Tex, u8 XDiv, u8 XDivp, u32 color = 0xffffffff ) ;		// eNX``悷
extern void DrawTex3( f32 x1, f32 y1, f32 x2, f32 y2, TEXDATA *Tex = NULL, u32 color = 0xffffffff ) ;				// eNX``悷
extern void DrawTex4( f32 x1, f32 y1, f32 x2, f32 y2, f32 u1, f32 v1, f32 u2, f32 v2, TEXDATA *Tex = NULL, u32 color = 0xffffffff ) ;		// eNX``悷 
extern void DrawTex5( f32 x, f32 y, TEXDATA *Tex, u8 XDiv, u8 YDiv, u8 XDivp, u8 YDivp, u32 color = 0xffffffff ) ;		// eNX``悷
extern void DrawTex6( f32 x1, f32 y1, f32 x2, f32 y2,
							 f32 ult, f32 vlt, f32 urt, f32 vrt,
							 f32 ulb, f32 vlb, f32 urb, f32 vrb,
							 u32 clt, u32 crt, u32 crb, u32 clb, TEXDATA *Tex = NULL ) ;		// eNX``悷 
extern void DrawRotTex( f32 x, f32 y, f32 rot, f32 exrate, TEXDATA *Tex, u32 color = 0xffffffff ) ;	// eNX`]`悷
extern void DrawRotTex2( f32 x, f32 y, f32 cx, f32 cy, f32 rot, f32 exrate, TEXDATA *Tex = NULL, u32 color = 0xffffffff ) ;	// eNX`]`悷
extern void DrawExTex( f32 x, f32 y, f32 exrate, bool centerf, TEXDATA *Tex, u32 color = 0xffffffff ) ;	// g`悷
extern void DrawBox( f32 x1, f32 y1, f32 x2, f32 y2, u32 color ) ;								// {bNX`悷
extern void DrawGradBoxLR( f32 x1, f32 y1, f32 x2, f32 y2, u32 cl, u32 cr ) ;					// Of[Vt{bNX`悷()
extern void DrawGradBoxTB( f32 x1, f32 y1, f32 x2, f32 y2, u32 ct, u32 cb ) ;					// Of[Vt{bNX`悷(c)
extern void DrawGradBox( f32 x1, f32 y1, f32 x2, f32 y2, u32 clt, u32 crt, u32 crb, u32 clb ) ;	// Of[Vt{bNX`悷(Sӏw)
extern void DrawLineBox( f32 x1, f32 y1, f32 x2, f32 y2, u32 color, u8 width = 1 ) ;			// ŕ`{bNX`悷
extern void DrawLine( f32 x1, f32 y1, f32 x2, f32 y2, u32 color ) ;								// `
extern void DrawLine2( f32 x1, f32 y1, u32 c1, f32 x2, f32 y2, u32 c2 ) ;						// `Q

extern void DrawTexNB( f32 x, f32 y, TEXDATA *Tex, u32 color = 0xffffffff ) ;							// eNX``悷
extern void DrawTex3NB( f32 x1, f32 y1, f32 x2, f32 y2, u32 color = 0xffffffff ) ;						// eNX``悷
extern void DrawTex4NB( f32 x1, f32 y1, f32 x2, f32 y2, f32 u1, f32 v1, f32 u2, f32 v2, u32 color = 0xffffffff ) ;		// eNX``悷 
extern void DrawTex6NB( f32 x1, f32 y1, f32 x2, f32 y2,
						 f32 ult, f32 vlt, f32 urt, f32 vrt,
						 f32 ulb, f32 vlb, f32 urb, f32 vrb,
						 u32 clt, u32 crt, u32 crb, u32 clb ) ;		// eNX``悷 
extern void DrawBoxNB( f32 x1, f32 y1, f32 x2, f32 y2, u32 color ) ;							// {bNX`悷
extern void DrawGradBoxLRNB( f32 x1, f32 y1, f32 x2, f32 y2, u32 cl, u32 cr ) ;					// Of[Vt{bNX`悷()
extern void DrawGradBoxTBNB( f32 x1, f32 y1, f32 x2, f32 y2, u32 ct, u32 cb ) ;					// Of[Vt{bNX`悷(c)
extern void DrawGradBoxNB( f32 x1, f32 y1, f32 x2, f32 y2, u32 clt, u32 crt, u32 crb, u32 clb ) ;	// Of[Vt{bNX`悷(Sӏw)
extern void DrawLineNB( f32 x1, f32 y1, f32 x2, f32 y2, u32 color ) ;							// `
extern void DrawLine2NB( f32 x1, f32 y1, u32 c1, f32 x2, f32 y2, u32 c2 ) ;						// `Q

extern void DrawTex3D( Vec *BaseV, f32 Size, f32 x, f32 y, f32 z, TEXDATA *Tex = NULL, u32 color = 0xffffffff ) ;	// r{[heNX``֐
extern void DrawTex3D( Vec *BaseV, f32 Size, Vec Trans, TEXDATA *Tex = NULL, u32 color = 0xffffffff ) ;				// r{[heNX``֐
extern void DrawExTex3D( MtxPtr mtx, f32 ExW, f32 ExH, f32 Rot, f32 Size, Vec Trans, TEXDATA *Tex = NULL, u32 color = 0xffffffff ) ;		// r{[heNX`g]`֐
extern void DrawTex3DNB( Vec *BaseV, f32 Size, f32 x, f32 y, f32 z, u32 color = 0xffffffff ) ;						// r{[heNX``֐
extern void DrawTex3DNB( Vec *BaseV, f32 Size, Vec Trans, u32 color = 0xffffffff ) ;								// r{[heNX``֐

extern void DrawCylinSetup( Vec dir ) ;																				// ~`̏s
extern void DrawCylin( Vec basepos, Vec zv, f32 p1, f32 p2, f32 size1, f32 size2, u32 color, u8 DivNum = 8 ) ;		// ~`悷

extern void DrawCircle_3D( Vec pos, f32 r, u32 outcolor, u32 incolor, s32 divnum ) ;					// ~`
extern void DrawCircle2_3D( Vec pos, f32 outR, f32 inR, u32 outcolor, u32 incolor, s32 divnum ) ;	// h[ic`

extern void CreateBillVert( MtxPtr mtx, Vec *buf, f32 XSize = 1.0F, f32 YSize = 1.0F, f32 Rot = 0.0F ) ;		// r{[h_쐬
extern void GetXYZVector( Vec Dir, Vec *XVec, Vec *YVec, Vec *ZVec ) ;			// w̃xNg牡AÂRxNg擾( NULL ɂƎ擾Ȃ )
extern void GetDir3( Vec Dir, DIR3 *DirBuf ) ;									// xNgOf[^擾
extern void GetDirPos( DIR3 *Dir, Vec *Pos, f32 x, f32 y, f32 z ) ;				// O񂩂ʒu擾
extern void GetDirVec( Vec *Dir, f32 oir, f32 xz ) ;							// IC[pƂwyʉ]lxNg擾
extern void GetDirAngle( Vec Dir, f32 *oir, f32 *xz ) ;							// xNgIC[pƂwyʉ]p𓾂

extern void GetJObjZVec( HSD_JObj *JObj, Vec *ZVec ) ;							// inĂỹxNg𓾂
extern void GetJObjPos( HSD_JObj *JObj, Vec *Pos ) ;							// inĂW𓾂
extern u32 GetEffectTime( void ) ;												// t[JEgGtFNgԂ擾

extern void SetEffectViewPort( u16 left, u16 top, u16 right, u16 bottom ) ;		// GtFNg̃r[Ɓ[ƂZbg
//extern void SetEffectKyouseiPriority( bool ValidFlag, s32 KyouseiPriority = -1 ) ;	// Dxݒ肷

#define DrawTex3NBM( x1, y1, x2, y2, color )			\
	GP2( (x1), (y1) ) ;	GCX(color) ; GT( 0.0F,	0.0F ) ;	\
	GP2( (x2), (y1) ) ;	GCX(color) ; GT( 1.0F,	0.0F ) ;	\
	GP2( (x2), (y2) ) ;	GCX(color) ; GT( 1.0F,	1.0F ) ;	\
	GP2( (x1), (y2) ) ;	GCX(color) ; GT( 0.0F,	1.0F ) ;


#endif


