///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBillboard
//
// YK7EffectBillboard.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/10/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectBillboard.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

/*
#undef K7AppSmallMemAllocName
#define K7AppSmallMemAllocName ghmGcMemAllocName
#undef K7AppSmallMemFree
#define K7AppSmallMemFree ghmGcMemFree
*/

#define TEXLISTNAME	"/Yam/Effect/Billboard/BillTex"		// r{[heNX`[ǂݍݗpt@Cl[

// eGtFNgɎgpr{[h̃eNX`hc
static s8 BillBoardEffectUseTexID[BILLEFF_NUM] =
{
	BILLID_WATER,			// XvN[
	BILLID_SPFIRE,			// ΂̕
	BILLID_SPFIRE,			// ΂̕Q(fJC)
	BILLID_LINE,			// ̉J
	BILLID_3DLINE,			// ~XVbg
	BILLID_TUBA,			// 
	BILLID_POPCORN,			// |bvR[
	BILLID_STEAM,			// C(p)
	BILLID_BALLOON,			// D
	BILLID_STEAM,			// 
	BILLID_3DLINE,			// Ή
	BILLID_STEAM,			// C(R[q[p)
} ;

// eNX`̏c̕
static u8 BillBoardTexDivNum[BILLID_NUM][2] =
{
	1, 1,			// 
	1, 1,			// ΂̕
	1, 1,			// p
	1, 1,			// RcCp
	1, 1,			// 
	1, 2,			// |bvR[
	1, 1,			// C
	2, 2,			// D
	1, 1,			// 
	1, 1,			// ΂̕Q
	1, 1,			// LL
} ;

// eeNX`̃^Cv( 0:ʂ̃r{[h  1:C  2:RcC  3:At@̂ )
static s8 BillBoardTexType[BILLID_NUM] =
{
	0,			// 
	0,			// ΂̕
	1,			// p
	2,			// RcCp
	0,			// 
	0,			// |bvR[
	3,			// C
	0,			// D
	0,			// 
	0,			// ΂̕Q
	0,			// LL
} ;

// ̏ꍇ̐̑
static u8 BillBoardTexLineWidth[BILLID_NUM] =
{
	0,				// 
	0,				// ΂̕
	12,				// p
	0,				// RcCp
	0,				// 
	0,				// |bvR[
	0,				// C
	0,				// D
	0,				// 
	0,				// ΂̕Q
	0,				// LL
} ;


// datatype -------------------------------------

// data -----------------------------------------

BILLBOARDUNION BlUnion ;

// function proto type --------------------------

static inline void GetCoordAxis( Vec *Dir, Vec *XAxis, Vec *YAxis ) ;		// ɐȕʂ̍W擾
static inline void GetCoordAxisPoint( Vec *Point, Vec *XAxis, Vec *YAxis, f32 x, f32 y, Vec *Dest ) ;
static inline void GetDirConv( Vec *Dir, f32 XZRot, f32 OirRot ) ;			// 

// function code --------------------------------

// 
static inline void GetDirConv( Vec *Dir, f32 *XZRot, f32 *OirRot )
{
	// 
	if( Dir->z == 0.0F || Dir->x == 0.0F )
	{
		*XZRot = 0.0F ;
	}
	else
	{
		*XZRot = atan2( Dir->z, Dir->x ) ;
	}
	if( Dir->y == 0.0F )
	{
		*OirRot = 0.0F ;
	}
	else
	{
		*OirRot = atan2( Dir->y, Dir->x * cos( -*XZRot ) - Dir->z * sin( -*XZRot ) ) ;
	}
}


static inline void GetCoordAxisPoint( Vec *Point, Vec *XAxis, Vec *YAxis, f32 x, f32 y, Vec *Dest )
{
	Dest->x = Point->x + XAxis->x * x + YAxis->x * y ;
	Dest->y = Point->y + XAxis->y * x + YAxis->y * y ;
	Dest->z = Point->z + XAxis->z * x + YAxis->z * y ;
}


// ɐȕʂ̍W擾
static inline void GetCoordAxis( Vec *Dir, Vec *XAxis, Vec *YAxis )
{
	Vec Axis ;

	Axis.x = 0.0F ;	Axis.y = 1.0F ;	Axis.z = 0.0F ;
	VECCrossProduct( &Axis, Dir, XAxis ) ;
	VECCrossProduct( Dir, XAxis, YAxis ) ;
}



// w̃r{[hGtFNg̃ZbgAbvs
extern s8 SetupBillboardEffectID( s8 BillEffID )
{
	// ZbgAbvĂȂZbgAbvs
	if( BlUnion.EffectState[BillEffID] != 2 )
	{
		// GtFNgɎgpeNX`̏Ԃɂď𕪊
		if( BlUnion.Image[BillBoardEffectUseTexID[BillEffID]].UseFlag == FALSE )
		{
			// ǂݍ܂ĂȂǂݍ݊Jn
			LoadBillboardImage( BillBoardEffectUseTexID[BillEffID] ) ;
			
			// Ԃ 1 ̓ǂݍݒɂ
			BlUnion.EffectState[BillEffID] = 1 ;
		}
		else
		{
			// eNX`ǂݍݏIĂ邩ׂ
			if( CheckBillboardImageLoadState( BillBoardEffectUseTexID[BillEffID] ) == TRUE )
			{
				// ǂݍ܂ĂZbgAbvɂ
				BlUnion.EffectState[BillEffID] = 2 ;
			}
		}
	}

/*
	// ŵhc̃r{[hǂݍ܂ĂȂǂݍ
	if( BlUnion.BillImageID[BillID] == -1 )
	{
		char FilePath[256] ;
		
		sprintf( FilePath, "%s%02d.bin", ANIMLISTNAME, (int)BillID ) ;
		BlUnion.BillImageID[BillID] = LoadBillboardData( FilePath ) ;
		
		// G[̎ -1 Ԃ
		if( BlUnion.BillImageID[BillID] == -1 ) return -1 ;
	}
*/
	// I
	return 0 ;
}

// w̃r{[hGtFNǧns
extern s8 ReleaseBillboardEffectID( s8 BillEffID )
{
	// w̃GtFNggpĂeNX`ĂȂ
	if( BlUnion.Image[BillBoardEffectUseTexID[BillEffID]].UseFlag != FALSE )
	{
		ReleaseBillboardImage( BillBoardEffectUseTexID[BillEffID] ) ;
		
		// ZbgAbv̏Ԃ 0 ̂ȂɂĂȂɂ
		BlUnion.EffectState[BillEffID] = 0 ;
	}

/*
	// ĂȂ
	if( BlUnion.BillImageID[BillID] != -1 )
	{
		ReleaseBillboardData( (s8)BlUnion.BillImageID[BillID] ) ;
		BlUnion.BillImageID[BillID] = -1 ;
	}
*/

	// I
	return 0 ;
}

// w̃r{[hGtFNg̃ZbgAbvĂ邩擾( TRUE:Ă   FALSE: )
extern s8 CheckBillboardEffectIDState( s8 BillEffID )
{
	// ԂԂ
	return CheckBillboardImageLoadState( BillBoardEffectUseTexID[BillEffID] ) ;
//	return BlUnion.EffectState[BillEffID] == 2 ;

	// gĂȂ FALSE Ԃ
//	if( BlUnion.BillImageID[BillID] == -1 ) return FALSE ;

	// ԂԂ
//	return CheckBillboardImageLoadState( (s8)BlUnion.BillImageID[BillID] ) ;
}




// r{[hf[^[h
extern s8 LoadBillboardImage( s8 BillID )
{
	char FileName[256], NameBuf[64] ;
	BILLBOARDIMAGE *BillP ;
	s32 Size ;

	// AhX̃Zbg
	BillP = &BlUnion.Image[BillID] ;
	
	// ɓǂݍ܂Ă牽I
	if( BillP->UseFlag == TRUE ) return 0 ;

	// ǂݍރt@C쐬
	sprintf( FileName, "%s%02d.bin", TEXLISTNAME, BillID ) ;
	
	// ghmGcFile IuWFNg쐬			
	ghmGcMemSetAllocName("YLdBlImg");
	if( ( BillP->File = new ghmGcFile ) == NULL ) return -1;

	// t@CJ
	if( BillP->File->Open( FileName ) == false )
	{
		delete BillP->File ;
		BillP->File = NULL ;
		return -1 ;
	}

	// t@C̃TCY𓾂
	Size = (s32)OSRoundUp32B( BillP->File->GetLength(true) ) ;

	// t@C擾
	{
		strcpy( NameBuf, "Y_" ) ;
		GetFileName( FileName, &NameBuf[2] ) ;
	}
	
	// mۂ
	BillP->Tex = ( GhmGcTexHeader * )ghmGcMemAllocName( Size, NameBuf ) ;
	if( BillP->Tex == NULL )
	{
		delete BillP->File ;
		BillP->File = NULL ;
		return -1 ;
	}

	// ۂƃ[h
	BillP->File->Read( BillP->Tex, 0, Size ) ;
	
	// eNX`IuWFNg NULL Zbg
	memset( &BillP->TexObj, 0, sizeof( BillP->TexObj ) ) ;

	// t@Cǂݍ񂾃tO𗧂Ă
	BillP->FileFlag = TRUE ;

	// gptO𗧂Ă
	BillP->UseFlag = TRUE ;

	// ZbgAbvtO|
	BillP->SetupCompFlag = FALSE ;

	// I	
	return 0 ;
}

// r{[hf[^(bin)Zbg(Rs[͂܂̂ ReleaseBillboardData ܂œnf[^͉Ȃł)
extern s8 SetupBillboardImage( s8 BillID, void *BillData )
{
	BILLBOARDIMAGE *BillP ;

	// AhX̃Zbg
	BillP = &BlUnion.Image[BillID] ;
	
	// ɃZbgAbvĂ牽I
	if( BillP->UseFlag == TRUE ) return 0 ;

	// f[^AhXZbg
	BillP->Tex = ( GhmGcTexHeader * )BillData ;

	// gȂ̂ NULL Zbg
	BillP->File = NULL  ;

	// eNX`̃ZbgAbvs
	{
		GhmGcTexHeader *Tex = BillP->Tex ;

		// eNX`̃ZbgAbv
		
		// eNX`쐬
		GXInitTexObj( &BillP->TexObj, GHMGCTEX_GETIMAGE(Tex),
						 Tex->mWidth, Tex->mHeight, Tex->mFormat,
						  GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
		GXInitTexObjLOD( &BillP->TexObj, GX_LINEAR, GX_LINEAR, Tex->mMinLOD, Tex->mMaxLOD, 0.0F,
							GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;
	}

	// t@Cǂݍ񂾃tO|
	BillP->FileFlag = FALSE ;

	// gptO𗧂Ă
	BillP->UseFlag = TRUE ;
	
	// I
	return 0 ;
}



// r{[hf[^
extern s8 ReleaseBillboardImage( s8 BillID )
{
	BILLBOARDIMAGE *BillP ;

	// AhX̃Zbg
	BillP = &BlUnion.Image[BillID] ;
	
	// ɎgĂȂ牽I
	if( BillP->UseFlag == FALSE ) return 0 ;
	
	// t@Cǂݍ܂Ă邩tOĂ邩ǂŏ𕪊
	if( BillP->FileFlag == TRUE )
	{
		// t@C
		CLOSECHK( BillP->File ) ;
		
		// 
		CHKMEMFREE( BillP->Tex ) ;
	}
	
	// gptO|
	BillP->UseFlag = FALSE ;
	
	// ZbgAbvtO|
	BillP->SetupCompFlag = FALSE ;
	
	// I
	return 0 ;
}

// r{[hf[^ǂݍ܂Ă邩ǂ`FbN( TRUE:ǂݍ܂Ă   FALSE:ǂݍ܂ĂȂ )
extern s8 CheckBillboardImageLoadState( s8 BillID )
{
	BILLBOARDIMAGE *BillP ;

	BillP = &BlUnion.Image[BillID] ;
	
	// ɎgĂȂ FALSE Ԃ
	if( BillP->UseFlag == FALSE ) return FALSE ;
	if( BillP->SetupCompFlag == TRUE ) return TRUE ;
	
	// t@CgĂ邩ǂŏ𕪊
	if( BillP->FileFlag == TRUE )
	{
		// C[Wf[^ǂݏIĂȂǂݍ܂ĂȂԂ
		if( CHKFILELOAD( BillP->File ) == FALSE ) return FALSE ;
		
		// C[Wf[^ǂݏIĂꍇ̓eNX`̃ZbgAbvIĂ邩ׂ
		{
			if( BillP->File != NULL )
			{
				// IĂȂeNX`̃ZbgAbvs
				{
					GhmGcTexHeader *Tex = BillP->Tex ;

					GXInitTexObj( &BillP->TexObj, GHMGCTEX_GETIMAGE(Tex),
									 Tex->mWidth, Tex->mHeight, Tex->mFormat,
									  GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
					GXInitTexObjLOD( &BillP->TexObj, GX_LINEAR, GX_LINEAR, Tex->mMinLOD, Tex->mMaxLOD, 0.0F,
										GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;
				}

				// t@C
				CLOSECHK( BillP->File ) ;
				
				// NULL Zbg
				BillP->File = NULL ;
				
				// ZbgAbvtO𗧂Ă
				BillP->SetupCompFlag = TRUE ;
				
				// ZbgAbv
				return TRUE ;
			}
		}
	}

	// ɂĂZbgAbvs
//	return BillP->FileFlag == FALSE ? (s8)TRUE : (s8)CHKFILELOAD( BillP->File ) ;
	return FALSE ;
}

// r{[hf[^̃AhX擾
extern BILLBOARDIMAGE *GetBillboardImage( s8 BillID )
{
	return &BlUnion.Image[BillID] ;
}


// r{[hGtFNg̋ʃf[^
extern s8 InitBillboardData( void )
{
	MEMINIT( BlUnion ) ;
	
	// I
	return 0 ;
}

// r{[hGtFNg̏풓f[^̓ǂݍ݊𒲂ׂ( TRUE: FALSE:܂ )
extern s8 CheckBillboardData( void )
{
	return TRUE ;
}

// r{[hGtFNg̋ʃf[^n
extern s8 EndBillboardData( void )
{
	BILLBOARDUNION *BillboardUnion = &BlUnion ;
	
	// ĂȂr{[hC[Wf[^ׂĉ
	{
		u8 i ;
		
		for( i = 0 ; i < BILLID_NUM ; i ++ )
		{
			if( BlUnion.Image[i].UseFlag == TRUE )
			{
				ReleaseBillboardImage( (s8)i ) ;
			}
		}
	}

	// [
	MEMINIT( BlUnion ) ;

	// I
	return 0 ;
}

// r{[hGtFNg쐬2
extern EFFECT *CreateBillboardEffect2( s8 EffectID, Vec Point, f32 YukaY,
										u32 MaxObjectNum, GXColor *Color, s32 Priority )
{
	// GtFNgio[ɂď𕪊
	switch( EffectID )
	{
	case BILLEFF_SPRINKLER :			// XvN[̏ꍇ
		{
			Vec SSpeed ;
			
			SSpeed.x = 0.0F ;
			SSpeed.y = -VParam[ED_SPRINKLER][6] * 0.001F ;
			SSpeed.z = 0.0F ;
			
			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_SPRINKLER][4], Point,
									VParam[ED_SPRINKLER][0] * 0.01F, VParam[ED_SPRINKLER][1] * 0.01F,
									VParam[ED_SPRINKLER][2] * 0.01F, VParam[ED_SPRINKLER][3] * 0.01F,
									(Vec){0.0F,-1.0F,0.0F}, VParam[ED_SPRINKLER][5] * PI / 180.0F,
									2, FALSE,
									SSpeed, VParam[ED_SPRINKLER][7] * 0.001F,
									VParam[ED_SPRINKLER][8] * 0.001F, VParam[ED_SPRINKLER][9] * 0.001F,
									1.0F, 1.0F,
									VParam[ED_SPRINKLER][10], VParam[ED_SPRINKLER][11],
									YukaY, VParam[ED_SPRINKLER][12],
									MaxObjectNum == 0xffffffff ? (u32)VParam[ED_SPRINKLER][13] * 10 : MaxObjectNum, TRUE,
									NULL, -1, FALSE, Priority ) ;
		}
		break ;

	case BILLEFF_SPFIRE :			// ΂̏̕ꍇ
		{
			Vec SSpeed ;
			
			SSpeed.x = 0.0F ;
			SSpeed.y = VParam[ED_FIRESPARK][6] * 0.001F ;
			SSpeed.z = 0.0F ;
			
			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_FIRESPARK][4], Point,
									VParam[ED_FIRESPARK][0] * 0.01F, VParam[ED_FIRESPARK][1] * 0.01F,
									VParam[ED_FIRESPARK][2] * 0.01F, VParam[ED_FIRESPARK][3] * 0.01F,
									(Vec){0.0F,-1.0F,0.0F}, VParam[ED_FIRESPARK][5] * PI / 180.0F,
									2, FALSE,
									SSpeed, VParam[ED_FIRESPARK][7] * 0.001F,
									VParam[ED_FIRESPARK][8] * 0.001F, VParam[ED_FIRESPARK][9] * 0.001F,
									1.0F, 1.0F,
									VParam[ED_FIRESPARK][10], VParam[ED_FIRESPARK][11],
									YukaY, VParam[ED_FIRESPARK][12],
									MaxObjectNum == 0xffffffff ? (u32)VParam[ED_FIRESPARK][13] * 10 : MaxObjectNum, FALSE,
									NULL, -1, FALSE, Priority ) ;
		}
		break ;


	case BILLEFF_SPFIRE2 :			// ΂̕Q̏ꍇ
		{
			Vec SSpeed ;
			
			SSpeed.x = 0.0F ;
			SSpeed.y = VParam[ED_FIRESPARK2][6] * 0.001F ;
			SSpeed.z = 0.0F ;
			
			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_FIRESPARK2][4], Point,
									VParam[ED_FIRESPARK2][0] * 0.01F, VParam[ED_FIRESPARK2][1] * 0.01F,
									VParam[ED_FIRESPARK2][2] * 0.01F, VParam[ED_FIRESPARK2][3] * 0.01F,
									(Vec){0.0F,1.0F,0.0F}, VParam[ED_FIRESPARK2][5] * PI / 180.0F,
									2, FALSE,
									SSpeed, VParam[ED_FIRESPARK2][7] * 0.001F,
									VParam[ED_FIRESPARK2][8] * 0.001F, VParam[ED_FIRESPARK2][9] * 0.001F,
									1.0F, 1.0F,
									VParam[ED_FIRESPARK2][10], VParam[ED_FIRESPARK2][11],
									YukaY, VParam[ED_FIRESPARK2][12],
									MaxObjectNum == 0xffffffff ? (u32)VParam[ED_FIRESPARK2][13] * 10 : MaxObjectNum, FALSE,
									NULL, -1, FALSE, Priority ) ;
		}
		break ;


	case BILLEFF_BLOODRAIN :		// ̉J̏ꍇ
		{
			Vec Dir, SSpeed ;
			GXColor C ;
			
			SSpeed.x = 0.0F ;
			SSpeed.y = -VParam[ED_BLDRAIN][4] * 0.001F ;
			SSpeed.z = 0.0F ;
			
			Dir.x = 0.0F ;
			Dir.y = 1.0F ;
			Dir.z = 0.0F ;

			if( Color != NULL )
			{
				C = *Color ;
			}
			else
			{
				C.r = (u8)VParam[ED_BLDRAIN][1] ;
				C.g = (u8)VParam[ED_BLDRAIN][2] ;
				C.b = (u8)VParam[ED_BLDRAIN][3] ;
			}
			C.a = 255 ;

			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], FALSE, Point,
									1.0F, 0.0F,
									VParam[ED_BLDRAIN][5] * 0.1F, VParam[ED_BLDRAIN][6] * 0.1F,
									Dir, VParam[ED_BLDRAIN][9] * PI / 180.0F,
									2, FALSE,
									SSpeed, 1.0F,
									0.001F, 0.0001F,
									1.0F, 1.0F,
									500, 400,
									YukaY, VParam[ED_BLDRAIN][7],
									MaxObjectNum == 0xffffffff ? (u32)VParam[ED_BLDRAIN][8] * 10 : MaxObjectNum, TRUE,
									&C, -1, FALSE, Priority ) ;
		}
		break ;

	case BILLEFF_MISSSHOT :
		{
			Vec Dir, SSpeed ;
			GXColor C ;
			
			SSpeed.x = 				SSpeed.y = 				SSpeed.z = 0.0F ;
			Dir.x = 0.0F ;			Dir.y = 1.0F ;			Dir.z = 0.0F ;
			
			if( Color != NULL )
			{
				C = *Color ;
			}
			else
			{
				C.r = (u8)VParam[ED_MISS][5] ;
				C.g = (u8)VParam[ED_MISS][6] ;
				C.b = (u8)VParam[ED_MISS][6] ;
			}
			C.a = 255 ;

			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_MISS][0], Point,
									VParam[ED_MISS][13] * 0.01F, VParam[ED_MISS][14] * 0.01F,
									VParam[ED_MISS][1] * 1.0F, VParam[ED_MISS][2] * 1.0F,
									Dir, VParam[ED_MISS][8] * PI / 1800.0F ,
									FALSE, TRUE,
									SSpeed, 1.0F,
									1.0F, 1.0F,
									1.0F, 1.0F,
									VParam[ED_MISS][4], VParam[ED_MISS][4],
									YukaY, 0.0F,
									MaxObjectNum == 0xffffffff ? (u32)VParam[ED_MISS][9] : MaxObjectNum, FALSE,
									&C, -1, FALSE, Priority ) ;
		}
		break ;
		
	case BILLEFF_TUBA :
		{
			Vec Dir, SSpeed ;
			GXColor C ;
			
			SSpeed.x = 				SSpeed.z = 0.0F ;
			SSpeed.y = -VParam[ED_TUBA][4] * 0.01F ;
			Dir.x = 0.0F ;			Dir.y = 1.0F ;			Dir.z = 0.0F ;
			
			C.r = 255 ;				C.g = 255 ;				C.b = 255 ;
			C.a = 255 ;

			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_TUBA][2], Point,
									VParam[ED_TUBA][0] * 0.01F, VParam[ED_TUBA][0] * 0.01F,
									VParam[ED_TUBA][1] * 0.1F, VParam[ED_TUBA][1] * 0.1F,
									Dir, 0.0F,
									FALSE, FALSE,
									SSpeed, 1.0F,
									1.0F, 1.0F,
									1.0F, 1.0F,
									10000, 10000,
									YukaY, 0.0F,
									MaxObjectNum == 0xffffffff ? (u32)1 : MaxObjectNum, TRUE,
									&C, -1, FALSE, Priority ) ;
		}
		break ;

	case BILLEFF_POPCORN :
		{
			Vec Dir, SSpeed ;
			GXColor C ;
			
			SSpeed.x = 				SSpeed.z = 0.0F ;
			SSpeed.y = -VParam[ED_POPCORN][4] * 0.01F ;
			Dir.x = 0.0F ;			Dir.y = 1.0F ;			Dir.z = 0.0F ;
			
			C.r = 255 ;				C.g = 255 ;				C.b = 255 ;
			C.a = 255 ;

			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_POPCORN][2], Point,
									VParam[ED_POPCORN][0] * 0.01F, VParam[ED_POPCORN][0] * 0.01F,
									VParam[ED_POPCORN][1] * 0.1F, VParam[ED_POPCORN][1] * 0.1F,
									Dir, VParam[ED_POPCORN][7] * 360 / PI_2,
									FALSE, FALSE,
									SSpeed, 1.0F,
									1.0F, 1.0F,
									1.0F, 1.0F,
									10000, 10000,
									YukaY, 0.0F,
									MaxObjectNum == 0xffffffff ? (u32)1 : MaxObjectNum, TRUE,
									&C, -1, FALSE, Priority ) ;
		}
		break ;

	case BILLEFF_STEAM :
		{
			Vec Dir, SSpeed ;
			GXColor C ;
			
			SSpeed.y = 		SSpeed.x = 		SSpeed.z = 0.0F ;
			Dir.x = 0.0F ;	Dir.y = 1.0F ;	Dir.z = 0.0F ;
			
			C.r = (u8)VParam[ED_STEAM][9] ;		C.g = (u8)VParam[ED_STEAM][10] ;		C.b = (u8)VParam[ED_STEAM][11] ;
			C.a = (u8)VParam[ED_STEAM][12] ;

			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_STEAM][2], Point,
									VParam[ED_STEAM][0] * 0.01F, VParam[ED_STEAM][0] * 0.01F,
									VParam[ED_STEAM][7] * 0.001F, VParam[ED_STEAM][8] * 0.001F,
									Dir, 0,
									FALSE, FALSE,
									SSpeed, 1.0F,
									VParam[ED_STEAM][5] * 0.01F, VParam[ED_STEAM][6] * 0.01F,
									VParam[ED_STEAM][3] * 0.01F, VParam[ED_STEAM][4] * 0.01F,
									VParam[ED_STEAM][17], VParam[ED_STEAM][18],
									YukaY, 0.0F,
									MaxObjectNum == 0xffffffff ? (u32)1 : MaxObjectNum, FALSE,
									&C, -1, FALSE, Priority ) ;
		}
		break ;
		
	case BILLEFF_STEAM2 :
		{
			Vec Dir, SSpeed ;
			GXColor C ;
			const static u16 _Table[] = 
			{	142,		50,		1,		20,		10,
				20,		10,		23,		8,		255,

				255,		255,		52,		40,		70,
				0,		0,		20,		10,		10,

				18,		0,		0,		0,		0,
				0,		0,		0,		0,		0 } ;
			
			SSpeed.y = 		SSpeed.x = 		SSpeed.z = 0.0F ;
			Dir.x = 0.0F ;	Dir.y = 1.0F ;	Dir.z = 0.0F ;
			
			C.r = (u8)_Table[9] ;		C.g = (u8)_Table[10] ;		C.b = (u8)_Table[11] ;
			C.a = (u8)_Table[12] ;

			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)_Table[2], Point,
									_Table[0] * 0.01F, _Table[0] * 0.01F,
									_Table[7] * 0.001F, _Table[8] * 0.001F,
									Dir, 0,
									FALSE, FALSE,
									SSpeed, 1.0F,
									_Table[5] * 0.01F, _Table[6] * 0.01F,
									_Table[3] * 0.01F, _Table[4] * 0.01F,
									_Table[17], _Table[18],
									YukaY, 0.0F,
									MaxObjectNum == 0xffffffff ? (u32)1 : MaxObjectNum, FALSE,
									&C, -1, FALSE, Priority ) ;
		}
		break ;

	case BILLEFF_BALLOON :
		{
			Vec Dir, SSpeed ;
			GXColor C ;
			
			SSpeed.y = VParam[ED_BALLOON][19] * 0.0001F ;
			SSpeed.x = 		SSpeed.z = 0.0F ;
			Dir.x = 0.0F ;	Dir.y = 1.0F ;	Dir.z = 0.0F ;

			C.r = 255 ;		C.g = 255 ;		C.b = 255 ;			C.a = 255 ;

			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_BALLOON][2], Point,
									VParam[ED_BALLOON][0] * 0.1F, VParam[ED_BALLOON][0] * 0.1F,
									VParam[ED_BALLOON][7] * 0.01F, VParam[ED_BALLOON][8] * 0.01F,
									Dir, VParam[ED_BALLOON][15] * PI_2 / 360,
									FALSE, TRUE,
									SSpeed, VParam[ED_BALLOON][16] * 0.001F,
									VParam[ED_BALLOON][5] * 0.01F, VParam[ED_BALLOON][6] * 0.01F,
									VParam[ED_BALLOON][3] * 0.01F, VParam[ED_BALLOON][4] * 0.01F,
									(u16)( VParam[ED_BALLOON][17] * 10 ), (u16)( VParam[ED_BALLOON][18] * 10 ),
									YukaY, VParam[ED_BALLOON][13] * 0.01F,
									MaxObjectNum == 0xffffffff ? (u32)1 : MaxObjectNum, TRUE,
									&C, -1, TRUE, Priority ) ;
		}
		break ;
		
	case BILLEFF_SMOKE :
		{
			Vec Dir, SSpeed ;
			GXColor C ;
			
			SSpeed.x = 		SSpeed.y =		SSpeed.z = 0.0F ;
			Dir.x = 0.0F ;	Dir.y = 1.0F ;	Dir.z = 0.0F ;

			C.r = (u8)VParam[ED_CLOUD][9] ;
			C.g = (u8)VParam[ED_CLOUD][10] ;
			C.b = (u8)VParam[ED_CLOUD][11] ;
			C.a = (u8)VParam[ED_CLOUD][12] ;

			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_CLOUD][0], Point,
									VParam[ED_CLOUD][1] * 1.0F, VParam[ED_CLOUD][2] * 1.0F,
									0.0F, 0.0F,
									Dir, 0.0F,
									FALSE, FALSE,
									SSpeed, 0.0F,
									VParam[ED_CLOUD][3] * 0.001F, VParam[ED_CLOUD][4] * 0.001F,
									1.0F, 1.0F,
									(u16)( VParam[ED_CLOUD][5] * 10 ), (u16)( VParam[ED_CLOUD][6] * 10 ),
									YukaY, VParam[ED_CLOUD][7] * 0.1F,
									MaxObjectNum == 0xffffffff ? (u32)1 : MaxObjectNum, FALSE,
									&C, -1, FALSE, Priority ) ;
		}
		break ;

	case BILLEFF_SPARK :
		{
			Vec Dir, SSpeed ;
			GXColor C ;
			
			SSpeed.x = 0.0F ;
			SSpeed.y = -VParam[ED_SPARK][8] * 0.001F ;
			SSpeed.z = 0.0F ;
			Dir.x = 0.0F ;	Dir.y = 1.0F ;	Dir.z = 0.0F ;

			C.r = (u8)VParam[ED_SPARK][1] ;
			C.g = (u8)VParam[ED_SPARK][2] ;
			C.b = (u8)VParam[ED_SPARK][3] ;
			C.a = (u8)VParam[ED_SPARK][4] ;

			return CreateBillboardEffect( BillBoardEffectUseTexID[EffectID], (u8)VParam[ED_SPARK][0], Point,
									1.0F, 0.0F,
									VParam[ED_SPARK][5] * 0.001F, VParam[ED_SPARK][6] * 0.001F,
									Dir, PI_2 / 360 * VParam[ED_SPARK][7],
									FALSE, TRUE,
									SSpeed, VParam[ED_SPARK][9] * 0.01F,
									VParam[ED_SPARK][10] * 0.01F, VParam[ED_SPARK][10] * 0.01F,
									1.0F, 1.0F,
									VParam[ED_SPARK][11], VParam[ED_SPARK][12],
									YukaY, 0.0F,
									(u32)VParam[ED_SPARK][13], FALSE,
									&C, -1, FALSE, Priority ) ;
		}
		break ;
	}

	// I
	return NULL ;
}


// r{[hGtFNg쐬
extern EFFECT *CreateBillboardEffect( s8 BillImageID, u8 AddBlendFlag, Vec Point,
										f32 MaxSize, f32 MinSize,
										f32 MaxSpeed, f32 MinSpeed,
										Vec Direction, f32 DirectionRange,
										u8 NonDirectionFlag, u8 OutSideFlag,
										Vec SSpeed, f32 Air,
										f32 MaxFadeOutSpeed, f32 MinFadeOutSpeed,
										f32 MaxFadeInSpeed, f32 MinFadeInSpeed,										
										u16 MaxDrawTime, u16 MinDrawTime,
										f32 YukaY, f32 CreateNumRate,
										u32 MaxObjectNum, u8 YukaYValidFlag,
										GXColor *Color, s32 SoundID,
										u8 TenjouModeFlag, s32 Priority )
{
	EFFECT *Effect ;
	BILLBOARDEFFECT *Bl ;
	BILLBOARDEFFECTOBJECT *ObjP ;
	
	// IuWFNgp̃m
	ObjP = ( BILLBOARDEFFECTOBJECT * )K7AppSmallMemAllocName( (s32)( MaxObjectNum * sizeof( BILLBOARDEFFECTOBJECT ) ), "Y_EBlObj" ) ;
	if( ObjP == NULL ) return NULL ;
	memset( ObjP, 0, MaxObjectNum * sizeof( BILLBOARDEFFECTOBJECT ) ) ;

	// Vr{[hf[^쐬
	Effect = AddEffectData( EFF_BILLBOARD, (void**)&Bl, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( ObjP ) ;
		return NULL ;
	}
	
	// f[^̕ۑ
	Bl->BillObjMoveCallBack = NULL ;
	Bl->Data = NULL ;
	Bl->ObjP = ObjP ;
	Bl->MaxObjectNum = MaxObjectNum ;
	Bl->ObjNum = 0 ;
	Bl->BillImageID = BillImageID ;
	Bl->AddBlendFlag = AddBlendFlag ;
	Bl->Point = Point ;
	Bl->MaxSize = MaxSize ;		Bl->MinSize = MinSize ;
	Bl->MaxSpeed = MaxSpeed ;	Bl->MinSpeed = MinSpeed ;
	Bl->Direction = Direction ;
	Bl->DirectionRange = DirectionRange ;
	Bl->OutSideFlag = OutSideFlag ;
	Bl->NonDirectionFlag = NonDirectionFlag ;
	Bl->SSpeed = SSpeed ;
	Bl->Air = Air ;
	Bl->MaxFadeOutSpeed = MaxFadeOutSpeed ;		Bl->MinFadeOutSpeed = MinFadeOutSpeed ;
	Bl->MaxFadeInSpeed = MaxFadeInSpeed ;		Bl->MinFadeInSpeed = MinFadeInSpeed ;
	Bl->MaxDrawTime = MaxDrawTime ;		Bl->MinDrawTime = MinDrawTime ;
	Bl->YukaY = YukaY ;
	Bl->PosJObj = NULL ;
	Bl->CreateNumRate = CreateNumRate ;
	Bl->TenjouModeFlag = TenjouModeFlag ;
	Bl->YukaYValidFlag = YukaYValidFlag ;
	if( Color == NULL )
	{
		Bl->Color = (GXColor){255,255,255,255} ;
	}
	else
	{
		Bl->Color = *Color ;
	}
	
	// 
	GetDirConv( &Direction, &Bl->XZRot, &Bl->OirRot ) ;

	Bl->FastDeleteFlag = FALSE  ;
	Bl->DrawFlag = TRUE ;
	Bl->CreateFlag = TRUE ;
	Bl->SpeedRate = 1.0F ;
	Bl->CreateRate = 1.0F ;
	Bl->CreateCounter = 0.0F ;
	Bl->SizeRate = 1.0F ;
	
	if( GetEffectSoundOffFlag() == FALSE && SoundID != -1 )
	{
		Bl->SoundID = PlayEffectSE3D( SoundID, Bl->Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
	}
	else
	{
		Bl->SoundID = -1 ;
	}

	// I
	return Effect ;
}

// r{[h̃GtFNǧns
extern s8 ReleaseBillboardEffect( EFFECT *Effect )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// ̉
	CHKMEMFREE2( Bl->ObjP ) ;
	
	if( Bl->SoundID != -1 )
	{
		gpSound->mStopSENo( Bl->SoundID ) ;
	}

	// I
	return 0 ;
}

// r{[h̃GtFNgPt[
extern s8 MoveBillboardEffect( EFFECT *Effect )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;
	BILLBOARDIMAGE *Image = &BlUnion.Image[Bl->BillImageID] ;
	BILLBOARDEFFECTOBJECT *Obj ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// f[^A폜tOĂ邩A
	// ͍폜]tOĂăIuWFNg폜
	if( /*Image->UseFlag == FALSE ||*/ Bl->FastDeleteFlag == TRUE ||
		( Bl->ObjNum == 0 && Effect->DelReqFlag == TRUE ) )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	if( Image->UseFlag == FALSE ) return 0 ;

	// ǂݍ݃`FbNAǂݍ܂Ė珟ɓǂݍݎn߂
	LoadBillboardImage( Bl->BillImageID ) ;
	CheckBillboardImageLoadState( Bl->BillImageID ) ;

	// IuWFNg̐JԂ
	{
		u32 i, Num ;
		
		Obj = Bl->ObjP ;
		Num = Bl->ObjNum ;
		for( i = 0 ; i < Num ; Obj ++ )
		{
			// f[^gp̏ꍇ̂ݏ
			if( Obj->UseFlag == TRUE ) 
			{
				i ++ ; 

				// R[obN֐o^Ă炻Ă
				if( Bl->BillObjMoveCallBack != NULL )
				{
					// OȊOԂĂ폜
					if( Bl->BillObjMoveCallBack( Obj, Bl, Bl->Data ) != 0 ) goto DEL ;
				}
				else
				{
					// ړ
					Obj->Point.x += Obj->Speed.x ;
					Obj->Point.y += Obj->Speed.y ;
					Obj->Point.z += Obj->Speed.z ;
				}

				// x
				Obj->Speed.x += Obj->SSpeed.x ;
				Obj->Speed.y += Obj->SSpeed.y ;
				Obj->Speed.z += Obj->SSpeed.z ;
				
				// 
				Obj->Speed.x *= Obj->Air ;
				Obj->Speed.y *= Obj->Air ;
				Obj->Speed.z *= Obj->Air ;

				// WĂ
				if( BillBoardTexType[Bl->BillImageID] >= 1 && BillBoardTexType[Bl->BillImageID] != 3 )
				{
					s32 i ;
					for( i = BILL_BACKPOINTNUM - 2 ; i >= 0 ; i -- )
						Obj->BackPoint[i+1] = Obj->BackPoint[i] ;
					Obj->BackPoint[0] = Obj->Point ;
				}

				// ɗ폜
				if( Bl->YukaYValidFlag == TRUE )
				{
					// \Ԃ̃CNg
					Obj->TimeCon ++ ;

					// tF[hC
					if( ( ( Bl->TenjouModeFlag == TRUE && Obj->Point.y < Bl->YukaY ) ||
						( Bl->TenjouModeFlag == FALSE ) ) && Obj->a < Obj->Alpha )
					{
						Obj->a += Obj->FadeInSpeed ;
						if( Obj->a > Obj->Alpha ) Obj->a = Obj->Alpha ;
					}
						
					if( Bl->TenjouModeFlag == TRUE )
					{
						if( Obj->Point.y > Bl->YukaY )
						{
							Obj->a -= 0.1F ;
							if( Obj->a <= 0.0F ) goto DEL ;
						}
					}
					else
					{
						if( Obj->Point.y < Bl->YukaY )
						{
					DEL :
							Obj->UseFlag = FALSE ;
							Bl->ObjNum -- ;
						}
					}
				}
				else
				{
					// At@l̃Zbg
					if( Obj->TimeCon >= Obj->DrawTime )
					{
						// ɃtF[hAEgn܂Ăꍇ̏
						
						// At@lOȉɂȂIuWFNg폜
						Obj->a -= Obj->FadeOutSpeed ;
						if( Obj->a <= 0.0F )
						{
							Obj->UseFlag = FALSE ;
							
							// IuWFNg̐炷
							Bl->ObjNum -- ;
						}
					}
					else
					{
						// \Ԃ̃CNg
						Obj->TimeCon ++ ;
					
						// tF[hC
						if( Obj->a < Obj->Alpha )
						{
							Obj->a += Obj->FadeInSpeed ;
							if( Obj->a > Obj->Alpha ) Obj->a = Obj->Alpha ;
						}
					}
				}
			}
		}
	}
	
	// IuWFNgVɐ鏈
	if( Bl->CreateFlag == TRUE && Effect->DelReqFlag == FALSE )
	{
		// IuWFNg쐬JE^[Z
		Bl->CreateCounter += Bl->CreateNumRate ;
		
		// IuWFg쐬JE^[Pȏ̊ԍ쐬JԂ
		while( Bl->CreateCounter >= 1.0F )
		{
			Vec Pos ;
			
			// PosJObj  NULL ȊO͓̎o^Ă WK7JObj 甭ˍW擾
			if( Bl->PosJObj != NULL )
			{
				HSD_JObjGetTranslate( Bl->PosJObj->GetJObj(), &Pos ) ;
				
				// IuWFNg̍쐬
				AddBillboardEffectObject( Effect, Pos ) ;
			}
			else
			{
				// IuWFNg̍쐬
				AddBillboardEffectObject( Effect, Bl->Point ) ;
			}
			
			// JE^[̒l炷
			Bl->CreateCounter -= 1.0F ;
		}
	}

	// I
	return 0 ;
}


// r{[h̃GtFNg`悷
extern s8 DrawBillboardEffect( EFFECT *Effect )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;
	BILLBOARDIMAGE *Image = &BlUnion.Image[Bl->BillImageID] ;
	BILLBOARDEFFECTOBJECT *Obj ;
	Mtx TMtx ;
	GhmGcTexHeader *Tex ;

	// f[^牽I
	if( Image->UseFlag == FALSE ) return 0 ;
	
	if( BlUnion.NotDrawFlag == TRUE ) return 0 ;

	// C[Wf[^ǂݏIĂȂ牽I
	if( CHKFILELOAD( Image->File ) == FALSE && Image->File != NULL ) return 0 ;

	// `tO|Ă牽ɏI
	if( Bl->DrawFlag == FALSE ) return 0 ;
	
	// eNX`wb_̃|C^Zbg
	Tex = Image->Tex ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, Bl->AddBlendFlag != TRUE ? EF_BLEND_ALPHA : EF_BLEND_ADD, EF_TEV_USETEX ) ;

	// ]us擾
	EffectGetInvViewMatrix( TMtx ) ;

	// eNX`̃[h
	GTLOAD( &Image->TexObj ) ;

	// ׂẴIuWFNg`悷
	{
		u8 Alpha, r, g, b, a ;
		f32 u, v, w, h ;

		r = Bl->Color.r ;
		g = Bl->Color.g ;
		b = Bl->Color.b ;
		a = Bl->Color.a ;

		switch( BillBoardTexType[Bl->BillImageID] ) 
		{
		case 0 :		// ʂ̃r{[h
		case 3 :		// At@݂̂̃eNX`
			if( Bl->ObjNum != 0 )
			{
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( 4 * Bl->ObjNum ) ) ;
				{
					Vec P[4], P2[4] ;
					u32 i, Num ;

					Obj = Bl->ObjP ;
					Num = Bl->ObjNum ;
					for( i = 0 ; i < Num ; Obj ++ )
					{
						if( Obj->UseFlag == TRUE )
						{
							i ++ ;
							
							// W̃Zbg
							P[0].x = -Obj->Size / 2.0F ;		P[0].y = Obj->Size / 2.0F ;			P[0].z = 0.0F ;
							P[1].x = Obj->Size / 2.0F ;			P[1].y = Obj->Size / 2.0F ;			P[1].z = 0.0F ;
							P[2].x = Obj->Size / 2.0F ;			P[2].y = -Obj->Size / 2.0F ;		P[2].z = 0.0F ;
							P[3].x = -Obj->Size / 2.0F ;		P[3].y = -Obj->Size / 2.0F ;		P[3].z = 0.0F ;

							// ϊ
							PSMTXMultVec( TMtx, &P[0], &P2[0] ) ;		PSMTXMultVec( TMtx, &P[1], &P2[1] ) ;
							PSMTXMultVec( TMtx, &P[2], &P2[2] ) ;		PSMTXMultVec( TMtx, &P[3], &P2[3] ) ;
							
							// uv l̃Zbg
							u = (f32)Obj->u / BillBoardTexDivNum[Bl->BillImageID][0] ;
							v = (f32)Obj->v / BillBoardTexDivNum[Bl->BillImageID][1] ;
							w = 1.0F / BillBoardTexDivNum[Bl->BillImageID][0] ;
							h = 1.0F / BillBoardTexDivNum[Bl->BillImageID][1] ;
							
							// At@l̃Zbg
							Alpha = (u8)( Obj->a * a ) ;

							// W̏o
							GPV3( P2[0], Obj->Point ) ;		GC2( Bl->Color, Alpha ) ;		GT( u, v ) ; 
							GPV3( P2[1], Obj->Point ) ;		GC2( Bl->Color, Alpha ) ;		GT( u + w, v ) ; 
							GPV3( P2[2], Obj->Point ) ;		GC2( Bl->Color, Alpha ) ;		GT( u + w, v + h ) ; 
							GPV3( P2[3], Obj->Point ) ;		GC2( Bl->Color, Alpha ) ;		GT( u, v + h ) ; 
						}
					}
				}
				GXEnd() ;
			}
			break ;
			
		case 1 :		// C
			if( Bl->ObjNum != 0 )
			{
				EffectTevSetup( EF_TEV_NOTEX ) ;
				
	#ifdef DEBUG_MODE
				GXSetLineWidth( (u8)VParam[ED_BLDRAIN][0], GX_TO_ZERO ) ;
	#else
				GXSetLineWidth( (u8)BillBoardTexLineWidth[Bl->BlllImageID][0], GX_TO_ZERO ) ;
	#endif
				GXBegin( GX_LINES, GX_VTXFMT0, (u16)( ( ( BILL_BACKPOINTNUM - 1 ) * 2 ) * Bl->ObjNum ) ) ;
				{
					u32 i, j, Num ;
					
					Obj = Bl->ObjP ;
					Num = Bl->ObjNum ;
					for( i = 0 ; i < Num ; Obj ++ )
					{
						if( Obj->UseFlag == TRUE )
						{
							i ++ ;
							
							// At@l̃Zbg
							Alpha = (u8)( Obj->a * a ) ;
							
							for( j = 0 ; j < BILL_BACKPOINTNUM - 1 ; j ++ )
							{
								GPV( Obj->BackPoint[j] ) ;		GC2( Bl->Color, Alpha ) ;
								GPV( Obj->BackPoint[j+1] ) ;	GC2( Bl->Color, Alpha ) ;
							}
						}
					}
				}
				GXEnd() ;
			}
			break ;

		case 2 :		// RcC
			if( Bl->ObjNum != 0 )
			{
				EffectTevSetup( EF_TEV_USETEX ) ;

				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( ( /*4 * 2*/ + ( BILL_BACKPOINTNUM - 1 ) * 8 ) * Bl->ObjNum ) ) ;
				{
					u32 i, j, Num ;
					Vec /*Dir,*/ XAxis, YAxis, Axis, p ;
					f32 OneVh ;
					
					Axis.x = 0.0F ;		Axis.y = 1.0F ;		Axis.z = 0.0F ;

					Obj = Bl->ObjP ;
					Num = Bl->ObjNum ;
					for( i = 0 ; i < Num ; Obj ++ )
					{
						if( Obj->UseFlag == TRUE )
						{
							i ++ ;
							
							// At@l̃Zbg
							Alpha = (u8)( Obj->a * a ) ;

							// uv l̃Zbg
							u = (f32)Obj->u / BillBoardTexDivNum[Bl->BillImageID][0] ;
							v = (f32)Obj->v / BillBoardTexDivNum[Bl->BillImageID][1] ;
							w = 1.0F / BillBoardTexDivNum[Bl->BillImageID][0] ;
							h = 1.0F / BillBoardTexDivNum[Bl->BillImageID][1] ;
							OneVh = h / ( BILL_BACKPOINTNUM - 1 ) ;

							// ŏ̔y`悷
/*							{
								VECSubtract( &Obj->BackPoint[0], &Obj->BackPoint[1], &Dir ) ;
								if( Dir.x == 0.0F && Dir.y == 0.0F && Dir.z == 0.0F ) Dir.x = 1.0F ;
								VECNormalize( &Dir, &Dir ) ;
								GetCoordAxis( &Dir, &XAxis, &YAxis ) ;

								GetCoordAxisPoint( &Obj->BackPoint[0], &XAxis, &YAxis, -Obj->Size * 0.5F, Obj->Size * 0.5F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u, v ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[0], &XAxis, &YAxis, Obj->Size * 0.5F, Obj->Size * 0.5F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u + w, v ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[0], &XAxis, &YAxis, Obj->Size * 0.5F, -Obj->Size * 0.5F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u + w, v + h ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[0], &XAxis, &YAxis, -Obj->Size * 0.5F, -Obj->Size * 0.5F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u, v + h) ; 
							}
*/							
							for( j = 0 ; j < BILL_BACKPOINTNUM - 1 ; j ++ )
							{
								VECSubtract( &Obj->BackPoint[j+1], &Obj->BackPoint[j], &YAxis ) ;
								if( YAxis.x == 0.0F && YAxis.y == 0.0F && YAxis.z == 0.0F ) YAxis.x = 1.0F ;
								VECNormalize( &YAxis, &YAxis ) ;
								VECCrossProduct( &Axis, &YAxis, &XAxis ) ;

//								GP3( Obj->BackPoint[j].x, Obj->BackPoint[j].y, Obj->BackPoint[j].z ) ;			GC2( Bl->Color, Alpha ) ;
//								GP3( Obj->BackPoint[j+1].x, Obj->BackPoint[j+1].y, Obj->BackPoint[j+1].z ) ;		GC2( Bl->Color, Alpha ) ;

								GetCoordAxisPoint( &Obj->BackPoint[j], &XAxis, &YAxis, -Obj->Size * 0.5F, 0.0F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u, v + OneVh * j ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[j], &XAxis, &YAxis, Obj->Size * 0.5F, 0.0F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u + w, v + OneVh * j ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[j+1], &XAxis, &YAxis, Obj->Size * 0.5F, 0.0F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u + w, v + OneVh * ( j + 1 ) ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[j+1], &XAxis, &YAxis, -Obj->Size * 0.5F, 0.0F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u, v + OneVh * ( j + 1 ) ) ; 
								
								VECCrossProduct( &YAxis, &XAxis, &XAxis ) ;

								GetCoordAxisPoint( &Obj->BackPoint[j], &XAxis, &YAxis, -Obj->Size * 0.5F, 0.0F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u, v + OneVh * j ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[j], &XAxis, &YAxis, Obj->Size * 0.5F, 0.0F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u + w, v + OneVh * j ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[j+1], &XAxis, &YAxis, Obj->Size * 0.5F, 0.0F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u + w, v + OneVh * ( j + 1 ) ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[j+1], &XAxis, &YAxis, -Obj->Size * 0.5F, 0.0F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u, v + OneVh * ( j + 1 ) ) ; 
							}
							
							// Ō̂y`悷
/*							{
								VECSubtract( &Obj->BackPoint[BILL_BACKPOINTNUM - 1], &Obj->BackPoint[BILL_BACKPOINTNUM - 2], &Dir ) ;
								if( Dir.x == 0.0F && Dir.y == 0.0F && Dir.z == 0.0F ) Dir.x = 1.0F ;
								VECNormalize( &Dir, &Dir ) ;
								GetCoordAxis( &Dir, &XAxis, &YAxis ) ;

								GetCoordAxisPoint( &Obj->BackPoint[j], &XAxis, &YAxis, -Obj->Size * 0.5F, Obj->Size * 0.5F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u, v ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[j], &XAxis, &YAxis, Obj->Size * 0.5F, Obj->Size * 0.5F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u + w, v ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[j], &XAxis, &YAxis, Obj->Size * 0.5F, -Obj->Size * 0.5F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u + w, v + h ) ; 
								
								GetCoordAxisPoint( &Obj->BackPoint[j], &XAxis, &YAxis, -Obj->Size * 0.5F, -Obj->Size * 0.5F, &p ) ;
								GP3( p.x, p.y, p.z ) ;	GC2( Bl->Color, Alpha ) ;	GT( u, v + h) ; 
							}
*/						}
					}
				}
				GXEnd() ;
			}
			break ;
		}
	}

	// I
	return 0 ;
}					

// Ăr{[hGtFNgɑ΂ăIuWFNgǉ
extern s8 AddBillboardEffectObject( EFFECT *Effect, Vec Point, Vec *Dir )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;
	BILLBOARDEFFECTOBJECT *Obj ;

	// ɃIuWFNg̐ςt͉̎I
	if( Bl->ObjNum >= Bl->MaxObjectNum ) return 0 ;
	
	// gĂȂf[^T
	for( Obj = Bl->ObjP ; Obj->UseFlag == TRUE ; Obj ++ ){}
	
	// IuWFNg̐𑝂₷
	Bl->ObjNum ++ ;
	
	// gptO𗧂Ă
	Obj->UseFlag = TRUE ;
	
	// f[^Zbg
	Obj->Point = Point ;
	if( BillBoardTexType[Bl->BillImageID] >= 1 && BillBoardTexType[Bl->BillImageID] != 3 )
	{
		s32 i ;
		for( i = 0 ; i < BILL_BACKPOINTNUM ; i ++ )
			Obj->BackPoint[i] = Point ;
	}

	// x̃Zbg
	{
		f32 oir, xzrot, randrot, randpower ;

		if( Dir != NULL )
		{
			GetDirConv( Dir, &xzrot, &oir ) ;
		}
		else
		{
			switch( Bl->NonDirectionFlag )
			{
			case 0 :
				randrot = rand() * PI_2 / RAND_MAX - PI ;
				randpower = Bl->OutSideFlag == TRUE ? Bl->DirectionRange : rand() * Bl->DirectionRange / RAND_MAX ;
	//			xzrot = cosf( randrot ) * randpower + Bl->XZRot ;
	//			oir = sinf( randrot ) * randpower + Bl->OirRot ;


	//			xzrot = randrot + Bl->XZRot ;
	//			oir = ( randpower - Bl->DirectionRange / 2 ) + Bl->OirRot ;
				xzrot = cosf( randrot ) * randpower + Bl->XZRot ;
				oir = sinf( randrot ) * randpower/*( randpower - Bl->DirectionRange / 2 )*/ + Bl->OirRot ;
				break ;
				
			case 1 :
				oir = rand() * PI / RAND_MAX - PI * 0.5F ;
				xzrot = rand() * PI_2 / RAND_MAX ;
				break ;
				
			case 2 :
				randrot = rand() * PI_2 / RAND_MAX - PI ;
				randpower = Bl->OutSideFlag == TRUE ? Bl->DirectionRange : rand() * Bl->DirectionRange / RAND_MAX ;
	//			xzrot = cosf( randrot ) * randpower + Bl->XZRot ;
	//			oir = sinf( randrot ) * randpower + Bl->OirRot ;

				xzrot = randrot + Bl->XZRot ;
				oir = ( randpower - Bl->DirectionRange / 2 ) + Bl->OirRot ;
				break ;
			}
		}
	
#if 0	
		if( Bl->NonDirectionFlag == FALSE )
		{
			randrot = rand() * PI_2 / RAND_MAX - PI ;
			randpower = Bl->OutSideFlag == TRUE ? Bl->DirectionRange : rand() * Bl->DirectionRange / RAND_MAX ;
//			xzrot = cosf( randrot ) * randpower + Bl->XZRot ;
//			oir = sinf( randrot ) * randpower + Bl->OirRot ;


//			xzrot = randrot + Bl->XZRot ;
//			oir = ( randpower - Bl->DirectionRange / 2 ) + Bl->OirRot ;
			xzrot = cosf( randrot ) * randpower + Bl->XZRot ;
			oir = sinf( randrot ) * randpower/*( randpower - Bl->DirectionRange / 2 )*/ + Bl->OirRot ;
		}
		else
		{
			oir = rand() * PI / RAND_MAX - PI * 0.5F ;
			xzrot = rand() * PI_2 / RAND_MAX ;
		}
#endif

		Obj->Speed.x = ( rand() * ( Bl->MaxSpeed - Bl->MinSpeed ) / RAND_MAX + Bl->MinSpeed ) * Bl->SpeedRate;
		Obj->Speed.y = sinf( oir ) * Obj->Speed.x ;
		Obj->Speed.x = cosf( oir ) * Obj->Speed.x ;
		
		Obj->Speed.z = sinf( xzrot ) * Obj->Speed.x ;
		Obj->Speed.x = cosf( xzrot ) * Obj->Speed.x ;
	}

	// x̃Zbg
	Obj->SSpeed = Bl->SSpeed ;
	
	// CR̃Zbg
	Obj->Air = Bl->Air ;
	
	// TCỸZbg
	Obj->Size = ( rand() * ( Bl->MaxSize - Bl->MinSize ) / RAND_MAX + Bl->MinSize ) * Bl->SizeRate ;
	
	// UVl̃Zbg
	Obj->u = (u8)( rand() * BillBoardTexDivNum[Bl->BillImageID][0] / RAND_MAX ) ;
	if( Obj->u == BillBoardTexDivNum[Bl->BillImageID][0] ) Obj->u = (u8)( BillBoardTexDivNum[Bl->BillImageID][0] - 1 ) ;
	Obj->v = (u8)( rand() * BillBoardTexDivNum[Bl->BillImageID][1] / RAND_MAX ) ;
	if( Obj->v == BillBoardTexDivNum[Bl->BillImageID][1] ) Obj->u = (u8)( BillBoardTexDivNum[Bl->BillImageID][1] - 1 ) ;
	
	// At@l̃Zbg
	Obj->Alpha = 1.0F ;
	Obj->a = 0.0F ;

	// tF[hXs[h̃Zbg
	Obj->FadeOutSpeed = rand() * ( Bl->MaxFadeOutSpeed - Bl->MinFadeOutSpeed ) / RAND_MAX + Bl->MinFadeOutSpeed ;
	Obj->FadeInSpeed = rand() * ( Bl->MaxFadeInSpeed - Bl->MinFadeInSpeed ) / RAND_MAX + Bl->MinFadeInSpeed ;

	// \^C̃Zbg
	Obj->TimeCon = 0 ;
	Obj->DrawTime = (u16)( rand() * ( Bl->MaxDrawTime - Bl->MinDrawTime ) / RAND_MAX + Bl->MinDrawTime ) ;
	
	// I
	return 0 ;
}

// Ăr{[hGtFNgׂč폜
extern s8 ClearBillboardEffectObject( EFFECT *Effect )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// IuWFNgf[^NA
	Bl->ObjNum = 0 ;
	memset( Bl->ObjP, 0, sizeof( BILLBOARDEFFECTOBJECT ) * Bl->MaxObjectNum ) ;

	// I
	return 0 ;
}

	


// Ăr{[hGtFNg̐擾
extern s32 GetBillboardEffectObjectNum( EFFECT *Effect )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;
	
	// Ԃ
	return (s32)Bl->ObjNum ;
}


// IuWFNgɎgpR[obN֐o^
extern s8 SetBillboardEffectMoveCallBackFunction( EFFECT *Effect,
	s8 (*Function)( BILLBOARDEFFECTOBJECT *, BILLBOARDEFFECT *, void * ),
	void *Data )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// o^
	Bl->BillObjMoveCallBack = Function ;
	Bl->Data = Data ;

	// I
	return 0 ;
}




// 폜NGXgs
extern s8 FastDelReqBillboardEffect( EFFECT *Effect )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// tO𗧂Ă	
	Bl->FastDeleteFlag = TRUE ;
	
	// I
	return 0 ;
}

// IuWFNg쐬ʒu WK7JObj ւ̃|C^Zbg
extern s8 SetBillboardPosJObj( EFFECT *Effect, WK7JObj *PosJObj )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;
	
	Bl->PosJObj = PosJObj ;
	
	// I
	return 0 ;
}
	
// r{[h`悷WύX
extern s8 SetBillboardPoint( EFFECT *Effect, Vec Point )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// W̕ύX
	Bl->Point = Point ;

	// I
	return 0 ;
}
	
// `tOZbg( TRUE:`  FALSE:` )
extern s8 SetBillboardDrawFlag( EFFECT *Effect, s8 DrawFlag )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// tO̕ۑ
	Bl->DrawFlag = (s8)DrawFlag ;
	
	// I
	return 0 ;
}

// IuWFNg쐬tOZbg( TRUE:쐬  FALSE:쐬Ȃ )
extern s8 SetBillboardCreateFlag( EFFECT *Effect, s8 CreateFlag )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// tO̕ۑ
	Bl->CreateFlag  = (s8)CreateFlag ;
	
	// I
	return 0 ;
}

// Xs[hɏZlZbg
extern s8 SetBillboardSpeedRate( EFFECT *Effect, f32 SpeedRate )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// {̕ۑ
	Bl->SpeedRate = SpeedRate ;
	
	// I
	return 0 ;
}

// IuWFNg̍쐬pxύX
extern s8 SetBillboardCreateRate( EFFECT *Effect, f32 CreateRate )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// {̕ۑ
	Bl->CreateRate = CreateRate ;

	// I
	return 0 ;
}

// IuWFNg𐶐ύX
extern s8 SetBillboardDirection( EFFECT *Effect, Vec Direction )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	// 
	GetDirConv( &Direction, &Bl->XZRot, &Bl->OirRot ) ;

	// I
	return 0 ;
}

// r{[hGtFNg`悷邩ǂ̃tOZbg
extern s8 SetBillboardAllDrawFlag( s8 Flag )
{
	BlUnion.NotDrawFlag = !Flag ;
	
	// I
	return 0 ;
}

// IuWFNg̃TCYɃoCAX
extern s8 SetBillboardSizeRate( EFFECT *Effect, f32 SizeRate )
{
	BILLBOARDEFFECT *Bl = ( BILLBOARDEFFECT * )Effect->Data ;

	Bl->SizeRate = SizeRate ;
	
	// I
	return 0 ;
}	

