///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBlood
//
// YK7EffectBlood.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/19/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectMesh.h"
#include "./YK7EffectBlood.h"
#include "./YK7EffectConveBlood.h"
#include "../matsu/mk7Sound.h"
#include "./YK7EffectBloodPack.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

/*
#undef K7AppSmallMemAllocName
#define K7AppSmallMemAllocName ghmGcMemAllocName

#undef K7AppSmallMemFree
#define K7AppSmallMemFree ghmGcMemFree
*/

#ifdef FRAME_30
	#define MULSSY				0.02F
#else
	#define MULSSY				0.01F
#endif

#define BLOODNUM				1.0F

#ifdef FRAME_30
	#define BLOODFASTTIME			5
	#define BLOODFASTSCALE			31.0F
	#define BLOODSLOWSCALE			0.2F
	#define BLOODKAZEPOWER			0.2F
#else
	#define BLOODFASTTIME			10
	#define BLOODFASTSCALE			8.0F
	#define BLOODSLOWSCALE			0.1F
	#define BLOODKAZEPOWER			0.1F
#endif
#define BLOODKAZEKAKUDO				45.0F
#ifdef FRAME_30
	#define BLOODG					0.002F
	#define BLOODG2					0.04F
#else
	#define BLOODG					0.001F
	#define BLOODG2					0.01F
#endif
#define BLOODSIZE				( (131.711284141216F) / 300.0F )
#define BLOODSIZE2				0.2F
#define BLOODSCALE				1115.7475601F

#define BLOODTEX "/yam/Effect/Blood/BloodTex"	// GtFNgp̃eNX`t@CpX
#define BLOODTEX_SMOKE "/yam/BloodSplat_P2.BIN"		// GtFNgp̃eNX`t@C

#define BLD_DIRMUSI				10			// ̎w𖳎ĔԊm(1/BLD_DIRMUSI)
#define BLD_GMUSI				10			// d͂𖳎ĔԊm(1/BLD_GMUSI)
#define BLD_TEXPATNUM			4			// eNX`̃p^[

// ̍W
static Vec BaseVert[4] = 
{
	-0.5F, 0.0F, 0.5F,
	-0.5F, 0.0F, -0.5F,
	0.5F, 0.0F, -0.5F,
	0.5F, 0.0F, 0.5F
} ;

#define BLOODDEF_NUM		5
#define MAXBLOODINFO		10000

// datatype -------------------------------------

// data -----------------------------------------

BLOODUNION BUnion ;

BLOODDEF BloodTable[BLOODDEF_NUM] =
{
//		Length						Power		BloodNum		BloodSize
	{	4097.912F/*20.0F*/,			1.0F,		1.0F,			1.0F	},
	{	2016.782F/*40.0F*/,			1.0F,		0.4F,			1.6666F	},
	{	979.753F/*82.0F*/,			2.25F,		0.3F,			2.5F	},
	{	516.610F/*155.390366F*/,	2.75F,		0.3F,			3.3333F	},
	{	346.900F/*231.325882F*/,	3.5F,		0.3F,			4.8333F	},
} ;

// Zuhe[u
const bool BloodAddBlendTable[BLOODTEX_NUM] =
{
	false, false, false, false, false,
	false, false, false, false, false,
	true,
} ;

// function proto type --------------------------

	
u32 GetMeshPrimitiveNum( MESH *Mesh ) ;				// bV\Ă|S̐擾
s8 BloodCallBack( Vec **Point, void *Data ) ;		// |S擾ăGtFNgf[^\zR[obN֐
s8 BloodNumCallBack( Vec **Point, void *Data ) ;	// |S擾ăGtFNgf[^̐𐔂R[obN֐

// function code --------------------------------

// ␳lZo 
extern s8 GetBloodDefParam( Vec *Point, BLOODDEF *DefBuf )
{
//	Vec CPoint ;
	f32 size ;
	f32 /*Length,*/ f ;
	BLOODDEF TBDef ;
	s32 i ;
	
	// JƂ̋𓾂
//	HSD_CObjGetEyePosition( GetEffectCamera(), &CPoint ) ;
//	Length = sqrt( VECSquareDistance( Point, &CPoint ) ) ;

	size = GetScreenSize( Point, 100.0F ) ;

	// ǂ̃e[uɓ邩o
	for( i = 0 ; i < BLOODDEF_NUM && size < BloodTable[i].Length ; i ++ ){}

	{
		f32 size, Length ;
		Vec CPoint ;

		HSD_CObjGetEyePosition( GetEffectCamera(), &CPoint ) ;
		Length = sqrt( VECSquareDistance( Point, &CPoint ) ) ;

		size = GetScreenSize( Point, 100.0F ) ;
#ifdef YAMADADEBUG
//		OSReport( "length:%.3f  size:%.3f  ind:%d\n", Length, size, i ) ;
#endif
	}

	if( i == BLOODDEF_NUM )
	{
		TBDef = BloodTable[i-1] ;
	}
	else
	if( i == 0 )
	{
		TBDef = BloodTable[0] ;
	}
	else
	{
		BLOODDEF *BDef1, *BDef2 ;
		
		BDef2 = &BloodTable[i] ;
		BDef1 = &BloodTable[i-1] ;
		
		f = ( size - BDef2->Length ) / ( BDef1->Length - BDef2->Length + 0.01F ) ;
		TBDef.BloodSize =	( 1.0F - f ) * BDef2->BloodSize	+ f * BDef1->BloodSize ;
		TBDef.BloodNum =	( 1.0F - f ) * BDef2->BloodNum 	+ f * BDef1->BloodNum ;
		TBDef.Power = 		( 1.0F - f ) * BDef2->Power 	+ f * BDef1->Power ;
	}
	
	// 
	*DefBuf = TBDef ;
	
	// I
	return 0 ;
}
	

// bV\Ă|S̐擾
u32 GetMeshPrimitiveNum( MESH *Mesh )
{
	u32 Num ;

	Num = (u32)Mesh->IndexDataNum / 3 ;
	if( Mesh->Next )
		Num += GetMeshPrimitiveNum( Mesh->Next ) ;
	
	// Ԃ
	return Num ;
}

// |S擾ăGtFNgf[^\zR[obN֐
s8 BloodCallBack( Vec **Point, void *Data )
{
	BLOODEFFECTINIT *Init = ( BLOODEFFECTINIT * )Data ;
	BLOODEFFECT *Blood = Init->BloodEffect ;
	BLOODOBJECT *Ob = &Blood->ObjP[Blood->Counter] ;
	f32 x, y, sx, sy, sz, rn, s ;
	Vec CPoint, dx, dy ;
	u32 i, Num ;
	f32 oir, xz/*, n*/ ;

	// ʐς߂
	PSVECSubtract( Point[1], Point[0], &dx ) ;
	PSVECSubtract( Point[2], Point[0], &dy ) ;
	s = sqrtf( 
		( dx.y * dy.z - dx.z * dy.y ) * ( dx.y * dy.z - dx.z * dy.y ) +
		( dx.z * dy.x - dx.x * dy.z ) * ( dx.z * dy.x - dx.x * dy.z ) +
		( dx.x * dy.y - dx.y * dy.x ) * ( dx.x * dy.y - dx.y * dy.x ) ) / 2.0F ;

	// ʐς琔߂
	Init->SmokeRate += s * Init->BloodNum * BLOODNUM ;
//	Num = (u32)( s * Init->BloodNum * BLOODNUM * 256 ) ;
//	if( Num == 0 ) Num = 1 ;
	Num = (u32)Init->SmokeRate ;
	Init->SmokeRate -= Num ;
	Init->Counter += Num ;
	
//	Num = Init->Counter / 256 ;
//	Init->Counter %= 256 ;

	// _̐JԂ
	CPoint = *Point[0] ;
	for( i = 0 ; i < Num ; i ++, Ob ++, Blood->Counter ++ )
	{
		// WZbg
		x = (f32)rand() / RAND_MAX ;
		y = ( 1.0F - x ) * ( (f32)rand() / RAND_MAX ) ;

		Ob->x = CPoint.x + dx.x * x + dy.x * y ;
		Ob->y = CPoint.y + dx.y * x + dy.y * y ;
		Ob->z = CPoint.z + dx.z * x + dy.z * y ;

		// xZbg
		Ob->ssx = Ob->ssy = Ob->ssz = 0.0F ;
		sx = (f32)rand() / RAND_MAX - 0.5F ;
		sy = (f32)rand() / RAND_MAX - 0.5F ; 
		sz = (f32)rand() / RAND_MAX - 0.5F ;

		// 菈
		{
			// ẘmŕ
			if( Init->DirIgnore > (f32)rand() / RAND_MAX )
			{
				oir = rand() * PI / RAND_MAX - PI / 2.0F ;
				xz = rand() * PI_2 / RAND_MAX ;
			}
			else
			{
				f32 rnd1, rnd2 ;
				
				rnd1 = rand() * PI_2 / RAND_MAX ;
				rnd2 = rand() * ( Init->Range / 2 ) / RAND_MAX ;
				xz = COSF( rnd1 ) * rnd2 + Init->dxz ;
				oir = SINF( rnd1 ) * rnd2 + Init->doir ;
			}
			Ob->sx = COSF( oir ) ;
			Ob->sy = SINF( oir ) ;
			Ob->sz = Ob->sx * SINF( xz ) ;
			Ob->sx = Ob->sx * COSF( xz ) ;
		}
		
		// Xs[h菈
		{
			rn = rand() * ( Init->MaxPower - Init->MinPower ) / RAND_MAX + Init->MinPower ;
			Ob->sx *= rn ;
			Ob->sy *= rn ;
			Ob->sz *= rn ;
			if( Init->Mode == 3 )
			{
				Ob->sy = 0 ;
				Ob->ssy = rn * MULSSY ;
				Ob->sz = rand() * PI_2 / RAND_MAX ;
				Ob->ssz = Ob->z ;
				Ob->ssx = Ob->x ;
			}
		}

		// ̑̃f[^

		// tF[hAEg܂ł̎ԂZbg
		Ob->FadeOutTime = (u16)( Init->FadeOutTime + ( rand() * Init->FadeRandTime / RAND_MAX - ( Init->FadeRandTime >> 1 ) ) ) ;
		Ob->FadeFlag = FALSE ;

		Ob->FadeCount = /*Ob->Count =*/ 0 ;
		Ob->Cycle = (u16)( rand() * Init->WindTime / RAND_MAX + ( Init->WindTime >> 1 ) ) ;
//		Ob->Type = (s8)( Init->SmokeRate < (f32)rand() / RAND_MAX ? 3 : ( ( Init->NoGBlood < (f32)rand() / RAND_MAX ) ? 1 : 0 ) ) ;
/*		if( Init->SmokeRate > (f32)rand() / RAND_MAX )
		{
			Ob->Type = (u8)3 ;
			Init->SmokeNum ++ ;
//			Ob->FadeOutTime = (u16)( Ob->FadeOutTime * VParam[ED_HSD1][20] * 0.01F ) ;
			Ob->FadeOutTime = (u16)( Ob->FadeOutTime * 2 * 0.01F ) ;
		}
		else
*/		{
			Ob->Type = (s8)( ( Init->NoGBlood < (f32)rand() / RAND_MAX ) ? 1 : 0 ) ;
		}
//		Ob->Type = (s8)( ( rand() * 10 / RAND_MAX < 2 ) ? 1 : 1 ) ;
		Ob->Pattarn = (u8)( ( rand() * BLOODPAT_NUM / RAND_MAX ) % BLOODPAT_NUM ) ;
		Ob->Pu = (u16)( ( UVSCALE * ( Ob->Pattarn % BLOODPAT_ONELINENUM ) ) / BLOODPAT_ONELINENUM ) ;
		Ob->Pv = (u16)( ( UVSCALE * ( Ob->Pattarn / BLOODPAT_ONELINENUM ) ) / ( BLOODPAT_NUM / BLOODPAT_ONELINENUM ) ) ;
//		Ob->Color = (u8)( 80 + rand() * 175 / RAND_MAX ) ;
		
		Ob->SinWidth = rand() * Init->SinWidth / RAND_MAX ;
		if( (f32)rand() / RAND_MAX < VParam[ED_HSD2][19] * 0.1F ) Ob->SinWidth = 0.0F ;
		Ob->SinSpeed = rand() * Init->SinSpeed / RAND_MAX ;
		Ob->RotType = (u8)( rand() * 4 / RAND_MAX ) ;
		if( Ob->RotType == 4 ) Ob->RotType = 3 ;
		Ob->SRot = (s16)( Ob->sz * PI2DIV / PI_2 ) ;
		Ob->SSpeed = (s16)( Ob->SinSpeed * PI2DIV / PI_2 ) ;
		if( rand() < RAND_MAX / 2 ) Ob->SSpeed *= -1 ;
		Ob->FadeY = rand() * ( Init->FadeY * 0.7F ) / RAND_MAX + Init->FadeY * 0.3F ; 
		{
			s16 Color ;
			
			if( Init->BloodTexNumber == 0 )
			{
				GXColor color ;
				
				color = GetRandINum( 2 ) == 0 ? Init->Color1_1 : Init->Color1_2 ;
				Color = (s16)( color.r + rand() * Init->ColorRand / RAND_MAX  - ( Init->ColorRand >> 1 ) ) ;
				Ob->Color1.r = (u8)( color.r == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
				Color = (s16)( color.g + rand() * Init->ColorRand / RAND_MAX  - ( Init->ColorRand >> 1 ) ) ;
				Ob->Color1.g = (u8)( color.g == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
				Color = (s16)( color.b + rand() * Init->ColorRand / RAND_MAX  - ( Init->ColorRand >> 1 ) ) ;
				Ob->Color1.b = (u8)( color.b == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
			}
			else
			{
				Ob->Color1 = (GXColor){255,255,255,255} ;
			}

			Color = (s16)( Init->Color2.r + rand() * Init->ColorRand / RAND_MAX  - ( Init->ColorRand >> 1 ) ) ;
			Ob->Color2.r = (u8)( Init->Color2.r == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
			Color = (s16)( Init->Color2.g + rand() * Init->ColorRand / RAND_MAX  - ( Init->ColorRand >> 1 ) ) ;
			Ob->Color2.g = (u8)( Init->Color2.g == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
			Color = (s16)( Init->Color2.b + rand() * Init->ColorRand / RAND_MAX  - ( Init->ColorRand >> 1 ) ) ;
			Ob->Color2.b = (u8)( Init->Color2.b == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
		}
	}
	
	return 0 ;
}

// |S擾ăGtFNgf[^̐𐔂R[obN֐
s8 BloodNumCallBack( Vec **Point, void *Data )
{
	BLOODEFFECTINIT *Init = ( BLOODEFFECTINIT * )Data ;
	BLOODEFFECT *Blood = Init->BloodEffect ;
	f32 s ;
	Vec dx, dy ;
	u32 Num ;

	// ʐς߂
	PSVECSubtract( Point[1], Point[0], &dx ) ;
	PSVECSubtract( Point[2], Point[0], &dy ) ;
//	s = sqrt( PSVECDotProduct( &dx, &dy ) ) / 2.0F ;
//	dx.x = Point[1]->x - Point[0]->x ; dx.y = Point[1]->y - Point[0]->y ; dx.z = Point[1]->z - Point[0]->z ;
//	dy.x = Point[2]->x - Point[0]->x ; dy.y = Point[2]->y - Point[0]->y ; dy.z = Point[2]->z - Point[0]->z ;
	s = sqrt(
		( dx.y * dy.z - dx.z * dy.y ) * ( dx.y * dy.z - dx.z * dy.y ) +
		( dx.z * dy.x - dx.x * dy.z ) * ( dx.z * dy.x - dx.x * dy.z ) +
		( dx.x * dy.y - dx.y * dy.x ) * ( dx.x * dy.y - dx.y * dy.x ) ) / 2.0F ;

	// ʐς琔߂
//	Num = (u32)( s * Init->BloodNum * BLOODNUM * 256 ) ;
//	if( Num == 0 ) Num = 1 ;
	Init->SmokeRate += s * Init->BloodNum * BLOODNUM ;
	Num = (u32)Init->SmokeRate ;
	Init->Counter += Num ;
	Init->SmokeRate -= Num ;

	return 0 ;
}


// GtFNg̋ʃf[^
extern s8 InitBloodData( void )
{
	BLOODUNION *BloodUnion = &BUnion ;
	s32 i ;
//	char FilePath[128] ;
	
	MEMINIT(BUnion) ;
	
	// ̃eNX`[ǂݍ
	for( i = 0 ; i < BLOODTEX_NUM ; i ++ )
		TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_BLOOD )->GetResource( STDAT_BLD_BloodTex00 + i ), &BUnion.BloodTex[i] ) ;
//	{
//		sprintf( FilePath, "%s%02d.BIN", BLOODTEX, i ) ;
//		TexLoadSet( FilePath, &BUnion.BloodTex[i] ) ;
//	}
	
	BUnion.color1 = BUnion.color2 = 0 ;
	BUnion.colorvalid = false ;

	// ̃eNX`[ǂݍ
//	TexLoad( BLOODTEX, &BloodUnion->BloodTex, &BUnion.TexFileBlood ) ;

	// ̃eNX`[ǂݍ
//	TexLoad( BLOODTEX_SMOKE, &BloodUnion->BloodSmokeTex, &BUnion.TexFileBloodSmoke ) ;

	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckBloodData( void )
{
//	s32 i ;

//	for( i = 0 ; i < BLOODTEX_NUM ; i ++ )
//		if( TexLoadChk( &BUnion.BloodTex[i] ) == FALSE ) return FALSE ;
	
	return TRUE ;
}
	


// GtFNg̋ʃf[^n
extern s8 EndBloodData( void )
{
	s32 i ;

	// ̃eNX`[
	for( i = 0 ; i < BLOODTEX_NUM ; i ++ )
		TexRelease( &BUnion.BloodTex[i] ) ;

	// t@C
//	CLOSECHK( BUnion.TexFileBlood ) ;
//	CLOSECHK( BUnion.TexFileBloodSmoke ) ;
	
	// eNX`̃J
//	CHKMEMFREE( BUnion.BloodTex.Header ) ;
//	CHKMEMFREE( BUnion.BloodSmokeTex.Header ) ;
	
	// I
	return 0 ;
}

// v~eBuf[^lGtFNg쐬
extern EFFECT *CreateVLossBloodEffect( HSD_JObj *JObj, Vec Direction, f32 MaxPower, f32 MinPower, u32 BloodNum,
									f32 YukaY, u8 PerspectiveFlag,
									f32 NoGBlood, f32 DirIgnore,
									f32 Range, f32 BloodSize, u8 Mode, u8 WaitTime,
									u16 FadeOutTime, u16 FadeRandTime,
									f32 SinWidth, f32 SinSpeed, f32 FadeY,
									u16 FadeSpeedTime,
									GXColor Color1, GXColor Color2,
									u16 ColorMoveTime, u8 ColorRand,
									f32 SmokeRate, s32 SoundID,
									f32 WindPower, u32 WindTime,
									u8 ConveFlag, u8 ConveWaitTime, f32 ConvePower,
									u8 BloodTexNumber, u8 MeshFlag, s32 Priority )
{
//	HSD_PObj *PObj ;
	EFFECT *Effect ;
	BLOODEFFECT *Blood ;
//	MESH *Mesh ;
//	BASICMESH *BasicMesh ;
	BLOODEFFECTINIT Init ;
//	HSD_DObj *dobj ;
	MODEL *model ;
	BASICMODEL *bmodel ;
	
	YukaY += 0.01F ;

//	SmokeSize = SmokeSize ;
	SmokeRate = SmokeRate ;

//	if( BloodTexNumber != 0 && BloodTexNumber != BLOODTEX_NORMALFLOWER ) ConveFlag = TRUE ;
	if( /*BloodTexNumber == 0 &&*/ GetActBloodMeter() != NULL ) ConveFlag = TRUE ;
	if( BloodTexNumber == BLOODTEX_FEATHER ) ConveFlag = TRUE ;

	// ̃eNX`[ǂݍݏIĂ邩𒲂ׂ
	if( CheckBloodData() == FALSE ) return NULL ;
	
	// ̃eNX`ǂݍ܂ĂȂ牽I
//	if( CHKFILELOAD( BUnion.TexFileBlood ) == FALSE ) return 0 ;
//	if( CHKFILELOAD( BUnion.TexFileBloodSmoke ) == FALSE ) return 0 ;
	
	// t@C
//	CLOSECHK( BUnion.TexFileBlood ) ;
//	CLOSECHK( BUnion.TexFileBloodSmoke ) ;
	
	// v~eBu\̂̃AhX擾
//	if( ( dobj = GetHaveMeshDObj( JObj ) ) == NULL ) return NULL ;
////	if( JObj->u.dobj == NULL || JObj->u.dobj->pobj == NULL ) return NULL ;
//	PObj = dobj->pobj ;

	// Vf[^쐬
	Effect = AddEffectData( EFF_BLOOD, (void**)&Blood, Priority ) ;
	if( Effect == NULL )
	{
		BUnion.colorvalid = false ;
		return NULL ;
	}
	memset( Blood, 0, sizeof( BLOODEFFECT ) ) ;

	// tOĂ猌GtFNg쐬
	if( ConveFlag == TRUE )
	{
		Blood->ConveEffect = CreateConveBloodEffect( Effect, ConveWaitTime, ConvePower ) ;
		if( Blood->ConveEffect == NULL )
		{
			Blood->ConveFlag = FALSE ;
		}
		else
		{
			Blood->ConveEffectID = GetEffectID( Blood->ConveEffect ) ;
		}
	}
	
#if 1
	// 𑪂ăp[^
	{
		Vec BPoint/*, CPoint*/ ;
//		f32 Length, f ;
		BLOODDEF TBDef ;
//		s32 i ;
		
		BPoint.x = JObj->mtx[0][3] ;
		BPoint.y = JObj->mtx[1][3] ;
		BPoint.z = JObj->mtx[2][3] ;
		
/*
		HSD_CObjGetEyePosition( GetEffectCamera(), &CPoint ) ;
		Length = sqrt( VECSquareDistance( &BPoint, &CPoint ) ) ;
		
		// ǂ̃e[uɓ邩o
		for( i = 0 ; i < BLOODDEF_NUM && Length > BloodTable[i].Length ; i ++ ){}
		if( i == BLOODDEF_NUM )
		{
			TBDef = BloodTable[i-1] ;
		}
		else
		if( i == 0 )
		{
			TBDef = BloodTable[0] ;
		}
		else
		{
			BLOODDEF *BDef1, *BDef2 ;
			
			BDef2 = &BloodTable[i] ;
			BDef1 = &BloodTable[i-1] ;
			
			f = ( Length - BDef1->Length ) / ( BDef2->Length - BDef1->Length ) ;
			TBDef.BloodSize = f * ( BDef2->BloodSize - BDef1->BloodSize ) + BDef1->BloodSize ;
			TBDef.BloodNum = f * ( BDef2->BloodNum - BDef1->BloodNum ) + BDef1->BloodNum ;
			TBDef.Power = f * ( BDef2->Power - BDef1->Power ) + BDef1->Power ;
		}
*/
		GetBloodDefParam( &BPoint, &TBDef ) ;
		
		// ␳
		MaxPower *= TBDef.Power ;
		MinPower *= TBDef.Power ;
		BloodNum = (u32)( BloodNum * TBDef.BloodNum ) ;
		if( BloodNum == 0 ) BloodNum = 1 ;
		BloodSize *= TBDef.BloodSize ;
	}
#endif

	// f[^
	Blood->MoveBloodNum = BloodNum ;
	Blood->MoveDrawBloodNum = BloodNum ;
	Blood->UnMoveDrawBloodNum = 0 ;
	Blood->RotCounter = 0 ;
	Blood->FadeTime = 0 ;
	Blood->FadeFlag = FALSE ;
	Blood->Counter = 0 ;
	Blood->MinPower = MinPower ;
	Blood->MaxPower = MaxPower ;
	Blood->Yuka = YukaY ;
	Blood->PerspectiveFlag = PerspectiveFlag ;
	Blood->NoGBlood = NoGBlood ;
	Blood->DirIgnore = DirIgnore ;
	Blood->Range = Range ;
	Blood->BloodSize = BloodSize ;
	Blood->Mode = Mode ;
	Blood->WaitTime = WaitTime ;
	Blood->SinWidth = SinWidth ;
	Blood->SinSpeed = SinSpeed ;
	Blood->FadeY = FadeY ;
	Blood->FadeSpeedTime = FadeSpeedTime ;
	if( BUnion.colorvalid == true )
	{
		Blood->Color1_1 = *((GXColor *)&BUnion.color1) ;
		Blood->Color1_2 = *((GXColor *)&BUnion.color2) ;
		BUnion.colorvalid = false ;
	}
	else
	{
		Blood->Color1_1 = Blood->Color1_2 = Color1 ;
	}
	Blood->Color2 = Color2 ;
	Blood->ColorMoveTime = ColorMoveTime ;
	Blood->ObjP = NULL ;
	Blood->SmokeNum = 0 ;
	Blood->SoundFlag = FALSE ;
	Blood->SoundID = SoundID ;
	Blood->WindPower = WindPower ;
	Blood->WindTime = WindTime ;
	Blood->ConveFlag = ConveFlag ;
	Blood->ConveWaitTime = ConveWaitTime ;
	Blood->ConvePower = ConvePower ;
	Blood->BloodTexNumber = BloodTexNumber ;
	
	// ff[^쐬
	if( CreateModelData( JObj, &model, TRUE, FALSE, TRUE, TRUE ) < 0 ){ DeleteEffect( Effect ) ; return 0 ; }
	
	// ȈՃff[^쐬
	if( CreateBasicModelData( model, &bmodel, TRUE, FALSE ) < 0 ){ DeleteModelData( model ) ; DeleteEffect( Effect ) ; return 0 ; }

	// XɃff[^폜
	DeleteModelData( model ) ;

//	OSReport( "Blood  SmallFree:%d   BigFree:%d\n", K7AppSmallMemGetFreeSize(), ghmGcMemGetFreeSize() ) ;

	// bVGtFNg쐬
	Blood->MeshEffect = NULL ;
	if( MeshFlag == TRUE )
	{
		Blood->MeshEffect = CreateMeshEffect( bmodel,
												(Vec){0.0F,0.0F,0.0F},
												TRUE,
												CMKC2( Blood->Color1_1, 255 ),
												true,
												Priority + 1
												 ) ;
		if( Blood->MeshEffect != NULL )
			SetEffectIndeManageFlag( Blood->MeshEffect, TRUE ) ;
	}
	else
	{
		Blood->MeshEffect = NULL ;
	}

	// IuWFNg̐Zo
	Init.Point.x = JObj->mtx[0][3] ; Init.Point.y = JObj->mtx[1][3] ; Init.Point.z = JObj->mtx[2][3] ;
	Blood->Point = Init.Point ;
	Init.BloodNum = BloodNum ;
	Init.Mode = Mode ;
	Init.Counter = 0 ;
	Init.BloodEffect = Blood ;
	Init.Direction = Direction ;
	Init.MaxPower = MaxPower ;
	Init.MinPower = MinPower ;
	Init.NoGBlood = NoGBlood ;
	Init.DirIgnore = DirIgnore ;
	Init.Range = Range ;
	Init.FadeOutTime = FadeOutTime ;
	Init.FadeRandTime = FadeRandTime ;
	Init.SinWidth = SinWidth ;
	Init.SinSpeed = SinSpeed ;
	Init.FadeY = FadeY ;
	Init.Color1_1 = Blood->Color1_1 ;
	Init.Color1_2 = Blood->Color1_2 ;
	Init.Color2 = Blood->Color2 ;
	Init.ColorMoveTime = ColorMoveTime ;
	Init.ColorRand = ColorRand ;
//	Init.SmokeRate = SmokeRate ;
	Init.SmokeRate = 0.0F ;
	Init.SmokeNum = 0 ;
	Init.WindPower = WindPower ;
	Init.WindTime = WindTime ;
	Init.BloodTexNumber = BloodTexNumber ;
	// 
	{
		Init.dxz = atan2( Direction.z, Direction.x ) ;
		Init.doir = atan2( Direction.y, Direction.x * cos( -Init.dxz ) - Direction.z * sin( -Init.dxz ) ) ;
	}

	// ̐𐔂
//	ScanMeshPrimitive( BasicMesh, BloodNumCallBack, &Init ) ;
	ScanBasicModelPrimitive( bmodel, BloodNumCallBack, &Init ) ;

	// IuWFNg̃f[^i[郁̈mۂ
//	Blood->MoveBloodNum = Blood->BloodNum = GetMeshPrimitiveNum( Mesh ) * BloodNum ;
	Blood->MoveBloodNum = Blood->BloodNum = Init.Counter ;
	Blood->MoveDrawBloodNum = Init.Counter ; //Init.Counter / 256 ;
	Blood->UnMoveDrawBloodNum = 0 ;
	Blood->ObjP = ( BLOODOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( BLOODOBJECT ) * Blood->BloodNum ), "Y_VlObj" ) ;
//	Blood->ObjP = ( BLOODOBJECT * )ghmGcMemAllocName( (s32)( sizeof( BLOODOBJECT ) * Blood->BloodNum ), "Y_VlObj" ) ;
	if( Blood->ObjP == NULL )
	{
		BUnion.colorvalid = false ;
//		DeletePrimitiveMeshData( Mesh ) ;
//		DeleteBasicMeshData( BasicMesh ) ;
		if( Blood->MeshEffect == NULL ) DeleteBasicModelData( bmodel ) ;
		DeleteEffect( Effect ) ;
		return NULL ;
	}

	// bṼ|SЂƂÂČIuWFNg쐬
	Blood->Point = Init.Point ;
	Init.Point.x = JObj->mtx[0][3] ; Init.Point.y = JObj->mtx[1][3] ; Init.Point.z = JObj->mtx[2][3] ;
	Init.BloodNum = BloodNum ;
	Init.Mode = Mode ;
	Init.Counter = 0 ;
	Init.BloodEffect = Blood ;
	Init.Direction = Direction ;
	Init.MaxPower = MaxPower ;
	Init.MinPower = MinPower ;
	Init.NoGBlood = NoGBlood ;
	Init.DirIgnore = DirIgnore ;
	Init.Range = Range ;
	Init.FadeOutTime = FadeOutTime ;
	Init.FadeRandTime = FadeRandTime ;
	Init.SinWidth = SinWidth ;
	Init.SinSpeed = SinSpeed ;
	Init.FadeY = FadeY ;	
	Init.Color1_1 = Blood->Color1_1 ;
	Init.Color1_2 = Blood->Color1_2 ;
	Init.Color2 = Blood->Color2 ;
	Init.ColorMoveTime = ColorMoveTime ;
	Init.ColorRand = ColorRand ;
//	Init.SmokeRate = SmokeRate ;
	Init.SmokeRate = 0.0F ;
	Init.SmokeNum = 0 ;
	Init.WindPower = WindPower ;
	Init.WindTime = WindTime ;
	Init.BloodTexNumber = BloodTexNumber ;
	// 
	{
		Init.dxz = atan2( Direction.z, Direction.x ) ;
		Init.doir = atan2( Direction.y, Direction.x * cos( -Init.dxz ) - Direction.z * sin( -Init.dxz ) ) ;
	}

	// IuWFNg̏s	
//	ScanMeshPrimitive( BasicMesh, BloodCallBack, &Init ) ;
	ScanBasicModelPrimitive( bmodel, BloodCallBack, &Init ) ;

	// bVf[^폜
//	DeletePrimitiveMeshData( Mesh ) ;
//	DeleteBasicMeshData( BasicMesh ) ;
	if( Blood->MeshEffect == NULL ) DeleteBasicModelData( bmodel ) ;

	Blood->MoveBloodNum = Init.Counter  ;
	Blood->MoveDrawBloodNum = Init.Counter ;
	
	Blood->SmokeNum = 0 ;
//	Blood->SmokeNum = Init.SmokeNum ;
//	Blood->MoveBloodNum -= Blood->SmokeNum ;
//	Blood->MoveDrawBloodNum -= Blood->SmokeNum ;
	Blood->Counter = 0 ;

	// ڂ̌IuWFNg̍WZbg
	if( Blood->BloodNum != 0 )
	{
		SetEffectPos( Effect, &Blood->ObjP->v ) ;
	}
	
	// I
	return Effect ;
}


// ̃GtFNg쐬
extern EFFECT *CreateBloodEffect( Vec Point, Vec Direction,
									f32 MaxPower, f32 MinPower,
									u32 BloodNum, f32 Size,
									f32 YukaY, u8 PerspectiveFlag,
									f32 NoGBlood, f32 DirIgnore,
									f32 Range, f32 BloodSize, u8 Mode, u8 WaitTime, 
									u16 FadeOutTime, u16 FadeRandTime,
									f32 SinWidth, f32 SinSpeed, f32 FadeY,
									u16 FadeSpeedTime,
									GXColor Color1, GXColor Color2,
									u16 ColorMoveTime, u8 ColorRand,
									f32 SmokeRate, s32 SoundID,
									f32 WindPower, u32 WindTime,
									u8 ConveFlag, u8 ConveWaitTime, f32 ConvePower,
									u8 BloodTexNumber, s32 Priority )
{
	EFFECT *Effect ;
	BLOODEFFECT *Blood ;
	u32 i, Num ;
	BLOODOBJECT *Ob ;
	f32 /*sx, sy, sz,*/ rn ;
	f32 oir, xz, doir, dxz  ;
	
	YukaY += 0.01F ;
	
	SmokeRate = SmokeRate ;

//	if( BloodTexNumber != 0 && BloodTexNumber != BLOODTEX_NORMALFLOWER ) ConveFlag = TRUE ;
	if( /*BloodTexNumber == 0 &&*/ GetActBloodMeter() != NULL ) ConveFlag = TRUE ;

	// ̃eNX`[ǂݍݏIĂ邩𒲂ׂ
	if( CheckBloodData() == FALSE )
	{
		BUnion.colorvalid = false ;
		return NULL ;
	}
	
	// ̃eNX`ǂݍ܂ĂȂ牽I
//	if( CHKFILELOAD( BUnion.TexFileBlood ) == FALSE ) return 0 ;
	
	// t@C
//	CLOSECHK( BUnion.TexFileBlood ) ;
	
	// Vf[^쐬
	Effect = AddEffectData( EFF_BLOOD, (void**)&Blood, Priority ) ;
	if( Effect == NULL )
	{
		BUnion.colorvalid = false ;
		return NULL ;
	}
	memset( Blood, 0, sizeof( BLOODEFFECT ) ) ;
	
	// WZbg
	SetEffectPos( Effect, &Point ) ;

	// tOĂ猌GtFNg쐬
	if( ConveFlag == TRUE )
	{
		Blood->ConveEffect = CreateConveBloodEffect( Effect, ConveWaitTime, ConvePower ) ;
		if( Blood->ConveEffect == NULL )
		{
			Blood->ConveFlag = FALSE ;
		}
		else
		{
			Blood->ConveEffectID = GetEffectID( Blood->ConveEffect ) ;
		}
	}

	// _ŉ炷
	if( GetEffectSoundOffFlag() == FALSE )
		PlayEffectSE3D( (f32)rand() / RAND_MAX > 0.5F ? SFX_BT_GUN_HIT_01 : SFX_BT_GUN_HIT_02, Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;

	// 𑪂ăp[^
	{
		Vec BPoint/*, CPoint*/ ;
//		f32 Length, f ;
		BLOODDEF TBDef ;
//		s32 i ;
		
		BPoint = Point ;
		
/*		HSD_CObjGetEyePosition( GetEffectCamera(), &CPoint ) ;
		Length = sqrt( VECSquareDistance( &BPoint, &CPoint ) ) ;
		
		// ǂ̃e[uɓ邩o
		for( i = 0 ; i < BLOODDEF_NUM && Length > BloodTable[i].Length ; i ++ ){}
		if( i == BLOODDEF_NUM )
		{
			TBDef = BloodTable[i-1] ;
		}
		else
		if( i == 0 )
		{
			TBDef = BloodTable[0] ;
		}
		else
		{
			BLOODDEF *BDef1, *BDef2 ;
			
			BDef2 = &BloodTable[i] ;
			BDef1 = &BloodTable[i-1] ;
			
			f = ( Length - BDef1->Length ) / ( BDef2->Length - BDef1->Length ) ;
			TBDef.BloodSize = f * ( BDef2->BloodSize - BDef1->BloodSize ) + BDef1->BloodSize ;
			TBDef.BloodNum = f * ( BDef2->BloodNum - BDef1->BloodNum ) + BDef1->BloodNum ;
			TBDef.Power = f * ( BDef2->Power - BDef1->Power ) + BDef1->Power ;
		}
*/
		GetBloodDefParam( &BPoint, &TBDef ) ;

		// ␳
		MaxPower *= TBDef.Power ;
		MinPower *= TBDef.Power ;
		BloodNum = (u32)( BloodNum * TBDef.BloodNum ) ;
		if( BloodNum == 0 ) BloodNum = 1 ;
		BloodSize *= TBDef.BloodSize ;
	}
	
	// f[^
	Blood->Point = Point ;
	Blood->BloodNum = BloodNum ;
	Blood->MoveBloodNum = BloodNum ;
	Blood->MoveDrawBloodNum = BloodNum ;
	Blood->UnMoveDrawBloodNum = 0 ;
	Blood->FadeTime = 0 ;
	Blood->FadeFlag = FALSE ;
	Blood->Counter = 0 ;
	Blood->RotCounter = 0 ;
	Blood->MinPower = MinPower ;
	Blood->MaxPower = MaxPower ;
	Blood->Yuka = YukaY ;
	Blood->PerspectiveFlag = PerspectiveFlag ;
	Blood->NoGBlood = NoGBlood ;
	Blood->DirIgnore = DirIgnore ;
	Blood->Range = Range ;
	Blood->BloodSize = BloodSize ;
	Blood->Mode = Mode ;
	Blood->WaitTime = WaitTime ;
	Blood->FadeOutTime = FadeOutTime ;
	Blood->FadeRandTime = FadeRandTime ;
	Blood->SinWidth = SinWidth ;
	Blood->SinSpeed = SinSpeed ;
	Blood->FadeY = FadeY ;
	Blood->FadeSpeedTime = FadeSpeedTime ;
	if( BUnion.colorvalid == true )
	{
		Blood->Color1_1 = *((GXColor *)&BUnion.color1) ;
		Blood->Color1_2 = *((GXColor *)&BUnion.color2) ;
		BUnion.colorvalid = false ;
	}
	else
	{
		Blood->Color1_1 = Blood->Color1_2 = Color1 ;
	}
	Blood->Color2 = Color2 ;
	Blood->ColorMoveTime = ColorMoveTime ;
	Blood->ObjP = NULL ;
	Blood->SmokeNum = 0 ;
	Blood->SoundFlag = FALSE ;
	Blood->SoundID = SoundID ;
	Blood->WindPower = WindPower ;
	Blood->WindTime = WindTime ;
	Blood->MeshEffect = NULL ;
	Blood->ConveFlag = ConveFlag ;
	Blood->ConveWaitTime = ConveWaitTime ;
	Blood->ConvePower = ConvePower ;
	Blood->BloodTexNumber = BloodTexNumber ;

	// 
	{
		dxz = atan2( Direction.z, Direction.x ) ;
		doir = atan2( Direction.y, Direction.x * cos( -dxz ) - Direction.z * sin( -dxz ) ) ;
	}

	// IuWFNg̃f[^i[郁̈mۂ
	Blood->ObjP = ( BLOODOBJECT * )/*ghmGcMemAlloc*/K7AppSmallMemAllocName( (s32)( sizeof( BLOODOBJECT ) * BloodNum ), "Y_BldObj" ) ;
	if( Blood->ObjP == NULL )
	{
		BUnion.colorvalid = false ;
		DeleteEffect( Effect ) ;
		return NULL ;
	}
	
	// IuWFNg̏
	Ob = Blood->ObjP ;
	Num = Blood->BloodNum ;
	for( i = 0 ; i < Num ; i ++, Ob ++ )
	{
		// WZo
		Ob->x = Point.x + rand() * Size / RAND_MAX - Size / 2 ;
		Ob->y = Point.y + rand() * Size / RAND_MAX - Size / 2 ;
		Ob->z = Point.z + rand() * Size / RAND_MAX - Size / 2 ;

		// x͂O
		Ob->ssx = Ob->ssy = Ob->ssz = 0.0F ;

		// 菈
		{
			// ẘmŕ
			if( DirIgnore > (f32)rand() / RAND_MAX )
			{
				oir = rand() * PI / RAND_MAX - PI / 2.0F ;
				xz = rand() * PI_2 / RAND_MAX ;
			}
			else
			{
				f32 rnd1, rnd2 ;
				
				rnd1 = rand() * PI_2 / RAND_MAX ;
				rnd2 = rand() * ( Range / 2 ) / RAND_MAX ;
				xz = cos( rnd1 ) * rnd2 + dxz ;
				oir = sin( rnd1 ) * rnd2 + doir ;
			}
			Ob->sx = cos( oir ) ;
			Ob->sy = sin( oir ) ;
			Ob->sz = Ob->sx * sin( xz ) ;
			Ob->sx = Ob->sx * cos( xz ) ;
		}
		
		// Xs[h菈
		{
			rn = rand() * ( MaxPower - MinPower ) / RAND_MAX + MinPower ;
			Ob->sx *= rn ;
			Ob->sy *= rn ;
			Ob->sz *= rn ;
			if( Mode == 3 )
			{
				Ob->sy = 0 ;
				Ob->ssy = rn * MULSSY ;
				Ob->sz = rand() * PI_2 / RAND_MAX ;
				Ob->ssz = Ob->z ;
				Ob->ssx = Ob->x ;
			}
		}

		// ̑̃f[^

		// tF[hAEg܂ł̎ԂZbg
		Ob->FadeOutTime = (u16)( FadeOutTime + ( rand() * FadeRandTime / RAND_MAX - ( FadeRandTime >> 1 ) ) ) ;
		Ob->FadeFlag = FALSE ;
		
		Ob->FadeCount = /*Ob->Count =*/ 0 ;
		Ob->Cycle = (u16)( rand() * WindTime / RAND_MAX + ( WindTime >> 1 ) ) ;
/*		if( SmokeRate > (f32)rand() / RAND_MAX )
		{
			Ob->Type = (u8)3 ;
			Blood->SmokeNum ++ ;
			Blood->MoveBloodNum -- ;
			Blood->MoveDrawBloodNum -- ;
			Ob->FadeOutTime = (u16)( Ob->FadeOutTime * VParam[ED_HSD1][20] * 0.01F ) ;
		}
		else
*/		{
			Ob->Type = (s8)( ( NoGBlood < (f32)rand() / RAND_MAX ) ? 1 : 0 ) ;
		}
//		Ob->Type = (s8)( ( rand() * 10 / RAND_MAX < 2 ) ? 1 : 1 ) ;
		Ob->Pattarn = (u8)( ( rand() * BLOODPAT_NUM / RAND_MAX ) % BLOODPAT_NUM ) ;
		Ob->Pu = (u16)( ( UVSCALE * ( Ob->Pattarn % BLOODPAT_ONELINENUM ) ) / BLOODPAT_ONELINENUM ) ;
		Ob->Pv = (u16)( ( UVSCALE * ( Ob->Pattarn / BLOODPAT_ONELINENUM ) ) / ( BLOODPAT_NUM / BLOODPAT_ONELINENUM ) ) ;
//		Ob->Color = (u8)( 80 + rand() * 175 / RAND_MAX ) ;

		Ob->SinWidth = rand() * SinWidth / RAND_MAX ;
		if( (f32)rand() / RAND_MAX < VParam[ED_HSD2][19] * 0.1F ) Ob->SinWidth = 0.0F ;
		Ob->SinSpeed = rand() * SinSpeed / RAND_MAX ;
		Ob->RotType = (u8)( rand() * 4 / RAND_MAX ) ;
		if( Ob->RotType == 4 ) Ob->RotType = 3 ;
		Ob->SRot = (s16)( Ob->sz * PI2DIV / PI_2 ) ;
		Ob->SSpeed = (s16)( Ob->SinSpeed * PI2DIV / PI_2 ) ;
		if( rand() < RAND_MAX / 2 ) Ob->SSpeed *= -1 ;
		Ob->FadeY = rand() * ( FadeY * 0.7F ) / RAND_MAX + FadeY * 0.3F ; 
		{
			s16 Color ;

			if( BloodTexNumber == 0 )
			{
				GXColor color ;

				color = GetRandINum( 2 ) == 0 ? Blood->Color1_1 : Blood->Color1_2 ;
				Color = (s16)( color.r + rand() * ColorRand / RAND_MAX  - ( ColorRand >> 1 ) ) ;
				Ob->Color1.r = (u8)( color.r == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
				Color = (s16)( color.g + rand() * ColorRand / RAND_MAX  - ( ColorRand >> 1 ) ) ;
				Ob->Color1.g = (u8)( color.g == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
				Color = (s16)( color.b + rand() * ColorRand / RAND_MAX  - ( ColorRand >> 1 ) ) ;
				Ob->Color1.b = (u8)( color.b == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
			}
			else
			{
				Ob->Color1 = (GXColor){255,255,255,255} ;
			}
			
			Color = (s16)( Color2.r + rand() * ColorRand / RAND_MAX  - ( ColorRand >> 1 ) ) ;
			Ob->Color2.r = (u8)( Color2.r == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
			Color = (s16)( Color2.g + rand() * ColorRand / RAND_MAX  - ( ColorRand >> 1 ) ) ;
			Ob->Color2.g = (u8)( Color2.g == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
			Color = (s16)( Color2.b + rand() * ColorRand / RAND_MAX  - ( ColorRand >> 1 ) ) ;
			Ob->Color2.b = (u8)( Color2.b == 0 ? 0 : ( Color < 0 ? Color = 0 : ( Color > 255 ? 255 : Color ) ) ) ;
		}
	}

	// I
	return Effect ;
}

// ̃GtFNǧns
extern s8 ReleaseBloodEffect( EFFECT *Effect )
{
	BLOODEFFECT *Blood = ( BLOODEFFECT * )Effect->Data ;
	
	// GtFNgIuWFNgp̃J
	/*CHKMEMFREE*/CHKMEMFREE2( Blood->ObjP ) ;
	
	if( Blood->ConveEffect != NULL && CheckEffectValidState( Blood->ConveEffect, Blood->ConveEffectID ) == TRUE )
	{
		DeleteEffect( Blood->ConveEffect ) ;
	}

	if( Blood->MeshEffect != NULL && GetEffectValidState( Blood->MeshEffect ) == TRUE )
	{
		DeleteEffect( Blood->MeshEffect ) ;
		Blood->MeshEffect = NULL ;
	}
	
	// I
	return 0 ;
}

// ̃GtFNgPt[
extern s8 MoveBloodEffect( EFFECT *Effect )
{
	BLOODEFFECT *Blood = ( BLOODEFFECT * )Effect->Data ;
	u32 i, Num ;
	BLOODOBJECT *Ob ;
	f32 k ;

	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Blood->ConveFlag == TRUE )
	{
		if( CheckEffectValidState( Blood->ConveEffect, Blood->ConveEffectID ) == FALSE )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		
		if( GetConveBloodRunFlag( Blood->ConveEffect ) == TRUE ) return 0 ;
	}
	
	if( Blood->MeshEffect != NULL && GetEffectValidState( Blood->MeshEffect ) == TRUE )
	{
		MoveEffect( Blood->MeshEffect ) ;
	}
	
	// ҂Ԓꍇ͐F̌vZďI
	if( Blood->WaitTime != 0 )
	{
		Blood->WaitTime -- ;

		// F̌vZ
		{
			Ob = Blood->ObjP ;
			Num = Blood->BloodNum ;
			// [hɂď𕪊
			if( Blood->Mode == 3 )
			{
				// ̐JԂ
				for( i = 0 ; i < Num ; i ++, Ob ++ )
				{
					// tF[hAEg̎Ԃ߂Ă牽I
					if( Ob->FadeCount > Blood->FadeSpeedTime ) continue ;

					// Fݒ肷
		//			Bright = (u8)( Ob->FadeFlag == TRUE ? 255 - 255 * Ob->FadeCount / Blood->FadeSpeedTime : 255 ) ;
					if( Blood->ConveFlag == FALSE )
					{
						Ob->Color.r = (u8)( ( Ob->Color2.r * Ob->FadeCount + Ob->Color1.r * ( Blood->FadeSpeedTime - Ob->FadeCount ) ) / Blood->FadeSpeedTime ) ;
						Ob->Color.g = (u8)( ( Ob->Color2.g * Ob->FadeCount + Ob->Color1.g * ( Blood->FadeSpeedTime - Ob->FadeCount ) ) / Blood->FadeSpeedTime ) ; 
						Ob->Color.b = (u8)( ( Ob->Color2.b * Ob->FadeCount + Ob->Color1.b * ( Blood->FadeSpeedTime - Ob->FadeCount ) ) / Blood->FadeSpeedTime ) ; 
						Ob->Color.a = 255 ;
					}
					else
					{
						Ob->Color = Ob->Color1 ;
						Ob->Color.a = 255 ;
					}
				}
			}
			else
			{
				// ̐JԂ
				for( i = 0 ; i < Num ; i ++, Ob ++ )
				{
					if( Ob->FadeCount > Blood->FadeSpeedTime ) continue ;

					// Fݒ肷
					if( Ob->Type < 2 )
					{
						if( Blood->ConveFlag == FALSE )
						{
							Ob->Color.a = (u8)( Ob->FadeFlag == TRUE ? 255 - 255 * Ob->FadeCount / Blood->FadeSpeedTime : 255 ) ;
							if( Blood->Counter < Blood->ColorMoveTime )
							{
								Ob->Color.r = (u8)( ( Ob->Color2.r * Blood->Counter + Ob->Color1.r * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ;
								Ob->Color.g = (u8)( ( Ob->Color2.g * Blood->Counter + Ob->Color1.g * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
								Ob->Color.b = (u8)( ( Ob->Color2.b * Blood->Counter + Ob->Color1.b * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
							}
							else
							{
								Ob->Color = Ob->Color2 ; 
							}
						}
						else
						{
							Ob->Color = Ob->Color1 ;
							Ob->Color.a = 255 ;
						}
					}
					else
					if( Ob->Type == 2 )
					{
						if( Blood->ConveFlag == FALSE )
						{
							// F̌vZ
							Ob->Color.a = (u8)( Ob->FadeFlag == TRUE ? 255 - 255 * Ob->FadeCount / Blood->FadeSpeedTime : 255 ) ;
							if( Blood->Counter < Blood->ColorMoveTime )
							{
								Ob->Color.r = (u8)( ( Ob->Color2.r * Blood->Counter + Ob->Color1.r * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ;
								Ob->Color.g = (u8)( ( Ob->Color2.g * Blood->Counter + Ob->Color1.g * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
								Ob->Color.b = (u8)( ( Ob->Color2.b * Blood->Counter + Ob->Color1.b * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
							}
							else
							{
								Ob->Color = Ob->Color2 ; 
							}
						}
						else
						{
							Ob->Color = Ob->Color1 ;
							Ob->Color.a = 255 ;
						}
					}
				}
			}
		}
	
		return 0 ;
	}
	
/*	if( Blood->Counter == VParam[ED_HSD1][20] )
	{
		gpSound->mPlaySE( SFX_BT_WARAI_DEATH ) ;
	}
*/		

	// ܂炵ĂȂꍇ͉炷s
	if( Blood->SoundFlag == FALSE )
	{
		// 炷o^Ăꍇ̂ݖ炷
		if( Blood->SoundID != -1 && GetEffectSoundOffFlag() == FALSE )
			PlayEffectSE3D( Blood->SoundID, Blood->Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
			
		// 炵tO𗧂Ă
		Blood->SoundFlag = TRUE ;
	}

	// ɏĂ폜
	if( Blood->UnMoveDrawBloodNum == 0 && Blood->MoveDrawBloodNum == 0 && Blood->ConveFlag == FALSE )
	{
		// ł錌Ă錌ȂȂ폜
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// bVGtFNggĂgr̗֊s`Ăꍇ
	// w̎Ԃ烁bVGtFNg폜
	if( Blood->MeshEffect != NULL &&
		 GetEffectValidState( Blood->MeshEffect ) == TRUE &&
		 Blood->Counter > VParam[ED_HSD1][21] )
	{
		DeleteEffect( Blood->MeshEffect ) ;
		Blood->MeshEffect = NULL ;
	}

	// 쑬x̌WvZĂ
	switch( Blood->Mode )
	{
	case 0 :
			 if( Blood->Counter < VParam[ED_HSD1][21] ) k = VParam[ED_HSD1][22] * 0.03F ;
			 else
			 k = ( Blood->Counter < BLOODFASTTIME + VParam[ED_HSD1][21] ) ?
					 BLOODSLOWSCALE + BLOODFASTSCALE - BLOODFASTSCALE / BLOODFASTTIME * ( Blood->Counter - VParam[ED_HSD1][21] ) :
					 BLOODSLOWSCALE ;
			break ;
			
	case 1 : k = ( Blood->Counter < BLOODFASTTIME ) ?
					 0.7F + 2.0F - 2.0F / BLOODFASTTIME * Blood->Counter :
					 0.7F ;
			break ;
	case 2 :
	case 3 : k = 1.0F ;
			break ;
	}
	
	// IuWFNg̏
	Ob = Blood->ObjP ;
	Num = Blood->BloodNum ;
	
	Blood->RotCounter += PI2DIV / 30 ;
	if( Blood->RotCounter >= PI2DIV ) Blood->RotCounter -= PI2DIV ;
	
	// [hɂď𕪊
	if( Blood->Mode == 3 )
	{
		// ̐JԂ
		for( i = 0 ; i < Num ; i ++, Ob ++ )
		{
			Vec bp ;
		
			// xω
			Ob->sy += Ob->ssy * k ;

			// pxω
			Ob->SRot += Ob->SSpeed ;
			if( Ob->SRot > PI2DIV ) Ob->SRot -= PI2DIV ;
			if( Ob->SRot < 0 ) Ob->SRot += PI2DIV ;

			// Wړ
			Ob->y += Ob->sy ;

			bp.x = Ob->x ;
			bp.z = Ob->z ;
			Ob->x = ( COS(Ob->SRot) * Ob->SinWidth * ( Ob->sy * 10.0F ) ) + Ob->ssx ;
			Ob->z = ( SIN(Ob->SRot) * Ob->SinWidth * ( Ob->sy * 10.0F ) ) + Ob->ssz ;
			Ob->sx = Ob->x - bp.x ;
			Ob->sz = Ob->z - bp.z ;

			// tF[hAEg̎Ԃ߂Ă牽I
			if( Ob->FadeCount > Blood->FadeSpeedTime ) continue ;

			// tF[hAEg`FbN
			if( Ob->FadeFlag == FALSE )
			{
				if( Blood->Counter > Ob->FadeOutTime ||
					( ( Ob->y - Blood->Point.y > Ob->FadeY ) && Ob->sy > VParam[ED_HSD2][10] * 0.001F ) /*|| 
					( Ob->y - Blood->Point.y > Ob->FadeY * 2.0F )*/ ) Ob->FadeFlag = TRUE ;
			}
			else
			{
				if( Blood->ConveFlag == FALSE ) Ob->FadeCount ++ ;
				if( Ob->FadeCount > Blood->FadeSpeedTime ) Blood->MoveDrawBloodNum -- ;
			}
//			Ob->Count ++ ;

			// Fݒ肷
			if( Blood->ConveFlag == FALSE )
			{
//				Bright = (u8)( Ob->FadeFlag == TRUE ? 255 - 255 * Ob->FadeCount / Blood->FadeSpeedTime : 255 ) ;
				Ob->Color.r = (u8)( ( Ob->Color2.r * Ob->FadeCount + Ob->Color1.r * ( Blood->FadeSpeedTime - Ob->FadeCount ) ) / Blood->FadeSpeedTime ) ;
				Ob->Color.g = (u8)( ( Ob->Color2.g * Ob->FadeCount + Ob->Color1.g * ( Blood->FadeSpeedTime - Ob->FadeCount ) ) / Blood->FadeSpeedTime ) ; 
				Ob->Color.b = (u8)( ( Ob->Color2.b * Ob->FadeCount + Ob->Color1.b * ( Blood->FadeSpeedTime - Ob->FadeCount ) ) / Blood->FadeSpeedTime ) ; 
				Ob->Color.a = 255 ;
			}
			else
			{
				Ob->Color = Ob->Color1 ;
				Ob->Color.a = 255 ;
			}
		}
	}
	else
	{
		// ̐JԂ
		for( i = 0 ; i < Num ; i ++, Ob ++ )
		{
			if( Ob->FadeCount > Blood->FadeSpeedTime )
				continue ;

			// ĊɗĂȂ瓮쏈
			if( Ob->Type != 2 )
			{
				// Ԃi߂
//				Ob->Count ++ ;
				
				// 莞Ԃ畗̕Zbg
				if( Blood->Mode == 0 && Blood->Counter == Ob->Cycle + VParam[ED_HSD1][21] )
				{
					f32 Rot, temp, S, C, r, rn ;
					
					r = sqrt( Ob->sx * Ob->sx + Ob->sy * Ob->sy + Ob->sz * Ob->sz ) ;
					rn = rand() * Blood->WindPower * 0.01F / RAND_MAX ;
					Ob->ssx = Ob->sx / r * rn ;
					Ob->ssy = 0.0F ;
					Ob->ssz = Ob->sz / r * rn ;
					
					Rot = rand() * PI / 180.0F * ( BLOODKAZEKAKUDO * 2 ) / RAND_MAX - PI / 180.0F * BLOODKAZEKAKUDO ;
					S = sin( Rot ) ; C = cos( Rot ) ;
					temp = Ob->ssx * C - S * Ob->ssz ;
					Ob->ssz = Ob->ssx * S + C * Ob->ssz ;
					Ob->ssx = temp ;

					Rot = rand() * PI / 180.0F * ( BLOODKAZEKAKUDO * 2 ) / RAND_MAX - PI / 180.0F * BLOODKAZEKAKUDO ;
					S = sin( Rot ) ; C = cos( Rot ) ;
					temp = Ob->sx * C - S * Ob->sz ;
					Ob->sz = Ob->sx * S + C * Ob->sz ;
					Ob->sx = temp ;
				}
				
				// pxω
				Ob->SRot += Ob->SSpeed ;
				if( Ob->SRot > PI2DIV ) Ob->SRot -= PI2DIV ;
				if( Ob->SRot < 0 ) Ob->SRot += PI2DIV ;
			
				// xω
				Ob->sx += Ob->ssx * k ;
				Ob->sy += Ob->ssy * k ;
				Ob->sz += Ob->ssz * k ;
				
				// Wړ
				Ob->x += Ob->sx * k ;
				Ob->y += Ob->sy * ( Blood->Mode == 0 ? k : 1.0F ) ;
				Ob->z += Ob->sz * k ;
				
				// d͂̉e󂯂ꍇ͉̉x^
				if( Ob->Type == 1 )
				{
					Ob->sy -= Blood->Mode == 0 ? BLOODG : BLOODG2 ;
				}
				
				// Ⴂʒu܂ł猌ɂ
				if( Ob->y < Blood->Yuka && Ob->Type != 3 )
				{
					Ob->y = Blood->Yuka ;
					Ob->Type = 2 ;
					Ob->sx = 0.0F ;
					Ob->sy = 0.0F ;
					Ob->sz = 0.0F ;

					// ł錌̐ЂƂ炷
					Blood->MoveBloodNum -- ;
					Blood->MoveDrawBloodNum -- ;
					Blood->UnMoveDrawBloodNum ++ ;
				}
			}
			
			// Fݒ肷
			if( Ob->Type < 2 )
			{
				if( Blood->ConveFlag == FALSE )
				{
					if( Blood->Counter < Blood->ColorMoveTime )
					{
						Ob->Color.r = (u8)( ( Ob->Color2.r * Blood->Counter + Ob->Color1.r * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ;
						Ob->Color.g = (u8)( ( Ob->Color2.g * Blood->Counter + Ob->Color1.g * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
						Ob->Color.b = (u8)( ( Ob->Color2.b * Blood->Counter + Ob->Color1.b * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
					}
					else
					{
						Ob->Color = Ob->Color2 ; 
					}
					Ob->Color.a = (u8)( Ob->FadeFlag == TRUE ? 255 - 255 * Ob->FadeCount / Blood->FadeSpeedTime : 255 ) ;
				}
				else
				{
					Ob->Color = Ob->Color1 ;
					Ob->Color.a = 255 ;
				}
			}
			else
			if( Ob->Type == 2 )
			{
				if( Blood->ConveFlag == FALSE )
				{
//					Ob->FadeFlag = TRUE ;
				
					// F̌vZ
					if( Blood->Counter < Blood->ColorMoveTime )
					{
						Ob->Color.r = (u8)( ( Ob->Color2.r * Blood->Counter + Ob->Color1.r * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ;
						Ob->Color.g = (u8)( ( Ob->Color2.g * Blood->Counter + Ob->Color1.g * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
						Ob->Color.b = (u8)( ( Ob->Color2.b * Blood->Counter + Ob->Color1.b * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
					}
					else
					{
						Ob->Color = Ob->Color2 ; 
					}
					Ob->Color.a = (u8)( Ob->FadeFlag == TRUE ? 255 - 255 * Ob->FadeCount / Blood->FadeSpeedTime : 255 ) ;
				}
				else
				{
					Ob->Color = Ob->Color1 ;
					Ob->Color.a = 255 ;
				}
			}
				
			// tF[hAEg`FbN
			if( Ob->FadeFlag == FALSE )
			{
				if( Blood->Counter > Ob->FadeOutTime )
					Ob->FadeFlag = TRUE ;
			}
			else
			{
				if( Blood->ConveFlag == FALSE ) Ob->FadeCount ++ ;
				if( Ob->FadeCount > Blood->FadeSpeedTime )
				{
					if( Ob->Type != 2 )
					{
						if( Ob->Type == 3 )
						{
							Blood->SmokeNum -- ;
						}
						else
						{
							Blood->MoveDrawBloodNum -- ;
						}
					}
					else
					{
						Blood->UnMoveDrawBloodNum -- ;
					}
				}
			}
	//		Ob->FadeOutTime += Ob->FadeFlag ;
//			Ob->Count ++ ;
		}
	}

	// JE^CNg
	Blood->Counter ++ ;
	
	// I
	return 0 ;
}

// ̃GtFNg`悷
extern s8 DrawBloodEffect( EFFECT *Effect )
{
	BLOODEFFECT *Blood = ( BLOODEFFECT * )Effect->Data ;
	Mtx TMtx ;
	u32 j, Num, DNum, Num2 ;
	BLOODOBJECT *Ob ;
	u8 Bright ;
//	u16 C ;
	HSD_CObj *Camera ;
	BLOODUNION *BloodUnion = &BUnion ;

	if( Blood->ConveFlag == TRUE && GetEffectValidState( Blood->ConveEffect ) == TRUE && GetConveBloodRunFlag( Blood->ConveEffect ) == TRUE )  return 0 ;
	
	// ɏĂI
	if( Blood->FadeTime > FEED_WAIT ) return -1 ;
	
	// bVGtFNg̕`
	if( Blood->MeshEffect != NULL && GetEffectValidState( Blood->MeshEffect ) == TRUE )
	{
		DrawEffect( Blood->MeshEffect ) ;
	}

	// `̏
	EffectRenderSetup( EF_PROJECT_PERS,
						BloodAddBlendTable[Blood->BloodTexNumber] ? EF_BLEND_ADD : EF_BLEND_ALPHA,
						EF_TEV_USETEX ) ;

	// J̏擾
	Camera = GetEffectCamera() ;
	
	// J[̐ݒ
    GXSetNumChans(1);
    GXSetAlphaCompare( GX_GREATER, 20, GX_AOP_AND, GX_ALWAYS, 0);
    GXSetChanAmbColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanMatColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanCtrl( GX_COLOR0A0, GX_DISABLE, GX_SRC_REG, GX_SRC_VTX,
  				GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// ̑傫Zbg
	if( Blood->PerspectiveFlag == FALSE )
	{
		f32 dx, dy, dz, Length, Size ;
		Vec CameraPoint ;
		
		// J̈ʒu𓾂
		HSD_CObjGetEyePosition( Camera, &CameraPoint ); 
		
		// J܂ł̒𓾂
		dx = CameraPoint.x - Blood->Point.x ;
		dy = CameraPoint.y - Blood->Point.y ;
		dz = CameraPoint.z - Blood->Point.z ;
		Length = sqrt( dx * dx + dy * dy + dz * dz ) ;

		// ̃TCYZo
		Size = Blood->BloodSize / ( (f32)Length / BLOODSCALE ) ;
		
		// ̃TCYZbg
		GXSetPointSize( (u8)Size, GX_TO_HALF ) ;
		GXEnableTexOffsets( GX_TEXCOORD0, GX_DISABLE, GX_ENABLE ) ;
	}
	else
	{
		// ]ns̎Zo
		EffectGetInvViewMatrix( TMtx ) ;
	}

	// eNX`̃[h
	GTLOAD( &BUnion.BloodTex[ VParam[ED_HSD1][26] ? VParam[ED_HSD1][25] : Blood->BloodTexNumber ].Data.Obj ) ;

	// `揈
#if	1
	{
		Vec DrawP[4] ;
		u16 Count ;
		s32 k ;
		GXColor GColor ;
	
		// ŏɌ`
		Ob = Blood->ObjP ;
//		Num = Blood->BloodNum - Blood->MoveBloodNum ;
		Num2 = Num = Blood->UnMoveDrawBloodNum ;
		Count = (u16)Blood->Counter ;
		if( Num != 0 )
		{
			VECScale( &BaseVert[0], &DrawP[0], Blood->BloodSize * 2 ) ;
			VECScale( &BaseVert[1], &DrawP[1], Blood->BloodSize * 2 ) ;
			VECScale( &BaseVert[2], &DrawP[2], Blood->BloodSize * 2 ) ;
			VECScale( &BaseVert[3], &DrawP[3], Blood->BloodSize * 2 ) ;

			DNum = Num ;
			if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
			Num -= DNum ;
			GBGN( GX_QUADS, DNum * 4 ) ;

			{
				k = 0 ;
				for( j = 0 ; j < Num2 ; Ob ++, k ++ )
				{
					if( Ob->Type == 2 && Ob->FadeCount <= Blood->FadeSpeedTime )
					{
						j ++ ;
					
						GPV3( DrawP[0], Ob->v ) ; GC( Ob->Color ) ; GT2( Ob->Pu, (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
						GPV3( DrawP[1], Ob->v ) ; GC( Ob->Color ) ; GT2( Ob->Pu, Ob->Pv ) ;
						GPV3( DrawP[2], Ob->v ) ; GC( Ob->Color ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), Ob->Pv ) ;
						GPV3( DrawP[3], Ob->v ) ; GC( Ob->Color ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
						
						DNum -- ;
						if( DNum == 0 && Num != 0 )
						{
							GEND() ;
							
							DNum = Num ;
							if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
							Num -= DNum ;
							GBGN( GX_QUADS, DNum * 4 ) ;
						}
					}
				}
			}
			GEND() ;
		}
		
		// ɔł錌̕`
		Ob = Blood->ObjP ;
//		Num = Blood->MoveBloodNum ;
		Num2 = Num = Blood->MoveDrawBloodNum ;
		if( Num != 0 )
		{
			if( Blood->PerspectiveFlag == FALSE )
			{
				DNum = Num ;
				if( DNum > 0xffff ) DNum = 0xffff ;
				Num -= DNum ;
				GBGN( GX_POINTS, DNum ) ;
				
				{
					k = 0 ;
					for( j = 0 ; j < Num2 ; Ob ++, k ++ )
					{
						if( Ob->Type < 2 && Ob->FadeCount <= Blood->FadeSpeedTime )
						{
							j ++ ;
							
							GPV( Ob->v ) ; GC( Ob->Color ) ; GT2( Ob->Pu, Ob->Pv ) ;
							
							DNum -- ;
							if( DNum == 0 && Num != 0 )
							{
								DNum = Num ;
								if( DNum > 0xffff ) DNum = 0xffff ;
								Num -= DNum ;
								GBGN( GX_POINTS, DNum ) ;
							}
						}
					}
				}
				GEND() ;
			}
			else
			{
				Vec tp[4] ;
				f32 Sin, Cos ;

//				Sin = SIN(Ob->SRot) ;	Cos = COS(Ob->SRot) ;
				Sin = SIN(Blood->RotCounter) ;	Cos = COS(Blood->RotCounter) ;
				tp[0].x = ( -Blood->BloodSize / 2 ) * Cos - ( -Blood->BloodSize / 2 ) * Sin ;
				tp[0].y = ( -Blood->BloodSize / 2 ) * Sin + ( -Blood->BloodSize / 2 ) * Cos ;
				tp[0].z = 0.0F ;
				
				tp[1].x = ( Blood->BloodSize / 2 ) * Cos - ( -Blood->BloodSize / 2 ) * Sin ;
				tp[1].y = ( Blood->BloodSize / 2 ) * Sin + ( -Blood->BloodSize / 2 ) * Cos ;
				tp[1].z = 0.0F ;

				tp[2].x = -tp[0].x ; tp[2].y = -tp[0].y ; tp[2].z = -tp[0].z ; tp[2].z = 0.0F ;
				tp[3].x = -tp[1].x ; tp[3].y = -tp[1].y ; tp[3].z = -tp[1].z ; tp[3].z = 0.0F ;
				MTXMultVec( TMtx, &tp[0], &tp[0] ) ;
				MTXMultVec( TMtx, &tp[1], &tp[1] ) ;
				MTXMultVec( TMtx, &tp[2], &tp[2] ) ;
				MTXMultVec( TMtx, &tp[3], &tp[3] ) ;

				DNum = Num ;
				if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
				Num -= DNum ;
				GBGN( GX_QUADS, DNum * 4 ) ;

				{
					if( Blood->Mode == 3 )
					{
						k = 0 ;
						for( j = 0 ; j < Num2 ; Ob ++, k ++ )
						{
							if( Ob->Type < 2 && Ob->FadeCount <= Blood->FadeSpeedTime )
							{
								j ++ ;
	
								if( Blood->BloodTexNumber != 0 )
								{
									GColor.b = GColor.g = GColor.r = Ob->Color.r ;
								}
								else
								{
									GColor = Ob->Color ;
								}

								switch( Ob->RotType )
								{
								case 0 :
									GPV3( tp[0], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( Ob->Pu, Ob->Pv ) ;
									GPV3( tp[1], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), Ob->Pv ) ;
									GPV3( tp[2], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[3], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( Ob->Pu, (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									break ;
									
								case 1 :
									GPV3( tp[0], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), Ob->Pv ) ;
									GPV3( tp[1], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[2], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( Ob->Pu, (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[3], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( Ob->Pu, Ob->Pv ) ;
									break ;
									
								case 2 :
									GPV3( tp[0], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[1], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( Ob->Pu, (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[2], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( Ob->Pu, Ob->Pv ) ;
									GPV3( tp[3], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), Ob->Pv ) ;
									break ;
									
								case 3 :
									GPV3( tp[0], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( Ob->Pu, (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[1], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( Ob->Pu, Ob->Pv ) ;
									GPV3( tp[2], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), Ob->Pv ) ;
									GPV3( tp[3], Ob->v ) ; GC2( GColor, Ob->Color.a ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									break ;
								}
								
								DNum -- ;
								if( DNum == 0 && Num != 0 )
								{
									DNum = Num ;
									if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
									Num -= DNum ;
									GBGN( GX_QUADS, DNum * 4 ) ;
								}
							}
						}
					}
					else
					{
						k = 0 ;
						for( j = 0 ; j < Num2 ; Ob ++, k ++ )
						{
							if( Ob->Type < 2 && Ob->FadeCount <= Blood->FadeSpeedTime )
							{
								j ++ ;

								Bright = (u8)( Ob->FadeFlag == TRUE ? 255 - 255 * Ob->FadeCount / Blood->FadeSpeedTime : 255 ) ;
								if( Blood->Counter < Blood->ColorMoveTime )
								{
									GColor.r = (u8)( ( Ob->Color2.r * Blood->Counter + Ob->Color1.r * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ;
									GColor.g = (u8)( ( Ob->Color2.g * Blood->Counter + Ob->Color1.g * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
									GColor.b = (u8)( ( Ob->Color2.b * Blood->Counter + Ob->Color1.b * ( Blood->ColorMoveTime - Blood->Counter ) ) / Blood->ColorMoveTime ) ; 
								}
								else
								{
									GColor = Ob->Color2 ; 
								}
								if( Blood->BloodTexNumber != 0 ) GColor.r = GColor.g = GColor.b = 255 ;

								switch( Ob->RotType )
								{
								case 0 :
									GPV3( tp[0], Ob->v ) ; GC2( GColor, Bright ) ; GT2( Ob->Pu, Ob->Pv ) ;
									GPV3( tp[1], Ob->v ) ; GC2( GColor, Bright ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), Ob->Pv ) ;
									GPV3( tp[2], Ob->v ) ; GC2( GColor, Bright ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[3], Ob->v ) ; GC2( GColor, Bright ) ; GT2( Ob->Pu, (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									break ;
									
								case 1 :
									GPV3( tp[0], Ob->v ) ; GC2( GColor, Bright ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), Ob->Pv ) ;
									GPV3( tp[1], Ob->v ) ; GC2( GColor, Bright ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[2], Ob->v ) ; GC2( GColor, Bright ) ; GT2( Ob->Pu, (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[3], Ob->v ) ; GC2( GColor, Bright ) ; GT2( Ob->Pu, Ob->Pv ) ;
									break ;
									
								case 2 :
									GPV3( tp[0], Ob->v ) ; GC2( GColor, Bright ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[1], Ob->v ) ; GC2( GColor, Bright ) ; GT2( Ob->Pu, (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[2], Ob->v ) ; GC2( GColor, Bright ) ; GT2( Ob->Pu, Ob->Pv ) ;
									GPV3( tp[3], Ob->v ) ; GC2( GColor, Bright ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), Ob->Pv ) ;
									break ;
									
								case 3 :
									GPV3( tp[0], Ob->v ) ; GC2( GColor, Bright ) ; GT2( Ob->Pu, (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									GPV3( tp[1], Ob->v ) ; GC2( GColor, Bright ) ; GT2( Ob->Pu, Ob->Pv ) ;
									GPV3( tp[2], Ob->v ) ; GC2( GColor, Bright ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), Ob->Pv ) ;
									GPV3( tp[3], Ob->v ) ; GC2( GColor, Bright ) ; GT2( (u16)( Ob->Pu + BLOODONE_SIZE ), (u16)( Ob->Pv + BLOODONE_SIZE ) ) ;
									break ;
								}

								DNum -- ;
								if( DNum == 0 && Num != 0 )
								{
									DNum = Num ;
									if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
									Num -= DNum ;
									GBGN( GX_QUADS, DNum * 4 ) ;
								}
							}
						}
					}
				}
				GEND() ;
			}
		}

	}
#endif

	// I
	return 0 ;
}					


// ̃eNX`擾
extern TEXTURE *GetBloodTex( u8 BloodTexNumber )
{
	if( TexLoadChk( &BUnion.BloodTex[BloodTexNumber] ) == FALSE ) return NULL ;
	return &BUnion.BloodTex[BloodTexNumber].Data ;

//	if( CHKFILELOAD( BUnion.TexFileBlood ) == FALSE ) return NULL ;
//	return &BUnion.BloodTex ;
}

// ̐Fݒ肷
extern s8 SetBloodColor( u32 color1, u32 color2 )
{
	BUnion.color1 = color1 ;
	BUnion.color2 = color2 ;
	BUnion.colorvalid = true ;
	
	return 0 ;
}


