///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBlood2
//
// YK7EffectBlood2.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/28/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectBlood2.h"
#include "./YK7EffectBlood.h"
#include "./YK7EffectFlyBlood.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

BLOOD2UNION B2Union ;


// function proto type --------------------------

// function code --------------------------------

// 򖗂QGtFNg̋ʃf[^
extern s8 InitBlood2Data( void )
{
	MEMINIT(B2Union) ;

	B2Union.Size = 1.0F ;
	
	// I
	return 0 ;
}

// 򖗂QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckBlood2Data( void )
{
	return TRUE ;
}


// 򖗂QGtFNg̋ʃf[^n
extern s8 EndBlood2Data( void )
{
	MEMINIT(B2Union) ;
	
	// I
	return 0 ;
}

// 򖗂Q̃GtFNg쐬
extern EFFECT *CreateBlood2Effect( WK7JObj *JObj, u32 VertexNumber,
									u16 ObjMaxNum,
									f32 MaxSpeed, f32 MinSpeed,
									s16 MaxLife, s16 MinLife,
									f32 r, f32 RotWidth,
									GXColor *Color, f32 CreateSpeed,
									s32 LifeTime, f32 SlowRate, 
									Vec *Dir, 
									Vec *PosBuf, Vec *DirBuf,
									s32 Priority )
{
	EFFECT *Effect ;
	BLOOD2EFFECT *Blood2 ;
	u32 HopeNumber ;
	BLOOD2OBJECT *Obj ;
	Vec Point, Direction ;
	f32 Size ;
	
	Size = B2Union.Size ;
	B2Union.Size = 1.0F ;

	// ̊m
	Obj = ( BLOOD2OBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( BLOOD2OBJECT ) * ObjMaxNum ), "Y_Bld2Obj" ) ;
	if( Obj == NULL ) return NULL ;
	memset( Obj, 0, sizeof( BLOOD2OBJECT ) * ObjMaxNum ) ;

	// V򖗂Qf[^쐬
	Effect = AddEffectData( EFF_BLOOD2, (void**)&Blood2, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( Obj ) ;
		return NULL ;
	}
	memset( Blood2, 0, sizeof( BLOOD2EFFECT ) ) ;
	
	Blood2->Mesh = NULL ;
	Blood2->Obj = Obj ;
	Blood2->MeshID = -1 ;
	if( Dir != NULL )
	{
		Blood2->DirValid = true ;
		Blood2->Dir = *Dir ;
	}
	else
	{
		Blood2->DirValid = false ;
	}

	// JObj nĂꍇ́A_io[WZo
	{
		HSD_PObj *pobj ;
		HSD_DObj *dobj ;
		MESHINFO *Info ;
		Mtx NrmInvMtx ;
		
		// ]̔ԍbVf[^̃AhX𓾂
		if( GetHaveHopeNumberVertexPObj( JObj->GetJObj(), VertexNumber, &HopeNumber, &pobj, &dobj ) < 0 )
		{
			DeleteEffect( Effect ) ;
			return NULL ;
		}

		// ܂bVf[^͂
		Blood2->MeshID = CreateMeshData( JObj, dobj, pobj ) ;
		if( Blood2->MeshID < 0 )
		{
			DeleteEffect( Effect ) ;
			return NULL ;
		}
		Info = GetMeshData( Blood2->MeshID ) ;
		Blood2->Mesh = Info->Mesh ;
		
/*		if( CreatePrimitiveMeshData( JObj->GetJObj(), pobj, &Blood2->Mesh, TRUE, TRUE, FALSE, FALSE ) != 0 )
		{
			DeleteEffect( Effect ) ;
			return NULL ;
		}
*/
		// _̍WƖ@擾
		GetHopeNumberVertexPositionAndNormal( Blood2->Mesh, HopeNumber, &Point, &Direction, NULL, NrmInvMtx ) ;
		
		if( DirBuf != NULL ) *DirBuf = Direction ;
		if( PosBuf != NULL ) *PosBuf = Point ;
		
		// w֔΂w肪ꍇ͖@̊̕擾Ă
		if( Blood2->DirValid )
		{
			// @̌os̋ts𓾂
			MTXInverse( NrmInvMtx, NrmInvMtx ) ;
			
			// ts|ĕϊǑ擾
			MTXMultVec( NrmInvMtx, &Blood2->Dir, &Blood2->Dir ) ;
		}
	}

	// ␳l𓾂
	{
		BLOODDEF Def ;
		
		GetBloodDefParam( &Point, &Def ) ;

		// ␳
		MaxSpeed *= Def.Power ;
		MinSpeed *= Def.Power ;
		CreateSpeed *= Def.BloodNum ;
		Blood2->Size = VParam[ED_BLOOD2][8] * 0.001F * Def.BloodSize * Size ;
	}

	// p[^̏
	Blood2->HopeNumber = HopeNumber ;
	Blood2->ObjMaxNum = ObjMaxNum ;
	Blood2->ObjNum = 0 ;
	Blood2->MaxSpeed = MaxSpeed ;
	Blood2->MinSpeed = MinSpeed ;
	Blood2->MaxLife = MaxLife ;
	Blood2->MinLife = MinLife ;
	Blood2->r = r ;
	Blood2->Color = Color != NULL ? *Color : (GXColor){180, 40, 0, 255} ; 
	Blood2->CreateSpeed = CreateSpeed ;
	Blood2->LifeTime = LifeTime ;
	Blood2->LifeCounter = 0 ;
	Blood2->SlowRate = SlowRate ;
	Blood2->RotWidth = RotWidth ;
	Blood2->ColorRand = B2Union.ColorRand ;

	// I
	return Effect ;
}

// 򖗂Q̃GtFNǧns
extern s8 ReleaseBlood2Effect( EFFECT *Effect )
{
	BLOOD2EFFECT *Blood2 = ( BLOOD2EFFECT * )Effect->Data ;

	// 쐬bVf[^
//	if( Blood2->Mesh != NULL )
	if( Blood2->MeshID >= 0 )
	{
//		DeletePrimitiveMeshData( Blood2->Mesh ) ;
		ReleaseMeshData( Blood2->MeshID ) ;
		Blood2->Mesh = NULL ;
	}

	// ̉
	if( Blood2->Obj != NULL )
	{
		K7AppSmallMemFree( Blood2->Obj ) ;
		Blood2->Obj = NULL ;
	}

	// I
	return 0 ;
}

// 򖗂Q̃GtFNgt[ړ
extern s8 MoveBlood2Effect( EFFECT *Effect )
{
	BLOOD2EFFECT *Blood2 = ( BLOOD2EFFECT * )Effect->Data ;
	BLOOD2OBJECT *Obj ;
	s32 i, Num ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜̏폜
	if( ( Blood2->LifeTime != -1 && Blood2->LifeCounter >= Blood2->LifeTime && Blood2->ObjNum == 0 ) ||
		( Effect->DelReqFlag == TRUE && Blood2->ObjNum == 0 ) )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	else
	{
		if( Blood2->LifeTime != -1 ) Blood2->LifeCounter ++ ;
	}

	// IuWFNg쐬
	if( Effect->DelReqFlag == FALSE && ( Blood2->LifeTime == -1 || Blood2->LifeCounter <= Blood2->LifeTime ) )
	{
		if( Blood2->ObjMaxNum != Blood2->ObjNum )
		{
			Blood2->CreateCounter += Blood2->CreateSpeed ;
			while( Blood2->CreateCounter >= 1.0F &&
					Blood2->ObjMaxNum != Blood2->ObjNum )
			{
				f32 Cos, Sin ;
				f32 xz, oir, f  ;
				Mtx NrmMtx ;
		
				// gĂȂIuWFNgT
				for( Obj = Blood2->Obj ; Obj->UseFlag == TRUE ; Obj ++ ){}
				
				// gptO𗧂Ă
				Obj->UseFlag = TRUE ;
				
				// _̍WƖ@擾
				GetHopeNumberVertexPositionAndNormal( Blood2->Mesh, Blood2->HopeNumber, &Obj->Point, &Obj->Dir, NULL, NrmMtx ) ;
				if( Blood2->DirValid == true )
				{
					MTXMultVec( NrmMtx, &Blood2->Dir, &Obj->Dir ) ;
				}
				
				// px𕪉
				{
					xz = atan2( Obj->Dir.z, Obj->Dir.x ) ;

					Sin = sinf( xz ) ; Cos = cosf( xz ) ;
					f = Obj->Dir.x * Cos - Obj->Dir.z * Sin ;
					Obj->Dir.z = Obj->Dir.x * Sin + Obj->Dir.z * Cos ;
					Obj->Dir.x = f ;

					oir = atan2( Obj->Dir.y, Obj->Dir.x ) ;
				}
				
				// pxɗh炬
				{
					f32 power, rot ;
					
					power = rand() * Blood2->RotWidth / RAND_MAX ;
					rot = rand() * PI_2 / RAND_MAX - PI ;
					xz += cosf( rot ) * power ;
					oir += sinf( rot ) * power ;
				}
				
				// pxZbg
				{
					Obj->Dir.x = cosf( oir ) ;
					Obj->Dir.y = sinf( oir ) ;
					f = Obj->Dir.x * cosf( xz ) ;
					Obj->Dir.z = Obj->Dir.x * sinf( xz ) ;
					Obj->Dir.x = f ;
				}
				
				// FZbg
				{
					s32 r, g, b ;
					
					if( Blood2->Color.r == 0 ) r = 0 ;
					else
					{
						r = GetRandINum( Blood2->ColorRand ) + Blood2->Color.r - Blood2->ColorRand / 2 ;
						if( r > 255 ) r = 255 ; else if( r < 0 ) r = 0 ;
					}
					if( Blood2->Color.g == 0 ) g = 0 ;
					else
					{
						g = GetRandINum( Blood2->ColorRand ) + Blood2->Color.g - Blood2->ColorRand / 2 ;
						if( g > 255 ) g = 255 ; else if( g < 0 ) g = 0 ;
					}
					if( Blood2->Color.b == 0 ) b = 0 ;
					else
					{
						b = GetRandINum( Blood2->ColorRand ) + Blood2->Color.b - Blood2->ColorRand / 2 ;
						if( b > 255 ) b = 255 ; else if( b < 0 ) b = 0 ;
					}
					Obj->Color = CMK( r, g, b, Blood2->Color.a ) ;
				}

				// x̃Zbg
				Obj->Power = rand() * ( Blood2->MaxSpeed - Blood2->MinSpeed ) / RAND_MAX + Blood2->MinSpeed ;

				// ̃Zbg
				Obj->Life = (s16)( rand() * ( Blood2->MaxLife - Blood2->MinLife ) / RAND_MAX + Blood2->MinLife ) ;
				Obj->LifeCounter = 0 ;
				
				// eNX`W̃Zbg
				{
					u8 Pattarn ;
					
					Pattarn = (u8)( rand() * BLOODPAT_NUM / RAND_MAX ) ;
					if( Pattarn == BLOODPAT_NUM ) Pattarn = BLOODPAT_NUM - 1 ;
					Obj->Pu = (u8)( ( UVSCALE * ( Pattarn % BLOODPAT_ONELINENUM ) ) / BLOODPAT_ONELINENUM ) ;
					Obj->Pv = (u8)( ( UVSCALE * ( Pattarn / BLOODPAT_ONELINENUM ) ) / ( BLOODPAT_NUM / BLOODPAT_ONELINENUM ) ) ;
					Obj->RotType = (u8)( rand() * 4 / RAND_MAX ) ;
					if( Obj->RotType == 4 ) Obj->RotType = 3 ;
				}

				// IuWFNg̐𑝂₷
				Blood2->ObjNum ++ ;
				
				// 쐬JE^[̒l炷
				Blood2->CreateCounter -= 1.0F ;
			}
		}
	}
	
	// IuWFNg𓮂
	Num = (s32)Blood2->ObjNum ;
	for( Obj = Blood2->Obj, i = 0 ; i < Num ; Obj ++ )
	{
		if( Obj->UseFlag == FALSE ) continue ;
		
		i ++ ;
		
		Obj->Point.x += Obj->Dir.x * Obj->Power ;
		Obj->Point.y += Obj->Dir.y * Obj->Power ;
		Obj->Point.z += Obj->Dir.z * Obj->Power ;
		
		Obj->Power *= Blood2->SlowRate ;
		Obj->LifeCounter ++ ;

		if( Obj->Power <= VParam[ED_BLOOD2][7] * 0.0001F ||
			Obj->LifeCounter == Obj->Life )
		{
			Obj->UseFlag = FALSE ;
			Blood2->ObjNum -- ;
		}
	}
	
	// I
	return 0 ;
}					


// 򖗂Q̃GtFNg`悷
extern s8 DrawBlood2Effect( EFFECT *Effect )
{
	BLOOD2EFFECT *Blood2 = ( BLOOD2EFFECT * )Effect->Data ;
	BLOOD2OBJECT *Ob ;
	Mtx TMtx ;
	u32 i ;
	HSD_CObj *Camera ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;							// `̏
							
	// J̏擾
	Camera = GetEffectCamera() ;
	
	// J[̐ݒ
    GXSetNumChans(1);
    GXSetAlphaCompare( GX_GREATER, 20, GX_AOP_AND, GX_ALWAYS, 0);
    GXSetChanAmbColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanMatColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanCtrl( GX_COLOR0A0, GX_DISABLE, GX_SRC_REG, GX_SRC_VTX,
  				GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// ]ns̎Zo
	EffectGetInvViewMatrix( TMtx ) ;
//	TMtx[0][0] = View[0][0] ;	TMtx[0][1] = View[1][0] ;	TMtx[0][2] = View[2][0] ;	TMtx[0][3] = 0.0F ;
//	TMtx[1][0] = View[0][1] ;	TMtx[1][1] = View[1][1] ;	TMtx[1][2] = View[2][1] ;	TMtx[1][3] = 0.0F ;
//	TMtx[2][0] = View[0][2] ;	TMtx[2][1] = View[1][2] ;	TMtx[2][2] = View[2][2] ;	TMtx[2][3] = 0.0F ;

	// eNX`̃[h
	GTLOAD( &(GetBloodTex(0)->Obj) ) ;

	// `揈
	{
//		GXColor GColor ;
		u32 Num ;
		u8 Bright ;
	
		// ł錌̕`
		Ob = Blood2->Obj ;
		Num = Blood2->ObjNum ;
		if( Num != 0 )
		{
			Vec tp[4] ;

			tp[0].x = -Blood2->Size / 2 ; tp[0].y = Blood2->Size / 2 ; tp[0].z = 0.0F ;
			tp[1].x = Blood2->Size / 2 ; tp[1].y = Blood2->Size / 2 ; tp[1].z = 0.0F ;
			tp[2].x = Blood2->Size / 2 ; tp[2].y = -Blood2->Size / 2 ; tp[2].z = 0.0F ;
			tp[3].x = -Blood2->Size / 2 ; tp[3].y = -Blood2->Size / 2 ; tp[3].z = 0.0F ;
			MTXMultVec( TMtx, &tp[0], &tp[0] ) ;
			MTXMultVec( TMtx, &tp[1], &tp[1] ) ;
			MTXMultVec( TMtx, &tp[2], &tp[2] ) ;
			MTXMultVec( TMtx, &tp[3], &tp[3] ) ;

			if( Num * 4 > 65536 ) Num = 0x10000 >> 2 ;
			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Num * 4 ) ) ;
			{
				for( i = 0 ; i < Num ; Ob ++ )
				{
					i ++ ;

//					GColor = Blood2->Color ; 
					Bright = 255 ;

					switch( Ob->RotType )
					{
					case 0 :
						GP3( tp[0].x + Ob->Point.x, tp[0].y + Ob->Point.y, tp[0].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu					, Ob->Pv ) ;
						GP3( tp[1].x + Ob->Point.x, tp[1].y + Ob->Point.y, tp[1].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu + BLOODONE_SIZE	, Ob->Pv ) ;
						GP3( tp[2].x + Ob->Point.x, tp[2].y + Ob->Point.y, tp[2].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu + BLOODONE_SIZE	, Ob->Pv + BLOODONE_SIZE ) ;
						GP3( tp[3].x + Ob->Point.x, tp[3].y + Ob->Point.y, tp[3].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu					, Ob->Pv + BLOODONE_SIZE ) ;
						break ;
						
					case 1 :
						GP3( tp[0].x + Ob->Point.x, tp[0].y + Ob->Point.y, tp[0].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu + BLOODONE_SIZE	, Ob->Pv ) ;
						GP3( tp[1].x + Ob->Point.x, tp[1].y + Ob->Point.y, tp[1].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu + BLOODONE_SIZE	, Ob->Pv + BLOODONE_SIZE ) ;
						GP3( tp[2].x + Ob->Point.x, tp[2].y + Ob->Point.y, tp[2].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu					, Ob->Pv + BLOODONE_SIZE ) ;
						GP3( tp[3].x + Ob->Point.x, tp[3].y + Ob->Point.y, tp[3].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu					, Ob->Pv ) ;
						break ;
						
					case 2 :
						GP3( tp[0].x + Ob->Point.x, tp[0].y + Ob->Point.y, tp[0].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu + BLOODONE_SIZE	, Ob->Pv + BLOODONE_SIZE ) ;
						GP3( tp[1].x + Ob->Point.x, tp[1].y + Ob->Point.y, tp[1].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu					, Ob->Pv + BLOODONE_SIZE ) ;
						GP3( tp[2].x + Ob->Point.x, tp[2].y + Ob->Point.y, tp[2].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu					, Ob->Pv ) ;
						GP3( tp[3].x + Ob->Point.x, tp[3].y + Ob->Point.y, tp[3].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu + BLOODONE_SIZE	, Ob->Pv ) ;
						break ;
						
					case 3 :
						GP3( tp[0].x + Ob->Point.x, tp[0].y + Ob->Point.y, tp[0].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu					, Ob->Pv + BLOODONE_SIZE ) ;
						GP3( tp[1].x + Ob->Point.x, tp[1].y + Ob->Point.y, tp[1].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu					, Ob->Pv ) ;
						GP3( tp[2].x + Ob->Point.x, tp[2].y + Ob->Point.y, tp[2].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu + BLOODONE_SIZE	, Ob->Pv ) ;
						GP3( tp[3].x + Ob->Point.x, tp[3].y + Ob->Point.y, tp[3].z + Ob->Point.z ) ; GCX( Ob->Color ) ; GT2( Ob->Pu + BLOODONE_SIZE	, Ob->Pv + BLOODONE_SIZE ) ;
						break ;
					}
				}
			}
			GXEnd() ;
		}
	}

	// I
	return 0 ;
}					
	
/*
	// 𑪂ăp[^
	{
		Vec BPoint, CPoint ;
		f32 Length, f ;
		BLOOD2DEF TBDef ;
		s32 i ;
		
		BPoint = Point ;

		HSD_CObjGetEyePosition( GetEffectCamera(), &CPoint ) ;
		Length = sqrt( VECSquareDistance( &BPoint, &CPoint ) ) ;
		
		// ǂ̃e[uɓ邩o
		for( i = 0 ; i < BLOOD2DEF_NUM && Length > Blood2Table[i].Length ; i ++ ){}
		if( i == BLOOD2DEF_NUM )
		{
			TBDef = Blood2Table[i-1] ;
		}
		else
		if( i == 0 )
		{
			TBDef = Blood2Table[0] ;
		}
		else
		{
			BLOOD2DEF *BDef1, *BDef2 ;
			
			BDef2 = &Blood2Table[i] ;
			BDef1 = &Blood2Table[i-1] ;
			
			f = ( Length - BDef1->Length ) / ( BDef2->Length - BDef1->Length ) ;
			TBDef.Size = f * ( BDef2->Size - BDef1->Size ) + BDef1->Size ;
			TBDef.BloodNum = f * ( BDef2->BloodNum - BDef1->BloodNum ) + BDef1->BloodNum ;
			TBDef.Power = f * ( BDef2->Power - BDef1->Power ) + BDef1->Power ;
		}

		// ␳
		Power *= TBDef.Power ;
		VibPower *= TBDef.Power ;
//		BloodNum = (u32)( BloodNum * TBDef.BloodNum ) ;
//		if( BloodNum == 0 ) BloodNum = 1 ;
		Size *= TBDef.Size ;
	}
*/


// 򖗃GtFNgQ̏ꏊw^
extern EFFECT *CreateBlood2Effect2( WK7JObj *JObj, Vec Point,
									u16 ObjMaxNum,
									f32 MaxSpeed, f32 MinSpeed,
									s16 MaxLife, s16 MinLife,
									f32 r, f32 RotWidth,
									GXColor *Color, f32 CreateSpeed,
									s32 LifeTime, f32 SlowRate, u8 Num,
									s32 Priority, Vec *Pos, Vec *Dir, LENGTHLIST *LengthInfoBuf )
{
	LENGTHLIST LengthInfo ;
	EFFECT *Effect ;
	f32 Size = B2Union.Size ;
	
	// XL
	CreateLengthList( JObj, Point, &LengthInfo, Num ) ;
	if( LengthInfoBuf != NULL ) *LengthInfoBuf = LengthInfo ;
	
	// XLɌ򖗃GtFNg쐬
	{
		s32 i ;
		LENGTHLISTCHIP *Chip ;

		Chip = LengthInfo.Chip[0].Next ;
		for( i = 0 ; i < LengthInfo.Num - 1 ; i ++, Chip = Chip->Next )
		{
			SetBlood2EffectSize( Size ) ;
			Effect = CreateBlood2Effect( Chip->JObj, (u32)Chip->Number,
										ObjMaxNum,
										MaxSpeed, MinSpeed,
										MaxLife, MinLife,
										r, RotWidth, 
										Color, CreateSpeed,
										LifeTime, SlowRate,
										B2Union.dirflag ? &B2Union.dir : NULL,
										( Pos != NULL && i == 0 ? Pos : NULL ),
										( Dir != NULL && i == 0 ? Dir : NULL ), Priority ) ;
		}
	}

	B2Union.dirflag = false ;

	// I
	return Effect ;
}

//  CreateBlood2Effect2 ō쐬錌򖗂QGtFNǧw肷
extern s8 SetBlood2EffectDir( Vec Dir, bool flag )
{
	B2Union.dir = Dir ;
	B2Union.dirflag = flag ;
	
	return 0 ;
}

// 򖗃GtFNgQ̐F_lݒ肷
extern s8 SetBlood2EffectColorRand( u8 ColorRand )
{
	B2Union.ColorRand = ColorRand ;
	
	return 0 ;
}

// TCY̐ݒ
extern s8 SetBlood2EffectSize( f32 Size )
{
	B2Union.Size = Size ;

	return 0 ;
}



