///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBlood2
//
// YK7EffectBlood2.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/28/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTBLOOD2_H
#define __YK7EFFECTBLOOD2_H

// include --------------------------------------
#include "../Wat/WK7Model.h"
#include "./YK7Break.h"
#include "./YK7Effect.h"

// define ---------------------------------------

//#define BLOOD2_MAXOBJECTNUM		300
//#define BLOOD2_NOFLYMAXNUM		700
#define BLOOD2_VIBSIN				20

// datatype -------------------------------------

// 򖗂QGtFNgʃf[^
typedef struct tagBLOOD2UNION
{
//	u8 Dummy ;
	u8 ColorRand ;		// F̃_l
	Vec dir ;			// Cӊpx
	bool dirflag ;		// CӊpxKtO
	f32 Size ;			// TCY
} BLOOD2UNION ;

// 򖗂QIuWFNgf[^
typedef struct tagBLOOD2OBJECT
{
	u8 UseFlag ;			// gptO

	Vec Point ;				// W
	Vec Dir ;				// 
	f32 Power ;				// x
	s16 Life ;				// 
	s16 LifeCounter ;		// JE^[
	u32 Color ;				// F
	
	u8 Pu, Pv ;				// eNX`W
	u8 RotType ;
} BLOOD2OBJECT ;

// 򖗂QGtFNgf[^
typedef struct tagBLOOD2EFFECT
{
	Vec Dir ;					// Cӂ̕Ɍ΂ꍇ̂̕
	bool DirValid ;				// DirLǂ̃tO

	s32 MeshID ;
	WK7JObj *JObj ;				// ǂꂩ JObj ɏ]Ăꍇ̏]Ă JObj
	MESH *Mesh ;				// ǂꂩ JObj ɏ]Ăꍇ JObj ̃bV̓f[^
	u32 VertexNumber ;			// ΏۂƂ钸_̃io[
	
	BLOOD2OBJECT *Obj ;			// 򖗂QIuWFNgf[^
	u32 ObjMaxNum ;				// ł錌IuWFNg̍쐬łő吔
	u32 ObjNum ;				// 򖗂QIuWFNg̐
	u32 HopeNumber ;			// wW
	
	f32 MaxSpeed, MinSpeed ;	// ő呬xAŏx
	s16 MaxLife, MinLife ;		// őAŏ
	f32 r ;						// a
	f32 RotWidth ;				// ԕ
	
	f32 CreateSpeed ;			// ̕ox
	f32 CreateCounter ;			// ̐oJE^[
	
	GXColor Color ;				// F
	u8 ColorRand ;				// F̃_l
	s32 LifeTime ;				// 
	s32 LifeCounter ;			// JE^
	f32 Size ;					// TCY
	
	f32 SlowRate ;				// x
} BLOOD2EFFECT ;

// 򖗂QGtFNg^XNɓnf[^
typedef struct tagBLOOD2EFFECTTACKPARAM
{
	WK7JObj *JObj ;				// ΏۂɂȂ WK7JObj
	u32 VertexNumber ;			// ΏۂƂ钸_̃io[
	
	u16 ObjMaxNum ;				// ł錌IuWFNg̍쐬łő吔

	f32 MaxSpeed, MinSpeed ;	// ő呬xAŏx
	s16 MaxLife, MinLife ;		// őAŏ
	f32 r ;						// a
	f32 RotWidth ;				// ԕ
	GXColor *Color ;			// F

	f32 CreateSpeed ;			// ̕ox
	f32 SlowRate ;				// x
} BLOOD2EFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitBlood2Data( void ) ;				// 򖗂QGtFNg̋ʃf[^
extern s8 CheckBlood2Data( void ) ;				// 򖗂QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndBlood2Data( void ) ;				// 򖗂QGtFNg̋ʃf[^n

extern EFFECT *CreateBlood2Effect( WK7JObj *JObj, u32 VertexNumber,
									u16 ObjMaxNum,
									f32 MaxSpeed, f32 MinSpeed,
									s16 MaxLife, s16 MinLife,
									f32 r, f32 RotWidth,
									GXColor *Color, f32 CreateSpeed,
									s32 LifeTime, f32 SlowRate,
									Vec *Dir,
									Vec *PosBuf = NULL, Vec *DirBuf = NULL,
									s32 Priority = -2 ) ;	// 򖗂Q̃GtFNg쐬
extern EFFECT *CreateBlood2Effect2( WK7JObj *JObj,				//  JObj
								Vec Point,						// W
								u16 ObjMaxNum,					// IuWFNg̍ő吔
								f32 MaxSpeed, f32 MinSpeed,		// ő呬xƍŏx
								s16 MaxLife, s16 MinLife,		// ꗱ̍ő呶ݎԂƍŏݎ
								f32 r,							// ̏oꏊ̔a
								f32 RotWidth,					// ̔ԕ͈̔(WA)
								GXColor *Color,					// F
								f32 CreateSpeed,				// 쐬x
								s32 LifeTime,					// o鎞
								f32 SlowRate,					// ̑x̌
								u8 Num,							// 򖗃GtFNg𓯎ɏo
								s32 Priority = -2,
								Vec *Pos = NULL, Vec *Dir = NULL,// ԋ߂_̍Wƌ
								LENGTHLIST *LengthInfoBuf = NULL// _Ƃ̋i[obt@
								) ;								// 򖗃GtFNgQ̏ꏊw^
extern s8 ReleaseBlood2Effect( EFFECT *Effect ) ;				// 򖗃GtFNgQ̌ns
extern s8 MoveBlood2Effect( EFFECT *Effect ) ;					// 򖗃GtFNgQPt[
extern s8 DrawBlood2Effect( EFFECT *Effect ) ;					// 򖗃GtFNgQ`悷

extern s8 SetBlood2EffectDir( Vec Dir, bool flag = true ) ;		//  CreateBlood2Effect2 ō쐬錌򖗂QGtFNǧw肷
extern s8 SetBlood2EffectColorRand( u8 ColorRand ) ;			// 򖗃GtFNgQ̐F_lݒ肷
extern s8 SetBlood2EffectSize( f32 Size ) ;						// TCY̐ݒ

#endif