///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBullet
//
// YK7EffectBullet.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/10/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectBullet.h"
#include "./YK7File.h"
#include "./YK7EffectSmoke2.h"
#include "./YK7EffectDamageBlood.h"
#include "./YK7EffectExplode.h"
#include "./YK7EffectSeenSound.h"
#include "./YK7EffectMuzzle.h"
#include "./YK7EffectWhirl.h"
#include "./YK7EffectSmoke.h"
#include "./YK7EffectStaticData.h"
#include "../Wat/WK7Light.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_BULLET]

#define KVN_MAXSPEED	(158 * 0.01F)
#define KVN_ROTSPEED	(PI/4.0F)
#define KVN_GRAVITY		(150 * 0.001F)

#define BULLETMARK_TEXPATH	"/Yam/Effect/BulletMark/GunBrole.BIN"

// data -----------------------------------------


// Cg`֌W
#include "..\Wat\K7App.h"
#include "..\Wat\WK7GameInfo.h"

 static  HSD_WObjDesc infinite_light_pos_wobjdesc = {
	NULL,                                    	/* class name */
	{ 3.0000f, 5.0000f, 3.0000f },	   	   		/* wobj position */
//	{ 1.57F, -0.96F, 3.54F },
	NULL,	                                   	/* robj Ή */
  };
 static  float shininess = 16.000000f;
 static  HSD_LightDesc infinite_light = {
	NULL, 									   	/* class name */
	NULL, 									  	/* N */
	LOBJ_SPECULAR|LOBJ_DIFFUSE|LOBJ_INFINITE,	/* flags */
	0x00,					 					/* attnflags */
//	{ 128, 128, 128, 128 },                  	/* ligh color */
	{ 255, 255, 255, 255 },                  	/* ligh color */
	&infinite_light_pos_wobjdesc,		   		/* position */
	NULL,					   					/* interest */
	&shininess,                              	/* shininess */
  };

  /*
   * ArGgCg
   */
 static  HSD_LightDesc amb_light = {
	NULL,                                    /* class name */
	&infinite_light,                         /* N */
	LOBJ_DIFFUSE,                            /* flags */
	0,                                       /* attnflags */
	{ 76, 76, 76, 0xff },                    /* color */
	NULL,                                    /* pos */
	NULL,                                    /* interest */
	NULL,
  };

  static WK7Light			*Light;


BULLETUNION btu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// eGtFNg̋ʃf[^
extern s8 InitBulletData( void )
{
	MEMINIT( btu ) ;
	
//	btu.light = WK7Light::Create(&amb_light,4,0);			// Cg

	// e}[NeNX`̃ZbgAbv
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_GunBrole ), &btu.MarkTex ) ;
	
	return 0 ;
}

// eGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckBulletData( void )
{
	return TRUE ;
}

// eGtFNg̋ʃf[^n
extern s8 EndBulletData( void )
{
//	GHM_SAFE_DELETE(btu.light);						// Cg̏I

	// eNX`̉
	TexRelease( &btu.MarkTex ) ;

	MEMINIT( btu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// eGtFNg쐬
extern EFFECT *CreateBulletEffect(
								BL_TYPE type,					// ehc
								Vec pos, 						// qbgW
								WK7JObj *JObj,					// Ώۂ WK7JObj
								f32 YukaY,						// ̍
								f32 Size,						// TCY
								s32 Priority )
{
	EFFECT *Effect ;
	BULLETEFFECT *bt ;
	
	// Vef[^쐬
	Effect = AddEffectData( EFF_BULLET, (void**)&bt, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// [	
	memset( bt, 0, sizeof( BULLETEFFECT ) ) ;

	bt->yukay = YukaY ;	
	bt->type = type ;
	bt->pos = pos ;
	bt->mod = 0 ;
	bt->con = 0 ;
	bt->drawrot = GetRandFNum( PI_2 ) ;
	bt->eff1 = NULL ;
	bt->eff2 = NULL ;
	bt->JObj = JObj ;
	bt->model = NULL ;
	bt->alpha = 1.0F ;
	bt->Size = Size ;

	switch( type )
	{
	default :
	case BL_INV_NRM :
	case BL_INV_NRM_RED :
		GXColor c1, c2 ;
		
		if ( type == BL_INV_NRM_RED ){
			*((u32 *)&c1) = CMK( 0xff, 0x99, 0x33, 0 	) ;	//
			*((u32 *)&c2) = CMK( 0xff, 0x66, 0x00, 255	) ; //O
		}else{
			*((u32 *)&c1) = CMK( 255, 125, 57, 0 ) ;
			*((u32 *)&c2) = CMK( 240, 255, 255, 255 ) ;
		}
		
		CreateSeenSoundEffect( pos,			// W
								0,			// 쐬҂
								0,			// \
								39 * 0.01F,	// 鑬x
								100 * 0.01F,// 
								c1, c2,		// F
								94 * 0.01F,	// Xs[h
								true ) ;	// L鑬x
		DeleteEffect( Effect ) ;
		return NULL ;
		
	case BL_INV_MSK_NRM :
	case BL_INV_MSK_ELC :
		{
			GXColor Color ;
			
			*((u32 *)&Color) = CMK( 64,64,64,255 ) ;

//	static bool smokePlay = false;
//	static int smokeNum = 274;
//				if ( smokePlay ){
			CreateSmokeEffect( 1,
								pos,
								221 * 0.1F,		// Power
								50 * 0.01F, 40 * 0.01F,		// HPow  VPow
								0.0F,
//								smokeNum,			// Num
								274,			// Num
								(Vec){0.0F,0.0F,0.0F}, 0.0F,
								PI * 50 * 0.1F / 180.0F, PI * 20 * 0.1F / 180.0F, 	// RotMaxSp   RotMinSp
								143 * 0.1F, 73 * 0.1F,		// MaxSize  MinSize 
								143 * 0.1F, 73 * 0.1F,		// MaxSize  MinSize 
								51, 39,		// MaxLifeT  MinLifeT
								30 * 1.0F,	// AreaSize
								Color, Color, Color, 255,	// A
								PI * 79 / 180.0F, 0.0F,		// MaxOir
								FALSE,
								5, 		// StopTime
								89 * 0.01F,		// MoveArea
								FALSE,
								0,		
								Color, Color, Color,
								30 * 0.01F		// LowSpeed
							 ) ;
//				}
		}
		DeleteEffect( Effect ) ;
		return NULL ;

		
	case BL_INV_MSK_CNV :
		CreateWhirlEffect( pos,					// ʂւ܂RcW
							604 * 0.1F,					// ˂ꂳ锼a
							30 * 0.1F,		// ˂ꂳ锼ãXs[h
							5 * 0.1F * PI_2,					// ˂ꂳpx
							465 * 0.1F,				// ˂ꂳ鑬x(100.0˂ꂫ WhirlTimeÔƂ̂ݗL)
							44 * 0.1F,			// ˂ꂳx(WhirlTimeÔƂ̂ݗL)
							119,				// ˂ꂳ鎞 
							5,				// ˂ꂫĂ̒~
							0 * 0.1F,		// ˂ꂪɖ߂鑬x(WhirlFinishTimeÔƂ̂ݗL)
							490 * 0.01F,	// ˂ꂪɖ߂x(WhirlFinishTimeÔƂ̂ݗL)
							0					// ˂ꂩ߂܂ł̎
							 ) ;					// ʂ˂GtFNg쐬
/*
		CreateWhirlEffect( pos,					// ʂւ܂RcW
							604 * 0.1F,					// ˂ꂳ锼a
							30 * 0.1F,		// ˂ꂳ锼ãXs[h
							20 * 0.1F * PI_2,					// ˂ꂳpx
							465 * 0.1F,				// ˂ꂳ鑬x(100.0˂ꂫ WhirlTimeÔƂ̂ݗL)
							44 * 0.1F,			// ˂ꂳx(WhirlTimeÔƂ̂ݗL)
							119,				// ˂ꂳ鎞 
							5,				// ˂ꂫĂ̒~
							0 * 0.1F,		// ˂ꂪɖ߂鑬x(WhirlFinishTimeÔƂ̂ݗL)
							490 * 0.01F,	// ˂ꂪɖ߂x(WhirlFinishTimeÔƂ̂ݗL)
							0					// ˂ꂩ߂܂ł̎
							 ) ;					// ʂ˂GtFNg쐬
*/
		DeleteEffect( Effect ) ;
		return NULL ;
		
	case BL_INV_KVN :
	case BL_INV_KVN_RED :
		GXColor cc ;
		
		if ( type == BL_INV_KVN_RED ){
			*((u32 *)&cc) = CMK( 0xff, 0x66, 0x00, 255	);
			CreateDamageBloodEffect( DMGBLD_KVN_INVALID, pos, (u32 *)&cc ) ;
		}else{
			CreateDamageBloodEffect( DMGBLD_KVN_INVALID, pos ) ;
		}

		bt->model = CopyGunModel( GUN_THKNIFE_R ) ;
		if( bt->model != NULL )
		{
			bt->model->SetPosition( pos ) ;
			bt->rot.x = GetRandFNum( PI_2 ) ;
			bt->rot.y = GetRandFNum( PI_2 ) ;
			bt->rot.z = GetRandFNum( PI_2 ) ;
			bt->rotspeed.x = GetRandFNum( KVN_ROTSPEED * 2.0F ) - KVN_ROTSPEED ;
			bt->rotspeed.y = GetRandFNum( KVN_ROTSPEED * 2.0F ) - KVN_ROTSPEED ;
			bt->rotspeed.z = GetRandFNum( KVN_ROTSPEED * 2.0F ) - KVN_ROTSPEED ;
			bt->speed.x = GetRandFNum( KVN_MAXSPEED * 2.0F ) - KVN_MAXSPEED ;
			bt->speed.y = GetRandFNum( KVN_MAXSPEED * 2.0F ) - KVN_MAXSPEED ;
			bt->speed.z = GetRandFNum( KVN_MAXSPEED * 2.0F ) - KVN_MAXSPEED ;
		}
		return NULL ;
		
	case BL_MARK :
		{
			Vec CPos, temp ;
			
			HSD_CObjGetEyePosition( GetEffectCamera(), &CPos ) ;
			VECSubtract( &bt->pos, &CPos, &temp ) ;
			VECNormalize( &temp, &temp ) ;
			VECScale( &temp, &temp, -0.2F ) ;
			VECAdd( &bt->pos, &temp, &bt->pos ) ;
		}
		break ;
	}

	// I
	return Effect ;
}

// eGtFNǧns
extern s8 ReleaseBulletEffect( EFFECT *Effect )
{
	BULLETEFFECT *bt = ( BULLETEFFECT * )Effect->Data ;
	
	if( CheckEffectValidState( bt->eff1, bt->eff1id ) == TRUE ) DeleteEffect( bt->eff1 ) ;
	if( CheckEffectValidState( bt->eff2, bt->eff2id ) == TRUE ) DeleteEffect( bt->eff2 ) ;
	if( bt->model != NULL ) delete bt->model ;
	
	// I
	return 0 ;
}

// eGtFNgPt[
extern s8 MoveBulletEffect( EFFECT *Effect )
{
	BULLETEFFECT *bt = ( BULLETEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	switch( bt->type )
	{
	case BL_INV_KVN :	
	case BL_INV_KVN_RED :	
		if( Effect->DelReqFlag == TRUE )
		{
			DeleteEffect( Effect ) ; 
			return 0 ;
		}

		// iCtf̈ړ
		if( bt->model == NULL ) return 0 ;
		bt->pos.x += bt->speed.x ;
		bt->pos.y += bt->speed.y ;
		bt->pos.z += bt->speed.z ;
		
		bt->rot.x += bt->rotspeed.x ;
		bt->rot.y += bt->rotspeed.y ;
		bt->rot.z += bt->rotspeed.z ;
		
		bt->model->SetRotation( bt->rot ) ;
		bt->model->SetPosition( bt->pos ) ;

		bt->speed.y -= KVN_GRAVITY ;
		if( bt->pos.y < bt->yukay )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}

		if( bt->model != NULL )
		{
			bt->model->FrameProcess() ;
		}
		break ;
		
	case BL_MARK :		// e}[N
	
		switch( bt->mod )
		{
		case 0 :	// ҂
			bt->alpha = 1.0F ;
			bt->con ++ ;
			if( bt->con < 120 ) break ;
			bt->mod ++ ;
			bt->con = 0 ;
			break ;
			
		case 1 :	// tF[hAEg
			bt->alpha -= 0.07F ;
			if( bt->alpha > 0.0F ) break ;
			bt->alpha = 0.0F ;
			bt->mod ++ ;
			break ;
			
		case 2 :	// 폜
			DeleteEffect( Effect ) ;
			break ;
		}
		break ;
	}
	
	// I
	return 0 ;
}

// eGtFNg`悷
extern s8 DrawBulletEffect( EFFECT *Effect )
{
	BULLETEFFECT *bt = ( BULLETEFFECT * )Effect->Data ;

	switch( bt->type )
	{
	case BL_INV_KVN :	
	case BL_INV_KVN_RED :	
		if( bt->model != NULL )
		{
			// 	_O
			HSD_StateInvalidate( HSD_STATE_ALL ) ;
			HSD_CObjSetCurrent( GetEffectCamera() ) ;
			WK7Light::DispStart();
	//		btu.light->SetPosition( &(Vec){1.0F,-1.0F,1.0F} ) ;
	//		btu.light->Disp() ;
			WK7Light::DispAll();
			WK7Light::DispEnd();
			
			// `
			bt->model->RenderProcess() ;
			
			// _OI
			HSD_CObjEndCurrent() ;
		}
		break ;
		
	case BL_MARK :
		{
			Mtx mtx ;
			
			EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
			EffectGetInvViewMatrix( mtx ) ;
//			GXSetZMode( GX_FALSE, GX_LEQUAL, GX_DISABLE ) ;
			DrawExTex3D( mtx, 1.0F, 1.0F, bt->drawrot, bt->Size, bt->pos, &btu.MarkTex, CMK( 0,0,0,255 * bt->alpha ) ) ;
		}
		break ;
	}

	// I
	return 0 ;
}

/*
const u16 _SBTable[][20] =
{
	{	// 
		100, 10, 128, 0, 0,
		255, 35, 68, 30, 30,

		10, 10, 8, 10, 20,
		0, 0,
	},

	{	// 
		100, 3, 128, 0, 0,
		255, 35, 68, 30, 30,

		10, 10, 8, 10, 20,
		0, 0,
	},
} ;


// eGtFNg쐬
extern EFFECT *CreateBulletEffect(
								u8 type, Vec pos,
								s32 dietime,				// S
								s32 Priority )
{
	if( type < 2 )
	{
#ifdef	YAMADADEBUG
		OSReport( "	{\n" ) ;
		OSReport( "		%d, %d, %d, %d, %d,\n", PRM[0], PRM[1], PRM[2], PRM[3], PRM[4] ) ;
		OSReport( "		%d, %d, %d, %d, %d,\n", PRM[5], PRM[6], PRM[7], PRM[8], PRM[9] ) ;
		OSReport( "\n" ) ;
		OSReport( "		%d, %d, %d, %d, %d,\n", PRM[10], PRM[11], PRM[12], PRM[13], PRM[14] ) ;
		OSReport( "		%d, %d,\n", PRM[15], PRM[16] ) ;
		OSReport( "	},\n" ) ;
#endif
	
		if( type == 0 )
			return CreateBulletEffect(
									PRM[0] * 10,				// ő吔
									
									pos,				// ʒu
									PRM[1] * 1.0F,			// TCY
									CMK( PRM[2],PRM[3],PRM[4],PRM[5] ),				// F
									
								//	f32 maxsize, minsize ;	// őTCYƍŏTCY
									PRM[6] * 0.1F,				// TCY
									PRM[7] * 0.01F, PRM[8] * 0.01F,	// ő呬xŏx
									PRM[9] * 0.01F, PRM[10] * 0.01F, 		// ㏸ő僿xƍŏx
									PRM[11] * 0.01F, PRM[12] * 0.01F,	// ~ő僿xƍŏx
									PRM[13] * 0.1F,			// őAt@l
									1.0F / PRM[14],			// 쐬[g
									(bool)false,			// W^Cv
									dietime, 
									Priority ) ;			// eGtFNg쐬
		else
			return CreateBulletEffect(
									PRM[0] * 10,				// ő吔
									
									pos,				// ʒu
									PRM[1] * 1.0F,			// TCY
									CMK( PRM[2],PRM[3],PRM[4],PRM[5] ),				// F
									
								//	f32 maxsize, minsize ;	// őTCYƍŏTCY
									PRM[6] * 0.1F,				// TCY
									PRM[7] * 0.01F, PRM[8] * 0.01F,	// ő呬xŏx
									PRM[9] * 0.01F, PRM[10] * 0.01F, 		// ㏸ő僿xƍŏx
									PRM[11] * 0.01F, PRM[12] * 0.01F,	// ~ő僿xƍŏx
									PRM[13] * 0.1F,			// őAt@l
									1.0F / PRM[14],			// 쐬[g
									(bool)true,			// W^Cv
									dietime,
									Priority ) ;			// eGtFNg쐬
	}
	else
	{
		type -= 2 ;

		return CreateBulletEffect(
								_SBTable[type][0] * 10,				// ő吔
								
								pos,				// ʒu
								_SBTable[type][1] * 1.0F,			// TCY
								CMK( _SBTable[type][2],_SBTable[type][3],_SBTable[type][4],_SBTable[type][5] ),				// F
								
							//	f32 maxsize, minsize ;	// őTCYƍŏTCY
								_SBTable[type][6] * 0.1F,				// TCY
								_SBTable[type][7] * 0.01F, _SBTable[type][8] * 0.01F,	// ő呬xŏx
								_SBTable[type][9] * 0.01F, _SBTable[type][10] * 0.01F, 		// ㏸ő僿xƍŏx
								_SBTable[type][11] * 0.01F, _SBTable[type][12] * 0.01F,	// ~ő僿xƍŏx
								_SBTable[type][13] * 0.1F,			// őAt@l
								1.0F / _SBTable[type][14],			// 쐬[g
								(bool)true,			// W^Cv
								dietime,
								
								Priority ) ;			// eGtFNg쐬
	}
	
	return NULL ;
}
*/

/*
// eGtFNg̔WύX
extern s8 SetBulletEffectPos( EFFECT *Effect, Vec pos )
{
	BULLETEFFECT *bt = ( BULLETEFFECT * )Effect->Data ;
	
	bt->pos = pos ;

	// I
	return 0 ;	
}
*/

// Cg̎擾
extern WK7Light *GetBulletLight( void )
{
	return btu.light ;
}

