///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCamera
//
// YK7EffectCamera.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/17/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectCamera.h"
#include "../matsu/mk7Sound.h"
#include "../Wat/WK7Cam.h"
#include "./YK7EffectNoise.h"
#include "./YK7EffectScanLine.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

static CAMERAUNION CMUnion ;

// function proto type --------------------------

// function code --------------------------------

// ĎJGtFNg̋ʃf[^
extern s8 InitCameraData( void )
{
	MEMINIT(CMUnion) ;

	// I
	return 0 ;
}

// ĎJGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckCameraData( void )
{
	return TRUE ;
}


// ĎJGtFNg̋ʃf[^n
extern s8 EndCameraData( void )
{
	MEMINIT(CMUnion) ;

	// I
	return 0 ;
}

// ĎJ̃GtFNg쐬
extern EFFECT *CreateCameraEffect( s32 Priority )
{
	EFFECT *Effect ;
	CAMERAEFFECT *Camera ;
	EFFECT *ScanLine, *Noise ;

	// XLCGtFNgIuWFNg쐬
	ScanLine = CreateScanLineEffect( (s8)VParam[ED_SCANLINE][0], (u8)VParam[ED_SCANLINE][1], Priority ) ;
	if( ScanLine == NULL ) return NULL ;
	
	// mCYGtFNgIuWFNg쐬
	Noise = CreateNoiseEffect( FALSE, false, Priority ) ;
	if( Noise == NULL )
	{
		DeleteEffect( ScanLine ) ;
		return NULL ;
	}

	// VĎJf[^쐬
	Effect = AddEffectData( EFF_CAMERA, (void**)&Camera, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// f[^
	SetEffectIndeManageFlag( Noise, TRUE ) ;
	SetEffectIndeManageFlag( ScanLine, TRUE ) ;
	Camera->Noise = Noise ;
	Camera->ScanLine = ScanLine ;
	Camera->SoundFlag = FALSE ;

	// I
	return Effect ;
}


// ĎJ̃GtFNǧns
extern s8 ReleaseCameraEffect( EFFECT *Effect )
{
	CAMERAEFFECT *Camera = ( CAMERAEFFECT * )Effect->Data ;

	// XLCGtFNgƍ쐬mCYGtFNg폜
	DeleteEffect( Camera->Noise ) ;
	DeleteEffect( Camera->ScanLine ) ;

	// I
	return 0 ;
}

// ĎJ̃GtFNgt[ړ
extern s8 MoveCameraEffect( EFFECT *Effect )
{
	CAMERAEFFECT *Camera = ( CAMERAEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// mCY쐬tOĂꍇ̓mCY쐬鏈s
	if( Camera->NoiseCreateFlag == TRUE )
	{
		Camera->NoiseCounter ++ ;
		if( Camera->NoiseCounter > (s32)VParam[ED_CAMERA][0] )
		{
			AddNoiseLine( Camera->Noise, (u8)VParam[ED_NOISE][0], VParam[ED_NOISE][1],
						 VParam[ED_NOISE][2], VParam[ED_NOISE][3], Camera->SoundFlag == FALSE ? SFX_SYS_CHARA_CHANGE : -1 ) ;
			Camera->SoundFlag = TRUE ;
			Camera->NoiseCounter = 0 ;
		}
	}
	
	// t[vZX
	MoveEffect( Camera->Noise ) ;
	MoveEffect( Camera->ScanLine ) ;

	// I
	return 0 ;
}					

// ĎJ̃GtFNg`悷
extern s8 DrawCameraEffect( EFFECT *Effect )
{
	CAMERAEFFECT *Camera = ( CAMERAEFFECT * )Effect->Data ;

	// VUÖ̐ݒ
	{
		HSD_RectU16 sc_rect;
		WK7CAM->GetScissor(sc_rect);
		GXSetScissor(sc_rect.xmin,sc_rect.ymin,(u32)(sc_rect.xmax-sc_rect.xmin),(u32)(sc_rect.ymax-sc_rect.ymin));
		GXSetViewport(0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);	
	}

	// ̕`
	DrawEffect( Camera->ScanLine ) ;
	
	// ʂ
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;	// `̏
	DrawBox( 0, 0, SCW, SCH, CMK( VParam[ED_CAMERA][1], VParam[ED_CAMERA][2], VParam[ED_CAMERA][3], VParam[ED_CAMERA][4] ) ) ;
	
	// mCY̕`
	DrawEffect( Camera->Noise ) ;
	
	// I
	return 0 ;
}					

// mCY쐬邩ǂύX
extern s8 SetCameraNoiseFlag( EFFECT *Effect, s8 NoiseFlag )
{
	CAMERAEFFECT *Camera = ( CAMERAEFFECT * )Effect->Data ;

	// tOۑ
	Camera->NoiseCreateFlag = NoiseFlag ;
	Camera->NoiseCounter = (s32)( VParam[ED_CAMERA][0] - 1 ) ;
	
	// I
	return 0 ;
}					
	





