///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCartridge
//
// YK7EffectCartridge.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/28/2003
//
//////////////////////////////////////////////////////////////////////////////

//#define _DBG
//#define _DBG2
#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectCartridge.h"
#include "./YK7Break.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

// J[gbW
const char *CartridgeName[CART_NUM] =
{
	"Cartridge_9mm", "Cartridge_50BMG"
} ;

// datatype -------------------------------------

// data -----------------------------------------

CARTRIDGEUNION CarUnion ;
static WK7Archive		*pItemArchive[CART_NUM] = { NULL, };

// function proto type --------------------------

// function code --------------------------------

// J[gbWGtFNg̋ʃf[^
extern s8 InitCartridgeData( void )
{
	u32 i ;

	MEMINIT( CarUnion ) ;

	// J[gbW̃A[JCut@Cǂݍ
	for( i = 0 ; i < CART_NUM ; i ++ )
	{
//		if( *(CartFileName[i]) != '\0' )
		{
			WK7Item::CreateStaticArchive(K7ITEMID(500,i));
			pItemArchive[i] = WK7Archive::Find(K7OBJTYPE_ITEM,K7ITEMID(500,i));
		}
	}

	// I
	return 0 ;
}

// J[gbWGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckCartridgeData( void )
{
	return TRUE ;
}


// J[gbWGtFNg̋ʃf[^n
extern s8 EndCartridgeData( void )
{
	int		i;
	for( i = 0 ; i < CART_NUM ; i ++ )
	{
		if( pItemArchive[i]==NULL ){
			continue;
		}
		pItemArchive[i]->SetStatic(false);
		delete pItemArchive[i];
		pItemArchive[i] = NULL;
	}
	// I
	return 0 ;
}


// J[gbW̃GtFNg쐬
extern EFFECT *CreateCartridgeEffect( WK7JObj *CartridgeJObj, f32 YukaY, s32 Sound, s32 Priority )
{
	EFFECT *Effect ;
	CARTRIDGEEFFECT *Cartridge ;
#ifndef _DBG2	
	Vec V ;
	Mtx mtx ;
#endif
	u32 CartID ;
	u8 Sound3DFlag ;
	
	Sound3DFlag = CarUnion.Sound3DFlag ;

	// J[gbWIuWFNgG[
	CartID = GetCartridgeJObj( CartridgeJObj, &CartridgeJObj ) ;
	if( CartridgeJObj == NULL ) return NULL ;

	// w̏ẽJ[gbWI
//	if( CarUnion.CartModel[GunID] == NULL ) return 0 ;

	// VJ[gbWf[^쐬
	Effect = AddEffectData( EFF_CARTRIDGE, (void**)&Cartridge, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// f[^
//	Cartridge->CartModel = CarUnion.CartModel[GunID]->CreateModel() ;

#ifndef _DBG
	// J[gbW̃ACe擾
	Cartridge->CartItem = WK7RenderObj::CreateItem(K7ITEMID(500,CartID)) ;
//	Cartridge->CartItem = WK7RenderObj::CreateItem(K7ITEMID(500,(u32)1)) ;
	if( Cartridge->CartItem == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
	Cartridge->CartItem->SetRenderFlag(true);
//	Cartridge->CartItem->SetRenderFlag(false);

	// f擾
	Cartridge->CartModel = Cartridge->CartItem->GetModel() ;
	if( Cartridge->CartModel == NULL )
	{
		// f擾łȂ폜
		DeleteEffect( Effect ) ;
		return NULL ;
	}
		
#endif

#ifndef _DBG2	
	// ̑̃f[^
	Cartridge->YukaY = YukaY ;
//	Cartridge->Point = CartridgeJObj->GetJObj()->translate ;
	HSD_JObjSetupMatrix( CartridgeJObj->GetJObj() ) ;
	Cartridge->Point.x = CartridgeJObj->GetJObj()->mtx[0][3] ;
	Cartridge->Point.y = CartridgeJObj->GetJObj()->mtx[1][3] ;
	Cartridge->Point.z = CartridgeJObj->GetJObj()->mtx[2][3] ;
	Cartridge->Counter = 0 ;
	Cartridge->Sound = Sound ;
	Cartridge->Flag = FALSE ;
	Cartridge->Sound3DFlag = Sound3DFlag ;
#endif
	
	// f̃Xe[^XZbg
	{
#ifndef _DBG2	
		Vec Rot = { 0.0F, 0.0F, 0.0F } ;
#endif
	
#ifndef _DBG
#ifndef _DBG2	
		// |WṼZbg
		Cartridge->CartModel->SetPosition( &Cartridge->Point ) ;
#endif
#endif

#ifndef _DBG2	
		// ]擾EfɃZbg
//		CartridgeJObj->GetRotation( &Rot ) ;
		Rot.x += VParam[ED_MUZ][3] * 0.1F + rand() * 1.0F / RAND_MAX ;
		Rot.y += VParam[ED_MUZ][4] * 0.1F + rand() * 1.0F / RAND_MAX ;
		Rot.z += VParam[ED_MUZ][5] * 0.1F + rand() * 1.0F / RAND_MAX ;
#endif

#ifndef _DBG
#ifndef _DBG2	
		Cartridge->CartModel->SetRotation( &Rot ) ;
#endif
#endif 
	}

	// ]擾
	{
#ifndef _DBG2	
		Mtx *m = &(CartridgeJObj->GetJObj()->mtx) ;
//		memcpy( mtx, CartridgeJObj->GetJObj()->mtx, sizeof( mtx ) ) ;
	
		mtx[0][0] = (*m)[0][0] ; mtx[0][1] = (*m)[0][1] ; mtx[0][2] = (*m)[0][2] ; 
		mtx[1][0] = (*m)[1][0] ; mtx[1][1] = (*m)[1][1] ; mtx[1][2] = (*m)[1][2] ; 
		mtx[2][0] = (*m)[2][0] ; mtx[2][1] = (*m)[2][1] ; mtx[2][2] = (*m)[2][2] ; 
		mtx[0][3] = 0.0F ;	mtx[1][3] = 0.0F ;	mtx[2][3] = 0.0F ;
#endif
	}
	
#ifndef _DBG2	
	// Xs[h̏
	{
		f32 f/*, sp*/ ;
	
		// xNg𓾂
		V.x = 0.0F ;	V.y = 1.0F ;	V.z = 0.0F ;
		MTXMultVec( mtx, &V, &Cartridge->Speed ) ;
		VECNormalize( &Cartridge->Speed, &Cartridge->Speed ) ;

		// KɃXs[h蓖Ă
//		f = rand() * 1.0F / RAND_MAX + VParam[ED_MUZ][1] ;
		Cartridge->Speed.x += ( rand() * (f32)VParam[ED_MUZ][12] / RAND_MAX - (f32)VParam[ED_MUZ][12] / 2.0F ) * 0.01F ;
		Cartridge->Speed.y += ( rand() * (f32)VParam[ED_MUZ][12] / RAND_MAX - (f32)VParam[ED_MUZ][12] / 2.0F ) * 0.01F ;
		Cartridge->Speed.z += ( rand() * (f32)VParam[ED_MUZ][12] / RAND_MAX - (f32)VParam[ED_MUZ][12] / 2.0F ) * 0.01F ;
		VECNormalize( &Cartridge->Speed, &Cartridge->Speed ) ;
		f = VParam[ED_MUZ][14] * 0.01F ;
		Cartridge->Speed.x *= f ;
		Cartridge->Speed.y *= f ;
		Cartridge->Speed.z *= f ;
	}

	// ]x̃Zbg
	{
		Cartridge->RotSp.x = PI_2 / 360.0F * 3.0F ;
		Cartridge->RotSp.y = 0.0F ;
		Cartridge->RotSp.z = 0.0F ;
		MTXMultVec( mtx, &Cartridge->RotSp, &Cartridge->RotSp ) ;
	}
#endif
	
	// I
	return Effect ;
}

// J[gbW̃GtFNǧns
extern s8 ReleaseCartridgeEffect( EFFECT *Effect )
{
	CARTRIDGEEFFECT *CartridgeEffect = ( CARTRIDGEEFFECT * )Effect->Data ;
	
	// J[gbW̃f폜
//	delete CartridgeEffect->CartModel ;

#ifndef _DBG
	// J[gbWACe폜
	if( CartridgeEffect->CartItem != NULL )
		delete CartridgeEffect->CartItem ;
#endif

	// I
	return 0 ;
}

// J[gbW̃GtFNgPt[
extern s8 MoveCartridgeEffect( EFFECT *Effect )
{
	CARTRIDGEEFFECT *Cart = ( CARTRIDGEEFFECT * )Effect->Data ;
#ifndef _DBG2	
	Vec Rot ;
#endif
	
	// JE^[
	Cart->Counter ++ ;

#ifndef _DBG2	
#ifndef _DBG
	// ]
	Cart->CartModel->GetRotation( &Rot ) ;
#endif
	Rot.x += -VParam[ED_MUZ][6] * 0.01F ;
	Rot.y += VParam[ED_MUZ][7] * 0.01F ;
	Rot.z += VParam[ED_MUZ][8] * 0.01F ;
#ifndef _DBG
	Cart->CartModel->SetRotation( &Rot ) ;
#endif
	
#ifndef _DBG2	
	// ړ
	if( Cart->Counter == 1 )
	{
		Cart->Point.x += Cart->Speed.x * 0.3F ;
		Cart->Point.y += Cart->Speed.y * 0.3F ;
		Cart->Point.z += Cart->Speed.z * 0.3F ;
	}
	else
	{
		Cart->Point.x += Cart->Speed.x ;
		Cart->Point.y += Cart->Speed.y ;
		Cart->Point.z += Cart->Speed.z ;
	}

	// x
	Cart->Speed.y -= VParam[ED_MUZ][2] * 0.01F ;
	
	// ɗ璵˕Ԃ
	if( Cart->Point.y < Cart->YukaY )
	{
		if( Cart->Flag < 1 )
		{
			Cart->Flag ++ ;
			if( GetEffectSoundOffFlag() == FALSE && Cart->Sound >= 0 )
			{
				if( Cart->Sound3DFlag )
					PlayEffectSE3D( (s32)Cart->Sound/*SFX_PC_KED_YAKKYOU*//*SFX_PC_CAT_YAKKYOU*/, Cart->Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
				else
					PlayEffectSE( (s32)Cart->Sound ) ;
			}
		}
		Cart->Speed.y *= -0.3 ;
		Cart->Point.y = Cart->YukaY ;
	}
#endif

#ifndef _DBG
	// |WṼZbg
	Cart->CartModel->SetPosition( &Cart->Point ) ;
#endif
#endif

	// JE^莞ԂI
	if( Cart->Counter == VParam[ED_MUZ][9] )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// I
	return 0 ;
}

// J[gbW̃GtFNg`悷
extern s8 DrawCartridgeEffect( EFFECT *Effect )
{
	CARTRIDGEEFFECT *CartridgeEffect = ( CARTRIDGEEFFECT * )Effect->Data ;

	// ɉȂ	

	// I
	return 0 ;
}

// J[gbW WK7JObj TĎ擾
extern s8 GetCartridgeJObj( WK7JObj *JObj, WK7JObj **Dest )
{
	WK7JObj *CartridgeJObj ;
	s8 CartID ;
	
	CartridgeJObj = NULL ;
	for( CartID = 0 ; CartID < CART_NUM && ( CartridgeJObj = JObj->GetObj( CartridgeName[CartID] ) ) == NULL ; CartID ++ ){}
	
	*Dest = CartridgeJObj ;
	
	// I
	return CartID ;
}

// J[gbW 3D Đ邩ǂ̃tOZbg
extern s8 SetCartridgeSound3DFlag( bool Flag )
{
	CarUnion.Sound3DFlag = Flag ;
	
	return 0 ;
}

