///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCentLight2
//
// YK7EffectCentLight2.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/28/200
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectCentLight2.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectBillboard.h"

// define ---------------------------------------

// data type ------------------------------------

// data -----------------------------------------

static CENTLIGHT2UNION CLU ;
extern LINEUNION LUnion ;


// function proto type --------------------------

// function code --------------------------------

// WGtFNg̋ʃf[^
extern s8 InitCentLight2Data( void )
{
	MEMINIT(CLU) ;

	LoadBillboardImage( BILLID_SPFIRE2 ) ;
//	LoadBillboardImage( BILLID_LIGHT ) ;
	
	// I
	return 0 ;
}

// WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckCentLight2Data( void )
{
	if( CheckBillboardImageLoadState( BILLID_SPFIRE2 ) == FALSE ) return FALSE ;
//	if( CheckBillboardImageLoadState( BILLID_LIGHT ) == FALSE ) return FALSE ;
	return TRUE ;
}


// WGtFNg̋ʃf[^n
extern s8 EndCentLight2Data( void )
{
	ReleaseBillboardImage( BILLID_SPFIRE2 ) ;
//	ReleaseBillboardImage( BILLID_LIGHT ) ;

	MEMINIT(CLU) ;

	// I
	return 0 ;
}




// WGtFNg쐬
extern EFFECT *CreateCentLight2Effect(
						s32 MaxObjNum,					// IuWFNg̍ő吔

						Vec Pos,						// W	
						f32 MaxLen, f32 MinLen,			// ő勗ƍŒZ
						f32 MaxSize, f32 MinSize,		// őTCYƍŏTCY
						f32 Speed,						// x
						f32 CreateCost,					// 쐬RXg
						GXColor Color,					// F
						s32 Priority )
{
	EFFECT *Effect ;
	CENTLIGHT2EFFECT *cl ;
	CENTLIGHT2OBJECT *ob ;
	u32 i ;

	// eNX`ǂݍ܂ĂȂ牽I
	if( CheckLineData() == FALSE ) return 0 ;

	// IuWFNgۑ邽߂̃̈̊m
	if( ( ob = ( CENTLIGHT2OBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( CENTLIGHT2OBJECT ) * MaxObjNum ), "Y_ClObj" ) ) == NULL ) return NULL ;

	// VCf[^쐬
	Effect = AddEffectData( EFF_CENTLIGHT2, (void**)&cl, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( ob ) ;
		return NULL ;
	}

	// p[^ۑE
	cl->Obj			= ob ;
	cl->ObjNum 		= 0 ;
	cl->MaxObjNum 	= MaxObjNum ;
	cl->Pos 		= Pos ;
	cl->MaxLen		= MaxLen ;		cl->MinLen	= MinLen ;
	cl->MaxSize		= MaxSize ;		cl->MinSize	= MinSize ;
	cl->Color		= *((u32 *)&Color) ;
	cl->CreateCost	= CreateCost ;
	cl->Speed 		= Speed ;
	cl->CLSize		= 0.0F ;
	cl->CLRandSize	= 0.0F ;
	cl->CreateCounter = 0.0F ;
	cl->Alpha		= 1.0F ; 

	// IuWFNg̏	
	for( i = 0 ; i < MaxObjNum ; i ++, ob ++ ) ob->vflag = 0 ;

	// I
	return Effect ;
}

// WGtFNǧns
extern s8 ReleaseCentLight2Effect( EFFECT *Effect )
{
	CENTLIGHT2EFFECT *cl = ( CENTLIGHT2EFFECT * )Effect->Data ;

	// CIuWFNgi[pɊmۂĂ̈̊J
	if( cl->Obj != NULL ) CHKMEMFREE2( cl->Obj ) ;
	cl->Obj = NULL ;

	// I
	return 0 ;
}

// WGtFNgPt[
extern s8 MoveCentLight2Effect( EFFECT *Effect )
{
	CENTLIGHT2EFFECT *cl = ( CENTLIGHT2EFFECT * )Effect->Data ;
	CENTLIGHT2OBJECT *ob ;
	u32 i, num ;
	f32 oir, xz ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE && cl->ObjNum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// ׂẴCIuWFNg
	ob = cl->Obj ;
	num = (u32)cl->ObjNum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == 0 ) continue ;

		i ++ ;

		ob->len -= cl->Speed ;
		if( ob->len < 0.0F )
		{
			ob->vflag = 0 ;
			cl->ObjNum -- ;
		}
	}
	
	if( Effect->DelReqFlag == TRUE )
	{
		cl->Alpha -= 0.1F ;
		if( cl->Alpha < 0.0F )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}
	
	// 쐬
	if( Effect->DelReqFlag != TRUE ) cl->CreateCounter += 1.0F ;
	while( cl->CreateCounter >= cl->CreateCost && cl->ObjNum < cl->MaxObjNum )
	{
		cl->CreateCounter -= cl->CreateCost ;

		for( ob = cl->Obj ; ob->vflag == 1 ; ob ++ ){}

		ob->vflag 		= 1 ;
		ob->initlen = ob->len = GetRandF2Num( cl->MaxLen, cl->MinLen ) ;
		ob->size 		= GetRandF2Num( cl->MaxSize,	cl->MinSize ) ;
		
		xz = rand() * PI_2 / RAND_MAX ;
		oir = rand() * PI / RAND_MAX - PI / 2 ;
		ob->dir.x = COSF(oir) ;				ob->dir.y = SINF(oir) ;
		ob->dir.z = SINF(xz) * ob->dir.x ;	ob->dir.x = COSF(xz) * ob->dir.x ;

		cl->ObjNum ++ ;
	}

	// I
	return 0 ;
}

// WGtFNg`悷
extern s8 DrawCentLight2Effect( EFFECT *Effect )
{
	CENTLIGHT2EFFECT *cl = ( CENTLIGHT2EFFECT * )Effect->Data ;
	CENTLIGHT2OBJECT *ob ;
	u32 i, num, cr ;
	Mtx tmtx ;
	Vec tv[4], p ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX ) ;			// `̏
    GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_2, GX_FALSE, GX_TEVPREV ) ;
	GTLOAD( &GetBillboardImage( BILLID_SPFIRE2 )->TexObj ) ;						// eNX`̃[h
	EffectGetInvViewMatrix( tmtx ) ;											// ]ns̍쐬
	CreateBillVert( tmtx, tv ) ;												// r{[h_̍쐬

	// `揈	
	GBGN( GX_QUADS, cl->ObjNum * 4 ) ;
	{
		// IuWFNg̐JԂ
		ob = cl->Obj ;
		num = (u32)cl->ObjNum ;
		for( i = 0 ; i < num ; ob ++ )
		{
			if( ob->vflag == 0 ) continue ;
			
			i ++ ;
			
			cr = CMKC2( cl->Color, ( 1.0F - ob->len / ob->initlen ) * 255 * cl->Alpha ) ;

			p.x = ob->dir.x * ob->len + cl->Pos.x ;
			p.y = ob->dir.y * ob->len + cl->Pos.y ;
			p.z = ob->dir.z * ob->len + cl->Pos.z ;
			GP3( tv[0].x * ob->size + p.x, tv[0].y * ob->size + p.y, tv[0].z * ob->size + p.z ) ;
			GCX( cr ) ;		GT( 0.0F, 0.0F ) ;

			GP3( tv[1].x * ob->size + p.x, tv[1].y * ob->size + p.y, tv[1].z * ob->size + p.z ) ;
			GCX( cr ) ;		GT( 1.0F, 0.0F ) ;

			GP3( tv[2].x * ob->size + p.x, tv[2].y * ob->size + p.y, tv[2].z * ob->size + p.z ) ;
			GCX( cr ) ;		GT( 1.0F, 1.0F ) ;

			GP3( tv[3].x * ob->size + p.x, tv[3].y * ob->size + p.y, tv[3].z * ob->size + p.z ) ;
			GCX( cr ) ;		GT( 0.0F, 1.0F ) ;
		}
	}
	GEND() ;
	
	// Š̕`
	CreateBillVert( tmtx, tv, 1.0F, 1.0F, GetRandFNum( PI_2 ) ) ;
//	GTLOAD( &GetBillboardImage( BILLID_LIGHT )->TexObj ) ;
	GTLOAD( &GetBillboardImage( BILLID_SPFIRE2 )->TexObj ) ;						// eNX`̃[h
	for( i = 0 ; i < VParam[ED_CENTLIGHT2][13] ; i ++ )
		DrawTex3D( &tv[0], cl->CLSize + GetRandFNum( cl->CLRandSize ), cl->Pos, NULL, cl->Color ) ;

	// I
	return 0 ;
}



// GtFNg̍WύX
extern s8 SetCentLight2Pos( Vec Pos, EFFECT *Effect )
{
	CENTLIGHT2EFFECT *cl = ( CENTLIGHT2EFFECT * )Effect->Data ;

	cl->Pos = Pos ;
	
	// I
	return 0 ;
}

// Š̑傫ݒ肷
extern s8 SetCentLight2CentSize( f32 Size, f32 RandSize, EFFECT *Effect ) 
{
	CENTLIGHT2EFFECT *cl = ( CENTLIGHT2EFFECT * )Effect->Data ;

	cl->CLSize = Size ;
	cl->CLRandSize = RandSize ;
	
	// I
	return 0 ;
}

// xύX
extern s8 SetCentLight2Speed( f32 Speed, EFFECT *Effect )
{
	CENTLIGHT2EFFECT *cl = ( CENTLIGHT2EFFECT * )Effect->Data ;

	cl->Speed = Speed ;

	return 0 ;
}


