///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectConfetti
//
// YK7EffectConfetti.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectConfetti.h"
#include "./YK7Break.h"
#include "../Wat/WK7Archive.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define CONFETTITEX 			"/Yam/Effect/Confetti/Confetti.BIN"	// GtFNgp̃eNX`t@C
#define CONFETTITEX_DIVNUM		2									// eNX`̕
#define CONFETTITEX_ONES		(1.0F/(CONFETTITEX_DIVNUM))
#define CONFETTI_MODELNUM		4									// eNX`̑

#define CONFETTI_COLORNUM		6

// datatype -------------------------------------

// data -----------------------------------------

CONFETTIUNION ConfUnion ;

static GXColor ConfettiColor[CONFETTI_COLORNUM] =
{
	{ 255, 255, 255 }, { 191, 190, 205 }, { 241, 154, 213 }, { 234, 160, 106 },
	{ 235, 255, 89 }, { 255, 0, 0 }
} ;

// function proto type --------------------------

// function code --------------------------------

// GtFNg̋ʃf[^
extern s8 InitConfettiData( void )
{
	MEMINIT( ConfUnion ) ;

	// peNX`[ǂݍ
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_CONFETTI ), &ConfUnion.ConfettiTex ) ;
//	TexLoadSet( CONFETTITEX, &ConfUnion.ConfettiTex ) ;

	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckConfettiData( void )
{
	// t@C̓ǂݍ݂IĂȂ牽ɏI
//	if( TexLoadChk( &ConfUnion.ConfettiTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}


// GtFNg̋ʃf[^n
extern s8 EndConfettiData( void )
{
	// eNX`f[^j
	TexRelease( &ConfUnion.ConfettiTex ) ;

	MEMINIT( ConfUnion ) ;

	// I
	return 0 ;
}


// ̃GtFNg쐬
extern EFFECT *CreateConfettiEffect( s32 MaxNum, Vec Point,
									f32 MaxDownSpeed, f32 MinDownSpeed, 
									f32 Radius, f32 Size,
									f32 YukaY, f32 CreateY,
									GXColor *Color, s32 Priority )
{
	EFFECT *Effect ;
	CONFETTIEFFECT *Cf ;
	CONFETTIOBJECT *Ob ;

	// t@C̓ǂݍ݂IĂȂ牽ɏI
	if( CheckConfettiData() == FALSE ) return 0 ;

	// ̊m
	Ob = ( CONFETTIOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( CONFETTIOBJECT ) * MaxNum ), "Y_ConfettiObj" ) ;
	if( Ob == NULL ) return NULL ;
	memset( Ob, 0, sizeof( CONFETTIOBJECT ) * MaxNum ) ;

	// Vf[^쐬
	Effect = AddEffectData( EFF_CONFETTI, (void**)&Cf, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( Ob ) ;
		return NULL ;
	}

	// p[^ۑ
	Cf->ObjP = Ob ;
	Cf->MaxNum = MaxNum ;
	Cf->Counter = 0 ;

	Cf->Point = Point ;
	Cf->MinDownSpeed = MinDownSpeed ;
	Cf->MaxDownSpeed = MaxDownSpeed ;
	Cf->Radius = Radius ;
	Cf->Size = Size ;
	Cf->YukaY = YukaY ;
	Cf->CreateY = CreateY ;

	if( Color != NULL )
	{
		Cf->Color = *Color ;
	}
	else
	{
		Cf->Color.r = (u8)VParam[ED_CONFETTI][8] ;
		Cf->Color.g = (u8)VParam[ED_CONFETTI][9] ;
		Cf->Color.b = (u8)VParam[ED_CONFETTI][10] ;
	}
	
	// SIuWFNg
	{
		s32 i, MaxNum ;
		f32 hw, f, Angle, Ritu, MoveTime, AllTime, Ritu2 ;
		const u16 WaitT = VParam[ED_CONFETTI][12], FadeT = VParam[ED_CONFETTI][13] ;

		hw = ( Cf->Point.y + CreateY ) - YukaY  ;
		MoveTime = ( YukaY + Cf->Point.y ) / ( ( MaxDownSpeed + MinDownSpeed ) / 2.0F ) ;
		AllTime = MoveTime + FadeT + WaitT ;
		Ritu = MoveTime / AllTime ;
		Ritu2 = (f32)WaitT / ( FadeT + WaitT ) ;

		Ob = Cf->ObjP ;
		MaxNum = Cf->MaxNum ;
		for( i = 0 ; i < MaxNum ; i ++, Ob ++ )
		{
			Angle = rand() * PI_2 / RAND_MAX ;
			Ob->Point.z = Cf->Point.z + sinf( Angle ) * rand() * Radius / RAND_MAX ;
			Ob->Point.x = Cf->Point.x + cosf( Angle ) * rand() * Radius / RAND_MAX ;
			Ob->Speed.y = -( rand() * ( MaxDownSpeed - MinDownSpeed ) / RAND_MAX + MinDownSpeed ) ;
			Ob->Counter1 = (u16)( ( rand() % RAND_MAX ) * ( CONFETTI_MODELNUM * VParam[ED_CONFETTI][7] ) / RAND_MAX ) ;
			Ob->Color.r = (u8)( rand() * 255 / RAND_MAX ) ;
			Ob->Color.g = (u8)( rand() * 255 / RAND_MAX ) ;
			Ob->Color.b = (u8)( rand() * 255 / RAND_MAX ) ;
			Ob->ColorIndex = (u8)( rand() * CONFETTI_COLORNUM / RAND_MAX % CONFETTI_COLORNUM ) ;
			
			if( ( f = (f32)rand() / RAND_MAX ) < Ritu )
			{
				Ob->Point.y = ( f / Ritu ) * hw + YukaY ;
				Ob->WaitT = WaitT ;
				Ob->FadeT = FadeT ;
				Ob->a = 255 ;
			}
			else
			{
				f = ( f - Ritu ) / ( 1.0F - Ritu ) ;
				Ob->Point.y = YukaY ;
				if( f < Ritu2 )
				{
					Ob->WaitT = (u16)( WaitT * ( f / Ritu2 ) ) ;
					Ob->FadeT = FadeT ;
					Ob->a = 255 ;
				}
				else
				{
					f = ( f - Ritu2 ) / ( 1.0F - Ritu2 ) ;
					Ob->WaitT = 0 ;
					Ob->FadeT = (u16)( (f32)FadeT * f ) ;
					if( Ob->FadeT == 0 ) Ob->FadeT = 1 ;
					Ob->a = (u8)( 255 * Ob->FadeT / FadeT ) ;
				}				
			}
		}
	}

	// I
	return Effect ;
}

// ̃GtFNǧns
extern s8 ReleaseConfettiEffect( EFFECT *Effect )
{
	CONFETTIEFFECT *Cf = ( CONFETTIEFFECT * )Effect->Data ;

	// GtFNgIuWFNgp̃J
	CHKMEMFREE2( Cf->ObjP ) ;

	// I
	return 0 ;
}

// ̃GtFNgPt[
extern s8 MoveConfettiEffect( EFFECT *Effect )
{
	CONFETTIEFFECT *Cf = ( CONFETTIEFFECT * )Effect->Data ;
	u32 i ;
	const u32 Num = (u32)Cf->MaxNum, j = (u32)( CONFETTI_MODELNUM * VParam[ED_CONFETTI][7] ) ;
	const u16 WaitT = VParam[ED_CONFETTI][12], FadeT = VParam[ED_CONFETTI][13] ;
	f32 Angle ;
	const f32 Speed = Cf->MaxDownSpeed - Cf->MinDownSpeed ;
	CONFETTIOBJECT *Ob ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// SIuWFNg
	Ob = Cf->ObjP ;
	for( i = 0 ; i < Num ; i ++, Ob ++ )
	{
/*		Ob->Point.y += Ob->Speed.y ;
		Ob->Counter1 = (u16)( ( Ob->Counter1 + 1 ) % j ) ;
		if( Ob->Point.y <= Cf->YukaY )
		{
			Angle = rand() * PI_2 / RAND_MAX ;
			Ob->Point.y = Cf->CreateY + Cf->Point.y ;
			Ob->Point.z = Cf->Point.z + sinf( Angle ) * rand() * Cf->Radius / RAND_MAX ;
			Ob->Point.x = Cf->Point.x + cosf( Angle ) * rand() * Cf->Radius / RAND_MAX ;
			Ob->Speed.y = -( rand() * Speed / RAND_MAX + Cf->MinDownSpeed ) ;
			Ob->Counter1 = (u16)( ( rand() * j / RAND_MAX ) % j ) ;
			Ob->Color.r = (u8)( rand() * 255 / RAND_MAX ) ;
			Ob->Color.g = (u8)( rand() * 255 / RAND_MAX ) ;
			Ob->Color.b = (u8)( rand() * 255 / RAND_MAX ) ;
			Ob->WaitT = WaitT ;
			Ob->FadeT = FadeT ;
			Ob->a = 255 ; 
		}
*/
		if( Ob->Point.y == Cf->YukaY )
		{
			if( Ob->WaitT == 0 )
			{
				Ob->FadeT -- ;
				if( Ob->FadeT == 0 )
				{
					Angle = rand() * PI_2 / RAND_MAX ;
					Ob->Point.y = Cf->CreateY + Cf->Point.y ;
					Ob->Point.z = Cf->Point.z + sinf( Angle ) * rand() * Cf->Radius / RAND_MAX ;
					Ob->Point.x = Cf->Point.x + cosf( Angle ) * rand() * Cf->Radius / RAND_MAX ;
					Ob->Speed.y = -( rand() * Speed / RAND_MAX + Cf->MinDownSpeed ) ;
					Ob->Counter1 = (u16)( ( rand() * j / RAND_MAX ) % j ) ;
					Ob->Color.r = (u8)( rand() * 255 / RAND_MAX ) ;
					Ob->Color.g = (u8)( rand() * 255 / RAND_MAX ) ;
					Ob->Color.b = (u8)( rand() * 255 / RAND_MAX ) ;
					Ob->WaitT = WaitT ;
					Ob->FadeT = FadeT ;
					Ob->a = 255 ; 
					Ob->ColorIndex = (u8)( rand() * CONFETTI_COLORNUM / RAND_MAX % CONFETTI_COLORNUM ) ;
				}
				else
				{
					Ob->a = (u8)( ( Ob->FadeT * 255 ) / FadeT ) ; 
				}
			}
			else
			{
				Ob->WaitT -- ;
			}
		}
		else
		{
			Ob->Point.y += Ob->Speed.y ;
			Ob->Counter1 = (u16)( ( Ob->Counter1 + 1 ) % j ) ;
			if( Ob->Point.y <= Cf->YukaY ) Ob->Point.y = Cf->YukaY ;
		}
	}

	// I
	return 0 ;
}

// ̃GtFNg`悷
extern s8 DrawConfettiEffect( EFFECT *Effect )
{
	CONFETTIEFFECT *Cf = ( CONFETTIEFFECT * )Effect->Data ;
	CONFETTIOBJECT *Ob ;
	Vec CamP ;
	const GXColor Color = Cf->Color ;
	const s32 Wait = (s32)VParam[ED_CONFETTI][7] ;

	if( ConfUnion.NotAllDrawFlag == TRUE ) return 0 ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	// eNX`̃[h
	GTLOAD2( ConfUnion.ConfettiTex ) ;
	
	// _̑傫Zbg
	GXEnableTexOffsets( GX_TEXCOORD0, GX_ENABLE, GX_ENABLE ) ;
	GXSetPointSize( (u8)Cf->Size, GX_TO_HALF ) ;

	// J̈ʒu擾
	HSD_CObjGetEyePosition( GetEffectCamera(), &CamP ) ;

	// `揈
	GBGN( GX_POINTS, Cf->MaxNum ) ;
	{
		u32 i, Num ;
		
		Num = (u32)( Cf->MaxNum ) ;
		Ob = Cf->ObjP ;
		for( i = 0 ; i < Num ; i ++, Ob ++ )
		{
			GPV( Ob->Point ) ;
			GC( ConfettiColor[Ob->ColorIndex] ) ;
			GT( ( ( Ob->Counter1 / Wait ) % CONFETTITEX_DIVNUM ) * CONFETTITEX_ONES,
				( ( Ob->Counter1 / Wait ) / CONFETTITEX_DIVNUM ) * CONFETTITEX_ONES ) ;
		}
	}
	GXEnd() ;
	
	// I
	return 0 ;
}					


	
// Ⴊ钆S_ύX
extern s8 SetConfettiEffectPoint( EFFECT *Effect, Vec Point )
{
	CONFETTIEFFECT *Cf = ( CONFETTIEFFECT * )Effect->Data ;

	// WύX
	Cf->Point = Point ;

	// I
	return 0 ;
}

// ׂ̂Ă`悷邩ǂ̃tOZbg
extern s8 SetConfettiAllDrawFlag( s8 Flag )
{
	ConfUnion.NotAllDrawFlag = !Flag ;
	
	// I
	return 0 ;
}	

