///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectConveConveBlood2
//
// YK7EffectConveConveBlood2.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/23/2004
//
//////////////////////////////////////////////////////////////////////////////

// include --------------------------------------
#include "./YK7EffectConveBlood2.h"
#include "./YK7Break.h"
#include "./YK7EffectBlood.h"
#include "./YK7EffectMesh.h"

// define ---------------------------------------

#define DEFR		(180)
#define DEFG		(40)
#define DEFB		(0)

// data type ------------------------------------

// data -----------------------------------------

CONVEBLOOD2UNION cb2u ;

// function proto type --------------------------

static s8 __ConveBlood2CallBack( Vec **Point, void *Data ) ;	// |S擾ăGtFNgf[^\zR[obN֐
static s8 __ConveBlood2NumCallBack( Vec **Point, void *Data ) ;	// |S擾ăGtFNgf[^̐𐔂R[obN֐

// function code --------------------------------

// |S擾ăGtFNgf[^\zR[obN֐
static s8 __ConveBlood2CallBack( Vec **Point, void *Data )
{
	CONVEBLOOD2EFFECT *cv2 = ( CONVEBLOOD2EFFECT * )Data ;
	CONVEBLOOD2OBJECT *ob ;
	f32 *s = (f32 *)WorkBuffer ;
	Vec dx, dy, dz, p ;
	f32 x, y, z ;
	u8 pat ;

	// O𓾂
	PSVECSubtract( Point[1], Point[0], &dx ) ;
	PSVECSubtract( Point[2], Point[0], &dy ) ;
	{
		Vec vx, vy ;
		PSVECNormalize( &dx, &vx ) ;
		PSVECNormalize( &dy, &vy ) ;
		PSVECCrossProduct( &vy, &vx, &dz ) ;
	}

	cv2->FloatObjNum += s[cv2->counter] ;
	while( cv2->FloatObjNum > 1.0F )
	{
		cv2->FloatObjNum -= 1.0F ;

		ob = &cv2->Obj[cv2->ObjNum] ;
		x = (f32)rand() / RAND_MAX ;	y = ( 1.0F - x ) * rand() / RAND_MAX ;
		z = GetRandF2Num( cv2->MaxLen, cv2->MinLen ) ;
		ob->pos.x = ob->dir.x = Point[0]->x + x * dx.x + y * dy.x ;
		ob->pos.y = ob->dir.y = Point[0]->y + x * dx.y + y * dy.y ;
		ob->pos.z = ob->dir.z = Point[0]->z + x * dx.z + y * dy.z ;
		if( cb2u.StartPosFlag == TRUE )
		{
			ob->dir.x = GetRandFNum( 1.0F ) - 0.5F ;
			ob->dir.y = GetRandFNum( 1.0F ) - 0.5F  ;
			ob->dir.z = GetRandFNum( 1.0F ) - 0.5F ;

			ob->apos = cb2u.StartPos ;
			ob->mode = 1 ;

			ob->len = VECDistance( &ob->dir, &p ) ;
			ob->dir.x /= ob->len ;
			ob->dir.y /= ob->len ;
			ob->dir.z /= ob->len ;
//			ob->speed = 2.0F ;
			ob->speed2.x = GetRandF2Num( 1.0F, -1.0F ) ;
			ob->speed2.y = GetRandF2Num( 1.0F, -1.0F ) ;
			ob->speed2.z = GetRandF2Num( 1.0F, -1.0F ) ;
			VECNormalize( &ob->speed2, &ob->speed2 ) ;
			VECScale( &ob->speed2, &ob->speed2, GetRandF2Num( cv2->speed, cv2->speed / 10.0F ) ) ; 
		}
		else
		{
			p.x = ob->pos.x + z * dz.x ;
			p.y = ob->pos.y + z * dz.y ;
			p.z = ob->pos.z + z * dz.z ;
			ob->mode = 0 ;

			ob->len = VECDistance( &ob->dir, &p ) ;
			ob->dir.x = ( ob->dir.x - p.x ) / ob->len ;
			ob->dir.y = ( ob->dir.y - p.y ) / ob->len ;
			ob->dir.z = ( ob->dir.z - p.z ) / ob->len ;
		}

		ob->speed = 0.0F ;
		ob->vflag = TRUE ;
//		*((u32 *)&ob->color) = cb2u.colorvalid ? cb2u.color : 0xff0000ff ;

		// FZbg
		{
			s32 r, g, b ;
			s32 crand = 161 ;
			s32 R, G, B ;
			
			if( cb2u.colorvalid == true )
			{
				GXColor *cr ;
				
				cr = GetRandINum(2) == 0 ? ((GXColor *)&cb2u.color1) : ((GXColor *)&cb2u.color2) ;
				R = cr->r ;	G = cr->g ;	B = cr->b ;
			}
			else
			{
				R = DEFR ; G = DEFG ; B = DEFB ;
			}
			
			if( R == 0 ) r = 0 ;
			else
			{
				r = GetRandINum( crand ) + R - crand / 2 ;
				if( r > 255 ) r = 255 ; else if( r < 0 ) r = 0 ;
			}
			if( G == 0 ) g = 0 ;
			else
			{
				g = GetRandINum( crand ) + G - crand / 2 ;
				if( g > 255 ) g = 255 ; else if( g < 0 ) g = 0 ;
			}
			if( B == 0 ) b = 0 ;
			else
			{
				b = GetRandINum( crand ) + B - crand / 2 ;
				if( b > 255 ) b = 255 ; else if( b < 0 ) b = 0 ;
			}
			*((u32 *)&ob->color) = CMK( r, g, b, 0xff ) ;
		}
				
		ob->wait = (u8)( GetRandINum( cb2u.ConveTime ) ) ; // ( cv2->MaxLen - ob->len ) / cv2->MaxLen * 30 ;

		pat = (u8)GetRandINum( 3 ) ;
		ob->u = (f32)( pat & 1 ) / 2.0F ;	ob->v = (f32)( pat >> 1 ) / 2.0F ;
		ob->rot = (u8)GetRandINum( 3 ) ;

		cv2->ObjNum ++ ;
	}

	cv2->counter ++ ;

	return 0 ;
}

// |S擾ăGtFNgf[^̐𐔂R[obN֐
static s8 __ConveBlood2NumCallBack( Vec **Point, void *Data )
{
	CONVEBLOOD2EFFECT *cv2 = ( CONVEBLOOD2EFFECT * )Data ;
	f32 *s = (f32 *)WorkBuffer ;
	Vec dx, dy ;

	PSVECSubtract( Point[1], Point[0], &dx ) ;
	PSVECSubtract( Point[2], Point[0], &dy ) ;

	// ʐς琔𑫂
	cv2->FloatObjNum += s[cv2->counter] =
		( sqrtf( ( dx.y * dy.z - dx.z * dy.y ) * ( dx.y * dy.z - dx.z * dy.y ) +
				 ( dx.z * dy.x - dx.x * dy.z ) * ( dx.z * dy.x - dx.x * dy.z ) +
				 ( dx.x * dy.y - dx.y * dy.x ) * ( dx.x * dy.y - dx.y * dy.x ) ) / 2.0F ) * cv2->rate ;

	cv2->counter ++ ;
	if( cv2->counter >= WORKBUFFERSIZE / 4 )
		return -1 ;

	return 0 ;
}


// QGtFNg̋ʃf[^
extern s8 InitConveBlood2Data( void )
{
	MEMINIT( cb2u ) ;

	cb2u.colorvalid = false ;	
	cb2u.ConveSpeed = 0.1F ;
	cb2u.TexNumber = 0 ; 
	
	return 0 ;
}

// QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckConveBlood2Data( void )
{
	return TRUE ;
}

// QGtFNg̋ʃf[^n
extern s8 EndConveBlood2Data( void )
{
	MEMINIT( cb2u ) ;
	
	return 0 ;
}

#define BIG		TRUE

// QGtFNg쐬
extern EFFECT *CreateConveBlood2Effect( 
										WK7JObj *Target,			// ڕW̃bV
										f32 MaxLen, f32 MinLen,		// 
										f32 speed,					// 鑬x
										f32 size,					// TCY
										f32 rate,					// ʐϕӂ̃IuWFNg̍쐬
										s32 Priority )
{
	EFFECT *ef ;
	CONVEBLOOD2EFFECT *cv2 ;
//	MESH *mesh = NULL ;
//	BASICMESH *basmesh = NULL ;
//	HSD_DObj *dobj ;
	MODEL *model = NULL ;
	BASICMODEL *basmodel = NULL ;

	// bV݂邩𒲂ׂ
//	if( ( dobj = GetHaveMeshDObj( Target->GetJObj() ) ) == NULL ) return NULL ;

	// o^
	ef = AddEffectData( EFF_CONVEBLOOD2, (void**)&cv2, Priority ) ;
	if( ef == NULL )
	{
		cb2u.colorvalid = false ;
		return NULL ;
	}
	memset( cv2, 0, sizeof( CONVEBLOOD2EFFECT ) ) ;
	
	// p[^̒
	{
		Vec pos ;
		BLOODDEF TBDef ;
		
		GetJObjPos( Target->GetJObj(), &pos ) ;
		GetBloodDefParam( &pos, &TBDef ) ;

		// ␳
		MaxLen *= TBDef.Power ;
		MinLen *= TBDef.Power ;
		rate *= TBDef.BloodNum ;
		size *= TBDef.BloodSize ;
	}

	// l̕ۑ
	cv2->Obj = NULL ;
	cv2->Target = Target ;
	cv2->MaxLen = MaxLen ;	cv2->MinLen = MinLen ;
	cv2->counter = 0 ;
	cv2->speed = speed ;
	cv2->size = size ;
	cv2->rate = rate ;
	cv2->EndNum = 0 ;
	cv2->rot = 0.0F ;
	cv2->FloatObjNum = 0.0F ;
	cv2->MeshEffect = NULL ;
	cv2->MeshAlpha = 0 ;
	cv2->Mode = 0 ;
	cv2->ConveSpeed = cb2u.ConveSpeed ;
	cb2u.ConveSpeed = 0.1F ;
	cv2->TexNumber = cb2u.TexNumber ;
	cb2u.TexNumber = 0 ;

//	goto ERR ;

	// bV쐬
/*	if( CreatePrimitiveMeshData( Target->GetJObj(), dobj, dobj->pobj, &mesh,
									FALSE, TRUE, FALSE, FALSE, BIG ) < 0 ) goto ERR ; 
	if( CreateBasicPrimitiveMeshData( mesh, &basmesh, TRUE, FALSE, TRUE, BIG ) < 0 ) goto ERR ;
*/
	if( CreateModelData( Target->GetJObj(), &model, TRUE, FALSE, TRUE, BIG ) < 0 ) goto ERR ;
	if( CreateBasicModelData( model, &basmodel, TRUE, BIG, FALSE, TRUE ) < 0 ) goto ERR ;
	
	DeleteModelData( model ) ;
	model = NULL ;

	// bVGtFNg쐬
	{
		u32 color ;
		
		color = cb2u.colorvalid == true ? CMKC2( cb2u.color1, 128 ) : CMK( DEFR, DEFG, DEFB, 128 ) ;
		cv2->MeshEffect = NULL ;
		cv2->MeshEffect = CreateMeshEffect( basmodel,
											(Vec){0.0F,0.0F,0.0F},
											TRUE,
											color, 
											true,
											Priority - 1 ) ;
	}
	
	if( cv2->MeshEffect != NULL )
	{
		SetMeshEffectLightValidFlag( cv2->MeshEffect, FALSE ) ;
		SetMeshEffectAlpha( cv2->MeshEffect, 0 ) ;
	}

	// IuWFNg̐𐔂
	cv2->counter = 0 ;
	cv2->FloatObjNum = 0.0F ;
//	if( ScanMeshPrimitive( basmesh, __ConveBlood2NumCallBack, cv2 ) < 0 ) goto ERR ;
	if( ScanBasicModelPrimitive( basmodel, __ConveBlood2NumCallBack, cv2 ) < 0 ) goto ERR ;

	// mۂ
	if( ( cv2->Obj = ( CONVEBLOOD2OBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( CONVEBLOOD2OBJECT ) * ( (s32)(cv2->FloatObjNum) + 1 ) ), "Conv2Obj" ) ) == NULL ) goto ERR ;
	
	// IuWFNg
	cv2->counter = 0 ;
	cv2->FloatObjNum = 0.0F ;
//	if( ScanMeshPrimitive( basmesh, __ConveBlood2CallBack, cv2 ) < 0 ) goto ERR ;
	if( ScanBasicModelPrimitive( basmodel, __ConveBlood2CallBack, cv2 ) < 0 ) goto ERR ;

	// JE^
	cv2->counter = 0 ;
	
	if( cv2->MeshEffect == NULL ) DeleteBasicModelData( basmodel ) ;
	basmodel = NULL ;

	cb2u.colorvalid = false ;

	// I
	return ef ;
	
ERR :
	if( cv2->MeshEffect )
	{
		DeleteEffect( cv2->MeshEffect ) ;
		basmodel = NULL ;
	}

//	if( mesh ) DeletePrimitiveMeshData( mesh ) ;
//	if( basmesh ) DeleteBasicMeshData( basmesh ) ;
	if( model ) DeleteModelData( model ) ;

	if( basmodel ) DeleteBasicModelData( basmodel ) ;
	if( ef )
	{
		if( cv2->Obj ) K7AppSmallMemFree( cv2->Obj ) ;
		DeleteEffect( ef ) ;
	}

	cb2u.colorvalid = false ;

	return NULL ;
}

// QGtFNǧns
extern s8 ReleaseConveBlood2Effect( EFFECT *Effect )
{
	CONVEBLOOD2EFFECT *cv2 = ( CONVEBLOOD2EFFECT * )Effect->Data ;
	
	// 
	if( cv2->Obj ) K7AppSmallMemFree( cv2->Obj ) ;
	if( cv2->MeshEffect ) DelReqEffect( cv2->MeshEffect ) ;
//	if( cv2->MeshEffect ) DeleteEffect( cv2->MeshEffect ) ;

	return 0 ;
}

// QGtFNgPt[
extern s8 MoveConveBlood2Effect( EFFECT *Effect )
{
	CONVEBLOOD2EFFECT *cv2 = ( CONVEBLOOD2EFFECT * )Effect->Data ;
	CONVEBLOOD2OBJECT *ob ;
	s32 i, num ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// ]̕ω
	cv2->rot += PI_2 / 360.0F * 4 ;
	if( cv2->rot >= PI_2 ) cv2->rot -= PI_2 ;

	// IuWFNg̓
	num = (s32)( cv2->ObjNum - cv2->EndNum ) ;
	ob = cv2->Obj ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == FALSE ) continue ;

		i ++ ;

		if( ob->mode == 1 )
		{
			if( VECDistance( &ob->pos, &ob->apos ) < VECMag( &ob->speed2 ) + ob->speed )
			{
				ob->len = 0.0F ;
				ob->vflag = FALSE ;
				cv2->EndNum ++ ;
				
				ob->apos.x = ob->pos.x + ob->dir.x * ob->len ;
				ob->apos.y = ob->pos.y + ob->dir.y * ob->len ;
				ob->apos.z = ob->pos.z + ob->dir.z * ob->len ;
			
				ob->mode = 0 ;
			}
			else
			{
				ob->apos.x += ob->speed2.x ;
				ob->apos.y += ob->speed2.y ;
				ob->apos.z += ob->speed2.z ;
				
				if( ob->wait == 0 )
				{
	//				ob->mode = 0 ;
					
					VECSubtract( &ob->pos, &ob->apos, &ob->dir ) ;
					ob->len = VECDistance( &ob->pos, &ob->apos ) ;
					VECNormalize( &ob->dir, &ob->dir ) ;
					
					ob->apos.x += ob->dir.x * ob->speed ;
					ob->apos.y += ob->dir.y * ob->speed ;
					ob->apos.z += ob->dir.z * ob->speed ;

//					ob->speed2.x += ob->dir.x * 0.1F ;
//					ob->speed2.y += ob->dir.y * 0.1F ;
//					ob->speed2.z += ob->dir.z * 0.1F ;
				ob->speed += cv2->ConveSpeed ;
				}
				else
				{
					ob->wait -- ;
				}
			}
		}
		else
		{
			if( ob->len < ob->speed )
			{
				ob->len = 0.0F ;
				ob->vflag = FALSE ;
				cv2->EndNum ++ ;
			}
			else
			{
				if( ob->wait != 0 ) ob->wait -- ;
				else
				{
					f32 l ;
			
					l = GetRandF2Num( ob->speed, ob->speed / 0.5F ) ;
					ob->len -= l ;
					ob->speed += cv2->speed ;
				}
			}

			ob->apos.x = ob->pos.x + ob->dir.x * ob->len ;
			ob->apos.y = ob->pos.y + ob->dir.y * ob->len ;
			ob->apos.z = ob->pos.z + ob->dir.z * ob->len ;
		}

/*
		if( ob->len < ob->speed )
		{
			ob->pos.x += ob->dir.x * ob->len ; 
			ob->pos.y += ob->dir.y * ob->len ; 
			ob->pos.z += ob->dir.z * ob->len ;
			ob->vflag = FALSE ;
			cv2->EndNum ++ ;
		}
		else
		{
			ob->pos.x += ob->dir.x * ob->speed ;
			ob->pos.y += ob->dir.y * ob->speed ;
			ob->pos.z += ob->dir.z * ob->speed ;
			ob->len -= ob->speed ;
			ob->speed += cv2->speed ;
		}
*/
	}
	
	if( cv2->MeshEffect ) SetMeshEffectAlpha( cv2->MeshEffect, (u8)cv2->MeshAlpha ) ;
	switch( cv2->Mode )
	{
	case 0 :	// SĂ̌܂ő҂
		cv2->counter += VParam[ED_CONVEBLOOD2][5] ;
		if( cv2->counter > 255 ) cv2->counter = 255 ;

		cv2->MeshAlpha = (s32)( cv2->EndNum * 255 / cv2->ObjNum ) ;
		if( cv2->ObjNum - cv2->EndNum == 0 ) cv2->Mode ++ ;
		break ;
		
/*	case 1 :	// f̃At@㏸
		cv2->counter += VParam[ED_CONVEBLOOD2][5] ;
		if( cv2->counter > 255 ) cv2->counter = 255 ;
		
		cv2->MeshAlpha += VParam[ED_CONVEBLOOD2][6] ;
		if( cv2->MeshAlpha > 255 )
		{
			cv2->MeshAlpha = 255 ;
			cv2->Mode ++ ;
		}
		break ;
*/		
	case 1 :	// f̃At@~
		cv2->MeshAlpha -= VParam[ED_CONVEBLOOD2][7] ;
		if( cv2->MeshAlpha < 0 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		cv2->counter = (u32)cv2->MeshAlpha ;
		break ;
	}

	// I
	return 0 ;
}

// QGtFNg`悷
extern s8 DrawConveBlood2Effect( EFFECT *Effect )
{
	CONVEBLOOD2EFFECT *cv2 = ( CONVEBLOOD2EFFECT * )Effect->Data ;
	CONVEBLOOD2OBJECT *ob ;
	Vec tp[4], p ;
	Mtx TMtx ;
	s32 j, num, dnum ;
	
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;					// `̏

	// J[̐ݒ
    GXSetNumChans(1);
    GXSetAlphaCompare( GX_GREATER, 20, GX_AOP_AND, GX_ALWAYS, 0);
    GXSetChanAmbColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanMatColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanCtrl( GX_COLOR0A0, GX_DISABLE, GX_SRC_REG, GX_SRC_VTX,
  				GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE ) ;

	// ]ns̎Zo
	EffectGetInvViewMatrix( TMtx ) ;

	// eNX`̃[h
	GTLOAD( &GetBloodTex((u8)cv2->TexNumber)->Obj ) ;

	// ɔł錌̕`
	if( cv2->ObjNum == 0 ) return 0 ;

	// `揈Jn
	{
		f32 Sin, Cos ;

		// r{[hWZo
		{
			Sin = SINF(cv2->rot) ;	Cos = COSF(cv2->rot) ;
			tp[0].x = ( -cv2->size / 2 ) * Cos - ( -cv2->size / 2 ) * Sin ;
			tp[0].y = ( -cv2->size / 2 ) * Sin + ( -cv2->size / 2 ) * Cos ;
			tp[0].z = 0.0F ;

			tp[1].x = ( cv2->size / 2 ) * Cos - ( -cv2->size / 2 ) * Sin ;
			tp[1].y = ( cv2->size / 2 ) * Sin + ( -cv2->size / 2 ) * Cos ;
			tp[1].z = 0.0F ;

			tp[2].x = -tp[0].x ; tp[2].y = -tp[0].y ; tp[2].z = -tp[0].z ; tp[2].z = 0.0F ;
			tp[3].x = -tp[1].x ; tp[3].y = -tp[1].y ; tp[3].z = -tp[1].z ; tp[3].z = 0.0F ;
			PSMTXMultVec( TMtx, &tp[0], &tp[0] ) ;
			PSMTXMultVec( TMtx, &tp[1], &tp[1] ) ;
			PSMTXMultVec( TMtx, &tp[2], &tp[2] ) ;
			PSMTXMultVec( TMtx, &tp[3], &tp[3] ) ;
		}

		num = (s32)cv2->ObjNum ;
		dnum = num ;
		if( dnum * 4 > 65535 ) dnum = 0xffff >> 2 ;
		num -= dnum ;
		GBGN( GX_QUADS, dnum * 4 ) ;

		{
			ob = cv2->Obj ;
			for( j = 0 ; j < cv2->ObjNum ; j ++, ob ++ )
			{
				if( ob->vflag )
				{
					p = ob->apos ;
				}
				else
				{
					p = ob->pos ;
				}
			
				switch( ob->rot )
				{
				case 0 :
					GPV3( tp[0], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u,		ob->v ) ;
					GPV3( tp[1], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u + 0.5F,	ob->v ) ;
					GPV3( tp[2], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u + 0.5F,	ob->v + 0.5F ) ;
					GPV3( tp[3], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u, 		ob->v + 0.5F ) ;
					break ;
					
				case 1 :
					GPV3( tp[0], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u + 0.5F,	ob->v ) ;
					GPV3( tp[1], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u + 0.5F,	ob->v + 0.5F ) ;
					GPV3( tp[2], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u, 		ob->v + 0.5F ) ;
					GPV3( tp[3], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u, 		ob->v ) ;
					break ;
					
				case 2 :
					GPV3( tp[0], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u + 0.5F,	ob->v + 0.5F ) ;
					GPV3( tp[1], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u, 		ob->v + 0.5F ) ;
					GPV3( tp[2], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u,		ob->v ) ;
					GPV3( tp[3], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u + 0.5F,	ob->v ) ;
					break ;
					
				case 3 :
					GPV3( tp[0], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u, 		ob->v + 0.5F ) ;
					GPV3( tp[1], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u, 		ob->v ) ;
					GPV3( tp[2], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u + 0.5F,	ob->v ) ;
					GPV3( tp[3], p ) ; GC2( ob->color, cv2->counter ) ; GT( ob->u + 0.5F,	ob->v + 0.5F ) ;
					break ;
				}
				
				dnum -- ;
				if( dnum == 0 && num != 0 )
				{
					GEND() ;
					
					dnum = num ;
					if( dnum * 4 > 65535 ) dnum = 0xffff >> 2 ;
					num -= dnum ;
					GBGN( GX_QUADS, dnum * 4 ) ;
				}
			}
		}
		GEND() ;
	}

	// I
	return 0 ;
}


// Ԃ𓾂( 0:W 1:I )
extern s8 GetConveBlood2EffectState( EFFECT *Effect )
{
	CONVEBLOOD2EFFECT *cv2 = ( CONVEBLOOD2EFFECT * )Effect->Data ;
	
	return (s8)( cv2->Mode >= 1 ? 1 : 0 ) ;
}

// w̍W猌oݒs
extern s8 SetConveBlood2StartPosition( Vec Pos, bool ValidFlag )
{
	cb2u.StartPos = Pos ;
	cb2u.StartPosFlag = ValidFlag ;
	
	return 0 ;
}

// Ɋ|鎞Ԃݒ肷
extern s8 SetConveBlood2ConveTime( u8 Time )
{
	cb2u.ConveTime = Time ;
	
	return 0 ;
}

// gpƂ͂ݒ肷
extern s8 SetConveBlood2ConveSpeed( f32 ConveSpeed )
{
	cb2u.ConveSpeed = ConveSpeed ;
	
	return 0 ;
}

// lʗpȈՊ֐
extern EFFECT *CreateConveBlood2EffectKamen( 
												WK7JObj *Target,			// ڕW̃bV
												f32 x, f32 y,				// JnW
												s32 Priority )
{
	Vec v ;
	
	GetScreen3DVector( x, y, VParam[ED_CONVEBLOOD3][5] * 0.1F, &v ) ;

	SetConveBlood2ConveTime( (u8)VParam[ED_CONVEBLOOD3][1] ) ;
	SetConveBlood2ConveSpeed( (f32)VParam[ED_CONVEBLOOD3][0] * 0.001F ) ;
	SetConveBlood2StartPosition( v, true ) ;
	return 	CreateConveBlood2Effect( Target,
										1.0F, 0.0F,
										(f32)VParam[ED_CONVEBLOOD3][2] * 0.01F,
										(f32)VParam[ED_CONVEBLOOD3][3] * 0.01F,
										(f32)VParam[ED_CONVEBLOOD3][4] * 0.5F, Priority ) ;
}

// gp錌eNX`̔ԍݒ肷
extern s8 SetConveBlood2TextureID( s32 TexNumber )
{
	cb2u.TexNumber = TexNumber ;
	
	return 0 ;
}


// ̐Fݒ肷
extern s8 SetConveBlood2Color( u32 color1, u32 color2 )
{
	cb2u.color1 = color1 ;
	cb2u.color2 = color2 ;
	cb2u.colorvalid = true ;
	
	return 0 ;
}

