///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCursor
//
// YK7EffectCursor.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/05/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectCursor.h"
#include "./YK7EffectShutter.h"
#include "../matsu/mk7Sound.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define PRM1			(s32)VParam[ED_CURSOR]
#define PRM2			(s32)VParam[ED_CURSOR2]
#define PRM3			(s32)VParam[ED_PNCURSOR]
#define PRM4			(s32)VParam[ED_PNCURSOR2]

#define LINEW			(PRM1[1])
#define LINELEN			(PRM1[0])

#define SHADOWX			(PRM2[13])
#define SHADOWY			(PRM2[14])
#define AIMAGENUM		(PRM2[8])

#define AMICOLOR		(CMK(PRM2[18],PRM2[19],PRM2[20],PRM2[21]))

#define CURSPEED		(PRM2[0] * 0.01F)
#define INITCURPOS		(PRM2[7])

#define CUR_GRID_SIZE		24			// Obh̃TCY
#define AMITEXNAME			"/Yam/Effect/Cursor/Ami.BIN"

// datatype -------------------------------------

// data -----------------------------------------

CURSORUNION CurUnion ;

static const s8 BrinkTable[] = { 4, 4, 4, 4, -1 } ;
static const s8 CharBrinkTable[] = { 4, 4, 1, 1, 1, 1,  1, 1, 1, 1, -1 } ;

// function proto type --------------------------

static s8 CurObjectFrameProcess( CURSOROBJECT *Obj ) ;													// J[\̃t[vZX
static s8 CurObjectRenderProcess( CURSOROBJECT *Obj, u8 r, u8 g, u8 b, u8 a, f32 Len, s8 ShadowFlag ) ;	// J[\̃_OvZX
	
// function code --------------------------------

// J[\̃_OvZX
static s8 CurObjectRenderProcess( CURSOROBJECT *Obj, u8 r, u8 g, u8 b, u8 a, f32 Len, s8 ShadowFlag )
{
	f32 x, y, AddX, AddY ;
	s32 j ;

	if( ShadowFlag == TRUE )
	{
		AddX = (f32)SHADOWX ;
		AddY = (f32)SHADOWY ;
	
		GP2( (s32)( Obj->x - Len + AddX ), (s32)( Obj->y + AddY ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
		GP2( (s32)( Obj->x + Len + AddX ), (s32)( Obj->y + AddY ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;

		GP2( (s32)( Obj->x + AddX ), (s32)( Obj->y - Len + AddY ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
		GP2( (s32)( Obj->x + AddX ), (s32)( Obj->y + Len + AddY ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
		
		for( j = 0 ; j < AIMAGENUM ; j ++ )
		{
			x = Obj->x - Obj->mx * j / AIMAGENUM ;
			y = Obj->y - Obj->my * j / AIMAGENUM ;

			GP2( (s32)( x - Len + AddX ), (s32)( y + AddY ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
			GP2( (s32)( x + Len + AddX ), (s32)( y + AddY ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;

			GP2( (s32)( x + AddX ), (s32)( y - Len + AddY ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
			GP2( (s32)( x + AddX ), (s32)( y + Len + AddY ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
		}
	}

	GP2( (s32)( Obj->x - Len ), (s32)Obj->y ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
	GP2( (s32)( Obj->x + Len ), (s32)Obj->y ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;

	GP2( (s32)Obj->x, (s32)( Obj->y - Len ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
	GP2( (s32)Obj->x, (s32)( Obj->y + Len ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;

	for( j = 0 ; j < AIMAGENUM ; j ++ )
	{
		x = Obj->x - Obj->mx * j / AIMAGENUM ;
		y = Obj->y - Obj->my * j / AIMAGENUM ;

		GP2( (s32)( x - Len ), (s32)y ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
		GP2( (s32)( x + Len ), (s32)y ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;

		GP2( (s32)x, (s32)( y - Len ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
		GP2( (s32)x, (s32)( y + Len ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
	}
	
	// I
	return 0 ;
}

// J[\̃t[vZX
static s8 CurObjectFrameProcess( CURSOREFFECT *Cur, CURSOROBJECT *Obj )
{
	f32 dx, dy ;

	dx = (s32)( ( Cur->x + Obj->dx ) - Obj->x ) ;
	dy = (s32)( ( Cur->y + Obj->dy ) - Obj->y ) ;

	Obj->x += ( Obj->mx = dx * CURSPEED ) ;
	Obj->y += ( Obj->my = dy * CURSPEED ) ;

	// I
	return 0 ;
}


// J[\GtFNg̋ʃf[^
extern s8 InitCursorData( void )
{
	MEMINIT( CurUnion ) ;

	// Ԋ|eNX`̓ǂݍ݂Jn
//	TexLoadSet( AMITEXNAME, &CurUnion.AmiTex, TEX_TYPE_NOLINEAR ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_AMI ), &CurUnion.AmiTex, TEX_TYPE_NOLINEAR ) ;

	// I
	return 0 ;
}

// J[\GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckCursorData( void )
{
	// ܂eNX`ǂݍ܂ĂȂ牽I
//	if( TexLoadChk( &CurUnion.AmiTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}


// J[\GtFNg̋ʃf[^n
extern s8 EndCursorData( void )
{
	// Ԋ|eNX`̌n
	TexRelease( &CurUnion.AmiTex ) ;

	MEMINIT( CurUnion ) ;

	// I
	return 0 ;
}


// J[\̃GtFNg쐬
extern EFFECT *CreateCursorEffect( GXColor Color, s8 FastFlag, s32 Priority )
{
	CURSOREFFECT *Cur ;
	CURSOROBJECT *Obj ;
	EFFECT *Effect ;
	s32 i ;
	
	// VJ[\f[^쐬
	Effect = AddEffectData( EFF_CURSOR, (void**)&Cur, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( Cur, 0, sizeof( CURSOREFFECT ) ) ;

	// J[\f[^
	Cur->x = 0 ;
	Cur->y = 0 ;
	Cur->Color = Color ;
	Cur->DrawFlag = FALSE ;
	Cur->LeftRightMovNum = 0 ;
	Cur->TopBottomMovNum = 0 ;
	Cur->LeftRightNum = 0 ;
	Cur->TopBottomNum = 0 ;
	Cur->LeftRightCounter = 0 ;
	Cur->TopBottomCounter = 0 ;
	Cur->BackLRMovNum = 0 ;
	Cur->BackTBMovNum = 0 ;
	Cur->ShadowFlag = FALSE ;
	Cur->EndFlag = FALSE ;
	Cur->EndCounter = 0 ;
	Cur->Alpha = 1.0F ;
	Cur->Alpha2 = 0.0F ;
	Cur->FastFlag = FastFlag ;
	Cur->AmiDrawFlag = FALSE ;
	Cur->AmiYFill = 0 ;
	Cur->AmiXFill = 0 ;
	Cur->BrinkMode = 0 ;
	Cur->BrinkCounter1 = Cur->BrinkCounter2 = Cur->BrinkCounter3 = 0 ;
	Cur->BrinkState = 0 ;
	Cur->CharBrinkCounter1 = Cur->CharBrinkCounter2 = Cur->CharBrinkCounter3 = 0 ;
	Cur->CharBrinkState = 0 ;
	Cur->BrinkSinCounter = 0.0F ;
	Cur->CenterBright = Cur->Bright = 0.0F ;
	Cur->AmiColorBot = Cur->AmiColorTop = 0 ;
	Cur->AmiColor = AMICOLOR ;

	// IuWFNgf[^̏
	Obj = Cur->Obj ;
	for( i = 0 ; i < CUR_OBJECTNUM ; Obj ++, i ++ )
	{
		Obj->Speed = 0.0F ;
		Obj->x = 0 ;		Obj->y = 0 ;
		Obj->sx = 0 ;		Obj->sy = 0 ;
		Obj->mx = 0 ;		Obj->my = 0 ;
		Obj->dxEx = 0.0F ;	Obj->dyEx = 0.0F ;
	}
	Obj = Cur->Obj ;
	Obj[0].dx = -INITCURPOS ; Obj[0].dy = -INITCURPOS ;
	Obj[1].dx =  INITCURPOS ; Obj[1].dy = -INITCURPOS ;
	Obj[2].dx =  INITCURPOS ; Obj[2].dy =  INITCURPOS ;
	Obj[3].dx = -INITCURPOS ; Obj[3].dy =  INITCURPOS ;

	// I
	return Effect ;
}

// J[\̃GtFNǧns
extern s8 ReleaseCursorEffect( EFFECT *Effect )
{
	CURSOREFFECT *Cursor = ( CURSOREFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// J[\̃GtFNgPt[
extern s8 MoveCursorEffect( EFFECT *Effect )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;
	CURSOROBJECT *Obj ;
	s32 i, j ;
	f32 dy ;

	// ܂eNX`ǂݍ܂ĂȂ牽I
	if( CheckCursorData() == FALSE ) return 0 ;

	if( (CURSOREFFECT *)NULL == Cur ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	if( Cur->DrawFlag == TRUE )
	{
		Cur->Alpha2 += (f32)PRM2[29] / 255.0F ;
		if( Cur->Alpha2 >= 1.0F ) Cur->Alpha2 = 1.0F ;
	}
	else
	{
		Cur->Alpha2 -= (f32)PRM2[29] / 255.0F ;
		if( Cur->Alpha2 < 0.0F ) Cur->Alpha2 = 0.0F ;
	}

	// _ŃtOĂ_ŏs
	switch( Cur->BrinkMode )
	{
	case 0 :
		Cur->CharBrinkState = Cur->BrinkState = 0 ;
		break ;
		
	case 1 :
		Cur->BrinkCounter1 ++ ;
		if( Cur->BrinkCounter1 >= BrinkTable[Cur->BrinkCounter2] * PRM2[24] )
		{
			if( GetEffectSoundOffFlag() == FALSE )
				PlayEffectSE( SFX_SYS_MESSE_FLASH, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackSystemOverlap, eSEGroupSystem00Env ) ;
				
			Cur->BrinkCounter1 = 0 ;
			Cur->BrinkCounter3 = (s8)PRM2[28] ;

			Cur->BrinkCounter2 ++ ;
			if( BrinkTable[Cur->BrinkCounter2] == -1 )
			{
				Cur->BrinkCounter2 = 0 ;
			}
		}
		if( Cur->BrinkCounter3 != 0 )
		{
			Cur->BrinkState = TRUE ;
			Cur->BrinkCounter3 -- ;
		}
		else
		{
			Cur->BrinkState = FALSE ;
		}

		Cur->CharBrinkCounter1 ++ ;
		if( Cur->CharBrinkCounter1 >= CharBrinkTable[Cur->CharBrinkCounter2] * PRM2[24] )
		{
			Cur->CharBrinkCounter1 = 0 ;
			Cur->CharBrinkCounter3 = (s8)PRM2[28] ;

			Cur->CharBrinkCounter2 ++ ;
			if( CharBrinkTable[Cur->CharBrinkCounter2] == -1 )
			{
				Cur->CharBrinkCounter2 = 0 ;
			}
		}
		if( Cur->CharBrinkCounter3 != 0 )
		{
			Cur->CharBrinkState = TRUE ;
			Cur->CharBrinkCounter3 -- ;
		}
		else
		{
			Cur->CharBrinkState = FALSE ;
		}
		break ;

	case 2 :
		Cur->CharBrinkState = Cur->BrinkState = 1 ;
		break ;
		
	case 3 :
		Cur->BrinkSinCounter = fmod( Cur->BrinkSinCounter + PRM3[27] * PI / 180.0F, 2 * PI ) ;
		break ;
	}
	
	// Pxݒ菈
	if( Cur->BrinkMode == 3 )
	{
		f32 target, f ;
		
		f = (f32)PRM3[28] / 255.0F ;
		target = ( ( 1.0F - f ) / 2.0F ) * sin( Cur->BrinkSinCounter ) + f + ( ( 1.0F - f ) / 2.0F ) ;
	
		if( Cur->Bright > target )
		{
			Cur->Bright -= (f32)PRM3[28] / 255.0F ;
			if( Cur->Bright < target ) Cur->Bright = target ;
		}
		else
		{
			Cur->Bright += (f32)PRM3[28] / 255.0F ;
			if( Cur->Bright > target ) Cur->Bright = target ;
		}

		f = (f32)PRM3[28] / 255.0F ;
		target = ( ( 1.0F - f ) / 2.0F ) * sin( Cur->BrinkSinCounter + PI ) + f + ( ( 1.0F - f ) / 2.0F ) ;
		if( Cur->CenterBright > target )
		{
			Cur->CenterBright -= (f32)PRM3[28] / 255.0F ;
			if( Cur->CenterBright < target ) Cur->CenterBright = target ;
		}
		else
		{
			Cur->CenterBright += (f32)PRM3[28] / 255.0F ;
			if( Cur->CenterBright > target ) Cur->CenterBright = target ;
		}
	}
	else
	{
		Cur->Bright += (f32)PRM3[28] / 255.0F ;
		if( Cur->Bright > 1.0F ) Cur->Bright = 1.0F ;

		Cur->CenterBright += (f32)PRM3[28] / 255.0F ;
		if( Cur->CenterBright > 1.0F ) Cur->CenterBright = 1.0F ;
	}
	
	// ItOĂIs
	if( Cur->EndFlag == TRUE )
	{
		if( Cur->EndCounter != PRM2[15] )
		{
			Cur->EndCounter ++ ;
		}
		Cur->Alpha = 1.0F - (f32)Cur->EndCounter / PRM2[15] ;
	}
	
	// Ԋ|
	if( Cur->AmiDrawFlag == TRUE )
	{
		Cur->AmiYFill += ( 100.0F - Cur->AmiYFill ) * PRM2[16] * 0.01F ;
		Cur->AmiXFill += ( 100.0F - Cur->AmiXFill ) * PRM2[16] * 0.01F ;
//		Cur->AmiYFill += PRM2[16] * 0.1F ;
//		Cur->AmiXFill += PRM2[16] * 0.1F ;
		
		if( Cur->AmiYFill > 99.0F ) Cur->AmiYFill = 100.0F ;
		if( Cur->AmiXFill > 99.0F ) Cur->AmiXFill = 100.0F ;
	}
	else
	{
		Cur->AmiYFill -= PRM2[16] * 0.1F ;
		Cur->AmiXFill -= PRM2[16] * 0.1F ;
		
		if( Cur->AmiYFill < 1.0F ) Cur->AmiYFill = 0.0F ;
		if( Cur->AmiXFill < 1.0F ) Cur->AmiXFill = 0.0F ;
	}
	
	// CJ[\̈ړ
	{
		Cur->mx = Cur->x2 - Cur->x ;
		Cur->my = Cur->y2 - Cur->y ;
		
		Cur->x = Cur->x2 ;
		Cur->y = Cur->y2 ;
	}
	
	// IuWFNg̃Zbg
	{
		if( Cur->LeftRightNum != Cur->LeftRightMovNum )
		{
			// Ȃꍇ͈CɌ炷
			if( Cur->LeftRightNum < Cur->LeftRightMovNum )
			{
				Cur->LeftRightMovNum = Cur->LeftRightNum ;
			}
			else
			{
				Cur->LeftRightCounter += 10 ;
				while( Cur->LeftRightCounter >= PRM2[10] &&
						Cur->LeftRightNum != Cur->LeftRightMovNum )
				{
					Cur->LeftRightMovNum ++ ;
					Cur->LeftRightCounter -= PRM2[10] ;
				}
			}
		}

		if( Cur->TopBottomNum != Cur->TopBottomMovNum )
		{
			// Ȃꍇ͈CɌ炷
			if( Cur->TopBottomNum < Cur->TopBottomMovNum )
			{
				Cur->TopBottomMovNum = Cur->TopBottomNum ;
			}
			else
			{
				Cur->TopBottomCounter += 10 ;
				while( Cur->TopBottomCounter >= PRM2[10] && 
						Cur->TopBottomNum != Cur->TopBottomMovNum )
				{
					Cur->TopBottomMovNum ++ ;
					Cur->TopBottomCounter -= PRM2[10] ;
				}
			}
		}
	}
	
	// ړIW̐ݒ
	{
		f32 dxl, dxr ;

		dy = Cur->Obj[2].dy - Cur->Obj[1].dy ;
		for( j = 0 ; j < 2 ; j ++ )
		{
			Obj = Cur->LeftRightObj[j] ;
			for( i = 0 ; i < CUR_OBJECTMAXNUM ; i ++, Obj ++ )
			{
				Obj->dx = Cur->Obj[j%2].dx ;
				if( i >= Cur->LeftRightMovNum )
				{
/*					Obj->dy = Cur->Obj[1+j].dy ;
					Obj->x = Cur->Obj[1+j].x ;
					Obj->y = Cur->Obj[1+j].y ;
*/
					*Obj = ( j == 0 ) ? Cur->Obj[0] : Cur->Obj[1] ;
				}
				else
				{
					Obj->dy = Cur->Obj[1].dy + dy * ( (f32)( i + 1 ) / ( Cur->LeftRightNum + 1 ) ) ;
					if( i >= Cur->BackLRMovNum && Cur->FastFlag == TRUE )
					{
						Obj->x = Cur->x + Obj->dx ;
						Obj->y = Cur->y + Obj->dy ;
					}
				}
			}
		}

		dxl = Cur->Obj[1].dx - Cur->Obj[0].dx ;
		dxr = Cur->Obj[0].dx - Cur->Obj[1].dx ;
		for( j = 0 ; j < 2 ; j ++ )
		{
			Obj = Cur->TopBottomObj[j] ;
			for( i = 0 ; i < CUR_OBJECTMAXNUM ; i ++, Obj ++ )
			{
				Obj->dy = Cur->Obj[1+j].dy ;
				if( i >= Cur->TopBottomMovNum )
				{
//					Obj->dx = Cur->Obj[j].dx ;
//					Obj->x = Cur->Obj[j].x ;
//					Obj->y = Cur->Obj[j].y ;
					*Obj = ( j == 0 ) ? ( ( i % 2 ) ? Cur->Obj[0] : Cur->Obj[1] ) :
										( ( i % 2 ) ? Cur->Obj[3] : Cur->Obj[2] ) ;
				}
				else
				{
					if( i % 2 )
					{
						Obj->dx = Cur->Obj[0].dx + dxl * ( (f32)( i / 2 + 1 ) / ( Cur->TopBottomNum + 1 ) ) ;
					}
					else
					{
						Obj->dx = Cur->Obj[1].dx + dxr * ( (f32)( i / 2 + 1 ) / ( Cur->TopBottomNum + 1 ) ) ;
					}
					
					if( i >= Cur->BackTBMovNum && Cur->FastFlag == TRUE )
					{
						Obj->x = Cur->x + Obj->dx ;
						Obj->y = Cur->y + Obj->dy ;
					}
				}
			}
		}
	}

	// J[\IuWFNg̏
	Obj = Cur->Obj ;
	for( i = 0 ; i < CUR_OBJECTNUM ; i ++, Obj ++ )	CurObjectFrameProcess( Cur, Obj ) ;

	for( j = 0 ; j < 2 ; j ++ )
	{
		Obj = Cur->LeftRightObj[j] ;
		for( i = 0 ; i < Cur->LeftRightMovNum ; i ++, Obj ++ ) CurObjectFrameProcess( Cur, Obj ) ;
	}

	for( j = 0 ; j < 2 ; j ++ )
	{
		Obj = Cur->TopBottomObj[j] ;
		for( i = 0 ; i < Cur->TopBottomMovNum ; i ++, Obj ++ ) CurObjectFrameProcess( Cur, Obj ) ;
	}
	
	Cur->BackLRMovNum = Cur->LeftRightMovNum ;
	Cur->BackTBMovNum = Cur->TopBottomMovNum ;

	// I
	return 0 ;
}


// J[\̃GtFNg`悷
extern s8 DrawCursorEffect( EFFECT *Effect )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;
	CURSOROBJECT *Obj ;
	s32 i, j ;
	f32 Len, x, y ;
//	u16 Color ;
	u8 r, g, b, a ;
	f32 AddX, AddY ;

	// ܂eNX`ǂݍ܂ĂȂ牽I
	if( CheckCursorData() == FALSE ) return 0 ;

	if( (CURSOREFFECT *)NULL == Cur ) return 0 ;

	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;

	// Ԋ|`
	if( Cur->AmiDrawFlag == TRUE )
	{
		s16 x, y, w, h ;
		f32 u, v, uw, vh ;
		s16 xw, yh ;
		u32 cr ;
		
		x = (s16)( Cur->Obj[0].x + PRM2[22] + SHADOWX ) ;
		y = (s16)( Cur->Obj[0].y + PRM2[22] + SHADOWY ) ;
		w = (s16)( ( ( Cur->Obj[2].x + SHADOWX ) - PRM2[22] ) - x ) ;
		h = (s16)( ( ( Cur->Obj[2].y + SHADOWY ) - PRM2[22] ) - y ) ;

		if( w <= 0 || h <= 0 ) goto R1 ;

		xw = (s16)w ;
		yh = (s16)( Cur->AmiXFill * h * 0.01F ) ;
	
		u = (f32)x / SCW ;					v = (f32)y / SCW ;
		uw = (f32)xw / SCW / PRM2[17] ;		vh = (f32)yh / SCW / PRM2[17] ;

		// Of[V̕`
		DrawGradBoxTB( x, y, x + xw, y + yh,
				CMKC2( Cur->AmiColorTop, ( Cur->AmiColorTop & 0xff ) * Cur->AmiXFill * 0.01F ),
				CMKC2( Cur->AmiColorBot, ( Cur->AmiColorBot & 0xff ) * Cur->AmiXFill * 0.01F ) ) ;
		
		// eNX`ǂݍ
		EffectTevSetup( EF_TEV_USETEX ) ;
		GTLOAD2( CurUnion.AmiTex ) ;
		
		cr = CMKC2( Cur->AmiColor, ( Cur->AmiColor & 0xff ) * Cur->Alpha * Cur->Alpha2 ) ;
		
		GXBegin( GX_QUADS, GX_VTXFMT0, 8 ) ;
		{
			GP2( x, 			y			) ;	GCX( cr ) ;	GT( u,		v ) ;
			GP2( ( x + xw ), 	y			) ;	GCX( cr ) ;	GT( u + uw,	v ) ;
			GP2( ( x + xw ), 	( y + yh )	) ;	GCX( cr ) ;	GT( u + uw,	v + vh ) ;
			GP2( x, 			( y + yh )	) ;	GCX( cr ) ;	GT( u,		v + vh ) ;

			x = (s16)( Cur->Obj[0].x + PRM2[22] ) ;
			y = (s16)( Cur->Obj[0].y + PRM2[22] ) ;
			w = (s16)( ( ( Cur->Obj[2].x ) - PRM2[22] ) - x ) ;
			h = (s16)( ( ( Cur->Obj[2].y ) - PRM2[22] ) - y ) ;

//			xw = (s16)( Cur->AmiXFill * w * 0.01F ) ;
//			yh = (s16)h ;
			xw = (s16)w ;
			yh = (s16)( Cur->AmiXFill * h * 0.01F ) ;
			
			y = (s16)( Cur->Obj[3].y + PRM2[22] - yh ) ;

			u = (f32)( x + 1 ) / SCW ;			v = (f32)y / SCW ;
			uw = (f32)xw / SCW / PRM2[17] ;		vh = (f32)yh / SCW / PRM2[17] ;

			GP2( x, 			y			) ;	GCX( cr ) ;	GT( u,		v ) ;
			GP2( ( x + xw ), 	y			) ;	GCX( cr ) ;	GT( u + uw,	v ) ;
			GP2( ( x + xw ), 	( y + yh )  ) ;	GCX( cr ) ;	GT( u + uw,	v + vh ) ;
			GP2( x, 			( y + yh )  ) ;	GCX( cr ) ;	GT( u,		v + vh ) ;
		}
		GXEnd() ;

	}
	R1 :
	EffectTevSetup( EF_TEV_NOTEX ) ;


	// CJ[\`
	GXSetLineWidth( (u8)LINEW, GX_TO_ONE ) ;
	Len = (f32)LINELEN ;
//	Color = GXPackedRGBA4( Cur->Color.r, Cur->Color.g, Cur->Color.b, Cur->Color.a ) ; 
	r = (u8)( Cur->Color.r * Cur->CenterBright ) ;
	g = (u8)( Cur->Color.g * Cur->CenterBright ) ;
	b = (u8)( Cur->Color.b * Cur->CenterBright ) ;
	a = (u8)( PRM2[9] / AIMAGENUM * Cur->Alpha * Cur->Alpha2 ) ;
	a = (u8)( Cur->Color.a * Cur->Alpha2 * ( (f32)PRM4[6] / 255.0F ) ) ;
	AddX = (f32)SHADOWX ;
	AddY = (f32)SHADOWY ;
	if( Cur->CenterDrawFlag == TRUE )
	{
		GXBegin( GX_LINES, GX_VTXFMT0, (u16)( ( 4 + ( Cur->ShadowFlag == TRUE ? 4 : 0 ) ) * ( 1 + AIMAGENUM ) ) ) ;
		{
			if( Cur->ShadowFlag )
			{
				GP2( (s32)( ( Cur->x - Len + AddX ) ), (s32)( ( Cur->y + AddY ) ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
				GP2( (s32)( ( Cur->x + Len + AddX ) ), (s32)( ( Cur->y + AddY ) ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;

				GP2( (s32)( ( Cur->x + AddX ) ), (s32)( ( Cur->y - Len + AddY ) ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
				GP2( (s32)( ( Cur->x + AddX ) ), (s32)( ( Cur->y + Len + AddY ) ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;

				for( j = 0 ; j < AIMAGENUM ; j ++ )
				{
					x = Cur->x - Cur->mx * j / AIMAGENUM ;
					y = Cur->y - Cur->my * j / AIMAGENUM ;

					GP2( (s32)( ( x - Len + AddX ) ), (s32)( ( y + AddY ) ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
					GP2( (s32)( ( x + Len + AddX ) ), (s32)( ( y + AddY ) ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;

					GP2( (s32)( ( x + AddX ) ), (s32)( ( y - Len + AddY ) ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
					GP2( (s32)( ( x + AddX ) ), (s32)( ( y + Len + AddY ) ) ) ; 	GC4( 0, 0, 0, a ) ; // GXColor1u16( Color ) ;
				}
			}
	
			GP2( (s32)( ( Cur->x - Len ) ), (s32)( Cur->y ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
			GP2( (s32)( ( Cur->x + Len ) ), (s32)( Cur->y ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;

			GP2( (s32)( Cur->x ), (s32)( ( Cur->y - Len ) ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
			GP2( (s32)( Cur->x ), (s32)( ( Cur->y + Len ) ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;

			for( j = 0 ; j < AIMAGENUM ; j ++ )
			{
				x = Cur->x - Cur->mx * j / AIMAGENUM ;
				y = Cur->y - Cur->my * j / AIMAGENUM ;

				GP2( (s32)( ( x - Len ) ), (s32)( y ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
				GP2( (s32)( ( x + Len ) ), (s32)( y ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;

				GP2( (s32)( x ), (s32)( ( y - Len ) ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
				GP2( (s32)( x ), (s32)( ( y + Len ) ) ) ; 	GC4( r, g, b, a ) ; // GXColor1u16( Color ) ;
			}
		}
		GXEnd() ;
	}

	// _ŒǂŐFύX
	if( Cur->BrinkState == TRUE )
	{
		r = (u8)PRM2[25] ;
		g = (u8)PRM2[26] ;
		b = (u8)PRM2[27] ;
	}
	else
	{
		r = (u8)( Cur->Color.r * Cur->Bright ) ;
		g = (u8)( Cur->Color.g * Cur->Bright ) ;
		b = (u8)( Cur->Color.b * Cur->Bright ) ;
	}

	// IuWFNg`
	{
		Len = (f32)PRM2[2] ;
		a = (u8)( Cur->Color.a * Cur->Alpha2 ) ;
		GXSetLineWidth( (u8)PRM2[1], GX_TO_ONE ) ;
		GXBegin( GX_LINES, GX_VTXFMT0,
				 (u16)(
				  ( CUR_OBJECTNUM + Cur->LeftRightMovNum * 2 + Cur->TopBottomMovNum * 2 ) *
				  ( ( 4 + ( Cur->ShadowFlag == TRUE ? 4 : 0 ) ) * ( 1 + AIMAGENUM ) ) ) ) ;
		{
			Obj = Cur->Obj ;
			for( i = 0 ; i < CUR_OBJECTNUM ; i ++, Obj ++ )
				CurObjectRenderProcess( Obj, r, g, b, a, Len, Cur->ShadowFlag ) ;

			for( j = 0 ; j < 2 ; j ++ )
			{
				Obj = Cur->LeftRightObj[j] ;
				for( i = 0 ; i < Cur->LeftRightMovNum ; i ++, Obj ++ ) CurObjectRenderProcess( Obj, r, g, b, a, Len, Cur->ShadowFlag ) ;
			}

			for( j = 0 ; j < 2 ; j ++ )
			{
				Obj = Cur->TopBottomObj[j] ;
				for( i = 0 ; i < Cur->TopBottomMovNum ; i ++, Obj ++ ) CurObjectRenderProcess( Obj, r, g, b, a, Len, Cur->ShadowFlag ) ;
			}
		}
		GXEnd() ;
	}
	
	// I
	return 0 ;
}

// J[\̕\WƃTCYύX
extern s8 SetCursorPos( u16 x, u16 y,
						s16 Width, s16 Height, EFFECT *Effect,
						s8 BaseLeftTopFlag, s8 InitBaseLeftTopFlag )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;

	if( Width <= -1 ) Width = (s16)( Cur->Obj[1].dx - Cur->Obj[0].dx ) ;
	if( Height <= -1 ) Height = (s16)( Cur->Obj[2].dy - Cur->Obj[1].dy ) ;

	Cur->x2 = x ;
	Cur->y2 = y ;
	if( BaseLeftTopFlag == TRUE )
	{
		Cur->Obj[0].dx = 0 ; 		Cur->Obj[0].dy = 0 ;
		Cur->Obj[1].dx = Width ; 	Cur->Obj[1].dy = 0 ;
		Cur->Obj[2].dx = Width ; 	Cur->Obj[2].dy = Height ;
		Cur->Obj[3].dx = 0 ; 		Cur->Obj[3].dy = Height ;
		
		if( Cur->DrawFlag == FALSE )
		{
			if( InitBaseLeftTopFlag == TRUE )
			{
				Cur->Obj[0].x = Cur->x2 ;	Cur->Obj[0].y = Cur->y2 ;
				Cur->Obj[1].x = Cur->x2 ;	Cur->Obj[1].y = Cur->y2 ;
				Cur->Obj[2].x = Cur->x2 ;	Cur->Obj[2].y = Cur->y2 ;
				Cur->Obj[3].x = Cur->x2 ;	Cur->Obj[3].y = Cur->y2 ;
			}
			else
			{
				Width /= 2 ;
				Height /= 2 ;
				Cur->Obj[0].x = Cur->x2 + Width ;	Cur->Obj[0].y = Cur->y2 + Height ;
				Cur->Obj[1].x = Cur->x2 + Width ;	Cur->Obj[1].y = Cur->y2 + Height ;
				Cur->Obj[2].x = Cur->x2 + Width ;	Cur->Obj[2].y = Cur->y2 + Height ;
				Cur->Obj[3].x = Cur->x2 + Width ;	Cur->Obj[3].y = Cur->y2 + Height ;
			}
		}
	}
	else
	{
		Width /= 2 ;
		Height /= 2 ;
		Cur->Obj[0].dx = -Width ; 	Cur->Obj[0].dy = -Height ;
		Cur->Obj[1].dx = Width ; 	Cur->Obj[1].dy = -Height ;
		Cur->Obj[2].dx = Width ; 	Cur->Obj[2].dy = Height ;
		Cur->Obj[3].dx = -Width ; 	Cur->Obj[3].dy = Height ;

		if( Cur->DrawFlag == FALSE )
		{
			if( InitBaseLeftTopFlag == TRUE )
			{
				Cur->Obj[0].x = Cur->x2 - Width ;	Cur->Obj[0].y = Cur->y2 - Height ;
				Cur->Obj[1].x = Cur->x2 - Width ;	Cur->Obj[1].y = Cur->y2 - Height ;
				Cur->Obj[2].x = Cur->x2 - Width ;	Cur->Obj[2].y = Cur->y2 - Height ;
				Cur->Obj[3].x = Cur->x2 - Width ;	Cur->Obj[3].y = Cur->y2 - Height ;
			}
			else
			{
				Cur->Obj[0].x = Cur->x2 ;	Cur->Obj[0].y = Cur->y2 ;
				Cur->Obj[1].x = Cur->x2 ;	Cur->Obj[1].y = Cur->y2 ;
				Cur->Obj[2].x = Cur->x2 ;	Cur->Obj[2].y = Cur->y2 ;
				Cur->Obj[3].x = Cur->x2 ;	Cur->Obj[3].y = Cur->y2 ;
			}
		}
	}

	// I
	return 0 ;
}
	

// J[\GtFNg`悷邩ǂ̃tOZbg
extern s8 SetCursorDrawFlag( u8 DrawFlag, EFFECT *Effect )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;
	
	Cur->DrawFlag = DrawFlag ;
	
	// I
	return 0 ;
}

// J[\̕`掞̃At@l𓾂
extern s8 GetCursorDrawAlpha( EFFECT * Effect )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;
	
	return (s8)( Cur->Alpha2 * 255 ) ;
}


// SɂObh`悷邩ǂ̃tOZbg
extern s8 SetCenterCursorDrawFlag( u8 DrawFlag, EFFECT *Effect )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;
	
	Cur->CenterDrawFlag = DrawFlag ;
	
	// I
	return 0 ;
}	

// FύX
extern s8 SetCursorColor( EFFECT *Effect, GXColor color )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;
	
	Cur->Color = color ;
	
	// I
	return 0 ;
}

	

// EɂIuWFNg̐ύX
extern s8 SetCursorLeftRightObjectNum( EFFECT *Effect, u16 Num )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;

	// Zbg
	Cur->TopBottomNum = Num ;

	// I
	return 0 ;
}

// ㉺ɂIuWFNg̐ύX
extern s8 SetCursorTopBottomObjectNum( EFFECT *Effect, u16 Num )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;

	// Zbg
	Cur->LeftRightNum = Num ;
	
	// I
	return 0 ;
}

// J[\̏IJn
extern s8 EndReqCursorEffect( EFFECT *Effect )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;
	
	Cur->EndFlag = TRUE ;
	Cur->EndCounter = 0 ;

	// I
	return 0 ;
}

// J[\ɉe邩ǂ̃tOύX
extern s8 SetCursorShadowFlag( EFFECT *Effect, s8 Flag )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;

	Cur->ShadowFlag = Flag ;

	// I
	return 0 ; 
}

// S̃IuWFNg͂ɖԊ|{ǂݒ肷
extern s8 SetCursorAmikakeFlag( EFFECT *Effect, s8 Flag ) 
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;

	Cur->AmiDrawFlag = (u8)Flag ;
	Cur->AmiCounter = 0 ;
	
	// I
	return 0 ;
}

// J[\̓_Ń[hύX
extern s8 SetCursorBrinkMode( EFFECT *Effect, s8 Mode )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;

	Cur->BrinkMode = Mode ;
	switch( Mode )
	{
	case 0 :
		Cur->CharBrinkState = Cur->BrinkState = 0 ;
		break ;
	
	case 1 :
		Cur->CharBrinkCounter1 = Cur->BrinkCounter1 = 0 ;
		Cur->CharBrinkCounter2 = Cur->BrinkCounter2 = 0 ;
		Cur->CharBrinkCounter3 = Cur->BrinkCounter3 = (s8)PRM2[28] ;
		Cur->CharBrinkState = Cur->BrinkState = 1 ;
		break ;
		
	case 2 :
		Cur->CharBrinkCounter1 = Cur->BrinkCounter1 = 0 ;
		Cur->CharBrinkCounter2 = Cur->BrinkCounter2 = 0 ;
		Cur->CharBrinkCounter3 = Cur->BrinkCounter3 = 0 ;
		Cur->CharBrinkState = Cur->BrinkState = 1 ;
		break ;

	case 3 :
		Cur->CharBrinkState = Cur->BrinkState = 0 ;
		Cur->BrinkSinCounter = 0.0F ;
		break ;
	}

	// I
	return 0 ;
}

// J[\̓_ŏԂ擾( 0:Ă 1:tĂ )
extern s8 GetCursorBrinkState( EFFECT *Effect )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;

	return Cur->BrinkState ;
}

// J[\̋t_ŏԂ擾( 0:Ă 1:tĂ )
extern s8 GetCursorBrinkState2( EFFECT *Effect )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;

	return (s8)Cur->CharBrinkState ;
}

// J[\̋tŏԂ擾( 0.0F:Ă  1.0F:_Ă )
extern f32 GetCursorBrinkState3( EFFECT *Effect )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;

	return Cur->Bright ;
}
	
// Ԃ̉ɕ`悷v[g̐Fݒ肷
extern s8 SetCursorAmiColor( EFFECT *Effect, u32 colorami, u32 colortop, u32 colorbottom )
{
	CURSOREFFECT *Cur = ( CURSOREFFECT * )Effect->Data ;
	
	Cur->AmiColorTop = colortop ;
	Cur->AmiColorBot = colorbottom ;
	Cur->AmiColor = colorami ;

	return 0 ;
}


