///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectEasyAnim
//
// YK7EffectEasyAnim.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/01/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectEasyAnim.h"
#include "./YK7EasyAnim.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

#define ADDCOUNT		(4800 / 30)						// Pt[̃`bN^CJEg
#define ANIMLISTNAME	"/Yam/Effect/EasyAnim/Anim"		// Aj[VXgǂݍݗpt@Cl[

// datatype -------------------------------------

// data -----------------------------------------

EASYANIMUNION EaUnion ;

// function proto type --------------------------

// function code --------------------------------

// Aj[Vf[^[h
extern s8 LoadEasyAnimPack( s8 AnimID )
{
	// ŵhc̃Aj[Vǂݍ܂ĂȂǂݍ
	if( EaUnion.AnimPackID[AnimID] == -1 )
	{
		char FilePath[256] ;
		
		sprintf( FilePath, "%s%02d.bin", ANIMLISTNAME, (int)AnimID ) ;
		EaUnion.AnimPackID[AnimID] = LoadEasyAnimData( FilePath ) ;
		
		// G[̎ -1 Ԃ
		if( EaUnion.AnimPackID[AnimID] == -1 ) return -1 ;
		
		// JE^
		EaUnion.AnimPackCounter[AnimID] = 1 ;
	}
	else
	{
		// JE^CNg
		EaUnion.AnimPackCounter[AnimID] ++ ;
	}

	// I
	return 0 ;
}

// Aj[Vf[^
extern s8 ReleaseEasyAnimPack( s8 AnimID )
{
	// ĂȂ
	if( EaUnion.AnimPackID[AnimID] != -1 )
	{
		// JE^fNg
		EaUnion.AnimPackCounter[AnimID] -- ;
		
		// 0ɂȂ
		if( EaUnion.AnimPackCounter[AnimID] == 0 )
		{
			ReleaseEasyAnimData( (s8)EaUnion.AnimPackID[AnimID] ) ;
			EaUnion.AnimPackID[AnimID] = -1 ;
		}
	}

	// I
	return 0 ;
}

// Aj[Vf[^ǂݍ܂Ă邩ǂ`FbN( TRUE:ǂݍ܂Ă   FALSE:ǂݍ܂ĂȂ )
extern s8 CheckEasyAnimPackLoadState( s8 AnimID )
{
	// gĂȂ FALSE Ԃ
	if( EaUnion.AnimPackID[AnimID] == -1 ) return FALSE ;

	// ԂԂ
	return CheckEasyAnimDataLoadState( (s8)EaUnion.AnimPackID[AnimID] ) ;
}
	


// ȈՃAj[Vf[^ǂݍ
extern s8 LoadEasyAnimData( char *FileName )
{
	s8 NewPackID ;
	EASYANIMPACK *AnimP ;
	s32 Size, i ;
	u32 len ;
	char NameBuf[64] ;

	// Ƀ[hĂ鐔ςς牽I
	if( EaUnion.AnimPackNum == ANIMPACK_MAXNUM ) return -1 ;

	// gĂȂpbNf[^T
	for( NewPackID = 0, AnimP = EaUnion.AnimPack ;
			AnimP->UseFlag == TRUE ; AnimP ++, NewPackID ++ ){}

	// ghmGcFile IuWFNg쐬			
	ghmGcMemSetAllocName("YLdEAnim");
	if( ( AnimP->File = new ghmGcFile ) == NULL ) return -1;

	// t@CJ
	if( AnimP->File->Open( FileName ) == false )
	{
		delete AnimP->File ;
		AnimP->File = NULL ;
		return -1 ;
	}

	// t@C̃TCY𓾂
	Size = (s32)OSRoundUp32B( AnimP->File->GetLength(true) ) ;

	// t@C쐬
	{
		strcpy( NameBuf, "Y_" ) ;
		GetFileName( FileName, &NameBuf[2] ) ;
	}

	// mۂ
	AnimP->Head = ( EASYANIMHEAD * )ghmGcMemAllocName( Size, NameBuf ) ;
	if( AnimP->Head == NULL )
	{
		delete AnimP->File ;
		AnimP->File = NULL ;
		return -1 ;
	}
/*
	if( ( AnimP->Anim = ( TEXDATA * )ghmGcMemAllocName( sizeof( TEXDATA ) * ANIMPACK_ANIMNUM, "AnimTex" ) ) == NULL )
	{
		ghmGcMemFree( AnimP->Head ) ;
		delete AnimP->File ;
		AnimP->File = NULL ;
		return -1 ;
	}
*/

	AnimP->File->Read( AnimP->Head, 0, Size ) ;				// ۂƃ[h
	memset( &AnimP->TexObj, 0, sizeof( AnimP->TexObj ) ) ;	// eNX`IuWFNg NULL Zbg
	for( i = 0 ; i < ANIMPACK_ANIMNUM ; i ++ )
		memset( &AnimP->Anim[i], 0, sizeof( TEXDATA ) ) ;	// eNX`f[^ NULL Zbg
	
	// AԃeNX`̃`FbN
	AnimP->AnimNum = 0 ;
	len = strlen(FileName) ;
	if( len > 4 && FileName[len-4] == '.' )
	{
		char FilePath[128], temp[64] ;
		u32 i ;
		
		len -= 4 ;
		strncpy( temp, FileName, len ) ;
		temp[len] = '\0' ;
		
		for( i = 0 ; i < ANIMPACK_ANIMNUM ; i ++ )
		{
			sprintf( FilePath, "%s_%02d.BIN", temp, i ) ;
			if( TexLoadSet( FilePath, &AnimP->Anim[i] ) == FALSE ) break ;
		}
		AnimP->AnimNum = (u8)i ;
	}

	AnimP->FileFlag = TRUE ;			// t@Cǂݍ񂾃tO𗧂Ă
	AnimP->UseFlag = TRUE ;				// gptO𗧂Ă
	
	EaUnion.AnimPackNum ++ ;			// gp̃pbNf[^̐𑝂₷
	
	// pbNhcԂ
	return NewPackID ;
}

// ȈՃAj[Vf[^(bin)Zbg(Rs[͂܂̂ ReleaseEasyAnimData ܂œnf[^͉Ȃł)
extern s8 SetupEasyAnimData( void *AnimData )
{
	s8 NewPackID ;
	EASYANIMPACK *AnimP ;

	// Ƀ[hĂ鐔ςς牽I
	if( EaUnion.AnimPackNum == ANIMPACK_MAXNUM ) return -1 ;

	// gĂȂpbNf[^T
	for( NewPackID = 0, AnimP = EaUnion.AnimPack ;
			AnimP->UseFlag == TRUE ; AnimP ++, NewPackID ++ ){}
	
	// f[^AhXZbg
	AnimP->Head = ( EASYANIMHEAD * )AnimData ;

	// gȂ̂ NULL Zbg
	AnimP->File = NULL  ;

	// eNX`̃ZbgAbvs
	{
		GhmGcTexHeader *Tex = ( GhmGcTexHeader * )( ( u8 * )AnimP->Head + AnimP->Head->TexOffset ) ;

		// eNX`̃ZbgAbv
		
		// eNX`쐬
		GXInitTexObj( &AnimP->TexObj, GHMGCTEX_GETIMAGE(Tex),
						 Tex->mWidth, Tex->mHeight, Tex->mFormat,
						  GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
		GXInitTexObjLOD( &AnimP->TexObj, GX_LINEAR, GX_LINEAR, Tex->mMinLOD, Tex->mMaxLOD, 0.0F,
							GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;
	}
	
	// Aԃt@C͐悸
	AnimP->AnimNum = 0 ;

	// t@Cǂݍ񂾃tO|
	AnimP->FileFlag = FALSE ;

	// gptO𗧂Ă
	AnimP->UseFlag = TRUE ;
	
	// gp̃f[^̐𑝂₷
	EaUnion.AnimPackNum ++ ;
	
	// pbNhcԂ
	return NewPackID ;
}

// ȈՃAj[Vf[^
extern s8 ReleaseEasyAnimData( s8 AnimPackID )
{
	EASYANIMPACK *AnimP ;
	
	AnimP = &EaUnion.AnimPack[AnimPackID] ;
	
	// ɎgĂȂ牽I
	if( AnimP->UseFlag == FALSE ) return 0 ;
	
	// t@Cǂݍ܂Ă邩tOĂ邩ǂŏ𕪊
	if( AnimP->FileFlag == TRUE )
	{
		s32 i ;
	
		// AԃeNX`
		for( i = 0 ; i < AnimP->AnimNum ; i ++ )
			TexRelease( &AnimP->Anim[i] ) ;

		// t@C
		CLOSECHK( AnimP->File ) ;
		
		// 
		CHKMEMFREE( AnimP->Head ) ;
//		CHKMEMFREE( AnimP->Anim ) ;
	}
	
	// gptO|
	AnimP->UseFlag = FALSE ;
	
	// ǂݍłpbNf[^̐炷
	EaUnion.AnimPackNum -- ;
	
	// I
	return 0 ;
}

// ȈՃAj[Vf[^ǂݍ܂Ă邩ǂ`FbN( TRUE:ǂݍ܂Ă  FALSE:ǂݍ܂ĂȂ )
extern s8 CheckEasyAnimDataLoadState( s8 AnimPackID )
{
	EASYANIMPACK *AnimP ;
	s32 i ;
	
	AnimP = &EaUnion.AnimPack[AnimPackID] ;
	
	// ɎgĂȂ FALSE Ԃ
	if( AnimP->UseFlag == FALSE ) return FALSE ;

	// AԃeNX`ǂݍݏIĂ邩`FbN
	for( i = 0 ; i < AnimP->AnimNum ; i ++ )
		if( TexLoadChk( &AnimP->Anim[i] ) == FALSE ) return FALSE ;

	
	// ԂԂ
	return AnimP->FileFlag == FALSE ? (s8)TRUE : (s8)CHKFILELOAD( AnimP->File ) ;
}
	

	


// ȈՃAjGtFNg̋ʃf[^
extern s8 InitEasyAnimData( void )
{
	EASYANIMUNION *EasyAnimUnion = &EaUnion ;

	MEMINIT( EaUnion ) ;
	
	// hc蓖Ă
	{
		u8 i ;
		
		for( i = 0 ; i < ANIMID_NUM ; i ++ )
			EaUnion.AnimPackID[i] = -1 ;
	}

	// I
	return 0 ;
}

// ȈՃAjGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckEasyAnimData( void )
{
	return TRUE ;
}


// ȈՃAjGtFNg̋ʃf[^n
extern s8 EndEasyAnimData( void )
{
	EASYANIMUNION *EasyAnimUnion = &EaUnion ;
	
	// ĂȂȈՃAj[VpbNf[^ׂĉ
	{
		u8 i ;
		
		for( i = 0 ; i < ANIMPACK_MAXNUM ; i ++ )
		{
			if( EaUnion.AnimPack[i].UseFlag == TRUE )
			{
				ReleaseEasyAnimData( (s8)i ) ;
			}
		}
	}
		
	// f[^؋Zbg
	{
		u8 i ;
		
		for( i = 0 ; i < ANIMID_NUM ; i ++ )
			EaUnion.AnimPackID[i] = -1 ;
	}

	// I
	return 0 ;
}

// ȈՃAjGtFNg쐬2
extern EFFECT *CreateEasyAnimEffect2( s8 AnimID, Vec Point, Vec Size,
										u8 AddBlendFlag, s32 Sound, s8 NonLoopFlag, s8 Pos2DFlag , s32 Priority )
{
	return CreateEasyAnimEffect( (s8)EaUnion.AnimPackID[AnimID], Point, Size, AddBlendFlag, Sound, NonLoopFlag, Pos2DFlag, Priority ) ;
}

// ȈՃAjGtFNg쐬
extern EFFECT *CreateEasyAnimEffect( s8 AnimPackID, Vec Point, Vec Size,
										u8 AddBlendFlag, s32 Sound, s8 NonLoopFlag, s8 Pos2DFlag, s32 Priority )
{
	EFFECT *Effect ;
	EASYANIMEFFECT *Ea ;

	// VȈՃAjf[^쐬
	Effect = AddEffectData( EFF_EASYANIM, (void**)&Ea, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// pϐ̏
	Ea->AnimPackID = AnimPackID ;
	Ea->Point = Point ;
	Ea->Size = Size ;
	Ea->AddBlendFlag = AddBlendFlag ;
	Ea->AnimCounter = 0 ;
	Ea->AnimPatNum = 0 ;
	Ea->DrawFlag = TRUE ;
	Ea->WaitFrameTime = 0xffffffff ;
	Ea->NonLoopFlag = NonLoopFlag ;
	Ea->Pos2DFlag = Pos2DFlag ;

	// ʉ̍Đ
	if( Sound != -1 && GetEffectSoundOffFlag() == FALSE )
	{
		PlayEffectSE( Sound, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
	}

	// I
	return Effect ;
}

// ȈՃAj̃GtFNǧns
extern s8 ReleaseEasyAnimEffect( EFFECT *Effect )
{
	EASYANIMEFFECT *Ea = ( EASYANIMEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// ȈՃAj̃GtFNgPt[
extern s8 MoveEasyAnimEffect( EFFECT *Effect )
{
	EASYANIMEFFECT *Ea = ( EASYANIMEFFECT * )Effect->Data ;
	EASYANIMPACK *Pack = &EaUnion.AnimPack[Ea->AnimPackID] ;
	EASYANIMHEAD *Head ;
//	u32 FrameTime ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// f[^A폜tOĂ폜
	if( Pack->UseFlag == FALSE && Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// pbNf[^ǂݏIĂȂ牽I
	if( CHKFILELOAD( Pack->File ) == FALSE ) return 0 ;
	
	// wb_̃AhXZbg
	Head = Pack->Head ;
	
	// pbNf[^ǂݏIĂꍇ̓eNX`̃ZbgAbvIĂ邩ׂ
	{
		if( Pack->File != NULL )
		{
			s32 i ;
		
			// gGfBArbOGfBAɃf[^ϊ
			Head->w = (u16)( ( ( Head->w & 0xff00 ) >> 8 ) | ( ( Head->w & 0xff ) << 8 ) ) ;
			Head->h = (u16)( ( ( Head->h & 0xff00 ) >> 8 ) | ( ( Head->h & 0xff ) << 8 ) ) ;
			Head->TexOffset = (u16)( ( ( Head->TexOffset & 0xff00 ) >> 8 ) | ( ( Head->TexOffset & 0xff ) << 8 ) ) ;
			Head->OneFrameTime = (u16)( ( ( Head->OneFrameTime & 0xff00 ) >> 8 ) | ( ( Head->OneFrameTime & 0xff ) << 8 ) ) ;

			for( i = 0 ; i < EASYANIM_TEXMAXNUM ; i ++ )
			{
				Head->ChipInfo[i].DrawX = (u16)( ( ( Head->ChipInfo[i].DrawX & 0xff00 ) >> 8 ) | ( ( Head->ChipInfo[i].DrawX & 0xff ) << 8 ) ) ;
				Head->ChipInfo[i].DrawY = (u16)( ( ( Head->ChipInfo[i].DrawY & 0xff00 ) >> 8 ) | ( ( Head->ChipInfo[i].DrawY & 0xff ) << 8 ) ) ;
			}

			// IĂȂeNX`̃ZbgAbvs
			{
				GhmGcTexHeader *Tex = ( GhmGcTexHeader * )( ( u8 * )Head + Head->TexOffset ) ;

				GXInitTexObj( &Pack->TexObj, GHMGCTEX_GETIMAGE(Tex),
								 Tex->mWidth, Tex->mHeight, Tex->mFormat,
								  GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
				GXInitTexObjLOD( &Pack->TexObj, GX_LINEAR, GX_LINEAR, Tex->mMinLOD, Tex->mMaxLOD, 0.0F,
									GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;
			}

			// t@C
			CLOSECHK( Pack->File ) ;
			
			// NULL Zbg
			Pack->File = NULL ;
		}
	}
	
	// Aj[VJEgCNg
	Ea->AnimCounter += ADDCOUNT ;
	
	// \ԂzĂ琳Aj[Vp^[܂Ńp^[io[ڍs
//	( Head->FrameInfo[Ea->AnimPatNum].RandomFlag == FALSE && Ea->AnimCounter > Head->FrameInfo[Ea->AnimPatNum].FrameInfo * Head->OneFrameTime ) ||
//	( Head->FrameInfo[Ea->AnimPatNum].RandomFlag == TRUE && Ea->AnimCounter > ( rand() * Head->FrameInfo[Ea->AnimPatNum].FrameInfo / RAND_MAX + Head->FrameInfo[Ea->AnimPatNum].FrameInfo / 10 ) * Head->OneFrameTime ) )
	if( Ea->WaitFrameTime == 0xffffffff )
	{
		Ea->WaitFrameTime = Head->FrameInfo[Ea->AnimPatNum].FrameInfo ;
		if( Head->FrameInfo[Ea->AnimPatNum].RandomFlag == TRUE ) 
			Ea->WaitFrameTime = (u32)( rand() * ( Ea->WaitFrameTime - Ea->WaitFrameTime / 10 ) / RAND_MAX + Ea->WaitFrameTime / 10 ) ;
		Ea->WaitFrameTime *= Head->OneFrameTime ;
	}
	while( Ea->AnimCounter >= Ea->WaitFrameTime )
	{
		Ea->AnimCounter -= Ea->WaitFrameTime ;
		Ea->AnimPatNum ++ ;
		
		// Aj[V̏I[ɒBĂ܂烋[vtOꍇ͍폜
		if( Ea->AnimPatNum == Head->FrameInfoNum )
		{
			if( Head->LoopFlag == TRUE && Ea->NonLoopFlag == FALSE )
			{
				Ea->AnimPatNum = 0 ;
			}
			else
			{
				DeleteEffect( Effect ) ;
				return 0 ;
			}
		}
		Ea->WaitFrameTime = Head->FrameInfo[Ea->AnimPatNum].FrameInfo ;
		if( Head->FrameInfo[Ea->AnimPatNum].RandomFlag == TRUE ) 
			Ea->WaitFrameTime = (u32)( rand() * ( Ea->WaitFrameTime - Ea->WaitFrameTime / 10 ) / RAND_MAX + Ea->WaitFrameTime / 10 ) ;
		Ea->WaitFrameTime *= Head->OneFrameTime ;
	}

	// I
	return 0 ;
}
			

// ȈՃAj̃GtFNg`悷
extern s8 DrawEasyAnimEffect( EFFECT *Effect )
{
	EASYANIMEFFECT *Ea = ( EASYANIMEFFECT * )Effect->Data ;
	EASYANIMPACK *Pack = &EaUnion.AnimPack[Ea->AnimPackID] ;
	EASYANIMHEAD *Head ;
	Mtx TMtx ;
	GhmGcTexHeader *Tex ;

//	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( EaUnion.NotDrawFlag == TRUE ) return 0 ;
	if( Pack->UseFlag == FALSE ) return 0 ;											// f[^牽I
	if( CHKFILELOAD( Pack->File ) == FALSE && Pack->File != NULL ) return 0 ;		// pbNf[^ǂݏIĂȂ牽I
	if( Ea->DrawFlag == FALSE ) return 0 ;											// `tO|Ă牽ɏI

	// wb_̃Zbg
	Head = Pack->Head ;
	Tex = ( GhmGcTexHeader * )( ( u8 * )Head + Head->TexOffset ) ;
	if( Head->FrameInfo[Ea->AnimPatNum].PatNumber == -1 ) return 0 ;				// eNX` -1 牽I

	EffectRenderSetup( Ea->Pos2DFlag == TRUE ? EF_PROJECT_ORTHO : EF_PROJECT_PERS,
						Ea->AddBlendFlag != TRUE ? EF_BLEND_ADD : EF_BLEND_ALPHA, EF_TEV_USETEX ) ;	// `揀
	if( Ea->Pos2DFlag == FALSE ) EffectGetInvViewMatrix( TMtx ) ;			// ]us擾

	// eNX`̃[h
	if( Pack->AnimNum == 0 )
	{
		GTLOAD( &Pack->TexObj ) ;
	}
	else
	{
		GTLOAD2( Pack->Anim[Head->FrameInfo[Ea->AnimPatNum].PatNumber] ) ;
	}

	// `揈
	GBGN( GX_QUADS, 4 ) ;
	{
		if( Ea->Pos2DFlag == TRUE )
		{
			f32 u, v, w, h, gw, gh ;
			
			gw = Ea->Size.x * Head->w ;
			gh = Ea->Size.y * Head->h ;

			// W̃Zbg
			if( Pack->AnimNum == 0 )
			{
				u16 Pitch, Height ;
				
				Pitch = (u16)( Tex->mWidth / Head->w ) ;
				Height = (u16)( Tex->mHeight / Head->h ) ;
			
				u = (f32)( Head->FrameInfo[Ea->AnimPatNum].PatNumber % Pitch ) / Pitch ;
				v = (f32)( Head->FrameInfo[Ea->AnimPatNum].PatNumber / Pitch ) / Height ;
				w = 1.0F / Pitch - 1.0F / Tex->mWidth ;
				h = 1.0F / Height - 1.0F / Tex->mHeight ;

				DrawTex4NB( Ea->Point.x - gw / 2.0F, Ea->Point.y - gh / 2.0F,
							Ea->Point.x + gw / 2.0F, Ea->Point.y + gh / 2.0F,
							u, v, u + w, v + h, 0xffffffff ) ;
			}
			else
			{
				EASYANIMCHIP *cp = &Head->ChipInfo[Head->FrameInfo[Ea->AnimPatNum].PatNumber] ;
				GhmGcTexHeader *hd = Pack->Anim[Head->FrameInfo[Ea->AnimPatNum].PatNumber].Data.Header ;

				DrawTex3NB( Ea->Point.x + ( (f32)cp->DrawX / Head->w - 0.5F ) * gw,
							Ea->Point.y + ( (f32)cp->DrawY / Head->h - 0.5F ) * gh,
							Ea->Point.x + ( (f32)( cp->DrawX + hd->mWidth ) / Head->w - 0.5F ) * gw,
							Ea->Point.y + ( (f32)( cp->DrawY + hd->mHeight ) / Head->h - 0.5F ) * gh, 0xffffffff ) ;
			}
		}
		else
		{
			Vec P[4], P2[4] ;
			f32 u, v, w, h ;
			
			// W̃Zbg
			if( Pack->AnimNum == 0 )
			{
				P[0].x = -Ea->Size.x / 2.0F ;		P[0].y = Ea->Size.y / 2.0F ;		P[0].z = 0.0F ;
				P[1].x = Ea->Size.x / 2.0F ;		P[1].y = Ea->Size.y / 2.0F ;		P[1].z = 0.0F ;
				P[2].x = Ea->Size.x / 2.0F ;		P[2].y = -Ea->Size.y / 2.0F ;		P[2].z = 0.0F ;
				P[3].x = -Ea->Size.x / 2.0F ;		P[3].y = -Ea->Size.y / 2.0F ;		P[3].z = 0.0F ;
			}
			else
			{
				EASYANIMCHIP *cp = &Head->ChipInfo[Head->FrameInfo[Ea->AnimPatNum].PatNumber] ;
				GhmGcTexHeader *hd = Pack->Anim[Head->FrameInfo[Ea->AnimPatNum].PatNumber].Data.Header ;
			
				P[0].x = ( (f32)cp->DrawX / Head->w - 0.5F ) * Ea->Size.x ;
				P[0].y = ( -(f32)cp->DrawY / Head->h + 0.5F ) * Ea->Size.y ;
				P[0].z = 0.0F ; 
				
				P[1].x = ( (f32)( cp->DrawX + hd->mWidth ) / Head->w - 0.5F ) * Ea->Size.x ;
				P[1].y = ( -(f32)cp->DrawY / Head->h + 0.5F ) * Ea->Size.y ;
				P[1].z = 0.0F ; 

				P[2].x = ( (f32)( cp->DrawX + hd->mWidth ) / Head->w - 0.5F ) * Ea->Size.x ;
				P[2].y = ( -(f32)( hd->mHeight + cp->DrawY ) / Head->h + 0.5F ) * Ea->Size.y ;
				P[2].z = 0.0F ; 

				P[3].x = ( (f32)cp->DrawX / Head->w - 0.5F ) * Ea->Size.x ;
				P[3].y = ( -(f32)( hd->mHeight + cp->DrawY ) / Head->h + 0.5F ) * Ea->Size.y ;
				P[3].z = 0.0F ;
			}

			// ϊ
			PSMTXMultVec( TMtx, &P[0], &P2[0] ) ;		PSMTXMultVec( TMtx, &P[1], &P2[1] ) ;
			PSMTXMultVec( TMtx, &P[2], &P2[2] ) ;		PSMTXMultVec( TMtx, &P[3], &P2[3] ) ;

			// uv l̎擾
			if( Pack->AnimNum == 0 )
			{
				u16 Pitch, Height ;
				
				Pitch = (u16)( Tex->mWidth / Head->w ) ;
				Height = (u16)( Tex->mHeight / Head->h ) ;
			
				u = (f32)( Head->FrameInfo[Ea->AnimPatNum].PatNumber % Pitch ) / Pitch ;
				v = (f32)( Head->FrameInfo[Ea->AnimPatNum].PatNumber / Pitch ) / Height ;
				w = 1.0F / Pitch - 1.0F / Tex->mWidth ;
				h = 1.0F / Height - 1.0F / Tex->mHeight ;
			}
			else
			{
				v = u = 0.0F ;
				w = h = 1.0F ;
			}

			// W̏o
			GPV3( P2[0], Ea->Point ) ;	GCX( 0xffffffff ) ;		GT( u, v ) ; 
			GPV3( P2[1], Ea->Point ) ;	GCX( 0xffffffff ) ;		GT( u + w, v ) ; 
			GPV3( P2[2], Ea->Point ) ;	GCX( 0xffffffff ) ;		GT( u + w, v + h ) ; 
			GPV3( P2[3], Ea->Point ) ;	GCX( 0xffffffff ) ;		GT( u, v + h ) ; 
		}
	}
	GEND() ;
	
	// I
	return 0 ;
}					

// ȈՃAj`悷WύX
extern s8 SetEasyAnimPoint( EFFECT *Effect, Vec Point )
{
	EASYANIMEFFECT *Ea = ( EASYANIMEFFECT * )Effect->Data ;

	// W̕ύX
	Ea->Point = Point ;
	
	// I
	return 0 ;
}
	
// `tOZbg( TRUE:`  FALSE:` )
extern s8 SetEasyAnimDrawFlag( EFFECT *Effect, u8 DrawFlag )
{
	EASYANIMEFFECT *Ea = ( EASYANIMEFFECT * )Effect->Data ;

	// tO̕ۑ
	Ea->DrawFlag = (s8)DrawFlag ;
	
	// I
	return 0 ;
}

// ȈՃAjGtFNg`悷邩ǂ̃tOZbg
extern s8 SetEasyAnimAllDrawFlag( s8 Flag )
{
	EaUnion.NotDrawFlag = !Flag ;	

	// I
	return 0 ;
}

