///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlashLine
//
// YK7EffectFlashLine.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/20/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectFlashLine.h"
//#include "./YK7EffectFlash.h"
//#include "./YK7EffectLine.h"
//#include "./YK7EffectImpact.h"
//#include "./YK7EffectWhirl.h"

// define ---------------------------------------


// datatype -------------------------------------

// data -----------------------------------------

FLASHLINEUNION FLineUnion ;

// function proto type --------------------------

// function code --------------------------------

// tbVCGtFNg̋ʃf[^
extern s8 InitFlashLineData( void )
{
	MEMINIT( FLineUnion ) ;

	// I
	return 0 ;
}

// tbVCGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFlashLineData( void )
{
	return TRUE ;
}

// tbVCGtFNg̋ʃf[^n
extern s8 EndFlashLineData( void )
{
	MEMINIT( FLineUnion ) ;

	// I
	return 0 ;
}




// tbVCGtFNg쐬
extern EFFECT *CreateFlashLineEffect( u8 Mode, Vec Point, u16 LineNum,
									u16 WidthWait, f32 WidthTime, f32 MaxWidth,
									f32 RSpeed, f32 MaxR,
									u16 CenterAlphaWait, f32 CenterAlphaSpeed,
									u16 FadeOutWait,
									f32 CenterAlphaFadeSpeed, f32 RFadeSpeed, u16 FadeOutTime,
									f32 AlphaGradLength, f32 RGradLength,
									u8 R, u8 G, u8 B,
									s32 Priority )
{
	EFFECT *Effect ;
	FLASHLINEEFFECT *FlashLineP ;
	FLASHLINEOBJECT *temp ;
	int i ;
	f32 rf, rw ;
	
	// VtbVCf[^쐬
	Effect = AddEffectData( EFF_FLASHLINE, (void**)&FlashLineP, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ̐̃IuWFNgf[^̃̈̊m
	FlashLineP->LineObj = ( FLASHLINEOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( FLASHLINEOBJECT ) * LineNum ), "Y_FllObj" ) ;
	if( FlashLineP->LineObj == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
	
	// Xe[^X̕ۑ
	FlashLineP->FlashMode = Mode ;
	FlashLineP->Point = Point ;
	FlashLineP->LineNum = LineNum ;
	FlashLineP->WidthWait = WidthWait ;
	FlashLineP->WidthTime = WidthTime ;
	FlashLineP->MaxWidth = MaxWidth ;
	FlashLineP->RSpeed = RSpeed ;
	FlashLineP->MaxR = MaxR ;
	FlashLineP->CenterAlphaWait = CenterAlphaWait ;
	FlashLineP->CenterAlphaSpeed = CenterAlphaSpeed ;
	FlashLineP->FadeOutWait = FadeOutWait ;
	FlashLineP->CenterAlphaFadeSpeed = CenterAlphaFadeSpeed ;
	FlashLineP->RFadeSpeed = RFadeSpeed ;
	FlashLineP->FadeOutTime = FadeOutTime ;
	FlashLineP->AlphaGradLength = AlphaGradLength ;
	FlashLineP->RGradLength = RGradLength ;
	FlashLineP->R = R ;
	FlashLineP->G = G ;
	FlashLineP->B = B ;

	FlashLineP->Width = Mode == 0 ? 0.2F : 0.0F ;
	FlashLineP->Counter = 0 ;
	FlashLineP->NoAlphaR = FlashLineP->AlphaR = 0.0F ;
	FlashLineP->Mode = 0 ;
	
	// C̏
	temp = FlashLineP->LineObj ;
	rf = ( PI_2 - PI / 4 ) / LineNum ;
	rw = MaxWidth / 5.0F ;
	for( i = 0 ; i < LineNum ; i ++, temp ++ )
	{
		temp->Rotate = PI_2 / LineNum * i + ( (f32)rand() / RAND_MAX * rf ) - rf / 2.0F ;
		temp->MaxWidth = MaxWidth + ( (f32)rand() / RAND_MAX * rw ) - rw / 2.0F ;
#if 1
		temp->RotSpeed = PI_2 / 360.0F * VParam[ED_HSEXP1][10] ;
#else
		temp->RotSpeed = PI_2 / 360.0F * 1 ;
#endif
	}

	// I
	return Effect ;
}

// tbVCGtFNǧns
extern s8 ReleaseFlashLineEffect( EFFECT *Effect )
{
	FLASHLINEEFFECT *FlashLineEffect = ( FLASHLINEEFFECT * )Effect->Data ;

	// IuWFNg̃J
	CHKMEMFREE2( FlashLineEffect->LineObj ) ;

	// I
	return 0 ;
}

// tbVCGtFNgPt[
extern s8 MoveFlashLineEffect( EFFECT *Effect )
{
	FLASHLINEEFFECT *FlashLine = ( FLASHLINEEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
				
	if( FlashLine->FlashMode == 0 )
	{
		switch( FlashLine->Mode )
		{
		case 0 :
			if( FlashLine->Counter < FlashLine->FadeOutWait )
			{
				FlashLine->NoAlphaR += FlashLine->RSpeed ;
				if( FlashLine->NoAlphaR > FlashLine->MaxR )
					FlashLine->NoAlphaR = FlashLine->MaxR ;
				
				if( FlashLine->Counter > FlashLine->CenterAlphaWait )
				{
					FlashLine->AlphaR += FlashLine->CenterAlphaSpeed ;
				}
				
				if( FlashLine->Counter > FlashLine->WidthWait )
				{
					FlashLine->Width = (f32)( FlashLine->Counter - FlashLine->WidthWait ) / FlashLine->WidthTime + 0.2F ;
					if( FlashLine->Width > 1.0F ) FlashLine->Width = 1.0F ;
				}

				FlashLine->Counter ++ ;
			}
			else
			{
				FlashLine->Counter = 0 ;
				FlashLine->Mode = 1 ;
			}
			break ;

		case 1 :
			if( FlashLine->NoAlphaR <= 0.0F )
			{
				DeleteEffect( Effect ) ;
				return 0 ;
			}
			else
			{
				FlashLine->NoAlphaR -= FlashLine->RFadeSpeed ;
				FlashLine->AlphaR -= FlashLine->CenterAlphaFadeSpeed ;
				if( FlashLine->NoAlphaR < 0.0F ) FlashLine->NoAlphaR = 0.0F ;
				if( FlashLine->AlphaR < 0.0F ) FlashLine->AlphaR = 0.0F ;
				
				if( FlashLine->FadeOutWait > FlashLine->Counter )
				{
					FlashLine->Width = (f32)( FlashLine->FadeOutWait - FlashLine->Counter ) / FlashLine->FadeOutWait + 0.2F ;
					if( FlashLine->Width > 1.0F ) FlashLine->Width = 1.0F ;
				}
					
				FlashLine->Counter ++ ;
			}
			break ; 
		}
	}
	else
	{
/*		{
			C_Paper papar( 10, 40, 1.0F, true, 512, 80 ) ;
			PRINTF( "FrameNumber:%d", FlashLine->Mode ) ;
		}
*/		switch( FlashLine->Mode )
		{
		case 0 :
			if( FlashLine->WidthWait == 0 )
			{
				FlashLine->Mode = 1 ;
				goto R1 ;
			}
			if( FlashLine->Counter < FlashLine->WidthWait )
			{
				FlashLine->Counter ++ ;
			}
			else
			{
				FlashLine->Counter = 0 ;
				FlashLine->Mode = 1 ;
			}
			break ;
			
		case 1 :
	R1 :
			if( FlashLine->Counter < FlashLine->WidthTime )
			{
				FlashLine->Width = (f32)( FlashLine->Counter + 1 ) / FlashLine->WidthTime ;
				if( FlashLine->Width > 1.0F ) FlashLine->Width = 1.0F ;
				
				FlashLine->Counter ++ ;
			}
			else
			{
				FlashLine->Counter = 0 ;
				FlashLine->Mode = 2 ;
			}
			break ;
			
		case 2 :
			if( FlashLine->FadeOutWait == 0 )
			{
				FlashLine->Mode = 3 ;
				goto R2 ;
			}
			
			if( FlashLine->Counter < FlashLine->FadeOutWait )
			{
				FlashLine->Counter ++ ;
				FlashLine->Width = 1.0F ;
			}
			else
			{
				FlashLine->Counter = 0 ;
				FlashLine->Mode = 3 ;
			}
			break ;

		case 3 :
	R2 :
			if( FlashLine->Counter < FlashLine->FadeOutTime )
			{
				FlashLine->Width = 1.0F - (f32)( FlashLine->Counter + 1 ) / FlashLine->FadeOutTime ;
				FlashLine->Counter ++ ;
			}
			else
			{
				DeleteEffect( Effect ) ;
				return 0 ;
			}
			break ;
		}
	}
		

	// I
	return 0 ;
}

// tbVCGtFNg`悷
extern s8 DrawFlashLineEffect( EFFECT *Effect )
{
	FLASHLINEEFFECT *FlashLine = ( FLASHLINEEFFECT * )Effect->Data ;
	Mtx TMtx ;
	FLASHLINEUNION *FlashLineUnion = &FLineUnion ;
	u16 LineNum, i ;
	FLASHLINEOBJECT *LineObject ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_NOTEX ) ;			// `̏
	
	// ]ns擾
	EffectGetInvViewMatrix( TMtx ) ;

	// Zobt@̏sݒ
	// rsȂ̂ŃeNX`̂ƂɎs邱Ƃɂ܂
	GXSetZCompLoc( GX_FALSE ) ;
	GXSetZMode( GX_FALSE, GX_LEQUAL, GX_DISABLE ) ;
	
	// [hɂď𕪊
	if( FlashLine->FlashMode == 0 )
	{
		// `
		GXBegin( GX_TRIANGLES, GX_VTXFMT0, (u16)( 36 * FlashLine->LineNum ) ) ;
	//	GXBegin( GX_TRIANGLES, GX_VTXFMT0, (u16)( 30 * 1 ) ) ;
	//	GXBegin( GX_TRIANGLES, GX_VTXFMT0, (u16)( 6 * 2 ) ) ;
		{
			Vec p[12], v[12] ;
			f32 Width1, Width2, Width3, Width4 ;
			f32 Length1, Length2, Length3, Length4, Sin, Cos ;
			u16 j ;
			u8 R, G, B ;

			R = FlashLine->R ;
			G = FlashLine->G ;
			B = FlashLine->B ;

			Length1 = FlashLine->NoAlphaR ;
			Width1 = ( FlashLine->Width * FlashLine->MaxWidth ) * ( Length1 / 100.0F ) ;
			
			Length2 = Length1 - ( Length1 - FlashLine->AlphaR ) * FlashLine->RGradLength ;
	//		if( Length2 < 0.0F ) Length2 = 0.0F ;
			Width2 = Width1 * ( Length2 / Length1 ) ;
			
			Length3 = FlashLine->AlphaR ;
			Width3 = Width1 * ( Length3 / Length1 ) ;
			
			Length4 = Length3 - Length3 * FlashLine->AlphaGradLength ;
			Width4 = Width1 * ( Length4 / Length1 ) ;

			p[0].x = -Width1 ;		p[0].y = Length1 ;	p[0].z = 0.0F ;
			p[1].x = 0.0F ;			p[1].y = Length1 ;	p[1].z = 0.0F ;
			p[2].x = Width1 ;		p[2].y = Length1 ;	p[2].z = 0.0F ;
			
			p[3].x = -Width2 ;		p[3].y = Length2 ;	p[3].z = 0.0F ;
			p[4].x = 0.0F ;			p[4].y = Length2 ;	p[4].z = 0.0F ;
			p[5].x = Width2 ;		p[5].y = Length2 ;	p[5].z = 0.0F ;
			
			p[6].x = -Width3 ;		p[6].y = Length3 ;	p[6].z = 0.0F ;
			p[7].x = 0.0F ;			p[7].y = Length3 ;	p[7].z = 0.0F ;
			p[8].x = Width3 ;		p[8].y = Length3 ;	p[8].z = 0.0F ;
			
			p[9].x = -Width4 ;		p[9].y = Length4 ;	p[9].z = 0.0F ;
			p[10].x = 0.0F ;		p[10].y = Length4 ;	p[10].z = 0.0F ;
			p[11].x = Width4 ;		p[11].y = Length4 ;	p[11].z = 0.0F ;
		
			// C̐JԂ
			LineObject = FlashLine->LineObj ;
			LineNum = FlashLine->LineNum ;
			for( i = 0 ; i < LineNum ; i ++, LineObject ++ )
	//		for( i = 0 ; i < 1 ; i ++, LineObject ++ )
			{
				Sin = sin( LineObject->Rotate ) ;
				Cos = cos( LineObject->Rotate ) ;
				LineObject->Rotate += LineObject->RotSpeed ;
				
				for( j = 0 ; j < 12 ; j ++ )
				{
					v[j].x = p[j].x * Cos - p[j].y * Sin ;
					v[j].y = p[j].x * Sin + p[j].y * Cos ;
					v[j].z = 0.0F ;
					MTXMultVec( TMtx, &v[j], &v[j] ) ;
					v[j].x += FlashLine->Point.x ;
					v[j].y += FlashLine->Point.y ;
					v[j].z += FlashLine->Point.z ;
				}

				GPV( v[0] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[1] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[3] ) ;	GC4( R, G, B, 0xff ) ;
				
				GPV( v[3] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[1] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[4] ) ;	GC4( R, G, B, 0xff ) ;
				
				GPV( v[1] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[2] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[4] ) ;	GC4( R, G, B, 0xff ) ;

				GPV( v[4] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[2] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[5] ) ;	GC4( R, G, B, 0xff ) ;

				
				GPV( v[3] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[4] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[6] ) ;	GC4( R, G, B, 0xff ) ;

				GPV( v[6] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[4] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[7] ) ;	GC4( R, G, B, 0xff ) ;
				
				GPV( v[4] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[5] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[7] ) ;	GC4( R, G, B, 0xff ) ;

				GPV( v[7] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[5] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[8] ) ;	GC4( R, G, B, 0xff ) ;


				GPV( v[6] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[7] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[9] ) ;	GC4( R, G, B, 0 ) ;
				
				GPV( v[9] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[7] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[10] ) ;	GC4( R, G, B, 0 ) ;
				
				GPV( v[7] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[8] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[10] ) ;	GC4( R, G, B, 0 ) ;

				GPV( v[10] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[8] ) ;	GC4( R, G, B, 0xff ) ;
				GPV( v[11] ) ;	GC4( R, G, B, 0 ) ;
			}
		}
		GXEnd() ;
	}
	else
	{
		f32 Length ;
		
		Length = 1.0F ;
		Length = GetScreenSize( &FlashLine->Point, Length ) ;
	
#define LINE_LENGTH		450.0F
		// `
		GXBegin( GX_TRIANGLES, GX_VTXFMT0, (u16)( 3 * FlashLine->LineNum ) ) ;
		{
			Vec p[3], v[3] ;
			f32 Width, Sin, Cos ;
			u16 j ;
			u8 R, G, B ;

			R = FlashLine->R ;
			G = FlashLine->G ;
			B = FlashLine->B ;

			Length = LINE_LENGTH / Length ;
			Width = ( FlashLine->MaxWidth * FlashLine->Width ) * ( Length / 100.0F ) ;
			p[0].x = 0.0F ;				p[0].y = Length ;	p[0].z = 0.0F ;
			p[1].x = Width * 2.0F ;		p[1].y = Length ;	p[1].z = 0.0F ;
			p[2].x = 0.0F ;				p[2].y = 0.0F ;		p[2].z = 0.0F ;
		
			// C̐JԂ
			LineObject = FlashLine->LineObj ;
			LineNum = FlashLine->LineNum ;
			for( i = 0 ; i < LineNum ; i ++, LineObject ++ )
			{
				Sin = sin( LineObject->Rotate ) ;
				Cos = cos( LineObject->Rotate ) ;
				LineObject->Rotate += LineObject->RotSpeed ;
				
				for( j = 0 ; j < 3 ; j ++ )
				{
					v[j].x = p[j].x * Cos - p[j].y * Sin ;
					v[j].y = p[j].x * Sin + p[j].y * Cos ;
					v[j].z = 0.0F ;
					MTXMultVec( TMtx, &v[j], &v[j] ) ;
					v[j].x += FlashLine->Point.x ;
					v[j].y += FlashLine->Point.y ;
					v[j].z += FlashLine->Point.z ;
				}

				GPV( v[0] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[1] ) ;	GC4( R, G, B, 0 ) ;
				GPV( v[2] ) ;	GC4( R, G, B, 0xff ) ;
			}
		}
		GXEnd() ;
	}		

	// I
	return 0 ;
}					







