///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectGauge
//
// YK7EffectGauge.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/07/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectGauge.h"
#include "../matsu/mk7Sound.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

GAUGEUNION GGUnion ;

// function proto type --------------------------

// function code --------------------------------

// Q[WGtFNg̋ʃf[^
extern s8 InitGaugeData( void )
{
	MEMINIT(GGUnion) ;

	// I
	return 0 ;
}

// Q[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckGaugeData( void )
{
	return TRUE ;
}

// Q[WGtFNg̋ʃf[^n
extern s8 EndGaugeData( void )
{
	MEMINIT(GGUnion) ;

	// I
	return 0 ;
}

// Q[W̃GtFNg쐬
extern EFFECT *CreateGaugeEffect( u8 MaxLineNum, u16 Length, Vec Point, f32 Rate,
									GXColor Color, f32 MaxSpeed, f32 MinSpeed, u8 InitMode, s32 Priority )
{
	EFFECT *Effect ;
	GAUGEEFFECT *gg ;
	GAUGEOBJECT *ob ;
	u16 i ;
//	f32 Max ;

	// VQ[Wf[^쐬
	Effect = AddEffectData( EFF_GAUGE, (void**)&gg, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// f[^
	memset( gg, 0, sizeof( GAUGEEFFECT ) ) ;
	gg->LineNum = 0 ;
	gg->Color = Color ;
	gg->MaxSpeed = MaxSpeed ;
	gg->MinSpeed = MinSpeed ;
	gg->Point = Point ;
	gg->MaxLineNum = MaxLineNum ;
	gg->Length = Length ;
	gg->Rate = Rate ;
	gg->Alpha = 255 ;
	gg->Mode = InitMode ;
	gg->len.init() ;
	gg->len.spos( 0.0F ) ;
	gg->Mode2 = 0 ;
	
	// Zbg
	{
		f32 Length ;
		f32 LengthTable[GAUGE_MAXNUM] ;

		// e[u̍쐬
		Length = VParam[ED_GAUGE][7] * 10 ;
		for( i = 0 ; i < GAUGE_MAXNUM ; i ++ )
		{
			LengthTable[i] = Length + VParam[ED_GAUGE][6] * 0.1F ;

			Length *= VParam[ED_GAUGE][8] * 0.001F ;
		}

		// ̃Zbg
		ob = &gg->Line[gg->MaxLineNum-1] ;
		for( i = 0 ; i < gg->MaxLineNum ; i ++, ob -- )
		{
			ob->UseFlag = FALSE ;
			ob->Persent = 0.0F ;
			ob->Speed = 0.0F ;
			ob->Length = LengthTable[i*GAUGE_MAXNUM/gg->MaxLineNum] ;
		}
	}
	

	// I
	return Effect ;
}

// gpQ[WC̐ύX
extern s8 SetUseGaugeEffect( EFFECT *Effect, u8 LineNum )
{
	GAUGEEFFECT *gg = ( GAUGEEFFECT * )Effect->Data ;
	GAUGEOBJECT *ob ;
	u32 i ;
	
	// CZbg
	ob = gg->Line ;
	gg->LineNum = LineNum ;
	for( i = 0 ; i < gg->LineNum ; i ++, ob ++ )
	{
		if( ob->UseFlag == FALSE )
		{
			ob->UseFlag =  TRUE ;
			ob->Speed = rand() * ( ( gg->MaxSpeed - gg->MinSpeed ) * 0.01F ) / RAND_MAX + gg->MinSpeed * 0.01F ;
			ob->AllTime = 1.0F / ob->Speed ;
			ob->Time = 0.0F ;
		}
	}
	for( ; i < gg->MaxLineNum ; i ++, ob ++ )
	{
		if( ob->UseFlag == TRUE )
		{
			ob->UseFlag = FALSE ;
			ob->Speed = rand() * ( ( gg->MaxSpeed - gg->MinSpeed ) * 0.01F ) / RAND_MAX + gg->MinSpeed * 0.01F ;
			ob->AllTime = 1.0F / ob->Speed ;
			ob->Time = 0.0F ;
		}
	}
	
	// I
	return 0 ;
}


// Q[W̃GtFNǧns
extern s8 ReleaseGaugeEffect( EFFECT *Effect )
{
	GAUGEEFFECT *gg = ( GAUGEEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// Q[W̃GtFNgt[ړ
extern s8 MoveGaugeEffect( EFFECT *Effect )
{
	GAUGEEFFECT *gg = ( GAUGEEFFECT * )Effect->Data ;
	GAUGEOBJECT *ob ;
	u32 i, Num ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	switch( gg->Mode )
	{
	case 0 :	// [h
		switch( gg->Mode2 )
		{
		case 0 : break ;
/*			if( gg->Counter == 0 )
			{
				gg->len.mov( 1, 10, 1.0F ) ;
				gg->Counter ++ ;
			}
			if( gg->len.eop() == true )
			{
				gg->Mode ++ ;
				gg->Mode2 = 0 ;
				gg->Counter = 0 ;
			}
			break ;
*/		}
		break ;
	
	case 1 :	// [^[[h
		// IuWFNg̏
		{
			Num = gg->LineNum ;
			ob = gg->Line ;
			for( i = 0 ; i < Num ; i ++, ob ++ )
			{
				if( ob->AllTime > ob->Time )
				{
					ob->Persent = 1.0F - GetSanjiFunction( ob->Speed, 1.0F, ob->AllTime, ob->Time ) ;
					ob->Time += 1.0F ;
					if( ob->AllTime <= ob->Time ) ob->Persent = 1.0F ;
				}
			}
			for( ; i < gg->MaxLineNum ; i ++, ob ++ )
			{
				if( ob->AllTime > ob->Time )
				{
					ob->Persent = GetSanjiFunction( ob->Speed, 1.0F, ob->AllTime, ob->Time ) ;
					ob->Time += 1.0F ;
					if( ob->AllTime <= ob->Time ) ob->Persent = 0.0F ;
				}
			}
		}
		break ;
	}

	// I
	return 0 ;
}					

// Q[W̃GtFNg`悷
extern s8 DrawGaugeEffect( EFFECT *Effect )
{
	GAUGEEFFECT *gg = ( GAUGEEFFECT * )Effect->Data ;
	GAUGEOBJECT *ob ;
	u32 i ;
	u32 color ;

	
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;

	color = CMKC2( gg->Color, gg->Alpha ) ;
	
	if( gg->Mode == 1 )
	{
		// [^[̕`
		GBGN( GX_QUADS, gg->MaxLineNum * 4 ) ;
		{
			f32 DrawX, DrawY ;
		
			ob = gg->Line ;
			DrawX = gg->Point.x ;	DrawY = gg->Point.y ;
			for( i = 0 ; i < gg->MaxLineNum ; i ++, ob ++, DrawX = gg->Point.x + (f32)gg->Length * i / gg->MaxLineNum )
			{
				DrawBoxNB( DrawX,													DrawY - ob->Length * ob->Persent,
							DrawX + (f32)gg->Length * 0.5F / gg->MaxLineNum,	DrawY, color ) ;
			}
		}
		GEND() ;
	}
	else
	{
		// ̕`
		DrawBox( gg->Point.x, 							gg->Point.y - 8,
				 gg->Point.x + gg->Length * gg->len.x, 	gg->Point.y, color ) ;
	}

	// I
	return 0 ;
}

// Q[WC̃At@lZbg
extern s8 SetGaugeAlpha( u8 Alpha, EFFECT *Effect )
{
	GAUGEEFFECT *gg = ( GAUGEEFFECT * )Effect->Data ;
	
	gg->Alpha = Alpha ;
	
	// I
	return 0 ;
}

// Q[W̕\[hύX
extern s8 SetGaugeMode( u8 Mode, EFFECT *Effect )
{
	GAUGEEFFECT *gg = ( GAUGEEFFECT * )Effect->Data ;
	
	gg->Mode = Mode ;
	
	// I
	return 0 ;
}

// ̒ݒ肷
extern s8 SetGaugeRate( f32 Rate, EFFECT *Effect )
{
	GAUGEEFFECT *gg = ( GAUGEEFFECT * )Effect->Data ;
	
	gg->len.x = Rate ;
	
	// I
	return 0 ;
}
