///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectGravity
//
// YK7EffectGravity.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectGravity.h"
#include "./YK7EffectElec.h"
#include "./YK7EffectWhirl.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_GRAVITY]

#define MAXSIZE			(PRM[0] * 0.1F)
#define MINSIZE			(PRM[1] * 0.1F)
#define SIZSPEED		(PRM[2] * 0.01F + 1.0F)
#define CIRCLEDIVNUM	(PRM[3])
#define OUTCOLOR		(CMK(PRM[4],PRM[5],PRM[6],PRM[7]))
#define INCOLOR			(CMK(PRM[8],PRM[9],PRM[10],PRM[11]))
#define ELECNUM			(PRM[12])
#define CENTERCOLOR		(CMK(PRM[13],PRM[14],PRM[15],PRM[16]))
#define COLORCENTER		(PRM[17] * 0.01F)
#define ELECMAXLEN		(PRM[18] * 1.0F)
#define ELECMINLEN		(PRM[19] * 1.0F)
#define ELEC_R			(PRM[23] * 1.0F)
#define WHIRL_R			(PRM[20] * 0.1F)
#define WHIRL_TIME		(PRM[21])
#define WHIRL_ANGLE		(PRM[22] * 0.1F * PI_2)
#define LIFE_TIME		(PRM[24])

// data -----------------------------------------

GRAVITYUNION gru ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// d̓GtFNg̋ʃf[^
extern s8 InitGravityData( void )
{
	MEMINIT( gru ) ;

	return 0 ;
}

// d̓GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckGravityData( void )
{
	return TRUE ;
}

// d̓GtFNg̋ʃf[^n
extern s8 EndGravityData( void )
{
	MEMINIT( gru ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// d̓GtFNg쐬
extern EFFECT *CreateGravityEffect(
								Vec pos,					// W
								s32 Priority )
{
	EFFECT *Effect ;
	GRAVITYEFFECT *gr ;
	s32 i ;

	// Vd̓f[^쐬
	Effect = AddEffectData( EFF_GRAVITY, (void**)&gr, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( gr, 0, sizeof( GRAVITYEFFECT ) ) ;

	// 
	gr->elecnum = ELECNUM ;
	gr->pos = pos ;
	gr->con = 0 ;
	gr->size = 1.0F ;
	
	// dGtFNg̍쐬
	for( i = 0 ; i < gr->elecnum ; i ++ )
	{
		Vec st, tar ;
		f32 len ;
		
		// d̔΂WZo
		GetDirVec( &tar, GetRandF2Num( PI / 2.0F, -PI / 2.0F ), GetRandFNum( PI_2 ) ) ;
		len = GetRandF2Num( ELECMAXLEN, ELECMINLEN ) ;
		st.x = tar.x * ELEC_R + pos.x ;
		st.y = tar.y * ELEC_R + pos.y ;
		st.z = tar.z * ELEC_R + pos.z ;
		tar.x = tar.x * ( len + ELEC_R ) + pos.x ;
		tar.y = tar.y * ( len + ELEC_R ) + pos.y ;
		tar.z = tar.z * ( len + ELEC_R ) + pos.z ;
	
		// 쐬
		gr->elec[i] = CreateElecEffect( EL_MSK_GRAV, st, tar ) ;
		if( gr->elec[i] == NULL )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		gr->elecid[i] = GetEffectID( gr->elec[i] ) ;
		SetEffectIndeManageFlag( gr->elec[i], TRUE ) ;
	}
	
	// ˂GtFNg̍쐬
	gr->whirl = CreateWhirlEffect( pos,				// ʂւ܂RcW
							WHIRL_R,				// ˂ꂳ锼a
							30 * 0.1F,				// ˂ꂳ锼ãXs[h
							WHIRL_ANGLE,			// ˂ꂳpx
							465 * 0.1F,				// ˂ꂳ鑬x(100.0˂ꂫ WhirlTimeÔƂ̂ݗL)
							44 * 0.1F,				// ˂ꂳx(WhirlTimeÔƂ̂ݗL)
							(u16)WHIRL_TIME,		// ˂ꂳ鎞 
							50000,					// ˂ꂫĂ̒~
							0 * 0.1F,				// ˂ꂪɖ߂鑬x(WhirlFinishTimeÔƂ̂ݗL)
							490 * 0.01F,			// ˂ꂪɖ߂x(WhirlFinishTimeÔƂ̂ݗL)
							0						// ˂ꂩ߂܂ł̎
							 ) ;					// ʂ˂GtFNg쐬
	if( gr->whirl == NULL )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	gr->whirlid = GetEffectID( gr->whirl ) ;
	SetEffectIndeManageFlag( gr->whirl, TRUE ) ;
	
	// u̐ݒ
	SetEffectLifeTime( Effect, LIFE_TIME ) ;

	// I
	return Effect ;
}

// d̓GtFNǧns
extern s8 ReleaseGravityEffect( EFFECT *Effect )
{
	GRAVITYEFFECT *gr = ( GRAVITYEFFECT * )Effect->Data ;
	s32 i ;

	for( i = 0 ; i < GRAV_ELECMAXNUM ; i ++ )
	{
		if( CheckEffectValidState( gr->elec[i], gr->elecid[i] ) == TRUE )
			DeleteEffect( gr->elec[i] ) ;
	}
	if( CheckEffectValidState( gr->whirl, gr->whirlid ) == TRUE )
		DeleteEffect( gr->whirl ) ;

	// I
	return 0 ;
}

// d̓GtFNgPt[
extern s8 MoveGravityEffect( EFFECT *Effect )
{
	GRAVITYEFFECT *gr = ( GRAVITYEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// dGtFNg𓮍삳
	for( s32 i = 0 ; i < GRAV_ELECMAXNUM ; i ++ )
	{
		if( CheckEffectValidState( gr->elec[i], gr->elecid[i] ) == TRUE )
			MoveEffect( gr->elec[i] ) ;
	}
	
	// ˂GtFNg𓮍삳
	if( CheckEffectValidState( gr->whirl, gr->whirlid ) == TRUE )
		MoveEffect( gr->whirl ) ;
		
	if( Effect->DelReqFlag == TRUE )
	{
		// IJn
		if( gr->con == 0 )
		{
			s32 i ;
		
//			if( CheckEffectValidState( gr->whirl, gr->whirlid ) == TRUE )
//				DelReqEffect( gr->whirl ) ;

			for( i = 0 ; i < GRAV_ELECMAXNUM ; i ++ )
			{
				if( CheckEffectValidState( gr->elec[i], gr->elecid[i] ) == TRUE )
				{
					DeleteEffect( gr->elec[i] ) ;
					gr->elec[i] = NULL ;
					gr->elecid[i] = 0 ;
				}
			}
			
			gr->con ++ ;
		}

		gr->size /= SIZSPEED ;
		if( gr->size <= 0.001F ) gr->size = 0.0F ;
		
		// TCYOɂȂI		
		if( gr->size == 0.0F )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
				
		return 0 ;
	}

	// I
	return 0 ;
}

// d̓GtFNg`悷
extern s8 DrawGravityEffect( EFFECT *Effect )
{
	GRAVITYEFFECT *gr = ( GRAVITYEFFECT * )Effect->Data ;
	f32 outr, inr, size ;
	
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;

	// aZo
	if( Effect->DelReqFlag == TRUE )
	{
		size = gr->size ;
	}
	else
	{
		size = GetRandF2Num( MAXSIZE, MINSIZE ) / MAXSIZE * gr->size ; 
	}
	outr = size * MAXSIZE ;
	inr = outr * COLORCENTER ;
	
	// ~`
	DrawCircle2_3D( gr->pos, outr, inr, OUTCOLOR, INCOLOR, CIRCLEDIVNUM ) ;
	DrawCircle_3D( gr->pos, inr, INCOLOR, CENTERCOLOR, CIRCLEDIVNUM ) ;

	// dGtFNg`悷
	for( s32 i = 0 ; i < GRAV_ELECMAXNUM ; i ++ )
	{
		if( CheckEffectValidState( gr->elec[i], gr->elecid[i] ) == TRUE )
			DrawEffect( gr->elec[i] ) ;
	}
	
	// ˂GtFNg`悷
	if( CheckEffectValidState( gr->whirl, gr->whirlid ) == TRUE )
	{
		SetWhirlEffectRadius( gr->whirl, WHIRL_R * size ) ;
		DrawEffect( gr->whirl ) ;
	}

	// I
	return 0 ;
}



