///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectJet
//
// YK7EffectJet.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectJet.h"
#include "./YK7EffectLine.h"

// define ---------------------------------------

#define JT_CIR_DIVNUM	(jt->cdivnum)//(s32)(VParam[ED_JET][0])
#define JT_G			((f32)VParam[ED_JET][1] * 0.0001F)
#define JT_IN_DIVNUM	(jt->idivnum)//(s32)(VParam[ED_JET][8])

// data -----------------------------------------

JETUNION jtu ;
extern LINEUNION LUnion ;

// datatype -------------------------------------

// function proto type --------------------------

static void __DrawJet( JETEFFECT *jt, f32 rate ) ;

// function code --------------------------------

static void __DrawJet( JETEFFECT *jt, f32 rate )
{
	Vec pos, dir, xv, yv, zv ;
	f32 ysp, zsp, zssp, y, z, zrate ;
	s32 vnum, i, j, k, cn, s ;
	static Vec cvec[40], *v, *cv ;
	Vec *jvec = ( Vec * )WorkBuffer ;
	
	if( VParam[ED_JET][0] > 40 ) VParam[ED_JET][0] = 40 ;
	zrate = rate ;

	// ʒuƕ擾
	if( jt->dirJObj != NULL )
	{
		Mtx mtx ;
	
		HSD_JObjSetupMatrix( jt->dirJObj->GetJObj() ) ;
		memcpy( mtx, jt->dirJObj->GetJObj()->mtx, sizeof( mtx ) ) ;
		
		pos.x = mtx[0][3] ;	pos.y = mtx[1][3] ;	pos.z = mtx[2][3] ;
		mtx[0][3] = mtx[1][3] = mtx[2][3] = 0.0F ;
		dir.x = 0.0F ;		dir.y = 0.0F ;		dir.z = 1.0F ;
		MTXMultVec( mtx, &dir, &dir ) ;
	}
	else
	{
		pos = jt->pos ;
		dir = jt->dir ;
	}
	
	// O擾
	{
		VECNormalize( &dir, &dir ) ;
		yv.x = 0.0F ;	yv.y = 1.0F ;	yv.z = 0.0F ;
		if( fabs( yv.x - dir.x ) < 0.000001F &&
			fabs( yv.y - dir.y ) < 0.000001F &&
			fabs( yv.z - dir.z ) < 0.000001F ){ yv.x = 1.0F ; yv.y = 0.0F ; yv.z = 0.0F ; }
		VECCrossProduct( &dir, &yv, &xv ) ;
		VECCrossProduct( &xv, &dir, &yv ) ;
		VECNormalize( &xv, &xv ) ;
		VECNormalize( &dir, &zv ) ;
		VECNormalize( &yv, &yv ) ;
	}

	// ~̒_
	v = cvec ;
	for( i = 0 ; i < JT_CIR_DIVNUM ; i ++, v ++ )
	{
		v->x = COSF( PI_2 / ( JT_CIR_DIVNUM - 1 ) * i ) ;
		v->y = SINF( PI_2 / ( JT_CIR_DIVNUM - 1 ) * i ) ;
		v->z = 0.0F ;
	}
	
	// WFbg̒_
	{
		z = y = 0.0F ; ysp = jt->width * jt->rate ; zsp = jt->length * zrate * jt->rate ; zssp = jt->length2 * zrate * jt->rate ;
		v = jvec ;
		for( vnum = 0 ; y >= 0.0F ; vnum ++ )
		{
			cv = cvec ;
			for( j = 0 ; j < JT_CIR_DIVNUM ; j ++, v ++, cv ++ )
			{
				v->x = xv.x * cv->x * y + 		yv.x * cv->y * y + 			zv.x * z ;
				v->y = xv.y * cv->x * y + 		yv.y * cv->y * y + 			zv.y * z ;
				v->z = xv.z * cv->x * y + 		yv.z * cv->y * y + 			zv.z * z ;
			}

			y += ysp ;
			ysp -= JT_G ;
			z += zsp ;
			zsp += zssp ;
		}
		cv = cvec ;
		for( j = 0 ; j < JT_CIR_DIVNUM ; j ++, v ++, cv ++ )
		{
			v->x = zv.x * z ;
			v->y = zv.y * z ;
			v->z = zv.z * z ;
		}
		vnum ++ ;
	}

	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_NOTEX ) ;
	
	// `̊Jn
//	s32 dvnum = ( ( ( vnum - 1 ) * ( JT_CIR_DIVNUM * 2 ) ) + ( vnum - 2 ) * 2 ) * JT_IN_DIVNUM ;
//	s32 bvnum = vnum * JT_CIR_DIVNUM * sizeof( Vec ) ;
	GBGN( GX_TRIANGLESTRIP, ( ( ( vnum - 1 ) * ( JT_CIR_DIVNUM * 2 ) ) + ( vnum - 2 ) * 2 ) * JT_IN_DIVNUM ) ;

#define POS(n)		GP3( v[(n)].x * rate + pos.x, v[(n)].y * rate + pos.y, v[(n)].z * rate + pos.z ) ;  GCX( jt->color )
	for( k = 0 ; k < JT_IN_DIVNUM ; k ++ )
	{
		rate = 1.0F * k / JT_IN_DIVNUM ;
	
		v = jvec ;
		cn = (s32)JT_CIR_DIVNUM ;
		s = 0 ;
		for( i = 0 ; i < vnum - 1 ; i ++, s += cn )
		{
			if( i != 0 ){ POS( s + cn ) ; }
		
			for( j = 0 ; j < cn ; j ++ )
			{
				POS(s + j+cn) ;
				POS(s + j) ;
			}

			if( i < vnum - 2 ){ POS( s + j - 1 ) ; }
		}
	}
#undef POS

	GEND() ;
}


// WFbgGtFNg̋ʃf[^
extern s8 InitJetData( void )
{
	MEMINIT( jtu ) ;

	return 0 ;
}

// WFbgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckJetData( void )
{
	return TRUE ;
}

// WFbgGtFNg̋ʃf[^n
extern s8 EndJetData( void )
{
	MEMINIT( jtu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// WFbgGtFNg쐬
extern EFFECT *CreateJetEffect(
								WK7JObj *dirJObj,			// P[^gĈʒuƊpx擾ꍇ
								Vec pos, Vec dir,			// ʂɍWƊpxw肷ꍇ
								f32 length,					// 
								f32 length2,				// [sɂ闦
								f32 width,					// 
								GXColor color,				// F
								u32 cdivnum,				// ~̕
								u32 idivnum,				// `悷WFbg̐
								s32 Priority )				// WFbgGtFNg쐬
{
	EFFECT *Effect ;
	JETEFFECT *jt ;
	
	// VWFbgf[^쐬
	Effect = AddEffectData( EFF_JET, (void**)&jt, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// ̏
	jt->dirJObj = dirJObj ;
	jt->pos = pos ;
	jt->dir = dir ;
	jt->length = length ;
	jt->length2 = length2 ;
	jt->width = width ;
	jt->color = *((u32 *)&color) ;
	jt->rotcount = 0 ;
	jt->cdivnum = cdivnum ;
	jt->idivnum = idivnum ;
	jt->rate = 1.0F ;

	// I
	return Effect ;
}

// WFbgGtFNǧns
extern s8 ReleaseJetEffect( EFFECT *Effect )
{
	JETEFFECT *jt = ( JETEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// WFbgGtFNgPt[
extern s8 MoveJetEffect( EFFECT *Effect )
{
	JETEFFECT *jt = ( JETEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	jt->rotcount ++ ;
	if( jt->rotcount == VParam[ED_JET][11] ) 
		jt->rotcount = 0 ;

	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// I
	return 0 ;
}

// WFbgGtFNg`悷
extern s8 DrawJetEffect( EFFECT *Effect )
{
	JETEFFECT *jt = ( JETEFFECT * )Effect->Data ;

	__DrawJet( jt, ( ( SINF( jt->rotcount * PI_2 / VParam[ED_JET][11] ) + 1.0F ) / 2.0F * (f32)( VParam[ED_JET][9] - VParam[ED_JET][10] ) + VParam[ED_JET][10] ) * 0.01F ) ;

	// I
	return 0 ;
}

// WFbgGtFNg̗Zbg
extern s8 SetJetEffectRate( EFFECT *Effect, f32 rate )
{
	JETEFFECT *jt = ( JETEFFECT * )Effect->Data ;
	
	jt->rate = rate ;
	
	return 0 ;
}
