///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLaser
//
// YK7EffectLaser.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/12/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTLASER_H
#define __YK7EFFECTLASER_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// [U[GtFNgʃf[^
typedef struct tagLASERUNION
{
	s8 NotAllDrawFlag ;
} LASERUNION ;

// [U[GtFNgf[^
typedef struct tagLASEREFFECT
{
	Vec Point1, Point2 ;				// [U[𔭎˂Q_
	f32 CrtLength ;						// Q_Ԃ烌[U[̌鋗
	f32 Width ;							// [U[̕
	GXColor Color ;						// [U[̐F
	u16 DivNum ;						// 
	
	f32 CenA ;							// S̃At@l
	f32 P1A, P2A ;						// e_̃At@
	s8 DoubleBrightFlag ;				// Q{PxtO
	
	u8 RingFlag ;						// O邩ǂ̃tO
	f32 RingWidth ;						// O̕
	f32 RingLaserSpace ;				// Oƃ[U[Ƃ̌
	s16 RingDivNum ;					// O̕
	f32 RingSpace ;						// O̊Ԋu
	f32 RingSpeed ;						// ÕXs[h
	f32 RingCounter ;					// OJE^

	s8 DLaserFlag ;						// Qd[U[tO
	f32 DLaserWidth ;					// Qd[U[̕
	GXColor DLaserColor ;				// Qd[U[̐F

	f32 LightRate ;						// [U[̌̋̃oCAX
	s8 DrawFlag ;						// `tO(nIȂ)
	s8 CrtFlag ;						// [U[邩tO(tF[hȂǂ^Cv)
	s8 BrinkFlag ;						// _ŗptO

	s8 FastDeleteFlag ;					// 폜tO
} LASEREFFECT ;

// [U[GtFNg^XNɓnf[^
typedef struct tagLASEREFFECTTACKPARAM
{
	Vec Point1, Point2 ;				// [U[𔭎˂Q_
	f32 CrtLength ;						// Q_Ԃ烌[U[̌鋗
	f32 Width ;							// [U[̕
	GXColor Color ;						// [U[̐F
	u16 DivNum ;						// 
} LASEREFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitLaserData( void ) ;				// [U[GtFNg̋ʃf[^
extern s8 CheckLaserData( void ) ;				// [U[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndLaserData( void ) ;				// [U[GtFNg̋ʃf[^n

extern EFFECT *CreateLaserEffect( Vec Point1, Vec Point2,
									f32 CrtLength, f32 Width,
									GXColor Color, u16 DivNum,
									f32 CenA = -1.0F, s32 Priority = -130 ) ;	// [U[GtFNg쐬
extern s8 ReleaseLaserEffect( EFFECT *Effect ) ;										// [U[GtFNǧns
extern s8 MoveLaserEffect( EFFECT *Effect ) ;											// [U[GtFNgPt[
extern s8 DrawLaserEffect( EFFECT *Effect ) ;											// [U[GtFNg`悷

extern s8 SetLaserEffectPoint( EFFECT *Effect, Vec *Point1, Vec *Point2 ) ;				// [U[GtFNĝQ_ݒ肷
extern s8 SetLaserEffectDrawFlag( EFFECT *Effect, s8 DrawFlag ) ;						// [U[GtFNg`悷邩ǂZbg(nIȂ)
extern s8 SetLaserEffectRenderFlag( EFFECT *Effect, s8 RenderFlag ) ;					// [U[GtFNg`悷邩ǂZbg(tF[ho[W)
extern s8 FastDelLaserEffect( EFFECT *Effect ) ;										// [U[GtFNg̑폜NGXgs
extern s8 SetLaserEffectAlpha( f32 P1A, f32 CenA, f32 P2A, EFFECT *Effect ) ;			// e_ł̃At@lZbg
extern s8 SetLaserEffectColor( GXColor *Color, EFFECT *Effect ) ;						// [U[̐FZbg

extern s8 SetLaserEffectRing( EFFECT *Effect, u8 RingFlag, f32 RingWidth = -1.0F, f32 RingLaserSpace = -1.0F,
								s16 RingDivNum = -1, f32 RingSpace = -1.0F, f32 RingSpeed = -1.0F ) ;		// [U[ɃO
extern s8 SetLaserEffectDouble( EFFECT *Effect, u8 DoubleLaserFlag, f32 Width, GXColor Color ) ;			// Qd[U[̃ZbgAbvs
extern s8 SetLaserEffectDoubleBrightFlag( EFFECT *Effect, u8 DoubleBrightFlag ) ;							// Q{̋Pxgp邩ǂ̃tO

extern s8 SetLaserEffectAllDrawFlag( s8 Flag ) ;										// [U[GtFNĝׂĂ`悷邩ǂZbg


#endif

