///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLaser2
//
// YK7EffectLaser2.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/07/2004
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectLaser2.h"

// define ---------------------------------------

// data -----------------------------------------

LASER2UNION ls2u ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// [U[QGtFNg̋ʃf[^
extern s8 InitLaser2Data( void )
{
	MEMINIT( ls2u ) ;

	ls2u.Width = VParam[ED_LASER2][0] * 0.001F ;
	ls2u.DivNum = (u8)VParam[ED_LASER2][1] ;
	
	return 0 ;
}

// [U[QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckLaser2Data( void )
{
	return TRUE ;
}

// [U[QGtFNg̋ʃf[^n
extern s8 EndLaser2Data( void )
{
	MEMINIT( ls2u ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// [U[QGtFNg쐬
extern EFFECT *CreateLaser2Effect(
									Vec StartPos, Vec EndPos,	// ˈʒuƖڕWʒu
									f32 speed,					// x
									GXColor color,				// F
									s32 Priority )				// [U[QGtFNg쐬
{
	EFFECT *Effect ;
	LASER2EFFECT *ls2 ;
	
	// V[U[Qf[^쐬
	Effect = AddEffectData( EFF_LASER2, (void**)&ls2, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// [U[Qf[^
	ls2->color = *((u32 *)&color) ;
	ls2->StartPos = StartPos ;
	ls2->EndPos = EndPos ;
	ls2->speed = speed ;

	ls2->Width = ls2u.Width ;
	ls2u.Width = VParam[ED_LASER2][0] * 0.001F ;
	
	ls2->DivNum = ls2u.DivNum ;
	ls2u.DivNum = (u8)VParam[ED_LASER2][1] ;

	VECSubtract( &EndPos, &StartPos, &ls2->Dir ) ;
	VECNormalize( &ls2->Dir, &ls2->Dir ) ;
	ls2->Len = VECDistance( &EndPos, &StartPos ) ;
	ls2->p1 = ls2->p2 = 0.0F ;

	// I
	return Effect ;
}

// [U[QGtFNǧns
extern s8 ReleaseLaser2Effect( EFFECT *Effect )
{
	LASER2EFFECT *ls2 = ( LASER2EFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// [U[QGtFNgPt[
extern s8 MoveLaser2Effect( EFFECT *Effect )
{
	LASER2EFFECT *ls2 = ( LASER2EFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	if( ls2->p2 != ls2->Len )
	{
		ls2->p2 = ( ls2->p2 + ls2->speed >= ls2->Len ) ? ls2->Len : ls2->p2 + ls2->speed ;
	}
	else
	{
		if( ls2->p1 + ls2->speed >= ls2->Len )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		else ls2->p1 += ls2->speed ;
	}

	// I
	return 0 ;
}

// [U[QGtFNg`悷
extern s8 DrawLaser2Effect( EFFECT *Effect )
{
	LASER2EFFECT *ls2 = ( LASER2EFFECT * )Effect->Data ;
	f32 len, hasilen ;
	Vec stv, env ;

	if( ls2->p1 == ls2->p2 ) return 0 ;
	if( VParam[ED_LASER2][2] <= 2 ) VParam[ED_LASER2][2] = 2 ;

	// ~`̏
	DrawCylinSetup( ls2->Dir ) ;

	// n_ƏI_Ƃ̊Ԃ̋Zo
	env.x = ls2->EndPos.x + ls2->Dir.x * ls2->p2 ;
	env.y = ls2->EndPos.y + ls2->Dir.y * ls2->p2 ;
	env.z = ls2->EndPos.z + ls2->Dir.z * ls2->p2 ;

	stv.x = ls2->EndPos.x + ls2->Dir.x * ls2->p1 ;
	stv.y = ls2->EndPos.y + ls2->Dir.y * ls2->p1 ;
	stv.z = ls2->EndPos.z + ls2->Dir.z * ls2->p1 ;

	len = VECDistance( &env, &stv ) ;
	hasilen = len * VParam[ED_LASER2][3] * 0.01F ;

	// `
	DrawCylin( ls2->StartPos, ls2->Dir, ls2->p1, 			ls2->p1 + hasilen,	0.0F, 		ls2->Width, ls2->color, ls2->DivNum ) ;	// n_r܂ł̃bV`悷
	DrawCylin( ls2->StartPos, ls2->Dir, ls2->p1 + hasilen,	ls2->p2 - hasilen,	ls2->Width, ls2->Width, ls2->color, ls2->DivNum ) ;	// rr܂ł̃bV`悷
	DrawCylin( ls2->StartPos, ls2->Dir, ls2->p2 - hasilen,	ls2->p2,			ls2->Width, 0.0F	  , ls2->color, ls2->DivNum ) ;	// rI_܂ł̃bV`悷

	// I
	return 0 ;
}

// [U[^[QbgɓBǂ𓾂( true:B  false:܂ )
extern bool GetLaser2HitState( EFFECT *Effect )
{
	LASER2EFFECT *ls2 = ( LASER2EFFECT * )Effect->Data ;

	return ls2->p2 == ls2->Len ? true : false ;
}


