///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLine
//
// YK7EffectLine.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/04/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectLine.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define TEST_TEXTURE	"/Yam/Effect/Line/LineTex.bin"

#define LINEWIDTH		0.29037613804053F
#define LINESCALE		1115.7475601F

// datatype -------------------------------------

// data -----------------------------------------

LINEUNION LUnion ;

// function proto type --------------------------

// function code --------------------------------

// CGtFNg̋ʃf[^
extern s8 InitLineData( void )
{
	MEMINIT(LUnion) ;

	// eNX`̓ǂݍ	
//	TexLoadSet( TEST_TEXTURE, &LUnion.TestTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_LineTex ), &LUnion.TestTex ) ;
	
	// I
	return 0 ;
}

// CGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckLineData( void )
{
//	if( TexLoadChk( &LUnion.TestTex ) == FALSE ) return FALSE ;

	return TRUE ;
}
	
// CGtFNg̋ʃf[^n
extern s8 EndLineData( void )
{
	// eNX`
	TexRelease( &LUnion.TestTex ) ;

	MEMINIT(LUnion) ;

	// I
	return 0 ;
}




// CGtFNg쐬
extern EFFECT *CreateLineEffect( u8 Mode2DFlag, u8 TexNumber, GXColor Color, Vec Point,
								f32 Size, f32 Width, f32 Length,
								f32 MaxPower, f32 MinPower, Vec Direction,
								f32 RotRange, f32 Scatter, f32 Gravity,
								u16 LineNum, u16 Time, u16 FadeTime,
								u8 AbsWidthFlag, u8 Type, u8 Mode,
								f32 YukaY, TEXTURE *Tex, u8 ColorRand, s32 Priority )
{
	EFFECT *Effect ;
	LINEEFFECT *LineP ;
	LINEOBJECT *LineObj ;
	u32 i ;
	f32 rnd1, rnd2 ;
	f32 oir, xz, randxz, randoir ;

	// eNX`ǂݍ܂ĂȂ牽I
	if( CheckLineData() == FALSE ) return 0 ;

	// t@C
//	CLOSECHK( LUnion.TexFileTest ) ;
	
	// VCf[^쐬
	Effect = AddEffectData( EFF_LINE, (void**)&LineP, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// p[^ۑ
	LineP->Mode2DFlag = Mode2DFlag ;
	LineP->TexNumber = TexNumber ;
	LineP->Color = Color ;
	LineP->Gravity = Gravity ;
	LineP->LineObjectNum = LineNum ;
	LineP->Time = Time ;
	LineP->FadeTime = FadeTime ;
	LineP->Counter = 0 ;
	LineP->Point = Point ;
	LineP->Width = Width ;
	LineP->Length = Length ;
	LineP->AbsWidthFlag = AbsWidthFlag ;
	LineP->Type = Type ;
	LineP->Mode = Mode ;
	LineP->YukaY = YukaY ;
	LineP->Tex = Tex ;

	// px𓾂
	{
		xz = atan2( Direction.z, Direction.x ) ;
		oir = atan2( Direction.y, Direction.x * cos( -xz ) - Direction.z * sin( -xz ) ) ;
	}

	// w̃C̐̃CIuWFNgf[^i[郁̈mۂ
	LineP->Object = ( LINEOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( LINEOBJECT ) * LineNum ), "Y_LinObj" ) ;
	if( LineP->Object == NULL )
	{
		DeleteEffect( Effect ) ;
		return NULL ;
	}

	// CIuWFNgׂď
	LineObj = LineP->Object ;
	for( i = 0 ; i < LineNum ; i ++, LineObj ++ )
	{
		// ^Cv LINE_TYPE_NOUTCIRCLE 珈𕪊򂷂
		if( Type == LINE_TYPE_NOUTCIRCLE )
		{
			f32 f ;
		
			// Zbg
			rnd1 = rand() * PI_2 / RAND_MAX ;
			LineObj->Speed.x = 0.0F ;
			LineObj->Speed.y = sin( rnd1 ) ;
			LineObj->Speed.z = cos( rnd1 ) ;
			
			LineObj->Speed.x = -sin( oir ) * LineObj->Speed.y ;
			LineObj->Speed.y = cos( oir ) * LineObj->Speed.y ;
			f = LineObj->Speed.x * cos( xz ) - LineObj->Speed.z * sin( xz ) ;
			LineObj->Speed.z = LineObj->Speed.x * sin( xz ) + LineObj->Speed.z * cos( xz ) ;
			LineObj->Speed.x = f ;
		}
		else
		{
			// ֌WȂقɔłǂŏ𕪊
			if( (f32)rand() / RAND_MAX < Scatter )
			{
				// ֌Wقɔłꍇ̏
				
				// KɃZbg
				if( Mode2DFlag == FALSE )
				{
					randxz = rand() * ( PI * 2 ) / RAND_MAX ;
					randoir = rand() * PI / RAND_MAX - PI / 2 ;
				}
				else
				{
					randxz = 0.0F ;
					randoir = rand() * ( PI * 2 ) / RAND_MAX ;
				}
			}
			else
			{
				// łpxZo
				rnd1 = rand() * ( PI * 2 ) / RAND_MAX ;
				rnd2 = Type == LINE_TYPE_OUTCIRCLE ? RotRange / 2 : rand() * ( RotRange / 2 ) / RAND_MAX ;
				randxz = cos( rnd1 ) * rnd2 + xz ;
				randoir = sin( rnd1 ) * rnd2 + oir ;
			}
	
			// xNgZo
			LineObj->Speed.x = cos( randoir ) ;
			LineObj->Speed.y = sin( randoir ) ;
			LineObj->Speed.z = LineObj->Speed.x * sin( randxz ) ;
			LineObj->Speed.x = LineObj->Speed.x * cos( randxz ) ;
		}
		
		if( Mode == 200 && (f32)rand() / RAND_MAX < VParam[ED_FLYBULLET][9] * 0.01F )
		{
			LineObj->Speed.x *= VParam[ED_FLYBULLET][10] * 0.1F ;
			LineObj->Speed.y *= VParam[ED_FLYBULLET][10] * 0.1F ;
			LineObj->Speed.z *= VParam[ED_FLYBULLET][10] * 0.1F ;
		}

		// WZbg
		if( Mode2DFlag == FALSE )
		{
			LineObj->BackPoint.x = LineObj->NowPoint.x = LineObj->Speed.x * Size + Point.x ;
			LineObj->BackPoint.y = LineObj->NowPoint.y = LineObj->Speed.y * Size + Point.y ;
			LineObj->BackPoint.z = LineObj->NowPoint.z = LineObj->Speed.z * Size + Point.z ;
		}
		else
		{
			f32 r = (f32)rand() * 0.6F / RAND_MAX + 0.4F ;
			LineObj->BackPoint.x = LineObj->NowPoint.x = LineObj->Speed.x * Size * r + Point.x ;
			LineObj->BackPoint.y = LineObj->NowPoint.y = LineObj->Speed.y * Size * r + Point.y ;
			LineObj->BackPoint.z = LineObj->NowPoint.z = LineObj->Speed.z * Size * r + Point.z ;
		}

		// F̃Zbg
		{
			s16 c ;
			
			c = (s16)( Color.r == 0 ? 0 : Color.r + rand() * ColorRand / RAND_MAX - ColorRand / 2 ) ;
			if( c < 0 ) c = 0 ; else if( c > 255 ) c = 255 ;
			LineObj->Color.r = (u8)c ;

			c = (s16)( Color.g == 0 ? 0 : Color.g + rand() * ColorRand / RAND_MAX - ColorRand / 2 ) ;
			if( c < 0 ) c = 0 ; else if( c > 255 ) c = 255 ;
			LineObj->Color.g = (u8)c ;

			c = (s16)( Color.b == 0 ? 0 : Color.b + rand() * ColorRand / RAND_MAX - ColorRand / 2 ) ;
			if( c < 0 ) c = 0 ; else if( c > 255 ) c = 255 ;
			LineObj->Color.b = (u8)c ;
			
			LineObj->Color.a = Color.a ;
		}

		// З͂Zbg
		rnd1 = rand() * ( MaxPower - MinPower ) / RAND_MAX + MinPower ;
		LineObj->Speed.x *= rnd1 ;
		LineObj->Speed.y *= rnd1 ;
		LineObj->Speed.z *= rnd1 ;

		// eNX`WZbg
		LineObj->TexX = (u8)( rand() * 2 / RAND_MAX ) ;
		LineObj->TexY = (u8)( rand() * 2 / RAND_MAX ) ;
		if( LineObj->TexX == 2 ) LineObj->TexX = 1 ;
		if( LineObj->TexY == 2 ) LineObj->TexY = 1 ;
	}

	// I
	return Effect ;
}

// CGtFNǧns
extern s8 ReleaseLineEffect( EFFECT *Effect )
{
	LINEEFFECT *LineP = ( LINEEFFECT * )Effect->Data ;

	// CIuWFƊi[pɊmۂĂ̈̊J
	CHKMEMFREE2( LineP->Object ) ;

	// I
	return 0 ;
}

// CGtFNgPt[
extern s8 MoveLineEffect( EFFECT *Effect )
{
	LINEEFFECT *LineP = ( LINEEFFECT * )Effect->Data ;
	u16 i, Num ;
	LINEOBJECT *LineObj ;
	f32 k ;
	u8 Mode ;
	f32 YukaY ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( LineP->Mode == 0 )
	{
		k = LineP->Counter > VParam[ED_EXP][3] ? 0.1F * VParam[ED_EXP][4] : 1.0F ;
	}
	else
	{
		k = 1.0F ;
	}
	
	// 莞Ԃo߂ĂGtFNg폜
	if( LineP->Counter > LineP->Time + LineP->FadeTime )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	else
	{
		Num = LineP->LineObjectNum ;
		LineObj = LineP->Object ;
		Mode = LineP->Mode ;
		YukaY = LineP->YukaY ;
		for( i = 0 ; i < Num ; i ++, LineObj ++ )
		{
			// ̏ꏊۑĂ
			LineObj->BackPoint = LineObj->NowPoint ;
			
			// |Cgړ
			LineObj->NowPoint.x += LineObj->Speed.x * k ;
			LineObj->NowPoint.y += LineObj->Speed.y * k ;
			LineObj->NowPoint.z += LineObj->Speed.z * k ;

			// d͏
			LineObj->Speed.y -= LineP->Gravity * k ;
			
/*			if( Mode == 200 && LineObj->NowPoint.y < YukaY )
			{
				f32 f ;
			
				LineObj->Speed.y *= -0.01 * VParam[ED_FLYBULLET][11] ;
				f = 0.01F * VParam[ED_FLYBULLET][11] * 3.0F ;
				if( f > 1.0F ) f = 1.0F ;
				LineObj->Speed.x *= f ;
				LineObj->Speed.z *= f ;
				LineObj->NowPoint.y = YukaY ;
			}
*/		}

		// JEg
		LineP->Counter ++ ;
	}

	// I
	return 0 ;
}

// CGtFNg`悷
extern s8 DrawLineEffect( EFFECT *Effect )
{
	LINEEFFECT *LineP = ( LINEEFFECT * )Effect->Data ;
	LINEUNION *LineUnion = &LUnion ;
	u8 Alpha ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// `̏
	EffectRenderSetup( LineP->Mode2DFlag == FALSE ? EF_PROJECT_PERS : EF_PROJECT_ORTHO,
						EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// C̑Zbg
	if( LineP->Mode2DFlag == FALSE )
	{
		f32 dx, dy, dz, Length, Size ;
		Vec CameraPoint ;
		
		// J̈ʒu𓾂
		HSD_CObjGetEyePosition( GetEffectCamera(), &CameraPoint ); 
		
		// J܂ł̒𓾂
		dx = CameraPoint.x - LineP->Point.x ;
		dy = CameraPoint.y - LineP->Point.y ;
		dz = CameraPoint.z - LineP->Point.z ;
		Length = sqrt( dx * dx + dy * dy + dz * dz ) ;

		// C̑Zo
		Size = LineP->Width / ( (f32)Length / LINESCALE ) ;

		// C̑Zbg
		GXSetPointSize( (u8)( LineP->AbsWidthFlag == TRUE ? LineP->Width : (u8)Size ) , GX_TO_ONE ) ;
		GXSetLineWidth( (u8)( LineP->AbsWidthFlag == TRUE ? LineP->Width : (u8)Size ) , GX_TO_ONE ) ;
	}
	else
	{
		// C̑Zbg
		GXSetPointSize( (u8)LineP->Width, GX_TO_ONE ) ;
		GXSetLineWidth( (u8)LineP->Width, GX_TO_ONE ) ;
	}
	GXEnableTexOffsets( GX_TEXCOORD0, GX_ENABLE, GX_ENABLE ) ;
	
	// `At@ľvZ
	{
		u16 temp ;
		
		temp = (u16)( LineP->Counter - 1 ) ;
		if( temp < LineP->Time )
		{
			Alpha = 255 ;
		}
		else
		{
			temp -= LineP->Time ;
			if( temp < LineP->FadeTime )
			{
				Alpha = (u8)( 255 - temp * 255 / LineP->FadeTime ) ;
			}
			else
			{
				Alpha = 0 ;
			}
		}
	}
	
	// C̕`
	if( LineP->Mode == 200 )
	{
		Mtx tmtx ;
		Vec p[4] ;

		// eNX`̃[h
		GTLOAD( &LineP->Tex->Obj ) ;
	
		EffectGetInvViewMatrix( tmtx ) ;
		p[0].x = -LineP->Width / 2.0F ; p[0].y = LineP->Width / 2.0F ; p[0].z = 0.0F ;
		p[1].x = LineP->Width / 2.0F ; p[1].y = LineP->Width / 2.0F ; p[1].z = 0.0F ;
		p[2].x = LineP->Width / 2.0F ; p[2].y = -LineP->Width / 2.0F ; p[2].z = 0.0F ;
		p[3].x = -LineP->Width / 2.0F ; p[3].y = -LineP->Width / 2.0F ; p[3].z = 0.0F ;
		MTXMultVec( tmtx, &p[0], &p[0] ) ;		MTXMultVec( tmtx, &p[1], &p[1] ) ;
		MTXMultVec( tmtx, &p[2], &p[2] ) ;		MTXMultVec( tmtx, &p[3], &p[3] ) ;
		GBGN( GX_QUADS, LineP->LineObjectNum * 4 ) ;
		{
			u16 i, Num ;
			LINEOBJECT *LineObj ;

			// `
			LineObj = LineP->Object ;
			Num = LineP->LineObjectNum ;
			if( LineP->Mode2DFlag == TRUE )
			{
				for( i = 0 ; i < Num ; i ++, LineObj ++ )
				{
					GP2( p[0].x + LineObj->NowPoint.x, p[0].y + LineObj->NowPoint.y ) ;	GC( LineObj->Color ) ; GT2( (u16)( LineObj->TexX * ( UVSCALE / 2 ) ), (u16)( LineObj->TexY * ( UVSCALE / 2 ) ) ) ;
					GP2( p[1].x + LineObj->NowPoint.x, p[1].y + LineObj->NowPoint.y ) ;	GC( LineObj->Color ) ; GT2( (u16)( ( LineObj->TexX + 1 ) * ( UVSCALE / 2 ) ), (u16)( LineObj->TexY * ( UVSCALE / 2 ) ) ) ;
					GP2( p[2].x + LineObj->NowPoint.x, p[2].y + LineObj->NowPoint.y ) ;	GC( LineObj->Color ) ; GT2( (u16)( ( LineObj->TexX + 1 ) * ( UVSCALE / 2 ) ), (u16)( ( LineObj->TexY + 1 ) * ( UVSCALE / 2 ) ) ) ;
					GP2( p[3].x + LineObj->NowPoint.x, p[3].y + LineObj->NowPoint.y ) ;	GC( LineObj->Color ) ; GT2( (u16)( LineObj->TexX * ( UVSCALE / 2 ) ), (u16)( ( LineObj->TexY + 1 ) * ( UVSCALE / 2 ) ) ) ;
				}
			}
			else
			{
				for( i = 0 ; i < Num ; i ++, LineObj ++ )
				{
					GP3( p[0].x + LineObj->NowPoint.x, p[0].y + LineObj->NowPoint.y, p[0].z + LineObj->NowPoint.z ) ;	GC( LineObj->Color ) ; GT2( (u16)( LineObj->TexX * ( UVSCALE / 2 ) ), (u16)( LineObj->TexY * ( UVSCALE / 2 ) ) ) ;
					GP3( p[1].x + LineObj->NowPoint.x, p[1].y + LineObj->NowPoint.y, p[1].z + LineObj->NowPoint.z ) ;	GC( LineObj->Color ) ; GT2( (u16)( ( LineObj->TexX + 1 ) * ( UVSCALE / 2 ) ), (u16)( LineObj->TexY * ( UVSCALE / 2 ) ) ) ;
					GP3( p[2].x + LineObj->NowPoint.x, p[2].y + LineObj->NowPoint.y, p[2].z + LineObj->NowPoint.z ) ;	GC( LineObj->Color ) ; GT2( (u16)( ( LineObj->TexX + 1 ) * ( UVSCALE / 2 ) ), (u16)( ( LineObj->TexY + 1 ) * ( UVSCALE / 2 ) ) ) ;
					GP3( p[3].x + LineObj->NowPoint.x, p[3].y + LineObj->NowPoint.y, p[3].z + LineObj->NowPoint.z ) ;	GC( LineObj->Color ) ; GT2( (u16)( LineObj->TexX * ( UVSCALE / 2 ) ), (u16)( ( LineObj->TexY + 1 ) * ( UVSCALE / 2 ) ) ) ;
				}
			}
		}
		GXEnd() ;
	}
	else
	{
		// eNX`̃[h
		GTLOAD2( LineUnion->TestTex ) ;
	
		GXBegin( GX_LINES, GX_VTXFMT0, (u16)( LineP->LineObjectNum * 2 ) ) ;
		{
			u16 i, Num ;
			LINEOBJECT *LineObj ;
			Vec Dir ;
		
			// `
			LineObj = LineP->Object ;
			Num = LineP->LineObjectNum ;
			if( LineP->Mode2DFlag == TRUE )
			{
				for( i = 0 ; i < Num ; i ++, LineObj ++ )
				{
					VECSubtract( &LineObj->NowPoint, &LineObj->BackPoint, &Dir ) ;
					VECNormalize( &Dir, &Dir ) ;
					VECScale( &Dir, &Dir, LineP->Length ) ;

					GP2( LineObj->BackPoint.x, LineObj->BackPoint.y ) ;						GC( LineObj->Color ) ;	GT2( 0, 0 ) ;
					GP2( Dir.x + LineObj->BackPoint.x, Dir.y + LineObj->BackPoint.y ) ;		GC( LineObj->Color ) ;	GT2( 0, UVSCALE ) ;
				}
			}
			else
			{
				for( i = 0 ; i < Num ; i ++, LineObj ++ )
				{
					VECSubtract( &LineObj->NowPoint, &LineObj->BackPoint, &Dir ) ;
					VECNormalize( &Dir, &Dir ) ;
					VECScale( &Dir, &Dir, LineP->Length ) ;

					GPV( LineObj->BackPoint ) ;
					GC( LineObj->Color ) ;	GT2( 0, 0 ) ;
					GP3( Dir.x + LineObj->BackPoint.x, Dir.y + LineObj->BackPoint.y, Dir.z + LineObj->BackPoint.z ) ;
					GC( LineObj->Color ) ;	GT2( 0, UVSCALE ) ;
				}
			}
		}
		GXEnd() ;
	}

	// I
	return 0 ;
}					







