///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMissile
//
// YK7EffectMissile.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/09/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectMissile.h"
#include "./YK7EffectCloud.h"
#include "./YK7EffectExplode.h"
#include "./YK7EffectHSExplode.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_MISSILE]
#define PR1				ExpTable		

#define CLD_SIZE				(PRM[0] * 0.1F)
#define CLD_MAXNUM				((u16)( PRM[1] * 100 ))
#define CLD_ALPHADOWNSPEED		(PRM[2] * 0.01F)
#define CLD_INITALPHA			(PRM[3] * CLD_ALPHADOWNSPEED + 1.0F)
#define CLD_COLOR				(CMK(PRM[4],PRM[5],PRM[6],PRM[7]))

#define CLD_DIVNUM				(PRM[12])

// data -----------------------------------------

MISSILEUNION msu ;

static const u16 ExpTable[] =
{
	129,	140,	181,	91,		80,
	59,		159,	109,	171,	0,
	
	5,		5,		3,		12,		5,
	21,		104,	5,		7,		25,
	
	25
} ;


// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// ~TCGtFNg̋ʃf[^
extern s8 InitMissileData( void )
{
	MEMINIT( msu ) ;

	return 0 ;
}

// ~TCGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckMissileData( void )
{
	return TRUE ;
}

// ~TCGtFNg̋ʃf[^n
extern s8 EndMissileData( void )
{
	MEMINIT( msu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// ~TCGtFNg쐬
extern EFFECT *CreateMissileEffect(
								Vec pos,					// JnW
								Vec targetpos,				// ڕWW

								f32 width,					// Uꕝ

								f32 speed,						// x
								f32 xrotspeed, f32 yrotspeed,	// UpxωXs[h
								s32 Priority )
{
	EFFECT *Effect ;
	MISSILEEFFECT *ms ;

	// V~TCf[^쐬
	Effect = AddEffectData( EFF_MISSILE, (void**)&ms, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// l
	ms->dpos = ms->pos	= pos ;
	ms->targetpos 		= targetpos ;
	ms->width 			= width ;
	ms->speed 			= speed ;
	ms->xrotspeed 		= xrotspeed * ( GetRandINum( 2 ) == 0 ? -1 : 1 ) ;
	ms->yrotspeed 		= yrotspeed * ( GetRandINum( 2 ) == 0 ? -1 : 1 ) ;
	ms->xrot			= 0.0F ;
	ms->yrot			= 0.0F ;

	// GtFNg쐬
	{
		GXColor cr ;
		
		*((u32 *)&cr) = CLD_COLOR ;
		ms->cloud = CreateCloudEffect( CLD_SIZE, CLD_MAXNUM, CLD_ALPHADOWNSPEED, CLD_INITALPHA, cr ) ;
		if( ms->cloud == NULL )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		ms->cloudid = GetEffectID( ms->cloud ) ;
	}
	
	// ƎO𓾂
	{
		Vec dir ;
		
		// ڕW܂ł̋𓾂
		ms->initlength = ms->length = VECDistance( &ms->targetpos, &ms->pos ) ;
	
		// k߂
		VECSubtract( &ms->targetpos, &ms->pos, &dir ) ;
		VECNormalize( &dir, &dir ) ;
		GetDir3( dir, &ms->dir ) ;
	}
	
	// I
	return Effect ;
}

// ~TCGtFNǧns
extern s8 ReleaseMissileEffect( EFFECT *Effect )
{
	MISSILEEFFECT *ms = ( MISSILEEFFECT * )Effect->Data ;
	
	if( CheckEffectValidState( ms->cloud, ms->cloudid ) == TRUE )
	{
		DeleteEffect( ms->cloud ) ;
	}
	
	// I
	return 0 ;
}

// ~TCGtFNgPt[
extern s8 MoveMissileEffect( EFFECT *Effect )
{
	MISSILEEFFECT *ms = ( MISSILEEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		if( CheckEffectValidState( ms->cloud, ms->cloudid ) == TRUE )
		{
			if( ms->cloud->DelReqFlag == FALSE )
			{
				DelReqEffect( ms->cloud ) ;
			}
		}
		else
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		
		return 0 ;
	}
	
	// W̌vZ
	ms->back = ms->dpos ;

	// k߂
	ms->length -= ms->speed;
	ms->pos.x += ms->dir.z.x * ms->speed ;
	ms->pos.y += ms->dir.z.y * ms->speed ;
	ms->pos.z += ms->dir.z.z * ms->speed ;
	
	// ]px
	{
		ms->xrot += ms->xrotspeed ;
		if( ms->xrot > PI_2 ) ms->xrot -= PI_2 ;
		else if( ms->xrot < 0.0F ) ms->xrot += PI_2 ;

		ms->yrot += ms->yrotspeed ;
		if( ms->yrot > PI_2 ) ms->yrot -= PI_2 ;
		else if( ms->yrot < 0.0F ) ms->yrot += PI_2 ;
	}

	// `W߂
	{
		f32 width, rate ;
		
		rate = ms->length / ms->initlength ;
//		width = ( rate < 0.5F ? rate * 2.0F : ( 1.0F - rate ) * 2.0F ) * ms->width ;
		width = fabs( sin( acos( 1.0F - rate * 2.0F ) ) ) * ms->width ;
		
		GetDirPos( &ms->dir, &ms->dpos,
					SINF( ms->xrot ) * width,
					SINF( ms->yrot ) * width,
					0.0F ) ;
		ms->dpos.x += ms->pos.x ;
		ms->dpos.y += ms->pos.y ;
		ms->dpos.z += ms->pos.z ;
	}
	
	// ڕWWɓB甚N
	if( ms->length < 0 )
	{
		GXColor Color1, Color2, Color3 ;
		SMEXPDEF TBDef ;
		Vec Point ;
		f32 Size ;
		
		Point = ms->targetpos ;
		Size = 2.0F ;
		
		GetSmokeExDef( Point, &TBDef ) ;
	
		// F̃Zbg
		*((u32 *)&Color1) = CMK( PR1[0],PR1[1],PR1[2], 255 ) ;
		*((u32 *)&Color2) = CMK( PR1[3],PR1[4],PR1[5], 255 ) ;
		*((u32 *)&Color3) = CMK( PR1[6],PR1[7],PR1[8], 255 ) ;
	
		// grGtFNg쐬
/*		CreateHSExplodeEffect2( Point, Size,
									(u8)PR1[9], 0, (u8)PR1[10],
									(u8)PR1[11], 0,
									0, PR1[13], 0.0F,
									(GXColor){0,0,0,0},(GXColor){0,0,0,0},(GXColor){0,0,0,0},
									(u16)( PR1[15] * TBDef.Size ), (u8)PR1[17], (u16)( PR1[16] * TBDef.Num ), (u16)( PR1[18] * TBDef.ASize ),
									PR1[19], PR1[20], 161,
									(u8)PR1[14], (u8)PR1[12],
									TRUE, FALSE, TRUE, TRUE, FALSE, FALSE,
									FALSE, 1.0F,
									FALSE, 0,
									Color1, Color2, Color3, 0 ) ;
*/
		CreateHSExplodeEffect2( Point, Size,
									(u8)PR1[9], 0, (u8)PR1[10],
									(u8)PR1[11], 0,
									0, PR1[13], 0.0F,
									Color1, Color2, Color3,
									(u16)( PR1[15] * TBDef.Size ), (u8)PR1[17], (u16)( PR1[16] * TBDef.Num ), (u16)( PR1[18] * TBDef.ASize ),
									PR1[19], PR1[20], 161,
									(u8)PR1[14], (u8)PR1[12],
									TRUE, FALSE, TRUE, TRUE, FALSE, FALSE,
									TRUE, 1.0F,
									FALSE, 0,
									Color1, Color2, Color3, 0 ) ;
		
		// 폜Jn
		DelReqEffect( Effect ) ;
		return 0 ;
	}
	
	// 𑝂₷
	{
		s32 i ;
		Vec d, t ;
		f32 rate ;

		rate = 0.0F ;
		VECSubtract( &ms->dpos, &ms->back, &d ) ;
		d.x /= CLD_DIVNUM ;		d.y /= CLD_DIVNUM ;		d.z /= CLD_DIVNUM ;
		t = ms->back ;
		for( i = 0 ; i < CLD_DIVNUM ; i ++ )
		{
			AddCloudObject( t, ms->dpos, ms->cloud ) ;
			t.x += d.x ;
			t.y += d.y ;
			t.z += d.z ;
		}
	}

	// I
	return 0 ;
}

// ~TCGtFNg`悷
extern s8 DrawMissileEffect( EFFECT *Effect )
{
	MISSILEEFFECT *ms = ( MISSILEEFFECT * )Effect->Data ;

	// I
	return 0 ;
}



