///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectModelFire
//
// YK7EffectModelFire.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/16/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectModelFire.h"
#include "./YK7Break.h"
#include "../matsu/mk7Sound.h"
#include "./YK7EffectBillboard.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define MODELFIRETEX "/Yam/Effect/ModelFire/HumanTorch2.BIN"		// ft@CGtFNgeNX`t@C

//#undef	K7AppSmallMemAlloc
//#define	K7AppSmallMemAlloc		ghmGcMemAlloc

//#undef	K7AppSmallMemFree
//#define	K7AppSmallMemFree		ghmGcMemFree

#define FIRETEX_DIVNUM				4				// t@CAeNX`̕

// datatype -------------------------------------

// gr[hp̊eʂ̏
typedef struct tagMODELFIREHSMODEINFO
{
	char *parent ;		// \mFˑ
	char *name ;		// ʂ̖
	float size ;		// 傫
} MODELFIREHSMODEINFO ;

// data -----------------------------------------

// eʂ̖OƑ傫Ɨ
static MODELFIREHSMODEINFO __ModelFireHSModeInfo[] =
{
	// Parent		Name				Size
//	{ "Body", 		"Root_joint", 		5.0F },
	{ "Body", 		"Spine_joint1", 	3.0F },
	{ "Body", 		"Spine_joint2", 	3.0F },

	{ "Body",	 	"ScapulaR_joint", 	3.0F },
	{ "Body", 		"HumerusR_joint1", 	3.0F },
	{ "Arm_R", 		"HumerusR_joint2", 	3.0F },
	{ "Arm_R", 		"UlnaR_joint", 		3.0F },
	{ "Arm_R", 		"RadiusR_joint", 	3.0F },
	{ "Arm_R", 		"WristR_joint", 	3.0F },
	{ "Arm_R", 		"F2R_joint1", 		3.0F },

	{ "Body", 		"ScapulaL_joint", 	3.0F },
	{ "Body", 		"HumerusL_joint1", 	3.0F },
	{ "Arm_L", 		"HumerusL_joint2", 	3.0F },
	{ "Arm_L", 		"UlnaL_joint", 		3.0F },
	{ "Arm_L", 		"RadiusL_joint", 	3.0F },
	{ "Arm_L", 		"WristL_joint", 	3.0F },
	{ "Arm_L", 		"F2L_joint1", 		3.0F },

	{ "Body", 		"Neck_joint", 		3.0F },
	{ "Skull_joint","Skull_joint", 		3.0F },
	
	{ "Body",	 	"HipR_joint", 		3.0F },
	{ "Body", 		"ThighR_joint", 	3.0F },
	{ "Foot_R", 	"ShinR_joint", 		3.0F },
	{ "Foot_R", 	"AnkleR_joint", 	3.0F },
	{ "Foot_R", 	"ToeR_joint", 		3.0F },

	{ "Body",		"HipL_joint", 		3.0F },
	{ "Body",		"ThighL_joint", 	3.0F },
	{ "Foot_L",		"ShinL_joint", 		3.0F },
	{ "Foot_L", 	"AnkleL_joint", 	3.0F },
	{ "Foot_L", 	"ToeL_joint", 		3.0F },
	
	{ NULL, NULL, 0.0F },
} ;

MODELFIREUNION MFiUnion ;

// function proto type --------------------------

static s8 FireAdd( MODELFIREEFFECT *MFire, Vec Point ) ;				// 𑝂₷


// function code --------------------------------

// 𑝂₷
static s8 FireAdd( MODELFIREEFFECT *MFire, Vec Point )
{
	MODELFIREOBJECT *Obj ;
	s32 i ;

	// IuWFNgςI
	if( MFire->ObjNum >= MFire->ObjMaxNum ) return 0 ;
		
	// gĂȂf[^T
	Obj = MFire->ObjP ;
	while( Obj->UseFlag ) Obj ++ ;
	
	// f[^̐𑝂₷
	MFire->ObjNum ++ ;

	// WZbg
	Obj->Point = Point ;
	
	// ̑̃f[^
	Obj->UseFlag = TRUE ;
	Obj->Speed.x = rand() * MFire->RandPower / RAND_MAX - MFire->RandPower / 2.0F ;
	Obj->Speed.y = 0.0F ;
	Obj->Speed.z = rand() * MFire->RandPower / RAND_MAX - MFire->RandPower / 2.0F ;
	Obj->SSpeed = rand() * ( MFire->MaxPower - MFire->MinPower ) / RAND_MAX + MFire->MinPower ;
	Obj->a = 0 ;
	Obj->sa = (u8)( ( rand() * ( MFire->MaxASpeed - MFire->MinASpeed ) / RAND_MAX + MFire->MinASpeed ) * 255 ) ;
	if( Obj->sa == 0 ) Obj->sa = 1 ;
	Obj->Size = rand() * ( MFire->MaxSize - MFire->MinSize ) / RAND_MAX + MFire->MinSize ;
	Obj->SSize = rand() * ( MFire->MaxSizeSpeed - MFire->MinSizeSpeed ) / RAND_MAX + MFire->MinSizeSpeed ;

	for( i = 0 ; i < SINTABLENUM ; i ++ )
	{
		Obj->SinTable[i] = 0.0F ;
		Obj->SinSpeed[i] = rand() * ( MFire->MaxSinSpeed - MFire->MinSinSpeed ) / RAND_MAX + MFire->MinSinSpeed ;
	}

	Obj->Counter = 0 ;
	Obj->DeadTime = (u8)( rand() * ( MFire->MaxTime - MFire->MinTime ) / RAND_MAX + MFire->MinTime ) ;
	Obj->tu = (u8)( rand() * FIRETEX_DIVNUM / RAND_MAX ) ; if( Obj->tu == FIRETEX_DIVNUM ) Obj->tu = FIRETEX_DIVNUM - 1 ;
	Obj->tv = (u8)( rand() * FIRETEX_DIVNUM / RAND_MAX ) ; if( Obj->tv == FIRETEX_DIVNUM ) Obj->tv = FIRETEX_DIVNUM - 1 ;
	Obj->ReverseFlag = (u8)( rand() > RAND_MAX / 2 ? TRUE : FALSE ) ;

	// F̐ݒ
	{
		s32 c ;
		
		c = (s16)MFire->Color.r ;
		if( c != 0 ) c += rand() * MFire->ColorRand / RAND_MAX - ( MFire->ColorRand >> 1 ) ;
		if( c < 0 ) c = 0 ;
		Obj->Color.r = (u8)c ;

		c = (s16)MFire->Color.g ;
		if( c != 0 ) c += rand() * MFire->ColorRand / RAND_MAX - ( MFire->ColorRand >> 1 ) ;
		if( c < 0 ) c = 0 ;
		Obj->Color.g = (u8)c ;

		c = (s16)MFire->Color.b ;
		if( c != 0 ) c += rand() * MFire->ColorRand / RAND_MAX - ( MFire->ColorRand >> 1 ) ;
		if( c < 0 ) c = 0 ;
		Obj->Color.b = (u8)c ;
		
		Obj->Color.a = MFire->Color.a ;
	}
	
	// I
	return 0 ;
}


// ft@CGtFNg̋ʃf[^
extern s8 InitModelFireData( void )
{
	MEMINIT( MFiUnion ) ;

	// ft@CpeNX`[ǂݍ
//	TexLoadSet( MODELFIRETEX, &MFiUnion.ModelFireTexAlpha ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_HumanTorch2 ), &MFiUnion.ModelFireTexAlpha ) ;

	// ΂̃̕GtFNgf[^ǂ܂ĂȂ̂߂ɓǂݍݏs
//	SetupBillboardEffectID( BILLEFF_SPFIRE2 ) ;

	MFiUnion.FireCount = 0 ;

	// I
	return 0 ;
}

// ft@CGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckModelFireData( void )
{
//	if( TexLoadChk( &MFiUnion.ModelFireTexAlpha ) == FALSE ) return FALSE ;
//	if( CheckBillboardEffectIDState( BILLEFF_SPFIRE2 ) == FALSE ) return FALSE ;

	return TRUE ;
}	


// ft@CGtFNg̋ʃf[^n
extern s8 EndModelFireData( void )
{
	// 
	TexRelease( &MFiUnion.ModelFireTexAlpha ) ;
	
	MEMINIT( MFiUnion ) ;
	
	// I
	return 0 ;
}


static const u16 __Fire9Table[] =
{	45,		10,		100,		73,		182,
	97,		10,		5,		8,		1,

	40,		21,		119,		83,		245,
	143,		87,		255,		10,		2,

	80,		32,		0,		30,		0,
	0,		0,		0,		0,		0 } ;

static const u16 __Fire8Table[] =
{	17,		16,		100,		50,		80,
	6,		10,		5,		8,		1,

	40,		21,		420,		420,		165,
	103,		56,		255,		10,		2,

	80,		2,		1,		20,		0,
	0,		0,		0,		0,		0 } ;

static const u16 __Fire10Table[] =
{ 	176,  	161,	100,	50,		80,
	6,		10,		5,		8,		1,

	40,		21,		328,	332,	149,
	84,		51,		255,	10,		2,
	0,		0 } ;

// ft@CGtFNg쐬ȈՔ
extern EFFECT *CreateModelFireEffectEasy( WK7JObj *JObj, u8 FireType, Vec Point,
											f32 Size, s32 SoundID, s32 Priority )
{
	f32 MaxNumRate ;
	EFFECT *Effect ;
	
	MaxNumRate = MFiUnion.MaxNumRateFlag ? MFiUnion.MaxNumRate : 1.0F ;
	MFiUnion.MaxNumRateFlag = false ;

	switch( FireType )
	{
	case MFIRE_ENEMY :		// grS
		{
			GXColor Color ;
			
			Color.r = (u8)VParam[ED_MFIRE][14] ;
			Color.g = (u8)VParam[ED_MFIRE][15] ;
			Color.b = (u8)VParam[ED_MFIRE][16] ;
			Color.a = (u8)VParam[ED_MFIRE][17] ;
		
			Effect = CreateModelFireEffect( JObj,
											(Vec){0.0F,0.0F,0.0F}, VParam[ED_MFIRE][20] * 0.01F, FALSE,
											VParam[ED_MFIRE][0] * 0.001F, VParam[ED_MFIRE][1] * 0.001F, 
											PI_2 / 3600.0F * VParam[ED_MFIRE][2], PI_2 / 3600.0F * VParam[ED_MFIRE][3], 
											VParam[ED_MFIRE][4] * 0.1F, VParam[ED_MFIRE][5] * 0.1F, 
											VParam[ED_MFIRE][6] * 0.01F, VParam[ED_MFIRE][7] * 0.01F, 
											(u8)VParam[ED_MFIRE][8], (u8)VParam[ED_MFIRE][9],
											(f32)VParam[ED_MFIRE][10] / 255, (f32)VParam[ED_MFIRE][11] / 255, (u8)VParam[ED_MFIRE][19],
											VParam[ED_MFIRE][12] * 0.01F, VParam[ED_MFIRE][13] * 0.01F,
											Color, (u8)VParam[ED_MFIRE][18], (u32)( 300 * MaxNumRate ),
											0.0F,
											-1, 0.0F, 0,
											SoundID, true, Priority ) ;
		}
		break ;
		
	case MFIRE_MSK :		// }XN\
		{
			GXColor Color ;
			
			Color.r = (u8)VParam[ED_MFIRE2][14] ;
			Color.g = (u8)VParam[ED_MFIRE2][15] ;
			Color.b = (u8)VParam[ED_MFIRE2][16] ;
			Color.a = (u8)VParam[ED_MFIRE2][17] ;
		
			Effect = CreateModelFireEffect( JObj,
											(Vec){0.0F,0.0F,0.0F}, 0.0F, FALSE,
											VParam[ED_MFIRE2][0] * 0.001F, VParam[ED_MFIRE2][1] * 0.001F, 
											PI_2 / 3600.0F * VParam[ED_MFIRE2][2], PI_2 / 3600.0F * VParam[ED_MFIRE2][3], 
											VParam[ED_MFIRE2][4] * 0.1F, VParam[ED_MFIRE2][5] * 0.1F, 
											VParam[ED_MFIRE2][6] * 0.01F, VParam[ED_MFIRE2][7] * 0.01F, 
											(u8)VParam[ED_MFIRE2][8], (u8)VParam[ED_MFIRE2][9],
											(f32)VParam[ED_MFIRE2][10] / 255, (f32)VParam[ED_MFIRE2][11] / 255, (u8)VParam[ED_MFIRE2][19],
											VParam[ED_MFIRE2][12] * 0.01F, VParam[ED_MFIRE2][13] * 0.01F,
											Color, (u8)VParam[ED_MFIRE2][18], (u32)( 450 * MaxNumRate ),
											VParam[ED_MFIRE2][20] * 0.01F,
											-1, 0.0F, 0,
											SoundID, false, Priority ) ;
		}
		break ;
		
		
	case MFIRE_CANDLE :		// 낤R
		{
			GXColor Color ;
			
			Color.r = (u8)VParam[ED_CANDLEFIRE][14] ;
			Color.g = (u8)VParam[ED_CANDLEFIRE][15] ;
			Color.b = (u8)VParam[ED_CANDLEFIRE][16] ;
			Color.a = (u8)VParam[ED_CANDLEFIRE][17] ;
		
			Effect = CreateModelFireEffect( NULL,
											Point, Size, FALSE,
											VParam[ED_CANDLEFIRE][0] * 0.0001F, VParam[ED_CANDLEFIRE][1] * 0.0001F, 
											PI_2 / 3600.0F * VParam[ED_CANDLEFIRE][2], PI_2 / 3600.0F * VParam[ED_CANDLEFIRE][3], 
											VParam[ED_CANDLEFIRE][4] * 0.1F, VParam[ED_CANDLEFIRE][5] * 0.1F, 
											VParam[ED_CANDLEFIRE][6] * 0.001F, VParam[ED_CANDLEFIRE][7] * 0.001F, 
											(u8)VParam[ED_CANDLEFIRE][8], (u8)VParam[ED_CANDLEFIRE][9],
											(f32)VParam[ED_CANDLEFIRE][10] / 255, (f32)VParam[ED_CANDLEFIRE][11] / 255, (u8)VParam[ED_CANDLEFIRE][19],
											VParam[ED_CANDLEFIRE][12] * 1.0F, VParam[ED_CANDLEFIRE][13] * 1.0F,
											Color, (u8)VParam[ED_CANDLEFIRE][18], (u32)( 120 * MaxNumRate ),
											0.0F,
											-1, 0.0F, 0,
											SoundID, false, Priority ) ;
		}
		break ;
		
	case MFIRE_WALL :		// ǔR
		{
			GXColor Color ;
			
			Color.r = (u8)VParam[ED_MFIRE3][14] ;
			Color.g = (u8)VParam[ED_MFIRE3][15] ;
			Color.b = (u8)VParam[ED_MFIRE3][16] ;
			Color.a = (u8)VParam[ED_MFIRE3][17] ;
		
			Effect = CreateModelFireEffect( JObj,
											(Vec){0.0F,0.0F,0.0F}, 0.0F, FALSE,
											VParam[ED_MFIRE3][0] * 0.001F, VParam[ED_MFIRE3][1] * 0.001F, 
											PI_2 / 3600.0F * VParam[ED_MFIRE3][2], PI_2 / 3600.0F * VParam[ED_MFIRE3][3], 
											VParam[ED_MFIRE3][4] * 0.1F, VParam[ED_MFIRE3][5] * 0.1F, 
											VParam[ED_MFIRE3][6] * 0.01F, VParam[ED_MFIRE3][7] * 0.01F, 
											(u8)VParam[ED_MFIRE3][8], (u8)VParam[ED_MFIRE3][9],
											(f32)VParam[ED_MFIRE3][10] / 255, (f32)VParam[ED_MFIRE3][11] / 255, (u8)VParam[ED_MFIRE3][19],
											VParam[ED_MFIRE3][12] * 0.01F, VParam[ED_MFIRE3][13] * 0.01F,
											Color, (u8)VParam[ED_MFIRE3][18], (u32)( 1000 * MaxNumRate ),
											VParam[ED_MFIRE3][20] * 0.01F,
											-1, 0.0F, 0,
											SoundID, false, Priority ) ;
		}
		break ;

	case MFIRE_RUMP :		// vR
		{
			GXColor Color ;
			
			Color.r = (u8)VParam[ED_MFIRE4][14] ;
			Color.g = (u8)VParam[ED_MFIRE4][15] ;
			Color.b = (u8)VParam[ED_MFIRE4][16] ;
			Color.a = (u8)VParam[ED_MFIRE4][17] ;
		
			Effect = CreateModelFireEffect( NULL,
											Point, Size, TRUE,
											VParam[ED_MFIRE4][0] * 0.001F, VParam[ED_MFIRE4][1] * 0.001F, 
											PI_2 / 3600.0F * VParam[ED_MFIRE4][2], PI_2 / 3600.0F * VParam[ED_MFIRE4][3], 
											VParam[ED_MFIRE4][4] * 0.1F, VParam[ED_MFIRE4][5] * 0.1F, 
											VParam[ED_MFIRE4][6] * 0.01F, VParam[ED_MFIRE4][7] * 0.01F, 
											(u8)VParam[ED_MFIRE4][8], (u8)VParam[ED_MFIRE4][9],
											(f32)VParam[ED_MFIRE4][10] / 255, (f32)VParam[ED_MFIRE4][11] / 255, (u8)VParam[ED_MFIRE4][19],
											VParam[ED_MFIRE4][12] * 0.01F, VParam[ED_MFIRE4][13] * 0.01F,
											Color, (u8)VParam[ED_MFIRE4][18], (u32)( 1000 * MaxNumRate ), VParam[ED_MFIRE4][20] * 0.01F,
											BILLEFF_SPFIRE, VParam[ED_MFIRE4][22] * 0.01F, VParam[ED_MFIRE4][21],
											SoundID, false, Priority ) ;
		}
		break ;
		
	case MFIRE_KIS :		// LXM
		{
			GXColor Color ;
			
			Color.r = (u8)VParam[ED_MFIRE5][14] ;
			Color.g = (u8)VParam[ED_MFIRE5][15] ;
			Color.b = (u8)VParam[ED_MFIRE5][16] ;
			Color.a = (u8)VParam[ED_MFIRE5][17] ;
		
			Effect = CreateModelFireEffect( JObj,
											(Vec){0.0F,0.0F,0.0F}, 0.0F, FALSE,
											VParam[ED_MFIRE5][0] * 0.01F, VParam[ED_MFIRE5][1] * 0.01F, 
											PI_2 / 3600.0F * VParam[ED_MFIRE5][2], PI_2 / 3600.0F * VParam[ED_MFIRE5][3], 
											VParam[ED_MFIRE5][4] * 0.1F, VParam[ED_MFIRE5][5] * 0.1F, 
											VParam[ED_MFIRE5][6] * 0.01F, VParam[ED_MFIRE5][7] * 0.01F, 
											(u8)VParam[ED_MFIRE5][8], (u8)VParam[ED_MFIRE5][9],
											(f32)VParam[ED_MFIRE5][10] / 255, (f32)VParam[ED_MFIRE5][11] / 255, (u8)VParam[ED_MFIRE5][19],
											VParam[ED_MFIRE5][12] * 0.01F, VParam[ED_MFIRE5][13] * 0.01F,
											Color, (u8)VParam[ED_MFIRE5][18], (u32)( VParam[ED_MFIRE5][23] * 100 * MaxNumRate ), VParam[ED_MFIRE5][20] * 0.01F,
											BILLEFF_SPFIRE2, VParam[ED_MFIRE5][22] * 0.01F, (u16)( VParam[ED_MFIRE5][21] * 10 ),
											SoundID, false, Priority ) ;
		}
		break ;

	case MFIRE_KIS_115 :		// LXMR
		{
			GXColor Color ;
			
			Color.r = (u8)VParam[ED_MFIRE6][14] ;
			Color.g = (u8)VParam[ED_MFIRE6][15] ;
			Color.b = (u8)VParam[ED_MFIRE6][16] ;
			Color.a = (u8)VParam[ED_MFIRE6][17] ;
		
			Effect = CreateModelFireEffect( JObj,
											(Vec){0.0F,0.0F,0.0F}, 0.0F, FALSE,
											VParam[ED_MFIRE6][0] * 0.01F, VParam[ED_MFIRE6][1] * 0.01F, 
											PI_2 / 3600.0F * VParam[ED_MFIRE6][2], PI_2 / 3600.0F * VParam[ED_MFIRE6][3], 
											VParam[ED_MFIRE6][4] * 0.1F, VParam[ED_MFIRE6][5] * 0.1F, 
											VParam[ED_MFIRE6][6] * 0.01F, VParam[ED_MFIRE6][7] * 0.01F, 
											(u8)VParam[ED_MFIRE6][8], (u8)VParam[ED_MFIRE6][9],
											(f32)VParam[ED_MFIRE6][10] / 255, (f32)VParam[ED_MFIRE6][11] / 255, (u8)VParam[ED_MFIRE6][19],
											VParam[ED_MFIRE6][12] * 0.01F, VParam[ED_MFIRE6][13] * 0.01F,
											Color, (u8)VParam[ED_MFIRE6][18], (u32)( VParam[ED_MFIRE6][23] * 100 * MaxNumRate ), VParam[ED_MFIRE6][20] * 0.01F,
											BILLEFF_SPFIRE2, VParam[ED_MFIRE6][22] * 0.01F, (u16)( VParam[ED_MFIRE6][21] * 10 ),
											SoundID, false, Priority ) ;
		}
		break ;

	case MFIRE_ISZK_309 :		// ISZKh
		{
			GXColor Color ;
			
			Color.r = (u8)VParam[ED_MFIRE7][14] ;
			Color.g = (u8)VParam[ED_MFIRE7][15] ;
			Color.b = (u8)VParam[ED_MFIRE7][16] ;
			Color.a = (u8)VParam[ED_MFIRE7][17] ;
		
			Effect = CreateModelFireEffect( JObj,
											(Vec){0.0F,0.0F,0.0F}, 0.0F, FALSE,
											VParam[ED_MFIRE7][0] * 0.01F, VParam[ED_MFIRE7][1] * 0.01F, 
											PI_2 / 3600.0F * VParam[ED_MFIRE7][2], PI_2 / 3600.0F * VParam[ED_MFIRE7][3], 
											VParam[ED_MFIRE7][4] * 0.1F, VParam[ED_MFIRE7][5] * 0.1F, 
											VParam[ED_MFIRE7][6] * 0.01F, VParam[ED_MFIRE7][7] * 0.01F, 
											(u8)VParam[ED_MFIRE7][8], (u8)VParam[ED_MFIRE7][9],
											(f32)VParam[ED_MFIRE7][10] / 255, (f32)VParam[ED_MFIRE7][11] / 255, (u8)VParam[ED_MFIRE7][19],
											VParam[ED_MFIRE7][12] * 0.01F, VParam[ED_MFIRE7][13] * 0.01F,
											Color, (u8)VParam[ED_MFIRE7][18], (u32)( VParam[ED_MFIRE7][23] * 100 * MaxNumRate ), VParam[ED_MFIRE7][20] * 0.01F,
											BILLEFF_SPFIRE2, VParam[ED_MFIRE7][22] * 0.01F, (u16)( VParam[ED_MFIRE7][21] * 10 ),
											SoundID, false, Priority ) ;
		}
		break ;
		
	case MFIRE_FUK_107 :		// tNV}R
		{
			GXColor Color ;
			
			Color.r = (u8)__Fire8Table[14] ;
			Color.g = (u8)__Fire8Table[15] ;
			Color.b = (u8)__Fire8Table[16] ;
			Color.a = (u8)__Fire8Table[17] ;
		
			Effect = CreateModelFireEffect( JObj,
											(Vec){0.0F,0.0F,0.0F}, 0.0F, FALSE,
											__Fire8Table[0] * 0.01F, __Fire8Table[1] * 0.01F, 
											PI_2 / 3600.0F * __Fire8Table[2], PI_2 / 3600.0F * __Fire8Table[3], 
											__Fire8Table[4] * 0.1F, __Fire8Table[5] * 0.1F, 
											__Fire8Table[6] * 0.01F, __Fire8Table[7] * 0.01F, 
											(u8)__Fire8Table[8], (u8)__Fire8Table[9],
											(f32)__Fire8Table[10] / 255, (f32)__Fire8Table[11] / 255, (u8)__Fire8Table[19],
											__Fire8Table[12] * 0.01F, __Fire8Table[13] * 0.01F,
											Color, (u8)__Fire8Table[18], (u32)( __Fire8Table[23] * 100 * MaxNumRate ), __Fire8Table[20] * 0.01F,
											BILLEFF_SPFIRE2, __Fire8Table[22] * 0.01F, (u16)( __Fire8Table[21] * 10 ),
											SoundID, false, Priority ) ;
		}
		break ;
		
	case MFIRE_KIS_115_2 :		// LXMR
		{
			GXColor Color ;
			
			Color.r = (u8)__Fire9Table[14] ;
			Color.g = (u8)__Fire9Table[15] ;
			Color.b = (u8)__Fire9Table[16] ;
			Color.a = (u8)__Fire9Table[17] ;
		
			Effect = CreateModelFireEffect( JObj,
											(Vec){0.0F,0.0F,0.0F}, 0.0F, FALSE,
											__Fire9Table[0] * 0.01F, __Fire9Table[1] * 0.01F, 
											PI_2 / 3600.0F * __Fire9Table[2], PI_2 / 3600.0F * __Fire9Table[3], 
											__Fire9Table[4] * 0.1F, __Fire9Table[5] * 0.1F, 
											__Fire9Table[6] * 0.01F, __Fire9Table[7] * 0.01F, 
											(u8)__Fire9Table[8], (u8)__Fire9Table[9],
											(f32)__Fire9Table[10] / 255, (f32)__Fire9Table[11] / 255, (u8)__Fire9Table[19],
											__Fire9Table[12] * 0.01F, __Fire9Table[13] * 0.01F,
											Color, (u8)__Fire9Table[18], (u32)( __Fire9Table[23] * 100 * MaxNumRate ), __Fire9Table[20] * 0.01F,
											BILLEFF_SPFIRE2, __Fire9Table[22] * 0.01F, (u16)( __Fire9Table[21] * 10 ),
											SoundID, false, Priority ) ;
		}
		break ;
		
	case MFIRE_HS :
		{
			GXColor Color ;
			
			Color.r = (u8)__Fire10Table[14] ;
			Color.g = (u8)__Fire10Table[15] ;
			Color.b = (u8)__Fire10Table[16] ;
			Color.a = (u8)__Fire10Table[17] ;
		
			Effect = CreateModelFireEffect( JObj,
											(Vec){0.0F,0.0F,0.0F}, 0.0F, FALSE,
											__Fire10Table[0] * 0.001F, __Fire10Table[1] * 0.001F, 
											PI_2 / 3600.0F * __Fire10Table[2], PI_2 / 3600.0F * __Fire10Table[3], 
											__Fire10Table[4] * 0.1F, __Fire10Table[5] * 0.1F, 
											__Fire10Table[6] * 0.01F, __Fire10Table[7] * 0.01F, 
											(u8)__Fire10Table[8], (u8)__Fire10Table[9],
											(f32)__Fire10Table[10] / 255, (f32)__Fire10Table[11] / 255, (u8)__Fire10Table[19],
											__Fire10Table[12] * 0.01F, __Fire10Table[13] * 0.01F,
											Color, (u8)__Fire10Table[18], (u32)( 300 * MaxNumRate ),
											0.0F,
											-1, 0.0F, 0,
											SoundID, false, Priority ) ;
		}
		break ;
	}
	
	// I
	return Effect ;
}

// ft@C̃GtFNg쐬
extern EFFECT *CreateModelFireEffect( WK7JObj *JObj,
										Vec FirePoint, f32 FireSize, u8 FireFlatFlag,
										f32 MaxPower, f32 MinPower,
										f32 MaxSinSpeed, f32 MinSinSpeed,
										f32 MaxSize, f32 MinSize,
										f32 MaxSizeSpeed, f32 MinSizeSpeed,
										u8 MaxTime, u8 MinTime,
										f32 MaxASpeed, f32 MinASpeed, u8 AlphaInTime,
										f32 CreateRate, f32 TriRate,
										GXColor Color, u8 ColorRand, u32 ObjMaxNum,
										f32 RandPower,
										s32 FireSparkID, f32 FireSparkRate, u16 FireSparkMaxNum,
										s32 SoundID, 
										bool HSModeFlag, 
										s32 Priority )
{
	EFFECT *Effect ;
	MODELFIREEFFECT *MFire ;
	MODEL *Model ;
	void *ObjP ;
	u32 i ;

	// t@C̓ǂݍ݂IĂȂ牽ɏI
	if( CheckModelFireData() == FALSE ) return 0 ;

	// t@CAIuWFNgۑ郁̈mۂ
	ObjP = K7AppSmallMemAllocName( (s32)( sizeof( MODELFIREOBJECT ) * ObjMaxNum ), "Y_MFiObj" ) ;
	if( ObjP == NULL ) return 0 ;
	
	// nꂽIuWFNgf[^烂ff[^쐬BsI
	Model = NULL ;
	if( JObj != NULL && CreateModelData( JObj->GetJObj(), &Model, FALSE, FALSE, TRUE, FALSE ) < 0 )
	{
		K7AppSmallMemFree( ObjP ) ;
		return 0 ;
	}

	// Vft@Cf[^쐬
	Effect = AddEffectData( EFF_MODELFIRE, (void**)&MFire, Priority ) ;
	if( Effect == NULL )
	{
		DeleteModelData( Model ) ;
		K7AppSmallMemFree( ObjP ) ;
		return NULL ;
	}
	
	// p[^ۑ
	MFire->ObjP = ( MODELFIREOBJECT * )ObjP ;
	MFire->JObj = JObj ;
	MFire->FirePoint = FirePoint ;		MFire->FireSize = FireSize ;			MFire->FireFlatFlag = FireFlatFlag ;
	MFire->MaxPower = MaxPower ;		MFire->MinPower = MinPower ;
	MFire->MaxSinSpeed = MaxSinSpeed ;	MFire->MinSinSpeed = MinSinSpeed ;
	MFire->MaxSize = MaxSize ;			MFire->MinSize = MinSize ;
	MFire->MaxSizeSpeed = MaxSizeSpeed ;MFire->MinSizeSpeed = MinSizeSpeed ;
	MFire->MaxTime = MaxTime ;			MFire->MinTime = MinTime ;
	MFire->MaxASpeed = MaxASpeed ;		MFire->MinASpeed = MinASpeed ;
	MFire->AlphaInTime = AlphaInTime ;
	MFire->CreateRate = CreateRate ;	MFire->TriRate = TriRate ;
	MFire->Model = Model ;
	MFire->ObjMaxNum = ObjMaxNum ;
	MFire->Wind = (Vec){0.0F,0.0F,0.0F} ;
	MFire->WindPower = 0.0F ;
	MFire->RandPower = RandPower ;
	MFire->FireSparkID = FireSparkID ;
	MFire->FireSparkRate = FireSparkRate ;
	MFire->FireSparkMaxNum = FireSparkMaxNum ;
	MFire->HSModeFlag = HSModeFlag ;

	MFire->Color = Color ;
	MFire->ColorRand = ColorRand ;
	
	// ΂̕oꍇ̓r{[hGtFNg쐬
	if( MFire->FireSparkID != -1 )
	{
		// ΂̃̕GtFNgf[^ǂ܂ĂȂ̂߂ɓǂݍݏs
		SetupBillboardEffectID( (s8)MFire->FireSparkID ) ;
	
		MFire->FireSparkEffect = CreateBillboardEffect2( (s8)MFire->FireSparkID, (Vec){0.0F,0.0F,0.0F}, 100.0F,
															FireSparkMaxNum, NULL, Priority ) ;
//		MFire->FireSparkEffect = CreateBillboardEffect2( BILLEFF_SPFIRE2, (Vec){0.0F,0.0F,0.0F}, 100.0F,
//															FireSparkMaxNum, NULL, Priority ) ;
		if( MFire->FireSparkEffect == NULL )
		{
			MFire->FireSparkID = -1 ;
		}
		else
		{
			// GtFNgŃIuWFNg쐬Ȃ悤ɂ
			SetBillboardCreateFlag( MFire->FireSparkEffect, FALSE ) ;
		}
	}

	// ̑̃f[^
	MFire->FastDeleteFlag = FALSE ;

	// Đ
//	if( MFiUnion.FireCount == 0 )
	if( SoundID != -1 )
	{
		Vec Point ;
		
		if( JObj != NULL )
		{
			HSD_JObj *JOb ;
			
			JOb = JObj->GetJObj() ;
		
			HSD_JObjSetupMatrix( JOb ) ;
			Point.x = JOb->mtx[0][3] ;
			Point.y = JOb->mtx[1][3] ;
			Point.z = JOb->mtx[2][3] ;
		}
		else
		{
			Point = FirePoint ;
		}

		if( GetEffectSoundOffFlag() == FALSE )
		{
			MFire->SoundID = PlayEffectSE3D( SoundID/*SFX_BT_EF_FIRE_MERAMERA*/, Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
		}
		else
		{
			MFire->SoundID = -1 ;
		}
	}
	else
	{
		MFire->SoundID = -1 ;
	}

	for( i = 0 ; i < MFire->ObjMaxNum ; i ++ )
		MFire->ObjP[i].UseFlag = FALSE ;
	MFire->ObjNum = 0 ;
	MFire->CreateCounter = 0 ;
	
	// ̐𑝂₷
	MFiUnion.FireCount ++ ;

	// I
	return Effect ;
}

// ft@C̃GtFNǧns
extern s8 ReleaseModelFireEffect( EFFECT *Effect )
{
	MODELFIREEFFECT *MFire = ( MODELFIREEFFECT * )Effect->Data ;
	
	// ff[^폜
	if( MFire->Model != NULL ) DeleteModelData( MFire->Model ) ;

	// ΂̕oĂꍇ͍폜
	if( MFire->FireSparkID != -1 && GetEffectValidState( MFire->FireSparkEffect ) == TRUE )
	{
		DelReqEffect( MFire->FireSparkEffect ) ;
		MFire->FireSparkEffect = NULL ;
	}

	// 
	CHKMEMFREE2( MFire->ObjP ) ;
	
	// ̐炷
	MFiUnion.FireCount -- ;
	
	// 
	if( MFire->SoundID != -1 )
	{
		gpSound->mStopSENo( MFire->SoundID/*SFX_BT_EF_FIRE_MERAMERA*/ ) ;
	}

	// I
	return 0 ;
}

// |SXLR[obN
static s8 CreateScanCallBack( Vec **Point, void *Data )
{
	MODELFIREEFFECT *MFire = ( MODELFIREEFFECT * )Data ;
	Vec V1, V2, VC, CPoint ;
	f32 Area, CRate ;
	s32 i, Num ;

//	return ;

	MFire->PolyCounter ++ ;
	
	// ɃIuWFNgς牽I
	if( MFire->ObjNum >= MFire->ObjMaxNum ) return -1 ;

	// Op`̖ʐς߂
/*	
	VECSubtract( &Point[1], &Point[0], &V1 ) ;
	VECSubtract( &Point[2], &Point[0], &V2 ) ;
	VECCrossProduct( &V1, &V2, &VC ) ;
	Area = VECMag( &VC ) * 0.5F ;
*/
	PSVECSubtract( Point[1], Point[0], &V1 ) ;
	PSVECSubtract( Point[2], Point[0], &V2 ) ;
	PSVECCrossProduct( &V1, &V2, &VC ) ;
	Area = PSVECMag( &VC ) * 0.5F ;
	
	// ʐς牽gC邩߂
	Num = (s32)( Area * MFire->TriRate ) ;
	
	// Pȉ̏ꍇ͊măgC
	if( Num <= 0 )
	{
		CRate = MFire->CreateRate * ( Area * MFire->TriRate ) ;
		Num = 1 ;
	}
	else
	{
		CRate = MFire->CreateRate ;
	}

	// Zoꂽ񐔂JԂ
	CPoint = *Point[0] ;
	for( i = 0 ; i < Num ; i ++ )
	{
		// IuWFNgςI
		if( MFire->ObjNum >= MFire->ObjMaxNum ) return -1 ;

		// ̊mŃt@CAo
		if( CRate > (f32)rand() / RAND_MAX * 100.0F )
		{
			Vec P ;
			
			// WZo
			{
				f32 x, y ;

				x = (f32)rand() / RAND_MAX ;
				y = ( 1.0F - x ) * (f32)rand() / RAND_MAX ;

				P.x = CPoint.x + V1.x * x + V2.x * y ;
				P.y = CPoint.y + V1.y * x + V2.y * y ;
				P.z = CPoint.z + V1.z * x + V2.z * y ;
			}

			// 쐬
			FireAdd( MFire, P ) ;
			
			// ΂̕o悤ȐݒɂȂĂ΂̕o
			if( MFire->FireSparkID != -1 )
			{
				// ΂̃̕GtFNgf[^ǂ܂ĂȂ̂߂ɓǂݍݏs
				SetupBillboardEffectID( (s8)MFire->FireSparkID ) ;
				
				// ΂̃̕GtFNgf[^܂ǂݏIĖ牽Ȃ
				if( CheckBillboardEffectIDState( (s8)MFire->FireSparkID ) == TRUE && (f32)rand() / RAND_MAX < MFire->FireSparkRate )
//				if( (f32)rand() / RAND_MAX < MFire->FireSparkRate )
				{
					AddBillboardEffectObject( MFire->FireSparkEffect, P ) ;
				}
			}
		}
	}
	
	return 0 ;
}


// ft@C̃GtFNgPt[
extern s8 MoveModelFireEffect( EFFECT *Effect )
{
	MODELFIREEFFECT *MFire = ( MODELFIREEFFECT * )Effect->Data ;
	u32 i, Num, j ;
	MODELFIREOBJECT *Ob ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 폜tOĂ폜
	if( MFire->FastDeleteFlag == TRUE || ( Effect->DelReqFlag == TRUE && MFire->ObjNum == 0 ) )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// ׂẴIuWFNgPt[s
	Num = MFire->ObjNum ;
	Ob = MFire->ObjP ;
	for( i = 0 ; i < Num ; Ob ++ )
	{
		// f[^L珈
		if( Ob->UseFlag == TRUE )
		{
			i ++ ;
#if 1

			// Wړ
			Ob->BackP = Ob->Point ;
			Ob->Point.x += Ob->Speed.x ;
			Ob->Point.y += Ob->Speed.y ;
			Ob->Point.z += Ob->Speed.z ;

			// xύX
			Ob->Speed.y += Ob->SSpeed ;
			
			// 
			Ob->Speed.x += MFire->Wind.x * MFire->WindPower ;
			Ob->Speed.y += MFire->Wind.y * MFire->WindPower ;
			Ob->Speed.z += MFire->Wind.z * MFire->WindPower ;
			
			// TCYύX
			Ob->Size -= Ob->SSize ;
			
			// TCe[u𐄈
			for( j = 0 ; j < SINTABLENUM ; j ++ )
				Ob->SinTable[j] += Ob->SinSpeed[j] ;
				
			// SJn^C𒴂ĂAt@l
			if( Ob->Counter < MFire->AlphaInTime )
			{
				Ob->a = (u8)( (f32)( Ob->Counter + 1 ) / MFire->AlphaInTime * 255 ) ;
			}
			else
			{
				if( Ob->Counter > Ob->DeadTime )
				{
					if( Ob->a <= Ob->sa ) Ob->a = 0 ;
					else Ob->a -= Ob->sa ;
				}
			}

			// JE^i߂
			Ob->Counter ++ ;
			
			// TCYOȉɂȂ邩At@lOȉɂȂ
			if( Ob->a <= 0 || Ob->Size < 0.0F )
			{
				Ob->UseFlag = FALSE ;
				
				// 炷
				MFire->ObjNum -- ;
				
				continue ;
			}
#else
				Ob->UseFlag = FALSE ;
				
				// 炷
				MFire->ObjNum -- ;
#endif
		}
	}

	// o
	if( Effect->DelReqFlag == FALSE ) 
	{
		// ff[^牊oĂ邩ǂŏ𕪊
		if( MFire->JObj != NULL )
		{
			// wuX}Cp[h̏ꍇƂłȂꍇŏ𕪊
			if( MFire->HSModeFlag == false )
			{
				// f̑S|SXL
				MFire->PolyCounter = 0 ;
	//			if( MFire->CreateCounter % 3 == 0 )
					ScanModelPrimitive( MFire->Model, CreateScanCallBack, MFire ) ;
	//			MFire->CreateCounter ++ ;
			}
			else
			{
				MODELFIREHSMODEINFO *info ;
				Vec Pos ;
				f32 Area, CRate ;
				s32 i ;
				WK7JObj *jobj ;
			
				// wuX}Cp
				
				for( info = __ModelFireHSModeInfo ; info->name != NULL ; info ++ )
				{
					if( ( jobj = MFire->JObj->GetObj( info->name ) ) == NULL ) continue ;

					// oW擾
					GetJObjPos( jobj->GetJObj(), &Pos ) ;
				
					// oZo
					Area = info->size * MFire->FireSize * 0.5F ;

					// ʐς牽gC邩߂
					Num = (u32)( Area * MFire->TriRate ) ;

					// Pȉ̏ꍇ͊măgC
					if( Num <= 0 )
					{
						CRate = MFire->CreateRate * ( Area * MFire->TriRate ) ;
						Num = 1 ;
					}
					else
					{
						CRate = MFire->CreateRate ;
					}
					
					// Zoꂽ񐔂JԂ
					for( i = 0 ; i < Num ; i ++ )
					{
						// IuWFNgςI
						if( MFire->ObjNum >= MFire->ObjMaxNum ) break ;

						// ̊mŃt@CAo
						if( CRate > (f32)rand() / RAND_MAX * 100.0F )
						{
							Vec Point ;
							
							// WZo
							{
								f32 oir, xz , l ;
								
								oir = rand() * PI / RAND_MAX - PI * 0.5F ;
								xz = rand() * PI_2 / RAND_MAX ;
								l = rand() * Area * ( VParam[ED_MFIRE][22] * 0.01F ) / RAND_MAX ;
								
								Point.x = cosf(oir) * l ;
								Point.y = sinf(oir) * l ;
								
								Point.z = sinf(xz) * Point.x ;
								Point.x = cosf(xz) * Point.x ;

								Point.x += Pos.x ;
								Point.y += Pos.y ;
								Point.z += Pos.z ;
							}
							
							// 쐬
							FireAdd( MFire, Point ) ;

							// ΂̕o悤ȐݒɂȂĂ΂̕o
							if( MFire->FireSparkID != -1 )
							{
								// ΂̃̕GtFNgf[^ǂ܂ĂȂ̂߂ɓǂݍݏs
								SetupBillboardEffectID( (s8)MFire->FireSparkID ) ;
								
								// ΂̃̕GtFNgf[^܂ǂݏIĖ牽Ȃ
								if( CheckBillboardEffectIDState( (s8)MFire->FireSparkID ) == TRUE && (f32)rand() / RAND_MAX < MFire->FireSparkRate )
//								if( (f32)rand() / RAND_MAX < MFire->FireSparkRate )
								{
									AddBillboardEffectObject( MFire->FireSparkEffect, Point ) ;
								}
							}
						}
					}

				}
			}
		}
		else
		{
			s32 Num ; 
			f32 Area, CRate ;
			
			// XZʂ牊oǂŏ𕪊
			if( MFire->FireFlatFlag == TRUE )
			{
				// XZʂ牊ȍ
				
				// oZo
				Area = PI * ( MFire->FireSize * 0.5F ) * ( MFire->FireSize * 0.5F ) ;

				// ʐς牽gC邩߂
				Num = (s32)( Area * MFire->TriRate ) ;

				// Pȉ̏ꍇ͊măgC
				if( Num <= 0 )
				{
					CRate = MFire->CreateRate * ( Area * MFire->TriRate ) ;
					Num = 1 ;
				}
				else
				{
					CRate = MFire->CreateRate ;
				}
				
				// Zoꂽ񐔂JԂ
				for( i = 0 ; i < Num ; i ++ )
				{
					// IuWFNgςI
					if( MFire->ObjNum >= MFire->ObjMaxNum ) break ;

					// ̊mŃt@CAo
					if( CRate > (f32)rand() / RAND_MAX * 100.0F )
					{
						Vec Point ;
						
						// WZo
						{
							f32 r, l ;
							
							r = rand() * PI_2 / RAND_MAX ;
							l = rand() * MFire->FireSize / RAND_MAX ;

							Point.x = MFire->FirePoint.x + cosf( r ) * l ;
							Point.y = MFire->FirePoint.y ;
							Point.z = MFire->FirePoint.z + sinf( r ) * l ;
						}
						
						// 쐬
						FireAdd( MFire, Point ) ;
						
						// ΂̕o悤ȐݒɂȂĂ΂̕o
						if( MFire->FireSparkID != -1 )
						{
							// ΂̃̕GtFNgf[^ǂ܂ĂȂ̂߂ɓǂݍݏs
							SetupBillboardEffectID( (s8)MFire->FireSparkID ) ;
							
							// ΂̃̕GtFNgf[^܂ǂݏIĖ牽Ȃ
							if( CheckBillboardEffectIDState( (s8)MFire->FireSparkID ) == TRUE && (f32)rand() / RAND_MAX < MFire->FireSparkRate )
//							if( (f32)rand() / RAND_MAX < MFire->FireSparkRate )
							{
								AddBillboardEffectObject( MFire->FireSparkEffect, Point ) ;
							}
						}
					}
				}
			}
			else
			{
				// 牊ȍ

				// oZo
				Area = ( 4.0F / 3.0F ) * PI * ( MFire->FireSize * 0.5F ) * ( MFire->FireSize * 0.5F ) * ( MFire->FireSize * 0.5F ) ;

				// ʐς牽gC邩߂
				Num = (s32)( Area * MFire->TriRate ) ;

				// Pȉ̏ꍇ͊măgC
				if( Num <= 0 )
				{
					CRate = MFire->CreateRate * ( Area * MFire->TriRate ) ;
					Num = 1 ;
				}
				else
				{
					CRate = MFire->CreateRate ;
				}
				
				// Zoꂽ񐔂JԂ
				for( i = 0 ; i < Num ; i ++ )
				{
					// IuWFNgςI
					if( MFire->ObjNum >= MFire->ObjMaxNum ) break ;

					// ̊mŃt@CAo
					if( CRate > (f32)rand() / RAND_MAX * 100.0F )
					{
						Vec Point ;
						
						// WZo
						{
							f32 oir, xz , l ;
							
							oir = rand() * PI / RAND_MAX - PI * 0.5F ;
							xz = rand() * PI_2 / RAND_MAX ;
							l = rand() * MFire->FireSize / RAND_MAX ;
							
							Point.x = cosf(oir) * l ;
							Point.y = sinf(oir) * l ;
							
							Point.z = sinf(xz) * Point.x ;
							Point.x = cosf(xz) * Point.x ;

							Point.x += MFire->FirePoint.x ;
							Point.y += MFire->FirePoint.y ;
							Point.z += MFire->FirePoint.z ;
						}
						
						// 쐬
						FireAdd( MFire, Point ) ;

						// ΂̕o悤ȐݒɂȂĂ΂̕o
						if( MFire->FireSparkID != -1 )
						{
							// ΂̃̕GtFNgf[^ǂ܂ĂȂ̂߂ɓǂݍݏs
							SetupBillboardEffectID( (s8)MFire->FireSparkID ) ;
							
							// ΂̃̕GtFNgf[^܂ǂݏIĖ牽Ȃ
							if( CheckBillboardEffectIDState( (s8)MFire->FireSparkID ) == TRUE && (f32)rand() / RAND_MAX < MFire->FireSparkRate )
//							if( (f32)rand() / RAND_MAX < MFire->FireSparkRate )
							{
								AddBillboardEffectObject( MFire->FireSparkEffect, Point ) ;
							}
						}
					}
				}
			}
		}
	}

	// I
	return 0 ;
}

// ft@C̃GtFNg`悷
extern s8 DrawModelFireEffect( EFFECT *Effect )
{
	MODELFIREEFFECT *MFire = ( MODELFIREEFFECT * )Effect->Data ;
	Mtx TMtx ;
	
//	return 0 ;
	
	// `悵ȂtOĂ牽`悵Ȃ
	if( MFiUnion.FireNotDrawFlag == TRUE ) return 0 ;
	
	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX ) ;
	
	// ]us擾
	EffectGetInvViewMatrix( TMtx ) ;
	
	// TEVݒ
    GXSetNumTevStages(1);
	GXSetTevSwapModeTable( GX_TEV_SWAP2, GX_CH_RED, GX_CH_RED, GX_CH_RED, GX_CH_RED ) ;
	GXSetTevSwapMode( GX_TEVSTAGE0, GX_TEV_SWAP0, GX_TEV_SWAP2 ) ;
    GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
    GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_RASA, GX_CA_TEXA, GX_CA_ZERO ) ; 
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// eNX`̃[h
	GTLOAD2( MFiUnion.ModelFireTexAlpha ) ;

	// `揈Jn
	GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( MFire->ObjNum * 4 ) ) ;
	{
		MODELFIREOBJECT *Ob ;
		u32 i, Num ;
		Vec Point ;
		u8 a ;
		u16 u, v ;
		s32 AddTC ;
		Vec p[4] ;
		f32 Width ;

		p[0].x = -0.5F ;	p[0].y = 0.5F ;		p[0].z = 0.0F ;	MTXMultVec( TMtx, &p[0], &p[0] ) ;
		p[1].x = 0.5F ;		p[1].y = 0.5F ;		p[1].z = 0.0F ;	MTXMultVec( TMtx, &p[1], &p[1] ) ;
		p[2].x = 0.5F ;		p[2].y = -0.5F ;	p[2].z = 0.0F ;	MTXMultVec( TMtx, &p[2], &p[2] ) ;
		p[3].x = -0.5F ;	p[3].y = -0.5F ;	p[3].z = 0.0F ;	MTXMultVec( TMtx, &p[3], &p[3] ) ;
		
		Num = MFire->ObjNum ;
		Ob = MFire->ObjP ;
		for( i = 0 ; i < Num ; Ob ++ )
		{
			if( Ob->UseFlag == TRUE )
			{
				i ++ ;
				
				// WZo
				Point = Ob->Point ;

				// At@lZbg
				a = (u8)( ( Ob->a * Ob->Color.a ) >> 8 ) ;
				
				// TCYZbg
				Width = ( Ob->Counter < MFire->AlphaInTime ) ? Ob->Size * (f32)( Ob->Counter + 1 ) / MFire->AlphaInTime : Ob->Size ;
				
				// eNX`WZbg
				if( Ob->ReverseFlag == TRUE )
				{
					u = (u16)( ( Ob->tu + 1 ) * UVSCALE / FIRETEX_DIVNUM ) ;
					v = (u16)( ( Ob->tv + 1 ) * UVSCALE / FIRETEX_DIVNUM ) ;
					AddTC = -( UVSCALE / FIRETEX_DIVNUM ) ;
				}
				else
				{
					u = (u16)( Ob->tu * UVSCALE / FIRETEX_DIVNUM ) ;
					v = (u16)( Ob->tv * UVSCALE / FIRETEX_DIVNUM ) ;
					AddTC = ( UVSCALE / FIRETEX_DIVNUM ) ;
				}

				// _o
				GP3( p[0].x * Width + Point.x, p[0].y * Width + Point.y, p[0].z * Width + Point.z ) ; 				GC2( Ob->Color, a ) ; GT2( u, v ) ;
				GP3( p[1].x * Width + Point.x, p[1].y * Width + Point.y, p[1].z * Width + Point.z ) ; 				GC2( Ob->Color, a ) ; GT2( (u16)( u + AddTC ), v ) ;
				GP3( p[2].x * Width + Ob->BackP.x, p[2].y * Width + Ob->BackP.y, p[2].z * Width + Ob->BackP.z ) ; 	GC2( Ob->Color, a ) ; GT2( (u16)( u + AddTC ), (u16)( v + AddTC ) ) ;
				GP3( p[3].x * Width + Ob->BackP.x, p[3].y * Width + Ob->BackP.y, p[3].z * Width + Ob->BackP.z ) ; 	GC2( Ob->Color, a ) ; GT2( u, (u16)( v + AddTC ) ) ;
			}
		}
	}
	GXEnd() ;

	// ߂
	GXSetTevSwapModeTable( GX_TEV_SWAP2, GX_CH_GREEN, GX_CH_GREEN, GX_CH_GREEN, GX_CH_ALPHA ) ;
	GXSetTevSwapMode( GX_TEVSTAGE0, GX_TEV_SWAP0, GX_TEV_SWAP0 ) ;
	
	// I
	return 0 ;
}					


// 폜NGXgs
extern s8 FastDelReqModelFireEffect( EFFECT *Effect )
{
	MODELFIREEFFECT *MFire = ( MODELFIREEFFECT * )Effect->Data ;
	
	MFire->FastDeleteFlag = TRUE ;

	// I
	return 0 ;
}

// ̋Zbg
extern s8 SetWindModelFireEffect( EFFECT *Effect, Vec Wind, f32 WindPower )
{
	MODELFIREEFFECT *MFire = ( MODELFIREEFFECT * )Effect->Data ;
	
	// K
	VECNormalize( &Wind, &MFire->Wind ) ;
	MFire->WindPower = WindPower ;

	// I
	return 0 ;
}

// `悷邩ǂ̃tOZbg
extern s8 SetModelFireDrawFlag( s8 DrawFlag )
{
	MFiUnion.FireNotDrawFlag = !DrawFlag ;
	
	// I
	return 0 ;
}

// 쐬łIuWFNg̍ő吔ɑ΂oCAXZbg
extern s8 SetModelFireMaxNumRate( f32 MaxNumRate )
{
	MFiUnion.MaxNumRate = MaxNumRate ;
	MFiUnion.MaxNumRateFlag = true ;
	
	// I
	return 0 ; 
}

