///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectPanelCursor
//
// YK7EffectPanelCursor.cpp
//
// Creator	   : Takumi Yamada (GHM)
// Creation Date : 12/19/2003
//
//////////////////////////////////////////////////////////////////////////////

#define __NONTEX

#define	__YK7TESTTASK_CPP__

#define BUT_A_D		PAD_BUTTON_Y
#define BUT_B_D		PAD_BUTTON_X
#define BUT_A		PAD_BUTTON_A
#define BUT_B		PAD_BUTTON_B

// include --------------------------------------
#include "./YK7EffectPanelCursor.h"
#include "./YK7EffectCursor.h"
#include "./YK7CharChange.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

#define DEF_MESPACK			"/Yam/Message/Select.jmb"

#define PNCUR_TEXBASE		"/Yam/cursor/"			// plJ[\GtFNgp̃eNX`̃x[XpX
#define DEMOTEXNUM			4
#define SELPOSNUM			2

#define PR1				(s32)VParam[ED_PNCURSOR]
#define PR2				(s32)VParam[ED_PNCURSOR2]

#define ZURE			(PR2[16]*0.1F)
#define ZURE2			(PR2[18]*0.1F)
#define ALPHA			(PR2[17]*0.01F)

// eNX`t@C
const char *DirTexName[4] = { "cr_left.BIN", "cr_right.BIN", "cr_up.BIN", "cr_down.BIN" } ;
const char *DemoTexName[DEMOTEXNUM] = { "cr_blood.BIN", "cr_cheese.BIN", "cr_killer7.BIN", "cr_unfurled.BIN" } ;
const char *OkCancelTexName[2] = { "cr_ok.BIN", "cr_cancel.BIN" } ;

// ̔zu
const s32 DirPos[4][2] = { { -1, 0 }, { 1, 0 }, { 0, -1 }, { 0, 1 } } ;

// OK,CANCEL ̔zu
//const s32 SelPos[SELPOSNUM][CUR_NUM][2] = { { { 1, -1 }, { 1, 1 }, { 1, 1 } },   { { -1, -1 }, { -1, 1 }, { -1, 1 } } } ;
const s32 SelPos[SELPOSNUM][CUR_NUM][2] = { { { 1, -1 }, { 1, -1 }, { 1, -1 } },   { { -1, -1 }, { -1, -1 }, { -1, -1 } } } ;


// datatype -------------------------------------

// data -----------------------------------------

PANELCURSORUNION PncUnion ;

// function proto type --------------------------

// plJ[\p̃eNX`ǂݍ
extern s8 PncTexLoad( const char *TexName, TEXDATA *TexData ) ;

// eNX`ǂݍ݂̃`FbN( TRUE:  FALSE: )
extern s8 PncTexLoadCheck( void ) ;

// ̂ʒu̎擾
static s8 GetPncSelPos( PANELCURSOREFFECT *Pnc ) ;

// function code --------------------------------

// ̂ʒu̎擾
static s8 GetPncSelPos( PANELCURSOREFFECT *Pnc )
{
	s32 w, h, x, y, Flag, j, i, maxw ;
	PANELSELECT *Sel ;
	
	// ԕ̂OtBbN
	if( Pnc->PackID != -1 && Pnc->MessageID != -1 )
	{
		maxw = 0 ;
		for( i = 0 ; i < 2 ; i ++ )
			if( Pnc->SelMes[i].Width > maxw ) maxw = Pnc->SelMes[i].Width ;
	}
	else
	{
		maxw = 0 ;
		for( i = 0 ; i < 2 ; i ++ )
			if( PncUnion.OkCancelTex[i].Data.Header->mWidth > maxw ) maxw = PncUnion.OkCancelTex[i].Data.Header->mWidth ;
	}

	for( j = 0 ; j < SELPOSNUM ; j ++ )
	{
		Flag = FALSE ;
		Sel = Pnc->Select ;
		for( i = 0 ; i < 2 ; i ++, Sel ++ )
		{
			if( Pnc->PackID != -1 && Pnc->MessageID != -1 )
			{
				w = Pnc->SelMes[i].Width ;
				h = Pnc->SelMes[i].Height / 2 ;
			}
			else
			{
				w = PncUnion.OkCancelTex[i].Data.Header->mWidth ;
				h = PncUnion.OkCancelTex[i].Data.Header->mHeight / 2 ;
			}

			x = Pnc->x + SelPos[j][i][0] * Pnc->Width ;
			y = (s32)( Pnc->y + SelPos[j][i][1] * ( Pnc->Height * ( (f32)VParam[ED_PNCURSOR][22] / ( (f32)VParam[ED_PNCURSOR][4] / 2.0F ) ) ) ) ;
			if( SelPos[j][i][0] < 0 ) x -= maxw ;
			
			if( ( x > VParam[ED_PNCURSOR][26] ) && ( x + w < SCW - VParam[ED_PNCURSOR][26] ) &&
				( y > VParam[ED_PNCURSOR][26] ) && ( y + h < SCH - VParam[ED_PNCURSOR][26] ) ) goto R1 ;
		}
	}
	
R1 :
	if( j == SELPOSNUM ) j -- ;
	
	return (s8)j ;
}


// eNX`ǂݍ݂̃`FbN( TRUE:  FALSE: )
extern s8 PncTexLoadCheck( void )
{
#ifndef __NONTEX
	s32 i ;
	
	for( i = 0 ; i < 4 ; i ++ )
		if( TexLoadChk( &PncUnion.DirTex[i] ) == FALSE ) return FALSE ;

	for( i = 0 ; i < 2 ; i ++ )
		if( TexLoadChk( &PncUnion.OkCancelTex[i] ) == FALSE ) return FALSE ;
	
	for( i = 0 ; i < DEMOTEXNUM ; i ++ )
		if( TexLoadChk( &PncUnion.DemoTex[i] ) == FALSE ) return FALSE ;
#endif
		
	if( CheckMessagePackLoadComp( (s8)PncUnion.SelectJmbPackID ) == FALSE ) return FALSE ;
	
	return TRUE ;
}



// plJ[\p̃eNX`ǂݍ
extern s8 PncTexLoad( const char *TexName, TEXDATA *TexData )
{
	char LoadFileName[64] ;
	
	sprintf( LoadFileName, "%s%s", PNCUR_TEXBASE, TexName ) ;

	// ǂݍ݊Jn
	return TexLoadSet( LoadFileName, TexData ) ;
}

// plJ[\GtFNg̋ʃf[^
extern s8 InitPanelCursorData( void )
{
	MEMINIT( PncUnion ) ;

#ifndef __NONTEX
	s32 i ;
	
	// eNX`ǂݍ
	for( i = 0 ; i < 4 ; i ++ )
	{
		PncTexLoad( DirTexName[i], &PncUnion.DirTex[i] ) ;
	}
	
	// OK,CanceleNX`ǂݍ
	for( i = 0 ; i < 2 ; i ++ )
		PncTexLoad( OkCancelTexName[i], &PncUnion.OkCancelTex[i] ) ;
	
	// feNX`ǂݍ
	for( i = 0 ; i < DEMOTEXNUM ; i ++ )
		PncTexLoad( DemoTexName[i], &PncUnion.DemoTex[i] ) ;
#endif
		
	// WI𕶎ǂݍ
	PncUnion.SelectJmbPackID = LoadMessagePack( DEF_MESPACK ) ;

	// I
	return 0 ;
}

// plJ[\GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckPanelCursorData( void )
{
	return TRUE ;
//	return PncTexLoadCheck() ;
}	


// plJ[\GtFNg̋ʃf[^n
extern s8 EndPanelCursorData( void )
{
#ifndef __NONTEX
	s32 i ;
	
	// eNX`
	for( i = 0 ; i < 4 ; i ++ )
		TexRelease( &PncUnion.DirTex[i] ) ;

	// feNX`
	for( i = 0 ; i < DEMOTEXNUM ; i ++ )
		TexRelease( &PncUnion.DemoTex[i] ) ;

	// OK,CanceleNX`
	for( i = 0 ; i < 2 ; i ++ )
		TexRelease( &PncUnion.OkCancelTex[i] ) ;
#endif

	// I
	return 0 ;
}

// plJ[\GtFNg쐬
extern EFFECT *CreatePanelCursorEffect( s16 x, s16 y, u32 color, s32 Priority )
{
	PANELCURSOREFFECT *Pnc ;
	PANELSELECT *Sel ;
	EFFECT *Effect, *Cursor ;
	GXColor Col ;
	s32 i ;
	
	// J[\GtFNg쐬
	{
/*
		Col.r = (u8)VParam[ED_PNCURSOR][0] ;
		Col.g = (u8)VParam[ED_PNCURSOR][1] ;
		Col.b = (u8)VParam[ED_PNCURSOR][2] ;
		Col.a = (u8)VParam[ED_PNCURSOR][3] ;
*/
		*((u32 *)&Col) = color ;
		Cursor = CreateCursorEffect( Col, FALSE ) ;
		if( Cursor == NULL ) return NULL ;
		SetCursorShadowFlag( Cursor, TRUE ) ;
		SetCursorPos( (u16)x, (u16)y, 0, 0, Cursor, FALSE, FALSE ) ;
		SetCenterCursorDrawFlag( TRUE, Cursor ) ;
		SetCursorDrawFlag( TRUE, Cursor ) ;
		SetCursorBrinkMode( Cursor, 3 ) ;
//		SetCursorPos( (u16)x, (u16)y, (s16)VParam[ED_PNCURSOR][4], (s16)VParam[ED_PNCURSOR][4], Cursor, FALSE ) ;
	}

	// VplJ[\f[^쐬
	Effect = AddEffectData( EFF_PANELCURSOR, (void**)&Pnc, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( Cursor ) ;
		return NULL ;
	}

	// ۑ
	Pnc->Ax = Pnc->x = x ;
	Pnc->Ay = Pnc->y = y ;
	Pnc->BackX = x ;
	Pnc->BackY = y ;
	Pnc->DrawFlag = FALSE ;
	Pnc->Cursor = Cursor ;
	Pnc->Width = 0 ;
	Pnc->Height = 0 ;
	Pnc->PackID = -1 ;
	Pnc->MessageID = -1 ;
	Pnc->MesDrawFlag = true ;
	Pnc->MesDrawAlpha = 0.0F ;

	Pnc->OkCancelFlag = FALSE ;
	Pnc->SelEndFlag = FALSE ;
	Pnc->SelEndCounter = 0 ;
	Pnc->ActSelect = 0 ;
	
	// ZNgIuWFNg̏
	{
		Sel = Pnc->Select ;
		for( i = 0 ; i < CUR_NUM ; i ++, Sel ++ )
		{
			Sel->DrawFlag = FALSE ;
			Sel->Alpha = 0.0F ;
			Sel->ActiveFlag = FALSE ;
			Sel->Bright = 0.0F ;
			Sel->BrightCounter = 0.0F ;
			Sel->ExtRate = 0.0F ;
			
			Sel->BrinkFlag = FALSE ;
			Sel->BrinkCounter = 0 ;
			Sel->BrinkState = FALSE ;
			
			Sel->r = Sel->g = Sel->b = 0.0F ;
		}
	}

	// IuWFNg̏
	{
		s32 i ;
		PANELCURSORDIR *Dir ;

		Dir = Pnc->Dir ;
		for( i = 0 ; i < 4 ; i ++, Dir ++ )
		{
			Dir->BackFlag = FALSE ;
			Dir->DrawFlag = FALSE ;
			Dir->ActiveFlag = TRUE ;
			Dir->Bright = 1.0F ;
			Dir->Alpha = 0.0F ;
			Dir->BrinkFlag = FALSE ;
			Dir->SubFlag = FALSE ;
			Dir->SubAlpha = 0.0F ;
			Dir->SubCounter = 0 ;
		}
	}
	
	// I
	return Effect ;
}

// plJ[\̃GtFNǧns
extern s8 ReleasePanelCursorEffect( EFFECT *Effect )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;

	// J[\GtFNg폜
	DeleteEffect( Pnc->Cursor ) ;

	// ʉ~߂
	gpSound->mStopSE( SFX_SYS_PNL_CHOOSE_OK_LOOP ) ;
	gpSound->mStopSE( SFX_SYS_PNL_CHOOSE_CANCEL_LOOP ) ;

	// I
	return 0 ;
}

// plJ[\̃GtFNgPt[
extern s8 MovePanelCursorEffect( EFFECT *Effect )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	s32 i, j, k ;
	
	// eNX`ǂݍ݂̃`FbN
	if( PncTexLoadCheck() == FALSE ) return 0 ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// ͂̍XV
	PadUpdateInput() ;
	
	if( Pnc->MesDrawFlag )
	{
		if( Pnc->MesDrawAlpha != 1.0F ) Pnc->MesDrawAlpha += 0.1F ;
		if( Pnc->MesDrawAlpha > 1.0F ) Pnc->MesDrawAlpha = 1.0F ;
	}
	else
	{
		if( Pnc->MesDrawAlpha != 0.0F ) Pnc->MesDrawAlpha -= 0.1F ;
		if( Pnc->MesDrawAlpha < 0.0F ) Pnc->MesDrawAlpha = 0.0F ;
	}

	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE )
	{
		PANELCURSORDIR *Dir ;
		PANELSELECT *Sel ;
		
		Dir = Pnc->Dir ;
		j = 0 ;
		for( i = 0 ; i < 4 ; i ++, Dir ++ )
		{
			if( Dir->Alpha == 0.0F ) j ++ ;
			Dir->DrawFlag = FALSE ;
		}

		Sel = Pnc->Select ;
		k = 0 ;
		for( i = 0 ; i < CUR_NUM ; i ++, Sel ++ )
		{
			if( Sel->Alpha == 0.0F ) k ++ ;
			Sel->DrawFlag = FALSE ;
		}
		
		if( j == 4 && k == CUR_NUM )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}
	
	// ̍Ẅړ
	{
		Pnc->Ax += ( Pnc->x - Pnc->Ax ) * VParam[ED_CURSOR2][0] * 0.01F ;
		Pnc->Ay += ( Pnc->y - Pnc->Ay ) * VParam[ED_CURSOR2][0] * 0.01F ;
	}
	
	// IuWFNg̏
	{
		PANELCURSORDIR *Dir ;
		
		Dir = Pnc->Dir ;
		for( i = 0 ; i < 4 ; i ++, Dir ++ )
		{
			if( Dir->BrinkFlag == TRUE )
			{
				Dir->BrinkCon1 ++ ;
				if( Dir->BrinkCon1 >= VParam[ED_PNCURSOR2][14] )
				{
					Dir->BrinkCon1 = 0 ;
					Dir->BrinkCon2 ++ ;
					if( Dir->BrinkCon2 == VParam[ED_PNCURSOR2][15] )
					{
						Dir->BrinkFlag = FALSE ;
					}
				}
			}
		
			if( Dir->SubFlag == TRUE )
			{
				if( Dir->SubDir < 0.0F )
				{
					Dir->SubAlpha -= (f32)VParam[ED_PNCURSOR2][12] * 0.01F ;
					if( Dir->SubAlpha < -1.0F )
					{
						Dir->SubAlpha = -1.0F ;
						Dir->SubDir = 1.0F ;
					}
				}
				else
				{
					if( Dir->SubCounter <= 0 )
					{
						Dir->SubAlpha += (f32)VParam[ED_PNCURSOR2][12] * 0.01F ;
						if( Dir->SubAlpha > 0.0F )
						{
							Dir->SubAlpha = 0.0F ;
							Dir->SubFlag = FALSE ;
						}
					}
					else
					{
						Dir->SubCounter -- ;
					}
				}
			}
		
			if( Dir->BackFlag == TRUE )
			{
				Dir->BackBright -= (f32)VParam[ED_PNCURSOR][11] / 255.0F ;
				if( Dir->BackBright < 0.0F ) Dir->BackBright = 0.0F ;
				
				Dir->BackAlpha -= (f32)VParam[ED_PNCURSOR][10] / 255.0F ;
				if( Dir->BackAlpha < 0 )
				{
					Dir->BackAlpha = 0.0F ;
					Dir->BackFlag = FALSE ;
				}
			}

			if( Dir->DrawFlag == TRUE && Pnc->DrawFlag == TRUE )
			{
				Dir->Alpha += VParam[ED_PNCURSOR][6] / 255.0F ;
				if( Dir->Alpha > VParam[ED_PNCURSOR][7] / 255.0F ) Dir->Alpha = (f32)VParam[ED_PNCURSOR][7] / 255.0F ;
			}
			else
			{
				if( Dir->BrinkFlag == FALSE )
				{
					Dir->Alpha -= (f32)VParam[ED_PNCURSOR][6] / 255.0F ;
					if( Dir->Alpha < 0.0F ) Dir->Alpha = 0.0F ;
				}
			}
			
			if( Dir->ActiveFlag == TRUE )
			{
				Dir->Bright += (f32)VParam[ED_PNCURSOR][8] / 255.0F ;
				if( Dir->Bright > 1.0F ) Dir->Bright = 1.0F ;
			}
			else
			{
				if( Dir->BrinkFlag == FALSE )
				{
					Dir->Bright -= (f32)VParam[ED_PNCURSOR][6] / 255.0F ;
					if( Dir->Bright < (f32)VParam[ED_PNCURSOR][9] / 255.0F ) Dir->Bright = (f32)VParam[ED_PNCURSOR][9] / 255.0F ;
				}
			}
		}
	}
	
	// OK,CANCEL 
	{
		PANELSELECT *Sel ;
		f32 f ;
		
		Sel = Pnc->Select ;
		for( i = 0 ; i < CUR_NUM ; i ++, Sel ++ )
		{
			if( Sel->DrawFlag == TRUE && Pnc->DrawFlag == TRUE )
			{
				if( Sel->BrinkFlag == TRUE )
				{
					Sel->BrinkCounter ++ ;
					if( Sel->BrinkCounter >= VParam[ED_PNCURSOR][20] )
					{
						Sel->BrinkCounter = 0 ;
						Sel->BrinkState = (u8)( Sel->BrinkState == TRUE ? FALSE : TRUE ) ;
					}
					
					Sel->ExtRate += (f32)VParam[ED_PNCURSOR2][3] * 0.01F ;
					if( Sel->ExtRate > 1.0F ) Sel->ExtRate = 1.0F ;
				}
				else
				{
					Sel->Alpha += (f32)VParam[ED_PNCURSOR2][10] / 255.0F ;
					if( Sel->Alpha > 1.0F ) Sel->Alpha = 1.0F ;
					
					if( Sel->ActiveFlag == TRUE )
					{
						f = 1.0F - ( VParam[ED_PNCURSOR][15] / 255.0F ) ;
						f = ( 1.0F - f ) + ( f * 0.5F ) + ( f * 0.5F ) * sinf( Sel->BrightCounter ) ;
						Sel->Bright += (f32)VParam[ED_PNCURSOR2][11] / 255.0F ;
						if( Sel->Bright >= f ) Sel->Bright = f ;

						Sel->BrightCounter += VParam[ED_PNCURSOR][14] * PI / 1800.0F ;

//						f = 1.0F + sinf( Sel->BrightCounter ) * VParam[ED_PNCURSOR2][5] * 0.01F ;
						f = 1.0F ;
						Sel->ExtRate += (f32)VParam[ED_PNCURSOR2][3] * 0.01F ;
						if( Sel->ExtRate > f ) Sel->ExtRate = f ;
					}
					else
					{
						f = (f32)VParam[ED_PNCURSOR][16] / 255.0F ;
						Sel->Bright += (f32)VParam[ED_PNCURSOR2][11] / 255.0F ;
						if( Sel->Bright >= f ) Sel->Bright = f ;

						Sel->ExtRate -= (f32)VParam[ED_PNCURSOR2][3] * 0.01F ;
						if( Sel->ExtRate < 0.0F ) Sel->ExtRate = 0.0F ;
					}
				}
			}
			else
			{
				Sel->Alpha -= (f32)VParam[ED_PNCURSOR2][10] / 255.0F ;
				if( Sel->Alpha < 0.0F ) Sel->Alpha = 0.0F ;
				
				Sel->Bright -= (f32)VParam[ED_PNCURSOR2][11] / 255.0F ;
				if( Sel->Bright < 0.0F ) Sel->Bright = 0.0F ;

				Sel->ExtRate -= (f32)VParam[ED_PNCURSOR2][3] * 0.01F ;
				if( Sel->ExtRate < 0.0F ) Sel->ExtRate = 0.0F ;
			}
			
			if( Sel->ActiveFlag == TRUE )
			{
				if( Sel->r >= (f32)VParam[ED_PNCURSOR2][0] / 255.0F )
				{
					Sel->r -= (f32)VParam[ED_PNCURSOR][5] / 255.0F ;
					if( Sel->r < (f32)VParam[ED_PNCURSOR2][0] / 255.0F ) Sel->r = (f32)VParam[ED_PNCURSOR2][0] / 255.0F ;
				}
				else
				{
					Sel->r += (f32)VParam[ED_PNCURSOR][5] / 255.0F ;
					if( Sel->r > (f32)VParam[ED_PNCURSOR2][0] / 255.0F ) Sel->r = (f32)VParam[ED_PNCURSOR2][0] / 255.0F ;
				}

				if( Sel->g >= (f32)VParam[ED_PNCURSOR2][1] / 255.0F )
				{
					Sel->g -= (f32)VParam[ED_PNCURSOR][5] / 255.0F ;
					if( Sel->g < (f32)VParam[ED_PNCURSOR2][1] / 255.0F ) Sel->g = (f32)VParam[ED_PNCURSOR2][1] / 255.0F ;
				}
				else
				{
					Sel->g += (f32)VParam[ED_PNCURSOR][5] / 255.0F ;
					if( Sel->g > (f32)VParam[ED_PNCURSOR2][1] / 255.0F ) Sel->g = (f32)VParam[ED_PNCURSOR2][1] / 255.0F ;
				}

				if( Sel->b >= (f32)VParam[ED_PNCURSOR2][2] / 255.0F )
				{
					Sel->b -= (f32)VParam[ED_PNCURSOR][5] / 255.0F ;
					if( Sel->b < (f32)VParam[ED_PNCURSOR2][2] / 255.0F ) Sel->b = (f32)VParam[ED_PNCURSOR2][2] / 255.0F ;
				}
				else
				{
					Sel->b += (f32)VParam[ED_PNCURSOR][5] / 255.0F ;
					if( Sel->b > (f32)VParam[ED_PNCURSOR2][2] / 255.0F ) Sel->b = (f32)VParam[ED_PNCURSOR2][2] / 255.0F ;
				}
			}
			else
			{
				if( Sel->r < 1.0F )
				{
					Sel->r += (f32)VParam[ED_PNCURSOR][5] / 255.0F ;
					if( Sel->r > 1.0F ) Sel->r = 1.0F  ;
				}

				if( Sel->g < 1.0F )
				{
					Sel->g += (f32)VParam[ED_PNCURSOR][5] / 255.0F ;
					if( Sel->g > 1.0F ) Sel->g = 1.0F  ;
				}

				if( Sel->b < 1.0F )
				{
					Sel->b += (f32)VParam[ED_PNCURSOR][5] / 255.0F ;
					if( Sel->b > 1.0F ) Sel->b = 1.0F  ;
				}
			}
		}
	}
	
	// I
	if( Pnc->OkCancelFlag == TRUE )
	{
		if( Pnc->SelEndFlag == TRUE )
		{
			Pnc->SelEndCounter ++ ;
			if( Pnc->SelEndCounter > VParam[ED_PNCURSOR][21] )
			{
				// II
				EndPanelCursorOkCancelSelect( Effect ) ;
			}
		}
		else
		{
			// {^͂ɂď𕪊
/*			if( GetPadEdgeInput() & PAD_BUTTON_UP )
			{
				Pnc->ActSelect = CUR_OK ;
				SetPanelCursorOkCancelSelectButton( Effect, Pnc->ActSelect ) ;
			}
			if( GetPadEdgeInput() & PAD_BUTTON_DOWN )
			{
				Pnc->ActSelect = CUR_CANCEL ;
				SetPanelCursorOkCancelSelectButton( Effect, Pnc->ActSelect ) ;
			}
*/


//
/*
			if( ( GetPadEdgeInput() & PAD_BUTTON_UP ) || ( GetPadEdgeInput() & PAD_BUTTON_DOWN ) )
			{
				Pnc->ActSelect = Pnc->ActSelect == CUR_OK ? CUR_CANCEL : CUR_OK ;
				SetPanelCursorOkCancelSelectButton( Effect, Pnc->ActSelect ) ;
			}
*/
//

/*			if( GetPadEdgeInput() & ( VParam[ED_PNCURSOR][23] == 0 ? BUT_A : BUT_A_D ) )
			{
	R2 :
				// I
				StopPanelCursorOkCancelSelect( Effect ) ;

				// 艹炷
				if( GetEffectSoundOffFlag() == FALSE )
				{
					gpSound->mStopSE( SFX_SYS_PNL_CHOOSE_OK_LOOP ) ;
					gpSound->mStopSE( SFX_SYS_PNL_CHOOSE_CANCEL_LOOP ) ;
					 
					PlayEffectSE( Pnc->ActSelect == CUR_CANCEL ? SFX_SYS_PNL_CANCEL : SFX_SYS_PNL_OK,
					 SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackSystemOverlap, eSEGroupSystem00 ) ;
				}
			}
			else
			if( GetPadEdgeInput() & ( VParam[ED_PNCURSOR][23] == 0 ? BUT_B : BUT_B_D ) )
			{
				Pnc->ActSelect = CUR_CANCEL ;
				SetPanelCursorOkCancelSelectButton( Effect, Pnc->ActSelect ) ;

				goto R2 ;

				// II
//				Pnc->ActSelect = CUR_CANCEL ;
//				EndPanelCursorOkCancelSelect( Effect ) ;
			}
*/
		}
	}

	// I
	return 0 ;
}



// plJ[\̃GtFNg`悷
extern s8 DrawPanelCursorEffect( EFFECT *Effect )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	PANELSELECT *Sel ;
	s32 i ;
	f32 x, y, w, h ;
	u8 a, b, r, g, bl ;
#ifndef __NONTEX
	f32 fa ;
	PANELCURSORDIR *Dir ;
#endif
	
	//VUO͈̔͐ݒ(!?)
	GXSetScissor( 0, 0, SCW, SCH );

	//r[|[g̐ݒ
	GXSetViewport( 0.0f, 0.0f, (f32)K7APP_SCREEN_WIDTH, (f32)K7APP_SCREEN_HEIGHT, 0.0f, 1.0f );
	
	// eNX`ǂݍ݂̃`FbN
	if( PncTexLoadCheck() == FALSE ) return 0 ;
	
	// `̏
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_2, GX_TRUE, GX_TEVPREV ) ;
	
#ifndef __NONTEX
	// ̕`
	{
		Dir = Pnc->Dir ;
		for( i = 0 ; i < 4 ; i ++, Dir ++ )
		{
			// eNX`̃[h
			GTLOAD2( PncUnion.DirTex[i] ) ;

			// `Jn
			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( 4 + ( Dir->BackFlag == TRUE ? 4 : 0 ) ) ) ;
			{
				w = PncUnion.DirTex[i].Data.Header->mWidth / 2 ;
				h = PncUnion.DirTex[i].Data.Header->mHeight / 2 ;

				if( Dir->BackFlag == TRUE )
				{
					x = Pnc->Ax + DirPos[i][0] * ( Pnc->Width * ( (f32)VParam[ED_PNCURSOR][5] / ( (f32)VParam[ED_PNCURSOR][4] / 2.0F ) ) ) ;
					y = Pnc->Ay + DirPos[i][1] * ( Pnc->Height * ( (f32)VParam[ED_PNCURSOR][5] / ( (f32)VParam[ED_PNCURSOR][4] / 2.0F ) ) ) ;

					fa = Dir->BackAlpha + Dir->SubAlpha ;
					if( fa < 0.0F ) fa = 0.0F ;
					a = (u8)( fa * 255 ) ;
					b = (u8)( Dir->BackBright * 255 ) ;

					DrawTex3NB( x - w, y - h, x + w, y - h, CMK2( b, a ) ) ;
/*
					GP2( x - w, y - h ) ;	GC1( b, a ) ;	GT( 0.0F, 0.0F ) ;
					GP2( x + w, y - h ) ;	GC1( b, a ) ;	GT( 1.0F, 0.0F ) ;
					GP2( x + w, y + h ) ;	GC1( b, a ) ;	GT( 1.0F, 1.0F ) ;
					GP2( x - w, y + h ) ;	GC1( b, a ) ;	GT( 0.0F, 1.0F ) ;
*/
				}

				x = Pnc->Ax + DirPos[i][0] * ( Pnc->Width * ( (f32)VParam[ED_PNCURSOR][5] / ( (f32)VParam[ED_PNCURSOR][4] / 2.0F ) ) ) ;
				y = Pnc->Ay + DirPos[i][1] * ( Pnc->Height * ( (f32)VParam[ED_PNCURSOR][5] / ( (f32)VParam[ED_PNCURSOR][4] / 2.0F ) ) ) ;

				fa = Dir->Alpha + Dir->SubAlpha ;
				if( fa < 0.0F ) fa = 0.0F ;
				a = (u8)( fa * 255 ) ;
				b = (u8)( GetCursorBrinkState3( Pnc->Cursor ) * Dir->Bright * 255 ) ;

				if( Dir->BrinkFlag == TRUE )
				{
					if( Dir->BrinkCon1 >= VParam[ED_PNCURSOR2][14] / 2 )
					{
						b = 50 ;
					}
					else
					{
						b = 255 ;
					}
				}
				else
				{
					b /= 2 ;
				}

				DrawTex3NB( x - w, y - h, x + w, y - h, CMK2( b, a ) ) ;
/*
				GP2( x - w, y - h ) ;	GC1( b, a ) ;	GT( 0.0F, 0.0F ) ;
				GP2( x + w, y - h ) ;	GC1( b, a ) ;	GT( 1.0F, 0.0F ) ;
				GP2( x + w, y + h ) ;	GC1( b, a ) ;	GT( 1.0F, 1.0F ) ;
				GP2( x - w, y + h ) ;	GC1( b, a ) ;	GT( 0.0F, 1.0F ) ;
*/
			}
			GXEnd() ;
		}
	}
#endif

	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV ) ;
	
	// OK,CANCEL ̕`
	{
		s32 p, maxw ;
	
		// ʒuԍ擾
		p = GetPncSelPos( Pnc ) ;
	
		if( Pnc->PackID != -1 && Pnc->MessageID != -1 )
		{
			MESSAGELINE *Line ;
			s32 j, k ;
			u8 r2, g2, b2 ;
			f32 xx, ww, hh, TexW, TexH ;
			stFontParam **Font ;
			GhmGcTexHeader *TexHead ;
		
			// eNX`̃[h
			GTLOAD( GetMessageTexObj( Pnc->PackID ) ) ;
			
			// eNX`̕ƍ𓾂
			TexHead = GetMessageTexHeader( Pnc->PackID ) ;
			TexW = TexHead->mWidth ;
			TexH = TexHead->mHeight ;
			
			// ԕ̂eLXg
			maxw = 0 ;
			for( i = 0 ; i < CUR_NUM ; i ++ )
				if( Pnc->SelMes[i].Width > maxw ) maxw = Pnc->SelMes[i].Width ;

			Sel = Pnc->Select ;
			Line = Pnc->SelMes ;
			for( i = 0 ; i < CUR_NUM ; i ++, Sel ++, Line ++ )
			{
				if( i == CUR_DECIP ) continue ;
				
				// `Jn
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Line->DrawStrLen * ( 8 * 9 ) ) ) ;
				{
					// Ŝ̕ƍ𓾂
					w = Line->Width ;
					h = Line->Height / 2 ;

					x = Pnc->x + SelPos[p][i][0] * Pnc->Width ;
					y = Pnc->y ;
//					y = Pnc->y + SelPos[p][i][1] * ( Pnc->Height * ( (f32)VParam[ED_PNCURSOR][22] / ( (f32)VParam[ED_PNCURSOR][4] / 2.0F ) ) ) ;
					if( SelPos[p][i][0] < 0 ) x -= maxw ;

					if( Sel->BrinkFlag == FALSE || Sel->DrawFlag == FALSE || Pnc->DrawFlag == FALSE )
					{
						a = (u8)( Sel->Alpha * 255 ) ;
						b = (u8)( Sel->Bright * 255 ) ;
					}
					else
					{
						a = 255 ;
						b = (u8)( Sel->BrinkState == TRUE ? 255 : VParam[ED_PNCURSOR][16] ) ;
					}

					r2 = (u8)( b * Sel->r ) ;
					g2 = (u8)( b * Sel->g ) ;
					b2 = (u8)( b * Sel->b ) ;

					x += VParam[ED_MES_V2][17] ;
					y += VParam[ED_MES_V2][17] ;
					r = g = bl = 0 ;
					for( j = 0 ; j < 2 ; j ++ )
					{
						xx = x /*+ (f32)maxw / 2.0F - ( (f32)w * ( 1.0F - (f32)VParam[ED_PNCURSOR2][4] * 0.01F * ( 1.0F - Sel->ExtRate ) ) ) / 2.0F */ ;
						Font = Line->TexPos ;
						for( k = 0 ; k < Line->StrLen ; k ++ )
						{
							if( Font[k] == FONT_NULLPOINT )
							{
								xx += (f32)VParam[ED_MES_V2_2][2] ;
							}
							else
							{
								ww = Font[k]->w /** ( 1.0F - (f32)VParam[ED_PNCURSOR2][4] * 0.01F * Sel->ExtRate )*/ ;
								hh = Font[k]->h ;
							
								{
									f32 x1, y1, x2, y2, u1, v1, u2, v2 ;
									u32 cr1, cr2 ;
									
									x1 = xx ;		y1 = y - hh / 2 ;
									x2 = xx + ww ;	y2 = y + hh / 2 ;
									u1 = (f32)Font[k]->u / TexW ;
									v1 = (f32)Font[k]->v / TexH ;
									u2 = (f32)( Font[k]->u + Font[k]->w ) / TexW ;
									v2 = (f32)( Font[k]->v + Font[k]->h ) / TexH ;
									cr1 = CMK( r, g, bl, a * Pnc->MesDrawAlpha ) ;
									cr2 = CMK( r * ALPHA, g * ALPHA, bl * ALPHA, a * Pnc->MesDrawAlpha ) ;

									DrawTex4NB( x1-ZURE, y1-ZURE, x2-ZURE, y2-ZURE, u1, v1, u2, v2, cr2 ) ;
									DrawTex4NB( x1+ZURE, y1-ZURE, x2+ZURE, y2-ZURE, u1, v1, u2, v2, cr2 ) ;
									DrawTex4NB( x1-ZURE, y1+ZURE, x2-ZURE, y2+ZURE, u1, v1, u2, v2, cr2 ) ;
									DrawTex4NB( x1+ZURE, y1+ZURE, x2+ZURE, y2+ZURE, u1, v1, u2, v2, cr2 ) ;
									DrawTex4NB( x1-ZURE2, y1-ZURE2, x2-ZURE2, y2-ZURE2, u1, v1, u2, v2, cr1 ) ;
									DrawTex4NB( x1+ZURE2, y1-ZURE2, x2+ZURE2, y2-ZURE2, u1, v1, u2, v2, cr1 ) ;
									DrawTex4NB( x1-ZURE2, y1+ZURE2, x2-ZURE2, y2+ZURE2, u1, v1, u2, v2, cr1 ) ;
									DrawTex4NB( x1+ZURE2, y1+ZURE2, x2+ZURE2, y2+ZURE2, u1, v1, u2, v2, cr1 ) ;
									DrawTex4NB( x1, y1, x2, y2, u1, v1, u2, v2, cr1 ) ;
								}

/*
								GP2( xx, 		y - hh / 2 ) ;	GC4( r, g, bl, a ) ;	GT( (f32)Font[k]->u / TexW					, (f32)Font[k]->v / TexH ) ;
								GP2( xx + ww, 	y - hh / 2 ) ;	GC4( r, g, bl, a ) ;	GT( (f32)( Font[k]->u + Font[k]->w ) / TexW	, (f32)Font[k]->v / TexH ) ;
								GP2( xx + ww, 	y + hh / 2 ) ;	GC4( r, g, bl, a ) ;	GT( (f32)( Font[k]->u + Font[k]->w ) / TexW	, (f32)( Font[k]->v + Font[k]->h ) / TexH ) ;
								GP2( xx, 		y + hh / 2 ) ;	GC4( r, g, bl, a ) ;	GT( (f32)Font[k]->u / TexW					, (f32)( Font[k]->v + Font[k]->h ) / TexH ) ;
*/
//								xx += Line->TexPos[k]->w * ( 1.0F - (f32)VParam[ED_PNCURSOR2][4] * 0.01F * ( 1.0F - Sel->ExtRate ) ) ;
								xx += Line->TexPos[k]->w * ( (f32)VParam[ED_PNCURSOR2][8] * 0.1F - (f32)VParam[ED_PNCURSOR2][4] * 0.01F * ( (f32)VParam[ED_PNCURSOR2][8] * 0.1F - Sel->ExtRate ) ) ;
							}
						}

						x -= VParam[ED_MES_V2][17] ;
						y -= VParam[ED_MES_V2][17] ;
						r = r2 ;
						g = g2 ;
						bl = b2 ;
					}
				}
				GXEnd() ;
			}
		}
		else
		{
#ifndef __NONTEX
			// ԕ̂OtBbN
			maxw = 0 ;
			for( i = 0 ; i < 2 ; i ++ )
				if( PncUnion.OkCancelTex[i].Data.Header->mWidth > maxw ) maxw = PncUnion.OkCancelTex[i].Data.Header->mWidth ;

			Sel = Pnc->Select ;
			for( i = 0 ; i < 2 ; i ++, Sel ++ )
			{
				// eNX`̃[h
				GTLOAD2( PncUnion.OkCancelTex[i] ) ;
				
				// `Jn
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( 8 ) ) ;
				{
					w = PncUnion.OkCancelTex[i].Data.Header->mWidth ;
					h = PncUnion.OkCancelTex[i].Data.Header->mHeight / 2 ;

					x = Pnc->x + SelPos[p][i][0] * Pnc->Width ;
					y = Pnc->y + SelPos[p][i][1] * ( Pnc->Height * ( (f32)VParam[ED_PNCURSOR][22] / ( (f32)VParam[ED_PNCURSOR][4] / 2.0F ) ) ) ;
					if( SelPos[p][i][0] < 0 ) x -= maxw ;

					if( Sel->BrinkFlag == FALSE || Sel->DrawFlag == FALSE || Pnc->DrawFlag == FALSE )
					{
						a = (u8)( Sel->Alpha * 255 ) ;
						b = (u8)( Sel->Bright * 255 ) ;
					}
					else
					{
						a = 255 ;
						b = (u8)( Sel->BrinkState == TRUE ? 255 : VParam[ED_PNCURSOR][16] ) ;
					}

					r = (u8)( b * Sel->r ) ;
					g = (u8)( b * Sel->g ) ;
					bl = (u8)( b * Sel->b ) ;

					x += VParam[ED_MES_V2][17] ;
					y += VParam[ED_MES_V2][17] ;
					DrawTex3NB( x, y - h, x + w, y + h, (s8)( a * Pnc->MesDrawAlpha ) ) ;
/*
					GP2( x, 	y - h ) ;	GC1( 0, a ) ;	GT( 0.0F, 0.0F ) ;
					GP2( x + w, y - h ) ;	GC1( 0, a ) ;	GT( 1.0F, 0.0F ) ;
					GP2( x + w, y + h ) ;	GC1( 0, a ) ;	GT( 1.0F, 1.0F ) ;
					GP2( x, 	y + h ) ;	GC1( 0, a ) ;	GT( 0.0F, 1.0F ) ;
*/

					x -= VParam[ED_MES_V2][17] ;
					y -= VParam[ED_MES_V2][17] ;
					DrawTex3NB( x, y - h, x + w, y + h, CMK( r, g, bl, a * Pnc->MesDrawAlpha ) ) ;
/*
					GP2( x, 	y - h ) ;	GC4( r, g, bl, a ) ;	GT( 0.0F, 0.0F ) ;
					GP2( x + w, y - h ) ;	GC4( r, g, bl, a ) ;	GT( 1.0F, 0.0F ) ;
					GP2( x + w, y + h ) ;	GC4( r, g, bl, a ) ;	GT( 1.0F, 1.0F ) ;
					GP2( x, 	y + h ) ;	GC4( r, g, bl, a ) ;	GT( 0.0F, 1.0F ) ;
*/
				}
//				GXEnd() ;
			}
#endif
		}
	}

	// I
	return 0 ;
}

// 폜NGXgs
extern s8 DelReqPanelCursorEffect( EFFECT *Effect )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	
	SetCursorDrawFlag( FALSE, Pnc->Cursor ) ;

	// I
	return 0 ;
}

// plJ[\̍WZbg
extern s8 SetPanelCursorPosition( EFFECT *Effect, s16 x, s16 y )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	
	Pnc->BackX = Pnc->x ;
	Pnc->BackY = Pnc->y ;
	Pnc->x = x ;
	Pnc->y = y ;
	
	// J[\̍WύX
	SetCursorPos( (u16)Pnc->x, (u16)Pnc->y, (s16)( Pnc->Width ), (s16)( Pnc->Height ), Pnc->Cursor, FALSE ) ;

	// IuWFNgɎcZbg
	{
		s32 i ;
		PANELCURSORDIR *Dir ;
	
		Dir = Pnc->Dir ;
		for( i = 0 ; i < 4 ; i ++, Dir ++ )
		{
			Dir->BackFlag = TRUE ;
			Dir->BackAlpha = Dir->Alpha ;
			Dir->BackBright = Dir->Bright ;
			
//			Dir->Alpha = 0.0F ;
//			Dir->Bright = 0.0F ;
		}
	}

	// I
	return 0;
}

// J[\̐FύX
extern s8 SetPanelCursorColor( EFFECT *Effect, u32 color )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	
	// J[\̐FύX
	SetCursorColor( Pnc->Cursor, *((GXColor*)&color) ) ;

	// I
	return 0 ;
}


// plJ[\`悷邩ǂ̃tOZbg
extern s8 SetPanelCursorDrawFlag( EFFECT *Effect, s8 Flag )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	
	Pnc->DrawFlag = (u8)Flag ;

	// J[\̕\A\Zbg
	SetCursorDrawFlag( (u8)Flag, Pnc->Cursor ) ;

	// I
	return 0 ;
}

// plJ[\`悷鎞̃At@l擾
extern s8 GetPanelCursorDrawAlpha( EFFECT *Effect )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	
	return GetCursorDrawAlpha( Pnc->Cursor ) ;
}


// plJ[\̕ƍZbg
extern s8 SetPanelCursorSize( EFFECT *Effect, u16 Width, u16 Height )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	
	// ƍXV
	Pnc->Width = Width ;
	Pnc->Height = Height ;

	// J[\̈ʒuύX
	SetCursorPos( (u16)Pnc->x, (u16)Pnc->y, (s16)( Pnc->Width ), (s16)( Pnc->Height ), Pnc->Cursor, FALSE ) ;

	// I
	return 0 ;
}


// plJ[\t̖̓\邩ۂύX
extern s8 SetPanelCursorDirDrawFlag( EFFECT *Effect, s32 Dir, s8 Flag )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	PANELCURSORDIR *D = &Pnc->Dir[Dir] ;

	// `悷邩ǂtOZbg
	D->DrawFlag = (u8)Flag ;
	
	// I
	return 0 ;
}

// plJ[\t̖̓ANeBuɂ邩ۂύX
extern s8 SetPanelCursorDirActiveFlag( EFFECT *Effect, s32 Dir, s8 Flag )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	PANELCURSORDIR *D = &Pnc->Dir[Dir] ;

	// ANeButOZbg
	D->ActiveFlag = (u8)Flag ;

	// I
	return 0 ;
}

// plJ[\t̖̓񖾖ł
extern s8 SetPanelCursorDirBlackBrink( EFFECT *Effect, s32 Dir )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	PANELCURSORDIR *D = &Pnc->Dir[Dir] ;

	// ŏ̏s
	D->SubFlag = TRUE ;
	D->SubDir = -1.0F ;
	D->SubAlpha = 0 ;
	D->SubCounter = (s8)VParam[ED_PNCURSOR2][13] ;

	// I
	return 0 ;
}

// plJ[\t̖̓񖾖ł
extern s8 SetPanelCursorDirWhiteBrink( EFFECT *Effect, s32 Dir )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	PANELCURSORDIR *D = &Pnc->Dir[Dir] ;

	// ŏ̏s
	D->BrinkFlag = TRUE ;
	D->BrinkCon1 = D->BrinkCon2 = 0 ;

	// I
	return 0 ;
}

// plJ[\t̖̓`悷邩ǂ̃tO擾
extern s8 GetPanelCursorDirDrawFlag( EFFECT *Effect, s32 Dir )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	PANELCURSORDIR *D = &Pnc->Dir[Dir] ;

	return (s8)D->DrawFlag ;
}


// njCb`mbdk`悷邩ǂZbg
extern s8 SetPanelCursorOkCancelSelectDrawFlag( EFFECT *Effect, bool drawflag )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	
	Pnc->MesDrawFlag = drawflag ;
	
	return 0 ;
}


// njCb`mbdk̓쓮
extern s8 RunPanelCursorOkCancelSelect( EFFECT *Effect, s8 PackID, s8 MessageID )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	PANELSELECT *Sel ;
	
	if( PackID == -1 && MessageID == -1 )
	{
		PackID = (s8)PncUnion.SelectJmbPackID ;
		MessageID = 0 ;
	}
	
	// ɔĂ牽Ȃ
	if( Pnc->OkCancelFlag == TRUE ) return 0 ;
	
	// tOZbg
	Pnc->OkCancelFlag = TRUE ;
	Pnc->SelEndFlag = FALSE ;
	Pnc->SelEndCounter = 0 ;
	
	// f[^
	Pnc->ActSelect = CUR_DECIP/*CUR_CANCEL*/ ;
	Pnc->PackID = PackID ;
	Pnc->MessageID = MessageID ;
	
	// bZ[W
	if( Pnc->PackID != -1 && Pnc->MessageID != -1 )
	{
		s32 i ;

		for( i = 0 ; i < 3 ; i ++ )
			GetMessageStringUvInfo( PackID, MessageID, (s8)i, NULL, NULL, &Pnc->SelMes[i] ) ; 
	}

	Sel = &Pnc->Select[CUR_DECIP] ;
	Sel->DrawFlag = TRUE ;
	Sel->Alpha = 0.0F ;
	Sel->ActiveFlag = FALSE ;
	Sel->Bright = 0.0F ;
	Sel->ExtRate = 0.0F ;
	Sel->BrightCounter = 0 ;
	Sel->BrinkFlag = FALSE ;
	Sel->BrinkCounter = 0 ;
	Sel->BrinkState = FALSE ;
	
	Sel = &Pnc->Select[CUR_COMP] ;
	Sel->DrawFlag = FALSE ;
	Sel->Alpha = 0.0F ;
	Sel->ActiveFlag = FALSE ;
	Sel->Bright = 0.0F ;
	Sel->ExtRate = 0.0F ;
	Sel->BrightCounter = 0 ;
	Sel->BrinkFlag = FALSE ;
	Sel->BrinkCounter = 0 ;
	Sel->BrinkState = FALSE ;

	Sel = &Pnc->Select[CUR_EXE] ;
	Sel->DrawFlag = FALSE ;
	Sel->Alpha = 0.0F ;
	Sel->ActiveFlag = FALSE ;
	Sel->Bright = 0.0F ;
	Sel->ExtRate = 0.0F ;
	Sel->BrightCounter = 0 ;
	Sel->BrinkFlag = FALSE ;
	Sel->BrinkCounter = 0 ;
	Sel->BrinkState = FALSE ;
	
	SetPanelCursorOkCancelSelectButton( Effect, CUR_DECIP ) ;
	
	// I
	return 0 ;
}
	
// njCb`mbdk̓Xgbv
extern s8 StopPanelCursorOkCancelSelect( EFFECT *Effect )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	PANELSELECT *Sel ;
	
	// ɃXgbvĂ牽Ȃ
	if( Pnc->OkCancelFlag == FALSE || Pnc->SelEndFlag == TRUE ) return 0 ;

	// tO|
	Pnc->SelEndFlag = TRUE ;

	// f[^̃Zbg
	Pnc->SelEndCounter = 0;

	Sel = &Pnc->Select[Pnc->ActSelect] ;
	Sel->BrinkFlag = TRUE ;
	Sel->BrinkCounter = 0 ;
	Sel->BrinkState = TRUE ;
	
	// I
	return 0 ;
}

// njCb`mbdk̓I
extern s8 EndPanelCursorOkCancelSelect( EFFECT *Effect )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	PANELSELECT *Sel ;
	s32 i ;
	
	// ɃXgbvĂ牽Ȃ
	if( Pnc->OkCancelFlag == FALSE ) return 0 ;

	// tO|
	Pnc->SelEndFlag = FALSE ;
	Pnc->OkCancelFlag = FALSE ;
	
	// f[^̃Zbg
	Pnc->SelEndCounter = 0;
	
	Sel = Pnc->Select ;
	for( i = 0 ; i < CUR_NUM ; i ++, Sel ++ )
		Sel->DrawFlag = FALSE ;

	gpSound->mStopSE( SFX_SYS_PNL_CHOOSE_OK_LOOP ) ;
	gpSound->mStopSE( SFX_SYS_PNL_CHOOSE_CANCEL_LOOP ) ;

	// I
	return 0 ;
}

	
// njCb`mbdǩʂ擾( 0:OK  1:CANCEL  2:܂ )
extern s8 GetPanelCursorOkCancelResult( EFFECT *Effect )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	
	if( Pnc->OkCancelFlag == TRUE ) return 2 ;
	
	return (s8)Pnc->ActSelect ;
}

// njCb`mbdk̃ANeBuȃ{^ύX
extern s8 SetPanelCursorOkCancelSelectButton( EFFECT *Effect, s32 But )
{
	PANELCURSOREFFECT *Pnc = ( PANELCURSOREFFECT * )Effect->Data ;
	s32 i ;
	
//	Pnc->Select[But].ActiveFlag = TRUE ;
	Pnc->Select[But].BrightCounter = 0 ;

	for( i = 0 ; i < CUR_NUM ; i ++ )
	{
		Pnc->Select[i].DrawFlag = Pnc->Select[i].ActiveFlag = i == But ;
	}
	
	// 艹炷
	if( GetEffectSoundOffFlag() == FALSE )
	{
		gpSound->mStopSE( SFX_SYS_PNL_CHOOSE_OK_LOOP ) ;
		gpSound->mStopSE( SFX_SYS_PNL_CHOOSE_CANCEL_LOOP ) ;

		PlayEffectSE( Pnc->ActSelect == CUR_CANCEL ? SFX_SYS_PNL_CHOOSE_CANCEL_LOOP : SFX_SYS_PNL_CHOOSE_OK_LOOP,
		 SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackSystemOverlap, eSEGroupSystem00 ) ;
	}
	
	// I
	return 0 ;
}	



