///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectPanelCursor
//
// YK7EffectPanelCursor.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/19/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTPANELCURSOR_H
#define __YK7EFFECTPANELCURSOR_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7EffectMessage.h"

// define ---------------------------------------

#define PNC_SELSTR_MAXLEN		64		// plJ[\̍ő僁bZ[W

// 
enum
{
	CUR_LEFT = 0,
	CUR_RIGHT = 1,
	CUR_UP = 2,
	CUR_DOWN = 3
} ;

// I
enum
{
	CUR_OK = 0,
	CUR_CANCEL = 1,
	
	CUR_DECIP = 0,
	CUR_COMP = 1,
	CUR_EXE = 2,
	CUR_NUM = 3,
} ;

// datatype -------------------------------------

// plJ[\GtFNgʃf[^
typedef struct tagPANELCURSORUNION
{
	TEXDATA DirTex[4] ;			// eNX`( 0: 1: 2: 3: )
	TEXDATA OkCancelTex[2] ;	// njeNX`ƃLZeNX`
	TEXDATA DemoTex[30] ;		// feNX`
	s32 SelectJmbPackID ;
} PANELCURSORUNION ;

// J[\f[^
typedef struct tagPANELCURSORDIR
{
	u8 BackFlag ;				// c̗L
//	s16 BackX, BackY ;			// c̍W(SW)
	f32 BackAlpha ;				// c̃At@l
	f32 BackBright ;			// Px( 1.0F:100% )

	f32 SubAlpha ;				// At@l
	f32 SubDir ;				// 
	s8 SubCounter ;				// Ă̑҂
	s8 SubFlag ;				// At@Ă邩tO

	u8 BrinkFlag ;				// _ŃtO
	u8 BrinkCon1, BrinkCon2 ;	// _ŃJE^

	u8 DrawFlag ;				// `tO
	f32 Alpha ;					// At@( 1.0F:s@0.0F:S )
	u8 ActiveFlag ;				// ANeButO
	f32 Bright ;				// Px( 1.0F:100% )
} PANELCURSORDIR ;

// OK, CANCEL \f[^
typedef struct tagPANELSELECT
{
	u8 DrawFlag ;				// `tO
	f32 Alpha ;					// At@
	u8 ActiveFlag ;				// ANeButO
	f32 Bright ;				// Px
	f32 BrightCounter ;			// PxJE^[
	f32 ExtRate ;				// g嗦
	
	u8 BrinkFlag ;				// _ŏtO
	u8 BrinkCounter ;			// _ŃJE^[
	u8 BrinkState ;				// _ŏ
	f32 r, g, b ;
} PANELSELECT ;

// plJ[\GtFNgf[^
typedef struct tagPANELCURSOREFFECT
{
	EFFECT *Cursor ;			// ACRꍇ̃ACRp̃ObhGtFNg

	s16 x, y ;					// W
	s16 BackX, BackY ;			// ړO̍W
	f32 Ax, Ay ;				// ̍W
	u8 DrawFlag ;				// `tO

	PANELCURSORDIR Dir[4] ;		// IuWFNg

	u8 OkCancelFlag ;			// OK, CANCEL Ă邩tO
	u8 SelEndFlag ;				// IItO
	u8 SelEndCounter ;			// IIJE^[
	s32 ActSelect ;					// IĂ{^
	PANELSELECT Select[CUR_NUM] ;	// ZNgIuWFNg( 0:OK  1:CANCEL )
	
	bool MesDrawFlag ;
	f32 MesDrawAlpha ;

	u16 Width, Height ;			// Obh̕ƍ
	
	s8 PackID, MessageID ;			// njCb`mbdkɎgp郁bZ[WpbNhcƃbZ[Whc
	MESSAGELINE SelMes[CUR_NUM] ;	// I𕶎̏
} PANELCURSOREFFECT ;


// plJ[\GtFNgf[^p\
typedef struct tagPANELCURSOREFFECTTASKPARAM
{
	f32 x, y ;				// J[\̍W
} PANELCURSOREFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitPanelCursorData( void ) ;				// plJ[\GtFNg̋ʃf[^
extern s8 CheckPanelCursorData( void ) ;			// plJ[\GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndPanelCursorData( void ) ;				// plJ[\GtFNg̋ʃf[^n

extern EFFECT *CreatePanelCursorEffect( s16 x, s16 y, u32 color = CMK( 255,0,0,255 ), s32 Priority = 6000 ) ;		// plJ[\GtFNg쐬
extern s8 ReleasePanelCursorEffect( EFFECT *Effect ) ;						// plJ[\GtFNǧns
extern s8 MovePanelCursorEffect( EFFECT *Effect ) ;							// plJ[\GtFNgPt[
extern s8 DrawPanelCursorEffect( EFFECT *Effect ) ;							// plJ[\GtFNg`悷

extern s8 DelReqPanelCursorEffect( EFFECT *Effect ) ;						// 폜NGXgs
extern s8 SetPanelCursorPosition( EFFECT *Effect, s16 x, s16 y ) ;			// plJ[\̍WZbg

extern s8 SetPanelCursorColor( EFFECT *Effect, u32 color ) ;				// J[\̐FύX

extern s8 SetPanelCursorDrawFlag( EFFECT *Effect, s8 Flag ) ;				// plJ[\`悷邩ǂ̃tOZbg
extern s8 GetPanelCursorDrawAlpha( EFFECT *Effect ) ;						// plJ[\`悷鎞̃At@l擾
extern s8 SetPanelCursorSize( EFFECT *Effect, u16 Width, u16 Height ) ;		// plJ[\̕ƍZbg

extern s8 SetPanelCursorDirDrawFlag( EFFECT *Effect, s32 Dir, s8 Flag ) ;	// plJ[\t̖̓\邩ۂύX
extern s8 SetPanelCursorDirActiveFlag( EFFECT *Effect, s32 Dir, s8 Flag ) ;	// plJ[\t̖̓ANeBuɂ邩ۂύX
extern s8 SetPanelCursorDirBlackBrink( EFFECT *Effect, s32 Dir ) ;			// plJ[\t̖̓񖾖ł
extern s8 SetPanelCursorDirWhiteBrink( EFFECT *Effect, s32 Dir ) ;			// plJ[\t̖̓񖾖ł
extern s8 GetPanelCursorDirDrawFlag( EFFECT *Effect, s32 Dir ) ;			// plJ[\t̖̓`悷邩ǂ̃tO擾

extern s8 SetPanelCursorOkCancelSelectDrawFlag( EFFECT *Effect, bool drawflag ) ;			// njCb`mbdk`悷邩ǂZbg
extern s8 RunPanelCursorOkCancelSelect( EFFECT *Effect, s8 PackID = -1, s8 MessageID = -1 ) ;	// njCb`mbdk̓쓮
extern s8 StopPanelCursorOkCancelSelect( EFFECT *Effect ) ;									// njCb`mbdk̓Xgbv
extern s8 EndPanelCursorOkCancelSelect( EFFECT *Effect ) ;									// njCb`mbdk̓I
extern s8 GetPanelCursorOkCancelResult( EFFECT *Effect ) ;									// njCb`mbdǩʂ擾
extern s8 SetPanelCursorOkCancelSelectButton( EFFECT *Effect, s32 But ) ;					// njCb`mbdk̃ANeBuȃ{^ύX


#endif
