///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectPool
//
// YK7EffectPool.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectPool.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define TEX_PATH			"/Yam/Effect/Pool/y_pool01.BIN"

// data -----------------------------------------

POOLUNION polu ;
extern LINEUNION LUnion ;

// datatype -------------------------------------

// function proto type --------------------------

void __DrawPoolEffect( EFFECT *Effect, u8 dir, f32 a ) ;

// function code --------------------------------

void __DrawPoolEffect( EFFECT *Effect, u8 dir, f32 a )
{
	POOLEFFECT *pl = ( POOLEFFECT * )Effect->Data ;
	f32 x, y, z, len, addst, v ;
	s32 rx, rz, raddx, raddz ;
	u32 xdiv, zdiv, cr ;
	s32 i, j ;
	Vec *tv = (Vec *)WorkBuffer, *vp ;
	f32 (*tuv)[2] ;
	f32 (*uvp)[2] ;
	f32 addu, addv, h, hrate, width, height ;

	tuv = (f32 (*)[2])( (u8 *)WorkBuffer + pl->xdiv * pl->zdiv * sizeof( Vec ) ) ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, VParam[ED_POOL][4] == 1 ? EF_BLEND_ADD : EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	// eNX`[h
	GTLOAD2( polu.pooltex ) ;

	// _̏
	addu = -pl->count * VParam[ED_POOL][9] * 0.001F * ( dir == 0 ? 1 : 0.7F ) ;
	addv = -pl->count * ( VParam[ED_POOL][9] ) * 0.001F * ( dir == 0 ? 1 : 0.7F ) ;
	cr = CMK(	( pl->color >> 24 ) & 0xff,
				( pl->color >> 16 ) & 0xff,
				( pl->color >> 8 ) & 0xff,
				( ( pl->color & 0xff ) * (s32)( VParam[ED_POOL][8] * a ) ) >> 8 ) ;
	addst = VParam[ED_POOL][3] * 0.01F ;
	xdiv = pl->xdiv ;
	zdiv = pl->zdiv ;
	x = pl->Pos.x - pl->xsize / 2.0F ;
	z = pl->Pos.z - pl->zsize / 2.0F ;
	y = pl->Pos.y ;
	raddx = VParam[ED_POOL][2] * 10 * ( dir == 0 ? 1 : -1 ) ;
	raddz = VParam[ED_POOL][2] ;
	len = pl->length ;
	rz = RCINT( pl->count * ( dir == 0 ? 1 : -1 ) ) ;
	vp = tv ;
	uvp = tuv ;
	hrate = VParam[ED_POOL][10] * 0.0001F ;
	width = ( xdiv - 1 ) * len ;
	height = ( zdiv - 1 ) * len ;
	for( i = 0 ; i < zdiv ; i ++, rz += raddz )
	{
		rx = rz ;
		v = i * addst ;
		for( j = 0 ; j < xdiv ; j ++, vp ++, uvp ++, rx += raddx )
		{
			if( dir == 0 )
			{
				vp->x = x + j * len ;
				vp->z = z + i * len ;
			}
			else
			{
				vp->x = x + ( width - j * len ) ;
				vp->z = z + ( height - i * len ) ;
			}
			vp->y = y + ( h = ( SIN( rx ) + SIN( rz ) ) /*(f32)pl->ZValue[0][ ( ( i + 1 ) * 3 ) * POOL_SIZE + ( ( j + 1 ) * 3 ) ] / 10.0F*/ * pl->height ) ;

			uvp[0][0] = j * addst + addu + h * hrate ;
			uvp[0][1] = v + addv + h * hrate ;
		}
	}

	// _O
	GBGN( GX_TRIANGLESTRIP, ( xdiv * ( zdiv - 1 ) * 2 ) + ( zdiv - 1 ) * 2 ) ;

	vp = tv ;
	uvp = tuv ;
	for( i = 0 ; i < zdiv - 1 ; i ++ )
	{
		if( i != 0 )
		{
			GPV( vp[xdiv] ) ; GCX( cr ) ; GT( uvp[xdiv][0], uvp[xdiv][1] ) ;
		}

		for( j = 0 ; j < xdiv ; j ++, vp ++, uvp ++ )
		{
			GPV( vp[xdiv] ) ; 	GCX( cr ) ; GT( uvp[xdiv][0], 	uvp[xdiv][1] ) ;
			GPV( vp[0] ) ; 		GCX( cr ) ; GT( uvp[0][0], 		uvp[0][1] ) ;
		}

		if( i < zdiv - 1 )
		{
			GPV( vp[-1] ) ; GCX( cr ) ; GT( uvp[-1][0], uvp[-1][1] ) ;
		}
	}

	GEND() ;
	
	GTLOAD2( LUnion.TestTex ) ;
}


// v[GtFNg̋ʃf[^
extern s8 InitPoolData( void )
{
	MEMINIT( polu ) ;
	
//	TexLoadSet( TEX_PATH, &polu.pooltex, TEX_TYPE_REPEAT ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_y_pool01 ), &polu.pooltex, TEX_TYPE_REPEAT ) ;

	return 0 ;
}

// v[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckPoolData( void )
{
//	if( TexLoadChk( &polu.pooltex ) == FALSE ) return FALSE ;

	return TRUE ;
}

// v[GtFNg̋ʃf[^n
extern s8 EndPoolData( void )
{
	TexRelease( &polu.pooltex ) ;

	MEMINIT( polu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}
/*

// g֐
void MakeWave( EFFECT *Effect, int x , int y , int Size ) ;
void MakeWave( EFFECT *Effect, int x , int y , int Size )
{
	POOLEFFECT *pl = ( POOLEFFECT * )Effect->Data ;
	int j , i ;
	int r ;

	for( j = -POOL_WSY ; j < POOL_WSY ; j ++ )
	{
		for( i = -POOL_WSX ; i < POOL_WSX ; i ++ )
		{
			if( ( x + i > 0 ) && ( x + i < POOL_SIZE - 1 ) &&
				( y + j > 0 ) && ( y + j < POOL_SIZE - 1 ) )
			{
				r = pl->Pow[ j + POOL_WSY ][ i + POOL_WSX ] ;
				pl->ZValue[1][ ( y + j ) * POOL_SIZE + x + i ] += Size >> r ;
			}
		}
	}
}*/



// v[GtFNg쐬
extern EFFECT *CreatePoolEffect(
									f32 xsize, f32 zsize,		// 傫
									f32 height,					// 
									Vec Pos,					// W
									s32 Priority )				// v[GtFNg쐬
{
	EFFECT *Effect ;
	POOLEFFECT *pl ;
	
	// Vv[f[^쐬
	Effect = AddEffectData( EFF_POOL, (void**)&pl, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ̏
	if( VParam[ED_POOL][0] == 0 ) VParam[ED_POOL][0] = 1 ;
	pl->length = (f32)VParam[ED_POOL][0] * 0.1F ;
	pl->Pos = Pos ;
	pl->color = CMK( 255,255,255,255 ) ;
	
R1 :
	pl->xdiv = (u32)( xsize / pl->length + 1 ) ;
	pl->zdiv = (u32)( zsize / pl->length + 1 ) ;
	pl->xsize = pl->xdiv * pl->length ;
	pl->zsize = pl->zdiv * pl->length ;

	if( pl->xdiv * pl->zdiv * ( sizeof( Vec ) + sizeof( f32 ) * 2 ) >= WORKBUFFERSIZE )
	{
		pl->length += 1.0F ;
		goto R1 ;
	}

	pl->count = 0.0F ;
	pl->height = height ;
	
/*	
	// 
	{
		s32 j, i ;
		
		memset( pl->ZValue, 0, sizeof( pl->ZValue ) ) ;

		// SW̋炩ߌvZ
		for( j = -POOL_WSY ; j < POOL_WSY ; j ++ )
		{
			for( i = -POOL_WSX ; i < POOL_WSX ; i ++ )
			{
				pl->Pow[ j + POOL_WSY ][ i + POOL_WSX ] = ( int )sqrt( j * j + i * i ) ;
			}
		}
		
		pl->count2 = 0 ;
	}
*/
	// I
	return Effect ;
}

// v[GtFNǧns
extern s8 ReleasePoolEffect( EFFECT *Effect )
{
	POOLEFFECT *pl = ( POOLEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// v[GtFNgPt[
extern s8 MovePoolEffect( EFFECT *Effect )
{
	POOLEFFECT *pl = ( POOLEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// 
	pl->count += PI_2 / 360.0F * VParam[ED_POOL][1] * 0.1F ;
	
/*	// g䏈
	{
		s32 i, j, p, k ;
		s32 f, dx, dy ;
	
		// g
		if( pl->count2 == 0 )
		{
			MakeWave( Effect, GetRandINum( POOL_SIZE - 1 ), GetRandINum( POOL_SIZE - 1 ), ( GetRandINum( 600 ) - 300 ) * POOL_ZM ) ;
			pl->count2 = (u8)VParam[ED_POOL][11] ;
		}
		else
		{
			pl->count2 -- ;
		}
			
		// `d
		for( j = 1 ; j < POOL_SIZE - 1 ; j ++ )
		{
			k = j * POOL_SIZE + 1 ;
			for( i = 1 ; i < POOL_SIZE - 1 ; i ++, k ++ )
			{
				p = j * POOL_SIZE + i ;

				// `d
				f = pl->ZValue[3][ p ] + (
						pl->ZValue[1][ p ] * POOL_WEIGHTO +
						pl->ZValue[2][ p - 1 ] +
						pl->ZValue[1][ p + 1 ] + 
						pl->ZValue[1][ p + POOL_SIZE ] +
						pl->ZValue[2][ p - POOL_SIZE ] 
						 )	/ POOL_WEIGHT ;
				f -= f / 16 ;

				pl->ZValue[3][ p ] = f - ( pl->ZValue[2][ p ] = pl->ZValue[1][ p ] ) ;
				pl->ZValue[1][ p ] = f ;


				// sɒlɂĕ`悷sNZύX
				dx = ( pl->ZValue[1][ p + 1 ] - pl->ZValue[1][ p ] ) / POOL_ZM ;
				dy = ( pl->ZValue[1][ p + POOL_SIZE ] - pl->ZValue[1][ p ] ) / POOL_ZM ;

				if( dx > 10 )
					dx = 10 ;
				else if( dx < -10 )
						dx = -10 ;

				if( dy > 10 )
					dy = 10 ;
				else if( dy < -10 )
						dy = -10 ;

				p += dy * POOL_SIZE + dx ;

				pl->ZValue[0][k] = dx ;
			}
		}
	}
*/
	// I
	return 0 ;
}

// v[GtFNg`悷
extern s8 DrawPoolEffect( EFFECT *Effect )
{
	__DrawPoolEffect( Effect, 0, 1.0F ) ;
	__DrawPoolEffect( Effect, 1, 0.5F ) ;

	// I
	return 0 ;
}

// v[̈ʒuύX
extern s8 ChangePoolPos( EFFECT *Effect, Vec Pos )
{
	POOLEFFECT *pl = ( POOLEFFECT * )Effect->Data ;
	
	pl->Pos = Pos ;
	
	return 0 ;
}

// v[̒_J[ύX
extern s8 ChangePoolColor( EFFECT *Effect, u32 color )
{
	POOLEFFECT *pl = ( POOLEFFECT * )Effect->Data ;
	
	pl->color = color ;
	
	return 0 ;
}



