///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectPopCorn
//
// YK7EffectPopCorn.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/28/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectPopCorn.h"
#include "./YK7EffectBillboard.h"

// define ---------------------------------------

#define POPCORN_FILENAME			"/Yam/Effect/PopCorn/PopCorn_"

// datatype -------------------------------------

// data -----------------------------------------

POPCORNUNION PopUnion ;

// function proto type --------------------------

// `̈꒸_Ɗeւ̒𓾂
static s8 GetWK7JObjRect( WK7JObj **BoxJObj, Vec *p, Vec *d1, Vec *d2 ) ;

// IuWFNgړR[obN֐
static s8 PopCornObjMoveFunction( BILLBOARDEFFECTOBJECT *Obj, BILLBOARDEFFECT *Bl, void *Data ) ;

// ƃ|S̓蔻s( TRUE:Ă FALSE:ĂȂ )
s8 CheckLintToPollgonCollsion( Vec *PolyPos, Vec *P1, Vec *P2 ) ;

// function code --------------------------------

// ƃ|S̓蔻s( TRUE:Ă FALSE:ĂȂ )
s8 CheckLintToPollgonCollsion( Vec *PolyPos, Vec *P1, Vec *P2 )
{
	Vec v, norm, d1, d2, r0, q, p ;
	f32 t ;

	// xNg v 𓾂
	q = *P1 ;
	VECSubtract( P2, P1, &v ) ;
	
	// |S̈꒸_Ƒ̓񒸓_ɌxNg𓾂
	r0 = PolyPos[0] ;
	VECSubtract( &PolyPos[1], &PolyPos[0], &d1 ) ;
	VECSubtract( &PolyPos[2], &PolyPos[0], &d2 ) ;
	
	// |S̖@𓾂
	VECCrossProduct( &d1, &d2, &norm ) ;
	
	// |S݂镽ʂƂ̌_߂
	{
		Vec tempd ;
	
		// ړ_߂
		VECSubtract( &r0, &q, &tempd ) ;
		t = VECDotProduct( &norm, &tempd ) / VECDotProduct( &norm, &v ) ;
		
		//  t  0.0F 悸ĂȂ
		if( t == 0.0F ) return FALSE ;
		
		//  t  0.0F ` 1.0F ̒ɖ悸ĂȂ
		if( t < 0.0F || t > 1.0F ) return FALSE ;

		// t gĖʏ̓_擾
		VECScale( &v, &p, t ) ;
		VECAdd( &p, &q, &p ) ;
	}

	// |Sʂۂ 3 _Ƃ̊OςƂĂׂĕvĂ邩f
	{
		Vec v1, v2, v3, tempv ;
		f32 f1, f2, f3 ;
		
		// |SƓꕽʏ̓_ p |Sۂe_ւ̃xNgZo
		VECSubtract( &PolyPos[0], &p, &v1 ) ;
		VECSubtract( &PolyPos[1], &p, &v2 ) ;
		VECSubtract( &PolyPos[2], &p, &v3 ) ;
		
		// exNgƂ̊OςƂA|S̖@Ƃ̓ςƂ
		VECCrossProduct( &v1, &v2, &tempv ) ;
		f1 = VECDotProduct( &tempv, &norm ) ;
		VECCrossProduct( &v2, &v3, &tempv ) ;
		f2 = VECDotProduct( &tempv, &norm ) ;
		VECCrossProduct( &v3, &v1, &tempv ) ;
		f3 = VECDotProduct( &tempv, &norm ) ;
		
		// ׂĂ̕vĂꍇ͒_̓|Sʏɑ݂Ă邱ƂɂȂ
		if( !( ( f1 > 0.0F && f2 > 0.0F && f3 > 0.0F ) ||
			   ( f1 <= 0.0F && f2 <= 0.0F && f3 <= 0.0F ) ) ) return FALSE ;
	}
	
	// ܂ŗĂ瓖Ă邱Ƃ
	return TRUE ;
}

// IuWFNgړR[obN֐
static s8 PopCornObjMoveFunction( BILLBOARDEFFECTOBJECT *Obj, BILLBOARDEFFECT *, void *Data )
{
	POPCORNEFFECT *PC = ( POPCORNEFFECT * )Data ;
	Vec P1, P2 ;
	s32 i, j ;
	
	// ړO̍WƂĂ
	P1 = Obj->Point ;
	
	// ړAĈړ̍W
	P2.x = Obj->Point.x += Obj->Speed.x ;
	P2.y = Obj->Point.y += Obj->Speed.y ;
	P2.z = Obj->Point.z += Obj->Speed.z ;
	
	// |SƂ̓蔻s
	for( i = 0 ; i < 5 ; i ++ )
	{
		for( j = 0 ; j < 2 ; j ++ )
		{
			// Ă폜
			if( CheckLintToPollgonCollsion( PC->PopPoly[i][j], &P1, &P2 ) == TRUE )
			{
				return -1 ;
			}
		}
	}

	// I
	return 0 ;
}

// `̈꒸_Ɗeւ̒𓾂
static s8 GetWK7JObjRect( WK7JObj **BoxJObj, Vec *p, Vec *d1, Vec *d2 )
{
	Vec pos[4] ;
	s32 i ;
	HSD_JObj *JObj ;
	
	for( i = 0 ; i < 4 ; i ++ )
	{
		JObj = BoxJObj[i]->GetJObj() ;
		HSD_JObjSetupMatrix( JObj ) ;
		pos[i].x = JObj->mtx[0][3] ;
		pos[i].y = JObj->mtx[1][3] ;
		pos[i].z = JObj->mtx[2][3] ;
	}
	
	*p = pos[0] ;
	VECSubtract( &pos[1], &pos[0], d1 ) ;
	VECSubtract( &pos[3], &pos[0], d2 ) ;
	
	// I
	return 0 ;
}

// |bvR[GtFNg̋ʃf[^
extern s8 InitPopCornData( void )
{
	MEMINIT( PopUnion ) ;

	SetupBillboardEffectID( BILLEFF_POPCORN ) ;
	
	// I
	return 0 ;
}

// |bvR[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckPopCornData( void )
{
	if( CheckBillboardEffectIDState( BILLEFF_POPCORN ) == FALSE ) return FALSE ;

	return TRUE ;
}


// |bvR[GtFNg̋ʃf[^n
extern s8 EndPopCornData( void )
{
	MEMINIT( PopUnion ) ;
	
	ReleaseBillboardEffectID( BILLEFF_POPCORN ) ;

	// I
	return 0 ;
}


// |bvR[̃GtFNg쐬
extern EFFECT *CreatePopCornEffect( WK7JObj *JObj,				// |bvR[ђ˂钷̂̒_f[^pP[^ WK7JObj ւ̃|C^
									f32 Speed,		 			// ђ˂|bvR[̑x
									f32 YukaY,					// ̍
									s32 Priority )
{
	POPCORNEFFECT *PopCorn ;
	EFFECT *Effect, *Bill ;
	WK7JObj *BoxJObj[8] ;
	s32 i ;
	
	// |bvR[̃{bNXۂ WK7JObj ̃P[^o
	{
		char Str[8] ;

		for( i = 0 ; i < 8 ; i ++ )
		{
			sprintf( Str, "P%02d", i ) ;
			if( ( BoxJObj[i] = JObj->GetObj( Str ) ) == NULL ) return NULL ;
		}
	}

	// r{[hGtFNg쐬
	Bill = CreateBillboardEffect2( BILLEFF_POPCORN, (Vec){0.0F,0.0F,0.0F}, YukaY,
									(u32)( VParam[ED_POPCORN][6] * 10 ), NULL, Priority - 1 ) ;
	if( Bill == NULL ) return NULL ;

	// r{[hGtFNg̃ZbgAbv
	SetBillboardCreateFlag( Bill, FALSE ) ;
	SetBillboardSpeedRate( Bill, Speed ) ;

	// V|bvR[f[^쐬
	Effect = AddEffectData( EFF_POPCORN, (void**)&PopCorn, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( Bill ) ;
		return NULL ;
	}
	
	// f[^̏
	PopCorn->BillEffID = GetEffectID( Bill ) ;
	PopCorn->BillEff = Bill ;
	for( i = 0 ; i < 8 ; i ++ ) PopCorn->PopBox[i] = BoxJObj[i] ;
	PopCorn->CreateCounter = 0.0F ;
	PopCorn->Speed = Speed ;
	
	// R[obN֐̓o^
	SetBillboardEffectMoveCallBackFunction( Bill, PopCornObjMoveFunction, PopCorn ) ;
	
	// |S_̃Zbg
	{
		Vec P[8] ;
		HSD_JObj *JObj ;
		
		for( i = 0 ; i < 8 ; i ++ )
		{
			JObj = PopCorn->PopBox[i]->GetJObj() ;
			HSD_JObjSetupMatrix( JObj ) ;
			P[i].x = JObj->mtx[0][3] ;
			P[i].y = JObj->mtx[1][3] ;
			P[i].z = JObj->mtx[2][3] ;
		}
		
		PopCorn->PopPoly[0][0][0] = P[0] ;
		PopCorn->PopPoly[0][0][1] = P[5] ;
		PopCorn->PopPoly[0][0][2] = P[4] ;

		PopCorn->PopPoly[0][1][0] = P[0] ;
		PopCorn->PopPoly[0][1][1] = P[1] ;
		PopCorn->PopPoly[0][1][2] = P[5] ;


		PopCorn->PopPoly[1][0][0] = P[1] ;
		PopCorn->PopPoly[1][0][1] = P[6] ;
		PopCorn->PopPoly[1][0][2] = P[5] ;

		PopCorn->PopPoly[1][1][0] = P[1] ;
		PopCorn->PopPoly[1][1][1] = P[2] ;
		PopCorn->PopPoly[1][1][2] = P[6] ;


		PopCorn->PopPoly[2][0][0] = P[2] ;
		PopCorn->PopPoly[2][0][1] = P[7] ;
		PopCorn->PopPoly[2][0][2] = P[6] ;

		PopCorn->PopPoly[2][1][0] = P[2] ;
		PopCorn->PopPoly[2][1][1] = P[3] ;
		PopCorn->PopPoly[2][1][2] = P[7] ;


		PopCorn->PopPoly[3][0][0] = P[3] ;
		PopCorn->PopPoly[3][0][1] = P[4] ;
		PopCorn->PopPoly[3][0][2] = P[7] ;

		PopCorn->PopPoly[3][1][0] = P[3] ;
		PopCorn->PopPoly[3][1][1] = P[0] ;
		PopCorn->PopPoly[3][1][2] = P[4] ;


		PopCorn->PopPoly[4][0][0] = P[4] ;
		PopCorn->PopPoly[4][0][1] = P[5] ;
		PopCorn->PopPoly[4][0][2] = P[6] ;

		PopCorn->PopPoly[4][1][0] = P[6] ;
		PopCorn->PopPoly[4][1][1] = P[4] ;
		PopCorn->PopPoly[4][1][2] = P[7] ;
	}

	// I
	return Effect ;
}

// |bvR[̃GtFNǧns
extern s8 ReleasePopCornEffect( EFFECT *Effect )
{
	POPCORNEFFECT *PopCorn = ( POPCORNEFFECT * )Effect->Data ;

	if( CheckEffectValidState( PopCorn->BillEff, PopCorn->BillEffID ) == TRUE )
	{
		DeleteEffect( PopCorn->BillEff ) ;
	}

	// ɂ邱ƂȂ
	return 0 ;
}

// |bvR[̃GtFNgPt[
extern s8 MovePopCornEffect( EFFECT *Effect )
{
	POPCORNEFFECT *PC = ( POPCORNEFFECT * )Effect->Data ;

	if( (POPCORNEFFECT *)NULL == PC ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE && GetBillboardEffectObjectNum( PC->BillEff ) == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// |S_̃Zbg
	{
		Vec P[8] ;
		HSD_JObj *JObj ;
		s32 i ;
		
		for( i = 0 ; i < 8 ; i ++ )
		{
			JObj = PC->PopBox[i]->GetJObj() ;
			HSD_JObjSetupMatrix( JObj ) ;
			P[i].x = JObj->mtx[0][3] ;
			P[i].y = JObj->mtx[1][3] ;
			P[i].z = JObj->mtx[2][3] ;
		}
		
		PC->PopPoly[0][0][0] = P[0] ;
		PC->PopPoly[0][0][1] = P[5] ;
		PC->PopPoly[0][0][2] = P[4] ;

		PC->PopPoly[0][1][0] = P[0] ;
		PC->PopPoly[0][1][1] = P[1] ;
		PC->PopPoly[0][1][2] = P[5] ;


		PC->PopPoly[1][0][0] = P[1] ;
		PC->PopPoly[1][0][1] = P[6] ;
		PC->PopPoly[1][0][2] = P[5] ;

		PC->PopPoly[1][1][0] = P[1] ;
		PC->PopPoly[1][1][1] = P[2] ;
		PC->PopPoly[1][1][2] = P[6] ;


		PC->PopPoly[2][0][0] = P[2] ;
		PC->PopPoly[2][0][1] = P[7] ;
		PC->PopPoly[2][0][2] = P[6] ;

		PC->PopPoly[2][1][0] = P[2] ;
		PC->PopPoly[2][1][1] = P[3] ;
		PC->PopPoly[2][1][2] = P[7] ;


		PC->PopPoly[3][0][0] = P[3] ;
		PC->PopPoly[3][0][1] = P[4] ;
		PC->PopPoly[3][0][2] = P[7] ;

		PC->PopPoly[3][1][0] = P[3] ;
		PC->PopPoly[3][1][1] = P[0] ;
		PC->PopPoly[3][1][2] = P[4] ;


		PC->PopPoly[4][0][0] = P[4] ;
		PC->PopPoly[4][0][1] = P[5] ;
		PC->PopPoly[4][0][2] = P[6] ;

		PC->PopPoly[4][1][0] = P[6] ;
		PC->PopPoly[4][1][1] = P[7] ;
		PC->PopPoly[4][1][2] = P[4] ;
	}
	
	// r{[h쐬
	if( Effect->DelReqFlag == FALSE )
	{
		Vec Pos, p, d1, d2 ;
		f32 x, y ;
	
		PC->CreateCounter += (f32)VParam[ED_POPCORN][5] * 0.1F ;
		while( PC->CreateCounter > 1.0F )
		{
			PC->CreateCounter -= 1.0F ;
	
			// `̌_ƊẽxNg𓾂
			GetWK7JObjRect( &PC->PopBox[4], &p, &d1, &d2 ) ;
			
			// Wo
			x = ( (f32)rand() * 0.95F ) / RAND_MAX ;
			y = ( (f32)rand() * 0.95F ) / RAND_MAX ;
			Pos.x = d1.x * x + d2.x * y + p.x ;
			Pos.y = d1.y * x + d2.y * y + p.y + 0.1F ;
			Pos.z = d1.z * x + d2.z * y + p.z ;
			
			// 
			AddBillboardEffectObject( PC->BillEff, Pos, NULL ) ;
		}
	}
			
	
	// I
	return 0 ;
}
	
// |bvR[̃GtFNg`悷
extern s8 DrawPopCornEffect( EFFECT *Effect )
{
	POPCORNEFFECT *PC = ( POPCORNEFFECT * )Effect->Data ;
 
	if( (POPCORNEFFECT *)NULL == PC ) return 0 ;

	// I
	return 0 ;
}

// |bvR[̃Xs[h
extern s8 SetPopCornEffectSpeed( EFFECT *Effect, f32 Speed )
{
	POPCORNEFFECT *PopCorn = ( POPCORNEFFECT * )Effect->Data ;
	
	PopCorn->Speed = Speed ;
	SetBillboardSpeedRate( PopCorn->BillEff, PopCorn->Speed ) ;

	// I
	return 0 ;
}
	

