///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectRain
//
// YK7EffectRain.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectRain.h"
#include "./YK7Break.h"
#include "../Wat/WK7Archive.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define RAINTEX 			"/Yam/Effect/Rain/Ripple.BIN"		// JGtFNgp̃eNX`t@C
#define RAINTEX_DIVNUM		2								// eNX`̕
#define RAINTEX_ONES		(1.0F/(RAINTEX_DIVNUM))
#define RAIN_MODELNUM		4								// JeNX`̑

#define PRM					(s32)VParam[ED_RAIN]
#define MAXLEN				(PRM[13])
#define MINALPHA			((f32)PRM[14] * 0.01F)
#define MAXALPHA			((f32)PRM[2] / 255.0F) 
#define SIZE				((f32)PRM[15] * 0.01F)
#define CREATESPEED			(PRM[0])


// datatype -------------------------------------

// data -----------------------------------------

RAINUNION RinUnion ;
extern LINEUNION LUnion ;

// function proto type --------------------------

static s8 CollisionCallBack( Vec **Point, void *Data ) ;										// 蔻pR[obN
extern s8 CheckMeshCollision( BASICMESH *Mesh, f32 x, f32 z, POSINDEXPOINTLIST *PIPList ) ;		// bVƂ̓蔻Ԃ( 0:ĂȂ  1:Ă )

// function code --------------------------------

// 蔻pR[obN
static s8 CollisionCallBack( Vec **Point, void *Data ) 
{
	f32 bx, bz, qx, qz, px, pz, m, n ;

	bx = ((Vec *)Data)->x - Point[0]->x ;
	bz = ((Vec *)Data)->z - Point[0]->z ;
	
	qx = Point[1]->x - Point[0]->x ;
	qz = Point[1]->z - Point[0]->z ;

	px = Point[2]->x - Point[0]->x ;
	pz = Point[2]->z - Point[0]->z ;

	n = ( bx * qz - bz * qx ) / ( px * qz - pz * qx ) ;
	if( qz == 0.0F )
	{
		m = ( bx - n * px ) / qx ;
	}
	else
	{
		m = ( bz - n * pz ) / qz ;
	}

/*
	m = ( bx * pz - bz * px ) / ( qx * pz - qz * px ) ;
	if( pz == 0.0F )
	{
		n = ( bx - m * qx ) / px ;
	}
	else
	{
		n = ( bz - m * qz ) / pz ;
	}
*/
	return n >= 0.0F && m >= 0.0F && n + m <= 1.0F ? (s8)-1 : (s8)0 ;
//	return 0 ;
}

// bVƂ̓蔻Ԃ( 0:ĂȂ  1:Ă )
extern s8 CheckMeshCollision( BASICMESH *Mesh, f32 x, f32 z, POSINDEXPOINTLIST *PIPList )
{
	Vec p ;
	s32 hr ;
	
	p.x = x ;
	p.z = z ;

	// XLJn
	hr = ScanMeshPrimitive( Mesh, CollisionCallBack, &p, NULL, PIPList ) ;
	return hr == -2 ? (s8)1 : (s8)0 ;
}


// JGtFNg̋ʃf[^
extern s8 InitRainData( void )
{
	MEMINIT( RinUnion ) ;

	// JpeNX`[ǂݍ
//	TexLoadSet( RAINTEX, &RinUnion.RainTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_Ripple ), &RinUnion.RainTex ) ;

	// I
	return 0 ;
}

// JtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckRainData( void )
{
//	if( TexLoadChk( &RinUnion.RainTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}


// JGtFNg̋ʃf[^n
extern s8 EndRainData( void )
{
	// eNX`f[^j
	TexRelease( &RinUnion.RainTex ) ;

	// I
	return 0 ;
}


// J̃GtFNg쐬
extern EFFECT *CreateRainEffect( Vec Point, f32 YukaY,
									f32 DownSpeed, f32 DownSSpeed,
									f32 RainR, u16 MaxNum,
									f32 LineWidth, f32 LineLen,
									GXColor *Color, WK7JObj *JObj,
									f32 BiasAlpha, s32 Priority )
{
	EFFECT *Effect ;
	RAINEFFECT *Rn ;
	RAINOBJECT *Ob = NULL ;
	BASICMESH *BasM = NULL, *BasM2 = NULL ;
	POSINDEXPOINTLIST PIPList, PIPList2 ;
	HSD_DObj *dobj ;
	WK7JObj *JObj2 ;
	MESH *Mesh = NULL ;
	HSD_JObj *hsjobj ;
	f32 YukaY2, YukaY1 ;
	
	JObj2 = RinUnion.Collision2JObj ;
	RinUnion.Collision2JObj = NULL ;
	
	memset( &PIPList, 0, sizeof( POSINDEXPOINTLIST ) ) ;
	memset( &PIPList2, 0, sizeof( POSINDEXPOINTLIST ) ) ;

	// t@C̓ǂݍ݂IĂȂ牽ɏI
	if( CheckRainData() == FALSE ) return 0 ;

	// JObj nĂӂ蔻胁bV쐬
	if( JObj != NULL &&
		JObj->GetObj( "RainCollision" ) != NULL &&
		JObj->GetObj( "RainCollision" )->GetChild() != NULL &&
		JObj->GetObj( "RainCollision" )->GetChild()->GetJObj() != NULL )
	{
		
		hsjobj = JObj->GetObj( "RainCollision" )->GetChild()->GetJObj() ;
		dobj = GetHaveMeshDObj( hsjobj ) ;
		if( dobj == NULL ) goto ERR ;
		
		if( CreatePrimitiveMeshData( hsjobj, dobj, dobj->pobj, &Mesh, FALSE, TRUE, FALSE, FALSE, TRUE ) < 0 ) return NULL ;
		if( CreateBasicPrimitiveMeshData( Mesh, &BasM, TRUE, FALSE, TRUE, FALSE ) < 0 ) goto ERR ;
		DeletePrimitiveMeshData( Mesh ) ;
		Mesh = NULL ;

		// ̍̂P擾(͉̍)
		HSD_JObjSetupMatrix( hsjobj ) ;
		YukaY1 = hsjobj->mtx[1][3] ;
		
		if( CreatePosIndexPointList( BasM, &PIPList, FALSE ) < 0 ) goto ERR ;
	}

	// U邯ǍႤbV񂪂ꍇ͂擾	
	if( JObj2 != NULL && 
		JObj2->GetObj( "RainCollision2" ) != NULL &&
		JObj2->GetObj( "RainCollision2" )->GetChild() != NULL &&
		JObj2->GetObj( "RainCollision2" )->GetChild()->GetJObj() != NULL )
	{
		hsjobj = JObj2->GetObj( "RainCollision2" )->GetChild()->GetJObj() ;
		dobj = GetHaveMeshDObj( hsjobj ) ;
		if( dobj == NULL ) goto ERR ;
		
		if( CreatePrimitiveMeshData( hsjobj, dobj, dobj->pobj, &Mesh, FALSE, TRUE, FALSE, FALSE, TRUE ) < 0 ) return NULL ;
		if( CreateBasicPrimitiveMeshData( Mesh, &BasM2, TRUE, FALSE, TRUE, FALSE ) < 0 ) goto ERR ;
		DeletePrimitiveMeshData( Mesh ) ;
		Mesh = NULL ;

		// ̍̂Q擾(͉̍)
		HSD_JObjSetupMatrix( hsjobj ) ;
		YukaY2 = hsjobj->mtx[1][3] ;

		if( CreatePosIndexPointList( BasM2, &PIPList2, FALSE ) < 0 ) goto ERR ;
	}

	// ̊m
	if( ( Ob = ( RAINOBJECT * )K7AppSmallMemAllocName( (s32)( ( sizeof( RAINOBJECT ) + sizeof( u16 ) * 2 ) * MaxNum ), "Y_RainObj" ) ) == NULL ) goto ERR ;
	memset( Ob, 0, ( sizeof( RAINOBJECT ) + sizeof( u16 ) * 2 ) * MaxNum ) ;

	// VJf[^쐬
	Effect = AddEffectData( EFF_RAIN, (void**)&Rn, Priority ) ;
	if( Effect == NULL ) goto ERR ;
	
	// p[^ۑ
	Rn->Mesh 			= BasM ;
	Rn->PIPList 		= PIPList ;
	Rn->Mesh2 			= BasM2 ;
	Rn->PIPList2 		= PIPList2 ;
	Rn->Point 			= Point ;
	Rn->RenderList 		= (u16*)( (u8*)Ob + sizeof( RAINOBJECT ) * MaxNum ) ;
	Rn->BotRenderList 	= (u16*)( (u8*)Rn->RenderList + sizeof( u16 ) * MaxNum ) ;
	Rn->DownSpeed 		= DownSpeed ;
	Rn->DownSSpeed 		= DownSSpeed ;
	Rn->RainR 			= RainR ;
	Rn->MaxObjNum 		= MaxNum ;
	Rn->YukaY[0] 		= YukaY + 0.01F ;
	Rn->YukaY[2]		= YukaY2 + 0.01F ;
	Rn->YukaY[1]		= YukaY1 + 0.01F ;
	Rn->LineWidth 		= LineWidth ;
	Rn->LineLen			= LineLen ;
	Rn->BiasAlpha		= BiasAlpha ;
	if( Color != NULL )
	{
		Rn->Color = *Color ;
	}
	else
	{
		Rn->Color.r = Rn->Color.g = Rn->Color.b = Rn->Color.a = 255 ;
	}
	
	Rn->VertCounter 	= 0 ;
	Rn->ValidCounter	= 0 ;
	Rn->ObjP 			= Ob ;
	Rn->ObjNum 			= 0 ;
	Rn->Counter 		= 0 ;
	Rn->Mode 			= 0 ;
	Rn->RainCounter 	= 0.0F ;
	Rn->OneRainPoint 	= 1.0F / CREATESPEED ;
	
	// I
	return Effect ;
	
ERR :
	if( Ob != NULL ) K7AppSmallMemFree( Ob ) ;
	DeletePosIndexPointList( &PIPList ) ;
	DeletePosIndexPointList( &PIPList2 ) ;
	if( BasM != NULL ) DeleteBasicMeshData( BasM ) ;
	if( BasM2 != NULL ) DeleteBasicMeshData( BasM2 ) ;
	if( Mesh != NULL ) DeletePrimitiveMeshData( Mesh ) ;

	return NULL ;
}

// J̃GtFNǧns
extern s8 ReleaseRainEffect( EFFECT *Effect )
{
	RAINEFFECT *Rn = ( RAINEFFECT * )Effect->Data ;

	// JGtFNgIuWFNgp̃J
	CHKMEMFREE2( Rn->ObjP ) ;
	
	// 蔻pbV쐬Ăꍇ͂폜
	if( Rn->Mesh != NULL ) DeleteBasicMeshData( Rn->Mesh ) ;
	DeletePosIndexPointList( &Rn->PIPList ) ;
	if( Rn->Mesh2 != NULL ) DeleteBasicMeshData( Rn->Mesh2 ) ;
	DeletePosIndexPointList( &Rn->PIPList2 ) ;

	// I
	return 0 ;
}

// J̃GtFNgPt[
extern s8 MoveRainEffect( EFFECT *Effect )
{
	RAINEFFECT *Rn = ( RAINEFFECT * )Effect->Data ;
	u32 i, j, Num ;
	RAINOBJECT *Ob ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// J̐JԂ
	Num = Rn->ObjNum ;
	Ob = Rn->ObjP ;
	Rn->VertCounter = 0 ;
	Rn->RenderNum = 0 ;
	Rn->BotRenderNum = 0 ;
	for( i = 0, j = 0 ; i < Num ; Ob ++, j ++ )
	{
		// LtOĂȂ牽Ȃ
		if( Ob->ValidFlag == FALSE ) continue ;

		i ++ ;
		
		// ړ
		if( Ob->BotFlag == TRUE ) 
		{
			Ob->Counter ++ ;
			if( Ob->Counter == 3 )
			{
				Ob->ValidFlag = FALSE ;
				Rn->ObjNum -- ;
			}
			else
			{
				Rn->BotRenderList[Rn->BotRenderNum] = (u16)j ;
				Rn->BotRenderNum ++ ;
			}
		}
		else
		{
			Ob->Point.y -= Ob->Speed.y ;
			Ob->Speed.y += Rn->DownSSpeed ;
			if( Rn->YukaY[Ob->YukaIndex] > Ob->Point.y ) 
			{
				if( Ob->YukaIndex > 0 )
				{
					Ob->ValidFlag = FALSE ;
					Rn->ObjNum -- ;
				}
				else
				{
					Ob->Point.y = Rn->YukaY[0] ;
					Ob->BotFlag = TRUE ;
					Ob->Counter = 0 ;
					Rn->BotRenderList[Rn->BotRenderNum] = (u16)j ;
					Rn->BotRenderNum ++ ;
				}
			}
			else
			{
				Rn->RenderList[Rn->RenderNum] = (u16)j ;
				Rn->RenderNum ++ ;
			}
		}
	}
	
	// J~胂[h
	{
		f32 x, z ;
		u8 YukaIndex ;
	
		// JE^
		Rn->RainCounter += 1.0F ;
		
		// JE^Kl𒴂ĂJ𕑂~点
		while( Rn->OneRainPoint != 0.0F && Rn->RainCounter > Rn->OneRainPoint && Rn->ObjNum != Rn->MaxObjNum )
		{
			YukaIndex = 0 ;
		
			x = rand() * Rn->RainR / RAND_MAX - Rn->RainR / 2 + Rn->Point.x ;
			z = rand() * Rn->RainR / RAND_MAX - Rn->RainR / 2 + Rn->Point.z ;
			if( Rn->Mesh != NULL && CheckMeshCollision( Rn->Mesh, x, z, &Rn->PIPList ) == 1 )
			{
				// ̍Ⴄ
				YukaIndex = 1 ;
/*
				// 蔻Ɉ|Ă܂ꍇ̓JE^炷
				Rn->RainCounter -= Rn->OneRainPoint ;
				continue ;
*/			}
			
			// 邯ǏI_ႤbV񂪂ꍇ̏
			if( Rn->Mesh2 != NULL && CheckMeshCollision( Rn->Mesh2, x, z, &Rn->PIPList2 ) == 1 )
			{
				// ̍Ⴄ
				YukaIndex = 2 ;
			}

			// gĂȂJf[^T
			for( Ob = &Rn->ObjP[Rn->ValidCounter] ; Ob->ValidFlag == TRUE ; )
			{
				Rn->ValidCounter ++ ;
				Ob ++ ;
				if( Rn->ValidCounter == Rn->MaxObjNum )
				{
					Ob = Rn->ObjP ;
					Rn->ValidCounter = 0 ;
				}
			}

			Rn->RenderList[Rn->RenderNum] = (u16)Rn->ValidCounter ;
			Rn->RenderNum ++ ;
			
			Rn->ValidCounter ++ ;
			if( Rn->ValidCounter == Rn->MaxObjNum ) Rn->ValidCounter = 0 ;
	
			// LtO𗧂Ă
			Ob->ValidFlag = TRUE ;
			Ob->BotFlag = FALSE ;
			
			// 𑝂₷
			Rn->ObjNum ++ ;
			Rn->RainCounter -= Rn->OneRainPoint ;

			// ̃Zbg
			{
				Ob->Point.y = Rn->Point.y + rand() * Rn->LineLen / RAND_MAX ;
				Ob->Point.x = x ;
				Ob->Point.z = z ;
			}
			Ob->Speed.x = Ob->Speed.z = 0.0F ;
			Ob->Speed.y = Rn->DownSpeed ;
			Ob->YukaIndex = YukaIndex ;
		}
	}

	// I
	return 0 ;
}

// J̃GtFNg`悷
extern s8 DrawRainEffect( EFFECT *Effect )
{
	RAINEFFECT *Rn = ( RAINEFFECT * )Effect->Data ;
	u32 j ;
	RAINOBJECT *Ob ;
	RAINUNION *RainUnion = &RinUnion ;
	Vec CamP ;

	if( RinUnion.NotAllDrawFlag == TRUE ) return 0 ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	
	// eNX`̃[h
	GTLOAD2( LUnion.TestTex ) ;
	
	// C̑Zbg
	GXSetLineWidth( (u8)6, GX_TO_ONE ) ;
	GXEnableTexOffsets( GX_TEXCOORD0, GX_ENABLE, GX_ENABLE ) ;
//	GXEnableTexOffsets( GX_TEXCOORD0, GX_DISABLE, GX_DISABLE ) ;

	// J̈ʒu擾
	HSD_CObjGetEyePosition( GetEffectCamera(), &CamP ) ;	

	// `揈
	if( Rn->RenderNum != 0 )
	{
		GXBegin( GX_LINES, GX_VTXFMT0, (u16)( Rn->RenderNum * 2 ) ) ;
		{
			u32 Num ;
			f32 a, maxa ;
			u16 *List ;
			RAINOBJECT *ObjP ;
			f32 MinA = MINALPHA * Rn->BiasAlpha, MaxLen = MAXLEN * Rn->BiasAlpha ;

			Num = Rn->RenderNum ;
			List = Rn->RenderList ;
			ObjP = Rn->ObjP ;
			maxa = MAXALPHA * Rn->BiasAlpha ;

			if( maxa > 1.0F )
			{
				maxa = 1.0F ;
			}
			else
			{
				if( maxa < 0.0F ) maxa = 0.0F ;
			}
			
			if( MinA > 1.0F )
			{
				MinA = 1.0F ;
			}
			else
			{
				if( MinA < 0.0F ) MinA = 0.0F ;
			}
			
			for( j = 0 ; j < Num ; j ++, List ++ )
			{
				Ob = &ObjP[*List] ;

				// ɂăAt@lZo
				a = maxa - PSVECDistance( &CamP, &Ob->Point ) / MaxLen ;
				if( a < MinA ) a = MinA ;

				// _̃Zbg
				GP3( Ob->Point.x, Ob->Point.y + Rn->LineLen, Ob->Point.z ) ;
				GC2( Rn->Color, 0 ) ;			GT( 0, 0 ) ;

				GPV( Ob->Point ) ;
				GC2( Rn->Color, a * 255 ) ;		GT( 0, 1.0F ) ;
			}
		}
		GXEnd() ;
	}
	
	// `揈
	if( Rn->BotRenderNum != 0 )
	{
		// eNX`̃[h
		GTLOAD2( RainUnion->RainTex ) ;
	
		GBGN( GX_QUADS, Rn->BotRenderNum * 4 ) ;
		{
			u32 Num ;
			f32 a, Size, maxa, maxlen, mina ;
			u16 *List ;
			RAINOBJECT *ObjP ;
			f32 u[3] = { 0.0F, 0.5F, 0.5F } ;
			f32 v[3] = { 0.5F, 0.5F, 0.0F } ;
			u32 color ;

			Size = SIZE ;
			Num = Rn->BotRenderNum ;
			List = Rn->BotRenderList ;
			ObjP = Rn->ObjP ;
			maxa = MAXALPHA ;
			mina = MINALPHA ;
			maxlen = MAXLEN ;
			for( j = 0 ; j < Num ; j ++, List ++ )
			{
				Ob = &ObjP[*List] ;

				// ɂăAt@lZo
				a = maxa - PSVECDistance( &CamP, &Ob->Point ) / maxlen ;
				if( a < mina ) a = mina ;
				color = CMKC2( Rn->Color, a * 255 ) ;

				// _̃Zbg
				GP3( Ob->Point.x - Size, Ob->Point.y, Ob->Point.z - Size ) ;
				GCX( color ) ;		GT( u[Ob->Counter], v[Ob->Counter] ) ;

				GP3( Ob->Point.x + Size, Ob->Point.y, Ob->Point.z - Size ) ;
				GCX( color ) ;		GT( u[Ob->Counter]+RAINTEX_ONES, v[Ob->Counter] ) ;

				GP3( Ob->Point.x + Size, Ob->Point.y, Ob->Point.z + Size ) ;
				GCX( color ) ;		GT( u[Ob->Counter]+RAINTEX_ONES, v[Ob->Counter]+RAINTEX_ONES ) ;

				GP3( Ob->Point.x - Size, Ob->Point.y, Ob->Point.z + Size ) ;
				GCX( color ) ;		GT( u[Ob->Counter], v[Ob->Counter]+RAINTEX_ONES ) ;
			}
		}
		GEND() ;
	}
	
	// sysdolphinԖ
	HSD_StateInvalidate(HSD_STATE_ALL);

	// I
	return 0 ;
}					


	
// J钆S_ύX
extern s8 SetRainEffectPoint( EFFECT *Effect, Vec Point )
{
	RAINEFFECT *Rn = ( RAINEFFECT * )Effect->Data ;

	// WύX
	Rn->Point = Point ;

	// I
	return 0 ;
}

// ̍Ⴄʒu񃁃bV JObj o^
extern s8 SetRainCollision2JObj( WK7JObj *JObj )
{
	RinUnion.Collision2JObj = JObj ;
	
	return 0 ;
}

// JGtFNg̑SĂ`悷邩ǂ̃tOZbg
extern s8 SetRainAllDrawFlag( s8 Flag )
{
	RinUnion.NotAllDrawFlag = (s8)( Flag == TRUE ? FALSE : TRUE ) ;

	return 0 ;
}

// Pt[ō쐬J̗ʂύX
extern s8 SetRainObjectCreateSpeed( EFFECT *Effect, s32 CreateNum )
{
	RAINEFFECT *Rn = ( RAINEFFECT * )Effect->Data ;

	if( CreateNum == 0 )
	{
		Rn->OneRainPoint = 0.0F ;
	}
	else
	{
		Rn->OneRainPoint = 1.0F / (f32)CreateNum ;
	}

	// I
	return 0 ;
}

