///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectRotLight
//
// YK7EffectRotLight.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/26/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectRotLight.h"
#include "./YK7EffectLaser.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

ROTLIGHTUNION RLigUnion ;

// function proto type --------------------------

//HSV RGBToHSV(TColor rgb) ;						

// function code --------------------------------

// gruJ[qfaJ[ɕϊ
extern GXColor HSVToRGB( f32 H, f32 S, f32 V )
{
	f32 r, g, b ;
	GXColor Color ;
	
	// FI
	H = fmod( H, 1.0F ) ;
	if( H >= 0.0F && H <= 1.0F / 6.0F )
	{
		H = H * 6.0F ;					r = 1.0F ;		g = H ;			b = 0.0F ;
	}
	else
	if( H > 1.0F / 6.0F && H <= 2.0F / 6.0F )
	{
		H = H * 6.0F - 1.0F ;			r = 1.0F - H ;	g = 1.0F ;		b = 0.0F ;
	}
	else
	if( H > 2.0F / 6.0F && H <= 3.0F / 6.0F )
	{
		H = H * 6.0F - 2.0F ;			r = 0.0F ;		g = 1.0F ;		b = H ;
	}
	else
	if( H > 3.0F / 6.0F && H <= 4.0F / 6.0F )
	{
		H = H * 6.0F - 3.0F ;			r = 0.0F ;		g = 1.0F - H ;	b = 1.0F ;
	}
	else
	if( H > 4.0F / 6.0F && H <= 5.0F / 6.0F )
	{
		H = H * 6.0F - 4.0F ;			r = H ;			g = 0.0F ;		b = 1.0F ;
	}
	else
	if( H > 5.0F / 6.0F && H <= 6.0F / 6.0F )
	{
		H = H * 6.0F - 5.0F ;			r = 1.0F ;		g = 0.0F ;		b = 1.0F - H ;
	}

	// ʓxƋPx̌vZs	
	{		
		// ʓx
		r += ( 0.5F - r ) * ( 1.0F - S ) ;
		g += ( 0.5F - g ) * ( 1.0F - S ) ;
		b += ( 0.5F - b ) * ( 1.0F - S ) ;
		
		// Px
		if( V <= 0.5F )
		{
			r *= V * 2.0F ;	
			g *= V * 2.0F ;	
			b *= V * 2.0F ;
		}
		else
		{
			r += ( 1.0F - r ) * ( ( V - 0.5F ) * 2.0F ) ;
			g += ( 1.0F - g ) * ( ( V - 0.5F ) * 2.0F ) ;
			b += ( 1.0F - b ) * ( ( V - 0.5F ) * 2.0F ) ;
		}
	}
	
	// 255 K
	Color.r = (u8)( r * 255.0F ) ;
	Color.g = (u8)( g * 255.0F ) ;
	Color.b = (u8)( b * 255.0F ) ;
	
	// I
	return Color ;
}
				

// 邭郉CgGtFNg̋ʃf[^
extern s8 InitRotLightData( void )
{
	MEMINIT( RLigUnion ) ;

	// I
	return 0 ;
}

// 邭郉CgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckRotLightData( void )
{
	return TRUE ;
}

// 邭郉CgGtFNg̋ʃf[^n
extern s8 EndRotLightData( void )
{
	MEMINIT( RLigUnion ) ;

	// I
	return 0 ;
}


// 邭郉Cg̃GtFNg쐬
extern EFFECT *CreateRotLightEffect(
									 Vec Pos,			// W
									 Vec Dir,			// 
									 f32 Slope,			// X
									 f32 Speed,			// ]x
									 f32 Width,			// ]
									 f32 Length,		// 
									 s32 Priority )
{
	ROTLIGHTEFFECT *RotLight ;
	EFFECT *Effect, *LaserEffect ;
	f32 Rot, ColorCounter ;
	GXColor Color ;
	DIR3 Dv ;
	
	if( Slope < 0.0F ) Slope = (f32)VParam[ED_ROTLIGHT][0] * PI_2 / 360 ;
	if( Speed < 0.0F ) Speed = VParam[ED_ROTLIGHT][6] * PI_2 / 360 ;
	if( Width < 0.0F ) Width = VParam[ED_ROTLIGHT][7] ;
	if( Length < 0.0F ) Length = VParam[ED_ROTLIGHT][8] ;
	
	// O𓾂
	GetDir3( Dir, &Dv ) ;
	
	// [U[GtFNg쐬
	{
		Vec P1, P2, dir ;
		
		P1 = Pos ;
		Rot = rand() * PI_2 / RAND_MAX ;

		dir.x = cosf( Slope ) ;
		dir.y = sinf( Slope ) ;
		dir.z = 0.0F ;
		
		dir.z = sinf( Rot ) * dir.x ;
		dir.x = cosf( Rot ) * dir.x ;
		VECScale( &dir, &P2, Length ) ;
		GetDirPos( &Dv, &P2, P2.z, P2.x, P2.y ) ;
		
		P2.x += Pos.x ;	P2.y += Pos.y ;	P2.z += Pos.z ;

		ColorCounter = (f32)rand() / RAND_MAX ;
		Color = HSVToRGB( ColorCounter, (f32)VParam[ED_ROTLIGHT][1] / 255.0F, (f32)VParam[ED_ROTLIGHT][2] / 255.0F ) ;
		Color.a = (u8)VParam[ED_ROTLIGHT][4] ;
		LaserEffect = CreateLaserEffect( P1, P2, VParam[ED_ROTLIGHT][9] * 10, Width,
											Color, VParam[ED_ROTLIGHT][3] ) ;
		if( LaserEffect == NULL ) return NULL ;
		SetLaserEffectAlpha( 1.0F, (f32)VParam[ED_ROTLIGHT][10] * 0.01F, 0.0F, LaserEffect ) ;
		SetLaserEffectDouble( LaserEffect, TRUE, (f32)VParam[ED_ROTLIGHT][7] * 0.80F, Color ) ;
	}
	
	// V邭郉Cgf[^쐬
	Effect = AddEffectData( EFF_ROTLIGHT, (void**)&RotLight, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( LaserEffect ) ;
		return NULL ;
	}

	// 邭郉Cgf[^
	RotLight->ColorCounter 	= ColorCounter ;
	RotLight->LaserEffect 	= LaserEffect ;
	RotLight->Pos 			= Pos ;
	RotLight->Dir			= Dir ;
	RotLight->Dv 			= Dv ;
	RotLight->RotSpeed 		= rand() * 2 / RAND_MAX == 0 ? Speed : -Speed ;
	RotLight->Length 		= Length ;
	RotLight->Width 		= Width ;
	RotLight->RotCounter 	= Rot ;
	RotLight->Color 		= Color ;
	RotLight->Slope 		= Slope ;

	// I
	return Effect ;
}

// 邭郉Cg̃GtFNǧns
extern s8 ReleaseRotLightEffect( EFFECT *Effect )
{
	ROTLIGHTEFFECT *RotLight = ( ROTLIGHTEFFECT * )Effect->Data ;

	// GtFNg폜
	DeleteEffect( RotLight->LaserEffect ) ;

	// I
	return 0 ;
}

// 邭郉Cg̃GtFNgPt[
extern s8 MoveRotLightEffect( EFFECT *Effect )
{
	ROTLIGHTEFFECT *RL = ( ROTLIGHTEFFECT * )Effect->Data ;

	if( (ROTLIGHTEFFECT *)NULL == RL ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
	}
	
	// ]
	RL->RotCounter += RL->RotSpeed ;
	
	// F𐄈ڂ
	RL->ColorCounter += (f32)VParam[ED_ROTLIGHT][5] / 255.0F ;
	
	// W̍XV
	{
		Vec P1, P2, dir ;
		f32 Rot ;
		
		P1 = RL->Pos ;
		Rot = rand() * PI_2 / RAND_MAX ;

		dir.x = cosf( RL->Slope ) ;
		dir.y = sinf( RL->Slope ) ;
		dir.z = 0.0F ;
		
		dir.z = sinf( RL->RotCounter ) * dir.x ;
		dir.x = cosf( RL->RotCounter ) * dir.x ;
		
		VECScale( &dir, &P2, RL->Length ) ;
		GetDirPos( &RL->Dv, &P2, P2.z, P2.x, P2.y ) ;

		P2.x += RL->Pos.x ;	P2.y += RL->Pos.y ;	P2.z += RL->Pos.z ;
		
		SetLaserEffectPoint( RL->LaserEffect, &P1, &P2 ) ;
	}
	
	// FZbg
	{
		GXColor Color ;
	
		Color = HSVToRGB( RL->ColorCounter, (f32)VParam[ED_ROTLIGHT][1] / 255.0F, (f32)VParam[ED_ROTLIGHT][2] / 255.0F ) ;
		Color.a = (u8)VParam[ED_ROTLIGHT][4] ;
		SetLaserEffectColor( &Color, RL->LaserEffect ) ;
		SetLaserEffectAlpha( 1.0F, VParam[ED_ROTLIGHT][10] * 0.01F, 0.0F, RL->LaserEffect ) ;
	}

	// I
	return 0 ;
}
	
// 邭郉Cg̃GtFNg`悷
extern s8 DrawRotLightEffect( EFFECT *Effect )
{
	ROTLIGHTEFFECT *RotLight = ( ROTLIGHTEFFECT * )Effect->Data ;

	// ɉȂ

	// I
	return 0 ;
}

// 邭郉Cg\`悷邩ǂ̃tOZbg
extern s8 SetRotLightAllDrawFlag( s8 Flag )
{
	RLigUnion.NotAllDrawFlag = !Flag ;
	
	// I
	return 0 ;
}	
