///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectScreen
//
// YK7EffectScreen.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/16/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectScreen.h"
#include "../matsu/mk7Sound.h"
#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

static SCREENUNION SCRUnion ;

// function proto type --------------------------

// function code --------------------------------

// XN[GtFNg̋ʃf[^
extern s8 InitScreenData( void )
{
	MEMINIT(SCRUnion) ;

	// I
	return 0 ;
}

// XN[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckScreenData( void )
{
	return TRUE ;
}

// XN[GtFNg̋ʃf[^n
extern s8 EndScreenData( void )
{
	MEMINIT(SCRUnion) ;

	// I
	return 0 ;
}

// XN[̃GtFNg쐬
extern EFFECT *CreateScreenEffect( s32 Priority )
{
	EFFECT *Effect ;
	SCREENEFFECT *Screen ;
	WK7ScreenImage *Image ;
	
	// XN[C[Wf[^쐬
	Image = new WK7ScreenImage ;
	Image->SetFormat( GX_TF_RGB565 ) ;
	if( Image == NULL ) return NULL ;
	if( Image->AllocBuffer() == false )
	{
		delete Image ;
		return NULL ;
	}

	// VXN[f[^쐬
	Effect = AddEffectData( EFF_SCREEN, (void**)&Screen, Priority ) ;
	if( Effect == NULL )
	{
		delete Image ;
		return NULL ;
	}

	// f[^
	Screen->Image = Image ;
	Screen->InitFlag = FALSE ;
	Screen->DeleteCounter = 0 ;

	Screen->Alpha = 254.0F / 255.0F ;
	Screen->DrawFlag = TRUE ;
	Screen->AddFlag = FALSE ;
	Screen->ExRate = 1.0F ;

	// I
	return Effect ;
}


// XN[̃GtFNǧns
extern s8 ReleaseScreenEffect( EFFECT *Effect )
{
	SCREENEFFECT *Screen = ( SCREENEFFECT * )Effect->Data ;

	// C[Wf[^̉
	delete Screen->Image ;

	// I
	return 0 ;
}

// XN[̃GtFNgt[ړ
extern s8 MoveScreenEffect( EFFECT *Effect )
{
	SCREENEFFECT *Screen = ( SCREENEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE ) 
	{
		Screen->DeleteCounter ++ ;
		if( Screen->DeleteCounter >= VParam[ED_SCREEN][12] )
		{
			SetEffectDrawFlag( Effect, FALSE ) ;
			if( Screen->DeleteCounter >= VParam[ED_SCREEN][12] + 3 )
			{
				DeleteEffect( Effect ) ;
				return 0 ;
			}
		}
	}

	// I
	return 0 ;
}					

// XN[̃GtFNg`悷
extern s8 DrawScreenEffect( EFFECT *Effect )
{
	SCREENEFFECT *Screen = ( SCREENEFFECT * )Effect->Data ;
	u8 a ;
	f32 ExRate, x, y, w, h ;

	if( Screen->DrawFlag == TRUE )
	{
		if( Screen->InitFlag == FALSE )
		{
			Screen->InitFlag = TRUE ;

			// ʂ̏Ԃ擾
			Screen->Image->ScreenCopy() ;
		}

		// eNX`̃[h
		GTLOAD( Screen->Image->GetTexObj() ) ;

		// `揀
		EffectRenderSetup( EF_PROJECT_ORTHO, 
							VParam[ED_SCREEN][3] == 1 ?
								( VParam[ED_SCREEN][2] == 0 ? EF_BLEND_ALPHA : EF_BLEND_ADD ) :
								( Screen->AddFlag == FALSE ? EF_BLEND_ALPHA : EF_BLEND_ADD ), EF_TEV_USETEX ) ;

		// TEVݒ
		GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA ) ; 
		GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV ) ;
			
		// p[^̃Zbg
		if( VParam[ED_SCREEN][3] == 1 )
		{
			ExRate = ( VParam[ED_SCREEN][1] + 100 ) * 0.01F ;
			if( Effect->DelReqFlag == TRUE )
			{
				a = (u8)( VParam[ED_SCREEN][0] * ( ( (f32)VParam[ED_SCREEN][12] - Screen->DeleteCounter ) / VParam[ED_SCREEN][12] ) ) ; 
			}
			else
			{
				a = (u8)VParam[ED_SCREEN][0] ;
			}
		}
		else
		{
			ExRate = Screen->ExRate ;
			if( Effect->DelReqFlag == TRUE )
			{
				a = (u8)( 255 * Screen->Alpha * ( ( (f32)VParam[ED_SCREEN][12] - Screen->DeleteCounter ) / VParam[ED_SCREEN][12] ) ) ;
			}
			else
			{
				a = (u8)( 255 * Screen->Alpha ) ;
			}
		}
		
		w = SCW * ExRate ;			h = SCH * ExRate ;
		x = -( w - SCW ) / 2.0F ;	y = -( h - SCH ) / 2.0F ;
		
		// XN[̕`
		DrawTex3( x, y, x + w, y + h, NULL, CMK2( 255, a ) ) ;
	}
	
	// ʂ̏Ԃ擾
	Screen->Image->ScreenCopy() ;
	
	// I
	return 0 ;
}					

// g嗦ύX
extern s8 SetScreenEffectExRate( EFFECT *Effect, f32 ExRate )
{
	SCREENEFFECT *Screen = ( SCREENEFFECT * )Effect->Data ;

	Screen->ExRate = ExRate ;

	// I
	return 0 ;
}

// Z`邩ǂ̃tOZbg
extern s8 SetScreenEffectAddFlag( EFFECT *Effect, s8 Flag )
{
	SCREENEFFECT *Screen = ( SCREENEFFECT * )Effect->Data ;

	Screen->AddFlag = Flag ;

	// I
	return 0 ;
}

// `掞̃At@lZbg
extern s8 SetScreenEffectAlpha( EFFECT *Effect, f32 Alpha )
{
	SCREENEFFECT *Screen = ( SCREENEFFECT * )Effect->Data ;

	Screen->Alpha = Alpha ;
	
	// I
	return 0 ;
}

// `悷邩ǂZbg
extern s8 SetScreenEffectDrawFlag( EFFECT *Effect, s8 Flag )
{
	SCREENEFFECT *Screen = ( SCREENEFFECT * )Effect->Data ;

	Screen->DrawFlag = Flag ;

	// I
	return 0 ;
}




