///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSearch
//
// YK7EffectSearch.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/23/2003
//
//////////////////////////////////////////////////////////////////////////////

#define __MODE2

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectSearch.h"
#include "../Wat/WK7MainTask.h"
#ifdef __MODE2
#include "./YK7EffectSight.h"
#endif

// define ---------------------------------------

#define BURE_SIZE		8.0F

// datatype -------------------------------------

// data -----------------------------------------

SEARCHUNION SarUnion ;

// function code --------------------------------

// T[``GtFNg̋ʃf[^
extern s8 InitSearchData( void )
{
	MEMINIT( SarUnion ) ;
	
	// I
	return 0 ;
}

// T[``GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSearchData( void )
{
	return TRUE ;
}


// T[``GtFNg̋ʃf[^n
extern s8 EndSearchData( void )
{
	MEMINIT( SarUnion ) ;
	
	// I
	return 0 ;
}

// T[``̃GtFNg쐬
extern EFFECT *CreateSearchEffect( f32 BaseSize, f32 Skill, f32 Speed, WK7JObj *HeadJObj, WK7JObj *WaistJObj, u32 RenderID, s32 Priority )
{
	SEARCHEFFECT *Search ;
	EFFECT *Effect ;
//	int i ;

	// VT[``f[^쐬
	Effect = AddEffectData( EFF_SEARCH, (void**)&Search, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// f[^ۑA
	Search->HeadJObj = HeadJObj ;
	Search->WaistJObj = WaistJObj ;
	Search->BaseSize = BaseSize ;
	Search->Skill = Skill ;
	Search->Speed = Speed ;
	Search->Counter = (u16)( 180 * rand() / RAND_MAX ) ;
	Search->Mode = 0 ;
	Search->RenderID = RenderID ;
	Search->EnemyAlphaL = WK7RenderObj::ConvRenderIDToAlpha( RenderID ) ;
	Search->EnemyAlphaH = WK7RenderObj::ConvRenderIDToAlpha( RenderID + 1 ) ;

#ifdef __MODE2
	AddSearchID( Search->RenderID ) ;
#endif

	// WZbg
	{
		Vec temp ;
	
		temp.x = Search->HeadJObj->GetJObj()->mtx[0][3] ;
		temp.y = Search->HeadJObj->GetJObj()->mtx[1][3] ;
		temp.z = Search->HeadJObj->GetJObj()->mtx[2][3] ;
		GetScreenPosition( &temp, &Search->Point ) ;
		for( int i = 0 ; i < BACK_PNUM ; i ++ )
			Search->BackPoint[i] = Search->Point ;
		
		Search->sx = BURE_SIZE * rand() / RAND_MAX - BURE_SIZE / 2.0F ;
		Search->sy = BURE_SIZE * rand() / RAND_MAX - BURE_SIZE / 2.0F ;
	}

	// I
	return Effect ;
}

// T[``̃GtFNǧns
extern s8 ReleaseSearchEffect( EFFECT *Effect )
{
	SEARCHEFFECT *Search = ( SEARCHEFFECT * )Effect->Data ;

#ifdef __MODE2
	SubSearchID( Search->RenderID ) ;
#endif

	// ɂ邱ƂȂ
	return 0 ;
}

// T[``̃GtFNgPt[
extern s8 MoveSearchEffect( EFFECT *Effect )
{
	SEARCHEFFECT *Search = ( SEARCHEFFECT * )Effect->Data ;
	Vec WV ;
	f32 dx, dy, r ;
	Vec temp ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// [hɂď𕪊
	switch( Search->Mode )
	{
	case 0 :
		Search->Mode = 1 ;
		break ;
		
	case 1 :
		{
			// Wɋ߂Â鏈

			// W𓾂
			temp.x = Search->HeadJObj->GetJObj()->mtx[0][3] ;
			temp.y = Search->HeadJObj->GetJObj()->mtx[1][3] ;
			temp.z = Search->HeadJObj->GetJObj()->mtx[2][3] ;

			// WQcɕϊ
			GetScreenPosition( &temp, &WV ) ; 

			// Wړ
			memmove( &Search->BackPoint[0], &Search->BackPoint[1], sizeof( Vec ) * ( BACK_PNUM -1 ) ) ;
			Search->BackPoint[BACK_PNUM -1] = Search->Point ;

			// ړ
			dx = WV.x - Search->Point.x ;
			dy = WV.y - Search->Point.y ;
			r = sqrt( dx * dx + dy * dy ) ;
		//	if( r > 16 )
			{
				Search->Point.x += Search->sx ;
				Search->Point.y += Search->sy ;

				// 𓾂
				dx = WV.x - Search->Point.x ;
				dy = WV.y - Search->Point.y ;
				r = sqrt( dx * dx + dy * dy ) ;
				dx /= r ;
				dy /= r ;

				// ɌĈړ͕ύX
				Search->sx /= Search->Skill ;
				Search->sy /= Search->Skill ;
				Search->sx += dx * Search->Speed * ( r / 10.0F ) ;
				Search->sy += dy * Search->Speed * ( r / 10.0F ) ;
			}
			
			// ߂ꍇ̂݃uo
			if( r < 16 )
			{
				Search->Point.x += cos( PI_2 / 180 * Search->Counter ) * 1 ;
				Search->Point.y += sin( PI_2 / 80 * Search->Counter ) * 0.5F ;
				
				// ɂԂ
				if( ( rand() - 1 ) * VParam[ED_SEARCH][0] / RAND_MAX == 0 )
				{
					Search->Point.x += rand() * ( VParam[ED_SEARCH][1] * 0.1F ) / RAND_MAX - ( VParam[ED_SEARCH][1] >> 1 ) * 0.1F ;
					Search->Point.y += rand() * ( VParam[ED_SEARCH][1] * 0.1F ) / RAND_MAX - ( VParam[ED_SEARCH][1] >> 1 ) * 0.1F ;
				}
			}
			
			// JE^܂킷
			Search->Counter ++ ;
		}
		break ;
		
	case 2 :
		DeleteEffect( Effect ) ;
		return 0 ;
		break ;
	}

	// I
	return 0 ;
}
	
// T[``̃GtFNg`悷
extern s8 DrawSearchEffect( EFFECT *Effect )
{
#ifdef __MODE2
	Effect = Effect ;
	return 0 ;
#else
	SEARCHEFFECT *Search = ( SEARCHEFFECT * )Effect->Data ;
	SEARCHUNION *SearchUnion = &SarUnion ;
//	int i ;
	u8 r, g, b, a ; 
	f32 Size ;
	Vec HV, WV, temp ;
	f32 Height, /*rr,*/ dx, dy, dz ;

	if( Search->DrawFlag == FALSE ) return 0 ;

	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_USETEX ) ;							// `̏
	GXSetBlendMode(GX_BM_BLEND, GX_BL_ONE, GX_BL_ZERO, GX_LO_SET);									// uh[h̃Zbg	
	GXSetAlphaCompare( GX_GEQUAL, Search->EnemyAlphaL, GX_AOP_AND, GX_LESS, Search->EnemyAlphaH );	// J[̐ݒ

	// TEVݒ
    GXSetNumTevStages(1);
	GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC ) ; 
    GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_TEXA ) ; 
    GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV ) ;

	// W𓾂
	WV.x = Search->WaistJObj->GetJObj()->mtx[0][3] ;
	WV.y = Search->WaistJObj->GetJObj()->mtx[1][3] ;
	WV.z = Search->WaistJObj->GetJObj()->mtx[2][3] ;

	HV.x = Search->HeadJObj->GetJObj()->mtx[0][3] ;
	HV.y = Search->HeadJObj->GetJObj()->mtx[1][3] ;
	HV.z = Search->HeadJObj->GetJObj()->mtx[2][3] ;
	
	// 𓾂
	{
		dx = WV.x - HV.x ;
		dy = WV.y - HV.y ;
		dz = WV.z - HV.z ;
		Height = sqrt( dx * dx + dy * dy + dz * dz ) ;
		
		Height *= 2.1F ;
	}
	Height = GetScreenSize( &WV, Height ) ;
	
	// TCY擾
	Size = GetScreenSize( &WV, Search->BaseSize ) ;
//	Height = Size * 7.0F ;
	
	// WQcɕϊ
	GetScreenPosition( &WV, &temp ) ; WV = temp ;
	GetScreenPosition( &HV, &temp ) ; HV = temp ;
	
   	// eNX`̃[h
	GTLOAD( screenImageFullColor.GetTexObj() ) ;

	// `揈
	GBGN( GX_QUADS, 4 ) ;
	{
		Mtx *HMtx, *WMtx ;
		r = 80 ;
		g = 0 ;
		b = 0 ;
		a = 0 ;
		
		Height -= fabs( HV.y - WV.y ) * 0.3F ;
		Size += fabs( HV.y - WV.y ) * 0.3F ;

		HMtx = &Search->HeadJObj->GetJObj()->mtx ;
		WMtx = &Search->WaistJObj->GetJObj()->mtx ;

		GP2( Search->Point.x, Search->Point.y - Height / 5.0F ) ;
		GC4( r, g, b, a ) ; GT( Search->Point.x / WK7_SCREEN_WIDTH, ( Search->Point.y - Height / 5.0F ) / WK7_SCREEN_HEIGHT ) ;
		GP2( Search->Point.x + Size, Search->Point.y - Height / 5.0F ) ;
		GC4( r, g, b, a ) ; GT( ( Search->Point.x + Size ) / WK7_SCREEN_WIDTH, ( Search->Point.y - Height / 5.0F ) / WK7_SCREEN_HEIGHT ) ;
		GP2( Search->Point.x + Size, Search->Point.y + Height ) ;
		GC4( 0, 0, 0, 0 ) ; GT( ( Search->Point.x + Size ) / WK7_SCREEN_WIDTH, ( Search->Point.y + Height ) / WK7_SCREEN_HEIGHT ) ;
		GP2( Search->Point.x, Search->Point.y + Height ) ;
		GC4( 0, 0, 0, 0 ) ; GT( ( Search->Point.x ) / WK7_SCREEN_WIDTH, ( Search->Point.y + Height ) / WK7_SCREEN_HEIGHT ) ;
	}
	GXEnd() ;

    GXSetTevOp(GX_TEVSTAGE0, GX_MODULATE );

	// I
	return 0 ;
#endif
}

// T[``GtFNg`悷邩ǂZbg
extern s8 SetSearchEffectRenderFlag( EFFECT *Effect, s8 Flag )
{
	SEARCHEFFECT *Search = ( SEARCHEFFECT * )Effect->Data ;
	
	Search->DrawFlag = (u8)Flag ;
	
	// I
	return 0 ;
}
	
// 폜NGXgs
extern s8 DelReqSearchEffect( EFFECT *Effect )
{
	SEARCHEFFECT *Search = ( SEARCHEFFECT * )Effect->Data ;
	
	// [h폜Ԃɂ
	Search->Mode = 2 ;
	Search->Counter = 0 ;
	
	// I
	return 0 ;
}
	
