///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectShutter
//
// YK7EffectShutter.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/06/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectShutter.h"

// define ---------------------------------------

#define CIR_DIVNUM			30				// ~̕		

// datatype -------------------------------------

// data -----------------------------------------

SHUTTERUNION ShtUnion ;

// function code --------------------------------

// Vb^[GtFNg̋ʃf[^
extern s8 InitShutterData( void )
{
	MEMINIT( ShtUnion ) ;

	// I
	return 0 ;
}

// Vb^[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckShutterData( void )
{
	return TRUE ;
}

// Vb^[GtFNg̋ʃf[^n
extern s8 EndShutterData( void )
{
	MEMINIT( ShtUnion ) ;

	// I
	return 0 ;
}


// Vb^[̃GtFNg쐬
extern EFFECT *CreateShutterEffect( u8 CloseTime, u8 CloseWait, u8 OpenTime, u8 Mode, s8 AutoOpenFlag, s32 Priority )
{
	SHUTTEREFFECT *st ;
	EFFECT *Effect ;
	
	// VVb^[f[^쐬
	Effect = AddEffectData( EFF_SHUTTER, (void**)&st, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// Vb^[f[^
	st->CloseTime = CloseTime ;
	st->CloseWait = CloseWait ;
	st->OpenTime = OpenTime ;
	st->Mode = Mode ;
	st->StartMode = 0 ;
	st->TargetMode = Mode ;
	st->NextMode = -1 ;
	st->AutoOpenFlag = AutoOpenFlag ;

	st->State = 0 ;
	st->Counter = 0 ;

	// I
	return Effect ;
}

// Vb^[̃GtFNǧns
extern s8 ReleaseShutterEffect( EFFECT *Effect )
{
	SHUTTEREFFECT *Shutter = ( SHUTTEREFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// Vb^[̃GtFNgPt[
extern s8 MoveShutterEffect( EFFECT *Effect )
{
	SHUTTEREFFECT *st = ( SHUTTEREFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		if( st->State == 3 && st->StartMode == 0 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		else
		{
			if( st->State == 3 && st->StartMode != 0 )
			{
				st->TargetMode = 0 ;
				st->State = 0 ;
				st->Counter = 0 ;
			}
		}
	}

	// JE^[̃CNg
	switch( st->State )
	{
	case 0 :			// ܂Ăr
		st->NextMode = -1 ;
		st->Counter ++ ;
		st->CloseRate = (f32)st->Counter / st->CloseTime ;
		if( st->Counter >= st->CloseTime )
		{
			st->CloseRate = 1.0F ;
			st->State ++ ;
			st->Counter = 0 ;
		}
		break ;

	case 1 :			// ܂҂
		if( st->AutoOpenFlag == TRUE )
		{
			st->Counter ++ ;
			st->CloseRate = 1.0F ;
			if( st->Counter >= st->CloseWait )
			{
				st->State ++ ;
				st->Counter = 0 ;
			}
		}
		break ;
		
	case 2 :			// J҂
		st->Counter ++ ;
		st->CloseRate = 1.0F - (f32)st->Counter / st->OpenTime ;
		if( st->Counter >= st->OpenTime )
		{
			// 폜
			if( st->Mode == 0 )
			{
				DeleteEffect( Effect ) ;
				return 0 ;
			}
			else
			{
				st->StartMode = st->TargetMode ;
				if( st->NextMode == -1 )
				{
					st->State ++ ;
				}
				else
				{
					st->TargetMode = (u8)st->NextMode ;
					st->State = 0 ;
					st->Counter = 0 ;
				}
			}
		}
		break ;
		
	case 3 : break ;
	}
	
	// I
	return 0 ;
}
	
// Vb^[̃GtFNg`悷
extern s8 DrawShutterEffect( EFFECT *Effect )
{
	SHUTTEREFFECT *st = ( SHUTTEREFFECT * )Effect->Data ;
	f32 top, bottom ;

	//VUO͈̔͐ݒ(!?)
	GXSetScissor( 0, 0, SCW, SCH );

	//r[|[g̐ݒ
	GXSetViewport( 0.0f, 0.0f, (f32)K7APP_SCREEN_WIDTH, (f32)K7APP_SCREEN_HEIGHT, 0.0f, 1.0f );
	
	// `̏
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_NONE, EF_TEV_NOTEX ) ;
	
	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA4, 0 ) ;
	
	switch( st->State )
	{
	case 0 :
		if( st->StartMode == 0 )
		{
			top = SCH / 2 * st->CloseRate ;
			bottom = SCH - SCH / 2 * st->CloseRate ;
		}
		else
		{
			top = ( SCH / 2 - VParam[ED_SHUTTER][3] ) * st->CloseRate + VParam[ED_SHUTTER][3] ;
			bottom = SCH - ( ( SCH / 2 - VParam[ED_SHUTTER][4] ) * st->CloseRate + VParam[ED_SHUTTER][4] ) ;
		}
		break ;
		
	case 1 :
		top = SCH / 2 ;
		bottom = SCH / 2 ;
		break ;
		
	case 2 :
		if( st->TargetMode == 0 )
		{
			top = SCH / 2 * st->CloseRate ;
			bottom = SCH - SCH / 2 * st->CloseRate ;
		}
		else
		{
			top = ( SCH / 2 - VParam[ED_SHUTTER][3] ) * st->CloseRate + VParam[ED_SHUTTER][3] ;
			bottom = SCH - ( ( SCH / 2 - VParam[ED_SHUTTER][4] ) * st->CloseRate + VParam[ED_SHUTTER][4] ) ;
		}
		break ;
		
	case 3 :
		if( st->TargetMode == 0 )
		{
			top = 0.0F ;
			bottom = SCH ;
		}
		else
		{
			top = VParam[ED_SHUTTER][3] ;
			bottom = SCH - VParam[ED_SHUTTER][4] ;
		}
		break ;
	}

	// `揈
	{
		u16 h, Color ;

		h = (u16)( st->CloseRate * ( SCH / 2.0F ) ) ;
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)8 ) ;
		{
			Color = GXPackedRGBA4( 0, 0, 0, 255 ) ;

			GP2( 0, 	0 ) ; 	GXColor1u16( Color ) ;
			GP2( SCW, 	0 ) ; 	GXColor1u16( Color ) ;
			GP2( SCW, 	top ) ;	GXColor1u16( Color ) ;
			GP2( 0, 	top ) ;	GXColor1u16( Color ) ;

			GP2( 0, 	bottom ) ; 	GXColor1u16( Color ) ;
			GP2( SCW, 	bottom ) ; 	GXColor1u16( Color ) ;
			GP2( SCW, 	SCH ) ; 	GXColor1u16( Color ) ;
			GP2( 0, 	SCH ) ; 	GXColor1u16( Color ) ;
		}
		GXEnd() ;
	}

	// I
	return 0 ;
}

// Vb^[̏Ԃ擾( 0:Vb^[͕܂肫Ă  1:Vb^[͊JĂ )
extern s8 GetShutterState( EFFECT *Effect )
{
	SHUTTEREFFECT *st = ( SHUTTEREFFECT * )Effect->Data ;
	
	return (s8)( st->State == 1 ? 0 : 1 ) ;
}

// Vb^[̊J[h؂ւ
extern s8 ChangeSutterOpneType( EFFECT *Effect )
{
	SHUTTEREFFECT *st = ( SHUTTEREFFECT * )Effect->Data ;
	
	st->NextMode = (s8)( st->TargetMode == 0 ? 1 : 0 ) ;

	if( st->State == 3 )
	{
		st->TargetMode = (u8)st->NextMode ;
		st->State = 0 ;
		st->Counter = 0 ;
	}

	// I
	return 0 ;
}

// Vb^[ŊJݒɂĂȂꍇÅ֐ŊJ
extern s8 OpenShutterEffect( EFFECT *Effect )
{
	SHUTTEREFFECT *st = ( SHUTTEREFFECT * )Effect->Data ;
	
	st->AutoOpenFlag = TRUE ;
	st->CloseWait = 0 ;
	
	// I
	return 0 ;
}




