///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSight
//
// YK7EffectSight.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/23/2003
//
//////////////////////////////////////////////////////////////////////////////

#define __MODE2

#define	__YK7TESTTASK_CPP__
//#define __TEXCOORD

// include --------------------------------------
#include "./YK7EffectSight.h"
#include "../Wat/WK7MainTask.h"
#include "./YK7EffectRotLight.h"
#include "./YK7EffectCentLight.h"
#include "../Wat/WK7Player.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define PAN_WAIT		0.5F
#define SHOT_WAIT		0.2F
#define NOBURE

#define BACK_POINTNUM	10
//#define BACK_POINTNUM	3

#define SIGHT_TEXPATH		"/Yam/Effect/Sight/Aim.BIN"
#define ARC_PATH			"/Yam/Effect/Sight/arc.BIN"
#define CIRCLE_PATH			"/Yam/Effect/Sight/circle.BIN"
#define SIGHT_PATH			"/Yam/Effect/Sight/sight.BIN"
#define CENTER_PATH			"/Yam/Effect/Sight/center.BIN"
#define CROSS_PATH			"/Yam/Effect/Sight/cross.BIN"
#define GRAD_PATH			"/Yam/Effect/Sight/grad.BIN"

#define ALLFRAME		(10)
#define CENTERALPHA		(0.70F)
#define SIGHTALPHA		(0.35F)
#define SIGHTSCALE		(0.34F)
#define SIGHTROT		(PI)

// datatype -------------------------------------

// data -----------------------------------------

SIGHTUNION SigUnion ;

static u32 SearchTable[20] ;
static u32 SearchNum ;

// function proto type --------------------------

static void __DrawSight( SIGHTEFFECT *sg, f32 x, f32 y ) ;			 // TCg`֐

// function code --------------------------------

extern void AddSearchID( u32 ID )
{
	SearchTable[SearchNum] = ID ;
	SearchNum ++ ;
}

extern void SubSearchID( u32 ID )
{
	s32 i ;
	
	for( i = 0 ; i < 20 && SearchTable[i] != ID ; i ++ ){}
	if( i == 20 )
		return ;
	memmove( &SearchTable[i], &SearchTable[i+1], sizeof( u32 ) * ( SearchNum - i - 1 ) ) ;
	SearchNum -- ;
}


#define WAKUW	SIG_WAKUW
#define WAKUH	SIG_WAKUH
#define WAKUX	SIG_X 
#define WAKUY	SIG_Y
#define WAKUCX	(SCW / 2) 
#define WAKUCY	(SCH / 2)
#define WAKUX2	( SIG_X + SIG_W ) 
#define WAKUY2	( SIG_Y + SIG_H )
#define WAKUL	8

#define SENL	3
#define SENS	8
#define SENP	(0.1F)
#define SENS2	24

#define SENL2	18
#define SENW2	6
#define SENL3	(3 * 2 + SENW2 * 2)

#define SUK		4

// sight color table
static const GXColor __sgct[6][5] =
{
	{ 148,74,37,255, 30,15,8,255, 171,86,43,255, 52,25,13,255, 255,128,64,255 },	// xO
	{ 148,37,46,255, 30,8,10,255, 177,43,53,255, 52,13,17,255, 255,64,80,255  },	// xP
	{ 144,40,109,255,29,8,22,255, 166,47,126,255,50,14,39,255, 236,60,177,255 },	// xQ
	{ 40,40,144,255, 9,9,28,255,  62,52,161,255, 16,17,49,255, 20,150,250/*54,54,217*/,255  },	// xR
	{ 75,144,40,255, 16,28,9,255, 88,161,52,255, 28,49,16,255, 107,217,54,255 },	// xS
	{ 144,118,40,255,29,23,8,255, 166,136,47,255,50,40,14,255, 238,193,60,255 },	// xT
} ;

// sight length table
static const u16 __slt[6] =
{
	0,			// xO
	30,			// xP
	60,			// xQ
	90,			// xR
	120,		// xS
	150,		// xT
} ;

// TCg`֐
static void __DrawSight( SIGHTEFFECT *sg, f32 x, f32 y, f32 aaa )
{
	u32 _cr ;
	
	x = x ;
	y = y ;

	// `̏
	EffectRenderSetup( EF_PROJECT_ORTHO,
						EF_BLEND_ALPHA,
						EF_TEV_NOTEX ) ;
	GXSetLineWidth( 12, GX_TO_ONE ) ;
	
	{
		u32 cr, cr2 ;
		u32 c1, c2, c3, c4 ;
		u32 c01, c02, c03, c04 ;	
		s32 lv, len ;
		f32 ad, ad2, ad3 ;

		u32 ccr, ccr2, len2 ;
		
#ifdef YAMADADEBUG
	#if 1
		lv = sg->chargelevel ;
	#else
		lv = VParam[ED_CHARGE2][0]/*(WK7PLAYERCONTROL->GetChargeSetUpLv())*/ ;
	#endif
#else
		lv = sg->chargelevel ;
#endif
		ad2 = 10.0F ;
		ad3 = 5.0F ;
		ad = lv * 2 ;
		len = __slt[lv] ;
		
/*
		c1 = CMK( 148, 74, 37, 255 ) ;
		c2 = CMK( 30, 15, 8, 255 ) ;
		c3 = CMK( 171, 86, 43, 255 ) ;
		c4 = CMK( 52, 25, 13, 255 ) ;

		c01 = CMK( 148, 74, 37, 0 ) ;
		c02 = CMK( 30, 15, 8, 0 ) ;
		c03 = CMK( 171, 86, 43, 0 ) ;
		c04 = CMK( 52, 25, 13, 0 ) ;
*/
		c1 = CMK( __sgct[lv][0].r, __sgct[lv][0].g, __sgct[lv][0].b, 255 ) ;
		c2 = CMK( __sgct[lv][1].r, __sgct[lv][1].g, __sgct[lv][1].b, 255 ) ;
		c3 = CMK( __sgct[lv][2].r, __sgct[lv][2].g, __sgct[lv][2].b, 255 ) ;
		c4 = CMK( __sgct[lv][3].r, __sgct[lv][3].g, __sgct[lv][3].b, 255 ) ;
		cr = CMK( __sgct[lv][4].r, __sgct[lv][4].g, __sgct[lv][4].b, 255 ) ;

		c01 = c1 & 0xffffff00 ;
		c02 = c2 & 0xffffff00 ;
		c03 = c3 & 0xffffff00 ;
		c04 = c4 & 0xffffff00 ;
		cr2 = cr & 0xffffff00 ;

		if( sg->brinkcon == 0 )
		{
			ccr = cr ;
			ccr2 = cr2 ;
			sg->brinkcon = 1 ;
			len2 = (u32)len ;
		}
		else
		{
			ccr = CMKC2( cr, ( cr & 0xff ) * 0.5F ) ;
			ccr2 = CMKC2( cr2, ( cr2 & 0xff ) * 0.5F ) ;
			sg->brinkcon = 0 ;
			len2 = (u32)( (f32)len * 0.5F ) ;
		} 
		
		EffectBlendModeSetup( EF_BLEND_ADD ) ;
		GXSetLineWidth( (u8)6, GX_TO_ONE ) ;

		GBGN( GX_LINES, 88 ) ;
		// c̃C
		DrawLine2NB( 318, 15, c02, 318, 115, c2 ) ;		DrawLineNB( 318, 115, 318, 221, c2 ) ;
		DrawLine2NB( 319, 15, c01, 319, 115, c1 ) ;		DrawLineNB( 319, 115, 319, 221, c1 ) ;
		DrawLine2NB( 320, 15, c01, 320, 115, c1 ) ;		DrawLineNB( 320, 115, 320, 221, c1 ) ;
		DrawLine2NB( 321, 15, c02, 321, 115, c2 ) ;		DrawLineNB( 321, 115, 321, 221, c2 ) ;

		DrawLineNB( 318, 268, 318, 336, c2 ) ;	DrawLine2NB( 318, 336, c2, 318, 480, c02 ) ;
		DrawLineNB( 319, 268, 319, 336, c1 ) ;	DrawLine2NB( 319, 336, c1, 319, 480, c01 ) ;
		DrawLineNB( 320, 268, 320, 336, c1 ) ;	DrawLine2NB( 320, 336, c1, 320, 480, c01 ) ;
		DrawLineNB( 321, 288, 321, 336, c2 ) ;	DrawLine2NB( 321, 336, c2, 321, 480, c02 ) ;
		
		// ̃C
		DrawLine2NB( 192, 238, c02, 270, 238, c2 ) ;	DrawLineNB( 270, 238, 297, 238, c2 ) ;
		DrawLine2NB( 192, 239, c01, 270, 239, c1 ) ;	DrawLineNB( 270, 239, 297, 239, c1 ) ;
		
		DrawLine2NB( 192, 240, c01, 270, 240, c1 ) ;	DrawLineNB( 270, 240, 297, 240, c1  ) ;
		DrawLine2NB( 192, 241, c02, 270, 241, c2 ) ;	DrawLineNB( 270, 241, 297, 241, c2  ) ;

		DrawLineNB( 339, 238, 365, 238, c2 ) ;	DrawLine2NB( 365, 238, c2, 457, 238, c02 ) ;
		DrawLineNB( 339, 239, 365, 239, c1 ) ;	DrawLine2NB( 365, 239, c1, 457, 239, c01 ) ;

		DrawLineNB( 339, 240, 365, 240, c1 ) ;	DrawLine2NB( 365, 240, c1, 457, 240, c01 ) ;
		DrawLineNB( 339, 241, 365, 241, c2 ) ;	DrawLine2NB( 366, 241, c2, 457, 241, c02 ) ;
		
		// ΂߂̃C
		DrawLineNB( 300, 260, 275, 285, c4 ) ;		DrawLine2NB( 275, 285, c4, 227, 333, c04 ) ;
		DrawLineNB( 301, 260, 275, 286, c3 ) ;		DrawLine2NB( 275, 286, c3, 227, 334, c03 ) ;
		DrawLineNB( 302, 260, 275, 287, c4 ) ;		DrawLine2NB( 275, 287, c4, 227, 335, c04 ) ;
		
		DrawLineNB( 338, 260, 366, 286, c4 ) ;		DrawLine2NB( 366, 286, c4, 413, 333, c04 ) ;
		DrawLineNB( 339, 260, 366, 287, c3 ) ;		DrawLine2NB( 366, 287, c3, 413, 334, c03 ) ;
		DrawLineNB( 340, 260, 366, 288, c4 ) ;		DrawLine2NB( 366, 288, c4, 413, 335, c04 ) ;
		GEND() ;
		
		GBGN( GX_QUADS, 4 * 12 ) ;
		{
			// c̃Of[V
			DrawGradBoxLRNB( 318 - ad, 	15,		318, 		115, ccr2, ccr ) ;
			DrawGradBoxLRNB( 318, 		15,		318 + ad, 	115, ccr, ccr2 ) ;

			DrawGradBoxLRNB( 318 - ad, 	115,	318, 		221, ccr2, ccr ) ;
			DrawGradBoxLRNB( 318, 		115,	318 + ad, 	221, ccr, ccr2 ) ;


			DrawGradBoxLRNB( 318 - ad, 	268,	318, 		336, ccr2, ccr ) ;
			DrawGradBoxLRNB( 318, 		268,	318 + ad, 	336, ccr, ccr2 ) ;

			DrawGradBoxLRNB( 318 - ad, 	336,	318, 		480, ccr2, ccr ) ;
			DrawGradBoxLRNB( 318, 		336,	318 + ad, 	480, ccr, ccr2 ) ;
			
			// ̃Of[V
//			DrawGradBoxNB(		192 - len2,	239 - ad,	270,		239,		0, ccr2, ccr, 0 ) ;
//			DrawGradBoxNB(		192 - len2,	240,		270,		240 + ad,	0, ccr, ccr2, 0 ) ;

			DrawGradBoxTBNB(	270,		238 - ad,	297,		238,		ccr2, ccr ) ;
			DrawGradBoxTBNB(	270,		238,		297,		238 + ad,	ccr, ccr2 ) ;


			DrawGradBoxTBNB(	339,		238 - ad,	365,		238,		ccr2, ccr ) ;
			DrawGradBoxTBNB(	339,		238,		365,		238 + ad,	ccr, ccr2 ) ;

//			DrawGradBoxNB(		365,		239 - ad,	457 + len2,	239,		ccr2, 0, 0, ccr ) ;
//			DrawGradBoxNB(		365,		240,		457 + len2,	240 + ad,	ccr,  0, 0, ccr2 ) ;
		}
		GEND() ;
		
//		DrawBox( 	318 - ad, 	221 - ad2,	318, 		221,	0xffffffff ) ;
//		DrawBox( 	318, 		221 - ad2,	318 + ad, 	221,	0xff0000ff ) ;

		EffectTevSetup( EF_TEV_USETEX ) ;
		GTLOAD2( SigUnion.gradTex ) ;
		
		// Of[V
		GBGN( GX_QUADS, 4 * 12 ) ;
		{
//			DrawTex6NB( 	318 - ad, 	221 - ad2,	318, 		221,	1.0F, 0.0F, 0.0F, 1.0F, ccr2, ccr, ccr, ccr2 ) ;
//			DrawTex6NB( 	318, 		221 - ad2,	318 + ad, 	221,	1.0F, 0.0F, 0.0F, 1.0F, ccr, ccr2, ccr2, ccr ) ;
			DrawTex6NB( 	318 - ad, 	221,	318, 		221 + ad2,	1.0F,0.0F, 1.0F,0.0F, 0.0F,0.0F,0.0F,0.0F, ccr2, ccr, ccr, ccr2 ) ;
			DrawTex6NB( 	318, 		221,	318 + ad, 	221 + ad2,	1.0F,0.0F, 1.0F,0.0F, 0.0F,0.0F,0.0F,0.0F, ccr, ccr2, ccr2, ccr ) ;

			DrawTex6NB(		318 - ad, 	268 - ad2,	318, 		268,	0.0F,0.0F, 0.0F,0.0F, 1.0F,0.0F,1.0F,0.0F, ccr2, ccr, ccr, ccr2 ) ;
			DrawTex6NB( 	318, 		268 - ad2,	318 + ad, 	268,	0.0F,0.0F, 0.0F,0.0F, 1.0F,0.0F,1.0F,0.0F, ccr, ccr2, ccr2, ccr ) ;
			
			
			DrawTex6NB(		297,	238 - ad,	297 + ad2,	238,		1.0F, 0.0F, 0.0F, 0.0F, 1.0F, 0.0F, 0.0F, 0.0F, ccr2, ccr2, ccr, ccr ) ;
			DrawTex6NB(		297,	238,		297 + ad2,	238 + ad,	1.0F, 0.0F, 0.0F, 0.0F, 1.0F, 0.0F, 0.0F, 0.0F, ccr, ccr, ccr2, ccr2 ) ;
			
			DrawTex6NB(		339 - ad2,	238 - ad,	339,	238,		0.0F, 0.0F, 1.0F, 0.0F, 0.0F, 0.0F, 1.0F, 0.0F, ccr2, ccr2, ccr, ccr ) ;
			DrawTex6NB(		339 - ad2,	238,		339,	238 + ad,	0.0F, 0.0F, 1.0F, 0.0F, 0.0F, 0.0F, 1.0F, 0.0F, ccr, ccr, ccr2, ccr2 ) ;
			

			DrawTex6NB(		192 - len2,	238 - ad,	270,		238,		0.0F, 0.0F, 1.0F, 0.0F, 0.0F, 0.0F, 1.0F, 0.0F, ccr2, ccr2, ccr, ccr ) ;
			DrawTex6NB(		192 - len2,	238,		270,		238 + ad,	0.0F, 0.0F, 1.0F, 0.0F, 0.0F, 0.0F, 1.0F, 0.0F, ccr, ccr, ccr2, ccr2 ) ;

			DrawTex6NB(		365,		238 - ad,	457 + len2,	238,		1.0F, 0.0F, 0.0F, 0.0F, 1.0F, 0.0F, 0.0F, 0.0F, ccr2, ccr2, ccr, ccr ) ;
			DrawTex6NB(		365,		238,		457 + len2,	238 + ad,	1.0F, 0.0F, 0.0F, 0.0F, 1.0F, 0.0F, 0.0F, 0.0F, ccr, ccr, ccr2, ccr2 ) ;
		}
		GEND() ;

//		u32 cr = CMK( 255, 128, 64, 255 ) ;

#define ADX		(-1.25F)

		TEXDATA *TEX = &SigUnion.circleTex ;
		GhmGcTexHeader *h = TEX->Data.Header ;
		f32 W = h->mWidth, H = h->mHeight ;
		
//		EffectTexColorIgnoreSetup( TRUE ) ;

		_cr = sg->circlecolorf == false ? cr : sg->circlecolor ;
		
		DrawTex( 272 + ADX - 1, 192, TEX, _cr ) ;
		DrawTex3( 320 + W + ADX, 	192, 		320 + ADX, 			192 + H, 	TEX, _cr ) ;
		DrawTex3( 272 + ADX - 1, 	240 + H, 	272 + W + ADX - 1,	240, 		TEX, _cr ) ;
		DrawTex3( 320 + W + ADX,	240 + H, 	320 + ADX,			240, 		TEX, _cr ) ;

		TEX = &SigUnion.arcTex ;
		h = TEX->Data.Header ;
		W = h->mWidth ; H = h->mHeight ;
		GTLOAD2( *TEX ) ;
		GBGN( GX_QUADS, 8 ) ;
		GP2( 120, 0 ) ; 	GCX( CMKC2( cr, 00.0F / 100.0F * 255 ) ) ; 	GT( 0.0F, 0.0F ) ;
		GP2( 120 + W, 0 ) ;	GCX( CMKC2( cr, 00.0F / 100.0F * 255 ) ) ; 	GT( 1.0F, 0.0F ) ;
		GP2( 120 + W, H ) ;	GCX( CMKC2( cr, 48.0F / 100.0F * 255 ) ) ;	GT( 1.0F, 1.0F ) ;
		GP2( 120, H ) ; 	GCX( CMKC2( cr, 48.0F / 100.0F * 255 ) ) ;	GT( 0.0F, 1.0F ) ;

		GP2( 320 + W, 0 ) ; GCX( CMKC2( cr, 00.0F / 100.0F * 255 ) ) ; 	GT( 0.0F, 0.0F ) ;
		GP2( 320, 0 ) ;		GCX( CMKC2( cr, 00.0F / 100.0F * 255 ) ) ; 	GT( 1.0F, 0.0F ) ;
		GP2( 320, H ) ;		GCX( CMKC2( cr, 48.0F / 100.0F * 255 ) ) ;	GT( 1.0F, 1.0F ) ;
		GP2( 320 + W, H ) ; GCX( CMKC2( cr, 48.0F / 100.0F * 255 ) ) ;	GT( 0.0F, 1.0F ) ;
		GEND() ;		

		TEX = &SigUnion.sightTex ;
		h = TEX->Data.Header ;
		W = h->mWidth ; H = h->mHeight ;
		f32 sc ;
		
		sc = 0.3F + 0.4F * ( 1.0F - aaa ) ;
		DrawRotTex( 320 + ADX, 240, PI, sc, TEX, CMKC2( cr, aaa * 255 ) ) ;
		
		sc = 1.0F - aaa * SIGHTSCALE ;
		DrawRotTex( 320 + ADX, 240, aaa * ( PI + PI / 180.0F ) - PI / 180.0F, sc, TEX, CMKC2( cr, ( SIGHTALPHA + aaa * ( 1.0F - SIGHTALPHA ) ) * 255 ) ) ;

		_cr = sg->centcolorf == false ? cr : sg->centcolor ;
		
		TEX = &SigUnion.centerTex ;
		h = TEX->Data.Header ;
		W = h->mWidth ; H = h->mHeight ;

		TEX = &SigUnion.crossTex ;
		h = TEX->Data.Header ;
		W = h->mWidth ; H = h->mHeight ;
		
		DrawTex3( 	320 - W / 2 + ADX, 240 - H / 2,
					320 + W / 2 + ADX, 240 + H / 2, TEX, _cr ) ;
	}
}


// ƏGtFNg̋ʃf[^
extern s8 InitSightData( void )
{
	MEMINIT( SigUnion ) ;
	
	MEMINIT( SearchTable ) ;
	SearchNum = 0 ;

	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_SIGHT )->GetResource( STDAT_SIG_sight ), &SigUnion.SightTex ) ;

	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_SIGHT )->GetResource( STDAT_SIG_arc ), &SigUnion.arcTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_SIGHT )->GetResource( STDAT_SIG_circle ), &SigUnion.circleTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_SIGHT )->GetResource( STDAT_SIG_sight ), &SigUnion.sightTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_SIGHT )->GetResource( STDAT_SIG_center ), &SigUnion.centerTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_SIGHT )->GetResource( STDAT_SIG_cross ), &SigUnion.crossTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_SIGHT )->GetResource( STDAT_SIG_grad ), &SigUnion.gradTex ) ;
	
//	TexLoadSet( SIGHT_TEXPATH, &SigUnion.SightTex ) ;

//	TexLoadSet( ARC_PATH, &SigUnion.arcTex ) ;
//	TexLoadSet( CIRCLE_PATH, &SigUnion.circleTex ) ;
//	TexLoadSet( SIGHT_PATH, &SigUnion.sightTex ) ;
//	TexLoadSet( CENTER_PATH, &SigUnion.centerTex ) ;
//	TexLoadSet( CROSS_PATH, &SigUnion.crossTex ) ;
//	TexLoadSet( GRAD_PATH, &SigUnion.gradTex ) ;
	
	// I
	return 0 ;
}

// ƏGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSightData( void )
{
//	if( TexLoadChk( &SigUnion.SightTex ) == FALSE ) return FALSE ;

//	if( TexLoadChk( &SigUnion.arcTex ) == FALSE ) return FALSE ;
//	if( TexLoadChk( &SigUnion.circleTex ) == FALSE ) return FALSE ;
//	if( TexLoadChk( &SigUnion.sightTex ) == FALSE ) return FALSE ;
//	if( TexLoadChk( &SigUnion.centerTex ) == FALSE ) return FALSE ;
//	if( TexLoadChk( &SigUnion.crossTex ) == FALSE ) return FALSE ;
//	if( TexLoadChk( &SigUnion.gradTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}

// ƏGtFNg̋ʃf[^n
extern s8 EndSightData( void )
{
	TexRelease( &SigUnion.SightTex ) ;

	TexRelease( &SigUnion.arcTex ) ;
	TexRelease( &SigUnion.circleTex ) ;
	TexRelease( &SigUnion.sightTex ) ;
	TexRelease( &SigUnion.centerTex ) ;
	TexRelease( &SigUnion.crossTex ) ;
	TexRelease( &SigUnion.gradTex ) ;

	MEMINIT( SigUnion ) ;
	
	// I
	return 0 ;
}

// ƏGtFNg쐬
extern EFFECT *CreateSightEffect( Vec Point, u8 MaxShotNum, u8 ShotNum, u8 SightType, s32 Priority )
{
	Vec ObjectVec[2] = { 0.0F, 0.0F, 0.0F };
	GXColor Color = { 128, 128, 255, 40 } ;

	if( SightType == SIGHT_TYPE_DAN )
	{
		Color.r = (u8)VParam[ED_SIGHT][5] ;
		Color.g = (u8)VParam[ED_SIGHT][6] ;
		Color.b = (u8)VParam[ED_SIGHT][7] ;
		Color.a = 0 ;
		
		return CreateSightEffect2( 0, 1, ObjectVec, 
									Color, Point, VParam[ED_SIGHT][8] * 0.1F,
									 VParam[ED_SIGHT][9], VParam[ED_SIGHT][10] * 0.01F, VParam[ED_SIGHT][11] * 0.01F,
									 VParam[ED_SIGHT][12], VParam[ED_SIGHT][13],
									 VParam[ED_SIGHT][14], VParam[ED_SIGHT][15], FALSE,
									 MaxShotNum, ShotNum, VParam[ED_SIGHT][16] * 0.1F, (u8)VParam[ED_SIGHT][17], (u8)VParam[ED_SIGHT][18],
									 (f32)VParam[ED_SIGHT][19] * 0.01F, (f32)VParam[ED_SIGHT][20] * 0.01F,
									 (f32)VParam[ED_SIGHT][21] * 0.01F, (f32)VParam[ED_SIGHT][22] * 0.01F,
									 1.0F, (u8)VParam[ED_SIGHT][23], FALSE,
									 TRUE, TRUE, TRUE, TRUE,
									 TRUE, TRUE, TRUE, TRUE,
									 0.0F,
									 TRUE, SightType, Priority ) ;
	}
	else
	if( SightType == SIGHT_TYPE_CON )
	{
/*		Color.r = (u8)VParam[ED_SIGHT2][0] ;
		Color.g = (u8)VParam[ED_SIGHT2][1] ;
		Color.b = (u8)VParam[ED_SIGHT2][2] ;
*/
		Color.r = (u8)VParam[ED_SIGHT][5] ;
		Color.g = (u8)VParam[ED_SIGHT][6] ;
		Color.b = (u8)VParam[ED_SIGHT][7] ;
		Color.a = 0 ;
		
		ObjectVec[0].x = VParam[ED_SIGHT2][11] - 512 ;
		ObjectVec[0].y = VParam[ED_SIGHT2][12] - 512 ;
		ObjectVec[1].x = VParam[ED_SIGHT2][13] - 512 ;
		ObjectVec[1].y = VParam[ED_SIGHT2][14] - 512 ;

		return CreateSightEffect2( 0, 2, ObjectVec, 
									Color, Point, VParam[ED_SIGHT2][3] * 0.1F,
									 VParam[ED_SIGHT2][4], VParam[ED_SIGHT2][5] * 0.01F, VParam[ED_SIGHT2][6] * 0.01F,
									 VParam[ED_SIGHT2][7], VParam[ED_SIGHT2][8],
									 VParam[ED_SIGHT2][9], VParam[ED_SIGHT2][10], TRUE,
									 MaxShotNum, ShotNum, VParam[ED_SIGHT2][15] * 0.1F, (u8)VParam[ED_SIGHT2][16], (u8)VParam[ED_SIGHT2][17],
									 (f32)VParam[ED_SIGHT2][18] * 0.01F, (f32)VParam[ED_SIGHT2][19] * 0.01F,
									 (f32)VParam[ED_SIGHT2][20] * 0.01F, (f32)VParam[ED_SIGHT2][21] * 0.01F,
									 1.0F, (u8)VParam[ED_SIGHT2][22], FALSE,
									 TRUE, TRUE, FALSE, TRUE,
									 TRUE, FALSE, TRUE, TRUE,
									 0.0F,
									 TRUE, SightType, Priority ) ;
	}
	else
	if( SightType == SIGHT_TYPE_KED )
	{
/*		Color.r = (u8)VParam[ED_SIGHT6][0] ;
		Color.g = (u8)VParam[ED_SIGHT6][1] ;
		Color.b = (u8)VParam[ED_SIGHT6][2] ;
*/
		Color.r = (u8)VParam[ED_SIGHT][5] ;
		Color.g = (u8)VParam[ED_SIGHT][6] ;
		Color.b = (u8)VParam[ED_SIGHT][7] ;
		Color.a = 0 ;
		
//		ObjectVec[0].x = VParam[ED_SIGHT6][11] - 512 ;
//		ObjectVec[0].y = VParam[ED_SIGHT6][12] - 512 ;
//		ObjectVec[1].x = VParam[ED_SIGHT6][13] - 512 ;
//		ObjectVec[1].y = VParam[ED_SIGHT6][14] - 512 ;

		return CreateSightEffect2( 0, 1, ObjectVec, 
									Color, Point, VParam[ED_SIGHT6][3] * 0.1F,
									 VParam[ED_SIGHT6][4], VParam[ED_SIGHT6][5] * 0.01F, VParam[ED_SIGHT6][6] * 0.01F,
									 VParam[ED_SIGHT6][7], VParam[ED_SIGHT6][8],
									 VParam[ED_SIGHT6][9], VParam[ED_SIGHT6][10], FALSE,
									 MaxShotNum, ShotNum, VParam[ED_SIGHT6][15] * 0.1F, (u8)VParam[ED_SIGHT6][16], (u8)VParam[ED_SIGHT6][17],
									 (f32)VParam[ED_SIGHT6][18] * 0.01F, (f32)VParam[ED_SIGHT6][19] * 0.01F,
									 (f32)VParam[ED_SIGHT6][20] * 0.01F, (f32)VParam[ED_SIGHT6][21] * 0.01F, VParam[ED_SIGHT6][22] * 0.01F,
									 (u8)VParam[ED_SIGHT6][23], FALSE,
									 TRUE, TRUE, TRUE, TRUE,
									 TRUE, TRUE, TRUE, TRUE,
									 0.0F,
									 TRUE, SightType, Priority ) ;
	}
	else
	if( SightType == SIGHT_TYPE_MSK )
	{
/*
		Color.r = (u8)VParam[ED_SIGHT3][0] ;
		Color.g = (u8)VParam[ED_SIGHT3][1] ;
		Color.b = (u8)VParam[ED_SIGHT3][2] ;
*/
		Color.r = (u8)VParam[ED_SIGHT][5] ;
		Color.g = (u8)VParam[ED_SIGHT][6] ;
		Color.b = (u8)VParam[ED_SIGHT][7] ;
		Color.a = 0 ;
		
		ObjectVec[0].x = VParam[ED_SIGHT3][11] - 512 ;
		ObjectVec[0].y = VParam[ED_SIGHT3][12] - 512 ;
		ObjectVec[1].x = VParam[ED_SIGHT3][13] - 512 ;
		ObjectVec[1].y = VParam[ED_SIGHT3][14] - 512 ;

		return CreateSightEffect2( 0, 2, ObjectVec, 
									Color, Point, VParam[ED_SIGHT3][3] * 0.1F,
									 VParam[ED_SIGHT3][4], VParam[ED_SIGHT3][5] * 0.01F, VParam[ED_SIGHT3][6] * 0.01F,
									 VParam[ED_SIGHT3][7], VParam[ED_SIGHT3][8],
									 VParam[ED_SIGHT3][9], VParam[ED_SIGHT3][10], FALSE,
									 MaxShotNum, ShotNum, VParam[ED_SIGHT3][15] * 0.1F, (u8)VParam[ED_SIGHT3][16], (u8)VParam[ED_SIGHT3][17],
									 (f32)VParam[ED_SIGHT3][18] * 0.01F, (f32)VParam[ED_SIGHT3][19] * 0.01F,
									 (f32)VParam[ED_SIGHT3][20] * 0.01F, (f32)VParam[ED_SIGHT3][21] * 0.01F,
									 1.0F, (u8)VParam[ED_SIGHT3][22], TRUE,
									 TRUE, TRUE, TRUE, FALSE,
									 FALSE, TRUE, TRUE, TRUE,
									 0.0F,
									 TRUE, SightType, Priority ) ;
	}
	else
	if( SightType == SIGHT_TYPE_GAL )
	{
/*
		Color.r = (u8)VParam[ED_SIGHT_GAL][5] ;
		Color.g = (u8)VParam[ED_SIGHT_GAL][6] ;
		Color.b = (u8)VParam[ED_SIGHT_GAL][7] ;
*/
		Color.r = (u8)VParam[ED_SIGHT][5] ;
		Color.g = (u8)VParam[ED_SIGHT][6] ;
		Color.b = (u8)VParam[ED_SIGHT][7] ;
		Color.a = 0 ;
		
		return CreateSightEffect2( 0, 1, ObjectVec, 
									Color, Point, VParam[ED_SIGHT_GAL][8] * 0.1F,
									 VParam[ED_SIGHT_GAL][9], VParam[ED_SIGHT_GAL][10] * 0.01F, VParam[ED_SIGHT_GAL][11] * 0.01F,
									 VParam[ED_SIGHT_GAL][12], VParam[ED_SIGHT_GAL][13],
									 VParam[ED_SIGHT_GAL][14], VParam[ED_SIGHT_GAL][15], FALSE,
									 MaxShotNum, ShotNum, VParam[ED_SIGHT_GAL][16] * 0.1F, (u8)VParam[ED_SIGHT_GAL][17], (u8)VParam[ED_SIGHT_GAL][18],
									 (f32)VParam[ED_SIGHT_GAL][19] * 0.01F, (f32)VParam[ED_SIGHT_GAL][20] * 0.01F,
									 (f32)VParam[ED_SIGHT_GAL][21] * 0.01F, (f32)VParam[ED_SIGHT_GAL][22] * 0.01F,
									 1.0F, (u8)VParam[ED_SIGHT_GAL][23], FALSE,
									 TRUE, TRUE, TRUE, TRUE,
									 TRUE, TRUE, TRUE, TRUE,
									 0.0F,
									 TRUE, SightType, Priority ) ;
	}
	else
	if( SightType == SIGHT_TYPE_CYO )
	{
/*
		Color.r = (u8)VParam[ED_SIGHT_CYO][5] ;
		Color.g = (u8)VParam[ED_SIGHT_CYO][6] ;
		Color.b = (u8)VParam[ED_SIGHT_CYO][7] ;
*/
		Color.r = (u8)VParam[ED_SIGHT][5] ;
		Color.g = (u8)VParam[ED_SIGHT][6] ;
		Color.b = (u8)VParam[ED_SIGHT][7] ;
		Color.a = 0 ;
		
		return CreateSightEffect2( 1, 1, ObjectVec, 
									Color, Point, VParam[ED_SIGHT_CYO][8] * 0.1F,
									 VParam[ED_SIGHT_CYO][9], VParam[ED_SIGHT_CYO][10] * 0.01F, VParam[ED_SIGHT_CYO][11] * 0.01F,
									 VParam[ED_SIGHT_CYO][12], VParam[ED_SIGHT_CYO][13],
									 VParam[ED_SIGHT_CYO][14], VParam[ED_SIGHT_CYO][15], FALSE,
									 MaxShotNum, ShotNum, VParam[ED_SIGHT_CYO][16] * 0.1F, (u8)VParam[ED_SIGHT_CYO][17], (u8)VParam[ED_SIGHT_CYO][18],
									 (f32)VParam[ED_SIGHT_CYO][19] * 0.01F, (f32)VParam[ED_SIGHT_CYO][20] * 0.01F,
									 (f32)VParam[ED_SIGHT_CYO][21] * 0.01F, (f32)VParam[ED_SIGHT_CYO][22] * 0.01F,
									 1.0F, (u8)VParam[ED_SIGHT_CYO][23], FALSE,
									 TRUE, TRUE, TRUE, TRUE,
									 TRUE, TRUE, TRUE, TRUE,
									 -VParam[ED_SIGHT_CYO][0] * PI / 90,
									 FALSE, SightType, Priority ) ;
	}
	else
	if( SightType == SIGHT_TYPE_HAY )
	{
/*
		Color.r = (u8)VParam[ED_SIGHT_HAY][5] ;
		Color.g = (u8)VParam[ED_SIGHT_HAY][6] ;
		Color.b = (u8)VParam[ED_SIGHT_HAY][7] ;
*/
		Color.r = (u8)VParam[ED_SIGHT][5] ;
		Color.g = (u8)VParam[ED_SIGHT][6] ;
		Color.b = (u8)VParam[ED_SIGHT][7] ;
		Color.a = 0 ;
		
		return CreateSightEffect2( 0, 1, ObjectVec, 
									Color, Point, VParam[ED_SIGHT_HAY][8] * 0.1F,
									 VParam[ED_SIGHT_HAY][9], VParam[ED_SIGHT_HAY][10] * 0.01F, VParam[ED_SIGHT_HAY][11] * 0.01F,
									 VParam[ED_SIGHT_HAY][12], VParam[ED_SIGHT_HAY][13],
									 VParam[ED_SIGHT_HAY][14], VParam[ED_SIGHT_HAY][15], FALSE,
									 MaxShotNum, ShotNum, VParam[ED_SIGHT_HAY][16] * 0.1F, (u8)VParam[ED_SIGHT_HAY][17], (u8)VParam[ED_SIGHT_HAY][18],
									 (f32)VParam[ED_SIGHT_HAY][19] * 0.01F, (f32)VParam[ED_SIGHT_HAY][20] * 0.01F,
									 (f32)VParam[ED_SIGHT_HAY][21] * 0.01F, (f32)VParam[ED_SIGHT_HAY][22] * 0.01F,
									 1.0F, (u8)VParam[ED_SIGHT_HAY][23], FALSE,
									 TRUE, TRUE, TRUE, TRUE,
									 TRUE, TRUE, TRUE, TRUE,
									 0.0F,
									 TRUE, SightType, Priority ) ;
	}
	else
	if( SightType == SIGHT_TYPE_KVN )
	{
/*
		Color.r = (u8)VParam[ED_SIGHT_KEV][5] ;
		Color.g = (u8)VParam[ED_SIGHT_KEV][6] ;
		Color.b = (u8)VParam[ED_SIGHT_KEV][7] ;
*/
		Color.r = (u8)VParam[ED_SIGHT][5] ;
		Color.g = (u8)VParam[ED_SIGHT][6] ;
		Color.b = (u8)VParam[ED_SIGHT][7] ;
		Color.a = 0 ;
		
		return CreateSightEffect2( 0, 1, ObjectVec, 
									Color, Point, VParam[ED_SIGHT_KEV][8] * 0.1F,
									 VParam[ED_SIGHT_KEV][9], VParam[ED_SIGHT_KEV][10] * 0.01F, VParam[ED_SIGHT_KEV][11] * 0.01F,
									 VParam[ED_SIGHT_KEV][12], VParam[ED_SIGHT_KEV][13],
									 VParam[ED_SIGHT_KEV][14], VParam[ED_SIGHT_KEV][15], FALSE,
									 MaxShotNum, ShotNum, VParam[ED_SIGHT_KEV][16] * 0.1F, (u8)VParam[ED_SIGHT_KEV][17], (u8)VParam[ED_SIGHT_KEV][18],
									 (f32)VParam[ED_SIGHT_KEV][19] * 0.01F, (f32)VParam[ED_SIGHT_KEV][20] * 0.01F,
									 (f32)VParam[ED_SIGHT_KEV][21] * 0.01F, (f32)VParam[ED_SIGHT_KEV][22] * 0.01F,
									 1.0F, (u8)VParam[ED_SIGHT_KEV][23], FALSE,
									 TRUE, TRUE, TRUE, TRUE,
									 TRUE, TRUE, TRUE, TRUE,
									 0.0F,
									 TRUE, SightType, Priority ) ;
	}
	else
	if( SightType == SIGHT_TYPE_CURSOR )
	{
		EFFECT *Sight ;
	
/*
		Color.r = (u8)VParam[ED_CURSOR][5] ;
		Color.g = (u8)VParam[ED_CURSOR][6] ;
		Color.b = (u8)VParam[ED_CURSOR][7] ;
*/
		Color.r = (u8)VParam[ED_SIGHT][5] ;
		Color.g = (u8)VParam[ED_SIGHT][6] ;
		Color.b = (u8)VParam[ED_SIGHT][7] ;
		Color.a = 0 ;
		
		Sight = CreateSightEffect2( 0, 1, ObjectVec, 
									Color, Point, VParam[ED_CURSOR][8] * 0.1F,
									 VParam[ED_CURSOR][9], VParam[ED_CURSOR][10] * 0.01F, VParam[ED_CURSOR][11] * 0.01F,
									 VParam[ED_CURSOR][12], VParam[ED_CURSOR][13],
									 VParam[ED_CURSOR][14], VParam[ED_CURSOR][15], FALSE,
									 MaxShotNum, ShotNum, VParam[ED_CURSOR][16] * 0.1F, (u8)VParam[ED_CURSOR][17], (u8)VParam[ED_CURSOR][18],
									 (f32)VParam[ED_CURSOR][19] * 0.01F, (f32)VParam[ED_CURSOR][20] * 0.01F,
									 (f32)VParam[ED_CURSOR][21] * 0.01F, (f32)VParam[ED_CURSOR][22] * 0.01F,
									 1.0F, (u8)VParam[ED_CURSOR][23], FALSE,
									 TRUE, TRUE, TRUE, TRUE,
									 TRUE, TRUE, TRUE, TRUE,
									 0.0F,
									 TRUE, SightType, Priority ) ;
		if( Sight == NULL ) return NULL ;
		SetSightSquareDrawFlag( Sight, FALSE ) ;
		SetSightLineDrawFlag( Sight, TRUE ) ;
		return Sight ;
	}

	return NULL ;
}


// Ə̃GtFNg쐬
extern EFFECT *CreateSightEffect2( u8 VibMode, u8 ObjectNum, Vec *ObjectVec,
									GXColor Color, Vec Point, f32 VibPower,
									f32 MaxMove, f32 MinSize, f32 BackSpeed,
									f32 SightWidth, f32 SightHeight,
									f32 XSquareLength, f32 YSquareLength, u8 DecVibSyncFlag,
									u8 MaxShotNum, u8 ShotNum, f32 MoveLength, u8 MoveSpeed1, u8 MoveSpeed2,
									f32 InitSpeed1, f32 InitSpeed2,
									f32 LineInSpeed, f32 LineOutSpeed, f32 ShotLineSize,
									u8 ShotLineWidth, u8 CurPointLockFlag,
									u8 Left1Flag, u8 Up1Flag, u8 Down1Flag, u8 Right1Flag,
									u8 Left2Flag, u8 Up2Flag, u8 Down2Flag, u8 Right2Flag,
									f32 Rotate,
									u8 AddBlendFlag, u8 SightType, s32 Priority )
{
	SIGHTEFFECT *Sight ;
	SIGHTOBJECT *Obj ;
	EFFECT *Effect ;
	int i ;
	
/*	EFFECT *clight ;
	
	clight = CreateCentLightEffect( Point, 
							VParam[ED_CENTLIGHT][0] * PI_2 / 360,	VParam[ED_CENTLIGHT][1] * PI_2 / 360,
							VParam[ED_CENTLIGHT][2],				VParam[ED_CENTLIGHT][3],
							VParam[ED_CENTLIGHT][4] * PI_2 / 360,	VParam[ED_CENTLIGHT][5] * PI_2 / 360,
							(f32)VParam[ED_CENTLIGHT][14],			(f32)VParam[ED_CENTLIGHT][15],
							(f32)VParam[ED_CENTLIGHT][16] * 0.1F,	(f32)VParam[ED_CENTLIGHT][17] * 0.1F,
							(f32)VParam[ED_CENTLIGHT][6] * 0.1F,
							(f32)VParam[ED_CENTLIGHT][7] * 0.01F,
							(s32)VParam[ED_CENTLIGHT][8],
							CMK( VParam[ED_CENTLIGHT][9], VParam[ED_CENTLIGHT][10], VParam[ED_CENTLIGHT][11], VParam[ED_CENTLIGHT][12] ),
							(u8)VParam[ED_CENTLIGHT][13]
							) ; 
	if( clight == NULL ) return NULL ;
*/
	// VƏf[^쐬
	Effect = AddEffectData( EFF_SIGHT, (void**)&Sight, Priority ) ;
	if( Effect == NULL )
	{
//		DeleteEffect( clight ) ;
		return NULL ;
	}
	memset( Sight, 0, sizeof( SIGHTEFFECT ) ) ;

	// f[^ۑA
	Sight->ObjectNum = ObjectNum ;
	Sight->Obj[0].Point = ObjectVec[0] ;
	if( ObjectNum == 2 ) Sight->Obj[1].Point = ObjectVec[1] ;
	Sight->Color = Color ;
	Sight->VibRate3 = Sight->VibRate2 = Sight->VibRate = 3.0F ;
	Sight->VibPower = VibPower ;
	Sight->VibCounter = 0 ;
	Sight->VibX = Sight->VibY = 0 ;
	Sight->MaxMove = MaxMove ;
	Sight->MinSize = MinSize ;
	Sight->Point = Point ;
	Sight->Width = Sight->Height = 3.0F ;
	Sight->BackSpeed = BackSpeed ;
	Sight->XSquareLength = XSquareLength ;
	Sight->YSquareLength = YSquareLength ;
	Sight->SightWidth = SightWidth ;
	Sight->SightHeight = SightHeight ;
	Sight->Mode = 0 ;
	Sight->Counter = 0 ;
	Sight->HPan = 0.0F ;
	Sight->VPan = 0.0F ;
	Sight->alpha[0] = 0.f;
	Sight->alpha[1] = 0.f;
	Sight->MovePoint = Sight->Point ;
	Sight->DecVibSyncFlag = DecVibSyncFlag ;
	Sight->MaxShotNum = MaxShotNum ;
	Sight->MoveLength = MoveLength ;
	Sight->MoveSpeed1 = MoveSpeed1 ;
	Sight->MoveSpeed2 = MoveSpeed2 ;
	Sight->InitSpeed1 = InitSpeed1 ;
	Sight->InitSpeed2 = InitSpeed2 ;
	Sight->LineDrawFlag = FALSE ;
	Sight->LineInSpeed = LineInSpeed ;
	Sight->LineOutSpeed = LineOutSpeed ;
	Sight->LineSize = 0.0F ;
	Sight->ShotLineSize = ShotLineSize ;
	Sight->ShotLineWidth = ShotLineWidth ;
	Sight->CurPointLockFlag = CurPointLockFlag ;
	Sight->ObjectMoveMode = 0 ;
	Sight->SquareDrawFlag = TRUE ;
	Sight->AddBlendFlag = AddBlendFlag ;
	Sight->SightType = SightType ;
	Sight->counter = 0 ;
	Sight->onflag = false ;
	Sight->brinkcon = 0 ;
	Sight->chargelevel = 0 ;
////	Sight->cenlight = clight ;
//	Sight->cenlight = NULL ;
//	Sight->cenlight2 = NULL ;

//	ChangeSightState( Effect, 0 ) ;
//	SetEffectIndeManageFlag( Sight->cenlight, TRUE ) ;
	

	Sight->LeftFlag[0] = Left1Flag ;	Sight->RightFlag[0] = Right1Flag ;
	Sight->UpFlag[0] = Up1Flag ;		Sight->DownFlag[0] = Down1Flag ;
	Sight->LeftFlag[1] = Left2Flag ;	Sight->RightFlag[1] = Right2Flag ;
	Sight->UpFlag[1] = Up2Flag ;		Sight->DownFlag[1] = Down2Flag ;
	Sight->DrawFlagNum[0] = (u8)( Left1Flag + Right1Flag + Up1Flag + Down1Flag ) ;
	Sight->DrawFlagNum[1] = (u8)( Left2Flag + Right2Flag + Up2Flag + Down2Flag ) ;
	
	Sight->Rotate = Rotate ;
	Sight->VibMode = VibMode ;

	// ce\̃f[^
	{
		SIGHTSHOTNUM *Shot ;
		
		Shot = Sight->Shot ;
		Sight->ShotNum = 0 ;
		for( i = 0 ; i < MaxShotNum ; i ++, Shot ++ )
		{
			Shot->Mode = 0 ;
			Shot->x = 1.0F ;
			Shot->nx = (f32)MoveLength * i / MaxShotNum + SHOT_WAIT ;
			Shot->Counter = 0 ;
		}

		// 
		SetSightShotNum( Effect, ShotNum ) ;
	}

	// ̏
	Obj = Sight->Obj ;
	for( i = 0 ; i < ObjectNum ; i ++, Obj ++ )
	{
		u8 j ;

		for( j = 0 ; j < DECNUM ; j ++ )
		{
			if( DecVibSyncFlag == FALSE )
			{
				Obj->LDec[j].x = 0.0F ;
				Obj->LDec[j].sx = VParam[ED_SIGHT][1] * 0.001F + ( (f32)rand() * ( VParam[ED_SIGHT][0] - VParam[ED_SIGHT][1] ) / RAND_MAX * 0.001F ) * ( rand() < RAND_MAX / 2 ? 1.0F : -1.0F ) ;
				Obj->LDec[j].w = VParam[ED_SIGHT][2] + rand() * ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / RAND_MAX ;

				Obj->RDec[j].x = 0.0F ;
				Obj->RDec[j].sx = VParam[ED_SIGHT][1] * 0.001F + ( (f32)rand() * ( VParam[ED_SIGHT][0] - VParam[ED_SIGHT][1] ) / RAND_MAX * 0.001F ) * ( rand() < RAND_MAX / 2 ? 1.0F : -1.0F ) ;
				Obj->RDec[j].w = VParam[ED_SIGHT][2] + rand() * ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / RAND_MAX ;

				Obj->UDec[j].x = 0.0F ;
				Obj->UDec[j].sx = VParam[ED_SIGHT][1] * 0.001F + ( (f32)rand() * ( VParam[ED_SIGHT][0] - VParam[ED_SIGHT][1] ) / RAND_MAX * 0.001F ) * ( rand() < RAND_MAX / 2 ? 1.0F : -1.0F ) ;
				Obj->UDec[j].w = VParam[ED_SIGHT][2] + rand() * ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / RAND_MAX ;

				Obj->DDec[j].x = 0.0F ;
				Obj->DDec[j].sx = VParam[ED_SIGHT][1] * 0.001F + ( (f32)rand() * ( VParam[ED_SIGHT][0] - VParam[ED_SIGHT][1] ) / RAND_MAX * 0.001F ) * ( rand() < RAND_MAX / 2 ? 1.0F : -1.0F ) ;
				Obj->DDec[j].w = VParam[ED_SIGHT][2] + rand() * ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / RAND_MAX ;
			}
			else
			{
				Obj->LDec[j].x = 1.0F ;
				Obj->LDec[j].sx = 1.0F / DECNUM * ( j + 1 ) ;
//				Obj->LDec[j].w = VParam[ED_SIGHT][2] + rand() * ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / RAND_MAX ;
				Obj->LDec[j].w = VParam[ED_SIGHT][2] + ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / 2 ;

				Obj->RDec[j].x = 1.0F ;
				Obj->RDec[j].sx = 1.0F / DECNUM * ( j + 1 ) ;
//				Obj->RDec[j].w = VParam[ED_SIGHT][2] + rand() * ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / RAND_MAX ;
				Obj->RDec[j].w = VParam[ED_SIGHT][2] + ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / 2 ;

				Obj->UDec[j].x = 1.0F ;
				Obj->UDec[j].sx = 1.0F / DECNUM * ( j + 1 ) ;
//				Obj->UDec[j].w = VParam[ED_SIGHT][2] + rand() * ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / RAND_MAX ;
				Obj->UDec[j].w = VParam[ED_SIGHT][2] + ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / 2 ;

				Obj->DDec[j].x = 1.0F ;
				Obj->DDec[j].sx = 1.0F / DECNUM * ( j + 1 ) ;
//				Obj->DDec[j].w = VParam[ED_SIGHT][2] + rand() * ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / RAND_MAX ;
				Obj->DDec[j].w = VParam[ED_SIGHT][2] + ( VParam[ED_SIGHT][3] - VParam[ED_SIGHT][2] ) / 2 ;
			}
		}

		// Xs[hZbg
		Obj->Speed = 50.0F ;

		// WZbg
		Obj->AbsPoint.x = Point.x + ObjectVec[i].x ;
		Obj->AbsPoint.y = Point.y + ObjectVec[i].y ;
		Obj->AbsPoint.z = Point.z + ObjectVec[i].z ;
		Obj->TargetPoint = Obj->AbsPoint ;
		for( j = 0 ; j < BACK_POINTNUM ; j ++ )
			Obj->BackPoint[i] = Obj->AbsPoint ;
	}

	// I
	return Effect ;
}

// Ə̃GtFNǧns
extern s8 ReleaseSightEffect( EFFECT *Effect )
{
	SIGHTEFFECT *sg = ( SIGHTEFFECT * )Effect->Data ;

//	if( sg->cenlight ) DeleteEffect( sg->cenlight ) ;
//	if( sg->cenlight2 ) DeleteEffect( sg->cenlight2 ) ;

	// ɂ邱ƂȂ
	return 0 ;
}

// Ə̃GtFNgPt[
extern s8 MoveSightEffect( EFFECT *Effect )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
	SIGHTOBJECT *Obj ;
	u8 j ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
/*	{
		static s32 CCC = 0 ;
		
		CCC ++ ;
		if( CCC == 60 )
		{
			CCC = 0 ;
			Sight->onflag = !Sight->onflag ;
		}
	}
*/
	if( Sight->onflag )
	{
		if( Sight->counter < ALLFRAME ) Sight->counter ++ ;
	}
	else
	{
		if( Sight->counter > 0 ) Sight->counter -- ;
	}
	
//	MoveEffect( Sight->cenlight ) ;
	
	// C\̃Zbg
	if( Sight->LineDrawFlag == TRUE )
	{
		Sight->LineSize += Sight->LineInSpeed ;
		if( Sight->LineSize > 1.0F ) Sight->LineSize = 1.0F ;
	}
	else
	{
		Sight->LineSize -= Sight->LineOutSpeed ;
		if( Sight->LineSize < 0.0F ) Sight->LineSize = 0.0F ;
	}

#ifndef __MODE2	
	// ce\̈ړ
	{
		SIGHTSHOTNUM *Shot ;
		u8 Num ;
		f32 r ;
		
		Shot = Sight->Shot ;
		Num = Sight->ShotNum ;
		for( j = 0 ; j < Num ; j ++, Shot ++ )
		{
			switch( Shot->Mode )
			{
			case 1 :
				// ړ
//				Shot->x += ( Shot->nx - Shot->x )/*Shot->sx*/ / ( Sight->MoveSpeed1 - Shot->Counter ) ;
				Shot->x = Shot->sl - ( r = GetSanjiFunction( -Shot->sl * Sight->InitSpeed1, Shot->sl, (f32)Sight->MoveSpeed1, (f32)Shot->Counter ) ) + Shot->sx ;
				if( Shot->Counter == Sight->MoveSpeed1 )
				{
					Shot->Mode = 2 ;
					Shot->x = Shot->nx ;
					Shot->Counter = 0 ;
				}
				else
				{
					Shot->Counter ++ ;
				}
				break ;

			case 3 :
				// SɈړ
//				Shot->x += ( 1.0F - Shot->x )/*Shot->sx*/ / ( Sight->MoveSpeed2 - Shot->Counter ) ;
				Shot->x = Shot->sl - ( r = GetSanjiFunction( -Shot->sl * Sight->InitSpeed2, Shot->sl, (f32)Sight->MoveSpeed2, (f32)Shot->Counter ) ) + Shot->sx ;
//				Shot->x = GetSanjiFunction( -Sight->InitSpeed2, Shot->sx, (f32)Sight->MoveSpeed2, (f32)Shot->Counter ) + Shot->x ;
				if( Shot->Counter == Sight->MoveSpeed2 )
				{
					Shot->Mode = 0 ;
					Shot->x = 1.0F ;
					Shot->Counter = 0 ;
					
					// Sɍs琔炷
					Sight->ShotNum -- ;
					
					if( j != Num -1 )
					{
						Shot->Counter = 1111 ;
					}
				}
				else
				{
					Shot->Counter ++ ;
				}
				break ;
			}
		}
	}

	// ̈ړ
	Obj = Sight->Obj ;
	for( j = 0 ; j < Sight->ObjectNum ; j ++, Obj ++ )
	{
		u8 i ;

		if( Sight->DecVibSyncFlag == FALSE )
		{
			for( i = 0 ; i < DECNUM ; i ++ )
			{
				Obj->LDec[i].x += Obj->LDec[i].sx ;
				if( Obj->LDec[i].x < 0.0F )
				{
					Obj->LDec[i].x = 0.0F ;
					Obj->LDec[i].sx *= -1.0F ;
				}
				if( Obj->LDec[i].x > 1.0F )
				{
					Obj->LDec[i].x = 1.0F ;
					Obj->LDec[i].sx *= -1.0F ;
				}
				
				Obj->RDec[i].x += Obj->RDec[i].sx ;
				if( Obj->RDec[i].x < 0.0F )
				{
					Obj->RDec[i].x = 0.0F ;
					Obj->RDec[i].sx *= -1.0F ;
				}
				if( Obj->RDec[i].x > 1.0F )
				{
					Obj->RDec[i].x = 1.0F ;
					Obj->RDec[i].sx *= -1.0F ;
				}

				Obj->UDec[i].x += Obj->UDec[i].sx ;
				if( Obj->UDec[i].x < 0.0F )
				{
					Obj->UDec[i].x = 0.0F ;
					Obj->UDec[i].sx *= -1.0F ;
				}
				if( Obj->UDec[i].x > 1.0F )
				{
					Obj->UDec[i].x = 1.0F ;
					Obj->UDec[i].sx *= -1.0F ;
				}

				Obj->DDec[i].x += Obj->DDec[i].sx ;
				if( Obj->DDec[i].x < 0.0F )
				{
					Obj->DDec[i].x = 0.0F ;
					Obj->DDec[i].sx *= -1.0F ;
				}
				if( Obj->DDec[i].x > 1.0F )
				{
					Obj->DDec[i].x = 1.0F ;
					Obj->DDec[i].sx *= -1.0F ;
				}
			}
		}
		else
		{
			f32 VibRate ;
		
			VibRate = Obj->VibRate2 / 3.0F ;
			for( i = 0 ; i < DECNUM ; i ++ )
			{
				Obj->LDec[i].x = VibRate * Obj->LDec[i].sx ;
				Obj->RDec[i].x = VibRate * Obj->RDec[i].sx ;
				Obj->UDec[i].x = VibRate * Obj->UDec[i].sx ;
				Obj->DDec[i].x = VibRate * Obj->DDec[i].sx ;
			}
		}
	}
#endif

	// [hɂď𕪊
	switch( Sight->Mode )
	{
	case 0 :
		Sight->Mode = 1 ;
		break ;
		
	case 1 :
		{
			f32 ddx, ddy ;

#ifndef __MODE2	
			// ̈ړ
			Obj = Sight->Obj ;
			for( j = 0 ; j < Sight->ObjectNum ; j ++, Obj ++ )
			{
				memmove( &Obj->BackPoint[1], &Obj->BackPoint[0], sizeof( Vec ) * ( BACK_POINTNUM - 1 ) ) ;
			}

			// TCgS̗h炬
			// Ԃꃂ[hɂď𕪊
			if( Sight->VibMode == 0 )
			{
				if( Sight->Point.x == Sight->MovePoint.x ) 
				{
					Sight->Width -= Sight->BackSpeed ;
					if( Sight->Width < 0.0F ) Sight->Width = 0.0F ;
					
					if( Sight->XAdd > 0.0F )
					{
						Sight->XAdd -= Sight->BackSpeed ;
						if( Sight->XAdd < 0.0F ) Sight->XAdd = 0.0F ;
					}
					else
					{
						Sight->XAdd += Sight->BackSpeed ;
						if( Sight->XAdd > 0.0F ) Sight->XAdd = 0.0F ;
					}

					if( Sight->HPan != 0.0F )
					{
						if( Sight->HPan > 0.0F )
						{
							Sight->HPan -= Sight->BackSpeed ;
							if( Sight->HPan < 0.0F ) Sight->HPan = 0.0F ;
						}
						else
						{
							Sight->HPan += Sight->BackSpeed ;
							if( Sight->HPan > 0.0F ) Sight->HPan = 0.0F ;
						}
					}
					
					ddx = 0.0F ;
				}
				else
				{
					f32 dx ;
				
					// ȊȌꍇ̓TCY
					
					dx = Sight->MovePoint.x - Sight->Point.x ;
					Sight->Width += fabs( dx ) / Sight->MaxMove ;
					if( Sight->Width > 1.0F - Sight->MinSize ) Sight->Width = 1.0F - Sight->MinSize ;

					Sight->XAdd = dx / Sight->MaxMove ;
					if( Sight->XAdd > 1.0F - Sight->MinSize ) Sight->XAdd = 1.0F - Sight->MinSize ;
					if( Sight->XAdd < -1.0F + Sight->MinSize ) Sight->XAdd = -1.0F + Sight->MinSize ;
					
					Sight->HPan += dx / Sight->MaxMove ;
					if( Sight->HPan > 1.0F ) Sight->HPan = 1.0F ;
					if( Sight->HPan < -1.0F ) Sight->HPan = -1.0F ;
					
					ddx = dx ;
				}

				if( Sight->Point.y == Sight->MovePoint.y )
				{
					Sight->Height -= Sight->BackSpeed ;
					if( Sight->Height < 0.0F ) Sight->Height = 0.0F ;
					
					if( Sight->YAdd > 0.0F )
					{
						Sight->YAdd -= Sight->BackSpeed ;
						if( Sight->YAdd < 0.0F ) Sight->YAdd = 0.0F ;
					}
					else
					{
						Sight->YAdd += Sight->BackSpeed ;
						if( Sight->YAdd > 0.0F ) Sight->YAdd = 0.0F ;
					}
					
					if( Sight->VPan != 0.0F )
					{
						if( Sight->VPan > 0.0F )
						{
							Sight->VPan -= Sight->BackSpeed ;
							if( Sight->VPan < 0.0F ) Sight->VPan = 0.0F ;
						}
						else
						{
							Sight->VPan += Sight->BackSpeed ;
							if( Sight->VPan > 0.0F ) Sight->VPan = 0.0F ;
						}
					}
					
					ddy = 0.0F ;
				}
				else
				{
					f32 dy ;
				
					// ȊȌꍇ̓TCY

					dy = Sight->MovePoint.y - Sight->Point.y ;
					Sight->Height += fabs( dy ) / Sight->MaxMove ;
					if( Sight->Height > 1.0F - Sight->MinSize ) Sight->Height = 1.0F - Sight->MinSize ;

					Sight->YAdd = dy / Sight->MaxMove ;
					if( Sight->YAdd > 1.0F - Sight->MinSize ) Sight->YAdd = 1.0F - Sight->MinSize ;
					if( Sight->YAdd < -1.0F + Sight->MinSize ) Sight->YAdd = -1.0F + Sight->MinSize ;
					
					Sight->VPan += dy / Sight->MaxMove ;
					if( Sight->VPan > 1.0F ) Sight->VPan = 1.0F ;
					if( Sight->VPan < -1.0F ) Sight->VPan = -1.0F ;
					
					ddy = dy ;
				}
			}
			else
			{
				if( Sight->Point.x == Sight->MovePoint.x ) 
				{
					if( Sight->XAdd > 0.0F )
					{
						Sight->XAdd -= Sight->BackSpeed ;
						if( Sight->XAdd < 0.0F ) Sight->XAdd = 0.0F ;
					}
					else
					{
						Sight->XAdd += Sight->BackSpeed ;
						if( Sight->XAdd > 0.0F ) Sight->XAdd = 0.0F ;
					}

					if( Sight->HPan != 0.0F )
					{
						if( Sight->HPan > 0.0F )
						{
							Sight->HPan -= Sight->BackSpeed ;
							if( Sight->HPan < 0.0F ) Sight->HPan = 0.0F ;
						}
						else
						{
							Sight->HPan += Sight->BackSpeed ;
							if( Sight->HPan > 0.0F ) Sight->HPan = 0.0F ;
						}
					}

					ddx = 0.0F ;
				}
				else
				{
					f32 dx ;
				
					// ȊȌꍇ̓TCY
					
					dx = Sight->MovePoint.x - Sight->Point.x ;

					Sight->XAdd = dx / Sight->MaxMove ;
					if( Sight->XAdd > 1.0F - Sight->MinSize ) Sight->XAdd = 1.0F - Sight->MinSize ;
					if( Sight->XAdd < -1.0F + Sight->MinSize ) Sight->XAdd = -1.0F + Sight->MinSize ;
					
					Sight->HPan += dx / Sight->MaxMove ;
					if( Sight->HPan > 1.0F ) Sight->HPan = 1.0F ;
					if( Sight->HPan < -1.0F ) Sight->HPan = -1.0F ;
					
					ddx = dx * 4.0F ;
				}

				if( Sight->Point.y == Sight->MovePoint.y )
				{
					if( Sight->YAdd > 0.0F )
					{
						Sight->YAdd -= Sight->BackSpeed ;
						if( Sight->YAdd < 0.0F ) Sight->YAdd = 0.0F ;
					}
					else
					{
						Sight->YAdd += Sight->BackSpeed ;
						if( Sight->YAdd > 0.0F ) Sight->YAdd = 0.0F ;
					}
					
					
					if( Sight->VPan != 0.0F )
					{
						if( Sight->VPan > 0.0F )
						{
							Sight->VPan -= Sight->BackSpeed ;
							if( Sight->VPan < 0.0F ) Sight->VPan = 0.0F ;
						}
						else
						{
							Sight->VPan += Sight->BackSpeed ;
							if( Sight->VPan > 0.0F ) Sight->VPan = 0.0F ;
						}
					}
					
					ddy = 0.0F ;
				}
				else
				{
					f32 dy ;
				
					// ȊȌꍇ̓TCY

					dy = Sight->MovePoint.y - Sight->Point.y ;

					Sight->VPan += dy / Sight->MaxMove ;
					if( Sight->VPan > 1.0F ) Sight->VPan = 1.0F ;
					if( Sight->VPan < -1.0F ) Sight->VPan = -1.0F ;
					
					Sight->YAdd = dy / Sight->MaxMove ;
					if( Sight->YAdd > 1.0F - Sight->MinSize ) Sight->YAdd = 1.0F - Sight->MinSize ;
					if( Sight->YAdd < -1.0F + Sight->MinSize ) Sight->YAdd = -1.0F + Sight->MinSize ;
					
					ddy = dy * 4.0F ;
				}
				
				{
					f32 dx, dy ;
					
					dx = 300 - Sight->Point.y ;
					dy = 300 - Sight->Point.y ;
					if( dx < 0.0F ) dx = 0.0F ;
					if( dy < 0.0F ) dy = 0.0F ;
					
					Sight->Height = fabs( dy ) / Sight->MaxMove ;
					if( Sight->Height > 1.0F - Sight->MinSize ) Sight->Height = 1.0F - Sight->MinSize ;

					Sight->Width = fabs( dx ) / Sight->MaxMove ;
					if( Sight->Width > 1.0F - Sight->MinSize ) Sight->Width = 1.0F - Sight->MinSize ;
				}
			}


			// Ԃꃂ[hɂď𕪊
//			if( Sight->VibMode == 0 )
			{
				// Ԃx̌vZ
				if( ddx == 0.0F && ddy == 0.0F )
				{
					Sight->VibRate -= Sight->BackSpeed ;
					if( Sight->VibRate < 0.0F )
					{
						Sight->VibRate = 0.0F ;
						Sight->VibCounter = 0 ;
					}
					
					Sight->VibRate2 -= Sight->BackSpeed ;
					if( Sight->VibRate2 < 0.0F )
					{
						Sight->VibRate2 = 0.0F ;
						Sight->VibCounter = 0 ;
					}
					
					Sight->VibRate3 -= Sight->BackSpeed ;
					if( Sight->VibRate3 < 0.0F )
					{
						Sight->VibRate3 = 0.0F ;
						Sight->VibCounter = 0 ;
					}
				}
				else
				{
					Sight->VibRate += ( sqrt( ddx * ddx + ddy * ddy ) / Sight->MaxMove ) * 5.0F ;
					if( Sight->VibRate > 5.0F ) Sight->VibRate = 5.0F ;

					Sight->VibRate2 += ( sqrt( ddx * ddx + ddy * ddy ) / Sight->MaxMove ) * 3.0F ;
					if( Sight->VibRate2 > 3.0F ) Sight->VibRate2 = 3.0F ;

					Sight->VibRate3 += ( sqrt( ddx * ddx + ddy * ddy ) / Sight->MaxMove ) * 7.0F ;
					if( Sight->VibRate3 > 7.0F ) Sight->VibRate3 = 7.0F ;
				}
				
				// Ԃ̏
				if( Sight->VibRate != 0.0F )
				{
					u16 Rot ;
				
					Rot = (u16)( rand() * PI2DIV / RAND_MAX ) ;
				}
				else
				{
					Sight->VibX = 0 ;
					Sight->VibY = 0 ;
				}
			}
#endif

			// WXV
			{
				f32 Rate ;
			
				Sight->Point = Sight->MovePoint ;

				Rate = Sight->CurPointLockFlag == TRUE ? 1.0F : Sight->VibRate3 / 7.0F ;
				Obj = Sight->Obj ;
				for( j = 0 ; j < Sight->ObjectNum ; j ++, Obj ++ )
				{
					// ڎwł͂Ȃꍇ͐΍WύX
					if( Sight->ObjectMoveMode == 0 )
					{
						Obj->TargetPoint.x = Sight->Point.x + Obj->Point.x * Rate ;
						Obj->TargetPoint.y = Sight->Point.y + Obj->Point.y * Rate ;
						Obj->TargetPoint.z = Sight->Point.z + Obj->Point.z * Rate ;
					}

					// ړI̍Wɋ߂Â
					{
						Vec d ;
						f32 Length ;
						
						VECSubtract( &Obj->TargetPoint, &Obj->AbsPoint, &d ) ;
						Length = VECMag( &d ) ;
						if( Length != 0.0F )
						{
							// 傫Xs[hɗĂȂ␳
							if( Length > Obj->Speed )
								Length = Obj->Speed ;
							
							// ړxNgɃRo[g
							VECNormalize( &d, &d ) ;
							VECScale( &d, &d, Length ) ;
							
							// Z
							VECAdd( &Obj->AbsPoint, &d, &Obj->AbsPoint ) ;
						}
					}

					// ړ𑪂
					ddx = Obj->AbsPoint.x - Obj->BackPoint[0].x ;
					ddy = Obj->AbsPoint.y - Obj->BackPoint[0].y ;

#ifndef __MODE2	
					// TCYύX
					// Ԃꃂ[hɂď𕪊
					if( Sight->VibMode == 0 )
					{
						if( ddx == 0.0F ) 
						{
							Obj->Width -= Sight->BackSpeed ;
							if( Obj->Width < 0.0F ) Obj->Width = 0.0F ;
							
							if( Obj->XAdd > 0.0F )
							{
								Obj->XAdd -= Sight->BackSpeed ;
								if( Obj->XAdd < 0.0F ) Obj->XAdd = 0.0F ;
							}
							else
							{
								Obj->XAdd += Sight->BackSpeed ;
								if( Obj->XAdd > 0.0F ) Obj->XAdd = 0.0F ;
							}

							if( Obj->HPan != 0.0F )
							{
								if( Obj->HPan > 0.0F )
								{
									Obj->HPan -= Sight->BackSpeed ;
									if( Obj->HPan < 0.0F ) Obj->HPan = 0.0F ;
								}
								else
								{
									Obj->HPan += Sight->BackSpeed ;
									if( Obj->HPan > 0.0F ) Obj->HPan = 0.0F ;
								}
							}
						}
						else
						{
							// ȊȌꍇ̓TCY
							
							Obj->Width += fabs( ddx ) / Sight->MaxMove ;
							if( Obj->Width > 1.0F - Sight->MinSize ) Obj->Width = 1.0F - Sight->MinSize ;

							Obj->XAdd = ddx / Sight->MaxMove ;
							if( Obj->XAdd > 1.0F - Sight->MinSize ) Obj->XAdd = 1.0F - Sight->MinSize ;
							if( Obj->XAdd < -1.0F + Sight->MinSize ) Obj->XAdd = -1.0F + Sight->MinSize ;
							
							Obj->HPan += ddx / Sight->MaxMove ;
							if( Obj->HPan > 1.0F ) Obj->HPan = 1.0F ;
							if( Obj->HPan < -1.0F ) Obj->HPan = -1.0F ;
						}

						if( ddy == 0.0F )
						{
							Obj->Height -= Sight->BackSpeed ;
							if( Obj->Height < 0.0F ) Obj->Height = 0.0F ;
							
							if( Obj->YAdd > 0.0F )
							{
								Obj->YAdd -= Sight->BackSpeed ;
								if( Obj->YAdd < 0.0F ) Obj->YAdd = 0.0F ;
							}
							else
							{
								Obj->YAdd += Sight->BackSpeed ;
								if( Obj->YAdd > 0.0F ) Obj->YAdd = 0.0F ;
							}
							
							if( Obj->VPan != 0.0F )
							{
								if( Obj->VPan > 0.0F )
								{
									Obj->VPan -= Sight->BackSpeed ;
									if( Obj->VPan < 0.0F ) Obj->VPan = 0.0F ;
								}
								else
								{
									Obj->VPan += Sight->BackSpeed ;
									if( Obj->VPan > 0.0F ) Obj->VPan = 0.0F ;
								}
							}
						}
						else
						{
							// ȊȌꍇ̓TCY

							Obj->Height += fabs( ddy ) / Sight->MaxMove ;
							if( Obj->Height > 1.0F - Sight->MinSize ) Obj->Height = 1.0F - Sight->MinSize ;

							Obj->YAdd = ddy / Sight->MaxMove ;
							if( Obj->YAdd > 1.0F - Sight->MinSize ) Obj->YAdd = 1.0F - Sight->MinSize ;
							if( Obj->YAdd < -1.0F + Sight->MinSize ) Obj->YAdd = -1.0F + Sight->MinSize ;
							
							Obj->VPan += ddy / Sight->MaxMove ;
							if( Obj->VPan > 1.0F ) Obj->VPan = 1.0F ;
							if( Obj->VPan < -1.0F ) Obj->VPan = -1.0F ;
						}
					}
					else
					{
						if( ddx == 0.0F ) 
						{
							if( Obj->XAdd > 0.0F )
							{
								Obj->XAdd -= Sight->BackSpeed ;
								if( Obj->XAdd < 0.0F ) Obj->XAdd = 0.0F ;
							}
							else
							{
								Obj->XAdd += Sight->BackSpeed ;
								if( Obj->XAdd > 0.0F ) Obj->XAdd = 0.0F ;
							}

							if( Obj->HPan != 0.0F )
							{
								if( Obj->HPan > 0.0F )
								{
									Obj->HPan -= Sight->BackSpeed ;
									if( Obj->HPan < 0.0F ) Obj->HPan = 0.0F ;
								}
								else
								{
									Obj->HPan += Sight->BackSpeed ;
									if( Obj->HPan > 0.0F ) Obj->HPan = 0.0F ;
								}
							}
						}
						else
						{
							// ȊȌꍇ̓TCY
							
							Obj->HPan += ddx / Sight->MaxMove ;
							if( Obj->HPan > 1.0F ) Obj->HPan = 1.0F ;
							if( Obj->HPan < -1.0F ) Obj->HPan = -1.0F ;
							
							Obj->XAdd = ddx / Sight->MaxMove ;
							if( Obj->XAdd > 1.0F - Sight->MinSize ) Obj->XAdd = 1.0F - Sight->MinSize ;
							if( Obj->XAdd < -1.0F + Sight->MinSize ) Obj->XAdd = -1.0F + Sight->MinSize ;
						}

						if( ddy == 0.0F )
						{
							if( Obj->YAdd > 0.0F )
							{
								Obj->YAdd -= Sight->BackSpeed ;
								if( Obj->YAdd < 0.0F ) Obj->YAdd = 0.0F ;
							}
							else
							{
								Obj->YAdd += Sight->BackSpeed ;
								if( Obj->YAdd > 0.0F ) Obj->YAdd = 0.0F ;
							}
							
							if( Obj->VPan != 0.0F )
							{
								if( Obj->VPan > 0.0F )
								{
									Obj->VPan -= Sight->BackSpeed ;
									if( Obj->VPan < 0.0F ) Obj->VPan = 0.0F ;
								}
								else
								{
									Obj->VPan += Sight->BackSpeed ;
									if( Obj->VPan > 0.0F ) Obj->VPan = 0.0F ;
								}
							}
						}
						else
						{
							// ȊȌꍇ̓TCY

							Obj->VPan += ddy / Sight->MaxMove ;
							if( Obj->VPan > 1.0F ) Obj->VPan = 1.0F ;
							if( Obj->VPan < -1.0F ) Obj->VPan = -1.0F ;
							
							Obj->YAdd = ddy / Sight->MaxMove ;
							if( Obj->YAdd > 1.0F - Sight->MinSize ) Obj->YAdd = 1.0F - Sight->MinSize ;
							if( Obj->YAdd < -1.0F + Sight->MinSize ) Obj->YAdd = -1.0F + Sight->MinSize ;
						}
						
						// p͕
						{
							ddx = 300 - Sight->Point.y ;
							ddy = 300 - Sight->Point.y ;
							if( ddx < 0.0F ) ddx = 0.0F ;
							if( ddy < 0.0F ) ddy = 0.0F ;

							Obj->Height = fabs( ddy ) / Sight->MaxMove ;
							if( Obj->Height > 1.0F - Sight->MinSize ) Obj->Height = 1.0F - Sight->MinSize ;

							Obj->Width = fabs( ddx ) / Sight->MaxMove ;
							if( Obj->Width > 1.0F - Sight->MinSize ) Obj->Width = 1.0F - Sight->MinSize ;
						}
					}
					

					// Ԃꃂ[hɂď𕪊
					{
						// Ԃx̌vZ
						if( ddx == 0.0F && ddy == 0.0F )
						{
							Obj->VibRate -= Sight->BackSpeed ;
							if( Obj->VibRate < 0.0F )
							{
								Obj->VibRate = 0.0F ;
							}
							
							Obj->VibRate2 -= Sight->BackSpeed ;
							if( Obj->VibRate2 < 0.0F )
							{
								Obj->VibRate2 = 0.0F ;
							}
						}
						else
						{
							Obj->VibRate += ( sqrt( ddx * ddx + ddy * ddy ) / Sight->MaxMove ) * 5.0F ;
							if( Obj->VibRate > 5.0F ) Obj->VibRate = 5.0F ;

							Obj->VibRate2 += ( sqrt( ddx * ddx + ddy * ddy ) / Sight->MaxMove ) * 3.0F ;
							if( Obj->VibRate2 > 3.0F ) Obj->VibRate2 = 3.0F ;
						}
					}
						
					// 䃂[h̏ꍇ͐eɍ킹
					if( Sight->ObjectMoveMode == 0 )
					{
						Obj->VibRate = Sight->VibRate ;
						Obj->VibRate2 = Sight->VibRate2 ;
						Obj->HPan = Sight->HPan ;
						Obj->VPan = Sight->VPan ;
						Obj->XAdd = Sight->XAdd ;
						Obj->YAdd = Sight->YAdd ;
						Obj->Width = Sight->Width ;
						Obj->Height = Sight->Height ;
					}
#endif						
					// ݂̍Wۑ
					Obj->BackPoint[0] = Obj->AbsPoint ;
					
				}
			}
		}
		
		Sight->LineRot += VParam[ED_SIGHT_KEV][3] * 0.01F ;
		if( Sight->LineRot >= 0.5F ) Sight->LineRot = -0.25F ;
		break ;
		
	case 2 :
		// 폜
		DeleteEffect( Effect ) ;
		return 0 ;
		break ;
	}
	
	// I
	return 0 ;
}

// Ə̃GtFNg`悷
#define GETVEC(n,m)		(VV.x = (n) * X.x + (m) * Y.x, VV.y = (n) * X.y + (m) * Y.y) 
extern s8 DrawSightEffect( EFFECT *Effect )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
#ifndef __MODE2
	Mtx View ;
	SIGHTOBJECT *Obj ;
	SIGHTUNION *SightUnion = &SigUnion ;
	s32 i, l ;
	u8 r, g, b, a ; 
	f32 VibX, VibY ;
	u16 Rot ;
	Vec X, Y, VV ;
#endif

	if( GetFlatTex() == NULL ) return 0 ; 
	if( Sight->DrawFlag == FALSE ) return 0 ;

#ifdef __MODE2
	__DrawSight( Sight, Sight->Point.x, Sight->Point.y, (f32)Sight->counter / ALLFRAME ) ;
//	SetCentLightPos( Sight->Point, Sight->cenlight ) ;
//	DrawEffect( Sight->cenlight ) ;
	return 0 ;
#endif

#ifndef __MODE2	
	// XZo
	{
		f32 Rot ;
	
		Rot = Sight->Rotate ;
//		if( Sight->SightType == SIGHT_TYPE_KVN ) Rot += PI / 4.0F ;
		X.x = cosf( Rot ) ;				X.y = sinf( Rot ) ;				X.z = 0.0F ;
		Y.x = cosf( Rot + PI / 2.0F ) ;	Y.y = sinf( Rot + PI / 2.0F ) ;	Y.z = 0.0F ;
	}

	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA ) ;			// `̏

	// `揈
	Obj = Sight->Obj ;
	for( l = 0 ; l < Sight->ObjectNum ; l ++, Obj ++ )
	{
		Vec p[4] ;
		f32 UHeight, LWidth, DHeight, RWidth, x2, y2 ;
		Vec Point, TempPoint ;
		int j ;

		GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, Sight->AddBlendFlag ? GX_BL_ONE : GX_BL_INVSRCALPHA, GX_LO_INV);
		GXSetDstAlpha( GX_FALSE, 0 ) ;
		GXSetLineWidth( (u8)VParam[ED_SIGHT_KEV][4], GX_TO_ONE ) ;

		// vZ̏
		UHeight = Sight->YSquareLength * ( 1.0F - PAN_WAIT + PAN_WAIT * ( ( Obj->VPan + 1.0F ) / 2.0F ) ) ;
		DHeight = Sight->YSquareLength * ( 1.0F - PAN_WAIT + PAN_WAIT * ( ( 2.0F - ( Obj->VPan + 1.0F ) ) / 2.0F ) ) ;
		LWidth = Sight->XSquareLength * ( 1.0F - PAN_WAIT + PAN_WAIT * ( ( Obj->HPan + 1.0F ) / 2.0F ) ) ;
		RWidth = Sight->XSquareLength * ( 1.0F - PAN_WAIT + PAN_WAIT * ( ( 2.0F - ( Obj->HPan + 1.0F ) ) / 2.0F ) ) ;

		// S_Zbg
		Point = Obj->AbsPoint ;

		x2 = ( ( Obj->Width + Sight->MinSize ) * Sight->SightWidth ) / 2.0F ;
		y2 = ( ( Obj->Height + Sight->MinSize ) * Sight->SightHeight ) / 2.0F ;
		p[0].x = - x2 ;		p[0].y = - y2 ;
		p[1].x = + x2 ;		p[1].y = - y2 ;
		p[2].x = - x2 ;		p[2].y = + y2 ;
		p[3].x = + x2 ;		p[3].y = + y2 ;
		
		// eNX`̃[h
		GTLOAD( GetFlatTex() ) ;

#if 1
		if( Sight->SquareDrawFlag == TRUE )
		{
			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( ( 4 * 4 ) * ( /*BACK_POINTNUM +*/ 1 ) ) ) ;
//			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( ( 1 * 4 ) * ( BACK_POINTNUM ) + 16 ) ) ;
			{
				r = Sight->Color.r ; // 128 ;
				g = Sight->Color.g ; // 128 ;
				b = Sight->Color.b ; // 255 ;
				a = (u8)( Sight->ObjectNum == 1 ? 40 : 20 ) ;
				
				Rot = (u16)( rand() * PI2DIV / RAND_MAX ) ;
				if( Rot == PI2DIV ) Rot = 0 ;
#ifdef NOBURE
				VibX = VibY = 0.0F ;
#else
				VibX = ( COS(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
				VibY = ( SIN(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
#endif
				TempPoint = Point ;
				Point.x += VibX ;
				Point.y += VibY ;
				
				if( Sight->SightType == SIGHT_TYPE_KVN )
				{
					p[0].x = - x2 ;		p[0].y = 0 ;
					p[1].x = + x2 ;		p[1].y = 0 ;
					p[2].x = - x2 ;		p[2].y = 0 ;
					p[3].x = + x2 ;		p[3].y = 0 ;
				}
				
				// ㉺̎lp``
				GETVEC(p[0].x, ( p[0].y - UHeight ) ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(p[1].x, ( p[1].y - UHeight ) ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(p[1].x, p[1].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(p[0].x, p[0].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
			
				GETVEC(p[2].x, p[2].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(( p[3].x ), p[3].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(p[3].x, ( p[3].y + DHeight ) ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(p[2].x, ( p[2].y + DHeight ) ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
			
				if( Sight->SightType == SIGHT_TYPE_KVN )
				{
					p[0].x = - x2 ;		p[0].y = - y2 ;
					p[1].x = + x2 ;		p[1].y = - y2 ;
					p[2].x = - x2 ;		p[2].y = + y2 ;
					p[3].x = + x2 ;		p[3].y = + y2 ;
				}
				
				// E̎lp``
				GETVEC(( p[0].x	- LWidth ), p[0].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(p[0].x, p[0].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(p[2].x, p[2].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(( p[2].x	- LWidth ), p[2].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
			
				GETVEC(( p[1].x	+ RWidth ), p[1].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(p[1].x, p[1].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(p[3].x, p[3].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
				GETVEC(( p[3].x	+ RWidth ), p[3].y ) ;
				GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
			
				Point = TempPoint ;
				
				j = 2 ;			
			}
			GXEnd() ;
		}

		if( Sight->LineSize != 0.0F )
		{
			if( Sight->SquareDrawFlag == TRUE )
			{
				s32 j ;

				// XZo
				if( Sight->SightType == SIGHT_TYPE_KVN )
				{
					f32 Rot ;

					Rot = Sight->Rotate + PI / 4.0F ;
					X.x = cosf( Rot ) ;				X.y = sinf( Rot ) ;				X.z = 0.0F ;
					Y.x = cosf( Rot + PI / 2.0F ) ;	Y.y = sinf( Rot + PI / 2.0F ) ;	Y.z = 0.0F ;
				}

				for( i = 0 ; i < 4 ; i ++ )
				{
					p[i].x *= Sight->LineSize ;
					p[i].y *= Sight->LineSize ;
				}

				GXBegin( GX_LINES, GX_VTXFMT0, (u16)( ( 4 * 4 * ( /*5 +*/ 1 ) ) * ( BACK_POINTNUM + 1 ) ) ) ;
	//			GXBegin( GX_LINES, GX_VTXFMT0, (u16)( 1 * 4 * ( 5 ) + 16 ) ) ;
				{
					f32 XLength, YLength, UpLength, DownLength, LeftLength, RightLength ;
					f32 XLengthB, YLengthB, UpLengthB, DownLengthB, LeftLengthB, RightLengthB ;
					f32 Sin1, Sin2 ;

					Sin1 = ( Sight->LineRot < 0.0F ) ? cosf( 0.0F ) : cosf( PI_2 * Sight->LineRot ) ;
					Sin2 = ( Sight->LineRot + 0.25F > 0.5F ) ? cosf( PI ) : cosf( PI_2 * ( Sight->LineRot + 0.25F ) ) ;
					Sin1 = ( Sin1 + 1.0F ) / 2.0F ;
					Sin2 = ( Sin2 + 1.0F ) / 2.0F ;

					r = Sight->Color.r ; // 128 ;
					g = Sight->Color.g ; // 128 ;
					b = Sight->Color.b ; // 255 ;

					if( Sight->SightType == SIGHT_TYPE_KVN )
					{
						YLengthB = YLength = VParam[ED_SIGHT_KEV][1] ;
						XLengthB = XLength = VParam[ED_SIGHT_KEV][2] ;


						LeftLengthB = LeftLength = XLength ; 
						RightLengthB = RightLength = XLength ; 
						UpLengthB = UpLength = YLength ; 
						DownLengthB = DownLength = YLength ; 
						
						UpLength = ( Sin2 - Sin1 ) * UpLengthB ;
						DownLength = ( Sin2 - Sin1 ) * DownLengthB ;
								
						LeftLength = ( Sin2 - Sin1 ) * LeftLengthB ;
						RightLength = ( Sin2 - Sin1 ) * RightLengthB ;
					}
					else
					{
						YLengthB = YLength = SCH * 0.7F ;
						XLengthB = XLength = SCW * 0.7F ;
						
						LeftLengthB = LeftLength = XLength * ( Sight->Point.x / ( SCW / 2.0F ) ) ; 
						RightLengthB = RightLength = XLength * ( ( SCW - Sight->Point.x ) / ( SCW / 2.0F ) ) ; 
						UpLengthB = UpLength = YLength * ( Sight->Point.y / ( SCH / 2.0F ) ) ; 
						DownLengthB = DownLength = YLength * ( ( SCH - Sight->Point.y ) / ( SCH / 2.0F ) ) ; 
					}
					
					for( j = 0 ; j < BACK_POINTNUM + 1 ; j ++ )
					{
						Rot = (u16)( rand() * PI2DIV / RAND_MAX ) ;
						if( Rot == PI2DIV ) Rot = 0 ;
#ifdef NOBURE
						VibX = 0.0F ;
						VibY = 0.0F ;
#else
						VibX = ( COS(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
						VibY = ( SIN(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
#endif

						TempPoint = Point ;
						if( j == 0 )
						{
							Point.x += VibX ;
							Point.y += VibY ;
							a = (u8)( Sight->ObjectNum == 1 ? 30 : 20 ) ;
							a = (u8)( Sight->ObjectNum == 1 ? 10 - ( j * 10 / BACK_POINTNUM ) : 6 - ( j * 6 / BACK_POINTNUM ) ) ;
						}
						else
						{
							Point.x = Obj->BackPoint[j].x + VibX ;
							Point.y = Obj->BackPoint[j].y + VibY ;
							a = (u8)( Sight->ObjectNum == 1 ? 10 - ( j * 10 / BACK_POINTNUM ) : 6 - ( j * 6 / BACK_POINTNUM ) ) ;
						}

						if( Sight->SightType == SIGHT_TYPE_KVN )
						{
							p[0].x = 0.0F ;		p[0].y = - VParam[ED_SIGHT_KEV][0] - Sin1 * UpLengthB ;
							p[1].x = 0.0F ;		p[1].y = - VParam[ED_SIGHT_KEV][0] - Sin1 * UpLengthB ;
							p[2].x = 0.0F ;		p[2].y = VParam[ED_SIGHT_KEV][0] + Sin1 * DownLengthB ;
							p[3].x = 0.0F ;		p[3].y = VParam[ED_SIGHT_KEV][0] + Sin1 * DownLengthB ;
						}

						// ㉺̎lp``
						GETVEC(( p[0].x	+ 1 ), p[0].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[0].x	+ 1 ), ( p[0].y - UpLength ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[1].x	+ 1 ), p[1].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[1].x	+ 1 ), ( p[1].y - UpLength ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						
						GETVEC(( p[2].x	+ 1 ), p[2].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[2].x	+ 1 ), ( p[2].y + DownLength ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[3].x	+ 1 ), p[3].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[3].x	+ 1 ), ( p[3].y + DownLength ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						
						if( Sight->SightType == SIGHT_TYPE_KVN )
						{
							p[0].x = - VParam[ED_SIGHT_KEV][0] - Sin1 * LeftLengthB ;		p[0].y = 0.0F ;
							p[1].x = + VParam[ED_SIGHT_KEV][0] + Sin1 * RightLengthB ;		p[1].y = 0.0F ;
							p[2].x = - VParam[ED_SIGHT_KEV][0] - Sin1 * LeftLengthB ;		p[2].y = 0.0F ;
							p[3].x = + VParam[ED_SIGHT_KEV][0] + Sin1 * RightLengthB ;		p[3].y = 0.0F ;
						}
						
						// E̎lp``
						GETVEC( p[0].x, p[0].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC( p[0].x - LeftLength, p[0].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC( p[2].x, p[2].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC( p[2].x - LeftLength, ( p[2].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						
						GETVEC(( p[1].x ), ( p[1].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[1].x + RightLength ), ( p[1].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[3].x	 ), ( p[3].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[3].x + RightLength ), ( p[3].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;

						Point = TempPoint ;


					}
				}
				GXEnd() ;
			}
			else
			{
				for( i = 0 ; i < 4 ; i ++ )
				{
					p[i].x *= Sight->LineSize ;
					p[i].y *= Sight->LineSize ;
				}

				GXBegin( GX_LINES, GX_VTXFMT0, (u16)( ( 4 * 4 * ( 5 + 1 ) ) * ( BACK_POINTNUM + 1 ) ) ) ;
				{
					r = Sight->Color.r ; // 128 ;
					g = Sight->Color.g ; // 128 ;
					b = Sight->Color.b ; // 255 ;
					a = (u8)( Sight->ObjectNum == 1 ? 30 : 20 ) ;

					for( j = 0 ; j < BACK_POINTNUM + 1 ; j ++ )
					{
						Rot = (u16)( rand() * PI2DIV / RAND_MAX ) ;
						if( Rot == PI2DIV ) Rot = 0 ;
#ifdef NOBURE
						VibX = VibY = 0.0F ;
#else
						VibX = ( COS(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
						VibY = ( SIN(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
#endif
						TempPoint = Point ;
//						Point.x += VibX ;
//						Point.y += VibY ;
						if( j == 0 )
						{
							Point.x += VibX ;
							Point.y += VibY ;
							a = (u8)( Sight->ObjectNum == 1 ? 30 : 20 ) ;
							a = (u8)( Sight->ObjectNum == 1 ? 10 - ( j * 10 / BACK_POINTNUM ) : 6 - ( j * 6 / BACK_POINTNUM ) ) ;
						}
						else
						{
							Point.x = Obj->BackPoint[j].x + VibX ;
							Point.y = Obj->BackPoint[j].y + VibY ;
							a = (u8)( Sight->ObjectNum == 1 ? 10 - ( j * 10 / BACK_POINTNUM ) : 6 - ( j * 6 / BACK_POINTNUM ) ) ;
						}

						// ㉺̎lp``
						GETVEC(( p[0].x	+ 1 ), 0 ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[0].x	+ 1 ), ( - SCH ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[1].x	+ 1 ), 0 ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[1].x	+ 1 ), ( - SCH ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						
						GETVEC(( p[2].x	+ 1 ), 0 ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[2].x	+ 1 ), ( SCH ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[3].x	+ 1 ), 0 ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( p[3].x	+ 1 ), ( SCH ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						
						// E̎lp``
						GETVEC( 0, p[0].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC( - SCW , p[0].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC( 0, p[2].y ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC( - SCW, ( p[2].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						
						GETVEC(( 0 ), ( p[1].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( SCW ), ( p[1].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( 0 ), ( p[3].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
						GETVEC(( SCW ), ( p[3].y  ) ) ;
						GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;

						Point = TempPoint ;
						
						for( i = 0 ; i < 5 ; i ++ )
						{
//							a = (u8)( Sight->ObjectNum == 1 ? 30 : 20 ) ;

							Rot = (u16)( rand() * PI2DIV / RAND_MAX ) ;
							if( Rot == PI2DIV ) Rot = 0 ;
#ifdef NOBURE
							VibX = VibY = 0.0F ;
#else
							VibX = ( COS(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
							VibY = ( SIN(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
#endif
						
//							Point.x += VibX ;
//							Point.y += VibY ;

							if( j == 0 )
							{
								Point.x += VibX ;
								Point.y += VibY ;
								a = (u8)( Sight->ObjectNum == 1 ? 30 : 20 ) ;
								a = (u8)( Sight->ObjectNum == 1 ? 10 - ( j * 10 / BACK_POINTNUM ) : 6 - ( j * 6 / BACK_POINTNUM ) ) ;
							}
							else
							{
								Point.x = Obj->BackPoint[j].x + VibX ;
								Point.y = Obj->BackPoint[j].y + VibY ;
								a = (u8)( Sight->ObjectNum == 1 ? 10 - ( j * 10 / BACK_POINTNUM ) : 6 - ( j * 6 / BACK_POINTNUM ) ) ;
							}
						
							// ㉺̎lp``
							GETVEC(( p[0].x	+ 1 ), 0 ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(( p[0].x	+ 1 ), ( - ( Sight->Point.y * 1.2F ) ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(( p[1].x	+ 1 ), 0 ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(( p[1].x	+ 1 ), ( 0 - ( Sight->Point.y * 1.2F ) ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							
							GETVEC(( p[2].x	+ 1 ), 0 ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(( p[2].x	+ 1 ), ( ( ( ( SCH - Sight->Point.y ) * 1.2F ) ) ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(p[3].x + 1, 0 ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(p[3].x + 1, ( ( ( ( SCH - Sight->Point.y ) * 1.2F ) ) ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;

							
							// E̎lp``
							GETVEC( 0, p[0].y ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(( - ( Sight->Point.x * 1.2F ) ), p[0].y ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(( 0 ), p[2].y ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(( - ( Sight->Point.x * 1.2F ) ), p[2].y ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;


							GETVEC(0 , p[1].y ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(( ( ( SCW - Sight->Point.x ) * 1.2F ) ), p[1].y ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC( 0, p[3].y ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;
							GETVEC(( ( ( SCW - Sight->Point.x ) * 1.2F ) ), p[3].y ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ; 	GC4( r, g, b, a ) ;

							
							Point = TempPoint ;
						}
					}
				}
				GXEnd() ;
			}
		
			if( Sight->SightType == SIGHT_TYPE_KVN )
			{
				p[0].x = - x2 * Sight->LineSize ;		p[0].y = - y2 * Sight->LineSize ;
				p[1].x = + x2 * Sight->LineSize ;		p[1].y = - y2 * Sight->LineSize ;
				p[2].x = - x2 * Sight->LineSize ;		p[2].y = + y2 * Sight->LineSize ;
				p[3].x = + x2 * Sight->LineSize ;		p[3].y = + y2 * Sight->LineSize ;
			}
						
			// C̎ce̕`揈
			GXSetLineWidth( Sight->ShotLineWidth, GX_TO_ONE ) ;
			GXBegin( GX_LINES, GX_VTXFMT0, (u16)( 2 * Sight->ShotNum * Sight->DrawFlagNum[l] * 16 ) ) ;
			{
				SIGHTSHOTNUM *Shot ;
				u8 i ;
				f32 uh, dh, lw, rw ;
				f32 VibX, VibY ;
				u16 Rot ;
				Vec tp[4] ;

				r = Sight->Color.r ; // 128 ;
				g = Sight->Color.g ; // 128 ;
				b = Sight->Color.b ; // 255 ;
				a = (u8)( Sight->ObjectNum == 1 ? 10 : 6 ) ;
				
				tp[0] = p[0] ;
				tp[0].x *= Sight->ShotLineSize ;
				tp[0].y *= Sight->ShotLineSize ;
				tp[1] = p[1] ;
				tp[1].x *= Sight->ShotLineSize ;
				tp[1].y *= Sight->ShotLineSize ;
				tp[2] = p[2] ;
				tp[2].x *= Sight->ShotLineSize ;
				tp[2].y *= Sight->ShotLineSize ;
				tp[3] = p[3] ;
				tp[3].x *= Sight->ShotLineSize ;
				tp[3].y *= Sight->ShotLineSize ;
				
				uh = tp[0].y + Point.y ;
				dh = SCH - ( tp[2].y + Point.y ) ;
				lw = tp[0].x + Point.x ;
				rw = SCW - ( tp[1].x + Point.x ) ;
				
				for( j = 0 ; j < 16 ; j ++ )
				{
					Shot = Sight->Shot ;
					for( i = 0 ; i < Sight->ShotNum ; i ++, Shot ++ )
					{
						Rot = (u16)( rand() * PI2DIV / RAND_MAX ) ;
						if( Rot == PI2DIV ) Rot = 0 ;
#ifdef NOBURE
						VibX = 0.0F ;
						VibY = 0.0F ;
#else
						VibX = ( COS(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
						VibY = ( SIN(Rot) * ( ( Obj->VibRate / 5.0F ) * Sight->VibPower ) ) ;
#endif

						TempPoint = Point ;
						Point.x += VibX ;
						Point.y += VibY ;

						// ̃C`
						if( Sight->UpFlag[l] == TRUE )
						{
							GETVEC(( tp[0].x ), ( tp[0].y - ( uh * ( 1.0F - Shot->x ) ) ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ;
							GC4( r, g, b, a ) ;
							GETVEC(( tp[1].x ), ( tp[1].y - ( uh * ( 1.0F - Shot->x ) ) ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ;
							GC4( r, g, b, a ) ;
						}

						// ̃C`				
						if( Sight->DownFlag[l] == TRUE )
						{
							GETVEC(( tp[2].x ), ( tp[2].y + ( dh * ( 1.0F - Shot->x ) ) ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ;
							GC4( r, g, b, a ) ;
							GETVEC(( tp[3].x ), ( tp[3].y + ( dh * ( 1.0F - Shot->x ) ) ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ;
							GC4( r, g, b, a ) ;
						}

						// ̃C`
						if( Sight->LeftFlag[l] == TRUE )
						{
							GETVEC(( tp[0].x - ( lw * ( 1.0F - Shot->x ) ) ), ( tp[0].y ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ;
							GC4( r, g, b, a ) ;
							GETVEC(( tp[2].x - ( lw * ( 1.0F - Shot->x ) ) ), ( tp[2].y ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ;
							GC4( r, g, b, a ) ;
						}

						// ẼC`
						if( Sight->RightFlag[l] == TRUE )
						{
							GETVEC(( tp[1].x + ( rw * ( 1.0F - Shot->x ) ) ), ( tp[1].y ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ;
							GC4( r, g, b, a ) ;
							GETVEC(( tp[3].x + ( rw * ( 1.0F - Shot->x ) ) ), ( tp[3].y ) ) ;
							GP2( VV.x + Point.x, VV.y + Point.y ) ;
							GC4( r, g, b, a ) ;
						}

						Point = TempPoint ;
					}	
				}
			}
			GXEnd() ;
			GXSetLineWidth( (u8)VParam[ED_SIGHT_KEV][4], GX_TO_ONE ) ;
			


	#endif

	#if FUJITA
			//OSReport( "effect\n" );
			{
			  Mtx44 mt ;
			
			  // ˉes쐬
			  MTXOrtho( mt, SCH, 0.0F,
						SCW, 0.0F, 1.f, 32768.f ) ;
			  GXSetProjection( mt, GX_ORTHOGRAPHIC ) ;
			}
		
			// r[}gbNXZbg
			{
			  // PʍsZbg
			  MTXIdentity( View ) ; 
		
			  // }gbNXZbg
			  GXLoadPosMtxImm( View, GX_PNMTX0 ) ;
			  GXSetCurrentMtx( GX_PNMTX0 ) ;
			}

			// _tH[}bg̃Zbg
			GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS, GX_POS_XYZ, GX_F32, 0 ) ;
			
			GXClearVtxDesc();
			GXSetVtxDesc(GX_VA_POS, GX_DIRECT) ;
			GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT) ;
			//GXSetBlendMode(GX_BM_LOGIC, GX_BL_SRCALPHA, GX_BL_ONE, GX_LO_INV);
			GXSetBlendMode(GX_BM_BLEND, GX_BL_ONE, GX_BL_ONE, GX_LO_INV);
			GXSetZMode( GX_ENABLE, GX_LESS, GX_FALSE ) ;
			GXSetZCompLoc( GX_ENABLE ) ;

			{
				f32 tmp;
				
				tmp = Sight->alpha[1] - Sight->alpha[0];
				if ( tmp ){
					Sight->alpha[0] += tmp / 8.f;
				}
			}


			GXBegin( GX_QUADS, GX_VTXFMT0, (u16) 4 ) ;
			f32 box_w=Sight->w;
			f32 box_h=Sight->h;
			{
			  Vec Point = Sight->Point ;
			  GP3( (SCW-Point.x) - box_w*0.5f, (SCH-Point.y) - box_h*0.5f, -1.0F ) ;
			  GC4( (u8)( Sight->alpha[0] / 2 ), (u8)( Sight->alpha[0] / 2 ), (u8 )( Sight->alpha[0] / 2 ), 128 ) ; // Yamada
			  GP3( (SCW-Point.x) + box_w*0.5f, (SCH-Point.y) - box_h*0.5f, -1.0F ) ;
			  GC4( (u8)( Sight->alpha[0] / 2 ), (u8)( Sight->alpha[0] / 2 ), (u8 )( Sight->alpha[0] / 2 ), 128 ) ; // Yamada
			  GP3( (SCW-Point.x) + box_w*0.5f, (SCH-Point.y) + box_h*0.5f, -1.0F ) ;
			  GC4( (u8)( Sight->alpha[0] / 2 ), (u8)( Sight->alpha[0] / 2 ), (u8 )( Sight->alpha[0] / 2 ), 128 ) ; // Yamada
			  GP3( (SCW-Point.x) - box_w*0.5f, (SCH-Point.y) + box_h*0.5f, -1.0F ) ;
			  GC4( (u8)( Sight->alpha[0] / 2 ), (u8)( Sight->alpha[0] / 2 ), (u8 )( Sight->alpha[0] / 2 ), 128 ) ; // Yamada
			}
			GXEnd();
	#endif

			{
				GXBegin( GX_LINESTRIP, GX_VTXFMT0, (u16) 5 ) ;
				{
				  f32 box_w=Sight->w;
				  f32 box_h=Sight->h;
				  GP3( (SCW-Point.x) - box_w*0.5f - 2.0F, (SCH-Point.y) - box_h*0.5f - 2.5F, -1.0F ) ;
				  GC4( (u8 )Sight->alpha[0] , (u8 )Sight->alpha[0] , (u8 )Sight->alpha[0] , 255 ) ;
				  GT2( 0, 0 ) ;
				  GP3( (SCW-Point.x) + box_w*0.5f + 2.0F, (SCH-Point.y) - box_h*0.5f - 2.5F, -1.0F ) ;
				  GC4( (u8)Sight->alpha[0] , (u8)Sight->alpha[0] , (u8)Sight->alpha[0] , 255 ) ;
				  GT2( UVSCALE, 0 ) ;
				  GP3( (SCW-Point.x) + box_w*0.5f + 2.0F, (SCH-Point.y) + box_h*0.5f + 2.0F, -1.0F ) ;
				  GC4( (u8)Sight->alpha[0] , (u8)Sight->alpha[0] , (u8)Sight->alpha[0] , 255 ) ;
				  GT2( UVSCALE, UVSCALE ) ;
				  GP3( (SCW-Point.x) - box_w*0.5f - 2.0F, (SCH-Point.y) + box_h*0.5f + 2.0F, -1.0F ) ;
				  GC4( (u8)Sight->alpha[0] , (u8)Sight->alpha[0] , (u8)Sight->alpha[0] , 255 ) ;
				  GT2( 0, UVSCALE ) ;
				  GP3( (SCW-Point.x) - box_w*0.5f - 2.0F, (SCH-Point.y) - box_h*0.5f - 2.5F, -1.0F ) ;
				  GC4( (u8 )Sight->alpha[0] , (u8 )Sight->alpha[0], (u8 )Sight->alpha[0] , 255 ) ;
				  GT2( 0, 0 ) ;
				}
				GXEnd();
			}
		}
	}
#endif	// __MODE2


	// ݒɖ߂
	GXSetClipMode( GX_CLIP_ENABLE ) ;
	
	// I
	return 0 ;
}

// ƏGtFNg̍WZbg 
extern s8 SetSightEffectPoint( EFFECT *Effect, Vec *Point, u8 AfterImageFlag )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
	
	AfterImageFlag = AfterImageFlag ;

#ifdef __MODE2
	Sight->Point = *Point ;
	Sight->MovePoint = *Point ;
#else
	// ⊮tOĂ邩ǂŏ𕪊
	if( AfterImageFlag == FALSE )
	{
		// ̈ړZbg邾
		Sight->MovePoint = *Point ;
	}
	else
	{
		f32 dx, dy ;
		u16 i ;
		Vec P ;
	
		// c{
		P = Sight->Point ;
		dx = Point->x - P.x ;
		dy = Point->y - P.y ;
		
		for( i = 0 ; i < BACK_POINTNUM / 2 ; i ++ )
		{
			Sight->MovePoint.x = P.x + dx * i / ( BACK_POINTNUM / 2 - 1 ) ;
			Sight->MovePoint.y = P.y + dy * i / ( BACK_POINTNUM / 2 - 1 ) ;
			MoveSightEffect( Effect ) ;
		}
	}
#endif

	// I
	return 0 ;
}
	
#if FUJITA
extern s8 SetSightEffectWH( EFFECT *Effect, f32 _w, f32 _h )
{
	SIGHTEFFECT *SightEffect = ( SIGHTEFFECT * )Effect->Data ;
	
	SightEffect->w = _w ;
	SightEffect->h = _h ;
	
	// I
	return 0 ;
}
#endif
// ƏGtFNg̕`悷邩ǂ̃tOZbg
extern s8 SetSightEffectRenderFlag( EFFECT *Effect, s8 Flag )
{
	SIGHTEFFECT *SightEffect = ( SIGHTEFFECT * )Effect->Data ;
	
	SightEffect->DrawFlag = (u8)Flag ;
	
	// I
	return 0 ;
}
	
// ƏGtFNgɍ폜w߂o
extern s8 DelReqSightEffect( EFFECT *Effect )
{
	SIGHTEFFECT *SightEffect = ( SIGHTEFFECT * )Effect->Data ;
	
	// ɍ폜sĂ牽ɏI
	if( SightEffect->Mode == 2 ) return 0 ;

	// [h폜ɂ
	SightEffect->Mode = 2 ;
	SightEffect->Counter = 0 ;
	
	// I
	return 0 ;
}

// ƏGtFNg̕`悷邩ǂ̃tOZbg
extern s8 SetSightEffectAlphaSet( EFFECT *Effect, u32 col )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;

	Sight->alpha[1] = col;
	
	// I
	return 0 ;
}

// ʒu擾( Hand  0:E  1: )
extern s8 GetSightShotPoint( EFFECT *Effect, s16 *y, s16 *x, u8 Hand )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
	SIGHTOBJECT *Obj ;
	f32 Width, Height, VibX, VibY ;
	u16 Rot ;
	Vec VV, Vx, Vy ;
	
#ifdef __MODE2
	*x = (s16)Sight->Point.x ;
	*y = (s16)Sight->Point.y ;
	return 0 ;
#endif

	// ͈͂擾
	Obj = &Sight->Obj[Hand] ;
	if( Sight->ObjectNum == 1 ) Obj = &Sight->Obj[0] ;

	Width = ( Sight->Width + Sight->MinSize ) * Sight->SightWidth ; 
	Height = ( Sight->Height + Sight->MinSize ) * Sight->SightHeight ;

	Rot = (u16)( rand() * PI2DIV / RAND_MAX ) ;
	if( Rot == PI2DIV ) Rot = 0 ;
	VibX = ( COS(Rot) * ( ( Sight->VibRate / 5.0F ) * Sight->VibPower ) ) ;
	VibY = ( SIN(Rot) * ( ( Sight->VibRate / 5.0F ) * Sight->VibPower ) ) ;

	VV.x = (s16)( rand() * Width / RAND_MAX - Width / 2.0F + VibX ) ;
	VV.y = (s16)( rand() * Height / RAND_MAX - Height / 2.0F + VibY ) ;
	
	Vx.x = cosf( Sight->Rotate ) ;					Vx.y = sinf( Sight->Rotate ) ;
	Vy.x = cosf( Sight->Rotate + PI / 2.0F ) ;		Vy.y = sinf( Sight->Rotate + PI / 2.0F ) ;

	*x = (s16)( VV.x * Vx.x + VV.y * Vy.x + Obj->AbsPoint.x ) ;
	*y = (s16)( VV.x * Vx.y + VV.y * Vy.y + Obj->AbsPoint.y ) ;

	// I
	return 0 ;
}	

// ƏԂꂳ
extern s8 SightVib( EFFECT *Effect )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;

	Sight->VibRate += 2.0F ;
	if( Sight->VibRate > 5.0F ) Sight->VibRate = 5.0F ;

	// I
	return 0 ;
}

// ceZbg
extern s8 SetSightShotNum( EFFECT *Effect, u8 ShotNum )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
	u32 i ;
	SIGHTSHOTNUM *Shot ;

	// ceɕωΉI
//	if( Sight->ShotNum == ShotNum ) return 0 ;

	// ݂̎ce葽Ȃŏ𕪊򂷂
	if( Sight->ShotNum > ShotNum )
	{
		u8 SubNum ;
	
		// ceꍇ̏
		SubNum = (u8)( Sight->ShotNum - ShotNum ) ;
		Shot = &Sight->Shot[Sight->ShotNum-1] ;
		for( i = 0 ; i < SubNum ; i ++, Shot -- )
		{
			// SɌĂȂ璆SɌ킹
			if( Shot->Mode != 3 )
			{
				Shot->Mode = 3 ;
				Shot->Counter = 0 ;
				Shot->sx = Shot->x ;
				Shot->sl = 1.0F - Shot->x ;
			}
		}
	}
	else
	{
		// ceꍇ̏
		Shot = Sight->Shot ;
		for( i = 0 ; i < ShotNum ; i ++, Shot ++ )
		{
			// ړԂɂ
			if( ( Shot->Mode != 2 && Shot->Mode != 1 ) || Shot->Mode == 0 )
			{
				Shot->Mode = 1 ;
				Shot->Counter = 0 ;
				Shot->sx = Shot->x ;
				Shot->sl = Shot->nx - Shot->x ;
			}
		}

		// Vbg̐𑝂₷
		Sight->ShotNum = ShotNum ;
	}
		
	// I
	return 0 ;
}

// Ə̏㉺ɐLт`悷邩ǂ̃tOZbg
extern s8 SetSightLineDrawFlag( EFFECT *Effect, u8 Flag )
{
	SIGHTEFFECT *sg = ( SIGHTEFFECT * )Effect->Data ;
	
	sg->LineDrawFlag = Flag ;
	
//	if( sg->cenlight != NULL ){ SetEffectDrawFlag( sg->cenlight, (s8)Flag ) ; }
//	if( sg->cenlight2 != NULL ){ SetEffectDrawFlag( sg->cenlight2, (s8)Flag ) ; }
	
	// I
	return 0 ;
}

// Ə̒ŜS̎lp`悷邩ǂ̃tOZbg
extern s8 SetSightSquareDrawFlag( EFFECT *Effect, u8 Flag )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
	
	Sight->SquareDrawFlag = Flag ;
	
	// I
	return 0 ;
}

// Ə̒S̃TCYZbg
extern s8 SetSightSize( EFFECT *Effect, f32 Width, f32 Height )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
	
	Sight->SightWidth = Width ;
	Sight->SightHeight = Height ;

	// I
	return 0 ;
}

	


// TCg̍W΍Ww肷邩ǂݒ肷
extern s8 SetSightDirectPointFlag( EFFECT *Effect, u8 DirectPointFlag )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
	
	Sight->ObjectMoveMode = DirectPointFlag ;
	
	// I
	return 0 ;
}
	
// TCg̍W΍Ww擾
extern u8 GetSightDirectPointFlag( EFFECT *Effect )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
	return Sight->ObjectMoveMode;
}
	
// TCg̐΍Ww肷( Hand  0:E  1: )
extern s8 SetSightTargetPoint( EFFECT *Effect, Vec Point, u8 Hand )
{
	SIGHTEFFECT *Sight = ( SIGHTEFFECT * )Effect->Data ;
	SIGHTOBJECT *Obj ;

	// ΍WZbg
	Obj = &Sight->Obj[Hand] ;
	Obj->TargetPoint = Point ;
	
	// I
	return 0 ;
}

#define PR			VParam[ED_CENTLIGHT]

// TCg̃^CvύX( 0:ʏ  1:ߌ )
extern s8 ChangeSightState( EFFECT *Effect, s8 Type )
{
	SIGHTEFFECT *sg = ( SIGHTEFFECT * )Effect->Data ;

//	if( sg->cenlight != NULL ){ DelReqEffect( sg->cenlight ) ; sg->cenlight = NULL ; }
//	if( sg->cenlight2 != NULL ){ DelReqEffect( sg->cenlight2 ) ; sg->cenlight2 = NULL ; }
	
	switch( Type )
	{
	case 0 :
/*		sg->cenlight = CreateCentLightEffect( sg->Point, 
							8 * PI_2 / 360,	7 * PI_2 / 360,
							67,				59,
							123 * PI_2 / 360,	120 * PI_2 / 360,
							(f32)PR[14],			(f32)PR[15],
							(f32)PR[16] * 0.1F,	(f32)PR[17] * 0.1F,
							(f32)PR[6] * 0.1F,
							(f32)PR[7] * 0.01F,
							(s32)PR[8],
							CMK( PR[9], PR[10], PR[11], PR[12] ),
							(u8)PR[13]
							) ; 
*/							

/*		sg->cenlight = CreateCentLightEffect( sg->Point, 
							8 * PI_2 / 360,		7 * PI_2 / 360,
							67,					59,
							123 * PI_2 / 360,	120 * PI_2 / 360,
							(f32)16,			(f32)3,
							(f32)30 * 0.1F,		(f32)10 * 0.1F,
							(f32)10 * 0.1F,
							(f32)815 * 0.01F,
							(s32)20,
							CMK( 200, 200, 200, 255 ),
							(u8)1
							) ; 
		sg->cenlight2 = CreateCentLightEffect( sg->Point, 
							8 * PI_2 / 360,	7 * PI_2 / 360,
							39,				20,
							123 * PI_2 / 360,	123 * PI_2 / 360,
							(f32)16,			(f32)3,
							(f32)30 * 0.1F,		(f32)10 * 0.1F,
							(f32)10 * 0.1F,
							(f32)358 * 0.01F,
							(s32)30,
							CMK( 200, 200, 200, 255 ),
							(u8)1
							) ; 
*/
		break ;

	case 1 :
/*
		sg->cenlight = CreateCentLightEffect( sg->Point, 
							PR[0] * PI_2 / 360,	PR[1] * PI_2 / 360,
							PR[2],				PR[3],
							PR[4] * PI_2 / 360,	PR[5] * PI_2 / 360,
							(f32)PR[14],			(f32)PR[15],
							(f32)PR[16] * 0.1F,	(f32)PR[17] * 0.1F,
							(f32)PR[6] * 0.1F,
							(f32)PR[7] * 0.01F,
							(s32)PR[8],
							CMK( PR[9], PR[10], PR[11], PR[12] ),
							(u8)PR[13]
							) ; 
		sg->cenlight2 = CreateCentLightEffect( sg->Point, 
							PR[0] * PI_2 / 360,	PR[1] * PI_2 / 360,
							PR[2],				PR[3],
							PR[4] * PI_2 / 360,	PR[5] * PI_2 / 360,
							(f32)PR[14],			(f32)PR[15],
							(f32)PR[16] * 0.1F,	(f32)PR[17] * 0.1F,
							(f32)PR[6] * 0.1F,
							(f32)PR[7] * 0.01F,
							(s32)PR[8],
							CMK( PR[9], PR[10], PR[11], PR[12] ),
							(u8)PR[13]
							) ; 
*/
		break ;
	}

	// I
	return 0 ;
}

// \^Cv̕ύXs
extern void SetSightModeFlag( EFFECT *Effect, bool Flag )
{
	SIGHTEFFECT *sg = ( SIGHTEFFECT * )Effect->Data ;
	
	sg->onflag = Flag ;	
}

// S̃p[c̐FύX
extern void SetSightCenterColor( EFFECT *Effect, bool valid, GXColor color )
{
	SIGHTEFFECT *sg = ( SIGHTEFFECT * )Effect->Data ;
	
	sg->centcolorf = valid ;
	sg->centcolor = *((u32 *)&color) ;
}

// S̃p[c̐FύX
extern void SetSightCenterColor( EFFECT *Effect, bool valid, u32 color )
{
	SIGHTEFFECT *sg = ( SIGHTEFFECT * )Effect->Data ;

	sg->centcolorf = valid ;
	sg->centcolor = color ;
}

// S̃p[c̐FύX
extern void SetSightCircleColor( EFFECT *Effect, bool valid, GXColor color )
{
	SIGHTEFFECT *sg = ( SIGHTEFFECT * )Effect->Data ;

	sg->circlecolorf = valid ;
	sg->circlecolor = *((u32 *)&color ) ;
}

// S̃p[c̐FύX
extern void SetSightCircleColor( EFFECT *Effect, bool valid, u32 color )
{
	SIGHTEFFECT *sg = ( SIGHTEFFECT * )Effect->Data ;

	sg->circlecolorf = valid ;
	sg->circlecolor = color ;
}
	
// `[WxZbg
extern void SetSightChargeLevel( EFFECT *Effect, s32 chargelevel )
{
	SIGHTEFFECT *sg = ( SIGHTEFFECT * )Effect->Data ;
	
	sg->chargelevel = chargelevel ;
//	sg->brinkcon = 0 ;
}

