// =============================================================================
//
//	t@Cǂݍ݃NX
//
//	YK7File.cpp
//
//	Creator			: Takumi Yamada(GHM)
//	Creation Date	: 04/26/04
//
// =============================================================================

// include --------------------------------------
#include "./YK7File.h"
#include "./YK7Effect.h"

// define ---------------------------------------

// data type ------------------------------------

// data -----------------------------------------

// function proto type --------------------------

extern void YK7FileTask( ghmGcTask *pTask ) ;		// YK7File NX̃t[vZXĂԊ֐

// class code -----------------------------------

// YK7File NX̃t[vZXĂԊ֐
extern void YK7FileTask( ghmGcTask *pTask )
{
	YK7File *CFile = ( YK7File * )GHMGCTASK_GETPARAM(0) ;
	pTask = pTask ;
	
	for(;;)
	{
		CFile->FrameProcess() ;
		retsys() ;
	}
}


// t@CJ
bool YK7File::Open( char *Path )
{
	s32 id ;

	if( State != ST_NOOPEN ) CloseB() ;
	
	CFile = NULL ;
	CTask = NULL ;

	ghmGcMemSetAllocName("YFile");
	if( ( CFile = new ghmGcFile ) == NULL ) goto ERR ;
	if( CFile->Open( Path ) == false ) goto ERR ;
	
	State = ST_IDLE ;
	FileSize = CFile->GetLength() ;

	// Vt@Cǂݍ݃^XNǉ
	id = EffSys.TaskCon->Start( YK7FileTask, (u32)this, 0, NULL, (s32)( 4 * 1024 ), (s32)( 500 + EffSys.FirstPriority + 1 ) ) ;
	if( id == -1 ) goto ERR ;
	CTask = EffSys.TaskCon->GetTask( id ) ;

	return true ;
	
ERR :
	if( CFile != NULL ) delete CFile ;
	CFile = NULL ;
	if( CTask != NULL ) delete CTask ;
	CTask = NULL ;

	return false ;
}


// t@Cǂݍ
bool YK7File::Read( void *Buffer, int Offset, int Length )
{
	if( State == ST_NOOPEN ) return false ;

	if( State == ST_READ ){ while( State == ST_READ ) Process() ; }
	
	State = ST_READ ;
	
	DestBuf = Buffer ;
	CompLength = 0 ;
	DestLength = Length ;
	StartOffset = Offset ;

	if( DestLength + StartOffset > FileSize ) DestLength = (int)( FileSize - StartOffset ) ;
	
	if( Process() == false ) return false ;

	return true ;
}

// ǂݍ݃LZ
bool YK7File::Cancel( bool sync )
{
	if( State == ST_NOOPEN ) return false ;
	if( State == ST_IDLE ) return true ;

	if( sync == true ) 
	{
		CFile->CancelB() ;
		State = ST_IDLE ;
	}
	else
	{
		CFile->Cancel() ;
	}
	
	return true ;
}

// t@C
bool YK7File::Close( bool sync )
{
	if( State == ST_NOOPEN ) return false ;
	if( State == ST_CLOSE ) return false ;

	if( sync == true )
	{
		Cancel( true ) ;
	}

	if( State == ST_READ )
	{
		CFile->CancelB() ;
		
		State = ST_CLOSE ;
	}
	else
	{
		delete CTask ;
		CTask = NULL ;
		
		CFile->Close() ;
		delete CFile ;
		CFile = NULL ;
		
		State = ST_NOOPEN ;
	}
	
	return true ;
}

// t[vZX
bool YK7File::Process( void )
{
	s32 Length ;

	if( State == ST_NOOPEN ) return true ;
	if( State == ST_IDLE ) return true ;
	
	CFile->FrameProcess() ;
	if( CFile->GetState() != ghmGcFile::READFINISH )
		return true ;
		
	switch( State )
	{
	case ST_READ :
		if( CompLength == DestLength )
		{
			State = ST_IDLE ;
		}
		else
		{
			Length = DestLength - CompLength ;
			if( Length > OneLength && OneLength != -1 ) Length = OneLength ;
			
			CFile->Read( ((u8 *)DestBuf) + CompLength + StartOffset, CompLength, Length ) ;
			CompLength += Length ;
		}
		break ;
		
	case ST_CLOSE :
		State = ST_IDLE ;
		Close() ;
		break ;
	}

	return true ;
}


// Ԃ擾
YK7File::STATE YK7File::GetState( void )
{
	Process() ;

	return State ;
}


// t@Cǂݍ
bool YK7ResLink::Read( char *Path )
{
	if( state != ST_NOOPEN ) return false ;
	
	file = NULL ;
	buffer = NULL ;
	reslink = NULL ;
	size = 0 ;
	state = ST_NOOPEN ;

	// t@CJ
	ghmGcMemSetAllocName("YFile");
	file = new YK7File ;
	if( file == NULL ) goto ERR ;
	if( file->Open( Path ) == false ) goto ERR ;
	
	// TCY擾
	size = file->GetLength() ;
	
	// obt@mۂ
	if( ( buffer = ghmGcMemAllocName( (s32)size, "YK7ResBin" ) ) == NULL ) goto ERR ;
	
	// ǂݍ݊Jn
	file->Read( buffer, 0, (s32)size ) ;
	file->Process() ;
	state = ST_READ ;
	
	// I
	return true ;
	
ERR :
	if( file ) delete file ;
	if( buffer ) ghmGcMemFree( buffer ) ;
	
	file = NULL ;
	buffer = NULL ;
	reslink = NULL ;
	
	return false ;
}

// f[^
bool YK7ResLink::Release( void )
{
	if( file ) delete file ;
	if( reslink == NULL )
	{
		if( buffer ) ghmGcMemFree( buffer ) ;
	}
	else
	{
		delete reslink ;
	}
	
	file = NULL ;
	reslink = NULL ;
	buffer = NULL ;
	state = ST_NOOPEN ;
	size = 0 ;

	// I
	return true ;
}

// t[vZX
bool YK7ResLink::FrameProcess( void )
{
	switch( state )
	{
	case ST_NOOPEN :
		break ;
		
	case ST_READ :
		file->Process() ;
		if( file->GetState() != ST_IDLE ) break ;
		
		// \[XNNX̍쐬
		reslink = new((ghmGcResLink *)buffer ) ghmGcResLink ;
		if( reslink == NULL )
		{
			state = ST_ERROR ;
			break ;
		}
		
		// t@CNX̍폜
		delete file ;
		file = NULL ;
		
		// ǂݍݏIԂ
		state = ST_IDLE ;
		
		break ;
		
	case ST_IDLE : break ;
	case ST_ERROR : break ;
	}
	
	return true ;
}


