///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7Model
//
// YK7Model.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/09/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7MODEL_H
#define	__YK7MODEL_H

// include --------------------------------------
#include "../Wat/WK7Model.h"
#include "../Wat/WK7Light.h"
#include "../Wat/WK7Archive.h"
#include "./YK7File.h"

// define ---------------------------------------

#define MODEL_LIGHT_MAXNUM		(10)

// data type ------------------------------------

// fA[JCuf[^
typedef struct tagYMODEL
{
	bool loadflag ;						// [htO

	void *buf ;							// A[JCũobt@
	YK7File file ;						// t@Cǂݍ݃NX

	ghmGcTask *ReleaseTask ;			// p^XN
	ghmGcTask *LoadTask ;				// ǂݍݗp^XN

	WK7Archive *a ;						// A[JCu
	WK7Model *d ;						// ff[^
	WK7ModelMotion *m ;					// [Vf[^
	WK7Light *l[MODEL_LIGHT_MAXNUM+1] ;	// Cgf[^
	
//	char path[128] ;					// f̃t@CpX
	char path[64] ;						// f̃t@CpX
} YMODEL ;

// [VA[JCuf[^
typedef struct tagYMOTION
{
	void *buf ;				// A[JCũobt@
	YK7File file ;			// t@Cǂݍ݃NX

	WK7Archive *a ;			// A[JCu
	WK7ModelMotion *d ;		// [Vf[^
} YMOTION ;

// data -----------------------------------------

// function proto type --------------------------

extern bool CreateModelMem( void *Buf, YMODEL *model ) ;			// ɓǂݍ܂ĂA[JCuC[W烂f쐬
extern bool CreateModel( WK7Archive *arc, YMODEL *model ) ;			// ɓǂݍ܂ĂA[JCu烂f쐬
extern bool LoadModel( char *filename, YMODEL *model ) ;			// ff[^̓ǂݍ
extern bool CheckModel( YMODEL *model ) ;							// ff[^ǂݍݏI`FbN( true:I false:܂ )
extern bool ReleaseModel( YMODEL *model ) ;							// ff[^̉
extern bool CheckModelRelease( YMODEL *model ) ;					// ff[^̉`FbN

extern bool AttachModel( YMODEL *dest, char *AttachName, YMODEL *src ) ;		// fA^b`
extern bool DetachModel( YMODEL *dest, char *DetachName, YMODEL *src ) ;		// fŃ^b`

extern bool AttachModelMotion( YMODEL *model, YMOTION *motion, YMODEL *motion2 = NULL ) ;		// w̃[VfɃA^b`
extern bool AttachModelMotion( YMODEL *model, YMODEL *motion ) ;								// w̃[VfɃA^b`
extern bool AttachModelMotionAll( YMODEL *model, YMOTION *motion, YMODEL *motion2 = NULL ) ;	// w̃[VfɃA^b`
extern bool AttachModelMotionAll( YMODEL *model, YMODEL *motion ) ;								// w̃[VfɃA^b`
extern bool DetachModelMotion( YMODEL *model ) ;								// [Ṽf^b`
extern bool PlayModelMotion( YMODEL *model, f32 PlayTime, bool LoopFlag ) ;		// [VĐ
extern bool PlayModelMotionAll( YMODEL *model, f32 PlayTime, bool LoopFlag ) ;	// [VĐ
extern bool CheckModelMotion( YMODEL *model ) ;						// [VĐǂ𓾂( TRUE:Đ  FALSE:~ )
extern bool DispModelLight( YMODEL *model, s32 LightNumber = 0 ) ;	// ff[^ɃCg݂ꍇ́ÃCgLɂ

extern bool CreateMotion( WK7Archive *arc, YMOTION *motion ) ;	// ɓǂݍ܂ĂA[JCu烂[V쐬
extern bool LoadMotion( char *filename, YMOTION *motion ) ;	// [Vf[^̓ǂݍ
extern bool CheckMotion( YMOTION *motion ) ;				// [Vf[^ǂݍݏI`FbN( true:I false:܂ )
extern bool ReleaseMotion( YMOTION *motion ) ;				// [Vf[^̉
extern bool CheckMotionRelease( YMOTION *motion ) ;			// [Vf[^̉`FbN

#endif // __YK7MODEL_H
