///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7StageTitle
//
// YK7StageTitle.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/04/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef K7APP_MASTER
#define __DEBUGMODE
#endif

// include --------------------------------------
#include "./YK7StageTitle.h"
#include "./YK7Effect.h"
#include "./YK7File.h"
#include "./YK7String.h"
#include "./YK7EffectNoise.h"
#include "../Wat/WK7Player.h"

// define ---------------------------------------

#define MAX_CHARNUM		(25)		// ő啶
#define FILE_PATH		"/Yam/Map/StageTitle/"

#define ENGSTRY			(410)
#define ENGSTRW			(20)
#define ENGALPHA		(PR[0])
#define ENGWAIT			(PR[3])

//#define FADETIME		(128)			// tF[hAEg̎
#define FADETIME		(64)			// tF[hAEg̎

#define ENDBRINKNUM		(3)				// oŌɃJ[\_ł

#define RES_ENGFONT		(0)
#define RES_BLUR		(1)
#define RES_FONT		(2)
#define RES_ORDER_NO	(3)
#define RES_STR			(4)

#define PR				(s32)VParam[ED_STTITLE]
#define CWAIT			(3)
#define ENDWAIT			(PR[1])
#define EXTIME			(PR[14])
#define BACKSIZE		((f32)PR[15] * 0.01F)

#define SHDADDX			(8)
#define SHDADDY			(35)

#define ONECHAR_WAIT	(PR[16])
#define ORDER_ENDWAIT	(PR[17])
#define CBRINK_WAIT		(PR[18])
#define BLUR_ALPHA		(0)
#define BLUR_X			(18-16)
#define BLUR_Y			(21-16)
#define BLUR_SIZ		((f32)127 * 0.01F)
#define SC2WAIT			(PR[25])
#define CURSOR_W		(PR[22])
#define CURSOR_H		(PR[23])
#define TOPBRIGHT		(PR[26])
#define BOTBRIGHT		(PR[27])
#define BOTY			(PR[29])
#define BOYSIZ			((f32)PR[24] * 0.01F)
#define CHANGEWAIT		(3)
#define JIKANUP			(PR[20]-16)
#define JIKANBOT		(PR[21]-16)
#define EXRATE			((f32)PR[28] * 0.01F)
#define LINE2Y			(PR[19])

// data type ------------------------------------

// ꕶӂ̏
typedef struct tagSTCHARINFO
{
	s16 x, y ;
	u8 siz ;
} STCHARINFO ;

// Xe[W^Cg̃VXef[^
typedef struct tagSTAGETITLE
{
	bool initflag ;					// tO
	bool readflag ;					// ǂݍ݊tO
	bool endflag ;					// ItO

	TEXDATA Order ;					// I[_[eNX`
	TEXDATA Blur ;					// ̃u[peNX`
	YK7StrImage *Font ;				// ^CgƂďotHgC[W
	YK7StrImage *EngFont ;			// pptHg

	u8 strlen[2], linenum ;			// ̒Es̐
	u8 drawlen[2] ;					// `悷镶̐
	u8 cflag, ccon, ccon2 ;			// J[\`tOAJ[\`^C~OvpJE^
	u8 cy ;							// J[\̂xW
	u8 backdrawcon ;				// Ỏʂ`悵Ă鎞
	
	u32 engcon ;					// po̓JE^

	EFFECT *Noise ;					// mCYGtFNgp|C^
		
	TEXDATA Tex[MAX_CHARNUM] ;		// eNX`
	u8 charfre[MAX_CHARNUM] ;		// t[
	
	s32 initmod, initcon ;
	
	u8 mod1, mod2, mod3 ;
	s32 con1, con2 ;

	YK7ResLink *pack ;				// ^CgOtBbÑpbNt@C

	u8 drawcharnum ;				// \LN^̐
	u8 charnum ;					// ̑
	STAGE_TITLE no ;				// Ă^Cghc

	char CharSSMName[64] ;			// v[[rrlt@C
} STAGETITLE ;

// data -----------------------------------------

static STAGETITLE stgt ;			// Xe[W^Cgf[^

#include "YK7StageTitleDat.h"

// function proto type --------------------------

static void __StageTitleShred1( bool draw ) ;		// Xe[W^CgXbhP
static void __StageTitleShred2( bool draw ) ;		// Xe[W^CgXbhQ

// function code --------------------------------

// \tgŕK͎sĂ֐
extern bool InitStageTitleData( void )
{
	// [
	MEMINIT( stgt ) ;
	
	return true ;
}


// Xe[W^Cg̏
extern bool StageTitleInit( STAGE_TITLE No )
{
	char path[128] ;
	
	if( stgt.initflag == true ) return false ;
	
	// pbNt@C̓ǂݍ
	ghmGcMemSetAllocName("YResLink");
	if( ( stgt.pack = new YK7ResLink ) == NULL ) return false ;
	sprintf( path, "%sst%02d.rsl", FILE_PATH, (int)No ) ;
	if( stgt.pack->Read( path ) == false )
	{
		OSReport( "}bvppbNt@C %s J܂ł", path ) ;
		return false ;
	}
	
	// ԍ̕ۑ
	stgt.no = No ;
	
	// ̑𐔂
	for( stgt.charnum = 0 ; StageCharTable[No][stgt.charnum].x != -1 ; stgt.charnum ++ )
		stgt.charfre[stgt.charnum] = 0 ;
	stgt.drawcharnum = 0 ;
	
	// ˗̒𓾂
	stgt.strlen[0] = (u8)( strlen( __OrderStr[No][0] ) / 2 ) ;
	if( __OrderStr[No][1] != NULL )
	{
		stgt.strlen[1] = (u8)( strlen( __OrderStr[No][1] ) / 2 ) ;
		stgt.linenum = 2 ;
	}
	else
	{
		stgt.strlen[1] = 0 ;
		stgt.linenum = 1 ;
	}

	// J[\֌W̏
	stgt.cflag = FALSE ;
	stgt.ccon = 0 ;
	stgt.ccon2 = 0 ;
	stgt.cy = 0 ;	
	stgt.drawlen[1] = stgt.drawlen[0] = 0 ;

	// ̑f[^̏
	stgt.initmod = 0 ; stgt.initcon = 0 ;
	stgt.mod1 = 0 ; stgt.mod2 = 0 ; stgt.mod3 = 0 ;
	stgt.con1 = 0 ; stgt.con2 = 0 ;
	stgt.backdrawcon = 0 ;
	stgt.Noise = NULL ;
	stgt.Font = NULL ;
	stgt.engcon = 0 ;
	

	stgt.initflag = true ;
	stgt.readflag = false ;
	stgt.endflag = false ;
	
	return true ;
}


// Xe[W^Cg̃ZbgAbv`FbN( true:Ă  false:܂ )
extern bool CheckStageTitleSetup( void )
{
	s32 i ;

	if( stgt.initflag == false ) return false ;
	if( stgt.readflag == true ) return true ;

	switch( stgt.initmod )
	{
	case 0 :
		// t@C̉
		if( gpSound->mReleasePcSsm() == false ) return false ;
		stgt.initmod ++ ;
		
	case 1 :
		// t@C̓ǂݍ
		if( gpSound->mReadSsm( "seSTitle.ssm", eBank3 ) == false ) return false ;
		stgt.initmod ++ ;
		
	case 2 :
		// t@C̓ǂݍݏI҂
		if( gpSound->mGetProcess() != eSndStandby ) return false ;
		stgt.initmod ++ ;
		
	case 3 :
		// pbNt@C̓ǂݍ݊`FbN
		if( stgt.pack->GetState() != YK7ResLink::ST_IDLE ) return false ;
		stgt.initmod ++ ;
		
	case 4 :
		// pptHgf[^\z
		ghmGcMemSetAllocName("YStrImg");
		stgt.EngFont = new YK7StrImage ;
		if( stgt.EngFont == NULL ) return false ;
		stgt.initmod ++ ;
		
	case 5 :
		// pptHg̓ǂݍ
		if( stgt.EngFont->LoadMem( stgt.pack->GetGroup()->GetResource(RES_ENGFONT) ) == false ) return false ;
		stgt.initmod ++ ;
		
	case 6 :
		// pbNt@C̒̃eNX`
		for( i = 0 ; i < stgt.charnum ; i ++ )
			TexLoadSetMem( stgt.pack->GetGroup()->GetResource(i+RES_STR), &stgt.Tex[i] ) ;

		// ˗u[p̃eNX`
		TexLoadSetMem( stgt.pack->GetGroup()->GetResource(RES_BLUR), &stgt.Blur ) ;
		
		stgt.initmod ++ ;
		
	case 7 :
		// ˗`ptHgf[^\z
		ghmGcMemSetAllocName("YStrImg");
		stgt.Font = new YK7StrImage ;
		if( stgt.Font == NULL ) return false ;
		stgt.initmod ++ ;
		
	case 8 :
		// ˗`ptHgf[^̓ǂݍ
		if( stgt.Font->LoadMem( stgt.pack->GetGroup()->GetResource(RES_FONT) ) == false ) return false ;
		stgt.initmod ++ ;

	case 9 :
		// ˗io[eNX`
		TexLoadSetMem( stgt.pack->GetGroup()->GetResource(RES_ORDER_NO), &stgt.Order ) ;
		stgt.initmod ++ ;
		
	case 10 :
		// ǂݍݏI
		stgt.readflag = true ;
			
		return true ;
	}

	return false ;
}

// Xe[W^Cg̏I( true:IĂ  false:܂ )
extern bool CheckStageTitleEndState( void )
{
	return stgt.endflag ;
}

// Xe[W^Cǧn
extern bool StageTitleEnd( void )
{
	s32 i ;

	if( stgt.initflag == false ) return true ;
	
	gpSound->mReleaseSsm( "seSTitle.ssm" ) ;
	if( WK7PLAYERCONTROL->GetMainID() != 0xffffffff && WK7PLAYERCONTROL->GetReleaseState()==WK7PlayerControl::LOADED ){
		gpSound->mReadPcSsmReq( WK7PLAYERCONTROL->GetMainID() ) ;
	}

	// Xe[W^CgeNX`̌n	
	if( stgt.readflag == true )
	{
		for( i = 0 ; i < stgt.charnum ; i ++ ) TexRelease( &stgt.Tex[i] ) ;
	}
	
	// ˗u[p̃eNX`̌n
	TexRelease( &stgt.Order ) ;

	// ˗`ptHgf[^̌n
	if( stgt.Font ) delete stgt.Font ;
	stgt.Font = NULL ;

	// p`ptHgf[^̌n
	if( stgt.EngFont ) delete stgt.EngFont ;
	stgt.EngFont = NULL ;

	// ˗io[eNX`̌n
	TexRelease( &stgt.Order ) ;
	
	// GtFNg̍폜
	if( stgt.Noise ) DeleteEffect( stgt.Noise ) ;
	stgt.Noise = NULL ;

	// pbNf[^̌n
	if( stgt.pack != NULL ) delete stgt.pack ;
	stgt.pack = NULL ;
	
	stgt.mod1 = 0 ;	stgt.mod2 = 0 ; stgt.mod3 = 0 ;
	stgt.con1 = 0 ;	stgt.con2 = 0 ;
	stgt.engcon = 0 ;
	
	stgt.initflag = false ;
	stgt.readflag = false ;
	stgt.endflag = false ;
	
	// I
	return true ;
}


// Xe[W^CgXbhP
static void __StageTitleShred1( bool draw )
{
	if( draw )
	{
		s32 i ;
		u32 color ;
		f32 x, y, rate ;
		STCHARINFO *cr ;
		u8 *tb ;

		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
		
		DrawBox( 0, 0, SCW, SCH, CMK( 0, 0, 0, 255 ) ) ;

		EffectBlendModeSetup( EF_BLEND_ALPHA ) ;	
		cr = StageCharTable[stgt.no] ;
		tb = __StateTable[stgt.no] ;
		color = CMK( tb[PL_R], tb[PL_G], tb[PL_B], tb[PL_A] ) ;
		for( i = 0 ; i < stgt.drawcharnum ; i ++, cr ++ )
		{
			DrawExTex(
					cr->x + TEXW( stgt.Tex[i] ) * (f32)cr->siz / 100.0F / 2.0F + SHDADDX,	// x 
					cr->y + TEXH( stgt.Tex[i] ) * (f32)cr->siz / 100.0F / 2.0F + SHDADDY,	// y
					 (f32)cr->siz / 100.0F * ( (f32)stgt.charfre[i] / EXTIME ) * BACKSIZE,	// ExRate
					 true,																	// leftupFlag
					 &stgt.Tex[i], color ) ;  // CMK( PR[5], PR[6], PR[7], PR[8] ) ) ;
		}

		EffectBlendModeSetup( EF_BLEND_ADD ) ;	
		cr = StageCharTable[stgt.no] ;
		for( i = 0 ; i < stgt.drawcharnum ; i ++, cr ++ )
		{
			x = cr->x + TEXW( stgt.Tex[i] ) * (f32)cr->siz / 100.0F /  2.0F ;
			y = cr->y + TEXH( stgt.Tex[i] ) * (f32)cr->siz / 100.0F / 2.0F ;
			rate = (f32)cr->siz / 100.0F * ( (f32)stgt.charfre[i] / EXTIME ) ;
			DrawExTex( x, y, rate, true, &stgt.Tex[i], CMK( PR[10], PR[11], PR[12], PR[13] ) ) ;
			DrawExTex( x, y, rate, true, &stgt.Tex[i], CMK( PR[10], PR[11], PR[12], PR[9] ) ) ;
		}

		// p`悷
		if( stgt.engcon > ENGWAIT )
		{
//			stgt.EngFont->SetColor2( color ) ;
//			if( StageEnglishStr[stgt.no][0][0] != NULL ) stgt.EngFont->DrawSStr( 320, ENGSTRY, StageEnglishStr[stgt.no][0][0], true, true ) ;
//			if( StageEnglishStr[stgt.no][0][1] != NULL ) stgt.EngFont->DrawSStr( 320, ENGSTRY + ENGSTRW, StageEnglishStr[stgt.no][0][1], true, true ) ;
//			if( StageEnglishStr[stgt.no][0][2] != NULL ) stgt.EngFont->DrawSStr( 320, ENGSTRY + ENGSTRW * 2, StageEnglishStr[stgt.no][0][2], true, true ) ;

			stgt.EngFont->SetColor2( CMK( TOPBRIGHT, TOPBRIGHT, TOPBRIGHT, ENGALPHA ) ) ;
			if( StageEnglishStr[stgt.no][0][0] != NULL ) stgt.EngFont->DrawSStr( 320 - 1, ENGSTRY - 1, StageEnglishStr[stgt.no][0][0], true, true ) ;
			if( StageEnglishStr[stgt.no][0][1] != NULL ) stgt.EngFont->DrawSStr( 320 - 1, ENGSTRY + ENGSTRW - 1, StageEnglishStr[stgt.no][0][1], true, true ) ;
			if( StageEnglishStr[stgt.no][0][2] != NULL ) stgt.EngFont->DrawSStr( 320 - 1, ENGSTRY + ENGSTRW * 2 - 1, StageEnglishStr[stgt.no][0][2], true, true ) ;
		}
	}
	else
	{
		s32 i ;
	
#ifdef __DEBUGMODE
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_START ) goto R1 ;
#endif
	
		switch( stgt.mod1 )
		{
		case 0 :
			stgt.con1 ++ ;
			if( stgt.con1 >= CWAIT )
			{
				const s32 snum = 6 ;
				s32 stable[snum] = { SFX_SYS_SCENARIO_TITLE_GLASS_A, SFX_SYS_SCENARIO_TITLE_GLASS_B, SFX_SYS_SCENARIO_TITLE_GLASS_C, SFX_SYS_SCENARIO_TITLE_GLASS_D, SFX_SYS_SCENARIO_TITLE_GLASS_E, SFX_SYS_SCENARIO_TITLE_GLASS_F } ;
			
				stgt.con1 = 0 ;
				
				PlayEffectSE( stable[GetRandINum(snum)] ) ;
				stgt.drawcharnum ++ ;
				if( stgt.drawcharnum == stgt.charnum )
				{
					stgt.mod1 ++ ;
				}
			}
			break ;
			
		case 1 :
			stgt.engcon ++ ;
			stgt.con1 ++ ;
			if( stgt.con1 >= ENDWAIT )
			{
		R1 :
				stgt.engcon = 0 ;
				stgt.con1 = 0 ;
				stgt.mod1 = 0 ;
				stgt.mod3 ++ ;
//				stgt.endflag = true ;
			}
			break ;
		}

		// g又	
		for( i = 0 ; i < stgt.drawcharnum ; i ++ )
		{
			if( stgt.charfre[i] < EXTIME ) stgt.charfre[i] ++ ;
		}
	}
}


// Xe[W^CgXbhQ
static void __StageTitleShred2( bool draw )
{
	if( draw )
	{
		s32 i, j ;
		f32 x, y, w, a ;
		char buf[3] ;
		const f32 chary[2] = { 213, 237 } ;
		u8 *tb ;
		
		a = stgt.mod1 == 4 ? 1.0F - (f32)stgt.con1 / FADETIME : 1.0F ;
		
		if( stgt.backdrawcon < CHANGEWAIT )
		{
			__StageTitleShred1( true ) ;
			if( stgt.Noise != NULL ) DrawEffect( stgt.Noise ) ;
			return ;
		}

		EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;

		DrawBox( 0, 0, SCW, SCH, CMK( 0, 0, 0, 255 ) ) ;
		
		EffectBlendModeSetup( EF_BLEND_ADD ) ;
		
		DrawTex( 218, 130, &stgt.Order, CMK( 255* a,255* a,255* a,255 ) ) ;

		tb = __StateTable[stgt.no] ;
		for( i = 0 ; i < stgt.linenum ; i ++ )
		{
			// `敶̒𓾂
			w = 0 ;
			stgt.Font->SetExRate( i == 0 ? 1.0F : EXRATE ) ;
			stgt.Font->SetJikan( ( i == 0 ) ? tb[PL_JIKAN]/*JIKANUP*/ : JIKANBOT ) ;
			for( j = 0 ; j < stgt.drawlen[i] ; j ++ )
			{
				strncpy( buf, &__OrderStr[(s32)stgt.no][i][j*2], 2 ) ; buf[2] = '\0' ;
				w += stgt.Font->DrawSStr( 0.0F, 0.0F, buf, false, false ) ;
			}
			
			// xW̎Zo
			y = chary[i] + ( i == 1 ? LINE2Y : 0 ) ;

			// `悷
			x = ( SCW - w ) / 2.0F ;
			for( j = 0 ; j < stgt.drawlen[i] ; j ++ )
			{
				strncpy( buf, &__OrderStr[(s32)stgt.no][i][j*2], 2 ) ; buf[2] = '\0' ;
				DrawExTex( x + BLUR_X, y + BLUR_Y, BLUR_SIZ, true, &stgt.Blur, CMK( 255* a, 255* a, 255* a, BLUR_ALPHA ) ) ;

				stgt.Font->SetExRate( i == 0 ? 1.0F : EXRATE ) ;

				stgt.Font->SetColor2( CMK( TOPBRIGHT* a, TOPBRIGHT* a, TOPBRIGHT* a, 255 ) ) ;
				stgt.Font->SetJikan( ( i == 0 ) ? tb[PL_JIKAN]/*JIKANUP*/ : JIKANBOT ) ;
				stgt.Font->DrawSStr( x, y, buf, false, true ) ;

				stgt.Font->SetColor2( CMK( 255* a, 255* a, 255* a, BOTBRIGHT ) ) ;
				stgt.Font->SetReverseFlag( true ) ;
				stgt.Font->SetExRate2( i == 0 ? 1.0F : EXRATE, BOYSIZ ) ;
				x += stgt.Font->DrawSStr( x, y + BOTY, buf, false, true ) ;
				stgt.Font->SetExRate2( 1.0F, 1.0F ) ;
				stgt.Font->SetReverseFlag( false ) ;
			}
			
			if( stgt.cflag && i == stgt.cy )
			{
				f32 y ;
			
				y = chary[stgt.cy] + stgt.Font->GetHeight() + ( i == 1 ? LINE2Y : 0 ) ;
				DrawBox( x, y - CURSOR_H, x + ( CURSOR_W * ( i == 0 ? 1.0F : EXRATE ) ), y - ( CURSOR_H - CURSOR_H * ( i == 0 ? 1.0F : EXRATE ) ), CMK( TOPBRIGHT* a, TOPBRIGHT* a, TOPBRIGHT* a, 255 ) ) ;  
			}
		}

		// p`悷
		if( stgt.engcon > ENGWAIT )
		{
			stgt.EngFont->SetColor2( CMK( TOPBRIGHT* a, TOPBRIGHT* a, TOPBRIGHT* a, ENGALPHA ) ) ;
			if( StageEnglishStr[stgt.no][1][0] != NULL ) stgt.EngFont->DrawSStr( 320, ENGSTRY, StageEnglishStr[stgt.no][1][0], true, true ) ;
			if( StageEnglishStr[stgt.no][1][1] != NULL ) stgt.EngFont->DrawSStr( 320, ENGSTRY + ENGSTRW, StageEnglishStr[stgt.no][1][1], true, true ) ;
			if( StageEnglishStr[stgt.no][1][2] != NULL ) stgt.EngFont->DrawSStr( 320, ENGSTRY + ENGSTRW * 2, StageEnglishStr[stgt.no][1][2], true, true ) ;
		}

		if( stgt.Noise != NULL ) DrawEffect( stgt.Noise ) ;
	}
	else
	{
		if( stgt.Noise != NULL ) MoveEffect( stgt.Noise ) ;
		
		// J[\
		if( stgt.ccon2 < ENDBRINKNUM )
		{
			stgt.ccon ++ ;
			if( stgt.ccon >= CBRINK_WAIT )
			{
				stgt.ccon = 0 ;
				stgt.cflag = (u8)( stgt.cflag == TRUE ? FALSE : TRUE ) ;
				if( stgt.cflag == TRUE )
				{
					if( stgt.mod1 == 3 ) stgt.con1 ++ ;
					PlayEffectSE( SFX_SYS_SCENARIO_TITLE_CURSOR ) ;
				}
				else
				{
					if( stgt.mod1 >= 3 )
						stgt.ccon2 ++ ;
				}
			}
		}
		
#ifdef __DEBUGMODE
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_START ) goto R1 ;
#endif

		switch( stgt.mod1 )
		{
		case 0 :
			stgt.Noise = CreateNoiseEffect() ;
			if( stgt.Noise == NULL ) return ;
			SetEffectIndeManageFlag( stgt.Noise, TRUE ) ;
			
			stgt.cflag = FALSE ;
			stgt.ccon = (u8)( CBRINK_WAIT / 2 ) ;
			stgt.backdrawcon = 0 ;
			
//			PlayEffectSE( SFX_SYS_SCENARIO_TITLE_CURSOR ) ;
			PlayEffectSE( SFX_SYS_SCENARIO_TITLE_NOIZ ) ;

			// mCY̒ǉ
			AddNoiseLine( stgt.Noise, (u8)VParam[ED_CHARCHANGE][3], VParam[ED_CHARCHANGE][4],
									VParam[ED_CHARCHANGE][5], VParam[ED_CHARCHANGE][6], -1 ) ;
			stgt.con1 = ONECHAR_WAIT ;
			stgt.mod1 ++ ;
			
		case 1 :
			stgt.con1 ++ ;
			stgt.backdrawcon ++ ;
			if( stgt.con1 >= SC2WAIT )
			{
				stgt.con1 = 0 ;
				stgt.con2 = 0 ;
				stgt.mod1 ++ ;
			}
			break ;

		case 2 :
			if( stgt.con2 == 0 )
			{
				PlayEffectSE( SFX_SYS_SCENARIO_TITLE_IRAI ) ;
				stgt.con2 ++ ;
			}
			stgt.con1 ++ ;
			if( stgt.con1 > ONECHAR_WAIT )
			{
				stgt.ccon = 0 ;
				stgt.cflag = TRUE ;
				stgt.con1 = 0 ;
				if( stgt.drawlen[stgt.cy] == stgt.strlen[stgt.cy] )
				{
					stgt.cy ++ ;
					if( stgt.cy >= stgt.linenum )
					{
//						PlayEffectSE( SFX_SYS_SCENARIO_TITLE_IRAI ) ;
						stgt.cy -- ;
						stgt.con1 = 0 ;
						stgt.mod1 ++ ;
						return ;
					}
				}
				else
				{
//					if( stgt.drawlen[stgt.cy] % 4 == 0 )
//						PlayEffectSE( SFX_SYS_SCENARIO_TITLE_IRAI ) ;
					stgt.drawlen[stgt.cy] ++ ;
				}
			}
			break ;

		case 3 :
//			stgt.con1 ++ ;
			stgt.engcon ++ ;
//			if( stgt.con1 >= ORDER_ENDWAIT )
			if( stgt.ccon2 >= ENDBRINKNUM )
			{
				stgt.mod1 ++ ;
				stgt.con1 = 0 ;
			}
			break ;
			
		case 4 :
			stgt.con1 ++ ;
			if( stgt.con1 >= FADETIME )
			{
		R1 :
				stgt.engcon = 0 ;
				stgt.endflag = true ;
			}
			break ;
		}
	}
}


// Xe[W^Cg̃t[vZX
extern bool StageTitleFrameProcess( void )
{
	if( stgt.initflag == false ) return false ;
	if( stgt.endflag == true ) return true ;
	if( stgt.readflag == false ) return false ;
	
	switch( stgt.mod3 )
	{
	case 0 : __StageTitleShred1( false ) ; break ;
	case 1 : __StageTitleShred2( false ) ; break ;
	}

	return true ;
}


// Xe[W^Cg̃_OvZX
extern bool StageTitleRenderProcess( void )
{
	if( stgt.initflag == false ) return false ;
	if( stgt.readflag == false ) return false ;
	
	switch( stgt.mod3 )
	{
	case 0 : __StageTitleShred1( true ) ; break ;
	case 1 : __StageTitleShred2( true ) ; break ;
	}

	return true ;
}






