#include "common.h"
#include "utility.h"
#include "c_ball.h"

void C_Ball::Proc( void )
{
	C_Vec gravity(0,kGravity,0),tmp;
	old_trs = trs;

	jobj.Proc();
	vel += acl;
	vel += gravity;
	trs += vel;

	int count = 3,i;
	C_Vec n,t = trs;
	for( i=0; i<count; i++ ){
	  C_Coll coll( trigon, old_trs, trs, 1.f );
	  if( coll.Result() ){
		if( i == (count-1) ){
		  trs = old_trs;
		}else{
		  C_Vec nrm = n = coll.GetNrm();
		  f32 VdotN = nrm | vel;
		
		  C_Vec Vn( (nrm * VdotN) );
		  C_Vec Vt( vel - Vn );
	  
		  Vn *= 0.5f;
		  vel = Vt - Vn;

		  trs = coll.GetPos() + vel;
		  tri_ptr = coll.GetTrigon();
		}
	  }else{
		break;
	  }
	}
	vel *= 0.9f;

#if 0
	OSReport( "----%d----\n", i );
	HSD_DmpVector( "src", &t );
	HSD_DmpVector( "dst", &trs );
	HSD_DmpVector( "vel", &vel );
	HSD_DmpVector( "nrm", &n );
	if( trs.y < 1.0f ){
	  assert(0);
	}
#endif
	if(HSD_PadGetTrigger(0) & HSD_PAD_A){
	  Init();
	}
	HSD_JObjSetTranslate( jobj.GetJObj(), &trs );
}
