#include "common.h"
#include "c_bloodline.h"

C_BloodLines::C_BloodLines( HSD_JObj *_body_jobj, HSD_JObj *_tgt_jobj, s32 _num_type1, s32 _num_type2 )
{
  //̃fB
  envelope = new C_Envelope( _body_jobj );

  //RXgCB
  tgt_jobj = _tgt_jobj;

  //{B
  num_type1 = _num_type1;
  num_type2 = _num_type2;
  
  //֍쐬B
  s32 tri_num = envelope->GetTrigonNum();
  C_Vec pos( 0.f, 0.f, 0.f );
  C_Vec dir( 0.f, -1.f, 0.f );

  type1 = new C_BloodLine[ num_type1 ];
  {
	s32 mtx_rate[10]={0,};
	s32 amount=0;
	for( int i=0; i<tri_num; i++ ){
	  s32 tmp = envelope->GetTrigon( i ).GetMtxIdx()[0];
	  mtx_rate[tmp]++;
	}
	for( int i=0; i<10; i++ ){
	  mtx_rate[i] = mtx_rate[i] * num_type1 / tri_num;
	  amount += mtx_rate[i];
	}
	if( num_type1 - amount ){
	  mtx_rate[0] += (num_type1 - amount);
	}

	s32 mtx_count[10]={0,};
	s32 mtx_idx;
	for( int i=0; i<num_type1; i++ ){
	  type1[i].length = 0.2f * ( (HSD_Rand()%100) / 100.f ) + 0.05f;
	  type1[i].counter = (u16)((HSD_Rand()%180));
	  type1[i].kill_frm = (u16)(5+(HSD_Rand()%10));
	  for( int j=0; j<10; j++ ){ 
		if( mtx_rate[j] > mtx_count[j] ){
		  mtx_idx = j;
		  break;
		}
	  }
	  while( 1 ){
		type1[i].tri_idx = (s16)(HSD_Rand()%tri_num);
		if( mtx_idx == envelope->GetTrigon( type1[i].tri_idx ).GetMtxIdx()[0] ){
		  mtx_count[mtx_idx]++;
		  break;
		}
	  }
	  //type1[i].seawead = new C_SeaWead( 10, pos, dir, 0.0001f, 1.f, 70.f, 0.7f );
	  type1[i].seawead = new C_SeaWead( 10, pos, dir, 0.001f, 1.f, 70.f, 0.7f );
	  type1[i].seawead->SetConstDumping( 0.7f );
	  //type1[i].seawead->SetRigidBind();
	}
  }

  type2 = new C_BloodLine[ num_type2 ];
  {
	s32 mtx_count[10]={0,};
	s32 mtx_idx;
	for( int i=0; i<num_type2; i++ ){
	  type2[i].counter = (u16)(HSD_Rand()%180);
	  type2[i].kill_frm = (u16)(5+(HSD_Rand()%10));
	  s32 tmp = 32768;
	  for( int j=0; j<10; j++ ){ 
		if( tmp>mtx_count[j] ){
		  tmp = mtx_count[j];
		  mtx_idx = j;
		}
	  }
	  while( 1 ){
		type2[i].tri_idx = (s16)(HSD_Rand()%tri_num);
		if( mtx_idx == envelope->GetTrigon( type2[i].tri_idx ).GetMtxIdx()[0] ){
		  mtx_count[mtx_idx]++;
		  break;
		}
	  }
	  //type2[i].seawead = new C_SeaWead( 12, pos, dir, 0.0001f, 1.f, 50.f, 0.8f );
	  type2[i].seawead = new C_SeaWead( 12, pos, dir, 0.001f, 1.f, 50.f, 0.8f );
	  type2[i].seawead->SetConstDumping( 0.7f );
	  //type2[i].seawead->SetRigidBind();
	}
  }

  started = false;
  fun_flg = 0;
  tip_flg = false;
  tip_reached = false;
  killed = 0;
}
void C_BloodLines::Kill( void ) { 
  if( started ) killed = 1; 
  for( int i_=0; i_<num_type2; i_++ ){
	type2[i_].seawead->SetSpringBind(0);
  }
}
C_BloodLines::~C_BloodLines()
{
  delete envelope;
  for( int i=0; i<num_type1; i++ ){
	delete type1[i].seawead;
  }
  delete [] type1;

  for( int i=0; i<num_type2; i++ ){
	delete type2[i].seawead;
  }
  delete [] type2;
}
void C_BloodLines::Proc( void )
{
  C_Vec pos,dir;
  HSD_JObjSetupMatrix( tgt_jobj );
  HSD_MtxGetTranslate( HSD_JObjGetMtxPtr( tgt_jobj ), &pos );

  tip_reached = false;
  for( int i=0; i<num_type1; i++ ){
	C_Trigon &tri = envelope->GetTrigon( type1[i].tri_idx );
	if( started ) {
	  if( killed ){
		//ÂJB
		s32 num_ = type1[i].seawead->GetNumParticle();
		s32 top_ = killed/type1[i].kill_frm;
		if( num_<top_ ) top_ = num_;
		for( int j=0; j<top_; j++ ){
		  type1[i].seawead->SetPos( (u32)j, *tri.GetVtx() );
		}
		type1[i].seawead->SetLineWidthRate( 0.3f + 0.7f * (1.f - (f32)(top_/(f32)num_)) );
		type1[i].seawead->SetShrink();
	  }else{
		C_Vec *anchor_pos = tri.GetVtx();
		dir = pos - *anchor_pos;
		//LkB
		s32 counter;
		type1[i].counter+=2;
		if( type1[i].counter > 210 ) type1[i].counter = 0;
		if( type1[i].counter > 180 )	counter = 0;
		else							counter = type1[i].counter;
		
		f32 val = sinf( counter * (f32)M_PI / 180.f);
		if( tip_flg ){
		  C_Vec t = tip_pos;
		  dir = t - *anchor_pos;
		  f32 l = dir.Mag();
		  dir.Nrm();
		  dir *= (0.01f + l * val * val);
		  dir += *anchor_pos;
		  type1[i].seawead->SetTipPos( dir );
		  if( dir.Dist( tip_pos ) < 0.5f ) tip_reached = true;
		}else{
		  dir *= (0.01f + type1[i].length * val * val * val * val );
		  dir += *anchor_pos;
		  type1[i].seawead->SetTipPos( dir );
		}

		dir = tri.GetNrm();
		dir.y += (HSD_Rand()%100)/100.f - 0.5f;
		dir.Nrm();
		if( (HSD_Rand()%100) > 80 ){
		  dir *= 300.f;
		}else{
		  dir *= 0.f;
		}
		for( int j=0; j<fun_flg; j++ )
		  type2[i].seawead->SetFun( fun_pos[j], fun_force[j] );
		type1[i].seawead->SetWind( dir );
	  }
	  type1[i].seawead->SetAnchorPos( *tri.GetVtx() );
	  type1[i].seawead->Proc();
	}
  }
  for( int i=0; i<num_type2; i++ ){
	C_Trigon &tri = envelope->GetTrigon( type2[i].tri_idx );
	if( started ){
	  if( killed ){
		//ÂJB
		s32 num_ = type2[i].seawead->GetNumParticle();
		s32 top_ = killed/type2[i].kill_frm;
		if( num_<top_ ) top_ = num_;
		for( int j=0; j<top_; j++ ){
		  type2[i].seawead->SetPos( (u32)j, *tri.GetVtx() );
		}
		type2[i].seawead->SetLineWidthRate( 0.3f + 0.7f * (1.f - (f32)(top_/(f32)num_)) );
		type2[i].seawead->SetShrink();
	  }else{
		dir.x = (HSD_Rand()%100)/50.f - 1.f + 0.01f;
		dir.y = (HSD_Rand()%100)/100.f;
		dir.z = 0.f;
		dir.Nrm();
		if( (HSD_Rand()%100) > 80 ){
		  dir *= 200.f;
		}else{
		  dir *= 0.f;
		}
		
		type2[i].seawead->SetTipPos( pos );
		for( int j=0; j<fun_flg; j++ )
		  type2[i].seawead->SetFun( fun_pos[j], fun_force[j] );
		type2[i].seawead->SetWind( dir );
	  }
	  type2[i].seawead->SetAnchorPos( *tri.GetVtx() );
	  type2[i].seawead->Proc();
	}
  }
  fun_flg = 0;
  tip_flg = false;
  if( killed ) ++killed;
}
void C_BloodLines::Disp( void )
{
  if( !started ) return;

  C_SeaWead::DispStart();
  for( int i=0; i<num_type1; i++ ){
	type1[i].seawead->Disp();
  }
  for( int i=0; i<num_type2; i++ ){
	type2[i].seawead->Disp();
  }
  C_SeaWead::DispEnd();
}

C_Vec C_BloodLines::GetPos( s32 type, s32 no )
{
  if( !type ){
	C_Trigon &tri = envelope->GetTrigon( type1[no].tri_idx );
	return *tri.GetVtx();
  }else{
	C_Trigon &tri = envelope->GetTrigon( type2[no].tri_idx );
	return *tri.GetVtx();
  }
}


void C_BloodLines::Start( void )
{
  if( started ) return;

  started = true;
  for( int i=0; i<num_type1; i++ ){
	C_Trigon &tri = envelope->GetTrigon( type1[i].tri_idx );
	type1[i].seawead->Reset( *tri.GetVtx(), tri.GetNrm(), 0.001f );
  }
  for( int i=0; i<num_type2; i++ ){
	C_Trigon &tri = envelope->GetTrigon( type2[i].tri_idx );
	type2[i].seawead->Reset( *tri.GetVtx(), tri.GetNrm(), 0.001f );
  }
}
void C_BloodLines::Stop( void )
{
  if( !started ) return;
  
#if 1
  started = false;
#else
  for( int i=0; i<num_type1; i++ ){
	type1[i].seawead->SetRigidBind();
  }
  for( int i=0; i<num_type2; i++ ){
	type2[i].seawead->SetRigidBind();
  }
  started = false;
#endif
}







