#include "common.h"
#include "c_cloth.h"
#include "c_coll.h"
#include "c_vec.h"
#include "utility.h"
//#define kDamping 0.99999f
#define kDamping 0.000099999f
#define kDiff 0

#define VECSCALE( A, B, C ) B.x = A.x * C; B.y = A.y * C; B.z = A.z * C; 
#define VECADD( A, B ) B.x = A.x; B.y = A.y; B.z = A.z;

/////////////////////////////////
//constructor
/////////////////////////////////

//bone_num, joint_num, HSD_JObj *root, HSD_JObj *jobj[]
//ŁAWCg̈ʒu(̍WnjɖԂ𒣂B
C_Cloth::C_Cloth( s16 bone_num, s16 joint_num, HSD_JObj *jobj[] ) 
  : wind( .0f, .0f, .0f )
{

  proc_counter = 0;
  grid_x = bone_num;
  grid_y = joint_num;

  num_ptcl = bone_num*joint_num;

  gravity.Set( 0.f, -1.0f, 0.f );

  //constrain_pow = 30.f;
  //constrain_pow_min = 6.f;
  constrain_pow = 60.f;
  constrain_pow_min = 2.f;
  const_spring =32.f;
  const_dspring = 0.5f;
  ptcl_buf[0] = ptcl_buf[1] = 0;
  spring = 0;
  ptcl_buf[0] = new PARTICLE[ num_ptcl ];
  ptcl_buf[1] = new PARTICLE[ num_ptcl ];
  cur = ptcl_buf[0];
  next = ptcl_buf[1];

  //p[eBNB
  PARTICLE *p0=cur,*p1=next;
  s32 count = 0;
  int i;
  int j;
  for( i=0; i<bone_num; i++ ){
	for( j=0; j<joint_num; j++ ){
	  HSD_JObj *current = jobj[count++];
	  HSD_JObjSetupMatrix( current );
	  p0->org_trs = current->translate;
	  p0->org_trs.Nrm();
	  C_Vec trs(current->mtx[0][3], current->mtx[1][3], current->mtx[2][3]);
	  if( !j ){
		p0->state = RIGID_BIND;
	  }else{
		p0->state = SPRING_BIND;
	  }
	  p0->pos = trs;
	  p0->vel.Set(0.f,0.f,0.f);
	  p0->force.Set(0.f,0.f,0.f);
	  //p0->mass = 0.07f;
	  p0->mass = 0.05f;
	  p0->InvMass = 1.0f / p0->mass;
	  p0->jobj = current;
	  p0->hit_flg = 0;
	  p0->dumping = 0.9f;

	  *p1 = *p0;
	  p1++;
	  p0++;
	}
  }
  //̃xNgoĂB
  //if[JWnɂj
  for( int i=0; i<bone_num; i++ ){
	for( int j=0; j<joint_num; j++ ){
	  if( j < joint_num-1 ){
		HSD_JObj *jobj0 = cur[ j + i * joint_num ].jobj;
		C_Vec trs0(jobj0->mtx[0][3], jobj0->mtx[1][3], jobj0->mtx[2][3]);

		HSD_JObj *jobj1 = cur[ j + 1 + i * joint_num ].jobj;
		C_Vec trs1(jobj1->mtx[0][3], jobj1->mtx[1][3], jobj1->mtx[2][3]);

		C_Vec dir = trs1 - trs0;

		//Ԃ̒B
		cur[ j + i * joint_num ].org_len = 
		next[ j + i * joint_num ].org_len = dir.Mag();

		Mtx m;
		if( MTXInverse( jobj0->mtx, m ) ){
		  //f̃[Jɖ߂B
		  MTXMultVecSR( m, &dir, &dir );

		  dir.Nrm();
		  cur[ j + i * joint_num ].org_dir = 
		  next[ j + i * joint_num ].org_dir = dir;
		  //OSReport( "%d %d\n", i, j );
		  //HSD_DmpVector( "", &cur[ i+j*bone_num ].org_dir );
		}else{
		  ASSERT2( 0, "No Inverse Matrix found.\n" );
		}
	  }
	}
  }

  //XvOB
  num_spring = 
	((bone_num-1) * joint_num) +  //B
	(bone_num * (joint_num-1)) +  //cB
	((bone_num-1)*(joint_num-1)*2);//ΊpB
  spring = new SPRING[ num_spring ];
  SPRING* sp = spring;
  p0 = cur;
  for( i=0; i<bone_num; i++ ){//row
	for( j=0; j<joint_num; j++ ){//column
	  //XvOB
	  if( i < bone_num-1 ){
		sp->p1 = (j+i*joint_num);
		sp->p2 = (j+(i+1)*joint_num);
		sp->length = p0[sp->p1].pos.Dist( p0[sp->p2].pos );
		sp->Ks = const_spring;
		sp->Kd = const_dspring;
		sp++;
	  }
	  //cXvOB
	  if( j < joint_num-1 ){
		sp->p1 = (j+i*joint_num);
		sp->p2 = (j+1+i*joint_num);
		sp->length = p0[sp->p1].pos.Dist( p0[sp->p2].pos );
		sp->Ks = const_spring + i * 10.f;
		sp->Kd = const_dspring + (joint_num-i) * 0.08f;
		sp++;
	  }
	  //ΊpXvOB
	  if( i<bone_num-1 ){
		if( j < joint_num-1 ){//΂߉B
		  sp->p1 = (j+i*joint_num);
		  sp->p2 = (j+(i+1)*joint_num+1);
		  sp->length = p0[sp->p1].pos.Dist( p0[sp->p2].pos );
		  sp->Ks = const_spring;
		  sp->Kd = const_dspring;
		  sp++;
		}

		if( j ){//΂ߏB
		  sp->p1 = (j+i*joint_num);
		  sp->p2 = (j+(i+1)*joint_num-1);
		  sp->length = p0[sp->p1].pos.Dist( p0[sp->p2].pos );
		  sp->Ks = const_spring;
		  sp->Kd = const_dspring;
		  sp++;
		}
	  }
	}
  }
  dtime = (f32)1.0 / 60.0f;

  warp_ofst.Set(0.f);
  warp_counter = 3;
}

C_Cloth::~C_Cloth()
{
  if( ptcl_buf[0] ) delete[] ptcl_buf[0];
  if( ptcl_buf[1] ) delete[] ptcl_buf[1];
  if( spring ) delete[] spring;
}

void C_Cloth::ResetParams( s16 bone_num, s16 joint_num, f32 params[][3] )
{
  //ォ,spring_constant,dumping,massݒB
  //columnDB

  //dʁBŌyʁ`ŏdʂ܂ł̃p[ZgB
  //_sOWBp[Zg
  {
	PARTICLE *p0=cur,*p1=next;
	s32 count = 0;
	for( int i=0; i<bone_num; i++ ){
	  for( int j=0; j<joint_num; j++ ){
		f32 mass = params[count][2];
		f32 dump = params[count++][1];
		p0->mass = p1->mass = 0.034f + (100.f - mass)/100.f * 0.04f;
		p0->InvMass = p1->InvMass = 1.f / p0->mass;
		p0->dumping = p1->dumping = dump / 100.f;
		p1++;
		p0++;
	  }
	}
  }
  
  //XvO萔
  {
	SPRING* sp = spring;
	PARTICLE *p0 = cur;
	for( int i=0; i<bone_num; i++ ){//row
	  for( int j=0; j<joint_num; j++ ){//column
		//cXvOB
		if( j < joint_num-1 ){
		  sp->Ks = (params[sp->p1][0] + params[sp->p2][0])*0.5f;
		  sp++;
		}
		//XvOB
		if( i < bone_num-1 ){
		  sp->Ks = params[sp->p1][0];
		  sp++;
		}
		//ΊpXvOB
		if( i < bone_num-1 ){
		  if( j < joint_num-1 ){//΂߉
			sp->Ks = (params[sp->p1][0] + params[sp->p2][0])*0.5f;
			sp++;
		  }
		  if( j ){//΂ߏ
			sp->Ks = (params[sp->p1][0] + params[sp->p2][0])*0.5f;
			sp++;
		  }
		}
	  }
	}
	//OSReport( "%d\n", ((u32)sp - (u32)spring ) / sizeof(SPRING) );
  }
}

void C_Cloth::ComputeForce( void )
{
  static s32 c=0;
  PARTICLE	*current,*p1, *p2;
  SPRING		*s;
  f32		dist, Hterm, Dterm;
  C_Vec		springForce,deltaV,deltaP,g;

  c+=(HSD_Rand()%5 + 2);
  current = cur;
  g = gravity * current->InvMass;
  for (int i = 0; i < num_ptcl; i++){
	current->force.Set(0.f, 0.f, 0.f);

	//d
	current->force += g;

	//
	s32 no = i % grid_y + 1;
	if( no == grid_y ){
	  f32 f = sinf(((c+45*no*(i/grid_x))%360)*(f32)M_PI/180.f);
	  C_Vec w = wind * (current->InvMass * f);
	  current->force += w;
	}

	//ɃftHgʒuɌď͂B
	//#if kDiff
#if 1
	//if( HSD_PadGetButton(1) & HSD_PAD_Y ){
	{
	  HSD_JObj *j_ = current->jobj;
	  HSD_JObjResetUserDefinedMtx( j_ );
	  HSD_JObjSetupMatrix( j_ );
	  C_Vec trs0_(j_->mtx[0][3], j_->mtx[1][3], j_->mtx[2][3]);
	  C_Vec trs1_ = current->pos;
	  f32 rate_ = ((grid_y-1) - (i % grid_y) )/(f32)(grid_y-1);
	  C_Vec v_=(trs0_-trs1_) * (constrain_pow * rate_ + constrain_pow_min);

	  current->force += v_;
	}
#endif

	//xB
	//#if kDiff
#if 1
#else
	f32 max_speed = 200.f;
	if( current->vel.Mag() > max_speed ){
	  //OSReport( "here %f\n", current->vel.Mag() );
	  current->vel.Nrm();
	  current->vel *= max_speed;
	}
#endif

	current++;
  }

  s = spring;
  for (int i = 0; i < num_spring; i++){
	p1 = &cur[s->p1];
	p2 = &cur[s->p2];

	//_̈ʒu̍
	deltaP = p1->pos - p2->pos;
	dist = deltaP.Mag();
	
	//Lы
	Hterm = (dist - s->length) * s->Ks * 0.5f;
		
	//_̈ړ̍
	deltaV = p1->vel - p2->vel;
	//_̈ړƃXvǑ߂قǁA
	//_m̋߂قǁA܂͈?

	Dterm = (deltaV|deltaP) * s->Kd / dist; 
	springForce = deltaP * (1.0f/dist);
	springForce *= -(Hterm+Dterm);

	p1->force += springForce;
	p2->force -= springForce;
	s++;
  }
}   

/////////////////////////////////////////
//RWB
/////////////////////////////////////////
static
bool _ResolveCollision( C_TrigonArray &tri, C_Cloth::PARTICLE *src, C_Cloth::PARTICLE *tgt, f32 dtime )
{
#pragma unused(dtime)

  C_Vec &old_trs = src->pos;
  C_Vec &new_trs = tgt->pos;
  C_Vec &vel = tgt->vel;

  C_Coll coll( tri, old_trs, new_trs, 0.1f );
  if( coll.Result() ){
	C_Vec nrm = coll.GetNrm();

	//HSD_DmpVector( "", &vel );
	//OSReport( "%f\n", vel.Mag() );
	//ꂽB
#if 0
	if( coll.Result() == C_Coll::COLL_TYPE2 ){
	  C_Vec v = coll.GetVel();
	  vel = vel + v * (1 / 60.f);
	}
	tgt->cv = vel;
#endif

	f32 VdotN = nrm | vel;

	C_Vec Vn = (nrm * VdotN);
	C_Vec Vt = (vel - Vn);
	  
	//#if kDiff
#if 1
	if( VdotN >= 0.f ) {
	  //ƕzisɐiłĂԂB
	  new_trs = coll.GetPos() + Vn * dtime;
	}else{
	  if( vel.Mag() > 10.f ){
		vel = Vt * 0.5f;
		new_trs = coll.GetPos() + vel * dtime;
	  }else{
		vel = Vt*0.01f;
		new_trs = coll.GetPos();
	  }
	}
#else
	vel = Vt - (Vn*0.1f);
	//Î~CB
	if( vel.Mag() > 1.f ){
	  new_trs = coll.GetPos();
	  //XCh邩ǂB
	  C_Vec v = vel * dtime * 0.01f;
	  //X^[gn_ƎグĂ܂B
	  C_Vec p0 = new_trs + nrm*0.007f;
	  C_Vec p1 = p0 + v;
	  C_Coll slide( tri, p0, p1, 0.1f, false );
	  if( !slide.Result() ){
		new_trs = p1;
	  }
	  tgt->cn = nrm;
	  tgt->cp = new_trs;
	  tgt->pos = new_trs;
	  tgt->vel = vel;
	}else{
	  //ȗ`B(ŃW[uj
	  tgt->pos = coll.GetPos() + nrm*0.0001f;
	  tgt->vel = vel;
	  tgt->cn = nrm;
	  tgt->cp = tgt->pos;
	}
#endif
	
	return true;
  }else{
	return false;
  }
}
void C_Cloth::ResolveCollision( void )
{
  PARTICLE *source,*target;

  //OSReport( "collision start\n" );
  source = cur;	// ݂̃p[^B
  target = next;	// ꂩ狁߂p[^B
  for (int i = 0; i < num_ptcl; i++){
	if( source->state==SPRING_BIND ){
	  for( int j=0; j<trigons.size(); j++ ){
		target->hit_flg = 
		  _ResolveCollision(*trigons[(u32)j], source, target, dtime);
	  }
	}else{
	}
	source++;
	target++;
  }
}

/////////////////////////////////////////
//ϕ
/////////////////////////////////////////
void C_Cloth::Integrate( void )
{
  PARTICLE *source,*target;
  int i;
#if kDiff
#else
  for(i = 0,target = next; i < num_ptcl; i++,target++){
	HSD_JObjResetUserDefinedMtx(target->jobj );
  }
#endif
  source = cur;	// ݂̃p[^B
  target = next;	// ꂩ狁߂p[^B
  for ( i = 0; i < num_ptcl; i++){
	//if( i == 3 ) OSReport( "%f\n", target->vel.Mag() );

	if( source->state==SPRING_BIND ){
	  //xB
	  target->vel =	(source->vel * source->dumping) + (source->force * source->InvMass * dtime);
	  target->vel *= 0.99f;
	  //ʒuB
	  target->pos = source->pos + (source->vel * dtime);
	  //ŏ̓WbhoChȂ̂ł(target-1)ł悢B
	  C_Vec dif = target->pos - (target-1)->pos;

	  //LтB
	  f32 scl = 1.f;
	  if( dif.Mag() >= (target-1)->org_len * scl ){
		dif.Nrm();
		dif *= (target-1)->org_len * scl;
		target->pos = (target-1)->pos + dif;
	  }

	}else{
	  C_Vec trs;
	  HSD_JObjSetupMatrix( target->jobj );
	  HSD_MtxGetTranslate( target->jobj->mtx, &trs );
#if 1
	  target->vel.Set(0.f);
#else
	  target->vel = trs - target->pos;
	  target->vel *= (1.0f/dtime);
#endif
	  target->pos = trs;
	}

	//if( i == 3 ) OSReport( "%f\n---\n", target->vel.Mag() );

	source++;
	target++;
  }

  //#if kDiff
}

void C_Cloth::Proc( void )
{

  s32 rep = 0;
  if( proc_counter )	rep = 1;
  else					rep = 60;
  proc_counter++;

#if 0
#ifdef	_DEBUG
  if( HSD_PadGetButton( 1 ) & HSD_PAD_Y ) warp_ofst.x = 1.f;
#endif
#endif

  for( rep; rep; rep-- ){
	PARTICLE	*tmp;

	tmp = cur;
	cur = next;
	next = tmp;

	if( warp_ofst.Mag() > 0.f ){
	  warp_counter = 3;
	  warp_ofst.Set( 0.f );
	}
	if( --warp_counter>0 ){
	  //xAƂ`ɖ߂B
	  C_Vec trs;
	  for ( int i = 0; i < num_ptcl; i++){
		HSD_JObjResetUserDefinedMtx( cur[i].jobj );
		HSD_JObjSetupMatrix( cur[i].jobj );
		HSD_MtxGetTranslate( cur[i].jobj->mtx, &trs );
		cur[i].pos = next[i].pos = trs;
		cur[i].force.Set(0.f);
		next[i].force.Set(0.f);
		cur[i].vel.Set(0.f);
		next[i].vel.Set(0.f);
	  }
	  //warp_ofst.Set( 0.f );
	  return;
	}
	{
	  ComputeForce();
	  Integrate();
	  ResolveCollision();
	}
  
	
	//[hŏoĂ_̈ʒuɁA
	//eWCg̈ʒu킹B
	//(o邾j
	for( int i=0; i<grid_x; i++ ){
	  for( int j=0; j<(grid_y-1); j++ ){
		PARTICLE *p0, *p1;
		C_Vec dir,dir_org,rot_axis,trs;
		f32 len;
		p0 = &cur[ j + i * grid_y ];
		p1 = &cur[ j + 1 + i * grid_y ];

		//p0p1ւ݂̌̌B([hj
		dir = p1->pos - p0->pos;
		len = dir.Mag();
		if( len == 0.f ) continue;
		dir.Nrm();
	  
		//p0p1ւ̏Ԃ̌B([hj
		HSD_JObjResetUserDefinedMtx( p0->jobj );
		HSD_JObjSetupMatrix( p0->jobj );

		MTXMultVecSR( p0->jobj->mtx, &p0->org_dir, &dir_org );
	  
		//]
		rot_axis = dir_org & dir;

		//]ꂽƂ̂݁B
		if( VECMag( &rot_axis ) > 0.000001f ){
		  Mtx m,mrot;
		  f32 c = acosf( VECDotProduct( &dir, &dir_org ) );
		  if( !isnan(c) ){
			//HSD_DmpVector("", (Vec*)&p1->jobj->rotate );
			//original rotate
			MTXCopy( p0->jobj->mtx, mrot );
			C_Vec trs(mrot[0][3], mrot[1][3], mrot[2][3]);
			mrot[0][3] = mrot[1][3] = mrot[2][3] = 0.f;

			//additional rotate
			MTXRotAxisRad( m, &rot_axis, c );

			//MTXConcat( mrot, mscl, mrot );
			MTXConcat( m, mrot, mrot );
			mrot[0][3] = trs.x;	mrot[1][3] = trs.y;	mrot[2][3] = trs.z;
			//		  MTXCopy( mrot, p0->jobj->mtx );
			HSD_JObjSetUserDefinedMtx(p0->jobj,mrot);
		  }
		}
	  }
	}
  }
}


static
void DrawLine( Vec &p0, Vec &p1, u32 col )
{
  GXBegin(GX_LINES, GX_VTXFMT0, 2);
  GXPosition3f32(p0.x, p0.y, p0.z);
  GXColor1u32(col);
  GXPosition3f32(p1.x, p1.y, p1.z);
  GXColor1u32(col);
  GXEnd();
}
static
void DrawPoint( Vec &p0, u32 col )
{
  GXBegin(GX_POINTS, GX_VTXFMT0, 1);
  GXPosition3f32(p0.x, p0.y, p0.z);
  GXColor1u32(col);
  GXEnd();
}

void C_Cloth::Disp( void )
{
  s32 count=0;
  s32 x = grid_x;
  s32 y = grid_y;

  HSD_CObj *cobj = HSD_CObjGetCurrent();

  GXSetZMode( GX_TRUE, GX_ALWAYS, GX_TRUE );

  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
  GXSetNumTevStages(1);
  GXSetNumTexGens(0);
  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
  GXSetChanCtrl(GX_COLOR0A0,
				//GX_ENABLE,		// enable channel
				GX_DISABLE,		// enable channel
				GX_SRC_VTX,		// amb source
				GX_SRC_VTX,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);

  GXLoadPosMtxImm(HSD_CObjGetViewingMtxPtr(cobj), GX_PNMTX0);
  GXSetCurrentMtx( GX_PNMTX0 );
  GXClearVtxDesc();
  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
  GXSetVtxDesc(GX_VA_CLR0,  GX_DIRECT);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);

#if 1
  //XvOB
  GXSetLineWidth( (u8)16,GX_TO_ZERO );
  for( int i=0; i<num_spring; i++ ){
	u32 col = 0x8f8f00ff;
#if 0
	C_Vec p0( cur[spring[i].p2].jobj->mtx[0][3],
			 cur[spring[i].p2].jobj->mtx[1][3],
			 cur[spring[i].p2].jobj->mtx[2][3] );
	C_Vec p1( cur[spring[i].p1].jobj->mtx[0][3],
			 cur[spring[i].p1].jobj->mtx[1][3],
			 cur[spring[i].p1].jobj->mtx[2][3] );
	DrawLine( p0, p1, (u32)col );
#else
	//OSReport( "%d %d\n", spring[i].p1, spring[i].p2 );
	DrawLine( cur[spring[i].p2].pos, cur[spring[i].p1].pos, (u32)col );
#endif
  }
#endif
#if 1
  //p[eBB
  GXSetPointSize( (u8)40,GX_TO_ZERO );
  for( int i=0; i<num_ptcl; i++ ){
	u32 col = 0xffffffff;
	u32 red = 0xff0000ff;
	u32 cyn = 0xff00ffff;
	if( cur[i].hit_flg ){
	  DrawPoint( cur[i].pos, (u32)col );
	  DrawLine( cur[i].cp, cur[i].cp + (cur[i].cn*2.f), (u32)col );
	  DrawLine( cur[i].cp, cur[i].cp + (cur[i].cv*-1.f)*0.1f, (u32)cyn );
	  DrawLine( cur[i].pos, cur[i].pos + (cur[i].vel)*0.1f, (u32)red );
	}
  }


#if 1
  //ƂƂ̍B
  for( int i=0; i<(grid_y-1); i++ ){
	for( int j=0; j<grid_x; j++ ){
	  PARTICLE *p0, *p1;
	  p0 = &cur[ i + j * grid_y ];
	  p1 = &cur[ i + 1 + j * grid_y ];
	  HSD_JObjResetUserDefinedMtx( p0->jobj );
	  HSD_JObjResetUserDefinedMtx( p1->jobj );
	}
  }
  for( int i=0; i<(grid_y-1); i++ ){
	for( int j=0; j<grid_x; j++ ){
	  u32 col = 0x000000ff;
	  PARTICLE *p0, *p1;
	  C_Vec t0, t1;
	  p0 = &cur[ i + j * grid_y ];
	  p1 = &cur[ i + 1 + j * grid_y ];
	  HSD_JObjSetupMatrix( p0->jobj );
	  HSD_JObjSetupMatrix( p1->jobj );
	  HSD_MtxGetTranslate( p0->jobj->mtx, &t0 );
	  HSD_MtxGetTranslate( p1->jobj->mtx, &t1 );
	  DrawLine( t0, t1, (u32)col );
	}
  }
#endif

#endif

#if 0
  if( HSD_PadGetButton(3) & HSD_PAD_STICK_LEFT )
	HSD_JObjAddRy( cur[0].jobj, 0.1f );
  if( HSD_PadGetButton(3) & HSD_PAD_STICK_RIGHT )
	HSD_JObjAddRy( cur[0].jobj, -0.1f );
  if( HSD_PadGetButton(3) & HSD_PAD_STICK_UP )
	HSD_JObjAddRz( cur[0].jobj, 0.1f );
  if( HSD_PadGetButton(3) & HSD_PAD_STICK_DOWN )
	HSD_JObjAddRz( cur[0].jobj, -0.1f );
#endif

#if 0
  for( int i=0; i<grid_y; i++ ){
	for( int j=0; j<grid_x; j++ ){
	  u32 r = 0xff0000ff;
	  u32 g = 0x00ff00ff;
	  u32 b = 0x0000ffff;
	  C_Vec x(1.f,0.f,0.f);
	  C_Vec y(0.f,1.f,0.f);
	  C_Vec z(0.f,0.f,1.f),o;
	  MTXMultVec( cur[i+j*grid_y].jobj->mtx, &o, &o );
	  MTXMultVec( cur[i+j*grid_y].jobj->mtx, &x, &x );
	  MTXMultVec( cur[i+j*grid_y].jobj->mtx, &y, &y );
	  MTXMultVec( cur[i+j*grid_y].jobj->mtx, &z, &z );
	  DrawLine( o, x, (u32)r );
	  DrawLine( o, y, (u32)g );
	  DrawLine( o, z, (u32)b );
	}
  }
#endif
  HSD_StateInvalidate( HSD_STATE_ALL );
}






