#include "common.h"
#include "c_font.h"
#include "utility.h"
#include "..\Wat\K7App.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTex.h"

C_Font* C_Font::instance = 0;
C_Font::C_Line* C_Font::C_Line::top = 0;
C_Paper* C_Paper::cur = 0;
GhmGcTexHeader* C_Font::mpFontHeader = NULL;
void*           C_Font::mpFontImage  = NULL;
ghmGcFile*      C_Font::mpFile       = NULL;
int             C_Font::mProc        = 0;
#define	FONTW			(16)
#define	FONTH			(16)
//#define	FONTH			(24)
#define	FONTSW			(16)
#define	FONTTH			(16)

//C_Font* C_Font::GetInstance( void ){
//  if( instance ){
//	return *instance;
//  }else{
//    ghmGcMemSetAllocName("C_Font I");
//	instance = new C_Font();
//	return *instance;
//  }
//}

bool C_Font::Proc(void)
{
	switch( mProc ){
	case	0:
		ghmGcMemSetAllocName("CFntFile");
		if( (mpFile = new ghmGcFile)==NULL ){
			break;
		}
		if( mpFile->Open("/Wat/SF_Font.bin")==false ){
			break;
		}
		mProc++;
	case	1:
		if( (mpFontHeader = (GhmGcTexHeader *)mpFile->Read())==NULL ){
			break;
		}
		mProc++;
		break;
	case	2:
		if( mpFile->GetState()!=ghmGcFile::READFINISH ){
			break;
		}
		mpFile->Close();
		GHM_SAFE_DELETE(mpFile);
		mProc++;
		mpFontImage = GHMGCTEX_GETIMAGE(mpFontHeader);
	case	3:
		ghmGcMemSetAllocName("C_Font I");
		instance = new C_Font();
		mProc = -1;
		break;
	default:
		break;
	}
	return true;
}

C_Font::C_Font( void )
{
//  ghmGcFile	file;
//  if( file.Open("/Wat/SF_Font.bin")==true ){
//	if( (mpFontHeader = (GhmGcTexHeader *)file.ReadB())!=NULL ){
//	  mpFontImage = GHMGCTEX_GETIMAGE(mpFontHeader);
//	}
//  }
#if 1
	// OS_FONT_SIZE_SJIS = 0x120f00
	// tHggĂȂǁAÔߗp̃obt@
    ghmGcMemSetAllocName("C_Font H");
	font_header = (OSFontHeader*)ghmGcMemAlloc(0x0b0000);	//20050330 A|ɒe~܂CΉŃȂȂ
//	font_header = (OSFontHeader*)ghmGcMemAlloc(0x0c0000);
//	font_header = (OSFontHeader*)ghmGcMemAlloc(0x100000);
//	font_header = (OSFontHeader*)new u8[0x100000];
#else
  //{ꃂ[h?
  if (OSGetFontEncode() == OS_FONT_ENCODE_SJIS){
    ghmGcMemSetAllocName("C_Font H");
	font_header = (OSFontHeader*)new u8[OS_FONT_SIZE_SJIS];
  }else{
	ASSERT2( 0, "You are in US-mode\n" );
  }
  if (!OSInitFont(font_header)){
	ASSERT2( 0, "This ROM has no ROM-Font\n" );
  }

  size  = (s16) (font_header->cellWidth * 16);
  space = -16;
#endif
}

  s32	sizeh;
void C_Font::DrawFontChar(int x, int y, int z, int xChar, int yChar)
{
  s16 posLeft   = (s16) x;
  s16 posRight  = (s16) (posLeft + size);
  s16 posTop    = (s16)y;
//  s16 posTop    = 
//	(s16) (y - (font_header->ascent  * size / font_header->cellWidth));
  s16 posBottom = (s16)(y + sizeh);
//  s16 posBottom = 
//	(s16) (y + (font_header->descent * size / font_header->cellWidth));

  s16 texLeft   = (s16) xChar;
  s16 texRight  = (s16) (xChar + FONTSW);
//  s16 texRight  = (s16) (xChar + font_header->cellWidth);
  s16 texTop    = (s16) yChar;
  s16 texBottom = (s16) (yChar + FONTTH);
//  s16 texBottom = (s16) (yChar + font_header->cellHeight);

  GXBegin(GX_QUADS, GX_VTXFMT0, 4);
  GXPosition3s16(posLeft , posTop   , (s16) z);
  GXTexCoord2s16(texLeft , texTop      );

  GXPosition3s16(posRight, posTop   , (s16) z);
  GXTexCoord2s16(texRight, texTop      );

  GXPosition3s16(posRight, posBottom, (s16) z);
  GXTexCoord2s16(texRight, texBottom   );

  GXPosition3s16(posLeft , posBottom, (s16) z);
  GXTexCoord2s16(texLeft , texBottom   );
  GXEnd();
}

void C_Font::LoadSheet(void* image, GXTexMapID texMapID)
{
#pragma	unused(image)
  Mtx          mtx;
  GXTexObj     texObj;

  // Set up and load texture object
  GXInitTexObj(&texObj,                           // obj
			   mpFontImage,                       // image_ptr
			   mpFontHeader->mWidth,              // width
			   mpFontHeader->mHeight,             // height
			   mpFontHeader->mFormat,             // format
//			   image,                             // image_ptr
//			   font_header->sheetWidth,              // wight
//			   font_header->sheetHeight,             // height
//			   (GXTexFmt) font_header->sheetFormat,  // format
			   GX_CLAMP,                          // wrap_s (don't care)
			   GX_CLAMP,                          // wrap_t (don't care)
			   GX_FALSE);                         // mipmap (don't care)

  GXInitTexObjLOD(&texObj,
				  GX_NEAR,     // min_filt
				  GX_NEAR,     // max_filt
				  0.0f,          // min_lod     (don't care)
				  0.0f,          // max_lod     (don't care)
				  0.0f,          // lod_bias    (don't care)
				  GX_DISABLE,    // bias_clamp  (don't care)
				  GX_FALSE,      // do_edge_lod (don't care)
				  GX_ANISO_1);   // max_aniso   (don't care)

  GXLoadTexObj(&texObj, texMapID);
  MTXScale(mtx, 1.0f / mpFontHeader->mWidth,
		   1.0f / mpFontHeader->mHeight,
		   1.0f);
//  MTXScale(mtx, 1.0f / font_header->sheetWidth,
//		   1.0f / font_header->sheetHeight,
//		   1.0f);
  GXLoadTexMtxImm(mtx, GX_TEXMTX0, GX_MTX2x4);
  GXSetNumTexGens(1);
  GXSetTexCoordGen(GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_TEXMTX0);
}

char* GetUV(char *pChar,s32 *pxChar, s32 *pyChar, s32 *pWidth);
char* GetUV(char *pChar,s32 *pxChar, s32 *pyChar, s32 *pWidth)
{
	if( *pChar >= '!' && *pChar <='~' ){
		*pxChar = (*pChar & 0xf) * 16;
		*pyChar = (*pChar-0x20) & 0xf0;
	}else{
		*pxChar = 0;
		*pyChar = 0;
	}
//	*pWidth = 24;
	*pWidth = 14;
//	*pWidth = FONTW;
	return pChar + 1;
}

int C_Font::Puts(s32 x, s32 y, s32 z, char* string)
{
  s32   cx;
//  void* image;
  s32   xChar;
  s32   yChar;
  s32   width;
  char	letter;

  sizeh = (s16) ((FONTH * 16) * font_scl);
  size  = (s16) ((FONTW * 16) * font_scl);
//  size  = (s16) ((font_header->cellWidth * 16) * font_scl);
//  space = 0;
  space = (s16) (-4 * 16 * font_scl);
//  space = (s16) (-16 * font_scl);
  //̌_͍ɂB
//  y += font_header->cellWidth * font_scl;

  // Set up vertex descriptors
  GXClearVtxDesc();
  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
  GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_S16, 4);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST,  GX_S16, 0);

  // Convert to GX_S16, 4 format
  x *= 16;
  y *= 16;
  z *= 16;

  LoadSheet(NULL, GX_TEXMAP0);
  
  width = 0;
  while (*string){
	if (*string == '\n'){
	  width = 0;
	  y += sizeh;
//	  y += font_header->cellWidth * size / font_header->cellWidth;
	  ++string;
	  continue;
	}
	
	letter = *string;
//	string = OSGetFontTexture(string, &image, &xChar, &yChar, &cx);
	string = GetUV(string,&xChar,&yChar,&cx);
	
	if( letter!=' ' ){
//	  LoadSheet(image, GX_TEXMAP0);
	  DrawFontChar(x + width, y, z, xChar, yChar);
	}
	width += size * cx / FONTW + space;
//	width += size * cx / font_header->cellWidth + space;
  }
  return (width + 15) / 16;
}

void C_Font::_Print( char* str, f32 s_ )
{
	s_ = 1.0f;
  ghmGcMemSetAllocName("C_Font L");
  
  new C_Line( str, C_Paper::GetX(), C_Paper::GetY(), *C_Paper::GetCurPtr(), 
			  s_, C_Paper::GetFlag(), C_Paper::GetCol() );
  s32 len = (s32)strlen( str ),num = 0;
  for( s32 i=0; i<len; i++ ){
	if( str[i] == '\n' ) num++;
  }
  C_Paper::Return( (s32)(FONTH * s_ * num) );
//  C_Paper::Return( (s32)(font_header->cellWidth * s_ * num) );
}
void C_Font::Print( char* fmt, ... )
{
  va_list  vlist;
  char     buf[512];
  
  //pӂĂB
  if( C_Paper::GetCurPtr() ){
	va_start(vlist, fmt);
	vsprintf(buf, fmt, vlist);
	va_end(vlist);
	_Print( buf, C_Paper::GetScale() );
  }
}

#define COLCONV( X, Y ) {	X.r = (u8)((Y&0xff000000)>>24); X.g = (u8)((Y&0x00ff0000)>>16); \
							X.b = (u8)((Y&0x0000ff00)>>8); X.a = (u8)(Y&0x000000ff);}
void C_Font::Draw( void )
{
  Mtx44  pMtx;
  Mtx    mMtx;

  MTXOrtho( pMtx, 0.0f, (float)480, 0.0f, (float)640, 0.0f, 100 );
  GXSetProjection( pMtx, GX_ORTHOGRAPHIC );
  MTXIdentity( mMtx );
  GXLoadPosMtxImm( mMtx, GX_PNMTX0 );
  GXSetCurrentMtx( GX_PNMTX0 );

  GXSetZMode( GX_DISABLE, GX_ALWAYS, GX_DISABLE );
  GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);
  GXSetZCompLoc( GX_TRUE );

  GXSetChanCtrl(GX_COLOR0A0,
				GX_DISABLE,		// enable channel
				GX_SRC_REG,		// amb source
				GX_SRC_REG,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);
  GXSetNumTevStages( 1 );
  GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_RASC, GX_CC_TEXA, GX_CC_ZERO );
  GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
  GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_TEXA );
  GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
  //GXSetTevOp( GX_TEVSTAGE0, GX_REPLACE );
  GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );

  //  C_Line::PrintAll();
  C_Line* tmp = C_Line::top;
  while( tmp ){
	GXColor col;
	COLCONV( col, (tmp->col));
	GXSetChanMatColor( GX_COLOR0A0, col );

	tmp->SetScissor();
//	if( tmp->flg ) 
//	  GXSetBlendMode( GX_BM_BLEND, GX_BL_ONE, GX_BL_ZERO, GX_LO_CLEAR );
//	else
	  //GXSetBlendMode( GX_BM_BLEND, GX_BL_ONE, GX_BL_ONE, GX_LO_CLEAR );
	  GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	font_scl = 1.0f;//tmp->scl;
	Puts( tmp->x, tmp->y, 0, tmp->str);
	tmp = tmp->next;
  }
  C_Line::DeleteAll();

  HSD_StateInvalidate( HSD_STATE_ALL );
}

void C_Font::C_Line::SetScissor(void)
{
  int		x,y,w,h;
  x = scissor.GetX();
  y = scissor.GetY();
  w = scissor.GetW();
  h = scissor.GetH();
  if( x + w > K7APP_SCREEN_WIDTH ){
	w = K7APP_SCREEN_WIDTH - x;
  }
  if( x > K7APP_SCREEN_WIDTH ){
	x = K7APP_SCREEN_WIDTH;
	w = 0;
  }else if( x < 0 ){
	w = w + x;
	x = 0;
  }
  if( y + h > K7APP_SCREEN_HEIGHT ){
	h = K7APP_SCREEN_HEIGHT - y;
  }
  if( y > K7APP_SCREEN_HEIGHT ){
	y = K7APP_SCREEN_HEIGHT;
	h = 0;
  }else if( y < 0 ){
	h = h + y;
	y = 0;
  }
  GXSetScissor((u32)x,(u32)y,(u32)w,(u32)h);
}






