#include "c_heap.h"
#include "utility.h"

C_Heap*		C_Heap::current = NULL;
const u8	C_Heap::magic_no = 0xaa; //10101010
s16			C_Heap::id = DEFAULT_ID;
const char*	C_Heap::name = "DEFAULT";

C_Heap::C_Heap(void* start, void* end)
{
  start = (void*)OSRoundUp32B((u32)start);

  //gbv͐ÓIɎB
  top.size = sizeof(Block);
  top.magic_no = magic_no;
  top.flag = true;
  top.prev = top.next = (Block*)start;
  top.id = TOP_ID;
  top.name = "TOP";

  //q[v̏ԁB
  Block*		block;
  block = (Block*)start;
  SetFree( block, (u32)end-(u32)start, &top, &top );

  OSReport( "Heap Set\n" );
}

C_Heap::~C_Heap(void)
{
}

void* C_Heap::Alloc(size_t size)
{
  //32byteACg
  size = OSRoundUp32B(size);
  size += sizeof(Block);

  //gbvubN猟ĂB
  for(Block* p = &current->top; p;){

	//TCY̑A󂫃ubNB
	if(!p->flag && p->size >= size){
	  //TCY҂肶ȂꍇB
	  //(Block\+f[^p̍ŏ̈(32byte))
	  //Ƀt[ubNB
	  if(p->size - size >= sizeof(Block)+32){
		Block*		s;
		s = (Block*)((char*)p + size);
		SetFree( s, p->size - size, p, p->next );

		p->next->prev = s;
		p->next = s;
		p->size = size;
	  }
	  p->flag = true;
	  p->id = id;
	  p->name = name;
	  return((void*)((char*)p + sizeof(Block)));
	}

	p = p->next;
	//PTĂ܂܂B
	if(p == &current->top) break;
  }

  //G[B
  for(Block* p = &current->top; p;){
	OSReport("%0x %0x %0x\n", p, p->next, &current->top);
	OSReport("%s %d %d %d\n", p->name, p->id, p->flag, p->size);
	p = p->next;
	if(p == &current->top) break;
  }
  ASSERT2( false, "Run out of memory\n" );

  return(NULL);
}

void C_Heap::Free(void* p)
{
  Block*		h = (Block*)((char*)p - sizeof(Block));
  if(h->magic_no != magic_no){
	ASSERTMSG( false, "Wrong pointer or Memory violation had occured.\n" );
  }

  //JB
  SetFree( h );

  //Õt[ubNAB
  if(!h->next->flag){
	h->size += h->next->size;
	h->next = h->next->next;
	h->next->prev = h;
  }
  if(!h->prev->flag){
	h = h->prev;
	h->size += h->next->size;
	h->next = h->next->next;
	h->next->prev = h;
  }
}
