#include "common.h"
#include "c_jobj.h"
#include "utility.h"

//JObj𖼑OłƂĂB
//
static HSD_JObj* GetJObjByName(HSD_Joint* joint, HSD_JObj* jobj
							   , const char* name)
{
  HSD_JObj*	r;

  if(!strcmp(GetDescName(joint), name))	return jobj;
  if(joint->child){
	r = GetJObjByName(joint->child, jobj->child, name);
	if(r)	return r;
  }
  if(joint->next){
	r = GetJObjByName(joint->next, jobj->next, name);
	if(r)	return r;
  }
  return 0;
}

HSD_JObj* C_JObj::GetJObj(const char* name) const
{
  return (name)?GetJObjByName(model_set->GetJoint(), jobj, name): jobj;
}

//DObj𖼑OłƂĂB
//͎ۂɂ̓}eA̖OB
//
static HSD_DObj* GetDObjByName(HSD_Joint* joint, HSD_JObj* jobj
							   , const char* name)
{
  HSD_DObj*		r;
  HSD_DObj*		d;
  HSD_DObjDesc*	dd;

  for(dd = joint->u.dobjdesc, d = jobj->u.dobj
		; dd; dd = dd->next, d = d->next){
	if(!strcmp(GetDescName(dd), name))	return d;
  }
  if(joint->child){
	r = GetDObjByName(joint->child, jobj->child, name);
	if(r)	return r;
  }
  if(joint->next){
	r = GetDObjByName(joint->next, jobj->next, name);
	return r;
  }
  return 0;
}

HSD_DObj* C_JObj::GetDObj(const char* name) const
{
  return GetDObjByName(model_set->GetJoint(), jobj, name);
}

void C_JObj::SetAction(const char* name)
{
  HSD_AnimJoint*		aj;
  HSD_MatAnimJoint*	mj;
  HSD_ShapeAnimJoint*	sj;
  model_set->GetAction(name, aj, mj, sj);
  HSD_JObjAddAnimAll(jobj, aj, mj, sj);
  HSD_JObjReqAnimAll(jobj, 0);
}

void C_JObj::SetAction(u32 no)
{
  HSD_AnimJoint*		aj;
  HSD_MatAnimJoint*	mj;
  HSD_ShapeAnimJoint*	sj;
  model_set->GetAction(no, aj, mj, sj);
  HSD_JObjAddAnimAll(jobj, aj, mj, sj);
  HSD_JObjReqAnimAll(jobj, 0);
}

void C_JObj::Disp()
{
  HSD_JObjDispAll(jobj, 0, HSD_TRSP_OPA, 0);
  HSD_JObjDispAll(jobj, 0, HSD_TRSP_XLU, 0);
  HSD_JObjDispAll(jobj, 0, HSD_TRSP_TEXEDGE, 0);
}








