#ifndef ___C_K7CLOTH_H___
#define ___C_K7CLOTH_H___

#define kClothJointPrefix ((char*)"ClothJoint_")
#define kClothCollisionPrefix ((char*)"ClothCollision_")

//#include "common.h"
#include "c_cloth.h"
class C_K7Cloth {
 public:
  //OKɂāAZIuWFNgƁA
  //RWfB
  C_K7Cloth( HSD_JObj *_jobj, HSD_Joint *_joint );
  virtual ~C_K7Cloth();
  void Proc(void);
  void Disp(void);
  void SetWind( Vec &_w );
  bool HideCollision(void);
  bool GetWarpOfst( Vec &pos_ ,int index=0){ 
	if( index<0 || index>=(int)cloth.size() ){
		return false;
	}
	cloth[(u32)index]->GetWarpOfst(pos_);
	return true;
  }
  void SetWarpOfst( Vec &pos_ ){ 
	u32 size = cloth.size();
	for( u32 i=0; i<size; i++ ) cloth[i]->SetWarpOfst(pos_);
  }

 private:
  typedef struct _JOINTS{
	const char *name;
	s8 len,bone_no,joint_no,id;
	HSD_JObj *jobj;
	f32 spring_const;
	f32 dumping_const;
	f32 mass;
	bool operator < (const _JOINTS j) const { 
#if 0
	  OSReport( "%s: %d < %s: %d => %d\n", 
				name, this->bone_no*10+this->joint_no,
				j.name, j.bone_no*10+j.joint_no,
				(this->bone_no*10 + this->joint_no) < (j.bone_no*10 + j.joint_no)
				);
#endif
	  return (this->bone_no*10 + this->joint_no) < (j.bone_no*10 + j.joint_no);
	}
	void Print( void ){
	  OSReport( "name: %s\n", name );
	  OSReport( "b|n:  %d | %d\n", bone_no, joint_no );
	  OSReport( "s|d:  %f | %f\n", spring_const, dumping_const );
	  OSReport( "m:    %f\n", mass );
	}
  }JOINTS;
  vector<C_TrigonArray*> trigon;
  vector<C_Cloth*> cloth;
  HSD_JObj *root_jobj;
  HSD_Joint *root_joint;
  HSD_JObj *collision_jobj;
  s32 joints_num;
  s32 joint_num,bone_num;
  bool constrain_pow_flg;
  enum DATA_STATUS{
	WRONG_PREFIX = (0x1<<0),//vtBbNXႤB
	WRONG_NAME = (0x1<<1),//OB
	WRONG_PARAM = (0x1<<2),//p[^[B
	OK = (0x1<<3)//SOKB
  };
  void GetClothData( HSD_JObj *_jobj, HSD_Joint *_joint, JOINTS _joints[]);
  HSD_JObj *GetCollisionJObj( HSD_JObj *_jobj, HSD_Joint *_joint, char *_name );
  DATA_STATUS _GetClothData( const char *top, JOINTS *data );
  s32 SortAdd( JOINTS joint, JOINTS _joints[], s32 _count );
  void SetCloth( JOINTS _joints[] );
  bool IsValid( JOINTS _joints[], s32 _count, s32 &_j, s32 &_b );
};
#endif
