#ifndef ___C_RECT_H___
#define ___C_RECT_H___

//#include "common.h"

class C_Rect{
 public:
  C_Rect( s32 x_=0, s32 y_=0, s32 w_=640, s32 h_=480 ):
	x(x_), y(y_), w(w_), h(h_) {
  }
  virtual s32 GetX( void ){ return x; }
  virtual s32 GetY( void ){ return y; }
  virtual s32 GetW( void ){ return w; }
  virtual s32 GetH( void ){ return h; }
  virtual void Draw( u8 r=127, u8 g=127, u8 b=127, u8 a=127 ){

	Mtx44  pMtx;
	Mtx    mMtx;
	MTXOrtho( pMtx, 0.0f, (float)480, 0.0f, (float)640, 0.0f, 100 );
	GXSetProjection( pMtx, GX_ORTHOGRAPHIC );
	MTXIdentity( mMtx );
	GXLoadPosMtxImm( mMtx, GX_PNMTX0 );
	GXSetCurrentMtx( GX_PNMTX0 );

	GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
	GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
	GXSetNumTevStages(1);
	GXSetNumTexGens(0);
	GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_ONE, GX_LO_CLEAR);
	GXSetChanCtrl(GX_COLOR0A0,
				  GX_DISABLE,		// enable channel
				  GX_SRC_VTX,		// amb source
				  GX_SRC_VTX,		// mat source
				  GX_LIGHT_NULL,	// light mask
				  GX_DF_CLAMP,	// diffuse function
				  GX_AF_NONE);
	GXSetNumChans(1);

	GXSetZMode( GX_FALSE, GX_LESS, GX_FALSE ) ;
	GXSetAlphaUpdate( GX_FALSE ) ;
	GXSetColorUpdate( GX_TRUE ) ;

	GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT) ;
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 ) ;
#define	ZMID -0.5f
	GXSetCullMode( GX_CULL_NONE ) ;
	GXBegin(GX_QUADS, GX_VTXFMT0, 4);{
	  GXPosition3f32((f32)x, (f32)y, ZMID);
	  GXColor4u8( r, g, b, a ) ;
	  GXPosition3f32((f32)x+w, (f32)y, ZMID);
	  GXColor4u8( r, g, b, a ) ;
	  GXPosition3f32((f32)x+w, (f32)y+h, ZMID);
	  GXColor4u8( r, g, b, a ) ;
	  GXPosition3f32((f32)x, (f32)y+h, ZMID);
	  GXColor4u8( r, g, b, a ) ;
	}GXEnd();
	HSD_StateInvalidate( HSD_STATE_ALL );
  }
 protected:
  s32 x,y,w,h;
};

#endif
