#include "common.h"
#include "c_seawead.h"
#include "utility.h"
#include "c_pesetup.h"
#include "vector.h"
#include "c_trigon.h"

#pragma warn_implicitconv off
//#include "line/line_CMPR_image.c"
//#include "metaball/Alpha_Texture00_RGB5A3_image.c"
//#include "metaball/metaball_cube1_dolphin.c"
#pragma warn_implicitconv on

//ԁB(1t[̎)
//f32 C_SeaWead::dtime = 1.f / 60.f;
f32 C_SeaWead::dtime = 1.f / 30.f;
C_Vec C_SeaWead::gravity = C_Vec( 0.f, -0.98f, 0.f);
s32 C_SeaWead::ref = 0;

C_SeaWead::~C_SeaWead(){
  if( ptcl_buf[0] ) delete[] ptcl_buf[0];
  if( ptcl_buf[1] ) delete[] ptcl_buf[1];
  if( spring )	delete[] spring;

  ref --;
}
C_SeaWead::C_SeaWead( s16 _num_ptcl, C_Vec &_world_pos, C_Vec &_dir,
					  f32 _len, f32 _mass, f32 _const_spring, f32 _const_dspring )
  : wind(0.f,0.f,0.f)
{
  ref++;
  //p[eBN̐B
  num_ptcl = _num_ptcl;
  //XvO萔B
  const_spring = _const_spring;
  //_sOWB
  const_dspring = _const_dspring;
  //tB
  anchor_pos = _world_pos;

  //p[eBNB
  cur = ptcl_buf[0] = new SEAWEAD_PARTICLE[ num_ptcl ];
  next = ptcl_buf[1] = new SEAWEAD_PARTICLE[ num_ptcl ];
  SEAWEAD_PARTICLE *p0=cur,*p1=next;
  for( int i=0; i<num_ptcl; i++ ){

	//KparentɌŒ肳B
	if( i == (num_ptcl-1) ){
	  p0->state = RIGID_BIND;
	}else{
	  p0->state = SPRING_BIND;
	}
	//k߂ԂɏB
	f32 l = i * _len;
	C_Vec d = _dir * l;
	p0->pos = d + _world_pos;
	p0->vel.Set(0.f,0.f,0.f);
	p0->force.Set(0.f,0.f,0.f);
	p0->mass = _mass;
	p0->InvMass = 1.0f / p0->mass;

	*p1 = *p0;
	p1++;
	p0++;
  }

  spring = new SEAWEAD_SPRING[ num_ptcl-1 ];
  SEAWEAD_SPRING* sp = spring;
  p0 = cur;
  for( int i=0; i<(num_ptcl-1); i++ ){
	sp->p1 = i;
	sp->p2 = i+1;
	sp->length = p0[sp->p1].pos.Dist( p0[sp->p2].pos );
	sp->Ks = const_spring;
	sp->Kd = const_dspring;
	sp++;
  }

  col = (u32)(((0x1f + (HSD_Rand()%0x20)) << 24 ) | 0xef);

  fun_flg = 0;
  line_width = 8;
}

//XvȌԂɖ߂B
void C_SeaWead::Reset( C_Vec &_world_pos, C_Vec &_dir, f32 _len )
{
  SEAWEAD_PARTICLE *p0=cur,*p1=next;
  for( int i=0; i<num_ptcl; i++ ){

	//KparentɌŒ肳B
	if( i == (num_ptcl-1) ){
	  p0->state = RIGID_BIND;
	}else{
	  p0->state = SPRING_BIND;
	}
	//k߂ԂɏB
	f32 l = i * _len;
	C_Vec d = _dir * l;
	p0->pos = d + _world_pos;
	p0->vel.Set(0.f,0.f,0.f);
	p0->force.Set(0.f,0.f,0.f);

	*p1 = *p0;
	p1++;
	p0++;
  }
  SEAWEAD_SPRING* sp = spring;
  p0 = cur;
  for( int i=0; i<(num_ptcl-1); i++ ){
	sp->p1 = i;
	sp->p2 = i+1;
	sp->length = p0[sp->p1].pos.Dist( p0[sp->p2].pos );
	sp++;
  }
}


void C_SeaWead::SetShrink( void ) { 
  const_dumping = 0.7f;
}

void C_SeaWead::ComputeForce( void )
{

  SEAWEAD_PARTICLE	*current,*p1, *p2;
  SEAWEAD_SPRING		*s;
  C_Vec		springForce,deltaV,deltaP;
  current = cur;
  C_Vec g = gravity * current->mass;
  C_Vec w = wind * current->mass;
  for (int i = 0; i < num_ptcl; i++){
	current->force.Set(0.f, 0.f, 0.f);

	if( current->state == RIGID_BIND ) continue;

	//d
	current->force += g;

	//
	if( i >= (num_ptcl-2) )	  current->force += w; 

	//@B
	for( int j=0; j<fun_flg; j++ ){
	  //͌ȂBȁ[B
	  fun_pos[j].y = current->pos.y;
	  f32 dist = current->pos.Dist( fun_pos[j] );
#define kRad (f32)(40.f)
	  if( dist < kRad ) {
		dist = dist*dist*dist / (kRad*kRad*kRad);
		C_Vec f = fun_force[j] * (1-dist);
		current->force += f;
	  }
	}

	//xB
	current->force -= (current->vel * 0.1f);

	//[ɂB
	if( current->state == SOFT_CONSTRAINT_BIND )  current->force += soft_constraint_force;

	current++;
  }

  fun_flg = 0;

  s = spring;
  for (int i = 0; i < (num_ptcl-1); i++){
	p1 = &cur[s->p1];
	p2 = &cur[s->p2];

	if( p1->state == RIGID_BIND && p2->state == RIGID_BIND ){
	}else{
#if 0
	// spring goes from 0 to 1

	C_Vec SpringVector( p1->pos - p2->pos );
	C_Vec Spring = SpringVector * (-s->Ks);

	C_Vec RelativeVelocity( p1->vel - p2->vel );
	C_Vec DampingForce =
			SpringVector * (-(s->Kd) * (RelativeVelocity|SpringVector)/(SpringVector|SpringVector));

	Spring += DampingForce;

	p1->force += Spring;
	p2->force -= Spring;

#else
	f32		dist, Hterm, Dterm;

	//_̈ʒu̍
	deltaP = p1->pos - p2->pos;
	dist = deltaP.Mag();
	
	//Lы
	Hterm = (dist - s->length) * s->Ks;
		
	//_̈ړ̍
	deltaV = p1->vel - p2->vel;
	//_̈ړƃXvǑ߂قǁA
	//_m̋߂قǁA܂͈?

	Dterm = (deltaV|deltaP) * s->Kd / dist; 
	springForce = deltaP * (1.0f/dist);
	springForce *= -(Hterm+Dterm);
	  
	p1->force += springForce;
	p2->force -= springForce;
#endif
	}
	s++;
  }
}


void C_SeaWead::Integrate( void )
{
  SEAWEAD_PARTICLE *source,*target;

  source = cur;	// ݂̃p[^B
  target = next;	// ꂩ狁߂p[^B
  for (int i = 0; i < num_ptcl; i++){
	if( source->state==SPRING_BIND || source->state==SOFT_CONSTRAINT_BIND){
	  //xB
	  target->vel =	(source->vel * const_dumping) + (source->force * source->InvMass * dtime);
	  //ʒuB
	  target->pos = source->pos + (source->vel * dtime);
	}else if( source->state==RIGID_BIND ){
	  C_Vec trs = anchor_pos;
	  //target->vel = trs - target->pos;
	  //target->vel *= (1.0f/dtime);
	  target->vel.Set(0.f);
	  target->pos = trs;
	}else if( source->state == CONSTRAINT_BIND ){
	  target->vel = source->pos - target->pos;
	  target->vel *= (1.0f/dtime);
	  target->pos = source->pos;
	}
	source++;
	target++;
  }
}

void C_SeaWead::Proc( void )
{
  s32 rep = 0;
  SEAWEAD_PARTICLE	*tmp;

  ComputeForce();
  Integrate();

#if 0
  SEAWEAD_PARTICLE	*p1,*p2;
  SEAWEAD_SPRING	*s;
  s = spring;
  for (int i = 0; i < (num_ptcl-1); i++){
	p1 = &cur[s->p1];
	p2 = &cur[s->p2];
	s++;
  }
#endif

  tmp = cur;
  cur = next;
  next = tmp;
}

static
void DrawLine( Vec &p0, Vec &p1, u32 col )
{
  GXBegin(GX_LINES, GX_VTXFMT0, 2);
  GXPosition3f32(p0.x, p0.y, p0.z);
  GXColor1u32(col);
  GXPosition3f32(p1.x, p1.y, p1.z);
  GXColor1u32(col);
  GXEnd();
}
void C_SeaWead::DispStart( void )
{
  HSD_CObj *cobj = HSD_CObjGetCurrent();

  //GXSetColorUpdate( GX_DISABLE );
  GXSetColorUpdate( GX_TRUE );
  GXSetAlphaUpdate( GX_TRUE );
  GXSetDstAlpha( GX_FALSE, 0 );
  //GXSetZMode( GX_TRUE, GX_ALWAYS, GX_TRUE );
  GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );

  //GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
  //GXSetTevOp(GX_TEVSTAGE0, GX_REPLACE);
  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
  GXSetNumTevStages(1);

  //GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
  //GXSetNumTexGens(1);
  GXSetNumTexGens(0);

  GXSetBlendMode(GX_BM_NONE, GX_BL_INVSRCALPHA, GX_BL_SRCALPHA, GX_LO_CLEAR);
  GXSetChanCtrl(GX_COLOR0A0,
				GX_DISABLE,		// enable channel
				GX_SRC_VTX,		// amb source
				GX_SRC_VTX,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);

  GXLoadPosMtxImm(HSD_CObjGetViewingMtxPtr(cobj), GX_PNMTX0);
  GXSetCurrentMtx( GX_PNMTX0 );

  GXClearVtxDesc();
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
  GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT);
}
void C_SeaWead::DispEnd( void )
{
  //GXSetZScaleOffset( 1.f, 0.0000f );
  HSD_StateInvalidate( HSD_STATE_ALL );
}

void C_SeaWead::Disp( void )
{
  for( int i=0; i<(num_ptcl-1); i++ ){
	u8 width = line_width;
	//f32 z_ofst = 0.00025f;
	f32 z_ofst = -0.0000015f;
	GXSetZScaleOffset( 1.f, -z_ofst );
	GXSetLineWidth( (u8)((width+2)*6),GX_TO_ZERO );
	if( cur[spring[i].p2].pos.IsValid() && cur[spring[i].p1].pos.IsValid() ){
	  DrawLine( cur[spring[i].p2].pos, cur[spring[i].p1].pos, (u32)(0xff8f8f00|0xef) );
	  GXSetZScaleOffset( 1.f, -(z_ofst+0.000001f) );
	  GXSetLineWidth( (u8)(width*6),GX_TO_ZERO );
	  //DrawLine( cur[spring[i].p2].pos, cur[spring[i].p1].pos, (u32)(0x1f000000|0xef) );
	  DrawLine( cur[spring[i].p2].pos, cur[spring[i].p1].pos, (u32)col );
	}
  }
  GXSetZScaleOffset(1.0f,0.0f);
}
#if 0
void C_SeaWead::DispMetaball( void )
{
  alpha_map->TexCopyAlpha();
  //alpha_map->Draw();
  //return;
  //eNX`[h
  GXLoadTexObj(alpha_map->GetTexObj(), GX_TEXMAP0);

  //JݒB
  GXRenderModeObj *rmode = HSD_VIGetConfigure();
  HSD_CObj *cobj = HSD_CObjAlloc();
  HSD_CObjSetProjectionType(cobj, COBJ_PROJECTION_ORTHO);
  HSD_CObjSetViewportfx4(cobj, 0, (u16)rmode->viWidth, 0, (u16)rmode->viHeight);
  HSD_CObjSetScissorx4  (cobj, 0, (u16)rmode->viWidth, 0, (u16)rmode->viHeight);
  HSD_CObjSetNear (cobj,   0.0F);
  HSD_CObjSetFar  (cobj, 200.0F);
  HSD_CObjSetOrtho(cobj, 0.f, 480.f, 0.f, 640.f);
  Vec	eyepos   = {0.0f, 0.0f, 100.0f};
  Vec	interest = {0.0f, 0.0f,   0.0f};
  Vec	up       = {0.0f, 1.0f,   0.0f};
  Mtx	mtxView;
  MTXLookAt(mtxView, &eyepos, &up, &interest);
  HSD_CObjSetUserDefinedMtx(cobj, mtxView);
	
  //Tev
#if 0
  //֊s
  //At@obt@̓ȉ̒lɐFB
  //eNX`̃At@RɃXbvB
  //GX_TEV_COMP_R8_GTgAlȉ̏ꍇ
void GXSetTevSwapModeTable(
    GXTevSwapSel   id,
    GXTevColorChan red,
    GXTevColorChan green,
    GXTevColorChan blue,
    GXTevColorChan alpha );
  GXSetTevSwapMode( GX_TEVSTAGE0, 
    GXTevStageID   stage,
    GXTevSwapSel   ras_sel,
    GXTevSwapSel   tex_sel );
#endif

  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
  GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC );
  GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, 
				   GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV );
  GXColor c0 = {0,0,0,threashold_alpha};
  GXSetTevColor( GX_TEVREG0, c0 );
  GXColor c1 = {0,0,0,255};
  GXSetTevColor( GX_TEVREG1, c1 );
  GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_TEXA, GX_CA_A0, GX_CA_A1, GX_CA_ZERO );
  GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_COMP_A8_GT, GX_TB_ZERO, 
				   GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV );
  //GXSetTevOp(GX_TEVSTAGE0, GX_DECAL);
  GXSetNumTevStages(1);
  //GXSetAlphaCompare( GX_GREATER, 180, GX_AOP_AND, GX_ALWAYS, 0 );

  //TexCoord
  GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
  GXSetNumTexGens(1);

  //PE
  GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
  //GXSetBlendMode(GX_BM_BLEND, GX_BL_INVSRCALPHA, GX_BL_SRCALPHA, GX_LO_CLEAR);
	
  //`lB
  GXSetChanCtrl(GX_COLOR0A0,
				GX_DISABLE,		// enable channel
				GX_SRC_REG,		// amb source
				GX_SRC_REG,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXColor col={255,0,0,0};
  GXSetChanMatColor( GX_COLOR0A0, col );
  GXSetNumChans(1);
	
  if (HSD_CObjSetCurrent(cobj)) {
	Mtx	mat;
	MTXIdentity(mat);
	GXLoadPosMtxImm(mat, GX_PNMTX0);
	GXSetCullMode( GX_CULL_NONE );

	GXSetColorUpdate( GX_ENABLE );
	GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

#define	ZMID -0.5f
	GXBegin(GX_QUADS, GX_VTXFMT0, 4);
	GXPosition3f32(0,0, ZMID);
	GXTexCoord2f32(0,0);
	
	GXPosition3f32((f32)rmode->viWidth,0, ZMID);
	GXTexCoord2f32(1,0);
	
	GXPosition3f32((f32)rmode->viWidth,(f32)rmode->viHeight, ZMID);
	GXTexCoord2f32(1,1);
	
	GXPosition3f32((f32)0,(f32)rmode->viHeight, ZMID);
	GXTexCoord2f32(0,1);
	GXEnd();
	HSD_CObjEndCurrent();
  }
  HSD_CObjUnref( cobj );
  HSD_StateInvalidate( HSD_STATE_ALL );
}
#endif






