#ifndef ___C_SHADER_H___
#define ___C_SHADER_H___

//#include "common.h"
#include "utility.h"
#include "c_rect.h"

#define TOON_TEXTURE_SIZE 256
class C_ToonShader {
 public:
  C_ToonShader(void);
  ~C_ToonShader();
		
  void SetToon( HSD_DObj* dobj ){
	for (; dobj; dobj = HSD_DObjGetNext(dobj)) {
	  HSD_MObj *mobj;
	  if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
		HSD_MObjSetFlags(mobj, RENDER_TOON);
		HSD_MObjCompileTev(mobj);
	  }
	}
  }
  void SetToon( HSD_JObj* jobj ){
	HSD_DObj *dobj;
	for (dobj=HSD_JObjGetDObj(jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	  HSD_MObj *mobj;
	  if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
		HSD_MObjSetFlags(mobj, RENDER_TOON);
		HSD_MObjCompileTev(mobj);
	  }
	}
	if( jobj->child ) SetToon( jobj->child );
	if( jobj->next ) SetToon( jobj->next );
  }
  void UnsetToon( HSD_DObj* dobj ){
	for (; dobj; dobj = HSD_DObjGetNext(dobj)) {
	  HSD_MObj *mobj;
	  if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
		HSD_MObjClearFlags(mobj, RENDER_TOON);
		HSD_MObjCompileTev(mobj);
	  }
	}
  }

  void SetCurrent(void) { HSD_MObjSetToonTextureImage(&img_desc); }
  void EndCurrent(void) { HSD_MObjSetToonTextureImage(NULL);       }
 private:
  u16		*img;
  HSD_ImageDesc	img_desc;
};

class C_ScreenTone{
 public:
  C_ScreenTone( s16 y, u8 s_, u8 e_ ) : 
	rect( 0, y, 640, (480-y)), s(s_), e(e_){
  }
  virtual ~C_ScreenTone(){
  }
  void  Proc( void );
  void  Disp( void );
 private:
  C_Rect rect;
  u8 s,e;
};

#endif

