#ifndef ___C_TRIGON_H___
#define ___C_TRIGON_H___

//#include "common.h"
#include "c_vec.h"
#include "vector.h"

typedef struct{
  u32 dirty:1;
}STATUS;
class C_3DBBOX{
 public:
  void SetUp( C_Vec p[], s32 num );
  void SetUp( C_Vec &p0, C_Vec &p1 );
  void AddRegion( f32 val );
  f32 min_x,max_x;
  f32 min_y,max_y;
  f32 min_z,max_z;
};
class C_Trigon{
  friend class C_TrigonArray;
 public:
  //RXgN^
  C_Trigon( C_Vec &p0, C_Vec &p1, C_Vec &p2, C_TrigonArray *_array );
  C_Trigon( C_Vec *p0, C_TrigonArray *_array, s16 *i=0, s16 *mi=0 );
  C_Trigon( void );
  //fXgN^
  virtual ~C_Trigon();

  //_
  C_Vec* GetVtx( void );

  //@
  C_Vec& GetNrm( void );

  //dS
  C_Vec& GetCtr( void );
  
  //Ő̖@
  C_Vec& GetEdgeNrm( u32 idx );

  //BBOX
  C_3DBBOX& GetBBox( void );

  //_
  s16* GetIdx( void );

  //_
  s16* GetMtxIdx( void ){ return mtx_idx; }

  void SetHitEdge( u8 flg ){ hit_edge = flg; }
  void SetDispFlg( u8 flg ){ disp_flg = flg; }


  //`(Jg̃JŁj
  void Disp( u32 col=(u32)(0xff<<24 | 0xff<<16 | 0x88<<8 |0x88), u32 flg=0 );

  bool GetCrossEdge( C_Vec &_s, C_Vec &_e, C_Vec &_n, C_Vec &_p );
  bool Include(const C_Vec &_p);
  bool Include(const Vec &_p);

  void DebugPrint( void );

 private:
  C_Vec p[3];//_
  C_Vec nrm;//@
  C_Vec edge_nrm[3];//GbW̖@B
  C_Vec ctr;//dS
  C_3DBBOX  bbox;
  s16	idx[3];
  s16	mtx_idx[3];
  u8	hit_edge;
  u8	disp_flg;
  C_TrigonArray *array;
  void SetUp( void );
};

class C_TrigonArray{
  friend class C_Coll;
 public:
  //RXgN^
  C_TrigonArray( HSD_PObj *pobj, HSD_JObj *j=0 );
  C_TrigonArray( f32 size, s32 row, s32 col );
  C_TrigonArray( void ){};
  //fXgN^
  virtual ~C_TrigonArray();

  u32 GetNum( void ){ return trigon_num; }
  C_Trigon& GetTrigon( u32 idx ){ return trigon[idx]; }
  C_Trigon* GetTrigonPtr( u32 idx ){ return trigon + idx; }

  void Proc( void );
  void DispStart( void );
  void DispEnd( void );
  void Disp( u32 idx, u32 flg=0, u32 col=(u32)(0x88<<24 | 0xff<<16 | 0x88<<8 |0x88) );
  void DispAll( void ){
	DispStart();
	for( int i=0; i<trigon_num; i++ ){
	  Disp( (u32)i, 0 );
	}
	DispEnd();
  }
  void SetMtx( MtxPtr m ){ MTXCopy( m, cur_mtx ); }
  MtxPtr GetMtx( void ){ return cur_mtx; }
  MtxPtr GetIMtx( void ){ return cur_inv_mtx; }
  bool IsDirty( void ){ return status.dirty; }
  static void SetHeap( s32 no ){ heap_no = no; }
  bool Include(const C_Vec &_p);
  bool Include(const Vec &_p);
 private:
  static s32 heap_no;
  //vector<C_Trigon> trigon;
  C_Trigon *trigon;
  u32 trigon_num;
  Mtx cur_mtx, old_mtx, cur_inv_mtx, old_inv_mtx;
  HSD_JObj *jobj;
  STATUS status;
};
class C_ExtractTrigonArray{
 public:
  C_ExtractTrigonArray( HSD_JObj *_jobj, vector<C_TrigonArray*> &_array ,bool next=true){
	Extract( _jobj, _array ,next);
  }
 private:
  void Extract( HSD_JObj *_jobj, vector<C_TrigonArray*> &_array ,bool next=true){
	HSD_DObj *dobj;
	HSD_PObj *pobj;

	for (dobj = HSD_JObjGetDObj(_jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	  if ((pobj = HSD_DObjGetPObj(dobj)) != NULL) {
		ghmGcMemSetAllocName("CTriAry");
		C_TrigonArray *ta = new C_TrigonArray( pobj, _jobj );
		if( ta ) _array.push_back( ta );
	  }
	}
	if(_jobj->child){
	  Extract(_jobj->child, _array,true);
	}
	if( next==true ){
		for(_jobj=_jobj->next ; _jobj!=NULL ; _jobj=_jobj->next){
		  Extract(_jobj, _array,false);
		}
	}
//	if(_jobj->next){
//	  Extract(_jobj->next, _array);
//	}
  }
};
#endif








