#ifndef ___C_VEC_H___
#define ___C_VEC_H___

//#include "common.h"

class C_Vec : public Vec{
 public:
  C_Vec( void ){x=y=z=0;}
  C_Vec( f32 v ){ x=y=z=v; }
  C_Vec( f32 x0, f32 y0, f32 z0 ){ x=x0, y=y0, z=z0; }
  C_Vec( const Vec& v ){ x=v.x, y=v.y, z=v.z; }

  //C_Vec = C_Vec
  void	operator  = (Vec v) { x  = v.x, y  = v.y, z  = v.z; }
  //C_Vec += C_Vec
  void	operator += (Vec v) { VECAdd(this, &v, this); }
  //C_Vec -= C_Vec
  void	operator -= (Vec v) { VECSubtract(this, &v, this); }

  //C_Vec *= f32
  void	operator *= (f32 f) { VECScale(this, this, f); }
  //C_Vec = C_Vec * f32
  C_Vec	operator *  (f32 f) { VECScale(this, &vec, f); return (C_Vec&)vec; }	
  //C_Vec = C_Vec + Vec
  C_Vec	&operator +  (Vec v) { VECAdd(this, &v, &vec); return (C_Vec&)vec; }
  //C_Vec = C_Vec - Vec
  C_Vec	operator -  (Vec v) { VECSubtract(this, &v, &vec); return (C_Vec&)vec; }
  //bool = (C_Vec == Vec)
  bool	operator == (Vec v) { return (x == v.x && y == v.y && z == v.z); }
  //bool = (C_Vec != Vec)
  bool	operator != (Vec v) { return (x != v.x || y != v.y || z != v.z); }
		
  //C_Vec = C_Vec & VeciOρj
  C_Vec operator & (Vec v) {VECCrossProduct(this, &v, &vec);return (C_Vec&)vec;}
  //f32 = C_Vec | Vec iρj
  f32	operator | (Vec v) { return VECDotProduct(this, &v); }
  
  //ʒuxNgƂ̋B
  f32 Dist(Vec v) { return VECDistance(this, &v); }
  //KB
  void Nrm( void ) { if( !(this->IsZero()) ) VECNormalize(this,this);}
  f32 Mag( void ) { return VECMag(this);}
  //0xNgH
  bool IsZero( void ){ return ( x==0.f && y==0.f && z==0.f ); }
  bool IsValid( void ){ return ( !isnan(x) && !isnan(y) && !isnan(z) ); }

  void Set( f32 _x, f32 _y, f32 _z ){ x=_x;y=_y;z=_z; }
  void Set( f32 _v ){ x = _v; y = _v; z = _v; }
  
 private:
  static C_Vec vec;
};
#endif
