#include "common.h"
#include "c_vfx.h"
#include "..\Wat\WK7ScreenImage.h"

extern	WK7ScreenImage		screenImageFullColor;
extern	WK7ScreenImage		screenImageMonoColor;

C_Tex::C_Tex(s32 _w, s32 _h, GXTexFmt _fmt ,GXTexWrapMode s,GXTexWrapMode t)
{
	w = _w; 
	h = _h;
	fmt_copy = fmt = _fmt;
	if( _w==0 && _h==0 ){
		img = NULL;
		size = 0;
		return;
	}
	size = GXGetTexBufferSize((u16)w, (u16)h, fmt, GX_FALSE, 0);
    ghmGcMemSetAllocName("C_TexImg");
	img = new u8[ size ];
//	img = (u8 *)ghmGcMem::mDefaultHeap.Alloc((int)size);
	GXInitTexObj( &texobj, img, (u16)w,(u16)h, fmt, s, t, GX_FALSE );
//	GXInitTexObj( &texobj, img, (u16)w,(u16)h, fmt, GX_CLAMP, GX_CLAMP, GX_FALSE );
	GXInitTexObjLOD(&texobj, GX_LINEAR, GX_LINEAR, 0, 0, 0, 0, 0, GX_ANISO_1);
	DCFlushRange((void *) img, size);
}

C_Tex::~C_Tex()
{
	GHM_SAFE_DELETE(img);
}

void C_Tex::TexCopy( GXBool flg, s16 _x, s16 _y, s16 _w, s16 _h )
{
	if( size <= 0 ){
		return;
	}
	if( _x < 0 ) _x = (s16)0;
	if( _y < 0 ) _y = (s16)0;
	if( _w < 0 ) _w = (s16)w;
	if( _h < 0 ) _h = (s16)h;

	GXSetColorUpdate( GX_TRUE );
	//GXSetAlphaUpdate( GX_TRUE );
	GXSetAlphaUpdate( GX_FALSE );
	GXSetZMode( GX_FALSE, GX_LESS, GX_TRUE );
	GXSetTexCopySrc((u16)_x, (u16)_y, (u16)_w, (u16)_h);
	GXSetTexCopyDst((u16)_w, (u16)_h, fmt_copy, GX_FALSE);
	GXCopyTex(img, flg);
	GXPixModeSync();
	GXInvalidateTexAll();
	DCFlushRange((void *) img, size);
}

void C_Tex::TexCopyAlpha( GXBool flg, s16 _x, s16 _y, s16 _w, s16 _h)
{
	if( size <= 0 ){
		return;
	}
	
	if( _x < 0 ) _x = (s16)0;
	if( _y < 0 ) _y = (s16)0;
	if( _w < 0 ) _w = (s16)w;
	if( _h < 0 ) _h = (s16)h;

	GXSetColorUpdate( GX_FALSE );
	GXSetAlphaUpdate( GX_TRUE );
	GXSetZMode( GX_FALSE, GX_LESS, GX_TRUE );
	GXSetTexCopySrc((u16)_x, (u16)_y, (u16)_w, (u16)_h);
	GXSetTexCopyDst((u16)_w, (u16)_h, fmt_copy, GX_FALSE);
	GXCopyTex(img, flg);
	GXPixModeSync();
	GXInvalidateTexAll();
	DCFlushRange((void *) img, size);
}

void C_Tex::Draw( void )
{
	if( size <= 0 ){
		return;
	}
	//eNX`[h
	GXLoadTexObj(&texobj, GX_TEXMAP0);

	//JݒB
	GXRenderModeObj *rmode = HSD_VIGetConfigure();
	HSD_CObj *cobj = HSD_CObjAlloc();
	HSD_CObjSetProjectionType(cobj, COBJ_PROJECTION_ORTHO);
	HSD_CObjSetViewportfx4(cobj, 0, (u16)rmode->viWidth, 0, (u16)rmode->viHeight);
	HSD_CObjSetScissorx4  (cobj, 0, (u16)rmode->viWidth, 0, (u16)rmode->viHeight);
	HSD_CObjSetNear (cobj,   0.0F);
	HSD_CObjSetFar  (cobj, 200.0F);
	HSD_CObjSetOrtho(cobj, 0.f, 480.f, 0.f, 640.f);
	Vec	eyepos   = {0.0f, 0.0f, 100.0f};
	Vec	interest = {0.0f, 0.0f,   0.0f};
	Vec	up       = {0.0f, 1.0f,   0.0f};
	Mtx	mtxView;
	MTXLookAt(mtxView, &eyepos, &up, &interest);
	HSD_CObjSetUserDefinedMtx(cobj, mtxView);
	
	//Tev
	GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	GXSetTevOp(GX_TEVSTAGE0, GX_REPLACE);
	GXSetNumTevStages(1);
	//TexCoord
	Mtx	mat;
	MTXIdentity(mat);
	GXLoadTexMtxImm(mat, GX_TEXMTX0, GX_MTX2x4);
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_TEXMTX0 );
	GXSetNumTexGens(1);

	//PE
	GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
	
	//`lB
	GXSetChanCtrl(GX_COLOR0A0,
				  GX_DISABLE,		// enable channel
				  GX_SRC_VTX,		// amb source
				  GX_SRC_VTX,		// mat source
				  GX_LIGHT_NULL,	// light mask
				  GX_DF_CLAMP,	// diffuse function
				  GX_AF_NONE);
	GXSetNumChans(1);
	
	if (HSD_CObjSetCurrent(cobj)) {
	  GXLoadPosMtxImm(mat, GX_PNMTX0);
	  GXClearVtxDesc();
	  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	  GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

#define	ZMID -0.5f
	  GXBegin(GX_QUADS, GX_VTXFMT0, 4);
	  GXPosition3f32(320-w*0.5f, 240-h*0.5f, ZMID);
	  GXTexCoord2f32(0,0);
		
	  GXPosition3f32(320+w*0.5f, 240-h*0.5f, ZMID);
	  GXTexCoord2f32(1,0);
		
	  GXPosition3f32(320+w*0.5f, 240+h*0.5f, ZMID);
	  GXTexCoord2f32(1,1);
		
	  GXPosition3f32(320-w*0.5f, 240+h*0.5f, ZMID);
	  GXTexCoord2f32(0,1);
	  GXEnd();
	  HSD_CObjEndCurrent();
	}
	HSD_CObjUnref( cobj );
	HSD_StateInvalidate(HSD_STATE_ALL);
}

C_VFX::C_VFX( VFX_TYPE _t) : 
//	texture(640,480,GX_TF_RGB5A3), indirect_texture(60,80,GX_TF_IA8){
//	texture(640,480,GX_TF_RGBA8), indirect_texture(64,64,GX_TF_IA8,GX_REPEAT,GX_REPEAT)
	texture(0,0,GX_TF_RGBA8), indirect_texture(64,64,GX_TF_IA8,GX_REPEAT,GX_REPEAT)
{
	type = _t;
	counter = 0;
	intensity = 1.f;
	target_alpha = -1;
	r = g = b = -1;
	s32 val = VFX_MIRAGE_MAX_OFST;
	for( int i=0; i<indirect_texture.GetSize(); i++ ){
	  indirect_texture.GetImage()[i] = (u8)(127 + ( HSD_Rand()%(val*2) - val));
	}
	DCFlushRange((void *) indirect_texture.GetImage(), indirect_texture.GetSize());
}

void C_VFX::Proc( void ){
	counter++;
}

void C_VFX::CopyTex( void )
{
	texture.TexCopy();
}

void C_VFX::SetIntensity( f32 i )
{
	if( i < 0.f ) intensity = 0.f;
	else if( i > 1.f ) intensity = 1.f;
	else intensity = i;
}

void C_VFX::AddIntensity( f32 v )
{
	SetIntensity( v + intensity );
}

f32 C_VFX::GetIntensity(void)
{
	return intensity;
}

void C_VFX::SetTargetAlpha( s32 t )
{
	target_alpha = t;
}

void C_VFX::SetModulateCol( s32 _r, s32 _g, s32 _b )
{
	r = _r;
	g = _g;
	b = _b;
}

GXTexObj *C_VFX::GetTexObj( void )
{
	return texture.GetTexObj();
}

void C_VFX::DispSobel(void)
{
  C_2DCam cam;
  if( cam.DispStart() ){
	GXRenderModeObj *rmode = HSD_VIGetConfigure();

	//`l
	GXSetNumChans(0);

	//eNX`
	GXLoadTexObj(screenImageMonoColor.GetTexObj(), GX_TEXMAP0);

	//eNX`}gbNXB
	f32 ofst_ = 1.f;
	Mtx	mat;
	//S
	MTXIdentity(mat);
	GXLoadTexMtxImm(mat, GX_TEXMTX0, GX_MTX2x4);
	//
	MTXTrans(mat, 0.f, ofst_/(f32)rmode->viHeight, 0.f );
	GXLoadTexMtxImm(mat, GX_TEXMTX1, GX_MTX2x4);
	//
	MTXTrans(mat, -ofst_/(f32)rmode->viWidth, 0.f, 0.f );
	GXLoadTexMtxImm(mat, GX_TEXMTX2, GX_MTX2x4);
	//E
	MTXTrans(mat, ofst_/(f32)rmode->viWidth, 0.f, 0.f );
	GXLoadTexMtxImm(mat, GX_TEXMTX3, GX_MTX2x4);
	//
	MTXTrans(mat, 0.f, -ofst_/(f32)rmode->viHeight, 0.f );
	GXLoadTexMtxImm(mat, GX_TEXMTX4, GX_MTX2x4);

	//eNX`W
	GXSetTexCoordGen(GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_TEXMTX0);
	GXSetTexCoordGen(GX_TEXCOORD1, GX_TG_MTX2x4, GX_TG_TEX0, GX_TEXMTX1);
	GXSetTexCoordGen(GX_TEXCOORD2, GX_TG_MTX2x4, GX_TG_TEX0, GX_TEXMTX2);
	GXSetTexCoordGen(GX_TEXCOORD3, GX_TG_MTX2x4, GX_TG_TEX0, GX_TEXMTX3);
	GXSetTexCoordGen(GX_TEXCOORD4, GX_TG_MTX2x4, GX_TG_TEX0, GX_TEXMTX4);
	GXSetNumTexGens(5);

	//Tev	
	//(d (op) ((1.0 - c)*a + c*b) + bias) * scale;

	//S
	//(d + ((1.0 - 0)*0 + 0*0) + 0) * 4.0 -> prev
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_TEXC);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_4,GX_FALSE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_TEXA,GX_CA_A0,GX_CA_KONST,GX_CA_ZERO);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR_NULL);
	
	//(W@-1)
	//(prev  -   ((1.0 - 0)*a + 0*0) + 0) * 1.0 -> prev
	GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_TEXC,GX_CC_ZERO,GX_CC_ZERO,GX_CC_CPREV);
	GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_SUB,GX_TB_ZERO,GX_CS_SCALE_1,GX_FALSE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_TEXA,GX_CA_A0,GX_CA_KONST,GX_CA_ZERO);
	GXSetTevAlphaOp  (GX_TEVSTAGE1,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder    (GX_TEVSTAGE1,GX_TEXCOORD1,GX_TEXMAP0,GX_COLOR_NULL);
	
	//(W@-1)
	//(prev  -   ((1.0 - 0)*a + 0*0) + 0) * 1.0 -> prev
	GXSetTevColorIn  (GX_TEVSTAGE2,GX_CC_TEXC,GX_CC_ZERO,GX_CC_ZERO,GX_CC_CPREV);
	GXSetTevColorOp  (GX_TEVSTAGE2,GX_TEV_SUB,GX_TB_ZERO,GX_CS_SCALE_1,GX_FALSE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE2,GX_CA_TEXA,GX_CA_A0,GX_CA_KONST,GX_CA_ZERO);
	GXSetTevAlphaOp  (GX_TEVSTAGE2,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder    (GX_TEVSTAGE2,GX_TEXCOORD2,GX_TEXMAP0,GX_COLOR_NULL);
	
	//E(W@-1)
	//(prev  -   ((1.0 - 0)*a + 0*0) + 0) * 1.0 -> prev
	GXSetTevColorIn  (GX_TEVSTAGE3,GX_CC_TEXC,GX_CC_ZERO,GX_CC_ZERO,GX_CC_CPREV);
	GXSetTevColorOp  (GX_TEVSTAGE3,GX_TEV_SUB,GX_TB_ZERO,GX_CS_SCALE_1,GX_FALSE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE3,GX_CA_TEXA,GX_CA_A0,GX_CA_KONST,GX_CA_ZERO);
	GXSetTevAlphaOp  (GX_TEVSTAGE3,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder    (GX_TEVSTAGE3,GX_TEXCOORD3,GX_TEXMAP0,GX_COLOR_NULL);
	
	//(W@-1)
	//(prev  -   ((1.0 - 0)*a + 0*0) + 0) * 4.0 -> prev
	GXSetTevColorIn  (GX_TEVSTAGE4,GX_CC_TEXC,GX_CC_ZERO,GX_CC_ZERO,GX_CC_CPREV);
	GXSetTevColorOp  (GX_TEVSTAGE4,GX_TEV_SUB,GX_TB_ZERO,GX_CS_SCALE_4,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE4,GX_CA_TEXA,GX_CA_A0,GX_CA_KONST,GX_CA_ZERO);
	GXSetTevAlphaOp  (GX_TEVSTAGE4,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder    (GX_TEVSTAGE4,GX_TEXCOORD4,GX_TEXMAP0,GX_COLOR_NULL);
	
	//ЂԂB
	//d + ((a[R] > b[R]) ? c : 0 ) -> prev
	u8 i_ = 24;
	GXColor c_={i_,i_,i_,(u8)a};
	GXSetTevColor( GX_TEVREG0, c_ );
	GXSetTevColorIn  (GX_TEVSTAGE5,GX_CC_C0,GX_CC_CPREV,GX_CC_ONE,GX_CC_ZERO);
	GXSetTevColorOp  (GX_TEVSTAGE5,GX_TEV_COMP_R8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE5,GX_CA_ZERO,GX_CA_ZERO, GX_CA_ZERO, GX_CA_A0);
	GXSetTevAlphaOp  (GX_TEVSTAGE5,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder    (GX_TEVSTAGE5,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR_NULL);
	
	GXSetNumTevStages(6);

	//PE
	GXSetColorUpdate( GX_ENABLE );
	//GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );

	//ʑS̕`B
	MTXIdentity(mat);
	GXLoadPosMtxImm(mat, GX_PNMTX0);
	GXSetCurrentMtx( GX_PNMTX0 );
	GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

#define	ZMID -0.5f
	GXBegin(GX_QUADS, GX_VTXFMT0, 4);{
	  GXPosition3f32((f32)0, (f32)0, ZMID);
	  GXTexCoord2f32(0,0);
		
	  GXPosition3f32((f32)0+(f32)rmode->viWidth, (f32)0, ZMID);
	  GXTexCoord2f32(1,0);

	  GXPosition3f32((f32)0+(f32)rmode->viWidth, 
					 (f32)0+(f32)rmode->viHeight, ZMID);
	  GXTexCoord2f32(1,1);
			
	  GXPosition3f32((f32)0, (f32)0+(f32)rmode->viHeight, ZMID);
	  GXTexCoord2f32(0,1);
	}GXEnd();
	HSD_StateInvalidate( HSD_STATE_ALL );
	cam.DispEnd();
  }
}

void C_VFX::Disp(void)
{
//	return;

  if( type == VFX_SOBEL ){
	DispSobel();
	return ;
  }


	if( intensity<=0.0f ){
		return;
	}
	C_2DCam cam;
	if( cam.DispStart() ){
	  //GXSetVerifyLevel( GX_WARN_NONE );
	  //GXSetVerifyLevel( GX_WARN_SEVERE );
	  //`l
	  GXSetNumChans(0);

	  //eNX`
	  GXLoadTexObj(screenImageFullColor.GetTexObj(), GX_TEXMAP0);
//	  GXLoadTexObj(texture.GetTexObj(), GX_TEXMAP0);
	  GXLoadTexObj(indirect_texture.GetTexObj(), GX_TEXMAP1);

	  //eNX`W
	  GXSetTexCoordGen(GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY);
	  GXSetNumTexGens(1);

	  //Tev1 C_CNg
	
#if FUJITA
	  //̂hc悤ɕύXB 
	  //𑜓xAԂł̂ɌB
	  static	GXColor			col = { 0x00,0x00,0x00,0x7f };
	  
	  if( target_alpha >= 0 ){
		col.a = (u8)target_alpha;
	  }else{
		col.a = (u8)0x7f;
	  }
	  if( r >= 0 ) col.r = (u8)r; else col.r = 0;
	  if( g >= 0 ) col.g = (u8)g; else col.g = 0;
	  if( b >= 0 ) col.b = (u8)b; else col.b = 0;

	  GXSetTevColor    (GX_TEVREG0,col);
#else
	static	GXColor			col = { 0x00,0x00,0x00,0x7f };
	GXSetTevColor    (GX_TEVREG0,col);
#endif
	GXSetTevKAlphaSel(GX_TEVSTAGE1,GX_TEV_KASEL_1);
	if( col.r || col.g || col.b ){
	  GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_CPREV,GX_CC_C0,GX_CC_APREV,GX_CC_ZERO);
#if 0
	  //l^
	  //ƃAt@̏܂ꂽɔwiāAAt@̂ȂɐԂB
	  //At@̏܂ꂽ̗֊st߂ł́AAt@̂Ȃ̐FiԐFj
	  //Ă̂ŁAwiPF̏ꍇ͂ŗ֊ŝ݂̐悪邱ƂɂȂB
	  //GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_C0,GX_CC_CPREV,GX_CC_APREV,GX_CC_ZERO);
#endif
	  GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	}else{
	  GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_CPREV);
	  GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	}
	GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_TEXA,GX_CA_A0,GX_CA_KONST,GX_CA_ZERO);
//	GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_TEXA,GX_CA_ZERO,GX_CA_KONST,GX_CA_ZERO);
	GXSetTevAlphaOp  (GX_TEVSTAGE1,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder    (GX_TEVSTAGE1,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR_NULL);
	
//	GXSetTevKAlphaSel(GX_TEVSTAGE0,GX_TEV_KASEL_1);
//	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_TEXC);
//	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
//	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_TEXA,GX_CA_ZERO,GX_CA_KONST,GX_CA_ZERO);
//	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
//	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR_NULL);
	
//	GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_TEXC);
//	GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
//	GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_APREV);
//	GXSetTevAlphaOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
//	GXSetTevOrder    (GX_TEVSTAGE1,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR_NULL);
	
//	GXSetTevOrder    (GX_TEVSTAGE1, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR_NULL);
//	GXSetTevOp       (GX_TEVSTAGE1, GX_REPLACE);

	GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR_NULL);
	GXSetTevOp(GX_TEVSTAGE0, GX_REPLACE);
	  
	  //GXSetAlphaCompare( GX_EQUAL, 255, GX_AOP_OR, GX_EQUAL, 255 );
	  
//	  GXSetNumTevStages(1);
	  GXSetNumTevStages(2);

	  //C_CNg
	  GXSetNumIndStages(1);
	  GXSetIndTexOrder(GX_INDTEXSTAGE0, GX_TEXCOORD0, GX_TEXMAP1);
	  GXSetIndTexCoordScale(GX_INDTEXSTAGE0, GX_ITS_8, GX_ITS_8);
	  GXSetTevIndWarp(GX_TEVSTAGE0,       // tev stage
//	  GXSetTevIndWarp(GX_TEVSTAGE1,       // tev stage
					  GX_INDTEXSTAGE0,    // indirect stage
					  GX_TRUE,            // signed offsets?
					  GX_FALSE,           // replace mode?
					  GX_ITM_0);          // ind matrix select
	  GXSetTevDirect (GX_TEVSTAGE1);

	  f32 indMtx[2][3];
	  Mtx tmpMtx,r,s;

	  MTXRotDeg(r, 'z', counter*20);
	  MTXScale(s, intensity, intensity, intensity );
	  MTXConcat( r,s,tmpMtx );
	  indMtx[0][0] = tmpMtx[0][0]*0.5f;
	  indMtx[0][1] = tmpMtx[0][1]*0.5f;
	  indMtx[0][2] = 0.0f;
	  indMtx[1][0] = tmpMtx[1][0]*0.5f;
	  indMtx[1][1] = tmpMtx[1][1]*0.5f;
	  indMtx[1][2] = 0.0f;
	  GXSetIndTexMtx(GX_ITM_0, indMtx, 1);

	  //PE
	  GXSetColorUpdate( GX_ENABLE );
	  GXSetAlphaUpdate( GX_DISABLE );
	  //GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
//	  GXSetBlendMode(GX_BM_BLEND, GX_BL_DSTALPHA, GX_BL_INVDSTALPHA, GX_LO_CLEAR);
	  GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	  GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );

	  //ʑS̕`B
	  GXRenderModeObj *rmode = HSD_VIGetConfigure();
	  MTXIdentity(tmpMtx);
	  GXLoadPosMtxImm(tmpMtx, GX_PNMTX0);
	  GXSetCurrentMtx( GX_PNMTX0 );
	  GXClearVtxDesc();
	  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	  GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

#if 1
#define	ZMID -0.5f
	  GXBegin(GX_QUADS, GX_VTXFMT0, 4);{
		GXPosition3f32((f32)0, (f32)0, ZMID);
		GXTexCoord2f32(0,0);
		
		GXPosition3f32((f32)0+(f32)rmode->viWidth, (f32)0, ZMID);
		GXTexCoord2f32(1,0);

		GXPosition3f32((f32)0+(f32)rmode->viWidth, 
					   (f32)0+(f32)rmode->viHeight, ZMID);
		GXTexCoord2f32(1,1);
			
		GXPosition3f32((f32)0, (f32)0+(f32)rmode->viHeight, ZMID);
		GXTexCoord2f32(0,1);
	  }GXEnd();
#endif
	  GXSetNumIndStages(0);
	  GXSetTevDirect(GX_TEVSTAGE0);
	  //GXSetAlphaCompare( GX_ALWAYS, 255, GX_AOP_OR, GX_ALWAYS, 255 );
	  HSD_StateInvalidate( HSD_STATE_ALL );
	  cam.DispEnd();

//	  GXSetVerifyLevel(GX_WARN_ALL   );
//	  GXSetVerifyLevel(GX_WARN_MEDIUM);
#if	!defined(K7APP_MASTER) && !defined(USE_ISDOLVIEWER)
	  //GXSetVerifyLevel(GX_WARN_SEVERE);
#endif
//	  GXSetVerifyLevel(GX_WARN_NONE  );

	}
}

