#include "mobj.h"
#include "common.h"
#include <vector>
#include "utility.h"
#include "c_dvd.h"
#include "c_scene.h"
#include "c_scenedesc.h"
#include "c_shader.h"
#include "c_shadow.h"
#include "c_trigon.h"
#include "c_cyclic.h"
#include "c_coll.h"
#include "c_ball.h"
#include "c_perf.h"
#include "c_font.h"
#include "c_cloth.h"

#include "c_mirror.h"
#include "c_edge.h"
#include "c_edgeshadow.h"
#include "c_particle.h"
#include "mK7Sound.h"
#include "c_pesetup.h"
#include "c_vfx.h"
#include "c_border.h"
#include "c_backlight.h"
#include "c_k7cloth.h"
#include "c_radialblur.h"
//#include "c_texture.h"
#include "c_seawead.h"
#include "c_envelope.h"
#include "c_bloodline.h"
#include "out.c"
#include "fmain.h"

#include "c_brokenglass.h"
#include "noise_CMPR_image.c"
//int C_BrokenGlass::gCount = 0;
//extern unsigned char Grade_01_CMPR_image[];
//#include "Grade_01_CMPR_image.c"
bool FK7MainTask::InitializeCallBack(void)
{
	return true;
}

bool FK7MainTask::TerminateCallBack(void)
{
	return true;
}

bool FK7MainTask::RenderProcess(void)
{
	return true;
}


static void DrawCube( void )
{
  Mtx mt,ms;
  C_Vec pos(-240.929688f, 1910.875610f, -583.568665f );
  C_Vec scl(10.f, 10.f, 10.f );
  MTXTrans( mt, pos.x, pos.y, pos.z );
  MTXScale( ms, scl.x, scl.y, scl.z );
  HSD_CObj *cobj = HSD_CObjGetCurrent();
  MTXConcat( mt, ms, mt );
  MTXConcat( mt, cobj->mtx, mt );
  GXLoadPosMtxImm(mt, GX_PNMTX0);
  GXSetCurrentMtx( GX_PNMTX0 );
  GXDrawCube();
  HSD_StateInvalidate( HSD_STATE_ALL );
}
bool FK7MainTask::FrameProcess(void)
{
#define kCloth 0
#define kShadow 0
#define kMirror 0
#define kSound 0
#define kMirage 0
#define kGrade 0
#define kBackLight 0
#define kRadialBlur 0
#define kTexture 0
#define kSeaWead 0
#define kAiming 0
#define kTV 1
  while( 1 ){
#if kTV
	C_DVD dvd_dan("3Ddata/Model/Chara/DAN/Dan_M00.dat");
	C_DVD dvd_mot("3Ddata/Motion/Chara/DAN/Dan_0080.dat");
	C_SceneDesc *sd_dan = new( dvd_dan.Read() ) C_SceneDesc();
	C_SceneDesc *sd_mot = new( dvd_mot.Read() ) C_SceneDesc();
	sd_dan->models[0]->adjointlist = sd_mot->models[0]->adjointlist;
	C_Scene s_dan( sd_dan );

	HSD_JObj *root = s_dan.GetJObj()->GetJObj();

	//pJ
	C_SphereCam cam;

	GXTexObj     tex_text;
	GXInitTexObj(&tex_text,                           // obj
				 noise_CMPR_image,                   // image_ptr
				 64,              // wight
				 128,             // height
				 (GXTexFmt) GX_TF_CMPR,  // format
				 GX_REPEAT,                          // wrap_s (don't care)
				 GX_REPEAT,                          // wrap_t (don't care)
				 GX_FALSE);                         // mipmap (don't care)
	GXInitTexObjLOD(&tex_text,
					GX_NEAR,     // min_filt
					GX_NEAR,     // max_filt
					0.0f,          // min_lod     (don't care)
					0.0f,          // max_lod     (don't care)
					0.0f,          // lod_bias    (don't care)
					GX_DISABLE,    // bias_clamp  (don't care)
					GX_FALSE,      // do_edge_lod (don't care)
					GX_ANISO_1);   // max_aniso   (don't care)

	s32 counter = 0;
	f32 max = 60.f;

	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  s_dan.Proc();

	  //JB
	  cam.Proc();
	  cam.Copy( s_dan.GetCObj() );

	  //\JnB
	  HSD_VISetClearClr((GXColor){0x20,0xff,0x20,0x00});
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, true);

	  if( !counter ){
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ) counter = (s32)max;
	  }else{
		--counter;
	  }

	  if( s_dan.StartCam() ){
		s_dan.DispLight();

		//f`B
		if( counter ){
		  GXSetColorUpdate( GX_ENABLE );
		  GXSetAlphaUpdate( GX_FALSE );
		  GXSetZMode( GX_ENABLE, GX_LEQUAL, GX_DISABLE );

		  //`lB
		  GXColor col = { 0,0,0,(u8)(255 * counter / max) };
		  GXSetChanMatColor( GX_COLOR0A0, col );
		  GXSetChanCtrl(GX_COLOR0A0,
						GX_ENABLE,		// enable channel
						GX_SRC_REG,		// amb source
						GX_SRC_REG,		// mat source
						GX_LIGHT_NULL,	// light mask
						GX_DF_CLAMP,	// diffuse function
						GX_AF_NONE);
		  GXSetNumChans(1);

		  //eNX`
		  GXLoadTexObj(&tex_text, GX_TEXMAP0);

		  //Tev
		  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );
		  GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_TEXC);
		  GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
		  GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
		  GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
		  GXSetNumTevStages(1);
		
		  //TexGen
		  Mtx mtx,scl,trs,rot;
		  MTXTrans( trs, 0.f, VIGetRetraceCount()*0.5f*counter / max, 0.f );
		  MTXScale( scl, 0.1f, 0.01f + 0.4f*counter/max, 0.5f );
		  MTXRotDeg( rot, 'z', sinf( 32 * (VIGetRetraceCount()%180) * (f32)M_PI / 180.f ) * 90 * counter / max );
		  
		  MTXConcat( rot, scl, mtx );
		  MTXConcat( trs, mtx, mtx );
		  GXLoadTexMtxImm(mtx, GX_TEXMTX9, GX_MTX2x4);
		  GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_POS, GX_TEXMTX9 );
		  GXSetNumTexGens(1);

		  //Blend
		  GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_AND );
		  HSD_JObjDispAll(root, 0, HSD_TRSP_ALL, RENDER_SHADOW|RENDER_EFFECT);
		  HSD_StateInvalidate(HSD_STATE_ALL);
		}else{
		  //C_SetAlpha *a = new C_SetAlpha( root, 0.98f );
		  s_dan.DispModel();
		  //delete a;
		}

		s_dan.EndCam();
	  }

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
#if kAiming
	C_DVD dvd_dan("3Ddata/Model/Chara/DAN/Dan_M00.dat");
	C_DVD dvd_mot("3Ddata/Motion/Chara/DAN/Dan_0080.dat");
	C_SceneDesc *sd_dan = new( dvd_dan.Read() ) C_SceneDesc();
	C_SceneDesc *sd_mot = new( dvd_mot.Read() ) C_SceneDesc();
	sd_dan->models[0]->adjointlist = sd_mot->models[0]->adjointlist;
	C_Scene s_dan( sd_dan );

	C_DVD dvd_ur2("3Ddata/Model/Chara/UR2/UR2_M00.dat");
	C_SceneDesc *sd_ur2 = new( dvd_ur2.Read() ) C_SceneDesc();
	C_Scene s_ur2( sd_ur2 );

	HSD_JObj *root = s_dan.GetJObj()->GetJObj();
	HSD_CObj *cobj = s_dan.GetCObj()->GetCObj();
	Mtx ofst,rot,trs;
	MTXRotDeg( rot, 'y', 180.f );
	MTXTrans( trs, 0.f, -13.f, -20.f );
	MTXConcat( trs, rot, ofst );

	//pJ
	C_SphereCam cam;

	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  s_dan.Proc();
	  s_ur2.Proc();

	  //JB
	  cam.Proc();
	  cam.Copy( s_dan.GetCObj() );

	  MtxPtr mp = HSD_CObjGetInvViewingMtxPtr( cobj );
	  MTXConcat( mp, ofst, HSD_JObjGetMtxPtr( root ) );
	  
	  HSD_JObjSetUserDefinedMtx(root, HSD_JObjGetMtxPtr( root ) );

	  //\JnB
	  HSD_VISetClearClr((GXColor){0x20,0x20,0x20,0x00});
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, true);

	  if( s_dan.StartCam() ){
		s_dan.DispLight();

		//f`B
		s_dan.DispModel();
		s_ur2.DispModel();

		s_dan.EndCam();
	  }

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif

#if kSeaWead
	//C_DVD dvd("3Ddata/Model/Chara/KUN/KUN_M00.dat");
	C_DVD dvd("3Ddata/Model/Chara/UR2/UR2_M00.dat");
	C_DVD dvd_mot("3Ddata/Motion/Chara/UR2/UR2_0020.dat");
	C_SceneDesc *sd = new( dvd.Read() ) C_SceneDesc();
	C_SceneDesc *sd_mot = new( dvd_mot.Read() ) C_SceneDesc();
	sd->models[0]->adjointlist = sd_mot->models[0]->adjointlist;
	C_Scene s( sd );
	HSD_JObj *afro_jobj = s.GetJObj()->GetJObj( "Afro" );
	C_BloodLines bloodline( s.GetJObj()->GetJObj( "UL2_Body" ), 
							afro_jobj, 120, 10 );

	//AẗʒuB
	C_Vec afro_pos( 0.f, 18.f, -25.f );

	//pJ
	C_SphereCam cam;

	//GtFNgB
	C_VFX vfx;

	vfx.SetIntensity( 0.08f );
	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  //At
	  {
		C_Vec rad( 0.f, 0.f, 5.f );
		Mtx rx,ry,r,t;
		MTXRotDeg( ry, 'y', 2*VIGetRetraceCount() );
		MTXRotDeg( rx, 'x', 2*VIGetRetraceCount() );
		MTXConcat( rx, ry, r );
		MTXMultVec( r, &rad, &rad );
		C_Vec p( rad + afro_pos );
		
		MTXTrans( t, p.x, p.y, p.z );
		HSD_JObjSetUserDefinedMtx( afro_jobj, t );
		//HSD_JObjSetTranslate( afro_jobj, &p );
	  }

	  s.Proc();
	  vfx.Proc();
	  bloodline.Proc();

	  //JB
	  cam.Proc();
	  cam.Copy( s.GetCObj() );

	  //\JnB
	  HSD_VISetClearClr((GXColor){0x20,0x20,0x20,0x00});
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, true);

	  if( s.StartCam() ){
		s.DispLight();


		bloodline.Disp();

		if( HSD_PadGetButton(0) & HSD_PAD_B )
		  bloodline.DispEnvelope();

		//f`B
		s.DispModel();

		s.EndCam();
	  }

	  //C_SeaWead::DispMetaball();

	  //Kȃ^C~OŃRs[B
	  vfx.CopyTex();

	  //GtFNg`B
	  vfx.Disp();

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
#if kTexture
	//C_Texture tex("speak.tpl");
	//C_Texture tex("out.tpl");
	C_Texture tex((TEXPalettePtr)broken_glass_IA8);
	C_Vec trs(0.f);

	//pJ
	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

#if 0
	  {
		//C_Paper paper( 197, 260, 1.f, false, 320,240, 0xff0000ff );
		C_Paper paper( 197, -34, 1.f, false, 320,240, 0xff0000ff );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
		PRINTF( "\m\n" );
	  }
#endif
#if 0
	  {
		C_Paper paper( 197, 260, 0.75f, false, 320,240 );
		PRINTF( "\mRE\n" );
	  }
#endif

	  //\JnB
	  HSD_VISetClearClr((GXColor){0x20,0x20,0x20,0x00});
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, false);

	  //eNX`
	  //tex.Disp(1,0);
	  tex.Disp(0);
	  if( HSD_PadGetButton(0) & HSD_PAD_UP ) trs.y -= 1.f;
	  if( HSD_PadGetButton(0) & HSD_PAD_DOWN ) trs.y += 1.f;
	  if( HSD_PadGetButton(0) & HSD_PAD_RIGHT ) trs.x += 1.f;
	  if( HSD_PadGetButton(0) & HSD_PAD_LEFT ) trs.x -= 1.f;

	  tex.Trs(1, trs.x, trs.y, trs.z );

	  //tHg
	  C_Font::GetInstance()->Draw();
	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
#if kRadialBlur
	//C_DVD dvd("3Ddata/Model/Chara/Dan/DAN_M00.dat");
	C_DVD dvd("3Ddata/Model/Chara/KUN/KUN_M00.dat");
	C_SceneDesc *sd = new( dvd.Read() ) C_SceneDesc();
	C_Scene s( sd );
	HSD_JObj *root_jobj = s.GetJObj()->GetJObj();
	HSD_JObj *target_jobj = s.GetJObj()->GetJObj("WristR_joint");

	//u[
	C_RadialBlur blur( root_jobj, target_jobj );

	//pJ
	C_SphereCam cam;
	f32 scale = 0.5f;
	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  //V[B(g̓_Oj
	  s.Proc();

	  //JB
	  cam.Proc();
	  cam.Copy( s.GetCObj() );

	  //u[
	  blur.Proc( s.GetCObj()->GetCObj() );

	  //\JnB
	  HSD_VISetClearClr((GXColor){0x20,0x20,0x20,0x00});
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, false);

	  if( s.StartCam() ){
		s.DispLight();

		//f`B
		s.DispModel();

		blur.Disp();

		GXSetZScaleOffset( 1.f, -0.0004f );
		s.EndCam();
		GXSetZScaleOffset( 1.f, 0.f );
	  }

	  if( HSD_PadGetButton(0) & HSD_PAD_MENU ) 	  blur.DrawTex();

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
#if kBackLight
	C_DVD dvd("3Ddata/Model/Chara/Dan/DAN_M00.dat");
	C_SceneDesc *sd = new( dvd.Read() ) C_SceneDesc();
	C_Scene s( sd );
	HSD_JObj *jobj = s.GetJObj()->GetJObj();

	C_Vec gen_pos;
	C_Generator gen( gen_pos, 10 );

	//t𔭂郉Cg쐬B
	//ۂ̕`ɎgnĂ悢B
	//jX|bgCgȂlɂȂĂ܂B
	HSD_LObj *lobj = HSD_LObjAlloc();
	lobj->flags |= LOBJ_SPOT;
	C_Vec lpos(0.f,10.f,-30.f);
	C_Vec i(0.f,0.f,0.f);
	HSD_LObjSetPosition( lobj, &lpos );
	HSD_LObjSetInterest( lobj, &i );
	HSD_LObjSetSpot( lobj, 30.f, GX_SP_OFF );

	//pJ
	C_SphereCam cam;
	f32 scale = 0.5f;
	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  //V[B
	  s.Proc();

	  //f𓮂B
	  if( HSD_PadGetButton(0) & HSD_PAD_STICK_LEFT ) HSD_JObjAddTx( jobj, -0.1f );
	  if( HSD_PadGetButton(0) & HSD_PAD_STICK_RIGHT ) HSD_JObjAddTx( jobj, 0.1f );

	  //t̋ςB
	  if( HSD_PadGetTrigger(0) & HSD_PAD_A ) scale += 0.1f;
	  if( HSD_PadGetTrigger(0) & HSD_PAD_B ) scale -= 0.1f;
	  //sJsJ
	  if( HSD_PadGetTrigger(0) & HSD_PAD_Y ) gen.Fire();
	  if( gen.IsAlive() ){
		HSD_JObj *j = s.GetJObj()->GetJObj("WristR_joint");
		MtxPtr mtx = HSD_JObjGetMtxPtr( j );
		HSD_MtxGetTranslate( mtx, &gen_pos );
		C_Vec eye_pos = s.GetCObj()->GetEyePos();
		C_Vec dir = gen_pos - eye_pos; 
		dir.Nrm();
		gen_pos -= (dir*3.f);
		gen.SetPos( gen_pos );
	  }

	  //tZbgB
	  //jobjɂtp̃f[^jobj̏ŎIɏB
	  //Iɋt؂ꍇ́ABACKLIGHT.Clear( jobj )ŏB
#if 1
	  //CgnB
	  BACKLIGHT.Set( jobj, scale, lobj );
#else
	  //ɃJ̐^tɃCgB
	  BACKLIGHT.Set( jobj, scale );
#endif

	  //JB
	  cam.Proc();
	  cam.Copy( s.GetCObj() );


	  PARTICLE.Proc( s.GetCObj()->GetCObj() );

	  //\JnB
	  HSD_VISetClearClr((GXColor){0x80,0x80,0x80,0x00});
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, false);

	  if( s.StartCam() ){
		s.DispLight();

		//f`B
		s.DispModel();

		{//Cg̈ʒu`B
		  Mtx trs,view,m;
		  C_Vec pos;
		  HSD_CObj *cobj = HSD_CObjGetCurrent();
		  HSD_CObjGetViewingMtx( cobj, view );
		  HSD_LObjGetPosition( lobj, &pos );
		  MTXTrans( trs, pos.x, pos.y, pos.z );
		  MTXConcat( view, trs, m );
		  GXLoadPosMtxImm( m, GX_PNMTX0 );
		  GXSetCurrentMtx( GX_PNMTX0 );
		  u8 c = (u8)(127 + 127*(scale>1.f ? 1.f : (scale<0.f ? 0.f : scale)));
		  GXColor col={c,c,c,c};
		  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
		  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
		  GXSetNumTevStages(1);
		  GXSetNumTexGens(0);
		  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
		  GXSetChanCtrl(GX_COLOR0A0,
						GX_ENABLE,		// enable channel
						GX_SRC_REG,		// amb source
						GX_SRC_REG,		// mat source
						GX_LIGHT_NULL,	// light mask
						GX_DF_CLAMP,	// diffuse function
						GX_AF_NONE);
		  GXSetChanMatColor( GX_COLOR0A0, col );
		  GXSetChanAmbColor( GX_COLOR0A0, col );
		  GXSetNumChans( 1 );
		  GXDrawSphere( 8, 8 );
		  HSD_StateInvalidate( HSD_STATE_ALL );
		}

		PARTICLE.Disp();
		s.EndCam();
	  }

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
#if kGrade
	//C_DVD dvd("enemy.dat");
	C_DVD dvd("coll.dat");
	C_SceneDesc *sd = new( dvd.Read() ) C_SceneDesc();
	C_Scene s( sd );
	
	//f|S쐬B
	C_JObj *mdl = s.GetJObj();
	HSD_JObj *red = mdl->GetJObj( "red" );
	class BLUES{
	public:
	  BLUES( void ){
		jobj = 0;
		flg = 1;
	  }
	  HSD_JObj *jobj;
	  s32 flg;
	  C_Vec dst;
	};
	HSD_JObj *blue1 = mdl->GetJObj( "blue1" );
	HSD_JObj *blue2 = mdl->GetJObj( "blue2" );
	HSD_JObj *blue3 = mdl->GetJObj( "blue3" );
	HSD_JObj *blue4 = mdl->GetJObj( "blue4" );
	BLUES blues[4];
	blues[0].jobj = blue1;
	blues[1].jobj = blue2;
	blues[2].jobj = blue3;
	blues[3].jobj = blue4;
	HSD_JObjSetFlags( mdl->GetJObj(), JOBJ_HIDDEN );
	//HSD_JObjClearFlags( red, JOBJ_HIDDEN );
	HSD_JObjClearFlags( blue1, JOBJ_HIDDEN );
	HSD_JObjClearFlags( blue2, JOBJ_HIDDEN );
	HSD_JObjClearFlags( blue3, JOBJ_HIDDEN );
	HSD_JObjClearFlags( blue4, JOBJ_HIDDEN );
  	C_TrigonArray trigon( HSD_JObjGetDObj( mdl->GetJObj() )->pobj, mdl->GetJObj() );
	//GbW𒊏oB
	C_Border border( trigon );
	//pJ
	C_SphereCam cam;

	C_Vec dst_pos,tmp_dst_pos;
	s32 last_no;
	s32 no = -1;
	s32 chg_flg;
	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  //V[B
	  s.Proc();
	  trigon.Proc();

	  if( HSD_PadGetButton(0) & HSD_PAD_A ){
	  }else{
		if( no < 0 ){
		  static int num = 0;
		  while( 1 ){
			no = (s32)(HSD_Rand()%border.GetNodeNum());
			if( no != last_no ) break;
		  }

		  //if( !num )	{no = 18;num++;}
		  //		  else { no = 3; }	
		  
		  last_no = no;
		  dst_pos = border.GetNodePos( (u32)no );
		  chg_flg = 1;
		  //HSD_JObjSetTranslate( blue1, &dst_pos );
		}else{
		  C_Vec rpos;
		  HSD_JObjGetTranslate( red, &rpos );

		  //ŏIړInɓBĂȂB
		  if( dst_pos != rpos ){

			//ʉߓ_߂B(ŏIړIn̏ꍇ)
			if( chg_flg ){
			  Vec d = border.FindPath( rpos, dst_pos );
			  tmp_dst_pos = d;
			  chg_flg = 0;
			}

			//ʉߓ_ɌĐiށB
			C_Vec d = tmp_dst_pos;
			d -= rpos;
			if( d.Mag() < 1.f ){
			  chg_flg = 1;
			  rpos = tmp_dst_pos;
			}else{
			  d.Nrm();
			  rpos += d;
			}
			HSD_JObjSetTranslate( red, &rpos );
		  }else{
			no = -1;
		  }
		}
	  }

#if 1
	  for( int i=0; i<4; i++ ){
		f32 speed = 0.5f;
		C_Vec rpos,bpos;
		HSD_JObjGetTranslate( red, &rpos );
		HSD_JObjGetTranslate( blues[i].jobj, &bpos );

		if( bpos != rpos ){
		  if( blues[i].flg ){
#if 0
			C_Vec node_pos[10];
			u32 num = border.FindPossibleLastNode( rpos, node_pos, 10 );
			if( num ){
			  //܂ɁAQԖڂɋ߂_ŏIړInɂB
			  if( (HSD_Rand()%100) > 70 )  rpos = node_pos[ 1 ];
			  //OSReport( "%d\n", num );
			  //HSD_DmpVector( "", &rpos );
			}
#endif
			Vec d = border.FindPath( bpos, rpos );
			blues[i].dst = d;
			blues[i].flg = 0;
		  }
		  C_Vec d = blues[i].dst;
		  d -= bpos;
		  if( d.Mag() < speed ){
			blues[i].flg = 1;
			bpos = blues[i].dst;
		  }else{
			d.Nrm();
			d *= speed;
			bpos += d;
		  }
		  HSD_JObjSetTranslate( blues[i].jobj, &bpos );
		}
	  }
#endif



	  //JB
	  //cam.Proc();
	  //cam.Copy( s.GetCObj() );

	  //\JnB
	  HSD_VISetClearClr((GXColor){0x30,0x30,0x30,0x00});
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, false);

	  if( s.StartCam() ){
		s.DispLight();
		//f`B
		s.DispModel();
		border.DispAll();
		s.EndCam();
	  }

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
#if kMirage
	C_DVD dvd("enemy.dat");
	C_DVD dvd_bg("bg.dat");
	C_SceneDesc *sd = new( dvd.Read() ) C_SceneDesc();
	C_Scene s( sd );
	C_SceneDesc *sd_bg = new( dvd_bg.Read() ) C_SceneDesc();
	C_Scene s_bg( sd_bg );
	
	//GtFNgf`悷鎞ɁA
	//255At@obt@ɏނ悤ɂB
	HSD_PEDesc pe={
	  //J[AAt@AŒAt@݁AZobt@SăGiuB
	  ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE,
	  //GXSetAlphaCompare(),ref0,ref1
	  //At@RyA͎gȂB
	  0,0,
	  //GXSetDstAlpha(),dst_alpha
	  //ɌŒl255ށBiCgeNX`̉e͂Ȃj
	  255,
	  //GXSetBlendMode(),type,src_factor,dst_factor,logic_op
	  //uh͂Ȃ̂src_factorAdst_factor, logic_op͂ǂł悢B
	  GX_BM_NONE,  GX_BL_DSTALPHA,  GX_BL_INVDSTALPHA,  GX_LO_CLEAR,
	  //GXSetZMode(),func
	  //Zr͒ʏǂB
	  GX_LEQUAL,
	  //GXAlphaCompare,comp0,op,comp1
	  //At@RyA͎gȂB
	  GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
	};

	//HSD_PEDescnHSD_JObjSĂPEB
	//PE̔jsysdolphinĂ̂ŋCɂȂł悢B
	C_PESetup pesetup( s.GetJObj()->GetJObj(), &pe );

	//pJ
	C_SphereCam cam;

	//GtFNgB
	C_VFX vfx;

	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  //V[B
	  s.Proc();
	  s_bg.Proc();

	  //GtFNgB
	  vfx.Proc();
	  //GtFNg̋ݒB0`1
	  if( HSD_PadGetTrigger(0) & HSD_PAD_A ) vfx.AddIntensity(0.1f);
	  if( HSD_PadGetTrigger(0) & HSD_PAD_B ) vfx.AddIntensity(-0.1f);
	  

	  //JB
	  cam.Proc();
	  cam.Copy( s.GetCObj() );

	  //\JnB
	  HSD_VISetClearClr((GXColor){0x00,0x00,0x80,0x00});
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, false);

	  if( s.StartCam() ){
		s.DispLight();
		//Xe[W`B
		s_bg.DispModel();
		//f`B
		s.DispModel();
#if 0
		//fB͖B
		GXColor col = { 0,0,0,255*scl };
		GXSetColorUpdate( GX_TRUE );
		GXSetAlphaUpdate( GX_TRUE );
		GXSetZMode( GX_TRUE, GX_EQUAL, GX_FALSE );
		GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
		GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
		GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
		GXSetNumTexGens(0);
		GXSetNumTevStages(1);
		GXSetChanMatColor( GX_COLOR0A0, col );
		GXSetChanCtrl(GX_COLOR0A0,
					  GX_ENABLE,		// enable channel
					  GX_SRC_REG,		// amb source
					  GX_SRC_REG,		// mat source
					  GX_LIGHT_NULL,	// light mask
					  GX_DF_CLAMP,	// diffuse function
					  GX_AF_NONE);
		GXSetNumChans(1);

		HSD_JObj *jobj = root->GetJObj();
		HSD_JObjDispAll(jobj, 0, HSD_TRSP_OPA, RENDER_SHADOW|RENDER_EFFECT);
		HSD_StateInvalidate( HSD_STATE_ALL );
#endif
		s.EndCam();
	  }

	  //Kȃ^C~OŃRs[B
	  vfx.CopyTex();

	  //GtFNg`B
	  vfx.Disp();

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
#if kSound
	s32 sound_no = 0;
	SND.ReadSFX( "/audio/sfx/ssmp/sample.ssm", 0 );
	
	s32 count=0;
	s32 stream[3] = {0,};
	s32 trk_no =0;
	s32 vol[3] = {0,};
	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  //B

	  ////////////////////////////////////////////////////////////////////////
	  //Xg[~O
	  ////////////////////////////////////////////////////////////////////////
	  char *fname[] = {
		"/audio/bgm/bgm2_32k.hps",
		"/audio/bgm/bgm1_32k.hps",
		"/audio/bgm/rocket.hps",
	  };

	  //gbNIB
	  if( HSD_PadGetTrigger(0) & HSD_PAD_UP ){
		trk_no -= 1;
	  }
	  if( HSD_PadGetTrigger(0) & HSD_PAD_DOWN ){
		trk_no += 1;
	  }
	  trk_no = trk_no>2 ? 2 : (trk_no<0 ? 0 : trk_no);


	  //H[B
	  s32 flg = 0;
	  if( HSD_PadGetButton(0) & HSD_PAD_LEFT ){
		vol[trk_no] -= 1; flg=1;
	  }
	  if( HSD_PadGetButton(0) & HSD_PAD_RIGHT ){
		vol[trk_no] += 1; flg=1;
	  }
	  vol[trk_no] = (u8)(vol[trk_no]>255 ? 255 : (vol[trk_no]<0 ? 0 : vol[trk_no]));

	  if( flg ) 
		SND.SetVolStream( (u8)vol[trk_no],trk_no );

	  //Đ
	  if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		stream[trk_no] ^= 1;
		if( stream[trk_no] )  SND.PlayStream( fname[trk_no], (u8)vol[trk_no], trk_no );
		else  SND.StopStream( trk_no );
	  }

	  ////////////////////////////////////////////////////////////////////////
	  //ʉ
	  ////////////////////////////////////////////////////////////////////////
	  if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
		sound_no = (sound_no+1)%20;
		SND.PlaySFX( sound_no );
	  }

	  ////////////////////////////////////////////////////////////////////////
	  //
	  ////////////////////////////////////////////////////////////////////////
	  //\
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, false);
  	  {
  		C_Paper paper( 30, 40, 1.f, false, 320,240 );
  		PRINTF( "SOUND-NO: %d \n", sound_no );
  		PRINTF( "%c:TRACK  1: %d (%d) VOL %d\n", trk_no==0?'o':' ', stream[0], SND.CheckStream(0), vol[0] );
  		PRINTF( "%c:TRACK  2: %d (%d) VOL %d\n", trk_no==1?'o':' ', stream[1], SND.CheckStream(1), vol[1] );
  		PRINTF( "%c:TRACK  3: %d (%d) VOL %d\n", trk_no==2?'o':' ', stream[2], SND.CheckStream(2), vol[2] );
  	  }
	  //tHg
	  C_Font::GetInstance()->Draw();

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
#if kMirror

	//ɉffB
	C_DVD dvd0("mask_coat.dat");
	C_SceneDesc *sd0 = new ( dvd0.Read() ) C_SceneDesc();
	C_Scene s0(sd0);
	C_JObj *root0 = s0.GetJObj();

	//̑OɔzuB
	C_Vec pos(-240.929688f, 1910.875610f, -583.568665f );
	HSD_JObjSetTranslate( root0->GetJObj(), &pos );

	//}bvB
	C_DVD dvd("3Ddata/Model/Stage/000/Stage000_M00.dat");
	C_SceneDesc *sd = new( dvd.Read() ) C_SceneDesc();
	C_Scene s(sd);

	C_JObj *root = s.GetJObj();
	C_CObj *camera = s.GetCObj();

	//TCYƂJOBJ.
	HSD_JObj *jobj_size = root->GetJObj( "MirrorScaleL" );
	//̃fB
	HSD_JObj *jobj = root->GetJObj( "MirrorL" );
	//̃}eAB
	HSD_DObj *dobj = root->GetDObj( "phong_MirrorL" );
	//Q[p̃JnB
	HSD_CObj *cobj = camera->GetCObj();
	//fJOBJ,@Q[JCOBJA}eADOBJATCYpJOBJȀB
	//C_Mirror mirror( jobj, cobj, dobj, jobj_size );
	C_Mirror* mirror = new C_Mirror( jobj, cobj, dobj, jobj_size );

	//pJ
	C_SphereCam cam;
	cam.SetScale( 2.f );
	cam.SetIntPos( C_Vec( -215.929688f, 1915.875610f, -557.568665f ) );
	cam.SetLatitude( 89.f );
	cam.SetLongtitude( 40.f );
	cam.SetLength( 5.f );

	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  //V[B
	  s.Proc();
	  HSD_JObjAddRy( root0->GetJObj(), (f32)(2.f * M_PI / 360.f) );

	  //JB
	  //cam.Proc();
	  //cam.Copy( s.GetCObj() );
	  C_Vec i(-232.481308f, 1911.335083f, -563.900391f);
	  C_Vec e(-222.598236f, 1906.937134f, -558.990540f);
	  HSD_CObj *c = s.GetCObj()->GetCObj();
	  HSD_CObjSetFov( c, 42.184681f );
	  HSD_CObjSetEyePosition( c, &e );
	  HSD_CObjSetInterest( c, &i );
	  HSD_CObjSetCurrent( c );
	  HSD_CObjEndCurrent();
  
	  //~[̏
	  //ۂɂ̓~[p̃eNX`B
	  //eƂƓC[WB
	  mirror->Proc();
	  //~[p̃JZbgB
	  if( mirror->DispStart() ){
		//~[Ɏʂf`B
#if 0
		HSD_CObj *cobj = HSD_CObjGetCurrent();
		Vec interest, eye_pos;
		HSD_CObjGetInterest		(cobj, &interest);
		HSD_CObjGetEyePosition	(cobj, &eye_pos);
		OSReport( "m_i: %f %f %f\n", interest.x, interest.y, interest.z );
		OSReport( "m_e: %f %f %f\n", eye_pos.x, eye_pos.y, eye_pos.z );
		HSD_DmpMatrix( "", cobj->mtx );
#endif
		root->Disp();
		root0->Disp();
		mirror->DispEnd();
#if 0
		//Tv
m_i: 0.000000 0.000000 0.000000
m_e: -280.368805 1906.937134 -558.990540
  (-0.000000 -0.000000 1.000000 558.990479)
  (-0.000000 1.000000 0.000000 -1906.937134)
  (-1.000000 0.000000 -0.000000 -280.368988)

	   //Q[
m_i: 0.000000 0.000000 0.000000
m_e: -280.368805 1906.937134 -558.990540
  (-0.000000 -0.000000 1.000000 558.990479)
  (-0.000000 1.000000 0.000000 -1906.937134)
  (-1.000000 0.000000 -0.000000 -280.368988)
#endif
	  }

	  //ʏ̕\
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, false);
	  s.Disp();
	  root0->Disp();
	  HSD_EndRender();

	  if( HSD_PadGetButton(0) & HSD_PAD_X ){
		cam.Print();
		mirror->DrawTex();
	  }

	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}


#endif
#if kShadow
	C_DVD dvd("shadow.dat");
	C_SceneDesc *sd = new( dvd.Read() ) C_SceneDesc();
	C_Scene s( sd );

	C_JObj *root = s.GetJObj();

	HSD_JObj *ball = root->GetJObj( "ball" );
	HSD_JObj *ground = root->GetJObj( "ground" );
	C_EdgeArray ball_edge( root->GetDObj( "ball_mat" )->pobj, ball );
	C_EdgeArray ground_edge( root->GetDObj("ground_mat")->pobj, ground );
	s.GetLObj(1)->SetRate(0.1f);
	C_Vec lpos = s.GetLObj(1)->GetPosition();
	C_EdgeShadow shadow( lpos );
	shadow.Add( ball_edge );
	shadow.Add( ground_edge );

	//pJ
	C_SphereCam cam;

	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  //V[B
	  s.Proc();

	  C_Vec lpos =s.GetLObj(1)->GetPosition();
	  shadow.SetEyePos( lpos );
	  shadow.Proc();

	  //JB
	  cam.Proc();
	  cam.Copy( s.GetCObj() );

	  //\
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, false);

	  s.Disp();
	  {
		C_CObj *cobj = s.GetCObj();
		cobj->DispStart();
		if( HSD_PadGetButton( 0 ) & HSD_PAD_X ){
		  shadow.DispAll(1);
		}else{
		  shadow.DispAll();
		}
		cobj->DispEnd();
	  }
	  
	  //̏ԂŁAAt@obt@͂قƂ0xffŖ߂ĂƂB
	  //iAt@obt@gꍇ0xffŃNA邱Ɓj
	  //S`悵ɁAGXSetColorUpdate( GX_FALSE ), GXSetAlphaUpdate( GX_TRUE ), 
	  // GXSetZMode( GX_TRUE , GX_LESS, GX_FALSE )ƂāA
	  //
	  //1,@GXSetCullMode( GX_CULL_BACK ), GXSetDstAlpha( GX_TRUE, 127 )ŉe|S`B
	  //	ŃAt@obt@ŁA\ʂ̐߂̈悪127őSēhԂB	@@@@@
	  //
	  //2,	GXSetCullMode( GX_CULL_FRONT ), GXSetBlendMode( GX_BM_BLEND, GX_BL_ONE, GX_BL_ONE, GX_LO_CLEAR )
	  //	ŁAAt@l128Ƃĉe|S`B
	  //	ŁA\ʂĂȂ̈悪128+127 = 0xffœhԂB
	  //
	  //3,	ʏ̕`Ԃɖ߂ĉʂPʂɃ|S`BF͉e̐FB
	  //	̍ہAAt@obt@̒lŃt[obt@̐FB

	  shadow.DispShadow();

	  //tHg
	  C_Font::GetInstance()->Draw();

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
#if kCloth
#define kNew 1
	s32 sound_no = 0;
	//SND.ReadSFX( "/audio/sfx/ssmp/sample.ssm", 0 );
	//SND.PlayStream( "/audio/bgm/rocket.hps", 255 );
	
	//DVDf[^ǂݍ݁B
#if kNew
	//C_DVD dvd("MSK_M01.dat");
	C_DVD dvd("mask.dat");
#else
	C_DVD dvd("mask_coat.dat");
#endif

	//V[fXNv^쐬B
	C_SceneDesc *sd = new ( dvd.Read() ) C_SceneDesc();
	sd->Print();

	//V[쐬B
	C_Scene s( sd );

	//R[g쐬B
	C_JObj *root = s.GetJObj();

#if kNew
	C_K7Cloth cloth( root->GetJObj(), sd->GetModelSet((u32)0)->GetJoint() );
	//C_K7Cloth *c = 0;
#else
	//[B
	HSD_JObj *ll0 = root->GetJObj( "CoatL1_joint1" );
	HSD_JObj *ll1 = root->GetJObj( "CoatL1_joint2" );
	HSD_JObj *ll2 = root->GetJObj( "CoatL1_joint3" );
	HSD_JObj *ll3 = root->GetJObj( "CoatL1_joint4" );
	HSD_JObj *ll4 = root->GetJObj( "CoatL1_tip" );

	//B
	HSD_JObj *l0 = root->GetJObj( "CoatL2_joint1" );
	HSD_JObj *l1 = root->GetJObj( "CoatL2_joint2" );
	HSD_JObj *l2 = root->GetJObj( "CoatL2_joint3" );
	HSD_JObj *l3 = root->GetJObj( "CoatL2_joint4" );
	HSD_JObj *l4 = root->GetJObj( "CoatL2_tip" );

	//^B
	HSD_JObj *m0 = root->GetJObj( "CoatCenter_joint1" );
	HSD_JObj *m1 = root->GetJObj( "CoatCenter_joint2" );
	HSD_JObj *m2 = root->GetJObj( "CoatCenter_joint3" );
	HSD_JObj *m3 = root->GetJObj( "CoatCenter_joint4" );
	HSD_JObj *m4 = root->GetJObj( "CoatCenter_tip" );

	//EB
	HSD_JObj *r0 = root->GetJObj( "CoatR2_joint1" );
	HSD_JObj *r1 = root->GetJObj( "CoatR2_joint2" );
	HSD_JObj *r2 = root->GetJObj( "CoatR2_joint3" );
	HSD_JObj *r3 = root->GetJObj( "CoatR2_joint4" );
	HSD_JObj *r4 = root->GetJObj( "CoatR2_tip" );

	//E[B
	HSD_JObj *rr0 = root->GetJObj( "CoatR1_joint1" );
	HSD_JObj *rr1 = root->GetJObj( "CoatR1_joint2" );
	HSD_JObj *rr2 = root->GetJObj( "CoatR1_joint3" );
	HSD_JObj *rr3 = root->GetJObj( "CoatR1_joint4" );
	HSD_JObj *rr4 = root->GetJObj( "CoatR1_tip" );

	HSD_JObj *objs[] = {ll0,ll1,ll2,ll3,ll4, 
						l0,l1,l2,l3,l4, 
						m0,m1,m2,m3,m4, 
						r0,r1,r2,r3,r4,
						rr0,rr1,rr2,rr3,rr4};
	C_Cloth cloth( 5,5, objs );

  	//C_TrigonArray floor( 2.f, 10, 10 );

	//郂f(}gNX擾pj
	HSD_JObj *body = root->GetJObj( "Koura" );
	//f|S쐬B
  	C_TrigonArray trigon( root->GetDObj( "ColBody" )->pobj, body );
	//R[gɓ|SwBij
	cloth.AddTrigon( &trigon );
	//cloth.AddTrigon( &floor );
#endif

	//pJ
	C_SphereCam cam;

	s32 count=0;
	while(true){
	  VIWaitForRetrace();
	  HSD_PadRenewStatus();

	  //B

	  //JB
	  cam.Proc();
	  cam.Copy( s.GetCObj() );

	  Mtx m;
	  C_Vec trs;
	  cam.GetMtx( m );
	  C_Vec x( m[0][0], m[0][1], m[0][2] ); 
	  C_Vec y( m[1][0], m[1][1], m[1][2] ); 
	  C_Vec z( m[2][0], m[2][1], m[2][2] ); 

	  //ZbgĂB
	  C_Vec wind = z;
	  //cloth.SetWind( wind );

	  static s32 flg = 0;
	  
	  if( HSD_PadGetButton(0) & HSD_PAD_START ){
		if( HSD_PadGetTrigger(0) & HSD_PAD_Z )flg=0;
		else flg = 1;
	  }else{
		flg = 60;
	  }

	  //if( HSD_PadGetTrigger(3) & HSD_PAD_START )
	  //SND.PlayStream( "/audio/bgm/bgm2_32k.hps", 255 );

	  if( (flg % 60) == 0 ){
	  //fB
	  f32 stick_x = HSD_PadGetNormalStickX(0);
	  f32 stick_y = HSD_PadGetNormalStickY(0);
	  if( fabs(stick_x) > 0.1f ) trs -= (x * stick_x);
	  if( fabs(stick_y) > 0.1f ) trs -= (y * stick_y);
#if 1
	  HSD_JObjAddTx( root->GetJObj(), trs.x );
	  HSD_JObjAddTy( root->GetJObj(), trs.y );
	  HSD_JObjAddTz( root->GetJObj(), trs.z );
	  HSD_JObjSetRy( root->GetJObj(), HSD_PadGetNormalSubStickX(0)*(f32)M_PI*0.7f );
#else
	  HSD_JObjAddTx( body, trs.x );
	  HSD_JObjAddTy( body, trs.y );
	  HSD_JObjAddTz( body, trs.z );
	  HSD_JObjSetRy( body, HSD_PadGetNormalSubStickX(0)*(f32)M_PI*0.7f );
#endif
	  //V[B
	  s.Proc();
	  //|SB
#if !kNew
	  trigon.Proc();
	  //floor.Proc();
#endif
	  //R[gB
	  cloth.Proc();
	  }

#if 0
	  if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		if( c ) delete c;
		c = new C_K7Cloth( root->GetJObj(), sd->GetModelSet((u32)0)->GetJoint() );
	  }
	  if( c ) c->Proc();
#endif
#if 0
  	  {
  		C_Paper paper( 30, 40, 1.f, false, 320,240 );
  		PRINTF( "SOUND-NO: %d \n", sound_no );
		if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
		  SND.PlaySFX( sound_no );
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		  sound_no = (sound_no+1)%20;
		}
  	  }
#endif


	  //\
	  HSD_StartRender(HSD_RP_SCREEN);
	  HSD_SetZSortMode(true, false);

	  //|S`,_\B
	  if( HSD_PadGetButton(0) & HSD_PAD_X ){
		C_CObj *cobj = s.GetCObj();
		cobj->DispStart();
#if !kNew
		trigon.DispAll();
		//floor.DispAll();
#endif
		cloth.Disp();
		cobj->DispEnd();
	  }else{
		s.Disp();
	  }
	  
	  //tHg
	  C_Font::GetInstance()->Draw();

	  HSD_EndRender();
	  HSD_VICopyXFBASync(HSD_RP_SCREEN);
	  HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	}
#endif
  }
	return true;
}


FK7MainTask::FK7MainTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
  _pApp = pApp;
}

FK7MainTask::~FK7MainTask()
{
}

