/*
 * Copyright 1999-2001 HAL Laboratory, Inc. All rights reserved.
 *
 * $Id: mobj.c,v 1.8 2004/07/27 02:14:29 TypeR Exp $
 */

//FUJITA
#ifdef FUJITA
#pragma cplusplus			off
#pragma cpp_extensions		off
#pragma warn_implicitconv	off
#endif

#include <string.h>

//tƂ͂ON
#define ENABLE_BACKLIGHT (FUJITA && 1)
//Of[VƂ͂ON
#define ENABLE_GRADATION (FUJITA && 1)
//#define ENABLE_GRADATION (FUJITA && 0)

//FUJITA
//#include "sysdolphin/baselib/mobj.h"
#include "mobj.h"
#include "sysdolphin/baselib/aobj.h"
#include "sysdolphin/baselib/lobj.h"
#include "sysdolphin/baselib/debug.h"
#include "sysdolphin/baselib/state.h"
#include "sysdolphin/baselib/dump.h"
#include "private.h"

static void MObjInfoInit(void);

HSD_MObjInfo hsdMObj = { MObjInfoInit };

static HSD_MObjInfo *default_class = NULL;

static HSD_MObj *current_mobj = NULL;

static HSD_TObj *tobj_toon    = NULL;
static HSD_TObj *tobj_shadows = NULL;

/** @package MObj */

/*
 * (J֐)
 * 
 * mobj̗L錾B
 */
void
HSD_MObjSetCurrent(HSD_MObj *mobj)
{
  current_mobj = mobj;
}

/**
 * ݂̕`pɗLĂmobj擾B
 */
HSD_MObj *
HSD_MObjGetCurrent(void)
{
  return current_mobj;
}

/**
 * tO擾B
 * 
 * @see HSD_MObjSetFlags
 * @see HSD_MObjClearFlags
 * @see HSD_MObjModifyFlags
 */
u32
HSD_MObjGetFlags(HSD_MObj *mobj)
{
  return (mobj)? mobj->rendermode : 0;
}

/**
 * tOZbgB
 * 
 * @see HSD_MObjGetFlags
 * @see HSD_MObjClearFlags
 * @see HSD_MObjModifyFlags
 */
void
HSD_MObjSetFlags(HSD_MObj *mobj, u32 flags)
{
  if (mobj) mobj->rendermode |= flags;
}

/**
 * tONAB
 * 
 * @see HSD_MObjSetFlags
 * @see HSD_MObjGetFlags
 * @see HSD_MObjModifyFlags
 */
void
HSD_MObjClearFlags(HSD_MObj *mobj, u32 flags)
{
  if (mobj) mobj->rendermode &= ~flags;
}

/**
 * tOݒ肷B
 *
 *  mask Ŏw肵tO flags ̒lɐݒ肷B
 * 
 * @param flags	ݒ肷tOl
 * @param mask	ύXtÕrbg}XN
 * 
 * @see HSD_MObjGetFlags
 * @see HSD_MObjSetFlags
 * @see HSD_MObjClearFlags
 */
void
HSD_MObjModifyFlags(HSD_MObj *mobj, u32 flags, u32 mask)
{
  if (mobj) mobj->rendermode = (mobj->rendermode & ~mask) | (flags & mask);
}

/**
 * 1 mobj Ƃ̉̍\̂ɑ΂flags Ŏw肳ꂽAj[V폜B
 * 
 * @see HSD_MObjRemoveAnim
 */
void
HSD_MObjRemoveAnimByFlags(HSD_MObj *mobj, u32 flags)
{
  if (mobj == NULL)
    return;
  
  if (flags & MOBJ_ANIM) {
    HSD_AObjRemove(mobj->aobj);
    mobj->aobj = NULL;
  }
  if (flags & TOBJ_ANIM) {
    HSD_TObjRemoveAnimAll(mobj->tobj);
  }
}

/**
 * 1 mobj Ƃ̉̍\̂ɑ΂SẴAj[V폜B
 * 
 * @see HSD_MObjRemoveAnimByFlags
 */
void
HSD_MObjRemoveAnim(HSD_MObj *mobj)
{
  HSD_MObjRemoveAnimByFlags(mobj, ALL_ANIM);
}

/**
 * 1 mobj Ƃ̉̍\̂ɑ΂Aj[Vo^B
 */
void
HSD_MObjAddAnim(HSD_MObj *mobj, HSD_MatAnim *matanim)
{
  if (mobj == NULL)
    return;

  if (matanim) {
    if (mobj->aobj) {
      HSD_AObjRemove(mobj->aobj);
    }
    mobj->aobj = HSD_AObjLoadDesc(matanim->aobjdesc);
    HSD_TObjAddAnimAll(mobj->tobj, matanim->texanim); 
  }
}

/**
 * 1 mobj Ƃ̉̍\̂ɑ΂flags Ŏw肳ꂽAj[V
 * JnwB
 * 
 * @see HSD_MObjReqAnim
 */
void
HSD_MObjReqAnimByFlags(HSD_MObj *mobj, float startframe, u32 flags)
{
  if (mobj == NULL)
    return;

#ifdef XDEBUG
  HSD_Report("MObjReqAnim: in\n");
#endif

  if (flags & MOBJ_ANIM) {
    HSD_AObjReqAnim(mobj->aobj, startframe);
  }
  HSD_TObjReqAnimAllByFlags(mobj->tobj, startframe, flags);

#ifdef XDEBUG
  HSD_Report("MObjReqAnim: out\n");
#endif
}

/**
 * 1 mobj Ƃ̉̍\̂ɑ΂ăAj[V̊JnwB
 * 
 * @see HSD_MObjReqAnimByFlags
 */
void
HSD_MObjReqAnim(HSD_MObj *mobj, float startframe)
{
  HSD_MObjReqAnimByFlags(mobj, startframe, ALL_ANIM);
}

/*
 * 1 mobj ɑ΂Aj[V̌ʂ\̂ɔfB
 */
static void
MObjUpdateFunc(void *obj, u32 type, FObjData *val)
{
  HSD_MObj *mobj = obj;

  if (mobj == NULL)
    return;

#ifdef XDEBUG
  HSD_Report("MObjUpdateFunc in\n");
#endif
  switch (type) {
  case HSD_A_M_AMBIENT_R:
    if (mobj->mat) {
      mobj->mat->ambient.r = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_AMBIENT_G:
    if (mobj->mat) {
      mobj->mat->ambient.g = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_AMBIENT_B:
    if (mobj->mat) {
      mobj->mat->ambient.b = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_DIFFUSE_R:
    if (mobj->mat) {
      mobj->mat->diffuse.r = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_DIFFUSE_G:
    if (mobj->mat) {
      mobj->mat->diffuse.g = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_DIFFUSE_B:
    if (mobj->mat) {
      mobj->mat->diffuse.b = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_ALPHA:
    if (mobj->mat) {
      mobj->mat->alpha = HSD_ClampFloat(1.0F - val->fv, 0, 1);
    }
    break;
  case HSD_A_M_SPECULAR_R:
    if (mobj->mat) {
      mobj->mat->specular.r = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_SPECULAR_G:
    if (mobj->mat) {
      mobj->mat->specular.g = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_SPECULAR_B:
    if (mobj->mat) {
      mobj->mat->specular.b = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_PE_REF0:
    if (mobj->pe) {
      mobj->pe->ref0 = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_PE_REF1:
    if (mobj->pe) {
      mobj->pe->ref1 = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_M_PE_DSTALPHA:
    if (mobj->pe) {
      mobj->pe->dst_alpha = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  }
}

/**
 * 1 mobj Ƃ̉̍\̂ɑ΂ăAj[VߎsB
 */
void
HSD_MObjAnim(HSD_MObj *mobj)
{
  if (mobj == NULL)
    return;
  
#ifdef XDEBUG
  HSD_Report("MObjAnim: in\n");
#endif
#if HSD_ANIM_METHOD_LEVEL <= 2
  HSD_AObjInterpretAnim(mobj->aobj, mobj, HSD_MOBJ_METHOD(mobj)->update);
#else
  HSD_AObjInterpretAnim(mobj->aobj, mobj, MObjUpdateFunc);
#endif
  HSD_TObjAnimAll(mobj->tobj);

#ifdef XDEBUG
  HSD_Report("MObjAnim: out\n");
#endif
}

#if FUJITA
static 
void SetToonTObj(HSD_MObj *mobj, HSD_TObjDesc *desc)
{
  mobj->tobj_toon = HSD_TObjLoadDesc(desc);
  assert2(mobj->tobj_toon, ("cannot allocate tobj for toon."));
}
static 
void SetGradationTObj(HSD_MObj *mobj, HSD_TObjDesc *desc)
{
  mobj->tobj_gradation = HSD_TObjLoadDesc(desc);
  assert2(mobj->tobj_gradation, ("cannot allocate tobj for gradation."));
}
static 
void SetBackLightTObj(HSD_MObj *mobj, HSD_TObjDesc *desc)
{
  mobj->tobj_backlight = HSD_TObjLoadDesc(desc);
  assert2(mobj->tobj_backlight, ("cannot allocate tobj for back light."));
}

#define kReadyMadeBackLightTex 0
#if kReadyMadeBackLightTex
#include "Grade_01_CMPR_image.c"
#if 1
static HSD_ImageDesc gBackLightImageDesc = {
  (void*)Grade_01_CMPR_image,                        /* eNX`C[W */
  32, 128,                                       /* width height */
  (GXTexFmt)GX_TF_CMPR,	                          /* eNX`tH[}bg*/
  GX_FALSE,                                       /* mipmap tO */
  0.000000, 0.000000,	                          /* minLOD, maxLOD */
};
#else
static u8 TestTexMap0[] ATTRIBUTE_ALIGN(32) =
{
    // IA4 format 16x4
    0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xF0, 0xF0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xF0, 0xF0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xF0, 0xF0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xF0, 0xF0,

    0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0x00, 0x00,
    0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0x00, 0x00,
    0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0x00, 0x00,
    0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0x00, 0x00
};
static HSD_ImageDesc gBackLightImageDesc = {
  (void*)TestTexMap0,                        /* eNX`C[W */
  16, 4,                                       /* width height */
  (GXTexFmt)GX_TF_IA4,	                          /* eNX`tH[}bg*/
  GX_FALSE,                                       /* mipmap tO */
  0.000000, 0.000000,	                          /* minLOD, maxLOD */
};
#endif
static HSD_TObjDesc gBackLightTObjDesc = {
  NULL,					//class_name
  NULL,					//next
  GX_TEXMAP7,			//id(ŏ㏑̂łǂłǂ)
  GX_TG_NRM,			//TexGeñ\[XB
  { 0.0F, 0.0F, 0.0F },	//rotate
  { 0.0F, 0.0F, 0.0F },	//scale  
  { 0.0F, 0.0F, 0.0F },	//translate  
  GX_CLAMP,				//wrap_s
  GX_REPEAT,			//wrap_t
  1,					//repeat_s
  1,					//repeat_t
  //TEX_COORD_BACKLIGHT|TEX_LIGHTMAP_DIFFUSE| \
  //TEX_COLORMAP_REPLACE|TEX_ALPHAMAP_NONE,  /* TEX_COORD_BACKLIGHTĂ */
  TEX_COORD_BACKLIGHT|TEX_LIGHTMAP_EXT| \
  TEX_COLORMAP_ADD|TEX_ALPHAMAP_NONE,  /* TEX_COORD_BACKLIGHTĂ */
  0.99F,					//blending
  GX_LINEAR,			//magFilt
  &gBackLightImageDesc,	//*imagedesc
  NULL,					//*tlutdesc
  NULL,					//*lod
  NULL,					//*tev
};
#endif

#define kReadyMadeGradationTex 0
//#define kReadyMadeGradationTex 1
#if kReadyMadeGradationTex
//eXgp̃Of[VveNX`.
static u8 gGradationImage[] ATTRIBUTE_ALIGN(32) =
{
#define COL16 ((u8)0xff)
#define COL15 ((u8)(0xff-0x10))
#define COL14 ((u8)(0xff-0x20))
#define COL13 ((u8)(0xff-0x30))
#define COL12 ((u8)(0xff-0x40))
#define COL11 ((u8)(0xff-0x50))
#define COL10 ((u8)(0xff-0x60))
#define COL9 ((u8)(0xff-0x70))
#define COL8 ((u8)(0xff-0x80))
#define COL7 ((u8)(0xff-0x90))
#define COL6 ((u8)(0xff-0xa0))
#define COL5 ((u8)(0xff-0xb0))
#define COL4 ((u8)(0xff-0xc0))
#define COL3 ((u8)(0xff-0xd0))
#define COL2 ((u8)(0xff-0xe0))
#define COL1 ((u8)(0xff-0xf0))

  COL16, COL16, COL16, COL16, COL16, COL16, COL16, COL16,
  COL15, COL15, COL15, COL15, COL15, COL15, COL15, COL15,
  COL14, COL14, COL14, COL14, COL14, COL14, COL14, COL14,
  COL13, COL13, COL13, COL13, COL13, COL13, COL13, COL13,

  COL16, COL16, COL16, COL16, COL16, COL16, COL16, COL16,
  COL15, COL15, COL15, COL15, COL15, COL15, COL15, COL15,
  COL14, COL14, COL14, COL14, COL14, COL14, COL14, COL14,
  COL13, COL13, COL13, COL13, COL13, COL13, COL13, COL13,

  COL12, COL12, COL12, COL12, COL12, COL12, COL12, COL12,
  COL11, COL11, COL11, COL11, COL11, COL11, COL11, COL11,
  COL10, COL10, COL10, COL10, COL10, COL10, COL10, COL10,
  COL9,  COL9,  COL9,  COL9,  COL9,  COL9,  COL9,  COL9,

  COL12, COL12, COL12, COL12, COL12, COL12, COL12, COL12,
  COL11, COL11, COL11, COL11, COL11, COL11, COL11, COL11,
  COL10, COL10, COL10, COL10, COL10, COL10, COL10, COL10,
  COL9,  COL9,  COL9,  COL9,  COL9,  COL9,  COL9,  COL9,

  COL8,  COL8,  COL8,  COL8,  COL8,  COL8,  COL8,  COL8,
  COL7,  COL7,  COL7,  COL7,  COL7,  COL7,  COL7,  COL7,
  COL6,  COL6,  COL6,  COL6,  COL6,  COL6,  COL6,  COL6,
  COL5,  COL5,  COL5,  COL5,  COL5,  COL5,  COL5,  COL5,

  COL8,  COL8,  COL8,  COL8,  COL8,  COL8,  COL8,  COL8,
  COL7,  COL7,  COL7,  COL7,  COL7,  COL7,  COL7,  COL7,
  COL6,  COL6,  COL6,  COL6,  COL6,  COL6,  COL6,  COL6,
  COL5,  COL5,  COL5,  COL5,  COL5,  COL5,  COL5,  COL5,

  COL4,  COL4,  COL4,  COL4,  COL4,  COL4,  COL4,  COL4,
  COL3,  COL3,  COL3,  COL3,  COL3,  COL3,  COL3,  COL3,
  COL2,  COL2,  COL2,  COL2,  COL2,  COL2,  COL2,  COL2,
  COL1,  COL1,  COL1,  COL1,  COL1,  COL1,  COL1,  COL1,

  COL4,  COL4,  COL4,  COL4,  COL4,  COL4,  COL4,  COL4,
  COL3,  COL3,  COL3,  COL3,  COL3,  COL3,  COL3,  COL3,
  COL2,  COL2,  COL2,  COL2,  COL2,  COL2,  COL2,  COL2,
  COL1,  COL1,  COL1,  COL1,  COL1,  COL1,  COL1,  COL1,
};
static HSD_ImageDesc gGradationImageDesc = {
  (void*)gGradationImage,                        /* eNX`C[W */
  16, 16,                                       /* width height */
  (GXTexFmt)GX_TF_I8,	                          /* eNX`tH[}bg*/
  GX_FALSE,                                       /* mipmap tO */
  0.000000, 0.000000,	                          /* minLOD, maxLOD */
};
static HSD_TObjDesc gGradationTObjDesc = {
  NULL,					//class_name
  NULL,					//next
  GX_TEXMAP7,			//id(ŏ㏑̂łǂłǂ)
  GX_TG_POS,			//TexGeñ\[XB_̈ʒu
  { 0.0F, 0.0F, 0.0F },	//rotate
  { 0.0F, 0.0F, 0.0F },	//scale  
  { 0.0F, 0.0F, 0.0F },	//translate  
  GX_CLAMP,				//wrap_s
  GX_CLAMP,				//wrap_t
  1,					//repeat_s
  1,					//repeat_t
  TEX_COORD_GRADATION|TEX_LIGHTMAP_DIFFUSE| \
  TEX_COLORMAP_BLEND|TEX_ALPHAMAP_NONE,		  /* TEX_COORD_GRADATIONĂ */
//  TEX_COLORMAP_MODULATE|TEX_ALPHAMAP_NONE,		  /* TEX_COORD_GRADATIONĂ */
  0.5F,					//blending
  GX_LINEAR,			//magFilt
  &gGradationImageDesc,	//*imagedesc
  NULL,					//*tlutdesc
  NULL,					//*lod
  NULL,					//*tev
};
#endif
#endif
static int
MObjLoad(HSD_MObj *mobj, HSD_MObjDesc *desc)
{
  mobj->rendermode = desc->rendermode;

  mobj->tobj = HSD_TObjLoadDesc(desc->texdesc);

  //OSReport( "%d\n", mobj->tobj->flag & TEX_LIGHTMAP_MASK );
  //OSReport( "%d\n", (mobj->tobj->flag & TEX_COLORMAP_MASK) >> 16 );

  mobj->mat = HSD_MaterialAlloc();
  memcpy(mobj->mat, desc->mat, sizeof(HSD_Material));
#if !FUJITA
#if 1	/* defined(USE_RENDER_TOON) */
  mobj->rendermode |= RENDER_TOON;
#endif
#else
  mobj->tobj_toon = NULL;
  mobj->tobj_gradation = NULL;
  mobj->tobj_backlight = NULL;
  //veNX`tB
  if( desc->renderdesc ){
	void **ptr = (void**)desc->renderdesc;
	//Toon
	if( ptr[0] ){
	  mobj->rendermode |= RENDER_TOON;
	  SetToonTObj( mobj, (HSD_TObjDesc*)ptr[0] );
	}
#if ENABLE_GRADATION
	//Gradation
#if !kReadyMadeGradationTex
	if( ptr[1] ){
	  SetGradationTObj( mobj, (HSD_TObjDesc*)ptr[1] );
	}
#else
	SetGradationTObj( mobj, &gGradationTObjDesc );
#endif
#endif
  }

  //Ƃ肠ASɂB
  //SetBackLightTObj( mobj, &gBackLightTObjDesc );
#endif
  if (desc->pedesc) {
    mobj->pe = hsdAllocMemPiece(sizeof(HSD_PEDesc));
    memcpy(mobj->pe, desc->pedesc, sizeof(HSD_PEDesc));
  }
  mobj->aobj = NULL;

  return 0;
}

/**
 * ftHgNX̎w
 * 
 * mobjƂăftHgŐIuWFNg̃NXw肷B
 * 
 * włNXhsdMObjA̓oNXłȂ΂ȂȂB
 * 
 * @see HSD_MObjGetDefaultClass
 * @see HSD_MObjAlloc
 * @see HSD_MObjLoadDesc
 */
void
HSD_MObjSetDefaultClass(HSD_MObjInfo *info)
{
  if (info) {
    assert(hsdIsDescendantOf(info, &hsdMObj));
  }
  default_class = info;
}

/**
 * ftHgNX̎擾
 * 
 * mobjƂăftHgŐIuWFNg̃NX擾B
 * 
 * @see HSD_MObjSetDefaultClass
 * @see HSD_MObjAlloc
 * @see HSD_MObjLoadDesc
 */
HSD_MObjInfo *
HSD_MObjGetDefaultClass(void)
{
  return default_class? default_class : &hsdMObj;
}

/**
 * MObj PAMObjDesc [h
 *
 * @see HSD_MObjAlloc
 * @see HSD_MObjRemove
 */
HSD_MObj *
HSD_MObjLoadDesc(HSD_MObjDesc *mobjdesc)
{
  if (mobjdesc) {
    HSD_MObj *mobj;
    HSD_ClassInfo *info;
    
    if (!mobjdesc->class_name ||
        !(info = hsdSearchClassInfo(mobjdesc->class_name)))
    {
      mobj = HSD_MObjAlloc();
    } else {
      mobj = hsdNew(info);
      assert(mobj);
    }

    HSD_MOBJ_METHOD(mobj)->load(mobj, mobjdesc);
    HSD_MObjCompileTev(mobj);

    return mobj;
  } else {
    return NULL;
  }
}

static HSD_TExp *
MObjMakeTExp(HSD_MObj *mobj, HSD_TObj *tobj_top, HSD_TExp **list)
{
  HSD_TExp *diff, *spec, *ext, *alpha;
  HSD_TExp *exp, *cnst;
  HSD_TObj *tobj, *toon = NULL, *bump = NULL;
  u32 done = 0;
  u32 diffuse_mode;
  u32 alpha_mode;

  assert(list);

  *list = NULL;

  for (tobj=tobj_top; tobj; tobj=tobj->next) {
    if (tobj_coord(tobj) == TEX_COORD_TOON) {
      toon = tobj;
    }
  }

  /*
   * ʌ݊̂߂̃tOC
   */

  diffuse_mode = mobj->rendermode & RENDER_DIFFUSE_BITS;
  if (diffuse_mode == RENDER_DIFFUSE_MAT0) {
    diffuse_mode = RENDER_DIFFUSE_MAT;
  }

  alpha_mode = mobj->rendermode & RENDER_ALPHA_BITS;
  if (alpha_mode == RENDER_ALPHA_COMPAT) {
    alpha_mode = diffuse_mode << (RENDER_ALPHA_SHIFT - RENDER_DIFFUSE_SHIFT);
  }

  /*
   * DIFFUSEňF𐶐B
   */

  exp = HSD_TExpTev(list);

  if (mobj->rendermode & RENDER_DIFFUSE) {
    static u8 one = 255;

    /*
     * DIFFUSECeBOsȂꍇB
     */

    switch (diffuse_mode) {
    case RENDER_DIFFUSE_VTX:
      /*
       * F RGB = 1.0
       */
      HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_1, HSD_TEXP_ZERO);
      break;

    default: // RENDER_DIFFUSE_MAT || RENDER_DIFFUSE_BOTH
      cnst = HSD_TExpCnst(&(mobj->mat->diffuse), HSD_TE_RGB, HSD_TE_U8, list);

      HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_RGB, cnst);
      break;
    }

    switch (alpha_mode) {
    case RENDER_ALPHA_VTX:
      /*
       * F A = 1.0
       */
      cnst = HSD_TExpCnst(&(one), HSD_TE_X, HSD_TE_U8, list);

      HSD_TExpAlphaOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_X, cnst);
      break;

    default: // RENDER_ALPHA_MAT || RENDER_ALPHA_BOTH
      cnst = HSD_TExpCnst(&(mobj->mat->alpha), HSD_TE_X, HSD_TE_F32, list);

      HSD_TExpAlphaOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_X, cnst);
      break;
    }
  } else {
    /*
     * DIFFUSECeBOsȂȂꍇB
     */
    switch (diffuse_mode) {
    case RENDER_DIFFUSE_MAT:
      /* base = mat */
      cnst = HSD_TExpCnst(&(mobj->mat->diffuse), HSD_TE_RGB, HSD_TE_U8, list);

      HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_RGB, cnst);
      break;
    case RENDER_DIFFUSE_VTX:
      /* base = vtx */
      HSD_TExpOrder  (exp, toon, GX_COLOR0A0);
      HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_RGB, (toon)? HSD_TEXP_TEX:HSD_TEXP_RAS);
      break;
    default: // RENDER_DIFFUSE_BOTH
      /* base = mat + vtx */
      cnst = HSD_TExpCnst(&(mobj->mat->diffuse), HSD_TE_RGB, HSD_TE_U8, list);

      HSD_TExpOrder  (exp, toon, GX_COLOR0A0);
      HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpColorIn(exp, HSD_TE_RGB, (toon)? HSD_TEXP_TEX:HSD_TEXP_RAS,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_RGB, cnst);
      break;
    }

    switch (alpha_mode) {
    case RENDER_ALPHA_MAT:
      /* base = mat */
      cnst = HSD_TExpCnst(&(mobj->mat->alpha), HSD_TE_X, HSD_TE_F32, list);

      HSD_TExpAlphaOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_X, cnst);
      break;
    case RENDER_ALPHA_VTX:
      /* base = vtx */

      /*
       * fBt[YFtoongĂ\̂ŁAKvȂĂ
       * toonw肵ĂBTExp̃RpCɕKv̂Ȃݒ͍폜
       * ̂ŁAȂB
       */
      HSD_TExpOrder  (exp, toon, GX_COLOR0A0);
      HSD_TExpAlphaOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_A, HSD_TEXP_RAS);
      break;
    default: // RENDER_ALPHA_BOTH:
      /* base = mat * vtx */
      cnst = HSD_TExpCnst(&(mobj->mat->alpha), HSD_TE_X, HSD_TE_F32, list);

      /*
       * fBt[YFtoongĂ\̂ŁAKvȂĂ
       * toonw肵ĂBTExp̃RpCɕKv̂Ȃݒ͍폜
       * ̂ŁAȂB
       */
      HSD_TExpOrder  (exp, toon, GX_COLOR0A0);
      HSD_TExpAlphaOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_A, HSD_TEXP_RAS,
			   HSD_TE_X, cnst,
			   HSD_TE_0, HSD_TEXP_ZERO);
      break;
    }
  }

  diff = exp;
  alpha = exp;


  /* DIFFUSE STAGES */

  for (tobj = tobj_top; tobj != NULL; tobj = tobj->next) {
    if ((tobj_lightmap(tobj) & (TEX_LIGHTMAP_DIFFUSE|TEX_LIGHTMAP_AMBIENT)) &&
        tobj->id != GX_TEXMAP_NULL)
    {
      HSD_TOBJ_METHOD(tobj)->make_texp(tobj, TEX_LIGHTMAP_DIFFUSE|
					     TEX_LIGHTMAP_AMBIENT,
					     done, &diff, &alpha, list);
    }
  }
  done |= TEX_LIGHTMAP_DIFFUSE|TEX_LIGHTMAP_AMBIENT;


  /* DIFFUSE Lights */
   
  if (mobj->rendermode & RENDER_DIFFUSE) {

    if (alpha_mode & RENDER_ALPHA_VTX) {
      /*
       * At@Cgƒ_At@Ɏgꍇ̃`lݒ
       *   _At@:   CHANNEL 0
       *   At@Cg: CHANNEL 1
       *
       * TEVvŹA
       *    alpha' = CH0 * (1-CH1) * alpha
       *
       * ȉ(1-CH1)Ɋ|ĂB
       */

      exp = HSD_TExpTev(list);

      HSD_TExpOrder(exp, NULL, GX_COLOR1A1);

      HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_RGB, diff);

      HSD_TExpAlphaOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(exp, HSD_TE_A, alpha,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_A, HSD_TEXP_RAS,
			   HSD_TE_0, HSD_TEXP_ZERO);

      diff  = exp;
      alpha = exp;
    }

    exp = HSD_TExpTev(list);

    if (toon) {
      HSD_TExpOrder  (exp, toon, GX_COLOR0A0);
#if !FUJITA
      HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_RGB, diff,
			   HSD_TE_RGB, HSD_TEXP_TEX,
			   HSD_TE_0, HSD_TEXP_ZERO);
#else
	  // out_reg = (d (op) ((1.0 - c)*a + c*b) + bias) * scl;
      HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
#if 0
      HSD_TExpColorIn(exp, 
					  HSD_TE_RGB, HSD_TEXP_TEX,
					  HSD_TE_RGB, diff,
					  HSD_TE_A, HSD_TEXP_TEX,
					  HSD_TE_0, HSD_TEXP_ZERO);
#else
      HSD_TExpColorIn(exp, 
					  HSD_TE_RGB, diff,
					  HSD_TE_RGB, HSD_TEXP_TEX,
					  HSD_TE_A, HSD_TEXP_TEX,
					  HSD_TE_0, HSD_TEXP_ZERO);
#endif
#endif
    } else {
      HSD_TExpOrder  (exp, NULL, GX_COLOR0A0);
      HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_RGB, diff,
			   HSD_TE_RGB, HSD_TEXP_RAS,
			   HSD_TE_0, HSD_TEXP_ZERO);
    }
    diff = exp;

    if (alpha_mode & RENDER_ALPHA_VTX) {
      HSD_TExpAlphaOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_A, alpha,
			   HSD_TE_A, HSD_TEXP_RAS,
			   HSD_TE_0, HSD_TEXP_ZERO);
    } else {
      HSD_TExpAlphaOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(exp, HSD_TE_A, alpha,
			   HSD_TE_0, HSD_TEXP_ZERO,
			   HSD_TE_A, HSD_TEXP_RAS,
			   HSD_TE_0, HSD_TEXP_ZERO);
    }
    alpha = exp;
  }


  /* SPECULAR STAGES */

  if (mobj->rendermode & RENDER_SPECULAR) {
    /*
     * SPECULARňF(mat->specular)𐶐B
     */
    cnst = HSD_TExpCnst(&(mobj->mat->specular), HSD_TE_RGB, HSD_TE_U8, list);
    exp = HSD_TExpTev(list);
    HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_RGB, cnst);

    spec = exp;

    /*
     * SPECULARñeNX`B
     */
    for (tobj = tobj_top; tobj != NULL; tobj = tobj->next) {
      if ((tobj_lightmap(tobj) & TEX_LIGHTMAP_SPECULAR) &&
	  tobj->id != GX_TEXMAP_NULL)
      {
	HSD_TOBJ_METHOD(tobj)->make_texp(tobj, TEX_LIGHTMAP_SPECULAR,
					 done, &spec, &alpha, list);
      }
    }
    done |= TEX_LIGHTMAP_SPECULAR;

    /* \ʐFɁAXyLCg̃X^J[| */

    exp = HSD_TExpTev(list);
    HSD_TExpOrder  (exp, NULL, GX_COLOR1A1);
    HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_RGB, spec,
			 HSD_TE_RGB, HSD_TEXP_RAS,
			 HSD_TE_0, HSD_TEXP_ZERO);
    spec = exp;

    /* Diffuse F Specular F𑫂 */

    exp = HSD_TExpTev(list);
    HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(exp, HSD_TE_RGB, spec,
			 HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_RGB, diff);
    diff = exp;
  }

  ext = diff;

  /* EXT STAGES (Reflection/Hilight) */

  for (tobj = tobj_top; tobj != NULL; tobj = tobj->next) {
    if ((tobj_lightmap(tobj) & TEX_LIGHTMAP_EXT) &&
        tobj->id != GX_TEXMAP_NULL)
    {
      HSD_TOBJ_METHOD(tobj)->make_texp(tobj, TEX_LIGHTMAP_EXT,
				       done, &ext, &alpha, list);
    }
  }

  if (ext != alpha ||
      HSD_TExpGetType(ext) != HSD_TE_TEV ||
      HSD_TExpGetType(alpha) != HSD_TE_TEV)
  {
    exp = HSD_TExpTev(list);
    HSD_TExpColorOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_RGB, ext);
    HSD_TExpAlphaOp(exp, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpAlphaIn(exp, HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_0, HSD_TEXP_ZERO,
			 HSD_TE_A, alpha);
    return exp;
  } else {
    return ext;
  }
}

/**
 * TEVݒRpCB
 * 
 * @warning
 * `ɊւtOύXAeNX`ǉE폜EύXꍇA
 * {֐ɂTEVݒăRpCȂ΂ȂȂB
 * 
 * ύXɍăRpC̕KvrendermodetO͈ȉ̂Ƃ
 * <pre>
 *   o RENDER_DIFFUSE_BITS
 *   o RENDER_ALPHA_BITS
 *   o RENDER_DIFFUSE
 *   o RENDER_SPECULAR
 *   o RENDER_TOON
 * </pre>
 * 
 * @see DObj#HSD_DObjCompileTevAll
 * @see HSD_MObjSetToonTextureImage
 */
void
HSD_MObjCompileTev(HSD_MObj *mobj)
{
  HSD_TObj *tobj, **tail = NULL;
  HSD_TExp *texp;
#if FUJITA
  HSD_TObj **grade_pos = NULL;
  HSD_TObj **backlight_pos = NULL;
#endif

  if (!mobj) return;

  if (mobj->tevdesc) {
    HSD_TExpFreeTevDesc(mobj->tevdesc);
    mobj->tevdesc = NULL;
  }
  if (mobj->texp) {
    HSD_TExpFreeList(mobj->texp, HSD_TE_ALL, 1);
    mobj->texp = NULL;
  }

  tobj = mobj->tobj;
#if FUJITA
  //Gradation
  //ʏ̃eNX`Xe[W̍ŌɃOf[V𑫂B
  if( mobj->tobj_gradation && mobj->tobj_gradation->imagedesc ){
    for (grade_pos=&tobj; *grade_pos; grade_pos=&(*grade_pos)->next) {}
    *grade_pos = mobj->tobj_gradation;
  }
#endif
#if FUJITA
  //BackLight
  //ԍŌBƎvǁB
  if( mobj->tobj_backlight && mobj->tobj_backlight->imagedesc ){
    for (backlight_pos=&tobj; *backlight_pos; backlight_pos=&(*backlight_pos)->next) {}
    *backlight_pos = mobj->tobj_backlight;
  }
#endif
  if ((mobj->rendermode & RENDER_SHADOW) && tobj_shadows) {
    for (tail=&tobj; *tail; tail=&(*tail)->next) {}
    *tail = tobj_shadows;
  }
#if !FUJITA
  if ((mobj->rendermode & RENDER_TOON) && tobj_toon && tobj_toon->imagedesc) {
    tobj_toon->next = tobj;
    tobj = tobj_toon;
  }
#else
  //Toon
  if ((mobj->rendermode & RENDER_TOON) && mobj->tobj_toon && mobj->tobj_toon->imagedesc) {
    mobj->tobj_toon->next = tobj;
    tobj = mobj->tobj_toon;
  }
#endif

  HSD_TObjAssignResources(tobj);
  texp = HSD_MOBJ_METHOD(mobj)->make_texp(mobj, tobj, &mobj->texp);
  HSD_TExpCompile(texp, &mobj->tevdesc, &mobj->texp);

  /* shadow texture AĂ؂藣 */
  if (tail) {
    *tail = NULL;
  }
#if FUJITA
  if(grade_pos){
	*grade_pos = NULL;
  }
  if(backlight_pos){
	*backlight_pos = NULL;
  }
#endif
}

/*
 * TEVXe[Wݒ
 */
static void
MObjSetupTev(HSD_MObj *mobj, HSD_TObj *tobj, u32 rendermode)
{
  assert(mobj->tevdesc);
  HSD_TExpSetupTev(mobj->tevdesc, mobj->texp);

  /* IɒǉeNX`pTevݒ */
  HSD_TObjSetupVolatileTev(tobj, rendermode);
}

/*
 * (J֐)
 * 
 * mobjɂăn[hEFAݒ
 */
void
HSD_MObjSetup(HSD_MObj *mobj, u32 rendermode)
{
  HSD_TObj *tobj, **tail;
#if FUJITA
  HSD_TObj **grade_pos = NULL;
  HSD_TObj **backlight_pos = NULL;
#endif
#ifdef XDEBUG
  HSD_Report("setupMaterial in\n");
#endif
#if FUJITA
  if( rendermode & RENDER_ZOFST ){
	GXSetZScaleOffset( 1.f, mobj->zofst );
  }else{
	//GXSetZScaleOffset( 1.f, 0.f );
  }
#endif
  
  HSD_StateInitTev();
  rendermode = mobj->rendermode;

  HSD_SetMaterialColor(mobj->mat->ambient,
		       mobj->mat->diffuse,
		       mobj->mat->specular,
		       mobj->mat->alpha);
  if (rendermode & RENDER_SPECULAR) {
    HSD_SetMaterialShininess(mobj->mat->shininess);
  }

  tobj = mobj->tobj;
  tail = NULL;

#if FUJITA
  //Gradation
  //ʏ̃eNX`̍ŌɃOf[V𑫂B
  if( mobj->tobj_gradation && mobj->tobj_gradation->imagedesc ){
    for (grade_pos=&tobj; *grade_pos; grade_pos=&(*grade_pos)->next) {}
    *grade_pos = mobj->tobj_gradation;
  }
#endif
#if FUJITA
  //ɌɃobNCgB
  if( mobj->tobj_backlight && mobj->tobj_backlight->imagedesc ){
    for (backlight_pos=&tobj; *backlight_pos; backlight_pos=&(*backlight_pos)->next) {}
    *backlight_pos = mobj->tobj_backlight;
  }
#endif
  if ((rendermode & RENDER_SHADOW) && tobj_shadows) {
    for (tail=&tobj; *tail; tail = &((*tail)->next)) {}
    *tail = tobj_shadows;
  }

#if !FUJITA
  if (rendermode & RENDER_TOON && tobj_toon && tobj_toon->imagedesc != NULL) {
    tobj_toon->next = tobj;
    tobj = tobj_toon;
  }
#else
  //Toon
  if (rendermode & RENDER_TOON && mobj->tobj_toon && mobj->tobj_toon->imagedesc != NULL) {
    mobj->tobj_toon->next = tobj;
    tobj = mobj->tobj_toon;
  }
#endif
  
  /* eNX`[hE}gNXݒ */
  HSD_TObjSetup(tobj);
  /* TexGen ݒ */
  HSD_TObjSetupTextureCoordGen(tobj);

#if HSD_DISP_METHOD_LEVEL > 2
  MObjSetupTev(mobj, tobj, rendermode);
#else
  HSD_MOBJ_METHOD(mobj)->setup_tev(mobj, tobj, rendermode);
#endif

  /* TEV xݒ肳Ėꍇ TEV ݒ肨сA
     NumTexGen, Channel, PE ݒ */
  HSD_SetupRenderModeWithCustomPE(rendermode, mobj->pe);

  /* shadow texture AĂ؂藣 */
  if (tail) {
    *tail = NULL;
  }
#if FUJITA
  if (grade_pos) {
    *grade_pos = NULL;
  }
  if (backlight_pos) {
    *backlight_pos = NULL;
  }
#endif
#ifdef XDEBUG
  HSD_Report("setupMaterial out\n");
#endif
}

/*
 * (J֐)
 *
 * HSD_MObjSetupɑΉn֐
 */
void
HSD_MObjUnset(HSD_MObj *mobj, u32 rendermode)
{
#pragma unused(mobj)
#pragma unused(rendermode)

  HSD_TObjSetup(NULL);
}

/**
 * Toon VF[hp̃eNX`C[Wݒ
 * 
 *  toonimage NULLw肵ꍇAToon VF[fBO
 * B
 * 
 * @warning
 * eNX`C[W߂Đݒ肵ꍇA܂͖ꍇɂ
 * mobjTEVݒăRpCȂ΂ȂȂB
 * 
 * @see HSD_MObjCompileTev
 */
void
HSD_MObjSetToonTextureImage(HSD_ImageDesc *toonimage)
{
  if (!tobj_toon) {
    static HSD_TObjDesc desc = {
      NULL,
      NULL,
      GX_TEXMAP7,
      GX_TG_COLOR0,
      { 0.0F, 0.0F, 0.0F },
      { 0.0F, 0.0F, 0.0F },  
      { 0.0F, 0.0F, 0.0F },  
      GX_CLAMP,
      GX_CLAMP,
      0,
      0,
      TEX_COORD_TOON,
      1.0F,
      GX_LINEAR,
      NULL,
      NULL,
      NULL
    };
    tobj_toon = HSD_TObjLoadDesc(&desc);
    assert2(tobj_toon, ("cannot allocate tobj for toon."));
  }
  tobj_toon->imagedesc = toonimage;
}

/**
 * ToonVF[hpTObj̎擾
 * 
 * @return
 * toon p tobj ւ̃|C^B
 * toon eNX`C[Wo^ĂȂꍇNULLԂB
 * 
 * @see HSD_MObjSetToonTextureImage
 */
HSD_TObj *
HSD_MObjGetToonTexture(void)
{
  if (tobj_toon && tobj_toon->imagedesc) {
    return tobj_toon;
  } else {
    return NULL;
  }
}


/**
 * mboj  ambient color ݒ肷B
 */
void
HSD_MObjSetAmbientColor(HSD_MObj *mobj, u8 r, u8 g, u8 b)
{
#if 0
  assert(mobj->rendermode&(RENDER_DIFFUSE|RENDER_SPECULAR));
#endif
  if (!mobj || !mobj->mat) {
    return;
  }
  mobj->mat->ambient.r = r;
  mobj->mat->ambient.g = g;
  mobj->mat->ambient.b = b;
}

/**
 * mboj  diffuse color ݒ肷B
 */
void
HSD_MObjSetDiffuseColor(HSD_MObj *mobj, u8 r, u8 g, u8 b)
{
#if 0
  assert(mobj->rendermode&RENDER_DIFFUSE);
#endif
  if (!mobj || !mobj->mat) {
    return;
  }
  mobj->mat->diffuse.r = r;
  mobj->mat->diffuse.g = g;
  mobj->mat->diffuse.b = b;
}

/**
 * mboj  specular color ݒ肷B
 */
void
HSD_MObjSetSpecularColor(HSD_MObj *mobj, u8 r, u8 g, u8 b)
{
#if 0
  assert(mobj->rendermode&RENDER_SPECULAR);
#endif
  if (!mobj || !mobj->mat) {
    return;
  }
  mobj->mat->specular.r = r;
  mobj->mat->specular.g = g;
  mobj->mat->specular.b = b;
}

/**
 * mboj  alpha lݒ肷B
 */
void
HSD_MObjSetAlpha(HSD_MObj *mobj, float alpha)
{
#if 0
  assert(mobj->rendermode&(RENDER_DIFFUSE|RENDER_SPECULAR));
#endif
  if (!mobj || !mobj->mat) {
    return;
  }
  mobj->mat->alpha = alpha;
}

/**
 * mobj  shininess lݒ肷B
 */
void
HSD_MObjSetShininess(HSD_MObj *mobj, float shininess)
{
  if (!mobj || !mobj->mat) {
    return;
  }
  mobj->mat->shininess = shininess;
}

/**
 * mobj  tobj 擾B
 */
HSD_TObj *
HSD_MObjGetTObj(HSD_MObj *mobj)
{
  if (mobj == NULL)
    return NULL;

  return mobj->tobj;
}

/**
 * mobj  tobj AB
 */
void
HSD_MObjAddTObj(HSD_MObj *mobj, HSD_TObj *tobj)
{
  if (mobj == NULL || tobj == NULL)
    return;

  tobj->next = mobj->tobj;
  mobj->tobj = tobj;
}

/**
 * tobj  prev  new AB
 */
void
HSD_MObjAddTObjPrev(HSD_MObj *mobj, HSD_TObj *tobj, HSD_TObj *new)
{
  HSD_TObj **tpp;

  if (mobj == NULL || tobj == NULL || new == NULL)
    return;

  for (tpp = &mobj->tobj; *tpp; tpp = &((*tpp)->next)) {
    if (*tpp == tobj) {
      new->next = tobj;
      *tpp = new;
      return;
    }
  }
  assert(0);
}

/**
 * tobj  next  new AB
 */
void
HSD_MObjAddTObjNext(HSD_MObj *mobj, HSD_TObj *tobj, HSD_TObj *new)
{
  if (mobj == NULL || tobj == NULL || new == NULL)
    return;

  HSD_TObjAddNext(tobj, new);
}

/**
 * mobj Ƃ̉̍\̂폜B
 */
void
HSD_MObjRemove(HSD_MObj *mobj)
{
  hsdDelete(mobj);
}

/**
 * mobj P쐬B
 *
 * @see HSD_MObjRemove
 * @see HSD_MObjLoadDesc
 */
HSD_MObj *
HSD_MObjAlloc(void)
{
  HSD_MObj *mobj = hsdNew(HSD_MObjGetDefaultClass());
  assert(mobj);
  return mobj;
}

/**
 * mobj jB
 *
 * @warning
 * {֐̓o̊J͍lȂB
 * ʏ̍폜ɂHSD_MObjRemovegp邱ƁB
 *
 * @see HSD_MObjRemove
 * @see HSD_MObjAlloc
 */
void
HSD_MObjFree(HSD_MObj *mobj)
{
  if (mobj)
    HSD_CLASS_METHOD(mobj)->destroy(HSD_CLASS(mobj));
}

/**
 * material \̂쐬B
 */
HSD_Material *
HSD_MaterialAlloc(void)
{
  HSD_Material *mat = hsdAllocMemPiece(sizeof(HSD_Material));
  assert(mat);
  memset(mat, 0, sizeof(HSD_Material));
  mat->alpha = 1.0F;
  return mat;
}

/**
 * material \̂pB
 * 
 * @warning
 * {֐͍\̂̃olȂBʏ̍폜ɂHSD_MaterialRemove
 * gp邱ƁB
 *
 * @see HSD_MaterialRemove
 */
void
HSD_MaterialFree(HSD_Material *mat)
{
  hsdFreeMemPiece(mat, sizeof(HSD_Material));
}

/**
 * material \̂폜B
 * 
 * @see HSD_MaterialFree
 */
void
HSD_MaterialRemove(HSD_Material *mat)
{
  HSD_MaterialFree(mat);
}

/**
 * Shadow projeciton p TObj o^B
 * 
 * tobj ̓O[oȃXgɓo^Amobj  rendermode 
 * RENDER_SHADOW rbgĂꍇɓKpB
 *
 * @see Shadow#HSD_ShadowAlloc
 * @see HSD_MObjDeleteShadowTexture
 * @see HSD_MObjGetShadowTexture
 */
void
HSD_MObjAddShadowTexture(HSD_TObj *tobj)
{
  HSD_TObj *tp;

  assert(tobj);

  for (tp=tobj_shadows; tp; tp=tp->next) {
    if (tp == tobj) return;
  }

  tobj->next = tobj_shadows;
  tobj_shadows = tobj;
}

/**
 * Shadow projection p TObj ̃Xg擾B
 * 
 * @return
 * shadow projection p tobj Xg̃gbv
 * 
 * @see HSD_MObjAddShadowTexture
 * @see HSD_MObjDeleteShadowTexture
 */
HSD_TObj *
HSD_MObjGetShadowTexture(void)
{
  return tobj_shadows;
}

/**
 * Shadow texture projection p̃Xgw肳ꂽ tobj 菜B
 * 
 * tobj == NULL ̏ꍇAׂĂ̓o^ꂽ TObj Xg菜B
 * 
 * tobj != NULL ̏ꍇ́Aw肵 tobj ݂̂菜B
 * 
 * @see HSD_MObjAddShadowTexture
 * @see HSD_MObjGetShadowTexture
 * @see Shadow#HSD_ShadowAlloc
 */
void
HSD_MObjDeleteShadowTexture(HSD_TObj *tobj)
{
  HSD_TObj **tp, *next;

  if (tobj) {
    for (tp = &tobj_shadows; *tp; tp = &(*tp)->next) {
      if (*tp == tobj) {
	*tp = tobj->next;
	tobj->next = NULL;
	return;
      }
    }
  } else {
    for (; tobj_shadows; tobj_shadows=next) {
      next = tobj_shadows->next;
      tobj_shadows->next = NULL;
    }
  }
}

static void
MObjRelease(HSD_Class *o)
{
  HSD_MObj *mobj = HSD_MOBJ(o);

  HSD_AObjRemove(mobj->aobj);
  HSD_MaterialRemove(mobj->mat);
  HSD_TObjRemoveAll(mobj->tobj);

  if (mobj->tevdesc)
    HSD_TExpFreeTevDesc(mobj->tevdesc);
  if (mobj->texp)
    HSD_TExpFreeList(mobj->texp, HSD_TE_ALL, 1);
  if (mobj->pe)
    hsdFreeMemPiece(mobj->pe, sizeof(HSD_PEDesc));

#if FUJITA
  if( mobj->tobj_toon ) HSD_TObjRemove( mobj->tobj_toon );
  if( mobj->tobj_gradation ) HSD_TObjRemove( mobj->tobj_gradation );
  if( mobj->tobj_backlight ) HSD_TObjRemove( mobj->tobj_backlight );
#endif

  HSD_PARENT_INFO(&hsdMObj)->release(o);
}

static void
MObjAmnesia(HSD_ClassInfo *info)
{
  if (info == HSD_CLASS_INFO(default_class)) {
    default_class = NULL;
  }
  if (info == HSD_CLASS_INFO(&hsdMObj)) {
    tobj_toon = NULL;
    tobj_shadows = NULL;
  }
  HSD_PARENT_INFO(&hsdMObj)->amnesia(info);
}

static void
MObjInfoInit(void)
{
  hsdInitClassInfo(HSD_CLASS_INFO(&hsdMObj),
  		   HSD_CLASS_INFO(&hsdClass),
		   HSD_BASE_CLASS_LIBRARY,
		   "hsd_mobj",
		   sizeof(HSD_MObjInfo),
		   sizeof(HSD_MObj));
  
  HSD_CLASS_INFO(&hsdMObj)->release  = MObjRelease;
  HSD_CLASS_INFO(&hsdMObj)->amnesia  = MObjAmnesia;
  HSD_MOBJ_INFO(&hsdMObj)->setup     = HSD_MObjSetup;
  HSD_MOBJ_INFO(&hsdMObj)->unset     = HSD_MObjUnset;
  HSD_MOBJ_INFO(&hsdMObj)->load      = MObjLoad;
  HSD_MOBJ_INFO(&hsdMObj)->make_texp = MObjMakeTExp;
  HSD_MOBJ_INFO(&hsdMObj)->setup_tev = MObjSetupTev;
  HSD_MOBJ_INFO(&hsdMObj)->update    = MObjUpdateFunc;
}
