////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage Object
//
// WK7Stage.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7STAGE_CPP__

//#include <dolphin.h>
#include ".\WK7Stage.h"
#include ".\WK7Define.h"
#include ".\K7ID.h"
#include ".\WK7Event.h"
#include ".\WK7MainTask.h"
#include ".\WK7Shadow.h"
#include ".\WK7Enemy.h"
#include ".\WK7Path.h"
#include ".\WK7MainMenu.h"
#include ".\WK7HitObj.h"
#include ".\WK7Npc.h"
#include ".\WK7Play.h"
#include ".\WK7SceneBlur.h"
#include ".\WK7Item.h"
#include ".\WK7Sight.h"
#include "..\Fujita\C_Font.h"
#include "..\Yam\YK7CharChange.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Stage\K7Stage121M00.h"
#include "..\Yam\YK7EffectNoiseOut.h"
#include "..\Yam\YK7EffectMessage2.h"
#include "..\Yam\YK7EffectItemGet.h"
#include "..\Matsu\MK7CharaDisp.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Matsu\MK7Noise.h"
#include "..\Matsu\MK7EngTelop.h"
#include "..\Matsu\MK7Movie.h"
#include ".\WK7DeadBodySign.h"
#include "..\Fujita\c_trigon.h"
#include "..\Fujita\c_coll.h"
#include "..\Fujita\c_border.h"
#include "..\Fujita\c_setalpha.h"
#include ".\WK7HitObj.h"
#include "..\Wat\WK7Zan.h"
#include ".\WK7EventScript.h"
#include ".\WK7EventItem.h"
#include "..\Yam\YK7EffectHSDead.h"
#include ".\WK7SelectIF.h"
#include ".\WK7Fog.h"
#include "..\Scn\K7Scn04.h"
#include "..\Stage\K7Stage578M00.h"
#include "..\Yam\YK7EffectLensFlare.h"

#define MAX_STAGE_ENEMY		(6)

WK7Stage*                WK7Stage::mpCurrentStage         = NULL;
u32                      WK7Stage::mCurrentStageID        = 0xffffffff;
u32                      WK7Stage::mCurrentStageParam     = 0xffffffff;
char*                    WK7Stage::mpCurrentStageBpName   = NULL;
u32                      WK7Stage::mPrevStageID           = 0xffffffff;
char*                    WK7Stage::mpPrevStagePathName    = NULL;
char*                    WK7Stage::mpPrevStageBpName      = NULL;
//f32                      WK7Stage::mPrevStagePathParam  = 0.0f;
//u32                      WK7Stage::mPrevStagePathDir    = 0;
bool                     WK7Stage::mChangingStage         = false;
bool                     WK7Stage::mRenderStage           = true;
bool                     WK7Stage::mManualBranch          = false;
bool                     WK7Stage::mMoveModeCancel        = false; 
//u32                      WK7Stage::mChangeChara           = 0xffffffff;
u32                      WK7Stage::mGetKeyMesID           = 0xffffffff;
u32                      WK7Stage::mHarmanRoomFlag[WK7STAGE_HARMANROOM_FLAG_WORK_SIZE] = { 0, };
u32                      WK7Stage::mHarmanTvFlag  [WK7STAGE_HARMANTV_FLAG_WORK_SIZE  ] = { 0, };
u32                      WK7Stage::mPassPathFlag  [WK7STAGE_PASSPATH_FLAG_WORK_SIZE  ] = { 0, };
u32                      WK7Stage::mSelectObjFlag [WK7STAGE_SELECTOBJ_FLAG_WORK_SIZE ] = { 0, };
u32                      WK7Stage::mMapFlag       [WK7STAGE_MAP_FLAG_WORK_SIZE       ] = { 0, };
WK7StageCreateStageFunc* WK7Stage::mpCreateStageFunc      = NULL;
ghmGcViewVolume          WK7Stage::mViewVolume;
WK7StageBpCamInfo*       WK7Stage::mpScenarioBpCamInfo    = NULL;
WK7StagePlaceInfo*       WK7Stage::mpScenarioPlaceInfo    = NULL;
WK7StageDoorInfo*        WK7Stage::mpScenarioDoorInfo     = NULL;
WK7StageTamaInfo*        WK7Stage::mpScenarioTamaInfo     = NULL;
WK7StageSoundInfo*       WK7Stage::mpScenarioSoundInfo    = NULL;
WK7StageSpCond*          WK7Stage::mpScenarioSpCond       = NULL;

#define	WK7STAGE_PADREPEAT		(HSD_PadGetRepeat (0)|HSD_PadGetRepeat (1))
#define	WK7STAGE_PADTRIGGER		(HSD_PadGetTrigger(0)|HSD_PadGetTrigger(1))
#define	WK7STAGE_PADBUTTON		(HSD_PadGetButton (0)|HSD_PadGetButton (1))

//bool WK7Stage::ClearChangeChara(void)
//{
//	mChangeChara = 0xffffffff;
////	SetChangeChara(K7GAL,false);
//	BattleCtrl.PcSelOKSet  (K7HAC, 0);
//	SetChangeChara(K7HAC,false);
//	return true;
//}

//bool WK7Stage::SetChangeChara(u32 chrid,bool flag)
//{
//	switch( chrid ){
//	case	K7DAN:
//	case	K7GAL:
//	case	K7CON:
//	case	K7HAC:
//	case	K7HAS:
//	case	K7HAY:
//	case	K7CYO:
//	case	K7KED:
//	case	K7KVN:
//	case	K7MSK:
//		break;
//	default:
//		return false;
//	}
//	if( flag==true ){
//		mChangeChara |=  (1<<chrid);
//	}else{
//		mChangeChara &= ~(1<<chrid);
//	}
//	return true;
//}

bool WK7StageBpEventBase::SetBpName(const char *pBpName)
{
	GHM_SAFE_DELETE_ARRAY(mpBpName);
	if( pBpName==NULL ){
		return true;
	}
	ghmGcMemSetAllocName("BpName");
	if( (mpBpName = new char[strlen(pBpName) + 1])==NULL ){
		return false;
	}
	strcpy(mpBpName,pBpName);
	return true;
}

WK7StageBpEventJumpNextStage::WK7StageBpEventJumpNextStage(WK7StageBpEventJumpNextStage *pPrev)
{
	mpNext = NULL;
	if( (mpPrev = pPrev)!=NULL ){
		pPrev->mpNext = this;
	}
	mpBpName = NULL;
	mStageID = 0xffffffff;
}

WK7StageBpEventJumpNextStage::~WK7StageBpEventJumpNextStage()
{
	GHM_SAFE_DELETE(mpBpName);
	GHM_SAFE_DELETE(mpNext);
	if( mpPrev!=NULL ){
		mpPrev->mpNext = NULL;
	}
}

WK7StageBpEventJump::WK7StageBpEventJump()
{
	mpStage = NULL;
}

WK7StageBpEventJump::~WK7StageBpEventJump()
{
	GHM_SAFE_DELETE(mpStage);
}

const char* WK7StageBpEventJump::ParseBpName(const char *pBpName)
{
	return pBpName;
}

WK7StageBpEventPlay::WK7StageBpEventPlay(WK7StageBpEventPlay *pPrev)
{
	mEventNo        = 0xffffffff;
	mpBpName        = NULL;
	mpSelectObjName = NULL;
	mpNext = NULL;
	if( (mpPrev = pPrev)!=NULL ){
		pPrev->mpNext = this;
	}
}

WK7StageBpEventPlay::~WK7StageBpEventPlay()
{
	GHM_SAFE_DELETE_ARRAY(mpBpName       );
	GHM_SAFE_DELETE_ARRAY(mpSelectObjName);
	GHM_SAFE_DELETE(mpNext);
	if( mpPrev!=NULL ){
		mpPrev->mpNext = NULL;
	}
}

bool IsStartedByPrefix(const char *pBpName);
bool IsStartedByPrefix(const char *pBpName)
{
	if( strstr(pBpName,WK7STAGE_STGBPARRIVE_EVPOINT_PREFIX "_")==pBpName ||
	    strstr(pBpName,WK7STAGE_STGBPARRIVE_PLAY_PREFIX    "_")==pBpName ||
	    strstr(pBpName,WK7STAGE_STGBPARRIVE_ZAN_PREFIX     "_")==pBpName ||
	    strstr(pBpName,WK7STAGE_STGBPARRIVE_DOOR_PREFIX    "_")==pBpName ||
	    strstr(pBpName,WK7STAGE_STGBPARRIVE_TAMA_PREFIX    "_")==pBpName ||
	    strstr(pBpName,WK7STAGE_STGBPARRIVE_MAP_PREFIX     "_")==pBpName ||
	    strstr(pBpName,WK7STAGE_STGBPARRIVE_KEY_PREFIX     "_")==pBpName ||
	    strstr(pBpName,WK7STAGE_STGBPARRIVE_MEMO_PREFIX    "_")==pBpName ){
		return true;
	}
	return false;
}

const char* WK7StageBpEventPlay::ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pPlayBpName)
{
	char	*pThisBpName = NULL;
	SetBpName(NULL);
	if( pPlayBpName==NULL ){
		if( (pBpName=GetPartialStr(pThisBpName,pBpName,'_'))==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
		pBpName++;
	}else{
		if( GetPartialStr(pThisBpName,pPlayBpName,'_')==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
	}
	if( pThisBpName==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	// ŴPUi
	char		*pEventNo = NULL;
	int			no;
	pBpName = GetPartialStr(pEventNo,pBpName,'_');
	if( pEventNo==NULL ){
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	switch( sscanf(pEventNo,"%x",&no) ){
	case	EOF:
	case	0:
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	default:
		mEventNo = (u32)((no & K7EV_ID_MASK)|K7EV_TYPE_PLAY);
		break;
	}
	u32			len;
	len = strlen(pThisBpName) + strlen(pEventNo) + 2;
	ghmGcMemSetAllocName("PlBpName");
	if( (mpBpName = new char[len])==NULL ){
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	strcpy(mpBpName,pThisBpName);
	strcat(mpBpName,"_");
	strcat(mpBpName,pEventNo);
	if( pBase!=NULL ){
		pBase->SetBpName(mpBpName);
	}
	GHM_SAFE_DELETE_ARRAY(pThisBpName);
	GHM_SAFE_DELETE_ARRAY(pEventNo);
	if( pBpName==NULL ){
		return NULL;
	}
	switch( *pBpName ){
	case	'\0':
		return NULL;
	case	'_':
		pBpName++;
		break;
	default:
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	if( IsStartedByPrefix(pBpName)==true ){
		return pBpName;
	}
	GHM_SAFE_DELETE_ARRAY(mpSelectObjName);
	if( (pBpName = GetPartialStr(mpSelectObjName,pBpName,'_'))!=NULL ){
		pBpName++;
	}
	return pBpName;
}

WK7StageBpEventPlayPoint::WK7StageBpEventPlayPoint()
{
	mpPlay = NULL;
}

WK7StageBpEventPlayPoint::~WK7StageBpEventPlayPoint()
{
	GHM_SAFE_DELETE(mpPlay);
}

const char* WK7StageBpEventPlayPoint::ParseBpName(const char *pBpName,const char *pPlayBpName)
{
	WK7StageBpEventPlay		*pPrev;
	if( (pPrev = mpPlay)!=NULL ){
		while( pPrev->mpNext!=NULL ){
			pPrev = pPrev->mpNext;
		}
	}
	ghmGcMemSetAllocName("BpPlay");
	WK7StageBpEventPlay		*pNext = new WK7StageBpEventPlay(pPrev);
	if( pNext==NULL ){
		return NULL;
	}
	if( (pBpName = pNext->ParseBpName(pBpName,pPrev==NULL? this:NULL,pPlayBpName))==WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
		delete pNext;
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	if( pPrev==NULL ){
		mpPlay = pNext;
	}
	return pBpName;
}

WK7StageBpEventZan::WK7StageBpEventZan(WK7StageBpEventZan *pPrev)
{
	mEventNo        = 0xffffffff;
	mpBpName        = NULL;
	mpSelectObjName = NULL;
	mpNext = NULL;
	if( (mpPrev = pPrev)!=NULL ){
		pPrev->mpNext = this;
	}
}

WK7StageBpEventZan::~WK7StageBpEventZan()
{
	GHM_SAFE_DELETE_ARRAY(mpBpName       );
	GHM_SAFE_DELETE_ARRAY(mpSelectObjName);
	GHM_SAFE_DELETE(mpNext);
	if( mpPrev!=NULL ){
		mpPrev->mpNext = NULL;
	}
}

const char* WK7StageBpEventZan::ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pZanBpName)
{
	char	*pThisBpName = NULL;
	SetBpName(NULL);
	if( pZanBpName==NULL ){
		if( (pBpName=GetPartialStr(pThisBpName,pBpName,'_'))==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
		pBpName++;
	}else{
		if( GetPartialStr(pThisBpName,pZanBpName,'_')==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
	}
	if( pThisBpName==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	// ŴPUi
	char		*pEventNo = NULL;
	int			no;
	pBpName = GetPartialStr(pEventNo,pBpName,'_');
	if( pEventNo==NULL ){
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	switch( sscanf(pEventNo,"%x",&no) ){
	case	EOF:
	case	0:
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	default:
		mEventNo = (u32)((no & K7EV_ID_MASK)|K7EV_TYPE_ZAN);
		break;
	}
	u32			len;
	len = strlen(pThisBpName) + strlen(pEventNo) + 2;
	ghmGcMemSetAllocName("PlBpName");
	if( (mpBpName = new char[len])==NULL ){
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	strcpy(mpBpName,pThisBpName);
	strcat(mpBpName,"_");
	strcat(mpBpName,pEventNo);
	if( pBase!=NULL ){
		pBase->SetBpName(mpBpName);
	}
	GHM_SAFE_DELETE_ARRAY(pThisBpName);
	GHM_SAFE_DELETE_ARRAY(pEventNo);
	if( pBpName==NULL ){
		return NULL;
	}
	switch( *pBpName ){
	case	'\0':
		return NULL;
	case	'_':
		pBpName++;
		break;
	default:
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	if( IsStartedByPrefix(pBpName)==true ){
		return pBpName;
	}
	GHM_SAFE_DELETE_ARRAY(mpSelectObjName);
	if( (pBpName = GetPartialStr(mpSelectObjName,pBpName,'_'))!=NULL ){
		pBpName++;
	}
	return pBpName;
}

WK7StageBpEventZanPoint::WK7StageBpEventZanPoint()
{
	mpZan = NULL;
}

WK7StageBpEventZanPoint::~WK7StageBpEventZanPoint()
{
	GHM_SAFE_DELETE(mpZan);
}

const char* WK7StageBpEventZanPoint::ParseBpName(const char *pBpName,const char *pZanBpName)
{
	WK7StageBpEventZan		*pPrev;
	if( (pPrev = mpZan)!=NULL ){
		while( pPrev->mpNext!=NULL ){
			pPrev = pPrev->mpNext;
		}
	}
	ghmGcMemSetAllocName("BpZan");
	WK7StageBpEventZan		*pNext = new WK7StageBpEventZan(pPrev);
	if( pNext==NULL ){
		return NULL;
	}
	if( (pBpName = pNext->ParseBpName(pBpName,pPrev==NULL? this:NULL,pZanBpName))==WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
		delete pNext;
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	if( pPrev==NULL ){
		mpZan = pNext;
	}
	return pBpName;
}

WK7StageBpEventBranchNextStage::WK7StageBpEventBranchNextStage(WK7StageBpEventBranchNextStage *pPrev)
{
	mpNext = NULL;
	if( (mpPrev = pPrev)!=NULL ){
		pPrev->mpNext = this;
	}
	mpBpName        = NULL;
	mStageID        = 0xffffffff;
	mpSelectObjName = NULL;
	mParam          = 0;
}

WK7StageBpEventBranchNextStage::~WK7StageBpEventBranchNextStage()
{
	GHM_SAFE_DELETE      (mpNext);
	GHM_SAFE_DELETE_ARRAY(mpBpName);
	GHM_SAFE_DELETE_ARRAY(mpSelectObjName);
	if( mpPrev!=NULL ){
		mpPrev->mpNext = NULL;
	}
}

const char* WK7StageBpEventBranchNextStage::ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pBranchBpName)
{
	GHM_SAFE_DELETE_ARRAY(mpBpName);
	if( pBranchBpName==NULL ){
		if( (pBpName=GetPartialStr(mpBpName,pBpName,'_'))==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
		pBpName++;
	}else{
		if( GetPartialStr(mpBpName,pBranchBpName,'_')==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
	}
	if( pBase!=NULL ){
		pBase->SetBpName(mpBpName);
	}
	GHM_SAFE_DELETE_ARRAY(mpSelectObjName);
	if( (pBpName=GetPartialStr(mpSelectObjName,pBpName,'_'))==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	pBpName++;
	if( (pBpName = WK7Stage::GetStageID(pBpName,mStageID))==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	switch( mStageID ){
	case	WK7STAGE_TVSTAGEID:
	case	WK7STAGE_GMSTAGEID:
		if( pBpName[0] >= '1' && pBpName[0] <= '9' ){
			mParam = (u32)(pBpName[0] - '0');
			pBpName++;
			if( mStageID==WK7STAGE_TVSTAGEID ){
				if( pBpName[0]==WK7STAGE_TVSTAGE_SAVELETTER ){
					mParam |= WK7STAGE_TVSTAGE_SAVEPARAM;
					pBpName++;
				}
			}
		}
		break;
	default:
		break;
	}
	
	switch( *pBpName ){
	case	'\0':
		pBpName = NULL;
		break;
	case	'_':
		pBpName++;
		break;
	default:
		GHM_SAFE_DELETE_ARRAY(mpBpName);
		if( (pBpName=GetPartialStr(mpBpName,pBpName,'_'))!=NULL ){
			pBpName++;
			if( strcmp(mpBpName,WK7STAGE_STGBPARRIVE_EVPOINT_PREFIX )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_PLAY_PREFIX    )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_ZAN_PREFIX     )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_DOOR_PREFIX    )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_TAMA_PREFIX    )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_MAP_PREFIX     )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_KEY_PREFIX     )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_MEMO_PREFIX    )==0 ){
				const char	*pPrevBpName = mpBpName;
				char		*pEvNo;
				if( (pBpName=GetPartialStr(pEvNo,pBpName,'_'))!=NULL ){
					pBpName++;
				}
				u32		len = strlen(pEvNo) + strlen(pPrevBpName) + 2;
				ghmGcMemSetAllocName("BPEVBNB0");
				if( (mpBpName = new char[len])==NULL ){
					GHM_SAFE_DELETE_ARRAY(pEvNo      );
					return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
				}
				strcpy(mpBpName,pPrevBpName);
				strcat(mpBpName,"_");
				strcat(mpBpName,pEvNo);
				GHM_SAFE_DELETE_ARRAY(pEvNo      );
				GHM_SAFE_DELETE_ARRAY(pPrevBpName);
			}else{
				break;
			}
		}
		break;
	}
	switch( mStageID ){
	case	WK7STAGE_TVSTAGEID:
		GHM_SAFE_DELETE_ARRAY(mpBpName);
		ghmGcMemSetAllocName("BPEVBNB1");
		if( (mpBpName = new char[strlen(WK7STAGE_TVSTAGE_BPNAME) + 1])!=NULL ){
			strcpy(mpBpName,WK7STAGE_TVSTAGE_BPNAME);
		}
		break;
	case	WK7STAGE_GMSTAGEID:
		switch( mParam ){
		case	1:
		case	2:
		case	3:
			K7Stage578M00_PointInfo		*pPointInfo = K7Stage578M00::GetKihanShortCut(GameInfo.GetScenarioFlow(),(int)mParam);
			GHM_SAFE_DELETE_ARRAY(mpBpName);
			ghmGcMemSetAllocName("BPEVBNB2");
			if( pPointInfo!=NULL ){
				if( (mpBpName = new char[strlen(pPointInfo->mpBpName) + 1])!=NULL ){
					strcpy(mpBpName,pPointInfo->mpBpName);
					mStageID = pPointInfo->mStageID;
				}
			}else{
				if( (mpBpName = new char[strlen(WK7STAGE_GMSTAGE_BPNAME(0)) + 1])!=NULL ){
					sprintf(mpBpName,WK7STAGE_GMSTAGE_BPNAME_BASE "%d",mParam % 10);
				}
			}
			break;
		default:
//			if( strstr(mpBpName,WK7STAGE_GMSTAGE_BPNAME_BASE)==mpBpName ){
//				const char	*pParam = mpBpName + strlen(WK7STAGE_GMSTAGE_BPNAME_BASE);
//				if( *pParam >= '1' && *pParam <= '9' ){
//					mParam = (u32)(*pParam - '0');
//				}
//			}
			break;
		}
		break;
	default:
		break;
	}
	return pBpName;
}

WK7StageBpEventBranch::WK7StageBpEventBranch()
{
	mpStage = NULL;
}

WK7StageBpEventBranch::~WK7StageBpEventBranch()
{
	GHM_SAFE_DELETE(mpStage);
}

const char* WK7StageBpEventBranch::ParseBpName(const char *pBpName,const char *pBranchBpName)
{
	WK7StageBpEventBranchNextStage	*pPrev;
	if( (pPrev = mpStage)!=NULL ){
		while( pPrev->mpNext!=NULL ){
			pPrev = pPrev->mpNext;
		}
	}
	ghmGcMemSetAllocName("BpNStage");
	WK7StageBpEventBranchNextStage	*pNext = new WK7StageBpEventBranchNextStage(pPrev);
	if( pNext==NULL ){
		return NULL;
	}
	if( (pBpName = pNext->ParseBpName(pBpName,pPrev==NULL? this:NULL,pBranchBpName))==WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
		delete pNext;
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	if( pPrev==NULL ){
		mpStage = pNext;
	}
	return pBpName;
}

WK7StageBpEventDoorNextStage::WK7StageBpEventDoorNextStage(WK7StageBpEventDoorNextStage *pPrev)
{
	mpNext = NULL;
	if( (mpPrev = pPrev)!=NULL ){
		pPrev->mpNext = this;
	}
	mpBpName        = NULL;
	mStageID        = 0xffffffff;
	mpSelectObjName = NULL;
	mParam          = 0;
}

WK7StageBpEventDoorNextStage::~WK7StageBpEventDoorNextStage()
{
	GHM_SAFE_DELETE      (mpNext);
	GHM_SAFE_DELETE_ARRAY(mpBpName);
	GHM_SAFE_DELETE_ARRAY(mpSelectObjName);
	if( mpPrev!=NULL ){
		mpPrev->mpNext = NULL;
	}
}

const char* WK7StageBpEventDoorNextStage::ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pDoorBpName)
{
	char	*pThisBpName = NULL;
	if( pDoorBpName==NULL ){
		if( (pBpName=GetPartialStr(pThisBpName,pBpName,'_'))==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
		pBpName++;
	}else{
		if( GetPartialStr(pThisBpName,pDoorBpName,'_')==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
	}
	if( pThisBpName==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	// ÛPUi
	char		*pEventNo = NULL;
	int			no;
	if( (pBpName=GetPartialStr(pEventNo,pBpName,'_'))==NULL || pEventNo==NULL ){
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	switch( sscanf(pEventNo,"%x",&no) ){
	case	EOF:
	case	0:
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	default:
		mEventNo = (u32)(no | K7EV_TYPE_DOOR);
		break;
	}
	u32			len;
	len = strlen(pThisBpName) + strlen(pEventNo) + 2;
	ghmGcMemSetAllocName("BPEVBND0");
	GHM_SAFE_DELETE_ARRAY(mpBpName);
	if( (mpBpName = new char[len])==NULL ){
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	strcpy(mpBpName,pThisBpName);
	strcat(mpBpName,"_");
	strcat(mpBpName,pEventNo);
	if( pBase!=NULL ){
		pBase->SetBpName(mpBpName);
	}
	pBpName++;
	GHM_SAFE_DELETE_ARRAY(mpSelectObjName);
	if( (pBpName=GetPartialStr(mpSelectObjName,pBpName,'_'))==NULL ){
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	pBpName++;
	if( (pBpName = WK7Stage::GetStageID(pBpName,mStageID))==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	switch( mStageID ){
	case	WK7STAGE_TVSTAGEID:
	case	WK7STAGE_GMSTAGEID:
		if( pBpName[0] >= '1' && pBpName[0] <= '9' ){
			mParam = (u32)(pBpName[0] - '0');
			pBpName++;
			if( mStageID==WK7STAGE_TVSTAGEID ){
				if( pBpName[0]==WK7STAGE_TVSTAGE_SAVELETTER ){
					mParam |= WK7STAGE_TVSTAGE_SAVEPARAM;
					pBpName++;
				}
			}
		}
		break;
	default:
		break;
	}
	
	switch( *pBpName ){
	case	'\0':
		pBpName = NULL;
		break;
	case	'_':
		pBpName++;
		break;
	default:
		GHM_SAFE_DELETE_ARRAY(mpBpName);
		if( (pBpName=GetPartialStr(mpBpName,pBpName,'_'))!=NULL ){
			pBpName++;
			if( strcmp(mpBpName,WK7STAGE_STGBPARRIVE_EVPOINT_PREFIX )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_PLAY_PREFIX    )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_ZAN_PREFIX     )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_DOOR_PREFIX    )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_TAMA_PREFIX    )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_MAP_PREFIX     )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_KEY_PREFIX     )==0 ||
			    strcmp(mpBpName,WK7STAGE_STGBPARRIVE_MEMO_PREFIX    )==0 ){
				const char	*pPrevBpName = mpBpName;
				char		*pEvNo;
				if( (pBpName=GetPartialStr(pEvNo,pBpName,'_'))!=NULL ){
					pBpName++;
				}
				u32		len = strlen(pEvNo) + strlen(pPrevBpName) + 2;
				ghmGcMemSetAllocName("BPEVBND1");
				if( (mpBpName = new char[len])==NULL ){
					GHM_SAFE_DELETE_ARRAY(pEvNo      );
					return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
				}
				strcpy(mpBpName,pPrevBpName);
				strcat(mpBpName,"_");
				strcat(mpBpName,pEvNo);
				GHM_SAFE_DELETE_ARRAY(pEvNo      );
				GHM_SAFE_DELETE_ARRAY(pPrevBpName);
			}else{
				break;
			}
		}
		break;
	}
	switch( mStageID ){
	case	WK7STAGE_TVSTAGEID:
		GHM_SAFE_DELETE_ARRAY(mpBpName);
		ghmGcMemSetAllocName("BPEVBND2");
		if( (mpBpName = new char[strlen(WK7STAGE_TVSTAGE_BPNAME) + 1])!=NULL ){
			strcpy(mpBpName,WK7STAGE_TVSTAGE_BPNAME);
		}
		break;
	case	WK7STAGE_GMSTAGEID:
		switch( mParam ){
		case	1:
		case	2:
		case	3:
			GHM_SAFE_DELETE_ARRAY(mpBpName);
			ghmGcMemSetAllocName("BPEVBND3");
			K7Stage578M00_PointInfo		*pPointInfo = K7Stage578M00::GetKihanShortCut(GameInfo.GetScenarioFlow(),(int)mParam);
			if( pPointInfo!=NULL ){
				if( (mpBpName = new char[strlen(pPointInfo->mpBpName) + 1])!=NULL ){
					strcpy(mpBpName,pPointInfo->mpBpName);
					mStageID = pPointInfo->mStageID;
				}
			}else{
				if( (mpBpName = new char[strlen(WK7STAGE_GMSTAGE_BPNAME(0)) + 1])!=NULL ){
					sprintf(mpBpName,WK7STAGE_GMSTAGE_BPNAME_BASE "%d",mParam % 10);
				}
			}
			break;
		default:
//			if( strstr(mpBpName,WK7STAGE_GMSTAGE_BPNAME_BASE)==mpBpName ){
//				const char	*pParam = mpBpName + strlen(WK7STAGE_GMSTAGE_BPNAME_BASE);
//				if( *pParam >= '1' && *pParam <= '9' ){
//					mParam = (u32)(*pParam - '0');
//				}
//			}
			break;
		}
		break;
	default:
		break;
	}
	GHM_SAFE_DELETE_ARRAY(pThisBpName);
	GHM_SAFE_DELETE_ARRAY(pEventNo);
	return pBpName;
}

WK7StageBpEventDoor::WK7StageBpEventDoor()
{
	mpStage = NULL;
}

WK7StageBpEventDoor::~WK7StageBpEventDoor()
{
	GHM_SAFE_DELETE(mpStage);
}

const char* WK7StageBpEventDoor::ParseBpName(const char *pBpName,const char *pDoorBpName)
{
	WK7StageBpEventDoorNextStage	*pPrev;
	if( (pPrev = mpStage)!=NULL ){
		while( pPrev->mpNext!=NULL ){
			pPrev = pPrev->mpNext;
		}
	}
	ghmGcMemSetAllocName("BpDNStg");
	WK7StageBpEventDoorNextStage	*pNext = new WK7StageBpEventDoorNextStage(pPrev);
	if( pNext==NULL ){
		return NULL;
	}
	if( (pBpName = pNext->ParseBpName(pBpName,pPrev==NULL? this:NULL,pDoorBpName))==WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
		delete pNext;
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	if( pPrev==NULL ){
		mpStage = pNext;
	}
	return pBpName;
}

WK7StageBpEventTv::WK7StageBpEventTv()
{
	mpSelectObjName = NULL;
	mpScreenObjName = NULL;
}

WK7StageBpEventTv::~WK7StageBpEventTv()
{
	GHM_SAFE_DELETE(mpSelectObjName);
	GHM_SAFE_DELETE(mpScreenObjName);
}

const char* WK7StageBpEventTv::ParseBpName(const char *pBpName)
{
	SetBpName(NULL);
	if( (pBpName = GetPartialStr(mpBpName,pBpName,'_'))==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	pBpName++;
	GHM_SAFE_DELETE(mpSelectObjName);
	if( (pBpName=GetPartialStr(mpSelectObjName,pBpName,'_'))==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	pBpName++;
	GHM_SAFE_DELETE(mpScreenObjName);
	if( (pBpName=GetPartialStr(mpScreenObjName,pBpName,'_'))!=NULL ){
		pBpName++;
	}
	return pBpName;
}

WK7StageBpEventLtv::WK7StageBpEventLtv()
{
	mpSelectObjName = NULL;
	mpScreenObjName = NULL;
}

WK7StageBpEventLtv::~WK7StageBpEventLtv()
{
	GHM_SAFE_DELETE(mpSelectObjName);
	GHM_SAFE_DELETE(mpScreenObjName);
}

const char* WK7StageBpEventLtv::ParseBpName(const char *pBpName)
{
	SetBpName(NULL);
	if( (pBpName = GetPartialStr(mpBpName,pBpName,'_'))==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	pBpName++;
	GHM_SAFE_DELETE(mpSelectObjName);
	if( (pBpName=GetPartialStr(mpSelectObjName,pBpName,'_'))==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	pBpName++;
	GHM_SAFE_DELETE(mpScreenObjName);
	if( (pBpName=GetPartialStr(mpScreenObjName,pBpName,'_'))!=NULL ){
		pBpName++;
	}
	return pBpName;
}

WK7StageBpEventPointObj::WK7StageBpEventPointObj(WK7StageBpEventPointObj *pPrev)
{
	mpNext = NULL;
	if( (mpPrev = pPrev)!=NULL ){
		pPrev->mpNext = this;
	}
	mpBpName        = NULL;
	mEventNo        = 0xffffffff;
	mpSelectObjName = NULL;
}

WK7StageBpEventPointObj::~WK7StageBpEventPointObj()
{
	GHM_SAFE_DELETE_ARRAY(mpBpName);
	GHM_SAFE_DELETE_ARRAY(mpSelectObjName);
	GHM_SAFE_DELETE      (mpNext);
	if( mpPrev!=NULL ){
		mpPrev->mpNext = NULL;
	}
}

const char* WK7StageBpEventPointObj::ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pBranchBpName)
{
	char	*pThisBpName = NULL;
	if( pBranchBpName==NULL ){
		if( (pBpName=GetPartialStr(pThisBpName,pBpName,'_'))==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
		pBpName++;
	}else{
		if( GetPartialStr(pThisBpName,pBranchBpName,'_')==NULL ){
			return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
		}
	}
	if( pThisBpName==NULL ){
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	// ÛPUi
	char		*pEventNo = NULL;
	int			no;
	if( (pBpName=GetPartialStr(pEventNo,pBpName,'_'))==NULL || pEventNo==NULL ){
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	switch( sscanf(pEventNo,"%x",&no) ){
	case	EOF:
	case	0:
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	default:
		mEventNo = (u32)no;
		break;
	}
	u32			len;
	len = strlen(pThisBpName) + strlen(pEventNo) + 2;
	GHM_SAFE_DELETE(mpBpName);
	ghmGcMemSetAllocName("BpName");
	if( (mpBpName = new char[len])==NULL ){
		GHM_SAFE_DELETE_ARRAY(pThisBpName);
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	strcpy(mpBpName,pThisBpName);
	strcat(mpBpName,"_");
	strcat(mpBpName,pEventNo);
	if( pBase!=NULL ){
		pBase->SetBpName(mpBpName);
	}
	GHM_SAFE_DELETE_ARRAY(pThisBpName);
	GHM_SAFE_DELETE_ARRAY(pEventNo);
	if( pBpName==NULL ){
		return NULL;
	}
	switch( *pBpName ){
	case	'\0':
		return NULL;
	case	'_':
		pBpName++;
		break;
	default:
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	if( IsStartedByPrefix(pBpName)==true ){
		return pBpName;
	}
	GHM_SAFE_DELETE(mpSelectObjName);
	if( (pBpName=GetPartialStr(mpSelectObjName,pBpName,'_'))!=NULL ){
		pBpName++;
	}
	return pBpName;
}

WK7StageBpEventPoint::WK7StageBpEventPoint()
{
	mpObj = NULL;
}

WK7StageBpEventPoint::~WK7StageBpEventPoint()
{
	GHM_SAFE_DELETE(mpObj);
}

const char* WK7StageBpEventPoint::ParseBpName(const char *pBpName,const char *pBranchBpName)
{
	WK7StageBpEventPointObj	*pPrev;
	if( (pPrev = mpObj)!=NULL ){
		while( pPrev->mpNext!=NULL ){
			pPrev = pPrev->mpNext;
		}
	}
	ghmGcMemSetAllocName("BpPObj");
	WK7StageBpEventPointObj		*pNext = new WK7StageBpEventPointObj(pPrev);
	if( pNext==NULL ){
		return NULL;
	}
	if( (pBpName = pNext->ParseBpName(pBpName,pPrev==NULL? this:NULL,pBranchBpName))==WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
		delete pNext;
		return WK7STAGEBPARRIVEEVENT_PARSE_ERROR;
	}
	if( pNext->GetSelectObjName()==NULL ){
		delete pNext;
		return pBpName;
	}
	pNext->mEventNo = pNext->mEventNo|GetType();
	if( pPrev==NULL ){
		mpObj = pNext;
	}
	return pBpName;
}

u32 WK7StageBpEventPoint::GetType(void)
{
	return K7EV_TYPE_NO;
}

WK7StageBpEventMap::WK7StageBpEventMap()
{
}

WK7StageBpEventMap::~WK7StageBpEventMap()
{
}

u32 WK7StageBpEventMap::GetType(void)
{
	return K7EV_TYPE_MAP;
}

WK7StageBpEventKey::WK7StageBpEventKey()
{
}

WK7StageBpEventKey::~WK7StageBpEventKey()
{
}

u32 WK7StageBpEventKey::GetType(void)
{
	return K7EV_TYPE_KEY;
}

WK7StageBpEventMemo::WK7StageBpEventMemo()
{
}

WK7StageBpEventMemo::~WK7StageBpEventMemo()
{
}

u32 WK7StageBpEventMemo::GetType(void)
{
	return K7EV_TYPE_MEMO;
}

WK7StageBpEventVoiceMemo::WK7StageBpEventVoiceMemo()
{
}

WK7StageBpEventVoiceMemo::~WK7StageBpEventVoiceMemo()
{
}

u32 WK7StageBpEventVoiceMemo::GetType(void)
{
	return K7EV_TYPE_VMEMO;
}

WK7StageBpEventRaku::WK7StageBpEventRaku()
{
}

WK7StageBpEventRaku::~WK7StageBpEventRaku()
{
}

u32 WK7StageBpEventRaku::GetType(void)
{
	return K7EV_TYPE_RAKU;
}

WK7StageBpEventTama::WK7StageBpEventTama()
{
}

WK7StageBpEventTama::~WK7StageBpEventTama()
{
}

u32 WK7StageBpEventTama::GetType(void)
{
	return K7EV_TYPE_TAMA;
}

WK7StageBpEvent::WK7StageBpEvent(const char *pBpName)
{
	const char	*pPrefix = NULL;
	const char	*pPrevBpName = NULL;
	mpJump      = NULL;
	mpPlayPoint = NULL;
	mpZanPoint  = NULL;
	mpBranch    = NULL;
	mpTv        = NULL;
	mpLtv       = NULL;
	mpPoint     = NULL;
	mpDoor      = NULL;
	mpMap       = NULL;
	mpKey       = NULL;
	mpMemo      = NULL;
	mpVoiceMemo = NULL;
	mpRaku      = NULL;
	mpTama      = NULL;
	mpBpName    = NULL;
	if( pBpName==NULL ){
		return;
	}
	ghmGcMemSetAllocName("BpName");
	if( (mpBpName = new char[strlen(pBpName) + 1])==NULL ){
		return;
	}
	strcpy(mpBpName,pBpName);
	while( pBpName!=NULL && pBpName!='\0' ){
//		if( strstr(pBpName,WK7STAGE_STGBPARRIVE_DEFMOVE_PREFIX)==pBpName ){
//			GHM_SAFE_DELETE(mpJump);
//			if( (mpJump = new WK7StageBpEventJump)==NULL ){
//				break;
//			}
//			if( (pBpName = mpJump->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
//				continue;
//			}
//			pBpName = NULL;
//			GHM_SAFE_DELETE(mpJump);
//		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_DEFPLAY_PREFIX)==pBpName ){
		if( strstr(pBpName,WK7STAGE_STGBPARRIVE_PLAY_PREFIX)==pBpName ){
			ghmGcMemSetAllocName("BPEVPP");
			if( mpPlayPoint==NULL && (mpPlayPoint = new WK7StageBpEventPlayPoint)==NULL ){
				break;
			}
			if( (pBpName = mpPlayPoint->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
			GHM_SAFE_DELETE(mpPlayPoint);
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_ZAN_PREFIX)==pBpName ){
			ghmGcMemSetAllocName("BPEVZP");
			if( mpZanPoint==NULL && (mpZanPoint = new WK7StageBpEventZanPoint)==NULL ){
				break;
			}
			if( (pBpName = mpZanPoint->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
			GHM_SAFE_DELETE(mpZanPoint);
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_DEFMOVE2_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_DEFMOVE2_PREFIX;
			pPrevBpName = pBpName;
			ghmGcMemSetAllocName("BpBranch");
			if( mpBranch==NULL && (mpBranch = new WK7StageBpEventBranch)==NULL ){
				break;
			}
			if( (pBpName = mpBranch->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_DOOR_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_DOOR_PREFIX;
			pPrevBpName = pBpName;
			ghmGcMemSetAllocName("BpDoor");
			if( mpDoor==NULL && (mpDoor = new WK7StageBpEventDoor)==NULL ){
				break;
			}
			if( (pBpName = mpDoor->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_TV_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_TV_PREFIX;
			pPrevBpName = pBpName;
			GHM_SAFE_DELETE(mpTv);
			ghmGcMemSetAllocName("BpTv");
			if( (mpTv = new WK7StageBpEventTv)==NULL ){
				break;
			}
			if( (pBpName = mpTv->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
			GHM_SAFE_DELETE(mpTv);
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_LTV_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_LTV_PREFIX;
			pPrevBpName = pBpName;
			GHM_SAFE_DELETE(mpLtv);
			ghmGcMemSetAllocName("BpLtv");
			if( (mpLtv = new WK7StageBpEventLtv)==NULL ){
				break;
			}
			if( (pBpName = mpLtv->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
			GHM_SAFE_DELETE(mpLtv);
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_EVPOINT_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_EVPOINT_PREFIX;
			pPrevBpName = pBpName;
			ghmGcMemSetAllocName("BpEpnt");
			if( mpPoint==NULL && (mpPoint = new WK7StageBpEventPoint)==NULL ){
				break;
			}
			if( (pBpName = mpPoint->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_MAP_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_MAP_PREFIX;
			pPrevBpName = pBpName;
			ghmGcMemSetAllocName("BpMap");
			if( mpMap==NULL && (mpMap = new WK7StageBpEventMap)==NULL ){
				break;
			}
			if( (pBpName = mpMap->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_KEY_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_KEY_PREFIX;
			pPrevBpName = pBpName;
			ghmGcMemSetAllocName("BpKey");
			if( mpKey==NULL && (mpKey = new WK7StageBpEventKey)==NULL ){
				break;
			}
			if( (pBpName = mpKey->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_MEMO_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_MEMO_PREFIX;
			pPrevBpName = pBpName;
			ghmGcMemSetAllocName("BpMemo");
			if( mpMemo==NULL && (mpMemo = new WK7StageBpEventMemo)==NULL ){
				break;
			}
			if( (pBpName = mpMemo->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_VMEMO_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_VMEMO_PREFIX;
			pPrevBpName = pBpName;
			ghmGcMemSetAllocName("BpVoM");
			if( mpVoiceMemo==NULL && (mpVoiceMemo = new WK7StageBpEventVoiceMemo)==NULL ){
				break;
			}
			if( (pBpName = mpVoiceMemo->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_RAKU_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_RAKU_PREFIX;
			pPrevBpName = pBpName;
			ghmGcMemSetAllocName("BpRaku");
			if( mpRaku==NULL && (mpRaku = new WK7StageBpEventRaku)==NULL ){
				break;
			}
			if( (pBpName = mpRaku->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
		}else if( strstr(pBpName,WK7STAGE_STGBPARRIVE_TAMA_PREFIX)==pBpName ){
			pPrefix = WK7STAGE_STGBPARRIVE_TAMA_PREFIX;
			pPrevBpName = pBpName;
			ghmGcMemSetAllocName("BpTama");
			if( mpTama==NULL && (mpTama = new WK7StageBpEventTama)==NULL ){
				break;
			}
			if( (pBpName = mpTama->ParseBpName(pBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
				continue;
			}
			pBpName = NULL;
		}else{
			if( pPrefix==NULL ){
				break;
			}
			if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_DEFMOVE2_PREFIX)==0 ){
				if( mpBranch==NULL ){
					break;
				}
				if( (pBpName = mpBranch->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_PLAY_PREFIX)==0 ){
				if( mpPlayPoint==NULL ){
					break;
				}
				if( (pBpName = mpPlayPoint->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_ZAN_PREFIX)==0 ){
				if( mpZanPoint==NULL ){
					break;
				}
				if( (pBpName = mpZanPoint->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_DOOR_PREFIX)==0 ){
				if( mpDoor==NULL ){
					break;
				}
				if( (pBpName = mpDoor->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_EVPOINT_PREFIX)==0 ){
				if( mpPoint==NULL ){
					break;
				}
				if( (pBpName = mpPoint->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_MAP_PREFIX)==0 ){
				if( mpMap==NULL ){
					break;
				}
				if( (pBpName = mpMap->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_KEY_PREFIX)==0 ){
				if( mpKey==NULL ){
					break;
				}
				if( (pBpName = mpKey->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_MEMO_PREFIX)==0 ){
				if( mpMemo==NULL ){
					break;
				}
				if( (pBpName = mpMemo->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_VMEMO_PREFIX)==0 ){
				if( mpVoiceMemo==NULL ){
					break;
				}
				if( (pBpName = mpVoiceMemo->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_RAKU_PREFIX)==0 ){
				if( mpRaku==NULL ){
					break;
				}
				if( (pBpName = mpRaku->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else if( strcmp(pPrefix,WK7STAGE_STGBPARRIVE_TAMA_PREFIX)==0 ){
				if( mpTama==NULL ){
					break;
				}
				if( (pBpName = mpTama->ParseBpName(pBpName,pPrevBpName))!=WK7STAGEBPARRIVEEVENT_PARSE_ERROR ){
					continue;
				}
				pBpName = NULL;
				break;
			}else{
				break;
			}
		}
	}
}

WK7StageBpEvent::~WK7StageBpEvent()
{
	GHM_SAFE_DELETE(mpJump     );
	GHM_SAFE_DELETE(mpPlayPoint);
	GHM_SAFE_DELETE(mpZanPoint );
	GHM_SAFE_DELETE(mpBranch   );
	GHM_SAFE_DELETE(mpTv       );
	GHM_SAFE_DELETE(mpLtv      );
	GHM_SAFE_DELETE(mpPoint    );
	GHM_SAFE_DELETE(mpDoor     );
	GHM_SAFE_DELETE(mpMap      );
	GHM_SAFE_DELETE(mpKey      );
	GHM_SAFE_DELETE(mpTama     );
	GHM_SAFE_DELETE(mpMemo     );
	GHM_SAFE_DELETE(mpVoiceMemo);
	GHM_SAFE_DELETE(mpRaku     );
	GHM_SAFE_DELETE_ARRAY(mpBpName);
}

const char* WK7StageBpEvent::GetShortBpName(void)
{
	if( mpBpName==NULL ){
		return NULL;
	}
	if( mpJump!=NULL && mpJump->GetBpName()!=NULL && strstr(mpBpName,mpJump->GetBpName())==mpBpName ){
		return mpJump->GetBpName();
	}
	if( mpPlayPoint!=NULL && mpPlayPoint->GetBpName()!=NULL && strstr(mpBpName,mpPlayPoint->GetBpName())==mpBpName ){
		return mpPlayPoint->GetBpName();
	}
	if( mpZanPoint!=NULL && mpZanPoint->GetBpName()!=NULL && strstr(mpBpName,mpZanPoint->GetBpName())==mpBpName ){
		return mpZanPoint->GetBpName();
	}
	if( mpBranch!=NULL && mpBranch->GetBpName()!=NULL && strstr(mpBpName,mpBranch->GetBpName())==mpBpName ){
		return mpBranch->GetBpName();
	}
	if( mpTv!=NULL && mpTv->GetBpName()!=NULL && strstr(mpBpName,mpTv->GetBpName())==mpBpName ){
		return mpTv->GetBpName();
	}
	if( mpLtv!=NULL && mpLtv->GetBpName()!=NULL && strstr(mpBpName,mpLtv->GetBpName())==mpBpName ){
		return mpLtv->GetBpName();
	}
	if( mpPoint!=NULL && mpPoint->GetBpName()!=NULL && strstr(mpBpName,mpPoint->GetBpName())==mpBpName ){
		return mpPoint->GetBpName();
	}
	if( mpDoor!=NULL && mpDoor->GetBpName()!=NULL && strstr(mpBpName,mpDoor->GetBpName())==mpBpName ){
		return mpDoor->GetBpName();
	}
	if( mpMap!=NULL && mpMap->GetBpName()!=NULL && strstr(mpBpName,mpMap->GetBpName())==mpBpName ){
		return mpMap->GetBpName();
	}
	if( mpKey!=NULL && mpKey->GetBpName()!=NULL && strstr(mpBpName,mpKey->GetBpName())==mpBpName ){
		return mpKey->GetBpName();
	}
	if( mpMemo!=NULL && mpMemo->GetBpName()!=NULL && strstr(mpBpName,mpMemo->GetBpName())==mpBpName ){
		return mpMemo->GetBpName();
	}
	if( mpVoiceMemo!=NULL && mpVoiceMemo->GetBpName()!=NULL && strstr(mpBpName,mpVoiceMemo->GetBpName())==mpBpName ){
		return mpVoiceMemo->GetBpName();
	}
	if( mpRaku!=NULL && mpRaku->GetBpName()!=NULL && strstr(mpBpName,mpRaku->GetBpName())==mpBpName ){
		return mpRaku->GetBpName();
	}
	if( mpTama!=NULL && mpTama->GetBpName()!=NULL && strstr(mpBpName,mpTama->GetBpName())==mpBpName ){
		return mpTama->GetBpName();
	}
	return mpBpName;
}

bool WK7StageBpEvent::SearchBpName(const char *pBpName)
{
	if( pBpName==NULL ){
		return false;
	}
	if( mpBpName!=NULL && strcmp(mpBpName,pBpName)==0 ){
		return true;
	}
	if( mpJump!=NULL && mpJump->GetBpName()!=NULL && strcmp(mpJump->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpPlayPoint!=NULL && mpPlayPoint->GetBpName()!=NULL && strcmp(mpPlayPoint->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpZanPoint!=NULL && mpZanPoint->GetBpName()!=NULL && strcmp(mpZanPoint->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpBranch!=NULL && mpBranch->GetBpName()!=NULL && strcmp(mpBranch->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpTv!=NULL && mpTv->GetBpName()!=NULL && strcmp(mpTv->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpLtv!=NULL && mpLtv->GetBpName()!=NULL && strcmp(mpLtv->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpPoint!=NULL && mpPoint->GetBpName()!=NULL && strcmp(mpPoint->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpDoor!=NULL && mpDoor->GetBpName()!=NULL && strcmp(mpDoor->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpMap!=NULL && mpMap->GetBpName()!=NULL && strcmp(mpMap->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpKey!=NULL && mpKey->GetBpName()!=NULL && strcmp(mpKey->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpMemo!=NULL && mpMemo->GetBpName()!=NULL && strcmp(mpMemo->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpVoiceMemo!=NULL && mpVoiceMemo->GetBpName()!=NULL && strcmp(mpVoiceMemo->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpRaku!=NULL && mpRaku->GetBpName()!=NULL && strcmp(mpRaku->GetBpName(),pBpName)==0 ){
		return true;
	}
	if( mpTama!=NULL && mpTama->GetBpName()!=NULL && strcmp(mpTama->GetBpName(),pBpName)==0 ){
		return true;
	}
	return false;
}

WK7PathNurbs* WK7Stage::SearchPath(const char *pName)
{
	if( mpPath==NULL || pName==NULL ){
		return NULL;
	}
	return mpPath->SearchPath(pName);
}

WK7PathBranchPoint* WK7Stage::SearchBranchPoint(const char *pBpName)
{
	if( mpPath==NULL || pBpName==NULL ){
		return NULL;
	}
	WK7PathBranchPoint	*pBranchPoint;
	WK7StageBpEvent		*pBpEvent = NULL;
	for(pBranchPoint=mpPath->GetBranchPointTop() ; pBranchPoint!=NULL ; pBranchPoint=pBranchPoint->GetNext()){
		if( pBranchPoint->GetName()==NULL ){
			continue;
		}
		ghmGcMemSetAllocName("BpEvent");
		pBpEvent = new WK7StageBpEvent(pBranchPoint->GetName());
		if( pBpEvent==NULL ){
			OSDebugReport("Search Branch Point : mem alloc error!!\n");
			continue;
		}
		if( pBpEvent->SearchBpName(pBpName)==true ){
			break;
		}
		GHM_SAFE_DELETE(pBpEvent);
	}
	GHM_SAFE_DELETE(pBpEvent);
	return pBranchPoint;
}

bool WK7Stage::ChangeStage(ghmGcTaskController *pTaskController,int prio)
{
	if( mChangingStage==true ){
		return false;
	}
	if( pTaskController==NULL && (pTaskController=GET_WK7MAINTASK_FRAMEPROCESSTASKPTR())==NULL ){
		return false;
	}
	if( pTaskController->Start(ChangeStageTask,0,0,NULL,-1,prio) < 0 ){
		return false;
	}
	SetChanging(true);
	return true;
}

#ifndef	K7APP_INIT_STAGE
#define	K7APP_INIT_STAGE		K7STGID(0,0)
#endif

void WK7Stage::ChangeStageTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	u32			stgid;
	u32			i = 0;
	u32			mainid[3] = { K7STG_MAINID(K7APP_INIT_STAGE)/100,(K7STG_MAINID(K7APP_INIT_STAGE)%100)/10,K7STG_MAINID(K7APP_INIT_STAGE)%10 },
				suffix[2] = { K7STG_SUFFIX(K7APP_INIT_STAGE)/10,K7STG_SUFFIX(K7APP_INIT_STAGE)%10 };
	int			num = 0;
	int			index = 2;
	WK7Stage	*pCurrentStage = GetCurrentStage();
	
	WK7Stage::SetCurrentStageParam(0xffffffff);
	
	if( pCurrentStage!=NULL ){
		
//		WK7PathInfo			*pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
//		WK7PathBranchPoint	*pBranchPoint;
//		
//		SetPrevStageID      (pCurrentStage->GetID());
//		SetPrevStageBpName  (NULL);
//		SetPrevStagePathName(NULL);
//		if( (pBranchPoint=pPathInfo->GetPrevBranchPoint())==NULL ){
//			if( (pBranchPoint=pPathInfo->GetNextBranchPoint())==NULL ){
//				WK7PathNurbs	*pPath = pPathInfo->GetPath();
//				if( pPath!=NULL && pPath->GetEnable()==false ){
//					SetPrevStagePathName(pPath->GetName());
//				}
//			}
//		}
//		if( pBranchPoint!=NULL ){
//			SetPrevStageBpName(pBranchPoint->GetName());
//		}
		
		pCurrentStage->SetRenderFlag(false);
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		
		suffix[0] = pCurrentStage->GetID();
		mainid[0] = K7STG_MAINID(suffix[0]);
		mainid[2] =  mainid[0] %  10;
		mainid[1] = (mainid[0] /  10) % 10;
		mainid[0] = (mainid[0] / 100) % 10;
		suffix[0] = K7STG_SUFFIX(suffix[0]);
		suffix[1] =  suffix[0] %  10;
		suffix[0] = (suffix[0] /  10) % 10;
		WK7Stage::DeleteStage(pCurrentStage);
		pCurrentStage = NULL;
	}
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	WK7PLAYERCONTROL->ReleaseArchive();
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	while( 1 ){
		while( 1 ){
			
			if( WK7STAGE_PADTRIGGER & HSD_PAD_Y ){
				if( WK7STAGE_PADBUTTON & HSD_PAD_Z ){
					K7AppDumpMemoryType(2);
				}else{
					K7AppDumpMemoryType(1);
				}
			}
			if( WK7STAGE_PADTRIGGER & HSD_PAD_A ){
				break;
			}
			if( WK7STAGE_PADREPEAT & HSD_PAD_RIGHT ){
				index++;
			}
			if( WK7STAGE_PADREPEAT & HSD_PAD_LEFT ){
				index--;
			}
			if( index < 0 ){
				index = 5-1;
			}else if( index > 5-1 ){
				index = 0;
			}
			switch( index ){
			case	0: 
			case	1: 
			case	2: num = (int)mainid[index  ]; break;
			case	3:
			case	4: num = (int)suffix[index-3]; break;
			default:
				 num = 0;
				 break;
			}
			if( WK7STAGE_PADREPEAT & HSD_PAD_UP ){
				num++;
			}
			if( WK7STAGE_PADREPEAT & HSD_PAD_DOWN ){
				num--;
			}
			if( num < 0 ){
				num = 9;
			}else if( num > 9 ){
				num = 0;
			}
			switch( index ){
			case	0:
			case	1:
			case	2: mainid[index  ] = (u32)num; break;
			case	3: 
			case	4: suffix[index-3] = (u32)num; break;
			default:
				break;
			}
			
			{
				C_Paper	paper(0,0);
				char	str[64];
				int		did;
				
				PRINTF("\n\n Killer7 Test Scenario Stage Select\n\n");
				
				memset(str,' ',sizeof(str));
				str[6] = '\0';
				if( index < 3 ){
					did = index;
				}else{
					did = index + 1;
				}
				str[did] = '|';
				
				PRINTF("        %s\n",str);
				PRINTF("   Stage%01d%01d%01dM%01d%01d\n",mainid[0],mainid[1],mainid[2],suffix[0],suffix[1]);
				PRINTF("        %s\n",str);
			}
			
			K7SCR_RETSYS();
			
		}
		
		stgid = K7STGID(mainid[0]*100+mainid[1]*10+mainid[2],suffix[0]*10+suffix[1]);
		
		WK7StageInfo	*pStageInfo = GetStageInfo(stgid);
		if( pStageInfo!=NULL &&
		    (K7ScenarioFlow)pStageInfo->mFlowID!=K7SCNF_UNKNOWN &&
		    GameInfo.GetScenarioFlow()!=(K7ScenarioFlow)pStageInfo->mFlowID ){
			GameInfo.SetScenarioFlow((K7ScenarioFlow)pStageInfo->mFlowID);
			K7SCR_CHANGE_SCENARIO_DATA();
		}
		
		if( WK7RenderObj::CreateStage(stgid)!=NULL ){
			WK7ArchiveSetDebugPrintSecDefault();
			break;
		}
		
		K7AppDebugPrint("Stage Not Found !!");
		K7SCR_RETSYS();
		
	}
	
	K7SCR_STG_CREATEWAIT (stgid);
	
	WK7PLAYERCONTROL->RestoreArchive();
	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
//	while( true == WK7PLAYERCONTROL->IsLoading() ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_STG_VISIBLE    (stgid,true);
	K7SCR_STG_SET_CURRENT(stgid);
	
	SetChanging(false);
	
	if( WK7Stage::GetMoveModeCancel()==false ){
		GameInfo.SetMode(WK7GameInfo::MOVE);
	}
	WK7Stage::SetMoveModeCancel(false);
	
}

bool WK7Stage::SandRelease(WK7StagePlaceInfo *pPlaceInfo,WK7StageDoorInfo *pDoorInfo)
{
	int		closeSeID;
	if( pDoorInfo==NULL ){
		closeSeID = NOISE_SE_MAP_DEFAULT;
	}else{
		closeSeID = pDoorInfo->mCloseSeID;
	}
	return SandRelease(pPlaceInfo,closeSeID);
}

bool WK7Stage::SandRelease(WK7StagePlaceInfo *pPlaceInfo,int closeSeID)
{
	if( pPlaceInfo==NULL ){
		gpNoise->mSandRelease();
		return true;
	}
	char	nullstr[1] = "";
	gpNoise->mSandRelease((pPlaceInfo->mpName[0]!=NULL? pPlaceInfo->mpName[0] : nullstr),
	                      (pPlaceInfo->mpName[1]!=NULL? pPlaceInfo->mpName[1] : nullstr),
	                      (pPlaceInfo->mpName[2]!=NULL? pPlaceInfo->mpName[2] : nullstr),
	                      (pPlaceInfo->mpName[3]!=NULL? pPlaceInfo->mpName[3] : nullstr),
	                      closeSeID);
	return true;
}

bool WK7Stage::SandRelease(int closeSeID)
{
	return SandRelease(mID,closeSeID);
}

bool WK7Stage::SandRelease(u32 stgid,int closeSeID)
{
	const char		*pPathName = WK7PLAYERPATHCONTROL->GetCurrentPathName();
	if( pPathName==NULL ){
		return false;
	}
	WK7StagePlaceInfo	*pPlaceInfo = GetPlaceInfo(stgid,pPathName);
#ifdef	_DEBUG
//	WK7Stage	*pStage;
//	if( (pStage=WK7Stage::GetCurrentStage())!=NULL ){
//		pStage->SetPlaceInfoWaring(pPlaceInfo,pPathName);
//	}
#endif
	SetCameraStartPosition(pPlaceInfo);
	SandRelease(pPlaceInfo,closeSeID);
	return true;
}

void WK7Stage::DoorEventTaskTerm(WK7DoorEventInfo &doorEventInfo,WK7StageDoorInfo *pDoorInfo)
{
	
	GameInfo.InitOptionWindow();
	
	if( WK7Stage::GetManualBranch()==false ){
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		
		WK7Stage::SetRenderStage(true);
		WK7Chara::SetRenderChara(true);
		WK7Item::SetRenderItem  (true);
		
		if( doorEventInfo.GetCinemaScopeClear()==true ){
			WK7CAM->SetCinemaScopeMode(false);
		}
		
		if( doorEventInfo.mNextBpName[0]!='\0' ){
			WK7StagePlaceInfo		*pPlaceInfo;
			pPlaceInfo = GetPlaceInfo(GetCurrentStageID(),doorEventInfo.mNextBpName);
			SetCameraStartPosition(pPlaceInfo);
#ifdef	_DEBUG
			WK7Stage	*pStage;
			if( (pStage=WK7Stage::GetCurrentStage())!=NULL ){
				pStage->SetPlaceInfoWaring(pPlaceInfo,doorEventInfo.mNextBpName);
			}
#endif
			SandRelease(pPlaceInfo,pDoorInfo);
		}else{
			return;
		}
		
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		
		if( WK7Stage::GetMoveModeCancel()==false ){
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		WK7Stage::SetMoveModeCancel(false);
		
	}
	
	while( WK7Stage::SetChanging(false)==false ){
		GHMGCTASK_RETSYS();
	}
	
	doorEventInfo.SetSelectObjEnable(true);
	
	GHM_SAFE_DELETE(doorEventInfo.mpBpEvent);
	
	WK7Stage::SetManualBranch(false);
	
//	GHMGCTASK_EXIT();
}

void WK7Stage::DoorEventTask(WK7DoorEventInfo &doorEventInfo)
{
	
	if( WK7Stage::SetChanging(true)==false ){
		DoorEventTaskTerm(doorEventInfo);
		return;
	}
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	const char					*pCurrentBpName;
	WK7StageDoorInfo			*pDoorInfo;
	WK7Stage					*pNextStg;
	bool						sameStg;
	
	if( doorEventInfo.mpBpEvent!=NULL ){
		pCurrentBpName = doorEventInfo.mpBpEvent->GetShortBpName();
	}else{
		if( (pCurrentBpName = WK7Stage::GetPrevStageBpName())==NULL ){
			pCurrentBpName = WK7Stage::GetPrevStagePathName();
		}
	}
	pDoorInfo = WK7Stage::GetDoorInfo(doorEventInfo.mCurrStageID,
	                                  pCurrentBpName,
	                                  doorEventInfo.mNextStageID,
	                                  doorEventInfo.mNextBpName);
	gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,pDoorInfo!=NULL? (int)pDoorInfo->mOpenSeID : NOISE_SE_MAP_DEFAULT);
	if( doorEventInfo.mNextStageID!=doorEventInfo.mCurrStageID ){
		WK7Stage	*pCurrentStage = WK7Stage::GetCurrentStage();
		if( pCurrentStage!=NULL ){
			K7SCR_RETSYS();
			pCurrentStage->SetRenderFlag(false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
		}
		sameStg = false;
		K7SCR_STG_RELEASE    (doorEventInfo.mCurrStageID);
		if( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
			while( WK7PLAYERCONTROL->IsLoading()==true ){
				K7SCR_RETSYS();
			}
			WK7PLAYERCONTROL->ReleaseArchive();
		}
		doorEventInfo.ClearSelectObj();
	}else{
		sameStg = true;
	}
	
	if( sameStg==false ){
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
			GHMGCTASK_RETSYS();
		}
		
		K7SCR_CHANGE_SCENARIO_DATA();
		
		if( (pNextStg = WK7RenderObj::CreateStage(doorEventInfo.mNextStageID))==NULL ){
			DoorEventTaskTerm(doorEventInfo);
			return;
		}
		while( pNextStg->GetState()!=WK7RenderObj::LOADED ){
			GHMGCTASK_RETSYS();
		}
		WK7PLAYERCONTROL->RestoreArchive();
		while( true == WK7PLAYERCONTROL->IsLoading() ){
			GHMGCTASK_RETSYS();
		}
	}else{
		if( (pNextStg = WK7RenderObj::GetStage(doorEventInfo.mCurrStageID))==NULL ){
			DoorEventTaskTerm(doorEventInfo);
			return;
		}
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	WK7PathNurbs				*pNextPath = pNextStg->SearchPath(doorEventInfo.mNextBpName);
	WK7PathBranchPoint			*pNextBranchPoint = NULL;
	
	if( pNextPath==NULL && (pNextBranchPoint=pNextStg->SearchBranchPoint(doorEventInfo.mNextBpName))==NULL ){
		WK7Path		*pPath = pNextStg->GetPath();
		if( pPath==NULL || (pNextBranchPoint = pPath->GetBranchPointTop())==NULL ){
			if( sameStg==false ){
				GHM_SAFE_DELETE(pNextStg);
			}
			DoorEventTaskTerm(doorEventInfo);
			return;
		}
	}
	
	if( sameStg==false ){
		K7SCR_STG_SET_CURRENT(doorEventInfo.mNextStageID);
		K7SCR_STG_VISIBLE    (doorEventInfo.mNextStageID,true);
	}else{
		pNextStg->InitializeSelectFlag();
	}
	if( pNextPath!=NULL ){
		u32		dir;
		f32		param;
		if( pNextPath->GetStartBranchPoint()==NULL ){
			dir   = 0;
			param = pNextPath->GetEndParam();
//			param = pNextPath->GetStartParam();
		}else{
			dir = 1;
			param = pNextPath->GetStartParam();
//			param = pNextPath->GetEndParam();
		}
		WK7Stage::SetCurrentPath(pNextPath,param,dir,WK7PATHINFO_INITDIR_TGTDIR);
		WK7PLAYERPATHCONTROL->SetBranchPointFix(true);
		WK7PLAYERPATHCONTROL->SetPathSelectMode();
	}else{
		WK7PLAYERPATHCONTROL->SetBranchPointFix(false);
		K7SCR_STG_SET_CURRENT_PATH_POINT(pNextBranchPoint->GetName());
	}
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	K7SCR_TIMEWAIT(600);
	
	DoorEventTaskTerm(doorEventInfo,pDoorInfo);
}

void WK7Stage::DoorEventTask(ghmGcTask *pTask)
{
#pragma	unused(pTask)
	
	WK7Event		*pEvent = K7EV_GETEVENT();
	
	if( IsChanging()==true ){
		return;
	}
	
	if( pEvent->GetParam(0)==0 ){
		WK7Path::DoorEventTask();
		return;
	}
	
	WK7PathBranchPointObjJObj	*pSelectObj   = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0);
	WK7Stage					*pCurrentStg  = WK7Stage::GetCurrentStage();
	u32							currStgID     = pCurrentStg->GetID();
	WK7PathBranchPoint			*pBranchPoint = pSelectObj->GetBranchPoint();
	const char					*pBranchPointName;
	WK7DoorEventInfo			doorEventInfo;
	
	doorEventInfo.Initialize();
	doorEventInfo.mCurrStageID = currStgID;
	
	if( pBranchPoint==NULL || (pBranchPointName=pBranchPoint->GetName())==NULL ){
		DoorEventTaskTerm(doorEventInfo);
		return;
	}
	ghmGcMemSetAllocName("BpEvent");
	doorEventInfo.mpBpEvent = new WK7StageBpEvent(pBranchPointName);
	if( doorEventInfo.mpBpEvent==NULL ){
		DoorEventTaskTerm(doorEventInfo);
		return;
	}
	WK7StageBpEventDoor		*pDoor    = doorEventInfo.mpBpEvent->GetDoor();
	WK7JObj					*pJObj    = pSelectObj->GetJObj();
	const char				*pSelectObjName;
	if( pDoor==NULL || pJObj==NULL || (pSelectObjName=pJObj->GetName())==NULL ){
		DoorEventTaskTerm(doorEventInfo);
		return;
	}
	WK7StageBpEventDoorNextStage	*pStage = pDoor->GetStageTop();
	while( pStage!=NULL ){
		if( pStage->GetSelectObjName()!=NULL ){
			if( strcmp(pStage->GetSelectObjName(),pSelectObjName)==0 ){
				break;
			}
		}
		pStage = pStage->GetNext();
	}
	if( pStage==NULL ){
		DoorEventTaskTerm(doorEventInfo);
		return;
	}
	
	doorEventInfo.mNextStageID = pStage->GetStageID();
	doorEventInfo.SetSelectObj(pSelectObj);
	doorEventInfo.SetNextBpName(pStage->GetBpName());
	
	WK7Stage::SetPrevStageID    (currStgID       );
	WK7Stage::SetPrevStageBpName(doorEventInfo.mpBpEvent->GetShortBpName());
//	WK7Stage::SetPrevStageBpName(pBranchPointName);
	WK7Stage::SetPrevStagePathName(NULL);
	WK7Stage::SetCurrentStageBpName(pStage->GetBpName());
	WK7Stage::SetCurrentStageParam(pStage->GetParam());
	
	DoorEventTask(doorEventInfo);
	
}

HSD_TObj* WK7Stage::GetScreenTObj(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return NULL;
	}
	HSD_DObj	*pDObj = pJObj->GetDObjByPartialName("Screen");
	if( pDObj==NULL ){
		return NULL;
	}
	HSD_MObj	*pMObj = pDObj->mobj;
	if( pMObj==NULL ){
		return NULL;
	}
	return pMObj->tobj;
}

void WK7Stage::TvEventTaskTerm(WK7TvEventInfo &info)
{
	info.SetSelectObjEnable(true);
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
//	GHMGCTASK_EXIT();
}

void WK7Stage::LtvEventTask(WK7TvEventInfo &info)
{
	TvEventTask(info);
}

bool WK7Stage::SetSelOKAll(bool flag)
{
	int		selok = (flag==true? 1:0);
	BattleCtrl.PcSelOKSet (K7DAN,selok);
	BattleCtrl.PcSelOKSet (K7GAL,selok);
	BattleCtrl.PcSelOKSet (K7CON,selok);
	BattleCtrl.PcSelOKSet (K7HAC,selok);
	BattleCtrl.PcSelOKSet (K7HAS,selok);
	BattleCtrl.PcSelOKSet (K7HAY,selok);
	BattleCtrl.PcSelOKSet (K7CYO,selok);
	BattleCtrl.PcSelOKSet (K7KED,selok);
	BattleCtrl.PcSelOKSet (K7KVN,selok);
	BattleCtrl.PcSelOKSet (K7MSK,selok);
	return true;
}

//bool WK7Stage::ClearCharChangeMask(void)
//{
//	BattleCtrl.PcSelOKSet (K7DAN, 1);
//	BattleCtrl.PcSelOKSet (K7GAL, 1);
//	BattleCtrl.PcSelOKSet (K7CON, 1);
//	BattleCtrl.PcSelOKSet (K7HAC, 1);
//	BattleCtrl.PcSelOKSet (K7HAS, 1);
//	BattleCtrl.PcSelOKSet (K7HAY, 1);
//	BattleCtrl.PcSelOKSet (K7CYO, 1);
//	BattleCtrl.PcSelOKSet (K7KED, 1);
//	BattleCtrl.PcSelOKSet (K7KVN, 1);
//	BattleCtrl.PcSelOKSet (K7MSK, 1);
//	return true;
//}

//bool WK7Stage::SetCharChangeMask(u32 chrid)
//{
//	switch( chrid ){
//	case	K7DAN:
//	case	K7GAL:
//	case	K7CON:
//	case	K7HAC:
//	case	K7HAS:
//	case	K7HAY:
//	case	K7CYO:
//	case	K7KED:
//	case	K7KVN:
//	case	K7MSK:
//		break;
//	default:
//		return false;
//	}
//	if( !(mChangeChara & (1<<chrid)) ){
//#if 1
//		BattleCtrl.PcSelOKSet (chrid, 0);
//#else
//		::SetCharChangeMask((u8)chrid);
//#endif
//	}
//	return true;
//}


//u8 SwitchOnFlag = false;				// Ƃ肠

void WK7Stage::TvEventTask(WK7TvEventInfo &info)
{
	bool	blurVisible = SceneBlur.GetVisible();

	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		K7SCR_RETSYS();
	}
	
	GHMGCTASK_RETSYS();
	GHMGCTASK_RETSYS();
	
	while( WK7Stage::ReleaseStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( WK7Stage::IsReleasedStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	// LI\}bv
//	ClearCharChangeMask();
	
	// ̃LN^IłȂ悤ɂ( InitCharChange ̑OɈړ܂ (Rc) )
//	SetCharChangeMask(K7DAN);
//	SetCharChangeMask(K7GAL);
//	SetCharChangeMask(K7CON);
//	SetCharChangeMask(K7HAC);
//	SetCharChangeMask(K7HAS);
//	SetCharChangeMask(K7HAY);
//	SetCharChangeMask(K7CYO);
//	SetCharChangeMask(K7KED);
//	SetCharChangeMask(K7KVN);
//	SetCharChangeMask(K7MSK);
#if 0
 Lerɂ̓xAbvׂ̈ɉf悤ɂȂ܂B040314
//	::SetCharChangeMask((u8)WK7PLAYERCONTROL->GetMainID());
	// goÕL L`FWłȂ悤ɂ
//	SetCharChangeMaskAuto();
#endif
	
	// ݂̃LN^̂goqɂɔf
	WK7PLAYERCONTROL->SetDataHp(WK7PLAYERCONTROL->GetMainID(), WK7PLAYERCONTROL->GetHp());		// ݂̂goqɃL̃f[^e[uɔf
	
	// LN^`FW̏
	// extern s8	InitCharChange( u8 NotCancelFlag = FALSE, s32 CurrentChar = K7GAL, u8 SwitchOnFlag = FALSE ) ;	// LN^`FW̏
//	InitCharChange(false, (s32 )-1, (u8 )SwitchOnFlag);				// CurrentChar = -1 ƁiQԖڂ̈j ʂftHg
//	SwitchOnFlag = true;				// Ƃ肠
	WK7Stage::InitCharChange(false, (s32 )-1, (u8 )WK7Stage::GetHarmanTvFlag(info.GetStageID(),(int)(info.GetParam()-1)));
	WK7Stage::SetHarmanTvFlag(info.GetStageID(),(int)(info.GetParam()-1),true);
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	while( CheckCharChangeSetup()==FALSE ){
		GHMGCTASK_RETSYS();
	}
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7CAM->StoreState();
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	// LN^`FW̏Ԃ𓾂( TRUE:s  FALSE:I͊ɏIĂ ) 
	while( GetCharChangeState()==TRUE ){
		K7SCR_RETSYS();
	}
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		GHMGCTASK_RETSYS();
	}
	
	// LN^`FW̌ns
	EndCharChange();
	
	GHMGCTASK_RETSYS();
	GHMGCTASK_RETSYS();
	
	while( WK7Stage::RestoreStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	while( WK7Stage::IsRestoredStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	// tF[hAEg
	WK7PLAYERCONTROL->ChangeChkPoint();			// `FbN|Cg̕ύXs
	
	WK7CAM->RestoreState();
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	
	// ILN^̂hc𓾂
	int		mainid  = GetSelectChar();
	bool	changeChara = false;
	if( mainid >= 0 ){
		u32		charaid = (u32)K7CHRID(mainid,0);
		if( WK7PLAYERCONTROL->GetMainID()!=charaid ){
			WK7PlayerChangeforTV(charaid);
			changeChara = true;
			WK7PLAYERCONTROL->SetVisible(false);
		}
	}
	
	SceneBlur.SetVisible(blurVisible);
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	
	WK7Stage		*pStage;
	if( (pStage=WK7Stage::GetCurrentStage())!=NULL ){
		pStage->RenewPath();
	}
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	WK7Chara	*pChara;
	WK7JObj		*pJObj;
	if( changeChara==true && (pChara=WK7PLAYERCONTROL->GetCharaPtr())!=NULL && (pJObj=pChara->GetJObj())!=NULL ){
		::SetNoiseOutNotAutoDelete();
		EFFECT	*pEffect = CreateNoiseOutEffect(pJObj,0,1);
		u32		effectID;
		if( pEffect!=NULL && (effectID=GetEffectID(pEffect))!=0xffffffff ){
			GHMGCTASK_RETSYS();
			WK7PLAYERCONTROL->SetVisible   (true );
			WK7PLAYERCONTROL->SetGunVisible(true );
			while( ::CheckNoiseOutEndState(pEffect)==false ){
				GHMGCTASK_RETSYS();
			}
			WK7PLAYERCONTROL->SetVisible(true);
			if( CheckEffectValidState(pEffect,effectID)==TRUE ){
				::SetEffectDrawFlag(pEffect,FALSE);
				::SetEffectMoveFlag(pEffect,FALSE);
				pJObj->Disp(true,true);
				pChara->HideClothCollision();
				GHMGCTASK_RETSYS();
				::DeleteEffect(pEffect);
			}
		}
	}
	
	WK7PLAYERCONTROL->SetVisible(true);
	
	TvEventTaskTerm(info);
//	TVEventTaskTerm(pTask);
}

void WK7Stage::MapEventTask(WK7MapEventInfo &info)
{
	u32							evno        = info.mEventNo;
	WK7EventItemTable			*pTable     = WK7EventItem::FindTable(evno);
	WK7JObj						*pJObj      = info.GetSelectObj()->GetJObj();
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	if( pTable!=NULL ){
		WK7EventItem::SetItem(evno,true);
	}
#ifdef	_DEBUG
	char						str[32];
	u32							itemno = evno & 0x00ffffff;
	if( pTable==NULL ){
		sprintf(str,"MAP_%06x undefined",itemno);
		K7SCR_DEBUGPRINT(str);
	}
#endif
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	if( pJObj != NULL ){
		Vec		pos,tgt;
		
		pJObj->GetWorldPosition(tgt);
		pos.x =  0.0f;
		pos.y =  2.0f;
		pos.z = 10.0f;
		MTXMultVec(pJObj->GetMtxPtr(),&pos,&pos);
		
		WK7CAM->SetMode          (WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (pos);
		WK7CAM->SetTargetPosition(tgt);
		
		WK7PLAYERCONTROL->StackVisible(false);
	}
	
	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETKEY);
//	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETMAP);
	
	if( pJObj != NULL ){
		pJObj->Hide(false,true);
		WK7PLAYERCONTROL->PullVisible();
	}
	
	MapEventTaskTerm(info);
}

void WK7Stage::MapEventTask(ghmGcTask *)
{
	WK7MapEventInfo				info;
	WK7PathBranchPointObjJObj	*pSelectObj;
	info.Initialize();
	if( (pSelectObj = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0))==NULL ){
		return;
	}
	info.SetSelectObj(pSelectObj);
	info.mEventNo = pSelectObj->GetEventNo();
	MapEventTask(info);
}

void WK7Stage::MapEventTaskTerm(WK7MapEventInfo &info)
{
	info.SetSelectObjEnable(false);
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
//	GHMGCTASK_EXIT();
}

void WK7Stage::KeyEventTask(WK7KeyEventInfo &info)
{
	u32							evno          = info.mEventNo;
	WK7EventItemTable			*pTable       = WK7EventItem::FindTable(evno);
	WK7JObj						*pJObj        = info.GetSelectObj()->GetJObj();
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	if( pTable!=NULL ){
		WK7EventItem::SetItem(evno,true);
	}
#ifdef	_DEBUG
	char						str[32];
	u32							itemno = evno & 0x00ffffff;
	if( pTable==NULL ){
		sprintf(str,"KEY_%06x undefined",itemno);
		K7SCR_DEBUGPRINT(str);
	}
#endif
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	if( pJObj != NULL ){
		Vec		pos,tgt;
		
		pJObj->GetWorldPosition(tgt);
		pos.x =  0.0f;
		pos.y =  2.0f;
		pos.z = 10.0f;
		MTXMultVec(pJObj->GetMtxPtr(),&pos,&pos);
		
		WK7CAM->SetMode          (WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (pos);
		WK7CAM->SetTargetPosition(tgt);
		
		WK7PLAYERCONTROL->StackVisible(false);
	}
	
	if( mGetKeyMesID==0xffffffff ){
		K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETKEY);
	}else{
		K7SCR_STGC_MESSAGE_B(mGetKeyMesID);
		mGetKeyMesID = 0xffffffff;
	}
	
	if( pJObj != NULL ){
		pJObj->Hide(false,true);
		WK7PLAYERCONTROL->PullVisible();
	}
	
	KeyEventTaskTerm(info);
}

void WK7Stage::KeyEventTask(ghmGcTask *)
{
	WK7KeyEventInfo				info;
	WK7PathBranchPointObjJObj	*pSelectObj;
	info.Initialize();
	if( (pSelectObj = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0))==NULL ){
		return;
	}
	info.SetSelectObj(pSelectObj);
	info.mEventNo = pSelectObj->GetEventNo();
	KeyEventTask(info);
}

void WK7Stage::KeyEventTaskTerm(WK7KeyEventInfo &info)
{
	info.SetSelectObjEnable(false);
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
//	GHMGCTASK_EXIT();
}

void WK7Stage::MemoEventTask(WK7MemoEventInfo &info)
{
	u32							evno        = info.mEventNo;
	WK7EventItemTable			*pTable     = WK7EventItem::FindTable(evno);
	WK7JObj						*pJObj      = NULL;//      = info.GetSelectObj()->GetJObj();
	WK7Stage					*pStage     = WK7Stage::GetCurrentStage();
	
	if( pStage!=NULL ){
		pJObj=pStage->GetSelectJObj_EventNo(evno);
	}
	
	if( pTable!=NULL ){
		WK7EventItem::SetItem(evno,true);
	}
#ifdef	_DEBUG
	char						str[32];
	u32							itemno = evno & 0x00ffffff;
	if( pTable==NULL ){
		sprintf(str,"MEMO_%06x undefined",itemno);
		K7SCR_DEBUGPRINT(str);
	}
#endif
	
	if( pJObj != NULL ){
		pJObj->Hide(false,true);
	}
//	K7SCR_SYS_MESSAGE(K7SCR_SYSMES_GETMEMO);
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	GameInfo.SetMemoLocator(pJObj);
	GameInfo.SetMemoNo(evno);
	
	GameInfo.SetMode(WK7GameInfo::HATOMEMOMODE);
	
	while( GameInfo.GetMode()==WK7GameInfo::HATOMEMOMODE ){
		K7SCR_RETSYS();
	}
	
	MemoEventTaskTerm(info);
}

void WK7Stage::MemoEventTask(ghmGcTask *)
{
	WK7MemoEventInfo			info;
	WK7PathBranchPointObjJObj	*pSelectObj;
	info.Initialize();
	if( (pSelectObj = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0))==NULL ){
		return;
	}
	info.SetSelectObj(pSelectObj);
	info.mEventNo = pSelectObj->GetEventNo();
	MemoEventTask(info);
}

void WK7Stage::MemoEventTaskTerm(WK7MemoEventInfo &info)
{
	if( WK7EventItem::HasItem(info.mEventNo)==true ){
		info.SetSelectObjEnable(false);
	}
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
//	GHMGCTASK_EXIT();
}

void WK7Stage::VoiceMemoEventTask(WK7VoiceMemoEventInfo &info)
{
	
	u32							evno        = info.mEventNo;
	WK7EventItemTable			*pTable     = WK7EventItem::FindTable(evno);
	WK7JObj						*pJObj      = info.GetSelectObj()->GetJObj();
	
	if( pTable!=NULL ){
		WK7EventItem::SetItem(evno,true);
	}
	
#ifdef	_DEBUG
	char						str[32];
	u32							itemno = evno & K7EV_ID_MASK;
	if( pTable==NULL ){
		sprintf(str,"VOICEM_%06x undefined",itemno);
		K7SCR_DEBUGPRINT(str);
	}
#endif
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	K7SCR_ENTER_DEMOPAUSE();
	
	if( pJObj != NULL ){
		Vec		pos,tgt;
		
		pJObj->GetWorldPosition(tgt);
		pos.x =  0.0f;
		pos.y =  2.0f;
		pos.z = 10.0f;
		MTXMultVec(pJObj->GetMtxPtr(),&pos,&pos);
		
		WK7CAM->SetMode          (WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (pos);
		WK7CAM->SetTargetPosition(tgt);
		
		WK7PLAYERCONTROL->StackVisible(false);
	}
	
	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETKEY);
//	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETVMEMO);
	
	if( pJObj != NULL ){
		pJObj->Hide(false,true);
		WK7PLAYERCONTROL->PullVisible();
	}
	
	VoiceMemoEventTaskTerm(info);
}

void WK7Stage::VoiceMemoEventTask(ghmGcTask *)
{
	WK7VoiceMemoEventInfo		info;
	WK7PathBranchPointObjJObj	*pSelectObj;
	info.Initialize();
	if( (pSelectObj = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0))==NULL ){
		return;
	}
	info.SetSelectObj(pSelectObj);
	info.mEventNo = pSelectObj->GetEventNo();
	VoiceMemoEventTask(info);
}

void WK7Stage::VoiceMemoEventTaskTerm(WK7VoiceMemoEventInfo &info)
{
	if( WK7EventItem::HasItem(info.mEventNo)==true ){
		info.SetSelectObjEnable(false);
	}
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
//	GHMGCTASK_EXIT();
}

void WK7Stage::RakuEventTask(WK7RakuEventInfo &info)
{
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	K7SCR_PANEL_SETPANELEVNO_NOPARAM(info.mEventNo);
	K7SCR_PANEL_START();
	K7SCR_PANEL_TERMWAIT();
	K7SCR_RETSYS();
	K7SCR_PANEL_EXIT();
	K7SCR_PANEL_EXITWAIT();
	
	RakuEventTaskTerm(info);
}

void WK7Stage::RakuEventTask(ghmGcTask *)
{
	WK7RakuEventInfo			info;
	WK7PathBranchPointObjJObj	*pSelectObj;
	info.Initialize();
	if( (pSelectObj = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0))==NULL ){
		return;
	}
	info.SetSelectObj(pSelectObj);
	info.mEventNo = pSelectObj->GetEventNo();
	RakuEventTask(info);
}

void WK7Stage::RakuEventTaskTerm(WK7RakuEventInfo &info)
{
#pragma	unused(info)
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
//	GHMGCTASK_EXIT();
}


WK7Stage*		WK7Stage::mpReleasedStage = NULL;
bool			WK7Stage::mReleaseStage   = false;
bool			WK7Stage::mReleasePlayer  = false;
bool			WK7Stage::mReleasedStage  = false;
bool			WK7Stage::mReleasedPlayer = false;
char			WK7Stage::mPlayerPathName[256];
f32				WK7Stage::mPlayerPathParam;
u32				WK7Stage::mPlayerPathDir;
Vec				WK7Stage::mPlayerPosition;
char			WK7Stage::mCameraPathName[256];
f32				WK7Stage::mCameraPathParam;
u32				WK7Stage::mCameraPathDir;
bool			WK7Stage::mReleasedStageVisible  = true;
bool			WK7Stage::mReleasedPlayerVisible = true;
bool			WK7Stage::mDisableInitializeSelectFlag = false;

bool WK7Stage::ReleaseStageArchive(bool player)
{
	if( mReleaseStage==true || mReleasePlayer==true || mReleasedStage==true || mReleasedPlayer==true ){
		return false;
	}
	
	if( (mpReleasedStage = WK7Stage::GetCurrentStage())!=NULL ){
		mReleasedStageVisible  = mpReleasedStage->GetRenderFlag();
	}
	
	mReleasedPlayerVisible = WK7PLAYERCONTROL->GetVisible();
	
	if( GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->Start(ReleaseStageArchiveTask) < 0 ){
		return false;
	}
	
	mReleaseStage  = true;
	mReleasePlayer = player;
	
	WK7PLAYERCONTROL->GetPosition(mPlayerPosition);
	
	return true;
}

bool WK7Stage::RestoreStageArchive(void)
{
	if( mReleaseStage==false || mReleasedStage==false ){
		return false;
	}
	
	if( GET_WK7MAINTASK_FRAMEPROCESSTASKPTR()->Start(RestoreStageArchiveTask) < 0 ){
		return false;
	}
	
	return true;
}

void WK7Stage::ReleaseStageArchiveTask(ghmGcTask *pTask)
{
#pragma	unused(pTask)
	
	WK7PathInfo		*pPathInfo;
	
	if( mpReleasedStage!=NULL ){
		mpReleasedStage->SetRenderFlag(false);
		GHMGCTASK_RETSYS();
		GHMGCTASK_RETSYS();
	}
	
	if( mpReleasedStage!=NULL ){
		pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
		if( pPathInfo->GetPathName()!=NULL ){
			strncpy(mPlayerPathName,pPathInfo->GetPathName(),sizeof(mPlayerPathName));
		}else{
			memset(mPlayerPathName,0,sizeof(mPlayerPathName));
		}
		mPlayerPathParam = pPathInfo->GetParam();
		mPlayerPathDir   = pPathInfo->GetDir  ();
		
		pPathInfo = WK7CAMPATHFOLLOWINFO->GetPathControl()->GetCurrentPathInfo();
		if( pPathInfo->GetPathName()!=NULL ){
			strncpy(mCameraPathName,pPathInfo->GetPathName(),sizeof(mCameraPathName));
		}else{
			memset(mCameraPathName,0,sizeof(mCameraPathName));
		}
		mCameraPathParam = pPathInfo->GetParam();
		mCameraPathDir   = pPathInfo->GetDir  ();
		
		mpReleasedStage->ReleaseArchive();
		
		while( mpReleasedStage->GetState()!=WK7RenderObj::RELEASEDARCHIVE ){
			GHMGCTASK_RETSYS();
		}
		
	}
	
	if( mReleasePlayer==true && WK7PLAYERCONTROL->GetMainID()!=0xffffffff ){
		
		WK7PLAYERCONTROL->SetVisible(false);
		GHMGCTASK_RETSYS();
		GHMGCTASK_RETSYS();
		
		WK7PLAYERCONTROL->ReleaseArchive();
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
			GHMGCTASK_RETSYS();
		}
		
		mReleasedPlayer = true;
	}
	
#ifdef	_DEBUG
	OSReport("StageRelease FreeSize %d\n",ghmGcMemGetFreeSize());
#endif
	
	mReleasedStage = true;
}

bool WK7Stage::IsReleasedStageArchive(void)
{
	return mReleasedStage;
}

void WK7Stage::RestoreStageArchiveTask(ghmGcTask *pTask)
{
#pragma	unused(pTask)
	
	if( mpReleasedStage!=NULL ){
		mpReleasedStage->RestoreArchive();
		while( mpReleasedStage->GetState()!=WK7RenderObj::LOADED ){
			GHMGCTASK_RETSYS();
		}
	}
	
	if( mReleasePlayer==true && mReleasedPlayer==true ){
		WK7PLAYERCONTROL->RestoreArchive();
		while( true == WK7PLAYERCONTROL->IsLoading() ){
			GHMGCTASK_RETSYS();
		}
		WK7PLAYERCONTROL->SetVisible(mReleasedPlayerVisible);
	}
	
	if( mpReleasedStage !=NULL ){
		WK7PathNurbs	*pPath;
		int				tipReverse = WK7CAMPATHFOLLOWINFO->GetTipReverseProc();
		WK7Stage::SetCurrentStage(mpReleasedStage);
		mpReleasedStage     ->SetRenderFlag(mReleasedStageVisible);
		WK7PLAYERPATHCONTROL->SetControlPath(mpReleasedStage->GetPath());
		pPath = mpReleasedStage->GetPathNurbs(mPlayerPathName);
		WK7Stage::SetCurrentPath(pPath,mPlayerPathParam,mPlayerPathDir);
		pPath = mpReleasedStage->GetPathNurbs(mCameraPathName);
		WK7CAM->SetControlPath(mpReleasedStage->GetPath());
		WK7CAM->SetCurrentPath(pPath,mCameraPathParam,mCameraPathDir);
		DefaultPathChangeProcess();
		WK7CAMPATHFOLLOWINFO->SetTipReverseProc(tipReverse);
	}
	
	mpReleasedStage = NULL;
	mReleasedStage  = false;
	mReleaseStage   = false;
	mReleasePlayer  = false;
	mReleasedPlayer = false;
}

bool WK7Stage::IsRestoredStageArchive(void)
{
	return mReleasedStage==true? false : true;
}

u32 WK7Stage::GetReleasedStageID(void)
{
	if( mpReleasedStage==NULL ){
		return 0xffffffff;
	}
	return mpReleasedStage->GetID();
}

void WK7Stage::PlayEventTask(WK7PlayEventInfo &info)
{
	u32			playno = info.mEventNo & K7EV_ID_MASK;
	
//	return;
	
	if( WK7Play::HasPlayed(playno)==true ){
		return;
	}
	
	WK7PlayTable	*pPlayTable = WK7Play::GetTable(playno);
	if( pPlayTable!=NULL ){
		if( !(pPlayTable->mPlayChara & (1<<WK7PLAYERCONTROL->GetMainID())) ){
			return;
		}
	}
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	K7SCR_PLAY_INIT   ();
	K7SCR_PLAY_START_B(playno);
	K7SCR_PLAY_TERM   ();
	
	PlayEventTaskTerm(info);
}

void WK7Stage::PlayEventTask(ghmGcTask *)
{
	WK7PlayEventInfo			info;
	WK7PathBranchPointObjJObj	*pSelectObj;
	info.Initialize();
	if( (pSelectObj = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0))==NULL ){
		return;
	}
	info.SetSelectObj(pSelectObj);
	info.mEventNo = pSelectObj->GetEventNo();
	PlayEventTask(info);
}

void WK7Stage::PlayEventTaskTerm(WK7PlayEventInfo &info)
{
	info.SetSelectObjEnable(false);
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
//	GHMGCTASK_EXIT();
}

const char		*pPrefixList[] = {
	"zanpos_",
	"zantama_",
	NULL,
};
WK7JObj* WK7Stage::GetZanLocator(u32 eventNo)
{
	WK7JObj		*pZanRoot = GetJObj("zan");
	if( pZanRoot==NULL ){
		return false;
	}
	WK7JObj		*pLocator;
	char		name[16];
	const char	*pLocatorName;
	int			prefixIndex;
//	eventNo &= K7EV_ID_MASK;
	switch( eventNo & K7EV_TYPE_MASK ){
	case	K7EV_TYPE_ZAN:  prefixIndex = 0; break;
	case	K7EV_TYPE_TAMA: prefixIndex = 1; break;
	default:
		return false;
	}
	sprintf(name,"%s%06x",pPrefixList[prefixIndex],eventNo & K7EV_ID_MASK);
	for(pLocator=pZanRoot->GetChild() ; pLocator!=NULL ; pLocator=pLocator->GetNext()){
		if( (pLocatorName = pLocator->GetName())==NULL ){
			continue;
		}
		if( strstr(pLocatorName,name)==pLocatorName ){
			return pLocator;
		}
	}
	return NULL;
}

u32 WK7Stage::GetLocatorEventNo(WK7JObj *pLocator)
{
	if( pLocator==NULL ){
		return 0xffffffff;
	}
	const char	*pLocatorName = pLocator->GetName();
	if( pLocatorName==NULL ){
		return 0xffffffff;
	}
	const char		**ppPrefix;
	int				prefixID = 0;
	for(ppPrefix=pPrefixList ; *ppPrefix!=NULL ; ppPrefix++,prefixID++){
		if( strstr(pLocatorName,*ppPrefix)==pLocatorName ){
			break;
		}
	}
	if( *ppPrefix==NULL ){
		return 0xffffffff;
	}
	int		i;
	u32		eventNo = 0;
	pLocatorName += strlen(*ppPrefix);
	for(i=0 ; i<6 ; i++,pLocatorName++){
		if( *pLocatorName < '0' || *pLocatorName > '9' ){
			return false;
		}
		eventNo <<= 4;
		eventNo  |= (u32)(*pLocatorName - '0');
	}
	switch( prefixID ){
	case	0: eventNo |= K7EV_TYPE_ZAN;  break;
	case	1: eventNo |= K7EV_TYPE_TAMA; break;
	default:
		return false;
	}
	return eventNo;
}

bool WK7Stage::GetZanChara(WK7JObj *pLocator,u32 &charaid,u32 &motid)
{
	if( pLocator==NULL ){
		return false;
	}
	const char	*pLocatorName = pLocator->GetName();
	if( pLocatorName==NULL ){
		return false;
	}
	const char		**ppPrefix;
	for(ppPrefix=pPrefixList ; *ppPrefix!=NULL ; ppPrefix++){
		if( strstr(pLocatorName,*ppPrefix)==pLocatorName ){
			break;
		}
	}
	if( *ppPrefix==NULL ){
		return false;
	}
	pLocatorName += strlen(*ppPrefix) + 6;
	if( pLocatorName[0]!='_' ){
		return false;
	}
	int		suffixid;
	switch( pLocatorName[4] ){
	case	'M':
	case	'm':
		suffixid = 5;
		break;
	case	'_':
		switch( pLocatorName[5] ){
		case	'M':
		case	'm':
			suffixid = 6;
			break;
		default:
			return false;
		}
		break;
	default:
		return false;
	}
	char		typeName[4];
	memcpy(typeName,pLocatorName+1,3);
	typeName[3] = '\0';
	strupr(typeName);
	u32		mainid;
	if( (mainid = WK7Chara::GetMainID(typeName))==0xffffffff ){
		return false;
	}
	u32		suffix = 0;
	int		i;
	pLocatorName += suffixid;
	for(i=0 ; i<2 ; i++){
		if( pLocatorName[i] < '0' || pLocatorName[i] > '9' ){
			return false;
		}
		suffix *= 10;
		suffix += (pLocatorName[i] - '0');
	}
	charaid = K7CHRID(mainid,suffix);

/////////////////////////////////////////////////////////////////
// eXgpEEEv폜
//	if( charaid==K7CHRID(K7ZA2,0) ){
//		charaid = K7CHRID(K7ZA2,1);
//	}
/////////////////////////////////////////////////////////////////

	if( pLocatorName[2]=='_' ){
		pLocatorName+=3;
		motid = 0;
		for(i=0 ; i<4 ; i++){
			if( pLocatorName[i] < '0' || pLocatorName[i] > '9' ){
				motid = 0xffffffff;
				return false;
			}
			motid *= 10;
			motid += (pLocatorName[i] - '0');
		}
		motid = K7MOTID(mainid,motid);
	}else{
		motid = 0xffffffff;
	}
	return true;
}

bool WK7Stage::SetZanEventInfo(u32 eventNo)
{
	Vec							pos,rot;
	WK7JObj						*pZan;
	
	rot.x = 
	rot.y = 
	rot.z = 0.0f;
	if( (pZan = GetZanLocator(eventNo))!=NULL ){
		pZan->GetPosition(pos);
		pZan->GetRotation(rot);
	}else{
		WK7PLAYERCONTROL->GetPosition(&pos);
	}
	
	WK7StageZan		*pStageZan;
	u32				chrid = 0xffffffff;
	
	if( (pStageZan = GetZan(eventNo))!=NULL ){
		chrid = pStageZan->GetCharaID();
	}
	
	GameInfo.SetZanPos    (pos);
	GameInfo.SetZanRot    (rot);
	GameInfo.SetZanID     (eventNo & K7EV_ID_MASK);
	GameInfo.SetZanCharaID(chrid);
	
	return true;
}

void WK7Stage::ZanEventTask(WK7ZanEventInfo &info)
{
	WK7EventItemTable			*pTable     = WK7EventItem::FindTable(info.mEventNo);
	
	if( pTable!=NULL ){
		if( WK7EventItem::HasItem(info.mEventNo)==true && info.GetSelectObj()==NULL ){
			return;
		}
	}
	
#ifdef	_DEBUG
	char						str[32];
	u32							itemno = info.mEventNo & 0x00ffffff;
	if( pTable==NULL ){
		sprintf(str,"ZAN_%06x undefined",itemno);
		K7SCR_DEBUGPRINT(str);
	}
#endif
	
	Vec							pos,rot;
	WK7JObj						*pZan;
	WK7PathBranchPointObjJObj	*pSelectObj;
	WK7PathBranchPoint			*pBranchPoint;
	
	rot.x = 
	rot.y = 
	rot.z = 0.0f;
	if( info.mpStage!=NULL && (pZan = info.mpStage->GetZanLocator(info.mEventNo))!=NULL ){
		pZan->GetPosition(pos);
		pZan->GetRotation(rot);
	}else if( (pSelectObj=info.GetSelectObj())!=NULL ){
		WK7JObj						*pJObj        = pSelectObj->GetJObj();
		WK7PathBranchPoint			*pBranchPoint = pSelectObj->GetBranchPoint();
		if( pJObj==NULL || pBranchPoint==NULL ){
			WK7PLAYERCONTROL->GetPosition(&pos);
		}else{
			Vec		bpos;
			pJObj       ->GetPosition(&pos );
			pBranchPoint->GetPosition(&bpos);
			pos.y = bpos.y;
		}
	}else if( (pBranchPoint=info.GetBranchPoint())!=NULL ){
		pBranchPoint->GetPosition(&pos);
	}else{
		WK7PLAYERCONTROL->GetPosition(&pos);
	}
	
	WK7StageZan		*pStageZan;
	u32				chrid = 0xffffffff;
	
	if( info.mpStage!=NULL && (pStageZan = info.mpStage->GetZan(info.mEventNo))!=NULL ){
		chrid = pStageZan->GetCharaID();
	}
	
	GameInfo.SetZanPos    (pos);
	GameInfo.SetZanRot    (rot);
	GameInfo.SetZanID     (info.mEventNo & K7EV_ID_MASK);
	GameInfo.SetZanCharaID(chrid);
	GameInfo.SetMode      (WK7GameInfo::ZAN);
//	GameInfo.SetZanMesID(1);
	
//	GameInfo.SetZanCharaLoadCancel(true);
//	GameInfo.SetZanInitWait(true);
//	while( GameInfo.GetZanState()!=WK7GameInfo::ZANSTATE_INITWAIT ){
//		K7SCR_RETSYS();
//	}
//	K7SCR_TIMEWAIT(4800);
//	GameInfo.SetZanInitWait(false);
//	
//	GameInfo.SetZanTermWait(true);
//	while( GameInfo.GetZanState()!=WK7GameInfo::ZANSTATE_TERMWAIT ){
//		K7SCR_RETSYS();
//	}
//	K7SCR_TIMEWAIT(4800);
//	GameInfo.SetZanTermWait(false);
//	
//	while( GameInfo.GetMode()==WK7GameInfo::ZAN ){
	while( GameInfo.GetZanState() <  WK7GameInfo::ZANSTATE_TERMWAIT &&
	       GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY  ){
		K7SCR_RETSYS();
	}
	
	switch( K7CHR_MAINID(chrid) ){
	case	K7ZA7:
	case	K7ZA2:
		break;
	default:
		WK7EventItem::SetItem(info.mEventNo,true);
		if( pStageZan!=NULL ){
			pStageZan->InitIwazaru();
		}
		break;
	}
	
	while( GameInfo.GetZanState()!=WK7GameInfo::ZANSTATE_STANDBY ){
		K7SCR_RETSYS();
	}
	
	switch( K7CHR_MAINID(chrid) ){
	case	K7ZA2:
		WK7EventItem::SetItem(info.mEventNo,true);
		if( pStageZan!=NULL ){
			pStageZan->InitIwazaru();
		}
		break;
	default:
		break;
	}
	
	ZanEventTaskTerm(info);
}

void WK7Stage::ZanEventTaskTerm(WK7ZanEventInfo &info)
{
	if( WK7EventItem::HasItem(info.mEventNo)==true && info.GetSelectObj()!=NULL ){
		WK7StageZan		*pStageZan;
		if( info.mpStage!=NULL && (pStageZan = info.mpStage->GetZan(info.mEventNo))!=NULL ){
			switch( K7CHR_MAINID(pStageZan->GetCharaID()) ){
			case	K7ZA2:
				if( pStageZan->GetCharaID()==K7CHRID(K7ZA2,1) ){
					WK7StageZanColChipInfo	*pZanColChipInfo = WK7StageZan::GetZanColChipInfo(info.mEventNo);
					if( pZanColChipInfo!=NULL && pZanColChipInfo->mFlagID >= 0 ){
						K7SCR_SET_SCENARIO_FLAG(pZanColChipInfo->mFlagID);
					}
				}
				if( pStageZan->GetForcedDisp()==false ){
					pStageZan->SetEnable(false);
					info.SetSelectObjEnable(false);
				}else{
					pStageZan->SetEnable(true);
					info.SetSelectObjEnable(true );
				}
				break;
			case	K7ZA1:
			case	K7ZA3:
			case	K7ZA4:
			case	K7ZA5:
			case	K7ZA6:
			case	K7ZA7:
//			case	K7ZAA:
				break;
			default:
				pStageZan->SetEnable(false);
				info.SetSelectObjEnable(false);
				break;
			}
		}
	}
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
//	GHMGCTASK_EXIT();
}

void WK7Stage::TamaEventTask(WK7TamaEventInfo &info)
{
	WK7EventItemTable			*pTable = WK7EventItem::FindTable(info.mEventNo);
	WK7JObj						*pJObj  = info.GetSelectObj()->GetJObj();
	u32							tamaid  = info.mEventNo & K7EV_ID_MASK;
	
	if( pTable!=NULL ){
		WK7EventItem::SetItem(info.mEventNo,true);
	}
#ifdef	_DEBUG
	char						str[32];
	u32							itemno = info.mEventNo & 0x00ffffff;
	if( pTable==NULL ){
		sprintf(str,"TAMA_%06x undefined",itemno);
		K7SCR_DEBUGPRINT(str);
	}
#endif
	
	if( pJObj != NULL ){
		pJObj->Hide(false,true);
	}
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	WK7StageTamaInfo		*pInfo;
	for(pInfo=stageTamaInfo ; pInfo->mTamaID!=0xffffffff ; pInfo++){
		if( pInfo->mTamaID==tamaid ){
			WK7CAM->SetPosition      (pInfo->mCamPos);
			WK7CAM->SetTargetPosition(pInfo->mCamTgt);
			break;
		}
	}
	
	WK7EventEffect	*pEventEffect;
	while( (pEventEffect=WK7EVENTCONTROLLER->CallItemGet(K7SCR_SYSMES_GETTAMA,true,15,SFX_SYS_GET_BULLET))==NULL ){
		K7SCR_RETSYS();
	}
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
	K7SCR_EVCONDCHANGE();
	while( WK7EVENTCONTROLLER->IsValidEffect(pEventEffect)==true ){
		K7SCR_RETSYS();
	}
//	K7SCR_SYS_ITEMGET_IS_B(K7SCR_SYSMES_GETTAMA,15,SFX_SYS_GET_BULLET);
//	K7SCR_SYS_MESSAGE_S_B(K7SCR_SYSMES_GETTAMA,SFX_SYS_GET_BULLET);
//	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETTAMA);
	
	TamaEventTaskTerm(info);
}

void WK7Stage::TamaEventTaskTerm(WK7TamaEventInfo &info)
{
	if( WK7EventItem::HasItem(info.mEventNo)==true ){
		info.SetSelectObjEnable(false);
	}
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	K7SCR_EVCONDCHANGE();
//	GHMGCTASK_EXIT();
}

bool WK7Stage::Clear(void)
{
	mDisableInitializeSelectFlag = false;
	mpCurrentStage      = NULL;
	mCurrentStageID     = 0xffffffff;
//	WK7Stage::ClearChangeChara();
	if( GameInfo.GetContinue()==false ){
		WK7Stage::SetPrevStageBpName   (NULL);
		WK7Stage::SetPrevStagePathName (NULL);
		WK7Stage::SetCurrentStageBpName(NULL);
		ClearHarmanRoomFlag();
		ClearHarmanTvFlag();
		mPrevStageID        = 0xffffffff;
		SetPrevStagePathName(NULL);
		SetPrevStageBpName  (NULL);
//		K7Stage121M00::Clear();
	}
	return true;
}

#ifdef	_DEBUG
bool WK7Stage::SetPlaceInfoWaring(WK7StagePlaceInfo *pPlaceInfo,const char *pPlaceName)
{
	if(  pPlaceInfo!=NULL &&
	    (pPlaceInfo->mCamPos.x!=pPlaceInfo->mCamTgt.x ||
	     pPlaceInfo->mCamPos.y!=pPlaceInfo->mCamTgt.y ||
	     pPlaceInfo->mCamPos.z!=pPlaceInfo->mCamTgt.z) ){
		mPlaceInfoTick  = 0;
		return false;
	}
	if( pPlaceName==NULL ){
		pPlaceName = "???";
	}
	strncpy(mPlaceName,pPlaceName,WK7PATH_SHORTPATHNAME_MAX-1);
	mPlaceInfoProc  = 0;
	mPlaceInfoCount = 0;
	mPlaceInfoTick  = (int)WK7_SEC_TO_TICK(10);
	return true;
}
bool WK7Stage::RenderPlaceInfoWaring(void)
{
	if( mPlaceInfoTick < WK7_TICK_PER_FRAME ){
		mPlaceInfoTick = 0;
		return false;
	}
	mPlaceInfoTick -= WK7_TICK_PER_FRAME;
	if( mPlaceInfoCount < WK7_TICK_PER_FRAME ){
		mPlaceInfoCount = WK7_SEC_TO_TICK(0.25f);
		mPlaceInfoProc ^= 1;
	}else{
		mPlaceInfoCount -= WK7_TICK_PER_FRAME;
	}
	if( mPlaceInfoProc ){
		C_Paper		paper(64,240);
		PRINTF("Warning : PlaceInfo Not Found !! ... %s\n",mPlaceName);
	}
	return true;
}
#endif

WK7Stage::WK7Stage(ghmGcListObj *pAnchor,int prio) : WK7RenderObj(pAnchor,prio)
{
	int		i;
#ifdef	_DEBUG
	SetPlaceInfoWaring(NULL,NULL);
	mPlaceInfoTick     = 0;
#endif
	mpTamaEffect       = NULL;
	mCollisionIndex    = -1;
	mpStageInfo        = NULL;
	mMultiNum          = 0;
	mMultiID           = 0;
	mMapID             = -1;
	mMapNum            = 0;
	mSelectPathID      = -1;
	mSelectPathNum     = 0;
	mSelectObjID       = -1;
	mSelectObjNum      = 0;
	mHarmanRoomID      = -1;
	mHarmanRoomNum     = 0;
	mDefaultFootSE     = WK7PATH_FOOTSE_DEFAULT;
	mStageEnemyMax     = MAX_STAGE_ENEMY;
	mpPath             = NULL;
	mpPathModel        = NULL;
	mpPathArchive      = NULL;
	mpCameraMotion     = NULL;
	mpLightMotion      = NULL;
//	mpAreaInfo         = NULL;
//	mpAreaInfoFile     = NULL;
	mFlag              = 0;
	mEdgeShadowVisible = 1;
	mpShadowLight      = NULL;
	mMessageHandle     = -1;
	mpNameFile         = NULL;
	mpNameData         = NULL;
	mpOneShotCamera    = NULL;
	mpBrokenWallInfo   = NULL;
	mpConstraintSky    = NULL;
	for(i=0 ; i<WK7STAGE_KUINUM ; i++){
		mpKui[i] = NULL;
	}
#if FUJITA
	mTrigonPtrs.clear();
	mBorderPtrs.clear();
#endif
}

WK7Stage::~WK7Stage()
{
	int		i;
	mpConstraintSky    = NULL;
	for(i=0 ; i<WK7STAGE_KUINUM ; i++){
		GHM_SAFE_DELETE(mpKui[i]);
	}
	if( mMessageHandle >= 0 ){
		ReleaseMessagePack((s8)mMessageHandle);
		mMessageHandle = -1;
	}
	ReleaseNameData();
	GHM_SAFE_DELETE   (mpNameFile);
	GHMGCMEM_SAFE_FREE(mpNameData);
	GHM_SAFE_DELETE   (mpCameraMotion);
	GHM_SAFE_DELETE   (mpLightMotion );
//	if( WK7EVENTCONTROLLER!=NULL && mType==K7OBJTYPE_STG ){
//		K7EventDescStgTerm	*pDesc;
//		K7EventDescData		data;
//		data.Initialize();
//		while( (pDesc=(K7EventDescStgTerm *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGTERM,data))!=NULL ){
//			if( pDesc->mStgID==mID ){
//				WK7EVENTCONTROLLER->CallIM(&pDesc->mBase,mID);
//			}
//		}
//		// IR[obN^XNN
//		CallTerminateCallBackTask();
//	}
	if( mType==K7OBJTYPE_STG ){
		// JgXe[Wꍇ̓|C^𖳌
		if( mpCurrentStage==this ){
//			WK7PathInfo		*pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
//			mPrevStageID = mCurrentStageID;
//			if( pPathInfo!=NULL ){
//				mPrevStagePathParam = pPathInfo->GetParam();
//				mPrevStagePathDir   = pPathInfo->GetDir  ();
//				SetPrevStagePathName(pPathInfo->GetPathName());
//			}else{
//				mPrevStagePathParam = 0.0f;
//				mPrevStagePathDir   = 0;
//				SetPrevStagePathName(NULL);
//			}
			mpCurrentStage  = NULL;
			mCurrentStageID = 0xffffffff;
			WK7SHADOW->SetLight(NULL);
		}
	}
	if( mpPath!=NULL ){
		WK7PlayerControl	*pPlayerControl = WK7PLAYERCONTROL;
		if( pPlayerControl!=NULL ){
			WK7PathControl	*pPathContorl = pPlayerControl->GetPathControl();
			if( pPathContorl->GetControlPath()==mpPath ){
				pPathContorl->SetControlPath(NULL);
				WK7CAM->SetControlPath(NULL);
			}
		}
		delete mpPath;
		mpPath = NULL;
	}
	GHM_SAFE_DELETE(mpPathModel);
	mpPathArchive = NULL;
	// ֘A郉Cg폜
//	WK7Light::Release(mType,mID);
	if( mType==K7OBJTYPE_STG ){
//		::DeleteEffectAll();			// RcXV
//		::DeleteEffectAll_2() ;
		DeleteEffectAll();
		WK7PLAYERCONTROL->StageReset();
		WK7Npc::ReleaseStageNpcAll(mID);
	}
	// ԉ
	ReleaseHanaAll();
	// RW
	ReleaseCollision();
//	GHM_SAFE_DELETE   (mpAreaInfoFile);
//	GHMGCMEM_SAFE_FREE(mpAreaInfo);
	
	if( WK7CAMPATHFOLLOWINFO->GetBpCamInfo()!=NULL ){
		WK7CAMPATHFOLLOWINFO->SetBpCamInfo(NULL);
	}
	
}

bool WK7Stage::CreateCollision(int index)
{
	ReleaseCollision();
	WK7JObj		*pJObj;
	//OCollisionƌP[^[ȉΏہB
	if( mpModel==NULL ){
		return false;
	}
	char		collName[32] = "Collision";
	if( index < 0 ){
		index = mCollisionIndex;
	}
	if( index > 0 ){
		sprintf(collName,"Collision%d",index);
	}else{
		strcpy(collName,"Collision");
	}
	if( (pJObj=mpModel->GetObjLC(collName))==NULL ){
		return false;
	}
	WK7JObj	*pChild;
	if( (pChild=pJObj->GetChild())==NULL ){
		return false;
	}
	//PObjKw瓖|SB
	C_ExtractTrigonArray( pChild->GetJObj(), mTrigonPtrs );
	//GbW𒊏oB
	for(u32 i=0 ; i<mTrigonPtrs.size(); i++ ){
		ghmGcMemSetAllocName("C_Border");
		C_Border *border = new C_Border( *mTrigonPtrs[i] );
		mBorderPtrs.push_back( border );
	}
	return true;
}

bool WK7Stage::ReleaseCollision(void)
{
	for( u32 i=0; i<mTrigonPtrs.size(); i++ ){
	  delete mTrigonPtrs[i];
	}
	mTrigonPtrs.clear();
	for( u32 i=0; i<mBorderPtrs.size(); i++ ){
	  delete mBorderPtrs[i];
	}
	mBorderPtrs.clear();
	return true;
}

int WK7Stage::HideCollision(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return 0;
	}
	const char		*pName = pJObj->GetName();
	int				count = 0;
	char			name[32];
	if( pName!=NULL ){
		int		i;
		for(i=0 ; i<sizeof(name)-1 ; i++){
			if( pName[i]=='\0' ){
				break;
			}
			if( pName[i] >= 'A' && pName[i] <= 'Z' ){
				name[i] = (char)(pName[i] + ('a' - 'A'));
			}else{
				name[i] = pName[i];
			}
		}
		name[i] = '\0';
		if( strstr(name,"collision")==name ){
			pJObj->Hide(false,true);
			count++;
			return count;
		}
	}
	for(pJObj=pJObj->GetChild() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
		count += HideCollision(pJObj);
	}
	return count;
}

int WK7Stage::HideCollision(void)
{
	WK7JObj		*pJObj;
	if( mpModel==NULL ){
		return 0;
	}
	int	count = 0;
	for(pJObj=mpModel->GetTopObj() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
		count += HideCollision(pJObj);
	}
	return count;
}

bool WK7Stage::_Terminate(void)
{
	ReleaseZan();
	ReleaseFootSeArea();
	
	ReleaseDeadBodySign();
	
	if( WK7EVENTCONTROLLER!=NULL && mType==K7OBJTYPE_STG ){
		K7EventDescStgTerm	*pDesc;
		K7EventDescData		data;
		data.Initialize();
		while( (pDesc=(K7EventDescStgTerm *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGTERM,data))!=NULL ){
			if( pDesc->mStgID==mID ){
				WK7EVENTCONTROLLER->CallIM(&pDesc->mBase,mID);
			}
		}
		// IR[obN^XNN
		CallTerminateCallBackTask();
	}
	return true;
}

bool WK7Stage::DeleteStageAll(void)
{
	WK7RenderObj	*pRenderObj,*pNext;
	for(pRenderObj=WK7RenderObj::GetTopObj() ; pRenderObj!=NULL ; pRenderObj=pNext){
		pNext = pRenderObj->GetNext();
		if( pRenderObj->GetType()!=K7OBJTYPE_STG ){
			continue;
		}
		DeleteStage((WK7Stage *)pRenderObj);
		if( WK7RenderObj::IsValid(pNext)==false ){
			pNext = WK7RenderObj::GetTopObj();
		}
	}
	return true;
}

bool WK7Stage::DeleteStage(WK7Stage *pStage)
{
	if( pStage==NULL ){
		return false;
	}
	pStage->_Terminate();
	delete pStage;
	return true;
}

K7StageKihanKui::K7StageKihanKui(WK7JObj *pJObj,K7StageKihanKuiTable *pTable)
{
	mpJObj  = pJObj;
	mpTable = pTable;
}

bool WK7Stage::CreateKui(K7StageKihanKuiTable *pTable)
{
	if( pTable==NULL ){
		return false;
	}
	int				i;
	char			objname[16];
	WK7JObj			*pJObj;
	K7StageKihanKui	*pKui;
	for(i=0 ; i<WK7STAGE_KUINUM && pTable->mNo!=0xffffffff ; pTable++){
		sprintf(objname,"hs%d",pTable->mNo);
		if( (pJObj = GetJObj(objname))==NULL ){
			continue;
		}
		ghmGcMemSetAllocName("STKUI");
		if( (pKui=new K7StageKihanKui(pJObj,pTable))==NULL ){
			continue;
		}
		SetHitObj(pJObj,pTable->mNo);
		GHM_SAFE_DELETE(mpKui[i]);
		mpKui[i] = pKui;
		i++;
	}
	return true;
}

K7StageKihanKui* WK7Stage::GetKui(u32 no)
{
	int			i;
	for(i=0 ; i<WK7STAGE_KUINUM ; i++){
		if( mpKui[i]==NULL ){
			continue;
		}
		if( mpKui[i]->GetNo()==no ){
			return mpKui[i];
		}
	}
	return NULL;
}

bool WK7Stage::KihanGateIsOpened(void)
{
	int			i;
	for(i=0 ; i<WK7STAGE_KUINUM ; i++){
		if( mpKui[i]==NULL ){
			continue;
		}
		if( K7SCR_EVISUSEDITEM(mpKui[i]->GetTamaNo())==FALSE ){
			return false;
		}
	}
	return true;
}

bool WK7Stage::ChangeKihanKuiState(void)
{
	WK7JObj				*pJObj;
	int					i;
	for(i=0 ; i<WK7STAGE_KUINUM ; i++){
		if( mpKui[i]==NULL || (pJObj = mpKui[i]->GetJObj())==NULL ){
			continue;
		}
		if( K7SCR_EVISUSEDITEM(mpKui[i]->GetTamaNo())==TRUE ){
			pJObj->Hide(false,true);
		}else{
			pJObj->Disp(false,true);
		}
	}
	return true;
}

bool WK7Stage::KihanKuiEvent(WK7HitObjInfo &info)
{
	K7StageKihanKui		*pKui = GetKui(info.mEventNo);
	if( pKui==NULL ){
		return false;
	}
	if( K7SCR_EVHASITEM(pKui->GetTamaNo())==FALSE ){
		return true;
	}
	if( K7SCR_EVISUSEDITEM(pKui->GetTamaNo())==TRUE ){
		return true;
	}
	
	Vec		campos,camtgt;
	
	KK7BattleMainTask::BattleMainTaskExit(2);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
		K7SCR_RETSYS();
	}
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	K7SCR_EVUSEITEM(pKui->GetTamaNo(),true);
	
	ChangeKihanKuiState();
	
	pKui->GetCamPos(campos);
	pKui->GetCamTgt(camtgt);
	
	if( campos.x==camtgt.x && campos.y==camtgt.y && campos.z==camtgt.z ){
		WK7JObj		*pJObj = pKui->GetJObj();
		pJObj->GetPosition(&camtgt);
		campos.x =  0.0f;
		campos.y =  0.0f;
		campos.z = 10.0f;
		MTXMultVec(pJObj->GetLocalWorldMatrix(),&campos,&campos);
	}
	
	WK7CAM->SetMode          (WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (campos);
	WK7CAM->SetTargetPosition(camtgt);
	
	K7SCR_PC_SETVISIBLE    (false);
	K7SCR_SYS_MESSAGE_B    (K7SCR_SYSMES_GETKEY);
//	K7SCR_SYS_MESSAGE_B    (K7SCR_SYSMES_BREAK_KUI);
//	K7SCR_SYS_MESSAGE_S_B  (K7SCR_SYSMES_BREAK_KUI,SFX_SYS_FREE_KIHANMON);
	
	K7SCR_PC_RETURNVISIBLE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return false;
}

K7StageBrokenWallInfo* WK7Stage::GetWallInfo(u32 eventNo)
{
	if( mpBrokenWallInfo==NULL ){
		return NULL;
	}
	K7StageBrokenWallInfo	*pWallInfo = mpBrokenWallInfo;
	while( pWallInfo->mEventNo!=0xffffffff ){
		if( pWallInfo->mEventNo==eventNo ){
			return pWallInfo;
		}
		pWallInfo++;
	}
	return NULL;
}

bool WK7Stage::ChangeBrokenWallState(void)
{
	if( mpBrokenWallInfo==NULL ){
		return true;
	}
	WK7JObj					*pJObj;
	K7StageBrokenWallInfo	*pWallInfo = mpBrokenWallInfo;
	while( pWallInfo->mEventNo!=0xffffffff ){
		pJObj = GetJObj(pWallInfo->mpWallName);
		if( K7SCR_GET_SCENARIO_FLAG(pWallInfo->mFlagID)==true ){
			K7SCR_JOBJ_HIDE(pJObj);
			K7SCR_STG_SET_PATHENABLE(pWallInfo->mpPathName,true );
		}else{
			K7SCR_JOBJ_DISP(pJObj);
			K7SCR_STG_SET_PATHENABLE(pWallInfo->mpPathName,false);
		}
		pWallInfo++;
	}
	return true;
}

bool WK7Stage::BrokeWallEvent(WK7HitObjInfo &info)
{
	if( WK7PLAYERCONTROL->GetMainID()!=K7MSK ){
		info.SetHitObjEnable(true);
//		if( info.mpHitObj!=NULL ){
//			info.mpHitObj->SetEnable(true);
//		}
		return false;
	}
	
	K7StageBrokenWallInfo	*pWallInfo = GetWallInfo(info.mEventNo);
	if( pWallInfo==NULL ){
		return false;
	}
	
	KK7BattleMainTask::BattleMainTaskExit(2);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
		K7SCR_RETSYS();
	}
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE(false);
	
	WK7JObj		*pJObj;
	pJObj = GetJObj(pWallInfo->mpWallName);
	K7SCR_JOBJ_HIDE         (pJObj);
	K7SCR_SET_SCENARIO_FLAG (pWallInfo->mFlagID);
	K7SCR_STG_SET_PATHENABLE(pWallInfo->mpPathName,true);
	CallCondChange();
	
	if( pWallInfo->mCamID >= 0 ){
		FixCam((u32)pWallInfo->mCamID);
	}
	
	K7SCR_TIMEWAIT( K7SCR_MSK_WALL_BEFORE_TICK );
	gpSound->mPlaySE( SFX_SYS_TRUE );
	K7SCR_TIMEWAIT( K7SCR_MSK_WALL_AFTER_TICK );
	
//	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_BREAK_WALL);
	
	K7SCR_PC_RETURNVISIBLE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}

bool WK7Stage::DeleteEffectAll(void)
{
	EFFECT		*pEffect,*pNext;
	
	for(pEffect=EffSys.FirstEffect ; pEffect!=NULL ; pEffect=pNext){
		pNext = pEffect->Next;
		// ̗̓GtFNgƃft@CGtFNg͍폜Ȃ
		switch( pEffect->Type ){
		case	EFF_VITAL:
		case	EFF_MODELFIRE:
		case	EFF_BILLBOARD:
		case	EFF_BLOODPACK:
		case	EFF_CHARGE:
			continue;
		default:
			break;
		}
		if( WK7RenderObj::FindEffectAll(pEffect)!=NULL ){
			continue;
		}
		DeleteEffect(pEffect);
	}
	
	return true;
}

u32 WK7Stage::GetMainID(void)
{
	return K7STG_MAINID(mID);
}

u32 WK7Stage::GetSuffix(void)
{
	return K7STG_SUFFIX(mID);
}

bool WK7Stage::GetFileName(char *pFileName,u32 id)
{
	u32		mainid = K7STG_MAINID(id);
	u32		suffix = K7STG_SUFFIX(id);
	OSDebugReportExp(mainid > 1000,"Stage Main ID Over 1000 : %d\n" ,mainid);
	OSDebugReportExp(suffix > 100 ,"Stage Suffix ID Over 100 : %d\n",suffix);
	sprintf(pFileName,WK7_3DDATA_FOLDER WK7_MODEL_FOLDER WK7_STAGE_FOLDER  "%03d/Stage%03d_M%02d.dat",mainid,mainid,suffix);
	return true;
}

bool WK7Stage::GetPathFileName(char *pFileName,u32 id)
{
	u32		mainid = K7STG_MAINID(id);
	u32		suffix = K7STG_SUFFIX(id);
	OSDebugReportExp(mainid > 1000,"Stage Main ID Over 1000 : %d\n" ,mainid);
	OSDebugReportExp(suffix > 100 ,"Stage Suffix ID Over 100 : %d\n",suffix);
	sprintf(pFileName,WK7_3DDATA_FOLDER WK7_MODEL_FOLDER WK7_STAGE_FOLDER  "%03d/Stage%03d_P%02d.dat",mainid,mainid,suffix);
	return true;
}

u32 WK7Stage::GetEventNo(const char *pName)
{
	if( pName==NULL ){
		return 0xffffffff;
	}
	u32						eventID = 0xffffffff;
	u32						eventNo;
	K7EventDescStgHitObj	*pDesc = NULL;
	// ŏ̕񔻒
	if( strstr(pName,"event")==pName ){
		eventNo = K7EV_TYPE_NO;
	}else if( strstr(pName,"door")==pName ){
		eventNo = K7EV_TYPE_DOOR;
//	}else if( strstr(pName,"hana")==pName ){
//		eventNo = K7EV_TYPE_HANA;
	}else{
		return 0xffffffff;
	}
	if( (pName = GetTokenPointer(pName,'_'))==NULL ){
		return 0xffffffff;
	}
	pName++;
	// ÛPUi
	char		*pEventNo = NULL;
	int			no;
	pName = GetPartialStr(pEventNo,pName,'_');
	if( pEventNo==NULL ){
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return 0xffffffff;
	}
	switch( sscanf(pEventNo,"%x",&no) ){
	case	EOF:
	case	0:
		GHM_SAFE_DELETE_ARRAY(pEventNo);
		return 0xffffffff;
	default:
		eventNo |= (u32)(no & ~K7EV_TYPE_MASK);
		break;
	}
	GHM_SAFE_DELETE_ARRAY(pEventNo);
	return eventNo;
}

u32 WK7Stage::GetEventNo(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return 0xffffffff;
	}
	return GetEventNo(pJObj->GetName());
}

bool WK7Stage::InitializeBranchPointEvent(void)
{
	if( mpPath==NULL || WK7EVENTCONTROLLER==NULL ){
		return true;
	}
	
	// _BCxg
//	K7EventDescStgBpArrive					*pDescBpArrive;
	K7EventDescStgBpLeave					*pDescBpLeave;
	K7EventDescData							data;
	WK7PathBranchPoint						*pBranchPoint;
	K7EventDescStgBpArriveEventNo			*pDescBpArriveEventNo;
	K7EventDescStgBpLeaveEventNo			*pDescBpLeaveEventNo;
	K7EventDescStgBpLeaveEventNoPathName	*pDescBpLeaveEventNoPathName;
//	WK7EventIDTable							*pEventIDTable;
	
//	data.Initialize();
//	while( (pDescBpArrive=(K7EventDescStgBpArrive *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPARRIVE,data))!=NULL ){
//		if( pDescBpArrive->mStgID!=mID ){
//			continue;
//		}
//		pBranchPoint = mpPath->GetBranchPoint(pDescBpArrive->mpBpName);
//		if( pBranchPoint==NULL ){
//			OSDebugReportExp(pBranchPoint==NULL,"Stage BranchPoint Not Found : %s\n",pDescBpArrive->mpBpName);
//			continue;
//		}
//		pBranchPoint->CreateArriveEvent(pDescBpArrive->mBase.GetID());
//	}
	
	data.Initialize();
	while( (pDescBpLeave=(K7EventDescStgBpLeave *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPLEAVE,data))!=NULL ){
		if( pDescBpLeave->mStgID!=mID ){
			continue;
		}
		pBranchPoint = mpPath->GetBranchPoint(pDescBpLeave->mpBpName);
		if( pBranchPoint==NULL ){
			OSDebugReportExp(pBranchPoint==NULL,"Stage BranchPoint Not Found : %s\n",pDescBpLeave->mpBpName);
			continue;
		}
		pBranchPoint->CreateLeaveEvent(pDescBpLeave->mBase.GetID());
	}
	
	data.Initialize();
	while( (pDescBpArriveEventNo=(K7EventDescStgBpArriveEventNo *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPARRIVEEVNO,data))!=NULL ){
		pBranchPoint = NULL;
		while( (pBranchPoint = mpPath->GetBranchPoint_EventNo(pDescBpArriveEventNo->mEventNo,pBranchPoint))!=NULL ){
			pBranchPoint->CreateArriveEventNo(pDescBpArriveEventNo->mBase.GetID(),
			                                  pDescBpArriveEventNo->mEventNo);
		}
	}
	
	data.Initialize();
	while( (pDescBpLeaveEventNo=(K7EventDescStgBpLeaveEventNo *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPLEAVEEVNO,data))!=NULL ){
		pBranchPoint = NULL;
		while( (pBranchPoint = mpPath->GetBranchPoint_EventNo(pDescBpLeaveEventNo->mEventNo,pBranchPoint))!=NULL ){
			pBranchPoint->CreateLeaveEventNo(pDescBpLeaveEventNo->mBase.GetID(),
			                                 pDescBpLeaveEventNo->mEventNo,
			                                 pDescBpLeaveEventNo->mPathNo);
		}
	}
	
	data.Initialize();
	while( (pDescBpLeaveEventNoPathName=(K7EventDescStgBpLeaveEventNoPathName *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPLEAVEEVNOPN,data))!=NULL ){
		pBranchPoint = NULL;
		while( (pBranchPoint = mpPath->GetBranchPoint_EventNo(pDescBpLeaveEventNoPathName->mEventNo,pBranchPoint))!=NULL ){
			pBranchPoint->CreateLeaveEventNo(pDescBpLeaveEventNoPathName->mBase.GetID(),
			                                 pDescBpLeaveEventNoPathName->mEventNo,
			                                 pDescBpLeaveEventNoPathName->mpPathName);
		}
	}
	
	for(pBranchPoint=mpPath->GetBranchPointTop() ; pBranchPoint!=NULL ; pBranchPoint=pBranchPoint->GetNext()){
		InitializeBpDefEvent(pBranchPoint);
	}
	
	return true;
}

bool WK7Stage::InitializeBpDefEvent(WK7PathBranchPoint *pBranchPoint)
{
	K7EventDescData						data;
	const char							*pBranchPointName;
	WK7PathBranchPointEventArrive		*pArriveEvent;
	
	if( (pBranchPointName = pBranchPoint->GetName())==NULL ){
		return false;
	}
	
	data.Initialize();
	if( WK7EVENTCONTROLLER->GetBranchPointEventDesc(pBranchPointName,data)==NULL ){
		// _CxgݒɂȂĂȂ
		if( strstr(pBranchPointName,WK7STAGE_STGBPARRIVE_DEFMOVE_PREFIX)==pBranchPointName ){
			K7EventDescStgBpArriveDefMove	*pDescDefMove;
			data.Initialize();
			if( (pDescDefMove=(K7EventDescStgBpArriveDefMove *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPARRIVE_DEFMOVE,data))!=NULL ){
				pArriveEvent = pBranchPoint->CreateArriveEvent(pDescDefMove->GetID());
			}
		}
//		if( GameInfo.GetScenarioID()!=K7SCN98 && strstr(pBranchPointName,WK7STAGE_STGBPARRIVE_DEFPLAY_PREFIX)==pBranchPointName ){
//			K7EventDescStgBpArriveDefPlay	*pDescDefPlay;
//			data.Initialize();
//			if( (pDescDefPlay=(K7EventDescStgBpArriveDefPlay *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPARRIVE_DEFPLAY,data))!=NULL ){
//				pArriveEvent = pBranchPoint->CreateArriveEvent(pDescDefPlay->GetID());
//				pBranchPoint->SetAutoPlay(true);
//			}
//		}
	}
	
	return true;
}

bool WK7Stage::InitializeBurnEffect(void)
{
#if 0
	WK7JObj		*pJObj;
	if( mpModel==NULL || (pJObj = mpModel->GetObj("burn"))==NULL ){;
		return true;
	}
	for(pJObj=pJObj->GetChild() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
static	u8		type = 5;
		CreateEffectModelFire(pJObj,type,NULL,0.0f);
	}
#endif
	return true;
}

bool WK7Stage::FindShadowLight(void)
{
	WK7Light			*pLight;
	WK7LightFindData	data;
	HSD_LObj			*pLObj;
	mpShadowLight = NULL;
	data.Initialize(mType,mID);
	while( (pLight=WK7Light::Find(data))!=NULL ){
		pLObj = pLight->GetHSDLObj();
		if( HSD_LObjGetFlags(pLObj) & LOBJ_HIDDEN ){
			continue;
		}
		switch( HSD_LObjGetType(pLObj) ){
		case	LOBJ_INFINITE:
			mpShadowLight = pLight;
			break;
		case	LOBJ_POINT:
		case	LOBJ_SPOT:
			if( mpShadowLight!=NULL ){
				break;
			}
			mpShadowLight = pLight;
			continue;
		case	LOBJ_AMBIENT:
		default:
			continue;
		}
		break;
	}
	return true;
}

bool WK7Stage::InitializeFlagCount(void)
{
	WK7Path::ClearFlagID();
	if( mpStageInfo==NULL ){
		OSDebugReport("Stage%03d_M%02d - StageInfo Not Found !!\n",K7STG_MAINID(mID),K7STG_SUFFIX(mID));
		return false;
	}
	WK7StageInfo	*pInfo;
	s16				startSelectPathID = 0;
	mMapID        = 0;
	mSelectPathID = 0;
	mSelectObjID  = 0;
	mHarmanRoomID = 0;
	for(pInfo=stageList ; pInfo->mID!=0xffffffff ; pInfo++){
		if( pInfo->mScenarioID >= 0 && pInfo->mScenarioID != GameInfo.GetScenarioID() ){
			continue;
		}
		if( pInfo->mID==mID ){
			mMapNum   = pInfo->mMapNum;
			mMultiNum = pInfo->mMultiNum;
			break;
		}
		int		multi = pInfo->mMultiNum;
		if( multi<=0 ){
			multi = 1;
		}
		mSelectObjID  += multi * pInfo->mSelectObjNum;
		mSelectPathID += multi * pInfo->mSelectPathNum;
		mHarmanRoomID += multi * pInfo->mHarmanRoomNum;
		mMapID        += multi * pInfo->mMapNum;
	}
	if( pInfo->mID==0xffffffff ){
		mSelectObjID  = -1;
		mSelectPathID = -1;
		mHarmanRoomID = -1;
		mMapID        = -1;
		return false;
	}
	return true;
}

bool WK7Stage::Initialize(void)
{
	WK7JObj		*pJObj,*pChild;
	
	mpStageInfo = GetStageInfo(mID);
	InitializeFlagCount();
	
	// eIuWFNg
	if( mpModel!=NULL && (pJObj=mpModel->GetObj("floor"))!=NULL && (pChild=pJObj->GetChild())!=NULL ){
		WK7SHADOW->AddReceiveShadowObj(pChild);
		
		CreateDeadBodySign();
#if 0
		Mtx		mtx;
		Vec		boxSize;
		
		MTXIdentity (mtx);
		boxSize.x = 1.0f;
		boxSize.y = 1.0f;
		boxSize.z = 1.0f;
		
		GHM_SAFE_DELETE(mpDeadBodySign);
		mpDeadBodySign = new WK7DeadBodySign(&mDeadBodySingAnchor,pJObj,mtx,boxSize);
		
		pJObj->Hide();
#endif
		
	}
	
	mpCameraMotion = mpArchive->CreateCameraMotion();
	mpLightMotion  = mpArchive->CreateLightMotion ();
	
//	WK7Path::ClearFlagID();
	
	// pX
	InitializePath();
	
	// _Cxg
	InitializeBranchPointEvent();
	
//	if( mpAreaInfo!=NULL ){
//		mpAreaInfo->Initialize();
//	}
	
//	CreateEdge();
	
	InitializeLight();
	
	if( WK7RenderObj::Initialize()==false ){
		return false;
	}
	
	switch( mType ){
	case	K7OBJTYPE_STG:
		// RWݒ
		HideCollision();
		CreateCollision();
		// R|SI
		InitializeBurnEffect();
		// Abvf[g𔼓IuWFNgɑ΂Ė
		SetAlphaUpdate(false,JOBJ_XLU);
		// ogRg[AXe[WI
		BattleCtrl.InitStage();
		// mob
		InitializeNpc();
		// epCg擾
		FindShadowLight();
		// cvO
//		InitializeZan();
		break;
	case	K7OBJTYPE_PLAY:
		// epCg擾
		FindShadowLight();
	default:
		return true;
	}
	
	// KXIuWFNg
	InitializeGlassObj();
	
	// IuWFNg
	InitializeConstraintSky();
	
	// 蔻IuWFNg
	InitializeHitObj();
	
	// ԏ
	InitializeHana();
	
	// n[}\
	InitializeHarmanRoom();
	
//	WK7Path::InvalidFlagID();
	
//	GHM_SAFE_DELETE(mpAreaInfoFile);
	
	return true;
}

const char* WK7Stage::GetStageID(const char *pStageStr,u32 &id)
{
	if( pStageStr==NULL ){
		return NULL;
	}
	
	if( strstr(pStageStr,WK7STAGE_TVSTAGE_PREFIX)==pStageStr ){
		id = WK7STAGE_TVSTAGEID;
		pStageStr += strlen(WK7STAGE_TVSTAGE_PREFIX);
		return pStageStr;
	}
	if( strstr(pStageStr,WK7STAGE_GMSTAGE_PREFIX)==pStageStr ){
		id = WK7STAGE_GMSTAGEID;
		pStageStr += strlen(WK7STAGE_GMSTAGE_PREFIX);
		return pStageStr;
	}
	
	char				dstMainID[4];
	char				dstSuffix[3];
	u32					mainID,suffix;
	int					i;
	
	memset(dstMainID,0,sizeof(dstMainID));
	memset(dstSuffix,0,sizeof(dstSuffix));
	
	for(i=0 ; i<3 ; i++,pStageStr++){
		if( *pStageStr < '0' || *pStageStr > '9' ){
			return NULL;
		}
		dstMainID[i] = *pStageStr;
	}
	switch( *pStageStr ){
	case	'm':
	case	'M':
		break;
	case	'_':
		switch( pStageStr[1] ){
		case	'm':
		case	'M':
			pStageStr++;
			break;
		default:
			return NULL;
		}
		break;
	default:
		return NULL;
	}
	pStageStr++;
	for(i=0 ; i<2 ; i++,pStageStr++){
		if( *pStageStr < '0' || *pStageStr > '9' ){
			return NULL;
		}
		dstSuffix[i] = *pStageStr;
	}
	
	mainID = (u32)atoi(dstMainID);
	suffix = (u32)atoi(dstSuffix);
	id     = K7STGID(mainID,suffix);
	
	return pStageStr;
}

u32 WK7Stage::GetStageID(const char *pStageStr)
{
	u32		id;
	if( GetStageID(pStageStr,id)==NULL ){
		return K7STGID_INVALID;
	}
	return id;
}

bool WK7Stage::GetSelectObjName(WK7JObj *pJObj,char **ppobjname)
{
	const char	*pName;
	int			len;
	
	pName = pJObj->GetNameAttr();
	if( pName==NULL ){
		pName = "=== nameless ===";
//		pName = pJObj->GetName();
	}
	if( pName!=NULL ){
		pName = GetPartialStr2(ppobjname[0],pName,'|');
		if( pName!=NULL && (len=(int)strlen(pName)) > 1 ){
			pName++;
		}else{
static	const char		*pSpace = " ";
			len   = (int)strlen(pSpace);
			pName = pSpace;
		}
		ghmGcMemSetAllocName("GetSelON");
		if( (ppobjname[1] = new char[len+1])!=NULL ){
			strcpy(ppobjname[1],pName);
		}
	}
	
	return true;
}

bool WK7Stage::InitializePath(void)
{
	// pXf[^
	if( mpArchive==NULL ){
		return false;
	}
	if( mpPathArchive!=NULL ){
		GHM_SAFE_DELETE(mpPath);
		if( (mpPath = mpPathArchive->CreatePath(mID))==NULL ){
			return false;
		}
		mpPath->SetContainer(this);
		return true;
	}
	GHM_SAFE_DELETE(mpPath);
	if( (mpPath = mpArchive->CreatePath(mID))==NULL ){
		return false;
	}
	mpPath->SetContainer(this);
	return true;
}

u32	WK7Stage::mDefBranchMoveEventID = 0xffffffff;
u32	WK7Stage::mDefTvEventID         = 0xffffffff;
u32	WK7Stage::mDefLtvEventID        = 0xffffffff;
u32	WK7Stage::mDefDoorEventID       = 0xffffffff;
u32	WK7Stage::mDefKeyEventID        = 0xffffffff;
u32	WK7Stage::mDefMapEventID        = 0xffffffff;
u32	WK7Stage::mDefMemoEventID       = 0xffffffff;
bool WK7Stage::InitDefEvent(void)
{
	K7EventDescData					data;
	K7EventDescStgBpArriveDefMove2	*pDescDefMove;
//	K7EventDescStgBpTv				*pDescTv;
//	K7EventDescStgBpLtv				*pDescLtv;
//	K7EventDescStgBpArriveDoor		*pDescDoor;
//	K7EventDescStgBpMap				*pDescMap;
//	K7EventDescStgBpKey				*pDescKey;
//	K7EventDescStgBpMemo			*pDescMemo;
	data.Initialize();
	if( (pDescDefMove=(K7EventDescStgBpArriveDefMove2 *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPARRIVE_DEFMOVE2,data))!=NULL ){
		mDefBranchMoveEventID = pDescDefMove->GetID();
	}else{
		mDefBranchMoveEventID = 0xffffffff;
	}
//	data.Initialize();
//	if( (pDescTv=(K7EventDescStgBpTv *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPTV,data))!=NULL ){
//		mDefTvEventID = pDescTv->GetID();
//	}else{
//		mDefTvEventID = 0xffffffff;
//	}
	
//	data.Initialize();
//	if( (pDescLtv=(K7EventDescStgBpLtv *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPLTV,data))!=NULL ){
//		mDefLtvEventID = pDescLtv->GetID();
//	}else{
//		mDefLtvEventID = 0xffffffff;
//	}
	
//	data.Initialize();
//	if( (pDescDoor=(K7EventDescStgBpArriveDoor *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPARRIVE_DOOR,data))!=NULL ){
//		mDefDoorEventID = pDescDoor->GetID();
//	}else{
		mDefDoorEventID = 0xffffffff;
//	}
	
	mDefMapEventID = 0xffffffff;
//	data.Initialize();
//	while( (pDescMap=(K7EventDescStgBpMap *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPMAP,data))!=NULL ){
//		if( pDescMap->mEventNo==0xffffffff ){
//			mDefMapEventID = pDescMap->mBase.GetID();
//			break;
//		}
//	}
	
	mDefKeyEventID = 0xffffffff;
//	data.Initialize();
//	while( (pDescKey=(K7EventDescStgBpKey *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPKEY,data))!=NULL ){
//		if( pDescKey->mEventNo==0xffffffff ){
//			mDefKeyEventID = pDescKey->mBase.GetID();
//			break;
//		}
//	}
	
	mDefMemoEventID = 0xffffffff;
//	data.Initialize();
//	while( (pDescMemo=(K7EventDescStgBpMemo *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPMEMO,data))!=NULL ){
//		if( pDescMemo->mEventNo==0xffffffff ){
//			mDefMemoEventID = pDescMemo->mBase.GetID();
//			break;
//		}
//	}
	return true;
}

bool WK7Stage::AddBranchPointEvent(WK7JObj *pJObj)
{
	if( mpPath==NULL || WK7EVENTCONTROLLER==NULL ){
		return false;
	}
	
	WK7PathBranchPoint				*pBranchPoint;
	const char						*pBranchPointName;
	WK7PathBranchPointObjJObj		*pObj;
	WK7JObj							*pSelectJObj;
	WK7StageBpEvent					*pBpEvent;
	char							*pobjname[2] = { NULL,NULL };
	
	const char				*pJObjName;
	if( (pJObjName=pJObj->GetName())==NULL || strlen(pJObjName)==0 ){
		return NULL;
	}
	
	for(pBranchPoint=mpPath->GetBranchPointTop() ; pBranchPoint!=NULL ; pBranchPoint=pBranchPoint->GetNext()){
		
		if( (pBranchPointName = pBranchPoint->GetName())==NULL ){
			continue;
		}
		
		ghmGcMemSetAllocName("BpEvent");
		pBpEvent = new WK7StageBpEvent(pBranchPointName);
		if( pBpEvent==NULL ){
			return false;
		}
		WK7StageBpEventBranch		*pBranch    = pBpEvent->GetBranch   ();
		WK7StageBpEventTv			*pTv        = pBpEvent->GetTv       ();
		WK7StageBpEventLtv			*pLtv       = pBpEvent->GetLtv      ();
		WK7StageBpEventPoint		*pPoint     = pBpEvent->GetPoint    ();
		WK7StageBpEventDoor			*pDoor      = pBpEvent->GetDoor     ();
		WK7StageBpEventMap			*pMap       = pBpEvent->GetMap      ();
		WK7StageBpEventKey			*pKey       = pBpEvent->GetKey      ();
		WK7StageBpEventMemo			*pMemo      = pBpEvent->GetMemo     ();
		WK7StageBpEventVoiceMemo	*pVoiceMemo = pBpEvent->GetVoiceMemo();
		WK7StageBpEventRaku			*pRaku      = pBpEvent->GetRaku     ();
		WK7StageBpEventPlayPoint	*pPlayPoint = pBpEvent->GetPlayPoint();
		WK7StageBpEventZanPoint		*pZanPoint  = pBpEvent->GetZanPoint ();
		WK7StageBpEventTama			*pTama      = pBpEvent->GetTama     ();
		
		if( pBranch!=NULL && mDefBranchMoveEventID!=0xffffffff ){
			
			WK7StageBpEventBranchNextStage	*pStage = pBranch->GetStageTop();
			
			while( pStage!=NULL ){
				
				if( (pSelectJObj = pJObj->GetObj(pStage->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)         )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(mDefBranchMoveEventID);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (true);
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
				pStage = pStage->GetNext();
				
			}
			
		}
		
		if( pTv!=NULL ){//&& mDefTvEventID!=0xffffffff ){
			
			if( (pSelectJObj = pJObj->GetObj(pTv->GetSelectObjName()))!=NULL &&
			    (pObj        = pBranchPoint->GetObj(pSelectJObj)     )==NULL ){
				
				GetSelectObjName(pSelectJObj,pobjname);
				
				pObj = pBranchPoint->AddObjJObj(pSelectJObj);
				pObj->SetEventID(mDefTvEventID);
				pObj->SetEventNo(K7EV_TYPE_TV);
				pObj->SetObjName(0,pobjname[0]);
				pObj->SetObjName(1,pobjname[1]);
				pObj->SetEnable (true);
				
				GHM_SAFE_DELETE_ARRAY(pobjname[0]);
				GHM_SAFE_DELETE_ARRAY(pobjname[1]);
			}
			
		}
		
		if( pLtv!=NULL ){//&& mDefLtvEventID!=0xffffffff ){
			
			if( (pSelectJObj = pJObj->GetObj(pLtv->GetSelectObjName()))!=NULL &&
			    (pObj        = pBranchPoint->GetObj(pSelectJObj)      )==NULL ){
				
				GetSelectObjName(pSelectJObj,pobjname);
				
				pObj = pBranchPoint->AddObjJObj(pSelectJObj);
				pObj->SetEventID(mDefLtvEventID);
				pObj->SetEventNo(K7EV_TYPE_LTV);
				pObj->SetObjName(0,pobjname[0]);
				pObj->SetObjName(1,pobjname[1]);
				pObj->SetEnable (true);
				
				GHM_SAFE_DELETE_ARRAY(pobjname[0]);
				GHM_SAFE_DELETE_ARRAY(pobjname[1]);
				
			}
			
		}
		
		if( pPoint!=NULL ){
			
			WK7StageBpEventPointObj		*pPointObj = pPoint->GetObjTop();
			
			while( pPointObj!=NULL ){
				
				u32						eventNo = pPointObj->GetEventNo();
				u32						eventID = 0xffffffff;
				WK7EventIDTable			*pEventIDTable = WK7Event::FindIDTable(eventNo);
				
				if( pEventIDTable!=NULL ){
					eventID = pEventIDTable->mEventID;
				}
				
				if( (pSelectJObj = pJObj->GetObj(pPointObj->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)           )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(eventID);
					pObj->SetEventNo(eventNo);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (true);
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
				pPointObj = pPointObj->GetNext();
				
			}
			
		}
		
		if( pDoor!=NULL ){
			
			WK7StageBpEventDoorNextStage	*pDStage = pDoor->GetStageTop();
			
			while( pDStage!=NULL ){
				
				if( (pSelectJObj = pJObj->GetObj(pDStage->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)         )==NULL ){
					
					u32								eventNo = pDStage->GetEventNo();
					u32								eventID = 0xffffffff;
					WK7PathBranchPointObjJObjDoor	*pObjDoor;
					WK7EventIDTable					*pEventIDTable = WK7Event::FindIDTable(eventNo);
					if( pEventIDTable!=NULL ){
						eventID = pEventIDTable->mEventID;
					}else{
						eventID = mDefDoorEventID;
					}
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObjDoor = pBranchPoint->AddObjJObjDoor(pSelectJObj);
					pObjDoor->SetEventID(eventID);
					pObjDoor->SetEventNo(eventNo);
					pObjDoor->SetObjName(0,pobjname[0]);
					pObjDoor->SetObjName(1,pobjname[1]);
					pObjDoor->SetEnable (true);
					pObjDoor->SetNextStageID(pDStage->GetStageID());
					pObjDoor->SetNextPoint  (pDStage->GetBpName ());
					pObjDoor->SetParam      (pDStage->GetParam  ());
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
				pDStage = pDStage->GetNext();
				
			}
			
		}
		
		if( pMap!=NULL ){
			
			WK7StageBpEventPointObj		*pMapObj = pMap->GetObjTop();
			
			while( pMapObj!=NULL ){
				
				u32						eventNo = pMapObj->GetEventNo();
				u32						eventID;
				WK7EventIDTable			*pEventIDTable = WK7Event::FindIDTable(eventNo);
				WK7EventItemTable		*pEventItemTable = WK7EventItem::FindTable(eventNo);
				bool					enable;
				
				if( pEventItemTable!=NULL ){
					if( WK7EventItem::HasItem(eventNo)==true ){
						enable = false;
					}else{
						enable = true;
					}
				}else{
					enable = true;
				}
				
				if( pEventIDTable!=NULL ){
					eventID = pEventIDTable->mEventID;
				}else{
					eventID = mDefMapEventID;
				}
				
				if( (pSelectJObj = pJObj->GetObj(pMapObj->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)         )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(eventID);
					pObj->SetEventNo(eventNo);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (enable);
					
					if( enable==true ){
						pSelectJObj->Disp(false,true);
					}else{
						pSelectJObj->Hide(false,true);
					}
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
				pMapObj = pMapObj->GetNext();
				
			}
			
		}
		
		if( pKey!=NULL ){
			
			WK7StageBpEventPointObj		*pKeyObj = pKey->GetObjTop();
			
			while( pKeyObj!=NULL ){
				
				u32						eventNo = pKeyObj->GetEventNo();
				u32						eventID;
				WK7EventIDTable			*pEventIDTable = WK7Event::FindIDTable(eventNo);
				WK7EventItemTable		*pEventItemTable = WK7EventItem::FindTable(eventNo);
				bool					enable;
				
				if( pEventItemTable!=NULL ){
					if( WK7EventItem::HasItem(eventNo)==true ){
						enable = false;
					}else{
						enable = true;
					}
				}else{
					enable = true;
				}
				
				if( pEventIDTable!=NULL ){
					eventID = pEventIDTable->mEventID;
				}else{
					eventID = mDefKeyEventID;
				}
				
				if( (pSelectJObj = pJObj->GetObj(pKeyObj->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)         )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(eventID);
					pObj->SetEventNo(eventNo);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (enable);
					
					if( enable==true ){
						pSelectJObj->Disp(false,true);
					}else{
						pSelectJObj->Hide(false,true);
					}
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
				pKeyObj = pKeyObj->GetNext();
				
			}
			
		}
		
		if( pMemo!=NULL ){
			
			WK7StageBpEventPointObj		*pMemoObj = pMemo->GetObjTop();
			
			while( pMemoObj!=NULL ){
				
				u32						eventNo = pMemoObj->GetEventNo();
				u32						eventID;
				WK7EventIDTable			*pEventIDTable = WK7Event::FindIDTable(eventNo);
				WK7EventItemTable		*pEventItemTable = WK7EventItem::FindTable(eventNo);
				bool					enable;
				
				if( pEventItemTable!=NULL ){
					if( WK7EventItem::HasItem(eventNo)==true ){
						enable = false;
					}else{
						enable = true;
					}
				}else{
					enable = true;
				}
				
				if( pEventIDTable!=NULL ){
					eventID = pEventIDTable->mEventID;
				}else{
					eventID = mDefMemoEventID;
				}
				
				if( (pSelectJObj = pJObj->GetObj(pMemoObj->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)         )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(eventID);
					pObj->SetEventNo(eventNo);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (enable);
					
					if( enable==true ){
						pSelectJObj->Disp(false,true);
					}else{
						pSelectJObj->Hide(false,true);
					}
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
				pMemoObj = pMemoObj->GetNext();
				
			}
			
		}
		
		if( pVoiceMemo!=NULL ){
			
			WK7StageBpEventPointObj		*pVoiceMemoObj = pVoiceMemo->GetObjTop();
			
			while( pVoiceMemoObj!=NULL ){
				
				u32						eventNo = pVoiceMemoObj->GetEventNo();
				
				if( (pSelectJObj = pJObj->GetObj(pVoiceMemoObj->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)         )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(0xffffffff);
					pObj->SetEventNo(eventNo);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (true);
					
					pSelectJObj->Disp(false,true);
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
				pVoiceMemoObj = pVoiceMemoObj->GetNext();
				
			}
			
		}
		
		if( pRaku!=NULL ){
			
			WK7StageBpEventPointObj		*pRakuObj;
			
			for(pRakuObj=pRaku->GetObjTop() ; pRakuObj!=NULL ; pRakuObj=pRakuObj->GetNext()){
				
				u32		eventNo = pRakuObj->GetEventNo();
				
				if( (pSelectJObj = pJObj->GetObj(pRakuObj->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)         )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(0xffffffff);
					pObj->SetEventNo(eventNo);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (true);
					
					pSelectJObj->Disp(false,true);
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
			}
			
		}
		
		if( pTama!=NULL ){
			
			WK7StageBpEventPointObj		*pTamaObj;
			
			for(pTamaObj=pTama->GetObjTop() ; pTamaObj!=NULL ; pTamaObj=pTamaObj->GetNext()){
				
				u32						eventNo = pTamaObj->GetEventNo();
				WK7EventItemTable		*pEventItemTable = WK7EventItem::FindTable(eventNo);
				bool					enable;
				
				if( pEventItemTable!=NULL ){
					if( WK7EventItem::HasItem(eventNo)==true ){
						enable = false;
					}else{
						enable = true;
					}
				}else{
					enable = true;
				}
				
				if( (pSelectJObj = pJObj->GetObj(pTamaObj->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)         )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(0xffffffff);
					pObj->SetEventNo(eventNo);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (enable);
					
					pSelectJObj->Disp(false,true);
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
			}
			
		}
		
		if( pPlayPoint != NULL ){
			
			WK7StageBpEventPlay		*pPlay;
			
			for(pPlay=pPlayPoint->GetPlayTop() ; pPlay!=NULL ; pPlay=pPlay->GetNext()){
				
				u32		eventNo = pPlay->GetEventNo();
				
				if( WK7Play::HasPlayed(eventNo)==true ){
					continue;
				}
				
				if( pPlay->GetSelectObjName()==NULL ){
					continue;
				}
				
				if( (pSelectJObj = pJObj->GetObj(pPlay->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)       )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(0xffffffff);
					pObj->SetEventNo(eventNo);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (true);
					
					pSelectJObj->Disp(false,true);
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
			}
			
		}
		
		if( pZanPoint != NULL ){
			
			WK7StageBpEventZan		*pZan;
			
			for(pZan=pZanPoint->GetZanTop() ; pZan!=NULL ; pZan=pZan->GetNext()){
				
				u32						eventNo = pZan->GetEventNo();
//				WK7EventItemTable		*pEventItemTable = WK7EventItem::FindTable(eventNo);
				bool					enable;
				WK7StageZanInfo			*pInfo = GetZanInfo(eventNo);
				WK7JObj					*pLocator;
				
				enable = true;
				if( WK7EventItem::HasItem(eventNo)==true && (pLocator = GetZanLocator(eventNo))!=NULL ){
					u32		charaid,motid;
					if( GetZanChara(pLocator,charaid,motid)==true ){
						switch( K7CHR_MAINID(charaid) ){
						case	K7ZA1:
						case	K7ZA3:
						case	K7ZA4:
						case	K7ZA5:
						case	K7ZA6:
						case	K7ZA7:
//						case	K7ZAA:
							break;
						default:
//						case	K7ZA2:
//						case	K7ZA8:
//						case	K7ZA9:
//						case	K7ZAB:
							enable = false;
							break;
						}
					}
				}
				
				if( pZan->GetSelectObjName()==NULL ){
					continue;
				}
				
				if( (pSelectJObj = pJObj->GetObj(pZan->GetSelectObjName()))!=NULL &&
				    (pObj        = pBranchPoint->GetObj(pSelectJObj)       )==NULL ){
					
					GetSelectObjName(pSelectJObj,pobjname);
					
					pObj = pBranchPoint->AddObjJObj(pSelectJObj);
					pObj->SetEventID(0xffffffff);
					pObj->SetEventNo(eventNo);
					pObj->SetObjName(0,pobjname[0]);
					pObj->SetObjName(1,pobjname[1]);
					pObj->SetEnable (enable);
					
					pSelectJObj->Disp(false,true);
					
					GHM_SAFE_DELETE_ARRAY(pobjname[0]);
					GHM_SAFE_DELETE_ARRAY(pobjname[1]);
					
				}
				
			}
			
		}
		
		GHM_SAFE_DELETE(pBpEvent);
		
	}
	
	return true;
}

WK7JObj* WK7Stage::GetSelectObjTop(void)
{
	if( mpPath==NULL ){
		return NULL;
	}
	WK7JObj		*pJObj;
	if( mpPathArchive==NULL ){
		if( mpModel!=NULL && (pJObj=mpModel->GetObjLC("Window"))!=NULL ){
			return pJObj;
		}
	}else{
		if( mpPathModel!=NULL && (pJObj=mpPathModel->GetObjLC("Window"))!=NULL ){
			return pJObj;
		}
	}
	return NULL;
}

bool WK7Stage::InitializeSelectObj(void)
{
	if( mType!=K7OBJTYPE_STG ){
		return true;
	}
	if( mpPath==NULL ){
		return false;
	}
	
	WK7JObj		*pJObj;
	if( (pJObj=GetSelectObjTop())==NULL ){
		return true;
	}
	AddBranchPointEvent(pJObj);
	return true;
}

WK7PathBranchPoint* WK7Stage::GetPathBranchPoint(const char *pBpName)
{
	if( pBpName==NULL || mpPath==NULL ){
		return NULL;
	}
	return mpPath->GetBranchPoint(pBpName);
}

bool WK7Stage::CreateEdge(void)
{
#if 0
	WK7Light			*pLight;
	WK7LightFindData	data;
	data.Initialize(mType,mID);
	while( (pLight=WK7Light::Find(data))!=NULL ){
		if( pLight->GetLightType()==LOBJ_POINT ){
			mpEdgeShadowLight = pLight;
			break;
		}
	}
	// VhE{[
	if( mpEdgeShadowLight != NULL ){
		C_LObj		*pLObj = mpEdgeShadowLight->GetLObj();
		C_Vec		pos;
		pos = pLObj->GetPosition();
		ghmGcMemSetAllocName("C_EdgeSh");
		mpEdgeShadow = new C_EdgeShadow(pos,254,10000.0f);
//		mpEdgeShadow = new C_EdgeShadow(pos,128,10000.0f);
	}
	HSD_Joint	**ppJoint = (HSD_Joint **)mpArchive->GetPublicAddress("castsShadows");
	if( ppJoint!=NULL ){
		WK7JObj	*pObj;
		while( *ppJoint!=NULL ){
			if( (pObj = mpModel->GetObj(*ppJoint))!=NULL && pObj->IsHidden()==false ){
				C_EdgeArray	*pEdge;
				pObj->CreateEdge();
				pEdge = pObj->GetEdge();
				if( mpEdgeShadow!=NULL && pEdge!=NULL ){
					mpEdgeShadow->Add(*pEdge);
				}
			}
			ppJoint++;
		}
	}
#endif
	return true;
}

bool WK7Stage::LoadingProcess(void)
{
	if( mpArchive==NULL ){
		return false;
	}
	if( mpArchive->GetState()!=WK7Archive::WK7ARCHIVE_LOADED ){
		return false;
	}
	if( IsOwnMotionObjLoaded()==false ){
		return false;
	}
	if( IsOwnRenderObjLoaded()==false ){
		return false;
	}
	if( IsLoadedMessage()==false ){
		return false;
	}
//	if( IsLoadedAreaInfo()==false ){
//		return false;
//	}
	if( IsLoadingNpc()==true ){
		return false;
	}
	if( IsLoadingHana()==true ){
		return false;
	}
//	if( IsLoadingZan()==true ){
//		return false;
//	}
	if( (mpModel = mpArchive->CreateModel())==NULL ){
		return false;
	}
//	Initialize();
	return true;
}

void* WK7Stage::InitializeThread(void)
{
	if( mpModel!=NULL ){
		mpModel->MakeBound();
	}
	if( mClothEnable==true ){
		SetClothEnable(true);
	}
	CreateFootSeArea();
	return NULL;
}

bool WK7Stage::LoadAfterInit(void)
{
	ghmGcMemSetAllocName("STLAITH");
	if( (mpInitThread = new ghmGcThread(_InitializeThread,(u32)this,18,WK7RENDEROBJ_INITTHREAD_STACKSIZE))==NULL ){
		return false;
	}
	mpInitThread->Resume();
	return true;
}

bool WK7Stage::IsLoadingAfterInit(void)
{
	if( mpInitThread!=NULL && mpInitThread->IsTerminated()==false ){
		return true;
	}
	GHM_SAFE_DELETE(mpInitThread);
	Initialize();
	return false;
}

bool WK7Stage::SetVisibleTamaJObj(u32 eventNo,bool flag,bool equal)
{
	if( flag==true ){
		return DispTamaJObj(eventNo,equal);
	}else{
		return HideTamaJObj(eventNo,equal);
	}
}

bool WK7Stage::DispTamaJObj(u32 eventNo,bool equal)
{
	WK7JObj	*pJObj = GetTamaJObj(eventNo,equal);
	if( pJObj==NULL ){
		return false;
	}
	pJObj->Disp(false,true);
	return true;
}

bool WK7Stage::HideTamaJObj(u32 eventNo,bool equal)
{
	WK7JObj	*pJObj = GetTamaJObj(eventNo,equal);
	if( pJObj==NULL ){
		return false;
	}
	pJObj->Hide(false,true);
	return true;
}

WK7JObj* WK7Stage::GetTamaJObj(u32 eventNo,bool equal)
{
	char	name[16];
	WK7JObj	*pJObj;
	sprintf(name,"tama_%06x",eventNo & K7EV_ID_MASK);
	if( (pJObj=GetJObj(name))!=NULL ){
		return pJObj;
	}
	if( equal==true ){
		return NULL;
	}
	WK7JObj	*pTamaLocator = GetJObj("tama");
	if( pTamaLocator==NULL ){
		return NULL;
	}
	return GetJObjPartialName(name);
}

WK7JObj* WK7Stage::GetSelectJObj_EventNo(u32 eventno)
{
	if( mpPath==NULL ){
		return NULL;
	}
	WK7PathBranchPointObjJObj	*pBranchPointObjJObj = mpPath->GetObj_EventNo(eventno);
	if( pBranchPointObjJObj==NULL ){
		return NULL;
	}
	return pBranchPointObjJObj->GetJObj();
}

WK7JObj* WK7Stage::GetJObj(const char *pName)
{
	WK7JObj	*pJObj;
	if( mpModel!=NULL ){
		if( pName==NULL ){
			return mpModel->GetTopObj();
		}
		if( (pJObj=mpModel->GetObj(pName))!=NULL ){
			return pJObj;
		}
	}
	if( mpPathModel!=NULL ){
		if( pName==NULL ){
			return mpPathModel->GetTopObj();
		}
		if( (pJObj=mpPathModel->GetObj(pName))!=NULL ){
			return pJObj;
		}
	}
	return NULL;
}

WK7JObj* WK7Stage::GetJObjPartialName(const char *pName)
{
	if( pName==NULL ){
		return NULL;
	}
	WK7JObj	*pJObj;
	if( mpModel!=NULL ){
		if( (pJObj=mpModel->GetObjPartialName2(pName))!=NULL ){
			return pJObj;
		}
	}
	if( mpPathModel!=NULL ){
		if( (pJObj=mpPathModel->GetObjPartialName2(pName))!=NULL ){
			return pJObj;
		}
	}
	return NULL;
}

bool WK7Stage::LoadAfterInit2(void)
{
	if( mType!=K7OBJTYPE_STG ){
		return true;
	}
	// pXȂۂɃpXǂݍ
	if( mpPath!=NULL ){
		return true;
	}
	if( (mpPathArchive = WK7Archive::Create())==NULL ){
		return false;
	}
	// t@C擾
	char	filename[WK7_FNAME_MAX];
	GetPathFileName(filename,mID);
	// ACe^Cvɐݒ
	mpPathArchive->SetType(K7OBJTYPE_PATH);
	// hcݒ
	mpPathArchive->SetID  (mID);
	// A[JCu[h
	if( mpPathArchive->LoadArchive(filename)==false ){
		delete mpPathArchive;
		mpPathArchive = NULL;
		return true;
//		return false;
	}
	return true;
}

bool WK7Stage::IsLoadingAfterInit2(void)
{
	// pXȂۂɃpXǂݍ݊҂
	if( mpPathArchive!=NULL ){
		if( mpPathArchive->GetState()!=WK7Archive::WK7ARCHIVE_LOADED ){
			return true;
		}
		
		mpPathModel = mpPathArchive->CreateModel();
		InitializePath();
		InitializeBranchPointEvent();
		InitializeSelectObj();
	}
	return false;
}

bool WK7Stage::LoadAfterInit3(void)
{
	// ŏ̏ɎcvO̓ǂݍ
	CreateZan();
	
	mSelectObjNum  = (s16)WK7Path::GetSelectObjFlagID();
	mSelectPathNum = (s16)WK7Path::GetPassPathFlagID();
	
	WK7Path::InvalidFlagID();
	
	return true;
}

bool WK7Stage::IsLoadingAfterInit3(void)
{
	// ŏ̏ɎcvO̓ǂݍ݊҂
	if( IsLoadingZan()==true ){
		return true;
	}
	InitializeZan();
	
	// ItO
	InitializeSelectFlag();
	
	if( WK7EVENTCONTROLLER!=NULL ){
		K7EventDescStgInit	*pDesc;
		K7EventDescData		data;
		data.Initialize();
		while( (pDesc=(K7EventDescStgInit *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGINIT,data))!=NULL ){
			if( pDesc->mStgID==mID ){
				WK7EVENTCONTROLLER->CallIM(&pDesc->mBase,mID);
			}
		}
		
		// R[obN^XNN
		CallInitializeCallBackTask();
	}
	
	CallStageCondChange(mID);
	
	return false;
}

int WK7Stage::SetSelectObjFlag(u32 eventNo,int index,bool flag)
{
	switch( index ){
	case	0:
	case	1:
		break;
	default:
		index = 1;
		break;
	}
	WK7PathBranchPointObjJObj	*pBranchPointObjJObj = GetBranchPointObj_EventNo(eventNo);
	if( pBranchPointObjJObj==NULL ){
		return 0;
	}
	if( flag==true ){
		pBranchPointObjJObj->Select(index);
	}else{
		pBranchPointObjJObj->ClearSelect(index);
	}
	return true;
}

int WK7Stage::SetSelectObjFlag(u32 nextStageID,const char *pName,int index,bool flag)
{
	WK7StageBpEvent				*pBpEvent = NULL;
	WK7PathBranchPoint			*pBranchPoint;
	const char					*pBranchPointName;
	WK7JObj						*pJObj;
	WK7PathBranchPointObjJObj	*pBranchPointObjJObj;
	int							count = 0;
	WK7JObj						*pSelectObjTop = GetSelectObjTop();
	const char					*pCurrentStageBpName = WK7Stage::GetCurrentStageBpName();
	
	if( pSelectObjTop==NULL ){
		return 0;
	}
	
	switch( index ){
	case	0:
	case	1:
		break;
	default:
		index = 1;
		break;
	}
	
	// _IuWFNg`FbN
	for(pBranchPoint=mpPath->GetBranchPointTop() ; pBranchPoint!=NULL ; pBranchPoint=pBranchPoint->GetNext()){
		if( (pBranchPointName = pBranchPoint->GetName())==NULL ){
			continue;
		}
		ghmGcMemSetAllocName("BpEvent");
		if( (pBpEvent = new WK7StageBpEvent(pBranchPointName))==NULL ){
			continue;
		}
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_PLAYERDEAD)==false && WK7Stage::GetPrevStageID()==WK7STAGE_TVSTAGEID && pCurrentStageBpName!=NULL ){
			if( pBpEvent->GetShortBpName()==NULL || strcmp(pBpEvent->GetShortBpName(),WK7Stage::GetCurrentStageBpName())!=0 ){
				GHM_SAFE_DELETE(pBpEvent);
				continue;
			}
		}
		WK7StageBpEventBranch	*pBranch;
		if( (pBranch=pBpEvent->GetBranch())!=NULL ){
			WK7StageBpEventBranchNextStage	*pBranchNextStage;
			for(pBranchNextStage=pBranch->GetStageTop() ; pBranchNextStage!=NULL ; pBranchNextStage=pBranchNextStage->GetNext()){
				if( pBranchNextStage->GetStageID()!=nextStageID ){
					continue;
				}
				if( pBranchNextStage->GetBpName()==NULL ){
					continue;
				}
				if( pName!=NULL ){
					if( strcmp(pBranchNextStage->GetBpName(),pName)!=0 ){
						continue;
					}
				}
				if( pBranchNextStage->GetSelectObjName()==NULL ){
					continue;
				}
				if( (pJObj=pSelectObjTop->GetObj(pBranchNextStage->GetSelectObjName()))==NULL ){
					continue;
				}
				if( (pBranchPointObjJObj = pBranchPoint->GetObj(pJObj))==NULL ){
					continue;
				}
				if( flag==true ){
					pBranchPointObjJObj->Select(index);
				}else{
					pBranchPointObjJObj->ClearSelect(index);
				}
				count++;
			}
		}
		WK7StageBpEventDoor		*pDoor;
		if( (pDoor=pBpEvent->GetDoor())!=NULL ){
			WK7StageBpEventDoorNextStage	*pDoorNextStage;
			for(pDoorNextStage=pDoor->GetStageTop() ; pDoorNextStage!=NULL ; pDoorNextStage=pDoorNextStage->GetNext()){
				if( pDoorNextStage->GetStageID()!=nextStageID ){
					continue;
				}
				if( pDoorNextStage->GetBpName()==NULL ){
					continue;
				}
				if( pName!=NULL ){
					if( strcmp(pDoorNextStage->GetBpName(),pName)!=0 ){
						continue;
					}
				}
				if( pDoorNextStage->GetSelectObjName()==NULL ){
					continue;
				}
				if( (pJObj=pSelectObjTop->GetObj(pDoorNextStage->GetSelectObjName()))==NULL ){
					continue;
				}
				if( (pBranchPointObjJObj = pBranchPoint->GetObj(pJObj))==NULL ){
					continue;
				}
				if( flag==true ){
					pBranchPointObjJObj->Select(index);
				}else{
					pBranchPointObjJObj->ClearSelect(index);
				}
				count++;
			}
		}
		GHM_SAFE_DELETE(pBpEvent);
	}
	return count;
}

int WK7Stage::SetPassPathFlag(u32 nextStageID,const char *pName,int index,bool flag)
{
	WK7PathNurbs	*pPathNurbs;
	int				count = 0;
	int				lindex;
	bool			pass;
	const char		*pCurrentStageBpName = WK7Stage::GetCurrentStageBpName();
	for(pPathNurbs=mpPath->GetPathTop() ; pPathNurbs!=NULL ; pPathNurbs=pPathNurbs->GetNext()){
		if( pPathNurbs->GetStageJump()==false ){
			continue;
		}
		if( pPathNurbs->GetNextStageID()!=nextStageID ){
			continue;
		}
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_PLAYERDEAD)==false && WK7Stage::GetPrevStageID()==WK7STAGE_TVSTAGEID && pCurrentStageBpName!=NULL ){
			WK7PathBranchPoint	*pBranchPoint;
			if( (pBranchPoint=pPathNurbs->GetStartBranchPoint())==NULL ){
				if( (pBranchPoint=pPathNurbs->GetEndBranchPoint())==NULL ){
					continue;
				}
			}
			if( pBranchPoint->GetShortName()==NULL ){
				continue;
			}
			if( strcmp(pBranchPoint->GetShortName(),pCurrentStageBpName)!=0 ){
				continue;
			}
		}
		if( pPathNurbs->GetNextPoint()==NULL ){
			continue;
		}
		if( pName!=NULL ){
			if( strcmp(pPathNurbs->GetNextPoint(),pName)!=0 ){
				continue;
			}
		}
		switch( index ){
		case	0:
		case	1:
			lindex = index;
			pass   = true;
			break;
		case	2:
		case	3:
			lindex = index-2;
			pass   = false;
			break;
		case	-1:
			pass   = true;
			if( pPathNurbs->GetStartBranchPoint()!=NULL ){
				lindex = 1;
			}else{
				lindex = 0;
			}
			break;
		case	-2:
			pass   = true;
			if( pPathNurbs->GetStartBranchPoint()!=NULL ){
				lindex = 0;
			}else{
				lindex = 1;
			}
			break;
		case	-3:
			pass   = false;
			if( pPathNurbs->GetStartBranchPoint()!=NULL ){
				lindex = 1;
			}else{
				lindex = 0;
			}
			break;
		case	-4:
			pass   = false;
			if( pPathNurbs->GetStartBranchPoint()!=NULL ){
				lindex = 0;
			}else{
				lindex = 1;
			}
			break;
		default:
			continue;
		}
		if( pass==true ){
			if( flag==true ){
				pPathNurbs->Pass(lindex); 
			}else{
				pPathNurbs->ClearPass(lindex); 
			}
		}else{
			if( flag==true ){
				pPathNurbs->Select(lindex); 
			}else{
				pPathNurbs->ClearSelect(lindex); 
			}
		}
		count++;
	}
	return count;
}

bool WK7Stage::InitializeSelectFlag(void)
{
	if( mDisableInitializeSelectFlag==true ){
		mDisableInitializeSelectFlag = false;
		return true;
	}
	
	if( mpPath==NULL ){
		return true;
	}
	
	u32		prevStageID = WK7Stage::GetPrevStageID();
	if( prevStageID==0xffffffff ){
		return true;
	}
	
	const char		*pName;
	if( (pName=WK7Stage::GetPrevStageBpName())==NULL ){
		if( (pName=WK7Stage::GetPrevStagePathName())==NULL ){
			return false;
		}
	}
	
	bool	shortcut = K7Stage578M00::GetKihanShortCutEnable();
	K7Stage578M00::SetKihanShortCutEnable(false);
	
	SetSelectObjFlag(prevStageID,pName);
	SetPassPathFlag (prevStageID,pName);
	if( mID!=WK7STAGE_TVSTAGEID ){
		K7SCR_RESET_GLOBAL_FLAG(K7GLFL_PLAYERDEAD);
	}
	
	K7Stage578M00::SetKihanShortCutEnable(shortcut);
	
	return true;
}

//#include "WK7EffectBreakObj.h"
bool WK7Stage::LoadedProcess(void)
{
//	if( mpConstraintSky != NULL ){
//		Mtx		vmtx,invmtx;
//		Vec		pos;	//,campos;
//		mpConstraintSky->GetWorldPosition(pos);
//		WK7CAM->GetViewingMtxCurrent(vmtx);
//		MTXInverse(vmtx,invmtx);
//		pos.x = invmtx[0][3];
//		pos.z = invmtx[2][3];
//		mpConstraintSky->SetWorldPosition(&pos);
//	}
	if( mpModel!=NULL ){
		mpModel->FrameProcess();
	}
	WK7StageHana	*pHana;
	for(pHana=(WK7StageHana *)mHanaAnchor.GetNext() ; pHana!=NULL ; pHana=pHana->GetNext()){
		pHana->FrameProcess();
	}
//	WK7StageZan		*pZan;
//	mViewVolume.SetCurrent(WK7CAM->GetCObj());
//	for(pZan=(WK7StageZan *)mZanAnchor.GetNext() ; pZan!=NULL ; pZan=pZan->GetNext()){
//		pZan->FrameProcess();
//	}
	if( mpPath!=NULL ){
		mpPath->FrameProcess();
	}
	if( mpCurrentStage==this ){
		if( mpShadowLight==NULL ){
			WK7SHADOW->SetLight(NULL);
		}else{
			HSD_LObj	*pLObj = mpShadowLight->GetHSDLObj();
			WK7SHADOW->SetLight(pLObj);
		}
	}
	FrameProcessCharaName();
#if 0
	if( mpEdgeShadow!=NULL ){
		mpEdgeShadow->Proc();
	}
#endif
#if FUJITA
	for(u32 i=0; i<mTrigonPtrs.size(); i++ ){
		mTrigonPtrs[i]->Proc();
	}
#endif
	
#if 1
#ifndef K7APP_MASTER
	if( HSD_PadGetTrigger(1) & HSD_PAD_DOWN ){
		Vec		pos,dir;
		WK7PLAYERPATHCONTROL->GetCurrentPosition(&pos);
		WK7PLAYERPATHCONTROL->GetCurrentDir     (&dir);
		CreateDeadBodySign(WK7PLAYERCONTROL->GetMainID(),pos,dir);
	}
#endif
#endif
	
	WK7DeadBodySign		*pDeadBodySign;
	for(pDeadBodySign=(WK7DeadBodySign *)mDeadBodySingAnchor.GetNext() ; pDeadBodySign!=NULL ; pDeadBodySign=pDeadBodySign->GetNext()){
		pDeadBodySign->FrameProcess();
	}
	return true;
}

bool WK7Stage::StateProcess(void)
{
	if( WK7RenderObj::StateProcess()==false ){
		return false;
	}
	if( mpConstraintSky != NULL ){
		Mtx		vmtx,invmtx;
		Vec		pos;	//,campos;
		mpConstraintSky->GetWorldPosition(pos);
		WK7CAM->GetViewingMtxCurrent(vmtx);
		MTXInverse(vmtx,invmtx);
		pos.x = invmtx[0][3];
		pos.z = invmtx[2][3];
		mpConstraintSky->SetWorldPosition(&pos);
	}
	WK7StageZan		*pZan;
	mViewVolume.SetCurrent(WK7CAM->GetCObj());
	for(pZan=(WK7StageZan *)mZanAnchor.GetNext() ; pZan!=NULL ; pZan=pZan->GetNext()){
		pZan->FrameProcess();
	}
	return true;
}

bool WK7Stage::ReleaseArchive(void)
{
	if( WK7RenderObj::ReleaseArchive()==false ){
		return false;
	}
	
	ReleaseZan();
	ReleaseFootSeArea();
	
	if( mMessageHandle >= 0 ){
		ReleaseMessagePack((s8)mMessageHandle);
		mMessageHandle = -1;
	}
	ReleaseNameData();
	GHM_SAFE_DELETE   (mpNameFile);
	GHMGCMEM_SAFE_FREE(mpNameData);
//	GHMGCMEM_SAFE_FREE(mpAreaInfo);
	GHM_SAFE_DELETE(mpCameraMotion);
	GHM_SAFE_DELETE(mpLightMotion );
	if( mpPath!=NULL ){
		WK7PlayerControl	*pPlayerControl = WK7PLAYERCONTROL;
		if( pPlayerControl!=NULL ){
			WK7PathControl	*pPathContorl = pPlayerControl->GetPathControl();
			if( pPathContorl->GetControlPath()==mpPath ){
				pPathContorl->SetControlPath(NULL);
				WK7CAM->SetControlPath(NULL);
			}
		}
		delete mpPath;
		mpPath = NULL;
	}
	GHM_SAFE_DELETE(mpPathModel);
	mpPathArchive = NULL;
	// ֘A郉Cg폜
	if( mType==K7OBJTYPE_STG ){
		// JgXe[Wꍇ̓|C^𖳌
		if( mpCurrentStage==this ){
			mpCurrentStage  = NULL;
			mPrevStageID    = mCurrentStageID;
			mCurrentStageID = 0xffffffff;
			WK7SHADOW->SetLight(NULL);
		}
		DeleteEffectAll();
		WK7PLAYERCONTROL->StageReset();
//		WK7Npc::ReleaseStageNpcAll(mID);
	}
	// RW
	ReleaseCollision();
	WK7Npc			*pNpc;
	WK7NpcFindData	finddata;
	finddata.Initialize(mID);
	while( (pNpc=WK7Npc::Find(finddata))!=NULL ){
		pNpc->ReleaseArchive();
	}
	
	// ̉
	ReleaseDeadBodySignAll();
	
	mpConstraintSky = NULL;
	
	return true;
}

bool WK7Stage::RestoreArchive(void)
{
	if( WK7RenderObj::RestoreArchive()==false ){
		return false;
	}
	
	WK7Npc			*pNpc;
	WK7NpcFindData	finddata;
	finddata.Initialize(mID);
	while( (pNpc=WK7Npc::Find(finddata))!=NULL ){
		pNpc->RestoreArchive();
	}
	
//	CreateZan();
	
	return true;
}

bool WK7Stage::ReleaseArchiveProcess(void)
{
	WK7Npc			*pNpc;
	WK7NpcFindData	finddata;
	
	finddata.Initialize(mID);
	while( (pNpc=WK7Npc::Find(finddata))!=NULL ){
		switch( pNpc->GetReleaseState() ){
		case	WK7Npc::RELEASEDARCHIVE:
		case	WK7Npc::IDLE:
			break;
		default:
			return false;
		}
	}
	
	ReleaseHanaAll();
	
	return WK7RenderObj::ReleaseArchiveProcess();
}

bool WK7Stage::RestoreArchiveProcess(void)
{
	WK7Npc			*pNpc;
	WK7NpcFindData	finddata;
	
	finddata.Initialize(mID);
	while( (pNpc=WK7Npc::Find(finddata))!=NULL ){
		switch( pNpc->GetReleaseState() ){
		case	WK7Npc::LOADED:
		case	WK7Npc::IDLE:
			break;
		default:
			return false;
		}
	}
	
	return WK7RenderObj::RestoreArchiveProcess();
}

bool WK7Stage::RenderProcess(void)
{
#ifdef	_DEBUG
	if( mainMenu.GetStageWarning()==true ){
		RenderPlaceInfoWaring();
	}
#endif
#if	!defined(K7APP_MASTER) && !defined(USE_ISDOLVIEWER)
#ifdef	_DEBUG
	if( mainMenu.GetStageWarning()==true ){
		if( mType==K7OBJTYPE_STG && mState==WK7RenderObj::LOADED ){
static	int		px = 16,py = 416;
			if( mpStageInfo==NULL ){
				C_Paper		paper(px,py);
				PRINTF("StageInfo Not Found !!\n");
			}else if( mHarmanRoomNum != mpStageInfo->mHarmanRoomNum || 
			          mSelectObjNum  != mpStageInfo->mSelectObjNum  ||
			          mSelectPathNum != mpStageInfo->mSelectPathNum ){
				switch( mID ){
				case	K7STGID(120,0):
				case	K7STGID(121,1):
					break;
				default:
					C_Paper		paper(px,py);
					PRINTF("StageInfo Error H,O,P (%d,%d,%d)-(%d,%d,%d)\n",mHarmanRoomNum,
					                                                       mSelectObjNum,
					                                                       mSelectPathNum,
					                                                       mpStageInfo->mHarmanRoomNum,
					                                                       mpStageInfo->mSelectObjNum,
					                                                       mpStageInfo->mSelectPathNum);
					break;
				}
			}
		}
	}
#endif
#endif
	if( mRenderFlag==false || (mType==K7OBJTYPE_STG && mRenderStage==false) ){
		return true;
	}
	SETDSENABLE(1);
	if( WK7RenderObj::RenderProcess()==false ){
		SETDSENABLE(0);
		return false;
	}
	SETDSENABLE(0);
	WK7StageHana	*pHana;
	for(pHana=(WK7StageHana *)mHanaAnchor.GetNext() ; pHana!=NULL ; pHana=pHana->GetNext()){
		pHana->RenderProcess();
	}
	if( mpPath!=NULL ){
		mpPath->RenderPath();
	}
#ifdef _DEBUG
#if FUJITA
	if ( mainMenu.IsEneWalkArea()==true ){
		for( u32 i=0; i<mTrigonPtrs.size(); i++ ){
		  mTrigonPtrs[i]->DispAll();
		}
		for( u32 i=0; i<mBorderPtrs.size(); i++ ){
		  mBorderPtrs[i]->DispAll();
		}
	}
#endif
#endif
	return true;
}

bool WK7Stage::ReleaseDeadBodySign(u32 charaid)
{
	WK7DeadBodySign		*pDeadBodySign;
	WK7DeadBodySign		*pNext;
	for(pDeadBodySign=(WK7DeadBodySign *)mDeadBodySingAnchor.GetNext() ; pDeadBodySign!=NULL ; pDeadBodySign=pNext){
		pNext = pDeadBodySign->GetNext();
		if( charaid==0xffffffff || pDeadBodySign->GetCharaID()==charaid ){
			delete pDeadBodySign;
		}
	}
	return true;
}

bool WK7Stage::ReleaseDeadBodySignAll(void)
{
	WK7DeadBodySign		*pDeadBodySign;
	WK7DeadBodySign		*pNext;
	for(pDeadBodySign=(WK7DeadBodySign *)mDeadBodySingAnchor.GetNext() ; pDeadBodySign!=NULL ; pDeadBodySign=pNext){
		pNext = pDeadBodySign->GetNext();
		delete pDeadBodySign;
	}
	return true;
}

WK7DeadBodySign* WK7Stage::FindDeadBodySign(u32 charaid)
{
	WK7DeadBodySign		*pDeadBodySign;
	for(pDeadBodySign=(WK7DeadBodySign *)mDeadBodySingAnchor.GetNext() ; pDeadBodySign!=NULL ; pDeadBodySign=pDeadBodySign->GetNext()){
		if( pDeadBodySign->GetCharaID()==charaid ){
			return pDeadBodySign;
		}
	}
	return NULL;
}

bool WK7Stage::CreateDeadBodySign(u32 charaid,const Vec &pos,const Vec &dir)
{
	WK7DeadBodySign		*pDeadBodySign;
	
static	Vec		boxSize = { 10.0f,10.0f,10.0f };
	Mtx		mtx,tm;
	Vec		rot;
	f32		zx;
	
	MTXIdentity (mtx);
	
	zx    = sqrtf(dir.x * dir.x + dir.z * dir.z);
	rot.y = atan2f( dir.x,dir.z);
	rot.x = atan2f(-dir.y,zx);
	rot.z = 0.0f;
	
	MTXRotRad(mtx,'x',rot.x);
	MTXRotRad( tm,'y',rot.y);
	MTXConcat( tm,mtx,mtx);
	MTXRotRad( tm,'z',rot.z);
	MTXConcat( tm,mtx,mtx);
	MTXTrans ( tm,pos.x,pos.y,pos.z);
	MTXConcat( tm,mtx,mtx);
	
	if( (pDeadBodySign = FindDeadBodySign(charaid))!=NULL ){
		GHM_SAFE_DELETE(pDeadBodySign);
	}
	
	WK7JObj	*pJObj = GetJObj("floor");
	
	if( pJObj==NULL ){
		return false;
	}
	
	ghmGcMemSetAllocName("DBSIGN");
	if( (pDeadBodySign = new WK7DeadBodySign(&mDeadBodySingAnchor,pJObj,mtx,boxSize))==NULL ){
		return false;
	}
	
	pDeadBodySign->SetCharaID(charaid);
	pDeadBodySign->SetVisible(true);
	pDeadBodySign->PaperBagSetVisible(true);
	
	return true;
}

bool WK7Stage::CreateDeadBodySign(u32 charaid)
{
	Vec					pos,dir;
	if( charaid==0xffffffff ){
		u32		i;
		for(i=0 ; i<K7PCMAX ; i++){
			if( BattleCtrl.mDeadPlayer[i].GetID()!=0xffffffff && BattleCtrl.mDeadPlayer[i].GetStageID()==mID ){
				BattleCtrl.mDeadPlayer[i].GetPosition(pos);
				BattleCtrl.mDeadPlayer[i].GetDir     (dir);
				CreateDeadBodySign(i,pos,dir);
			}
		}
		return true;
	}
	if( charaid >= K7PCMAX ){
		return false;
	}
	BattleCtrl.mDeadPlayer[charaid].GetPosition(pos);
	BattleCtrl.mDeadPlayer[charaid].GetDir     (dir);
	CreateDeadBodySign(charaid,pos,dir);
	return true;
}

bool WK7Stage::RenderDeadBodySign(void)
{
	WK7DeadBodySign		*pDeadBodySign;
	for(pDeadBodySign=(WK7DeadBodySign *)mDeadBodySingAnchor.GetNext() ; pDeadBodySign!=NULL ; pDeadBodySign=pDeadBodySign->GetNext()){
		pDeadBodySign->RenderProcess();
	}
	return true;
}

bool WK7Stage::RenderDeadBodySignAll(void)
{
	if( WK7Stage::GetRenderStage()==false ){
		return true;
	}
	WK7RenderObj	*pRenderObj;
	for(pRenderObj=WK7RenderObj::GetTopObj() ; pRenderObj!=NULL ; pRenderObj=pRenderObj->GetNext()){
		if( pRenderObj->GetType()!=K7OBJTYPE_STG ){
			continue;
		}
		WK7Stage	*pStage = (WK7Stage *)pRenderObj;
		pStage->RenderDeadBodySign();
	}
	return true;
}

//bool WK7Stage::DispLight(void)
//{
//	return WK7RenderObj::DispLight();
//}

bool WK7Stage::RenderEdgeShadow(void)
{
#if 0
	if( mpEdgeShadow!=NULL && mEdgeShadowVisible && mpEdgeShadowLight!=NULL ){
		C_LObj		*pLObj = mpEdgeShadowLight->GetLObj();
		C_Vec		pos;
		pos = pLObj->GetPosition();
		mpEdgeShadow->SetEyePos(pos);
static	u32	flag = 0;
		mpEdgeShadow->DispAll(flag);
//		mpEdgeShadow->DispAll();
	}
#endif
	return true;
}

bool WK7Stage::_RenderEdgeShadowPaint(void)
{
#if 0
	if( mpEdgeShadow==NULL ){
		return true;
	}
	mpEdgeShadow->DispShadow();
#endif
	return true;
}

int WK7Stage::GetCameraDescNum(void)
{
	if( mpArchive==NULL ){
		return 0;
	}
	return mpArchive->GetCameraDescNum();
}

HSD_CameraDesc* WK7Stage::GetCameraDesc(int index)
{
	if( mpArchive==NULL ){
		return NULL;
	}
	return mpArchive->GetCameraDesc(index);
}

HSD_CameraDesc* WK7Stage::GetCameraDesc(const char *pName)
{
	if( mpArchive==NULL ){
		return NULL;
	}
	return mpArchive->GetCameraDesc(pName);
}

C_LightSet* WK7Stage::GetLightSet(int index)
{
	if( mpArchive==NULL ){
		return NULL;
	}
	return mpArchive->GetLightSet(index);
}

bool WK7Stage::SetCurrentStage(u32 id)
{
	WK7Stage	*pStage = WK7RenderObj::GetStage(id);
	if( pStage==NULL ){
		OSDebugReportExp(pStage==NULL,"Stage Not Found !! %08x\n",id);
		return false;
	}
	SetCurrentStage(pStage);
	return true;
}

HSD_CameraDesc* WK7Stage::GetDefaultCameraDesc(void)
{
	if( mpArchive==NULL ){
		return NULL;
	}
	return mpArchive->GetCameraDesc("persp");
}

f32 WK7Stage::GetDefaultCameraNear(void)
{
	HSD_CameraDesc	*pCameraDesc = GetDefaultCameraDesc();
	if( pCameraDesc==NULL ){
		return -1.0f;
	}
	return pCameraDesc->common.nnear;
}

f32 WK7Stage::GetDefaultCameraFar(void)
{
	HSD_CameraDesc	*pCameraDesc = GetDefaultCameraDesc();
	if( pCameraDesc==NULL ){
		return -1.0f;
	}
	return pCameraDesc->common.ffar;
}

f32 WK7Stage::GetDefaultCameraFov(void)
{
	return 59.840444f;
}

bool WK7Stage::SetDefaultCameraDesc(bool delay)
{
	HSD_CameraDesc	*pCameraDesc = mpArchive->GetCameraDesc("persp");
	if( pCameraDesc!=NULL ){
		WK7CAM->SetNear(pCameraDesc->common.nnear);
		WK7CAM->SetFar (pCameraDesc->common.ffar );
		WK7CAM->SetFov (GetDefaultCameraFov(),delay);
//		if( pCameraDesc->common.projection_type==COBJ_PROJECTION_PERSPECTIVE ){
//			WK7CAM->SetFov(pCameraDesc->perspective.fov);
//		}
	}
	return true;
}

void WK7Stage::SetCurrentStage(WK7Stage *pStage)
{
	u32		id;
	if( pStage==NULL ){
		id = 0xffffffff;
	}else{
		id = pStage->GetID();
	}
	mCurrentStageID = id;
	mpCurrentStage  = pStage;
	WK7CAM->SetBranchPointMode(false,true);
	WK7Stage::SetCurrentPath("set_start",(char *)NULL);
	
	WK7StageInfo	*pStageInfo = GetStageInfo(id);
	if( pStageInfo!=NULL && pStageInfo->mAreaID!=K7AREA_UNKNOWN ){
		GameInfo.SetAreaID((K7Area)pStageInfo->mAreaID);
	}
	
	if( pStage!=NULL ){
		// }bvtOݒ
		if( pStageInfo!=NULL && pStageInfo->mMapNum==1 ){
			switch( pStageInfo->mMultiNum ){
			case	0:
			case	1:
				pStage->SetStageMapFlag(0,true);
				GameInfo.SetMenuMapSubNo(0);
				break;
			default:
				break;
			}
		}
		// ftHgJݒ
		pStage->SetDefaultCameraDesc();
		// ftHgݒ
		pStage->SetDefaultSetting();
		// JgXe[WݒCxg
		if( WK7EVENTCONTROLLER!=NULL ){
			K7EventDescStgSetCurrent	*pDesc;
			K7EventDescData				data;
			data.Initialize();
			while( (pDesc=(K7EventDescStgSetCurrent *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGSETCURRENT,data))!=NULL ){
				if( pDesc->mStgID==id ){
					WK7EVENTCONTROLLER->CallIM(&pDesc->mBase,id);
				}
			}
			// JgXe[WݒR[obN^XNN
			pStage->CallSetCurrentCallBackTask();
		}
	}
//	DefaultPathChangeProcess();
}

bool WK7Stage::SetDefaultSetting(void)
{
	WK7SdExpInfo	*pSdExpInfo = mpArchive->GetSdExpInfo();
	bool			blur = true;
	bool			fog  = false;
	if( pSdExpInfo!=NULL ){
		if( pSdExpInfo->mVersion >= 141 && !pSdExpInfo->mBlur ){
			blur = false;
		}
		if( pSdExpInfo->mVersion >= 171 && pSdExpInfo->mFogType ){
			WK7FOG->SetType  ((GXFogType)pSdExpInfo->mFogType);
			WK7FOG->SetStartZ(pSdExpInfo->mFogStartZ);
			WK7FOG->SetEndZ  (pSdExpInfo->mFogEndZ  );
			WK7FOG->SetColor (*((GXColor *)&pSdExpInfo->mFogColor));
			fog  = true;
		}
	}
	SceneBlur.SetVisible(blur);
	WK7FOG->SetEnable(fog);
	return true;
}

bool WK7Stage::SetCurrentPath(const char *pBpName,const char *pPathName,f32 dparam,int initdir)
{
	WK7PLAYERPATHCONTROL->SetCurrentPath(pBpName,pPathName,dparam);
	WK7PLAYERPATHCONTROL->Move(0.0f);
	WK7CAM->SetCurrentPath(initdir);
	WK7CAM->SetBranchPointMode(false,true);
	WK7Stage	*pStage;
	if( (pStage=WK7Stage::GetCurrentStage())!=NULL ){
		WK7PathChangeInfo		info;
		WK7PathNurbs			*pPath;
		pPathName = WK7PLAYERPATHCONTROL->GetCurrentPathName();
		pPath     = pStage->GetPathNurbs(pPathName);
		info.Initialize();
		info.mpPathName         = pPathName;
		info.SetPath(pPath);
		info.mInvPath           = 0;
		pStage->CallPathChangeCallBackTask(info);
	}
//	DefaultPathChangeProcess();
	return true;
}

bool WK7Stage::SetCurrentPathToBp(const char *pBpName,const char *pPathName,f32 dparam,int initdir)
{
	WK7PLAYERPATHCONTROL->SetCurrentPathToBp(pBpName,pPathName,dparam);
	WK7PLAYERPATHCONTROL->Move(0.0f);
	WK7CAM->SetCurrentPath(initdir);
	WK7CAM->SetBranchPointMode(false,true);
	WK7Stage	*pStage;
	if( (pStage=WK7Stage::GetCurrentStage())!=NULL ){
		WK7PathChangeInfo		info;
		WK7PathNurbs			*pPath;
		pPathName = WK7PLAYERPATHCONTROL->GetCurrentPathName();
		pPath     = pStage->GetPathNurbs(pPathName);
		info.Initialize();
		info.mpPathName         = pPathName;
		info.SetPath(pPath);
		info.mInvPath           = 0;
		pStage->CallPathChangeCallBackTask(info);
	}
//	DefaultPathChangeProcess();
	return true;
}

bool WK7Stage::SetCurrentPath(const char *pPathName,f32 param,u32 dir,int initdir)
{
	if( mpPath==NULL ){
		return false;
	}
	WK7PathNurbs		*pPathNurbs = mpPath->SearchPath(pPathName);
	if( pPathNurbs==NULL ){
		return false;
	}
	SetCurrentPath(pPathNurbs,param,dir,initdir);
	return true;
}

bool WK7Stage::SetCurrentPath(WK7PathNurbs *pPath,f32 param,u32 dir,int initdir)
{
	WK7PLAYERPATHCONTROL->SetCurrentPath(pPath,param,dir);
	WK7PLAYERPATHCONTROL->Move(0.0f);
	WK7CAM->SetCurrentPath(initdir);
	WK7CAM->SetBranchPointMode(false,true);
	WK7Stage	*pStage;
	if( (pStage=WK7Stage::GetCurrentStage())!=NULL && pPath!=NULL ){
		WK7PathChangeInfo		info;
		info.Initialize();
		info.mpPathName         = pPath->GetName();
		info.SetPath(pPath);
		info.mInvPath           = 0;
		pStage->CallPathChangeCallBackTask(info);
	}
//	DefaultPathChangeProcess();
	return true;
}

bool WK7Stage::SetCurrentPath(WK7PathNurbs *pPath,f32 param,u32 dir)
{
	bool	result = WK7PLAYERPATHCONTROL->SetCurrentPath(pPath,param,dir);
	WK7PLAYERPATHCONTROL->Move(0.0f);
	WK7Stage	*pStage;
	if( (pStage=WK7Stage::GetCurrentStage())!=NULL && pPath!=NULL ){
		WK7PathChangeInfo		info;
		info.Initialize();
		info.mpPathName         = pPath->GetName();
		info.SetPath(pPath);
		info.mInvPath           = 0;
		pStage->CallPathChangeCallBackTask(info);
	}
//	DefaultPathChangeProcess();
	return result;
}

bool WK7Stage::RenewPath(void)
{
	WK7PathNurbs	*pPath = WK7PLAYERPATHCONTROL->GetCurrentPath();
	if( pPath==NULL ){
		return false;
	}
	WK7PathChangeInfo		info;
	info.Initialize();
	info.mpPathName         = pPath->GetName();
	info.SetPath(pPath);
	info.mInvPath           = 0;
	CallPathChangeCallBackTask(info);
	return true;
}

WK7Stage* WK7Stage::GetCurrentStage(void)
{
//	OSDebugReportExp(mpCurrentStage==NULL,"Current Stage Not Found !!\n");
	return mpCurrentStage;
}

u32 WK7Stage::GetCurrentStageID(void)
{
	return mCurrentStageID;
}

bool WK7Stage::SetPrevStageID(u32 id)
{
	mPrevStageID = id;
	return true;
}

u32 WK7Stage::GetPrevStageID(void)
{
	return mPrevStageID;
}

bool WK7Stage::SetPrevStagePathName(const char *pName)
{
	GHMGCMEM_SAFE_FREE(mpPrevStagePathName);
	if( pName==NULL ){
		return true;
	}
	ghmGcMemSetAllocName("StgPSPN");
	if( (mpPrevStagePathName = (char *)K7AppSmallMemAlloc((int)strlen(pName)+1))==NULL ){
		return false;
	}
	strcpy(mpPrevStagePathName,pName);
	return true;
}

bool WK7Stage::SetPrevStageBpName(const char *pName)
{
	GHMGCMEM_SAFE_FREE(mpPrevStageBpName);
	if( pName==NULL ){
		return true;
	}
	ghmGcMemSetAllocName("StgPSBN");
	if( (mpPrevStageBpName = (char *)K7AppSmallMemAlloc((int)strlen(pName)+1))==NULL ){
		return false;
	}
	strcpy(mpPrevStageBpName,pName);
	return true;
}

const char* WK7Stage::GetPrevStagePathName(void)
{
	return mpPrevStagePathName;
}

const char* WK7Stage::GetPrevStageBpName(void)
{
	return mpPrevStageBpName;
}

bool WK7Stage::SetCurrentStageBpName(const char *pName)
{
	GHMGCMEM_SAFE_FREE(mpCurrentStageBpName);
	if( pName==NULL ){
		return true;
	}
	ghmGcMemSetAllocName("StgCSBN");
	if( (mpCurrentStageBpName = (char *)K7AppSmallMemAlloc((int)strlen(pName)+1))==NULL ){
		return false;
	}
	strcpy(mpCurrentStageBpName,pName);
	return true;
}

const char* WK7Stage::GetCurrentStageBpName(void)
{
	return mpCurrentStageBpName;
}

//bool WK7Stage::ReleaseArchive(u32 id)
//{
//	WK7Archive	*pArchive;
//	if( (pArchive = WK7Archive::Find(K7OBJTYPE_STG,id))==NULL ){
//		return false;
//	}
//	delete pArchive;
//	return true;
//}

bool WK7Stage::CreateStaticArchive(u32 id)
{
	WK7Archive	*pArchive;
	if( (pArchive = WK7Archive::Find(K7OBJTYPE_STG,id))==NULL ){
		if( (pArchive = WK7Archive::Create())==NULL ){
			return false;
		}
		// t@C擾
		char	filename[WK7_FNAME_MAX];
		GetFileName(filename,id);
		// ACe^Cvɐݒ
		pArchive->SetType(K7OBJTYPE_STG);
		// hcݒ
		pArchive->SetID  (id);
		// A[JCu[h
		if( pArchive->LoadArchive(filename)==false ){
			delete pArchive;
			return false;
		}
	}
	pArchive->SetStatic(true);
	return true;
}

bool WK7Stage::IsLoadedMessage(void)
{
	// [hĂtrue
	if( mMessageHandle >= 0 ){
		if( CheckMessagePackLoadComp((s8)mMessageHandle)==0 ){
			return false;
		}
	}
	if( mpNameFile!=NULL ){
		if( mpNameFile->GetState()!=ghmGcFile::READFINISH ){
			return false;
		}
		GHM_SAFE_DELETE(mpNameFile);
	}
	return true;
}

bool WK7Stage::LoadMessage(void)
{
	char	filename[256];		// ͂
	u32		mainid,suffix;
	
	mainid = K7STG_MAINID(mID);
	suffix = K7STG_SUFFIX(mID);
	
	if( mMessageHandle < 0 ){
		
		sprintf(filename,"Message/Stage/%03d/Stage%03d_M%02d.jmb",mainid,mainid,suffix);
		
		mMessageHandle = (int)LoadMessagePack(filename);
		
#ifdef	_DEBUG
		if( mMessageHandle < 0 ){
			OSReport("not found Message(jmb) : Stage%03d_%02d\n",mainid,suffix);
		}
#endif
		
	}
	
	GHM_SAFE_DELETE(mpNameFile);
	
	ghmGcMemSetAllocName("STLMFILE");
	if( (mpNameFile=new ghmGcFile)!=NULL ){
		
		sprintf(filename,"Message/Stage/%03d/Stage%03d_M%02dNM.jmb",mainid,mainid,suffix);
		
		if( mpNameFile->Open(filename)==true ){
			
			mpNameData = mpNameFile->Read();
			
		}else{
			GHM_SAFE_DELETE(mpNameFile);
		}
		
	}
	
	return true;
}

WK7StageCharaName::WK7StageCharaName(ghmGcListObj *pAnchor) : ghmGcListObj(pAnchor)
{
	ghmGcMemSetAllocName("STCHDISP");
	if( (mpCharaDisp = new MK7CharaDisp)==NULL ){
		mReleaseRequest = true;
	}else{
		mReleaseRequest = false;
	}
	mWaitTick = 0xffffffff;
}

WK7StageCharaName::~WK7StageCharaName()
{
	GHM_SAFE_DELETE(mpCharaDisp);
}

bool WK7StageCharaName::FrameProcess(void)
{
	if( mpCharaDisp==NULL ){
		return false;
	}
	if( mWaitTick!=0xffffffff ){
		if( mWaitTick  > WK7_TICK_PER_FRAME ){
			mWaitTick -= WK7_TICK_PER_FRAME;
		}else{
			mWaitTick  = 0xffffffff;
			mpCharaDisp->mRequest(mNo,mX,mY,mDispTick);
			gpEngTelop ->mSetPause();
			gpJimaku   ->mSetPause();
		}
	}else{
		if( mDispTick >= 0 ){
			if( mDispTick  > WK7_TICK_PER_FRAME ){
				mDispTick -= WK7_TICK_PER_FRAME;
			}else{
				Release();
				mDispTick = -1;
			}
		}
	}
	if( mpCharaDisp->mGetFrameProcess()==eCharaDispStandby ){
		if( mReleaseRequest==true ){
			return false;
		}
	}
	return true;
}

bool WK7StageCharaName::Reserve(u32 waitTick,s16 inNo,s16 inX,s16 inY,s32 inTick)
{
	if( mpCharaDisp==NULL ){
		return false;
	}
	mDispTick = inTick;
	mX        = inX;
	mY        = inY;
	mNo       = inNo;
	mWaitTick = waitTick;
	return true;
}

bool WK7StageCharaName::Disp(s16 inNo,s16 inX,s16 inY,s32 inTick)
{
	if( mpCharaDisp==NULL ){
		return false;
	}
	gpEngTelop ->mSetPause();
	gpJimaku   ->mSetPause();
	mpCharaDisp->mRequest(inNo,inX,inY,inTick);
	mDispTick = inTick;
	mX        = inX;
	mY        = inY;
	mNo       = inNo;
	mWaitTick = 0xffffffff;
	return true;
}

bool WK7StageCharaName::Hide(void)
{
	if( mpCharaDisp==NULL ){
		return false;
	}
	mpCharaDisp->mRelease();
	return true;
}

bool WK7Stage::ReserveCharaName(u32 waitTick,s16 inNo,s16 inX,s16 inY,s32 inTick)
{
	if( gpCharaDispMng->mDataGet()==NULL ){
		return false;
	}
	ghmGcMemSetAllocName("STCHNMR");
	WK7StageCharaName		*pCharaName = new WK7StageCharaName(&mCharaNameAnchor);
	if( pCharaName==NULL ){
		return false;
	}
	pCharaName->Reserve(waitTick,inNo,inX,inY,inTick);
	return true;
}

bool WK7Stage::DispCharaName(s16 inNo,s16 inX,s16 inY,s32 inTick)
{
	if( gpCharaDispMng->mDataGet()==NULL ){
		return false;
	}
	ghmGcMemSetAllocName("STCHNMD");
	WK7StageCharaName		*pCharaName = new WK7StageCharaName(&mCharaNameAnchor);
	if( pCharaName==NULL ){
		return false;
	}
	pCharaName->Disp(inNo,inX,inY,inTick);
	return true;
}

bool WK7Stage::HideCharaName(void)
{
	WK7StageCharaName	*pCharaName;
	for(pCharaName=(WK7StageCharaName *)mCharaNameAnchor.GetNext() ; pCharaName!=NULL ; pCharaName=pCharaName->GetNext()){
		pCharaName->Release();
	}
	return true;
}

bool WK7Stage::ClearCharaName(void)
{
	WK7StageCharaName	*pCharaName,*pNext;
	for(pCharaName=(WK7StageCharaName *)mCharaNameAnchor.GetNext() ; pCharaName!=NULL ; pCharaName=pNext){
		pNext = pCharaName->GetNext();
		delete pCharaName;
	}
	return true;
}

bool WK7Stage::FrameProcessCharaName(void)
{
	WK7StageCharaName	*pCharaName;
	WK7StageCharaName	*pNext;
	for(pCharaName=(WK7StageCharaName *)mCharaNameAnchor.GetNext() ; pCharaName!=NULL ; pCharaName=pNext){
		pNext = pCharaName->GetNext();
		if( pCharaName->FrameProcess()==false ){
			delete pCharaName;
			if( mCharaNameAnchor.GetNext()==NULL ){
				ReleaseNameData();
			}
		}
	}
	return true;
}

bool WK7Stage::SetNameData(void)
{
	if( mpNameData==NULL ){
		return false;
	}
	gpCharaDispMng->mDataSet(mpNameData);
	return true;
}

bool WK7Stage::ReleaseNameData(void)
{
	if( gpCharaDispMng!=NULL && mpNameData!=NULL ){
		if( gpCharaDispMng->mDataGet()==mpNameData ){
			gpCharaDispMng->mDataSet(NULL);
		}
	}
	if( gpEngTelop!=NULL ){ gpEngTelop->mReleasePause(); }
	if( gpJimaku  !=NULL ){ gpJimaku  ->mReleasePause(); }
	return true;
}

//bool WK7Stage::LoadAreaInfo(void)
//{
//	if( mpAreaInfoFile!=NULL || mpAreaInfo!=NULL ){
//		return true;
//	}
//	if( (mpAreaInfoFile = new ghmGcFile)==NULL ){
//		return false;
//	}
//	char	filename[256];		// ͂
//	u32		mainid,suffix;
//	
//	mainid = K7STG_MAINID(mID);
//	suffix = K7STG_SUFFIX(mID);
//	
//	sprintf(filename,"3DData/Model/Stage/%03d/Stage%03d_M%02d.ard",mainid,mainid,suffix);
//	
//	if( mpAreaInfoFile->Open(filename)==false ){
//		GHM_SAFE_DELETE(mpAreaInfoFile);
//		return true;
//	}
//	if( (mpAreaInfo = (WK7AreaInfo *)mpAreaInfoFile->Read())==NULL ){
//		GHM_SAFE_DELETE(mpAreaInfoFile);
//		return false;
//	}
//	
//	return true;
//}
//
//bool WK7Stage::IsLoadedAreaInfo(void)
//{
//	if( mpAreaInfoFile==NULL || mpAreaInfo==NULL ){
//		return true;
//	}
//	if( mpAreaInfoFile->GetState()!=ghmGcFile::READFINISH ){
//		return false;
//	}
//	return true;
//}

bool WK7Stage::RestoreObj(void)
{
	if( LoadMessage()==false ){
		return false;
	}
//	if( LoadAreaInfo()==false ){
//		return false;
//	}
	if( WK7RenderObj::RestoreObj()==false ){
		return false;
	}
	return true;
}

bool WK7Stage::LoadObj(u32 type,u32 id)
{
	bool	result = true;
	mpStageInfo = GetStageInfo(mID);
	if( mLoadWait==false && type==K7OBJTYPE_STG ){
		if( LoadMessage()==false ){
			result = false;
		}
//		if( LoadAreaInfo()==false ){
//			result = false;
//		}
	}
	if( WK7RenderObj::LoadObj(type,id)==false ){
		return false;
	}
	return result;
}

WK7RenderObjEffectMessage* WK7Stage::CreateMessage(u32 messageID,s32 iconID,s32 soundID)
{
	if( mMessageHandle < 0 ){
		return NULL;
	}
	EFFECT		*pMessageEffect;
	if( (pMessageEffect=CreateMessage2Effect((s8)mMessageHandle,(u16)messageID, TRUE, iconID,soundID))==NULL ){
		return NULL;
	}
	WK7RenderObjEffectMessage	*pRenderObjEffect;
	ghmGcMemSetAllocName("RndrObEf");
	if( (pRenderObjEffect=new WK7RenderObjEffectMessage(messageID,
	                                                    iconID,
	                                                    soundID,
	                                                    WK7RENDEROBJEFFECTMESSAGE_KIND_MESSAGE,
	                                                    &mEffectAnchor,
	                                                    this,
	                                                    pMessageEffect))==NULL ){
		::DeleteEffect(pMessageEffect);
		return NULL;
	}
	return pRenderObjEffect;
}

WK7RenderObjEffectMessage* WK7Stage::CallMessage(u32 messageID,s32 iconID,s32 soundID)
{
	return CreateMessage(messageID, iconID, soundID);
}

bool WK7Stage::CallMessageB(u32 messageID,s32 iconID,s32 soundID)
{
	bool SetOperateEnableSave;
	bool NpcPauseAllSave;
	
	WK7RenderObjEffect	*pRenderObjEffect;
	
	while( (pRenderObjEffect = CreateMessage(messageID, iconID, soundID))==NULL ){
		retsys();
	}
	
	{
		SetOperateEnableSave = WK7PLAYERCONTROL->GetOperateEnable();
		NpcPauseAllSave = WK7Npc::GetNpcPauseAll();
		
		WK7PLAYERCONTROL->SetOperateEnable(false);
		WK7Npc::NpcPauseAll();
		
		while( IsValidEffect(pRenderObjEffect)==true ){
			retsys();
		}
		
#if 1
		WK7PLAYERCONTROL->SetOperateEnable(SetOperateEnableSave);
		if ( NpcPauseAllSave == false ){
			WK7Npc::NpcResetPauseAll();
		}
#else
//		WK7PLAYERCONTROL->SetOperateEnable(true);
//		WK7Npc::NpcResetPauseAll();
#endif
		
		return true;
	}
}

bool WK7Stage::CallMessageB2(u32 messageID,s32 iconID,s32 soundID)
{
	WK7RenderObjEffect	*pRenderObjEffect;
	
	while( (pRenderObjEffect = CreateMessage(messageID, iconID, soundID))==NULL ){
		retsys();
	}
	
	while( IsValidEffect(pRenderObjEffect)==true ){
		retsys();
	}
	
	return true;
}

WK7RenderObjEffectMessage* WK7Stage::CreateItemGet(u32 messageID,bool buttonCancel,s32 iconID,s32 soundID)
{
	if( mMessageHandle < 0 ){
		return NULL;
	}
	EFFECT		*pEffect;
	if( (pEffect=CreateItemGetEffect((s8)mMessageHandle,(u16)messageID,buttonCancel,iconID,soundID))==NULL ){
		return NULL;
	}
	WK7RenderObjEffectMessage	*pRenderObjEffect;
	ghmGcMemSetAllocName("StItGtEf");
	if( (pRenderObjEffect=new WK7RenderObjEffectMessage(messageID,
	                                                    iconID,
	                                                    soundID,
	                                                    WK7RENDEROBJEFFECTMESSAGE_KIND_ITEMGET,
	                                                    &mEffectAnchor,
	                                                    this,
	                                                    pEffect))==NULL ){
		::DeleteEffect(pEffect);
		return NULL;
	}
	return pRenderObjEffect;
}

WK7RenderObjEffectMessage* WK7Stage::CallItemGet(u32 messageID,bool buttonCancel,s32 iconID,s32 soundID)
{
	return CreateItemGet(messageID,buttonCancel,iconID,soundID);
}

bool WK7Stage::CallItemGetB(u32 messageID,bool buttonCancel,s32 iconID,s32 soundID)
{
	bool	SetOperateEnableSave;
	bool	NpcPauseAllSave;
	WK7RenderObjEffect	*pRenderObjEffect;
	
	while( (pRenderObjEffect = CreateItemGet(messageID,buttonCancel,iconID,soundID))==NULL ){
		retsys();
	}
	
	SetOperateEnableSave = WK7PLAYERCONTROL->GetOperateEnable();
	NpcPauseAllSave = WK7Npc::GetNpcPauseAll();
	
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7Npc::NpcPauseAll();
	
	while( IsValidEffect(pRenderObjEffect)==true ){
		retsys();
	}
	
	WK7PLAYERCONTROL->SetOperateEnable(SetOperateEnableSave);
	if ( NpcPauseAllSave == false ){
		WK7Npc::NpcResetPauseAll();
	}
	
	return true;
}

bool WK7Stage::CallItemGetB2(u32 messageID,bool buttonCancel,s32 iconID,s32 soundID)
{
	WK7RenderObjEffect	*pRenderObjEffect;
	
	while( (pRenderObjEffect = CreateItemGet(messageID,buttonCancel,iconID,soundID))==NULL ){
		retsys();
	}
	
	while( IsValidEffect(pRenderObjEffect)==true ){
		retsys();
	}
	
	return true;
}

bool WK7Stage::IsValidMessage(u32 messageID)
{
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=GetEffectTop() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect->GetType()!=WK7RenderObjEffect::MESSAGE ){
			continue;
		}
		WK7RenderObjEffectMessage	*pRenderObjEffectMessage = (WK7RenderObjEffectMessage *)pRenderObjEffect;
		if( pRenderObjEffectMessage->GetMessageID()!=messageID ){
			continue;
		}
		if( pRenderObjEffectMessage->GetKind()!=WK7RENDEROBJEFFECTMESSAGE_KIND_MESSAGE ){
			continue;
		}
		return true;
	}
	return false;
}

bool WK7Stage::IsDisplayedMessage(u32 messageID)
{
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=GetEffectTop() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect->GetType()!=WK7RenderObjEffect::MESSAGE ){
			continue;
		}
		WK7RenderObjEffectMessage	*pRenderObjEffectMessage = (WK7RenderObjEffectMessage *)pRenderObjEffect;
		if( pRenderObjEffectMessage->GetMessageID()!=messageID ){
			continue;
		}
		if( pRenderObjEffectMessage->GetKind()!=WK7RENDEROBJEFFECTMESSAGE_KIND_MESSAGE ){
			continue;
		}
		EFFECT	*pEffect = pRenderObjEffectMessage->GetEffect();
		if( pEffect==NULL ){
			continue;
		}
		if( ::GetStopStateMessage2Effect(pEffect)==FALSE ){
			return false;
		}
		return true;
	}
	return false;
}

bool WK7Stage::IsValidItemGet(u32 messageID)
{
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=GetEffectTop() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect->GetType()!=WK7RenderObjEffect::MESSAGE ){
			continue;
		}
		WK7RenderObjEffectMessage	*pRenderObjEffectMessage = (WK7RenderObjEffectMessage *)pRenderObjEffect;
		if( pRenderObjEffectMessage->GetMessageID()!=messageID ){
			continue;
		}
		if( pRenderObjEffectMessage->GetKind()!=WK7RENDEROBJEFFECTMESSAGE_KIND_ITEMGET ){
			continue;
		}
		return true;
	}
	return false;
}

bool WK7Stage::IsDisplayedItemGet(u32 messageID)
{
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=GetEffectTop() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect->GetType()!=WK7RenderObjEffect::MESSAGE ){
			continue;
		}
		WK7RenderObjEffectMessage	*pRenderObjEffectMessage = (WK7RenderObjEffectMessage *)pRenderObjEffect;
		if( pRenderObjEffectMessage->GetMessageID()!=messageID ){
			continue;
		}
		if( pRenderObjEffectMessage->GetKind()!=WK7RENDEROBJEFFECTMESSAGE_KIND_ITEMGET ){
			continue;
		}
		EFFECT	*pEffect = pRenderObjEffectMessage->GetEffect();
		if( pEffect==NULL ){
			continue;
		}
		if( ::GetItemGetState(pEffect)==0 ){
			return false;
		}
		return true;
	}
	return false;
}

WK7StageMotion::WK7StageMotion(ghmGcListObj *pAnchor,int prio) : WK7MotionObj(pAnchor,prio)
{
}

WK7StageMotion::~WK7StageMotion()
{
}

bool WK7StageMotion::GetFileName(char *pFileName,u32 id)
{
	u32			mainid = K7MOT_MAINID(id);
	u32			suffix = K7MOT_SUFFIX(id);
	
	OSDebugReportExp(mainid > K7STGID_MAX,"Stage Motion Main ID Over 1000 : %d\n" ,mainid);
	OSDebugReportExp(suffix > 10000      ,"Stage Motion Suffix ID Over 10000 : %d\n",suffix);
	
	sprintf(pFileName,WK7_3DDATA_FOLDER WK7_MOTION_FOLDER WK7_STAGE_FOLDER "%03d/Stage%03d_%04d.dat",mainid,mainid,suffix);
	return true;
}

bool WK7StageMotion::CreateStaticArchive(u32 id)
{
	WK7Archive	*pArchive;
	if( (pArchive = WK7Archive::Find(K7MOT_ATTR|K7OBJTYPE_STG,id))==NULL ){
		if( (pArchive = WK7Archive::Create())==NULL ){
			return false;
		}
		// t@C擾
		char	filename[WK7_FNAME_MAX];
		GetFileName(filename,id);
		// ACe^Cvɐݒ
		pArchive->SetType(K7MOT_ATTR|K7OBJTYPE_STG);
		// hcݒ
		pArchive->SetID  (id);
		// A[JCu[h
		if( pArchive->LoadArchive(filename)==false ){
			delete pArchive;
			return false;
		}
	}
	pArchive->SetStatic(true);
	return true;
}

#if FUJITA

C_Coll WK7Stage::CollisionCheck( Vec &_p0, Vec &_p1, f32 _rad )
{
  C_Vec p0(_p0);
  C_Vec p1(_p1);
  C_Coll dummy;

  for( u32 i=0; i<mTrigonPtrs.size(); i++ ){
	C_Coll coll( *mTrigonPtrs[i], p0, p1, _rad, false );
	if( coll.Result() ){
	  _p1 = p1;
	  return coll;
	}
  }

  return dummy;
}
Vec WK7Stage::FindPath( Vec &_p0, Vec &_p1 )
{
  C_Vec p0(_p0);
  C_Vec p1(_p1);
  C_Vec dst;

  for( u32 i=0; i<mBorderPtrs.size(); i++ ){
	dst = mBorderPtrs[i]->FindPath( p0, p1 );
	if( p1 != dst ){
	  mFirstNodePos = mBorderPtrs[i]->GetFirstNodePos();
	  mFirstNodeNrm = mBorderPtrs[i]->GetFirstNodeNrm();
	  mShortestDist = mBorderPtrs[i]->GetShortestDist();
	  break;
	}
  }
  
  return dst;
}
#endif

/*
	
	
	݂̈ړ̍WړRW͈͂ǂeXg
	
	łȂꍇ͂Ăɕ␳
	
	
*/
bool WK7Stage::CollisionCheck2(Vec &nowPos, Vec &nextPos)
{
	C_Coll coll;
	C_Vec top, btm;

	top = nowPos; top.y += 100.f;
	btm = nextPos; btm.y -= 100.f;
	coll = CollisionCheck(top, btm, 0.f);
	if( coll.Result() ){
		//|SɈړ悤ƂĂBOK
		return true;
	}else{
		// ̑G[
//		nextPos = nowPos;
		return false;
	}
}

bool WK7Stage::DeleteTaskTerm(u32 stgid)
{
	WK7Stage	*pStage = WK7RenderObj::GetStage(stgid);
	if( pStage!=NULL ){
		return false;
	}
	GHMGCTASK_EXIT();
	return true;
}

int WK7Stage::SetEventEnable(u32 eventid,bool flag)
{
	int		count = 0;
	if( mpPath!=NULL ){
		count += mpPath->SetEventEnable(eventid,flag);
	}
	count += WK7RenderObj::SetEventEnable(eventid,flag);
	return count;
}

int WK7Stage::ChangeEventNo(u32 from_evno,u32 to_evno)
{
	int		count = 0;
	if( mpPath!=NULL ){
		count += mpPath->ChangeEventNo(from_evno,to_evno);
	}
	return count;
}

int WK7Stage::SetEventNoEnable(u32 eventno,bool flag)
{
	int		count = 0;
	if( mpPath!=NULL ){
		count += mpPath->SetEventNoEnable(eventno,flag);
	}
	return count;
}

WK7JObj* WK7Stage::GetObjEventNo(u32 evno)
{
	WK7JObj	*pJObj;
	if( mpPath!=NULL ){
		if( (pJObj = mpPath->GetObjEventNo(evno))!=NULL ){
			return pJObj;
		}
	}
	WK7JObj	*pHitTop = GetJObj("hit");
	if( pHitTop!=NULL ){
		for(pJObj=pHitTop->GetChild() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
			if( GetEventNo(pJObj)==evno ){
				return pJObj;
			}
		}
	}
	return NULL;
}

int WK7Stage::SetObjVisibleEventNo(u32 evno,bool flag)
{
	int		count = 0;
	if( mpPath!=NULL ){
		count += mpPath->SetObjVisibleEventNo(evno,flag);
	}
	return count;
}

int WK7Stage::SetObjVisible(u32 eventid,bool flag)
{
	int		count = 0;
	if( mpPath!=NULL ){
		count += mpPath->SetObjVisible(eventid,flag);
	}
	return count;
}

bool WK7Stage::CallStageCondChange(u32 stgid)
{
	WK7Stage	*pStage = WK7RenderObj::GetStage(stgid);
	if( pStage==NULL ){
		return false;
	}
	return pStage->CallCondChange();
}

bool WK7Stage::CallCurrentStageCondChange(void)
{
	return CallStageCondChange(GetCurrentStageID());
}

bool WK7Stage::CallCondChange(void)
{
//	WK7HitObj::InitEventEnable();
	
	if( WK7EVENTCONTROLLER!=NULL ){
		
		K7EventDescStgTerm	*pDesc;
		K7EventDescData		data;
		data.Initialize();
		while( (pDesc=(K7EventDescStgTerm *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGCONDCHANGE,data))!=NULL ){
			if( pDesc->mStgID==mID ){
				WK7EVENTCONTROLLER->CallIM(&pDesc->mBase,mID);
			}
		}
		
		// ԕύXR[obN^XNN
		CallCondChangeCallBackTask();
	}
	
	return true;
}

WK7PathNurbs* WK7Stage::GetPathNurbs(const char *pName)
{
	if( mpPath==NULL || pName==NULL ){
		return NULL;
	}
	return mpPath->GetPath(pName);
}

WK7PathNurbs* WK7Stage::GetPathNurbsAll(const char *pName)
{
	WK7RenderObj	*pRenderObj;
	WK7PathNurbs	*pPath;
	for(pRenderObj=WK7RenderObj::GetTopObj() ; pRenderObj!=NULL ; pRenderObj=pRenderObj->GetNext()){
		if( pRenderObj->GetType()!=K7OBJTYPE_STG ){
			continue;
		}
		WK7Stage	*pStage = (WK7Stage *)pRenderObj;
		if( (pPath=pStage->GetPathNurbs(pName))==NULL ){
			continue;
		}
		return pPath;
	}
	return NULL;
}

WK7MotionObj* WK7Stage::CreateOwnMotionObj(u32 id,int prio)
{
	return WK7RenderObj::CreateOwnMotionObj(mType,id,prio);
}

bool WK7Stage::SetPathEnable(const char *pName,bool flag)
{
	WK7PathNurbs	*pPathNurbs = SearchPath(pName);
	if( pPathNurbs==NULL ){
		return false;
	}
	pPathNurbs->SetEnable  (flag);
	if( pPathNurbs->GetStageJump()==true ){
		pPathNurbs->SetEnableEx(false);
	}else{
		pPathNurbs->SetEnableEx(flag);
	}
	return true;
}

bool WK7Stage::SetPathEnableOnly(const char *pName,bool flag)
{
	WK7PathNurbs	*pPathNurbs = SearchPath(pName);
	if( pPathNurbs==NULL ){
		return false;
	}
	pPathNurbs->SetEnable(flag);
	return true;
}

bool WK7Stage::SetPathEnableEx(const char *pName,bool flag)
{
	WK7PathNurbs	*pPathNurbs = SearchPath(pName);
	if( pPathNurbs==NULL ){
		return false;
	}
	pPathNurbs->SetEnableEx(flag);
	return true;
}

bool WK7Stage::SetDisablePathCamera(const char *pName,bool flag)
{
	WK7PathNurbs	*pPathNurbs = SearchPath(pName);
	if( pPathNurbs==NULL ){
		return false;
	}
	pPathNurbs->SetDisablePathCamera(flag);
	return true;
}

WK7PathBranchPoint* WK7Stage::GetBranchPoint_EventNo(u32 eventno,WK7PathBranchPoint *pBranchPoint)
{
	if( mpPath==NULL ){
		return NULL;
	}
	return mpPath->GetBranchPoint_EventNo(eventno,pBranchPoint);
}

u32 WK7Stage::GetBpEventNo(WK7BpInfo &info)
{
	WK7PathBranchPoint	*pBranchPoint;
	if( (pBranchPoint=info.GetBranchPoint())==NULL ){
		return 0xffffffff;
	}
	return GetEventNo(pBranchPoint->GetName());
}

int WK7Stage::GetBpPathNo(WK7BpInfo &info,bool next)
{
	WK7PathBranchPoint	*pBranchPoint;
	if( (pBranchPoint=info.GetBranchPoint())==NULL ){
		return -1;
	}
	WK7PathNurbs	*pPath;
	if( next==true ){
		pPath = info.GetNextPath();
	}else{
		pPath = info.GetCurrentPath();
	}
	if( pPath==NULL ){
		return -1;
	}
	u32		eventNo = GetEventNo(pBranchPoint->GetName());
	if( eventNo==0xffffffff ){
		return -1;
	}
	char	evname[16];
	switch( eventNo & K7EV_TYPE_MASK ){
	case	K7EV_TYPE_NO:   sprintf(evname,"event_%06x",eventNo & K7EV_ID_MASK); break;
	case	K7EV_TYPE_DOOR: sprintf(evname,"door_%06x" ,eventNo & K7EV_ID_MASK); break;
	default:
		return -1;
	}
	const char	*pPathName = pPath->GetName();
	if( (pPathName=strstr(pPathName,evname))==NULL ){
//	if( (pPathName=strstr(pPathName,pBranchPoint->GetName()))==NULL ){
		return -1;
	}
	u32		len = strlen(evname);
//	u32		len = strlen(pBranchPoint->GetName());
	pPathName += len;
	if( *pPathName != '_' ){
		return -1;
	}
	int		no = 0;
	int		count = 0;
	for(pPathName++,count=0 ; *pPathName!='\0' ; pPathName++,count++){
		if( *pPathName < '0' || *pPathName > '9' ){
			break;
		}
		no *= 10;
		no += (int)(*pPathName - '0');
	}
	if( count <= 0 ){
		return -1;
	}
	return no;
}

WK7StageDoorInfo* WK7Stage::GetDoorInfo(const char *pBpName,u32 tostgid,const char *pToBpName)
{
	return GetDoorInfo(mID,pBpName,tostgid,pToBpName);
}

WK7StageDoorInfo* WK7Stage::GetDoorInfo(u32 stgid,const char *pBpName,u32 tostgid,const char *pToBpName)
{
	WK7StageDoorInfo		*pDoorInfo;
	WK7StageDoorInfo		*pDoorInfoReserved = NULL;
	int						i;
	
	for(i=0 ; i<2 ; i++){
		
		switch( i ){
		case	0:
			if( (pDoorInfo = mpScenarioDoorInfo)==NULL ){
				continue;
			}
			break;
		case	1:
		default:
			pDoorInfo = stageDoorInfo;
			break;
		}
		
		for( ; pDoorInfo->mFromID!=0xffffffff ; pDoorInfo++){
			
			if( pDoorInfo->mScenarioID >= 0 && pDoorInfo->mScenarioID != GameInfo.GetScenarioID() ){
				continue;
			}
			
			if( pDoorInfo->mFromID!=stgid ){
				continue;
			}
			
			if( pBpName!=NULL ){
			
				if( pDoorInfo->mpBpName==NULL ){
					if( pDoorInfo->mToID==0xffffffff ){
						if( pDoorInfoReserved==NULL && pDoorInfo->mpToBpName==NULL ){
							pDoorInfoReserved = pDoorInfo;
						}
						continue;
					}
				}else{
					if( strcmp(pDoorInfo->mpBpName,pBpName)!=0 ){
						continue;
					}
				}
				
			}else{
				
				if( pDoorInfo->mpBpName!=NULL ){
					continue;
				}
				
			}
			
			if( pDoorInfo->mToID!=0xffffffff ){
				
				if( pDoorInfo->mToID!=tostgid ){
					continue;
				}
				
				if( pToBpName!=NULL ){
					
					if( pDoorInfo->mpToBpName!=NULL ){
						if( strcmp(pDoorInfo->mpToBpName,pToBpName)!=0 ){
							continue;
						}
					}
					
				}else{
					
					if( pDoorInfo->mpToBpName!=NULL ){
						continue;
					}
					
				}
				
			}
			
			i = 2;
			break;
			
		}
		
	}
	
	if( pDoorInfo->mFromID==0xffffffff && pDoorInfoReserved!=NULL ){
		pDoorInfo = pDoorInfoReserved;
	}
	return pDoorInfo;
}

WK7StagePlaceInfo* WK7Stage::GetPlaceInfo(const char *pPathName)
{
	return GetPlaceInfo(mID,pPathName);
}

WK7StagePlaceInfo* WK7Stage::GetPlaceInfo(u32 id,const char *pPathName)
{
	WK7StagePlaceInfo		*pPlaceInfo;
	WK7StagePlaceInfo		*pPlaceInfoReserved = NULL;
	int						i;
	
#ifdef	_DEBUG
	if( pPathName!=NULL ){
		ghmGcMemSetAllocName("pathname");
		char		*pStr = new char[strlen(pPathName) + 1 + 32];
		if( pStr!=NULL ){
			sprintf(pStr,"%03dM%02d : %s",K7STG_MAINID(WK7Stage::GetCurrentStageID()),K7STG_SUFFIX(WK7Stage::GetCurrentStageID()),pPathName);
			K7AppDebugPrint(pStr);
		}
		GHM_SAFE_DELETE_ARRAY(pStr);
	}
#endif
	
	for(i=0 ; i<2 ; i++){
		switch( i ){
		case	0:
			if( (pPlaceInfo = mpScenarioPlaceInfo)==NULL ){
				continue;
			}
			break;
		case	1:
		default:
			pPlaceInfo = stagePlaceInfo;
			break;
		}
		for( ; pPlaceInfo->mID!=0xffffffff ; pPlaceInfo++){
			
			if( pPlaceInfo->mID!=id ){
				continue;
			}
			
			if( pPathName!=NULL ){
			
				if( pPlaceInfo->mpPathName==NULL ){
					if( pPlaceInfoReserved==NULL ){
						pPlaceInfoReserved = pPlaceInfo;
					}
					continue;
				}
				
				if( strcmp(pPlaceInfo->mpPathName,pPathName)!=0 ){
					continue;
				}
				
			}else{
				
				if( pPlaceInfo->mpPathName!=NULL ){
					continue;
				}
				
			}
			
			i = 2;
			break;
			
		}
	}
	
	if( pPlaceInfo->mID==0xffffffff && pPlaceInfoReserved!=NULL ){
		pPlaceInfo = pPlaceInfoReserved;
	}
	return pPlaceInfo;
}

struct WK7Stage_EnemyType{
	u32		type;
	u32		suffix;
};

bool WK7Stage::CreateNpc(void)
{
#ifndef	K7APP_MASTER
	if( mainMenu.GetDumpStageInfoProc() >= 0 ){
		return true;
	}
#endif
	
	u32					i;
	int					setOk,j;
	ENEMYLIST			*pEnemyList;
	WK7Stage_EnemyType	*pEnemyType;
	int					enemax = mStageEnemyMax;
	u32					prevStgid = WK7Stage::GetPrevStageID();
	
	WK7Npc::WK7NpcNoCounterClear();
	
	pEnemyList = WK7Npc::GetEnemyList(0);
	
	if( mStageEnemyMax > 0 ){
		ghmGcMemSetAllocName("StgNpc");
		if( (pEnemyType = (WK7Stage_EnemyType *)K7AppSmallMemAlloc((int)(sizeof(WK7Stage_EnemyType) * mStageEnemyMax)))==NULL ){
			enemax = 0;
		}
	}else{
		pEnemyType = NULL;
	}
	
	for(i=0,setOk=0 ; i<ENENO_MAX ; i++,pEnemyList++){
		
		if( mID!=pEnemyList->stgid ){
			continue;
		}
		
		if( pEnemyList->dead ){
			continue;
		}
		
		// S|bv֎~tO
		if( true == WK7Npc::GetNpcPopAll() ){
			continue;
		}
		
		if ( pEnemyList->prevstgid != 0xffffffff ){				// ÕXe[W񂪂ꍇBׂ
			if ( prevStgid == 0xffffffff ) {
				continue;
			}
			
			if ( prevStgid != pEnemyList->prevstgid ){
				continue;
			}
		}
		
		
		if( pEnemyList->loadEvFlag >= 0 ){
			if( K7SCR_GET_SCENARIO_FLAG((int)pEnemyList->loadEvFlag)==false ){
				continue;
			}
		}
		
		for(j=setOk-1 ; j>=0 ; j--){
			if( pEnemyType[j].type  ==pEnemyList->type   && 
			    pEnemyType[j].suffix==(u32 )pEnemyList->suffix ){
				break;
			}
		}
		
		if( j<0 ){
			// PXe[WMAX_STAGE_ENEMY
			if( setOk >= enemax ){
#ifdef	_DEBUG
				setOk++;
				continue;
#else
				break;
#endif
			}
			pEnemyType[setOk].type   = pEnemyList->type;
			pEnemyType[setOk].suffix = (u32 )pEnemyList->suffix;
			setOk++;
		}
		
		// ̃Xe[WɃZbgG
		if( WK7Npc::Create(i)==NULL ){
			continue;
		}
		
	}
	
#ifdef	_DEBUG
	if( setOk > enemax ){
		OSReport("Enemy Max Over : %d(max %d) in (%03dM%02d)\n",setOk,enemax,K7STG_MAINID(mID),K7STG_SUFFIX(mID));
	}
#endif
	
	GHMGCMEM_SAFE_FREE(pEnemyType);
	
	return true;
}

bool WK7Stage::IsLoadingNpc(void)
{
	WK7Npc			*pNpc;
	WK7NpcFindData	finddata;
	
	finddata.Initialize(mID);
	
	while( (pNpc=WK7Npc::Find(finddata))!=NULL ){
		if( pNpc->GetReleaseState()!=WK7Npc::LOADED ){
//		if( pNpc->IsLoading()==true ){
			return true;
		}
//		if( pNpc->GetNpcState()==NPC_STATE_INIT ){
//			return true;
//		}
	}
	return false;
}

bool WK7Stage::InitializeNpc(void)
{
	WK7Npc			*pNpc;
	WK7NpcFindData	finddata;
	Vec				pos;
	
	finddata.Initialize(mID);
	
	while( (pNpc=WK7Npc::Find(finddata))!=NULL ){
		switch( pNpc->GetType() ){
		case	WK7Npc::TYPE_EXTRA:
			pNpc->SetVisible(true);
			break;
		case	WK7Npc::TYPE_ENEMY:
			if( K7ENM_ANG > pNpc->GetEneType() ){
				pNpc->GetPosition(pos);
				if( PutEnemyWalk(pos)==false ){
					delete pNpc;
					break;
				}
				pNpc->SetInitPos(pos);
			}
			break;
		case	WK7Npc::TYPE_NPC:
		default:
			break;
		}
	}
	return true;
}

bool WK7Stage::InitializeGlassObj(void)
{
	WK7JObj		*pJObj = GetJObj("GLASS");
	static	HSD_PEDesc	pedesc = {
		//J[AAt@AŒAt@݁AZobt@SăGiuB
		ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE|ENABLE_DITHER|BEFORE_TEX,
		// GXSetAlphaCompare(),ref0,ref1
		0,0,
		// GXSetDstAlpha(),dst_alpha
		WK7RENDEROBJ_RENDERID_DEFAULT_ALPHA,
		// GXSetBlendMode(),type,src_factor,dst_factor,logic_op
		GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR,
		//GXSetZMode(),func
		GX_LEQUAL,
		//GXAlphaCompare,comp0,op,comp1
		GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
	};
	if( pJObj!=NULL ){
		pJObj->SetPE(&pedesc,false,true);
		pJObj->SetNoZUpdate(false,false,true);
	}
	return true;
}

bool WK7Stage::InitializeConstraintSky(void)
{
	mpConstraintSky = GetJObj("constraint_sky");
	return true;
}

#ifdef	USE_ISDOLVIEWER
u32						defitemid;
#endif
bool WK7Stage::CreateHana(void)
{
#ifndef	K7APP_MASTER
	if( mainMenu.GetDumpStageInfoProc() >= 0 ){
		return true;
	}
#endif
	WK7StageHanaInfo		*pHanaInfo;
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()==K7SCN99 ){
	#ifdef	USE_ISDOLVIEWER
		char					itemno[6];
		char					str[128];
	static	const char			*pFileName = "/Wat/Hana.txt";
		defitemid = WK7STAGE_HANA_ITEMID_DEF;
		if( usbFile.Open(pFileName,FIO_OPEN_RDONLY)==true ){
			u32			mainid;
			u32			suffix;
			int			i;
			
			usbFile.Read(itemno,sizeof(itemno));
			
			mainid = 0;
			for(i=0 ; i<3 ; i++){
				if( itemno[i] < '0' || itemno[i] > '9' ){
					sprintf(str,"Error MainID %d %d",i,itemno[i]);
					K7AppDebugPrint(str);
					break;
				}
				mainid *= 10;
				mainid += itemno[i] - '0';
			}
			
			if( i==3 && itemno[3]=='M' ){
				suffix = 0;
				for(i=4 ; i<6 ; i++){
					if( itemno[i] < '0' || itemno[i] > '9' ){
						sprintf(str,"Error Suffix %d %d",i,itemno[i]);
						K7AppDebugPrint(str);
						break;
					}
					suffix *= 10;
					suffix += itemno[i] - '0';
				}
				if( i==6 ){
					defitemid = K7ITEMID(mainid,suffix);
				}
			}
			
			usbFile.Close();
		}
		sprintf(str,"Hana %03dM%02d",K7ITEM_MAINID(defitemid),K7ITEM_SUFFIX(defitemid));
		K7AppDebugPrint(str);
		CreateOwnItem(defitemid);
	#else
		CreateOwnItem(WK7STAGE_HANA_ITEMID_DEF);
	#endif
	}
#endif
	for(pHanaInfo=stageHanaInfo ; pHanaInfo->mID!=0xffffffff ; pHanaInfo++){
		if( pHanaInfo->mID!=mID ){
			continue;
		}
		if( CreateOwnItem(pHanaInfo->mItemID)==NULL ){
			OSDebugReport("Hana(Item%03dM%02d) Not Found or Created.",K7ITEM_MAINID(pHanaInfo->mItemID),K7ITEM_SUFFIX(pHanaInfo->mItemID));
		}
	}
	return true;
}

bool WK7Stage::IsLoadingHana(void)
{
	return false;
}


bool WK7Stage::ReleaseZan(void)
{
	WK7StageZan		*pZan;
	WK7StageZan		*pNext;
	for(pZan=(WK7StageZan *)mZanAnchor.GetNext() ; pZan!=NULL ; pZan=pNext){
		pNext = pZan->GetNext();
		delete pZan;
	}
	return true;
}

WK7StageZan* WK7Stage::GetZan(u32 eventNo)
{
	WK7StageZan		*pZan;
	for(pZan=(WK7StageZan *)mZanAnchor.GetNext() ; pZan!=NULL ; pZan=pZan->GetNext()){
		if( pZan->GetEventNo()==eventNo ){
			return pZan;
		}
	}
	return NULL;
}

bool WK7Stage::ZanHitEvent(WK7HitObjInfo &info)
{
	WK7StageZan		*pZan = GetZan(info.mEventNo);
	
	if( pZan==NULL ){
		return false;
	}
	WK7Chara		*pZanChara = pZan->GetChara();
	
	KK7BattleMainTask::BattleMainTaskExit(1);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	
	info.SetHitObjEnable(true);
//	if( info.mpHitObj!=NULL ){
//		info.mpHitObj->SetEnable(true);
//	}
	
	WK7Model	*pModel;
	WK7JObj		*pDispJObj = NULL;
	WK7JObj		*pHideJObj = NULL;
	
	if( (pModel=pZan->GetModel())!=NULL ){
		WK7JObj		*pKamenHandJObj;
		WK7JObj		*pKamenFaceJObj;
		pKamenHandJObj = pModel->GetObj(K7ZA7_KAMEN_HAND_OBJNAME);
		pKamenFaceJObj = pModel->GetObj(K7ZA7_KAMEN_FACE_OBJNAME);
		if( K7SCR_EVHASITEM(info.mEventNo)==true ){
			K7SCR_EVSETITEM(info.mEventNo,false);
			pDispJObj = pKamenHandJObj;
			pHideJObj = pKamenFaceJObj;
		}else{
			K7SCR_EVSETITEM(info.mEventNo,true );
			pDispJObj = pKamenFaceJObj;
			pHideJObj = pKamenHandJObj;
			// ttO낷
			K7SCR_EVUSEITEM(info.mEventNo,false);
		}
	}
	
	if( pZanChara != NULL ){
		
		WK7RenderObjEffect	*pBloodEffect;
		Vec					pos,dir;
		f32					roty;
		
		K7SCR_RETSYS();
		
		pZanChara->GetPosition(pos);
		pZanChara->GetRotY(&roty);
		dir.y = 0.0f;
		dir.x = sinf(roty);
		dir.z = cosf(roty);
		
		WK7RenderObjEffectInfo	info;
		EFFECT					*pYamEfc;
		info.Create();
		pBloodEffect = pZanChara->CreateEffect((pYamEfc=CreateHSDeadEffect(pHideJObj,
											dir,
											VParam[ED_HSD1][0] / 10.0F,	// Power ԑ
											pos.y,
											VParam[ED_HSD1][1],			// BloodNum ̐
											(u8)VParam[ED_HSD1][2],		// Wait
											0,							// Mode
											NULL,						// BInfo
											3000,						// BInfoMaxNum
											NULL,						// BInfoNumBuffer		
											false,						// BloodEffectDeleteFlag
											false,						// ConveFlag
											60 * WK7_FRAME_RATE / 30,	// ConveWaitTime
											0.01F,						// ConvePower
											BLOODTEX_BLOOD,
											TRUE,
											FALSE
		)));
		if( pYamEfc!=NULL ){ info.Parent(pYamEfc); }
		
		K7SCR_JOBJ_HIDE(pHideJObj);
		
		while( pZanChara->IsValidEffect(pBloodEffect)==true ){
			K7SCR_RETSYS();
		}
		
		info.Create();
		pBloodEffect = pZanChara->CreateEffect((pYamEfc=CreateHSDeadEffect(pDispJObj,
											dir,
											VParam[ED_HSD1][0] / 10.0F,	// Power ԑ
											pos.y,
											VParam[ED_HSD1][1],			// BloodNum ̐
											(u8)VParam[ED_HSD1][2],		// Wait
											0,							// Mode
											NULL,						// BInfo
											3000,						// BInfoMaxNum
											NULL,						// BInfoNumBuffer		
											false,						// BloodEffectDeleteFlag
											false,						// ConveFlag
											60 * WK7_FRAME_RATE / 30,	// ConveWaitTime
											0.01F,						// ConvePower
											BLOODTEX_BLOOD,
											TRUE,
											TRUE
		)));
		if( pYamEfc!=NULL ){ info.Parent(pYamEfc); }
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
		
		K7SCR_JOBJ_DISP(pDispJObj);
		
		while( pZanChara->IsValidEffect(pBloodEffect)==true ){
			K7SCR_RETSYS();
		}
		
	}
	
	K7SCR_JOBJ_DISP(pDispJObj);
	K7SCR_JOBJ_HIDE(pHideJObj);
	
//	K7SCR_PC_SETVISIBLE(false);
//	
//	WK7JObj		*pJObj;
//	pJObj = GetJObj(pWallInfo->mpWallName);
//	K7SCR_JOBJ_HIDE         (pJObj);
//	K7SCR_SET_SCENARIO_FLAG (pWallInfo->mFlagID);
//	K7SCR_STG_SET_PATHENABLE(pWallInfo->mpPathName,true);
//	CallCondChange();
//	
//	if( pWallInfo->mCamID >= 0 ){
//		FixCam((u32)pWallInfo->mCamID);
//	}
//	
//	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_BREAK_WALL);
//	K7SCR_PC_RETURNVISIBLE();
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return true;
}

WK7StageZan::WK7StageZan(ghmGcListObj *pAnchor,WK7Stage *pContainer,u32 eventNo,u32 charaid,WK7Chara *pChara,u32 motid,WK7CharaMotion *pMotion) : ghmGcListObj(pAnchor)
{
	int		i;
	for(i=0 ; i<WK7STAGEZAN_MOTIONNUM ; i++){
		mpCharaMotion[i] = NULL;
	}
	mpContainer       = pContainer;
	mEventNo          = eventNo;
	mCharaID          = charaid;
	mpChara           = pChara;
	mMotID            = motid;
	mpCharaMotion[0]  = pMotion;
	mPosition.x       = 
	mPosition.y       = 
	mPosition.z       = 0.0f;
	mRotation.x       = 
	mRotation.y       = 
	mRotation.z       = 0.0f;
	mpAlpha           = NULL;
	mpInfo            = NULL;
	mProc             = 0;
	mEnable           = true;
	mForcedDisp       = false;
	if( pChara!=NULL ){
		switch( K7CHR_MAINID(charaid) ){
		case	K7ZA2:
			if( K7CHR_SUFFIX(charaid)==1 ){
				// J[`bv
				mpCharaMotion[1] = (WK7CharaMotion *)WK7MotionObj::CreateCharaMotion(K7MOTID(K7CHR_MAINID(charaid),330));
				mpCharaMotion[2] = (WK7CharaMotion *)WK7MotionObj::CreateCharaMotion(K7MOTID(K7CHR_MAINID(charaid),340));
				break;
			}
		case	K7ZA3:
			mpCharaMotion[1] = (WK7CharaMotion *)WK7MotionObj::CreateCharaMotion(K7MOTID(K7CHR_MAINID(charaid),30));
			mpCharaMotion[2] = (WK7CharaMotion *)WK7MotionObj::CreateCharaMotion(K7MOTID(K7CHR_MAINID(charaid),40));
			break;
		case	K7ZA7:
			mpCharaMotion[1] = (WK7CharaMotion *)WK7MotionObj::CreateCharaMotion(K7MOTID(K7CHR_MAINID(charaid),30));
			break;
		default:
			break;
		}
	}
}

WK7StageZan::~WK7StageZan()
{
	GHM_SAFE_DELETE(mpAlpha);
	mEventNo      = 0xffffffff;
	mCharaID      = 0xffffffff;
	if( WK7RenderObj::IsValid(mpChara)==true ){
		GHM_SAFE_DELETE(mpChara);
	}
	mMotID        = 0xffffffff;
	int		i;
	for(i=0 ; i<WK7STAGEZAN_MOTIONNUM ; i++){
		if( WK7MotionObj::IsValid(mpCharaMotion[i])==true ){
			GHM_SAFE_DELETE(mpCharaMotion[i]);
		}
	}
}

bool WK7StageZan::PlayMotion(int index,bool loop,f32 startframe)
{
	if( index < 0 || index > 2 ){
		return false;
	}
	WK7Model		*pModel;
	if( mpChara==NULL || (pModel=mpChara->GetModel())==NULL ){
		return false;
	}
	if( mpCharaMotion[index]==NULL ){
		return false;
	}
	WK7ModelMotion	*pModelMotion = mpCharaMotion[index]->GetModelMotion();
	if( pModelMotion==NULL ){
		return false;
	}
	pModel->AttachMotion (pModelMotion);
	pModel->PlayMotion   (startframe);
	pModel->SetMotionLoop(loop);
	return true;
}

bool WK7StageZan::Initialize(void)
{
	GHM_SAFE_DELETE(mpAlpha);
	if( mpChara==NULL ){
		return false;
	}
	WK7Model		*pModel = mpChara->GetModel();
	mpChara->CreatePrivateLight();
	mpChara->SetStageLight(false);
	if( pModel!=NULL ){
		WK7JObj		*pRoot = pModel->GetObj(K7CHRBONE_ROOT);
		if( pRoot!=NULL ){
			pRoot->SetPosition(mPosition);
			pRoot->SetRotation(mRotation);
		}
		PlayMotion(0);
//		if( mpCharaMotion[0]!=NULL ){
//			WK7ModelMotion	*pModelMotion = mpCharaMotion[0]->GetModelMotion();
//			if( pModelMotion!=NULL ){
//				pModel->AttachMotion (pModelMotion);
//				pModel->PlayMotion   ();
//				pModel->SetMotionLoop(true);
//			}
//		}
	}
	WK7JObj		*pJObj;
	HSD_JObj	*pHSDJObj;
	mAlpha.SetValue(0.0f);
	if( (pJObj = mpChara->GetJObj())!=NULL && (pHSDJObj=pJObj->GetJObj())!=NULL ){
		pJObj->SetDstAlpha(0,false,true);		// e
		pJObj->SetCastShadowDisable(true);
		pJObj->SetZSortPrio(WK7JOBJ_ZSORTPRIO_DEFAULT+256);
		ghmGcMemSetAllocName("STZANALP");
		mpAlpha = new C_SetAlpha(pHSDJObj,mAlpha.GetValue());
	}
//	if( K7SCR_EVHASITEM(K7EVENTZANID(mEventNo))==TRUE &&
//	    (mpInfo==NULL || mpInfo->mAppearCount==0) ){
//		mpChara->SetRenderFlag(false);
//	}else{
		mpChara->SetRenderFlag(true );
//	}
//	WK7CastShadowObj	*pCastShadowObj;
//	if( (pCastShadowObj=WK7SHADOW->FindCastShadowObj(mpChara))!=NULL ){
//		pCastShadowObj->SetTrspMask(HSD_TRSP_ALL);
//	}
	InitYunion();
	InitIwazaru();
	return true;
}

bool WK7StageZan::InitYunion(void)
{
	if( K7CHR_MAINID(mCharaID)!=K7ZA7 ){
		return true;
	}
	WK7Model		*pModel = mpChara->GetModel();
	WK7JObj			*pKamenHandJObj = pModel->GetObj(K7ZA7_KAMEN_HAND_OBJNAME);
	WK7JObj			*pKamenFaceJObj = pModel->GetObj(K7ZA7_KAMEN_FACE_OBJNAME);
//		pKamenHandJObj->DetachMotion(false,true);
//		pKamenFaceJObj->DetachMotion(false,true);
	if( mpContainer != NULL ){//&& K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE)==FALSE ){
		mpContainer->SetHitObj(pKamenHandJObj,mEventNo);
		// ʂԂ猳ɖ߂ȂIII
//		mpContainer->SetHitObj(pKamenFaceJObj,mEventNo);
	}
	if( K7SCR_EVHASITEM(mEventNo)==true ){//|| K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE)==TRUE ){
		K7SCR_JOBJ_DISP(pKamenFaceJObj);
		K7SCR_JOBJ_HIDE(pKamenHandJObj);
		mProc = 1;
		PlayMotion(1);
	}else{
		K7SCR_JOBJ_DISP(pKamenHandJObj);
		K7SCR_JOBJ_HIDE(pKamenFaceJObj);
		mProc = 0;
		PlayMotion(0);
	}
	return true;
}

WK7StageZanColChipInfo	zanColChipInfo[] = {
#define	__WK7STGZAN_COLCHIP__
#include	"..\Stage\info\K7StageZanInfo.h"
#undef	__WK7STGZAN_COLCHIP__
	{ 0xffffffff , -1 , -1 },
};

WK7StageZanColChipInfo* WK7StageZan::GetZanColChipInfo(u32 eventNo)
{
	WK7StageZanColChipInfo	*pInfo;
	for(pInfo=zanColChipInfo ; pInfo->mZanID!=0xffffffff ; pInfo++){
		if( pInfo->mZanID==eventNo ){
			return pInfo;
		}
	}
	return NULL;
}

WK7JObj* WK7StageZan::GetColorChip(int color)
{
static	const char*	colorChipName[] = {
	//
	"Chip_R",
	"Chip_G",
	"Chip_RG",
	"Chip_B",
	"Chip_RB",
	"Chip_GB",
	"Chip_RGB",
};
	if( color==0 || color>K7ZAN_COL_RGB ){
		return NULL;
	}
	return mpChara->GetJObj(colorChipName[color-1]);
}

bool WK7StageZan::InitIwazaru(void)
{
	if( mCharaID!=K7CHRID(K7ZA2,1) ){
		return true;
	}
	int			color;
	WK7StageZanColChipInfo	*pZanColChipInfo = GetZanColChipInfo(mEventNo);
	if( K7SCR_EVHASITEM(mEventNo)==true || pZanColChipInfo==NULL ){
		color = 0;
	}else{
		if( (color = pZanColChipInfo->mColorID) < 0 || color > K7ZAN_COL_RGB ){
			color = 0;
		}
	}
	int			i;
	for(i=1 ; i<8 ; i++){
		WK7JObj	*pJObj = GetColorChip(i);
		if( pJObj==NULL ){
			continue;
		}
		if( i==color ){
			pJObj->Disp(false,true);
		}else{
			pJObj->Hide(false,true);
		}
	}
	return true;
}

bool WK7StageZan::FrameProcess(void)
{
	Vec					pos;
	bool				appear;
	WK7Model			*pModel;
	WK7ModelMotion		*pModelMotion; 
	f32					dist;
	ghmGcCollSphere		sphere;
	bool				renderFlag;
	
	if( mpChara==NULL || (pModel = mpChara->GetModel())==NULL ){
		return false;
	}
	
	WK7PLAYERCONTROL->GetPathPosition(&pos);
	pos.y = mPosition.y;
	
	WK7JObj				*pRootJoint;
	sphere.mRadius = 10.0f;
	if( (pRootJoint=pModel->GetObj(K7CHRBONE_WAIST))!=NULL ){
		sphere.mPosition.x = 0.0f;
		sphere.mPosition.y = 0.0f;
		sphere.mPosition.z = 0.0f;
		MTXMultVec(pRootJoint->GetLocalWorldMatrix(),&sphere.mPosition,&sphere.mPosition);
	}else{
		sphere.mPosition.x = mPosition.x;
		sphere.mPosition.y = mPosition.y + sphere.mRadius;
		sphere.mPosition.z = mPosition.z;
	}
	if( WK7Stage::GetViewVolume()->GetCrossState(sphere)==ghmGcCollObj::OUTSIDE ){
		renderFlag = false;
		if( K7CHR_MAINID(mCharaID)==K7ZA2 ){
			// CU
			ghmGcCollBox	box;
			box.mExtent.x = 1.0f;
			box.mExtent.y = (50.0f - 20.0f) * 0.5f;
			box.mExtent.z = 1.0f;
			MTXTrans (box.mCoordinate,sphere.mPosition.x,
			                          sphere.mPosition.y + 20.0f + box.mExtent.y,
			                          sphere.mPosition.z);
			if( WK7Stage::GetViewVolume()->GetCrossState(box)!=ghmGcCollObj::OUTSIDE ){
				renderFlag = true;
			}
		}
	}else{
		renderFlag = true;
	}
	if( WK7Stage::GetRenderStage()==false || (mpContainer!=NULL && mpContainer->GetRenderFlag()==false) ){
		renderFlag = false;
	}
	
	mAlpha.FrameProcess();
	
	if( mAlpha.GetValue()<=0.0f ){
		renderFlag = false;
	}
	
	switch( mEventNo & K7EV_TYPE_MASK ){
	case	K7EV_TYPE_ZAN:
//static	f32	dist = 50.0f;
static	f32	distza4 =  60.0f;
static	f32	distza2 =  75.0f;
		switch( K7CHR_MAINID(mCharaID) ){
		case	K7ZA1:
		case	K7ZA3:
		case	K7ZA4:
		case	K7ZA5:
		case	K7ZA6:
		case	K7ZA7:
			dist = distza4;
			break;
//		case	K7ZAA:
//			dist = distza2;
//			break;
		case	K7ZA2:
		default:
			dist = distza2;
			if( K7SCR_EVHASITEM(mEventNo)==true ){
				// xoꂵoĂȂ
				dist = 0.0f;
			}
			break;
		}
		if( dist > 0.0f && mpInfo!=NULL && mpInfo->mJudgeDistance >= 0.0f ){
			dist = mpInfo->mJudgeDistance;
		}
		if( (GHM_VEC_DIST(&pos,&mPosition) < dist || mForcedDisp==true) && mEnable==true ){
			appear = true;
		}else{
			appear = false;
		}
		if( appear==true ){
			if( mAlpha.GetDstValue() < WK7ZAN_FADE_ALPHA ){
				mAlpha.Play(WK7ZAN_FADE_ALPHA,WK7_SEC_TO_TICK(1));
			}
		}else{
			if( mAlpha.GetDstValue() > 0.0f ){
				mAlpha.Play(0.0f,WK7_SEC_TO_TICK(1));
			}
		}
		switch( K7CHR_MAINID(mCharaID) ){
		case	K7ZA7:
			switch( mProc ){
			case	0:
				if( K7SCR_EVHASITEM(mEventNo)==true ){
					PlayMotion(1);
					mProc = 1;
				}
				break;
			default:
//				if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE)==TRUE ){
//					break;
//				}
				if( K7SCR_EVHASITEM(mEventNo)==false ){
					PlayMotion(0);
					mProc = 0;
				}
				break;
			}
			mpChara->SetRenderFlag(renderFlag);
			break;
		case	K7ZA2:
			switch( mProc ){
			case	0:
				if( appear==false ){
					break;
				}
				// o
				mProc++;
				pModel->DetachMotion();
				if( mpCharaMotion[1]!=NULL && (pModelMotion = mpCharaMotion[1]->GetModelMotion())!=NULL ){
					pModel->AttachMotion (pModelMotion);
					pModel->PlayMotion   ();
					pModel->SetMotionLoop(false);
				}
				break;
			case	1:
				// o[V҂
				if( pModel->GetMotionState()!=WK7MODEL_NOANIM ){
					break;
				}
				mProc++;
				pModel->DetachMotion();
				if( mpCharaMotion[0]!=NULL && (pModelMotion = mpCharaMotion[0]->GetModelMotion())!=NULL ){
					pModel->AttachMotion (pModelMotion);
					pModel->PlayMotion   ();
					pModel->SetMotionLoop(true);
				}
				break;
			case	2:
				if( appear==true ){
					break;
				}
				// ޏo
				mProc++;
				pModel->DetachMotion();
				if( mpCharaMotion[2]!=NULL && (pModelMotion = mpCharaMotion[2]->GetModelMotion())!=NULL ){
					pModel->AttachMotion (pModelMotion);
					pModel->PlayMotion   ();
					pModel->SetMotionLoop(false);
				}
				break;
			case	3:
				// ޏo[V҂
				if( pModel->GetMotionState()!=WK7MODEL_NOANIM ){
					break;
				}
				mProc = 0;
				break;
			default:
				break;
			}
			mpChara->SetRenderFlag(renderFlag);
			break;
		case	K7ZA1:
		case	K7ZA3:
		case	K7ZA4:
		case	K7ZA5:
		case	K7ZA6:
//		case	K7ZAA:
			if( mEnable==true ){
				mpChara->SetRenderFlag(renderFlag);
			}else{
				mpChara->SetRenderFlag(false);
			}
			break;
		default:
			if( mAlpha.GetValue()==0.0f ){
				mpChara->SetRenderFlag(false);
			}else{
				mpChara->SetRenderFlag(renderFlag);
			}
			break;
		}
		break;
	case	K7EV_TYPE_TAMA:
static	f32	tamadist = 50.0f;
		if( mpInfo!=NULL && mpInfo->mJudgeDistance >= 0.0f ){
			dist = mpInfo->mJudgeDistance;
		}else{
			dist = tamadist;
		}
		if( GHM_VEC_DIST(&pos,&mPosition) > dist && WK7EventItem::HasItem(mEventNo)==false && mEnable==true ){
			appear = true;
		}else{
			appear = false;
		}
		if( appear==true ){
			if( mAlpha.GetDstValue() < WK7ZAN_FADE_ALPHA ){
				mAlpha.Play(WK7ZAN_FADE_ALPHA,WK7_SEC_TO_TICK(1));
			}
		}else{
			if( mAlpha.GetDstValue() > 0.0f ){
				mAlpha.Play(0.0f,WK7_SEC_TO_TICK(1));
			}
		}
		switch( mCharaID ){
		case	K7CHRID(K7ZA3, 0):
			switch( mProc ){
			case	0:
				if( appear==false ){
					break;
				}
				// o
				mProc++;
				pModel->DetachMotion();
				if( mpCharaMotion[1]!=NULL && (pModelMotion = mpCharaMotion[1]->GetModelMotion())!=NULL ){
					pModel->AttachMotion (pModelMotion);
					pModel->PlayMotion   ();
					pModel->SetMotionLoop(false);
				}
				gpSound->mPlaySE(SFX_SYS_KIKAZARU_DERU);
				break;
			case	1:
				// o[V҂
				if( pModel->GetMotionState()!=WK7MODEL_NOANIM ){
					break;
				}
				mProc++;
				pModel->DetachMotion();
				if( mpCharaMotion[0]!=NULL && (pModelMotion = mpCharaMotion[0]->GetModelMotion())!=NULL ){
					pModel->AttachMotion (pModelMotion);
					pModel->PlayMotion   ();
					pModel->SetMotionLoop(true);
				}
				break;
			case	2:
				if( appear==true ){
					break;
				}
				// ޏo
				mProc++;
				pModel->DetachMotion();
				if( mpCharaMotion[2]!=NULL && (pModelMotion = mpCharaMotion[2]->GetModelMotion())!=NULL ){
					pModel->AttachMotion (pModelMotion);
					pModel->PlayMotion   ();
					pModel->SetMotionLoop(false);
				}
				gpSound->mPlaySE(SFX_SYS_KIKAZARU_KIERU);
				break;
			case	3:
				// ޏo[V҂
				if( pModel->GetMotionState()!=WK7MODEL_NOANIM ){
					break;
				}
				mProc = 0;
				break;
			default:
				break;
			}
			mpChara->SetRenderFlag(renderFlag);
			break;
		default:
			if( mEnable==true ){
				mpChara->SetRenderFlag(renderFlag);
			}else{
				mpChara->SetRenderFlag(false);
			}
			break;
		}
		break;
	default:
		break;
	}
	
	if( mpAlpha!=NULL ){
		mpAlpha->SetVal(mAlpha.GetValue());
	}
	
	return true;
}

bool WK7StageZan::IsLoading(void)
{
	if( mpChara!=NULL ){
		if( mpChara->GetState()!=WK7RenderObj::LOADED ){
			return true;
		}
	}
	int			i;
	for(i=0 ; i<WK7STAGEZAN_MOTIONNUM ; i++){
		if( mpCharaMotion[i]==NULL ){
			continue;
		}
		if( mpCharaMotion[i]->GetState()!=WK7MotionObj::LOADED ){
			return true;
		}
	}
	return false;
}

WK7Chara* WK7StageZan::GetChara(void)
{
	return mpChara;
}

WK7CharaMotion* WK7StageZan::GetCharaMotion(int index)
{
	if( index < 0 || index >= WK7STAGEZAN_MOTIONNUM ){
		return NULL;
	}
	return mpCharaMotion[index];
}

WK7Model* WK7StageZan::GetModel(void)
{
	WK7Chara	*pChara = GetChara();
	if( pChara==NULL ){
		return NULL;
	}
	return pChara->GetModel();
}

WK7ModelMotion* WK7StageZan::GetModelMotion(int index)
{
	WK7CharaMotion	*pCharaMotion = GetCharaMotion(index);
	if( pCharaMotion==NULL ){
		return NULL;
	}
	return pCharaMotion->GetModelMotion();
}

WK7StageZanInfo* WK7Stage::GetZanInfo(u32 eventNo)
{
	WK7StageZanInfo		*pInfo;
	eventNo &= K7EV_ID_MASK;
	for(pInfo=stageZanInfo ; pInfo->mZanID!=0xffffffff ; pInfo++){
		if( pInfo->mZanID==eventNo ){
			return pInfo;
		}
	}
	return NULL;
}

bool WK7Stage::CreateZan(WK7JObj *pLocator,u32 eventNo)
{
	if( eventNo==0xffffffff ){
		return false;
	}
	WK7StageZan		*pZan;
	WK7Chara		*pChara;
	WK7CharaMotion	*pCharaMotion;
	u32				charaid = 0xffffffff,motid = 0xffffffff;
	GetZanChara(pLocator,charaid,motid);
	if( charaid==0xffffffff ){
		switch( eventNo & K7EV_TYPE_MASK ){
		case	K7EV_TYPE_TAMA:
			charaid = K7CHRID(K7ZA3, 0);
			break;
		case	K7EV_TYPE_ZAN:
		default:
			charaid = K7CHRID(K7ZA4, 0);
			break;
		}
	}
	if( charaid==K7CHRID(K7ZA2,1) ){
		motid = K7MOTID(K7ZA2,320);
	}
	if( motid==0xffffffff && charaid != 0xffffffff ){
//		switch( K7CHR_MAINID(charaid) ){
//		case	K7ZA2:
//		case	K7ZA3:
//		case	K7ZA4:
			motid = K7MOTID(K7CHR_MAINID(charaid),20);
//			break;
//		default:
//			motid = K7MOTID(K7CHR_MAINID(charaid),20);
//			break;
//		}
	}
	if( (pChara=WK7RenderObj::CreateChara(charaid))==NULL ){
		return false;
	}
	pCharaMotion = (WK7CharaMotion *)WK7MotionObj::CreateCharaMotion(motid);
	ghmGcMemSetAllocName("STZAN");
	if( (pZan = new WK7StageZan(&mZanAnchor,this,eventNo,charaid,pChara,motid,pCharaMotion))==NULL ){
		return false;
	}
	WK7StageZanInfo		*pInfo;
	eventNo &= K7EV_ID_MASK;
	for(pInfo=stageZanInfo ; pInfo->mZanID!=0xffffffff ; pInfo++){
		if( pInfo->mZanID==eventNo ){
			pZan->SetInfo(pInfo);
			break;
		}
	}
	return true;
}

bool WK7Stage::CreateZan(void)
{
	WK7PathBranchPoint	*pBranchPoint;
	if( mpPath==NULL ){
		return true;
	}
#ifndef	K7APP_MASTER
	if( mainMenu.GetDumpStageInfoProc() >= 0 ){
		return true;
	}
#endif
	const char	*pBranchPointName;
	u32			eventNo;
	for(pBranchPoint=mpPath->GetBranchPointTop() ; pBranchPoint!=NULL ; pBranchPoint=pBranchPoint->GetNext()){
		if( (pBranchPointName = pBranchPoint->GetName())==NULL ){
			continue;
		}
		ghmGcMemSetAllocName("STZANBPE");
		WK7StageBpEvent		*pBpName = new WK7StageBpEvent(pBranchPointName);
		if( pBpName==NULL ){
			continue;
		}
		WK7StageBpEventZanPoint	*pZanPoint = pBpName->GetZanPoint();
		if( pZanPoint!=NULL ){
			WK7StageBpEventZan	*pZanEvent;
			WK7JObj				*pLocator;
			for(pZanEvent=pZanPoint->GetZanTop() ; pZanEvent!=NULL ; pZanEvent=pZanEvent->GetNext()){
				if( pZanEvent->GetSelectObjName()==NULL ){
					continue;
				}
				eventNo = pZanEvent->GetEventNo();
				if( (pLocator = GetZanLocator(eventNo))==NULL ){
					continue;
				}
				CreateZan(pLocator,eventNo);
			}
		}
		GHM_SAFE_DELETE(pBpName);
	}
	WK7JObj		*pZanRoot = GetJObj("zan");
	if( pZanRoot==NULL ){
		return true;
	}
	WK7JObj		*pLocator;
	for(pLocator=pZanRoot->GetChild() ; pLocator!=NULL ; pLocator=pLocator->GetNext()){
		eventNo = GetLocatorEventNo(pLocator);		
		if( (eventNo & K7EV_TYPE_MASK) != K7EV_TYPE_TAMA ){
			continue;
		}
		CreateZan(pLocator,eventNo);
	}
	return true;
}

bool WK7Stage::IsLoadingZan(void)
{
	WK7StageZan		*pZan;
	for(pZan=(WK7StageZan *)mZanAnchor.GetNext() ; pZan!=NULL ; pZan=pZan->GetNext()){
		if( pZan->IsLoading()==true ){
			return true;
		}
	}
	return false;
}

bool WK7Stage::InitializeZan(void)
{
	ChangeZanEventState();
	return true;
}

bool WK7Stage::ChangeZanEventState(void)
{
	WK7StageZan		*pZan;
	WK7Chara		*pChara;
	WK7JObj			*pLocator;
	Vec				pos,rot;
	for(pZan=(WK7StageZan *)mZanAnchor.GetNext() ; pZan!=NULL ; pZan=pZan->GetNext()){
		if( (pChara = pZan->GetChara())==NULL ){
			continue;
		}
		u32			eventNo = pZan->GetEventNo();
		pos.x = 0.0f;
		pos.y = 0.0f;
		pos.z = 0.0f;
		rot.x = 0.0f;
		rot.y = 0.0f;
		rot.z = 0.0f;
		if( (pLocator = GetZanLocator(eventNo))!=NULL ){
			pLocator->GetPosition(pos);
			pLocator->GetRotation(rot);
		}else{
			WK7PathBranchPoint			*pBranchPoint;
			WK7PathBranchPointObjJObj	*pBranchPointObjJObj;
			WK7JObj						*pJObj;
			if( mpPath!=NULL &&
			    (pBranchPointObjJObj = mpPath->GetObj_EventNo(eventNo))!=NULL &&
			    (pBranchPoint = pBranchPointObjJObj->GetBranchPoint())!=NULL &&
			    (pJObj=pBranchPointObjJObj->GetJObj())!=NULL ){
				Vec		bpos;
				pJObj       ->GetPosition(&pos );
				pBranchPoint->GetPosition(&bpos);
				pos.y = bpos.y;
			}
		}
		pZan->SetPosition(pos);
		pZan->SetRotation(rot);
		pZan->Initialize();
	}
	return true;
}

bool WK7Stage::SetZanEnable(u32 zanno,bool flag)
{
	WK7StageZan		*pZan;
	for(pZan=(WK7StageZan *)mZanAnchor.GetNext() ; pZan!=NULL ; pZan=pZan->GetNext()){
		if( pZan->GetEventNo()==zanno ){
			pZan->SetEnable(flag);
		}
	}
	return true;
}

bool WK7Stage::SetZanEventEnable(u32 zanno,bool flag)
{
	SetZanEnable(zanno,flag);
	K7SCR_EVNO_SETENABLE(zanno,flag);
	return true;
}

WK7HitObjJObj* WK7Stage::SetHitObj(WK7JObj *pJObj,u32 eventNo,u32 renderID)
{
	switch( renderID ){
	case	WK7STAGE_HITOBJ_ALLOC_RENDERID:
		if( (renderID = WK7RenderObj::GetUniqueRenderID(false,WK7RENDEROBJ_RENDERID_DEFAULT-1))==0xffffffff ){
			return NULL;
		}
		break;
	case	WK7STAGE_HITOBJ_ALLOC_ENEMYRENDERID:
		if( (renderID = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF))==0xffffffff ){
			return NULL;
		}
		break;
	}
	if( eventNo==0xffffffff ){
		eventNo = GetEventNo(pJObj);
		if( eventNo==0xffffffff ){
			return NULL;
		}
	}
	ghmGcMemSetAllocName("HitObjJ");
	WK7HitObjJObj	*pHitObj = new WK7HitObjJObj;
	if( pHitObj==NULL ){
		return NULL;
	}
	pHitObj->SetStage(this);
	u32						eventID = 0xffffffff;
	K7EventDescStgHitObj	*pDesc = NULL;
	WK7EventIDTable			*pEventIDTable = WK7Event::FindIDTable(eventNo);
	if( pEventIDTable!=NULL ){
		eventID = pEventIDTable->mEventID;
	}
	pHitObj->SetJObj(pJObj);
	pHitObj->SetEnable(true);
	pHitObj->SetRenderID(renderID);
	pHitObj->SetEventID(eventID);
	pHitObj->SetEventNo(eventNo);
	SetRenderID(pJObj,WK7RenderObj::ConvRenderIDToAlpha(renderID),false,true);
//	switch( eventNo & K7EV_TYPE_MASK ){
//	case	K7EV_TYPE_HANA:
//		// 
//		switch( GameInfo.GetHanaFlag(eventNo,mID) ){
//		case	TRUE:
//			pHitObj->SetEnable(false);
//			pJObj->Hide(false,true);
//			break;
//		case	FALSE:
//		default:
//			break;
//		}
//		break;
//	default:
//		// ʏ̉IuWFNg
//		break;
//	}
	return pHitObj;
}

bool WK7Stage::InitializeHitObj(void)
{
	WK7JObj		*pJObj;
	if( mpModel==NULL || (pJObj=mpModel->GetObj("hit"))==NULL ){
		return true;
	}
	for(pJObj=pJObj->GetChild() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
		SetHitObj(pJObj);
	}
	return true;
}

bool WK7Stage::InitializeHarmanRoom(void)
{
	WK7JObj		*pJObj;
	if( mID==WK7STAGE_GALSTAGEID ){
		mHarmanRoomNum = 1;
	}else{
		mHarmanRoomNum = 0;
	}
	if( mpModel==NULL || (pJObj=mpModel->GetObj(WK7STAGE_TVSTAGE_PREFIX))==NULL ){
		return true;
	}
	const char	*pName;
	u32			len = strlen(WK7STAGE_TVSTAGE_PREFIX);
	for(pJObj=pJObj->GetChild() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
		if( (pName = pJObj->GetName())==NULL ){
			continue;
		}
		if( strstr(pName,WK7STAGE_TVSTAGE_PREFIX)!=pName ){
			continue;
		}
		pName += len;
		int		id;
		if( *pName >= '1' && *pName <= '9' ){
			id = (int)(*pName - '1');
		}else if( *pName=='\0' ){
			id = 0;
		}else{
			continue;
		}
		if( mHarmanRoomNum <       id+1 ){
			mHarmanRoomNum = (s16)(id+1);
		}
		WK7JObj		*pOn,*pOff;
		bool		flag = GetHarmanRoomFlag(mID,id);
		if( (pOn  = pJObj->GetObj("ON"))!=NULL ){
			if( flag==true ){
				pOn ->Disp(false,true);
			}else{
				pOn ->Hide(false,true);
			}
		}
		if( (pOff = pJObj->GetObj("OFF"))!=NULL ){
			if( flag==true ){
				pOff->Hide(false,true);
			}else{
				pOff->Disp(false,true);
			}
		}
		
	}
	return true;
}

#define	WK7STAGE_HANAOBJ_PREFIX		"hana_"
bool WK7Stage::InitializeHana(void)
{
	WK7StageHanaInfo		*pHanaInfo;
	WK7Item					*pItem;
	WK7Model				*pModel;
	u32						eventNo;
	WK7JObj					*pJObj;
	WK7JObj					*pHanaJObj;
	u16						seqid;
	const char				*pHanaJObjName;
	int						i;
	WK7Archive				*pArchive;
	u32						scnid;
	u32						itemid;
	
	if( mpModel==NULL || (pHanaJObj=mpModel->GetObj("hana"))==NULL ){
		return false;
	}
	
	for(pHanaJObj=pHanaJObj->GetChild() ; pHanaJObj!=NULL ; pHanaJObj=pHanaJObj->GetNext()){
		
		if( (pHanaJObjName = pHanaJObj->GetName())==NULL ){
			continue;
		}
		
		if( strstr(pHanaJObjName,WK7STAGE_HANAOBJ_PREFIX)!=pHanaJObjName ){
			continue;
		}
		pHanaJObjName += strlen(WK7STAGE_HANAOBJ_PREFIX);
		if( pHanaJObjName[2]!='\0' ){
			continue;
		}
		seqid = 0;
		for(i=0 ; i<2 ; i++){
			if( pHanaJObjName[0] < '0' || pHanaJObjName[0] > '9' ){
				break;
			}
			seqid *= 10;
			seqid += (u32)(pHanaJObjName[i] - '0');
		}
		if( i < 2 ){
			continue;
		}
		
		pItem = NULL;
		for(pHanaInfo=stageHanaInfo ; pHanaInfo->mID!=0xffffffff ; pHanaInfo++){
			if( pHanaInfo->mID!=mID || seqid!=pHanaInfo->mSeqID ){
				continue;
			}
			if( (pItem=GetOwnItem(pHanaInfo->mItemID))==NULL ){
				continue;
			}
			itemid = pHanaInfo->mItemID;
			scnid  = pHanaInfo->mScenarioID;
			break;
		}
		
#ifdef	_DEBUG
		if( GameInfo.GetScenarioID()==K7SCN99 ){
			if( pHanaInfo->mID==0xffffffff ){
	#ifdef	USE_ISDOLVIEWER
				itemid = defitemid;
	#else
				itemid = WK7STAGE_HANA_ITEMID_DEF;
	#endif
				scnid  = 0xffffffff;
				seqid  = 0xffff;
				if( (pItem=GetOwnItem(itemid))==NULL ){
					continue;
				}
			}
		}
#endif
		
		if( pItem!=NULL ){
			
			if( (pArchive=pItem->GetArchive())==NULL ){
				continue;
			}
			if( (pModel=pArchive->CreateModel())==NULL ){
				continue;
			}
			if( (pJObj=pModel->GetTopObj())==NULL ){
				continue;
			}
			
			ghmGcMemSetAllocName("STHANA");
			WK7StageHana	*pHana = new WK7StageHana(&mHanaAnchor,pModel);
			
			pModel->SetPE(GetNormalPEDesc());
			
			eventNo  = K7EV_TYPE_HANA;
			eventNo |= (scnid & 0xff) << 16;
			eventNo |= (K7ITEM_SUFFIX(itemid) & 0xff) << 8;
			eventNo |= (seqid & 0xff);
			SetHitObj(pJObj,eventNo);
			
			Vec		pos,rot,scl;
			
			pHanaJObj->GetPosition(pos);
			pJObj    ->SetPosition(pos);
			pHanaJObj->GetRotation(rot);
			pJObj    ->SetRotation(rot);
			pHanaJObj->GetScale   (scl);
			pJObj    ->SetScale   (scl);
			
		}
	}
	
	return true;
}

WK7StageHana::WK7StageHana(ghmGcListObj *pAnchor,WK7Model *pModel) : ghmGcListObj(pAnchor)
{
	mpModel = pModel;
}

WK7StageHana::~WK7StageHana()
{
	GHM_SAFE_DELETE(mpModel);
}

bool WK7StageHana::FrameProcess(void)
{
	if( mpModel==NULL ){
		return true;
	}
	mpModel->FrameProcess();
	return true;
}

bool WK7StageHana::RenderProcess(void)
{
	if( mpModel==NULL ){
		return true;
	}
	mpModel->RenderProcess();
	return true;
}

bool WK7Stage::ReleaseOwnRenderObjAll(void)
{
	ReleaseZan();
	return WK7RenderObj::ReleaseOwnRenderObjAll();
}

bool WK7Stage::ReleaseHanaAll(void)
{
	WK7StageHana		*pHana;
	WK7StageHana		*pNext;
	for(pHana=(WK7StageHana *)mHanaAnchor.GetNext() ; pHana!=NULL ; pHana=pNext){
		pNext = pHana->GetNext();
		delete pHana;
	}
	return true;
}

bool WK7Stage::CallCreateCallBackTask(void)
{
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()==K7SCN99 ){
		return true;
	}
#endif
	if( WK7EVENTCONTROLLER->CallIM(_CreateCallBackTask,NULL,(u32)this)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_CreateCallBackTask    (ghmGcTask *)
{
	WK7Stage	*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	if( pStage->CreateCallBack()==false ){
		return;
	}
//	WK7Npc::NpcAutoCreateAll(pStage->GetID());
	pStage->CreateNpc ();
	pStage->CreateHana();
//	pStage->CreateZan ();
}

bool WK7Stage::CallInitializeCallBackTask(void)
{
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()==K7SCN99 ){
		return true;
	}
#endif
	if( WK7EVENTCONTROLLER->CallIM(_InitializeCallBackTask,NULL,(u32)this)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_InitializeCallBackTask(ghmGcTask *)
{
	WK7Stage	*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	if( pStage->InitializeCallBack()==false ){
		return;
	}
//	WK7Npc::NpcAutoCreateAll(pStage->GetID());
//	while( WK7Npc::NpcAutoCreateIsLoading()==true ){
//		K7SCR_RETSYS();
//	}
}

bool WK7Stage::CallCondChangeCallBackTask(void)
{
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()==K7SCN99 ){
		return true;
	}
#endif
	if( WK7EVENTCONTROLLER->CallIM(_CondChangeCallBackTask,NULL,(u32)this)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_CondChangeCallBackTask(ghmGcTask *)
{
	WK7Stage	*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	if( pStage->CondChangeCallBack()==false ){
		return;
	}
	pStage->ChangeBrokenWallState();
	pStage->ChangeKihanKuiState  ();
	pStage->InitializeHarmanRoom ();
//	pStage->ChangeZanEventState  ();
}

bool WK7Stage::CallTerminateCallBackTask(void)
{
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()==K7SCN99 ){
		return true;
	}
#endif
	if( WK7EVENTCONTROLLER->CallIM(_TerminateCallBackTask,NULL,(u32)this)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_TerminateCallBackTask (ghmGcTask *)
{
	WK7Stage	*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	pStage->TerminateCallBack();
}

bool WK7Stage::CallSetCurrentCallBackTask(void)
{
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()==K7SCN99 ){
		return true;
	}
#endif
	if( WK7EVENTCONTROLLER->CallIM(_SetCurrentCallBackTask,NULL,(u32)this)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

WK7StageSoundInfo* WK7Stage::GetSoundInfo(void)
{
	return GetSoundInfo(mID);
}

WK7StageSoundInfo* WK7Stage::GetSoundInfo(u32 id)
{
	WK7StageSoundInfo	*pSoundInfo;
	int					i;
	for(i=0 ; i<2 ; i++){
		switch( i ){
		case	0:
			if( (pSoundInfo = mpScenarioSoundInfo)==NULL ){
				continue;
			}
			break;
		case	1:
		default:
			pSoundInfo = stageSoundInfo;
			break;
		}
		for( ; pSoundInfo->mID!=0xffffffff ; pSoundInfo++){
			if( pSoundInfo->mID!=id ){
				continue;
			}
			return pSoundInfo;
		}
	}
	return NULL;
}

WK7StageTamaInfo* WK7Stage::GetTamaInfo(u32 evno)
{
	WK7StageTamaInfo	*pTamaInfo;
	int					i;
	for(i=0 ; i<2 ; i++){
		switch( i ){
		case	0:
			if( (pTamaInfo = mpScenarioTamaInfo)==NULL ){
				continue;
			}
			break;
		case	1:
		default:
			pTamaInfo = stageTamaInfo;
			break;
		}
		for( ; pTamaInfo->mTamaID!=0xffffffff ; pTamaInfo++){
			if( pTamaInfo->mTamaID!=evno ){
				continue;
			}
			return pTamaInfo;
		}
	}
	return NULL;
}

bool WK7Stage::SetCurrentCallBackDefaultProc(void)
{
	WK7StageSoundInfo	*pSoundInfo = GetSoundInfo();
	if( pSoundInfo!=NULL ){
		gpSound->mSetDspRateAll(pSoundInfo->mDspRate);
		//gpSound->mPlayStreamNo (pSoundInfo->mBgmID );
		if(  pSoundInfo->mBgmVol < 0 ){
			gpSound->mPlayStreamEx (pSoundInfo->mBgmID, VOLUME_MUSIC, pSoundInfo->mBgmFade );
		}else{
			gpSound->mPlayStreamEx (pSoundInfo->mBgmID, (u8)pSoundInfo->mBgmVol, pSoundInfo->mBgmFade );
		}
	}
	return true;
}

void WK7Stage::_SetCurrentCallBackTask(ghmGcTask *)
{
	WK7Stage	*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	if( pStage->SetCurrentCallBack()==false ){
		return;
	}
	pStage->SetCurrentCallBackDefaultProc();
}

bool WK7Stage::CallEventCallBackTask(WK7EventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_EventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_EventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7EventInfo	info = *((WK7EventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->EventCallBack(info)==false ){
		return;
	}
}

bool WK7Stage::CallDoorEventCallBackTask(WK7DoorEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_DoorEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_DoorEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7DoorEventInfo	info = *((WK7DoorEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->DoorEventCallBack(info)==false ){
		return;
	}
	DoorEventTask(info);
}

bool WK7Stage::CallKeyEventCallBackTask(WK7KeyEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_KeyEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_KeyEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7KeyEventInfo	info = *((WK7KeyEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->KeyEventCallBack(info)==false ){
		return;
	}
	KeyEventTask(info);
}

bool WK7Stage::CallMapEventCallBackTask(WK7MapEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_MapEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_MapEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7MapEventInfo	info = *((WK7MapEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->MapEventCallBack(info)==false ){
		return;
	}
	MapEventTask(info);
}

bool WK7Stage::CallMemoEventCallBackTask(WK7MemoEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_MemoEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_MemoEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7MemoEventInfo	info = *((WK7MemoEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->MemoEventCallBack(info)==false ){
		return;
	}
	MemoEventTask(info);
}

bool WK7Stage::CallVoiceMemoEventCallBackTask(WK7VoiceMemoEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_VoiceMemoEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_VoiceMemoEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7VoiceMemoEventInfo	info = *((WK7VoiceMemoEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->VoiceMemoEventCallBack(info)==false ){
		return;
	}
	VoiceMemoEventTask(info);
}

bool WK7Stage::CallRakuEventCallBackTask(WK7RakuEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_RakuEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_RakuEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7RakuEventInfo	info = *((WK7RakuEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->RakuEventCallBack(info)==false ){
		return;
	}
	RakuEventTask(info);
}

bool WK7Stage::CallTamaEventCallBackTask(WK7TamaEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_TamaEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_TamaEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7TamaEventInfo	info = *((WK7TamaEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->TamaEventCallBack(info)==false ){
		return;
	}
	TamaEventTask(info);
}

bool WK7Stage::CallPlayEventCallBackTask(WK7PlayEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_PlayEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_PlayEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7PlayEventInfo	info = *((WK7PlayEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->PlayEventCallBack(info)==false ){
		return;
	}
	PlayEventTask(info);
}

bool WK7Stage::CallZanEventCallBackTask(WK7ZanEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_ZanEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_ZanEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7ZanEventInfo	info = *((WK7ZanEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->ZanEventCallBack(info)==false ){
		return;
	}
	ZanEventTask(info);
}

bool WK7Stage::CallTvEventCallBackTask(WK7TvEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_TvEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_TvEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7TvEventInfo	info = *((WK7TvEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->TvEventCallBack(info)==false ){
		return;
	}
	TvEventTask(info);
}

bool WK7Stage::CallLtvEventCallBackTask(WK7TvEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_LtvEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_LtvEventCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7TvEventInfo	info = *((WK7TvEventInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->LtvEventCallBack(info)==false ){
		return;
	}
	LtvEventTask(info);
}

bool WK7Stage::CallCharaChangeCallBackTask(WK7CharaChangeInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_CharaChangeCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_CharaChangeCallBackTask(ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7CharaChangeInfo	info = *((WK7CharaChangeInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->CharaChangeCallBack(info)==false ){
		return;
	}
}

bool WK7Stage::CallPreCharaChangeCallBackTask(WK7CharaChangeInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_PreCharaChangeCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_PreCharaChangeCallBackTask(ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7CharaChangeInfo	info = *((WK7CharaChangeInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->PreCharaChangeCallBack(info)==false ){
		return;
	}
}

const char* WK7BpInfo::GetBranchPointName(void)
{
	if( mpBranchPoint==NULL ){
		return NULL;
	}
	return mpBranchPoint->GetName();
}

bool WK7BpInfo::IsBranchPointName(const char *pName)
{
	const char	*pBranchPointName;
	if( pName==NULL || (pBranchPointName=GetBranchPointName())==NULL ){
		return false;
	}
	if( strcmp(pName,pBranchPointName)!=0 ){
		return false;
	}
	return true;
}

const char* WK7BpInfo::GetCurrentPathName(void)
{
	if( mpCurrentPath==NULL ){
		return NULL;
	}
	return mpCurrentPath->GetName();
}

bool WK7BpInfo::IsCurrentPathName(const char *pName)
{
	const char	*pCurrentPathName;
	if( pName==NULL || (pCurrentPathName=GetCurrentPathName())==NULL ){
		return false;
	}
	if( strcmp(pName,pCurrentPathName)!=0 ){
		return false;
	}
	return true;
}

const char* WK7BpInfo::GetNextPathName(void)
{
	if( mpNextPath==NULL ){
		return NULL;
	}
	return mpNextPath->GetName();
}

bool WK7BpInfo::IsNextPathName(const char *pName)
{
	const char	*pNextPathName;
	if( pName==NULL || (pNextPathName=GetNextPathName())==NULL ){
		return false;
	}
	if( strcmp(pName,pNextPathName)!=0 ){
		return false;
	}
	return true;
}

bool WK7Stage::CallBpLeaveCallBackTask(WK7BpInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_BpLeaveCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_BpLeaveCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7BpInfo	info = *((WK7BpInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->BpLeaveCallBack(info)==false ){
		return;
	}
}

bool WK7Stage::CallBpArriveCallBackTask(WK7BpInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_BpArriveCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_BpArriveCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7BpInfo	info = *((WK7BpInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->BpArriveCallBack(info)==false ){
		return;
	}
}

bool WK7Stage::CallPathTurnCallBackTask(WK7PathTurnInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_PathTurnCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_PathTurnCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7PathTurnInfo			info = *((WK7PathTurnInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->PathTurnCallBack(info)==false ){
		return;
	}
}

bool WK7Stage::CallPathChangeCallBackTask(WK7PathChangeInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_PathChangeCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_PathChangeCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7PathChangeInfo	info = *((WK7PathChangeInfo *)K7EV_GETEVENTPARAM(1));
	WK7CamPathFollowInfo	*pPathFollowInfo = WK7CAM->GetPathFollowInfo();
	if( pPathFollowInfo!=NULL && info.GetPath()!=NULL ){
		// Jʒu}jAݒȂ
		if( info.mInvPath && pPathFollowInfo->GetOldDir() >= 0 ){
			pPathFollowInfo->ReversePosLR();
		}
	}
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->PathChangeCallBack(info)==false ){
		return;
	}
	pStage->DefaultPathChangeProcess();
}

bool WK7Stage::PathChangeCancel(void)
{
	WK7PLAYERPATHCONTROL->SetPathChangeCancel(true);
	return true;
}

bool WK7Stage::CallPrePathChangeCallBackTask(WK7PrePathChangeInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_PrePathChangeCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_PrePathChangeCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7PrePathChangeInfo	info = *((WK7PrePathChangeInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->PrePathChangeCallBack(info)==false ){
		PathChangeCancel();
		return;
	}
}

bool WK7Stage::CallHitObjCallBackTask(WK7HitObjInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_HitObjCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_HitObjCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7HitObjInfo	info = *((WK7HitObjInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->HitObjCallBack(info)==false ){
		return;
	}
	if( pStage->ZanHitEvent(info)==true ){
		return;
	}
	if( pStage->BrokeWallEvent(info)==true ){
		return;
	}
	if( pStage->KihanKuiEvent(info)==true ){
		return;
	}
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 ){
		return;
	}
	if( info.mpJObj!=NULL ){
		info.mpJObj->Hide(false,true);
	}
	char		str[64];
	strcpy(str,"HitObj !!");
	if( info.mpJObj!=NULL ){
		const char	*pJObjName;
		if( (pJObjName=info.mpJObj->GetName())!=NULL ){
			sprintf(str,"Hit %s",pJObjName);
		}
	}
	K7AppDebugPrint(str);
	K7SCR_TIMEWAIT(2400);
	if( info.mpJObj!=NULL ){
		info.mpJObj->Disp(false,true);
	}
	info.SetHitObjEnable(true);
//	info.mpHitObj->SetEnable(true);
#endif
}

bool WK7Stage::CallDieNpcCallBackTask(WK7DieNpcInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_DieNpcCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_DieNpcCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7DieNpcInfo	info = *((WK7DieNpcInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->DieNpcCallBack(info)==false ){
		return;
	}
}

bool WK7Stage::CallAttackCallBackTask(WK7AttackInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_AttackCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_AttackCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7AttackInfo	info = *((WK7AttackInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->AttackCallBack(info)==false ){
		return;
	}
}

//bool WK7Stage::CallSpAttackCallBackTask(WK7SpAttackInfo &info)
//{
//	if( WK7EVENTCONTROLLER->CallIM(_SpAttackCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
//		return false;
//	}
//	return true;
//}

//void WK7Stage::_SpAttackCallBackTask (ghmGcTask *)
//{
//	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
//	if( pStage==NULL ){
//		return;
//	}
//	WK7SpAttackInfo	info = *((WK7SpAttackInfo *)K7EV_GETEVENTPARAM(1));
//#ifdef	_DEBUG
//	if( GameInfo.GetScenarioID()!=K7SCN99 )
//#endif
//	if( pStage->SpAttackCallBack(info)==false ){
//		return;
//	}
//}

/*
	
	\͔ɃR[
	
*/
bool WK7Stage::CallSpAbilityCallBackTask(WK7SpAbilityInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_SpAbilityCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_SpAbilityCallBackTask (ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7SpAbilityInfo	info = *((WK7SpAbilityInfo *)K7EV_GETEVENTPARAM(1));
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()==K7SCN99 ){
		return;
	}
#endif
	if( pStage->SpAbilityCallBack(info)==false ){
		return;
	}
	
	switch( info.mAbilityID ){
	case	PC_SPA_CLOAKING:
	case	PC_SPA_BOOST_RUN:
		return;
	default:
		WK7PLAYERCONTROL->SetSpAbilityCancel(true);
		break;
	}
	
	while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
		K7SCR_RETSYS();
	}
	
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_NO_REACTION);
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
}

bool WK7Stage::TestSpAbility(WK7SpAbilityInfo &info)
{
	WK7StageSpCond		*pSpCond;
	Vec					pos,dir;
	int					count = -1;
	WK7PathNurbs		*pCurrentPath;
	int					i;
	
	if( WK7PLAYERCONTROL->GetSpAbilityDisable()==true ){
		return false;
	}
	
	WK7PLAYERCONTROL->GetPosition(&pos);
	pCurrentPath = WK7PLAYERPATHCONTROL->GetCurrentPath();
	
	for(i=0 ; i<2 ; i++){
		switch( i ){
		case	0:
			if( (pSpCond = mpScenarioSpCond)==NULL ){
				continue;
			}
			break;
		case	1:
		default:
			pSpCond = stageSpCond;
			break;
		}
		for( ; pSpCond->mID!=0xffffffff ; pSpCond++){
			if( pSpCond->mID!=mID ){
				continue;
			}
			if( pSpCond->mSpID >= 0 && pSpCond->mSpID!=info.mAbilityID ){
				continue;
			}
			count++;
			if( !(pSpCond->mCharaMask & (1<<WK7PLAYERCONTROL->GetMainID())) ){
				continue;
			}
			if( pSpCond->mRadius < 0.0f || pSpCond->mpPathName!=NULL ){
				if( pCurrentPath==NULL ){
					continue;
				}
				WK7PathNurbs	*pPath = SearchPath(pSpCond->mpPathName);
				if( pPath!=pCurrentPath ){
					continue;
				}
			}else{
				VECSubtract(&pos,&pSpCond->mPosition,&dir);
				if( VECMag(&dir) > pSpCond->mRadius ){
					continue;
				}
			}
			info.mType = pSpCond->mType;
			i = 2;
			break;
		}
	}
	
	switch( info.mAbilityID ){
	case	PC_SPA_BLOODY_SHOWER:
	case	PC_SPA_BOOST_JUMP:
	case	PC_SPA_PICKING_TOOL:
		if( info.mType!=0xffffffff ){
			return true;
		}
		break;
	case	PC_SPA_CLOAKING:
	case	PC_SPA_BOOST_RUN:
		return true;
	default:
		break;
	}
	return false;
}

bool WK7Stage::CallHanaEventCallBackTask(WK7HanaEventInfo &info)
{
	if( WK7EVENTCONTROLLER->CallIM(_HanaEventCallBackTask,NULL,(u32)this,(u32)&info)!=WK7EVENTCONTROLLER_CALL_SUCCESS ){
		return false;
	}
	return true;
}

void WK7Stage::_HanaEventCallBackTask(ghmGcTask *)
{
	WK7Stage		*pStage = (WK7Stage *)K7EV_GETEVENTPARAM(0);
	if( pStage==NULL ){
		return;
	}
	WK7HanaEventInfo	info = *((WK7HanaEventInfo *)K7EV_GETEVENTPARAM(1));
//	GameInfo.SetHanaFlag(info.mEventNo,pStage->GetID());
#ifdef	_DEBUG
	if( GameInfo.GetScenarioID()!=K7SCN99 )
#endif
	if( pStage->HanaEventCallBack(info)==false ){
		return;
	}
	pStage->BrokenFlowerObj(info.mpJObj,K7EVENTHANA_CHRID(info.mEventNo));
}

void WK7Stage::DefaultPathChangeProcess(void)
{
	WK7CamPathFollowInfo	*pPathFollowInfo = WK7CAM->GetPathFollowInfo();
	if( pPathFollowInfo==NULL ){
		return;
	}
	
	// pXJZbeBO
	WK7PathControl			*pPathControl = WK7PLAYERPATHCONTROL;
	WK7PathInfo				*pPathInfo    = pPathControl->GetCurrentPathInfo();
	WK7PathNurbs			*pPath;
	WK7PathDataDesc			*pPathDataDesc;
	HSD_CameraDesc			*pDesc;
	WK7CameraPathDesc		*pCameraPathDesc;
	bool					disablePathCamera = false;
	
	if( (pPath = pPathInfo->GetPath())!=NULL ){
		pPathDataDesc = pPath->GetPathDataDesc();
		if( pPath->GetDisablePathCamera()==true ){
			disablePathCamera = true;
		}
	}else{
		pPathDataDesc = NULL;
	}
	if( disablePathCamera==false && pPathDataDesc != NULL && pPathDataDesc->mpCameraDesc != NULL ){
		// pXJ
		switch( (pPathDataDesc->mCamType/10)%10 ){
		case	1:
			pPathFollowInfo->SetBpCamInfoPrio(1);
			break;
		case	0:
		default:
			pPathFollowInfo->SetBpCamInfoPrio();
			break;
		}
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		switch( pPathDataDesc->mCamType % 10 ){
		case	2:
		case	3:
			if( (pCameraPathDesc = pPathControl->GetCameraPath(pPathDataDesc->mpCameraPathName))!=NULL ){
				pPathFollowInfo->SetMode        (WK7CamPathFollowInfo::RAIL_MODE);
				pPathFollowInfo->SetRailPosition(pCameraPathDesc->mPosition   );
				pPathFollowInfo->SetPathCamera  (pCameraPathDesc->mpCameraDesc);
				switch( pPathDataDesc->mCamType ){
				case	3:
					pPathFollowInfo->SetRailType(WK7CamPathFollowInfo::RAILTYPE_CAMDIR);
					break;
				case	2:
				default:
					pPathFollowInfo->SetRailType(WK7CamPathFollowInfo::RAILTYPE_TOPLAYER);
					break;
				}
				return;
			}
			break;
		case	1:
			pPathFollowInfo->SetMode(WK7CamPathFollowInfo::FIXED_MODE);
			pPathFollowInfo->SetPathCamera(pPathDataDesc->mpCameraDesc);
			return;
		case	0:
		default:
			pPathFollowInfo->SetMode(WK7CamPathFollowInfo::POSFIXED_MODE);
			pPathFollowInfo->SetPathCamera(pPathDataDesc->mpCameraDesc);
			return;
		}
	}
	
	if( (pDesc = pPathControl->GetCurrentPathCamera())==NULL ){
		WK7CameraPathDesc		*pCameraPathDesc = pPathControl->GetCurrentCameraPath();
		if( pCameraPathDesc==NULL ){
			if( pPathFollowInfo->GetPathCamera()!=NULL ){
				WK7Stage		*pCurrentStage = WK7Stage::GetCurrentStage();
				if( pCurrentStage!=NULL ){
					pCurrentStage->SetDefaultCameraDesc();
				}
			}
			if( pPathDataDesc!=NULL ){
				bool	change = false;
				if( pPathDataDesc->mCamPosV != 0xffff ){
					pPathFollowInfo->SetPosV(pPathDataDesc->mCamPosV);
					change = true;
				}
				if( pPathDataDesc->mCamPosH != 0xffff ){
					pPathFollowInfo->SetPosH(pPathDataDesc->mCamPosH);
					change = true;
				}
				if( change==true ){
					pPathFollowInfo->SetPos(WK7CamPathFollowInfo::RENEW_SLOW);
				}
			}
			if( pPathFollowInfo->GetMode()!=WK7CamPathFollowInfo::FOLLOW_MODE ){
				pPathFollowInfo->SetMode(WK7CamPathFollowInfo::FOLLOW_MODE);
			}
//			pPathFollowInfo->SetMode(WK7CamPathFollowInfo::FOLLOW_MODE);
//			pPathFollowInfo->SetPos(-3);
			pPathFollowInfo->SetPathCamera(NULL);
			return;
		}
		if( disablePathCamera==false ){
			pPathFollowInfo->SetMode        (WK7CamPathFollowInfo::RAIL_MODE);
			pPathFollowInfo->SetRailPosition(pCameraPathDesc->mPosition   );
			pPathFollowInfo->SetPathCamera  (pCameraPathDesc->mpCameraDesc);
			pPathFollowInfo->SetRailType    (WK7CamPathFollowInfo::RAILTYPE_TOPLAYER);
			return;
		}
	}
	if( disablePathCamera==true ){
		return;
	}
	const char		*pPathName;
	if( pPath!=NULL && (pPathName=pPath->GetName())!=NULL ){
		if( strstr(pPathName,"_fix")!=NULL ){
			pPathFollowInfo->SetMode(WK7CamPathFollowInfo::FIXED_MODE);
		}else{
			pPathFollowInfo->SetMode(WK7CamPathFollowInfo::POSFIXED_MODE);
		}
	}
	pPathFollowInfo->SetPathCamera(pDesc);
}

bool WK7Stage::SetCameraStartPosition(u32 id,const char *pName)
{
	WK7Stage		*pStage = WK7RenderObj::GetStage(id);
	if( pStage==NULL ){
		return false;
	}
	return pStage->SetCameraStartPosition(pName);
}

bool WK7Stage::SetCameraStartPosition(const char *pName)
{
	WK7StagePlaceInfo		*pPlaceInfo;
	if( pName==NULL ){
		WK7PathInfo		*pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
		if( pPathInfo==NULL ){
			return false;
		}
		if( (pName = pPathInfo->GetPathName())==NULL ){
			return false;
		}
	}
	pPlaceInfo = GetPlaceInfo(mID,pName);
	return SetCameraStartPosition(pPlaceInfo);
}

bool WK7Stage::SetCameraStartPosition(WK7StagePlaceInfo *pPlaceInfo)
{
	if( pPlaceInfo==NULL || pPlaceInfo->mID==0xffffffff ){
		return false;
	}
	if( pPlaceInfo->mCamPos.x==pPlaceInfo->mCamTgt.x &&
	    pPlaceInfo->mCamPos.y==pPlaceInfo->mCamTgt.y &&
	    pPlaceInfo->mCamPos.z==pPlaceInfo->mCamTgt.z ){
		return false;
	}
	WK7CamPathFollowInfo	*pPathFollowInfo = WK7CAM->GetPathFollowInfo();
	WK7PathControl			*pPathControl = WK7PLAYERPATHCONTROL;
	if( pPathFollowInfo==NULL || pPathControl==NULL ){
		return false;
	}
	Vec		initpos;
	pPathControl->GetCurrentPosition(&initpos);
	pPathFollowInfo->SetStageStartMode              (true);
	pPathFollowInfo->SetStageStartCamPosition       (pPlaceInfo->mCamPos);
	pPathFollowInfo->SetStageStartCamTargetPosition (pPlaceInfo->mCamTgt);
	pPathFollowInfo->SetStageStartTargetInitPosition(initpos);
	return true;
}

//
//
//			MOVIE
//
//

//===========================================================
//		Movie̖O
//===========================================================
static	const char	*pMovieTable[] = {
	"clemence",
	"cloudman",
	"drugstore",
	"gurad",
	"postman",
	"tractor",
	"05100201",
	"05100202",
	"051002018",
	"051002028",
	"01010101",		//`
	"04010101",		//KVAH
	"04010201",		//n[}s
	"04010203",		//T_[XEQp
	"04040101",		//RXe
	"04050101",		//_ƃVK[
	"04050202",		//a
	"04050301",		//g@[
	"04060101",		//nT}o
	"04060902",		//uo
	"04070101",		//NQ[
};

//===========================================================
//		[r[Đ IDw FĐ̂݃o[W
//===========================================================
bool WK7Stage::PlayMovie3( u32 id )
{
	if( id >= sizeof(pMovieTable) / sizeof(const char *) ){
		return false;
	}
	char		filename[256];
	sprintf(filename,"/Movie/%s.h4m",pMovieTable[id]);
	return PlayMovie3(filename);
}

//===========================================================
//		[r[Đ IDw FmCYo[W
//===========================================================
bool WK7Stage::PlayMovie2( u32 id )
{
	if( id >= sizeof(pMovieTable) / sizeof(const char *) ){
		return false;
	}
	char		filename[256];
	sprintf(filename,"/Movie/%s.h4m",pMovieTable[id]);
	return PlayMovie2(filename);
}

//===========================================================
//		[r[Đ IDw FSJ^
//===========================================================
bool WK7Stage::PlayMovie(u32 id)
{
	if( id >= sizeof(pMovieTable) / sizeof(const char *) ){
		return false;
	}
	char		filename[256];
	sprintf(filename,"/Movie/%s.h4m",pMovieTable[id]);
	return PlayMovie(filename);
}

//#define	K7STAGE_MOVIE_DEBUG
//===========================================================
//		[r[Đ t@Cw FĐ݂̂o[W
//===========================================================
bool WK7Stage::PlayMovie3(const char *pFileName)
{
#ifdef	_DEBUG
	ghmGcFile		file;
	if( file.Open((char *)pFileName)==true ){
		file.Close();
#endif
	while( gpMovie->mRequest((char *)pFileName)==false ){
		K7SCR_RETSYS();
	}
#ifdef	_DEBUG
	}
#endif
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	while( gpMovie->mGetStatus()!=eMvProcStandby ){
		if( gpMovie->mGetFrame() >= 1 && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
			gpMovie->mStop();
			while( gpMovie->mGetStatus()!=eMvProcStandby ){
				K7SCR_RETSYS();
			}
			break;
		}
		K7SCR_RETSYS();
	}
#ifdef	K7STAGE_MOVIE_DEBUG
	K7AppDumpMemoryType(1);
	while( !(HSD_PadGetTrigger(1) & HSD_PAD_A) ){
		K7SCR_RETSYS();
	}
#endif
	return true;
}

//===========================================================
//		[r[Đ t@Cw FmCYo[W
//===========================================================
bool WK7Stage::PlayMovie2(const char *pFileName)
{
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();

	while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
		K7SCR_RETSYS();
	}
	while( gpMovie->mGetStatus()!=eMvProcStandby ){
		K7SCR_RETSYS();
	}
#ifdef	_DEBUG
	ghmGcFile		file;
	if( file.Open((char *)pFileName)==true ){
		file.Close();
#endif
	while( gpMovie->mRequest((char *)pFileName)==false ){
		K7SCR_RETSYS();
	}
#ifdef	_DEBUG
	}
#endif
//	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//		K7SCR_RETSYS();
//	}
	while( gpMovie->mGetStatus()!=eMvProcStandby ){
		if( gpMovie->mGetFrame() >= 1 && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
			gpMovie->mStop();
			while( gpMovie->mGetStatus()!=eMvProcStandby ){
				K7SCR_RETSYS();
			}
			break;
		}
		K7SCR_RETSYS();
	}
#ifdef	K7STAGE_MOVIE_DEBUG
	K7AppDumpMemoryType(1);
	while( !(HSD_PadGetTrigger(1) & HSD_PAD_A) ){
		K7SCR_RETSYS();
	}
#endif
	while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->LoadData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
		K7SCR_RETSYS();
	}
//	K7SCR_EXIT_DEMOPAUSE();
//	K7SCR_EXIT_PLAYMODE();
	return true;
}

//===========================================================
//		[r[Đ t@Cw FSȂ
//===========================================================
bool WK7Stage::PlayMovie(const char *pFileName)
{
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	while( gpNoise->mSandRequest(eSandLongNoise)==false ){
		GHMGCTASK_RETSYS();
	}
	while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7Stage::ReleaseStageArchive()==false ){
		K7SCR_RETSYS();
	}
	while( WK7Stage::IsReleasedStageArchive()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
		K7SCR_RETSYS();
	}
	while( gpMovie->mGetStatus()!=eMvProcStandby ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	while( gpNoise->mSandRelease()==false ){
		K7SCR_RETSYS();
	}
#ifdef	_DEBUG
	ghmGcFile		file;
	if( file.Open((char *)pFileName)==true ){
		file.Close();
#endif
	while( gpMovie->mRequest((char *)pFileName)==false ){
		K7SCR_RETSYS();
	}
#ifdef	_DEBUG
	}
#endif
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	while( gpMovie->mGetStatus()!=eMvProcStandby ){
		if( gpMovie->mGetFrame() >= 1 && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
			gpMovie->mStop();
			while( gpMovie->mGetStatus()!=eMvProcStandby ){
				K7SCR_RETSYS();
			}
			break;
		}
		K7SCR_RETSYS();
	}
#ifdef	K7STAGE_MOVIE_DEBUG
	K7AppDumpMemoryType(1);
	while( !(HSD_PadGetTrigger(1) & HSD_PAD_A) ){
		K7SCR_RETSYS();
	}
#endif
	while( gpNoise->mSandRequest(eSandLongNoise)==false ){
		GHMGCTASK_RETSYS();
	}
	while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->LoadData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
		K7SCR_RETSYS();
	}
	while( WK7Stage::RestoreStageArchive()==false ){
		K7SCR_RETSYS();
	}
	while( WK7Stage::IsRestoredStageArchive()==false ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	while( gpNoise->mSandRelease()==false ){
		K7SCR_RETSYS();
	}
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
//	K7SCR_EXIT_DEMOPAUSE();
//	K7SCR_EXIT_PLAYMODE();
	return true;
}

bool WK7Stage::IsPlayingMovie(void)
{
	return (gpMovie->mGetStatus() != eMvProcStandby);
}

bool WK7Stage::GalEnter(WK7DoorEventInfo &doorEventInfo)
{
	return GalEnter(doorEventInfo.mNextStageID,doorEventInfo.mNextBpName);
}

bool WK7Stage::GalEnter(u32 &id,char *pBpName)
{
	id = WK7STAGE_GALSTAGEID;
	if( pBpName!=NULL ){
		strncpy(pBpName,WK7STAGE_GALSTAGE_ENTER_BPNAME,WK7DOOREVENT_BPNAME_MAX-1);
	}
	return true;
}

bool WK7Stage::PutEnemyWalk(Vec &pos)
{
	C_Trigon		*pTrigon = NULL;
	C_TrigonArray	*pTrigonArray = NULL;
	C_Trigon		*pNearestTrigon = NULL;
	C_TrigonArray	*pNearestTrigonArray = NULL;
	f32				nearestDist;
	u32				i,inum = mTrigonPtrs.size();
	u32				j,jnum;
	Vec				cpos;
	for(i=0 ; i<inum ; i++){
		pTrigonArray = mTrigonPtrs[i];
		pTrigonArray->Proc();
		MTXMultVec(pTrigonArray->GetIMtx(),&pos,&cpos);
		jnum         = pTrigonArray->GetNum();
		for(j=0 ; j<jnum ; j++){
			pTrigon = pTrigonArray->GetTrigonPtr(j);
			if( pTrigon->Include(cpos)==true ){
				return true;
			}
			f32		dist = GHM_VEC_DIST(pTrigon->GetVtx(),&cpos);
			if( pNearestTrigon==NULL || nearestDist > dist ){
				pNearestTrigon      = pTrigon;
				pNearestTrigonArray = pTrigonArray;
				nearestDist         = dist;
			}
		}
	}
	if( pNearestTrigon!=NULL ){
		Vec	*ppos = pNearestTrigon->GetVtx();
		pos.x = 0.0f;
		pos.y = 0.0f;
		pos.z = 0.0f;
		for(i=0 ; i<3 ; i++,ppos++){
			VECAdd(&pos,ppos,&pos);
		}
		VECScale(&pos,&pos,0.333f);
		MTXMultVec(pNearestTrigonArray->GetMtx(),&pos,&cpos);
		return true;
	}
	return false;
}

WK7StageArea::WK7StageArea(ghmGcListObj *pAnchor,WK7JObj *pJObj) : ghmGcListObj(pAnchor)
{
	mpContainer = NULL;
	mSeID       = WK7PATH_FOOTSE_DEFAULT;
	mEnable     = true;
	HSD_JObj	*pHSDJObj;
	if( (mpJObj=pJObj)!=NULL && (pHSDJObj = pJObj->GetJObj())!=NULL ){
		C_ExtractTrigonArray	et(pHSDJObj,mTrigons,false);
	}
}

WK7StageArea::~WK7StageArea()
{
	u32		size = mTrigons.size();
	u32		i;
	for(i=0 ; i<size ; i++){
		if( mTrigons[i]==NULL ){
			continue;
		}
		delete mTrigons[i];
	}
}

bool WK7StageArea::Include(const Vec &pos)
{
	u32		size = mTrigons.size();
	u32		i;
	for(i=0 ; i<size ; i++){
		if( mTrigons[i]==NULL ){
			continue;
		}
		mTrigons[i]->Proc();
		if( mTrigons[i]->Include(pos)==true ){
			return true;
		}
	}
	return false;
}

#define	WK7STAGE_FOOTSE_PREFIX			"footse"
#define	WK7STAGE_FOOTSE_CHILD_PREFIX	"se"
bool WK7Stage::CreateFootSeArea(void)
{
	WK7JObj		*pJObj;
	const char	*pJObjName;
	if( mpModel==NULL || (pJObj=mpModel->GetObjPartialName2(WK7STAGE_FOOTSE_PREFIX))==NULL || (pJObjName=pJObj->GetName())==NULL ){
		return true;
	}
	u16		seid = 0;
	for(pJObjName += strlen(WK7STAGE_FOOTSE_PREFIX) ; *pJObjName!='\0' ; pJObjName++){
		if( *pJObjName < '0' || *pJObjName > '9' ){
			break;
		}
		seid *= 10;
		seid += (u16)(*pJObjName - '0');
	}
	mDefaultFootSE = seid;
	for(pJObj=pJObj->GetChild() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
		if( (pJObjName=pJObj->GetName())==NULL ){
			continue;
		}
		if( strstr(pJObjName,WK7STAGE_FOOTSE_CHILD_PREFIX)!=pJObjName ){
			continue;
		}
		seid = 0;
		for(pJObjName += strlen(WK7STAGE_FOOTSE_CHILD_PREFIX) ; *pJObjName!='\0' ; pJObjName++){
			if( *pJObjName < '0' || *pJObjName > '9' ){
				break;
			}
			seid *= 10;
			seid += (u16)(*pJObjName - '0');
		}
		ghmGcMemSetAllocName("STAREA");
		WK7StageArea	*pStageArea = new WK7StageArea(&mAreaAnchor,pJObj);
		if( pStageArea==NULL ){
			continue;
		}
		pStageArea->SetSeID(seid);
		pStageArea->mpContainer = this;
		pJObj->Hide(false,true);
	}
	return true;
}

bool WK7Stage::ReleaseFootSeArea(void)
{
	WK7StageArea	*pStageArea;
	for(pStageArea=(WK7StageArea *)mAreaAnchor.GetNext() ; pStageArea!=NULL ; pStageArea=(WK7StageArea *)mAreaAnchor.GetNext()){
		delete pStageArea;
	}
	return true;
}

WK7StageArea* WK7Stage::GetArea(const Vec& pos)
{
	WK7StageArea	*pStageArea;
	for(pStageArea=(WK7StageArea *)mAreaAnchor.GetNext() ; pStageArea!=NULL ; pStageArea=pStageArea->GetNext()){
		if( pStageArea->Include(pos)==true ){
			return pStageArea;
		}
	}
	return NULL;
}

u16 WK7Stage::GetDefaultFootSE(void)
{
	WK7StageSoundInfo	*pSoundInfo = GetSoundInfo();
	if( pSoundInfo==NULL || pSoundInfo->mFootSE==WK7PATH_FOOTSE_DEFAULT ){
		return mDefaultFootSE;
	}
	return pSoundInfo->mFootSE;
}

s8 WK7Stage::InitCharChange(u8 NotCancelFlag,s32 CurrentChar,u8 SwitchOnFlag)
{
	s32					CharSoundTableNumber;
	MASK_MODEL_INDEX	maskModelIndex;
	CHARMODEL_INDEX		charModelIndex;
	switch( GameInfo.GetScenarioFlow() ){
	case	K7SCNF_CEL: CharSoundTableNumber=VOICE_CELTIC;       charModelIndex = CHAR_MODEL_CELTIC;       break;
	case	K7SCNF_FUK: CharSoundTableNumber=VOICE_FUKUSHIMA;    charModelIndex = CHAR_MODEL_FUKUSHIMA;    break;
	case	K7SCNF_KAK: CharSoundTableNumber=VOICE_KAKUBUILL;    charModelIndex = CHAR_MODEL_KAKUBUILL;    break;
	case	K7SCNF_TXS: CharSoundTableNumber=VOICE_TEXAS;        charModelIndex = CHAR_MODEL_TEXAS;        break;
	case	K7SCNF_ISZ: CharSoundTableNumber=VOICE_ISHIZAKALAND; charModelIndex = CHAR_MODEL_ISHIZAKALAND; break;
	case	K7SCNF_CUR: CharSoundTableNumber=VOICE_CATHISUHOUSE; charModelIndex = CHAR_MODEL_CATHISUHOUSE; break;
	case	K7SCNF_DM1: CharSoundTableNumber=VOICE_DOMINICA;     charModelIndex = CHAR_MODEL_DOMINICA;     break;
	case	K7SCNF_DM2: CharSoundTableNumber=VOICE_DOMINICA;     charModelIndex = CHAR_MODEL_BROADWAY;     break;
	case	K7SCNF_HT1: CharSoundTableNumber=VOICE_HOTEL;        charModelIndex = CHAR_MODEL_HOTEL01;      break;
	case	K7SCNF_SCL: CharSoundTableNumber=VOICE_SCHOOL;       charModelIndex = CHAR_MODEL_SCHOOL;       break;
	case	K7SCNF_HT2: CharSoundTableNumber=VOICE_DEF;          charModelIndex = CHAR_MODEL_HOTEL02;      break;
	case	K7SCNF_GNK:
	default:            CharSoundTableNumber=VOICE_DEF;          charModelIndex = CHAR_MODEL_HOTEL02;      break;
	}
	switch( BattleCtrl.GetMskPowerUp() ){
	case	KK7BATTLECTRL_MSKLV_TEXAS:    maskModelIndex = MASK_MODEL_TEXAS;    break;
	case	KK7BATTLECTRL_MSKLV_FINAL:    maskModelIndex = MASK_MODEL_FINAL;    break;
	case	KK7BATTLECTRL_MSKLV_TEKKAMEN: maskModelIndex = MASK_MODEL_TEKKAMEN; break;
	case	KK7BATTLECTRL_MSKLV_NORMAL:   
	default:                              maskModelIndex = MASK_MODEL_DEFAULT;  break;
	}
	::SetCharChangeMaskModelIndex(maskModelIndex);
	::SetCharChangeModelIndex    (charModelIndex);
	return ::InitCharChange(NotCancelFlag,CurrentChar,SwitchOnFlag,CharSoundTableNumber);
}

int WK7PathChangeInfo::CompareList(const char **ppPathList)
{
	if( ppPathList==NULL || mpPathName==NULL ){
		return -1;
	}
	int		i;
	for(i=0 ; *ppPathList!=NULL ; ppPathList++,i++){
		if( strcmp(*ppPathList,mpPathName)==0 ){
			return i;
		}
	}
	return -1;
}

int WK7PrePathChangeInfo::CompareListC(const char **ppPathList)
{
	if( ppPathList==NULL || mpCurrPathName==NULL ){
		return -1;
	}
	int		i;
	for(i=0 ; *ppPathList!=NULL ; ppPathList++,i++){
		if( strcmp(*ppPathList,mpCurrPathName)==0 ){
			return i;
		}
	}
	return -1;
}

int WK7PrePathChangeInfo::CompareListN(const char **ppPathList)
{
	if( ppPathList==NULL || mpNextPathName==NULL ){
		return -1;
	}
	int		i;
	for(i=0 ; *ppPathList!=NULL ; ppPathList++,i++){
		if( strcmp(*ppPathList,mpNextPathName)==0 ){
			return i;
		}
	}
	return -1;
}

WK7PathBranchPointObjJObj* WK7Stage::GetBranchPointObj_EventNo(u32 evno)
{
	if( mpPath==NULL ){
		return NULL;
	}
	return mpPath->GetObj_EventNo(evno);
}

WK7PathNurbs* WK7Stage::GetPathNurbs_EventNo(u32 evno)
{
	if( mpPath==NULL ){
		return NULL;
	}
	return mpPath->GetPath_EventNo(evno);
}

bool WK7Stage::IsValid(WK7PathBranchPointObj *pBranchPointObj)
{
	if( mpPath==NULL ){
		return false;
	}
	return mpPath->IsValid(pBranchPointObj);
}

bool WK7Stage::IsValid(WK7PathBranch *pBranch)
{
	if( mpPath==NULL ){
		return false;
	}
	return mpPath->IsValid(pBranch);
}

bool WK7Stage::IsValid(WK7PathBranchPoint *pBranchPoint)
{
	if( mpPath==NULL ){
		return false;
	}
	return mpPath->IsValid(pBranchPoint);
}

bool WK7Stage::IsValid(WK7PathNurbs *pPath)
{
	if( mpPath==NULL ){
		return false;
	}
	return mpPath->IsValid(pPath);
}

bool IsValidAll(WK7PathBranchPointObj *pBranchPointObj)
{
	if( pBranchPointObj==NULL ){
		return false;
	}
	WK7RenderObj		*pObj;
	WK7Stage			*pStage;
	for(pObj=WK7RenderObj::GetTopObj() ; pObj!=NULL ; pObj=pObj->GetNext()){
		if( pObj->GetType()!=K7OBJTYPE_STG ){
			continue;
		}
		pStage = (WK7Stage *)pObj;
		if( pStage->IsValid(pBranchPointObj)==true ){
			return true;
		}
	}
	return false;
}

bool IsValidAll(WK7PathBranch *pBranch)
{
	if( pBranch==NULL ){
		return false;
	}
	WK7RenderObj		*pObj;
	WK7Stage			*pStage;
	for(pObj=WK7RenderObj::GetTopObj() ; pObj!=NULL ; pObj=pObj->GetNext()){
		if( pObj->GetType()!=K7OBJTYPE_STG ){
			continue;
		}
		pStage = (WK7Stage *)pObj;
		if( pStage->IsValid(pBranch)==true ){
			return true;
		}
	}
	return false;
}

bool IsValidAll(WK7PathBranchPoint *pBranchPoint)
{
	if( pBranchPoint==NULL ){
		return false;
	}
	WK7RenderObj		*pObj;
	WK7Stage			*pStage;
	for(pObj=WK7RenderObj::GetTopObj() ; pObj!=NULL ; pObj=pObj->GetNext()){
		if( pObj->GetType()!=K7OBJTYPE_STG ){
			continue;
		}
		pStage = (WK7Stage *)pObj;
		if( pStage->IsValid(pBranchPoint)==true ){
			return true;
		}
	}
	return false;
}

bool IsValidAll(WK7PathNurbs *pPath)
{
	if( pPath==NULL ){
		return false;
	}
	WK7RenderObj		*pObj;
	WK7Stage			*pStage;
	for(pObj=WK7RenderObj::GetTopObj() ; pObj!=NULL ; pObj=pObj->GetNext()){
		if( pObj->GetType()!=K7OBJTYPE_STG ){
			continue;
		}
		pStage = (WK7Stage *)pObj;
		if( pStage->IsValid(pPath)==true ){
			return true;
		}
	}
	return false;
}

bool WK7Stage::SetBpCamInfo(WK7PathBranchPoint *pBranchPoint)
{
	if( pBranchPoint==NULL ){
		return false;
	}
	if( pBranchPoint->GetBpCamDisable()==true ){
		return false;
	}
	WK7StageBpCamInfo	*pInfo = GetBpCamInfo(pBranchPoint->GetShortName());
	if( pInfo==NULL ){
		return false;
	}
	Vec		pos;
	pBranchPoint->GetPosition(&pos);
	WK7CAMPATHFOLLOWINFO->SetBpCamInfo(pInfo);
	WK7CAMPATHFOLLOWINFO->SetBpPosition(pos);
	return true;
}

WK7StageBpCamInfo* WK7Stage::GetBpCamInfo(WK7PathBranchPoint *pBranchPoint)
{
	if( pBranchPoint==NULL ){
		return NULL;
	}
	return GetBpCamInfo(pBranchPoint->GetShortName());
}

WK7StageBpCamInfo* WK7Stage::GetBpCamInfo(const char *pName)
{
	if( pName==NULL ){
		return NULL;
	}
	WK7StageBpCamInfo	*pInfo;
	int					i;
	for(i=0 ; i<2 ; i++){
		switch( i ){
		case	0:
			if( (pInfo = mpScenarioBpCamInfo)==NULL ){
				continue;
			}
			break;
		case	1:
		default:
			pInfo = stageBpCamInfo;
			break;
		}
		for( ; pInfo->mID!=0xffffffff ; pInfo++){
			if( mCurrentStageID!=pInfo->mID ){
				continue;
			}
			if( pInfo->mpPathName==NULL ){
				return pInfo;
			}
			if( strcmp(pInfo->mpPathName,pName)!=0 ){
				continue;
			}
			return pInfo;
		}
	}
	return NULL;
}

int WK7Stage::SetBpCamDisable(const char *pName,bool flag)
{
	if( mpPath==NULL ){
		return 0;
	}
	return mpPath->SetBpCamDisable(pName,flag);
}

WK7RenderObjEffect* WK7Stage::CreateEffectLensFlare(const char *pSunName,u32 *pRenderID)
{
	WK7JObj	*pJObj = GetJObj(pSunName);
	if( pJObj==NULL ){
		return NULL;
	}
	WK7RenderObjEffect	*pRenderObjEffect;
	u32					renderID;
	renderID = WK7RenderObj::GetUniqueRenderID(false,WK7RENDEROBJ_RENDERID_DEFAULT-1);
	SetHitObj(pJObj,0x00ffffff,renderID);
	pJObj->CreateAlphaControl(0.0f,true);
	pJObj->SetZSortPrio(WK7JOBJ_ZSORTPRIO_DEFAULT + WK7JOBJ_ZSORTPRIO_SCALE,false,true);
	pJObj->Disp(false,true);
	u8		minAlpha = (u8) WK7RenderObj::ConvRenderIDToAlpha(renderID  );
	u8		maxAlpha = (u8)(WK7RenderObj::ConvRenderIDToAlpha(renderID+1)-1);
	WK7RenderObjEffectInfo	info;
	info.Create();
	pRenderObjEffect = CreateEffect(::CreateLensFlareEffect(pJObj,true,maxAlpha,minAlpha),&info);
	if( pRenderID!=NULL ){
		*pRenderID = renderID;
	}
	return pRenderObjEffect;
}

bool WK7Stage::ReleaseEffectLensFlare(void)
{
	::ReleaseLensFlareTexture();
	return true;
}

bool WK7Stage::SetupEffectLensFlare(void)
{
	::SetupLensFlareTexture();
//	::SetupLensFlareTexture(LENSFLARETEX_ALPHA);
	return true;
}

bool WK7Stage::CheckSetupEffectLensFlare(void)
{
	return ::CheckLensFlareTexture()==TRUE? true : false;
}

bool WK7HitObjInfo::SetHitObj(WK7HitObj *pHitObj)
{
	if( pHitObj!=NULL ){
		if( WK7HitObj::IsValid(pHitObj)==false ){
			return false;
		}
	}
	mpHitObj = pHitObj;
	return true;
}

bool WK7HitObjInfo::SetHitObjEnable(bool flag)
{
	if( IsValidHitObj()==false ){
		return false;
	}
	mpHitObj->SetEnable(flag);
	return true;
}

bool WK7HitObjInfo::GetHitObjEnable(void)
{
	if( IsValidHitObj()==false ){
		return false;
	}
	return mpHitObj->GetEnable();
}

bool WK7HitObjInfo::IsValidHitObj(void)
{
	return WK7HitObj::IsValid(mpHitObj);
}

